-----------------------------------------------------------
-- (c) 1998,  Daan Leijen, leijen@@fwi.uva.nl
-----------------------------------------------------------

module AutoPrim where

import StdDIS
import PointerPrim
import MarshallPrim
import ComPrim

data Dispatch a         = Dispatch
type IDispatch a        = IUnknown (Dispatch a)



data BSTR       = BSTR
data VARIANT    = VARIANT
data EXCEPINFO  = EXCEPINFO

-- for wont of a better home..
type Byte = Char

-----------------------------------------------------------
-- Dispatch interface
-----------------------------------------------------------

primitive prim_dispErrorUNKNOWNNAME :: Int -> IO (Int)
dispErrorUNKNOWNNAME :: Int -> Bool
dispErrorUNKNOWNNAME arg1 =
  unsafePerformIO(
    prim_dispErrorUNKNOWNNAME arg1 >>= \ (res1) ->
    (unmarshall_bool_ res1) >>= \ gc_res1 ->
    (return (gc_res1)))

primitive prim_dispErrorEXCEPTION :: Int -> IO (Int)
dispErrorEXCEPTION :: Int -> Bool
dispErrorEXCEPTION arg1 =
  unsafePerformIO(
    prim_dispErrorEXCEPTION arg1 >>= \ (res1) ->
    (unmarshall_bool_ res1) >>= \ gc_res1 ->
    (return (gc_res1)))

primitive prim_dispatchInvoke :: ForeignObj -> Int -> Int -> Int -> Int -> Int -> Int -> ForeignObj -> ForeignObj -> IO (Int,Addr,Addr)
dispatchInvoke :: IDispatch a -> Int -> Int -> Bool -> Int -> Int -> Int -> Pointer VARIANT -> Pointer VARIANT -> IO (Int,Pointer EXCEPINFO)
dispatchInvoke gc_arg1 arg2 arg3 gc_arg3 arg5 arg6 arg7 gc_arg4 gc_arg5 =
  (marshall_iunknown_ gc_arg1) >>= \ (gc_arg2) ->
  (marshall_pointer_ gc_arg2) >>= \ (arg1) ->
  (marshall_bool_ gc_arg3) >>= \ (arg4) ->
  (marshall_pointer_ gc_arg4) >>= \ (arg8) ->
  (marshall_pointer_ gc_arg5) >>= \ (arg9) ->
  prim_dispatchInvoke arg1 arg2 arg3 arg4 arg5 arg6 arg7 arg8 arg9 >>= \ (res1,gc_res4,gc_res2) ->
  (makeForeignObj gc_res2 gc_res4) >>= \ gc_res3 ->
  (unmarshall_pointer_ gc_res3) >>= \ gc_res1 ->
  (return ((res1,gc_res1)))

primitive prim_dispatchGetMemberID :: ForeignObj -> ForeignObj -> Int -> IO (Int,Int)
dispatchGetMemberID :: IDispatch a -> Pointer BSTR -> Int -> IO (Int,Int)
dispatchGetMemberID gc_arg1 gc_arg3 arg3 =
  (marshall_iunknown_ gc_arg1) >>= \ (gc_arg2) ->
  (marshall_pointer_ gc_arg2) >>= \ (arg1) ->
  (marshall_pointer_ gc_arg3) >>= \ (arg2) ->
  prim_dispatchGetMemberID arg1 arg2 arg3

primitive prim_freeExcepInfo :: ForeignObj -> IO ()
freeExcepInfo :: Pointer EXCEPINFO -> IO ()
freeExcepInfo gc_arg1 =
  (marshall_pointer_ gc_arg1) >>= \ (arg1) ->
  prim_freeExcepInfo arg1

primitive prim_getExcepInfoMessage :: ForeignObj -> IO (Addr,Addr)
getExcepInfoMessage :: Pointer EXCEPINFO -> IO (Pointer String)
getExcepInfoMessage gc_arg1 =
  (marshall_pointer_ gc_arg1) >>= \ (arg1) ->
  prim_getExcepInfoMessage arg1 >>= \ (gc_res4,gc_res2) ->
  (makeForeignObj gc_res2 gc_res4) >>= \ gc_res3 ->
  (unmarshall_pointer_ gc_res3) >>= \ gc_res1 ->
  (return (gc_res1))

-----------------------------------------------------------
-- Variant memory
-----------------------------------------------------------

primitive prim_freeVariants :: Int -> ForeignObj -> IO ()
freeVariants :: Int -> Pointer VARIANT -> IO ()
freeVariants arg1 gc_arg1 =
  (marshall_pointer_ gc_arg1) >>= \ (arg2) ->
  prim_freeVariants arg1 arg2

-----------------------------------------------------------
-- Variant marshalling
-----------------------------------------------------------

primitive prim_writeVarShort :: Int -> ForeignObj -> IO ()
writeVarShort :: Int -> Pointer VARIANT -> IO ()
writeVarShort arg1 gc_arg1 =
  (marshall_pointer_ gc_arg1) >>= \ (arg2) ->
  prim_writeVarShort arg1 arg2

primitive prim_readVarShort :: ForeignObj -> IO (Int,Int,Addr)
readVarShort :: Pointer VARIANT -> IO Int
readVarShort gc_arg1 =
  (marshall_pointer_ gc_arg1) >>= \ (arg1) ->
  prim_readVarShort arg1 >>= \ (res2,gc_failed,gc_failstring) ->
  if ( gc_failed /= 0)
  then unmarshall_string_ gc_failstring >>= fail . userError
  else (return (res2))


primitive prim_writeVarInt :: Int -> ForeignObj -> IO ()
writeVarInt :: Int -> Pointer VARIANT -> IO ()
writeVarInt arg1 gc_arg1 =
  (marshall_pointer_ gc_arg1) >>= \ (arg2) ->
  prim_writeVarInt arg1 arg2

primitive prim_readVarInt :: ForeignObj -> IO (Int,Int,Addr)
readVarInt :: Pointer VARIANT -> IO Int
readVarInt gc_arg1 =
  (marshall_pointer_ gc_arg1) >>= \ (arg1) ->
  prim_readVarInt arg1 >>= \ (res2,gc_failed,gc_failstring) ->
  if ( gc_failed /= 0)
  then unmarshall_string_ gc_failstring >>= fail . userError
  else (return (res2))


primitive prim_writeVarFloat :: Float -> ForeignObj -> IO ()
writeVarFloat :: Float -> Pointer VARIANT -> IO ()
writeVarFloat arg1 gc_arg1 =
  (marshall_pointer_ gc_arg1) >>= \ (arg2) ->
  prim_writeVarFloat arg1 arg2

primitive prim_readVarFloat :: ForeignObj -> IO (Float,Int,Addr)
readVarFloat :: Pointer VARIANT -> IO Float
readVarFloat gc_arg1 =
  (marshall_pointer_ gc_arg1) >>= \ (arg1) ->
  prim_readVarFloat arg1 >>= \ (res2,gc_failed,gc_failstring) ->
  if ( gc_failed /= 0)
  then unmarshall_string_ gc_failstring >>= fail . userError
  else (return (res2))


primitive prim_writeVarDouble :: Double -> ForeignObj -> IO ()
writeVarDouble :: Double -> Pointer VARIANT -> IO ()
writeVarDouble arg1 gc_arg1 =
  (marshall_pointer_ gc_arg1) >>= \ (arg2) ->
  prim_writeVarDouble arg1 arg2

primitive prim_readVarDouble :: ForeignObj -> IO (Double,Int,Addr)
readVarDouble :: Pointer VARIANT -> IO Double
readVarDouble gc_arg1 =
  (marshall_pointer_ gc_arg1) >>= \ (arg1) ->
  prim_readVarDouble arg1 >>= \ (res2,gc_failed,gc_failstring) ->
  if ( gc_failed /= 0)
  then unmarshall_string_ gc_failstring >>= fail . userError
  else (return (res2))


primitive prim_writeVarString :: ForeignObj -> ForeignObj -> IO ()
writeVarString :: Pointer BSTR -> Pointer VARIANT -> IO ()
writeVarString gc_arg1 gc_arg2 =
  (marshall_pointer_ gc_arg1) >>= \ (arg1) ->
  (marshall_pointer_ gc_arg2) >>= \ (arg2) ->
  prim_writeVarString arg1 arg2

primitive prim_readVarString :: ForeignObj -> IO (Addr,Addr,Addr,Addr,Int,Addr)
readVarString :: Pointer VARIANT -> IO (Pointer BSTR,Pointer VARIANT)
readVarString gc_arg1 =
  (marshall_pointer_ gc_arg1) >>= \ (arg1) ->
  prim_readVarString arg1 >>= \ (gc_res4,gc_res2,gc_res8,gc_res6,gc_failed,gc_failstring) ->
  if ( gc_failed /= 0)
  then unmarshall_string_ gc_failstring >>= fail . userError
  else (makeForeignObj gc_res2 gc_res4) >>= \ gc_res3 ->
       (unmarshall_pointer_ gc_res3) >>= \ gc_res1 ->
       (makeForeignObj gc_res6 gc_res8) >>= \ gc_res7 ->
       (unmarshall_pointer_ gc_res7) >>= \ gc_res5 ->
       (return ((gc_res1,gc_res5)))


primitive prim_writeVarDispatch :: ForeignObj -> ForeignObj -> IO ()
writeVarDispatch :: IDispatch a -> Pointer VARIANT -> IO ()
writeVarDispatch gc_arg1 gc_arg3 =
  (marshall_iunknown_ gc_arg1) >>= \ (gc_arg2) ->
  (marshall_pointer_ gc_arg2) >>= \ (arg1) ->
  (marshall_pointer_ gc_arg3) >>= \ (arg2) ->
  prim_writeVarDispatch arg1 arg2

-- unsafe read !
primitive prim_readVarDispatch :: ForeignObj -> IO (Addr,Addr,Addr,Addr,Int,Addr)
readVarDispatch :: Pointer VARIANT -> IO (IDispatch a,Pointer VARIANT)
readVarDispatch gc_arg1 =
  (marshall_pointer_ gc_arg1) >>= \ (arg1) ->
  prim_readVarDispatch arg1 >>= \ (gc_res5,gc_res3,gc_res9,gc_res7,gc_failed,gc_failstring) ->
  if ( gc_failed /= 0)
  then unmarshall_string_ gc_failstring >>= fail . userError
  else (makeForeignObj gc_res3 gc_res5) >>= \ gc_res4 ->
       (unmarshall_pointer_ gc_res4) >>= \ gc_res2 ->
       (unmarshall_iunknown_ gc_res2) >>= \ gc_res1 ->
       (makeForeignObj gc_res7 gc_res9) >>= \ gc_res8 ->
       (unmarshall_pointer_ gc_res8) >>= \ gc_res6 ->
       (return ((gc_res1,gc_res6)))


primitive prim_writeVarError :: Int -> ForeignObj -> IO ()
writeVarError :: Int -> Pointer VARIANT -> IO ()
writeVarError arg1 gc_arg1 =
  (marshall_pointer_ gc_arg1) >>= \ (arg2) ->
  prim_writeVarError arg1 arg2

primitive prim_readVarError :: ForeignObj -> IO (Int,Int,Addr)
readVarError :: Pointer VARIANT -> IO Int
readVarError gc_arg1 =
  (marshall_pointer_ gc_arg1) >>= \ (arg1) ->
  prim_readVarError arg1 >>= \ (res2,gc_failed,gc_failstring) ->
  if ( gc_failed /= 0)
  then unmarshall_string_ gc_failstring >>= fail . userError
  else (return (res2))


primitive prim_writeVarBool :: Int -> ForeignObj -> IO ()
writeVarBool :: Bool -> Pointer VARIANT -> IO ()
writeVarBool gc_arg1 gc_arg2 =
  (marshall_bool_ gc_arg1) >>= \ (arg1) ->
  (marshall_pointer_ gc_arg2) >>= \ (arg2) ->
  prim_writeVarBool arg1 arg2

primitive prim_readVarBool :: ForeignObj -> IO (Int,Int,Addr)
readVarBool :: Pointer VARIANT -> IO Bool
readVarBool gc_arg1 =
  (marshall_pointer_ gc_arg1) >>= \ (arg1) ->
  prim_readVarBool arg1 >>= \ (res2,gc_failed,gc_failstring) ->
  if ( gc_failed /= 0)
  then unmarshall_string_ gc_failstring >>= fail . userError
  else (unmarshall_bool_ res2) >>= \ gc_res1 ->
       (return (gc_res1))


primitive prim_writeVarUnknown :: ForeignObj -> ForeignObj -> IO ()
writeVarUnknown :: IUnknown a -> Pointer VARIANT -> IO ()
writeVarUnknown gc_arg1 gc_arg3 =
  (marshall_iunknown_ gc_arg1) >>= \ (gc_arg2) ->
  (marshall_pointer_ gc_arg2) >>= \ (arg1) ->
  (marshall_pointer_ gc_arg3) >>= \ (arg2) ->
  prim_writeVarUnknown arg1 arg2

-- unsafe read !
primitive prim_readVarUnknown :: ForeignObj -> IO (Addr,Addr,Addr,Addr,Int,Addr)
readVarUnknown :: Pointer VARIANT -> IO (IUnknown a,Pointer VARIANT)
readVarUnknown gc_arg1 =
  (marshall_pointer_ gc_arg1) >>= \ (arg1) ->
  prim_readVarUnknown arg1 >>= \ (gc_res5,gc_res3,gc_res9,gc_res7,gc_failed,gc_failstring) ->
  if ( gc_failed /= 0)
  then unmarshall_string_ gc_failstring >>= fail . userError
  else (makeForeignObj gc_res3 gc_res5) >>= \ gc_res4 ->
       (unmarshall_pointer_ gc_res4) >>= \ gc_res2 ->
       (unmarshall_iunknown_ gc_res2) >>= \ gc_res1 ->
       (makeForeignObj gc_res7 gc_res9) >>= \ gc_res8 ->
       (unmarshall_pointer_ gc_res8) >>= \ gc_res6 ->
       (return ((gc_res1,gc_res6)))


primitive prim_writeVarByte :: Char -> ForeignObj -> IO ()
writeVarByte :: Byte -> Pointer VARIANT -> IO ()
writeVarByte arg1 gc_arg1 =
  (marshall_pointer_ gc_arg1) >>= \ (arg2) ->
  prim_writeVarByte arg1 arg2

primitive prim_readVarByte :: ForeignObj -> IO (Char,Int,Addr)
readVarByte :: Pointer VARIANT -> IO Byte
readVarByte gc_arg1 =
  (marshall_pointer_ gc_arg1) >>= \ (arg1) ->
  prim_readVarByte arg1 >>= \ (res2,gc_failed,gc_failstring) ->
  if ( gc_failed /= 0)
  then unmarshall_string_ gc_failstring >>= fail . userError
  else (return (res2))


primitive prim_writeVarEmpty :: ForeignObj -> IO ()
writeVarEmpty :: Pointer VARIANT -> IO ()
writeVarEmpty gc_arg1 =
  (marshall_pointer_ gc_arg1) >>= \ (arg1) ->
  prim_writeVarEmpty arg1
-- %fun readVarEmpty

primitive prim_writeVarNull :: ForeignObj -> IO ()
writeVarNull :: Pointer VARIANT -> IO ()
writeVarNull gc_arg1 =
  (marshall_pointer_ gc_arg1) >>= \ (arg1) ->
  prim_writeVarNull arg1

primitive prim_readVarNull :: ForeignObj -> IO (Int,Addr)
readVarNull :: Pointer VARIANT -> IO ()
readVarNull gc_arg1 =
  (marshall_pointer_ gc_arg1) >>= \ (arg1) ->
  prim_readVarNull arg1 >>= \ (gc_failed,gc_failstring) ->
  if ( gc_failed /= 0)
  then unmarshall_string_ gc_failstring >>= fail . userError
  else (return (()))


primitive prim_writeVarCurrency :: Int -> Int -> ForeignObj -> IO ()
writeVarCurrency :: Int -> Int -> Pointer VARIANT -> IO ()
writeVarCurrency arg1 arg2 gc_arg1 =
  (marshall_pointer_ gc_arg1) >>= \ (arg3) ->
  prim_writeVarCurrency arg1 arg2 arg3

primitive prim_readVarCurrency :: ForeignObj -> IO (Int,Int,Int,Addr)
readVarCurrency :: Pointer VARIANT -> IO (Int,Int)
readVarCurrency gc_arg1 =
  (marshall_pointer_ gc_arg1) >>= \ (arg1) ->
  prim_readVarCurrency arg1 >>= \ (res2,res3,gc_failed,gc_failstring) ->
  if ( gc_failed /= 0)
  then unmarshall_string_ gc_failstring >>= fail . userError
  else (return ((res2,res3)))



-----------------------------------------------------------
-- BSTR marshalling
-----------------------------------------------------------

primitive prim_lenStringFromBSTR :: ForeignObj -> IO (Int)
lenStringFromBSTR :: Pointer BSTR -> Int
lenStringFromBSTR gc_arg1 =
  unsafePerformIO(
    (marshall_pointer_ gc_arg1) >>= \ (arg1) ->
    prim_lenStringFromBSTR arg1 >>= \ (res1) ->
    (return (res1)))

primitive prim_bstrFromString :: ForeignObj -> IO (Addr,Addr,Int,Addr)
bstrFromString :: Pointer String -> IO (Pointer BSTR)
bstrFromString gc_arg1 =
  (marshall_pointer_ gc_arg1) >>= \ (arg1) ->
  prim_bstrFromString arg1 >>= \ (gc_res4,gc_res2,gc_failed,gc_failstring) ->
  if ( gc_failed /= 0)
  then unmarshall_string_ gc_failstring >>= fail . userError
  else (makeForeignObj gc_res2 gc_res4) >>= \ gc_res3 ->
       (unmarshall_pointer_ gc_res3) >>= \ gc_res1 ->
       (return (gc_res1))

primitive prim_nofreeBstrFromString :: ForeignObj -> IO (Addr,Addr,Int,Addr)
nofreeBstrFromString :: Pointer String -> IO (Pointer BSTR)
nofreeBstrFromString gc_arg1 =
  (marshall_pointer_ gc_arg1) >>= \ (arg1) ->
  prim_nofreeBstrFromString arg1 >>= \ (gc_res4,gc_res2,gc_failed,gc_failstring) ->
  if ( gc_failed /= 0)
  then unmarshall_string_ gc_failstring >>= fail . userError
  else (makeForeignObj gc_res2 gc_res4) >>= \ gc_res3 ->
       (unmarshall_pointer_ gc_res3) >>= \ gc_res1 ->
       (return (gc_res1))


primitive prim_stringFromBSTR :: ForeignObj -> Int -> ForeignObj -> IO ()
stringFromBSTR :: Pointer BSTR -> Int -> Pointer String -> IO ()
stringFromBSTR gc_arg1 arg2 gc_arg2 =
  (marshall_pointer_ gc_arg1) >>= \ (arg1) ->
  (marshall_pointer_ gc_arg2) >>= \ (arg3) ->
  prim_stringFromBSTR arg1 arg2 arg3





needPrims_hugs 2
