\documentclass{article}
\include{/hugs/lib/activex/lhs}

\begin{document}

\begin{notice}
1998,  Daan Leijen, leijen@@fwi.uva.nl

This module is part of HaskellScript.
See @notice.txt@ for details and conditions of use.
\end{notice}

> module HtmlScript ( module HScript,
>                     module MSHTML,
>                     module HtmlScript
>                   ) where
> import ComPrim (uniqueInt)
> import HScript
> import MSHTML 
>
> type IHTMLWindow a    = IHTMLWindow2 a
>
> theWindow :: IO (IHTMLWindow Interface)
> theWindow     = extern "window"
>
> theDocument :: IO (IHTMLDocument2 Interface)
> theDocument   = do { window <- theWindow; window # getDocument}


> onEventItem :: String -> String -> IO () -> IHTMLWindow () -> IO (IEventSink Interface)
> onEventItem name eventName action window
>       = do { window # item name ## onEvent eventName action
>            }

> item :: String -> IHTMLWindow Interface -> IO (IHTMLElement Interface)
> item name window
>       = window # getDocument ## getItemElement name

> getItem :: String -> IDispatch a -> IO (IHTMLElement Interface)
> getItem name obj = obj # propertyGet name [] outIDispatch 

win # getDocument ## getAll ## getItemElement i

> getItemElement :: String -> IHTMLDocument2 a -> IO (IHTMLElement Interface)
> getItemElement s obj = obj # getAll ## function1 "Item" [inString s] outIDispatch


> newName :: IO String
> newName       = do i <- uniqueInt
>                    return ("tempName" ++ show i)

> insertHTML    = insertAdjacentHTML "BeforeEnd"
> appendHTML    = insertAdjacentHTML "AfterEnd"

-----------------------------------------------------------
-- Scriptlets
-----------------------------------------------------------

> data HTMLExternal a   = HTMLExternal
> type IHTMLExternal a  = IDispatch (HTMLExternal a)

> getExternal :: IHTMLWindow a -> IO (IHTMLExternal b)
> getExternal       = propertyGet "External" [] outIDispatch

> raiseEvent :: Variant v => String -> v -> IHTMLExternal a -> IO ()
> raiseEvent name info obj       
>                   = (obj # method_2_0 "raiseEvent" name info)
>                       `catch` \err -> return ()

> bubbleEvent :: IHTMLExternal a -> IO ()
> bubbleEvent       = method_0_0 "BubbleEvent" 

-----------------------------------------------------------
-- Using the application object
-----------------------------------------------------------

> getBusy :: IHTMLWindow2 a -> IO Bool
> getBusy = propertyGet "Busy" [] outBool


\end{document}
