Copyright (c) 1998 Daan Leijen,  leijen@@fwi.uva.nl

> module LibMonad (
>       (@@),
>       foreach, seqs, binds,
>       mapm, maplRev, maplWhile,
>       mapl, mapr, mapl_, mapr_,
>       seql, seqr, seql_, seqr_,
>       mfoldr, mfoldl,
>       mscanr, mscanl
> ) where
>
> infixl 1 @@
>
> foreach f ms  = mapl_ f ms
> seqs ms       = seql_ ms
> binds ms      = seql ms
>
> (@@) :: Monad m => (b -> m c) -> (a -> m b) -> a -> m c
> f @@ g        = \x -> do { y <- g x; f y }
>
> mapm :: Functor m => (a -> b) -> m a -> m b
> mapm          = map
>
> maplWhile :: Monad m => (b -> Bool) -> (a -> m b) -> [a] -> m [b]
> maplRev  :: Monad m => (a -> m b) -> [a] -> m [b]
>
> maplWhile p f []      = return []
> maplWhile p f (x:xs)  = do y <- f x
>                            if (p y)
>                             then return []
>                             else do ys <- maplWhile p f xs
>                                     return (y:ys)
>
> maplRev f xs
>       = maplr [] xs
>       where
>         maplr ys []       = return ys
>         maplr ys (x:xx)   = do y <- f x
>                                maplr (y:ys) xx


> mapl   :: Monad m => (a -> m b) -> [a] -> m [b]
> mapr   :: Monad m => (a -> m b) -> [a] -> m [b]
> mapr_  :: Monad m => (a -> m b) -> [a] -> m ()
> mapl_  :: Monad m => (a -> m b) -> [a] -> m ()
>
> mapl f []     = return []
> mapl f (x:xs) = do y  <- f x
>                    ys <- mapl f xs
>                    return (y:ys)
>
> mapr f []     = return []
> mapr f (x:xs) = do ys <- mapr f xs
>                    y  <- f x
>                    return (y:ys)
>
> mapl_ f []            = return ()
> mapl_ f (x:xs)        = do { f x; mapl_ f xs }
>
> mapr_ f []            = return ()
> mapr_ f (x:xs)        = do { mapr_ f xs; f x; return () }


> mfoldr :: Monad m => (a -> b -> m b) -> b -> [a] -> m b
> mfoldr f z []         = return z
> mfoldr f z (x:xs)     = do y <- mfoldr f z xs
>                            f x y
>
> mfoldl :: Monad m => (b -> a -> m b) -> b -> [a] -> m b
> mfoldl f z []         = return z
> mfoldl f z (x:xs)     = do y <- f z x
>                            mfoldl f y xs


> seql    :: Monad m => [m a] -> m [a]
> seqr    :: Monad m => [m a] -> m [a]
> seql_   :: Monad m => [m a] -> m ()
> seqr_   :: Monad m => [m a] -> m ()
>
> seql []       = return []
> seql (m:ms)   = do x  <- m
>                    xs <- seql ms
>                    return (x:xs)
>
> seqr []       = return []
> seqr (m:ms)   = do xs <- seqr ms
>                    x  <- m
>                    return (x:xs)
>
> seql_ []      = return ()
> seql_ (m:ms)  = do { m; seql_ ms }
>
> seqr_ []      = return ()
> seqr_ (m:ms)  = do { seqr_ ms; m; return () }

> mscanl :: Monad m => (b -> a -> m b) -> b -> [a] -> m [b]
> mscanr :: Monad m => (a -> b -> m b) -> b -> [a] -> m [b]
>
> mscanl f z []         = return [z]
> mscanl f z (x:xs)     = do y <- f z x
>                            ys <- mscanl f y xs
>                            return (y:ys)
>
> mscanr f z []         = return [z]
> mscanr f z (x:xs)     = do ys <- mscanr f z xs
>                            y  <- f x (head ys)
>                            return (y:ys)
