module MSForms where

import qualified Prelude
import qualified Automation (IDispatch, outInt, propertyGet, 
                             inInt, propertySet, outString, inString, method0, Variant, 
                             inVariant, function1, inFloat, outFloat, method1, outIDispatch, 
                             outVariant, outIUnknown, inIDispatch, inoutInt, {- Currency, -}
                             inIUnknown)
import qualified Com (IID, mkIID, CLSID, mkCLSID, IUnknown)
import qualified Int (Int32, Int16)
import qualified Com as Stdole2 (IUnknown)

type OLE_COLOR = Int.Int32
type OLE_HANDLE = Int.Int32
type OLE_OPTEXCLUSIVE = Int.Int16
-- --------------------------------------------------
-- 
-- dispinterface IFont
-- 
-- --------------------------------------------------
data Font a = Font
               
type IFont a = Automation.IDispatch (Font a)
iidIFont :: Com.IID (IFont ())
iidIFont = Com.mkIID "{BEF6E003-A874-101A-8BBA-00AA00300CAB}"
getcharset :: IFont a -> Prelude.IO Prelude.Int
getcharset = Automation.propertyGet "charset" [] Automation.outInt
setcharset :: Prelude.Int -> IFont a -> Prelude.IO ()
setcharset prop =
  Automation.propertySet "charset" [Automation.inInt prop]
getweight :: IFont a -> Prelude.IO Prelude.Int
getweight = Automation.propertyGet "weight" [] Automation.outInt
setweight :: Prelude.Int -> IFont a -> Prelude.IO ()
setweight prop =
  Automation.propertySet "weight" [Automation.inInt prop]
getstrikethrough :: IFont a -> Prelude.IO Prelude.Int
getstrikethrough =
  Automation.propertyGet "strikethrough" [] Automation.outInt
setstrikethrough :: Prelude.Int -> IFont a -> Prelude.IO ()
setstrikethrough prop =
  Automation.propertySet "strikethrough" [Automation.inInt prop]
getunderline :: IFont a -> Prelude.IO Prelude.Int
getunderline =
  Automation.propertyGet "underline" [] Automation.outInt
setunderline :: Prelude.Int -> IFont a -> Prelude.IO ()
setunderline prop =
  Automation.propertySet "underline" [Automation.inInt prop]
getitalic :: IFont a -> Prelude.IO Prelude.Int
getitalic = Automation.propertyGet "italic" [] Automation.outInt
setitalic :: Prelude.Int -> IFont a -> Prelude.IO ()
setitalic prop =
  Automation.propertySet "italic" [Automation.inInt prop]
getbold :: IFont a -> Prelude.IO Prelude.Int
getbold = Automation.propertyGet "bold" [] Automation.outInt
setbold :: Prelude.Int -> IFont a -> Prelude.IO ()
setbold prop =
  Automation.propertySet "bold" [Automation.inInt prop]
getsize :: IFont a -> Prelude.IO Prelude.Int
getsize = Automation.propertyGet "size" [] Automation.outInt
setsize :: Prelude.Int -> IFont a -> Prelude.IO ()
setsize prop =
  Automation.propertySet "size" [Automation.inInt prop]
getname :: IFont a -> Prelude.IO Prelude.String
getname = Automation.propertyGet "name" [] Automation.outString
setname :: Prelude.String -> IFont a -> Prelude.IO ()
setname prop =
  Automation.propertySet "name" [Automation.inString prop]
data FmDropEffect
 = FmDropEffectNone
 | FmDropEffectCopy
 | FmDropEffectMove
 | FmDropEffectCopyOrMove
 
marshallFmDropEffect :: FmDropEffect -> Prelude.IO Int.Int16
marshallFmDropEffect v =
  case v of
     FmDropEffectNone -> Prelude.return (0)
     FmDropEffectCopy -> Prelude.return (1)
     FmDropEffectMove -> Prelude.return (2)
     FmDropEffectCopyOrMove -> Prelude.return (3)
unmarshallFmDropEffect :: Int.Int16 -> Prelude.IO FmDropEffect
unmarshallFmDropEffect v =
  case v of
     0 -> Prelude.return (FmDropEffectNone)
     1 -> Prelude.return (FmDropEffectCopy)
     2 -> Prelude.return (FmDropEffectMove)
     3 -> Prelude.return (FmDropEffectCopyOrMove)
     _ -> Prelude.fail (Prelude.userError "unmarshallFmDropEffect: illegal enum value ")
data FmAction
 = FmActionCut
 | FmActionCopy
 | FmActionPaste
 | FmActionDragDrop
 
marshallFmAction :: FmAction -> Prelude.IO Int.Int16
marshallFmAction v =
  case v of
     FmActionCut -> Prelude.return (0)
     FmActionCopy -> Prelude.return (1)
     FmActionPaste -> Prelude.return (2)
     FmActionDragDrop -> Prelude.return (3)
unmarshallFmAction :: Int.Int16 -> Prelude.IO FmAction
unmarshallFmAction v =
  case v of
     0 -> Prelude.return (FmActionCut)
     1 -> Prelude.return (FmActionCopy)
     2 -> Prelude.return (FmActionPaste)
     3 -> Prelude.return (FmActionDragDrop)
     _ -> Prelude.fail (Prelude.userError "unmarshallFmAction: illegal enum value ")
-- --------------------------------------------------
-- 
-- interface IDataAutoWrapper
-- 
-- --------------------------------------------------
data DataAutoWrapper a = DataAutoWrapper
                          
type IDataAutoWrapper a = Automation.IDispatch (DataAutoWrapper a)
iidIDataAutoWrapper :: Com.IID (IDataAutoWrapper ())
iidIDataAutoWrapper =
  Com.mkIID "{EC72F590-F375-11CE-B9E8-00AA006B1A69}"
clear :: Automation.IDispatch a -> Prelude.IO ()
clear = Automation.method0 "Clear" []
getFormat :: (Automation.Variant a0) => a0 -> IDataAutoWrapper a -> Prelude.IO (Prelude.Int)
getFormat format =
  Automation.function1 "GetFormat" [Automation.inVariant format] Automation.outInt
getText  = Automation.propertyGet "Text" [] Automation.outString 
getText' :: (Automation.Variant a0) => a0 -> IDataAutoWrapper a -> Prelude.IO (Prelude.String)
getText' format =
  Automation.propertyGet "Text" [Automation.inVariant format] Automation.outString
setText :: (Automation.Variant a0) => Prelude.String -> a0 -> IDataAutoWrapper a -> Prelude.IO ()
setText text format =
  Automation.propertySet "Text" [Automation.inString text, Automation.inVariant format]
putInClipboard :: IDataAutoWrapper a -> Prelude.IO ()
putInClipboard = Automation.method0 "PutInClipboard" []
getFromClipboard :: IDataAutoWrapper a -> Prelude.IO ()
getFromClipboard = Automation.method0 "GetFromClipboard" []
startDrag :: (Automation.Variant a0) => a0 -> IDataAutoWrapper a -> Prelude.IO (Prelude.Int)
startDrag oKEffect =
  Automation.function1 "StartDrag" [Automation.inVariant oKEffect] Automation.outInt
-- --------------------------------------------------
-- 
-- interface IReturnInteger
-- 
-- --------------------------------------------------
data ReturnInteger a = ReturnInteger
                        
type IReturnInteger a = Automation.IDispatch (ReturnInteger a)
iidIReturnInteger :: Com.IID (IReturnInteger ())
iidIReturnInteger =
  Com.mkIID "{82B02370-B5BC-11CF-810F-00A0C9030074}"
setValue :: Prelude.Int -> Automation.IDispatch a -> Prelude.IO ()
setValue value =
  Automation.propertySet "Value" [Automation.inInt value]
getValue :: Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getValue = Automation.propertyGet "Value" [] Automation.outInt
-- --------------------------------------------------
-- 
-- interface IReturnBoolean
-- 
-- --------------------------------------------------
data ReturnBoolean a = ReturnBoolean
                        
type IReturnBoolean a = Automation.IDispatch (ReturnBoolean a)
iidIReturnBoolean :: Com.IID (IReturnBoolean ())
iidIReturnBoolean =
  Com.mkIID "{82B02371-B5BC-11CF-810F-00A0C9030074}"
setValue0 :: Prelude.Int -> Automation.IDispatch a -> Prelude.IO ()
setValue0 value =
  Automation.propertySet "Value" [Automation.inInt value]
getValue0 :: Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getValue0 = Automation.propertyGet "Value" [] Automation.outInt
-- --------------------------------------------------
-- 
-- interface IReturnString
-- 
-- --------------------------------------------------
data ReturnString a = ReturnString
                       
type IReturnString a = Automation.IDispatch (ReturnString a)
iidIReturnString :: Com.IID (IReturnString ())
iidIReturnString =
  Com.mkIID "{82B02372-B5BC-11CF-810F-00A0C9030074}"
setValue1 :: Prelude.String -> Automation.IDispatch a -> Prelude.IO ()
setValue1 value =
  Automation.propertySet "Value" [Automation.inString value]
getValue1 :: Automation.IDispatch a -> Prelude.IO (Prelude.String)
getValue1 = Automation.propertyGet "Value" [] Automation.outString
-- --------------------------------------------------
-- 
-- interface IReturnSingle
-- 
-- --------------------------------------------------
data ReturnSingle a = ReturnSingle
                       
type IReturnSingle a = Automation.IDispatch (ReturnSingle a)
iidIReturnSingle :: Com.IID (IReturnSingle ())
iidIReturnSingle =
  Com.mkIID "{8A683C90-BA84-11CF-8110-00A0C9030074}"
setValue2 :: Prelude.Float -> IReturnSingle a -> Prelude.IO ()
setValue2 value =
  Automation.propertySet "Value" [Automation.inFloat value]
getValue2 :: IReturnSingle a -> Prelude.IO (Prelude.Float)
getValue2 = Automation.propertyGet "Value" [] Automation.outFloat
-- --------------------------------------------------
-- 
-- interface IReturnEffect
-- 
-- --------------------------------------------------
data ReturnEffect a = ReturnEffect
                       
type IReturnEffect a = Automation.IDispatch (ReturnEffect a)
iidIReturnEffect :: Com.IID (IReturnEffect ())
iidIReturnEffect =
  Com.mkIID "{8A683C91-BA84-11CF-8110-00A0C9030074}"
setValue3 :: Prelude.Int -> IReturnEffect a -> Prelude.IO ()
setValue3 value =
  Automation.propertySet "Value" [Automation.inInt value]
getValue3 :: IReturnEffect a -> Prelude.IO (Prelude.Int)
getValue3 = Automation.propertyGet "Value" [] Automation.outInt
-- --------------------------------------------------
-- 
-- coclass ReturnInteger
-- 
-- --------------------------------------------------
clsidReturnInteger :: Com.CLSID
clsidReturnInteger =
  Com.mkCLSID "{82B02373-B5BC-11CF-810F-00A0C9030074}"
-- --------------------------------------------------
-- 
-- coclass ReturnBoolean
-- 
-- --------------------------------------------------
clsidReturnBoolean :: Com.CLSID
clsidReturnBoolean =
  Com.mkCLSID "{82B02374-B5BC-11CF-810F-00A0C9030074}"
-- --------------------------------------------------
-- 
-- coclass ReturnString
-- 
-- --------------------------------------------------
clsidReturnString :: Com.CLSID
clsidReturnString =
  Com.mkCLSID "{82B02375-B5BC-11CF-810F-00A0C9030074}"
-- --------------------------------------------------
-- 
-- coclass ReturnSingle
-- 
-- --------------------------------------------------
clsidReturnSingle :: Com.CLSID
clsidReturnSingle =
  Com.mkCLSID "{8A683C92-BA84-11CF-8110-00A0C9030074}"
-- --------------------------------------------------
-- 
-- coclass ReturnEffect
-- 
-- --------------------------------------------------
clsidReturnEffect :: Com.CLSID
clsidReturnEffect =
  Com.mkCLSID "{8A683C93-BA84-11CF-8110-00A0C9030074}"
-- --------------------------------------------------
-- 
-- coclass DataObject
-- 
-- --------------------------------------------------
clsidDataObject :: Com.CLSID
clsidDataObject =
  Com.mkCLSID "{1C3B4210-F441-11CE-B9EA-00AA006B1A69}"
data FmMode
 = FmModeInherit
 | FmModeOn
 | FmModeOff
 
marshallFmMode :: FmMode -> Prelude.IO Int.Int16
marshallFmMode v =
  case v of
     FmModeInherit -> Prelude.return ((-2))
     FmModeOn -> Prelude.return ((-1))
     FmModeOff -> Prelude.return (0)
unmarshallFmMode :: Int.Int16 -> Prelude.IO FmMode
unmarshallFmMode v =
  case v of
     (-2) -> Prelude.return (FmModeInherit)
     (-1) -> Prelude.return (FmModeOn)
     0 -> Prelude.return (FmModeOff)
     _ -> Prelude.fail (Prelude.userError "unmarshallFmMode: illegal enum value ")
data FmMousePointer
 = FmMousePointerDefault
 | FmMousePointerArrow
 | FmMousePointerCross
 | FmMousePointerIBeam
 | FmMousePointerSizeNESW
 | FmMousePointerSizeNS
 | FmMousePointerSizeNWSE
 | FmMousePointerSizeWE
 | FmMousePointerUpArrow
 | FmMousePointerHourGlass
 | FmMousePointerNoDrop
 | FmMousePointerAppStarting
 | FmMousePointerHelp
 | FmMousePointerSizeAll
 | FmMousePointerCustom
 
marshallFmMousePointer :: FmMousePointer -> Prelude.IO Int.Int16
marshallFmMousePointer v =
  case v of
     FmMousePointerDefault -> Prelude.return (0)
     FmMousePointerArrow -> Prelude.return (1)
     FmMousePointerCross -> Prelude.return (2)
     FmMousePointerIBeam -> Prelude.return (3)
     FmMousePointerSizeNESW -> Prelude.return (6)
     FmMousePointerSizeNS -> Prelude.return (7)
     FmMousePointerSizeNWSE -> Prelude.return (8)
     FmMousePointerSizeWE -> Prelude.return (9)
     FmMousePointerUpArrow -> Prelude.return (10)
     FmMousePointerHourGlass -> Prelude.return (11)
     FmMousePointerNoDrop -> Prelude.return (12)
     FmMousePointerAppStarting -> Prelude.return (13)
     FmMousePointerHelp -> Prelude.return (14)
     FmMousePointerSizeAll -> Prelude.return (15)
     FmMousePointerCustom -> Prelude.return (99)
unmarshallFmMousePointer :: Int.Int16 -> Prelude.IO FmMousePointer
unmarshallFmMousePointer v =
  case v of
     0 -> Prelude.return (FmMousePointerDefault)
     1 -> Prelude.return (FmMousePointerArrow)
     2 -> Prelude.return (FmMousePointerCross)
     3 -> Prelude.return (FmMousePointerIBeam)
     6 -> Prelude.return (FmMousePointerSizeNESW)
     7 -> Prelude.return (FmMousePointerSizeNS)
     8 -> Prelude.return (FmMousePointerSizeNWSE)
     9 -> Prelude.return (FmMousePointerSizeWE)
     10 -> Prelude.return (FmMousePointerUpArrow)
     11 -> Prelude.return (FmMousePointerHourGlass)
     12 -> Prelude.return (FmMousePointerNoDrop)
     13 -> Prelude.return (FmMousePointerAppStarting)
     14 -> Prelude.return (FmMousePointerHelp)
     15 -> Prelude.return (FmMousePointerSizeAll)
     99 -> Prelude.return (FmMousePointerCustom)
     _ -> Prelude.fail (Prelude.userError "unmarshallFmMousePointer: illegal enum value ")
data FmScrollBars
 = FmScrollBarsNone
 | FmScrollBarsHorizontal
 | FmScrollBarsVertical
 | FmScrollBarsBoth
 
marshallFmScrollBars :: FmScrollBars -> Prelude.IO Int.Int16
marshallFmScrollBars v =
  case v of
     FmScrollBarsNone -> Prelude.return (0)
     FmScrollBarsHorizontal -> Prelude.return (1)
     FmScrollBarsVertical -> Prelude.return (2)
     FmScrollBarsBoth -> Prelude.return (3)
unmarshallFmScrollBars :: Int.Int16 -> Prelude.IO FmScrollBars
unmarshallFmScrollBars v =
  case v of
     0 -> Prelude.return (FmScrollBarsNone)
     1 -> Prelude.return (FmScrollBarsHorizontal)
     2 -> Prelude.return (FmScrollBarsVertical)
     3 -> Prelude.return (FmScrollBarsBoth)
     _ -> Prelude.fail (Prelude.userError "unmarshallFmScrollBars: illegal enum value ")
data FmScrollAction
 = FmScrollActionNoChange
 | FmScrollActionLineUp
 | FmScrollActionLineDown
 | FmScrollActionPageUp
 | FmScrollActionPageDown
 | FmScrollActionBegin
 | FmScrollActionEnd
 | FmScrollActionAbsoluteChange
 | FmScrollActionPropertyChange
 | FmScrollActionControlRequest
 | FmScrollActionFocusRequest
 
marshallFmScrollAction :: FmScrollAction -> Prelude.IO Int.Int16
marshallFmScrollAction v =
  case v of
     FmScrollActionNoChange -> Prelude.return (0)
     FmScrollActionLineUp -> Prelude.return (1)
     FmScrollActionLineDown -> Prelude.return (2)
     FmScrollActionPageUp -> Prelude.return (3)
     FmScrollActionPageDown -> Prelude.return (4)
     FmScrollActionBegin -> Prelude.return (5)
     FmScrollActionEnd -> Prelude.return (6)
     FmScrollActionAbsoluteChange -> Prelude.return (7)
     FmScrollActionPropertyChange -> Prelude.return (8)
     FmScrollActionControlRequest -> Prelude.return (9)
     FmScrollActionFocusRequest -> Prelude.return (10)
unmarshallFmScrollAction :: Int.Int16 -> Prelude.IO FmScrollAction
unmarshallFmScrollAction v =
  case v of
     0 -> Prelude.return (FmScrollActionNoChange)
     1 -> Prelude.return (FmScrollActionLineUp)
     2 -> Prelude.return (FmScrollActionLineDown)
     3 -> Prelude.return (FmScrollActionPageUp)
     4 -> Prelude.return (FmScrollActionPageDown)
     5 -> Prelude.return (FmScrollActionBegin)
     6 -> Prelude.return (FmScrollActionEnd)
     7 -> Prelude.return (FmScrollActionAbsoluteChange)
     8 -> Prelude.return (FmScrollActionPropertyChange)
     9 -> Prelude.return (FmScrollActionControlRequest)
     10 -> Prelude.return (FmScrollActionFocusRequest)
     _ -> Prelude.fail (Prelude.userError "unmarshallFmScrollAction: illegal enum value ")
data FmCycle
 = FmCycleAllForms
 | FmCycleCurrentForm
 
marshallFmCycle :: FmCycle -> Prelude.IO Int.Int16
marshallFmCycle v =
  case v of
     FmCycleAllForms -> Prelude.return (0)
     FmCycleCurrentForm -> Prelude.return (2)
unmarshallFmCycle :: Int.Int16 -> Prelude.IO FmCycle
unmarshallFmCycle v =
  case v of
     0 -> Prelude.return (FmCycleAllForms)
     2 -> Prelude.return (FmCycleCurrentForm)
     _ -> Prelude.fail (Prelude.userError "unmarshallFmCycle: illegal enum value ")
data FmZOrder
 = FmZOrderFront
 | FmZOrderBack
 
marshallFmZOrder :: FmZOrder -> Prelude.IO Int.Int16
marshallFmZOrder v =
  case v of
     FmZOrderFront -> Prelude.return (0)
     FmZOrderBack -> Prelude.return (1)
unmarshallFmZOrder :: Int.Int16 -> Prelude.IO FmZOrder
unmarshallFmZOrder v =
  case v of
     0 -> Prelude.return (FmZOrderFront)
     1 -> Prelude.return (FmZOrderBack)
     _ -> Prelude.fail (Prelude.userError "unmarshallFmZOrder: illegal enum value ")
data FmBorderStyle
 = FmBorderStyleNone
 | FmBorderStyleSingle
 
marshallFmBorderStyle :: FmBorderStyle -> Prelude.IO Int.Int16
marshallFmBorderStyle v =
  case v of
     FmBorderStyleNone -> Prelude.return (0)
     FmBorderStyleSingle -> Prelude.return (1)
unmarshallFmBorderStyle :: Int.Int16 -> Prelude.IO FmBorderStyle
unmarshallFmBorderStyle v =
  case v of
     0 -> Prelude.return (FmBorderStyleNone)
     1 -> Prelude.return (FmBorderStyleSingle)
     _ -> Prelude.fail (Prelude.userError "unmarshallFmBorderStyle: illegal enum value ")
data FmTextAlign
 = FmTextAlignLeft
 | FmTextAlignCenter
 | FmTextAlignRight
 
marshallFmTextAlign :: FmTextAlign -> Prelude.IO Int.Int16
marshallFmTextAlign v =
  case v of
     FmTextAlignLeft -> Prelude.return (1)
     FmTextAlignCenter -> Prelude.return (2)
     FmTextAlignRight -> Prelude.return (3)
unmarshallFmTextAlign :: Int.Int16 -> Prelude.IO FmTextAlign
unmarshallFmTextAlign v =
  case v of
     1 -> Prelude.return (FmTextAlignLeft)
     2 -> Prelude.return (FmTextAlignCenter)
     3 -> Prelude.return (FmTextAlignRight)
     _ -> Prelude.fail (Prelude.userError "unmarshallFmTextAlign: illegal enum value ")
data FmAlignment
 = FmAlignmentLeft
 | FmAlignmentRight
 
marshallFmAlignment :: FmAlignment -> Prelude.IO Int.Int16
marshallFmAlignment v =
  case v of
     FmAlignmentLeft -> Prelude.return (0)
     FmAlignmentRight -> Prelude.return (1)
unmarshallFmAlignment :: Int.Int16 -> Prelude.IO FmAlignment
unmarshallFmAlignment v =
  case v of
     0 -> Prelude.return (FmAlignmentLeft)
     1 -> Prelude.return (FmAlignmentRight)
     _ -> Prelude.fail (Prelude.userError "unmarshallFmAlignment: illegal enum value ")
data FmBorders
 = FmBordersNone
 | FmBordersBox
 | FmBordersLeft
 | FmBordersTop
 
marshallFmBorders :: FmBorders -> Prelude.IO Int.Int16
marshallFmBorders v =
  case v of
     FmBordersNone -> Prelude.return (0)
     FmBordersBox -> Prelude.return (1)
     FmBordersLeft -> Prelude.return (2)
     FmBordersTop -> Prelude.return (3)
unmarshallFmBorders :: Int.Int16 -> Prelude.IO FmBorders
unmarshallFmBorders v =
  case v of
     0 -> Prelude.return (FmBordersNone)
     1 -> Prelude.return (FmBordersBox)
     2 -> Prelude.return (FmBordersLeft)
     3 -> Prelude.return (FmBordersTop)
     _ -> Prelude.fail (Prelude.userError "unmarshallFmBorders: illegal enum value ")
data FmBackStyle
 = FmBackStyleTransparent
 | FmBackStyleOpaque
 
marshallFmBackStyle :: FmBackStyle -> Prelude.IO Int.Int16
marshallFmBackStyle v =
  case v of
     FmBackStyleTransparent -> Prelude.return (0)
     FmBackStyleOpaque -> Prelude.return (1)
unmarshallFmBackStyle :: Int.Int16 -> Prelude.IO FmBackStyle
unmarshallFmBackStyle v =
  case v of
     0 -> Prelude.return (FmBackStyleTransparent)
     1 -> Prelude.return (FmBackStyleOpaque)
     _ -> Prelude.fail (Prelude.userError "unmarshallFmBackStyle: illegal enum value ")
data FmButtonStyle
 = FmButtonStylePushButton
 | FmButtonStyleToggleButton
 
marshallFmButtonStyle :: FmButtonStyle -> Prelude.IO Int.Int16
marshallFmButtonStyle v =
  case v of
     FmButtonStylePushButton -> Prelude.return (0)
     FmButtonStyleToggleButton -> Prelude.return (1)
unmarshallFmButtonStyle :: Int.Int16 -> Prelude.IO FmButtonStyle
unmarshallFmButtonStyle v =
  case v of
     0 -> Prelude.return (FmButtonStylePushButton)
     1 -> Prelude.return (FmButtonStyleToggleButton)
     _ -> Prelude.fail (Prelude.userError "unmarshallFmButtonStyle: illegal enum value ")
data FmPicPosition
 = FmPicPositionCenter
 | FmPicPositionTopLeft
 | FmPicPositionTopCenter
 | FmPicPositionTopRight
 | FmPicPositionCenterLeft
 | FmPicPositionCenterRight
 | FmPicPositionBottomLeft
 | FmPicPositionBottomCenter
 | FmPicPositionBottomRight
 
marshallFmPicPosition :: FmPicPosition -> Prelude.IO Int.Int16
marshallFmPicPosition v =
  case v of
     FmPicPositionCenter -> Prelude.return (0)
     FmPicPositionTopLeft -> Prelude.return (1)
     FmPicPositionTopCenter -> Prelude.return (2)
     FmPicPositionTopRight -> Prelude.return (3)
     FmPicPositionCenterLeft -> Prelude.return (4)
     FmPicPositionCenterRight -> Prelude.return (5)
     FmPicPositionBottomLeft -> Prelude.return (6)
     FmPicPositionBottomCenter -> Prelude.return (7)
     FmPicPositionBottomRight -> Prelude.return (8)
unmarshallFmPicPosition :: Int.Int16 -> Prelude.IO FmPicPosition
unmarshallFmPicPosition v =
  case v of
     0 -> Prelude.return (FmPicPositionCenter)
     1 -> Prelude.return (FmPicPositionTopLeft)
     2 -> Prelude.return (FmPicPositionTopCenter)
     3 -> Prelude.return (FmPicPositionTopRight)
     4 -> Prelude.return (FmPicPositionCenterLeft)
     5 -> Prelude.return (FmPicPositionCenterRight)
     6 -> Prelude.return (FmPicPositionBottomLeft)
     7 -> Prelude.return (FmPicPositionBottomCenter)
     8 -> Prelude.return (FmPicPositionBottomRight)
     _ -> Prelude.fail (Prelude.userError "unmarshallFmPicPosition: illegal enum value ")
data FmVerticalScrollBarSide
 = FmVerticalScrollBarSideRight
 | FmVerticalScrollBarSideLeft
 
marshallFmVerticalScrollBarSide :: FmVerticalScrollBarSide -> Prelude.IO Int.Int16
marshallFmVerticalScrollBarSide v =
  case v of
     FmVerticalScrollBarSideRight -> Prelude.return (0)
     FmVerticalScrollBarSideLeft -> Prelude.return (1)
unmarshallFmVerticalScrollBarSide :: Int.Int16 -> Prelude.IO FmVerticalScrollBarSide
unmarshallFmVerticalScrollBarSide v =
  case v of
     0 -> Prelude.return (FmVerticalScrollBarSideRight)
     1 -> Prelude.return (FmVerticalScrollBarSideLeft)
     _ -> Prelude.fail (Prelude.userError "unmarshallFmVerticalScrollBarSide: illegal enum value ")
data FmLayoutEffect
 = FmLayoutEffectNone
 | FmLayoutEffectInitiate
 | FmLayoutEffectRespond
 
marshallFmLayoutEffect :: FmLayoutEffect -> Prelude.IO Int.Int16
marshallFmLayoutEffect v =
  case v of
     FmLayoutEffectNone -> Prelude.return (0)
     FmLayoutEffectInitiate -> Prelude.return (1)
     FmLayoutEffectRespond -> Prelude.return (2)
unmarshallFmLayoutEffect :: Int.Int16 -> Prelude.IO FmLayoutEffect
unmarshallFmLayoutEffect v =
  case v of
     0 -> Prelude.return (FmLayoutEffectNone)
     1 -> Prelude.return (FmLayoutEffectInitiate)
     2 -> Prelude.return (FmLayoutEffectRespond)
     _ -> Prelude.fail (Prelude.userError "unmarshallFmLayoutEffect: illegal enum value ")
data FmSpecialEffect
 = FmSpecialEffectFlat
 | FmSpecialEffectRaised
 | FmSpecialEffectSunken
 | FmSpecialEffectEtched
 | FmSpecialEffectBump
 
marshallFmSpecialEffect :: FmSpecialEffect -> Prelude.IO Int.Int16
marshallFmSpecialEffect v =
  case v of
     FmSpecialEffectFlat -> Prelude.return (0)
     FmSpecialEffectRaised -> Prelude.return (1)
     FmSpecialEffectSunken -> Prelude.return (2)
     FmSpecialEffectEtched -> Prelude.return (3)
     FmSpecialEffectBump -> Prelude.return (6)
unmarshallFmSpecialEffect :: Int.Int16 -> Prelude.IO FmSpecialEffect
unmarshallFmSpecialEffect v =
  case v of
     0 -> Prelude.return (FmSpecialEffectFlat)
     1 -> Prelude.return (FmSpecialEffectRaised)
     2 -> Prelude.return (FmSpecialEffectSunken)
     3 -> Prelude.return (FmSpecialEffectEtched)
     6 -> Prelude.return (FmSpecialEffectBump)
     _ -> Prelude.fail (Prelude.userError "unmarshallFmSpecialEffect: illegal enum value ")
data FmDragState
 = FmDragStateEnter
 | FmDragStateLeave
 | FmDragStateOver
 
marshallFmDragState :: FmDragState -> Prelude.IO Int.Int16
marshallFmDragState v =
  case v of
     FmDragStateEnter -> Prelude.return (0)
     FmDragStateLeave -> Prelude.return (1)
     FmDragStateOver -> Prelude.return (2)
unmarshallFmDragState :: Int.Int16 -> Prelude.IO FmDragState
unmarshallFmDragState v =
  case v of
     0 -> Prelude.return (FmDragStateEnter)
     1 -> Prelude.return (FmDragStateLeave)
     2 -> Prelude.return (FmDragStateOver)
     _ -> Prelude.fail (Prelude.userError "unmarshallFmDragState: illegal enum value ")
data FmPictureSizeMode
 = FmPictureSizeModeClip
 | FmPictureSizeModeStretch
 | FmPictureSizeModeZoom
 
marshallFmPictureSizeMode :: FmPictureSizeMode -> Prelude.IO Int.Int16
marshallFmPictureSizeMode v =
  case v of
     FmPictureSizeModeClip -> Prelude.return (0)
     FmPictureSizeModeStretch -> Prelude.return (1)
     FmPictureSizeModeZoom -> Prelude.return (3)
unmarshallFmPictureSizeMode :: Int.Int16 -> Prelude.IO FmPictureSizeMode
unmarshallFmPictureSizeMode v =
  case v of
     0 -> Prelude.return (FmPictureSizeModeClip)
     1 -> Prelude.return (FmPictureSizeModeStretch)
     3 -> Prelude.return (FmPictureSizeModeZoom)
     _ -> Prelude.fail (Prelude.userError "unmarshallFmPictureSizeMode: illegal enum value ")
data FmPictureAlignment
 = FmPictureAlignmentTopLeft
 | FmPictureAlignmentTopRight
 | FmPictureAlignmentCenter
 | FmPictureAlignmentBottomLeft
 | FmPictureAlignmentBottomRight
 
marshallFmPictureAlignment :: FmPictureAlignment -> Prelude.IO Int.Int16
marshallFmPictureAlignment v =
  case v of
     FmPictureAlignmentTopLeft -> Prelude.return (0)
     FmPictureAlignmentTopRight -> Prelude.return (1)
     FmPictureAlignmentCenter -> Prelude.return (2)
     FmPictureAlignmentBottomLeft -> Prelude.return (3)
     FmPictureAlignmentBottomRight -> Prelude.return (4)
unmarshallFmPictureAlignment :: Int.Int16 -> Prelude.IO FmPictureAlignment
unmarshallFmPictureAlignment v =
  case v of
     0 -> Prelude.return (FmPictureAlignmentTopLeft)
     1 -> Prelude.return (FmPictureAlignmentTopRight)
     2 -> Prelude.return (FmPictureAlignmentCenter)
     3 -> Prelude.return (FmPictureAlignmentBottomLeft)
     4 -> Prelude.return (FmPictureAlignmentBottomRight)
     _ -> Prelude.fail (Prelude.userError "unmarshallFmPictureAlignment: illegal enum value ")
-- --------------------------------------------------
-- 
-- interface IControl
-- 
-- --------------------------------------------------
data Control a = Control
                  
type IControl a = Automation.IDispatch (Control a)
iidIControl :: Com.IID (IControl ())
iidIControl = Com.mkIID "{04598FC6-866C-11CF-AB7C-00AA00C08FCF}"
setCancel :: Prelude.Int -> IControl a -> Prelude.IO ()
setCancel cancel =
  Automation.propertySet "Cancel" [Automation.inInt cancel]
getCancel :: IControl a -> Prelude.IO (Prelude.Int)
getCancel = Automation.propertyGet "Cancel" [] Automation.outInt
setControlSource :: Prelude.String -> IControl a -> Prelude.IO ()
setControlSource controlSource =
  Automation.propertySet "ControlSource" [Automation.inString controlSource]
getControlSource :: IControl a -> Prelude.IO (Prelude.String)
getControlSource =
  Automation.propertyGet "ControlSource" [] Automation.outString
setControlTipText :: Prelude.String -> Automation.IDispatch a -> Prelude.IO ()
setControlTipText controlTipText =
  Automation.propertySet "ControlTipText" [Automation.inString controlTipText]
getControlTipText :: Automation.IDispatch a -> Prelude.IO (Prelude.String)
getControlTipText =
  Automation.propertyGet "ControlTipText" [] Automation.outString
setDefault :: Prelude.Int -> IControl a -> Prelude.IO ()
setDefault default0 =
  Automation.propertySet "Default" [Automation.inInt default0]
getDefault :: IControl a -> Prelude.IO (Prelude.Int)
getDefault = Automation.propertyGet "Default" [] Automation.outInt
setHeight :: Prelude.Int -> IControl a -> Prelude.IO ()
setHeight height =
  Automation.method0 "_SetHeight" [Automation.inInt height]
getHeight :: IControl a -> Prelude.IO (Prelude.Int)
getHeight = Automation.method1 "_GetHeight" [] Automation.outInt
setHeight0 :: Prelude.Float -> IControl a -> Prelude.IO ()
setHeight0 height =
  Automation.propertySet "Height" [Automation.inFloat height]
getHeight0 :: IControl a -> Prelude.IO (Prelude.Float)
getHeight0 = Automation.propertyGet "Height" [] Automation.outFloat
setHelpContextID :: Prelude.Int -> IControl a -> Prelude.IO ()
setHelpContextID helpContextID =
  Automation.propertySet "HelpContextID" [Automation.inInt helpContextID]
getHelpContextID :: IControl a -> Prelude.IO (Prelude.Int)
getHelpContextID =
  Automation.propertyGet "HelpContextID" [] Automation.outInt
setInSelection :: Prelude.Int -> IControl a -> Prelude.IO ()
setInSelection inSelection =
  Automation.propertySet "InSelection" [Automation.inInt inSelection]
getInSelection :: IControl a -> Prelude.IO (Prelude.Int)
getInSelection =
  Automation.propertyGet "InSelection" [] Automation.outInt
getLayoutEffect :: IControl a -> Prelude.IO (Prelude.Int)
getLayoutEffect =
  Automation.propertyGet "LayoutEffect" [] Automation.outInt
setLeft :: Prelude.Int -> IControl a -> Prelude.IO ()
setLeft left =
  Automation.method0 "_SetLeft" [Automation.inInt left]
getLeft :: IControl a -> Prelude.IO (Prelude.Int)
getLeft = Automation.method1 "_GetLeft" [] Automation.outInt
setLeft0 :: Prelude.Float -> IControl a -> Prelude.IO ()
setLeft0 left =
  Automation.propertySet "Left" [Automation.inFloat left]
getLeft0 :: IControl a -> Prelude.IO (Prelude.Float)
getLeft0 = Automation.propertyGet "Left" [] Automation.outFloat
setName :: Prelude.String -> Automation.IDispatch a -> Prelude.IO ()
setName name =
  Automation.propertySet "Name" [Automation.inString name]
getName :: Automation.IDispatch a -> Prelude.IO (Prelude.String)
getName = Automation.propertyGet "Name" [] Automation.outString
getOldHeight :: IControl a -> Prelude.IO (Prelude.Int)
getOldHeight =
  Automation.method1 "_GetOldHeight" [] Automation.outInt
getOldHeight0 :: IControl a -> Prelude.IO (Prelude.Float)
getOldHeight0 =
  Automation.propertyGet "OldHeight" [] Automation.outFloat
getOldLeft :: IControl a -> Prelude.IO (Prelude.Int)
getOldLeft = Automation.method1 "_GetOldLeft" [] Automation.outInt
getOldLeft0 :: IControl a -> Prelude.IO (Prelude.Float)
getOldLeft0 =
  Automation.propertyGet "OldLeft" [] Automation.outFloat
getOldTop :: IControl a -> Prelude.IO (Prelude.Int)
getOldTop = Automation.method1 "_GetOldTop" [] Automation.outInt
getOldTop0 :: IControl a -> Prelude.IO (Prelude.Float)
getOldTop0 = Automation.propertyGet "OldTop" [] Automation.outFloat
getOldWidth :: IControl a -> Prelude.IO (Prelude.Int)
getOldWidth =
  Automation.method1 "_GetOldWidth" [] Automation.outInt
getOldWidth0 :: IControl a -> Prelude.IO (Prelude.Float)
getOldWidth0 =
  Automation.propertyGet "OldWidth" [] Automation.outFloat
getObject :: IControl a -> Prelude.IO (Automation.IDispatch ())
getObject =
  Automation.propertyGet "Object" [] Automation.outIDispatch
getParent :: Automation.IDispatch a -> Prelude.IO (Automation.IDispatch ())
getParent =
  Automation.propertyGet "Parent" [] Automation.outIDispatch
setRowSource :: Prelude.String -> IControl a -> Prelude.IO ()
setRowSource rowSource =
  Automation.propertySet "RowSource" [Automation.inString rowSource]
getRowSource :: IControl a -> Prelude.IO (Prelude.String)
getRowSource =
  Automation.propertyGet "RowSource" [] Automation.outString
setRowSourceType :: Prelude.Int -> IControl a -> Prelude.IO ()
setRowSourceType rowSourceType =
  Automation.propertySet "RowSourceType" [Automation.inInt rowSourceType]
getRowSourceType :: IControl a -> Prelude.IO (Prelude.Int)
getRowSourceType =
  Automation.propertyGet "RowSourceType" [] Automation.outInt
setTabIndex :: Prelude.Int -> IControl a -> Prelude.IO ()
setTabIndex tabIndex =
  Automation.propertySet "TabIndex" [Automation.inInt tabIndex]
getTabIndex :: IControl a -> Prelude.IO (Prelude.Int)
getTabIndex =
  Automation.propertyGet "TabIndex" [] Automation.outInt
setTabStop :: Prelude.Int -> IControl a -> Prelude.IO ()
setTabStop tabStop =
  Automation.propertySet "TabStop" [Automation.inInt tabStop]
getTabStop :: IControl a -> Prelude.IO (Prelude.Int)
getTabStop = Automation.propertyGet "TabStop" [] Automation.outInt
setTag :: Prelude.String -> Automation.IDispatch a -> Prelude.IO ()
setTag tag = Automation.propertySet "Tag" [Automation.inString tag]
getTag :: Automation.IDispatch a -> Prelude.IO (Prelude.String)
getTag = Automation.propertyGet "Tag" [] Automation.outString
setTop :: Prelude.Int -> IControl a -> Prelude.IO ()
setTop top = Automation.method0 "_SetTop" [Automation.inInt top]
getTop :: IControl a -> Prelude.IO (Prelude.Int)
getTop = Automation.method1 "_GetTop" [] Automation.outInt
setTop0 :: Prelude.Float -> IControl a -> Prelude.IO ()
setTop0 top = Automation.propertySet "Top" [Automation.inFloat top]
getTop0 :: IControl a -> Prelude.IO (Prelude.Float)
getTop0 = Automation.propertyGet "Top" [] Automation.outFloat
setBoundValue :: (Automation.Variant a0) => a0 -> IControl a -> Prelude.IO ()
setBoundValue boundValue =
  Automation.propertySet "BoundValue" [Automation.inVariant boundValue]
getBoundValue :: (Automation.Variant a0) => IControl a -> Prelude.IO (a0)
getBoundValue =
  Automation.propertyGet "BoundValue" [] Automation.outVariant
setVisible :: Prelude.Int -> Automation.IDispatch a -> Prelude.IO ()
setVisible visible =
  Automation.propertySet "Visible" [Automation.inInt visible]
getVisible :: Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getVisible = Automation.propertyGet "Visible" [] Automation.outInt
setWidth :: Prelude.Int -> IControl a -> Prelude.IO ()
setWidth width =
  Automation.method0 "_SetWidth" [Automation.inInt width]
getWidth :: IControl a -> Prelude.IO (Prelude.Int)
getWidth = Automation.method1 "_GetWidth" [] Automation.outInt
setWidth0 :: Prelude.Float -> IControl a -> Prelude.IO ()
setWidth0 width =
  Automation.propertySet "Width" [Automation.inFloat width]
getWidth0 :: IControl a -> Prelude.IO (Prelude.Float)
getWidth0 = Automation.propertyGet "Width" [] Automation.outFloat
move :: (Automation.Variant a0, Automation.Variant a1, Automation.Variant a2, Automation.Variant a3, Automation.Variant a4) => a0 -> a1 -> a2 -> a3 -> a4 -> IControl a -> Prelude.IO ()
move left top width height layout =
  Automation.method0 "Move" [Automation.inVariant left, Automation.inVariant top, Automation.inVariant width, Automation.inVariant height, Automation.inVariant layout]
zOrder :: (Automation.Variant a0) => a0 -> IControl a -> Prelude.IO ()
zOrder zPosition =
  Automation.method0 "ZOrder" [Automation.inVariant zPosition]
select :: Prelude.Int -> IControl a -> Prelude.IO ()
select selectInGroup =
  Automation.method0 "Select" [Automation.inInt selectInGroup]
setFocus :: IControl a -> Prelude.IO ()
setFocus = Automation.method0 "SetFocus" []
gethWnd :: IControl a -> Prelude.IO (Prelude.Int)
gethWnd = Automation.function1 "_GethWnd" [] Automation.outInt
getID :: IControl a -> Prelude.IO (Prelude.Int)
getID = Automation.function1 "_GetID" [] Automation.outInt
move0 :: Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> IControl a -> Prelude.IO ()
move0 left top width height =
  Automation.method0 "_Move" [Automation.inInt left, Automation.inInt top, Automation.inInt width, Automation.inInt height]
zOrder0 :: Prelude.Int -> IControl a -> Prelude.IO ()
zOrder0 zPosition =
  Automation.method0 "_ZOrder" [Automation.inInt zPosition]
-- --------------------------------------------------
-- 
-- interface Controls
-- 
-- --------------------------------------------------
data Controls a = Controls
                   
type IControls a = Automation.IDispatch (Controls a)
iidIControls :: Com.IID (IControls ())
iidIControls = Com.mkIID "{04598FC7-866C-11CF-AB7C-00AA00C08FCF}"
getCount :: Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getCount = Automation.propertyGet "Count" [] Automation.outInt
getNewEnum :: Automation.IDispatch a -> Prelude.IO (Com.IUnknown ())
getNewEnum =
  Automation.propertyGet "_NewEnum" [] Automation.outIUnknown
item :: (Automation.Variant a0) => a0 -> Automation.IDispatch a -> Prelude.IO (Automation.IDispatch ())
item varg =
  Automation.function1 "Item" [Automation.inVariant varg] Automation.outIDispatch
move1 :: Prelude.Int -> Prelude.Int -> Automation.IDispatch a -> Prelude.IO ()
move1 cx cy =
  Automation.method0 "_Move" [Automation.inInt cx, Automation.inInt cy]
selectAll :: IControls a -> Prelude.IO ()
selectAll = Automation.method0 "SelectAll" []
addByClass :: Prelude.Int -> IControls a -> Prelude.IO (Automation.IDispatch ())
addByClass clsid =
  Automation.function1 "_AddByClass" [Automation.inInt clsid] Automation.outIDispatch
alignToGrid :: IControls a -> Prelude.IO ()
alignToGrid = Automation.method0 "AlignToGrid" []
bringForward :: IControls a -> Prelude.IO ()
bringForward = Automation.method0 "BringForward" []
bringToFront :: IControls a -> Prelude.IO ()
bringToFront = Automation.method0 "BringToFront" []
copy :: Automation.IDispatch a -> Prelude.IO ()
copy = Automation.method0 "Copy" []
cut :: Automation.IDispatch a -> Prelude.IO ()
cut = Automation.method0 "Cut" []
enum :: Automation.IDispatch a -> Prelude.IO (Com.IUnknown ())
enum = Automation.function1 "Enum" [] Automation.outIUnknown
getItemByIndex :: Prelude.Int -> Automation.IDispatch a -> Prelude.IO (Automation.IDispatch ())
getItemByIndex lIndex =
  Automation.function1 "_GetItemByIndex" [Automation.inInt lIndex] Automation.outIDispatch
getItemByName :: Prelude.String -> Automation.IDispatch a -> Prelude.IO (Automation.IDispatch ())
getItemByName pstr =
  Automation.function1 "_GetItemByName" [Automation.inString pstr] Automation.outIDispatch
getItemByID :: Prelude.Int -> IControls a -> Prelude.IO (Automation.IDispatch ())
getItemByID iD =
  Automation.function1 "_GetItemByID" [Automation.inInt iD] Automation.outIDispatch
sendBackward :: IControls a -> Prelude.IO ()
sendBackward = Automation.method0 "SendBackward" []
sendToBack :: IControls a -> Prelude.IO ()
sendToBack = Automation.method0 "SendToBack" []
move2 :: Prelude.Float -> Prelude.Float -> IControls a -> Prelude.IO ()
move2 cx cy =
  Automation.method0 "Move" [Automation.inFloat cx, Automation.inFloat cy]
add :: (Automation.Variant a0, Automation.Variant a1) => Prelude.String -> a0 -> a1 -> IControls a -> Prelude.IO (Automation.IDispatch ())
add bstrProgID name visible =
  Automation.function1 "Add" [Automation.inString bstrProgID, Automation.inVariant name, Automation.inVariant visible] Automation.outIDispatch
remove :: (Automation.Variant a0) => a0 -> Automation.IDispatch a -> Prelude.IO ()
remove varg =
  Automation.method0 "Remove" [Automation.inVariant varg]
-- --------------------------------------------------
-- 
-- interface IOptionFrame
-- 
-- --------------------------------------------------
data OptionFrame a = OptionFrame
                      
type IOptionFrame a = Automation.IDispatch (OptionFrame a)
iidIOptionFrame :: Com.IID (IOptionFrame ())
iidIOptionFrame =
  Com.mkIID "{29B86A70-F52E-11CE-9BCE-00AA00608E01}"
getActiveControl :: Automation.IDispatch a -> Prelude.IO (Automation.IDispatch ())
getActiveControl =
  Automation.propertyGet "ActiveControl" [] Automation.outIDispatch
setBackColor :: Prelude.Int -> Automation.IDispatch a -> Prelude.IO ()
setBackColor backColor =
  Automation.propertySet "BackColor" [Automation.inInt backColor]
getBackColor :: Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getBackColor =
  Automation.propertyGet "BackColor" [] Automation.outInt
setBorderColor :: Prelude.Int -> Automation.IDispatch a -> Prelude.IO ()
setBorderColor borderColor =
  Automation.propertySet "BorderColor" [Automation.inInt borderColor]
getBorderColor :: Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getBorderColor =
  Automation.propertyGet "BorderColor" [] Automation.outInt
setBorderStyle :: Prelude.Int -> Automation.IDispatch a -> Prelude.IO ()
setBorderStyle borderStyle =
  Automation.propertySet "BorderStyle" [Automation.inInt borderStyle]
getBorderStyle :: Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getBorderStyle =
  Automation.propertyGet "BorderStyle" [] Automation.outInt
getCanPaste :: Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getCanPaste =
  Automation.propertyGet "CanPaste" [] Automation.outInt
getCanRedo :: Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getCanRedo = Automation.propertyGet "CanRedo" [] Automation.outInt
getCanUndo :: Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getCanUndo = Automation.propertyGet "CanUndo" [] Automation.outInt
setCaption :: Prelude.String -> Automation.IDispatch a -> Prelude.IO ()
setCaption caption =
  Automation.propertySet "Caption" [Automation.inString caption]
getCaption :: Automation.IDispatch a -> Prelude.IO (Prelude.String)
getCaption =
  Automation.propertyGet "Caption" [] Automation.outString
getControls :: Automation.IDispatch a -> Prelude.IO (Automation.IDispatch ())
getControls =
  Automation.propertyGet "Controls" [] Automation.outIDispatch
setCycle :: Prelude.Int -> Automation.IDispatch a -> Prelude.IO ()
setCycle cycle =
  Automation.propertySet "Cycle" [Automation.inInt cycle]
getCycle :: Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getCycle = Automation.propertyGet "Cycle" [] Automation.outInt
setEnabled :: Prelude.Int -> Automation.IDispatch a -> Prelude.IO ()
setEnabled enabled =
  Automation.propertySet "Enabled" [Automation.inInt enabled]
getEnabled :: Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getEnabled = Automation.propertyGet "Enabled" [] Automation.outInt
setFont_Reserved :: Automation.IDispatch a0 -> Automation.IDispatch a -> Prelude.IO ()
setFont_Reserved rhs =
  Automation.propertySet "_Font_Reserved" [Automation.inIDispatch rhs]
font :: Automation.IDispatch a0 -> Automation.IDispatch a -> Prelude.IO ()
font font = Automation.method0 "Font" [Automation.inIDispatch font]
getFont :: Automation.IDispatch a -> Prelude.IO (Automation.IDispatch ())
getFont = Automation.propertyGet "Font" [] Automation.outIDispatch
setForeColor :: Prelude.Int -> Automation.IDispatch a -> Prelude.IO ()
setForeColor foreColor =
  Automation.propertySet "ForeColor" [Automation.inInt foreColor]
getForeColor :: Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getForeColor =
  Automation.propertyGet "ForeColor" [] Automation.outInt
getInsideHeight :: Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getInsideHeight =
  Automation.method1 "_GetInsideHeight" [] Automation.outInt
getInsideHeight0 :: Automation.IDispatch a -> Prelude.IO (Prelude.Float)
getInsideHeight0 =
  Automation.propertyGet "InsideHeight" [] Automation.outFloat
getInsideWidth :: Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getInsideWidth =
  Automation.method1 "_GetInsideWidth" [] Automation.outInt
getInsideWidth0 :: Automation.IDispatch a -> Prelude.IO (Prelude.Float)
getInsideWidth0 =
  Automation.propertyGet "InsideWidth" [] Automation.outFloat
setKeepScrollBarsVisible :: Prelude.Int -> Automation.IDispatch a -> Prelude.IO ()
setKeepScrollBarsVisible scrollBars =
  Automation.propertySet "KeepScrollBarsVisible" [Automation.inInt scrollBars]
getKeepScrollBarsVisible :: Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getKeepScrollBarsVisible =
  Automation.propertyGet "KeepScrollBarsVisible" [] Automation.outInt
setMouseIcon :: Automation.IDispatch a0 -> Automation.IDispatch a -> Prelude.IO ()
setMouseIcon mouseIcon =
  Automation.propertySet "MouseIcon" [Automation.inIDispatch mouseIcon]
getMouseIcon :: Automation.IDispatch a -> Prelude.IO (Automation.IDispatch ())
getMouseIcon =
  Automation.propertyGet "MouseIcon" [] Automation.outIDispatch
setMousePointer :: Prelude.Int -> Automation.IDispatch a -> Prelude.IO ()
setMousePointer mousePointer =
  Automation.propertySet "MousePointer" [Automation.inInt mousePointer]
getMousePointer :: Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getMousePointer =
  Automation.propertyGet "MousePointer" [] Automation.outInt
setPictureAlignment :: Prelude.Int -> Automation.IDispatch a -> Prelude.IO ()
setPictureAlignment pictureAlignment =
  Automation.propertySet "PictureAlignment" [Automation.inInt pictureAlignment]
getPictureAlignment :: Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getPictureAlignment =
  Automation.propertyGet "PictureAlignment" [] Automation.outInt
setPicture :: Automation.IDispatch a0 -> Automation.IDispatch a -> Prelude.IO ()
setPicture picture =
  Automation.propertySet "Picture" [Automation.inIDispatch picture]
getPicture :: Automation.IDispatch a -> Prelude.IO (Automation.IDispatch ())
getPicture =
  Automation.propertyGet "Picture" [] Automation.outIDispatch
setPictureSizeMode :: Prelude.Int -> Automation.IDispatch a -> Prelude.IO ()
setPictureSizeMode pictureSizeMode =
  Automation.propertySet "PictureSizeMode" [Automation.inInt pictureSizeMode]
getPictureSizeMode :: Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getPictureSizeMode =
  Automation.propertyGet "PictureSizeMode" [] Automation.outInt
setPictureTiling :: Prelude.Int -> Automation.IDispatch a -> Prelude.IO ()
setPictureTiling pictureTiling =
  Automation.propertySet "PictureTiling" [Automation.inInt pictureTiling]
getPictureTiling :: Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getPictureTiling =
  Automation.propertyGet "PictureTiling" [] Automation.outInt
setScrollBars :: Prelude.Int -> Automation.IDispatch a -> Prelude.IO ()
setScrollBars scrollBars =
  Automation.propertySet "ScrollBars" [Automation.inInt scrollBars]
getScrollBars :: Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getScrollBars =
  Automation.propertyGet "ScrollBars" [] Automation.outInt
setScrollHeight :: Prelude.Int -> Automation.IDispatch a -> Prelude.IO ()
setScrollHeight scrollHeight =
  Automation.method0 "_SetScrollHeight" [Automation.inInt scrollHeight]
getScrollHeight :: Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getScrollHeight =
  Automation.method1 "_GetScrollHeight" [] Automation.outInt
setScrollHeight0 :: Prelude.Float -> Automation.IDispatch a -> Prelude.IO ()
setScrollHeight0 scrollHeight =
  Automation.propertySet "ScrollHeight" [Automation.inFloat scrollHeight]
getScrollHeight0 :: Automation.IDispatch a -> Prelude.IO (Prelude.Float)
getScrollHeight0 =
  Automation.propertyGet "ScrollHeight" [] Automation.outFloat
setScrollLeft :: Prelude.Int -> Automation.IDispatch a -> Prelude.IO ()
setScrollLeft scrollLeft =
  Automation.method0 "_SetScrollLeft" [Automation.inInt scrollLeft]
getScrollLeft :: Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getScrollLeft =
  Automation.method1 "_GetScrollLeft" [] Automation.outInt
setScrollLeft0 :: Prelude.Float -> Automation.IDispatch a -> Prelude.IO ()
setScrollLeft0 scrollLeft =
  Automation.propertySet "ScrollLeft" [Automation.inFloat scrollLeft]
getScrollLeft0 :: Automation.IDispatch a -> Prelude.IO (Prelude.Float)
getScrollLeft0 =
  Automation.propertyGet "ScrollLeft" [] Automation.outFloat
setScrollTop :: Prelude.Int -> Automation.IDispatch a -> Prelude.IO ()
setScrollTop scrollTop =
  Automation.method0 "_SetScrollTop" [Automation.inInt scrollTop]
getScrollTop :: Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getScrollTop =
  Automation.method1 "_GetScrollTop" [] Automation.outInt
setScrollTop0 :: Prelude.Float -> Automation.IDispatch a -> Prelude.IO ()
setScrollTop0 scrollTop =
  Automation.propertySet "ScrollTop" [Automation.inFloat scrollTop]
getScrollTop0 :: Automation.IDispatch a -> Prelude.IO (Prelude.Float)
getScrollTop0 =
  Automation.propertyGet "ScrollTop" [] Automation.outFloat
setScrollWidth :: Prelude.Int -> Automation.IDispatch a -> Prelude.IO ()
setScrollWidth scrollWidth =
  Automation.method0 "_SetScrollWidth" [Automation.inInt scrollWidth]
getScrollWidth :: Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getScrollWidth =
  Automation.method1 "_GetScrollWidth" [] Automation.outInt
setScrollWidth0 :: Prelude.Float -> Automation.IDispatch a -> Prelude.IO ()
setScrollWidth0 scrollWidth =
  Automation.propertySet "ScrollWidth" [Automation.inFloat scrollWidth]
getScrollWidth0 :: Automation.IDispatch a -> Prelude.IO (Prelude.Float)
getScrollWidth0 =
  Automation.propertyGet "ScrollWidth" [] Automation.outFloat
getSelected :: Automation.IDispatch a -> Prelude.IO (Automation.IDispatch ())
getSelected =
  Automation.propertyGet "Selected" [] Automation.outIDispatch
setSpecialEffect :: Prelude.Int -> Automation.IDispatch a -> Prelude.IO ()
setSpecialEffect specialEffect =
  Automation.propertySet "SpecialEffect" [Automation.inInt specialEffect]
getSpecialEffect :: Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getSpecialEffect =
  Automation.propertyGet "SpecialEffect" [] Automation.outInt
setVerticalScrollBarSide :: Prelude.Int -> Automation.IDispatch a -> Prelude.IO ()
setVerticalScrollBarSide side =
  Automation.propertySet "VerticalScrollBarSide" [Automation.inInt side]
getVerticalScrollBarSide :: Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getVerticalScrollBarSide =
  Automation.propertyGet "VerticalScrollBarSide" [] Automation.outInt
setZoom :: Prelude.Int -> Automation.IDispatch a -> Prelude.IO ()
setZoom zoom =
  Automation.propertySet "Zoom" [Automation.inInt zoom]
getZoom :: Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getZoom = Automation.propertyGet "Zoom" [] Automation.outInt
paste :: Automation.IDispatch a -> Prelude.IO ()
paste = Automation.method0 "Paste" []
redoAction :: Automation.IDispatch a -> Prelude.IO ()
redoAction = Automation.method0 "RedoAction" []
repaint :: Automation.IDispatch a -> Prelude.IO ()
repaint = Automation.method0 "Repaint" []
scroll :: (Automation.Variant a0, Automation.Variant a1) => a0 -> a1 -> Automation.IDispatch a -> Prelude.IO ()
scroll xAction yAction =
  Automation.method0 "Scroll" [Automation.inVariant xAction, Automation.inVariant yAction]
setDefaultTabOrder :: Automation.IDispatch a -> Prelude.IO ()
setDefaultTabOrder = Automation.method0 "SetDefaultTabOrder" []
undoAction :: Automation.IDispatch a -> Prelude.IO ()
undoAction = Automation.method0 "UndoAction" []
setDesignMode :: Prelude.Int -> Automation.IDispatch a -> Prelude.IO ()
setDesignMode designMode =
  Automation.propertySet "DesignMode" [Automation.inInt designMode]
getDesignMode :: Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getDesignMode =
  Automation.propertyGet "DesignMode" [] Automation.outInt
setShowToolbox :: Prelude.Int -> Automation.IDispatch a -> Prelude.IO ()
setShowToolbox showToolbox =
  Automation.propertySet "ShowToolbox" [Automation.inInt showToolbox]
getShowToolbox :: Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getShowToolbox =
  Automation.propertyGet "ShowToolbox" [] Automation.outInt
setShowGridDots :: Prelude.Int -> Automation.IDispatch a -> Prelude.IO ()
setShowGridDots showGridDots =
  Automation.propertySet "ShowGridDots" [Automation.inInt showGridDots]
getShowGridDots :: Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getShowGridDots =
  Automation.propertyGet "ShowGridDots" [] Automation.outInt
setSnapToGrid :: Prelude.Int -> Automation.IDispatch a -> Prelude.IO ()
setSnapToGrid snapToGrid =
  Automation.propertySet "SnapToGrid" [Automation.inInt snapToGrid]
getSnapToGrid :: Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getSnapToGrid =
  Automation.propertyGet "SnapToGrid" [] Automation.outInt
setGridX :: Prelude.Float -> Automation.IDispatch a -> Prelude.IO ()
setGridX gridX =
  Automation.propertySet "GridX" [Automation.inFloat gridX]
getGridX :: Automation.IDispatch a -> Prelude.IO (Prelude.Float)
getGridX = Automation.propertyGet "GridX" [] Automation.outFloat
setGridX0 :: Prelude.Int -> Automation.IDispatch a -> Prelude.IO ()
setGridX0 gridX =
  Automation.method0 "_SetGridX" [Automation.inInt gridX]
getGridX0 :: Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getGridX0 = Automation.method1 "_GetGridX" [] Automation.outInt
setGridY :: Prelude.Float -> Automation.IDispatch a -> Prelude.IO ()
setGridY gridY =
  Automation.propertySet "GridY" [Automation.inFloat gridY]
getGridY :: Automation.IDispatch a -> Prelude.IO (Prelude.Float)
getGridY = Automation.propertyGet "GridY" [] Automation.outFloat
setGridY0 :: Prelude.Int -> Automation.IDispatch a -> Prelude.IO ()
setGridY0 gridY =
  Automation.method0 "_SetGridY" [Automation.inInt gridY]
getGridY0 :: Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getGridY0 = Automation.method1 "_GetGridY" [] Automation.outInt
-- --------------------------------------------------
-- 
-- interface UserForm
-- 
-- --------------------------------------------------
data UserForm a = UserForm
                   
type IUserForm a = IOptionFrame (UserForm a)
iidIUserForm :: Com.IID (IUserForm ())
iidIUserForm = Com.mkIID "{04598FC8-866C-11CF-AB7C-00AA00C08FCF}"
setDrawBuffer :: Prelude.Int -> IUserForm a -> Prelude.IO ()
setDrawBuffer drawBuffer =
  Automation.propertySet "DrawBuffer" [Automation.inInt drawBuffer]
getDrawBuffer :: IUserForm a -> Prelude.IO (Prelude.Int)
getDrawBuffer =
  Automation.propertyGet "DrawBuffer" [] Automation.outInt
-- --------------------------------------------------
-- 
-- dispinterface ControlEvents
-- 
-- --------------------------------------------------
data ControlEvents a = ControlEvents
                        
type IControlEvents a = Automation.IDispatch (ControlEvents a)
iidIControlEvents :: Com.IID (IControlEvents ())
iidIControlEvents =
  Com.mkIID "{9A4BBF53-4E46-101B-8BBD-00AA003E3B29}"
enter :: IControlEvents a -> Prelude.IO ()
enter = Automation.method0 "Enter" []
exit :: (Automation.Variant a0) => a0 -> IControlEvents a -> Prelude.IO ()
exit cancel =
  Automation.method0 "Exit" [Automation.inVariant cancel]
beforeUpdate :: (Automation.Variant a0) => a0 -> IControlEvents a -> Prelude.IO ()
beforeUpdate cancel =
  Automation.method0 "BeforeUpdate" [Automation.inVariant cancel]
afterUpdate :: IControlEvents a -> Prelude.IO ()
afterUpdate = Automation.method0 "AfterUpdate" []
-- --------------------------------------------------
-- 
-- coclass Control
-- 
-- --------------------------------------------------
clsidControl :: Com.CLSID
clsidControl = Com.mkCLSID "{909E0AE0-16DC-11CE-9E98-00AA00574A4F}"
-- --------------------------------------------------
-- 
-- dispinterface FormEvents
-- 
-- --------------------------------------------------
data FormEvents a = FormEvents
                     
type IFormEvents a = Automation.IDispatch (FormEvents a)
iidIFormEvents :: Com.IID (IFormEvents ())
iidIFormEvents = Com.mkIID "{5B9D8FC8-4A71-101B-97A6-00000B65C08B}"
addControl :: Automation.IDispatch a0 -> Automation.IDispatch a -> Prelude.IO ()
addControl control =
  Automation.method0 "AddControl" [Automation.inIDispatch control]
beforeDragOver :: (Automation.Variant a0, Automation.Variant a2, Automation.Variant a3) => a0 -> Automation.IDispatch a1 -> a2 -> Prelude.Float -> Prelude.Float -> Prelude.Int -> a3 -> Prelude.Int -> Automation.IDispatch a -> Prelude.IO ()
beforeDragOver cancel control data0 x y state effect shift =
  Automation.method0 "BeforeDragOver" [Automation.inVariant cancel, Automation.inIDispatch control, Automation.inVariant data0, Automation.inFloat x, Automation.inFloat y, Automation.inInt state, Automation.inVariant effect, Automation.inInt shift]
beforeDropOrPaste :: (Automation.Variant a0, Automation.Variant a2, Automation.Variant a3) => a0 -> Automation.IDispatch a1 -> Prelude.Int -> a2 -> Prelude.Float -> Prelude.Float -> a3 -> Prelude.Int -> Automation.IDispatch a -> Prelude.IO ()
beforeDropOrPaste cancel control action data0 x y effect shift =
  Automation.method0 "BeforeDropOrPaste" [Automation.inVariant cancel, Automation.inIDispatch control, Automation.inInt action, Automation.inVariant data0, Automation.inFloat x, Automation.inFloat y, Automation.inVariant effect, Automation.inInt shift]
click :: Automation.IDispatch a -> Prelude.IO ()
click = Automation.method0 "Click" []
dblClick :: (Automation.Variant a0) => a0 -> Automation.IDispatch a -> Prelude.IO ()
dblClick cancel =
  Automation.method0 "DblClick" [Automation.inVariant cancel]
onError :: (Automation.Variant a0, Automation.Variant a1) => Prelude.Int -> a0 -> Prelude.Int -> Prelude.String -> Prelude.String -> Prelude.Int -> a1 -> Automation.IDispatch a -> Prelude.IO ()
onError number description sCode source helpFile helpContext cancelDisplay =
  Automation.method0 "Error" [Automation.inInt number, Automation.inVariant description, Automation.inInt sCode, Automation.inString source, Automation.inString helpFile, Automation.inInt helpContext, Automation.inVariant cancelDisplay]
keyDown :: (Automation.Variant a0) => a0 -> Prelude.Int -> Automation.IDispatch a -> Prelude.IO ()
keyDown keyCode shift =
  Automation.method0 "KeyDown" [Automation.inVariant keyCode, Automation.inInt shift]
keyPress :: (Automation.Variant a0) => a0 -> Automation.IDispatch a -> Prelude.IO ()
keyPress keyAscii =
  Automation.method0 "KeyPress" [Automation.inVariant keyAscii]
keyUp :: (Automation.Variant a0) => a0 -> Prelude.Int -> Automation.IDispatch a -> Prelude.IO ()
keyUp keyCode shift =
  Automation.method0 "KeyUp" [Automation.inVariant keyCode, Automation.inInt shift]
layout :: Automation.IDispatch a -> Prelude.IO ()
layout = Automation.method0 "Layout" []
mouseDown :: Prelude.Int -> Prelude.Int -> Prelude.Float -> Prelude.Float -> Automation.IDispatch a -> Prelude.IO ()
mouseDown button shift x y =
  Automation.method0 "MouseDown" [Automation.inInt button, Automation.inInt shift, Automation.inFloat x, Automation.inFloat y]
mouseMove :: Prelude.Int -> Prelude.Int -> Prelude.Float -> Prelude.Float -> Automation.IDispatch a -> Prelude.IO ()
mouseMove button shift x y =
  Automation.method0 "MouseMove" [Automation.inInt button, Automation.inInt shift, Automation.inFloat x, Automation.inFloat y]
mouseUp :: Prelude.Int -> Prelude.Int -> Prelude.Float -> Prelude.Float -> Automation.IDispatch a -> Prelude.IO ()
mouseUp button shift x y =
  Automation.method0 "MouseUp" [Automation.inInt button, Automation.inInt shift, Automation.inFloat x, Automation.inFloat y]
removeControl :: Automation.IDispatch a0 -> Automation.IDispatch a -> Prelude.IO ()
removeControl control =
  Automation.method0 "RemoveControl" [Automation.inIDispatch control]
scroll1 :: (Automation.Variant a0, Automation.Variant a1) => Prelude.Int -> Prelude.Int -> Prelude.Float -> Prelude.Float -> a0 -> a1 -> Automation.IDispatch a -> Prelude.IO ()
scroll1 actionX actionY requestDx requestDy actualDx actualDy =
  Automation.method0 "Scroll" [Automation.inInt actionX, Automation.inInt actionY, Automation.inFloat requestDx, Automation.inFloat requestDy, Automation.inVariant actualDx, Automation.inVariant actualDy]
zoom :: Prelude.Int -> Automation.IDispatch a -> Prelude.IO (Prelude.Int)
zoom percent =
  Automation.method1 "Zoom" [] (Automation.inoutInt percent)
-- --------------------------------------------------
-- 
-- dispinterface OptionFrameEvents
-- 
-- --------------------------------------------------
data OptionFrameEvents a = OptionFrameEvents
                            
type IOptionFrameEvents a = Automation.IDispatch (OptionFrameEvents a)
iidIOptionFrameEvents :: Com.IID (IOptionFrameEvents ())
iidIOptionFrameEvents =
  Com.mkIID "{CF3F94A0-F546-11CE-9BCE-00AA00608E01}"
-- --------------------------------------------------
-- 
-- coclass UserForm
-- 
-- --------------------------------------------------
clsidUserForm :: Com.CLSID
clsidUserForm =
  Com.mkCLSID "{C62A69F0-16DC-11CE-9E98-00AA00574A4F}"
-- --------------------------------------------------
-- 
-- coclass Frame
-- 
-- --------------------------------------------------
clsidFrame :: Com.CLSID
clsidFrame = Com.mkCLSID "{6E182020-F460-11CE-9BCD-00AA00608E01}"
data FmButtonEffect
 = FmButtonEffectFlat
 | FmButtonEffectSunken
 
marshallFmButtonEffect :: FmButtonEffect -> Prelude.IO Int.Int16
marshallFmButtonEffect v =
  case v of
     FmButtonEffectFlat -> Prelude.return (0)
     FmButtonEffectSunken -> Prelude.return (2)
unmarshallFmButtonEffect :: Int.Int16 -> Prelude.IO FmButtonEffect
unmarshallFmButtonEffect v =
  case v of
     0 -> Prelude.return (FmButtonEffectFlat)
     2 -> Prelude.return (FmButtonEffectSunken)
     _ -> Prelude.fail (Prelude.userError "unmarshallFmButtonEffect: illegal enum value ")
data FmOrientation
 = FmOrientationAuto
 | FmOrientationVertical
 | FmOrientationHorizontal
 
marshallFmOrientation :: FmOrientation -> Prelude.IO Int.Int16
marshallFmOrientation v =
  case v of
     FmOrientationAuto -> Prelude.return ((-1))
     FmOrientationVertical -> Prelude.return (0)
     FmOrientationHorizontal -> Prelude.return (1)
unmarshallFmOrientation :: Int.Int16 -> Prelude.IO FmOrientation
unmarshallFmOrientation v =
  case v of
     (-1) -> Prelude.return (FmOrientationAuto)
     0 -> Prelude.return (FmOrientationVertical)
     1 -> Prelude.return (FmOrientationHorizontal)
     _ -> Prelude.fail (Prelude.userError "unmarshallFmOrientation: illegal enum value ")
data FmSnapPoint
 = FmSnapPointTopLeft
 | FmSnapPointTopCenter
 | FmSnapPointTopRight
 | FmSnapPointCenterLeft
 | FmSnapPointCenter
 | FmSnapPointCenterRight
 | FmSnapPointBottomLeft
 | FmSnapPointBottomCenter
 | FmSnapPointBottomRight
 
marshallFmSnapPoint :: FmSnapPoint -> Prelude.IO Int.Int16
marshallFmSnapPoint v =
  case v of
     FmSnapPointTopLeft -> Prelude.return (0)
     FmSnapPointTopCenter -> Prelude.return (1)
     FmSnapPointTopRight -> Prelude.return (2)
     FmSnapPointCenterLeft -> Prelude.return (3)
     FmSnapPointCenter -> Prelude.return (4)
     FmSnapPointCenterRight -> Prelude.return (5)
     FmSnapPointBottomLeft -> Prelude.return (6)
     FmSnapPointBottomCenter -> Prelude.return (7)
     FmSnapPointBottomRight -> Prelude.return (8)
unmarshallFmSnapPoint :: Int.Int16 -> Prelude.IO FmSnapPoint
unmarshallFmSnapPoint v =
  case v of
     0 -> Prelude.return (FmSnapPointTopLeft)
     1 -> Prelude.return (FmSnapPointTopCenter)
     2 -> Prelude.return (FmSnapPointTopRight)
     3 -> Prelude.return (FmSnapPointCenterLeft)
     4 -> Prelude.return (FmSnapPointCenter)
     5 -> Prelude.return (FmSnapPointCenterRight)
     6 -> Prelude.return (FmSnapPointBottomLeft)
     7 -> Prelude.return (FmSnapPointBottomCenter)
     8 -> Prelude.return (FmSnapPointBottomRight)
     _ -> Prelude.fail (Prelude.userError "unmarshallFmSnapPoint: illegal enum value ")
data FmPicturePosition
 = FmPicturePositionLeftTop
 | FmPicturePositionLeftCenter
 | FmPicturePositionLeftBottom
 | FmPicturePositionRightTop
 | FmPicturePositionRightCenter
 | FmPicturePositionRightBottom
 | FmPicturePositionAboveLeft
 | FmPicturePositionAboveCenter
 | FmPicturePositionAboveRight
 | FmPicturePositionBelowLeft
 | FmPicturePositionBelowCenter
 | FmPicturePositionBelowRight
 | FmPicturePositionCenter
 
marshallFmPicturePosition :: FmPicturePosition -> Prelude.IO Int.Int16
marshallFmPicturePosition v =
  case v of
     FmPicturePositionLeftTop -> Prelude.return (0)
     FmPicturePositionLeftCenter -> Prelude.return (1)
     FmPicturePositionLeftBottom -> Prelude.return (2)
     FmPicturePositionRightTop -> Prelude.return (3)
     FmPicturePositionRightCenter -> Prelude.return (4)
     FmPicturePositionRightBottom -> Prelude.return (5)
     FmPicturePositionAboveLeft -> Prelude.return (6)
     FmPicturePositionAboveCenter -> Prelude.return (7)
     FmPicturePositionAboveRight -> Prelude.return (8)
     FmPicturePositionBelowLeft -> Prelude.return (9)
     FmPicturePositionBelowCenter -> Prelude.return (10)
     FmPicturePositionBelowRight -> Prelude.return (11)
     FmPicturePositionCenter -> Prelude.return (12)
unmarshallFmPicturePosition :: Int.Int16 -> Prelude.IO FmPicturePosition
unmarshallFmPicturePosition v =
  case v of
     0 -> Prelude.return (FmPicturePositionLeftTop)
     1 -> Prelude.return (FmPicturePositionLeftCenter)
     2 -> Prelude.return (FmPicturePositionLeftBottom)
     3 -> Prelude.return (FmPicturePositionRightTop)
     4 -> Prelude.return (FmPicturePositionRightCenter)
     5 -> Prelude.return (FmPicturePositionRightBottom)
     6 -> Prelude.return (FmPicturePositionAboveLeft)
     7 -> Prelude.return (FmPicturePositionAboveCenter)
     8 -> Prelude.return (FmPicturePositionAboveRight)
     9 -> Prelude.return (FmPicturePositionBelowLeft)
     10 -> Prelude.return (FmPicturePositionBelowCenter)
     11 -> Prelude.return (FmPicturePositionBelowRight)
     12 -> Prelude.return (FmPicturePositionCenter)
     _ -> Prelude.fail (Prelude.userError "unmarshallFmPicturePosition: illegal enum value ")
data FmDisplayStyle
 = FmDisplayStyleText
 | FmDisplayStyleList
 | FmDisplayStyleCombo
 | FmDisplayStyleCheckBox
 | FmDisplayStyleOptionButton
 | FmDisplayStyleToggle
 | FmDisplayStyleDropList
 
marshallFmDisplayStyle :: FmDisplayStyle -> Prelude.IO Int.Int16
marshallFmDisplayStyle v =
  case v of
     FmDisplayStyleText -> Prelude.return (1)
     FmDisplayStyleList -> Prelude.return (2)
     FmDisplayStyleCombo -> Prelude.return (3)
     FmDisplayStyleCheckBox -> Prelude.return (4)
     FmDisplayStyleOptionButton -> Prelude.return (5)
     FmDisplayStyleToggle -> Prelude.return (6)
     FmDisplayStyleDropList -> Prelude.return (7)
unmarshallFmDisplayStyle :: Int.Int16 -> Prelude.IO FmDisplayStyle
unmarshallFmDisplayStyle v =
  case v of
     1 -> Prelude.return (FmDisplayStyleText)
     2 -> Prelude.return (FmDisplayStyleList)
     3 -> Prelude.return (FmDisplayStyleCombo)
     4 -> Prelude.return (FmDisplayStyleCheckBox)
     5 -> Prelude.return (FmDisplayStyleOptionButton)
     6 -> Prelude.return (FmDisplayStyleToggle)
     7 -> Prelude.return (FmDisplayStyleDropList)
     _ -> Prelude.fail (Prelude.userError "unmarshallFmDisplayStyle: illegal enum value ")
data FmShowListWhen
 = FmShowListWhenNever
 | FmShowListWhenButton
 | FmShowListWhenFocus
 | FmShowListWhenAlways
 
marshallFmShowListWhen :: FmShowListWhen -> Prelude.IO Int.Int16
marshallFmShowListWhen v =
  case v of
     FmShowListWhenNever -> Prelude.return (0)
     FmShowListWhenButton -> Prelude.return (1)
     FmShowListWhenFocus -> Prelude.return (2)
     FmShowListWhenAlways -> Prelude.return (3)
unmarshallFmShowListWhen :: Int.Int16 -> Prelude.IO FmShowListWhen
unmarshallFmShowListWhen v =
  case v of
     0 -> Prelude.return (FmShowListWhenNever)
     1 -> Prelude.return (FmShowListWhenButton)
     2 -> Prelude.return (FmShowListWhenFocus)
     3 -> Prelude.return (FmShowListWhenAlways)
     _ -> Prelude.fail (Prelude.userError "unmarshallFmShowListWhen: illegal enum value ")
data FmShowDropButtonWhen
 = FmShowDropButtonWhenNever
 | FmShowDropButtonWhenFocus
 | FmShowDropButtonWhenAlways
 
marshallFmShowDropButtonWhen :: FmShowDropButtonWhen -> Prelude.IO Int.Int16
marshallFmShowDropButtonWhen v =
  case v of
     FmShowDropButtonWhenNever -> Prelude.return (0)
     FmShowDropButtonWhenFocus -> Prelude.return (1)
     FmShowDropButtonWhenAlways -> Prelude.return (2)
unmarshallFmShowDropButtonWhen :: Int.Int16 -> Prelude.IO FmShowDropButtonWhen
unmarshallFmShowDropButtonWhen v =
  case v of
     0 -> Prelude.return (FmShowDropButtonWhenNever)
     1 -> Prelude.return (FmShowDropButtonWhenFocus)
     2 -> Prelude.return (FmShowDropButtonWhenAlways)
     _ -> Prelude.fail (Prelude.userError "unmarshallFmShowDropButtonWhen: illegal enum value ")
data FmMultiSelect
 = FmMultiSelectSingle
 | FmMultiSelectMulti
 | FmMultiSelectExtended
 
marshallFmMultiSelect :: FmMultiSelect -> Prelude.IO Int.Int16
marshallFmMultiSelect v =
  case v of
     FmMultiSelectSingle -> Prelude.return (0)
     FmMultiSelectMulti -> Prelude.return (1)
     FmMultiSelectExtended -> Prelude.return (2)
unmarshallFmMultiSelect :: Int.Int16 -> Prelude.IO FmMultiSelect
unmarshallFmMultiSelect v =
  case v of
     0 -> Prelude.return (FmMultiSelectSingle)
     1 -> Prelude.return (FmMultiSelectMulti)
     2 -> Prelude.return (FmMultiSelectExtended)
     _ -> Prelude.fail (Prelude.userError "unmarshallFmMultiSelect: illegal enum value ")
data FmListStyle
 = FmListStylePlain
 | FmListStyleOption
 
marshallFmListStyle :: FmListStyle -> Prelude.IO Int.Int16
marshallFmListStyle v =
  case v of
     FmListStylePlain -> Prelude.return (0)
     FmListStyleOption -> Prelude.return (1)
unmarshallFmListStyle :: Int.Int16 -> Prelude.IO FmListStyle
unmarshallFmListStyle v =
  case v of
     0 -> Prelude.return (FmListStylePlain)
     1 -> Prelude.return (FmListStyleOption)
     _ -> Prelude.fail (Prelude.userError "unmarshallFmListStyle: illegal enum value ")
data FmEnterFieldBehavior
 = FmEnterFieldBehaviorSelectAll
 | FmEnterFieldBehaviorRecallSelection
 
marshallFmEnterFieldBehavior :: FmEnterFieldBehavior -> Prelude.IO Int.Int16
marshallFmEnterFieldBehavior v =
  case v of
     FmEnterFieldBehaviorSelectAll -> Prelude.return (0)
     FmEnterFieldBehaviorRecallSelection -> Prelude.return (1)
unmarshallFmEnterFieldBehavior :: Int.Int16 -> Prelude.IO FmEnterFieldBehavior
unmarshallFmEnterFieldBehavior v =
  case v of
     0 -> Prelude.return (FmEnterFieldBehaviorSelectAll)
     1 -> Prelude.return (FmEnterFieldBehaviorRecallSelection)
     _ -> Prelude.fail (Prelude.userError "unmarshallFmEnterFieldBehavior: illegal enum value ")
data FmDragBehavior
 = FmDragBehaviorDisabled
 | FmDragBehaviorEnabled
 
marshallFmDragBehavior :: FmDragBehavior -> Prelude.IO Int.Int16
marshallFmDragBehavior v =
  case v of
     FmDragBehaviorDisabled -> Prelude.return (0)
     FmDragBehaviorEnabled -> Prelude.return (1)
unmarshallFmDragBehavior :: Int.Int16 -> Prelude.IO FmDragBehavior
unmarshallFmDragBehavior v =
  case v of
     0 -> Prelude.return (FmDragBehaviorDisabled)
     1 -> Prelude.return (FmDragBehaviorEnabled)
     _ -> Prelude.fail (Prelude.userError "unmarshallFmDragBehavior: illegal enum value ")
data FmMatchEntry
 = FmMatchEntryFirstLetter
 | FmMatchEntryComplete
 | FmMatchEntryNone
 
marshallFmMatchEntry :: FmMatchEntry -> Prelude.IO Int.Int16
marshallFmMatchEntry v =
  case v of
     FmMatchEntryFirstLetter -> Prelude.return (0)
     FmMatchEntryComplete -> Prelude.return (1)
     FmMatchEntryNone -> Prelude.return (2)
unmarshallFmMatchEntry :: Int.Int16 -> Prelude.IO FmMatchEntry
unmarshallFmMatchEntry v =
  case v of
     0 -> Prelude.return (FmMatchEntryFirstLetter)
     1 -> Prelude.return (FmMatchEntryComplete)
     2 -> Prelude.return (FmMatchEntryNone)
     _ -> Prelude.fail (Prelude.userError "unmarshallFmMatchEntry: illegal enum value ")
data FmDropButtonStyle
 = FmDropButtonStylePlain
 | FmDropButtonStyleArrow
 | FmDropButtonStyleEllipsis
 | FmDropButtonStyleReduce
 
marshallFmDropButtonStyle :: FmDropButtonStyle -> Prelude.IO Int.Int16
marshallFmDropButtonStyle v =
  case v of
     FmDropButtonStylePlain -> Prelude.return (0)
     FmDropButtonStyleArrow -> Prelude.return (1)
     FmDropButtonStyleEllipsis -> Prelude.return (2)
     FmDropButtonStyleReduce -> Prelude.return (3)
unmarshallFmDropButtonStyle :: Int.Int16 -> Prelude.IO FmDropButtonStyle
unmarshallFmDropButtonStyle v =
  case v of
     0 -> Prelude.return (FmDropButtonStylePlain)
     1 -> Prelude.return (FmDropButtonStyleArrow)
     2 -> Prelude.return (FmDropButtonStyleEllipsis)
     3 -> Prelude.return (FmDropButtonStyleReduce)
     _ -> Prelude.fail (Prelude.userError "unmarshallFmDropButtonStyle: illegal enum value ")
data FmStyle
 = FmStyleDropDownCombo
 | FmStyleDropDownList
 
marshallFmStyle :: FmStyle -> Prelude.IO Int.Int16
marshallFmStyle v =
  case v of
     FmStyleDropDownCombo -> Prelude.return (0)
     FmStyleDropDownList -> Prelude.return (2)
unmarshallFmStyle :: Int.Int16 -> Prelude.IO FmStyle
unmarshallFmStyle v =
  case v of
     0 -> Prelude.return (FmStyleDropDownCombo)
     2 -> Prelude.return (FmStyleDropDownList)
     _ -> Prelude.fail (Prelude.userError "unmarshallFmStyle: illegal enum value ")
data FmTabOrientation
 = FmTabOrientationTop
 | FmTabOrientationBottom
 | FmTabOrientationLeft
 | FmTabOrientationRight
 
marshallFmTabOrientation :: FmTabOrientation -> Prelude.IO Int.Int16
marshallFmTabOrientation v =
  case v of
     FmTabOrientationTop -> Prelude.return (0)
     FmTabOrientationBottom -> Prelude.return (1)
     FmTabOrientationLeft -> Prelude.return (2)
     FmTabOrientationRight -> Prelude.return (3)
unmarshallFmTabOrientation :: Int.Int16 -> Prelude.IO FmTabOrientation
unmarshallFmTabOrientation v =
  case v of
     0 -> Prelude.return (FmTabOrientationTop)
     1 -> Prelude.return (FmTabOrientationBottom)
     2 -> Prelude.return (FmTabOrientationLeft)
     3 -> Prelude.return (FmTabOrientationRight)
     _ -> Prelude.fail (Prelude.userError "unmarshallFmTabOrientation: illegal enum value ")
data FmTabStyle
 = FmTabStyleTabs
 | FmTabStyleButtons
 | FmTabStyleNone
 
marshallFmTabStyle :: FmTabStyle -> Prelude.IO Int.Int16
marshallFmTabStyle v =
  case v of
     FmTabStyleTabs -> Prelude.return (0)
     FmTabStyleButtons -> Prelude.return (1)
     FmTabStyleNone -> Prelude.return (2)
unmarshallFmTabStyle :: Int.Int16 -> Prelude.IO FmTabStyle
unmarshallFmTabStyle v =
  case v of
     0 -> Prelude.return (FmTabStyleTabs)
     1 -> Prelude.return (FmTabStyleButtons)
     2 -> Prelude.return (FmTabStyleNone)
     _ -> Prelude.fail (Prelude.userError "unmarshallFmTabStyle: illegal enum value ")
data FmIMEMode
 = FmIMEModeNoControl
 | FmIMEModeOn
 | FmIMEModeOff
 | FmIMEModeDisable
 | FmIMEModeHiragana
 | FmIMEModeKatakana
 | FmIMEModeKatakanaHalf
 | FmIMEModeAlphaFull
 | FmIMEModeAlpha
 | FmIMEModeHangulFull
 | FmIMEModeHangul
 | FmIMEModeHanziFull
 | FmIMEModeHanzi
 
marshallFmIMEMode :: FmIMEMode -> Prelude.IO Int.Int16
marshallFmIMEMode v =
  case v of
     FmIMEModeNoControl -> Prelude.return (0)
     FmIMEModeOn -> Prelude.return (1)
     FmIMEModeOff -> Prelude.return (2)
     FmIMEModeDisable -> Prelude.return (3)
     FmIMEModeHiragana -> Prelude.return (4)
     FmIMEModeKatakana -> Prelude.return (5)
     FmIMEModeKatakanaHalf -> Prelude.return (6)
     FmIMEModeAlphaFull -> Prelude.return (7)
     FmIMEModeAlpha -> Prelude.return (8)
     FmIMEModeHangulFull -> Prelude.return (9)
     FmIMEModeHangul -> Prelude.return (10)
     FmIMEModeHanziFull -> Prelude.return (11)
     FmIMEModeHanzi -> Prelude.return (12)
unmarshallFmIMEMode :: Int.Int16 -> Prelude.IO FmIMEMode
unmarshallFmIMEMode v =
  case v of
     0 -> Prelude.return (FmIMEModeNoControl)
     1 -> Prelude.return (FmIMEModeOn)
     2 -> Prelude.return (FmIMEModeOff)
     3 -> Prelude.return (FmIMEModeDisable)
     4 -> Prelude.return (FmIMEModeHiragana)
     5 -> Prelude.return (FmIMEModeKatakana)
     6 -> Prelude.return (FmIMEModeKatakanaHalf)
     7 -> Prelude.return (FmIMEModeAlphaFull)
     8 -> Prelude.return (FmIMEModeAlpha)
     9 -> Prelude.return (FmIMEModeHangulFull)
     10 -> Prelude.return (FmIMEModeHangul)
     11 -> Prelude.return (FmIMEModeHanziFull)
     12 -> Prelude.return (FmIMEModeHanzi)
     _ -> Prelude.fail (Prelude.userError "unmarshallFmIMEMode: illegal enum value ")
-- --------------------------------------------------
-- 
-- interface ILabelControl
-- 
-- --------------------------------------------------
data LabelControl a = LabelControl
                       
type ILabelControl a = Automation.IDispatch (LabelControl a)
iidILabelControl :: Com.IID (ILabelControl ())
iidILabelControl =
  Com.mkIID "{04598FC1-866C-11CF-AB7C-00AA00C08FCF}"
setAutoSize :: Prelude.Int -> Automation.IDispatch a -> Prelude.IO ()
setAutoSize fvbAutoSize =
  Automation.propertySet "AutoSize" [Automation.inInt fvbAutoSize]
getAutoSize :: Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getAutoSize =
  Automation.propertyGet "AutoSize" [] Automation.outInt
setBackStyle :: Prelude.Int -> Automation.IDispatch a -> Prelude.IO ()
setBackStyle backStyle =
  Automation.propertySet "BackStyle" [Automation.inInt backStyle]
getBackStyle :: Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getBackStyle =
  Automation.propertyGet "BackStyle" [] Automation.outInt
setFontItalic :: Prelude.Int -> Automation.IDispatch a -> Prelude.IO ()
setFontItalic fontItalic =
  Automation.propertySet "FontItalic" [Automation.inInt fontItalic]
getFontItalic :: Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getFontItalic =
  Automation.propertyGet "FontItalic" [] Automation.outInt
setFontBold :: Prelude.Int -> Automation.IDispatch a -> Prelude.IO ()
setFontBold fontBold =
  Automation.propertySet "FontBold" [Automation.inInt fontBold]
getFontBold :: Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getFontBold =
  Automation.propertyGet "FontBold" [] Automation.outInt
setFontName :: Prelude.String -> Automation.IDispatch a -> Prelude.IO ()
setFontName fontName =
  Automation.propertySet "FontName" [Automation.inString fontName]
getFontName :: Automation.IDispatch a -> Prelude.IO (Prelude.String)
getFontName =
  Automation.propertyGet "FontName" [] Automation.outString
{-
setFontSize :: Automation.Currency -> Automation.IDispatch a -> Prelude.IO ()
setFontSize fontSize =
  Automation.propertySet "FontSize" [Automation.inInt fontSize]
-}
getFontSize :: Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getFontSize =
  Automation.propertyGet "FontSize" [] Automation.outInt
setFontStrikethru :: Prelude.Int -> Automation.IDispatch a -> Prelude.IO ()
setFontStrikethru fontStrikethru =
  Automation.propertySet "FontStrikethru" [Automation.inInt fontStrikethru]
getFontStrikethru :: Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getFontStrikethru =
  Automation.propertyGet "FontStrikethru" [] Automation.outInt
setFontUnderline :: Prelude.Int -> Automation.IDispatch a -> Prelude.IO ()
setFontUnderline fontUnderline =
  Automation.propertySet "FontUnderline" [Automation.inInt fontUnderline]
getFontUnderline :: Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getFontUnderline =
  Automation.propertyGet "FontUnderline" [] Automation.outInt
setPicturePosition :: Prelude.Int -> Automation.IDispatch a -> Prelude.IO ()
setPicturePosition picPos =
  Automation.propertySet "PicturePosition" [Automation.inInt picPos]
getPicturePosition :: Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getPicturePosition =
  Automation.propertyGet "PicturePosition" [] Automation.outInt
setTextAlign :: Prelude.Int -> Automation.IDispatch a -> Prelude.IO ()
setTextAlign textAlign =
  Automation.propertySet "TextAlign" [Automation.inInt textAlign]
getTextAlign :: Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getTextAlign =
  Automation.propertyGet "TextAlign" [] Automation.outInt
setWordWrap :: Prelude.Int -> Automation.IDispatch a -> Prelude.IO ()
setWordWrap wordWrap =
  Automation.propertySet "WordWrap" [Automation.inInt wordWrap]
getWordWrap :: Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getWordWrap =
  Automation.propertyGet "WordWrap" [] Automation.outInt
setAccelerator :: Prelude.String -> Automation.IDispatch a -> Prelude.IO ()
setAccelerator accelerator =
  Automation.propertySet "Accelerator" [Automation.inString accelerator]
getAccelerator :: Automation.IDispatch a -> Prelude.IO (Prelude.String)
getAccelerator =
  Automation.propertyGet "Accelerator" [] Automation.outString
setFontWeight :: Prelude.Int -> Automation.IDispatch a -> Prelude.IO ()
setFontWeight fontWeight =
  Automation.propertySet "FontWeight" [Automation.inInt fontWeight]
getFontWeight :: Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getFontWeight =
  Automation.propertyGet "FontWeight" [] Automation.outInt
setValue4 :: Prelude.String -> ILabelControl a -> Prelude.IO ()
setValue4 bstrCaption =
  Automation.propertySet "_Value" [Automation.inString bstrCaption]
getValue4 :: ILabelControl a -> Prelude.IO (Prelude.String)
getValue4 = Automation.propertyGet "_Value" [] Automation.outString
-- --------------------------------------------------
-- 
-- interface ICommandButton
-- 
-- --------------------------------------------------
data CommandButton a = CommandButton
                        
type ICommandButton a = Automation.IDispatch (CommandButton a)
iidICommandButton :: Com.IID (ICommandButton ())
iidICommandButton =
  Com.mkIID "{04598FC4-866C-11CF-AB7C-00AA00C08FCF}"
setTakeFocusOnClick :: Prelude.Int -> ICommandButton a -> Prelude.IO ()
setTakeFocusOnClick takeFocusOnClick =
  Automation.propertySet "TakeFocusOnClick" [Automation.inInt takeFocusOnClick]
getTakeFocusOnClick :: ICommandButton a -> Prelude.IO (Prelude.Int)
getTakeFocusOnClick =
  Automation.propertyGet "TakeFocusOnClick" [] Automation.outInt
setLocked :: Prelude.Int -> Automation.IDispatch a -> Prelude.IO ()
setLocked fLocked =
  Automation.propertySet "Locked" [Automation.inInt fLocked]
getLocked :: Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getLocked = Automation.propertyGet "Locked" [] Automation.outInt
type PIROWSET = Stdole2.IUnknown ()
-- --------------------------------------------------
-- 
-- interface IMdcText
-- 
-- --------------------------------------------------
data MdcText a = MdcText
                  
type IMdcText a = Automation.IDispatch (MdcText a)
iidIMdcText :: Com.IID (IMdcText ())
iidIMdcText = Com.mkIID "{8BD21D13-EC42-11CE-9E0D-00AA006002F3}"
setAutoTab :: Prelude.Int -> Automation.IDispatch a -> Prelude.IO ()
setAutoTab autoTab =
  Automation.propertySet "AutoTab" [Automation.inInt autoTab]
getAutoTab :: Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getAutoTab = Automation.propertyGet "AutoTab" [] Automation.outInt
setAutoWordSelect :: Prelude.Int -> Automation.IDispatch a -> Prelude.IO ()
setAutoWordSelect autoWordSelect =
  Automation.propertySet "AutoWordSelect" [Automation.inInt autoWordSelect]
getAutoWordSelect :: Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getAutoWordSelect =
  Automation.propertyGet "AutoWordSelect" [] Automation.outInt
setBordersSuppress :: Prelude.Int -> Automation.IDispatch a -> Prelude.IO ()
setBordersSuppress bordersSuppress =
  Automation.propertySet "BordersSuppress" [Automation.inInt bordersSuppress]
getBordersSuppress :: Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getBordersSuppress =
  Automation.propertyGet "BordersSuppress" [] Automation.outInt
setCurLine :: Prelude.Int -> IMdcText a -> Prelude.IO ()
setCurLine curLine =
  Automation.propertySet "CurLine" [Automation.inInt curLine]
getCurLine :: IMdcText a -> Prelude.IO (Prelude.Int)
getCurLine = Automation.propertyGet "CurLine" [] Automation.outInt
getCurTargetX :: Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getCurTargetX =
  Automation.propertyGet "CurTargetX" [] Automation.outInt
getCurTargetY :: Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getCurTargetY =
  Automation.propertyGet "CurTargetY" [] Automation.outInt
setCurX :: Prelude.Int -> Automation.IDispatch a -> Prelude.IO ()
setCurX curX =
  Automation.propertySet "CurX" [Automation.inInt curX]
getCurX :: Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getCurX = Automation.propertyGet "CurX" [] Automation.outInt
setCurY :: Prelude.Int -> IMdcText a -> Prelude.IO ()
setCurY curY =
  Automation.propertySet "CurY" [Automation.inInt curY]
getCurY :: IMdcText a -> Prelude.IO (Prelude.Int)
getCurY = Automation.propertyGet "CurY" [] Automation.outInt
setDropButtonStyle :: Prelude.Int -> Automation.IDispatch a -> Prelude.IO ()
setDropButtonStyle dropButtonStyle =
  Automation.propertySet "DropButtonStyle" [Automation.inInt dropButtonStyle]
getDropButtonStyle :: Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getDropButtonStyle =
  Automation.propertyGet "DropButtonStyle" [] Automation.outInt
setEnterKeyBehavior :: Prelude.Int -> IMdcText a -> Prelude.IO ()
setEnterKeyBehavior enterKeyBehavior =
  Automation.propertySet "EnterKeyBehavior" [Automation.inInt enterKeyBehavior]
getEnterKeyBehavior :: IMdcText a -> Prelude.IO (Prelude.Int)
getEnterKeyBehavior =
  Automation.propertyGet "EnterKeyBehavior" [] Automation.outInt
setHideSelection :: Prelude.Int -> Automation.IDispatch a -> Prelude.IO ()
setHideSelection hideSelection =
  Automation.propertySet "HideSelection" [Automation.inInt hideSelection]
getHideSelection :: Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getHideSelection =
  Automation.propertyGet "HideSelection" [] Automation.outInt
setIntegralHeight :: Prelude.Int -> Automation.IDispatch a -> Prelude.IO ()
setIntegralHeight integralHeight =
  Automation.propertySet "IntegralHeight" [Automation.inInt integralHeight]
getIntegralHeight :: Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getIntegralHeight =
  Automation.propertyGet "IntegralHeight" [] Automation.outInt
getLineCount :: Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getLineCount =
  Automation.propertyGet "LineCount" [] Automation.outInt
setMaxLength :: Prelude.Int -> Automation.IDispatch a -> Prelude.IO ()
setMaxLength maxLength =
  Automation.propertySet "MaxLength" [Automation.inInt maxLength]
getMaxLength :: Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getMaxLength =
  Automation.propertyGet "MaxLength" [] Automation.outInt
setMultiLine :: Prelude.Int -> IMdcText a -> Prelude.IO ()
setMultiLine multiLine =
  Automation.propertySet "MultiLine" [Automation.inInt multiLine]
getMultiLine :: IMdcText a -> Prelude.IO (Prelude.Int)
getMultiLine =
  Automation.propertyGet "MultiLine" [] Automation.outInt
setPasswordChar :: Prelude.String -> IMdcText a -> Prelude.IO ()
setPasswordChar passwordChar =
  Automation.propertySet "PasswordChar" [Automation.inString passwordChar]
getPasswordChar :: IMdcText a -> Prelude.IO (Prelude.String)
getPasswordChar =
  Automation.propertyGet "PasswordChar" [] Automation.outString
setSelectionMargin :: Prelude.Int -> Automation.IDispatch a -> Prelude.IO ()
setSelectionMargin selectionMargin =
  Automation.propertySet "SelectionMargin" [Automation.inInt selectionMargin]
getSelectionMargin :: Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getSelectionMargin =
  Automation.propertyGet "SelectionMargin" [] Automation.outInt
setSelLength :: Prelude.Int -> Automation.IDispatch a -> Prelude.IO ()
setSelLength selLength =
  Automation.propertySet "SelLength" [Automation.inInt selLength]
getSelLength :: Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getSelLength =
  Automation.propertyGet "SelLength" [] Automation.outInt
setSelStart :: Prelude.Int -> Automation.IDispatch a -> Prelude.IO ()
setSelStart selStart =
  Automation.propertySet "SelStart" [Automation.inInt selStart]
getSelStart :: Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getSelStart =
  Automation.propertyGet "SelStart" [] Automation.outInt
setSelText :: Prelude.String -> Automation.IDispatch a -> Prelude.IO ()
setSelText selText =
  Automation.propertySet "SelText" [Automation.inString selText]
getSelText :: Automation.IDispatch a -> Prelude.IO (Prelude.String)
getSelText =
  Automation.propertyGet "SelText" [] Automation.outString
setShowDropButtonWhen :: Prelude.Int -> Automation.IDispatch a -> Prelude.IO ()
setShowDropButtonWhen showDropButtonWhen =
  Automation.propertySet "ShowDropButtonWhen" [Automation.inInt showDropButtonWhen]
getShowDropButtonWhen :: Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getShowDropButtonWhen =
  Automation.propertyGet "ShowDropButtonWhen" [] Automation.outInt
setTabKeyBehavior :: Prelude.Int -> IMdcText a -> Prelude.IO ()
setTabKeyBehavior tabKeyBehavior =
  Automation.propertySet "TabKeyBehavior" [Automation.inInt tabKeyBehavior]
getTabKeyBehavior :: IMdcText a -> Prelude.IO (Prelude.Int)
getTabKeyBehavior =
  Automation.propertyGet "TabKeyBehavior" [] Automation.outInt
setText0 :: Prelude.String -> Automation.IDispatch a -> Prelude.IO ()
setText0 text =
  Automation.propertySet "Text" [Automation.inString text]
getText0 :: Automation.IDispatch a -> Prelude.IO (Prelude.String)
getText0 = Automation.propertyGet "Text" [] Automation.outString
getTextLength :: Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getTextLength =
  Automation.propertyGet "TextLength" [] Automation.outInt
getValid :: Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getValid = Automation.propertyGet "Valid" [] Automation.outInt
setValue6 :: (Automation.Variant a0) => a0 -> Automation.IDispatch a -> Prelude.IO ()
setValue6 value =
  Automation.propertySet "Value" [Automation.inVariant value]
getValue6 :: (Automation.Variant a0) => Automation.IDispatch a -> Prelude.IO (a0)
getValue6 = Automation.propertyGet "Value" [] Automation.outVariant
setIMEMode :: Prelude.Int -> Automation.IDispatch a -> Prelude.IO ()
setIMEMode iMEMode =
  Automation.propertySet "IMEMode" [Automation.inInt iMEMode]
getIMEMode :: Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getIMEMode = Automation.propertyGet "IMEMode" [] Automation.outInt
setEnterFieldBehavior :: Prelude.Int -> Automation.IDispatch a -> Prelude.IO ()
setEnterFieldBehavior enterFieldBehavior =
  Automation.propertySet "EnterFieldBehavior" [Automation.inInt enterFieldBehavior]
getEnterFieldBehavior :: Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getEnterFieldBehavior =
  Automation.propertyGet "EnterFieldBehavior" [] Automation.outInt
setDragBehavior :: Prelude.Int -> Automation.IDispatch a -> Prelude.IO ()
setDragBehavior dragBehavior =
  Automation.propertySet "DragBehavior" [Automation.inInt dragBehavior]
getDragBehavior :: Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getDragBehavior =
  Automation.propertyGet "DragBehavior" [] Automation.outInt
getDisplayStyle :: Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getDisplayStyle =
  Automation.propertyGet "DisplayStyle" [] Automation.outInt
-- --------------------------------------------------
-- 
-- interface IMdcList
-- 
-- --------------------------------------------------
data MdcList a = MdcList
                  
type IMdcList a = Automation.IDispatch (MdcList a)
iidIMdcList :: Com.IID (IMdcList ())
iidIMdcList = Com.mkIID "{8BD21D23-EC42-11CE-9E0D-00AA006002F3}"
setBoundColumn :: (Automation.Variant a0) => a0 -> Automation.IDispatch a -> Prelude.IO ()
setBoundColumn boundColumn =
  Automation.propertySet "BoundColumn" [Automation.inVariant boundColumn]
getBoundColumn :: (Automation.Variant a0) => Automation.IDispatch a -> Prelude.IO (a0)
getBoundColumn =
  Automation.propertyGet "BoundColumn" [] Automation.outVariant
setColumnCount :: Prelude.Int -> Automation.IDispatch a -> Prelude.IO ()
setColumnCount columnCount =
  Automation.propertySet "ColumnCount" [Automation.inInt columnCount]
getColumnCount :: Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getColumnCount =
  Automation.propertyGet "ColumnCount" [] Automation.outInt
setColumnHeads :: Prelude.Int -> Automation.IDispatch a -> Prelude.IO ()
setColumnHeads columnHeads =
  Automation.propertySet "ColumnHeads" [Automation.inInt columnHeads]
getColumnHeads :: Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getColumnHeads =
  Automation.propertyGet "ColumnHeads" [] Automation.outInt
setColumnWidths :: Prelude.String -> Automation.IDispatch a -> Prelude.IO ()
setColumnWidths columnWidths =
  Automation.propertySet "ColumnWidths" [Automation.inString columnWidths]
getColumnWidths :: Automation.IDispatch a -> Prelude.IO (Prelude.String)
getColumnWidths =
  Automation.propertyGet "ColumnWidths" [] Automation.outString
getListCount :: Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getListCount =
  Automation.propertyGet "ListCount" [] Automation.outInt
setListCursor :: Com.IUnknown b -> Automation.IDispatch a -> Prelude.IO ()
setListCursor listCursor =
  Automation.propertySet "ListCursor" [Automation.inIUnknown listCursor]
getListCursor :: Automation.IDispatch a -> Prelude.IO (Com.IUnknown ())
getListCursor =
  Automation.propertyGet "ListCursor" [] Automation.outIUnknown
setListIndex :: (Automation.Variant a0) => a0 -> Automation.IDispatch a -> Prelude.IO ()
setListIndex listIndex =
  Automation.propertySet "ListIndex" [Automation.inVariant listIndex]
getListIndex :: (Automation.Variant a0) => Automation.IDispatch a -> Prelude.IO (a0)
getListIndex =
  Automation.propertyGet "ListIndex" [] Automation.outVariant
setListStyle :: Prelude.Int -> Automation.IDispatch a -> Prelude.IO ()
setListStyle listStyle =
  Automation.propertySet "ListStyle" [Automation.inInt listStyle]
getListStyle :: Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getListStyle =
  Automation.propertyGet "ListStyle" [] Automation.outInt
setListWidth :: (Automation.Variant a0) => a0 -> Automation.IDispatch a -> Prelude.IO ()
setListWidth listWidth =
  Automation.propertySet "ListWidth" [Automation.inVariant listWidth]
getListWidth :: (Automation.Variant a0) => Automation.IDispatch a -> Prelude.IO (a0)
getListWidth =
  Automation.propertyGet "ListWidth" [] Automation.outVariant
setMatchEntry :: Prelude.Int -> Automation.IDispatch a -> Prelude.IO ()
setMatchEntry matchEntry =
  Automation.propertySet "MatchEntry" [Automation.inInt matchEntry]
getMatchEntry :: Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getMatchEntry =
  Automation.propertyGet "MatchEntry" [] Automation.outInt
setMultiSelect :: Prelude.Int -> Automation.IDispatch a -> Prelude.IO ()
setMultiSelect multiSelect =
  Automation.propertySet "MultiSelect" [Automation.inInt multiSelect]
getMultiSelect :: Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getMultiSelect =
  Automation.propertyGet "MultiSelect" [] Automation.outInt
setTextColumn :: (Automation.Variant a0) => a0 -> Automation.IDispatch a -> Prelude.IO ()
setTextColumn textColumn =
  Automation.propertySet "TextColumn" [Automation.inVariant textColumn]
getTextColumn :: (Automation.Variant a0) => Automation.IDispatch a -> Prelude.IO (a0)
getTextColumn =
  Automation.propertyGet "TextColumn" [] Automation.outVariant
setTopIndex :: (Automation.Variant a0) => a0 -> Automation.IDispatch a -> Prelude.IO ()
setTopIndex topIndex =
  Automation.propertySet "TopIndex" [Automation.inVariant topIndex]
getTopIndex :: (Automation.Variant a0) => Automation.IDispatch a -> Prelude.IO (a0)
getTopIndex =
  Automation.propertyGet "TopIndex" [] Automation.outVariant
getColumn :: (Automation.Variant a0, Automation.Variant a1, Automation.Variant a2) => a0 -> a1 -> Automation.IDispatch a -> Prelude.IO (a2)
getColumn pvargColumn pvargIndex =
  Automation.propertyGet "Column" [Automation.inVariant pvargColumn, Automation.inVariant pvargIndex] Automation.outVariant
setColumn :: (Automation.Variant a0, Automation.Variant a1, Automation.Variant a2) => a0 -> a1 -> a2 -> Automation.IDispatch a -> Prelude.IO ()
setColumn pvargColumn pvargIndex pvargValue =
  Automation.propertySet "Column" [Automation.inVariant pvargColumn, Automation.inVariant pvargIndex, Automation.inVariant pvargValue]
getList :: (Automation.Variant a0, Automation.Variant a1, Automation.Variant a2) => a0 -> a1 -> Automation.IDispatch a -> Prelude.IO (a2)
getList pvargIndex pvargColumn =
  Automation.propertyGet "List" [Automation.inVariant pvargIndex, Automation.inVariant pvargColumn] Automation.outVariant
setList :: (Automation.Variant a0, Automation.Variant a1, Automation.Variant a2) => a0 -> a1 -> a2 -> Automation.IDispatch a -> Prelude.IO ()
setList pvargIndex pvargColumn pvargValue =
  Automation.propertySet "List" [Automation.inVariant pvargIndex, Automation.inVariant pvargColumn, Automation.inVariant pvargValue]
getSelected1 :: (Automation.Variant a0) => a0 -> IMdcList a -> Prelude.IO (Prelude.Int)
getSelected1 pvargIndex =
  Automation.propertyGet "Selected" [Automation.inVariant pvargIndex] Automation.outInt
setSelected :: (Automation.Variant a0) => a0 -> Prelude.Int -> IMdcList a -> Prelude.IO ()
setSelected pvargIndex pfvb =
  Automation.propertySet "Selected" [Automation.inVariant pvargIndex, Automation.inInt pfvb]
addItem :: (Automation.Variant a0, Automation.Variant a1) => a0 -> a1 -> Automation.IDispatch a -> Prelude.IO ()
addItem pvargItem pvargIndex =
  Automation.method0 "AddItem" [Automation.inVariant pvargItem, Automation.inVariant pvargIndex]
removeItem :: (Automation.Variant a0) => a0 -> Automation.IDispatch a -> Prelude.IO ()
removeItem pvargIndex =
  Automation.method0 "RemoveItem" [Automation.inVariant pvargIndex]
-- --------------------------------------------------
-- 
-- interface IMdcCombo
-- 
-- --------------------------------------------------
data MdcCombo a = MdcCombo
                   
type IMdcCombo a = Automation.IDispatch (MdcCombo a)
iidIMdcCombo :: Com.IID (IMdcCombo ())
iidIMdcCombo = Com.mkIID "{8BD21D33-EC42-11CE-9E0D-00AA006002F3}"
setListRows :: Prelude.Int -> IMdcCombo a -> Prelude.IO ()
setListRows listRows =
  Automation.propertySet "ListRows" [Automation.inInt listRows]
getListRows :: IMdcCombo a -> Prelude.IO (Prelude.Int)
getListRows =
  Automation.propertyGet "ListRows" [] Automation.outInt
getMatchFound :: IMdcCombo a -> Prelude.IO (Prelude.Int)
getMatchFound =
  Automation.propertyGet "MatchFound" [] Automation.outInt
setMatchRequired :: Prelude.Int -> IMdcCombo a -> Prelude.IO ()
setMatchRequired matchRequired =
  Automation.propertySet "MatchRequired" [Automation.inInt matchRequired]
getMatchRequired :: IMdcCombo a -> Prelude.IO (Prelude.Int)
getMatchRequired =
  Automation.propertyGet "MatchRequired" [] Automation.outInt
setStyle :: Prelude.Int -> IMdcCombo a -> Prelude.IO ()
setStyle style =
  Automation.propertySet "Style" [Automation.inInt style]
getStyle :: IMdcCombo a -> Prelude.IO (Prelude.Int)
getStyle = Automation.propertyGet "Style" [] Automation.outInt
dropDown :: IMdcCombo a -> Prelude.IO ()
dropDown = Automation.method0 "DropDown" []
-- --------------------------------------------------
-- 
-- interface IMdcCheckBox
-- 
-- --------------------------------------------------
data MdcCheckBox a = MdcCheckBox
                      
type IMdcCheckBox a = Automation.IDispatch (MdcCheckBox a)
iidIMdcCheckBox :: Com.IID (IMdcCheckBox ())
iidIMdcCheckBox =
  Com.mkIID "{8BD21D43-EC42-11CE-9E0D-00AA006002F3}"
setAlignment :: Prelude.Int -> Automation.IDispatch a -> Prelude.IO ()
setAlignment alignment =
  Automation.propertySet "Alignment" [Automation.inInt alignment]
getAlignment :: Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getAlignment =
  Automation.propertyGet "Alignment" [] Automation.outInt
setSpecialEffect5 :: Prelude.Int -> Automation.IDispatch a -> Prelude.IO ()
setSpecialEffect5 specialEffect =
  Automation.propertySet "SpecialEffect" [Automation.inInt specialEffect]
getSpecialEffect5 :: Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getSpecialEffect5 =
  Automation.propertyGet "SpecialEffect" [] Automation.outInt
setTripleState :: Prelude.Int -> Automation.IDispatch a -> Prelude.IO ()
setTripleState tripleState =
  Automation.propertySet "TripleState" [Automation.inInt tripleState]
getTripleState :: Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getTripleState =
  Automation.propertyGet "TripleState" [] Automation.outInt
setGroupName :: Prelude.String -> Automation.IDispatch a -> Prelude.IO ()
setGroupName groupName =
  Automation.propertySet "GroupName" [Automation.inString groupName]
getGroupName :: Automation.IDispatch a -> Prelude.IO (Prelude.String)
getGroupName =
  Automation.propertyGet "GroupName" [] Automation.outString
-- --------------------------------------------------
-- 
-- interface IMdcOptionButton
-- 
-- --------------------------------------------------
data MdcOptionButton a = MdcOptionButton
                          
type IMdcOptionButton a = IMdcCheckBox (MdcOptionButton a)
iidIMdcOptionButton :: Com.IID (IMdcOptionButton ())
iidIMdcOptionButton =
  Com.mkIID "{8BD21D53-EC42-11CE-9E0D-00AA006002F3}"
-- --------------------------------------------------
-- 
-- interface IMdcToggleButton
-- 
-- --------------------------------------------------
data MdcToggleButton a = MdcToggleButton
                          
type IMdcToggleButton a = IMdcCheckBox (MdcToggleButton a)
iidIMdcToggleButton :: Com.IID (IMdcToggleButton ())
iidIMdcToggleButton =
  Com.mkIID "{8BD21D63-EC42-11CE-9E0D-00AA006002F3}"
-- --------------------------------------------------
-- 
-- interface IScrollbar
-- 
-- --------------------------------------------------
data Scrollbar a = Scrollbar
                    
type IScrollbar a = Automation.IDispatch (Scrollbar a)
iidIScrollbar :: Com.IID (IScrollbar ())
iidIScrollbar = Com.mkIID "{04598FC3-866C-11CF-AB7C-00AA00C08FCF}"
setMin :: Prelude.Int -> Automation.IDispatch a -> Prelude.IO ()
setMin min = Automation.propertySet "Min" [Automation.inInt min]
getMin :: Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getMin = Automation.propertyGet "Min" [] Automation.outInt
setMax :: Prelude.Int -> Automation.IDispatch a -> Prelude.IO ()
setMax max = Automation.propertySet "Max" [Automation.inInt max]
getMax :: Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getMax = Automation.propertyGet "Max" [] Automation.outInt
setSmallChange :: Prelude.Int -> Automation.IDispatch a -> Prelude.IO ()
setSmallChange smallChange =
  Automation.propertySet "SmallChange" [Automation.inInt smallChange]
getSmallChange :: Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getSmallChange =
  Automation.propertyGet "SmallChange" [] Automation.outInt
setLargeChange :: Prelude.Int -> IScrollbar a -> Prelude.IO ()
setLargeChange largeChange =
  Automation.propertySet "LargeChange" [Automation.inInt largeChange]
getLargeChange :: IScrollbar a -> Prelude.IO (Prelude.Int)
getLargeChange =
  Automation.propertyGet "LargeChange" [] Automation.outInt
setProportionalThumb :: Prelude.Int -> IScrollbar a -> Prelude.IO ()
setProportionalThumb proportionalThumb =
  Automation.propertySet "ProportionalThumb" [Automation.inInt proportionalThumb]
getProportionalThumb :: IScrollbar a -> Prelude.IO (Prelude.Int)
getProportionalThumb =
  Automation.propertyGet "ProportionalThumb" [] Automation.outInt
setOrientation :: Prelude.Int -> Automation.IDispatch a -> Prelude.IO ()
setOrientation orientation =
  Automation.propertySet "Orientation" [Automation.inInt orientation]
getOrientation :: Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getOrientation =
  Automation.propertyGet "Orientation" [] Automation.outInt
setDelay :: Prelude.Int -> Automation.IDispatch a -> Prelude.IO ()
setDelay delay =
  Automation.propertySet "Delay" [Automation.inInt delay]
getDelay :: Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getDelay = Automation.propertyGet "Delay" [] Automation.outInt
-- --------------------------------------------------
-- 
-- interface Tab
-- 
-- --------------------------------------------------
data Tab a = Tab
              
type ITab a = Automation.IDispatch (Tab a)
iidITab :: Com.IID (ITab ())
iidITab = Com.mkIID "{A38BFFC3-A5A0-11CE-8107-00AA00611080}"
setIndex :: Prelude.Int -> Automation.IDispatch a -> Prelude.IO ()
setIndex index =
  Automation.propertySet "Index" [Automation.inInt index]
getIndex :: Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getIndex = Automation.propertyGet "Index" [] Automation.outInt
-- --------------------------------------------------
-- 
-- interface Tabs
-- 
-- --------------------------------------------------
data Tabs a = Tabs
               
type ITabs a = Automation.IDispatch (Tabs a)
iidITabs :: Com.IID (ITabs ())
iidITabs = Com.mkIID "{944ACF93-A1E6-11CE-8104-00AA00611080}"
getItemByIndex0 :: Prelude.Int -> ITabs a -> Prelude.IO (Automation.IDispatch ())
getItemByIndex0 lIndex =
  Automation.function1 "_GetItemByIndex" [Automation.inInt lIndex] Automation.outIDispatch
getItemByName0 :: Prelude.String -> ITabs a -> Prelude.IO (Automation.IDispatch ())
getItemByName0 bstr =
  Automation.function1 "_GetItemByName" [Automation.inString bstr] Automation.outIDispatch
add0 :: (Automation.Variant a0, Automation.Variant a1, Automation.Variant a2) => a0 -> a1 -> a2 -> ITabs a -> Prelude.IO (Automation.IDispatch ())
add0 bstrName bstrCaption lIndex =
  Automation.function1 "Add" [Automation.inVariant bstrName, Automation.inVariant bstrCaption, Automation.inVariant lIndex] Automation.outIDispatch
add1 :: Prelude.String -> Prelude.String -> ITabs a -> Prelude.IO (Automation.IDispatch ())
add1 bstrName bstrCaption =
  Automation.function1 "_Add" [Automation.inString bstrName, Automation.inString bstrCaption] Automation.outIDispatch
insert :: Prelude.String -> Prelude.String -> Prelude.Int -> ITabs a -> Prelude.IO (Automation.IDispatch ())
insert bstrName bstrCaption lIndex =
  Automation.function1 "_Insert" [Automation.inString bstrName, Automation.inString bstrCaption, Automation.inInt lIndex] Automation.outIDispatch
-- --------------------------------------------------
-- 
-- interface ITabStrip
-- 
-- --------------------------------------------------
data TabStrip a = TabStrip
                   
type ITabStrip a = Automation.IDispatch (TabStrip a)
iidITabStrip :: Com.IID (ITabStrip ())
iidITabStrip = Com.mkIID "{04598FC2-866C-11CF-AB7C-00AA00C08FCF}"
setMultiRow :: Prelude.Int -> Automation.IDispatch a -> Prelude.IO ()
setMultiRow multiRow =
  Automation.propertySet "MultiRow" [Automation.inInt multiRow]
getMultiRow :: Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getMultiRow =
  Automation.propertyGet "MultiRow" [] Automation.outInt
setStyle0 :: Prelude.Int -> Automation.IDispatch a -> Prelude.IO ()
setStyle0 tabStyle =
  Automation.propertySet "Style" [Automation.inInt tabStyle]
getStyle0 :: Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getStyle0 = Automation.propertyGet "Style" [] Automation.outInt
setTabOrientation :: Prelude.Int -> Automation.IDispatch a -> Prelude.IO ()
setTabOrientation tabOrientation =
  Automation.propertySet "TabOrientation" [Automation.inInt tabOrientation]
getTabOrientation :: Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getTabOrientation =
  Automation.propertyGet "TabOrientation" [] Automation.outInt
setTabFixedWidth :: Prelude.Int -> Automation.IDispatch a -> Prelude.IO ()
setTabFixedWidth tabFixedWidth =
  Automation.method0 "_SetTabFixedWidth" [Automation.inInt tabFixedWidth]
getTabFixedWidth :: Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getTabFixedWidth =
  Automation.method1 "_GetTabFixedWidth" [] Automation.outInt
setTabFixedHeight :: Prelude.Int -> Automation.IDispatch a -> Prelude.IO ()
setTabFixedHeight tabFixedHeight =
  Automation.method0 "_SetTabFixedHeight" [Automation.inInt tabFixedHeight]
getTabFixedHeight :: Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getTabFixedHeight =
  Automation.method1 "_GetTabFixedHeight" [] Automation.outInt
getClientTop :: ITabStrip a -> Prelude.IO (Prelude.Int)
getClientTop =
  Automation.method1 "_GetClientTop" [] Automation.outInt
getClientTop0 :: ITabStrip a -> Prelude.IO (Prelude.Float)
getClientTop0 =
  Automation.propertyGet "ClientTop" [] Automation.outFloat
getClientLeft :: ITabStrip a -> Prelude.IO (Prelude.Int)
getClientLeft =
  Automation.method1 "_GetClientLeft" [] Automation.outInt
getClientLeft0 :: ITabStrip a -> Prelude.IO (Prelude.Float)
getClientLeft0 =
  Automation.propertyGet "ClientLeft" [] Automation.outFloat
getClientWidth :: ITabStrip a -> Prelude.IO (Prelude.Int)
getClientWidth =
  Automation.method1 "_GetClientWidth" [] Automation.outInt
getClientWidth0 :: ITabStrip a -> Prelude.IO (Prelude.Float)
getClientWidth0 =
  Automation.propertyGet "ClientWidth" [] Automation.outFloat
getClientHeight :: ITabStrip a -> Prelude.IO (Prelude.Int)
getClientHeight =
  Automation.method1 "_GetClientHeight" [] Automation.outInt
getClientHeight0 :: ITabStrip a -> Prelude.IO (Prelude.Float)
getClientHeight0 =
  Automation.propertyGet "ClientHeight" [] Automation.outFloat
getTabs :: ITabStrip a -> Prelude.IO (Automation.IDispatch ())
getTabs = Automation.propertyGet "Tabs" [] Automation.outIDispatch
getSelectedItem :: ITabStrip a -> Prelude.IO (Automation.IDispatch ())
getSelectedItem =
  Automation.propertyGet "SelectedItem" [] Automation.outIDispatch
setTabFixedWidth0 :: Prelude.Float -> Automation.IDispatch a -> Prelude.IO ()
setTabFixedWidth0 tabFixedWidth =
  Automation.propertySet "TabFixedWidth" [Automation.inFloat tabFixedWidth]
getTabFixedWidth0 :: Automation.IDispatch a -> Prelude.IO (Prelude.Float)
getTabFixedWidth0 =
  Automation.propertyGet "TabFixedWidth" [] Automation.outFloat
setTabFixedHeight0 :: Prelude.Float -> Automation.IDispatch a -> Prelude.IO ()
setTabFixedHeight0 tabFixedHeight =
  Automation.propertySet "TabFixedHeight" [Automation.inFloat tabFixedHeight]
getTabFixedHeight0 :: Automation.IDispatch a -> Prelude.IO (Prelude.Float)
getTabFixedHeight0 =
  Automation.propertyGet "TabFixedHeight" [] Automation.outFloat
-- --------------------------------------------------
-- 
-- interface ISpinbutton
-- 
-- --------------------------------------------------
data Spinbutton a = Spinbutton
                     
type ISpinbutton a = Automation.IDispatch (Spinbutton a)
iidISpinbutton :: Com.IID (ISpinbutton ())
iidISpinbutton = Com.mkIID "{79176FB3-B7F2-11CE-97EF-00AA006D2776}"
-- --------------------------------------------------
-- 
-- interface IImage
-- 
-- --------------------------------------------------
data Image a = Image
                
type IImage a = Automation.IDispatch (Image a)
iidIImage :: Com.IID (IImage ())
iidIImage = Com.mkIID "{4C599243-6926-101B-9992-00000B65C6F9}"
-- --------------------------------------------------
-- 
-- interface IWHTMLSubmitButton
-- 
-- --------------------------------------------------
data WHTMLSubmitButton a = WHTMLSubmitButton
                            
type IWHTMLSubmitButton a = Automation.IDispatch (WHTMLSubmitButton a)
iidIWHTMLSubmitButton :: Com.IID (IWHTMLSubmitButton ())
iidIWHTMLSubmitButton =
  Com.mkIID "{5512D111-5CC6-11CF-8D67-00AA00BDCE1D}"
setAction :: Prelude.String -> Automation.IDispatch a -> Prelude.IO ()
setAction action =
  Automation.propertySet "Action" [Automation.inString action]
getAction :: Automation.IDispatch a -> Prelude.IO (Prelude.String)
getAction = Automation.propertyGet "Action" [] Automation.outString
setEncoding :: Prelude.String -> Automation.IDispatch a -> Prelude.IO ()
setEncoding encoding =
  Automation.propertySet "Encoding" [Automation.inString encoding]
getEncoding :: Automation.IDispatch a -> Prelude.IO (Prelude.String)
getEncoding =
  Automation.propertyGet "Encoding" [] Automation.outString
setMethod :: Prelude.String -> Automation.IDispatch a -> Prelude.IO ()
setMethod method =
  Automation.propertySet "Method" [Automation.inString method]
getMethod :: Automation.IDispatch a -> Prelude.IO (Prelude.String)
getMethod = Automation.propertyGet "Method" [] Automation.outString
setHTMLName :: Prelude.String -> Automation.IDispatch a -> Prelude.IO ()
setHTMLName hTMLName =
  Automation.propertySet "HTMLName" [Automation.inString hTMLName]
getHTMLName :: Automation.IDispatch a -> Prelude.IO (Prelude.String)
getHTMLName =
  Automation.propertyGet "HTMLName" [] Automation.outString
setHTMLType :: Prelude.String -> Automation.IDispatch a -> Prelude.IO ()
setHTMLType hTMLType =
  Automation.propertySet "HTMLType" [Automation.inString hTMLType]
getHTMLType :: Automation.IDispatch a -> Prelude.IO (Prelude.String)
getHTMLType =
  Automation.propertyGet "HTMLType" [] Automation.outString
-- --------------------------------------------------
-- 
-- interface IWHTMLImage
-- 
-- --------------------------------------------------
data WHTMLImage a = WHTMLImage
                     
type IWHTMLImage a = Automation.IDispatch (WHTMLImage a)
iidIWHTMLImage :: Com.IID (IWHTMLImage ())
iidIWHTMLImage = Com.mkIID "{5512D113-5CC6-11CF-8D67-00AA00BDCE1D}"
setSource :: Prelude.String -> IWHTMLImage a -> Prelude.IO ()
setSource source =
  Automation.propertySet "Source" [Automation.inString source]
getSource :: IWHTMLImage a -> Prelude.IO (Prelude.String)
getSource = Automation.propertyGet "Source" [] Automation.outString
-- --------------------------------------------------
-- 
-- interface IWHTMLReset
-- 
-- --------------------------------------------------
data WHTMLReset a = WHTMLReset
                     
type IWHTMLReset a = Automation.IDispatch (WHTMLReset a)
iidIWHTMLReset :: Com.IID (IWHTMLReset ())
iidIWHTMLReset = Com.mkIID "{5512D115-5CC6-11CF-8D67-00AA00BDCE1D}"
-- --------------------------------------------------
-- 
-- interface IWHTMLCheckbox
-- 
-- --------------------------------------------------
data WHTMLCheckbox a = WHTMLCheckbox
                        
type IWHTMLCheckbox a = Automation.IDispatch (WHTMLCheckbox a)
iidIWHTMLCheckbox :: Com.IID (IWHTMLCheckbox ())
iidIWHTMLCheckbox =
  Com.mkIID "{5512D117-5CC6-11CF-8D67-00AA00BDCE1D}"
setChecked :: Prelude.Int -> Automation.IDispatch a -> Prelude.IO ()
setChecked checked =
  Automation.propertySet "Checked" [Automation.inInt checked]
getChecked :: Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getChecked = Automation.propertyGet "Checked" [] Automation.outInt
-- --------------------------------------------------
-- 
-- interface IWHTMLOption
-- 
-- --------------------------------------------------
data WHTMLOption a = WHTMLOption
                      
type IWHTMLOption a = Automation.IDispatch (WHTMLOption a)
iidIWHTMLOption :: Com.IID (IWHTMLOption ())
iidIWHTMLOption =
  Com.mkIID "{5512D119-5CC6-11CF-8D67-00AA00BDCE1D}"
-- --------------------------------------------------
-- 
-- interface IWHTMLText
-- 
-- --------------------------------------------------
data WHTMLText a = WHTMLText
                    
type IWHTMLText a = Automation.IDispatch (WHTMLText a)
iidIWHTMLText :: Com.IID (IWHTMLText ())
iidIWHTMLText = Com.mkIID "{5512D11B-5CC6-11CF-8D67-00AA00BDCE1D}"
setWidth1 :: Prelude.Int -> Automation.IDispatch a -> Prelude.IO ()
setWidth1 width =
  Automation.propertySet "Width" [Automation.inInt width]
getWidth1 :: Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getWidth1 = Automation.propertyGet "Width" [] Automation.outInt
-- --------------------------------------------------
-- 
-- interface IWHTMLHidden
-- 
-- --------------------------------------------------
data WHTMLHidden a = WHTMLHidden
                      
type IWHTMLHidden a = Automation.IDispatch (WHTMLHidden a)
iidIWHTMLHidden :: Com.IID (IWHTMLHidden ())
iidIWHTMLHidden =
  Com.mkIID "{5512D11D-5CC6-11CF-8D67-00AA00BDCE1D}"
-- --------------------------------------------------
-- 
-- interface IWHTMLPassword
-- 
-- --------------------------------------------------
data WHTMLPassword a = WHTMLPassword
                        
type IWHTMLPassword a = Automation.IDispatch (WHTMLPassword a)
iidIWHTMLPassword :: Com.IID (IWHTMLPassword ())
iidIWHTMLPassword =
  Com.mkIID "{5512D11F-5CC6-11CF-8D67-00AA00BDCE1D}"
-- --------------------------------------------------
-- 
-- interface IWHTMLSelect
-- 
-- --------------------------------------------------
data WHTMLSelect a = WHTMLSelect
                      
type IWHTMLSelect a = Automation.IDispatch (WHTMLSelect a)
iidIWHTMLSelect :: Com.IID (IWHTMLSelect ())
iidIWHTMLSelect =
  Com.mkIID "{5512D123-5CC6-11CF-8D67-00AA00BDCE1D}"
setValues :: (Automation.Variant a0) => a0 -> IWHTMLSelect a -> Prelude.IO ()
setValues values =
  Automation.propertySet "Values" [Automation.inVariant values]
getValues :: (Automation.Variant a0) => IWHTMLSelect a -> Prelude.IO (a0)
getValues =
  Automation.propertyGet "Values" [] Automation.outVariant
setDisplayValues :: (Automation.Variant a0) => a0 -> IWHTMLSelect a -> Prelude.IO ()
setDisplayValues displayValues =
  Automation.propertySet "DisplayValues" [Automation.inVariant displayValues]
getDisplayValues :: (Automation.Variant a0) => IWHTMLSelect a -> Prelude.IO (a0)
getDisplayValues =
  Automation.propertyGet "DisplayValues" [] Automation.outVariant
setSelected0 :: Prelude.String -> IWHTMLSelect a -> Prelude.IO ()
setSelected0 selected =
  Automation.propertySet "Selected" [Automation.inString selected]
getSelected2 :: IWHTMLSelect a -> Prelude.IO (Prelude.String)
getSelected2 =
  Automation.propertyGet "Selected" [] Automation.outString
setMultiSelect3 :: Prelude.Int -> IWHTMLSelect a -> Prelude.IO ()
setMultiSelect3 multiSelect =
  Automation.propertySet "MultiSelect" [Automation.inInt multiSelect]
getMultiSelect3 :: IWHTMLSelect a -> Prelude.IO (Prelude.Int)
getMultiSelect3 =
  Automation.propertyGet "MultiSelect" [] Automation.outInt
setSize :: Prelude.Int -> IWHTMLSelect a -> Prelude.IO ()
setSize size =
  Automation.propertySet "Size" [Automation.inInt size]
getSize :: IWHTMLSelect a -> Prelude.IO (Prelude.Int)
getSize = Automation.propertyGet "Size" [] Automation.outInt
-- --------------------------------------------------
-- 
-- interface IWHTMLTextArea
-- 
-- --------------------------------------------------
data WHTMLTextArea a = WHTMLTextArea
                        
type IWHTMLTextArea a = Automation.IDispatch (WHTMLTextArea a)
iidIWHTMLTextArea :: Com.IID (IWHTMLTextArea ())
iidIWHTMLTextArea =
  Com.mkIID "{5512D125-5CC6-11CF-8D67-00AA00BDCE1D}"
setRows :: Prelude.Int -> IWHTMLTextArea a -> Prelude.IO ()
setRows rows =
  Automation.propertySet "Rows" [Automation.inInt rows]
getRows :: IWHTMLTextArea a -> Prelude.IO (Prelude.Int)
getRows = Automation.propertyGet "Rows" [] Automation.outInt
setColumns :: Prelude.Int -> IWHTMLTextArea a -> Prelude.IO ()
setColumns columns =
  Automation.propertySet "Columns" [Automation.inInt columns]
getColumns :: IWHTMLTextArea a -> Prelude.IO (Prelude.Int)
getColumns = Automation.propertyGet "Columns" [] Automation.outInt
setWordWrap5 :: Prelude.String -> IWHTMLTextArea a -> Prelude.IO ()
setWordWrap5 wordWrap =
  Automation.propertySet "WordWrap" [Automation.inString wordWrap]
getWordWrap5 :: IWHTMLTextArea a -> Prelude.IO (Prelude.String)
getWordWrap5 =
  Automation.propertyGet "WordWrap" [] Automation.outString
-- --------------------------------------------------
-- 
-- dispinterface LabelControlEvents
-- 
-- --------------------------------------------------
data LabelControlEvents a = LabelControlEvents
                             
type ILabelControlEvents a = Automation.IDispatch (LabelControlEvents a)
iidILabelControlEvents :: Com.IID (ILabelControlEvents ())
iidILabelControlEvents =
  Com.mkIID "{978C9E22-D4B0-11CE-BF2D-00AA003F40D0}"
beforeDragOver1 :: (Automation.Variant a0, Automation.Variant a1, Automation.Variant a2) => a0 -> a1 -> Prelude.Float -> Prelude.Float -> Prelude.Int -> a2 -> Prelude.Int -> Automation.IDispatch a -> Prelude.IO ()
beforeDragOver1 cancel data0 x y dragState effect shift =
  Automation.method0 "BeforeDragOver" [Automation.inVariant cancel, Automation.inVariant data0, Automation.inFloat x, Automation.inFloat y, Automation.inInt dragState, Automation.inVariant effect, Automation.inInt shift]
beforeDropOrPaste1 :: (Automation.Variant a0, Automation.Variant a1, Automation.Variant a2) => a0 -> Prelude.Int -> a1 -> Prelude.Float -> Prelude.Float -> a2 -> Prelude.Int -> Automation.IDispatch a -> Prelude.IO ()
beforeDropOrPaste1 cancel action data0 x y effect shift =
  Automation.method0 "BeforeDropOrPaste" [Automation.inVariant cancel, Automation.inInt action, Automation.inVariant data0, Automation.inFloat x, Automation.inFloat y, Automation.inVariant effect, Automation.inInt shift]
-- --------------------------------------------------
-- 
-- coclass Label
-- 
-- --------------------------------------------------
clsidLabel :: Com.CLSID
clsidLabel = Com.mkCLSID "{978C9E23-D4B0-11CE-BF2D-00AA003F40D0}"
-- --------------------------------------------------
-- 
-- dispinterface CommandButtonEvents
-- 
-- --------------------------------------------------
data CommandButtonEvents a = CommandButtonEvents
                              
type ICommandButtonEvents a = Automation.IDispatch (CommandButtonEvents a)
iidICommandButtonEvents :: Com.IID (ICommandButtonEvents ())
iidICommandButtonEvents =
  Com.mkIID "{7B020EC1-AF6C-11CE-9F46-00AA00574A4F}"
-- --------------------------------------------------
-- 
-- coclass CommandButton
-- 
-- --------------------------------------------------
clsidCommandButton :: Com.CLSID
clsidCommandButton =
  Com.mkCLSID "{D7053240-CE69-11CD-A777-00DD01143C57}"
-- --------------------------------------------------
-- 
-- dispinterface MdcTextEvents
-- 
-- --------------------------------------------------
data MdcTextEvents a = MdcTextEvents
                        
type IMdcTextEvents a = Automation.IDispatch (MdcTextEvents a)
iidIMdcTextEvents :: Com.IID (IMdcTextEvents ())
iidIMdcTextEvents =
  Com.mkIID "{8BD21D12-EC42-11CE-9E0D-00AA006002F3}"
change :: Automation.IDispatch a -> Prelude.IO ()
change = Automation.method0 "Change" []
dropButtonClick :: Automation.IDispatch a -> Prelude.IO ()
dropButtonClick = Automation.method0 "DropButtonClick" []
-- --------------------------------------------------
-- 
-- coclass TextBox
-- 
-- --------------------------------------------------
clsidTextBox :: Com.CLSID
clsidTextBox = Com.mkCLSID "{8BD21D10-EC42-11CE-9E0D-00AA006002F3}"
-- --------------------------------------------------
-- 
-- dispinterface MdcListEvents
-- 
-- --------------------------------------------------
data MdcListEvents a = MdcListEvents
                        
type IMdcListEvents a = Automation.IDispatch (MdcListEvents a)
iidIMdcListEvents :: Com.IID (IMdcListEvents ())
iidIMdcListEvents =
  Com.mkIID "{8BD21D22-EC42-11CE-9E0D-00AA006002F3}"
-- --------------------------------------------------
-- 
-- coclass ListBox
-- 
-- --------------------------------------------------
clsidListBox :: Com.CLSID
clsidListBox = Com.mkCLSID "{8BD21D20-EC42-11CE-9E0D-00AA006002F3}"
-- --------------------------------------------------
-- 
-- dispinterface MdcComboEvents
-- 
-- --------------------------------------------------
data MdcComboEvents a = MdcComboEvents
                         
type IMdcComboEvents a = Automation.IDispatch (MdcComboEvents a)
iidIMdcComboEvents :: Com.IID (IMdcComboEvents ())
iidIMdcComboEvents =
  Com.mkIID "{8BD21D32-EC42-11CE-9E0D-00AA006002F3}"
-- --------------------------------------------------
-- 
-- coclass ComboBox
-- 
-- --------------------------------------------------
clsidComboBox :: Com.CLSID
clsidComboBox =
  Com.mkCLSID "{8BD21D30-EC42-11CE-9E0D-00AA006002F3}"
-- --------------------------------------------------
-- 
-- dispinterface MdcCheckBoxEvents
-- 
-- --------------------------------------------------
data MdcCheckBoxEvents a = MdcCheckBoxEvents
                            
type IMdcCheckBoxEvents a = Automation.IDispatch (MdcCheckBoxEvents a)
iidIMdcCheckBoxEvents :: Com.IID (IMdcCheckBoxEvents ())
iidIMdcCheckBoxEvents =
  Com.mkIID "{8BD21D42-EC42-11CE-9E0D-00AA006002F3}"
-- --------------------------------------------------
-- 
-- dispinterface MdcOptionButtonEvents
-- 
-- --------------------------------------------------
data MdcOptionButtonEvents a = MdcOptionButtonEvents
                                
type IMdcOptionButtonEvents a = Automation.IDispatch (MdcOptionButtonEvents a)
iidIMdcOptionButtonEvents :: Com.IID (IMdcOptionButtonEvents ())
iidIMdcOptionButtonEvents =
  Com.mkIID "{8BD21D52-EC42-11CE-9E0D-00AA006002F3}"
-- --------------------------------------------------
-- 
-- dispinterface MdcToggleButtonEvents
-- 
-- --------------------------------------------------
data MdcToggleButtonEvents a = MdcToggleButtonEvents
                                
type IMdcToggleButtonEvents a = Automation.IDispatch (MdcToggleButtonEvents a)
iidIMdcToggleButtonEvents :: Com.IID (IMdcToggleButtonEvents ())
iidIMdcToggleButtonEvents =
  Com.mkIID "{8BD21D62-EC42-11CE-9E0D-00AA006002F3}"
-- --------------------------------------------------
-- 
-- coclass CheckBox
-- 
-- --------------------------------------------------
clsidCheckBox :: Com.CLSID
clsidCheckBox =
  Com.mkCLSID "{8BD21D40-EC42-11CE-9E0D-00AA006002F3}"
-- --------------------------------------------------
-- 
-- coclass OptionButton
-- 
-- --------------------------------------------------
clsidOptionButton :: Com.CLSID
clsidOptionButton =
  Com.mkCLSID "{8BD21D50-EC42-11CE-9E0D-00AA006002F3}"
-- --------------------------------------------------
-- 
-- coclass ToggleButton
-- 
-- --------------------------------------------------
clsidToggleButton :: Com.CLSID
clsidToggleButton =
  Com.mkCLSID "{8BD21D60-EC42-11CE-9E0D-00AA006002F3}"
-- --------------------------------------------------
-- 
-- coclass NewFont
-- 
-- --------------------------------------------------
clsidNewFont :: Com.CLSID
clsidNewFont = Com.mkCLSID "{AFC20920-DA4E-11CE-B943-00AA006887B4}"
-- --------------------------------------------------
-- 
-- dispinterface ScrollbarEvents
-- 
-- --------------------------------------------------
data ScrollbarEvents a = ScrollbarEvents
                          
type IScrollbarEvents a = Automation.IDispatch (ScrollbarEvents a)
iidIScrollbarEvents :: Com.IID (IScrollbarEvents ())
iidIScrollbarEvents =
  Com.mkIID "{7B020EC2-AF6C-11CE-9F46-00AA00574A4F}"
scroll3 :: Automation.IDispatch a -> Prelude.IO ()
scroll3 = Automation.method0 "Scroll" []
-- --------------------------------------------------
-- 
-- coclass ScrollBar
-- 
-- --------------------------------------------------
clsidScrollBar :: Com.CLSID
clsidScrollBar =
  Com.mkCLSID "{DFD181E0-5E2F-11CE-A449-00AA004A803D}"
-- --------------------------------------------------
-- 
-- dispinterface TabStripEvents
-- 
-- --------------------------------------------------
data TabStripEvents a = TabStripEvents
                         
type ITabStripEvents a = Automation.IDispatch (TabStripEvents a)
iidITabStripEvents :: Com.IID (ITabStripEvents ())
iidITabStripEvents =
  Com.mkIID "{7B020EC7-AF6C-11CE-9F46-00AA00574A4F}"
beforeDragOver10 :: (Automation.Variant a0, Automation.Variant a1, Automation.Variant a2) => Prelude.Int -> a0 -> a1 -> Prelude.Float -> Prelude.Float -> Prelude.Int -> a2 -> Prelude.Int -> ITabStripEvents a -> Prelude.IO ()
beforeDragOver10 index cancel data0 x y dragState effect shift =
  Automation.method0 "BeforeDragOver" [Automation.inInt index, Automation.inVariant cancel, Automation.inVariant data0, Automation.inFloat x, Automation.inFloat y, Automation.inInt dragState, Automation.inVariant effect, Automation.inInt shift]
beforeDropOrPaste10 :: (Automation.Variant a0, Automation.Variant a1, Automation.Variant a2) => Prelude.Int -> a0 -> Prelude.Int -> a1 -> Prelude.Float -> Prelude.Float -> a2 -> Prelude.Int -> ITabStripEvents a -> Prelude.IO ()
beforeDropOrPaste10 index cancel action data0 x y effect shift =
  Automation.method0 "BeforeDropOrPaste" [Automation.inInt index, Automation.inVariant cancel, Automation.inInt action, Automation.inVariant data0, Automation.inFloat x, Automation.inFloat y, Automation.inVariant effect, Automation.inInt shift]
click8 :: Prelude.Int -> Automation.IDispatch a -> Prelude.IO ()
click8 index = Automation.method0 "Click" [Automation.inInt index]
dblClick9 :: (Automation.Variant a0) => Prelude.Int -> a0 -> Automation.IDispatch a -> Prelude.IO ()
dblClick9 index cancel =
  Automation.method0 "DblClick" [Automation.inInt index, Automation.inVariant cancel]
mouseDown9 :: Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Float -> Prelude.Float -> Automation.IDispatch a -> Prelude.IO ()
mouseDown9 index button shift x y =
  Automation.method0 "MouseDown" [Automation.inInt index, Automation.inInt button, Automation.inInt shift, Automation.inFloat x, Automation.inFloat y]
mouseMove9 :: Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Float -> Prelude.Float -> Automation.IDispatch a -> Prelude.IO ()
mouseMove9 index button shift x y =
  Automation.method0 "MouseMove" [Automation.inInt index, Automation.inInt button, Automation.inInt shift, Automation.inFloat x, Automation.inFloat y]
mouseUp9 :: Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Float -> Prelude.Float -> Automation.IDispatch a -> Prelude.IO ()
mouseUp9 index button shift x y =
  Automation.method0 "MouseUp" [Automation.inInt index, Automation.inInt button, Automation.inInt shift, Automation.inFloat x, Automation.inFloat y]
-- --------------------------------------------------
-- 
-- coclass TabStrip
-- 
-- --------------------------------------------------
clsidTabStrip :: Com.CLSID
clsidTabStrip =
  Com.mkCLSID "{EAE50EB0-4A62-11CE-BED6-00AA00611080}"
-- --------------------------------------------------
-- 
-- dispinterface SpinbuttonEvents
-- 
-- --------------------------------------------------
data SpinbuttonEvents a = SpinbuttonEvents
                           
type ISpinbuttonEvents a = Automation.IDispatch (SpinbuttonEvents a)
iidISpinbuttonEvents :: Com.IID (ISpinbuttonEvents ())
iidISpinbuttonEvents =
  Com.mkIID "{79176FB2-B7F2-11CE-97EF-00AA006D2776}"
spinUp :: ISpinbuttonEvents a -> Prelude.IO ()
spinUp = Automation.method0 "SpinUp" []
spinDown :: ISpinbuttonEvents a -> Prelude.IO ()
spinDown = Automation.method0 "SpinDown" []
-- --------------------------------------------------
-- 
-- coclass SpinButton
-- 
-- --------------------------------------------------
clsidSpinButton :: Com.CLSID
clsidSpinButton =
  Com.mkCLSID "{79176FB0-B7F2-11CE-97EF-00AA006D2776}"
-- --------------------------------------------------
-- 
-- dispinterface ImageEvents
-- 
-- --------------------------------------------------
data MageEvents a = MageEvents
                     
type ImageEvents a = Automation.IDispatch (MageEvents a)
iidImageEvents :: Com.IID (ImageEvents ())
iidImageEvents = Com.mkIID "{4C5992A5-6926-101B-9992-00000B65C6F9}"
-- --------------------------------------------------
-- 
-- coclass Image
-- 
-- --------------------------------------------------
clsidImage :: Com.CLSID
clsidImage = Com.mkCLSID "{4C599241-6926-101B-9992-00000B65C6F9}"
-- --------------------------------------------------
-- 
-- dispinterface WHTMLControlEvents
-- 
-- --------------------------------------------------
data WHTMLControlEvents a = WHTMLControlEvents
                             
type IWHTMLControlEvents a = Automation.IDispatch (WHTMLControlEvents a)
iidIWHTMLControlEvents :: Com.IID (IWHTMLControlEvents ())
iidIWHTMLControlEvents =
  Com.mkIID "{796ED650-5FE9-11CF-8D68-00AA00BDCE1D}"
-- --------------------------------------------------
-- 
-- dispinterface WHTMLControlEvents1
-- 
-- --------------------------------------------------
data WHTMLControlEvents1 a = WHTMLControlEvents1
                              
type IWHTMLControlEvents1 a = Automation.IDispatch (WHTMLControlEvents1 a)
iidIWHTMLControlEvents1 :: Com.IID (IWHTMLControlEvents1 ())
iidIWHTMLControlEvents1 =
  Com.mkIID "{47FF8FE0-6198-11CF-8CE8-00AA006CB389}"
-- --------------------------------------------------
-- 
-- dispinterface WHTMLControlEvents2
-- 
-- --------------------------------------------------
data WHTMLControlEvents2 a = WHTMLControlEvents2
                              
type IWHTMLControlEvents2 a = Automation.IDispatch (WHTMLControlEvents2 a)
iidIWHTMLControlEvents2 :: Com.IID (IWHTMLControlEvents2 ())
iidIWHTMLControlEvents2 =
  Com.mkIID "{47FF8FE1-6198-11CF-8CE8-00AA006CB389}"
-- --------------------------------------------------
-- 
-- dispinterface WHTMLControlEvents3
-- 
-- --------------------------------------------------
data WHTMLControlEvents3 a = WHTMLControlEvents3
                              
type IWHTMLControlEvents3 a = Automation.IDispatch (WHTMLControlEvents3 a)
iidIWHTMLControlEvents3 :: Com.IID (IWHTMLControlEvents3 ())
iidIWHTMLControlEvents3 =
  Com.mkIID "{47FF8FE2-6198-11CF-8CE8-00AA006CB389}"
-- --------------------------------------------------
-- 
-- dispinterface WHTMLControlEvents4
-- 
-- --------------------------------------------------
data WHTMLControlEvents4 a = WHTMLControlEvents4
                              
type IWHTMLControlEvents4 a = Automation.IDispatch (WHTMLControlEvents4 a)
iidIWHTMLControlEvents4 :: Com.IID (IWHTMLControlEvents4 ())
iidIWHTMLControlEvents4 =
  Com.mkIID "{47FF8FE3-6198-11CF-8CE8-00AA006CB389}"
-- --------------------------------------------------
-- 
-- dispinterface WHTMLControlEvents5
-- 
-- --------------------------------------------------
data WHTMLControlEvents5 a = WHTMLControlEvents5
                              
type IWHTMLControlEvents5 a = Automation.IDispatch (WHTMLControlEvents5 a)
iidIWHTMLControlEvents5 :: Com.IID (IWHTMLControlEvents5 ())
iidIWHTMLControlEvents5 =
  Com.mkIID "{47FF8FE4-6198-11CF-8CE8-00AA006CB389}"
-- --------------------------------------------------
-- 
-- dispinterface WHTMLControlEvents6
-- 
-- --------------------------------------------------
data WHTMLControlEvents6 a = WHTMLControlEvents6
                              
type IWHTMLControlEvents6 a = Automation.IDispatch (WHTMLControlEvents6 a)
iidIWHTMLControlEvents6 :: Com.IID (IWHTMLControlEvents6 ())
iidIWHTMLControlEvents6 =
  Com.mkIID "{47FF8FE5-6198-11CF-8CE8-00AA006CB389}"
-- --------------------------------------------------
-- 
-- dispinterface WHTMLControlEvents7
-- 
-- --------------------------------------------------
data WHTMLControlEvents7 a = WHTMLControlEvents7
                              
type IWHTMLControlEvents7 a = Automation.IDispatch (WHTMLControlEvents7 a)
iidIWHTMLControlEvents7 :: Com.IID (IWHTMLControlEvents7 ())
iidIWHTMLControlEvents7 =
  Com.mkIID "{47FF8FE6-6198-11CF-8CE8-00AA006CB389}"
-- --------------------------------------------------
-- 
-- dispinterface WHTMLControlEvents9
-- 
-- --------------------------------------------------
data WHTMLControlEvents9 a = WHTMLControlEvents9
                              
type IWHTMLControlEvents9 a = Automation.IDispatch (WHTMLControlEvents9 a)
iidIWHTMLControlEvents9 :: Com.IID (IWHTMLControlEvents9 ())
iidIWHTMLControlEvents9 =
  Com.mkIID "{47FF8FE8-6198-11CF-8CE8-00AA006CB389}"
-- --------------------------------------------------
-- 
-- dispinterface WHTMLControlEvents10
-- 
-- --------------------------------------------------
data WHTMLControlEvents10 a = WHTMLControlEvents10
                               
type IWHTMLControlEvents10 a = Automation.IDispatch (WHTMLControlEvents10 a)
iidIWHTMLControlEvents10 :: Com.IID (IWHTMLControlEvents10 ())
iidIWHTMLControlEvents10 =
  Com.mkIID "{47FF8FE9-6198-11CF-8CE8-00AA006CB389}"
-- --------------------------------------------------
-- 
-- coclass HTMLSubmit
-- 
-- --------------------------------------------------
clsidHTMLSubmit :: Com.CLSID
clsidHTMLSubmit =
  Com.mkCLSID "{5512D110-5CC6-11CF-8D67-00AA00BDCE1D}"
-- --------------------------------------------------
-- 
-- coclass HTMLImage
-- 
-- --------------------------------------------------
clsidHTMLImage :: Com.CLSID
clsidHTMLImage =
  Com.mkCLSID "{5512D112-5CC6-11CF-8D67-00AA00BDCE1D}"
-- --------------------------------------------------
-- 
-- coclass HTMLReset
-- 
-- --------------------------------------------------
clsidHTMLReset :: Com.CLSID
clsidHTMLReset =
  Com.mkCLSID "{5512D114-5CC6-11CF-8D67-00AA00BDCE1D}"
-- --------------------------------------------------
-- 
-- coclass HTMLCheckbox
-- 
-- --------------------------------------------------
clsidHTMLCheckbox :: Com.CLSID
clsidHTMLCheckbox =
  Com.mkCLSID "{5512D116-5CC6-11CF-8D67-00AA00BDCE1D}"
-- --------------------------------------------------
-- 
-- coclass HTMLOption
-- 
-- --------------------------------------------------
clsidHTMLOption :: Com.CLSID
clsidHTMLOption =
  Com.mkCLSID "{5512D118-5CC6-11CF-8D67-00AA00BDCE1D}"
-- --------------------------------------------------
-- 
-- coclass HTMLText
-- 
-- --------------------------------------------------
clsidHTMLText :: Com.CLSID
clsidHTMLText =
  Com.mkCLSID "{5512D11A-5CC6-11CF-8D67-00AA00BDCE1D}"
-- --------------------------------------------------
-- 
-- coclass HTMLHidden
-- 
-- --------------------------------------------------
clsidHTMLHidden :: Com.CLSID
clsidHTMLHidden =
  Com.mkCLSID "{5512D11C-5CC6-11CF-8D67-00AA00BDCE1D}"
-- --------------------------------------------------
-- 
-- coclass HTMLPassword
-- 
-- --------------------------------------------------
clsidHTMLPassword :: Com.CLSID
clsidHTMLPassword =
  Com.mkCLSID "{5512D11E-5CC6-11CF-8D67-00AA00BDCE1D}"
-- --------------------------------------------------
-- 
-- coclass HTMLSelect
-- 
-- --------------------------------------------------
clsidHTMLSelect :: Com.CLSID
clsidHTMLSelect =
  Com.mkCLSID "{5512D122-5CC6-11CF-8D67-00AA00BDCE1D}"
-- --------------------------------------------------
-- 
-- coclass HTMLTextArea
-- 
-- --------------------------------------------------
clsidHTMLTextArea :: Com.CLSID
clsidHTMLTextArea =
  Com.mkCLSID "{5512D124-5CC6-11CF-8D67-00AA00BDCE1D}"
data FmTransitionEffect
 = FmTransitionEffectNone
 | FmTransitionEffectCoverUp
 | FmTransitionEffectCoverRightUp
 | FmTransitionEffectCoverRight
 | FmTransitionEffectCoverRightDown
 | FmTransitionEffectCoverDown
 | FmTransitionEffectCoverLeftDown
 | FmTransitionEffectCoverLeft
 | FmTransitionEffectCoverLeftUp
 | FmTransitionEffectPushUp
 | FmTransitionEffectPushRight
 | FmTransitionEffectPushDown
 | FmTransitionEffectPushLeft
 
marshallFmTransitionEffect :: FmTransitionEffect -> Prelude.IO Int.Int16
marshallFmTransitionEffect v =
  case v of
     FmTransitionEffectNone -> Prelude.return (0)
     FmTransitionEffectCoverUp -> Prelude.return (1)
     FmTransitionEffectCoverRightUp -> Prelude.return (2)
     FmTransitionEffectCoverRight -> Prelude.return (3)
     FmTransitionEffectCoverRightDown -> Prelude.return (4)
     FmTransitionEffectCoverDown -> Prelude.return (5)
     FmTransitionEffectCoverLeftDown -> Prelude.return (6)
     FmTransitionEffectCoverLeft -> Prelude.return (7)
     FmTransitionEffectCoverLeftUp -> Prelude.return (8)
     FmTransitionEffectPushUp -> Prelude.return (9)
     FmTransitionEffectPushRight -> Prelude.return (10)
     FmTransitionEffectPushDown -> Prelude.return (11)
     FmTransitionEffectPushLeft -> Prelude.return (12)
unmarshallFmTransitionEffect :: Int.Int16 -> Prelude.IO FmTransitionEffect
unmarshallFmTransitionEffect v =
  case v of
     0 -> Prelude.return (FmTransitionEffectNone)
     1 -> Prelude.return (FmTransitionEffectCoverUp)
     2 -> Prelude.return (FmTransitionEffectCoverRightUp)
     3 -> Prelude.return (FmTransitionEffectCoverRight)
     4 -> Prelude.return (FmTransitionEffectCoverRightDown)
     5 -> Prelude.return (FmTransitionEffectCoverDown)
     6 -> Prelude.return (FmTransitionEffectCoverLeftDown)
     7 -> Prelude.return (FmTransitionEffectCoverLeft)
     8 -> Prelude.return (FmTransitionEffectCoverLeftUp)
     9 -> Prelude.return (FmTransitionEffectPushUp)
     10 -> Prelude.return (FmTransitionEffectPushRight)
     11 -> Prelude.return (FmTransitionEffectPushDown)
     12 -> Prelude.return (FmTransitionEffectPushLeft)
     _ -> Prelude.fail (Prelude.userError "unmarshallFmTransitionEffect: illegal enum value ")
-- --------------------------------------------------
-- 
-- interface IPage
-- 
-- --------------------------------------------------
data Page a = Page
               
type IPage a = Automation.IDispatch (Page a)
iidIPage :: Com.IID (IPage ())
iidIPage = Com.mkIID "{5CEF5613-713D-11CE-80C9-00AA00611080}"
setTransitionEffect :: Prelude.Int -> IPage a -> Prelude.IO ()
setTransitionEffect transitionEffect =
  Automation.propertySet "TransitionEffect" [Automation.inInt transitionEffect]
getTransitionEffect :: IPage a -> Prelude.IO (Prelude.Int)
getTransitionEffect =
  Automation.propertyGet "TransitionEffect" [] Automation.outInt
setTransitionPeriod :: Prelude.Int -> IPage a -> Prelude.IO ()
setTransitionPeriod transitionPeriod =
  Automation.propertySet "TransitionPeriod" [Automation.inInt transitionPeriod]
getTransitionPeriod :: IPage a -> Prelude.IO (Prelude.Int)
getTransitionPeriod =
  Automation.propertyGet "TransitionPeriod" [] Automation.outInt
-- --------------------------------------------------
-- 
-- interface Pages
-- 
-- --------------------------------------------------
data Pages a = Pages
                
type IPages a = Automation.IDispatch (Pages a)
iidIPages :: Com.IID (IPages ())
iidIPages = Com.mkIID "{92E11A03-7358-11CE-80CB-00AA00611080}"
add2 :: (Automation.Variant a0, Automation.Variant a1, Automation.Variant a2) => a0 -> a1 -> a2 -> IPages a -> Prelude.IO (Automation.IDispatch ())
add2 bstrName bstrCaption lIndex =
  Automation.function1 "Add" [Automation.inVariant bstrName, Automation.inVariant bstrCaption, Automation.inVariant lIndex] Automation.outIDispatch
addCtrl :: Prelude.Int -> Prelude.String -> Prelude.String -> IPages a -> Prelude.IO (Automation.IDispatch ())
addCtrl clsid bstrName bstrCaption =
  Automation.function1 "_AddCtrl" [Automation.inInt clsid, Automation.inString bstrName, Automation.inString bstrCaption] Automation.outIDispatch
insertCtrl :: Prelude.Int -> Prelude.String -> Prelude.String -> Prelude.Int -> IPages a -> Prelude.IO (Automation.IDispatch ())
insertCtrl clsid bstrName bstrCaption lIndex =
  Automation.function1 "_InsertCtrl" [Automation.inInt clsid, Automation.inString bstrName, Automation.inString bstrCaption, Automation.inInt lIndex] Automation.outIDispatch
-- --------------------------------------------------
-- 
-- interface IMultiPage
-- 
-- --------------------------------------------------
data MultiPage a = MultiPage
                    
type IMultiPage a = Automation.IDispatch (MultiPage a)
iidIMultiPage :: Com.IID (IMultiPage ())
iidIMultiPage = Com.mkIID "{04598FC9-866C-11CF-AB7C-00AA00C08FCF}"
getSelectedItem0 :: IMultiPage a -> Prelude.IO (Automation.IDispatch ())
getSelectedItem0 =
  Automation.propertyGet "SelectedItem" [] Automation.outIDispatch
getPages :: IMultiPage a -> Prelude.IO (Automation.IDispatch ())
getPages =
  Automation.propertyGet "Pages" [] Automation.outIDispatch
-- --------------------------------------------------
-- 
-- dispinterface MultiPageEvents
-- 
-- --------------------------------------------------
data MultiPageEvents a = MultiPageEvents
                          
type IMultiPageEvents a = Automation.IDispatch (MultiPageEvents a)
iidIMultiPageEvents :: Com.IID (IMultiPageEvents ())
iidIMultiPageEvents =
  Com.mkIID "{7B020EC8-AF6C-11CE-9F46-00AA00574A4F}"
addControl1 :: Prelude.Int -> Automation.IDispatch a0 -> IMultiPageEvents a -> Prelude.IO ()
addControl1 index control =
  Automation.method0 "AddControl" [Automation.inInt index, Automation.inIDispatch control]
beforeDragOver13 :: (Automation.Variant a0, Automation.Variant a2, Automation.Variant a3) => Prelude.Int -> a0 -> Automation.IDispatch a1 -> a2 -> Prelude.Float -> Prelude.Float -> Prelude.Int -> a3 -> Prelude.Int -> IMultiPageEvents a -> Prelude.IO ()
beforeDragOver13 index cancel control data0 x y state effect shift =
  Automation.method0 "BeforeDragOver" [Automation.inInt index, Automation.inVariant cancel, Automation.inIDispatch control, Automation.inVariant data0, Automation.inFloat x, Automation.inFloat y, Automation.inInt state, Automation.inVariant effect, Automation.inInt shift]
beforeDropOrPaste13 :: (Automation.Variant a0, Automation.Variant a2, Automation.Variant a3) => Prelude.Int -> a0 -> Automation.IDispatch a1 -> Prelude.Int -> a2 -> Prelude.Float -> Prelude.Float -> a3 -> Prelude.Int -> IMultiPageEvents a -> Prelude.IO ()
beforeDropOrPaste13 index cancel control action data0 x y effect shift =
  Automation.method0 "BeforeDropOrPaste" [Automation.inInt index, Automation.inVariant cancel, Automation.inIDispatch control, Automation.inInt action, Automation.inVariant data0, Automation.inFloat x, Automation.inFloat y, Automation.inVariant effect, Automation.inInt shift]
error13 :: (Automation.Variant a0, Automation.Variant a1) => Prelude.Int -> Prelude.Int -> a0 -> Prelude.Int -> Prelude.String -> Prelude.String -> Prelude.Int -> a1 -> IMultiPageEvents a -> Prelude.IO ()
error13 index number description sCode source helpFile helpContext cancelDisplay =
  Automation.method0 "Error" [Automation.inInt index, Automation.inInt number, Automation.inVariant description, Automation.inInt sCode, Automation.inString source, Automation.inString helpFile, Automation.inInt helpContext, Automation.inVariant cancelDisplay]
layout1 :: Prelude.Int -> Automation.IDispatch a -> Prelude.IO ()
layout1 index =
  Automation.method0 "Layout" [Automation.inInt index]
removeControl1 :: Prelude.Int -> Automation.IDispatch a0 -> IMultiPageEvents a -> Prelude.IO ()
removeControl1 index control =
  Automation.method0 "RemoveControl" [Automation.inInt index, Automation.inIDispatch control]
scroll5 :: (Automation.Variant a0, Automation.Variant a1) => Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Float -> Prelude.Float -> a0 -> a1 -> IMultiPageEvents a -> Prelude.IO ()
scroll5 index actionX actionY requestDx requestDy actualDx actualDy =
  Automation.method0 "Scroll" [Automation.inInt index, Automation.inInt actionX, Automation.inInt actionY, Automation.inFloat requestDx, Automation.inFloat requestDy, Automation.inVariant actualDx, Automation.inVariant actualDy]
zoom1 :: Prelude.Int -> Prelude.Int -> IMultiPageEvents a -> Prelude.IO (Prelude.Int)
zoom1 index percent =
  Automation.method1 "Zoom" [Automation.inInt index] (Automation.inoutInt percent)
-- --------------------------------------------------
-- 
-- coclass MultiPage
-- 
-- --------------------------------------------------
clsidMultiPage :: Com.CLSID
clsidMultiPage =
  Com.mkCLSID "{46E31370-3F7A-11CE-BED6-00AA00611080}"
-- --------------------------------------------------
-- 
-- coclass Page
-- 
-- --------------------------------------------------
clsidPage :: Com.CLSID
clsidPage = Com.mkCLSID "{5CEF5610-713D-11CE-80C9-00AA00611080}"
data FmListBoxStyles
 = FmListBoxStylesNone
 | FmListBoxStylesListBox
 | FmListBoxStylesComboBox
 
marshallFmListBoxStyles :: FmListBoxStyles -> Prelude.IO Int.Int16
marshallFmListBoxStyles v =
  case v of
     FmListBoxStylesNone -> Prelude.return (0)
     FmListBoxStylesListBox -> Prelude.return (1)
     FmListBoxStylesComboBox -> Prelude.return (2)
unmarshallFmListBoxStyles :: Int.Int16 -> Prelude.IO FmListBoxStyles
unmarshallFmListBoxStyles v =
  case v of
     0 -> Prelude.return (FmListBoxStylesNone)
     1 -> Prelude.return (FmListBoxStylesListBox)
     2 -> Prelude.return (FmListBoxStylesComboBox)
     _ -> Prelude.fail (Prelude.userError "unmarshallFmListBoxStyles: illegal enum value ")
data FmRepeatDirection
 = FmRepeatDirectionHorizontal
 | FmRepeatDirectionVertical
 
marshallFmRepeatDirection :: FmRepeatDirection -> Prelude.IO Int.Int16
marshallFmRepeatDirection v =
  case v of
     FmRepeatDirectionHorizontal -> Prelude.return (0)
     FmRepeatDirectionVertical -> Prelude.return (1)
unmarshallFmRepeatDirection :: Int.Int16 -> Prelude.IO FmRepeatDirection
unmarshallFmRepeatDirection v =
  case v of
     0 -> Prelude.return (FmRepeatDirectionHorizontal)
     1 -> Prelude.return (FmRepeatDirectionVertical)
     _ -> Prelude.fail (Prelude.userError "unmarshallFmRepeatDirection: illegal enum value ")
data FmEnAutoSize
 = FmEnAutoSizeNone
 | FmEnAutoSizeHorizontal
 | FmEnAutoSizeVertical
 | FmEnAutoSizeBoth
 
marshallFmEnAutoSize :: FmEnAutoSize -> Prelude.IO Int.Int16
marshallFmEnAutoSize v =
  case v of
     FmEnAutoSizeNone -> Prelude.return (0)
     FmEnAutoSizeHorizontal -> Prelude.return (1)
     FmEnAutoSizeVertical -> Prelude.return (2)
     FmEnAutoSizeBoth -> Prelude.return (3)
unmarshallFmEnAutoSize :: Int.Int16 -> Prelude.IO FmEnAutoSize
unmarshallFmEnAutoSize v =
  case v of
     0 -> Prelude.return (FmEnAutoSizeNone)
     1 -> Prelude.return (FmEnAutoSizeHorizontal)
     2 -> Prelude.return (FmEnAutoSizeVertical)
     3 -> Prelude.return (FmEnAutoSizeBoth)
     _ -> Prelude.fail (Prelude.userError "unmarshallFmEnAutoSize: illegal enum value ")
