-----------------------------------------------------------
-- copyright (c) 1998,  Daan Leijen, leijen@@fwi.uva.nl
-----------------------------------------------------------

module MarshallPrim where

import StdDIS
import PointerPrim

data WideString         = WideString
sizeWide                = 2


primitive prim_readCharAt :: ForeignObj -> IO (Char)
readCharAt :: Pointer String -> IO Char
readCharAt gc_arg1 =
  (marshall_pointer_ gc_arg1) >>= \ (arg1) ->
  prim_readCharAt arg1 >>= \ (res1) ->
  (return (res1))

primitive prim_readCharAtOffset :: ForeignObj -> Int -> IO (Char)
readCharAtOffset :: Pointer String -> Int -> IO Char
readCharAtOffset gc_arg1 ofs =
  (marshall_pointer_ gc_arg1) >>= \ (p) ->
  prim_readCharAtOffset p ofs >>= \ (res1) ->
  (return (res1))

primitive prim_writeCharAt :: Char -> ForeignObj -> IO ()
writeCharAt :: Char -> Pointer String -> IO ()
writeCharAt arg1 gc_arg1 =
  (marshall_pointer_ gc_arg1) >>= \ (arg2) ->
  prim_writeCharAt arg1 arg2

primitive prim_lenString :: ForeignObj -> IO (Int)
lenString :: Pointer String -> Int
lenString gc_arg1 =
  unsafePerformIO(
    (marshall_pointer_ gc_arg1) >>= \ (arg1) ->
    prim_lenString arg1 >>= \ (res1) ->
    (return (res1)))

primitive prim_lenStringFromWide :: ForeignObj -> IO (Int)
lenStringFromWide :: Pointer WideString -> Int
lenStringFromWide gc_arg1 =
  unsafePerformIO(
    (marshall_pointer_ gc_arg1) >>= \ (arg1) ->
    prim_lenStringFromWide arg1 >>= \ (res1) ->
    (return (res1)))

primitive prim_lenWideFromString :: ForeignObj -> IO (Int)
lenWideFromString :: Pointer String -> Int
lenWideFromString gc_arg1 =
  unsafePerformIO(
    (marshall_pointer_ gc_arg1) >>= \ (arg1) ->
    prim_lenWideFromString arg1 >>= \ (res1) ->
    (return (res1)))

primitive prim_stringFromWide :: ForeignObj -> Int -> ForeignObj -> IO ()
stringFromWide :: Pointer WideString -> Int -> Pointer String -> IO ()
stringFromWide gc_arg1 arg2 gc_arg2 =
  (marshall_pointer_ gc_arg1) >>= \ (arg1) ->
  (marshall_pointer_ gc_arg2) >>= \ (arg3) ->
  prim_stringFromWide arg1 arg2 arg3

primitive prim_wideFromString :: ForeignObj -> Int -> ForeignObj -> IO ()
wideFromString :: Pointer String -> Int -> Pointer WideString -> IO ()
wideFromString gc_arg1 arg2 gc_arg2 =
  (marshall_pointer_ gc_arg1) >>= \ (arg1) ->
  (marshall_pointer_ gc_arg2) >>= \ (arg3) ->
  prim_wideFromString arg1 arg2 arg3

needPrims_hugs 2
