module SHDocVw where

import qualified Prelude
import qualified Automation (IDispatch, Interface, method0, inInt, 
                             inString, outIDispatch, propertyGet, outInt, outString, 
                             propertySet, inoutInt, method1, method2, function1, Variant, 
                             outVariant, inVariant, inIDispatch, inoutIDispatch, outIUnknown, 
                             function2, inIUnknown, Date, outDate, inDate)
import qualified Com (IID, mkIID, CLSID, mkCLSID, IUnknown)
import qualified Int (Int16)

-- --------------------------------------------------
-- 
-- interface IWebBrowser
-- 
-- --------------------------------------------------
data WebBrowser a = WebBrowser
                     
type IWebBrowser a = Automation.IDispatch (WebBrowser a)
iidIWebBrowser :: Com.IID (IWebBrowser Automation.Interface)
iidIWebBrowser = Com.mkIID "{EAB22AC1-30C1-11CF-A7EB-0000C05BAE0B}"
goBack :: IWebBrowser a -> Prelude.IO ()
goBack = Automation.method0 "GoBack" []
goForward :: IWebBrowser a -> Prelude.IO ()
goForward = Automation.method0 "GoForward" []
goHome :: IWebBrowser a -> Prelude.IO ()
goHome = Automation.method0 "GoHome" []
goSearch :: IWebBrowser a -> Prelude.IO ()
goSearch = Automation.method0 "GoSearch" []
navigate :: Prelude.String -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> IWebBrowser a -> Prelude.IO ()
navigate uRL flags targetFrameName postData headers =
  Automation.method0 "Navigate" [Automation.inString uRL, Automation.inInt flags, Automation.inInt targetFrameName, Automation.inInt postData, Automation.inInt headers]
refresh :: IWebBrowser a -> Prelude.IO ()
refresh = Automation.method0 "Refresh" []
refresh2 :: Prelude.Int -> IWebBrowser a -> Prelude.IO ()
refresh2 level =
  Automation.method0 "Refresh2" [Automation.inInt level]
stop :: IWebBrowser a -> Prelude.IO ()
stop = Automation.method0 "Stop" []
getApplication :: IWebBrowser a -> Prelude.IO (Automation.IDispatch Automation.Interface)
getApplication =
  Automation.propertyGet "Application" [] Automation.outIDispatch
getParent :: IWebBrowser a -> Prelude.IO (Automation.IDispatch Automation.Interface)
getParent =
  Automation.propertyGet "Parent" [] Automation.outIDispatch
getContainer :: IWebBrowser a -> Prelude.IO (Automation.IDispatch Automation.Interface)
getContainer =
  Automation.propertyGet "Container" [] Automation.outIDispatch
getDocument :: IWebBrowser a -> Prelude.IO (Automation.IDispatch b)
getDocument =
  Automation.propertyGet "Document" [] Automation.outIDispatch
getTopLevelContainer :: IWebBrowser a -> Prelude.IO (Prelude.Int)
getTopLevelContainer =
  Automation.propertyGet "TopLevelContainer" [] Automation.outInt
getType :: IWebBrowser a -> Prelude.IO (Prelude.String)
getType = Automation.propertyGet "Type" [] Automation.outString
getLeft :: IWebBrowser a -> Prelude.IO (Prelude.Int)
getLeft = Automation.propertyGet "Left" [] Automation.outInt
setLeft :: Prelude.Int -> IWebBrowser a -> Prelude.IO ()
setLeft pl = Automation.propertySet "Left" [Automation.inInt pl]
getTop :: IWebBrowser a -> Prelude.IO (Prelude.Int)
getTop = Automation.propertyGet "Top" [] Automation.outInt
setTop :: Prelude.Int -> IWebBrowser a -> Prelude.IO ()
setTop pl = Automation.propertySet "Top" [Automation.inInt pl]
getWidth :: IWebBrowser a -> Prelude.IO (Prelude.Int)
getWidth = Automation.propertyGet "Width" [] Automation.outInt
setWidth :: Prelude.Int -> IWebBrowser a -> Prelude.IO ()
setWidth pl = Automation.propertySet "Width" [Automation.inInt pl]
getHeight :: IWebBrowser a -> Prelude.IO (Prelude.Int)
getHeight = Automation.propertyGet "Height" [] Automation.outInt
setHeight :: Prelude.Int -> IWebBrowser a -> Prelude.IO ()
setHeight pl =
  Automation.propertySet "Height" [Automation.inInt pl]
getLocationName :: IWebBrowser a -> Prelude.IO (Prelude.String)
getLocationName =
  Automation.propertyGet "LocationName" [] Automation.outString
getLocationURL :: IWebBrowser a -> Prelude.IO (Prelude.String)
getLocationURL =
  Automation.propertyGet "LocationURL" [] Automation.outString
getBusy :: IWebBrowser a -> Prelude.IO (Prelude.Int)
getBusy = Automation.propertyGet "Busy" [] Automation.outInt
-- --------------------------------------------------
-- 
-- dispinterface DWebBrowserEvents
-- 
-- --------------------------------------------------
data WebBrowserEvents a = WebBrowserEvents
                           
type DWebBrowserEvents a = Automation.IDispatch (WebBrowserEvents a)
iidDWebBrowserEvents :: Com.IID (DWebBrowserEvents Automation.Interface)
iidDWebBrowserEvents =
  Com.mkIID "{EAB22AC2-30C1-11CF-A7EB-0000C05BAE0B}"
beforeNavigate :: Prelude.String -> Prelude.Int -> Prelude.String -> Prelude.Int -> Prelude.String -> Prelude.Int -> DWebBrowserEvents a -> Prelude.IO (Prelude.Int)
beforeNavigate uRL flags targetFrameName postData headers cancel =
  Automation.method1 "BeforeNavigate" [Automation.inString uRL, Automation.inInt flags, Automation.inString targetFrameName, Automation.inInt postData, Automation.inString headers] (Automation.inoutInt cancel)
navigateComplete :: Prelude.String -> DWebBrowserEvents a -> Prelude.IO ()
navigateComplete uRL =
  Automation.method0 "NavigateComplete" [Automation.inString uRL]
statusTextChange :: Prelude.String -> DWebBrowserEvents a -> Prelude.IO ()
statusTextChange text =
  Automation.method0 "StatusTextChange" [Automation.inString text]
progressChange :: Prelude.Int -> Prelude.Int -> DWebBrowserEvents a -> Prelude.IO ()
progressChange progress progressMax =
  Automation.method0 "ProgressChange" [Automation.inInt progress, Automation.inInt progressMax]
downloadComplete :: DWebBrowserEvents a -> Prelude.IO ()
downloadComplete = Automation.method0 "DownloadComplete" []
commandStateChange :: Prelude.Int -> Prelude.Int -> DWebBrowserEvents a -> Prelude.IO ()
commandStateChange command enable =
  Automation.method0 "CommandStateChange" [Automation.inInt command, Automation.inInt enable]
downloadBegin :: DWebBrowserEvents a -> Prelude.IO ()
downloadBegin = Automation.method0 "DownloadBegin" []
newWindow :: Prelude.String -> Prelude.Int -> Prelude.String -> Prelude.Int -> Prelude.String -> Prelude.Int -> DWebBrowserEvents a -> Prelude.IO (Prelude.Int)
newWindow uRL flags targetFrameName postData headers processed =
  Automation.method1 "NewWindow" [Automation.inString uRL, Automation.inInt flags, Automation.inString targetFrameName, Automation.inInt postData, Automation.inString headers] (Automation.inoutInt processed)
titleChange :: Prelude.String -> DWebBrowserEvents a -> Prelude.IO ()
titleChange text =
  Automation.method0 "TitleChange" [Automation.inString text]
frameBeforeNavigate :: Prelude.String -> Prelude.Int -> Prelude.String -> Prelude.Int -> Prelude.String -> Prelude.Int -> DWebBrowserEvents a -> Prelude.IO (Prelude.Int)
frameBeforeNavigate uRL flags targetFrameName postData headers cancel =
  Automation.method1 "FrameBeforeNavigate" [Automation.inString uRL, Automation.inInt flags, Automation.inString targetFrameName, Automation.inInt postData, Automation.inString headers] (Automation.inoutInt cancel)
frameNavigateComplete :: Prelude.String -> DWebBrowserEvents a -> Prelude.IO ()
frameNavigateComplete uRL =
  Automation.method0 "FrameNavigateComplete" [Automation.inString uRL]
frameNewWindow :: Prelude.String -> Prelude.Int -> Prelude.String -> Prelude.Int -> Prelude.String -> Prelude.Int -> DWebBrowserEvents a -> Prelude.IO (Prelude.Int)
frameNewWindow uRL flags targetFrameName postData headers processed =
  Automation.method1 "FrameNewWindow" [Automation.inString uRL, Automation.inInt flags, Automation.inString targetFrameName, Automation.inInt postData, Automation.inString headers] (Automation.inoutInt processed)
quit :: Prelude.Int -> DWebBrowserEvents a -> Prelude.IO (Prelude.Int)
quit cancel =
  Automation.method1 "Quit" [] (Automation.inoutInt cancel)
windowMove :: DWebBrowserEvents a -> Prelude.IO ()
windowMove = Automation.method0 "WindowMove" []
windowResize :: DWebBrowserEvents a -> Prelude.IO ()
windowResize = Automation.method0 "WindowResize" []
windowActivate :: DWebBrowserEvents a -> Prelude.IO ()
windowActivate = Automation.method0 "WindowActivate" []
propertyChange :: Prelude.String -> DWebBrowserEvents a -> Prelude.IO ()
propertyChange property =
  Automation.method0 "PropertyChange" [Automation.inString property]
data CommandStateChangeConstants
 = CSC_UPDATECOMMANDS
 | CSC_NAVIGATEFORWARD
 | CSC_NAVIGATEBACK
 
marshallCommandStateChangeConstants :: CommandStateChangeConstants -> Prelude.IO Int.Int16
marshallCommandStateChangeConstants v =
  case v of
     CSC_UPDATECOMMANDS -> Prelude.return ((-1))
     CSC_NAVIGATEFORWARD -> Prelude.return (1)
     CSC_NAVIGATEBACK -> Prelude.return (2)
unmarshallCommandStateChangeConstants :: Int.Int16 -> Prelude.IO CommandStateChangeConstants
unmarshallCommandStateChangeConstants v =
  case v of
     (-1) -> Prelude.return (CSC_UPDATECOMMANDS)
     1 -> Prelude.return (CSC_NAVIGATEFORWARD)
     2 -> Prelude.return (CSC_NAVIGATEBACK)
     _ -> Prelude.fail (Prelude.userError "unmarshallCommandStateChangeConstants: illegal enum value ")
-- --------------------------------------------------
-- 
-- interface IWebBrowserApp
-- 
-- --------------------------------------------------
data WebBrowserApp a = WebBrowserApp
                        
type IWebBrowserApp a = IWebBrowser (WebBrowserApp a)
iidIWebBrowserApp :: Com.IID (IWebBrowserApp Automation.Interface)
iidIWebBrowserApp =
  Com.mkIID "{0002DF05-0000-0000-C000-000000000046}"
goBack0 :: IWebBrowserApp a -> Prelude.IO ()
goBack0 = Automation.method0 "GoBack" []
goForward0 :: IWebBrowserApp a -> Prelude.IO ()
goForward0 = Automation.method0 "GoForward" []
goHome0 :: IWebBrowserApp a -> Prelude.IO ()
goHome0 = Automation.method0 "GoHome" []
goSearch0 :: IWebBrowserApp a -> Prelude.IO ()
goSearch0 = Automation.method0 "GoSearch" []
navigate0 :: Prelude.String -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> IWebBrowserApp a -> Prelude.IO ()
navigate0 uRL flags targetFrameName postData headers =
  Automation.method0 "Navigate" [Automation.inString uRL, Automation.inInt flags, Automation.inInt targetFrameName, Automation.inInt postData, Automation.inInt headers]
refresh0 :: IWebBrowserApp a -> Prelude.IO ()
refresh0 = Automation.method0 "Refresh" []
refresh20 :: Prelude.Int -> IWebBrowserApp a -> Prelude.IO ()
refresh20 level =
  Automation.method0 "Refresh2" [Automation.inInt level]
stop0 :: IWebBrowserApp a -> Prelude.IO ()
stop0 = Automation.method0 "Stop" []
getApplication0 :: IWebBrowserApp a -> Prelude.IO (Automation.IDispatch Automation.Interface)
getApplication0 =
  Automation.propertyGet "Application" [] Automation.outIDispatch
getParent0 :: IWebBrowserApp a -> Prelude.IO (Automation.IDispatch Automation.Interface)
getParent0 =
  Automation.propertyGet "Parent" [] Automation.outIDispatch
getContainer0 :: IWebBrowserApp a -> Prelude.IO (Automation.IDispatch Automation.Interface)
getContainer0 =
  Automation.propertyGet "Container" [] Automation.outIDispatch
getDocument0 :: IWebBrowserApp a -> Prelude.IO (Automation.IDispatch Automation.Interface)
getDocument0 =
  Automation.propertyGet "Document" [] Automation.outIDispatch
getTopLevelContainer0 :: IWebBrowserApp a -> Prelude.IO (Prelude.Int)
getTopLevelContainer0 =
  Automation.propertyGet "TopLevelContainer" [] Automation.outInt
getType0 :: IWebBrowserApp a -> Prelude.IO (Prelude.String)
getType0 = Automation.propertyGet "Type" [] Automation.outString
getLeft0 :: IWebBrowserApp a -> Prelude.IO (Prelude.Int)
getLeft0 = Automation.propertyGet "Left" [] Automation.outInt
setLeft0 :: Prelude.Int -> IWebBrowserApp a -> Prelude.IO ()
setLeft0 pl = Automation.propertySet "Left" [Automation.inInt pl]
getTop0 :: IWebBrowserApp a -> Prelude.IO (Prelude.Int)
getTop0 = Automation.propertyGet "Top" [] Automation.outInt
setTop0 :: Prelude.Int -> IWebBrowserApp a -> Prelude.IO ()
setTop0 pl = Automation.propertySet "Top" [Automation.inInt pl]
getWidth0 :: IWebBrowserApp a -> Prelude.IO (Prelude.Int)
getWidth0 = Automation.propertyGet "Width" [] Automation.outInt
setWidth0 :: Prelude.Int -> IWebBrowserApp a -> Prelude.IO ()
setWidth0 pl = Automation.propertySet "Width" [Automation.inInt pl]
getHeight0 :: IWebBrowserApp a -> Prelude.IO (Prelude.Int)
getHeight0 = Automation.propertyGet "Height" [] Automation.outInt
setHeight0 :: Prelude.Int -> IWebBrowserApp a -> Prelude.IO ()
setHeight0 pl =
  Automation.propertySet "Height" [Automation.inInt pl]
getLocationName0 :: IWebBrowserApp a -> Prelude.IO (Prelude.String)
getLocationName0 =
  Automation.propertyGet "LocationName" [] Automation.outString
getLocationURL0 :: IWebBrowserApp a -> Prelude.IO (Prelude.String)
getLocationURL0 =
  Automation.propertyGet "LocationURL" [] Automation.outString
getBusy0 :: IWebBrowserApp a -> Prelude.IO (Prelude.Int)
getBusy0 = Automation.propertyGet "Busy" [] Automation.outInt
quit0 :: IWebBrowserApp a -> Prelude.IO ()
quit0 = Automation.method0 "Quit" []
clientToWindow :: Prelude.Int -> Prelude.Int -> IWebBrowserApp a -> Prelude.IO (Prelude.Int, Prelude.Int)
clientToWindow pcx pcy =
  Automation.method2 "ClientToWindow" [] (Automation.inoutInt pcx) (Automation.inoutInt pcy)
putProperty :: Prelude.String -> Prelude.Int -> IWebBrowserApp a -> Prelude.IO ()
putProperty property vtValue =
  Automation.method0 "PutProperty" [Automation.inString property, Automation.inInt vtValue]
getProperty :: Prelude.String -> IWebBrowserApp a -> Prelude.IO (Prelude.Int)
getProperty property =
  Automation.function1 "GetProperty" [Automation.inString property] Automation.outInt
getName :: IWebBrowserApp a -> Prelude.IO (Prelude.String)
getName = Automation.propertyGet "Name" [] Automation.outString
getHWND :: IWebBrowserApp a -> Prelude.IO (Prelude.Int)
getHWND = Automation.propertyGet "HWND" [] Automation.outInt
getFullName :: IWebBrowserApp a -> Prelude.IO (Prelude.String)
getFullName =
  Automation.propertyGet "FullName" [] Automation.outString
getPath :: IWebBrowserApp a -> Prelude.IO (Prelude.String)
getPath = Automation.propertyGet "Path" [] Automation.outString
getVisible :: IWebBrowserApp a -> Prelude.IO (Prelude.Int)
getVisible = Automation.propertyGet "Visible" [] Automation.outInt
setVisible :: Prelude.Int -> IWebBrowserApp a -> Prelude.IO ()
setVisible pBool =
  Automation.propertySet "Visible" [Automation.inInt pBool]
getStatusBar :: IWebBrowserApp a -> Prelude.IO (Prelude.Int)
getStatusBar =
  Automation.propertyGet "StatusBar" [] Automation.outInt
setStatusBar :: Prelude.Int -> IWebBrowserApp a -> Prelude.IO ()
setStatusBar pBool =
  Automation.propertySet "StatusBar" [Automation.inInt pBool]
getStatusText :: IWebBrowserApp a -> Prelude.IO (Prelude.String)
getStatusText =
  Automation.propertyGet "StatusText" [] Automation.outString
setStatusText :: Prelude.String -> IWebBrowserApp a -> Prelude.IO ()
setStatusText statusText =
  Automation.propertySet "StatusText" [Automation.inString statusText]
getToolBar :: IWebBrowserApp a -> Prelude.IO (Prelude.Int)
getToolBar = Automation.propertyGet "ToolBar" [] Automation.outInt
setToolBar :: Prelude.Int -> IWebBrowserApp a -> Prelude.IO ()
setToolBar value =
  Automation.propertySet "ToolBar" [Automation.inInt value]
getMenuBar :: IWebBrowserApp a -> Prelude.IO (Prelude.Int)
getMenuBar = Automation.propertyGet "MenuBar" [] Automation.outInt
setMenuBar :: Prelude.Int -> IWebBrowserApp a -> Prelude.IO ()
setMenuBar value =
  Automation.propertySet "MenuBar" [Automation.inInt value]
getFullScreen :: IWebBrowserApp a -> Prelude.IO (Prelude.Int)
getFullScreen =
  Automation.propertyGet "FullScreen" [] Automation.outInt
setFullScreen :: Prelude.Int -> IWebBrowserApp a -> Prelude.IO ()
setFullScreen pbFullScreen =
  Automation.propertySet "FullScreen" [Automation.inInt pbFullScreen]
data OLECMDID
 = OLECMDID_OPEN
 | OLECMDID_NEW
 | OLECMDID_SAVE
 | OLECMDID_SAVEAS
 | OLECMDID_SAVECOPYAS
 | OLECMDID_PRINT
 | OLECMDID_PRINTPREVIEW
 | OLECMDID_PAGESETUP
 | OLECMDID_SPELL
 | OLECMDID_PROPERTIES
 | OLECMDID_CUT
 | OLECMDID_COPY
 | OLECMDID_PASTE
 | OLECMDID_PASTESPECIAL
 | OLECMDID_UNDO
 | OLECMDID_REDO
 | OLECMDID_SELECTALL
 | OLECMDID_CLEARSELECTION
 | OLECMDID_ZOOM
 | OLECMDID_GETZOOMRANGE
 | OLECMDID_UPDATECOMMANDS
 | OLECMDID_REFRESH
 | OLECMDID_STOP
 | OLECMDID_HIDETOOLBARS
 | OLECMDID_SETPROGRESSMAX
 | OLECMDID_SETPROGRESSPOS
 | OLECMDID_SETPROGRESSTEXT
 | OLECMDID_SETTITLE
 | OLECMDID_SETDOWNLOADSTATE
 | OLECMDID_STOPDOWNLOAD
 | OLECMDID_ONTOOLBARACTIVATED
 | OLECMDID_FIND
 | OLECMDID_DELETE
 | OLECMDID_HTTPEQUIV
 | OLECMDID_HTTPEQUIV_DONE
 | OLECMDID_ENABLE_INTERACTION
 | OLECMDID_ONUNLOAD
 | OLECMDID_PROPERTYBAG2
 | OLECMDID_PREREFRESH
 
marshallOLECMDID :: OLECMDID -> Prelude.IO Int.Int16
marshallOLECMDID v =
  case v of
     OLECMDID_OPEN -> Prelude.return (1)
     OLECMDID_NEW -> Prelude.return (2)
     OLECMDID_SAVE -> Prelude.return (3)
     OLECMDID_SAVEAS -> Prelude.return (4)
     OLECMDID_SAVECOPYAS -> Prelude.return (5)
     OLECMDID_PRINT -> Prelude.return (6)
     OLECMDID_PRINTPREVIEW -> Prelude.return (7)
     OLECMDID_PAGESETUP -> Prelude.return (8)
     OLECMDID_SPELL -> Prelude.return (9)
     OLECMDID_PROPERTIES -> Prelude.return (10)
     OLECMDID_CUT -> Prelude.return (11)
     OLECMDID_COPY -> Prelude.return (12)
     OLECMDID_PASTE -> Prelude.return (13)
     OLECMDID_PASTESPECIAL -> Prelude.return (14)
     OLECMDID_UNDO -> Prelude.return (15)
     OLECMDID_REDO -> Prelude.return (16)
     OLECMDID_SELECTALL -> Prelude.return (17)
     OLECMDID_CLEARSELECTION -> Prelude.return (18)
     OLECMDID_ZOOM -> Prelude.return (19)
     OLECMDID_GETZOOMRANGE -> Prelude.return (20)
     OLECMDID_UPDATECOMMANDS -> Prelude.return (21)
     OLECMDID_REFRESH -> Prelude.return (22)
     OLECMDID_STOP -> Prelude.return (23)
     OLECMDID_HIDETOOLBARS -> Prelude.return (24)
     OLECMDID_SETPROGRESSMAX -> Prelude.return (25)
     OLECMDID_SETPROGRESSPOS -> Prelude.return (26)
     OLECMDID_SETPROGRESSTEXT -> Prelude.return (27)
     OLECMDID_SETTITLE -> Prelude.return (28)
     OLECMDID_SETDOWNLOADSTATE -> Prelude.return (29)
     OLECMDID_STOPDOWNLOAD -> Prelude.return (30)
     OLECMDID_ONTOOLBARACTIVATED -> Prelude.return (31)
     OLECMDID_FIND -> Prelude.return (32)
     OLECMDID_DELETE -> Prelude.return (33)
     OLECMDID_HTTPEQUIV -> Prelude.return (34)
     OLECMDID_HTTPEQUIV_DONE -> Prelude.return (35)
     OLECMDID_ENABLE_INTERACTION -> Prelude.return (36)
     OLECMDID_ONUNLOAD -> Prelude.return (37)
     OLECMDID_PROPERTYBAG2 -> Prelude.return (38)
     OLECMDID_PREREFRESH -> Prelude.return (39)
unmarshallOLECMDID :: Int.Int16 -> Prelude.IO OLECMDID
unmarshallOLECMDID v =
  case v of
     1 -> Prelude.return (OLECMDID_OPEN)
     2 -> Prelude.return (OLECMDID_NEW)
     3 -> Prelude.return (OLECMDID_SAVE)
     4 -> Prelude.return (OLECMDID_SAVEAS)
     5 -> Prelude.return (OLECMDID_SAVECOPYAS)
     6 -> Prelude.return (OLECMDID_PRINT)
     7 -> Prelude.return (OLECMDID_PRINTPREVIEW)
     8 -> Prelude.return (OLECMDID_PAGESETUP)
     9 -> Prelude.return (OLECMDID_SPELL)
     10 -> Prelude.return (OLECMDID_PROPERTIES)
     11 -> Prelude.return (OLECMDID_CUT)
     12 -> Prelude.return (OLECMDID_COPY)
     13 -> Prelude.return (OLECMDID_PASTE)
     14 -> Prelude.return (OLECMDID_PASTESPECIAL)
     15 -> Prelude.return (OLECMDID_UNDO)
     16 -> Prelude.return (OLECMDID_REDO)
     17 -> Prelude.return (OLECMDID_SELECTALL)
     18 -> Prelude.return (OLECMDID_CLEARSELECTION)
     19 -> Prelude.return (OLECMDID_ZOOM)
     20 -> Prelude.return (OLECMDID_GETZOOMRANGE)
     21 -> Prelude.return (OLECMDID_UPDATECOMMANDS)
     22 -> Prelude.return (OLECMDID_REFRESH)
     23 -> Prelude.return (OLECMDID_STOP)
     24 -> Prelude.return (OLECMDID_HIDETOOLBARS)
     25 -> Prelude.return (OLECMDID_SETPROGRESSMAX)
     26 -> Prelude.return (OLECMDID_SETPROGRESSPOS)
     27 -> Prelude.return (OLECMDID_SETPROGRESSTEXT)
     28 -> Prelude.return (OLECMDID_SETTITLE)
     29 -> Prelude.return (OLECMDID_SETDOWNLOADSTATE)
     30 -> Prelude.return (OLECMDID_STOPDOWNLOAD)
     31 -> Prelude.return (OLECMDID_ONTOOLBARACTIVATED)
     32 -> Prelude.return (OLECMDID_FIND)
     33 -> Prelude.return (OLECMDID_DELETE)
     34 -> Prelude.return (OLECMDID_HTTPEQUIV)
     35 -> Prelude.return (OLECMDID_HTTPEQUIV_DONE)
     36 -> Prelude.return (OLECMDID_ENABLE_INTERACTION)
     37 -> Prelude.return (OLECMDID_ONUNLOAD)
     38 -> Prelude.return (OLECMDID_PROPERTYBAG2)
     39 -> Prelude.return (OLECMDID_PREREFRESH)
     _ -> Prelude.fail (Prelude.userError "unmarshallOLECMDID: illegal enum value ")
data OLECMDF
 = OLECMDF_SUPPORTED
 | OLECMDF_ENABLED
 | OLECMDF_LATCHED
 | OLECMDF_NINCHED
 
marshallOLECMDF :: OLECMDF -> Prelude.IO Int.Int16
marshallOLECMDF v =
  case v of
     OLECMDF_SUPPORTED -> Prelude.return (1)
     OLECMDF_ENABLED -> Prelude.return (2)
     OLECMDF_LATCHED -> Prelude.return (4)
     OLECMDF_NINCHED -> Prelude.return (8)
unmarshallOLECMDF :: Int.Int16 -> Prelude.IO OLECMDF
unmarshallOLECMDF v =
  case v of
     1 -> Prelude.return (OLECMDF_SUPPORTED)
     2 -> Prelude.return (OLECMDF_ENABLED)
     4 -> Prelude.return (OLECMDF_LATCHED)
     8 -> Prelude.return (OLECMDF_NINCHED)
     _ -> Prelude.fail (Prelude.userError "unmarshallOLECMDF: illegal enum value ")
data OLECMDEXECOPT
 = OLECMDEXECOPT_DODEFAULT
 | OLECMDEXECOPT_PROMPTUSER
 | OLECMDEXECOPT_DONTPROMPTUSER
 | OLECMDEXECOPT_SHOWHELP
 
marshallOLECMDEXECOPT :: OLECMDEXECOPT -> Prelude.IO Int.Int16
marshallOLECMDEXECOPT v =
  case v of
     OLECMDEXECOPT_DODEFAULT -> Prelude.return (0)
     OLECMDEXECOPT_PROMPTUSER -> Prelude.return (1)
     OLECMDEXECOPT_DONTPROMPTUSER -> Prelude.return (2)
     OLECMDEXECOPT_SHOWHELP -> Prelude.return (3)
unmarshallOLECMDEXECOPT :: Int.Int16 -> Prelude.IO OLECMDEXECOPT
unmarshallOLECMDEXECOPT v =
  case v of
     0 -> Prelude.return (OLECMDEXECOPT_DODEFAULT)
     1 -> Prelude.return (OLECMDEXECOPT_PROMPTUSER)
     2 -> Prelude.return (OLECMDEXECOPT_DONTPROMPTUSER)
     3 -> Prelude.return (OLECMDEXECOPT_SHOWHELP)
     _ -> Prelude.fail (Prelude.userError "unmarshallOLECMDEXECOPT: illegal enum value ")
data TagREADYSTATE
 = READYSTATE_UNINITIALIZED
 | READYSTATE_LOADING
 | READYSTATE_LOADED
 | READYSTATE_INTERACTIVE
 | READYSTATE_COMPLETE
 
marshallTagREADYSTATE :: TagREADYSTATE -> Prelude.IO Int.Int16
marshallTagREADYSTATE v =
  case v of
     READYSTATE_UNINITIALIZED -> Prelude.return (0)
     READYSTATE_LOADING -> Prelude.return (1)
     READYSTATE_LOADED -> Prelude.return (2)
     READYSTATE_INTERACTIVE -> Prelude.return (3)
     READYSTATE_COMPLETE -> Prelude.return (4)
unmarshallTagREADYSTATE :: Int.Int16 -> Prelude.IO TagREADYSTATE
unmarshallTagREADYSTATE v =
  case v of
     0 -> Prelude.return (READYSTATE_UNINITIALIZED)
     1 -> Prelude.return (READYSTATE_LOADING)
     2 -> Prelude.return (READYSTATE_LOADED)
     3 -> Prelude.return (READYSTATE_INTERACTIVE)
     4 -> Prelude.return (READYSTATE_COMPLETE)
     _ -> Prelude.fail (Prelude.userError "unmarshallTagREADYSTATE: illegal enum value ")
-- --------------------------------------------------
-- 
-- interface IWebBrowser2
-- 
-- --------------------------------------------------
data WebBrowser2 a = WebBrowser2
                      
type IWebBrowser2 a = IWebBrowserApp (WebBrowser2 a)
iidIWebBrowser2 :: Com.IID (IWebBrowser2 Automation.Interface)
iidIWebBrowser2 =
  Com.mkIID "{D30C1661-CDAF-11D0-8A3E-00C04FC9E26E}"
goBack1 :: IWebBrowser2 a -> Prelude.IO ()
goBack1 = Automation.method0 "GoBack" []
goForward1 :: IWebBrowser2 a -> Prelude.IO ()
goForward1 = Automation.method0 "GoForward" []
goHome1 :: IWebBrowser2 a -> Prelude.IO ()
goHome1 = Automation.method0 "GoHome" []
goSearch1 :: IWebBrowser2 a -> Prelude.IO ()
goSearch1 = Automation.method0 "GoSearch" []
navigate1 :: Prelude.String -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> IWebBrowser2 a -> Prelude.IO ()
navigate1 uRL flags targetFrameName postData headers =
  Automation.method0 "Navigate" [Automation.inString uRL, Automation.inInt flags, Automation.inInt targetFrameName, Automation.inInt postData, Automation.inInt headers]
refresh1 :: IWebBrowser2 a -> Prelude.IO ()
refresh1 = Automation.method0 "Refresh" []
refresh21 :: Prelude.Int -> IWebBrowser2 a -> Prelude.IO ()
refresh21 level =
  Automation.method0 "Refresh2" [Automation.inInt level]
stop1 :: IWebBrowser2 a -> Prelude.IO ()
stop1 = Automation.method0 "Stop" []
getApplication1 :: IWebBrowser2 a -> Prelude.IO (Automation.IDispatch Automation.Interface)
getApplication1 =
  Automation.propertyGet "Application" [] Automation.outIDispatch
getParent1 :: IWebBrowser2 a -> Prelude.IO (Automation.IDispatch Automation.Interface)
getParent1 =
  Automation.propertyGet "Parent" [] Automation.outIDispatch
getContainer1 :: IWebBrowser2 a -> Prelude.IO (Automation.IDispatch Automation.Interface)
getContainer1 =
  Automation.propertyGet "Container" [] Automation.outIDispatch
getDocument1 :: IWebBrowser2 a -> Prelude.IO (Automation.IDispatch Automation.Interface)
getDocument1 =
  Automation.propertyGet "Document" [] Automation.outIDispatch
getTopLevelContainer1 :: IWebBrowser2 a -> Prelude.IO (Prelude.Int)
getTopLevelContainer1 =
  Automation.propertyGet "TopLevelContainer" [] Automation.outInt
getType1 :: IWebBrowser2 a -> Prelude.IO (Prelude.String)
getType1 = Automation.propertyGet "Type" [] Automation.outString
getLeft1 :: IWebBrowser2 a -> Prelude.IO (Prelude.Int)
getLeft1 = Automation.propertyGet "Left" [] Automation.outInt
setLeft1 :: Prelude.Int -> IWebBrowser2 a -> Prelude.IO ()
setLeft1 pl = Automation.propertySet "Left" [Automation.inInt pl]
getTop1 :: IWebBrowser2 a -> Prelude.IO (Prelude.Int)
getTop1 = Automation.propertyGet "Top" [] Automation.outInt
setTop1 :: Prelude.Int -> IWebBrowser2 a -> Prelude.IO ()
setTop1 pl = Automation.propertySet "Top" [Automation.inInt pl]
getWidth1 :: IWebBrowser2 a -> Prelude.IO (Prelude.Int)
getWidth1 = Automation.propertyGet "Width" [] Automation.outInt
setWidth1 :: Prelude.Int -> IWebBrowser2 a -> Prelude.IO ()
setWidth1 pl = Automation.propertySet "Width" [Automation.inInt pl]
getHeight1 :: IWebBrowser2 a -> Prelude.IO (Prelude.Int)
getHeight1 = Automation.propertyGet "Height" [] Automation.outInt
setHeight1 :: Prelude.Int -> IWebBrowser2 a -> Prelude.IO ()
setHeight1 pl =
  Automation.propertySet "Height" [Automation.inInt pl]
getLocationName1 :: IWebBrowser2 a -> Prelude.IO (Prelude.String)
getLocationName1 =
  Automation.propertyGet "LocationName" [] Automation.outString
getLocationURL1 :: IWebBrowser2 a -> Prelude.IO (Prelude.String)
getLocationURL1 =
  Automation.propertyGet "LocationURL" [] Automation.outString
getBusy1 :: IWebBrowser2 a -> Prelude.IO (Prelude.Int)
getBusy1 = Automation.propertyGet "Busy" [] Automation.outInt
quit1 :: IWebBrowser2 a -> Prelude.IO ()
quit1 = Automation.method0 "Quit" []
clientToWindow0 :: Prelude.Int -> Prelude.Int -> IWebBrowser2 a -> Prelude.IO (Prelude.Int, Prelude.Int)
clientToWindow0 pcx pcy =
  Automation.method2 "ClientToWindow" [] (Automation.inoutInt pcx) (Automation.inoutInt pcy)
putProperty0 :: Prelude.String -> Prelude.Int -> IWebBrowser2 a -> Prelude.IO ()
putProperty0 property vtValue =
  Automation.method0 "PutProperty" [Automation.inString property, Automation.inInt vtValue]
getProperty0 :: Prelude.String -> IWebBrowser2 a -> Prelude.IO (Prelude.Int)
getProperty0 property =
  Automation.function1 "GetProperty" [Automation.inString property] Automation.outInt
getName0 :: IWebBrowser2 a -> Prelude.IO (Prelude.String)
getName0 = Automation.propertyGet "Name" [] Automation.outString
getHWND0 :: IWebBrowser2 a -> Prelude.IO (Prelude.Int)
getHWND0 = Automation.propertyGet "HWND" [] Automation.outInt
getFullName0 :: IWebBrowser2 a -> Prelude.IO (Prelude.String)
getFullName0 =
  Automation.propertyGet "FullName" [] Automation.outString
getPath0 :: IWebBrowser2 a -> Prelude.IO (Prelude.String)
getPath0 = Automation.propertyGet "Path" [] Automation.outString
getVisible0 :: IWebBrowser2 a -> Prelude.IO (Prelude.Int)
getVisible0 = Automation.propertyGet "Visible" [] Automation.outInt
setVisible0 :: Prelude.Int -> IWebBrowser2 a -> Prelude.IO ()
setVisible0 pBool =
  Automation.propertySet "Visible" [Automation.inInt pBool]
getStatusBar0 :: IWebBrowser2 a -> Prelude.IO (Prelude.Int)
getStatusBar0 =
  Automation.propertyGet "StatusBar" [] Automation.outInt
setStatusBar0 :: Prelude.Int -> IWebBrowser2 a -> Prelude.IO ()
setStatusBar0 pBool =
  Automation.propertySet "StatusBar" [Automation.inInt pBool]
getStatusText0 :: IWebBrowser2 a -> Prelude.IO (Prelude.String)
getStatusText0 =
  Automation.propertyGet "StatusText" [] Automation.outString
setStatusText0 :: Prelude.String -> IWebBrowser2 a -> Prelude.IO ()
setStatusText0 statusText =
  Automation.propertySet "StatusText" [Automation.inString statusText]
getToolBar0 :: IWebBrowser2 a -> Prelude.IO (Prelude.Int)
getToolBar0 = Automation.propertyGet "ToolBar" [] Automation.outInt
setToolBar0 :: Prelude.Int -> IWebBrowser2 a -> Prelude.IO ()
setToolBar0 value =
  Automation.propertySet "ToolBar" [Automation.inInt value]
getMenuBar0 :: IWebBrowser2 a -> Prelude.IO (Prelude.Int)
getMenuBar0 = Automation.propertyGet "MenuBar" [] Automation.outInt
setMenuBar0 :: Prelude.Int -> IWebBrowser2 a -> Prelude.IO ()
setMenuBar0 value =
  Automation.propertySet "MenuBar" [Automation.inInt value]
getFullScreen0 :: IWebBrowser2 a -> Prelude.IO (Prelude.Int)
getFullScreen0 =
  Automation.propertyGet "FullScreen" [] Automation.outInt
setFullScreen0 :: Prelude.Int -> IWebBrowser2 a -> Prelude.IO ()
setFullScreen0 pbFullScreen =
  Automation.propertySet "FullScreen" [Automation.inInt pbFullScreen]
navigate2 :: Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> IWebBrowser2 a -> Prelude.IO ()
navigate2 uRL flags targetFrameName postData headers =
  Automation.method0 "Navigate2" [Automation.inInt uRL, Automation.inInt flags, Automation.inInt targetFrameName, Automation.inInt postData, Automation.inInt headers]
queryStatusWB :: (Automation.Variant a0, Automation.Variant a1) => a0 -> IWebBrowser2 a -> Prelude.IO (a1)
queryStatusWB cmdID =
  Automation.function1 "QueryStatusWB" [Automation.inVariant cmdID] Automation.outVariant
execWB :: (Automation.Variant a0, Automation.Variant a1) => a0 -> a1 -> Prelude.Int -> Prelude.Int -> IWebBrowser2 a -> Prelude.IO (Prelude.Int)
execWB cmdID cmdexecopt pvaIn pvaOut =
  Automation.method1 "ExecWB" [Automation.inVariant cmdID, Automation.inVariant cmdexecopt, Automation.inInt pvaIn] (Automation.inoutInt pvaOut)
showBrowserBar :: Prelude.Int -> Prelude.Int -> Prelude.Int -> IWebBrowser2 a -> Prelude.IO ()
showBrowserBar pvaClsid pvarShow pvarSize =
  Automation.method0 "ShowBrowserBar" [Automation.inInt pvaClsid, Automation.inInt pvarShow, Automation.inInt pvarSize]
getReadyState :: (Automation.Variant a0) => IWebBrowser2 a -> Prelude.IO (a0)
getReadyState =
  Automation.propertyGet "ReadyState" [] Automation.outVariant
getOffline :: IWebBrowser2 a -> Prelude.IO (Prelude.Int)
getOffline = Automation.propertyGet "Offline" [] Automation.outInt
setOffline :: Prelude.Int -> IWebBrowser2 a -> Prelude.IO ()
setOffline pbOffline =
  Automation.propertySet "Offline" [Automation.inInt pbOffline]
getSilent :: IWebBrowser2 a -> Prelude.IO (Prelude.Int)
getSilent = Automation.propertyGet "Silent" [] Automation.outInt
setSilent :: Prelude.Int -> IWebBrowser2 a -> Prelude.IO ()
setSilent pbSilent =
  Automation.propertySet "Silent" [Automation.inInt pbSilent]
getRegisterAsBrowser :: IWebBrowser2 a -> Prelude.IO (Prelude.Int)
getRegisterAsBrowser =
  Automation.propertyGet "RegisterAsBrowser" [] Automation.outInt
setRegisterAsBrowser :: Prelude.Int -> IWebBrowser2 a -> Prelude.IO ()
setRegisterAsBrowser pbRegister =
  Automation.propertySet "RegisterAsBrowser" [Automation.inInt pbRegister]
getRegisterAsDropTarget :: IWebBrowser2 a -> Prelude.IO (Prelude.Int)
getRegisterAsDropTarget =
  Automation.propertyGet "RegisterAsDropTarget" [] Automation.outInt
setRegisterAsDropTarget :: Prelude.Int -> IWebBrowser2 a -> Prelude.IO ()
setRegisterAsDropTarget pbRegister =
  Automation.propertySet "RegisterAsDropTarget" [Automation.inInt pbRegister]
getTheaterMode :: IWebBrowser2 a -> Prelude.IO (Prelude.Int)
getTheaterMode =
  Automation.propertyGet "TheaterMode" [] Automation.outInt
setTheaterMode :: Prelude.Int -> IWebBrowser2 a -> Prelude.IO ()
setTheaterMode pbRegister =
  Automation.propertySet "TheaterMode" [Automation.inInt pbRegister]
getAddressBar :: IWebBrowser2 a -> Prelude.IO (Prelude.Int)
getAddressBar =
  Automation.propertyGet "AddressBar" [] Automation.outInt
setAddressBar :: Prelude.Int -> IWebBrowser2 a -> Prelude.IO ()
setAddressBar value =
  Automation.propertySet "AddressBar" [Automation.inInt value]
getResizable :: IWebBrowser2 a -> Prelude.IO (Prelude.Int)
getResizable =
  Automation.propertyGet "Resizable" [] Automation.outInt
setResizable :: Prelude.Int -> IWebBrowser2 a -> Prelude.IO ()
setResizable value =
  Automation.propertySet "Resizable" [Automation.inInt value]
-- --------------------------------------------------
-- 
-- dispinterface DWebBrowserEvents2
-- 
-- --------------------------------------------------
data WebBrowserEvents2 a = WebBrowserEvents2
                            
type DWebBrowserEvents2 a = Automation.IDispatch (WebBrowserEvents2 a)
iidDWebBrowserEvents2 :: Com.IID (DWebBrowserEvents2 Automation.Interface)
iidDWebBrowserEvents2 =
  Com.mkIID "{34A715A0-6587-11D0-924A-0020AFC7AC4D}"
statusTextChange0 :: Prelude.String -> DWebBrowserEvents2 a -> Prelude.IO ()
statusTextChange0 text =
  Automation.method0 "StatusTextChange" [Automation.inString text]
progressChange0 :: Prelude.Int -> Prelude.Int -> DWebBrowserEvents2 a -> Prelude.IO ()
progressChange0 progress progressMax =
  Automation.method0 "ProgressChange" [Automation.inInt progress, Automation.inInt progressMax]
commandStateChange0 :: Prelude.Int -> Prelude.Int -> DWebBrowserEvents2 a -> Prelude.IO ()
commandStateChange0 command enable =
  Automation.method0 "CommandStateChange" [Automation.inInt command, Automation.inInt enable]
downloadBegin0 :: DWebBrowserEvents2 a -> Prelude.IO ()
downloadBegin0 = Automation.method0 "DownloadBegin" []
downloadComplete0 :: DWebBrowserEvents2 a -> Prelude.IO ()
downloadComplete0 = Automation.method0 "DownloadComplete" []
titleChange0 :: Prelude.String -> DWebBrowserEvents2 a -> Prelude.IO ()
titleChange0 text =
  Automation.method0 "TitleChange" [Automation.inString text]
propertyChange0 :: Prelude.String -> DWebBrowserEvents2 a -> Prelude.IO ()
propertyChange0 szProperty =
  Automation.method0 "PropertyChange" [Automation.inString szProperty]
beforeNavigate2 :: Automation.IDispatch a0 -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> DWebBrowserEvents2 a -> Prelude.IO (Prelude.Int)
beforeNavigate2 pDisp uRL flags targetFrameName postData headers cancel =
  Automation.method1 "BeforeNavigate2" [Automation.inIDispatch pDisp, Automation.inInt uRL, Automation.inInt flags, Automation.inInt targetFrameName, Automation.inInt postData, Automation.inInt headers] (Automation.inoutInt cancel)
newWindow2 :: Automation.IDispatch a0 -> Prelude.Int -> DWebBrowserEvents2 a -> Prelude.IO (Automation.IDispatch a0, Prelude.Int)
newWindow2 ppDisp cancel =
  Automation.method2 "NewWindow2" [] (Automation.inoutIDispatch ppDisp) (Automation.inoutInt cancel)
navigateComplete2 :: Automation.IDispatch a0 -> Prelude.Int -> DWebBrowserEvents2 a -> Prelude.IO ()
navigateComplete2 pDisp uRL =
  Automation.method0 "NavigateComplete2" [Automation.inIDispatch pDisp, Automation.inInt uRL]
documentComplete :: Automation.IDispatch a0 -> Prelude.Int -> DWebBrowserEvents2 a -> Prelude.IO ()
documentComplete pDisp uRL =
  Automation.method0 "DocumentComplete" [Automation.inIDispatch pDisp, Automation.inInt uRL]
onQuit :: DWebBrowserEvents2 a -> Prelude.IO ()
onQuit = Automation.method0 "OnQuit" []
onVisible :: Prelude.Int -> DWebBrowserEvents2 a -> Prelude.IO ()
onVisible visible =
  Automation.method0 "OnVisible" [Automation.inInt visible]
onToolBar :: Prelude.Int -> DWebBrowserEvents2 a -> Prelude.IO ()
onToolBar toolBar =
  Automation.method0 "OnToolBar" [Automation.inInt toolBar]
onMenuBar :: Prelude.Int -> DWebBrowserEvents2 a -> Prelude.IO ()
onMenuBar menuBar =
  Automation.method0 "OnMenuBar" [Automation.inInt menuBar]
onStatusBar :: Prelude.Int -> DWebBrowserEvents2 a -> Prelude.IO ()
onStatusBar statusBar =
  Automation.method0 "OnStatusBar" [Automation.inInt statusBar]
onFullScreen :: Prelude.Int -> DWebBrowserEvents2 a -> Prelude.IO ()
onFullScreen fullScreen =
  Automation.method0 "OnFullScreen" [Automation.inInt fullScreen]
onTheaterMode :: Prelude.Int -> DWebBrowserEvents2 a -> Prelude.IO ()
onTheaterMode theaterMode =
  Automation.method0 "OnTheaterMode" [Automation.inInt theaterMode]
-- --------------------------------------------------
-- 
-- coclass WebBrowser_V1
-- 
-- --------------------------------------------------
clsidWebBrowser_V1 :: Com.CLSID
clsidWebBrowser_V1 =
  Com.mkCLSID "{EAB22AC3-30C1-11CF-A7EB-0000C05BAE0B}"
-- --------------------------------------------------
-- 
-- coclass WebBrowser
-- 
-- --------------------------------------------------
clsidWebBrowser :: Com.CLSID
clsidWebBrowser =
  Com.mkCLSID "{8856F961-340A-11D0-A96B-00C04FD705A2}"
-- --------------------------------------------------
-- 
-- coclass InternetExplorer
-- 
-- --------------------------------------------------
clsidInternetExplorer :: Com.CLSID
clsidInternetExplorer =
  Com.mkCLSID "{0002DF01-0000-0000-C000-000000000046}"
-- --------------------------------------------------
-- 
-- interface IFolderViewOC
-- 
-- --------------------------------------------------
data FolderViewOC a = FolderViewOC
                       
type IFolderViewOC a = Automation.IDispatch (FolderViewOC a)
iidIFolderViewOC :: Com.IID (IFolderViewOC Automation.Interface)
iidIFolderViewOC =
  Com.mkIID "{9BA05970-F6A8-11CF-A442-00A0C90A8F39}"
setFolderView :: Automation.IDispatch a0 -> IFolderViewOC a -> Prelude.IO ()
setFolderView pDisp =
  Automation.method0 "SetFolderView" [Automation.inIDispatch pDisp]
-- --------------------------------------------------
-- 
-- dispinterface DShellFolderViewEvents
-- 
-- --------------------------------------------------
data ShellFolderViewEvents a = ShellFolderViewEvents
                                
type DShellFolderViewEvents a = Automation.IDispatch (ShellFolderViewEvents a)
iidDShellFolderViewEvents :: Com.IID (DShellFolderViewEvents Automation.Interface)
iidDShellFolderViewEvents =
  Com.mkIID "{62112AA2-EBE4-11CF-A5FB-0020AFE7292D}"
selectionChanged :: DShellFolderViewEvents a -> Prelude.IO ()
selectionChanged = Automation.method0 "SelectionChanged" []
-- --------------------------------------------------
-- 
-- coclass ShellFolderViewOC
-- 
-- --------------------------------------------------
clsidShellFolderViewOC :: Com.CLSID
clsidShellFolderViewOC =
  Com.mkCLSID "{9BA05971-F6A8-11CF-A442-00A0C90A8F39}"
data ShellWindowTypeConstants
 = SWC_EXPLORER
 | SWC_BROWSER
 | SWC_3RDPARTY
 | SWC_CALLBACK
 
marshallShellWindowTypeConstants :: ShellWindowTypeConstants -> Prelude.IO Int.Int16
marshallShellWindowTypeConstants v =
  case v of
     SWC_EXPLORER -> Prelude.return (0)
     SWC_BROWSER -> Prelude.return (1)
     SWC_3RDPARTY -> Prelude.return (2)
     SWC_CALLBACK -> Prelude.return (4)
unmarshallShellWindowTypeConstants :: Int.Int16 -> Prelude.IO ShellWindowTypeConstants
unmarshallShellWindowTypeConstants v =
  case v of
     0 -> Prelude.return (SWC_EXPLORER)
     1 -> Prelude.return (SWC_BROWSER)
     2 -> Prelude.return (SWC_3RDPARTY)
     4 -> Prelude.return (SWC_CALLBACK)
     _ -> Prelude.fail (Prelude.userError "unmarshallShellWindowTypeConstants: illegal enum value ")
data ShellWindowFindWindowOptions
 = SWFO_NEEDDISPATCH
 | SWFO_INCLUDEPENDING
 | SWFO_COOKIEPASSED
 
marshallShellWindowFindWindowOptions :: ShellWindowFindWindowOptions -> Prelude.IO Int.Int16
marshallShellWindowFindWindowOptions v =
  case v of
     SWFO_NEEDDISPATCH -> Prelude.return (1)
     SWFO_INCLUDEPENDING -> Prelude.return (2)
     SWFO_COOKIEPASSED -> Prelude.return (4)
unmarshallShellWindowFindWindowOptions :: Int.Int16 -> Prelude.IO ShellWindowFindWindowOptions
unmarshallShellWindowFindWindowOptions v =
  case v of
     1 -> Prelude.return (SWFO_NEEDDISPATCH)
     2 -> Prelude.return (SWFO_INCLUDEPENDING)
     4 -> Prelude.return (SWFO_COOKIEPASSED)
     _ -> Prelude.fail (Prelude.userError "unmarshallShellWindowFindWindowOptions: illegal enum value ")
-- --------------------------------------------------
-- 
-- dispinterface DShellWindowsEvents
-- 
-- --------------------------------------------------
data ShellWindowsEvents a = ShellWindowsEvents
                             
type DShellWindowsEvents a = Automation.IDispatch (ShellWindowsEvents a)
iidDShellWindowsEvents :: Com.IID (DShellWindowsEvents Automation.Interface)
iidDShellWindowsEvents =
  Com.mkIID "{FE4106E0-399A-11D0-A48C-00A0C90A8F39}"
windowRegistered :: Prelude.Int -> DShellWindowsEvents a -> Prelude.IO ()
windowRegistered lCookie =
  Automation.method0 "WindowRegistered" [Automation.inInt lCookie]
windowRevoked :: Prelude.Int -> DShellWindowsEvents a -> Prelude.IO ()
windowRevoked lCookie =
  Automation.method0 "WindowRevoked" [Automation.inInt lCookie]
-- --------------------------------------------------
-- 
-- interface IShellWindows
-- 
-- --------------------------------------------------
data ShellWindows a = ShellWindows
                       
type IShellWindows a = Automation.IDispatch (ShellWindows a)
iidIShellWindows :: Com.IID (IShellWindows Automation.Interface)
iidIShellWindows =
  Com.mkIID "{85CB6900-4D95-11CF-960C-0080C7F4EE85}"
getCount :: IShellWindows a -> Prelude.IO (Prelude.Int)
getCount = Automation.propertyGet "Count" [] Automation.outInt
item :: Prelude.Int -> IShellWindows a -> Prelude.IO (Automation.IDispatch Automation.Interface)
item index =
  Automation.function1 "Item" [Automation.inInt index] Automation.outIDispatch
newEnum :: IShellWindows a -> Prelude.IO (Com.IUnknown Automation.Interface)
newEnum = Automation.function1 "_NewEnum" [] Automation.outIUnknown
register :: Automation.IDispatch a0 -> Prelude.Int -> Prelude.Int -> IShellWindows a -> Prelude.IO (Prelude.Int)
register pid hWND swClass =
  Automation.method1 "Register" [Automation.inIDispatch pid, Automation.inInt hWND, Automation.inInt swClass] Automation.outInt
registerPending :: Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> IShellWindows a -> Prelude.IO (Prelude.Int)
registerPending lThreadId pvarloc pvarlocRoot swClass =
  Automation.method1 "RegisterPending" [Automation.inInt lThreadId, Automation.inInt pvarloc, Automation.inInt pvarlocRoot, Automation.inInt swClass] Automation.outInt
revoke :: Prelude.Int -> IShellWindows a -> Prelude.IO ()
revoke lCookie =
  Automation.method0 "Revoke" [Automation.inInt lCookie]
onNavigate :: Prelude.Int -> Prelude.Int -> IShellWindows a -> Prelude.IO ()
onNavigate lCookie pvarloc =
  Automation.method0 "OnNavigate" [Automation.inInt lCookie, Automation.inInt pvarloc]
onActivated :: Prelude.Int -> Prelude.Int -> IShellWindows a -> Prelude.IO ()
onActivated lCookie fActive =
  Automation.method0 "OnActivated" [Automation.inInt lCookie, Automation.inInt fActive]
findWindow :: Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> IShellWindows a -> Prelude.IO (Prelude.Int, Automation.IDispatch Automation.Interface)
findWindow pvarloc pvarlocRoot swClass swfwOptions =
  Automation.function2 "FindWindow" [Automation.inInt pvarloc, Automation.inInt pvarlocRoot, Automation.inInt swClass, Automation.inInt swfwOptions] Automation.outInt Automation.outIDispatch
onCreated :: Prelude.Int -> Com.IUnknown a0 -> IShellWindows a -> Prelude.IO ()
onCreated lCookie punk =
  Automation.method0 "OnCreated" [Automation.inInt lCookie, Automation.inIUnknown punk]
processAttachDetach :: Prelude.Int -> IShellWindows a -> Prelude.IO ()
processAttachDetach fAttach =
  Automation.method0 "ProcessAttachDetach" [Automation.inInt fAttach]
-- --------------------------------------------------
-- 
-- coclass ShellWindows
-- 
-- --------------------------------------------------
clsidShellWindows :: Com.CLSID
clsidShellWindows =
  Com.mkCLSID "{9BA05972-F6A8-11CF-A442-00A0C90A8F39}"
-- --------------------------------------------------
-- 
-- interface IShellLinkDual
-- 
-- --------------------------------------------------
data ShellLinkDual a = ShellLinkDual
                        
type IShellLinkDual a = Automation.IDispatch (ShellLinkDual a)
iidIShellLinkDual :: Com.IID (IShellLinkDual Automation.Interface)
iidIShellLinkDual =
  Com.mkIID "{88A05C00-F000-11CE-8350-444553540000}"
getPath1 :: IShellLinkDual a -> Prelude.IO (Prelude.String)
getPath1 = Automation.propertyGet "Path" [] Automation.outString
setPath :: Prelude.String -> IShellLinkDual a -> Prelude.IO ()
setPath pbs =
  Automation.propertySet "Path" [Automation.inString pbs]
getDescription :: IShellLinkDual a -> Prelude.IO (Prelude.String)
getDescription =
  Automation.propertyGet "Description" [] Automation.outString
setDescription :: Prelude.String -> IShellLinkDual a -> Prelude.IO ()
setDescription pbs =
  Automation.propertySet "Description" [Automation.inString pbs]
getWorkingDirectory :: IShellLinkDual a -> Prelude.IO (Prelude.String)
getWorkingDirectory =
  Automation.propertyGet "WorkingDirectory" [] Automation.outString
setWorkingDirectory :: Prelude.String -> IShellLinkDual a -> Prelude.IO ()
setWorkingDirectory pbs =
  Automation.propertySet "WorkingDirectory" [Automation.inString pbs]
getArguments :: IShellLinkDual a -> Prelude.IO (Prelude.String)
getArguments =
  Automation.propertyGet "Arguments" [] Automation.outString
setArguments :: Prelude.String -> IShellLinkDual a -> Prelude.IO ()
setArguments pbs =
  Automation.propertySet "Arguments" [Automation.inString pbs]
getHotkey :: IShellLinkDual a -> Prelude.IO (Prelude.Int)
getHotkey = Automation.propertyGet "Hotkey" [] Automation.outInt
setHotkey :: Prelude.Int -> IShellLinkDual a -> Prelude.IO ()
setHotkey piHK =
  Automation.propertySet "Hotkey" [Automation.inInt piHK]
getShowCommand :: IShellLinkDual a -> Prelude.IO (Prelude.Int)
getShowCommand =
  Automation.propertyGet "ShowCommand" [] Automation.outInt
setShowCommand :: Prelude.Int -> IShellLinkDual a -> Prelude.IO ()
setShowCommand piShowCommand =
  Automation.propertySet "ShowCommand" [Automation.inInt piShowCommand]
resolve :: Prelude.Int -> IShellLinkDual a -> Prelude.IO ()
resolve fFlags =
  Automation.method0 "Resolve" [Automation.inInt fFlags]
getIconLocation :: IShellLinkDual a -> Prelude.IO (Prelude.String, Prelude.Int)
getIconLocation =
  Automation.function2 "GetIconLocation" [] Automation.outString Automation.outInt
setIconLocation :: Prelude.String -> Prelude.Int -> IShellLinkDual a -> Prelude.IO ()
setIconLocation bs iIcon =
  Automation.method0 "SetIconLocation" [Automation.inString bs, Automation.inInt iIcon]
save :: Prelude.Int -> IShellLinkDual a -> Prelude.IO ()
save vWhere = Automation.method0 "Save" [Automation.inInt vWhere]
-- --------------------------------------------------
-- 
-- coclass ShellLinkObject
-- 
-- --------------------------------------------------
clsidShellLinkObject :: Com.CLSID
clsidShellLinkObject =
  Com.mkCLSID "{11219420-1768-11D1-95BE-00609797EA4F}"
-- --------------------------------------------------
-- 
-- interface FolderItemVerb
-- 
-- --------------------------------------------------
data FolderItemVerb a = FolderItemVerb
                         
type IFolderItemVerb a = Automation.IDispatch (FolderItemVerb a)
iidIFolderItemVerb :: Com.IID (IFolderItemVerb Automation.Interface)
iidIFolderItemVerb =
  Com.mkIID "{08EC3E00-50B0-11CF-960C-0080C7F4EE85}"
getApplication2 :: IFolderItemVerb a -> Prelude.IO (Automation.IDispatch Automation.Interface)
getApplication2 =
  Automation.propertyGet "Application" [] Automation.outIDispatch
getParent2 :: IFolderItemVerb a -> Prelude.IO (Automation.IDispatch Automation.Interface)
getParent2 =
  Automation.propertyGet "Parent" [] Automation.outIDispatch
getName1 :: IFolderItemVerb a -> Prelude.IO (Prelude.String)
getName1 = Automation.propertyGet "Name" [] Automation.outString
doIt :: IFolderItemVerb a -> Prelude.IO ()
doIt = Automation.method0 "DoIt" []
-- --------------------------------------------------
-- 
-- interface FolderItemVerbs
-- 
-- --------------------------------------------------
data FolderItemVerbs a = FolderItemVerbs
                          
type IFolderItemVerbs a = Automation.IDispatch (FolderItemVerbs a)
iidIFolderItemVerbs :: Com.IID (IFolderItemVerbs Automation.Interface)
iidIFolderItemVerbs =
  Com.mkIID "{1F8352C0-50B0-11CF-960C-0080C7F4EE85}"
getCount0 :: IFolderItemVerbs a -> Prelude.IO (Prelude.Int)
getCount0 = Automation.propertyGet "Count" [] Automation.outInt
getApplication3 :: IFolderItemVerbs a -> Prelude.IO (Automation.IDispatch Automation.Interface)
getApplication3 =
  Automation.propertyGet "Application" [] Automation.outIDispatch
getParent3 :: IFolderItemVerbs a -> Prelude.IO (Automation.IDispatch Automation.Interface)
getParent3 =
  Automation.propertyGet "Parent" [] Automation.outIDispatch
item0 :: Prelude.Int -> IFolderItemVerbs a -> Prelude.IO (IFolderItemVerb Automation.Interface)
item0 index =
  Automation.function1 "Item" [Automation.inInt index] Automation.outIDispatch
newEnum0 :: IFolderItemVerbs a -> Prelude.IO (Com.IUnknown Automation.Interface)
newEnum0 =
  Automation.function1 "_NewEnum" [] Automation.outIUnknown
-- --------------------------------------------------
-- 
-- interface Folder
-- 
-- --------------------------------------------------
data Folder a = Folder
                 
type IFolder a = Automation.IDispatch (Folder a)
iidIFolder :: Com.IID (IFolder Automation.Interface)
iidIFolder = Com.mkIID "{BBCBDE60-C3FF-11CE-8350-444553540000}"
getTitle :: IFolder a -> Prelude.IO (Prelude.String)
getTitle = Automation.propertyGet "Title" [] Automation.outString
getApplication4 :: IFolder a -> Prelude.IO (Automation.IDispatch Automation.Interface)
getApplication4 =
  Automation.propertyGet "Application" [] Automation.outIDispatch
getParent4 :: IFolder a -> Prelude.IO (Automation.IDispatch Automation.Interface)
getParent4 =
  Automation.propertyGet "Parent" [] Automation.outIDispatch
getParentFolder :: IFolder a -> Prelude.IO (IFolder Automation.Interface)
getParentFolder =
  Automation.propertyGet "ParentFolder" [] Automation.outIDispatch
items :: IFolder a -> Prelude.IO (IFolderItems Automation.Interface)
items = Automation.function1 "Items" [] Automation.outIDispatch
parseName :: Prelude.String -> IFolder a -> Prelude.IO (IFolderItem Automation.Interface)
parseName bName =
  Automation.function1 "ParseName" [Automation.inString bName] Automation.outIDispatch
newFolder :: Prelude.String -> Prelude.Int -> IFolder a -> Prelude.IO ()
newFolder bName vOptions =
  Automation.method0 "NewFolder" [Automation.inString bName, Automation.inInt vOptions]
moveHere :: Prelude.Int -> Prelude.Int -> IFolder a -> Prelude.IO ()
moveHere vItem vOptions =
  Automation.method0 "MoveHere" [Automation.inInt vItem, Automation.inInt vOptions]
copyHere :: Prelude.Int -> Prelude.Int -> IFolder a -> Prelude.IO ()
copyHere vItem vOptions =
  Automation.method0 "CopyHere" [Automation.inInt vItem, Automation.inInt vOptions]
getDetailsOf :: Prelude.Int -> Prelude.Int -> IFolder a -> Prelude.IO (Prelude.String)
getDetailsOf vItem iColumn =
  Automation.function1 "GetDetailsOf" [Automation.inInt vItem, Automation.inInt iColumn] Automation.outString
-- --------------------------------------------------
-- 
-- interface FolderItems
-- 
-- --------------------------------------------------
data FolderItems a = FolderItems
                      
type IFolderItems a = Automation.IDispatch (FolderItems a)
iidIFolderItems :: Com.IID (IFolderItems Automation.Interface)
iidIFolderItems =
  Com.mkIID "{744129E0-CBE5-11CE-8350-444553540000}"
getCount1 :: IFolderItems a -> Prelude.IO (Prelude.Int)
getCount1 = Automation.propertyGet "Count" [] Automation.outInt
getApplication5 :: IFolderItems a -> Prelude.IO (Automation.IDispatch Automation.Interface)
getApplication5 =
  Automation.propertyGet "Application" [] Automation.outIDispatch
getParent5 :: IFolderItems a -> Prelude.IO (Automation.IDispatch Automation.Interface)
getParent5 =
  Automation.propertyGet "Parent" [] Automation.outIDispatch
item1 :: Prelude.Int -> IFolderItems a -> Prelude.IO (IFolderItem Automation.Interface)
item1 index =
  Automation.function1 "Item" [Automation.inInt index] Automation.outIDispatch
newEnum1 :: IFolderItems a -> Prelude.IO (Com.IUnknown Automation.Interface)
newEnum1 =
  Automation.function1 "_NewEnum" [] Automation.outIUnknown
-- --------------------------------------------------
-- 
-- interface FolderItem
-- 
-- --------------------------------------------------
data FolderItem a = FolderItem
                     
type IFolderItem a = Automation.IDispatch (FolderItem a)
iidIFolderItem :: Com.IID (IFolderItem Automation.Interface)
iidIFolderItem = Com.mkIID "{FAC32C80-CBE4-11CE-8350-444553540000}"
getApplication6 :: IFolderItem a -> Prelude.IO (Automation.IDispatch Automation.Interface)
getApplication6 =
  Automation.propertyGet "Application" [] Automation.outIDispatch
getParent6 :: IFolderItem a -> Prelude.IO (Automation.IDispatch Automation.Interface)
getParent6 =
  Automation.propertyGet "Parent" [] Automation.outIDispatch
getName2 :: IFolderItem a -> Prelude.IO (Prelude.String)
getName2 = Automation.propertyGet "Name" [] Automation.outString
setName :: Prelude.String -> IFolderItem a -> Prelude.IO ()
setName pbs =
  Automation.propertySet "Name" [Automation.inString pbs]
getPath2 :: IFolderItem a -> Prelude.IO (Prelude.String)
getPath2 = Automation.propertyGet "Path" [] Automation.outString
getGetLink :: IFolderItem a -> Prelude.IO (Automation.IDispatch Automation.Interface)
getGetLink =
  Automation.propertyGet "GetLink" [] Automation.outIDispatch
getGetFolder :: IFolderItem a -> Prelude.IO (Automation.IDispatch Automation.Interface)
getGetFolder =
  Automation.propertyGet "GetFolder" [] Automation.outIDispatch
getIsLink :: IFolderItem a -> Prelude.IO (Prelude.Int)
getIsLink = Automation.propertyGet "IsLink" [] Automation.outInt
getIsFolder :: IFolderItem a -> Prelude.IO (Prelude.Int)
getIsFolder =
  Automation.propertyGet "IsFolder" [] Automation.outInt
getIsFileSystem :: IFolderItem a -> Prelude.IO (Prelude.Int)
getIsFileSystem =
  Automation.propertyGet "IsFileSystem" [] Automation.outInt
getIsBrowsable :: IFolderItem a -> Prelude.IO (Prelude.Int)
getIsBrowsable =
  Automation.propertyGet "IsBrowsable" [] Automation.outInt
getModifyDate :: IFolderItem a -> Prelude.IO (Automation.Date)
getModifyDate =
  Automation.propertyGet "ModifyDate" [] Automation.outDate
setModifyDate :: Automation.Date -> IFolderItem a -> Prelude.IO ()
setModifyDate pdt =
  Automation.propertySet "ModifyDate" [Automation.inDate pdt]
getSize :: IFolderItem a -> Prelude.IO (Prelude.Int)
getSize = Automation.propertyGet "Size" [] Automation.outInt
getType2 :: IFolderItem a -> Prelude.IO (Prelude.String)
getType2 = Automation.propertyGet "Type" [] Automation.outString
verbs :: IFolderItem a -> Prelude.IO (IFolderItemVerbs Automation.Interface)
verbs = Automation.function1 "Verbs" [] Automation.outIDispatch
invokeVerb :: Prelude.Int -> IFolderItem a -> Prelude.IO ()
invokeVerb vVerb =
  Automation.method0 "InvokeVerb" [Automation.inInt vVerb]
-- --------------------------------------------------
-- 
-- interface IShellFolderViewDual
-- 
-- --------------------------------------------------
data ShellFolderViewDual a = ShellFolderViewDual
                              
type IShellFolderViewDual a = Automation.IDispatch (ShellFolderViewDual a)
iidIShellFolderViewDual :: Com.IID (IShellFolderViewDual Automation.Interface)
iidIShellFolderViewDual =
  Com.mkIID "{E7A1AF80-4D96-11CF-960C-0080C7F4EE85}"
getApplication7 :: IShellFolderViewDual a -> Prelude.IO (Automation.IDispatch Automation.Interface)
getApplication7 =
  Automation.propertyGet "Application" [] Automation.outIDispatch
getParent7 :: IShellFolderViewDual a -> Prelude.IO (Automation.IDispatch Automation.Interface)
getParent7 =
  Automation.propertyGet "Parent" [] Automation.outIDispatch
getFolder :: IShellFolderViewDual a -> Prelude.IO (IFolder Automation.Interface)
getFolder =
  Automation.propertyGet "Folder" [] Automation.outIDispatch
selectedItems :: IShellFolderViewDual a -> Prelude.IO (IFolderItems Automation.Interface)
selectedItems =
  Automation.function1 "SelectedItems" [] Automation.outIDispatch
getFocusedItem :: IShellFolderViewDual a -> Prelude.IO (IFolderItem Automation.Interface)
getFocusedItem =
  Automation.propertyGet "FocusedItem" [] Automation.outIDispatch
selectItem :: Prelude.Int -> Prelude.Int -> IShellFolderViewDual a -> Prelude.IO ()
selectItem pvfi dwFlags =
  Automation.method0 "SelectItem" [Automation.inInt pvfi, Automation.inInt dwFlags]
popupItemMenu :: IFolderItem a0 -> Prelude.Int -> Prelude.Int -> IShellFolderViewDual a -> Prelude.IO (Prelude.String)
popupItemMenu pfi vx vy =
  Automation.function1 "PopupItemMenu" [Automation.inIDispatch pfi, Automation.inInt vx, Automation.inInt vy] Automation.outString
getScript :: IShellFolderViewDual a -> Prelude.IO (Automation.IDispatch Automation.Interface)
getScript =
  Automation.propertyGet "Script" [] Automation.outIDispatch
getViewOptions :: IShellFolderViewDual a -> Prelude.IO (Prelude.Int)
getViewOptions =
  Automation.propertyGet "ViewOptions" [] Automation.outInt
-- --------------------------------------------------
-- 
-- coclass ShellFolderView
-- 
-- --------------------------------------------------
clsidShellFolderView :: Com.CLSID
clsidShellFolderView =
  Com.mkCLSID "{62112AA1-EBE4-11CF-A5FB-0020AFE7292D}"
data ShellFolderViewOptions
 = SFVVO_SHOWALLOBJECTS
 | SFVVO_SHOWEXTENSIONS
 | SFVVO_SHOWCOMPCOLOR
 | SFVVO_SHOWSYSFILES
 | SFVVO_WIN95CLASSIC
 | SFVVO_DOUBLECLICKINWEBVIEW
 | SFVVO_DESKTOPHTML
 
marshallShellFolderViewOptions :: ShellFolderViewOptions -> Prelude.IO Int.Int16
marshallShellFolderViewOptions v =
  case v of
     SFVVO_SHOWALLOBJECTS -> Prelude.return (1)
     SFVVO_SHOWEXTENSIONS -> Prelude.return (2)
     SFVVO_SHOWCOMPCOLOR -> Prelude.return (8)
     SFVVO_SHOWSYSFILES -> Prelude.return (32)
     SFVVO_WIN95CLASSIC -> Prelude.return (64)
     SFVVO_DOUBLECLICKINWEBVIEW -> Prelude.return (128)
     SFVVO_DESKTOPHTML -> Prelude.return (512)
unmarshallShellFolderViewOptions :: Int.Int16 -> Prelude.IO ShellFolderViewOptions
unmarshallShellFolderViewOptions v =
  case v of
     1 -> Prelude.return (SFVVO_SHOWALLOBJECTS)
     2 -> Prelude.return (SFVVO_SHOWEXTENSIONS)
     8 -> Prelude.return (SFVVO_SHOWCOMPCOLOR)
     32 -> Prelude.return (SFVVO_SHOWSYSFILES)
     64 -> Prelude.return (SFVVO_WIN95CLASSIC)
     128 -> Prelude.return (SFVVO_DOUBLECLICKINWEBVIEW)
     512 -> Prelude.return (SFVVO_DESKTOPHTML)
     _ -> Prelude.fail (Prelude.userError "unmarshallShellFolderViewOptions: illegal enum value ")
-- --------------------------------------------------
-- 
-- interface IShellDispatch
-- 
-- --------------------------------------------------
data ShellDispatch a = ShellDispatch
                        
type IShellDispatch a = Automation.IDispatch (ShellDispatch a)
iidIShellDispatch :: Com.IID (IShellDispatch Automation.Interface)
iidIShellDispatch =
  Com.mkIID "{D8F015C0-C278-11CE-A49E-444553540000}"
getApplication8 :: IShellDispatch a -> Prelude.IO (Automation.IDispatch Automation.Interface)
getApplication8 =
  Automation.propertyGet "Application" [] Automation.outIDispatch
getParent8 :: IShellDispatch a -> Prelude.IO (Automation.IDispatch Automation.Interface)
getParent8 =
  Automation.propertyGet "Parent" [] Automation.outIDispatch
nameSpace :: Prelude.Int -> IShellDispatch a -> Prelude.IO (IFolder Automation.Interface)
nameSpace vDir =
  Automation.function1 "NameSpace" [Automation.inInt vDir] Automation.outIDispatch
browseForFolder :: Prelude.Int -> Prelude.String -> Prelude.Int -> Prelude.Int -> IShellDispatch a -> Prelude.IO (IFolder Automation.Interface)
browseForFolder hWND title options rootFolder =
  Automation.function1 "BrowseForFolder" [Automation.inInt hWND, Automation.inString title, Automation.inInt options, Automation.inInt rootFolder] Automation.outIDispatch
windows :: IShellDispatch a -> Prelude.IO (Automation.IDispatch Automation.Interface)
windows = Automation.function1 "Windows" [] Automation.outIDispatch
open :: Prelude.Int -> IShellDispatch a -> Prelude.IO ()
open vDir = Automation.method0 "Open" [Automation.inInt vDir]
explore :: Prelude.Int -> IShellDispatch a -> Prelude.IO ()
explore vDir = Automation.method0 "Explore" [Automation.inInt vDir]
minimizeAll :: IShellDispatch a -> Prelude.IO ()
minimizeAll = Automation.method0 "MinimizeAll" []
undoMinimizeALL :: IShellDispatch a -> Prelude.IO ()
undoMinimizeALL = Automation.method0 "UndoMinimizeALL" []
fileRun :: IShellDispatch a -> Prelude.IO ()
fileRun = Automation.method0 "FileRun" []
cascadeWindows :: IShellDispatch a -> Prelude.IO ()
cascadeWindows = Automation.method0 "CascadeWindows" []
tileVertically :: IShellDispatch a -> Prelude.IO ()
tileVertically = Automation.method0 "TileVertically" []
tileHorizontally :: IShellDispatch a -> Prelude.IO ()
tileHorizontally = Automation.method0 "TileHorizontally" []
shutdownWindows :: IShellDispatch a -> Prelude.IO ()
shutdownWindows = Automation.method0 "ShutdownWindows" []
suspend :: IShellDispatch a -> Prelude.IO ()
suspend = Automation.method0 "Suspend" []
ejectPC :: IShellDispatch a -> Prelude.IO ()
ejectPC = Automation.method0 "EjectPC" []
setTime :: IShellDispatch a -> Prelude.IO ()
setTime = Automation.method0 "SetTime" []
trayProperties :: IShellDispatch a -> Prelude.IO ()
trayProperties = Automation.method0 "TrayProperties" []
help :: IShellDispatch a -> Prelude.IO ()
help = Automation.method0 "Help" []
findFiles :: IShellDispatch a -> Prelude.IO ()
findFiles = Automation.method0 "FindFiles" []
findComputer :: IShellDispatch a -> Prelude.IO ()
findComputer = Automation.method0 "FindComputer" []
refreshMenu :: IShellDispatch a -> Prelude.IO ()
refreshMenu = Automation.method0 "RefreshMenu" []
controlPanelItem :: Prelude.String -> IShellDispatch a -> Prelude.IO ()
controlPanelItem szDir =
  Automation.method0 "ControlPanelItem" [Automation.inString szDir]
-- --------------------------------------------------
-- 
-- coclass Shell
-- 
-- --------------------------------------------------
clsidShell :: Com.CLSID
clsidShell = Com.mkCLSID "{13709620-C279-11CE-A49E-444553540000}"
-- --------------------------------------------------
-- 
-- coclass ShellDispatchInproc
-- 
-- --------------------------------------------------
clsidShellDispatchInproc :: Com.CLSID
clsidShellDispatchInproc =
  Com.mkCLSID "{0A89A860-D7B1-11CE-8350-444553540000}"
-- --------------------------------------------------
-- 
-- coclass WebViewFolderContents
-- 
-- --------------------------------------------------
clsidWebViewFolderContents :: Com.CLSID
clsidWebViewFolderContents =
  Com.mkCLSID "{1820FED0-473E-11D0-A96C-00C04FD705A2}"
data ShellSpecialFolderConstants
 = SsfDESKTOP
 | SsfPROGRAMS
 | SsfCONTROLS
 | SsfPRINTERS
 | SsfPERSONAL
 | SsfFAVORITES
 | SsfSTARTUP
 | SsfRECENT
 | SsfSENDTO
 | SsfBITBUCKET
 | SsfSTARTMENU
 | SsfDESKTOPDIRECTORY
 | SsfDRIVES
 | SsfNETWORK
 | SsfNETHOOD
 | SsfFONTS
 | SsfTEMPLATES
 
marshallShellSpecialFolderConstants :: ShellSpecialFolderConstants -> Prelude.IO Int.Int16
marshallShellSpecialFolderConstants v =
  case v of
     SsfDESKTOP -> Prelude.return (0)
     SsfPROGRAMS -> Prelude.return (2)
     SsfCONTROLS -> Prelude.return (3)
     SsfPRINTERS -> Prelude.return (4)
     SsfPERSONAL -> Prelude.return (5)
     SsfFAVORITES -> Prelude.return (6)
     SsfSTARTUP -> Prelude.return (7)
     SsfRECENT -> Prelude.return (8)
     SsfSENDTO -> Prelude.return (9)
     SsfBITBUCKET -> Prelude.return (10)
     SsfSTARTMENU -> Prelude.return (11)
     SsfDESKTOPDIRECTORY -> Prelude.return (16)
     SsfDRIVES -> Prelude.return (17)
     SsfNETWORK -> Prelude.return (18)
     SsfNETHOOD -> Prelude.return (19)
     SsfFONTS -> Prelude.return (20)
     SsfTEMPLATES -> Prelude.return (21)
unmarshallShellSpecialFolderConstants :: Int.Int16 -> Prelude.IO ShellSpecialFolderConstants
unmarshallShellSpecialFolderConstants v =
  case v of
     0 -> Prelude.return (SsfDESKTOP)
     2 -> Prelude.return (SsfPROGRAMS)
     3 -> Prelude.return (SsfCONTROLS)
     4 -> Prelude.return (SsfPRINTERS)
     5 -> Prelude.return (SsfPERSONAL)
     6 -> Prelude.return (SsfFAVORITES)
     7 -> Prelude.return (SsfSTARTUP)
     8 -> Prelude.return (SsfRECENT)
     9 -> Prelude.return (SsfSENDTO)
     10 -> Prelude.return (SsfBITBUCKET)
     11 -> Prelude.return (SsfSTARTMENU)
     16 -> Prelude.return (SsfDESKTOPDIRECTORY)
     17 -> Prelude.return (SsfDRIVES)
     18 -> Prelude.return (SsfNETWORK)
     19 -> Prelude.return (SsfNETHOOD)
     20 -> Prelude.return (SsfFONTS)
     21 -> Prelude.return (SsfTEMPLATES)
     _ -> Prelude.fail (Prelude.userError "unmarshallShellSpecialFolderConstants: illegal enum value ")
-- --------------------------------------------------
-- 
-- interface IShellUIHelper
-- 
-- --------------------------------------------------
data ShellUIHelper a = ShellUIHelper
                        
type IShellUIHelper a = Automation.IDispatch (ShellUIHelper a)
iidIShellUIHelper :: Com.IID (IShellUIHelper Automation.Interface)
iidIShellUIHelper =
  Com.mkIID "{729FE2F8-1EA8-11D1-8F85-00C04FC2FBE1}"
resetFirstBootMode :: IShellUIHelper a -> Prelude.IO ()
resetFirstBootMode = Automation.method0 "ResetFirstBootMode" []
resetSafeMode :: IShellUIHelper a -> Prelude.IO ()
resetSafeMode = Automation.method0 "ResetSafeMode" []
refreshOfflineDesktop :: IShellUIHelper a -> Prelude.IO ()
refreshOfflineDesktop =
  Automation.method0 "RefreshOfflineDesktop" []
addFavorite :: Prelude.String -> Prelude.Int -> IShellUIHelper a -> Prelude.IO ()
addFavorite uRL title =
  Automation.method0 "AddFavorite" [Automation.inString uRL, Automation.inInt title]
addChannel :: Prelude.String -> IShellUIHelper a -> Prelude.IO ()
addChannel uRL =
  Automation.method0 "AddChannel" [Automation.inString uRL]
addDesktopComponent :: Prelude.String -> Prelude.String -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> IShellUIHelper a -> Prelude.IO ()
addDesktopComponent uRL type0 left top width height =
  Automation.method0 "AddDesktopComponent" [Automation.inString uRL, Automation.inString type0, Automation.inInt left, Automation.inInt top, Automation.inInt width, Automation.inInt height]
isSubscribed :: Prelude.String -> IShellUIHelper a -> Prelude.IO (Prelude.Int)
isSubscribed uRL =
  Automation.function1 "IsSubscribed" [Automation.inString uRL] Automation.outInt
-- --------------------------------------------------
-- 
-- coclass ShellUIHelper
-- 
-- --------------------------------------------------
clsidShellUIHelper :: Com.CLSID
clsidShellUIHelper =
  Com.mkCLSID "{64AB4BB7-111E-11D1-8F79-00C04FC2FBE1}"
