module ScriptEvents 
        ( 
          onEvent_0_0
        , onEvent_1_0
        , onEvent_2_0
        , onEvent_3_0
        , onEvent_4_0
        
        , onEvent_0_1
        , onEvent_1_1
        , onEvent_2_1
        , onEvent_3_1
        , onEvent_4_1
            
        , onEventID_0_0
        , onEventID_1_0
        , onEventID_2_0
        , onEventID_3_0
        , onEventID_4_0
        
        , onEventID_0_1
        , onEventID_1_1
        , onEventID_2_1
        , onEventID_3_1
        , onEventID_4_1            
            
        , export_0_0
        , export_1_0
        , export_2_0
        , export_3_0
        , export_4_0
        
        , export_0_1
        , export_1_1
        , export_2_1
        , export_3_1
        , export_4_1
        
        , onEvent
        , onEvents
        , onEventEx
        , onEventsEx
        
        , onEventID
        , onEventsID
        , onEventExID
        , onEventsExID
        
        , addEvent
        , addEventEx
        , addEventExID
        
        , Export
        , export
        , export0, export1, export2, export3, export4
        , exportRes
        , exportRes0, exportRes1, exportRes2, exportRes3, exportRes4
        , IEventSink
        , makeScriptable
        )
        where

import PointerPrim      (unsafePointerFromInt)
import Pointer          (Pointer,makeInterfacePointer)
import ComPrim          (unsafeMkInterface)

import Automation
import ScriptServer

-----------------------------------------------------------
-- Overloaded versions of the 'onEvent' functions
-----------------------------------------------------------

onEvent_0_0 name f    = onEventEx name (export_0_0 f)
onEvent_1_0 name f    = onEventEx name (export_1_0 f) 
onEvent_2_0 name f    = onEventEx name (export_2_0 f) 
onEvent_3_0 name f    = onEventEx name (export_3_0 f) 
onEvent_4_0 name f    = onEventEx name (export_4_0 f) 

onEvent_0_1 name f    = onEventEx name (export_0_1 f)
onEvent_1_1 name f    = onEventEx name (export_1_1 f) 
onEvent_2_1 name f    = onEventEx name (export_2_1 f) 
onEvent_3_1 name f    = onEventEx name (export_3_1 f) 
onEvent_4_1 name f    = onEventEx name (export_4_1 f) 



onEventID_0_0 name f    = onEventExID name (export_0_0 f)
onEventID_1_0 name f    = onEventExID name (export_1_0 f) 
onEventID_2_0 name f    = onEventExID name (export_2_0 f) 
onEventID_3_0 name f    = onEventExID name (export_3_0 f) 
onEventID_4_0 name f    = onEventExID name (export_4_0 f) 

onEventID_0_1 name f    = onEventExID name (export_0_1 f)
onEventID_1_1 name f    = onEventExID name (export_1_1 f) 
onEventID_2_1 name f    = onEventExID name (export_2_1 f) 
onEventID_3_1 name f    = onEventExID name (export_3_1 f) 
onEventID_4_1 name f    = onEventExID name (export_4_1 f) 


-----------------------------------------------------------
-- Connecting to events
-----------------------------------------------------------

onEvent  :: String -> IO () -> IDispatch a -> IO (IEventSink Interface)
onEvent name f
        = onEventEx name (export f)

onEvents :: [(String, IO ())] -> IDispatch a -> IO (IEventSink Interface)        
onEvents events
        = onEventsEx (map (\(name,f) -> (name,export f)) events)


onEventID  :: DISPID -> IO () -> IDispatch a -> IO (IEventSink Interface)
onEventID name f
        = onEventExID name (export f)

onEventsID :: [(DISPID, IO ())] -> IDispatch a -> IO (IEventSink Interface)        
onEventsID events
        = onEventsExID (map (\(name,f) -> (name,export f)) events)


-- onEvent(s)Ex allow you to connect arbitrary haskell
-- functions to events instead of just IO () functions.

onEventEx :: String -> Export -> IDispatch a -> IO (IEventSink Interface)
onEventEx name fun object
        = do sink     <- coCreateObject "EventSink.1" iidIEventSink
             sink # connect object ""   
             sink # addEventEx name fun 
             return sink
             
        
onEventsEx :: [(String,Export)] -> IDispatch a -> IO (IEventSink Interface)
onEventsEx events object
        = do sink     <- coCreateObject "EventSink.1" iidIEventSink
             sink # connect object ""
             sink # withMethod (uncurry addEventEx) events
             return sink


onEventExID :: DISPID -> Export -> IDispatch a -> IO (IEventSink Interface)
onEventExID eventID fun object
        = do sink     <- coCreateObject "EventSink.1" iidIEventSink
             sink # connect object ""   
             sink # addEventExID eventID fun 
             return sink


onEventsExID :: [(DISPID,Export)] -> IDispatch a -> IO (IEventSink Interface)
onEventsExID events object
        = do sink     <- coCreateObject "EventSink.1" iidIEventSink
             sink # connect object ""
             sink # withMethod (uncurry addEventExID) events
             return sink


addEvent :: String -> IO () -> IEventSink a -> IO ()
addEvent name fun
        = addEventEx name (export fun)

addEventEx :: String -> Export -> IEventSink a -> IO ()
addEventEx name fun sink
        = do eventID <- sink # getEventID name
             sink # addEventExID eventID fun

addEventExID :: DISPID -> Export -> IEventSink a -> IO ()
addEventExID eventID fun sink
        = do funSink <- unsafeMakeScriptable fun
             sink # sinkEvent eventID funSink


-----------------------------------------------------------
-- Overloaded versions of the 'export' functions
-----------------------------------------------------------

export_0_0 f        = export0 f
export_1_0 f        = export1 resVariant f
export_2_0 f        = export2 resVariant resVariant f
export_3_0 f        = export3 resVariant resVariant resVariant f
export_4_0 f        = export4 resVariant resVariant resVariant resVariant f

export_0_1 f        = exportRes0 inVariant f
export_1_1 f        = exportRes1 inVariant resVariant f
export_2_1 f        = exportRes2 inVariant resVariant resVariant f
export_3_1 f        = exportRes3 inVariant resVariant resVariant resVariant f
export_4_1 f        = exportRes4 inVariant resVariant resVariant resVariant resVariant f


-----------------------------------------------------------
-- Haskell functions/values can be exported when they
-- are of type Export. It expects the number of
-- arguments, a pointer to an array of VARIANTS and
-- a pointer to a VARIANT that gets the result.
--
-- Haskell functions can be exported using the functions
-- export(n) or exportRes(n) if you want to return a
-- result.
-- example: export1 resString putString
--          exportRes0 inChar getChar
--
-- note how 'res' functions are now used for arguments
-- and 'in' functions for results.
-----------------------------------------------------------

type Export     = Int -> Int -> Int -> IO ()

export          = export0
exportRes       = exportRes0

export0         = exportRes0 inEmpty
export1         = exportRes1 inEmpty
export2         = exportRes2 inEmpty
export3         = exportRes3 inEmpty
export4         = exportRes4 inEmpty


exportRes0 :: ArgIn a -> IO a -> Export
exportRes0 pack fun  cargs args res 
        = do checkArgs cargs 0               
             x <- fun
             writeRes (pack x) res
             return ()
             
exportRes1 :: ArgIn a -> ArgRes b -> (b -> IO a) -> Export
exportRes1 pack arg1 fun  cargs args res 
        = do checkArgs cargs 1
             a <- rdArg 1 arg1 
             x <- fun a   
             writeRes (pack x) res
             return ()
        where
          rdArg = readArg cargs args 
             
             
exportRes2 :: ArgIn a -> ArgRes b -> ArgRes c -> (b -> c -> IO a) -> Export
exportRes2 pack arg1 arg2 fun  cargs args res 
        = do checkArgs cargs 2
             a <- rdArg 1 arg1 
             b <- rdArg 2 arg2 
             x <- fun a b  
             writeRes (pack x) res
             return ()
        where
          rdArg = readArg cargs args 
             

exportRes3 :: ArgIn a -> ArgRes b -> ArgRes c -> ArgRes d -> 
                (b -> c -> d -> IO a) -> Export
exportRes3 pack arg1 arg2 arg3 fun  cargs args res 
        = do checkArgs cargs 3
             a <- rdArg 1 arg1 
             b <- rdArg 2 arg2 
             c <- rdArg 3 arg3 
             x <- fun a b c 
             writeRes (pack x) res
             return ()
        where
          rdArg = readArg cargs args 

                        
exportRes4 :: ArgIn a -> ArgRes b -> ArgRes c -> ArgRes d -> ArgRes e ->  
                (b -> c -> d -> e -> IO a) -> Export
exportRes4 pack arg1 arg2 arg3 arg4  fun  cargs args res 
        = do checkArgs cargs 4
             a <- rdArg 1 arg1 
             b <- rdArg 2 arg2 
             c <- rdArg 3 arg3 
             d <- rdArg 4 arg4 
             x <- fun a b c d 
             writeRes (pack x) res
             return ()
        where
          rdArg = readArg cargs args 
                        
-----------------------------------------------------------
-- Check the number of arguments
-----------------------------------------------------------

checkArgs cargs cnt
        | cargs >= cnt  = return ()
        | otherwise     = coFail "not enough arguments"
  


-----------------------------------------------------------
-- Primitive for wrapping a haskell value inside
-- a COM object
-----------------------------------------------------------

primitive makeHaskellItem :: a -> IO Addr

makeScriptable :: Export -> IO (IHaskellItem ())
makeScriptable
        = unsafeMakeScriptable
        
unsafeMakeScriptable :: a -> IO (IHaskellItem ())
unsafeMakeScriptable x
        = do addr <- makeHaskellItem x
             p    <- makeInterfacePointer addr
             return (unsafeMkInterface p)
             
-----------------------------------------------------------
-- Utility functions for reading/writing arguments
-----------------------------------------------------------

writeRes :: (Pointer VARIANT -> IO ()) -> Int -> IO ()
writeRes pack res       = pack (unsafePointerFromInt res)
              --  | res == 0      = return ()
              --  | otherwise     = pack (unsafePointerFromInt res)

readArg :: Int -> Int -> Int -> (Pointer VARIANT -> IO a) -> IO a
readArg cargs args idx unpack 
                = unpack (unsafePointerFromInt (args + ((cargs - idx)*sizeVARIANT)))


 
