module ScriptServer where

import Automation

-----------------------------------------------------------
-- ScriptItem interface
-----------------------------------------------------------


-----------------------------------------------------------
-- HaskellItem interface
-----------------------------------------------------------

data HaskellItem a      = HaskellItem
type IHaskellItem a     = IDispatch (HaskellItem a)


-----------------------------------------------------------
-- Script interface
-----------------------------------------------------------


-----------------------------------------------------------
-- EventSink Interface
-----------------------------------------------------------
 
data EventSink a        = EventSink          
type IEventSink a       = IDispatch (EventSink a)

iidIEventSink :: IID (IEventSink Interface)
iidIEventSink           = mkIID "{934A7CA3-1003-11d2-803E-00C04FA91355}"

connect src pre obj     = (connect' src pre obj) `coOnFail` "interface doesn't provide type information"

connect' :: IDispatch a -> String -> IEventSink b -> IO ()
connect' source prefix   = method0 "Connect" [inIDispatch source, inString prefix]

disConnect :: IEventSink a -> IO ()
disConnect              = method0 "DisConnect" []

sinkEvents :: IDispatch a -> IEventSink b -> IO ()
sinkEvents sink         = method0 "SinkEvents" [inIDispatch sink]

sinkEvent :: DISPID -> IDispatch a -> IEventSink b -> IO ()
sinkEvent eventID sink  = method0 "SinkEvent" [inInt eventID, inIDispatch sink]

getEventID :: String -> IEventSink a -> IO DISPID
getEventID eventName    = function1 "GetEventID" [inString eventName] outInt
