module VBIDE where

import qualified Prelude
import qualified Automation (IDispatch, Interface, outString, 
                             propertyGet, outIDispatch, inIDispatch, method0, outInt, inInt, 
                             propertySet, Variant, outVariant, inVariant, function1, 
                             outIUnknown, inString, inIUnknown, inoutInt, function5, method4)
import qualified Com (IID, mkIID, IUnknown, CLSID, mkCLSID)
import qualified Int (Int16)
import qualified Office (ICommandBars)

-- --------------------------------------------------
-- 
-- interface Application
-- 
-- --------------------------------------------------
data Application a = Application
                      
type IApplication a = Automation.IDispatch (Application a)
iidIApplication :: Com.IID (IApplication Automation.Interface)
iidIApplication =
  Com.mkIID "{0002E158-0000-0000-C000-000000000046}"
getVersion :: Automation.IDispatch a -> Prelude.IO (Prelude.String)
getVersion =
  Automation.propertyGet "Version" [] Automation.outString
data VbextFileTypes
 = VbextFileTypeForm
 | VbextFileTypeModule
 | VbextFileTypeClass
 | VbextFileTypeProject
 | VbextFileTypeExe
 | VbextFileTypeFrx
 | VbextFileTypeRes
 | VbextFileTypeUserControl
 | VbextFileTypePropertyPage
 | VbextFileTypeDocObject
 | VbextFileTypeBinary
 | VbextFileTypeGroupProject
 | VbextFileTypeDesigners
 
marshallVbextFileTypes :: VbextFileTypes -> Prelude.IO Int.Int16
marshallVbextFileTypes v =
  case v of
     VbextFileTypeForm -> Prelude.return (0)
     VbextFileTypeModule -> Prelude.return (1)
     VbextFileTypeClass -> Prelude.return (2)
     VbextFileTypeProject -> Prelude.return (3)
     VbextFileTypeExe -> Prelude.return (4)
     VbextFileTypeFrx -> Prelude.return (5)
     VbextFileTypeRes -> Prelude.return (6)
     VbextFileTypeUserControl -> Prelude.return (7)
     VbextFileTypePropertyPage -> Prelude.return (8)
     VbextFileTypeDocObject -> Prelude.return (9)
     VbextFileTypeBinary -> Prelude.return (10)
     VbextFileTypeGroupProject -> Prelude.return (11)
     VbextFileTypeDesigners -> Prelude.return (12)
unmarshallVbextFileTypes :: Int.Int16 -> Prelude.IO VbextFileTypes
unmarshallVbextFileTypes v =
  case v of
     0 -> Prelude.return (VbextFileTypeForm)
     1 -> Prelude.return (VbextFileTypeModule)
     2 -> Prelude.return (VbextFileTypeClass)
     3 -> Prelude.return (VbextFileTypeProject)
     4 -> Prelude.return (VbextFileTypeExe)
     5 -> Prelude.return (VbextFileTypeFrx)
     6 -> Prelude.return (VbextFileTypeRes)
     7 -> Prelude.return (VbextFileTypeUserControl)
     8 -> Prelude.return (VbextFileTypePropertyPage)
     9 -> Prelude.return (VbextFileTypeDocObject)
     10 -> Prelude.return (VbextFileTypeBinary)
     11 -> Prelude.return (VbextFileTypeGroupProject)
     12 -> Prelude.return (VbextFileTypeDesigners)
     _ -> Prelude.fail (Prelude.userError "unmarshallVbextFileTypes: illegal enum value ")
-- --------------------------------------------------
-- 
-- interface VBE
-- 
-- --------------------------------------------------
data VBE a = VBE
              
type IVBE a = IApplication (VBE a)
iidIVBE :: Com.IID (IVBE Automation.Interface)
iidIVBE = Com.mkIID "{0002E166-0000-0000-C000-000000000046}"
getVBProjects :: IVBE a -> Prelude.IO (IVBProjects Automation.Interface)
getVBProjects =
  Automation.propertyGet "VBProjects" [] Automation.outIDispatch
getCommandBars :: IVBE a -> Prelude.IO (Office.ICommandBars Automation.Interface)
getCommandBars =
  Automation.propertyGet "CommandBars" [] Automation.outIDispatch
getCodePanes :: IVBE a -> Prelude.IO (I_CodePanes Automation.Interface)
getCodePanes =
  Automation.propertyGet "CodePanes" [] Automation.outIDispatch
getWindows :: IVBE a -> Prelude.IO (I_Windows Automation.Interface)
getWindows =
  Automation.propertyGet "Windows" [] Automation.outIDispatch
getEvents :: IVBE a -> Prelude.IO (IEvents Automation.Interface)
getEvents =
  Automation.propertyGet "Events" [] Automation.outIDispatch
getActiveVBProject :: IVBE a -> Prelude.IO (IVBProject Automation.Interface)
getActiveVBProject =
  Automation.propertyGet "ActiveVBProject" [] Automation.outIDispatch
activeVBProject :: IVBProject a0 -> IVBE a -> Prelude.IO ()
activeVBProject lppptReturn =
  Automation.method0 "ActiveVBProject" [Automation.inIDispatch lppptReturn]
getSelectedVBComponent :: IVBE a -> Prelude.IO (I_VBComponent Automation.Interface)
getSelectedVBComponent =
  Automation.propertyGet "SelectedVBComponent" [] Automation.outIDispatch
getMainWindow :: IVBE a -> Prelude.IO (IWindow Automation.Interface)
getMainWindow =
  Automation.propertyGet "MainWindow" [] Automation.outIDispatch
getActiveWindow :: IVBE a -> Prelude.IO (IWindow Automation.Interface)
getActiveWindow =
  Automation.propertyGet "ActiveWindow" [] Automation.outIDispatch
getActiveCodePane :: IVBE a -> Prelude.IO (I_CodePane Automation.Interface)
getActiveCodePane =
  Automation.propertyGet "ActiveCodePane" [] Automation.outIDispatch
activeCodePane :: I_CodePane a0 -> IVBE a -> Prelude.IO ()
activeCodePane ppCodePane =
  Automation.method0 "ActiveCodePane" [Automation.inIDispatch ppCodePane]
data Vbext_WindowType
 = Vbext_wt_CodeWindow
 | Vbext_wt_Designer
 | Vbext_wt_Browser
 | Vbext_wt_Watch
 | Vbext_wt_Locals
 | Vbext_wt_Immediate
 | Vbext_wt_ProjectWindow
 | Vbext_wt_PropertyWindow
 | Vbext_wt_Find
 | Vbext_wt_FindReplace
 | Vbext_wt_LinkedWindowFrame
 | Vbext_wt_MainWindow
 | Vbext_wt_ToolWindow
 
marshallVbext_WindowType :: Vbext_WindowType -> Prelude.IO Int.Int16
marshallVbext_WindowType v =
  case v of
     Vbext_wt_CodeWindow -> Prelude.return (0)
     Vbext_wt_Designer -> Prelude.return (1)
     Vbext_wt_Browser -> Prelude.return (2)
     Vbext_wt_Watch -> Prelude.return (3)
     Vbext_wt_Locals -> Prelude.return (4)
     Vbext_wt_Immediate -> Prelude.return (5)
     Vbext_wt_ProjectWindow -> Prelude.return (6)
     Vbext_wt_PropertyWindow -> Prelude.return (7)
     Vbext_wt_Find -> Prelude.return (8)
     Vbext_wt_FindReplace -> Prelude.return (9)
     Vbext_wt_LinkedWindowFrame -> Prelude.return (11)
     Vbext_wt_MainWindow -> Prelude.return (12)
     Vbext_wt_ToolWindow -> Prelude.return (15)
unmarshallVbext_WindowType :: Int.Int16 -> Prelude.IO Vbext_WindowType
unmarshallVbext_WindowType v =
  case v of
     0 -> Prelude.return (Vbext_wt_CodeWindow)
     1 -> Prelude.return (Vbext_wt_Designer)
     2 -> Prelude.return (Vbext_wt_Browser)
     3 -> Prelude.return (Vbext_wt_Watch)
     4 -> Prelude.return (Vbext_wt_Locals)
     5 -> Prelude.return (Vbext_wt_Immediate)
     6 -> Prelude.return (Vbext_wt_ProjectWindow)
     7 -> Prelude.return (Vbext_wt_PropertyWindow)
     8 -> Prelude.return (Vbext_wt_Find)
     9 -> Prelude.return (Vbext_wt_FindReplace)
     11 -> Prelude.return (Vbext_wt_LinkedWindowFrame)
     12 -> Prelude.return (Vbext_wt_MainWindow)
     15 -> Prelude.return (Vbext_wt_ToolWindow)
     _ -> Prelude.fail (Prelude.userError "unmarshallVbext_WindowType: illegal enum value ")
data Vbext_WindowState
 = Vbext_ws_Normal
 | Vbext_ws_Minimize
 | Vbext_ws_Maximize
 
marshallVbext_WindowState :: Vbext_WindowState -> Prelude.IO Int.Int16
marshallVbext_WindowState v =
  case v of
     Vbext_ws_Normal -> Prelude.return (0)
     Vbext_ws_Minimize -> Prelude.return (1)
     Vbext_ws_Maximize -> Prelude.return (2)
unmarshallVbext_WindowState :: Int.Int16 -> Prelude.IO Vbext_WindowState
unmarshallVbext_WindowState v =
  case v of
     0 -> Prelude.return (Vbext_ws_Normal)
     1 -> Prelude.return (Vbext_ws_Minimize)
     2 -> Prelude.return (Vbext_ws_Maximize)
     _ -> Prelude.fail (Prelude.userError "unmarshallVbext_WindowState: illegal enum value ")
-- --------------------------------------------------
-- 
-- interface Window
-- 
-- --------------------------------------------------
data Window a = Window
                 
type IWindow a = Automation.IDispatch (Window a)
iidIWindow :: Com.IID (IWindow Automation.Interface)
iidIWindow = Com.mkIID "{0002E16B-0000-0000-C000-000000000046}"
getVBE :: Automation.IDispatch a -> Prelude.IO (IVBE Automation.Interface)
getVBE = Automation.propertyGet "VBE" [] Automation.outIDispatch
getCollection :: IWindow a -> Prelude.IO (I_Windows Automation.Interface)
getCollection =
  Automation.propertyGet "Collection" [] Automation.outIDispatch
close :: IWindow a -> Prelude.IO ()
close = Automation.method0 "Close" []
getCaption :: IWindow a -> Prelude.IO (Prelude.String)
getCaption =
  Automation.propertyGet "Caption" [] Automation.outString
getVisible :: IWindow a -> Prelude.IO (Prelude.Int)
getVisible = Automation.propertyGet "Visible" [] Automation.outInt
setVisible :: Prelude.Int -> IWindow a -> Prelude.IO ()
setVisible pfVisible =
  Automation.propertySet "Visible" [Automation.inInt pfVisible]
getLeft :: IWindow a -> Prelude.IO (Prelude.Int)
getLeft = Automation.propertyGet "Left" [] Automation.outInt
setLeft :: Prelude.Int -> IWindow a -> Prelude.IO ()
setLeft plLeft =
  Automation.propertySet "Left" [Automation.inInt plLeft]
getTop :: IWindow a -> Prelude.IO (Prelude.Int)
getTop = Automation.propertyGet "Top" [] Automation.outInt
setTop :: Prelude.Int -> IWindow a -> Prelude.IO ()
setTop plTop =
  Automation.propertySet "Top" [Automation.inInt plTop]
getWidth :: IWindow a -> Prelude.IO (Prelude.Int)
getWidth = Automation.propertyGet "Width" [] Automation.outInt
setWidth :: Prelude.Int -> IWindow a -> Prelude.IO ()
setWidth plWidth =
  Automation.propertySet "Width" [Automation.inInt plWidth]
getHeight :: IWindow a -> Prelude.IO (Prelude.Int)
getHeight = Automation.propertyGet "Height" [] Automation.outInt
setHeight :: Prelude.Int -> IWindow a -> Prelude.IO ()
setHeight plHeight =
  Automation.propertySet "Height" [Automation.inInt plHeight]
getWindowState :: (Automation.Variant a0) => IWindow a -> Prelude.IO (a0)
getWindowState =
  Automation.propertyGet "WindowState" [] Automation.outVariant
setWindowState :: (Automation.Variant a0) => a0 -> IWindow a -> Prelude.IO ()
setWindowState plWindowState =
  Automation.propertySet "WindowState" [Automation.inVariant plWindowState]
setFocus :: IWindow a -> Prelude.IO ()
setFocus = Automation.method0 "SetFocus" []
getType :: (Automation.Variant a0) => IWindow a -> Prelude.IO (a0)
getType = Automation.propertyGet "Type" [] Automation.outVariant
setKind :: (Automation.Variant a0) => a0 -> IWindow a -> Prelude.IO ()
setKind eKind =
  Automation.method0 "SetKind" [Automation.inVariant eKind]
getLinkedWindows :: IWindow a -> Prelude.IO (I_LinkedWindows Automation.Interface)
getLinkedWindows =
  Automation.propertyGet "LinkedWindows" [] Automation.outIDispatch
getLinkedWindowFrame :: IWindow a -> Prelude.IO (IWindow Automation.Interface)
getLinkedWindowFrame =
  Automation.propertyGet "LinkedWindowFrame" [] Automation.outIDispatch
detach :: IWindow a -> Prelude.IO ()
detach = Automation.method0 "Detach" []
attach :: Prelude.Int -> IWindow a -> Prelude.IO ()
attach lWindowHandle =
  Automation.method0 "Attach" [Automation.inInt lWindowHandle]
getHWnd :: IWindow a -> Prelude.IO (Prelude.Int)
getHWnd = Automation.propertyGet "HWnd" [] Automation.outInt
-- --------------------------------------------------
-- 
-- interface Windows
-- 
-- --------------------------------------------------
data Windows a = Windows
                  
type IWindows a = Automation.IDispatch (Windows a)
type I_Windows a = IWindows a
iidIWindows :: Com.IID (IWindows Automation.Interface)
iidIWindows = Com.mkIID "{0002E16A-0000-0000-C000-000000000046}"
getParent :: Automation.IDispatch a -> Prelude.IO (IApplication Automation.Interface)
getParent =
  Automation.propertyGet "Parent" [] Automation.outIDispatch
item :: Prelude.Int -> Automation.IDispatch a -> Prelude.IO (IWindow Automation.Interface)
item index =
  Automation.function1 "Item" [Automation.inInt index] Automation.outIDispatch
getCount :: Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getCount = Automation.propertyGet "Count" [] Automation.outInt
newEnum :: Automation.IDispatch a -> Prelude.IO (Com.IUnknown Automation.Interface)
newEnum = Automation.function1 "_NewEnum" [] Automation.outIUnknown
-- --------------------------------------------------
-- 
-- interface LinkedWindows
-- 
-- --------------------------------------------------
data LinkedWindows a = LinkedWindows
                        
type ILinkedWindows a = Automation.IDispatch (LinkedWindows a)
type I_LinkedWindows a = ILinkedWindows a
iidILinkedWindows :: Com.IID (ILinkedWindows Automation.Interface)
iidILinkedWindows =
  Com.mkIID "{0002E16C-0000-0000-C000-000000000046}"
getParent0 :: ILinkedWindows a -> Prelude.IO (IWindow Automation.Interface)
getParent0 =
  Automation.propertyGet "Parent" [] Automation.outIDispatch
remove :: IWindow a0 -> ILinkedWindows a -> Prelude.IO ()
remove window =
  Automation.method0 "Remove" [Automation.inIDispatch window]
add :: IWindow a0 -> ILinkedWindows a -> Prelude.IO ()
add window =
  Automation.method0 "Add" [Automation.inIDispatch window]
-- --------------------------------------------------
-- 
-- coclass LinkedWindows0
-- 
-- --------------------------------------------------
clsidLinkedWindows0 :: Com.CLSID
clsidLinkedWindows0 =
  Com.mkCLSID "{0002E187-0000-0000-C000-000000000046}"
-- --------------------------------------------------
-- 
-- interface Events
-- 
-- --------------------------------------------------
data Events a = Events
                 
type IEvents a = Automation.IDispatch (Events a)
iidIEvents :: Com.IID (IEvents Automation.Interface)
iidIEvents = Com.mkIID "{0002E167-0000-0000-C000-000000000046}"
getReferencesEvents :: IVBProject a0 -> IEvents a -> Prelude.IO (I_ReferencesEvents Automation.Interface)
getReferencesEvents vBProject =
  Automation.propertyGet "ReferencesEvents" [Automation.inIDispatch vBProject] Automation.outIDispatch
getCommandBarEvents :: Automation.IDispatch a0 -> IEvents a -> Prelude.IO (IEvents Automation.Interface)
getCommandBarEvents commandBarControl =
  Automation.propertyGet "CommandBarEvents" [Automation.inIDispatch commandBarControl] Automation.outIDispatch
-- --------------------------------------------------
-- 
-- interface VBProjectsEvents
-- 
-- --------------------------------------------------
data VBProjectsEvents a = VBProjectsEvents
                           
type IVBProjectsEvents a = Automation.IDispatch (VBProjectsEvents a)
iidIVBProjectsEvents :: Com.IID (IVBProjectsEvents Automation.Interface)
iidIVBProjectsEvents =
  Com.mkIID "{0002E113-0000-0000-C000-000000000046}"
-- --------------------------------------------------
-- 
-- dispinterface DispVBProjectsEvents
-- 
-- --------------------------------------------------
data D_VBProjectsEvents a = D_VBProjectsEvents
                           
type DispVBProjectsEvents a = Automation.IDispatch (D_VBProjectsEvents a)
iidDispVBProjectsEvents :: Com.IID (DispVBProjectsEvents Automation.Interface)
iidDispVBProjectsEvents =
  Com.mkIID "{0002E103-0000-0000-C000-000000000046}"
itemAdded :: IVBProject a0 -> DispVBProjectsEvents a -> Prelude.IO ()
itemAdded vBProject =
  Automation.method0 "ItemAdded" [Automation.inIDispatch vBProject]
itemRemoved :: IVBProject a0 -> DispVBProjectsEvents a -> Prelude.IO ()
itemRemoved vBProject =
  Automation.method0 "ItemRemoved" [Automation.inIDispatch vBProject]
itemRenamed :: IVBProject a0 -> Prelude.String -> DispVBProjectsEvents a -> Prelude.IO ()
itemRenamed vBProject oldName =
  Automation.method0 "ItemRenamed" [Automation.inIDispatch vBProject, Automation.inString oldName]
itemActivated :: IVBProject a0 -> DispVBProjectsEvents a -> Prelude.IO ()
itemActivated vBProject =
  Automation.method0 "ItemActivated" [Automation.inIDispatch vBProject]
-- --------------------------------------------------
-- 
-- interface VBComponentsEvents
-- 
-- --------------------------------------------------
data D_VBComponentsEvents a = D_VBComponentsEvents
                             
type IVBComponentsEvents a = Automation.IDispatch (D_VBComponentsEvents a)
iidIVBComponentsEvents :: Com.IID (IVBComponentsEvents Automation.Interface)
iidIVBComponentsEvents =
  Com.mkIID "{0002E115-0000-0000-C000-000000000046}"
-- --------------------------------------------------
-- 
-- dispinterface DispVBComponentsEvents
-- 
-- --------------------------------------------------
data VBComponentsEvents a = VBComponentsEvents
                             
type DispVBComponentsEvents a = Automation.IDispatch (VBComponentsEvents a)
iidDispVBComponentsEvents :: Com.IID (DispVBComponentsEvents Automation.Interface)
iidDispVBComponentsEvents =
  Com.mkIID "{0002E116-0000-0000-C000-000000000046}"
itemAdded0 :: I_VBComponent a0 -> DispVBComponentsEvents a -> Prelude.IO ()
itemAdded0 vBComponent =
  Automation.method0 "ItemAdded" [Automation.inIDispatch vBComponent]
itemRemoved0 :: I_VBComponent a0 -> DispVBComponentsEvents a -> Prelude.IO ()
itemRemoved0 vBComponent =
  Automation.method0 "ItemRemoved" [Automation.inIDispatch vBComponent]
itemRenamed0 :: I_VBComponent a0 -> Prelude.String -> DispVBComponentsEvents a -> Prelude.IO ()
itemRenamed0 vBComponent oldName =
  Automation.method0 "ItemRenamed" [Automation.inIDispatch vBComponent, Automation.inString oldName]
itemSelected :: I_VBComponent a0 -> DispVBComponentsEvents a -> Prelude.IO ()
itemSelected vBComponent =
  Automation.method0 "ItemSelected" [Automation.inIDispatch vBComponent]
itemActivated0 :: I_VBComponent a0 -> DispVBComponentsEvents a -> Prelude.IO ()
itemActivated0 vBComponent =
  Automation.method0 "ItemActivated" [Automation.inIDispatch vBComponent]
itemReloaded :: I_VBComponent a0 -> DispVBComponentsEvents a -> Prelude.IO ()
itemReloaded vBComponent =
  Automation.method0 "ItemReloaded" [Automation.inIDispatch vBComponent]
-- --------------------------------------------------
-- 
-- interface ReferencesEvents
-- 
-- --------------------------------------------------
data D_ReferencesEvents a = D_ReferencesEvents
                           
type IReferencesEvents a = Automation.IDispatch (D_ReferencesEvents a)
type I_ReferencesEvents a = IReferencesEvents a
iidIReferencesEvents :: Com.IID (IReferencesEvents Automation.Interface)
iidIReferencesEvents =
  Com.mkIID "{0002E11A-0000-0000-C000-000000000046}"
-- --------------------------------------------------
-- 
-- dispinterface DispReferencesEvents
-- 
-- --------------------------------------------------
data ReferencesEvents a = ReferencesEvents
                           
type DispReferencesEvents a = Automation.IDispatch (ReferencesEvents a)
iidDispReferencesEvents :: Com.IID (DispReferencesEvents Automation.Interface)
iidDispReferencesEvents =
  Com.mkIID "{0002E118-0000-0000-C000-000000000046}"
itemAdded1 :: IReference a0 -> Automation.IDispatch a -> Prelude.IO ()
itemAdded1 reference =
  Automation.method0 "ItemAdded" [Automation.inIDispatch reference]
itemRemoved1 :: IReference a0 -> Automation.IDispatch a -> Prelude.IO ()
itemRemoved1 reference =
  Automation.method0 "ItemRemoved" [Automation.inIDispatch reference]
-- --------------------------------------------------
-- 
-- coclass ReferencesEvents0
-- 
-- --------------------------------------------------
clsidReferencesEvents0 :: Com.CLSID
clsidReferencesEvents0 =
  Com.mkCLSID "{0002E119-0000-0000-C000-000000000046}"
-- --------------------------------------------------
-- 
-- interface CommandBarControlEvents
-- 
-- --------------------------------------------------
data CommandBarControlEvents a = CommandBarControlEvents
                                  
type ICommandBarControlEvents a = Automation.IDispatch (CommandBarControlEvents a)
iidICommandBarControlEvents :: Com.IID (ICommandBarControlEvents Automation.Interface)
iidICommandBarControlEvents =
  Com.mkIID "{0002E130-0000-0000-C000-000000000046}"
-- --------------------------------------------------
-- 
-- dispinterface DispCommandBarControlEvents
-- 
-- --------------------------------------------------
data D_CommandBarControlEvents a = D_CommandBarControlEvents
                                  
type DispCommandBarControlEvents a = Automation.IDispatch (D_CommandBarControlEvents a)
iidDispCommandBarControlEvents :: Com.IID (DispCommandBarControlEvents Automation.Interface)
iidDispCommandBarControlEvents =
  Com.mkIID "{0002E131-0000-0000-C000-000000000046}"
click :: Automation.IDispatch a0 -> Prelude.Int -> Prelude.Int -> DispCommandBarControlEvents a -> Prelude.IO ()
click commandBarControl handled cancelDefault =
  Automation.method0 "Click" [Automation.inIDispatch commandBarControl, Automation.inInt handled, Automation.inInt cancelDefault]
-- --------------------------------------------------
-- 
-- coclass CommandBarEvents
-- 
-- --------------------------------------------------
clsidCommandBarEvents :: Com.CLSID
clsidCommandBarEvents =
  Com.mkCLSID "{0002E132-0000-0000-C000-000000000046}"
-- --------------------------------------------------
-- 
-- interface ProjectTemplate
-- 
-- --------------------------------------------------
data ProjectTemplate a = ProjectTemplate
                          
type IProjectTemplate a = Automation.IDispatch (ProjectTemplate a)
iidIProjectTemplate :: Com.IID (IProjectTemplate Automation.Interface)
iidIProjectTemplate =
  Com.mkIID "{0002E159-0000-0000-C000-000000000046}"
getApplication :: Automation.IDispatch a -> Prelude.IO (IApplication Automation.Interface)
getApplication =
  Automation.propertyGet "Application" [] Automation.outIDispatch
-- --------------------------------------------------
-- 
-- coclass ProjectTemplate0
-- 
-- --------------------------------------------------
clsidProjectTemplate0 :: Com.CLSID
clsidProjectTemplate0 =
  Com.mkCLSID "{32CDF9E0-1602-11CE-BFDC-08002B2B8CDA}"
data Vbext_ProjectProtection
 = Vbext_pp_none
 | Vbext_pp_locked
 
marshallVbext_ProjectProtection :: Vbext_ProjectProtection -> Prelude.IO Int.Int16
marshallVbext_ProjectProtection v =
  case v of
     Vbext_pp_none -> Prelude.return (0)
     Vbext_pp_locked -> Prelude.return (1)
unmarshallVbext_ProjectProtection :: Int.Int16 -> Prelude.IO Vbext_ProjectProtection
unmarshallVbext_ProjectProtection v =
  case v of
     0 -> Prelude.return (Vbext_pp_none)
     1 -> Prelude.return (Vbext_pp_locked)
     _ -> Prelude.fail (Prelude.userError "unmarshallVbext_ProjectProtection: illegal enum value ")
data Vbext_VBAMode
 = Vbext_vm_Run
 | Vbext_vm_Break
 | Vbext_vm_Design
 
marshallVbext_VBAMode :: Vbext_VBAMode -> Prelude.IO Int.Int16
marshallVbext_VBAMode v =
  case v of
     Vbext_vm_Run -> Prelude.return (0)
     Vbext_vm_Break -> Prelude.return (1)
     Vbext_vm_Design -> Prelude.return (2)
unmarshallVbext_VBAMode :: Int.Int16 -> Prelude.IO Vbext_VBAMode
unmarshallVbext_VBAMode v =
  case v of
     0 -> Prelude.return (Vbext_vm_Run)
     1 -> Prelude.return (Vbext_vm_Break)
     2 -> Prelude.return (Vbext_vm_Design)
     _ -> Prelude.fail (Prelude.userError "unmarshallVbext_VBAMode: illegal enum value ")
-- --------------------------------------------------
-- 
-- interface VBProject
-- 
-- --------------------------------------------------
data VBProject a = VBProject
                    
type IVBProject a = IProjectTemplate (VBProject a)
iidIVBProject :: Com.IID (IVBProject Automation.Interface)
iidIVBProject = Com.mkIID "{0002E160-0000-0000-C000-000000000046}"
getHelpFile :: IVBProject a -> Prelude.IO (Prelude.String)
getHelpFile =
  Automation.propertyGet "HelpFile" [] Automation.outString
setHelpFile :: Prelude.String -> IVBProject a -> Prelude.IO ()
setHelpFile lpbstrHelpFile =
  Automation.propertySet "HelpFile" [Automation.inString lpbstrHelpFile]
getHelpContextID :: IVBProject a -> Prelude.IO (Prelude.Int)
getHelpContextID =
  Automation.propertyGet "HelpContextID" [] Automation.outInt
setHelpContextID :: Prelude.Int -> IVBProject a -> Prelude.IO ()
setHelpContextID lpdwContextID =
  Automation.propertySet "HelpContextID" [Automation.inInt lpdwContextID]
getDescription :: Automation.IDispatch a -> Prelude.IO (Prelude.String)
getDescription =
  Automation.propertyGet "Description" [] Automation.outString
setDescription :: Prelude.String -> IVBProject a -> Prelude.IO ()
setDescription lpbstrDescription =
  Automation.propertySet "Description" [Automation.inString lpbstrDescription]
getMode :: (Automation.Variant a0) => IVBProject a -> Prelude.IO (a0)
getMode = Automation.propertyGet "Mode" [] Automation.outVariant
getReferences :: IVBProject a -> Prelude.IO (I_References Automation.Interface)
getReferences =
  Automation.propertyGet "References" [] Automation.outIDispatch
getName :: Automation.IDispatch a -> Prelude.IO (Prelude.String)
getName = Automation.propertyGet "Name" [] Automation.outString
setName :: Prelude.String -> Automation.IDispatch a -> Prelude.IO ()
setName lpbstrName =
  Automation.propertySet "Name" [Automation.inString lpbstrName]
getCollection0 :: IVBProject a -> Prelude.IO (IVBProjects Automation.Interface)
getCollection0 =
  Automation.propertyGet "Collection" [] Automation.outIDispatch
getProtection :: (Automation.Variant a0) => IVBProject a -> Prelude.IO (a0)
getProtection =
  Automation.propertyGet "Protection" [] Automation.outVariant
getSaved :: Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getSaved = Automation.propertyGet "Saved" [] Automation.outInt
getVBComponents :: IVBProject a -> Prelude.IO (I_VBComponents Automation.Interface)
getVBComponents =
  Automation.propertyGet "VBComponents" [] Automation.outIDispatch
-- --------------------------------------------------
-- 
-- coclass VBProject0
-- 
-- --------------------------------------------------
clsidVBProject0 :: Com.CLSID
clsidVBProject0 =
  Com.mkCLSID "{0002E169-0000-0000-C000-000000000046}"
-- --------------------------------------------------
-- 
-- interface VBProjects
-- 
-- --------------------------------------------------
data VBProjects a = VBProjects
                     
type IVBProjects a = Automation.IDispatch (VBProjects a)
iidIVBProjects :: Com.IID (IVBProjects Automation.Interface)
iidIVBProjects = Com.mkIID "{0002E165-0000-0000-C000-000000000046}"
item1 :: Prelude.Int -> IVBProjects a -> Prelude.IO (IVBProject Automation.Interface)
item1 index =
  Automation.function1 "Item" [Automation.inInt index] Automation.outIDispatch
getParent3 :: Automation.IDispatch a -> Prelude.IO (IVBE Automation.Interface)
getParent3 =
  Automation.propertyGet "Parent" [] Automation.outIDispatch
-- --------------------------------------------------
-- 
-- coclass VBProjects0
-- 
-- --------------------------------------------------
clsidVBProjects0 :: Com.CLSID
clsidVBProjects0 =
  Com.mkCLSID "{0002E101-0000-0000-C000-000000000046}"
-- --------------------------------------------------
-- 
-- interface SelectedComponents
-- 
-- --------------------------------------------------
data SelectedComponents a = SelectedComponents
                             
type ISelectedComponents a = Automation.IDispatch (SelectedComponents a)
iidISelectedComponents :: Com.IID (ISelectedComponents Automation.Interface)
iidISelectedComponents =
  Com.mkIID "{BE39F3D4-1B13-11D0-887F-00A0C90F2744}"
item2 :: Prelude.Int -> Automation.IDispatch a -> Prelude.IO (I_Component Automation.Interface)
item2 index =
  Automation.function1 "Item" [Automation.inInt index] Automation.outIDispatch
getParent4 :: Automation.IDispatch a -> Prelude.IO (IVBProject Automation.Interface)
getParent4 =
  Automation.propertyGet "Parent" [] Automation.outIDispatch
data Vbext_ComponentType
 = Vbext_ct_StdModule
 | Vbext_ct_ClassModule
 | Vbext_ct_MSForm
 | Vbext_ct_Document
 
marshallVbext_ComponentType :: Vbext_ComponentType -> Prelude.IO Int.Int16
marshallVbext_ComponentType v =
  case v of
     Vbext_ct_StdModule -> Prelude.return (1)
     Vbext_ct_ClassModule -> Prelude.return (2)
     Vbext_ct_MSForm -> Prelude.return (3)
     Vbext_ct_Document -> Prelude.return (100)
unmarshallVbext_ComponentType :: Int.Int16 -> Prelude.IO Vbext_ComponentType
unmarshallVbext_ComponentType v =
  case v of
     1 -> Prelude.return (Vbext_ct_StdModule)
     2 -> Prelude.return (Vbext_ct_ClassModule)
     3 -> Prelude.return (Vbext_ct_MSForm)
     100 -> Prelude.return (Vbext_ct_Document)
     _ -> Prelude.fail (Prelude.userError "unmarshallVbext_ComponentType: illegal enum value ")
-- --------------------------------------------------
-- 
-- interface Components
-- 
-- --------------------------------------------------
data Components a = Components
                     
type IComponents a = Automation.IDispatch (Components a)
type I_Components a = IComponents a
iidIComponents :: Com.IID (IComponents Automation.Interface)
iidIComponents = Com.mkIID "{0002E161-0000-0000-C000-000000000046}"
remove0 :: I_Component a0 -> IComponents a -> Prelude.IO ()
remove0 component =
  Automation.method0 "Remove" [Automation.inIDispatch component]
add0 :: (Automation.Variant a0) => a0 -> IComponents a -> Prelude.IO (I_Component Automation.Interface)
add0 componentType =
  Automation.function1 "Add" [Automation.inVariant componentType] Automation.outIDispatch
import0 :: Prelude.String -> IComponents a -> Prelude.IO (I_Component Automation.Interface)
import0 fileName =
  Automation.function1 "Import" [Automation.inString fileName] Automation.outIDispatch
-- --------------------------------------------------
-- 
-- coclass Components0
-- 
-- --------------------------------------------------
clsidComponents0 :: Com.CLSID
clsidComponents0 =
  Com.mkCLSID "{BE39F3D6-1B13-11D0-887F-00A0C90F2744}"
-- --------------------------------------------------
-- 
-- interface VBComponents
-- 
-- --------------------------------------------------
data VBComponents a = VBComponents
                       
type IVBComponents a = Automation.IDispatch (VBComponents a)
type I_VBComponents a = IVBComponents a
iidIVBComponents :: Com.IID (IVBComponents Automation.Interface)
iidIVBComponents =
  Com.mkIID "{0002E162-0000-0000-C000-000000000046}"
item4 :: Prelude.Int -> IVBComponents a -> Prelude.IO (I_VBComponent Automation.Interface)
item4 index =
  Automation.function1 "Item" [Automation.inInt index] Automation.outIDispatch
remove1 :: I_VBComponent a0 -> IVBComponents a -> Prelude.IO ()
remove1 vBComponent =
  Automation.method0 "Remove" [Automation.inIDispatch vBComponent]
add1 :: (Automation.Variant a0) => a0 -> IVBComponents a -> Prelude.IO (I_VBComponent Automation.Interface)
add1 componentType =
  Automation.function1 "Add" [Automation.inVariant componentType] Automation.outIDispatch
import1 :: Prelude.String -> IVBComponents a -> Prelude.IO (I_VBComponent Automation.Interface)
import1 fileName =
  Automation.function1 "Import" [Automation.inString fileName] Automation.outIDispatch
-- --------------------------------------------------
-- 
-- coclass VBComponents0
-- 
-- --------------------------------------------------
clsidVBComponents0 :: Com.CLSID
clsidVBComponents0 =
  Com.mkCLSID "{BE39F3D7-1B13-11D0-887F-00A0C90F2744}"
-- --------------------------------------------------
-- 
-- interface Component
-- 
-- --------------------------------------------------
data Component a = Component
                    
type IComponent a = Automation.IDispatch (Component a)
type I_Component a = IComponent a
iidIComponent :: Com.IID (IComponent Automation.Interface)
iidIComponent = Com.mkIID "{0002E163-0000-0000-C000-000000000046}"
getParent7 :: IComponent a -> Prelude.IO (I_Components Automation.Interface)
getParent7 =
  Automation.propertyGet "Parent" [] Automation.outIDispatch
getIsDirty :: IComponent a -> Prelude.IO (Prelude.Int)
getIsDirty = Automation.propertyGet "IsDirty" [] Automation.outInt
setIsDirty :: Prelude.Int -> IComponent a -> Prelude.IO ()
setIsDirty lpfReturn =
  Automation.propertySet "IsDirty" [Automation.inInt lpfReturn]
-- --------------------------------------------------
-- 
-- coclass Component0
-- 
-- --------------------------------------------------
clsidComponent0 :: Com.CLSID
clsidComponent0 =
  Com.mkCLSID "{BE39F3D8-1B13-11D0-887F-00A0C90F2744}"
-- --------------------------------------------------
-- 
-- interface VBComponent
-- 
-- --------------------------------------------------
data VBComponent a = VBComponent
                      
type IVBComponent a = Automation.IDispatch (VBComponent a)
type I_VBComponent a = IVBComponent a
iidIVBComponent :: Com.IID (IVBComponent Automation.Interface)
iidIVBComponent =
  Com.mkIID "{0002E164-0000-0000-C000-000000000046}"
getDesigner :: IVBComponent a -> Prelude.IO (Automation.IDispatch Automation.Interface)
getDesigner =
  Automation.propertyGet "Designer" [] Automation.outIDispatch
getCodeModule :: Automation.IDispatch a -> Prelude.IO (I_CodeModule Automation.Interface)
getCodeModule =
  Automation.propertyGet "CodeModule" [] Automation.outIDispatch
getType0 :: (Automation.Variant a0) => IVBComponent a -> Prelude.IO (a0)
getType0 = Automation.propertyGet "Type" [] Automation.outVariant
export :: Prelude.String -> IVBComponent a -> Prelude.IO ()
export fileName =
  Automation.method0 "Export" [Automation.inString fileName]
getCollection1 :: IVBComponent a -> Prelude.IO (I_VBComponents Automation.Interface)
getCollection1 =
  Automation.propertyGet "Collection" [] Automation.outIDispatch
getHasOpenDesigner :: IVBComponent a -> Prelude.IO (Prelude.Int)
getHasOpenDesigner =
  Automation.propertyGet "HasOpenDesigner" [] Automation.outInt
getProperties :: IVBComponent a -> Prelude.IO (I_Properties Automation.Interface)
getProperties =
  Automation.propertyGet "Properties" [] Automation.outIDispatch
designerWindow :: IVBComponent a -> Prelude.IO (IWindow Automation.Interface)
designerWindow =
  Automation.function1 "DesignerWindow" [] Automation.outIDispatch
activate :: IVBComponent a -> Prelude.IO ()
activate = Automation.method0 "Activate" []
-- --------------------------------------------------
-- 
-- coclass VBComponent0
-- 
-- --------------------------------------------------
clsidVBComponent0 :: Com.CLSID
clsidVBComponent0 =
  Com.mkCLSID "{BE39F3DA-1B13-11D0-887F-00A0C90F2744}"
-- --------------------------------------------------
-- 
-- interface Property
-- 
-- --------------------------------------------------
data Property a = Property
                   
type IProperty a = Automation.IDispatch (Property a)
iidIProperty :: Com.IID (IProperty Automation.Interface)
iidIProperty = Com.mkIID "{0002E18C-0000-0000-C000-000000000046}"
getValue :: IProperty a -> Prelude.IO (Prelude.Int)
getValue = Automation.propertyGet "Value" [] Automation.outInt
setValue :: Prelude.Int -> IProperty a -> Prelude.IO ()
setValue lppvReturn =
  Automation.propertySet "Value" [Automation.inInt lppvReturn]
getIndexedValue :: Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> IProperty a -> Prelude.IO (Prelude.Int)
getIndexedValue index1 index2 index3 index4 =
  Automation.propertyGet "IndexedValue" [Automation.inInt index1, Automation.inInt index2, Automation.inInt index3, Automation.inInt index4] Automation.outInt
setIndexedValue :: Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> IProperty a -> Prelude.IO ()
setIndexedValue index1 index2 index3 index4 lppvReturn =
  Automation.propertySet "IndexedValue" [Automation.inInt index1, Automation.inInt index2, Automation.inInt index3, Automation.inInt index4, Automation.inInt lppvReturn]
getNumIndices :: IProperty a -> Prelude.IO (Prelude.Int)
getNumIndices =
  Automation.propertyGet "NumIndices" [] Automation.outInt
getParent8 :: IProperty a -> Prelude.IO (I_Properties Automation.Interface)
getParent8 =
  Automation.propertyGet "Parent" [] Automation.outIDispatch
getCollection2 :: IProperty a -> Prelude.IO (I_Properties Automation.Interface)
getCollection2 =
  Automation.propertyGet "Collection" [] Automation.outIDispatch
getObject :: IProperty a -> Prelude.IO (Com.IUnknown Automation.Interface)
getObject =
  Automation.propertyGet "Object" [] Automation.outIUnknown
object :: Com.IUnknown a0 -> IProperty a -> Prelude.IO ()
object lppunk =
  Automation.method0 "Object" [Automation.inIUnknown lppunk]
-- --------------------------------------------------
-- 
-- interface Properties
-- 
-- --------------------------------------------------
data Properties a = Properties
                     
type IProperties a = Automation.IDispatch (Properties a)
type I_Properties a = IProperties a
iidIProperties :: Com.IID (IProperties Automation.Interface)
iidIProperties = Com.mkIID "{0002E188-0000-0000-C000-000000000046}"
item5 :: Prelude.Int -> IProperties a -> Prelude.IO (IProperty Automation.Interface)
item5 index =
  Automation.function1 "Item" [Automation.inInt index] Automation.outIDispatch
getParent9 :: IProperties a -> Prelude.IO (Automation.IDispatch Automation.Interface)
getParent9 =
  Automation.propertyGet "Parent" [] Automation.outIDispatch
-- --------------------------------------------------
-- 
-- coclass Properties0
-- 
-- --------------------------------------------------
clsidProperties0 :: Com.CLSID
clsidProperties0 =
  Com.mkCLSID "{0002E18B-0000-0000-C000-000000000046}"
data Vbext_ProcKind
 = Vbext_pk_Proc
 | Vbext_pk_Let
 | Vbext_pk_Set
 | Vbext_pk_Get
 
marshallVbext_ProcKind :: Vbext_ProcKind -> Prelude.IO Int.Int16
marshallVbext_ProcKind v =
  case v of
     Vbext_pk_Proc -> Prelude.return (0)
     Vbext_pk_Let -> Prelude.return (1)
     Vbext_pk_Set -> Prelude.return (2)
     Vbext_pk_Get -> Prelude.return (3)
unmarshallVbext_ProcKind :: Int.Int16 -> Prelude.IO Vbext_ProcKind
unmarshallVbext_ProcKind v =
  case v of
     0 -> Prelude.return (Vbext_pk_Proc)
     1 -> Prelude.return (Vbext_pk_Let)
     2 -> Prelude.return (Vbext_pk_Set)
     3 -> Prelude.return (Vbext_pk_Get)
     _ -> Prelude.fail (Prelude.userError "unmarshallVbext_ProcKind: illegal enum value ")
-- --------------------------------------------------
-- 
-- interface CodeModule
-- 
-- --------------------------------------------------
data CodeModule a = CodeModule
                     
type ICodeModule a = Automation.IDispatch (CodeModule a)
type I_CodeModule a = ICodeModule a
iidICodeModule :: Com.IID (ICodeModule Automation.Interface)
iidICodeModule = Com.mkIID "{0002E16E-0000-0000-C000-000000000046}"
getParent10 :: ICodeModule a -> Prelude.IO (I_VBComponent Automation.Interface)
getParent10 =
  Automation.propertyGet "Parent" [] Automation.outIDispatch
addFromString :: Prelude.String -> ICodeModule a -> Prelude.IO ()
addFromString string =
  Automation.method0 "AddFromString" [Automation.inString string]
addFromFile :: Prelude.String -> ICodeModule a -> Prelude.IO ()
addFromFile fileName =
  Automation.method0 "AddFromFile" [Automation.inString fileName]
getLines :: Prelude.Int -> Prelude.Int -> ICodeModule a -> Prelude.IO (Prelude.String)
getLines startLine count =
  Automation.propertyGet "Lines" [Automation.inInt startLine, Automation.inInt count] Automation.outString
getCountOfLines :: ICodeModule a -> Prelude.IO (Prelude.Int)
getCountOfLines =
  Automation.propertyGet "CountOfLines" [] Automation.outInt
insertLines :: Prelude.Int -> Prelude.String -> ICodeModule a -> Prelude.IO ()
insertLines line string =
  Automation.method0 "InsertLines" [Automation.inInt line, Automation.inString string]
deleteLines :: Prelude.Int -> Prelude.Int -> ICodeModule a -> Prelude.IO ()
deleteLines startLine count =
  Automation.method0 "DeleteLines" [Automation.inInt startLine, Automation.inInt count]
replaceLine :: Prelude.Int -> Prelude.String -> ICodeModule a -> Prelude.IO ()
replaceLine line string =
  Automation.method0 "ReplaceLine" [Automation.inInt line, Automation.inString string]
getProcStartLine :: (Automation.Variant a0) => Prelude.String -> a0 -> ICodeModule a -> Prelude.IO (Prelude.Int)
getProcStartLine procName procKind =
  Automation.propertyGet "ProcStartLine" [Automation.inString procName, Automation.inVariant procKind] Automation.outInt
getProcCountLines :: (Automation.Variant a0) => Prelude.String -> a0 -> ICodeModule a -> Prelude.IO (Prelude.Int)
getProcCountLines procName procKind =
  Automation.propertyGet "ProcCountLines" [Automation.inString procName, Automation.inVariant procKind] Automation.outInt
getProcBodyLine :: (Automation.Variant a0) => Prelude.String -> a0 -> ICodeModule a -> Prelude.IO (Prelude.Int)
getProcBodyLine procName procKind =
  Automation.propertyGet "ProcBodyLine" [Automation.inString procName, Automation.inVariant procKind] Automation.outInt
getProcOfLine :: (Automation.Variant a0) => Prelude.Int -> ICodeModule a -> Prelude.IO (a0) --, Prelude.String)
getProcOfLine line =
  Automation.propertyGet "ProcOfLine" [Automation.inInt line] Automation.outVariant -- Automation.outString
getCountOfDeclarationLines :: ICodeModule a -> Prelude.IO (Prelude.Int)
getCountOfDeclarationLines =
  Automation.propertyGet "CountOfDeclarationLines" [] Automation.outInt
createEventProc :: Prelude.String -> Prelude.String -> ICodeModule a -> Prelude.IO (Prelude.Int)
createEventProc eventName objectName =
  Automation.function1 "CreateEventProc" [Automation.inString eventName, Automation.inString objectName] Automation.outInt
--find :: Prelude.String -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> ICodeModule a -> Prelude.IO (Prelude.Int, Prelude.Int, Prelude.Int, Prelude.Int, Prelude.Int)
--find target startLine startColumn endLine endColumn wholeWord matchCase patternSearch =
--  Automation.function5 "Find" [Automation.inString target, Automation.inInt wholeWord, Automation.inInt matchCase, Automation.inInt patternSearch, Automation.inoutInt startLine, Automation.inoutInt startColumn, Automation.inoutInt endLine, Automation.inoutInt endColumn] Automation.inoutInt Automation.inoutInt Automation.inoutInt Automation.inoutInt Automation.outInt
getCodePane :: ICodeModule a -> Prelude.IO (I_CodePane Automation.Interface)
getCodePane =
  Automation.propertyGet "CodePane" [] Automation.outIDispatch
-- --------------------------------------------------
-- 
-- coclass CodeModule0
-- 
-- --------------------------------------------------
clsidCodeModule0 :: Com.CLSID
clsidCodeModule0 =
  Com.mkCLSID "{0002E170-0000-0000-C000-000000000046}"
-- --------------------------------------------------
-- 
-- interface CodePanes
-- 
-- --------------------------------------------------
data CodePanes a = CodePanes
                    
type ICodePanes a = Automation.IDispatch (CodePanes a)
type I_CodePanes a = ICodePanes a
iidICodePanes :: Com.IID (ICodePanes Automation.Interface)
iidICodePanes = Com.mkIID "{0002E172-0000-0000-C000-000000000046}"
item6 :: Prelude.Int -> I_CodePanes a -> Prelude.IO (I_CodePane Automation.Interface)
item6 index =
  Automation.function1 "Item" [Automation.inInt index] Automation.outIDispatch
getCurrent :: I_CodePanes a -> Prelude.IO (I_CodePane Automation.Interface)
getCurrent =
  Automation.propertyGet "Current" [] Automation.outIDispatch
setCurrent :: I_CodePane a0 -> I_CodePanes a -> Prelude.IO ()
setCurrent codePane =
  Automation.propertySet "Current" [Automation.inIDispatch codePane]
-- --------------------------------------------------
-- 
-- coclass CodePanes0
-- 
-- --------------------------------------------------
clsidCodePanes0 :: Com.CLSID
clsidCodePanes0 =
  Com.mkCLSID "{0002E174-0000-0000-C000-000000000046}"
data Vbext_CodePaneview
 = Vbext_cv_ProcedureView
 | Vbext_cv_FullModuleView
 
marshallVbext_CodePaneview :: Vbext_CodePaneview -> Prelude.IO Int.Int16
marshallVbext_CodePaneview v =
  case v of
     Vbext_cv_ProcedureView -> Prelude.return (0)
     Vbext_cv_FullModuleView -> Prelude.return (1)
unmarshallVbext_CodePaneview :: Int.Int16 -> Prelude.IO Vbext_CodePaneview
unmarshallVbext_CodePaneview v =
  case v of
     0 -> Prelude.return (Vbext_cv_ProcedureView)
     1 -> Prelude.return (Vbext_cv_FullModuleView)
     _ -> Prelude.fail (Prelude.userError "unmarshallVbext_CodePaneview: illegal enum value ")
-- --------------------------------------------------
-- 
-- interface CodePane
-- 
-- --------------------------------------------------
data CodePane a = CodePane
                   
type ICodePane a = Automation.IDispatch (CodePane a)
type I_CodePane a = ICodePane a
iidICodePane :: Com.IID (ICodePane Automation.Interface)
iidICodePane = Com.mkIID "{0002E176-0000-0000-C000-000000000046}"
getCollection3 :: ICodePane a -> Prelude.IO (I_CodePanes Automation.Interface)
getCollection3 =
  Automation.propertyGet "Collection" [] Automation.outIDispatch
getWindow :: ICodePane a -> Prelude.IO (IWindow Automation.Interface)
getWindow =
  Automation.propertyGet "Window" [] Automation.outIDispatch
getSelection :: ICodePane a -> Prelude.IO (Prelude.Int, Prelude.Int, Prelude.Int, Prelude.Int)
getSelection =
  Automation.method4 "GetSelection" [] Automation.outInt Automation.outInt Automation.outInt Automation.outInt
setSelection :: Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> ICodePane a -> Prelude.IO ()
setSelection startLine startColumn endLine endColumn =
  Automation.method0 "SetSelection" [Automation.inInt startLine, Automation.inInt startColumn, Automation.inInt endLine, Automation.inInt endColumn]
getTopLine :: ICodePane a -> Prelude.IO (Prelude.Int)
getTopLine = Automation.propertyGet "TopLine" [] Automation.outInt
setTopLine :: Prelude.Int -> ICodePane a -> Prelude.IO ()
setTopLine topLine =
  Automation.propertySet "TopLine" [Automation.inInt topLine]
getCountOfVisibleLines :: ICodePane a -> Prelude.IO (Prelude.Int)
getCountOfVisibleLines =
  Automation.propertyGet "CountOfVisibleLines" [] Automation.outInt
show :: ICodePane a -> Prelude.IO ()
show = Automation.method0 "Show" []
getCodePaneView :: (Automation.Variant a0) => ICodePane a -> Prelude.IO (a0)
getCodePaneView =
  Automation.propertyGet "CodePaneView" [] Automation.outVariant
-- --------------------------------------------------
-- 
-- coclass CodePane0
-- 
-- --------------------------------------------------
clsidCodePane0 :: Com.CLSID
clsidCodePane0 =
  Com.mkCLSID "{0002E178-0000-0000-C000-000000000046}"
-- --------------------------------------------------
-- 
-- interface References
-- 
-- --------------------------------------------------
data References a = References
                     
type IReferences a = Automation.IDispatch (References a)
type I_References a = IReferences a
iidIReferences :: Com.IID (IReferences Automation.Interface)
iidIReferences = Com.mkIID "{0002E17A-0000-0000-C000-000000000046}"
item7 :: Prelude.Int -> IReferences a -> Prelude.IO (IReference Automation.Interface)
item7 index =
  Automation.function1 "Item" [Automation.inInt index] Automation.outIDispatch
addFromGuid :: Prelude.String -> Prelude.Int -> Prelude.Int -> IReferences a -> Prelude.IO (IReference Automation.Interface)
addFromGuid guid major minor =
  Automation.function1 "AddFromGuid" [Automation.inString guid, Automation.inInt major, Automation.inInt minor] Automation.outIDispatch
addFromFile0 :: Prelude.String -> Automation.IDispatch a -> Prelude.IO (IReference Automation.Interface)
addFromFile0 fileName =
  Automation.function1 "AddFromFile" [Automation.inString fileName] Automation.outIDispatch
remove2 :: IReference a0 -> IReferences a -> Prelude.IO ()
remove2 reference =
  Automation.method0 "Remove" [Automation.inIDispatch reference]
data Vbext_RefKind
 = Vbext_rk_TypeLib
 | Vbext_rk_Project
 
marshallVbext_RefKind :: Vbext_RefKind -> Prelude.IO Int.Int16
marshallVbext_RefKind v =
  case v of
     Vbext_rk_TypeLib -> Prelude.return (0)
     Vbext_rk_Project -> Prelude.return (1)
unmarshallVbext_RefKind :: Int.Int16 -> Prelude.IO Vbext_RefKind
unmarshallVbext_RefKind v =
  case v of
     0 -> Prelude.return (Vbext_rk_TypeLib)
     1 -> Prelude.return (Vbext_rk_Project)
     _ -> Prelude.fail (Prelude.userError "unmarshallVbext_RefKind: illegal enum value ")
-- --------------------------------------------------
-- 
-- interface Reference
-- 
-- --------------------------------------------------
data Reference a = Reference
                    
type IReference a = Automation.IDispatch (Reference a)
iidIReference :: Com.IID (IReference Automation.Interface)
iidIReference = Com.mkIID "{0002E17E-0000-0000-C000-000000000046}"
getCollection4 :: IReference a -> Prelude.IO (I_References Automation.Interface)
getCollection4 =
  Automation.propertyGet "Collection" [] Automation.outIDispatch
getGuid :: IReference a -> Prelude.IO (Prelude.String)
getGuid = Automation.propertyGet "Guid" [] Automation.outString
getMajor :: IReference a -> Prelude.IO (Prelude.Int)
getMajor = Automation.propertyGet "Major" [] Automation.outInt
getMinor :: IReference a -> Prelude.IO (Prelude.Int)
getMinor = Automation.propertyGet "Minor" [] Automation.outInt
getFullPath :: IReference a -> Prelude.IO (Prelude.String)
getFullPath =
  Automation.propertyGet "FullPath" [] Automation.outString
getBuiltIn :: IReference a -> Prelude.IO (Prelude.Int)
getBuiltIn = Automation.propertyGet "BuiltIn" [] Automation.outInt
getIsBroken :: IReference a -> Prelude.IO (Prelude.Int)
getIsBroken =
  Automation.propertyGet "IsBroken" [] Automation.outInt
getType1 :: (Automation.Variant a0) => IReference a -> Prelude.IO (a0)
getType1 = Automation.propertyGet "Type" [] Automation.outVariant
-- --------------------------------------------------
-- 
-- dispinterface DispReferences_Events
-- 
-- --------------------------------------------------
data References_Events a = References_Events
                            
type DispReferences_Events a = Automation.IDispatch (References_Events a)
iidDispReferences_Events :: Com.IID (DispReferences_Events Automation.Interface)
iidDispReferences_Events =
  Com.mkIID "{CDDE3804-2064-11CF-867F-00AA005FF34A}"
-- --------------------------------------------------
-- 
-- coclass References0
-- 
-- --------------------------------------------------
clsidReferences0 :: Com.CLSID
clsidReferences0 =
  Com.mkCLSID "{0002E17C-0000-0000-C000-000000000046}"
