\documentclass{article}
\include{/hugs/lib/activex/lhs}

\begin{document}

\begin{notice}
June 1998, Daan Leijen, leijen@@fwi.uva.nl

This module is part of HaskellScript.
See @notice.txt@ for details and conditions of use.
\end{notice}

> module WScript (module HScript,
>                 module WShost,
>                 module WScript) where
> 
> import HScript
> import WShost
> import HScript
> import LibMonad (mapl)

Wscript 

> data WHost a  = WHost
> type IWHost a = IDispatch (WHost a)

> createWScript :: IO (IWHost Interface)
> createWScript    = externRoot

> createWShell :: IO (IWshShell Interface)
> createWShell     = createObject "WScript.Shell"
            
> getArgs :: IWHost a -> IO [String]
> getArgs host
>       = do args <- host # propertyGet "Arguments" [] outIDispatch
>            cnt  <- args # getArgCount
>            mapl (\i -> args # getArgItem i) [0..cnt-1]

> getArgItem :: Int -> IDispatch a -> IO String
> getArgItem i   = function1 "Item" [inInt i] outString

> getArgCount :: IDispatch a -> IO Int
> getArgCount    = function1 "Count" [] outInt


> runCmd cmd         = run cmd (1::Int) True


-----------------------------------------------------------
-- shell - popup 
-----------------------------------------------------------

> data InputType  = InputOk | 
>                   InputOkCancel | 
>                   InputAbortRetryIgnore | 
>                   InputYesNoCancel |
>                   InputYesNo |
>                   InputRetryCancel
>                 deriving Enum  
>                   
> data IconType   = IconStop | 
>                   IconQuest | 
>                   IconExcl | 
>                   IconInfo
                
> data ButtonType = ButtonNull
>                 | ButtonOk 
>                 | ButtonCancel
>                 | ButtonAbort 
>                 | ButtonRetry
>                 | ButtonIgnore
>                 | ButtonYes
>                 | ButtonNo
>                 deriving (Show,Enum)
                
> instance Enum IconType where
>   fromEnum icon = case icon of
>                         IconStop   -> 16
>                         IconQuest  -> 32
>                         IconExcl   -> 48
>                         IconInfo   -> 64
>                         
>   toEnum x      = case x of 16  -> IconStop 
>                             32  -> IconQuest 
>                             48  -> IconExcl 
>                             _   -> IconInfo                     
> 
> popupInfo text
>         = popupBox "Haskell Info" text InputOk IconInfo
> 
> 
> popupBox :: String -> String -> InputType -> IconType -> IWshShell a -> IO ButtonType
> popupBox title text input icon
>         = map toEnum . popup text (0::Int) title (fromEnum input + fromEnum icon)
             
\end{module}