module Excel where

import qualified Prelude
import qualified Automation (Interface, IDispatch, outIDispatch, 
                             propertyGetID, outInt, outFloat, inInt, inFloat, propertySetID, 
                             methodID0, Variant, inVariant, outVariant, inIDispatch, 
                             functionID1, outIUnknown, outString, inString, propertyGet, 
                             propertySet, method0, outDouble, inDouble, function1, inIUnknown)
import qualified Com (IID, mkIID, IUnknown, CLSID, mkCLSID)
import qualified Int (Int16)
import qualified Office (IAssistant, ICommandBars, IFileSearch, 
                        IFind, IShapes, IShapeRange, IShape, ITextFrame, IConnectorFormat, 
                        IGroupShapes, IFreeformBuilder, IMsoDispObj)
import qualified VBIDE (IApplication, IWindow, IVBE, IVBProject)

-- --------------------------------------------------
-- 
-- interface Adjustments
-- 
-- --------------------------------------------------
data Adjustments a = Adjustments
                      
type IAdjustments a = Office.IMsoDispObj (Adjustments a)
iidIAdjustments :: Com.IID (IAdjustments Automation.Interface)
iidIAdjustments =
  Com.mkIID "{000C0310-0000-0000-C000-000000000046}"
getApplication :: Automation.IDispatch a -> Prelude.IO (Automation.IDispatch Automation.Interface)
getApplication =
  Automation.propertyGetID 0x60020000 [] Automation.outIDispatch
getCreator :: Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getCreator =
  Automation.propertyGetID 0x60020001 [] Automation.outInt
getParent :: Automation.IDispatch a -> Prelude.IO (Automation.IDispatch Automation.Interface)
getParent = Automation.propertyGetID 0x1 [] Automation.outIDispatch
getCount :: Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getCount = Automation.propertyGetID 0x2 [] Automation.outInt
getItem :: Prelude.Int -> IAdjustments a -> Prelude.IO (Prelude.Float)
getItem index =
  Automation.propertyGetID 0o0 [Automation.inInt index] Automation.outFloat
setItem :: Prelude.Int -> Prelude.Float -> IAdjustments a -> Prelude.IO ()
setItem index val =
  Automation.propertySetID 0o0 [Automation.inInt index, Automation.inFloat val]
-- --------------------------------------------------
-- 
-- interface CalloutFormat
-- 
-- --------------------------------------------------
data CalloutFormat a = CalloutFormat
                        
type ICalloutFormat a = Office.IMsoDispObj (CalloutFormat a)
iidICalloutFormat :: Com.IID (ICalloutFormat Automation.Interface)
iidICalloutFormat =
  Com.mkIID "{000C0311-0000-0000-C000-000000000046}"
automaticLength :: ICalloutFormat a -> Prelude.IO ()
automaticLength = Automation.methodID0 0xa []
customDrop :: Prelude.Float -> ICalloutFormat a -> Prelude.IO ()
customDrop drop =
  Automation.methodID0 0xb [Automation.inFloat drop]
customLength :: Prelude.Float -> ICalloutFormat a -> Prelude.IO ()
customLength length =
  Automation.methodID0 0xc [Automation.inFloat length]
presetDrop :: (Automation.Variant a0) => a0 -> ICalloutFormat a -> Prelude.IO ()
presetDrop dropType =
  Automation.methodID0 0xd [Automation.inVariant dropType]
getAccent :: (Automation.Variant a0) => ICalloutFormat a -> Prelude.IO (a0)
getAccent = Automation.propertyGetID 0x64 [] Automation.outVariant
setAccent :: (Automation.Variant a0) => a0 -> ICalloutFormat a -> Prelude.IO ()
setAccent accent =
  Automation.propertySetID 0x64 [Automation.inVariant accent]
getAngle :: (Automation.Variant a0) => ICalloutFormat a -> Prelude.IO (a0)
getAngle = Automation.propertyGetID 0x65 [] Automation.outVariant
setAngle :: (Automation.Variant a0) => a0 -> ICalloutFormat a -> Prelude.IO ()
setAngle angle =
  Automation.propertySetID 0x65 [Automation.inVariant angle]
getAutoAttach :: (Automation.Variant a0) => ICalloutFormat a -> Prelude.IO (a0)
getAutoAttach =
  Automation.propertyGetID 0x66 [] Automation.outVariant
setAutoAttach :: (Automation.Variant a0) => a0 -> ICalloutFormat a -> Prelude.IO ()
setAutoAttach autoAttach =
  Automation.propertySetID 0x66 [Automation.inVariant autoAttach]
getAutoLength :: (Automation.Variant a0) => ICalloutFormat a -> Prelude.IO (a0)
getAutoLength =
  Automation.propertyGetID 0x67 [] Automation.outVariant
getBorder :: (Automation.Variant a0) => ICalloutFormat a -> Prelude.IO (a0)
getBorder = Automation.propertyGetID 0x68 [] Automation.outVariant
setBorder :: (Automation.Variant a0) => a0 -> ICalloutFormat a -> Prelude.IO ()
setBorder border =
  Automation.propertySetID 0x68 [Automation.inVariant border]
getDrop :: ICalloutFormat a -> Prelude.IO (Prelude.Float)
getDrop = Automation.propertyGetID 0x69 [] Automation.outFloat
getDropType :: (Automation.Variant a0) => ICalloutFormat a -> Prelude.IO (a0)
getDropType =
  Automation.propertyGetID 0x6a [] Automation.outVariant
getGap :: ICalloutFormat a -> Prelude.IO (Prelude.Float)
getGap = Automation.propertyGetID 0x6b [] Automation.outFloat
setGap :: Prelude.Float -> ICalloutFormat a -> Prelude.IO ()
setGap gap = Automation.propertySetID 0x6b [Automation.inFloat gap]
getLength :: ICalloutFormat a -> Prelude.IO (Prelude.Float)
getLength = Automation.propertyGetID 0x6c [] Automation.outFloat
getType :: (Automation.Variant a0) => ICalloutFormat a -> Prelude.IO (a0)
getType = Automation.propertyGetID 0x6d [] Automation.outVariant
setType :: (Automation.Variant a0) => a0 -> ICalloutFormat a -> Prelude.IO ()
setType type0 =
  Automation.propertySetID 0x6d [Automation.inVariant type0]
-- --------------------------------------------------
-- 
-- interface ColorFormat
-- 
-- --------------------------------------------------
data ColorFormat a = ColorFormat
                      
type IColorFormat a = Office.IMsoDispObj (ColorFormat a)
iidIColorFormat :: Com.IID (IColorFormat Automation.Interface)
iidIColorFormat =
  Com.mkIID "{000C0312-0000-0000-C000-000000000046}"
getRGB :: Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getRGB = Automation.propertyGetID 0o0 [] Automation.outInt
setRGB :: Prelude.Int -> IColorFormat a -> Prelude.IO ()
setRGB rGB = Automation.propertySetID 0o0 [Automation.inInt rGB]
getSchemeColor :: Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getSchemeColor = Automation.propertyGetID 0x64 [] Automation.outInt
setSchemeColor :: Prelude.Int -> Automation.IDispatch a -> Prelude.IO ()
setSchemeColor schemeColor =
  Automation.propertySetID 0x64 [Automation.inInt schemeColor]
getType0 :: (Automation.Variant a0) => IColorFormat a -> Prelude.IO (a0)
getType0 = Automation.propertyGetID 0x65 [] Automation.outVariant
-- --------------------------------------------------
-- 
-- interface LineFormat
-- 
-- --------------------------------------------------
data LineFormat a = LineFormat
                     
type ILineFormat a = Office.IMsoDispObj (LineFormat a)
iidILineFormat :: Com.IID (ILineFormat Automation.Interface)
iidILineFormat = Com.mkIID "{000C0317-0000-0000-C000-000000000046}"
getBackColor :: Automation.IDispatch a -> Prelude.IO (IColorFormat Automation.Interface)
getBackColor =
  Automation.propertyGetID 0x64 [] Automation.outIDispatch
setBackColor :: IColorFormat a0 -> Automation.IDispatch a -> Prelude.IO ()
setBackColor backColor =
  Automation.propertySetID 0x64 [Automation.inIDispatch backColor]
getBeginArrowheadLength :: (Automation.Variant a0) => ILineFormat a -> Prelude.IO (a0)
getBeginArrowheadLength =
  Automation.propertyGetID 0x65 [] Automation.outVariant
setBeginArrowheadLength :: (Automation.Variant a0) => a0 -> ILineFormat a -> Prelude.IO ()
setBeginArrowheadLength beginArrowheadLength =
  Automation.propertySetID 0x65 [Automation.inVariant beginArrowheadLength]
getBeginArrowheadStyle :: (Automation.Variant a0) => ILineFormat a -> Prelude.IO (a0)
getBeginArrowheadStyle =
  Automation.propertyGetID 0x66 [] Automation.outVariant
setBeginArrowheadStyle :: (Automation.Variant a0) => a0 -> ILineFormat a -> Prelude.IO ()
setBeginArrowheadStyle beginArrowheadStyle =
  Automation.propertySetID 0x66 [Automation.inVariant beginArrowheadStyle]
getBeginArrowheadWidth :: (Automation.Variant a0) => ILineFormat a -> Prelude.IO (a0)
getBeginArrowheadWidth =
  Automation.propertyGetID 0x67 [] Automation.outVariant
setBeginArrowheadWidth :: (Automation.Variant a0) => a0 -> ILineFormat a -> Prelude.IO ()
setBeginArrowheadWidth beginArrowheadWidth =
  Automation.propertySetID 0x67 [Automation.inVariant beginArrowheadWidth]
getDashStyle :: (Automation.Variant a0) => ILineFormat a -> Prelude.IO (a0)
getDashStyle =
  Automation.propertyGetID 0x68 [] Automation.outVariant
setDashStyle :: (Automation.Variant a0) => a0 -> ILineFormat a -> Prelude.IO ()
setDashStyle dashStyle =
  Automation.propertySetID 0x68 [Automation.inVariant dashStyle]
getEndArrowheadLength :: (Automation.Variant a0) => ILineFormat a -> Prelude.IO (a0)
getEndArrowheadLength =
  Automation.propertyGetID 0x69 [] Automation.outVariant
setEndArrowheadLength :: (Automation.Variant a0) => a0 -> ILineFormat a -> Prelude.IO ()
setEndArrowheadLength endArrowheadLength =
  Automation.propertySetID 0x69 [Automation.inVariant endArrowheadLength]
getEndArrowheadStyle :: (Automation.Variant a0) => ILineFormat a -> Prelude.IO (a0)
getEndArrowheadStyle =
  Automation.propertyGetID 0x6a [] Automation.outVariant
setEndArrowheadStyle :: (Automation.Variant a0) => a0 -> ILineFormat a -> Prelude.IO ()
setEndArrowheadStyle endArrowheadStyle =
  Automation.propertySetID 0x6a [Automation.inVariant endArrowheadStyle]
getEndArrowheadWidth :: (Automation.Variant a0) => ILineFormat a -> Prelude.IO (a0)
getEndArrowheadWidth =
  Automation.propertyGetID 0x6b [] Automation.outVariant
setEndArrowheadWidth :: (Automation.Variant a0) => a0 -> ILineFormat a -> Prelude.IO ()
setEndArrowheadWidth endArrowheadWidth =
  Automation.propertySetID 0x6b [Automation.inVariant endArrowheadWidth]
getForeColor :: Automation.IDispatch a -> Prelude.IO (IColorFormat Automation.Interface)
getForeColor =
  Automation.propertyGetID 0x6c [] Automation.outIDispatch
setForeColor :: IColorFormat a0 -> Automation.IDispatch a -> Prelude.IO ()
setForeColor foreColor =
  Automation.propertySetID 0x6c [Automation.inIDispatch foreColor]
getPattern :: (Automation.Variant a0) => Automation.IDispatch a -> Prelude.IO (a0)
getPattern = Automation.propertyGetID 0x6d [] Automation.outVariant
setPattern :: (Automation.Variant a0) => a0 -> ILineFormat a -> Prelude.IO ()
setPattern pattern =
  Automation.propertySetID 0x6d [Automation.inVariant pattern]
getStyle :: (Automation.Variant a0) => ILineFormat a -> Prelude.IO (a0)
getStyle = Automation.propertyGetID 0x6e [] Automation.outVariant
setStyle :: (Automation.Variant a0) => a0 -> ILineFormat a -> Prelude.IO ()
setStyle style =
  Automation.propertySetID 0x6e [Automation.inVariant style]
getTransparency :: Automation.IDispatch a -> Prelude.IO (Prelude.Float)
getTransparency =
  Automation.propertyGetID 0x6f [] Automation.outFloat
setTransparency :: Prelude.Float -> Automation.IDispatch a -> Prelude.IO ()
setTransparency transparency =
  Automation.propertySetID 0x6f [Automation.inFloat transparency]
getVisible :: (Automation.Variant a0) => Automation.IDispatch a -> Prelude.IO (a0)
getVisible = Automation.propertyGetID 0x70 [] Automation.outVariant
setVisible :: (Automation.Variant a0) => a0 -> Automation.IDispatch a -> Prelude.IO ()
setVisible visible =
  Automation.propertySetID 0x70 [Automation.inVariant visible]
getWeight :: ILineFormat a -> Prelude.IO (Prelude.Float)
getWeight = Automation.propertyGetID 0x71 [] Automation.outFloat
setWeight :: Prelude.Float -> ILineFormat a -> Prelude.IO ()
setWeight weight =
  Automation.propertySetID 0x71 [Automation.inFloat weight]
-- --------------------------------------------------
-- 
-- interface ShapeNode
-- 
-- --------------------------------------------------
data ShapeNode a = ShapeNode
                    
type IShapeNode a = Office.IMsoDispObj (ShapeNode a)
iidIShapeNode :: Com.IID (IShapeNode Automation.Interface)
iidIShapeNode = Com.mkIID "{000C0318-0000-0000-C000-000000000046}"
getEditingType :: (Automation.Variant a0) => IShapeNode a -> Prelude.IO (a0)
getEditingType =
  Automation.propertyGetID 0x64 [] Automation.outVariant
getPoints :: IShapeNode a -> Prelude.IO (Prelude.Int)
getPoints = Automation.propertyGetID 0x65 [] Automation.outInt
getSegmentType :: (Automation.Variant a0) => IShapeNode a -> Prelude.IO (a0)
getSegmentType =
  Automation.propertyGetID 0x66 [] Automation.outVariant
-- --------------------------------------------------
-- 
-- interface ShapeNodes
-- 
-- --------------------------------------------------
data ShapeNodes a = ShapeNodes
                     
type IShapeNodes a = Office.IMsoDispObj (ShapeNodes a)
iidIShapeNodes :: Com.IID (IShapeNodes Automation.Interface)
iidIShapeNodes = Com.mkIID "{000C0319-0000-0000-C000-000000000046}"
item :: Prelude.Int -> IShapeNodes a -> Prelude.IO (IShapeNode Automation.Interface)
item index =
  Automation.functionID1 0o0 [Automation.inInt index] Automation.outIDispatch
getNewEnum :: Automation.IDispatch a -> Prelude.IO (Com.IUnknown Automation.Interface)
getNewEnum =
  Automation.propertyGetID 0xfffffffc [] Automation.outIUnknown
delete :: Prelude.Int -> Automation.IDispatch a -> Prelude.IO ()
delete index = Automation.methodID0 0xb [Automation.inInt index]
insert :: (Automation.Variant a0, Automation.Variant a1) => Prelude.Int -> a0 -> a1 -> Prelude.Float -> Prelude.Float -> Prelude.Float -> Prelude.Float -> Prelude.Float -> Prelude.Float -> IShapeNodes a -> Prelude.IO ()
insert index segmentType editingType x1 y1 x2 y2 x3 y3 =
  Automation.methodID0 0xc [Automation.inInt index, Automation.inVariant segmentType, Automation.inVariant editingType, Automation.inFloat x1, Automation.inFloat y1, Automation.inFloat x2, Automation.inFloat y2, Automation.inFloat x3, Automation.inFloat y3]
setEditingType :: (Automation.Variant a0) => Prelude.Int -> a0 -> IShapeNodes a -> Prelude.IO ()
setEditingType index editingType =
  Automation.methodID0 0xd [Automation.inInt index, Automation.inVariant editingType]
setPosition :: Prelude.Int -> Prelude.Float -> Prelude.Float -> IShapeNodes a -> Prelude.IO ()
setPosition index x1 y1 =
  Automation.methodID0 0xe [Automation.inInt index, Automation.inFloat x1, Automation.inFloat y1]
setSegmentType :: (Automation.Variant a0) => Prelude.Int -> a0 -> IShapeNodes a -> Prelude.IO ()
setSegmentType index segmentType =
  Automation.methodID0 0xf [Automation.inInt index, Automation.inVariant segmentType]
-- --------------------------------------------------
-- 
-- interface PictureFormat
-- 
-- --------------------------------------------------
data PictureFormat a = PictureFormat
                        
type IPictureFormat a = Office.IMsoDispObj (PictureFormat a)
iidIPictureFormat :: Com.IID (IPictureFormat Automation.Interface)
iidIPictureFormat =
  Com.mkIID "{000C031A-0000-0000-C000-000000000046}"
incrementBrightness :: Prelude.Float -> IPictureFormat a -> Prelude.IO ()
incrementBrightness increment =
  Automation.methodID0 0xa [Automation.inFloat increment]
incrementContrast :: Prelude.Float -> IPictureFormat a -> Prelude.IO ()
incrementContrast increment =
  Automation.methodID0 0xb [Automation.inFloat increment]
getBrightness :: IPictureFormat a -> Prelude.IO (Prelude.Float)
getBrightness =
  Automation.propertyGetID 0x64 [] Automation.outFloat
setBrightness :: Prelude.Float -> IPictureFormat a -> Prelude.IO ()
setBrightness brightness =
  Automation.propertySetID 0x64 [Automation.inFloat brightness]
getColorType :: (Automation.Variant a0) => IPictureFormat a -> Prelude.IO (a0)
getColorType =
  Automation.propertyGetID 0x65 [] Automation.outVariant
setColorType :: (Automation.Variant a0) => a0 -> IPictureFormat a -> Prelude.IO ()
setColorType colorType =
  Automation.propertySetID 0x65 [Automation.inVariant colorType]
getContrast :: IPictureFormat a -> Prelude.IO (Prelude.Float)
getContrast = Automation.propertyGetID 0x66 [] Automation.outFloat
setContrast :: Prelude.Float -> IPictureFormat a -> Prelude.IO ()
setContrast contrast =
  Automation.propertySetID 0x66 [Automation.inFloat contrast]
getCropBottom :: IPictureFormat a -> Prelude.IO (Prelude.Float)
getCropBottom =
  Automation.propertyGetID 0x67 [] Automation.outFloat
setCropBottom :: Prelude.Float -> IPictureFormat a -> Prelude.IO ()
setCropBottom cropBottom =
  Automation.propertySetID 0x67 [Automation.inFloat cropBottom]
getCropLeft :: IPictureFormat a -> Prelude.IO (Prelude.Float)
getCropLeft = Automation.propertyGetID 0x68 [] Automation.outFloat
setCropLeft :: Prelude.Float -> IPictureFormat a -> Prelude.IO ()
setCropLeft cropLeft =
  Automation.propertySetID 0x68 [Automation.inFloat cropLeft]
getCropRight :: IPictureFormat a -> Prelude.IO (Prelude.Float)
getCropRight = Automation.propertyGetID 0x69 [] Automation.outFloat
setCropRight :: Prelude.Float -> IPictureFormat a -> Prelude.IO ()
setCropRight cropRight =
  Automation.propertySetID 0x69 [Automation.inFloat cropRight]
getCropTop :: IPictureFormat a -> Prelude.IO (Prelude.Float)
getCropTop = Automation.propertyGetID 0x6a [] Automation.outFloat
setCropTop :: Prelude.Float -> IPictureFormat a -> Prelude.IO ()
setCropTop cropTop =
  Automation.propertySetID 0x6a [Automation.inFloat cropTop]
getTransparencyColor :: IPictureFormat a -> Prelude.IO (Prelude.Int)
getTransparencyColor =
  Automation.propertyGetID 0x6b [] Automation.outInt
setTransparencyColor :: Prelude.Int -> IPictureFormat a -> Prelude.IO ()
setTransparencyColor transparencyColor =
  Automation.propertySetID 0x6b [Automation.inInt transparencyColor]
getTransparentBackground :: (Automation.Variant a0) => IPictureFormat a -> Prelude.IO (a0)
getTransparentBackground =
  Automation.propertyGetID 0x6c [] Automation.outVariant
setTransparentBackground :: (Automation.Variant a0) => a0 -> IPictureFormat a -> Prelude.IO ()
setTransparentBackground transparentBackground =
  Automation.propertySetID 0x6c [Automation.inVariant transparentBackground]
-- --------------------------------------------------
-- 
-- interface ShadowFormat
-- 
-- --------------------------------------------------
data ShadowFormat a = ShadowFormat
                       
type IShadowFormat a = Office.IMsoDispObj (ShadowFormat a)
iidIShadowFormat :: Com.IID (IShadowFormat Automation.Interface)
iidIShadowFormat =
  Com.mkIID "{000C031B-0000-0000-C000-000000000046}"
incrementOffsetX :: Prelude.Float -> IShadowFormat a -> Prelude.IO ()
incrementOffsetX increment =
  Automation.methodID0 0xa [Automation.inFloat increment]
incrementOffsetY :: Prelude.Float -> IShadowFormat a -> Prelude.IO ()
incrementOffsetY increment =
  Automation.methodID0 0xb [Automation.inFloat increment]
getObscured :: (Automation.Variant a0) => IShadowFormat a -> Prelude.IO (a0)
getObscured =
  Automation.propertyGetID 0x65 [] Automation.outVariant
setObscured :: (Automation.Variant a0) => a0 -> IShadowFormat a -> Prelude.IO ()
setObscured obscured =
  Automation.propertySetID 0x65 [Automation.inVariant obscured]
getOffsetX :: IShadowFormat a -> Prelude.IO (Prelude.Float)
getOffsetX = Automation.propertyGetID 0x66 [] Automation.outFloat
setOffsetX :: Prelude.Float -> IShadowFormat a -> Prelude.IO ()
setOffsetX offsetX =
  Automation.propertySetID 0x66 [Automation.inFloat offsetX]
getOffsetY :: IShadowFormat a -> Prelude.IO (Prelude.Float)
getOffsetY = Automation.propertyGetID 0x67 [] Automation.outFloat
setOffsetY :: Prelude.Float -> IShadowFormat a -> Prelude.IO ()
setOffsetY offsetY =
  Automation.propertySetID 0x67 [Automation.inFloat offsetY]
getType1 :: (Automation.Variant a0) => IShadowFormat a -> Prelude.IO (a0)
getType1 = Automation.propertyGetID 0x69 [] Automation.outVariant
setType0 :: (Automation.Variant a0) => a0 -> IShadowFormat a -> Prelude.IO ()
setType0 type0 =
  Automation.propertySetID 0x69 [Automation.inVariant type0]
-- --------------------------------------------------
-- 
-- interface TextEffectFormat
-- 
-- --------------------------------------------------
data TextEffectFormat a = TextEffectFormat
                           
type ITextEffectFormat a = Office.IMsoDispObj (TextEffectFormat a)
iidITextEffectFormat :: Com.IID (ITextEffectFormat Automation.Interface)
iidITextEffectFormat =
  Com.mkIID "{000C031F-0000-0000-C000-000000000046}"
toggleVerticalText :: ITextEffectFormat a -> Prelude.IO ()
toggleVerticalText = Automation.methodID0 0xa []
getAlignment :: (Automation.Variant a0) => ITextEffectFormat a -> Prelude.IO (a0)
getAlignment =
  Automation.propertyGetID 0x64 [] Automation.outVariant
setAlignment :: (Automation.Variant a0) => a0 -> ITextEffectFormat a -> Prelude.IO ()
setAlignment alignment =
  Automation.propertySetID 0x64 [Automation.inVariant alignment]
getFontBold :: (Automation.Variant a0) => ITextEffectFormat a -> Prelude.IO (a0)
getFontBold =
  Automation.propertyGetID 0x65 [] Automation.outVariant
setFontBold :: (Automation.Variant a0) => a0 -> ITextEffectFormat a -> Prelude.IO ()
setFontBold fontBold =
  Automation.propertySetID 0x65 [Automation.inVariant fontBold]
getFontItalic :: (Automation.Variant a0) => ITextEffectFormat a -> Prelude.IO (a0)
getFontItalic =
  Automation.propertyGetID 0x66 [] Automation.outVariant
setFontItalic :: (Automation.Variant a0) => a0 -> ITextEffectFormat a -> Prelude.IO ()
setFontItalic fontItalic =
  Automation.propertySetID 0x66 [Automation.inVariant fontItalic]
getFontName :: ITextEffectFormat a -> Prelude.IO (Prelude.String)
getFontName = Automation.propertyGetID 0x67 [] Automation.outString
setFontName :: Prelude.String -> ITextEffectFormat a -> Prelude.IO ()
setFontName fontName =
  Automation.propertySetID 0x67 [Automation.inString fontName]
getFontSize :: ITextEffectFormat a -> Prelude.IO (Prelude.Float)
getFontSize = Automation.propertyGetID 0x68 [] Automation.outFloat
setFontSize :: Prelude.Float -> ITextEffectFormat a -> Prelude.IO ()
setFontSize fontSize =
  Automation.propertySetID 0x68 [Automation.inFloat fontSize]
getKernedPairs :: (Automation.Variant a0) => ITextEffectFormat a -> Prelude.IO (a0)
getKernedPairs =
  Automation.propertyGetID 0x69 [] Automation.outVariant
setKernedPairs :: (Automation.Variant a0) => a0 -> ITextEffectFormat a -> Prelude.IO ()
setKernedPairs kernedPairs =
  Automation.propertySetID 0x69 [Automation.inVariant kernedPairs]
getNormalizedHeight :: (Automation.Variant a0) => ITextEffectFormat a -> Prelude.IO (a0)
getNormalizedHeight =
  Automation.propertyGetID 0x6a [] Automation.outVariant
setNormalizedHeight :: (Automation.Variant a0) => a0 -> ITextEffectFormat a -> Prelude.IO ()
setNormalizedHeight normalizedHeight =
  Automation.propertySetID 0x6a [Automation.inVariant normalizedHeight]
getPresetShape :: (Automation.Variant a0) => ITextEffectFormat a -> Prelude.IO (a0)
getPresetShape =
  Automation.propertyGetID 0x6b [] Automation.outVariant
setPresetShape :: (Automation.Variant a0) => a0 -> ITextEffectFormat a -> Prelude.IO ()
setPresetShape presetShape =
  Automation.propertySetID 0x6b [Automation.inVariant presetShape]
getPresetTextEffect :: (Automation.Variant a0) => ITextEffectFormat a -> Prelude.IO (a0)
getPresetTextEffect =
  Automation.propertyGetID 0x6c [] Automation.outVariant
setPresetTextEffect :: (Automation.Variant a0) => a0 -> ITextEffectFormat a -> Prelude.IO ()
setPresetTextEffect preset =
  Automation.propertySetID 0x6c [Automation.inVariant preset]
getRotatedChars :: (Automation.Variant a0) => ITextEffectFormat a -> Prelude.IO (a0)
getRotatedChars =
  Automation.propertyGetID 0x6d [] Automation.outVariant
setRotatedChars :: (Automation.Variant a0) => a0 -> ITextEffectFormat a -> Prelude.IO ()
setRotatedChars rotatedChars =
  Automation.propertySetID 0x6d [Automation.inVariant rotatedChars]
getText :: Automation.IDispatch a -> Prelude.IO (Prelude.String)
getText = Automation.propertyGetID 0x6e [] Automation.outString
setText :: Prelude.String -> Automation.IDispatch a -> Prelude.IO ()
setText text =
  Automation.propertySetID 0x6e [Automation.inString text]
getTracking :: ITextEffectFormat a -> Prelude.IO (Prelude.Float)
getTracking = Automation.propertyGetID 0x6f [] Automation.outFloat
setTracking :: Prelude.Float -> ITextEffectFormat a -> Prelude.IO ()
setTracking tracking =
  Automation.propertySetID 0x6f [Automation.inFloat tracking]
-- --------------------------------------------------
-- 
-- interface ThreeDFormat
-- 
-- --------------------------------------------------
data ThreeDFormat a = ThreeDFormat
                       
type IThreeDFormat a = Office.IMsoDispObj (ThreeDFormat a)
iidIThreeDFormat :: Com.IID (IThreeDFormat Automation.Interface)
iidIThreeDFormat =
  Com.mkIID "{000C0321-0000-0000-C000-000000000046}"
incrementRotationX :: Prelude.Float -> IThreeDFormat a -> Prelude.IO ()
incrementRotationX increment =
  Automation.methodID0 0xa [Automation.inFloat increment]
incrementRotationY :: Prelude.Float -> IThreeDFormat a -> Prelude.IO ()
incrementRotationY increment =
  Automation.methodID0 0xb [Automation.inFloat increment]
resetRotation :: IThreeDFormat a -> Prelude.IO ()
resetRotation = Automation.methodID0 0xc []
setThreeDFormat :: (Automation.Variant a0) => a0 -> IThreeDFormat a -> Prelude.IO ()
setThreeDFormat presetThreeDFormat =
  Automation.methodID0 0xd [Automation.inVariant presetThreeDFormat]
setExtrusionDirection :: (Automation.Variant a0) => a0 -> IThreeDFormat a -> Prelude.IO ()
setExtrusionDirection presetExtrusionDirection =
  Automation.methodID0 0xe [Automation.inVariant presetExtrusionDirection]
getDepth :: IThreeDFormat a -> Prelude.IO (Prelude.Float)
getDepth = Automation.propertyGetID 0x64 [] Automation.outFloat
setDepth :: Prelude.Float -> IThreeDFormat a -> Prelude.IO ()
setDepth depth =
  Automation.propertySetID 0x64 [Automation.inFloat depth]
getExtrusionColor :: IThreeDFormat a -> Prelude.IO (IColorFormat Automation.Interface)
getExtrusionColor =
  Automation.propertyGetID 0x65 [] Automation.outIDispatch
getExtrusionColorType :: (Automation.Variant a0) => IThreeDFormat a -> Prelude.IO (a0)
getExtrusionColorType =
  Automation.propertyGetID 0x66 [] Automation.outVariant
setExtrusionColorType :: (Automation.Variant a0) => a0 -> IThreeDFormat a -> Prelude.IO ()
setExtrusionColorType extrusionColorType =
  Automation.propertySetID 0x66 [Automation.inVariant extrusionColorType]
getPerspective :: (Automation.Variant a0) => IThreeDFormat a -> Prelude.IO (a0)
getPerspective =
  Automation.propertyGetID 0x67 [] Automation.outVariant
setPerspective :: (Automation.Variant a0) => a0 -> IThreeDFormat a -> Prelude.IO ()
setPerspective perspective =
  Automation.propertySetID 0x67 [Automation.inVariant perspective]
getPresetExtrusionDirection :: (Automation.Variant a0) => IThreeDFormat a -> Prelude.IO (a0)
getPresetExtrusionDirection =
  Automation.propertyGetID 0x68 [] Automation.outVariant
getPresetLightingDirection :: (Automation.Variant a0) => IThreeDFormat a -> Prelude.IO (a0)
getPresetLightingDirection =
  Automation.propertyGetID 0x69 [] Automation.outVariant
setPresetLightingDirection :: (Automation.Variant a0) => a0 -> IThreeDFormat a -> Prelude.IO ()
setPresetLightingDirection presetLightingDirection =
  Automation.propertySetID 0x69 [Automation.inVariant presetLightingDirection]
getPresetLightingSoftness :: (Automation.Variant a0) => IThreeDFormat a -> Prelude.IO (a0)
getPresetLightingSoftness =
  Automation.propertyGetID 0x6a [] Automation.outVariant
setPresetLightingSoftness :: (Automation.Variant a0) => a0 -> IThreeDFormat a -> Prelude.IO ()
setPresetLightingSoftness presetLightingSoftness =
  Automation.propertySetID 0x6a [Automation.inVariant presetLightingSoftness]
getPresetMaterial :: (Automation.Variant a0) => IThreeDFormat a -> Prelude.IO (a0)
getPresetMaterial =
  Automation.propertyGetID 0x6b [] Automation.outVariant
setPresetMaterial :: (Automation.Variant a0) => a0 -> IThreeDFormat a -> Prelude.IO ()
setPresetMaterial presetMaterial =
  Automation.propertySetID 0x6b [Automation.inVariant presetMaterial]
getPresetThreeDFormat :: (Automation.Variant a0) => IThreeDFormat a -> Prelude.IO (a0)
getPresetThreeDFormat =
  Automation.propertyGetID 0x6c [] Automation.outVariant
getRotationX :: IThreeDFormat a -> Prelude.IO (Prelude.Float)
getRotationX = Automation.propertyGetID 0x6d [] Automation.outFloat
setRotationX :: Prelude.Float -> IThreeDFormat a -> Prelude.IO ()
setRotationX rotationX =
  Automation.propertySetID 0x6d [Automation.inFloat rotationX]
getRotationY :: IThreeDFormat a -> Prelude.IO (Prelude.Float)
getRotationY = Automation.propertyGetID 0x6e [] Automation.outFloat
setRotationY :: Prelude.Float -> IThreeDFormat a -> Prelude.IO ()
setRotationY rotationY =
  Automation.propertySetID 0x6e [Automation.inFloat rotationY]
-- --------------------------------------------------
-- 
-- interface FillFormat
-- 
-- --------------------------------------------------
data FillFormat a = FillFormat
                     
type IFillFormat a = Office.IMsoDispObj (FillFormat a)
iidIFillFormat :: Com.IID (IFillFormat Automation.Interface)
iidIFillFormat = Com.mkIID "{000C0314-0000-0000-C000-000000000046}"
background :: IFillFormat a -> Prelude.IO ()
background = Automation.methodID0 0xa []
oneColorGradient :: (Automation.Variant a0) => a0 -> Prelude.Int -> Prelude.Float -> Automation.IDispatch a -> Prelude.IO ()
oneColorGradient style variant degree =
  Automation.methodID0 0xb [Automation.inVariant style, Automation.inInt variant, Automation.inFloat degree]
patterned :: (Automation.Variant a0) => a0 -> Automation.IDispatch a -> Prelude.IO ()
patterned pattern =
  Automation.methodID0 0xc [Automation.inVariant pattern]
presetGradient :: (Automation.Variant a0, Automation.Variant a1) => a0 -> Prelude.Int -> a1 -> Automation.IDispatch a -> Prelude.IO ()
presetGradient style variant presetGradientType =
  Automation.methodID0 0xd [Automation.inVariant style, Automation.inInt variant, Automation.inVariant presetGradientType]
presetTextured :: (Automation.Variant a0) => a0 -> Automation.IDispatch a -> Prelude.IO ()
presetTextured presetTexture =
  Automation.methodID0 0xe [Automation.inVariant presetTexture]
solid :: Automation.IDispatch a -> Prelude.IO ()
solid = Automation.methodID0 0xf []
twoColorGradient :: (Automation.Variant a0) => a0 -> Prelude.Int -> Automation.IDispatch a -> Prelude.IO ()
twoColorGradient style variant =
  Automation.methodID0 0x10 [Automation.inVariant style, Automation.inInt variant]
userPicture :: Prelude.String -> IFillFormat a -> Prelude.IO ()
userPicture pictureFile =
  Automation.methodID0 0x11 [Automation.inString pictureFile]
userTextured :: Prelude.String -> Automation.IDispatch a -> Prelude.IO ()
userTextured textureFile =
  Automation.methodID0 0x12 [Automation.inString textureFile]
getGradientColorType :: (Automation.Variant a0) => Automation.IDispatch a -> Prelude.IO (a0)
getGradientColorType =
  Automation.propertyGetID 0x66 [] Automation.outVariant
getGradientDegree :: Automation.IDispatch a -> Prelude.IO (Prelude.Float)
getGradientDegree =
  Automation.propertyGetID 0x67 [] Automation.outFloat
getGradientStyle :: (Automation.Variant a0) => Automation.IDispatch a -> Prelude.IO (a0)
getGradientStyle =
  Automation.propertyGetID 0x68 [] Automation.outVariant
getGradientVariant :: Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getGradientVariant =
  Automation.propertyGetID 0x69 [] Automation.outInt
getPresetGradientType :: (Automation.Variant a0) => Automation.IDispatch a -> Prelude.IO (a0)
getPresetGradientType =
  Automation.propertyGetID 0x6b [] Automation.outVariant
getPresetTexture :: (Automation.Variant a0) => Automation.IDispatch a -> Prelude.IO (a0)
getPresetTexture =
  Automation.propertyGetID 0x6c [] Automation.outVariant
getTextureName :: Automation.IDispatch a -> Prelude.IO (Prelude.String)
getTextureName =
  Automation.propertyGetID 0x6d [] Automation.outString
getTextureType :: (Automation.Variant a0) => Automation.IDispatch a -> Prelude.IO (a0)
getTextureType =
  Automation.propertyGetID 0x6e [] Automation.outVariant
getType2 :: (Automation.Variant a0) => Automation.IDispatch a -> Prelude.IO (a0)
getType2 = Automation.propertyGetID 0x70 [] Automation.outVariant

{-

data Constants
 = XlAll
 | XlAutomatic
 | XlBoth
 | XlCenter
 | XlChecker
 | XlCircle
 | XlCorner
 | XlCrissCross
 | XlCross
 | XlDiamond
 | XlDistributed
 | XlDoubleAccounting
 | XlFixedValue
 | XlFormats
 | XlGray16
 | XlGray8
 | XlGrid
 | XlHigh
 | XlInside
 | XlJustify
 | XlLightDown
 | XlLightHorizontal
 | XlLightUp
 | XlLightVertical
 | XlLow
 | XlManual
 | XlMinusValues
 | XlModule
 | XlNextToAxis
 | XlNone
 | XlNotes
 | XlOff
 | XlOn
 | XlPercent
 | XlPlus
 | XlPlusValues
 | XlSemiGray75
 | XlShowLabel
 | XlShowLabelAndPercent
 | XlShowPercent
 | XlShowValue
 | XlSimple
 | XlSingle
 | XlSingleAccounting
 | XlSolid
 | XlSquare
 | XlStar
 | XlStError
 | XlToolbarButton
 | XlTriangle
 | XlGray25
 | XlGray50
 | XlGray75
 | XlBottom
 | XlLeft
 | XlRight
 | XlTop
 | Xl3DBar
 | Xl3DSurface
 | XlBar
 | XlColumn
 | XlCombination
 | XlCustom
 | XlDefaultAutoFormat
 | XlMaximum
 | XlMinimum
 | XlOpaque
 | XlTransparent
 | XlBidi
 | XlLatin
 | XlContext
 | XlLTR
 | XlRTL
 | XlVisualCursor
 | XlLogicalCursor
 | XlSystem
 | XlPartial
 | XlHindiNumerals
 | XlBidiCalendar
 | XlGregorian
 | XlComplete
 | XlScale
 | XlClosed
 | XlColor1
 | XlColor2
 | XlColor3
 | XlConstants
 | XlContents
 | XlBelow
 | XlCascade
 | XlCenterAcrossSelection
 | XlChart4
 | XlChartSeries
 | XlChartShort
 | XlChartTitles
 | XlClassic1
 | XlClassic2
 | XlClassic3
 | Xl3DEffects1
 | Xl3DEffects2
 | XlAbove
 | XlAccounting1
 | XlAccounting2
 | XlAccounting3
 | XlAccounting4
 | XlAdd
 | XlDebugCodePane
 | XlDesktop
 | XlDirect
 | XlDivide
 | XlDoubleClosed
 | XlDoubleOpen
 | XlDoubleQuote
 | XlEntireChart
 | XlExcelMenus
 | XlExtended
 | XlFill
 | XlFirst
 | XlFloating
 | XlFormula
 | XlGeneral
 | XlGridline
 | XlIcons
 | XlImmediatePane
 | XlInteger
 | XlLast
 | XlLastCell
 | XlList1
 | XlList2
 | XlList3
 | XlLocalFormat1
 | XlLocalFormat2
 | XlLong
 | XlLotusHelp
 | XlMacrosheetCell
 | XlMixed
 | XlMultiply
 | XlNarrow
 | XlNoDocuments
 | XlOpen
 | XlOutside
 | XlReference
 | XlSemiautomatic
 | XlShort
 | XlSingleQuote
 | XlStrict
 | XlSubtract
 | XlTextBox
 | XlTiled
 | XlTitleBar
 | XlToolbar
 | XlVisible
 | XlWatchPane
 | XlWide
 | XlWorkbookTab
 | XlWorksheet4
 | XlWorksheetCell
 | XlWorksheetShort
 | XlAllExceptBorders
 | XlLeftToRight
 | XlTopToBottom
 | XlVeryHidden
 | XlDrawingObject
 
marshallConstants :: Constants -> Prelude.IO Int.Int16
marshallConstants v =
  case v of
     XlAll -> Prelude.return ((-4104))
     XlAutomatic -> Prelude.return ((-4105))
     XlBoth -> Prelude.return (1)
     XlCenter -> Prelude.return ((-4108))
     XlChecker -> Prelude.return (9)
     XlCircle -> Prelude.return (8)
     XlCorner -> Prelude.return (2)
     XlCrissCross -> Prelude.return (16)
     XlCross -> Prelude.return (4)
     XlDiamond -> Prelude.return (2)
     XlDistributed -> Prelude.return ((-4117))
     XlDoubleAccounting -> Prelude.return (5)
     XlFixedValue -> Prelude.return (1)
     XlFormats -> Prelude.return ((-4122))
     XlGray16 -> Prelude.return (17)
     XlGray8 -> Prelude.return (18)
     XlGrid -> Prelude.return (15)
     XlHigh -> Prelude.return ((-4127))
     XlInside -> Prelude.return (2)
     XlJustify -> Prelude.return ((-4130))
     XlLightDown -> Prelude.return (13)
     XlLightHorizontal -> Prelude.return (11)
     XlLightUp -> Prelude.return (14)
     XlLightVertical -> Prelude.return (12)
     XlLow -> Prelude.return ((-4134))
     XlManual -> Prelude.return ((-4135))
     XlMinusValues -> Prelude.return (3)
     XlModule -> Prelude.return ((-4141))
     XlNextToAxis -> Prelude.return (4)
     XlNone -> Prelude.return ((-4142))
     XlNotes -> Prelude.return ((-4144))
     XlOff -> Prelude.return ((-4146))
     XlOn -> Prelude.return (1)
     XlPercent -> Prelude.return (2)
     XlPlus -> Prelude.return (9)
     XlPlusValues -> Prelude.return (2)
     XlSemiGray75 -> Prelude.return (10)
     XlShowLabel -> Prelude.return (4)
     XlShowLabelAndPercent -> Prelude.return (5)
     XlShowPercent -> Prelude.return (3)
     XlShowValue -> Prelude.return (2)
     XlSimple -> Prelude.return ((-4154))
     XlSingle -> Prelude.return (2)
     XlSingleAccounting -> Prelude.return (4)
     XlSolid -> Prelude.return (1)
     XlSquare -> Prelude.return (1)
     XlStar -> Prelude.return (5)
     XlStError -> Prelude.return (4)
     XlToolbarButton -> Prelude.return (2)
     XlTriangle -> Prelude.return (3)
     XlGray25 -> Prelude.return ((-4124))
     XlGray50 -> Prelude.return ((-4125))
     XlGray75 -> Prelude.return ((-4126))
     XlBottom -> Prelude.return ((-4107))
     XlLeft -> Prelude.return ((-4131))
     XlRight -> Prelude.return ((-4152))
     XlTop -> Prelude.return ((-4160))
     Xl3DBar -> Prelude.return ((-4099))
     Xl3DSurface -> Prelude.return ((-4103))
     XlBar -> Prelude.return (2)
     XlColumn -> Prelude.return (3)
     XlCombination -> Prelude.return ((-4111))
     XlCustom -> Prelude.return ((-4114))
     XlDefaultAutoFormat -> Prelude.return ((-1))
     XlMaximum -> Prelude.return (2)
     XlMinimum -> Prelude.return (4)
     XlOpaque -> Prelude.return (3)
     XlTransparent -> Prelude.return (2)
     XlBidi -> Prelude.return ((-5000))
     XlLatin -> Prelude.return ((-5001))
     XlContext -> Prelude.return ((-5002))
     XlLTR -> Prelude.return ((-5003))
     XlRTL -> Prelude.return ((-5004))
     XlVisualCursor -> Prelude.return (2)
     XlLogicalCursor -> Prelude.return (1)
     XlSystem -> Prelude.return (1)
     XlPartial -> Prelude.return (3)
     XlHindiNumerals -> Prelude.return (3)
     XlBidiCalendar -> Prelude.return (3)
     XlGregorian -> Prelude.return (2)
     XlComplete -> Prelude.return (4)
     XlScale -> Prelude.return (3)
     XlClosed -> Prelude.return (3)
     XlColor1 -> Prelude.return (7)
     XlColor2 -> Prelude.return (8)
     XlColor3 -> Prelude.return (9)
     XlConstants -> Prelude.return (2)
     XlContents -> Prelude.return (2)
     XlBelow -> Prelude.return (1)
     XlCascade -> Prelude.return (7)
     XlCenterAcrossSelection -> Prelude.return (7)
     XlChart4 -> Prelude.return (2)
     XlChartSeries -> Prelude.return (17)
     XlChartShort -> Prelude.return (6)
     XlChartTitles -> Prelude.return (18)
     XlClassic1 -> Prelude.return (1)
     XlClassic2 -> Prelude.return (2)
     XlClassic3 -> Prelude.return (3)
     Xl3DEffects1 -> Prelude.return (13)
     Xl3DEffects2 -> Prelude.return (14)
     XlAbove -> Prelude.return (0)
     XlAccounting1 -> Prelude.return (4)
     XlAccounting2 -> Prelude.return (5)
     XlAccounting3 -> Prelude.return (6)
     XlAccounting4 -> Prelude.return (17)
     XlAdd -> Prelude.return (2)
     XlDebugCodePane -> Prelude.return (13)
     XlDesktop -> Prelude.return (9)
     XlDirect -> Prelude.return (1)
     XlDivide -> Prelude.return (5)
     XlDoubleClosed -> Prelude.return (5)
     XlDoubleOpen -> Prelude.return (4)
     XlDoubleQuote -> Prelude.return (1)
     XlEntireChart -> Prelude.return (20)
     XlExcelMenus -> Prelude.return (1)
     XlExtended -> Prelude.return (3)
     XlFill -> Prelude.return (5)
     XlFirst -> Prelude.return (0)
     XlFloating -> Prelude.return (5)
     XlFormula -> Prelude.return (5)
     XlGeneral -> Prelude.return (1)
     XlGridline -> Prelude.return (22)
     XlIcons -> Prelude.return (1)
     XlImmediatePane -> Prelude.return (12)
     XlInteger -> Prelude.return (2)
     XlLast -> Prelude.return (1)
     XlLastCell -> Prelude.return (11)
     XlList1 -> Prelude.return (10)
     XlList2 -> Prelude.return (11)
     XlList3 -> Prelude.return (12)
     XlLocalFormat1 -> Prelude.return (15)
     XlLocalFormat2 -> Prelude.return (16)
     XlLong -> Prelude.return (3)
     XlLotusHelp -> Prelude.return (2)
     XlMacrosheetCell -> Prelude.return (7)
     XlMixed -> Prelude.return (2)
     XlMultiply -> Prelude.return (4)
     XlNarrow -> Prelude.return (1)
     XlNoDocuments -> Prelude.return (3)
     XlOpen -> Prelude.return (2)
     XlOutside -> Prelude.return (3)
     XlReference -> Prelude.return (4)
     XlSemiautomatic -> Prelude.return (2)
     XlShort -> Prelude.return (1)
     XlSingleQuote -> Prelude.return (2)
     XlStrict -> Prelude.return (2)
     XlSubtract -> Prelude.return (3)
     XlTextBox -> Prelude.return (16)
     XlTiled -> Prelude.return (1)
     XlTitleBar -> Prelude.return (8)
     XlToolbar -> Prelude.return (1)
     XlVisible -> Prelude.return (12)
     XlWatchPane -> Prelude.return (11)
     XlWide -> Prelude.return (3)
     XlWorkbookTab -> Prelude.return (6)
     XlWorksheet4 -> Prelude.return (1)
     XlWorksheetCell -> Prelude.return (3)
     XlWorksheetShort -> Prelude.return (5)
     XlAllExceptBorders -> Prelude.return (6)
     XlLeftToRight -> Prelude.return (2)
     XlTopToBottom -> Prelude.return (1)
     XlVeryHidden -> Prelude.return (2)
     XlDrawingObject -> Prelude.return (14)
unmarshallConstants :: Int.Int16 -> Prelude.IO Constants
unmarshallConstants v =
  case v of
     (-4104) -> Prelude.return (XlAll)
     (-4105) -> Prelude.return (XlAutomatic)
     1 -> Prelude.return (XlBoth)
     (-4108) -> Prelude.return (XlCenter)
     9 -> Prelude.return (XlChecker)
     8 -> Prelude.return (XlCircle)
     2 -> Prelude.return (XlCorner)
     16 -> Prelude.return (XlCrissCross)
     4 -> Prelude.return (XlCross)
     2 -> Prelude.return (XlDiamond)
     (-4117) -> Prelude.return (XlDistributed)
     5 -> Prelude.return (XlDoubleAccounting)
     1 -> Prelude.return (XlFixedValue)
     (-4122) -> Prelude.return (XlFormats)
     17 -> Prelude.return (XlGray16)
     18 -> Prelude.return (XlGray8)
     15 -> Prelude.return (XlGrid)
     (-4127) -> Prelude.return (XlHigh)
     2 -> Prelude.return (XlInside)
     (-4130) -> Prelude.return (XlJustify)
     13 -> Prelude.return (XlLightDown)
     11 -> Prelude.return (XlLightHorizontal)
     14 -> Prelude.return (XlLightUp)
     12 -> Prelude.return (XlLightVertical)
     (-4134) -> Prelude.return (XlLow)
     (-4135) -> Prelude.return (XlManual)
     3 -> Prelude.return (XlMinusValues)
     (-4141) -> Prelude.return (XlModule)
     4 -> Prelude.return (XlNextToAxis)
     (-4142) -> Prelude.return (XlNone)
     (-4144) -> Prelude.return (XlNotes)
     (-4146) -> Prelude.return (XlOff)
     1 -> Prelude.return (XlOn)
     2 -> Prelude.return (XlPercent)
     9 -> Prelude.return (XlPlus)
     2 -> Prelude.return (XlPlusValues)
     10 -> Prelude.return (XlSemiGray75)
     4 -> Prelude.return (XlShowLabel)
     5 -> Prelude.return (XlShowLabelAndPercent)
     3 -> Prelude.return (XlShowPercent)
     2 -> Prelude.return (XlShowValue)
     (-4154) -> Prelude.return (XlSimple)
     2 -> Prelude.return (XlSingle)
     4 -> Prelude.return (XlSingleAccounting)
     1 -> Prelude.return (XlSolid)
     1 -> Prelude.return (XlSquare)
     5 -> Prelude.return (XlStar)
     4 -> Prelude.return (XlStError)
     2 -> Prelude.return (XlToolbarButton)
     3 -> Prelude.return (XlTriangle)
     (-4124) -> Prelude.return (XlGray25)
     (-4125) -> Prelude.return (XlGray50)
     (-4126) -> Prelude.return (XlGray75)
     (-4107) -> Prelude.return (XlBottom)
     (-4131) -> Prelude.return (XlLeft)
     (-4152) -> Prelude.return (XlRight)
     (-4160) -> Prelude.return (XlTop)
     (-4099) -> Prelude.return (Xl3DBar)
     (-4103) -> Prelude.return (Xl3DSurface)
     2 -> Prelude.return (XlBar)
     3 -> Prelude.return (XlColumn)
     (-4111) -> Prelude.return (XlCombination)
     (-4114) -> Prelude.return (XlCustom)
     (-1) -> Prelude.return (XlDefaultAutoFormat)
     2 -> Prelude.return (XlMaximum)
     4 -> Prelude.return (XlMinimum)
     3 -> Prelude.return (XlOpaque)
     2 -> Prelude.return (XlTransparent)
     (-5000) -> Prelude.return (XlBidi)
     (-5001) -> Prelude.return (XlLatin)
     (-5002) -> Prelude.return (XlContext)
     (-5003) -> Prelude.return (XlLTR)
     (-5004) -> Prelude.return (XlRTL)
     2 -> Prelude.return (XlVisualCursor)
     1 -> Prelude.return (XlLogicalCursor)
     1 -> Prelude.return (XlSystem)
     3 -> Prelude.return (XlPartial)
     3 -> Prelude.return (XlHindiNumerals)
     3 -> Prelude.return (XlBidiCalendar)
     2 -> Prelude.return (XlGregorian)
     4 -> Prelude.return (XlComplete)
     3 -> Prelude.return (XlScale)
     3 -> Prelude.return (XlClosed)
     7 -> Prelude.return (XlColor1)
     8 -> Prelude.return (XlColor2)
     9 -> Prelude.return (XlColor3)
     2 -> Prelude.return (XlConstants)
     2 -> Prelude.return (XlContents)
     1 -> Prelude.return (XlBelow)
     7 -> Prelude.return (XlCascade)
     7 -> Prelude.return (XlCenterAcrossSelection)
     2 -> Prelude.return (XlChart4)
     17 -> Prelude.return (XlChartSeries)
     6 -> Prelude.return (XlChartShort)
     18 -> Prelude.return (XlChartTitles)
     1 -> Prelude.return (XlClassic1)
     2 -> Prelude.return (XlClassic2)
     3 -> Prelude.return (XlClassic3)
     13 -> Prelude.return (Xl3DEffects1)
     14 -> Prelude.return (Xl3DEffects2)
     0 -> Prelude.return (XlAbove)
     4 -> Prelude.return (XlAccounting1)
     5 -> Prelude.return (XlAccounting2)
     6 -> Prelude.return (XlAccounting3)
     17 -> Prelude.return (XlAccounting4)
     2 -> Prelude.return (XlAdd)
     13 -> Prelude.return (XlDebugCodePane)
     9 -> Prelude.return (XlDesktop)
     1 -> Prelude.return (XlDirect)
     5 -> Prelude.return (XlDivide)
     5 -> Prelude.return (XlDoubleClosed)
     4 -> Prelude.return (XlDoubleOpen)
     1 -> Prelude.return (XlDoubleQuote)
     20 -> Prelude.return (XlEntireChart)
     1 -> Prelude.return (XlExcelMenus)
     3 -> Prelude.return (XlExtended)
     5 -> Prelude.return (XlFill)
     0 -> Prelude.return (XlFirst)
     5 -> Prelude.return (XlFloating)
     5 -> Prelude.return (XlFormula)
     1 -> Prelude.return (XlGeneral)
     22 -> Prelude.return (XlGridline)
     1 -> Prelude.return (XlIcons)
     12 -> Prelude.return (XlImmediatePane)
     2 -> Prelude.return (XlInteger)
     1 -> Prelude.return (XlLast)
     11 -> Prelude.return (XlLastCell)
     10 -> Prelude.return (XlList1)
     11 -> Prelude.return (XlList2)
     12 -> Prelude.return (XlList3)
     15 -> Prelude.return (XlLocalFormat1)
     16 -> Prelude.return (XlLocalFormat2)
     3 -> Prelude.return (XlLong)
     2 -> Prelude.return (XlLotusHelp)
     7 -> Prelude.return (XlMacrosheetCell)
     2 -> Prelude.return (XlMixed)
     4 -> Prelude.return (XlMultiply)
     1 -> Prelude.return (XlNarrow)
     3 -> Prelude.return (XlNoDocuments)
     2 -> Prelude.return (XlOpen)
     3 -> Prelude.return (XlOutside)
     4 -> Prelude.return (XlReference)
     2 -> Prelude.return (XlSemiautomatic)
     1 -> Prelude.return (XlShort)
     2 -> Prelude.return (XlSingleQuote)
     2 -> Prelude.return (XlStrict)
     3 -> Prelude.return (XlSubtract)
     16 -> Prelude.return (XlTextBox)
     1 -> Prelude.return (XlTiled)
     8 -> Prelude.return (XlTitleBar)
     1 -> Prelude.return (XlToolbar)
     12 -> Prelude.return (XlVisible)
     11 -> Prelude.return (XlWatchPane)
     3 -> Prelude.return (XlWide)
     6 -> Prelude.return (XlWorkbookTab)
     1 -> Prelude.return (XlWorksheet4)
     3 -> Prelude.return (XlWorksheetCell)
     5 -> Prelude.return (XlWorksheetShort)
     6 -> Prelude.return (XlAllExceptBorders)
     2 -> Prelude.return (XlLeftToRight)
     1 -> Prelude.return (XlTopToBottom)
     2 -> Prelude.return (XlVeryHidden)
     14 -> Prelude.return (XlDrawingObject)
     _ -> Prelude.fail (Prelude.userError "unmarshallConstants: illegal enum value ")
data XlCreator = XlCreatorCode
                  
marshallXlCreator :: XlCreator -> Prelude.IO Int.Int16
marshallXlCreator v =
  case v of
     XlCreatorCode -> Prelude.return (1480803660)
unmarshallXlCreator :: Int.Int16 -> Prelude.IO XlCreator
unmarshallXlCreator v =
  case v of
     1480803660 -> Prelude.return (XlCreatorCode)
     _ -> Prelude.fail (Prelude.userError "unmarshallXlCreator: illegal enum value ")
data XlChartGallery
 = XlBuiltIn
 | XlUserDefined
 | XlAnyGallery
 
marshallXlChartGallery :: XlChartGallery -> Prelude.IO Int.Int16
marshallXlChartGallery v =
  case v of
     XlBuiltIn -> Prelude.return (21)
     XlUserDefined -> Prelude.return (22)
     XlAnyGallery -> Prelude.return (23)
unmarshallXlChartGallery :: Int.Int16 -> Prelude.IO XlChartGallery
unmarshallXlChartGallery v =
  case v of
     21 -> Prelude.return (XlBuiltIn)
     22 -> Prelude.return (XlUserDefined)
     23 -> Prelude.return (XlAnyGallery)
     _ -> Prelude.fail (Prelude.userError "unmarshallXlChartGallery: illegal enum value ")
data XlColorIndex
 = XlColorIndexAutomatic
 | XlColorIndexNone
 
marshallXlColorIndex :: XlColorIndex -> Prelude.IO Int.Int16
marshallXlColorIndex v =
  case v of
     XlColorIndexAutomatic -> Prelude.return ((-4105))
     XlColorIndexNone -> Prelude.return ((-4142))
unmarshallXlColorIndex :: Int.Int16 -> Prelude.IO XlColorIndex
unmarshallXlColorIndex v =
  case v of
     (-4105) -> Prelude.return (XlColorIndexAutomatic)
     (-4142) -> Prelude.return (XlColorIndexNone)
     _ -> Prelude.fail (Prelude.userError "unmarshallXlColorIndex: illegal enum value ")
data XlEndStyleCap
 = XlCap
 | XlNoCap
 
marshallXlEndStyleCap :: XlEndStyleCap -> Prelude.IO Int.Int16
marshallXlEndStyleCap v =
  case v of
     XlCap -> Prelude.return (1)
     XlNoCap -> Prelude.return (2)
unmarshallXlEndStyleCap :: Int.Int16 -> Prelude.IO XlEndStyleCap
unmarshallXlEndStyleCap v =
  case v of
     1 -> Prelude.return (XlCap)
     2 -> Prelude.return (XlNoCap)
     _ -> Prelude.fail (Prelude.userError "unmarshallXlEndStyleCap: illegal enum value ")
data XlRowCol
 = XlColumns
 | XlRows
 
marshallXlRowCol :: XlRowCol -> Prelude.IO Int.Int16
marshallXlRowCol v =
  case v of
     XlColumns -> Prelude.return (2)
     XlRows -> Prelude.return (1)
unmarshallXlRowCol :: Int.Int16 -> Prelude.IO XlRowCol
unmarshallXlRowCol v =
  case v of
     2 -> Prelude.return (XlColumns)
     1 -> Prelude.return (XlRows)
     _ -> Prelude.fail (Prelude.userError "unmarshallXlRowCol: illegal enum value ")
data XlScaleType
 = XlScaleLinear
 | XlScaleLogarithmic
 
marshallXlScaleType :: XlScaleType -> Prelude.IO Int.Int16
marshallXlScaleType v =
  case v of
     XlScaleLinear -> Prelude.return ((-4132))
     XlScaleLogarithmic -> Prelude.return ((-4133))
unmarshallXlScaleType :: Int.Int16 -> Prelude.IO XlScaleType
unmarshallXlScaleType v =
  case v of
     (-4132) -> Prelude.return (XlScaleLinear)
     (-4133) -> Prelude.return (XlScaleLogarithmic)
     _ -> Prelude.fail (Prelude.userError "unmarshallXlScaleType: illegal enum value ")
data XlDataSeriesType
 = XlAutoFill
 | XlChronological
 | XlGrowth
 | XlDataSeriesLinear
 
marshallXlDataSeriesType :: XlDataSeriesType -> Prelude.IO Int.Int16
marshallXlDataSeriesType v =
  case v of
     XlAutoFill -> Prelude.return (4)
     XlChronological -> Prelude.return (3)
     XlGrowth -> Prelude.return (2)
     XlDataSeriesLinear -> Prelude.return ((-4132))
unmarshallXlDataSeriesType :: Int.Int16 -> Prelude.IO XlDataSeriesType
unmarshallXlDataSeriesType v =
  case v of
     4 -> Prelude.return (XlAutoFill)
     3 -> Prelude.return (XlChronological)
     2 -> Prelude.return (XlGrowth)
     (-4132) -> Prelude.return (XlDataSeriesLinear)
     _ -> Prelude.fail (Prelude.userError "unmarshallXlDataSeriesType: illegal enum value ")
data XlAxisCrosses
 = XlAxisCrossesAutomatic
 | XlAxisCrossesCustom
 | XlAxisCrossesMaximum
 | XlAxisCrossesMinimum
 
marshallXlAxisCrosses :: XlAxisCrosses -> Prelude.IO Int.Int16
marshallXlAxisCrosses v =
  case v of
     XlAxisCrossesAutomatic -> Prelude.return ((-4105))
     XlAxisCrossesCustom -> Prelude.return ((-4114))
     XlAxisCrossesMaximum -> Prelude.return (2)
     XlAxisCrossesMinimum -> Prelude.return (4)
unmarshallXlAxisCrosses :: Int.Int16 -> Prelude.IO XlAxisCrosses
unmarshallXlAxisCrosses v =
  case v of
     (-4105) -> Prelude.return (XlAxisCrossesAutomatic)
     (-4114) -> Prelude.return (XlAxisCrossesCustom)
     2 -> Prelude.return (XlAxisCrossesMaximum)
     4 -> Prelude.return (XlAxisCrossesMinimum)
     _ -> Prelude.fail (Prelude.userError "unmarshallXlAxisCrosses: illegal enum value ")
data XlAxisGroup
 = XlPrimary
 | XlSecondary
 
marshallXlAxisGroup :: XlAxisGroup -> Prelude.IO Int.Int16
marshallXlAxisGroup v =
  case v of
     XlPrimary -> Prelude.return (1)
     XlSecondary -> Prelude.return (2)
unmarshallXlAxisGroup :: Int.Int16 -> Prelude.IO XlAxisGroup
unmarshallXlAxisGroup v =
  case v of
     1 -> Prelude.return (XlPrimary)
     2 -> Prelude.return (XlSecondary)
     _ -> Prelude.fail (Prelude.userError "unmarshallXlAxisGroup: illegal enum value ")
data XlBackground
 = XlBackgroundAutomatic
 | XlBackgroundOpaque
 | XlBackgroundTransparent
 
marshallXlBackground :: XlBackground -> Prelude.IO Int.Int16
marshallXlBackground v =
  case v of
     XlBackgroundAutomatic -> Prelude.return ((-4105))
     XlBackgroundOpaque -> Prelude.return (3)
     XlBackgroundTransparent -> Prelude.return (2)
unmarshallXlBackground :: Int.Int16 -> Prelude.IO XlBackground
unmarshallXlBackground v =
  case v of
     (-4105) -> Prelude.return (XlBackgroundAutomatic)
     3 -> Prelude.return (XlBackgroundOpaque)
     2 -> Prelude.return (XlBackgroundTransparent)
     _ -> Prelude.fail (Prelude.userError "unmarshallXlBackground: illegal enum value ")
data XlWindowState
 = XlMaximized
 | XlMinimized
 | XlNormal
 
marshallXlWindowState :: XlWindowState -> Prelude.IO Int.Int16
marshallXlWindowState v =
  case v of
     XlMaximized -> Prelude.return ((-4137))
     XlMinimized -> Prelude.return ((-4140))
     XlNormal -> Prelude.return ((-4143))
unmarshallXlWindowState :: Int.Int16 -> Prelude.IO XlWindowState
unmarshallXlWindowState v =
  case v of
     (-4137) -> Prelude.return (XlMaximized)
     (-4140) -> Prelude.return (XlMinimized)
     (-4143) -> Prelude.return (XlNormal)
     _ -> Prelude.fail (Prelude.userError "unmarshallXlWindowState: illegal enum value ")
data XlAxisType
 = XlCategory
 | XlSeriesAxis
 | XlValue
 
marshallXlAxisType :: XlAxisType -> Prelude.IO Int.Int16
marshallXlAxisType v =
  case v of
     XlCategory -> Prelude.return (1)
     XlSeriesAxis -> Prelude.return (3)
     XlValue -> Prelude.return (2)
unmarshallXlAxisType :: Int.Int16 -> Prelude.IO XlAxisType
unmarshallXlAxisType v =
  case v of
     1 -> Prelude.return (XlCategory)
     3 -> Prelude.return (XlSeriesAxis)
     2 -> Prelude.return (XlValue)
     _ -> Prelude.fail (Prelude.userError "unmarshallXlAxisType: illegal enum value ")
data XlArrowHeadLength
 = XlArrowHeadLengthLong
 | XlArrowHeadLengthMedium
 | XlArrowHeadLengthShort
 
marshallXlArrowHeadLength :: XlArrowHeadLength -> Prelude.IO Int.Int16
marshallXlArrowHeadLength v =
  case v of
     XlArrowHeadLengthLong -> Prelude.return (3)
     XlArrowHeadLengthMedium -> Prelude.return ((-4138))
     XlArrowHeadLengthShort -> Prelude.return (1)
unmarshallXlArrowHeadLength :: Int.Int16 -> Prelude.IO XlArrowHeadLength
unmarshallXlArrowHeadLength v =
  case v of
     3 -> Prelude.return (XlArrowHeadLengthLong)
     (-4138) -> Prelude.return (XlArrowHeadLengthMedium)
     1 -> Prelude.return (XlArrowHeadLengthShort)
     _ -> Prelude.fail (Prelude.userError "unmarshallXlArrowHeadLength: illegal enum value ")
data XlVAlign
 = XlVAlignBottom
 | XlVAlignCenter
 | XlVAlignDistributed
 | XlVAlignJustify
 | XlVAlignTop
 
marshallXlVAlign :: XlVAlign -> Prelude.IO Int.Int16
marshallXlVAlign v =
  case v of
     XlVAlignBottom -> Prelude.return ((-4107))
     XlVAlignCenter -> Prelude.return ((-4108))
     XlVAlignDistributed -> Prelude.return ((-4117))
     XlVAlignJustify -> Prelude.return ((-4130))
     XlVAlignTop -> Prelude.return ((-4160))
unmarshallXlVAlign :: Int.Int16 -> Prelude.IO XlVAlign
unmarshallXlVAlign v =
  case v of
     (-4107) -> Prelude.return (XlVAlignBottom)
     (-4108) -> Prelude.return (XlVAlignCenter)
     (-4117) -> Prelude.return (XlVAlignDistributed)
     (-4130) -> Prelude.return (XlVAlignJustify)
     (-4160) -> Prelude.return (XlVAlignTop)
     _ -> Prelude.fail (Prelude.userError "unmarshallXlVAlign: illegal enum value ")
data XlTickMark
 = XlTickMarkCross
 | XlTickMarkInside
 | XlTickMarkNone
 | XlTickMarkOutside
 
marshallXlTickMark :: XlTickMark -> Prelude.IO Int.Int16
marshallXlTickMark v =
  case v of
     XlTickMarkCross -> Prelude.return (4)
     XlTickMarkInside -> Prelude.return (2)
     XlTickMarkNone -> Prelude.return ((-4142))
     XlTickMarkOutside -> Prelude.return (3)
unmarshallXlTickMark :: Int.Int16 -> Prelude.IO XlTickMark
unmarshallXlTickMark v =
  case v of
     4 -> Prelude.return (XlTickMarkCross)
     2 -> Prelude.return (XlTickMarkInside)
     (-4142) -> Prelude.return (XlTickMarkNone)
     3 -> Prelude.return (XlTickMarkOutside)
     _ -> Prelude.fail (Prelude.userError "unmarshallXlTickMark: illegal enum value ")
data XlErrorBarDirection
 = XlX
 | XlY
 
marshallXlErrorBarDirection :: XlErrorBarDirection -> Prelude.IO Int.Int16
marshallXlErrorBarDirection v =
  case v of
     XlX -> Prelude.return ((-4168))
     XlY -> Prelude.return (1)
unmarshallXlErrorBarDirection :: Int.Int16 -> Prelude.IO XlErrorBarDirection
unmarshallXlErrorBarDirection v =
  case v of
     (-4168) -> Prelude.return (XlX)
     1 -> Prelude.return (XlY)
     _ -> Prelude.fail (Prelude.userError "unmarshallXlErrorBarDirection: illegal enum value ")
data XlErrorBarInclude
 = XlErrorBarIncludeBoth
 | XlErrorBarIncludeMinusValues
 | XlErrorBarIncludeNone
 | XlErrorBarIncludePlusValues
 
marshallXlErrorBarInclude :: XlErrorBarInclude -> Prelude.IO Int.Int16
marshallXlErrorBarInclude v =
  case v of
     XlErrorBarIncludeBoth -> Prelude.return (1)
     XlErrorBarIncludeMinusValues -> Prelude.return (3)
     XlErrorBarIncludeNone -> Prelude.return ((-4142))
     XlErrorBarIncludePlusValues -> Prelude.return (2)
unmarshallXlErrorBarInclude :: Int.Int16 -> Prelude.IO XlErrorBarInclude
unmarshallXlErrorBarInclude v =
  case v of
     1 -> Prelude.return (XlErrorBarIncludeBoth)
     3 -> Prelude.return (XlErrorBarIncludeMinusValues)
     (-4142) -> Prelude.return (XlErrorBarIncludeNone)
     2 -> Prelude.return (XlErrorBarIncludePlusValues)
     _ -> Prelude.fail (Prelude.userError "unmarshallXlErrorBarInclude: illegal enum value ")
data XlDisplayBlanksAs
 = XlInterpolated
 | XlNotPlotted
 | XlZero
 
marshallXlDisplayBlanksAs :: XlDisplayBlanksAs -> Prelude.IO Int.Int16
marshallXlDisplayBlanksAs v =
  case v of
     XlInterpolated -> Prelude.return (3)
     XlNotPlotted -> Prelude.return (1)
     XlZero -> Prelude.return (2)
unmarshallXlDisplayBlanksAs :: Int.Int16 -> Prelude.IO XlDisplayBlanksAs
unmarshallXlDisplayBlanksAs v =
  case v of
     3 -> Prelude.return (XlInterpolated)
     1 -> Prelude.return (XlNotPlotted)
     2 -> Prelude.return (XlZero)
     _ -> Prelude.fail (Prelude.userError "unmarshallXlDisplayBlanksAs: illegal enum value ")
data XlArrowHeadStyle
 = XlArrowHeadStyleClosed
 | XlArrowHeadStyleDoubleClosed
 | XlArrowHeadStyleDoubleOpen
 | XlArrowHeadStyleNone
 | XlArrowHeadStyleOpen
 
marshallXlArrowHeadStyle :: XlArrowHeadStyle -> Prelude.IO Int.Int16
marshallXlArrowHeadStyle v =
  case v of
     XlArrowHeadStyleClosed -> Prelude.return (3)
     XlArrowHeadStyleDoubleClosed -> Prelude.return (5)
     XlArrowHeadStyleDoubleOpen -> Prelude.return (4)
     XlArrowHeadStyleNone -> Prelude.return ((-4142))
     XlArrowHeadStyleOpen -> Prelude.return (2)
unmarshallXlArrowHeadStyle :: Int.Int16 -> Prelude.IO XlArrowHeadStyle
unmarshallXlArrowHeadStyle v =
  case v of
     3 -> Prelude.return (XlArrowHeadStyleClosed)
     5 -> Prelude.return (XlArrowHeadStyleDoubleClosed)
     4 -> Prelude.return (XlArrowHeadStyleDoubleOpen)
     (-4142) -> Prelude.return (XlArrowHeadStyleNone)
     2 -> Prelude.return (XlArrowHeadStyleOpen)
     _ -> Prelude.fail (Prelude.userError "unmarshallXlArrowHeadStyle: illegal enum value ")
data XlArrowHeadWidth
 = XlArrowHeadWidthMedium
 | XlArrowHeadWidthNarrow
 | XlArrowHeadWidthWide
 
marshallXlArrowHeadWidth :: XlArrowHeadWidth -> Prelude.IO Int.Int16
marshallXlArrowHeadWidth v =
  case v of
     XlArrowHeadWidthMedium -> Prelude.return ((-4138))
     XlArrowHeadWidthNarrow -> Prelude.return (1)
     XlArrowHeadWidthWide -> Prelude.return (3)
unmarshallXlArrowHeadWidth :: Int.Int16 -> Prelude.IO XlArrowHeadWidth
unmarshallXlArrowHeadWidth v =
  case v of
     (-4138) -> Prelude.return (XlArrowHeadWidthMedium)
     1 -> Prelude.return (XlArrowHeadWidthNarrow)
     3 -> Prelude.return (XlArrowHeadWidthWide)
     _ -> Prelude.fail (Prelude.userError "unmarshallXlArrowHeadWidth: illegal enum value ")
data XlHAlign
 = XlHAlignCenter
 | XlHAlignCenterAcrossSelection
 | XlHAlignDistributed
 | XlHAlignFill
 | XlHAlignGeneral
 | XlHAlignJustify
 | XlHAlignLeft
 | XlHAlignRight
 
marshallXlHAlign :: XlHAlign -> Prelude.IO Int.Int16
marshallXlHAlign v =
  case v of
     XlHAlignCenter -> Prelude.return ((-4108))
     XlHAlignCenterAcrossSelection -> Prelude.return (7)
     XlHAlignDistributed -> Prelude.return ((-4117))
     XlHAlignFill -> Prelude.return (5)
     XlHAlignGeneral -> Prelude.return (1)
     XlHAlignJustify -> Prelude.return ((-4130))
     XlHAlignLeft -> Prelude.return ((-4131))
     XlHAlignRight -> Prelude.return ((-4152))
unmarshallXlHAlign :: Int.Int16 -> Prelude.IO XlHAlign
unmarshallXlHAlign v =
  case v of
     (-4108) -> Prelude.return (XlHAlignCenter)
     7 -> Prelude.return (XlHAlignCenterAcrossSelection)
     (-4117) -> Prelude.return (XlHAlignDistributed)
     5 -> Prelude.return (XlHAlignFill)
     1 -> Prelude.return (XlHAlignGeneral)
     (-4130) -> Prelude.return (XlHAlignJustify)
     (-4131) -> Prelude.return (XlHAlignLeft)
     (-4152) -> Prelude.return (XlHAlignRight)
     _ -> Prelude.fail (Prelude.userError "unmarshallXlHAlign: illegal enum value ")
data XlTickLabelPosition
 = XlTickLabelPositionHigh
 | XlTickLabelPositionLow
 | XlTickLabelPositionNextToAxis
 | XlTickLabelPositionNone
 
marshallXlTickLabelPosition :: XlTickLabelPosition -> Prelude.IO Int.Int16
marshallXlTickLabelPosition v =
  case v of
     XlTickLabelPositionHigh -> Prelude.return ((-4127))
     XlTickLabelPositionLow -> Prelude.return ((-4134))
     XlTickLabelPositionNextToAxis -> Prelude.return (4)
     XlTickLabelPositionNone -> Prelude.return ((-4142))
unmarshallXlTickLabelPosition :: Int.Int16 -> Prelude.IO XlTickLabelPosition
unmarshallXlTickLabelPosition v =
  case v of
     (-4127) -> Prelude.return (XlTickLabelPositionHigh)
     (-4134) -> Prelude.return (XlTickLabelPositionLow)
     4 -> Prelude.return (XlTickLabelPositionNextToAxis)
     (-4142) -> Prelude.return (XlTickLabelPositionNone)
     _ -> Prelude.fail (Prelude.userError "unmarshallXlTickLabelPosition: illegal enum value ")
data XlLegendPosition
 = XlLegendPositionBottom
 | XlLegendPositionCorner
 | XlLegendPositionLeft
 | XlLegendPositionRight
 | XlLegendPositionTop
 
marshallXlLegendPosition :: XlLegendPosition -> Prelude.IO Int.Int16
marshallXlLegendPosition v =
  case v of
     XlLegendPositionBottom -> Prelude.return ((-4107))
     XlLegendPositionCorner -> Prelude.return (2)
     XlLegendPositionLeft -> Prelude.return ((-4131))
     XlLegendPositionRight -> Prelude.return ((-4152))
     XlLegendPositionTop -> Prelude.return ((-4160))
unmarshallXlLegendPosition :: Int.Int16 -> Prelude.IO XlLegendPosition
unmarshallXlLegendPosition v =
  case v of
     (-4107) -> Prelude.return (XlLegendPositionBottom)
     2 -> Prelude.return (XlLegendPositionCorner)
     (-4131) -> Prelude.return (XlLegendPositionLeft)
     (-4152) -> Prelude.return (XlLegendPositionRight)
     (-4160) -> Prelude.return (XlLegendPositionTop)
     _ -> Prelude.fail (Prelude.userError "unmarshallXlLegendPosition: illegal enum value ")
data XlChartPictureType
 = XlStackScale
 | XlStack
 | XlStretch
 
marshallXlChartPictureType :: XlChartPictureType -> Prelude.IO Int.Int16
marshallXlChartPictureType v =
  case v of
     XlStackScale -> Prelude.return (3)
     XlStack -> Prelude.return (2)
     XlStretch -> Prelude.return (1)
unmarshallXlChartPictureType :: Int.Int16 -> Prelude.IO XlChartPictureType
unmarshallXlChartPictureType v =
  case v of
     3 -> Prelude.return (XlStackScale)
     2 -> Prelude.return (XlStack)
     1 -> Prelude.return (XlStretch)
     _ -> Prelude.fail (Prelude.userError "unmarshallXlChartPictureType: illegal enum value ")
data XlChartPicturePlacement
 = XlSides
 | XlEnd
 | XlEndSides
 | XlFront
 | XlFrontSides
 | XlFrontEnd
 | XlAllFaces
 
marshallXlChartPicturePlacement :: XlChartPicturePlacement -> Prelude.IO Int.Int16
marshallXlChartPicturePlacement v =
  case v of
     XlSides -> Prelude.return (1)
     XlEnd -> Prelude.return (2)
     XlEndSides -> Prelude.return (3)
     XlFront -> Prelude.return (4)
     XlFrontSides -> Prelude.return (5)
     XlFrontEnd -> Prelude.return (6)
     XlAllFaces -> Prelude.return (7)
unmarshallXlChartPicturePlacement :: Int.Int16 -> Prelude.IO XlChartPicturePlacement
unmarshallXlChartPicturePlacement v =
  case v of
     1 -> Prelude.return (XlSides)
     2 -> Prelude.return (XlEnd)
     3 -> Prelude.return (XlEndSides)
     4 -> Prelude.return (XlFront)
     5 -> Prelude.return (XlFrontSides)
     6 -> Prelude.return (XlFrontEnd)
     7 -> Prelude.return (XlAllFaces)
     _ -> Prelude.fail (Prelude.userError "unmarshallXlChartPicturePlacement: illegal enum value ")
data XlOrientation
 = XlDownward
 | XlHorizontal
 | XlUpward
 | XlVertical
 
marshallXlOrientation :: XlOrientation -> Prelude.IO Int.Int16
marshallXlOrientation v =
  case v of
     XlDownward -> Prelude.return ((-4170))
     XlHorizontal -> Prelude.return ((-4128))
     XlUpward -> Prelude.return ((-4171))
     XlVertical -> Prelude.return ((-4166))
unmarshallXlOrientation :: Int.Int16 -> Prelude.IO XlOrientation
unmarshallXlOrientation v =
  case v of
     (-4170) -> Prelude.return (XlDownward)
     (-4128) -> Prelude.return (XlHorizontal)
     (-4171) -> Prelude.return (XlUpward)
     (-4166) -> Prelude.return (XlVertical)
     _ -> Prelude.fail (Prelude.userError "unmarshallXlOrientation: illegal enum value ")
data XlTickLabelOrientation
 = XlTickLabelOrientationAutomatic
 | XlTickLabelOrientationDownward
 | XlTickLabelOrientationHorizontal
 | XlTickLabelOrientationUpward
 | XlTickLabelOrientationVertical
 
marshallXlTickLabelOrientation :: XlTickLabelOrientation -> Prelude.IO Int.Int16
marshallXlTickLabelOrientation v =
  case v of
     XlTickLabelOrientationAutomatic -> Prelude.return ((-4105))
     XlTickLabelOrientationDownward -> Prelude.return ((-4170))
     XlTickLabelOrientationHorizontal -> Prelude.return ((-4128))
     XlTickLabelOrientationUpward -> Prelude.return ((-4171))
     XlTickLabelOrientationVertical -> Prelude.return ((-4166))
unmarshallXlTickLabelOrientation :: Int.Int16 -> Prelude.IO XlTickLabelOrientation
unmarshallXlTickLabelOrientation v =
  case v of
     (-4105) -> Prelude.return (XlTickLabelOrientationAutomatic)
     (-4170) -> Prelude.return (XlTickLabelOrientationDownward)
     (-4128) -> Prelude.return (XlTickLabelOrientationHorizontal)
     (-4171) -> Prelude.return (XlTickLabelOrientationUpward)
     (-4166) -> Prelude.return (XlTickLabelOrientationVertical)
     _ -> Prelude.fail (Prelude.userError "unmarshallXlTickLabelOrientation: illegal enum value ")
data XlBorderWeight
 = XlHairline
 | XlMedium
 | XlThick
 | XlThin
 
marshallXlBorderWeight :: XlBorderWeight -> Prelude.IO Int.Int16
marshallXlBorderWeight v =
  case v of
     XlHairline -> Prelude.return (1)
     XlMedium -> Prelude.return ((-4138))
     XlThick -> Prelude.return (4)
     XlThin -> Prelude.return (2)
unmarshallXlBorderWeight :: Int.Int16 -> Prelude.IO XlBorderWeight
unmarshallXlBorderWeight v =
  case v of
     1 -> Prelude.return (XlHairline)
     (-4138) -> Prelude.return (XlMedium)
     4 -> Prelude.return (XlThick)
     2 -> Prelude.return (XlThin)
     _ -> Prelude.fail (Prelude.userError "unmarshallXlBorderWeight: illegal enum value ")
data XlDataSeriesDate
 = XlDay
 | XlMonth
 | XlWeekday
 | XlYear
 
marshallXlDataSeriesDate :: XlDataSeriesDate -> Prelude.IO Int.Int16
marshallXlDataSeriesDate v =
  case v of
     XlDay -> Prelude.return (1)
     XlMonth -> Prelude.return (3)
     XlWeekday -> Prelude.return (2)
     XlYear -> Prelude.return (4)
unmarshallXlDataSeriesDate :: Int.Int16 -> Prelude.IO XlDataSeriesDate
unmarshallXlDataSeriesDate v =
  case v of
     1 -> Prelude.return (XlDay)
     3 -> Prelude.return (XlMonth)
     2 -> Prelude.return (XlWeekday)
     4 -> Prelude.return (XlYear)
     _ -> Prelude.fail (Prelude.userError "unmarshallXlDataSeriesDate: illegal enum value ")
data XlUnderlineStyle
 = XlUnderlineStyleDouble
 | XlUnderlineStyleDoubleAccounting
 | XlUnderlineStyleNone
 | XlUnderlineStyleSingle
 | XlUnderlineStyleSingleAccounting
 
marshallXlUnderlineStyle :: XlUnderlineStyle -> Prelude.IO Int.Int16
marshallXlUnderlineStyle v =
  case v of
     XlUnderlineStyleDouble -> Prelude.return ((-4119))
     XlUnderlineStyleDoubleAccounting -> Prelude.return (5)
     XlUnderlineStyleNone -> Prelude.return ((-4142))
     XlUnderlineStyleSingle -> Prelude.return (2)
     XlUnderlineStyleSingleAccounting -> Prelude.return (4)
unmarshallXlUnderlineStyle :: Int.Int16 -> Prelude.IO XlUnderlineStyle
unmarshallXlUnderlineStyle v =
  case v of
     (-4119) -> Prelude.return (XlUnderlineStyleDouble)
     5 -> Prelude.return (XlUnderlineStyleDoubleAccounting)
     (-4142) -> Prelude.return (XlUnderlineStyleNone)
     2 -> Prelude.return (XlUnderlineStyleSingle)
     4 -> Prelude.return (XlUnderlineStyleSingleAccounting)
     _ -> Prelude.fail (Prelude.userError "unmarshallXlUnderlineStyle: illegal enum value ")
data XlErrorBarType
 = XlErrorBarTypeCustom
 | XlErrorBarTypeFixedValue
 | XlErrorBarTypePercent
 | XlErrorBarTypeStDev
 | XlErrorBarTypeStError
 
marshallXlErrorBarType :: XlErrorBarType -> Prelude.IO Int.Int16
marshallXlErrorBarType v =
  case v of
     XlErrorBarTypeCustom -> Prelude.return ((-4114))
     XlErrorBarTypeFixedValue -> Prelude.return (1)
     XlErrorBarTypePercent -> Prelude.return (2)
     XlErrorBarTypeStDev -> Prelude.return ((-4155))
     XlErrorBarTypeStError -> Prelude.return (4)
unmarshallXlErrorBarType :: Int.Int16 -> Prelude.IO XlErrorBarType
unmarshallXlErrorBarType v =
  case v of
     (-4114) -> Prelude.return (XlErrorBarTypeCustom)
     1 -> Prelude.return (XlErrorBarTypeFixedValue)
     2 -> Prelude.return (XlErrorBarTypePercent)
     (-4155) -> Prelude.return (XlErrorBarTypeStDev)
     4 -> Prelude.return (XlErrorBarTypeStError)
     _ -> Prelude.fail (Prelude.userError "unmarshallXlErrorBarType: illegal enum value ")
data XlTrendlineType
 = XlExponential
 | XlLinear
 | XlLogarithmic
 | XlMovingAvg
 | XlPolynomial
 | XlPower
 
marshallXlTrendlineType :: XlTrendlineType -> Prelude.IO Int.Int16
marshallXlTrendlineType v =
  case v of
     XlExponential -> Prelude.return (5)
     XlLinear -> Prelude.return ((-4132))
     XlLogarithmic -> Prelude.return ((-4133))
     XlMovingAvg -> Prelude.return (6)
     XlPolynomial -> Prelude.return (3)
     XlPower -> Prelude.return (4)
unmarshallXlTrendlineType :: Int.Int16 -> Prelude.IO XlTrendlineType
unmarshallXlTrendlineType v =
  case v of
     5 -> Prelude.return (XlExponential)
     (-4132) -> Prelude.return (XlLinear)
     (-4133) -> Prelude.return (XlLogarithmic)
     6 -> Prelude.return (XlMovingAvg)
     3 -> Prelude.return (XlPolynomial)
     4 -> Prelude.return (XlPower)
     _ -> Prelude.fail (Prelude.userError "unmarshallXlTrendlineType: illegal enum value ")
data XlLineStyle
 = XlContinuous
 | XlDash
 | XlDashDot
 | XlDashDotDot
 | XlDot
 | XlDouble
 | XlSlantDashDot
 | XlLineStyleNone
 
marshallXlLineStyle :: XlLineStyle -> Prelude.IO Int.Int16
marshallXlLineStyle v =
  case v of
     XlContinuous -> Prelude.return (1)
     XlDash -> Prelude.return ((-4115))
     XlDashDot -> Prelude.return (4)
     XlDashDotDot -> Prelude.return (5)
     XlDot -> Prelude.return ((-4118))
     XlDouble -> Prelude.return ((-4119))
     XlSlantDashDot -> Prelude.return (13)
     XlLineStyleNone -> Prelude.return ((-4142))
unmarshallXlLineStyle :: Int.Int16 -> Prelude.IO XlLineStyle
unmarshallXlLineStyle v =
  case v of
     1 -> Prelude.return (XlContinuous)
     (-4115) -> Prelude.return (XlDash)
     4 -> Prelude.return (XlDashDot)
     5 -> Prelude.return (XlDashDotDot)
     (-4118) -> Prelude.return (XlDot)
     (-4119) -> Prelude.return (XlDouble)
     13 -> Prelude.return (XlSlantDashDot)
     (-4142) -> Prelude.return (XlLineStyleNone)
     _ -> Prelude.fail (Prelude.userError "unmarshallXlLineStyle: illegal enum value ")
data XlDataLabelsType
 = XlDataLabelsShowNone
 | XlDataLabelsShowValue
 | XlDataLabelsShowPercent
 | XlDataLabelsShowLabel
 | XlDataLabelsShowLabelAndPercent
 | XlDataLabelsShowBubbleSizes
 
marshallXlDataLabelsType :: XlDataLabelsType -> Prelude.IO Int.Int16
marshallXlDataLabelsType v =
  case v of
     XlDataLabelsShowNone -> Prelude.return ((-4142))
     XlDataLabelsShowValue -> Prelude.return (2)
     XlDataLabelsShowPercent -> Prelude.return (3)
     XlDataLabelsShowLabel -> Prelude.return (4)
     XlDataLabelsShowLabelAndPercent -> Prelude.return (5)
     XlDataLabelsShowBubbleSizes -> Prelude.return (6)
unmarshallXlDataLabelsType :: Int.Int16 -> Prelude.IO XlDataLabelsType
unmarshallXlDataLabelsType v =
  case v of
     (-4142) -> Prelude.return (XlDataLabelsShowNone)
     2 -> Prelude.return (XlDataLabelsShowValue)
     3 -> Prelude.return (XlDataLabelsShowPercent)
     4 -> Prelude.return (XlDataLabelsShowLabel)
     5 -> Prelude.return (XlDataLabelsShowLabelAndPercent)
     6 -> Prelude.return (XlDataLabelsShowBubbleSizes)
     _ -> Prelude.fail (Prelude.userError "unmarshallXlDataLabelsType: illegal enum value ")
data XlMarkerStyle
 = XlMarkerStyleAutomatic
 | XlMarkerStyleCircle
 | XlMarkerStyleDash
 | XlMarkerStyleDiamond
 | XlMarkerStyleDot
 | XlMarkerStyleNone
 | XlMarkerStylePicture
 | XlMarkerStylePlus
 | XlMarkerStyleSquare
 | XlMarkerStyleStar
 | XlMarkerStyleTriangle
 | XlMarkerStyleX
 
marshallXlMarkerStyle :: XlMarkerStyle -> Prelude.IO Int.Int16
marshallXlMarkerStyle v =
  case v of
     XlMarkerStyleAutomatic -> Prelude.return ((-4105))
     XlMarkerStyleCircle -> Prelude.return (8)
     XlMarkerStyleDash -> Prelude.return ((-4115))
     XlMarkerStyleDiamond -> Prelude.return (2)
     XlMarkerStyleDot -> Prelude.return ((-4118))
     XlMarkerStyleNone -> Prelude.return ((-4142))
     XlMarkerStylePicture -> Prelude.return ((-4147))
     XlMarkerStylePlus -> Prelude.return (9)
     XlMarkerStyleSquare -> Prelude.return (1)
     XlMarkerStyleStar -> Prelude.return (5)
     XlMarkerStyleTriangle -> Prelude.return (3)
     XlMarkerStyleX -> Prelude.return ((-4168))
unmarshallXlMarkerStyle :: Int.Int16 -> Prelude.IO XlMarkerStyle
unmarshallXlMarkerStyle v =
  case v of
     (-4105) -> Prelude.return (XlMarkerStyleAutomatic)
     8 -> Prelude.return (XlMarkerStyleCircle)
     (-4115) -> Prelude.return (XlMarkerStyleDash)
     2 -> Prelude.return (XlMarkerStyleDiamond)
     (-4118) -> Prelude.return (XlMarkerStyleDot)
     (-4142) -> Prelude.return (XlMarkerStyleNone)
     (-4147) -> Prelude.return (XlMarkerStylePicture)
     9 -> Prelude.return (XlMarkerStylePlus)
     1 -> Prelude.return (XlMarkerStyleSquare)
     5 -> Prelude.return (XlMarkerStyleStar)
     3 -> Prelude.return (XlMarkerStyleTriangle)
     (-4168) -> Prelude.return (XlMarkerStyleX)
     _ -> Prelude.fail (Prelude.userError "unmarshallXlMarkerStyle: illegal enum value ")
data XlPictureConvertorType
 = XlBMP
 | XlCGM
 | XlDRW
 | XlDXF
 | XlEPS
 | XlHGL
 | XlPCT
 | XlPCX
 | XlPIC
 | XlPLT
 | XlTIF
 | XlWMF
 | XlWPG
 
marshallXlPictureConvertorType :: XlPictureConvertorType -> Prelude.IO Int.Int16
marshallXlPictureConvertorType v =
  case v of
     XlBMP -> Prelude.return (1)
     XlCGM -> Prelude.return (7)
     XlDRW -> Prelude.return (4)
     XlDXF -> Prelude.return (5)
     XlEPS -> Prelude.return (8)
     XlHGL -> Prelude.return (6)
     XlPCT -> Prelude.return (13)
     XlPCX -> Prelude.return (10)
     XlPIC -> Prelude.return (11)
     XlPLT -> Prelude.return (12)
     XlTIF -> Prelude.return (9)
     XlWMF -> Prelude.return (2)
     XlWPG -> Prelude.return (3)
unmarshallXlPictureConvertorType :: Int.Int16 -> Prelude.IO XlPictureConvertorType
unmarshallXlPictureConvertorType v =
  case v of
     1 -> Prelude.return (XlBMP)
     7 -> Prelude.return (XlCGM)
     4 -> Prelude.return (XlDRW)
     5 -> Prelude.return (XlDXF)
     8 -> Prelude.return (XlEPS)
     6 -> Prelude.return (XlHGL)
     13 -> Prelude.return (XlPCT)
     10 -> Prelude.return (XlPCX)
     11 -> Prelude.return (XlPIC)
     12 -> Prelude.return (XlPLT)
     9 -> Prelude.return (XlTIF)
     2 -> Prelude.return (XlWMF)
     3 -> Prelude.return (XlWPG)
     _ -> Prelude.fail (Prelude.userError "unmarshallXlPictureConvertorType: illegal enum value ")
data XlPattern
 = XlPatternAutomatic
 | XlPatternChecker
 | XlPatternCrissCross
 | XlPatternDown
 | XlPatternGray16
 | XlPatternGray25
 | XlPatternGray50
 | XlPatternGray75
 | XlPatternGray8
 | XlPatternGrid
 | XlPatternHorizontal
 | XlPatternLightDown
 | XlPatternLightHorizontal
 | XlPatternLightUp
 | XlPatternLightVertical
 | XlPatternNone
 | XlPatternSemiGray75
 | XlPatternSolid
 | XlPatternUp
 | XlPatternVertical
 
marshallXlPattern :: XlPattern -> Prelude.IO Int.Int16
marshallXlPattern v =
  case v of
     XlPatternAutomatic -> Prelude.return ((-4105))
     XlPatternChecker -> Prelude.return (9)
     XlPatternCrissCross -> Prelude.return (16)
     XlPatternDown -> Prelude.return ((-4121))
     XlPatternGray16 -> Prelude.return (17)
     XlPatternGray25 -> Prelude.return ((-4124))
     XlPatternGray50 -> Prelude.return ((-4125))
     XlPatternGray75 -> Prelude.return ((-4126))
     XlPatternGray8 -> Prelude.return (18)
     XlPatternGrid -> Prelude.return (15)
     XlPatternHorizontal -> Prelude.return ((-4128))
     XlPatternLightDown -> Prelude.return (13)
     XlPatternLightHorizontal -> Prelude.return (11)
     XlPatternLightUp -> Prelude.return (14)
     XlPatternLightVertical -> Prelude.return (12)
     XlPatternNone -> Prelude.return ((-4142))
     XlPatternSemiGray75 -> Prelude.return (10)
     XlPatternSolid -> Prelude.return (1)
     XlPatternUp -> Prelude.return ((-4162))
     XlPatternVertical -> Prelude.return ((-4166))
unmarshallXlPattern :: Int.Int16 -> Prelude.IO XlPattern
unmarshallXlPattern v =
  case v of
     (-4105) -> Prelude.return (XlPatternAutomatic)
     9 -> Prelude.return (XlPatternChecker)
     16 -> Prelude.return (XlPatternCrissCross)
     (-4121) -> Prelude.return (XlPatternDown)
     17 -> Prelude.return (XlPatternGray16)
     (-4124) -> Prelude.return (XlPatternGray25)
     (-4125) -> Prelude.return (XlPatternGray50)
     (-4126) -> Prelude.return (XlPatternGray75)
     18 -> Prelude.return (XlPatternGray8)
     15 -> Prelude.return (XlPatternGrid)
     (-4128) -> Prelude.return (XlPatternHorizontal)
     13 -> Prelude.return (XlPatternLightDown)
     11 -> Prelude.return (XlPatternLightHorizontal)
     14 -> Prelude.return (XlPatternLightUp)
     12 -> Prelude.return (XlPatternLightVertical)
     (-4142) -> Prelude.return (XlPatternNone)
     10 -> Prelude.return (XlPatternSemiGray75)
     1 -> Prelude.return (XlPatternSolid)
     (-4162) -> Prelude.return (XlPatternUp)
     (-4166) -> Prelude.return (XlPatternVertical)
     _ -> Prelude.fail (Prelude.userError "unmarshallXlPattern: illegal enum value ")
data XlChartSplitType
 = XlSplitByPosition
 | XlSplitByPercentValue
 | XlSplitByCustomSplit
 | XlSplitByValue
 
marshallXlChartSplitType :: XlChartSplitType -> Prelude.IO Int.Int16
marshallXlChartSplitType v =
  case v of
     XlSplitByPosition -> Prelude.return (1)
     XlSplitByPercentValue -> Prelude.return (3)
     XlSplitByCustomSplit -> Prelude.return (4)
     XlSplitByValue -> Prelude.return (2)
unmarshallXlChartSplitType :: Int.Int16 -> Prelude.IO XlChartSplitType
unmarshallXlChartSplitType v =
  case v of
     1 -> Prelude.return (XlSplitByPosition)
     3 -> Prelude.return (XlSplitByPercentValue)
     4 -> Prelude.return (XlSplitByCustomSplit)
     2 -> Prelude.return (XlSplitByValue)
     _ -> Prelude.fail (Prelude.userError "unmarshallXlChartSplitType: illegal enum value ")
data XlDataLabelPosition
 = XlLabelPositionCenter
 | XlLabelPositionAbove
 | XlLabelPositionBelow
 | XlLabelPositionLeft
 | XlLabelPositionRight
 | XlLabelPositionOutsideEnd
 | XlLabelPositionInsideEnd
 | XlLabelPositionInsideBase
 | XlLabelPositionBestFit
 | XlLabelPositionMixed
 | XlLabelPositionCustom
 
marshallXlDataLabelPosition :: XlDataLabelPosition -> Prelude.IO Int.Int16
marshallXlDataLabelPosition v =
  case v of
     XlLabelPositionCenter -> Prelude.return ((-4108))
     XlLabelPositionAbove -> Prelude.return (0)
     XlLabelPositionBelow -> Prelude.return (1)
     XlLabelPositionLeft -> Prelude.return ((-4131))
     XlLabelPositionRight -> Prelude.return ((-4152))
     XlLabelPositionOutsideEnd -> Prelude.return (2)
     XlLabelPositionInsideEnd -> Prelude.return (3)
     XlLabelPositionInsideBase -> Prelude.return (4)
     XlLabelPositionBestFit -> Prelude.return (5)
     XlLabelPositionMixed -> Prelude.return (6)
     XlLabelPositionCustom -> Prelude.return (7)
unmarshallXlDataLabelPosition :: Int.Int16 -> Prelude.IO XlDataLabelPosition
unmarshallXlDataLabelPosition v =
  case v of
     (-4108) -> Prelude.return (XlLabelPositionCenter)
     0 -> Prelude.return (XlLabelPositionAbove)
     1 -> Prelude.return (XlLabelPositionBelow)
     (-4131) -> Prelude.return (XlLabelPositionLeft)
     (-4152) -> Prelude.return (XlLabelPositionRight)
     2 -> Prelude.return (XlLabelPositionOutsideEnd)
     3 -> Prelude.return (XlLabelPositionInsideEnd)
     4 -> Prelude.return (XlLabelPositionInsideBase)
     5 -> Prelude.return (XlLabelPositionBestFit)
     6 -> Prelude.return (XlLabelPositionMixed)
     7 -> Prelude.return (XlLabelPositionCustom)
     _ -> Prelude.fail (Prelude.userError "unmarshallXlDataLabelPosition: illegal enum value ")
data XlTimeUnit
 = XlDays
 | XlMonths
 | XlYears
 
marshallXlTimeUnit :: XlTimeUnit -> Prelude.IO Int.Int16
marshallXlTimeUnit v =
  case v of
     XlDays -> Prelude.return (0)
     XlMonths -> Prelude.return (1)
     XlYears -> Prelude.return (2)
unmarshallXlTimeUnit :: Int.Int16 -> Prelude.IO XlTimeUnit
unmarshallXlTimeUnit v =
  case v of
     0 -> Prelude.return (XlDays)
     1 -> Prelude.return (XlMonths)
     2 -> Prelude.return (XlYears)
     _ -> Prelude.fail (Prelude.userError "unmarshallXlTimeUnit: illegal enum value ")
data XlCategoryType
 = XlCategoryScale
 | XlTimeScale
 | XlAutomaticScale
 
marshallXlCategoryType :: XlCategoryType -> Prelude.IO Int.Int16
marshallXlCategoryType v =
  case v of
     XlCategoryScale -> Prelude.return (2)
     XlTimeScale -> Prelude.return (3)
     XlAutomaticScale -> Prelude.return ((-4105))
unmarshallXlCategoryType :: Int.Int16 -> Prelude.IO XlCategoryType
unmarshallXlCategoryType v =
  case v of
     2 -> Prelude.return (XlCategoryScale)
     3 -> Prelude.return (XlTimeScale)
     (-4105) -> Prelude.return (XlAutomaticScale)
     _ -> Prelude.fail (Prelude.userError "unmarshallXlCategoryType: illegal enum value ")
data XlBarShape
 = XlBox
 | XlPyramidToPoint
 | XlPyramidToMax
 | XlCylinder
 | XlConeToPoint
 | XlConeToMax
 
marshallXlBarShape :: XlBarShape -> Prelude.IO Int.Int16
marshallXlBarShape v =
  case v of
     XlBox -> Prelude.return (0)
     XlPyramidToPoint -> Prelude.return (1)
     XlPyramidToMax -> Prelude.return (2)
     XlCylinder -> Prelude.return (3)
     XlConeToPoint -> Prelude.return (4)
     XlConeToMax -> Prelude.return (5)
unmarshallXlBarShape :: Int.Int16 -> Prelude.IO XlBarShape
unmarshallXlBarShape v =
  case v of
     0 -> Prelude.return (XlBox)
     1 -> Prelude.return (XlPyramidToPoint)
     2 -> Prelude.return (XlPyramidToMax)
     3 -> Prelude.return (XlCylinder)
     4 -> Prelude.return (XlConeToPoint)
     5 -> Prelude.return (XlConeToMax)
     _ -> Prelude.fail (Prelude.userError "unmarshallXlBarShape: illegal enum value ")
data XlChartType
 = XlColumnClustered
 | XlColumnStacked
 | XlColumnStacked100
 | Xl3DColumnClustered
 | Xl3DColumnStacked
 | Xl3DColumnStacked100
 | XlBarClustered
 | XlBarStacked
 | XlBarStacked100
 | Xl3DBarClustered
 | Xl3DBarStacked
 | Xl3DBarStacked100
 | XlLineStacked
 | XlLineStacked100
 | XlLineMarkers
 | XlLineMarkersStacked
 | XlLineMarkersStacked100
 | XlPieOfPie
 | XlPieExploded
 | Xl3DPieExploded
 | XlBarOfPie
 | XlXYScatterSmooth
 | XlXYScatterSmoothNoMarkers
 | XlXYScatterLines
 | XlXYScatterLinesNoMarkers
 | XlAreaStacked
 | XlAreaStacked100
 | Xl3DAreaStacked
 | Xl3DAreaStacked100
 | XlDoughnutExploded
 | XlRadarMarkers
 | XlRadarFilled
 | XlSurface
 | XlSurfaceWireframe
 | XlSurfaceTopView
 | XlSurfaceTopViewWireframe
 | XlBubble
 | XlBubble3DEffect
 | XlStockHLC
 | XlStockOHLC
 | XlStockVHLC
 | XlStockVOHLC
 | XlCylinderColClustered
 | XlCylinderColStacked
 | XlCylinderColStacked100
 | XlCylinderBarClustered
 | XlCylinderBarStacked
 | XlCylinderBarStacked100
 | XlCylinderCol
 | XlConeColClustered
 | XlConeColStacked
 | XlConeColStacked100
 | XlConeBarClustered
 | XlConeBarStacked
 | XlConeBarStacked100
 | XlConeCol
 | XlPyramidColClustered
 | XlPyramidColStacked
 | XlPyramidColStacked100
 | XlPyramidBarClustered
 | XlPyramidBarStacked
 | XlPyramidBarStacked100
 | XlPyramidCol
 | Xl3DColumn
 | XlLine
 | Xl3DLine
 | Xl3DPie
 | XlPie
 | XlXYScatter
 | Xl3DArea
 | XlArea
 | XlDoughnut
 | XlRadar
 
marshallXlChartType :: XlChartType -> Prelude.IO Int.Int16
marshallXlChartType v =
  case v of
     XlColumnClustered -> Prelude.return (51)
     XlColumnStacked -> Prelude.return (52)
     XlColumnStacked100 -> Prelude.return (53)
     Xl3DColumnClustered -> Prelude.return (54)
     Xl3DColumnStacked -> Prelude.return (55)
     Xl3DColumnStacked100 -> Prelude.return (56)
     XlBarClustered -> Prelude.return (57)
     XlBarStacked -> Prelude.return (58)
     XlBarStacked100 -> Prelude.return (59)
     Xl3DBarClustered -> Prelude.return (60)
     Xl3DBarStacked -> Prelude.return (61)
     Xl3DBarStacked100 -> Prelude.return (62)
     XlLineStacked -> Prelude.return (63)
     XlLineStacked100 -> Prelude.return (64)
     XlLineMarkers -> Prelude.return (65)
     XlLineMarkersStacked -> Prelude.return (66)
     XlLineMarkersStacked100 -> Prelude.return (67)
     XlPieOfPie -> Prelude.return (68)
     XlPieExploded -> Prelude.return (69)
     Xl3DPieExploded -> Prelude.return (70)
     XlBarOfPie -> Prelude.return (71)
     XlXYScatterSmooth -> Prelude.return (72)
     XlXYScatterSmoothNoMarkers -> Prelude.return (73)
     XlXYScatterLines -> Prelude.return (74)
     XlXYScatterLinesNoMarkers -> Prelude.return (75)
     XlAreaStacked -> Prelude.return (76)
     XlAreaStacked100 -> Prelude.return (77)
     Xl3DAreaStacked -> Prelude.return (78)
     Xl3DAreaStacked100 -> Prelude.return (79)
     XlDoughnutExploded -> Prelude.return (80)
     XlRadarMarkers -> Prelude.return (81)
     XlRadarFilled -> Prelude.return (82)
     XlSurface -> Prelude.return (83)
     XlSurfaceWireframe -> Prelude.return (84)
     XlSurfaceTopView -> Prelude.return (85)
     XlSurfaceTopViewWireframe -> Prelude.return (86)
     XlBubble -> Prelude.return (15)
     XlBubble3DEffect -> Prelude.return (87)
     XlStockHLC -> Prelude.return (88)
     XlStockOHLC -> Prelude.return (89)
     XlStockVHLC -> Prelude.return (90)
     XlStockVOHLC -> Prelude.return (91)
     XlCylinderColClustered -> Prelude.return (92)
     XlCylinderColStacked -> Prelude.return (93)
     XlCylinderColStacked100 -> Prelude.return (94)
     XlCylinderBarClustered -> Prelude.return (95)
     XlCylinderBarStacked -> Prelude.return (96)
     XlCylinderBarStacked100 -> Prelude.return (97)
     XlCylinderCol -> Prelude.return (98)
     XlConeColClustered -> Prelude.return (99)
     XlConeColStacked -> Prelude.return (100)
     XlConeColStacked100 -> Prelude.return (101)
     XlConeBarClustered -> Prelude.return (102)
     XlConeBarStacked -> Prelude.return (103)
     XlConeBarStacked100 -> Prelude.return (104)
     XlConeCol -> Prelude.return (105)
     XlPyramidColClustered -> Prelude.return (106)
     XlPyramidColStacked -> Prelude.return (107)
     XlPyramidColStacked100 -> Prelude.return (108)
     XlPyramidBarClustered -> Prelude.return (109)
     XlPyramidBarStacked -> Prelude.return (110)
     XlPyramidBarStacked100 -> Prelude.return (111)
     XlPyramidCol -> Prelude.return (112)
     Xl3DColumn -> Prelude.return ((-4100))
     XlLine -> Prelude.return (4)
     Xl3DLine -> Prelude.return ((-4101))
     Xl3DPie -> Prelude.return ((-4102))
     XlPie -> Prelude.return (5)
     XlXYScatter -> Prelude.return ((-4169))
     Xl3DArea -> Prelude.return ((-4098))
     XlArea -> Prelude.return (1)
     XlDoughnut -> Prelude.return ((-4120))
     XlRadar -> Prelude.return ((-4151))
unmarshallXlChartType :: Int.Int16 -> Prelude.IO XlChartType
unmarshallXlChartType v =
  case v of
     51 -> Prelude.return (XlColumnClustered)
     52 -> Prelude.return (XlColumnStacked)
     53 -> Prelude.return (XlColumnStacked100)
     54 -> Prelude.return (Xl3DColumnClustered)
     55 -> Prelude.return (Xl3DColumnStacked)
     56 -> Prelude.return (Xl3DColumnStacked100)
     57 -> Prelude.return (XlBarClustered)
     58 -> Prelude.return (XlBarStacked)
     59 -> Prelude.return (XlBarStacked100)
     60 -> Prelude.return (Xl3DBarClustered)
     61 -> Prelude.return (Xl3DBarStacked)
     62 -> Prelude.return (Xl3DBarStacked100)
     63 -> Prelude.return (XlLineStacked)
     64 -> Prelude.return (XlLineStacked100)
     65 -> Prelude.return (XlLineMarkers)
     66 -> Prelude.return (XlLineMarkersStacked)
     67 -> Prelude.return (XlLineMarkersStacked100)
     68 -> Prelude.return (XlPieOfPie)
     69 -> Prelude.return (XlPieExploded)
     70 -> Prelude.return (Xl3DPieExploded)
     71 -> Prelude.return (XlBarOfPie)
     72 -> Prelude.return (XlXYScatterSmooth)
     73 -> Prelude.return (XlXYScatterSmoothNoMarkers)
     74 -> Prelude.return (XlXYScatterLines)
     75 -> Prelude.return (XlXYScatterLinesNoMarkers)
     76 -> Prelude.return (XlAreaStacked)
     77 -> Prelude.return (XlAreaStacked100)
     78 -> Prelude.return (Xl3DAreaStacked)
     79 -> Prelude.return (Xl3DAreaStacked100)
     80 -> Prelude.return (XlDoughnutExploded)
     81 -> Prelude.return (XlRadarMarkers)
     82 -> Prelude.return (XlRadarFilled)
     83 -> Prelude.return (XlSurface)
     84 -> Prelude.return (XlSurfaceWireframe)
     85 -> Prelude.return (XlSurfaceTopView)
     86 -> Prelude.return (XlSurfaceTopViewWireframe)
     15 -> Prelude.return (XlBubble)
     87 -> Prelude.return (XlBubble3DEffect)
     88 -> Prelude.return (XlStockHLC)
     89 -> Prelude.return (XlStockOHLC)
     90 -> Prelude.return (XlStockVHLC)
     91 -> Prelude.return (XlStockVOHLC)
     92 -> Prelude.return (XlCylinderColClustered)
     93 -> Prelude.return (XlCylinderColStacked)
     94 -> Prelude.return (XlCylinderColStacked100)
     95 -> Prelude.return (XlCylinderBarClustered)
     96 -> Prelude.return (XlCylinderBarStacked)
     97 -> Prelude.return (XlCylinderBarStacked100)
     98 -> Prelude.return (XlCylinderCol)
     99 -> Prelude.return (XlConeColClustered)
     100 -> Prelude.return (XlConeColStacked)
     101 -> Prelude.return (XlConeColStacked100)
     102 -> Prelude.return (XlConeBarClustered)
     103 -> Prelude.return (XlConeBarStacked)
     104 -> Prelude.return (XlConeBarStacked100)
     105 -> Prelude.return (XlConeCol)
     106 -> Prelude.return (XlPyramidColClustered)
     107 -> Prelude.return (XlPyramidColStacked)
     108 -> Prelude.return (XlPyramidColStacked100)
     109 -> Prelude.return (XlPyramidBarClustered)
     110 -> Prelude.return (XlPyramidBarStacked)
     111 -> Prelude.return (XlPyramidBarStacked100)
     112 -> Prelude.return (XlPyramidCol)
     (-4100) -> Prelude.return (Xl3DColumn)
     4 -> Prelude.return (XlLine)
     (-4101) -> Prelude.return (Xl3DLine)
     (-4102) -> Prelude.return (Xl3DPie)
     5 -> Prelude.return (XlPie)
     (-4169) -> Prelude.return (XlXYScatter)
     (-4098) -> Prelude.return (Xl3DArea)
     1 -> Prelude.return (XlArea)
     (-4120) -> Prelude.return (XlDoughnut)
     (-4151) -> Prelude.return (XlRadar)
     _ -> Prelude.fail (Prelude.userError "unmarshallXlChartType: illegal enum value ")
data XlChartItem
 = XlDataLabel
 | XlChartArea
 | XlSeries
 | XlChartTitle
 | XlWalls
 | XlCorners
 | XlDataTable
 | XlTrendline
 | XlErrorBars
 | XlXErrorBars
 | XlYErrorBars
 | XlLegendEntry
 | XlLegendKey
 | XlShape
 | XlMajorGridlines
 | XlMinorGridlines
 | XlAxisTitle
 | XlUpBars
 | XlPlotArea
 | XlDownBars
 | XlAxis
 | XlSeriesLines
 | XlFloor
 | XlLegend
 | XlHiLoLines
 | XlDropLines
 | XlRadarAxisLabels
 | XlNothing
 | XlLeaderLines
 
marshallXlChartItem :: XlChartItem -> Prelude.IO Int.Int16
marshallXlChartItem v =
  case v of
     XlDataLabel -> Prelude.return (0)
     XlChartArea -> Prelude.return (2)
     XlSeries -> Prelude.return (3)
     XlChartTitle -> Prelude.return (4)
     XlWalls -> Prelude.return (5)
     XlCorners -> Prelude.return (6)
     XlDataTable -> Prelude.return (7)
     XlTrendline -> Prelude.return (8)
     XlErrorBars -> Prelude.return (9)
     XlXErrorBars -> Prelude.return (10)
     XlYErrorBars -> Prelude.return (11)
     XlLegendEntry -> Prelude.return (12)
     XlLegendKey -> Prelude.return (13)
     XlShape -> Prelude.return (14)
     XlMajorGridlines -> Prelude.return (15)
     XlMinorGridlines -> Prelude.return (16)
     XlAxisTitle -> Prelude.return (17)
     XlUpBars -> Prelude.return (18)
     XlPlotArea -> Prelude.return (19)
     XlDownBars -> Prelude.return (20)
     XlAxis -> Prelude.return (21)
     XlSeriesLines -> Prelude.return (22)
     XlFloor -> Prelude.return (23)
     XlLegend -> Prelude.return (24)
     XlHiLoLines -> Prelude.return (25)
     XlDropLines -> Prelude.return (26)
     XlRadarAxisLabels -> Prelude.return (27)
     XlNothing -> Prelude.return (28)
     XlLeaderLines -> Prelude.return (29)
unmarshallXlChartItem :: Int.Int16 -> Prelude.IO XlChartItem
unmarshallXlChartItem v =
  case v of
     0 -> Prelude.return (XlDataLabel)
     2 -> Prelude.return (XlChartArea)
     3 -> Prelude.return (XlSeries)
     4 -> Prelude.return (XlChartTitle)
     5 -> Prelude.return (XlWalls)
     6 -> Prelude.return (XlCorners)
     7 -> Prelude.return (XlDataTable)
     8 -> Prelude.return (XlTrendline)
     9 -> Prelude.return (XlErrorBars)
     10 -> Prelude.return (XlXErrorBars)
     11 -> Prelude.return (XlYErrorBars)
     12 -> Prelude.return (XlLegendEntry)
     13 -> Prelude.return (XlLegendKey)
     14 -> Prelude.return (XlShape)
     15 -> Prelude.return (XlMajorGridlines)
     16 -> Prelude.return (XlMinorGridlines)
     17 -> Prelude.return (XlAxisTitle)
     18 -> Prelude.return (XlUpBars)
     19 -> Prelude.return (XlPlotArea)
     20 -> Prelude.return (XlDownBars)
     21 -> Prelude.return (XlAxis)
     22 -> Prelude.return (XlSeriesLines)
     23 -> Prelude.return (XlFloor)
     24 -> Prelude.return (XlLegend)
     25 -> Prelude.return (XlHiLoLines)
     26 -> Prelude.return (XlDropLines)
     27 -> Prelude.return (XlRadarAxisLabels)
     28 -> Prelude.return (XlNothing)
     29 -> Prelude.return (XlLeaderLines)
     _ -> Prelude.fail (Prelude.userError "unmarshallXlChartItem: illegal enum value ")
data XlSizeRepresents
 = XlSizeIsWidth
 | XlSizeIsArea
 
marshallXlSizeRepresents :: XlSizeRepresents -> Prelude.IO Int.Int16
marshallXlSizeRepresents v =
  case v of
     XlSizeIsWidth -> Prelude.return (2)
     XlSizeIsArea -> Prelude.return (1)
unmarshallXlSizeRepresents :: Int.Int16 -> Prelude.IO XlSizeRepresents
unmarshallXlSizeRepresents v =
  case v of
     2 -> Prelude.return (XlSizeIsWidth)
     1 -> Prelude.return (XlSizeIsArea)
     _ -> Prelude.fail (Prelude.userError "unmarshallXlSizeRepresents: illegal enum value ")
data XlInsertShiftDirection
 = XlShiftDown
 | XlShiftToRight
 
marshallXlInsertShiftDirection :: XlInsertShiftDirection -> Prelude.IO Int.Int16
marshallXlInsertShiftDirection v =
  case v of
     XlShiftDown -> Prelude.return ((-4121))
     XlShiftToRight -> Prelude.return ((-4161))
unmarshallXlInsertShiftDirection :: Int.Int16 -> Prelude.IO XlInsertShiftDirection
unmarshallXlInsertShiftDirection v =
  case v of
     (-4121) -> Prelude.return (XlShiftDown)
     (-4161) -> Prelude.return (XlShiftToRight)
     _ -> Prelude.fail (Prelude.userError "unmarshallXlInsertShiftDirection: illegal enum value ")
data XlDeleteShiftDirection
 = XlShiftToLeft
 | XlShiftUp
 
marshallXlDeleteShiftDirection :: XlDeleteShiftDirection -> Prelude.IO Int.Int16
marshallXlDeleteShiftDirection v =
  case v of
     XlShiftToLeft -> Prelude.return ((-4159))
     XlShiftUp -> Prelude.return ((-4162))
unmarshallXlDeleteShiftDirection :: Int.Int16 -> Prelude.IO XlDeleteShiftDirection
unmarshallXlDeleteShiftDirection v =
  case v of
     (-4159) -> Prelude.return (XlShiftToLeft)
     (-4162) -> Prelude.return (XlShiftUp)
     _ -> Prelude.fail (Prelude.userError "unmarshallXlDeleteShiftDirection: illegal enum value ")
data XlDirection
 = XlDown
 | XlToLeft
 | XlToRight
 | XlUp
 
marshallXlDirection :: XlDirection -> Prelude.IO Int.Int16
marshallXlDirection v =
  case v of
     XlDown -> Prelude.return ((-4121))
     XlToLeft -> Prelude.return ((-4159))
     XlToRight -> Prelude.return ((-4161))
     XlUp -> Prelude.return ((-4162))
unmarshallXlDirection :: Int.Int16 -> Prelude.IO XlDirection
unmarshallXlDirection v =
  case v of
     (-4121) -> Prelude.return (XlDown)
     (-4159) -> Prelude.return (XlToLeft)
     (-4161) -> Prelude.return (XlToRight)
     (-4162) -> Prelude.return (XlUp)
     _ -> Prelude.fail (Prelude.userError "unmarshallXlDirection: illegal enum value ")
data XlConsolidationFunction
 = XlAverage
 | XlCount
 | XlCountNums
 | XlMax
 | XlMin
 | XlProduct
 | XlStDev
 | XlStDevP
 | XlSum
 | XlVar
 | XlVarP
 
marshallXlConsolidationFunction :: XlConsolidationFunction -> Prelude.IO Int.Int16
marshallXlConsolidationFunction v =
  case v of
     XlAverage -> Prelude.return ((-4106))
     XlCount -> Prelude.return ((-4112))
     XlCountNums -> Prelude.return ((-4113))
     XlMax -> Prelude.return ((-4136))
     XlMin -> Prelude.return ((-4139))
     XlProduct -> Prelude.return ((-4149))
     XlStDev -> Prelude.return ((-4155))
     XlStDevP -> Prelude.return ((-4156))
     XlSum -> Prelude.return ((-4157))
     XlVar -> Prelude.return ((-4164))
     XlVarP -> Prelude.return ((-4165))
unmarshallXlConsolidationFunction :: Int.Int16 -> Prelude.IO XlConsolidationFunction
unmarshallXlConsolidationFunction v =
  case v of
     (-4106) -> Prelude.return (XlAverage)
     (-4112) -> Prelude.return (XlCount)
     (-4113) -> Prelude.return (XlCountNums)
     (-4136) -> Prelude.return (XlMax)
     (-4139) -> Prelude.return (XlMin)
     (-4149) -> Prelude.return (XlProduct)
     (-4155) -> Prelude.return (XlStDev)
     (-4156) -> Prelude.return (XlStDevP)
     (-4157) -> Prelude.return (XlSum)
     (-4164) -> Prelude.return (XlVar)
     (-4165) -> Prelude.return (XlVarP)
     _ -> Prelude.fail (Prelude.userError "unmarshallXlConsolidationFunction: illegal enum value ")
data XlSheetType
 = XlChart
 | XlDialogSheet
 | XlExcel4IntlMacroSheet
 | XlExcel4MacroSheet
 | XlWorksheet
 
marshallXlSheetType :: XlSheetType -> Prelude.IO Int.Int16
marshallXlSheetType v =
  case v of
     XlChart -> Prelude.return ((-4109))
     XlDialogSheet -> Prelude.return ((-4116))
     XlExcel4IntlMacroSheet -> Prelude.return (4)
     XlExcel4MacroSheet -> Prelude.return (3)
     XlWorksheet -> Prelude.return ((-4167))
unmarshallXlSheetType :: Int.Int16 -> Prelude.IO XlSheetType
unmarshallXlSheetType v =
  case v of
     (-4109) -> Prelude.return (XlChart)
     (-4116) -> Prelude.return (XlDialogSheet)
     4 -> Prelude.return (XlExcel4IntlMacroSheet)
     3 -> Prelude.return (XlExcel4MacroSheet)
     (-4167) -> Prelude.return (XlWorksheet)
     _ -> Prelude.fail (Prelude.userError "unmarshallXlSheetType: illegal enum value ")
data XlLocationInTable
 = XlColumnHeader
 | XlColumnItem
 | XlDataHeader
 | XlDataItem
 | XlPageHeader
 | XlPageItem
 | XlRowHeader
 | XlRowItem
 | XlTableBody
 
marshallXlLocationInTable :: XlLocationInTable -> Prelude.IO Int.Int16
marshallXlLocationInTable v =
  case v of
     XlColumnHeader -> Prelude.return ((-4110))
     XlColumnItem -> Prelude.return (5)
     XlDataHeader -> Prelude.return (3)
     XlDataItem -> Prelude.return (7)
     XlPageHeader -> Prelude.return (2)
     XlPageItem -> Prelude.return (6)
     XlRowHeader -> Prelude.return ((-4153))
     XlRowItem -> Prelude.return (4)
     XlTableBody -> Prelude.return (8)
unmarshallXlLocationInTable :: Int.Int16 -> Prelude.IO XlLocationInTable
unmarshallXlLocationInTable v =
  case v of
     (-4110) -> Prelude.return (XlColumnHeader)
     5 -> Prelude.return (XlColumnItem)
     3 -> Prelude.return (XlDataHeader)
     7 -> Prelude.return (XlDataItem)
     2 -> Prelude.return (XlPageHeader)
     6 -> Prelude.return (XlPageItem)
     (-4153) -> Prelude.return (XlRowHeader)
     4 -> Prelude.return (XlRowItem)
     8 -> Prelude.return (XlTableBody)
     _ -> Prelude.fail (Prelude.userError "unmarshallXlLocationInTable: illegal enum value ")
data XlFindLookIn
 = XlFormulas
 | XlComments
 | XlValues
 
marshallXlFindLookIn :: XlFindLookIn -> Prelude.IO Int.Int16
marshallXlFindLookIn v =
  case v of
     XlFormulas -> Prelude.return ((-4123))
     XlComments -> Prelude.return ((-4144))
     XlValues -> Prelude.return ((-4163))
unmarshallXlFindLookIn :: Int.Int16 -> Prelude.IO XlFindLookIn
unmarshallXlFindLookIn v =
  case v of
     (-4123) -> Prelude.return (XlFormulas)
     (-4144) -> Prelude.return (XlComments)
     (-4163) -> Prelude.return (XlValues)
     _ -> Prelude.fail (Prelude.userError "unmarshallXlFindLookIn: illegal enum value ")
data XlWindowType
 = XlChartAsWindow
 | XlChartInPlace
 | XlClipboard
 | XlInfo
 | XlWorkbook
 
marshallXlWindowType :: XlWindowType -> Prelude.IO Int.Int16
marshallXlWindowType v =
  case v of
     XlChartAsWindow -> Prelude.return (5)
     XlChartInPlace -> Prelude.return (4)
     XlClipboard -> Prelude.return (3)
     XlInfo -> Prelude.return ((-4129))
     XlWorkbook -> Prelude.return (1)
unmarshallXlWindowType :: Int.Int16 -> Prelude.IO XlWindowType
unmarshallXlWindowType v =
  case v of
     5 -> Prelude.return (XlChartAsWindow)
     4 -> Prelude.return (XlChartInPlace)
     3 -> Prelude.return (XlClipboard)
     (-4129) -> Prelude.return (XlInfo)
     1 -> Prelude.return (XlWorkbook)
     _ -> Prelude.fail (Prelude.userError "unmarshallXlWindowType: illegal enum value ")
data XlPivotFieldDataType
 = XlDate
 | XlNumber
 | XlText
 
marshallXlPivotFieldDataType :: XlPivotFieldDataType -> Prelude.IO Int.Int16
marshallXlPivotFieldDataType v =
  case v of
     XlDate -> Prelude.return (2)
     XlNumber -> Prelude.return ((-4145))
     XlText -> Prelude.return ((-4158))
unmarshallXlPivotFieldDataType :: Int.Int16 -> Prelude.IO XlPivotFieldDataType
unmarshallXlPivotFieldDataType v =
  case v of
     2 -> Prelude.return (XlDate)
     (-4145) -> Prelude.return (XlNumber)
     (-4158) -> Prelude.return (XlText)
     _ -> Prelude.fail (Prelude.userError "unmarshallXlPivotFieldDataType: illegal enum value ")
data XlCopyPictureFormat
 = XlBitmap
 | XlPicture
 
marshallXlCopyPictureFormat :: XlCopyPictureFormat -> Prelude.IO Int.Int16
marshallXlCopyPictureFormat v =
  case v of
     XlBitmap -> Prelude.return (2)
     XlPicture -> Prelude.return ((-4147))
unmarshallXlCopyPictureFormat :: Int.Int16 -> Prelude.IO XlCopyPictureFormat
unmarshallXlCopyPictureFormat v =
  case v of
     2 -> Prelude.return (XlBitmap)
     (-4147) -> Prelude.return (XlPicture)
     _ -> Prelude.fail (Prelude.userError "unmarshallXlCopyPictureFormat: illegal enum value ")
data XlPivotTableSourceType
 = XlConsolidation
 | XlDatabase
 | XlExternal
 | XlPivotTable
 
marshallXlPivotTableSourceType :: XlPivotTableSourceType -> Prelude.IO Int.Int16
marshallXlPivotTableSourceType v =
  case v of
     XlConsolidation -> Prelude.return (3)
     XlDatabase -> Prelude.return (1)
     XlExternal -> Prelude.return (2)
     XlPivotTable -> Prelude.return ((-4148))
unmarshallXlPivotTableSourceType :: Int.Int16 -> Prelude.IO XlPivotTableSourceType
unmarshallXlPivotTableSourceType v =
  case v of
     3 -> Prelude.return (XlConsolidation)
     1 -> Prelude.return (XlDatabase)
     2 -> Prelude.return (XlExternal)
     (-4148) -> Prelude.return (XlPivotTable)
     _ -> Prelude.fail (Prelude.userError "unmarshallXlPivotTableSourceType: illegal enum value ")
data XlReferenceStyle
 = XlA1
 | XlR1C1
 
marshallXlReferenceStyle :: XlReferenceStyle -> Prelude.IO Int.Int16
marshallXlReferenceStyle v =
  case v of
     XlA1 -> Prelude.return (1)
     XlR1C1 -> Prelude.return ((-4150))
unmarshallXlReferenceStyle :: Int.Int16 -> Prelude.IO XlReferenceStyle
unmarshallXlReferenceStyle v =
  case v of
     1 -> Prelude.return (XlA1)
     (-4150) -> Prelude.return (XlR1C1)
     _ -> Prelude.fail (Prelude.userError "unmarshallXlReferenceStyle: illegal enum value ")
data XlMSApplication
 = XlMicrosoftAccess
 | XlMicrosoftFoxPro
 | XlMicrosoftMail
 | XlMicrosoftPowerPoint
 | XlMicrosoftProject
 | XlMicrosoftSchedulePlus
 | XlMicrosoftWord
 
marshallXlMSApplication :: XlMSApplication -> Prelude.IO Int.Int16
marshallXlMSApplication v =
  case v of
     XlMicrosoftAccess -> Prelude.return (4)
     XlMicrosoftFoxPro -> Prelude.return (5)
     XlMicrosoftMail -> Prelude.return (3)
     XlMicrosoftPowerPoint -> Prelude.return (2)
     XlMicrosoftProject -> Prelude.return (6)
     XlMicrosoftSchedulePlus -> Prelude.return (7)
     XlMicrosoftWord -> Prelude.return (1)
unmarshallXlMSApplication :: Int.Int16 -> Prelude.IO XlMSApplication
unmarshallXlMSApplication v =
  case v of
     4 -> Prelude.return (XlMicrosoftAccess)
     5 -> Prelude.return (XlMicrosoftFoxPro)
     3 -> Prelude.return (XlMicrosoftMail)
     2 -> Prelude.return (XlMicrosoftPowerPoint)
     6 -> Prelude.return (XlMicrosoftProject)
     7 -> Prelude.return (XlMicrosoftSchedulePlus)
     1 -> Prelude.return (XlMicrosoftWord)
     _ -> Prelude.fail (Prelude.userError "unmarshallXlMSApplication: illegal enum value ")
data XlMouseButton
 = XlNoButton
 | XlPrimaryButton
 | XlSecondaryButton
 
marshallXlMouseButton :: XlMouseButton -> Prelude.IO Int.Int16
marshallXlMouseButton v =
  case v of
     XlNoButton -> Prelude.return (0)
     XlPrimaryButton -> Prelude.return (1)
     XlSecondaryButton -> Prelude.return (2)
unmarshallXlMouseButton :: Int.Int16 -> Prelude.IO XlMouseButton
unmarshallXlMouseButton v =
  case v of
     0 -> Prelude.return (XlNoButton)
     1 -> Prelude.return (XlPrimaryButton)
     2 -> Prelude.return (XlSecondaryButton)
     _ -> Prelude.fail (Prelude.userError "unmarshallXlMouseButton: illegal enum value ")
data XlCutCopyMode
 = XlCopy
 | XlCut
 
marshallXlCutCopyMode :: XlCutCopyMode -> Prelude.IO Int.Int16
marshallXlCutCopyMode v =
  case v of
     XlCopy -> Prelude.return (1)
     XlCut -> Prelude.return (2)
unmarshallXlCutCopyMode :: Int.Int16 -> Prelude.IO XlCutCopyMode
unmarshallXlCutCopyMode v =
  case v of
     1 -> Prelude.return (XlCopy)
     2 -> Prelude.return (XlCut)
     _ -> Prelude.fail (Prelude.userError "unmarshallXlCutCopyMode: illegal enum value ")
data XlFillWith
 = XlFillWithAll
 | XlFillWithContents
 | XlFillWithFormats
 
marshallXlFillWith :: XlFillWith -> Prelude.IO Int.Int16
marshallXlFillWith v =
  case v of
     XlFillWithAll -> Prelude.return ((-4104))
     XlFillWithContents -> Prelude.return (2)
     XlFillWithFormats -> Prelude.return ((-4122))
unmarshallXlFillWith :: Int.Int16 -> Prelude.IO XlFillWith
unmarshallXlFillWith v =
  case v of
     (-4104) -> Prelude.return (XlFillWithAll)
     2 -> Prelude.return (XlFillWithContents)
     (-4122) -> Prelude.return (XlFillWithFormats)
     _ -> Prelude.fail (Prelude.userError "unmarshallXlFillWith: illegal enum value ")
data XlFilterAction
 = XlFilterCopy
 | XlFilterInPlace
 
marshallXlFilterAction :: XlFilterAction -> Prelude.IO Int.Int16
marshallXlFilterAction v =
  case v of
     XlFilterCopy -> Prelude.return (2)
     XlFilterInPlace -> Prelude.return (1)
unmarshallXlFilterAction :: Int.Int16 -> Prelude.IO XlFilterAction
unmarshallXlFilterAction v =
  case v of
     2 -> Prelude.return (XlFilterCopy)
     1 -> Prelude.return (XlFilterInPlace)
     _ -> Prelude.fail (Prelude.userError "unmarshallXlFilterAction: illegal enum value ")
data XlOrder
 = XlDownThenOver
 | XlOverThenDown
 
marshallXlOrder :: XlOrder -> Prelude.IO Int.Int16
marshallXlOrder v =
  case v of
     XlDownThenOver -> Prelude.return (1)
     XlOverThenDown -> Prelude.return (2)
unmarshallXlOrder :: Int.Int16 -> Prelude.IO XlOrder
unmarshallXlOrder v =
  case v of
     1 -> Prelude.return (XlDownThenOver)
     2 -> Prelude.return (XlOverThenDown)
     _ -> Prelude.fail (Prelude.userError "unmarshallXlOrder: illegal enum value ")
data XlLinkType
 = XlLinkTypeExcelLinks
 | XlLinkTypeOLELinks
 
marshallXlLinkType :: XlLinkType -> Prelude.IO Int.Int16
marshallXlLinkType v =
  case v of
     XlLinkTypeExcelLinks -> Prelude.return (1)
     XlLinkTypeOLELinks -> Prelude.return (2)
unmarshallXlLinkType :: Int.Int16 -> Prelude.IO XlLinkType
unmarshallXlLinkType v =
  case v of
     1 -> Prelude.return (XlLinkTypeExcelLinks)
     2 -> Prelude.return (XlLinkTypeOLELinks)
     _ -> Prelude.fail (Prelude.userError "unmarshallXlLinkType: illegal enum value ")
data XlApplyNamesOrder
 = XlColumnThenRow
 | XlRowThenColumn
 
marshallXlApplyNamesOrder :: XlApplyNamesOrder -> Prelude.IO Int.Int16
marshallXlApplyNamesOrder v =
  case v of
     XlColumnThenRow -> Prelude.return (2)
     XlRowThenColumn -> Prelude.return (1)
unmarshallXlApplyNamesOrder :: Int.Int16 -> Prelude.IO XlApplyNamesOrder
unmarshallXlApplyNamesOrder v =
  case v of
     2 -> Prelude.return (XlColumnThenRow)
     1 -> Prelude.return (XlRowThenColumn)
     _ -> Prelude.fail (Prelude.userError "unmarshallXlApplyNamesOrder: illegal enum value ")
data XlEnableCancelKey
 = XlDisabled
 | XlErrorHandler
 | XlInterrupt
 
marshallXlEnableCancelKey :: XlEnableCancelKey -> Prelude.IO Int.Int16
marshallXlEnableCancelKey v =
  case v of
     XlDisabled -> Prelude.return (0)
     XlErrorHandler -> Prelude.return (2)
     XlInterrupt -> Prelude.return (1)
unmarshallXlEnableCancelKey :: Int.Int16 -> Prelude.IO XlEnableCancelKey
unmarshallXlEnableCancelKey v =
  case v of
     0 -> Prelude.return (XlDisabled)
     2 -> Prelude.return (XlErrorHandler)
     1 -> Prelude.return (XlInterrupt)
     _ -> Prelude.fail (Prelude.userError "unmarshallXlEnableCancelKey: illegal enum value ")
data XlPageBreak
 = XlPageBreakAutomatic
 | XlPageBreakManual
 
marshallXlPageBreak :: XlPageBreak -> Prelude.IO Int.Int16
marshallXlPageBreak v =
  case v of
     XlPageBreakAutomatic -> Prelude.return ((-4105))
     XlPageBreakManual -> Prelude.return ((-4135))
unmarshallXlPageBreak :: Int.Int16 -> Prelude.IO XlPageBreak
unmarshallXlPageBreak v =
  case v of
     (-4105) -> Prelude.return (XlPageBreakAutomatic)
     (-4135) -> Prelude.return (XlPageBreakManual)
     _ -> Prelude.fail (Prelude.userError "unmarshallXlPageBreak: illegal enum value ")
data XlOLEType
 = XlOLEControl
 | XlOLEEmbed
 | XlOLELink
 
marshallXlOLEType :: XlOLEType -> Prelude.IO Int.Int16
marshallXlOLEType v =
  case v of
     XlOLEControl -> Prelude.return (2)
     XlOLEEmbed -> Prelude.return (1)
     XlOLELink -> Prelude.return (0)
unmarshallXlOLEType :: Int.Int16 -> Prelude.IO XlOLEType
unmarshallXlOLEType v =
  case v of
     2 -> Prelude.return (XlOLEControl)
     1 -> Prelude.return (XlOLEEmbed)
     0 -> Prelude.return (XlOLELink)
     _ -> Prelude.fail (Prelude.userError "unmarshallXlOLEType: illegal enum value ")
data XlPageOrientation
 = XlLandscape
 | XlPortrait
 
marshallXlPageOrientation :: XlPageOrientation -> Prelude.IO Int.Int16
marshallXlPageOrientation v =
  case v of
     XlLandscape -> Prelude.return (2)
     XlPortrait -> Prelude.return (1)
unmarshallXlPageOrientation :: Int.Int16 -> Prelude.IO XlPageOrientation
unmarshallXlPageOrientation v =
  case v of
     2 -> Prelude.return (XlLandscape)
     1 -> Prelude.return (XlPortrait)
     _ -> Prelude.fail (Prelude.userError "unmarshallXlPageOrientation: illegal enum value ")
data XlLinkInfo
 = XlEditionDate
 | XlUpdateState
 
marshallXlLinkInfo :: XlLinkInfo -> Prelude.IO Int.Int16
marshallXlLinkInfo v =
  case v of
     XlEditionDate -> Prelude.return (2)
     XlUpdateState -> Prelude.return (1)
unmarshallXlLinkInfo :: Int.Int16 -> Prelude.IO XlLinkInfo
unmarshallXlLinkInfo v =
  case v of
     2 -> Prelude.return (XlEditionDate)
     1 -> Prelude.return (XlUpdateState)
     _ -> Prelude.fail (Prelude.userError "unmarshallXlLinkInfo: illegal enum value ")
data XlCommandUnderlines
 = XlCommandUnderlinesAutomatic
 | XlCommandUnderlinesOff
 | XlCommandUnderlinesOn
 
marshallXlCommandUnderlines :: XlCommandUnderlines -> Prelude.IO Int.Int16
marshallXlCommandUnderlines v =
  case v of
     XlCommandUnderlinesAutomatic -> Prelude.return ((-4105))
     XlCommandUnderlinesOff -> Prelude.return ((-4146))
     XlCommandUnderlinesOn -> Prelude.return (1)
unmarshallXlCommandUnderlines :: Int.Int16 -> Prelude.IO XlCommandUnderlines
unmarshallXlCommandUnderlines v =
  case v of
     (-4105) -> Prelude.return (XlCommandUnderlinesAutomatic)
     (-4146) -> Prelude.return (XlCommandUnderlinesOff)
     1 -> Prelude.return (XlCommandUnderlinesOn)
     _ -> Prelude.fail (Prelude.userError "unmarshallXlCommandUnderlines: illegal enum value ")
data XlOLEVerb
 = XlVerbOpen
 | XlVerbPrimary
 
marshallXlOLEVerb :: XlOLEVerb -> Prelude.IO Int.Int16
marshallXlOLEVerb v =
  case v of
     XlVerbOpen -> Prelude.return (2)
     XlVerbPrimary -> Prelude.return (1)
unmarshallXlOLEVerb :: Int.Int16 -> Prelude.IO XlOLEVerb
unmarshallXlOLEVerb v =
  case v of
     2 -> Prelude.return (XlVerbOpen)
     1 -> Prelude.return (XlVerbPrimary)
     _ -> Prelude.fail (Prelude.userError "unmarshallXlOLEVerb: illegal enum value ")
data XlCalculation
 = XlCalculationAutomatic
 | XlCalculationManual
 | XlCalculationSemiautomatic
 
marshallXlCalculation :: XlCalculation -> Prelude.IO Int.Int16
marshallXlCalculation v =
  case v of
     XlCalculationAutomatic -> Prelude.return ((-4105))
     XlCalculationManual -> Prelude.return ((-4135))
     XlCalculationSemiautomatic -> Prelude.return (2)
unmarshallXlCalculation :: Int.Int16 -> Prelude.IO XlCalculation
unmarshallXlCalculation v =
  case v of
     (-4105) -> Prelude.return (XlCalculationAutomatic)
     (-4135) -> Prelude.return (XlCalculationManual)
     2 -> Prelude.return (XlCalculationSemiautomatic)
     _ -> Prelude.fail (Prelude.userError "unmarshallXlCalculation: illegal enum value ")
data XlFileAccess
 = XlReadOnly
 | XlReadWrite
 
marshallXlFileAccess :: XlFileAccess -> Prelude.IO Int.Int16
marshallXlFileAccess v =
  case v of
     XlReadOnly -> Prelude.return (3)
     XlReadWrite -> Prelude.return (2)
unmarshallXlFileAccess :: Int.Int16 -> Prelude.IO XlFileAccess
unmarshallXlFileAccess v =
  case v of
     3 -> Prelude.return (XlReadOnly)
     2 -> Prelude.return (XlReadWrite)
     _ -> Prelude.fail (Prelude.userError "unmarshallXlFileAccess: illegal enum value ")
data XlEditionType
 = XlPublisher
 | XlSubscriber
 
marshallXlEditionType :: XlEditionType -> Prelude.IO Int.Int16
marshallXlEditionType v =
  case v of
     XlPublisher -> Prelude.return (1)
     XlSubscriber -> Prelude.return (2)
unmarshallXlEditionType :: Int.Int16 -> Prelude.IO XlEditionType
unmarshallXlEditionType v =
  case v of
     1 -> Prelude.return (XlPublisher)
     2 -> Prelude.return (XlSubscriber)
     _ -> Prelude.fail (Prelude.userError "unmarshallXlEditionType: illegal enum value ")
data XlObjectSize
 = XlFitToPage
 | XlFullPage
 | XlScreenSize
 
marshallXlObjectSize :: XlObjectSize -> Prelude.IO Int.Int16
marshallXlObjectSize v =
  case v of
     XlFitToPage -> Prelude.return (2)
     XlFullPage -> Prelude.return (3)
     XlScreenSize -> Prelude.return (1)
unmarshallXlObjectSize :: Int.Int16 -> Prelude.IO XlObjectSize
unmarshallXlObjectSize v =
  case v of
     2 -> Prelude.return (XlFitToPage)
     3 -> Prelude.return (XlFullPage)
     1 -> Prelude.return (XlScreenSize)
     _ -> Prelude.fail (Prelude.userError "unmarshallXlObjectSize: illegal enum value ")
data XlLookAt
 = XlPart
 | XlWhole
 
marshallXlLookAt :: XlLookAt -> Prelude.IO Int.Int16
marshallXlLookAt v =
  case v of
     XlPart -> Prelude.return (2)
     XlWhole -> Prelude.return (1)
unmarshallXlLookAt :: Int.Int16 -> Prelude.IO XlLookAt
unmarshallXlLookAt v =
  case v of
     2 -> Prelude.return (XlPart)
     1 -> Prelude.return (XlWhole)
     _ -> Prelude.fail (Prelude.userError "unmarshallXlLookAt: illegal enum value ")
data XlMailSystem
 = XlMAPI
 | XlNoMailSystem
 | XlPowerTalk
 
marshallXlMailSystem :: XlMailSystem -> Prelude.IO Int.Int16
marshallXlMailSystem v =
  case v of
     XlMAPI -> Prelude.return (1)
     XlNoMailSystem -> Prelude.return (0)
     XlPowerTalk -> Prelude.return (2)
unmarshallXlMailSystem :: Int.Int16 -> Prelude.IO XlMailSystem
unmarshallXlMailSystem v =
  case v of
     1 -> Prelude.return (XlMAPI)
     0 -> Prelude.return (XlNoMailSystem)
     2 -> Prelude.return (XlPowerTalk)
     _ -> Prelude.fail (Prelude.userError "unmarshallXlMailSystem: illegal enum value ")
data XlLinkInfoType
 = XlLinkInfoOLELinks
 | XlLinkInfoPublishers
 | XlLinkInfoSubscribers
 
marshallXlLinkInfoType :: XlLinkInfoType -> Prelude.IO Int.Int16
marshallXlLinkInfoType v =
  case v of
     XlLinkInfoOLELinks -> Prelude.return (2)
     XlLinkInfoPublishers -> Prelude.return (5)
     XlLinkInfoSubscribers -> Prelude.return (6)
unmarshallXlLinkInfoType :: Int.Int16 -> Prelude.IO XlLinkInfoType
unmarshallXlLinkInfoType v =
  case v of
     2 -> Prelude.return (XlLinkInfoOLELinks)
     5 -> Prelude.return (XlLinkInfoPublishers)
     6 -> Prelude.return (XlLinkInfoSubscribers)
     _ -> Prelude.fail (Prelude.userError "unmarshallXlLinkInfoType: illegal enum value ")
data XlCVError
 = XlErrDiv0
 | XlErrNA
 | XlErrName
 | XlErrNull
 | XlErrNum
 | XlErrRef
 | XlErrValue
 
marshallXlCVError :: XlCVError -> Prelude.IO Int.Int16
marshallXlCVError v =
  case v of
     XlErrDiv0 -> Prelude.return (2007)
     XlErrNA -> Prelude.return (2042)
     XlErrName -> Prelude.return (2029)
     XlErrNull -> Prelude.return (2000)
     XlErrNum -> Prelude.return (2036)
     XlErrRef -> Prelude.return (2023)
     XlErrValue -> Prelude.return (2015)
unmarshallXlCVError :: Int.Int16 -> Prelude.IO XlCVError
unmarshallXlCVError v =
  case v of
     2007 -> Prelude.return (XlErrDiv0)
     2042 -> Prelude.return (XlErrNA)
     2029 -> Prelude.return (XlErrName)
     2000 -> Prelude.return (XlErrNull)
     2036 -> Prelude.return (XlErrNum)
     2023 -> Prelude.return (XlErrRef)
     2015 -> Prelude.return (XlErrValue)
     _ -> Prelude.fail (Prelude.userError "unmarshallXlCVError: illegal enum value ")
data XlEditionFormat
 = XlBIFF
 | XlPICT
 | XlRTF
 | XlVALU
 
marshallXlEditionFormat :: XlEditionFormat -> Prelude.IO Int.Int16
marshallXlEditionFormat v =
  case v of
     XlBIFF -> Prelude.return (2)
     XlPICT -> Prelude.return (1)
     XlRTF -> Prelude.return (4)
     XlVALU -> Prelude.return (8)
unmarshallXlEditionFormat :: Int.Int16 -> Prelude.IO XlEditionFormat
unmarshallXlEditionFormat v =
  case v of
     2 -> Prelude.return (XlBIFF)
     1 -> Prelude.return (XlPICT)
     4 -> Prelude.return (XlRTF)
     8 -> Prelude.return (XlVALU)
     _ -> Prelude.fail (Prelude.userError "unmarshallXlEditionFormat: illegal enum value ")
data XlLink
 = XlExcelLinks
 | XlOLELinks
 | XlPublishers
 | XlSubscribers
 
marshallXlLink :: XlLink -> Prelude.IO Int.Int16
marshallXlLink v =
  case v of
     XlExcelLinks -> Prelude.return (1)
     XlOLELinks -> Prelude.return (2)
     XlPublishers -> Prelude.return (5)
     XlSubscribers -> Prelude.return (6)
unmarshallXlLink :: Int.Int16 -> Prelude.IO XlLink
unmarshallXlLink v =
  case v of
     1 -> Prelude.return (XlExcelLinks)
     2 -> Prelude.return (XlOLELinks)
     5 -> Prelude.return (XlPublishers)
     6 -> Prelude.return (XlSubscribers)
     _ -> Prelude.fail (Prelude.userError "unmarshallXlLink: illegal enum value ")
data XlCellType
 = XlCellTypeBlanks
 | XlCellTypeConstants
 | XlCellTypeFormulas
 | XlCellTypeLastCell
 | XlCellTypeComments
 | XlCellTypeVisible
 | XlCellTypeAllFormatConditions
 | XlCellTypeSameFormatConditions
 | XlCellTypeAllValidation
 | XlCellTypeSameValidation
 
marshallXlCellType :: XlCellType -> Prelude.IO Int.Int16
marshallXlCellType v =
  case v of
     XlCellTypeBlanks -> Prelude.return (4)
     XlCellTypeConstants -> Prelude.return (2)
     XlCellTypeFormulas -> Prelude.return ((-4123))
     XlCellTypeLastCell -> Prelude.return (11)
     XlCellTypeComments -> Prelude.return ((-4144))
     XlCellTypeVisible -> Prelude.return (12)
     XlCellTypeAllFormatConditions -> Prelude.return ((-4172))
     XlCellTypeSameFormatConditions -> Prelude.return ((-4173))
     XlCellTypeAllValidation -> Prelude.return ((-4174))
     XlCellTypeSameValidation -> Prelude.return ((-4175))
unmarshallXlCellType :: Int.Int16 -> Prelude.IO XlCellType
unmarshallXlCellType v =
  case v of
     4 -> Prelude.return (XlCellTypeBlanks)
     2 -> Prelude.return (XlCellTypeConstants)
     (-4123) -> Prelude.return (XlCellTypeFormulas)
     11 -> Prelude.return (XlCellTypeLastCell)
     (-4144) -> Prelude.return (XlCellTypeComments)
     12 -> Prelude.return (XlCellTypeVisible)
     (-4172) -> Prelude.return (XlCellTypeAllFormatConditions)
     (-4173) -> Prelude.return (XlCellTypeSameFormatConditions)
     (-4174) -> Prelude.return (XlCellTypeAllValidation)
     (-4175) -> Prelude.return (XlCellTypeSameValidation)
     _ -> Prelude.fail (Prelude.userError "unmarshallXlCellType: illegal enum value ")
data XlArrangeStyle
 = XlArrangeStyleCascade
 | XlArrangeStyleHorizontal
 | XlArrangeStyleTiled
 | XlArrangeStyleVertical
 
marshallXlArrangeStyle :: XlArrangeStyle -> Prelude.IO Int.Int16
marshallXlArrangeStyle v =
  case v of
     XlArrangeStyleCascade -> Prelude.return (7)
     XlArrangeStyleHorizontal -> Prelude.return ((-4128))
     XlArrangeStyleTiled -> Prelude.return (1)
     XlArrangeStyleVertical -> Prelude.return ((-4166))
unmarshallXlArrangeStyle :: Int.Int16 -> Prelude.IO XlArrangeStyle
unmarshallXlArrangeStyle v =
  case v of
     7 -> Prelude.return (XlArrangeStyleCascade)
     (-4128) -> Prelude.return (XlArrangeStyleHorizontal)
     1 -> Prelude.return (XlArrangeStyleTiled)
     (-4166) -> Prelude.return (XlArrangeStyleVertical)
     _ -> Prelude.fail (Prelude.userError "unmarshallXlArrangeStyle: illegal enum value ")
data XlMousePointer
 = XlIBeam
 | XlDefault
 | XlNorthwestArrow
 | XlWait
 
marshallXlMousePointer :: XlMousePointer -> Prelude.IO Int.Int16
marshallXlMousePointer v =
  case v of
     XlIBeam -> Prelude.return (3)
     XlDefault -> Prelude.return ((-4143))
     XlNorthwestArrow -> Prelude.return (1)
     XlWait -> Prelude.return (2)
unmarshallXlMousePointer :: Int.Int16 -> Prelude.IO XlMousePointer
unmarshallXlMousePointer v =
  case v of
     3 -> Prelude.return (XlIBeam)
     (-4143) -> Prelude.return (XlDefault)
     1 -> Prelude.return (XlNorthwestArrow)
     2 -> Prelude.return (XlWait)
     _ -> Prelude.fail (Prelude.userError "unmarshallXlMousePointer: illegal enum value ")
data XlEditionOptionsOption
 = XlAutomaticUpdate
 | XlCancel
 | XlChangeAttributes
 | XlManualUpdate
 | XlOpenSource
 | XlSelect
 | XlSendPublisher
 | XlUpdateSubscriber
 
marshallXlEditionOptionsOption :: XlEditionOptionsOption -> Prelude.IO Int.Int16
marshallXlEditionOptionsOption v =
  case v of
     XlAutomaticUpdate -> Prelude.return (4)
     XlCancel -> Prelude.return (1)
     XlChangeAttributes -> Prelude.return (6)
     XlManualUpdate -> Prelude.return (5)
     XlOpenSource -> Prelude.return (3)
     XlSelect -> Prelude.return (3)
     XlSendPublisher -> Prelude.return (2)
     XlUpdateSubscriber -> Prelude.return (2)
unmarshallXlEditionOptionsOption :: Int.Int16 -> Prelude.IO XlEditionOptionsOption
unmarshallXlEditionOptionsOption v =
  case v of
     4 -> Prelude.return (XlAutomaticUpdate)
     1 -> Prelude.return (XlCancel)
     6 -> Prelude.return (XlChangeAttributes)
     5 -> Prelude.return (XlManualUpdate)
     3 -> Prelude.return (XlOpenSource)
     3 -> Prelude.return (XlSelect)
     2 -> Prelude.return (XlSendPublisher)
     2 -> Prelude.return (XlUpdateSubscriber)
     _ -> Prelude.fail (Prelude.userError "unmarshallXlEditionOptionsOption: illegal enum value ")
data XlAutoFillType
 = XlFillCopy
 | XlFillDays
 | XlFillDefault
 | XlFillFormats
 | XlFillMonths
 | XlFillSeries
 | XlFillValues
 | XlFillWeekdays
 | XlFillYears
 | XlGrowthTrend
 | XlLinearTrend
 
marshallXlAutoFillType :: XlAutoFillType -> Prelude.IO Int.Int16
marshallXlAutoFillType v =
  case v of
     XlFillCopy -> Prelude.return (1)
     XlFillDays -> Prelude.return (5)
     XlFillDefault -> Prelude.return (0)
     XlFillFormats -> Prelude.return (3)
     XlFillMonths -> Prelude.return (7)
     XlFillSeries -> Prelude.return (2)
     XlFillValues -> Prelude.return (4)
     XlFillWeekdays -> Prelude.return (6)
     XlFillYears -> Prelude.return (8)
     XlGrowthTrend -> Prelude.return (10)
     XlLinearTrend -> Prelude.return (9)
unmarshallXlAutoFillType :: Int.Int16 -> Prelude.IO XlAutoFillType
unmarshallXlAutoFillType v =
  case v of
     1 -> Prelude.return (XlFillCopy)
     5 -> Prelude.return (XlFillDays)
     0 -> Prelude.return (XlFillDefault)
     3 -> Prelude.return (XlFillFormats)
     7 -> Prelude.return (XlFillMonths)
     2 -> Prelude.return (XlFillSeries)
     4 -> Prelude.return (XlFillValues)
     6 -> Prelude.return (XlFillWeekdays)
     8 -> Prelude.return (XlFillYears)
     10 -> Prelude.return (XlGrowthTrend)
     9 -> Prelude.return (XlLinearTrend)
     _ -> Prelude.fail (Prelude.userError "unmarshallXlAutoFillType: illegal enum value ")
data XlAutoFilterOperator
 = XlAnd
 | XlBottom10Items
 | XlBottom10Percent
 | XlOr
 | XlTop10Items
 | XlTop10Percent
 
marshallXlAutoFilterOperator :: XlAutoFilterOperator -> Prelude.IO Int.Int16
marshallXlAutoFilterOperator v =
  case v of
     XlAnd -> Prelude.return (1)
     XlBottom10Items -> Prelude.return (4)
     XlBottom10Percent -> Prelude.return (6)
     XlOr -> Prelude.return (2)
     XlTop10Items -> Prelude.return (3)
     XlTop10Percent -> Prelude.return (5)
unmarshallXlAutoFilterOperator :: Int.Int16 -> Prelude.IO XlAutoFilterOperator
unmarshallXlAutoFilterOperator v =
  case v of
     1 -> Prelude.return (XlAnd)
     4 -> Prelude.return (XlBottom10Items)
     6 -> Prelude.return (XlBottom10Percent)
     2 -> Prelude.return (XlOr)
     3 -> Prelude.return (XlTop10Items)
     5 -> Prelude.return (XlTop10Percent)
     _ -> Prelude.fail (Prelude.userError "unmarshallXlAutoFilterOperator: illegal enum value ")
data XlClipboardFormat
 = XlClipboardFormatBIFF
 | XlClipboardFormatBIFF2
 | XlClipboardFormatBIFF3
 | XlClipboardFormatBIFF4
 | XlClipboardFormatBinary
 | XlClipboardFormatBitmap
 | XlClipboardFormatCGM
 | XlClipboardFormatCSV
 | XlClipboardFormatDIF
 | XlClipboardFormatDspText
 | XlClipboardFormatEmbeddedObject
 | XlClipboardFormatEmbedSource
 | XlClipboardFormatLink
 | XlClipboardFormatLinkSource
 | XlClipboardFormatLinkSourceDesc
 | XlClipboardFormatMovie
 | XlClipboardFormatNative
 | XlClipboardFormatObjectDesc
 | XlClipboardFormatObjectLink
 | XlClipboardFormatOwnerLink
 | XlClipboardFormatPICT
 | XlClipboardFormatPrintPICT
 | XlClipboardFormatRTF
 | XlClipboardFormatScreenPICT
 | XlClipboardFormatStandardFont
 | XlClipboardFormatStandardScale
 | XlClipboardFormatSYLK
 | XlClipboardFormatTable
 | XlClipboardFormatText
 | XlClipboardFormatToolFace
 | XlClipboardFormatToolFacePICT
 | XlClipboardFormatVALU
 | XlClipboardFormatWK1
 
marshallXlClipboardFormat :: XlClipboardFormat -> Prelude.IO Int.Int16
marshallXlClipboardFormat v =
  case v of
     XlClipboardFormatBIFF -> Prelude.return (8)
     XlClipboardFormatBIFF2 -> Prelude.return (18)
     XlClipboardFormatBIFF3 -> Prelude.return (20)
     XlClipboardFormatBIFF4 -> Prelude.return (30)
     XlClipboardFormatBinary -> Prelude.return (15)
     XlClipboardFormatBitmap -> Prelude.return (9)
     XlClipboardFormatCGM -> Prelude.return (13)
     XlClipboardFormatCSV -> Prelude.return (5)
     XlClipboardFormatDIF -> Prelude.return (4)
     XlClipboardFormatDspText -> Prelude.return (12)
     XlClipboardFormatEmbeddedObject -> Prelude.return (21)
     XlClipboardFormatEmbedSource -> Prelude.return (22)
     XlClipboardFormatLink -> Prelude.return (11)
     XlClipboardFormatLinkSource -> Prelude.return (23)
     XlClipboardFormatLinkSourceDesc -> Prelude.return (32)
     XlClipboardFormatMovie -> Prelude.return (24)
     XlClipboardFormatNative -> Prelude.return (14)
     XlClipboardFormatObjectDesc -> Prelude.return (31)
     XlClipboardFormatObjectLink -> Prelude.return (19)
     XlClipboardFormatOwnerLink -> Prelude.return (17)
     XlClipboardFormatPICT -> Prelude.return (2)
     XlClipboardFormatPrintPICT -> Prelude.return (3)
     XlClipboardFormatRTF -> Prelude.return (7)
     XlClipboardFormatScreenPICT -> Prelude.return (29)
     XlClipboardFormatStandardFont -> Prelude.return (28)
     XlClipboardFormatStandardScale -> Prelude.return (27)
     XlClipboardFormatSYLK -> Prelude.return (6)
     XlClipboardFormatTable -> Prelude.return (16)
     XlClipboardFormatText -> Prelude.return (0)
     XlClipboardFormatToolFace -> Prelude.return (25)
     XlClipboardFormatToolFacePICT -> Prelude.return (26)
     XlClipboardFormatVALU -> Prelude.return (1)
     XlClipboardFormatWK1 -> Prelude.return (10)
unmarshallXlClipboardFormat :: Int.Int16 -> Prelude.IO XlClipboardFormat
unmarshallXlClipboardFormat v =
  case v of
     8 -> Prelude.return (XlClipboardFormatBIFF)
     18 -> Prelude.return (XlClipboardFormatBIFF2)
     20 -> Prelude.return (XlClipboardFormatBIFF3)
     30 -> Prelude.return (XlClipboardFormatBIFF4)
     15 -> Prelude.return (XlClipboardFormatBinary)
     9 -> Prelude.return (XlClipboardFormatBitmap)
     13 -> Prelude.return (XlClipboardFormatCGM)
     5 -> Prelude.return (XlClipboardFormatCSV)
     4 -> Prelude.return (XlClipboardFormatDIF)
     12 -> Prelude.return (XlClipboardFormatDspText)
     21 -> Prelude.return (XlClipboardFormatEmbeddedObject)
     22 -> Prelude.return (XlClipboardFormatEmbedSource)
     11 -> Prelude.return (XlClipboardFormatLink)
     23 -> Prelude.return (XlClipboardFormatLinkSource)
     32 -> Prelude.return (XlClipboardFormatLinkSourceDesc)
     24 -> Prelude.return (XlClipboardFormatMovie)
     14 -> Prelude.return (XlClipboardFormatNative)
     31 -> Prelude.return (XlClipboardFormatObjectDesc)
     19 -> Prelude.return (XlClipboardFormatObjectLink)
     17 -> Prelude.return (XlClipboardFormatOwnerLink)
     2 -> Prelude.return (XlClipboardFormatPICT)
     3 -> Prelude.return (XlClipboardFormatPrintPICT)
     7 -> Prelude.return (XlClipboardFormatRTF)
     29 -> Prelude.return (XlClipboardFormatScreenPICT)
     28 -> Prelude.return (XlClipboardFormatStandardFont)
     27 -> Prelude.return (XlClipboardFormatStandardScale)
     6 -> Prelude.return (XlClipboardFormatSYLK)
     16 -> Prelude.return (XlClipboardFormatTable)
     0 -> Prelude.return (XlClipboardFormatText)
     25 -> Prelude.return (XlClipboardFormatToolFace)
     26 -> Prelude.return (XlClipboardFormatToolFacePICT)
     1 -> Prelude.return (XlClipboardFormatVALU)
     10 -> Prelude.return (XlClipboardFormatWK1)
     _ -> Prelude.fail (Prelude.userError "unmarshallXlClipboardFormat: illegal enum value ")
data XlFileFormat
 = XlAddIn
 | XlCSV
 | XlCSVMac
 | XlCSVMSDOS
 | XlCSVWindows
 | XlDBF2
 | XlDBF3
 | XlDBF4
 | XlDIF
 | XlExcel2
 | XlExcel2FarEast
 | XlExcel3
 | XlExcel4
 | XlExcel5
 | XlExcel7
 | XlExcel9795
 | XlExcel4Workbook
 | XlIntlAddIn
 | XlIntlMacro
 | XlWorkbookNormal
 | XlSYLK
 | XlTemplate
 | XlCurrentPlatformText
 | XlTextMac
 | XlTextMSDOS
 | XlTextPrinter
 | XlTextWindows
 | XlWJ2WD1
 | XlWK1
 | XlWK1ALL
 | XlWK1FMT
 | XlWK3
 | XlWK4
 | XlWK3FM3
 | XlWKS
 | XlWorks2FarEast
 | XlWQ1
 | XlWJ3
 | XlWJ3FJ3
 
marshallXlFileFormat :: XlFileFormat -> Prelude.IO Int.Int16
marshallXlFileFormat v =
  case v of
     XlAddIn -> Prelude.return (18)
     XlCSV -> Prelude.return (6)
     XlCSVMac -> Prelude.return (22)
     XlCSVMSDOS -> Prelude.return (24)
     XlCSVWindows -> Prelude.return (23)
     XlDBF2 -> Prelude.return (7)
     XlDBF3 -> Prelude.return (8)
     XlDBF4 -> Prelude.return (11)
     XlDIF -> Prelude.return (9)
     XlExcel2 -> Prelude.return (16)
     XlExcel2FarEast -> Prelude.return (27)
     XlExcel3 -> Prelude.return (29)
     XlExcel4 -> Prelude.return (33)
     XlExcel5 -> Prelude.return (39)
     XlExcel7 -> Prelude.return (39)
     XlExcel9795 -> Prelude.return (43)
     XlExcel4Workbook -> Prelude.return (35)
     XlIntlAddIn -> Prelude.return (26)
     XlIntlMacro -> Prelude.return (25)
     XlWorkbookNormal -> Prelude.return ((-4143))
     XlSYLK -> Prelude.return (2)
     XlTemplate -> Prelude.return (17)
     XlCurrentPlatformText -> Prelude.return ((-4158))
     XlTextMac -> Prelude.return (19)
     XlTextMSDOS -> Prelude.return (21)
     XlTextPrinter -> Prelude.return (36)
     XlTextWindows -> Prelude.return (20)
     XlWJ2WD1 -> Prelude.return (14)
     XlWK1 -> Prelude.return (5)
     XlWK1ALL -> Prelude.return (31)
     XlWK1FMT -> Prelude.return (30)
     XlWK3 -> Prelude.return (15)
     XlWK4 -> Prelude.return (38)
     XlWK3FM3 -> Prelude.return (32)
     XlWKS -> Prelude.return (4)
     XlWorks2FarEast -> Prelude.return (28)
     XlWQ1 -> Prelude.return (34)
     XlWJ3 -> Prelude.return (40)
     XlWJ3FJ3 -> Prelude.return (41)
unmarshallXlFileFormat :: Int.Int16 -> Prelude.IO XlFileFormat
unmarshallXlFileFormat v =
  case v of
     18 -> Prelude.return (XlAddIn)
     6 -> Prelude.return (XlCSV)
     22 -> Prelude.return (XlCSVMac)
     24 -> Prelude.return (XlCSVMSDOS)
     23 -> Prelude.return (XlCSVWindows)
     7 -> Prelude.return (XlDBF2)
     8 -> Prelude.return (XlDBF3)
     11 -> Prelude.return (XlDBF4)
     9 -> Prelude.return (XlDIF)
     16 -> Prelude.return (XlExcel2)
     27 -> Prelude.return (XlExcel2FarEast)
     29 -> Prelude.return (XlExcel3)
     33 -> Prelude.return (XlExcel4)
     39 -> Prelude.return (XlExcel5)
     39 -> Prelude.return (XlExcel7)
     43 -> Prelude.return (XlExcel9795)
     35 -> Prelude.return (XlExcel4Workbook)
     26 -> Prelude.return (XlIntlAddIn)
     25 -> Prelude.return (XlIntlMacro)
     (-4143) -> Prelude.return (XlWorkbookNormal)
     2 -> Prelude.return (XlSYLK)
     17 -> Prelude.return (XlTemplate)
     (-4158) -> Prelude.return (XlCurrentPlatformText)
     19 -> Prelude.return (XlTextMac)
     21 -> Prelude.return (XlTextMSDOS)
     36 -> Prelude.return (XlTextPrinter)
     20 -> Prelude.return (XlTextWindows)
     14 -> Prelude.return (XlWJ2WD1)
     5 -> Prelude.return (XlWK1)
     31 -> Prelude.return (XlWK1ALL)
     30 -> Prelude.return (XlWK1FMT)
     15 -> Prelude.return (XlWK3)
     38 -> Prelude.return (XlWK4)
     32 -> Prelude.return (XlWK3FM3)
     4 -> Prelude.return (XlWKS)
     28 -> Prelude.return (XlWorks2FarEast)
     34 -> Prelude.return (XlWQ1)
     40 -> Prelude.return (XlWJ3)
     41 -> Prelude.return (XlWJ3FJ3)
     _ -> Prelude.fail (Prelude.userError "unmarshallXlFileFormat: illegal enum value ")
data XlApplicationInternational
 = Xl24HourClock
 | Xl4DigitYears
 | XlAlternateArraySeparator
 | XlColumnSeparator
 | XlCountryCode
 | XlCountrySetting
 | XlCurrencyBefore
 | XlCurrencyCode
 | XlCurrencyDigits
 | XlCurrencyLeadingZeros
 | XlCurrencyMinusSign
 | XlCurrencyNegative
 | XlCurrencySpaceBefore
 | XlCurrencyTrailingZeros
 | XlDateOrder
 | XlDateSeparator
 | XlDayCode
 | XlDayLeadingZero
 | XlDecimalSeparator
 | XlGeneralFormatName
 | XlHourCode
 | XlLeftBrace
 | XlLeftBracket
 | XlListSeparator
 | XlLowerCaseColumnLetter
 | XlLowerCaseRowLetter
 | XlMDY
 | XlMetric
 | XlMinuteCode
 | XlMonthCode
 | XlMonthLeadingZero
 | XlMonthNameChars
 | XlNoncurrencyDigits
 | XlNonEnglishFunctions
 | XlRightBrace
 | XlRightBracket
 | XlRowSeparator
 | XlSecondCode
 | XlThousandsSeparator
 | XlTimeLeadingZero
 | XlTimeSeparator
 | XlUpperCaseColumnLetter
 | XlUpperCaseRowLetter
 | XlWeekdayNameChars
 | XlYearCode
 
marshallXlApplicationInternational :: XlApplicationInternational -> Prelude.IO Int.Int16
marshallXlApplicationInternational v =
  case v of
     Xl24HourClock -> Prelude.return (33)
     Xl4DigitYears -> Prelude.return (43)
     XlAlternateArraySeparator -> Prelude.return (16)
     XlColumnSeparator -> Prelude.return (14)
     XlCountryCode -> Prelude.return (1)
     XlCountrySetting -> Prelude.return (2)
     XlCurrencyBefore -> Prelude.return (37)
     XlCurrencyCode -> Prelude.return (25)
     XlCurrencyDigits -> Prelude.return (27)
     XlCurrencyLeadingZeros -> Prelude.return (40)
     XlCurrencyMinusSign -> Prelude.return (38)
     XlCurrencyNegative -> Prelude.return (28)
     XlCurrencySpaceBefore -> Prelude.return (36)
     XlCurrencyTrailingZeros -> Prelude.return (39)
     XlDateOrder -> Prelude.return (32)
     XlDateSeparator -> Prelude.return (17)
     XlDayCode -> Prelude.return (21)
     XlDayLeadingZero -> Prelude.return (42)
     XlDecimalSeparator -> Prelude.return (3)
     XlGeneralFormatName -> Prelude.return (26)
     XlHourCode -> Prelude.return (22)
     XlLeftBrace -> Prelude.return (12)
     XlLeftBracket -> Prelude.return (10)
     XlListSeparator -> Prelude.return (5)
     XlLowerCaseColumnLetter -> Prelude.return (9)
     XlLowerCaseRowLetter -> Prelude.return (8)
     XlMDY -> Prelude.return (44)
     XlMetric -> Prelude.return (35)
     XlMinuteCode -> Prelude.return (23)
     XlMonthCode -> Prelude.return (20)
     XlMonthLeadingZero -> Prelude.return (41)
     XlMonthNameChars -> Prelude.return (30)
     XlNoncurrencyDigits -> Prelude.return (29)
     XlNonEnglishFunctions -> Prelude.return (34)
     XlRightBrace -> Prelude.return (13)
     XlRightBracket -> Prelude.return (11)
     XlRowSeparator -> Prelude.return (15)
     XlSecondCode -> Prelude.return (24)
     XlThousandsSeparator -> Prelude.return (4)
     XlTimeLeadingZero -> Prelude.return (45)
     XlTimeSeparator -> Prelude.return (18)
     XlUpperCaseColumnLetter -> Prelude.return (7)
     XlUpperCaseRowLetter -> Prelude.return (6)
     XlWeekdayNameChars -> Prelude.return (31)
     XlYearCode -> Prelude.return (19)
unmarshallXlApplicationInternational :: Int.Int16 -> Prelude.IO XlApplicationInternational
unmarshallXlApplicationInternational v =
  case v of
     33 -> Prelude.return (Xl24HourClock)
     43 -> Prelude.return (Xl4DigitYears)
     16 -> Prelude.return (XlAlternateArraySeparator)
     14 -> Prelude.return (XlColumnSeparator)
     1 -> Prelude.return (XlCountryCode)
     2 -> Prelude.return (XlCountrySetting)
     37 -> Prelude.return (XlCurrencyBefore)
     25 -> Prelude.return (XlCurrencyCode)
     27 -> Prelude.return (XlCurrencyDigits)
     40 -> Prelude.return (XlCurrencyLeadingZeros)
     38 -> Prelude.return (XlCurrencyMinusSign)
     28 -> Prelude.return (XlCurrencyNegative)
     36 -> Prelude.return (XlCurrencySpaceBefore)
     39 -> Prelude.return (XlCurrencyTrailingZeros)
     32 -> Prelude.return (XlDateOrder)
     17 -> Prelude.return (XlDateSeparator)
     21 -> Prelude.return (XlDayCode)
     42 -> Prelude.return (XlDayLeadingZero)
     3 -> Prelude.return (XlDecimalSeparator)
     26 -> Prelude.return (XlGeneralFormatName)
     22 -> Prelude.return (XlHourCode)
     12 -> Prelude.return (XlLeftBrace)
     10 -> Prelude.return (XlLeftBracket)
     5 -> Prelude.return (XlListSeparator)
     9 -> Prelude.return (XlLowerCaseColumnLetter)
     8 -> Prelude.return (XlLowerCaseRowLetter)
     44 -> Prelude.return (XlMDY)
     35 -> Prelude.return (XlMetric)
     23 -> Prelude.return (XlMinuteCode)
     20 -> Prelude.return (XlMonthCode)
     41 -> Prelude.return (XlMonthLeadingZero)
     30 -> Prelude.return (XlMonthNameChars)
     29 -> Prelude.return (XlNoncurrencyDigits)
     34 -> Prelude.return (XlNonEnglishFunctions)
     13 -> Prelude.return (XlRightBrace)
     11 -> Prelude.return (XlRightBracket)
     15 -> Prelude.return (XlRowSeparator)
     24 -> Prelude.return (XlSecondCode)
     4 -> Prelude.return (XlThousandsSeparator)
     45 -> Prelude.return (XlTimeLeadingZero)
     18 -> Prelude.return (XlTimeSeparator)
     7 -> Prelude.return (XlUpperCaseColumnLetter)
     6 -> Prelude.return (XlUpperCaseRowLetter)
     31 -> Prelude.return (XlWeekdayNameChars)
     19 -> Prelude.return (XlYearCode)
     _ -> Prelude.fail (Prelude.userError "unmarshallXlApplicationInternational: illegal enum value ")
data XlPageBreakExtent
 = XlPageBreakFull
 | XlPageBreakPartial
 
marshallXlPageBreakExtent :: XlPageBreakExtent -> Prelude.IO Int.Int16
marshallXlPageBreakExtent v =
  case v of
     XlPageBreakFull -> Prelude.return (1)
     XlPageBreakPartial -> Prelude.return (2)
unmarshallXlPageBreakExtent :: Int.Int16 -> Prelude.IO XlPageBreakExtent
unmarshallXlPageBreakExtent v =
  case v of
     1 -> Prelude.return (XlPageBreakFull)
     2 -> Prelude.return (XlPageBreakPartial)
     _ -> Prelude.fail (Prelude.userError "unmarshallXlPageBreakExtent: illegal enum value ")
data XlCellInsertionMode
 = XlOverwriteCells
 | XlInsertDeleteCells
 | XlInsertEntireRows
 
marshallXlCellInsertionMode :: XlCellInsertionMode -> Prelude.IO Int.Int16
marshallXlCellInsertionMode v =
  case v of
     XlOverwriteCells -> Prelude.return (0)
     XlInsertDeleteCells -> Prelude.return (1)
     XlInsertEntireRows -> Prelude.return (2)
unmarshallXlCellInsertionMode :: Int.Int16 -> Prelude.IO XlCellInsertionMode
unmarshallXlCellInsertionMode v =
  case v of
     0 -> Prelude.return (XlOverwriteCells)
     1 -> Prelude.return (XlInsertDeleteCells)
     2 -> Prelude.return (XlInsertEntireRows)
     _ -> Prelude.fail (Prelude.userError "unmarshallXlCellInsertionMode: illegal enum value ")
data XlFormulaLabel
 = XlNoLabels
 | XlRowLabels
 | XlColumnLabels
 | XlMixedLabels
 
marshallXlFormulaLabel :: XlFormulaLabel -> Prelude.IO Int.Int16
marshallXlFormulaLabel v =
  case v of
     XlNoLabels -> Prelude.return ((-4142))
     XlRowLabels -> Prelude.return (1)
     XlColumnLabels -> Prelude.return (2)
     XlMixedLabels -> Prelude.return (3)
unmarshallXlFormulaLabel :: Int.Int16 -> Prelude.IO XlFormulaLabel
unmarshallXlFormulaLabel v =
  case v of
     (-4142) -> Prelude.return (XlNoLabels)
     1 -> Prelude.return (XlRowLabels)
     2 -> Prelude.return (XlColumnLabels)
     3 -> Prelude.return (XlMixedLabels)
     _ -> Prelude.fail (Prelude.userError "unmarshallXlFormulaLabel: illegal enum value ")
data XlHighlightChangesTime
 = XlSinceMyLastSave
 | XlAllChanges
 | XlNotYetReviewed
 
marshallXlHighlightChangesTime :: XlHighlightChangesTime -> Prelude.IO Int.Int16
marshallXlHighlightChangesTime v =
  case v of
     XlSinceMyLastSave -> Prelude.return (1)
     XlAllChanges -> Prelude.return (2)
     XlNotYetReviewed -> Prelude.return (3)
unmarshallXlHighlightChangesTime :: Int.Int16 -> Prelude.IO XlHighlightChangesTime
unmarshallXlHighlightChangesTime v =
  case v of
     1 -> Prelude.return (XlSinceMyLastSave)
     2 -> Prelude.return (XlAllChanges)
     3 -> Prelude.return (XlNotYetReviewed)
     _ -> Prelude.fail (Prelude.userError "unmarshallXlHighlightChangesTime: illegal enum value ")
data XlCommentDisplayMode
 = XlNoIndicator
 | XlCommentIndicatorOnly
 | XlCommentAndIndicator
 
marshallXlCommentDisplayMode :: XlCommentDisplayMode -> Prelude.IO Int.Int16
marshallXlCommentDisplayMode v =
  case v of
     XlNoIndicator -> Prelude.return (0)
     XlCommentIndicatorOnly -> Prelude.return ((-1))
     XlCommentAndIndicator -> Prelude.return (1)
unmarshallXlCommentDisplayMode :: Int.Int16 -> Prelude.IO XlCommentDisplayMode
unmarshallXlCommentDisplayMode v =
  case v of
     0 -> Prelude.return (XlNoIndicator)
     (-1) -> Prelude.return (XlCommentIndicatorOnly)
     1 -> Prelude.return (XlCommentAndIndicator)
     _ -> Prelude.fail (Prelude.userError "unmarshallXlCommentDisplayMode: illegal enum value ")
data XlFormatConditionType
 = XlCellValue
 | XlExpression
 
marshallXlFormatConditionType :: XlFormatConditionType -> Prelude.IO Int.Int16
marshallXlFormatConditionType v =
  case v of
     XlCellValue -> Prelude.return (1)
     XlExpression -> Prelude.return (2)
unmarshallXlFormatConditionType :: Int.Int16 -> Prelude.IO XlFormatConditionType
unmarshallXlFormatConditionType v =
  case v of
     1 -> Prelude.return (XlCellValue)
     2 -> Prelude.return (XlExpression)
     _ -> Prelude.fail (Prelude.userError "unmarshallXlFormatConditionType: illegal enum value ")
data XlFormatConditionOperator
 = XlBetween
 | XlNotBetween
 | XlEqual
 | XlNotEqual
 | XlGreater
 | XlLess
 | XlGreaterEqual
 | XlLessEqual
 
marshallXlFormatConditionOperator :: XlFormatConditionOperator -> Prelude.IO Int.Int16
marshallXlFormatConditionOperator v =
  case v of
     XlBetween -> Prelude.return (1)
     XlNotBetween -> Prelude.return (2)
     XlEqual -> Prelude.return (3)
     XlNotEqual -> Prelude.return (4)
     XlGreater -> Prelude.return (5)
     XlLess -> Prelude.return (6)
     XlGreaterEqual -> Prelude.return (7)
     XlLessEqual -> Prelude.return (8)
unmarshallXlFormatConditionOperator :: Int.Int16 -> Prelude.IO XlFormatConditionOperator
unmarshallXlFormatConditionOperator v =
  case v of
     1 -> Prelude.return (XlBetween)
     2 -> Prelude.return (XlNotBetween)
     3 -> Prelude.return (XlEqual)
     4 -> Prelude.return (XlNotEqual)
     5 -> Prelude.return (XlGreater)
     6 -> Prelude.return (XlLess)
     7 -> Prelude.return (XlGreaterEqual)
     8 -> Prelude.return (XlLessEqual)
     _ -> Prelude.fail (Prelude.userError "unmarshallXlFormatConditionOperator: illegal enum value ")
data XlEnableSelection
 = XlNoRestrictions
 | XlUnlockedCells
 | XlNoSelection
 
marshallXlEnableSelection :: XlEnableSelection -> Prelude.IO Int.Int16
marshallXlEnableSelection v =
  case v of
     XlNoRestrictions -> Prelude.return (0)
     XlUnlockedCells -> Prelude.return (1)
     XlNoSelection -> Prelude.return ((-4142))
unmarshallXlEnableSelection :: Int.Int16 -> Prelude.IO XlEnableSelection
unmarshallXlEnableSelection v =
  case v of
     0 -> Prelude.return (XlNoRestrictions)
     1 -> Prelude.return (XlUnlockedCells)
     (-4142) -> Prelude.return (XlNoSelection)
     _ -> Prelude.fail (Prelude.userError "unmarshallXlEnableSelection: illegal enum value ")
data XlDVType
 = XlValidateInputOnly
 | XlValidateWholeNumber
 | XlValidateDecimal
 | XlValidateList
 | XlValidateDate
 | XlValidateTime
 | XlValidateTextLength
 | XlValidateCustom
 
marshallXlDVType :: XlDVType -> Prelude.IO Int.Int16
marshallXlDVType v =
  case v of
     XlValidateInputOnly -> Prelude.return (0)
     XlValidateWholeNumber -> Prelude.return (1)
     XlValidateDecimal -> Prelude.return (2)
     XlValidateList -> Prelude.return (3)
     XlValidateDate -> Prelude.return (4)
     XlValidateTime -> Prelude.return (5)
     XlValidateTextLength -> Prelude.return (6)
     XlValidateCustom -> Prelude.return (7)
unmarshallXlDVType :: Int.Int16 -> Prelude.IO XlDVType
unmarshallXlDVType v =
  case v of
     0 -> Prelude.return (XlValidateInputOnly)
     1 -> Prelude.return (XlValidateWholeNumber)
     2 -> Prelude.return (XlValidateDecimal)
     3 -> Prelude.return (XlValidateList)
     4 -> Prelude.return (XlValidateDate)
     5 -> Prelude.return (XlValidateTime)
     6 -> Prelude.return (XlValidateTextLength)
     7 -> Prelude.return (XlValidateCustom)
     _ -> Prelude.fail (Prelude.userError "unmarshallXlDVType: illegal enum value ")
data XlIMEMode
 = XlIMEModeNoControl
 | XlIMEModeOn
 | XlIMEModeOff
 | XlIMEModeDisable
 | XlIMEModeHiragana
 | XlIMEModeKatakana
 | XlIMEModeKatakanaHalf
 | XlIMEModeAlphaFull
 | XlIMEModeAlpha
 | XlIMEModeHangulFull
 | XlIMEModeHangul
 
marshallXlIMEMode :: XlIMEMode -> Prelude.IO Int.Int16
marshallXlIMEMode v =
  case v of
     XlIMEModeNoControl -> Prelude.return (0)
     XlIMEModeOn -> Prelude.return (1)
     XlIMEModeOff -> Prelude.return (2)
     XlIMEModeDisable -> Prelude.return (3)
     XlIMEModeHiragana -> Prelude.return (4)
     XlIMEModeKatakana -> Prelude.return (5)
     XlIMEModeKatakanaHalf -> Prelude.return (6)
     XlIMEModeAlphaFull -> Prelude.return (7)
     XlIMEModeAlpha -> Prelude.return (8)
     XlIMEModeHangulFull -> Prelude.return (9)
     XlIMEModeHangul -> Prelude.return (10)
unmarshallXlIMEMode :: Int.Int16 -> Prelude.IO XlIMEMode
unmarshallXlIMEMode v =
  case v of
     0 -> Prelude.return (XlIMEModeNoControl)
     1 -> Prelude.return (XlIMEModeOn)
     2 -> Prelude.return (XlIMEModeOff)
     3 -> Prelude.return (XlIMEModeDisable)
     4 -> Prelude.return (XlIMEModeHiragana)
     5 -> Prelude.return (XlIMEModeKatakana)
     6 -> Prelude.return (XlIMEModeKatakanaHalf)
     7 -> Prelude.return (XlIMEModeAlphaFull)
     8 -> Prelude.return (XlIMEModeAlpha)
     9 -> Prelude.return (XlIMEModeHangulFull)
     10 -> Prelude.return (XlIMEModeHangul)
     _ -> Prelude.fail (Prelude.userError "unmarshallXlIMEMode: illegal enum value ")
data XlDVAlertStyle
 = XlValidAlertStop
 | XlValidAlertWarning
 | XlValidAlertInformation
 
marshallXlDVAlertStyle :: XlDVAlertStyle -> Prelude.IO Int.Int16
marshallXlDVAlertStyle v =
  case v of
     XlValidAlertStop -> Prelude.return (1)
     XlValidAlertWarning -> Prelude.return (2)
     XlValidAlertInformation -> Prelude.return (3)
unmarshallXlDVAlertStyle :: Int.Int16 -> Prelude.IO XlDVAlertStyle
unmarshallXlDVAlertStyle v =
  case v of
     1 -> Prelude.return (XlValidAlertStop)
     2 -> Prelude.return (XlValidAlertWarning)
     3 -> Prelude.return (XlValidAlertInformation)
     _ -> Prelude.fail (Prelude.userError "unmarshallXlDVAlertStyle: illegal enum value ")
data XlChartLocation
 = XlLocationAsNewSheet
 | XlLocationAsObject
 | XlLocationAutomatic
 
marshallXlChartLocation :: XlChartLocation -> Prelude.IO Int.Int16
marshallXlChartLocation v =
  case v of
     XlLocationAsNewSheet -> Prelude.return (1)
     XlLocationAsObject -> Prelude.return (2)
     XlLocationAutomatic -> Prelude.return (3)
unmarshallXlChartLocation :: Int.Int16 -> Prelude.IO XlChartLocation
unmarshallXlChartLocation v =
  case v of
     1 -> Prelude.return (XlLocationAsNewSheet)
     2 -> Prelude.return (XlLocationAsObject)
     3 -> Prelude.return (XlLocationAutomatic)
     _ -> Prelude.fail (Prelude.userError "unmarshallXlChartLocation: illegal enum value ")
data XlPaperSize
 = XlPaper10x14
 | XlPaper11x17
 | XlPaperA3
 | XlPaperA4
 | XlPaperA4Small
 | XlPaperA5
 | XlPaperB4
 | XlPaperB5
 | XlPaperCsheet
 | XlPaperDsheet
 | XlPaperEnvelope10
 | XlPaperEnvelope11
 | XlPaperEnvelope12
 | XlPaperEnvelope14
 | XlPaperEnvelope9
 | XlPaperEnvelopeB4
 | XlPaperEnvelopeB5
 | XlPaperEnvelopeB6
 | XlPaperEnvelopeC3
 | XlPaperEnvelopeC4
 | XlPaperEnvelopeC5
 | XlPaperEnvelopeC6
 | XlPaperEnvelopeC65
 | XlPaperEnvelopeDL
 | XlPaperEnvelopeItaly
 | XlPaperEnvelopeMonarch
 | XlPaperEnvelopePersonal
 | XlPaperEsheet
 | XlPaperExecutive
 | XlPaperFanfoldLegalGerman
 | XlPaperFanfoldStdGerman
 | XlPaperFanfoldUS
 | XlPaperFolio
 | XlPaperLedger
 | XlPaperLegal
 | XlPaperLetter
 | XlPaperLetterSmall
 | XlPaperNote
 | XlPaperQuarto
 | XlPaperStatement
 | XlPaperTabloid
 | XlPaperUser
 
marshallXlPaperSize :: XlPaperSize -> Prelude.IO Int.Int16
marshallXlPaperSize v =
  case v of
     XlPaper10x14 -> Prelude.return (16)
     XlPaper11x17 -> Prelude.return (17)
     XlPaperA3 -> Prelude.return (8)
     XlPaperA4 -> Prelude.return (9)
     XlPaperA4Small -> Prelude.return (10)
     XlPaperA5 -> Prelude.return (11)
     XlPaperB4 -> Prelude.return (12)
     XlPaperB5 -> Prelude.return (13)
     XlPaperCsheet -> Prelude.return (24)
     XlPaperDsheet -> Prelude.return (25)
     XlPaperEnvelope10 -> Prelude.return (20)
     XlPaperEnvelope11 -> Prelude.return (21)
     XlPaperEnvelope12 -> Prelude.return (22)
     XlPaperEnvelope14 -> Prelude.return (23)
     XlPaperEnvelope9 -> Prelude.return (19)
     XlPaperEnvelopeB4 -> Prelude.return (33)
     XlPaperEnvelopeB5 -> Prelude.return (34)
     XlPaperEnvelopeB6 -> Prelude.return (35)
     XlPaperEnvelopeC3 -> Prelude.return (29)
     XlPaperEnvelopeC4 -> Prelude.return (30)
     XlPaperEnvelopeC5 -> Prelude.return (28)
     XlPaperEnvelopeC6 -> Prelude.return (31)
     XlPaperEnvelopeC65 -> Prelude.return (32)
     XlPaperEnvelopeDL -> Prelude.return (27)
     XlPaperEnvelopeItaly -> Prelude.return (36)
     XlPaperEnvelopeMonarch -> Prelude.return (37)
     XlPaperEnvelopePersonal -> Prelude.return (38)
     XlPaperEsheet -> Prelude.return (26)
     XlPaperExecutive -> Prelude.return (7)
     XlPaperFanfoldLegalGerman -> Prelude.return (41)
     XlPaperFanfoldStdGerman -> Prelude.return (40)
     XlPaperFanfoldUS -> Prelude.return (39)
     XlPaperFolio -> Prelude.return (14)
     XlPaperLedger -> Prelude.return (4)
     XlPaperLegal -> Prelude.return (5)
     XlPaperLetter -> Prelude.return (1)
     XlPaperLetterSmall -> Prelude.return (2)
     XlPaperNote -> Prelude.return (18)
     XlPaperQuarto -> Prelude.return (15)
     XlPaperStatement -> Prelude.return (6)
     XlPaperTabloid -> Prelude.return (3)
     XlPaperUser -> Prelude.return (256)
unmarshallXlPaperSize :: Int.Int16 -> Prelude.IO XlPaperSize
unmarshallXlPaperSize v =
  case v of
     16 -> Prelude.return (XlPaper10x14)
     17 -> Prelude.return (XlPaper11x17)
     8 -> Prelude.return (XlPaperA3)
     9 -> Prelude.return (XlPaperA4)
     10 -> Prelude.return (XlPaperA4Small)
     11 -> Prelude.return (XlPaperA5)
     12 -> Prelude.return (XlPaperB4)
     13 -> Prelude.return (XlPaperB5)
     24 -> Prelude.return (XlPaperCsheet)
     25 -> Prelude.return (XlPaperDsheet)
     20 -> Prelude.return (XlPaperEnvelope10)
     21 -> Prelude.return (XlPaperEnvelope11)
     22 -> Prelude.return (XlPaperEnvelope12)
     23 -> Prelude.return (XlPaperEnvelope14)
     19 -> Prelude.return (XlPaperEnvelope9)
     33 -> Prelude.return (XlPaperEnvelopeB4)
     34 -> Prelude.return (XlPaperEnvelopeB5)
     35 -> Prelude.return (XlPaperEnvelopeB6)
     29 -> Prelude.return (XlPaperEnvelopeC3)
     30 -> Prelude.return (XlPaperEnvelopeC4)
     28 -> Prelude.return (XlPaperEnvelopeC5)
     31 -> Prelude.return (XlPaperEnvelopeC6)
     32 -> Prelude.return (XlPaperEnvelopeC65)
     27 -> Prelude.return (XlPaperEnvelopeDL)
     36 -> Prelude.return (XlPaperEnvelopeItaly)
     37 -> Prelude.return (XlPaperEnvelopeMonarch)
     38 -> Prelude.return (XlPaperEnvelopePersonal)
     26 -> Prelude.return (XlPaperEsheet)
     7 -> Prelude.return (XlPaperExecutive)
     41 -> Prelude.return (XlPaperFanfoldLegalGerman)
     40 -> Prelude.return (XlPaperFanfoldStdGerman)
     39 -> Prelude.return (XlPaperFanfoldUS)
     14 -> Prelude.return (XlPaperFolio)
     4 -> Prelude.return (XlPaperLedger)
     5 -> Prelude.return (XlPaperLegal)
     1 -> Prelude.return (XlPaperLetter)
     2 -> Prelude.return (XlPaperLetterSmall)
     18 -> Prelude.return (XlPaperNote)
     15 -> Prelude.return (XlPaperQuarto)
     6 -> Prelude.return (XlPaperStatement)
     3 -> Prelude.return (XlPaperTabloid)
     256 -> Prelude.return (XlPaperUser)
     _ -> Prelude.fail (Prelude.userError "unmarshallXlPaperSize: illegal enum value ")
data XlPasteSpecialOperation
 = XlPasteSpecialOperationAdd
 | XlPasteSpecialOperationDivide
 | XlPasteSpecialOperationMultiply
 | XlPasteSpecialOperationNone
 | XlPasteSpecialOperationSubtract
 
marshallXlPasteSpecialOperation :: XlPasteSpecialOperation -> Prelude.IO Int.Int16
marshallXlPasteSpecialOperation v =
  case v of
     XlPasteSpecialOperationAdd -> Prelude.return (2)
     XlPasteSpecialOperationDivide -> Prelude.return (5)
     XlPasteSpecialOperationMultiply -> Prelude.return (4)
     XlPasteSpecialOperationNone -> Prelude.return ((-4142))
     XlPasteSpecialOperationSubtract -> Prelude.return (3)
unmarshallXlPasteSpecialOperation :: Int.Int16 -> Prelude.IO XlPasteSpecialOperation
unmarshallXlPasteSpecialOperation v =
  case v of
     2 -> Prelude.return (XlPasteSpecialOperationAdd)
     5 -> Prelude.return (XlPasteSpecialOperationDivide)
     4 -> Prelude.return (XlPasteSpecialOperationMultiply)
     (-4142) -> Prelude.return (XlPasteSpecialOperationNone)
     3 -> Prelude.return (XlPasteSpecialOperationSubtract)
     _ -> Prelude.fail (Prelude.userError "unmarshallXlPasteSpecialOperation: illegal enum value ")
data XlPasteType
 = XlPasteAll
 | XlPasteAllExceptBorders
 | XlPasteFormats
 | XlPasteFormulas
 | XlPasteComments
 | XlPasteValues
 
marshallXlPasteType :: XlPasteType -> Prelude.IO Int.Int16
marshallXlPasteType v =
  case v of
     XlPasteAll -> Prelude.return ((-4104))
     XlPasteAllExceptBorders -> Prelude.return (6)
     XlPasteFormats -> Prelude.return ((-4122))
     XlPasteFormulas -> Prelude.return ((-4123))
     XlPasteComments -> Prelude.return ((-4144))
     XlPasteValues -> Prelude.return ((-4163))
unmarshallXlPasteType :: Int.Int16 -> Prelude.IO XlPasteType
unmarshallXlPasteType v =
  case v of
     (-4104) -> Prelude.return (XlPasteAll)
     6 -> Prelude.return (XlPasteAllExceptBorders)
     (-4122) -> Prelude.return (XlPasteFormats)
     (-4123) -> Prelude.return (XlPasteFormulas)
     (-4144) -> Prelude.return (XlPasteComments)
     (-4163) -> Prelude.return (XlPasteValues)
     _ -> Prelude.fail (Prelude.userError "unmarshallXlPasteType: illegal enum value ")
data XlPhoneticCharacterType
 = XlKatakanaHalf
 | XlKatakana
 | XlHiragana
 | XlNoConversion
 
marshallXlPhoneticCharacterType :: XlPhoneticCharacterType -> Prelude.IO Int.Int16
marshallXlPhoneticCharacterType v =
  case v of
     XlKatakanaHalf -> Prelude.return (0)
     XlKatakana -> Prelude.return (1)
     XlHiragana -> Prelude.return (2)
     XlNoConversion -> Prelude.return (3)
unmarshallXlPhoneticCharacterType :: Int.Int16 -> Prelude.IO XlPhoneticCharacterType
unmarshallXlPhoneticCharacterType v =
  case v of
     0 -> Prelude.return (XlKatakanaHalf)
     1 -> Prelude.return (XlKatakana)
     2 -> Prelude.return (XlHiragana)
     3 -> Prelude.return (XlNoConversion)
     _ -> Prelude.fail (Prelude.userError "unmarshallXlPhoneticCharacterType: illegal enum value ")
data XlPhoneticAlignment
 = XlPhoneticAlignNoControl
 | XlPhoneticAlignLeft
 | XlPhoneticAlignCenter
 | XlPhoneticAlignDistributed
 
marshallXlPhoneticAlignment :: XlPhoneticAlignment -> Prelude.IO Int.Int16
marshallXlPhoneticAlignment v =
  case v of
     XlPhoneticAlignNoControl -> Prelude.return (0)
     XlPhoneticAlignLeft -> Prelude.return (1)
     XlPhoneticAlignCenter -> Prelude.return (2)
     XlPhoneticAlignDistributed -> Prelude.return (3)
unmarshallXlPhoneticAlignment :: Int.Int16 -> Prelude.IO XlPhoneticAlignment
unmarshallXlPhoneticAlignment v =
  case v of
     0 -> Prelude.return (XlPhoneticAlignNoControl)
     1 -> Prelude.return (XlPhoneticAlignLeft)
     2 -> Prelude.return (XlPhoneticAlignCenter)
     3 -> Prelude.return (XlPhoneticAlignDistributed)
     _ -> Prelude.fail (Prelude.userError "unmarshallXlPhoneticAlignment: illegal enum value ")
data XlPictureAppearance
 = XlPrinter
 | XlScreen
 
marshallXlPictureAppearance :: XlPictureAppearance -> Prelude.IO Int.Int16
marshallXlPictureAppearance v =
  case v of
     XlPrinter -> Prelude.return (2)
     XlScreen -> Prelude.return (1)
unmarshallXlPictureAppearance :: Int.Int16 -> Prelude.IO XlPictureAppearance
unmarshallXlPictureAppearance v =
  case v of
     2 -> Prelude.return (XlPrinter)
     1 -> Prelude.return (XlScreen)
     _ -> Prelude.fail (Prelude.userError "unmarshallXlPictureAppearance: illegal enum value ")
data XlPivotFieldOrientation
 = XlColumnField
 | XlDataField
 | XlHidden
 | XlPageField
 | XlRowField
 
marshallXlPivotFieldOrientation :: XlPivotFieldOrientation -> Prelude.IO Int.Int16
marshallXlPivotFieldOrientation v =
  case v of
     XlColumnField -> Prelude.return (2)
     XlDataField -> Prelude.return (4)
     XlHidden -> Prelude.return (0)
     XlPageField -> Prelude.return (3)
     XlRowField -> Prelude.return (1)
unmarshallXlPivotFieldOrientation :: Int.Int16 -> Prelude.IO XlPivotFieldOrientation
unmarshallXlPivotFieldOrientation v =
  case v of
     2 -> Prelude.return (XlColumnField)
     4 -> Prelude.return (XlDataField)
     0 -> Prelude.return (XlHidden)
     3 -> Prelude.return (XlPageField)
     1 -> Prelude.return (XlRowField)
     _ -> Prelude.fail (Prelude.userError "unmarshallXlPivotFieldOrientation: illegal enum value ")
data XlPivotFieldCalculation
 = XlDifferenceFrom
 | XlIndex
 | XlNoAdditionalCalculation
 | XlPercentDifferenceFrom
 | XlPercentOf
 | XlPercentOfColumn
 | XlPercentOfRow
 | XlPercentOfTotal
 | XlRunningTotal
 
marshallXlPivotFieldCalculation :: XlPivotFieldCalculation -> Prelude.IO Int.Int16
marshallXlPivotFieldCalculation v =
  case v of
     XlDifferenceFrom -> Prelude.return (2)
     XlIndex -> Prelude.return (9)
     XlNoAdditionalCalculation -> Prelude.return ((-4143))
     XlPercentDifferenceFrom -> Prelude.return (4)
     XlPercentOf -> Prelude.return (3)
     XlPercentOfColumn -> Prelude.return (7)
     XlPercentOfRow -> Prelude.return (6)
     XlPercentOfTotal -> Prelude.return (8)
     XlRunningTotal -> Prelude.return (5)
unmarshallXlPivotFieldCalculation :: Int.Int16 -> Prelude.IO XlPivotFieldCalculation
unmarshallXlPivotFieldCalculation v =
  case v of
     2 -> Prelude.return (XlDifferenceFrom)
     9 -> Prelude.return (XlIndex)
     (-4143) -> Prelude.return (XlNoAdditionalCalculation)
     4 -> Prelude.return (XlPercentDifferenceFrom)
     3 -> Prelude.return (XlPercentOf)
     7 -> Prelude.return (XlPercentOfColumn)
     6 -> Prelude.return (XlPercentOfRow)
     8 -> Prelude.return (XlPercentOfTotal)
     5 -> Prelude.return (XlRunningTotal)
     _ -> Prelude.fail (Prelude.userError "unmarshallXlPivotFieldCalculation: illegal enum value ")
data XlPlacement
 = XlFreeFloating
 | XlMove
 | XlMoveAndSize
 
marshallXlPlacement :: XlPlacement -> Prelude.IO Int.Int16
marshallXlPlacement v =
  case v of
     XlFreeFloating -> Prelude.return (3)
     XlMove -> Prelude.return (2)
     XlMoveAndSize -> Prelude.return (1)
unmarshallXlPlacement :: Int.Int16 -> Prelude.IO XlPlacement
unmarshallXlPlacement v =
  case v of
     3 -> Prelude.return (XlFreeFloating)
     2 -> Prelude.return (XlMove)
     1 -> Prelude.return (XlMoveAndSize)
     _ -> Prelude.fail (Prelude.userError "unmarshallXlPlacement: illegal enum value ")
data XlPlatform
 = XlMacintosh
 | XlMSDOS
 | XlWindows
 
marshallXlPlatform :: XlPlatform -> Prelude.IO Int.Int16
marshallXlPlatform v =
  case v of
     XlMacintosh -> Prelude.return (1)
     XlMSDOS -> Prelude.return (3)
     XlWindows -> Prelude.return (2)
unmarshallXlPlatform :: Int.Int16 -> Prelude.IO XlPlatform
unmarshallXlPlatform v =
  case v of
     1 -> Prelude.return (XlMacintosh)
     3 -> Prelude.return (XlMSDOS)
     2 -> Prelude.return (XlWindows)
     _ -> Prelude.fail (Prelude.userError "unmarshallXlPlatform: illegal enum value ")
data XlPrintLocation
 = XlPrintSheetEnd
 | XlPrintInPlace
 | XlPrintNoComments
 
marshallXlPrintLocation :: XlPrintLocation -> Prelude.IO Int.Int16
marshallXlPrintLocation v =
  case v of
     XlPrintSheetEnd -> Prelude.return (1)
     XlPrintInPlace -> Prelude.return (16)
     XlPrintNoComments -> Prelude.return ((-4142))
unmarshallXlPrintLocation :: Int.Int16 -> Prelude.IO XlPrintLocation
unmarshallXlPrintLocation v =
  case v of
     1 -> Prelude.return (XlPrintSheetEnd)
     16 -> Prelude.return (XlPrintInPlace)
     (-4142) -> Prelude.return (XlPrintNoComments)
     _ -> Prelude.fail (Prelude.userError "unmarshallXlPrintLocation: illegal enum value ")
data XlPriority
 = XlPriorityHigh
 | XlPriorityLow
 | XlPriorityNormal
 
marshallXlPriority :: XlPriority -> Prelude.IO Int.Int16
marshallXlPriority v =
  case v of
     XlPriorityHigh -> Prelude.return ((-4127))
     XlPriorityLow -> Prelude.return ((-4134))
     XlPriorityNormal -> Prelude.return ((-4143))
unmarshallXlPriority :: Int.Int16 -> Prelude.IO XlPriority
unmarshallXlPriority v =
  case v of
     (-4127) -> Prelude.return (XlPriorityHigh)
     (-4134) -> Prelude.return (XlPriorityLow)
     (-4143) -> Prelude.return (XlPriorityNormal)
     _ -> Prelude.fail (Prelude.userError "unmarshallXlPriority: illegal enum value ")
data XlPTSelectionMode
 = XlLabelOnly
 | XlDataAndLabel
 | XlDataOnly
 | XlOrigin
 | XlButton
 | XlBlanks
 
marshallXlPTSelectionMode :: XlPTSelectionMode -> Prelude.IO Int.Int16
marshallXlPTSelectionMode v =
  case v of
     XlLabelOnly -> Prelude.return (1)
     XlDataAndLabel -> Prelude.return (0)
     XlDataOnly -> Prelude.return (2)
     XlOrigin -> Prelude.return (3)
     XlButton -> Prelude.return (15)
     XlBlanks -> Prelude.return (4)
unmarshallXlPTSelectionMode :: Int.Int16 -> Prelude.IO XlPTSelectionMode
unmarshallXlPTSelectionMode v =
  case v of
     1 -> Prelude.return (XlLabelOnly)
     0 -> Prelude.return (XlDataAndLabel)
     2 -> Prelude.return (XlDataOnly)
     3 -> Prelude.return (XlOrigin)
     15 -> Prelude.return (XlButton)
     4 -> Prelude.return (XlBlanks)
     _ -> Prelude.fail (Prelude.userError "unmarshallXlPTSelectionMode: illegal enum value ")
data XlRangeAutoFormat
 = XlRangeAutoFormat3DEffects1
 | XlRangeAutoFormat3DEffects2
 | XlRangeAutoFormatAccounting1
 | XlRangeAutoFormatAccounting2
 | XlRangeAutoFormatAccounting3
 | XlRangeAutoFormatAccounting4
 | XlRangeAutoFormatClassic1
 | XlRangeAutoFormatClassic2
 | XlRangeAutoFormatClassic3
 | XlRangeAutoFormatColor1
 | XlRangeAutoFormatColor2
 | XlRangeAutoFormatColor3
 | XlRangeAutoFormatList1
 | XlRangeAutoFormatList2
 | XlRangeAutoFormatList3
 | XlRangeAutoFormatLocalFormat1
 | XlRangeAutoFormatLocalFormat2
 | XlRangeAutoFormatLocalFormat3
 | XlRangeAutoFormatLocalFormat4
 | XlRangeAutoFormatNone
 | XlRangeAutoFormatSimple
 
marshallXlRangeAutoFormat :: XlRangeAutoFormat -> Prelude.IO Int.Int16
marshallXlRangeAutoFormat v =
  case v of
     XlRangeAutoFormat3DEffects1 -> Prelude.return (13)
     XlRangeAutoFormat3DEffects2 -> Prelude.return (14)
     XlRangeAutoFormatAccounting1 -> Prelude.return (4)
     XlRangeAutoFormatAccounting2 -> Prelude.return (5)
     XlRangeAutoFormatAccounting3 -> Prelude.return (6)
     XlRangeAutoFormatAccounting4 -> Prelude.return (17)
     XlRangeAutoFormatClassic1 -> Prelude.return (1)
     XlRangeAutoFormatClassic2 -> Prelude.return (2)
     XlRangeAutoFormatClassic3 -> Prelude.return (3)
     XlRangeAutoFormatColor1 -> Prelude.return (7)
     XlRangeAutoFormatColor2 -> Prelude.return (8)
     XlRangeAutoFormatColor3 -> Prelude.return (9)
     XlRangeAutoFormatList1 -> Prelude.return (10)
     XlRangeAutoFormatList2 -> Prelude.return (11)
     XlRangeAutoFormatList3 -> Prelude.return (12)
     XlRangeAutoFormatLocalFormat1 -> Prelude.return (15)
     XlRangeAutoFormatLocalFormat2 -> Prelude.return (16)
     XlRangeAutoFormatLocalFormat3 -> Prelude.return (19)
     XlRangeAutoFormatLocalFormat4 -> Prelude.return (20)
     XlRangeAutoFormatNone -> Prelude.return ((-4142))
     XlRangeAutoFormatSimple -> Prelude.return ((-4154))
unmarshallXlRangeAutoFormat :: Int.Int16 -> Prelude.IO XlRangeAutoFormat
unmarshallXlRangeAutoFormat v =
  case v of
     13 -> Prelude.return (XlRangeAutoFormat3DEffects1)
     14 -> Prelude.return (XlRangeAutoFormat3DEffects2)
     4 -> Prelude.return (XlRangeAutoFormatAccounting1)
     5 -> Prelude.return (XlRangeAutoFormatAccounting2)
     6 -> Prelude.return (XlRangeAutoFormatAccounting3)
     17 -> Prelude.return (XlRangeAutoFormatAccounting4)
     1 -> Prelude.return (XlRangeAutoFormatClassic1)
     2 -> Prelude.return (XlRangeAutoFormatClassic2)
     3 -> Prelude.return (XlRangeAutoFormatClassic3)
     7 -> Prelude.return (XlRangeAutoFormatColor1)
     8 -> Prelude.return (XlRangeAutoFormatColor2)
     9 -> Prelude.return (XlRangeAutoFormatColor3)
     10 -> Prelude.return (XlRangeAutoFormatList1)
     11 -> Prelude.return (XlRangeAutoFormatList2)
     12 -> Prelude.return (XlRangeAutoFormatList3)
     15 -> Prelude.return (XlRangeAutoFormatLocalFormat1)
     16 -> Prelude.return (XlRangeAutoFormatLocalFormat2)
     19 -> Prelude.return (XlRangeAutoFormatLocalFormat3)
     20 -> Prelude.return (XlRangeAutoFormatLocalFormat4)
     (-4142) -> Prelude.return (XlRangeAutoFormatNone)
     (-4154) -> Prelude.return (XlRangeAutoFormatSimple)
     _ -> Prelude.fail (Prelude.userError "unmarshallXlRangeAutoFormat: illegal enum value ")
data XlReferenceType
 = XlAbsolute
 | XlAbsRowRelColumn
 | XlRelative
 | XlRelRowAbsColumn
 
marshallXlReferenceType :: XlReferenceType -> Prelude.IO Int.Int16
marshallXlReferenceType v =
  case v of
     XlAbsolute -> Prelude.return (1)
     XlAbsRowRelColumn -> Prelude.return (2)
     XlRelative -> Prelude.return (4)
     XlRelRowAbsColumn -> Prelude.return (3)
unmarshallXlReferenceType :: Int.Int16 -> Prelude.IO XlReferenceType
unmarshallXlReferenceType v =
  case v of
     1 -> Prelude.return (XlAbsolute)
     2 -> Prelude.return (XlAbsRowRelColumn)
     4 -> Prelude.return (XlRelative)
     3 -> Prelude.return (XlRelRowAbsColumn)
     _ -> Prelude.fail (Prelude.userError "unmarshallXlReferenceType: illegal enum value ")
data XlRoutingSlipDelivery
 = XlAllAtOnce
 | XlOneAfterAnother
 
marshallXlRoutingSlipDelivery :: XlRoutingSlipDelivery -> Prelude.IO Int.Int16
marshallXlRoutingSlipDelivery v =
  case v of
     XlAllAtOnce -> Prelude.return (2)
     XlOneAfterAnother -> Prelude.return (1)
unmarshallXlRoutingSlipDelivery :: Int.Int16 -> Prelude.IO XlRoutingSlipDelivery
unmarshallXlRoutingSlipDelivery v =
  case v of
     2 -> Prelude.return (XlAllAtOnce)
     1 -> Prelude.return (XlOneAfterAnother)
     _ -> Prelude.fail (Prelude.userError "unmarshallXlRoutingSlipDelivery: illegal enum value ")
data XlRoutingSlipStatus
 = XlNotYetRouted
 | XlRoutingComplete
 | XlRoutingInProgress
 
marshallXlRoutingSlipStatus :: XlRoutingSlipStatus -> Prelude.IO Int.Int16
marshallXlRoutingSlipStatus v =
  case v of
     XlNotYetRouted -> Prelude.return (0)
     XlRoutingComplete -> Prelude.return (2)
     XlRoutingInProgress -> Prelude.return (1)
unmarshallXlRoutingSlipStatus :: Int.Int16 -> Prelude.IO XlRoutingSlipStatus
unmarshallXlRoutingSlipStatus v =
  case v of
     0 -> Prelude.return (XlNotYetRouted)
     2 -> Prelude.return (XlRoutingComplete)
     1 -> Prelude.return (XlRoutingInProgress)
     _ -> Prelude.fail (Prelude.userError "unmarshallXlRoutingSlipStatus: illegal enum value ")
data XlRunAutoMacro
 = XlAutoActivate
 | XlAutoClose
 | XlAutoDeactivate
 | XlAutoOpen
 
marshallXlRunAutoMacro :: XlRunAutoMacro -> Prelude.IO Int.Int16
marshallXlRunAutoMacro v =
  case v of
     XlAutoActivate -> Prelude.return (3)
     XlAutoClose -> Prelude.return (2)
     XlAutoDeactivate -> Prelude.return (4)
     XlAutoOpen -> Prelude.return (1)
unmarshallXlRunAutoMacro :: Int.Int16 -> Prelude.IO XlRunAutoMacro
unmarshallXlRunAutoMacro v =
  case v of
     3 -> Prelude.return (XlAutoActivate)
     2 -> Prelude.return (XlAutoClose)
     4 -> Prelude.return (XlAutoDeactivate)
     1 -> Prelude.return (XlAutoOpen)
     _ -> Prelude.fail (Prelude.userError "unmarshallXlRunAutoMacro: illegal enum value ")
data XlSaveAction
 = XlDoNotSaveChanges
 | XlSaveChanges
 
marshallXlSaveAction :: XlSaveAction -> Prelude.IO Int.Int16
marshallXlSaveAction v =
  case v of
     XlDoNotSaveChanges -> Prelude.return (2)
     XlSaveChanges -> Prelude.return (1)
unmarshallXlSaveAction :: Int.Int16 -> Prelude.IO XlSaveAction
unmarshallXlSaveAction v =
  case v of
     2 -> Prelude.return (XlDoNotSaveChanges)
     1 -> Prelude.return (XlSaveChanges)
     _ -> Prelude.fail (Prelude.userError "unmarshallXlSaveAction: illegal enum value ")
data XlSaveAsAccessMode
 = XlExclusive
 | XlNoChange
 | XlShared
 
marshallXlSaveAsAccessMode :: XlSaveAsAccessMode -> Prelude.IO Int.Int16
marshallXlSaveAsAccessMode v =
  case v of
     XlExclusive -> Prelude.return (3)
     XlNoChange -> Prelude.return (1)
     XlShared -> Prelude.return (2)
unmarshallXlSaveAsAccessMode :: Int.Int16 -> Prelude.IO XlSaveAsAccessMode
unmarshallXlSaveAsAccessMode v =
  case v of
     3 -> Prelude.return (XlExclusive)
     1 -> Prelude.return (XlNoChange)
     2 -> Prelude.return (XlShared)
     _ -> Prelude.fail (Prelude.userError "unmarshallXlSaveAsAccessMode: illegal enum value ")
data XlSaveConflictResolution
 = XlLocalSessionChanges
 | XlOtherSessionChanges
 | XlUserResolution
 
marshallXlSaveConflictResolution :: XlSaveConflictResolution -> Prelude.IO Int.Int16
marshallXlSaveConflictResolution v =
  case v of
     XlLocalSessionChanges -> Prelude.return (2)
     XlOtherSessionChanges -> Prelude.return (3)
     XlUserResolution -> Prelude.return (1)
unmarshallXlSaveConflictResolution :: Int.Int16 -> Prelude.IO XlSaveConflictResolution
unmarshallXlSaveConflictResolution v =
  case v of
     2 -> Prelude.return (XlLocalSessionChanges)
     3 -> Prelude.return (XlOtherSessionChanges)
     1 -> Prelude.return (XlUserResolution)
     _ -> Prelude.fail (Prelude.userError "unmarshallXlSaveConflictResolution: illegal enum value ")
data XlSearchDirection
 = XlNext
 | XlPrevious
 
marshallXlSearchDirection :: XlSearchDirection -> Prelude.IO Int.Int16
marshallXlSearchDirection v =
  case v of
     XlNext -> Prelude.return (1)
     XlPrevious -> Prelude.return (2)
unmarshallXlSearchDirection :: Int.Int16 -> Prelude.IO XlSearchDirection
unmarshallXlSearchDirection v =
  case v of
     1 -> Prelude.return (XlNext)
     2 -> Prelude.return (XlPrevious)
     _ -> Prelude.fail (Prelude.userError "unmarshallXlSearchDirection: illegal enum value ")
data XlSearchOrder
 = XlByColumns
 | XlByRows
 
marshallXlSearchOrder :: XlSearchOrder -> Prelude.IO Int.Int16
marshallXlSearchOrder v =
  case v of
     XlByColumns -> Prelude.return (2)
     XlByRows -> Prelude.return (1)
unmarshallXlSearchOrder :: Int.Int16 -> Prelude.IO XlSearchOrder
unmarshallXlSearchOrder v =
  case v of
     2 -> Prelude.return (XlByColumns)
     1 -> Prelude.return (XlByRows)
     _ -> Prelude.fail (Prelude.userError "unmarshallXlSearchOrder: illegal enum value ")
data XlSheetVisibility
 = XlSheetVisible
 | XlSheetHidden
 | XlSheetVeryHidden
 
marshallXlSheetVisibility :: XlSheetVisibility -> Prelude.IO Int.Int16
marshallXlSheetVisibility v =
  case v of
     XlSheetVisible -> Prelude.return ((-1))
     XlSheetHidden -> Prelude.return (0)
     XlSheetVeryHidden -> Prelude.return (2)
unmarshallXlSheetVisibility :: Int.Int16 -> Prelude.IO XlSheetVisibility
unmarshallXlSheetVisibility v =
  case v of
     (-1) -> Prelude.return (XlSheetVisible)
     0 -> Prelude.return (XlSheetHidden)
     2 -> Prelude.return (XlSheetVeryHidden)
     _ -> Prelude.fail (Prelude.userError "unmarshallXlSheetVisibility: illegal enum value ")
data XlSortMethod
 = XlPinYin
 | XlStroke
 
marshallXlSortMethod :: XlSortMethod -> Prelude.IO Int.Int16
marshallXlSortMethod v =
  case v of
     XlPinYin -> Prelude.return (1)
     XlStroke -> Prelude.return (2)
unmarshallXlSortMethod :: Int.Int16 -> Prelude.IO XlSortMethod
unmarshallXlSortMethod v =
  case v of
     1 -> Prelude.return (XlPinYin)
     2 -> Prelude.return (XlStroke)
     _ -> Prelude.fail (Prelude.userError "unmarshallXlSortMethod: illegal enum value ")
data XlSortMethodOld
 = XlCodePage
 | XlSyllabary
 
marshallXlSortMethodOld :: XlSortMethodOld -> Prelude.IO Int.Int16
marshallXlSortMethodOld v =
  case v of
     XlCodePage -> Prelude.return (2)
     XlSyllabary -> Prelude.return (1)
unmarshallXlSortMethodOld :: Int.Int16 -> Prelude.IO XlSortMethodOld
unmarshallXlSortMethodOld v =
  case v of
     2 -> Prelude.return (XlCodePage)
     1 -> Prelude.return (XlSyllabary)
     _ -> Prelude.fail (Prelude.userError "unmarshallXlSortMethodOld: illegal enum value ")
data XlSortOrder
 = XlAscending
 | XlDescending
 
marshallXlSortOrder :: XlSortOrder -> Prelude.IO Int.Int16
marshallXlSortOrder v =
  case v of
     XlAscending -> Prelude.return (1)
     XlDescending -> Prelude.return (2)
unmarshallXlSortOrder :: Int.Int16 -> Prelude.IO XlSortOrder
unmarshallXlSortOrder v =
  case v of
     1 -> Prelude.return (XlAscending)
     2 -> Prelude.return (XlDescending)
     _ -> Prelude.fail (Prelude.userError "unmarshallXlSortOrder: illegal enum value ")
data XlSortOrientation
 = XlSortRows
 | XlSortColumns
 
marshallXlSortOrientation :: XlSortOrientation -> Prelude.IO Int.Int16
marshallXlSortOrientation v =
  case v of
     XlSortRows -> Prelude.return (2)
     XlSortColumns -> Prelude.return (1)
unmarshallXlSortOrientation :: Int.Int16 -> Prelude.IO XlSortOrientation
unmarshallXlSortOrientation v =
  case v of
     2 -> Prelude.return (XlSortRows)
     1 -> Prelude.return (XlSortColumns)
     _ -> Prelude.fail (Prelude.userError "unmarshallXlSortOrientation: illegal enum value ")
data XlSortType
 = XlSortLabels
 | XlSortValues
 
marshallXlSortType :: XlSortType -> Prelude.IO Int.Int16
marshallXlSortType v =
  case v of
     XlSortLabels -> Prelude.return (2)
     XlSortValues -> Prelude.return (1)
unmarshallXlSortType :: Int.Int16 -> Prelude.IO XlSortType
unmarshallXlSortType v =
  case v of
     2 -> Prelude.return (XlSortLabels)
     1 -> Prelude.return (XlSortValues)
     _ -> Prelude.fail (Prelude.userError "unmarshallXlSortType: illegal enum value ")
data XlSpecialCellsValue
 = XlErrors
 | XlLogical
 | XlNumbers
 | XlTextValues
 
marshallXlSpecialCellsValue :: XlSpecialCellsValue -> Prelude.IO Int.Int16
marshallXlSpecialCellsValue v =
  case v of
     XlErrors -> Prelude.return (16)
     XlLogical -> Prelude.return (4)
     XlNumbers -> Prelude.return (1)
     XlTextValues -> Prelude.return (2)
unmarshallXlSpecialCellsValue :: Int.Int16 -> Prelude.IO XlSpecialCellsValue
unmarshallXlSpecialCellsValue v =
  case v of
     16 -> Prelude.return (XlErrors)
     4 -> Prelude.return (XlLogical)
     1 -> Prelude.return (XlNumbers)
     2 -> Prelude.return (XlTextValues)
     _ -> Prelude.fail (Prelude.userError "unmarshallXlSpecialCellsValue: illegal enum value ")
data XlSubscribeToFormat
 = XlSubscribeToPicture
 | XlSubscribeToText
 
marshallXlSubscribeToFormat :: XlSubscribeToFormat -> Prelude.IO Int.Int16
marshallXlSubscribeToFormat v =
  case v of
     XlSubscribeToPicture -> Prelude.return ((-4147))
     XlSubscribeToText -> Prelude.return ((-4158))
unmarshallXlSubscribeToFormat :: Int.Int16 -> Prelude.IO XlSubscribeToFormat
unmarshallXlSubscribeToFormat v =
  case v of
     (-4147) -> Prelude.return (XlSubscribeToPicture)
     (-4158) -> Prelude.return (XlSubscribeToText)
     _ -> Prelude.fail (Prelude.userError "unmarshallXlSubscribeToFormat: illegal enum value ")
data XlSummaryRow
 = XlSummaryAbove
 | XlSummaryBelow
 
marshallXlSummaryRow :: XlSummaryRow -> Prelude.IO Int.Int16
marshallXlSummaryRow v =
  case v of
     XlSummaryAbove -> Prelude.return (0)
     XlSummaryBelow -> Prelude.return (1)
unmarshallXlSummaryRow :: Int.Int16 -> Prelude.IO XlSummaryRow
unmarshallXlSummaryRow v =
  case v of
     0 -> Prelude.return (XlSummaryAbove)
     1 -> Prelude.return (XlSummaryBelow)
     _ -> Prelude.fail (Prelude.userError "unmarshallXlSummaryRow: illegal enum value ")
data XlSummaryColumn
 = XlSummaryOnLeft
 | XlSummaryOnRight
 
marshallXlSummaryColumn :: XlSummaryColumn -> Prelude.IO Int.Int16
marshallXlSummaryColumn v =
  case v of
     XlSummaryOnLeft -> Prelude.return ((-4131))
     XlSummaryOnRight -> Prelude.return ((-4152))
unmarshallXlSummaryColumn :: Int.Int16 -> Prelude.IO XlSummaryColumn
unmarshallXlSummaryColumn v =
  case v of
     (-4131) -> Prelude.return (XlSummaryOnLeft)
     (-4152) -> Prelude.return (XlSummaryOnRight)
     _ -> Prelude.fail (Prelude.userError "unmarshallXlSummaryColumn: illegal enum value ")
data XlSummaryReportType
 = XlSummaryPivotTable
 | XlStandardSummary
 
marshallXlSummaryReportType :: XlSummaryReportType -> Prelude.IO Int.Int16
marshallXlSummaryReportType v =
  case v of
     XlSummaryPivotTable -> Prelude.return ((-4148))
     XlStandardSummary -> Prelude.return (1)
unmarshallXlSummaryReportType :: Int.Int16 -> Prelude.IO XlSummaryReportType
unmarshallXlSummaryReportType v =
  case v of
     (-4148) -> Prelude.return (XlSummaryPivotTable)
     1 -> Prelude.return (XlStandardSummary)
     _ -> Prelude.fail (Prelude.userError "unmarshallXlSummaryReportType: illegal enum value ")
data XlTabPosition
 = XlTabPositionFirst
 | XlTabPositionLast
 
marshallXlTabPosition :: XlTabPosition -> Prelude.IO Int.Int16
marshallXlTabPosition v =
  case v of
     XlTabPositionFirst -> Prelude.return (0)
     XlTabPositionLast -> Prelude.return (1)
unmarshallXlTabPosition :: Int.Int16 -> Prelude.IO XlTabPosition
unmarshallXlTabPosition v =
  case v of
     0 -> Prelude.return (XlTabPositionFirst)
     1 -> Prelude.return (XlTabPositionLast)
     _ -> Prelude.fail (Prelude.userError "unmarshallXlTabPosition: illegal enum value ")
data XlTextParsingType
 = XlDelimited
 | XlFixedWidth
 
marshallXlTextParsingType :: XlTextParsingType -> Prelude.IO Int.Int16
marshallXlTextParsingType v =
  case v of
     XlDelimited -> Prelude.return (1)
     XlFixedWidth -> Prelude.return (2)
unmarshallXlTextParsingType :: Int.Int16 -> Prelude.IO XlTextParsingType
unmarshallXlTextParsingType v =
  case v of
     1 -> Prelude.return (XlDelimited)
     2 -> Prelude.return (XlFixedWidth)
     _ -> Prelude.fail (Prelude.userError "unmarshallXlTextParsingType: illegal enum value ")
data XlTextQualifier
 = XlTextQualifierDoubleQuote
 | XlTextQualifierNone
 | XlTextQualifierSingleQuote
 
marshallXlTextQualifier :: XlTextQualifier -> Prelude.IO Int.Int16
marshallXlTextQualifier v =
  case v of
     XlTextQualifierDoubleQuote -> Prelude.return (1)
     XlTextQualifierNone -> Prelude.return ((-4142))
     XlTextQualifierSingleQuote -> Prelude.return (2)
unmarshallXlTextQualifier :: Int.Int16 -> Prelude.IO XlTextQualifier
unmarshallXlTextQualifier v =
  case v of
     1 -> Prelude.return (XlTextQualifierDoubleQuote)
     (-4142) -> Prelude.return (XlTextQualifierNone)
     2 -> Prelude.return (XlTextQualifierSingleQuote)
     _ -> Prelude.fail (Prelude.userError "unmarshallXlTextQualifier: illegal enum value ")
data XlWBATemplate
 = XlWBATChart
 | XlWBATExcel4IntlMacroSheet
 | XlWBATExcel4MacroSheet
 | XlWBATWorksheet
 
marshallXlWBATemplate :: XlWBATemplate -> Prelude.IO Int.Int16
marshallXlWBATemplate v =
  case v of
     XlWBATChart -> Prelude.return ((-4109))
     XlWBATExcel4IntlMacroSheet -> Prelude.return (4)
     XlWBATExcel4MacroSheet -> Prelude.return (3)
     XlWBATWorksheet -> Prelude.return ((-4167))
unmarshallXlWBATemplate :: Int.Int16 -> Prelude.IO XlWBATemplate
unmarshallXlWBATemplate v =
  case v of
     (-4109) -> Prelude.return (XlWBATChart)
     4 -> Prelude.return (XlWBATExcel4IntlMacroSheet)
     3 -> Prelude.return (XlWBATExcel4MacroSheet)
     (-4167) -> Prelude.return (XlWBATWorksheet)
     _ -> Prelude.fail (Prelude.userError "unmarshallXlWBATemplate: illegal enum value ")
data XlWindowView
 = XlNormalView
 | XlPageBreakPreview
 
marshallXlWindowView :: XlWindowView -> Prelude.IO Int.Int16
marshallXlWindowView v =
  case v of
     XlNormalView -> Prelude.return (1)
     XlPageBreakPreview -> Prelude.return (2)
unmarshallXlWindowView :: Int.Int16 -> Prelude.IO XlWindowView
unmarshallXlWindowView v =
  case v of
     1 -> Prelude.return (XlNormalView)
     2 -> Prelude.return (XlPageBreakPreview)
     _ -> Prelude.fail (Prelude.userError "unmarshallXlWindowView: illegal enum value ")
data XlXLMMacroType
 = XlCommand
 | XlFunction
 | XlNotXLM
 
marshallXlXLMMacroType :: XlXLMMacroType -> Prelude.IO Int.Int16
marshallXlXLMMacroType v =
  case v of
     XlCommand -> Prelude.return (2)
     XlFunction -> Prelude.return (1)
     XlNotXLM -> Prelude.return (3)
unmarshallXlXLMMacroType :: Int.Int16 -> Prelude.IO XlXLMMacroType
unmarshallXlXLMMacroType v =
  case v of
     2 -> Prelude.return (XlCommand)
     1 -> Prelude.return (XlFunction)
     3 -> Prelude.return (XlNotXLM)
     _ -> Prelude.fail (Prelude.userError "unmarshallXlXLMMacroType: illegal enum value ")
data XlYesNoGuess
 = XlGuess
 | XlNo
 | XlYes
 
marshallXlYesNoGuess :: XlYesNoGuess -> Prelude.IO Int.Int16
marshallXlYesNoGuess v =
  case v of
     XlGuess -> Prelude.return (0)
     XlNo -> Prelude.return (2)
     XlYes -> Prelude.return (1)
unmarshallXlYesNoGuess :: Int.Int16 -> Prelude.IO XlYesNoGuess
unmarshallXlYesNoGuess v =
  case v of
     0 -> Prelude.return (XlGuess)
     2 -> Prelude.return (XlNo)
     1 -> Prelude.return (XlYes)
     _ -> Prelude.fail (Prelude.userError "unmarshallXlYesNoGuess: illegal enum value ")
data XlDisplayShapes
 = XlDisplayShapes
 | XlHide
 | XlPlaceholders
 
marshallXlDisplayShapes :: XlDisplayShapes -> Prelude.IO Int.Int16
marshallXlDisplayShapes v =
  case v of
     XlDisplayShapes -> Prelude.return ((-4104))
     XlHide -> Prelude.return (3)
     XlPlaceholders -> Prelude.return (2)
unmarshallXlDisplayShapes :: Int.Int16 -> Prelude.IO XlDisplayShapes
unmarshallXlDisplayShapes v =
  case v of
     (-4104) -> Prelude.return (XlDisplayShapes)
     3 -> Prelude.return (XlHide)
     2 -> Prelude.return (XlPlaceholders)
     _ -> Prelude.fail (Prelude.userError "unmarshallXlDisplayShapes: illegal enum value ")
data XlBordersIndex
 = XlInsideHorizontal
 | XlInsideVertical
 | XlDiagonalDown
 | XlDiagonalUp
 | XlEdgeBottom
 | XlEdgeLeft
 | XlEdgeRight
 | XlEdgeTop
 
marshallXlBordersIndex :: XlBordersIndex -> Prelude.IO Int.Int16
marshallXlBordersIndex v =
  case v of
     XlInsideHorizontal -> Prelude.return (12)
     XlInsideVertical -> Prelude.return (11)
     XlDiagonalDown -> Prelude.return (5)
     XlDiagonalUp -> Prelude.return (6)
     XlEdgeBottom -> Prelude.return (9)
     XlEdgeLeft -> Prelude.return (7)
     XlEdgeRight -> Prelude.return (10)
     XlEdgeTop -> Prelude.return (8)
unmarshallXlBordersIndex :: Int.Int16 -> Prelude.IO XlBordersIndex
unmarshallXlBordersIndex v =
  case v of
     12 -> Prelude.return (XlInsideHorizontal)
     11 -> Prelude.return (XlInsideVertical)
     5 -> Prelude.return (XlDiagonalDown)
     6 -> Prelude.return (XlDiagonalUp)
     9 -> Prelude.return (XlEdgeBottom)
     7 -> Prelude.return (XlEdgeLeft)
     10 -> Prelude.return (XlEdgeRight)
     8 -> Prelude.return (XlEdgeTop)
     _ -> Prelude.fail (Prelude.userError "unmarshallXlBordersIndex: illegal enum value ")
data XlToolbarProtection
 = XlNoButtonChanges
 | XlNoChanges
 | XlNoDockingChanges
 | XlToolbarProtectionNone
 | XlNoShapeChanges
 
marshallXlToolbarProtection :: XlToolbarProtection -> Prelude.IO Int.Int16
marshallXlToolbarProtection v =
  case v of
     XlNoButtonChanges -> Prelude.return (1)
     XlNoChanges -> Prelude.return (4)
     XlNoDockingChanges -> Prelude.return (3)
     XlToolbarProtectionNone -> Prelude.return ((-4143))
     XlNoShapeChanges -> Prelude.return (2)
unmarshallXlToolbarProtection :: Int.Int16 -> Prelude.IO XlToolbarProtection
unmarshallXlToolbarProtection v =
  case v of
     1 -> Prelude.return (XlNoButtonChanges)
     4 -> Prelude.return (XlNoChanges)
     3 -> Prelude.return (XlNoDockingChanges)
     (-4143) -> Prelude.return (XlToolbarProtectionNone)
     2 -> Prelude.return (XlNoShapeChanges)
     _ -> Prelude.fail (Prelude.userError "unmarshallXlToolbarProtection: illegal enum value ")
data XlBuiltInDialog
 = XlDialogOpen
 | XlDialogOpenLinks
 | XlDialogSaveAs
 | XlDialogFileDelete
 | XlDialogPageSetup
 | XlDialogPrint
 | XlDialogPrinterSetup
 | XlDialogArrangeAll
 | XlDialogWindowSize
 | XlDialogWindowMove
 | XlDialogRun
 | XlDialogSetPrintTitles
 | XlDialogFont
 | XlDialogDisplay
 | XlDialogProtectDocument
 | XlDialogCalculation
 | XlDialogExtract
 | XlDialogDataDelete
 | XlDialogSort
 | XlDialogDataSeries
 | XlDialogTable
 | XlDialogFormatNumber
 | XlDialogAlignment
 | XlDialogStyle
 | XlDialogBorder
 | XlDialogCellProtection
 | XlDialogColumnWidth
 | XlDialogClear
 | XlDialogPasteSpecial
 | XlDialogEditDelete
 | XlDialogInsert
 | XlDialogPasteNames
 | XlDialogDefineName
 | XlDialogCreateNames
 | XlDialogFormulaGoto
 | XlDialogFormulaFind
 | XlDialogGalleryArea
 | XlDialogGalleryBar
 | XlDialogGalleryColumn
 | XlDialogGalleryLine
 | XlDialogGalleryPie
 | XlDialogGalleryScatter
 | XlDialogCombination
 | XlDialogGridlines
 | XlDialogAxes
 | XlDialogAttachText
 | XlDialogPatterns
 | XlDialogMainChart
 | XlDialogOverlay
 | XlDialogScale
 | XlDialogFormatLegend
 | XlDialogFormatText
 | XlDialogParse
 | XlDialogUnhide
 | XlDialogWorkspace
 | XlDialogActivate
 | XlDialogCopyPicture
 | XlDialogDeleteName
 | XlDialogDeleteFormat
 | XlDialogNew
 | XlDialogRowHeight
 | XlDialogFormatMove
 | XlDialogFormatSize
 | XlDialogFormulaReplace
 | XlDialogSelectSpecial
 | XlDialogApplyNames
 | XlDialogReplaceFont
 | XlDialogSplit
 | XlDialogOutline
 | XlDialogSaveWorkbook
 | XlDialogCopyChart
 | XlDialogFormatFont
 | XlDialogNote
 | XlDialogSetUpdateStatus
 | XlDialogColorPalette
 | XlDialogChangeLink
 | XlDialogAppMove
 | XlDialogAppSize
 | XlDialogMainChartType
 | XlDialogOverlayChartType
 | XlDialogOpenMail
 | XlDialogSendMail
 | XlDialogStandardFont
 | XlDialogConsolidate
 | XlDialogSortSpecial
 | XlDialogGallery3dArea
 | XlDialogGallery3dColumn
 | XlDialogGallery3dLine
 | XlDialogGallery3dPie
 | XlDialogView3d
 | XlDialogGoalSeek
 | XlDialogWorkgroup
 | XlDialogFillGroup
 | XlDialogUpdateLink
 | XlDialogPromote
 | XlDialogDemote
 | XlDialogShowDetail
 | XlDialogObjectProperties
 | XlDialogSaveNewObject
 | XlDialogApplyStyle
 | XlDialogAssignToObject
 | XlDialogObjectProtection
 | XlDialogCreatePublisher
 | XlDialogSubscribeTo
 | XlDialogShowToolbar
 | XlDialogPrintPreview
 | XlDialogEditColor
 | XlDialogFormatMain
 | XlDialogFormatOverlay
 | XlDialogEditSeries
 | XlDialogDefineStyle
 | XlDialogGalleryRadar
 | XlDialogEditionOptions
 | XlDialogZoom
 | XlDialogInsertObject
 | XlDialogSize
 | XlDialogMove
 | XlDialogFormatAuto
 | XlDialogGallery3dBar
 | XlDialogGallery3dSurface
 | XlDialogCustomizeToolbar
 | XlDialogWorkbookAdd
 | XlDialogWorkbookMove
 | XlDialogWorkbookCopy
 | XlDialogWorkbookOptions
 | XlDialogSaveWorkspace
 | XlDialogChartWizard
 | XlDialogAssignToTool
 | XlDialogPlacement
 | XlDialogFillWorkgroup
 | XlDialogWorkbookNew
 | XlDialogScenarioCells
 | XlDialogScenarioAdd
 | XlDialogScenarioEdit
 | XlDialogScenarioSummary
 | XlDialogPivotTableWizard
 | XlDialogPivotFieldProperties
 | XlDialogOptionsCalculation
 | XlDialogOptionsEdit
 | XlDialogOptionsView
 | XlDialogAddinManager
 | XlDialogMenuEditor
 | XlDialogAttachToolbars
 | XlDialogOptionsChart
 | XlDialogVbaInsertFile
 | XlDialogVbaProcedureDefinition
 | XlDialogRoutingSlip
 | XlDialogMailLogon
 | XlDialogInsertPicture
 | XlDialogGalleryDoughnut
 | XlDialogChartTrend
 | XlDialogWorkbookInsert
 | XlDialogOptionsTransition
 | XlDialogOptionsGeneral
 | XlDialogFilterAdvanced
 | XlDialogMailNextLetter
 | XlDialogDataLabel
 | XlDialogInsertTitle
 | XlDialogFontProperties
 | XlDialogMacroOptions
 | XlDialogWorkbookUnhide
 | XlDialogWorkbookName
 | XlDialogGalleryCustom
 | XlDialogAddChartAutoformat
 | XlDialogChartAddData
 | XlDialogTabOrder
 | XlDialogSubtotalCreate
 | XlDialogWorkbookTabSplit
 | XlDialogWorkbookProtect
 | XlDialogScrollbarProperties
 | XlDialogPivotShowPages
 | XlDialogTextToColumns
 | XlDialogFormatCharttype
 | XlDialogPivotFieldGroup
 | XlDialogPivotFieldUngroup
 | XlDialogCheckboxProperties
 | XlDialogLabelProperties
 | XlDialogListboxProperties
 | XlDialogEditboxProperties
 | XlDialogOpenText
 | XlDialogPushbuttonProperties
 | XlDialogFilter
 | XlDialogFunctionWizard
 | XlDialogSaveCopyAs
 | XlDialogOptionsListsAdd
 | XlDialogSeriesAxes
 | XlDialogSeriesX
 | XlDialogSeriesY
 | XlDialogErrorbarX
 | XlDialogErrorbarY
 | XlDialogFormatChart
 | XlDialogSeriesOrder
 | XlDialogMailEditMailer
 | XlDialogStandardWidth
 | XlDialogScenarioMerge
 | XlDialogProperties
 | XlDialogSummaryInfo
 | XlDialogFindFile
 | XlDialogActiveCellFont
 | XlDialogVbaMakeAddin
 | XlDialogFileSharing
 | XlDialogAutoCorrect
 | XlDialogCustomViews
 | XlDialogInsertNameLabel
 | XlDialogSeriesShape
 | XlDialogChartOptionsDataLabels
 | XlDialogChartOptionsDataTable
 | XlDialogSetBackgroundPicture
 | XlDialogDataValidation
 | XlDialogChartType
 | XlDialogChartLocation
 | XlDialogPhonetic
 | XlDialogChartSourceData
 | XlDialogSeriesOptions
 | XlDialogPivotTableOptions
 | XlDialogPivotSolveOrder
 | XlDialogPivotCalculatedField
 | XlDialogPivotCalculatedItem
 | XlDialogConditionalFormatting
 | XlDialogInsertHyperlink
 | XlDialogProtectSharing
 
marshallXlBuiltInDialog :: XlBuiltInDialog -> Prelude.IO Int.Int16
marshallXlBuiltInDialog v =
  case v of
     XlDialogOpen -> Prelude.return (1)
     XlDialogOpenLinks -> Prelude.return (2)
     XlDialogSaveAs -> Prelude.return (5)
     XlDialogFileDelete -> Prelude.return (6)
     XlDialogPageSetup -> Prelude.return (7)
     XlDialogPrint -> Prelude.return (8)
     XlDialogPrinterSetup -> Prelude.return (9)
     XlDialogArrangeAll -> Prelude.return (12)
     XlDialogWindowSize -> Prelude.return (13)
     XlDialogWindowMove -> Prelude.return (14)
     XlDialogRun -> Prelude.return (17)
     XlDialogSetPrintTitles -> Prelude.return (23)
     XlDialogFont -> Prelude.return (26)
     XlDialogDisplay -> Prelude.return (27)
     XlDialogProtectDocument -> Prelude.return (28)
     XlDialogCalculation -> Prelude.return (32)
     XlDialogExtract -> Prelude.return (35)
     XlDialogDataDelete -> Prelude.return (36)
     XlDialogSort -> Prelude.return (39)
     XlDialogDataSeries -> Prelude.return (40)
     XlDialogTable -> Prelude.return (41)
     XlDialogFormatNumber -> Prelude.return (42)
     XlDialogAlignment -> Prelude.return (43)
     XlDialogStyle -> Prelude.return (44)
     XlDialogBorder -> Prelude.return (45)
     XlDialogCellProtection -> Prelude.return (46)
     XlDialogColumnWidth -> Prelude.return (47)
     XlDialogClear -> Prelude.return (52)
     XlDialogPasteSpecial -> Prelude.return (53)
     XlDialogEditDelete -> Prelude.return (54)
     XlDialogInsert -> Prelude.return (55)
     XlDialogPasteNames -> Prelude.return (58)
     XlDialogDefineName -> Prelude.return (61)
     XlDialogCreateNames -> Prelude.return (62)
     XlDialogFormulaGoto -> Prelude.return (63)
     XlDialogFormulaFind -> Prelude.return (64)
     XlDialogGalleryArea -> Prelude.return (67)
     XlDialogGalleryBar -> Prelude.return (68)
     XlDialogGalleryColumn -> Prelude.return (69)
     XlDialogGalleryLine -> Prelude.return (70)
     XlDialogGalleryPie -> Prelude.return (71)
     XlDialogGalleryScatter -> Prelude.return (72)
     XlDialogCombination -> Prelude.return (73)
     XlDialogGridlines -> Prelude.return (76)
     XlDialogAxes -> Prelude.return (78)
     XlDialogAttachText -> Prelude.return (80)
     XlDialogPatterns -> Prelude.return (84)
     XlDialogMainChart -> Prelude.return (85)
     XlDialogOverlay -> Prelude.return (86)
     XlDialogScale -> Prelude.return (87)
     XlDialogFormatLegend -> Prelude.return (88)
     XlDialogFormatText -> Prelude.return (89)
     XlDialogParse -> Prelude.return (91)
     XlDialogUnhide -> Prelude.return (94)
     XlDialogWorkspace -> Prelude.return (95)
     XlDialogActivate -> Prelude.return (103)
     XlDialogCopyPicture -> Prelude.return (108)
     XlDialogDeleteName -> Prelude.return (110)
     XlDialogDeleteFormat -> Prelude.return (111)
     XlDialogNew -> Prelude.return (119)
     XlDialogRowHeight -> Prelude.return (127)
     XlDialogFormatMove -> Prelude.return (128)
     XlDialogFormatSize -> Prelude.return (129)
     XlDialogFormulaReplace -> Prelude.return (130)
     XlDialogSelectSpecial -> Prelude.return (132)
     XlDialogApplyNames -> Prelude.return (133)
     XlDialogReplaceFont -> Prelude.return (134)
     XlDialogSplit -> Prelude.return (137)
     XlDialogOutline -> Prelude.return (142)
     XlDialogSaveWorkbook -> Prelude.return (145)
     XlDialogCopyChart -> Prelude.return (147)
     XlDialogFormatFont -> Prelude.return (150)
     XlDialogNote -> Prelude.return (154)
     XlDialogSetUpdateStatus -> Prelude.return (159)
     XlDialogColorPalette -> Prelude.return (161)
     XlDialogChangeLink -> Prelude.return (166)
     XlDialogAppMove -> Prelude.return (170)
     XlDialogAppSize -> Prelude.return (171)
     XlDialogMainChartType -> Prelude.return (185)
     XlDialogOverlayChartType -> Prelude.return (186)
     XlDialogOpenMail -> Prelude.return (188)
     XlDialogSendMail -> Prelude.return (189)
     XlDialogStandardFont -> Prelude.return (190)
     XlDialogConsolidate -> Prelude.return (191)
     XlDialogSortSpecial -> Prelude.return (192)
     XlDialogGallery3dArea -> Prelude.return (193)
     XlDialogGallery3dColumn -> Prelude.return (194)
     XlDialogGallery3dLine -> Prelude.return (195)
     XlDialogGallery3dPie -> Prelude.return (196)
     XlDialogView3d -> Prelude.return (197)
     XlDialogGoalSeek -> Prelude.return (198)
     XlDialogWorkgroup -> Prelude.return (199)
     XlDialogFillGroup -> Prelude.return (200)
     XlDialogUpdateLink -> Prelude.return (201)
     XlDialogPromote -> Prelude.return (202)
     XlDialogDemote -> Prelude.return (203)
     XlDialogShowDetail -> Prelude.return (204)
     XlDialogObjectProperties -> Prelude.return (207)
     XlDialogSaveNewObject -> Prelude.return (208)
     XlDialogApplyStyle -> Prelude.return (212)
     XlDialogAssignToObject -> Prelude.return (213)
     XlDialogObjectProtection -> Prelude.return (214)
     XlDialogCreatePublisher -> Prelude.return (217)
     XlDialogSubscribeTo -> Prelude.return (218)
     XlDialogShowToolbar -> Prelude.return (220)
     XlDialogPrintPreview -> Prelude.return (222)
     XlDialogEditColor -> Prelude.return (223)
     XlDialogFormatMain -> Prelude.return (225)
     XlDialogFormatOverlay -> Prelude.return (226)
     XlDialogEditSeries -> Prelude.return (228)
     XlDialogDefineStyle -> Prelude.return (229)
     XlDialogGalleryRadar -> Prelude.return (249)
     XlDialogEditionOptions -> Prelude.return (251)
     XlDialogZoom -> Prelude.return (256)
     XlDialogInsertObject -> Prelude.return (259)
     XlDialogSize -> Prelude.return (261)
     XlDialogMove -> Prelude.return (262)
     XlDialogFormatAuto -> Prelude.return (269)
     XlDialogGallery3dBar -> Prelude.return (272)
     XlDialogGallery3dSurface -> Prelude.return (273)
     XlDialogCustomizeToolbar -> Prelude.return (276)
     XlDialogWorkbookAdd -> Prelude.return (281)
     XlDialogWorkbookMove -> Prelude.return (282)
     XlDialogWorkbookCopy -> Prelude.return (283)
     XlDialogWorkbookOptions -> Prelude.return (284)
     XlDialogSaveWorkspace -> Prelude.return (285)
     XlDialogChartWizard -> Prelude.return (288)
     XlDialogAssignToTool -> Prelude.return (293)
     XlDialogPlacement -> Prelude.return (300)
     XlDialogFillWorkgroup -> Prelude.return (301)
     XlDialogWorkbookNew -> Prelude.return (302)
     XlDialogScenarioCells -> Prelude.return (305)
     XlDialogScenarioAdd -> Prelude.return (307)
     XlDialogScenarioEdit -> Prelude.return (308)
     XlDialogScenarioSummary -> Prelude.return (311)
     XlDialogPivotTableWizard -> Prelude.return (312)
     XlDialogPivotFieldProperties -> Prelude.return (313)
     XlDialogOptionsCalculation -> Prelude.return (318)
     XlDialogOptionsEdit -> Prelude.return (319)
     XlDialogOptionsView -> Prelude.return (320)
     XlDialogAddinManager -> Prelude.return (321)
     XlDialogMenuEditor -> Prelude.return (322)
     XlDialogAttachToolbars -> Prelude.return (323)
     XlDialogOptionsChart -> Prelude.return (325)
     XlDialogVbaInsertFile -> Prelude.return (328)
     XlDialogVbaProcedureDefinition -> Prelude.return (330)
     XlDialogRoutingSlip -> Prelude.return (336)
     XlDialogMailLogon -> Prelude.return (339)
     XlDialogInsertPicture -> Prelude.return (342)
     XlDialogGalleryDoughnut -> Prelude.return (344)
     XlDialogChartTrend -> Prelude.return (350)
     XlDialogWorkbookInsert -> Prelude.return (354)
     XlDialogOptionsTransition -> Prelude.return (355)
     XlDialogOptionsGeneral -> Prelude.return (356)
     XlDialogFilterAdvanced -> Prelude.return (370)
     XlDialogMailNextLetter -> Prelude.return (378)
     XlDialogDataLabel -> Prelude.return (379)
     XlDialogInsertTitle -> Prelude.return (380)
     XlDialogFontProperties -> Prelude.return (381)
     XlDialogMacroOptions -> Prelude.return (382)
     XlDialogWorkbookUnhide -> Prelude.return (384)
     XlDialogWorkbookName -> Prelude.return (386)
     XlDialogGalleryCustom -> Prelude.return (388)
     XlDialogAddChartAutoformat -> Prelude.return (390)
     XlDialogChartAddData -> Prelude.return (392)
     XlDialogTabOrder -> Prelude.return (394)
     XlDialogSubtotalCreate -> Prelude.return (398)
     XlDialogWorkbookTabSplit -> Prelude.return (415)
     XlDialogWorkbookProtect -> Prelude.return (417)
     XlDialogScrollbarProperties -> Prelude.return (420)
     XlDialogPivotShowPages -> Prelude.return (421)
     XlDialogTextToColumns -> Prelude.return (422)
     XlDialogFormatCharttype -> Prelude.return (423)
     XlDialogPivotFieldGroup -> Prelude.return (433)
     XlDialogPivotFieldUngroup -> Prelude.return (434)
     XlDialogCheckboxProperties -> Prelude.return (435)
     XlDialogLabelProperties -> Prelude.return (436)
     XlDialogListboxProperties -> Prelude.return (437)
     XlDialogEditboxProperties -> Prelude.return (438)
     XlDialogOpenText -> Prelude.return (441)
     XlDialogPushbuttonProperties -> Prelude.return (445)
     XlDialogFilter -> Prelude.return (447)
     XlDialogFunctionWizard -> Prelude.return (450)
     XlDialogSaveCopyAs -> Prelude.return (456)
     XlDialogOptionsListsAdd -> Prelude.return (458)
     XlDialogSeriesAxes -> Prelude.return (460)
     XlDialogSeriesX -> Prelude.return (461)
     XlDialogSeriesY -> Prelude.return (462)
     XlDialogErrorbarX -> Prelude.return (463)
     XlDialogErrorbarY -> Prelude.return (464)
     XlDialogFormatChart -> Prelude.return (465)
     XlDialogSeriesOrder -> Prelude.return (466)
     XlDialogMailEditMailer -> Prelude.return (470)
     XlDialogStandardWidth -> Prelude.return (472)
     XlDialogScenarioMerge -> Prelude.return (473)
     XlDialogProperties -> Prelude.return (474)
     XlDialogSummaryInfo -> Prelude.return (474)
     XlDialogFindFile -> Prelude.return (475)
     XlDialogActiveCellFont -> Prelude.return (476)
     XlDialogVbaMakeAddin -> Prelude.return (478)
     XlDialogFileSharing -> Prelude.return (481)
     XlDialogAutoCorrect -> Prelude.return (485)
     XlDialogCustomViews -> Prelude.return (493)
     XlDialogInsertNameLabel -> Prelude.return (496)
     XlDialogSeriesShape -> Prelude.return (504)
     XlDialogChartOptionsDataLabels -> Prelude.return (505)
     XlDialogChartOptionsDataTable -> Prelude.return (506)
     XlDialogSetBackgroundPicture -> Prelude.return (509)
     XlDialogDataValidation -> Prelude.return (525)
     XlDialogChartType -> Prelude.return (526)
     XlDialogChartLocation -> Prelude.return (527)
     XlDialogPhonetic -> Prelude.return (538)
     XlDialogChartSourceData -> Prelude.return (541)
     XlDialogSeriesOptions -> Prelude.return (557)
     XlDialogPivotTableOptions -> Prelude.return (567)
     XlDialogPivotSolveOrder -> Prelude.return (568)
     XlDialogPivotCalculatedField -> Prelude.return (570)
     XlDialogPivotCalculatedItem -> Prelude.return (572)
     XlDialogConditionalFormatting -> Prelude.return (583)
     XlDialogInsertHyperlink -> Prelude.return (596)
     XlDialogProtectSharing -> Prelude.return (620)
unmarshallXlBuiltInDialog :: Int.Int16 -> Prelude.IO XlBuiltInDialog
unmarshallXlBuiltInDialog v =
  case v of
     1 -> Prelude.return (XlDialogOpen)
     2 -> Prelude.return (XlDialogOpenLinks)
     5 -> Prelude.return (XlDialogSaveAs)
     6 -> Prelude.return (XlDialogFileDelete)
     7 -> Prelude.return (XlDialogPageSetup)
     8 -> Prelude.return (XlDialogPrint)
     9 -> Prelude.return (XlDialogPrinterSetup)
     12 -> Prelude.return (XlDialogArrangeAll)
     13 -> Prelude.return (XlDialogWindowSize)
     14 -> Prelude.return (XlDialogWindowMove)
     17 -> Prelude.return (XlDialogRun)
     23 -> Prelude.return (XlDialogSetPrintTitles)
     26 -> Prelude.return (XlDialogFont)
     27 -> Prelude.return (XlDialogDisplay)
     28 -> Prelude.return (XlDialogProtectDocument)
     32 -> Prelude.return (XlDialogCalculation)
     35 -> Prelude.return (XlDialogExtract)
     36 -> Prelude.return (XlDialogDataDelete)
     39 -> Prelude.return (XlDialogSort)
     40 -> Prelude.return (XlDialogDataSeries)
     41 -> Prelude.return (XlDialogTable)
     42 -> Prelude.return (XlDialogFormatNumber)
     43 -> Prelude.return (XlDialogAlignment)
     44 -> Prelude.return (XlDialogStyle)
     45 -> Prelude.return (XlDialogBorder)
     46 -> Prelude.return (XlDialogCellProtection)
     47 -> Prelude.return (XlDialogColumnWidth)
     52 -> Prelude.return (XlDialogClear)
     53 -> Prelude.return (XlDialogPasteSpecial)
     54 -> Prelude.return (XlDialogEditDelete)
     55 -> Prelude.return (XlDialogInsert)
     58 -> Prelude.return (XlDialogPasteNames)
     61 -> Prelude.return (XlDialogDefineName)
     62 -> Prelude.return (XlDialogCreateNames)
     63 -> Prelude.return (XlDialogFormulaGoto)
     64 -> Prelude.return (XlDialogFormulaFind)
     67 -> Prelude.return (XlDialogGalleryArea)
     68 -> Prelude.return (XlDialogGalleryBar)
     69 -> Prelude.return (XlDialogGalleryColumn)
     70 -> Prelude.return (XlDialogGalleryLine)
     71 -> Prelude.return (XlDialogGalleryPie)
     72 -> Prelude.return (XlDialogGalleryScatter)
     73 -> Prelude.return (XlDialogCombination)
     76 -> Prelude.return (XlDialogGridlines)
     78 -> Prelude.return (XlDialogAxes)
     80 -> Prelude.return (XlDialogAttachText)
     84 -> Prelude.return (XlDialogPatterns)
     85 -> Prelude.return (XlDialogMainChart)
     86 -> Prelude.return (XlDialogOverlay)
     87 -> Prelude.return (XlDialogScale)
     88 -> Prelude.return (XlDialogFormatLegend)
     89 -> Prelude.return (XlDialogFormatText)
     91 -> Prelude.return (XlDialogParse)
     94 -> Prelude.return (XlDialogUnhide)
     95 -> Prelude.return (XlDialogWorkspace)
     103 -> Prelude.return (XlDialogActivate)
     108 -> Prelude.return (XlDialogCopyPicture)
     110 -> Prelude.return (XlDialogDeleteName)
     111 -> Prelude.return (XlDialogDeleteFormat)
     119 -> Prelude.return (XlDialogNew)
     127 -> Prelude.return (XlDialogRowHeight)
     128 -> Prelude.return (XlDialogFormatMove)
     129 -> Prelude.return (XlDialogFormatSize)
     130 -> Prelude.return (XlDialogFormulaReplace)
     132 -> Prelude.return (XlDialogSelectSpecial)
     133 -> Prelude.return (XlDialogApplyNames)
     134 -> Prelude.return (XlDialogReplaceFont)
     137 -> Prelude.return (XlDialogSplit)
     142 -> Prelude.return (XlDialogOutline)
     145 -> Prelude.return (XlDialogSaveWorkbook)
     147 -> Prelude.return (XlDialogCopyChart)
     150 -> Prelude.return (XlDialogFormatFont)
     154 -> Prelude.return (XlDialogNote)
     159 -> Prelude.return (XlDialogSetUpdateStatus)
     161 -> Prelude.return (XlDialogColorPalette)
     166 -> Prelude.return (XlDialogChangeLink)
     170 -> Prelude.return (XlDialogAppMove)
     171 -> Prelude.return (XlDialogAppSize)
     185 -> Prelude.return (XlDialogMainChartType)
     186 -> Prelude.return (XlDialogOverlayChartType)
     188 -> Prelude.return (XlDialogOpenMail)
     189 -> Prelude.return (XlDialogSendMail)
     190 -> Prelude.return (XlDialogStandardFont)
     191 -> Prelude.return (XlDialogConsolidate)
     192 -> Prelude.return (XlDialogSortSpecial)
     193 -> Prelude.return (XlDialogGallery3dArea)
     194 -> Prelude.return (XlDialogGallery3dColumn)
     195 -> Prelude.return (XlDialogGallery3dLine)
     196 -> Prelude.return (XlDialogGallery3dPie)
     197 -> Prelude.return (XlDialogView3d)
     198 -> Prelude.return (XlDialogGoalSeek)
     199 -> Prelude.return (XlDialogWorkgroup)
     200 -> Prelude.return (XlDialogFillGroup)
     201 -> Prelude.return (XlDialogUpdateLink)
     202 -> Prelude.return (XlDialogPromote)
     203 -> Prelude.return (XlDialogDemote)
     204 -> Prelude.return (XlDialogShowDetail)
     207 -> Prelude.return (XlDialogObjectProperties)
     208 -> Prelude.return (XlDialogSaveNewObject)
     212 -> Prelude.return (XlDialogApplyStyle)
     213 -> Prelude.return (XlDialogAssignToObject)
     214 -> Prelude.return (XlDialogObjectProtection)
     217 -> Prelude.return (XlDialogCreatePublisher)
     218 -> Prelude.return (XlDialogSubscribeTo)
     220 -> Prelude.return (XlDialogShowToolbar)
     222 -> Prelude.return (XlDialogPrintPreview)
     223 -> Prelude.return (XlDialogEditColor)
     225 -> Prelude.return (XlDialogFormatMain)
     226 -> Prelude.return (XlDialogFormatOverlay)
     228 -> Prelude.return (XlDialogEditSeries)
     229 -> Prelude.return (XlDialogDefineStyle)
     249 -> Prelude.return (XlDialogGalleryRadar)
     251 -> Prelude.return (XlDialogEditionOptions)
     256 -> Prelude.return (XlDialogZoom)
     259 -> Prelude.return (XlDialogInsertObject)
     261 -> Prelude.return (XlDialogSize)
     262 -> Prelude.return (XlDialogMove)
     269 -> Prelude.return (XlDialogFormatAuto)
     272 -> Prelude.return (XlDialogGallery3dBar)
     273 -> Prelude.return (XlDialogGallery3dSurface)
     276 -> Prelude.return (XlDialogCustomizeToolbar)
     281 -> Prelude.return (XlDialogWorkbookAdd)
     282 -> Prelude.return (XlDialogWorkbookMove)
     283 -> Prelude.return (XlDialogWorkbookCopy)
     284 -> Prelude.return (XlDialogWorkbookOptions)
     285 -> Prelude.return (XlDialogSaveWorkspace)
     288 -> Prelude.return (XlDialogChartWizard)
     293 -> Prelude.return (XlDialogAssignToTool)
     300 -> Prelude.return (XlDialogPlacement)
     301 -> Prelude.return (XlDialogFillWorkgroup)
     302 -> Prelude.return (XlDialogWorkbookNew)
     305 -> Prelude.return (XlDialogScenarioCells)
     307 -> Prelude.return (XlDialogScenarioAdd)
     308 -> Prelude.return (XlDialogScenarioEdit)
     311 -> Prelude.return (XlDialogScenarioSummary)
     312 -> Prelude.return (XlDialogPivotTableWizard)
     313 -> Prelude.return (XlDialogPivotFieldProperties)
     318 -> Prelude.return (XlDialogOptionsCalculation)
     319 -> Prelude.return (XlDialogOptionsEdit)
     320 -> Prelude.return (XlDialogOptionsView)
     321 -> Prelude.return (XlDialogAddinManager)
     322 -> Prelude.return (XlDialogMenuEditor)
     323 -> Prelude.return (XlDialogAttachToolbars)
     325 -> Prelude.return (XlDialogOptionsChart)
     328 -> Prelude.return (XlDialogVbaInsertFile)
     330 -> Prelude.return (XlDialogVbaProcedureDefinition)
     336 -> Prelude.return (XlDialogRoutingSlip)
     339 -> Prelude.return (XlDialogMailLogon)
     342 -> Prelude.return (XlDialogInsertPicture)
     344 -> Prelude.return (XlDialogGalleryDoughnut)
     350 -> Prelude.return (XlDialogChartTrend)
     354 -> Prelude.return (XlDialogWorkbookInsert)
     355 -> Prelude.return (XlDialogOptionsTransition)
     356 -> Prelude.return (XlDialogOptionsGeneral)
     370 -> Prelude.return (XlDialogFilterAdvanced)
     378 -> Prelude.return (XlDialogMailNextLetter)
     379 -> Prelude.return (XlDialogDataLabel)
     380 -> Prelude.return (XlDialogInsertTitle)
     381 -> Prelude.return (XlDialogFontProperties)
     382 -> Prelude.return (XlDialogMacroOptions)
     384 -> Prelude.return (XlDialogWorkbookUnhide)
     386 -> Prelude.return (XlDialogWorkbookName)
     388 -> Prelude.return (XlDialogGalleryCustom)
     390 -> Prelude.return (XlDialogAddChartAutoformat)
     392 -> Prelude.return (XlDialogChartAddData)
     394 -> Prelude.return (XlDialogTabOrder)
     398 -> Prelude.return (XlDialogSubtotalCreate)
     415 -> Prelude.return (XlDialogWorkbookTabSplit)
     417 -> Prelude.return (XlDialogWorkbookProtect)
     420 -> Prelude.return (XlDialogScrollbarProperties)
     421 -> Prelude.return (XlDialogPivotShowPages)
     422 -> Prelude.return (XlDialogTextToColumns)
     423 -> Prelude.return (XlDialogFormatCharttype)
     433 -> Prelude.return (XlDialogPivotFieldGroup)
     434 -> Prelude.return (XlDialogPivotFieldUngroup)
     435 -> Prelude.return (XlDialogCheckboxProperties)
     436 -> Prelude.return (XlDialogLabelProperties)
     437 -> Prelude.return (XlDialogListboxProperties)
     438 -> Prelude.return (XlDialogEditboxProperties)
     441 -> Prelude.return (XlDialogOpenText)
     445 -> Prelude.return (XlDialogPushbuttonProperties)
     447 -> Prelude.return (XlDialogFilter)
     450 -> Prelude.return (XlDialogFunctionWizard)
     456 -> Prelude.return (XlDialogSaveCopyAs)
     458 -> Prelude.return (XlDialogOptionsListsAdd)
     460 -> Prelude.return (XlDialogSeriesAxes)
     461 -> Prelude.return (XlDialogSeriesX)
     462 -> Prelude.return (XlDialogSeriesY)
     463 -> Prelude.return (XlDialogErrorbarX)
     464 -> Prelude.return (XlDialogErrorbarY)
     465 -> Prelude.return (XlDialogFormatChart)
     466 -> Prelude.return (XlDialogSeriesOrder)
     470 -> Prelude.return (XlDialogMailEditMailer)
     472 -> Prelude.return (XlDialogStandardWidth)
     473 -> Prelude.return (XlDialogScenarioMerge)
     474 -> Prelude.return (XlDialogProperties)
     474 -> Prelude.return (XlDialogSummaryInfo)
     475 -> Prelude.return (XlDialogFindFile)
     476 -> Prelude.return (XlDialogActiveCellFont)
     478 -> Prelude.return (XlDialogVbaMakeAddin)
     481 -> Prelude.return (XlDialogFileSharing)
     485 -> Prelude.return (XlDialogAutoCorrect)
     493 -> Prelude.return (XlDialogCustomViews)
     496 -> Prelude.return (XlDialogInsertNameLabel)
     504 -> Prelude.return (XlDialogSeriesShape)
     505 -> Prelude.return (XlDialogChartOptionsDataLabels)
     506 -> Prelude.return (XlDialogChartOptionsDataTable)
     509 -> Prelude.return (XlDialogSetBackgroundPicture)
     525 -> Prelude.return (XlDialogDataValidation)
     526 -> Prelude.return (XlDialogChartType)
     527 -> Prelude.return (XlDialogChartLocation)
     538 -> Prelude.return (XlDialogPhonetic)
     541 -> Prelude.return (XlDialogChartSourceData)
     557 -> Prelude.return (XlDialogSeriesOptions)
     567 -> Prelude.return (XlDialogPivotTableOptions)
     568 -> Prelude.return (XlDialogPivotSolveOrder)
     570 -> Prelude.return (XlDialogPivotCalculatedField)
     572 -> Prelude.return (XlDialogPivotCalculatedItem)
     583 -> Prelude.return (XlDialogConditionalFormatting)
     596 -> Prelude.return (XlDialogInsertHyperlink)
     620 -> Prelude.return (XlDialogProtectSharing)
     _ -> Prelude.fail (Prelude.userError "unmarshallXlBuiltInDialog: illegal enum value ")
data XlParameterType
 = XlPrompt
 | XlConstant
 | XlRange
 
marshallXlParameterType :: XlParameterType -> Prelude.IO Int.Int16
marshallXlParameterType v =
  case v of
     XlPrompt -> Prelude.return (0)
     XlConstant -> Prelude.return (1)
     XlRange -> Prelude.return (2)
unmarshallXlParameterType :: Int.Int16 -> Prelude.IO XlParameterType
unmarshallXlParameterType v =
  case v of
     0 -> Prelude.return (XlPrompt)
     1 -> Prelude.return (XlConstant)
     2 -> Prelude.return (XlRange)
     _ -> Prelude.fail (Prelude.userError "unmarshallXlParameterType: illegal enum value ")
data XlParameterDataType
 = XlParamTypeUnknown
 | XlParamTypeChar
 | XlParamTypeNumeric
 | XlParamTypeDecimal
 | XlParamTypeInteger
 | XlParamTypeSmallInt
 | XlParamTypeFloat
 | XlParamTypeReal
 | XlParamTypeDouble
 | XlParamTypeVarChar
 | XlParamTypeDate
 | XlParamTypeTime
 | XlParamTypeTimestamp
 | XlParamTypeLongVarChar
 | XlParamTypeBinary
 | XlParamTypeVarBinary
 | XlParamTypeLongVarBinary
 | XlParamTypeBigInt
 | XlParamTypeTinyInt
 | XlParamTypeBit
 
marshallXlParameterDataType :: XlParameterDataType -> Prelude.IO Int.Int16
marshallXlParameterDataType v =
  case v of
     XlParamTypeUnknown -> Prelude.return (0)
     XlParamTypeChar -> Prelude.return (1)
     XlParamTypeNumeric -> Prelude.return (2)
     XlParamTypeDecimal -> Prelude.return (3)
     XlParamTypeInteger -> Prelude.return (4)
     XlParamTypeSmallInt -> Prelude.return (5)
     XlParamTypeFloat -> Prelude.return (6)
     XlParamTypeReal -> Prelude.return (7)
     XlParamTypeDouble -> Prelude.return (8)
     XlParamTypeVarChar -> Prelude.return (12)
     XlParamTypeDate -> Prelude.return (9)
     XlParamTypeTime -> Prelude.return (10)
     XlParamTypeTimestamp -> Prelude.return (11)
     XlParamTypeLongVarChar -> Prelude.return ((-1))
     XlParamTypeBinary -> Prelude.return ((-2))
     XlParamTypeVarBinary -> Prelude.return ((-3))
     XlParamTypeLongVarBinary -> Prelude.return ((-4))
     XlParamTypeBigInt -> Prelude.return ((-5))
     XlParamTypeTinyInt -> Prelude.return ((-6))
     XlParamTypeBit -> Prelude.return ((-7))
unmarshallXlParameterDataType :: Int.Int16 -> Prelude.IO XlParameterDataType
unmarshallXlParameterDataType v =
  case v of
     0 -> Prelude.return (XlParamTypeUnknown)
     1 -> Prelude.return (XlParamTypeChar)
     2 -> Prelude.return (XlParamTypeNumeric)
     3 -> Prelude.return (XlParamTypeDecimal)
     4 -> Prelude.return (XlParamTypeInteger)
     5 -> Prelude.return (XlParamTypeSmallInt)
     6 -> Prelude.return (XlParamTypeFloat)
     7 -> Prelude.return (XlParamTypeReal)
     8 -> Prelude.return (XlParamTypeDouble)
     12 -> Prelude.return (XlParamTypeVarChar)
     9 -> Prelude.return (XlParamTypeDate)
     10 -> Prelude.return (XlParamTypeTime)
     11 -> Prelude.return (XlParamTypeTimestamp)
     (-1) -> Prelude.return (XlParamTypeLongVarChar)
     (-2) -> Prelude.return (XlParamTypeBinary)
     (-3) -> Prelude.return (XlParamTypeVarBinary)
     (-4) -> Prelude.return (XlParamTypeLongVarBinary)
     (-5) -> Prelude.return (XlParamTypeBigInt)
     (-6) -> Prelude.return (XlParamTypeTinyInt)
     (-7) -> Prelude.return (XlParamTypeBit)
     _ -> Prelude.fail (Prelude.userError "unmarshallXlParameterDataType: illegal enum value ")
data XlFormControl
 = XlButtonControl
 | XlCheckBox
 | XlDropDown
 | XlEditBox
 | XlGroupBox
 | XlLabel
 | XlListBox
 | XlOptionButton
 | XlScrollBar
 | XlSpinner
 
marshallXlFormControl :: XlFormControl -> Prelude.IO Int.Int16
marshallXlFormControl v =
  case v of
     XlButtonControl -> Prelude.return (0)
     XlCheckBox -> Prelude.return (1)
     XlDropDown -> Prelude.return (2)
     XlEditBox -> Prelude.return (3)
     XlGroupBox -> Prelude.return (4)
     XlLabel -> Prelude.return (5)
     XlListBox -> Prelude.return (6)
     XlOptionButton -> Prelude.return (7)
     XlScrollBar -> Prelude.return (8)
     XlSpinner -> Prelude.return (9)
unmarshallXlFormControl :: Int.Int16 -> Prelude.IO XlFormControl
unmarshallXlFormControl v =
  case v of
     0 -> Prelude.return (XlButtonControl)
     1 -> Prelude.return (XlCheckBox)
     2 -> Prelude.return (XlDropDown)
     3 -> Prelude.return (XlEditBox)
     4 -> Prelude.return (XlGroupBox)
     5 -> Prelude.return (XlLabel)
     6 -> Prelude.return (XlListBox)
     7 -> Prelude.return (XlOptionButton)
     8 -> Prelude.return (XlScrollBar)
     9 -> Prelude.return (XlSpinner)
     _ -> Prelude.fail (Prelude.userError "unmarshallXlFormControl: illegal enum value ")
-}

-- --------------------------------------------------
-- 
-- interface IFont
-- 
-- --------------------------------------------------
data Font a = Font
               
type IFont a = Automation.IDispatch (Font a)
iidIFont :: Com.IID (IFont Automation.Interface)
iidIFont = Com.mkIID "{0002084D-0001-0000-C000-000000000046}"
getApplication10 :: Automation.IDispatch a -> Prelude.IO (VBIDE.IApplication Automation.Interface)
getApplication10 =
  Automation.propertyGet "Application" [] Automation.outIDispatch
getCreator10 :: (Automation.Variant a0) => Automation.IDispatch a -> Prelude.IO (a0)
getCreator10 =
  Automation.propertyGet "Creator" [] Automation.outVariant
getBackground :: Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getBackground =
  Automation.propertyGet "Background" [] Automation.outInt
setBackground :: Prelude.Int -> Automation.IDispatch a -> Prelude.IO ()
setBackground rHS =
  Automation.propertySet "Background" [Automation.inInt rHS]
getBold :: IFont a -> Prelude.IO (Prelude.Int)
getBold = Automation.propertyGet "Bold" [] Automation.outInt
setBold :: Prelude.Int -> IFont a -> Prelude.IO ()
setBold rHS = Automation.propertySet "Bold" [Automation.inInt rHS]
getColor :: Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getColor = Automation.propertyGet "Color" [] Automation.outInt
setColor :: Prelude.Int -> Automation.IDispatch a -> Prelude.IO ()
setColor rHS =
  Automation.propertySet "Color" [Automation.inInt rHS]
getColorIndex :: Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getColorIndex =
  Automation.propertyGet "ColorIndex" [] Automation.outInt
setColorIndex :: Prelude.Int -> Automation.IDispatch a -> Prelude.IO ()
setColorIndex rHS =
  Automation.propertySet "ColorIndex" [Automation.inInt rHS]
getFontStyle :: IFont a -> Prelude.IO (Prelude.Int)
getFontStyle =
  Automation.propertyGet "FontStyle" [] Automation.outInt
setFontStyle :: Prelude.Int -> IFont a -> Prelude.IO ()
setFontStyle rHS =
  Automation.propertySet "FontStyle" [Automation.inInt rHS]
getItalic :: IFont a -> Prelude.IO (Prelude.Int)
getItalic = Automation.propertyGet "Italic" [] Automation.outInt
setItalic :: Prelude.Int -> IFont a -> Prelude.IO ()
setItalic rHS =
  Automation.propertySet "Italic" [Automation.inInt rHS]
getName :: Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getName = Automation.propertyGet "Name" [] Automation.outInt
setName :: Prelude.Int -> Automation.IDispatch a -> Prelude.IO ()
setName rHS = Automation.propertySet "Name" [Automation.inInt rHS]
getOutlineFont :: IFont a -> Prelude.IO (Prelude.Int)
getOutlineFont =
  Automation.propertyGet "OutlineFont" [] Automation.outInt
setOutlineFont :: Prelude.Int -> IFont a -> Prelude.IO ()
setOutlineFont rHS =
  Automation.propertySet "OutlineFont" [Automation.inInt rHS]
getShadow :: IFont a -> Prelude.IO (Prelude.Int)
getShadow = Automation.propertyGet "Shadow" [] Automation.outInt
setShadow :: Prelude.Int -> IFont a -> Prelude.IO ()
setShadow rHS =
  Automation.propertySet "Shadow" [Automation.inInt rHS]
getSize :: IFont a -> Prelude.IO (Prelude.Int)
getSize = Automation.propertyGet "Size" [] Automation.outInt
setSize :: Prelude.Int -> IFont a -> Prelude.IO ()
setSize rHS = Automation.propertySet "Size" [Automation.inInt rHS]
getStrikethrough :: IFont a -> Prelude.IO (Prelude.Int)
getStrikethrough =
  Automation.propertyGet "Strikethrough" [] Automation.outInt
setStrikethrough :: Prelude.Int -> IFont a -> Prelude.IO ()
setStrikethrough rHS =
  Automation.propertySet "Strikethrough" [Automation.inInt rHS]
getSubscript :: IFont a -> Prelude.IO (Prelude.Int)
getSubscript =
  Automation.propertyGet "Subscript" [] Automation.outInt
setSubscript :: Prelude.Int -> IFont a -> Prelude.IO ()
setSubscript rHS =
  Automation.propertySet "Subscript" [Automation.inInt rHS]
getSuperscript :: IFont a -> Prelude.IO (Prelude.Int)
getSuperscript =
  Automation.propertyGet "Superscript" [] Automation.outInt
setSuperscript :: Prelude.Int -> IFont a -> Prelude.IO ()
setSuperscript rHS =
  Automation.propertySet "Superscript" [Automation.inInt rHS]
getUnderline :: IFont a -> Prelude.IO (Prelude.Int)
getUnderline =
  Automation.propertyGet "Underline" [] Automation.outInt
setUnderline :: Prelude.Int -> IFont a -> Prelude.IO ()
setUnderline rHS =
  Automation.propertySet "Underline" [Automation.inInt rHS]
-- --------------------------------------------------
-- 
-- interface IWindow
-- 
-- --------------------------------------------------
data Window a = Window
                 
type IWindow a = Automation.IDispatch (Window a)
iidIWindow :: Com.IID (IWindow Automation.Interface)
iidIWindow = Com.mkIID "{00020893-0001-0000-C000-000000000046}"
activate :: Automation.IDispatch a -> Prelude.IO ()
activate = Automation.method0 "Activate" []
activateNext :: IWindow a -> Prelude.IO ()
activateNext = Automation.method0 "ActivateNext" []
activatePrevious :: IWindow a -> Prelude.IO ()
activatePrevious = Automation.method0 "ActivatePrevious" []
getActiveCell :: Automation.IDispatch a -> Prelude.IO (IRange Automation.Interface)
getActiveCell =
  Automation.propertyGet "ActiveCell" [] Automation.outIDispatch
getActiveChart :: Automation.IDispatch a -> Prelude.IO (IChart Automation.Interface)
getActiveChart =
  Automation.propertyGet "ActiveChart" [] Automation.outIDispatch
getActivePane :: IWindow a -> Prelude.IO (IPane Automation.Interface)
getActivePane =
  Automation.propertyGet "ActivePane" [] Automation.outIDispatch
getActiveSheet :: Automation.IDispatch a -> Prelude.IO (Automation.IDispatch Automation.Interface)
getActiveSheet =
  Automation.propertyGet "ActiveSheet" [] Automation.outIDispatch
getCaption :: IWindow a -> Prelude.IO (Prelude.Int)
getCaption = Automation.propertyGet "Caption" [] Automation.outInt
setCaption :: Prelude.Int -> IWindow a -> Prelude.IO ()
setCaption rHS =
  Automation.propertySet "Caption" [Automation.inInt rHS]
close :: Prelude.Int -> Prelude.Int -> Prelude.Int -> IWindow a -> Prelude.IO ()
close saveChanges filename routeWorkbook =
  Automation.method0 "Close" [Automation.inInt saveChanges, Automation.inInt filename, Automation.inInt routeWorkbook]
getDisplayFormulas :: IWindow a -> Prelude.IO (Prelude.Int)
getDisplayFormulas =
  Automation.propertyGet "DisplayFormulas" [] Automation.outInt
setDisplayFormulas :: Prelude.Int -> IWindow a -> Prelude.IO ()
setDisplayFormulas rHS =
  Automation.propertySet "DisplayFormulas" [Automation.inInt rHS]
getDisplayGridlines :: IWindow a -> Prelude.IO (Prelude.Int)
getDisplayGridlines =
  Automation.propertyGet "DisplayGridlines" [] Automation.outInt
setDisplayGridlines :: Prelude.Int -> IWindow a -> Prelude.IO ()
setDisplayGridlines rHS =
  Automation.propertySet "DisplayGridlines" [Automation.inInt rHS]
getDisplayHeadings :: IWindow a -> Prelude.IO (Prelude.Int)
getDisplayHeadings =
  Automation.propertyGet "DisplayHeadings" [] Automation.outInt
setDisplayHeadings :: Prelude.Int -> IWindow a -> Prelude.IO ()
setDisplayHeadings rHS =
  Automation.propertySet "DisplayHeadings" [Automation.inInt rHS]
getDisplayHorizontalScrollBar :: IWindow a -> Prelude.IO (Prelude.Int)
getDisplayHorizontalScrollBar =
  Automation.propertyGet "DisplayHorizontalScrollBar" [] Automation.outInt
setDisplayHorizontalScrollBar :: Prelude.Int -> IWindow a -> Prelude.IO ()
setDisplayHorizontalScrollBar rHS =
  Automation.propertySet "DisplayHorizontalScrollBar" [Automation.inInt rHS]
getDisplayOutline :: IWindow a -> Prelude.IO (Prelude.Int)
getDisplayOutline =
  Automation.propertyGet "DisplayOutline" [] Automation.outInt
setDisplayOutline :: Prelude.Int -> IWindow a -> Prelude.IO ()
setDisplayOutline rHS =
  Automation.propertySet "DisplayOutline" [Automation.inInt rHS]
getDisplayRightToLeft :: IWindow a -> Prelude.IO (Prelude.Int)
getDisplayRightToLeft =
  Automation.propertyGet "DisplayRightToLeft" [] Automation.outInt
setDisplayRightToLeft :: Prelude.Int -> IWindow a -> Prelude.IO ()
setDisplayRightToLeft rHS =
  Automation.propertySet "DisplayRightToLeft" [Automation.inInt rHS]
getDisplayVerticalScrollBar :: Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getDisplayVerticalScrollBar =
  Automation.propertyGet "DisplayVerticalScrollBar" [] Automation.outInt
setDisplayVerticalScrollBar :: Prelude.Int -> Automation.IDispatch a -> Prelude.IO ()
setDisplayVerticalScrollBar rHS =
  Automation.propertySet "DisplayVerticalScrollBar" [Automation.inInt rHS]
getDisplayWorkbookTabs :: IWindow a -> Prelude.IO (Prelude.Int)
getDisplayWorkbookTabs =
  Automation.propertyGet "DisplayWorkbookTabs" [] Automation.outInt
setDisplayWorkbookTabs :: Prelude.Int -> IWindow a -> Prelude.IO ()
setDisplayWorkbookTabs rHS =
  Automation.propertySet "DisplayWorkbookTabs" [Automation.inInt rHS]
getDisplayZeros :: IWindow a -> Prelude.IO (Prelude.Int)
getDisplayZeros =
  Automation.propertyGet "DisplayZeros" [] Automation.outInt
setDisplayZeros :: Prelude.Int -> IWindow a -> Prelude.IO ()
setDisplayZeros rHS =
  Automation.propertySet "DisplayZeros" [Automation.inInt rHS]
getEnableResize :: IWindow a -> Prelude.IO (Prelude.Int)
getEnableResize =
  Automation.propertyGet "EnableResize" [] Automation.outInt
setEnableResize :: Prelude.Int -> IWindow a -> Prelude.IO ()
setEnableResize rHS =
  Automation.propertySet "EnableResize" [Automation.inInt rHS]
getFreezePanes :: IWindow a -> Prelude.IO (Prelude.Int)
getFreezePanes =
  Automation.propertyGet "FreezePanes" [] Automation.outInt
setFreezePanes :: Prelude.Int -> IWindow a -> Prelude.IO ()
setFreezePanes rHS =
  Automation.propertySet "FreezePanes" [Automation.inInt rHS]
getGridlineColor :: IWindow a -> Prelude.IO (Prelude.Int)
getGridlineColor =
  Automation.propertyGet "GridlineColor" [] Automation.outInt
setGridlineColor :: Prelude.Int -> IWindow a -> Prelude.IO ()
setGridlineColor rHS =
  Automation.propertySet "GridlineColor" [Automation.inInt rHS]
getGridlineColorIndex :: (Automation.Variant a0) => IWindow a -> Prelude.IO (a0)
getGridlineColorIndex =
  Automation.propertyGet "GridlineColorIndex" [] Automation.outVariant
setGridlineColorIndex :: (Automation.Variant a0) => a0 -> IWindow a -> Prelude.IO ()
setGridlineColorIndex rHS =
  Automation.propertySet "GridlineColorIndex" [Automation.inVariant rHS]
getHeight :: Automation.IDispatch a -> Prelude.IO (Prelude.Double)
getHeight = Automation.propertyGet "Height" [] Automation.outDouble
setHeight :: Prelude.Double -> Automation.IDispatch a -> Prelude.IO ()
setHeight rHS =
  Automation.propertySet "Height" [Automation.inDouble rHS]
getIndex :: Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getIndex = Automation.propertyGet "Index" [] Automation.outInt
largeScroll :: Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Automation.IDispatch a -> Prelude.IO ()
largeScroll down up toRight toLeft =
  Automation.method0 "LargeScroll" [Automation.inInt down, Automation.inInt up, Automation.inInt toRight, Automation.inInt toLeft]
getLeft :: Automation.IDispatch a -> Prelude.IO (Prelude.Double)
getLeft = Automation.propertyGet "Left" [] Automation.outDouble
setLeft :: Prelude.Double -> Automation.IDispatch a -> Prelude.IO ()
setLeft rHS =
  Automation.propertySet "Left" [Automation.inDouble rHS]
newWindow :: IWindow a -> Prelude.IO (VBIDE.IWindow Automation.Interface)
newWindow =
  Automation.function1 "NewWindow" [] Automation.outIDispatch
getOnWindow :: IWindow a -> Prelude.IO (Prelude.String)
getOnWindow =
  Automation.propertyGet "OnWindow" [] Automation.outString
setOnWindow :: Prelude.String -> IWindow a -> Prelude.IO ()
setOnWindow rHS =
  Automation.propertySet "OnWindow" [Automation.inString rHS]
getPanes :: IWindow a -> Prelude.IO (IPanes Automation.Interface)
getPanes =
  Automation.propertyGet "Panes" [] Automation.outIDispatch
printOut :: Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Automation.IDispatch a -> Prelude.IO ()
printOut from to copies preview activePrinter printToFile collate =
  Automation.method0 "PrintOut" [Automation.inInt from, Automation.inInt to, Automation.inInt copies, Automation.inInt preview, Automation.inInt activePrinter, Automation.inInt printToFile, Automation.inInt collate]
printPreview :: Prelude.Int -> Automation.IDispatch a -> Prelude.IO ()
printPreview enableChanges =
  Automation.method0 "PrintPreview" [Automation.inInt enableChanges]
getRangeSelection :: IWindow a -> Prelude.IO (IRange Automation.Interface)
getRangeSelection =
  Automation.propertyGet "RangeSelection" [] Automation.outIDispatch
getScrollColumn :: Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getScrollColumn =
  Automation.propertyGet "ScrollColumn" [] Automation.outInt
setScrollColumn :: Prelude.Int -> Automation.IDispatch a -> Prelude.IO ()
setScrollColumn rHS =
  Automation.propertySet "ScrollColumn" [Automation.inInt rHS]
getScrollRow :: Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getScrollRow =
  Automation.propertyGet "ScrollRow" [] Automation.outInt
setScrollRow :: Prelude.Int -> Automation.IDispatch a -> Prelude.IO ()
setScrollRow rHS =
  Automation.propertySet "ScrollRow" [Automation.inInt rHS]
scrollWorkbookTabs :: Prelude.Int -> Prelude.Int -> IWindow a -> Prelude.IO ()
scrollWorkbookTabs sheets position =
  Automation.method0 "ScrollWorkbookTabs" [Automation.inInt sheets, Automation.inInt position]
getSelectedSheets :: IWindow a -> Prelude.IO (ISheets Automation.Interface)
getSelectedSheets =
  Automation.propertyGet "SelectedSheets" [] Automation.outIDispatch
getSelection :: IWindow a -> Prelude.IO (Automation.IDispatch Automation.Interface)
getSelection =
  Automation.propertyGet "Selection" [] Automation.outIDispatch
smallScroll :: Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Automation.IDispatch a -> Prelude.IO ()
smallScroll down up toRight toLeft =
  Automation.method0 "SmallScroll" [Automation.inInt down, Automation.inInt up, Automation.inInt toRight, Automation.inInt toLeft]
getSplit :: IWindow a -> Prelude.IO (Prelude.Int)
getSplit = Automation.propertyGet "Split" [] Automation.outInt
setSplit :: Prelude.Int -> IWindow a -> Prelude.IO ()
setSplit rHS =
  Automation.propertySet "Split" [Automation.inInt rHS]
getSplitColumn :: IWindow a -> Prelude.IO (Prelude.Int)
getSplitColumn =
  Automation.propertyGet "SplitColumn" [] Automation.outInt
setSplitColumn :: Prelude.Int -> IWindow a -> Prelude.IO ()
setSplitColumn rHS =
  Automation.propertySet "SplitColumn" [Automation.inInt rHS]
getSplitHorizontal :: IWindow a -> Prelude.IO (Prelude.Double)
getSplitHorizontal =
  Automation.propertyGet "SplitHorizontal" [] Automation.outDouble
setSplitHorizontal :: Prelude.Double -> IWindow a -> Prelude.IO ()
setSplitHorizontal rHS =
  Automation.propertySet "SplitHorizontal" [Automation.inDouble rHS]
getSplitRow :: IWindow a -> Prelude.IO (Prelude.Int)
getSplitRow =
  Automation.propertyGet "SplitRow" [] Automation.outInt
setSplitRow :: Prelude.Int -> IWindow a -> Prelude.IO ()
setSplitRow rHS =
  Automation.propertySet "SplitRow" [Automation.inInt rHS]
getSplitVertical :: IWindow a -> Prelude.IO (Prelude.Double)
getSplitVertical =
  Automation.propertyGet "SplitVertical" [] Automation.outDouble
setSplitVertical :: Prelude.Double -> IWindow a -> Prelude.IO ()
setSplitVertical rHS =
  Automation.propertySet "SplitVertical" [Automation.inDouble rHS]
getTabRatio :: IWindow a -> Prelude.IO (Prelude.Double)
getTabRatio =
  Automation.propertyGet "TabRatio" [] Automation.outDouble
setTabRatio :: Prelude.Double -> IWindow a -> Prelude.IO ()
setTabRatio rHS =
  Automation.propertySet "TabRatio" [Automation.inDouble rHS]
getTop :: Automation.IDispatch a -> Prelude.IO (Prelude.Double)
getTop = Automation.propertyGet "Top" [] Automation.outDouble
setTop :: Prelude.Double -> Automation.IDispatch a -> Prelude.IO ()
setTop rHS = Automation.propertySet "Top" [Automation.inDouble rHS]
getType3 :: (Automation.Variant a0) => IWindow a -> Prelude.IO (a0)
getType3 = Automation.propertyGet "Type" [] Automation.outVariant
getUsableHeight :: IWindow a -> Prelude.IO (Prelude.Double)
getUsableHeight =
  Automation.propertyGet "UsableHeight" [] Automation.outDouble
getUsableWidth :: IWindow a -> Prelude.IO (Prelude.Double)
getUsableWidth =
  Automation.propertyGet "UsableWidth" [] Automation.outDouble
getVisible3 :: Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getVisible3 = Automation.propertyGet "Visible" [] Automation.outInt
setVisible3 :: Prelude.Int -> Automation.IDispatch a -> Prelude.IO ()
setVisible3 rHS =
  Automation.propertySet "Visible" [Automation.inInt rHS]
getVisibleRange :: Automation.IDispatch a -> Prelude.IO (IRange Automation.Interface)
getVisibleRange =
  Automation.propertyGet "VisibleRange" [] Automation.outIDispatch
getWidth :: Automation.IDispatch a -> Prelude.IO (Prelude.Double)
getWidth = Automation.propertyGet "Width" [] Automation.outDouble
setWidth :: Prelude.Double -> Automation.IDispatch a -> Prelude.IO ()
setWidth rHS =
  Automation.propertySet "Width" [Automation.inDouble rHS]
getWindowNumber :: IWindow a -> Prelude.IO (Prelude.Int)
getWindowNumber =
  Automation.propertyGet "WindowNumber" [] Automation.outInt
getWindowState :: (Automation.Variant a0) => IWindow a -> Prelude.IO (a0)
getWindowState =
  Automation.propertyGet "WindowState" [] Automation.outVariant
setWindowState :: (Automation.Variant a0) => a0 -> IWindow a -> Prelude.IO ()
setWindowState rHS =
  Automation.propertySet "WindowState" [Automation.inVariant rHS]
getZoom :: Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getZoom = Automation.propertyGet "Zoom" [] Automation.outInt
setZoom :: Prelude.Int -> Automation.IDispatch a -> Prelude.IO ()
setZoom rHS = Automation.propertySet "Zoom" [Automation.inInt rHS]
getView :: (Automation.Variant a0) => IWindow a -> Prelude.IO (a0)
getView = Automation.propertyGet "View" [] Automation.outVariant
setView :: (Automation.Variant a0) => a0 -> IWindow a -> Prelude.IO ()
setView rHS =
  Automation.propertySet "View" [Automation.inVariant rHS]
-- --------------------------------------------------
-- 
-- interface IWindows
-- 
-- --------------------------------------------------
data Windows a = Windows
                  
type IWindows a = Automation.IDispatch (Windows a)
iidIWindows :: Com.IID (IWindows Automation.Interface)
iidIWindows = Com.mkIID "{00020892-0001-0000-C000-000000000046}"
arrange :: (Automation.Variant a0) => a0 -> Prelude.Int -> Prelude.Int -> Prelude.Int -> IWindows a -> Prelude.IO ()
arrange arrangeStyle activeWorkbook syncHorizontal syncVertical =
  Automation.method0 "Arrange" [Automation.inVariant arrangeStyle, Automation.inInt activeWorkbook, Automation.inInt syncHorizontal, Automation.inInt syncVertical]
getItem0 :: Prelude.Int -> IWindows a -> Prelude.IO (VBIDE.IWindow Automation.Interface)
getItem0 index =
  Automation.propertyGet "Item" [Automation.inInt index] Automation.outIDispatch
getDefault :: Prelude.Int -> IWindows a -> Prelude.IO (VBIDE.IWindow Automation.Interface)
getDefault index =
  Automation.propertyGet "_Default" [Automation.inInt index] Automation.outIDispatch
-- --------------------------------------------------
-- 
-- interface IAppEvents
-- 
-- --------------------------------------------------
data AppEvents a = AppEvents
                    
type IAppEvents a = Automation.IDispatch (AppEvents a)
iidIAppEvents :: Com.IID (IAppEvents Automation.Interface)
iidIAppEvents = Com.mkIID "{00024413-0001-0000-C000-000000000046}"
newWorkbook :: IWorkbook a0 -> IAppEvents a -> Prelude.IO ()
newWorkbook wb =
  Automation.method0 "NewWorkbook" [Automation.inIDispatch wb]
sheetSelectionChange :: Automation.IDispatch a0 -> IRange a1 -> Automation.IDispatch a -> Prelude.IO ()
sheetSelectionChange sh target =
  Automation.method0 "SheetSelectionChange" [Automation.inIDispatch sh, Automation.inIDispatch target]
sheetBeforeDoubleClick :: Automation.IDispatch a0 -> IRange a1 -> Prelude.Int -> Automation.IDispatch a -> Prelude.IO ()
sheetBeforeDoubleClick sh target cancel =
  Automation.method0 "SheetBeforeDoubleClick" [Automation.inIDispatch sh, Automation.inIDispatch target, Automation.inInt cancel]
sheetBeforeRightClick :: Automation.IDispatch a0 -> IRange a1 -> Prelude.Int -> Automation.IDispatch a -> Prelude.IO ()
sheetBeforeRightClick sh target cancel =
  Automation.method0 "SheetBeforeRightClick" [Automation.inIDispatch sh, Automation.inIDispatch target, Automation.inInt cancel]
sheetActivate :: Automation.IDispatch a0 -> Automation.IDispatch a -> Prelude.IO ()
sheetActivate sh =
  Automation.method0 "SheetActivate" [Automation.inIDispatch sh]
sheetDeactivate :: Automation.IDispatch a0 -> Automation.IDispatch a -> Prelude.IO ()
sheetDeactivate sh =
  Automation.method0 "SheetDeactivate" [Automation.inIDispatch sh]
sheetCalculate :: Automation.IDispatch a0 -> Automation.IDispatch a -> Prelude.IO ()
sheetCalculate sh =
  Automation.method0 "SheetCalculate" [Automation.inIDispatch sh]
sheetChange :: Automation.IDispatch a0 -> IRange a1 -> Automation.IDispatch a -> Prelude.IO ()
sheetChange sh target =
  Automation.method0 "SheetChange" [Automation.inIDispatch sh, Automation.inIDispatch target]
workbookOpen :: IWorkbook a0 -> IAppEvents a -> Prelude.IO ()
workbookOpen wb =
  Automation.method0 "WorkbookOpen" [Automation.inIDispatch wb]
workbookActivate :: IWorkbook a0 -> IAppEvents a -> Prelude.IO ()
workbookActivate wb =
  Automation.method0 "WorkbookActivate" [Automation.inIDispatch wb]
workbookDeactivate :: IWorkbook a0 -> IAppEvents a -> Prelude.IO ()
workbookDeactivate wb =
  Automation.method0 "WorkbookDeactivate" [Automation.inIDispatch wb]
workbookBeforeClose :: IWorkbook a0 -> Prelude.Int -> IAppEvents a -> Prelude.IO ()
workbookBeforeClose wb cancel =
  Automation.method0 "WorkbookBeforeClose" [Automation.inIDispatch wb, Automation.inInt cancel]
workbookBeforeSave :: IWorkbook a0 -> Prelude.Int -> Prelude.Int -> IAppEvents a -> Prelude.IO ()
workbookBeforeSave wb saveAsUI cancel =
  Automation.method0 "WorkbookBeforeSave" [Automation.inIDispatch wb, Automation.inInt saveAsUI, Automation.inInt cancel]
workbookBeforePrint :: IWorkbook a0 -> Prelude.Int -> IAppEvents a -> Prelude.IO ()
workbookBeforePrint wb cancel =
  Automation.method0 "WorkbookBeforePrint" [Automation.inIDispatch wb, Automation.inInt cancel]
workbookNewSheet :: IWorkbook a0 -> Automation.IDispatch a1 -> IAppEvents a -> Prelude.IO ()
workbookNewSheet wb sh =
  Automation.method0 "WorkbookNewSheet" [Automation.inIDispatch wb, Automation.inIDispatch sh]
workbookAddinInstall :: IWorkbook a0 -> IAppEvents a -> Prelude.IO ()
workbookAddinInstall wb =
  Automation.method0 "WorkbookAddinInstall" [Automation.inIDispatch wb]
workbookAddinUninstall :: IWorkbook a0 -> IAppEvents a -> Prelude.IO ()
workbookAddinUninstall wb =
  Automation.method0 "WorkbookAddinUninstall" [Automation.inIDispatch wb]
windowResize :: IWorkbook a0 -> VBIDE.IWindow a1 -> IAppEvents a -> Prelude.IO ()
windowResize wb wn =
  Automation.method0 "WindowResize" [Automation.inIDispatch wb, Automation.inIDispatch wn]
windowActivate :: IWorkbook a0 -> VBIDE.IWindow a1 -> IAppEvents a -> Prelude.IO ()
windowActivate wb wn =
  Automation.method0 "WindowActivate" [Automation.inIDispatch wb, Automation.inIDispatch wn]
windowDeactivate :: IWorkbook a0 -> VBIDE.IWindow a1 -> IAppEvents a -> Prelude.IO ()
windowDeactivate wb wn =
  Automation.method0 "WindowDeactivate" [Automation.inIDispatch wb, Automation.inIDispatch wn]
-- --------------------------------------------------
-- 
-- interface Application
-- 
-- --------------------------------------------------
data Application a = Application
                      
type IApplication a = Automation.IDispatch (Application a)
iidIApplication :: Com.IID (IApplication Automation.Interface)
iidIApplication =
  Com.mkIID "{000208D5-0000-0000-C000-000000000046}"
getApplication13 :: Automation.IDispatch a -> Prelude.IO (IApplication Automation.Interface)
getApplication13 =
  Automation.propertyGetID 0x94 [] Automation.outIDispatch
getParent13 :: Automation.IDispatch a -> Prelude.IO (IApplication Automation.Interface)
getParent13 =
  Automation.propertyGetID 0x96 [] Automation.outIDispatch
getActiveDialog :: Automation.IDispatch a -> Prelude.IO (IDialogSheet Automation.Interface)
getActiveDialog =
  Automation.propertyGetID 0x32f [] Automation.outIDispatch
getActiveMenuBar :: Automation.IDispatch a -> Prelude.IO (IMenuBar Automation.Interface)
getActiveMenuBar =
  Automation.propertyGetID 0x2f6 [] Automation.outIDispatch
getActivePrinter :: Prelude.Int -> Automation.IDispatch a -> Prelude.IO (Prelude.String)
getActivePrinter lcid =
  Automation.propertyGetID 0x132 [Automation.inInt lcid] Automation.outString
setActivePrinter :: Prelude.Int -> Prelude.String -> Automation.IDispatch a -> Prelude.IO ()
setActivePrinter lcid rHS =
  Automation.propertySetID 0x132 [Automation.inInt lcid, Automation.inString rHS]
getActiveWindow :: Automation.IDispatch a -> Prelude.IO (VBIDE.IWindow Automation.Interface)
getActiveWindow =
  Automation.propertyGetID 0x2f7 [] Automation.outIDispatch
getActiveWorkbook :: Automation.IDispatch a -> Prelude.IO (IWorkbook Automation.Interface)
getActiveWorkbook =
  Automation.propertyGetID 0x134 [] Automation.outIDispatch
getAddIns :: Automation.IDispatch a -> Prelude.IO (IAddIns Automation.Interface)
getAddIns =
  Automation.propertyGetID 0x225 [] Automation.outIDispatch
getAssistant :: Automation.IDispatch a -> Prelude.IO (Office.IAssistant Automation.Interface)
getAssistant =
  Automation.propertyGetID 0x59e [] Automation.outIDispatch
calculate :: Prelude.Int -> Automation.IDispatch a -> Prelude.IO ()
calculate lcid = Automation.methodID0 0x117 [Automation.inInt lcid]
getCells :: Automation.IDispatch a -> Prelude.IO (IRange Automation.Interface)
getCells = Automation.propertyGetID 0xee [] Automation.outIDispatch
getCharts :: Automation.IDispatch a -> Prelude.IO (ISheets Automation.Interface)
getCharts =
  Automation.propertyGetID 0x79 [] Automation.outIDispatch
getColumns :: Automation.IDispatch a -> Prelude.IO (IRange Automation.Interface)
getColumns =
  Automation.propertyGetID 0xf1 [] Automation.outIDispatch
getCommandBars :: Automation.IDispatch a -> Prelude.IO (Office.ICommandBars Automation.Interface)
getCommandBars =
  Automation.propertyGetID 0x59f [] Automation.outIDispatch
getDDEAppReturnCode :: Prelude.Int -> Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getDDEAppReturnCode lcid =
  Automation.propertyGetID 0x14c [Automation.inInt lcid] Automation.outInt
dDEExecute :: Prelude.Int -> Prelude.String -> Prelude.Int -> Automation.IDispatch a -> Prelude.IO ()
dDEExecute channel string lcid =
  Automation.methodID0 0x14d [Automation.inInt channel, Automation.inString string, Automation.inInt lcid]
dDEInitiate :: Prelude.String -> Prelude.String -> Prelude.Int -> Automation.IDispatch a -> Prelude.IO (Prelude.Int)
dDEInitiate app topic lcid =
  Automation.functionID1 0x14e [Automation.inString app, Automation.inString topic, Automation.inInt lcid] Automation.outInt
dDEPoke :: Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Automation.IDispatch a -> Prelude.IO ()
dDEPoke channel item data0 lcid =
  Automation.methodID0 0x14f [Automation.inInt channel, Automation.inInt item, Automation.inInt data0, Automation.inInt lcid]
dDERequest :: Prelude.Int -> Prelude.String -> Prelude.Int -> Automation.IDispatch a -> Prelude.IO (Prelude.Int)
dDERequest channel item lcid =
  Automation.functionID1 0x150 [Automation.inInt channel, Automation.inString item, Automation.inInt lcid] Automation.outInt
dDETerminate :: Prelude.Int -> Prelude.Int -> Automation.IDispatch a -> Prelude.IO ()
dDETerminate channel lcid =
  Automation.methodID0 0x151 [Automation.inInt channel, Automation.inInt lcid]
getDialogSheets :: Automation.IDispatch a -> Prelude.IO (ISheets Automation.Interface)
getDialogSheets =
  Automation.propertyGetID 0x2fc [] Automation.outIDispatch
evaluate :: Prelude.Int -> Prelude.Int -> Automation.IDispatch a -> Prelude.IO (Prelude.Int)
evaluate name lcid =
  Automation.functionID1 0x1 [Automation.inInt name, Automation.inInt lcid] Automation.outInt
evaluate0 :: Prelude.Int -> Prelude.Int -> Automation.IDispatch a -> Prelude.IO (Prelude.Int)
evaluate0 name lcid =
  Automation.functionID1 0xfffffffb [Automation.inInt name, Automation.inInt lcid] Automation.outInt
executeExcel4Macro :: Prelude.String -> Prelude.Int -> Automation.IDispatch a -> Prelude.IO (Prelude.Int)
executeExcel4Macro string lcid =
  Automation.functionID1 0x15e [Automation.inString string, Automation.inInt lcid] Automation.outInt
intersect :: IRange a0 -> IRange a1 -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Automation.IDispatch a -> Prelude.IO (IRange Automation.Interface)
intersect arg1 arg2 arg3 arg4 arg5 arg6 arg7 arg8 arg9 arg10 arg11 arg12 arg13 arg14 arg15 arg16 arg17 arg18 arg19 arg20 arg21 arg22 arg23 arg24 arg25 arg26 arg27 arg28 arg29 arg30 lcid =
  Automation.functionID1 0x2fe [Automation.inIDispatch arg1, Automation.inIDispatch arg2, Automation.inInt arg3, Automation.inInt arg4, Automation.inInt arg5, Automation.inInt arg6, Automation.inInt arg7, Automation.inInt arg8, Automation.inInt arg9, Automation.inInt arg10, Automation.inInt arg11, Automation.inInt arg12, Automation.inInt arg13, Automation.inInt arg14, Automation.inInt arg15, Automation.inInt arg16, Automation.inInt arg17, Automation.inInt arg18, Automation.inInt arg19, Automation.inInt arg20, Automation.inInt arg21, Automation.inInt arg22, Automation.inInt arg23, Automation.inInt arg24, Automation.inInt arg25, Automation.inInt arg26, Automation.inInt arg27, Automation.inInt arg28, Automation.inInt arg29, Automation.inInt arg30, Automation.inInt lcid] Automation.outIDispatch
getMenuBars :: Automation.IDispatch a -> Prelude.IO (IMenuBars Automation.Interface)
getMenuBars =
  Automation.propertyGetID 0x24d [] Automation.outIDispatch
getModules :: Automation.IDispatch a -> Prelude.IO (IModules Automation.Interface)
getModules =
  Automation.propertyGetID 0x246 [] Automation.outIDispatch
getNames :: Automation.IDispatch a -> Prelude.IO (INames Automation.Interface)
getNames =
  Automation.propertyGetID 0x1ba [] Automation.outIDispatch
getRange :: Prelude.Int -> Prelude.Int -> Automation.IDispatch a -> Prelude.IO (IRange Automation.Interface)
getRange cell1 cell2 =
  Automation.propertyGetID 0xc5 [Automation.inInt cell1, Automation.inInt cell2] Automation.outIDispatch
getRows :: Automation.IDispatch a -> Prelude.IO (IRange Automation.Interface)
getRows = Automation.propertyGetID 0x102 [] Automation.outIDispatch
run :: Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Automation.IDispatch a -> Prelude.IO (Prelude.Int)
run macro arg1 arg2 arg3 arg4 arg5 arg6 arg7 arg8 arg9 arg10 arg11 arg12 arg13 arg14 arg15 arg16 arg17 arg18 arg19 arg20 arg21 arg22 arg23 arg24 arg25 arg26 arg27 arg28 arg29 arg30 =
  Automation.functionID1 0x103 [Automation.inInt macro, Automation.inInt arg1, Automation.inInt arg2, Automation.inInt arg3, Automation.inInt arg4, Automation.inInt arg5, Automation.inInt arg6, Automation.inInt arg7, Automation.inInt arg8, Automation.inInt arg9, Automation.inInt arg10, Automation.inInt arg11, Automation.inInt arg12, Automation.inInt arg13, Automation.inInt arg14, Automation.inInt arg15, Automation.inInt arg16, Automation.inInt arg17, Automation.inInt arg18, Automation.inInt arg19, Automation.inInt arg20, Automation.inInt arg21, Automation.inInt arg22, Automation.inInt arg23, Automation.inInt arg24, Automation.inInt arg25, Automation.inInt arg26, Automation.inInt arg27, Automation.inInt arg28, Automation.inInt arg29, Automation.inInt arg30] Automation.outInt
run2 :: Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Automation.IDispatch a -> Prelude.IO (Prelude.Int)
run2 macro arg1 arg2 arg3 arg4 arg5 arg6 arg7 arg8 arg9 arg10 arg11 arg12 arg13 arg14 arg15 arg16 arg17 arg18 arg19 arg20 arg21 arg22 arg23 arg24 arg25 arg26 arg27 arg28 arg29 arg30 lcid =
  Automation.functionID1 0x326 [Automation.inInt macro, Automation.inInt arg1, Automation.inInt arg2, Automation.inInt arg3, Automation.inInt arg4, Automation.inInt arg5, Automation.inInt arg6, Automation.inInt arg7, Automation.inInt arg8, Automation.inInt arg9, Automation.inInt arg10, Automation.inInt arg11, Automation.inInt arg12, Automation.inInt arg13, Automation.inInt arg14, Automation.inInt arg15, Automation.inInt arg16, Automation.inInt arg17, Automation.inInt arg18, Automation.inInt arg19, Automation.inInt arg20, Automation.inInt arg21, Automation.inInt arg22, Automation.inInt arg23, Automation.inInt arg24, Automation.inInt arg25, Automation.inInt arg26, Automation.inInt arg27, Automation.inInt arg28, Automation.inInt arg29, Automation.inInt arg30, Automation.inInt lcid] Automation.outInt
getSelection0 :: Prelude.Int -> Automation.IDispatch a -> Prelude.IO (Automation.IDispatch Automation.Interface)
getSelection0 lcid =
  Automation.propertyGetID 0x93 [Automation.inInt lcid] Automation.outIDispatch
sendKeys :: Prelude.Int -> Prelude.Int -> Prelude.Int -> Automation.IDispatch a -> Prelude.IO ()
sendKeys keys wait lcid =
  Automation.methodID0 0x17f [Automation.inInt keys, Automation.inInt wait, Automation.inInt lcid]
getSheets :: Automation.IDispatch a -> Prelude.IO (ISheets Automation.Interface)
getSheets =
  Automation.propertyGetID 0x1e5 [] Automation.outIDispatch
getShortcutMenus :: Prelude.Int -> Automation.IDispatch a -> Prelude.IO (IMenu Automation.Interface)
getShortcutMenus index =
  Automation.propertyGetID 0x308 [Automation.inInt index] Automation.outIDispatch
getThisWorkbook :: Prelude.Int -> Automation.IDispatch a -> Prelude.IO (IWorkbook Automation.Interface)
getThisWorkbook lcid =
  Automation.propertyGetID 0x30a [Automation.inInt lcid] Automation.outIDispatch
getToolbars :: Automation.IDispatch a -> Prelude.IO (IToolbars Automation.Interface)
getToolbars =
  Automation.propertyGetID 0x228 [] Automation.outIDispatch
union :: IRange a0 -> IRange a1 -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Automation.IDispatch a -> Prelude.IO (IRange Automation.Interface)
union arg1 arg2 arg3 arg4 arg5 arg6 arg7 arg8 arg9 arg10 arg11 arg12 arg13 arg14 arg15 arg16 arg17 arg18 arg19 arg20 arg21 arg22 arg23 arg24 arg25 arg26 arg27 arg28 arg29 arg30 lcid =
  Automation.functionID1 0x30b [Automation.inIDispatch arg1, Automation.inIDispatch arg2, Automation.inInt arg3, Automation.inInt arg4, Automation.inInt arg5, Automation.inInt arg6, Automation.inInt arg7, Automation.inInt arg8, Automation.inInt arg9, Automation.inInt arg10, Automation.inInt arg11, Automation.inInt arg12, Automation.inInt arg13, Automation.inInt arg14, Automation.inInt arg15, Automation.inInt arg16, Automation.inInt arg17, Automation.inInt arg18, Automation.inInt arg19, Automation.inInt arg20, Automation.inInt arg21, Automation.inInt arg22, Automation.inInt arg23, Automation.inInt arg24, Automation.inInt arg25, Automation.inInt arg26, Automation.inInt arg27, Automation.inInt arg28, Automation.inInt arg29, Automation.inInt arg30, Automation.inInt lcid] Automation.outIDispatch
getWindows :: Automation.IDispatch a -> Prelude.IO (IWindows Automation.Interface)
getWindows =
  Automation.propertyGetID 0x1ae [] Automation.outIDispatch
getWorkbooks :: Automation.IDispatch a -> Prelude.IO (IWorkbooks Automation.Interface)
getWorkbooks =
  Automation.propertyGetID 0x23c [] Automation.outIDispatch
getWorksheetFunction :: Automation.IDispatch a -> Prelude.IO (IWorksheetFunction Automation.Interface)
getWorksheetFunction =
  Automation.propertyGetID 0x5a0 [] Automation.outIDispatch
getWorksheets :: Automation.IDispatch a -> Prelude.IO (ISheets Automation.Interface)
getWorksheets =
  Automation.propertyGetID 0x1ee [] Automation.outIDispatch
getExcel4IntlMacroSheets :: Automation.IDispatch a -> Prelude.IO (ISheets Automation.Interface)
getExcel4IntlMacroSheets =
  Automation.propertyGetID 0x245 [] Automation.outIDispatch
getExcel4MacroSheets :: Automation.IDispatch a -> Prelude.IO (ISheets Automation.Interface)
getExcel4MacroSheets =
  Automation.propertyGetID 0x243 [] Automation.outIDispatch
activateMicrosoftApp :: (Automation.Variant a0) => a0 -> Prelude.Int -> IApplication a -> Prelude.IO ()
activateMicrosoftApp index lcid =
  Automation.methodID0 0x447 [Automation.inVariant index, Automation.inInt lcid]
addChartAutoFormat :: Prelude.Int -> Prelude.String -> Prelude.Int -> Prelude.Int -> IApplication a -> Prelude.IO ()
addChartAutoFormat chart name description lcid =
  Automation.methodID0 0xd8 [Automation.inInt chart, Automation.inString name, Automation.inInt description, Automation.inInt lcid]
addCustomList :: Prelude.Int -> Prelude.Int -> Prelude.Int -> IApplication a -> Prelude.IO ()
addCustomList listArray byRow lcid =
  Automation.methodID0 0x30c [Automation.inInt listArray, Automation.inInt byRow, Automation.inInt lcid]
getAlertBeforeOverwriting :: Prelude.Int -> IApplication a -> Prelude.IO (Prelude.Int)
getAlertBeforeOverwriting lcid =
  Automation.propertyGetID 0x3a2 [Automation.inInt lcid] Automation.outInt
setAlertBeforeOverwriting :: Prelude.Int -> Prelude.Int -> IApplication a -> Prelude.IO ()
setAlertBeforeOverwriting lcid rHS =
  Automation.propertySetID 0x3a2 [Automation.inInt lcid, Automation.inInt rHS]
getAltStartupPath :: Prelude.Int -> IApplication a -> Prelude.IO (Prelude.String)
getAltStartupPath lcid =
  Automation.propertyGetID 0x139 [Automation.inInt lcid] Automation.outString
setAltStartupPath :: Prelude.Int -> Prelude.String -> IApplication a -> Prelude.IO ()
setAltStartupPath lcid rHS =
  Automation.propertySetID 0x139 [Automation.inInt lcid, Automation.inString rHS]
getAskToUpdateLinks :: Prelude.Int -> IApplication a -> Prelude.IO (Prelude.Int)
getAskToUpdateLinks lcid =
  Automation.propertyGetID 0x3e0 [Automation.inInt lcid] Automation.outInt
setAskToUpdateLinks :: Prelude.Int -> Prelude.Int -> IApplication a -> Prelude.IO ()
setAskToUpdateLinks lcid rHS =
  Automation.propertySetID 0x3e0 [Automation.inInt lcid, Automation.inInt rHS]
getEnableAnimations :: Prelude.Int -> IApplication a -> Prelude.IO (Prelude.Int)
getEnableAnimations lcid =
  Automation.propertyGetID 0x49c [Automation.inInt lcid] Automation.outInt
setEnableAnimations :: Prelude.Int -> Prelude.Int -> IApplication a -> Prelude.IO ()
setEnableAnimations lcid rHS =
  Automation.propertySetID 0x49c [Automation.inInt lcid, Automation.inInt rHS]
getAutoCorrect :: IApplication a -> Prelude.IO (IAutoCorrect Automation.Interface)
getAutoCorrect =
  Automation.propertyGetID 0x479 [] Automation.outIDispatch
getBuild :: Prelude.Int -> IApplication a -> Prelude.IO (Prelude.Int)
getBuild lcid =
  Automation.propertyGetID 0x13a [Automation.inInt lcid] Automation.outInt
getCalculateBeforeSave :: Prelude.Int -> IApplication a -> Prelude.IO (Prelude.Int)
getCalculateBeforeSave lcid =
  Automation.propertyGetID 0x13b [Automation.inInt lcid] Automation.outInt
setCalculateBeforeSave :: Prelude.Int -> Prelude.Int -> IApplication a -> Prelude.IO ()
setCalculateBeforeSave lcid rHS =
  Automation.propertySetID 0x13b [Automation.inInt lcid, Automation.inInt rHS]
getCalculation :: (Automation.Variant a0) => Prelude.Int -> IApplication a -> Prelude.IO (a0)
getCalculation lcid =
  Automation.propertyGetID 0x13c [Automation.inInt lcid] Automation.outVariant
setCalculation :: (Automation.Variant a0) => Prelude.Int -> a0 -> IApplication a -> Prelude.IO ()
setCalculation lcid rHS =
  Automation.propertySetID 0x13c [Automation.inInt lcid, Automation.inVariant rHS]
getCaller :: Prelude.Int -> Prelude.Int -> IApplication a -> Prelude.IO (Prelude.Int)
getCaller index lcid =
  Automation.propertyGetID 0x13d [Automation.inInt index, Automation.inInt lcid] Automation.outInt
getCanPlaySounds :: Prelude.Int -> IApplication a -> Prelude.IO (Prelude.Int)
getCanPlaySounds lcid =
  Automation.propertyGetID 0x13e [Automation.inInt lcid] Automation.outInt
getCanRecordSounds :: Prelude.Int -> IApplication a -> Prelude.IO (Prelude.Int)
getCanRecordSounds lcid =
  Automation.propertyGetID 0x13f [Automation.inInt lcid] Automation.outInt
getCaption0 :: Automation.IDispatch a -> Prelude.IO (Prelude.String)
getCaption0 = Automation.propertyGetID 0x8b [] Automation.outString
setCaption0 :: Prelude.String -> Automation.IDispatch a -> Prelude.IO ()
setCaption0 rHS =
  Automation.propertySetID 0x8b [Automation.inString rHS]
getCellDragAndDrop :: Prelude.Int -> IApplication a -> Prelude.IO (Prelude.Int)
getCellDragAndDrop lcid =
  Automation.propertyGetID 0x140 [Automation.inInt lcid] Automation.outInt
setCellDragAndDrop :: Prelude.Int -> Prelude.Int -> IApplication a -> Prelude.IO ()
setCellDragAndDrop lcid rHS =
  Automation.propertySetID 0x140 [Automation.inInt lcid, Automation.inInt rHS]
centimetersToPoints :: Prelude.Double -> Prelude.Int -> IApplication a -> Prelude.IO (Prelude.Double)
centimetersToPoints centimeters lcid =
  Automation.functionID1 0x43e [Automation.inDouble centimeters, Automation.inInt lcid] Automation.outDouble
checkSpelling :: Prelude.String -> Prelude.Int -> Prelude.Int -> Prelude.Int -> IApplication a -> Prelude.IO (Prelude.Int)
checkSpelling word customDictionary ignoreUppercase lcid =
  Automation.functionID1 0x1f9 [Automation.inString word, Automation.inInt customDictionary, Automation.inInt ignoreUppercase, Automation.inInt lcid] Automation.outInt
getClipboardFormats :: Prelude.Int -> Prelude.Int -> IApplication a -> Prelude.IO (Prelude.Int)
getClipboardFormats index lcid =
  Automation.propertyGetID 0x141 [Automation.inInt index, Automation.inInt lcid] Automation.outInt
getDisplayClipboardWindow :: Prelude.Int -> IApplication a -> Prelude.IO (Prelude.Int)
getDisplayClipboardWindow lcid =
  Automation.propertyGetID 0x142 [Automation.inInt lcid] Automation.outInt
setDisplayClipboardWindow :: Prelude.Int -> Prelude.Int -> IApplication a -> Prelude.IO ()
setDisplayClipboardWindow lcid rHS =
  Automation.propertySetID 0x142 [Automation.inInt lcid, Automation.inInt rHS]
getColorButtons :: IApplication a -> Prelude.IO (Prelude.Int)
getColorButtons =
  Automation.propertyGetID 0x16d [] Automation.outInt
setColorButtons :: Prelude.Int -> IApplication a -> Prelude.IO ()
setColorButtons rHS =
  Automation.propertySetID 0x16d [Automation.inInt rHS]
getCommandUnderlines :: (Automation.Variant a0) => Prelude.Int -> IApplication a -> Prelude.IO (a0)
getCommandUnderlines lcid =
  Automation.propertyGetID 0x143 [Automation.inInt lcid] Automation.outVariant
setCommandUnderlines :: (Automation.Variant a0) => Prelude.Int -> a0 -> IApplication a -> Prelude.IO ()
setCommandUnderlines lcid rHS =
  Automation.propertySetID 0x143 [Automation.inInt lcid, Automation.inVariant rHS]
getConstrainNumeric :: Prelude.Int -> IApplication a -> Prelude.IO (Prelude.Int)
getConstrainNumeric lcid =
  Automation.propertyGetID 0x144 [Automation.inInt lcid] Automation.outInt
setConstrainNumeric :: Prelude.Int -> Prelude.Int -> IApplication a -> Prelude.IO ()
setConstrainNumeric lcid rHS =
  Automation.propertySetID 0x144 [Automation.inInt lcid, Automation.inInt rHS]
convertFormula :: (Automation.Variant a0) => Prelude.Int -> a0 -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> IApplication a -> Prelude.IO (Prelude.Int)
convertFormula formula fromReferenceStyle toReferenceStyle toAbsolute relativeTo lcid =
  Automation.functionID1 0x145 [Automation.inInt formula, Automation.inVariant fromReferenceStyle, Automation.inInt toReferenceStyle, Automation.inInt toAbsolute, Automation.inInt relativeTo, Automation.inInt lcid] Automation.outInt
getCopyObjectsWithCells :: Prelude.Int -> IApplication a -> Prelude.IO (Prelude.Int)
getCopyObjectsWithCells lcid =
  Automation.propertyGetID 0x3df [Automation.inInt lcid] Automation.outInt
setCopyObjectsWithCells :: Prelude.Int -> Prelude.Int -> IApplication a -> Prelude.IO ()
setCopyObjectsWithCells lcid rHS =
  Automation.propertySetID 0x3df [Automation.inInt lcid, Automation.inInt rHS]
getCursor :: (Automation.Variant a0) => Prelude.Int -> IApplication a -> Prelude.IO (a0)
getCursor lcid =
  Automation.propertyGetID 0x489 [Automation.inInt lcid] Automation.outVariant
setCursor :: (Automation.Variant a0) => Prelude.Int -> a0 -> IApplication a -> Prelude.IO ()
setCursor lcid rHS =
  Automation.propertySetID 0x489 [Automation.inInt lcid, Automation.inVariant rHS]
getCustomListCount :: Prelude.Int -> IApplication a -> Prelude.IO (Prelude.Int)
getCustomListCount lcid =
  Automation.propertyGetID 0x313 [Automation.inInt lcid] Automation.outInt
getCutCopyMode :: (Automation.Variant a0) => Prelude.Int -> IApplication a -> Prelude.IO (a0)
getCutCopyMode lcid =
  Automation.propertyGetID 0x14a [Automation.inInt lcid] Automation.outVariant
setCutCopyMode :: (Automation.Variant a0) => Prelude.Int -> a0 -> IApplication a -> Prelude.IO ()
setCutCopyMode lcid rHS =
  Automation.propertySetID 0x14a [Automation.inInt lcid, Automation.inVariant rHS]
getDataEntryMode :: Prelude.Int -> IApplication a -> Prelude.IO (Prelude.Int)
getDataEntryMode lcid =
  Automation.propertyGetID 0x14b [Automation.inInt lcid] Automation.outInt
setDataEntryMode :: Prelude.Int -> Prelude.Int -> IApplication a -> Prelude.IO ()
setDataEntryMode lcid rHS =
  Automation.propertySetID 0x14b [Automation.inInt lcid, Automation.inInt rHS]
dummy1 :: IApplication a -> Prelude.IO ()
dummy1 = Automation.methodID0 0x6e7 []
dummy2 :: IApplication a -> Prelude.IO ()
dummy2 = Automation.methodID0 0x6e8 []
dummy3 :: IApplication a -> Prelude.IO ()
dummy3 = Automation.methodID0 0x6e9 []
dummy4 :: IApplication a -> Prelude.IO ()
dummy4 = Automation.methodID0 0x6ea []
dummy5 :: IApplication a -> Prelude.IO ()
dummy5 = Automation.methodID0 0x6eb []
dummy6 :: IApplication a -> Prelude.IO ()
dummy6 = Automation.methodID0 0x6ec []
dummy7 :: IApplication a -> Prelude.IO ()
dummy7 = Automation.methodID0 0x6ed []
dummy8 :: IApplication a -> Prelude.IO ()
dummy8 = Automation.methodID0 0x6ee []
dummy9 :: IApplication a -> Prelude.IO ()
dummy9 = Automation.methodID0 0x6ef []
dummy10 :: IApplication a -> Prelude.IO ()
dummy10 = Automation.methodID0 0x6f0 []
dummy11 :: IApplication a -> Prelude.IO ()
dummy11 = Automation.methodID0 0x6f1 []
getDefault0 :: Automation.IDispatch a -> Prelude.IO (Prelude.String)
getDefault0 = Automation.propertyGetID 0o0 [] Automation.outString
getDefaultFilePath :: Prelude.Int -> IApplication a -> Prelude.IO (Prelude.String)
getDefaultFilePath lcid =
  Automation.propertyGetID 0x40e [Automation.inInt lcid] Automation.outString
setDefaultFilePath :: Prelude.Int -> Prelude.String -> IApplication a -> Prelude.IO ()
setDefaultFilePath lcid rHS =
  Automation.propertySetID 0x40e [Automation.inInt lcid, Automation.inString rHS]
deleteChartAutoFormat :: Prelude.String -> Prelude.Int -> IApplication a -> Prelude.IO ()
deleteChartAutoFormat name lcid =
  Automation.methodID0 0xd9 [Automation.inString name, Automation.inInt lcid]
deleteCustomList :: Prelude.Int -> Prelude.Int -> IApplication a -> Prelude.IO ()
deleteCustomList listNum lcid =
  Automation.methodID0 0x30f [Automation.inInt listNum, Automation.inInt lcid]
getDialogs :: IApplication a -> Prelude.IO (IDialogs Automation.Interface)
getDialogs =
  Automation.propertyGetID 0x2f9 [] Automation.outIDispatch
getDisplayAlerts :: Prelude.Int -> IApplication a -> Prelude.IO (Prelude.Int)
getDisplayAlerts lcid =
  Automation.propertyGetID 0x157 [Automation.inInt lcid] Automation.outInt
setDisplayAlerts :: Prelude.Int -> Prelude.Int -> IApplication a -> Prelude.IO ()
setDisplayAlerts lcid rHS =
  Automation.propertySetID 0x157 [Automation.inInt lcid, Automation.inInt rHS]
getDisplayFormulaBar :: Prelude.Int -> IApplication a -> Prelude.IO (Prelude.Int)
getDisplayFormulaBar lcid =
  Automation.propertyGetID 0x158 [Automation.inInt lcid] Automation.outInt
setDisplayFormulaBar :: Prelude.Int -> Prelude.Int -> IApplication a -> Prelude.IO ()
setDisplayFormulaBar lcid rHS =
  Automation.propertySetID 0x158 [Automation.inInt lcid, Automation.inInt rHS]
getDisplayFullScreen :: Prelude.Int -> IApplication a -> Prelude.IO (Prelude.Int)
getDisplayFullScreen lcid =
  Automation.propertyGetID 0x425 [Automation.inInt lcid] Automation.outInt
setDisplayFullScreen :: Prelude.Int -> Prelude.Int -> IApplication a -> Prelude.IO ()
setDisplayFullScreen lcid rHS =
  Automation.propertySetID 0x425 [Automation.inInt lcid, Automation.inInt rHS]
getDisplayNoteIndicator :: IApplication a -> Prelude.IO (Prelude.Int)
getDisplayNoteIndicator =
  Automation.propertyGetID 0x159 [] Automation.outInt
setDisplayNoteIndicator :: Prelude.Int -> IApplication a -> Prelude.IO ()
setDisplayNoteIndicator rHS =
  Automation.propertySetID 0x159 [Automation.inInt rHS]
getDisplayCommentIndicator :: (Automation.Variant a0) => IApplication a -> Prelude.IO (a0)
getDisplayCommentIndicator =
  Automation.propertyGetID 0x4ac [] Automation.outVariant
setDisplayCommentIndicator :: (Automation.Variant a0) => a0 -> IApplication a -> Prelude.IO ()
setDisplayCommentIndicator rHS =
  Automation.propertySetID 0x4ac [Automation.inVariant rHS]
getDisplayExcel4Menus :: Prelude.Int -> IApplication a -> Prelude.IO (Prelude.Int)
getDisplayExcel4Menus lcid =
  Automation.propertyGetID 0x39f [Automation.inInt lcid] Automation.outInt
setDisplayExcel4Menus :: Prelude.Int -> Prelude.Int -> IApplication a -> Prelude.IO ()
setDisplayExcel4Menus lcid rHS =
  Automation.propertySetID 0x39f [Automation.inInt lcid, Automation.inInt rHS]
getDisplayRecentFiles :: IApplication a -> Prelude.IO (Prelude.Int)
getDisplayRecentFiles =
  Automation.propertyGetID 0x39e [] Automation.outInt
setDisplayRecentFiles :: Prelude.Int -> IApplication a -> Prelude.IO ()
setDisplayRecentFiles rHS =
  Automation.propertySetID 0x39e [Automation.inInt rHS]
getDisplayScrollBars :: Prelude.Int -> IApplication a -> Prelude.IO (Prelude.Int)
getDisplayScrollBars lcid =
  Automation.propertyGetID 0x15a [Automation.inInt lcid] Automation.outInt
setDisplayScrollBars :: Prelude.Int -> Prelude.Int -> IApplication a -> Prelude.IO ()
setDisplayScrollBars lcid rHS =
  Automation.propertySetID 0x15a [Automation.inInt lcid, Automation.inInt rHS]
getDisplayStatusBar :: Prelude.Int -> IApplication a -> Prelude.IO (Prelude.Int)
getDisplayStatusBar lcid =
  Automation.propertyGetID 0x15b [Automation.inInt lcid] Automation.outInt
setDisplayStatusBar :: Prelude.Int -> Prelude.Int -> IApplication a -> Prelude.IO ()
setDisplayStatusBar lcid rHS =
  Automation.propertySetID 0x15b [Automation.inInt lcid, Automation.inInt rHS]
doubleClick :: Prelude.Int -> IApplication a -> Prelude.IO ()
doubleClick lcid =
  Automation.methodID0 0x15d [Automation.inInt lcid]
getEditDirectlyInCell :: Prelude.Int -> IApplication a -> Prelude.IO (Prelude.Int)
getEditDirectlyInCell lcid =
  Automation.propertyGetID 0x3a1 [Automation.inInt lcid] Automation.outInt
setEditDirectlyInCell :: Prelude.Int -> Prelude.Int -> IApplication a -> Prelude.IO ()
setEditDirectlyInCell lcid rHS =
  Automation.propertySetID 0x3a1 [Automation.inInt lcid, Automation.inInt rHS]
getEnableAutoComplete :: IApplication a -> Prelude.IO (Prelude.Int)
getEnableAutoComplete =
  Automation.propertyGetID 0x49b [] Automation.outInt
setEnableAutoComplete :: Prelude.Int -> IApplication a -> Prelude.IO ()
setEnableAutoComplete rHS =
  Automation.propertySetID 0x49b [Automation.inInt rHS]
getEnableCancelKey :: (Automation.Variant a0) => Prelude.Int -> IApplication a -> Prelude.IO (a0)
getEnableCancelKey lcid =
  Automation.propertyGetID 0x448 [Automation.inInt lcid] Automation.outVariant
setEnableCancelKey :: (Automation.Variant a0) => Prelude.Int -> a0 -> IApplication a -> Prelude.IO ()
setEnableCancelKey lcid rHS =
  Automation.propertySetID 0x448 [Automation.inInt lcid, Automation.inVariant rHS]
getEnableSound :: IApplication a -> Prelude.IO (Prelude.Int)
getEnableSound =
  Automation.propertyGetID 0x4ad [] Automation.outInt
setEnableSound :: Prelude.Int -> IApplication a -> Prelude.IO ()
setEnableSound rHS =
  Automation.propertySetID 0x4ad [Automation.inInt rHS]
getEnableTipWizard :: Prelude.Int -> IApplication a -> Prelude.IO (Prelude.Int)
getEnableTipWizard lcid =
  Automation.propertyGetID 0x428 [Automation.inInt lcid] Automation.outInt
setEnableTipWizard :: Prelude.Int -> Prelude.Int -> IApplication a -> Prelude.IO ()
setEnableTipWizard lcid rHS =
  Automation.propertySetID 0x428 [Automation.inInt lcid, Automation.inInt rHS]
getFileConverters :: Prelude.Int -> Prelude.Int -> Prelude.Int -> IApplication a -> Prelude.IO (Prelude.Int)
getFileConverters index1 index2 lcid =
  Automation.propertyGetID 0x3a3 [Automation.inInt index1, Automation.inInt index2, Automation.inInt lcid] Automation.outInt
getFileSearch :: IApplication a -> Prelude.IO (Office.IFileSearch Automation.Interface)
getFileSearch =
  Automation.propertyGetID 0x4b0 [] Automation.outIDispatch
getFileFind :: IApplication a -> Prelude.IO (Office.IFind Automation.Interface)
getFileFind =
  Automation.propertyGetID 0x4b1 [] Automation.outIDispatch
findFile :: Prelude.Int -> IApplication a -> Prelude.IO ()
findFile lcid = Automation.methodID0 0x42c [Automation.inInt lcid]
getFixedDecimal :: Prelude.Int -> IApplication a -> Prelude.IO (Prelude.Int)
getFixedDecimal lcid =
  Automation.propertyGetID 0x15f [Automation.inInt lcid] Automation.outInt
setFixedDecimal :: Prelude.Int -> Prelude.Int -> IApplication a -> Prelude.IO ()
setFixedDecimal lcid rHS =
  Automation.propertySetID 0x15f [Automation.inInt lcid, Automation.inInt rHS]
getFixedDecimalPlaces :: Prelude.Int -> IApplication a -> Prelude.IO (Prelude.Int)
getFixedDecimalPlaces lcid =
  Automation.propertyGetID 0x160 [Automation.inInt lcid] Automation.outInt
setFixedDecimalPlaces :: Prelude.Int -> Prelude.Int -> IApplication a -> Prelude.IO ()
setFixedDecimalPlaces lcid rHS =
  Automation.propertySetID 0x160 [Automation.inInt lcid, Automation.inInt rHS]
getCustomListContents :: Prelude.Int -> Prelude.Int -> IApplication a -> Prelude.IO (Prelude.Int)
getCustomListContents listNum lcid =
  Automation.functionID1 0x312 [Automation.inInt listNum, Automation.inInt lcid] Automation.outInt
getCustomListNum :: Prelude.Int -> Prelude.Int -> IApplication a -> Prelude.IO (Prelude.Int)
getCustomListNum listArray lcid =
  Automation.functionID1 0x311 [Automation.inInt listArray, Automation.inInt lcid] Automation.outInt
getOpenFilename :: Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> IApplication a -> Prelude.IO (Prelude.Int)
getOpenFilename fileFilter filterIndex title buttonText multiSelect lcid =
  Automation.functionID1 0x433 [Automation.inInt fileFilter, Automation.inInt filterIndex, Automation.inInt title, Automation.inInt buttonText, Automation.inInt multiSelect, Automation.inInt lcid] Automation.outInt
getSaveAsFilename :: Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> IApplication a -> Prelude.IO (Prelude.Int)
getSaveAsFilename initialFilename fileFilter filterIndex title buttonText lcid =
  Automation.functionID1 0x434 [Automation.inInt initialFilename, Automation.inInt fileFilter, Automation.inInt filterIndex, Automation.inInt title, Automation.inInt buttonText, Automation.inInt lcid] Automation.outInt
goto :: Prelude.Int -> Prelude.Int -> Prelude.Int -> IApplication a -> Prelude.IO ()
goto reference scroll lcid =
  Automation.methodID0 0x1db [Automation.inInt reference, Automation.inInt scroll, Automation.inInt lcid]
getHeight0 :: Prelude.Int -> IApplication a -> Prelude.IO (Prelude.Double)
getHeight0 lcid =
  Automation.propertyGetID 0x7b [Automation.inInt lcid] Automation.outDouble
setHeight0 :: Prelude.Int -> Prelude.Double -> IApplication a -> Prelude.IO ()
setHeight0 lcid rHS =
  Automation.propertySetID 0x7b [Automation.inInt lcid, Automation.inDouble rHS]
help :: Prelude.Int -> Prelude.Int -> Prelude.Int -> IApplication a -> Prelude.IO ()
help helpFile helpContextID lcid =
  Automation.methodID0 0x162 [Automation.inInt helpFile, Automation.inInt helpContextID, Automation.inInt lcid]
getIgnoreRemoteRequests :: Prelude.Int -> IApplication a -> Prelude.IO (Prelude.Int)
getIgnoreRemoteRequests lcid =
  Automation.propertyGetID 0x164 [Automation.inInt lcid] Automation.outInt
setIgnoreRemoteRequests :: Prelude.Int -> Prelude.Int -> IApplication a -> Prelude.IO ()
setIgnoreRemoteRequests lcid rHS =
  Automation.propertySetID 0x164 [Automation.inInt lcid, Automation.inInt rHS]
inchesToPoints :: Prelude.Double -> Prelude.Int -> IApplication a -> Prelude.IO (Prelude.Double)
inchesToPoints inches lcid =
  Automation.functionID1 0x43f [Automation.inDouble inches, Automation.inInt lcid] Automation.outDouble
inputBox :: Prelude.String -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> IApplication a -> Prelude.IO (Prelude.Int)
inputBox prompt title default0 left top helpFile helpContextID type0 lcid =
  Automation.functionID1 0x165 [Automation.inString prompt, Automation.inInt title, Automation.inInt default0, Automation.inInt left, Automation.inInt top, Automation.inInt helpFile, Automation.inInt helpContextID, Automation.inInt type0, Automation.inInt lcid] Automation.outInt
getInteractive :: Prelude.Int -> IApplication a -> Prelude.IO (Prelude.Int)
getInteractive lcid =
  Automation.propertyGetID 0x169 [Automation.inInt lcid] Automation.outInt
setInteractive :: Prelude.Int -> Prelude.Int -> IApplication a -> Prelude.IO ()
setInteractive lcid rHS =
  Automation.propertySetID 0x169 [Automation.inInt lcid, Automation.inInt rHS]
getInternational :: Prelude.Int -> Prelude.Int -> IApplication a -> Prelude.IO (Prelude.Int)
getInternational index lcid =
  Automation.propertyGetID 0x16a [Automation.inInt index, Automation.inInt lcid] Automation.outInt
getIteration :: Prelude.Int -> IApplication a -> Prelude.IO (Prelude.Int)
getIteration lcid =
  Automation.propertyGetID 0x16b [Automation.inInt lcid] Automation.outInt
setIteration :: Prelude.Int -> Prelude.Int -> IApplication a -> Prelude.IO ()
setIteration lcid rHS =
  Automation.propertySetID 0x16b [Automation.inInt lcid, Automation.inInt rHS]
getLargeButtons :: IApplication a -> Prelude.IO (Prelude.Int)
getLargeButtons =
  Automation.propertyGetID 0x16c [] Automation.outInt
setLargeButtons :: Prelude.Int -> IApplication a -> Prelude.IO ()
setLargeButtons rHS =
  Automation.propertySetID 0x16c [Automation.inInt rHS]
getLeft0 :: Prelude.Int -> IApplication a -> Prelude.IO (Prelude.Double)
getLeft0 lcid =
  Automation.propertyGetID 0x7f [Automation.inInt lcid] Automation.outDouble
setLeft0 :: Prelude.Int -> Prelude.Double -> IApplication a -> Prelude.IO ()
setLeft0 lcid rHS =
  Automation.propertySetID 0x7f [Automation.inInt lcid, Automation.inDouble rHS]
getLibraryPath :: Prelude.Int -> IApplication a -> Prelude.IO (Prelude.String)
getLibraryPath lcid =
  Automation.propertyGetID 0x16e [Automation.inInt lcid] Automation.outString
macroOptions :: Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> IApplication a -> Prelude.IO ()
macroOptions macro description hasMenu menuText hasShortcutKey shortcutKey category statusBar helpContextID helpFile lcid =
  Automation.methodID0 0x46f [Automation.inInt macro, Automation.inInt description, Automation.inInt hasMenu, Automation.inInt menuText, Automation.inInt hasShortcutKey, Automation.inInt shortcutKey, Automation.inInt category, Automation.inInt statusBar, Automation.inInt helpContextID, Automation.inInt helpFile, Automation.inInt lcid]
mailLogoff :: Prelude.Int -> IApplication a -> Prelude.IO ()
mailLogoff lcid =
  Automation.methodID0 0x3b1 [Automation.inInt lcid]
mailLogon :: Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> IApplication a -> Prelude.IO ()
mailLogon name password downloadNewMail lcid =
  Automation.methodID0 0x3af [Automation.inInt name, Automation.inInt password, Automation.inInt downloadNewMail, Automation.inInt lcid]
getMailSession :: Prelude.Int -> IApplication a -> Prelude.IO (Prelude.Int)
getMailSession lcid =
  Automation.propertyGetID 0x3ae [Automation.inInt lcid] Automation.outInt
getMailSystem :: (Automation.Variant a0) => Prelude.Int -> IApplication a -> Prelude.IO (a0)
getMailSystem lcid =
  Automation.propertyGetID 0x3cb [Automation.inInt lcid] Automation.outVariant
getMathCoprocessorAvailable :: Prelude.Int -> IApplication a -> Prelude.IO (Prelude.Int)
getMathCoprocessorAvailable lcid =
  Automation.propertyGetID 0x16f [Automation.inInt lcid] Automation.outInt
getMaxChange :: Prelude.Int -> IApplication a -> Prelude.IO (Prelude.Double)
getMaxChange lcid =
  Automation.propertyGetID 0x170 [Automation.inInt lcid] Automation.outDouble
setMaxChange :: Prelude.Int -> Prelude.Double -> IApplication a -> Prelude.IO ()
setMaxChange lcid rHS =
  Automation.propertySetID 0x170 [Automation.inInt lcid, Automation.inDouble rHS]
getMaxIterations :: Prelude.Int -> IApplication a -> Prelude.IO (Prelude.Int)
getMaxIterations lcid =
  Automation.propertyGetID 0x171 [Automation.inInt lcid] Automation.outInt
setMaxIterations :: Prelude.Int -> Prelude.Int -> IApplication a -> Prelude.IO ()
setMaxIterations lcid rHS =
  Automation.propertySetID 0x171 [Automation.inInt lcid, Automation.inInt rHS]
getMemoryFree :: Prelude.Int -> IApplication a -> Prelude.IO (Prelude.Int)
getMemoryFree lcid =
  Automation.propertyGetID 0x172 [Automation.inInt lcid] Automation.outInt
getMemoryTotal :: Prelude.Int -> IApplication a -> Prelude.IO (Prelude.Int)
getMemoryTotal lcid =
  Automation.propertyGetID 0x173 [Automation.inInt lcid] Automation.outInt
getMemoryUsed :: Prelude.Int -> IApplication a -> Prelude.IO (Prelude.Int)
getMemoryUsed lcid =
  Automation.propertyGetID 0x174 [Automation.inInt lcid] Automation.outInt
getMouseAvailable :: Prelude.Int -> IApplication a -> Prelude.IO (Prelude.Int)
getMouseAvailable lcid =
  Automation.propertyGetID 0x175 [Automation.inInt lcid] Automation.outInt
getMoveAfterReturn :: Prelude.Int -> IApplication a -> Prelude.IO (Prelude.Int)
getMoveAfterReturn lcid =
  Automation.propertyGetID 0x176 [Automation.inInt lcid] Automation.outInt
setMoveAfterReturn :: Prelude.Int -> Prelude.Int -> IApplication a -> Prelude.IO ()
setMoveAfterReturn lcid rHS =
  Automation.propertySetID 0x176 [Automation.inInt lcid, Automation.inInt rHS]
getMoveAfterReturnDirection :: (Automation.Variant a0) => Prelude.Int -> IApplication a -> Prelude.IO (a0)
getMoveAfterReturnDirection lcid =
  Automation.propertyGetID 0x478 [Automation.inInt lcid] Automation.outVariant
setMoveAfterReturnDirection :: (Automation.Variant a0) => Prelude.Int -> a0 -> IApplication a -> Prelude.IO ()
setMoveAfterReturnDirection lcid rHS =
  Automation.propertySetID 0x478 [Automation.inInt lcid, Automation.inVariant rHS]
getRecentFiles :: IApplication a -> Prelude.IO (IRecentFiles Automation.Interface)
getRecentFiles =
  Automation.propertyGetID 0x4b2 [] Automation.outIDispatch
getName0 :: Automation.IDispatch a -> Prelude.IO (Prelude.String)
getName0 = Automation.propertyGetID 0x6e [] Automation.outString
nextLetter :: Prelude.Int -> IApplication a -> Prelude.IO (IWorkbook Automation.Interface)
nextLetter lcid =
  Automation.functionID1 0x3cc [Automation.inInt lcid] Automation.outIDispatch
getNetworkTemplatesPath :: Prelude.Int -> IApplication a -> Prelude.IO (Prelude.String)
getNetworkTemplatesPath lcid =
  Automation.propertyGetID 0x184 [Automation.inInt lcid] Automation.outString
getODBCErrors :: IApplication a -> Prelude.IO (IODBCErrors Automation.Interface)
getODBCErrors =
  Automation.propertyGetID 0x4b3 [] Automation.outIDispatch
getODBCTimeout :: IApplication a -> Prelude.IO (Prelude.Int)
getODBCTimeout =
  Automation.propertyGetID 0x4b4 [] Automation.outInt
setODBCTimeout :: Prelude.Int -> IApplication a -> Prelude.IO ()
setODBCTimeout rHS =
  Automation.propertySetID 0x4b4 [Automation.inInt rHS]
getOnCalculate :: Prelude.Int -> Automation.IDispatch a -> Prelude.IO (Prelude.String)
getOnCalculate lcid =
  Automation.propertyGetID 0x271 [Automation.inInt lcid] Automation.outString
setOnCalculate :: Prelude.Int -> Prelude.String -> Automation.IDispatch a -> Prelude.IO ()
setOnCalculate lcid rHS =
  Automation.propertySetID 0x271 [Automation.inInt lcid, Automation.inString rHS]
getOnData :: Prelude.Int -> Automation.IDispatch a -> Prelude.IO (Prelude.String)
getOnData lcid =
  Automation.propertyGetID 0x275 [Automation.inInt lcid] Automation.outString
setOnData :: Prelude.Int -> Prelude.String -> Automation.IDispatch a -> Prelude.IO ()
setOnData lcid rHS =
  Automation.propertySetID 0x275 [Automation.inInt lcid, Automation.inString rHS]
getOnDoubleClick :: Prelude.Int -> Automation.IDispatch a -> Prelude.IO (Prelude.String)
getOnDoubleClick lcid =
  Automation.propertyGetID 0x274 [Automation.inInt lcid] Automation.outString
setOnDoubleClick :: Prelude.Int -> Prelude.String -> Automation.IDispatch a -> Prelude.IO ()
setOnDoubleClick lcid rHS =
  Automation.propertySetID 0x274 [Automation.inInt lcid, Automation.inString rHS]
getOnEntry :: Prelude.Int -> Automation.IDispatch a -> Prelude.IO (Prelude.String)
getOnEntry lcid =
  Automation.propertyGetID 0x273 [Automation.inInt lcid] Automation.outString
setOnEntry :: Prelude.Int -> Prelude.String -> Automation.IDispatch a -> Prelude.IO ()
setOnEntry lcid rHS =
  Automation.propertySetID 0x273 [Automation.inInt lcid, Automation.inString rHS]
onKey :: Prelude.String -> Prelude.Int -> Prelude.Int -> IApplication a -> Prelude.IO ()
onKey key procedure lcid =
  Automation.methodID0 0x272 [Automation.inString key, Automation.inInt procedure, Automation.inInt lcid]
onRepeat :: Prelude.String -> Prelude.String -> Prelude.Int -> IApplication a -> Prelude.IO ()
onRepeat text procedure lcid =
  Automation.methodID0 0x301 [Automation.inString text, Automation.inString procedure, Automation.inInt lcid]
getOnSheetActivate :: Prelude.Int -> Automation.IDispatch a -> Prelude.IO (Prelude.String)
getOnSheetActivate lcid =
  Automation.propertyGetID 0x407 [Automation.inInt lcid] Automation.outString
setOnSheetActivate :: Prelude.Int -> Prelude.String -> Automation.IDispatch a -> Prelude.IO ()
setOnSheetActivate lcid rHS =
  Automation.propertySetID 0x407 [Automation.inInt lcid, Automation.inString rHS]
getOnSheetDeactivate :: Prelude.Int -> Automation.IDispatch a -> Prelude.IO (Prelude.String)
getOnSheetDeactivate lcid =
  Automation.propertyGetID 0x439 [Automation.inInt lcid] Automation.outString
setOnSheetDeactivate :: Prelude.Int -> Prelude.String -> Automation.IDispatch a -> Prelude.IO ()
setOnSheetDeactivate lcid rHS =
  Automation.propertySetID 0x439 [Automation.inInt lcid, Automation.inString rHS]
onTime :: Prelude.Int -> Prelude.String -> Prelude.Int -> Prelude.Int -> Prelude.Int -> IApplication a -> Prelude.IO ()
onTime earliestTime procedure latestTime schedule lcid =
  Automation.methodID0 0x270 [Automation.inInt earliestTime, Automation.inString procedure, Automation.inInt latestTime, Automation.inInt schedule, Automation.inInt lcid]
onUndo :: Prelude.String -> Prelude.String -> Prelude.Int -> IApplication a -> Prelude.IO ()
onUndo text procedure lcid =
  Automation.methodID0 0x302 [Automation.inString text, Automation.inString procedure, Automation.inInt lcid]
getOnWindow0 :: Prelude.Int -> IApplication a -> Prelude.IO (Prelude.String)
getOnWindow0 lcid =
  Automation.propertyGetID 0x26f [Automation.inInt lcid] Automation.outString
setOnWindow0 :: Prelude.Int -> Prelude.String -> IApplication a -> Prelude.IO ()
setOnWindow0 lcid rHS =
  Automation.propertySetID 0x26f [Automation.inInt lcid, Automation.inString rHS]
getOperatingSystem :: Prelude.Int -> IApplication a -> Prelude.IO (Prelude.String)
getOperatingSystem lcid =
  Automation.propertyGetID 0x177 [Automation.inInt lcid] Automation.outString
getOrganizationName :: Prelude.Int -> IApplication a -> Prelude.IO (Prelude.String)
getOrganizationName lcid =
  Automation.propertyGetID 0x178 [Automation.inInt lcid] Automation.outString
getPath :: Prelude.Int -> Automation.IDispatch a -> Prelude.IO (Prelude.String)
getPath lcid =
  Automation.propertyGetID 0x123 [Automation.inInt lcid] Automation.outString
getPathSeparator :: Prelude.Int -> IApplication a -> Prelude.IO (Prelude.String)
getPathSeparator lcid =
  Automation.propertyGetID 0x179 [Automation.inInt lcid] Automation.outString
getPreviousSelections :: Prelude.Int -> Prelude.Int -> IApplication a -> Prelude.IO (Prelude.Int)
getPreviousSelections index lcid =
  Automation.propertyGetID 0x17a [Automation.inInt index, Automation.inInt lcid] Automation.outInt
getPivotTableSelection :: IApplication a -> Prelude.IO (Prelude.Int)
getPivotTableSelection =
  Automation.propertyGetID 0x4b5 [] Automation.outInt
setPivotTableSelection :: Prelude.Int -> IApplication a -> Prelude.IO ()
setPivotTableSelection rHS =
  Automation.propertySetID 0x4b5 [Automation.inInt rHS]
getPromptForSummaryInfo :: Prelude.Int -> IApplication a -> Prelude.IO (Prelude.Int)
getPromptForSummaryInfo lcid =
  Automation.propertyGetID 0x426 [Automation.inInt lcid] Automation.outInt
setPromptForSummaryInfo :: Prelude.Int -> Prelude.Int -> IApplication a -> Prelude.IO ()
setPromptForSummaryInfo lcid rHS =
  Automation.propertySetID 0x426 [Automation.inInt lcid, Automation.inInt rHS]
quit :: IApplication a -> Prelude.IO ()
quit = Automation.methodID0 0x12e []
recordMacro :: Prelude.Int -> Prelude.Int -> Prelude.Int -> IApplication a -> Prelude.IO ()
recordMacro basicCode xlmCode lcid =
  Automation.methodID0 0x305 [Automation.inInt basicCode, Automation.inInt xlmCode, Automation.inInt lcid]
getRecordRelative :: Prelude.Int -> IApplication a -> Prelude.IO (Prelude.Int)
getRecordRelative lcid =
  Automation.propertyGetID 0x17b [Automation.inInt lcid] Automation.outInt
getReferenceStyle :: (Automation.Variant a0) => Prelude.Int -> IApplication a -> Prelude.IO (a0)
getReferenceStyle lcid =
  Automation.propertyGetID 0x17c [Automation.inInt lcid] Automation.outVariant
setReferenceStyle :: (Automation.Variant a0) => Prelude.Int -> a0 -> IApplication a -> Prelude.IO ()
setReferenceStyle lcid rHS =
  Automation.propertySetID 0x17c [Automation.inInt lcid, Automation.inVariant rHS]
getRegisteredFunctions :: Prelude.Int -> Prelude.Int -> Prelude.Int -> IApplication a -> Prelude.IO (Prelude.Int)
getRegisteredFunctions index1 index2 lcid =
  Automation.propertyGetID 0x307 [Automation.inInt index1, Automation.inInt index2, Automation.inInt lcid] Automation.outInt
registerXLL :: Prelude.String -> Prelude.Int -> IApplication a -> Prelude.IO (Prelude.Int)
registerXLL filename lcid =
  Automation.functionID1 0x1e [Automation.inString filename, Automation.inInt lcid] Automation.outInt
repeat :: Prelude.Int -> IApplication a -> Prelude.IO ()
repeat lcid = Automation.methodID0 0x12d [Automation.inInt lcid]
resetTipWizard :: Prelude.Int -> IApplication a -> Prelude.IO ()
resetTipWizard lcid =
  Automation.methodID0 0x3a0 [Automation.inInt lcid]
getRollZoom :: IApplication a -> Prelude.IO (Prelude.Int)
getRollZoom = Automation.propertyGetID 0x4b6 [] Automation.outInt
setRollZoom :: Prelude.Int -> IApplication a -> Prelude.IO ()
setRollZoom rHS =
  Automation.propertySetID 0x4b6 [Automation.inInt rHS]
save :: Prelude.Int -> Prelude.Int -> IApplication a -> Prelude.IO ()
save filename lcid =
  Automation.methodID0 0x11b [Automation.inInt filename, Automation.inInt lcid]
saveWorkspace :: Prelude.Int -> Prelude.Int -> IApplication a -> Prelude.IO ()
saveWorkspace filename lcid =
  Automation.methodID0 0xd4 [Automation.inInt filename, Automation.inInt lcid]
getScreenUpdating :: Prelude.Int -> IApplication a -> Prelude.IO (Prelude.Int)
getScreenUpdating lcid =
  Automation.propertyGetID 0x17e [Automation.inInt lcid] Automation.outInt
setScreenUpdating :: Prelude.Int -> Prelude.Int -> IApplication a -> Prelude.IO ()
setScreenUpdating lcid rHS =
  Automation.propertySetID 0x17e [Automation.inInt lcid, Automation.inInt rHS]
setDefaultChart :: Prelude.Int -> Prelude.Int -> IApplication a -> Prelude.IO ()
setDefaultChart formatName gallery =
  Automation.methodID0 0xdb [Automation.inInt formatName, Automation.inInt gallery]
getSheetsInNewWorkbook :: Prelude.Int -> IApplication a -> Prelude.IO (Prelude.Int)
getSheetsInNewWorkbook lcid =
  Automation.propertyGetID 0x3e1 [Automation.inInt lcid] Automation.outInt
setSheetsInNewWorkbook :: Prelude.Int -> Prelude.Int -> IApplication a -> Prelude.IO ()
setSheetsInNewWorkbook lcid rHS =
  Automation.propertySetID 0x3e1 [Automation.inInt lcid, Automation.inInt rHS]
getShowChartTipNames :: IApplication a -> Prelude.IO (Prelude.Int)
getShowChartTipNames =
  Automation.propertyGetID 0x4b7 [] Automation.outInt
setShowChartTipNames :: Prelude.Int -> IApplication a -> Prelude.IO ()
setShowChartTipNames rHS =
  Automation.propertySetID 0x4b7 [Automation.inInt rHS]
getShowChartTipValues :: IApplication a -> Prelude.IO (Prelude.Int)
getShowChartTipValues =
  Automation.propertyGetID 0x4b8 [] Automation.outInt
setShowChartTipValues :: Prelude.Int -> IApplication a -> Prelude.IO ()
setShowChartTipValues rHS =
  Automation.propertySetID 0x4b8 [Automation.inInt rHS]
getStandardFont :: Prelude.Int -> IApplication a -> Prelude.IO (Prelude.String)
getStandardFont lcid =
  Automation.propertyGetID 0x39c [Automation.inInt lcid] Automation.outString
setStandardFont :: Prelude.Int -> Prelude.String -> IApplication a -> Prelude.IO ()
setStandardFont lcid rHS =
  Automation.propertySetID 0x39c [Automation.inInt lcid, Automation.inString rHS]
getStandardFontSize :: Prelude.Int -> IApplication a -> Prelude.IO (Prelude.Double)
getStandardFontSize lcid =
  Automation.propertyGetID 0x39d [Automation.inInt lcid] Automation.outDouble
setStandardFontSize :: Prelude.Int -> Prelude.Double -> IApplication a -> Prelude.IO ()
setStandardFontSize lcid rHS =
  Automation.propertySetID 0x39d [Automation.inInt lcid, Automation.inDouble rHS]
getStartupPath :: Prelude.Int -> IApplication a -> Prelude.IO (Prelude.String)
getStartupPath lcid =
  Automation.propertyGetID 0x181 [Automation.inInt lcid] Automation.outString
getStatusBar :: Prelude.Int -> IApplication a -> Prelude.IO (Prelude.Int)
getStatusBar lcid =
  Automation.propertyGetID 0x182 [Automation.inInt lcid] Automation.outInt
setStatusBar :: Prelude.Int -> Prelude.Int -> IApplication a -> Prelude.IO ()
setStatusBar lcid rHS =
  Automation.propertySetID 0x182 [Automation.inInt lcid, Automation.inInt rHS]
getTemplatesPath :: Prelude.Int -> IApplication a -> Prelude.IO (Prelude.String)
getTemplatesPath lcid =
  Automation.propertyGetID 0x17d [Automation.inInt lcid] Automation.outString
getShowToolTips :: IApplication a -> Prelude.IO (Prelude.Int)
getShowToolTips =
  Automation.propertyGetID 0x183 [] Automation.outInt
setShowToolTips :: Prelude.Int -> IApplication a -> Prelude.IO ()
setShowToolTips rHS =
  Automation.propertySetID 0x183 [Automation.inInt rHS]
getTop0 :: Prelude.Int -> IApplication a -> Prelude.IO (Prelude.Double)
getTop0 lcid =
  Automation.propertyGetID 0x7e [Automation.inInt lcid] Automation.outDouble
setTop0 :: Prelude.Int -> Prelude.Double -> IApplication a -> Prelude.IO ()
setTop0 lcid rHS =
  Automation.propertySetID 0x7e [Automation.inInt lcid, Automation.inDouble rHS]
getDefaultSaveFormat :: (Automation.Variant a0) => IApplication a -> Prelude.IO (a0)
getDefaultSaveFormat =
  Automation.propertyGetID 0x4b9 [] Automation.outVariant
setDefaultSaveFormat :: (Automation.Variant a0) => a0 -> IApplication a -> Prelude.IO ()
setDefaultSaveFormat rHS =
  Automation.propertySetID 0x4b9 [Automation.inVariant rHS]
getTransitionMenuKey :: Prelude.Int -> IApplication a -> Prelude.IO (Prelude.String)
getTransitionMenuKey lcid =
  Automation.propertyGetID 0x136 [Automation.inInt lcid] Automation.outString
setTransitionMenuKey :: Prelude.Int -> Prelude.String -> IApplication a -> Prelude.IO ()
setTransitionMenuKey lcid rHS =
  Automation.propertySetID 0x136 [Automation.inInt lcid, Automation.inString rHS]
getTransitionMenuKeyAction :: Prelude.Int -> IApplication a -> Prelude.IO (Prelude.Int)
getTransitionMenuKeyAction lcid =
  Automation.propertyGetID 0x137 [Automation.inInt lcid] Automation.outInt
setTransitionMenuKeyAction :: Prelude.Int -> Prelude.Int -> IApplication a -> Prelude.IO ()
setTransitionMenuKeyAction lcid rHS =
  Automation.propertySetID 0x137 [Automation.inInt lcid, Automation.inInt rHS]
getTransitionNavigKeys :: Prelude.Int -> IApplication a -> Prelude.IO (Prelude.Int)
getTransitionNavigKeys lcid =
  Automation.propertyGetID 0x138 [Automation.inInt lcid] Automation.outInt
setTransitionNavigKeys :: Prelude.Int -> Prelude.Int -> IApplication a -> Prelude.IO ()
setTransitionNavigKeys lcid rHS =
  Automation.propertySetID 0x138 [Automation.inInt lcid, Automation.inInt rHS]
undo :: Prelude.Int -> IApplication a -> Prelude.IO ()
undo lcid = Automation.methodID0 0x12f [Automation.inInt lcid]
getUsableHeight0 :: Prelude.Int -> IApplication a -> Prelude.IO (Prelude.Double)
getUsableHeight0 lcid =
  Automation.propertyGetID 0x185 [Automation.inInt lcid] Automation.outDouble
getUsableWidth0 :: Prelude.Int -> IApplication a -> Prelude.IO (Prelude.Double)
getUsableWidth0 lcid =
  Automation.propertyGetID 0x186 [Automation.inInt lcid] Automation.outDouble
getUserControl :: Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getUserControl =
  Automation.propertyGetID 0x4ba [] Automation.outInt
setUserControl :: Prelude.Int -> Automation.IDispatch a -> Prelude.IO ()
setUserControl rHS =
  Automation.propertySetID 0x4ba [Automation.inInt rHS]
getUserName :: Prelude.Int -> IApplication a -> Prelude.IO (Prelude.String)
getUserName lcid =
  Automation.propertyGetID 0x187 [Automation.inInt lcid] Automation.outString
setUserName :: Prelude.Int -> Prelude.String -> IApplication a -> Prelude.IO ()
setUserName lcid rHS =
  Automation.propertySetID 0x187 [Automation.inInt lcid, Automation.inString rHS]
getValue :: Automation.IDispatch a -> Prelude.IO (Prelude.String)
getValue = Automation.propertyGetID 0x6 [] Automation.outString
getVBE :: IApplication a -> Prelude.IO (VBIDE.IVBE Automation.Interface)
getVBE = Automation.propertyGetID 0x4bb [] Automation.outIDispatch
getVersion :: Prelude.Int -> IApplication a -> Prelude.IO (Prelude.String)
getVersion lcid =
  Automation.propertyGetID 0x188 [Automation.inInt lcid] Automation.outString
getVisible4 :: Prelude.Int -> IApplication a -> Prelude.IO (Prelude.Int)
getVisible4 lcid =
  Automation.propertyGetID 0x22e [Automation.inInt lcid] Automation.outInt
setVisible4 :: Prelude.Int -> Prelude.Int -> IApplication a -> Prelude.IO ()
setVisible4 lcid rHS =
  Automation.propertySetID 0x22e [Automation.inInt lcid, Automation.inInt rHS]
volatile :: Prelude.Int -> Prelude.Int -> IApplication a -> Prelude.IO ()
volatile volatile lcid =
  Automation.methodID0 0x314 [Automation.inInt volatile, Automation.inInt lcid]
wait :: Prelude.Int -> Prelude.Int -> IApplication a -> Prelude.IO ()
wait time lcid =
  Automation.methodID0 0x189 [Automation.inInt time, Automation.inInt lcid]
getWidth0 :: Prelude.Int -> IApplication a -> Prelude.IO (Prelude.Double)
getWidth0 lcid =
  Automation.propertyGetID 0x7a [Automation.inInt lcid] Automation.outDouble
setWidth0 :: Prelude.Int -> Prelude.Double -> IApplication a -> Prelude.IO ()
setWidth0 lcid rHS =
  Automation.propertySetID 0x7a [Automation.inInt lcid, Automation.inDouble rHS]
getWindowsForPens :: Prelude.Int -> IApplication a -> Prelude.IO (Prelude.Int)
getWindowsForPens lcid =
  Automation.propertyGetID 0x18b [Automation.inInt lcid] Automation.outInt
getWindowState0 :: (Automation.Variant a0) => Prelude.Int -> IApplication a -> Prelude.IO (a0)
getWindowState0 lcid =
  Automation.propertyGetID 0x18c [Automation.inInt lcid] Automation.outVariant
setWindowState0 :: (Automation.Variant a0) => Prelude.Int -> a0 -> IApplication a -> Prelude.IO ()
setWindowState0 lcid rHS =
  Automation.propertySetID 0x18c [Automation.inInt lcid, Automation.inVariant rHS]
getUILanguage :: Prelude.Int -> IApplication a -> Prelude.IO (Prelude.Int)
getUILanguage lcid =
  Automation.propertyGetID 0x2 [Automation.inInt lcid] Automation.outInt
setUILanguage :: Prelude.Int -> Prelude.Int -> IApplication a -> Prelude.IO ()
setUILanguage lcid rHS =
  Automation.propertySetID 0x2 [Automation.inInt lcid, Automation.inInt rHS]
getDefaultSheetDirection :: Prelude.Int -> IApplication a -> Prelude.IO (Prelude.Int)
getDefaultSheetDirection lcid =
  Automation.propertyGetID 0xe5 [Automation.inInt lcid] Automation.outInt
setDefaultSheetDirection :: Prelude.Int -> Prelude.Int -> IApplication a -> Prelude.IO ()
setDefaultSheetDirection lcid rHS =
  Automation.propertySetID 0xe5 [Automation.inInt lcid, Automation.inInt rHS]
getCursorMovement :: Prelude.Int -> IApplication a -> Prelude.IO (Prelude.Int)
getCursorMovement lcid =
  Automation.propertyGetID 0xe8 [Automation.inInt lcid] Automation.outInt
setCursorMovement :: Prelude.Int -> Prelude.Int -> IApplication a -> Prelude.IO ()
setCursorMovement lcid rHS =
  Automation.propertySetID 0xe8 [Automation.inInt lcid, Automation.inInt rHS]
getControlCharacters :: Prelude.Int -> IApplication a -> Prelude.IO (Prelude.Int)
getControlCharacters lcid =
  Automation.propertyGetID 0xe9 [Automation.inInt lcid] Automation.outInt
setControlCharacters :: Prelude.Int -> Prelude.Int -> IApplication a -> Prelude.IO ()
setControlCharacters lcid rHS =
  Automation.propertySetID 0xe9 [Automation.inInt lcid, Automation.inInt rHS]
wSFunction :: Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> IApplication a -> Prelude.IO (Prelude.Int)
wSFunction arg1 arg2 arg3 arg4 arg5 arg6 arg7 arg8 arg9 arg10 arg11 arg12 arg13 arg14 arg15 arg16 arg17 arg18 arg19 arg20 arg21 arg22 arg23 arg24 arg25 arg26 arg27 arg28 arg29 arg30 lcid =
  Automation.functionID1 0xa9 [Automation.inInt arg1, Automation.inInt arg2, Automation.inInt arg3, Automation.inInt arg4, Automation.inInt arg5, Automation.inInt arg6, Automation.inInt arg7, Automation.inInt arg8, Automation.inInt arg9, Automation.inInt arg10, Automation.inInt arg11, Automation.inInt arg12, Automation.inInt arg13, Automation.inInt arg14, Automation.inInt arg15, Automation.inInt arg16, Automation.inInt arg17, Automation.inInt arg18, Automation.inInt arg19, Automation.inInt arg20, Automation.inInt arg21, Automation.inInt arg22, Automation.inInt arg23, Automation.inInt arg24, Automation.inInt arg25, Automation.inInt arg26, Automation.inInt arg27, Automation.inInt arg28, Automation.inInt arg29, Automation.inInt arg30, Automation.inInt lcid] Automation.outInt
getEnableEvents :: IApplication a -> Prelude.IO (Prelude.Int)
getEnableEvents =
  Automation.propertyGetID 0x4bc [] Automation.outInt
setEnableEvents :: Prelude.Int -> IApplication a -> Prelude.IO ()
setEnableEvents rHS =
  Automation.propertySetID 0x4bc [Automation.inInt rHS]
getDisplayInfoWindow :: IApplication a -> Prelude.IO (Prelude.Int)
getDisplayInfoWindow =
  Automation.propertyGetID 0x4bd [] Automation.outInt
setDisplayInfoWindow :: Prelude.Int -> IApplication a -> Prelude.IO ()
setDisplayInfoWindow rHS =
  Automation.propertySetID 0x4bd [Automation.inInt rHS]
-- --------------------------------------------------
-- 
-- interface IWorksheetFunction
-- 
-- --------------------------------------------------
data WorksheetFunction a = WorksheetFunction
                            
type IWorksheetFunction a = Automation.IDispatch (WorksheetFunction a)
iidIWorksheetFunction :: Com.IID (IWorksheetFunction Automation.Interface)
iidIWorksheetFunction =
  Com.mkIID "{00020845-0001-0000-C000-000000000046}"
wSFunction0 :: Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> IWorksheetFunction a -> Prelude.IO (Prelude.Int)
wSFunction0 arg1 arg2 arg3 arg4 arg5 arg6 arg7 arg8 arg9 arg10 arg11 arg12 arg13 arg14 arg15 arg16 arg17 arg18 arg19 arg20 arg21 arg22 arg23 arg24 arg25 arg26 arg27 arg28 arg29 arg30 =
  Automation.function1 "_WSFunction" [Automation.inInt arg1, Automation.inInt arg2, Automation.inInt arg3, Automation.inInt arg4, Automation.inInt arg5, Automation.inInt arg6, Automation.inInt arg7, Automation.inInt arg8, Automation.inInt arg9, Automation.inInt arg10, Automation.inInt arg11, Automation.inInt arg12, Automation.inInt arg13, Automation.inInt arg14, Automation.inInt arg15, Automation.inInt arg16, Automation.inInt arg17, Automation.inInt arg18, Automation.inInt arg19, Automation.inInt arg20, Automation.inInt arg21, Automation.inInt arg22, Automation.inInt arg23, Automation.inInt arg24, Automation.inInt arg25, Automation.inInt arg26, Automation.inInt arg27, Automation.inInt arg28, Automation.inInt arg29, Automation.inInt arg30] Automation.outInt
count :: Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> IWorksheetFunction a -> Prelude.IO (Prelude.Double)
count arg1 arg2 arg3 arg4 arg5 arg6 arg7 arg8 arg9 arg10 arg11 arg12 arg13 arg14 arg15 arg16 arg17 arg18 arg19 arg20 arg21 arg22 arg23 arg24 arg25 arg26 arg27 arg28 arg29 arg30 =
  Automation.function1 "Count" [Automation.inInt arg1, Automation.inInt arg2, Automation.inInt arg3, Automation.inInt arg4, Automation.inInt arg5, Automation.inInt arg6, Automation.inInt arg7, Automation.inInt arg8, Automation.inInt arg9, Automation.inInt arg10, Automation.inInt arg11, Automation.inInt arg12, Automation.inInt arg13, Automation.inInt arg14, Automation.inInt arg15, Automation.inInt arg16, Automation.inInt arg17, Automation.inInt arg18, Automation.inInt arg19, Automation.inInt arg20, Automation.inInt arg21, Automation.inInt arg22, Automation.inInt arg23, Automation.inInt arg24, Automation.inInt arg25, Automation.inInt arg26, Automation.inInt arg27, Automation.inInt arg28, Automation.inInt arg29, Automation.inInt arg30] Automation.outDouble
isNA :: Prelude.Int -> IWorksheetFunction a -> Prelude.IO (Prelude.Int)
isNA arg1 =
  Automation.function1 "IsNA" [Automation.inInt arg1] Automation.outInt
isError :: Prelude.Int -> IWorksheetFunction a -> Prelude.IO (Prelude.Int)
isError arg1 =
  Automation.function1 "IsError" [Automation.inInt arg1] Automation.outInt
sum :: Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> IWorksheetFunction a -> Prelude.IO (Prelude.Double)
sum arg1 arg2 arg3 arg4 arg5 arg6 arg7 arg8 arg9 arg10 arg11 arg12 arg13 arg14 arg15 arg16 arg17 arg18 arg19 arg20 arg21 arg22 arg23 arg24 arg25 arg26 arg27 arg28 arg29 arg30 =
  Automation.function1 "Sum" [Automation.inInt arg1, Automation.inInt arg2, Automation.inInt arg3, Automation.inInt arg4, Automation.inInt arg5, Automation.inInt arg6, Automation.inInt arg7, Automation.inInt arg8, Automation.inInt arg9, Automation.inInt arg10, Automation.inInt arg11, Automation.inInt arg12, Automation.inInt arg13, Automation.inInt arg14, Automation.inInt arg15, Automation.inInt arg16, Automation.inInt arg17, Automation.inInt arg18, Automation.inInt arg19, Automation.inInt arg20, Automation.inInt arg21, Automation.inInt arg22, Automation.inInt arg23, Automation.inInt arg24, Automation.inInt arg25, Automation.inInt arg26, Automation.inInt arg27, Automation.inInt arg28, Automation.inInt arg29, Automation.inInt arg30] Automation.outDouble
average :: Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> IWorksheetFunction a -> Prelude.IO (Prelude.Double)
average arg1 arg2 arg3 arg4 arg5 arg6 arg7 arg8 arg9 arg10 arg11 arg12 arg13 arg14 arg15 arg16 arg17 arg18 arg19 arg20 arg21 arg22 arg23 arg24 arg25 arg26 arg27 arg28 arg29 arg30 =
  Automation.function1 "Average" [Automation.inInt arg1, Automation.inInt arg2, Automation.inInt arg3, Automation.inInt arg4, Automation.inInt arg5, Automation.inInt arg6, Automation.inInt arg7, Automation.inInt arg8, Automation.inInt arg9, Automation.inInt arg10, Automation.inInt arg11, Automation.inInt arg12, Automation.inInt arg13, Automation.inInt arg14, Automation.inInt arg15, Automation.inInt arg16, Automation.inInt arg17, Automation.inInt arg18, Automation.inInt arg19, Automation.inInt arg20, Automation.inInt arg21, Automation.inInt arg22, Automation.inInt arg23, Automation.inInt arg24, Automation.inInt arg25, Automation.inInt arg26, Automation.inInt arg27, Automation.inInt arg28, Automation.inInt arg29, Automation.inInt arg30] Automation.outDouble
min :: Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> IWorksheetFunction a -> Prelude.IO (Prelude.Double)
min arg1 arg2 arg3 arg4 arg5 arg6 arg7 arg8 arg9 arg10 arg11 arg12 arg13 arg14 arg15 arg16 arg17 arg18 arg19 arg20 arg21 arg22 arg23 arg24 arg25 arg26 arg27 arg28 arg29 arg30 =
  Automation.function1 "Min" [Automation.inInt arg1, Automation.inInt arg2, Automation.inInt arg3, Automation.inInt arg4, Automation.inInt arg5, Automation.inInt arg6, Automation.inInt arg7, Automation.inInt arg8, Automation.inInt arg9, Automation.inInt arg10, Automation.inInt arg11, Automation.inInt arg12, Automation.inInt arg13, Automation.inInt arg14, Automation.inInt arg15, Automation.inInt arg16, Automation.inInt arg17, Automation.inInt arg18, Automation.inInt arg19, Automation.inInt arg20, Automation.inInt arg21, Automation.inInt arg22, Automation.inInt arg23, Automation.inInt arg24, Automation.inInt arg25, Automation.inInt arg26, Automation.inInt arg27, Automation.inInt arg28, Automation.inInt arg29, Automation.inInt arg30] Automation.outDouble
max :: Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> IWorksheetFunction a -> Prelude.IO (Prelude.Double)
max arg1 arg2 arg3 arg4 arg5 arg6 arg7 arg8 arg9 arg10 arg11 arg12 arg13 arg14 arg15 arg16 arg17 arg18 arg19 arg20 arg21 arg22 arg23 arg24 arg25 arg26 arg27 arg28 arg29 arg30 =
  Automation.function1 "Max" [Automation.inInt arg1, Automation.inInt arg2, Automation.inInt arg3, Automation.inInt arg4, Automation.inInt arg5, Automation.inInt arg6, Automation.inInt arg7, Automation.inInt arg8, Automation.inInt arg9, Automation.inInt arg10, Automation.inInt arg11, Automation.inInt arg12, Automation.inInt arg13, Automation.inInt arg14, Automation.inInt arg15, Automation.inInt arg16, Automation.inInt arg17, Automation.inInt arg18, Automation.inInt arg19, Automation.inInt arg20, Automation.inInt arg21, Automation.inInt arg22, Automation.inInt arg23, Automation.inInt arg24, Automation.inInt arg25, Automation.inInt arg26, Automation.inInt arg27, Automation.inInt arg28, Automation.inInt arg29, Automation.inInt arg30] Automation.outDouble
npv :: Prelude.Double -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> IWorksheetFunction a -> Prelude.IO (Prelude.Double)
npv arg1 arg2 arg3 arg4 arg5 arg6 arg7 arg8 arg9 arg10 arg11 arg12 arg13 arg14 arg15 arg16 arg17 arg18 arg19 arg20 arg21 arg22 arg23 arg24 arg25 arg26 arg27 arg28 arg29 arg30 =
  Automation.function1 "Npv" [Automation.inDouble arg1, Automation.inInt arg2, Automation.inInt arg3, Automation.inInt arg4, Automation.inInt arg5, Automation.inInt arg6, Automation.inInt arg7, Automation.inInt arg8, Automation.inInt arg9, Automation.inInt arg10, Automation.inInt arg11, Automation.inInt arg12, Automation.inInt arg13, Automation.inInt arg14, Automation.inInt arg15, Automation.inInt arg16, Automation.inInt arg17, Automation.inInt arg18, Automation.inInt arg19, Automation.inInt arg20, Automation.inInt arg21, Automation.inInt arg22, Automation.inInt arg23, Automation.inInt arg24, Automation.inInt arg25, Automation.inInt arg26, Automation.inInt arg27, Automation.inInt arg28, Automation.inInt arg29, Automation.inInt arg30] Automation.outDouble
stDev :: Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> IWorksheetFunction a -> Prelude.IO (Prelude.Double)
stDev arg1 arg2 arg3 arg4 arg5 arg6 arg7 arg8 arg9 arg10 arg11 arg12 arg13 arg14 arg15 arg16 arg17 arg18 arg19 arg20 arg21 arg22 arg23 arg24 arg25 arg26 arg27 arg28 arg29 arg30 =
  Automation.function1 "StDev" [Automation.inInt arg1, Automation.inInt arg2, Automation.inInt arg3, Automation.inInt arg4, Automation.inInt arg5, Automation.inInt arg6, Automation.inInt arg7, Automation.inInt arg8, Automation.inInt arg9, Automation.inInt arg10, Automation.inInt arg11, Automation.inInt arg12, Automation.inInt arg13, Automation.inInt arg14, Automation.inInt arg15, Automation.inInt arg16, Automation.inInt arg17, Automation.inInt arg18, Automation.inInt arg19, Automation.inInt arg20, Automation.inInt arg21, Automation.inInt arg22, Automation.inInt arg23, Automation.inInt arg24, Automation.inInt arg25, Automation.inInt arg26, Automation.inInt arg27, Automation.inInt arg28, Automation.inInt arg29, Automation.inInt arg30] Automation.outDouble
dollar :: Prelude.Double -> Prelude.Int -> IWorksheetFunction a -> Prelude.IO (Prelude.String)
dollar arg1 arg2 =
  Automation.function1 "Dollar" [Automation.inDouble arg1, Automation.inInt arg2] Automation.outString
fixed :: Prelude.Double -> Prelude.Int -> Prelude.Int -> IWorksheetFunction a -> Prelude.IO (Prelude.String)
fixed arg1 arg2 arg3 =
  Automation.function1 "Fixed" [Automation.inDouble arg1, Automation.inInt arg2, Automation.inInt arg3] Automation.outString
pi :: IWorksheetFunction a -> Prelude.IO (Prelude.Double)
pi = Automation.function1 "Pi" [] Automation.outDouble
ln :: Prelude.Double -> IWorksheetFunction a -> Prelude.IO (Prelude.Double)
ln arg1 =
  Automation.function1 "Ln" [Automation.inDouble arg1] Automation.outDouble
log10 :: Prelude.Double -> IWorksheetFunction a -> Prelude.IO (Prelude.Double)
log10 arg1 =
  Automation.function1 "Log10" [Automation.inDouble arg1] Automation.outDouble
round :: Prelude.Double -> Prelude.Double -> IWorksheetFunction a -> Prelude.IO (Prelude.Double)
round arg1 arg2 =
  Automation.function1 "Round" [Automation.inDouble arg1, Automation.inDouble arg2] Automation.outDouble
lookup :: Prelude.Int -> Prelude.Int -> Prelude.Int -> IWorksheetFunction a -> Prelude.IO (Prelude.Int)
lookup arg1 arg2 arg3 =
  Automation.function1 "Lookup" [Automation.inInt arg1, Automation.inInt arg2, Automation.inInt arg3] Automation.outInt
index :: Prelude.Int -> Prelude.Double -> Prelude.Int -> Prelude.Int -> IWorksheetFunction a -> Prelude.IO (Prelude.Int)
index arg1 arg2 arg3 arg4 =
  Automation.function1 "Index" [Automation.inInt arg1, Automation.inDouble arg2, Automation.inInt arg3, Automation.inInt arg4] Automation.outInt
rept :: Prelude.String -> Prelude.Double -> IWorksheetFunction a -> Prelude.IO (Prelude.String)
rept arg1 arg2 =
  Automation.function1 "Rept" [Automation.inString arg1, Automation.inDouble arg2] Automation.outString
and :: Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> IWorksheetFunction a -> Prelude.IO (Prelude.Int)
and arg1 arg2 arg3 arg4 arg5 arg6 arg7 arg8 arg9 arg10 arg11 arg12 arg13 arg14 arg15 arg16 arg17 arg18 arg19 arg20 arg21 arg22 arg23 arg24 arg25 arg26 arg27 arg28 arg29 arg30 =
  Automation.function1 "And" [Automation.inInt arg1, Automation.inInt arg2, Automation.inInt arg3, Automation.inInt arg4, Automation.inInt arg5, Automation.inInt arg6, Automation.inInt arg7, Automation.inInt arg8, Automation.inInt arg9, Automation.inInt arg10, Automation.inInt arg11, Automation.inInt arg12, Automation.inInt arg13, Automation.inInt arg14, Automation.inInt arg15, Automation.inInt arg16, Automation.inInt arg17, Automation.inInt arg18, Automation.inInt arg19, Automation.inInt arg20, Automation.inInt arg21, Automation.inInt arg22, Automation.inInt arg23, Automation.inInt arg24, Automation.inInt arg25, Automation.inInt arg26, Automation.inInt arg27, Automation.inInt arg28, Automation.inInt arg29, Automation.inInt arg30] Automation.outInt
or :: Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> IWorksheetFunction a -> Prelude.IO (Prelude.Int)
or arg1 arg2 arg3 arg4 arg5 arg6 arg7 arg8 arg9 arg10 arg11 arg12 arg13 arg14 arg15 arg16 arg17 arg18 arg19 arg20 arg21 arg22 arg23 arg24 arg25 arg26 arg27 arg28 arg29 arg30 =
  Automation.function1 "Or" [Automation.inInt arg1, Automation.inInt arg2, Automation.inInt arg3, Automation.inInt arg4, Automation.inInt arg5, Automation.inInt arg6, Automation.inInt arg7, Automation.inInt arg8, Automation.inInt arg9, Automation.inInt arg10, Automation.inInt arg11, Automation.inInt arg12, Automation.inInt arg13, Automation.inInt arg14, Automation.inInt arg15, Automation.inInt arg16, Automation.inInt arg17, Automation.inInt arg18, Automation.inInt arg19, Automation.inInt arg20, Automation.inInt arg21, Automation.inInt arg22, Automation.inInt arg23, Automation.inInt arg24, Automation.inInt arg25, Automation.inInt arg26, Automation.inInt arg27, Automation.inInt arg28, Automation.inInt arg29, Automation.inInt arg30] Automation.outInt
dCount :: IRange a0 -> Prelude.Int -> Prelude.Int -> IWorksheetFunction a -> Prelude.IO (Prelude.Double)
dCount arg1 arg2 arg3 =
  Automation.function1 "DCount" [Automation.inIDispatch arg1, Automation.inInt arg2, Automation.inInt arg3] Automation.outDouble
dSum :: IRange a0 -> Prelude.Int -> Prelude.Int -> IWorksheetFunction a -> Prelude.IO (Prelude.Double)
dSum arg1 arg2 arg3 =
  Automation.function1 "DSum" [Automation.inIDispatch arg1, Automation.inInt arg2, Automation.inInt arg3] Automation.outDouble
dAverage :: IRange a0 -> Prelude.Int -> Prelude.Int -> IWorksheetFunction a -> Prelude.IO (Prelude.Double)
dAverage arg1 arg2 arg3 =
  Automation.function1 "DAverage" [Automation.inIDispatch arg1, Automation.inInt arg2, Automation.inInt arg3] Automation.outDouble
dMin :: IRange a0 -> Prelude.Int -> Prelude.Int -> IWorksheetFunction a -> Prelude.IO (Prelude.Double)
dMin arg1 arg2 arg3 =
  Automation.function1 "DMin" [Automation.inIDispatch arg1, Automation.inInt arg2, Automation.inInt arg3] Automation.outDouble
dMax :: IRange a0 -> Prelude.Int -> Prelude.Int -> IWorksheetFunction a -> Prelude.IO (Prelude.Double)
dMax arg1 arg2 arg3 =
  Automation.function1 "DMax" [Automation.inIDispatch arg1, Automation.inInt arg2, Automation.inInt arg3] Automation.outDouble
dStDev :: IRange a0 -> Prelude.Int -> Prelude.Int -> IWorksheetFunction a -> Prelude.IO (Prelude.Double)
dStDev arg1 arg2 arg3 =
  Automation.function1 "DStDev" [Automation.inIDispatch arg1, Automation.inInt arg2, Automation.inInt arg3] Automation.outDouble
var :: Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> IWorksheetFunction a -> Prelude.IO (Prelude.Double)
var arg1 arg2 arg3 arg4 arg5 arg6 arg7 arg8 arg9 arg10 arg11 arg12 arg13 arg14 arg15 arg16 arg17 arg18 arg19 arg20 arg21 arg22 arg23 arg24 arg25 arg26 arg27 arg28 arg29 arg30 =
  Automation.function1 "Var" [Automation.inInt arg1, Automation.inInt arg2, Automation.inInt arg3, Automation.inInt arg4, Automation.inInt arg5, Automation.inInt arg6, Automation.inInt arg7, Automation.inInt arg8, Automation.inInt arg9, Automation.inInt arg10, Automation.inInt arg11, Automation.inInt arg12, Automation.inInt arg13, Automation.inInt arg14, Automation.inInt arg15, Automation.inInt arg16, Automation.inInt arg17, Automation.inInt arg18, Automation.inInt arg19, Automation.inInt arg20, Automation.inInt arg21, Automation.inInt arg22, Automation.inInt arg23, Automation.inInt arg24, Automation.inInt arg25, Automation.inInt arg26, Automation.inInt arg27, Automation.inInt arg28, Automation.inInt arg29, Automation.inInt arg30] Automation.outDouble
dVar :: IRange a0 -> Prelude.Int -> Prelude.Int -> IWorksheetFunction a -> Prelude.IO (Prelude.Double)
dVar arg1 arg2 arg3 =
  Automation.function1 "DVar" [Automation.inIDispatch arg1, Automation.inInt arg2, Automation.inInt arg3] Automation.outDouble
text :: Prelude.Int -> Prelude.String -> IWorksheetFunction a -> Prelude.IO (Prelude.String)
text arg1 arg2 =
  Automation.function1 "Text" [Automation.inInt arg1, Automation.inString arg2] Automation.outString
linEst :: Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> IWorksheetFunction a -> Prelude.IO (Prelude.Int)
linEst arg1 arg2 arg3 arg4 =
  Automation.function1 "LinEst" [Automation.inInt arg1, Automation.inInt arg2, Automation.inInt arg3, Automation.inInt arg4] Automation.outInt
trend :: Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> IWorksheetFunction a -> Prelude.IO (Prelude.Int)
trend arg1 arg2 arg3 arg4 =
  Automation.function1 "Trend" [Automation.inInt arg1, Automation.inInt arg2, Automation.inInt arg3, Automation.inInt arg4] Automation.outInt
logEst :: Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> IWorksheetFunction a -> Prelude.IO (Prelude.Int)
logEst arg1 arg2 arg3 arg4 =
  Automation.function1 "LogEst" [Automation.inInt arg1, Automation.inInt arg2, Automation.inInt arg3, Automation.inInt arg4] Automation.outInt
growth :: Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> IWorksheetFunction a -> Prelude.IO (Prelude.Int)
growth arg1 arg2 arg3 arg4 =
  Automation.function1 "Growth" [Automation.inInt arg1, Automation.inInt arg2, Automation.inInt arg3, Automation.inInt arg4] Automation.outInt
pv :: Prelude.Double -> Prelude.Double -> Prelude.Double -> Prelude.Int -> Prelude.Int -> IWorksheetFunction a -> Prelude.IO (Prelude.Double)
pv arg1 arg2 arg3 arg4 arg5 =
  Automation.function1 "Pv" [Automation.inDouble arg1, Automation.inDouble arg2, Automation.inDouble arg3, Automation.inInt arg4, Automation.inInt arg5] Automation.outDouble
fv :: Prelude.Double -> Prelude.Double -> Prelude.Double -> Prelude.Int -> Prelude.Int -> IWorksheetFunction a -> Prelude.IO (Prelude.Double)
fv arg1 arg2 arg3 arg4 arg5 =
  Automation.function1 "Fv" [Automation.inDouble arg1, Automation.inDouble arg2, Automation.inDouble arg3, Automation.inInt arg4, Automation.inInt arg5] Automation.outDouble
nPer :: Prelude.Double -> Prelude.Double -> Prelude.Double -> Prelude.Int -> Prelude.Int -> IWorksheetFunction a -> Prelude.IO (Prelude.Double)
nPer arg1 arg2 arg3 arg4 arg5 =
  Automation.function1 "NPer" [Automation.inDouble arg1, Automation.inDouble arg2, Automation.inDouble arg3, Automation.inInt arg4, Automation.inInt arg5] Automation.outDouble
pmt :: Prelude.Double -> Prelude.Double -> Prelude.Double -> Prelude.Int -> Prelude.Int -> IWorksheetFunction a -> Prelude.IO (Prelude.Double)
pmt arg1 arg2 arg3 arg4 arg5 =
  Automation.function1 "Pmt" [Automation.inDouble arg1, Automation.inDouble arg2, Automation.inDouble arg3, Automation.inInt arg4, Automation.inInt arg5] Automation.outDouble
rate :: Prelude.Double -> Prelude.Double -> Prelude.Double -> Prelude.Int -> Prelude.Int -> Prelude.Int -> IWorksheetFunction a -> Prelude.IO (Prelude.Double)
rate arg1 arg2 arg3 arg4 arg5 arg6 =
  Automation.function1 "Rate" [Automation.inDouble arg1, Automation.inDouble arg2, Automation.inDouble arg3, Automation.inInt arg4, Automation.inInt arg5, Automation.inInt arg6] Automation.outDouble
mIrr :: Prelude.Int -> Prelude.Double -> Prelude.Double -> IWorksheetFunction a -> Prelude.IO (Prelude.Double)
mIrr arg1 arg2 arg3 =
  Automation.function1 "MIrr" [Automation.inInt arg1, Automation.inDouble arg2, Automation.inDouble arg3] Automation.outDouble
irr :: Prelude.Int -> Prelude.Int -> IWorksheetFunction a -> Prelude.IO (Prelude.Double)
irr arg1 arg2 =
  Automation.function1 "Irr" [Automation.inInt arg1, Automation.inInt arg2] Automation.outDouble
match :: Prelude.Int -> Prelude.Int -> Prelude.Int -> IWorksheetFunction a -> Prelude.IO (Prelude.Double)
match arg1 arg2 arg3 =
  Automation.function1 "Match" [Automation.inInt arg1, Automation.inInt arg2, Automation.inInt arg3] Automation.outDouble
weekday :: Prelude.Int -> Prelude.Int -> IWorksheetFunction a -> Prelude.IO (Prelude.Double)
weekday arg1 arg2 =
  Automation.function1 "Weekday" [Automation.inInt arg1, Automation.inInt arg2] Automation.outDouble
search :: Prelude.String -> Prelude.String -> Prelude.Int -> IWorksheetFunction a -> Prelude.IO (Prelude.Double)
search arg1 arg2 arg3 =
  Automation.function1 "Search" [Automation.inString arg1, Automation.inString arg2, Automation.inInt arg3] Automation.outDouble
transpose :: Prelude.Int -> IWorksheetFunction a -> Prelude.IO (Prelude.Int)
transpose arg1 =
  Automation.function1 "Transpose" [Automation.inInt arg1] Automation.outInt
atan2 :: Prelude.Double -> Prelude.Double -> IWorksheetFunction a -> Prelude.IO (Prelude.Double)
atan2 arg1 arg2 =
  Automation.function1 "Atan2" [Automation.inDouble arg1, Automation.inDouble arg2] Automation.outDouble
asin :: Prelude.Double -> IWorksheetFunction a -> Prelude.IO (Prelude.Double)
asin arg1 =
  Automation.function1 "Asin" [Automation.inDouble arg1] Automation.outDouble
acos :: Prelude.Double -> IWorksheetFunction a -> Prelude.IO (Prelude.Double)
acos arg1 =
  Automation.function1 "Acos" [Automation.inDouble arg1] Automation.outDouble
choose :: Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> IWorksheetFunction a -> Prelude.IO (Prelude.Int)
choose arg1 arg2 arg3 arg4 arg5 arg6 arg7 arg8 arg9 arg10 arg11 arg12 arg13 arg14 arg15 arg16 arg17 arg18 arg19 arg20 arg21 arg22 arg23 arg24 arg25 arg26 arg27 arg28 arg29 arg30 =
  Automation.function1 "Choose" [Automation.inInt arg1, Automation.inInt arg2, Automation.inInt arg3, Automation.inInt arg4, Automation.inInt arg5, Automation.inInt arg6, Automation.inInt arg7, Automation.inInt arg8, Automation.inInt arg9, Automation.inInt arg10, Automation.inInt arg11, Automation.inInt arg12, Automation.inInt arg13, Automation.inInt arg14, Automation.inInt arg15, Automation.inInt arg16, Automation.inInt arg17, Automation.inInt arg18, Automation.inInt arg19, Automation.inInt arg20, Automation.inInt arg21, Automation.inInt arg22, Automation.inInt arg23, Automation.inInt arg24, Automation.inInt arg25, Automation.inInt arg26, Automation.inInt arg27, Automation.inInt arg28, Automation.inInt arg29, Automation.inInt arg30] Automation.outInt
hLookup :: Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> IWorksheetFunction a -> Prelude.IO (Prelude.Int)
hLookup arg1 arg2 arg3 arg4 =
  Automation.function1 "HLookup" [Automation.inInt arg1, Automation.inInt arg2, Automation.inInt arg3, Automation.inInt arg4] Automation.outInt
vLookup :: Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> IWorksheetFunction a -> Prelude.IO (Prelude.Int)
vLookup arg1 arg2 arg3 arg4 =
  Automation.function1 "VLookup" [Automation.inInt arg1, Automation.inInt arg2, Automation.inInt arg3, Automation.inInt arg4] Automation.outInt
log :: Prelude.Double -> Prelude.Int -> IWorksheetFunction a -> Prelude.IO (Prelude.Double)
log arg1 arg2 =
  Automation.function1 "Log" [Automation.inDouble arg1, Automation.inInt arg2] Automation.outDouble
proper :: Prelude.String -> IWorksheetFunction a -> Prelude.IO (Prelude.String)
proper arg1 =
  Automation.function1 "Proper" [Automation.inString arg1] Automation.outString
trim :: Prelude.String -> IWorksheetFunction a -> Prelude.IO (Prelude.String)
trim arg1 =
  Automation.function1 "Trim" [Automation.inString arg1] Automation.outString
replace :: Prelude.String -> Prelude.Double -> Prelude.Double -> Prelude.String -> IWorksheetFunction a -> Prelude.IO (Prelude.String)
replace arg1 arg2 arg3 arg4 =
  Automation.function1 "Replace" [Automation.inString arg1, Automation.inDouble arg2, Automation.inDouble arg3, Automation.inString arg4] Automation.outString
substitute :: Prelude.String -> Prelude.String -> Prelude.String -> Prelude.Int -> IWorksheetFunction a -> Prelude.IO (Prelude.String)
substitute arg1 arg2 arg3 arg4 =
  Automation.function1 "Substitute" [Automation.inString arg1, Automation.inString arg2, Automation.inString arg3, Automation.inInt arg4] Automation.outString
find :: Prelude.String -> Prelude.String -> Prelude.Int -> IWorksheetFunction a -> Prelude.IO (Prelude.Double)
find arg1 arg2 arg3 =
  Automation.function1 "Find" [Automation.inString arg1, Automation.inString arg2, Automation.inInt arg3] Automation.outDouble
isErr :: Prelude.Int -> IWorksheetFunction a -> Prelude.IO (Prelude.Int)
isErr arg1 =
  Automation.function1 "IsErr" [Automation.inInt arg1] Automation.outInt
isText :: Prelude.Int -> IWorksheetFunction a -> Prelude.IO (Prelude.Int)
isText arg1 =
  Automation.function1 "IsText" [Automation.inInt arg1] Automation.outInt
isNumber :: Prelude.Int -> IWorksheetFunction a -> Prelude.IO (Prelude.Int)
isNumber arg1 =
  Automation.function1 "IsNumber" [Automation.inInt arg1] Automation.outInt
sln :: Prelude.Double -> Prelude.Double -> Prelude.Double -> IWorksheetFunction a -> Prelude.IO (Prelude.Double)
sln arg1 arg2 arg3 =
  Automation.function1 "Sln" [Automation.inDouble arg1, Automation.inDouble arg2, Automation.inDouble arg3] Automation.outDouble
syd :: Prelude.Double -> Prelude.Double -> Prelude.Double -> Prelude.Double -> IWorksheetFunction a -> Prelude.IO (Prelude.Double)
syd arg1 arg2 arg3 arg4 =
  Automation.function1 "Syd" [Automation.inDouble arg1, Automation.inDouble arg2, Automation.inDouble arg3, Automation.inDouble arg4] Automation.outDouble
ddb :: Prelude.Double -> Prelude.Double -> Prelude.Double -> Prelude.Double -> Prelude.Int -> IWorksheetFunction a -> Prelude.IO (Prelude.Double)
ddb arg1 arg2 arg3 arg4 arg5 =
  Automation.function1 "Ddb" [Automation.inDouble arg1, Automation.inDouble arg2, Automation.inDouble arg3, Automation.inDouble arg4, Automation.inInt arg5] Automation.outDouble
clean :: Prelude.String -> IWorksheetFunction a -> Prelude.IO (Prelude.String)
clean arg1 =
  Automation.function1 "Clean" [Automation.inString arg1] Automation.outString
mDeterm :: Prelude.Int -> IWorksheetFunction a -> Prelude.IO (Prelude.Double)
mDeterm arg1 =
  Automation.function1 "MDeterm" [Automation.inInt arg1] Automation.outDouble
mInverse :: Prelude.Int -> IWorksheetFunction a -> Prelude.IO (Prelude.Int)
mInverse arg1 =
  Automation.function1 "MInverse" [Automation.inInt arg1] Automation.outInt
mMult :: Prelude.Int -> Prelude.Int -> IWorksheetFunction a -> Prelude.IO (Prelude.Int)
mMult arg1 arg2 =
  Automation.function1 "MMult" [Automation.inInt arg1, Automation.inInt arg2] Automation.outInt
ipmt :: Prelude.Double -> Prelude.Double -> Prelude.Double -> Prelude.Double -> Prelude.Int -> Prelude.Int -> IWorksheetFunction a -> Prelude.IO (Prelude.Double)
ipmt arg1 arg2 arg3 arg4 arg5 arg6 =
  Automation.function1 "Ipmt" [Automation.inDouble arg1, Automation.inDouble arg2, Automation.inDouble arg3, Automation.inDouble arg4, Automation.inInt arg5, Automation.inInt arg6] Automation.outDouble
ppmt :: Prelude.Double -> Prelude.Double -> Prelude.Double -> Prelude.Double -> Prelude.Int -> Prelude.Int -> IWorksheetFunction a -> Prelude.IO (Prelude.Double)
ppmt arg1 arg2 arg3 arg4 arg5 arg6 =
  Automation.function1 "Ppmt" [Automation.inDouble arg1, Automation.inDouble arg2, Automation.inDouble arg3, Automation.inDouble arg4, Automation.inInt arg5, Automation.inInt arg6] Automation.outDouble
countA :: Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> IWorksheetFunction a -> Prelude.IO (Prelude.Double)
countA arg1 arg2 arg3 arg4 arg5 arg6 arg7 arg8 arg9 arg10 arg11 arg12 arg13 arg14 arg15 arg16 arg17 arg18 arg19 arg20 arg21 arg22 arg23 arg24 arg25 arg26 arg27 arg28 arg29 arg30 =
  Automation.function1 "CountA" [Automation.inInt arg1, Automation.inInt arg2, Automation.inInt arg3, Automation.inInt arg4, Automation.inInt arg5, Automation.inInt arg6, Automation.inInt arg7, Automation.inInt arg8, Automation.inInt arg9, Automation.inInt arg10, Automation.inInt arg11, Automation.inInt arg12, Automation.inInt arg13, Automation.inInt arg14, Automation.inInt arg15, Automation.inInt arg16, Automation.inInt arg17, Automation.inInt arg18, Automation.inInt arg19, Automation.inInt arg20, Automation.inInt arg21, Automation.inInt arg22, Automation.inInt arg23, Automation.inInt arg24, Automation.inInt arg25, Automation.inInt arg26, Automation.inInt arg27, Automation.inInt arg28, Automation.inInt arg29, Automation.inInt arg30] Automation.outDouble
product :: Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> IWorksheetFunction a -> Prelude.IO (Prelude.Double)
product arg1 arg2 arg3 arg4 arg5 arg6 arg7 arg8 arg9 arg10 arg11 arg12 arg13 arg14 arg15 arg16 arg17 arg18 arg19 arg20 arg21 arg22 arg23 arg24 arg25 arg26 arg27 arg28 arg29 arg30 =
  Automation.function1 "Product" [Automation.inInt arg1, Automation.inInt arg2, Automation.inInt arg3, Automation.inInt arg4, Automation.inInt arg5, Automation.inInt arg6, Automation.inInt arg7, Automation.inInt arg8, Automation.inInt arg9, Automation.inInt arg10, Automation.inInt arg11, Automation.inInt arg12, Automation.inInt arg13, Automation.inInt arg14, Automation.inInt arg15, Automation.inInt arg16, Automation.inInt arg17, Automation.inInt arg18, Automation.inInt arg19, Automation.inInt arg20, Automation.inInt arg21, Automation.inInt arg22, Automation.inInt arg23, Automation.inInt arg24, Automation.inInt arg25, Automation.inInt arg26, Automation.inInt arg27, Automation.inInt arg28, Automation.inInt arg29, Automation.inInt arg30] Automation.outDouble
fact :: Prelude.Double -> IWorksheetFunction a -> Prelude.IO (Prelude.Double)
fact arg1 =
  Automation.function1 "Fact" [Automation.inDouble arg1] Automation.outDouble
dProduct :: IRange a0 -> Prelude.Int -> Prelude.Int -> IWorksheetFunction a -> Prelude.IO (Prelude.Double)
dProduct arg1 arg2 arg3 =
  Automation.function1 "DProduct" [Automation.inIDispatch arg1, Automation.inInt arg2, Automation.inInt arg3] Automation.outDouble
isNonText :: Prelude.Int -> IWorksheetFunction a -> Prelude.IO (Prelude.Int)
isNonText arg1 =
  Automation.function1 "IsNonText" [Automation.inInt arg1] Automation.outInt
stDevP :: Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> IWorksheetFunction a -> Prelude.IO (Prelude.Double)
stDevP arg1 arg2 arg3 arg4 arg5 arg6 arg7 arg8 arg9 arg10 arg11 arg12 arg13 arg14 arg15 arg16 arg17 arg18 arg19 arg20 arg21 arg22 arg23 arg24 arg25 arg26 arg27 arg28 arg29 arg30 =
  Automation.function1 "StDevP" [Automation.inInt arg1, Automation.inInt arg2, Automation.inInt arg3, Automation.inInt arg4, Automation.inInt arg5, Automation.inInt arg6, Automation.inInt arg7, Automation.inInt arg8, Automation.inInt arg9, Automation.inInt arg10, Automation.inInt arg11, Automation.inInt arg12, Automation.inInt arg13, Automation.inInt arg14, Automation.inInt arg15, Automation.inInt arg16, Automation.inInt arg17, Automation.inInt arg18, Automation.inInt arg19, Automation.inInt arg20, Automation.inInt arg21, Automation.inInt arg22, Automation.inInt arg23, Automation.inInt arg24, Automation.inInt arg25, Automation.inInt arg26, Automation.inInt arg27, Automation.inInt arg28, Automation.inInt arg29, Automation.inInt arg30] Automation.outDouble
varP :: Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> IWorksheetFunction a -> Prelude.IO (Prelude.Double)
varP arg1 arg2 arg3 arg4 arg5 arg6 arg7 arg8 arg9 arg10 arg11 arg12 arg13 arg14 arg15 arg16 arg17 arg18 arg19 arg20 arg21 arg22 arg23 arg24 arg25 arg26 arg27 arg28 arg29 arg30 =
  Automation.function1 "VarP" [Automation.inInt arg1, Automation.inInt arg2, Automation.inInt arg3, Automation.inInt arg4, Automation.inInt arg5, Automation.inInt arg6, Automation.inInt arg7, Automation.inInt arg8, Automation.inInt arg9, Automation.inInt arg10, Automation.inInt arg11, Automation.inInt arg12, Automation.inInt arg13, Automation.inInt arg14, Automation.inInt arg15, Automation.inInt arg16, Automation.inInt arg17, Automation.inInt arg18, Automation.inInt arg19, Automation.inInt arg20, Automation.inInt arg21, Automation.inInt arg22, Automation.inInt arg23, Automation.inInt arg24, Automation.inInt arg25, Automation.inInt arg26, Automation.inInt arg27, Automation.inInt arg28, Automation.inInt arg29, Automation.inInt arg30] Automation.outDouble
dStDevP :: IRange a0 -> Prelude.Int -> Prelude.Int -> IWorksheetFunction a -> Prelude.IO (Prelude.Double)
dStDevP arg1 arg2 arg3 =
  Automation.function1 "DStDevP" [Automation.inIDispatch arg1, Automation.inInt arg2, Automation.inInt arg3] Automation.outDouble
dVarP :: IRange a0 -> Prelude.Int -> Prelude.Int -> IWorksheetFunction a -> Prelude.IO (Prelude.Double)
dVarP arg1 arg2 arg3 =
  Automation.function1 "DVarP" [Automation.inIDispatch arg1, Automation.inInt arg2, Automation.inInt arg3] Automation.outDouble
isLogical :: Prelude.Int -> IWorksheetFunction a -> Prelude.IO (Prelude.Int)
isLogical arg1 =
  Automation.function1 "IsLogical" [Automation.inInt arg1] Automation.outInt
dCountA :: IRange a0 -> Prelude.Int -> Prelude.Int -> IWorksheetFunction a -> Prelude.IO (Prelude.Double)
dCountA arg1 arg2 arg3 =
  Automation.function1 "DCountA" [Automation.inIDispatch arg1, Automation.inInt arg2, Automation.inInt arg3] Automation.outDouble
uSDollar :: Prelude.Double -> Prelude.Double -> IWorksheetFunction a -> Prelude.IO (Prelude.String)
uSDollar arg1 arg2 =
  Automation.function1 "USDollar" [Automation.inDouble arg1, Automation.inDouble arg2] Automation.outString
findB :: Prelude.String -> Prelude.String -> Prelude.Int -> IWorksheetFunction a -> Prelude.IO (Prelude.Double)
findB arg1 arg2 arg3 =
  Automation.function1 "FindB" [Automation.inString arg1, Automation.inString arg2, Automation.inInt arg3] Automation.outDouble
searchB :: Prelude.String -> Prelude.String -> Prelude.Int -> IWorksheetFunction a -> Prelude.IO (Prelude.Double)
searchB arg1 arg2 arg3 =
  Automation.function1 "SearchB" [Automation.inString arg1, Automation.inString arg2, Automation.inInt arg3] Automation.outDouble
replaceB :: Prelude.String -> Prelude.Double -> Prelude.Double -> Prelude.String -> IWorksheetFunction a -> Prelude.IO (Prelude.String)
replaceB arg1 arg2 arg3 arg4 =
  Automation.function1 "ReplaceB" [Automation.inString arg1, Automation.inDouble arg2, Automation.inDouble arg3, Automation.inString arg4] Automation.outString
roundUp :: Prelude.Double -> Prelude.Double -> IWorksheetFunction a -> Prelude.IO (Prelude.Double)
roundUp arg1 arg2 =
  Automation.function1 "RoundUp" [Automation.inDouble arg1, Automation.inDouble arg2] Automation.outDouble
roundDown :: Prelude.Double -> Prelude.Double -> IWorksheetFunction a -> Prelude.IO (Prelude.Double)
roundDown arg1 arg2 =
  Automation.function1 "RoundDown" [Automation.inDouble arg1, Automation.inDouble arg2] Automation.outDouble
rank :: Prelude.Double -> IRange a0 -> Prelude.Int -> IWorksheetFunction a -> Prelude.IO (Prelude.Double)
rank arg1 arg2 arg3 =
  Automation.function1 "Rank" [Automation.inDouble arg1, Automation.inIDispatch arg2, Automation.inInt arg3] Automation.outDouble
days360 :: Prelude.Int -> Prelude.Int -> Prelude.Int -> IWorksheetFunction a -> Prelude.IO (Prelude.Double)
days360 arg1 arg2 arg3 =
  Automation.function1 "Days360" [Automation.inInt arg1, Automation.inInt arg2, Automation.inInt arg3] Automation.outDouble
vdb :: Prelude.Double -> Prelude.Double -> Prelude.Double -> Prelude.Double -> Prelude.Double -> Prelude.Int -> Prelude.Int -> IWorksheetFunction a -> Prelude.IO (Prelude.Double)
vdb arg1 arg2 arg3 arg4 arg5 arg6 arg7 =
  Automation.function1 "Vdb" [Automation.inDouble arg1, Automation.inDouble arg2, Automation.inDouble arg3, Automation.inDouble arg4, Automation.inDouble arg5, Automation.inInt arg6, Automation.inInt arg7] Automation.outDouble
median :: Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> IWorksheetFunction a -> Prelude.IO (Prelude.Double)
median arg1 arg2 arg3 arg4 arg5 arg6 arg7 arg8 arg9 arg10 arg11 arg12 arg13 arg14 arg15 arg16 arg17 arg18 arg19 arg20 arg21 arg22 arg23 arg24 arg25 arg26 arg27 arg28 arg29 arg30 =
  Automation.function1 "Median" [Automation.inInt arg1, Automation.inInt arg2, Automation.inInt arg3, Automation.inInt arg4, Automation.inInt arg5, Automation.inInt arg6, Automation.inInt arg7, Automation.inInt arg8, Automation.inInt arg9, Automation.inInt arg10, Automation.inInt arg11, Automation.inInt arg12, Automation.inInt arg13, Automation.inInt arg14, Automation.inInt arg15, Automation.inInt arg16, Automation.inInt arg17, Automation.inInt arg18, Automation.inInt arg19, Automation.inInt arg20, Automation.inInt arg21, Automation.inInt arg22, Automation.inInt arg23, Automation.inInt arg24, Automation.inInt arg25, Automation.inInt arg26, Automation.inInt arg27, Automation.inInt arg28, Automation.inInt arg29, Automation.inInt arg30] Automation.outDouble
sumProduct :: Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> IWorksheetFunction a -> Prelude.IO (Prelude.Double)
sumProduct arg1 arg2 arg3 arg4 arg5 arg6 arg7 arg8 arg9 arg10 arg11 arg12 arg13 arg14 arg15 arg16 arg17 arg18 arg19 arg20 arg21 arg22 arg23 arg24 arg25 arg26 arg27 arg28 arg29 arg30 =
  Automation.function1 "SumProduct" [Automation.inInt arg1, Automation.inInt arg2, Automation.inInt arg3, Automation.inInt arg4, Automation.inInt arg5, Automation.inInt arg6, Automation.inInt arg7, Automation.inInt arg8, Automation.inInt arg9, Automation.inInt arg10, Automation.inInt arg11, Automation.inInt arg12, Automation.inInt arg13, Automation.inInt arg14, Automation.inInt arg15, Automation.inInt arg16, Automation.inInt arg17, Automation.inInt arg18, Automation.inInt arg19, Automation.inInt arg20, Automation.inInt arg21, Automation.inInt arg22, Automation.inInt arg23, Automation.inInt arg24, Automation.inInt arg25, Automation.inInt arg26, Automation.inInt arg27, Automation.inInt arg28, Automation.inInt arg29, Automation.inInt arg30] Automation.outDouble
sinh :: Prelude.Double -> IWorksheetFunction a -> Prelude.IO (Prelude.Double)
sinh arg1 =
  Automation.function1 "Sinh" [Automation.inDouble arg1] Automation.outDouble
cosh :: Prelude.Double -> IWorksheetFunction a -> Prelude.IO (Prelude.Double)
cosh arg1 =
  Automation.function1 "Cosh" [Automation.inDouble arg1] Automation.outDouble
tanh :: Prelude.Double -> IWorksheetFunction a -> Prelude.IO (Prelude.Double)
tanh arg1 =
  Automation.function1 "Tanh" [Automation.inDouble arg1] Automation.outDouble
asinh :: Prelude.Double -> IWorksheetFunction a -> Prelude.IO (Prelude.Double)
asinh arg1 =
  Automation.function1 "Asinh" [Automation.inDouble arg1] Automation.outDouble
acosh :: Prelude.Double -> IWorksheetFunction a -> Prelude.IO (Prelude.Double)
acosh arg1 =
  Automation.function1 "Acosh" [Automation.inDouble arg1] Automation.outDouble
atanh :: Prelude.Double -> IWorksheetFunction a -> Prelude.IO (Prelude.Double)
atanh arg1 =
  Automation.function1 "Atanh" [Automation.inDouble arg1] Automation.outDouble
dGet :: IRange a0 -> Prelude.Int -> Prelude.Int -> IWorksheetFunction a -> Prelude.IO (Prelude.Int)
dGet arg1 arg2 arg3 =
  Automation.function1 "DGet" [Automation.inIDispatch arg1, Automation.inInt arg2, Automation.inInt arg3] Automation.outInt
db :: Prelude.Double -> Prelude.Double -> Prelude.Double -> Prelude.Double -> Prelude.Int -> IWorksheetFunction a -> Prelude.IO (Prelude.Double)
db arg1 arg2 arg3 arg4 arg5 =
  Automation.function1 "Db" [Automation.inDouble arg1, Automation.inDouble arg2, Automation.inDouble arg3, Automation.inDouble arg4, Automation.inInt arg5] Automation.outDouble
frequency :: Prelude.Int -> Prelude.Int -> IWorksheetFunction a -> Prelude.IO (Prelude.Int)
frequency arg1 arg2 =
  Automation.function1 "Frequency" [Automation.inInt arg1, Automation.inInt arg2] Automation.outInt
aveDev :: Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> IWorksheetFunction a -> Prelude.IO (Prelude.Double)
aveDev arg1 arg2 arg3 arg4 arg5 arg6 arg7 arg8 arg9 arg10 arg11 arg12 arg13 arg14 arg15 arg16 arg17 arg18 arg19 arg20 arg21 arg22 arg23 arg24 arg25 arg26 arg27 arg28 arg29 arg30 =
  Automation.function1 "AveDev" [Automation.inInt arg1, Automation.inInt arg2, Automation.inInt arg3, Automation.inInt arg4, Automation.inInt arg5, Automation.inInt arg6, Automation.inInt arg7, Automation.inInt arg8, Automation.inInt arg9, Automation.inInt arg10, Automation.inInt arg11, Automation.inInt arg12, Automation.inInt arg13, Automation.inInt arg14, Automation.inInt arg15, Automation.inInt arg16, Automation.inInt arg17, Automation.inInt arg18, Automation.inInt arg19, Automation.inInt arg20, Automation.inInt arg21, Automation.inInt arg22, Automation.inInt arg23, Automation.inInt arg24, Automation.inInt arg25, Automation.inInt arg26, Automation.inInt arg27, Automation.inInt arg28, Automation.inInt arg29, Automation.inInt arg30] Automation.outDouble
betaDist :: Prelude.Double -> Prelude.Double -> Prelude.Double -> Prelude.Int -> Prelude.Int -> IWorksheetFunction a -> Prelude.IO (Prelude.Double)
betaDist arg1 arg2 arg3 arg4 arg5 =
  Automation.function1 "BetaDist" [Automation.inDouble arg1, Automation.inDouble arg2, Automation.inDouble arg3, Automation.inInt arg4, Automation.inInt arg5] Automation.outDouble
gammaLn :: Prelude.Double -> IWorksheetFunction a -> Prelude.IO (Prelude.Double)
gammaLn arg1 =
  Automation.function1 "GammaLn" [Automation.inDouble arg1] Automation.outDouble
betaInv :: Prelude.Double -> Prelude.Double -> Prelude.Double -> Prelude.Int -> Prelude.Int -> IWorksheetFunction a -> Prelude.IO (Prelude.Double)
betaInv arg1 arg2 arg3 arg4 arg5 =
  Automation.function1 "BetaInv" [Automation.inDouble arg1, Automation.inDouble arg2, Automation.inDouble arg3, Automation.inInt arg4, Automation.inInt arg5] Automation.outDouble
binomDist :: Prelude.Double -> Prelude.Double -> Prelude.Double -> Prelude.Int -> IWorksheetFunction a -> Prelude.IO (Prelude.Double)
binomDist arg1 arg2 arg3 arg4 =
  Automation.function1 "BinomDist" [Automation.inDouble arg1, Automation.inDouble arg2, Automation.inDouble arg3, Automation.inInt arg4] Automation.outDouble
chiDist :: Prelude.Double -> Prelude.Double -> IWorksheetFunction a -> Prelude.IO (Prelude.Double)
chiDist arg1 arg2 =
  Automation.function1 "ChiDist" [Automation.inDouble arg1, Automation.inDouble arg2] Automation.outDouble
chiInv :: Prelude.Double -> Prelude.Double -> IWorksheetFunction a -> Prelude.IO (Prelude.Double)
chiInv arg1 arg2 =
  Automation.function1 "ChiInv" [Automation.inDouble arg1, Automation.inDouble arg2] Automation.outDouble
combin :: Prelude.Double -> Prelude.Double -> IWorksheetFunction a -> Prelude.IO (Prelude.Double)
combin arg1 arg2 =
  Automation.function1 "Combin" [Automation.inDouble arg1, Automation.inDouble arg2] Automation.outDouble
confidence :: Prelude.Double -> Prelude.Double -> Prelude.Double -> IWorksheetFunction a -> Prelude.IO (Prelude.Double)
confidence arg1 arg2 arg3 =
  Automation.function1 "Confidence" [Automation.inDouble arg1, Automation.inDouble arg2, Automation.inDouble arg3] Automation.outDouble
critBinom :: Prelude.Double -> Prelude.Double -> Prelude.Double -> IWorksheetFunction a -> Prelude.IO (Prelude.Double)
critBinom arg1 arg2 arg3 =
  Automation.function1 "CritBinom" [Automation.inDouble arg1, Automation.inDouble arg2, Automation.inDouble arg3] Automation.outDouble
even :: Prelude.Double -> IWorksheetFunction a -> Prelude.IO (Prelude.Double)
even arg1 =
  Automation.function1 "Even" [Automation.inDouble arg1] Automation.outDouble
exponDist :: Prelude.Double -> Prelude.Double -> Prelude.Int -> IWorksheetFunction a -> Prelude.IO (Prelude.Double)
exponDist arg1 arg2 arg3 =
  Automation.function1 "ExponDist" [Automation.inDouble arg1, Automation.inDouble arg2, Automation.inInt arg3] Automation.outDouble
fDist :: Prelude.Double -> Prelude.Double -> Prelude.Double -> IWorksheetFunction a -> Prelude.IO (Prelude.Double)
fDist arg1 arg2 arg3 =
  Automation.function1 "FDist" [Automation.inDouble arg1, Automation.inDouble arg2, Automation.inDouble arg3] Automation.outDouble
fInv :: Prelude.Double -> Prelude.Double -> Prelude.Double -> IWorksheetFunction a -> Prelude.IO (Prelude.Double)
fInv arg1 arg2 arg3 =
  Automation.function1 "FInv" [Automation.inDouble arg1, Automation.inDouble arg2, Automation.inDouble arg3] Automation.outDouble
fisher :: Prelude.Double -> IWorksheetFunction a -> Prelude.IO (Prelude.Double)
fisher arg1 =
  Automation.function1 "Fisher" [Automation.inDouble arg1] Automation.outDouble
fisherInv :: Prelude.Double -> IWorksheetFunction a -> Prelude.IO (Prelude.Double)
fisherInv arg1 =
  Automation.function1 "FisherInv" [Automation.inDouble arg1] Automation.outDouble
floor :: Prelude.Double -> Prelude.Double -> IWorksheetFunction a -> Prelude.IO (Prelude.Double)
floor arg1 arg2 =
  Automation.function1 "Floor" [Automation.inDouble arg1, Automation.inDouble arg2] Automation.outDouble
gammaDist :: Prelude.Double -> Prelude.Double -> Prelude.Double -> Prelude.Int -> IWorksheetFunction a -> Prelude.IO (Prelude.Double)
gammaDist arg1 arg2 arg3 arg4 =
  Automation.function1 "GammaDist" [Automation.inDouble arg1, Automation.inDouble arg2, Automation.inDouble arg3, Automation.inInt arg4] Automation.outDouble
gammaInv :: Prelude.Double -> Prelude.Double -> Prelude.Double -> IWorksheetFunction a -> Prelude.IO (Prelude.Double)
gammaInv arg1 arg2 arg3 =
  Automation.function1 "GammaInv" [Automation.inDouble arg1, Automation.inDouble arg2, Automation.inDouble arg3] Automation.outDouble
ceiling :: Prelude.Double -> Prelude.Double -> IWorksheetFunction a -> Prelude.IO (Prelude.Double)
ceiling arg1 arg2 =
  Automation.function1 "Ceiling" [Automation.inDouble arg1, Automation.inDouble arg2] Automation.outDouble
hypGeomDist :: Prelude.Double -> Prelude.Double -> Prelude.Double -> Prelude.Double -> IWorksheetFunction a -> Prelude.IO (Prelude.Double)
hypGeomDist arg1 arg2 arg3 arg4 =
  Automation.function1 "HypGeomDist" [Automation.inDouble arg1, Automation.inDouble arg2, Automation.inDouble arg3, Automation.inDouble arg4] Automation.outDouble
logNormDist :: Prelude.Double -> Prelude.Double -> Prelude.Double -> IWorksheetFunction a -> Prelude.IO (Prelude.Double)
logNormDist arg1 arg2 arg3 =
  Automation.function1 "LogNormDist" [Automation.inDouble arg1, Automation.inDouble arg2, Automation.inDouble arg3] Automation.outDouble
logInv :: Prelude.Double -> Prelude.Double -> Prelude.Double -> IWorksheetFunction a -> Prelude.IO (Prelude.Double)
logInv arg1 arg2 arg3 =
  Automation.function1 "LogInv" [Automation.inDouble arg1, Automation.inDouble arg2, Automation.inDouble arg3] Automation.outDouble
negBinomDist :: Prelude.Double -> Prelude.Double -> Prelude.Double -> IWorksheetFunction a -> Prelude.IO (Prelude.Double)
negBinomDist arg1 arg2 arg3 =
  Automation.function1 "NegBinomDist" [Automation.inDouble arg1, Automation.inDouble arg2, Automation.inDouble arg3] Automation.outDouble
normDist :: Prelude.Double -> Prelude.Double -> Prelude.Double -> Prelude.Int -> IWorksheetFunction a -> Prelude.IO (Prelude.Double)
normDist arg1 arg2 arg3 arg4 =
  Automation.function1 "NormDist" [Automation.inDouble arg1, Automation.inDouble arg2, Automation.inDouble arg3, Automation.inInt arg4] Automation.outDouble
normSDist :: Prelude.Double -> IWorksheetFunction a -> Prelude.IO (Prelude.Double)
normSDist arg1 =
  Automation.function1 "NormSDist" [Automation.inDouble arg1] Automation.outDouble
normInv :: Prelude.Double -> Prelude.Double -> Prelude.Double -> IWorksheetFunction a -> Prelude.IO (Prelude.Double)
normInv arg1 arg2 arg3 =
  Automation.function1 "NormInv" [Automation.inDouble arg1, Automation.inDouble arg2, Automation.inDouble arg3] Automation.outDouble
normSInv :: Prelude.Double -> IWorksheetFunction a -> Prelude.IO (Prelude.Double)
normSInv arg1 =
  Automation.function1 "NormSInv" [Automation.inDouble arg1] Automation.outDouble
standardize :: Prelude.Double -> Prelude.Double -> Prelude.Double -> IWorksheetFunction a -> Prelude.IO (Prelude.Double)
standardize arg1 arg2 arg3 =
  Automation.function1 "Standardize" [Automation.inDouble arg1, Automation.inDouble arg2, Automation.inDouble arg3] Automation.outDouble
odd :: Prelude.Double -> IWorksheetFunction a -> Prelude.IO (Prelude.Double)
odd arg1 =
  Automation.function1 "Odd" [Automation.inDouble arg1] Automation.outDouble
permut :: Prelude.Double -> Prelude.Double -> IWorksheetFunction a -> Prelude.IO (Prelude.Double)
permut arg1 arg2 =
  Automation.function1 "Permut" [Automation.inDouble arg1, Automation.inDouble arg2] Automation.outDouble
poisson :: Prelude.Double -> Prelude.Double -> Prelude.Int -> IWorksheetFunction a -> Prelude.IO (Prelude.Double)
poisson arg1 arg2 arg3 =
  Automation.function1 "Poisson" [Automation.inDouble arg1, Automation.inDouble arg2, Automation.inInt arg3] Automation.outDouble
tDist :: Prelude.Double -> Prelude.Double -> Prelude.Double -> IWorksheetFunction a -> Prelude.IO (Prelude.Double)
tDist arg1 arg2 arg3 =
  Automation.function1 "TDist" [Automation.inDouble arg1, Automation.inDouble arg2, Automation.inDouble arg3] Automation.outDouble
weibull :: Prelude.Double -> Prelude.Double -> Prelude.Double -> Prelude.Int -> IWorksheetFunction a -> Prelude.IO (Prelude.Double)
weibull arg1 arg2 arg3 arg4 =
  Automation.function1 "Weibull" [Automation.inDouble arg1, Automation.inDouble arg2, Automation.inDouble arg3, Automation.inInt arg4] Automation.outDouble
sumXMY2 :: Prelude.Int -> Prelude.Int -> IWorksheetFunction a -> Prelude.IO (Prelude.Double)
sumXMY2 arg1 arg2 =
  Automation.function1 "SumXMY2" [Automation.inInt arg1, Automation.inInt arg2] Automation.outDouble
sumX2MY2 :: Prelude.Int -> Prelude.Int -> IWorksheetFunction a -> Prelude.IO (Prelude.Double)
sumX2MY2 arg1 arg2 =
  Automation.function1 "SumX2MY2" [Automation.inInt arg1, Automation.inInt arg2] Automation.outDouble
sumX2PY2 :: Prelude.Int -> Prelude.Int -> IWorksheetFunction a -> Prelude.IO (Prelude.Double)
sumX2PY2 arg1 arg2 =
  Automation.function1 "SumX2PY2" [Automation.inInt arg1, Automation.inInt arg2] Automation.outDouble
chiTest :: Prelude.Int -> Prelude.Int -> IWorksheetFunction a -> Prelude.IO (Prelude.Double)
chiTest arg1 arg2 =
  Automation.function1 "ChiTest" [Automation.inInt arg1, Automation.inInt arg2] Automation.outDouble
correl :: Prelude.Int -> Prelude.Int -> IWorksheetFunction a -> Prelude.IO (Prelude.Double)
correl arg1 arg2 =
  Automation.function1 "Correl" [Automation.inInt arg1, Automation.inInt arg2] Automation.outDouble
covar :: Prelude.Int -> Prelude.Int -> IWorksheetFunction a -> Prelude.IO (Prelude.Double)
covar arg1 arg2 =
  Automation.function1 "Covar" [Automation.inInt arg1, Automation.inInt arg2] Automation.outDouble
forecast :: Prelude.Double -> Prelude.Int -> Prelude.Int -> IWorksheetFunction a -> Prelude.IO (Prelude.Double)
forecast arg1 arg2 arg3 =
  Automation.function1 "Forecast" [Automation.inDouble arg1, Automation.inInt arg2, Automation.inInt arg3] Automation.outDouble
fTest :: Prelude.Int -> Prelude.Int -> IWorksheetFunction a -> Prelude.IO (Prelude.Double)
fTest arg1 arg2 =
  Automation.function1 "FTest" [Automation.inInt arg1, Automation.inInt arg2] Automation.outDouble
intercept :: Prelude.Int -> Prelude.Int -> IWorksheetFunction a -> Prelude.IO (Prelude.Double)
intercept arg1 arg2 =
  Automation.function1 "Intercept" [Automation.inInt arg1, Automation.inInt arg2] Automation.outDouble
pearson :: Prelude.Int -> Prelude.Int -> IWorksheetFunction a -> Prelude.IO (Prelude.Double)
pearson arg1 arg2 =
  Automation.function1 "Pearson" [Automation.inInt arg1, Automation.inInt arg2] Automation.outDouble
rSq :: Prelude.Int -> Prelude.Int -> IWorksheetFunction a -> Prelude.IO (Prelude.Double)
rSq arg1 arg2 =
  Automation.function1 "RSq" [Automation.inInt arg1, Automation.inInt arg2] Automation.outDouble
stEyx :: Prelude.Int -> Prelude.Int -> IWorksheetFunction a -> Prelude.IO (Prelude.Double)
stEyx arg1 arg2 =
  Automation.function1 "StEyx" [Automation.inInt arg1, Automation.inInt arg2] Automation.outDouble
slope :: Prelude.Int -> Prelude.Int -> IWorksheetFunction a -> Prelude.IO (Prelude.Double)
slope arg1 arg2 =
  Automation.function1 "Slope" [Automation.inInt arg1, Automation.inInt arg2] Automation.outDouble
tTest :: Prelude.Int -> Prelude.Int -> Prelude.Double -> Prelude.Double -> IWorksheetFunction a -> Prelude.IO (Prelude.Double)
tTest arg1 arg2 arg3 arg4 =
  Automation.function1 "TTest" [Automation.inInt arg1, Automation.inInt arg2, Automation.inDouble arg3, Automation.inDouble arg4] Automation.outDouble
prob :: Prelude.Int -> Prelude.Int -> Prelude.Double -> Prelude.Int -> IWorksheetFunction a -> Prelude.IO (Prelude.Double)
prob arg1 arg2 arg3 arg4 =
  Automation.function1 "Prob" [Automation.inInt arg1, Automation.inInt arg2, Automation.inDouble arg3, Automation.inInt arg4] Automation.outDouble
devSq :: Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> IWorksheetFunction a -> Prelude.IO (Prelude.Double)
devSq arg1 arg2 arg3 arg4 arg5 arg6 arg7 arg8 arg9 arg10 arg11 arg12 arg13 arg14 arg15 arg16 arg17 arg18 arg19 arg20 arg21 arg22 arg23 arg24 arg25 arg26 arg27 arg28 arg29 arg30 =
  Automation.function1 "DevSq" [Automation.inInt arg1, Automation.inInt arg2, Automation.inInt arg3, Automation.inInt arg4, Automation.inInt arg5, Automation.inInt arg6, Automation.inInt arg7, Automation.inInt arg8, Automation.inInt arg9, Automation.inInt arg10, Automation.inInt arg11, Automation.inInt arg12, Automation.inInt arg13, Automation.inInt arg14, Automation.inInt arg15, Automation.inInt arg16, Automation.inInt arg17, Automation.inInt arg18, Automation.inInt arg19, Automation.inInt arg20, Automation.inInt arg21, Automation.inInt arg22, Automation.inInt arg23, Automation.inInt arg24, Automation.inInt arg25, Automation.inInt arg26, Automation.inInt arg27, Automation.inInt arg28, Automation.inInt arg29, Automation.inInt arg30] Automation.outDouble
geoMean :: Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> IWorksheetFunction a -> Prelude.IO (Prelude.Double)
geoMean arg1 arg2 arg3 arg4 arg5 arg6 arg7 arg8 arg9 arg10 arg11 arg12 arg13 arg14 arg15 arg16 arg17 arg18 arg19 arg20 arg21 arg22 arg23 arg24 arg25 arg26 arg27 arg28 arg29 arg30 =
  Automation.function1 "GeoMean" [Automation.inInt arg1, Automation.inInt arg2, Automation.inInt arg3, Automation.inInt arg4, Automation.inInt arg5, Automation.inInt arg6, Automation.inInt arg7, Automation.inInt arg8, Automation.inInt arg9, Automation.inInt arg10, Automation.inInt arg11, Automation.inInt arg12, Automation.inInt arg13, Automation.inInt arg14, Automation.inInt arg15, Automation.inInt arg16, Automation.inInt arg17, Automation.inInt arg18, Automation.inInt arg19, Automation.inInt arg20, Automation.inInt arg21, Automation.inInt arg22, Automation.inInt arg23, Automation.inInt arg24, Automation.inInt arg25, Automation.inInt arg26, Automation.inInt arg27, Automation.inInt arg28, Automation.inInt arg29, Automation.inInt arg30] Automation.outDouble
harMean :: Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> IWorksheetFunction a -> Prelude.IO (Prelude.Double)
harMean arg1 arg2 arg3 arg4 arg5 arg6 arg7 arg8 arg9 arg10 arg11 arg12 arg13 arg14 arg15 arg16 arg17 arg18 arg19 arg20 arg21 arg22 arg23 arg24 arg25 arg26 arg27 arg28 arg29 arg30 =
  Automation.function1 "HarMean" [Automation.inInt arg1, Automation.inInt arg2, Automation.inInt arg3, Automation.inInt arg4, Automation.inInt arg5, Automation.inInt arg6, Automation.inInt arg7, Automation.inInt arg8, Automation.inInt arg9, Automation.inInt arg10, Automation.inInt arg11, Automation.inInt arg12, Automation.inInt arg13, Automation.inInt arg14, Automation.inInt arg15, Automation.inInt arg16, Automation.inInt arg17, Automation.inInt arg18, Automation.inInt arg19, Automation.inInt arg20, Automation.inInt arg21, Automation.inInt arg22, Automation.inInt arg23, Automation.inInt arg24, Automation.inInt arg25, Automation.inInt arg26, Automation.inInt arg27, Automation.inInt arg28, Automation.inInt arg29, Automation.inInt arg30] Automation.outDouble
sumSq :: Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> IWorksheetFunction a -> Prelude.IO (Prelude.Double)
sumSq arg1 arg2 arg3 arg4 arg5 arg6 arg7 arg8 arg9 arg10 arg11 arg12 arg13 arg14 arg15 arg16 arg17 arg18 arg19 arg20 arg21 arg22 arg23 arg24 arg25 arg26 arg27 arg28 arg29 arg30 =
  Automation.function1 "SumSq" [Automation.inInt arg1, Automation.inInt arg2, Automation.inInt arg3, Automation.inInt arg4, Automation.inInt arg5, Automation.inInt arg6, Automation.inInt arg7, Automation.inInt arg8, Automation.inInt arg9, Automation.inInt arg10, Automation.inInt arg11, Automation.inInt arg12, Automation.inInt arg13, Automation.inInt arg14, Automation.inInt arg15, Automation.inInt arg16, Automation.inInt arg17, Automation.inInt arg18, Automation.inInt arg19, Automation.inInt arg20, Automation.inInt arg21, Automation.inInt arg22, Automation.inInt arg23, Automation.inInt arg24, Automation.inInt arg25, Automation.inInt arg26, Automation.inInt arg27, Automation.inInt arg28, Automation.inInt arg29, Automation.inInt arg30] Automation.outDouble
kurt :: Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> IWorksheetFunction a -> Prelude.IO (Prelude.Double)
kurt arg1 arg2 arg3 arg4 arg5 arg6 arg7 arg8 arg9 arg10 arg11 arg12 arg13 arg14 arg15 arg16 arg17 arg18 arg19 arg20 arg21 arg22 arg23 arg24 arg25 arg26 arg27 arg28 arg29 arg30 =
  Automation.function1 "Kurt" [Automation.inInt arg1, Automation.inInt arg2, Automation.inInt arg3, Automation.inInt arg4, Automation.inInt arg5, Automation.inInt arg6, Automation.inInt arg7, Automation.inInt arg8, Automation.inInt arg9, Automation.inInt arg10, Automation.inInt arg11, Automation.inInt arg12, Automation.inInt arg13, Automation.inInt arg14, Automation.inInt arg15, Automation.inInt arg16, Automation.inInt arg17, Automation.inInt arg18, Automation.inInt arg19, Automation.inInt arg20, Automation.inInt arg21, Automation.inInt arg22, Automation.inInt arg23, Automation.inInt arg24, Automation.inInt arg25, Automation.inInt arg26, Automation.inInt arg27, Automation.inInt arg28, Automation.inInt arg29, Automation.inInt arg30] Automation.outDouble
skew :: Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> IWorksheetFunction a -> Prelude.IO (Prelude.Double)
skew arg1 arg2 arg3 arg4 arg5 arg6 arg7 arg8 arg9 arg10 arg11 arg12 arg13 arg14 arg15 arg16 arg17 arg18 arg19 arg20 arg21 arg22 arg23 arg24 arg25 arg26 arg27 arg28 arg29 arg30 =
  Automation.function1 "Skew" [Automation.inInt arg1, Automation.inInt arg2, Automation.inInt arg3, Automation.inInt arg4, Automation.inInt arg5, Automation.inInt arg6, Automation.inInt arg7, Automation.inInt arg8, Automation.inInt arg9, Automation.inInt arg10, Automation.inInt arg11, Automation.inInt arg12, Automation.inInt arg13, Automation.inInt arg14, Automation.inInt arg15, Automation.inInt arg16, Automation.inInt arg17, Automation.inInt arg18, Automation.inInt arg19, Automation.inInt arg20, Automation.inInt arg21, Automation.inInt arg22, Automation.inInt arg23, Automation.inInt arg24, Automation.inInt arg25, Automation.inInt arg26, Automation.inInt arg27, Automation.inInt arg28, Automation.inInt arg29, Automation.inInt arg30] Automation.outDouble
zTest :: Prelude.Int -> Prelude.Double -> Prelude.Int -> IWorksheetFunction a -> Prelude.IO (Prelude.Double)
zTest arg1 arg2 arg3 =
  Automation.function1 "ZTest" [Automation.inInt arg1, Automation.inDouble arg2, Automation.inInt arg3] Automation.outDouble
large :: Prelude.Int -> Prelude.Double -> IWorksheetFunction a -> Prelude.IO (Prelude.Double)
large arg1 arg2 =
  Automation.function1 "Large" [Automation.inInt arg1, Automation.inDouble arg2] Automation.outDouble
small :: Prelude.Int -> Prelude.Double -> IWorksheetFunction a -> Prelude.IO (Prelude.Double)
small arg1 arg2 =
  Automation.function1 "Small" [Automation.inInt arg1, Automation.inDouble arg2] Automation.outDouble
quartile :: Prelude.Int -> Prelude.Double -> IWorksheetFunction a -> Prelude.IO (Prelude.Double)
quartile arg1 arg2 =
  Automation.function1 "Quartile" [Automation.inInt arg1, Automation.inDouble arg2] Automation.outDouble
percentile :: Prelude.Int -> Prelude.Double -> IWorksheetFunction a -> Prelude.IO (Prelude.Double)
percentile arg1 arg2 =
  Automation.function1 "Percentile" [Automation.inInt arg1, Automation.inDouble arg2] Automation.outDouble
percentRank :: Prelude.Int -> Prelude.Double -> Prelude.Int -> IWorksheetFunction a -> Prelude.IO (Prelude.Double)
percentRank arg1 arg2 arg3 =
  Automation.function1 "PercentRank" [Automation.inInt arg1, Automation.inDouble arg2, Automation.inInt arg3] Automation.outDouble
mode :: Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> IWorksheetFunction a -> Prelude.IO (Prelude.Double)
mode arg1 arg2 arg3 arg4 arg5 arg6 arg7 arg8 arg9 arg10 arg11 arg12 arg13 arg14 arg15 arg16 arg17 arg18 arg19 arg20 arg21 arg22 arg23 arg24 arg25 arg26 arg27 arg28 arg29 arg30 =
  Automation.function1 "Mode" [Automation.inInt arg1, Automation.inInt arg2, Automation.inInt arg3, Automation.inInt arg4, Automation.inInt arg5, Automation.inInt arg6, Automation.inInt arg7, Automation.inInt arg8, Automation.inInt arg9, Automation.inInt arg10, Automation.inInt arg11, Automation.inInt arg12, Automation.inInt arg13, Automation.inInt arg14, Automation.inInt arg15, Automation.inInt arg16, Automation.inInt arg17, Automation.inInt arg18, Automation.inInt arg19, Automation.inInt arg20, Automation.inInt arg21, Automation.inInt arg22, Automation.inInt arg23, Automation.inInt arg24, Automation.inInt arg25, Automation.inInt arg26, Automation.inInt arg27, Automation.inInt arg28, Automation.inInt arg29, Automation.inInt arg30] Automation.outDouble
trimMean :: Prelude.Int -> Prelude.Double -> IWorksheetFunction a -> Prelude.IO (Prelude.Double)
trimMean arg1 arg2 =
  Automation.function1 "TrimMean" [Automation.inInt arg1, Automation.inDouble arg2] Automation.outDouble
tInv :: Prelude.Double -> Prelude.Double -> IWorksheetFunction a -> Prelude.IO (Prelude.Double)
tInv arg1 arg2 =
  Automation.function1 "TInv" [Automation.inDouble arg1, Automation.inDouble arg2] Automation.outDouble
power :: Prelude.Double -> Prelude.Double -> IWorksheetFunction a -> Prelude.IO (Prelude.Double)
power arg1 arg2 =
  Automation.function1 "Power" [Automation.inDouble arg1, Automation.inDouble arg2] Automation.outDouble
radians :: Prelude.Double -> IWorksheetFunction a -> Prelude.IO (Prelude.Double)
radians arg1 =
  Automation.function1 "Radians" [Automation.inDouble arg1] Automation.outDouble
degrees :: Prelude.Double -> IWorksheetFunction a -> Prelude.IO (Prelude.Double)
degrees arg1 =
  Automation.function1 "Degrees" [Automation.inDouble arg1] Automation.outDouble
subtotal :: Prelude.Double -> IRange a0 -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> IWorksheetFunction a -> Prelude.IO (Prelude.Double)
subtotal arg1 arg2 arg3 arg4 arg5 arg6 arg7 arg8 arg9 arg10 arg11 arg12 arg13 arg14 arg15 arg16 arg17 arg18 arg19 arg20 arg21 arg22 arg23 arg24 arg25 arg26 arg27 arg28 arg29 arg30 =
  Automation.function1 "Subtotal" [Automation.inDouble arg1, Automation.inIDispatch arg2, Automation.inInt arg3, Automation.inInt arg4, Automation.inInt arg5, Automation.inInt arg6, Automation.inInt arg7, Automation.inInt arg8, Automation.inInt arg9, Automation.inInt arg10, Automation.inInt arg11, Automation.inInt arg12, Automation.inInt arg13, Automation.inInt arg14, Automation.inInt arg15, Automation.inInt arg16, Automation.inInt arg17, Automation.inInt arg18, Automation.inInt arg19, Automation.inInt arg20, Automation.inInt arg21, Automation.inInt arg22, Automation.inInt arg23, Automation.inInt arg24, Automation.inInt arg25, Automation.inInt arg26, Automation.inInt arg27, Automation.inInt arg28, Automation.inInt arg29, Automation.inInt arg30] Automation.outDouble
sumIf :: IRange a0 -> Prelude.Int -> Prelude.Int -> IWorksheetFunction a -> Prelude.IO (Prelude.Double)
sumIf arg1 arg2 arg3 =
  Automation.function1 "SumIf" [Automation.inIDispatch arg1, Automation.inInt arg2, Automation.inInt arg3] Automation.outDouble
countIf :: IRange a0 -> Prelude.Int -> IWorksheetFunction a -> Prelude.IO (Prelude.Double)
countIf arg1 arg2 =
  Automation.function1 "CountIf" [Automation.inIDispatch arg1, Automation.inInt arg2] Automation.outDouble
countBlank :: IRange a0 -> IWorksheetFunction a -> Prelude.IO (Prelude.Double)
countBlank arg1 =
  Automation.function1 "CountBlank" [Automation.inIDispatch arg1] Automation.outDouble
ispmt :: Prelude.Double -> Prelude.Double -> Prelude.Double -> Prelude.Double -> IWorksheetFunction a -> Prelude.IO (Prelude.Double)
ispmt arg1 arg2 arg3 arg4 =
  Automation.function1 "Ispmt" [Automation.inDouble arg1, Automation.inDouble arg2, Automation.inDouble arg3, Automation.inDouble arg4] Automation.outDouble
roman :: Prelude.Double -> Prelude.Int -> IWorksheetFunction a -> Prelude.IO (Prelude.String)
roman arg1 arg2 =
  Automation.function1 "Roman" [Automation.inDouble arg1, Automation.inInt arg2] Automation.outString
asc :: Prelude.String -> IWorksheetFunction a -> Prelude.IO (Prelude.String)
asc arg1 =
  Automation.function1 "Asc" [Automation.inString arg1] Automation.outString
dbcs :: Prelude.String -> IWorksheetFunction a -> Prelude.IO (Prelude.String)
dbcs arg1 =
  Automation.function1 "Dbcs" [Automation.inString arg1] Automation.outString
-- --------------------------------------------------
-- 
-- interface IRange
-- 
-- --------------------------------------------------
data Range a = Range
                
type IRange a = Automation.IDispatch (Range a)
iidIRange :: Com.IID (IRange Automation.Interface)
iidIRange = Com.mkIID "{00020846-0001-0000-C000-000000000046}"
getAddIndent :: IRange a -> Prelude.IO (Prelude.Int)
getAddIndent =
  Automation.propertyGet "AddIndent" [] Automation.outInt
setAddIndent :: Prelude.Int -> IRange a -> Prelude.IO ()
setAddIndent rHS =
  Automation.propertySet "AddIndent" [Automation.inInt rHS]
getAddress :: (Automation.Variant a0) => Prelude.Int -> Prelude.Int -> a0 -> Prelude.Int -> Prelude.Int -> Prelude.Int -> IRange a -> Prelude.IO (Prelude.String)
getAddress rowAbsolute columnAbsolute referenceStyle external relativeTo lcid =
  Automation.propertyGet "Address" [Automation.inInt rowAbsolute, Automation.inInt columnAbsolute, Automation.inVariant referenceStyle, Automation.inInt external, Automation.inInt relativeTo, Automation.inInt lcid] Automation.outString
getAddressLocal :: (Automation.Variant a0) => Prelude.Int -> Prelude.Int -> a0 -> Prelude.Int -> Prelude.Int -> IRange a -> Prelude.IO (Prelude.String)
getAddressLocal rowAbsolute columnAbsolute referenceStyle external relativeTo =
  Automation.propertyGet "AddressLocal" [Automation.inInt rowAbsolute, Automation.inInt columnAbsolute, Automation.inVariant referenceStyle, Automation.inInt external, Automation.inInt relativeTo] Automation.outString
advancedFilter :: (Automation.Variant a0) => a0 -> Prelude.Int -> Prelude.Int -> Prelude.Int -> IRange a -> Prelude.IO ()
advancedFilter action criteriaRange copyToRange unique =
  Automation.method0 "AdvancedFilter" [Automation.inVariant action, Automation.inInt criteriaRange, Automation.inInt copyToRange, Automation.inInt unique]
applyNames :: (Automation.Variant a0) => Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> a0 -> Prelude.Int -> IRange a -> Prelude.IO ()
applyNames names ignoreRelativeAbsolute useRowColumnNames omitColumn omitRow order appendLast =
  Automation.method0 "ApplyNames" [Automation.inInt names, Automation.inInt ignoreRelativeAbsolute, Automation.inInt useRowColumnNames, Automation.inInt omitColumn, Automation.inInt omitRow, Automation.inVariant order, Automation.inInt appendLast]
applyOutlineStyles :: IRange a -> Prelude.IO ()
applyOutlineStyles = Automation.method0 "ApplyOutlineStyles" []
getAreas :: IRange a -> Prelude.IO (IAreas Automation.Interface)
getAreas =
  Automation.propertyGet "Areas" [] Automation.outIDispatch
autoComplete :: Prelude.String -> IRange a -> Prelude.IO (Prelude.String)
autoComplete string =
  Automation.function1 "AutoComplete" [Automation.inString string] Automation.outString
autoFill :: (Automation.Variant a1) => IRange a0 -> a1 -> IRange a -> Prelude.IO ()
autoFill destination type0 =
  Automation.method0 "AutoFill" [Automation.inIDispatch destination, Automation.inVariant type0]
autoFilter :: (Automation.Variant a0) => Prelude.Int -> Prelude.Int -> a0 -> Prelude.Int -> Prelude.Int -> IRange a -> Prelude.IO ()
autoFilter field criteria1 operator criteria2 visibleDropDown =
  Automation.method0 "AutoFilter" [Automation.inInt field, Automation.inInt criteria1, Automation.inVariant operator, Automation.inInt criteria2, Automation.inInt visibleDropDown]
autoFit :: IRange a -> Prelude.IO ()
autoFit = Automation.method0 "AutoFit" []
autoFormat :: (Automation.Variant a0) => a0 -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> IRange a -> Prelude.IO ()
autoFormat format number font alignment border pattern width =
  Automation.method0 "AutoFormat" [Automation.inVariant format, Automation.inInt number, Automation.inInt font, Automation.inInt alignment, Automation.inInt border, Automation.inInt pattern, Automation.inInt width]
autoOutline :: IRange a -> Prelude.IO ()
autoOutline = Automation.method0 "AutoOutline" []
borderAround :: (Automation.Variant a0, Automation.Variant a1) => Prelude.Int -> a0 -> a1 -> Prelude.Int -> IRange a -> Prelude.IO ()
borderAround lineStyle weight colorIndex color =
  Automation.method0 "BorderAround" [Automation.inInt lineStyle, Automation.inVariant weight, Automation.inVariant colorIndex, Automation.inInt color]
getBorders :: Automation.IDispatch a -> Prelude.IO (IBorders Automation.Interface)
getBorders =
  Automation.propertyGet "Borders" [] Automation.outIDispatch
calculate0 :: Automation.IDispatch a -> Prelude.IO ()
calculate0 = Automation.method0 "Calculate" []
getCharacters :: Prelude.Int -> Prelude.Int -> Automation.IDispatch a -> Prelude.IO (ICharacters Automation.Interface)
getCharacters start length =
  Automation.propertyGet "Characters" [Automation.inInt start, Automation.inInt length] Automation.outIDispatch
checkSpelling0 :: Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Automation.IDispatch a -> Prelude.IO ()
checkSpelling0 customDictionary ignoreUppercase alwaysSuggest ignoreInitialAlefHamza ignoreFinalYaa spellScript =
  Automation.method0 "CheckSpelling" [Automation.inInt customDictionary, Automation.inInt ignoreUppercase, Automation.inInt alwaysSuggest, Automation.inInt ignoreInitialAlefHamza, Automation.inInt ignoreFinalYaa, Automation.inInt spellScript]
clear :: Automation.IDispatch a -> Prelude.IO ()
clear = Automation.method0 "Clear" []
clearContents :: Automation.IDispatch a -> Prelude.IO ()
clearContents = Automation.method0 "ClearContents" []
clearFormats :: Automation.IDispatch a -> Prelude.IO ()
clearFormats = Automation.method0 "ClearFormats" []
clearNotes :: IRange a -> Prelude.IO ()
clearNotes = Automation.method0 "ClearNotes" []
clearOutline :: IRange a -> Prelude.IO ()
clearOutline = Automation.method0 "ClearOutline" []
getColumn :: IRange a -> Prelude.IO (Prelude.Int)
getColumn = Automation.propertyGet "Column" [] Automation.outInt
columnDifferences :: Prelude.Int -> IRange a -> Prelude.IO (IRange Automation.Interface)
columnDifferences comparison =
  Automation.function1 "ColumnDifferences" [Automation.inInt comparison] Automation.outIDispatch
getColumnWidth :: IRange a -> Prelude.IO (Prelude.Int)
getColumnWidth =
  Automation.propertyGet "ColumnWidth" [] Automation.outInt
setColumnWidth :: Prelude.Int -> IRange a -> Prelude.IO ()
setColumnWidth rHS =
  Automation.propertySet "ColumnWidth" [Automation.inInt rHS]
consolidate :: Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> IRange a -> Prelude.IO ()
consolidate sources function topRow leftColumn createLinks =
  Automation.method0 "Consolidate" [Automation.inInt sources, Automation.inInt function, Automation.inInt topRow, Automation.inInt leftColumn, Automation.inInt createLinks]
copy :: Prelude.Int -> IRange a -> Prelude.IO ()
copy destination =
  Automation.method0 "Copy" [Automation.inInt destination]
copyFromRecordset :: Com.IUnknown a0 -> Prelude.Int -> Prelude.Int -> IRange a -> Prelude.IO (Prelude.Int)
copyFromRecordset data0 maxRows maxColumns =
  Automation.function1 "CopyFromRecordset" [Automation.inIUnknown data0, Automation.inInt maxRows, Automation.inInt maxColumns] Automation.outInt
copyPicture :: (Automation.Variant a0, Automation.Variant a1) => a0 -> a1 -> Automation.IDispatch a -> Prelude.IO ()
copyPicture appearance format =
  Automation.method0 "CopyPicture" [Automation.inVariant appearance, Automation.inVariant format]
createNames :: Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> IRange a -> Prelude.IO ()
createNames top left bottom right =
  Automation.method0 "CreateNames" [Automation.inInt top, Automation.inInt left, Automation.inInt bottom, Automation.inInt right]
createPublisher :: (Automation.Variant a0) => Prelude.Int -> a0 -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> IRange a -> Prelude.IO ()
createPublisher edition appearance containsPICT containsBIFF containsRTF containsVALU =
  Automation.method0 "CreatePublisher" [Automation.inInt edition, Automation.inVariant appearance, Automation.inInt containsPICT, Automation.inInt containsBIFF, Automation.inInt containsRTF, Automation.inInt containsVALU]
getCurrentArray :: IRange a -> Prelude.IO (IRange Automation.Interface)
getCurrentArray =
  Automation.propertyGet "CurrentArray" [] Automation.outIDispatch
getCurrentRegion :: IRange a -> Prelude.IO (IRange Automation.Interface)
getCurrentRegion =
  Automation.propertyGet "CurrentRegion" [] Automation.outIDispatch
cut :: Prelude.Int -> IRange a -> Prelude.IO ()
cut destination =
  Automation.method0 "Cut" [Automation.inInt destination]
dataSeries :: (Automation.Variant a0, Automation.Variant a1) => Prelude.Int -> a0 -> a1 -> Prelude.Int -> Prelude.Int -> Prelude.Int -> IRange a -> Prelude.IO ()
dataSeries rowcol type0 date step stop trend =
  Automation.method0 "DataSeries" [Automation.inInt rowcol, Automation.inVariant type0, Automation.inVariant date, Automation.inInt step, Automation.inInt stop, Automation.inInt trend]
getDefault1 :: Prelude.Int -> Prelude.Int -> Prelude.Int -> IRange a -> Prelude.IO (Prelude.Int)
getDefault1 rowIndex columnIndex lcid =
  Automation.propertyGet "_Default" [Automation.inInt rowIndex, Automation.inInt columnIndex, Automation.inInt lcid] Automation.outInt
setDefault :: Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> IRange a -> Prelude.IO ()
setDefault rowIndex columnIndex lcid rHS =
  Automation.propertySet "_Default" [Automation.inInt rowIndex, Automation.inInt columnIndex, Automation.inInt lcid, Automation.inInt rHS]
getDependents :: IRange a -> Prelude.IO (IRange Automation.Interface)
getDependents =
  Automation.propertyGet "Dependents" [] Automation.outIDispatch
dialogBox :: IRange a -> Prelude.IO (Prelude.Int)
dialogBox = Automation.function1 "DialogBox" [] Automation.outInt
getDirectDependents :: IRange a -> Prelude.IO (IRange Automation.Interface)
getDirectDependents =
  Automation.propertyGet "DirectDependents" [] Automation.outIDispatch
getDirectPrecedents :: IRange a -> Prelude.IO (IRange Automation.Interface)
getDirectPrecedents =
  Automation.propertyGet "DirectPrecedents" [] Automation.outIDispatch
editionOptions :: (Automation.Variant a0, Automation.Variant a1, Automation.Variant a2, Automation.Variant a3) => a0 -> a1 -> Prelude.Int -> Prelude.Int -> a2 -> a3 -> Prelude.Int -> IRange a -> Prelude.IO (Prelude.Int)
editionOptions type0 option name reference appearance chartSize format =
  Automation.function1 "EditionOptions" [Automation.inVariant type0, Automation.inVariant option, Automation.inInt name, Automation.inInt reference, Automation.inVariant appearance, Automation.inVariant chartSize, Automation.inInt format] Automation.outInt
getEnd :: (Automation.Variant a0) => a0 -> IRange a -> Prelude.IO (IRange Automation.Interface)
getEnd direction =
  Automation.propertyGet "End" [Automation.inVariant direction] Automation.outIDispatch
getEntireColumn :: IRange a -> Prelude.IO (IRange Automation.Interface)
getEntireColumn =
  Automation.propertyGet "EntireColumn" [] Automation.outIDispatch
getEntireRow :: IRange a -> Prelude.IO (IRange Automation.Interface)
getEntireRow =
  Automation.propertyGet "EntireRow" [] Automation.outIDispatch
fillDown :: IRange a -> Prelude.IO ()
fillDown = Automation.method0 "FillDown" []
fillLeft :: IRange a -> Prelude.IO ()
fillLeft = Automation.method0 "FillLeft" []
fillRight :: IRange a -> Prelude.IO ()
fillRight = Automation.method0 "FillRight" []
fillUp :: IRange a -> Prelude.IO ()
fillUp = Automation.method0 "FillUp" []
find0 :: (Automation.Variant a0) => Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> a0 -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> IRange a -> Prelude.IO (IRange Automation.Interface)
find0 what after lookIn lookAt searchOrder searchDirection matchCase matchByte matchControlCharacters matchDiacritics matchKashida matchAlefHamza =
  Automation.function1 "Find" [Automation.inInt what, Automation.inInt after, Automation.inInt lookIn, Automation.inInt lookAt, Automation.inInt searchOrder, Automation.inVariant searchDirection, Automation.inInt matchCase, Automation.inInt matchByte, Automation.inInt matchControlCharacters, Automation.inInt matchDiacritics, Automation.inInt matchKashida, Automation.inInt matchAlefHamza] Automation.outIDispatch
findNext :: Prelude.Int -> IRange a -> Prelude.IO (IRange Automation.Interface)
findNext after =
  Automation.function1 "FindNext" [Automation.inInt after] Automation.outIDispatch
findPrevious :: Prelude.Int -> IRange a -> Prelude.IO (IRange Automation.Interface)
findPrevious after =
  Automation.function1 "FindPrevious" [Automation.inInt after] Automation.outIDispatch
getFont :: Automation.IDispatch a -> Prelude.IO (IFont Automation.Interface)
getFont = Automation.propertyGet "Font" [] Automation.outIDispatch
getFormula :: Prelude.Int -> IRange a -> Prelude.IO (Prelude.Int)
getFormula lcid =
  Automation.propertyGet "Formula" [Automation.inInt lcid] Automation.outInt
setFormula :: Prelude.Int -> Prelude.Int -> IRange a -> Prelude.IO ()
setFormula lcid rHS =
  Automation.propertySet "Formula" [Automation.inInt lcid, Automation.inInt rHS]
getFormulaArray :: IRange a -> Prelude.IO (Prelude.Int)
getFormulaArray =
  Automation.propertyGet "FormulaArray" [] Automation.outInt
setFormulaArray :: Prelude.Int -> IRange a -> Prelude.IO ()
setFormulaArray rHS =
  Automation.propertySet "FormulaArray" [Automation.inInt rHS]
getFormulaLabel :: (Automation.Variant a0) => IRange a -> Prelude.IO (a0)
getFormulaLabel =
  Automation.propertyGet "FormulaLabel" [] Automation.outVariant
setFormulaLabel :: (Automation.Variant a0) => a0 -> IRange a -> Prelude.IO ()
setFormulaLabel rHS =
  Automation.propertySet "FormulaLabel" [Automation.inVariant rHS]
getFormulaHidden :: IRange a -> Prelude.IO (Prelude.Int)
getFormulaHidden =
  Automation.propertyGet "FormulaHidden" [] Automation.outInt
setFormulaHidden :: Prelude.Int -> IRange a -> Prelude.IO ()
setFormulaHidden rHS =
  Automation.propertySet "FormulaHidden" [Automation.inInt rHS]
getFormulaLocal :: IRange a -> Prelude.IO (Prelude.Int)
getFormulaLocal =
  Automation.propertyGet "FormulaLocal" [] Automation.outInt
setFormulaLocal :: Prelude.Int -> IRange a -> Prelude.IO ()
setFormulaLocal rHS =
  Automation.propertySet "FormulaLocal" [Automation.inInt rHS]
getFormulaR1C1 :: Prelude.Int -> IRange a -> Prelude.IO (Prelude.Int)
getFormulaR1C1 lcid =
  Automation.propertyGet "FormulaR1C1" [Automation.inInt lcid] Automation.outInt
setFormulaR1C1 :: Prelude.Int -> Prelude.Int -> IRange a -> Prelude.IO ()
setFormulaR1C1 lcid rHS =
  Automation.propertySet "FormulaR1C1" [Automation.inInt lcid, Automation.inInt rHS]
getFormulaR1C1Local :: IRange a -> Prelude.IO (Prelude.Int)
getFormulaR1C1Local =
  Automation.propertyGet "FormulaR1C1Local" [] Automation.outInt
setFormulaR1C1Local :: Prelude.Int -> IRange a -> Prelude.IO ()
setFormulaR1C1Local rHS =
  Automation.propertySet "FormulaR1C1Local" [Automation.inInt rHS]
functionWizard :: IRange a -> Prelude.IO ()
functionWizard = Automation.method0 "FunctionWizard" []
goalSeek :: Prelude.Int -> IRange a0 -> IRange a -> Prelude.IO (Prelude.Int)
goalSeek goal changingCell =
  Automation.function1 "GoalSeek" [Automation.inInt goal, Automation.inIDispatch changingCell] Automation.outInt
group :: Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> IRange a -> Prelude.IO (Prelude.Int)
group start end by periods =
  Automation.function1 "Group" [Automation.inInt start, Automation.inInt end, Automation.inInt by, Automation.inInt periods] Automation.outInt
getHasArray :: IRange a -> Prelude.IO (Prelude.Int)
getHasArray =
  Automation.propertyGet "HasArray" [] Automation.outInt
getHasFormula :: IRange a -> Prelude.IO (Prelude.Int)
getHasFormula =
  Automation.propertyGet "HasFormula" [] Automation.outInt
getHeight1 :: Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getHeight1 = Automation.propertyGet "Height" [] Automation.outInt
getHidden :: IRange a -> Prelude.IO (Prelude.Int)
getHidden = Automation.propertyGet "Hidden" [] Automation.outInt
setHidden :: Prelude.Int -> IRange a -> Prelude.IO ()
setHidden rHS =
  Automation.propertySet "Hidden" [Automation.inInt rHS]
getHorizontalAlignment :: Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getHorizontalAlignment =
  Automation.propertyGet "HorizontalAlignment" [] Automation.outInt
setHorizontalAlignment :: Prelude.Int -> Automation.IDispatch a -> Prelude.IO ()
setHorizontalAlignment rHS =
  Automation.propertySet "HorizontalAlignment" [Automation.inInt rHS]
getIndentLevel :: Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getIndentLevel =
  Automation.propertyGet "IndentLevel" [] Automation.outInt
setIndentLevel :: Prelude.Int -> Automation.IDispatch a -> Prelude.IO ()
setIndentLevel rHS =
  Automation.propertySet "IndentLevel" [Automation.inInt rHS]
insertIndent :: Prelude.Int -> IRange a -> Prelude.IO ()
insertIndent insertAmount =
  Automation.method0 "InsertIndent" [Automation.inInt insertAmount]
insert0 :: Prelude.Int -> Automation.IDispatch a -> Prelude.IO ()
insert0 shift =
  Automation.method0 "Insert" [Automation.inInt shift]
getInterior :: Automation.IDispatch a -> Prelude.IO (IInterior Automation.Interface)
getInterior =
  Automation.propertyGet "Interior" [] Automation.outIDispatch
getItem1 :: Prelude.Int -> Prelude.Int -> Prelude.Int -> IRange a -> Prelude.IO (Prelude.Int)
getItem1 rowIndex columnIndex lcid =
  Automation.propertyGet "Item" [Automation.inInt rowIndex, Automation.inInt columnIndex, Automation.inInt lcid] Automation.outInt
setItem0 :: Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> IRange a -> Prelude.IO ()
setItem0 rowIndex columnIndex lcid rHS =
  Automation.propertySet "Item" [Automation.inInt rowIndex, Automation.inInt columnIndex, Automation.inInt lcid, Automation.inInt rHS]
justify :: IRange a -> Prelude.IO ()
justify = Automation.method0 "Justify" []
getLeft1 :: Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getLeft1 = Automation.propertyGet "Left" [] Automation.outInt
getListHeaderRows :: IRange a -> Prelude.IO (Prelude.Int)
getListHeaderRows =
  Automation.propertyGet "ListHeaderRows" [] Automation.outInt
listNames :: IRange a -> Prelude.IO ()
listNames = Automation.method0 "ListNames" []
getLocationInTable :: (Automation.Variant a0) => IRange a -> Prelude.IO (a0)
getLocationInTable =
  Automation.propertyGet "LocationInTable" [] Automation.outVariant
getLocked :: IRange a -> Prelude.IO (Prelude.Int)
getLocked = Automation.propertyGet "Locked" [] Automation.outInt
setLocked :: Prelude.Int -> IRange a -> Prelude.IO ()
setLocked rHS =
  Automation.propertySet "Locked" [Automation.inInt rHS]
merge :: Prelude.Int -> Automation.IDispatch a -> Prelude.IO ()
merge across = Automation.method0 "Merge" [Automation.inInt across]
unMerge :: IRange a -> Prelude.IO ()
unMerge = Automation.method0 "UnMerge" []
getMergeArea :: IRange a -> Prelude.IO (IRange Automation.Interface)
getMergeArea =
  Automation.propertyGet "MergeArea" [] Automation.outIDispatch
getMergeCells :: Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getMergeCells =
  Automation.propertyGet "MergeCells" [] Automation.outInt
setMergeCells :: Prelude.Int -> Automation.IDispatch a -> Prelude.IO ()
setMergeCells rHS =
  Automation.propertySet "MergeCells" [Automation.inInt rHS]
navigateArrow :: Prelude.Int -> Prelude.Int -> Prelude.Int -> IRange a -> Prelude.IO ()
navigateArrow towardPrecedent arrowNumber linkNumber =
  Automation.method0 "NavigateArrow" [Automation.inInt towardPrecedent, Automation.inInt arrowNumber, Automation.inInt linkNumber]
getNext :: IRange a -> Prelude.IO (IRange Automation.Interface)
getNext = Automation.propertyGet "Next" [] Automation.outIDispatch
noteText :: Prelude.Int -> Prelude.Int -> Prelude.Int -> IRange a -> Prelude.IO (Prelude.String)
noteText text start length =
  Automation.function1 "NoteText" [Automation.inInt text, Automation.inInt start, Automation.inInt length] Automation.outString
getNumberFormat :: IRange a -> Prelude.IO (Prelude.Int)
getNumberFormat =
  Automation.propertyGet "NumberFormat" [] Automation.outInt
setNumberFormat :: Prelude.Int -> IRange a -> Prelude.IO ()
setNumberFormat rHS =
  Automation.propertySet "NumberFormat" [Automation.inInt rHS]
getNumberFormatLocal :: IRange a -> Prelude.IO (Prelude.Int)
getNumberFormatLocal =
  Automation.propertyGet "NumberFormatLocal" [] Automation.outInt
setNumberFormatLocal :: Prelude.Int -> IRange a -> Prelude.IO ()
setNumberFormatLocal rHS =
  Automation.propertySet "NumberFormatLocal" [Automation.inInt rHS]
getOffset :: Prelude.Int -> Prelude.Int -> IRange a -> Prelude.IO (IRange Automation.Interface)
getOffset rowOffset columnOffset =
  Automation.propertyGet "Offset" [Automation.inInt rowOffset, Automation.inInt columnOffset] Automation.outIDispatch
getOrientation :: Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getOrientation =
  Automation.propertyGet "Orientation" [] Automation.outInt
setOrientation :: Prelude.Int -> Automation.IDispatch a -> Prelude.IO ()
setOrientation rHS =
  Automation.propertySet "Orientation" [Automation.inInt rHS]
getOutlineLevel :: IRange a -> Prelude.IO (Prelude.Int)
getOutlineLevel =
  Automation.propertyGet "OutlineLevel" [] Automation.outInt
setOutlineLevel :: Prelude.Int -> IRange a -> Prelude.IO ()
setOutlineLevel rHS =
  Automation.propertySet "OutlineLevel" [Automation.inInt rHS]
getPageBreak :: IRange a -> Prelude.IO (Prelude.Int)
getPageBreak =
  Automation.propertyGet "PageBreak" [] Automation.outInt
setPageBreak :: Prelude.Int -> IRange a -> Prelude.IO ()
setPageBreak rHS =
  Automation.propertySet "PageBreak" [Automation.inInt rHS]
parse :: Prelude.Int -> Prelude.Int -> IRange a -> Prelude.IO ()
parse parseLine destination =
  Automation.method0 "Parse" [Automation.inInt parseLine, Automation.inInt destination]
pasteSpecial :: (Automation.Variant a0, Automation.Variant a1) => a0 -> a1 -> Prelude.Int -> Prelude.Int -> IRange a -> Prelude.IO ()
pasteSpecial paste operation skipBlanks transpose =
  Automation.method0 "PasteSpecial" [Automation.inVariant paste, Automation.inVariant operation, Automation.inInt skipBlanks, Automation.inInt transpose]
getPivotField :: IRange a -> Prelude.IO (IPivotField Automation.Interface)
getPivotField =
  Automation.propertyGet "PivotField" [] Automation.outIDispatch
getPivotItem :: IRange a -> Prelude.IO (IPivotItem Automation.Interface)
getPivotItem =
  Automation.propertyGet "PivotItem" [] Automation.outIDispatch
getPivotTable :: IRange a -> Prelude.IO (IPivotTable Automation.Interface)
getPivotTable =
  Automation.propertyGet "PivotTable" [] Automation.outIDispatch
getPrecedents :: IRange a -> Prelude.IO (IRange Automation.Interface)
getPrecedents =
  Automation.propertyGet "Precedents" [] Automation.outIDispatch
getPrefixCharacter :: IRange a -> Prelude.IO (Prelude.Int)
getPrefixCharacter =
  Automation.propertyGet "PrefixCharacter" [] Automation.outInt
getPrevious :: IRange a -> Prelude.IO (IRange Automation.Interface)
getPrevious =
  Automation.propertyGet "Previous" [] Automation.outIDispatch
getQueryTable :: IRange a -> Prelude.IO (IQueryTable Automation.Interface)
getQueryTable =
  Automation.propertyGet "QueryTable" [] Automation.outIDispatch
removeSubtotal :: IRange a -> Prelude.IO ()
removeSubtotal = Automation.method0 "RemoveSubtotal" []
replace0 :: Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> IRange a -> Prelude.IO (Prelude.Int)
replace0 what replacement lookAt searchOrder matchCase matchByte matchControlCharacters matchDiacritics matchKashida matchAlefHamza =
  Automation.function1 "Replace" [Automation.inInt what, Automation.inInt replacement, Automation.inInt lookAt, Automation.inInt searchOrder, Automation.inInt matchCase, Automation.inInt matchByte, Automation.inInt matchControlCharacters, Automation.inInt matchDiacritics, Automation.inInt matchKashida, Automation.inInt matchAlefHamza] Automation.outInt
getResize :: Prelude.Int -> Prelude.Int -> IRange a -> Prelude.IO (IRange Automation.Interface)
getResize rowSize columnSize =
  Automation.propertyGet "Resize" [Automation.inInt rowSize, Automation.inInt columnSize] Automation.outIDispatch
getRow :: IRange a -> Prelude.IO (Prelude.Int)
getRow = Automation.propertyGet "Row" [] Automation.outInt
rowDifferences :: Prelude.Int -> IRange a -> Prelude.IO (IRange Automation.Interface)
rowDifferences comparison =
  Automation.function1 "RowDifferences" [Automation.inInt comparison] Automation.outIDispatch
getRowHeight :: IRange a -> Prelude.IO (Prelude.Int)
getRowHeight =
  Automation.propertyGet "RowHeight" [] Automation.outInt
setRowHeight :: Prelude.Int -> IRange a -> Prelude.IO ()
setRowHeight rHS =
  Automation.propertySet "RowHeight" [Automation.inInt rHS]
run0 :: Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> IRange a -> Prelude.IO (Prelude.Int)
run0 arg1 arg2 arg3 arg4 arg5 arg6 arg7 arg8 arg9 arg10 arg11 arg12 arg13 arg14 arg15 arg16 arg17 arg18 arg19 arg20 arg21 arg22 arg23 arg24 arg25 arg26 arg27 arg28 arg29 arg30 =
  Automation.function1 "Run" [Automation.inInt arg1, Automation.inInt arg2, Automation.inInt arg3, Automation.inInt arg4, Automation.inInt arg5, Automation.inInt arg6, Automation.inInt arg7, Automation.inInt arg8, Automation.inInt arg9, Automation.inInt arg10, Automation.inInt arg11, Automation.inInt arg12, Automation.inInt arg13, Automation.inInt arg14, Automation.inInt arg15, Automation.inInt arg16, Automation.inInt arg17, Automation.inInt arg18, Automation.inInt arg19, Automation.inInt arg20, Automation.inInt arg21, Automation.inInt arg22, Automation.inInt arg23, Automation.inInt arg24, Automation.inInt arg25, Automation.inInt arg26, Automation.inInt arg27, Automation.inInt arg28, Automation.inInt arg29, Automation.inInt arg30] Automation.outInt
select :: Automation.IDispatch a -> Prelude.IO ()
select = Automation.method0 "Select" []
show :: Automation.IDispatch a -> Prelude.IO ()
show = Automation.method0 "Show" []
showDependents :: Prelude.Int -> IRange a -> Prelude.IO ()
showDependents remove =
  Automation.method0 "ShowDependents" [Automation.inInt remove]
getShowDetail :: IRange a -> Prelude.IO (Prelude.Int)
getShowDetail =
  Automation.propertyGet "ShowDetail" [] Automation.outInt
setShowDetail :: Prelude.Int -> IRange a -> Prelude.IO ()
setShowDetail rHS =
  Automation.propertySet "ShowDetail" [Automation.inInt rHS]
showErrors :: IRange a -> Prelude.IO ()
showErrors = Automation.method0 "ShowErrors" []
showPrecedents :: Prelude.Int -> IRange a -> Prelude.IO ()
showPrecedents remove =
  Automation.method0 "ShowPrecedents" [Automation.inInt remove]
getShrinkToFit :: IRange a -> Prelude.IO (Prelude.Int)
getShrinkToFit =
  Automation.propertyGet "ShrinkToFit" [] Automation.outInt
setShrinkToFit :: Prelude.Int -> IRange a -> Prelude.IO ()
setShrinkToFit rHS =
  Automation.propertySet "ShrinkToFit" [Automation.inInt rHS]
sort :: (Automation.Variant a0, Automation.Variant a1, Automation.Variant a2, Automation.Variant a3, Automation.Variant a4, Automation.Variant a5) => Prelude.Int -> a0 -> Prelude.Int -> Prelude.Int -> a1 -> Prelude.Int -> a2 -> a3 -> Prelude.Int -> Prelude.Int -> a4 -> a5 -> Prelude.Int -> Prelude.Int -> Prelude.Int -> IRange a -> Prelude.IO ()
sort key1 order1 key2 type0 order2 key3 order3 header orderCustom matchCase orientation sortMethod ignoreControlCharacters ignoreDiacritics ignoreKashida =
  Automation.method0 "Sort" [Automation.inInt key1, Automation.inVariant order1, Automation.inInt key2, Automation.inInt type0, Automation.inVariant order2, Automation.inInt key3, Automation.inVariant order3, Automation.inVariant header, Automation.inInt orderCustom, Automation.inInt matchCase, Automation.inVariant orientation, Automation.inVariant sortMethod, Automation.inInt ignoreControlCharacters, Automation.inInt ignoreDiacritics, Automation.inInt ignoreKashida]
sortSpecial :: (Automation.Variant a0, Automation.Variant a1, Automation.Variant a2, Automation.Variant a3, Automation.Variant a4, Automation.Variant a5) => a0 -> Prelude.Int -> a1 -> Prelude.Int -> Prelude.Int -> a2 -> Prelude.Int -> a3 -> a4 -> Prelude.Int -> Prelude.Int -> a5 -> IRange a -> Prelude.IO ()
sortSpecial sortMethod key1 order1 type0 key2 order2 key3 order3 header orderCustom matchCase orientation =
  Automation.method0 "SortSpecial" [Automation.inVariant sortMethod, Automation.inInt key1, Automation.inVariant order1, Automation.inInt type0, Automation.inInt key2, Automation.inVariant order2, Automation.inInt key3, Automation.inVariant order3, Automation.inVariant header, Automation.inInt orderCustom, Automation.inInt matchCase, Automation.inVariant orientation]
getSoundNote :: IRange a -> Prelude.IO (ISoundNote Automation.Interface)
getSoundNote =
  Automation.propertyGet "SoundNote" [] Automation.outIDispatch
specialCells :: (Automation.Variant a0) => a0 -> Prelude.Int -> IRange a -> Prelude.IO (IRange Automation.Interface)
specialCells type0 value =
  Automation.function1 "SpecialCells" [Automation.inVariant type0, Automation.inInt value] Automation.outIDispatch
getStyle0 :: IRange a -> Prelude.IO (Prelude.Int)
getStyle0 = Automation.propertyGet "Style" [] Automation.outInt
setStyle0 :: Prelude.Int -> IRange a -> Prelude.IO ()
setStyle0 rHS =
  Automation.propertySet "Style" [Automation.inInt rHS]
subscribeTo :: (Automation.Variant a0) => Prelude.String -> a0 -> IRange a -> Prelude.IO ()
subscribeTo edition format =
  Automation.method0 "SubscribeTo" [Automation.inString edition, Automation.inVariant format]
subtotal0 :: (Automation.Variant a0, Automation.Variant a1) => Prelude.Int -> a0 -> Prelude.Int -> Prelude.Int -> Prelude.Int -> a1 -> IRange a -> Prelude.IO ()
subtotal0 groupBy function totalList replace pageBreaks summaryBelowData =
  Automation.method0 "Subtotal" [Automation.inInt groupBy, Automation.inVariant function, Automation.inInt totalList, Automation.inInt replace, Automation.inInt pageBreaks, Automation.inVariant summaryBelowData]
getSummary :: IRange a -> Prelude.IO (Prelude.Int)
getSummary = Automation.propertyGet "Summary" [] Automation.outInt
table :: Prelude.Int -> Prelude.Int -> IRange a -> Prelude.IO ()
table rowInput columnInput =
  Automation.method0 "Table" [Automation.inInt rowInput, Automation.inInt columnInput]
getText0 :: IRange a -> Prelude.IO (Prelude.Int)
getText0 = Automation.propertyGet "Text" [] Automation.outInt
textToColumns :: (Automation.Variant a0, Automation.Variant a1) => Prelude.Int -> a0 -> a1 -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> IRange a -> Prelude.IO ()
textToColumns destination dataType textQualifier consecutiveDelimiter tab semicolon comma space other otherChar fieldInfo =
  Automation.method0 "TextToColumns" [Automation.inInt destination, Automation.inVariant dataType, Automation.inVariant textQualifier, Automation.inInt consecutiveDelimiter, Automation.inInt tab, Automation.inInt semicolon, Automation.inInt comma, Automation.inInt space, Automation.inInt other, Automation.inInt otherChar, Automation.inInt fieldInfo]
getTop1 :: Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getTop1 = Automation.propertyGet "Top" [] Automation.outInt
ungroup :: IRange a -> Prelude.IO ()
ungroup = Automation.method0 "Ungroup" []
getUseStandardHeight :: IRange a -> Prelude.IO (Prelude.Int)
getUseStandardHeight =
  Automation.propertyGet "UseStandardHeight" [] Automation.outInt
setUseStandardHeight :: Prelude.Int -> IRange a -> Prelude.IO ()
setUseStandardHeight rHS =
  Automation.propertySet "UseStandardHeight" [Automation.inInt rHS]
getUseStandardWidth :: IRange a -> Prelude.IO (Prelude.Int)
getUseStandardWidth =
  Automation.propertyGet "UseStandardWidth" [] Automation.outInt
setUseStandardWidth :: Prelude.Int -> IRange a -> Prelude.IO ()
setUseStandardWidth rHS =
  Automation.propertySet "UseStandardWidth" [Automation.inInt rHS]
getValidation :: IRange a -> Prelude.IO (IValidation Automation.Interface)
getValidation =
  Automation.propertyGet "Validation" [] Automation.outIDispatch
getValue0 :: Prelude.Int -> IRange a -> Prelude.IO (Prelude.Int)
getValue0 lcid =
  Automation.propertyGet "Value" [Automation.inInt lcid] Automation.outInt
setValue :: Prelude.Int -> Prelude.Int -> IRange a -> Prelude.IO ()
setValue lcid rHS =
  Automation.propertySet "Value" [Automation.inInt lcid, Automation.inInt rHS]
getValue2 :: Prelude.Int -> IRange a -> Prelude.IO (Prelude.Int)
getValue2 lcid =
  Automation.propertyGet "Value2" [Automation.inInt lcid] Automation.outInt
setValue2 :: Prelude.Int -> Prelude.Int -> IRange a -> Prelude.IO ()
setValue2 lcid rHS =
  Automation.propertySet "Value2" [Automation.inInt lcid, Automation.inInt rHS]
getVerticalAlignment :: Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getVerticalAlignment =
  Automation.propertyGet "VerticalAlignment" [] Automation.outInt
setVerticalAlignment :: Prelude.Int -> Automation.IDispatch a -> Prelude.IO ()
setVerticalAlignment rHS =
  Automation.propertySet "VerticalAlignment" [Automation.inInt rHS]
getWidth1 :: Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getWidth1 = Automation.propertyGet "Width" [] Automation.outInt
getWorksheet :: IRange a -> Prelude.IO (IWorksheet Automation.Interface)
getWorksheet =
  Automation.propertyGet "Worksheet" [] Automation.outIDispatch
getWrapText :: IRange a -> Prelude.IO (Prelude.Int)
getWrapText =
  Automation.propertyGet "WrapText" [] Automation.outInt
setWrapText :: Prelude.Int -> IRange a -> Prelude.IO ()
setWrapText rHS =
  Automation.propertySet "WrapText" [Automation.inInt rHS]
addComment :: Prelude.Int -> IRange a -> Prelude.IO (IComment Automation.Interface)
addComment text =
  Automation.function1 "AddComment" [Automation.inInt text] Automation.outIDispatch
getComment :: IRange a -> Prelude.IO (IComment Automation.Interface)
getComment =
  Automation.propertyGet "Comment" [] Automation.outIDispatch
clearComments :: IRange a -> Prelude.IO ()
clearComments = Automation.method0 "ClearComments" []
getPhonetic :: IRange a -> Prelude.IO (IPhonetic Automation.Interface)
getPhonetic =
  Automation.propertyGet "Phonetic" [] Automation.outIDispatch
getFormatConditions :: IRange a -> Prelude.IO (IFormatConditions Automation.Interface)
getFormatConditions =
  Automation.propertyGet "FormatConditions" [] Automation.outIDispatch
getReadingOrder :: Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getReadingOrder =
  Automation.propertyGet "ReadingOrder" [] Automation.outInt
setReadingOrder :: Prelude.Int -> Automation.IDispatch a -> Prelude.IO ()
setReadingOrder rHS =
  Automation.propertySet "ReadingOrder" [Automation.inInt rHS]
getHyperlinks :: Automation.IDispatch a -> Prelude.IO (IHyperlinks Automation.Interface)
getHyperlinks =
  Automation.propertyGet "Hyperlinks" [] Automation.outIDispatch
-- --------------------------------------------------
-- 
-- interface IChartEvents
-- 
-- --------------------------------------------------
data ChartEvents a = ChartEvents
                      
type IChartEvents a = Automation.IDispatch (ChartEvents a)
iidIChartEvents :: Com.IID (IChartEvents Automation.Interface)
iidIChartEvents =
  Com.mkIID "{0002440F-0001-0000-C000-000000000046}"
deactivate :: Automation.IDispatch a -> Prelude.IO ()
deactivate = Automation.method0 "Deactivate" []
resize :: Automation.IDispatch a -> Prelude.IO ()
resize = Automation.method0 "Resize" []
mouseDown :: (Automation.Variant a0) => a0 -> Prelude.Int -> Prelude.Int -> Prelude.Int -> IChartEvents a -> Prelude.IO ()
mouseDown button shift x y =
  Automation.method0 "MouseDown" [Automation.inVariant button, Automation.inInt shift, Automation.inInt x, Automation.inInt y]
mouseUp :: (Automation.Variant a0) => a0 -> Prelude.Int -> Prelude.Int -> Prelude.Int -> IChartEvents a -> Prelude.IO ()
mouseUp button shift x y =
  Automation.method0 "MouseUp" [Automation.inVariant button, Automation.inInt shift, Automation.inInt x, Automation.inInt y]
mouseMove :: (Automation.Variant a0) => a0 -> Prelude.Int -> Prelude.Int -> Prelude.Int -> IChartEvents a -> Prelude.IO ()
mouseMove button shift x y =
  Automation.method0 "MouseMove" [Automation.inVariant button, Automation.inInt shift, Automation.inInt x, Automation.inInt y]
beforeRightClick :: Prelude.Int -> IChartEvents a -> Prelude.IO ()
beforeRightClick cancel =
  Automation.method0 "BeforeRightClick" [Automation.inInt cancel]
dragPlot :: IChartEvents a -> Prelude.IO ()
dragPlot = Automation.method0 "DragPlot" []
dragOver :: IChartEvents a -> Prelude.IO ()
dragOver = Automation.method0 "DragOver" []
beforeDoubleClick :: (Automation.Variant a0) => a0 -> Prelude.Int -> Prelude.Int -> Prelude.Int -> IChartEvents a -> Prelude.IO ()
beforeDoubleClick elementID arg1 arg2 cancel =
  Automation.method0 "BeforeDoubleClick" [Automation.inVariant elementID, Automation.inInt arg1, Automation.inInt arg2, Automation.inInt cancel]
select0 :: (Automation.Variant a0) => a0 -> Prelude.Int -> Prelude.Int -> Automation.IDispatch a -> Prelude.IO ()
select0 elementID arg1 arg2 =
  Automation.method0 "Select" [Automation.inVariant elementID, Automation.inInt arg1, Automation.inInt arg2]
seriesChange :: Prelude.Int -> Prelude.Int -> IChartEvents a -> Prelude.IO ()
seriesChange seriesIndex pointIndex =
  Automation.method0 "SeriesChange" [Automation.inInt seriesIndex, Automation.inInt pointIndex]
-- --------------------------------------------------
-- 
-- interface Chart
-- 
-- --------------------------------------------------
data Chart a = Chart
                
type IChart a = Automation.IDispatch (Chart a)
iidIChart :: Com.IID (IChart Automation.Interface)
iidIChart = Com.mkIID "{000208D6-0000-0000-C000-000000000046}"
activate2 :: Prelude.Int -> Automation.IDispatch a -> Prelude.IO ()
activate2 lcid = Automation.methodID0 0x130 [Automation.inInt lcid]
copy0 :: Prelude.Int -> Prelude.Int -> Prelude.Int -> Automation.IDispatch a -> Prelude.IO ()
copy0 before after lcid =
  Automation.methodID0 0x227 [Automation.inInt before, Automation.inInt after, Automation.inInt lcid]
getCodeName :: Automation.IDispatch a -> Prelude.IO (Prelude.String)
getCodeName =
  Automation.propertyGetID 0x55d [] Automation.outString
getCodeName0 :: Automation.IDispatch a -> Prelude.IO (Prelude.String)
getCodeName0 =
  Automation.propertyGetID 0x80010000 [] Automation.outString
setCodeName :: Prelude.String -> Automation.IDispatch a -> Prelude.IO ()
setCodeName rHS =
  Automation.propertySetID 0x80010000 [Automation.inString rHS]
getIndex0 :: Prelude.Int -> Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getIndex0 lcid =
  Automation.propertyGetID 0x1e6 [Automation.inInt lcid] Automation.outInt
move :: Prelude.Int -> Prelude.Int -> Prelude.Int -> Automation.IDispatch a -> Prelude.IO ()
move before after lcid =
  Automation.methodID0 0x27d [Automation.inInt before, Automation.inInt after, Automation.inInt lcid]
setName1 :: Prelude.String -> Automation.IDispatch a -> Prelude.IO ()
setName1 rHS =
  Automation.propertySetID 0x6e [Automation.inString rHS]
getNext0 :: Automation.IDispatch a -> Prelude.IO (Automation.IDispatch Automation.Interface)
getNext0 =
  Automation.propertyGetID 0x1f6 [] Automation.outIDispatch
getPageSetup :: Automation.IDispatch a -> Prelude.IO (IPageSetup Automation.Interface)
getPageSetup =
  Automation.propertyGetID 0x3e6 [] Automation.outIDispatch
getPrevious0 :: Automation.IDispatch a -> Prelude.IO (Automation.IDispatch Automation.Interface)
getPrevious0 =
  Automation.propertyGetID 0x1f7 [] Automation.outIDispatch
printOut1 :: Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Automation.IDispatch a -> Prelude.IO ()
printOut1 from to copies preview activePrinter printToFile collate lcid =
  Automation.methodID0 0x389 [Automation.inInt from, Automation.inInt to, Automation.inInt copies, Automation.inInt preview, Automation.inInt activePrinter, Automation.inInt printToFile, Automation.inInt collate, Automation.inInt lcid]
printPreview1 :: Prelude.Int -> Prelude.Int -> Automation.IDispatch a -> Prelude.IO ()
printPreview1 enableChanges lcid =
  Automation.methodID0 0x119 [Automation.inInt enableChanges, Automation.inInt lcid]
protect :: Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Automation.IDispatch a -> Prelude.IO ()
protect password drawingObjects contents scenarios userInterfaceOnly lcid =
  Automation.methodID0 0x11a [Automation.inInt password, Automation.inInt drawingObjects, Automation.inInt contents, Automation.inInt scenarios, Automation.inInt userInterfaceOnly, Automation.inInt lcid]
getProtectContents :: Prelude.Int -> Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getProtectContents lcid =
  Automation.propertyGetID 0x124 [Automation.inInt lcid] Automation.outInt
getProtectDrawingObjects :: Prelude.Int -> Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getProtectDrawingObjects lcid =
  Automation.propertyGetID 0x125 [Automation.inInt lcid] Automation.outInt
getProtectionMode :: Prelude.Int -> Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getProtectionMode lcid =
  Automation.propertyGetID 0x487 [Automation.inInt lcid] Automation.outInt
dummy23 :: Automation.IDispatch a -> Prelude.IO ()
dummy23 = Automation.methodID0 0x10017 []
saveAs :: Prelude.String -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Automation.IDispatch a -> Prelude.IO ()
saveAs filename fileFormat password writeResPassword readOnlyRecommended createBackup addToMru textCodepage textVisualLayout lcid =
  Automation.methodID0 0x11c [Automation.inString filename, Automation.inInt fileFormat, Automation.inInt password, Automation.inInt writeResPassword, Automation.inInt readOnlyRecommended, Automation.inInt createBackup, Automation.inInt addToMru, Automation.inInt textCodepage, Automation.inInt textVisualLayout, Automation.inInt lcid]
select1 :: Prelude.Int -> Prelude.Int -> Automation.IDispatch a -> Prelude.IO ()
select1 replace lcid =
  Automation.methodID0 0xeb [Automation.inInt replace, Automation.inInt lcid]
unprotect :: Prelude.Int -> Prelude.Int -> Automation.IDispatch a -> Prelude.IO ()
unprotect password lcid =
  Automation.methodID0 0x11d [Automation.inInt password, Automation.inInt lcid]
getVisible5 :: (Automation.Variant a0) => Prelude.Int -> Automation.IDispatch a -> Prelude.IO (a0)
getVisible5 lcid =
  Automation.propertyGetID 0x22e [Automation.inInt lcid] Automation.outVariant
setVisible5 :: (Automation.Variant a0) => Prelude.Int -> a0 -> Automation.IDispatch a -> Prelude.IO ()
setVisible5 lcid rHS =
  Automation.propertySetID 0x22e [Automation.inInt lcid, Automation.inVariant rHS]
getShapes :: Automation.IDispatch a -> Prelude.IO (Office.IShapes Automation.Interface)
getShapes =
  Automation.propertyGetID 0x561 [] Automation.outIDispatch
applyDataLabels :: (Automation.Variant a0) => a0 -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> IChart a -> Prelude.IO ()
applyDataLabels type0 legendKey autoText hasLeaderLines lcid =
  Automation.methodID0 0x97 [Automation.inVariant type0, Automation.inInt legendKey, Automation.inInt autoText, Automation.inInt hasLeaderLines, Automation.inInt lcid]
arcs :: Prelude.Int -> Prelude.Int -> Automation.IDispatch a -> Prelude.IO (Automation.IDispatch Automation.Interface)
arcs index lcid =
  Automation.functionID1 0x2f8 [Automation.inInt index, Automation.inInt lcid] Automation.outIDispatch
getArea3DGroup :: Prelude.Int -> IChart a -> Prelude.IO (IChartGroup Automation.Interface)
getArea3DGroup lcid =
  Automation.propertyGetID 0x11 [Automation.inInt lcid] Automation.outIDispatch
areaGroups :: Prelude.Int -> Prelude.Int -> IChart a -> Prelude.IO (Automation.IDispatch Automation.Interface)
areaGroups index lcid =
  Automation.functionID1 0x9 [Automation.inInt index, Automation.inInt lcid] Automation.outIDispatch
autoFormat0 :: Prelude.Int -> Prelude.Int -> IChart a -> Prelude.IO ()
autoFormat0 gallery format =
  Automation.methodID0 0x72 [Automation.inInt gallery, Automation.inInt format]
getAutoScaling :: Prelude.Int -> IChart a -> Prelude.IO (Prelude.Int)
getAutoScaling lcid =
  Automation.propertyGetID 0x6b [Automation.inInt lcid] Automation.outInt
setAutoScaling :: Prelude.Int -> Prelude.Int -> IChart a -> Prelude.IO ()
setAutoScaling lcid rHS =
  Automation.propertySetID 0x6b [Automation.inInt lcid, Automation.inInt rHS]
axes :: (Automation.Variant a0) => Prelude.Int -> a0 -> Prelude.Int -> IChart a -> Prelude.IO (Automation.IDispatch Automation.Interface)
axes type0 axisGroup lcid =
  Automation.functionID1 0x17 [Automation.inInt type0, Automation.inVariant axisGroup, Automation.inInt lcid] Automation.outIDispatch
setBackgroundPicture :: Prelude.String -> Automation.IDispatch a -> Prelude.IO ()
setBackgroundPicture filename =
  Automation.methodID0 0x4a4 [Automation.inString filename]
getBar3DGroup :: Prelude.Int -> IChart a -> Prelude.IO (IChartGroup Automation.Interface)
getBar3DGroup lcid =
  Automation.propertyGetID 0x12 [Automation.inInt lcid] Automation.outIDispatch
barGroups :: Prelude.Int -> Prelude.Int -> IChart a -> Prelude.IO (Automation.IDispatch Automation.Interface)
barGroups index lcid =
  Automation.functionID1 0xa [Automation.inInt index, Automation.inInt lcid] Automation.outIDispatch
buttons :: Prelude.Int -> Prelude.Int -> Automation.IDispatch a -> Prelude.IO (Automation.IDispatch Automation.Interface)
buttons index lcid =
  Automation.functionID1 0x22d [Automation.inInt index, Automation.inInt lcid] Automation.outIDispatch
getChartArea :: Prelude.Int -> IChart a -> Prelude.IO (IChartArea Automation.Interface)
getChartArea lcid =
  Automation.propertyGetID 0x50 [Automation.inInt lcid] Automation.outIDispatch
chartGroups :: Prelude.Int -> Prelude.Int -> IChart a -> Prelude.IO (Automation.IDispatch Automation.Interface)
chartGroups index lcid =
  Automation.functionID1 0x8 [Automation.inInt index, Automation.inInt lcid] Automation.outIDispatch
chartObjects :: Prelude.Int -> Prelude.Int -> Automation.IDispatch a -> Prelude.IO (Automation.IDispatch Automation.Interface)
chartObjects index lcid =
  Automation.functionID1 0x424 [Automation.inInt index, Automation.inInt lcid] Automation.outIDispatch
getChartTitle :: Prelude.Int -> IChart a -> Prelude.IO (IChartTitle Automation.Interface)
getChartTitle lcid =
  Automation.propertyGetID 0x51 [Automation.inInt lcid] Automation.outIDispatch
chartWizard :: Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> IChart a -> Prelude.IO ()
chartWizard source gallery format plotBy categoryLabels seriesLabels hasLegend title categoryTitle valueTitle extraTitle lcid =
  Automation.methodID0 0xc4 [Automation.inInt source, Automation.inInt gallery, Automation.inInt format, Automation.inInt plotBy, Automation.inInt categoryLabels, Automation.inInt seriesLabels, Automation.inInt hasLegend, Automation.inInt title, Automation.inInt categoryTitle, Automation.inInt valueTitle, Automation.inInt extraTitle, Automation.inInt lcid]
checkBoxes :: Prelude.Int -> Prelude.Int -> Automation.IDispatch a -> Prelude.IO (Automation.IDispatch Automation.Interface)
checkBoxes index lcid =
  Automation.functionID1 0x338 [Automation.inInt index, Automation.inInt lcid] Automation.outIDispatch
checkSpelling1 :: Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Automation.IDispatch a -> Prelude.IO ()
checkSpelling1 customDictionary ignoreUppercase alwaysSuggest ignoreInitialAlefHamza ignoreFinalYaa spellScript lcid =
  Automation.methodID0 0x1f9 [Automation.inInt customDictionary, Automation.inInt ignoreUppercase, Automation.inInt alwaysSuggest, Automation.inInt ignoreInitialAlefHamza, Automation.inInt ignoreFinalYaa, Automation.inInt spellScript, Automation.inInt lcid]
getColumn3DGroup :: Prelude.Int -> IChart a -> Prelude.IO (IChartGroup Automation.Interface)
getColumn3DGroup lcid =
  Automation.propertyGetID 0x13 [Automation.inInt lcid] Automation.outIDispatch
columnGroups :: Prelude.Int -> Prelude.Int -> IChart a -> Prelude.IO (Automation.IDispatch Automation.Interface)
columnGroups index lcid =
  Automation.functionID1 0xb [Automation.inInt index, Automation.inInt lcid] Automation.outIDispatch
copyPicture0 :: (Automation.Variant a0, Automation.Variant a1, Automation.Variant a2) => a0 -> a1 -> a2 -> Prelude.Int -> Automation.IDispatch a -> Prelude.IO ()
copyPicture0 appearance format size lcid =
  Automation.methodID0 0xd5 [Automation.inVariant appearance, Automation.inVariant format, Automation.inVariant size, Automation.inInt lcid]
getCorners :: Prelude.Int -> IChart a -> Prelude.IO (ICorners Automation.Interface)
getCorners lcid =
  Automation.propertyGetID 0x4f [Automation.inInt lcid] Automation.outIDispatch
createPublisher0 :: (Automation.Variant a0, Automation.Variant a1) => Prelude.Int -> a0 -> a1 -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> IChart a -> Prelude.IO ()
createPublisher0 edition appearance size containsPICT containsBIFF containsRTF containsVALU lcid =
  Automation.methodID0 0x1ca [Automation.inInt edition, Automation.inVariant appearance, Automation.inVariant size, Automation.inInt containsPICT, Automation.inInt containsBIFF, Automation.inInt containsRTF, Automation.inInt containsVALU, Automation.inInt lcid]
getDataTable :: IChart a -> Prelude.IO (IDataTable Automation.Interface)
getDataTable =
  Automation.propertyGetID 0x573 [] Automation.outIDispatch
getDepthPercent :: Prelude.Int -> IChart a -> Prelude.IO (Prelude.Int)
getDepthPercent lcid =
  Automation.propertyGetID 0x30 [Automation.inInt lcid] Automation.outInt
setDepthPercent :: Prelude.Int -> Prelude.Int -> IChart a -> Prelude.IO ()
setDepthPercent lcid rHS =
  Automation.propertySetID 0x30 [Automation.inInt lcid, Automation.inInt rHS]
deselect :: Prelude.Int -> IChart a -> Prelude.IO ()
deselect lcid = Automation.methodID0 0x460 [Automation.inInt lcid]
getDisplayBlanksAs :: (Automation.Variant a0) => Prelude.Int -> IChart a -> Prelude.IO (a0)
getDisplayBlanksAs lcid =
  Automation.propertyGetID 0x5d [Automation.inInt lcid] Automation.outVariant
setDisplayBlanksAs :: (Automation.Variant a0) => Prelude.Int -> a0 -> IChart a -> Prelude.IO ()
setDisplayBlanksAs lcid rHS =
  Automation.propertySetID 0x5d [Automation.inInt lcid, Automation.inVariant rHS]
doughnutGroups :: Prelude.Int -> Prelude.Int -> IChart a -> Prelude.IO (Automation.IDispatch Automation.Interface)
doughnutGroups index lcid =
  Automation.functionID1 0xe [Automation.inInt index, Automation.inInt lcid] Automation.outIDispatch
drawings :: Prelude.Int -> Prelude.Int -> Automation.IDispatch a -> Prelude.IO (Automation.IDispatch Automation.Interface)
drawings index lcid =
  Automation.functionID1 0x304 [Automation.inInt index, Automation.inInt lcid] Automation.outIDispatch
drawingObjects :: Prelude.Int -> Prelude.Int -> Automation.IDispatch a -> Prelude.IO (Automation.IDispatch Automation.Interface)
drawingObjects index lcid =
  Automation.functionID1 0x58 [Automation.inInt index, Automation.inInt lcid] Automation.outIDispatch
dropDowns :: Prelude.Int -> Prelude.Int -> Automation.IDispatch a -> Prelude.IO (Automation.IDispatch Automation.Interface)
dropDowns index lcid =
  Automation.functionID1 0x344 [Automation.inInt index, Automation.inInt lcid] Automation.outIDispatch
getElevation :: Prelude.Int -> IChart a -> Prelude.IO (Prelude.Int)
getElevation lcid =
  Automation.propertyGetID 0x31 [Automation.inInt lcid] Automation.outInt
setElevation :: Prelude.Int -> Prelude.Int -> IChart a -> Prelude.IO ()
setElevation lcid rHS =
  Automation.propertySetID 0x31 [Automation.inInt lcid, Automation.inInt rHS]
getFloor :: Prelude.Int -> IChart a -> Prelude.IO (IFloor Automation.Interface)
getFloor lcid =
  Automation.propertyGetID 0x53 [Automation.inInt lcid] Automation.outIDispatch
getGapDepth :: Prelude.Int -> IChart a -> Prelude.IO (Prelude.Int)
getGapDepth lcid =
  Automation.propertyGetID 0x32 [Automation.inInt lcid] Automation.outInt
setGapDepth :: Prelude.Int -> Prelude.Int -> IChart a -> Prelude.IO ()
setGapDepth lcid rHS =
  Automation.propertySetID 0x32 [Automation.inInt lcid, Automation.inInt rHS]
groupBoxes :: Prelude.Int -> Prelude.Int -> Automation.IDispatch a -> Prelude.IO (Automation.IDispatch Automation.Interface)
groupBoxes index lcid =
  Automation.functionID1 0x342 [Automation.inInt index, Automation.inInt lcid] Automation.outIDispatch
groupObjects :: Prelude.Int -> Prelude.Int -> Automation.IDispatch a -> Prelude.IO (Automation.IDispatch Automation.Interface)
groupObjects index lcid =
  Automation.functionID1 0x459 [Automation.inInt index, Automation.inInt lcid] Automation.outIDispatch
getHasAxis :: Prelude.Int -> Prelude.Int -> Prelude.Int -> IChart a -> Prelude.IO (Prelude.Int)
getHasAxis index1 index2 lcid =
  Automation.propertyGetID 0x34 [Automation.inInt index1, Automation.inInt index2, Automation.inInt lcid] Automation.outInt
setHasAxis :: Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> IChart a -> Prelude.IO ()
setHasAxis index1 index2 lcid rHS =
  Automation.propertySetID 0x34 [Automation.inInt index1, Automation.inInt index2, Automation.inInt lcid, Automation.inInt rHS]
getHasDataTable :: IChart a -> Prelude.IO (Prelude.Int)
getHasDataTable =
  Automation.propertyGetID 0x574 [] Automation.outInt
setHasDataTable :: Prelude.Int -> IChart a -> Prelude.IO ()
setHasDataTable rHS =
  Automation.propertySetID 0x574 [Automation.inInt rHS]
getHasLegend :: Prelude.Int -> IChart a -> Prelude.IO (Prelude.Int)
getHasLegend lcid =
  Automation.propertyGetID 0x35 [Automation.inInt lcid] Automation.outInt
setHasLegend :: Prelude.Int -> Prelude.Int -> IChart a -> Prelude.IO ()
setHasLegend lcid rHS =
  Automation.propertySetID 0x35 [Automation.inInt lcid, Automation.inInt rHS]
getHasTitle :: Prelude.Int -> IChart a -> Prelude.IO (Prelude.Int)
getHasTitle lcid =
  Automation.propertyGetID 0x36 [Automation.inInt lcid] Automation.outInt
setHasTitle :: Prelude.Int -> Prelude.Int -> IChart a -> Prelude.IO ()
setHasTitle lcid rHS =
  Automation.propertySetID 0x36 [Automation.inInt lcid, Automation.inInt rHS]
getHeightPercent :: Prelude.Int -> IChart a -> Prelude.IO (Prelude.Int)
getHeightPercent lcid =
  Automation.propertyGetID 0x37 [Automation.inInt lcid] Automation.outInt
setHeightPercent :: Prelude.Int -> Prelude.Int -> IChart a -> Prelude.IO ()
setHeightPercent lcid rHS =
  Automation.propertySetID 0x37 [Automation.inInt lcid, Automation.inInt rHS]
labels :: Prelude.Int -> Prelude.Int -> Automation.IDispatch a -> Prelude.IO (Automation.IDispatch Automation.Interface)
labels index lcid =
  Automation.functionID1 0x349 [Automation.inInt index, Automation.inInt lcid] Automation.outIDispatch
getLegend :: Prelude.Int -> IChart a -> Prelude.IO (ILegend Automation.Interface)
getLegend lcid =
  Automation.propertyGetID 0x54 [Automation.inInt lcid] Automation.outIDispatch
getLine3DGroup :: Prelude.Int -> IChart a -> Prelude.IO (IChartGroup Automation.Interface)
getLine3DGroup lcid =
  Automation.propertyGetID 0x14 [Automation.inInt lcid] Automation.outIDispatch
lineGroups :: Prelude.Int -> Prelude.Int -> IChart a -> Prelude.IO (Automation.IDispatch Automation.Interface)
lineGroups index lcid =
  Automation.functionID1 0xc [Automation.inInt index, Automation.inInt lcid] Automation.outIDispatch
lines :: Prelude.Int -> Prelude.Int -> Automation.IDispatch a -> Prelude.IO (Automation.IDispatch Automation.Interface)
lines index lcid =
  Automation.functionID1 0x2ff [Automation.inInt index, Automation.inInt lcid] Automation.outIDispatch
listBoxes :: Prelude.Int -> Prelude.Int -> Automation.IDispatch a -> Prelude.IO (Automation.IDispatch Automation.Interface)
listBoxes index lcid =
  Automation.functionID1 0x340 [Automation.inInt index, Automation.inInt lcid] Automation.outIDispatch
location :: (Automation.Variant a0) => a0 -> Prelude.Int -> IChart a -> Prelude.IO (IChart Automation.Interface)
location where0 name =
  Automation.functionID1 0x575 [Automation.inVariant where0, Automation.inInt name] Automation.outIDispatch
oLEObjects :: Prelude.Int -> Prelude.Int -> Automation.IDispatch a -> Prelude.IO (Automation.IDispatch Automation.Interface)
oLEObjects index lcid =
  Automation.functionID1 0x31f [Automation.inInt index, Automation.inInt lcid] Automation.outIDispatch
optionButtons :: Prelude.Int -> Prelude.Int -> Automation.IDispatch a -> Prelude.IO (Automation.IDispatch Automation.Interface)
optionButtons index lcid =
  Automation.functionID1 0x33a [Automation.inInt index, Automation.inInt lcid] Automation.outIDispatch
ovals :: Prelude.Int -> Prelude.Int -> Automation.IDispatch a -> Prelude.IO (Automation.IDispatch Automation.Interface)
ovals index lcid =
  Automation.functionID1 0x321 [Automation.inInt index, Automation.inInt lcid] Automation.outIDispatch
paste :: Prelude.Int -> Prelude.Int -> IChart a -> Prelude.IO ()
paste type0 lcid =
  Automation.methodID0 0xd3 [Automation.inInt type0, Automation.inInt lcid]
getPerspective0 :: Prelude.Int -> IChart a -> Prelude.IO (Prelude.Int)
getPerspective0 lcid =
  Automation.propertyGetID 0x39 [Automation.inInt lcid] Automation.outInt
setPerspective0 :: Prelude.Int -> Prelude.Int -> IChart a -> Prelude.IO ()
setPerspective0 lcid rHS =
  Automation.propertySetID 0x39 [Automation.inInt lcid, Automation.inInt rHS]
pictures :: Prelude.Int -> Prelude.Int -> Automation.IDispatch a -> Prelude.IO (Automation.IDispatch Automation.Interface)
pictures index lcid =
  Automation.functionID1 0x303 [Automation.inInt index, Automation.inInt lcid] Automation.outIDispatch
getPie3DGroup :: Prelude.Int -> IChart a -> Prelude.IO (IChartGroup Automation.Interface)
getPie3DGroup lcid =
  Automation.propertyGetID 0x15 [Automation.inInt lcid] Automation.outIDispatch
pieGroups :: Prelude.Int -> Prelude.Int -> IChart a -> Prelude.IO (Automation.IDispatch Automation.Interface)
pieGroups index lcid =
  Automation.functionID1 0xd [Automation.inInt index, Automation.inInt lcid] Automation.outIDispatch
getPlotArea :: Prelude.Int -> IChart a -> Prelude.IO (IPlotArea Automation.Interface)
getPlotArea lcid =
  Automation.propertyGetID 0x55 [Automation.inInt lcid] Automation.outIDispatch
getPlotVisibleOnly :: Prelude.Int -> IChart a -> Prelude.IO (Prelude.Int)
getPlotVisibleOnly lcid =
  Automation.propertyGetID 0x5c [Automation.inInt lcid] Automation.outInt
setPlotVisibleOnly :: Prelude.Int -> Prelude.Int -> IChart a -> Prelude.IO ()
setPlotVisibleOnly lcid rHS =
  Automation.propertySetID 0x5c [Automation.inInt lcid, Automation.inInt rHS]
radarGroups :: Prelude.Int -> Prelude.Int -> IChart a -> Prelude.IO (Automation.IDispatch Automation.Interface)
radarGroups index lcid =
  Automation.functionID1 0xf [Automation.inInt index, Automation.inInt lcid] Automation.outIDispatch
rectangles :: Prelude.Int -> Prelude.Int -> Automation.IDispatch a -> Prelude.IO (Automation.IDispatch Automation.Interface)
rectangles index lcid =
  Automation.functionID1 0x306 [Automation.inInt index, Automation.inInt lcid] Automation.outIDispatch
getRightAngleAxes :: Prelude.Int -> IChart a -> Prelude.IO (Prelude.Int)
getRightAngleAxes lcid =
  Automation.propertyGetID 0x3a [Automation.inInt lcid] Automation.outInt
setRightAngleAxes :: Prelude.Int -> Prelude.Int -> IChart a -> Prelude.IO ()
setRightAngleAxes lcid rHS =
  Automation.propertySetID 0x3a [Automation.inInt lcid, Automation.inInt rHS]
getRotation :: Prelude.Int -> IChart a -> Prelude.IO (Prelude.Int)
getRotation lcid =
  Automation.propertyGetID 0x3b [Automation.inInt lcid] Automation.outInt
setRotation :: Prelude.Int -> Prelude.Int -> IChart a -> Prelude.IO ()
setRotation lcid rHS =
  Automation.propertySetID 0x3b [Automation.inInt lcid, Automation.inInt rHS]
scrollBars :: Prelude.Int -> Prelude.Int -> Automation.IDispatch a -> Prelude.IO (Automation.IDispatch Automation.Interface)
scrollBars index lcid =
  Automation.functionID1 0x33e [Automation.inInt index, Automation.inInt lcid] Automation.outIDispatch
seriesCollection :: Prelude.Int -> Prelude.Int -> IChart a -> Prelude.IO (Automation.IDispatch Automation.Interface)
seriesCollection index lcid =
  Automation.functionID1 0x44 [Automation.inInt index, Automation.inInt lcid] Automation.outIDispatch
getSizeWithWindow :: Prelude.Int -> IChart a -> Prelude.IO (Prelude.Int)
getSizeWithWindow lcid =
  Automation.propertyGetID 0x5e [Automation.inInt lcid] Automation.outInt
setSizeWithWindow :: Prelude.Int -> Prelude.Int -> IChart a -> Prelude.IO ()
setSizeWithWindow lcid rHS =
  Automation.propertySetID 0x5e [Automation.inInt lcid, Automation.inInt rHS]
getShowWindow :: IChart a -> Prelude.IO (Prelude.Int)
getShowWindow = Automation.propertyGetID 0x577 [] Automation.outInt
setShowWindow :: Prelude.Int -> IChart a -> Prelude.IO ()
setShowWindow rHS =
  Automation.propertySetID 0x577 [Automation.inInt rHS]
spinners :: Prelude.Int -> Prelude.Int -> Automation.IDispatch a -> Prelude.IO (Automation.IDispatch Automation.Interface)
spinners index lcid =
  Automation.functionID1 0x346 [Automation.inInt index, Automation.inInt lcid] Automation.outIDispatch
getSubType :: Prelude.Int -> IChart a -> Prelude.IO (Prelude.Int)
getSubType lcid =
  Automation.propertyGetID 0x6d [Automation.inInt lcid] Automation.outInt
setSubType :: Prelude.Int -> Prelude.Int -> IChart a -> Prelude.IO ()
setSubType lcid rHS =
  Automation.propertySetID 0x6d [Automation.inInt lcid, Automation.inInt rHS]
getSurfaceGroup :: Prelude.Int -> IChart a -> Prelude.IO (IChartGroup Automation.Interface)
getSurfaceGroup lcid =
  Automation.propertyGetID 0x16 [Automation.inInt lcid] Automation.outIDispatch
textBoxes :: Prelude.Int -> Prelude.Int -> Automation.IDispatch a -> Prelude.IO (Automation.IDispatch Automation.Interface)
textBoxes index lcid =
  Automation.functionID1 0x309 [Automation.inInt index, Automation.inInt lcid] Automation.outIDispatch
getType4 :: Prelude.Int -> IChart a -> Prelude.IO (Prelude.Int)
getType4 lcid =
  Automation.propertyGetID 0x6c [Automation.inInt lcid] Automation.outInt
setType1 :: Prelude.Int -> Prelude.Int -> IChart a -> Prelude.IO ()
setType1 lcid rHS =
  Automation.propertySetID 0x6c [Automation.inInt lcid, Automation.inInt rHS]
getChartType :: (Automation.Variant a0) => Automation.IDispatch a -> Prelude.IO (a0)
getChartType =
  Automation.propertyGetID 0x578 [] Automation.outVariant
setChartType :: (Automation.Variant a0) => a0 -> Automation.IDispatch a -> Prelude.IO ()
setChartType rHS =
  Automation.propertySetID 0x578 [Automation.inVariant rHS]
applyCustomType :: (Automation.Variant a0) => a0 -> Prelude.Int -> IChart a -> Prelude.IO ()
applyCustomType chartType typeName =
  Automation.methodID0 0x579 [Automation.inVariant chartType, Automation.inInt typeName]
getWalls :: Prelude.Int -> IChart a -> Prelude.IO (IWalls Automation.Interface)
getWalls lcid =
  Automation.propertyGetID 0x56 [Automation.inInt lcid] Automation.outIDispatch
getWallsAndGridlines2D :: Prelude.Int -> IChart a -> Prelude.IO (Prelude.Int)
getWallsAndGridlines2D lcid =
  Automation.propertyGetID 0xd2 [Automation.inInt lcid] Automation.outInt
setWallsAndGridlines2D :: Prelude.Int -> Prelude.Int -> IChart a -> Prelude.IO ()
setWallsAndGridlines2D lcid rHS =
  Automation.propertySetID 0xd2 [Automation.inInt lcid, Automation.inInt rHS]
xYGroups :: Prelude.Int -> Prelude.Int -> IChart a -> Prelude.IO (Automation.IDispatch Automation.Interface)
xYGroups index lcid =
  Automation.functionID1 0x10 [Automation.inInt index, Automation.inInt lcid] Automation.outIDispatch
getBarShape :: (Automation.Variant a0) => Automation.IDispatch a -> Prelude.IO (a0)
getBarShape =
  Automation.propertyGetID 0x57b [] Automation.outVariant
setBarShape :: (Automation.Variant a0) => a0 -> Automation.IDispatch a -> Prelude.IO ()
setBarShape rHS =
  Automation.propertySetID 0x57b [Automation.inVariant rHS]
getPlotBy :: (Automation.Variant a0) => IChart a -> Prelude.IO (a0)
getPlotBy = Automation.propertyGetID 0xca [] Automation.outVariant
setPlotBy :: (Automation.Variant a0) => a0 -> IChart a -> Prelude.IO ()
setPlotBy rHS =
  Automation.propertySetID 0xca [Automation.inVariant rHS]
copyChartBuild :: IChart a -> Prelude.IO ()
copyChartBuild = Automation.methodID0 0x57c []
getProtectFormatting :: IChart a -> Prelude.IO (Prelude.Int)
getProtectFormatting =
  Automation.propertyGetID 0x57d [] Automation.outInt
setProtectFormatting :: Prelude.Int -> IChart a -> Prelude.IO ()
setProtectFormatting rHS =
  Automation.propertySetID 0x57d [Automation.inInt rHS]
getProtectData :: IChart a -> Prelude.IO (Prelude.Int)
getProtectData =
  Automation.propertyGetID 0x57e [] Automation.outInt
setProtectData :: Prelude.Int -> IChart a -> Prelude.IO ()
setProtectData rHS =
  Automation.propertySetID 0x57e [Automation.inInt rHS]
getProtectGoalSeek :: IChart a -> Prelude.IO (Prelude.Int)
getProtectGoalSeek =
  Automation.propertyGetID 0x57f [] Automation.outInt
setProtectGoalSeek :: Prelude.Int -> IChart a -> Prelude.IO ()
setProtectGoalSeek rHS =
  Automation.propertySetID 0x57f [Automation.inInt rHS]
getProtectSelection :: IChart a -> Prelude.IO (Prelude.Int)
getProtectSelection =
  Automation.propertyGetID 0x580 [] Automation.outInt
setProtectSelection :: Prelude.Int -> IChart a -> Prelude.IO ()
setProtectSelection rHS =
  Automation.propertySetID 0x580 [Automation.inInt rHS]
getChartElement :: Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> IChart a -> Prelude.IO ()
getChartElement x y elementID arg1 arg2 =
  Automation.methodID0 0x581 [Automation.inInt x, Automation.inInt y, Automation.inInt elementID, Automation.inInt arg1, Automation.inInt arg2]
setSourceData :: IRange a0 -> Prelude.Int -> IChart a -> Prelude.IO ()
setSourceData source plotBy =
  Automation.methodID0 0x585 [Automation.inIDispatch source, Automation.inInt plotBy]
export :: Prelude.String -> Prelude.Int -> Prelude.Int -> IChart a -> Prelude.IO (Prelude.Int)
export filename filterName interactive =
  Automation.functionID1 0x586 [Automation.inString filename, Automation.inInt filterName, Automation.inInt interactive] Automation.outInt
refresh :: Automation.IDispatch a -> Prelude.IO ()
refresh = Automation.methodID0 0x589 []
-- --------------------------------------------------
-- 
-- interface Sheets
-- 
-- --------------------------------------------------
data Sheets a = Sheets
                 
type ISheets a = Automation.IDispatch (Sheets a)
iidISheets :: Com.IID (ISheets Automation.Interface)
iidISheets = Com.mkIID "{000208D7-0000-0000-C000-000000000046}"
add :: Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Automation.IDispatch a -> Prelude.IO (Automation.IDispatch Automation.Interface)
add before after count type0 lcid =
  Automation.functionID1 0xb5 [Automation.inInt before, Automation.inInt after, Automation.inInt count, Automation.inInt type0, Automation.inInt lcid] Automation.outIDispatch
fillAcrossSheets :: (Automation.Variant a1) => IRange a0 -> a1 -> Prelude.Int -> Automation.IDispatch a -> Prelude.IO ()
fillAcrossSheets range type0 lcid =
  Automation.methodID0 0x1d5 [Automation.inIDispatch range, Automation.inVariant type0, Automation.inInt lcid]
getItem2 :: Prelude.Int -> Automation.IDispatch a -> Prelude.IO (Automation.IDispatch Automation.Interface)
getItem2 index =
  Automation.propertyGetID 0xaa [Automation.inInt index] Automation.outIDispatch
getHPageBreaks :: Automation.IDispatch a -> Prelude.IO (IHPageBreaks Automation.Interface)
getHPageBreaks =
  Automation.propertyGetID 0x58a [] Automation.outIDispatch
getVPageBreaks :: Automation.IDispatch a -> Prelude.IO (IVPageBreaks Automation.Interface)
getVPageBreaks =
  Automation.propertyGetID 0x58b [] Automation.outIDispatch
getVisible6 :: Prelude.Int -> Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getVisible6 lcid =
  Automation.propertyGetID 0x22e [Automation.inInt lcid] Automation.outInt
setVisible6 :: Prelude.Int -> Prelude.Int -> Automation.IDispatch a -> Prelude.IO ()
setVisible6 lcid rHS =
  Automation.propertySetID 0x22e [Automation.inInt lcid, Automation.inInt rHS]
getDefault2 :: Prelude.Int -> Automation.IDispatch a -> Prelude.IO (Automation.IDispatch Automation.Interface)
getDefault2 index =
  Automation.propertyGetID 0o0 [Automation.inInt index] Automation.outIDispatch
-- --------------------------------------------------
-- 
-- interface IVPageBreak
-- 
-- --------------------------------------------------
data VPageBreak a = VPageBreak
                     
type IVPageBreak a = Automation.IDispatch (VPageBreak a)
iidIVPageBreak :: Com.IID (IVPageBreak Automation.Interface)
iidIVPageBreak = Com.mkIID "{00024402-0001-0000-C000-000000000046}"
getParent18 :: Automation.IDispatch a -> Prelude.IO (IWorksheet Automation.Interface)
getParent18 =
  Automation.propertyGet "Parent" [] Automation.outIDispatch
delete3 :: Automation.IDispatch a -> Prelude.IO ()
delete3 = Automation.method0 "Delete" []
dragOff :: (Automation.Variant a0) => a0 -> Prelude.Int -> Automation.IDispatch a -> Prelude.IO ()
dragOff direction regionIndex =
  Automation.method0 "DragOff" [Automation.inVariant direction, Automation.inInt regionIndex]
getType5 :: (Automation.Variant a0) => Automation.IDispatch a -> Prelude.IO (a0)
getType5 = Automation.propertyGet "Type" [] Automation.outVariant
setType2 :: (Automation.Variant a0) => a0 -> Automation.IDispatch a -> Prelude.IO ()
setType2 rHS =
  Automation.propertySet "Type" [Automation.inVariant rHS]
getExtent :: (Automation.Variant a0) => Automation.IDispatch a -> Prelude.IO (a0)
getExtent =
  Automation.propertyGet "Extent" [] Automation.outVariant
getLocation :: Automation.IDispatch a -> Prelude.IO (IRange Automation.Interface)
getLocation =
  Automation.propertyGet "Location" [] Automation.outIDispatch
location0 :: IRange a0 -> Automation.IDispatch a -> Prelude.IO ()
location0 rHS =
  Automation.method0 "Location" [Automation.inIDispatch rHS]
-- --------------------------------------------------
-- 
-- interface IHPageBreak
-- 
-- --------------------------------------------------
data HPageBreak a = HPageBreak
                     
type IHPageBreak a = Automation.IDispatch (HPageBreak a)
iidIHPageBreak :: Com.IID (IHPageBreak Automation.Interface)
iidIHPageBreak = Com.mkIID "{00024401-0001-0000-C000-000000000046}"
-- --------------------------------------------------
-- 
-- interface IHPageBreaks
-- 
-- --------------------------------------------------
data HPageBreaks a = HPageBreaks
                      
type IHPageBreaks a = Automation.IDispatch (HPageBreaks a)
iidIHPageBreaks :: Com.IID (IHPageBreaks Automation.Interface)
iidIHPageBreaks =
  Com.mkIID "{00024404-0001-0000-C000-000000000046}"
getItem3 :: Prelude.Int -> IHPageBreaks a -> Prelude.IO (IHPageBreak Automation.Interface)
getItem3 index =
  Automation.propertyGet "Item" [Automation.inInt index] Automation.outIDispatch
getDefault3 :: Prelude.Int -> IHPageBreaks a -> Prelude.IO (IHPageBreak Automation.Interface)
getDefault3 index =
  Automation.propertyGet "_Default" [Automation.inInt index] Automation.outIDispatch
add0 :: Automation.IDispatch a0 -> IHPageBreaks a -> Prelude.IO (IHPageBreak Automation.Interface)
add0 before =
  Automation.function1 "Add" [Automation.inIDispatch before] Automation.outIDispatch
-- --------------------------------------------------
-- 
-- interface IVPageBreaks
-- 
-- --------------------------------------------------
data VPageBreaks a = VPageBreaks
                      
type IVPageBreaks a = Automation.IDispatch (VPageBreaks a)
iidIVPageBreaks :: Com.IID (IVPageBreaks Automation.Interface)
iidIVPageBreaks =
  Com.mkIID "{00024405-0001-0000-C000-000000000046}"
getItem4 :: Prelude.Int -> IVPageBreaks a -> Prelude.IO (IVPageBreak Automation.Interface)
getItem4 index =
  Automation.propertyGet "Item" [Automation.inInt index] Automation.outIDispatch
getDefault4 :: Prelude.Int -> IVPageBreaks a -> Prelude.IO (IVPageBreak Automation.Interface)
getDefault4 index =
  Automation.propertyGet "_Default" [Automation.inInt index] Automation.outIDispatch
add1 :: Automation.IDispatch a0 -> IVPageBreaks a -> Prelude.IO (IVPageBreak Automation.Interface)
add1 before =
  Automation.function1 "Add" [Automation.inIDispatch before] Automation.outIDispatch
-- --------------------------------------------------
-- 
-- interface IRecentFile
-- 
-- --------------------------------------------------
data RecentFile a = RecentFile
                     
type IRecentFile a = Automation.IDispatch (RecentFile a)
iidIRecentFile :: Com.IID (IRecentFile Automation.Interface)
iidIRecentFile = Com.mkIID "{00024407-0001-0000-C000-000000000046}"
getPath0 :: Automation.IDispatch a -> Prelude.IO (Prelude.String)
getPath0 = Automation.propertyGet "Path" [] Automation.outString
open :: IRecentFile a -> Prelude.IO (IWorkbook Automation.Interface)
open = Automation.function1 "Open" [] Automation.outIDispatch
-- --------------------------------------------------
-- 
-- interface IRecentFiles
-- 
-- --------------------------------------------------
data RecentFiles a = RecentFiles
                      
type IRecentFiles a = Automation.IDispatch (RecentFiles a)
iidIRecentFiles :: Com.IID (IRecentFiles Automation.Interface)
iidIRecentFiles =
  Com.mkIID "{00024406-0001-0000-C000-000000000046}"
getMaximum :: IRecentFiles a -> Prelude.IO (Prelude.Int)
getMaximum = Automation.propertyGet "Maximum" [] Automation.outInt
setMaximum :: Prelude.Int -> IRecentFiles a -> Prelude.IO ()
setMaximum rHS =
  Automation.propertySet "Maximum" [Automation.inInt rHS]
getItem5 :: Prelude.Int -> IRecentFiles a -> Prelude.IO (IRecentFile Automation.Interface)
getItem5 index =
  Automation.propertyGet "Item" [Automation.inInt index] Automation.outIDispatch
getDefault5 :: Prelude.Int -> IRecentFiles a -> Prelude.IO (IRecentFile Automation.Interface)
getDefault5 index =
  Automation.propertyGet "_Default" [Automation.inInt index] Automation.outIDispatch
add2 :: Prelude.String -> IRecentFiles a -> Prelude.IO (IRecentFile Automation.Interface)
add2 name =
  Automation.function1 "Add" [Automation.inString name] Automation.outIDispatch
-- --------------------------------------------------
-- 
-- interface IDocEvents
-- 
-- --------------------------------------------------
data DocEvents a = DocEvents
                    
type IDocEvents a = Automation.IDispatch (DocEvents a)
iidIDocEvents :: Com.IID (IDocEvents Automation.Interface)
iidIDocEvents = Com.mkIID "{00024411-0001-0000-C000-000000000046}"
selectionChange :: IRange a0 -> IDocEvents a -> Prelude.IO ()
selectionChange target =
  Automation.method0 "SelectionChange" [Automation.inIDispatch target]
beforeDoubleClick0 :: IRange a0 -> Prelude.Int -> IDocEvents a -> Prelude.IO ()
beforeDoubleClick0 target cancel =
  Automation.method0 "BeforeDoubleClick" [Automation.inIDispatch target, Automation.inInt cancel]
beforeRightClick0 :: IRange a0 -> Prelude.Int -> IDocEvents a -> Prelude.IO ()
beforeRightClick0 target cancel =
  Automation.method0 "BeforeRightClick" [Automation.inIDispatch target, Automation.inInt cancel]
change :: IRange a0 -> IDocEvents a -> Prelude.IO ()
change target =
  Automation.method0 "Change" [Automation.inIDispatch target]
-- --------------------------------------------------
-- 
-- interface Worksheet
-- 
-- --------------------------------------------------
data Worksheet a = Worksheet
                    
type IWorksheet a = Automation.IDispatch (Worksheet a)
iidIWorksheet :: Com.IID (IWorksheet Automation.Interface)
iidIWorksheet = Com.mkIID "{000208D8-0000-0000-C000-000000000046}"
getProtectScenarios :: Prelude.Int -> Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getProtectScenarios lcid =
  Automation.propertyGetID 0x126 [Automation.inInt lcid] Automation.outInt
getTransitionExpEval :: Prelude.Int -> IWorksheet a -> Prelude.IO (Prelude.Int)
getTransitionExpEval lcid =
  Automation.propertyGetID 0x191 [Automation.inInt lcid] Automation.outInt
setTransitionExpEval :: Prelude.Int -> Prelude.Int -> IWorksheet a -> Prelude.IO ()
setTransitionExpEval lcid rHS =
  Automation.propertySetID 0x191 [Automation.inInt lcid, Automation.inInt rHS]
getAutoFilterMode :: Prelude.Int -> IWorksheet a -> Prelude.IO (Prelude.Int)
getAutoFilterMode lcid =
  Automation.propertyGetID 0x318 [Automation.inInt lcid] Automation.outInt
setAutoFilterMode :: Prelude.Int -> Prelude.Int -> IWorksheet a -> Prelude.IO ()
setAutoFilterMode lcid rHS =
  Automation.propertySetID 0x318 [Automation.inInt lcid, Automation.inInt rHS]
getEnableCalculation :: Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getEnableCalculation =
  Automation.propertyGetID 0x590 [] Automation.outInt
setEnableCalculation :: Prelude.Int -> Automation.IDispatch a -> Prelude.IO ()
setEnableCalculation rHS =
  Automation.propertySetID 0x590 [Automation.inInt rHS]
getCircularReference :: Prelude.Int -> IWorksheet a -> Prelude.IO (IRange Automation.Interface)
getCircularReference lcid =
  Automation.propertyGetID 0x42d [Automation.inInt lcid] Automation.outIDispatch
clearArrows :: Prelude.Int -> IWorksheet a -> Prelude.IO ()
clearArrows lcid =
  Automation.methodID0 0x3ca [Automation.inInt lcid]
getConsolidationFunction :: (Automation.Variant a0) => Prelude.Int -> IWorksheet a -> Prelude.IO (a0)
getConsolidationFunction lcid =
  Automation.propertyGetID 0x315 [Automation.inInt lcid] Automation.outVariant
getConsolidationOptions :: Prelude.Int -> IWorksheet a -> Prelude.IO (Prelude.Int)
getConsolidationOptions lcid =
  Automation.propertyGetID 0x316 [Automation.inInt lcid] Automation.outInt
getConsolidationSources :: Prelude.Int -> IWorksheet a -> Prelude.IO (Prelude.Int)
getConsolidationSources lcid =
  Automation.propertyGetID 0x317 [Automation.inInt lcid] Automation.outInt
getDisplayAutomaticPageBreaks :: Prelude.Int -> Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getDisplayAutomaticPageBreaks lcid =
  Automation.propertyGetID 0x283 [Automation.inInt lcid] Automation.outInt
setDisplayAutomaticPageBreaks :: Prelude.Int -> Prelude.Int -> Automation.IDispatch a -> Prelude.IO ()
setDisplayAutomaticPageBreaks lcid rHS =
  Automation.propertySetID 0x283 [Automation.inInt lcid, Automation.inInt rHS]
getEnableAutoFilter :: Prelude.Int -> Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getEnableAutoFilter lcid =
  Automation.propertyGetID 0x484 [Automation.inInt lcid] Automation.outInt
setEnableAutoFilter :: Prelude.Int -> Prelude.Int -> Automation.IDispatch a -> Prelude.IO ()
setEnableAutoFilter lcid rHS =
  Automation.propertySetID 0x484 [Automation.inInt lcid, Automation.inInt rHS]
getEnableSelection :: (Automation.Variant a0) => Automation.IDispatch a -> Prelude.IO (a0)
getEnableSelection =
  Automation.propertyGetID 0x591 [] Automation.outVariant
setEnableSelection :: (Automation.Variant a0) => a0 -> Automation.IDispatch a -> Prelude.IO ()
setEnableSelection rHS =
  Automation.propertySetID 0x591 [Automation.inVariant rHS]
getEnableOutlining :: Prelude.Int -> Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getEnableOutlining lcid =
  Automation.propertyGetID 0x485 [Automation.inInt lcid] Automation.outInt
setEnableOutlining :: Prelude.Int -> Prelude.Int -> Automation.IDispatch a -> Prelude.IO ()
setEnableOutlining lcid rHS =
  Automation.propertySetID 0x485 [Automation.inInt lcid, Automation.inInt rHS]
getEnablePivotTable :: Prelude.Int -> Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getEnablePivotTable lcid =
  Automation.propertyGetID 0x486 [Automation.inInt lcid] Automation.outInt
setEnablePivotTable :: Prelude.Int -> Prelude.Int -> Automation.IDispatch a -> Prelude.IO ()
setEnablePivotTable lcid rHS =
  Automation.propertySetID 0x486 [Automation.inInt lcid, Automation.inInt rHS]
getFilterMode :: Prelude.Int -> IWorksheet a -> Prelude.IO (Prelude.Int)
getFilterMode lcid =
  Automation.propertyGetID 0x320 [Automation.inInt lcid] Automation.outInt
resetAllPageBreaks :: Automation.IDispatch a -> Prelude.IO ()
resetAllPageBreaks = Automation.methodID0 0x592 []
getOutline :: IWorksheet a -> Prelude.IO (IOutline Automation.Interface)
getOutline =
  Automation.propertyGetID 0x66 [] Automation.outIDispatch
paste0 :: Prelude.Int -> Prelude.Int -> Prelude.Int -> Automation.IDispatch a -> Prelude.IO ()
paste0 destination link lcid =
  Automation.methodID0 0xd3 [Automation.inInt destination, Automation.inInt link, Automation.inInt lcid]
pasteSpecial0 :: Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Automation.IDispatch a -> Prelude.IO ()
pasteSpecial0 format link displayAsIcon iconFileName iconIndex iconLabel lcid =
  Automation.methodID0 0x403 [Automation.inInt format, Automation.inInt link, Automation.inInt displayAsIcon, Automation.inInt iconFileName, Automation.inInt iconIndex, Automation.inInt iconLabel, Automation.inInt lcid]
pivotTables :: Prelude.Int -> Prelude.Int -> IWorksheet a -> Prelude.IO (Automation.IDispatch Automation.Interface)
pivotTables index lcid =
  Automation.functionID1 0x2b2 [Automation.inInt index, Automation.inInt lcid] Automation.outIDispatch
pivotTableWizard :: Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> IWorksheet a -> Prelude.IO (IPivotTable Automation.Interface)
pivotTableWizard sourceType sourceData tableDestination tableName rowGrand columnGrand saveData hasAutoFormat autoPage reserved backgroundQuery optimizeCache pageFieldOrder pageFieldWrapCount readData connection lcid =
  Automation.functionID1 0x2ac [Automation.inInt sourceType, Automation.inInt sourceData, Automation.inInt tableDestination, Automation.inInt tableName, Automation.inInt rowGrand, Automation.inInt columnGrand, Automation.inInt saveData, Automation.inInt hasAutoFormat, Automation.inInt autoPage, Automation.inInt reserved, Automation.inInt backgroundQuery, Automation.inInt optimizeCache, Automation.inInt pageFieldOrder, Automation.inInt pageFieldWrapCount, Automation.inInt readData, Automation.inInt connection, Automation.inInt lcid] Automation.outIDispatch
scenarios :: Prelude.Int -> Prelude.Int -> IWorksheet a -> Prelude.IO (Automation.IDispatch Automation.Interface)
scenarios index lcid =
  Automation.functionID1 0x38c [Automation.inInt index, Automation.inInt lcid] Automation.outIDispatch
getScrollArea :: Automation.IDispatch a -> Prelude.IO (Prelude.String)
getScrollArea =
  Automation.propertyGetID 0x599 [] Automation.outString
setScrollArea :: Prelude.String -> Automation.IDispatch a -> Prelude.IO ()
setScrollArea rHS =
  Automation.propertySetID 0x599 [Automation.inString rHS]
showAllData :: Prelude.Int -> IWorksheet a -> Prelude.IO ()
showAllData lcid =
  Automation.methodID0 0x31a [Automation.inInt lcid]
showDataForm :: Prelude.Int -> IWorksheet a -> Prelude.IO ()
showDataForm lcid =
  Automation.methodID0 0x199 [Automation.inInt lcid]
getStandardHeight :: Prelude.Int -> IWorksheet a -> Prelude.IO (Prelude.Double)
getStandardHeight lcid =
  Automation.propertyGetID 0x197 [Automation.inInt lcid] Automation.outDouble
getStandardWidth :: Prelude.Int -> IWorksheet a -> Prelude.IO (Prelude.Double)
getStandardWidth lcid =
  Automation.propertyGetID 0x198 [Automation.inInt lcid] Automation.outDouble
setStandardWidth :: Prelude.Int -> Prelude.Double -> IWorksheet a -> Prelude.IO ()
setStandardWidth lcid rHS =
  Automation.propertySetID 0x198 [Automation.inInt lcid, Automation.inDouble rHS]
getTransitionFormEntry :: Prelude.Int -> IWorksheet a -> Prelude.IO (Prelude.Int)
getTransitionFormEntry lcid =
  Automation.propertyGetID 0x192 [Automation.inInt lcid] Automation.outInt
setTransitionFormEntry :: Prelude.Int -> Prelude.Int -> IWorksheet a -> Prelude.IO ()
setTransitionFormEntry lcid rHS =
  Automation.propertySetID 0x192 [Automation.inInt lcid, Automation.inInt rHS]
getType7 :: (Automation.Variant a0) => Prelude.Int -> IWorksheet a -> Prelude.IO (a0)
getType7 lcid =
  Automation.propertyGetID 0x6c [Automation.inInt lcid] Automation.outVariant
getUsedRange :: Prelude.Int -> IWorksheet a -> Prelude.IO (IRange Automation.Interface)
getUsedRange lcid =
  Automation.propertyGetID 0x19c [Automation.inInt lcid] Automation.outIDispatch
getQueryTables :: Automation.IDispatch a -> Prelude.IO (IQueryTables Automation.Interface)
getQueryTables =
  Automation.propertyGetID 0x59a [] Automation.outIDispatch
getDisplayPageBreaks :: Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getDisplayPageBreaks =
  Automation.propertyGetID 0x59b [] Automation.outInt
setDisplayPageBreaks :: Prelude.Int -> Automation.IDispatch a -> Prelude.IO ()
setDisplayPageBreaks rHS =
  Automation.propertySetID 0x59b [Automation.inInt rHS]
getComments :: Automation.IDispatch a -> Prelude.IO (IComments Automation.Interface)
getComments =
  Automation.propertyGetID 0x23f [] Automation.outIDispatch
clearCircles :: Automation.IDispatch a -> Prelude.IO ()
clearCircles = Automation.methodID0 0x59c []
circleInvalid :: Automation.IDispatch a -> Prelude.IO ()
circleInvalid = Automation.methodID0 0x59d []
getDisplayRightToLeft0 :: Prelude.Int -> Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getDisplayRightToLeft0 lcid =
  Automation.propertyGetID 0x288 [Automation.inInt lcid] Automation.outInt
setDisplayRightToLeft0 :: Prelude.Int -> Prelude.Int -> Automation.IDispatch a -> Prelude.IO ()
setDisplayRightToLeft0 lcid rHS =
  Automation.propertySetID 0x288 [Automation.inInt lcid, Automation.inInt rHS]
getAutoFilter :: Automation.IDispatch a -> Prelude.IO (IAutoFilter Automation.Interface)
getAutoFilter =
  Automation.propertyGetID 0x319 [] Automation.outIDispatch
-- --------------------------------------------------
-- 
-- interface IStyle
-- 
-- --------------------------------------------------
data Style a = Style
                
type IStyle a = Automation.IDispatch (Style a)
iidIStyle :: Com.IID (IStyle Automation.Interface)
iidIStyle = Com.mkIID "{00020852-0001-0000-C000-000000000046}"
getAddIndent0 :: Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getAddIndent0 =
  Automation.propertyGet "AddIndent" [] Automation.outInt
setAddIndent0 :: Prelude.Int -> Automation.IDispatch a -> Prelude.IO ()
setAddIndent0 rHS =
  Automation.propertySet "AddIndent" [Automation.inInt rHS]
getBuiltIn :: Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getBuiltIn = Automation.propertyGet "BuiltIn" [] Automation.outInt
getFormulaHidden0 :: IStyle a -> Prelude.IO (Prelude.Int)
getFormulaHidden0 =
  Automation.propertyGet "FormulaHidden" [] Automation.outInt
setFormulaHidden0 :: Prelude.Int -> IStyle a -> Prelude.IO ()
setFormulaHidden0 rHS =
  Automation.propertySet "FormulaHidden" [Automation.inInt rHS]
getHorizontalAlignment0 :: (Automation.Variant a0) => Automation.IDispatch a -> Prelude.IO (a0)
getHorizontalAlignment0 =
  Automation.propertyGet "HorizontalAlignment" [] Automation.outVariant
setHorizontalAlignment0 :: (Automation.Variant a0) => a0 -> Automation.IDispatch a -> Prelude.IO ()
setHorizontalAlignment0 rHS =
  Automation.propertySet "HorizontalAlignment" [Automation.inVariant rHS]
getIncludeAlignment :: IStyle a -> Prelude.IO (Prelude.Int)
getIncludeAlignment =
  Automation.propertyGet "IncludeAlignment" [] Automation.outInt
setIncludeAlignment :: Prelude.Int -> IStyle a -> Prelude.IO ()
setIncludeAlignment rHS =
  Automation.propertySet "IncludeAlignment" [Automation.inInt rHS]
getIncludeBorder :: IStyle a -> Prelude.IO (Prelude.Int)
getIncludeBorder =
  Automation.propertyGet "IncludeBorder" [] Automation.outInt
setIncludeBorder :: Prelude.Int -> IStyle a -> Prelude.IO ()
setIncludeBorder rHS =
  Automation.propertySet "IncludeBorder" [Automation.inInt rHS]
getIncludeFont :: IStyle a -> Prelude.IO (Prelude.Int)
getIncludeFont =
  Automation.propertyGet "IncludeFont" [] Automation.outInt
setIncludeFont :: Prelude.Int -> IStyle a -> Prelude.IO ()
setIncludeFont rHS =
  Automation.propertySet "IncludeFont" [Automation.inInt rHS]
getIncludeNumber :: IStyle a -> Prelude.IO (Prelude.Int)
getIncludeNumber =
  Automation.propertyGet "IncludeNumber" [] Automation.outInt
setIncludeNumber :: Prelude.Int -> IStyle a -> Prelude.IO ()
setIncludeNumber rHS =
  Automation.propertySet "IncludeNumber" [Automation.inInt rHS]
getIncludePatterns :: IStyle a -> Prelude.IO (Prelude.Int)
getIncludePatterns =
  Automation.propertyGet "IncludePatterns" [] Automation.outInt
setIncludePatterns :: Prelude.Int -> IStyle a -> Prelude.IO ()
setIncludePatterns rHS =
  Automation.propertySet "IncludePatterns" [Automation.inInt rHS]
getIncludeProtection :: IStyle a -> Prelude.IO (Prelude.Int)
getIncludeProtection =
  Automation.propertyGet "IncludeProtection" [] Automation.outInt
setIncludeProtection :: Prelude.Int -> IStyle a -> Prelude.IO ()
setIncludeProtection rHS =
  Automation.propertySet "IncludeProtection" [Automation.inInt rHS]
getLocked0 :: Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getLocked0 = Automation.propertyGet "Locked" [] Automation.outInt
setLocked0 :: Prelude.Int -> Automation.IDispatch a -> Prelude.IO ()
setLocked0 rHS =
  Automation.propertySet "Locked" [Automation.inInt rHS]
getName5 :: Prelude.Int -> Automation.IDispatch a -> Prelude.IO (Prelude.String)
getName5 lcid =
  Automation.propertyGet "Name" [Automation.inInt lcid] Automation.outString
getNameLocal :: Automation.IDispatch a -> Prelude.IO (Prelude.String)
getNameLocal =
  Automation.propertyGet "NameLocal" [] Automation.outString
getNumberFormat0 :: Automation.IDispatch a -> Prelude.IO (Prelude.String)
getNumberFormat0 =
  Automation.propertyGet "NumberFormat" [] Automation.outString
setNumberFormat0 :: Prelude.String -> Automation.IDispatch a -> Prelude.IO ()
setNumberFormat0 rHS =
  Automation.propertySet "NumberFormat" [Automation.inString rHS]
getNumberFormatLocal0 :: IStyle a -> Prelude.IO (Prelude.String)
getNumberFormatLocal0 =
  Automation.propertyGet "NumberFormatLocal" [] Automation.outString
setNumberFormatLocal0 :: Prelude.String -> IStyle a -> Prelude.IO ()
setNumberFormatLocal0 rHS =
  Automation.propertySet "NumberFormatLocal" [Automation.inString rHS]
getOrientation0 :: (Automation.Variant a0) => IStyle a -> Prelude.IO (a0)
getOrientation0 =
  Automation.propertyGet "Orientation" [] Automation.outVariant
setOrientation0 :: (Automation.Variant a0) => a0 -> IStyle a -> Prelude.IO ()
setOrientation0 rHS =
  Automation.propertySet "Orientation" [Automation.inVariant rHS]
getShrinkToFit0 :: IStyle a -> Prelude.IO (Prelude.Int)
getShrinkToFit0 =
  Automation.propertyGet "ShrinkToFit" [] Automation.outInt
setShrinkToFit0 :: Prelude.Int -> IStyle a -> Prelude.IO ()
setShrinkToFit0 rHS =
  Automation.propertySet "ShrinkToFit" [Automation.inInt rHS]
getValue1 :: Prelude.Int -> IStyle a -> Prelude.IO (Prelude.String)
getValue1 lcid =
  Automation.propertyGet "Value" [Automation.inInt lcid] Automation.outString
getVerticalAlignment0 :: (Automation.Variant a0) => Automation.IDispatch a -> Prelude.IO (a0)
getVerticalAlignment0 =
  Automation.propertyGet "VerticalAlignment" [] Automation.outVariant
setVerticalAlignment0 :: (Automation.Variant a0) => a0 -> Automation.IDispatch a -> Prelude.IO ()
setVerticalAlignment0 rHS =
  Automation.propertySet "VerticalAlignment" [Automation.inVariant rHS]
getWrapText0 :: IStyle a -> Prelude.IO (Prelude.Int)
getWrapText0 =
  Automation.propertyGet "WrapText" [] Automation.outInt
setWrapText0 :: Prelude.Int -> IStyle a -> Prelude.IO ()
setWrapText0 rHS =
  Automation.propertySet "WrapText" [Automation.inInt rHS]
getDefault6 :: Prelude.Int -> IStyle a -> Prelude.IO (Prelude.String)
getDefault6 lcid =
  Automation.propertyGet "_Default" [Automation.inInt lcid] Automation.outString
-- --------------------------------------------------
-- 
-- interface IStyles
-- 
-- --------------------------------------------------
data Styles a = Styles
                 
type IStyles a = Automation.IDispatch (Styles a)
iidIStyles :: Com.IID (IStyles Automation.Interface)
iidIStyles = Com.mkIID "{00020853-0001-0000-C000-000000000046}"
add3 :: Prelude.String -> Prelude.Int -> IStyles a -> Prelude.IO (IStyle Automation.Interface)
add3 name basedOn =
  Automation.function1 "Add" [Automation.inString name, Automation.inInt basedOn] Automation.outIDispatch
getItem6 :: Prelude.Int -> Prelude.Int -> IStyles a -> Prelude.IO (IStyle Automation.Interface)
getItem6 index lcid =
  Automation.propertyGet "Item" [Automation.inInt index, Automation.inInt lcid] Automation.outIDispatch
getDefault7 :: Prelude.Int -> Prelude.Int -> IStyles a -> Prelude.IO (IStyle Automation.Interface)
getDefault7 index lcid =
  Automation.propertyGet "_Default" [Automation.inInt index, Automation.inInt lcid] Automation.outIDispatch
-- --------------------------------------------------
-- 
-- interface IBorders
-- 
-- --------------------------------------------------
data Borders a = Borders
                  
type IBorders a = Automation.IDispatch (Borders a)
iidIBorders :: Com.IID (IBorders Automation.Interface)
iidIBorders = Com.mkIID "{00020855-0001-0000-C000-000000000046}"
getItem7 :: (Automation.Variant a0) => a0 -> IBorders a -> Prelude.IO (IBorder Automation.Interface)
getItem7 index =
  Automation.propertyGet "Item" [Automation.inVariant index] Automation.outIDispatch
getLineStyle :: Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getLineStyle =
  Automation.propertyGet "LineStyle" [] Automation.outInt
setLineStyle :: Prelude.Int -> Automation.IDispatch a -> Prelude.IO ()
setLineStyle rHS =
  Automation.propertySet "LineStyle" [Automation.inInt rHS]
getValue3 :: Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getValue3 = Automation.propertyGet "Value" [] Automation.outInt
setValue0 :: Prelude.Int -> Automation.IDispatch a -> Prelude.IO ()
setValue0 rHS =
  Automation.propertySet "Value" [Automation.inInt rHS]
getWeight0 :: Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getWeight0 = Automation.propertyGet "Weight" [] Automation.outInt
setWeight0 :: Prelude.Int -> Automation.IDispatch a -> Prelude.IO ()
setWeight0 rHS =
  Automation.propertySet "Weight" [Automation.inInt rHS]
getDefault8 :: (Automation.Variant a0) => a0 -> IBorders a -> Prelude.IO (IBorder Automation.Interface)
getDefault8 index =
  Automation.propertyGet "_Default" [Automation.inVariant index] Automation.outIDispatch
-- --------------------------------------------------
-- 
-- interface Global
-- 
-- --------------------------------------------------
data Global a = Global
                 
type IGlobal a = Automation.IDispatch (Global a)
iidIGlobal :: Com.IID (IGlobal Automation.Interface)
iidIGlobal = Com.mkIID "{000208D9-0000-0000-C000-000000000046}"
-- --------------------------------------------------
-- 
-- interface IAddIn
-- 
-- --------------------------------------------------
data AddIn a = AddIn
                
type IAddIn a = Automation.IDispatch (AddIn a)
iidIAddIn :: Com.IID (IAddIn Automation.Interface)
iidIAddIn = Com.mkIID "{00020857-0001-0000-C000-000000000046}"
getAuthor :: Automation.IDispatch a -> Prelude.IO (Prelude.String)
getAuthor = Automation.propertyGet "Author" [] Automation.outString
getComments0 :: IAddIn a -> Prelude.IO (Prelude.String)
getComments0 =
  Automation.propertyGet "Comments" [] Automation.outString
getFullName :: IAddIn a -> Prelude.IO (Prelude.String)
getFullName =
  Automation.propertyGet "FullName" [] Automation.outString
getInstalled :: IAddIn a -> Prelude.IO (Prelude.Int)
getInstalled =
  Automation.propertyGet "Installed" [] Automation.outInt
setInstalled :: Prelude.Int -> IAddIn a -> Prelude.IO ()
setInstalled rHS =
  Automation.propertySet "Installed" [Automation.inInt rHS]
getKeywords :: IAddIn a -> Prelude.IO (Prelude.String)
getKeywords =
  Automation.propertyGet "Keywords" [] Automation.outString
getSubject :: Automation.IDispatch a -> Prelude.IO (Prelude.String)
getSubject =
  Automation.propertyGet "Subject" [] Automation.outString
getTitle :: IAddIn a -> Prelude.IO (Prelude.String)
getTitle = Automation.propertyGet "Title" [] Automation.outString
-- --------------------------------------------------
-- 
-- interface IAddIns
-- 
-- --------------------------------------------------
data AddIns a = AddIns
                 
type IAddIns a = Automation.IDispatch (AddIns a)
iidIAddIns :: Com.IID (IAddIns Automation.Interface)
iidIAddIns = Com.mkIID "{00020858-0001-0000-C000-000000000046}"
add4 :: Prelude.String -> Prelude.Int -> IAddIns a -> Prelude.IO (IAddIn Automation.Interface)
add4 filename copyFile =
  Automation.function1 "Add" [Automation.inString filename, Automation.inInt copyFile] Automation.outIDispatch
getItem8 :: Prelude.Int -> IAddIns a -> Prelude.IO (IAddIn Automation.Interface)
getItem8 index =
  Automation.propertyGet "Item" [Automation.inInt index] Automation.outIDispatch
getDefault9 :: Prelude.Int -> IAddIns a -> Prelude.IO (IAddIn Automation.Interface)
getDefault9 index =
  Automation.propertyGet "_Default" [Automation.inInt index] Automation.outIDispatch
-- --------------------------------------------------
-- 
-- interface IToolbar
-- 
-- --------------------------------------------------
data Toolbar a = Toolbar
                  
type IToolbar a = Automation.IDispatch (Toolbar a)
iidIToolbar :: Com.IID (IToolbar Automation.Interface)
iidIToolbar = Com.mkIID "{0002085C-0001-0000-C000-000000000046}"
setHeight1 :: Prelude.Int -> Automation.IDispatch a -> Prelude.IO ()
setHeight1 rHS =
  Automation.propertySet "Height" [Automation.inInt rHS]
setLeft1 :: Prelude.Int -> Automation.IDispatch a -> Prelude.IO ()
setLeft1 rHS = Automation.propertySet "Left" [Automation.inInt rHS]
getPosition :: Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getPosition =
  Automation.propertyGet "Position" [] Automation.outInt
setPosition0 :: Prelude.Int -> Automation.IDispatch a -> Prelude.IO ()
setPosition0 rHS =
  Automation.propertySet "Position" [Automation.inInt rHS]
getProtection :: (Automation.Variant a0) => IToolbar a -> Prelude.IO (a0)
getProtection =
  Automation.propertyGet "Protection" [] Automation.outVariant
setProtection :: (Automation.Variant a0) => a0 -> IToolbar a -> Prelude.IO ()
setProtection rHS =
  Automation.propertySet "Protection" [Automation.inVariant rHS]
reset :: Automation.IDispatch a -> Prelude.IO ()
reset = Automation.method0 "Reset" []
getToolbarButtons :: IToolbar a -> Prelude.IO (IToolbarButtons Automation.Interface)
getToolbarButtons =
  Automation.propertyGet "ToolbarButtons" [] Automation.outIDispatch
setTop1 :: Prelude.Int -> Automation.IDispatch a -> Prelude.IO ()
setTop1 rHS = Automation.propertySet "Top" [Automation.inInt rHS]
setWidth1 :: Prelude.Int -> Automation.IDispatch a -> Prelude.IO ()
setWidth1 rHS =
  Automation.propertySet "Width" [Automation.inInt rHS]
-- --------------------------------------------------
-- 
-- interface IToolbars
-- 
-- --------------------------------------------------
data Toolbars a = Toolbars
                   
type IToolbars a = Automation.IDispatch (Toolbars a)
iidIToolbars :: Com.IID (IToolbars Automation.Interface)
iidIToolbars = Com.mkIID "{0002085D-0001-0000-C000-000000000046}"
add5 :: Prelude.Int -> IToolbars a -> Prelude.IO (IToolbar Automation.Interface)
add5 name =
  Automation.function1 "Add" [Automation.inInt name] Automation.outIDispatch
getDefault10 :: Prelude.Int -> IToolbars a -> Prelude.IO (IToolbar Automation.Interface)
getDefault10 index =
  Automation.propertyGet "_Default" [Automation.inInt index] Automation.outIDispatch
getItem9 :: Prelude.Int -> IToolbars a -> Prelude.IO (IToolbar Automation.Interface)
getItem9 index =
  Automation.propertyGet "Item" [Automation.inInt index] Automation.outIDispatch
-- --------------------------------------------------
-- 
-- interface IToolbarButton
-- 
-- --------------------------------------------------
data ToolbarButton a = ToolbarButton
                        
type IToolbarButton a = Automation.IDispatch (ToolbarButton a)
iidIToolbarButton :: Com.IID (IToolbarButton Automation.Interface)
iidIToolbarButton =
  Com.mkIID "{0002085E-0001-0000-C000-000000000046}"
getBuiltInFace :: IToolbarButton a -> Prelude.IO (Prelude.Int)
getBuiltInFace =
  Automation.propertyGet "BuiltInFace" [] Automation.outInt
setBuiltInFace :: Prelude.Int -> IToolbarButton a -> Prelude.IO ()
setBuiltInFace rHS =
  Automation.propertySet "BuiltInFace" [Automation.inInt rHS]
copy3 :: IToolbar a0 -> Prelude.Int -> IToolbarButton a -> Prelude.IO ()
copy3 toolbar before =
  Automation.method0 "Copy" [Automation.inIDispatch toolbar, Automation.inInt before]
copyFace :: IToolbarButton a -> Prelude.IO ()
copyFace = Automation.method0 "CopyFace" []
edit :: IToolbarButton a -> Prelude.IO ()
edit = Automation.method0 "Edit" []
getEnabled :: Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getEnabled = Automation.propertyGet "Enabled" [] Automation.outInt
setEnabled :: Prelude.Int -> Automation.IDispatch a -> Prelude.IO ()
setEnabled rHS =
  Automation.propertySet "Enabled" [Automation.inInt rHS]
getHelpContextID :: Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getHelpContextID =
  Automation.propertyGet "HelpContextID" [] Automation.outInt
setHelpContextID :: Prelude.Int -> Automation.IDispatch a -> Prelude.IO ()
setHelpContextID rHS =
  Automation.propertySet "HelpContextID" [Automation.inInt rHS]
getHelpFile :: Automation.IDispatch a -> Prelude.IO (Prelude.String)
getHelpFile =
  Automation.propertyGet "HelpFile" [] Automation.outString
setHelpFile :: Prelude.String -> Automation.IDispatch a -> Prelude.IO ()
setHelpFile rHS =
  Automation.propertySet "HelpFile" [Automation.inString rHS]
getId :: IToolbarButton a -> Prelude.IO (Prelude.Int)
getId = Automation.propertyGet "Id" [] Automation.outInt
getIsGap :: IToolbarButton a -> Prelude.IO (Prelude.Int)
getIsGap = Automation.propertyGet "IsGap" [] Automation.outInt
move2 :: IToolbar a0 -> Prelude.Int -> IToolbarButton a -> Prelude.IO ()
move2 toolbar before =
  Automation.method0 "Move" [Automation.inIDispatch toolbar, Automation.inInt before]
getOnAction :: Automation.IDispatch a -> Prelude.IO (Prelude.String)
getOnAction =
  Automation.propertyGet "OnAction" [] Automation.outString
setOnAction :: Prelude.String -> Automation.IDispatch a -> Prelude.IO ()
setOnAction rHS =
  Automation.propertySet "OnAction" [Automation.inString rHS]
pasteFace :: IToolbarButton a -> Prelude.IO ()
pasteFace = Automation.method0 "PasteFace" []
getPushed :: IToolbarButton a -> Prelude.IO (Prelude.Int)
getPushed = Automation.propertyGet "Pushed" [] Automation.outInt
setPushed :: Prelude.Int -> IToolbarButton a -> Prelude.IO ()
setPushed rHS =
  Automation.propertySet "Pushed" [Automation.inInt rHS]
getStatusBar0 :: Automation.IDispatch a -> Prelude.IO (Prelude.String)
getStatusBar0 =
  Automation.propertyGet "StatusBar" [] Automation.outString
setStatusBar0 :: Prelude.String -> Automation.IDispatch a -> Prelude.IO ()
setStatusBar0 rHS =
  Automation.propertySet "StatusBar" [Automation.inString rHS]
-- --------------------------------------------------
-- 
-- interface IToolbarButtons
-- 
-- --------------------------------------------------
data ToolbarButtons a = ToolbarButtons
                         
type IToolbarButtons a = Automation.IDispatch (ToolbarButtons a)
iidIToolbarButtons :: Com.IID (IToolbarButtons Automation.Interface)
iidIToolbarButtons =
  Com.mkIID "{0002085F-0001-0000-C000-000000000046}"
add6 :: Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> IToolbarButtons a -> Prelude.IO (IToolbarButton Automation.Interface)
add6 button before onAction pushed enabled statusBar helpFile helpContextID =
  Automation.function1 "Add" [Automation.inInt button, Automation.inInt before, Automation.inInt onAction, Automation.inInt pushed, Automation.inInt enabled, Automation.inInt statusBar, Automation.inInt helpFile, Automation.inInt helpContextID] Automation.outIDispatch
getItem10 :: Prelude.Int -> IToolbarButtons a -> Prelude.IO (IToolbarButton Automation.Interface)
getItem10 index =
  Automation.propertyGet "Item" [Automation.inInt index] Automation.outIDispatch
getDefault11 :: Prelude.Int -> IToolbarButtons a -> Prelude.IO (IToolbarButton Automation.Interface)
getDefault11 index =
  Automation.propertyGet "_Default" [Automation.inInt index] Automation.outIDispatch
-- --------------------------------------------------
-- 
-- interface IAreas
-- 
-- --------------------------------------------------
data Areas a = Areas
                
type IAreas a = Automation.IDispatch (Areas a)
iidIAreas :: Com.IID (IAreas Automation.Interface)
iidIAreas = Com.mkIID "{00020860-0001-0000-C000-000000000046}"
getItem11 :: Prelude.Int -> IAreas a -> Prelude.IO (IRange Automation.Interface)
getItem11 index =
  Automation.propertyGet "Item" [Automation.inInt index] Automation.outIDispatch
getDefault12 :: Prelude.Int -> IAreas a -> Prelude.IO (IRange Automation.Interface)
getDefault12 index =
  Automation.propertyGet "_Default" [Automation.inInt index] Automation.outIDispatch
-- --------------------------------------------------
-- 
-- interface IWorkbookEvents
-- 
-- --------------------------------------------------
data WorkbookEvents a = WorkbookEvents
                         
type IWorkbookEvents a = Automation.IDispatch (WorkbookEvents a)
iidIWorkbookEvents :: Com.IID (IWorkbookEvents Automation.Interface)
iidIWorkbookEvents =
  Com.mkIID "{00024412-0001-0000-C000-000000000046}"
open0 :: Automation.IDispatch a -> Prelude.IO ()
open0 = Automation.method0 "Open" []
beforeClose :: Prelude.Int -> IWorkbookEvents a -> Prelude.IO ()
beforeClose cancel =
  Automation.method0 "BeforeClose" [Automation.inInt cancel]
beforeSave :: Prelude.Int -> Prelude.Int -> IWorkbookEvents a -> Prelude.IO ()
beforeSave saveAsUI cancel =
  Automation.method0 "BeforeSave" [Automation.inInt saveAsUI, Automation.inInt cancel]
beforePrint :: Prelude.Int -> IWorkbookEvents a -> Prelude.IO ()
beforePrint cancel =
  Automation.method0 "BeforePrint" [Automation.inInt cancel]
newSheet :: Automation.IDispatch a0 -> IWorkbookEvents a -> Prelude.IO ()
newSheet sh =
  Automation.method0 "NewSheet" [Automation.inIDispatch sh]
addinInstall :: IWorkbookEvents a -> Prelude.IO ()
addinInstall = Automation.method0 "AddinInstall" []
addinUninstall :: IWorkbookEvents a -> Prelude.IO ()
addinUninstall = Automation.method0 "AddinUninstall" []
windowResize0 :: VBIDE.IWindow a0 -> IWorkbookEvents a -> Prelude.IO ()
windowResize0 wn =
  Automation.method0 "WindowResize" [Automation.inIDispatch wn]
windowActivate0 :: VBIDE.IWindow a0 -> IWorkbookEvents a -> Prelude.IO ()
windowActivate0 wn =
  Automation.method0 "WindowActivate" [Automation.inIDispatch wn]
windowDeactivate0 :: VBIDE.IWindow a0 -> IWorkbookEvents a -> Prelude.IO ()
windowDeactivate0 wn =
  Automation.method0 "WindowDeactivate" [Automation.inIDispatch wn]
-- --------------------------------------------------
-- 
-- interface Workbook
-- 
-- --------------------------------------------------
data Workbook a = Workbook
                   
type IWorkbook a = Automation.IDispatch (Workbook a)
iidIWorkbook :: Com.IID (IWorkbook Automation.Interface)
iidIWorkbook = Com.mkIID "{000208DA-0000-0000-C000-000000000046}"
getAcceptLabelsInFormulas :: IWorkbook a -> Prelude.IO (Prelude.Int)
getAcceptLabelsInFormulas =
  Automation.propertyGetID 0x5a1 [] Automation.outInt
setAcceptLabelsInFormulas :: Prelude.Int -> IWorkbook a -> Prelude.IO ()
setAcceptLabelsInFormulas rHS =
  Automation.propertySetID 0x5a1 [Automation.inInt rHS]
getAuthor0 :: Prelude.Int -> IWorkbook a -> Prelude.IO (Prelude.String)
getAuthor0 lcid =
  Automation.propertyGetID 0x23e [Automation.inInt lcid] Automation.outString
setAuthor :: Prelude.Int -> Prelude.String -> IWorkbook a -> Prelude.IO ()
setAuthor lcid rHS =
  Automation.propertySetID 0x23e [Automation.inInt lcid, Automation.inString rHS]
getAutoUpdateFrequency :: IWorkbook a -> Prelude.IO (Prelude.Int)
getAutoUpdateFrequency =
  Automation.propertyGetID 0x5a2 [] Automation.outInt
setAutoUpdateFrequency :: Prelude.Int -> IWorkbook a -> Prelude.IO ()
setAutoUpdateFrequency rHS =
  Automation.propertySetID 0x5a2 [Automation.inInt rHS]
getAutoUpdateSaveChanges :: IWorkbook a -> Prelude.IO (Prelude.Int)
getAutoUpdateSaveChanges =
  Automation.propertyGetID 0x5a3 [] Automation.outInt
setAutoUpdateSaveChanges :: Prelude.Int -> IWorkbook a -> Prelude.IO ()
setAutoUpdateSaveChanges rHS =
  Automation.propertySetID 0x5a3 [Automation.inInt rHS]
getChangeHistoryDuration :: IWorkbook a -> Prelude.IO (Prelude.Int)
getChangeHistoryDuration =
  Automation.propertyGetID 0x5a4 [] Automation.outInt
setChangeHistoryDuration :: Prelude.Int -> IWorkbook a -> Prelude.IO ()
setChangeHistoryDuration rHS =
  Automation.propertySetID 0x5a4 [Automation.inInt rHS]
getBuiltinDocumentProperties :: IWorkbook a -> Prelude.IO (Automation.IDispatch Automation.Interface)
getBuiltinDocumentProperties =
  Automation.propertyGetID 0x498 [] Automation.outIDispatch
changeFileAccess :: (Automation.Variant a0) => a0 -> Prelude.Int -> Prelude.Int -> Prelude.Int -> IWorkbook a -> Prelude.IO ()
changeFileAccess mode writePassword notify lcid =
  Automation.methodID0 0x3dd [Automation.inVariant mode, Automation.inInt writePassword, Automation.inInt notify, Automation.inInt lcid]
changeLink :: (Automation.Variant a0) => Prelude.String -> Prelude.String -> a0 -> Prelude.Int -> IWorkbook a -> Prelude.IO ()
changeLink name newName type0 lcid =
  Automation.methodID0 0x322 [Automation.inString name, Automation.inString newName, Automation.inVariant type0, Automation.inInt lcid]
close0 :: Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Automation.IDispatch a -> Prelude.IO ()
close0 saveChanges filename routeWorkbook lcid =
  Automation.methodID0 0x115 [Automation.inInt saveChanges, Automation.inInt filename, Automation.inInt routeWorkbook, Automation.inInt lcid]
getColors :: Prelude.Int -> Prelude.Int -> IWorkbook a -> Prelude.IO (Prelude.Int)
getColors index lcid =
  Automation.propertyGetID 0x11e [Automation.inInt index, Automation.inInt lcid] Automation.outInt
setColors :: Prelude.Int -> Prelude.Int -> Prelude.Int -> IWorkbook a -> Prelude.IO ()
setColors index lcid rHS =
  Automation.propertySetID 0x11e [Automation.inInt index, Automation.inInt lcid, Automation.inInt rHS]
getComments1 :: Prelude.Int -> IWorkbook a -> Prelude.IO (Prelude.String)
getComments1 lcid =
  Automation.propertyGetID 0x23f [Automation.inInt lcid] Automation.outString
setComments :: Prelude.Int -> Prelude.String -> IWorkbook a -> Prelude.IO ()
setComments lcid rHS =
  Automation.propertySetID 0x23f [Automation.inInt lcid, Automation.inString rHS]
getConflictResolution :: IWorkbook a -> Prelude.IO (Prelude.Int)
getConflictResolution =
  Automation.propertyGetID 0x497 [] Automation.outInt
setConflictResolution :: Prelude.Int -> IWorkbook a -> Prelude.IO ()
setConflictResolution rHS =
  Automation.propertySetID 0x497 [Automation.inInt rHS]
getContainer :: IWorkbook a -> Prelude.IO (Automation.IDispatch Automation.Interface)
getContainer =
  Automation.propertyGetID 0x4a6 [] Automation.outIDispatch
getCreateBackup :: Prelude.Int -> IWorkbook a -> Prelude.IO (Prelude.Int)
getCreateBackup lcid =
  Automation.propertyGetID 0x11f [Automation.inInt lcid] Automation.outInt
getCustomDocumentProperties :: IWorkbook a -> Prelude.IO (Automation.IDispatch Automation.Interface)
getCustomDocumentProperties =
  Automation.propertyGetID 0x499 [] Automation.outIDispatch
getDate1904 :: Prelude.Int -> IWorkbook a -> Prelude.IO (Prelude.Int)
getDate1904 lcid =
  Automation.propertyGetID 0x193 [Automation.inInt lcid] Automation.outInt
setDate1904 :: Prelude.Int -> Prelude.Int -> IWorkbook a -> Prelude.IO ()
setDate1904 lcid rHS =
  Automation.propertySetID 0x193 [Automation.inInt lcid, Automation.inInt rHS]
deleteNumberFormat :: Prelude.String -> Prelude.Int -> IWorkbook a -> Prelude.IO ()
deleteNumberFormat numberFormat lcid =
  Automation.methodID0 0x18d [Automation.inString numberFormat, Automation.inInt lcid]
getDisplayDrawingObjects :: (Automation.Variant a0) => Prelude.Int -> IWorkbook a -> Prelude.IO (a0)
getDisplayDrawingObjects lcid =
  Automation.propertyGetID 0x194 [Automation.inInt lcid] Automation.outVariant
setDisplayDrawingObjects :: (Automation.Variant a0) => Prelude.Int -> a0 -> IWorkbook a -> Prelude.IO ()
setDisplayDrawingObjects lcid rHS =
  Automation.propertySetID 0x194 [Automation.inInt lcid, Automation.inVariant rHS]
exclusiveAccess :: Prelude.Int -> IWorkbook a -> Prelude.IO (Prelude.Int)
exclusiveAccess lcid =
  Automation.functionID1 0x490 [Automation.inInt lcid] Automation.outInt
getFileFormat :: (Automation.Variant a0) => Prelude.Int -> IWorkbook a -> Prelude.IO (a0)
getFileFormat lcid =
  Automation.propertyGetID 0x120 [Automation.inInt lcid] Automation.outVariant
forwardMailer :: Prelude.Int -> IWorkbook a -> Prelude.IO ()
forwardMailer lcid =
  Automation.methodID0 0x3cd [Automation.inInt lcid]
getFullName0 :: Prelude.Int -> IWorkbook a -> Prelude.IO (Prelude.String)
getFullName0 lcid =
  Automation.propertyGetID 0x121 [Automation.inInt lcid] Automation.outString
getHasMailer :: Prelude.Int -> IWorkbook a -> Prelude.IO (Prelude.Int)
getHasMailer lcid =
  Automation.propertyGetID 0x3d0 [Automation.inInt lcid] Automation.outInt
setHasMailer :: Prelude.Int -> Prelude.Int -> IWorkbook a -> Prelude.IO ()
setHasMailer lcid rHS =
  Automation.propertySetID 0x3d0 [Automation.inInt lcid, Automation.inInt rHS]
getHasPassword :: Prelude.Int -> IWorkbook a -> Prelude.IO (Prelude.Int)
getHasPassword lcid =
  Automation.propertyGetID 0x122 [Automation.inInt lcid] Automation.outInt
getHasRoutingSlip :: Prelude.Int -> IWorkbook a -> Prelude.IO (Prelude.Int)
getHasRoutingSlip lcid =
  Automation.propertyGetID 0x3b6 [Automation.inInt lcid] Automation.outInt
setHasRoutingSlip :: Prelude.Int -> Prelude.Int -> IWorkbook a -> Prelude.IO ()
setHasRoutingSlip lcid rHS =
  Automation.propertySetID 0x3b6 [Automation.inInt lcid, Automation.inInt rHS]
getIsAddin :: IWorkbook a -> Prelude.IO (Prelude.Int)
getIsAddin = Automation.propertyGetID 0x5a5 [] Automation.outInt
setIsAddin :: Prelude.Int -> IWorkbook a -> Prelude.IO ()
setIsAddin rHS =
  Automation.propertySetID 0x5a5 [Automation.inInt rHS]
getKeywords0 :: Prelude.Int -> IWorkbook a -> Prelude.IO (Prelude.String)
getKeywords0 lcid =
  Automation.propertyGetID 0x241 [Automation.inInt lcid] Automation.outString
setKeywords :: Prelude.Int -> Prelude.String -> IWorkbook a -> Prelude.IO ()
setKeywords lcid rHS =
  Automation.propertySetID 0x241 [Automation.inInt lcid, Automation.inString rHS]
linkInfo :: (Automation.Variant a0) => Prelude.String -> a0 -> Prelude.Int -> Prelude.Int -> Prelude.Int -> IWorkbook a -> Prelude.IO (Prelude.Int)
linkInfo name linkInfo type0 editionRef lcid =
  Automation.functionID1 0x327 [Automation.inString name, Automation.inVariant linkInfo, Automation.inInt type0, Automation.inInt editionRef, Automation.inInt lcid] Automation.outInt
linkSources :: Prelude.Int -> Prelude.Int -> IWorkbook a -> Prelude.IO (Prelude.Int)
linkSources type0 lcid =
  Automation.functionID1 0x328 [Automation.inInt type0, Automation.inInt lcid] Automation.outInt
getMailer :: IWorkbook a -> Prelude.IO (IMailer Automation.Interface)
getMailer =
  Automation.propertyGetID 0x3d3 [] Automation.outIDispatch
mergeWorkbook :: Prelude.Int -> IWorkbook a -> Prelude.IO ()
mergeWorkbook filename =
  Automation.methodID0 0x5a6 [Automation.inInt filename]
getModules1 :: IWorkbook a -> Prelude.IO (ISheets Automation.Interface)
getModules1 =
  Automation.propertyGetID 0x246 [] Automation.outIDispatch
getMultiUserEditing :: Prelude.Int -> IWorkbook a -> Prelude.IO (Prelude.Int)
getMultiUserEditing lcid =
  Automation.propertyGetID 0x491 [Automation.inInt lcid] Automation.outInt
newWindow0 :: Prelude.Int -> IWorkbook a -> Prelude.IO (VBIDE.IWindow Automation.Interface)
newWindow0 lcid =
  Automation.functionID1 0x118 [Automation.inInt lcid] Automation.outIDispatch
getOnSave :: Prelude.Int -> IWorkbook a -> Prelude.IO (Prelude.String)
getOnSave lcid =
  Automation.propertyGetID 0x49a [Automation.inInt lcid] Automation.outString
setOnSave :: Prelude.Int -> Prelude.String -> IWorkbook a -> Prelude.IO ()
setOnSave lcid rHS =
  Automation.propertySetID 0x49a [Automation.inInt lcid, Automation.inString rHS]
openLinks :: Prelude.String -> Prelude.Int -> Prelude.Int -> Prelude.Int -> IWorkbook a -> Prelude.IO ()
openLinks name readOnly type0 lcid =
  Automation.methodID0 0x323 [Automation.inString name, Automation.inInt readOnly, Automation.inInt type0, Automation.inInt lcid]
getPersonalViewListSettings :: IWorkbook a -> Prelude.IO (Prelude.Int)
getPersonalViewListSettings =
  Automation.propertyGetID 0x5a7 [] Automation.outInt
setPersonalViewListSettings :: Prelude.Int -> IWorkbook a -> Prelude.IO ()
setPersonalViewListSettings rHS =
  Automation.propertySetID 0x5a7 [Automation.inInt rHS]
getPersonalViewPrintSettings :: IWorkbook a -> Prelude.IO (Prelude.Int)
getPersonalViewPrintSettings =
  Automation.propertyGetID 0x5a8 [] Automation.outInt
setPersonalViewPrintSettings :: Prelude.Int -> IWorkbook a -> Prelude.IO ()
setPersonalViewPrintSettings rHS =
  Automation.propertySetID 0x5a8 [Automation.inInt rHS]
pivotCaches :: IWorkbook a -> Prelude.IO (IPivotCaches Automation.Interface)
pivotCaches =
  Automation.functionID1 0x5a9 [] Automation.outIDispatch
post :: Prelude.Int -> Prelude.Int -> IWorkbook a -> Prelude.IO ()
post destName lcid =
  Automation.methodID0 0x48e [Automation.inInt destName, Automation.inInt lcid]
getPrecisionAsDisplayed :: Prelude.Int -> IWorkbook a -> Prelude.IO (Prelude.Int)
getPrecisionAsDisplayed lcid =
  Automation.propertyGetID 0x195 [Automation.inInt lcid] Automation.outInt
setPrecisionAsDisplayed :: Prelude.Int -> Prelude.Int -> IWorkbook a -> Prelude.IO ()
setPrecisionAsDisplayed lcid rHS =
  Automation.propertySetID 0x195 [Automation.inInt lcid, Automation.inInt rHS]
protect1 :: Prelude.Int -> Prelude.Int -> Prelude.Int -> Automation.IDispatch a -> Prelude.IO ()
protect1 password structure windows =
  Automation.methodID0 0x11a [Automation.inInt password, Automation.inInt structure, Automation.inInt windows]
protectSharing :: Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> IWorkbook a -> Prelude.IO ()
protectSharing filename password writeResPassword readOnlyRecommended createBackup sharingPassword =
  Automation.methodID0 0x5aa [Automation.inInt filename, Automation.inInt password, Automation.inInt writeResPassword, Automation.inInt readOnlyRecommended, Automation.inInt createBackup, Automation.inInt sharingPassword]
getProtectStructure :: IWorkbook a -> Prelude.IO (Prelude.Int)
getProtectStructure =
  Automation.propertyGetID 0x24c [] Automation.outInt
getProtectWindows :: IWorkbook a -> Prelude.IO (Prelude.Int)
getProtectWindows =
  Automation.propertyGetID 0x127 [] Automation.outInt
getReadOnly :: Prelude.Int -> IWorkbook a -> Prelude.IO (Prelude.Int)
getReadOnly lcid =
  Automation.propertyGetID 0x128 [Automation.inInt lcid] Automation.outInt
getReadOnlyRecommended :: Prelude.Int -> IWorkbook a -> Prelude.IO (Prelude.Int)
getReadOnlyRecommended lcid =
  Automation.propertyGetID 0x129 [Automation.inInt lcid] Automation.outInt
refreshAll :: IWorkbook a -> Prelude.IO ()
refreshAll = Automation.methodID0 0x5ac []
reply :: Prelude.Int -> IWorkbook a -> Prelude.IO ()
reply lcid = Automation.methodID0 0x3d1 [Automation.inInt lcid]
replyAll :: Prelude.Int -> IWorkbook a -> Prelude.IO ()
replyAll lcid = Automation.methodID0 0x3d2 [Automation.inInt lcid]
removeUser :: Prelude.Int -> IWorkbook a -> Prelude.IO ()
removeUser index =
  Automation.methodID0 0x5ad [Automation.inInt index]
getRevisionNumber :: Prelude.Int -> IWorkbook a -> Prelude.IO (Prelude.Int)
getRevisionNumber lcid =
  Automation.propertyGetID 0x494 [Automation.inInt lcid] Automation.outInt
route :: Prelude.Int -> IWorkbook a -> Prelude.IO ()
route lcid = Automation.methodID0 0x3b2 [Automation.inInt lcid]
getRouted :: Prelude.Int -> IWorkbook a -> Prelude.IO (Prelude.Int)
getRouted lcid =
  Automation.propertyGetID 0x3b7 [Automation.inInt lcid] Automation.outInt
getRoutingSlip :: IWorkbook a -> Prelude.IO (IRoutingSlip Automation.Interface)
getRoutingSlip =
  Automation.propertyGetID 0x3b5 [] Automation.outIDispatch
runAutoMacros :: (Automation.Variant a0) => a0 -> Prelude.Int -> IWorkbook a -> Prelude.IO ()
runAutoMacros which lcid =
  Automation.methodID0 0x27a [Automation.inVariant which, Automation.inInt lcid]
save0 :: Prelude.Int -> Automation.IDispatch a -> Prelude.IO ()
save0 lcid = Automation.methodID0 0x11b [Automation.inInt lcid]
saveAs1 :: (Automation.Variant a0) => Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> a0 -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> IWorkbook a -> Prelude.IO ()
saveAs1 filename fileFormat password writeResPassword readOnlyRecommended createBackup accessMode conflictResolution addToMru textCodepage textVisualLayout lcid =
  Automation.methodID0 0x11c [Automation.inInt filename, Automation.inInt fileFormat, Automation.inInt password, Automation.inInt writeResPassword, Automation.inInt readOnlyRecommended, Automation.inInt createBackup, Automation.inVariant accessMode, Automation.inInt conflictResolution, Automation.inInt addToMru, Automation.inInt textCodepage, Automation.inInt textVisualLayout, Automation.inInt lcid]
saveCopyAs :: Prelude.Int -> Prelude.Int -> IWorkbook a -> Prelude.IO ()
saveCopyAs filename lcid =
  Automation.methodID0 0xaf [Automation.inInt filename, Automation.inInt lcid]
getSaved :: Prelude.Int -> IWorkbook a -> Prelude.IO (Prelude.Int)
getSaved lcid =
  Automation.propertyGetID 0x12a [Automation.inInt lcid] Automation.outInt
setSaved :: Prelude.Int -> Prelude.Int -> IWorkbook a -> Prelude.IO ()
setSaved lcid rHS =
  Automation.propertySetID 0x12a [Automation.inInt lcid, Automation.inInt rHS]
getSaveLinkValues :: Prelude.Int -> IWorkbook a -> Prelude.IO (Prelude.Int)
getSaveLinkValues lcid =
  Automation.propertyGetID 0x196 [Automation.inInt lcid] Automation.outInt
setSaveLinkValues :: Prelude.Int -> Prelude.Int -> IWorkbook a -> Prelude.IO ()
setSaveLinkValues lcid rHS =
  Automation.propertySetID 0x196 [Automation.inInt lcid, Automation.inInt rHS]
sendMail :: Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> IWorkbook a -> Prelude.IO ()
sendMail recipients subject returnReceipt lcid =
  Automation.methodID0 0x3b3 [Automation.inInt recipients, Automation.inInt subject, Automation.inInt returnReceipt, Automation.inInt lcid]
sendMailer :: (Automation.Variant a0) => Prelude.Int -> a0 -> Prelude.Int -> IWorkbook a -> Prelude.IO ()
sendMailer fileFormat priority lcid =
  Automation.methodID0 0x3d4 [Automation.inInt fileFormat, Automation.inVariant priority, Automation.inInt lcid]
setLinkOnData :: Prelude.String -> Prelude.Int -> Prelude.Int -> IWorkbook a -> Prelude.IO ()
setLinkOnData name procedure lcid =
  Automation.methodID0 0x329 [Automation.inString name, Automation.inInt procedure, Automation.inInt lcid]
getShowConflictHistory :: Prelude.Int -> IWorkbook a -> Prelude.IO (Prelude.Int)
getShowConflictHistory lcid =
  Automation.propertyGetID 0x493 [Automation.inInt lcid] Automation.outInt
setShowConflictHistory :: Prelude.Int -> Prelude.Int -> IWorkbook a -> Prelude.IO ()
setShowConflictHistory lcid rHS =
  Automation.propertySetID 0x493 [Automation.inInt lcid, Automation.inInt rHS]
getStyles :: IWorkbook a -> Prelude.IO (IStyles Automation.Interface)
getStyles =
  Automation.propertyGetID 0x1ed [] Automation.outIDispatch
getSubject0 :: Prelude.Int -> IWorkbook a -> Prelude.IO (Prelude.String)
getSubject0 lcid =
  Automation.propertyGetID 0x3b9 [Automation.inInt lcid] Automation.outString
setSubject :: Prelude.Int -> Prelude.String -> IWorkbook a -> Prelude.IO ()
setSubject lcid rHS =
  Automation.propertySetID 0x3b9 [Automation.inInt lcid, Automation.inString rHS]
getTitle0 :: Prelude.Int -> IWorkbook a -> Prelude.IO (Prelude.String)
getTitle0 lcid =
  Automation.propertyGetID 0xc7 [Automation.inInt lcid] Automation.outString
setTitle :: Prelude.Int -> Prelude.String -> IWorkbook a -> Prelude.IO ()
setTitle lcid rHS =
  Automation.propertySetID 0xc7 [Automation.inInt lcid, Automation.inString rHS]
unprotectSharing :: Prelude.Int -> IWorkbook a -> Prelude.IO ()
unprotectSharing sharingPassword =
  Automation.methodID0 0x5af [Automation.inInt sharingPassword]
updateFromFile :: Prelude.Int -> IWorkbook a -> Prelude.IO ()
updateFromFile lcid =
  Automation.methodID0 0x3e3 [Automation.inInt lcid]
updateLink :: Prelude.Int -> Prelude.Int -> Prelude.Int -> IWorkbook a -> Prelude.IO ()
updateLink name type0 lcid =
  Automation.methodID0 0x324 [Automation.inInt name, Automation.inInt type0, Automation.inInt lcid]
getUpdateRemoteReferences :: Prelude.Int -> IWorkbook a -> Prelude.IO (Prelude.Int)
getUpdateRemoteReferences lcid =
  Automation.propertyGetID 0x19b [Automation.inInt lcid] Automation.outInt
setUpdateRemoteReferences :: Prelude.Int -> Prelude.Int -> IWorkbook a -> Prelude.IO ()
setUpdateRemoteReferences lcid rHS =
  Automation.propertySetID 0x19b [Automation.inInt lcid, Automation.inInt rHS]
getUserStatus :: Prelude.Int -> IWorkbook a -> Prelude.IO (Prelude.Int)
getUserStatus lcid =
  Automation.propertyGetID 0x495 [Automation.inInt lcid] Automation.outInt
getCustomViews :: IWorkbook a -> Prelude.IO (ICustomViews Automation.Interface)
getCustomViews =
  Automation.propertyGetID 0x5b0 [] Automation.outIDispatch
getWriteReserved :: Prelude.Int -> IWorkbook a -> Prelude.IO (Prelude.Int)
getWriteReserved lcid =
  Automation.propertyGetID 0x12b [Automation.inInt lcid] Automation.outInt
getWriteReservedBy :: Prelude.Int -> IWorkbook a -> Prelude.IO (Prelude.String)
getWriteReservedBy lcid =
  Automation.propertyGetID 0x12c [Automation.inInt lcid] Automation.outString
getTemplateRemoveExtData :: IWorkbook a -> Prelude.IO (Prelude.Int)
getTemplateRemoveExtData =
  Automation.propertyGetID 0x5b1 [] Automation.outInt
setTemplateRemoveExtData :: Prelude.Int -> IWorkbook a -> Prelude.IO ()
setTemplateRemoveExtData rHS =
  Automation.propertySetID 0x5b1 [Automation.inInt rHS]
highlightChangesOptions :: Prelude.Int -> Prelude.Int -> Prelude.Int -> IWorkbook a -> Prelude.IO ()
highlightChangesOptions when who where0 =
  Automation.methodID0 0x5b2 [Automation.inInt when, Automation.inInt who, Automation.inInt where0]
getHighlightChangesOnScreen :: IWorkbook a -> Prelude.IO (Prelude.Int)
getHighlightChangesOnScreen =
  Automation.propertyGetID 0x5b5 [] Automation.outInt
setHighlightChangesOnScreen :: Prelude.Int -> IWorkbook a -> Prelude.IO ()
setHighlightChangesOnScreen rHS =
  Automation.propertySetID 0x5b5 [Automation.inInt rHS]
getKeepChangeHistory :: IWorkbook a -> Prelude.IO (Prelude.Int)
getKeepChangeHistory =
  Automation.propertyGetID 0x5b6 [] Automation.outInt
setKeepChangeHistory :: Prelude.Int -> IWorkbook a -> Prelude.IO ()
setKeepChangeHistory rHS =
  Automation.propertySetID 0x5b6 [Automation.inInt rHS]
getListChangesOnNewSheet :: IWorkbook a -> Prelude.IO (Prelude.Int)
getListChangesOnNewSheet =
  Automation.propertyGetID 0x5b7 [] Automation.outInt
setListChangesOnNewSheet :: Prelude.Int -> IWorkbook a -> Prelude.IO ()
setListChangesOnNewSheet rHS =
  Automation.propertySetID 0x5b7 [Automation.inInt rHS]
purgeChangeHistoryNow :: Prelude.Int -> Prelude.Int -> IWorkbook a -> Prelude.IO ()
purgeChangeHistoryNow days sharingPassword =
  Automation.methodID0 0x5b8 [Automation.inInt days, Automation.inInt sharingPassword]
acceptAllChanges :: Prelude.Int -> Prelude.Int -> Prelude.Int -> IWorkbook a -> Prelude.IO ()
acceptAllChanges when who where0 =
  Automation.methodID0 0x5ba [Automation.inInt when, Automation.inInt who, Automation.inInt where0]
rejectAllChanges :: Prelude.Int -> Prelude.Int -> Prelude.Int -> IWorkbook a -> Prelude.IO ()
rejectAllChanges when who where0 =
  Automation.methodID0 0x5bb [Automation.inInt when, Automation.inInt who, Automation.inInt where0]
pivotTableWizard0 :: Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Automation.IDispatch a -> Prelude.IO ()
pivotTableWizard0 sourceType sourceData tableDestination tableName rowGrand columnGrand saveData hasAutoFormat autoPage reserved backgroundQuery optimizeCache pageFieldOrder pageFieldWrapCount readData connection lcid =
  Automation.methodID0 0x2ac [Automation.inInt sourceType, Automation.inInt sourceData, Automation.inInt tableDestination, Automation.inInt tableName, Automation.inInt rowGrand, Automation.inInt columnGrand, Automation.inInt saveData, Automation.inInt hasAutoFormat, Automation.inInt autoPage, Automation.inInt reserved, Automation.inInt backgroundQuery, Automation.inInt optimizeCache, Automation.inInt pageFieldOrder, Automation.inInt pageFieldWrapCount, Automation.inInt readData, Automation.inInt connection, Automation.inInt lcid]
resetColors :: IWorkbook a -> Prelude.IO ()
resetColors = Automation.methodID0 0x5bc []
getVBProject :: IWorkbook a -> Prelude.IO (VBIDE.IVBProject Automation.Interface)
getVBProject =
  Automation.propertyGetID 0x5bd [] Automation.outIDispatch
followHyperlink :: Prelude.String -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> IWorkbook a -> Prelude.IO ()
followHyperlink address subAddress newWindow addHistory extraInfo method headerInfo =
  Automation.methodID0 0x5be [Automation.inString address, Automation.inInt subAddress, Automation.inInt newWindow, Automation.inInt addHistory, Automation.inInt extraInfo, Automation.inInt method, Automation.inInt headerInfo]
addToFavorites :: Automation.IDispatch a -> Prelude.IO ()
addToFavorites = Automation.methodID0 0x5c4 []
getIsInplace :: IWorkbook a -> Prelude.IO (Prelude.Int)
getIsInplace = Automation.propertyGetID 0x6f4 [] Automation.outInt
-- --------------------------------------------------
-- 
-- interface Workbooks
-- 
-- --------------------------------------------------
data Workbooks a = Workbooks
                    
type IWorkbooks a = Automation.IDispatch (Workbooks a)
iidIWorkbooks :: Com.IID (IWorkbooks Automation.Interface)
iidIWorkbooks = Com.mkIID "{000208DB-0000-0000-C000-000000000046}"
add7 :: Prelude.Int -> Prelude.Int -> IWorkbooks a -> Prelude.IO (IWorkbook Automation.Interface)
add7 template lcid =
  Automation.functionID1 0xb5 [Automation.inInt template, Automation.inInt lcid] Automation.outIDispatch
close1 :: Prelude.Int -> Automation.IDispatch a -> Prelude.IO ()
close1 lcid = Automation.methodID0 0x115 [Automation.inInt lcid]
getItem12 :: Prelude.Int -> IWorkbooks a -> Prelude.IO (IWorkbook Automation.Interface)
getItem12 index =
  Automation.propertyGetID 0xaa [Automation.inInt index] Automation.outIDispatch
open1 :: Prelude.String -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> IWorkbooks a -> Prelude.IO (IWorkbook Automation.Interface)
open1 filename updateLinks readOnly format password writeResPassword ignoreReadOnlyRecommended origin delimiter editable notify converter addToMru lcid =
  Automation.functionID1 0x2aa [Automation.inString filename, Automation.inInt updateLinks, Automation.inInt readOnly, Automation.inInt format, Automation.inInt password, Automation.inInt writeResPassword, Automation.inInt ignoreReadOnlyRecommended, Automation.inInt origin, Automation.inInt delimiter, Automation.inInt editable, Automation.inInt notify, Automation.inInt converter, Automation.inInt addToMru, Automation.inInt lcid] Automation.outIDispatch
openText :: (Automation.Variant a0) => Prelude.String -> Prelude.Int -> Prelude.Int -> Prelude.Int -> a0 -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> IWorkbooks a -> Prelude.IO ()
openText filename origin startRow dataType textQualifier consecutiveDelimiter tab semicolon comma space other otherChar fieldInfo textVisualLayout lcid =
  Automation.methodID0 0x2ab [Automation.inString filename, Automation.inInt origin, Automation.inInt startRow, Automation.inInt dataType, Automation.inVariant textQualifier, Automation.inInt consecutiveDelimiter, Automation.inInt tab, Automation.inInt semicolon, Automation.inInt comma, Automation.inInt space, Automation.inInt other, Automation.inInt otherChar, Automation.inInt fieldInfo, Automation.inInt textVisualLayout, Automation.inInt lcid]
getDefault13 :: Prelude.Int -> IWorkbooks a -> Prelude.IO (IWorkbook Automation.Interface)
getDefault13 index =
  Automation.propertyGetID 0o0 [Automation.inInt index] Automation.outIDispatch
-- --------------------------------------------------
-- 
-- interface IMenuBars
-- 
-- --------------------------------------------------
data MenuBars a = MenuBars
                   
type IMenuBars a = Automation.IDispatch (MenuBars a)
iidIMenuBars :: Com.IID (IMenuBars Automation.Interface)
iidIMenuBars = Com.mkIID "{00020863-0001-0000-C000-000000000046}"
add8 :: Prelude.Int -> IMenuBars a -> Prelude.IO (IMenuBar Automation.Interface)
add8 name =
  Automation.function1 "Add" [Automation.inInt name] Automation.outIDispatch
getDefault14 :: Prelude.Int -> IMenuBars a -> Prelude.IO (IMenuBar Automation.Interface)
getDefault14 index =
  Automation.propertyGet "_Default" [Automation.inInt index] Automation.outIDispatch
getItem13 :: Prelude.Int -> IMenuBars a -> Prelude.IO (IMenuBar Automation.Interface)
getItem13 index =
  Automation.propertyGet "Item" [Automation.inInt index] Automation.outIDispatch
-- --------------------------------------------------
-- 
-- interface IMenuBar
-- 
-- --------------------------------------------------
data MenuBar a = MenuBar
                  
type IMenuBar a = Automation.IDispatch (MenuBar a)
iidIMenuBar :: Com.IID (IMenuBar Automation.Interface)
iidIMenuBar = Com.mkIID "{00020864-0001-0000-C000-000000000046}"
getMenus :: IMenuBar a -> Prelude.IO (IMenus Automation.Interface)
getMenus =
  Automation.propertyGet "Menus" [] Automation.outIDispatch
-- --------------------------------------------------
-- 
-- interface IMenus
-- 
-- --------------------------------------------------
data Menus a = Menus
                
type IMenus a = Automation.IDispatch (Menus a)
iidIMenus :: Com.IID (IMenus Automation.Interface)
iidIMenus = Com.mkIID "{00020865-0001-0000-C000-000000000046}"
add9 :: Prelude.String -> Prelude.Int -> Prelude.Int -> IMenus a -> Prelude.IO (IMenu Automation.Interface)
add9 caption before restore =
  Automation.function1 "Add" [Automation.inString caption, Automation.inInt before, Automation.inInt restore] Automation.outIDispatch
getDefault15 :: Prelude.Int -> IMenus a -> Prelude.IO (IMenu Automation.Interface)
getDefault15 index =
  Automation.propertyGet "_Default" [Automation.inInt index] Automation.outIDispatch
getItem14 :: Prelude.Int -> IMenus a -> Prelude.IO (IMenu Automation.Interface)
getItem14 index =
  Automation.propertyGet "Item" [Automation.inInt index] Automation.outIDispatch
-- --------------------------------------------------
-- 
-- interface IMenu
-- 
-- --------------------------------------------------
data Menu a = Menu
               
type IMenu a = Automation.IDispatch (Menu a)
iidIMenu :: Com.IID (IMenu Automation.Interface)
iidIMenu = Com.mkIID "{00020866-0001-0000-C000-000000000046}"
getMenuItems :: IMenu a -> Prelude.IO (IMenuItems Automation.Interface)
getMenuItems =
  Automation.propertyGet "MenuItems" [] Automation.outIDispatch
-- --------------------------------------------------
-- 
-- interface IMenuItems
-- 
-- --------------------------------------------------
data MenuItems a = MenuItems
                    
type IMenuItems a = Automation.IDispatch (MenuItems a)
iidIMenuItems :: Com.IID (IMenuItems Automation.Interface)
iidIMenuItems = Com.mkIID "{00020867-0001-0000-C000-000000000046}"
add10 :: Prelude.String -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> IMenuItems a -> Prelude.IO (IMenuItem Automation.Interface)
add10 caption onAction shortcutKey before restore statusBar helpFile helpContextID =
  Automation.function1 "Add" [Automation.inString caption, Automation.inInt onAction, Automation.inInt shortcutKey, Automation.inInt before, Automation.inInt restore, Automation.inInt statusBar, Automation.inInt helpFile, Automation.inInt helpContextID] Automation.outIDispatch
addMenu :: Prelude.String -> Prelude.Int -> Prelude.Int -> IMenuItems a -> Prelude.IO (IMenu Automation.Interface)
addMenu caption before restore =
  Automation.function1 "AddMenu" [Automation.inString caption, Automation.inInt before, Automation.inInt restore] Automation.outIDispatch
-- --------------------------------------------------
-- 
-- interface IMenuItem
-- 
-- --------------------------------------------------
data MenuItem a = MenuItem
                   
type IMenuItem a = Automation.IDispatch (MenuItem a)
iidIMenuItem :: Com.IID (IMenuItem Automation.Interface)
iidIMenuItem = Com.mkIID "{00020868-0001-0000-C000-000000000046}"
getChecked :: IMenuItem a -> Prelude.IO (Prelude.Int)
getChecked = Automation.propertyGet "Checked" [] Automation.outInt
setChecked :: Prelude.Int -> IMenuItem a -> Prelude.IO ()
setChecked rHS =
  Automation.propertySet "Checked" [Automation.inInt rHS]
-- --------------------------------------------------
-- 
-- interface ICharts
-- 
-- --------------------------------------------------
data Charts a = Charts
                 
type ICharts a = Automation.IDispatch (Charts a)
iidICharts :: Com.IID (ICharts Automation.Interface)
iidICharts = Com.mkIID "{0002086D-0001-0000-C000-000000000046}"
add11 :: Prelude.Int -> Prelude.Int -> Prelude.Int -> ICharts a -> Prelude.IO (IChart Automation.Interface)
add11 before after count =
  Automation.function1 "Add" [Automation.inInt before, Automation.inInt after, Automation.inInt count] Automation.outIDispatch
dummy70 :: Automation.IDispatch a -> Prelude.IO ()
dummy70 = Automation.method0 "_Dummy7" []
-- --------------------------------------------------
-- 
-- interface IDrawingObjects
-- 
-- --------------------------------------------------
data DrawingObjects a = DrawingObjects
                         
type IDrawingObjects a = Automation.IDispatch (DrawingObjects a)
iidIDrawingObjects :: Com.IID (IDrawingObjects Automation.Interface)
iidIDrawingObjects =
  Com.mkIID "{0002086F-0001-0000-C000-000000000046}"
dummy30 :: Automation.IDispatch a -> Prelude.IO ()
dummy30 = Automation.method0 "_Dummy3" []
bringToFront :: Automation.IDispatch a -> Prelude.IO ()
bringToFront = Automation.method0 "BringToFront" []
copy5 :: Automation.IDispatch a -> Prelude.IO ()
copy5 = Automation.method0 "Copy" []
cut0 :: Automation.IDispatch a -> Prelude.IO ()
cut0 = Automation.method0 "Cut" []
duplicate :: Automation.IDispatch a -> Prelude.IO (Automation.IDispatch Automation.Interface)
duplicate =
  Automation.function1 "Duplicate" [] Automation.outIDispatch
dummy12 :: Automation.IDispatch a -> Prelude.IO ()
dummy12 = Automation.method0 "_Dummy12" []
dummy15 :: Automation.IDispatch a -> Prelude.IO ()
dummy15 = Automation.method0 "_Dummy15" []
getPlacement :: Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getPlacement =
  Automation.propertyGet "Placement" [] Automation.outInt
setPlacement :: Prelude.Int -> Automation.IDispatch a -> Prelude.IO ()
setPlacement rHS =
  Automation.propertySet "Placement" [Automation.inInt rHS]
getPrintObject :: Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getPrintObject =
  Automation.propertyGet "PrintObject" [] Automation.outInt
setPrintObject :: Prelude.Int -> Automation.IDispatch a -> Prelude.IO ()
setPrintObject rHS =
  Automation.propertySet "PrintObject" [Automation.inInt rHS]
select5 :: Prelude.Int -> Automation.IDispatch a -> Prelude.IO ()
select5 replace =
  Automation.method0 "Select" [Automation.inInt replace]
sendToBack :: Automation.IDispatch a -> Prelude.IO ()
sendToBack = Automation.method0 "SendToBack" []
dummy22 :: Automation.IDispatch a -> Prelude.IO ()
dummy22 = Automation.method0 "_Dummy22" []
getZOrder :: Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getZOrder = Automation.propertyGet "ZOrder" [] Automation.outInt
getShapeRange :: Automation.IDispatch a -> Prelude.IO (Office.IShapeRange Automation.Interface)
getShapeRange =
  Automation.propertyGet "ShapeRange" [] Automation.outIDispatch
getAccelerator :: Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getAccelerator =
  Automation.propertyGet "Accelerator" [] Automation.outInt
setAccelerator :: Prelude.Int -> Automation.IDispatch a -> Prelude.IO ()
setAccelerator rHS =
  Automation.propertySet "Accelerator" [Automation.inInt rHS]
dummy28 :: Automation.IDispatch a -> Prelude.IO ()
dummy28 = Automation.method0 "_Dummy28" []
addItem :: Prelude.Int -> Prelude.Int -> Automation.IDispatch a -> Prelude.IO ()
addItem text index =
  Automation.method0 "AddItem" [Automation.inInt text, Automation.inInt index]
getArrowHeadLength :: Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getArrowHeadLength =
  Automation.propertyGet "ArrowHeadLength" [] Automation.outInt
setArrowHeadLength :: Prelude.Int -> Automation.IDispatch a -> Prelude.IO ()
setArrowHeadLength rHS =
  Automation.propertySet "ArrowHeadLength" [Automation.inInt rHS]
getArrowHeadStyle :: Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getArrowHeadStyle =
  Automation.propertyGet "ArrowHeadStyle" [] Automation.outInt
setArrowHeadStyle :: Prelude.Int -> Automation.IDispatch a -> Prelude.IO ()
setArrowHeadStyle rHS =
  Automation.propertySet "ArrowHeadStyle" [Automation.inInt rHS]
getArrowHeadWidth :: Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getArrowHeadWidth =
  Automation.propertyGet "ArrowHeadWidth" [] Automation.outInt
setArrowHeadWidth :: Prelude.Int -> Automation.IDispatch a -> Prelude.IO ()
setArrowHeadWidth rHS =
  Automation.propertySet "ArrowHeadWidth" [Automation.inInt rHS]
getAutoSize :: Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getAutoSize =
  Automation.propertyGet "AutoSize" [] Automation.outInt
setAutoSize :: Prelude.Int -> Automation.IDispatch a -> Prelude.IO ()
setAutoSize rHS =
  Automation.propertySet "AutoSize" [Automation.inInt rHS]
getBorder0 :: Automation.IDispatch a -> Prelude.IO (IBorder Automation.Interface)
getBorder0 =
  Automation.propertyGet "Border" [] Automation.outIDispatch
getCancelButton :: Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getCancelButton =
  Automation.propertyGet "CancelButton" [] Automation.outInt
setCancelButton :: Prelude.Int -> Automation.IDispatch a -> Prelude.IO ()
setCancelButton rHS =
  Automation.propertySet "CancelButton" [Automation.inInt rHS]
getDefault18 :: Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getDefault18 =
  Automation.propertyGet "_Default" [] Automation.outInt
setDefault0 :: Prelude.Int -> Automation.IDispatch a -> Prelude.IO ()
setDefault0 rHS =
  Automation.propertySet "_Default" [Automation.inInt rHS]
getDefaultButton :: Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getDefaultButton =
  Automation.propertyGet "DefaultButton" [] Automation.outInt
setDefaultButton :: Prelude.Int -> Automation.IDispatch a -> Prelude.IO ()
setDefaultButton rHS =
  Automation.propertySet "DefaultButton" [Automation.inInt rHS]
getDismissButton :: Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getDismissButton =
  Automation.propertyGet "DismissButton" [] Automation.outInt
setDismissButton :: Prelude.Int -> Automation.IDispatch a -> Prelude.IO ()
setDismissButton rHS =
  Automation.propertySet "DismissButton" [Automation.inInt rHS]
getDisplay3DShading :: Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getDisplay3DShading =
  Automation.propertyGet "Display3DShading" [] Automation.outInt
setDisplay3DShading :: Prelude.Int -> Automation.IDispatch a -> Prelude.IO ()
setDisplay3DShading rHS =
  Automation.propertySet "Display3DShading" [Automation.inInt rHS]
getDropDownLines :: Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getDropDownLines =
  Automation.propertyGet "DropDownLines" [] Automation.outInt
setDropDownLines :: Prelude.Int -> Automation.IDispatch a -> Prelude.IO ()
setDropDownLines rHS =
  Automation.propertySet "DropDownLines" [Automation.inInt rHS]
dummy47 :: Automation.IDispatch a -> Prelude.IO ()
dummy47 = Automation.method0 "_Dummy47" []
getHelpButton :: Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getHelpButton =
  Automation.propertyGet "HelpButton" [] Automation.outInt
setHelpButton :: Prelude.Int -> Automation.IDispatch a -> Prelude.IO ()
setHelpButton rHS =
  Automation.propertySet "HelpButton" [Automation.inInt rHS]
getInputType :: Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getInputType =
  Automation.propertyGet "InputType" [] Automation.outInt
setInputType :: Prelude.Int -> Automation.IDispatch a -> Prelude.IO ()
setInputType rHS =
  Automation.propertySet "InputType" [Automation.inInt rHS]
getLargeChange :: Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getLargeChange =
  Automation.propertyGet "LargeChange" [] Automation.outInt
setLargeChange :: Prelude.Int -> Automation.IDispatch a -> Prelude.IO ()
setLargeChange rHS =
  Automation.propertySet "LargeChange" [Automation.inInt rHS]
getLinkedCell :: Automation.IDispatch a -> Prelude.IO (Prelude.String)
getLinkedCell =
  Automation.propertyGet "LinkedCell" [] Automation.outString
setLinkedCell :: Prelude.String -> Automation.IDispatch a -> Prelude.IO ()
setLinkedCell rHS =
  Automation.propertySet "LinkedCell" [Automation.inString rHS]
dummy54 :: Automation.IDispatch a -> Prelude.IO ()
dummy54 = Automation.method0 "_Dummy54" []
list :: Prelude.Int -> Automation.IDispatch a -> Prelude.IO (Prelude.Int)
list index =
  Automation.function1 "List" [Automation.inInt index] Automation.outInt
dummy56 :: Automation.IDispatch a -> Prelude.IO ()
dummy56 = Automation.method0 "_Dummy56" []
getListFillRange :: Automation.IDispatch a -> Prelude.IO (Prelude.String)
getListFillRange =
  Automation.propertyGet "ListFillRange" [] Automation.outString
setListFillRange :: Prelude.String -> Automation.IDispatch a -> Prelude.IO ()
setListFillRange rHS =
  Automation.propertySet "ListFillRange" [Automation.inString rHS]
getListIndex :: Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getListIndex =
  Automation.propertyGet "ListIndex" [] Automation.outInt
setListIndex :: Prelude.Int -> Automation.IDispatch a -> Prelude.IO ()
setListIndex rHS =
  Automation.propertySet "ListIndex" [Automation.inInt rHS]
getLockedText :: Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getLockedText =
  Automation.propertyGet "LockedText" [] Automation.outInt
setLockedText :: Prelude.Int -> Automation.IDispatch a -> Prelude.IO ()
setLockedText rHS =
  Automation.propertySet "LockedText" [Automation.inInt rHS]
getMax :: Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getMax = Automation.propertyGet "Max" [] Automation.outInt
setMax :: Prelude.Int -> Automation.IDispatch a -> Prelude.IO ()
setMax rHS = Automation.propertySet "Max" [Automation.inInt rHS]
getMin :: Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getMin = Automation.propertyGet "Min" [] Automation.outInt
setMin :: Prelude.Int -> Automation.IDispatch a -> Prelude.IO ()
setMin rHS = Automation.propertySet "Min" [Automation.inInt rHS]
getMultiLine :: Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getMultiLine =
  Automation.propertyGet "MultiLine" [] Automation.outInt
setMultiLine :: Prelude.Int -> Automation.IDispatch a -> Prelude.IO ()
setMultiLine rHS =
  Automation.propertySet "MultiLine" [Automation.inInt rHS]
getMultiSelect :: IDrawingObjects a -> Prelude.IO (Prelude.Int)
getMultiSelect =
  Automation.propertyGet "MultiSelect" [] Automation.outInt
setMultiSelect :: Prelude.Int -> IDrawingObjects a -> Prelude.IO ()
setMultiSelect rHS =
  Automation.propertySet "MultiSelect" [Automation.inInt rHS]
getPhoneticAccelerator :: Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getPhoneticAccelerator =
  Automation.propertyGet "PhoneticAccelerator" [] Automation.outInt
setPhoneticAccelerator :: Prelude.Int -> Automation.IDispatch a -> Prelude.IO ()
setPhoneticAccelerator rHS =
  Automation.propertySet "PhoneticAccelerator" [Automation.inInt rHS]
removeAllItems :: Automation.IDispatch a -> Prelude.IO ()
removeAllItems = Automation.method0 "RemoveAllItems" []
removeItem :: Prelude.Int -> Prelude.Int -> Automation.IDispatch a -> Prelude.IO ()
removeItem index count =
  Automation.method0 "RemoveItem" [Automation.inInt index, Automation.inInt count]
reshape :: Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> IDrawingObjects a -> Prelude.IO ()
reshape vertex insert left top =
  Automation.method0 "Reshape" [Automation.inInt vertex, Automation.inInt insert, Automation.inInt left, Automation.inInt top]
getRoundedCorners :: Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getRoundedCorners =
  Automation.propertyGet "RoundedCorners" [] Automation.outInt
setRoundedCorners :: Prelude.Int -> Automation.IDispatch a -> Prelude.IO ()
setRoundedCorners rHS =
  Automation.propertySet "RoundedCorners" [Automation.inInt rHS]
selected :: Prelude.Int -> Automation.IDispatch a -> Prelude.IO (Prelude.Int)
selected index =
  Automation.function1 "Selected" [Automation.inInt index] Automation.outInt
getShadow0 :: Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getShadow0 = Automation.propertyGet "Shadow" [] Automation.outInt
setShadow0 :: Prelude.Int -> Automation.IDispatch a -> Prelude.IO ()
setShadow0 rHS =
  Automation.propertySet "Shadow" [Automation.inInt rHS]
getSmallChange :: Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getSmallChange =
  Automation.propertyGet "SmallChange" [] Automation.outInt
setSmallChange :: Prelude.Int -> Automation.IDispatch a -> Prelude.IO ()
setSmallChange rHS =
  Automation.propertySet "SmallChange" [Automation.inInt rHS]
ungroup0 :: Automation.IDispatch a -> Prelude.IO (Automation.IDispatch Automation.Interface)
ungroup0 =
  Automation.function1 "Ungroup" [] Automation.outIDispatch
vertices :: Prelude.Int -> Prelude.Int -> Automation.IDispatch a -> Prelude.IO (Prelude.Int)
vertices index1 index2 =
  Automation.function1 "Vertices" [Automation.inInt index1, Automation.inInt index2] Automation.outInt
group0 :: Automation.IDispatch a -> Prelude.IO (IGroupObject Automation.Interface)
group0 = Automation.function1 "Group" [] Automation.outIDispatch
linkCombo :: Prelude.Int -> IDrawingObjects a -> Prelude.IO ()
linkCombo link =
  Automation.method0 "LinkCombo" [Automation.inInt link]
-- --------------------------------------------------
-- 
-- interface IPivotCache
-- 
-- --------------------------------------------------
data PivotCache a = PivotCache
                     
type IPivotCache a = Automation.IDispatch (PivotCache a)
iidIPivotCache :: Com.IID (IPivotCache Automation.Interface)
iidIPivotCache = Com.mkIID "{0002441C-0001-0000-C000-000000000046}"
getBackgroundQuery :: Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getBackgroundQuery =
  Automation.propertyGet "BackgroundQuery" [] Automation.outInt
setBackgroundQuery :: Prelude.Int -> Automation.IDispatch a -> Prelude.IO ()
setBackgroundQuery rHS =
  Automation.propertySet "BackgroundQuery" [Automation.inInt rHS]
getConnection :: Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getConnection =
  Automation.propertyGet "Connection" [] Automation.outInt
setConnection :: Prelude.Int -> Automation.IDispatch a -> Prelude.IO ()
setConnection rHS =
  Automation.propertySet "Connection" [Automation.inInt rHS]
getEnableRefresh :: Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getEnableRefresh =
  Automation.propertyGet "EnableRefresh" [] Automation.outInt
setEnableRefresh :: Prelude.Int -> Automation.IDispatch a -> Prelude.IO ()
setEnableRefresh rHS =
  Automation.propertySet "EnableRefresh" [Automation.inInt rHS]
getMemoryUsed0 :: Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getMemoryUsed0 =
  Automation.propertyGet "MemoryUsed" [] Automation.outInt
getOptimizeCache :: IPivotCache a -> Prelude.IO (Prelude.Int)
getOptimizeCache =
  Automation.propertyGet "OptimizeCache" [] Automation.outInt
setOptimizeCache :: Prelude.Int -> IPivotCache a -> Prelude.IO ()
setOptimizeCache rHS =
  Automation.propertySet "OptimizeCache" [Automation.inInt rHS]
getRecordCount :: Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getRecordCount =
  Automation.propertyGet "RecordCount" [] Automation.outInt
getRefreshDate :: Automation.IDispatch a -> Prelude.IO (Prelude.Double)
getRefreshDate =
  Automation.propertyGet "RefreshDate" [] Automation.outDouble
getRefreshName :: Automation.IDispatch a -> Prelude.IO (Prelude.String)
getRefreshName =
  Automation.propertyGet "RefreshName" [] Automation.outString
getRefreshOnFileOpen :: Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getRefreshOnFileOpen =
  Automation.propertyGet "RefreshOnFileOpen" [] Automation.outInt
setRefreshOnFileOpen :: Prelude.Int -> Automation.IDispatch a -> Prelude.IO ()
setRefreshOnFileOpen rHS =
  Automation.propertySet "RefreshOnFileOpen" [Automation.inInt rHS]
getSql :: Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getSql = Automation.propertyGet "Sql" [] Automation.outInt
setSql :: Prelude.Int -> Automation.IDispatch a -> Prelude.IO ()
setSql rHS = Automation.propertySet "Sql" [Automation.inInt rHS]
getSavePassword :: Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getSavePassword =
  Automation.propertyGet "SavePassword" [] Automation.outInt
setSavePassword :: Prelude.Int -> Automation.IDispatch a -> Prelude.IO ()
setSavePassword rHS =
  Automation.propertySet "SavePassword" [Automation.inInt rHS]
getSourceData :: Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getSourceData =
  Automation.propertyGet "SourceData" [] Automation.outInt
setSourceData0 :: Prelude.Int -> Automation.IDispatch a -> Prelude.IO ()
setSourceData0 rHS =
  Automation.propertySet "SourceData" [Automation.inInt rHS]
-- --------------------------------------------------
-- 
-- interface IPivotCaches
-- 
-- --------------------------------------------------
data PivotCaches a = PivotCaches
                      
type IPivotCaches a = Automation.IDispatch (PivotCaches a)
iidIPivotCaches :: Com.IID (IPivotCaches Automation.Interface)
iidIPivotCaches =
  Com.mkIID "{0002441D-0001-0000-C000-000000000046}"
item1 :: Prelude.Int -> IPivotCaches a -> Prelude.IO (IPivotCache Automation.Interface)
item1 index =
  Automation.function1 "Item" [Automation.inInt index] Automation.outIDispatch
getDefault19 :: Prelude.Int -> IPivotCaches a -> Prelude.IO (IPivotCache Automation.Interface)
getDefault19 index =
  Automation.propertyGet "_Default" [Automation.inInt index] Automation.outIDispatch
-- --------------------------------------------------
-- 
-- interface IPivotFormula
-- 
-- --------------------------------------------------
data PivotFormula a = PivotFormula
                       
type IPivotFormula a = Automation.IDispatch (PivotFormula a)
iidIPivotFormula :: Com.IID (IPivotFormula Automation.Interface)
iidIPivotFormula =
  Com.mkIID "{0002441E-0001-0000-C000-000000000046}"
setDefault1 :: Prelude.String -> Automation.IDispatch a -> Prelude.IO ()
setDefault1 rHS =
  Automation.propertySet "_Default" [Automation.inString rHS]
getFormula0 :: Automation.IDispatch a -> Prelude.IO (Prelude.String)
getFormula0 =
  Automation.propertyGet "Formula" [] Automation.outString
setFormula0 :: Prelude.String -> Automation.IDispatch a -> Prelude.IO ()
setFormula0 rHS =
  Automation.propertySet "Formula" [Automation.inString rHS]
setValue3 :: Prelude.String -> Automation.IDispatch a -> Prelude.IO ()
setValue3 rHS =
  Automation.propertySet "Value" [Automation.inString rHS]
setIndex :: Prelude.Int -> Automation.IDispatch a -> Prelude.IO ()
setIndex rHS =
  Automation.propertySet "Index" [Automation.inInt rHS]
-- --------------------------------------------------
-- 
-- interface IPivotFormulas
-- 
-- --------------------------------------------------
data PivotFormulas a = PivotFormulas
                        
type IPivotFormulas a = Automation.IDispatch (PivotFormulas a)
iidIPivotFormulas :: Com.IID (IPivotFormulas Automation.Interface)
iidIPivotFormulas =
  Com.mkIID "{0002441F-0001-0000-C000-000000000046}"
add12 :: Prelude.String -> IPivotFormulas a -> Prelude.IO (IPivotFormula Automation.Interface)
add12 formula =
  Automation.function1 "Add" [Automation.inString formula] Automation.outIDispatch
item2 :: Prelude.Int -> IPivotFormulas a -> Prelude.IO (IPivotFormula Automation.Interface)
item2 index =
  Automation.function1 "Item" [Automation.inInt index] Automation.outIDispatch
getDefault21 :: Prelude.Int -> IPivotFormulas a -> Prelude.IO (IPivotFormula Automation.Interface)
getDefault21 index =
  Automation.propertyGet "_Default" [Automation.inInt index] Automation.outIDispatch
-- --------------------------------------------------
-- 
-- interface IPivotTable
-- 
-- --------------------------------------------------
data PivotTable a = PivotTable
                     
type IPivotTable a = Automation.IDispatch (PivotTable a)
iidIPivotTable :: Com.IID (IPivotTable Automation.Interface)
iidIPivotTable = Com.mkIID "{00020872-0001-0000-C000-000000000046}"
addFields :: Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> IPivotTable a -> Prelude.IO ()
addFields rowFields columnFields pageFields addToTable =
  Automation.method0 "AddFields" [Automation.inInt rowFields, Automation.inInt columnFields, Automation.inInt pageFields, Automation.inInt addToTable]
getColumnFields :: Prelude.Int -> IPivotTable a -> Prelude.IO (Automation.IDispatch Automation.Interface)
getColumnFields index =
  Automation.propertyGet "ColumnFields" [Automation.inInt index] Automation.outIDispatch
getColumnGrand :: IPivotTable a -> Prelude.IO (Prelude.Int)
getColumnGrand =
  Automation.propertyGet "ColumnGrand" [] Automation.outInt
setColumnGrand :: Prelude.Int -> IPivotTable a -> Prelude.IO ()
setColumnGrand rHS =
  Automation.propertySet "ColumnGrand" [Automation.inInt rHS]
getColumnRange :: IPivotTable a -> Prelude.IO (IRange Automation.Interface)
getColumnRange =
  Automation.propertyGet "ColumnRange" [] Automation.outIDispatch
showPages :: Prelude.Int -> IPivotTable a -> Prelude.IO ()
showPages pageField =
  Automation.method0 "ShowPages" [Automation.inInt pageField]
getDataBodyRange :: IPivotTable a -> Prelude.IO (IRange Automation.Interface)
getDataBodyRange =
  Automation.propertyGet "DataBodyRange" [] Automation.outIDispatch
getDataFields :: Prelude.Int -> IPivotTable a -> Prelude.IO (Automation.IDispatch Automation.Interface)
getDataFields index =
  Automation.propertyGet "DataFields" [Automation.inInt index] Automation.outIDispatch
getDataLabelRange :: IPivotTable a -> Prelude.IO (IRange Automation.Interface)
getDataLabelRange =
  Automation.propertyGet "DataLabelRange" [] Automation.outIDispatch
getHasAutoFormat :: Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getHasAutoFormat =
  Automation.propertyGet "HasAutoFormat" [] Automation.outInt
setHasAutoFormat :: Prelude.Int -> Automation.IDispatch a -> Prelude.IO ()
setHasAutoFormat rHS =
  Automation.propertySet "HasAutoFormat" [Automation.inInt rHS]
getHiddenFields :: Prelude.Int -> IPivotTable a -> Prelude.IO (Automation.IDispatch Automation.Interface)
getHiddenFields index =
  Automation.propertyGet "HiddenFields" [Automation.inInt index] Automation.outIDispatch
getInnerDetail :: IPivotTable a -> Prelude.IO (Prelude.String)
getInnerDetail =
  Automation.propertyGet "InnerDetail" [] Automation.outString
setInnerDetail :: Prelude.String -> IPivotTable a -> Prelude.IO ()
setInnerDetail rHS =
  Automation.propertySet "InnerDetail" [Automation.inString rHS]
getPageFields :: Prelude.Int -> IPivotTable a -> Prelude.IO (Automation.IDispatch Automation.Interface)
getPageFields index =
  Automation.propertyGet "PageFields" [Automation.inInt index] Automation.outIDispatch
getPageRange :: IPivotTable a -> Prelude.IO (IRange Automation.Interface)
getPageRange =
  Automation.propertyGet "PageRange" [] Automation.outIDispatch
getPageRangeCells :: IPivotTable a -> Prelude.IO (IRange Automation.Interface)
getPageRangeCells =
  Automation.propertyGet "PageRangeCells" [] Automation.outIDispatch
pivotFields :: Prelude.Int -> IPivotTable a -> Prelude.IO (Automation.IDispatch Automation.Interface)
pivotFields index =
  Automation.function1 "PivotFields" [Automation.inInt index] Automation.outIDispatch
refreshTable :: IPivotTable a -> Prelude.IO (Prelude.Int)
refreshTable =
  Automation.function1 "RefreshTable" [] Automation.outInt
getRowFields :: Prelude.Int -> IPivotTable a -> Prelude.IO (Automation.IDispatch Automation.Interface)
getRowFields index =
  Automation.propertyGet "RowFields" [Automation.inInt index] Automation.outIDispatch
getRowGrand :: IPivotTable a -> Prelude.IO (Prelude.Int)
getRowGrand =
  Automation.propertyGet "RowGrand" [] Automation.outInt
setRowGrand :: Prelude.Int -> IPivotTable a -> Prelude.IO ()
setRowGrand rHS =
  Automation.propertySet "RowGrand" [Automation.inInt rHS]
getRowRange :: IPivotTable a -> Prelude.IO (IRange Automation.Interface)
getRowRange =
  Automation.propertyGet "RowRange" [] Automation.outIDispatch
getSaveData :: Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getSaveData =
  Automation.propertyGet "SaveData" [] Automation.outInt
setSaveData :: Prelude.Int -> Automation.IDispatch a -> Prelude.IO ()
setSaveData rHS =
  Automation.propertySet "SaveData" [Automation.inInt rHS]
getTableRange1 :: IPivotTable a -> Prelude.IO (IRange Automation.Interface)
getTableRange1 =
  Automation.propertyGet "TableRange1" [] Automation.outIDispatch
getTableRange2 :: IPivotTable a -> Prelude.IO (IRange Automation.Interface)
getTableRange2 =
  Automation.propertyGet "TableRange2" [] Automation.outIDispatch
getVisibleFields :: Prelude.Int -> IPivotTable a -> Prelude.IO (Automation.IDispatch Automation.Interface)
getVisibleFields index =
  Automation.propertyGet "VisibleFields" [Automation.inInt index] Automation.outIDispatch
getCacheIndex :: IPivotTable a -> Prelude.IO (Prelude.Int)
getCacheIndex =
  Automation.propertyGet "CacheIndex" [] Automation.outInt
setCacheIndex :: Prelude.Int -> IPivotTable a -> Prelude.IO ()
setCacheIndex rHS =
  Automation.propertySet "CacheIndex" [Automation.inInt rHS]
calculatedFields :: IPivotTable a -> Prelude.IO (ICalculatedFields Automation.Interface)
calculatedFields =
  Automation.function1 "CalculatedFields" [] Automation.outIDispatch
getDisplayErrorString :: IPivotTable a -> Prelude.IO (Prelude.Int)
getDisplayErrorString =
  Automation.propertyGet "DisplayErrorString" [] Automation.outInt
setDisplayErrorString :: Prelude.Int -> IPivotTable a -> Prelude.IO ()
setDisplayErrorString rHS =
  Automation.propertySet "DisplayErrorString" [Automation.inInt rHS]
getDisplayNullString :: IPivotTable a -> Prelude.IO (Prelude.Int)
getDisplayNullString =
  Automation.propertyGet "DisplayNullString" [] Automation.outInt
setDisplayNullString :: Prelude.Int -> IPivotTable a -> Prelude.IO ()
setDisplayNullString rHS =
  Automation.propertySet "DisplayNullString" [Automation.inInt rHS]
getEnableDrilldown :: IPivotTable a -> Prelude.IO (Prelude.Int)
getEnableDrilldown =
  Automation.propertyGet "EnableDrilldown" [] Automation.outInt
setEnableDrilldown :: Prelude.Int -> IPivotTable a -> Prelude.IO ()
setEnableDrilldown rHS =
  Automation.propertySet "EnableDrilldown" [Automation.inInt rHS]
getEnableFieldDialog :: IPivotTable a -> Prelude.IO (Prelude.Int)
getEnableFieldDialog =
  Automation.propertyGet "EnableFieldDialog" [] Automation.outInt
setEnableFieldDialog :: Prelude.Int -> IPivotTable a -> Prelude.IO ()
setEnableFieldDialog rHS =
  Automation.propertySet "EnableFieldDialog" [Automation.inInt rHS]
getEnableWizard :: IPivotTable a -> Prelude.IO (Prelude.Int)
getEnableWizard =
  Automation.propertyGet "EnableWizard" [] Automation.outInt
setEnableWizard :: Prelude.Int -> IPivotTable a -> Prelude.IO ()
setEnableWizard rHS =
  Automation.propertySet "EnableWizard" [Automation.inInt rHS]
getErrorString :: Automation.IDispatch a -> Prelude.IO (Prelude.String)
getErrorString =
  Automation.propertyGet "ErrorString" [] Automation.outString
setErrorString :: Prelude.String -> IPivotTable a -> Prelude.IO ()
setErrorString rHS =
  Automation.propertySet "ErrorString" [Automation.inString rHS]
getData :: Prelude.String -> IPivotTable a -> Prelude.IO (Prelude.Double)
getData name =
  Automation.function1 "GetData" [Automation.inString name] Automation.outDouble
listFormulas :: IPivotTable a -> Prelude.IO ()
listFormulas = Automation.method0 "ListFormulas" []
getManualUpdate :: IPivotTable a -> Prelude.IO (Prelude.Int)
getManualUpdate =
  Automation.propertyGet "ManualUpdate" [] Automation.outInt
setManualUpdate :: Prelude.Int -> IPivotTable a -> Prelude.IO ()
setManualUpdate rHS =
  Automation.propertySet "ManualUpdate" [Automation.inInt rHS]
getMergeLabels :: IPivotTable a -> Prelude.IO (Prelude.Int)
getMergeLabels =
  Automation.propertyGet "MergeLabels" [] Automation.outInt
setMergeLabels :: Prelude.Int -> IPivotTable a -> Prelude.IO ()
setMergeLabels rHS =
  Automation.propertySet "MergeLabels" [Automation.inInt rHS]
getNullString :: IPivotTable a -> Prelude.IO (Prelude.String)
getNullString =
  Automation.propertyGet "NullString" [] Automation.outString
setNullString :: Prelude.String -> IPivotTable a -> Prelude.IO ()
setNullString rHS =
  Automation.propertySet "NullString" [Automation.inString rHS]
pivotCache :: IPivotTable a -> Prelude.IO (IPivotCache Automation.Interface)
pivotCache =
  Automation.function1 "PivotCache" [] Automation.outIDispatch
pivotFormulas :: IPivotTable a -> Prelude.IO (IPivotFormulas Automation.Interface)
pivotFormulas =
  Automation.function1 "PivotFormulas" [] Automation.outIDispatch
pivotTableWizard1 :: Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Automation.IDispatch a -> Prelude.IO ()
pivotTableWizard1 sourceType sourceData tableDestination tableName rowGrand columnGrand saveData hasAutoFormat autoPage reserved backgroundQuery optimizeCache pageFieldOrder pageFieldWrapCount readData connection =
  Automation.method0 "PivotTableWizard" [Automation.inInt sourceType, Automation.inInt sourceData, Automation.inInt tableDestination, Automation.inInt tableName, Automation.inInt rowGrand, Automation.inInt columnGrand, Automation.inInt saveData, Automation.inInt hasAutoFormat, Automation.inInt autoPage, Automation.inInt reserved, Automation.inInt backgroundQuery, Automation.inInt optimizeCache, Automation.inInt pageFieldOrder, Automation.inInt pageFieldWrapCount, Automation.inInt readData, Automation.inInt connection]
getSubtotalHiddenPageItems :: IPivotTable a -> Prelude.IO (Prelude.Int)
getSubtotalHiddenPageItems =
  Automation.propertyGet "SubtotalHiddenPageItems" [] Automation.outInt
setSubtotalHiddenPageItems :: Prelude.Int -> IPivotTable a -> Prelude.IO ()
setSubtotalHiddenPageItems rHS =
  Automation.propertySet "SubtotalHiddenPageItems" [Automation.inInt rHS]
getPageFieldOrder :: IPivotTable a -> Prelude.IO (Prelude.Int)
getPageFieldOrder =
  Automation.propertyGet "PageFieldOrder" [] Automation.outInt
setPageFieldOrder :: Prelude.Int -> IPivotTable a -> Prelude.IO ()
setPageFieldOrder rHS =
  Automation.propertySet "PageFieldOrder" [Automation.inInt rHS]
getPageFieldStyle :: IPivotTable a -> Prelude.IO (Prelude.String)
getPageFieldStyle =
  Automation.propertyGet "PageFieldStyle" [] Automation.outString
setPageFieldStyle :: Prelude.String -> IPivotTable a -> Prelude.IO ()
setPageFieldStyle rHS =
  Automation.propertySet "PageFieldStyle" [Automation.inString rHS]
getPageFieldWrapCount :: IPivotTable a -> Prelude.IO (Prelude.Int)
getPageFieldWrapCount =
  Automation.propertyGet "PageFieldWrapCount" [] Automation.outInt
setPageFieldWrapCount :: Prelude.Int -> IPivotTable a -> Prelude.IO ()
setPageFieldWrapCount rHS =
  Automation.propertySet "PageFieldWrapCount" [Automation.inInt rHS]
getPreserveFormatting :: IPivotTable a -> Prelude.IO (Prelude.Int)
getPreserveFormatting =
  Automation.propertyGet "PreserveFormatting" [] Automation.outInt
setPreserveFormatting :: Prelude.Int -> IPivotTable a -> Prelude.IO ()
setPreserveFormatting rHS =
  Automation.propertySet "PreserveFormatting" [Automation.inInt rHS]
pivotSelect :: (Automation.Variant a0) => Prelude.String -> a0 -> IPivotTable a -> Prelude.IO ()
pivotSelect name mode =
  Automation.method0 "PivotSelect" [Automation.inString name, Automation.inVariant mode]
getPivotSelection :: IPivotTable a -> Prelude.IO (Prelude.String)
getPivotSelection =
  Automation.propertyGet "PivotSelection" [] Automation.outString
setPivotSelection :: Prelude.String -> IPivotTable a -> Prelude.IO ()
setPivotSelection rHS =
  Automation.propertySet "PivotSelection" [Automation.inString rHS]
getSelectionMode :: (Automation.Variant a0) => IPivotTable a -> Prelude.IO (a0)
getSelectionMode =
  Automation.propertyGet "SelectionMode" [] Automation.outVariant
setSelectionMode :: (Automation.Variant a0) => a0 -> IPivotTable a -> Prelude.IO ()
setSelectionMode rHS =
  Automation.propertySet "SelectionMode" [Automation.inVariant rHS]
getTableStyle :: IPivotTable a -> Prelude.IO (Prelude.String)
getTableStyle =
  Automation.propertyGet "TableStyle" [] Automation.outString
setTableStyle :: Prelude.String -> IPivotTable a -> Prelude.IO ()
setTableStyle rHS =
  Automation.propertySet "TableStyle" [Automation.inString rHS]
getTag :: IPivotTable a -> Prelude.IO (Prelude.String)
getTag = Automation.propertyGet "Tag" [] Automation.outString
setTag :: Prelude.String -> IPivotTable a -> Prelude.IO ()
setTag rHS = Automation.propertySet "Tag" [Automation.inString rHS]
update :: Automation.IDispatch a -> Prelude.IO ()
update = Automation.method0 "Update" []
getVacatedStyle :: IPivotTable a -> Prelude.IO (Prelude.String)
getVacatedStyle =
  Automation.propertyGet "VacatedStyle" [] Automation.outString
setVacatedStyle :: Prelude.String -> IPivotTable a -> Prelude.IO ()
setVacatedStyle rHS =
  Automation.propertySet "VacatedStyle" [Automation.inString rHS]
-- --------------------------------------------------
-- 
-- interface IPivotTables
-- 
-- --------------------------------------------------
data PivotTables a = PivotTables
                      
type IPivotTables a = Automation.IDispatch (PivotTables a)
iidIPivotTables :: Com.IID (IPivotTables Automation.Interface)
iidIPivotTables =
  Com.mkIID "{00020873-0001-0000-C000-000000000046}"
item3 :: Prelude.Int -> IPivotTables a -> Prelude.IO (IPivotTable Automation.Interface)
item3 index =
  Automation.function1 "Item" [Automation.inInt index] Automation.outIDispatch
-- --------------------------------------------------
-- 
-- interface IPivotField
-- 
-- --------------------------------------------------
data PivotField a = PivotField
                     
type IPivotField a = Automation.IDispatch (PivotField a)
iidIPivotField :: Com.IID (IPivotField Automation.Interface)
iidIPivotField = Com.mkIID "{00020874-0001-0000-C000-000000000046}"
getParent52 :: Automation.IDispatch a -> Prelude.IO (IPivotTable Automation.Interface)
getParent52 =
  Automation.propertyGet "Parent" [] Automation.outIDispatch
getCalculation0 :: (Automation.Variant a0) => IPivotField a -> Prelude.IO (a0)
getCalculation0 =
  Automation.propertyGet "Calculation" [] Automation.outVariant
setCalculation0 :: (Automation.Variant a0) => a0 -> IPivotField a -> Prelude.IO ()
setCalculation0 rHS =
  Automation.propertySet "Calculation" [Automation.inVariant rHS]
getChildField :: IPivotField a -> Prelude.IO (IPivotField Automation.Interface)
getChildField =
  Automation.propertyGet "ChildField" [] Automation.outIDispatch
getChildItems :: Prelude.Int -> Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getChildItems index =
  Automation.propertyGet "ChildItems" [Automation.inInt index] Automation.outInt
getCurrentPage :: IPivotField a -> Prelude.IO (Prelude.String)
getCurrentPage =
  Automation.propertyGet "CurrentPage" [] Automation.outString
setCurrentPage :: Prelude.String -> IPivotField a -> Prelude.IO ()
setCurrentPage rHS =
  Automation.propertySet "CurrentPage" [Automation.inString rHS]
getDataRange :: Automation.IDispatch a -> Prelude.IO (IRange Automation.Interface)
getDataRange =
  Automation.propertyGet "DataRange" [] Automation.outIDispatch
getDataType :: (Automation.Variant a0) => IPivotField a -> Prelude.IO (a0)
getDataType =
  Automation.propertyGet "DataType" [] Automation.outVariant
getFunction :: (Automation.Variant a0) => IPivotField a -> Prelude.IO (a0)
getFunction =
  Automation.propertyGet "Function" [] Automation.outVariant
setFunction :: (Automation.Variant a0) => a0 -> IPivotField a -> Prelude.IO ()
setFunction rHS =
  Automation.propertySet "Function" [Automation.inVariant rHS]
getGroupLevel :: IPivotField a -> Prelude.IO (Prelude.Int)
getGroupLevel =
  Automation.propertyGet "GroupLevel" [] Automation.outInt
getHiddenItems :: Prelude.Int -> IPivotField a -> Prelude.IO (Prelude.Int)
getHiddenItems index =
  Automation.propertyGet "HiddenItems" [Automation.inInt index] Automation.outInt
getLabelRange :: Automation.IDispatch a -> Prelude.IO (IRange Automation.Interface)
getLabelRange =
  Automation.propertyGet "LabelRange" [] Automation.outIDispatch
getOrientation2 :: (Automation.Variant a0) => IPivotField a -> Prelude.IO (a0)
getOrientation2 =
  Automation.propertyGet "Orientation" [] Automation.outVariant
setOrientation2 :: (Automation.Variant a0) => a0 -> IPivotField a -> Prelude.IO ()
setOrientation2 rHS =
  Automation.propertySet "Orientation" [Automation.inVariant rHS]
getShowAllItems :: IPivotField a -> Prelude.IO (Prelude.Int)
getShowAllItems =
  Automation.propertyGet "ShowAllItems" [] Automation.outInt
setShowAllItems :: Prelude.Int -> IPivotField a -> Prelude.IO ()
setShowAllItems rHS =
  Automation.propertySet "ShowAllItems" [Automation.inInt rHS]
getParentField :: IPivotField a -> Prelude.IO (IPivotField Automation.Interface)
getParentField =
  Automation.propertyGet "ParentField" [] Automation.outIDispatch
getParentItems :: Prelude.Int -> IPivotField a -> Prelude.IO (Prelude.Int)
getParentItems index =
  Automation.propertyGet "ParentItems" [Automation.inInt index] Automation.outInt
pivotItems :: Prelude.Int -> IPivotField a -> Prelude.IO (Prelude.Int)
pivotItems index =
  Automation.function1 "PivotItems" [Automation.inInt index] Automation.outInt
getSourceName :: Automation.IDispatch a -> Prelude.IO (Prelude.String)
getSourceName =
  Automation.propertyGet "SourceName" [] Automation.outString
subtotals :: Prelude.Int -> IPivotField a -> Prelude.IO (Prelude.Int)
subtotals index =
  Automation.function1 "Subtotals" [Automation.inInt index] Automation.outInt
getBaseField :: IPivotField a -> Prelude.IO (Prelude.Int)
getBaseField =
  Automation.propertyGet "BaseField" [] Automation.outInt
setBaseField :: Prelude.Int -> IPivotField a -> Prelude.IO ()
setBaseField rHS =
  Automation.propertySet "BaseField" [Automation.inInt rHS]
getBaseItem :: IPivotField a -> Prelude.IO (Prelude.Int)
getBaseItem =
  Automation.propertyGet "BaseItem" [] Automation.outInt
setBaseItem :: Prelude.Int -> IPivotField a -> Prelude.IO ()
setBaseItem rHS =
  Automation.propertySet "BaseItem" [Automation.inInt rHS]
getTotalLevels :: IPivotField a -> Prelude.IO (Prelude.Int)
getTotalLevels =
  Automation.propertyGet "TotalLevels" [] Automation.outInt
getVisibleItems :: Prelude.Int -> IPivotField a -> Prelude.IO (Prelude.Int)
getVisibleItems index =
  Automation.propertyGet "VisibleItems" [Automation.inInt index] Automation.outInt
calculatedItems :: IPivotField a -> Prelude.IO (ICalculatedItems Automation.Interface)
calculatedItems =
  Automation.function1 "CalculatedItems" [] Automation.outIDispatch
getDragToColumn :: IPivotField a -> Prelude.IO (Prelude.Int)
getDragToColumn =
  Automation.propertyGet "DragToColumn" [] Automation.outInt
setDragToColumn :: Prelude.Int -> IPivotField a -> Prelude.IO ()
setDragToColumn rHS =
  Automation.propertySet "DragToColumn" [Automation.inInt rHS]
getDragToHide :: IPivotField a -> Prelude.IO (Prelude.Int)
getDragToHide =
  Automation.propertyGet "DragToHide" [] Automation.outInt
setDragToHide :: Prelude.Int -> IPivotField a -> Prelude.IO ()
setDragToHide rHS =
  Automation.propertySet "DragToHide" [Automation.inInt rHS]
getDragToPage :: IPivotField a -> Prelude.IO (Prelude.Int)
getDragToPage =
  Automation.propertyGet "DragToPage" [] Automation.outInt
setDragToPage :: Prelude.Int -> IPivotField a -> Prelude.IO ()
setDragToPage rHS =
  Automation.propertySet "DragToPage" [Automation.inInt rHS]
getDragToRow :: IPivotField a -> Prelude.IO (Prelude.Int)
getDragToRow =
  Automation.propertyGet "DragToRow" [] Automation.outInt
setDragToRow :: Prelude.Int -> IPivotField a -> Prelude.IO ()
setDragToRow rHS =
  Automation.propertySet "DragToRow" [Automation.inInt rHS]
getIsCalculated :: Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getIsCalculated =
  Automation.propertyGet "IsCalculated" [] Automation.outInt
getServerBased :: IPivotField a -> Prelude.IO (Prelude.Int)
getServerBased =
  Automation.propertyGet "ServerBased" [] Automation.outInt
setServerBased :: Prelude.Int -> IPivotField a -> Prelude.IO ()
setServerBased rHS =
  Automation.propertySet "ServerBased" [Automation.inInt rHS]
autoSort :: Prelude.Int -> Prelude.String -> IPivotField a -> Prelude.IO ()
autoSort order field =
  Automation.method0 "AutoSort" [Automation.inInt order, Automation.inString field]
autoShow :: Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.String -> IPivotField a -> Prelude.IO ()
autoShow type0 range count field =
  Automation.method0 "AutoShow" [Automation.inInt type0, Automation.inInt range, Automation.inInt count, Automation.inString field]
getAutoSortOrder :: IPivotField a -> Prelude.IO (Prelude.Int)
getAutoSortOrder =
  Automation.propertyGet "AutoSortOrder" [] Automation.outInt
getAutoSortField :: IPivotField a -> Prelude.IO (Prelude.String)
getAutoSortField =
  Automation.propertyGet "AutoSortField" [] Automation.outString
getAutoShowType :: IPivotField a -> Prelude.IO (Prelude.Int)
getAutoShowType =
  Automation.propertyGet "AutoShowType" [] Automation.outInt
getAutoShowRange :: IPivotField a -> Prelude.IO (Prelude.Int)
getAutoShowRange =
  Automation.propertyGet "AutoShowRange" [] Automation.outInt
getAutoShowCount :: IPivotField a -> Prelude.IO (Prelude.Int)
getAutoShowCount =
  Automation.propertyGet "AutoShowCount" [] Automation.outInt
getAutoShowField :: IPivotField a -> Prelude.IO (Prelude.String)
getAutoShowField =
  Automation.propertyGet "AutoShowField" [] Automation.outString
-- --------------------------------------------------
-- 
-- interface IPivotFields
-- 
-- --------------------------------------------------
data PivotFields a = PivotFields
                      
type IPivotFields a = Automation.IDispatch (PivotFields a)
iidIPivotFields :: Com.IID (IPivotFields Automation.Interface)
iidIPivotFields =
  Com.mkIID "{00020875-0001-0000-C000-000000000046}"
-- --------------------------------------------------
-- 
-- interface ICalculatedFields
-- 
-- --------------------------------------------------
data CalculatedFields a = CalculatedFields
                           
type ICalculatedFields a = Automation.IDispatch (CalculatedFields a)
iidICalculatedFields :: Com.IID (ICalculatedFields Automation.Interface)
iidICalculatedFields =
  Com.mkIID "{00024420-0001-0000-C000-000000000046}"
add13 :: Prelude.String -> Prelude.String -> ICalculatedFields a -> Prelude.IO (IPivotField Automation.Interface)
add13 name formula =
  Automation.function1 "Add" [Automation.inString name, Automation.inString formula] Automation.outIDispatch
item5 :: Prelude.Int -> ICalculatedFields a -> Prelude.IO (IPivotField Automation.Interface)
item5 index =
  Automation.function1 "Item" [Automation.inInt index] Automation.outIDispatch
getDefault24 :: Prelude.Int -> ICalculatedFields a -> Prelude.IO (IPivotField Automation.Interface)
getDefault24 field =
  Automation.propertyGet "_Default" [Automation.inInt field] Automation.outIDispatch
-- --------------------------------------------------
-- 
-- interface IPivotItem
-- 
-- --------------------------------------------------
data PivotItem a = PivotItem
                    
type IPivotItem a = Automation.IDispatch (PivotItem a)
iidIPivotItem :: Com.IID (IPivotItem Automation.Interface)
iidIPivotItem = Com.mkIID "{00020876-0001-0000-C000-000000000046}"
getParent55 :: Automation.IDispatch a -> Prelude.IO (IPivotField Automation.Interface)
getParent55 =
  Automation.propertyGet "Parent" [] Automation.outIDispatch
getParentItem :: IPivotItem a -> Prelude.IO (IPivotItem Automation.Interface)
getParentItem =
  Automation.propertyGet "ParentItem" [] Automation.outIDispatch
getParentShowDetail :: IPivotItem a -> Prelude.IO (Prelude.Int)
getParentShowDetail =
  Automation.propertyGet "ParentShowDetail" [] Automation.outInt
getShowDetail0 :: IPivotItem a -> Prelude.IO (Prelude.Int)
getShowDetail0 =
  Automation.propertyGet "ShowDetail" [] Automation.outInt
setShowDetail0 :: Prelude.Int -> IPivotItem a -> Prelude.IO ()
setShowDetail0 rHS =
  Automation.propertySet "ShowDetail" [Automation.inInt rHS]
getSourceName0 :: IPivotItem a -> Prelude.IO (Prelude.Int)
getSourceName0 =
  Automation.propertyGet "SourceName" [] Automation.outInt
-- --------------------------------------------------
-- 
-- interface IPivotItems
-- 
-- --------------------------------------------------
data PivotItems a = PivotItems
                     
type IPivotItems a = Automation.IDispatch (PivotItems a)
iidIPivotItems :: Com.IID (IPivotItems Automation.Interface)
iidIPivotItems = Com.mkIID "{00020877-0001-0000-C000-000000000046}"
add14 :: Prelude.String -> Automation.IDispatch a -> Prelude.IO ()
add14 name = Automation.method0 "Add" [Automation.inString name]
-- --------------------------------------------------
-- 
-- interface ICalculatedItems
-- 
-- --------------------------------------------------
data CalculatedItems a = CalculatedItems
                          
type ICalculatedItems a = Automation.IDispatch (CalculatedItems a)
iidICalculatedItems :: Com.IID (ICalculatedItems Automation.Interface)
iidICalculatedItems =
  Com.mkIID "{00024421-0001-0000-C000-000000000046}"
add15 :: Prelude.String -> Prelude.String -> ICalculatedItems a -> Prelude.IO (IPivotItem Automation.Interface)
add15 name formula =
  Automation.function1 "Add" [Automation.inString name, Automation.inString formula] Automation.outIDispatch
item7 :: Prelude.Int -> ICalculatedItems a -> Prelude.IO (IPivotItem Automation.Interface)
item7 index =
  Automation.function1 "Item" [Automation.inInt index] Automation.outIDispatch
getDefault26 :: Prelude.Int -> ICalculatedItems a -> Prelude.IO (IPivotItem Automation.Interface)
getDefault26 field =
  Automation.propertyGet "_Default" [Automation.inInt field] Automation.outIDispatch
-- --------------------------------------------------
-- 
-- interface ICharacters
-- 
-- --------------------------------------------------
data Characters a = Characters
                     
type ICharacters a = Automation.IDispatch (Characters a)
iidICharacters :: Com.IID (ICharacters Automation.Interface)
iidICharacters = Com.mkIID "{00020878-0001-0000-C000-000000000046}"
insert1 :: Prelude.String -> ICharacters a -> Prelude.IO ()
insert1 string =
  Automation.method0 "Insert" [Automation.inString string]
getPhoneticCharacters :: ICharacters a -> Prelude.IO (Prelude.String)
getPhoneticCharacters =
  Automation.propertyGet "PhoneticCharacters" [] Automation.outString
setPhoneticCharacters :: Prelude.String -> ICharacters a -> Prelude.IO ()
setPhoneticCharacters rHS =
  Automation.propertySet "PhoneticCharacters" [Automation.inString rHS]
-- --------------------------------------------------
-- 
-- interface IDialogs
-- 
-- --------------------------------------------------
data Dialogs a = Dialogs
                  
type IDialogs a = Automation.IDispatch (Dialogs a)
iidIDialogs :: Com.IID (IDialogs Automation.Interface)
iidIDialogs = Com.mkIID "{00020879-0001-0000-C000-000000000046}"
getItem17 :: (Automation.Variant a0) => a0 -> IDialogs a -> Prelude.IO (IDialog Automation.Interface)
getItem17 index =
  Automation.propertyGet "Item" [Automation.inVariant index] Automation.outIDispatch
getDefault27 :: (Automation.Variant a0) => a0 -> IDialogs a -> Prelude.IO (IDialog Automation.Interface)
getDefault27 index =
  Automation.propertyGet "_Default" [Automation.inVariant index] Automation.outIDispatch
-- --------------------------------------------------
-- 
-- interface IDialog
-- 
-- --------------------------------------------------
data Dialog a = Dialog
                 
type IDialog a = Automation.IDispatch (Dialog a)
iidIDialog :: Com.IID (IDialog Automation.Interface)
iidIDialog = Com.mkIID "{0002087A-0001-0000-C000-000000000046}"
show0 :: Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Automation.IDispatch a -> Prelude.IO (Prelude.Int)
show0 arg1 arg2 arg3 arg4 arg5 arg6 arg7 arg8 arg9 arg10 arg11 arg12 arg13 arg14 arg15 arg16 arg17 arg18 arg19 arg20 arg21 arg22 arg23 arg24 arg25 arg26 arg27 arg28 arg29 arg30 =
  Automation.function1 "Show" [Automation.inInt arg1, Automation.inInt arg2, Automation.inInt arg3, Automation.inInt arg4, Automation.inInt arg5, Automation.inInt arg6, Automation.inInt arg7, Automation.inInt arg8, Automation.inInt arg9, Automation.inInt arg10, Automation.inInt arg11, Automation.inInt arg12, Automation.inInt arg13, Automation.inInt arg14, Automation.inInt arg15, Automation.inInt arg16, Automation.inInt arg17, Automation.inInt arg18, Automation.inInt arg19, Automation.inInt arg20, Automation.inInt arg21, Automation.inInt arg22, Automation.inInt arg23, Automation.inInt arg24, Automation.inInt arg25, Automation.inInt arg26, Automation.inInt arg27, Automation.inInt arg28, Automation.inInt arg29, Automation.inInt arg30] Automation.outInt
-- --------------------------------------------------
-- 
-- interface ISoundNote
-- 
-- --------------------------------------------------
data SoundNote a = SoundNote
                    
type ISoundNote a = Automation.IDispatch (SoundNote a)
iidISoundNote :: Com.IID (ISoundNote Automation.Interface)
iidISoundNote = Com.mkIID "{0002087B-0001-0000-C000-000000000046}"
import0 :: Prelude.String -> ISoundNote a -> Prelude.IO ()
import0 filename =
  Automation.method0 "Import" [Automation.inString filename]
play :: ISoundNote a -> Prelude.IO ()
play = Automation.method0 "Play" []
record :: ISoundNote a -> Prelude.IO ()
record = Automation.method0 "Record" []
-- --------------------------------------------------
-- 
-- interface IButton
-- 
-- --------------------------------------------------
data Button a = Button
                 
type IButton a = Automation.IDispatch (Button a)
iidIButton :: Com.IID (IButton Automation.Interface)
iidIButton = Com.mkIID "{0002087D-0001-0000-C000-000000000046}"
getBottomRightCell :: Automation.IDispatch a -> Prelude.IO (IRange Automation.Interface)
getBottomRightCell =
  Automation.propertyGet "BottomRightCell" [] Automation.outIDispatch
getTopLeftCell :: Automation.IDispatch a -> Prelude.IO (IRange Automation.Interface)
getTopLeftCell =
  Automation.propertyGet "TopLeftCell" [] Automation.outIDispatch
getAutoScaleFont :: Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getAutoScaleFont =
  Automation.propertyGet "AutoScaleFont" [] Automation.outInt
setAutoScaleFont :: Prelude.Int -> Automation.IDispatch a -> Prelude.IO ()
setAutoScaleFont rHS =
  Automation.propertySet "AutoScaleFont" [Automation.inInt rHS]
-- --------------------------------------------------
-- 
-- interface IButtons
-- 
-- --------------------------------------------------
data Buttons a = Buttons
                  
type IButtons a = Automation.IDispatch (Buttons a)
iidIButtons :: Com.IID (IButtons Automation.Interface)
iidIButtons = Com.mkIID "{0002087E-0001-0000-C000-000000000046}"
add16 :: Prelude.Double -> Prelude.Double -> Prelude.Double -> Prelude.Double -> IButtons a -> Prelude.IO (IButton Automation.Interface)
add16 left top width height =
  Automation.function1 "Add" [Automation.inDouble left, Automation.inDouble top, Automation.inDouble width, Automation.inDouble height] Automation.outIDispatch
-- --------------------------------------------------
-- 
-- interface ICheckBox
-- 
-- --------------------------------------------------
data CheckBox a = CheckBox
                   
type ICheckBox a = Automation.IDispatch (CheckBox a)
iidICheckBox :: Com.IID (ICheckBox Automation.Interface)
iidICheckBox = Com.mkIID "{0002087F-0001-0000-C000-000000000046}"
-- --------------------------------------------------
-- 
-- interface ICheckBoxes
-- 
-- --------------------------------------------------
data CheckBoxes a = CheckBoxes
                     
type ICheckBoxes a = Automation.IDispatch (CheckBoxes a)
iidICheckBoxes :: Com.IID (ICheckBoxes Automation.Interface)
iidICheckBoxes = Com.mkIID "{00020880-0001-0000-C000-000000000046}"
add17 :: Prelude.Double -> Prelude.Double -> Prelude.Double -> Prelude.Double -> ICheckBoxes a -> Prelude.IO (ICheckBox Automation.Interface)
add17 left top width height =
  Automation.function1 "Add" [Automation.inDouble left, Automation.inDouble top, Automation.inDouble width, Automation.inDouble height] Automation.outIDispatch
-- --------------------------------------------------
-- 
-- interface IOptionButton
-- 
-- --------------------------------------------------
data OptionButton a = OptionButton
                       
type IOptionButton a = Automation.IDispatch (OptionButton a)
iidIOptionButton :: Com.IID (IOptionButton Automation.Interface)
iidIOptionButton =
  Com.mkIID "{00020881-0001-0000-C000-000000000046}"
getGroupBox :: Automation.IDispatch a -> Prelude.IO (IGroupBox Automation.Interface)
getGroupBox =
  Automation.propertyGet "GroupBox" [] Automation.outIDispatch
-- --------------------------------------------------
-- 
-- interface IOptionButtons
-- 
-- --------------------------------------------------
data OptionButtons a = OptionButtons
                        
type IOptionButtons a = Automation.IDispatch (OptionButtons a)
iidIOptionButtons :: Com.IID (IOptionButtons Automation.Interface)
iidIOptionButtons =
  Com.mkIID "{00020882-0001-0000-C000-000000000046}"
add18 :: Prelude.Double -> Prelude.Double -> Prelude.Double -> Prelude.Double -> IOptionButtons a -> Prelude.IO (IOptionButton Automation.Interface)
add18 left top width height =
  Automation.function1 "Add" [Automation.inDouble left, Automation.inDouble top, Automation.inDouble width, Automation.inDouble height] Automation.outIDispatch
-- --------------------------------------------------
-- 
-- interface IEditBox
-- 
-- --------------------------------------------------
data EditBox a = EditBox
                  
type IEditBox a = Automation.IDispatch (EditBox a)
iidIEditBox :: Com.IID (IEditBox Automation.Interface)
iidIEditBox = Com.mkIID "{00020883-0001-0000-C000-000000000046}"
getLinkedObject :: IEditBox a -> Prelude.IO (Prelude.String)
getLinkedObject =
  Automation.propertyGet "LinkedObject" [] Automation.outString
getPasswordEdit :: Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getPasswordEdit =
  Automation.propertyGet "PasswordEdit" [] Automation.outInt
setPasswordEdit :: Prelude.Int -> Automation.IDispatch a -> Prelude.IO ()
setPasswordEdit rHS =
  Automation.propertySet "PasswordEdit" [Automation.inInt rHS]
-- --------------------------------------------------
-- 
-- interface IEditBoxes
-- 
-- --------------------------------------------------
data EditBoxes a = EditBoxes
                    
type IEditBoxes a = Automation.IDispatch (EditBoxes a)
iidIEditBoxes :: Com.IID (IEditBoxes Automation.Interface)
iidIEditBoxes = Com.mkIID "{00020884-0001-0000-C000-000000000046}"
dummy340 :: Automation.IDispatch a -> Prelude.IO ()
dummy340 = Automation.method0 "_Dummy34" []
add19 :: Prelude.Double -> Prelude.Double -> Prelude.Double -> Prelude.Double -> IEditBoxes a -> Prelude.IO (IEditBox Automation.Interface)
add19 left top width height =
  Automation.function1 "Add" [Automation.inDouble left, Automation.inDouble top, Automation.inDouble width, Automation.inDouble height] Automation.outIDispatch
item11 :: Prelude.Int -> IEditBoxes a -> Prelude.IO (Prelude.Int)
item11 index =
  Automation.function1 "Item" [Automation.inInt index] Automation.outInt
-- --------------------------------------------------
-- 
-- interface IScrollBar
-- 
-- --------------------------------------------------
data ScrollBar a = ScrollBar
                    
type IScrollBar a = Automation.IDispatch (ScrollBar a)
iidIScrollBar :: Com.IID (IScrollBar Automation.Interface)
iidIScrollBar = Com.mkIID "{00020885-0001-0000-C000-000000000046}"
-- --------------------------------------------------
-- 
-- interface IScrollBars
-- 
-- --------------------------------------------------
data ScrollBars a = ScrollBars
                     
type IScrollBars a = Automation.IDispatch (ScrollBars a)
iidIScrollBars :: Com.IID (IScrollBars Automation.Interface)
iidIScrollBars = Com.mkIID "{00020886-0001-0000-C000-000000000046}"
add20 :: Prelude.Double -> Prelude.Double -> Prelude.Double -> Prelude.Double -> IScrollBars a -> Prelude.IO (IScrollBar Automation.Interface)
add20 left top width height =
  Automation.function1 "Add" [Automation.inDouble left, Automation.inDouble top, Automation.inDouble width, Automation.inDouble height] Automation.outIDispatch
-- --------------------------------------------------
-- 
-- interface IListBox
-- 
-- --------------------------------------------------
data ListBox a = ListBox
                  
type IListBox a = Automation.IDispatch (ListBox a)
iidIListBox :: Com.IID (IListBox Automation.Interface)
iidIListBox = Com.mkIID "{00020887-0001-0000-C000-000000000046}"
getLinkedObject0 :: Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getLinkedObject0 =
  Automation.propertyGet "LinkedObject" [] Automation.outInt
getListCount :: Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getListCount =
  Automation.propertyGet "ListCount" [] Automation.outInt
getMultiSelect0 :: Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getMultiSelect0 =
  Automation.propertyGet "MultiSelect" [] Automation.outInt
setMultiSelect0 :: Prelude.Int -> Automation.IDispatch a -> Prelude.IO ()
setMultiSelect0 rHS =
  Automation.propertySet "MultiSelect" [Automation.inInt rHS]
-- --------------------------------------------------
-- 
-- interface IListBoxes
-- 
-- --------------------------------------------------
data ListBoxes a = ListBoxes
                    
type IListBoxes a = Automation.IDispatch (ListBoxes a)
iidIListBoxes :: Com.IID (IListBoxes Automation.Interface)
iidIListBoxes = Com.mkIID "{00020888-0001-0000-C000-000000000046}"
dummy310 :: Automation.IDispatch a -> Prelude.IO ()
dummy310 = Automation.method0 "_Dummy31" []
dummy330 :: Automation.IDispatch a -> Prelude.IO ()
dummy330 = Automation.method0 "_Dummy33" []
add21 :: Prelude.Double -> Prelude.Double -> Prelude.Double -> Prelude.Double -> IListBoxes a -> Prelude.IO (IListBox Automation.Interface)
add21 left top width height =
  Automation.function1 "Add" [Automation.inDouble left, Automation.inDouble top, Automation.inDouble width, Automation.inDouble height] Automation.outIDispatch
-- --------------------------------------------------
-- 
-- interface IGroupBox
-- 
-- --------------------------------------------------
data GroupBox a = GroupBox
                   
type IGroupBox a = Automation.IDispatch (GroupBox a)
iidIGroupBox :: Com.IID (IGroupBox Automation.Interface)
iidIGroupBox = Com.mkIID "{00020889-0001-0000-C000-000000000046}"
-- --------------------------------------------------
-- 
-- interface IGroupBoxes
-- 
-- --------------------------------------------------
data GroupBoxes a = GroupBoxes
                     
type IGroupBoxes a = Automation.IDispatch (GroupBoxes a)
iidIGroupBoxes :: Com.IID (IGroupBoxes Automation.Interface)
iidIGroupBoxes = Com.mkIID "{0002088A-0001-0000-C000-000000000046}"
add22 :: Prelude.Double -> Prelude.Double -> Prelude.Double -> Prelude.Double -> IGroupBoxes a -> Prelude.IO (IGroupBox Automation.Interface)
add22 left top width height =
  Automation.function1 "Add" [Automation.inDouble left, Automation.inDouble top, Automation.inDouble width, Automation.inDouble height] Automation.outIDispatch
-- --------------------------------------------------
-- 
-- interface IDropDown
-- 
-- --------------------------------------------------
data DropDown a = DropDown
                   
type IDropDown a = Automation.IDispatch (DropDown a)
iidIDropDown :: Com.IID (IDropDown Automation.Interface)
iidIDropDown = Com.mkIID "{0002088B-0001-0000-C000-000000000046}"
dummy360 :: Automation.IDispatch a -> Prelude.IO ()
dummy360 = Automation.method0 "_Dummy36" []
-- --------------------------------------------------
-- 
-- interface IDropDowns
-- 
-- --------------------------------------------------
data DropDowns a = DropDowns
                    
type IDropDowns a = Automation.IDispatch (DropDowns a)
iidIDropDowns :: Com.IID (IDropDowns Automation.Interface)
iidIDropDowns = Com.mkIID "{0002088C-0001-0000-C000-000000000046}"
add23 :: Prelude.Double -> Prelude.Double -> Prelude.Double -> Prelude.Double -> Prelude.Int -> IDropDowns a -> Prelude.IO (IDropDown Automation.Interface)
add23 left top width height editable =
  Automation.function1 "Add" [Automation.inDouble left, Automation.inDouble top, Automation.inDouble width, Automation.inDouble height, Automation.inInt editable] Automation.outIDispatch
-- --------------------------------------------------
-- 
-- interface ISpinner
-- 
-- --------------------------------------------------
data Spinner a = Spinner
                  
type ISpinner a = Automation.IDispatch (Spinner a)
iidISpinner :: Com.IID (ISpinner Automation.Interface)
iidISpinner = Com.mkIID "{0002088D-0001-0000-C000-000000000046}"
-- --------------------------------------------------
-- 
-- interface ISpinners
-- 
-- --------------------------------------------------
data Spinners a = Spinners
                   
type ISpinners a = Automation.IDispatch (Spinners a)
iidISpinners :: Com.IID (ISpinners Automation.Interface)
iidISpinners = Com.mkIID "{0002088E-0001-0000-C000-000000000046}"
add24 :: Prelude.Double -> Prelude.Double -> Prelude.Double -> Prelude.Double -> ISpinners a -> Prelude.IO (ISpinner Automation.Interface)
add24 left top width height =
  Automation.function1 "Add" [Automation.inDouble left, Automation.inDouble top, Automation.inDouble width, Automation.inDouble height] Automation.outIDispatch
-- --------------------------------------------------
-- 
-- interface IDialogFrame
-- 
-- --------------------------------------------------
data DialogFrame a = DialogFrame
                      
type IDialogFrame a = Automation.IDispatch (DialogFrame a)
iidIDialogFrame :: Com.IID (IDialogFrame Automation.Interface)
iidIDialogFrame =
  Com.mkIID "{0002088F-0001-0000-C000-000000000046}"
dummy40 :: IDialogFrame a -> Prelude.IO ()
dummy40 = Automation.method0 "_Dummy4" []
dummy50 :: IDialogFrame a -> Prelude.IO ()
dummy50 = Automation.method0 "_Dummy5" []
dummy80 :: IDialogFrame a -> Prelude.IO ()
dummy80 = Automation.method0 "_Dummy8" []
dummy90 :: Automation.IDispatch a -> Prelude.IO ()
dummy90 = Automation.method0 "_Dummy9" []
dummy100 :: Automation.IDispatch a -> Prelude.IO ()
dummy100 = Automation.method0 "_Dummy10" []
dummy17 :: Automation.IDispatch a -> Prelude.IO ()
dummy17 = Automation.method0 "_Dummy17" []
dummy18 :: Automation.IDispatch a -> Prelude.IO ()
dummy18 = Automation.method0 "_Dummy18" []
dummy20 :: IDialogFrame a -> Prelude.IO ()
dummy20 = Automation.method0 "_Dummy20" []
dummy25 :: Automation.IDispatch a -> Prelude.IO ()
dummy25 = Automation.method0 "_Dummy25" []
-- --------------------------------------------------
-- 
-- interface ILabel
-- 
-- --------------------------------------------------
data Label a = Label
                
type ILabel a = Automation.IDispatch (Label a)
iidILabel :: Com.IID (ILabel Automation.Interface)
iidILabel = Com.mkIID "{00020890-0001-0000-C000-000000000046}"
-- --------------------------------------------------
-- 
-- interface ILabels
-- 
-- --------------------------------------------------
data Labels a = Labels
                 
type ILabels a = Automation.IDispatch (Labels a)
iidILabels :: Com.IID (ILabels Automation.Interface)
iidILabels = Com.mkIID "{00020891-0001-0000-C000-000000000046}"
add25 :: Prelude.Double -> Prelude.Double -> Prelude.Double -> Prelude.Double -> ILabels a -> Prelude.IO (ILabel Automation.Interface)
add25 left top width height =
  Automation.function1 "Add" [Automation.inDouble left, Automation.inDouble top, Automation.inDouble width, Automation.inDouble height] Automation.outIDispatch
-- --------------------------------------------------
-- 
-- interface IPanes
-- 
-- --------------------------------------------------
data Panes a = Panes
                
type IPanes a = Automation.IDispatch (Panes a)
iidIPanes :: Com.IID (IPanes Automation.Interface)
iidIPanes = Com.mkIID "{00020894-0001-0000-C000-000000000046}"
getItem18 :: Prelude.Int -> IPanes a -> Prelude.IO (IPane Automation.Interface)
getItem18 index =
  Automation.propertyGet "Item" [Automation.inInt index] Automation.outIDispatch
getDefault40 :: Prelude.Int -> IPanes a -> Prelude.IO (IPane Automation.Interface)
getDefault40 index =
  Automation.propertyGet "_Default" [Automation.inInt index] Automation.outIDispatch
-- --------------------------------------------------
-- 
-- interface IPane
-- 
-- --------------------------------------------------
data Pane a = Pane
               
type IPane a = Automation.IDispatch (Pane a)
iidIPane :: Com.IID (IPane Automation.Interface)
iidIPane = Com.mkIID "{00020895-0001-0000-C000-000000000046}"
-- --------------------------------------------------
-- 
-- interface IScenarios
-- 
-- --------------------------------------------------
data Scenarios a = Scenarios
                    
type IScenarios a = Automation.IDispatch (Scenarios a)
iidIScenarios :: Com.IID (IScenarios Automation.Interface)
iidIScenarios = Com.mkIID "{00020896-0001-0000-C000-000000000046}"
add26 :: Prelude.String -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> IScenarios a -> Prelude.IO (IScenario Automation.Interface)
add26 name changingCells values comment locked hidden =
  Automation.function1 "Add" [Automation.inString name, Automation.inInt changingCells, Automation.inInt values, Automation.inInt comment, Automation.inInt locked, Automation.inInt hidden] Automation.outIDispatch
createSummary :: (Automation.Variant a0) => a0 -> Prelude.Int -> IScenarios a -> Prelude.IO ()
createSummary reportType resultCells =
  Automation.method0 "CreateSummary" [Automation.inVariant reportType, Automation.inInt resultCells]
item18 :: Prelude.Int -> IScenarios a -> Prelude.IO (IScenario Automation.Interface)
item18 index =
  Automation.function1 "Item" [Automation.inInt index] Automation.outIDispatch
-- --------------------------------------------------
-- 
-- interface IScenario
-- 
-- --------------------------------------------------
data Scenario a = Scenario
                   
type IScenario a = Automation.IDispatch (Scenario a)
iidIScenario :: Com.IID (IScenario Automation.Interface)
iidIScenario = Com.mkIID "{00020897-0001-0000-C000-000000000046}"
changeScenario :: Prelude.Int -> Prelude.Int -> IScenario a -> Prelude.IO ()
changeScenario changingCells values =
  Automation.method0 "ChangeScenario" [Automation.inInt changingCells, Automation.inInt values]
getChangingCells :: IScenario a -> Prelude.IO (IRange Automation.Interface)
getChangingCells =
  Automation.propertyGet "ChangingCells" [] Automation.outIDispatch
getComment0 :: IScenario a -> Prelude.IO (Prelude.String)
getComment0 =
  Automation.propertyGet "Comment" [] Automation.outString
setComment :: Prelude.String -> IScenario a -> Prelude.IO ()
setComment rHS =
  Automation.propertySet "Comment" [Automation.inString rHS]
getHidden0 :: IScenario a -> Prelude.IO (Prelude.Int)
getHidden0 = Automation.propertyGet "Hidden" [] Automation.outInt
setHidden0 :: Prelude.Int -> IScenario a -> Prelude.IO ()
setHidden0 rHS =
  Automation.propertySet "Hidden" [Automation.inInt rHS]
getValues :: Prelude.Int -> IScenario a -> Prelude.IO (Prelude.Int)
getValues index =
  Automation.propertyGet "Values" [Automation.inInt index] Automation.outInt
-- --------------------------------------------------
-- 
-- interface IGroupObject
-- 
-- --------------------------------------------------
data GroupObject a = GroupObject
                      
type IGroupObject a = Automation.IDispatch (GroupObject a)
iidIGroupObject :: Com.IID (IGroupObject Automation.Interface)
iidIGroupObject =
  Com.mkIID "{00020898-0001-0000-C000-000000000046}"
dummy27 :: Automation.IDispatch a -> Prelude.IO ()
dummy27 = Automation.method0 "_Dummy27" []
dummy300 :: Automation.IDispatch a -> Prelude.IO ()
dummy300 = Automation.method0 "_Dummy30" []
dummy370 :: Automation.IDispatch a -> Prelude.IO ()
dummy370 = Automation.method0 "_Dummy37" []
dummy380 :: Automation.IDispatch a -> Prelude.IO ()
dummy380 = Automation.method0 "_Dummy38" []
dummy41 :: Automation.IDispatch a -> Prelude.IO ()
dummy41 = Automation.method0 "_Dummy41" []
dummy42 :: Automation.IDispatch a -> Prelude.IO ()
dummy42 = Automation.method0 "_Dummy42" []
dummy43 :: Automation.IDispatch a -> Prelude.IO ()
dummy43 = Automation.method0 "_Dummy43" []
dummy44 :: Automation.IDispatch a -> Prelude.IO ()
dummy44 = Automation.method0 "_Dummy44" []
dummy45 :: Automation.IDispatch a -> Prelude.IO ()
dummy45 = Automation.method0 "_Dummy45" []
dummy48 :: Automation.IDispatch a -> Prelude.IO ()
dummy48 = Automation.method0 "_Dummy48" []
dummy500 :: Automation.IDispatch a -> Prelude.IO ()
dummy500 = Automation.method0 "_Dummy50" []
dummy52 :: Automation.IDispatch a -> Prelude.IO ()
dummy52 = Automation.method0 "_Dummy52" []
dummy53 :: Automation.IDispatch a -> Prelude.IO ()
dummy53 = Automation.method0 "_Dummy53" []
dummy55 :: Automation.IDispatch a -> Prelude.IO ()
dummy55 = Automation.method0 "_Dummy55" []
dummy57 :: Automation.IDispatch a -> Prelude.IO ()
dummy57 = Automation.method0 "_Dummy57" []
dummy58 :: Automation.IDispatch a -> Prelude.IO ()
dummy58 = Automation.method0 "_Dummy58" []
dummy59 :: Automation.IDispatch a -> Prelude.IO ()
dummy59 = Automation.method0 "_Dummy59" []
dummy60 :: Automation.IDispatch a -> Prelude.IO ()
dummy60 = Automation.method0 "_Dummy60" []
dummy61 :: Automation.IDispatch a -> Prelude.IO ()
dummy61 = Automation.method0 "_Dummy61" []
dummy62 :: Automation.IDispatch a -> Prelude.IO ()
dummy62 = Automation.method0 "_Dummy62" []
dummy63 :: Automation.IDispatch a -> Prelude.IO ()
dummy63 = Automation.method0 "_Dummy63" []
dummy65 :: Automation.IDispatch a -> Prelude.IO ()
dummy65 = Automation.method0 "_Dummy65" []
dummy66 :: Automation.IDispatch a -> Prelude.IO ()
dummy66 = Automation.method0 "_Dummy66" []
dummy67 :: Automation.IDispatch a -> Prelude.IO ()
dummy67 = Automation.method0 "_Dummy67" []
dummy68 :: Automation.IDispatch a -> Prelude.IO ()
dummy68 = Automation.method0 "_Dummy68" []
dummy700 :: Automation.IDispatch a -> Prelude.IO ()
dummy700 = Automation.method0 "_Dummy70" []
dummy72 :: Automation.IDispatch a -> Prelude.IO ()
dummy72 = Automation.method0 "_Dummy72" []
dummy73 :: Automation.IDispatch a -> Prelude.IO ()
dummy73 = Automation.method0 "_Dummy73" []
dummy75 :: Automation.IDispatch a -> Prelude.IO ()
dummy75 = Automation.method0 "_Dummy75" []
dummy77 :: Automation.IDispatch a -> Prelude.IO ()
dummy77 = Automation.method0 "_Dummy77" []
-- --------------------------------------------------
-- 
-- interface IGroupObjects
-- 
-- --------------------------------------------------
data GroupObjects a = GroupObjects
                       
type IGroupObjects a = Automation.IDispatch (GroupObjects a)
iidIGroupObjects :: Com.IID (IGroupObjects Automation.Interface)
iidIGroupObjects =
  Com.mkIID "{00020899-0001-0000-C000-000000000046}"
-- --------------------------------------------------
-- 
-- interface ILine
-- 
-- --------------------------------------------------
data Line a = Line
               
type ILine a = Automation.IDispatch (Line a)
iidILine :: Com.IID (ILine Automation.Interface)
iidILine = Com.mkIID "{0002089A-0001-0000-C000-000000000046}"
-- --------------------------------------------------
-- 
-- interface ILines
-- 
-- --------------------------------------------------
data Lines a = Lines
                
type ILines a = Automation.IDispatch (Lines a)
iidILines :: Com.IID (ILines Automation.Interface)
iidILines = Com.mkIID "{0002089B-0001-0000-C000-000000000046}"
add27 :: Prelude.Double -> Prelude.Double -> Prelude.Double -> Prelude.Double -> ILines a -> Prelude.IO (ILine Automation.Interface)
add27 x1 y1 x2 y2 =
  Automation.function1 "Add" [Automation.inDouble x1, Automation.inDouble y1, Automation.inDouble x2, Automation.inDouble y2] Automation.outIDispatch
-- --------------------------------------------------
-- 
-- interface IRectangle
-- 
-- --------------------------------------------------
data Rectangle a = Rectangle
                    
type IRectangle a = Automation.IDispatch (Rectangle a)
iidIRectangle :: Com.IID (IRectangle Automation.Interface)
iidIRectangle = Com.mkIID "{0002089C-0001-0000-C000-000000000046}"
-- --------------------------------------------------
-- 
-- interface IRectangles
-- 
-- --------------------------------------------------
data Rectangles a = Rectangles
                     
type IRectangles a = Automation.IDispatch (Rectangles a)
iidIRectangles :: Com.IID (IRectangles Automation.Interface)
iidIRectangles = Com.mkIID "{0002089D-0001-0000-C000-000000000046}"
add28 :: Prelude.Double -> Prelude.Double -> Prelude.Double -> Prelude.Double -> IRectangles a -> Prelude.IO (IRectangle Automation.Interface)
add28 left top width height =
  Automation.function1 "Add" [Automation.inDouble left, Automation.inDouble top, Automation.inDouble width, Automation.inDouble height] Automation.outIDispatch
-- --------------------------------------------------
-- 
-- interface IOval
-- 
-- --------------------------------------------------
data Oval a = Oval
               
type IOval a = Automation.IDispatch (Oval a)
iidIOval :: Com.IID (IOval Automation.Interface)
iidIOval = Com.mkIID "{0002089E-0001-0000-C000-000000000046}"
-- --------------------------------------------------
-- 
-- interface IOvals
-- 
-- --------------------------------------------------
data Ovals a = Ovals
                
type IOvals a = Automation.IDispatch (Ovals a)
iidIOvals :: Com.IID (IOvals Automation.Interface)
iidIOvals = Com.mkIID "{0002089F-0001-0000-C000-000000000046}"
add29 :: Prelude.Double -> Prelude.Double -> Prelude.Double -> Prelude.Double -> IOvals a -> Prelude.IO (IOval Automation.Interface)
add29 left top width height =
  Automation.function1 "Add" [Automation.inDouble left, Automation.inDouble top, Automation.inDouble width, Automation.inDouble height] Automation.outIDispatch
-- --------------------------------------------------
-- 
-- interface IArc
-- 
-- --------------------------------------------------
data Arc a = Arc
              
type IArc a = Automation.IDispatch (Arc a)
iidIArc :: Com.IID (IArc Automation.Interface)
iidIArc = Com.mkIID "{000208A0-0001-0000-C000-000000000046}"
-- --------------------------------------------------
-- 
-- interface IArcs
-- 
-- --------------------------------------------------
data Arcs a = Arcs
               
type IArcs a = Automation.IDispatch (Arcs a)
iidIArcs :: Com.IID (IArcs Automation.Interface)
iidIArcs = Com.mkIID "{000208A1-0001-0000-C000-000000000046}"
add30 :: Prelude.Double -> Prelude.Double -> Prelude.Double -> Prelude.Double -> IArcs a -> Prelude.IO (IArc Automation.Interface)
add30 x1 y1 x2 y2 =
  Automation.function1 "Add" [Automation.inDouble x1, Automation.inDouble y1, Automation.inDouble x2, Automation.inDouble y2] Automation.outIDispatch
-- --------------------------------------------------
-- 
-- interface IOLEObjectEvents
-- 
-- --------------------------------------------------
data OLEObjectEvents a = OLEObjectEvents
                          
type IOLEObjectEvents a = Automation.IDispatch (OLEObjectEvents a)
iidIOLEObjectEvents :: Com.IID (IOLEObjectEvents Automation.Interface)
iidIOLEObjectEvents =
  Com.mkIID "{00024410-0001-0000-C000-000000000046}"
gotFocus :: IOLEObjectEvents a -> Prelude.IO ()
gotFocus = Automation.method0 "GotFocus" []
lostFocus :: IOLEObjectEvents a -> Prelude.IO ()
lostFocus = Automation.method0 "LostFocus" []
-- --------------------------------------------------
-- 
-- interface IOLEObject
-- 
-- --------------------------------------------------
data OLEObject a = OLEObject
                    
type IOLEObject a = Automation.IDispatch (OLEObject a)
iidIOLEObject :: Com.IID (IOLEObject Automation.Interface)
iidIOLEObject = Com.mkIID "{000208A2-0001-0000-C000-000000000046}"
getAutoLoad :: Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getAutoLoad =
  Automation.propertyGet "AutoLoad" [] Automation.outInt
setAutoLoad :: Prelude.Int -> Automation.IDispatch a -> Prelude.IO ()
setAutoLoad rHS =
  Automation.propertySet "AutoLoad" [Automation.inInt rHS]
getAutoUpdate :: Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getAutoUpdate =
  Automation.propertyGet "AutoUpdate" [] Automation.outInt
setAutoUpdate :: Prelude.Int -> Automation.IDispatch a -> Prelude.IO ()
setAutoUpdate rHS =
  Automation.propertySet "AutoUpdate" [Automation.inInt rHS]
getObject :: Automation.IDispatch a -> Prelude.IO (Automation.IDispatch Automation.Interface)
getObject =
  Automation.propertyGet "Object" [] Automation.outIDispatch
getOLEType :: IOLEObject a -> Prelude.IO (Prelude.Int)
getOLEType = Automation.propertyGet "OLEType" [] Automation.outInt
setSourceName :: Prelude.String -> Automation.IDispatch a -> Prelude.IO ()
setSourceName rHS =
  Automation.propertySet "SourceName" [Automation.inString rHS]
verb :: (Automation.Variant a0) => a0 -> IOLEObject a -> Prelude.IO ()
verb verb = Automation.method0 "Verb" [Automation.inVariant verb]
getProgId :: Automation.IDispatch a -> Prelude.IO (Prelude.String)
getProgId = Automation.propertyGet "ProgId" [] Automation.outString
-- --------------------------------------------------
-- 
-- interface IOLEObjects
-- 
-- --------------------------------------------------
data OLEObjects a = OLEObjects
                     
type IOLEObjects a = Automation.IDispatch (OLEObjects a)
iidIOLEObjects :: Com.IID (IOLEObjects Automation.Interface)
iidIOLEObjects = Com.mkIID "{000208A3-0001-0000-C000-000000000046}"
dummy320 :: Automation.IDispatch a -> Prelude.IO ()
dummy320 = Automation.method0 "_Dummy32" []
dummy390 :: IOLEObjects a -> Prelude.IO ()
dummy390 = Automation.method0 "_Dummy39" []
dummy400 :: Automation.IDispatch a -> Prelude.IO ()
dummy400 = Automation.method0 "_Dummy40" []
add31 :: Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> IOLEObjects a -> Prelude.IO (IOLEObject Automation.Interface)
add31 classType filename link displayAsIcon iconFileName iconIndex iconLabel left top width height =
  Automation.function1 "Add" [Automation.inInt classType, Automation.inInt filename, Automation.inInt link, Automation.inInt displayAsIcon, Automation.inInt iconFileName, Automation.inInt iconIndex, Automation.inInt iconLabel, Automation.inInt left, Automation.inInt top, Automation.inInt width, Automation.inInt height] Automation.outIDispatch
-- --------------------------------------------------
-- 
-- interface ITextBox
-- 
-- --------------------------------------------------
data TextBox a = TextBox
                  
type ITextBox a = Automation.IDispatch (TextBox a)
iidITextBox :: Com.IID (ITextBox Automation.Interface)
iidITextBox = Com.mkIID "{000208A4-0001-0000-C000-000000000046}"
-- --------------------------------------------------
-- 
-- interface ITextBoxes
-- 
-- --------------------------------------------------
data TextBoxes a = TextBoxes
                    
type ITextBoxes a = Automation.IDispatch (TextBoxes a)
iidITextBoxes :: Com.IID (ITextBoxes Automation.Interface)
iidITextBoxes = Com.mkIID "{000208A5-0001-0000-C000-000000000046}"
add32 :: Prelude.Double -> Prelude.Double -> Prelude.Double -> Prelude.Double -> ITextBoxes a -> Prelude.IO (ITextBox Automation.Interface)
add32 left top width height =
  Automation.function1 "Add" [Automation.inDouble left, Automation.inDouble top, Automation.inDouble width, Automation.inDouble height] Automation.outIDispatch
-- --------------------------------------------------
-- 
-- interface IPicture
-- 
-- --------------------------------------------------
data Picture a = Picture
                  
type IPicture a = Automation.IDispatch (Picture a)
iidIPicture :: Com.IID (IPicture Automation.Interface)
iidIPicture = Com.mkIID "{000208A6-0001-0000-C000-000000000046}"
-- --------------------------------------------------
-- 
-- interface IPictures
-- 
-- --------------------------------------------------
data Pictures a = Pictures
                   
type IPictures a = Automation.IDispatch (Pictures a)
iidIPictures :: Com.IID (IPictures Automation.Interface)
iidIPictures = Com.mkIID "{000208A7-0001-0000-C000-000000000046}"
add33 :: Prelude.Double -> Prelude.Double -> Prelude.Double -> Prelude.Double -> IPictures a -> Prelude.IO (IPicture Automation.Interface)
add33 left top width height =
  Automation.function1 "Add" [Automation.inDouble left, Automation.inDouble top, Automation.inDouble width, Automation.inDouble height] Automation.outIDispatch
insert2 :: Prelude.String -> Prelude.Int -> Automation.IDispatch a -> Prelude.IO (IPicture Automation.Interface)
insert2 filename converter =
  Automation.function1 "Insert" [Automation.inString filename, Automation.inInt converter] Automation.outIDispatch
paste1 :: Prelude.Int -> IPictures a -> Prelude.IO (IPicture Automation.Interface)
paste1 link =
  Automation.function1 "Paste" [Automation.inInt link] Automation.outIDispatch
-- --------------------------------------------------
-- 
-- interface IDrawing
-- 
-- --------------------------------------------------
data Drawing a = Drawing
                  
type IDrawing a = Automation.IDispatch (Drawing a)
iidIDrawing :: Com.IID (IDrawing Automation.Interface)
iidIDrawing = Com.mkIID "{000208A8-0001-0000-C000-000000000046}"
addVertex :: Prelude.Double -> Prelude.Double -> IDrawing a -> Prelude.IO ()
addVertex left top =
  Automation.method0 "AddVertex" [Automation.inDouble left, Automation.inDouble top]
reshape0 :: Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Automation.IDispatch a -> Prelude.IO ()
reshape0 vertex insert left top =
  Automation.method0 "Reshape" [Automation.inInt vertex, Automation.inInt insert, Automation.inInt left, Automation.inInt top]
-- --------------------------------------------------
-- 
-- interface IDrawings
-- 
-- --------------------------------------------------
data Drawings a = Drawings
                   
type IDrawings a = Automation.IDispatch (Drawings a)
iidIDrawings :: Com.IID (IDrawings Automation.Interface)
iidIDrawings = Com.mkIID "{000208A9-0001-0000-C000-000000000046}"
dummy46 :: IDrawings a -> Prelude.IO ()
dummy46 = Automation.method0 "_Dummy46" []
add34 :: Prelude.Double -> Prelude.Double -> Prelude.Double -> Prelude.Double -> Prelude.Int -> IDrawings a -> Prelude.IO (IDrawing Automation.Interface)
add34 x1 y1 x2 y2 closed =
  Automation.function1 "Add" [Automation.inDouble x1, Automation.inDouble y1, Automation.inDouble x2, Automation.inDouble y2, Automation.inInt closed] Automation.outIDispatch
-- --------------------------------------------------
-- 
-- interface IRoutingSlip
-- 
-- --------------------------------------------------
data RoutingSlip a = RoutingSlip
                      
type IRoutingSlip a = Automation.IDispatch (RoutingSlip a)
iidIRoutingSlip :: Com.IID (IRoutingSlip Automation.Interface)
iidIRoutingSlip =
  Com.mkIID "{000208AA-0001-0000-C000-000000000046}"
getDelivery :: (Automation.Variant a0) => IRoutingSlip a -> Prelude.IO (a0)
getDelivery =
  Automation.propertyGet "Delivery" [] Automation.outVariant
setDelivery :: (Automation.Variant a0) => a0 -> IRoutingSlip a -> Prelude.IO ()
setDelivery rHS =
  Automation.propertySet "Delivery" [Automation.inVariant rHS]
getMessage :: IRoutingSlip a -> Prelude.IO (Prelude.Int)
getMessage = Automation.propertyGet "Message" [] Automation.outInt
setMessage :: Prelude.Int -> IRoutingSlip a -> Prelude.IO ()
setMessage rHS =
  Automation.propertySet "Message" [Automation.inInt rHS]
recipients :: Prelude.Int -> IRoutingSlip a -> Prelude.IO (Prelude.Int)
recipients index =
  Automation.function1 "Recipients" [Automation.inInt index] Automation.outInt
getReturnWhenDone :: IRoutingSlip a -> Prelude.IO (Prelude.Int)
getReturnWhenDone =
  Automation.propertyGet "ReturnWhenDone" [] Automation.outInt
setReturnWhenDone :: Prelude.Int -> IRoutingSlip a -> Prelude.IO ()
setReturnWhenDone rHS =
  Automation.propertySet "ReturnWhenDone" [Automation.inInt rHS]
getStatus :: (Automation.Variant a0) => IRoutingSlip a -> Prelude.IO (a0)
getStatus =
  Automation.propertyGet "Status" [] Automation.outVariant
getSubject1 :: IRoutingSlip a -> Prelude.IO (Prelude.Int)
getSubject1 = Automation.propertyGet "Subject" [] Automation.outInt
setSubject0 :: Prelude.Int -> Automation.IDispatch a -> Prelude.IO ()
setSubject0 rHS =
  Automation.propertySet "Subject" [Automation.inInt rHS]
getTrackStatus :: IRoutingSlip a -> Prelude.IO (Prelude.Int)
getTrackStatus =
  Automation.propertyGet "TrackStatus" [] Automation.outInt
setTrackStatus :: Prelude.Int -> IRoutingSlip a -> Prelude.IO ()
setTrackStatus rHS =
  Automation.propertySet "TrackStatus" [Automation.inInt rHS]
-- --------------------------------------------------
-- 
-- interface IOutline
-- 
-- --------------------------------------------------
data Outline a = Outline
                  
type IOutline a = Automation.IDispatch (Outline a)
iidIOutline :: Com.IID (IOutline Automation.Interface)
iidIOutline = Com.mkIID "{000208AB-0001-0000-C000-000000000046}"
getAutomaticStyles :: IOutline a -> Prelude.IO (Prelude.Int)
getAutomaticStyles =
  Automation.propertyGet "AutomaticStyles" [] Automation.outInt
setAutomaticStyles :: Prelude.Int -> IOutline a -> Prelude.IO ()
setAutomaticStyles rHS =
  Automation.propertySet "AutomaticStyles" [Automation.inInt rHS]
showLevels :: Prelude.Int -> Prelude.Int -> IOutline a -> Prelude.IO ()
showLevels rowLevels columnLevels =
  Automation.method0 "ShowLevels" [Automation.inInt rowLevels, Automation.inInt columnLevels]
getSummaryColumn :: (Automation.Variant a0) => IOutline a -> Prelude.IO (a0)
getSummaryColumn =
  Automation.propertyGet "SummaryColumn" [] Automation.outVariant
setSummaryColumn :: (Automation.Variant a0) => a0 -> IOutline a -> Prelude.IO ()
setSummaryColumn rHS =
  Automation.propertySet "SummaryColumn" [Automation.inVariant rHS]
getSummaryRow :: (Automation.Variant a0) => IOutline a -> Prelude.IO (a0)
getSummaryRow =
  Automation.propertyGet "SummaryRow" [] Automation.outVariant
setSummaryRow :: (Automation.Variant a0) => a0 -> IOutline a -> Prelude.IO ()
setSummaryRow rHS =
  Automation.propertySet "SummaryRow" [Automation.inVariant rHS]
-- --------------------------------------------------
-- 
-- interface IModule
-- 
-- --------------------------------------------------
data Module a = Module
                 
type IModule a = Automation.IDispatch (Module a)
iidIModule :: Com.IID (IModule Automation.Interface)
iidIModule = Com.mkIID "{000208AD-0001-0000-C000-000000000046}"
dummy21 :: IModule a -> Prelude.IO ()
dummy21 = Automation.method0 "_Dummy21" []
insertFile :: Prelude.Int -> Prelude.Int -> IModule a -> Prelude.IO ()
insertFile filename merge =
  Automation.method0 "InsertFile" [Automation.inInt filename, Automation.inInt merge]
-- --------------------------------------------------
-- 
-- interface IModules
-- 
-- --------------------------------------------------
data Modules a = Modules
                  
type IModules a = Automation.IDispatch (Modules a)
iidIModules :: Com.IID (IModules Automation.Interface)
iidIModules = Com.mkIID "{000208AE-0001-0000-C000-000000000046}"
add35 :: Prelude.Int -> Prelude.Int -> Prelude.Int -> IModules a -> Prelude.IO (IModule Automation.Interface)
add35 before after count =
  Automation.function1 "Add" [Automation.inInt before, Automation.inInt after, Automation.inInt count] Automation.outIDispatch
-- --------------------------------------------------
-- 
-- interface IDialogSheet
-- 
-- --------------------------------------------------
data DialogSheet a = DialogSheet
                      
type IDialogSheet a = Automation.IDispatch (DialogSheet a)
iidIDialogSheet :: Com.IID (IDialogSheet Automation.Interface)
iidIDialogSheet =
  Com.mkIID "{000208AF-0001-0000-C000-000000000046}"
dummy29 :: Automation.IDispatch a -> Prelude.IO ()
dummy29 = Automation.method0 "_Dummy29" []
dummy69 :: IDialogSheet a -> Prelude.IO ()
dummy69 = Automation.method0 "_Dummy69" []
dummy740 :: IDialogSheet a -> Prelude.IO ()
dummy740 = Automation.method0 "_Dummy74" []
dummy76 :: IDialogSheet a -> Prelude.IO ()
dummy76 = Automation.method0 "_Dummy76" []
dummy78 :: IDialogSheet a -> Prelude.IO ()
dummy78 = Automation.method0 "_Dummy78" []
dummy79 :: IDialogSheet a -> Prelude.IO ()
dummy79 = Automation.method0 "_Dummy79" []
dummy82 :: IDialogSheet a -> Prelude.IO ()
dummy82 = Automation.method0 "_Dummy82" []
dummy83 :: IDialogSheet a -> Prelude.IO ()
dummy83 = Automation.method0 "_Dummy83" []
dummy85 :: IDialogSheet a -> Prelude.IO ()
dummy85 = Automation.method0 "_Dummy85" []
dummy86 :: IDialogSheet a -> Prelude.IO ()
dummy86 = Automation.method0 "_Dummy86" []
dummy88 :: IDialogSheet a -> Prelude.IO ()
dummy88 = Automation.method0 "_Dummy88" []
dummy89 :: IDialogSheet a -> Prelude.IO ()
dummy89 = Automation.method0 "_Dummy89" []
dummy900 :: IDialogSheet a -> Prelude.IO ()
dummy900 = Automation.method0 "_Dummy90" []
getDefaultButton2 :: IDialogSheet a -> Prelude.IO (Prelude.Int)
getDefaultButton2 =
  Automation.propertyGet "DefaultButton" [] Automation.outInt
setDefaultButton2 :: Prelude.Int -> IDialogSheet a -> Prelude.IO ()
setDefaultButton2 rHS =
  Automation.propertySet "DefaultButton" [Automation.inInt rHS]
getDialogFrame :: IDialogSheet a -> Prelude.IO (IDialogFrame Automation.Interface)
getDialogFrame =
  Automation.propertyGet "DialogFrame" [] Automation.outIDispatch
editBoxes :: Prelude.Int -> IDialogSheet a -> Prelude.IO (Automation.IDispatch Automation.Interface)
editBoxes index =
  Automation.function1 "EditBoxes" [Automation.inInt index] Automation.outIDispatch
getFocus :: IDialogSheet a -> Prelude.IO (Prelude.Int)
getFocus = Automation.propertyGet "Focus" [] Automation.outInt
setFocus :: Prelude.Int -> IDialogSheet a -> Prelude.IO ()
setFocus rHS =
  Automation.propertySet "Focus" [Automation.inInt rHS]
hide :: Prelude.Int -> IDialogSheet a -> Prelude.IO (Prelude.Int)
hide cancel =
  Automation.function1 "Hide" [Automation.inInt cancel] Automation.outInt
show2 :: Automation.IDispatch a -> Prelude.IO (Prelude.Int)
show2 = Automation.function1 "Show" [] Automation.outInt
-- --------------------------------------------------
-- 
-- interface IDialogSheets
-- 
-- --------------------------------------------------
data DialogSheets a = DialogSheets
                       
type IDialogSheets a = Automation.IDispatch (DialogSheets a)
iidIDialogSheets :: Com.IID (IDialogSheets Automation.Interface)
iidIDialogSheets =
  Com.mkIID "{000208B0-0001-0000-C000-000000000046}"
add36 :: Prelude.Int -> Prelude.Int -> Prelude.Int -> IDialogSheets a -> Prelude.IO (IDialogSheet Automation.Interface)
add36 before after count =
  Automation.function1 "Add" [Automation.inInt before, Automation.inInt after, Automation.inInt count] Automation.outIDispatch
-- --------------------------------------------------
-- 
-- interface IWorksheets
-- 
-- --------------------------------------------------
data Worksheets a = Worksheets
                     
type IWorksheets a = Automation.IDispatch (Worksheets a)
iidIWorksheets :: Com.IID (IWorksheets Automation.Interface)
iidIWorksheets = Com.mkIID "{000208B1-0001-0000-C000-000000000046}"
-- --------------------------------------------------
-- 
-- interface IPageSetup
-- 
-- --------------------------------------------------
data PageSetup a = PageSetup
                    
type IPageSetup a = Automation.IDispatch (PageSetup a)
iidIPageSetup :: Com.IID (IPageSetup Automation.Interface)
iidIPageSetup = Com.mkIID "{000208B4-0001-0000-C000-000000000046}"
getBlackAndWhite :: IPageSetup a -> Prelude.IO (Prelude.Int)
getBlackAndWhite =
  Automation.propertyGet "BlackAndWhite" [] Automation.outInt
setBlackAndWhite :: Prelude.Int -> IPageSetup a -> Prelude.IO ()
setBlackAndWhite rHS =
  Automation.propertySet "BlackAndWhite" [Automation.inInt rHS]
getBottomMargin :: IPageSetup a -> Prelude.IO (Prelude.Double)
getBottomMargin =
  Automation.propertyGet "BottomMargin" [] Automation.outDouble
setBottomMargin :: Prelude.Double -> IPageSetup a -> Prelude.IO ()
setBottomMargin rHS =
  Automation.propertySet "BottomMargin" [Automation.inDouble rHS]
getCenterFooter :: IPageSetup a -> Prelude.IO (Prelude.String)
getCenterFooter =
  Automation.propertyGet "CenterFooter" [] Automation.outString
setCenterFooter :: Prelude.String -> IPageSetup a -> Prelude.IO ()
setCenterFooter rHS =
  Automation.propertySet "CenterFooter" [Automation.inString rHS]
getCenterHeader :: IPageSetup a -> Prelude.IO (Prelude.String)
getCenterHeader =
  Automation.propertyGet "CenterHeader" [] Automation.outString
setCenterHeader :: Prelude.String -> IPageSetup a -> Prelude.IO ()
setCenterHeader rHS =
  Automation.propertySet "CenterHeader" [Automation.inString rHS]
getCenterHorizontally :: IPageSetup a -> Prelude.IO (Prelude.Int)
getCenterHorizontally =
  Automation.propertyGet "CenterHorizontally" [] Automation.outInt
setCenterHorizontally :: Prelude.Int -> IPageSetup a -> Prelude.IO ()
setCenterHorizontally rHS =
  Automation.propertySet "CenterHorizontally" [Automation.inInt rHS]
getCenterVertically :: IPageSetup a -> Prelude.IO (Prelude.Int)
getCenterVertically =
  Automation.propertyGet "CenterVertically" [] Automation.outInt
setCenterVertically :: Prelude.Int -> IPageSetup a -> Prelude.IO ()
setCenterVertically rHS =
  Automation.propertySet "CenterVertically" [Automation.inInt rHS]
getChartSize :: (Automation.Variant a0) => IPageSetup a -> Prelude.IO (a0)
getChartSize =
  Automation.propertyGet "ChartSize" [] Automation.outVariant
setChartSize :: (Automation.Variant a0) => a0 -> IPageSetup a -> Prelude.IO ()
setChartSize rHS =
  Automation.propertySet "ChartSize" [Automation.inVariant rHS]
getDraft :: IPageSetup a -> Prelude.IO (Prelude.Int)
getDraft = Automation.propertyGet "Draft" [] Automation.outInt
setDraft :: Prelude.Int -> IPageSetup a -> Prelude.IO ()
setDraft rHS =
  Automation.propertySet "Draft" [Automation.inInt rHS]
getFirstPageNumber :: IPageSetup a -> Prelude.IO (Prelude.Int)
getFirstPageNumber =
  Automation.propertyGet "FirstPageNumber" [] Automation.outInt
setFirstPageNumber :: Prelude.Int -> IPageSetup a -> Prelude.IO ()
setFirstPageNumber rHS =
  Automation.propertySet "FirstPageNumber" [Automation.inInt rHS]
getFitToPagesTall :: IPageSetup a -> Prelude.IO (Prelude.Int)
getFitToPagesTall =
  Automation.propertyGet "FitToPagesTall" [] Automation.outInt
setFitToPagesTall :: Prelude.Int -> IPageSetup a -> Prelude.IO ()
setFitToPagesTall rHS =
  Automation.propertySet "FitToPagesTall" [Automation.inInt rHS]
getFitToPagesWide :: IPageSetup a -> Prelude.IO (Prelude.Int)
getFitToPagesWide =
  Automation.propertyGet "FitToPagesWide" [] Automation.outInt
setFitToPagesWide :: Prelude.Int -> IPageSetup a -> Prelude.IO ()
setFitToPagesWide rHS =
  Automation.propertySet "FitToPagesWide" [Automation.inInt rHS]
getFooterMargin :: IPageSetup a -> Prelude.IO (Prelude.Double)
getFooterMargin =
  Automation.propertyGet "FooterMargin" [] Automation.outDouble
setFooterMargin :: Prelude.Double -> IPageSetup a -> Prelude.IO ()
setFooterMargin rHS =
  Automation.propertySet "FooterMargin" [Automation.inDouble rHS]
getHeaderMargin :: IPageSetup a -> Prelude.IO (Prelude.Double)
getHeaderMargin =
  Automation.propertyGet "HeaderMargin" [] Automation.outDouble
setHeaderMargin :: Prelude.Double -> IPageSetup a -> Prelude.IO ()
setHeaderMargin rHS =
  Automation.propertySet "HeaderMargin" [Automation.inDouble rHS]
getLeftFooter :: IPageSetup a -> Prelude.IO (Prelude.String)
getLeftFooter =
  Automation.propertyGet "LeftFooter" [] Automation.outString
setLeftFooter :: Prelude.String -> IPageSetup a -> Prelude.IO ()
setLeftFooter rHS =
  Automation.propertySet "LeftFooter" [Automation.inString rHS]
getLeftHeader :: IPageSetup a -> Prelude.IO (Prelude.String)
getLeftHeader =
  Automation.propertyGet "LeftHeader" [] Automation.outString
setLeftHeader :: Prelude.String -> IPageSetup a -> Prelude.IO ()
setLeftHeader rHS =
  Automation.propertySet "LeftHeader" [Automation.inString rHS]
getLeftMargin :: IPageSetup a -> Prelude.IO (Prelude.Double)
getLeftMargin =
  Automation.propertyGet "LeftMargin" [] Automation.outDouble
setLeftMargin :: Prelude.Double -> IPageSetup a -> Prelude.IO ()
setLeftMargin rHS =
  Automation.propertySet "LeftMargin" [Automation.inDouble rHS]
getOrder :: (Automation.Variant a0) => IPageSetup a -> Prelude.IO (a0)
getOrder = Automation.propertyGet "Order" [] Automation.outVariant
setOrder :: (Automation.Variant a0) => a0 -> IPageSetup a -> Prelude.IO ()
setOrder rHS =
  Automation.propertySet "Order" [Automation.inVariant rHS]
getOrientation17 :: (Automation.Variant a0) => IPageSetup a -> Prelude.IO (a0)
getOrientation17 =
  Automation.propertyGet "Orientation" [] Automation.outVariant
setOrientation17 :: (Automation.Variant a0) => a0 -> IPageSetup a -> Prelude.IO ()
setOrientation17 rHS =
  Automation.propertySet "Orientation" [Automation.inVariant rHS]
getPaperSize :: (Automation.Variant a0) => IPageSetup a -> Prelude.IO (a0)
getPaperSize =
  Automation.propertyGet "PaperSize" [] Automation.outVariant
setPaperSize :: (Automation.Variant a0) => a0 -> IPageSetup a -> Prelude.IO ()
setPaperSize rHS =
  Automation.propertySet "PaperSize" [Automation.inVariant rHS]
getPrintArea :: IPageSetup a -> Prelude.IO (Prelude.String)
getPrintArea =
  Automation.propertyGet "PrintArea" [] Automation.outString
setPrintArea :: Prelude.String -> IPageSetup a -> Prelude.IO ()
setPrintArea rHS =
  Automation.propertySet "PrintArea" [Automation.inString rHS]
getPrintGridlines :: IPageSetup a -> Prelude.IO (Prelude.Int)
getPrintGridlines =
  Automation.propertyGet "PrintGridlines" [] Automation.outInt
setPrintGridlines :: Prelude.Int -> IPageSetup a -> Prelude.IO ()
setPrintGridlines rHS =
  Automation.propertySet "PrintGridlines" [Automation.inInt rHS]
getPrintHeadings :: IPageSetup a -> Prelude.IO (Prelude.Int)
getPrintHeadings =
  Automation.propertyGet "PrintHeadings" [] Automation.outInt
setPrintHeadings :: Prelude.Int -> IPageSetup a -> Prelude.IO ()
setPrintHeadings rHS =
  Automation.propertySet "PrintHeadings" [Automation.inInt rHS]
getPrintNotes :: IPageSetup a -> Prelude.IO (Prelude.Int)
getPrintNotes =
  Automation.propertyGet "PrintNotes" [] Automation.outInt
setPrintNotes :: Prelude.Int -> IPageSetup a -> Prelude.IO ()
setPrintNotes rHS =
  Automation.propertySet "PrintNotes" [Automation.inInt rHS]
printQuality :: Prelude.Int -> IPageSetup a -> Prelude.IO (Prelude.Int)
printQuality index =
  Automation.function1 "PrintQuality" [Automation.inInt index] Automation.outInt
getPrintTitleColumns :: IPageSetup a -> Prelude.IO (Prelude.String)
getPrintTitleColumns =
  Automation.propertyGet "PrintTitleColumns" [] Automation.outString
setPrintTitleColumns :: Prelude.String -> IPageSetup a -> Prelude.IO ()
setPrintTitleColumns rHS =
  Automation.propertySet "PrintTitleColumns" [Automation.inString rHS]
getPrintTitleRows :: IPageSetup a -> Prelude.IO (Prelude.String)
getPrintTitleRows =
  Automation.propertyGet "PrintTitleRows" [] Automation.outString
setPrintTitleRows :: Prelude.String -> IPageSetup a -> Prelude.IO ()
setPrintTitleRows rHS =
  Automation.propertySet "PrintTitleRows" [Automation.inString rHS]
getRightFooter :: IPageSetup a -> Prelude.IO (Prelude.String)
getRightFooter =
  Automation.propertyGet "RightFooter" [] Automation.outString
setRightFooter :: Prelude.String -> IPageSetup a -> Prelude.IO ()
setRightFooter rHS =
  Automation.propertySet "RightFooter" [Automation.inString rHS]
getRightHeader :: IPageSetup a -> Prelude.IO (Prelude.String)
getRightHeader =
  Automation.propertyGet "RightHeader" [] Automation.outString
setRightHeader :: Prelude.String -> IPageSetup a -> Prelude.IO ()
setRightHeader rHS =
  Automation.propertySet "RightHeader" [Automation.inString rHS]
getRightMargin :: IPageSetup a -> Prelude.IO (Prelude.Double)
getRightMargin =
  Automation.propertyGet "RightMargin" [] Automation.outDouble
setRightMargin :: Prelude.Double -> IPageSetup a -> Prelude.IO ()
setRightMargin rHS =
  Automation.propertySet "RightMargin" [Automation.inDouble rHS]
getTopMargin :: IPageSetup a -> Prelude.IO (Prelude.Double)
getTopMargin =
  Automation.propertyGet "TopMargin" [] Automation.outDouble
setTopMargin :: Prelude.Double -> IPageSetup a -> Prelude.IO ()
setTopMargin rHS =
  Automation.propertySet "TopMargin" [Automation.inDouble rHS]
getPrintComments :: (Automation.Variant a0) => IPageSetup a -> Prelude.IO (a0)
getPrintComments =
  Automation.propertyGet "PrintComments" [] Automation.outVariant
setPrintComments :: (Automation.Variant a0) => a0 -> IPageSetup a -> Prelude.IO ()
setPrintComments rHS =
  Automation.propertySet "PrintComments" [Automation.inVariant rHS]
-- --------------------------------------------------
-- 
-- interface INames
-- 
-- --------------------------------------------------
data Names a = Names
                
type INames a = Automation.IDispatch (Names a)
iidINames :: Com.IID (INames Automation.Interface)
iidINames = Com.mkIID "{000208B8-0001-0000-C000-000000000046}"
add38 :: Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> INames a -> Prelude.IO (IName Automation.Interface)
add38 name refersTo visible macroType shortcutKey category nameLocal refersToLocal categoryLocal refersToR1C1 refersToR1C1Local =
  Automation.function1 "Add" [Automation.inInt name, Automation.inInt refersTo, Automation.inInt visible, Automation.inInt macroType, Automation.inInt shortcutKey, Automation.inInt category, Automation.inInt nameLocal, Automation.inInt refersToLocal, Automation.inInt categoryLocal, Automation.inInt refersToR1C1, Automation.inInt refersToR1C1Local] Automation.outIDispatch
item28 :: Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Automation.IDispatch a -> Prelude.IO (IName Automation.Interface)
item28 index indexLocal refersTo lcid =
  Automation.function1 "Item" [Automation.inInt index, Automation.inInt indexLocal, Automation.inInt refersTo, Automation.inInt lcid] Automation.outIDispatch
default0 :: Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Automation.IDispatch a -> Prelude.IO (IName Automation.Interface)
default0 index indexLocal refersTo lcid =
  Automation.function1 "_Default" [Automation.inInt index, Automation.inInt indexLocal, Automation.inInt refersTo, Automation.inInt lcid] Automation.outIDispatch
-- --------------------------------------------------
-- 
-- interface IName
-- 
-- --------------------------------------------------
data Name a = Name
               
type IName a = Automation.IDispatch (Name a)
iidIName :: Com.IID (IName Automation.Interface)
iidIName = Com.mkIID "{000208B9-0001-0000-C000-000000000046}"
getCategory :: Prelude.Int -> IName a -> Prelude.IO (Prelude.String)
getCategory lcidIn =
  Automation.propertyGet "Category" [Automation.inInt lcidIn] Automation.outString
setCategory :: Prelude.Int -> Prelude.String -> IName a -> Prelude.IO ()
setCategory lcidIn rHS =
  Automation.propertySet "Category" [Automation.inInt lcidIn, Automation.inString rHS]
getCategoryLocal :: IName a -> Prelude.IO (Prelude.String)
getCategoryLocal =
  Automation.propertyGet "CategoryLocal" [] Automation.outString
setCategoryLocal :: Prelude.String -> IName a -> Prelude.IO ()
setCategoryLocal rHS =
  Automation.propertySet "CategoryLocal" [Automation.inString rHS]
getMacroType :: (Automation.Variant a0) => IName a -> Prelude.IO (a0)
getMacroType =
  Automation.propertyGet "MacroType" [] Automation.outVariant
setMacroType :: (Automation.Variant a0) => a0 -> IName a -> Prelude.IO ()
setMacroType rHS =
  Automation.propertySet "MacroType" [Automation.inVariant rHS]
setName30 :: Prelude.Int -> Prelude.String -> Automation.IDispatch a -> Prelude.IO ()
setName30 lcidIn rHS =
  Automation.propertySet "Name" [Automation.inInt lcidIn, Automation.inString rHS]
getRefersTo :: Prelude.Int -> IName a -> Prelude.IO (Prelude.Int)
getRefersTo lcidIn =
  Automation.propertyGet "RefersTo" [Automation.inInt lcidIn] Automation.outInt
setRefersTo :: Prelude.Int -> Prelude.Int -> IName a -> Prelude.IO ()
setRefersTo lcidIn rHS =
  Automation.propertySet "RefersTo" [Automation.inInt lcidIn, Automation.inInt rHS]
getShortcutKey :: IName a -> Prelude.IO (Prelude.String)
getShortcutKey =
  Automation.propertyGet "ShortcutKey" [] Automation.outString
setShortcutKey :: Prelude.String -> IName a -> Prelude.IO ()
setShortcutKey rHS =
  Automation.propertySet "ShortcutKey" [Automation.inString rHS]
setNameLocal :: Prelude.String -> IName a -> Prelude.IO ()
setNameLocal rHS =
  Automation.propertySet "NameLocal" [Automation.inString rHS]
getRefersToLocal :: IName a -> Prelude.IO (Prelude.Int)
getRefersToLocal =
  Automation.propertyGet "RefersToLocal" [] Automation.outInt
setRefersToLocal :: Prelude.Int -> IName a -> Prelude.IO ()
setRefersToLocal rHS =
  Automation.propertySet "RefersToLocal" [Automation.inInt rHS]
getRefersToR1C1 :: Prelude.Int -> IName a -> Prelude.IO (Prelude.Int)
getRefersToR1C1 lcidIn =
  Automation.propertyGet "RefersToR1C1" [Automation.inInt lcidIn] Automation.outInt
setRefersToR1C1 :: Prelude.Int -> Prelude.Int -> IName a -> Prelude.IO ()
setRefersToR1C1 lcidIn rHS =
  Automation.propertySet "RefersToR1C1" [Automation.inInt lcidIn, Automation.inInt rHS]
getRefersToR1C1Local :: IName a -> Prelude.IO (Prelude.Int)
getRefersToR1C1Local =
  Automation.propertyGet "RefersToR1C1Local" [] Automation.outInt
setRefersToR1C1Local :: Prelude.Int -> IName a -> Prelude.IO ()
setRefersToR1C1Local rHS =
  Automation.propertySet "RefersToR1C1Local" [Automation.inInt rHS]
getRefersToRange :: IName a -> Prelude.IO (IRange Automation.Interface)
getRefersToRange =
  Automation.propertyGet "RefersToRange" [] Automation.outIDispatch
-- --------------------------------------------------
-- 
-- interface IChartObject
-- 
-- --------------------------------------------------
data ChartObject a = ChartObject
                      
type IChartObject a = Automation.IDispatch (ChartObject a)
iidIChartObject :: Com.IID (IChartObject Automation.Interface)
iidIChartObject =
  Com.mkIID "{000208CF-0001-0000-C000-000000000046}"
getChart :: IChartObject a -> Prelude.IO (IChart Automation.Interface)
getChart =
  Automation.propertyGet "Chart" [] Automation.outIDispatch
getProtectChartObject :: IChartObject a -> Prelude.IO (Prelude.Int)
getProtectChartObject =
  Automation.propertyGet "ProtectChartObject" [] Automation.outInt
setProtectChartObject :: Prelude.Int -> IChartObject a -> Prelude.IO ()
setProtectChartObject rHS =
  Automation.propertySet "ProtectChartObject" [Automation.inInt rHS]
-- --------------------------------------------------
-- 
-- interface IChartObjects
-- 
-- --------------------------------------------------
data ChartObjects a = ChartObjects
                       
type IChartObjects a = Automation.IDispatch (ChartObjects a)
iidIChartObjects :: Com.IID (IChartObjects Automation.Interface)
iidIChartObjects =
  Com.mkIID "{000208D0-0001-0000-C000-000000000046}"
add39 :: Prelude.Double -> Prelude.Double -> Prelude.Double -> Prelude.Double -> IChartObjects a -> Prelude.IO (IChartObject Automation.Interface)
add39 left top width height =
  Automation.function1 "Add" [Automation.inDouble left, Automation.inDouble top, Automation.inDouble width, Automation.inDouble height] Automation.outIDispatch
-- --------------------------------------------------
-- 
-- interface IMailer
-- 
-- --------------------------------------------------
data Mailer a = Mailer
                 
type IMailer a = Automation.IDispatch (Mailer a)
iidIMailer :: Com.IID (IMailer Automation.Interface)
iidIMailer = Com.mkIID "{000208D1-0001-0000-C000-000000000046}"
getBCCRecipients :: IMailer a -> Prelude.IO (Prelude.Int)
getBCCRecipients =
  Automation.propertyGet "BCCRecipients" [] Automation.outInt
setBCCRecipients :: Prelude.Int -> IMailer a -> Prelude.IO ()
setBCCRecipients rHS =
  Automation.propertySet "BCCRecipients" [Automation.inInt rHS]
getCCRecipients :: IMailer a -> Prelude.IO (Prelude.Int)
getCCRecipients =
  Automation.propertyGet "CCRecipients" [] Automation.outInt
setCCRecipients :: Prelude.Int -> IMailer a -> Prelude.IO ()
setCCRecipients rHS =
  Automation.propertySet "CCRecipients" [Automation.inInt rHS]
getEnclosures :: IMailer a -> Prelude.IO (Prelude.Int)
getEnclosures =
  Automation.propertyGet "Enclosures" [] Automation.outInt
setEnclosures :: Prelude.Int -> IMailer a -> Prelude.IO ()
setEnclosures rHS =
  Automation.propertySet "Enclosures" [Automation.inInt rHS]
getReceived :: IMailer a -> Prelude.IO (Prelude.Int)
getReceived =
  Automation.propertyGet "Received" [] Automation.outInt
getSendDateTime :: IMailer a -> Prelude.IO (Prelude.Double)
getSendDateTime =
  Automation.propertyGet "SendDateTime" [] Automation.outDouble
getSender :: IMailer a -> Prelude.IO (Prelude.String)
getSender = Automation.propertyGet "Sender" [] Automation.outString
setSubject1 :: Prelude.String -> IMailer a -> Prelude.IO ()
setSubject1 rHS =
  Automation.propertySet "Subject" [Automation.inString rHS]
getToRecipients :: IMailer a -> Prelude.IO (Prelude.Int)
getToRecipients =
  Automation.propertyGet "ToRecipients" [] Automation.outInt
setToRecipients :: Prelude.Int -> IMailer a -> Prelude.IO ()
setToRecipients rHS =
  Automation.propertySet "ToRecipients" [Automation.inInt rHS]
getWhichAddress :: IMailer a -> Prelude.IO (Prelude.Int)
getWhichAddress =
  Automation.propertyGet "WhichAddress" [] Automation.outInt
setWhichAddress :: Prelude.Int -> IMailer a -> Prelude.IO ()
setWhichAddress rHS =
  Automation.propertySet "WhichAddress" [Automation.inInt rHS]
-- --------------------------------------------------
-- 
-- interface ICustomViews
-- 
-- --------------------------------------------------
data CustomViews a = CustomViews
                      
type ICustomViews a = Automation.IDispatch (CustomViews a)
iidICustomViews :: Com.IID (ICustomViews Automation.Interface)
iidICustomViews =
  Com.mkIID "{00024422-0001-0000-C000-000000000046}"
item30 :: Prelude.Int -> ICustomViews a -> Prelude.IO (ICustomView Automation.Interface)
item30 viewName =
  Automation.function1 "Item" [Automation.inInt viewName] Automation.outIDispatch
add40 :: Prelude.String -> Prelude.Int -> Prelude.Int -> ICustomViews a -> Prelude.IO (ICustomView Automation.Interface)
add40 viewName printSettings rowColSettings =
  Automation.function1 "Add" [Automation.inString viewName, Automation.inInt printSettings, Automation.inInt rowColSettings] Automation.outIDispatch
getDefault47 :: Prelude.Int -> ICustomViews a -> Prelude.IO (ICustomView Automation.Interface)
getDefault47 viewName =
  Automation.propertyGet "_Default" [Automation.inInt viewName] Automation.outIDispatch
-- --------------------------------------------------
-- 
-- interface ICustomView
-- 
-- --------------------------------------------------
data CustomView a = CustomView
                     
type ICustomView a = Automation.IDispatch (CustomView a)
iidICustomView :: Com.IID (ICustomView Automation.Interface)
iidICustomView = Com.mkIID "{00024423-0001-0000-C000-000000000046}"
getPrintSettings :: ICustomView a -> Prelude.IO (Prelude.Int)
getPrintSettings =
  Automation.propertyGet "PrintSettings" [] Automation.outInt
getRowColSettings :: ICustomView a -> Prelude.IO (Prelude.Int)
getRowColSettings =
  Automation.propertyGet "RowColSettings" [] Automation.outInt
-- --------------------------------------------------
-- 
-- interface IFormatConditions
-- 
-- --------------------------------------------------
data FormatConditions a = FormatConditions
                           
type IFormatConditions a = Automation.IDispatch (FormatConditions a)
iidIFormatConditions :: Com.IID (IFormatConditions Automation.Interface)
iidIFormatConditions =
  Com.mkIID "{00024424-0001-0000-C000-000000000046}"
item31 :: Prelude.Int -> IFormatConditions a -> Prelude.IO (IFormatCondition Automation.Interface)
item31 index =
  Automation.function1 "Item" [Automation.inInt index] Automation.outIDispatch
add41 :: (Automation.Variant a0) => a0 -> Prelude.Int -> Prelude.Int -> Prelude.Int -> IFormatConditions a -> Prelude.IO (IFormatCondition Automation.Interface)
add41 type0 operator formula1 formula2 =
  Automation.function1 "Add" [Automation.inVariant type0, Automation.inInt operator, Automation.inInt formula1, Automation.inInt formula2] Automation.outIDispatch
getDefault48 :: Prelude.Int -> IFormatConditions a -> Prelude.IO (IFormatCondition Automation.Interface)
getDefault48 index =
  Automation.propertyGet "_Default" [Automation.inInt index] Automation.outIDispatch
-- --------------------------------------------------
-- 
-- interface IFormatCondition
-- 
-- --------------------------------------------------
data FormatCondition a = FormatCondition
                          
type IFormatCondition a = Automation.IDispatch (FormatCondition a)
iidIFormatCondition :: Com.IID (IFormatCondition Automation.Interface)
iidIFormatCondition =
  Com.mkIID "{00024425-0001-0000-C000-000000000046}"
modify :: (Automation.Variant a0) => a0 -> Prelude.Int -> Prelude.Int -> Prelude.Int -> IFormatCondition a -> Prelude.IO ()
modify type0 operator formula1 formula2 =
  Automation.method0 "Modify" [Automation.inVariant type0, Automation.inInt operator, Automation.inInt formula1, Automation.inInt formula2]
getType8 :: Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getType8 = Automation.propertyGet "Type" [] Automation.outInt
getOperator :: Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getOperator =
  Automation.propertyGet "Operator" [] Automation.outInt
getFormula17 :: Automation.IDispatch a -> Prelude.IO (Prelude.String)
getFormula17 =
  Automation.propertyGet "Formula1" [] Automation.outString
getFormula20 :: Automation.IDispatch a -> Prelude.IO (Prelude.String)
getFormula20 =
  Automation.propertyGet "Formula2" [] Automation.outString
-- --------------------------------------------------
-- 
-- interface IComments
-- 
-- --------------------------------------------------
data Comments a = Comments
                   
type IComments a = Automation.IDispatch (Comments a)
iidIComments :: Com.IID (IComments Automation.Interface)
iidIComments = Com.mkIID "{00024426-0001-0000-C000-000000000046}"
item32 :: Prelude.Int -> IComments a -> Prelude.IO (IComment Automation.Interface)
item32 index =
  Automation.function1 "Item" [Automation.inInt index] Automation.outIDispatch
getDefault49 :: Prelude.Int -> IComments a -> Prelude.IO (IComment Automation.Interface)
getDefault49 index =
  Automation.propertyGet "_Default" [Automation.inInt index] Automation.outIDispatch
-- --------------------------------------------------
-- 
-- interface IComment
-- 
-- --------------------------------------------------
data Comment a = Comment
                  
type IComment a = Automation.IDispatch (Comment a)
iidIComment :: Com.IID (IComment Automation.Interface)
iidIComment = Com.mkIID "{00024427-0001-0000-C000-000000000046}"
getShape :: Automation.IDispatch a -> Prelude.IO (Office.IShape Automation.Interface)
getShape =
  Automation.propertyGet "Shape" [] Automation.outIDispatch
text0 :: Prelude.Int -> Prelude.Int -> Prelude.Int -> IComment a -> Prelude.IO (Prelude.String)
text0 text start overwrite =
  Automation.function1 "Text" [Automation.inInt text, Automation.inInt start, Automation.inInt overwrite] Automation.outString
next :: IComment a -> Prelude.IO (IComment Automation.Interface)
next = Automation.function1 "Next" [] Automation.outIDispatch
previous :: IComment a -> Prelude.IO (IComment Automation.Interface)
previous =
  Automation.function1 "Previous" [] Automation.outIDispatch
-- --------------------------------------------------
-- 
-- interface IRefreshEvents
-- 
-- --------------------------------------------------
data RefreshEvents a = RefreshEvents
                        
type IRefreshEvents a = Automation.IDispatch (RefreshEvents a)
iidIRefreshEvents :: Com.IID (IRefreshEvents Automation.Interface)
iidIRefreshEvents =
  Com.mkIID "{0002441B-0001-0000-C000-000000000046}"
beforeRefresh :: Prelude.Int -> IRefreshEvents a -> Prelude.IO ()
beforeRefresh cancel =
  Automation.method0 "BeforeRefresh" [Automation.inInt cancel]
afterRefresh :: Prelude.Int -> IRefreshEvents a -> Prelude.IO ()
afterRefresh success =
  Automation.method0 "AfterRefresh" [Automation.inInt success]
-- --------------------------------------------------
-- 
-- interface IQueryTable
-- 
-- --------------------------------------------------
data QueryTable a = QueryTable
                     
type IQueryTable a = Automation.IDispatch (QueryTable a)
iidIQueryTable :: Com.IID (IQueryTable Automation.Interface)
iidIQueryTable = Com.mkIID "{00024428-0001-0000-C000-000000000046}"
getFieldNames :: IQueryTable a -> Prelude.IO (Prelude.Int)
getFieldNames =
  Automation.propertyGet "FieldNames" [] Automation.outInt
setFieldNames :: Prelude.Int -> IQueryTable a -> Prelude.IO ()
setFieldNames rHS =
  Automation.propertySet "FieldNames" [Automation.inInt rHS]
getRowNumbers :: IQueryTable a -> Prelude.IO (Prelude.Int)
getRowNumbers =
  Automation.propertyGet "RowNumbers" [] Automation.outInt
setRowNumbers :: Prelude.Int -> IQueryTable a -> Prelude.IO ()
setRowNumbers rHS =
  Automation.propertySet "RowNumbers" [Automation.inInt rHS]
getFillAdjacentFormulas :: IQueryTable a -> Prelude.IO (Prelude.Int)
getFillAdjacentFormulas =
  Automation.propertyGet "FillAdjacentFormulas" [] Automation.outInt
setFillAdjacentFormulas :: Prelude.Int -> IQueryTable a -> Prelude.IO ()
setFillAdjacentFormulas rHS =
  Automation.propertySet "FillAdjacentFormulas" [Automation.inInt rHS]
getRefreshing :: IQueryTable a -> Prelude.IO (Prelude.Int)
getRefreshing =
  Automation.propertyGet "Refreshing" [] Automation.outInt
getFetchedRowOverflow :: IQueryTable a -> Prelude.IO (Prelude.Int)
getFetchedRowOverflow =
  Automation.propertyGet "FetchedRowOverflow" [] Automation.outInt
cancelRefresh :: IQueryTable a -> Prelude.IO ()
cancelRefresh = Automation.method0 "CancelRefresh" []
getRefreshStyle :: (Automation.Variant a0) => IQueryTable a -> Prelude.IO (a0)
getRefreshStyle =
  Automation.propertyGet "RefreshStyle" [] Automation.outVariant
setRefreshStyle :: (Automation.Variant a0) => a0 -> IQueryTable a -> Prelude.IO ()
setRefreshStyle rHS =
  Automation.propertySet "RefreshStyle" [Automation.inVariant rHS]
getDestination :: IQueryTable a -> Prelude.IO (IRange Automation.Interface)
getDestination =
  Automation.propertyGet "Destination" [] Automation.outIDispatch
getPostText :: IQueryTable a -> Prelude.IO (Prelude.String)
getPostText =
  Automation.propertyGet "PostText" [] Automation.outString
setPostText :: Prelude.String -> IQueryTable a -> Prelude.IO ()
setPostText rHS =
  Automation.propertySet "PostText" [Automation.inString rHS]
getResultRange :: IQueryTable a -> Prelude.IO (IRange Automation.Interface)
getResultRange =
  Automation.propertyGet "ResultRange" [] Automation.outIDispatch
refresh1 :: Prelude.Int -> Automation.IDispatch a -> Prelude.IO (Prelude.Int)
refresh1 backgroundQuery =
  Automation.function1 "Refresh" [Automation.inInt backgroundQuery] Automation.outInt
getParameters :: IQueryTable a -> Prelude.IO (IParameters Automation.Interface)
getParameters =
  Automation.propertyGet "Parameters" [] Automation.outIDispatch
getRecordset :: IQueryTable a -> Prelude.IO (Automation.IDispatch Automation.Interface)
getRecordset =
  Automation.propertyGet "Recordset" [] Automation.outIDispatch
recordset :: Automation.IDispatch a0 -> IQueryTable a -> Prelude.IO ()
recordset rHS =
  Automation.method0 "Recordset" [Automation.inIDispatch rHS]
getTablesOnlyFromHTML :: IQueryTable a -> Prelude.IO (Prelude.Int)
getTablesOnlyFromHTML =
  Automation.propertyGet "TablesOnlyFromHTML" [] Automation.outInt
setTablesOnlyFromHTML :: Prelude.Int -> IQueryTable a -> Prelude.IO ()
setTablesOnlyFromHTML rHS =
  Automation.propertySet "TablesOnlyFromHTML" [Automation.inInt rHS]
getEnableEditing :: IQueryTable a -> Prelude.IO (Prelude.Int)
getEnableEditing =
  Automation.propertyGet "EnableEditing" [] Automation.outInt
setEnableEditing :: Prelude.Int -> IQueryTable a -> Prelude.IO ()
setEnableEditing rHS =
  Automation.propertySet "EnableEditing" [Automation.inInt rHS]
-- --------------------------------------------------
-- 
-- interface IQueryTables
-- 
-- --------------------------------------------------
data QueryTables a = QueryTables
                      
type IQueryTables a = Automation.IDispatch (QueryTables a)
iidIQueryTables :: Com.IID (IQueryTables Automation.Interface)
iidIQueryTables =
  Com.mkIID "{00024429-0001-0000-C000-000000000046}"
add42 :: Prelude.Int -> IRange a0 -> Prelude.Int -> IQueryTables a -> Prelude.IO (IQueryTable Automation.Interface)
add42 connection destination sql =
  Automation.function1 "Add" [Automation.inInt connection, Automation.inIDispatch destination, Automation.inInt sql] Automation.outIDispatch
item33 :: Prelude.Int -> IQueryTables a -> Prelude.IO (IQueryTable Automation.Interface)
item33 index =
  Automation.function1 "Item" [Automation.inInt index] Automation.outIDispatch
getDefault50 :: Prelude.Int -> IQueryTables a -> Prelude.IO (IQueryTable Automation.Interface)
getDefault50 index =
  Automation.propertyGet "_Default" [Automation.inInt index] Automation.outIDispatch
-- --------------------------------------------------
-- 
-- interface IParameter
-- 
-- --------------------------------------------------
data Parameter a = Parameter
                    
type IParameter a = Automation.IDispatch (Parameter a)
iidIParameter :: Com.IID (IParameter Automation.Interface)
iidIParameter = Com.mkIID "{0002442A-0001-0000-C000-000000000046}"
getDataType0 :: (Automation.Variant a0) => IParameter a -> Prelude.IO (a0)
getDataType0 =
  Automation.propertyGet "DataType" [] Automation.outVariant
setDataType :: (Automation.Variant a0) => a0 -> IParameter a -> Prelude.IO ()
setDataType rHS =
  Automation.propertySet "DataType" [Automation.inVariant rHS]
getType9 :: (Automation.Variant a0) => IParameter a -> Prelude.IO (a0)
getType9 = Automation.propertyGet "Type" [] Automation.outVariant
getPromptString :: IParameter a -> Prelude.IO (Prelude.String)
getPromptString =
  Automation.propertyGet "PromptString" [] Automation.outString
getSourceRange :: IParameter a -> Prelude.IO (IRange Automation.Interface)
getSourceRange =
  Automation.propertyGet "SourceRange" [] Automation.outIDispatch
setParam :: (Automation.Variant a0) => a0 -> Prelude.Int -> IParameter a -> Prelude.IO ()
setParam type0 value =
  Automation.method0 "SetParam" [Automation.inVariant type0, Automation.inInt value]
-- --------------------------------------------------
-- 
-- interface IParameters
-- 
-- --------------------------------------------------
data Parameters a = Parameters
                     
type IParameters a = Automation.IDispatch (Parameters a)
iidIParameters :: Com.IID (IParameters Automation.Interface)
iidIParameters = Com.mkIID "{0002442B-0001-0000-C000-000000000046}"
add43 :: Prelude.String -> Prelude.Int -> IParameters a -> Prelude.IO (IParameter Automation.Interface)
add43 name iDataType =
  Automation.function1 "Add" [Automation.inString name, Automation.inInt iDataType] Automation.outIDispatch
item34 :: Prelude.Int -> IParameters a -> Prelude.IO (IParameter Automation.Interface)
item34 index =
  Automation.function1 "Item" [Automation.inInt index] Automation.outIDispatch
getDefault51 :: Prelude.Int -> IParameters a -> Prelude.IO (IParameter Automation.Interface)
getDefault51 index =
  Automation.propertyGet "_Default" [Automation.inInt index] Automation.outIDispatch
-- --------------------------------------------------
-- 
-- interface IODBCError
-- 
-- --------------------------------------------------
data ODBCError a = ODBCError
                    
type IODBCError a = Automation.IDispatch (ODBCError a)
iidIODBCError :: Com.IID (IODBCError Automation.Interface)
iidIODBCError = Com.mkIID "{0002442C-0001-0000-C000-000000000046}"
getSqlState :: IODBCError a -> Prelude.IO (Prelude.String)
getSqlState =
  Automation.propertyGet "SqlState" [] Automation.outString
-- --------------------------------------------------
-- 
-- interface IODBCErrors
-- 
-- --------------------------------------------------
data ODBCErrors a = ODBCErrors
                     
type IODBCErrors a = Automation.IDispatch (ODBCErrors a)
iidIODBCErrors :: Com.IID (IODBCErrors Automation.Interface)
iidIODBCErrors = Com.mkIID "{0002442D-0001-0000-C000-000000000046}"
item35 :: Prelude.Int -> IODBCErrors a -> Prelude.IO (IODBCError Automation.Interface)
item35 index =
  Automation.function1 "Item" [Automation.inInt index] Automation.outIDispatch
getDefault52 :: Prelude.Int -> IODBCErrors a -> Prelude.IO (IODBCError Automation.Interface)
getDefault52 index =
  Automation.propertyGet "_Default" [Automation.inInt index] Automation.outIDispatch
-- --------------------------------------------------
-- 
-- interface IValidation
-- 
-- --------------------------------------------------
data Validation a = Validation
                     
type IValidation a = Automation.IDispatch (Validation a)
iidIValidation :: Com.IID (IValidation Automation.Interface)
iidIValidation = Com.mkIID "{0002442F-0001-0000-C000-000000000046}"
add44 :: (Automation.Variant a0) => a0 -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> IValidation a -> Prelude.IO ()
add44 type0 alertStyle operator formula1 formula2 =
  Automation.method0 "Add" [Automation.inVariant type0, Automation.inInt alertStyle, Automation.inInt operator, Automation.inInt formula1, Automation.inInt formula2]
getAlertStyle :: IValidation a -> Prelude.IO (Prelude.Int)
getAlertStyle =
  Automation.propertyGet "AlertStyle" [] Automation.outInt
getIgnoreBlank :: IValidation a -> Prelude.IO (Prelude.Int)
getIgnoreBlank =
  Automation.propertyGet "IgnoreBlank" [] Automation.outInt
setIgnoreBlank :: Prelude.Int -> IValidation a -> Prelude.IO ()
setIgnoreBlank rHS =
  Automation.propertySet "IgnoreBlank" [Automation.inInt rHS]
getIMEMode :: IValidation a -> Prelude.IO (Prelude.Int)
getIMEMode = Automation.propertyGet "IMEMode" [] Automation.outInt
setIMEMode :: Prelude.Int -> IValidation a -> Prelude.IO ()
setIMEMode rHS =
  Automation.propertySet "IMEMode" [Automation.inInt rHS]
getInCellDropdown :: IValidation a -> Prelude.IO (Prelude.Int)
getInCellDropdown =
  Automation.propertyGet "InCellDropdown" [] Automation.outInt
setInCellDropdown :: Prelude.Int -> IValidation a -> Prelude.IO ()
setInCellDropdown rHS =
  Automation.propertySet "InCellDropdown" [Automation.inInt rHS]
getErrorMessage :: IValidation a -> Prelude.IO (Prelude.String)
getErrorMessage =
  Automation.propertyGet "ErrorMessage" [] Automation.outString
setErrorMessage :: Prelude.String -> IValidation a -> Prelude.IO ()
setErrorMessage rHS =
  Automation.propertySet "ErrorMessage" [Automation.inString rHS]
getErrorTitle :: IValidation a -> Prelude.IO (Prelude.String)
getErrorTitle =
  Automation.propertyGet "ErrorTitle" [] Automation.outString
setErrorTitle :: Prelude.String -> IValidation a -> Prelude.IO ()
setErrorTitle rHS =
  Automation.propertySet "ErrorTitle" [Automation.inString rHS]
getInputMessage :: IValidation a -> Prelude.IO (Prelude.String)
getInputMessage =
  Automation.propertyGet "InputMessage" [] Automation.outString
setInputMessage :: Prelude.String -> IValidation a -> Prelude.IO ()
setInputMessage rHS =
  Automation.propertySet "InputMessage" [Automation.inString rHS]
getInputTitle :: IValidation a -> Prelude.IO (Prelude.String)
getInputTitle =
  Automation.propertyGet "InputTitle" [] Automation.outString
setInputTitle :: Prelude.String -> IValidation a -> Prelude.IO ()
setInputTitle rHS =
  Automation.propertySet "InputTitle" [Automation.inString rHS]
modify0 :: Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> IValidation a -> Prelude.IO ()
modify0 type0 alertStyle operator formula1 formula2 =
  Automation.method0 "Modify" [Automation.inInt type0, Automation.inInt alertStyle, Automation.inInt operator, Automation.inInt formula1, Automation.inInt formula2]
getShowError :: IValidation a -> Prelude.IO (Prelude.Int)
getShowError =
  Automation.propertyGet "ShowError" [] Automation.outInt
setShowError :: Prelude.Int -> IValidation a -> Prelude.IO ()
setShowError rHS =
  Automation.propertySet "ShowError" [Automation.inInt rHS]
getShowInput :: IValidation a -> Prelude.IO (Prelude.Int)
getShowInput =
  Automation.propertyGet "ShowInput" [] Automation.outInt
setShowInput :: Prelude.Int -> IValidation a -> Prelude.IO ()
setShowInput rHS =
  Automation.propertySet "ShowInput" [Automation.inInt rHS]
getValue23 :: IValidation a -> Prelude.IO (Prelude.Int)
getValue23 = Automation.propertyGet "Value" [] Automation.outInt
-- --------------------------------------------------
-- 
-- interface IHyperlinks
-- 
-- --------------------------------------------------
data Hyperlinks a = Hyperlinks
                     
type IHyperlinks a = Automation.IDispatch (Hyperlinks a)
iidIHyperlinks :: Com.IID (IHyperlinks Automation.Interface)
iidIHyperlinks = Com.mkIID "{00024430-0001-0000-C000-000000000046}"
add45 :: Automation.IDispatch a0 -> Prelude.String -> Prelude.Int -> IHyperlinks a -> Prelude.IO (Automation.IDispatch Automation.Interface)
add45 anchor address subAddress =
  Automation.function1 "Add" [Automation.inIDispatch anchor, Automation.inString address, Automation.inInt subAddress] Automation.outIDispatch
getItem22 :: Prelude.Int -> IHyperlinks a -> Prelude.IO (IHyperlink Automation.Interface)
getItem22 index =
  Automation.propertyGet "Item" [Automation.inInt index] Automation.outIDispatch
getDefault53 :: Prelude.Int -> IHyperlinks a -> Prelude.IO (IHyperlink Automation.Interface)
getDefault53 index =
  Automation.propertyGet "_Default" [Automation.inInt index] Automation.outIDispatch
-- --------------------------------------------------
-- 
-- interface IHyperlink
-- 
-- --------------------------------------------------
data Hyperlink a = Hyperlink
                    
type IHyperlink a = Automation.IDispatch (Hyperlink a)
iidIHyperlink :: Com.IID (IHyperlink Automation.Interface)
iidIHyperlink = Com.mkIID "{00024431-0001-0000-C000-000000000046}"
getRange3 :: Automation.IDispatch a -> Prelude.IO (IRange Automation.Interface)
getRange3 =
  Automation.propertyGet "Range" [] Automation.outIDispatch
getSubAddress :: IHyperlink a -> Prelude.IO (Prelude.String)
getSubAddress =
  Automation.propertyGet "SubAddress" [] Automation.outString
setSubAddress :: Prelude.String -> IHyperlink a -> Prelude.IO ()
setSubAddress rHS =
  Automation.propertySet "SubAddress" [Automation.inString rHS]
getAddress0 :: IHyperlink a -> Prelude.IO (Prelude.String)
getAddress0 =
  Automation.propertyGet "Address" [] Automation.outString
setAddress :: Prelude.String -> IHyperlink a -> Prelude.IO ()
setAddress rHS =
  Automation.propertySet "Address" [Automation.inString rHS]
follow :: Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> IHyperlink a -> Prelude.IO ()
follow newWindow addHistory extraInfo method headerInfo =
  Automation.method0 "Follow" [Automation.inInt newWindow, Automation.inInt addHistory, Automation.inInt extraInfo, Automation.inInt method, Automation.inInt headerInfo]
-- --------------------------------------------------
-- 
-- interface IAutoFilter
-- 
-- --------------------------------------------------
data AutoFilter a = AutoFilter
                     
type IAutoFilter a = Automation.IDispatch (AutoFilter a)
iidIAutoFilter :: Com.IID (IAutoFilter Automation.Interface)
iidIAutoFilter = Com.mkIID "{00024432-0001-0000-C000-000000000046}"
getFilters :: IAutoFilter a -> Prelude.IO (IFilters Automation.Interface)
getFilters =
  Automation.propertyGet "Filters" [] Automation.outIDispatch
-- --------------------------------------------------
-- 
-- interface IFilters
-- 
-- --------------------------------------------------
data Filters a = Filters
                  
type IFilters a = Automation.IDispatch (Filters a)
iidIFilters :: Com.IID (IFilters Automation.Interface)
iidIFilters = Com.mkIID "{00024433-0001-0000-C000-000000000046}"
getDefault54 :: Prelude.Int -> IFilters a -> Prelude.IO (IFilter Automation.Interface)
getDefault54 index =
  Automation.propertyGet "_Default" [Automation.inInt index] Automation.outIDispatch
getItem23 :: Prelude.Int -> IFilters a -> Prelude.IO (IFilter Automation.Interface)
getItem23 index =
  Automation.propertyGet "Item" [Automation.inInt index] Automation.outIDispatch
-- --------------------------------------------------
-- 
-- interface IFilter
-- 
-- --------------------------------------------------
data Filter a = Filter
                 
type IFilter a = Automation.IDispatch (Filter a)
iidIFilter :: Com.IID (IFilter Automation.Interface)
iidIFilter = Com.mkIID "{00024434-0001-0000-C000-000000000046}"
getOn :: IFilter a -> Prelude.IO (Prelude.Int)
getOn = Automation.propertyGet "On" [] Automation.outInt
getCriteria1 :: IFilter a -> Prelude.IO (Prelude.Int)
getCriteria1 =
  Automation.propertyGet "Criteria1" [] Automation.outInt
getOperator1 :: (Automation.Variant a0) => IFilter a -> Prelude.IO (a0)
getOperator1 =
  Automation.propertyGet "Operator" [] Automation.outVariant
getCriteria2 :: IFilter a -> Prelude.IO (Prelude.Int)
getCriteria2 =
  Automation.propertyGet "Criteria2" [] Automation.outInt
-- --------------------------------------------------
-- 
-- interface IAutoCorrect
-- 
-- --------------------------------------------------
data AutoCorrect a = AutoCorrect
                      
type IAutoCorrect a = Automation.IDispatch (AutoCorrect a)
iidIAutoCorrect :: Com.IID (IAutoCorrect Automation.Interface)
iidIAutoCorrect =
  Com.mkIID "{000208D4-0001-0000-C000-000000000046}"
addReplacement :: Prelude.String -> Prelude.String -> IAutoCorrect a -> Prelude.IO ()
addReplacement what replacement =
  Automation.method0 "AddReplacement" [Automation.inString what, Automation.inString replacement]
getCapitalizeNamesOfDays :: IAutoCorrect a -> Prelude.IO (Prelude.Int)
getCapitalizeNamesOfDays =
  Automation.propertyGet "CapitalizeNamesOfDays" [] Automation.outInt
setCapitalizeNamesOfDays :: Prelude.Int -> IAutoCorrect a -> Prelude.IO ()
setCapitalizeNamesOfDays rHS =
  Automation.propertySet "CapitalizeNamesOfDays" [Automation.inInt rHS]
deleteReplacement :: Prelude.String -> IAutoCorrect a -> Prelude.IO ()
deleteReplacement what =
  Automation.method0 "DeleteReplacement" [Automation.inString what]
replacementList :: Prelude.Int -> IAutoCorrect a -> Prelude.IO (Prelude.Int)
replacementList index =
  Automation.function1 "ReplacementList" [Automation.inInt index] Automation.outInt
getReplaceText :: IAutoCorrect a -> Prelude.IO (Prelude.Int)
getReplaceText =
  Automation.propertyGet "ReplaceText" [] Automation.outInt
setReplaceText :: Prelude.Int -> IAutoCorrect a -> Prelude.IO ()
setReplaceText rHS =
  Automation.propertySet "ReplaceText" [Automation.inInt rHS]
getTwoInitialCapitals :: IAutoCorrect a -> Prelude.IO (Prelude.Int)
getTwoInitialCapitals =
  Automation.propertyGet "TwoInitialCapitals" [] Automation.outInt
setTwoInitialCapitals :: Prelude.Int -> IAutoCorrect a -> Prelude.IO ()
setTwoInitialCapitals rHS =
  Automation.propertySet "TwoInitialCapitals" [Automation.inInt rHS]
getCorrectSentenceCap :: IAutoCorrect a -> Prelude.IO (Prelude.Int)
getCorrectSentenceCap =
  Automation.propertyGet "CorrectSentenceCap" [] Automation.outInt
setCorrectSentenceCap :: Prelude.Int -> IAutoCorrect a -> Prelude.IO ()
setCorrectSentenceCap rHS =
  Automation.propertySet "CorrectSentenceCap" [Automation.inInt rHS]
getCorrectCapsLock :: IAutoCorrect a -> Prelude.IO (Prelude.Int)
getCorrectCapsLock =
  Automation.propertyGet "CorrectCapsLock" [] Automation.outInt
setCorrectCapsLock :: Prelude.Int -> IAutoCorrect a -> Prelude.IO ()
setCorrectCapsLock rHS =
  Automation.propertySet "CorrectCapsLock" [Automation.inInt rHS]
-- --------------------------------------------------
-- 
-- interface IBorder
-- 
-- --------------------------------------------------
data Border a = Border
                 
type IBorder a = Automation.IDispatch (Border a)
iidIBorder :: Com.IID (IBorder Automation.Interface)
iidIBorder = Com.mkIID "{00020854-0001-0000-C000-000000000046}"
-- --------------------------------------------------
-- 
-- interface IInterior
-- 
-- --------------------------------------------------
data Interior a = Interior
                   
type IInterior a = Automation.IDispatch (Interior a)
iidIInterior :: Com.IID (IInterior Automation.Interface)
iidIInterior = Com.mkIID "{00020870-0001-0000-C000-000000000046}"
getInvertIfNegative :: IInterior a -> Prelude.IO (Prelude.Int)
getInvertIfNegative =
  Automation.propertyGet "InvertIfNegative" [] Automation.outInt
setInvertIfNegative :: Prelude.Int -> IInterior a -> Prelude.IO ()
setInvertIfNegative rHS =
  Automation.propertySet "InvertIfNegative" [Automation.inInt rHS]
getPattern1 :: IInterior a -> Prelude.IO (Prelude.Int)
getPattern1 = Automation.propertyGet "Pattern" [] Automation.outInt
setPattern0 :: Prelude.Int -> IInterior a -> Prelude.IO ()
setPattern0 rHS =
  Automation.propertySet "Pattern" [Automation.inInt rHS]
getPatternColor :: IInterior a -> Prelude.IO (Prelude.Int)
getPatternColor =
  Automation.propertyGet "PatternColor" [] Automation.outInt
setPatternColor :: Prelude.Int -> IInterior a -> Prelude.IO ()
setPatternColor rHS =
  Automation.propertySet "PatternColor" [Automation.inInt rHS]
getPatternColorIndex :: IInterior a -> Prelude.IO (Prelude.Int)
getPatternColorIndex =
  Automation.propertyGet "PatternColorIndex" [] Automation.outInt
setPatternColorIndex :: Prelude.Int -> IInterior a -> Prelude.IO ()
setPatternColorIndex rHS =
  Automation.propertySet "PatternColorIndex" [Automation.inInt rHS]
-- --------------------------------------------------
-- 
-- interface IChartFillFormat
-- 
-- --------------------------------------------------
data ChartFillFormat a = ChartFillFormat
                          
type IChartFillFormat a = Automation.IDispatch (ChartFillFormat a)
iidIChartFillFormat :: Com.IID (IChartFillFormat Automation.Interface)
iidIChartFillFormat =
  Com.mkIID "{00024435-0001-0000-C000-000000000046}"
userPicture0 :: Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> IChartFillFormat a -> Prelude.IO ()
userPicture0 pictureFile pictureFormat pictureStackUnit picturePlacement =
  Automation.method0 "UserPicture" [Automation.inInt pictureFile, Automation.inInt pictureFormat, Automation.inInt pictureStackUnit, Automation.inInt picturePlacement]
getBackColor1 :: IChartFillFormat a -> Prelude.IO (IChartColorFormat Automation.Interface)
getBackColor1 =
  Automation.propertyGet "BackColor" [] Automation.outIDispatch
getForeColor2 :: IChartFillFormat a -> Prelude.IO (IChartColorFormat Automation.Interface)
getForeColor2 =
  Automation.propertyGet "ForeColor" [] Automation.outIDispatch
-- --------------------------------------------------
-- 
-- interface IChartColorFormat
-- 
-- --------------------------------------------------
data ChartColorFormat a = ChartColorFormat
                           
type IChartColorFormat a = Automation.IDispatch (ChartColorFormat a)
iidIChartColorFormat :: Com.IID (IChartColorFormat Automation.Interface)
iidIChartColorFormat =
  Com.mkIID "{00024436-0001-0000-C000-000000000046}"
-- --------------------------------------------------
-- 
-- interface IAxis
-- 
-- --------------------------------------------------
data Axis a = Axis
               
type IAxis a = Automation.IDispatch (Axis a)
iidIAxis :: Com.IID (IAxis Automation.Interface)
iidIAxis = Com.mkIID "{00020848-0001-0000-C000-000000000046}"
getAxisBetweenCategories :: IAxis a -> Prelude.IO (Prelude.Int)
getAxisBetweenCategories =
  Automation.propertyGet "AxisBetweenCategories" [] Automation.outInt
setAxisBetweenCategories :: Prelude.Int -> IAxis a -> Prelude.IO ()
setAxisBetweenCategories rHS =
  Automation.propertySet "AxisBetweenCategories" [Automation.inInt rHS]
getAxisGroup :: (Automation.Variant a0) => Automation.IDispatch a -> Prelude.IO (a0)
getAxisGroup =
  Automation.propertyGet "AxisGroup" [] Automation.outVariant
getAxisTitle :: IAxis a -> Prelude.IO (IAxisTitle Automation.Interface)
getAxisTitle =
  Automation.propertyGet "AxisTitle" [] Automation.outIDispatch
getCategoryNames :: IAxis a -> Prelude.IO (Prelude.Int)
getCategoryNames =
  Automation.propertyGet "CategoryNames" [] Automation.outInt
setCategoryNames :: Prelude.Int -> IAxis a -> Prelude.IO ()
setCategoryNames rHS =
  Automation.propertySet "CategoryNames" [Automation.inInt rHS]
getCrosses :: (Automation.Variant a0) => IAxis a -> Prelude.IO (a0)
getCrosses =
  Automation.propertyGet "Crosses" [] Automation.outVariant
setCrosses :: (Automation.Variant a0) => a0 -> IAxis a -> Prelude.IO ()
setCrosses rHS =
  Automation.propertySet "Crosses" [Automation.inVariant rHS]
getCrossesAt :: IAxis a -> Prelude.IO (Prelude.Double)
getCrossesAt =
  Automation.propertyGet "CrossesAt" [] Automation.outDouble
setCrossesAt :: Prelude.Double -> IAxis a -> Prelude.IO ()
setCrossesAt rHS =
  Automation.propertySet "CrossesAt" [Automation.inDouble rHS]
getHasMajorGridlines :: IAxis a -> Prelude.IO (Prelude.Int)
getHasMajorGridlines =
  Automation.propertyGet "HasMajorGridlines" [] Automation.outInt
setHasMajorGridlines :: Prelude.Int -> IAxis a -> Prelude.IO ()
setHasMajorGridlines rHS =
  Automation.propertySet "HasMajorGridlines" [Automation.inInt rHS]
getHasMinorGridlines :: IAxis a -> Prelude.IO (Prelude.Int)
getHasMinorGridlines =
  Automation.propertyGet "HasMinorGridlines" [] Automation.outInt
setHasMinorGridlines :: Prelude.Int -> IAxis a -> Prelude.IO ()
setHasMinorGridlines rHS =
  Automation.propertySet "HasMinorGridlines" [Automation.inInt rHS]
getHasTitle0 :: IAxis a -> Prelude.IO (Prelude.Int)
getHasTitle0 =
  Automation.propertyGet "HasTitle" [] Automation.outInt
setHasTitle0 :: Prelude.Int -> IAxis a -> Prelude.IO ()
setHasTitle0 rHS =
  Automation.propertySet "HasTitle" [Automation.inInt rHS]
getMajorGridlines :: IAxis a -> Prelude.IO (IGridlines Automation.Interface)
getMajorGridlines =
  Automation.propertyGet "MajorGridlines" [] Automation.outIDispatch
getMajorTickMark :: (Automation.Variant a0) => IAxis a -> Prelude.IO (a0)
getMajorTickMark =
  Automation.propertyGet "MajorTickMark" [] Automation.outVariant
setMajorTickMark :: (Automation.Variant a0) => a0 -> IAxis a -> Prelude.IO ()
setMajorTickMark rHS =
  Automation.propertySet "MajorTickMark" [Automation.inVariant rHS]
getMajorUnit :: IAxis a -> Prelude.IO (Prelude.Double)
getMajorUnit =
  Automation.propertyGet "MajorUnit" [] Automation.outDouble
setMajorUnit :: Prelude.Double -> IAxis a -> Prelude.IO ()
setMajorUnit rHS =
  Automation.propertySet "MajorUnit" [Automation.inDouble rHS]
getMajorUnitIsAuto :: IAxis a -> Prelude.IO (Prelude.Int)
getMajorUnitIsAuto =
  Automation.propertyGet "MajorUnitIsAuto" [] Automation.outInt
setMajorUnitIsAuto :: Prelude.Int -> IAxis a -> Prelude.IO ()
setMajorUnitIsAuto rHS =
  Automation.propertySet "MajorUnitIsAuto" [Automation.inInt rHS]
getMaximumScale :: IAxis a -> Prelude.IO (Prelude.Double)
getMaximumScale =
  Automation.propertyGet "MaximumScale" [] Automation.outDouble
setMaximumScale :: Prelude.Double -> IAxis a -> Prelude.IO ()
setMaximumScale rHS =
  Automation.propertySet "MaximumScale" [Automation.inDouble rHS]
getMaximumScaleIsAuto :: IAxis a -> Prelude.IO (Prelude.Int)
getMaximumScaleIsAuto =
  Automation.propertyGet "MaximumScaleIsAuto" [] Automation.outInt
setMaximumScaleIsAuto :: Prelude.Int -> IAxis a -> Prelude.IO ()
setMaximumScaleIsAuto rHS =
  Automation.propertySet "MaximumScaleIsAuto" [Automation.inInt rHS]
getMinimumScale :: IAxis a -> Prelude.IO (Prelude.Double)
getMinimumScale =
  Automation.propertyGet "MinimumScale" [] Automation.outDouble
setMinimumScale :: Prelude.Double -> IAxis a -> Prelude.IO ()
setMinimumScale rHS =
  Automation.propertySet "MinimumScale" [Automation.inDouble rHS]
getMinimumScaleIsAuto :: IAxis a -> Prelude.IO (Prelude.Int)
getMinimumScaleIsAuto =
  Automation.propertyGet "MinimumScaleIsAuto" [] Automation.outInt
setMinimumScaleIsAuto :: Prelude.Int -> IAxis a -> Prelude.IO ()
setMinimumScaleIsAuto rHS =
  Automation.propertySet "MinimumScaleIsAuto" [Automation.inInt rHS]
getMinorGridlines :: IAxis a -> Prelude.IO (IGridlines Automation.Interface)
getMinorGridlines =
  Automation.propertyGet "MinorGridlines" [] Automation.outIDispatch
getMinorTickMark :: (Automation.Variant a0) => IAxis a -> Prelude.IO (a0)
getMinorTickMark =
  Automation.propertyGet "MinorTickMark" [] Automation.outVariant
setMinorTickMark :: (Automation.Variant a0) => a0 -> IAxis a -> Prelude.IO ()
setMinorTickMark rHS =
  Automation.propertySet "MinorTickMark" [Automation.inVariant rHS]
getMinorUnit :: IAxis a -> Prelude.IO (Prelude.Double)
getMinorUnit =
  Automation.propertyGet "MinorUnit" [] Automation.outDouble
setMinorUnit :: Prelude.Double -> IAxis a -> Prelude.IO ()
setMinorUnit rHS =
  Automation.propertySet "MinorUnit" [Automation.inDouble rHS]
getMinorUnitIsAuto :: IAxis a -> Prelude.IO (Prelude.Int)
getMinorUnitIsAuto =
  Automation.propertyGet "MinorUnitIsAuto" [] Automation.outInt
setMinorUnitIsAuto :: Prelude.Int -> IAxis a -> Prelude.IO ()
setMinorUnitIsAuto rHS =
  Automation.propertySet "MinorUnitIsAuto" [Automation.inInt rHS]
getReversePlotOrder :: IAxis a -> Prelude.IO (Prelude.Int)
getReversePlotOrder =
  Automation.propertyGet "ReversePlotOrder" [] Automation.outInt
setReversePlotOrder :: Prelude.Int -> IAxis a -> Prelude.IO ()
setReversePlotOrder rHS =
  Automation.propertySet "ReversePlotOrder" [Automation.inInt rHS]
getScaleType :: (Automation.Variant a0) => IAxis a -> Prelude.IO (a0)
getScaleType =
  Automation.propertyGet "ScaleType" [] Automation.outVariant
setScaleType :: (Automation.Variant a0) => a0 -> IAxis a -> Prelude.IO ()
setScaleType rHS =
  Automation.propertySet "ScaleType" [Automation.inVariant rHS]
getTickLabelPosition :: (Automation.Variant a0) => IAxis a -> Prelude.IO (a0)
getTickLabelPosition =
  Automation.propertyGet "TickLabelPosition" [] Automation.outVariant
setTickLabelPosition :: (Automation.Variant a0) => a0 -> IAxis a -> Prelude.IO ()
setTickLabelPosition rHS =
  Automation.propertySet "TickLabelPosition" [Automation.inVariant rHS]
getTickLabels :: IAxis a -> Prelude.IO (ITickLabels Automation.Interface)
getTickLabels =
  Automation.propertyGet "TickLabels" [] Automation.outIDispatch
getTickLabelSpacing :: IAxis a -> Prelude.IO (Prelude.Int)
getTickLabelSpacing =
  Automation.propertyGet "TickLabelSpacing" [] Automation.outInt
setTickLabelSpacing :: Prelude.Int -> IAxis a -> Prelude.IO ()
setTickLabelSpacing rHS =
  Automation.propertySet "TickLabelSpacing" [Automation.inInt rHS]
getTickMarkSpacing :: IAxis a -> Prelude.IO (Prelude.Int)
getTickMarkSpacing =
  Automation.propertyGet "TickMarkSpacing" [] Automation.outInt
setTickMarkSpacing :: Prelude.Int -> IAxis a -> Prelude.IO ()
setTickMarkSpacing rHS =
  Automation.propertySet "TickMarkSpacing" [Automation.inInt rHS]
getType14 :: (Automation.Variant a0) => IAxis a -> Prelude.IO (a0)
getType14 = Automation.propertyGet "Type" [] Automation.outVariant
setType4 :: (Automation.Variant a0) => a0 -> IAxis a -> Prelude.IO ()
setType4 rHS =
  Automation.propertySet "Type" [Automation.inVariant rHS]
getBaseUnit :: (Automation.Variant a0) => IAxis a -> Prelude.IO (a0)
getBaseUnit =
  Automation.propertyGet "BaseUnit" [] Automation.outVariant
setBaseUnit :: (Automation.Variant a0) => a0 -> IAxis a -> Prelude.IO ()
setBaseUnit rHS =
  Automation.propertySet "BaseUnit" [Automation.inVariant rHS]
getBaseUnitIsAuto :: IAxis a -> Prelude.IO (Prelude.Int)
getBaseUnitIsAuto =
  Automation.propertyGet "BaseUnitIsAuto" [] Automation.outInt
setBaseUnitIsAuto :: Prelude.Int -> IAxis a -> Prelude.IO ()
setBaseUnitIsAuto rHS =
  Automation.propertySet "BaseUnitIsAuto" [Automation.inInt rHS]
getMajorUnitScale :: (Automation.Variant a0) => IAxis a -> Prelude.IO (a0)
getMajorUnitScale =
  Automation.propertyGet "MajorUnitScale" [] Automation.outVariant
setMajorUnitScale :: (Automation.Variant a0) => a0 -> IAxis a -> Prelude.IO ()
setMajorUnitScale rHS =
  Automation.propertySet "MajorUnitScale" [Automation.inVariant rHS]
getMinorUnitScale :: (Automation.Variant a0) => IAxis a -> Prelude.IO (a0)
getMinorUnitScale =
  Automation.propertyGet "MinorUnitScale" [] Automation.outVariant
setMinorUnitScale :: (Automation.Variant a0) => a0 -> IAxis a -> Prelude.IO ()
setMinorUnitScale rHS =
  Automation.propertySet "MinorUnitScale" [Automation.inVariant rHS]
getCategoryType :: (Automation.Variant a0) => IAxis a -> Prelude.IO (a0)
getCategoryType =
  Automation.propertyGet "CategoryType" [] Automation.outVariant
setCategoryType :: (Automation.Variant a0) => a0 -> IAxis a -> Prelude.IO ()
setCategoryType rHS =
  Automation.propertySet "CategoryType" [Automation.inVariant rHS]
-- --------------------------------------------------
-- 
-- interface IChartTitle
-- 
-- --------------------------------------------------
data ChartTitle a = ChartTitle
                     
type IChartTitle a = Automation.IDispatch (ChartTitle a)
iidIChartTitle :: Com.IID (IChartTitle Automation.Interface)
iidIChartTitle = Com.mkIID "{00020849-0001-0000-C000-000000000046}"
getFill :: Automation.IDispatch a -> Prelude.IO (IChartFillFormat Automation.Interface)
getFill = Automation.propertyGet "Fill" [] Automation.outIDispatch
-- --------------------------------------------------
-- 
-- interface IAxisTitle
-- 
-- --------------------------------------------------
data AxisTitle a = AxisTitle
                    
type IAxisTitle a = Automation.IDispatch (AxisTitle a)
iidIAxisTitle :: Com.IID (IAxisTitle Automation.Interface)
iidIAxisTitle = Com.mkIID "{0002084A-0001-0000-C000-000000000046}"
-- --------------------------------------------------
-- 
-- interface IChartGroup
-- 
-- --------------------------------------------------
data ChartGroup a = ChartGroup
                     
type IChartGroup a = Automation.IDispatch (ChartGroup a)
iidIChartGroup :: Com.IID (IChartGroup Automation.Interface)
iidIChartGroup = Com.mkIID "{00020859-0001-0000-C000-000000000046}"
setAxisGroup :: (Automation.Variant a0) => a0 -> Automation.IDispatch a -> Prelude.IO ()
setAxisGroup rHS =
  Automation.propertySet "AxisGroup" [Automation.inVariant rHS]
getDoughnutHoleSize :: IChartGroup a -> Prelude.IO (Prelude.Int)
getDoughnutHoleSize =
  Automation.propertyGet "DoughnutHoleSize" [] Automation.outInt
setDoughnutHoleSize :: Prelude.Int -> IChartGroup a -> Prelude.IO ()
setDoughnutHoleSize rHS =
  Automation.propertySet "DoughnutHoleSize" [Automation.inInt rHS]
getDownBars :: IChartGroup a -> Prelude.IO (IDownBars Automation.Interface)
getDownBars =
  Automation.propertyGet "DownBars" [] Automation.outIDispatch
getDropLines :: IChartGroup a -> Prelude.IO (IDropLines Automation.Interface)
getDropLines =
  Automation.propertyGet "DropLines" [] Automation.outIDispatch
getFirstSliceAngle :: IChartGroup a -> Prelude.IO (Prelude.Int)
getFirstSliceAngle =
  Automation.propertyGet "FirstSliceAngle" [] Automation.outInt
setFirstSliceAngle :: Prelude.Int -> IChartGroup a -> Prelude.IO ()
setFirstSliceAngle rHS =
  Automation.propertySet "FirstSliceAngle" [Automation.inInt rHS]
getGapWidth :: IChartGroup a -> Prelude.IO (Prelude.Int)
getGapWidth =
  Automation.propertyGet "GapWidth" [] Automation.outInt
setGapWidth :: Prelude.Int -> IChartGroup a -> Prelude.IO ()
setGapWidth rHS =
  Automation.propertySet "GapWidth" [Automation.inInt rHS]
getHasDropLines :: IChartGroup a -> Prelude.IO (Prelude.Int)
getHasDropLines =
  Automation.propertyGet "HasDropLines" [] Automation.outInt
setHasDropLines :: Prelude.Int -> IChartGroup a -> Prelude.IO ()
setHasDropLines rHS =
  Automation.propertySet "HasDropLines" [Automation.inInt rHS]
getHasHiLoLines :: IChartGroup a -> Prelude.IO (Prelude.Int)
getHasHiLoLines =
  Automation.propertyGet "HasHiLoLines" [] Automation.outInt
setHasHiLoLines :: Prelude.Int -> IChartGroup a -> Prelude.IO ()
setHasHiLoLines rHS =
  Automation.propertySet "HasHiLoLines" [Automation.inInt rHS]
getHasRadarAxisLabels :: IChartGroup a -> Prelude.IO (Prelude.Int)
getHasRadarAxisLabels =
  Automation.propertyGet "HasRadarAxisLabels" [] Automation.outInt
setHasRadarAxisLabels :: Prelude.Int -> IChartGroup a -> Prelude.IO ()
setHasRadarAxisLabels rHS =
  Automation.propertySet "HasRadarAxisLabels" [Automation.inInt rHS]
getHasSeriesLines :: IChartGroup a -> Prelude.IO (Prelude.Int)
getHasSeriesLines =
  Automation.propertyGet "HasSeriesLines" [] Automation.outInt
setHasSeriesLines :: Prelude.Int -> IChartGroup a -> Prelude.IO ()
setHasSeriesLines rHS =
  Automation.propertySet "HasSeriesLines" [Automation.inInt rHS]
getHasUpDownBars :: IChartGroup a -> Prelude.IO (Prelude.Int)
getHasUpDownBars =
  Automation.propertyGet "HasUpDownBars" [] Automation.outInt
setHasUpDownBars :: Prelude.Int -> IChartGroup a -> Prelude.IO ()
setHasUpDownBars rHS =
  Automation.propertySet "HasUpDownBars" [Automation.inInt rHS]
getHiLoLines :: IChartGroup a -> Prelude.IO (IHiLoLines Automation.Interface)
getHiLoLines =
  Automation.propertyGet "HiLoLines" [] Automation.outIDispatch
getOverlap :: IChartGroup a -> Prelude.IO (Prelude.Int)
getOverlap = Automation.propertyGet "Overlap" [] Automation.outInt
setOverlap :: Prelude.Int -> IChartGroup a -> Prelude.IO ()
setOverlap rHS =
  Automation.propertySet "Overlap" [Automation.inInt rHS]
getRadarAxisLabels :: IChartGroup a -> Prelude.IO (ITickLabels Automation.Interface)
getRadarAxisLabels =
  Automation.propertyGet "RadarAxisLabels" [] Automation.outIDispatch
seriesCollection0 :: Prelude.Int -> IChartGroup a -> Prelude.IO (Automation.IDispatch Automation.Interface)
seriesCollection0 index =
  Automation.function1 "SeriesCollection" [Automation.inInt index] Automation.outIDispatch
getSeriesLines :: IChartGroup a -> Prelude.IO (ISeriesLines Automation.Interface)
getSeriesLines =
  Automation.propertyGet "SeriesLines" [] Automation.outIDispatch
getSubType0 :: IChartGroup a -> Prelude.IO (Prelude.Int)
getSubType0 = Automation.propertyGet "SubType" [] Automation.outInt
setSubType0 :: Prelude.Int -> Automation.IDispatch a -> Prelude.IO ()
setSubType0 rHS =
  Automation.propertySet "SubType" [Automation.inInt rHS]
setType5 :: Prelude.Int -> Automation.IDispatch a -> Prelude.IO ()
setType5 rHS = Automation.propertySet "Type" [Automation.inInt rHS]
getUpBars :: IChartGroup a -> Prelude.IO (IUpBars Automation.Interface)
getUpBars =
  Automation.propertyGet "UpBars" [] Automation.outIDispatch
getVaryByCategories :: IChartGroup a -> Prelude.IO (Prelude.Int)
getVaryByCategories =
  Automation.propertyGet "VaryByCategories" [] Automation.outInt
setVaryByCategories :: Prelude.Int -> IChartGroup a -> Prelude.IO ()
setVaryByCategories rHS =
  Automation.propertySet "VaryByCategories" [Automation.inInt rHS]
getSizeRepresents :: (Automation.Variant a0) => IChartGroup a -> Prelude.IO (a0)
getSizeRepresents =
  Automation.propertyGet "SizeRepresents" [] Automation.outVariant
setSizeRepresents :: (Automation.Variant a0) => a0 -> IChartGroup a -> Prelude.IO ()
setSizeRepresents rHS =
  Automation.propertySet "SizeRepresents" [Automation.inVariant rHS]
getBubbleScale :: IChartGroup a -> Prelude.IO (Prelude.Int)
getBubbleScale =
  Automation.propertyGet "BubbleScale" [] Automation.outInt
setBubbleScale :: Prelude.Int -> IChartGroup a -> Prelude.IO ()
setBubbleScale rHS =
  Automation.propertySet "BubbleScale" [Automation.inInt rHS]
getShowNegativeBubbles :: IChartGroup a -> Prelude.IO (Prelude.Int)
getShowNegativeBubbles =
  Automation.propertyGet "ShowNegativeBubbles" [] Automation.outInt
setShowNegativeBubbles :: Prelude.Int -> IChartGroup a -> Prelude.IO ()
setShowNegativeBubbles rHS =
  Automation.propertySet "ShowNegativeBubbles" [Automation.inInt rHS]
getSplitType :: (Automation.Variant a0) => IChartGroup a -> Prelude.IO (a0)
getSplitType =
  Automation.propertyGet "SplitType" [] Automation.outVariant
setSplitType :: (Automation.Variant a0) => a0 -> IChartGroup a -> Prelude.IO ()
setSplitType rHS =
  Automation.propertySet "SplitType" [Automation.inVariant rHS]
getSplitValue :: IChartGroup a -> Prelude.IO (Prelude.Int)
getSplitValue =
  Automation.propertyGet "SplitValue" [] Automation.outInt
setSplitValue :: Prelude.Int -> IChartGroup a -> Prelude.IO ()
setSplitValue rHS =
  Automation.propertySet "SplitValue" [Automation.inInt rHS]
getSecondPlotSize :: IChartGroup a -> Prelude.IO (Prelude.Int)
getSecondPlotSize =
  Automation.propertyGet "SecondPlotSize" [] Automation.outInt
setSecondPlotSize :: Prelude.Int -> IChartGroup a -> Prelude.IO ()
setSecondPlotSize rHS =
  Automation.propertySet "SecondPlotSize" [Automation.inInt rHS]
getHas3DShading :: IChartGroup a -> Prelude.IO (Prelude.Int)
getHas3DShading =
  Automation.propertyGet "Has3DShading" [] Automation.outInt
setHas3DShading :: Prelude.Int -> IChartGroup a -> Prelude.IO ()
setHas3DShading rHS =
  Automation.propertySet "Has3DShading" [Automation.inInt rHS]
-- --------------------------------------------------
-- 
-- interface IChartGroups
-- 
-- --------------------------------------------------
data ChartGroups a = ChartGroups
                      
type IChartGroups a = Automation.IDispatch (ChartGroups a)
iidIChartGroups :: Com.IID (IChartGroups Automation.Interface)
iidIChartGroups =
  Com.mkIID "{0002085A-0001-0000-C000-000000000046}"
item36 :: Prelude.Int -> IChartGroups a -> Prelude.IO (IChartGroup Automation.Interface)
item36 index =
  Automation.function1 "Item" [Automation.inInt index] Automation.outIDispatch
-- --------------------------------------------------
-- 
-- interface IAxes
-- 
-- --------------------------------------------------
data Axes a = Axes
               
type IAxes a = Automation.IDispatch (Axes a)
iidIAxes :: Com.IID (IAxes Automation.Interface)
iidIAxes = Com.mkIID "{0002085B-0001-0000-C000-000000000046}"
item37 :: (Automation.Variant a0, Automation.Variant a1) => a0 -> a1 -> IAxes a -> Prelude.IO (IAxis Automation.Interface)
item37 type0 axisGroup =
  Automation.function1 "Item" [Automation.inVariant type0, Automation.inVariant axisGroup] Automation.outIDispatch
-- --------------------------------------------------
-- 
-- interface IPoints
-- 
-- --------------------------------------------------
data Points a = Points
                 
type IPoints a = Automation.IDispatch (Points a)
iidIPoints :: Com.IID (IPoints Automation.Interface)
iidIPoints = Com.mkIID "{00020869-0001-0000-C000-000000000046}"
item38 :: Prelude.Int -> IPoints a -> Prelude.IO (IPoint Automation.Interface)
item38 index =
  Automation.function1 "Item" [Automation.inInt index] Automation.outIDispatch
-- --------------------------------------------------
-- 
-- interface IPoint
-- 
-- --------------------------------------------------
data Point a = Point
                
type IPoint a = Automation.IDispatch (Point a)
iidIPoint :: Com.IID (IPoint Automation.Interface)
iidIPoint = Com.mkIID "{0002086A-0001-0000-C000-000000000046}"
applyDataLabels0 :: (Automation.Variant a0) => a0 -> Prelude.Int -> Prelude.Int -> Automation.IDispatch a -> Prelude.IO ()
applyDataLabels0 type0 legendKey autoText =
  Automation.method0 "ApplyDataLabels" [Automation.inVariant type0, Automation.inInt legendKey, Automation.inInt autoText]
getDataLabel :: Automation.IDispatch a -> Prelude.IO (IDataLabel Automation.Interface)
getDataLabel =
  Automation.propertyGet "DataLabel" [] Automation.outIDispatch
getExplosion :: Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getExplosion =
  Automation.propertyGet "Explosion" [] Automation.outInt
setExplosion :: Prelude.Int -> Automation.IDispatch a -> Prelude.IO ()
setExplosion rHS =
  Automation.propertySet "Explosion" [Automation.inInt rHS]
getHasDataLabel :: IPoint a -> Prelude.IO (Prelude.Int)
getHasDataLabel =
  Automation.propertyGet "HasDataLabel" [] Automation.outInt
setHasDataLabel :: Prelude.Int -> IPoint a -> Prelude.IO ()
setHasDataLabel rHS =
  Automation.propertySet "HasDataLabel" [Automation.inInt rHS]
getInvertIfNegative0 :: Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getInvertIfNegative0 =
  Automation.propertyGet "InvertIfNegative" [] Automation.outInt
setInvertIfNegative0 :: Prelude.Int -> Automation.IDispatch a -> Prelude.IO ()
setInvertIfNegative0 rHS =
  Automation.propertySet "InvertIfNegative" [Automation.inInt rHS]
getMarkerBackgroundColor :: Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getMarkerBackgroundColor =
  Automation.propertyGet "MarkerBackgroundColor" [] Automation.outInt
setMarkerBackgroundColor :: Prelude.Int -> Automation.IDispatch a -> Prelude.IO ()
setMarkerBackgroundColor rHS =
  Automation.propertySet "MarkerBackgroundColor" [Automation.inInt rHS]
getMarkerBackgroundColorIndex :: (Automation.Variant a0) => Automation.IDispatch a -> Prelude.IO (a0)
getMarkerBackgroundColorIndex =
  Automation.propertyGet "MarkerBackgroundColorIndex" [] Automation.outVariant
setMarkerBackgroundColorIndex :: (Automation.Variant a0) => a0 -> Automation.IDispatch a -> Prelude.IO ()
setMarkerBackgroundColorIndex rHS =
  Automation.propertySet "MarkerBackgroundColorIndex" [Automation.inVariant rHS]
getMarkerForegroundColor :: Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getMarkerForegroundColor =
  Automation.propertyGet "MarkerForegroundColor" [] Automation.outInt
setMarkerForegroundColor :: Prelude.Int -> Automation.IDispatch a -> Prelude.IO ()
setMarkerForegroundColor rHS =
  Automation.propertySet "MarkerForegroundColor" [Automation.inInt rHS]
getMarkerForegroundColorIndex :: (Automation.Variant a0) => Automation.IDispatch a -> Prelude.IO (a0)
getMarkerForegroundColorIndex =
  Automation.propertyGet "MarkerForegroundColorIndex" [] Automation.outVariant
setMarkerForegroundColorIndex :: (Automation.Variant a0) => a0 -> Automation.IDispatch a -> Prelude.IO ()
setMarkerForegroundColorIndex rHS =
  Automation.propertySet "MarkerForegroundColorIndex" [Automation.inVariant rHS]
getMarkerSize :: Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getMarkerSize =
  Automation.propertyGet "MarkerSize" [] Automation.outInt
setMarkerSize :: Prelude.Int -> Automation.IDispatch a -> Prelude.IO ()
setMarkerSize rHS =
  Automation.propertySet "MarkerSize" [Automation.inInt rHS]
getMarkerStyle :: (Automation.Variant a0) => Automation.IDispatch a -> Prelude.IO (a0)
getMarkerStyle =
  Automation.propertyGet "MarkerStyle" [] Automation.outVariant
setMarkerStyle :: (Automation.Variant a0) => a0 -> Automation.IDispatch a -> Prelude.IO ()
setMarkerStyle rHS =
  Automation.propertySet "MarkerStyle" [Automation.inVariant rHS]
paste3 :: Automation.IDispatch a -> Prelude.IO ()
paste3 = Automation.method0 "Paste" []
getPictureType :: (Automation.Variant a0) => Automation.IDispatch a -> Prelude.IO (a0)
getPictureType =
  Automation.propertyGet "PictureType" [] Automation.outVariant
setPictureType :: (Automation.Variant a0) => a0 -> Automation.IDispatch a -> Prelude.IO ()
setPictureType rHS =
  Automation.propertySet "PictureType" [Automation.inVariant rHS]
getPictureUnit :: Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getPictureUnit =
  Automation.propertyGet "PictureUnit" [] Automation.outInt
setPictureUnit :: Prelude.Int -> Automation.IDispatch a -> Prelude.IO ()
setPictureUnit rHS =
  Automation.propertySet "PictureUnit" [Automation.inInt rHS]
getApplyPictToSides :: Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getApplyPictToSides =
  Automation.propertyGet "ApplyPictToSides" [] Automation.outInt
setApplyPictToSides :: Prelude.Int -> Automation.IDispatch a -> Prelude.IO ()
setApplyPictToSides rHS =
  Automation.propertySet "ApplyPictToSides" [Automation.inInt rHS]
getApplyPictToFront :: Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getApplyPictToFront =
  Automation.propertyGet "ApplyPictToFront" [] Automation.outInt
setApplyPictToFront :: Prelude.Int -> Automation.IDispatch a -> Prelude.IO ()
setApplyPictToFront rHS =
  Automation.propertySet "ApplyPictToFront" [Automation.inInt rHS]
getApplyPictToEnd :: Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getApplyPictToEnd =
  Automation.propertyGet "ApplyPictToEnd" [] Automation.outInt
setApplyPictToEnd :: Prelude.Int -> Automation.IDispatch a -> Prelude.IO ()
setApplyPictToEnd rHS =
  Automation.propertySet "ApplyPictToEnd" [Automation.inInt rHS]
getSecondaryPlot :: IPoint a -> Prelude.IO (Prelude.Int)
getSecondaryPlot =
  Automation.propertyGet "SecondaryPlot" [] Automation.outInt
setSecondaryPlot :: Prelude.Int -> IPoint a -> Prelude.IO ()
setSecondaryPlot rHS =
  Automation.propertySet "SecondaryPlot" [Automation.inInt rHS]
-- --------------------------------------------------
-- 
-- interface ISeries
-- 
-- --------------------------------------------------
data Series a = Series
                 
type ISeries a = Automation.IDispatch (Series a)
iidISeries :: Com.IID (ISeries Automation.Interface)
iidISeries = Com.mkIID "{0002086B-0001-0000-C000-000000000046}"
applyDataLabels1 :: (Automation.Variant a0) => a0 -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Automation.IDispatch a -> Prelude.IO ()
applyDataLabels1 type0 legendKey autoText hasLeaderLines =
  Automation.method0 "ApplyDataLabels" [Automation.inVariant type0, Automation.inInt legendKey, Automation.inInt autoText, Automation.inInt hasLeaderLines]
dataLabels :: Prelude.Int -> ISeries a -> Prelude.IO (Automation.IDispatch Automation.Interface)
dataLabels index =
  Automation.function1 "DataLabels" [Automation.inInt index] Automation.outIDispatch
errorBar :: (Automation.Variant a0, Automation.Variant a1, Automation.Variant a2) => a0 -> a1 -> a2 -> Prelude.Int -> Prelude.Int -> ISeries a -> Prelude.IO ()
errorBar direction include type0 amount minusValues =
  Automation.method0 "ErrorBar" [Automation.inVariant direction, Automation.inVariant include, Automation.inVariant type0, Automation.inInt amount, Automation.inInt minusValues]
getErrorBars :: ISeries a -> Prelude.IO (IErrorBars Automation.Interface)
getErrorBars =
  Automation.propertyGet "ErrorBars" [] Automation.outIDispatch
getFormulaLocal0 :: ISeries a -> Prelude.IO (Prelude.String)
getFormulaLocal0 =
  Automation.propertyGet "FormulaLocal" [] Automation.outString
setFormulaLocal0 :: Prelude.String -> ISeries a -> Prelude.IO ()
setFormulaLocal0 rHS =
  Automation.propertySet "FormulaLocal" [Automation.inString rHS]
getFormulaR1C10 :: ISeries a -> Prelude.IO (Prelude.String)
getFormulaR1C10 =
  Automation.propertyGet "FormulaR1C1" [] Automation.outString
setFormulaR1C10 :: Prelude.String -> ISeries a -> Prelude.IO ()
setFormulaR1C10 rHS =
  Automation.propertySet "FormulaR1C1" [Automation.inString rHS]
getFormulaR1C1Local0 :: ISeries a -> Prelude.IO (Prelude.String)
getFormulaR1C1Local0 =
  Automation.propertyGet "FormulaR1C1Local" [] Automation.outString
setFormulaR1C1Local0 :: Prelude.String -> ISeries a -> Prelude.IO ()
setFormulaR1C1Local0 rHS =
  Automation.propertySet "FormulaR1C1Local" [Automation.inString rHS]
getHasDataLabels :: ISeries a -> Prelude.IO (Prelude.Int)
getHasDataLabels =
  Automation.propertyGet "HasDataLabels" [] Automation.outInt
setHasDataLabels :: Prelude.Int -> ISeries a -> Prelude.IO ()
setHasDataLabels rHS =
  Automation.propertySet "HasDataLabels" [Automation.inInt rHS]
getHasErrorBars :: ISeries a -> Prelude.IO (Prelude.Int)
getHasErrorBars =
  Automation.propertyGet "HasErrorBars" [] Automation.outInt
setHasErrorBars :: Prelude.Int -> ISeries a -> Prelude.IO ()
setHasErrorBars rHS =
  Automation.propertySet "HasErrorBars" [Automation.inInt rHS]
getPlotOrder :: ISeries a -> Prelude.IO (Prelude.Int)
getPlotOrder =
  Automation.propertyGet "PlotOrder" [] Automation.outInt
setPlotOrder :: Prelude.Int -> ISeries a -> Prelude.IO ()
setPlotOrder rHS =
  Automation.propertySet "PlotOrder" [Automation.inInt rHS]
points :: Prelude.Int -> ISeries a -> Prelude.IO (Automation.IDispatch Automation.Interface)
points index =
  Automation.function1 "Points" [Automation.inInt index] Automation.outIDispatch
getSmooth :: Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getSmooth = Automation.propertyGet "Smooth" [] Automation.outInt
setSmooth :: Prelude.Int -> Automation.IDispatch a -> Prelude.IO ()
setSmooth rHS =
  Automation.propertySet "Smooth" [Automation.inInt rHS]
trendlines :: Prelude.Int -> ISeries a -> Prelude.IO (Automation.IDispatch Automation.Interface)
trendlines index =
  Automation.function1 "Trendlines" [Automation.inInt index] Automation.outIDispatch
applyCustomType0 :: (Automation.Variant a0) => a0 -> Automation.IDispatch a -> Prelude.IO ()
applyCustomType0 chartType =
  Automation.method0 "ApplyCustomType" [Automation.inVariant chartType]
getValues0 :: ISeries a -> Prelude.IO (Prelude.Int)
getValues0 = Automation.propertyGet "Values" [] Automation.outInt
setValues :: Prelude.Int -> Automation.IDispatch a -> Prelude.IO ()
setValues rHS =
  Automation.propertySet "Values" [Automation.inInt rHS]
getXValues :: ISeries a -> Prelude.IO (Prelude.Int)
getXValues = Automation.propertyGet "XValues" [] Automation.outInt
setXValues :: Prelude.Int -> ISeries a -> Prelude.IO ()
setXValues rHS =
  Automation.propertySet "XValues" [Automation.inInt rHS]
getBubbleSizes :: ISeries a -> Prelude.IO (Prelude.Int)
getBubbleSizes =
  Automation.propertyGet "BubbleSizes" [] Automation.outInt
setBubbleSizes :: Prelude.Int -> ISeries a -> Prelude.IO ()
setBubbleSizes rHS =
  Automation.propertySet "BubbleSizes" [Automation.inInt rHS]
getHas3DEffect :: ISeries a -> Prelude.IO (Prelude.Int)
getHas3DEffect =
  Automation.propertyGet "Has3DEffect" [] Automation.outInt
setHas3DEffect :: Prelude.Int -> ISeries a -> Prelude.IO ()
setHas3DEffect rHS =
  Automation.propertySet "Has3DEffect" [Automation.inInt rHS]
getHasLeaderLines :: ISeries a -> Prelude.IO (Prelude.Int)
getHasLeaderLines =
  Automation.propertyGet "HasLeaderLines" [] Automation.outInt
setHasLeaderLines :: Prelude.Int -> ISeries a -> Prelude.IO ()
setHasLeaderLines rHS =
  Automation.propertySet "HasLeaderLines" [Automation.inInt rHS]
getLeaderLines :: ISeries a -> Prelude.IO (ILeaderLines Automation.Interface)
getLeaderLines =
  Automation.propertyGet "LeaderLines" [] Automation.outIDispatch
-- --------------------------------------------------
-- 
-- interface ISeriesCollection
-- 
-- --------------------------------------------------
data SeriesCollection a = SeriesCollection
                           
type ISeriesCollection a = Automation.IDispatch (SeriesCollection a)
iidISeriesCollection :: Com.IID (ISeriesCollection Automation.Interface)
iidISeriesCollection =
  Com.mkIID "{0002086C-0001-0000-C000-000000000046}"
add46 :: (Automation.Variant a0) => Prelude.Int -> a0 -> Prelude.Int -> Prelude.Int -> Prelude.Int -> ISeriesCollection a -> Prelude.IO (ISeries Automation.Interface)
add46 source rowcol seriesLabels categoryLabels replace =
  Automation.function1 "Add" [Automation.inInt source, Automation.inVariant rowcol, Automation.inInt seriesLabels, Automation.inInt categoryLabels, Automation.inInt replace] Automation.outIDispatch
extend :: Prelude.Int -> Prelude.Int -> Prelude.Int -> ISeriesCollection a -> Prelude.IO ()
extend source rowcol categoryLabels =
  Automation.method0 "Extend" [Automation.inInt source, Automation.inInt rowcol, Automation.inInt categoryLabels]
item39 :: Prelude.Int -> ISeriesCollection a -> Prelude.IO (ISeries Automation.Interface)
item39 index =
  Automation.function1 "Item" [Automation.inInt index] Automation.outIDispatch
paste5 :: (Automation.Variant a0) => a0 -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> ISeriesCollection a -> Prelude.IO ()
paste5 rowcol seriesLabels categoryLabels replace newSeries =
  Automation.method0 "Paste" [Automation.inVariant rowcol, Automation.inInt seriesLabels, Automation.inInt categoryLabels, Automation.inInt replace, Automation.inInt newSeries]
newSeries :: ISeriesCollection a -> Prelude.IO (ISeries Automation.Interface)
newSeries =
  Automation.function1 "NewSeries" [] Automation.outIDispatch
-- --------------------------------------------------
-- 
-- interface IDataLabel
-- 
-- --------------------------------------------------
data DataLabel a = DataLabel
                    
type IDataLabel a = Automation.IDispatch (DataLabel a)
iidIDataLabel :: Com.IID (IDataLabel Automation.Interface)
iidIDataLabel = Com.mkIID "{000208B2-0001-0000-C000-000000000046}"
getAutoText :: Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getAutoText =
  Automation.propertyGet "AutoText" [] Automation.outInt
setAutoText :: Prelude.Int -> Automation.IDispatch a -> Prelude.IO ()
setAutoText rHS =
  Automation.propertySet "AutoText" [Automation.inInt rHS]
getNumberFormatLinked :: Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getNumberFormatLinked =
  Automation.propertyGet "NumberFormatLinked" [] Automation.outInt
setNumberFormatLinked :: Prelude.Int -> Automation.IDispatch a -> Prelude.IO ()
setNumberFormatLinked rHS =
  Automation.propertySet "NumberFormatLinked" [Automation.inInt rHS]
getShowLegendKey :: Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getShowLegendKey =
  Automation.propertyGet "ShowLegendKey" [] Automation.outInt
setShowLegendKey :: Prelude.Int -> Automation.IDispatch a -> Prelude.IO ()
setShowLegendKey rHS =
  Automation.propertySet "ShowLegendKey" [Automation.inInt rHS]
getPosition2 :: (Automation.Variant a0) => Automation.IDispatch a -> Prelude.IO (a0)
getPosition2 =
  Automation.propertyGet "Position" [] Automation.outVariant
setPosition3 :: (Automation.Variant a0) => a0 -> Automation.IDispatch a -> Prelude.IO ()
setPosition3 rHS =
  Automation.propertySet "Position" [Automation.inVariant rHS]
-- --------------------------------------------------
-- 
-- interface IDataLabels
-- 
-- --------------------------------------------------
data DataLabels a = DataLabels
                     
type IDataLabels a = Automation.IDispatch (DataLabels a)
iidIDataLabels :: Com.IID (IDataLabels Automation.Interface)
iidIDataLabels = Com.mkIID "{000208B3-0001-0000-C000-000000000046}"
dummy13 :: IDataLabels a -> Prelude.IO ()
dummy13 = Automation.method0 "_Dummy13" []
dummy16 :: IDataLabels a -> Prelude.IO ()
dummy16 = Automation.method0 "_Dummy16" []
item40 :: Prelude.Int -> IDataLabels a -> Prelude.IO (IDataLabel Automation.Interface)
item40 index =
  Automation.function1 "Item" [Automation.inInt index] Automation.outIDispatch
-- --------------------------------------------------
-- 
-- interface ILegendEntry
-- 
-- --------------------------------------------------
data LegendEntry a = LegendEntry
                      
type ILegendEntry a = Automation.IDispatch (LegendEntry a)
iidILegendEntry :: Com.IID (ILegendEntry Automation.Interface)
iidILegendEntry =
  Com.mkIID "{000208BA-0001-0000-C000-000000000046}"
getLegendKey :: ILegendEntry a -> Prelude.IO (ILegendKey Automation.Interface)
getLegendKey =
  Automation.propertyGet "LegendKey" [] Automation.outIDispatch
-- --------------------------------------------------
-- 
-- interface ILegendEntries
-- 
-- --------------------------------------------------
data LegendEntries a = LegendEntries
                        
type ILegendEntries a = Automation.IDispatch (LegendEntries a)
iidILegendEntries :: Com.IID (ILegendEntries Automation.Interface)
iidILegendEntries =
  Com.mkIID "{000208BB-0001-0000-C000-000000000046}"
item41 :: Prelude.Int -> ILegendEntries a -> Prelude.IO (ILegendEntry Automation.Interface)
item41 index =
  Automation.function1 "Item" [Automation.inInt index] Automation.outIDispatch
-- --------------------------------------------------
-- 
-- interface ILegendKey
-- 
-- --------------------------------------------------
data LegendKey a = LegendKey
                    
type ILegendKey a = Automation.IDispatch (LegendKey a)
iidILegendKey :: Com.IID (ILegendKey Automation.Interface)
iidILegendKey = Com.mkIID "{000208BC-0001-0000-C000-000000000046}"
getPictureType1 :: Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getPictureType1 =
  Automation.propertyGet "PictureType" [] Automation.outInt
setPictureType1 :: Prelude.Int -> Automation.IDispatch a -> Prelude.IO ()
setPictureType1 rHS =
  Automation.propertySet "PictureType" [Automation.inInt rHS]
-- --------------------------------------------------
-- 
-- interface ITrendlines
-- 
-- --------------------------------------------------
data Trendlines a = Trendlines
                     
type ITrendlines a = Automation.IDispatch (Trendlines a)
iidITrendlines :: Com.IID (ITrendlines Automation.Interface)
iidITrendlines = Com.mkIID "{000208BD-0001-0000-C000-000000000046}"
add47 :: (Automation.Variant a0) => a0 -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> ITrendlines a -> Prelude.IO (ITrendline Automation.Interface)
add47 type0 order period forward backward intercept displayEquation displayRSquared name =
  Automation.function1 "Add" [Automation.inVariant type0, Automation.inInt order, Automation.inInt period, Automation.inInt forward, Automation.inInt backward, Automation.inInt intercept, Automation.inInt displayEquation, Automation.inInt displayRSquared, Automation.inInt name] Automation.outIDispatch
item42 :: Prelude.Int -> ITrendlines a -> Prelude.IO (ITrendline Automation.Interface)
item42 index =
  Automation.function1 "Item" [Automation.inInt index] Automation.outIDispatch
-- --------------------------------------------------
-- 
-- interface ITrendline
-- 
-- --------------------------------------------------
data Trendline a = Trendline
                    
type ITrendline a = Automation.IDispatch (Trendline a)
iidITrendline :: Com.IID (ITrendline Automation.Interface)
iidITrendline = Com.mkIID "{000208BE-0001-0000-C000-000000000046}"
getBackward :: ITrendline a -> Prelude.IO (Prelude.Int)
getBackward =
  Automation.propertyGet "Backward" [] Automation.outInt
setBackward :: Prelude.Int -> ITrendline a -> Prelude.IO ()
setBackward rHS =
  Automation.propertySet "Backward" [Automation.inInt rHS]
getDisplayEquation :: ITrendline a -> Prelude.IO (Prelude.Int)
getDisplayEquation =
  Automation.propertyGet "DisplayEquation" [] Automation.outInt
setDisplayEquation :: Prelude.Int -> ITrendline a -> Prelude.IO ()
setDisplayEquation rHS =
  Automation.propertySet "DisplayEquation" [Automation.inInt rHS]
getDisplayRSquared :: ITrendline a -> Prelude.IO (Prelude.Int)
getDisplayRSquared =
  Automation.propertyGet "DisplayRSquared" [] Automation.outInt
setDisplayRSquared :: Prelude.Int -> ITrendline a -> Prelude.IO ()
setDisplayRSquared rHS =
  Automation.propertySet "DisplayRSquared" [Automation.inInt rHS]
getForward :: ITrendline a -> Prelude.IO (Prelude.Int)
getForward = Automation.propertyGet "Forward" [] Automation.outInt
setForward :: Prelude.Int -> ITrendline a -> Prelude.IO ()
setForward rHS =
  Automation.propertySet "Forward" [Automation.inInt rHS]
getIntercept :: ITrendline a -> Prelude.IO (Prelude.Double)
getIntercept =
  Automation.propertyGet "Intercept" [] Automation.outDouble
setIntercept :: Prelude.Double -> ITrendline a -> Prelude.IO ()
setIntercept rHS =
  Automation.propertySet "Intercept" [Automation.inDouble rHS]
getInterceptIsAuto :: ITrendline a -> Prelude.IO (Prelude.Int)
getInterceptIsAuto =
  Automation.propertyGet "InterceptIsAuto" [] Automation.outInt
setInterceptIsAuto :: Prelude.Int -> ITrendline a -> Prelude.IO ()
setInterceptIsAuto rHS =
  Automation.propertySet "InterceptIsAuto" [Automation.inInt rHS]
getNameIsAuto :: ITrendline a -> Prelude.IO (Prelude.Int)
getNameIsAuto =
  Automation.propertyGet "NameIsAuto" [] Automation.outInt
setNameIsAuto :: Prelude.Int -> ITrendline a -> Prelude.IO ()
setNameIsAuto rHS =
  Automation.propertySet "NameIsAuto" [Automation.inInt rHS]
getOrder0 :: ITrendline a -> Prelude.IO (Prelude.Int)
getOrder0 = Automation.propertyGet "Order" [] Automation.outInt
setOrder0 :: Prelude.Int -> ITrendline a -> Prelude.IO ()
setOrder0 rHS =
  Automation.propertySet "Order" [Automation.inInt rHS]
getPeriod :: ITrendline a -> Prelude.IO (Prelude.Int)
getPeriod = Automation.propertyGet "Period" [] Automation.outInt
setPeriod :: Prelude.Int -> ITrendline a -> Prelude.IO ()
setPeriod rHS =
  Automation.propertySet "Period" [Automation.inInt rHS]
getType19 :: (Automation.Variant a0) => ITrendline a -> Prelude.IO (a0)
getType19 = Automation.propertyGet "Type" [] Automation.outVariant
setType9 :: (Automation.Variant a0) => a0 -> ITrendline a -> Prelude.IO ()
setType9 rHS =
  Automation.propertySet "Type" [Automation.inVariant rHS]
-- --------------------------------------------------
-- 
-- interface ICorners
-- 
-- --------------------------------------------------
data Corners a = Corners
                  
type ICorners a = Automation.IDispatch (Corners a)
iidICorners :: Com.IID (ICorners Automation.Interface)
iidICorners = Com.mkIID "{000208C0-0001-0000-C000-000000000046}"
-- --------------------------------------------------
-- 
-- interface ISeriesLines
-- 
-- --------------------------------------------------
data SeriesLines a = SeriesLines
                      
type ISeriesLines a = Automation.IDispatch (SeriesLines a)
iidISeriesLines :: Com.IID (ISeriesLines Automation.Interface)
iidISeriesLines =
  Com.mkIID "{000208C1-0001-0000-C000-000000000046}"
-- --------------------------------------------------
-- 
-- interface IHiLoLines
-- 
-- --------------------------------------------------
data HiLoLines a = HiLoLines
                    
type IHiLoLines a = Automation.IDispatch (HiLoLines a)
iidIHiLoLines :: Com.IID (IHiLoLines Automation.Interface)
iidIHiLoLines = Com.mkIID "{000208C2-0001-0000-C000-000000000046}"
-- --------------------------------------------------
-- 
-- interface IGridlines
-- 
-- --------------------------------------------------
data Gridlines a = Gridlines
                    
type IGridlines a = Automation.IDispatch (Gridlines a)
iidIGridlines :: Com.IID (IGridlines Automation.Interface)
iidIGridlines = Com.mkIID "{000208C3-0001-0000-C000-000000000046}"
-- --------------------------------------------------
-- 
-- interface IDropLines
-- 
-- --------------------------------------------------
data DropLines a = DropLines
                    
type IDropLines a = Automation.IDispatch (DropLines a)
iidIDropLines :: Com.IID (IDropLines Automation.Interface)
iidIDropLines = Com.mkIID "{000208C4-0001-0000-C000-000000000046}"
-- --------------------------------------------------
-- 
-- interface ILeaderLines
-- 
-- --------------------------------------------------
data LeaderLines a = LeaderLines
                      
type ILeaderLines a = Automation.IDispatch (LeaderLines a)
iidILeaderLines :: Com.IID (ILeaderLines Automation.Interface)
iidILeaderLines =
  Com.mkIID "{00024437-0001-0000-C000-000000000046}"
-- --------------------------------------------------
-- 
-- interface IUpBars
-- 
-- --------------------------------------------------
data UpBars a = UpBars
                 
type IUpBars a = Automation.IDispatch (UpBars a)
iidIUpBars :: Com.IID (IUpBars Automation.Interface)
iidIUpBars = Com.mkIID "{000208C5-0001-0000-C000-000000000046}"
-- --------------------------------------------------
-- 
-- interface IDownBars
-- 
-- --------------------------------------------------
data DownBars a = DownBars
                   
type IDownBars a = Automation.IDispatch (DownBars a)
iidIDownBars :: Com.IID (IDownBars Automation.Interface)
iidIDownBars = Com.mkIID "{000208C6-0001-0000-C000-000000000046}"
-- --------------------------------------------------
-- 
-- interface IFloor
-- 
-- --------------------------------------------------
data Floor a = Floor
                
type IFloor a = Automation.IDispatch (Floor a)
iidIFloor :: Com.IID (IFloor Automation.Interface)
iidIFloor = Com.mkIID "{000208C7-0001-0000-C000-000000000046}"
-- --------------------------------------------------
-- 
-- interface IWalls
-- 
-- --------------------------------------------------
data Walls a = Walls
                
type IWalls a = Automation.IDispatch (Walls a)
iidIWalls :: Com.IID (IWalls Automation.Interface)
iidIWalls = Com.mkIID "{000208C8-0001-0000-C000-000000000046}"
-- --------------------------------------------------
-- 
-- interface ITickLabels
-- 
-- --------------------------------------------------
data TickLabels a = TickLabels
                     
type ITickLabels a = Automation.IDispatch (TickLabels a)
iidITickLabels :: Com.IID (ITickLabels Automation.Interface)
iidITickLabels = Com.mkIID "{000208C9-0001-0000-C000-000000000046}"
getOrientation22 :: (Automation.Variant a0) => ITickLabels a -> Prelude.IO (a0)
getOrientation22 =
  Automation.propertyGet "Orientation" [] Automation.outVariant
setOrientation22 :: (Automation.Variant a0) => a0 -> ITickLabels a -> Prelude.IO ()
setOrientation22 rHS =
  Automation.propertySet "Orientation" [Automation.inVariant rHS]
-- --------------------------------------------------
-- 
-- interface IPlotArea
-- 
-- --------------------------------------------------
data PlotArea a = PlotArea
                   
type IPlotArea a = Automation.IDispatch (PlotArea a)
iidIPlotArea :: Com.IID (IPlotArea Automation.Interface)
iidIPlotArea = Com.mkIID "{000208CB-0001-0000-C000-000000000046}"
getInsideLeft :: IPlotArea a -> Prelude.IO (Prelude.Double)
getInsideLeft =
  Automation.propertyGet "InsideLeft" [] Automation.outDouble
getInsideTop :: IPlotArea a -> Prelude.IO (Prelude.Double)
getInsideTop =
  Automation.propertyGet "InsideTop" [] Automation.outDouble
getInsideWidth :: IPlotArea a -> Prelude.IO (Prelude.Double)
getInsideWidth =
  Automation.propertyGet "InsideWidth" [] Automation.outDouble
getInsideHeight :: IPlotArea a -> Prelude.IO (Prelude.Double)
getInsideHeight =
  Automation.propertyGet "InsideHeight" [] Automation.outDouble
-- --------------------------------------------------
-- 
-- interface IChartArea
-- 
-- --------------------------------------------------
data ChartArea a = ChartArea
                    
type IChartArea a = Automation.IDispatch (ChartArea a)
iidIChartArea :: Com.IID (IChartArea Automation.Interface)
iidIChartArea = Com.mkIID "{000208CC-0001-0000-C000-000000000046}"
-- --------------------------------------------------
-- 
-- interface ILegend
-- 
-- --------------------------------------------------
data Legend a = Legend
                 
type ILegend a = Automation.IDispatch (Legend a)
iidILegend :: Com.IID (ILegend Automation.Interface)
iidILegend = Com.mkIID "{000208CD-0001-0000-C000-000000000046}"
legendEntries :: Prelude.Int -> ILegend a -> Prelude.IO (Automation.IDispatch Automation.Interface)
legendEntries index =
  Automation.function1 "LegendEntries" [Automation.inInt index] Automation.outIDispatch
getPosition4 :: (Automation.Variant a0) => ILegend a -> Prelude.IO (a0)
getPosition4 =
  Automation.propertyGet "Position" [] Automation.outVariant
setPosition5 :: (Automation.Variant a0) => a0 -> ILegend a -> Prelude.IO ()
setPosition5 rHS =
  Automation.propertySet "Position" [Automation.inVariant rHS]
-- --------------------------------------------------
-- 
-- interface IErrorBars
-- 
-- --------------------------------------------------
data ErrorBars a = ErrorBars
                    
type IErrorBars a = Automation.IDispatch (ErrorBars a)
iidIErrorBars :: Com.IID (IErrorBars Automation.Interface)
iidIErrorBars = Com.mkIID "{000208CE-0001-0000-C000-000000000046}"
getEndStyle :: (Automation.Variant a0) => IErrorBars a -> Prelude.IO (a0)
getEndStyle =
  Automation.propertyGet "EndStyle" [] Automation.outVariant
setEndStyle :: (Automation.Variant a0) => a0 -> IErrorBars a -> Prelude.IO ()
setEndStyle rHS =
  Automation.propertySet "EndStyle" [Automation.inVariant rHS]
-- --------------------------------------------------
-- 
-- interface IDataTable
-- 
-- --------------------------------------------------
data DataTable a = DataTable
                    
type IDataTable a = Automation.IDispatch (DataTable a)
iidIDataTable :: Com.IID (IDataTable Automation.Interface)
iidIDataTable = Com.mkIID "{00020843-0001-0000-C000-000000000046}"
getHasBorderHorizontal :: IDataTable a -> Prelude.IO (Prelude.Int)
getHasBorderHorizontal =
  Automation.propertyGet "HasBorderHorizontal" [] Automation.outInt
setHasBorderHorizontal :: Prelude.Int -> IDataTable a -> Prelude.IO ()
setHasBorderHorizontal rHS =
  Automation.propertySet "HasBorderHorizontal" [Automation.inInt rHS]
getHasBorderVertical :: IDataTable a -> Prelude.IO (Prelude.Int)
getHasBorderVertical =
  Automation.propertyGet "HasBorderVertical" [] Automation.outInt
setHasBorderVertical :: Prelude.Int -> IDataTable a -> Prelude.IO ()
setHasBorderVertical rHS =
  Automation.propertySet "HasBorderVertical" [Automation.inInt rHS]
getHasBorderOutline :: IDataTable a -> Prelude.IO (Prelude.Int)
getHasBorderOutline =
  Automation.propertyGet "HasBorderOutline" [] Automation.outInt
setHasBorderOutline :: Prelude.Int -> IDataTable a -> Prelude.IO ()
setHasBorderOutline rHS =
  Automation.propertySet "HasBorderOutline" [Automation.inInt rHS]
-- --------------------------------------------------
-- 
-- interface IPhonetic
-- 
-- --------------------------------------------------
data Phonetic a = Phonetic
                   
type IPhonetic a = Automation.IDispatch (Phonetic a)
iidIPhonetic :: Com.IID (IPhonetic Automation.Interface)
iidIPhonetic = Com.mkIID "{00024438-0001-0000-C000-000000000046}"
getCharacterType :: IPhonetic a -> Prelude.IO (Prelude.Int)
getCharacterType =
  Automation.propertyGet "CharacterType" [] Automation.outInt
setCharacterType :: Prelude.Int -> IPhonetic a -> Prelude.IO ()
setCharacterType rHS =
  Automation.propertySet "CharacterType" [Automation.inInt rHS]
getAlignment0 :: IPhonetic a -> Prelude.IO (Prelude.Int)
getAlignment0 =
  Automation.propertyGet "Alignment" [] Automation.outInt
setAlignment0 :: Prelude.Int -> IPhonetic a -> Prelude.IO ()
setAlignment0 rHS =
  Automation.propertySet "Alignment" [Automation.inInt rHS]

-- --------------------------------------------------
-- 
-- interface IShape
-- 
-- --------------------------------------------------
data Shape a = Shape
                
type IShape a = Automation.IDispatch (Shape a)
iidIShape :: Com.IID (IShape Automation.Interface)
iidIShape = Com.mkIID "{00024439-0001-0000-C000-000000000046}"
apply :: Automation.IDispatch a -> Prelude.IO ()
apply = Automation.method0 "Apply" []
duplicate40 :: IShape a -> Prelude.IO (Office.IShape Automation.Interface)
duplicate40 =
  Automation.function1 "Duplicate" [] Automation.outIDispatch
flip :: (Automation.Variant a0) => a0 -> Automation.IDispatch a -> Prelude.IO ()
flip flipCmd =
  Automation.method0 "Flip" [Automation.inVariant flipCmd]
incrementLeft :: Prelude.Float -> Automation.IDispatch a -> Prelude.IO ()
incrementLeft increment =
  Automation.method0 "IncrementLeft" [Automation.inFloat increment]
incrementRotation :: Prelude.Float -> Automation.IDispatch a -> Prelude.IO ()
incrementRotation increment =
  Automation.method0 "IncrementRotation" [Automation.inFloat increment]
incrementTop :: Prelude.Float -> Automation.IDispatch a -> Prelude.IO ()
incrementTop increment =
  Automation.method0 "IncrementTop" [Automation.inFloat increment]
pickUp :: Automation.IDispatch a -> Prelude.IO ()
pickUp = Automation.method0 "PickUp" []
rerouteConnections :: Automation.IDispatch a -> Prelude.IO ()
rerouteConnections = Automation.method0 "RerouteConnections" []
scaleHeight :: (Automation.Variant a0) => Prelude.Float -> a0 -> Prelude.Int -> Automation.IDispatch a -> Prelude.IO ()
scaleHeight factor relativeToOriginalSize scale =
  Automation.method0 "ScaleHeight" [Automation.inFloat factor, Automation.inVariant relativeToOriginalSize, Automation.inInt scale]
scaleWidth :: (Automation.Variant a0) => Prelude.Float -> a0 -> Prelude.Int -> Automation.IDispatch a -> Prelude.IO ()
scaleWidth factor relativeToOriginalSize scale =
  Automation.method0 "ScaleWidth" [Automation.inFloat factor, Automation.inVariant relativeToOriginalSize, Automation.inInt scale]
setShapesDefaultProperties :: Automation.IDispatch a -> Prelude.IO ()
setShapesDefaultProperties =
  Automation.method0 "SetShapesDefaultProperties" []
ungroup3 :: Automation.IDispatch a -> Prelude.IO (Office.IShapeRange Automation.Interface)
ungroup3 =
  Automation.function1 "Ungroup" [] Automation.outIDispatch
zOrder :: (Automation.Variant a0) => a0 -> Automation.IDispatch a -> Prelude.IO ()
zOrder zOrderCmd =
  Automation.method0 "ZOrder" [Automation.inVariant zOrderCmd]
getAdjustments :: Automation.IDispatch a -> Prelude.IO (IAdjustments Automation.Interface)
getAdjustments =
  Automation.propertyGet "Adjustments" [] Automation.outIDispatch
getTextFrame :: Automation.IDispatch a -> Prelude.IO (Office.ITextFrame Automation.Interface)
getTextFrame =
  Automation.propertyGet "TextFrame" [] Automation.outIDispatch
getAutoShapeType :: (Automation.Variant a0) => Automation.IDispatch a -> Prelude.IO (a0)
getAutoShapeType =
  Automation.propertyGet "AutoShapeType" [] Automation.outVariant
setAutoShapeType :: (Automation.Variant a0) => a0 -> Automation.IDispatch a -> Prelude.IO ()
setAutoShapeType rHS =
  Automation.propertySet "AutoShapeType" [Automation.inVariant rHS]
getCallout :: Automation.IDispatch a -> Prelude.IO (ICalloutFormat Automation.Interface)
getCallout =
  Automation.propertyGet "Callout" [] Automation.outIDispatch
getConnectionSiteCount :: Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getConnectionSiteCount =
  Automation.propertyGet "ConnectionSiteCount" [] Automation.outInt
getConnector :: (Automation.Variant a0) => Automation.IDispatch a -> Prelude.IO (a0)
getConnector =
  Automation.propertyGet "Connector" [] Automation.outVariant
getConnectorFormat :: Automation.IDispatch a -> Prelude.IO (Office.IConnectorFormat Automation.Interface)
getConnectorFormat =
  Automation.propertyGet "ConnectorFormat" [] Automation.outIDispatch
getFill13 :: Automation.IDispatch a -> Prelude.IO (IFillFormat Automation.Interface)
getFill13 =
  Automation.propertyGet "Fill" [] Automation.outIDispatch
getGroupItems :: Automation.IDispatch a -> Prelude.IO (Office.IGroupShapes Automation.Interface)
getGroupItems =
  Automation.propertyGet "GroupItems" [] Automation.outIDispatch
getHeight51 :: Automation.IDispatch a -> Prelude.IO (Prelude.Float)
getHeight51 =
  Automation.propertyGet "Height" [] Automation.outFloat
setHeight47 :: Prelude.Float -> Automation.IDispatch a -> Prelude.IO ()
setHeight47 rHS =
  Automation.propertySet "Height" [Automation.inFloat rHS]
getHorizontalFlip :: (Automation.Variant a0) => Automation.IDispatch a -> Prelude.IO (a0)
getHorizontalFlip =
  Automation.propertyGet "HorizontalFlip" [] Automation.outVariant
getLeft54 :: Automation.IDispatch a -> Prelude.IO (Prelude.Float)
getLeft54 = Automation.propertyGet "Left" [] Automation.outFloat
setLeft50 :: Prelude.Float -> Automation.IDispatch a -> Prelude.IO ()
setLeft50 rHS =
  Automation.propertySet "Left" [Automation.inFloat rHS]
getLine :: Automation.IDispatch a -> Prelude.IO (ILineFormat Automation.Interface)
getLine = Automation.propertyGet "Line" [] Automation.outIDispatch
getLockAspectRatio :: (Automation.Variant a0) => Automation.IDispatch a -> Prelude.IO (a0)
getLockAspectRatio =
  Automation.propertyGet "LockAspectRatio" [] Automation.outVariant
setLockAspectRatio :: (Automation.Variant a0) => a0 -> Automation.IDispatch a -> Prelude.IO ()
setLockAspectRatio rHS =
  Automation.propertySet "LockAspectRatio" [Automation.inVariant rHS]
getNodes :: Automation.IDispatch a -> Prelude.IO (IShapeNodes Automation.Interface)
getNodes =
  Automation.propertyGet "Nodes" [] Automation.outIDispatch
getRotation0 :: Automation.IDispatch a -> Prelude.IO (Prelude.Float)
getRotation0 =
  Automation.propertyGet "Rotation" [] Automation.outFloat
setRotation0 :: Prelude.Float -> Automation.IDispatch a -> Prelude.IO ()
setRotation0 rHS =
  Automation.propertySet "Rotation" [Automation.inFloat rHS]
getPictureFormat :: Automation.IDispatch a -> Prelude.IO (IPictureFormat Automation.Interface)
getPictureFormat =
  Automation.propertyGet "PictureFormat" [] Automation.outIDispatch
getShadow26 :: Automation.IDispatch a -> Prelude.IO (IShadowFormat Automation.Interface)
getShadow26 =
  Automation.propertyGet "Shadow" [] Automation.outIDispatch
getTextEffect :: Automation.IDispatch a -> Prelude.IO (ITextEffectFormat Automation.Interface)
getTextEffect =
  Automation.propertyGet "TextEffect" [] Automation.outIDispatch
getThreeD :: Automation.IDispatch a -> Prelude.IO (IThreeDFormat Automation.Interface)
getThreeD =
  Automation.propertyGet "ThreeD" [] Automation.outIDispatch
getTop54 :: Automation.IDispatch a -> Prelude.IO (Prelude.Float)
getTop54 = Automation.propertyGet "Top" [] Automation.outFloat
setTop50 :: Prelude.Float -> Automation.IDispatch a -> Prelude.IO ()
setTop50 rHS =
  Automation.propertySet "Top" [Automation.inFloat rHS]
getType20 :: (Automation.Variant a0) => Automation.IDispatch a -> Prelude.IO (a0)
getType20 = Automation.propertyGet "Type" [] Automation.outVariant
getVerticalFlip :: (Automation.Variant a0) => Automation.IDispatch a -> Prelude.IO (a0)
getVerticalFlip =
  Automation.propertyGet "VerticalFlip" [] Automation.outVariant
getVertices0 :: Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getVertices0 =
  Automation.propertyGet "Vertices" [] Automation.outInt
getWidth52 :: Automation.IDispatch a -> Prelude.IO (Prelude.Float)
getWidth52 = Automation.propertyGet "Width" [] Automation.outFloat
setWidth48 :: Prelude.Float -> Automation.IDispatch a -> Prelude.IO ()
setWidth48 rHS =
  Automation.propertySet "Width" [Automation.inFloat rHS]
getZOrderPosition :: Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getZOrderPosition =
  Automation.propertyGet "ZOrderPosition" [] Automation.outInt
getHyperlink :: IShape a -> Prelude.IO (IHyperlink Automation.Interface)
getHyperlink =
  Automation.propertyGet "Hyperlink" [] Automation.outIDispatch
getBlackWhiteMode :: (Automation.Variant a0) => Automation.IDispatch a -> Prelude.IO (a0)
getBlackWhiteMode =
  Automation.propertyGet "BlackWhiteMode" [] Automation.outVariant
setBlackWhiteMode :: (Automation.Variant a0) => a0 -> Automation.IDispatch a -> Prelude.IO ()
setBlackWhiteMode rHS =
  Automation.propertySet "BlackWhiteMode" [Automation.inVariant rHS]
getDrawingObject :: IShape a -> Prelude.IO (Automation.IDispatch Automation.Interface)
getDrawingObject =
  Automation.propertyGet "DrawingObject" [] Automation.outIDispatch
getPlacement40 :: (Automation.Variant a0) => IShape a -> Prelude.IO (a0)
getPlacement40 =
  Automation.propertyGet "Placement" [] Automation.outVariant
setPlacement40 :: (Automation.Variant a0) => a0 -> IShape a -> Prelude.IO ()
setPlacement40 rHS =
  Automation.propertySet "Placement" [Automation.inVariant rHS]
copyPicture43 :: Prelude.Int -> Prelude.Int -> IShape a -> Prelude.IO ()
copyPicture43 appearance format =
  Automation.method0 "CopyPicture" [Automation.inInt appearance, Automation.inInt format]
getControlFormat :: IShape a -> Prelude.IO (IControlFormat Automation.Interface)
getControlFormat =
  Automation.propertyGet "ControlFormat" [] Automation.outIDispatch
getLinkFormat :: IShape a -> Prelude.IO (ILinkFormat Automation.Interface)
getLinkFormat =
  Automation.propertyGet "LinkFormat" [] Automation.outIDispatch
getOLEFormat :: IShape a -> Prelude.IO (IOLEFormat Automation.Interface)
getOLEFormat =
  Automation.propertyGet "OLEFormat" [] Automation.outIDispatch
getFormControlType :: (Automation.Variant a0) => IShape a -> Prelude.IO (a0)
getFormControlType =
  Automation.propertyGet "FormControlType" [] Automation.outVariant
-- --------------------------------------------------
-- 
-- interface IShapes
-- 
-- --------------------------------------------------
data Shapes a = Shapes
                 
type IShapes a = Automation.IDispatch (Shapes a)
iidIShapes :: Com.IID (IShapes Automation.Interface)
iidIShapes = Com.mkIID "{0002443A-0001-0000-C000-000000000046}"
item43 :: Prelude.Int -> Automation.IDispatch a -> Prelude.IO (Office.IShape Automation.Interface)
item43 index =
  Automation.function1 "Item" [Automation.inInt index] Automation.outIDispatch
default1 :: Prelude.Int -> Automation.IDispatch a -> Prelude.IO (Office.IShape Automation.Interface)
default1 index =
  Automation.function1 "_Default" [Automation.inInt index] Automation.outIDispatch
addCallout :: (Automation.Variant a0) => a0 -> Prelude.Float -> Prelude.Float -> Prelude.Float -> Prelude.Float -> IShapes a -> Prelude.IO (Office.IShape Automation.Interface)
addCallout type0 left top width height =
  Automation.function1 "AddCallout" [Automation.inVariant type0, Automation.inFloat left, Automation.inFloat top, Automation.inFloat width, Automation.inFloat height] Automation.outIDispatch
addConnector :: (Automation.Variant a0) => a0 -> Prelude.Float -> Prelude.Float -> Prelude.Float -> Prelude.Float -> IShapes a -> Prelude.IO (Office.IShape Automation.Interface)
addConnector type0 beginX beginY endX endY =
  Automation.function1 "AddConnector" [Automation.inVariant type0, Automation.inFloat beginX, Automation.inFloat beginY, Automation.inFloat endX, Automation.inFloat endY] Automation.outIDispatch
addCurve :: Prelude.Int -> IShapes a -> Prelude.IO (Office.IShape Automation.Interface)
addCurve safeArrayOfPoints =
  Automation.function1 "AddCurve" [Automation.inInt safeArrayOfPoints] Automation.outIDispatch
addLabel :: (Automation.Variant a0) => a0 -> Prelude.Float -> Prelude.Float -> Prelude.Float -> Prelude.Float -> IShapes a -> Prelude.IO (Office.IShape Automation.Interface)
addLabel orientation left top width height =
  Automation.function1 "AddLabel" [Automation.inVariant orientation, Automation.inFloat left, Automation.inFloat top, Automation.inFloat width, Automation.inFloat height] Automation.outIDispatch
addLine :: Prelude.Float -> Prelude.Float -> Prelude.Float -> Prelude.Float -> IShapes a -> Prelude.IO (Office.IShape Automation.Interface)
addLine beginX beginY endX endY =
  Automation.function1 "AddLine" [Automation.inFloat beginX, Automation.inFloat beginY, Automation.inFloat endX, Automation.inFloat endY] Automation.outIDispatch
addPicture :: (Automation.Variant a0, Automation.Variant a1) => Prelude.String -> a0 -> a1 -> Prelude.Float -> Prelude.Float -> Prelude.Float -> Prelude.Float -> IShapes a -> Prelude.IO (Office.IShape Automation.Interface)
addPicture filename linkToFile saveWithDocument left top width height =
  Automation.function1 "AddPicture" [Automation.inString filename, Automation.inVariant linkToFile, Automation.inVariant saveWithDocument, Automation.inFloat left, Automation.inFloat top, Automation.inFloat width, Automation.inFloat height] Automation.outIDispatch
addPolyline :: Prelude.Int -> IShapes a -> Prelude.IO (Office.IShape Automation.Interface)
addPolyline safeArrayOfPoints =
  Automation.function1 "AddPolyline" [Automation.inInt safeArrayOfPoints] Automation.outIDispatch
addShape :: (Automation.Variant a0) => a0 -> Prelude.Float -> Prelude.Float -> Prelude.Float -> Prelude.Float -> IShapes a -> Prelude.IO (Office.IShape Automation.Interface)
addShape type0 left top width height =
  Automation.function1 "AddShape" [Automation.inVariant type0, Automation.inFloat left, Automation.inFloat top, Automation.inFloat width, Automation.inFloat height] Automation.outIDispatch
addTextEffect :: (Automation.Variant a0, Automation.Variant a1, Automation.Variant a2) => a0 -> Prelude.String -> Prelude.String -> Prelude.Float -> a1 -> a2 -> Prelude.Float -> Prelude.Float -> IShapes a -> Prelude.IO (Office.IShape Automation.Interface)
addTextEffect presetTextEffect text fontName fontSize fontBold fontItalic left top =
  Automation.function1 "AddTextEffect" [Automation.inVariant presetTextEffect, Automation.inString text, Automation.inString fontName, Automation.inFloat fontSize, Automation.inVariant fontBold, Automation.inVariant fontItalic, Automation.inFloat left, Automation.inFloat top] Automation.outIDispatch
addTextbox :: (Automation.Variant a0) => a0 -> Prelude.Float -> Prelude.Float -> Prelude.Float -> Prelude.Float -> IShapes a -> Prelude.IO (Office.IShape Automation.Interface)
addTextbox orientation left top width height =
  Automation.function1 "AddTextbox" [Automation.inVariant orientation, Automation.inFloat left, Automation.inFloat top, Automation.inFloat width, Automation.inFloat height] Automation.outIDispatch
buildFreeform :: (Automation.Variant a0) => a0 -> Prelude.Float -> Prelude.Float -> IShapes a -> Prelude.IO (Office.IFreeformBuilder Automation.Interface)
buildFreeform editingType x1 y1 =
  Automation.function1 "BuildFreeform" [Automation.inVariant editingType, Automation.inFloat x1, Automation.inFloat y1] Automation.outIDispatch
getRange5 :: Prelude.Int -> IShapes a -> Prelude.IO (Office.IShapeRange Automation.Interface)
getRange5 index =
  Automation.propertyGet "Range" [Automation.inInt index] Automation.outIDispatch
selectAll :: IShapes a -> Prelude.IO ()
selectAll = Automation.method0 "SelectAll" []
addFormControl :: (Automation.Variant a0) => a0 -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> IShapes a -> Prelude.IO (Office.IShape Automation.Interface)
addFormControl type0 left top width height =
  Automation.function1 "AddFormControl" [Automation.inVariant type0, Automation.inInt left, Automation.inInt top, Automation.inInt width, Automation.inInt height] Automation.outIDispatch
addOLEObject :: Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> IShapes a -> Prelude.IO (Office.IShape Automation.Interface)
addOLEObject classType filename link displayAsIcon iconFileName iconIndex iconLabel left top width height =
  Automation.function1 "AddOLEObject" [Automation.inInt classType, Automation.inInt filename, Automation.inInt link, Automation.inInt displayAsIcon, Automation.inInt iconFileName, Automation.inInt iconIndex, Automation.inInt iconLabel, Automation.inInt left, Automation.inInt top, Automation.inInt width, Automation.inInt height] Automation.outIDispatch
-- --------------------------------------------------
-- 
-- interface IShapeRange
-- 
-- --------------------------------------------------
data ShapeRange a = ShapeRange
                     
type IShapeRange a = Automation.IDispatch (ShapeRange a)
iidIShapeRange :: Com.IID (IShapeRange Automation.Interface)
iidIShapeRange = Com.mkIID "{0002443B-0001-0000-C000-000000000046}"
align :: (Automation.Variant a0, Automation.Variant a1) => a0 -> a1 -> IShapeRange a -> Prelude.IO ()
align alignCmd relativeTo =
  Automation.method0 "Align" [Automation.inVariant alignCmd, Automation.inVariant relativeTo]
distribute :: (Automation.Variant a0, Automation.Variant a1) => a0 -> a1 -> IShapeRange a -> Prelude.IO ()
distribute distributeCmd relativeTo =
  Automation.method0 "Distribute" [Automation.inVariant distributeCmd, Automation.inVariant relativeTo]
duplicate41 :: IShapeRange a -> Prelude.IO (Office.IShapeRange Automation.Interface)
duplicate41 =
  Automation.function1 "Duplicate" [] Automation.outIDispatch
group21 :: IShapeRange a -> Prelude.IO (Office.IShape Automation.Interface)
group21 = Automation.function1 "Group" [] Automation.outIDispatch
regroup :: IShapeRange a -> Prelude.IO (Office.IShape Automation.Interface)
regroup = Automation.function1 "Regroup" [] Automation.outIDispatch
-- --------------------------------------------------
-- 
-- interface IGroupShapes
-- 
-- --------------------------------------------------
data GroupShapes a = GroupShapes
                      
type IGroupShapes a = Automation.IDispatch (GroupShapes a)
iidIGroupShapes :: Com.IID (IGroupShapes Automation.Interface)
iidIGroupShapes =
  Com.mkIID "{0002443C-0001-0000-C000-000000000046}"
-- --------------------------------------------------
-- 
-- interface ITextFrame
-- 
-- --------------------------------------------------
data TextFrame a = TextFrame
                    
type ITextFrame a = Automation.IDispatch (TextFrame a)
iidITextFrame :: Com.IID (ITextFrame Automation.Interface)
iidITextFrame = Com.mkIID "{0002443D-0001-0000-C000-000000000046}"
getMarginBottom :: ITextFrame a -> Prelude.IO (Prelude.Float)
getMarginBottom =
  Automation.propertyGet "MarginBottom" [] Automation.outFloat
setMarginBottom :: Prelude.Float -> ITextFrame a -> Prelude.IO ()
setMarginBottom rHS =
  Automation.propertySet "MarginBottom" [Automation.inFloat rHS]
getMarginLeft :: ITextFrame a -> Prelude.IO (Prelude.Float)
getMarginLeft =
  Automation.propertyGet "MarginLeft" [] Automation.outFloat
setMarginLeft :: Prelude.Float -> ITextFrame a -> Prelude.IO ()
setMarginLeft rHS =
  Automation.propertySet "MarginLeft" [Automation.inFloat rHS]
getMarginRight :: ITextFrame a -> Prelude.IO (Prelude.Float)
getMarginRight =
  Automation.propertyGet "MarginRight" [] Automation.outFloat
setMarginRight :: Prelude.Float -> ITextFrame a -> Prelude.IO ()
setMarginRight rHS =
  Automation.propertySet "MarginRight" [Automation.inFloat rHS]
getMarginTop :: ITextFrame a -> Prelude.IO (Prelude.Float)
getMarginTop =
  Automation.propertyGet "MarginTop" [] Automation.outFloat
setMarginTop :: Prelude.Float -> ITextFrame a -> Prelude.IO ()
setMarginTop rHS =
  Automation.propertySet "MarginTop" [Automation.inFloat rHS]
getOrientation23 :: (Automation.Variant a0) => ITextFrame a -> Prelude.IO (a0)
getOrientation23 =
  Automation.propertyGet "Orientation" [] Automation.outVariant
setOrientation23 :: (Automation.Variant a0) => a0 -> ITextFrame a -> Prelude.IO ()
setOrientation23 rHS =
  Automation.propertySet "Orientation" [Automation.inVariant rHS]
getAutoMargins :: ITextFrame a -> Prelude.IO (Prelude.Int)
getAutoMargins =
  Automation.propertyGet "AutoMargins" [] Automation.outInt
setAutoMargins :: Prelude.Int -> ITextFrame a -> Prelude.IO ()
setAutoMargins rHS =
  Automation.propertySet "AutoMargins" [Automation.inInt rHS]
-- --------------------------------------------------
-- 
-- interface IConnectorFormat
-- 
-- --------------------------------------------------
data ConnectorFormat a = ConnectorFormat
                          
type IConnectorFormat a = Automation.IDispatch (ConnectorFormat a)
iidIConnectorFormat :: Com.IID (IConnectorFormat Automation.Interface)
iidIConnectorFormat =
  Com.mkIID "{0002443E-0001-0000-C000-000000000046}"
beginConnect :: Office.IShape a0 -> Prelude.Int -> IConnectorFormat a -> Prelude.IO ()
beginConnect connectedShape connectionSite =
  Automation.method0 "BeginConnect" [Automation.inIDispatch connectedShape, Automation.inInt connectionSite]
beginDisconnect :: IConnectorFormat a -> Prelude.IO ()
beginDisconnect = Automation.method0 "BeginDisconnect" []
endConnect :: Office.IShape a0 -> Prelude.Int -> IConnectorFormat a -> Prelude.IO ()
endConnect connectedShape connectionSite =
  Automation.method0 "EndConnect" [Automation.inIDispatch connectedShape, Automation.inInt connectionSite]
endDisconnect :: IConnectorFormat a -> Prelude.IO ()
endDisconnect = Automation.method0 "EndDisconnect" []
getBeginConnected :: (Automation.Variant a0) => IConnectorFormat a -> Prelude.IO (a0)
getBeginConnected =
  Automation.propertyGet "BeginConnected" [] Automation.outVariant
getBeginConnectedShape :: IConnectorFormat a -> Prelude.IO (Office.IShape Automation.Interface)
getBeginConnectedShape =
  Automation.propertyGet "BeginConnectedShape" [] Automation.outIDispatch
getBeginConnectionSite :: IConnectorFormat a -> Prelude.IO (Prelude.Int)
getBeginConnectionSite =
  Automation.propertyGet "BeginConnectionSite" [] Automation.outInt
getEndConnected :: (Automation.Variant a0) => IConnectorFormat a -> Prelude.IO (a0)
getEndConnected =
  Automation.propertyGet "EndConnected" [] Automation.outVariant
getEndConnectedShape :: IConnectorFormat a -> Prelude.IO (Office.IShape Automation.Interface)
getEndConnectedShape =
  Automation.propertyGet "EndConnectedShape" [] Automation.outIDispatch
getEndConnectionSite :: IConnectorFormat a -> Prelude.IO (Prelude.Int)
getEndConnectionSite =
  Automation.propertyGet "EndConnectionSite" [] Automation.outInt
getType22 :: (Automation.Variant a0) => IConnectorFormat a -> Prelude.IO (a0)
getType22 = Automation.propertyGet "Type" [] Automation.outVariant
setType10 :: (Automation.Variant a0) => a0 -> IConnectorFormat a -> Prelude.IO ()
setType10 rHS =
  Automation.propertySet "Type" [Automation.inVariant rHS]
-- --------------------------------------------------
-- 
-- interface IFreeformBuilder
-- 
-- --------------------------------------------------
data FreeformBuilder a = FreeformBuilder
                          
type IFreeformBuilder a = Automation.IDispatch (FreeformBuilder a)
iidIFreeformBuilder :: Com.IID (IFreeformBuilder Automation.Interface)
iidIFreeformBuilder =
  Com.mkIID "{0002443F-0001-0000-C000-000000000046}"
addNodes :: (Automation.Variant a0, Automation.Variant a1) => a0 -> a1 -> Prelude.Float -> Prelude.Float -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> IFreeformBuilder a -> Prelude.IO ()
addNodes segmentType editingType x1 y1 x2 y2 x3 y3 =
  Automation.method0 "AddNodes" [Automation.inVariant segmentType, Automation.inVariant editingType, Automation.inFloat x1, Automation.inFloat y1, Automation.inInt x2, Automation.inInt y2, Automation.inInt x3, Automation.inInt y3]
convertToShape :: IFreeformBuilder a -> Prelude.IO (Office.IShape Automation.Interface)
convertToShape =
  Automation.function1 "ConvertToShape" [] Automation.outIDispatch
-- --------------------------------------------------
-- 
-- interface IControlFormat
-- 
-- --------------------------------------------------
data ControlFormat a = ControlFormat
                        
type IControlFormat a = Automation.IDispatch (ControlFormat a)
iidIControlFormat :: Com.IID (IControlFormat Automation.Interface)
iidIControlFormat =
  Com.mkIID "{00024440-0001-0000-C000-000000000046}"
addItem4 :: Prelude.String -> Prelude.Int -> IControlFormat a -> Prelude.IO ()
addItem4 text index =
  Automation.method0 "AddItem" [Automation.inString text, Automation.inInt index]
setListCount :: Prelude.Int -> IControlFormat a -> Prelude.IO ()
setListCount rHS =
  Automation.propertySet "ListCount" [Automation.inInt rHS]
-- --------------------------------------------------
-- 
-- interface IOLEFormat
-- 
-- --------------------------------------------------
data OLEFormat a = OLEFormat
                    
type IOLEFormat a = Automation.IDispatch (OLEFormat a)
iidIOLEFormat :: Com.IID (IOLEFormat Automation.Interface)
iidIOLEFormat = Com.mkIID "{00024441-0001-0000-C000-000000000046}"
verb0 :: Prelude.Int -> IOLEFormat a -> Prelude.IO ()
verb0 verb = Automation.method0 "Verb" [Automation.inInt verb]
-- --------------------------------------------------
-- 
-- interface ILinkFormat
-- 
-- --------------------------------------------------
data LinkFormat a = LinkFormat
                     
type ILinkFormat a = Automation.IDispatch (LinkFormat a)
iidILinkFormat :: Com.IID (ILinkFormat Automation.Interface)
iidILinkFormat = Com.mkIID "{00024442-0001-0000-C000-000000000046}"
-- --------------------------------------------------
-- 
-- interface IDummy
-- 
-- --------------------------------------------------
data Dummy a = Dummy
                
type IDummy a = Automation.IDispatch (Dummy a)
iidIDummy :: Com.IID (IDummy Automation.Interface)
iidIDummy = Com.mkIID "{0002442E-0001-0000-C000-000000000046}"
activeSheetOrChart :: IDummy a -> Prelude.IO ()
activeSheetOrChart = Automation.method0 "_ActiveSheetOrChart" []
rGB :: Automation.IDispatch a -> Prelude.IO ()
rGB = Automation.method0 "RGB" []
chDir :: IDummy a -> Prelude.IO ()
chDir = Automation.method0 "ChDir" []
doScript :: IDummy a -> Prelude.IO ()
doScript = Automation.method0 "DoScript" []
directObject :: IDummy a -> Prelude.IO ()
directObject = Automation.method0 "DirectObject" []
-- --------------------------------------------------
-- 
-- coclass QueryTable
-- 
-- --------------------------------------------------
clsidQueryTable :: Com.CLSID
clsidQueryTable =
  Com.mkCLSID "{59191DA1-EA47-11CE-A51F-00AA0061507F}"
-- --------------------------------------------------
-- 
-- coclass Application0
-- 
-- --------------------------------------------------
clsidApplication0 :: Com.CLSID
clsidApplication0 =
  Com.mkCLSID "{00024500-0000-0000-C000-000000000046}"
-- --------------------------------------------------
-- 
-- coclass Chart0
-- 
-- --------------------------------------------------
clsidChart0 :: Com.CLSID
clsidChart0 = Com.mkCLSID "{00020821-0000-0000-C000-000000000046}"
-- --------------------------------------------------
-- 
-- coclass Worksheet0
-- 
-- --------------------------------------------------
clsidWorksheet0 :: Com.CLSID
clsidWorksheet0 =
  Com.mkCLSID "{00020820-0000-0000-C000-000000000046}"
-- --------------------------------------------------
-- 
-- coclass Global0
-- 
-- --------------------------------------------------
clsidGlobal0 :: Com.CLSID
clsidGlobal0 = Com.mkCLSID "{00020812-0000-0000-C000-000000000046}"
-- --------------------------------------------------
-- 
-- coclass Workbook0
-- 
-- --------------------------------------------------
clsidWorkbook0 :: Com.CLSID
clsidWorkbook0 =
  Com.mkCLSID "{00020819-0000-0000-C000-000000000046}"
-- --------------------------------------------------
-- 
-- coclass OLEObject
-- 
-- --------------------------------------------------
clsidOLEObject :: Com.CLSID
clsidOLEObject =
  Com.mkCLSID "{00020818-0000-0000-C000-000000000046}"
