module MSHTML where

import qualified Prelude
import qualified Automation (IDispatch, Interface, inString, 
                             propertySet, outString, propertyGet, Variant, inVariant, 
                             outVariant, inInt, outInt, inFloat, outFloat, method0, function1, 
                             outIUnknown, outIDispatch, inIDispatch, inIUnknown)
import qualified Com (IID, mkIID, CLSID, mkCLSID, IUnknown)

-- --------------------------------------------------
-- 
-- interface IHTMLStyle
-- 
-- --------------------------------------------------
data HTMLStyle a = HTMLStyle
                    
type IHTMLStyle a = Automation.IDispatch (HTMLStyle a)
iidHTMLStyle :: Com.IID (IHTMLStyle Automation.Interface)
iidHTMLStyle = Com.mkIID "{3050f25e-98b5-11cf-bb82-00aa00bdce0b}"
setFontFamily :: Prelude.String -> IHTMLStyle a -> Prelude.IO ()
setFontFamily v =
  Automation.propertySet "fontFamily" [Automation.inString v]
getFontFamily :: IHTMLStyle a -> Prelude.IO (Prelude.String)
getFontFamily =
  Automation.propertyGet "fontFamily" [] Automation.outString
setFontStyle :: Prelude.String -> IHTMLStyle a -> Prelude.IO ()
setFontStyle v =
  Automation.propertySet "fontStyle" [Automation.inString v]
getFontStyle :: IHTMLStyle a -> Prelude.IO (Prelude.String)
getFontStyle =
  Automation.propertyGet "fontStyle" [] Automation.outString
setFontVariant :: Prelude.String -> IHTMLStyle a -> Prelude.IO ()
setFontVariant v =
  Automation.propertySet "fontVariant" [Automation.inString v]
getFontVariant :: IHTMLStyle a -> Prelude.IO (Prelude.String)
getFontVariant =
  Automation.propertyGet "fontVariant" [] Automation.outString
setFontWeight :: Prelude.String -> IHTMLStyle a -> Prelude.IO ()
setFontWeight v =
  Automation.propertySet "fontWeight" [Automation.inString v]
getFontWeight :: IHTMLStyle a -> Prelude.IO (Prelude.String)
getFontWeight =
  Automation.propertyGet "fontWeight" [] Automation.outString
setFontSize :: (Automation.Variant a0) => a0 -> IHTMLStyle a -> Prelude.IO ()
setFontSize v =
  Automation.propertySet "fontSize" [Automation.inVariant v]
getFontSize :: (Automation.Variant a0) => IHTMLStyle a -> Prelude.IO (a0)
getFontSize =
  Automation.propertyGet "fontSize" [] Automation.outVariant
setFont :: Prelude.String -> IHTMLStyle a -> Prelude.IO ()
setFont v = Automation.propertySet "font" [Automation.inString v]
getFont :: IHTMLStyle a -> Prelude.IO (Prelude.String)
getFont = Automation.propertyGet "font" [] Automation.outString
setColor :: (Automation.Variant a0) => a0 -> Automation.IDispatch a -> Prelude.IO ()
setColor v =
  Automation.propertySet "color" [Automation.inVariant v]
getColor :: (Automation.Variant a0) => Automation.IDispatch a -> Prelude.IO (a0)
getColor = Automation.propertyGet "color" [] Automation.outVariant
setBackground :: Prelude.String -> Automation.IDispatch a -> Prelude.IO ()
setBackground v =
  Automation.propertySet "background" [Automation.inString v]
getBackground :: Automation.IDispatch a -> Prelude.IO (Prelude.String)
getBackground =
  Automation.propertyGet "background" [] Automation.outString
setBackgroundColor :: (Automation.Variant a0) => a0 -> IHTMLStyle a -> Prelude.IO ()
setBackgroundColor v =
  Automation.propertySet "backgroundColor" [Automation.inVariant v]
getBackgroundColor :: (Automation.Variant a0) => IHTMLStyle a -> Prelude.IO (a0)
getBackgroundColor =
  Automation.propertyGet "backgroundColor" [] Automation.outVariant
setBackgroundImage :: Prelude.String -> IHTMLStyle a -> Prelude.IO ()
setBackgroundImage v =
  Automation.propertySet "backgroundImage" [Automation.inString v]
getBackgroundImage :: IHTMLStyle a -> Prelude.IO (Prelude.String)
getBackgroundImage =
  Automation.propertyGet "backgroundImage" [] Automation.outString
setBackgroundRepeat :: Prelude.String -> IHTMLStyle a -> Prelude.IO ()
setBackgroundRepeat v =
  Automation.propertySet "backgroundRepeat" [Automation.inString v]
getBackgroundRepeat :: IHTMLStyle a -> Prelude.IO (Prelude.String)
getBackgroundRepeat =
  Automation.propertyGet "backgroundRepeat" [] Automation.outString
setBackgroundAttachment :: Prelude.String -> IHTMLStyle a -> Prelude.IO ()
setBackgroundAttachment v =
  Automation.propertySet "backgroundAttachment" [Automation.inString v]
getBackgroundAttachment :: IHTMLStyle a -> Prelude.IO (Prelude.String)
getBackgroundAttachment =
  Automation.propertyGet "backgroundAttachment" [] Automation.outString
setBackgroundPosition :: Prelude.String -> IHTMLStyle a -> Prelude.IO ()
setBackgroundPosition v =
  Automation.propertySet "backgroundPosition" [Automation.inString v]
getBackgroundPosition :: IHTMLStyle a -> Prelude.IO (Prelude.String)
getBackgroundPosition =
  Automation.propertyGet "backgroundPosition" [] Automation.outString
setBackgroundPositionX :: (Automation.Variant a0) => a0 -> IHTMLStyle a -> Prelude.IO ()
setBackgroundPositionX v =
  Automation.propertySet "backgroundPositionX" [Automation.inVariant v]
getBackgroundPositionX :: (Automation.Variant a0) => IHTMLStyle a -> Prelude.IO (a0)
getBackgroundPositionX =
  Automation.propertyGet "backgroundPositionX" [] Automation.outVariant
setBackgroundPositionY :: (Automation.Variant a0) => a0 -> IHTMLStyle a -> Prelude.IO ()
setBackgroundPositionY v =
  Automation.propertySet "backgroundPositionY" [Automation.inVariant v]
getBackgroundPositionY :: (Automation.Variant a0) => IHTMLStyle a -> Prelude.IO (a0)
getBackgroundPositionY =
  Automation.propertyGet "backgroundPositionY" [] Automation.outVariant
setWordSpacing :: (Automation.Variant a0) => a0 -> IHTMLStyle a -> Prelude.IO ()
setWordSpacing v =
  Automation.propertySet "wordSpacing" [Automation.inVariant v]
getWordSpacing :: (Automation.Variant a0) => IHTMLStyle a -> Prelude.IO (a0)
getWordSpacing =
  Automation.propertyGet "wordSpacing" [] Automation.outVariant
setLetterSpacing :: (Automation.Variant a0) => a0 -> IHTMLStyle a -> Prelude.IO ()
setLetterSpacing v =
  Automation.propertySet "letterSpacing" [Automation.inVariant v]
getLetterSpacing :: (Automation.Variant a0) => IHTMLStyle a -> Prelude.IO (a0)
getLetterSpacing =
  Automation.propertyGet "letterSpacing" [] Automation.outVariant
setTextDecoration :: Prelude.String -> IHTMLStyle a -> Prelude.IO ()
setTextDecoration v =
  Automation.propertySet "textDecoration" [Automation.inString v]
getTextDecoration :: IHTMLStyle a -> Prelude.IO (Prelude.String)
getTextDecoration =
  Automation.propertyGet "textDecoration" [] Automation.outString
setTextDecorationNone :: Prelude.Int -> IHTMLStyle a -> Prelude.IO ()
setTextDecorationNone v =
  Automation.propertySet "textDecorationNone" [Automation.inInt v]
getTextDecorationNone :: IHTMLStyle a -> Prelude.IO (Prelude.Int)
getTextDecorationNone =
  Automation.propertyGet "textDecorationNone" [] Automation.outInt
setTextDecorationUnderline :: Prelude.Int -> IHTMLStyle a -> Prelude.IO ()
setTextDecorationUnderline v =
  Automation.propertySet "textDecorationUnderline" [Automation.inInt v]
getTextDecorationUnderline :: IHTMLStyle a -> Prelude.IO (Prelude.Int)
getTextDecorationUnderline =
  Automation.propertyGet "textDecorationUnderline" [] Automation.outInt
setTextDecorationOverline :: Prelude.Int -> IHTMLStyle a -> Prelude.IO ()
setTextDecorationOverline v =
  Automation.propertySet "textDecorationOverline" [Automation.inInt v]
getTextDecorationOverline :: IHTMLStyle a -> Prelude.IO (Prelude.Int)
getTextDecorationOverline =
  Automation.propertyGet "textDecorationOverline" [] Automation.outInt
setTextDecorationLineThrough :: Prelude.Int -> IHTMLStyle a -> Prelude.IO ()
setTextDecorationLineThrough v =
  Automation.propertySet "textDecorationLineThrough" [Automation.inInt v]
getTextDecorationLineThrough :: IHTMLStyle a -> Prelude.IO (Prelude.Int)
getTextDecorationLineThrough =
  Automation.propertyGet "textDecorationLineThrough" [] Automation.outInt
setTextDecorationBlink :: Prelude.Int -> IHTMLStyle a -> Prelude.IO ()
setTextDecorationBlink v =
  Automation.propertySet "textDecorationBlink" [Automation.inInt v]
getTextDecorationBlink :: IHTMLStyle a -> Prelude.IO (Prelude.Int)
getTextDecorationBlink =
  Automation.propertyGet "textDecorationBlink" [] Automation.outInt
setVerticalAlign :: (Automation.Variant a0) => a0 -> IHTMLStyle a -> Prelude.IO ()
setVerticalAlign v =
  Automation.propertySet "verticalAlign" [Automation.inVariant v]
getVerticalAlign :: (Automation.Variant a0) => IHTMLStyle a -> Prelude.IO (a0)
getVerticalAlign =
  Automation.propertyGet "verticalAlign" [] Automation.outVariant
setTextTransform :: Prelude.String -> IHTMLStyle a -> Prelude.IO ()
setTextTransform v =
  Automation.propertySet "textTransform" [Automation.inString v]
getTextTransform :: IHTMLStyle a -> Prelude.IO (Prelude.String)
getTextTransform =
  Automation.propertyGet "textTransform" [] Automation.outString
setTextAlign :: Prelude.String -> IHTMLStyle a -> Prelude.IO ()
setTextAlign v =
  Automation.propertySet "textAlign" [Automation.inString v]
getTextAlign :: IHTMLStyle a -> Prelude.IO (Prelude.String)
getTextAlign =
  Automation.propertyGet "textAlign" [] Automation.outString
setTextIndent :: (Automation.Variant a0) => a0 -> IHTMLStyle a -> Prelude.IO ()
setTextIndent v =
  Automation.propertySet "textIndent" [Automation.inVariant v]
getTextIndent :: (Automation.Variant a0) => IHTMLStyle a -> Prelude.IO (a0)
getTextIndent =
  Automation.propertyGet "textIndent" [] Automation.outVariant
setLineHeight :: (Automation.Variant a0) => a0 -> IHTMLStyle a -> Prelude.IO ()
setLineHeight v =
  Automation.propertySet "lineHeight" [Automation.inVariant v]
getLineHeight :: (Automation.Variant a0) => IHTMLStyle a -> Prelude.IO (a0)
getLineHeight =
  Automation.propertyGet "lineHeight" [] Automation.outVariant
setMarginTop :: (Automation.Variant a0) => a0 -> IHTMLStyle a -> Prelude.IO ()
setMarginTop v =
  Automation.propertySet "marginTop" [Automation.inVariant v]
getMarginTop :: (Automation.Variant a0) => IHTMLStyle a -> Prelude.IO (a0)
getMarginTop =
  Automation.propertyGet "marginTop" [] Automation.outVariant
setMarginRight :: (Automation.Variant a0) => a0 -> IHTMLStyle a -> Prelude.IO ()
setMarginRight v =
  Automation.propertySet "marginRight" [Automation.inVariant v]
getMarginRight :: (Automation.Variant a0) => IHTMLStyle a -> Prelude.IO (a0)
getMarginRight =
  Automation.propertyGet "marginRight" [] Automation.outVariant
setMarginBottom :: (Automation.Variant a0) => a0 -> IHTMLStyle a -> Prelude.IO ()
setMarginBottom v =
  Automation.propertySet "marginBottom" [Automation.inVariant v]
getMarginBottom :: (Automation.Variant a0) => IHTMLStyle a -> Prelude.IO (a0)
getMarginBottom =
  Automation.propertyGet "marginBottom" [] Automation.outVariant
setMarginLeft :: (Automation.Variant a0) => a0 -> IHTMLStyle a -> Prelude.IO ()
setMarginLeft v =
  Automation.propertySet "marginLeft" [Automation.inVariant v]
getMarginLeft :: (Automation.Variant a0) => IHTMLStyle a -> Prelude.IO (a0)
getMarginLeft =
  Automation.propertyGet "marginLeft" [] Automation.outVariant
setMargin :: Prelude.String -> IHTMLStyle a -> Prelude.IO ()
setMargin v =
  Automation.propertySet "margin" [Automation.inString v]
getMargin :: IHTMLStyle a -> Prelude.IO (Prelude.String)
getMargin = Automation.propertyGet "margin" [] Automation.outString
setPaddingTop :: (Automation.Variant a0) => a0 -> IHTMLStyle a -> Prelude.IO ()
setPaddingTop v =
  Automation.propertySet "paddingTop" [Automation.inVariant v]
getPaddingTop :: (Automation.Variant a0) => IHTMLStyle a -> Prelude.IO (a0)
getPaddingTop =
  Automation.propertyGet "paddingTop" [] Automation.outVariant
setPaddingRight :: (Automation.Variant a0) => a0 -> IHTMLStyle a -> Prelude.IO ()
setPaddingRight v =
  Automation.propertySet "paddingRight" [Automation.inVariant v]
getPaddingRight :: (Automation.Variant a0) => IHTMLStyle a -> Prelude.IO (a0)
getPaddingRight =
  Automation.propertyGet "paddingRight" [] Automation.outVariant
setPaddingBottom :: (Automation.Variant a0) => a0 -> IHTMLStyle a -> Prelude.IO ()
setPaddingBottom v =
  Automation.propertySet "paddingBottom" [Automation.inVariant v]
getPaddingBottom :: (Automation.Variant a0) => IHTMLStyle a -> Prelude.IO (a0)
getPaddingBottom =
  Automation.propertyGet "paddingBottom" [] Automation.outVariant
setPaddingLeft :: (Automation.Variant a0) => a0 -> IHTMLStyle a -> Prelude.IO ()
setPaddingLeft v =
  Automation.propertySet "paddingLeft" [Automation.inVariant v]
getPaddingLeft :: (Automation.Variant a0) => IHTMLStyle a -> Prelude.IO (a0)
getPaddingLeft =
  Automation.propertyGet "paddingLeft" [] Automation.outVariant
setPadding :: Prelude.String -> IHTMLStyle a -> Prelude.IO ()
setPadding v =
  Automation.propertySet "padding" [Automation.inString v]
getPadding :: IHTMLStyle a -> Prelude.IO (Prelude.String)
getPadding =
  Automation.propertyGet "padding" [] Automation.outString
setBorder :: Prelude.String -> IHTMLStyle a -> Prelude.IO ()
setBorder v =
  Automation.propertySet "border" [Automation.inString v]
getBorder :: IHTMLStyle a -> Prelude.IO (Prelude.String)
getBorder = Automation.propertyGet "border" [] Automation.outString
setBorderTop :: Prelude.String -> IHTMLStyle a -> Prelude.IO ()
setBorderTop v =
  Automation.propertySet "borderTop" [Automation.inString v]
getBorderTop :: IHTMLStyle a -> Prelude.IO (Prelude.String)
getBorderTop =
  Automation.propertyGet "borderTop" [] Automation.outString
setBorderRight :: Prelude.String -> IHTMLStyle a -> Prelude.IO ()
setBorderRight v =
  Automation.propertySet "borderRight" [Automation.inString v]
getBorderRight :: IHTMLStyle a -> Prelude.IO (Prelude.String)
getBorderRight =
  Automation.propertyGet "borderRight" [] Automation.outString
setBorderBottom :: Prelude.String -> IHTMLStyle a -> Prelude.IO ()
setBorderBottom v =
  Automation.propertySet "borderBottom" [Automation.inString v]
getBorderBottom :: IHTMLStyle a -> Prelude.IO (Prelude.String)
getBorderBottom =
  Automation.propertyGet "borderBottom" [] Automation.outString
setBorderLeft :: Prelude.String -> IHTMLStyle a -> Prelude.IO ()
setBorderLeft v =
  Automation.propertySet "borderLeft" [Automation.inString v]
getBorderLeft :: IHTMLStyle a -> Prelude.IO (Prelude.String)
getBorderLeft =
  Automation.propertyGet "borderLeft" [] Automation.outString
setBorderColor :: Prelude.String -> IHTMLStyle a -> Prelude.IO ()
setBorderColor v =
  Automation.propertySet "borderColor" [Automation.inString v]
getBorderColor :: IHTMLStyle a -> Prelude.IO (Prelude.String)
getBorderColor =
  Automation.propertyGet "borderColor" [] Automation.outString
setBorderTopColor :: (Automation.Variant a0) => a0 -> IHTMLStyle a -> Prelude.IO ()
setBorderTopColor v =
  Automation.propertySet "borderTopColor" [Automation.inVariant v]
getBorderTopColor :: (Automation.Variant a0) => IHTMLStyle a -> Prelude.IO (a0)
getBorderTopColor =
  Automation.propertyGet "borderTopColor" [] Automation.outVariant
setBorderRightColor :: (Automation.Variant a0) => a0 -> IHTMLStyle a -> Prelude.IO ()
setBorderRightColor v =
  Automation.propertySet "borderRightColor" [Automation.inVariant v]
getBorderRightColor :: (Automation.Variant a0) => IHTMLStyle a -> Prelude.IO (a0)
getBorderRightColor =
  Automation.propertyGet "borderRightColor" [] Automation.outVariant
setBorderBottomColor :: (Automation.Variant a0) => a0 -> IHTMLStyle a -> Prelude.IO ()
setBorderBottomColor v =
  Automation.propertySet "borderBottomColor" [Automation.inVariant v]
getBorderBottomColor :: (Automation.Variant a0) => IHTMLStyle a -> Prelude.IO (a0)
getBorderBottomColor =
  Automation.propertyGet "borderBottomColor" [] Automation.outVariant
setBorderLeftColor :: (Automation.Variant a0) => a0 -> IHTMLStyle a -> Prelude.IO ()
setBorderLeftColor v =
  Automation.propertySet "borderLeftColor" [Automation.inVariant v]
getBorderLeftColor :: (Automation.Variant a0) => IHTMLStyle a -> Prelude.IO (a0)
getBorderLeftColor =
  Automation.propertyGet "borderLeftColor" [] Automation.outVariant
setBorderWidth :: Prelude.String -> IHTMLStyle a -> Prelude.IO ()
setBorderWidth v =
  Automation.propertySet "borderWidth" [Automation.inString v]
getBorderWidth :: IHTMLStyle a -> Prelude.IO (Prelude.String)
getBorderWidth =
  Automation.propertyGet "borderWidth" [] Automation.outString
setBorderTopWidth :: (Automation.Variant a0) => a0 -> IHTMLStyle a -> Prelude.IO ()
setBorderTopWidth v =
  Automation.propertySet "borderTopWidth" [Automation.inVariant v]
getBorderTopWidth :: (Automation.Variant a0) => IHTMLStyle a -> Prelude.IO (a0)
getBorderTopWidth =
  Automation.propertyGet "borderTopWidth" [] Automation.outVariant
setBorderRightWidth :: (Automation.Variant a0) => a0 -> IHTMLStyle a -> Prelude.IO ()
setBorderRightWidth v =
  Automation.propertySet "borderRightWidth" [Automation.inVariant v]
getBorderRightWidth :: (Automation.Variant a0) => IHTMLStyle a -> Prelude.IO (a0)
getBorderRightWidth =
  Automation.propertyGet "borderRightWidth" [] Automation.outVariant
setBorderBottomWidth :: (Automation.Variant a0) => a0 -> IHTMLStyle a -> Prelude.IO ()
setBorderBottomWidth v =
  Automation.propertySet "borderBottomWidth" [Automation.inVariant v]
getBorderBottomWidth :: (Automation.Variant a0) => IHTMLStyle a -> Prelude.IO (a0)
getBorderBottomWidth =
  Automation.propertyGet "borderBottomWidth" [] Automation.outVariant
setBorderLeftWidth :: (Automation.Variant a0) => a0 -> IHTMLStyle a -> Prelude.IO ()
setBorderLeftWidth v =
  Automation.propertySet "borderLeftWidth" [Automation.inVariant v]
getBorderLeftWidth :: (Automation.Variant a0) => IHTMLStyle a -> Prelude.IO (a0)
getBorderLeftWidth =
  Automation.propertyGet "borderLeftWidth" [] Automation.outVariant
setBorderStyle :: Prelude.String -> IHTMLStyle a -> Prelude.IO ()
setBorderStyle v =
  Automation.propertySet "borderStyle" [Automation.inString v]
getBorderStyle :: IHTMLStyle a -> Prelude.IO (Prelude.String)
getBorderStyle =
  Automation.propertyGet "borderStyle" [] Automation.outString
setBorderTopStyle :: Prelude.String -> IHTMLStyle a -> Prelude.IO ()
setBorderTopStyle v =
  Automation.propertySet "borderTopStyle" [Automation.inString v]
getBorderTopStyle :: IHTMLStyle a -> Prelude.IO (Prelude.String)
getBorderTopStyle =
  Automation.propertyGet "borderTopStyle" [] Automation.outString
setBorderRightStyle :: Prelude.String -> IHTMLStyle a -> Prelude.IO ()
setBorderRightStyle v =
  Automation.propertySet "borderRightStyle" [Automation.inString v]
getBorderRightStyle :: IHTMLStyle a -> Prelude.IO (Prelude.String)
getBorderRightStyle =
  Automation.propertyGet "borderRightStyle" [] Automation.outString
setBorderBottomStyle :: Prelude.String -> IHTMLStyle a -> Prelude.IO ()
setBorderBottomStyle v =
  Automation.propertySet "borderBottomStyle" [Automation.inString v]
getBorderBottomStyle :: IHTMLStyle a -> Prelude.IO (Prelude.String)
getBorderBottomStyle =
  Automation.propertyGet "borderBottomStyle" [] Automation.outString
setBorderLeftStyle :: Prelude.String -> IHTMLStyle a -> Prelude.IO ()
setBorderLeftStyle v =
  Automation.propertySet "borderLeftStyle" [Automation.inString v]
getBorderLeftStyle :: IHTMLStyle a -> Prelude.IO (Prelude.String)
getBorderLeftStyle =
  Automation.propertyGet "borderLeftStyle" [] Automation.outString
setWidth :: (Automation.Variant a0) => a0 -> Automation.IDispatch a -> Prelude.IO ()
setWidth v =
  Automation.propertySet "width" [Automation.inVariant v]
getWidth :: (Automation.Variant a0) => Automation.IDispatch a -> Prelude.IO (a0)
getWidth = Automation.propertyGet "width" [] Automation.outVariant
setHeight :: (Automation.Variant a0) => a0 -> Automation.IDispatch a -> Prelude.IO ()
setHeight v =
  Automation.propertySet "height" [Automation.inVariant v]
getHeight :: (Automation.Variant a0) => Automation.IDispatch a -> Prelude.IO (a0)
getHeight =
  Automation.propertyGet "height" [] Automation.outVariant
setStyleFloat :: Prelude.String -> IHTMLStyle a -> Prelude.IO ()
setStyleFloat v =
  Automation.propertySet "styleFloat" [Automation.inString v]
getStyleFloat :: IHTMLStyle a -> Prelude.IO (Prelude.String)
getStyleFloat =
  Automation.propertyGet "styleFloat" [] Automation.outString
setClear :: Prelude.String -> Automation.IDispatch a -> Prelude.IO ()
setClear v = Automation.propertySet "clear" [Automation.inString v]
getClear :: Automation.IDispatch a -> Prelude.IO (Prelude.String)
getClear = Automation.propertyGet "clear" [] Automation.outString
setDisplay :: Prelude.String -> IHTMLStyle a -> Prelude.IO ()
setDisplay v =
  Automation.propertySet "display" [Automation.inString v]
getDisplay :: IHTMLStyle a -> Prelude.IO (Prelude.String)
getDisplay =
  Automation.propertyGet "display" [] Automation.outString
setVisibility :: Prelude.String -> IHTMLStyle a -> Prelude.IO ()
setVisibility v =
  Automation.propertySet "visibility" [Automation.inString v]
getVisibility :: IHTMLStyle a -> Prelude.IO (Prelude.String)
getVisibility =
  Automation.propertyGet "visibility" [] Automation.outString
setListStyleType :: Prelude.String -> IHTMLStyle a -> Prelude.IO ()
setListStyleType v =
  Automation.propertySet "listStyleType" [Automation.inString v]
getListStyleType :: IHTMLStyle a -> Prelude.IO (Prelude.String)
getListStyleType =
  Automation.propertyGet "listStyleType" [] Automation.outString
setListStylePosition :: Prelude.String -> IHTMLStyle a -> Prelude.IO ()
setListStylePosition v =
  Automation.propertySet "listStylePosition" [Automation.inString v]
getListStylePosition :: IHTMLStyle a -> Prelude.IO (Prelude.String)
getListStylePosition =
  Automation.propertyGet "listStylePosition" [] Automation.outString
setListStyleImage :: Prelude.String -> IHTMLStyle a -> Prelude.IO ()
setListStyleImage v =
  Automation.propertySet "listStyleImage" [Automation.inString v]
getListStyleImage :: IHTMLStyle a -> Prelude.IO (Prelude.String)
getListStyleImage =
  Automation.propertyGet "listStyleImage" [] Automation.outString
setListStyle :: Prelude.String -> IHTMLStyle a -> Prelude.IO ()
setListStyle v =
  Automation.propertySet "listStyle" [Automation.inString v]
getListStyle :: IHTMLStyle a -> Prelude.IO (Prelude.String)
getListStyle =
  Automation.propertyGet "listStyle" [] Automation.outString
setWhiteSpace :: Prelude.String -> IHTMLStyle a -> Prelude.IO ()
setWhiteSpace v =
  Automation.propertySet "whiteSpace" [Automation.inString v]
getWhiteSpace :: IHTMLStyle a -> Prelude.IO (Prelude.String)
getWhiteSpace =
  Automation.propertyGet "whiteSpace" [] Automation.outString
setTop :: (Automation.Variant a0) => a0 -> IHTMLStyle a -> Prelude.IO ()
setTop v = Automation.propertySet "top" [Automation.inVariant v]
getTop :: (Automation.Variant a0) => IHTMLStyle a -> Prelude.IO (a0)
getTop = Automation.propertyGet "top" [] Automation.outVariant
setLeft :: (Automation.Variant a0) => a0 -> IHTMLStyle a -> Prelude.IO ()
setLeft v = Automation.propertySet "left" [Automation.inVariant v]
getLeft :: (Automation.Variant a0) => IHTMLStyle a -> Prelude.IO (a0)
getLeft = Automation.propertyGet "left" [] Automation.outVariant
getPosition :: IHTMLStyle a -> Prelude.IO (Prelude.String)
getPosition =
  Automation.propertyGet "position" [] Automation.outString
setZIndex :: (Automation.Variant a0) => a0 -> IHTMLStyle a -> Prelude.IO ()
setZIndex v =
  Automation.propertySet "zIndex" [Automation.inVariant v]
getZIndex :: (Automation.Variant a0) => IHTMLStyle a -> Prelude.IO (a0)
getZIndex =
  Automation.propertyGet "zIndex" [] Automation.outVariant
setOverflow :: Prelude.String -> IHTMLStyle a -> Prelude.IO ()
setOverflow v =
  Automation.propertySet "overflow" [Automation.inString v]
getOverflow :: IHTMLStyle a -> Prelude.IO (Prelude.String)
getOverflow =
  Automation.propertyGet "overflow" [] Automation.outString
setPageBreakBefore :: Prelude.String -> IHTMLStyle a -> Prelude.IO ()
setPageBreakBefore v =
  Automation.propertySet "pageBreakBefore" [Automation.inString v]
getPageBreakBefore :: IHTMLStyle a -> Prelude.IO (Prelude.String)
getPageBreakBefore =
  Automation.propertyGet "pageBreakBefore" [] Automation.outString
setPageBreakAfter :: Prelude.String -> IHTMLStyle a -> Prelude.IO ()
setPageBreakAfter v =
  Automation.propertySet "pageBreakAfter" [Automation.inString v]
getPageBreakAfter :: IHTMLStyle a -> Prelude.IO (Prelude.String)
getPageBreakAfter =
  Automation.propertyGet "pageBreakAfter" [] Automation.outString
setCssText :: Prelude.String -> IHTMLStyle a -> Prelude.IO ()
setCssText v =
  Automation.propertySet "cssText" [Automation.inString v]
getCssText :: IHTMLStyle a -> Prelude.IO (Prelude.String)
getCssText =
  Automation.propertyGet "cssText" [] Automation.outString
setPixelTop :: Prelude.Int -> IHTMLStyle a -> Prelude.IO ()
setPixelTop v =
  Automation.propertySet "pixelTop" [Automation.inInt v]
getPixelTop :: IHTMLStyle a -> Prelude.IO (Prelude.Int)
getPixelTop =
  Automation.propertyGet "pixelTop" [] Automation.outInt
setPixelLeft :: Prelude.Int -> IHTMLStyle a -> Prelude.IO ()
setPixelLeft v =
  Automation.propertySet "pixelLeft" [Automation.inInt v]
getPixelLeft :: IHTMLStyle a -> Prelude.IO (Prelude.Int)
getPixelLeft =
  Automation.propertyGet "pixelLeft" [] Automation.outInt
setPixelWidth :: Prelude.Int -> IHTMLStyle a -> Prelude.IO ()
setPixelWidth v =
  Automation.propertySet "pixelWidth" [Automation.inInt v]
getPixelWidth :: IHTMLStyle a -> Prelude.IO (Prelude.Int)
getPixelWidth =
  Automation.propertyGet "pixelWidth" [] Automation.outInt
setPixelHeight :: Prelude.Int -> IHTMLStyle a -> Prelude.IO ()
setPixelHeight v =
  Automation.propertySet "pixelHeight" [Automation.inInt v]
getPixelHeight :: IHTMLStyle a -> Prelude.IO (Prelude.Int)
getPixelHeight =
  Automation.propertyGet "pixelHeight" [] Automation.outInt
setPosTop :: Prelude.Float -> IHTMLStyle a -> Prelude.IO ()
setPosTop v =
  Automation.propertySet "posTop" [Automation.inFloat v]
getPosTop :: IHTMLStyle a -> Prelude.IO (Prelude.Float)
getPosTop = Automation.propertyGet "posTop" [] Automation.outFloat
setPosLeft :: Prelude.Float -> IHTMLStyle a -> Prelude.IO ()
setPosLeft v =
  Automation.propertySet "posLeft" [Automation.inFloat v]
getPosLeft :: IHTMLStyle a -> Prelude.IO (Prelude.Float)
getPosLeft =
  Automation.propertyGet "posLeft" [] Automation.outFloat
setPosWidth :: Prelude.Float -> IHTMLStyle a -> Prelude.IO ()
setPosWidth v =
  Automation.propertySet "posWidth" [Automation.inFloat v]
getPosWidth :: IHTMLStyle a -> Prelude.IO (Prelude.Float)
getPosWidth =
  Automation.propertyGet "posWidth" [] Automation.outFloat
setPosHeight :: Prelude.Float -> IHTMLStyle a -> Prelude.IO ()
setPosHeight v =
  Automation.propertySet "posHeight" [Automation.inFloat v]
getPosHeight :: IHTMLStyle a -> Prelude.IO (Prelude.Float)
getPosHeight =
  Automation.propertyGet "posHeight" [] Automation.outFloat
setCursor :: Prelude.String -> IHTMLStyle a -> Prelude.IO ()
setCursor v =
  Automation.propertySet "cursor" [Automation.inString v]
getCursor :: IHTMLStyle a -> Prelude.IO (Prelude.String)
getCursor = Automation.propertyGet "cursor" [] Automation.outString
setClip :: Prelude.String -> IHTMLStyle a -> Prelude.IO ()
setClip v = Automation.propertySet "clip" [Automation.inString v]
getClip :: IHTMLStyle a -> Prelude.IO (Prelude.String)
getClip = Automation.propertyGet "clip" [] Automation.outString
setFilter :: Prelude.String -> IHTMLStyle a -> Prelude.IO ()
setFilter v =
  Automation.propertySet "filter" [Automation.inString v]
getFilter :: IHTMLStyle a -> Prelude.IO (Prelude.String)
getFilter = Automation.propertyGet "filter" [] Automation.outString
setAttribute :: (Automation.Variant a0) => Prelude.String -> a0 -> Prelude.Int -> Automation.IDispatch a -> Prelude.IO ()
setAttribute strAttributeName attributeValue lFlags =
  Automation.method0 "setAttribute" [Automation.inString strAttributeName, Automation.inVariant attributeValue, Automation.inInt lFlags]
getAttribute :: (Automation.Variant a0) => Prelude.String -> Prelude.Int -> Automation.IDispatch a -> Prelude.IO (a0)
getAttribute strAttributeName lFlags =
  Automation.function1 "getAttribute" [Automation.inString strAttributeName, Automation.inInt lFlags] Automation.outVariant
removeAttribute :: Prelude.String -> Prelude.Int -> Automation.IDispatch a -> Prelude.IO (Prelude.Int)
removeAttribute strAttributeName lFlags =
  Automation.function1 "removeAttribute" [Automation.inString strAttributeName, Automation.inInt lFlags] Automation.outInt
toString :: Automation.IDispatch a -> Prelude.IO (Prelude.String)
toString = Automation.function1 "toString" [] Automation.outString
-- --------------------------------------------------
-- 
-- coclass HTMLStyle
-- 
-- --------------------------------------------------
clsidHTMLStyle :: Com.CLSID
clsidHTMLStyle =
  Com.mkCLSID "{3050f285-98b5-11cf-bb82-00aa00bdce0b}"
-- --------------------------------------------------
-- 
-- interface IHTMLFiltersCollection
-- 
-- --------------------------------------------------
data HTMLFiltersCollection a = HTMLFiltersCollection
                                
type IHTMLFiltersCollection a = Automation.IDispatch (HTMLFiltersCollection a)
iidHTMLFiltersCollection :: Com.IID (IHTMLFiltersCollection Automation.Interface)
iidHTMLFiltersCollection =
  Com.mkIID "{3050f3ee-98b5-11cf-bb82-00aa00bdce0b}"
getLength :: Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getLength = Automation.propertyGet "length" [] Automation.outInt
getNewEnum :: Automation.IDispatch a -> Prelude.IO (Com.IUnknown Automation.Interface)
getNewEnum =
  Automation.propertyGet "_newEnum" [] Automation.outIUnknown
getItem0 :: (Automation.Variant a0, Automation.Variant a1) => a0 -> Automation.IDispatch a -> Prelude.IO (a1)
getItem0 pvarIndex =
  Automation.function1 "item" [Automation.inVariant pvarIndex] Automation.outVariant
-- --------------------------------------------------
-- 
-- interface ICSSFilterSite
-- 
-- --------------------------------------------------
data CSSFilterSite a = CSSFilterSite
                        
type ICSSFilterSite a = Automation.IDispatch (CSSFilterSite a)
iidCSSFilterSite :: Com.IID (ICSSFilterSite Automation.Interface)
iidCSSFilterSite =
  Com.mkIID "{3050f3ed-98b5-11cf-bb82-00aa00bdce0b}"
getElement :: ICSSFilterSite a -> Prelude.IO (IHTMLElement Automation.Interface)
getElement =
  Automation.function1 "GetElement" [] Automation.outIDispatch
fireOnFilterChangeEvent :: ICSSFilterSite a -> Prelude.IO ()
fireOnFilterChangeEvent =
  Automation.method0 "FireOnFilterChangeEvent" []
-- --------------------------------------------------
-- 
-- interface ICSSFilter
-- 
-- --------------------------------------------------
data CSSFilter a = CSSFilter
                    
type ICSSFilter a = Automation.IDispatch (CSSFilter a)
iidCSSFilter :: Com.IID (ICSSFilter Automation.Interface)
iidCSSFilter = Com.mkIID "{3050f3ec-98b5-11cf-bb82-00aa00bdce0b}"
setSite :: ICSSFilterSite a0 -> ICSSFilter a -> Prelude.IO ()
setSite pSink =
  Automation.method0 "SetSite" [Automation.inIDispatch pSink]
onAmbientPropertyChange :: Prelude.Int -> ICSSFilter a -> Prelude.IO ()
onAmbientPropertyChange dispid =
  Automation.method0 "OnAmbientPropertyChange" [Automation.inInt dispid]
-- --------------------------------------------------
-- 
-- coclass HTMLFiltersCollection
-- 
-- --------------------------------------------------
clsidHTMLFiltersCollection :: Com.CLSID
clsidHTMLFiltersCollection =
  Com.mkCLSID "{3050f3ef-98b5-11cf-bb82-00aa00bdce0b}"
-- --------------------------------------------------
-- 
-- dispinterface HTMLElementEvents
-- 
-- --------------------------------------------------
data HTMLElementEvents a = HTMLElementEvents
                            
type IHTMLElementEvents a = Automation.IDispatch (HTMLElementEvents a)
iidHTMLElementEvents :: Com.IID (IHTMLElementEvents Automation.Interface)
iidHTMLElementEvents =
  Com.mkIID "{3050f33c-98b5-11cf-bb82-00aa00bdce0b}"
onhelp :: Automation.IDispatch a -> Prelude.IO ()
onhelp = Automation.method0 "onhelp" []
onclick :: Automation.IDispatch a -> Prelude.IO ()
onclick = Automation.method0 "onclick" []
ondblclick :: Automation.IDispatch a -> Prelude.IO ()
ondblclick = Automation.method0 "ondblclick" []
onkeypress :: Automation.IDispatch a -> Prelude.IO ()
onkeypress = Automation.method0 "onkeypress" []
onkeydown :: Automation.IDispatch a -> Prelude.IO ()
onkeydown = Automation.method0 "onkeydown" []
onkeyup :: Automation.IDispatch a -> Prelude.IO ()
onkeyup = Automation.method0 "onkeyup" []
onmouseout :: Automation.IDispatch a -> Prelude.IO ()
onmouseout = Automation.method0 "onmouseout" []
onmouseover :: Automation.IDispatch a -> Prelude.IO ()
onmouseover = Automation.method0 "onmouseover" []
onmousemove :: Automation.IDispatch a -> Prelude.IO ()
onmousemove = Automation.method0 "onmousemove" []
onmousedown :: Automation.IDispatch a -> Prelude.IO ()
onmousedown = Automation.method0 "onmousedown" []
onmouseup :: Automation.IDispatch a -> Prelude.IO ()
onmouseup = Automation.method0 "onmouseup" []
onselectstart :: Automation.IDispatch a -> Prelude.IO ()
onselectstart = Automation.method0 "onselectstart" []
onfilterchange :: Automation.IDispatch a -> Prelude.IO ()
onfilterchange = Automation.method0 "onfilterchange" []
ondragstart :: Automation.IDispatch a -> Prelude.IO ()
ondragstart = Automation.method0 "ondragstart" []
onbeforeupdate :: Automation.IDispatch a -> Prelude.IO ()
onbeforeupdate = Automation.method0 "onbeforeupdate" []
onafterupdate :: Automation.IDispatch a -> Prelude.IO ()
onafterupdate = Automation.method0 "onafterupdate" []
onerrorupdate :: Automation.IDispatch a -> Prelude.IO ()
onerrorupdate = Automation.method0 "onerrorupdate" []
onrowexit :: Automation.IDispatch a -> Prelude.IO ()
onrowexit = Automation.method0 "onrowexit" []
onrowenter :: Automation.IDispatch a -> Prelude.IO ()
onrowenter = Automation.method0 "onrowenter" []
ondatasetchanged :: Automation.IDispatch a -> Prelude.IO ()
ondatasetchanged = Automation.method0 "ondatasetchanged" []
ondataavailable :: Automation.IDispatch a -> Prelude.IO ()
ondataavailable = Automation.method0 "ondataavailable" []
ondatasetcomplete :: Automation.IDispatch a -> Prelude.IO ()
ondatasetcomplete = Automation.method0 "ondatasetcomplete" []
-- --------------------------------------------------
-- 
-- interface IHTMLElement
-- 
-- --------------------------------------------------
data HTMLElement a = HTMLElement
                      
type IHTMLElement a = Automation.IDispatch (HTMLElement a)
iidHTMLElement :: Com.IID (IHTMLElement Automation.Interface)
iidHTMLElement = Com.mkIID "{3050f1ff-98b5-11cf-bb82-00aa00bdce0b}"
setClassName :: Prelude.String -> Automation.IDispatch a -> Prelude.IO ()
setClassName v =
  Automation.propertySet "className" [Automation.inString v]
getClassName :: Automation.IDispatch a -> Prelude.IO (Prelude.String)
getClassName =
  Automation.propertyGet "className" [] Automation.outString
setId :: Prelude.String -> Automation.IDispatch a -> Prelude.IO ()
setId v = Automation.propertySet "id" [Automation.inString v]
getId :: Automation.IDispatch a -> Prelude.IO (Prelude.String)
getId = Automation.propertyGet "id" [] Automation.outString
getTagName :: Automation.IDispatch a -> Prelude.IO (Prelude.String)
getTagName =
  Automation.propertyGet "tagName" [] Automation.outString
getParentElement :: Automation.IDispatch a -> Prelude.IO (IHTMLElement Automation.Interface)
getParentElement =
  Automation.propertyGet "parentElement" [] Automation.outIDispatch
getStyle :: Automation.IDispatch a -> Prelude.IO (IHTMLStyle Automation.Interface)
getStyle =
  Automation.propertyGet "style" [] Automation.outIDispatch
setOnhelp :: (Automation.Variant a0) => a0 -> Automation.IDispatch a -> Prelude.IO ()
setOnhelp v =
  Automation.propertySet "onhelp" [Automation.inVariant v]
getOnhelp :: (Automation.Variant a0) => Automation.IDispatch a -> Prelude.IO (a0)
getOnhelp =
  Automation.propertyGet "onhelp" [] Automation.outVariant
setOnclick :: (Automation.Variant a0) => a0 -> Automation.IDispatch a -> Prelude.IO ()
setOnclick v =
  Automation.propertySet "onclick" [Automation.inVariant v]
getOnclick :: (Automation.Variant a0) => Automation.IDispatch a -> Prelude.IO (a0)
getOnclick =
  Automation.propertyGet "onclick" [] Automation.outVariant
setOndblclick :: (Automation.Variant a0) => a0 -> Automation.IDispatch a -> Prelude.IO ()
setOndblclick v =
  Automation.propertySet "ondblclick" [Automation.inVariant v]
getOndblclick :: (Automation.Variant a0) => Automation.IDispatch a -> Prelude.IO (a0)
getOndblclick =
  Automation.propertyGet "ondblclick" [] Automation.outVariant
setOnkeydown :: (Automation.Variant a0) => a0 -> Automation.IDispatch a -> Prelude.IO ()
setOnkeydown v =
  Automation.propertySet "onkeydown" [Automation.inVariant v]
getOnkeydown :: (Automation.Variant a0) => Automation.IDispatch a -> Prelude.IO (a0)
getOnkeydown =
  Automation.propertyGet "onkeydown" [] Automation.outVariant
setOnkeyup :: (Automation.Variant a0) => a0 -> Automation.IDispatch a -> Prelude.IO ()
setOnkeyup v =
  Automation.propertySet "onkeyup" [Automation.inVariant v]
getOnkeyup :: (Automation.Variant a0) => Automation.IDispatch a -> Prelude.IO (a0)
getOnkeyup =
  Automation.propertyGet "onkeyup" [] Automation.outVariant
setOnkeypress :: (Automation.Variant a0) => a0 -> Automation.IDispatch a -> Prelude.IO ()
setOnkeypress v =
  Automation.propertySet "onkeypress" [Automation.inVariant v]
getOnkeypress :: (Automation.Variant a0) => Automation.IDispatch a -> Prelude.IO (a0)
getOnkeypress =
  Automation.propertyGet "onkeypress" [] Automation.outVariant
setOnmouseout :: (Automation.Variant a0) => a0 -> Automation.IDispatch a -> Prelude.IO ()
setOnmouseout v =
  Automation.propertySet "onmouseout" [Automation.inVariant v]
getOnmouseout :: (Automation.Variant a0) => Automation.IDispatch a -> Prelude.IO (a0)
getOnmouseout =
  Automation.propertyGet "onmouseout" [] Automation.outVariant
setOnmouseover :: (Automation.Variant a0) => a0 -> Automation.IDispatch a -> Prelude.IO ()
setOnmouseover v =
  Automation.propertySet "onmouseover" [Automation.inVariant v]
getOnmouseover :: (Automation.Variant a0) => Automation.IDispatch a -> Prelude.IO (a0)
getOnmouseover =
  Automation.propertyGet "onmouseover" [] Automation.outVariant
setOnmousemove :: (Automation.Variant a0) => a0 -> Automation.IDispatch a -> Prelude.IO ()
setOnmousemove v =
  Automation.propertySet "onmousemove" [Automation.inVariant v]
getOnmousemove :: (Automation.Variant a0) => Automation.IDispatch a -> Prelude.IO (a0)
getOnmousemove =
  Automation.propertyGet "onmousemove" [] Automation.outVariant
setOnmousedown :: (Automation.Variant a0) => a0 -> Automation.IDispatch a -> Prelude.IO ()
setOnmousedown v =
  Automation.propertySet "onmousedown" [Automation.inVariant v]
getOnmousedown :: (Automation.Variant a0) => Automation.IDispatch a -> Prelude.IO (a0)
getOnmousedown =
  Automation.propertyGet "onmousedown" [] Automation.outVariant
setOnmouseup :: (Automation.Variant a0) => a0 -> Automation.IDispatch a -> Prelude.IO ()
setOnmouseup v =
  Automation.propertySet "onmouseup" [Automation.inVariant v]
getOnmouseup :: (Automation.Variant a0) => Automation.IDispatch a -> Prelude.IO (a0)
getOnmouseup =
  Automation.propertyGet "onmouseup" [] Automation.outVariant
getDocument :: Automation.IDispatch a -> Prelude.IO (IHTMLDocument2 Automation.Interface)
getDocument =
  Automation.propertyGet "document" [] Automation.outIDispatch
setTitle :: Prelude.String -> Automation.IDispatch a -> Prelude.IO ()
setTitle v = Automation.propertySet "title" [Automation.inString v]
getTitle :: Automation.IDispatch a -> Prelude.IO (Prelude.String)
getTitle = Automation.propertyGet "title" [] Automation.outString
setLanguage :: Prelude.String -> Automation.IDispatch a -> Prelude.IO ()
setLanguage v =
  Automation.propertySet "language" [Automation.inString v]
getLanguage :: Automation.IDispatch a -> Prelude.IO (Prelude.String)
getLanguage =
  Automation.propertyGet "language" [] Automation.outString
setOnselectstart :: (Automation.Variant a0) => a0 -> Automation.IDispatch a -> Prelude.IO ()
setOnselectstart v =
  Automation.propertySet "onselectstart" [Automation.inVariant v]
getOnselectstart :: (Automation.Variant a0) => Automation.IDispatch a -> Prelude.IO (a0)
getOnselectstart =
  Automation.propertyGet "onselectstart" [] Automation.outVariant
scrollIntoView :: (Automation.Variant a0) => a0 -> Automation.IDispatch a -> Prelude.IO ()
scrollIntoView varargStart =
  Automation.method0 "scrollIntoView" [Automation.inVariant varargStart]
contains :: IHTMLElement a0 -> Automation.IDispatch a -> Prelude.IO (Prelude.Int)
contains pChild =
  Automation.function1 "contains" [Automation.inIDispatch pChild] Automation.outInt
getSourceIndex :: Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getSourceIndex =
  Automation.propertyGet "sourceIndex" [] Automation.outInt
getRecordNumber :: (Automation.Variant a0) => Automation.IDispatch a -> Prelude.IO (a0)
getRecordNumber =
  Automation.propertyGet "recordNumber" [] Automation.outVariant
setLang :: Prelude.String -> Automation.IDispatch a -> Prelude.IO ()
setLang v = Automation.propertySet "lang" [Automation.inString v]
getLang :: Automation.IDispatch a -> Prelude.IO (Prelude.String)
getLang = Automation.propertyGet "lang" [] Automation.outString
getOffsetLeft :: Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getOffsetLeft =
  Automation.propertyGet "offsetLeft" [] Automation.outInt
getOffsetTop :: Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getOffsetTop =
  Automation.propertyGet "offsetTop" [] Automation.outInt
getOffsetWidth :: Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getOffsetWidth =
  Automation.propertyGet "offsetWidth" [] Automation.outInt
getOffsetHeight :: Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getOffsetHeight =
  Automation.propertyGet "offsetHeight" [] Automation.outInt
getOffsetParent :: Automation.IDispatch a -> Prelude.IO (IHTMLElement Automation.Interface)
getOffsetParent =
  Automation.propertyGet "offsetParent" [] Automation.outIDispatch
setInnerHTML :: Prelude.String -> Automation.IDispatch a -> Prelude.IO ()
setInnerHTML v =
  Automation.propertySet "innerHTML" [Automation.inString v]
getInnerHTML :: Automation.IDispatch a -> Prelude.IO (Prelude.String)
getInnerHTML =
  Automation.propertyGet "innerHTML" [] Automation.outString
setInnerText :: Prelude.String -> Automation.IDispatch a -> Prelude.IO ()
setInnerText v =
  Automation.propertySet "innerText" [Automation.inString v]
getInnerText :: Automation.IDispatch a -> Prelude.IO (Prelude.String)
getInnerText =
  Automation.propertyGet "innerText" [] Automation.outString
setOuterHTML :: Prelude.String -> Automation.IDispatch a -> Prelude.IO ()
setOuterHTML v =
  Automation.propertySet "outerHTML" [Automation.inString v]
getOuterHTML :: Automation.IDispatch a -> Prelude.IO (Prelude.String)
getOuterHTML =
  Automation.propertyGet "outerHTML" [] Automation.outString
setOuterText :: Prelude.String -> Automation.IDispatch a -> Prelude.IO ()
setOuterText v =
  Automation.propertySet "outerText" [Automation.inString v]
getOuterText :: Automation.IDispatch a -> Prelude.IO (Prelude.String)
getOuterText =
  Automation.propertyGet "outerText" [] Automation.outString
insertAdjacentHTML :: Prelude.String -> Prelude.String -> Automation.IDispatch a -> Prelude.IO ()
insertAdjacentHTML where0 html =
  Automation.method0 "insertAdjacentHTML" [Automation.inString where0, Automation.inString html]
insertAdjacentText :: Prelude.String -> Prelude.String -> Automation.IDispatch a -> Prelude.IO ()
insertAdjacentText where0 text =
  Automation.method0 "insertAdjacentText" [Automation.inString where0, Automation.inString text]
getParentTextEdit :: Automation.IDispatch a -> Prelude.IO (IHTMLElement Automation.Interface)
getParentTextEdit =
  Automation.propertyGet "parentTextEdit" [] Automation.outIDispatch
getIsTextEdit :: Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getIsTextEdit =
  Automation.propertyGet "isTextEdit" [] Automation.outInt
click :: Automation.IDispatch a -> Prelude.IO ()
click = Automation.method0 "click" []
getFilters :: Automation.IDispatch a -> Prelude.IO (IHTMLFiltersCollection Automation.Interface)
getFilters =
  Automation.propertyGet "filters" [] Automation.outIDispatch
setOndragstart :: (Automation.Variant a0) => a0 -> Automation.IDispatch a -> Prelude.IO ()
setOndragstart v =
  Automation.propertySet "ondragstart" [Automation.inVariant v]
getOndragstart :: (Automation.Variant a0) => Automation.IDispatch a -> Prelude.IO (a0)
getOndragstart =
  Automation.propertyGet "ondragstart" [] Automation.outVariant
setOnbeforeupdate :: (Automation.Variant a0) => a0 -> Automation.IDispatch a -> Prelude.IO ()
setOnbeforeupdate v =
  Automation.propertySet "onbeforeupdate" [Automation.inVariant v]
getOnbeforeupdate :: (Automation.Variant a0) => Automation.IDispatch a -> Prelude.IO (a0)
getOnbeforeupdate =
  Automation.propertyGet "onbeforeupdate" [] Automation.outVariant
setOnafterupdate :: (Automation.Variant a0) => a0 -> Automation.IDispatch a -> Prelude.IO ()
setOnafterupdate v =
  Automation.propertySet "onafterupdate" [Automation.inVariant v]
getOnafterupdate :: (Automation.Variant a0) => Automation.IDispatch a -> Prelude.IO (a0)
getOnafterupdate =
  Automation.propertyGet "onafterupdate" [] Automation.outVariant
setOnerrorupdate :: (Automation.Variant a0) => a0 -> Automation.IDispatch a -> Prelude.IO ()
setOnerrorupdate v =
  Automation.propertySet "onerrorupdate" [Automation.inVariant v]
getOnerrorupdate :: (Automation.Variant a0) => Automation.IDispatch a -> Prelude.IO (a0)
getOnerrorupdate =
  Automation.propertyGet "onerrorupdate" [] Automation.outVariant
setOnrowexit :: (Automation.Variant a0) => a0 -> Automation.IDispatch a -> Prelude.IO ()
setOnrowexit v =
  Automation.propertySet "onrowexit" [Automation.inVariant v]
getOnrowexit :: (Automation.Variant a0) => Automation.IDispatch a -> Prelude.IO (a0)
getOnrowexit =
  Automation.propertyGet "onrowexit" [] Automation.outVariant
setOnrowenter :: (Automation.Variant a0) => a0 -> Automation.IDispatch a -> Prelude.IO ()
setOnrowenter v =
  Automation.propertySet "onrowenter" [Automation.inVariant v]
getOnrowenter :: (Automation.Variant a0) => Automation.IDispatch a -> Prelude.IO (a0)
getOnrowenter =
  Automation.propertyGet "onrowenter" [] Automation.outVariant
setOndatasetchanged :: (Automation.Variant a0) => a0 -> Automation.IDispatch a -> Prelude.IO ()
setOndatasetchanged v =
  Automation.propertySet "ondatasetchanged" [Automation.inVariant v]
getOndatasetchanged :: (Automation.Variant a0) => Automation.IDispatch a -> Prelude.IO (a0)
getOndatasetchanged =
  Automation.propertyGet "ondatasetchanged" [] Automation.outVariant
setOndataavailable :: (Automation.Variant a0) => a0 -> Automation.IDispatch a -> Prelude.IO ()
setOndataavailable v =
  Automation.propertySet "ondataavailable" [Automation.inVariant v]
getOndataavailable :: (Automation.Variant a0) => Automation.IDispatch a -> Prelude.IO (a0)
getOndataavailable =
  Automation.propertyGet "ondataavailable" [] Automation.outVariant
setOndatasetcomplete :: (Automation.Variant a0) => a0 -> Automation.IDispatch a -> Prelude.IO ()
setOndatasetcomplete v =
  Automation.propertySet "ondatasetcomplete" [Automation.inVariant v]
getOndatasetcomplete :: (Automation.Variant a0) => Automation.IDispatch a -> Prelude.IO (a0)
getOndatasetcomplete =
  Automation.propertyGet "ondatasetcomplete" [] Automation.outVariant
setOnfilterchange :: (Automation.Variant a0) => a0 -> Automation.IDispatch a -> Prelude.IO ()
setOnfilterchange v =
  Automation.propertySet "onfilterchange" [Automation.inVariant v]
getOnfilterchange :: (Automation.Variant a0) => Automation.IDispatch a -> Prelude.IO (a0)
getOnfilterchange =
  Automation.propertyGet "onfilterchange" [] Automation.outVariant
-- --------------------------------------------------
-- 
-- interface IHTMLDatabinding
-- 
-- --------------------------------------------------
data HTMLDatabinding a = HTMLDatabinding
                          
type IHTMLDatabinding a = Automation.IDispatch (HTMLDatabinding a)
iidHTMLDatabinding :: Com.IID (IHTMLDatabinding Automation.Interface)
iidHTMLDatabinding =
  Com.mkIID "{3050f3f2-98b5-11cf-bb82-00aa00bdce0b}"
setDataFld :: Prelude.String -> Automation.IDispatch a -> Prelude.IO ()
setDataFld v =
  Automation.propertySet "dataFld" [Automation.inString v]
getDataFld :: Automation.IDispatch a -> Prelude.IO (Prelude.String)
getDataFld =
  Automation.propertyGet "dataFld" [] Automation.outString
setDataSrc :: Prelude.String -> Automation.IDispatch a -> Prelude.IO ()
setDataSrc v =
  Automation.propertySet "dataSrc" [Automation.inString v]
getDataSrc :: Automation.IDispatch a -> Prelude.IO (Prelude.String)
getDataSrc =
  Automation.propertyGet "dataSrc" [] Automation.outString
setDataFormatAs :: Prelude.String -> Automation.IDispatch a -> Prelude.IO ()
setDataFormatAs v =
  Automation.propertySet "dataFormatAs" [Automation.inString v]
getDataFormatAs :: Automation.IDispatch a -> Prelude.IO (Prelude.String)
getDataFormatAs =
  Automation.propertyGet "dataFormatAs" [] Automation.outString
-- --------------------------------------------------
-- 
-- interface IHTMLStyleSheet
-- 
-- --------------------------------------------------
data HTMLStyleSheet a = HTMLStyleSheet
                         
type IHTMLStyleSheet a = Automation.IDispatch (HTMLStyleSheet a)
iidHTMLStyleSheet :: Com.IID (IHTMLStyleSheet Automation.Interface)
iidHTMLStyleSheet =
  Com.mkIID "{3050f2e3-98b5-11cf-bb82-00aa00bdce0b}"
getParentStyleSheet :: IHTMLStyleSheet a -> Prelude.IO (IHTMLStyleSheet Automation.Interface)
getParentStyleSheet =
  Automation.propertyGet "parentStyleSheet" [] Automation.outIDispatch
getOwningElement :: IHTMLStyleSheet a -> Prelude.IO (IHTMLElement Automation.Interface)
getOwningElement =
  Automation.propertyGet "owningElement" [] Automation.outIDispatch
setDisabled :: Prelude.Int -> Automation.IDispatch a -> Prelude.IO ()
setDisabled v =
  Automation.propertySet "disabled" [Automation.inInt v]
getDisabled :: Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getDisabled =
  Automation.propertyGet "disabled" [] Automation.outInt
getReadOnly :: Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getReadOnly =
  Automation.propertyGet "readOnly" [] Automation.outInt
getImports :: IHTMLStyleSheet a -> Prelude.IO (IHTMLStyleSheetsCollection Automation.Interface)
getImports =
  Automation.propertyGet "imports" [] Automation.outIDispatch
setHref :: Prelude.String -> Automation.IDispatch a -> Prelude.IO ()
setHref v = Automation.propertySet "href" [Automation.inString v]
getHref :: Automation.IDispatch a -> Prelude.IO (Prelude.String)
getHref = Automation.propertyGet "href" [] Automation.outString
getType :: Automation.IDispatch a -> Prelude.IO (Prelude.String)
getType = Automation.propertyGet "type" [] Automation.outString
addImport :: Prelude.String -> Prelude.Int -> IHTMLStyleSheet a -> Prelude.IO (Prelude.Int)
addImport bstrURL lIndex =
  Automation.function1 "addImport" [Automation.inString bstrURL, Automation.inInt lIndex] Automation.outInt
addRule :: Prelude.String -> Prelude.String -> Prelude.Int -> IHTMLStyleSheet a -> Prelude.IO (Prelude.Int)
addRule bstrSelector bstrStyle lIndex =
  Automation.function1 "addRule" [Automation.inString bstrSelector, Automation.inString bstrStyle, Automation.inInt lIndex] Automation.outInt
-- --------------------------------------------------
-- 
-- coclass HTMLStyleSheet
-- 
-- --------------------------------------------------
clsidHTMLStyleSheet :: Com.CLSID
clsidHTMLStyleSheet =
  Com.mkCLSID "{3050f2e4-98b5-11cf-bb82-00aa00bdce0b}"
-- --------------------------------------------------
-- 
-- interface IHTMLStyleSheetsCollection
-- 
-- --------------------------------------------------
data HTMLStyleSheetsCollection a = HTMLStyleSheetsCollection
                                    
type IHTMLStyleSheetsCollection a = Automation.IDispatch (HTMLStyleSheetsCollection a)
iidHTMLStyleSheetsCollection :: Com.IID (IHTMLStyleSheetsCollection Automation.Interface)
iidHTMLStyleSheetsCollection =
  Com.mkIID "{3050f37e-98b5-11cf-bb82-00aa00bdce0b}"
-- --------------------------------------------------
-- 
-- coclass HTMLStyleSheetsCollection
-- 
-- --------------------------------------------------
clsidHTMLStyleSheetsCollection :: Com.CLSID
clsidHTMLStyleSheetsCollection =
  Com.mkCLSID "{3050f37f-98b5-11cf-bb82-00aa00bdce0b}"
-- --------------------------------------------------
-- 
-- dispinterface HTMLLinkElementEvents
-- 
-- --------------------------------------------------
data HTMLLinkElementEvents a = HTMLLinkElementEvents
                                
type IHTMLLinkElementEvents a = Automation.IDispatch (HTMLLinkElementEvents a)
iidHTMLLinkElementEvents :: Com.IID (IHTMLLinkElementEvents Automation.Interface)
iidHTMLLinkElementEvents =
  Com.mkIID "{3050f3cc-98b5-11cf-bb82-00aa00bdce0b}"
onreadystatechange :: Automation.IDispatch a -> Prelude.IO ()
onreadystatechange = Automation.method0 "onreadystatechange" []
onload :: Automation.IDispatch a -> Prelude.IO ()
onload = Automation.method0 "onload" []
onerror :: Automation.IDispatch a -> Prelude.IO ()
onerror = Automation.method0 "onerror" []
-- --------------------------------------------------
-- 
-- interface IHTMLLinkElement
-- 
-- --------------------------------------------------
data HTMLLinkElement a = HTMLLinkElement
                          
type IHTMLLinkElement a = Automation.IDispatch (HTMLLinkElement a)
iidHTMLLinkElement :: Com.IID (IHTMLLinkElement Automation.Interface)
iidHTMLLinkElement =
  Com.mkIID "{3050f205-98b5-11cf-bb82-00aa00bdce0b}"
setRel :: Prelude.String -> Automation.IDispatch a -> Prelude.IO ()
setRel v = Automation.propertySet "rel" [Automation.inString v]
getRel :: Automation.IDispatch a -> Prelude.IO (Prelude.String)
getRel = Automation.propertyGet "rel" [] Automation.outString
setRev :: Prelude.String -> Automation.IDispatch a -> Prelude.IO ()
setRev v = Automation.propertySet "rev" [Automation.inString v]
getRev :: Automation.IDispatch a -> Prelude.IO (Prelude.String)
getRev = Automation.propertyGet "rev" [] Automation.outString
setType :: Prelude.String -> Automation.IDispatch a -> Prelude.IO ()
setType v = Automation.propertySet "type" [Automation.inString v]
getReadyState :: Automation.IDispatch a -> Prelude.IO (Prelude.String)
getReadyState =
  Automation.propertyGet "readyState" [] Automation.outString
setOnreadystatechange :: (Automation.Variant a0) => a0 -> Automation.IDispatch a -> Prelude.IO ()
setOnreadystatechange v =
  Automation.propertySet "onreadystatechange" [Automation.inVariant v]
getOnreadystatechange :: (Automation.Variant a0) => Automation.IDispatch a -> Prelude.IO (a0)
getOnreadystatechange =
  Automation.propertyGet "onreadystatechange" [] Automation.outVariant
setOnload :: (Automation.Variant a0) => a0 -> Automation.IDispatch a -> Prelude.IO ()
setOnload v =
  Automation.propertySet "onload" [Automation.inVariant v]
getOnload :: (Automation.Variant a0) => Automation.IDispatch a -> Prelude.IO (a0)
getOnload =
  Automation.propertyGet "onload" [] Automation.outVariant
setOnerror :: (Automation.Variant a0) => a0 -> Automation.IDispatch a -> Prelude.IO ()
setOnerror v =
  Automation.propertySet "onerror" [Automation.inVariant v]
getOnerror :: (Automation.Variant a0) => Automation.IDispatch a -> Prelude.IO (a0)
getOnerror =
  Automation.propertyGet "onerror" [] Automation.outVariant
getStyleSheet :: Automation.IDispatch a -> Prelude.IO (IHTMLStyleSheet Automation.Interface)
getStyleSheet =
  Automation.propertyGet "styleSheet" [] Automation.outIDispatch
-- --------------------------------------------------
-- 
-- dispinterface DispIHTMLLinkElement
-- 
-- --------------------------------------------------
                           
type DispIHTMLLinkElement a = Automation.IDispatch (HTMLLinkElement a)
iidIHTMLLinkElement :: Com.IID (DispIHTMLLinkElement Automation.Interface)
iidIHTMLLinkElement =
  Com.mkIID "{3050f524-98b5-11cf-bb82-00aa00bdce0b}"
-- --------------------------------------------------
-- 
-- coclass HTMLLinkElement
-- 
-- --------------------------------------------------
clsidHTMLLinkElement :: Com.CLSID
clsidHTMLLinkElement =
  Com.mkCLSID "{3050f277-98b5-11cf-bb82-00aa00bdce0b}"
-- --------------------------------------------------
-- 
-- interface IHTMLTxtRange
-- 
-- --------------------------------------------------
data HTMLTxtRange a = HTMLTxtRange
                       
type IHTMLTxtRange a = Automation.IDispatch (HTMLTxtRange a)
iidHTMLTxtRange :: Com.IID (IHTMLTxtRange Automation.Interface)
iidHTMLTxtRange =
  Com.mkIID "{3050f220-98b5-11cf-bb82-00aa00bdce0b}"
getHtmlText :: IHTMLTxtRange a -> Prelude.IO (Prelude.String)
getHtmlText =
  Automation.propertyGet "htmlText" [] Automation.outString
setText :: Prelude.String -> Automation.IDispatch a -> Prelude.IO ()
setText v = Automation.propertySet "text" [Automation.inString v]
getText :: Automation.IDispatch a -> Prelude.IO (Prelude.String)
getText = Automation.propertyGet "text" [] Automation.outString
duplicate :: IHTMLTxtRange a -> Prelude.IO (IHTMLTxtRange Automation.Interface)
duplicate =
  Automation.function1 "duplicate" [] Automation.outIDispatch
isInRange :: IHTMLTxtRange a0 -> IHTMLTxtRange a -> Prelude.IO (Prelude.Int)
isInRange range =
  Automation.function1 "inRange" [Automation.inIDispatch range] Automation.outInt
isEqual :: IHTMLTxtRange a0 -> IHTMLTxtRange a -> Prelude.IO (Prelude.Int)
isEqual range =
  Automation.function1 "isEqual" [Automation.inIDispatch range] Automation.outInt
scrollIntoView1 :: Prelude.Int -> IHTMLTxtRange a -> Prelude.IO ()
scrollIntoView1 fStart =
  Automation.method0 "scrollIntoView" [Automation.inInt fStart]
collapse :: Prelude.Int -> IHTMLTxtRange a -> Prelude.IO ()
collapse start =
  Automation.method0 "collapse" [Automation.inInt start]
expand :: Prelude.String -> IHTMLTxtRange a -> Prelude.IO (Prelude.Int)
expand unit =
  Automation.function1 "expand" [Automation.inString unit] Automation.outInt
move :: Prelude.String -> Prelude.Int -> IHTMLTxtRange a -> Prelude.IO (Prelude.Int)
move unit count =
  Automation.function1 "move" [Automation.inString unit, Automation.inInt count] Automation.outInt
moveStart :: Prelude.String -> Prelude.Int -> IHTMLTxtRange a -> Prelude.IO (Prelude.Int)
moveStart unit count =
  Automation.function1 "moveStart" [Automation.inString unit, Automation.inInt count] Automation.outInt
moveEnd :: Prelude.String -> Prelude.Int -> IHTMLTxtRange a -> Prelude.IO (Prelude.Int)
moveEnd unit count =
  Automation.function1 "moveEnd" [Automation.inString unit, Automation.inInt count] Automation.outInt
select :: Automation.IDispatch a -> Prelude.IO ()
select = Automation.method0 "select" []
pasteHTML :: Prelude.String -> IHTMLTxtRange a -> Prelude.IO ()
pasteHTML html =
  Automation.method0 "pasteHTML" [Automation.inString html]
moveToElementText :: IHTMLElement a0 -> IHTMLTxtRange a -> Prelude.IO ()
moveToElementText element =
  Automation.method0 "moveToElementText" [Automation.inIDispatch element]
setEndPoint :: Prelude.String -> IHTMLTxtRange a0 -> IHTMLTxtRange a -> Prelude.IO ()
setEndPoint how sourceRange =
  Automation.method0 "setEndPoint" [Automation.inString how, Automation.inIDispatch sourceRange]
compareEndPoints :: Prelude.String -> IHTMLTxtRange a0 -> IHTMLTxtRange a -> Prelude.IO (Prelude.Int)
compareEndPoints how sourceRange =
  Automation.function1 "compareEndPoints" [Automation.inString how, Automation.inIDispatch sourceRange] Automation.outInt
findText :: Prelude.String -> Prelude.Int -> Prelude.Int -> IHTMLTxtRange a -> Prelude.IO (Prelude.Int)
findText string count flags =
  Automation.function1 "findText" [Automation.inString string, Automation.inInt count, Automation.inInt flags] Automation.outInt
moveToPoint :: Prelude.Int -> Prelude.Int -> IHTMLTxtRange a -> Prelude.IO ()
moveToPoint x y =
  Automation.method0 "moveToPoint" [Automation.inInt x, Automation.inInt y]
getBookmark :: IHTMLTxtRange a -> Prelude.IO (Prelude.String)
getBookmark =
  Automation.function1 "getBookmark" [] Automation.outString
moveToBookmark :: Prelude.String -> IHTMLTxtRange a -> Prelude.IO (Prelude.Int)
moveToBookmark bookmark =
  Automation.function1 "moveToBookmark" [Automation.inString bookmark] Automation.outInt
queryCommandSupported :: Prelude.String -> Automation.IDispatch a -> Prelude.IO (Prelude.Int)
queryCommandSupported cmdID =
  Automation.function1 "queryCommandSupported" [Automation.inString cmdID] Automation.outInt
queryCommandEnabled :: Prelude.String -> Automation.IDispatch a -> Prelude.IO (Prelude.Int)
queryCommandEnabled cmdID =
  Automation.function1 "queryCommandEnabled" [Automation.inString cmdID] Automation.outInt
queryCommandState :: Prelude.String -> Automation.IDispatch a -> Prelude.IO (Prelude.Int)
queryCommandState cmdID =
  Automation.function1 "queryCommandState" [Automation.inString cmdID] Automation.outInt
queryCommandIndeterm :: Prelude.String -> Automation.IDispatch a -> Prelude.IO (Prelude.Int)
queryCommandIndeterm cmdID =
  Automation.function1 "queryCommandIndeterm" [Automation.inString cmdID] Automation.outInt
queryCommandText :: Prelude.String -> Automation.IDispatch a -> Prelude.IO (Prelude.String)
queryCommandText cmdID =
  Automation.function1 "queryCommandText" [Automation.inString cmdID] Automation.outString
queryCommandValue :: (Automation.Variant a0) => Prelude.String -> Automation.IDispatch a -> Prelude.IO (a0)
queryCommandValue cmdID =
  Automation.function1 "queryCommandValue" [Automation.inString cmdID] Automation.outVariant
execCommand :: (Automation.Variant a0) => Prelude.String -> Prelude.Int -> a0 -> Automation.IDispatch a -> Prelude.IO (Prelude.Int)
execCommand cmdID showUI value =
  Automation.function1 "execCommand" [Automation.inString cmdID, Automation.inInt showUI, Automation.inVariant value] Automation.outInt
execCommandShowHelp :: Prelude.String -> Automation.IDispatch a -> Prelude.IO (Prelude.Int)
execCommandShowHelp cmdID =
  Automation.function1 "execCommandShowHelp" [Automation.inString cmdID] Automation.outInt
-- --------------------------------------------------
-- 
-- dispinterface HTMLFormElementEvents
-- 
-- --------------------------------------------------
data HTMLFormElementEvents a = HTMLFormElementEvents
                                
type IHTMLFormElementEvents a = Automation.IDispatch (HTMLFormElementEvents a)
iidHTMLFormElementEvents :: Com.IID (IHTMLFormElementEvents Automation.Interface)
iidHTMLFormElementEvents =
  Com.mkIID "{3050f364-98b5-11cf-bb82-00aa00bdce0b}"
onsubmit :: IHTMLFormElementEvents a -> Prelude.IO ()
onsubmit = Automation.method0 "onsubmit" []
onreset :: IHTMLFormElementEvents a -> Prelude.IO ()
onreset = Automation.method0 "onreset" []
-- --------------------------------------------------
-- 
-- interface IHTMLFormElement
-- 
-- --------------------------------------------------
data HTMLFormElement a = HTMLFormElement
                          
type IHTMLFormElement a = Automation.IDispatch (HTMLFormElement a)
iidHTMLFormElement :: Com.IID (IHTMLFormElement Automation.Interface)
iidHTMLFormElement =
  Com.mkIID "{3050f1f7-98b5-11cf-bb82-00aa00bdce0b}"
setAction :: Prelude.String -> Automation.IDispatch a -> Prelude.IO ()
setAction v =
  Automation.propertySet "action" [Automation.inString v]
getAction :: Automation.IDispatch a -> Prelude.IO (Prelude.String)
getAction = Automation.propertyGet "action" [] Automation.outString
setDir :: Prelude.String -> Automation.IDispatch a -> Prelude.IO ()
setDir v = Automation.propertySet "dir" [Automation.inString v]
getDir :: Automation.IDispatch a -> Prelude.IO (Prelude.String)
getDir = Automation.propertyGet "dir" [] Automation.outString
setEncoding :: Prelude.String -> Automation.IDispatch a -> Prelude.IO ()
setEncoding v =
  Automation.propertySet "encoding" [Automation.inString v]
getEncoding :: Automation.IDispatch a -> Prelude.IO (Prelude.String)
getEncoding =
  Automation.propertyGet "encoding" [] Automation.outString
setMethod :: Prelude.String -> Automation.IDispatch a -> Prelude.IO ()
setMethod v =
  Automation.propertySet "method" [Automation.inString v]
getMethod :: Automation.IDispatch a -> Prelude.IO (Prelude.String)
getMethod = Automation.propertyGet "method" [] Automation.outString
getElements :: Automation.IDispatch a -> Prelude.IO (Automation.IDispatch Automation.Interface)
getElements =
  Automation.propertyGet "elements" [] Automation.outIDispatch
setTarget :: Prelude.String -> Automation.IDispatch a -> Prelude.IO ()
setTarget v =
  Automation.propertySet "target" [Automation.inString v]
getTarget :: Automation.IDispatch a -> Prelude.IO (Prelude.String)
getTarget = Automation.propertyGet "target" [] Automation.outString
setName :: Prelude.String -> Automation.IDispatch a -> Prelude.IO ()
setName v = Automation.propertySet "name" [Automation.inString v]
getName :: Automation.IDispatch a -> Prelude.IO (Prelude.String)
getName = Automation.propertyGet "name" [] Automation.outString
setOnsubmit :: (Automation.Variant a0) => a0 -> Automation.IDispatch a -> Prelude.IO ()
setOnsubmit v =
  Automation.propertySet "onsubmit" [Automation.inVariant v]
getOnsubmit :: (Automation.Variant a0) => Automation.IDispatch a -> Prelude.IO (a0)
getOnsubmit =
  Automation.propertyGet "onsubmit" [] Automation.outVariant
setOnreset :: (Automation.Variant a0) => a0 -> Automation.IDispatch a -> Prelude.IO ()
setOnreset v =
  Automation.propertySet "onreset" [Automation.inVariant v]
getOnreset :: (Automation.Variant a0) => Automation.IDispatch a -> Prelude.IO (a0)
getOnreset =
  Automation.propertyGet "onreset" [] Automation.outVariant
submit :: Automation.IDispatch a -> Prelude.IO ()
submit = Automation.method0 "submit" []
reset :: Automation.IDispatch a -> Prelude.IO ()
reset = Automation.method0 "reset" []
setLength :: Prelude.Int -> Automation.IDispatch a -> Prelude.IO ()
setLength v = Automation.propertySet "length" [Automation.inInt v]
item1 :: (Automation.Variant a0, Automation.Variant a1) => a0 -> a1 -> Automation.IDispatch a -> Prelude.IO (Automation.IDispatch Automation.Interface)
item1 name index =
  Automation.function1 "item" [Automation.inVariant name, Automation.inVariant index] Automation.outIDispatch
tags :: (Automation.Variant a0) => a0 -> Automation.IDispatch a -> Prelude.IO (Automation.IDispatch Automation.Interface)
tags tagName =
  Automation.function1 "tags" [Automation.inVariant tagName] Automation.outIDispatch
-- --------------------------------------------------
-- 
-- dispinterface DispIHTMLFormElement
-- 
-- --------------------------------------------------

                           
type DispIHTMLFormElement a = Automation.IDispatch (HTMLFormElement a)
iidIHTMLFormElement :: Com.IID (DispIHTMLFormElement Automation.Interface)
iidIHTMLFormElement =
  Com.mkIID "{3050f510-98b5-11cf-bb82-00aa00bdce0b}"
-- --------------------------------------------------
-- 
-- coclass HTMLFormElement
-- 
-- --------------------------------------------------
clsidHTMLFormElement :: Com.CLSID
clsidHTMLFormElement =
  Com.mkCLSID "{3050f251-98b5-11cf-bb82-00aa00bdce0b}"
-- --------------------------------------------------
-- 
-- dispinterface HTMLControlElementEvents
-- 
-- --------------------------------------------------
data HTMLControlElementEvents a = HTMLControlElementEvents
                                   
type IHTMLControlElementEvents a = Automation.IDispatch (HTMLControlElementEvents a)
iidHTMLControlElementEvents :: Com.IID (IHTMLControlElementEvents Automation.Interface)
iidHTMLControlElementEvents =
  Com.mkIID "{9a4bbf53-4e46-101b-8bbd-00aa003e3b29}"
onfocus :: Automation.IDispatch a -> Prelude.IO ()
onfocus = Automation.method0 "onfocus" []
onblur :: Automation.IDispatch a -> Prelude.IO ()
onblur = Automation.method0 "onblur" []
onresize :: Automation.IDispatch a -> Prelude.IO ()
onresize = Automation.method0 "onresize" []
-- --------------------------------------------------
-- 
-- interface IHTMLControlElement
-- 
-- --------------------------------------------------
data HTMLControlElement a = HTMLControlElement
                             
type IHTMLControlElement a = Automation.IDispatch (HTMLControlElement a)
iidHTMLControlElement :: Com.IID (IHTMLControlElement Automation.Interface)
iidHTMLControlElement =
  Com.mkIID "{04598fc6-866c-11cf-ab7c-00aa00c08fcf}"
setTabIndex :: Prelude.Int -> Automation.IDispatch a -> Prelude.IO ()
setTabIndex v =
  Automation.propertySet "tabIndex" [Automation.inInt v]
getTabIndex :: Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getTabIndex =
  Automation.propertyGet "tabIndex" [] Automation.outInt
focus :: Automation.IDispatch a -> Prelude.IO ()
focus = Automation.method0 "focus" []
setAccessKey :: Prelude.String -> Automation.IDispatch a -> Prelude.IO ()
setAccessKey v =
  Automation.propertySet "accessKey" [Automation.inString v]
getAccessKey :: Automation.IDispatch a -> Prelude.IO (Prelude.String)
getAccessKey =
  Automation.propertyGet "accessKey" [] Automation.outString
setOnblur :: (Automation.Variant a0) => a0 -> Automation.IDispatch a -> Prelude.IO ()
setOnblur v =
  Automation.propertySet "onblur" [Automation.inVariant v]
getOnblur :: (Automation.Variant a0) => Automation.IDispatch a -> Prelude.IO (a0)
getOnblur =
  Automation.propertyGet "onblur" [] Automation.outVariant
setOnfocus :: (Automation.Variant a0) => a0 -> Automation.IDispatch a -> Prelude.IO ()
setOnfocus v =
  Automation.propertySet "onfocus" [Automation.inVariant v]
getOnfocus :: (Automation.Variant a0) => Automation.IDispatch a -> Prelude.IO (a0)
getOnfocus =
  Automation.propertyGet "onfocus" [] Automation.outVariant
setOnresize :: (Automation.Variant a0) => a0 -> Automation.IDispatch a -> Prelude.IO ()
setOnresize v =
  Automation.propertySet "onresize" [Automation.inVariant v]
getOnresize :: (Automation.Variant a0) => Automation.IDispatch a -> Prelude.IO (a0)
getOnresize =
  Automation.propertyGet "onresize" [] Automation.outVariant
blur :: Automation.IDispatch a -> Prelude.IO ()
blur = Automation.method0 "blur" []
addFilter :: Com.IUnknown a0 -> Automation.IDispatch a -> Prelude.IO ()
addFilter pUnk =
  Automation.method0 "addFilter" [Automation.inIUnknown pUnk]
removeFilter :: Com.IUnknown a0 -> Automation.IDispatch a -> Prelude.IO ()
removeFilter pUnk =
  Automation.method0 "removeFilter" [Automation.inIUnknown pUnk]
setFilter0 :: Com.IUnknown a0 -> Automation.IDispatch a -> Prelude.IO ()
setFilter0 v = Automation.method0 "filter" [Automation.inIUnknown v]
getFilter0 :: Automation.IDispatch a -> Prelude.IO (Com.IUnknown Automation.Interface)
getFilter0 =
  Automation.propertyGet "filter" [] Automation.outIUnknown
stopPainting :: Com.IUnknown a0 -> Automation.IDispatch a -> Prelude.IO ()
stopPainting pUnk =
  Automation.method0 "stopPainting" [Automation.inIUnknown pUnk]
startPainting :: Prelude.Int -> Automation.IDispatch a -> Prelude.IO ()
startPainting milliseconds =
  Automation.method0 "startPainting" [Automation.inInt milliseconds]
-- --------------------------------------------------
-- 
-- dispinterface DispIHTMLControlElement
-- 
-- --------------------------------------------------

                              
type DispIHTMLControlElement a = Automation.IDispatch (HTMLControlElement a)
iidIHTMLControlElement :: Com.IID (DispIHTMLControlElement Automation.Interface)
iidIHTMLControlElement =
  Com.mkIID "{3050f53f-98b5-11cf-bb82-00aa00bdce0b}"
-- --------------------------------------------------
-- 
-- interface IHTMLTextElement
-- 
-- --------------------------------------------------
data HTMLTextElement a = HTMLTextElement
                          
type IHTMLTextElement a = Automation.IDispatch (HTMLTextElement a)
iidHTMLTextElement :: Com.IID (IHTMLTextElement Automation.Interface)
iidHTMLTextElement =
  Com.mkIID "{3050f218-98b5-11cf-bb82-00aa00bdce0b}"
-- --------------------------------------------------
-- 
-- dispinterface DispIHTMLTextElement
-- 
-- --------------------------------------------------

                           
type DispIHTMLTextElement a = Automation.IDispatch (HTMLTextElement a)
iidIHTMLTextElement :: Com.IID (DispIHTMLTextElement Automation.Interface)
iidIHTMLTextElement =
  Com.mkIID "{3050f537-98b5-11cf-bb82-00aa00bdce0b}"
-- --------------------------------------------------
-- 
-- coclass HTMLTextElement
-- 
-- --------------------------------------------------
clsidHTMLTextElement :: Com.CLSID
clsidHTMLTextElement =
  Com.mkCLSID "{3050f26a-98b5-11cf-bb82-00aa00bdce0b}"
-- --------------------------------------------------
-- 
-- dispinterface HTMLTextContainerEvents
-- 
-- --------------------------------------------------
data HTMLTextContainerEvents a = HTMLTextContainerEvents
                                  
type IHTMLTextContainerEvents a = Automation.IDispatch (HTMLTextContainerEvents a)
iidHTMLTextContainerEvents :: Com.IID (IHTMLTextContainerEvents Automation.Interface)
iidHTMLTextContainerEvents =
  Com.mkIID "{1FF6AA72-5842-11cf-A707-00AA00C0098D}"
onchange :: Automation.IDispatch a -> Prelude.IO ()
onchange = Automation.method0 "onchange" []
onscroll :: Automation.IDispatch a -> Prelude.IO ()
onscroll = Automation.method0 "onscroll" []
onselect :: Automation.IDispatch a -> Prelude.IO ()
onselect = Automation.method0 "onselect" []
-- --------------------------------------------------
-- 
-- interface IHTMLTextContainer
-- 
-- --------------------------------------------------
data HTMLTextContainer a = HTMLTextContainer
                            
type IHTMLTextContainer a = Automation.IDispatch (HTMLTextContainer a)
iidHTMLTextContainer :: Com.IID (IHTMLTextContainer Automation.Interface)
iidHTMLTextContainer =
  Com.mkIID "{3050f230-98b5-11cf-bb82-00aa00bdce0b}"
createControlRange :: Automation.IDispatch a -> Prelude.IO (Automation.IDispatch Automation.Interface)
createControlRange =
  Automation.function1 "createControlRange" [] Automation.outIDispatch
getScrollHeight :: Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getScrollHeight =
  Automation.propertyGet "scrollHeight" [] Automation.outInt
getScrollWidth :: Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getScrollWidth =
  Automation.propertyGet "scrollWidth" [] Automation.outInt
setScrollTop :: Prelude.Int -> Automation.IDispatch a -> Prelude.IO ()
setScrollTop v =
  Automation.propertySet "scrollTop" [Automation.inInt v]
getScrollTop :: Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getScrollTop =
  Automation.propertyGet "scrollTop" [] Automation.outInt
setScrollLeft :: Prelude.Int -> Automation.IDispatch a -> Prelude.IO ()
setScrollLeft v =
  Automation.propertySet "scrollLeft" [Automation.inInt v]
getScrollLeft :: Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getScrollLeft =
  Automation.propertyGet "scrollLeft" [] Automation.outInt
setOnscroll :: (Automation.Variant a0) => a0 -> Automation.IDispatch a -> Prelude.IO ()
setOnscroll v =
  Automation.propertySet "onscroll" [Automation.inVariant v]
getOnscroll :: (Automation.Variant a0) => Automation.IDispatch a -> Prelude.IO (a0)
getOnscroll =
  Automation.propertyGet "onscroll" [] Automation.outVariant
getClientHeight :: Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getClientHeight =
  Automation.propertyGet "clientHeight" [] Automation.outInt
getClientWidth :: Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getClientWidth =
  Automation.propertyGet "clientWidth" [] Automation.outInt
-- --------------------------------------------------
-- 
-- dispinterface DispIHTMLTextContainer
-- 
-- --------------------------------------------------

                             
type DispIHTMLTextContainer a = Automation.IDispatch (HTMLTextContainer a)
iidIHTMLTextContainer :: Com.IID (DispIHTMLTextContainer Automation.Interface)
iidIHTMLTextContainer =
  Com.mkIID "{3050f53e-98b5-11cf-bb82-00aa00bdce0b}"
-- --------------------------------------------------
-- 
-- interface IHTMLControlRange
-- 
-- --------------------------------------------------
data HTMLControlRange a = HTMLControlRange
                           
type IHTMLControlRange a = Automation.IDispatch (HTMLControlRange a)
iidHTMLControlRange :: Com.IID (IHTMLControlRange Automation.Interface)
iidHTMLControlRange =
  Com.mkIID "{3050f29c-98b5-11cf-bb82-00aa00bdce0b}"
add :: IHTMLControlElement a0 -> IHTMLControlRange a -> Prelude.IO ()
add item = Automation.method0 "add" [Automation.inIDispatch item]
remove :: Prelude.Int -> Automation.IDispatch a -> Prelude.IO ()
remove index = Automation.method0 "remove" [Automation.inInt index]
item3 :: Prelude.Int -> IHTMLControlRange a -> Prelude.IO (IHTMLElement Automation.Interface)
item3 index =
  Automation.function1 "item" [Automation.inInt index] Automation.outIDispatch
commonParentElement :: IHTMLControlRange a -> Prelude.IO (IHTMLElement Automation.Interface)
commonParentElement =
  Automation.function1 "commonParentElement" [] Automation.outIDispatch
-- --------------------------------------------------
-- 
-- dispinterface HTMLImgEvents
-- 
-- --------------------------------------------------
data HTMLImgEvents a = HTMLImgEvents
                        
type IHTMLImgEvents a = Automation.IDispatch (HTMLImgEvents a)
iidHTMLImgEvents :: Com.IID (IHTMLImgEvents Automation.Interface)
iidHTMLImgEvents =
  Com.mkIID "{3050f25b-98b5-11cf-bb82-00aa00bdce0b}"
onabort :: Automation.IDispatch a -> Prelude.IO ()
onabort = Automation.method0 "onabort" []
-- --------------------------------------------------
-- 
-- dispinterface HTMLInputImageEvents
-- 
-- --------------------------------------------------
data HTMLInputImageEvents a = HTMLInputImageEvents
                               
type IHTMLInputImageEvents a = Automation.IDispatch (HTMLInputImageEvents a)
iidHTMLInputImageEvents :: Com.IID (IHTMLInputImageEvents Automation.Interface)
iidHTMLInputImageEvents =
  Com.mkIID "{3050f2c3-98b5-11cf-bb82-00aa00bdce0b}"
-- --------------------------------------------------
-- 
-- interface IHTMLImgElement
-- 
-- --------------------------------------------------
data HTMLImgElement a = HTMLImgElement
                         
type IHTMLImgElement a = Automation.IDispatch (HTMLImgElement a)
iidHTMLImgElement :: Com.IID (IHTMLImgElement Automation.Interface)
iidHTMLImgElement =
  Com.mkIID "{3050f240-98b5-11cf-bb82-00aa00bdce0b}"
setIsMap :: Prelude.Int -> Automation.IDispatch a -> Prelude.IO ()
setIsMap v = Automation.propertySet "isMap" [Automation.inInt v]
getIsMap :: Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getIsMap = Automation.propertyGet "isMap" [] Automation.outInt
setUseMap :: Prelude.String -> Automation.IDispatch a -> Prelude.IO ()
setUseMap v =
  Automation.propertySet "useMap" [Automation.inString v]
getUseMap :: Automation.IDispatch a -> Prelude.IO (Prelude.String)
getUseMap = Automation.propertyGet "useMap" [] Automation.outString
getMimeType :: Automation.IDispatch a -> Prelude.IO (Prelude.String)
getMimeType =
  Automation.propertyGet "mimeType" [] Automation.outString
getFileSize :: Automation.IDispatch a -> Prelude.IO (Prelude.String)
getFileSize =
  Automation.propertyGet "fileSize" [] Automation.outString
getFileCreatedDate :: Automation.IDispatch a -> Prelude.IO (Prelude.String)
getFileCreatedDate =
  Automation.propertyGet "fileCreatedDate" [] Automation.outString
getFileModifiedDate :: Automation.IDispatch a -> Prelude.IO (Prelude.String)
getFileModifiedDate =
  Automation.propertyGet "fileModifiedDate" [] Automation.outString
getFileUpdatedDate :: Automation.IDispatch a -> Prelude.IO (Prelude.String)
getFileUpdatedDate =
  Automation.propertyGet "fileUpdatedDate" [] Automation.outString
getProtocol :: Automation.IDispatch a -> Prelude.IO (Prelude.String)
getProtocol =
  Automation.propertyGet "protocol" [] Automation.outString
getNameProp :: Automation.IDispatch a -> Prelude.IO (Prelude.String)
getNameProp =
  Automation.propertyGet "nameProp" [] Automation.outString
setBorder0 :: (Automation.Variant a0) => a0 -> Automation.IDispatch a -> Prelude.IO ()
setBorder0 v =
  Automation.propertySet "border" [Automation.inVariant v]
getBorder0 :: (Automation.Variant a0) => Automation.IDispatch a -> Prelude.IO (a0)
getBorder0 =
  Automation.propertyGet "border" [] Automation.outVariant
setVspace :: Prelude.Int -> Automation.IDispatch a -> Prelude.IO ()
setVspace v = Automation.propertySet "vspace" [Automation.inInt v]
getVspace :: Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getVspace = Automation.propertyGet "vspace" [] Automation.outInt
setHspace :: Prelude.Int -> Automation.IDispatch a -> Prelude.IO ()
setHspace v = Automation.propertySet "hspace" [Automation.inInt v]
getHspace :: Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getHspace = Automation.propertyGet "hspace" [] Automation.outInt
setAlt :: Prelude.String -> Automation.IDispatch a -> Prelude.IO ()
setAlt v = Automation.propertySet "alt" [Automation.inString v]
getAlt :: Automation.IDispatch a -> Prelude.IO (Prelude.String)
getAlt = Automation.propertyGet "alt" [] Automation.outString
setSrc :: Prelude.String -> Automation.IDispatch a -> Prelude.IO ()
setSrc v = Automation.propertySet "src" [Automation.inString v]
getSrc :: Automation.IDispatch a -> Prelude.IO (Prelude.String)
getSrc = Automation.propertyGet "src" [] Automation.outString
setLowsrc :: Prelude.String -> Automation.IDispatch a -> Prelude.IO ()
setLowsrc v =
  Automation.propertySet "lowsrc" [Automation.inString v]
getLowsrc :: Automation.IDispatch a -> Prelude.IO (Prelude.String)
getLowsrc = Automation.propertyGet "lowsrc" [] Automation.outString
setVrml :: Prelude.String -> Automation.IDispatch a -> Prelude.IO ()
setVrml v = Automation.propertySet "vrml" [Automation.inString v]
getVrml :: Automation.IDispatch a -> Prelude.IO (Prelude.String)
getVrml = Automation.propertyGet "vrml" [] Automation.outString
setDynsrc :: Prelude.String -> Automation.IDispatch a -> Prelude.IO ()
setDynsrc v =
  Automation.propertySet "dynsrc" [Automation.inString v]
getDynsrc :: Automation.IDispatch a -> Prelude.IO (Prelude.String)
getDynsrc = Automation.propertyGet "dynsrc" [] Automation.outString
getComplete :: Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getComplete =
  Automation.propertyGet "complete" [] Automation.outInt
setLoop :: (Automation.Variant a0) => a0 -> Automation.IDispatch a -> Prelude.IO ()
setLoop v = Automation.propertySet "loop" [Automation.inVariant v]
getLoop :: (Automation.Variant a0) => Automation.IDispatch a -> Prelude.IO (a0)
getLoop = Automation.propertyGet "loop" [] Automation.outVariant
setAlign :: Prelude.String -> Automation.IDispatch a -> Prelude.IO ()
setAlign v = Automation.propertySet "align" [Automation.inString v]
getAlign :: Automation.IDispatch a -> Prelude.IO (Prelude.String)
getAlign = Automation.propertyGet "align" [] Automation.outString
setOnabort :: (Automation.Variant a0) => a0 -> Automation.IDispatch a -> Prelude.IO ()
setOnabort v =
  Automation.propertySet "onabort" [Automation.inVariant v]
getOnabort :: (Automation.Variant a0) => Automation.IDispatch a -> Prelude.IO (a0)
getOnabort =
  Automation.propertyGet "onabort" [] Automation.outVariant
setWidth0 :: Prelude.Int -> Automation.IDispatch a -> Prelude.IO ()
setWidth0 v = Automation.propertySet "width" [Automation.inInt v]
getWidth0 :: Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getWidth0 = Automation.propertyGet "width" [] Automation.outInt
setHeight0 :: Prelude.Int -> Automation.IDispatch a -> Prelude.IO ()
setHeight0 v = Automation.propertySet "height" [Automation.inInt v]
getHeight0 :: Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getHeight0 = Automation.propertyGet "height" [] Automation.outInt
setStart :: Prelude.String -> Automation.IDispatch a -> Prelude.IO ()
setStart v = Automation.propertySet "start" [Automation.inString v]
getStart :: Automation.IDispatch a -> Prelude.IO (Prelude.String)
getStart = Automation.propertyGet "start" [] Automation.outString
-- --------------------------------------------------
-- 
-- interface IHTMLInputImage
-- 
-- --------------------------------------------------
data HTMLInputImage a = HTMLInputImage
                         
type IHTMLInputImage a = Automation.IDispatch (HTMLInputImage a)
iidHTMLInputImage :: Com.IID (IHTMLInputImage Automation.Interface)
iidHTMLInputImage =
  Com.mkIID "{3050f2c2-98b5-11cf-bb82-00aa00bdce0b}"
-- --------------------------------------------------
-- 
-- interface IHTMLImageElementFactory
-- 
-- --------------------------------------------------
data HTMLImageElementFactory a = HTMLImageElementFactory
                                  
type IHTMLImageElementFactory a = Automation.IDispatch (HTMLImageElementFactory a)
iidHTMLImageElementFactory :: Com.IID (IHTMLImageElementFactory Automation.Interface)
iidHTMLImageElementFactory =
  Com.mkIID "{3050f38e-98b5-11cf-bb82-00aa00bdce0b}"
create :: (Automation.Variant a0, Automation.Variant a1) => a0 -> a1 -> IHTMLImageElementFactory a -> Prelude.IO (IHTMLImgElement Automation.Interface)
create width height =
  Automation.function1 "create" [Automation.inVariant width, Automation.inVariant height] Automation.outIDispatch
-- --------------------------------------------------
-- 
-- dispinterface DispIHTMLImgElement
-- 
-- --------------------------------------------------

                          
type DispIHTMLImgElement a = Automation.IDispatch (HTMLImgElement a)
iidIHTMLImgElement :: Com.IID (DispIHTMLImgElement Automation.Interface)
iidIHTMLImgElement =
  Com.mkIID "{3050f51c-98b5-11cf-bb82-00aa00bdce0b}"
-- --------------------------------------------------
-- 
-- coclass HTMLImg
-- 
-- --------------------------------------------------
clsidHTMLImg :: Com.CLSID
clsidHTMLImg = Com.mkCLSID "{3050f241-98b5-11cf-bb82-00aa00bdce0b}"
-- --------------------------------------------------
-- 
-- dispinterface DispIHTMLInputImage
-- 
-- --------------------------------------------------

                          
type DispIHTMLInputImage a = Automation.IDispatch (HTMLInputImage a)
iidIHTMLInputImage :: Com.IID (DispIHTMLInputImage Automation.Interface)
iidIHTMLInputImage =
  Com.mkIID "{3050f51d-98b5-11cf-bb82-00aa00bdce0b}"
-- --------------------------------------------------
-- 
-- coclass HTMLInputImage
-- 
-- --------------------------------------------------
clsidHTMLInputImage :: Com.CLSID
clsidHTMLInputImage =
  Com.mkCLSID "{3050f2c4-98b5-11cf-bb82-00aa00bdce0b}"
-- --------------------------------------------------
-- 
-- coclass HTMLImageElementFactory
-- 
-- --------------------------------------------------
clsidHTMLImageElementFactory :: Com.CLSID
clsidHTMLImageElementFactory =
  Com.mkCLSID "{3050f38f-98b5-11cf-bb82-00aa00bdce0b}"
-- --------------------------------------------------
-- 
-- interface IHTMLBodyElement
-- 
-- --------------------------------------------------
data HTMLBodyElement a = HTMLBodyElement
                          
type IHTMLBodyElement a = Automation.IDispatch (HTMLBodyElement a)
iidHTMLBodyElement :: Com.IID (IHTMLBodyElement Automation.Interface)
iidHTMLBodyElement =
  Com.mkIID "{3050f1d8-98b5-11cf-bb82-00aa00bdce0b}"
setBgProperties :: Prelude.String -> Automation.IDispatch a -> Prelude.IO ()
setBgProperties v =
  Automation.propertySet "bgProperties" [Automation.inString v]
getBgProperties :: Automation.IDispatch a -> Prelude.IO (Prelude.String)
getBgProperties =
  Automation.propertyGet "bgProperties" [] Automation.outString
setLeftMargin :: (Automation.Variant a0) => a0 -> Automation.IDispatch a -> Prelude.IO ()
setLeftMargin v =
  Automation.propertySet "leftMargin" [Automation.inVariant v]
getLeftMargin :: (Automation.Variant a0) => Automation.IDispatch a -> Prelude.IO (a0)
getLeftMargin =
  Automation.propertyGet "leftMargin" [] Automation.outVariant
setTopMargin :: (Automation.Variant a0) => a0 -> Automation.IDispatch a -> Prelude.IO ()
setTopMargin v =
  Automation.propertySet "topMargin" [Automation.inVariant v]
getTopMargin :: (Automation.Variant a0) => Automation.IDispatch a -> Prelude.IO (a0)
getTopMargin =
  Automation.propertyGet "topMargin" [] Automation.outVariant
setRightMargin :: (Automation.Variant a0) => a0 -> Automation.IDispatch a -> Prelude.IO ()
setRightMargin v =
  Automation.propertySet "rightMargin" [Automation.inVariant v]
getRightMargin :: (Automation.Variant a0) => Automation.IDispatch a -> Prelude.IO (a0)
getRightMargin =
  Automation.propertyGet "rightMargin" [] Automation.outVariant
setBottomMargin :: (Automation.Variant a0) => a0 -> Automation.IDispatch a -> Prelude.IO ()
setBottomMargin v =
  Automation.propertySet "bottomMargin" [Automation.inVariant v]
getBottomMargin :: (Automation.Variant a0) => Automation.IDispatch a -> Prelude.IO (a0)
getBottomMargin =
  Automation.propertyGet "bottomMargin" [] Automation.outVariant
setNoWrap :: Prelude.Int -> Automation.IDispatch a -> Prelude.IO ()
setNoWrap v = Automation.propertySet "noWrap" [Automation.inInt v]
getNoWrap :: Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getNoWrap = Automation.propertyGet "noWrap" [] Automation.outInt
setBgColor :: (Automation.Variant a0) => a0 -> Automation.IDispatch a -> Prelude.IO ()
setBgColor v =
  Automation.propertySet "bgColor" [Automation.inVariant v]
getBgColor :: (Automation.Variant a0) => Automation.IDispatch a -> Prelude.IO (a0)
getBgColor =
  Automation.propertyGet "bgColor" [] Automation.outVariant
setText0 :: (Automation.Variant a0) => a0 -> Automation.IDispatch a -> Prelude.IO ()
setText0 v = Automation.propertySet "text" [Automation.inVariant v]
getText0 :: (Automation.Variant a0) => Automation.IDispatch a -> Prelude.IO (a0)
getText0 = Automation.propertyGet "text" [] Automation.outVariant
setLink :: (Automation.Variant a0) => a0 -> Automation.IDispatch a -> Prelude.IO ()
setLink v = Automation.propertySet "link" [Automation.inVariant v]
getLink :: (Automation.Variant a0) => Automation.IDispatch a -> Prelude.IO (a0)
getLink = Automation.propertyGet "link" [] Automation.outVariant
setVLink :: (Automation.Variant a0) => a0 -> Automation.IDispatch a -> Prelude.IO ()
setVLink v =
  Automation.propertySet "vLink" [Automation.inVariant v]
getVLink :: (Automation.Variant a0) => Automation.IDispatch a -> Prelude.IO (a0)
getVLink = Automation.propertyGet "vLink" [] Automation.outVariant
setALink :: (Automation.Variant a0) => a0 -> Automation.IDispatch a -> Prelude.IO ()
setALink v =
  Automation.propertySet "aLink" [Automation.inVariant v]
getALink :: (Automation.Variant a0) => Automation.IDispatch a -> Prelude.IO (a0)
getALink = Automation.propertyGet "aLink" [] Automation.outVariant
setOnunload :: (Automation.Variant a0) => a0 -> Automation.IDispatch a -> Prelude.IO ()
setOnunload v =
  Automation.propertySet "onunload" [Automation.inVariant v]
getOnunload :: (Automation.Variant a0) => Automation.IDispatch a -> Prelude.IO (a0)
getOnunload =
  Automation.propertyGet "onunload" [] Automation.outVariant
setScroll :: Prelude.String -> Automation.IDispatch a -> Prelude.IO ()
setScroll v =
  Automation.propertySet "scroll" [Automation.inString v]
getScroll :: Automation.IDispatch a -> Prelude.IO (Prelude.String)
getScroll = Automation.propertyGet "scroll" [] Automation.outString
setOnselect :: (Automation.Variant a0) => a0 -> Automation.IDispatch a -> Prelude.IO ()
setOnselect v =
  Automation.propertySet "onselect" [Automation.inVariant v]
getOnselect :: (Automation.Variant a0) => Automation.IDispatch a -> Prelude.IO (a0)
getOnselect =
  Automation.propertyGet "onselect" [] Automation.outVariant
setOnbeforeunload :: (Automation.Variant a0) => a0 -> Automation.IDispatch a -> Prelude.IO ()
setOnbeforeunload v =
  Automation.propertySet "onbeforeunload" [Automation.inVariant v]
getOnbeforeunload :: (Automation.Variant a0) => Automation.IDispatch a -> Prelude.IO (a0)
getOnbeforeunload =
  Automation.propertyGet "onbeforeunload" [] Automation.outVariant
createTextRange :: Automation.IDispatch a -> Prelude.IO (IHTMLTxtRange Automation.Interface)
createTextRange =
  Automation.function1 "createTextRange" [] Automation.outIDispatch
-- --------------------------------------------------
-- 
-- dispinterface DispIHTMLBodyElement
-- 
-- --------------------------------------------------

                           
type DispIHTMLBodyElement a = Automation.IDispatch (HTMLBodyElement a)
iidIHTMLBodyElement :: Com.IID (DispIHTMLBodyElement Automation.Interface)
iidIHTMLBodyElement =
  Com.mkIID "{3050f507-98b5-11cf-bb82-00aa00bdce0b}"
-- --------------------------------------------------
-- 
-- coclass HTMLBody
-- 
-- --------------------------------------------------
clsidHTMLBody :: Com.CLSID
clsidHTMLBody =
  Com.mkCLSID "{3050f24a-98b5-11cf-bb82-00aa00bdce0b}"
-- --------------------------------------------------
-- 
-- interface IHTMLFontElement
-- 
-- --------------------------------------------------
data HTMLFontElement a = HTMLFontElement
                          
type IHTMLFontElement a = Automation.IDispatch (HTMLFontElement a)
iidHTMLFontElement :: Com.IID (IHTMLFontElement Automation.Interface)
iidHTMLFontElement =
  Com.mkIID "{3050f1d9-98b5-11cf-bb82-00aa00bdce0b}"
setFace :: Prelude.String -> Automation.IDispatch a -> Prelude.IO ()
setFace v = Automation.propertySet "face" [Automation.inString v]
getFace :: Automation.IDispatch a -> Prelude.IO (Prelude.String)
getFace = Automation.propertyGet "face" [] Automation.outString
setSize :: (Automation.Variant a0) => a0 -> Automation.IDispatch a -> Prelude.IO ()
setSize v = Automation.propertySet "size" [Automation.inVariant v]
getSize :: (Automation.Variant a0) => Automation.IDispatch a -> Prelude.IO (a0)
getSize = Automation.propertyGet "size" [] Automation.outVariant
-- --------------------------------------------------
-- 
-- dispinterface DispIHTMLFontElement
-- 
-- --------------------------------------------------

                           
type DispIHTMLFontElement a = Automation.IDispatch (HTMLFontElement a)
iidIHTMLFontElement :: Com.IID (DispIHTMLFontElement Automation.Interface)
iidIHTMLFontElement =
  Com.mkIID "{3050f512-98b5-11cf-bb82-00aa00bdce0b}"
-- --------------------------------------------------
-- 
-- coclass HTMLFontElement
-- 
-- --------------------------------------------------
clsidHTMLFontElement :: Com.CLSID
clsidHTMLFontElement =
  Com.mkCLSID "{3050f27b-98b5-11cf-bb82-00aa00bdce0b}"
-- --------------------------------------------------
-- 
-- dispinterface HTMLAnchorEvents
-- 
-- --------------------------------------------------
data HTMLAnchorEvents a = HTMLAnchorEvents
                           
type IHTMLAnchorEvents a = Automation.IDispatch (HTMLAnchorEvents a)
iidHTMLAnchorEvents :: Com.IID (IHTMLAnchorEvents Automation.Interface)
iidHTMLAnchorEvents =
  Com.mkIID "{3050f29d-98b5-11cf-bb82-00aa00bdce0b}"
-- --------------------------------------------------
-- 
-- interface IHTMLAnchorElement
-- 
-- --------------------------------------------------
data HTMLAnchorElement a = HTMLAnchorElement
                            
type IHTMLAnchorElement a = Automation.IDispatch (HTMLAnchorElement a)
iidHTMLAnchorElement :: Com.IID (IHTMLAnchorElement Automation.Interface)
iidHTMLAnchorElement =
  Com.mkIID "{3050f1da-98b5-11cf-bb82-00aa00bdce0b}"
setUrn :: Prelude.String -> Automation.IDispatch a -> Prelude.IO ()
setUrn v = Automation.propertySet "urn" [Automation.inString v]
getUrn :: Automation.IDispatch a -> Prelude.IO (Prelude.String)
getUrn = Automation.propertyGet "urn" [] Automation.outString
setMethods :: Prelude.String -> Automation.IDispatch a -> Prelude.IO ()
setMethods v =
  Automation.propertySet "Methods" [Automation.inString v]
getMethods :: Automation.IDispatch a -> Prelude.IO (Prelude.String)
getMethods =
  Automation.propertyGet "Methods" [] Automation.outString
setHost :: Prelude.String -> Automation.IDispatch a -> Prelude.IO ()
setHost v = Automation.propertySet "host" [Automation.inString v]
getHost :: Automation.IDispatch a -> Prelude.IO (Prelude.String)
getHost = Automation.propertyGet "host" [] Automation.outString
setHostname :: Prelude.String -> Automation.IDispatch a -> Prelude.IO ()
setHostname v =
  Automation.propertySet "hostname" [Automation.inString v]
getHostname :: Automation.IDispatch a -> Prelude.IO (Prelude.String)
getHostname =
  Automation.propertyGet "hostname" [] Automation.outString
setPathname :: Prelude.String -> Automation.IDispatch a -> Prelude.IO ()
setPathname v =
  Automation.propertySet "pathname" [Automation.inString v]
getPathname :: Automation.IDispatch a -> Prelude.IO (Prelude.String)
getPathname =
  Automation.propertyGet "pathname" [] Automation.outString
setPort :: Prelude.String -> Automation.IDispatch a -> Prelude.IO ()
setPort v = Automation.propertySet "port" [Automation.inString v]
getPort :: Automation.IDispatch a -> Prelude.IO (Prelude.String)
getPort = Automation.propertyGet "port" [] Automation.outString
setProtocol :: Prelude.String -> Automation.IDispatch a -> Prelude.IO ()
setProtocol v =
  Automation.propertySet "protocol" [Automation.inString v]
setSearch :: Prelude.String -> Automation.IDispatch a -> Prelude.IO ()
setSearch v =
  Automation.propertySet "search" [Automation.inString v]
getSearch :: Automation.IDispatch a -> Prelude.IO (Prelude.String)
getSearch = Automation.propertyGet "search" [] Automation.outString
setHash :: Prelude.String -> Automation.IDispatch a -> Prelude.IO ()
setHash v = Automation.propertySet "hash" [Automation.inString v]
getHash :: Automation.IDispatch a -> Prelude.IO (Prelude.String)
getHash = Automation.propertyGet "hash" [] Automation.outString
getProtocolLong :: Automation.IDispatch a -> Prelude.IO (Prelude.String)
getProtocolLong =
  Automation.propertyGet "protocolLong" [] Automation.outString
-- --------------------------------------------------
-- 
-- dispinterface DispIHTMLAnchorElement
-- 
-- --------------------------------------------------

                             
type DispIHTMLAnchorElement a = Automation.IDispatch (HTMLAnchorElement a)
iidIHTMLAnchorElement :: Com.IID (DispIHTMLAnchorElement Automation.Interface)
iidIHTMLAnchorElement =
  Com.mkIID "{3050f502-98b5-11cf-bb82-00aa00bdce0b}"
-- --------------------------------------------------
-- 
-- coclass HTMLAnchorElement
-- 
-- --------------------------------------------------
clsidHTMLAnchorElement :: Com.CLSID
clsidHTMLAnchorElement =
  Com.mkCLSID "{3050f248-98b5-11cf-bb82-00aa00bdce0b}"
-- --------------------------------------------------
-- 
-- dispinterface HTMLLabelEvents
-- 
-- --------------------------------------------------
data HTMLLabelEvents a = HTMLLabelEvents
                          
type IHTMLLabelEvents a = Automation.IDispatch (HTMLLabelEvents a)
iidHTMLLabelEvents :: Com.IID (IHTMLLabelEvents Automation.Interface)
iidHTMLLabelEvents =
  Com.mkIID "{3050f329-98b5-11cf-bb82-00aa00bdce0b}"
-- --------------------------------------------------
-- 
-- interface IHTMLLabelElement
-- 
-- --------------------------------------------------
data HTMLLabelElement a = HTMLLabelElement
                           
type IHTMLLabelElement a = Automation.IDispatch (HTMLLabelElement a)
iidHTMLLabelElement :: Com.IID (IHTMLLabelElement Automation.Interface)
iidHTMLLabelElement =
  Com.mkIID "{3050f32a-98b5-11cf-bb82-00aa00bdce0b}"
setHtmlFor :: Prelude.String -> Automation.IDispatch a -> Prelude.IO ()
setHtmlFor v =
  Automation.propertySet "htmlFor" [Automation.inString v]
getHtmlFor :: Automation.IDispatch a -> Prelude.IO (Prelude.String)
getHtmlFor =
  Automation.propertyGet "htmlFor" [] Automation.outString
-- --------------------------------------------------
-- 
-- dispinterface DispIHTMLLabelElement
-- 
-- --------------------------------------------------

                            
type DispIHTMLLabelElement a = Automation.IDispatch (HTMLLabelElement a)
iidIHTMLLabelElement :: Com.IID (DispIHTMLLabelElement Automation.Interface)
iidIHTMLLabelElement =
  Com.mkIID "{3050f522-98b5-11cf-bb82-00aa00bdce0b}"
-- --------------------------------------------------
-- 
-- coclass HTMLLabelElement
-- 
-- --------------------------------------------------
clsidHTMLLabelElement :: Com.CLSID
clsidHTMLLabelElement =
  Com.mkCLSID "{3050f32b-98b5-11cf-bb82-00aa00bdce0b}"
-- --------------------------------------------------
-- 
-- interface IHTMLListElement
-- 
-- --------------------------------------------------
data HTMLListElement a = HTMLListElement
                          
type IHTMLListElement a = Automation.IDispatch (HTMLListElement a)
iidHTMLListElement :: Com.IID (IHTMLListElement Automation.Interface)
iidHTMLListElement =
  Com.mkIID "{3050f20e-98b5-11cf-bb82-00aa00bdce0b}"
-- --------------------------------------------------
-- 
-- dispinterface DispIHTMLListElement
-- 
-- --------------------------------------------------

                           
type DispIHTMLListElement a = Automation.IDispatch (HTMLListElement a)
iidIHTMLListElement :: Com.IID (DispIHTMLListElement Automation.Interface)
iidIHTMLListElement =
  Com.mkIID "{3050f525-98b5-11cf-bb82-00aa00bdce0b}"
-- --------------------------------------------------
-- 
-- coclass HTMLListElement
-- 
-- --------------------------------------------------
clsidHTMLListElement :: Com.CLSID
clsidHTMLListElement =
  Com.mkCLSID "{3050f272-98b5-11cf-bb82-00aa00bdce0b}"
-- --------------------------------------------------
-- 
-- interface IHTMLUListElement
-- 
-- --------------------------------------------------
data HTMLUListElement a = HTMLUListElement
                           
type IHTMLUListElement a = Automation.IDispatch (HTMLUListElement a)
iidHTMLUListElement :: Com.IID (IHTMLUListElement Automation.Interface)
iidHTMLUListElement =
  Com.mkIID "{3050f1dd-98b5-11cf-bb82-00aa00bdce0b}"
setCompact :: Prelude.Int -> Automation.IDispatch a -> Prelude.IO ()
setCompact v =
  Automation.propertySet "compact" [Automation.inInt v]
getCompact :: Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getCompact = Automation.propertyGet "compact" [] Automation.outInt
-- --------------------------------------------------
-- 
-- dispinterface DispIHTMLUListElement
-- 
-- --------------------------------------------------

                            
type DispIHTMLUListElement a = Automation.IDispatch (HTMLUListElement a)
iidIHTMLUListElement :: Com.IID (DispIHTMLUListElement Automation.Interface)
iidIHTMLUListElement =
  Com.mkIID "{3050f538-98b5-11cf-bb82-00aa00bdce0b}"
-- --------------------------------------------------
-- 
-- coclass HTMLUListElement
-- 
-- --------------------------------------------------
clsidHTMLUListElement :: Com.CLSID
clsidHTMLUListElement =
  Com.mkCLSID "{3050f269-98b5-11cf-bb82-00aa00bdce0b}"
-- --------------------------------------------------
-- 
-- interface IHTMLOListElement
-- 
-- --------------------------------------------------
data HTMLOListElement a = HTMLOListElement
                           
type IHTMLOListElement a = Automation.IDispatch (HTMLOListElement a)
iidHTMLOListElement :: Com.IID (IHTMLOListElement Automation.Interface)
iidHTMLOListElement =
  Com.mkIID "{3050f1de-98b5-11cf-bb82-00aa00bdce0b}"
setStart3 :: Prelude.Int -> Automation.IDispatch a -> Prelude.IO ()
setStart3 v = Automation.propertySet "start" [Automation.inInt v]
getStart3 :: Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getStart3 = Automation.propertyGet "start" [] Automation.outInt
-- --------------------------------------------------
-- 
-- dispinterface DispIHTMLOListElement
-- 
-- --------------------------------------------------

                            
type DispIHTMLOListElement a = Automation.IDispatch (HTMLOListElement a)
iidIHTMLOListElement :: Com.IID (DispIHTMLOListElement Automation.Interface)
iidIHTMLOListElement =
  Com.mkIID "{3050f52a-98b5-11cf-bb82-00aa00bdce0b}"
-- --------------------------------------------------
-- 
-- coclass HTMLOListElement
-- 
-- --------------------------------------------------
clsidHTMLOListElement :: Com.CLSID
clsidHTMLOListElement =
  Com.mkCLSID "{3050f270-98b5-11cf-bb82-00aa00bdce0b}"
-- --------------------------------------------------
-- 
-- interface IHTMLLIElement
-- 
-- --------------------------------------------------
data HTMLLIElement a = HTMLLIElement
                        
type IHTMLLIElement a = Automation.IDispatch (HTMLLIElement a)
iidHTMLLIElement :: Com.IID (IHTMLLIElement Automation.Interface)
iidHTMLLIElement =
  Com.mkIID "{3050f1e0-98b5-11cf-bb82-00aa00bdce0b}"
setValue :: Automation.Variant a0 => a0 -> Automation.IDispatch a -> Prelude.IO ()
setValue v = Automation.propertySet "value" [Automation.inVariant v]
getValue :: (Automation.Variant b) => Automation.IDispatch a -> Prelude.IO (b)
getValue = Automation.propertyGet "value" [] Automation.outVariant
-- --------------------------------------------------
-- 
-- dispinterface DispIHTMLLIElement
-- 
-- --------------------------------------------------

                         
type DispIHTMLLIElement a = Automation.IDispatch (HTMLLIElement a)
iidIHTMLLIElement :: Com.IID (DispIHTMLLIElement Automation.Interface)
iidIHTMLLIElement =
  Com.mkIID "{3050f523-98b5-11cf-bb82-00aa00bdce0b}"
-- --------------------------------------------------
-- 
-- coclass HTMLLIElement
-- 
-- --------------------------------------------------
clsidHTMLLIElement :: Com.CLSID
clsidHTMLLIElement =
  Com.mkCLSID "{3050f273-98b5-11cf-bb82-00aa00bdce0b}"
-- --------------------------------------------------
-- 
-- interface IHTMLBlockElement
-- 
-- --------------------------------------------------
data HTMLBlockElement a = HTMLBlockElement
                           
type IHTMLBlockElement a = Automation.IDispatch (HTMLBlockElement a)
iidHTMLBlockElement :: Com.IID (IHTMLBlockElement Automation.Interface)
iidHTMLBlockElement =
  Com.mkIID "{3050f208-98b5-11cf-bb82-00aa00bdce0b}"
-- --------------------------------------------------
-- 
-- dispinterface DispIHTMLBlockElement
-- 
-- --------------------------------------------------

                            
type DispIHTMLBlockElement a = Automation.IDispatch (HTMLBlockElement a)
iidIHTMLBlockElement :: Com.IID (DispIHTMLBlockElement Automation.Interface)
iidIHTMLBlockElement =
  Com.mkIID "{3050f506-98b5-11cf-bb82-00aa00bdce0b}"
-- --------------------------------------------------
-- 
-- coclass HTMLBlockElement
-- 
-- --------------------------------------------------
clsidHTMLBlockElement :: Com.CLSID
clsidHTMLBlockElement =
  Com.mkCLSID "{3050f281-98b5-11cf-bb82-00aa00bdce0b}"
-- --------------------------------------------------
-- 
-- interface IHTMLDivElement
-- 
-- --------------------------------------------------
data HTMLDivElement a = HTMLDivElement
                         
type IHTMLDivElement a = Automation.IDispatch (HTMLDivElement a)
iidHTMLDivElement :: Com.IID (IHTMLDivElement Automation.Interface)
iidHTMLDivElement =
  Com.mkIID "{3050f200-98b5-11cf-bb82-00aa00bdce0b}"
-- --------------------------------------------------
-- 
-- dispinterface DispIHTMLDivElement
-- 
-- --------------------------------------------------

                          
type DispIHTMLDivElement a = Automation.IDispatch (HTMLDivElement a)
iidIHTMLDivElement :: Com.IID (DispIHTMLDivElement Automation.Interface)
iidIHTMLDivElement =
  Com.mkIID "{3050f50c-98b5-11cf-bb82-00aa00bdce0b}"
-- --------------------------------------------------
-- 
-- coclass HTMLDivElement
-- 
-- --------------------------------------------------
clsidHTMLDivElement :: Com.CLSID
clsidHTMLDivElement =
  Com.mkCLSID "{3050f27e-98b5-11cf-bb82-00aa00bdce0b}"
-- --------------------------------------------------
-- 
-- interface IHTMLDDElement
-- 
-- --------------------------------------------------
data HTMLDDElement a = HTMLDDElement
                        
type IHTMLDDElement a = Automation.IDispatch (HTMLDDElement a)
iidHTMLDDElement :: Com.IID (IHTMLDDElement Automation.Interface)
iidHTMLDDElement =
  Com.mkIID "{3050f1f2-98b5-11cf-bb82-00aa00bdce0b}"
-- --------------------------------------------------
-- 
-- dispinterface DispIHTMLDDElement
-- 
-- --------------------------------------------------

                         
type DispIHTMLDDElement a = Automation.IDispatch (HTMLDDElement a)
iidIHTMLDDElement :: Com.IID (DispIHTMLDDElement Automation.Interface)
iidIHTMLDDElement =
  Com.mkIID "{3050f50b-98b5-11cf-bb82-00aa00bdce0b}"
-- --------------------------------------------------
-- 
-- coclass HTMLDDElement
-- 
-- --------------------------------------------------
clsidHTMLDDElement :: Com.CLSID
clsidHTMLDDElement =
  Com.mkCLSID "{3050f27f-98b5-11cf-bb82-00aa00bdce0b}"
-- --------------------------------------------------
-- 
-- interface IHTMLDTElement
-- 
-- --------------------------------------------------
data HTMLDTElement a = HTMLDTElement
                        
type IHTMLDTElement a = Automation.IDispatch (HTMLDTElement a)
iidHTMLDTElement :: Com.IID (IHTMLDTElement Automation.Interface)
iidHTMLDTElement =
  Com.mkIID "{3050f1f3-98b5-11cf-bb82-00aa00bdce0b}"
-- --------------------------------------------------
-- 
-- dispinterface DispIHTMLDTElement
-- 
-- --------------------------------------------------

                         
type DispIHTMLDTElement a = Automation.IDispatch (HTMLDTElement a)
iidIHTMLDTElement :: Com.IID (DispIHTMLDTElement Automation.Interface)
iidIHTMLDTElement =
  Com.mkIID "{3050f50d-98b5-11cf-bb82-00aa00bdce0b}"
-- --------------------------------------------------
-- 
-- coclass HTMLDTElement
-- 
-- --------------------------------------------------
clsidHTMLDTElement :: Com.CLSID
clsidHTMLDTElement =
  Com.mkCLSID "{3050f27c-98b5-11cf-bb82-00aa00bdce0b}"
-- --------------------------------------------------
-- 
-- interface IHTMLBRElement
-- 
-- --------------------------------------------------
data HTMLBRElement a = HTMLBRElement
                        
type IHTMLBRElement a = Automation.IDispatch (HTMLBRElement a)
iidHTMLBRElement :: Com.IID (IHTMLBRElement Automation.Interface)
iidHTMLBRElement =
  Com.mkIID "{3050f1f0-98b5-11cf-bb82-00aa00bdce0b}"
-- --------------------------------------------------
-- 
-- dispinterface DispIHTMLBRElement
-- 
-- --------------------------------------------------

                         
type DispIHTMLBRElement a = Automation.IDispatch (HTMLBRElement a)
iidIHTMLBRElement :: Com.IID (DispIHTMLBRElement Automation.Interface)
iidIHTMLBRElement =
  Com.mkIID "{3050f53a-98b5-11cf-bb82-00aa00bdce0b}"
-- --------------------------------------------------
-- 
-- coclass HTMLBRElement
-- 
-- --------------------------------------------------
clsidHTMLBRElement :: Com.CLSID
clsidHTMLBRElement =
  Com.mkCLSID "{3050f280-98b5-11cf-bb82-00aa00bdce0b}"
-- --------------------------------------------------
-- 
-- interface IHTMLDListElement
-- 
-- --------------------------------------------------
data HTMLDListElement a = HTMLDListElement
                           
type IHTMLDListElement a = Automation.IDispatch (HTMLDListElement a)
iidHTMLDListElement :: Com.IID (IHTMLDListElement Automation.Interface)
iidHTMLDListElement =
  Com.mkIID "{3050f1f1-98b5-11cf-bb82-00aa00bdce0b}"
-- --------------------------------------------------
-- 
-- dispinterface DispIHTMLDListElement
-- 
-- --------------------------------------------------

                            
type DispIHTMLDListElement a = Automation.IDispatch (HTMLDListElement a)
iidIHTMLDListElement :: Com.IID (DispIHTMLDListElement Automation.Interface)
iidIHTMLDListElement =
  Com.mkIID "{3050f53b-98b5-11cf-bb82-00aa00bdce0b}"
-- --------------------------------------------------
-- 
-- coclass HTMLDListElement
-- 
-- --------------------------------------------------
clsidHTMLDListElement :: Com.CLSID
clsidHTMLDListElement =
  Com.mkCLSID "{3050f27d-98b5-11cf-bb82-00aa00bdce0b}"
-- --------------------------------------------------
-- 
-- interface IHTMLHRElement
-- 
-- --------------------------------------------------
data HTMLHRElement a = HTMLHRElement
                        
type IHTMLHRElement a = Automation.IDispatch (HTMLHRElement a)
iidHTMLHRElement :: Com.IID (IHTMLHRElement Automation.Interface)
iidHTMLHRElement =
  Com.mkIID "{3050f1f4-98b5-11cf-bb82-00aa00bdce0b}"
setNoShade :: Prelude.Int -> Automation.IDispatch a -> Prelude.IO ()
setNoShade v =
  Automation.propertySet "noShade" [Automation.inInt v]
getNoShade :: Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getNoShade = Automation.propertyGet "noShade" [] Automation.outInt
-- --------------------------------------------------
-- 
-- dispinterface DispIHTMLHRElement
-- 
-- --------------------------------------------------

                         
type DispIHTMLHRElement a = Automation.IDispatch (HTMLHRElement a)
iidIHTMLHRElement :: Com.IID (DispIHTMLHRElement Automation.Interface)
iidIHTMLHRElement =
  Com.mkIID "{3050f53d-98b5-11cf-bb82-00aa00bdce0b}"
-- --------------------------------------------------
-- 
-- coclass HTMLHRElement
-- 
-- --------------------------------------------------
clsidHTMLHRElement :: Com.CLSID
clsidHTMLHRElement =
  Com.mkCLSID "{3050f252-98b5-11cf-bb82-00aa00bdce0b}"
-- --------------------------------------------------
-- 
-- interface IHTMLParaElement
-- 
-- --------------------------------------------------
data HTMLParaElement a = HTMLParaElement
                          
type IHTMLParaElement a = Automation.IDispatch (HTMLParaElement a)
iidHTMLParaElement :: Com.IID (IHTMLParaElement Automation.Interface)
iidHTMLParaElement =
  Com.mkIID "{3050f1f5-98b5-11cf-bb82-00aa00bdce0b}"
-- --------------------------------------------------
-- 
-- dispinterface DispIHTMLParaElement
-- 
-- --------------------------------------------------

                           
type DispIHTMLParaElement a = Automation.IDispatch (HTMLParaElement a)
iidIHTMLParaElement :: Com.IID (DispIHTMLParaElement Automation.Interface)
iidIHTMLParaElement =
  Com.mkIID "{3050f52c-98b5-11cf-bb82-00aa00bdce0b}"
-- --------------------------------------------------
-- 
-- coclass HTMLParaElement
-- 
-- --------------------------------------------------
clsidHTMLParaElement :: Com.CLSID
clsidHTMLParaElement =
  Com.mkCLSID "{3050f26f-98b5-11cf-bb82-00aa00bdce0b}"
-- --------------------------------------------------
-- 
-- interface IHTMLElementCollection
-- 
-- --------------------------------------------------
data HTMLElementCollection a = HTMLElementCollection
                                
type IHTMLElementCollection a = Automation.IDispatch (HTMLElementCollection a)
iidHTMLElementCollection :: Com.IID (IHTMLElementCollection Automation.Interface)
iidHTMLElementCollection =
  Com.mkIID "{3050f21f-98b5-11cf-bb82-00aa00bdce0b}"
-- --------------------------------------------------
-- 
-- interface IHTMLHeaderElement
-- 
-- --------------------------------------------------
data HTMLHeaderElement a = HTMLHeaderElement
                            
type IHTMLHeaderElement a = Automation.IDispatch (HTMLHeaderElement a)
iidHTMLHeaderElement :: Com.IID (IHTMLHeaderElement Automation.Interface)
iidHTMLHeaderElement =
  Com.mkIID "{3050f1f6-98b5-11cf-bb82-00aa00bdce0b}"
-- --------------------------------------------------
-- 
-- dispinterface DispIHTMLHeaderElement
-- 
-- --------------------------------------------------

                             
type DispIHTMLHeaderElement a = Automation.IDispatch (HTMLHeaderElement a)
iidIHTMLHeaderElement :: Com.IID (DispIHTMLHeaderElement Automation.Interface)
iidIHTMLHeaderElement =
  Com.mkIID "{3050f515-98b5-11cf-bb82-00aa00bdce0b}"
-- --------------------------------------------------
-- 
-- coclass HTMLHeaderElement
-- 
-- --------------------------------------------------
clsidHTMLHeaderElement :: Com.CLSID
clsidHTMLHeaderElement =
  Com.mkCLSID "{3050f27a-98b5-11cf-bb82-00aa00bdce0b}"
-- --------------------------------------------------
-- 
-- dispinterface HTMLSelectElementEvents
-- 
-- --------------------------------------------------
data HTMLSelectElementEvents a = HTMLSelectElementEvents
                                  
type IHTMLSelectElementEvents a = Automation.IDispatch (HTMLSelectElementEvents a)
iidHTMLSelectElementEvents :: Com.IID (IHTMLSelectElementEvents Automation.Interface)
iidHTMLSelectElementEvents =
  Com.mkIID "{3050f302-98b5-11cf-bb82-00aa00bdce0b}"
-- --------------------------------------------------
-- 
-- interface IHTMLSelectElement
-- 
-- --------------------------------------------------
data HTMLSelectElement a = HTMLSelectElement
                            
type IHTMLSelectElement a = Automation.IDispatch (HTMLSelectElement a)
iidHTMLSelectElement :: Com.IID (IHTMLSelectElement Automation.Interface)
iidHTMLSelectElement =
  Com.mkIID "{3050f244-98b5-11cf-bb82-00aa00bdce0b}"
setSize3 :: Prelude.Int -> Automation.IDispatch a -> Prelude.IO ()
setSize3 v = Automation.propertySet "size" [Automation.inInt v]
getSize3 :: Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getSize3 = Automation.propertyGet "size" [] Automation.outInt
setMultiple :: Prelude.Int -> Automation.IDispatch a -> Prelude.IO ()
setMultiple v =
  Automation.propertySet "multiple" [Automation.inInt v]
getMultiple :: Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getMultiple =
  Automation.propertyGet "multiple" [] Automation.outInt
getOptions :: Automation.IDispatch a -> Prelude.IO (Automation.IDispatch Automation.Interface)
getOptions =
  Automation.propertyGet "options" [] Automation.outIDispatch
setOnchange :: (Automation.Variant a0) => a0 -> Automation.IDispatch a -> Prelude.IO ()
setOnchange v =
  Automation.propertySet "onchange" [Automation.inVariant v]
getOnchange :: (Automation.Variant a0) => Automation.IDispatch a -> Prelude.IO (a0)
getOnchange =
  Automation.propertyGet "onchange" [] Automation.outVariant
setSelectedIndex :: Prelude.Int -> Automation.IDispatch a -> Prelude.IO ()
setSelectedIndex v =
  Automation.propertySet "selectedIndex" [Automation.inInt v]
getSelectedIndex :: Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getSelectedIndex =
  Automation.propertyGet "selectedIndex" [] Automation.outInt
setValue1 :: Prelude.String -> Automation.IDispatch a -> Prelude.IO ()
setValue1 v =
  Automation.propertySet "value" [Automation.inString v]
getValue1 :: Automation.IDispatch a -> Prelude.IO (Prelude.String)
getValue1 = Automation.propertyGet "value" [] Automation.outString
getForm :: Automation.IDispatch a -> Prelude.IO (IHTMLFormElement Automation.Interface)
getForm = Automation.propertyGet "form" [] Automation.outIDispatch
add0 :: (Automation.Variant a1) => IHTMLElement a0 -> a1 -> Automation.IDispatch a -> Prelude.IO ()
add0 element before =
  Automation.method0 "add" [Automation.inIDispatch element, Automation.inVariant before]
-- --------------------------------------------------
-- 
-- dispinterface DispIHTMLSelectElement
-- 
-- --------------------------------------------------

                             
type DispIHTMLSelectElement a = Automation.IDispatch (HTMLSelectElement a)
iidIHTMLSelectElement :: Com.IID (DispIHTMLSelectElement Automation.Interface)
iidIHTMLSelectElement =
  Com.mkIID "{3050f531-98b5-11cf-bb82-00aa00bdce0b}"
-- --------------------------------------------------
-- 
-- coclass HTMLSelectElement
-- 
-- --------------------------------------------------
clsidHTMLSelectElement :: Com.CLSID
clsidHTMLSelectElement =
  Com.mkCLSID "{3050f245-98b5-11cf-bb82-00aa00bdce0b}"
-- --------------------------------------------------
-- 
-- interface IHTMLSelectionObject
-- 
-- --------------------------------------------------
data HTMLSelectionObject a = HTMLSelectionObject
                              
type IHTMLSelectionObject a = Automation.IDispatch (HTMLSelectionObject a)
iidHTMLSelectionObject :: Com.IID (IHTMLSelectionObject Automation.Interface)
iidHTMLSelectionObject =
  Com.mkIID "{3050f25A-98b5-11cf-bb82-00aa00bdce0b}"
createRange :: IHTMLSelectionObject a -> Prelude.IO (Automation.IDispatch Automation.Interface)
createRange =
  Automation.function1 "createRange" [] Automation.outIDispatch
empty :: IHTMLSelectionObject a -> Prelude.IO ()
empty = Automation.method0 "empty" []
clear :: Automation.IDispatch a -> Prelude.IO ()
clear = Automation.method0 "clear" []
-- --------------------------------------------------
-- 
-- interface IHTMLOptionElement
-- 
-- --------------------------------------------------
data HTMLOptionElement a = HTMLOptionElement
                            
type IHTMLOptionElement a = Automation.IDispatch (HTMLOptionElement a)
iidHTMLOptionElement :: Com.IID (IHTMLOptionElement Automation.Interface)
iidHTMLOptionElement =
  Com.mkIID "{3050f211-98b5-11cf-bb82-00aa00bdce0b}"
setSelected :: Prelude.Int -> Automation.IDispatch a -> Prelude.IO ()
setSelected v =
  Automation.propertySet "selected" [Automation.inInt v]
getSelected :: Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getSelected =
  Automation.propertyGet "selected" [] Automation.outInt
setDefaultSelected :: Prelude.Int -> Automation.IDispatch a -> Prelude.IO ()
setDefaultSelected v =
  Automation.propertySet "defaultSelected" [Automation.inInt v]
getDefaultSelected :: Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getDefaultSelected =
  Automation.propertyGet "defaultSelected" [] Automation.outInt
setIndex :: Prelude.Int -> Automation.IDispatch a -> Prelude.IO ()
setIndex v = Automation.propertySet "index" [Automation.inInt v]
getIndex :: Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getIndex = Automation.propertyGet "index" [] Automation.outInt
-- --------------------------------------------------
-- 
-- interface IHTMLOptionElementFactory
-- 
-- --------------------------------------------------
data HTMLOptionElementFactory a = HTMLOptionElementFactory
                                   
type IHTMLOptionElementFactory a = Automation.IDispatch (HTMLOptionElementFactory a)
iidHTMLOptionElementFactory :: Com.IID (IHTMLOptionElementFactory Automation.Interface)
iidHTMLOptionElementFactory =
  Com.mkIID "{3050f38c-98b5-11cf-bb82-00aa00bdce0b}"
create0 :: (Automation.Variant a0, Automation.Variant a1, Automation.Variant a2, Automation.Variant a3) => a0 -> a1 -> a2 -> a3 -> IHTMLOptionElementFactory a -> Prelude.IO (IHTMLOptionElement Automation.Interface)
create0 text value defaultselected selected =
  Automation.function1 "create" [Automation.inVariant text, Automation.inVariant value, Automation.inVariant defaultselected, Automation.inVariant selected] Automation.outIDispatch
-- --------------------------------------------------
-- 
-- dispinterface DispIHTMLOptionElement
-- 
-- --------------------------------------------------

                             
type DispIHTMLOptionElement a = Automation.IDispatch (HTMLOptionElement a)
iidIHTMLOptionElement :: Com.IID (DispIHTMLOptionElement Automation.Interface)
iidIHTMLOptionElement =
  Com.mkIID "{3050f52b-98b5-11cf-bb82-00aa00bdce0b}"
-- --------------------------------------------------
-- 
-- coclass HTMLOptionElement
-- 
-- --------------------------------------------------
clsidHTMLOptionElement :: Com.CLSID
clsidHTMLOptionElement =
  Com.mkCLSID "{3050f24d-98b5-11cf-bb82-00aa00bdce0b}"
-- --------------------------------------------------
-- 
-- coclass HTMLOptionElementFactory
-- 
-- --------------------------------------------------
clsidHTMLOptionElementFactory :: Com.CLSID
clsidHTMLOptionElementFactory =
  Com.mkCLSID "{3050f38d-98b5-11cf-bb82-00aa00bdce0b}"
-- --------------------------------------------------
-- 
-- dispinterface HTMLInputTextElementEvents
-- 
-- --------------------------------------------------
data HTMLInputTextElementEvents a = HTMLInputTextElementEvents
                                     
type IHTMLInputTextElementEvents a = Automation.IDispatch (HTMLInputTextElementEvents a)
iidHTMLInputTextElementEvents :: Com.IID (IHTMLInputTextElementEvents Automation.Interface)
iidHTMLInputTextElementEvents =
  Com.mkIID "{3050f2a7-98b5-11cf-bb82-00aa00bdce0b}"
-- --------------------------------------------------
-- 
-- interface IHTMLInputHiddenElement
-- 
-- --------------------------------------------------
data HTMLInputHiddenElement a = HTMLInputHiddenElement
                                 
type IHTMLInputHiddenElement a = Automation.IDispatch (HTMLInputHiddenElement a)
iidHTMLInputHiddenElement :: Com.IID (IHTMLInputHiddenElement Automation.Interface)
iidHTMLInputHiddenElement =
  Com.mkIID "{3050f2a4-98b5-11cf-bb82-00aa00bdce0b}"
setStatus :: (Automation.Variant a0) => a0 -> Automation.IDispatch a -> Prelude.IO ()
setStatus v =
  Automation.propertySet "status" [Automation.inVariant v]
getStatus :: (Automation.Variant a0) => Automation.IDispatch a -> Prelude.IO (a0)
getStatus =
  Automation.propertyGet "status" [] Automation.outVariant
-- --------------------------------------------------
-- 
-- interface IHTMLInputTextElement
-- 
-- --------------------------------------------------
data HTMLInputTextElement a = HTMLInputTextElement
                               
type IHTMLInputTextElement a = Automation.IDispatch (HTMLInputTextElement a)
iidHTMLInputTextElement :: Com.IID (IHTMLInputTextElement Automation.Interface)
iidHTMLInputTextElement =
  Com.mkIID "{3050f2a6-98b5-11cf-bb82-00aa00bdce0b}"
setDefaultValue :: Prelude.String -> Automation.IDispatch a -> Prelude.IO ()
setDefaultValue v =
  Automation.propertySet "defaultValue" [Automation.inString v]
getDefaultValue :: Automation.IDispatch a -> Prelude.IO (Prelude.String)
getDefaultValue =
  Automation.propertyGet "defaultValue" [] Automation.outString
setMaxLength :: Prelude.Int -> Automation.IDispatch a -> Prelude.IO ()
setMaxLength v =
  Automation.propertySet "maxLength" [Automation.inInt v]
getMaxLength :: Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getMaxLength =
  Automation.propertyGet "maxLength" [] Automation.outInt
setReadOnly :: Prelude.Int -> Automation.IDispatch a -> Prelude.IO ()
setReadOnly v =
  Automation.propertySet "readOnly" [Automation.inInt v]
-- --------------------------------------------------
-- 
-- interface IHTMLTextAreaElement
-- 
-- --------------------------------------------------
data HTMLTextAreaElement a = HTMLTextAreaElement
                              
type IHTMLTextAreaElement a = Automation.IDispatch (HTMLTextAreaElement a)
iidHTMLTextAreaElement :: Com.IID (IHTMLTextAreaElement Automation.Interface)
iidHTMLTextAreaElement =
  Com.mkIID "{3050f2aa-98b5-11cf-bb82-00aa00bdce0b}"
setRows :: Prelude.Int -> Automation.IDispatch a -> Prelude.IO ()
setRows v = Automation.propertySet "rows" [Automation.inInt v]
getRows :: Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getRows = Automation.propertyGet "rows" [] Automation.outInt
setCols :: Prelude.Int -> Automation.IDispatch a -> Prelude.IO ()
setCols v = Automation.propertySet "cols" [Automation.inInt v]
getCols :: Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getCols = Automation.propertyGet "cols" [] Automation.outInt
setWrap :: Prelude.String -> Automation.IDispatch a -> Prelude.IO ()
setWrap v = Automation.propertySet "wrap" [Automation.inString v]
getWrap :: Automation.IDispatch a -> Prelude.IO (Prelude.String)
getWrap = Automation.propertyGet "wrap" [] Automation.outString
-- --------------------------------------------------
-- 
-- dispinterface DispIHTMLInputTextElement
-- 
-- --------------------------------------------------

                                
type DispIHTMLInputTextElement a = Automation.IDispatch (HTMLInputTextElement a)
iidIHTMLInputTextElement :: Com.IID (DispIHTMLInputTextElement Automation.Interface)
iidIHTMLInputTextElement =
  Com.mkIID "{3050f520-98b5-11cf-bb82-00aa00bdce0b}"
-- --------------------------------------------------
-- 
-- coclass HTMLInputTextElement
-- 
-- --------------------------------------------------
clsidHTMLInputTextElement :: Com.CLSID
clsidHTMLInputTextElement =
  Com.mkCLSID "{3050f2ab-98b5-11cf-bb82-00aa00bdce0b}"
-- --------------------------------------------------
-- 
-- dispinterface DispIHTMLTextAreaElement
-- 
-- --------------------------------------------------

                               
type DispIHTMLTextAreaElement a = Automation.IDispatch (HTMLTextAreaElement a)
iidIHTMLTextAreaElement :: Com.IID (DispIHTMLTextAreaElement Automation.Interface)
iidIHTMLTextAreaElement =
  Com.mkIID "{3050f521-98b5-11cf-bb82-00aa00bdce0b}"
-- --------------------------------------------------
-- 
-- coclass HTMLTextAreaElement
-- 
-- --------------------------------------------------
clsidHTMLTextAreaElement :: Com.CLSID
clsidHTMLTextAreaElement =
  Com.mkCLSID "{3050f2ac-98b5-11cf-bb82-00aa00bdce0b}"
-- --------------------------------------------------
-- 
-- dispinterface HTMLButtonElementEvents
-- 
-- --------------------------------------------------
data HTMLButtonElementEvents a = HTMLButtonElementEvents
                                  
type IHTMLButtonElementEvents a = Automation.IDispatch (HTMLButtonElementEvents a)
iidHTMLButtonElementEvents :: Com.IID (IHTMLButtonElementEvents Automation.Interface)
iidHTMLButtonElementEvents =
  Com.mkIID "{3050f2b3-98b5-11cf-bb82-00aa00bdce0b}"
-- --------------------------------------------------
-- 
-- interface IHTMLInputButtonElement
-- 
-- --------------------------------------------------
data HTMLInputButtonElement a = HTMLInputButtonElement
                                 
type IHTMLInputButtonElement a = Automation.IDispatch (HTMLInputButtonElement a)
iidHTMLInputButtonElement :: Com.IID (IHTMLInputButtonElement Automation.Interface)
iidHTMLInputButtonElement =
  Com.mkIID "{3050f2b2-98b5-11cf-bb82-00aa00bdce0b}"
-- --------------------------------------------------
-- 
-- interface IHTMLButtonElement
-- 
-- --------------------------------------------------
data HTMLButtonElement a = HTMLButtonElement
                            
type IHTMLButtonElement a = Automation.IDispatch (HTMLButtonElement a)
iidHTMLButtonElement :: Com.IID (IHTMLButtonElement Automation.Interface)
iidHTMLButtonElement =
  Com.mkIID "{3050f2bb-98b5-11cf-bb82-00aa00bdce0b}"
-- --------------------------------------------------
-- 
-- dispinterface DispIHTMLInputButtonElement
-- 
-- --------------------------------------------------

                                  
type DispIHTMLInputButtonElement a = Automation.IDispatch (HTMLInputButtonElement a)
iidIHTMLInputButtonElement :: Com.IID (DispIHTMLInputButtonElement Automation.Interface)
iidIHTMLInputButtonElement =
  Com.mkIID "{3050f51e-98b5-11cf-bb82-00aa00bdce0b}"
-- --------------------------------------------------
-- 
-- coclass HTMLInputButtonElement
-- 
-- --------------------------------------------------
clsidHTMLInputButtonElement :: Com.CLSID
clsidHTMLInputButtonElement =
  Com.mkCLSID "{3050f2b4-98b5-11cf-bb82-00aa00bdce0b}"
-- --------------------------------------------------
-- 
-- dispinterface DispIHTMLButtonElement
-- 
-- --------------------------------------------------

                             
type DispIHTMLButtonElement a = Automation.IDispatch (HTMLButtonElement a)
iidIHTMLButtonElement :: Com.IID (DispIHTMLButtonElement Automation.Interface)
iidIHTMLButtonElement =
  Com.mkIID "{3050f51f-98b5-11cf-bb82-00aa00bdce0b}"
-- --------------------------------------------------
-- 
-- coclass HTMLButtonElement
-- 
-- --------------------------------------------------
clsidHTMLButtonElement :: Com.CLSID
clsidHTMLButtonElement =
  Com.mkCLSID "{3050f2c6-98b5-11cf-bb82-00aa00bdce0b}"
-- --------------------------------------------------
-- 
-- dispinterface HTMLInputFileElementEvents
-- 
-- --------------------------------------------------
data HTMLInputFileElementEvents a = HTMLInputFileElementEvents
                                     
type IHTMLInputFileElementEvents a = Automation.IDispatch (HTMLInputFileElementEvents a)
iidHTMLInputFileElementEvents :: Com.IID (IHTMLInputFileElementEvents Automation.Interface)
iidHTMLInputFileElementEvents =
  Com.mkIID "{3050f2af-98b5-11cf-bb82-00aa00bdce0b}"
-- --------------------------------------------------
-- 
-- interface IHTMLInputFileElement
-- 
-- --------------------------------------------------
data HTMLInputFileElement a = HTMLInputFileElement
                               
type IHTMLInputFileElement a = Automation.IDispatch (HTMLInputFileElement a)
iidHTMLInputFileElement :: Com.IID (IHTMLInputFileElement Automation.Interface)
iidHTMLInputFileElement =
  Com.mkIID "{3050f2ad-98b5-11cf-bb82-00aa00bdce0b}"
-- --------------------------------------------------
-- 
-- dispinterface DispIHTMLInputFileElement
-- 
-- --------------------------------------------------

                                
type DispIHTMLInputFileElement a = Automation.IDispatch (HTMLInputFileElement a)
iidIHTMLInputFileElement :: Com.IID (DispIHTMLInputFileElement Automation.Interface)
iidIHTMLInputFileElement =
  Com.mkIID "{3050f542-98b5-11cf-bb82-00aa00bdce0b}"
-- --------------------------------------------------
-- 
-- coclass HTMLInputFileElement
-- 
-- --------------------------------------------------
clsidHTMLInputFileElement :: Com.CLSID
clsidHTMLInputFileElement =
  Com.mkCLSID "{3050f2ae-98b5-11cf-bb82-00aa00bdce0b}"
-- --------------------------------------------------
-- 
-- dispinterface HTMLMarqueeElementEvents
-- 
-- --------------------------------------------------
data HTMLMarqueeElementEvents a = HTMLMarqueeElementEvents
                                   
type IHTMLMarqueeElementEvents a = Automation.IDispatch (HTMLMarqueeElementEvents a)
iidHTMLMarqueeElementEvents :: Com.IID (IHTMLMarqueeElementEvents Automation.Interface)
iidHTMLMarqueeElementEvents =
  Com.mkIID "{3050f2b8-98b5-11cf-bb82-00aa00bdce0b}"
onbounce :: IHTMLMarqueeElementEvents a -> Prelude.IO ()
onbounce = Automation.method0 "onbounce" []
onfinish :: IHTMLMarqueeElementEvents a -> Prelude.IO ()
onfinish = Automation.method0 "onfinish" []
onstart :: IHTMLMarqueeElementEvents a -> Prelude.IO ()
onstart = Automation.method0 "onstart" []
-- --------------------------------------------------
-- 
-- interface IHTMLMarqueeElement
-- 
-- --------------------------------------------------
data HTMLMarqueeElement a = HTMLMarqueeElement
                             
type IHTMLMarqueeElement a = Automation.IDispatch (HTMLMarqueeElement a)
iidHTMLMarqueeElement :: Com.IID (IHTMLMarqueeElement Automation.Interface)
iidHTMLMarqueeElement =
  Com.mkIID "{3050f2b5-98b5-11cf-bb82-00aa00bdce0b}"
setScrollDelay :: Prelude.Int -> Automation.IDispatch a -> Prelude.IO ()
setScrollDelay v =
  Automation.propertySet "scrollDelay" [Automation.inInt v]
getScrollDelay :: Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getScrollDelay =
  Automation.propertyGet "scrollDelay" [] Automation.outInt
setDirection :: Prelude.String -> Automation.IDispatch a -> Prelude.IO ()
setDirection v =
  Automation.propertySet "direction" [Automation.inString v]
getDirection :: Automation.IDispatch a -> Prelude.IO (Prelude.String)
getDirection =
  Automation.propertyGet "direction" [] Automation.outString
setBehavior :: Prelude.String -> Automation.IDispatch a -> Prelude.IO ()
setBehavior v =
  Automation.propertySet "behavior" [Automation.inString v]
getBehavior :: Automation.IDispatch a -> Prelude.IO (Prelude.String)
getBehavior =
  Automation.propertyGet "behavior" [] Automation.outString
setScrollAmount :: Prelude.Int -> Automation.IDispatch a -> Prelude.IO ()
setScrollAmount v =
  Automation.propertySet "scrollAmount" [Automation.inInt v]
getScrollAmount :: Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getScrollAmount =
  Automation.propertyGet "scrollAmount" [] Automation.outInt
setLoop3 :: Prelude.Int -> Automation.IDispatch a -> Prelude.IO ()
setLoop3 v = Automation.propertySet "loop" [Automation.inInt v]
getLoop3 :: Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getLoop3 = Automation.propertyGet "loop" [] Automation.outInt
setOnfinish :: (Automation.Variant a0) => a0 -> Automation.IDispatch a -> Prelude.IO ()
setOnfinish v =
  Automation.propertySet "onfinish" [Automation.inVariant v]
getOnfinish :: (Automation.Variant a0) => Automation.IDispatch a -> Prelude.IO (a0)
getOnfinish =
  Automation.propertyGet "onfinish" [] Automation.outVariant
setOnstart :: (Automation.Variant a0) => a0 -> Automation.IDispatch a -> Prelude.IO ()
setOnstart v =
  Automation.propertySet "onstart" [Automation.inVariant v]
getOnstart :: (Automation.Variant a0) => Automation.IDispatch a -> Prelude.IO (a0)
getOnstart =
  Automation.propertyGet "onstart" [] Automation.outVariant
setOnbounce :: (Automation.Variant a0) => a0 -> Automation.IDispatch a -> Prelude.IO ()
setOnbounce v =
  Automation.propertySet "onbounce" [Automation.inVariant v]
getOnbounce :: (Automation.Variant a0) => Automation.IDispatch a -> Prelude.IO (a0)
getOnbounce =
  Automation.propertyGet "onbounce" [] Automation.outVariant
setTrueSpeed :: Prelude.Int -> Automation.IDispatch a -> Prelude.IO ()
setTrueSpeed v =
  Automation.propertySet "trueSpeed" [Automation.inInt v]
getTrueSpeed :: Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getTrueSpeed =
  Automation.propertyGet "trueSpeed" [] Automation.outInt
start :: Automation.IDispatch a -> Prelude.IO ()
start = Automation.method0 "start" []
stop :: Automation.IDispatch a -> Prelude.IO ()
stop = Automation.method0 "stop" []
-- --------------------------------------------------
-- 
-- dispinterface DispIHTMLMarqueeElement
-- 
-- --------------------------------------------------

                              
type DispIHTMLMarqueeElement a = Automation.IDispatch (HTMLMarqueeElement a)
iidIHTMLMarqueeElement :: Com.IID (DispIHTMLMarqueeElement Automation.Interface)
iidIHTMLMarqueeElement =
  Com.mkIID "{3050f527-98b5-11cf-bb82-00aa00bdce0b}"
-- --------------------------------------------------
-- 
-- coclass HTMLMarqueeElement
-- 
-- --------------------------------------------------
clsidHTMLMarqueeElement :: Com.CLSID
clsidHTMLMarqueeElement =
  Com.mkCLSID "{3050f2b9-98b5-11cf-bb82-00aa00bdce0b}"
-- --------------------------------------------------
-- 
-- dispinterface HTMLOptionButtonElementEvents
-- 
-- --------------------------------------------------
data HTMLOptionButtonElementEvents a = HTMLOptionButtonElementEvents
                                        
type IHTMLOptionButtonElementEvents a = Automation.IDispatch (HTMLOptionButtonElementEvents a)
iidHTMLOptionButtonElementEvents :: Com.IID (IHTMLOptionButtonElementEvents Automation.Interface)
iidHTMLOptionButtonElementEvents =
  Com.mkIID "{3050f2bd-98b5-11cf-bb82-00aa00bdce0b}"
-- --------------------------------------------------
-- 
-- interface IHTMLOptionButtonElement
-- 
-- --------------------------------------------------
data HTMLOptionButtonElement a = HTMLOptionButtonElement
                                  
type IHTMLOptionButtonElement a = Automation.IDispatch (HTMLOptionButtonElement a)
iidHTMLOptionButtonElement :: Com.IID (IHTMLOptionButtonElement Automation.Interface)
iidHTMLOptionButtonElement =
  Com.mkIID "{3050f2bc-98b5-11cf-bb82-00aa00bdce0b}"
setChecked :: Prelude.Int -> Automation.IDispatch a -> Prelude.IO ()
setChecked v =
  Automation.propertySet "checked" [Automation.inInt v]
getChecked :: Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getChecked = Automation.propertyGet "checked" [] Automation.outInt
setDefaultChecked :: Prelude.Int -> Automation.IDispatch a -> Prelude.IO ()
setDefaultChecked v =
  Automation.propertySet "defaultChecked" [Automation.inInt v]
getDefaultChecked :: Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getDefaultChecked =
  Automation.propertyGet "defaultChecked" [] Automation.outInt
setStatus10 :: Prelude.Int -> Automation.IDispatch a -> Prelude.IO ()
setStatus10 v =
  Automation.propertySet "status" [Automation.inInt v]
getStatus10 :: Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getStatus10 = Automation.propertyGet "status" [] Automation.outInt
setIndeterminate :: Prelude.Int -> Automation.IDispatch a -> Prelude.IO ()
setIndeterminate v =
  Automation.propertySet "indeterminate" [Automation.inInt v]
getIndeterminate :: Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getIndeterminate =
  Automation.propertyGet "indeterminate" [] Automation.outInt
-- --------------------------------------------------
-- 
-- dispinterface DispIHTMLOptionButtonElement
-- 
-- --------------------------------------------------

                                   
type DispIHTMLOptionButtonElement a = Automation.IDispatch (HTMLOptionButtonElement a)
iidIHTMLOptionButtonElement :: Com.IID (DispIHTMLOptionButtonElement Automation.Interface)
iidIHTMLOptionButtonElement =
  Com.mkIID "{3050f509-98b5-11cf-bb82-00aa00bdce0b}"
-- --------------------------------------------------
-- 
-- coclass HTMLOptionButtonElement
-- 
-- --------------------------------------------------
clsidHTMLOptionButtonElement :: Com.CLSID
clsidHTMLOptionButtonElement =
  Com.mkCLSID "{3050f2be-98b5-11cf-bb82-00aa00bdce0b}"
-- --------------------------------------------------
-- 
-- interface IHTMLTitleElement
-- 
-- --------------------------------------------------
data HTMLTitleElement a = HTMLTitleElement
                           
type IHTMLTitleElement a = Automation.IDispatch (HTMLTitleElement a)
iidHTMLTitleElement :: Com.IID (IHTMLTitleElement Automation.Interface)
iidHTMLTitleElement =
  Com.mkIID "{3050f322-98b5-11cf-bb82-00aa00bdce0b}"
-- --------------------------------------------------
-- 
-- interface IHTMLMetaElement
-- 
-- --------------------------------------------------
data HTMLMetaElement a = HTMLMetaElement
                          
type IHTMLMetaElement a = Automation.IDispatch (HTMLMetaElement a)
iidHTMLMetaElement :: Com.IID (IHTMLMetaElement Automation.Interface)
iidHTMLMetaElement =
  Com.mkIID "{3050f203-98b5-11cf-bb82-00aa00bdce0b}"
setHttpEquiv :: Prelude.String -> Automation.IDispatch a -> Prelude.IO ()
setHttpEquiv v =
  Automation.propertySet "httpEquiv" [Automation.inString v]
getHttpEquiv :: Automation.IDispatch a -> Prelude.IO (Prelude.String)
getHttpEquiv =
  Automation.propertyGet "httpEquiv" [] Automation.outString
setContent :: Prelude.String -> Automation.IDispatch a -> Prelude.IO ()
setContent v =
  Automation.propertySet "content" [Automation.inString v]
getContent :: Automation.IDispatch a -> Prelude.IO (Prelude.String)
getContent =
  Automation.propertyGet "content" [] Automation.outString
setUrl :: Prelude.String -> Automation.IDispatch a -> Prelude.IO ()
setUrl v = Automation.propertySet "url" [Automation.inString v]
getUrl :: Automation.IDispatch a -> Prelude.IO (Prelude.String)
getUrl = Automation.propertyGet "url" [] Automation.outString
setCharset :: Prelude.String -> Automation.IDispatch a -> Prelude.IO ()
setCharset v =
  Automation.propertySet "charset" [Automation.inString v]
getCharset :: Automation.IDispatch a -> Prelude.IO (Prelude.String)
getCharset =
  Automation.propertyGet "charset" [] Automation.outString
-- --------------------------------------------------
-- 
-- interface IHTMLBaseElement
-- 
-- --------------------------------------------------
data HTMLBaseElement a = HTMLBaseElement
                          
type IHTMLBaseElement a = Automation.IDispatch (HTMLBaseElement a)
iidHTMLBaseElement :: Com.IID (IHTMLBaseElement Automation.Interface)
iidHTMLBaseElement =
  Com.mkIID "{3050f204-98b5-11cf-bb82-00aa00bdce0b}"
-- --------------------------------------------------
-- 
-- interface IHTMLIsIndexElement
-- 
-- --------------------------------------------------
data HTMLIsIndexElement a = HTMLIsIndexElement
                             
type IHTMLIsIndexElement a = Automation.IDispatch (HTMLIsIndexElement a)
iidHTMLIsIndexElement :: Com.IID (IHTMLIsIndexElement Automation.Interface)
iidHTMLIsIndexElement =
  Com.mkIID "{3050f206-98b5-11cf-bb82-00aa00bdce0b}"
setPrompt :: Prelude.String -> Automation.IDispatch a -> Prelude.IO ()
setPrompt v =
  Automation.propertySet "prompt" [Automation.inString v]
getPrompt :: Automation.IDispatch a -> Prelude.IO (Prelude.String)
getPrompt = Automation.propertyGet "prompt" [] Automation.outString
-- --------------------------------------------------
-- 
-- interface IHTMLNextIdElement
-- 
-- --------------------------------------------------
data HTMLNextIdElement a = HTMLNextIdElement
                            
type IHTMLNextIdElement a = Automation.IDispatch (HTMLNextIdElement a)
iidHTMLNextIdElement :: Com.IID (IHTMLNextIdElement Automation.Interface)
iidHTMLNextIdElement =
  Com.mkIID "{3050f207-98b5-11cf-bb82-00aa00bdce0b}"
setN :: Prelude.String -> Automation.IDispatch a -> Prelude.IO ()
setN v = Automation.propertySet "n" [Automation.inString v]
getN :: Automation.IDispatch a -> Prelude.IO (Prelude.String)
getN = Automation.propertyGet "n" [] Automation.outString
-- --------------------------------------------------
-- 
-- dispinterface DispIHTMLTitleElement
-- 
-- --------------------------------------------------

                            
type DispIHTMLTitleElement a = Automation.IDispatch (HTMLTitleElement a)
iidIHTMLTitleElement :: Com.IID (DispIHTMLTitleElement Automation.Interface)
iidIHTMLTitleElement =
  Com.mkIID "{3050f516-98b5-11cf-bb82-00aa00bdce0b}"
-- --------------------------------------------------
-- 
-- coclass HTMLTitleElement
-- 
-- --------------------------------------------------
clsidHTMLTitleElement :: Com.CLSID
clsidHTMLTitleElement =
  Com.mkCLSID "{3050f284-98b5-11cf-bb82-00aa00bdce0b}"
-- --------------------------------------------------
-- 
-- dispinterface DispIHTMLMetaElement
-- 
-- --------------------------------------------------

                           
type DispIHTMLMetaElement a = Automation.IDispatch (HTMLMetaElement a)
iidIHTMLMetaElement :: Com.IID (DispIHTMLMetaElement Automation.Interface)
iidIHTMLMetaElement =
  Com.mkIID "{3050f517-98b5-11cf-bb82-00aa00bdce0b}"
-- --------------------------------------------------
-- 
-- coclass HTMLMetaElement
-- 
-- --------------------------------------------------
clsidHTMLMetaElement :: Com.CLSID
clsidHTMLMetaElement =
  Com.mkCLSID "{3050f275-98b5-11cf-bb82-00aa00bdce0b}"
-- --------------------------------------------------
-- 
-- dispinterface DispIHTMLBaseElement
-- 
-- --------------------------------------------------

                           
type DispIHTMLBaseElement a = Automation.IDispatch (HTMLBaseElement a)
iidIHTMLBaseElement :: Com.IID (DispIHTMLBaseElement Automation.Interface)
iidIHTMLBaseElement =
  Com.mkIID "{3050f518-98b5-11cf-bb82-00aa00bdce0b}"
-- --------------------------------------------------
-- 
-- coclass HTMLBaseElement
-- 
-- --------------------------------------------------
clsidHTMLBaseElement :: Com.CLSID
clsidHTMLBaseElement =
  Com.mkCLSID "{3050f276-98b5-11cf-bb82-00aa00bdce0b}"
-- --------------------------------------------------
-- 
-- dispinterface DispIHTMLIsIndexElement
-- 
-- --------------------------------------------------

                              
type DispIHTMLIsIndexElement a = Automation.IDispatch (HTMLIsIndexElement a)
iidIHTMLIsIndexElement :: Com.IID (DispIHTMLIsIndexElement Automation.Interface)
iidIHTMLIsIndexElement =
  Com.mkIID "{3050f519-98b5-11cf-bb82-00aa00bdce0b}"
-- --------------------------------------------------
-- 
-- coclass HTMLIsIndexElement
-- 
-- --------------------------------------------------
clsidHTMLIsIndexElement :: Com.CLSID
clsidHTMLIsIndexElement =
  Com.mkCLSID "{3050f278-98b5-11cf-bb82-00aa00bdce0b}"
-- --------------------------------------------------
-- 
-- dispinterface DispIHTMLNextIdElement
-- 
-- --------------------------------------------------

                             
type DispIHTMLNextIdElement a = Automation.IDispatch (HTMLNextIdElement a)
iidIHTMLNextIdElement :: Com.IID (DispIHTMLNextIdElement Automation.Interface)
iidIHTMLNextIdElement =
  Com.mkIID "{3050f51a-98b5-11cf-bb82-00aa00bdce0b}"
-- --------------------------------------------------
-- 
-- coclass HTMLNextIdElement
-- 
-- --------------------------------------------------
clsidHTMLNextIdElement :: Com.CLSID
clsidHTMLNextIdElement =
  Com.mkCLSID "{3050f279-98b5-11cf-bb82-00aa00bdce0b}"
-- --------------------------------------------------
-- 
-- interface IHTMLBaseFontElement
-- 
-- --------------------------------------------------
data HTMLBaseFontElement a = HTMLBaseFontElement
                              
type IHTMLBaseFontElement a = Automation.IDispatch (HTMLBaseFontElement a)
iidHTMLBaseFontElement :: Com.IID (IHTMLBaseFontElement Automation.Interface)
iidHTMLBaseFontElement =
  Com.mkIID "{3050f202-98b5-11cf-bb82-00aa00bdce0b}"
-- --------------------------------------------------
-- 
-- dispinterface DispIHTMLBaseFontElement
-- 
-- --------------------------------------------------

                               
type DispIHTMLBaseFontElement a = Automation.IDispatch (HTMLBaseFontElement a)
iidIHTMLBaseFontElement :: Com.IID (DispIHTMLBaseFontElement Automation.Interface)
iidIHTMLBaseFontElement =
  Com.mkIID "{3050f504-98b5-11cf-bb82-00aa00bdce0b}"
-- --------------------------------------------------
-- 
-- coclass HTMLBaseFontElement
-- 
-- --------------------------------------------------
clsidHTMLBaseFontElement :: Com.CLSID
clsidHTMLBaseFontElement =
  Com.mkCLSID "{3050f282-98b5-11cf-bb82-00aa00bdce0b}"
-- --------------------------------------------------
-- 
-- interface IHTMLUnknownElement
-- 
-- --------------------------------------------------
data HTMLUnknownElement a = HTMLUnknownElement
                             
type IHTMLUnknownElement a = Automation.IDispatch (HTMLUnknownElement a)
iidHTMLUnknownElement :: Com.IID (IHTMLUnknownElement Automation.Interface)
iidHTMLUnknownElement =
  Com.mkIID "{3050f209-98b5-11cf-bb82-00aa00bdce0b}"
-- --------------------------------------------------
-- 
-- dispinterface DispIHTMLUnknownElement
-- 
-- --------------------------------------------------

                              
type DispIHTMLUnknownElement a = Automation.IDispatch (HTMLUnknownElement a)
iidIHTMLUnknownElement :: Com.IID (DispIHTMLUnknownElement Automation.Interface)
iidIHTMLUnknownElement =
  Com.mkIID "{3050f539-98b5-11cf-bb82-00aa00bdce0b}"
-- --------------------------------------------------
-- 
-- coclass HTMLUnknownElement
-- 
-- --------------------------------------------------
clsidHTMLUnknownElement :: Com.CLSID
clsidHTMLUnknownElement =
  Com.mkCLSID "{3050f268-98b5-11cf-bb82-00aa00bdce0b}"
-- --------------------------------------------------
-- 
-- interface IOmHistory
-- 
-- --------------------------------------------------
data OmHistory a = OmHistory
                    
type IOmHistory a = Automation.IDispatch (OmHistory a)
iidOmHistory :: Com.IID (IOmHistory Automation.Interface)
iidOmHistory = Com.mkIID "{FECEAAA2-8405-11cf-8BA1-00AA00476DA6}"
getLength7 :: IOmHistory a -> Prelude.IO (Prelude.Int)
getLength7 = Automation.propertyGet "length" [] Automation.outInt
back :: (Automation.Variant a0) => a0 -> IOmHistory a -> Prelude.IO ()
back pvargdistance =
  Automation.method0 "back" [Automation.inVariant pvargdistance]
forward :: (Automation.Variant a0) => a0 -> IOmHistory a -> Prelude.IO ()
forward pvargdistance =
  Automation.method0 "forward" [Automation.inVariant pvargdistance]
go :: (Automation.Variant a0) => a0 -> IOmHistory a -> Prelude.IO ()
go pvargdistance =
  Automation.method0 "go" [Automation.inVariant pvargdistance]
-- --------------------------------------------------
-- 
-- interface IHTMLMimeTypesCollection
-- 
-- --------------------------------------------------
data HTMLMimeTypesCollection a = HTMLMimeTypesCollection
                                  
type IHTMLMimeTypesCollection a = Automation.IDispatch (HTMLMimeTypesCollection a)
iidHTMLMimeTypesCollection :: Com.IID (IHTMLMimeTypesCollection Automation.Interface)
iidHTMLMimeTypesCollection =
  Com.mkIID "{3050f3fc-98b5-11cf-bb82-00aa00bdce0b}"
-- --------------------------------------------------
-- 
-- interface IHTMLPluginsCollection
-- 
-- --------------------------------------------------
data HTMLPluginsCollection a = HTMLPluginsCollection
                                
type IHTMLPluginsCollection a = Automation.IDispatch (HTMLPluginsCollection a)
iidHTMLPluginsCollection :: Com.IID (IHTMLPluginsCollection Automation.Interface)
iidHTMLPluginsCollection =
  Com.mkIID "{3050f3fd-98b5-11cf-bb82-00aa00bdce0b}"
refresh :: Prelude.Int -> IHTMLPluginsCollection a -> Prelude.IO ()
refresh reload =
  Automation.method0 "refresh" [Automation.inInt reload]
-- --------------------------------------------------
-- 
-- interface IHTMLOpsProfile
-- 
-- --------------------------------------------------
data HTMLOpsProfile a = HTMLOpsProfile
                         
type IHTMLOpsProfile a = Automation.IDispatch (HTMLOpsProfile a)
iidHTMLOpsProfile :: Com.IID (IHTMLOpsProfile Automation.Interface)
iidHTMLOpsProfile =
  Com.mkIID "{3050f401-98b5-11cf-bb82-00aa00bdce0b}"
addRequest :: (Automation.Variant a0) => Prelude.String -> a0 -> IHTMLOpsProfile a -> Prelude.IO (Prelude.Int)
addRequest name reserved =
  Automation.function1 "addRequest" [Automation.inString name, Automation.inVariant reserved] Automation.outInt
clearRequest :: IHTMLOpsProfile a -> Prelude.IO ()
clearRequest = Automation.method0 "clearRequest" []
doRequest :: (Automation.Variant a0, Automation.Variant a1, Automation.Variant a2) => a0 -> a1 -> a2 -> IHTMLOpsProfile a -> Prelude.IO ()
doRequest usage fname reserved =
  Automation.method0 "doRequest" [Automation.inVariant usage, Automation.inVariant fname, Automation.inVariant reserved]
getAttribute41 :: Prelude.String -> IHTMLOpsProfile a -> Prelude.IO (Prelude.String)
getAttribute41 name =
  Automation.function1 "getAttribute" [Automation.inString name] Automation.outString
setAttribute41 :: Prelude.String -> Prelude.String -> IHTMLOpsProfile a -> Prelude.IO (Prelude.Int)
setAttribute41 name value =
  Automation.function1 "setAttribute" [Automation.inString name, Automation.inString value] Automation.outInt
commitChanges :: IHTMLOpsProfile a -> Prelude.IO (Prelude.Int)
commitChanges =
  Automation.function1 "commitChanges" [] Automation.outInt
-- --------------------------------------------------
-- 
-- interface IOmNavigator
-- 
-- --------------------------------------------------
data OmNavigator a = OmNavigator
                      
type IOmNavigator a = Automation.IDispatch (OmNavigator a)
iidOmNavigator :: Com.IID (IOmNavigator Automation.Interface)
iidOmNavigator = Com.mkIID "{FECEAAA5-8405-11cf-8BA1-00AA00476DA6}"
getAppCodeName :: IOmNavigator a -> Prelude.IO (Prelude.String)
getAppCodeName =
  Automation.propertyGet "appCodeName" [] Automation.outString
getAppName :: IOmNavigator a -> Prelude.IO (Prelude.String)
getAppName =
  Automation.propertyGet "appName" [] Automation.outString
getAppVersion :: IOmNavigator a -> Prelude.IO (Prelude.String)
getAppVersion =
  Automation.propertyGet "appVersion" [] Automation.outString
getUserAgent :: IOmNavigator a -> Prelude.IO (Prelude.String)
getUserAgent =
  Automation.propertyGet "userAgent" [] Automation.outString
javaEnabled :: IOmNavigator a -> Prelude.IO (Prelude.Int)
javaEnabled =
  Automation.function1 "javaEnabled" [] Automation.outInt
taintEnabled :: IOmNavigator a -> Prelude.IO (Prelude.Int)
taintEnabled =
  Automation.function1 "taintEnabled" [] Automation.outInt
getMimeTypes :: IOmNavigator a -> Prelude.IO (IHTMLMimeTypesCollection Automation.Interface)
getMimeTypes =
  Automation.propertyGet "mimeTypes" [] Automation.outIDispatch
getPlugins :: IOmNavigator a -> Prelude.IO (IHTMLPluginsCollection Automation.Interface)
getPlugins =
  Automation.propertyGet "plugins" [] Automation.outIDispatch
getCookieEnabled :: IOmNavigator a -> Prelude.IO (Prelude.Int)
getCookieEnabled =
  Automation.propertyGet "cookieEnabled" [] Automation.outInt
getOpsProfile :: IOmNavigator a -> Prelude.IO (IHTMLOpsProfile Automation.Interface)
getOpsProfile =
  Automation.propertyGet "opsProfile" [] Automation.outIDispatch
-- --------------------------------------------------
-- 
-- interface IHTMLLocation
-- 
-- --------------------------------------------------
data HTMLLocation a = HTMLLocation
                       
type IHTMLLocation a = Automation.IDispatch (HTMLLocation a)
iidHTMLLocation :: Com.IID (IHTMLLocation Automation.Interface)
iidHTMLLocation =
  Com.mkIID "{163BB1E0-6E00-11cf-837A-48DC04C10000}"
reload :: Prelude.Int -> IHTMLLocation a -> Prelude.IO ()
reload flag = Automation.method0 "reload" [Automation.inInt flag]
replace :: Prelude.String -> IHTMLLocation a -> Prelude.IO ()
replace bstr =
  Automation.method0 "replace" [Automation.inString bstr]
assign :: Prelude.String -> IHTMLLocation a -> Prelude.IO ()
assign bstr =
  Automation.method0 "assign" [Automation.inString bstr]
-- --------------------------------------------------
-- 
-- coclass HTMLHistory
-- 
-- --------------------------------------------------
clsidHTMLHistory :: Com.CLSID
clsidHTMLHistory =
  Com.mkCLSID "{FECEAAA3-8405-11cf-8BA1-00AA00476DA6}"
-- --------------------------------------------------
-- 
-- coclass CMimeTypes
-- 
-- --------------------------------------------------
clsidCMimeTypes :: Com.CLSID
clsidCMimeTypes =
  Com.mkCLSID "{3050f3fe-98b5-11cf-bb82-00aa00bdce0b}"
-- --------------------------------------------------
-- 
-- coclass CPlugins
-- 
-- --------------------------------------------------
clsidCPlugins :: Com.CLSID
clsidCPlugins =
  Com.mkCLSID "{3050f3ff-98b5-11cf-bb82-00aa00bdce0b}"
-- --------------------------------------------------
-- 
-- coclass COpsProfile
-- 
-- --------------------------------------------------
clsidCOpsProfile :: Com.CLSID
clsidCOpsProfile =
  Com.mkCLSID "{3050f402-98b5-11cf-bb82-00aa00bdce0b}"
-- --------------------------------------------------
-- 
-- coclass HTMLNavigator
-- 
-- --------------------------------------------------
clsidHTMLNavigator :: Com.CLSID
clsidHTMLNavigator =
  Com.mkCLSID "{FECEAAA6-8405-11cf-8BA1-00AA00476DA6}"
-- --------------------------------------------------
-- 
-- coclass HTMLLocation
-- 
-- --------------------------------------------------
clsidHTMLLocation :: Com.CLSID
clsidHTMLLocation =
  Com.mkCLSID "{163BB1E1-6E00-11cf-837A-48DC04C10000}"
-- --------------------------------------------------
-- 
-- dispinterface HTMLWindowEvents
-- 
-- --------------------------------------------------
data HTMLWindowEvents a = HTMLWindowEvents
                           
type IHTMLWindowEvents a = Automation.IDispatch (HTMLWindowEvents a)
iidHTMLWindowEvents :: Com.IID (IHTMLWindowEvents Automation.Interface)
iidHTMLWindowEvents =
  Com.mkIID "{96A0A4E0-D062-11cf-94B6-00AA0060275C}"
onunload :: IHTMLWindowEvents a -> Prelude.IO ()
onunload = Automation.method0 "onunload" []
onbeforeunload :: IHTMLWindowEvents a -> Prelude.IO ()
onbeforeunload = Automation.method0 "onbeforeunload" []
-- --------------------------------------------------
-- 
-- interface IHTMLEventObj
-- 
-- --------------------------------------------------
data HTMLEventObj a = HTMLEventObj
                       
type IHTMLEventObj a = Automation.IDispatch (HTMLEventObj a)
iidHTMLEventObj :: Com.IID (IHTMLEventObj Automation.Interface)
iidHTMLEventObj =
  Com.mkIID "{3050f32d-98b5-11cf-bb82-00aa00bdce0b}"
getSrcElement :: IHTMLEventObj a -> Prelude.IO (IHTMLElement Automation.Interface)
getSrcElement =
  Automation.propertyGet "srcElement" [] Automation.outIDispatch
getAltKey :: IHTMLEventObj a -> Prelude.IO (Prelude.Int)
getAltKey = Automation.propertyGet "altKey" [] Automation.outInt
getCtrlKey :: IHTMLEventObj a -> Prelude.IO (Prelude.Int)
getCtrlKey = Automation.propertyGet "ctrlKey" [] Automation.outInt
getShiftKey :: IHTMLEventObj a -> Prelude.IO (Prelude.Int)
getShiftKey =
  Automation.propertyGet "shiftKey" [] Automation.outInt
setReturnValue :: (Automation.Variant a0) => a0 -> Automation.IDispatch a -> Prelude.IO ()
setReturnValue v =
  Automation.propertySet "returnValue" [Automation.inVariant v]
getReturnValue :: (Automation.Variant a0) => Automation.IDispatch a -> Prelude.IO (a0)
getReturnValue =
  Automation.propertyGet "returnValue" [] Automation.outVariant
setCancelBubble :: Prelude.Int -> IHTMLEventObj a -> Prelude.IO ()
setCancelBubble v =
  Automation.propertySet "cancelBubble" [Automation.inInt v]
getCancelBubble :: IHTMLEventObj a -> Prelude.IO (Prelude.Int)
getCancelBubble =
  Automation.propertyGet "cancelBubble" [] Automation.outInt
getFromElement :: IHTMLEventObj a -> Prelude.IO (IHTMLElement Automation.Interface)
getFromElement =
  Automation.propertyGet "fromElement" [] Automation.outIDispatch
getToElement :: IHTMLEventObj a -> Prelude.IO (IHTMLElement Automation.Interface)
getToElement =
  Automation.propertyGet "toElement" [] Automation.outIDispatch
setKeyCode :: Prelude.Int -> IHTMLEventObj a -> Prelude.IO ()
setKeyCode v =
  Automation.propertySet "keyCode" [Automation.inInt v]
getKeyCode :: IHTMLEventObj a -> Prelude.IO (Prelude.Int)
getKeyCode = Automation.propertyGet "keyCode" [] Automation.outInt
getButton :: IHTMLEventObj a -> Prelude.IO (Prelude.Int)
getButton = Automation.propertyGet "button" [] Automation.outInt
getQualifier :: IHTMLEventObj a -> Prelude.IO (Prelude.String)
getQualifier =
  Automation.propertyGet "qualifier" [] Automation.outString
getReason :: IHTMLEventObj a -> Prelude.IO (Prelude.Int)
getReason = Automation.propertyGet "reason" [] Automation.outInt
getX :: IHTMLEventObj a -> Prelude.IO (Prelude.Int)
getX = Automation.propertyGet "x" [] Automation.outInt
getY :: IHTMLEventObj a -> Prelude.IO (Prelude.Int)
getY = Automation.propertyGet "y" [] Automation.outInt
getClientX :: IHTMLEventObj a -> Prelude.IO (Prelude.Int)
getClientX = Automation.propertyGet "clientX" [] Automation.outInt
getClientY :: IHTMLEventObj a -> Prelude.IO (Prelude.Int)
getClientY = Automation.propertyGet "clientY" [] Automation.outInt
getOffsetX :: IHTMLEventObj a -> Prelude.IO (Prelude.Int)
getOffsetX = Automation.propertyGet "offsetX" [] Automation.outInt
getOffsetY :: IHTMLEventObj a -> Prelude.IO (Prelude.Int)
getOffsetY = Automation.propertyGet "offsetY" [] Automation.outInt
getScreenX :: IHTMLEventObj a -> Prelude.IO (Prelude.Int)
getScreenX = Automation.propertyGet "screenX" [] Automation.outInt
getScreenY :: IHTMLEventObj a -> Prelude.IO (Prelude.Int)
getScreenY = Automation.propertyGet "screenY" [] Automation.outInt
getSrcFilter :: IHTMLEventObj a -> Prelude.IO (Prelude.String)
getSrcFilter =
  Automation.propertyGet "srcFilter" [] Automation.outString
-- --------------------------------------------------
-- 
-- interface IHTMLFramesCollection2
-- 
-- --------------------------------------------------
data HTMLFramesCollection2 a = HTMLFramesCollection2
                                
type IHTMLFramesCollection2 a = Automation.IDispatch (HTMLFramesCollection2 a)
iidHTMLFramesCollection2 :: Com.IID (IHTMLFramesCollection2 Automation.Interface)
iidHTMLFramesCollection2 =
  Com.mkIID "{332c4426-26cb-11d0-b483-00c04fd90119}"
-- --------------------------------------------------
-- 
-- interface IHTMLScreen
-- 
-- --------------------------------------------------
data HTMLScreen a = HTMLScreen
                     
type IHTMLScreen a = Automation.IDispatch (HTMLScreen a)
iidHTMLScreen :: Com.IID (IHTMLScreen Automation.Interface)
iidHTMLScreen = Com.mkIID "{3050f35c-98b5-11cf-bb82-00aa00bdce0b}"
getColorDepth :: IHTMLScreen a -> Prelude.IO (Prelude.Int)
getColorDepth =
  Automation.propertyGet "colorDepth" [] Automation.outInt
setBufferDepth :: Prelude.Int -> IHTMLScreen a -> Prelude.IO ()
setBufferDepth v =
  Automation.propertySet "bufferDepth" [Automation.inInt v]
getBufferDepth :: IHTMLScreen a -> Prelude.IO (Prelude.Int)
getBufferDepth =
  Automation.propertyGet "bufferDepth" [] Automation.outInt
setUpdateInterval :: Prelude.Int -> IHTMLScreen a -> Prelude.IO ()
setUpdateInterval v =
  Automation.propertySet "updateInterval" [Automation.inInt v]
getUpdateInterval :: IHTMLScreen a -> Prelude.IO (Prelude.Int)
getUpdateInterval =
  Automation.propertyGet "updateInterval" [] Automation.outInt
-- --------------------------------------------------
-- 
-- interface IHTMLWindow2
-- 
-- --------------------------------------------------
data HTMLWindow2 a = HTMLWindow2
                      
type IHTMLWindow2 a = IHTMLFramesCollection2 (HTMLWindow2 a)
iidHTMLWindow2 :: Com.IID (IHTMLWindow2 Automation.Interface)
iidHTMLWindow2 = Com.mkIID "{332c4427-26cb-11d0-b483-00c04fd90119}"
getFrames :: Automation.IDispatch a -> Prelude.IO (IHTMLFramesCollection2 Automation.Interface)
getFrames =
  Automation.propertyGet "frames" [] Automation.outIDispatch
setDefaultStatus :: Prelude.String -> IHTMLWindow2 a -> Prelude.IO ()
setDefaultStatus v =
  Automation.propertySet "defaultStatus" [Automation.inString v]
getDefaultStatus :: IHTMLWindow2 a -> Prelude.IO (Prelude.String)
getDefaultStatus =
  Automation.propertyGet "defaultStatus" [] Automation.outString
setStatus12 :: Prelude.String -> IHTMLWindow2 a -> Prelude.IO ()
setStatus12 v =
  Automation.propertySet "status" [Automation.inString v]
getStatus12 :: IHTMLWindow2 a -> Prelude.IO (Prelude.String)
getStatus12 =
  Automation.propertyGet "status" [] Automation.outString

{-CHANGED Daan Leijen-}
setTimeout expr msec
            = setTimeout' expr msec "HaskellScript"
setTimeout' :: (Automation.Variant a0) => Prelude.String -> Prelude.Int -> a0 -> IHTMLWindow2 a -> Prelude.IO (Prelude.Int)
setTimeout' expression msec language =
  Automation.function1 "setTimeout" [Automation.inString expression, Automation.inInt msec, Automation.inVariant language] Automation.outInt

clearTimeout :: Prelude.Int -> IHTMLWindow2 a -> Prelude.IO ()
clearTimeout timerID =
  Automation.method0 "clearTimeout" [Automation.inInt timerID]
alert :: Prelude.String -> IHTMLWindow2 a -> Prelude.IO ()
alert message =
  Automation.method0 "alert" [Automation.inString message]
confirm :: Prelude.String -> IHTMLWindow2 a -> Prelude.IO (Prelude.Bool)
confirm message =
  Automation.function1 "confirm" [Automation.inString message] Automation.outBool
prompt :: (Automation.Variant a0) => Prelude.String -> Prelude.String -> Automation.IDispatch a -> Prelude.IO (a0)
prompt message defstr =
  Automation.function1 "prompt" [Automation.inString message, Automation.inString defstr] Automation.outVariant
getImage :: IHTMLWindow2 a -> Prelude.IO (IHTMLImageElementFactory Automation.Interface)
getImage =
  Automation.propertyGet "Image" [] Automation.outIDispatch
getLocation :: Automation.IDispatch a -> Prelude.IO (IHTMLLocation Automation.Interface)
getLocation =
  Automation.propertyGet "location" [] Automation.outIDispatch
getHistory :: IHTMLWindow2 a -> Prelude.IO (IOmHistory Automation.Interface)
getHistory =
  Automation.propertyGet "history" [] Automation.outIDispatch
close :: Automation.IDispatch a -> Prelude.IO ()
close = Automation.method0 "close" []
setOpener :: (Automation.Variant a0) => a0 -> IHTMLWindow2 a -> Prelude.IO ()
setOpener v =
  Automation.propertySet "opener" [Automation.inVariant v]
getOpener :: (Automation.Variant a0) => IHTMLWindow2 a -> Prelude.IO (a0)
getOpener =
  Automation.propertyGet "opener" [] Automation.outVariant
getNavigator :: IHTMLWindow2 a -> Prelude.IO (IOmNavigator Automation.Interface)
getNavigator =
  Automation.propertyGet "navigator" [] Automation.outIDispatch
getParent :: IHTMLWindow2 a -> Prelude.IO (IHTMLWindow2 Automation.Interface)
getParent =
  Automation.propertyGet "parent" [] Automation.outIDispatch
open :: Prelude.String -> Prelude.String -> Prelude.String -> Prelude.Int -> IHTMLWindow2 a -> Prelude.IO (IHTMLWindow2 Automation.Interface)
open url name features replace =
  Automation.function1 "open" [Automation.inString url, Automation.inString name, Automation.inString features, Automation.inInt replace] Automation.outIDispatch
getSelf :: IHTMLWindow2 a -> Prelude.IO (IHTMLWindow2 Automation.Interface)
getSelf = Automation.propertyGet "self" [] Automation.outIDispatch
getTop0 :: IHTMLWindow2 a -> Prelude.IO (IHTMLWindow2 Automation.Interface)
getTop0 = Automation.propertyGet "top" [] Automation.outIDispatch
getWindow :: IHTMLWindow2 a -> Prelude.IO (IHTMLWindow2 Automation.Interface)
getWindow =
  Automation.propertyGet "window" [] Automation.outIDispatch
navigate :: Prelude.String -> IHTMLWindow2 a -> Prelude.IO ()
navigate url =
  Automation.method0 "navigate" [Automation.inString url]
getDocument40 :: Automation.IDispatch a -> Prelude.IO (IHTMLDocument2 Automation.Interface)
getDocument40 =
  Automation.propertyGet "document" [] Automation.outIDispatch
getEvent :: IHTMLWindow2 a -> Prelude.IO (IHTMLEventObj Automation.Interface)
getEvent =
  Automation.propertyGet "event" [] Automation.outIDispatch
showModalDialog :: (Automation.Variant a0, Automation.Variant a1, Automation.Variant a2) => Prelude.String -> a0 -> a1 -> IHTMLWindow2 a -> Prelude.IO (a2)
showModalDialog dialog varArgIn varOptions =
  Automation.function1 "showModalDialog" [Automation.inString dialog, Automation.inVariant varArgIn, Automation.inVariant varOptions] Automation.outVariant
showHelp :: (Automation.Variant a0) => Prelude.String -> a0 -> Prelude.String -> IHTMLWindow2 a -> Prelude.IO ()
showHelp helpURL helpArg features =
  Automation.method0 "showHelp" [Automation.inString helpURL, Automation.inVariant helpArg, Automation.inString features]
getScreen :: IHTMLWindow2 a -> Prelude.IO (IHTMLScreen Automation.Interface)
getScreen =
  Automation.propertyGet "screen" [] Automation.outIDispatch
getOption :: IHTMLWindow2 a -> Prelude.IO (IHTMLOptionElementFactory Automation.Interface)
getOption =
  Automation.propertyGet "Option" [] Automation.outIDispatch
getClosed :: IHTMLWindow2 a -> Prelude.IO (Prelude.Int)
getClosed = Automation.propertyGet "closed" [] Automation.outInt
scroll :: Prelude.Int -> Prelude.Int -> IHTMLWindow2 a -> Prelude.IO ()
scroll x y =
  Automation.method0 "scroll" [Automation.inInt x, Automation.inInt y]
getClient :: IHTMLWindow2 a -> Prelude.IO (IOmNavigator Automation.Interface)
getClient =
  Automation.propertyGet "client" [] Automation.outIDispatch

{- CHANGED Daan Leijen  -}
setInterval expr msec
            = setInterval' expr msec "HaskellScript"
            
setInterval' :: (Automation.Variant a0) => Prelude.String -> Prelude.Int -> a0 -> IHTMLWindow2 a -> Prelude.IO (Prelude.Int)
setInterval' expression msec language =
  Automation.function1 "setInterval" [Automation.inString expression, Automation.inInt msec, Automation.inVariant language] Automation.outInt


clearInterval :: Prelude.Int -> IHTMLWindow2 a -> Prelude.IO ()
clearInterval timerID =
  Automation.method0 "clearInterval" [Automation.inInt timerID]
setOffscreenBuffering :: (Automation.Variant a0) => a0 -> IHTMLWindow2 a -> Prelude.IO ()
setOffscreenBuffering v =
  Automation.propertySet "offscreenBuffering" [Automation.inVariant v]
getOffscreenBuffering :: (Automation.Variant a0) => IHTMLWindow2 a -> Prelude.IO (a0)
getOffscreenBuffering =
  Automation.propertyGet "offscreenBuffering" [] Automation.outVariant
execScript :: (Automation.Variant a0) => Prelude.String -> Prelude.String -> IHTMLWindow2 a -> Prelude.IO (a0)
execScript code language =
  Automation.function1 "execScript" [Automation.inString code, Automation.inString language] Automation.outVariant
-- --------------------------------------------------
-- 
-- coclass HTMLScreen
-- 
-- --------------------------------------------------
clsidHTMLScreen :: Com.CLSID
clsidHTMLScreen =
  Com.mkCLSID "{3050f35d-98b5-11cf-bb82-00aa00bdce0b}"
-- --------------------------------------------------
-- 
-- coclass HTMLWindow2
-- 
-- --------------------------------------------------
clsidHTMLWindow2 :: Com.CLSID
clsidHTMLWindow2 =
  Com.mkCLSID "{D48A6EC6-6A4A-11cf-94A7-444553540000}"
-- --------------------------------------------------
-- 
-- coclass HTMLWindowProxy
-- 
-- --------------------------------------------------
clsidHTMLWindowProxy :: Com.CLSID
clsidHTMLWindowProxy =
  Com.mkCLSID "{3050f391-98b5-11cf-bb82-00aa00bdce0b}"
-- --------------------------------------------------
-- 
-- dispinterface HTMLDocumentEvents
-- 
-- --------------------------------------------------
data HTMLDocumentEvents a = HTMLDocumentEvents
                             
type IHTMLDocumentEvents a = Automation.IDispatch (HTMLDocumentEvents a)
iidHTMLDocumentEvents :: Com.IID (IHTMLDocumentEvents Automation.Interface)
iidHTMLDocumentEvents =
  Com.mkIID "{3050f260-98b5-11cf-bb82-00aa00bdce0b}"
onkeydown14 :: Prelude.Int -> Automation.IDispatch a -> Prelude.IO ()
onkeydown14 shift =
  Automation.method0 "onkeydown" [Automation.inInt shift]
onkeyup14 :: Prelude.Int -> Automation.IDispatch a -> Prelude.IO ()
onkeyup14 shift =
  Automation.method0 "onkeyup" [Automation.inInt shift]
onmousedown14 :: Prelude.Int -> Prelude.Int -> Prelude.Float -> Prelude.Float -> Automation.IDispatch a -> Prelude.IO ()
onmousedown14 button shift x y =
  Automation.method0 "onmousedown" [Automation.inInt button, Automation.inInt shift, Automation.inFloat x, Automation.inFloat y]
onmousemove14 :: Prelude.Int -> Prelude.Int -> Prelude.Float -> Prelude.Float -> Automation.IDispatch a -> Prelude.IO ()
onmousemove14 button shift x y =
  Automation.method0 "onmousemove" [Automation.inInt button, Automation.inInt shift, Automation.inFloat x, Automation.inFloat y]
onmouseup14 :: Prelude.Int -> Prelude.Int -> Prelude.Float -> Prelude.Float -> Automation.IDispatch a -> Prelude.IO ()
onmouseup14 button shift x y =
  Automation.method0 "onmouseup" [Automation.inInt button, Automation.inInt shift, Automation.inFloat x, Automation.inFloat y]
-- --------------------------------------------------
-- 
-- interface IHTMLDocument
-- 
-- --------------------------------------------------
data HTMLDocument a = HTMLDocument
                       
type IHTMLDocument a = Automation.IDispatch (HTMLDocument a)
iidHTMLDocument :: Com.IID (IHTMLDocument Automation.Interface)
iidHTMLDocument =
  Com.mkIID "{626FC520-A41E-11cf-A731-00A0C9082637}"
getScript :: Automation.IDispatch a -> Prelude.IO (Automation.IDispatch Automation.Interface)
getScript =
  Automation.propertyGet "Script" [] Automation.outIDispatch
-- --------------------------------------------------
-- 
-- interface IHTMLDocument2
-- 
-- --------------------------------------------------
data HTMLDocument2 a = HTMLDocument2
                        
type IHTMLDocument2 a = IHTMLDocument (HTMLDocument2 a)
iidHTMLDocument2 :: Com.IID (IHTMLDocument2 Automation.Interface)
iidHTMLDocument2 =
  Com.mkIID "{332c4425-26cb-11d0-b483-00c04fd90119}"
getAll :: IHTMLDocument2 a -> Prelude.IO (IHTMLElementCollection Automation.Interface)
getAll = Automation.propertyGet "all" [] Automation.outIDispatch
getBody :: IHTMLDocument2 a -> Prelude.IO (IHTMLElement Automation.Interface)
getBody = Automation.propertyGet "body" [] Automation.outIDispatch
getActiveElement :: IHTMLDocument2 a -> Prelude.IO (IHTMLElement Automation.Interface)
getActiveElement =
  Automation.propertyGet "activeElement" [] Automation.outIDispatch
getImages :: IHTMLDocument2 a -> Prelude.IO (IHTMLElementCollection Automation.Interface)
getImages =
  Automation.propertyGet "images" [] Automation.outIDispatch
getApplets :: IHTMLDocument2 a -> Prelude.IO (IHTMLElementCollection Automation.Interface)
getApplets =
  Automation.propertyGet "applets" [] Automation.outIDispatch
getLinks :: IHTMLDocument2 a -> Prelude.IO (IHTMLElementCollection Automation.Interface)
getLinks =
  Automation.propertyGet "links" [] Automation.outIDispatch
getForms :: IHTMLDocument2 a -> Prelude.IO (IHTMLElementCollection Automation.Interface)
getForms =
  Automation.propertyGet "forms" [] Automation.outIDispatch
getAnchors :: IHTMLDocument2 a -> Prelude.IO (IHTMLElementCollection Automation.Interface)
getAnchors =
  Automation.propertyGet "anchors" [] Automation.outIDispatch
getScripts :: IHTMLDocument2 a -> Prelude.IO (IHTMLElementCollection Automation.Interface)
getScripts =
  Automation.propertyGet "scripts" [] Automation.outIDispatch
setDesignMode :: Prelude.String -> IHTMLDocument2 a -> Prelude.IO ()
setDesignMode v =
  Automation.propertySet "designMode" [Automation.inString v]
getDesignMode :: IHTMLDocument2 a -> Prelude.IO (Prelude.String)
getDesignMode =
  Automation.propertyGet "designMode" [] Automation.outString
getSelection :: IHTMLDocument2 a -> Prelude.IO (IHTMLSelectionObject Automation.Interface)
getSelection =
  Automation.propertyGet "selection" [] Automation.outIDispatch
getEmbeds :: IHTMLDocument2 a -> Prelude.IO (IHTMLElementCollection Automation.Interface)
getEmbeds =
  Automation.propertyGet "embeds" [] Automation.outIDispatch
getPlugins0 :: IHTMLDocument2 a -> Prelude.IO (IHTMLElementCollection Automation.Interface)
getPlugins0 =
  Automation.propertyGet "plugins" [] Automation.outIDispatch
setAlinkColor :: (Automation.Variant a0) => a0 -> IHTMLDocument2 a -> Prelude.IO ()
setAlinkColor v =
  Automation.propertySet "alinkColor" [Automation.inVariant v]
getAlinkColor :: (Automation.Variant a0) => IHTMLDocument2 a -> Prelude.IO (a0)
getAlinkColor =
  Automation.propertyGet "alinkColor" [] Automation.outVariant
setFgColor :: (Automation.Variant a0) => a0 -> IHTMLDocument2 a -> Prelude.IO ()
setFgColor v =
  Automation.propertySet "fgColor" [Automation.inVariant v]
getFgColor :: (Automation.Variant a0) => IHTMLDocument2 a -> Prelude.IO (a0)
getFgColor =
  Automation.propertyGet "fgColor" [] Automation.outVariant
setLinkColor :: (Automation.Variant a0) => a0 -> IHTMLDocument2 a -> Prelude.IO ()
setLinkColor v =
  Automation.propertySet "linkColor" [Automation.inVariant v]
getLinkColor :: (Automation.Variant a0) => IHTMLDocument2 a -> Prelude.IO (a0)
getLinkColor =
  Automation.propertyGet "linkColor" [] Automation.outVariant
setVlinkColor :: (Automation.Variant a0) => a0 -> IHTMLDocument2 a -> Prelude.IO ()
setVlinkColor v =
  Automation.propertySet "vlinkColor" [Automation.inVariant v]
getVlinkColor :: (Automation.Variant a0) => IHTMLDocument2 a -> Prelude.IO (a0)
getVlinkColor =
  Automation.propertyGet "vlinkColor" [] Automation.outVariant
getReferrer :: IHTMLDocument2 a -> Prelude.IO (Prelude.String)
getReferrer =
  Automation.propertyGet "referrer" [] Automation.outString
getLastModified :: IHTMLDocument2 a -> Prelude.IO (Prelude.String)
getLastModified =
  Automation.propertyGet "lastModified" [] Automation.outString
setURL :: Prelude.String -> IHTMLDocument2 a -> Prelude.IO ()
setURL v = Automation.propertySet "URL" [Automation.inString v]
getURL :: IHTMLDocument2 a -> Prelude.IO (Prelude.String)
getURL = Automation.propertyGet "URL" [] Automation.outString
setDomain :: Prelude.String -> IHTMLDocument2 a -> Prelude.IO ()
setDomain v =
  Automation.propertySet "domain" [Automation.inString v]
getDomain :: IHTMLDocument2 a -> Prelude.IO (Prelude.String)
getDomain = Automation.propertyGet "domain" [] Automation.outString
setCookie :: Prelude.String -> IHTMLDocument2 a -> Prelude.IO ()
setCookie v =
  Automation.propertySet "cookie" [Automation.inString v]
getCookie :: IHTMLDocument2 a -> Prelude.IO (Prelude.String)
getCookie = Automation.propertyGet "cookie" [] Automation.outString
setExpando :: Prelude.Int -> IHTMLDocument2 a -> Prelude.IO ()
setExpando v =
  Automation.propertySet "expando" [Automation.inInt v]
getExpando :: IHTMLDocument2 a -> Prelude.IO (Prelude.Int)
getExpando = Automation.propertyGet "expando" [] Automation.outInt
setDefaultCharset :: Prelude.String -> IHTMLDocument2 a -> Prelude.IO ()
setDefaultCharset v =
  Automation.propertySet "defaultCharset" [Automation.inString v]
getDefaultCharset :: IHTMLDocument2 a -> Prelude.IO (Prelude.String)
getDefaultCharset =
  Automation.propertyGet "defaultCharset" [] Automation.outString
getSecurity :: IHTMLDocument2 a -> Prelude.IO (Prelude.String)
getSecurity =
  Automation.propertyGet "security" [] Automation.outString
  
write :: Prelude.String -> IHTMLDocument2 a -> Prelude.IO ()
write psarray =
  Automation.method0 "write" [Automation.inString psarray]
writeln :: Prelude.String -> IHTMLDocument2 a -> Prelude.IO ()
writeln psarray =
  Automation.method0 "writeln" [Automation.inString psarray]
  
open0 :: (Automation.Variant a0, Automation.Variant a1, Automation.Variant a2) => Prelude.String -> a0 -> a1 -> a2 -> IHTMLDocument2 a -> Prelude.IO (Automation.IDispatch Automation.Interface)
open0 url name features replace =
  Automation.function1 "open" [Automation.inString url, Automation.inVariant name, Automation.inVariant features, Automation.inVariant replace] Automation.outIDispatch
createElement :: Prelude.String -> IHTMLDocument2 a -> Prelude.IO (IHTMLElement Automation.Interface)
createElement eTag =
  Automation.function1 "createElement" [Automation.inString eTag] Automation.outIDispatch
elementFromPoint :: Prelude.Int -> Prelude.Int -> IHTMLDocument2 a -> Prelude.IO (IHTMLElement Automation.Interface)
elementFromPoint x y =
  Automation.function1 "elementFromPoint" [Automation.inInt x, Automation.inInt y] Automation.outIDispatch
getParentWindow :: IHTMLDocument2 a -> Prelude.IO (IHTMLWindow2 Automation.Interface)
getParentWindow =
  Automation.propertyGet "parentWindow" [] Automation.outIDispatch
getStyleSheets :: IHTMLDocument2 a -> Prelude.IO (IHTMLStyleSheetsCollection Automation.Interface)
getStyleSheets =
  Automation.propertyGet "styleSheets" [] Automation.outIDispatch
-- --------------------------------------------------
-- 
-- coclass HTMLDocument
-- 
-- --------------------------------------------------
clsidHTMLDocument :: Com.CLSID
clsidHTMLDocument =
  Com.mkCLSID "{25336920-03F9-11cf-8FD0-00AA00686F13}"
-- --------------------------------------------------
-- 
-- interface IHTMLEmbedElement
-- 
-- --------------------------------------------------
data HTMLEmbedElement a = HTMLEmbedElement
                           
type IHTMLEmbedElement a = Automation.IDispatch (HTMLEmbedElement a)
iidHTMLEmbedElement :: Com.IID (IHTMLEmbedElement Automation.Interface)
iidHTMLEmbedElement =
  Com.mkIID "{3050f25f-98b5-11cf-bb82-00aa00bdce0b}"
setHidden :: Prelude.Int -> Automation.IDispatch a -> Prelude.IO ()
setHidden v = Automation.propertySet "hidden" [Automation.inInt v]
getHidden :: Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getHidden = Automation.propertyGet "hidden" [] Automation.outInt
setPalette :: Prelude.String -> Automation.IDispatch a -> Prelude.IO ()
setPalette v =
  Automation.propertySet "palette" [Automation.inString v]
getPalette :: Automation.IDispatch a -> Prelude.IO (Prelude.String)
getPalette =
  Automation.propertyGet "palette" [] Automation.outString
setPluginspage :: Prelude.String -> Automation.IDispatch a -> Prelude.IO ()
setPluginspage v =
  Automation.propertySet "pluginspage" [Automation.inString v]
getPluginspage :: Automation.IDispatch a -> Prelude.IO (Prelude.String)
getPluginspage =
  Automation.propertyGet "pluginspage" [] Automation.outString
setUnits :: Prelude.String -> Automation.IDispatch a -> Prelude.IO ()
setUnits v = Automation.propertySet "units" [Automation.inString v]
getUnits :: Automation.IDispatch a -> Prelude.IO (Prelude.String)
getUnits = Automation.propertyGet "units" [] Automation.outString
setCodeBase :: Prelude.String -> Automation.IDispatch a -> Prelude.IO ()
setCodeBase v =
  Automation.propertySet "codeBase" [Automation.inString v]
getCodeBase :: Automation.IDispatch a -> Prelude.IO (Prelude.String)
getCodeBase =
  Automation.propertyGet "codeBase" [] Automation.outString
getBaseHref :: Automation.IDispatch a -> Prelude.IO (Prelude.String)
getBaseHref =
  Automation.propertyGet "BaseHref" [] Automation.outString
-- --------------------------------------------------
-- 
-- dispinterface DispIHTMLEmbedElement
-- 
-- --------------------------------------------------

                            
type DispIHTMLEmbedElement a = Automation.IDispatch (HTMLEmbedElement a)
iidIHTMLEmbedElement :: Com.IID (DispIHTMLEmbedElement Automation.Interface)
iidIHTMLEmbedElement =
  Com.mkIID "{3050f52e-98b5-11cf-bb82-00aa00bdce0b}"
-- --------------------------------------------------
-- 
-- coclass HTMLEmbed
-- 
-- --------------------------------------------------
clsidHTMLEmbed :: Com.CLSID
clsidHTMLEmbed =
  Com.mkCLSID "{3050f25d-98b5-11cf-bb82-00aa00bdce0b}"
-- --------------------------------------------------
-- 
-- dispinterface HTMLMapEvents
-- 
-- --------------------------------------------------
data HTMLMapEvents a = HTMLMapEvents
                        
type IHTMLMapEvents a = Automation.IDispatch (HTMLMapEvents a)
iidHTMLMapEvents :: Com.IID (IHTMLMapEvents Automation.Interface)
iidHTMLMapEvents =
  Com.mkIID "{3050f3ba-98b5-11cf-bb82-00aa00bdce0b}"
-- --------------------------------------------------
-- 
-- interface IHTMLAreasCollection
-- 
-- --------------------------------------------------
data HTMLAreasCollection a = HTMLAreasCollection
                              
type IHTMLAreasCollection a = Automation.IDispatch (HTMLAreasCollection a)
iidHTMLAreasCollection :: Com.IID (IHTMLAreasCollection Automation.Interface)
iidHTMLAreasCollection =
  Com.mkIID "{3050f383-98b5-11cf-bb82-00aa00bdce0b}"
-- --------------------------------------------------
-- 
-- interface IHTMLMapElement
-- 
-- --------------------------------------------------
data HTMLMapElement a = HTMLMapElement
                         
type IHTMLMapElement a = Automation.IDispatch (HTMLMapElement a)
iidHTMLMapElement :: Com.IID (IHTMLMapElement Automation.Interface)
iidHTMLMapElement =
  Com.mkIID "{3050f266-98b5-11cf-bb82-00aa00bdce0b}"
getAreas :: Automation.IDispatch a -> Prelude.IO (IHTMLAreasCollection Automation.Interface)
getAreas =
  Automation.propertyGet "areas" [] Automation.outIDispatch
-- --------------------------------------------------
-- 
-- dispinterface DispIHTMLMapElement
-- 
-- --------------------------------------------------

                          
type DispIHTMLMapElement a = Automation.IDispatch (HTMLMapElement a)
iidIHTMLMapElement :: Com.IID (DispIHTMLMapElement Automation.Interface)
iidIHTMLMapElement =
  Com.mkIID "{3050f526-98b5-11cf-bb82-00aa00bdce0b}"
-- --------------------------------------------------
-- 
-- coclass HTMLMapElement
-- 
-- --------------------------------------------------
clsidHTMLMapElement :: Com.CLSID
clsidHTMLMapElement =
  Com.mkCLSID "{3050f271-98b5-11cf-bb82-00aa00bdce0b}"
-- --------------------------------------------------
-- 
-- dispinterface HTMLAreaEvents
-- 
-- --------------------------------------------------
data HTMLAreaEvents a = HTMLAreaEvents
                         
type IHTMLAreaEvents a = Automation.IDispatch (HTMLAreaEvents a)
iidHTMLAreaEvents :: Com.IID (IHTMLAreaEvents Automation.Interface)
iidHTMLAreaEvents =
  Com.mkIID "{3050f366-98b5-11cf-bb82-00aa00bdce0b}"
-- --------------------------------------------------
-- 
-- interface IHTMLAreaElement
-- 
-- --------------------------------------------------
data HTMLAreaElement a = HTMLAreaElement
                          
type IHTMLAreaElement a = Automation.IDispatch (HTMLAreaElement a)
iidHTMLAreaElement :: Com.IID (IHTMLAreaElement Automation.Interface)
iidHTMLAreaElement =
  Com.mkIID "{3050f265-98b5-11cf-bb82-00aa00bdce0b}"
setShape :: Prelude.String -> Automation.IDispatch a -> Prelude.IO ()
setShape v = Automation.propertySet "shape" [Automation.inString v]
getShape :: Automation.IDispatch a -> Prelude.IO (Prelude.String)
getShape = Automation.propertyGet "shape" [] Automation.outString
setCoords :: Prelude.String -> Automation.IDispatch a -> Prelude.IO ()
setCoords v =
  Automation.propertySet "coords" [Automation.inString v]
getCoords :: Automation.IDispatch a -> Prelude.IO (Prelude.String)
getCoords = Automation.propertyGet "coords" [] Automation.outString
setNoHref :: Prelude.Int -> Automation.IDispatch a -> Prelude.IO ()
setNoHref v = Automation.propertySet "noHref" [Automation.inInt v]
getNoHref :: Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getNoHref = Automation.propertyGet "noHref" [] Automation.outInt
-- --------------------------------------------------
-- 
-- dispinterface DispIHTMLAreaElement
-- 
-- --------------------------------------------------

                           
type DispIHTMLAreaElement a = Automation.IDispatch (HTMLAreaElement a)
iidIHTMLAreaElement :: Com.IID (DispIHTMLAreaElement Automation.Interface)
iidIHTMLAreaElement =
  Com.mkIID "{3050f503-98b5-11cf-bb82-00aa00bdce0b}"
-- --------------------------------------------------
-- 
-- coclass HTMLAreaElement
-- 
-- --------------------------------------------------
clsidHTMLAreaElement :: Com.CLSID
clsidHTMLAreaElement =
  Com.mkCLSID "{3050f283-98b5-11cf-bb82-00aa00bdce0b}"
-- --------------------------------------------------
-- 
-- interface IHTMLTableCaption
-- 
-- --------------------------------------------------
data HTMLTableCaption a = HTMLTableCaption
                           
type IHTMLTableCaption a = Automation.IDispatch (HTMLTableCaption a)
iidHTMLTableCaption :: Com.IID (IHTMLTableCaption Automation.Interface)
iidHTMLTableCaption =
  Com.mkIID "{3050f2eb-98b5-11cf-bb82-00aa00bdce0b}"
setVAlign :: Prelude.String -> Automation.IDispatch a -> Prelude.IO ()
setVAlign v =
  Automation.propertySet "vAlign" [Automation.inString v]
getVAlign :: Automation.IDispatch a -> Prelude.IO (Prelude.String)
getVAlign = Automation.propertyGet "vAlign" [] Automation.outString
-- --------------------------------------------------
-- 
-- dispinterface DispIHTMLTableCaption
-- 
-- --------------------------------------------------

                            
type DispIHTMLTableCaption a = Automation.IDispatch (HTMLTableCaption a)
iidIHTMLTableCaption :: Com.IID (DispIHTMLTableCaption Automation.Interface)
iidIHTMLTableCaption =
  Com.mkIID "{3050f508-98b5-11cf-bb82-00aa00bdce0b}"
-- --------------------------------------------------
-- 
-- coclass HTMLTableCaption
-- 
-- --------------------------------------------------
clsidHTMLTableCaption :: Com.CLSID
clsidHTMLTableCaption =
  Com.mkCLSID "{3050f2ec-98b5-11cf-bb82-00aa00bdce0b}"
-- --------------------------------------------------
-- 
-- interface IHTMLCommentElement
-- 
-- --------------------------------------------------
data HTMLCommentElement a = HTMLCommentElement
                             
type IHTMLCommentElement a = Automation.IDispatch (HTMLCommentElement a)
iidHTMLCommentElement :: Com.IID (IHTMLCommentElement Automation.Interface)
iidHTMLCommentElement =
  Com.mkIID "{3050f20c-98b5-11cf-bb82-00aa00bdce0b}"
setAtomic :: Prelude.Int -> Automation.IDispatch a -> Prelude.IO ()
setAtomic v = Automation.propertySet "atomic" [Automation.inInt v]
getAtomic :: Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getAtomic = Automation.propertyGet "atomic" [] Automation.outInt
-- --------------------------------------------------
-- 
-- dispinterface DispIHTMLCommentElement
-- 
-- --------------------------------------------------

                              
type DispIHTMLCommentElement a = Automation.IDispatch (HTMLCommentElement a)
iidIHTMLCommentElement :: Com.IID (DispIHTMLCommentElement Automation.Interface)
iidIHTMLCommentElement =
  Com.mkIID "{3050f50a-98b5-11cf-bb82-00aa00bdce0b}"
-- --------------------------------------------------
-- 
-- coclass HTMLCommentElement
-- 
-- --------------------------------------------------
clsidHTMLCommentElement :: Com.CLSID
clsidHTMLCommentElement =
  Com.mkCLSID "{3050f317-98b5-11cf-bb82-00aa00bdce0b}"
-- --------------------------------------------------
-- 
-- interface IHTMLPhraseElement
-- 
-- --------------------------------------------------
data HTMLPhraseElement a = HTMLPhraseElement
                            
type IHTMLPhraseElement a = Automation.IDispatch (HTMLPhraseElement a)
iidHTMLPhraseElement :: Com.IID (IHTMLPhraseElement Automation.Interface)
iidHTMLPhraseElement =
  Com.mkIID "{3050f20a-98b5-11cf-bb82-00aa00bdce0b}"
-- --------------------------------------------------
-- 
-- interface IHTMLSpanElement
-- 
-- --------------------------------------------------
data HTMLSpanElement a = HTMLSpanElement
                          
type IHTMLSpanElement a = Automation.IDispatch (HTMLSpanElement a)
iidHTMLSpanElement :: Com.IID (IHTMLSpanElement Automation.Interface)
iidHTMLSpanElement =
  Com.mkIID "{3050f3f3-98b5-11cf-bb82-00aa00bdce0b}"
-- --------------------------------------------------
-- 
-- dispinterface DispIHTMLPhraseElement
-- 
-- --------------------------------------------------

                             
type DispIHTMLPhraseElement a = Automation.IDispatch (HTMLPhraseElement a)
iidIHTMLPhraseElement :: Com.IID (DispIHTMLPhraseElement Automation.Interface)
iidIHTMLPhraseElement =
  Com.mkIID "{3050f52d-98b5-11cf-bb82-00aa00bdce0b}"
-- --------------------------------------------------
-- 
-- coclass HTMLPhraseElement
-- 
-- --------------------------------------------------
clsidHTMLPhraseElement :: Com.CLSID
clsidHTMLPhraseElement =
  Com.mkCLSID "{3050f26e-98b5-11cf-bb82-00aa00bdce0b}"
-- --------------------------------------------------
-- 
-- dispinterface DispIHTMLSpanElement
-- 
-- --------------------------------------------------

                           
type DispIHTMLSpanElement a = Automation.IDispatch (HTMLSpanElement a)
iidIHTMLSpanElement :: Com.IID (DispIHTMLSpanElement Automation.Interface)
iidIHTMLSpanElement =
  Com.mkIID "{3050f548-98b5-11cf-bb82-00aa00bdce0b}"
-- --------------------------------------------------
-- 
-- coclass HTMLSpanElement
-- 
-- --------------------------------------------------
clsidHTMLSpanElement :: Com.CLSID
clsidHTMLSpanElement =
  Com.mkCLSID "{3050f3f5-98b4-11cf-bb82-00aa00bdce0b}"
-- --------------------------------------------------
-- 
-- interface IHTMLTable
-- 
-- --------------------------------------------------
data HTMLTable a = HTMLTable
                    
type IHTMLTable a = Automation.IDispatch (HTMLTable a)
iidHTMLTable :: Com.IID (IHTMLTable Automation.Interface)
iidHTMLTable = Com.mkIID "{3050f21e-98b5-11cf-bb82-00aa00bdce0b}"
setFrame :: Prelude.String -> Automation.IDispatch a -> Prelude.IO ()
setFrame v = Automation.propertySet "frame" [Automation.inString v]
getFrame :: Automation.IDispatch a -> Prelude.IO (Prelude.String)
getFrame = Automation.propertyGet "frame" [] Automation.outString
setRules :: Prelude.String -> Automation.IDispatch a -> Prelude.IO ()
setRules v = Automation.propertySet "rules" [Automation.inString v]
getRules :: Automation.IDispatch a -> Prelude.IO (Prelude.String)
getRules = Automation.propertyGet "rules" [] Automation.outString
setCellSpacing :: (Automation.Variant a0) => a0 -> Automation.IDispatch a -> Prelude.IO ()
setCellSpacing v =
  Automation.propertySet "cellSpacing" [Automation.inVariant v]
getCellSpacing :: (Automation.Variant a0) => Automation.IDispatch a -> Prelude.IO (a0)
getCellSpacing =
  Automation.propertyGet "cellSpacing" [] Automation.outVariant
setCellPadding :: (Automation.Variant a0) => a0 -> Automation.IDispatch a -> Prelude.IO ()
setCellPadding v =
  Automation.propertySet "cellPadding" [Automation.inVariant v]
getCellPadding :: (Automation.Variant a0) => Automation.IDispatch a -> Prelude.IO (a0)
getCellPadding =
  Automation.propertyGet "cellPadding" [] Automation.outVariant
setBorderColor0 :: (Automation.Variant a0) => a0 -> Automation.IDispatch a -> Prelude.IO ()
setBorderColor0 v =
  Automation.propertySet "borderColor" [Automation.inVariant v]
getBorderColor0 :: (Automation.Variant a0) => Automation.IDispatch a -> Prelude.IO (a0)
getBorderColor0 =
  Automation.propertyGet "borderColor" [] Automation.outVariant
setBorderColorLight :: (Automation.Variant a0) => a0 -> Automation.IDispatch a -> Prelude.IO ()
setBorderColorLight v =
  Automation.propertySet "borderColorLight" [Automation.inVariant v]
getBorderColorLight :: (Automation.Variant a0) => Automation.IDispatch a -> Prelude.IO (a0)
getBorderColorLight =
  Automation.propertyGet "borderColorLight" [] Automation.outVariant
setBorderColorDark :: (Automation.Variant a0) => a0 -> Automation.IDispatch a -> Prelude.IO ()
setBorderColorDark v =
  Automation.propertySet "borderColorDark" [Automation.inVariant v]
getBorderColorDark :: (Automation.Variant a0) => Automation.IDispatch a -> Prelude.IO (a0)
getBorderColorDark =
  Automation.propertyGet "borderColorDark" [] Automation.outVariant
refresh0 :: Automation.IDispatch a -> Prelude.IO ()
refresh0 = Automation.method0 "refresh" []
getRows1 :: Automation.IDispatch a -> Prelude.IO (Automation.IDispatch Automation.Interface)
getRows1 = Automation.propertyGet "rows" [] Automation.outIDispatch
setDataPageSize :: Prelude.Int -> Automation.IDispatch a -> Prelude.IO ()
setDataPageSize v =
  Automation.propertySet "dataPageSize" [Automation.inInt v]
getDataPageSize :: Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getDataPageSize =
  Automation.propertyGet "dataPageSize" [] Automation.outInt
nextPage :: Automation.IDispatch a -> Prelude.IO ()
nextPage = Automation.method0 "nextPage" []
previousPage :: Automation.IDispatch a -> Prelude.IO ()
previousPage = Automation.method0 "previousPage" []
-- --------------------------------------------------
-- 
-- interface IHTMLTableCol
-- 
-- --------------------------------------------------
data HTMLTableCol a = HTMLTableCol
                       
type IHTMLTableCol a = Automation.IDispatch (HTMLTableCol a)
iidHTMLTableCol :: Com.IID (IHTMLTableCol Automation.Interface)
iidHTMLTableCol =
  Com.mkIID "{3050f23a-98b5-11cf-bb82-00aa00bdce0b}"
setSpan :: Prelude.Int -> Automation.IDispatch a -> Prelude.IO ()
setSpan v = Automation.propertySet "span" [Automation.inInt v]
getSpan :: Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getSpan = Automation.propertyGet "span" [] Automation.outInt
-- --------------------------------------------------
-- 
-- interface IHTMLTableSection
-- 
-- --------------------------------------------------
data HTMLTableSection a = HTMLTableSection
                           
type IHTMLTableSection a = Automation.IDispatch (HTMLTableSection a)
iidHTMLTableSection :: Com.IID (IHTMLTableSection Automation.Interface)
iidHTMLTableSection =
  Com.mkIID "{3050f23b-98b5-11cf-bb82-00aa00bdce0b}"
-- --------------------------------------------------
-- 
-- interface IHTMLTableRow
-- 
-- --------------------------------------------------
data HTMLTableRow a = HTMLTableRow
                       
type IHTMLTableRow a = Automation.IDispatch (HTMLTableRow a)
iidHTMLTableRow :: Com.IID (IHTMLTableRow Automation.Interface)
iidHTMLTableRow =
  Com.mkIID "{3050f23c-98b5-11cf-bb82-00aa00bdce0b}"
getCells :: Automation.IDispatch a -> Prelude.IO (Automation.IDispatch Automation.Interface)
getCells =
  Automation.propertyGet "cells" [] Automation.outIDispatch
-- --------------------------------------------------
-- 
-- interface IHTMLTableCell
-- 
-- --------------------------------------------------
data HTMLTableCell a = HTMLTableCell
                        
type IHTMLTableCell a = Automation.IDispatch (HTMLTableCell a)
iidHTMLTableCell :: Com.IID (IHTMLTableCell Automation.Interface)
iidHTMLTableCell =
  Com.mkIID "{3050f23d-98b5-11cf-bb82-00aa00bdce0b}"
setRowSpan :: Prelude.Int -> Automation.IDispatch a -> Prelude.IO ()
setRowSpan v =
  Automation.propertySet "rowSpan" [Automation.inInt v]
getRowSpan :: Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getRowSpan = Automation.propertyGet "rowSpan" [] Automation.outInt
setColSpan :: Prelude.Int -> Automation.IDispatch a -> Prelude.IO ()
setColSpan v =
  Automation.propertySet "colSpan" [Automation.inInt v]
getColSpan :: Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getColSpan = Automation.propertyGet "colSpan" [] Automation.outInt
-- --------------------------------------------------
-- 
-- dispinterface DispIHTMLTable
-- 
-- --------------------------------------------------

                     
type DispIHTMLTable a = Automation.IDispatch (HTMLTable a)
iidIHTMLTable :: Com.IID (DispIHTMLTable Automation.Interface)
iidIHTMLTable = Com.mkIID "{3050f532-98b5-11cf-bb82-00aa00bdce0b}"
-- --------------------------------------------------
-- 
-- coclass HTMLTable
-- 
-- --------------------------------------------------
clsidHTMLTable :: Com.CLSID
clsidHTMLTable =
  Com.mkCLSID "{3050f26b-98b5-11cf-bb82-00aa00bdce0b}"
-- --------------------------------------------------
-- 
-- dispinterface DispIHTMLTableCol
-- 
-- --------------------------------------------------

                        
type DispIHTMLTableCol a = Automation.IDispatch (HTMLTableCol a)
iidIHTMLTableCol :: Com.IID (DispIHTMLTableCol Automation.Interface)
iidIHTMLTableCol =
  Com.mkIID "{3050f533-98b5-11cf-bb82-00aa00bdce0b}"
-- --------------------------------------------------
-- 
-- coclass HTMLTableCol
-- 
-- --------------------------------------------------
clsidHTMLTableCol :: Com.CLSID
clsidHTMLTableCol =
  Com.mkCLSID "{3050f26c-98b5-11cf-bb82-00aa00bdce0b}"
-- --------------------------------------------------
-- 
-- dispinterface DispIHTMLTableSection
-- 
-- --------------------------------------------------

                            
type DispIHTMLTableSection a = Automation.IDispatch (HTMLTableSection a)
iidIHTMLTableSection :: Com.IID (DispIHTMLTableSection Automation.Interface)
iidIHTMLTableSection =
  Com.mkIID "{3050f534-98b5-11cf-bb82-00aa00bdce0b}"
-- --------------------------------------------------
-- 
-- coclass HTMLTableSection
-- 
-- --------------------------------------------------
clsidHTMLTableSection :: Com.CLSID
clsidHTMLTableSection =
  Com.mkCLSID "{3050f2e9-98b5-11cf-bb82-00aa00bdce0b}"
-- --------------------------------------------------
-- 
-- dispinterface DispIHTMLTableRow
-- 
-- --------------------------------------------------

                        
type DispIHTMLTableRow a = Automation.IDispatch (HTMLTableRow a)
iidIHTMLTableRow :: Com.IID (DispIHTMLTableRow Automation.Interface)
iidIHTMLTableRow =
  Com.mkIID "{3050f535-98b5-11cf-bb82-00aa00bdce0b}"
-- --------------------------------------------------
-- 
-- coclass HTMLTableRow
-- 
-- --------------------------------------------------
clsidHTMLTableRow :: Com.CLSID
clsidHTMLTableRow =
  Com.mkCLSID "{3050f26d-98b5-11cf-bb82-00aa00bdce0b}"
-- --------------------------------------------------
-- 
-- dispinterface DispIHTMLTableCell
-- 
-- --------------------------------------------------

                         
type DispIHTMLTableCell a = Automation.IDispatch (HTMLTableCell a)
iidIHTMLTableCell :: Com.IID (DispIHTMLTableCell Automation.Interface)
iidIHTMLTableCell =
  Com.mkIID "{3050f536-98b5-11cf-bb82-00aa00bdce0b}"
-- --------------------------------------------------
-- 
-- coclass HTMLTableCell
-- 
-- --------------------------------------------------
clsidHTMLTableCell :: Com.CLSID
clsidHTMLTableCell =
  Com.mkCLSID "{3050f246-98b5-11cf-bb82-00aa00bdce0b}"
-- --------------------------------------------------
-- 
-- dispinterface HTMLScriptEvents
-- 
-- --------------------------------------------------
data HTMLScriptEvents a = HTMLScriptEvents
                           
type IHTMLScriptEvents a = Automation.IDispatch (HTMLScriptEvents a)
iidHTMLScriptEvents :: Com.IID (IHTMLScriptEvents Automation.Interface)
iidHTMLScriptEvents =
  Com.mkIID "{3050f3e2-98b5-11cf-bb82-00aa00bdce0b}"
onreadystatechange3 :: Prelude.Int -> Automation.IDispatch a -> Prelude.IO ()
onreadystatechange3 lReadyState =
  Automation.method0 "onreadystatechange" [Automation.inInt lReadyState]
-- --------------------------------------------------
-- 
-- interface IHTMLScriptElement
-- 
-- --------------------------------------------------
data HTMLScriptElement a = HTMLScriptElement
                            
type IHTMLScriptElement a = Automation.IDispatch (HTMLScriptElement a)
iidHTMLScriptElement :: Com.IID (IHTMLScriptElement Automation.Interface)
iidHTMLScriptElement =
  Com.mkIID "{3050f28b-98b5-11cf-bb82-00aa00bdce0b}"
setEvent :: Prelude.String -> Automation.IDispatch a -> Prelude.IO ()
setEvent v = Automation.propertySet "event" [Automation.inString v]
getEvent0 :: Automation.IDispatch a -> Prelude.IO (Prelude.String)
getEvent0 = Automation.propertyGet "event" [] Automation.outString
setDefer :: Prelude.Int -> Automation.IDispatch a -> Prelude.IO ()
setDefer v = Automation.propertySet "defer" [Automation.inInt v]
getDefer :: Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getDefer = Automation.propertyGet "defer" [] Automation.outInt
-- --------------------------------------------------
-- 
-- dispinterface DispIHTMLScriptElement
-- 
-- --------------------------------------------------

                             
type DispIHTMLScriptElement a = Automation.IDispatch (HTMLScriptElement a)
iidIHTMLScriptElement :: Com.IID (DispIHTMLScriptElement Automation.Interface)
iidIHTMLScriptElement =
  Com.mkIID "{3050f530-98b5-11cf-bb82-00aa00bdce0b}"
-- --------------------------------------------------
-- 
-- coclass HTMLScriptElement
-- 
-- --------------------------------------------------
clsidHTMLScriptElement :: Com.CLSID
clsidHTMLScriptElement =
  Com.mkCLSID "{3050f28c-98b5-11cf-bb82-00aa00bdce0b}"
-- --------------------------------------------------
-- 
-- interface IHTMLNoShowElement
-- 
-- --------------------------------------------------
data HTMLNoShowElement a = HTMLNoShowElement
                            
type IHTMLNoShowElement a = Automation.IDispatch (HTMLNoShowElement a)
iidHTMLNoShowElement :: Com.IID (IHTMLNoShowElement Automation.Interface)
iidHTMLNoShowElement =
  Com.mkIID "{3050f38a-98b5-11cf-bb82-00aa00bdce0b}"
-- --------------------------------------------------
-- 
-- dispinterface DispIHTMLNoShowElement
-- 
-- --------------------------------------------------

                             
type DispIHTMLNoShowElement a = Automation.IDispatch (HTMLNoShowElement a)
iidIHTMLNoShowElement :: Com.IID (DispIHTMLNoShowElement Automation.Interface)
iidIHTMLNoShowElement =
  Com.mkIID "{3050f528-98b5-11cf-bb82-00aa00bdce0b}"
-- --------------------------------------------------
-- 
-- coclass HTMLNoShowElement
-- 
-- --------------------------------------------------
clsidHTMLNoShowElement :: Com.CLSID
clsidHTMLNoShowElement =
  Com.mkCLSID "{3050f38b-98b5-11cf-bb82-00aa00bdce0b}"
-- --------------------------------------------------
-- 
-- dispinterface HTMLObjectElementEvents
-- 
-- --------------------------------------------------
data HTMLObjectElementEvents a = HTMLObjectElementEvents
                                  
type IHTMLObjectElementEvents a = Automation.IDispatch (HTMLObjectElementEvents a)
iidHTMLObjectElementEvents :: Com.IID (IHTMLObjectElementEvents Automation.Interface)
iidHTMLObjectElementEvents =
  Com.mkIID "{3050f3c4-98b5-11cf-bb82-00aa00bdce0b}"
-- --------------------------------------------------
-- 
-- interface IHTMLObjectElement
-- 
-- --------------------------------------------------
data HTMLObjectElement a = HTMLObjectElement
                            
type IHTMLObjectElement a = Automation.IDispatch (HTMLObjectElement a)
iidHTMLObjectElement :: Com.IID (IHTMLObjectElement Automation.Interface)
iidHTMLObjectElement =
  Com.mkIID "{3050f24f-98b5-11cf-bb82-00aa00bdce0b}"
htmlGetObject :: Automation.IDispatch a -> Prelude.IO (Automation.IDispatch Automation.Interface)
htmlGetObject =
  Automation.propertyGet "object" [] Automation.outIDispatch
getClassid :: Automation.IDispatch a -> Prelude.IO (Prelude.String)
getClassid =
  Automation.propertyGet "classid" [] Automation.outString
getData :: Automation.IDispatch a -> Prelude.IO (Prelude.String)
getData = Automation.propertyGet "data" [] Automation.outString
recordset :: Automation.IDispatch a0 -> Automation.IDispatch a -> Prelude.IO ()
recordset v =
  Automation.method0 "recordset" [Automation.inIDispatch v]
getRecordset :: Automation.IDispatch a -> Prelude.IO (Automation.IDispatch Automation.Interface)
getRecordset =
  Automation.propertyGet "recordset" [] Automation.outIDispatch
setCodeType :: Prelude.String -> Automation.IDispatch a -> Prelude.IO ()
setCodeType v =
  Automation.propertySet "codeType" [Automation.inString v]
getCodeType :: Automation.IDispatch a -> Prelude.IO (Prelude.String)
getCodeType =
  Automation.propertyGet "codeType" [] Automation.outString
setCode :: Prelude.String -> Automation.IDispatch a -> Prelude.IO ()
setCode v = Automation.propertySet "code" [Automation.inString v]
getCode :: Automation.IDispatch a -> Prelude.IO (Prelude.String)
getCode = Automation.propertyGet "code" [] Automation.outString
getReadyState8 :: Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getReadyState8 =
  Automation.propertyGet "readyState" [] Automation.outInt
-- --------------------------------------------------
-- 
-- dispinterface DispIHTMLObjectElement
-- 
-- --------------------------------------------------

                             
type DispIHTMLObjectElement a = Automation.IDispatch (HTMLObjectElement a)
iidIHTMLObjectElement :: Com.IID (DispIHTMLObjectElement Automation.Interface)
iidIHTMLObjectElement =
  Com.mkIID "{3050f529-98b5-11cf-bb82-00aa00bdce0b}"
-- --------------------------------------------------
-- 
-- coclass HTMLObjectElement
-- 
-- --------------------------------------------------
clsidHTMLObjectElement :: Com.CLSID
clsidHTMLObjectElement =
  Com.mkCLSID "{3050f24e-98b5-11cf-bb82-00aa00bdce0b}"
-- --------------------------------------------------
-- 
-- interface IHTMLFrameBase
-- 
-- --------------------------------------------------
data HTMLFrameBase a = HTMLFrameBase
                        
type IHTMLFrameBase a = Automation.IDispatch (HTMLFrameBase a)
iidHTMLFrameBase :: Com.IID (IHTMLFrameBase Automation.Interface)
iidHTMLFrameBase =
  Com.mkIID "{3050f311-98b5-11cf-bb82-00aa00bdce0b}"
setFrameBorder :: Prelude.String -> Automation.IDispatch a -> Prelude.IO ()
setFrameBorder v =
  Automation.propertySet "frameBorder" [Automation.inString v]
getFrameBorder :: Automation.IDispatch a -> Prelude.IO (Prelude.String)
getFrameBorder =
  Automation.propertyGet "frameBorder" [] Automation.outString
setFrameSpacing :: (Automation.Variant a0) => a0 -> Automation.IDispatch a -> Prelude.IO ()
setFrameSpacing v =
  Automation.propertySet "frameSpacing" [Automation.inVariant v]
getFrameSpacing :: (Automation.Variant a0) => Automation.IDispatch a -> Prelude.IO (a0)
getFrameSpacing =
  Automation.propertyGet "frameSpacing" [] Automation.outVariant
setMarginWidth :: (Automation.Variant a0) => a0 -> Automation.IDispatch a -> Prelude.IO ()
setMarginWidth v =
  Automation.propertySet "marginWidth" [Automation.inVariant v]
getMarginWidth :: (Automation.Variant a0) => Automation.IDispatch a -> Prelude.IO (a0)
getMarginWidth =
  Automation.propertyGet "marginWidth" [] Automation.outVariant
setMarginHeight :: (Automation.Variant a0) => a0 -> Automation.IDispatch a -> Prelude.IO ()
setMarginHeight v =
  Automation.propertySet "marginHeight" [Automation.inVariant v]
getMarginHeight :: (Automation.Variant a0) => Automation.IDispatch a -> Prelude.IO (a0)
getMarginHeight =
  Automation.propertyGet "marginHeight" [] Automation.outVariant
setNoResize :: Prelude.Int -> Automation.IDispatch a -> Prelude.IO ()
setNoResize v =
  Automation.propertySet "noResize" [Automation.inInt v]
getNoResize :: Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getNoResize =
  Automation.propertyGet "noResize" [] Automation.outInt
setScrolling :: Prelude.String -> Automation.IDispatch a -> Prelude.IO ()
setScrolling v =
  Automation.propertySet "scrolling" [Automation.inString v]
getScrolling :: Automation.IDispatch a -> Prelude.IO (Prelude.String)
getScrolling =
  Automation.propertyGet "scrolling" [] Automation.outString
-- --------------------------------------------------
-- 
-- dispinterface DispIHTMLFrameBase
-- 
-- --------------------------------------------------

                         
type DispIHTMLFrameBase a = Automation.IDispatch (HTMLFrameBase a)
iidIHTMLFrameBase :: Com.IID (DispIHTMLFrameBase Automation.Interface)
iidIHTMLFrameBase =
  Com.mkIID "{3050f541-98b5-11cf-bb82-00aa00bdce0b}"
-- --------------------------------------------------
-- 
-- coclass HTMLFrameBase
-- 
-- --------------------------------------------------
clsidHTMLFrameBase :: Com.CLSID
clsidHTMLFrameBase =
  Com.mkCLSID "{3050f312-98b5-11cf-bb82-00aa00bdce0b}"
-- --------------------------------------------------
-- 
-- interface IHTMLFrameElement
-- 
-- --------------------------------------------------
data HTMLFrameElement a = HTMLFrameElement
                           
type IHTMLFrameElement a = Automation.IDispatch (HTMLFrameElement a)
iidHTMLFrameElement :: Com.IID (IHTMLFrameElement Automation.Interface)
iidHTMLFrameElement =
  Com.mkIID "{3050f313-98b5-11cf-bb82-00aa00bdce0b}"
-- --------------------------------------------------
-- 
-- dispinterface DispIHTMLFrameElement
-- 
-- --------------------------------------------------

                            
type DispIHTMLFrameElement a = Automation.IDispatch (HTMLFrameElement a)
iidIHTMLFrameElement :: Com.IID (DispIHTMLFrameElement Automation.Interface)
iidIHTMLFrameElement =
  Com.mkIID "{3050f513-98b5-11cf-bb82-00aa00bdce0b}"
-- --------------------------------------------------
-- 
-- coclass HTMLFrameElement
-- 
-- --------------------------------------------------
clsidHTMLFrameElement :: Com.CLSID
clsidHTMLFrameElement =
  Com.mkCLSID "{3050f314-98b5-11cf-bb82-00aa00bdce0b}"
-- --------------------------------------------------
-- 
-- interface IHTMLIFrameElement
-- 
-- --------------------------------------------------
data HTMLIFrameElement a = HTMLIFrameElement
                            
type IHTMLIFrameElement a = Automation.IDispatch (HTMLIFrameElement a)
iidHTMLIFrameElement :: Com.IID (IHTMLIFrameElement Automation.Interface)
iidHTMLIFrameElement =
  Com.mkIID "{3050f315-98b5-11cf-bb82-00aa00bdce0b}"
-- --------------------------------------------------
-- 
-- dispinterface DispIHTMLIFrameElement
-- 
-- --------------------------------------------------

                             
type DispIHTMLIFrameElement a = Automation.IDispatch (HTMLIFrameElement a)
iidIHTMLIFrameElement :: Com.IID (DispIHTMLIFrameElement Automation.Interface)
iidIHTMLIFrameElement =
  Com.mkIID "{3050f51b-98b5-11cf-bb82-00aa00bdce0b}"
-- --------------------------------------------------
-- 
-- coclass HTMLIFrame
-- 
-- --------------------------------------------------
clsidHTMLIFrame :: Com.CLSID
clsidHTMLIFrame =
  Com.mkCLSID "{3050f316-98b5-11cf-bb82-00aa00bdce0b}"
-- --------------------------------------------------
-- 
-- interface IHTMLDivPosition
-- 
-- --------------------------------------------------
data HTMLDivPosition a = HTMLDivPosition
                          
type IHTMLDivPosition a = Automation.IDispatch (HTMLDivPosition a)
iidHTMLDivPosition :: Com.IID (IHTMLDivPosition Automation.Interface)
iidHTMLDivPosition =
  Com.mkIID "{3050f212-98b5-11cf-bb82-00aa00bdce0b}"
-- --------------------------------------------------
-- 
-- interface IHTMLFieldSetElement
-- 
-- --------------------------------------------------
data HTMLFieldSetElement a = HTMLFieldSetElement
                              
type IHTMLFieldSetElement a = Automation.IDispatch (HTMLFieldSetElement a)
iidHTMLFieldSetElement :: Com.IID (IHTMLFieldSetElement Automation.Interface)
iidHTMLFieldSetElement =
  Com.mkIID "{3050f3e7-98b5-11cf-bb82-00aa00bdce0b}"
-- --------------------------------------------------
-- 
-- interface IHTMLLegendElement
-- 
-- --------------------------------------------------
data HTMLLegendElement a = HTMLLegendElement
                            
type IHTMLLegendElement a = Automation.IDispatch (HTMLLegendElement a)
iidHTMLLegendElement :: Com.IID (IHTMLLegendElement Automation.Interface)
iidHTMLLegendElement =
  Com.mkIID "{3050f3ea-98b5-11cf-bb82-00aa00bdce0b}"
-- --------------------------------------------------
-- 
-- dispinterface DispIHTMLDivPosition
-- 
-- --------------------------------------------------

                           
type DispIHTMLDivPosition a = Automation.IDispatch (HTMLDivPosition a)
iidIHTMLDivPosition :: Com.IID (DispIHTMLDivPosition Automation.Interface)
iidIHTMLDivPosition =
  Com.mkIID "{3050f50f-98b5-11cf-bb82-00aa00bdce0b}"
-- --------------------------------------------------
-- 
-- coclass HTMLDivPosition
-- 
-- --------------------------------------------------
clsidHTMLDivPosition :: Com.CLSID
clsidHTMLDivPosition =
  Com.mkCLSID "{3050f249-98b5-11cf-bb82-00aa00bdce0b}"
-- --------------------------------------------------
-- 
-- dispinterface DispIHTMLFieldSetElement
-- 
-- --------------------------------------------------

                               
type DispIHTMLFieldSetElement a = Automation.IDispatch (HTMLFieldSetElement a)
iidIHTMLFieldSetElement :: Com.IID (DispIHTMLFieldSetElement Automation.Interface)
iidIHTMLFieldSetElement =
  Com.mkIID "{3050f545-98b5-11cf-bb82-00aa00bdce0b}"
-- --------------------------------------------------
-- 
-- coclass HTMLFieldSetElement
-- 
-- --------------------------------------------------
clsidHTMLFieldSetElement :: Com.CLSID
clsidHTMLFieldSetElement =
  Com.mkCLSID "{3050f3e8-98b5-11cf-bb82-00aa00bdce0b}"
-- --------------------------------------------------
-- 
-- dispinterface DispIHTMLLegendElement
-- 
-- --------------------------------------------------

                             
type DispIHTMLLegendElement a = Automation.IDispatch (HTMLLegendElement a)
iidIHTMLLegendElement :: Com.IID (DispIHTMLLegendElement Automation.Interface)
iidIHTMLLegendElement =
  Com.mkIID "{3050f546-98b5-11cf-bb82-00aa00bdce0b}"
-- --------------------------------------------------
-- 
-- coclass HTMLLegendElement
-- 
-- --------------------------------------------------
clsidHTMLLegendElement :: Com.CLSID
clsidHTMLLegendElement =
  Com.mkCLSID "{3050f3e9-98b5-11cf-bb82-00aa00bdce0b}"
-- --------------------------------------------------
-- 
-- interface IHTMLSpanFlow
-- 
-- --------------------------------------------------
data HTMLSpanFlow a = HTMLSpanFlow
                       
type IHTMLSpanFlow a = Automation.IDispatch (HTMLSpanFlow a)
iidHTMLSpanFlow :: Com.IID (IHTMLSpanFlow Automation.Interface)
iidHTMLSpanFlow =
  Com.mkIID "{3050f3e5-98b5-11cf-bb82-00aa00bdce0b}"
-- --------------------------------------------------
-- 
-- dispinterface DispIHTMLSpanFlow
-- 
-- --------------------------------------------------

                        
type DispIHTMLSpanFlow a = Automation.IDispatch (HTMLSpanFlow a)
iidIHTMLSpanFlow :: Com.IID (DispIHTMLSpanFlow Automation.Interface)
iidIHTMLSpanFlow =
  Com.mkIID "{3050f544-98b5-11cf-bb82-00aa00bdce0b}"
-- --------------------------------------------------
-- 
-- coclass HTMLSpanFlow
-- 
-- --------------------------------------------------
clsidHTMLSpanFlow :: Com.CLSID
clsidHTMLSpanFlow =
  Com.mkCLSID "{3050f3e6-98b5-11cf-bb82-00aa00bdce0b}"
-- --------------------------------------------------
-- 
-- interface IHTMLFrameSetElement
-- 
-- --------------------------------------------------
data HTMLFrameSetElement a = HTMLFrameSetElement
                              
type IHTMLFrameSetElement a = Automation.IDispatch (HTMLFrameSetElement a)
iidHTMLFrameSetElement :: Com.IID (IHTMLFrameSetElement Automation.Interface)
iidHTMLFrameSetElement =
  Com.mkIID "{3050f319-98b5-11cf-bb82-00aa00bdce0b}"
setRows1 :: Prelude.String -> Automation.IDispatch a -> Prelude.IO ()
setRows1 v = Automation.propertySet "rows" [Automation.inString v]
getRows3 :: Automation.IDispatch a -> Prelude.IO (Prelude.String)
getRows3 = Automation.propertyGet "rows" [] Automation.outString
setCols3 :: Prelude.String -> Automation.IDispatch a -> Prelude.IO ()
setCols3 v = Automation.propertySet "cols" [Automation.inString v]
getCols3 :: Automation.IDispatch a -> Prelude.IO (Prelude.String)
getCols3 = Automation.propertyGet "cols" [] Automation.outString
-- --------------------------------------------------
-- 
-- dispinterface DispIHTMLFrameSetElement
-- 
-- --------------------------------------------------

                               
type DispIHTMLFrameSetElement a = Automation.IDispatch (HTMLFrameSetElement a)
iidIHTMLFrameSetElement :: Com.IID (DispIHTMLFrameSetElement Automation.Interface)
iidIHTMLFrameSetElement =
  Com.mkIID "{3050f514-98b5-11cf-bb82-00aa00bdce0b}"
-- --------------------------------------------------
-- 
-- coclass HTMLFrameSetSite
-- 
-- --------------------------------------------------
clsidHTMLFrameSetSite :: Com.CLSID
clsidHTMLFrameSetSite =
  Com.mkCLSID "{3050f31A-98b5-11cf-bb82-00aa00bdce0b}"
-- --------------------------------------------------
-- 
-- interface IHTMLBGsound
-- 
-- --------------------------------------------------
data HTMLBGsound a = HTMLBGsound
                      
type IHTMLBGsound a = Automation.IDispatch (HTMLBGsound a)
iidHTMLBGsound :: Com.IID (IHTMLBGsound Automation.Interface)
iidHTMLBGsound = Com.mkIID "{3050f369-98b5-11cf-bb82-00aa00bdce0b}"
setVolume :: (Automation.Variant a0) => a0 -> Automation.IDispatch a -> Prelude.IO ()
setVolume v =
  Automation.propertySet "volume" [Automation.inVariant v]
getVolume :: (Automation.Variant a0) => Automation.IDispatch a -> Prelude.IO (a0)
getVolume =
  Automation.propertyGet "volume" [] Automation.outVariant
setBalance :: (Automation.Variant a0) => a0 -> Automation.IDispatch a -> Prelude.IO ()
setBalance v =
  Automation.propertySet "balance" [Automation.inVariant v]
getBalance :: (Automation.Variant a0) => Automation.IDispatch a -> Prelude.IO (a0)
getBalance =
  Automation.propertyGet "balance" [] Automation.outVariant
-- --------------------------------------------------
-- 
-- dispinterface DispIHTMLBGsound
-- 
-- --------------------------------------------------

                       
type DispIHTMLBGsound a = Automation.IDispatch (HTMLBGsound a)
iidIHTMLBGsound :: Com.IID (DispIHTMLBGsound Automation.Interface)
iidIHTMLBGsound =
  Com.mkIID "{3050f53c-98b5-11cf-bb82-00aa00bdce0b}"
-- --------------------------------------------------
-- 
-- coclass HTMLBGsound
-- 
-- --------------------------------------------------
clsidHTMLBGsound :: Com.CLSID
clsidHTMLBGsound =
  Com.mkCLSID "{3050f370-98b5-11cf-bb82-00aa00bdce0b}"
-- --------------------------------------------------
-- 
-- interface IHTMLFontNamesCollection
-- 
-- --------------------------------------------------
data HTMLFontNamesCollection a = HTMLFontNamesCollection
                                  
type IHTMLFontNamesCollection a = Automation.IDispatch (HTMLFontNamesCollection a)
iidHTMLFontNamesCollection :: Com.IID (IHTMLFontNamesCollection Automation.Interface)
iidHTMLFontNamesCollection =
  Com.mkIID "{3050f376-98b5-11cf-bb82-00aa00bdce0b}"
item10 :: Prelude.Int -> IHTMLFontNamesCollection a -> Prelude.IO (Prelude.String)
item10 index =
  Automation.function1 "item" [Automation.inInt index] Automation.outString
-- --------------------------------------------------
-- 
-- interface IHTMLFontSizesCollection
-- 
-- --------------------------------------------------
data HTMLFontSizesCollection a = HTMLFontSizesCollection
                                  
type IHTMLFontSizesCollection a = Automation.IDispatch (HTMLFontSizesCollection a)
iidHTMLFontSizesCollection :: Com.IID (IHTMLFontSizesCollection Automation.Interface)
iidHTMLFontSizesCollection =
  Com.mkIID "{3050f377-98b5-11cf-bb82-00aa00bdce0b}"
getForFont :: IHTMLFontSizesCollection a -> Prelude.IO (Prelude.String)
getForFont =
  Automation.propertyGet "forFont" [] Automation.outString
item11 :: Prelude.Int -> IHTMLFontSizesCollection a -> Prelude.IO (Prelude.Int)
item11 index =
  Automation.function1 "item" [Automation.inInt index] Automation.outInt
-- --------------------------------------------------
-- 
-- interface IHTMLOptionsHolder
-- 
-- --------------------------------------------------
data HTMLOptionsHolder a = HTMLOptionsHolder
                            
type IHTMLOptionsHolder a = Automation.IDispatch (HTMLOptionsHolder a)
iidHTMLOptionsHolder :: Com.IID (IHTMLOptionsHolder Automation.Interface)
iidHTMLOptionsHolder =
  Com.mkIID "{3050f378-98b5-11cf-bb82-00aa00bdce0b}"
getFonts :: IHTMLOptionsHolder a -> Prelude.IO (IHTMLFontNamesCollection Automation.Interface)
getFonts =
  Automation.propertyGet "fonts" [] Automation.outIDispatch
setExecArg :: (Automation.Variant a0) => a0 -> IHTMLOptionsHolder a -> Prelude.IO ()
setExecArg v =
  Automation.propertySet "execArg" [Automation.inVariant v]
getExecArg :: (Automation.Variant a0) => IHTMLOptionsHolder a -> Prelude.IO (a0)
getExecArg =
  Automation.propertyGet "execArg" [] Automation.outVariant
setErrorLine :: Prelude.Int -> IHTMLOptionsHolder a -> Prelude.IO ()
setErrorLine v =
  Automation.propertySet "errorLine" [Automation.inInt v]
getErrorLine :: IHTMLOptionsHolder a -> Prelude.IO (Prelude.Int)
getErrorLine =
  Automation.propertyGet "errorLine" [] Automation.outInt
setErrorCharacter :: Prelude.Int -> IHTMLOptionsHolder a -> Prelude.IO ()
setErrorCharacter v =
  Automation.propertySet "errorCharacter" [Automation.inInt v]
getErrorCharacter :: IHTMLOptionsHolder a -> Prelude.IO (Prelude.Int)
getErrorCharacter =
  Automation.propertyGet "errorCharacter" [] Automation.outInt
setErrorCode :: Prelude.Int -> IHTMLOptionsHolder a -> Prelude.IO ()
setErrorCode v =
  Automation.propertySet "errorCode" [Automation.inInt v]
getErrorCode :: IHTMLOptionsHolder a -> Prelude.IO (Prelude.Int)
getErrorCode =
  Automation.propertyGet "errorCode" [] Automation.outInt
setErrorMessage :: Prelude.String -> IHTMLOptionsHolder a -> Prelude.IO ()
setErrorMessage v =
  Automation.propertySet "errorMessage" [Automation.inString v]
getErrorMessage :: IHTMLOptionsHolder a -> Prelude.IO (Prelude.String)
getErrorMessage =
  Automation.propertyGet "errorMessage" [] Automation.outString
setErrorDebug :: Prelude.Int -> IHTMLOptionsHolder a -> Prelude.IO ()
setErrorDebug v =
  Automation.propertySet "errorDebug" [Automation.inInt v]
getErrorDebug :: IHTMLOptionsHolder a -> Prelude.IO (Prelude.Int)
getErrorDebug =
  Automation.propertyGet "errorDebug" [] Automation.outInt
setProductVersion :: Prelude.String -> IHTMLOptionsHolder a -> Prelude.IO ()
setProductVersion v =
  Automation.propertySet "productVersion" [Automation.inString v]
getProductVersion :: IHTMLOptionsHolder a -> Prelude.IO (Prelude.String)
getProductVersion =
  Automation.propertyGet "productVersion" [] Automation.outString
getUnsecuredWindowOfDocument :: IHTMLOptionsHolder a -> Prelude.IO (IHTMLWindow2 Automation.Interface)
getUnsecuredWindowOfDocument =
  Automation.propertyGet "unsecuredWindowOfDocument" [] Automation.outIDispatch
setEncryption :: Prelude.String -> IHTMLOptionsHolder a -> Prelude.IO ()
setEncryption v =
  Automation.propertySet "encryption" [Automation.inString v]
getEncryption :: IHTMLOptionsHolder a -> Prelude.IO (Prelude.String)
getEncryption =
  Automation.propertyGet "encryption" [] Automation.outString
sizes :: Prelude.String -> IHTMLOptionsHolder a -> Prelude.IO (IHTMLFontSizesCollection Automation.Interface)
sizes fontName =
  Automation.function1 "sizes" [Automation.inString fontName] Automation.outIDispatch
openfiledlg :: (Automation.Variant a0, Automation.Variant a1, Automation.Variant a2, Automation.Variant a3) => a0 -> a1 -> a2 -> a3 -> IHTMLOptionsHolder a -> Prelude.IO (Prelude.String)
openfiledlg initFile initDir filter title =
  Automation.function1 "openfiledlg" [Automation.inVariant initFile, Automation.inVariant initDir, Automation.inVariant filter, Automation.inVariant title] Automation.outString
savefiledlg :: (Automation.Variant a0, Automation.Variant a1, Automation.Variant a2, Automation.Variant a3) => a0 -> a1 -> a2 -> a3 -> IHTMLOptionsHolder a -> Prelude.IO (Prelude.String)
savefiledlg initFile initDir filter title =
  Automation.function1 "savefiledlg" [Automation.inVariant initFile, Automation.inVariant initDir, Automation.inVariant filter, Automation.inVariant title] Automation.outString
choosecolordlg :: (Automation.Variant a0) => a0 -> IHTMLOptionsHolder a -> Prelude.IO (Prelude.Int)
choosecolordlg initColor =
  Automation.function1 "choosecolordlg" [Automation.inVariant initColor] Automation.outInt
showSecurityInfo :: IHTMLOptionsHolder a -> Prelude.IO ()
showSecurityInfo = Automation.method0 "showSecurityInfo" []
-- --------------------------------------------------
-- 
-- dispinterface HTMLStyleElementEvents
-- 
-- --------------------------------------------------
data HTMLStyleElementEvents a = HTMLStyleElementEvents
                                 
type IHTMLStyleElementEvents a = Automation.IDispatch (HTMLStyleElementEvents a)
iidHTMLStyleElementEvents :: Com.IID (IHTMLStyleElementEvents Automation.Interface)
iidHTMLStyleElementEvents =
  Com.mkIID "{3050f3cb-98b5-11cf-bb82-00aa00bdce0b}"
-- --------------------------------------------------
-- 
-- interface IHTMLStyleElement
-- 
-- --------------------------------------------------
data HTMLStyleElement a = HTMLStyleElement
                           
type IHTMLStyleElement a = Automation.IDispatch (HTMLStyleElement a)
iidHTMLStyleElement :: Com.IID (IHTMLStyleElement Automation.Interface)
iidHTMLStyleElement =
  Com.mkIID "{3050f375-98b5-11cf-bb82-00aa00bdce0b}"
-- --------------------------------------------------
-- 
-- dispinterface DispIHTMLStyleElement
-- 
-- --------------------------------------------------

                            
type DispIHTMLStyleElement a = Automation.IDispatch (HTMLStyleElement a)
iidIHTMLStyleElement :: Com.IID (DispIHTMLStyleElement Automation.Interface)
iidIHTMLStyleElement =
  Com.mkIID "{3050f511-98b5-11cf-bb82-00aa00bdce0b}"
-- --------------------------------------------------
-- 
-- coclass HTMLStyleElement
-- 
-- --------------------------------------------------
clsidHTMLStyleElement :: Com.CLSID
clsidHTMLStyleElement =
  Com.mkCLSID "{3050f37d-98b5-11cf-bb82-00aa00bdce0b}"
-- --------------------------------------------------
-- 
-- interface IHTMLStyleFontFace
-- 
-- --------------------------------------------------
data HTMLStyleFontFace a = HTMLStyleFontFace
                            
type IHTMLStyleFontFace a = Automation.IDispatch (HTMLStyleFontFace a)
iidHTMLStyleFontFace :: Com.IID (IHTMLStyleFontFace Automation.Interface)
iidHTMLStyleFontFace =
  Com.mkIID "{3050f3d5-98b5-11cf-bb82-00aa00bdce0b}"
setFontsrc :: Prelude.String -> IHTMLStyleFontFace a -> Prelude.IO ()
setFontsrc v =
  Automation.propertySet "fontsrc" [Automation.inString v]
getFontsrc :: IHTMLStyleFontFace a -> Prelude.IO (Prelude.String)
getFontsrc =
  Automation.propertyGet "fontsrc" [] Automation.outString
-- --------------------------------------------------
-- 
-- coclass HTMLStyleFontFace
-- 
-- --------------------------------------------------
clsidHTMLStyleFontFace :: Com.CLSID
clsidHTMLStyleFontFace =
  Com.mkCLSID "{3050f3d4-98b5-11cf-bb82-00aa00bdce0b}"
-- --------------------------------------------------
-- 
-- interface IHTMLDialog
-- 
-- --------------------------------------------------
data HTMLDialog a = HTMLDialog
                     
type IHTMLDialog a = Automation.IDispatch (HTMLDialog a)
iidHTMLDialog :: Com.IID (IHTMLDialog Automation.Interface)
iidHTMLDialog = Com.mkIID "{3050f216-98b5-11cf-bb82-00aa00bdce0b}"
setDialogTop :: (Automation.Variant a0) => a0 -> IHTMLDialog a -> Prelude.IO ()
setDialogTop v =
  Automation.propertySet "dialogTop" [Automation.inVariant v]
getDialogTop :: (Automation.Variant a0) => IHTMLDialog a -> Prelude.IO (a0)
getDialogTop =
  Automation.propertyGet "dialogTop" [] Automation.outVariant
setDialogLeft :: (Automation.Variant a0) => a0 -> IHTMLDialog a -> Prelude.IO ()
setDialogLeft v =
  Automation.propertySet "dialogLeft" [Automation.inVariant v]
getDialogLeft :: (Automation.Variant a0) => IHTMLDialog a -> Prelude.IO (a0)
getDialogLeft =
  Automation.propertyGet "dialogLeft" [] Automation.outVariant
setDialogWidth :: (Automation.Variant a0) => a0 -> IHTMLDialog a -> Prelude.IO ()
setDialogWidth v =
  Automation.propertySet "dialogWidth" [Automation.inVariant v]
getDialogWidth :: (Automation.Variant a0) => IHTMLDialog a -> Prelude.IO (a0)
getDialogWidth =
  Automation.propertyGet "dialogWidth" [] Automation.outVariant
setDialogHeight :: (Automation.Variant a0) => a0 -> IHTMLDialog a -> Prelude.IO ()
setDialogHeight v =
  Automation.propertySet "dialogHeight" [Automation.inVariant v]
getDialogHeight :: (Automation.Variant a0) => IHTMLDialog a -> Prelude.IO (a0)
getDialogHeight =
  Automation.propertyGet "dialogHeight" [] Automation.outVariant
getDialogArguments :: (Automation.Variant a0) => IHTMLDialog a -> Prelude.IO (a0)
getDialogArguments =
  Automation.propertyGet "dialogArguments" [] Automation.outVariant
-- --------------------------------------------------
-- 
-- coclass HTMLDialog
-- 
-- --------------------------------------------------
clsidHTMLDialog :: Com.CLSID
clsidHTMLDialog =
  Com.mkCLSID "{3050f28a-98b5-11cf-bb82-00aa00bdce0b}"
