module Office where

import qualified Prelude
import qualified Automation (IDispatch, Interface, outIDispatch, 
                             propertyGet, outInt, inInt, outString, method0, method4, 
                             function1, inString, propertySet, Variant, outVariant, inVariant, 
                             outIUnknown, outFloat, inFloat, inIDispatch)
import qualified Com (IID, mkIID, IUnknown)
import qualified Int (Int16, Int32)

data MsoLineDashStyle
 = MsoLineDashStyleMixed
 | MsoLineSolid
 | MsoLineSquareDot
 | MsoLineRoundDot
 | MsoLineDash
 | MsoLineDashDot
 | MsoLineDashDotDot
 | MsoLineLongDash
 | MsoLineLongDashDot
 
marshallMsoLineDashStyle :: MsoLineDashStyle -> Prelude.IO Int.Int16
marshallMsoLineDashStyle v =
  case v of
     MsoLineDashStyleMixed -> Prelude.return ((-2))
     MsoLineSolid -> Prelude.return (1)
     MsoLineSquareDot -> Prelude.return (2)
     MsoLineRoundDot -> Prelude.return (3)
     MsoLineDash -> Prelude.return (4)
     MsoLineDashDot -> Prelude.return (5)
     MsoLineDashDotDot -> Prelude.return (6)
     MsoLineLongDash -> Prelude.return (7)
     MsoLineLongDashDot -> Prelude.return (8)
unmarshallMsoLineDashStyle :: Int.Int16 -> Prelude.IO MsoLineDashStyle
unmarshallMsoLineDashStyle v =
  case v of
     (-2) -> Prelude.return (MsoLineDashStyleMixed)
     1 -> Prelude.return (MsoLineSolid)
     2 -> Prelude.return (MsoLineSquareDot)
     3 -> Prelude.return (MsoLineRoundDot)
     4 -> Prelude.return (MsoLineDash)
     5 -> Prelude.return (MsoLineDashDot)
     6 -> Prelude.return (MsoLineDashDotDot)
     7 -> Prelude.return (MsoLineLongDash)
     8 -> Prelude.return (MsoLineLongDashDot)
     _ -> Prelude.fail (Prelude.userError "unmarshallMsoLineDashStyle: illegal enum value ")
data MsoLineStyle
 = MsoLineStyleMixed
 | MsoLineSingle
 | MsoLineThinThin
 | MsoLineThinThick
 | MsoLineThickThin
 | MsoLineThickBetweenThin
 
marshallMsoLineStyle :: MsoLineStyle -> Prelude.IO Int.Int16
marshallMsoLineStyle v =
  case v of
     MsoLineStyleMixed -> Prelude.return ((-2))
     MsoLineSingle -> Prelude.return (1)
     MsoLineThinThin -> Prelude.return (2)
     MsoLineThinThick -> Prelude.return (3)
     MsoLineThickThin -> Prelude.return (4)
     MsoLineThickBetweenThin -> Prelude.return (5)
unmarshallMsoLineStyle :: Int.Int16 -> Prelude.IO MsoLineStyle
unmarshallMsoLineStyle v =
  case v of
     (-2) -> Prelude.return (MsoLineStyleMixed)
     1 -> Prelude.return (MsoLineSingle)
     2 -> Prelude.return (MsoLineThinThin)
     3 -> Prelude.return (MsoLineThinThick)
     4 -> Prelude.return (MsoLineThickThin)
     5 -> Prelude.return (MsoLineThickBetweenThin)
     _ -> Prelude.fail (Prelude.userError "unmarshallMsoLineStyle: illegal enum value ")
data MsoArrowheadStyle
 = MsoArrowheadStyleMixed
 | MsoArrowheadNone
 | MsoArrowheadTriangle
 | MsoArrowheadOpen
 | MsoArrowheadStealth
 | MsoArrowheadDiamond
 | MsoArrowheadOval
 
marshallMsoArrowheadStyle :: MsoArrowheadStyle -> Prelude.IO Int.Int16
marshallMsoArrowheadStyle v =
  case v of
     MsoArrowheadStyleMixed -> Prelude.return ((-2))
     MsoArrowheadNone -> Prelude.return (1)
     MsoArrowheadTriangle -> Prelude.return (2)
     MsoArrowheadOpen -> Prelude.return (3)
     MsoArrowheadStealth -> Prelude.return (4)
     MsoArrowheadDiamond -> Prelude.return (5)
     MsoArrowheadOval -> Prelude.return (6)
unmarshallMsoArrowheadStyle :: Int.Int16 -> Prelude.IO MsoArrowheadStyle
unmarshallMsoArrowheadStyle v =
  case v of
     (-2) -> Prelude.return (MsoArrowheadStyleMixed)
     1 -> Prelude.return (MsoArrowheadNone)
     2 -> Prelude.return (MsoArrowheadTriangle)
     3 -> Prelude.return (MsoArrowheadOpen)
     4 -> Prelude.return (MsoArrowheadStealth)
     5 -> Prelude.return (MsoArrowheadDiamond)
     6 -> Prelude.return (MsoArrowheadOval)
     _ -> Prelude.fail (Prelude.userError "unmarshallMsoArrowheadStyle: illegal enum value ")
data MsoArrowheadWidth
 = MsoArrowheadWidthMixed
 | MsoArrowheadNarrow
 | MsoArrowheadWidthMedium
 | MsoArrowheadWide
 
marshallMsoArrowheadWidth :: MsoArrowheadWidth -> Prelude.IO Int.Int16
marshallMsoArrowheadWidth v =
  case v of
     MsoArrowheadWidthMixed -> Prelude.return ((-2))
     MsoArrowheadNarrow -> Prelude.return (1)
     MsoArrowheadWidthMedium -> Prelude.return (2)
     MsoArrowheadWide -> Prelude.return (3)
unmarshallMsoArrowheadWidth :: Int.Int16 -> Prelude.IO MsoArrowheadWidth
unmarshallMsoArrowheadWidth v =
  case v of
     (-2) -> Prelude.return (MsoArrowheadWidthMixed)
     1 -> Prelude.return (MsoArrowheadNarrow)
     2 -> Prelude.return (MsoArrowheadWidthMedium)
     3 -> Prelude.return (MsoArrowheadWide)
     _ -> Prelude.fail (Prelude.userError "unmarshallMsoArrowheadWidth: illegal enum value ")
data MsoArrowheadLength
 = MsoArrowheadLengthMixed
 | MsoArrowheadShort
 | MsoArrowheadLengthMedium
 | MsoArrowheadLong
 
marshallMsoArrowheadLength :: MsoArrowheadLength -> Prelude.IO Int.Int16
marshallMsoArrowheadLength v =
  case v of
     MsoArrowheadLengthMixed -> Prelude.return ((-2))
     MsoArrowheadShort -> Prelude.return (1)
     MsoArrowheadLengthMedium -> Prelude.return (2)
     MsoArrowheadLong -> Prelude.return (3)
unmarshallMsoArrowheadLength :: Int.Int16 -> Prelude.IO MsoArrowheadLength
unmarshallMsoArrowheadLength v =
  case v of
     (-2) -> Prelude.return (MsoArrowheadLengthMixed)
     1 -> Prelude.return (MsoArrowheadShort)
     2 -> Prelude.return (MsoArrowheadLengthMedium)
     3 -> Prelude.return (MsoArrowheadLong)
     _ -> Prelude.fail (Prelude.userError "unmarshallMsoArrowheadLength: illegal enum value ")
data MsoFillType
 = MsoFillMixed
 | MsoFillSolid
 | MsoFillPatterned
 | MsoFillGradient
 | MsoFillTextured
 | MsoFillBackground
 | MsoFillPicture
 
marshallMsoFillType :: MsoFillType -> Prelude.IO Int.Int16
marshallMsoFillType v =
  case v of
     MsoFillMixed -> Prelude.return ((-2))
     MsoFillSolid -> Prelude.return (1)
     MsoFillPatterned -> Prelude.return (2)
     MsoFillGradient -> Prelude.return (3)
     MsoFillTextured -> Prelude.return (4)
     MsoFillBackground -> Prelude.return (5)
     MsoFillPicture -> Prelude.return (6)
unmarshallMsoFillType :: Int.Int16 -> Prelude.IO MsoFillType
unmarshallMsoFillType v =
  case v of
     (-2) -> Prelude.return (MsoFillMixed)
     1 -> Prelude.return (MsoFillSolid)
     2 -> Prelude.return (MsoFillPatterned)
     3 -> Prelude.return (MsoFillGradient)
     4 -> Prelude.return (MsoFillTextured)
     5 -> Prelude.return (MsoFillBackground)
     6 -> Prelude.return (MsoFillPicture)
     _ -> Prelude.fail (Prelude.userError "unmarshallMsoFillType: illegal enum value ")
data MsoGradientStyle
 = MsoGradientMixed
 | MsoGradientHorizontal
 | MsoGradientVertical
 | MsoGradientDiagonalUp
 | MsoGradientDiagonalDown
 | MsoGradientFromCorner
 | MsoGradientFromTitle
 | MsoGradientFromCenter
 
marshallMsoGradientStyle :: MsoGradientStyle -> Prelude.IO Int.Int16
marshallMsoGradientStyle v =
  case v of
     MsoGradientMixed -> Prelude.return ((-2))
     MsoGradientHorizontal -> Prelude.return (1)
     MsoGradientVertical -> Prelude.return (2)
     MsoGradientDiagonalUp -> Prelude.return (3)
     MsoGradientDiagonalDown -> Prelude.return (4)
     MsoGradientFromCorner -> Prelude.return (5)
     MsoGradientFromTitle -> Prelude.return (6)
     MsoGradientFromCenter -> Prelude.return (7)
unmarshallMsoGradientStyle :: Int.Int16 -> Prelude.IO MsoGradientStyle
unmarshallMsoGradientStyle v =
  case v of
     (-2) -> Prelude.return (MsoGradientMixed)
     1 -> Prelude.return (MsoGradientHorizontal)
     2 -> Prelude.return (MsoGradientVertical)
     3 -> Prelude.return (MsoGradientDiagonalUp)
     4 -> Prelude.return (MsoGradientDiagonalDown)
     5 -> Prelude.return (MsoGradientFromCorner)
     6 -> Prelude.return (MsoGradientFromTitle)
     7 -> Prelude.return (MsoGradientFromCenter)
     _ -> Prelude.fail (Prelude.userError "unmarshallMsoGradientStyle: illegal enum value ")
data MsoGradientColorType
 = MsoGradientColorMixed
 | MsoGradientOneColor
 | MsoGradientTwoColors
 | MsoGradientPresetColors
 
marshallMsoGradientColorType :: MsoGradientColorType -> Prelude.IO Int.Int16
marshallMsoGradientColorType v =
  case v of
     MsoGradientColorMixed -> Prelude.return ((-2))
     MsoGradientOneColor -> Prelude.return (1)
     MsoGradientTwoColors -> Prelude.return (2)
     MsoGradientPresetColors -> Prelude.return (3)
unmarshallMsoGradientColorType :: Int.Int16 -> Prelude.IO MsoGradientColorType
unmarshallMsoGradientColorType v =
  case v of
     (-2) -> Prelude.return (MsoGradientColorMixed)
     1 -> Prelude.return (MsoGradientOneColor)
     2 -> Prelude.return (MsoGradientTwoColors)
     3 -> Prelude.return (MsoGradientPresetColors)
     _ -> Prelude.fail (Prelude.userError "unmarshallMsoGradientColorType: illegal enum value ")
data MsoTextureType
 = MsoTextureTypeMixed
 | MsoTexturePreset
 | MsoTextureUserDefined
 
marshallMsoTextureType :: MsoTextureType -> Prelude.IO Int.Int16
marshallMsoTextureType v =
  case v of
     MsoTextureTypeMixed -> Prelude.return ((-2))
     MsoTexturePreset -> Prelude.return (1)
     MsoTextureUserDefined -> Prelude.return (2)
unmarshallMsoTextureType :: Int.Int16 -> Prelude.IO MsoTextureType
unmarshallMsoTextureType v =
  case v of
     (-2) -> Prelude.return (MsoTextureTypeMixed)
     1 -> Prelude.return (MsoTexturePreset)
     2 -> Prelude.return (MsoTextureUserDefined)
     _ -> Prelude.fail (Prelude.userError "unmarshallMsoTextureType: illegal enum value ")
data MsoPresetTexture
 = MsoPresetTextureMixed
 | MsoTexturePapyrus
 | MsoTextureCanvas
 | MsoTextureDenim
 | MsoTextureWovenMat
 | MsoTextureWaterDroplets
 | MsoTexturePaperBag
 | MsoTextureFishFossil
 | MsoTextureSand
 | MsoTextureGreenMarble
 | MsoTextureWhiteMarble
 | MsoTextureBrownMarble
 | MsoTextureGranite
 | MsoTextureNewsprint
 | MsoTextureRecycledPaper
 | MsoTextureParchment
 | MsoTextureStationery
 | MsoTextureBlueTissuePaper
 | MsoTexturePinkTissuePaper
 | MsoTexturePurpleMesh
 | MsoTextureBouquet
 | MsoTextureCork
 | MsoTextureWalnut
 | MsoTextureOak
 | MsoTextureMediumWood
 
marshallMsoPresetTexture :: MsoPresetTexture -> Prelude.IO Int.Int16
marshallMsoPresetTexture v =
  case v of
     MsoPresetTextureMixed -> Prelude.return ((-2))
     MsoTexturePapyrus -> Prelude.return (1)
     MsoTextureCanvas -> Prelude.return (2)
     MsoTextureDenim -> Prelude.return (3)
     MsoTextureWovenMat -> Prelude.return (4)
     MsoTextureWaterDroplets -> Prelude.return (5)
     MsoTexturePaperBag -> Prelude.return (6)
     MsoTextureFishFossil -> Prelude.return (7)
     MsoTextureSand -> Prelude.return (8)
     MsoTextureGreenMarble -> Prelude.return (9)
     MsoTextureWhiteMarble -> Prelude.return (10)
     MsoTextureBrownMarble -> Prelude.return (11)
     MsoTextureGranite -> Prelude.return (12)
     MsoTextureNewsprint -> Prelude.return (13)
     MsoTextureRecycledPaper -> Prelude.return (14)
     MsoTextureParchment -> Prelude.return (15)
     MsoTextureStationery -> Prelude.return (16)
     MsoTextureBlueTissuePaper -> Prelude.return (17)
     MsoTexturePinkTissuePaper -> Prelude.return (18)
     MsoTexturePurpleMesh -> Prelude.return (19)
     MsoTextureBouquet -> Prelude.return (20)
     MsoTextureCork -> Prelude.return (21)
     MsoTextureWalnut -> Prelude.return (22)
     MsoTextureOak -> Prelude.return (23)
     MsoTextureMediumWood -> Prelude.return (24)
unmarshallMsoPresetTexture :: Int.Int16 -> Prelude.IO MsoPresetTexture
unmarshallMsoPresetTexture v =
  case v of
     (-2) -> Prelude.return (MsoPresetTextureMixed)
     1 -> Prelude.return (MsoTexturePapyrus)
     2 -> Prelude.return (MsoTextureCanvas)
     3 -> Prelude.return (MsoTextureDenim)
     4 -> Prelude.return (MsoTextureWovenMat)
     5 -> Prelude.return (MsoTextureWaterDroplets)
     6 -> Prelude.return (MsoTexturePaperBag)
     7 -> Prelude.return (MsoTextureFishFossil)
     8 -> Prelude.return (MsoTextureSand)
     9 -> Prelude.return (MsoTextureGreenMarble)
     10 -> Prelude.return (MsoTextureWhiteMarble)
     11 -> Prelude.return (MsoTextureBrownMarble)
     12 -> Prelude.return (MsoTextureGranite)
     13 -> Prelude.return (MsoTextureNewsprint)
     14 -> Prelude.return (MsoTextureRecycledPaper)
     15 -> Prelude.return (MsoTextureParchment)
     16 -> Prelude.return (MsoTextureStationery)
     17 -> Prelude.return (MsoTextureBlueTissuePaper)
     18 -> Prelude.return (MsoTexturePinkTissuePaper)
     19 -> Prelude.return (MsoTexturePurpleMesh)
     20 -> Prelude.return (MsoTextureBouquet)
     21 -> Prelude.return (MsoTextureCork)
     22 -> Prelude.return (MsoTextureWalnut)
     23 -> Prelude.return (MsoTextureOak)
     24 -> Prelude.return (MsoTextureMediumWood)
     _ -> Prelude.fail (Prelude.userError "unmarshallMsoPresetTexture: illegal enum value ")
data MsoPatternType
 = MsoPatternMixed
 | MsoPattern5Percent
 | MsoPattern10Percent
 | MsoPattern20Percent
 | MsoPattern25Percent
 | MsoPattern30Percent
 | MsoPattern40Percent
 | MsoPattern50Percent
 | MsoPattern60Percent
 | MsoPattern70Percent
 | MsoPattern75Percent
 | MsoPattern80Percent
 | MsoPattern90Percent
 | MsoPatternDarkHorizontal
 | MsoPatternDarkVertical
 | MsoPatternDarkDownwardDiagonal
 | MsoPatternDarkUpwardDiagonal
 | MsoPatternSmallCheckerBoard
 | MsoPatternTrellis
 | MsoPatternLightHorizontal
 | MsoPatternLightVertical
 | MsoPatternLightDownwardDiagonal
 | MsoPatternLightUpwardDiagonal
 | MsoPatternSmallGrid
 | MsoPatternDottedDiamond
 | MsoPatternWideDownwardDiagonal
 | MsoPatternWideUpwardDiagonal
 | MsoPatternDashedUpwardDiagonal
 | MsoPatternDashedDownwardDiagonal
 | MsoPatternNarrowVertical
 | MsoPatternNarrowHorizontal
 | MsoPatternDashedVertical
 | MsoPatternDashedHorizontal
 | MsoPatternLargeConfetti
 | MsoPatternLargeGrid
 | MsoPatternHorizontalBrick
 | MsoPatternLargeCheckerBoard
 | MsoPatternSmallConfetti
 | MsoPatternZigZag
 | MsoPatternSolidDiamond
 | MsoPatternDiagonalBrick
 | MsoPatternOutlinedDiamond
 | MsoPatternPlaid
 | MsoPatternSphere
 | MsoPatternWeave
 | MsoPatternDottedGrid
 | MsoPatternDivot
 | MsoPatternShingle
 | MsoPatternWave
 
marshallMsoPatternType :: MsoPatternType -> Prelude.IO Int.Int16
marshallMsoPatternType v =
  case v of
     MsoPatternMixed -> Prelude.return ((-2))
     MsoPattern5Percent -> Prelude.return (1)
     MsoPattern10Percent -> Prelude.return (2)
     MsoPattern20Percent -> Prelude.return (3)
     MsoPattern25Percent -> Prelude.return (4)
     MsoPattern30Percent -> Prelude.return (5)
     MsoPattern40Percent -> Prelude.return (6)
     MsoPattern50Percent -> Prelude.return (7)
     MsoPattern60Percent -> Prelude.return (8)
     MsoPattern70Percent -> Prelude.return (9)
     MsoPattern75Percent -> Prelude.return (10)
     MsoPattern80Percent -> Prelude.return (11)
     MsoPattern90Percent -> Prelude.return (12)
     MsoPatternDarkHorizontal -> Prelude.return (13)
     MsoPatternDarkVertical -> Prelude.return (14)
     MsoPatternDarkDownwardDiagonal -> Prelude.return (15)
     MsoPatternDarkUpwardDiagonal -> Prelude.return (16)
     MsoPatternSmallCheckerBoard -> Prelude.return (17)
     MsoPatternTrellis -> Prelude.return (18)
     MsoPatternLightHorizontal -> Prelude.return (19)
     MsoPatternLightVertical -> Prelude.return (20)
     MsoPatternLightDownwardDiagonal -> Prelude.return (21)
     MsoPatternLightUpwardDiagonal -> Prelude.return (22)
     MsoPatternSmallGrid -> Prelude.return (23)
     MsoPatternDottedDiamond -> Prelude.return (24)
     MsoPatternWideDownwardDiagonal -> Prelude.return (25)
     MsoPatternWideUpwardDiagonal -> Prelude.return (26)
     MsoPatternDashedUpwardDiagonal -> Prelude.return (27)
     MsoPatternDashedDownwardDiagonal -> Prelude.return (28)
     MsoPatternNarrowVertical -> Prelude.return (29)
     MsoPatternNarrowHorizontal -> Prelude.return (30)
     MsoPatternDashedVertical -> Prelude.return (31)
     MsoPatternDashedHorizontal -> Prelude.return (32)
     MsoPatternLargeConfetti -> Prelude.return (33)
     MsoPatternLargeGrid -> Prelude.return (34)
     MsoPatternHorizontalBrick -> Prelude.return (35)
     MsoPatternLargeCheckerBoard -> Prelude.return (36)
     MsoPatternSmallConfetti -> Prelude.return (37)
     MsoPatternZigZag -> Prelude.return (38)
     MsoPatternSolidDiamond -> Prelude.return (39)
     MsoPatternDiagonalBrick -> Prelude.return (40)
     MsoPatternOutlinedDiamond -> Prelude.return (41)
     MsoPatternPlaid -> Prelude.return (42)
     MsoPatternSphere -> Prelude.return (43)
     MsoPatternWeave -> Prelude.return (44)
     MsoPatternDottedGrid -> Prelude.return (45)
     MsoPatternDivot -> Prelude.return (46)
     MsoPatternShingle -> Prelude.return (47)
     MsoPatternWave -> Prelude.return (48)
unmarshallMsoPatternType :: Int.Int16 -> Prelude.IO MsoPatternType
unmarshallMsoPatternType v =
  case v of
     (-2) -> Prelude.return (MsoPatternMixed)
     1 -> Prelude.return (MsoPattern5Percent)
     2 -> Prelude.return (MsoPattern10Percent)
     3 -> Prelude.return (MsoPattern20Percent)
     4 -> Prelude.return (MsoPattern25Percent)
     5 -> Prelude.return (MsoPattern30Percent)
     6 -> Prelude.return (MsoPattern40Percent)
     7 -> Prelude.return (MsoPattern50Percent)
     8 -> Prelude.return (MsoPattern60Percent)
     9 -> Prelude.return (MsoPattern70Percent)
     10 -> Prelude.return (MsoPattern75Percent)
     11 -> Prelude.return (MsoPattern80Percent)
     12 -> Prelude.return (MsoPattern90Percent)
     13 -> Prelude.return (MsoPatternDarkHorizontal)
     14 -> Prelude.return (MsoPatternDarkVertical)
     15 -> Prelude.return (MsoPatternDarkDownwardDiagonal)
     16 -> Prelude.return (MsoPatternDarkUpwardDiagonal)
     17 -> Prelude.return (MsoPatternSmallCheckerBoard)
     18 -> Prelude.return (MsoPatternTrellis)
     19 -> Prelude.return (MsoPatternLightHorizontal)
     20 -> Prelude.return (MsoPatternLightVertical)
     21 -> Prelude.return (MsoPatternLightDownwardDiagonal)
     22 -> Prelude.return (MsoPatternLightUpwardDiagonal)
     23 -> Prelude.return (MsoPatternSmallGrid)
     24 -> Prelude.return (MsoPatternDottedDiamond)
     25 -> Prelude.return (MsoPatternWideDownwardDiagonal)
     26 -> Prelude.return (MsoPatternWideUpwardDiagonal)
     27 -> Prelude.return (MsoPatternDashedUpwardDiagonal)
     28 -> Prelude.return (MsoPatternDashedDownwardDiagonal)
     29 -> Prelude.return (MsoPatternNarrowVertical)
     30 -> Prelude.return (MsoPatternNarrowHorizontal)
     31 -> Prelude.return (MsoPatternDashedVertical)
     32 -> Prelude.return (MsoPatternDashedHorizontal)
     33 -> Prelude.return (MsoPatternLargeConfetti)
     34 -> Prelude.return (MsoPatternLargeGrid)
     35 -> Prelude.return (MsoPatternHorizontalBrick)
     36 -> Prelude.return (MsoPatternLargeCheckerBoard)
     37 -> Prelude.return (MsoPatternSmallConfetti)
     38 -> Prelude.return (MsoPatternZigZag)
     39 -> Prelude.return (MsoPatternSolidDiamond)
     40 -> Prelude.return (MsoPatternDiagonalBrick)
     41 -> Prelude.return (MsoPatternOutlinedDiamond)
     42 -> Prelude.return (MsoPatternPlaid)
     43 -> Prelude.return (MsoPatternSphere)
     44 -> Prelude.return (MsoPatternWeave)
     45 -> Prelude.return (MsoPatternDottedGrid)
     46 -> Prelude.return (MsoPatternDivot)
     47 -> Prelude.return (MsoPatternShingle)
     48 -> Prelude.return (MsoPatternWave)
     _ -> Prelude.fail (Prelude.userError "unmarshallMsoPatternType: illegal enum value ")
data MsoPresetGradientType
 = MsoPresetGradientMixed
 | MsoGradientEarlySunset
 | MsoGradientLateSunset
 | MsoGradientNightfall
 | MsoGradientDaybreak
 | MsoGradientHorizon
 | MsoGradientDesert
 | MsoGradientOcean
 | MsoGradientCalmWater
 | MsoGradientFire
 | MsoGradientFog
 | MsoGradientMoss
 | MsoGradientPeacock
 | MsoGradientWheat
 | MsoGradientParchment
 | MsoGradientMahogany
 | MsoGradientRainbow
 | MsoGradientRainbowII
 | MsoGradientGold
 | MsoGradientGoldII
 | MsoGradientBrass
 | MsoGradientChrome
 | MsoGradientChromeII
 | MsoGradientSilver
 | MsoGradientSapphire
 
marshallMsoPresetGradientType :: MsoPresetGradientType -> Prelude.IO Int.Int16
marshallMsoPresetGradientType v =
  case v of
     MsoPresetGradientMixed -> Prelude.return ((-2))
     MsoGradientEarlySunset -> Prelude.return (1)
     MsoGradientLateSunset -> Prelude.return (2)
     MsoGradientNightfall -> Prelude.return (3)
     MsoGradientDaybreak -> Prelude.return (4)
     MsoGradientHorizon -> Prelude.return (5)
     MsoGradientDesert -> Prelude.return (6)
     MsoGradientOcean -> Prelude.return (7)
     MsoGradientCalmWater -> Prelude.return (8)
     MsoGradientFire -> Prelude.return (9)
     MsoGradientFog -> Prelude.return (10)
     MsoGradientMoss -> Prelude.return (11)
     MsoGradientPeacock -> Prelude.return (12)
     MsoGradientWheat -> Prelude.return (13)
     MsoGradientParchment -> Prelude.return (14)
     MsoGradientMahogany -> Prelude.return (15)
     MsoGradientRainbow -> Prelude.return (16)
     MsoGradientRainbowII -> Prelude.return (17)
     MsoGradientGold -> Prelude.return (18)
     MsoGradientGoldII -> Prelude.return (19)
     MsoGradientBrass -> Prelude.return (20)
     MsoGradientChrome -> Prelude.return (21)
     MsoGradientChromeII -> Prelude.return (22)
     MsoGradientSilver -> Prelude.return (23)
     MsoGradientSapphire -> Prelude.return (24)
unmarshallMsoPresetGradientType :: Int.Int16 -> Prelude.IO MsoPresetGradientType
unmarshallMsoPresetGradientType v =
  case v of
     (-2) -> Prelude.return (MsoPresetGradientMixed)
     1 -> Prelude.return (MsoGradientEarlySunset)
     2 -> Prelude.return (MsoGradientLateSunset)
     3 -> Prelude.return (MsoGradientNightfall)
     4 -> Prelude.return (MsoGradientDaybreak)
     5 -> Prelude.return (MsoGradientHorizon)
     6 -> Prelude.return (MsoGradientDesert)
     7 -> Prelude.return (MsoGradientOcean)
     8 -> Prelude.return (MsoGradientCalmWater)
     9 -> Prelude.return (MsoGradientFire)
     10 -> Prelude.return (MsoGradientFog)
     11 -> Prelude.return (MsoGradientMoss)
     12 -> Prelude.return (MsoGradientPeacock)
     13 -> Prelude.return (MsoGradientWheat)
     14 -> Prelude.return (MsoGradientParchment)
     15 -> Prelude.return (MsoGradientMahogany)
     16 -> Prelude.return (MsoGradientRainbow)
     17 -> Prelude.return (MsoGradientRainbowII)
     18 -> Prelude.return (MsoGradientGold)
     19 -> Prelude.return (MsoGradientGoldII)
     20 -> Prelude.return (MsoGradientBrass)
     21 -> Prelude.return (MsoGradientChrome)
     22 -> Prelude.return (MsoGradientChromeII)
     23 -> Prelude.return (MsoGradientSilver)
     24 -> Prelude.return (MsoGradientSapphire)
     _ -> Prelude.fail (Prelude.userError "unmarshallMsoPresetGradientType: illegal enum value ")
data MsoShadowType
 = MsoShadowMixed
 | MsoShadow1
 | MsoShadow2
 | MsoShadow3
 | MsoShadow4
 | MsoShadow5
 | MsoShadow6
 | MsoShadow7
 | MsoShadow8
 | MsoShadow9
 | MsoShadow10
 | MsoShadow11
 | MsoShadow12
 | MsoShadow13
 | MsoShadow14
 | MsoShadow15
 | MsoShadow16
 | MsoShadow17
 | MsoShadow18
 | MsoShadow19
 | MsoShadow20
 
marshallMsoShadowType :: MsoShadowType -> Prelude.IO Int.Int16
marshallMsoShadowType v =
  case v of
     MsoShadowMixed -> Prelude.return ((-2))
     MsoShadow1 -> Prelude.return (1)
     MsoShadow2 -> Prelude.return (2)
     MsoShadow3 -> Prelude.return (3)
     MsoShadow4 -> Prelude.return (4)
     MsoShadow5 -> Prelude.return (5)
     MsoShadow6 -> Prelude.return (6)
     MsoShadow7 -> Prelude.return (7)
     MsoShadow8 -> Prelude.return (8)
     MsoShadow9 -> Prelude.return (9)
     MsoShadow10 -> Prelude.return (10)
     MsoShadow11 -> Prelude.return (11)
     MsoShadow12 -> Prelude.return (12)
     MsoShadow13 -> Prelude.return (13)
     MsoShadow14 -> Prelude.return (14)
     MsoShadow15 -> Prelude.return (15)
     MsoShadow16 -> Prelude.return (16)
     MsoShadow17 -> Prelude.return (17)
     MsoShadow18 -> Prelude.return (18)
     MsoShadow19 -> Prelude.return (19)
     MsoShadow20 -> Prelude.return (20)
unmarshallMsoShadowType :: Int.Int16 -> Prelude.IO MsoShadowType
unmarshallMsoShadowType v =
  case v of
     (-2) -> Prelude.return (MsoShadowMixed)
     1 -> Prelude.return (MsoShadow1)
     2 -> Prelude.return (MsoShadow2)
     3 -> Prelude.return (MsoShadow3)
     4 -> Prelude.return (MsoShadow4)
     5 -> Prelude.return (MsoShadow5)
     6 -> Prelude.return (MsoShadow6)
     7 -> Prelude.return (MsoShadow7)
     8 -> Prelude.return (MsoShadow8)
     9 -> Prelude.return (MsoShadow9)
     10 -> Prelude.return (MsoShadow10)
     11 -> Prelude.return (MsoShadow11)
     12 -> Prelude.return (MsoShadow12)
     13 -> Prelude.return (MsoShadow13)
     14 -> Prelude.return (MsoShadow14)
     15 -> Prelude.return (MsoShadow15)
     16 -> Prelude.return (MsoShadow16)
     17 -> Prelude.return (MsoShadow17)
     18 -> Prelude.return (MsoShadow18)
     19 -> Prelude.return (MsoShadow19)
     20 -> Prelude.return (MsoShadow20)
     _ -> Prelude.fail (Prelude.userError "unmarshallMsoShadowType: illegal enum value ")
data MsoPresetTextEffect
 = MsoTextEffectMixed
 | MsoTextEffect1
 | MsoTextEffect2
 | MsoTextEffect3
 | MsoTextEffect4
 | MsoTextEffect5
 | MsoTextEffect6
 | MsoTextEffect7
 | MsoTextEffect8
 | MsoTextEffect9
 | MsoTextEffect10
 | MsoTextEffect11
 | MsoTextEffect12
 | MsoTextEffect13
 | MsoTextEffect14
 | MsoTextEffect15
 | MsoTextEffect16
 | MsoTextEffect17
 | MsoTextEffect18
 | MsoTextEffect19
 | MsoTextEffect20
 | MsoTextEffect21
 | MsoTextEffect22
 | MsoTextEffect23
 | MsoTextEffect24
 | MsoTextEffect25
 | MsoTextEffect26
 | MsoTextEffect27
 | MsoTextEffect28
 | MsoTextEffect29
 | MsoTextEffect30
 
marshallMsoPresetTextEffect :: MsoPresetTextEffect -> Prelude.IO Int.Int16
marshallMsoPresetTextEffect v =
  case v of
     MsoTextEffectMixed -> Prelude.return ((-2))
     MsoTextEffect1 -> Prelude.return (0)
     MsoTextEffect2 -> Prelude.return (1)
     MsoTextEffect3 -> Prelude.return (2)
     MsoTextEffect4 -> Prelude.return (3)
     MsoTextEffect5 -> Prelude.return (4)
     MsoTextEffect6 -> Prelude.return (5)
     MsoTextEffect7 -> Prelude.return (6)
     MsoTextEffect8 -> Prelude.return (7)
     MsoTextEffect9 -> Prelude.return (8)
     MsoTextEffect10 -> Prelude.return (9)
     MsoTextEffect11 -> Prelude.return (10)
     MsoTextEffect12 -> Prelude.return (11)
     MsoTextEffect13 -> Prelude.return (12)
     MsoTextEffect14 -> Prelude.return (13)
     MsoTextEffect15 -> Prelude.return (14)
     MsoTextEffect16 -> Prelude.return (15)
     MsoTextEffect17 -> Prelude.return (16)
     MsoTextEffect18 -> Prelude.return (17)
     MsoTextEffect19 -> Prelude.return (18)
     MsoTextEffect20 -> Prelude.return (19)
     MsoTextEffect21 -> Prelude.return (20)
     MsoTextEffect22 -> Prelude.return (21)
     MsoTextEffect23 -> Prelude.return (22)
     MsoTextEffect24 -> Prelude.return (23)
     MsoTextEffect25 -> Prelude.return (24)
     MsoTextEffect26 -> Prelude.return (25)
     MsoTextEffect27 -> Prelude.return (26)
     MsoTextEffect28 -> Prelude.return (27)
     MsoTextEffect29 -> Prelude.return (28)
     MsoTextEffect30 -> Prelude.return (29)
unmarshallMsoPresetTextEffect :: Int.Int16 -> Prelude.IO MsoPresetTextEffect
unmarshallMsoPresetTextEffect v =
  case v of
     (-2) -> Prelude.return (MsoTextEffectMixed)
     0 -> Prelude.return (MsoTextEffect1)
     1 -> Prelude.return (MsoTextEffect2)
     2 -> Prelude.return (MsoTextEffect3)
     3 -> Prelude.return (MsoTextEffect4)
     4 -> Prelude.return (MsoTextEffect5)
     5 -> Prelude.return (MsoTextEffect6)
     6 -> Prelude.return (MsoTextEffect7)
     7 -> Prelude.return (MsoTextEffect8)
     8 -> Prelude.return (MsoTextEffect9)
     9 -> Prelude.return (MsoTextEffect10)
     10 -> Prelude.return (MsoTextEffect11)
     11 -> Prelude.return (MsoTextEffect12)
     12 -> Prelude.return (MsoTextEffect13)
     13 -> Prelude.return (MsoTextEffect14)
     14 -> Prelude.return (MsoTextEffect15)
     15 -> Prelude.return (MsoTextEffect16)
     16 -> Prelude.return (MsoTextEffect17)
     17 -> Prelude.return (MsoTextEffect18)
     18 -> Prelude.return (MsoTextEffect19)
     19 -> Prelude.return (MsoTextEffect20)
     20 -> Prelude.return (MsoTextEffect21)
     21 -> Prelude.return (MsoTextEffect22)
     22 -> Prelude.return (MsoTextEffect23)
     23 -> Prelude.return (MsoTextEffect24)
     24 -> Prelude.return (MsoTextEffect25)
     25 -> Prelude.return (MsoTextEffect26)
     26 -> Prelude.return (MsoTextEffect27)
     27 -> Prelude.return (MsoTextEffect28)
     28 -> Prelude.return (MsoTextEffect29)
     29 -> Prelude.return (MsoTextEffect30)
     _ -> Prelude.fail (Prelude.userError "unmarshallMsoPresetTextEffect: illegal enum value ")
data MsoPresetTextEffectShape
 = MsoTextEffectShapeMixed
 | MsoTextEffectShapePlainText
 | MsoTextEffectShapeStop
 | MsoTextEffectShapeTriangleUp
 | MsoTextEffectShapeTriangleDown
 | MsoTextEffectShapeChevronUp
 | MsoTextEffectShapeChevronDown
 | MsoTextEffectShapeRingInside
 | MsoTextEffectShapeRingOutside
 | MsoTextEffectShapeArchUpCurve
 | MsoTextEffectShapeArchDownCurve
 | MsoTextEffectShapeCircleCurve
 | MsoTextEffectShapeButtonCurve
 | MsoTextEffectShapeArchUpPour
 | MsoTextEffectShapeArchDownPour
 | MsoTextEffectShapeCirclePour
 | MsoTextEffectShapeButtonPour
 | MsoTextEffectShapeCurveUp
 | MsoTextEffectShapeCurveDown
 | MsoTextEffectShapeCanUp
 | MsoTextEffectShapeCanDown
 | MsoTextEffectShapeWave1
 | MsoTextEffectShapeWave2
 | MsoTextEffectShapeDoubleWave1
 | MsoTextEffectShapeDoubleWave2
 | MsoTextEffectShapeInflate
 | MsoTextEffectShapeDeflate
 | MsoTextEffectShapeInflateBottom
 | MsoTextEffectShapeDeflateBottom
 | MsoTextEffectShapeInflateTop
 | MsoTextEffectShapeDeflateTop
 | MsoTextEffectShapeDeflateInflate
 | MsoTextEffectShapeDeflateInflateDeflate
 | MsoTextEffectShapeFadeRight
 | MsoTextEffectShapeFadeLeft
 | MsoTextEffectShapeFadeUp
 | MsoTextEffectShapeFadeDown
 | MsoTextEffectShapeSlantUp
 | MsoTextEffectShapeSlantDown
 | MsoTextEffectShapeCascadeUp
 | MsoTextEffectShapeCascadeDown
 
marshallMsoPresetTextEffectShape :: MsoPresetTextEffectShape -> Prelude.IO Int.Int16
marshallMsoPresetTextEffectShape v =
  case v of
     MsoTextEffectShapeMixed -> Prelude.return ((-2))
     MsoTextEffectShapePlainText -> Prelude.return (1)
     MsoTextEffectShapeStop -> Prelude.return (2)
     MsoTextEffectShapeTriangleUp -> Prelude.return (3)
     MsoTextEffectShapeTriangleDown -> Prelude.return (4)
     MsoTextEffectShapeChevronUp -> Prelude.return (5)
     MsoTextEffectShapeChevronDown -> Prelude.return (6)
     MsoTextEffectShapeRingInside -> Prelude.return (7)
     MsoTextEffectShapeRingOutside -> Prelude.return (8)
     MsoTextEffectShapeArchUpCurve -> Prelude.return (9)
     MsoTextEffectShapeArchDownCurve -> Prelude.return (10)
     MsoTextEffectShapeCircleCurve -> Prelude.return (11)
     MsoTextEffectShapeButtonCurve -> Prelude.return (12)
     MsoTextEffectShapeArchUpPour -> Prelude.return (13)
     MsoTextEffectShapeArchDownPour -> Prelude.return (14)
     MsoTextEffectShapeCirclePour -> Prelude.return (15)
     MsoTextEffectShapeButtonPour -> Prelude.return (16)
     MsoTextEffectShapeCurveUp -> Prelude.return (17)
     MsoTextEffectShapeCurveDown -> Prelude.return (18)
     MsoTextEffectShapeCanUp -> Prelude.return (19)
     MsoTextEffectShapeCanDown -> Prelude.return (20)
     MsoTextEffectShapeWave1 -> Prelude.return (21)
     MsoTextEffectShapeWave2 -> Prelude.return (22)
     MsoTextEffectShapeDoubleWave1 -> Prelude.return (23)
     MsoTextEffectShapeDoubleWave2 -> Prelude.return (24)
     MsoTextEffectShapeInflate -> Prelude.return (25)
     MsoTextEffectShapeDeflate -> Prelude.return (26)
     MsoTextEffectShapeInflateBottom -> Prelude.return (27)
     MsoTextEffectShapeDeflateBottom -> Prelude.return (28)
     MsoTextEffectShapeInflateTop -> Prelude.return (29)
     MsoTextEffectShapeDeflateTop -> Prelude.return (30)
     MsoTextEffectShapeDeflateInflate -> Prelude.return (31)
     MsoTextEffectShapeDeflateInflateDeflate -> Prelude.return (32)
     MsoTextEffectShapeFadeRight -> Prelude.return (33)
     MsoTextEffectShapeFadeLeft -> Prelude.return (34)
     MsoTextEffectShapeFadeUp -> Prelude.return (35)
     MsoTextEffectShapeFadeDown -> Prelude.return (36)
     MsoTextEffectShapeSlantUp -> Prelude.return (37)
     MsoTextEffectShapeSlantDown -> Prelude.return (38)
     MsoTextEffectShapeCascadeUp -> Prelude.return (39)
     MsoTextEffectShapeCascadeDown -> Prelude.return (40)
unmarshallMsoPresetTextEffectShape :: Int.Int16 -> Prelude.IO MsoPresetTextEffectShape
unmarshallMsoPresetTextEffectShape v =
  case v of
     (-2) -> Prelude.return (MsoTextEffectShapeMixed)
     1 -> Prelude.return (MsoTextEffectShapePlainText)
     2 -> Prelude.return (MsoTextEffectShapeStop)
     3 -> Prelude.return (MsoTextEffectShapeTriangleUp)
     4 -> Prelude.return (MsoTextEffectShapeTriangleDown)
     5 -> Prelude.return (MsoTextEffectShapeChevronUp)
     6 -> Prelude.return (MsoTextEffectShapeChevronDown)
     7 -> Prelude.return (MsoTextEffectShapeRingInside)
     8 -> Prelude.return (MsoTextEffectShapeRingOutside)
     9 -> Prelude.return (MsoTextEffectShapeArchUpCurve)
     10 -> Prelude.return (MsoTextEffectShapeArchDownCurve)
     11 -> Prelude.return (MsoTextEffectShapeCircleCurve)
     12 -> Prelude.return (MsoTextEffectShapeButtonCurve)
     13 -> Prelude.return (MsoTextEffectShapeArchUpPour)
     14 -> Prelude.return (MsoTextEffectShapeArchDownPour)
     15 -> Prelude.return (MsoTextEffectShapeCirclePour)
     16 -> Prelude.return (MsoTextEffectShapeButtonPour)
     17 -> Prelude.return (MsoTextEffectShapeCurveUp)
     18 -> Prelude.return (MsoTextEffectShapeCurveDown)
     19 -> Prelude.return (MsoTextEffectShapeCanUp)
     20 -> Prelude.return (MsoTextEffectShapeCanDown)
     21 -> Prelude.return (MsoTextEffectShapeWave1)
     22 -> Prelude.return (MsoTextEffectShapeWave2)
     23 -> Prelude.return (MsoTextEffectShapeDoubleWave1)
     24 -> Prelude.return (MsoTextEffectShapeDoubleWave2)
     25 -> Prelude.return (MsoTextEffectShapeInflate)
     26 -> Prelude.return (MsoTextEffectShapeDeflate)
     27 -> Prelude.return (MsoTextEffectShapeInflateBottom)
     28 -> Prelude.return (MsoTextEffectShapeDeflateBottom)
     29 -> Prelude.return (MsoTextEffectShapeInflateTop)
     30 -> Prelude.return (MsoTextEffectShapeDeflateTop)
     31 -> Prelude.return (MsoTextEffectShapeDeflateInflate)
     32 -> Prelude.return (MsoTextEffectShapeDeflateInflateDeflate)
     33 -> Prelude.return (MsoTextEffectShapeFadeRight)
     34 -> Prelude.return (MsoTextEffectShapeFadeLeft)
     35 -> Prelude.return (MsoTextEffectShapeFadeUp)
     36 -> Prelude.return (MsoTextEffectShapeFadeDown)
     37 -> Prelude.return (MsoTextEffectShapeSlantUp)
     38 -> Prelude.return (MsoTextEffectShapeSlantDown)
     39 -> Prelude.return (MsoTextEffectShapeCascadeUp)
     40 -> Prelude.return (MsoTextEffectShapeCascadeDown)
     _ -> Prelude.fail (Prelude.userError "unmarshallMsoPresetTextEffectShape: illegal enum value ")
data MsoTextEffectAlignment
 = MsoTextEffectAlignmentMixed
 | MsoTextEffectAlignmentLeft
 | MsoTextEffectAlignmentCentered
 | MsoTextEffectAlignmentRight
 | MsoTextEffectAlignmentLetterJustify
 | MsoTextEffectAlignmentWordJustify
 | MsoTextEffectAlignmentStretchJustify
 
marshallMsoTextEffectAlignment :: MsoTextEffectAlignment -> Prelude.IO Int.Int16
marshallMsoTextEffectAlignment v =
  case v of
     MsoTextEffectAlignmentMixed -> Prelude.return ((-2))
     MsoTextEffectAlignmentLeft -> Prelude.return (1)
     MsoTextEffectAlignmentCentered -> Prelude.return (2)
     MsoTextEffectAlignmentRight -> Prelude.return (3)
     MsoTextEffectAlignmentLetterJustify -> Prelude.return (4)
     MsoTextEffectAlignmentWordJustify -> Prelude.return (5)
     MsoTextEffectAlignmentStretchJustify -> Prelude.return (6)
unmarshallMsoTextEffectAlignment :: Int.Int16 -> Prelude.IO MsoTextEffectAlignment
unmarshallMsoTextEffectAlignment v =
  case v of
     (-2) -> Prelude.return (MsoTextEffectAlignmentMixed)
     1 -> Prelude.return (MsoTextEffectAlignmentLeft)
     2 -> Prelude.return (MsoTextEffectAlignmentCentered)
     3 -> Prelude.return (MsoTextEffectAlignmentRight)
     4 -> Prelude.return (MsoTextEffectAlignmentLetterJustify)
     5 -> Prelude.return (MsoTextEffectAlignmentWordJustify)
     6 -> Prelude.return (MsoTextEffectAlignmentStretchJustify)
     _ -> Prelude.fail (Prelude.userError "unmarshallMsoTextEffectAlignment: illegal enum value ")
data MsoPresetLightingDirection
 = MsoPresetLightingDirectionMixed
 | MsoLightingTopLeft
 | MsoLightingTop
 | MsoLightingTopRight
 | MsoLightingLeft
 | MsoLightingNone
 | MsoLightingRight
 | MsoLightingBottomLeft
 | MsoLightingBottom
 | MsoLightingBottomRight
 
marshallMsoPresetLightingDirection :: MsoPresetLightingDirection -> Prelude.IO Int.Int16
marshallMsoPresetLightingDirection v =
  case v of
     MsoPresetLightingDirectionMixed -> Prelude.return ((-2))
     MsoLightingTopLeft -> Prelude.return (1)
     MsoLightingTop -> Prelude.return (2)
     MsoLightingTopRight -> Prelude.return (3)
     MsoLightingLeft -> Prelude.return (4)
     MsoLightingNone -> Prelude.return (5)
     MsoLightingRight -> Prelude.return (6)
     MsoLightingBottomLeft -> Prelude.return (7)
     MsoLightingBottom -> Prelude.return (8)
     MsoLightingBottomRight -> Prelude.return (9)
unmarshallMsoPresetLightingDirection :: Int.Int16 -> Prelude.IO MsoPresetLightingDirection
unmarshallMsoPresetLightingDirection v =
  case v of
     (-2) -> Prelude.return (MsoPresetLightingDirectionMixed)
     1 -> Prelude.return (MsoLightingTopLeft)
     2 -> Prelude.return (MsoLightingTop)
     3 -> Prelude.return (MsoLightingTopRight)
     4 -> Prelude.return (MsoLightingLeft)
     5 -> Prelude.return (MsoLightingNone)
     6 -> Prelude.return (MsoLightingRight)
     7 -> Prelude.return (MsoLightingBottomLeft)
     8 -> Prelude.return (MsoLightingBottom)
     9 -> Prelude.return (MsoLightingBottomRight)
     _ -> Prelude.fail (Prelude.userError "unmarshallMsoPresetLightingDirection: illegal enum value ")
data MsoPresetLightingSoftness
 = MsoPresetLightingSoftnessMixed
 | MsoLightingDim
 | MsoLightingNormal
 | MsoLightingBright
 
marshallMsoPresetLightingSoftness :: MsoPresetLightingSoftness -> Prelude.IO Int.Int16
marshallMsoPresetLightingSoftness v =
  case v of
     MsoPresetLightingSoftnessMixed -> Prelude.return ((-2))
     MsoLightingDim -> Prelude.return (1)
     MsoLightingNormal -> Prelude.return (2)
     MsoLightingBright -> Prelude.return (3)
unmarshallMsoPresetLightingSoftness :: Int.Int16 -> Prelude.IO MsoPresetLightingSoftness
unmarshallMsoPresetLightingSoftness v =
  case v of
     (-2) -> Prelude.return (MsoPresetLightingSoftnessMixed)
     1 -> Prelude.return (MsoLightingDim)
     2 -> Prelude.return (MsoLightingNormal)
     3 -> Prelude.return (MsoLightingBright)
     _ -> Prelude.fail (Prelude.userError "unmarshallMsoPresetLightingSoftness: illegal enum value ")
data MsoPresetMaterial
 = MsoPresetMaterialMixed
 | MsoMaterialMatte
 | MsoMaterialPlastic
 | MsoMaterialMetal
 | MsoMaterialWireFrame
 
marshallMsoPresetMaterial :: MsoPresetMaterial -> Prelude.IO Int.Int16
marshallMsoPresetMaterial v =
  case v of
     MsoPresetMaterialMixed -> Prelude.return ((-2))
     MsoMaterialMatte -> Prelude.return (1)
     MsoMaterialPlastic -> Prelude.return (2)
     MsoMaterialMetal -> Prelude.return (3)
     MsoMaterialWireFrame -> Prelude.return (4)
unmarshallMsoPresetMaterial :: Int.Int16 -> Prelude.IO MsoPresetMaterial
unmarshallMsoPresetMaterial v =
  case v of
     (-2) -> Prelude.return (MsoPresetMaterialMixed)
     1 -> Prelude.return (MsoMaterialMatte)
     2 -> Prelude.return (MsoMaterialPlastic)
     3 -> Prelude.return (MsoMaterialMetal)
     4 -> Prelude.return (MsoMaterialWireFrame)
     _ -> Prelude.fail (Prelude.userError "unmarshallMsoPresetMaterial: illegal enum value ")
data MsoPresetExtrusionDirection
 = MsoPresetExtrusionDirectionMixed
 | MsoExtrusionBottomRight
 | MsoExtrusionBottom
 | MsoExtrusionBottomLeft
 | MsoExtrusionRight
 | MsoExtrusionNone
 | MsoExtrusionLeft
 | MsoExtrusionTopRight
 | MsoExtrusionTop
 | MsoExtrusionTopLeft
 
marshallMsoPresetExtrusionDirection :: MsoPresetExtrusionDirection -> Prelude.IO Int.Int16
marshallMsoPresetExtrusionDirection v =
  case v of
     MsoPresetExtrusionDirectionMixed -> Prelude.return ((-2))
     MsoExtrusionBottomRight -> Prelude.return (1)
     MsoExtrusionBottom -> Prelude.return (2)
     MsoExtrusionBottomLeft -> Prelude.return (3)
     MsoExtrusionRight -> Prelude.return (4)
     MsoExtrusionNone -> Prelude.return (5)
     MsoExtrusionLeft -> Prelude.return (6)
     MsoExtrusionTopRight -> Prelude.return (7)
     MsoExtrusionTop -> Prelude.return (8)
     MsoExtrusionTopLeft -> Prelude.return (9)
unmarshallMsoPresetExtrusionDirection :: Int.Int16 -> Prelude.IO MsoPresetExtrusionDirection
unmarshallMsoPresetExtrusionDirection v =
  case v of
     (-2) -> Prelude.return (MsoPresetExtrusionDirectionMixed)
     1 -> Prelude.return (MsoExtrusionBottomRight)
     2 -> Prelude.return (MsoExtrusionBottom)
     3 -> Prelude.return (MsoExtrusionBottomLeft)
     4 -> Prelude.return (MsoExtrusionRight)
     5 -> Prelude.return (MsoExtrusionNone)
     6 -> Prelude.return (MsoExtrusionLeft)
     7 -> Prelude.return (MsoExtrusionTopRight)
     8 -> Prelude.return (MsoExtrusionTop)
     9 -> Prelude.return (MsoExtrusionTopLeft)
     _ -> Prelude.fail (Prelude.userError "unmarshallMsoPresetExtrusionDirection: illegal enum value ")
data MsoPresetThreeDFormat
 = MsoPresetThreeDFormatMixed
 | MsoThreeD1
 | MsoThreeD2
 | MsoThreeD3
 | MsoThreeD4
 | MsoThreeD5
 | MsoThreeD6
 | MsoThreeD7
 | MsoThreeD8
 | MsoThreeD9
 | MsoThreeD10
 | MsoThreeD11
 | MsoThreeD12
 | MsoThreeD13
 | MsoThreeD14
 | MsoThreeD15
 | MsoThreeD16
 | MsoThreeD17
 | MsoThreeD18
 | MsoThreeD19
 | MsoThreeD20
 
marshallMsoPresetThreeDFormat :: MsoPresetThreeDFormat -> Prelude.IO Int.Int16
marshallMsoPresetThreeDFormat v =
  case v of
     MsoPresetThreeDFormatMixed -> Prelude.return ((-2))
     MsoThreeD1 -> Prelude.return (1)
     MsoThreeD2 -> Prelude.return (2)
     MsoThreeD3 -> Prelude.return (3)
     MsoThreeD4 -> Prelude.return (4)
     MsoThreeD5 -> Prelude.return (5)
     MsoThreeD6 -> Prelude.return (6)
     MsoThreeD7 -> Prelude.return (7)
     MsoThreeD8 -> Prelude.return (8)
     MsoThreeD9 -> Prelude.return (9)
     MsoThreeD10 -> Prelude.return (10)
     MsoThreeD11 -> Prelude.return (11)
     MsoThreeD12 -> Prelude.return (12)
     MsoThreeD13 -> Prelude.return (13)
     MsoThreeD14 -> Prelude.return (14)
     MsoThreeD15 -> Prelude.return (15)
     MsoThreeD16 -> Prelude.return (16)
     MsoThreeD17 -> Prelude.return (17)
     MsoThreeD18 -> Prelude.return (18)
     MsoThreeD19 -> Prelude.return (19)
     MsoThreeD20 -> Prelude.return (20)
unmarshallMsoPresetThreeDFormat :: Int.Int16 -> Prelude.IO MsoPresetThreeDFormat
unmarshallMsoPresetThreeDFormat v =
  case v of
     (-2) -> Prelude.return (MsoPresetThreeDFormatMixed)
     1 -> Prelude.return (MsoThreeD1)
     2 -> Prelude.return (MsoThreeD2)
     3 -> Prelude.return (MsoThreeD3)
     4 -> Prelude.return (MsoThreeD4)
     5 -> Prelude.return (MsoThreeD5)
     6 -> Prelude.return (MsoThreeD6)
     7 -> Prelude.return (MsoThreeD7)
     8 -> Prelude.return (MsoThreeD8)
     9 -> Prelude.return (MsoThreeD9)
     10 -> Prelude.return (MsoThreeD10)
     11 -> Prelude.return (MsoThreeD11)
     12 -> Prelude.return (MsoThreeD12)
     13 -> Prelude.return (MsoThreeD13)
     14 -> Prelude.return (MsoThreeD14)
     15 -> Prelude.return (MsoThreeD15)
     16 -> Prelude.return (MsoThreeD16)
     17 -> Prelude.return (MsoThreeD17)
     18 -> Prelude.return (MsoThreeD18)
     19 -> Prelude.return (MsoThreeD19)
     20 -> Prelude.return (MsoThreeD20)
     _ -> Prelude.fail (Prelude.userError "unmarshallMsoPresetThreeDFormat: illegal enum value ")
data MsoExtrusionColorType
 = MsoExtrusionColorTypeMixed
 | MsoExtrusionColorAutomatic
 | MsoExtrusionColorCustom
 
marshallMsoExtrusionColorType :: MsoExtrusionColorType -> Prelude.IO Int.Int16
marshallMsoExtrusionColorType v =
  case v of
     MsoExtrusionColorTypeMixed -> Prelude.return ((-2))
     MsoExtrusionColorAutomatic -> Prelude.return (1)
     MsoExtrusionColorCustom -> Prelude.return (2)
unmarshallMsoExtrusionColorType :: Int.Int16 -> Prelude.IO MsoExtrusionColorType
unmarshallMsoExtrusionColorType v =
  case v of
     (-2) -> Prelude.return (MsoExtrusionColorTypeMixed)
     1 -> Prelude.return (MsoExtrusionColorAutomatic)
     2 -> Prelude.return (MsoExtrusionColorCustom)
     _ -> Prelude.fail (Prelude.userError "unmarshallMsoExtrusionColorType: illegal enum value ")
data MsoAlignCmd
 = MsoAlignLefts
 | MsoAlignCenters
 | MsoAlignRights
 | MsoAlignTops
 | MsoAlignMiddles
 | MsoAlignBottoms
 
marshallMsoAlignCmd :: MsoAlignCmd -> Prelude.IO Int.Int16
marshallMsoAlignCmd v =
  case v of
     MsoAlignLefts -> Prelude.return (0)
     MsoAlignCenters -> Prelude.return (1)
     MsoAlignRights -> Prelude.return (2)
     MsoAlignTops -> Prelude.return (3)
     MsoAlignMiddles -> Prelude.return (4)
     MsoAlignBottoms -> Prelude.return (5)
unmarshallMsoAlignCmd :: Int.Int16 -> Prelude.IO MsoAlignCmd
unmarshallMsoAlignCmd v =
  case v of
     0 -> Prelude.return (MsoAlignLefts)
     1 -> Prelude.return (MsoAlignCenters)
     2 -> Prelude.return (MsoAlignRights)
     3 -> Prelude.return (MsoAlignTops)
     4 -> Prelude.return (MsoAlignMiddles)
     5 -> Prelude.return (MsoAlignBottoms)
     _ -> Prelude.fail (Prelude.userError "unmarshallMsoAlignCmd: illegal enum value ")
data MsoDistributeCmd
 = MsoDistributeHorizontally
 | MsoDistributeVertically
 
marshallMsoDistributeCmd :: MsoDistributeCmd -> Prelude.IO Int.Int16
marshallMsoDistributeCmd v =
  case v of
     MsoDistributeHorizontally -> Prelude.return (0)
     MsoDistributeVertically -> Prelude.return (1)
unmarshallMsoDistributeCmd :: Int.Int16 -> Prelude.IO MsoDistributeCmd
unmarshallMsoDistributeCmd v =
  case v of
     0 -> Prelude.return (MsoDistributeHorizontally)
     1 -> Prelude.return (MsoDistributeVertically)
     _ -> Prelude.fail (Prelude.userError "unmarshallMsoDistributeCmd: illegal enum value ")
data MsoConnectorType
 = MsoConnectorTypeMixed
 | MsoConnectorStraight
 | MsoConnectorElbow
 | MsoConnectorCurve
 
marshallMsoConnectorType :: MsoConnectorType -> Prelude.IO Int.Int16
marshallMsoConnectorType v =
  case v of
     MsoConnectorTypeMixed -> Prelude.return ((-2))
     MsoConnectorStraight -> Prelude.return (1)
     MsoConnectorElbow -> Prelude.return (2)
     MsoConnectorCurve -> Prelude.return (3)
unmarshallMsoConnectorType :: Int.Int16 -> Prelude.IO MsoConnectorType
unmarshallMsoConnectorType v =
  case v of
     (-2) -> Prelude.return (MsoConnectorTypeMixed)
     1 -> Prelude.return (MsoConnectorStraight)
     2 -> Prelude.return (MsoConnectorElbow)
     3 -> Prelude.return (MsoConnectorCurve)
     _ -> Prelude.fail (Prelude.userError "unmarshallMsoConnectorType: illegal enum value ")
data MsoHorizontalAnchor
 = MsoHorizontalAnchorMixed
 | MsoAnchorNone
 | MsoAnchorCenter
 
marshallMsoHorizontalAnchor :: MsoHorizontalAnchor -> Prelude.IO Int.Int16
marshallMsoHorizontalAnchor v =
  case v of
     MsoHorizontalAnchorMixed -> Prelude.return ((-2))
     MsoAnchorNone -> Prelude.return (1)
     MsoAnchorCenter -> Prelude.return (2)
unmarshallMsoHorizontalAnchor :: Int.Int16 -> Prelude.IO MsoHorizontalAnchor
unmarshallMsoHorizontalAnchor v =
  case v of
     (-2) -> Prelude.return (MsoHorizontalAnchorMixed)
     1 -> Prelude.return (MsoAnchorNone)
     2 -> Prelude.return (MsoAnchorCenter)
     _ -> Prelude.fail (Prelude.userError "unmarshallMsoHorizontalAnchor: illegal enum value ")
data MsoVerticalAnchor
 = MsoVerticalAnchorMixed
 | MsoAnchorTop
 | MsoAnchorTopBaseline
 | MsoAnchorMiddle
 | MsoAnchorBottom
 | MsoAnchorBottomBaseLine
 
marshallMsoVerticalAnchor :: MsoVerticalAnchor -> Prelude.IO Int.Int16
marshallMsoVerticalAnchor v =
  case v of
     MsoVerticalAnchorMixed -> Prelude.return ((-2))
     MsoAnchorTop -> Prelude.return (1)
     MsoAnchorTopBaseline -> Prelude.return (2)
     MsoAnchorMiddle -> Prelude.return (3)
     MsoAnchorBottom -> Prelude.return (4)
     MsoAnchorBottomBaseLine -> Prelude.return (5)
unmarshallMsoVerticalAnchor :: Int.Int16 -> Prelude.IO MsoVerticalAnchor
unmarshallMsoVerticalAnchor v =
  case v of
     (-2) -> Prelude.return (MsoVerticalAnchorMixed)
     1 -> Prelude.return (MsoAnchorTop)
     2 -> Prelude.return (MsoAnchorTopBaseline)
     3 -> Prelude.return (MsoAnchorMiddle)
     4 -> Prelude.return (MsoAnchorBottom)
     5 -> Prelude.return (MsoAnchorBottomBaseLine)
     _ -> Prelude.fail (Prelude.userError "unmarshallMsoVerticalAnchor: illegal enum value ")
data MsoOrientation
 = MsoOrientationMixed
 | MsoOrientationHorizontal
 | MsoOrientationVertical
 
marshallMsoOrientation :: MsoOrientation -> Prelude.IO Int.Int16
marshallMsoOrientation v =
  case v of
     MsoOrientationMixed -> Prelude.return ((-2))
     MsoOrientationHorizontal -> Prelude.return (1)
     MsoOrientationVertical -> Prelude.return (2)
unmarshallMsoOrientation :: Int.Int16 -> Prelude.IO MsoOrientation
unmarshallMsoOrientation v =
  case v of
     (-2) -> Prelude.return (MsoOrientationMixed)
     1 -> Prelude.return (MsoOrientationHorizontal)
     2 -> Prelude.return (MsoOrientationVertical)
     _ -> Prelude.fail (Prelude.userError "unmarshallMsoOrientation: illegal enum value ")
data MsoZOrderCmd
 = MsoBringToFront
 | MsoSendToBack
 | MsoBringForward
 | MsoSendBackward
 | MsoBringInFrontOfText
 | MsoSendBehindText
 
marshallMsoZOrderCmd :: MsoZOrderCmd -> Prelude.IO Int.Int16
marshallMsoZOrderCmd v =
  case v of
     MsoBringToFront -> Prelude.return (0)
     MsoSendToBack -> Prelude.return (1)
     MsoBringForward -> Prelude.return (2)
     MsoSendBackward -> Prelude.return (3)
     MsoBringInFrontOfText -> Prelude.return (4)
     MsoSendBehindText -> Prelude.return (5)
unmarshallMsoZOrderCmd :: Int.Int16 -> Prelude.IO MsoZOrderCmd
unmarshallMsoZOrderCmd v =
  case v of
     0 -> Prelude.return (MsoBringToFront)
     1 -> Prelude.return (MsoSendToBack)
     2 -> Prelude.return (MsoBringForward)
     3 -> Prelude.return (MsoSendBackward)
     4 -> Prelude.return (MsoBringInFrontOfText)
     5 -> Prelude.return (MsoSendBehindText)
     _ -> Prelude.fail (Prelude.userError "unmarshallMsoZOrderCmd: illegal enum value ")
data MsoSegmentType
 = MsoSegmentLine
 | MsoSegmentCurve
 
marshallMsoSegmentType :: MsoSegmentType -> Prelude.IO Int.Int16
marshallMsoSegmentType v =
  case v of
     MsoSegmentLine -> Prelude.return (0)
     MsoSegmentCurve -> Prelude.return (1)
unmarshallMsoSegmentType :: Int.Int16 -> Prelude.IO MsoSegmentType
unmarshallMsoSegmentType v =
  case v of
     0 -> Prelude.return (MsoSegmentLine)
     1 -> Prelude.return (MsoSegmentCurve)
     _ -> Prelude.fail (Prelude.userError "unmarshallMsoSegmentType: illegal enum value ")
data MsoEditingType
 = MsoEditingAuto
 | MsoEditingCorner
 | MsoEditingSmooth
 | MsoEditingSymmetric
 
marshallMsoEditingType :: MsoEditingType -> Prelude.IO Int.Int16
marshallMsoEditingType v =
  case v of
     MsoEditingAuto -> Prelude.return (0)
     MsoEditingCorner -> Prelude.return (1)
     MsoEditingSmooth -> Prelude.return (2)
     MsoEditingSymmetric -> Prelude.return (3)
unmarshallMsoEditingType :: Int.Int16 -> Prelude.IO MsoEditingType
unmarshallMsoEditingType v =
  case v of
     0 -> Prelude.return (MsoEditingAuto)
     1 -> Prelude.return (MsoEditingCorner)
     2 -> Prelude.return (MsoEditingSmooth)
     3 -> Prelude.return (MsoEditingSymmetric)
     _ -> Prelude.fail (Prelude.userError "unmarshallMsoEditingType: illegal enum value ")
data MsoAutoShapeType
 = MsoShapeMixed
 | MsoShapeRectangle
 | MsoShapeParallelogram
 | MsoShapeTrapezoid
 | MsoShapeDiamond
 | MsoShapeRoundedRectangle
 | MsoShapeOctagon
 | MsoShapeIsoscelesTriangle
 | MsoShapeRightTriangle
 | MsoShapeOval
 | MsoShapeHexagon
 | MsoShapeCross
 | MsoShapeRegularPentagon
 | MsoShapeCan
 | MsoShapeCube
 | MsoShapeBevel
 | MsoShapeFoldedCorner
 | MsoShapeSmileyFace
 | MsoShapeDonut
 | MsoShapeNoSymbol
 | MsoShapeBlockArc
 | MsoShapeHeart
 | MsoShapeLightningBolt
 | MsoShapeSun
 | MsoShapeMoon
 | MsoShapeArc
 | MsoShapeDoubleBracket
 | MsoShapeDoubleBrace
 | MsoShapePlaque
 | MsoShapeLeftBracket
 | MsoShapeRightBracket
 | MsoShapeLeftBrace
 | MsoShapeRightBrace
 | MsoShapeRightArrow
 | MsoShapeLeftArrow
 | MsoShapeUpArrow
 | MsoShapeDownArrow
 | MsoShapeLeftRightArrow
 | MsoShapeUpDownArrow
 | MsoShapeQuadArrow
 | MsoShapeLeftRightUpArrow
 | MsoShapeBentArrow
 | MsoShapeUTurnArrow
 | MsoShapeLeftUpArrow
 | MsoShapeBentUpArrow
 | MsoShapeCurvedRightArrow
 | MsoShapeCurvedLeftArrow
 | MsoShapeCurvedUpArrow
 | MsoShapeCurvedDownArrow
 | MsoShapeStripedRightArrow
 | MsoShapeNotchedRightArrow
 | MsoShapePentagon
 | MsoShapeChevron
 | MsoShapeRightArrowCallout
 | MsoShapeLeftArrowCallout
 | MsoShapeUpArrowCallout
 | MsoShapeDownArrowCallout
 | MsoShapeLeftRightArrowCallout
 | MsoShapeUpDownArrowCallout
 | MsoShapeQuadArrowCallout
 | MsoShapeCircularArrow
 | MsoShapeFlowchartProcess
 | MsoShapeFlowchartAlternateProcess
 | MsoShapeFlowchartDecision
 | MsoShapeFlowchartData
 | MsoShapeFlowchartPredefinedProcess
 | MsoShapeFlowchartInternalStorage
 | MsoShapeFlowchartDocument
 | MsoShapeFlowchartMultidocument
 | MsoShapeFlowchartTerminator
 | MsoShapeFlowchartPreparation
 | MsoShapeFlowchartManualInput
 | MsoShapeFlowchartManualOperation
 | MsoShapeFlowchartConnector
 | MsoShapeFlowchartOffpageConnector
 | MsoShapeFlowchartCard
 | MsoShapeFlowchartPunchedTape
 | MsoShapeFlowchartSummingJunction
 | MsoShapeFlowchartOr
 | MsoShapeFlowchartCollate
 | MsoShapeFlowchartSort
 | MsoShapeFlowchartExtract
 | MsoShapeFlowchartMerge
 | MsoShapeFlowchartStoredData
 | MsoShapeFlowchartDelay
 | MsoShapeFlowchartSequentialAccessStorage
 | MsoShapeFlowchartMagneticDisk
 | MsoShapeFlowchartDirectAccessStorage
 | MsoShapeFlowchartDisplay
 | MsoShapeExplosion1
 | MsoShapeExplosion2
 | MsoShape4pointStar
 | MsoShape5pointStar
 | MsoShape8pointStar
 | MsoShape16pointStar
 | MsoShape24pointStar
 | MsoShape32pointStar
 | MsoShapeUpRibbon
 | MsoShapeDownRibbon
 | MsoShapeCurvedUpRibbon
 | MsoShapeCurvedDownRibbon
 | MsoShapeVerticalScroll
 | MsoShapeHorizontalScroll
 | MsoShapeWave
 | MsoShapeDoubleWave
 | MsoShapeRectangularCallout
 | MsoShapeRoundedRectangularCallout
 | MsoShapeOvalCallout
 | MsoShapeCloudCallout
 | MsoShapeLineCallout1
 | MsoShapeLineCallout2
 | MsoShapeLineCallout3
 | MsoShapeLineCallout4
 | MsoShapeLineCallout1AccentBar
 | MsoShapeLineCallout2AccentBar
 | MsoShapeLineCallout3AccentBar
 | MsoShapeLineCallout4AccentBar
 | MsoShapeLineCallout1NoBorder
 | MsoShapeLineCallout2NoBorder
 | MsoShapeLineCallout3NoBorder
 | MsoShapeLineCallout4NoBorder
 | MsoShapeLineCallout1BorderandAccentBar
 | MsoShapeLineCallout2BorderandAccentBar
 | MsoShapeLineCallout3BorderandAccentBar
 | MsoShapeLineCallout4BorderandAccentBar
 | MsoShapeActionButtonCustom
 | MsoShapeActionButtonHome
 | MsoShapeActionButtonHelp
 | MsoShapeActionButtonInformation
 | MsoShapeActionButtonBackorPrevious
 | MsoShapeActionButtonForwardorNext
 | MsoShapeActionButtonBeginning
 | MsoShapeActionButtonEnd
 | MsoShapeActionButtonReturn
 | MsoShapeActionButtonDocument
 | MsoShapeActionButtonSound
 | MsoShapeActionButtonMovie
 | MsoShapeBalloon
 | MsoShapeNotPrimitive
 
marshallMsoAutoShapeType :: MsoAutoShapeType -> Prelude.IO Int.Int16
marshallMsoAutoShapeType v =
  case v of
     MsoShapeMixed -> Prelude.return ((-2))
     MsoShapeRectangle -> Prelude.return (1)
     MsoShapeParallelogram -> Prelude.return (2)
     MsoShapeTrapezoid -> Prelude.return (3)
     MsoShapeDiamond -> Prelude.return (4)
     MsoShapeRoundedRectangle -> Prelude.return (5)
     MsoShapeOctagon -> Prelude.return (6)
     MsoShapeIsoscelesTriangle -> Prelude.return (7)
     MsoShapeRightTriangle -> Prelude.return (8)
     MsoShapeOval -> Prelude.return (9)
     MsoShapeHexagon -> Prelude.return (10)
     MsoShapeCross -> Prelude.return (11)
     MsoShapeRegularPentagon -> Prelude.return (12)
     MsoShapeCan -> Prelude.return (13)
     MsoShapeCube -> Prelude.return (14)
     MsoShapeBevel -> Prelude.return (15)
     MsoShapeFoldedCorner -> Prelude.return (16)
     MsoShapeSmileyFace -> Prelude.return (17)
     MsoShapeDonut -> Prelude.return (18)
     MsoShapeNoSymbol -> Prelude.return (19)
     MsoShapeBlockArc -> Prelude.return (20)
     MsoShapeHeart -> Prelude.return (21)
     MsoShapeLightningBolt -> Prelude.return (22)
     MsoShapeSun -> Prelude.return (23)
     MsoShapeMoon -> Prelude.return (24)
     MsoShapeArc -> Prelude.return (25)
     MsoShapeDoubleBracket -> Prelude.return (26)
     MsoShapeDoubleBrace -> Prelude.return (27)
     MsoShapePlaque -> Prelude.return (28)
     MsoShapeLeftBracket -> Prelude.return (29)
     MsoShapeRightBracket -> Prelude.return (30)
     MsoShapeLeftBrace -> Prelude.return (31)
     MsoShapeRightBrace -> Prelude.return (32)
     MsoShapeRightArrow -> Prelude.return (33)
     MsoShapeLeftArrow -> Prelude.return (34)
     MsoShapeUpArrow -> Prelude.return (35)
     MsoShapeDownArrow -> Prelude.return (36)
     MsoShapeLeftRightArrow -> Prelude.return (37)
     MsoShapeUpDownArrow -> Prelude.return (38)
     MsoShapeQuadArrow -> Prelude.return (39)
     MsoShapeLeftRightUpArrow -> Prelude.return (40)
     MsoShapeBentArrow -> Prelude.return (41)
     MsoShapeUTurnArrow -> Prelude.return (42)
     MsoShapeLeftUpArrow -> Prelude.return (43)
     MsoShapeBentUpArrow -> Prelude.return (44)
     MsoShapeCurvedRightArrow -> Prelude.return (45)
     MsoShapeCurvedLeftArrow -> Prelude.return (46)
     MsoShapeCurvedUpArrow -> Prelude.return (47)
     MsoShapeCurvedDownArrow -> Prelude.return (48)
     MsoShapeStripedRightArrow -> Prelude.return (49)
     MsoShapeNotchedRightArrow -> Prelude.return (50)
     MsoShapePentagon -> Prelude.return (51)
     MsoShapeChevron -> Prelude.return (52)
     MsoShapeRightArrowCallout -> Prelude.return (53)
     MsoShapeLeftArrowCallout -> Prelude.return (54)
     MsoShapeUpArrowCallout -> Prelude.return (55)
     MsoShapeDownArrowCallout -> Prelude.return (56)
     MsoShapeLeftRightArrowCallout -> Prelude.return (57)
     MsoShapeUpDownArrowCallout -> Prelude.return (58)
     MsoShapeQuadArrowCallout -> Prelude.return (59)
     MsoShapeCircularArrow -> Prelude.return (60)
     MsoShapeFlowchartProcess -> Prelude.return (61)
     MsoShapeFlowchartAlternateProcess -> Prelude.return (62)
     MsoShapeFlowchartDecision -> Prelude.return (63)
     MsoShapeFlowchartData -> Prelude.return (64)
     MsoShapeFlowchartPredefinedProcess -> Prelude.return (65)
     MsoShapeFlowchartInternalStorage -> Prelude.return (66)
     MsoShapeFlowchartDocument -> Prelude.return (67)
     MsoShapeFlowchartMultidocument -> Prelude.return (68)
     MsoShapeFlowchartTerminator -> Prelude.return (69)
     MsoShapeFlowchartPreparation -> Prelude.return (70)
     MsoShapeFlowchartManualInput -> Prelude.return (71)
     MsoShapeFlowchartManualOperation -> Prelude.return (72)
     MsoShapeFlowchartConnector -> Prelude.return (73)
     MsoShapeFlowchartOffpageConnector -> Prelude.return (74)
     MsoShapeFlowchartCard -> Prelude.return (75)
     MsoShapeFlowchartPunchedTape -> Prelude.return (76)
     MsoShapeFlowchartSummingJunction -> Prelude.return (77)
     MsoShapeFlowchartOr -> Prelude.return (78)
     MsoShapeFlowchartCollate -> Prelude.return (79)
     MsoShapeFlowchartSort -> Prelude.return (80)
     MsoShapeFlowchartExtract -> Prelude.return (81)
     MsoShapeFlowchartMerge -> Prelude.return (82)
     MsoShapeFlowchartStoredData -> Prelude.return (83)
     MsoShapeFlowchartDelay -> Prelude.return (84)
     MsoShapeFlowchartSequentialAccessStorage -> Prelude.return (85)
     MsoShapeFlowchartMagneticDisk -> Prelude.return (86)
     MsoShapeFlowchartDirectAccessStorage -> Prelude.return (87)
     MsoShapeFlowchartDisplay -> Prelude.return (88)
     MsoShapeExplosion1 -> Prelude.return (89)
     MsoShapeExplosion2 -> Prelude.return (90)
     MsoShape4pointStar -> Prelude.return (91)
     MsoShape5pointStar -> Prelude.return (92)
     MsoShape8pointStar -> Prelude.return (93)
     MsoShape16pointStar -> Prelude.return (94)
     MsoShape24pointStar -> Prelude.return (95)
     MsoShape32pointStar -> Prelude.return (96)
     MsoShapeUpRibbon -> Prelude.return (97)
     MsoShapeDownRibbon -> Prelude.return (98)
     MsoShapeCurvedUpRibbon -> Prelude.return (99)
{-
     MsoShapeCurvedDownRibbon -> Prelude.return (100)
     MsoShapeVerticalScroll -> Prelude.return (101)
     MsoShapeHorizontalScroll -> Prelude.return (102)
     MsoShapeWave -> Prelude.return (103)
     MsoShapeDoubleWave -> Prelude.return (104)
     MsoShapeRectangularCallout -> Prelude.return (105)
     MsoShapeRoundedRectangularCallout -> Prelude.return (106)
     MsoShapeOvalCallout -> Prelude.return (107)
     MsoShapeCloudCallout -> Prelude.return (108)
     MsoShapeLineCallout1 -> Prelude.return (109)
     MsoShapeLineCallout2 -> Prelude.return (110)
     MsoShapeLineCallout3 -> Prelude.return (111)
     MsoShapeLineCallout4 -> Prelude.return (112)
     MsoShapeLineCallout1AccentBar -> Prelude.return (113)
     MsoShapeLineCallout2AccentBar -> Prelude.return (114)
     MsoShapeLineCallout3AccentBar -> Prelude.return (115)
     MsoShapeLineCallout4AccentBar -> Prelude.return (116)
     MsoShapeLineCallout1NoBorder -> Prelude.return (117)
     MsoShapeLineCallout2NoBorder -> Prelude.return (118)
     MsoShapeLineCallout3NoBorder -> Prelude.return (119)
     MsoShapeLineCallout4NoBorder -> Prelude.return (120)
     MsoShapeLineCallout1BorderandAccentBar -> Prelude.return (121)
     MsoShapeLineCallout2BorderandAccentBar -> Prelude.return (122)
     MsoShapeLineCallout3BorderandAccentBar -> Prelude.return (123)
     MsoShapeLineCallout4BorderandAccentBar -> Prelude.return (124)
     MsoShapeActionButtonCustom -> Prelude.return (125)
     MsoShapeActionButtonHome -> Prelude.return (126)
     MsoShapeActionButtonHelp -> Prelude.return (127)
     MsoShapeActionButtonInformation -> Prelude.return (128)
     MsoShapeActionButtonBackorPrevious -> Prelude.return (129)
     MsoShapeActionButtonForwardorNext -> Prelude.return (130)
     MsoShapeActionButtonBeginning -> Prelude.return (131)
     MsoShapeActionButtonEnd -> Prelude.return (132)
     MsoShapeActionButtonReturn -> Prelude.return (133)
     MsoShapeActionButtonDocument -> Prelude.return (134)
     MsoShapeActionButtonSound -> Prelude.return (135)
     MsoShapeActionButtonMovie -> Prelude.return (136)
     MsoShapeBalloon -> Prelude.return (137)
     MsoShapeNotPrimitive -> Prelude.return (138)
-}
unmarshallMsoAutoShapeType :: Int.Int16 -> Prelude.IO MsoAutoShapeType
unmarshallMsoAutoShapeType v =
  case v of
     (-2) -> Prelude.return (MsoShapeMixed)
     1 -> Prelude.return (MsoShapeRectangle)
     2 -> Prelude.return (MsoShapeParallelogram)
     3 -> Prelude.return (MsoShapeTrapezoid)
     4 -> Prelude.return (MsoShapeDiamond)
     5 -> Prelude.return (MsoShapeRoundedRectangle)
     6 -> Prelude.return (MsoShapeOctagon)
     7 -> Prelude.return (MsoShapeIsoscelesTriangle)
     8 -> Prelude.return (MsoShapeRightTriangle)
     9 -> Prelude.return (MsoShapeOval)
     10 -> Prelude.return (MsoShapeHexagon)
     11 -> Prelude.return (MsoShapeCross)
     12 -> Prelude.return (MsoShapeRegularPentagon)
     13 -> Prelude.return (MsoShapeCan)
     14 -> Prelude.return (MsoShapeCube)
     15 -> Prelude.return (MsoShapeBevel)
     16 -> Prelude.return (MsoShapeFoldedCorner)
     17 -> Prelude.return (MsoShapeSmileyFace)
     18 -> Prelude.return (MsoShapeDonut)
     19 -> Prelude.return (MsoShapeNoSymbol)
     20 -> Prelude.return (MsoShapeBlockArc)
     21 -> Prelude.return (MsoShapeHeart)
     22 -> Prelude.return (MsoShapeLightningBolt)
     23 -> Prelude.return (MsoShapeSun)
     24 -> Prelude.return (MsoShapeMoon)
     25 -> Prelude.return (MsoShapeArc)
     26 -> Prelude.return (MsoShapeDoubleBracket)
     27 -> Prelude.return (MsoShapeDoubleBrace)
     28 -> Prelude.return (MsoShapePlaque)
     29 -> Prelude.return (MsoShapeLeftBracket)
     30 -> Prelude.return (MsoShapeRightBracket)
     31 -> Prelude.return (MsoShapeLeftBrace)
     32 -> Prelude.return (MsoShapeRightBrace)
     33 -> Prelude.return (MsoShapeRightArrow)
     34 -> Prelude.return (MsoShapeLeftArrow)
     35 -> Prelude.return (MsoShapeUpArrow)
     36 -> Prelude.return (MsoShapeDownArrow)
     37 -> Prelude.return (MsoShapeLeftRightArrow)
     38 -> Prelude.return (MsoShapeUpDownArrow)
     39 -> Prelude.return (MsoShapeQuadArrow)
     40 -> Prelude.return (MsoShapeLeftRightUpArrow)
     41 -> Prelude.return (MsoShapeBentArrow)
     42 -> Prelude.return (MsoShapeUTurnArrow)
     43 -> Prelude.return (MsoShapeLeftUpArrow)
     44 -> Prelude.return (MsoShapeBentUpArrow)
     45 -> Prelude.return (MsoShapeCurvedRightArrow)
     46 -> Prelude.return (MsoShapeCurvedLeftArrow)
     47 -> Prelude.return (MsoShapeCurvedUpArrow)
     48 -> Prelude.return (MsoShapeCurvedDownArrow)
     49 -> Prelude.return (MsoShapeStripedRightArrow)
     50 -> Prelude.return (MsoShapeNotchedRightArrow)
     51 -> Prelude.return (MsoShapePentagon)
     52 -> Prelude.return (MsoShapeChevron)
     53 -> Prelude.return (MsoShapeRightArrowCallout)
     54 -> Prelude.return (MsoShapeLeftArrowCallout)
     55 -> Prelude.return (MsoShapeUpArrowCallout)
     56 -> Prelude.return (MsoShapeDownArrowCallout)
     57 -> Prelude.return (MsoShapeLeftRightArrowCallout)
     58 -> Prelude.return (MsoShapeUpDownArrowCallout)
     59 -> Prelude.return (MsoShapeQuadArrowCallout)
     60 -> Prelude.return (MsoShapeCircularArrow)
     61 -> Prelude.return (MsoShapeFlowchartProcess)
     62 -> Prelude.return (MsoShapeFlowchartAlternateProcess)
     63 -> Prelude.return (MsoShapeFlowchartDecision)
     64 -> Prelude.return (MsoShapeFlowchartData)
     65 -> Prelude.return (MsoShapeFlowchartPredefinedProcess)
     66 -> Prelude.return (MsoShapeFlowchartInternalStorage)
     67 -> Prelude.return (MsoShapeFlowchartDocument)
     68 -> Prelude.return (MsoShapeFlowchartMultidocument)
     69 -> Prelude.return (MsoShapeFlowchartTerminator)
     70 -> Prelude.return (MsoShapeFlowchartPreparation)
     71 -> Prelude.return (MsoShapeFlowchartManualInput)
     72 -> Prelude.return (MsoShapeFlowchartManualOperation)
     73 -> Prelude.return (MsoShapeFlowchartConnector)
     74 -> Prelude.return (MsoShapeFlowchartOffpageConnector)
     75 -> Prelude.return (MsoShapeFlowchartCard)
     76 -> Prelude.return (MsoShapeFlowchartPunchedTape)
     77 -> Prelude.return (MsoShapeFlowchartSummingJunction)
     78 -> Prelude.return (MsoShapeFlowchartOr)
     79 -> Prelude.return (MsoShapeFlowchartCollate)
     80 -> Prelude.return (MsoShapeFlowchartSort)
     81 -> Prelude.return (MsoShapeFlowchartExtract)
     82 -> Prelude.return (MsoShapeFlowchartMerge)
     83 -> Prelude.return (MsoShapeFlowchartStoredData)
     84 -> Prelude.return (MsoShapeFlowchartDelay)
     85 -> Prelude.return (MsoShapeFlowchartSequentialAccessStorage)
     86 -> Prelude.return (MsoShapeFlowchartMagneticDisk)
     87 -> Prelude.return (MsoShapeFlowchartDirectAccessStorage)
     88 -> Prelude.return (MsoShapeFlowchartDisplay)
     89 -> Prelude.return (MsoShapeExplosion1)
     90 -> Prelude.return (MsoShapeExplosion2)
     91 -> Prelude.return (MsoShape4pointStar)
     92 -> Prelude.return (MsoShape5pointStar)
     93 -> Prelude.return (MsoShape8pointStar)
     94 -> Prelude.return (MsoShape16pointStar)
     95 -> Prelude.return (MsoShape24pointStar)
     96 -> Prelude.return (MsoShape32pointStar)
     97 -> Prelude.return (MsoShapeUpRibbon)
     98 -> Prelude.return (MsoShapeDownRibbon)
{-
     99 -> Prelude.return (MsoShapeCurvedUpRibbon)
     100 -> Prelude.return (MsoShapeCurvedDownRibbon)
     101 -> Prelude.return (MsoShapeVerticalScroll)
     102 -> Prelude.return (MsoShapeHorizontalScroll)
     103 -> Prelude.return (MsoShapeWave)
     104 -> Prelude.return (MsoShapeDoubleWave)
     105 -> Prelude.return (MsoShapeRectangularCallout)
     106 -> Prelude.return (MsoShapeRoundedRectangularCallout)
     107 -> Prelude.return (MsoShapeOvalCallout)
     108 -> Prelude.return (MsoShapeCloudCallout)
     109 -> Prelude.return (MsoShapeLineCallout1)
     110 -> Prelude.return (MsoShapeLineCallout2)
     111 -> Prelude.return (MsoShapeLineCallout3)
     112 -> Prelude.return (MsoShapeLineCallout4)
     113 -> Prelude.return (MsoShapeLineCallout1AccentBar)
     114 -> Prelude.return (MsoShapeLineCallout2AccentBar)
     115 -> Prelude.return (MsoShapeLineCallout3AccentBar)
     116 -> Prelude.return (MsoShapeLineCallout4AccentBar)
     117 -> Prelude.return (MsoShapeLineCallout1NoBorder)
     118 -> Prelude.return (MsoShapeLineCallout2NoBorder)
     119 -> Prelude.return (MsoShapeLineCallout3NoBorder)
     120 -> Prelude.return (MsoShapeLineCallout4NoBorder)
     121 -> Prelude.return (MsoShapeLineCallout1BorderandAccentBar)
     122 -> Prelude.return (MsoShapeLineCallout2BorderandAccentBar)
     123 -> Prelude.return (MsoShapeLineCallout3BorderandAccentBar)
     124 -> Prelude.return (MsoShapeLineCallout4BorderandAccentBar)
     125 -> Prelude.return (MsoShapeActionButtonCustom)
     126 -> Prelude.return (MsoShapeActionButtonHome)
     127 -> Prelude.return (MsoShapeActionButtonHelp)
     128 -> Prelude.return (MsoShapeActionButtonInformation)
     129 -> Prelude.return (MsoShapeActionButtonBackorPrevious)
     130 -> Prelude.return (MsoShapeActionButtonForwardorNext)
     131 -> Prelude.return (MsoShapeActionButtonBeginning)
     132 -> Prelude.return (MsoShapeActionButtonEnd)
     133 -> Prelude.return (MsoShapeActionButtonReturn)
     134 -> Prelude.return (MsoShapeActionButtonDocument)
     135 -> Prelude.return (MsoShapeActionButtonSound)
     136 -> Prelude.return (MsoShapeActionButtonMovie)
     137 -> Prelude.return (MsoShapeBalloon)
     138 -> Prelude.return (MsoShapeNotPrimitive)
-}
     _ -> Prelude.fail (Prelude.userError "unmarshallMsoAutoShapeType: illegal enum value ")
data MsoShapeType
 = MsoShapeTypeMixed
 | MsoAutoShape
 | MsoCallout
 | MsoChart
 | MsoComment
 | MsoFreeform
 | MsoGroup
 | MsoEmbeddedOLEObject
 | MsoFormControl
 | MsoLine
 | MsoLinkedOLEObject
 | MsoLinkedPicture
 | MsoOLEControlObject
 | MsoPicture
 | MsoPlaceholder
 | MsoTextEffect
 | MsoMedia
 | MsoTextBox
 
marshallMsoShapeType :: MsoShapeType -> Prelude.IO Int.Int16
marshallMsoShapeType v =
  case v of
     MsoShapeTypeMixed -> Prelude.return ((-2))
     MsoAutoShape -> Prelude.return (1)
     MsoCallout -> Prelude.return (2)
     MsoChart -> Prelude.return (3)
     MsoComment -> Prelude.return (4)
     MsoFreeform -> Prelude.return (5)
     MsoGroup -> Prelude.return (6)
     MsoEmbeddedOLEObject -> Prelude.return (7)
     MsoFormControl -> Prelude.return (8)
     MsoLine -> Prelude.return (9)
     MsoLinkedOLEObject -> Prelude.return (10)
     MsoLinkedPicture -> Prelude.return (11)
     MsoOLEControlObject -> Prelude.return (12)
     MsoPicture -> Prelude.return (13)
     MsoPlaceholder -> Prelude.return (14)
     MsoTextEffect -> Prelude.return (15)
     MsoMedia -> Prelude.return (16)
     MsoTextBox -> Prelude.return (17)
unmarshallMsoShapeType :: Int.Int16 -> Prelude.IO MsoShapeType
unmarshallMsoShapeType v =
  case v of
     (-2) -> Prelude.return (MsoShapeTypeMixed)
     1 -> Prelude.return (MsoAutoShape)
     2 -> Prelude.return (MsoCallout)
     3 -> Prelude.return (MsoChart)
     4 -> Prelude.return (MsoComment)
     5 -> Prelude.return (MsoFreeform)
     6 -> Prelude.return (MsoGroup)
     7 -> Prelude.return (MsoEmbeddedOLEObject)
     8 -> Prelude.return (MsoFormControl)
     9 -> Prelude.return (MsoLine)
     10 -> Prelude.return (MsoLinkedOLEObject)
     11 -> Prelude.return (MsoLinkedPicture)
     12 -> Prelude.return (MsoOLEControlObject)
     13 -> Prelude.return (MsoPicture)
     14 -> Prelude.return (MsoPlaceholder)
     15 -> Prelude.return (MsoTextEffect)
     16 -> Prelude.return (MsoMedia)
     17 -> Prelude.return (MsoTextBox)
     _ -> Prelude.fail (Prelude.userError "unmarshallMsoShapeType: illegal enum value ")
data MsoFlipCmd
 = MsoFlipHorizontal
 | MsoFlipVertical
 
marshallMsoFlipCmd :: MsoFlipCmd -> Prelude.IO Int.Int16
marshallMsoFlipCmd v =
  case v of
     MsoFlipHorizontal -> Prelude.return (0)
     MsoFlipVertical -> Prelude.return (1)
unmarshallMsoFlipCmd :: Int.Int16 -> Prelude.IO MsoFlipCmd
unmarshallMsoFlipCmd v =
  case v of
     0 -> Prelude.return (MsoFlipHorizontal)
     1 -> Prelude.return (MsoFlipVertical)
     _ -> Prelude.fail (Prelude.userError "unmarshallMsoFlipCmd: illegal enum value ")
data MsoTriState
 = MsoTrue
 | MsoFalse
 | MsoCTrue
 | MsoTriStateToggle
 | MsoTriStateMixed
 
marshallMsoTriState :: MsoTriState -> Prelude.IO Int.Int16
marshallMsoTriState v =
  case v of
     MsoTrue -> Prelude.return ((-1))
     MsoFalse -> Prelude.return (0)
     MsoCTrue -> Prelude.return (1)
     MsoTriStateToggle -> Prelude.return ((-3))
     MsoTriStateMixed -> Prelude.return ((-2))
unmarshallMsoTriState :: Int.Int16 -> Prelude.IO MsoTriState
unmarshallMsoTriState v =
  case v of
     (-1) -> Prelude.return (MsoTrue)
     0 -> Prelude.return (MsoFalse)
     1 -> Prelude.return (MsoCTrue)
     (-3) -> Prelude.return (MsoTriStateToggle)
     (-2) -> Prelude.return (MsoTriStateMixed)
     _ -> Prelude.fail (Prelude.userError "unmarshallMsoTriState: illegal enum value ")
data MsoColorType
 = MsoColorTypeMixed
 | MsoColorTypeRGB
 | MsoColorTypeScheme
 
marshallMsoColorType :: MsoColorType -> Prelude.IO Int.Int16
marshallMsoColorType v =
  case v of
     MsoColorTypeMixed -> Prelude.return ((-2))
     MsoColorTypeRGB -> Prelude.return (1)
     MsoColorTypeScheme -> Prelude.return (2)
unmarshallMsoColorType :: Int.Int16 -> Prelude.IO MsoColorType
unmarshallMsoColorType v =
  case v of
     (-2) -> Prelude.return (MsoColorTypeMixed)
     1 -> Prelude.return (MsoColorTypeRGB)
     2 -> Prelude.return (MsoColorTypeScheme)
     _ -> Prelude.fail (Prelude.userError "unmarshallMsoColorType: illegal enum value ")
data MsoPictureColorType
 = MsoPictureMixed
 | MsoPictureAutomatic
 | MsoPictureGrayscale
 | MsoPictureBlackAndWhite
 | MsoPictureWatermark
 
marshallMsoPictureColorType :: MsoPictureColorType -> Prelude.IO Int.Int16
marshallMsoPictureColorType v =
  case v of
     MsoPictureMixed -> Prelude.return ((-2))
     MsoPictureAutomatic -> Prelude.return (1)
     MsoPictureGrayscale -> Prelude.return (2)
     MsoPictureBlackAndWhite -> Prelude.return (3)
     MsoPictureWatermark -> Prelude.return (4)
unmarshallMsoPictureColorType :: Int.Int16 -> Prelude.IO MsoPictureColorType
unmarshallMsoPictureColorType v =
  case v of
     (-2) -> Prelude.return (MsoPictureMixed)
     1 -> Prelude.return (MsoPictureAutomatic)
     2 -> Prelude.return (MsoPictureGrayscale)
     3 -> Prelude.return (MsoPictureBlackAndWhite)
     4 -> Prelude.return (MsoPictureWatermark)
     _ -> Prelude.fail (Prelude.userError "unmarshallMsoPictureColorType: illegal enum value ")
data MsoCalloutAngleType
 = MsoCalloutAngleMixed
 | MsoCalloutAngleAutomatic
 | MsoCalloutAngle30
 | MsoCalloutAngle45
 | MsoCalloutAngle60
 | MsoCalloutAngle90
 
marshallMsoCalloutAngleType :: MsoCalloutAngleType -> Prelude.IO Int.Int16
marshallMsoCalloutAngleType v =
  case v of
     MsoCalloutAngleMixed -> Prelude.return ((-2))
     MsoCalloutAngleAutomatic -> Prelude.return (1)
     MsoCalloutAngle30 -> Prelude.return (2)
     MsoCalloutAngle45 -> Prelude.return (3)
     MsoCalloutAngle60 -> Prelude.return (4)
     MsoCalloutAngle90 -> Prelude.return (5)
unmarshallMsoCalloutAngleType :: Int.Int16 -> Prelude.IO MsoCalloutAngleType
unmarshallMsoCalloutAngleType v =
  case v of
     (-2) -> Prelude.return (MsoCalloutAngleMixed)
     1 -> Prelude.return (MsoCalloutAngleAutomatic)
     2 -> Prelude.return (MsoCalloutAngle30)
     3 -> Prelude.return (MsoCalloutAngle45)
     4 -> Prelude.return (MsoCalloutAngle60)
     5 -> Prelude.return (MsoCalloutAngle90)
     _ -> Prelude.fail (Prelude.userError "unmarshallMsoCalloutAngleType: illegal enum value ")
data MsoCalloutDropType
 = MsoCalloutDropMixed
 | MsoCalloutDropCustom
 | MsoCalloutDropTop
 | MsoCalloutDropCenter
 | MsoCalloutDropBottom
 
marshallMsoCalloutDropType :: MsoCalloutDropType -> Prelude.IO Int.Int16
marshallMsoCalloutDropType v =
  case v of
     MsoCalloutDropMixed -> Prelude.return ((-2))
     MsoCalloutDropCustom -> Prelude.return (1)
     MsoCalloutDropTop -> Prelude.return (2)
     MsoCalloutDropCenter -> Prelude.return (3)
     MsoCalloutDropBottom -> Prelude.return (4)
unmarshallMsoCalloutDropType :: Int.Int16 -> Prelude.IO MsoCalloutDropType
unmarshallMsoCalloutDropType v =
  case v of
     (-2) -> Prelude.return (MsoCalloutDropMixed)
     1 -> Prelude.return (MsoCalloutDropCustom)
     2 -> Prelude.return (MsoCalloutDropTop)
     3 -> Prelude.return (MsoCalloutDropCenter)
     4 -> Prelude.return (MsoCalloutDropBottom)
     _ -> Prelude.fail (Prelude.userError "unmarshallMsoCalloutDropType: illegal enum value ")
data MsoCalloutType
 = MsoCalloutMixed
 | MsoCalloutOne
 | MsoCalloutTwo
 | MsoCalloutThree
 | MsoCalloutFour
 
marshallMsoCalloutType :: MsoCalloutType -> Prelude.IO Int.Int16
marshallMsoCalloutType v =
  case v of
     MsoCalloutMixed -> Prelude.return ((-2))
     MsoCalloutOne -> Prelude.return (1)
     MsoCalloutTwo -> Prelude.return (2)
     MsoCalloutThree -> Prelude.return (3)
     MsoCalloutFour -> Prelude.return (4)
unmarshallMsoCalloutType :: Int.Int16 -> Prelude.IO MsoCalloutType
unmarshallMsoCalloutType v =
  case v of
     (-2) -> Prelude.return (MsoCalloutMixed)
     1 -> Prelude.return (MsoCalloutOne)
     2 -> Prelude.return (MsoCalloutTwo)
     3 -> Prelude.return (MsoCalloutThree)
     4 -> Prelude.return (MsoCalloutFour)
     _ -> Prelude.fail (Prelude.userError "unmarshallMsoCalloutType: illegal enum value ")
data MsoBlackWhiteMode
 = MsoBlackWhiteMixed
 | MsoBlackWhiteAutomatic
 | MsoBlackWhiteGrayScale
 | MsoBlackWhiteLightGrayScale
 | MsoBlackWhiteInverseGrayScale
 | MsoBlackWhiteGrayOutline
 | MsoBlackWhiteBlackTextAndLine
 | MsoBlackWhiteHighContrast
 | MsoBlackWhiteBlack
 | MsoBlackWhiteWhite
 | MsoBlackWhiteDontShow
 
marshallMsoBlackWhiteMode :: MsoBlackWhiteMode -> Prelude.IO Int.Int16
marshallMsoBlackWhiteMode v =
  case v of
     MsoBlackWhiteMixed -> Prelude.return ((-2))
     MsoBlackWhiteAutomatic -> Prelude.return (1)
     MsoBlackWhiteGrayScale -> Prelude.return (2)
     MsoBlackWhiteLightGrayScale -> Prelude.return (3)
     MsoBlackWhiteInverseGrayScale -> Prelude.return (4)
     MsoBlackWhiteGrayOutline -> Prelude.return (5)
     MsoBlackWhiteBlackTextAndLine -> Prelude.return (6)
     MsoBlackWhiteHighContrast -> Prelude.return (7)
     MsoBlackWhiteBlack -> Prelude.return (8)
     MsoBlackWhiteWhite -> Prelude.return (9)
     MsoBlackWhiteDontShow -> Prelude.return (10)
unmarshallMsoBlackWhiteMode :: Int.Int16 -> Prelude.IO MsoBlackWhiteMode
unmarshallMsoBlackWhiteMode v =
  case v of
     (-2) -> Prelude.return (MsoBlackWhiteMixed)
     1 -> Prelude.return (MsoBlackWhiteAutomatic)
     2 -> Prelude.return (MsoBlackWhiteGrayScale)
     3 -> Prelude.return (MsoBlackWhiteLightGrayScale)
     4 -> Prelude.return (MsoBlackWhiteInverseGrayScale)
     5 -> Prelude.return (MsoBlackWhiteGrayOutline)
     6 -> Prelude.return (MsoBlackWhiteBlackTextAndLine)
     7 -> Prelude.return (MsoBlackWhiteHighContrast)
     8 -> Prelude.return (MsoBlackWhiteBlack)
     9 -> Prelude.return (MsoBlackWhiteWhite)
     10 -> Prelude.return (MsoBlackWhiteDontShow)
     _ -> Prelude.fail (Prelude.userError "unmarshallMsoBlackWhiteMode: illegal enum value ")
data MsoMixedType
 = MsoIntegerMixed
 | MsoSingleMixed
 
marshallMsoMixedType :: MsoMixedType -> Prelude.IO Int.Int16
marshallMsoMixedType v =
  case v of
     MsoIntegerMixed -> Prelude.return (32768)
     MsoSingleMixed -> Prelude.return (0)
unmarshallMsoMixedType :: Int.Int16 -> Prelude.IO MsoMixedType
unmarshallMsoMixedType v =
  case v of
     32768 -> Prelude.return (MsoIntegerMixed)
     0 -> Prelude.return (MsoSingleMixed)
     _ -> Prelude.fail (Prelude.userError "unmarshallMsoMixedType: illegal enum value ")
data MsoTextOrientation
 = MsoTextOrientationMixed
 | MsoTextOrientationHorizontal
 | MsoTextOrientationUpward
 | MsoTextOrientationDownward
 | MsoTextOrientationVerticalFarEast
 | MsoTextOrientationVertical
 | MsoTextOrientationHorizontalRotatedFarEast
 
marshallMsoTextOrientation :: MsoTextOrientation -> Prelude.IO Int.Int16
marshallMsoTextOrientation v =
  case v of
     MsoTextOrientationMixed -> Prelude.return ((-2))
     MsoTextOrientationHorizontal -> Prelude.return (1)
     MsoTextOrientationUpward -> Prelude.return (2)
     MsoTextOrientationDownward -> Prelude.return (3)
     MsoTextOrientationVerticalFarEast -> Prelude.return (4)
     MsoTextOrientationVertical -> Prelude.return (5)
     MsoTextOrientationHorizontalRotatedFarEast -> Prelude.return (6)
unmarshallMsoTextOrientation :: Int.Int16 -> Prelude.IO MsoTextOrientation
unmarshallMsoTextOrientation v =
  case v of
     (-2) -> Prelude.return (MsoTextOrientationMixed)
     1 -> Prelude.return (MsoTextOrientationHorizontal)
     2 -> Prelude.return (MsoTextOrientationUpward)
     3 -> Prelude.return (MsoTextOrientationDownward)
     4 -> Prelude.return (MsoTextOrientationVerticalFarEast)
     5 -> Prelude.return (MsoTextOrientationVertical)
     6 -> Prelude.return (MsoTextOrientationHorizontalRotatedFarEast)
     _ -> Prelude.fail (Prelude.userError "unmarshallMsoTextOrientation: illegal enum value ")
data MsoScaleFrom
 = MsoScaleFromTopLeft
 | MsoScaleFromMiddle
 | MsoScaleFromBottomRight
 
marshallMsoScaleFrom :: MsoScaleFrom -> Prelude.IO Int.Int16
marshallMsoScaleFrom v =
  case v of
     MsoScaleFromTopLeft -> Prelude.return (0)
     MsoScaleFromMiddle -> Prelude.return (1)
     MsoScaleFromBottomRight -> Prelude.return (2)
unmarshallMsoScaleFrom :: Int.Int16 -> Prelude.IO MsoScaleFrom
unmarshallMsoScaleFrom v =
  case v of
     0 -> Prelude.return (MsoScaleFromTopLeft)
     1 -> Prelude.return (MsoScaleFromMiddle)
     2 -> Prelude.return (MsoScaleFromBottomRight)
     _ -> Prelude.fail (Prelude.userError "unmarshallMsoScaleFrom: illegal enum value ")
type MsoRGBType = Int.Int32
data MsoBarPosition
 = MsoBarLeft
 | MsoBarTop
 | MsoBarRight
 | MsoBarBottom
 | MsoBarFloating
 | MsoBarPopup
 | MsoBarMenuBar
 
marshallMsoBarPosition :: MsoBarPosition -> Prelude.IO Int.Int16
marshallMsoBarPosition v =
  case v of
     MsoBarLeft -> Prelude.return (0)
     MsoBarTop -> Prelude.return (1)
     MsoBarRight -> Prelude.return (2)
     MsoBarBottom -> Prelude.return (3)
     MsoBarFloating -> Prelude.return (4)
     MsoBarPopup -> Prelude.return (5)
     MsoBarMenuBar -> Prelude.return (6)
unmarshallMsoBarPosition :: Int.Int16 -> Prelude.IO MsoBarPosition
unmarshallMsoBarPosition v =
  case v of
     0 -> Prelude.return (MsoBarLeft)
     1 -> Prelude.return (MsoBarTop)
     2 -> Prelude.return (MsoBarRight)
     3 -> Prelude.return (MsoBarBottom)
     4 -> Prelude.return (MsoBarFloating)
     5 -> Prelude.return (MsoBarPopup)
     6 -> Prelude.return (MsoBarMenuBar)
     _ -> Prelude.fail (Prelude.userError "unmarshallMsoBarPosition: illegal enum value ")
data MsoBarProtection
 = MsoBarNoProtection
 | MsoBarNoCustomize
 | MsoBarNoResize
 | MsoBarNoMove
 | MsoBarNoChangeVisible
 | MsoBarNoChangeDock
 | MsoBarNoVerticalDock
 | MsoBarNoHorizontalDock
 
marshallMsoBarProtection :: MsoBarProtection -> Prelude.IO Int.Int16
marshallMsoBarProtection v =
  case v of
     MsoBarNoProtection -> Prelude.return (0)
     MsoBarNoCustomize -> Prelude.return (1)
     MsoBarNoResize -> Prelude.return (2)
     MsoBarNoMove -> Prelude.return (4)
     MsoBarNoChangeVisible -> Prelude.return (8)
     MsoBarNoChangeDock -> Prelude.return (16)
     MsoBarNoVerticalDock -> Prelude.return (32)
     MsoBarNoHorizontalDock -> Prelude.return (64)
unmarshallMsoBarProtection :: Int.Int16 -> Prelude.IO MsoBarProtection
unmarshallMsoBarProtection v =
  case v of
     0 -> Prelude.return (MsoBarNoProtection)
     1 -> Prelude.return (MsoBarNoCustomize)
     2 -> Prelude.return (MsoBarNoResize)
     4 -> Prelude.return (MsoBarNoMove)
     8 -> Prelude.return (MsoBarNoChangeVisible)
     16 -> Prelude.return (MsoBarNoChangeDock)
     32 -> Prelude.return (MsoBarNoVerticalDock)
     64 -> Prelude.return (MsoBarNoHorizontalDock)
     _ -> Prelude.fail (Prelude.userError "unmarshallMsoBarProtection: illegal enum value ")
data MsoBarType
 = MsoBarTypeNormal
 | MsoBarTypeMenuBar
 | MsoBarTypePopup
 
marshallMsoBarType :: MsoBarType -> Prelude.IO Int.Int16
marshallMsoBarType v =
  case v of
     MsoBarTypeNormal -> Prelude.return (0)
     MsoBarTypeMenuBar -> Prelude.return (1)
     MsoBarTypePopup -> Prelude.return (2)
unmarshallMsoBarType :: Int.Int16 -> Prelude.IO MsoBarType
unmarshallMsoBarType v =
  case v of
     0 -> Prelude.return (MsoBarTypeNormal)
     1 -> Prelude.return (MsoBarTypeMenuBar)
     2 -> Prelude.return (MsoBarTypePopup)
     _ -> Prelude.fail (Prelude.userError "unmarshallMsoBarType: illegal enum value ")
data MsoControlType
 = MsoControlCustom
 | MsoControlButton
 | MsoControlEdit
 | MsoControlDropdown
 | MsoControlComboBox
 | MsoControlButtonDropdown
 | MsoControlSplitDropdown
 | MsoControlOCXDropdown
 | MsoControlGenericDropdown
 | MsoControlGraphicDropdown
 | MsoControlPopup
 | MsoControlGraphicPopup
 | MsoControlButtonPopup
 | MsoControlSplitButtonPopup
 | MsoControlSplitButtonMRUPopup
 | MsoControlLabel
 | MsoControlExpandingGrid
 | MsoControlSplitExpandingGrid
 | MsoControlGrid
 | MsoControlGauge
 | MsoControlGraphicCombo
 
marshallMsoControlType :: MsoControlType -> Prelude.IO Int.Int16
marshallMsoControlType v =
  case v of
     MsoControlCustom -> Prelude.return (0)
     MsoControlButton -> Prelude.return (1)
     MsoControlEdit -> Prelude.return (2)
     MsoControlDropdown -> Prelude.return (3)
     MsoControlComboBox -> Prelude.return (4)
     MsoControlButtonDropdown -> Prelude.return (5)
     MsoControlSplitDropdown -> Prelude.return (6)
     MsoControlOCXDropdown -> Prelude.return (7)
     MsoControlGenericDropdown -> Prelude.return (8)
     MsoControlGraphicDropdown -> Prelude.return (9)
     MsoControlPopup -> Prelude.return (10)
     MsoControlGraphicPopup -> Prelude.return (11)
     MsoControlButtonPopup -> Prelude.return (12)
     MsoControlSplitButtonPopup -> Prelude.return (13)
     MsoControlSplitButtonMRUPopup -> Prelude.return (14)
     MsoControlLabel -> Prelude.return (15)
     MsoControlExpandingGrid -> Prelude.return (16)
     MsoControlSplitExpandingGrid -> Prelude.return (17)
     MsoControlGrid -> Prelude.return (18)
     MsoControlGauge -> Prelude.return (19)
     MsoControlGraphicCombo -> Prelude.return (20)
unmarshallMsoControlType :: Int.Int16 -> Prelude.IO MsoControlType
unmarshallMsoControlType v =
  case v of
     0 -> Prelude.return (MsoControlCustom)
     1 -> Prelude.return (MsoControlButton)
     2 -> Prelude.return (MsoControlEdit)
     3 -> Prelude.return (MsoControlDropdown)
     4 -> Prelude.return (MsoControlComboBox)
     5 -> Prelude.return (MsoControlButtonDropdown)
     6 -> Prelude.return (MsoControlSplitDropdown)
     7 -> Prelude.return (MsoControlOCXDropdown)
     8 -> Prelude.return (MsoControlGenericDropdown)
     9 -> Prelude.return (MsoControlGraphicDropdown)
     10 -> Prelude.return (MsoControlPopup)
     11 -> Prelude.return (MsoControlGraphicPopup)
     12 -> Prelude.return (MsoControlButtonPopup)
     13 -> Prelude.return (MsoControlSplitButtonPopup)
     14 -> Prelude.return (MsoControlSplitButtonMRUPopup)
     15 -> Prelude.return (MsoControlLabel)
     16 -> Prelude.return (MsoControlExpandingGrid)
     17 -> Prelude.return (MsoControlSplitExpandingGrid)
     18 -> Prelude.return (MsoControlGrid)
     19 -> Prelude.return (MsoControlGauge)
     20 -> Prelude.return (MsoControlGraphicCombo)
     _ -> Prelude.fail (Prelude.userError "unmarshallMsoControlType: illegal enum value ")
data MsoButtonState
 = MsoButtonUp
 | MsoButtonDown
 | MsoButtonMixed
 
marshallMsoButtonState :: MsoButtonState -> Prelude.IO Int.Int16
marshallMsoButtonState v =
  case v of
     MsoButtonUp -> Prelude.return (0)
     MsoButtonDown -> Prelude.return ((-1))
     MsoButtonMixed -> Prelude.return (2)
unmarshallMsoButtonState :: Int.Int16 -> Prelude.IO MsoButtonState
unmarshallMsoButtonState v =
  case v of
     0 -> Prelude.return (MsoButtonUp)
     (-1) -> Prelude.return (MsoButtonDown)
     2 -> Prelude.return (MsoButtonMixed)
     _ -> Prelude.fail (Prelude.userError "unmarshallMsoButtonState: illegal enum value ")
data MsoControlOLEUsage
 = MsoControlOLEUsageNeither
 | MsoControlOLEUsageServer
 | MsoControlOLEUsageClient
 | MsoControlOLEUsageBoth
 
marshallMsoControlOLEUsage :: MsoControlOLEUsage -> Prelude.IO Int.Int16
marshallMsoControlOLEUsage v =
  case v of
     MsoControlOLEUsageNeither -> Prelude.return (0)
     MsoControlOLEUsageServer -> Prelude.return (1)
     MsoControlOLEUsageClient -> Prelude.return (2)
     MsoControlOLEUsageBoth -> Prelude.return (3)
unmarshallMsoControlOLEUsage :: Int.Int16 -> Prelude.IO MsoControlOLEUsage
unmarshallMsoControlOLEUsage v =
  case v of
     0 -> Prelude.return (MsoControlOLEUsageNeither)
     1 -> Prelude.return (MsoControlOLEUsageServer)
     2 -> Prelude.return (MsoControlOLEUsageClient)
     3 -> Prelude.return (MsoControlOLEUsageBoth)
     _ -> Prelude.fail (Prelude.userError "unmarshallMsoControlOLEUsage: illegal enum value ")
data MsoButtonStyle
 = MsoButtonAutomatic
 | MsoButtonIcon
 | MsoButtonCaption
 | MsoButtonIconAndCaption
 
marshallMsoButtonStyle :: MsoButtonStyle -> Prelude.IO Int.Int16
marshallMsoButtonStyle v =
  case v of
     MsoButtonAutomatic -> Prelude.return (0)
     MsoButtonIcon -> Prelude.return (1)
     MsoButtonCaption -> Prelude.return (2)
     MsoButtonIconAndCaption -> Prelude.return (3)
unmarshallMsoButtonStyle :: Int.Int16 -> Prelude.IO MsoButtonStyle
unmarshallMsoButtonStyle v =
  case v of
     0 -> Prelude.return (MsoButtonAutomatic)
     1 -> Prelude.return (MsoButtonIcon)
     2 -> Prelude.return (MsoButtonCaption)
     3 -> Prelude.return (MsoButtonIconAndCaption)
     _ -> Prelude.fail (Prelude.userError "unmarshallMsoButtonStyle: illegal enum value ")
data MsoComboStyle
 = MsoComboNormal
 | MsoComboLabel
 
marshallMsoComboStyle :: MsoComboStyle -> Prelude.IO Int.Int16
marshallMsoComboStyle v =
  case v of
     MsoComboNormal -> Prelude.return (0)
     MsoComboLabel -> Prelude.return (1)
unmarshallMsoComboStyle :: Int.Int16 -> Prelude.IO MsoComboStyle
unmarshallMsoComboStyle v =
  case v of
     0 -> Prelude.return (MsoComboNormal)
     1 -> Prelude.return (MsoComboLabel)
     _ -> Prelude.fail (Prelude.userError "unmarshallMsoComboStyle: illegal enum value ")
data MsoOLEMenuGroup
 = MsoOLEMenuGroupNone
 | MsoOLEMenuGroupFile
 | MsoOLEMenuGroupEdit
 | MsoOLEMenuGroupContainer
 | MsoOLEMenuGroupObject
 | MsoOLEMenuGroupWindow
 | MsoOLEMenuGroupHelp
 
marshallMsoOLEMenuGroup :: MsoOLEMenuGroup -> Prelude.IO Int.Int16
marshallMsoOLEMenuGroup v =
  case v of
     MsoOLEMenuGroupNone -> Prelude.return ((-1))
     MsoOLEMenuGroupFile -> Prelude.return (0)
     MsoOLEMenuGroupEdit -> Prelude.return (1)
     MsoOLEMenuGroupContainer -> Prelude.return (2)
     MsoOLEMenuGroupObject -> Prelude.return (3)
     MsoOLEMenuGroupWindow -> Prelude.return (4)
     MsoOLEMenuGroupHelp -> Prelude.return (5)
unmarshallMsoOLEMenuGroup :: Int.Int16 -> Prelude.IO MsoOLEMenuGroup
unmarshallMsoOLEMenuGroup v =
  case v of
     (-1) -> Prelude.return (MsoOLEMenuGroupNone)
     0 -> Prelude.return (MsoOLEMenuGroupFile)
     1 -> Prelude.return (MsoOLEMenuGroupEdit)
     2 -> Prelude.return (MsoOLEMenuGroupContainer)
     3 -> Prelude.return (MsoOLEMenuGroupObject)
     4 -> Prelude.return (MsoOLEMenuGroupWindow)
     5 -> Prelude.return (MsoOLEMenuGroupHelp)
     _ -> Prelude.fail (Prelude.userError "unmarshallMsoOLEMenuGroup: illegal enum value ")
data MsoMenuAnimation
 = MsoMenuAnimationNone
 | MsoMenuAnimationRandom
 | MsoMenuAnimationUnfold
 | MsoMenuAnimationSlide
 
marshallMsoMenuAnimation :: MsoMenuAnimation -> Prelude.IO Int.Int16
marshallMsoMenuAnimation v =
  case v of
     MsoMenuAnimationNone -> Prelude.return (0)
     MsoMenuAnimationRandom -> Prelude.return (1)
     MsoMenuAnimationUnfold -> Prelude.return (2)
     MsoMenuAnimationSlide -> Prelude.return (3)
unmarshallMsoMenuAnimation :: Int.Int16 -> Prelude.IO MsoMenuAnimation
unmarshallMsoMenuAnimation v =
  case v of
     0 -> Prelude.return (MsoMenuAnimationNone)
     1 -> Prelude.return (MsoMenuAnimationRandom)
     2 -> Prelude.return (MsoMenuAnimationUnfold)
     3 -> Prelude.return (MsoMenuAnimationSlide)
     _ -> Prelude.fail (Prelude.userError "unmarshallMsoMenuAnimation: illegal enum value ")
data MsoBarRow
 = MsoBarRowFirst
 | MsoBarRowLast
 
marshallMsoBarRow :: MsoBarRow -> Prelude.IO Int.Int16
marshallMsoBarRow v =
  case v of
     MsoBarRowFirst -> Prelude.return (0)
     MsoBarRowLast -> Prelude.return ((-1))
unmarshallMsoBarRow :: Int.Int16 -> Prelude.IO MsoBarRow
unmarshallMsoBarRow v =
  case v of
     0 -> Prelude.return (MsoBarRowFirst)
     (-1) -> Prelude.return (MsoBarRowLast)
     _ -> Prelude.fail (Prelude.userError "unmarshallMsoBarRow: illegal enum value ")
data MsoHyperlinkType
 = MsoHyperlinkRange
 | MsoHyperlinkShape
 | MsoHyperlinkInlineShape
 
marshallMsoHyperlinkType :: MsoHyperlinkType -> Prelude.IO Int.Int16
marshallMsoHyperlinkType v =
  case v of
     MsoHyperlinkRange -> Prelude.return (0)
     MsoHyperlinkShape -> Prelude.return (1)
     MsoHyperlinkInlineShape -> Prelude.return (2)
unmarshallMsoHyperlinkType :: Int.Int16 -> Prelude.IO MsoHyperlinkType
unmarshallMsoHyperlinkType v =
  case v of
     0 -> Prelude.return (MsoHyperlinkRange)
     1 -> Prelude.return (MsoHyperlinkShape)
     2 -> Prelude.return (MsoHyperlinkInlineShape)
     _ -> Prelude.fail (Prelude.userError "unmarshallMsoHyperlinkType: illegal enum value ")
data MsoExtraInfoMethod
 = MsoMethodGet
 | MsoMethodPost
 
marshallMsoExtraInfoMethod :: MsoExtraInfoMethod -> Prelude.IO Int.Int16
marshallMsoExtraInfoMethod v =
  case v of
     MsoMethodGet -> Prelude.return (0)
     MsoMethodPost -> Prelude.return (1)
unmarshallMsoExtraInfoMethod :: Int.Int16 -> Prelude.IO MsoExtraInfoMethod
unmarshallMsoExtraInfoMethod v =
  case v of
     0 -> Prelude.return (MsoMethodGet)
     1 -> Prelude.return (MsoMethodPost)
     _ -> Prelude.fail (Prelude.userError "unmarshallMsoExtraInfoMethod: illegal enum value ")
data MsoAnimationType
 = MsoAnimationIdle
 | MsoAnimationGreeting
 | MsoAnimationGoodbye
 | MsoAnimationBeginSpeaking
 | MsoAnimationCharacterSuccessMajor
 | MsoAnimationGetAttentionMajor
 | MsoAnimationGetAttentionMinor
 | MsoAnimationSearching
 | MsoAnimationPrinting
 | MsoAnimationGestureRight
 | MsoAnimationWritingNotingSomething
 | MsoAnimationWorkingAtSomething
 | MsoAnimationThinking
 | MsoAnimationSendingMail
 | MsoAnimationListensToComputer
 | MsoAnimationDisappear
 | MsoAnimationAppear
 | MsoAnimationGetArtsy
 | MsoAnimationGetTechy
 | MsoAnimationGetWizardy
 | MsoAnimationCheckingSomething
 | MsoAnimationLookDown
 | MsoAnimationLookDownLeft
 | MsoAnimationLookDownRight
 | MsoAnimationLookLeft
 | MsoAnimationLookRight
 | MsoAnimationLookUp
 | MsoAnimationLookUpLeft
 | MsoAnimationLookUpRight
 | MsoAnimationSaving
 | MsoAnimationGestureDown
 | MsoAnimationGestureLeft
 | MsoAnimationGestureUp
 | MsoAnimationEmptyTrash
 
marshallMsoAnimationType :: MsoAnimationType -> Prelude.IO Int.Int16
marshallMsoAnimationType v =
  case v of
     MsoAnimationIdle -> Prelude.return (1)
     MsoAnimationGreeting -> Prelude.return (2)
     MsoAnimationGoodbye -> Prelude.return (3)
     MsoAnimationBeginSpeaking -> Prelude.return (4)
     MsoAnimationCharacterSuccessMajor -> Prelude.return (6)
     MsoAnimationGetAttentionMajor -> Prelude.return (11)
     MsoAnimationGetAttentionMinor -> Prelude.return (12)
     MsoAnimationSearching -> Prelude.return (13)
     MsoAnimationPrinting -> Prelude.return (18)
     MsoAnimationGestureRight -> Prelude.return (19)
     MsoAnimationWritingNotingSomething -> Prelude.return (22)
     MsoAnimationWorkingAtSomething -> Prelude.return (23)
     MsoAnimationThinking -> Prelude.return (24)
     MsoAnimationSendingMail -> Prelude.return (25)
     MsoAnimationListensToComputer -> Prelude.return (26)
     MsoAnimationDisappear -> Prelude.return (31)
     MsoAnimationAppear -> Prelude.return (32)
     MsoAnimationGetArtsy -> Prelude.return (100)
     MsoAnimationGetTechy -> Prelude.return (101)
     MsoAnimationGetWizardy -> Prelude.return (102)
     MsoAnimationCheckingSomething -> Prelude.return (103)
     MsoAnimationLookDown -> Prelude.return (104)
     MsoAnimationLookDownLeft -> Prelude.return (105)
     MsoAnimationLookDownRight -> Prelude.return (106)
     MsoAnimationLookLeft -> Prelude.return (107)
     MsoAnimationLookRight -> Prelude.return (108)
     MsoAnimationLookUp -> Prelude.return (109)
     MsoAnimationLookUpLeft -> Prelude.return (110)
     MsoAnimationLookUpRight -> Prelude.return (111)
     MsoAnimationSaving -> Prelude.return (112)
     MsoAnimationGestureDown -> Prelude.return (113)
     MsoAnimationGestureLeft -> Prelude.return (114)
     MsoAnimationGestureUp -> Prelude.return (115)
     MsoAnimationEmptyTrash -> Prelude.return (116)
unmarshallMsoAnimationType :: Int.Int16 -> Prelude.IO MsoAnimationType
unmarshallMsoAnimationType v =
  case v of
     1 -> Prelude.return (MsoAnimationIdle)
     2 -> Prelude.return (MsoAnimationGreeting)
     3 -> Prelude.return (MsoAnimationGoodbye)
     4 -> Prelude.return (MsoAnimationBeginSpeaking)
     6 -> Prelude.return (MsoAnimationCharacterSuccessMajor)
     11 -> Prelude.return (MsoAnimationGetAttentionMajor)
     12 -> Prelude.return (MsoAnimationGetAttentionMinor)
     13 -> Prelude.return (MsoAnimationSearching)
     18 -> Prelude.return (MsoAnimationPrinting)
     19 -> Prelude.return (MsoAnimationGestureRight)
     22 -> Prelude.return (MsoAnimationWritingNotingSomething)
     23 -> Prelude.return (MsoAnimationWorkingAtSomething)
     24 -> Prelude.return (MsoAnimationThinking)
     25 -> Prelude.return (MsoAnimationSendingMail)
     26 -> Prelude.return (MsoAnimationListensToComputer)
     31 -> Prelude.return (MsoAnimationDisappear)
     32 -> Prelude.return (MsoAnimationAppear)
     100 -> Prelude.return (MsoAnimationGetArtsy)
     101 -> Prelude.return (MsoAnimationGetTechy)
     102 -> Prelude.return (MsoAnimationGetWizardy)
     103 -> Prelude.return (MsoAnimationCheckingSomething)
     104 -> Prelude.return (MsoAnimationLookDown)
     105 -> Prelude.return (MsoAnimationLookDownLeft)
     106 -> Prelude.return (MsoAnimationLookDownRight)
     107 -> Prelude.return (MsoAnimationLookLeft)
     108 -> Prelude.return (MsoAnimationLookRight)
     109 -> Prelude.return (MsoAnimationLookUp)
     110 -> Prelude.return (MsoAnimationLookUpLeft)
     111 -> Prelude.return (MsoAnimationLookUpRight)
     112 -> Prelude.return (MsoAnimationSaving)
     113 -> Prelude.return (MsoAnimationGestureDown)
     114 -> Prelude.return (MsoAnimationGestureLeft)
     115 -> Prelude.return (MsoAnimationGestureUp)
     116 -> Prelude.return (MsoAnimationEmptyTrash)
     _ -> Prelude.fail (Prelude.userError "unmarshallMsoAnimationType: illegal enum value ")
data MsoButtonSetType
 = MsoButtonSetNone
 | MsoButtonSetOK
 | MsoButtonSetCancel
 | MsoButtonSetOkCancel
 | MsoButtonSetYesNo
 | MsoButtonSetYesNoCancel
 | MsoButtonSetBackClose
 | MsoButtonSetNextClose
 | MsoButtonSetBackNextClose
 | MsoButtonSetRetryCancel
 | MsoButtonSetAbortRetryIgnore
 | MsoButtonSetSearchClose
 | MsoButtonSetBackNextSnooze
 | MsoButtonSetTipsOptionsClose
 | MsoButtonSetYesAllNoCancel
 
marshallMsoButtonSetType :: MsoButtonSetType -> Prelude.IO Int.Int16
marshallMsoButtonSetType v =
  case v of
     MsoButtonSetNone -> Prelude.return (0)
     MsoButtonSetOK -> Prelude.return (1)
     MsoButtonSetCancel -> Prelude.return (2)
     MsoButtonSetOkCancel -> Prelude.return (3)
     MsoButtonSetYesNo -> Prelude.return (4)
     MsoButtonSetYesNoCancel -> Prelude.return (5)
     MsoButtonSetBackClose -> Prelude.return (6)
     MsoButtonSetNextClose -> Prelude.return (7)
     MsoButtonSetBackNextClose -> Prelude.return (8)
     MsoButtonSetRetryCancel -> Prelude.return (9)
     MsoButtonSetAbortRetryIgnore -> Prelude.return (10)
     MsoButtonSetSearchClose -> Prelude.return (11)
     MsoButtonSetBackNextSnooze -> Prelude.return (12)
     MsoButtonSetTipsOptionsClose -> Prelude.return (13)
     MsoButtonSetYesAllNoCancel -> Prelude.return (14)
unmarshallMsoButtonSetType :: Int.Int16 -> Prelude.IO MsoButtonSetType
unmarshallMsoButtonSetType v =
  case v of
     0 -> Prelude.return (MsoButtonSetNone)
     1 -> Prelude.return (MsoButtonSetOK)
     2 -> Prelude.return (MsoButtonSetCancel)
     3 -> Prelude.return (MsoButtonSetOkCancel)
     4 -> Prelude.return (MsoButtonSetYesNo)
     5 -> Prelude.return (MsoButtonSetYesNoCancel)
     6 -> Prelude.return (MsoButtonSetBackClose)
     7 -> Prelude.return (MsoButtonSetNextClose)
     8 -> Prelude.return (MsoButtonSetBackNextClose)
     9 -> Prelude.return (MsoButtonSetRetryCancel)
     10 -> Prelude.return (MsoButtonSetAbortRetryIgnore)
     11 -> Prelude.return (MsoButtonSetSearchClose)
     12 -> Prelude.return (MsoButtonSetBackNextSnooze)
     13 -> Prelude.return (MsoButtonSetTipsOptionsClose)
     14 -> Prelude.return (MsoButtonSetYesAllNoCancel)
     _ -> Prelude.fail (Prelude.userError "unmarshallMsoButtonSetType: illegal enum value ")
data MsoIconType
 = MsoIconNone
 | MsoIconAlert
 | MsoIconTip
 
marshallMsoIconType :: MsoIconType -> Prelude.IO Int.Int16
marshallMsoIconType v =
  case v of
     MsoIconNone -> Prelude.return (0)
     MsoIconAlert -> Prelude.return (2)
     MsoIconTip -> Prelude.return (3)
unmarshallMsoIconType :: Int.Int16 -> Prelude.IO MsoIconType
unmarshallMsoIconType v =
  case v of
     0 -> Prelude.return (MsoIconNone)
     2 -> Prelude.return (MsoIconAlert)
     3 -> Prelude.return (MsoIconTip)
     _ -> Prelude.fail (Prelude.userError "unmarshallMsoIconType: illegal enum value ")
data MsoBalloonType
 = MsoBalloonTypeButtons
 | MsoBalloonTypeBullets
 | MsoBalloonTypeNumbers
 
marshallMsoBalloonType :: MsoBalloonType -> Prelude.IO Int.Int16
marshallMsoBalloonType v =
  case v of
     MsoBalloonTypeButtons -> Prelude.return (0)
     MsoBalloonTypeBullets -> Prelude.return (1)
     MsoBalloonTypeNumbers -> Prelude.return (2)
unmarshallMsoBalloonType :: Int.Int16 -> Prelude.IO MsoBalloonType
unmarshallMsoBalloonType v =
  case v of
     0 -> Prelude.return (MsoBalloonTypeButtons)
     1 -> Prelude.return (MsoBalloonTypeBullets)
     2 -> Prelude.return (MsoBalloonTypeNumbers)
     _ -> Prelude.fail (Prelude.userError "unmarshallMsoBalloonType: illegal enum value ")
data MsoModeType
 = MsoModeModal
 | MsoModeAutoDown
 | MsoModeModeless
 
marshallMsoModeType :: MsoModeType -> Prelude.IO Int.Int16
marshallMsoModeType v =
  case v of
     MsoModeModal -> Prelude.return (0)
     MsoModeAutoDown -> Prelude.return (1)
     MsoModeModeless -> Prelude.return (2)
unmarshallMsoModeType :: Int.Int16 -> Prelude.IO MsoModeType
unmarshallMsoModeType v =
  case v of
     0 -> Prelude.return (MsoModeModal)
     1 -> Prelude.return (MsoModeAutoDown)
     2 -> Prelude.return (MsoModeModeless)
     _ -> Prelude.fail (Prelude.userError "unmarshallMsoModeType: illegal enum value ")
data MsoBalloonErrorType
 = MsoBalloonErrorNone
 | MsoBalloonErrorOther
 | MsoBalloonErrorTooBig
 | MsoBalloonErrorOutOfMemory
 | MsoBalloonErrorBadPictureRef
 | MsoBalloonErrorBadReference
 | MsoBalloonErrorButtonlessModal
 | MsoBalloonErrorButtonModeless
 | MsoBalloonErrorBadCharacter
 
marshallMsoBalloonErrorType :: MsoBalloonErrorType -> Prelude.IO Int.Int16
marshallMsoBalloonErrorType v =
  case v of
     MsoBalloonErrorNone -> Prelude.return (0)
     MsoBalloonErrorOther -> Prelude.return (1)
     MsoBalloonErrorTooBig -> Prelude.return (2)
     MsoBalloonErrorOutOfMemory -> Prelude.return (3)
     MsoBalloonErrorBadPictureRef -> Prelude.return (4)
     MsoBalloonErrorBadReference -> Prelude.return (5)
     MsoBalloonErrorButtonlessModal -> Prelude.return (6)
     MsoBalloonErrorButtonModeless -> Prelude.return (7)
     MsoBalloonErrorBadCharacter -> Prelude.return (8)
unmarshallMsoBalloonErrorType :: Int.Int16 -> Prelude.IO MsoBalloonErrorType
unmarshallMsoBalloonErrorType v =
  case v of
     0 -> Prelude.return (MsoBalloonErrorNone)
     1 -> Prelude.return (MsoBalloonErrorOther)
     2 -> Prelude.return (MsoBalloonErrorTooBig)
     3 -> Prelude.return (MsoBalloonErrorOutOfMemory)
     4 -> Prelude.return (MsoBalloonErrorBadPictureRef)
     5 -> Prelude.return (MsoBalloonErrorBadReference)
     6 -> Prelude.return (MsoBalloonErrorButtonlessModal)
     7 -> Prelude.return (MsoBalloonErrorButtonModeless)
     8 -> Prelude.return (MsoBalloonErrorBadCharacter)
     _ -> Prelude.fail (Prelude.userError "unmarshallMsoBalloonErrorType: illegal enum value ")
data MsoWizardActType
 = MsoWizardActInactive
 | MsoWizardActActive
 | MsoWizardActSuspend
 | MsoWizardActResume
 
marshallMsoWizardActType :: MsoWizardActType -> Prelude.IO Int.Int16
marshallMsoWizardActType v =
  case v of
     MsoWizardActInactive -> Prelude.return (0)
     MsoWizardActActive -> Prelude.return (1)
     MsoWizardActSuspend -> Prelude.return (2)
     MsoWizardActResume -> Prelude.return (3)
unmarshallMsoWizardActType :: Int.Int16 -> Prelude.IO MsoWizardActType
unmarshallMsoWizardActType v =
  case v of
     0 -> Prelude.return (MsoWizardActInactive)
     1 -> Prelude.return (MsoWizardActActive)
     2 -> Prelude.return (MsoWizardActSuspend)
     3 -> Prelude.return (MsoWizardActResume)
     _ -> Prelude.fail (Prelude.userError "unmarshallMsoWizardActType: illegal enum value ")
data MsoWizardMsgType
 = MsoWizardMsgLocalStateOn
 | MsoWizardMsgLocalStateOff
 | MsoWizardMsgShowHelp
 | MsoWizardMsgSuspending
 | MsoWizardMsgResuming
 
marshallMsoWizardMsgType :: MsoWizardMsgType -> Prelude.IO Int.Int16
marshallMsoWizardMsgType v =
  case v of
     MsoWizardMsgLocalStateOn -> Prelude.return (1)
     MsoWizardMsgLocalStateOff -> Prelude.return (2)
     MsoWizardMsgShowHelp -> Prelude.return (3)
     MsoWizardMsgSuspending -> Prelude.return (4)
     MsoWizardMsgResuming -> Prelude.return (5)
unmarshallMsoWizardMsgType :: Int.Int16 -> Prelude.IO MsoWizardMsgType
unmarshallMsoWizardMsgType v =
  case v of
     1 -> Prelude.return (MsoWizardMsgLocalStateOn)
     2 -> Prelude.return (MsoWizardMsgLocalStateOff)
     3 -> Prelude.return (MsoWizardMsgShowHelp)
     4 -> Prelude.return (MsoWizardMsgSuspending)
     5 -> Prelude.return (MsoWizardMsgResuming)
     _ -> Prelude.fail (Prelude.userError "unmarshallMsoWizardMsgType: illegal enum value ")
data MsoBalloonButtonType
 = MsoBalloonButtonYesToAll
 | MsoBalloonButtonOptions
 | MsoBalloonButtonTips
 | MsoBalloonButtonClose
 | MsoBalloonButtonSnooze
 | MsoBalloonButtonSearch
 | MsoBalloonButtonIgnore
 | MsoBalloonButtonAbort
 | MsoBalloonButtonRetry
 | MsoBalloonButtonNext
 | MsoBalloonButtonBack
 | MsoBalloonButtonNo
 | MsoBalloonButtonYes
 | MsoBalloonButtonCancel
 | MsoBalloonButtonOK
 | MsoBalloonButtonNull
 
marshallMsoBalloonButtonType :: MsoBalloonButtonType -> Prelude.IO Int.Int16
marshallMsoBalloonButtonType v =
  case v of
     MsoBalloonButtonYesToAll -> Prelude.return ((-15))
     MsoBalloonButtonOptions -> Prelude.return ((-14))
     MsoBalloonButtonTips -> Prelude.return ((-13))
     MsoBalloonButtonClose -> Prelude.return ((-12))
     MsoBalloonButtonSnooze -> Prelude.return ((-11))
     MsoBalloonButtonSearch -> Prelude.return ((-10))
     MsoBalloonButtonIgnore -> Prelude.return ((-9))
     MsoBalloonButtonAbort -> Prelude.return ((-8))
     MsoBalloonButtonRetry -> Prelude.return ((-7))
     MsoBalloonButtonNext -> Prelude.return ((-6))
     MsoBalloonButtonBack -> Prelude.return ((-5))
     MsoBalloonButtonNo -> Prelude.return ((-4))
     MsoBalloonButtonYes -> Prelude.return ((-3))
     MsoBalloonButtonCancel -> Prelude.return ((-2))
     MsoBalloonButtonOK -> Prelude.return ((-1))
     MsoBalloonButtonNull -> Prelude.return (0)
unmarshallMsoBalloonButtonType :: Int.Int16 -> Prelude.IO MsoBalloonButtonType
unmarshallMsoBalloonButtonType v =
  case v of
     (-15) -> Prelude.return (MsoBalloonButtonYesToAll)
     (-14) -> Prelude.return (MsoBalloonButtonOptions)
     (-13) -> Prelude.return (MsoBalloonButtonTips)
     (-12) -> Prelude.return (MsoBalloonButtonClose)
     (-11) -> Prelude.return (MsoBalloonButtonSnooze)
     (-10) -> Prelude.return (MsoBalloonButtonSearch)
     (-9) -> Prelude.return (MsoBalloonButtonIgnore)
     (-8) -> Prelude.return (MsoBalloonButtonAbort)
     (-7) -> Prelude.return (MsoBalloonButtonRetry)
     (-6) -> Prelude.return (MsoBalloonButtonNext)
     (-5) -> Prelude.return (MsoBalloonButtonBack)
     (-4) -> Prelude.return (MsoBalloonButtonNo)
     (-3) -> Prelude.return (MsoBalloonButtonYes)
     (-2) -> Prelude.return (MsoBalloonButtonCancel)
     (-1) -> Prelude.return (MsoBalloonButtonOK)
     0 -> Prelude.return (MsoBalloonButtonNull)
     _ -> Prelude.fail (Prelude.userError "unmarshallMsoBalloonButtonType: illegal enum value ")
data DocProperties
 = OffPropertyTypeNumber
 | OffPropertyTypeBoolean
 | OffPropertyTypeDate
 | OffPropertyTypeString
 | OffPropertyTypeFloat
 
marshallDocProperties :: DocProperties -> Prelude.IO Int.Int16
marshallDocProperties v =
  case v of
     OffPropertyTypeNumber -> Prelude.return (1)
     OffPropertyTypeBoolean -> Prelude.return (2)
     OffPropertyTypeDate -> Prelude.return (3)
     OffPropertyTypeString -> Prelude.return (4)
     OffPropertyTypeFloat -> Prelude.return (5)
unmarshallDocProperties :: Int.Int16 -> Prelude.IO DocProperties
unmarshallDocProperties v =
  case v of
     1 -> Prelude.return (OffPropertyTypeNumber)
     2 -> Prelude.return (OffPropertyTypeBoolean)
     3 -> Prelude.return (OffPropertyTypeDate)
     4 -> Prelude.return (OffPropertyTypeString)
     5 -> Prelude.return (OffPropertyTypeFloat)
     _ -> Prelude.fail (Prelude.userError "unmarshallDocProperties: illegal enum value ")
data MsoDocProperties
 = MsoPropertyTypeNumber
 | MsoPropertyTypeBoolean
 | MsoPropertyTypeDate
 | MsoPropertyTypeString
 | MsoPropertyTypeFloat
 
marshallMsoDocProperties :: MsoDocProperties -> Prelude.IO Int.Int16
marshallMsoDocProperties v =
  case v of
     MsoPropertyTypeNumber -> Prelude.return (1)
     MsoPropertyTypeBoolean -> Prelude.return (2)
     MsoPropertyTypeDate -> Prelude.return (3)
     MsoPropertyTypeString -> Prelude.return (4)
     MsoPropertyTypeFloat -> Prelude.return (5)
unmarshallMsoDocProperties :: Int.Int16 -> Prelude.IO MsoDocProperties
unmarshallMsoDocProperties v =
  case v of
     1 -> Prelude.return (MsoPropertyTypeNumber)
     2 -> Prelude.return (MsoPropertyTypeBoolean)
     3 -> Prelude.return (MsoPropertyTypeDate)
     4 -> Prelude.return (MsoPropertyTypeString)
     5 -> Prelude.return (MsoPropertyTypeFloat)
     _ -> Prelude.fail (Prelude.userError "unmarshallMsoDocProperties: illegal enum value ")
-- --------------------------------------------------
-- 
-- interface IAccessible
-- 
-- --------------------------------------------------
data Accessible a = Accessible
                     
type IAccessible a = Automation.IDispatch (Accessible a)
iidIAccessible :: Com.IID (IAccessible Automation.Interface)
iidIAccessible = Com.mkIID "{618736E0-3C3D-11CF-810C-00AA00389B71}"
getAccParent :: Automation.IDispatch a -> Prelude.IO (Automation.IDispatch Automation.Interface)
getAccParent =
  Automation.propertyGet "accParent" [] Automation.outIDispatch
getAccChildCount :: Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getAccChildCount =
  Automation.propertyGet "accChildCount" [] Automation.outInt
getAccChild :: Prelude.Int -> Automation.IDispatch a -> Prelude.IO (Automation.IDispatch Automation.Interface)
getAccChild varChild =
  Automation.propertyGet "accChild" [Automation.inInt varChild] Automation.outIDispatch
getAccName :: Prelude.Int -> Automation.IDispatch a -> Prelude.IO (Prelude.String)
getAccName varChild =
  Automation.propertyGet "accName" [Automation.inInt varChild] Automation.outString
getAccValue :: Prelude.Int -> Automation.IDispatch a -> Prelude.IO (Prelude.String)
getAccValue varChild =
  Automation.propertyGet "accValue" [Automation.inInt varChild] Automation.outString
getAccDescription :: Prelude.Int -> Automation.IDispatch a -> Prelude.IO (Prelude.String)
getAccDescription varChild =
  Automation.propertyGet "accDescription" [Automation.inInt varChild] Automation.outString
getAccRole :: Prelude.Int -> Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getAccRole varChild =
  Automation.propertyGet "accRole" [Automation.inInt varChild] Automation.outInt
getAccState :: Prelude.Int -> Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getAccState varChild =
  Automation.propertyGet "accState" [Automation.inInt varChild] Automation.outInt
getAccHelp :: Prelude.Int -> Automation.IDispatch a -> Prelude.IO (Prelude.String)
getAccHelp varChild =
  Automation.propertyGet "accHelp" [Automation.inInt varChild] Automation.outString
getAccHelpTopic :: Prelude.Int -> Automation.IDispatch a -> Prelude.IO (Prelude.String) -- Prelude.Int)
getAccHelpTopic varChild =
  Automation.propertyGet "accHelpTopic" [Automation.inInt varChild] Automation.outString -- Automation.outInt
getAccKeyboardShortcut :: Prelude.Int -> Automation.IDispatch a -> Prelude.IO (Prelude.String)
getAccKeyboardShortcut varChild =
  Automation.propertyGet "accKeyboardShortcut" [Automation.inInt varChild] Automation.outString
getAccFocus :: Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getAccFocus =
  Automation.propertyGet "accFocus" [] Automation.outInt
getAccSelection :: Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getAccSelection =
  Automation.propertyGet "accSelection" [] Automation.outInt
getAccDefaultAction :: Prelude.Int -> Automation.IDispatch a -> Prelude.IO (Prelude.String)
getAccDefaultAction varChild =
  Automation.propertyGet "accDefaultAction" [Automation.inInt varChild] Automation.outString
accSelect :: Prelude.Int -> Prelude.Int -> Automation.IDispatch a -> Prelude.IO ()
accSelect flagsSelect varChild =
  Automation.method0 "accSelect" [Automation.inInt flagsSelect, Automation.inInt varChild]
accLocation :: Prelude.Int -> Automation.IDispatch a -> Prelude.IO (Prelude.Int, Prelude.Int, Prelude.Int, Prelude.Int)
accLocation varChild =
  Automation.method4 "accLocation" [Automation.inInt varChild] Automation.outInt Automation.outInt Automation.outInt Automation.outInt
accNavigate :: Prelude.Int -> Prelude.Int -> Automation.IDispatch a -> Prelude.IO (Prelude.Int)
accNavigate navDir varStart =
  Automation.function1 "accNavigate" [Automation.inInt navDir, Automation.inInt varStart] Automation.outInt
accHitTest :: Prelude.Int -> Prelude.Int -> Automation.IDispatch a -> Prelude.IO (Prelude.Int)
accHitTest xLeft yTop =
  Automation.function1 "accHitTest" [Automation.inInt xLeft, Automation.inInt yTop] Automation.outInt
accDoDefaultAction :: Prelude.Int -> Automation.IDispatch a -> Prelude.IO ()
accDoDefaultAction varChild =
  Automation.method0 "accDoDefaultAction" [Automation.inInt varChild]
setAccName :: Prelude.Int -> Prelude.String -> Automation.IDispatch a -> Prelude.IO ()
setAccName varChild pszName =
  Automation.propertySet "accName" [Automation.inInt varChild, Automation.inString pszName]
setAccValue :: Prelude.Int -> Prelude.String -> Automation.IDispatch a -> Prelude.IO ()
setAccValue varChild pszValue =
  Automation.propertySet "accValue" [Automation.inInt varChild, Automation.inString pszValue]
-- --------------------------------------------------
-- 
-- interface IMsoDispObj
-- 
-- --------------------------------------------------
data MsoDispObj a = MsoDispObj
                     
type IMsoDispObj a = Automation.IDispatch (MsoDispObj a)
iidIMsoDispObj :: Com.IID (IMsoDispObj Automation.Interface)
iidIMsoDispObj = Com.mkIID "{000C0300-0000-0000-C000-000000000046}"
getApplication :: Automation.IDispatch a -> Prelude.IO (Automation.IDispatch Automation.Interface)
getApplication =
  Automation.propertyGet "Application" [] Automation.outIDispatch
getCreator :: Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getCreator = Automation.propertyGet "Creator" [] Automation.outInt
-- --------------------------------------------------
-- 
-- interface IMsoOleAccDispObj
-- 
-- --------------------------------------------------
data MsoOleAccDispObj a = MsoOleAccDispObj
                           
type IMsoOleAccDispObj a = IAccessible (MsoOleAccDispObj a)
iidIMsoOleAccDispObj :: Com.IID (IMsoOleAccDispObj Automation.Interface)
iidIMsoOleAccDispObj =
  Com.mkIID "{000C0301-0000-0000-C000-000000000046}"
-- --------------------------------------------------
-- 
-- interface CommandBars
-- 
-- --------------------------------------------------
data CommandBars a = CommandBars
                      
type ICommandBars a = IMsoDispObj (CommandBars a)
iidICommandBars :: Com.IID (ICommandBars Automation.Interface)
iidICommandBars =
  Com.mkIID "{000C0302-0000-0000-C000-000000000046}"
getActionControl :: ICommandBars a -> Prelude.IO (ICommandBarControl Automation.Interface)
getActionControl =
  Automation.propertyGet "ActionControl" [] Automation.outIDispatch
getActiveMenuBar :: ICommandBars a -> Prelude.IO (ICommandBar Automation.Interface)
getActiveMenuBar =
  Automation.propertyGet "ActiveMenuBar" [] Automation.outIDispatch
add :: Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> ICommandBars a -> Prelude.IO (ICommandBar Automation.Interface)
add name position menuBar temporary =
  Automation.function1 "Add" [Automation.inInt name, Automation.inInt position, Automation.inInt menuBar, Automation.inInt temporary] Automation.outIDispatch
getCount :: Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getCount = Automation.propertyGet "Count" [] Automation.outInt
getDisplayTooltips :: ICommandBars a -> Prelude.IO (Prelude.Int)
getDisplayTooltips =
  Automation.propertyGet "DisplayTooltips" [] Automation.outInt
setDisplayTooltips :: Prelude.Int -> ICommandBars a -> Prelude.IO ()
setDisplayTooltips pvarfDisplayTooltips =
  Automation.propertySet "DisplayTooltips" [Automation.inInt pvarfDisplayTooltips]
getDisplayKeysInTooltips :: ICommandBars a -> Prelude.IO (Prelude.Int)
getDisplayKeysInTooltips =
  Automation.propertyGet "DisplayKeysInTooltips" [] Automation.outInt
setDisplayKeysInTooltips :: Prelude.Int -> ICommandBars a -> Prelude.IO ()
setDisplayKeysInTooltips pvarfDisplayKeys =
  Automation.propertySet "DisplayKeysInTooltips" [Automation.inInt pvarfDisplayKeys]
findControl :: Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> ICommandBars a -> Prelude.IO (ICommandBarControl Automation.Interface)
findControl type0 id tag visible =
  Automation.function1 "FindControl" [Automation.inInt type0, Automation.inInt id, Automation.inInt tag, Automation.inInt visible] Automation.outIDispatch
getItem :: Prelude.Int -> ICommandBars a -> Prelude.IO (ICommandBar Automation.Interface)
getItem idex =
  Automation.propertyGet "Item" [Automation.inInt idex] Automation.outIDispatch
getLargeButtons :: ICommandBars a -> Prelude.IO (Prelude.Int)
getLargeButtons =
  Automation.propertyGet "LargeButtons" [] Automation.outInt
setLargeButtons :: Prelude.Int -> ICommandBars a -> Prelude.IO ()
setLargeButtons pvarfLargeButtons =
  Automation.propertySet "LargeButtons" [Automation.inInt pvarfLargeButtons]
getMenuAnimationStyle :: (Automation.Variant a0) => ICommandBars a -> Prelude.IO (a0)
getMenuAnimationStyle =
  Automation.propertyGet "MenuAnimationStyle" [] Automation.outVariant
setMenuAnimationStyle :: (Automation.Variant a0) => a0 -> ICommandBars a -> Prelude.IO ()
setMenuAnimationStyle pma =
  Automation.propertySet "MenuAnimationStyle" [Automation.inVariant pma]
getNewEnum :: Automation.IDispatch a -> Prelude.IO (Com.IUnknown Automation.Interface)
getNewEnum =
  Automation.propertyGet "_NewEnum" [] Automation.outIUnknown
getParent :: Automation.IDispatch a -> Prelude.IO (Automation.IDispatch Automation.Interface)
getParent =
  Automation.propertyGet "Parent" [] Automation.outIDispatch
releaseFocus :: ICommandBars a -> Prelude.IO ()
releaseFocus = Automation.method0 "ReleaseFocus" []
-- --------------------------------------------------
-- 
-- interface CommandBar
-- 
-- --------------------------------------------------
data CommandBar a = CommandBar
                     
type ICommandBar a = IMsoOleAccDispObj (CommandBar a)
iidICommandBar :: Com.IID (ICommandBar Automation.Interface)
iidICommandBar = Com.mkIID "{000C0304-0000-0000-C000-000000000046}"
getBuiltIn :: Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getBuiltIn = Automation.propertyGet "BuiltIn" [] Automation.outInt
getContext :: ICommandBar a -> Prelude.IO (Prelude.String)
getContext =
  Automation.propertyGet "Context" [] Automation.outString
setContext :: Prelude.String -> ICommandBar a -> Prelude.IO ()
setContext pbstrContext =
  Automation.propertySet "Context" [Automation.inString pbstrContext]
getControls :: Automation.IDispatch a -> Prelude.IO (ICommandBarControls Automation.Interface)
getControls =
  Automation.propertyGet "Controls" [] Automation.outIDispatch
delete :: Automation.IDispatch a -> Prelude.IO ()
delete = Automation.method0 "Delete" []
getEnabled :: Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getEnabled = Automation.propertyGet "Enabled" [] Automation.outInt
setEnabled :: Prelude.Int -> Automation.IDispatch a -> Prelude.IO ()
setEnabled pvarfEnabled =
  Automation.propertySet "Enabled" [Automation.inInt pvarfEnabled]
findControl0 :: Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> ICommandBar a -> Prelude.IO (ICommandBarControl Automation.Interface)
findControl0 type0 id tag visible recursive =
  Automation.function1 "FindControl" [Automation.inInt type0, Automation.inInt id, Automation.inInt tag, Automation.inInt visible, Automation.inInt recursive] Automation.outIDispatch
getHeight :: Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getHeight = Automation.propertyGet "Height" [] Automation.outInt
setHeight :: Prelude.Int -> Automation.IDispatch a -> Prelude.IO ()
setHeight pdy =
  Automation.propertySet "Height" [Automation.inInt pdy]
getIndex :: Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getIndex = Automation.propertyGet "Index" [] Automation.outInt
getInstanceId :: Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getInstanceId =
  Automation.propertyGet "InstanceId" [] Automation.outInt
getLeft :: Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getLeft = Automation.propertyGet "Left" [] Automation.outInt
setLeft :: Prelude.Int -> Automation.IDispatch a -> Prelude.IO ()
setLeft pxpLeft =
  Automation.propertySet "Left" [Automation.inInt pxpLeft]
getName :: Automation.IDispatch a -> Prelude.IO (Prelude.String)
getName = Automation.propertyGet "Name" [] Automation.outString
setName :: Prelude.String -> Automation.IDispatch a -> Prelude.IO ()
setName pbstrName =
  Automation.propertySet "Name" [Automation.inString pbstrName]
getNameLocal :: ICommandBar a -> Prelude.IO (Prelude.String)
getNameLocal =
  Automation.propertyGet "NameLocal" [] Automation.outString
setNameLocal :: Prelude.String -> ICommandBar a -> Prelude.IO ()
setNameLocal pbstrNameLocal =
  Automation.propertySet "NameLocal" [Automation.inString pbstrNameLocal]
getPosition :: (Automation.Variant a0) => ICommandBar a -> Prelude.IO (a0)
getPosition =
  Automation.propertyGet "Position" [] Automation.outVariant
setPosition :: (Automation.Variant a0) => a0 -> ICommandBar a -> Prelude.IO ()
setPosition ppos =
  Automation.propertySet "Position" [Automation.inVariant ppos]
getRowIndex :: ICommandBar a -> Prelude.IO (Prelude.Int)
getRowIndex =
  Automation.propertyGet "RowIndex" [] Automation.outInt
setRowIndex :: Prelude.Int -> ICommandBar a -> Prelude.IO ()
setRowIndex piRow =
  Automation.propertySet "RowIndex" [Automation.inInt piRow]
getProtection :: (Automation.Variant a0) => ICommandBar a -> Prelude.IO (a0)
getProtection =
  Automation.propertyGet "Protection" [] Automation.outVariant
setProtection :: (Automation.Variant a0) => a0 -> ICommandBar a -> Prelude.IO ()
setProtection pprot =
  Automation.propertySet "Protection" [Automation.inVariant pprot]
reset :: Automation.IDispatch a -> Prelude.IO ()
reset = Automation.method0 "Reset" []
showPopup :: Prelude.Int -> Prelude.Int -> ICommandBar a -> Prelude.IO ()
showPopup x y =
  Automation.method0 "ShowPopup" [Automation.inInt x, Automation.inInt y]
getTop :: Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getTop = Automation.propertyGet "Top" [] Automation.outInt
setTop :: Prelude.Int -> Automation.IDispatch a -> Prelude.IO ()
setTop pypTop =
  Automation.propertySet "Top" [Automation.inInt pypTop]
getType :: (Automation.Variant a0) => ICommandBar a -> Prelude.IO (a0)
getType = Automation.propertyGet "Type" [] Automation.outVariant
getVisible :: Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getVisible = Automation.propertyGet "Visible" [] Automation.outInt
setVisible :: Prelude.Int -> Automation.IDispatch a -> Prelude.IO ()
setVisible pvarfVisible =
  Automation.propertySet "Visible" [Automation.inInt pvarfVisible]
getWidth :: Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getWidth = Automation.propertyGet "Width" [] Automation.outInt
setWidth :: Prelude.Int -> Automation.IDispatch a -> Prelude.IO ()
setWidth pdx =
  Automation.propertySet "Width" [Automation.inInt pdx]
-- --------------------------------------------------
-- 
-- interface CommandBarControls
-- 
-- --------------------------------------------------
data CommandBarControls a = CommandBarControls
                             
type ICommandBarControls a = IMsoDispObj (CommandBarControls a)
iidICommandBarControls :: Com.IID (ICommandBarControls Automation.Interface)
iidICommandBarControls =
  Com.mkIID "{000C0306-0000-0000-C000-000000000046}"
add0 :: Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> ICommandBarControls a -> Prelude.IO (ICommandBarControl Automation.Interface)
add0 type0 id parameter before temporary =
  Automation.function1 "Add" [Automation.inInt type0, Automation.inInt id, Automation.inInt parameter, Automation.inInt before, Automation.inInt temporary] Automation.outIDispatch
getItem0 :: Prelude.Int -> ICommandBarControls a -> Prelude.IO (ICommandBarControl Automation.Interface)
getItem0 idex =
  Automation.propertyGet "Item" [Automation.inInt idex] Automation.outIDispatch
getParent1 :: Automation.IDispatch a -> Prelude.IO (ICommandBar Automation.Interface)
getParent1 =
  Automation.propertyGet "Parent" [] Automation.outIDispatch
-- --------------------------------------------------
-- 
-- interface CommandBarControl
-- 
-- --------------------------------------------------
data CommandBarControl a = CommandBarControl
                            
type ICommandBarControl a = IMsoOleAccDispObj (CommandBarControl a)
iidICommandBarControl :: Com.IID (ICommandBarControl Automation.Interface)
iidICommandBarControl =
  Com.mkIID "{000C0308-0000-0000-C000-000000000046}"
getBeginGroup :: Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getBeginGroup =
  Automation.propertyGet "BeginGroup" [] Automation.outInt
setBeginGroup :: Prelude.Int -> Automation.IDispatch a -> Prelude.IO ()
setBeginGroup pvarfBeginGroup =
  Automation.propertySet "BeginGroup" [Automation.inInt pvarfBeginGroup]
getCaption :: Automation.IDispatch a -> Prelude.IO (Prelude.String)
getCaption =
  Automation.propertyGet "Caption" [] Automation.outString
setCaption :: Prelude.String -> Automation.IDispatch a -> Prelude.IO ()
setCaption pbstrCaption =
  Automation.propertySet "Caption" [Automation.inString pbstrCaption]
getControl :: Automation.IDispatch a -> Prelude.IO (Automation.IDispatch Automation.Interface)
getControl =
  Automation.propertyGet "Control" [] Automation.outIDispatch
copy :: Prelude.Int -> Prelude.Int -> Automation.IDispatch a -> Prelude.IO (ICommandBarControl Automation.Interface)
copy bar before =
  Automation.function1 "Copy" [Automation.inInt bar, Automation.inInt before] Automation.outIDispatch
delete0 :: Prelude.Int -> Automation.IDispatch a -> Prelude.IO ()
delete0 temporary =
  Automation.method0 "Delete" [Automation.inInt temporary]
getDescriptionText :: Automation.IDispatch a -> Prelude.IO (Prelude.String)
getDescriptionText =
  Automation.propertyGet "DescriptionText" [] Automation.outString
setDescriptionText :: Prelude.String -> Automation.IDispatch a -> Prelude.IO ()
setDescriptionText pbstrText =
  Automation.propertySet "DescriptionText" [Automation.inString pbstrText]
execute :: Automation.IDispatch a -> Prelude.IO ()
execute = Automation.method0 "Execute" []
getHelpContextId :: Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getHelpContextId =
  Automation.propertyGet "HelpContextId" [] Automation.outInt
setHelpContextId :: Prelude.Int -> Automation.IDispatch a -> Prelude.IO ()
setHelpContextId pid =
  Automation.propertySet "HelpContextId" [Automation.inInt pid]
getHelpFile :: Automation.IDispatch a -> Prelude.IO (Prelude.String)
getHelpFile =
  Automation.propertyGet "HelpFile" [] Automation.outString
setHelpFile :: Prelude.String -> Automation.IDispatch a -> Prelude.IO ()
setHelpFile pbstrFilename =
  Automation.propertySet "HelpFile" [Automation.inString pbstrFilename]
getId :: Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getId = Automation.propertyGet "Id" [] Automation.outInt
move :: Prelude.Int -> Prelude.Int -> Automation.IDispatch a -> Prelude.IO (ICommandBarControl Automation.Interface)
move bar before =
  Automation.function1 "Move" [Automation.inInt bar, Automation.inInt before] Automation.outIDispatch
getOLEUsage :: (Automation.Variant a0) => Automation.IDispatch a -> Prelude.IO (a0)
getOLEUsage =
  Automation.propertyGet "OLEUsage" [] Automation.outVariant
setOLEUsage :: (Automation.Variant a0) => a0 -> Automation.IDispatch a -> Prelude.IO ()
setOLEUsage pcou =
  Automation.propertySet "OLEUsage" [Automation.inVariant pcou]
getOnAction :: Automation.IDispatch a -> Prelude.IO (Prelude.String)
getOnAction =
  Automation.propertyGet "OnAction" [] Automation.outString
setOnAction :: Prelude.String -> Automation.IDispatch a -> Prelude.IO ()
setOnAction pbstrOnAction =
  Automation.propertySet "OnAction" [Automation.inString pbstrOnAction]
getParameter :: Automation.IDispatch a -> Prelude.IO (Prelude.String)
getParameter =
  Automation.propertyGet "Parameter" [] Automation.outString
setParameter :: Prelude.String -> Automation.IDispatch a -> Prelude.IO ()
setParameter pbstrParam =
  Automation.propertySet "Parameter" [Automation.inString pbstrParam]
getPriority :: Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getPriority =
  Automation.propertyGet "Priority" [] Automation.outInt
setPriority :: Prelude.Int -> Automation.IDispatch a -> Prelude.IO ()
setPriority pnPri =
  Automation.propertySet "Priority" [Automation.inInt pnPri]
setFocus :: Automation.IDispatch a -> Prelude.IO ()
setFocus = Automation.method0 "SetFocus" []
getTag :: Automation.IDispatch a -> Prelude.IO (Prelude.String)
getTag = Automation.propertyGet "Tag" [] Automation.outString
setTag :: Prelude.String -> Automation.IDispatch a -> Prelude.IO ()
setTag pbstrTag =
  Automation.propertySet "Tag" [Automation.inString pbstrTag]
getTooltipText :: Automation.IDispatch a -> Prelude.IO (Prelude.String)
getTooltipText =
  Automation.propertyGet "TooltipText" [] Automation.outString
setTooltipText :: Prelude.String -> Automation.IDispatch a -> Prelude.IO ()
setTooltipText pbstrTooltip =
  Automation.propertySet "TooltipText" [Automation.inString pbstrTooltip]
getType0 :: (Automation.Variant a0) => Automation.IDispatch a -> Prelude.IO (a0)
getType0 = Automation.propertyGet "Type" [] Automation.outVariant
reserved1 :: Automation.IDispatch a -> Prelude.IO ()
reserved1 = Automation.method0 "Reserved1" []
reserved2 :: Automation.IDispatch a -> Prelude.IO ()
reserved2 = Automation.method0 "Reserved2" []
reserved3 :: Automation.IDispatch a -> Prelude.IO ()
reserved3 = Automation.method0 "Reserved3" []
reserved4 :: Automation.IDispatch a -> Prelude.IO ()
reserved4 = Automation.method0 "Reserved4" []
reserved5 :: Automation.IDispatch a -> Prelude.IO ()
reserved5 = Automation.method0 "Reserved5" []
reserved6 :: Automation.IDispatch a -> Prelude.IO ()
reserved6 = Automation.method0 "Reserved6" []
reserved7 :: Automation.IDispatch a -> Prelude.IO ()
reserved7 = Automation.method0 "Reserved7" []
reserved8 :: Automation.IDispatch a -> Prelude.IO ()
reserved8 = Automation.method0 "Reserved8" []
-- --------------------------------------------------
-- 
-- interface CommandBarButton
-- 
-- --------------------------------------------------
data CommandBarButton a = CommandBarButton
                           
type ICommandBarButton a = ICommandBarControl (CommandBarButton a)
iidICommandBarButton :: Com.IID (ICommandBarButton Automation.Interface)
iidICommandBarButton =
  Com.mkIID "{000C030E-0000-0000-C000-000000000046}"
getBuiltInFace :: ICommandBarButton a -> Prelude.IO (Prelude.Int)
getBuiltInFace =
  Automation.propertyGet "BuiltInFace" [] Automation.outInt
setBuiltInFace :: Prelude.Int -> ICommandBarButton a -> Prelude.IO ()
setBuiltInFace pvarfBuiltIn =
  Automation.propertySet "BuiltInFace" [Automation.inInt pvarfBuiltIn]
copyFace :: ICommandBarButton a -> Prelude.IO ()
copyFace = Automation.method0 "CopyFace" []
getFaceId :: ICommandBarButton a -> Prelude.IO (Prelude.Int)
getFaceId = Automation.propertyGet "FaceId" [] Automation.outInt
setFaceId :: Prelude.Int -> ICommandBarButton a -> Prelude.IO ()
setFaceId pid =
  Automation.propertySet "FaceId" [Automation.inInt pid]
pasteFace :: ICommandBarButton a -> Prelude.IO ()
pasteFace = Automation.method0 "PasteFace" []
getShortcutText :: ICommandBarButton a -> Prelude.IO (Prelude.String)
getShortcutText =
  Automation.propertyGet "ShortcutText" [] Automation.outString
setShortcutText :: Prelude.String -> ICommandBarButton a -> Prelude.IO ()
setShortcutText pbstrText =
  Automation.propertySet "ShortcutText" [Automation.inString pbstrText]
getState :: (Automation.Variant a0) => ICommandBarButton a -> Prelude.IO (a0)
getState = Automation.propertyGet "State" [] Automation.outVariant
setState :: (Automation.Variant a0) => a0 -> ICommandBarButton a -> Prelude.IO ()
setState pstate =
  Automation.propertySet "State" [Automation.inVariant pstate]
getStyle :: (Automation.Variant a0) => ICommandBarButton a -> Prelude.IO (a0)
getStyle = Automation.propertyGet "Style" [] Automation.outVariant
setStyle :: (Automation.Variant a0) => a0 -> ICommandBarButton a -> Prelude.IO ()
setStyle pstyle =
  Automation.propertySet "Style" [Automation.inVariant pstyle]
-- --------------------------------------------------
-- 
-- interface CommandBarPopup
-- 
-- --------------------------------------------------
data CommandBarPopup a = CommandBarPopup
                          
type ICommandBarPopup a = ICommandBarControl (CommandBarPopup a)
iidICommandBarPopup :: Com.IID (ICommandBarPopup Automation.Interface)
iidICommandBarPopup =
  Com.mkIID "{000C030A-0000-0000-C000-000000000046}"
getCommandBar :: ICommandBarPopup a -> Prelude.IO (ICommandBar Automation.Interface)
getCommandBar =
  Automation.propertyGet "CommandBar" [] Automation.outIDispatch
getOLEMenuGroup :: (Automation.Variant a0) => ICommandBarPopup a -> Prelude.IO (a0)
getOLEMenuGroup =
  Automation.propertyGet "OLEMenuGroup" [] Automation.outVariant
setOLEMenuGroup :: (Automation.Variant a0) => a0 -> ICommandBarPopup a -> Prelude.IO ()
setOLEMenuGroup pomg =
  Automation.propertySet "OLEMenuGroup" [Automation.inVariant pomg]
-- --------------------------------------------------
-- 
-- interface CommandBarComboBox
-- 
-- --------------------------------------------------
data CommandBarComboBox a = CommandBarComboBox
                             
type ICommandBarComboBox a = ICommandBarControl (CommandBarComboBox a)
iidICommandBarComboBox :: Com.IID (ICommandBarComboBox Automation.Interface)
iidICommandBarComboBox =
  Com.mkIID "{000C030C-0000-0000-C000-000000000046}"
addItem :: Prelude.String -> Prelude.Int -> ICommandBarComboBox a -> Prelude.IO ()
addItem text idex =
  Automation.method0 "AddItem" [Automation.inString text, Automation.inInt idex]
clear :: ICommandBarComboBox a -> Prelude.IO ()
clear = Automation.method0 "Clear" []
getDropDownLines :: ICommandBarComboBox a -> Prelude.IO (Prelude.Int)
getDropDownLines =
  Automation.propertyGet "DropDownLines" [] Automation.outInt
setDropDownLines :: Prelude.Int -> ICommandBarComboBox a -> Prelude.IO ()
setDropDownLines pcLines =
  Automation.propertySet "DropDownLines" [Automation.inInt pcLines]
getDropDownWidth :: ICommandBarComboBox a -> Prelude.IO (Prelude.Int)
getDropDownWidth =
  Automation.propertyGet "DropDownWidth" [] Automation.outInt
setDropDownWidth :: Prelude.Int -> ICommandBarComboBox a -> Prelude.IO ()
setDropDownWidth pdx =
  Automation.propertySet "DropDownWidth" [Automation.inInt pdx]
getList :: Prelude.Int -> ICommandBarComboBox a -> Prelude.IO (Prelude.String)
getList idex =
  Automation.propertyGet "List" [Automation.inInt idex] Automation.outString
setList :: Prelude.Int -> Prelude.String -> ICommandBarComboBox a -> Prelude.IO ()
setList idex pbstrItem =
  Automation.propertySet "List" [Automation.inInt idex, Automation.inString pbstrItem]
getListCount :: ICommandBarComboBox a -> Prelude.IO (Prelude.Int)
getListCount =
  Automation.propertyGet "ListCount" [] Automation.outInt
getListHeaderCount :: ICommandBarComboBox a -> Prelude.IO (Prelude.Int)
getListHeaderCount =
  Automation.propertyGet "ListHeaderCount" [] Automation.outInt
setListHeaderCount :: Prelude.Int -> ICommandBarComboBox a -> Prelude.IO ()
setListHeaderCount pcItems =
  Automation.propertySet "ListHeaderCount" [Automation.inInt pcItems]
getListIndex :: ICommandBarComboBox a -> Prelude.IO (Prelude.Int)
getListIndex =
  Automation.propertyGet "ListIndex" [] Automation.outInt
setListIndex :: Prelude.Int -> ICommandBarComboBox a -> Prelude.IO ()
setListIndex pi =
  Automation.propertySet "ListIndex" [Automation.inInt pi]
removeItem :: Prelude.Int -> ICommandBarComboBox a -> Prelude.IO ()
removeItem idex =
  Automation.method0 "RemoveItem" [Automation.inInt idex]
getStyle0 :: (Automation.Variant a0) => ICommandBarComboBox a -> Prelude.IO (a0)
getStyle0 = Automation.propertyGet "Style" [] Automation.outVariant
setStyle0 :: (Automation.Variant a0) => a0 -> ICommandBarComboBox a -> Prelude.IO ()
setStyle0 pstyle =
  Automation.propertySet "Style" [Automation.inVariant pstyle]
getText :: Automation.IDispatch a -> Prelude.IO (Prelude.String)
getText = Automation.propertyGet "Text" [] Automation.outString
setText :: Prelude.String -> Automation.IDispatch a -> Prelude.IO ()
setText pbstrText =
  Automation.propertySet "Text" [Automation.inString pbstrText]
-- --------------------------------------------------
-- 
-- interface Adjustments
-- 
-- --------------------------------------------------
data Adjustments a = Adjustments
                      
type IAdjustments a = IMsoDispObj (Adjustments a)
iidIAdjustments :: Com.IID (IAdjustments Automation.Interface)
iidIAdjustments =
  Com.mkIID "{000C0310-0000-0000-C000-000000000046}"
getItem1 :: Prelude.Int -> IAdjustments a -> Prelude.IO (Prelude.Float)
getItem1 idex =
  Automation.propertyGet "Item" [Automation.inInt idex] Automation.outFloat
setItem :: Prelude.Int -> Prelude.Float -> IAdjustments a -> Prelude.IO ()
setItem idex val =
  Automation.propertySet "Item" [Automation.inInt idex, Automation.inFloat val]
-- --------------------------------------------------
-- 
-- interface CalloutFormat
-- 
-- --------------------------------------------------
data CalloutFormat a = CalloutFormat
                        
type ICalloutFormat a = IMsoDispObj (CalloutFormat a)
iidICalloutFormat :: Com.IID (ICalloutFormat Automation.Interface)
iidICalloutFormat =
  Com.mkIID "{000C0311-0000-0000-C000-000000000046}"
automaticLength :: ICalloutFormat a -> Prelude.IO ()
automaticLength = Automation.method0 "AutomaticLength" []
customDrop :: Prelude.Float -> ICalloutFormat a -> Prelude.IO ()
customDrop drop =
  Automation.method0 "CustomDrop" [Automation.inFloat drop]
customLength :: Prelude.Float -> ICalloutFormat a -> Prelude.IO ()
customLength length =
  Automation.method0 "CustomLength" [Automation.inFloat length]
presetDrop :: (Automation.Variant a0) => a0 -> ICalloutFormat a -> Prelude.IO ()
presetDrop dropType =
  Automation.method0 "PresetDrop" [Automation.inVariant dropType]
getAccent :: (Automation.Variant a0) => ICalloutFormat a -> Prelude.IO (a0)
getAccent =
  Automation.propertyGet "Accent" [] Automation.outVariant
setAccent :: (Automation.Variant a0) => a0 -> ICalloutFormat a -> Prelude.IO ()
setAccent accent =
  Automation.propertySet "Accent" [Automation.inVariant accent]
getAngle :: (Automation.Variant a0) => ICalloutFormat a -> Prelude.IO (a0)
getAngle = Automation.propertyGet "Angle" [] Automation.outVariant
setAngle :: (Automation.Variant a0) => a0 -> ICalloutFormat a -> Prelude.IO ()
setAngle angle =
  Automation.propertySet "Angle" [Automation.inVariant angle]
getAutoAttach :: (Automation.Variant a0) => ICalloutFormat a -> Prelude.IO (a0)
getAutoAttach =
  Automation.propertyGet "AutoAttach" [] Automation.outVariant
setAutoAttach :: (Automation.Variant a0) => a0 -> ICalloutFormat a -> Prelude.IO ()
setAutoAttach autoAttach =
  Automation.propertySet "AutoAttach" [Automation.inVariant autoAttach]
getAutoLength :: (Automation.Variant a0) => ICalloutFormat a -> Prelude.IO (a0)
getAutoLength =
  Automation.propertyGet "AutoLength" [] Automation.outVariant
getBorder :: (Automation.Variant a0) => ICalloutFormat a -> Prelude.IO (a0)
getBorder =
  Automation.propertyGet "Border" [] Automation.outVariant
setBorder :: (Automation.Variant a0) => a0 -> ICalloutFormat a -> Prelude.IO ()
setBorder border =
  Automation.propertySet "Border" [Automation.inVariant border]
getDrop :: ICalloutFormat a -> Prelude.IO (Prelude.Float)
getDrop = Automation.propertyGet "Drop" [] Automation.outFloat
getDropType :: (Automation.Variant a0) => ICalloutFormat a -> Prelude.IO (a0)
getDropType =
  Automation.propertyGet "DropType" [] Automation.outVariant
getGap :: ICalloutFormat a -> Prelude.IO (Prelude.Float)
getGap = Automation.propertyGet "Gap" [] Automation.outFloat
setGap :: Prelude.Float -> ICalloutFormat a -> Prelude.IO ()
setGap gap = Automation.propertySet "Gap" [Automation.inFloat gap]
getLength :: ICalloutFormat a -> Prelude.IO (Prelude.Float)
getLength = Automation.propertyGet "Length" [] Automation.outFloat
getType4 :: (Automation.Variant a0) => ICalloutFormat a -> Prelude.IO (a0)
getType4 = Automation.propertyGet "Type" [] Automation.outVariant
setType :: (Automation.Variant a0) => a0 -> ICalloutFormat a -> Prelude.IO ()
setType type0 =
  Automation.propertySet "Type" [Automation.inVariant type0]
-- --------------------------------------------------
-- 
-- interface ColorFormat
-- 
-- --------------------------------------------------
data ColorFormat a = ColorFormat
                      
type IColorFormat a = IMsoDispObj (ColorFormat a)
iidIColorFormat :: Com.IID (IColorFormat Automation.Interface)
iidIColorFormat =
  Com.mkIID "{000C0312-0000-0000-C000-000000000046}"
getRGB :: IColorFormat a -> Prelude.IO (Prelude.Int)
getRGB = Automation.propertyGet "RGB" [] Automation.outInt
setRGB :: Prelude.Int -> IColorFormat a -> Prelude.IO ()
setRGB rGB = Automation.propertySet "RGB" [Automation.inInt rGB]
getSchemeColor :: IColorFormat a -> Prelude.IO (Prelude.Int)
getSchemeColor =
  Automation.propertyGet "SchemeColor" [] Automation.outInt
setSchemeColor :: Prelude.Int -> IColorFormat a -> Prelude.IO ()
setSchemeColor schemeColor =
  Automation.propertySet "SchemeColor" [Automation.inInt schemeColor]
getType5 :: (Automation.Variant a0) => IColorFormat a -> Prelude.IO (a0)
getType5 = Automation.propertyGet "Type" [] Automation.outVariant
-- --------------------------------------------------
-- 
-- interface ConnectorFormat
-- 
-- --------------------------------------------------
data ConnectorFormat a = ConnectorFormat
                          
type IConnectorFormat a = IMsoDispObj (ConnectorFormat a)
iidIConnectorFormat :: Com.IID (IConnectorFormat Automation.Interface)
iidIConnectorFormat =
  Com.mkIID "{000C0313-0000-0000-C000-000000000046}"
beginConnect :: IShape a0 -> Prelude.Int -> IConnectorFormat a -> Prelude.IO ()
beginConnect connectedShape connectionSite =
  Automation.method0 "BeginConnect" [Automation.inIDispatch connectedShape, Automation.inInt connectionSite]
beginDisconnect :: IConnectorFormat a -> Prelude.IO ()
beginDisconnect = Automation.method0 "BeginDisconnect" []
endConnect :: IShape a0 -> Prelude.Int -> IConnectorFormat a -> Prelude.IO ()
endConnect connectedShape connectionSite =
  Automation.method0 "EndConnect" [Automation.inIDispatch connectedShape, Automation.inInt connectionSite]
endDisconnect :: IConnectorFormat a -> Prelude.IO ()
endDisconnect = Automation.method0 "EndDisconnect" []
getBeginConnected :: (Automation.Variant a0) => IConnectorFormat a -> Prelude.IO (a0)
getBeginConnected =
  Automation.propertyGet "BeginConnected" [] Automation.outVariant
getBeginConnectedShape :: IConnectorFormat a -> Prelude.IO (IShape Automation.Interface)
getBeginConnectedShape =
  Automation.propertyGet "BeginConnectedShape" [] Automation.outIDispatch
getBeginConnectionSite :: IConnectorFormat a -> Prelude.IO (Prelude.Int)
getBeginConnectionSite =
  Automation.propertyGet "BeginConnectionSite" [] Automation.outInt
getEndConnected :: (Automation.Variant a0) => IConnectorFormat a -> Prelude.IO (a0)
getEndConnected =
  Automation.propertyGet "EndConnected" [] Automation.outVariant
getEndConnectedShape :: IConnectorFormat a -> Prelude.IO (IShape Automation.Interface)
getEndConnectedShape =
  Automation.propertyGet "EndConnectedShape" [] Automation.outIDispatch
getEndConnectionSite :: IConnectorFormat a -> Prelude.IO (Prelude.Int)
getEndConnectionSite =
  Automation.propertyGet "EndConnectionSite" [] Automation.outInt
getType6 :: (Automation.Variant a0) => IConnectorFormat a -> Prelude.IO (a0)
getType6 = Automation.propertyGet "Type" [] Automation.outVariant
setType0 :: (Automation.Variant a0) => a0 -> IConnectorFormat a -> Prelude.IO ()
setType0 type0 =
  Automation.propertySet "Type" [Automation.inVariant type0]
-- --------------------------------------------------
-- 
-- interface FillFormat
-- 
-- --------------------------------------------------
data FillFormat a = FillFormat
                     
type IFillFormat a = IMsoDispObj (FillFormat a)
iidIFillFormat :: Com.IID (IFillFormat Automation.Interface)
iidIFillFormat = Com.mkIID "{000C0314-0000-0000-C000-000000000046}"
background :: IFillFormat a -> Prelude.IO ()
background = Automation.method0 "Background" []
oneColorGradient :: (Automation.Variant a0) => a0 -> Prelude.Int -> Prelude.Float -> IFillFormat a -> Prelude.IO ()
oneColorGradient style variant degree =
  Automation.method0 "OneColorGradient" [Automation.inVariant style, Automation.inInt variant, Automation.inFloat degree]
patterned :: (Automation.Variant a0) => a0 -> IFillFormat a -> Prelude.IO ()
patterned pattern =
  Automation.method0 "Patterned" [Automation.inVariant pattern]
presetGradient :: (Automation.Variant a0, Automation.Variant a1) => a0 -> Prelude.Int -> a1 -> IFillFormat a -> Prelude.IO ()
presetGradient style variant presetGradientType =
  Automation.method0 "PresetGradient" [Automation.inVariant style, Automation.inInt variant, Automation.inVariant presetGradientType]
presetTextured :: (Automation.Variant a0) => a0 -> IFillFormat a -> Prelude.IO ()
presetTextured presetTexture =
  Automation.method0 "PresetTextured" [Automation.inVariant presetTexture]
solid :: IFillFormat a -> Prelude.IO ()
solid = Automation.method0 "Solid" []
twoColorGradient :: (Automation.Variant a0) => a0 -> Prelude.Int -> IFillFormat a -> Prelude.IO ()
twoColorGradient style variant =
  Automation.method0 "TwoColorGradient" [Automation.inVariant style, Automation.inInt variant]
userPicture :: Prelude.String -> IFillFormat a -> Prelude.IO ()
userPicture pictureFile =
  Automation.method0 "UserPicture" [Automation.inString pictureFile]
userTextured :: Prelude.String -> IFillFormat a -> Prelude.IO ()
userTextured textureFile =
  Automation.method0 "UserTextured" [Automation.inString textureFile]
getBackColor :: Automation.IDispatch a -> Prelude.IO (IColorFormat Automation.Interface)
getBackColor =
  Automation.propertyGet "BackColor" [] Automation.outIDispatch
setBackColor :: IColorFormat a0 -> Automation.IDispatch a -> Prelude.IO ()
setBackColor backColor =
  Automation.propertySet "BackColor" [Automation.inIDispatch backColor]
getForeColor :: Automation.IDispatch a -> Prelude.IO (IColorFormat Automation.Interface)
getForeColor =
  Automation.propertyGet "ForeColor" [] Automation.outIDispatch
setForeColor :: IColorFormat a0 -> Automation.IDispatch a -> Prelude.IO ()
setForeColor foreColor =
  Automation.propertySet "ForeColor" [Automation.inIDispatch foreColor]
getGradientColorType :: (Automation.Variant a0) => IFillFormat a -> Prelude.IO (a0)
getGradientColorType =
  Automation.propertyGet "GradientColorType" [] Automation.outVariant
getGradientDegree :: IFillFormat a -> Prelude.IO (Prelude.Float)
getGradientDegree =
  Automation.propertyGet "GradientDegree" [] Automation.outFloat
getGradientStyle :: (Automation.Variant a0) => IFillFormat a -> Prelude.IO (a0)
getGradientStyle =
  Automation.propertyGet "GradientStyle" [] Automation.outVariant
getGradientVariant :: IFillFormat a -> Prelude.IO (Prelude.Int)
getGradientVariant =
  Automation.propertyGet "GradientVariant" [] Automation.outInt
getPattern :: (Automation.Variant a0) => Automation.IDispatch a -> Prelude.IO (a0)
getPattern =
  Automation.propertyGet "Pattern" [] Automation.outVariant
getPresetGradientType :: (Automation.Variant a0) => IFillFormat a -> Prelude.IO (a0)
getPresetGradientType =
  Automation.propertyGet "PresetGradientType" [] Automation.outVariant
getPresetTexture :: (Automation.Variant a0) => IFillFormat a -> Prelude.IO (a0)
getPresetTexture =
  Automation.propertyGet "PresetTexture" [] Automation.outVariant
getTextureName :: IFillFormat a -> Prelude.IO (Prelude.String)
getTextureName =
  Automation.propertyGet "TextureName" [] Automation.outString
getTextureType :: (Automation.Variant a0) => IFillFormat a -> Prelude.IO (a0)
getTextureType =
  Automation.propertyGet "TextureType" [] Automation.outVariant
getTransparency :: Automation.IDispatch a -> Prelude.IO (Prelude.Float)
getTransparency =
  Automation.propertyGet "Transparency" [] Automation.outFloat
setTransparency :: Prelude.Float -> Automation.IDispatch a -> Prelude.IO ()
setTransparency transparency =
  Automation.propertySet "Transparency" [Automation.inFloat transparency]
getType7 :: (Automation.Variant a0) => IFillFormat a -> Prelude.IO (a0)
getType7 = Automation.propertyGet "Type" [] Automation.outVariant
getVisible4 :: (Automation.Variant a0) => Automation.IDispatch a -> Prelude.IO (a0)
getVisible4 =
  Automation.propertyGet "Visible" [] Automation.outVariant
setVisible4 :: (Automation.Variant a0) => a0 -> Automation.IDispatch a -> Prelude.IO ()
setVisible4 visible =
  Automation.propertySet "Visible" [Automation.inVariant visible]
-- --------------------------------------------------
-- 
-- interface FreeformBuilder
-- 
-- --------------------------------------------------
data FreeformBuilder a = FreeformBuilder
                          
type IFreeformBuilder a = IMsoDispObj (FreeformBuilder a)
iidIFreeformBuilder :: Com.IID (IFreeformBuilder Automation.Interface)
iidIFreeformBuilder =
  Com.mkIID "{000C0315-0000-0000-C000-000000000046}"
addNodes :: (Automation.Variant a0, Automation.Variant a1) => a0 -> a1 -> Prelude.Float -> Prelude.Float -> Prelude.Float -> Prelude.Float -> Prelude.Float -> Prelude.Float -> IFreeformBuilder a -> Prelude.IO ()
addNodes segmentType editingType x1 y1 x2 y2 x3 y3 =
  Automation.method0 "AddNodes" [Automation.inVariant segmentType, Automation.inVariant editingType, Automation.inFloat x1, Automation.inFloat y1, Automation.inFloat x2, Automation.inFloat y2, Automation.inFloat x3, Automation.inFloat y3]
convertToShape :: IFreeformBuilder a -> Prelude.IO (IShape Automation.Interface)
convertToShape =
  Automation.function1 "ConvertToShape" [] Automation.outIDispatch
-- --------------------------------------------------
-- 
-- interface GroupShapes
-- 
-- --------------------------------------------------
data GroupShapes a = GroupShapes
                      
type IGroupShapes a = IMsoDispObj (GroupShapes a)
iidIGroupShapes :: Com.IID (IGroupShapes Automation.Interface)
iidIGroupShapes =
  Com.mkIID "{000C0316-0000-0000-C000-000000000046}"
item :: Prelude.Int -> Automation.IDispatch a -> Prelude.IO (IShape Automation.Interface)
item idex =
  Automation.function1 "Item" [Automation.inInt idex] Automation.outIDispatch
-- --------------------------------------------------
-- 
-- interface LineFormat
-- 
-- --------------------------------------------------
data LineFormat a = LineFormat
                     
type ILineFormat a = IMsoDispObj (LineFormat a)
iidILineFormat :: Com.IID (ILineFormat Automation.Interface)
iidILineFormat = Com.mkIID "{000C0317-0000-0000-C000-000000000046}"
getBeginArrowheadLength :: (Automation.Variant a0) => ILineFormat a -> Prelude.IO (a0)
getBeginArrowheadLength =
  Automation.propertyGet "BeginArrowheadLength" [] Automation.outVariant
setBeginArrowheadLength :: (Automation.Variant a0) => a0 -> ILineFormat a -> Prelude.IO ()
setBeginArrowheadLength beginArrowheadLength =
  Automation.propertySet "BeginArrowheadLength" [Automation.inVariant beginArrowheadLength]
getBeginArrowheadStyle :: (Automation.Variant a0) => ILineFormat a -> Prelude.IO (a0)
getBeginArrowheadStyle =
  Automation.propertyGet "BeginArrowheadStyle" [] Automation.outVariant
setBeginArrowheadStyle :: (Automation.Variant a0) => a0 -> ILineFormat a -> Prelude.IO ()
setBeginArrowheadStyle beginArrowheadStyle =
  Automation.propertySet "BeginArrowheadStyle" [Automation.inVariant beginArrowheadStyle]
getBeginArrowheadWidth :: (Automation.Variant a0) => ILineFormat a -> Prelude.IO (a0)
getBeginArrowheadWidth =
  Automation.propertyGet "BeginArrowheadWidth" [] Automation.outVariant
setBeginArrowheadWidth :: (Automation.Variant a0) => a0 -> ILineFormat a -> Prelude.IO ()
setBeginArrowheadWidth beginArrowheadWidth =
  Automation.propertySet "BeginArrowheadWidth" [Automation.inVariant beginArrowheadWidth]
getDashStyle :: (Automation.Variant a0) => ILineFormat a -> Prelude.IO (a0)
getDashStyle =
  Automation.propertyGet "DashStyle" [] Automation.outVariant
setDashStyle :: (Automation.Variant a0) => a0 -> ILineFormat a -> Prelude.IO ()
setDashStyle dashStyle =
  Automation.propertySet "DashStyle" [Automation.inVariant dashStyle]
getEndArrowheadLength :: (Automation.Variant a0) => ILineFormat a -> Prelude.IO (a0)
getEndArrowheadLength =
  Automation.propertyGet "EndArrowheadLength" [] Automation.outVariant
setEndArrowheadLength :: (Automation.Variant a0) => a0 -> ILineFormat a -> Prelude.IO ()
setEndArrowheadLength endArrowheadLength =
  Automation.propertySet "EndArrowheadLength" [Automation.inVariant endArrowheadLength]
getEndArrowheadStyle :: (Automation.Variant a0) => ILineFormat a -> Prelude.IO (a0)
getEndArrowheadStyle =
  Automation.propertyGet "EndArrowheadStyle" [] Automation.outVariant
setEndArrowheadStyle :: (Automation.Variant a0) => a0 -> ILineFormat a -> Prelude.IO ()
setEndArrowheadStyle endArrowheadStyle =
  Automation.propertySet "EndArrowheadStyle" [Automation.inVariant endArrowheadStyle]
getEndArrowheadWidth :: (Automation.Variant a0) => ILineFormat a -> Prelude.IO (a0)
getEndArrowheadWidth =
  Automation.propertyGet "EndArrowheadWidth" [] Automation.outVariant
setEndArrowheadWidth :: (Automation.Variant a0) => a0 -> ILineFormat a -> Prelude.IO ()
setEndArrowheadWidth endArrowheadWidth =
  Automation.propertySet "EndArrowheadWidth" [Automation.inVariant endArrowheadWidth]
setPattern :: (Automation.Variant a0) => a0 -> ILineFormat a -> Prelude.IO ()
setPattern pattern =
  Automation.propertySet "Pattern" [Automation.inVariant pattern]
getStyle1 :: (Automation.Variant a0) => ILineFormat a -> Prelude.IO (a0)
getStyle1 = Automation.propertyGet "Style" [] Automation.outVariant
setStyle1 :: (Automation.Variant a0) => a0 -> ILineFormat a -> Prelude.IO ()
setStyle1 style =
  Automation.propertySet "Style" [Automation.inVariant style]
getWeight :: ILineFormat a -> Prelude.IO (Prelude.Float)
getWeight = Automation.propertyGet "Weight" [] Automation.outFloat
setWeight :: Prelude.Float -> ILineFormat a -> Prelude.IO ()
setWeight weight =
  Automation.propertySet "Weight" [Automation.inFloat weight]
-- --------------------------------------------------
-- 
-- interface ShapeNode
-- 
-- --------------------------------------------------
data ShapeNode a = ShapeNode
                    
type IShapeNode a = IMsoDispObj (ShapeNode a)
iidIShapeNode :: Com.IID (IShapeNode Automation.Interface)
iidIShapeNode = Com.mkIID "{000C0318-0000-0000-C000-000000000046}"
getEditingType :: (Automation.Variant a0) => IShapeNode a -> Prelude.IO (a0)
getEditingType =
  Automation.propertyGet "EditingType" [] Automation.outVariant
getPoints :: IShapeNode a -> Prelude.IO (Prelude.Int)
getPoints = Automation.propertyGet "Points" [] Automation.outInt
getSegmentType :: (Automation.Variant a0) => IShapeNode a -> Prelude.IO (a0)
getSegmentType =
  Automation.propertyGet "SegmentType" [] Automation.outVariant
-- --------------------------------------------------
-- 
-- interface ShapeNodes
-- 
-- --------------------------------------------------
data ShapeNodes a = ShapeNodes
                     
type IShapeNodes a = IMsoDispObj (ShapeNodes a)
iidIShapeNodes :: Com.IID (IShapeNodes Automation.Interface)
iidIShapeNodes = Com.mkIID "{000C0319-0000-0000-C000-000000000046}"
item0 :: Prelude.Int -> IShapeNodes a -> Prelude.IO (IShapeNode Automation.Interface)
item0 idex =
  Automation.function1 "Item" [Automation.inInt idex] Automation.outIDispatch
insert :: (Automation.Variant a0, Automation.Variant a1) => Prelude.Int -> a0 -> a1 -> Prelude.Float -> Prelude.Float -> Prelude.Float -> Prelude.Float -> Prelude.Float -> Prelude.Float -> IShapeNodes a -> Prelude.IO ()
insert idex segmentType editingType x1 y1 x2 y2 x3 y3 =
  Automation.method0 "Insert" [Automation.inInt idex, Automation.inVariant segmentType, Automation.inVariant editingType, Automation.inFloat x1, Automation.inFloat y1, Automation.inFloat x2, Automation.inFloat y2, Automation.inFloat x3, Automation.inFloat y3]
setEditingType :: (Automation.Variant a0) => Prelude.Int -> a0 -> IShapeNodes a -> Prelude.IO ()
setEditingType idex editingType =
  Automation.method0 "SetEditingType" [Automation.inInt idex, Automation.inVariant editingType]
setPosition0 :: Prelude.Int -> Prelude.Float -> Prelude.Float -> IShapeNodes a -> Prelude.IO ()
setPosition0 idex x1 y1 =
  Automation.method0 "SetPosition" [Automation.inInt idex, Automation.inFloat x1, Automation.inFloat y1]
setSegmentType :: (Automation.Variant a0) => Prelude.Int -> a0 -> IShapeNodes a -> Prelude.IO ()
setSegmentType idex segmentType =
  Automation.method0 "SetSegmentType" [Automation.inInt idex, Automation.inVariant segmentType]
-- --------------------------------------------------
-- 
-- interface PictureFormat
-- 
-- --------------------------------------------------
data PictureFormat a = PictureFormat
                        
type IPictureFormat a = IMsoDispObj (PictureFormat a)
iidIPictureFormat :: Com.IID (IPictureFormat Automation.Interface)
iidIPictureFormat =
  Com.mkIID "{000C031A-0000-0000-C000-000000000046}"
incrementBrightness :: Prelude.Float -> IPictureFormat a -> Prelude.IO ()
incrementBrightness increment =
  Automation.method0 "IncrementBrightness" [Automation.inFloat increment]
incrementContrast :: Prelude.Float -> IPictureFormat a -> Prelude.IO ()
incrementContrast increment =
  Automation.method0 "IncrementContrast" [Automation.inFloat increment]
getBrightness :: IPictureFormat a -> Prelude.IO (Prelude.Float)
getBrightness =
  Automation.propertyGet "Brightness" [] Automation.outFloat
setBrightness :: Prelude.Float -> IPictureFormat a -> Prelude.IO ()
setBrightness brightness =
  Automation.propertySet "Brightness" [Automation.inFloat brightness]
getColorType :: (Automation.Variant a0) => IPictureFormat a -> Prelude.IO (a0)
getColorType =
  Automation.propertyGet "ColorType" [] Automation.outVariant
setColorType :: (Automation.Variant a0) => a0 -> IPictureFormat a -> Prelude.IO ()
setColorType colorType =
  Automation.propertySet "ColorType" [Automation.inVariant colorType]
getContrast :: IPictureFormat a -> Prelude.IO (Prelude.Float)
getContrast =
  Automation.propertyGet "Contrast" [] Automation.outFloat
setContrast :: Prelude.Float -> IPictureFormat a -> Prelude.IO ()
setContrast contrast =
  Automation.propertySet "Contrast" [Automation.inFloat contrast]
getCropBottom :: IPictureFormat a -> Prelude.IO (Prelude.Float)
getCropBottom =
  Automation.propertyGet "CropBottom" [] Automation.outFloat
setCropBottom :: Prelude.Float -> IPictureFormat a -> Prelude.IO ()
setCropBottom cropBottom =
  Automation.propertySet "CropBottom" [Automation.inFloat cropBottom]
getCropLeft :: IPictureFormat a -> Prelude.IO (Prelude.Float)
getCropLeft =
  Automation.propertyGet "CropLeft" [] Automation.outFloat
setCropLeft :: Prelude.Float -> IPictureFormat a -> Prelude.IO ()
setCropLeft cropLeft =
  Automation.propertySet "CropLeft" [Automation.inFloat cropLeft]
getCropRight :: IPictureFormat a -> Prelude.IO (Prelude.Float)
getCropRight =
  Automation.propertyGet "CropRight" [] Automation.outFloat
setCropRight :: Prelude.Float -> IPictureFormat a -> Prelude.IO ()
setCropRight cropRight =
  Automation.propertySet "CropRight" [Automation.inFloat cropRight]
getCropTop :: IPictureFormat a -> Prelude.IO (Prelude.Float)
getCropTop =
  Automation.propertyGet "CropTop" [] Automation.outFloat
setCropTop :: Prelude.Float -> IPictureFormat a -> Prelude.IO ()
setCropTop cropTop =
  Automation.propertySet "CropTop" [Automation.inFloat cropTop]
getTransparencyColor :: IPictureFormat a -> Prelude.IO (Prelude.Int)
getTransparencyColor =
  Automation.propertyGet "TransparencyColor" [] Automation.outInt
setTransparencyColor :: Prelude.Int -> IPictureFormat a -> Prelude.IO ()
setTransparencyColor transparencyColor =
  Automation.propertySet "TransparencyColor" [Automation.inInt transparencyColor]
getTransparentBackground :: (Automation.Variant a0) => IPictureFormat a -> Prelude.IO (a0)
getTransparentBackground =
  Automation.propertyGet "TransparentBackground" [] Automation.outVariant
setTransparentBackground :: (Automation.Variant a0) => a0 -> IPictureFormat a -> Prelude.IO ()
setTransparentBackground transparentBackground =
  Automation.propertySet "TransparentBackground" [Automation.inVariant transparentBackground]
-- --------------------------------------------------
-- 
-- interface ShadowFormat
-- 
-- --------------------------------------------------
data ShadowFormat a = ShadowFormat
                       
type IShadowFormat a = IMsoDispObj (ShadowFormat a)
iidIShadowFormat :: Com.IID (IShadowFormat Automation.Interface)
iidIShadowFormat =
  Com.mkIID "{000C031B-0000-0000-C000-000000000046}"
incrementOffsetX :: Prelude.Float -> IShadowFormat a -> Prelude.IO ()
incrementOffsetX increment =
  Automation.method0 "IncrementOffsetX" [Automation.inFloat increment]
incrementOffsetY :: Prelude.Float -> IShadowFormat a -> Prelude.IO ()
incrementOffsetY increment =
  Automation.method0 "IncrementOffsetY" [Automation.inFloat increment]
getObscured :: (Automation.Variant a0) => IShadowFormat a -> Prelude.IO (a0)
getObscured =
  Automation.propertyGet "Obscured" [] Automation.outVariant
setObscured :: (Automation.Variant a0) => a0 -> IShadowFormat a -> Prelude.IO ()
setObscured obscured =
  Automation.propertySet "Obscured" [Automation.inVariant obscured]
getOffsetX :: IShadowFormat a -> Prelude.IO (Prelude.Float)
getOffsetX =
  Automation.propertyGet "OffsetX" [] Automation.outFloat
setOffsetX :: Prelude.Float -> IShadowFormat a -> Prelude.IO ()
setOffsetX offsetX =
  Automation.propertySet "OffsetX" [Automation.inFloat offsetX]
getOffsetY :: IShadowFormat a -> Prelude.IO (Prelude.Float)
getOffsetY =
  Automation.propertyGet "OffsetY" [] Automation.outFloat
setOffsetY :: Prelude.Float -> IShadowFormat a -> Prelude.IO ()
setOffsetY offsetY =
  Automation.propertySet "OffsetY" [Automation.inFloat offsetY]
getType8 :: (Automation.Variant a0) => IShadowFormat a -> Prelude.IO (a0)
getType8 = Automation.propertyGet "Type" [] Automation.outVariant
setType1 :: (Automation.Variant a0) => a0 -> IShadowFormat a -> Prelude.IO ()
setType1 type0 =
  Automation.propertySet "Type" [Automation.inVariant type0]
-- --------------------------------------------------
-- 
-- interface Shape
-- 
-- --------------------------------------------------
data Shape a = Shape
                
type IShape a = IMsoDispObj (Shape a)
iidIShape :: Com.IID (IShape Automation.Interface)
iidIShape = Com.mkIID "{000C031C-0000-0000-C000-000000000046}"
apply :: Automation.IDispatch a -> Prelude.IO ()
apply = Automation.method0 "Apply" []
duplicate :: IShape a -> Prelude.IO (IShape Automation.Interface)
duplicate =
  Automation.function1 "Duplicate" [] Automation.outIDispatch
flip :: (Automation.Variant a0) => a0 -> Automation.IDispatch a -> Prelude.IO ()
flip flipCmd =
  Automation.method0 "Flip" [Automation.inVariant flipCmd]
incrementLeft :: Prelude.Float -> Automation.IDispatch a -> Prelude.IO ()
incrementLeft increment =
  Automation.method0 "IncrementLeft" [Automation.inFloat increment]
incrementRotation :: Prelude.Float -> Automation.IDispatch a -> Prelude.IO ()
incrementRotation increment =
  Automation.method0 "IncrementRotation" [Automation.inFloat increment]
incrementTop :: Prelude.Float -> Automation.IDispatch a -> Prelude.IO ()
incrementTop increment =
  Automation.method0 "IncrementTop" [Automation.inFloat increment]
pickUp :: Automation.IDispatch a -> Prelude.IO ()
pickUp = Automation.method0 "PickUp" []
rerouteConnections :: Automation.IDispatch a -> Prelude.IO ()
rerouteConnections = Automation.method0 "RerouteConnections" []
scaleHeight :: (Automation.Variant a0, Automation.Variant a1) => Prelude.Float -> a0 -> a1 -> Automation.IDispatch a -> Prelude.IO ()
scaleHeight factor relativeToOriginalSize fScale =
  Automation.method0 "ScaleHeight" [Automation.inFloat factor, Automation.inVariant relativeToOriginalSize, Automation.inVariant fScale]
scaleWidth :: (Automation.Variant a0, Automation.Variant a1) => Prelude.Float -> a0 -> a1 -> Automation.IDispatch a -> Prelude.IO ()
scaleWidth factor relativeToOriginalSize fScale =
  Automation.method0 "ScaleWidth" [Automation.inFloat factor, Automation.inVariant relativeToOriginalSize, Automation.inVariant fScale]
select :: Prelude.Int -> Automation.IDispatch a -> Prelude.IO ()
select replace =
  Automation.method0 "Select" [Automation.inInt replace]
setShapesDefaultProperties :: Automation.IDispatch a -> Prelude.IO ()
setShapesDefaultProperties =
  Automation.method0 "SetShapesDefaultProperties" []
ungroup :: Automation.IDispatch a -> Prelude.IO (IShapeRange Automation.Interface)
ungroup = Automation.function1 "Ungroup" [] Automation.outIDispatch
zOrder :: (Automation.Variant a0) => a0 -> Automation.IDispatch a -> Prelude.IO ()
zOrder zOrderCmd =
  Automation.method0 "ZOrder" [Automation.inVariant zOrderCmd]
getAdjustments :: Automation.IDispatch a -> Prelude.IO (IAdjustments Automation.Interface)
getAdjustments =
  Automation.propertyGet "Adjustments" [] Automation.outIDispatch
getAutoShapeType :: (Automation.Variant a0) => Automation.IDispatch a -> Prelude.IO (a0)
getAutoShapeType =
  Automation.propertyGet "AutoShapeType" [] Automation.outVariant
setAutoShapeType :: (Automation.Variant a0) => a0 -> Automation.IDispatch a -> Prelude.IO ()
setAutoShapeType autoShapeType =
  Automation.propertySet "AutoShapeType" [Automation.inVariant autoShapeType]
getBlackWhiteMode :: (Automation.Variant a0) => Automation.IDispatch a -> Prelude.IO (a0)
getBlackWhiteMode =
  Automation.propertyGet "BlackWhiteMode" [] Automation.outVariant
setBlackWhiteMode :: (Automation.Variant a0) => a0 -> Automation.IDispatch a -> Prelude.IO ()
setBlackWhiteMode blackWhiteMode =
  Automation.propertySet "BlackWhiteMode" [Automation.inVariant blackWhiteMode]
getCallout :: Automation.IDispatch a -> Prelude.IO (ICalloutFormat Automation.Interface)
getCallout =
  Automation.propertyGet "Callout" [] Automation.outIDispatch
getConnectionSiteCount :: Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getConnectionSiteCount =
  Automation.propertyGet "ConnectionSiteCount" [] Automation.outInt
getConnector :: (Automation.Variant a0) => Automation.IDispatch a -> Prelude.IO (a0)
getConnector =
  Automation.propertyGet "Connector" [] Automation.outVariant
getConnectorFormat :: Automation.IDispatch a -> Prelude.IO (IConnectorFormat Automation.Interface)
getConnectorFormat =
  Automation.propertyGet "ConnectorFormat" [] Automation.outIDispatch
getFill :: Automation.IDispatch a -> Prelude.IO (IFillFormat Automation.Interface)
getFill = Automation.propertyGet "Fill" [] Automation.outIDispatch
getGroupItems :: Automation.IDispatch a -> Prelude.IO (IGroupShapes Automation.Interface)
getGroupItems =
  Automation.propertyGet "GroupItems" [] Automation.outIDispatch
getHeight4 :: Automation.IDispatch a -> Prelude.IO (Prelude.Float)
getHeight4 = Automation.propertyGet "Height" [] Automation.outFloat
setHeight4 :: Prelude.Float -> Automation.IDispatch a -> Prelude.IO ()
setHeight4 height =
  Automation.propertySet "Height" [Automation.inFloat height]
getHorizontalFlip :: (Automation.Variant a0) => Automation.IDispatch a -> Prelude.IO (a0)
getHorizontalFlip =
  Automation.propertyGet "HorizontalFlip" [] Automation.outVariant
getLeft4 :: Automation.IDispatch a -> Prelude.IO (Prelude.Float)
getLeft4 = Automation.propertyGet "Left" [] Automation.outFloat
setLeft0 :: Prelude.Float -> Automation.IDispatch a -> Prelude.IO ()
setLeft0 left =
  Automation.propertySet "Left" [Automation.inFloat left]
getLine :: Automation.IDispatch a -> Prelude.IO (ILineFormat Automation.Interface)
getLine = Automation.propertyGet "Line" [] Automation.outIDispatch
getLockAspectRatio :: (Automation.Variant a0) => Automation.IDispatch a -> Prelude.IO (a0)
getLockAspectRatio =
  Automation.propertyGet "LockAspectRatio" [] Automation.outVariant
setLockAspectRatio :: (Automation.Variant a0) => a0 -> Automation.IDispatch a -> Prelude.IO ()
setLockAspectRatio lockAspectRatio =
  Automation.propertySet "LockAspectRatio" [Automation.inVariant lockAspectRatio]
getNodes :: Automation.IDispatch a -> Prelude.IO (IShapeNodes Automation.Interface)
getNodes =
  Automation.propertyGet "Nodes" [] Automation.outIDispatch
getRotation :: Automation.IDispatch a -> Prelude.IO (Prelude.Float)
getRotation =
  Automation.propertyGet "Rotation" [] Automation.outFloat
setRotation :: Prelude.Float -> Automation.IDispatch a -> Prelude.IO ()
setRotation rotation =
  Automation.propertySet "Rotation" [Automation.inFloat rotation]
getPictureFormat :: Automation.IDispatch a -> Prelude.IO (IPictureFormat Automation.Interface)
getPictureFormat =
  Automation.propertyGet "PictureFormat" [] Automation.outIDispatch
getShadow :: Automation.IDispatch a -> Prelude.IO (IShadowFormat Automation.Interface)
getShadow =
  Automation.propertyGet "Shadow" [] Automation.outIDispatch
getTextEffect :: Automation.IDispatch a -> Prelude.IO (ITextEffectFormat Automation.Interface)
getTextEffect =
  Automation.propertyGet "TextEffect" [] Automation.outIDispatch
getTextFrame :: Automation.IDispatch a -> Prelude.IO (ITextFrame Automation.Interface)
getTextFrame =
  Automation.propertyGet "TextFrame" [] Automation.outIDispatch
getThreeD :: Automation.IDispatch a -> Prelude.IO (IThreeDFormat Automation.Interface)
getThreeD =
  Automation.propertyGet "ThreeD" [] Automation.outIDispatch
getTop4 :: Automation.IDispatch a -> Prelude.IO (Prelude.Float)
getTop4 = Automation.propertyGet "Top" [] Automation.outFloat
setTop0 :: Prelude.Float -> Automation.IDispatch a -> Prelude.IO ()
setTop0 top = Automation.propertySet "Top" [Automation.inFloat top]
getType9 :: (Automation.Variant a0) => Automation.IDispatch a -> Prelude.IO (a0)
getType9 = Automation.propertyGet "Type" [] Automation.outVariant
getVerticalFlip :: (Automation.Variant a0) => Automation.IDispatch a -> Prelude.IO (a0)
getVerticalFlip =
  Automation.propertyGet "VerticalFlip" [] Automation.outVariant
getVertices :: Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getVertices =
  Automation.propertyGet "Vertices" [] Automation.outInt
getWidth4 :: Automation.IDispatch a -> Prelude.IO (Prelude.Float)
getWidth4 = Automation.propertyGet "Width" [] Automation.outFloat
setWidth4 :: Prelude.Float -> Automation.IDispatch a -> Prelude.IO ()
setWidth4 width =
  Automation.propertySet "Width" [Automation.inFloat width]
getZOrderPosition :: Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getZOrderPosition =
  Automation.propertyGet "ZOrderPosition" [] Automation.outInt
-- --------------------------------------------------
-- 
-- interface ShapeRange
-- 
-- --------------------------------------------------
data ShapeRange a = ShapeRange
                     
type IShapeRange a = IMsoDispObj (ShapeRange a)
iidIShapeRange :: Com.IID (IShapeRange Automation.Interface)
iidIShapeRange = Com.mkIID "{000C031D-0000-0000-C000-000000000046}"
align :: (Automation.Variant a0, Automation.Variant a1) => a0 -> a1 -> IShapeRange a -> Prelude.IO ()
align alignCmd relativeTo =
  Automation.method0 "Align" [Automation.inVariant alignCmd, Automation.inVariant relativeTo]
distribute :: (Automation.Variant a0, Automation.Variant a1) => a0 -> a1 -> IShapeRange a -> Prelude.IO ()
distribute distributeCmd relativeTo =
  Automation.method0 "Distribute" [Automation.inVariant distributeCmd, Automation.inVariant relativeTo]
duplicate0 :: IShapeRange a -> Prelude.IO (IShapeRange Automation.Interface)
duplicate0 =
  Automation.function1 "Duplicate" [] Automation.outIDispatch
group :: IShapeRange a -> Prelude.IO (IShape Automation.Interface)
group = Automation.function1 "Group" [] Automation.outIDispatch
regroup :: IShapeRange a -> Prelude.IO (IShape Automation.Interface)
regroup = Automation.function1 "Regroup" [] Automation.outIDispatch
-- --------------------------------------------------
-- 
-- interface Shapes
-- 
-- --------------------------------------------------
data Shapes a = Shapes
                 
type IShapes a = IMsoDispObj (Shapes a)
iidIShapes :: Com.IID (IShapes Automation.Interface)
iidIShapes = Com.mkIID "{000C031E-0000-0000-C000-000000000046}"
addCallout :: (Automation.Variant a0) => a0 -> Prelude.Float -> Prelude.Float -> Prelude.Float -> Prelude.Float -> IShapes a -> Prelude.IO (IShape Automation.Interface)
addCallout type0 left top width height =
  Automation.function1 "AddCallout" [Automation.inVariant type0, Automation.inFloat left, Automation.inFloat top, Automation.inFloat width, Automation.inFloat height] Automation.outIDispatch
addConnector :: (Automation.Variant a0) => a0 -> Prelude.Float -> Prelude.Float -> Prelude.Float -> Prelude.Float -> IShapes a -> Prelude.IO (IShape Automation.Interface)
addConnector type0 beginX beginY endX endY =
  Automation.function1 "AddConnector" [Automation.inVariant type0, Automation.inFloat beginX, Automation.inFloat beginY, Automation.inFloat endX, Automation.inFloat endY] Automation.outIDispatch
addCurve :: Prelude.Int -> IShapes a -> Prelude.IO (IShape Automation.Interface)
addCurve safeArrayOfPoints =
  Automation.function1 "AddCurve" [Automation.inInt safeArrayOfPoints] Automation.outIDispatch
addLabel :: (Automation.Variant a0) => a0 -> Prelude.Float -> Prelude.Float -> Prelude.Float -> Prelude.Float -> IShapes a -> Prelude.IO (IShape Automation.Interface)
addLabel orientation left top width height =
  Automation.function1 "AddLabel" [Automation.inVariant orientation, Automation.inFloat left, Automation.inFloat top, Automation.inFloat width, Automation.inFloat height] Automation.outIDispatch
addLine :: Prelude.Float -> Prelude.Float -> Prelude.Float -> Prelude.Float -> IShapes a -> Prelude.IO (IShape Automation.Interface)
addLine beginX beginY endX endY =
  Automation.function1 "AddLine" [Automation.inFloat beginX, Automation.inFloat beginY, Automation.inFloat endX, Automation.inFloat endY] Automation.outIDispatch
addPicture :: (Automation.Variant a0, Automation.Variant a1) => Prelude.String -> a0 -> a1 -> Prelude.Float -> Prelude.Float -> Prelude.Float -> Prelude.Float -> IShapes a -> Prelude.IO (IShape Automation.Interface)
addPicture fileName linkToFile saveWithDocument left top width height =
  Automation.function1 "AddPicture" [Automation.inString fileName, Automation.inVariant linkToFile, Automation.inVariant saveWithDocument, Automation.inFloat left, Automation.inFloat top, Automation.inFloat width, Automation.inFloat height] Automation.outIDispatch
addPolyline :: Prelude.Int -> IShapes a -> Prelude.IO (IShape Automation.Interface)
addPolyline safeArrayOfPoints =
  Automation.function1 "AddPolyline" [Automation.inInt safeArrayOfPoints] Automation.outIDispatch
addShape :: (Automation.Variant a0) => a0 -> Prelude.Float -> Prelude.Float -> Prelude.Float -> Prelude.Float -> IShapes a -> Prelude.IO (IShape Automation.Interface)
addShape type0 left top width height =
  Automation.function1 "AddShape" [Automation.inVariant type0, Automation.inFloat left, Automation.inFloat top, Automation.inFloat width, Automation.inFloat height] Automation.outIDispatch
addTextEffect :: (Automation.Variant a0, Automation.Variant a1, Automation.Variant a2) => a0 -> Prelude.String -> Prelude.String -> Prelude.Float -> a1 -> a2 -> Prelude.Float -> Prelude.Float -> IShapes a -> Prelude.IO (IShape Automation.Interface)
addTextEffect presetTextEffect text fontName fontSize fontBold fontItalic left top =
  Automation.function1 "AddTextEffect" [Automation.inVariant presetTextEffect, Automation.inString text, Automation.inString fontName, Automation.inFloat fontSize, Automation.inVariant fontBold, Automation.inVariant fontItalic, Automation.inFloat left, Automation.inFloat top] Automation.outIDispatch
addTextbox :: (Automation.Variant a0) => a0 -> Prelude.Float -> Prelude.Float -> Prelude.Float -> Prelude.Float -> IShapes a -> Prelude.IO (IShape Automation.Interface)
addTextbox orientation left top width height =
  Automation.function1 "AddTextbox" [Automation.inVariant orientation, Automation.inFloat left, Automation.inFloat top, Automation.inFloat width, Automation.inFloat height] Automation.outIDispatch
buildFreeform :: (Automation.Variant a0) => a0 -> Prelude.Float -> Prelude.Float -> IShapes a -> Prelude.IO (IFreeformBuilder Automation.Interface)
buildFreeform editingType x1 y1 =
  Automation.function1 "BuildFreeform" [Automation.inVariant editingType, Automation.inFloat x1, Automation.inFloat y1] Automation.outIDispatch
range :: Prelude.Int -> IShapes a -> Prelude.IO (IShapeRange Automation.Interface)
range idex =
  Automation.function1 "Range" [Automation.inInt idex] Automation.outIDispatch
selectAll :: IShapes a -> Prelude.IO ()
selectAll = Automation.method0 "SelectAll" []
getBackground :: Automation.IDispatch a -> Prelude.IO (IShape Automation.Interface)
getBackground =
  Automation.propertyGet "Background" [] Automation.outIDispatch
getDefault :: IShapes a -> Prelude.IO (IShape Automation.Interface)
getDefault =
  Automation.propertyGet "Default" [] Automation.outIDispatch
-- --------------------------------------------------
-- 
-- interface TextEffectFormat
-- 
-- --------------------------------------------------
data TextEffectFormat a = TextEffectFormat
                           
type ITextEffectFormat a = IMsoDispObj (TextEffectFormat a)
iidITextEffectFormat :: Com.IID (ITextEffectFormat Automation.Interface)
iidITextEffectFormat =
  Com.mkIID "{000C031F-0000-0000-C000-000000000046}"
toggleVerticalText :: ITextEffectFormat a -> Prelude.IO ()
toggleVerticalText = Automation.method0 "ToggleVerticalText" []
getAlignment :: (Automation.Variant a0) => ITextEffectFormat a -> Prelude.IO (a0)
getAlignment =
  Automation.propertyGet "Alignment" [] Automation.outVariant
setAlignment :: (Automation.Variant a0) => a0 -> ITextEffectFormat a -> Prelude.IO ()
setAlignment alignment =
  Automation.propertySet "Alignment" [Automation.inVariant alignment]
getFontBold :: (Automation.Variant a0) => ITextEffectFormat a -> Prelude.IO (a0)
getFontBold =
  Automation.propertyGet "FontBold" [] Automation.outVariant
setFontBold :: (Automation.Variant a0) => a0 -> ITextEffectFormat a -> Prelude.IO ()
setFontBold fontBold =
  Automation.propertySet "FontBold" [Automation.inVariant fontBold]
getFontItalic :: (Automation.Variant a0) => ITextEffectFormat a -> Prelude.IO (a0)
getFontItalic =
  Automation.propertyGet "FontItalic" [] Automation.outVariant
setFontItalic :: (Automation.Variant a0) => a0 -> ITextEffectFormat a -> Prelude.IO ()
setFontItalic fontItalic =
  Automation.propertySet "FontItalic" [Automation.inVariant fontItalic]
getFontName :: ITextEffectFormat a -> Prelude.IO (Prelude.String)
getFontName =
  Automation.propertyGet "FontName" [] Automation.outString
setFontName :: Prelude.String -> ITextEffectFormat a -> Prelude.IO ()
setFontName fontName =
  Automation.propertySet "FontName" [Automation.inString fontName]
getFontSize :: ITextEffectFormat a -> Prelude.IO (Prelude.Float)
getFontSize =
  Automation.propertyGet "FontSize" [] Automation.outFloat
setFontSize :: Prelude.Float -> ITextEffectFormat a -> Prelude.IO ()
setFontSize fontSize =
  Automation.propertySet "FontSize" [Automation.inFloat fontSize]
getKernedPairs :: (Automation.Variant a0) => ITextEffectFormat a -> Prelude.IO (a0)
getKernedPairs =
  Automation.propertyGet "KernedPairs" [] Automation.outVariant
setKernedPairs :: (Automation.Variant a0) => a0 -> ITextEffectFormat a -> Prelude.IO ()
setKernedPairs kernedPairs =
  Automation.propertySet "KernedPairs" [Automation.inVariant kernedPairs]
getNormalizedHeight :: (Automation.Variant a0) => ITextEffectFormat a -> Prelude.IO (a0)
getNormalizedHeight =
  Automation.propertyGet "NormalizedHeight" [] Automation.outVariant
setNormalizedHeight :: (Automation.Variant a0) => a0 -> ITextEffectFormat a -> Prelude.IO ()
setNormalizedHeight normalizedHeight =
  Automation.propertySet "NormalizedHeight" [Automation.inVariant normalizedHeight]
getPresetShape :: (Automation.Variant a0) => ITextEffectFormat a -> Prelude.IO (a0)
getPresetShape =
  Automation.propertyGet "PresetShape" [] Automation.outVariant
setPresetShape :: (Automation.Variant a0) => a0 -> ITextEffectFormat a -> Prelude.IO ()
setPresetShape presetShape =
  Automation.propertySet "PresetShape" [Automation.inVariant presetShape]
getPresetTextEffect :: (Automation.Variant a0) => ITextEffectFormat a -> Prelude.IO (a0)
getPresetTextEffect =
  Automation.propertyGet "PresetTextEffect" [] Automation.outVariant
setPresetTextEffect :: (Automation.Variant a0) => a0 -> ITextEffectFormat a -> Prelude.IO ()
setPresetTextEffect preset =
  Automation.propertySet "PresetTextEffect" [Automation.inVariant preset]
getRotatedChars :: (Automation.Variant a0) => ITextEffectFormat a -> Prelude.IO (a0)
getRotatedChars =
  Automation.propertyGet "RotatedChars" [] Automation.outVariant
setRotatedChars :: (Automation.Variant a0) => a0 -> ITextEffectFormat a -> Prelude.IO ()
setRotatedChars rotatedChars =
  Automation.propertySet "RotatedChars" [Automation.inVariant rotatedChars]
getTracking :: ITextEffectFormat a -> Prelude.IO (Prelude.Float)
getTracking =
  Automation.propertyGet "Tracking" [] Automation.outFloat
setTracking :: Prelude.Float -> ITextEffectFormat a -> Prelude.IO ()
setTracking tracking =
  Automation.propertySet "Tracking" [Automation.inFloat tracking]
-- --------------------------------------------------
-- 
-- interface TextFrame
-- 
-- --------------------------------------------------
data TextFrame a = TextFrame
                    
type ITextFrame a = IMsoDispObj (TextFrame a)
iidITextFrame :: Com.IID (ITextFrame Automation.Interface)
iidITextFrame = Com.mkIID "{000C0320-0000-0000-C000-000000000046}"
getMarginBottom :: ITextFrame a -> Prelude.IO (Prelude.Float)
getMarginBottom =
  Automation.propertyGet "MarginBottom" [] Automation.outFloat
setMarginBottom :: Prelude.Float -> ITextFrame a -> Prelude.IO ()
setMarginBottom marginBottom =
  Automation.propertySet "MarginBottom" [Automation.inFloat marginBottom]
getMarginLeft :: ITextFrame a -> Prelude.IO (Prelude.Float)
getMarginLeft =
  Automation.propertyGet "MarginLeft" [] Automation.outFloat
setMarginLeft :: Prelude.Float -> ITextFrame a -> Prelude.IO ()
setMarginLeft marginLeft =
  Automation.propertySet "MarginLeft" [Automation.inFloat marginLeft]
getMarginRight :: ITextFrame a -> Prelude.IO (Prelude.Float)
getMarginRight =
  Automation.propertyGet "MarginRight" [] Automation.outFloat
setMarginRight :: Prelude.Float -> ITextFrame a -> Prelude.IO ()
setMarginRight marginRight =
  Automation.propertySet "MarginRight" [Automation.inFloat marginRight]
getMarginTop :: ITextFrame a -> Prelude.IO (Prelude.Float)
getMarginTop =
  Automation.propertyGet "MarginTop" [] Automation.outFloat
setMarginTop :: Prelude.Float -> ITextFrame a -> Prelude.IO ()
setMarginTop marginTop =
  Automation.propertySet "MarginTop" [Automation.inFloat marginTop]
getOrientation :: (Automation.Variant a0) => ITextFrame a -> Prelude.IO (a0)
getOrientation =
  Automation.propertyGet "Orientation" [] Automation.outVariant
setOrientation :: (Automation.Variant a0) => a0 -> ITextFrame a -> Prelude.IO ()
setOrientation orientation =
  Automation.propertySet "Orientation" [Automation.inVariant orientation]
-- --------------------------------------------------
-- 
-- interface ThreeDFormat
-- 
-- --------------------------------------------------
data ThreeDFormat a = ThreeDFormat
                       
type IThreeDFormat a = IMsoDispObj (ThreeDFormat a)
iidIThreeDFormat :: Com.IID (IThreeDFormat Automation.Interface)
iidIThreeDFormat =
  Com.mkIID "{000C0321-0000-0000-C000-000000000046}"
incrementRotationX :: Prelude.Float -> IThreeDFormat a -> Prelude.IO ()
incrementRotationX increment =
  Automation.method0 "IncrementRotationX" [Automation.inFloat increment]
incrementRotationY :: Prelude.Float -> IThreeDFormat a -> Prelude.IO ()
incrementRotationY increment =
  Automation.method0 "IncrementRotationY" [Automation.inFloat increment]
resetRotation :: IThreeDFormat a -> Prelude.IO ()
resetRotation = Automation.method0 "ResetRotation" []
setThreeDFormat :: (Automation.Variant a0) => a0 -> IThreeDFormat a -> Prelude.IO ()
setThreeDFormat presetThreeDFormat =
  Automation.method0 "SetThreeDFormat" [Automation.inVariant presetThreeDFormat]
setExtrusionDirection :: (Automation.Variant a0) => a0 -> IThreeDFormat a -> Prelude.IO ()
setExtrusionDirection presetExtrusionDirection =
  Automation.method0 "SetExtrusionDirection" [Automation.inVariant presetExtrusionDirection]
getDepth :: IThreeDFormat a -> Prelude.IO (Prelude.Float)
getDepth = Automation.propertyGet "Depth" [] Automation.outFloat
setDepth :: Prelude.Float -> IThreeDFormat a -> Prelude.IO ()
setDepth depth =
  Automation.propertySet "Depth" [Automation.inFloat depth]
getExtrusionColor :: IThreeDFormat a -> Prelude.IO (IColorFormat Automation.Interface)
getExtrusionColor =
  Automation.propertyGet "ExtrusionColor" [] Automation.outIDispatch
getExtrusionColorType :: (Automation.Variant a0) => IThreeDFormat a -> Prelude.IO (a0)
getExtrusionColorType =
  Automation.propertyGet "ExtrusionColorType" [] Automation.outVariant
setExtrusionColorType :: (Automation.Variant a0) => a0 -> IThreeDFormat a -> Prelude.IO ()
setExtrusionColorType extrusionColorType =
  Automation.propertySet "ExtrusionColorType" [Automation.inVariant extrusionColorType]
getPerspective :: (Automation.Variant a0) => IThreeDFormat a -> Prelude.IO (a0)
getPerspective =
  Automation.propertyGet "Perspective" [] Automation.outVariant
setPerspective :: (Automation.Variant a0) => a0 -> IThreeDFormat a -> Prelude.IO ()
setPerspective perspective =
  Automation.propertySet "Perspective" [Automation.inVariant perspective]
getPresetExtrusionDirection :: (Automation.Variant a0) => IThreeDFormat a -> Prelude.IO (a0)
getPresetExtrusionDirection =
  Automation.propertyGet "PresetExtrusionDirection" [] Automation.outVariant
getPresetLightingDirection :: (Automation.Variant a0) => IThreeDFormat a -> Prelude.IO (a0)
getPresetLightingDirection =
  Automation.propertyGet "PresetLightingDirection" [] Automation.outVariant
setPresetLightingDirection :: (Automation.Variant a0) => a0 -> IThreeDFormat a -> Prelude.IO ()
setPresetLightingDirection presetLightingDirection =
  Automation.propertySet "PresetLightingDirection" [Automation.inVariant presetLightingDirection]
getPresetLightingSoftness :: (Automation.Variant a0) => IThreeDFormat a -> Prelude.IO (a0)
getPresetLightingSoftness =
  Automation.propertyGet "PresetLightingSoftness" [] Automation.outVariant
setPresetLightingSoftness :: (Automation.Variant a0) => a0 -> IThreeDFormat a -> Prelude.IO ()
setPresetLightingSoftness presetLightingSoftness =
  Automation.propertySet "PresetLightingSoftness" [Automation.inVariant presetLightingSoftness]
getPresetMaterial :: (Automation.Variant a0) => IThreeDFormat a -> Prelude.IO (a0)
getPresetMaterial =
  Automation.propertyGet "PresetMaterial" [] Automation.outVariant
setPresetMaterial :: (Automation.Variant a0) => a0 -> IThreeDFormat a -> Prelude.IO ()
setPresetMaterial presetMaterial =
  Automation.propertySet "PresetMaterial" [Automation.inVariant presetMaterial]
getPresetThreeDFormat :: (Automation.Variant a0) => IThreeDFormat a -> Prelude.IO (a0)
getPresetThreeDFormat =
  Automation.propertyGet "PresetThreeDFormat" [] Automation.outVariant
getRotationX :: IThreeDFormat a -> Prelude.IO (Prelude.Float)
getRotationX =
  Automation.propertyGet "RotationX" [] Automation.outFloat
setRotationX :: Prelude.Float -> IThreeDFormat a -> Prelude.IO ()
setRotationX rotationX =
  Automation.propertySet "RotationX" [Automation.inFloat rotationX]
getRotationY :: IThreeDFormat a -> Prelude.IO (Prelude.Float)
getRotationY =
  Automation.propertyGet "RotationY" [] Automation.outFloat
setRotationY :: Prelude.Float -> IThreeDFormat a -> Prelude.IO ()
setRotationY rotationY =
  Automation.propertySet "RotationY" [Automation.inFloat rotationY]
-- --------------------------------------------------
-- 
-- interface Assistant
-- 
-- --------------------------------------------------
data Assistant a = Assistant
                    
type IAssistant a = IMsoDispObj (Assistant a)
iidIAssistant :: Com.IID (IAssistant Automation.Interface)
iidIAssistant = Com.mkIID "{000C0322-0000-0000-C000-000000000046}"
move3 :: Prelude.Int -> Prelude.Int -> Automation.IDispatch a -> Prelude.IO ()
move3 xLeft yTop =
  Automation.method0 "Move" [Automation.inInt xLeft, Automation.inInt yTop]
help :: IAssistant a -> Prelude.IO ()
help = Automation.method0 "Help" []
startWizard :: Prelude.Int -> Prelude.String -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> IAssistant a -> Prelude.IO (Prelude.Int)
startWizard on callback privateX animation customTeaser top left bottom right =
  Automation.function1 "StartWizard" [Automation.inInt on, Automation.inString callback, Automation.inInt privateX, Automation.inInt animation, Automation.inInt customTeaser, Automation.inInt top, Automation.inInt left, Automation.inInt bottom, Automation.inInt right] Automation.outInt
endWizard :: Prelude.Int -> Prelude.Int -> Prelude.Int -> IAssistant a -> Prelude.IO ()
endWizard wizardID varfSuccess animation =
  Automation.method0 "EndWizard" [Automation.inInt wizardID, Automation.inInt varfSuccess, Automation.inInt animation]
activateWizard :: (Automation.Variant a0) => Prelude.Int -> a0 -> Prelude.Int -> IAssistant a -> Prelude.IO ()
activateWizard wizardID act animation =
  Automation.method0 "ActivateWizard" [Automation.inInt wizardID, Automation.inVariant act, Automation.inInt animation]
resetTips :: IAssistant a -> Prelude.IO ()
resetTips = Automation.method0 "ResetTips" []
getNewBalloon :: IAssistant a -> Prelude.IO (Automation.IDispatch Automation.Interface)
getNewBalloon =
  Automation.propertyGet "NewBalloon" [] Automation.outIDispatch
getBalloonError :: (Automation.Variant a0) => IAssistant a -> Prelude.IO (a0)
getBalloonError =
  Automation.propertyGet "BalloonError" [] Automation.outVariant
getAnimation :: (Automation.Variant a0) => Automation.IDispatch a -> Prelude.IO (a0)
getAnimation =
  Automation.propertyGet "Animation" [] Automation.outVariant
setAnimation :: (Automation.Variant a0) => a0 -> Automation.IDispatch a -> Prelude.IO ()
setAnimation pfca =
  Automation.propertySet "Animation" [Automation.inVariant pfca]
getReduced :: IAssistant a -> Prelude.IO (Prelude.Int)
getReduced = Automation.propertyGet "Reduced" [] Automation.outInt
setReduced :: Prelude.Int -> IAssistant a -> Prelude.IO ()
setReduced pvarfReduced =
  Automation.propertySet "Reduced" [Automation.inInt pvarfReduced]
setAssistWithHelp :: Prelude.Int -> IAssistant a -> Prelude.IO ()
setAssistWithHelp pvarfAssistWithHelp =
  Automation.propertySet "AssistWithHelp" [Automation.inInt pvarfAssistWithHelp]
getAssistWithHelp :: IAssistant a -> Prelude.IO (Prelude.Int)
getAssistWithHelp =
  Automation.propertyGet "AssistWithHelp" [] Automation.outInt
setAssistWithWizards :: Prelude.Int -> IAssistant a -> Prelude.IO ()
setAssistWithWizards pvarfAssistWithWizards =
  Automation.propertySet "AssistWithWizards" [Automation.inInt pvarfAssistWithWizards]
getAssistWithWizards :: IAssistant a -> Prelude.IO (Prelude.Int)
getAssistWithWizards =
  Automation.propertyGet "AssistWithWizards" [] Automation.outInt
setAssistWithAlerts :: Prelude.Int -> IAssistant a -> Prelude.IO ()
setAssistWithAlerts pvarfAssistWithAlerts =
  Automation.propertySet "AssistWithAlerts" [Automation.inInt pvarfAssistWithAlerts]
getAssistWithAlerts :: IAssistant a -> Prelude.IO (Prelude.Int)
getAssistWithAlerts =
  Automation.propertyGet "AssistWithAlerts" [] Automation.outInt
setMoveWhenInTheWay :: Prelude.Int -> IAssistant a -> Prelude.IO ()
setMoveWhenInTheWay pvarfMove =
  Automation.propertySet "MoveWhenInTheWay" [Automation.inInt pvarfMove]
getMoveWhenInTheWay :: IAssistant a -> Prelude.IO (Prelude.Int)
getMoveWhenInTheWay =
  Automation.propertyGet "MoveWhenInTheWay" [] Automation.outInt
setSounds :: Prelude.Int -> IAssistant a -> Prelude.IO ()
setSounds pvarfSounds =
  Automation.propertySet "Sounds" [Automation.inInt pvarfSounds]
getSounds :: IAssistant a -> Prelude.IO (Prelude.Int)
getSounds = Automation.propertyGet "Sounds" [] Automation.outInt
setFeatureTips :: Prelude.Int -> IAssistant a -> Prelude.IO ()
setFeatureTips pvarfFeatures =
  Automation.propertySet "FeatureTips" [Automation.inInt pvarfFeatures]
getFeatureTips :: IAssistant a -> Prelude.IO (Prelude.Int)
getFeatureTips =
  Automation.propertyGet "FeatureTips" [] Automation.outInt
setMouseTips :: Prelude.Int -> IAssistant a -> Prelude.IO ()
setMouseTips pvarfMouse =
  Automation.propertySet "MouseTips" [Automation.inInt pvarfMouse]
getMouseTips :: IAssistant a -> Prelude.IO (Prelude.Int)
getMouseTips =
  Automation.propertyGet "MouseTips" [] Automation.outInt
setKeyboardShortcutTips :: Prelude.Int -> IAssistant a -> Prelude.IO ()
setKeyboardShortcutTips pvarfKeyboardShortcuts =
  Automation.propertySet "KeyboardShortcutTips" [Automation.inInt pvarfKeyboardShortcuts]
getKeyboardShortcutTips :: IAssistant a -> Prelude.IO (Prelude.Int)
getKeyboardShortcutTips =
  Automation.propertyGet "KeyboardShortcutTips" [] Automation.outInt
setHighPriorityTips :: Prelude.Int -> IAssistant a -> Prelude.IO ()
setHighPriorityTips pvarfHighPriorityTips =
  Automation.propertySet "HighPriorityTips" [Automation.inInt pvarfHighPriorityTips]
getHighPriorityTips :: IAssistant a -> Prelude.IO (Prelude.Int)
getHighPriorityTips =
  Automation.propertyGet "HighPriorityTips" [] Automation.outInt
setTipOfDay :: Prelude.Int -> IAssistant a -> Prelude.IO ()
setTipOfDay pvarfTipOfDay =
  Automation.propertySet "TipOfDay" [Automation.inInt pvarfTipOfDay]
getTipOfDay :: IAssistant a -> Prelude.IO (Prelude.Int)
getTipOfDay =
  Automation.propertyGet "TipOfDay" [] Automation.outInt
setGuessHelp :: Prelude.Int -> IAssistant a -> Prelude.IO ()
setGuessHelp pvarfGuessHelp =
  Automation.propertySet "GuessHelp" [Automation.inInt pvarfGuessHelp]
getGuessHelp :: IAssistant a -> Prelude.IO (Prelude.Int)
getGuessHelp =
  Automation.propertyGet "GuessHelp" [] Automation.outInt
setSearchWhenProgramming :: Prelude.Int -> IAssistant a -> Prelude.IO ()
setSearchWhenProgramming pvarfSearchInProgram =
  Automation.propertySet "SearchWhenProgramming" [Automation.inInt pvarfSearchInProgram]
getSearchWhenProgramming :: IAssistant a -> Prelude.IO (Prelude.Int)
getSearchWhenProgramming =
  Automation.propertyGet "SearchWhenProgramming" [] Automation.outInt
getItem2 :: Automation.IDispatch a -> Prelude.IO (Prelude.String)
getItem2 = Automation.propertyGet "Item" [] Automation.outString
getFileName :: Automation.IDispatch a -> Prelude.IO (Prelude.String)
getFileName =
  Automation.propertyGet "FileName" [] Automation.outString
setFileName :: Prelude.String -> Automation.IDispatch a -> Prelude.IO ()
setFileName pbstr =
  Automation.propertySet "FileName" [Automation.inString pbstr]
-- --------------------------------------------------
-- 
-- interface Balloon
-- 
-- --------------------------------------------------
data Balloon a = Balloon
                  
type IBalloon a = IMsoDispObj (Balloon a)
iidIBalloon :: Com.IID (IBalloon Automation.Interface)
iidIBalloon = Com.mkIID "{000C0324-0000-0000-C000-000000000046}"
getCheckboxes :: IBalloon a -> Prelude.IO (Automation.IDispatch Automation.Interface)
getCheckboxes =
  Automation.propertyGet "Checkboxes" [] Automation.outIDispatch
getLabels :: IBalloon a -> Prelude.IO (Automation.IDispatch Automation.Interface)
getLabels =
  Automation.propertyGet "Labels" [] Automation.outIDispatch
setBalloonType :: (Automation.Variant a0) => a0 -> IBalloon a -> Prelude.IO ()
setBalloonType pbty =
  Automation.propertySet "BalloonType" [Automation.inVariant pbty]
getBalloonType :: (Automation.Variant a0) => IBalloon a -> Prelude.IO (a0)
getBalloonType =
  Automation.propertyGet "BalloonType" [] Automation.outVariant
setIcon :: (Automation.Variant a0) => a0 -> IBalloon a -> Prelude.IO ()
setIcon picn =
  Automation.propertySet "Icon" [Automation.inVariant picn]
getIcon :: (Automation.Variant a0) => IBalloon a -> Prelude.IO (a0)
getIcon = Automation.propertyGet "Icon" [] Automation.outVariant
setHeading :: Prelude.String -> IBalloon a -> Prelude.IO ()
setHeading pbstr =
  Automation.propertySet "Heading" [Automation.inString pbstr]
getHeading :: IBalloon a -> Prelude.IO (Prelude.String)
getHeading =
  Automation.propertyGet "Heading" [] Automation.outString
setMode :: (Automation.Variant a0) => a0 -> IBalloon a -> Prelude.IO ()
setMode pmd =
  Automation.propertySet "Mode" [Automation.inVariant pmd]
getMode :: (Automation.Variant a0) => IBalloon a -> Prelude.IO (a0)
getMode = Automation.propertyGet "Mode" [] Automation.outVariant
setButton :: (Automation.Variant a0) => a0 -> IBalloon a -> Prelude.IO ()
setButton psbs =
  Automation.propertySet "Button" [Automation.inVariant psbs]
getButton :: (Automation.Variant a0) => IBalloon a -> Prelude.IO (a0)
getButton =
  Automation.propertyGet "Button" [] Automation.outVariant
setCallback :: Prelude.String -> IBalloon a -> Prelude.IO ()
setCallback pbstr =
  Automation.propertySet "Callback" [Automation.inString pbstr]
getCallback :: IBalloon a -> Prelude.IO (Prelude.String)
getCallback =
  Automation.propertyGet "Callback" [] Automation.outString
setPrivate :: Prelude.Int -> IBalloon a -> Prelude.IO ()
setPrivate plPrivate =
  Automation.propertySet "Private" [Automation.inInt plPrivate]
getPrivate :: IBalloon a -> Prelude.IO (Prelude.Int)
getPrivate = Automation.propertyGet "Private" [] Automation.outInt
setAvoidRectangle :: Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> IBalloon a -> Prelude.IO ()
setAvoidRectangle left top right bottom =
  Automation.method0 "SetAvoidRectangle" [Automation.inInt left, Automation.inInt top, Automation.inInt right, Automation.inInt bottom]
show :: (Automation.Variant a0) => IBalloon a -> Prelude.IO (a0)
show = Automation.function1 "Show" [] Automation.outVariant
close :: IBalloon a -> Prelude.IO ()
close = Automation.method0 "Close" []
-- --------------------------------------------------
-- 
-- interface BalloonCheckboxes
-- 
-- --------------------------------------------------
data BalloonCheckboxes a = BalloonCheckboxes
                            
type IBalloonCheckboxes a = IMsoDispObj (BalloonCheckboxes a)
iidIBalloonCheckboxes :: Com.IID (IBalloonCheckboxes Automation.Interface)
iidIBalloonCheckboxes =
  Com.mkIID "{000C0326-0000-0000-C000-000000000046}"
getItem3 :: Prelude.Int -> Automation.IDispatch a -> Prelude.IO (Automation.IDispatch Automation.Interface)
getItem3 idex =
  Automation.propertyGet "Item" [Automation.inInt idex] Automation.outIDispatch
setCount :: Prelude.Int -> Automation.IDispatch a -> Prelude.IO ()
setCount pccbx =
  Automation.propertySet "Count" [Automation.inInt pccbx]
-- --------------------------------------------------
-- 
-- interface BalloonCheckbox
-- 
-- --------------------------------------------------
data BalloonCheckbox a = BalloonCheckbox
                          
type IBalloonCheckbox a = IMsoDispObj (BalloonCheckbox a)
iidIBalloonCheckbox :: Com.IID (IBalloonCheckbox Automation.Interface)
iidIBalloonCheckbox =
  Com.mkIID "{000C0328-0000-0000-C000-000000000046}"
setChecked :: Prelude.Int -> IBalloonCheckbox a -> Prelude.IO ()
setChecked pvarfChecked =
  Automation.propertySet "Checked" [Automation.inInt pvarfChecked]
getChecked :: IBalloonCheckbox a -> Prelude.IO (Prelude.Int)
getChecked = Automation.propertyGet "Checked" [] Automation.outInt
-- --------------------------------------------------
-- 
-- interface BalloonLabels
-- 
-- --------------------------------------------------
data BalloonLabels a = BalloonLabels
                        
type IBalloonLabels a = IMsoDispObj (BalloonLabels a)
iidIBalloonLabels :: Com.IID (IBalloonLabels Automation.Interface)
iidIBalloonLabels =
  Com.mkIID "{000C032E-0000-0000-C000-000000000046}"
-- --------------------------------------------------
-- 
-- interface BalloonLabel
-- 
-- --------------------------------------------------
data BalloonLabel a = BalloonLabel
                       
type IBalloonLabel a = IMsoDispObj (BalloonLabel a)
iidIBalloonLabel :: Com.IID (IBalloonLabel Automation.Interface)
iidIBalloonLabel =
  Com.mkIID "{000C0330-0000-0000-C000-000000000046}"
-- --------------------------------------------------
-- 
-- interface DocumentProperty
-- 
-- --------------------------------------------------
data DocumentProperty a = DocumentProperty
                           
type IDocumentProperty a = Automation.IDispatch (DocumentProperty a)
iidIDocumentProperty :: Com.IID (IDocumentProperty Automation.Interface)
iidIDocumentProperty =
  Com.mkIID "{2DF8D04E-5BFA-101B-BDE5-00AA0044DE52}"
getName8 :: Prelude.Int -> IDocumentProperty a -> Prelude.IO (Prelude.String)
getName8 lcid =
  Automation.propertyGet "Name" [Automation.inInt lcid] Automation.outString
setName2 :: Prelude.Int -> Prelude.String -> IDocumentProperty a -> Prelude.IO ()
setName2 lcid pbstrRetVal =
  Automation.propertySet "Name" [Automation.inInt lcid, Automation.inString pbstrRetVal]
getValue :: Prelude.Int -> IDocumentProperty a -> Prelude.IO (Prelude.Int)
getValue lcid =
  Automation.propertyGet "Value" [Automation.inInt lcid] Automation.outInt
setValue :: Prelude.Int -> Prelude.Int -> IDocumentProperty a -> Prelude.IO ()
setValue lcid pvargRetVal =
  Automation.propertySet "Value" [Automation.inInt lcid, Automation.inInt pvargRetVal]
getType11 :: (Automation.Variant a0) => Prelude.Int -> IDocumentProperty a -> Prelude.IO (a0)
getType11 lcid =
  Automation.propertyGet "Type" [Automation.inInt lcid] Automation.outVariant
setType2 :: (Automation.Variant a0) => Prelude.Int -> a0 -> IDocumentProperty a -> Prelude.IO ()
setType2 lcid ptypeRetVal =
  Automation.propertySet "Type" [Automation.inInt lcid, Automation.inVariant ptypeRetVal]
getLinkToContent :: IDocumentProperty a -> Prelude.IO (Prelude.Int)
getLinkToContent =
  Automation.propertyGet "LinkToContent" [] Automation.outInt
setLinkToContent :: Prelude.Int -> IDocumentProperty a -> Prelude.IO ()
setLinkToContent pfLinkRetVal =
  Automation.propertySet "LinkToContent" [Automation.inInt pfLinkRetVal]
getLinkSource :: IDocumentProperty a -> Prelude.IO (Prelude.String)
getLinkSource =
  Automation.propertyGet "LinkSource" [] Automation.outString
setLinkSource :: Prelude.String -> IDocumentProperty a -> Prelude.IO ()
setLinkSource pbstrSourceRetVal =
  Automation.propertySet "LinkSource" [Automation.inString pbstrSourceRetVal]
-- --------------------------------------------------
-- 
-- interface DocumentProperties
-- 
-- --------------------------------------------------
data DocumentProperties a = DocumentProperties
                             
type IDocumentProperties a = Automation.IDispatch (DocumentProperties a)
iidIDocumentProperties :: Com.IID (IDocumentProperties Automation.Interface)
iidIDocumentProperties =
  Com.mkIID "{2DF8D04D-5BFA-101B-BDE5-00AA0044DE52}"
getItem7 :: Prelude.Int -> Prelude.Int -> IDocumentProperties a -> Prelude.IO (IDocumentProperty Automation.Interface)
getItem7 idex lcid =
  Automation.propertyGet "Item" [Automation.inInt idex, Automation.inInt lcid] Automation.outIDispatch
add1 :: Prelude.String -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> IDocumentProperties a -> Prelude.IO (IDocumentProperty Automation.Interface)
add1 name linkToContent type0 value linkSource lcid =
  Automation.function1 "Add" [Automation.inString name, Automation.inInt linkToContent, Automation.inInt type0, Automation.inInt value, Automation.inInt linkSource, Automation.inInt lcid] Automation.outIDispatch
data MsoFileFindOptions
 = MsoOptionsNew
 | MsoOptionsAdd
 | MsoOptionsWithin
 
marshallMsoFileFindOptions :: MsoFileFindOptions -> Prelude.IO Int.Int16
marshallMsoFileFindOptions v =
  case v of
     MsoOptionsNew -> Prelude.return (1)
     MsoOptionsAdd -> Prelude.return (2)
     MsoOptionsWithin -> Prelude.return (3)
unmarshallMsoFileFindOptions :: Int.Int16 -> Prelude.IO MsoFileFindOptions
unmarshallMsoFileFindOptions v =
  case v of
     1 -> Prelude.return (MsoOptionsNew)
     2 -> Prelude.return (MsoOptionsAdd)
     3 -> Prelude.return (MsoOptionsWithin)
     _ -> Prelude.fail (Prelude.userError "unmarshallMsoFileFindOptions: illegal enum value ")
data MsoFileFindView
 = MsoViewFileInfo
 | MsoViewPreview
 | MsoViewSummaryInfo
 
marshallMsoFileFindView :: MsoFileFindView -> Prelude.IO Int.Int16
marshallMsoFileFindView v =
  case v of
     MsoViewFileInfo -> Prelude.return (1)
     MsoViewPreview -> Prelude.return (2)
     MsoViewSummaryInfo -> Prelude.return (3)
unmarshallMsoFileFindView :: Int.Int16 -> Prelude.IO MsoFileFindView
unmarshallMsoFileFindView v =
  case v of
     1 -> Prelude.return (MsoViewFileInfo)
     2 -> Prelude.return (MsoViewPreview)
     3 -> Prelude.return (MsoViewSummaryInfo)
     _ -> Prelude.fail (Prelude.userError "unmarshallMsoFileFindView: illegal enum value ")
data MsoFileFindSortBy
 = MsoFileFindSortbyAuthor
 | MsoFileFindSortbyDateCreated
 | MsoFileFindSortbyLastSavedBy
 | MsoFileFindSortbyDateSaved
 | MsoFileFindSortbyFileName
 | MsoFileFindSortbySize
 | MsoFileFindSortbyTitle
 
marshallMsoFileFindSortBy :: MsoFileFindSortBy -> Prelude.IO Int.Int16
marshallMsoFileFindSortBy v =
  case v of
     MsoFileFindSortbyAuthor -> Prelude.return (1)
     MsoFileFindSortbyDateCreated -> Prelude.return (2)
     MsoFileFindSortbyLastSavedBy -> Prelude.return (3)
     MsoFileFindSortbyDateSaved -> Prelude.return (4)
     MsoFileFindSortbyFileName -> Prelude.return (5)
     MsoFileFindSortbySize -> Prelude.return (6)
     MsoFileFindSortbyTitle -> Prelude.return (7)
unmarshallMsoFileFindSortBy :: Int.Int16 -> Prelude.IO MsoFileFindSortBy
unmarshallMsoFileFindSortBy v =
  case v of
     1 -> Prelude.return (MsoFileFindSortbyAuthor)
     2 -> Prelude.return (MsoFileFindSortbyDateCreated)
     3 -> Prelude.return (MsoFileFindSortbyLastSavedBy)
     4 -> Prelude.return (MsoFileFindSortbyDateSaved)
     5 -> Prelude.return (MsoFileFindSortbyFileName)
     6 -> Prelude.return (MsoFileFindSortbySize)
     7 -> Prelude.return (MsoFileFindSortbyTitle)
     _ -> Prelude.fail (Prelude.userError "unmarshallMsoFileFindSortBy: illegal enum value ")
data MsoFileFindListBy
 = MsoListbyName
 | MsoListbyTitle
 
marshallMsoFileFindListBy :: MsoFileFindListBy -> Prelude.IO Int.Int16
marshallMsoFileFindListBy v =
  case v of
     MsoListbyName -> Prelude.return (1)
     MsoListbyTitle -> Prelude.return (2)
unmarshallMsoFileFindListBy :: Int.Int16 -> Prelude.IO MsoFileFindListBy
unmarshallMsoFileFindListBy v =
  case v of
     1 -> Prelude.return (MsoListbyName)
     2 -> Prelude.return (MsoListbyTitle)
     _ -> Prelude.fail (Prelude.userError "unmarshallMsoFileFindListBy: illegal enum value ")
-- --------------------------------------------------
-- 
-- interface IFoundFiles
-- 
-- --------------------------------------------------
data D_FoundFiles a = D_FoundFiles
                     
type I_FoundFiles a = Automation.IDispatch (D_FoundFiles a)
iidI_FoundFiles :: Com.IID (IFoundFiles Automation.Interface)
iidI_FoundFiles = Com.mkIID "{000C0338-0000-0000-C000-000000000046}"
getItem8 :: Prelude.Int -> I_FoundFiles a -> Prelude.IO (Prelude.String)
getItem8 idex =
  Automation.propertyGet "Item" [Automation.inInt idex] Automation.outString
-- --------------------------------------------------
-- 
-- interface IFind
-- 
-- --------------------------------------------------
data Find a = Find
               
type IFind a = Automation.IDispatch (Find a)
iidIFind :: Com.IID (IFind Automation.Interface)
iidIFind = Com.mkIID "{000C0337-0000-0000-C000-000000000046}"
getSearchPath :: IFind a -> Prelude.IO (Prelude.String)
getSearchPath =
  Automation.propertyGet "SearchPath" [] Automation.outString
getSubDir :: IFind a -> Prelude.IO (Prelude.Int)
getSubDir = Automation.propertyGet "SubDir" [] Automation.outInt
getTitle :: IFind a -> Prelude.IO (Prelude.String)
getTitle = Automation.propertyGet "Title" [] Automation.outString
getAuthor :: IFind a -> Prelude.IO (Prelude.String)
getAuthor = Automation.propertyGet "Author" [] Automation.outString
getKeywords :: IFind a -> Prelude.IO (Prelude.String)
getKeywords =
  Automation.propertyGet "Keywords" [] Automation.outString
getSubject :: IFind a -> Prelude.IO (Prelude.String)
getSubject =
  Automation.propertyGet "Subject" [] Automation.outString
getOptions :: (Automation.Variant a0) => IFind a -> Prelude.IO (a0)
getOptions =
  Automation.propertyGet "Options" [] Automation.outVariant
getMatchCase :: IFind a -> Prelude.IO (Prelude.Int)
getMatchCase =
  Automation.propertyGet "MatchCase" [] Automation.outInt
getPatternMatch :: IFind a -> Prelude.IO (Prelude.Int)
getPatternMatch =
  Automation.propertyGet "PatternMatch" [] Automation.outInt
getDateSavedFrom :: IFind a -> Prelude.IO (Prelude.Int)
getDateSavedFrom =
  Automation.propertyGet "DateSavedFrom" [] Automation.outInt
getDateSavedTo :: IFind a -> Prelude.IO (Prelude.Int)
getDateSavedTo =
  Automation.propertyGet "DateSavedTo" [] Automation.outInt
getSavedBy :: IFind a -> Prelude.IO (Prelude.String)
getSavedBy =
  Automation.propertyGet "SavedBy" [] Automation.outString
getDateCreatedFrom :: IFind a -> Prelude.IO (Prelude.Int)
getDateCreatedFrom =
  Automation.propertyGet "DateCreatedFrom" [] Automation.outInt
getDateCreatedTo :: IFind a -> Prelude.IO (Prelude.Int)
getDateCreatedTo =
  Automation.propertyGet "DateCreatedTo" [] Automation.outInt
getView :: (Automation.Variant a0) => IFind a -> Prelude.IO (a0)
getView = Automation.propertyGet "View" [] Automation.outVariant
getSortBy :: (Automation.Variant a0) => IFind a -> Prelude.IO (a0)
getSortBy =
  Automation.propertyGet "SortBy" [] Automation.outVariant
getListBy :: (Automation.Variant a0) => IFind a -> Prelude.IO (a0)
getListBy =
  Automation.propertyGet "ListBy" [] Automation.outVariant
getSelectedFile :: IFind a -> Prelude.IO (Prelude.Int)
getSelectedFile =
  Automation.propertyGet "SelectedFile" [] Automation.outInt
getResults :: IFind a -> Prelude.IO (IFoundFiles Automation.Interface)
getResults =
  Automation.propertyGet "Results" [] Automation.outIDispatch
show0 :: IFind a -> Prelude.IO (Prelude.Int)
show0 = Automation.function1 "Show" [] Automation.outInt
setSearchPath :: Prelude.String -> IFind a -> Prelude.IO ()
setSearchPath pbstr =
  Automation.propertySet "SearchPath" [Automation.inString pbstr]
setSubDir :: Prelude.Int -> IFind a -> Prelude.IO ()
setSubDir retval =
  Automation.propertySet "SubDir" [Automation.inInt retval]
setTitle :: Prelude.String -> IFind a -> Prelude.IO ()
setTitle pbstr =
  Automation.propertySet "Title" [Automation.inString pbstr]
setAuthor :: Prelude.String -> IFind a -> Prelude.IO ()
setAuthor pbstr =
  Automation.propertySet "Author" [Automation.inString pbstr]
setKeywords :: Prelude.String -> IFind a -> Prelude.IO ()
setKeywords pbstr =
  Automation.propertySet "Keywords" [Automation.inString pbstr]
setSubject :: Prelude.String -> IFind a -> Prelude.IO ()
setSubject pbstr =
  Automation.propertySet "Subject" [Automation.inString pbstr]
setOptions :: (Automation.Variant a0) => a0 -> IFind a -> Prelude.IO ()
setOptions penmOptions =
  Automation.propertySet "Options" [Automation.inVariant penmOptions]
setMatchCase :: Prelude.Int -> IFind a -> Prelude.IO ()
setMatchCase retval =
  Automation.propertySet "MatchCase" [Automation.inInt retval]
setPatternMatch :: Prelude.Int -> IFind a -> Prelude.IO ()
setPatternMatch retval =
  Automation.propertySet "PatternMatch" [Automation.inInt retval]
setDateSavedFrom :: Prelude.Int -> IFind a -> Prelude.IO ()
setDateSavedFrom pdatSavedFrom =
  Automation.propertySet "DateSavedFrom" [Automation.inInt pdatSavedFrom]
setDateSavedTo :: Prelude.Int -> IFind a -> Prelude.IO ()
setDateSavedTo pdatSavedTo =
  Automation.propertySet "DateSavedTo" [Automation.inInt pdatSavedTo]
setSavedBy :: Prelude.String -> IFind a -> Prelude.IO ()
setSavedBy pbstr =
  Automation.propertySet "SavedBy" [Automation.inString pbstr]
setDateCreatedFrom :: Prelude.Int -> IFind a -> Prelude.IO ()
setDateCreatedFrom pdatCreatedFrom =
  Automation.propertySet "DateCreatedFrom" [Automation.inInt pdatCreatedFrom]
setDateCreatedTo :: Prelude.Int -> IFind a -> Prelude.IO ()
setDateCreatedTo pdatCreatedTo =
  Automation.propertySet "DateCreatedTo" [Automation.inInt pdatCreatedTo]
setView :: (Automation.Variant a0) => a0 -> IFind a -> Prelude.IO ()
setView penmView =
  Automation.propertySet "View" [Automation.inVariant penmView]
setSortBy :: (Automation.Variant a0) => a0 -> IFind a -> Prelude.IO ()
setSortBy penmSortBy =
  Automation.propertySet "SortBy" [Automation.inVariant penmSortBy]
setListBy :: (Automation.Variant a0) => a0 -> IFind a -> Prelude.IO ()
setListBy penmListBy =
  Automation.propertySet "ListBy" [Automation.inVariant penmListBy]
setSelectedFile :: Prelude.Int -> IFind a -> Prelude.IO ()
setSelectedFile pintSelectedFile =
  Automation.propertySet "SelectedFile" [Automation.inInt pintSelectedFile]
load :: Prelude.String -> IFind a -> Prelude.IO ()
load bstrQueryName =
  Automation.method0 "Load" [Automation.inString bstrQueryName]
save :: Prelude.String -> IFind a -> Prelude.IO ()
save bstrQueryName =
  Automation.method0 "Save" [Automation.inString bstrQueryName]
delete8 :: Prelude.String -> Automation.IDispatch a -> Prelude.IO ()
delete8 bstrQueryName =
  Automation.method0 "Delete" [Automation.inString bstrQueryName]
getFileType :: IFind a -> Prelude.IO (Prelude.Int)
getFileType =
  Automation.propertyGet "FileType" [] Automation.outInt
setFileType :: Prelude.Int -> IFind a -> Prelude.IO ()
setFileType plFileType =
  Automation.propertySet "FileType" [Automation.inInt plFileType]
data MsoLastModified
 = MsoLastModifiedYesterday
 | MsoLastModifiedToday
 | MsoLastModifiedLastWeek
 | MsoLastModifiedThisWeek
 | MsoLastModifiedLastMonth
 | MsoLastModifiedThisMonth
 | MsoLastModifiedAnyTime
 
marshallMsoLastModified :: MsoLastModified -> Prelude.IO Int.Int16
marshallMsoLastModified v =
  case v of
     MsoLastModifiedYesterday -> Prelude.return (1)
     MsoLastModifiedToday -> Prelude.return (2)
     MsoLastModifiedLastWeek -> Prelude.return (3)
     MsoLastModifiedThisWeek -> Prelude.return (4)
     MsoLastModifiedLastMonth -> Prelude.return (5)
     MsoLastModifiedThisMonth -> Prelude.return (6)
     MsoLastModifiedAnyTime -> Prelude.return (7)
unmarshallMsoLastModified :: Int.Int16 -> Prelude.IO MsoLastModified
unmarshallMsoLastModified v =
  case v of
     1 -> Prelude.return (MsoLastModifiedYesterday)
     2 -> Prelude.return (MsoLastModifiedToday)
     3 -> Prelude.return (MsoLastModifiedLastWeek)
     4 -> Prelude.return (MsoLastModifiedThisWeek)
     5 -> Prelude.return (MsoLastModifiedLastMonth)
     6 -> Prelude.return (MsoLastModifiedThisMonth)
     7 -> Prelude.return (MsoLastModifiedAnyTime)
     _ -> Prelude.fail (Prelude.userError "unmarshallMsoLastModified: illegal enum value ")
data MsoSortBy
 = MsoSortByFileName
 | MsoSortBySize
 | MsoSortByFileType
 | MsoSortByLastModified
 
marshallMsoSortBy :: MsoSortBy -> Prelude.IO Int.Int16
marshallMsoSortBy v =
  case v of
     MsoSortByFileName -> Prelude.return (1)
     MsoSortBySize -> Prelude.return (2)
     MsoSortByFileType -> Prelude.return (3)
     MsoSortByLastModified -> Prelude.return (4)
unmarshallMsoSortBy :: Int.Int16 -> Prelude.IO MsoSortBy
unmarshallMsoSortBy v =
  case v of
     1 -> Prelude.return (MsoSortByFileName)
     2 -> Prelude.return (MsoSortBySize)
     3 -> Prelude.return (MsoSortByFileType)
     4 -> Prelude.return (MsoSortByLastModified)
     _ -> Prelude.fail (Prelude.userError "unmarshallMsoSortBy: illegal enum value ")
data MsoSortOrder
 = MsoSortOrderAscending
 | MsoSortOrderDescending
 
marshallMsoSortOrder :: MsoSortOrder -> Prelude.IO Int.Int16
marshallMsoSortOrder v =
  case v of
     MsoSortOrderAscending -> Prelude.return (1)
     MsoSortOrderDescending -> Prelude.return (2)
unmarshallMsoSortOrder :: Int.Int16 -> Prelude.IO MsoSortOrder
unmarshallMsoSortOrder v =
  case v of
     1 -> Prelude.return (MsoSortOrderAscending)
     2 -> Prelude.return (MsoSortOrderDescending)
     _ -> Prelude.fail (Prelude.userError "unmarshallMsoSortOrder: illegal enum value ")
data MsoConnector
 = MsoConnectorAnd
 | MsoConnectorOr
 
marshallMsoConnector :: MsoConnector -> Prelude.IO Int.Int16
marshallMsoConnector v =
  case v of
     MsoConnectorAnd -> Prelude.return (1)
     MsoConnectorOr -> Prelude.return (2)
unmarshallMsoConnector :: Int.Int16 -> Prelude.IO MsoConnector
unmarshallMsoConnector v =
  case v of
     1 -> Prelude.return (MsoConnectorAnd)
     2 -> Prelude.return (MsoConnectorOr)
     _ -> Prelude.fail (Prelude.userError "unmarshallMsoConnector: illegal enum value ")
data MsoCondition
 = MsoConditionFileTypeAllFiles
 | MsoConditionFileTypeOfficeFiles
 | MsoConditionFileTypeWordDocuments
 | MsoConditionFileTypeExcelWorkbooks
 | MsoConditionFileTypePowerPointPresentations
 | MsoConditionFileTypeBinders
 | MsoConditionFileTypeDatabases
 | MsoConditionFileTypeTemplates
 | MsoConditionIncludes
 | MsoConditionIncludesPhrase
 | MsoConditionBeginsWith
 | MsoConditionEndsWith
 | MsoConditionIncludesNearEachOther
 | MsoConditionIsExactly
 | MsoConditionIsNot
 | MsoConditionYesterday
 | MsoConditionToday
 | MsoConditionTomorrow
 | MsoConditionLastWeek
 | MsoConditionThisWeek
 | MsoConditionNextWeek
 | MsoConditionLastMonth
 | MsoConditionThisMonth
 | MsoConditionNextMonth
 | MsoConditionAnytime
 | MsoConditionAnytimeBetween
 | MsoConditionOn
 | MsoConditionOnOrAfter
 | MsoConditionOnOrBefore
 | MsoConditionInTheNext
 | MsoConditionInTheLast
 | MsoConditionEquals
 | MsoConditionDoesNotEqual
 | MsoConditionAnyNumberBetween
 | MsoConditionAtMost
 | MsoConditionAtLeast
 | MsoConditionMoreThan
 | MsoConditionLessThan
 | MsoConditionIsYes
 | MsoConditionIsNo
 
marshallMsoCondition :: MsoCondition -> Prelude.IO Int.Int16
marshallMsoCondition v =
  case v of
     MsoConditionFileTypeAllFiles -> Prelude.return (1)
     MsoConditionFileTypeOfficeFiles -> Prelude.return (2)
     MsoConditionFileTypeWordDocuments -> Prelude.return (3)
     MsoConditionFileTypeExcelWorkbooks -> Prelude.return (4)
     MsoConditionFileTypePowerPointPresentations -> Prelude.return (5)
     MsoConditionFileTypeBinders -> Prelude.return (6)
     MsoConditionFileTypeDatabases -> Prelude.return (7)
     MsoConditionFileTypeTemplates -> Prelude.return (8)
     MsoConditionIncludes -> Prelude.return (9)
     MsoConditionIncludesPhrase -> Prelude.return (10)
     MsoConditionBeginsWith -> Prelude.return (11)
     MsoConditionEndsWith -> Prelude.return (12)
     MsoConditionIncludesNearEachOther -> Prelude.return (13)
     MsoConditionIsExactly -> Prelude.return (14)
     MsoConditionIsNot -> Prelude.return (15)
     MsoConditionYesterday -> Prelude.return (16)
     MsoConditionToday -> Prelude.return (17)
     MsoConditionTomorrow -> Prelude.return (18)
     MsoConditionLastWeek -> Prelude.return (19)
     MsoConditionThisWeek -> Prelude.return (20)
     MsoConditionNextWeek -> Prelude.return (21)
     MsoConditionLastMonth -> Prelude.return (22)
     MsoConditionThisMonth -> Prelude.return (23)
     MsoConditionNextMonth -> Prelude.return (24)
     MsoConditionAnytime -> Prelude.return (25)
     MsoConditionAnytimeBetween -> Prelude.return (26)
     MsoConditionOn -> Prelude.return (27)
     MsoConditionOnOrAfter -> Prelude.return (28)
     MsoConditionOnOrBefore -> Prelude.return (29)
     MsoConditionInTheNext -> Prelude.return (30)
     MsoConditionInTheLast -> Prelude.return (31)
     MsoConditionEquals -> Prelude.return (32)
     MsoConditionDoesNotEqual -> Prelude.return (33)
     MsoConditionAnyNumberBetween -> Prelude.return (34)
     MsoConditionAtMost -> Prelude.return (35)
     MsoConditionAtLeast -> Prelude.return (36)
     MsoConditionMoreThan -> Prelude.return (37)
     MsoConditionLessThan -> Prelude.return (38)
     MsoConditionIsYes -> Prelude.return (39)
     MsoConditionIsNo -> Prelude.return (40)
unmarshallMsoCondition :: Int.Int16 -> Prelude.IO MsoCondition
unmarshallMsoCondition v =
  case v of
     1 -> Prelude.return (MsoConditionFileTypeAllFiles)
     2 -> Prelude.return (MsoConditionFileTypeOfficeFiles)
     3 -> Prelude.return (MsoConditionFileTypeWordDocuments)
     4 -> Prelude.return (MsoConditionFileTypeExcelWorkbooks)
     5 -> Prelude.return (MsoConditionFileTypePowerPointPresentations)
     6 -> Prelude.return (MsoConditionFileTypeBinders)
     7 -> Prelude.return (MsoConditionFileTypeDatabases)
     8 -> Prelude.return (MsoConditionFileTypeTemplates)
     9 -> Prelude.return (MsoConditionIncludes)
     10 -> Prelude.return (MsoConditionIncludesPhrase)
     11 -> Prelude.return (MsoConditionBeginsWith)
     12 -> Prelude.return (MsoConditionEndsWith)
     13 -> Prelude.return (MsoConditionIncludesNearEachOther)
     14 -> Prelude.return (MsoConditionIsExactly)
     15 -> Prelude.return (MsoConditionIsNot)
     16 -> Prelude.return (MsoConditionYesterday)
     17 -> Prelude.return (MsoConditionToday)
     18 -> Prelude.return (MsoConditionTomorrow)
     19 -> Prelude.return (MsoConditionLastWeek)
     20 -> Prelude.return (MsoConditionThisWeek)
     21 -> Prelude.return (MsoConditionNextWeek)
     22 -> Prelude.return (MsoConditionLastMonth)
     23 -> Prelude.return (MsoConditionThisMonth)
     24 -> Prelude.return (MsoConditionNextMonth)
     25 -> Prelude.return (MsoConditionAnytime)
     26 -> Prelude.return (MsoConditionAnytimeBetween)
     27 -> Prelude.return (MsoConditionOn)
     28 -> Prelude.return (MsoConditionOnOrAfter)
     29 -> Prelude.return (MsoConditionOnOrBefore)
     30 -> Prelude.return (MsoConditionInTheNext)
     31 -> Prelude.return (MsoConditionInTheLast)
     32 -> Prelude.return (MsoConditionEquals)
     33 -> Prelude.return (MsoConditionDoesNotEqual)
     34 -> Prelude.return (MsoConditionAnyNumberBetween)
     35 -> Prelude.return (MsoConditionAtMost)
     36 -> Prelude.return (MsoConditionAtLeast)
     37 -> Prelude.return (MsoConditionMoreThan)
     38 -> Prelude.return (MsoConditionLessThan)
     39 -> Prelude.return (MsoConditionIsYes)
     40 -> Prelude.return (MsoConditionIsNo)
     _ -> Prelude.fail (Prelude.userError "unmarshallMsoCondition: illegal enum value ")
data MsoFileType
 = MsoFileTypeAllFiles
 | MsoFileTypeOfficeFiles
 | MsoFileTypeWordDocuments
 | MsoFileTypeExcelWorkbooks
 | MsoFileTypePowerPointPresentations
 | MsoFileTypeBinders
 | MsoFileTypeDatabases
 | MsoFileTypeTemplates
 
marshallMsoFileType :: MsoFileType -> Prelude.IO Int.Int16
marshallMsoFileType v =
  case v of
     MsoFileTypeAllFiles -> Prelude.return (1)
     MsoFileTypeOfficeFiles -> Prelude.return (2)
     MsoFileTypeWordDocuments -> Prelude.return (3)
     MsoFileTypeExcelWorkbooks -> Prelude.return (4)
     MsoFileTypePowerPointPresentations -> Prelude.return (5)
     MsoFileTypeBinders -> Prelude.return (6)
     MsoFileTypeDatabases -> Prelude.return (7)
     MsoFileTypeTemplates -> Prelude.return (8)
unmarshallMsoFileType :: Int.Int16 -> Prelude.IO MsoFileType
unmarshallMsoFileType v =
  case v of
     1 -> Prelude.return (MsoFileTypeAllFiles)
     2 -> Prelude.return (MsoFileTypeOfficeFiles)
     3 -> Prelude.return (MsoFileTypeWordDocuments)
     4 -> Prelude.return (MsoFileTypeExcelWorkbooks)
     5 -> Prelude.return (MsoFileTypePowerPointPresentations)
     6 -> Prelude.return (MsoFileTypeBinders)
     7 -> Prelude.return (MsoFileTypeDatabases)
     8 -> Prelude.return (MsoFileTypeTemplates)
     _ -> Prelude.fail (Prelude.userError "unmarshallMsoFileType: illegal enum value ")
-- --------------------------------------------------
-- 
-- interface FoundFiles
-- 
-- --------------------------------------------------
data FoundFiles a = FoundFiles
                     
type IFoundFiles a = IMsoDispObj (FoundFiles a)
iidIFoundFiles :: Com.IID (IFoundFiles Automation.Interface)
iidIFoundFiles = Com.mkIID "{000C0331-0000-0000-C000-000000000046}"
getItem9 :: Prelude.Int -> Prelude.Int -> IFoundFiles a -> Prelude.IO (Prelude.String)
getItem9 idex lcid =
  Automation.propertyGet "Item" [Automation.inInt idex, Automation.inInt lcid] Automation.outString
-- --------------------------------------------------
-- 
-- interface PropertyTest
-- 
-- --------------------------------------------------
data PropertyTest a = PropertyTest
                       
type IPropertyTest a = IMsoDispObj (PropertyTest a)
iidIPropertyTest :: Com.IID (IPropertyTest Automation.Interface)
iidIPropertyTest =
  Com.mkIID "{000C0333-0000-0000-C000-000000000046}"
getCondition :: (Automation.Variant a0) => IPropertyTest a -> Prelude.IO (a0)
getCondition =
  Automation.propertyGet "Condition" [] Automation.outVariant
getValue0 :: IPropertyTest a -> Prelude.IO (Prelude.Int)
getValue0 = Automation.propertyGet "Value" [] Automation.outInt
getSecondValue :: IPropertyTest a -> Prelude.IO (Prelude.Int)
getSecondValue =
  Automation.propertyGet "SecondValue" [] Automation.outInt
getConnector1 :: (Automation.Variant a0) => IPropertyTest a -> Prelude.IO (a0)
getConnector1 =
  Automation.propertyGet "Connector" [] Automation.outVariant
-- --------------------------------------------------
-- 
-- interface PropertyTests
-- 
-- --------------------------------------------------
data PropertyTests a = PropertyTests
                        
type IPropertyTests a = IMsoDispObj (PropertyTests a)
iidIPropertyTests :: Com.IID (IPropertyTests Automation.Interface)
iidIPropertyTests =
  Com.mkIID "{000C0334-0000-0000-C000-000000000046}"
getItem10 :: Prelude.Int -> Prelude.Int -> IPropertyTests a -> Prelude.IO (IPropertyTest Automation.Interface)
getItem10 idex lcid =
  Automation.propertyGet "Item" [Automation.inInt idex, Automation.inInt lcid] Automation.outIDispatch
add2 :: (Automation.Variant a0, Automation.Variant a1) => Prelude.String -> a0 -> Prelude.Int -> Prelude.Int -> a1 -> IPropertyTests a -> Prelude.IO ()
add2 name condition value secondValue connector =
  Automation.method0 "Add" [Automation.inString name, Automation.inVariant condition, Automation.inInt value, Automation.inInt secondValue, Automation.inVariant connector]
remove :: Prelude.Int -> IPropertyTests a -> Prelude.IO ()
remove idex = Automation.method0 "Remove" [Automation.inInt idex]
-- --------------------------------------------------
-- 
-- interface FileSearch
-- 
-- --------------------------------------------------
data FileSearch a = FileSearch
                     
type IFileSearch a = IMsoDispObj (FileSearch a)
iidIFileSearch :: Com.IID (IFileSearch Automation.Interface)
iidIFileSearch = Com.mkIID "{000C0332-0000-0000-C000-000000000046}"
getSearchSubFolders :: IFileSearch a -> Prelude.IO (Prelude.Int)
getSearchSubFolders =
  Automation.propertyGet "SearchSubFolders" [] Automation.outInt
setSearchSubFolders :: Prelude.Int -> IFileSearch a -> Prelude.IO ()
setSearchSubFolders searchSubFoldersRetVal =
  Automation.propertySet "SearchSubFolders" [Automation.inInt searchSubFoldersRetVal]
getMatchTextExactly :: IFileSearch a -> Prelude.IO (Prelude.Int)
getMatchTextExactly =
  Automation.propertyGet "MatchTextExactly" [] Automation.outInt
setMatchTextExactly :: Prelude.Int -> IFileSearch a -> Prelude.IO ()
setMatchTextExactly matchTextRetVal =
  Automation.propertySet "MatchTextExactly" [Automation.inInt matchTextRetVal]
getMatchAllWordForms :: IFileSearch a -> Prelude.IO (Prelude.Int)
getMatchAllWordForms =
  Automation.propertyGet "MatchAllWordForms" [] Automation.outInt
setMatchAllWordForms :: Prelude.Int -> IFileSearch a -> Prelude.IO ()
setMatchAllWordForms matchAllWordFormsRetVal =
  Automation.propertySet "MatchAllWordForms" [Automation.inInt matchAllWordFormsRetVal]
getFileType0 :: (Automation.Variant a0) => IFileSearch a -> Prelude.IO (a0)
getFileType0 =
  Automation.propertyGet "FileType" [] Automation.outVariant
setFileType0 :: (Automation.Variant a0) => a0 -> IFileSearch a -> Prelude.IO ()
setFileType0 fileTypeRetVal =
  Automation.propertySet "FileType" [Automation.inVariant fileTypeRetVal]
getLastModified :: (Automation.Variant a0) => IFileSearch a -> Prelude.IO (a0)
getLastModified =
  Automation.propertyGet "LastModified" [] Automation.outVariant
setLastModified :: (Automation.Variant a0) => a0 -> IFileSearch a -> Prelude.IO ()
setLastModified lastModifiedRetVal =
  Automation.propertySet "LastModified" [Automation.inVariant lastModifiedRetVal]
getTextOrProperty :: IFileSearch a -> Prelude.IO (Prelude.String)
getTextOrProperty =
  Automation.propertyGet "TextOrProperty" [] Automation.outString
setTextOrProperty :: Prelude.String -> IFileSearch a -> Prelude.IO ()
setTextOrProperty textOrProperty =
  Automation.propertySet "TextOrProperty" [Automation.inString textOrProperty]
getLookIn :: IFileSearch a -> Prelude.IO (Prelude.String)
getLookIn = Automation.propertyGet "LookIn" [] Automation.outString
setLookIn :: Prelude.String -> IFileSearch a -> Prelude.IO ()
setLookIn lookInRetVal =
  Automation.propertySet "LookIn" [Automation.inString lookInRetVal]
execute4 :: (Automation.Variant a0, Automation.Variant a1) => a0 -> a1 -> Prelude.Int -> Automation.IDispatch a -> Prelude.IO (Prelude.Int)
execute4 sortBy sortOrder alwaysAccurate =
  Automation.function1 "Execute" [Automation.inVariant sortBy, Automation.inVariant sortOrder, Automation.inInt alwaysAccurate] Automation.outInt
newSearch :: IFileSearch a -> Prelude.IO ()
newSearch = Automation.method0 "NewSearch" []
getFoundFiles :: IFileSearch a -> Prelude.IO (IFoundFiles Automation.Interface)
getFoundFiles =
  Automation.propertyGet "FoundFiles" [] Automation.outIDispatch
getPropertyTests :: IFileSearch a -> Prelude.IO (IPropertyTests Automation.Interface)
getPropertyTests =
  Automation.propertyGet "PropertyTests" [] Automation.outIDispatch
