module PowerPoint where

import qualified Prelude
import qualified Automation (IDispatch, Interface, outIUnknown, 
                             propertyGetID, outInt, inInt, functionID1, outIDispatch, 
                             outString, inString, propertySetID, methodID0, inArray, Variant, 
                             inVariant, inIDispatch, outFloat, inFloat, outVariant, methodID2, 
                             methodID8, inIUnknown, method0)
import qualified Com (IID, mkIID, IUnknown, CLSID, mkCLSID, Interface )
import qualified Int ( Int16 )
import qualified Office (ICommandBars, IAssistant, IFileSearch, 
                        IFind, IShapeRange, IShapes, IShape, IFreeformBuilder, 
                        IAdjustments, ICalloutFormat, IConnectorFormat, IFillFormat, 
                        IGroupShapes, ILineFormat, IShapeNodes, IPictureFormat, 
                        IShadowFormat, ITextEffectFormat, ITextFrame, IThreeDFormat, 
                        IShapeNode)
import qualified VBIDE (IVBE, IVBProject)
{-
data PpWindowState
 = PpWindowNormal
 | PpWindowMinimized
 | PpWindowMaximized
 
marshallPpWindowState :: PpWindowState -> Prelude.IO Int.Int16
marshallPpWindowState v =
  case v of
     PpWindowNormal -> Prelude.return (1)
     PpWindowMinimized -> Prelude.return (2)
     PpWindowMaximized -> Prelude.return (3)
unmarshallPpWindowState :: Int.Int16 -> Prelude.IO PpWindowState
unmarshallPpWindowState v =
  case v of
     1 -> Prelude.return (PpWindowNormal)
     2 -> Prelude.return (PpWindowMinimized)
     3 -> Prelude.return (PpWindowMaximized)
     _ -> Prelude.fail (Prelude.userError "unmarshallPpWindowState: illegal enum value ")
data PpArrangeStyle
 = PpArrangeTiled
 | PpArrangeCascade
 
marshallPpArrangeStyle :: PpArrangeStyle -> Prelude.IO Int.Int16
marshallPpArrangeStyle v =
  case v of
     PpArrangeTiled -> Prelude.return (1)
     PpArrangeCascade -> Prelude.return (2)
unmarshallPpArrangeStyle :: Int.Int16 -> Prelude.IO PpArrangeStyle
unmarshallPpArrangeStyle v =
  case v of
     1 -> Prelude.return (PpArrangeTiled)
     2 -> Prelude.return (PpArrangeCascade)
     _ -> Prelude.fail (Prelude.userError "unmarshallPpArrangeStyle: illegal enum value ")
data PpViewType
 = PpViewSlide
 | PpViewSlideMaster
 | PpViewNotesPage
 | PpViewHandoutMaster
 | PpViewNotesMaster
 | PpViewOutline
 | PpViewSlideSorter
 | PpViewTitleMaster
 
marshallPpViewType :: PpViewType -> Prelude.IO Int.Int16
marshallPpViewType v =
  case v of
     PpViewSlide -> Prelude.return (1)
     PpViewSlideMaster -> Prelude.return (2)
     PpViewNotesPage -> Prelude.return (3)
     PpViewHandoutMaster -> Prelude.return (4)
     PpViewNotesMaster -> Prelude.return (5)
     PpViewOutline -> Prelude.return (6)
     PpViewSlideSorter -> Prelude.return (7)
     PpViewTitleMaster -> Prelude.return (8)
unmarshallPpViewType :: Int.Int16 -> Prelude.IO PpViewType
unmarshallPpViewType v =
  case v of
     1 -> Prelude.return (PpViewSlide)
     2 -> Prelude.return (PpViewSlideMaster)
     3 -> Prelude.return (PpViewNotesPage)
     4 -> Prelude.return (PpViewHandoutMaster)
     5 -> Prelude.return (PpViewNotesMaster)
     6 -> Prelude.return (PpViewOutline)
     7 -> Prelude.return (PpViewSlideSorter)
     8 -> Prelude.return (PpViewTitleMaster)
     _ -> Prelude.fail (Prelude.userError "unmarshallPpViewType: illegal enum value ")
data PpColorSchemeIndex
 = PpSchemeColorMixed
 | PpNotSchemeColor
 | PpBackground
 | PpForeground
 | PpShadow
 | PpTitle
 | PpFill
 | PpAccent1
 | PpAccent2
 | PpAccent3
 
marshallPpColorSchemeIndex :: PpColorSchemeIndex -> Prelude.IO Int.Int16
marshallPpColorSchemeIndex v =
  case v of
     PpSchemeColorMixed -> Prelude.return ((-2))
     PpNotSchemeColor -> Prelude.return (0)
     PpBackground -> Prelude.return (1)
     PpForeground -> Prelude.return (2)
     PpShadow -> Prelude.return (3)
     PpTitle -> Prelude.return (4)
     PpFill -> Prelude.return (5)
     PpAccent1 -> Prelude.return (6)
     PpAccent2 -> Prelude.return (7)
     PpAccent3 -> Prelude.return (8)
unmarshallPpColorSchemeIndex :: Int.Int16 -> Prelude.IO PpColorSchemeIndex
unmarshallPpColorSchemeIndex v =
  case v of
     (-2) -> Prelude.return (PpSchemeColorMixed)
     0 -> Prelude.return (PpNotSchemeColor)
     1 -> Prelude.return (PpBackground)
     2 -> Prelude.return (PpForeground)
     3 -> Prelude.return (PpShadow)
     4 -> Prelude.return (PpTitle)
     5 -> Prelude.return (PpFill)
     6 -> Prelude.return (PpAccent1)
     7 -> Prelude.return (PpAccent2)
     8 -> Prelude.return (PpAccent3)
     _ -> Prelude.fail (Prelude.userError "unmarshallPpColorSchemeIndex: illegal enum value ")
data PpSlideSizeType
 = PpSlideSizeOnScreen
 | PpSlideSizeLetterPaper
 | PpSlideSizeA4Paper
 | PpSlideSize35MM
 | PpSlideSizeOverhead
 | PpSlideSizeBanner
 | PpSlideSizeCustom
 
marshallPpSlideSizeType :: PpSlideSizeType -> Prelude.IO Int.Int16
marshallPpSlideSizeType v =
  case v of
     PpSlideSizeOnScreen -> Prelude.return (1)
     PpSlideSizeLetterPaper -> Prelude.return (2)
     PpSlideSizeA4Paper -> Prelude.return (3)
     PpSlideSize35MM -> Prelude.return (4)
     PpSlideSizeOverhead -> Prelude.return (5)
     PpSlideSizeBanner -> Prelude.return (6)
     PpSlideSizeCustom -> Prelude.return (7)
unmarshallPpSlideSizeType :: Int.Int16 -> Prelude.IO PpSlideSizeType
unmarshallPpSlideSizeType v =
  case v of
     1 -> Prelude.return (PpSlideSizeOnScreen)
     2 -> Prelude.return (PpSlideSizeLetterPaper)
     3 -> Prelude.return (PpSlideSizeA4Paper)
     4 -> Prelude.return (PpSlideSize35MM)
     5 -> Prelude.return (PpSlideSizeOverhead)
     6 -> Prelude.return (PpSlideSizeBanner)
     7 -> Prelude.return (PpSlideSizeCustom)
     _ -> Prelude.fail (Prelude.userError "unmarshallPpSlideSizeType: illegal enum value ")
data PpSaveAsFileType
 = PpSaveAsPresentation
 | PpSaveAsPowerPoint7
 | PpSaveAsPowerPoint4
 | PpSaveAsPowerPoint3
 | PpSaveAsTemplate
 | PpSaveAsRTF
 | PpSaveAsShow
 | PpSaveAsAddIn
 | PpSaveAsWizard
 | PpSaveAsPowerPoint4FarEast
 | PpSaveAsDefault
 
marshallPpSaveAsFileType :: PpSaveAsFileType -> Prelude.IO Int.Int16
marshallPpSaveAsFileType v =
  case v of
     PpSaveAsPresentation -> Prelude.return (1)
     PpSaveAsPowerPoint7 -> Prelude.return (2)
     PpSaveAsPowerPoint4 -> Prelude.return (3)
     PpSaveAsPowerPoint3 -> Prelude.return (4)
     PpSaveAsTemplate -> Prelude.return (5)
     PpSaveAsRTF -> Prelude.return (6)
     PpSaveAsShow -> Prelude.return (7)
     PpSaveAsAddIn -> Prelude.return (8)
     PpSaveAsWizard -> Prelude.return (9)
     PpSaveAsPowerPoint4FarEast -> Prelude.return (10)
     PpSaveAsDefault -> Prelude.return (11)
unmarshallPpSaveAsFileType :: Int.Int16 -> Prelude.IO PpSaveAsFileType
unmarshallPpSaveAsFileType v =
  case v of
     1 -> Prelude.return (PpSaveAsPresentation)
     2 -> Prelude.return (PpSaveAsPowerPoint7)
     3 -> Prelude.return (PpSaveAsPowerPoint4)
     4 -> Prelude.return (PpSaveAsPowerPoint3)
     5 -> Prelude.return (PpSaveAsTemplate)
     6 -> Prelude.return (PpSaveAsRTF)
     7 -> Prelude.return (PpSaveAsShow)
     8 -> Prelude.return (PpSaveAsAddIn)
     9 -> Prelude.return (PpSaveAsWizard)
     10 -> Prelude.return (PpSaveAsPowerPoint4FarEast)
     11 -> Prelude.return (PpSaveAsDefault)
     _ -> Prelude.fail (Prelude.userError "unmarshallPpSaveAsFileType: illegal enum value ")
data PpTextStyleType
 = PpDefaultStyle
 | PpTitleStyle
 | PpBodyStyle
 
marshallPpTextStyleType :: PpTextStyleType -> Prelude.IO Int.Int16
marshallPpTextStyleType v =
  case v of
     PpDefaultStyle -> Prelude.return (1)
     PpTitleStyle -> Prelude.return (2)
     PpBodyStyle -> Prelude.return (3)
unmarshallPpTextStyleType :: Int.Int16 -> Prelude.IO PpTextStyleType
unmarshallPpTextStyleType v =
  case v of
     1 -> Prelude.return (PpDefaultStyle)
     2 -> Prelude.return (PpTitleStyle)
     3 -> Prelude.return (PpBodyStyle)
     _ -> Prelude.fail (Prelude.userError "unmarshallPpTextStyleType: illegal enum value ")
data PpSlideLayout
 = PpLayoutMixed
 | PpLayoutTitle
 | PpLayoutText
 | PpLayoutTwoColumnText
 | PpLayoutTable
 | PpLayoutTextAndChart
 | PpLayoutChartAndText
 | PpLayoutOrgchart
 | PpLayoutChart
 | PpLayoutTextAndClipart
 | PpLayoutClipartAndText
 | PpLayoutTitleOnly
 | PpLayoutBlank
 | PpLayoutTextAndObject
 | PpLayoutObjectAndText
 | PpLayoutLargeObject
 | PpLayoutObject
 | PpLayoutTextAndMediaClip
 | PpLayoutMediaClipAndText
 | PpLayoutObjectOverText
 | PpLayoutTextOverObject
 | PpLayoutTextAndTwoObjects
 | PpLayoutTwoObjectsAndText
 | PpLayoutTwoObjectsOverText
 | PpLayoutFourObjects
 | PpLayoutVerticalText
 | PpLayoutClipArtAndVerticalText
 | PpLayoutVerticalTitleAndText
 | PpLayoutVerticalTitleAndTextOverChart
 
marshallPpSlideLayout :: PpSlideLayout -> Prelude.IO Int.Int16
marshallPpSlideLayout v =
  case v of
     PpLayoutMixed -> Prelude.return ((-2))
     PpLayoutTitle -> Prelude.return (1)
     PpLayoutText -> Prelude.return (2)
     PpLayoutTwoColumnText -> Prelude.return (3)
     PpLayoutTable -> Prelude.return (4)
     PpLayoutTextAndChart -> Prelude.return (5)
     PpLayoutChartAndText -> Prelude.return (6)
     PpLayoutOrgchart -> Prelude.return (7)
     PpLayoutChart -> Prelude.return (8)
     PpLayoutTextAndClipart -> Prelude.return (9)
     PpLayoutClipartAndText -> Prelude.return (10)
     PpLayoutTitleOnly -> Prelude.return (11)
     PpLayoutBlank -> Prelude.return (12)
     PpLayoutTextAndObject -> Prelude.return (13)
     PpLayoutObjectAndText -> Prelude.return (14)
     PpLayoutLargeObject -> Prelude.return (15)
     PpLayoutObject -> Prelude.return (16)
     PpLayoutTextAndMediaClip -> Prelude.return (17)
     PpLayoutMediaClipAndText -> Prelude.return (18)
     PpLayoutObjectOverText -> Prelude.return (19)
     PpLayoutTextOverObject -> Prelude.return (20)
     PpLayoutTextAndTwoObjects -> Prelude.return (21)
     PpLayoutTwoObjectsAndText -> Prelude.return (22)
     PpLayoutTwoObjectsOverText -> Prelude.return (23)
     PpLayoutFourObjects -> Prelude.return (24)
     PpLayoutVerticalText -> Prelude.return (25)
     PpLayoutClipArtAndVerticalText -> Prelude.return (26)
     PpLayoutVerticalTitleAndText -> Prelude.return (27)
     PpLayoutVerticalTitleAndTextOverChart -> Prelude.return (28)
unmarshallPpSlideLayout :: Int.Int16 -> Prelude.IO PpSlideLayout
unmarshallPpSlideLayout v =
  case v of
     (-2) -> Prelude.return (PpLayoutMixed)
     1 -> Prelude.return (PpLayoutTitle)
     2 -> Prelude.return (PpLayoutText)
     3 -> Prelude.return (PpLayoutTwoColumnText)
     4 -> Prelude.return (PpLayoutTable)
     5 -> Prelude.return (PpLayoutTextAndChart)
     6 -> Prelude.return (PpLayoutChartAndText)
     7 -> Prelude.return (PpLayoutOrgchart)
     8 -> Prelude.return (PpLayoutChart)
     9 -> Prelude.return (PpLayoutTextAndClipart)
     10 -> Prelude.return (PpLayoutClipartAndText)
     11 -> Prelude.return (PpLayoutTitleOnly)
     12 -> Prelude.return (PpLayoutBlank)
     13 -> Prelude.return (PpLayoutTextAndObject)
     14 -> Prelude.return (PpLayoutObjectAndText)
     15 -> Prelude.return (PpLayoutLargeObject)
     16 -> Prelude.return (PpLayoutObject)
     17 -> Prelude.return (PpLayoutTextAndMediaClip)
     18 -> Prelude.return (PpLayoutMediaClipAndText)
     19 -> Prelude.return (PpLayoutObjectOverText)
     20 -> Prelude.return (PpLayoutTextOverObject)
     21 -> Prelude.return (PpLayoutTextAndTwoObjects)
     22 -> Prelude.return (PpLayoutTwoObjectsAndText)
     23 -> Prelude.return (PpLayoutTwoObjectsOverText)
     24 -> Prelude.return (PpLayoutFourObjects)
     25 -> Prelude.return (PpLayoutVerticalText)
     26 -> Prelude.return (PpLayoutClipArtAndVerticalText)
     27 -> Prelude.return (PpLayoutVerticalTitleAndText)
     28 -> Prelude.return (PpLayoutVerticalTitleAndTextOverChart)
     _ -> Prelude.fail (Prelude.userError "unmarshallPpSlideLayout: illegal enum value ")
data PpEntryEffect
 = PpEffectMixed
 | PpEffectNone
 | PpEffectCut
 | PpEffectCutThroughBlack
 | PpEffectRandom
 | PpEffectBlindsHorizontal
 | PpEffectBlindsVertical
 | PpEffectCheckerboardAcross
 | PpEffectCheckerboardDown
 | PpEffectCoverLeft
 | PpEffectCoverUp
 | PpEffectCoverRight
 | PpEffectCoverDown
 | PpEffectCoverLeftUp
 | PpEffectCoverRightUp
 | PpEffectCoverLeftDown
 | PpEffectCoverRightDown
 | PpEffectDissolve
 | PpEffectFade
 | PpEffectUncoverLeft
 | PpEffectUncoverUp
 | PpEffectUncoverRight
 | PpEffectUncoverDown
 | PpEffectUncoverLeftUp
 | PpEffectUncoverRightUp
 | PpEffectUncoverLeftDown
 | PpEffectUncoverRightDown
 | PpEffectRandomBarsHorizontal
 | PpEffectRandomBarsVertical
 | PpEffectStripsUpLeft
 | PpEffectStripsUpRight
 | PpEffectStripsDownLeft
 | PpEffectStripsDownRight
 | PpEffectStripsLeftUp
 | PpEffectStripsRightUp
 | PpEffectStripsLeftDown
 | PpEffectStripsRightDown
 | PpEffectWipeLeft
 | PpEffectWipeUp
 | PpEffectWipeRight
 | PpEffectWipeDown
 | PpEffectBoxOut
 | PpEffectBoxIn
 | PpEffectFlyFromLeft
 | PpEffectFlyFromTop
 | PpEffectFlyFromRight
 | PpEffectFlyFromBottom
 | PpEffectFlyFromTopLeft
 | PpEffectFlyFromTopRight
 | PpEffectFlyFromBottomLeft
 | PpEffectFlyFromBottomRight
 | PpEffectPeekFromLeft
 | PpEffectPeekFromDown
 | PpEffectPeekFromRight
 | PpEffectPeekFromUp
 | PpEffectCrawlFromLeft
 | PpEffectCrawlFromUp
 | PpEffectCrawlFromRight
 | PpEffectCrawlFromDown
 | PpEffectZoomIn
 | PpEffectZoomInSlightly
 | PpEffectZoomOut
 | PpEffectZoomOutSlightly
 | PpEffectZoomCenter
 | PpEffectZoomBottom
 | PpEffectStretchAcross
 | PpEffectStretchLeft
 | PpEffectStretchUp
 | PpEffectStretchRight
 | PpEffectStretchDown
 | PpEffectSwivel
 | PpEffectSpiral
 | PpEffectSplitHorizontalOut
 | PpEffectSplitHorizontalIn
 | PpEffectSplitVerticalOut
 | PpEffectSplitVerticalIn
 | PpEffectFlashOnceFast
 | PpEffectFlashOnceMedium
 | PpEffectFlashOnceSlow
 | PpEffectAppear
 
marshallPpEntryEffect :: PpEntryEffect -> Prelude.IO Int.Int16
marshallPpEntryEffect v =
  case v of
     PpEffectMixed -> Prelude.return ((-2))
     PpEffectNone -> Prelude.return (0)
     PpEffectCut -> Prelude.return (257)
     PpEffectCutThroughBlack -> Prelude.return (258)
     PpEffectRandom -> Prelude.return (513)
     PpEffectBlindsHorizontal -> Prelude.return (769)
     PpEffectBlindsVertical -> Prelude.return (770)
     PpEffectCheckerboardAcross -> Prelude.return (1025)
     PpEffectCheckerboardDown -> Prelude.return (1026)
     PpEffectCoverLeft -> Prelude.return (1281)
     PpEffectCoverUp -> Prelude.return (1282)
     PpEffectCoverRight -> Prelude.return (1283)
     PpEffectCoverDown -> Prelude.return (1284)
     PpEffectCoverLeftUp -> Prelude.return (1285)
     PpEffectCoverRightUp -> Prelude.return (1286)
     PpEffectCoverLeftDown -> Prelude.return (1287)
     PpEffectCoverRightDown -> Prelude.return (1288)
     PpEffectDissolve -> Prelude.return (1537)
     PpEffectFade -> Prelude.return (1793)
     PpEffectUncoverLeft -> Prelude.return (2049)
     PpEffectUncoverUp -> Prelude.return (2050)
     PpEffectUncoverRight -> Prelude.return (2051)
     PpEffectUncoverDown -> Prelude.return (2052)
     PpEffectUncoverLeftUp -> Prelude.return (2053)
     PpEffectUncoverRightUp -> Prelude.return (2054)
     PpEffectUncoverLeftDown -> Prelude.return (2055)
     PpEffectUncoverRightDown -> Prelude.return (2056)
     PpEffectRandomBarsHorizontal -> Prelude.return (2305)
     PpEffectRandomBarsVertical -> Prelude.return (2306)
     PpEffectStripsUpLeft -> Prelude.return (2561)
     PpEffectStripsUpRight -> Prelude.return (2562)
     PpEffectStripsDownLeft -> Prelude.return (2563)
     PpEffectStripsDownRight -> Prelude.return (2564)
     PpEffectStripsLeftUp -> Prelude.return (2565)
     PpEffectStripsRightUp -> Prelude.return (2566)
     PpEffectStripsLeftDown -> Prelude.return (2567)
     PpEffectStripsRightDown -> Prelude.return (2568)
     PpEffectWipeLeft -> Prelude.return (2817)
     PpEffectWipeUp -> Prelude.return (2818)
     PpEffectWipeRight -> Prelude.return (2819)
     PpEffectWipeDown -> Prelude.return (2820)
     PpEffectBoxOut -> Prelude.return (3073)
     PpEffectBoxIn -> Prelude.return (3074)
     PpEffectFlyFromLeft -> Prelude.return (3329)
     PpEffectFlyFromTop -> Prelude.return (3330)
     PpEffectFlyFromRight -> Prelude.return (3331)
     PpEffectFlyFromBottom -> Prelude.return (3332)
     PpEffectFlyFromTopLeft -> Prelude.return (3333)
     PpEffectFlyFromTopRight -> Prelude.return (3334)
     PpEffectFlyFromBottomLeft -> Prelude.return (3335)
     PpEffectFlyFromBottomRight -> Prelude.return (3336)
     PpEffectPeekFromLeft -> Prelude.return (3337)
     PpEffectPeekFromDown -> Prelude.return (3338)
     PpEffectPeekFromRight -> Prelude.return (3339)
     PpEffectPeekFromUp -> Prelude.return (3340)
     PpEffectCrawlFromLeft -> Prelude.return (3341)
     PpEffectCrawlFromUp -> Prelude.return (3342)
     PpEffectCrawlFromRight -> Prelude.return (3343)
     PpEffectCrawlFromDown -> Prelude.return (3344)
     PpEffectZoomIn -> Prelude.return (3345)
     PpEffectZoomInSlightly -> Prelude.return (3346)
     PpEffectZoomOut -> Prelude.return (3347)
     PpEffectZoomOutSlightly -> Prelude.return (3348)
     PpEffectZoomCenter -> Prelude.return (3349)
     PpEffectZoomBottom -> Prelude.return (3350)
     PpEffectStretchAcross -> Prelude.return (3351)
     PpEffectStretchLeft -> Prelude.return (3352)
     PpEffectStretchUp -> Prelude.return (3353)
     PpEffectStretchRight -> Prelude.return (3354)
     PpEffectStretchDown -> Prelude.return (3355)
     PpEffectSwivel -> Prelude.return (3356)
     PpEffectSpiral -> Prelude.return (3357)
     PpEffectSplitHorizontalOut -> Prelude.return (3585)
     PpEffectSplitHorizontalIn -> Prelude.return (3586)
     PpEffectSplitVerticalOut -> Prelude.return (3587)
     PpEffectSplitVerticalIn -> Prelude.return (3588)
     PpEffectFlashOnceFast -> Prelude.return (3841)
     PpEffectFlashOnceMedium -> Prelude.return (3842)
     PpEffectFlashOnceSlow -> Prelude.return (3843)
     PpEffectAppear -> Prelude.return (3844)
unmarshallPpEntryEffect :: Int.Int16 -> Prelude.IO PpEntryEffect
unmarshallPpEntryEffect v =
  case v of
     (-2) -> Prelude.return (PpEffectMixed)
     0 -> Prelude.return (PpEffectNone)
     257 -> Prelude.return (PpEffectCut)
     258 -> Prelude.return (PpEffectCutThroughBlack)
     513 -> Prelude.return (PpEffectRandom)
     769 -> Prelude.return (PpEffectBlindsHorizontal)
     770 -> Prelude.return (PpEffectBlindsVertical)
     1025 -> Prelude.return (PpEffectCheckerboardAcross)
     1026 -> Prelude.return (PpEffectCheckerboardDown)
     1281 -> Prelude.return (PpEffectCoverLeft)
     1282 -> Prelude.return (PpEffectCoverUp)
     1283 -> Prelude.return (PpEffectCoverRight)
     1284 -> Prelude.return (PpEffectCoverDown)
     1285 -> Prelude.return (PpEffectCoverLeftUp)
     1286 -> Prelude.return (PpEffectCoverRightUp)
     1287 -> Prelude.return (PpEffectCoverLeftDown)
     1288 -> Prelude.return (PpEffectCoverRightDown)
     1537 -> Prelude.return (PpEffectDissolve)
     1793 -> Prelude.return (PpEffectFade)
     2049 -> Prelude.return (PpEffectUncoverLeft)
     2050 -> Prelude.return (PpEffectUncoverUp)
     2051 -> Prelude.return (PpEffectUncoverRight)
     2052 -> Prelude.return (PpEffectUncoverDown)
     2053 -> Prelude.return (PpEffectUncoverLeftUp)
     2054 -> Prelude.return (PpEffectUncoverRightUp)
     2055 -> Prelude.return (PpEffectUncoverLeftDown)
     2056 -> Prelude.return (PpEffectUncoverRightDown)
     2305 -> Prelude.return (PpEffectRandomBarsHorizontal)
     2306 -> Prelude.return (PpEffectRandomBarsVertical)
     2561 -> Prelude.return (PpEffectStripsUpLeft)
     2562 -> Prelude.return (PpEffectStripsUpRight)
     2563 -> Prelude.return (PpEffectStripsDownLeft)
     2564 -> Prelude.return (PpEffectStripsDownRight)
     2565 -> Prelude.return (PpEffectStripsLeftUp)
     2566 -> Prelude.return (PpEffectStripsRightUp)
     2567 -> Prelude.return (PpEffectStripsLeftDown)
     2568 -> Prelude.return (PpEffectStripsRightDown)
     2817 -> Prelude.return (PpEffectWipeLeft)
     2818 -> Prelude.return (PpEffectWipeUp)
     2819 -> Prelude.return (PpEffectWipeRight)
     2820 -> Prelude.return (PpEffectWipeDown)
     3073 -> Prelude.return (PpEffectBoxOut)
     3074 -> Prelude.return (PpEffectBoxIn)
     3329 -> Prelude.return (PpEffectFlyFromLeft)
     3330 -> Prelude.return (PpEffectFlyFromTop)
     3331 -> Prelude.return (PpEffectFlyFromRight)
     3332 -> Prelude.return (PpEffectFlyFromBottom)
     3333 -> Prelude.return (PpEffectFlyFromTopLeft)
     3334 -> Prelude.return (PpEffectFlyFromTopRight)
     3335 -> Prelude.return (PpEffectFlyFromBottomLeft)
     3336 -> Prelude.return (PpEffectFlyFromBottomRight)
     3337 -> Prelude.return (PpEffectPeekFromLeft)
     3338 -> Prelude.return (PpEffectPeekFromDown)
     3339 -> Prelude.return (PpEffectPeekFromRight)
     3340 -> Prelude.return (PpEffectPeekFromUp)
     3341 -> Prelude.return (PpEffectCrawlFromLeft)
     3342 -> Prelude.return (PpEffectCrawlFromUp)
     3343 -> Prelude.return (PpEffectCrawlFromRight)
     3344 -> Prelude.return (PpEffectCrawlFromDown)
     3345 -> Prelude.return (PpEffectZoomIn)
     3346 -> Prelude.return (PpEffectZoomInSlightly)
     3347 -> Prelude.return (PpEffectZoomOut)
     3348 -> Prelude.return (PpEffectZoomOutSlightly)
     3349 -> Prelude.return (PpEffectZoomCenter)
     3350 -> Prelude.return (PpEffectZoomBottom)
     3351 -> Prelude.return (PpEffectStretchAcross)
     3352 -> Prelude.return (PpEffectStretchLeft)
     3353 -> Prelude.return (PpEffectStretchUp)
     3354 -> Prelude.return (PpEffectStretchRight)
     3355 -> Prelude.return (PpEffectStretchDown)
     3356 -> Prelude.return (PpEffectSwivel)
     3357 -> Prelude.return (PpEffectSpiral)
     3585 -> Prelude.return (PpEffectSplitHorizontalOut)
     3586 -> Prelude.return (PpEffectSplitHorizontalIn)
     3587 -> Prelude.return (PpEffectSplitVerticalOut)
     3588 -> Prelude.return (PpEffectSplitVerticalIn)
     3841 -> Prelude.return (PpEffectFlashOnceFast)
     3842 -> Prelude.return (PpEffectFlashOnceMedium)
     3843 -> Prelude.return (PpEffectFlashOnceSlow)
     3844 -> Prelude.return (PpEffectAppear)
     _ -> Prelude.fail (Prelude.userError "unmarshallPpEntryEffect: illegal enum value ")
data PpTextLevelEffect
 = PpAnimateLevelMixed
 | PpAnimateLevelNone
 | PpAnimateByFirstLevel
 | PpAnimateBySecondLevel
 | PpAnimateByThirdLevel
 | PpAnimateByFourthLevel
 | PpAnimateByFifthLevel
 | PpAnimateByAllLevels
 
marshallPpTextLevelEffect :: PpTextLevelEffect -> Prelude.IO Int.Int16
marshallPpTextLevelEffect v =
  case v of
     PpAnimateLevelMixed -> Prelude.return ((-2))
     PpAnimateLevelNone -> Prelude.return (0)
     PpAnimateByFirstLevel -> Prelude.return (1)
     PpAnimateBySecondLevel -> Prelude.return (2)
     PpAnimateByThirdLevel -> Prelude.return (3)
     PpAnimateByFourthLevel -> Prelude.return (4)
     PpAnimateByFifthLevel -> Prelude.return (5)
     PpAnimateByAllLevels -> Prelude.return (16)
unmarshallPpTextLevelEffect :: Int.Int16 -> Prelude.IO PpTextLevelEffect
unmarshallPpTextLevelEffect v =
  case v of
     (-2) -> Prelude.return (PpAnimateLevelMixed)
     0 -> Prelude.return (PpAnimateLevelNone)
     1 -> Prelude.return (PpAnimateByFirstLevel)
     2 -> Prelude.return (PpAnimateBySecondLevel)
     3 -> Prelude.return (PpAnimateByThirdLevel)
     4 -> Prelude.return (PpAnimateByFourthLevel)
     5 -> Prelude.return (PpAnimateByFifthLevel)
     16 -> Prelude.return (PpAnimateByAllLevels)
     _ -> Prelude.fail (Prelude.userError "unmarshallPpTextLevelEffect: illegal enum value ")
data PpTextUnitEffect
 = PpAnimateUnitMixed
 | PpAnimateByParagraph
 | PpAnimateByWord
 | PpAnimateByCharacter
 
marshallPpTextUnitEffect :: PpTextUnitEffect -> Prelude.IO Int.Int16
marshallPpTextUnitEffect v =
  case v of
     PpAnimateUnitMixed -> Prelude.return ((-2))
     PpAnimateByParagraph -> Prelude.return (0)
     PpAnimateByWord -> Prelude.return (1)
     PpAnimateByCharacter -> Prelude.return (2)
unmarshallPpTextUnitEffect :: Int.Int16 -> Prelude.IO PpTextUnitEffect
unmarshallPpTextUnitEffect v =
  case v of
     (-2) -> Prelude.return (PpAnimateUnitMixed)
     0 -> Prelude.return (PpAnimateByParagraph)
     1 -> Prelude.return (PpAnimateByWord)
     2 -> Prelude.return (PpAnimateByCharacter)
     _ -> Prelude.fail (Prelude.userError "unmarshallPpTextUnitEffect: illegal enum value ")
data PpChartUnitEffect
 = PpAnimateChartMixed
 | PpAnimateBySeries
 | PpAnimateByCategory
 | PpAnimateBySeriesElements
 | PpAnimateByCategoryElements
 
marshallPpChartUnitEffect :: PpChartUnitEffect -> Prelude.IO Int.Int16
marshallPpChartUnitEffect v =
  case v of
     PpAnimateChartMixed -> Prelude.return ((-2))
     PpAnimateBySeries -> Prelude.return (1)
     PpAnimateByCategory -> Prelude.return (2)
     PpAnimateBySeriesElements -> Prelude.return (3)
     PpAnimateByCategoryElements -> Prelude.return (4)
unmarshallPpChartUnitEffect :: Int.Int16 -> Prelude.IO PpChartUnitEffect
unmarshallPpChartUnitEffect v =
  case v of
     (-2) -> Prelude.return (PpAnimateChartMixed)
     1 -> Prelude.return (PpAnimateBySeries)
     2 -> Prelude.return (PpAnimateByCategory)
     3 -> Prelude.return (PpAnimateBySeriesElements)
     4 -> Prelude.return (PpAnimateByCategoryElements)
     _ -> Prelude.fail (Prelude.userError "unmarshallPpChartUnitEffect: illegal enum value ")
data PpAfterEffect
 = PpAfterEffectMixed
 | PpAfterEffectNothing
 | PpAfterEffectHide
 | PpAfterEffectDim
 | PpAfterEffectHideOnClick
 
marshallPpAfterEffect :: PpAfterEffect -> Prelude.IO Int.Int16
marshallPpAfterEffect v =
  case v of
     PpAfterEffectMixed -> Prelude.return ((-2))
     PpAfterEffectNothing -> Prelude.return (0)
     PpAfterEffectHide -> Prelude.return (1)
     PpAfterEffectDim -> Prelude.return (2)
     PpAfterEffectHideOnClick -> Prelude.return (3)
unmarshallPpAfterEffect :: Int.Int16 -> Prelude.IO PpAfterEffect
unmarshallPpAfterEffect v =
  case v of
     (-2) -> Prelude.return (PpAfterEffectMixed)
     0 -> Prelude.return (PpAfterEffectNothing)
     1 -> Prelude.return (PpAfterEffectHide)
     2 -> Prelude.return (PpAfterEffectDim)
     3 -> Prelude.return (PpAfterEffectHideOnClick)
     _ -> Prelude.fail (Prelude.userError "unmarshallPpAfterEffect: illegal enum value ")
data PpAdvanceMode
 = PpAdvanceModeMixed
 | PpAdvanceOnClick
 | PpAdvanceOnTime
 
marshallPpAdvanceMode :: PpAdvanceMode -> Prelude.IO Int.Int16
marshallPpAdvanceMode v =
  case v of
     PpAdvanceModeMixed -> Prelude.return ((-2))
     PpAdvanceOnClick -> Prelude.return (1)
     PpAdvanceOnTime -> Prelude.return (2)
unmarshallPpAdvanceMode :: Int.Int16 -> Prelude.IO PpAdvanceMode
unmarshallPpAdvanceMode v =
  case v of
     (-2) -> Prelude.return (PpAdvanceModeMixed)
     1 -> Prelude.return (PpAdvanceOnClick)
     2 -> Prelude.return (PpAdvanceOnTime)
     _ -> Prelude.fail (Prelude.userError "unmarshallPpAdvanceMode: illegal enum value ")
data PpSoundEffectType
 = PpSoundEffectsMixed
 | PpSoundNone
 | PpSoundStopPrevious
 | PpSoundFile
 
marshallPpSoundEffectType :: PpSoundEffectType -> Prelude.IO Int.Int16
marshallPpSoundEffectType v =
  case v of
     PpSoundEffectsMixed -> Prelude.return ((-2))
     PpSoundNone -> Prelude.return (0)
     PpSoundStopPrevious -> Prelude.return (1)
     PpSoundFile -> Prelude.return (2)
unmarshallPpSoundEffectType :: Int.Int16 -> Prelude.IO PpSoundEffectType
unmarshallPpSoundEffectType v =
  case v of
     (-2) -> Prelude.return (PpSoundEffectsMixed)
     0 -> Prelude.return (PpSoundNone)
     1 -> Prelude.return (PpSoundStopPrevious)
     2 -> Prelude.return (PpSoundFile)
     _ -> Prelude.fail (Prelude.userError "unmarshallPpSoundEffectType: illegal enum value ")
data PpFollowColors
 = PpFollowColorsMixed
 | PpFollowColorsNone
 | PpFollowColorsScheme
 | PpFollowColorsTextAndBackground
 
marshallPpFollowColors :: PpFollowColors -> Prelude.IO Int.Int16
marshallPpFollowColors v =
  case v of
     PpFollowColorsMixed -> Prelude.return ((-2))
     PpFollowColorsNone -> Prelude.return (0)
     PpFollowColorsScheme -> Prelude.return (1)
     PpFollowColorsTextAndBackground -> Prelude.return (2)
unmarshallPpFollowColors :: Int.Int16 -> Prelude.IO PpFollowColors
unmarshallPpFollowColors v =
  case v of
     (-2) -> Prelude.return (PpFollowColorsMixed)
     0 -> Prelude.return (PpFollowColorsNone)
     1 -> Prelude.return (PpFollowColorsScheme)
     2 -> Prelude.return (PpFollowColorsTextAndBackground)
     _ -> Prelude.fail (Prelude.userError "unmarshallPpFollowColors: illegal enum value ")
data PpUpdateOption
 = PpUpdateOptionMixed
 | PpUpdateOptionManual
 | PpUpdateOptionAutomatic
 
marshallPpUpdateOption :: PpUpdateOption -> Prelude.IO Int.Int16
marshallPpUpdateOption v =
  case v of
     PpUpdateOptionMixed -> Prelude.return ((-2))
     PpUpdateOptionManual -> Prelude.return (1)
     PpUpdateOptionAutomatic -> Prelude.return (2)
unmarshallPpUpdateOption :: Int.Int16 -> Prelude.IO PpUpdateOption
unmarshallPpUpdateOption v =
  case v of
     (-2) -> Prelude.return (PpUpdateOptionMixed)
     1 -> Prelude.return (PpUpdateOptionManual)
     2 -> Prelude.return (PpUpdateOptionAutomatic)
     _ -> Prelude.fail (Prelude.userError "unmarshallPpUpdateOption: illegal enum value ")
data PpParagraphAlignment
 = PpAlignmentMixed
 | PpAlignLeft
 | PpAlignCenter
 | PpAlignRight
 | PpAlignJustify
 | PpAlignDistribute
 
marshallPpParagraphAlignment :: PpParagraphAlignment -> Prelude.IO Int.Int16
marshallPpParagraphAlignment v =
  case v of
     PpAlignmentMixed -> Prelude.return ((-2))
     PpAlignLeft -> Prelude.return (1)
     PpAlignCenter -> Prelude.return (2)
     PpAlignRight -> Prelude.return (3)
     PpAlignJustify -> Prelude.return (4)
     PpAlignDistribute -> Prelude.return (5)
unmarshallPpParagraphAlignment :: Int.Int16 -> Prelude.IO PpParagraphAlignment
unmarshallPpParagraphAlignment v =
  case v of
     (-2) -> Prelude.return (PpAlignmentMixed)
     1 -> Prelude.return (PpAlignLeft)
     2 -> Prelude.return (PpAlignCenter)
     3 -> Prelude.return (PpAlignRight)
     4 -> Prelude.return (PpAlignJustify)
     5 -> Prelude.return (PpAlignDistribute)
     _ -> Prelude.fail (Prelude.userError "unmarshallPpParagraphAlignment: illegal enum value ")
data PpBaselineAlignment
 = PpBaselineAlignMixed
 | PpBaselineAlignBaseline
 | PpBaselineAlignTop
 | PpBaselineAlignCenter
 | PpBaselineAlignFarEast50
 
marshallPpBaselineAlignment :: PpBaselineAlignment -> Prelude.IO Int.Int16
marshallPpBaselineAlignment v =
  case v of
     PpBaselineAlignMixed -> Prelude.return ((-2))
     PpBaselineAlignBaseline -> Prelude.return (1)
     PpBaselineAlignTop -> Prelude.return (2)
     PpBaselineAlignCenter -> Prelude.return (3)
     PpBaselineAlignFarEast50 -> Prelude.return (4)
unmarshallPpBaselineAlignment :: Int.Int16 -> Prelude.IO PpBaselineAlignment
unmarshallPpBaselineAlignment v =
  case v of
     (-2) -> Prelude.return (PpBaselineAlignMixed)
     1 -> Prelude.return (PpBaselineAlignBaseline)
     2 -> Prelude.return (PpBaselineAlignTop)
     3 -> Prelude.return (PpBaselineAlignCenter)
     4 -> Prelude.return (PpBaselineAlignFarEast50)
     _ -> Prelude.fail (Prelude.userError "unmarshallPpBaselineAlignment: illegal enum value ")
data PpTabStopType
 = PpTabStopMixed
 | PpTabStopLeft
 | PpTabStopCenter
 | PpTabStopRight
 | PpTabStopDecimal
 
marshallPpTabStopType :: PpTabStopType -> Prelude.IO Int.Int16
marshallPpTabStopType v =
  case v of
     PpTabStopMixed -> Prelude.return ((-2))
     PpTabStopLeft -> Prelude.return (1)
     PpTabStopCenter -> Prelude.return (2)
     PpTabStopRight -> Prelude.return (3)
     PpTabStopDecimal -> Prelude.return (4)
unmarshallPpTabStopType :: Int.Int16 -> Prelude.IO PpTabStopType
unmarshallPpTabStopType v =
  case v of
     (-2) -> Prelude.return (PpTabStopMixed)
     1 -> Prelude.return (PpTabStopLeft)
     2 -> Prelude.return (PpTabStopCenter)
     3 -> Prelude.return (PpTabStopRight)
     4 -> Prelude.return (PpTabStopDecimal)
     _ -> Prelude.fail (Prelude.userError "unmarshallPpTabStopType: illegal enum value ")
data PpIndentControl
 = PpIndentControlMixed
 | PpIndentReplaceAttr
 | PpIndentKeepAttr
 
marshallPpIndentControl :: PpIndentControl -> Prelude.IO Int.Int16
marshallPpIndentControl v =
  case v of
     PpIndentControlMixed -> Prelude.return ((-2))
     PpIndentReplaceAttr -> Prelude.return (1)
     PpIndentKeepAttr -> Prelude.return (2)
unmarshallPpIndentControl :: Int.Int16 -> Prelude.IO PpIndentControl
unmarshallPpIndentControl v =
  case v of
     (-2) -> Prelude.return (PpIndentControlMixed)
     1 -> Prelude.return (PpIndentReplaceAttr)
     2 -> Prelude.return (PpIndentKeepAttr)
     _ -> Prelude.fail (Prelude.userError "unmarshallPpIndentControl: illegal enum value ")
data PpChangeCase
 = PpCaseSentence
 | PpCaseLower
 | PpCaseUpper
 | PpCaseTitle
 | PpCaseToggle
 
marshallPpChangeCase :: PpChangeCase -> Prelude.IO Int.Int16
marshallPpChangeCase v =
  case v of
     PpCaseSentence -> Prelude.return (1)
     PpCaseLower -> Prelude.return (2)
     PpCaseUpper -> Prelude.return (3)
     PpCaseTitle -> Prelude.return (4)
     PpCaseToggle -> Prelude.return (5)
unmarshallPpChangeCase :: Int.Int16 -> Prelude.IO PpChangeCase
unmarshallPpChangeCase v =
  case v of
     1 -> Prelude.return (PpCaseSentence)
     2 -> Prelude.return (PpCaseLower)
     3 -> Prelude.return (PpCaseUpper)
     4 -> Prelude.return (PpCaseTitle)
     5 -> Prelude.return (PpCaseToggle)
     _ -> Prelude.fail (Prelude.userError "unmarshallPpChangeCase: illegal enum value ")
data PpDialogMode
 = PpDialogModeMixed
 | PpDialogModeless
 | PpDialogModal
 
marshallPpDialogMode :: PpDialogMode -> Prelude.IO Int.Int16
marshallPpDialogMode v =
  case v of
     PpDialogModeMixed -> Prelude.return ((-2))
     PpDialogModeless -> Prelude.return (0)
     PpDialogModal -> Prelude.return (1)
unmarshallPpDialogMode :: Int.Int16 -> Prelude.IO PpDialogMode
unmarshallPpDialogMode v =
  case v of
     (-2) -> Prelude.return (PpDialogModeMixed)
     0 -> Prelude.return (PpDialogModeless)
     1 -> Prelude.return (PpDialogModal)
     _ -> Prelude.fail (Prelude.userError "unmarshallPpDialogMode: illegal enum value ")
data PpDialogStyle
 = PpDialogStyleMixed
 | PpDialogStandard
 | PpDialogTabbed
 
marshallPpDialogStyle :: PpDialogStyle -> Prelude.IO Int.Int16
marshallPpDialogStyle v =
  case v of
     PpDialogStyleMixed -> Prelude.return ((-2))
     PpDialogStandard -> Prelude.return (1)
     PpDialogTabbed -> Prelude.return (2)
unmarshallPpDialogStyle :: Int.Int16 -> Prelude.IO PpDialogStyle
unmarshallPpDialogStyle v =
  case v of
     (-2) -> Prelude.return (PpDialogStyleMixed)
     1 -> Prelude.return (PpDialogStandard)
     2 -> Prelude.return (PpDialogTabbed)
     _ -> Prelude.fail (Prelude.userError "unmarshallPpDialogStyle: illegal enum value ")
data PpDialogPositioning
 = PpDialogPositionNormal
 | PpDialogPositionCenterParent
 | PpDialogPositionCenterScreen
 | PpDialogPositionRememberLast
 
marshallPpDialogPositioning :: PpDialogPositioning -> Prelude.IO Int.Int16
marshallPpDialogPositioning v =
  case v of
     PpDialogPositionNormal -> Prelude.return (1)
     PpDialogPositionCenterParent -> Prelude.return (2)
     PpDialogPositionCenterScreen -> Prelude.return (3)
     PpDialogPositionRememberLast -> Prelude.return (4)
unmarshallPpDialogPositioning :: Int.Int16 -> Prelude.IO PpDialogPositioning
unmarshallPpDialogPositioning v =
  case v of
     1 -> Prelude.return (PpDialogPositionNormal)
     2 -> Prelude.return (PpDialogPositionCenterParent)
     3 -> Prelude.return (PpDialogPositionCenterScreen)
     4 -> Prelude.return (PpDialogPositionRememberLast)
     _ -> Prelude.fail (Prelude.userError "unmarshallPpDialogPositioning: illegal enum value ")
data PpDialogFontStyle
 = PpDialogFontStyleMixed
 | PpDialogSmall
 | PpDialogItalic
 
marshallPpDialogFontStyle :: PpDialogFontStyle -> Prelude.IO Int.Int16
marshallPpDialogFontStyle v =
  case v of
     PpDialogFontStyleMixed -> Prelude.return ((-2))
     PpDialogSmall -> Prelude.return ((-1))
     PpDialogItalic -> Prelude.return (0)
unmarshallPpDialogFontStyle :: Int.Int16 -> Prelude.IO PpDialogFontStyle
unmarshallPpDialogFontStyle v =
  case v of
     (-2) -> Prelude.return (PpDialogFontStyleMixed)
     (-1) -> Prelude.return (PpDialogSmall)
     0 -> Prelude.return (PpDialogItalic)
     _ -> Prelude.fail (Prelude.userError "unmarshallPpDialogFontStyle: illegal enum value ")
data PpScrollBarStyle
 = PpScrollBarVertical
 | PpScrollBarHorizontal
 
marshallPpScrollBarStyle :: PpScrollBarStyle -> Prelude.IO Int.Int16
marshallPpScrollBarStyle v =
  case v of
     PpScrollBarVertical -> Prelude.return (0)
     PpScrollBarHorizontal -> Prelude.return (1)
unmarshallPpScrollBarStyle :: Int.Int16 -> Prelude.IO PpScrollBarStyle
unmarshallPpScrollBarStyle v =
  case v of
     0 -> Prelude.return (PpScrollBarVertical)
     1 -> Prelude.return (PpScrollBarHorizontal)
     _ -> Prelude.fail (Prelude.userError "unmarshallPpScrollBarStyle: illegal enum value ")
data PpListBoxSelectionStyle
 = PpListBoxSingle
 | PpListBoxMulti
 
marshallPpListBoxSelectionStyle :: PpListBoxSelectionStyle -> Prelude.IO Int.Int16
marshallPpListBoxSelectionStyle v =
  case v of
     PpListBoxSingle -> Prelude.return (0)
     PpListBoxMulti -> Prelude.return (1)
unmarshallPpListBoxSelectionStyle :: Int.Int16 -> Prelude.IO PpListBoxSelectionStyle
unmarshallPpListBoxSelectionStyle v =
  case v of
     0 -> Prelude.return (PpListBoxSingle)
     1 -> Prelude.return (PpListBoxMulti)
     _ -> Prelude.fail (Prelude.userError "unmarshallPpListBoxSelectionStyle: illegal enum value ")
data PpListBoxAbbreviationStyle
 = PpListBoxAbbreviationNone
 | PpListBoxAbbreviationTruncation
 | PpListBoxAbbreviationTruncationWithEllipsis
 | PpListBoxAbbreviationFileNames
 
marshallPpListBoxAbbreviationStyle :: PpListBoxAbbreviationStyle -> Prelude.IO Int.Int16
marshallPpListBoxAbbreviationStyle v =
  case v of
     PpListBoxAbbreviationNone -> Prelude.return (0)
     PpListBoxAbbreviationTruncation -> Prelude.return (1)
     PpListBoxAbbreviationTruncationWithEllipsis -> Prelude.return (2)
     PpListBoxAbbreviationFileNames -> Prelude.return (3)
unmarshallPpListBoxAbbreviationStyle :: Int.Int16 -> Prelude.IO PpListBoxAbbreviationStyle
unmarshallPpListBoxAbbreviationStyle v =
  case v of
     0 -> Prelude.return (PpListBoxAbbreviationNone)
     1 -> Prelude.return (PpListBoxAbbreviationTruncation)
     2 -> Prelude.return (PpListBoxAbbreviationTruncationWithEllipsis)
     3 -> Prelude.return (PpListBoxAbbreviationFileNames)
     _ -> Prelude.fail (Prelude.userError "unmarshallPpListBoxAbbreviationStyle: illegal enum value ")
data PpAlertType
 = PpAlertTypeOK
 | PpAlertTypeOKCANCEL
 | PpAlertTypeYESNO
 | PpAlertTypeYESNOCANCEL
 | PpAlertTypeBACKNEXTCLOSE
 | PpAlertTypeRETRYCANCEL
 | PpAlertTypeABORTRETRYIGNORE
 
marshallPpAlertType :: PpAlertType -> Prelude.IO Int.Int16
marshallPpAlertType v =
  case v of
     PpAlertTypeOK -> Prelude.return (0)
     PpAlertTypeOKCANCEL -> Prelude.return (1)
     PpAlertTypeYESNO -> Prelude.return (2)
     PpAlertTypeYESNOCANCEL -> Prelude.return (3)
     PpAlertTypeBACKNEXTCLOSE -> Prelude.return (4)
     PpAlertTypeRETRYCANCEL -> Prelude.return (5)
     PpAlertTypeABORTRETRYIGNORE -> Prelude.return (6)
unmarshallPpAlertType :: Int.Int16 -> Prelude.IO PpAlertType
unmarshallPpAlertType v =
  case v of
     0 -> Prelude.return (PpAlertTypeOK)
     1 -> Prelude.return (PpAlertTypeOKCANCEL)
     2 -> Prelude.return (PpAlertTypeYESNO)
     3 -> Prelude.return (PpAlertTypeYESNOCANCEL)
     4 -> Prelude.return (PpAlertTypeBACKNEXTCLOSE)
     5 -> Prelude.return (PpAlertTypeRETRYCANCEL)
     6 -> Prelude.return (PpAlertTypeABORTRETRYIGNORE)
     _ -> Prelude.fail (Prelude.userError "unmarshallPpAlertType: illegal enum value ")
data PpAlertButton
 = PpAlertButtonCLOSE
 | PpAlertButtonSNOOZE
 | PpAlertButtonSEARCH
 | PpAlertButtonIGNORE
 | PpAlertButtonABORT
 | PpAlertButtonRETRY
 | PpAlertButtonNEXT
 | PpAlertButtonBACK
 | PpAlertButtonNO
 | PpAlertButtonYES
 | PpAlertButtonCANCEL
 | PpAlertButtonOK
 | PpAlertButtonNULL
 
marshallPpAlertButton :: PpAlertButton -> Prelude.IO Int.Int16
marshallPpAlertButton v =
  case v of
     PpAlertButtonCLOSE -> Prelude.return (0)
     PpAlertButtonSNOOZE -> Prelude.return (1)
     PpAlertButtonSEARCH -> Prelude.return (2)
     PpAlertButtonIGNORE -> Prelude.return (3)
     PpAlertButtonABORT -> Prelude.return (4)
     PpAlertButtonRETRY -> Prelude.return (5)
     PpAlertButtonNEXT -> Prelude.return (6)
     PpAlertButtonBACK -> Prelude.return (7)
     PpAlertButtonNO -> Prelude.return (8)
     PpAlertButtonYES -> Prelude.return (9)
     PpAlertButtonCANCEL -> Prelude.return (10)
     PpAlertButtonOK -> Prelude.return (11)
     PpAlertButtonNULL -> Prelude.return (12)
unmarshallPpAlertButton :: Int.Int16 -> Prelude.IO PpAlertButton
unmarshallPpAlertButton v =
  case v of
     0 -> Prelude.return (PpAlertButtonCLOSE)
     1 -> Prelude.return (PpAlertButtonSNOOZE)
     2 -> Prelude.return (PpAlertButtonSEARCH)
     3 -> Prelude.return (PpAlertButtonIGNORE)
     4 -> Prelude.return (PpAlertButtonABORT)
     5 -> Prelude.return (PpAlertButtonRETRY)
     6 -> Prelude.return (PpAlertButtonNEXT)
     7 -> Prelude.return (PpAlertButtonBACK)
     8 -> Prelude.return (PpAlertButtonNO)
     9 -> Prelude.return (PpAlertButtonYES)
     10 -> Prelude.return (PpAlertButtonCANCEL)
     11 -> Prelude.return (PpAlertButtonOK)
     12 -> Prelude.return (PpAlertButtonNULL)
     _ -> Prelude.fail (Prelude.userError "unmarshallPpAlertButton: illegal enum value ")
data PpAlertIcon
 = PpAlertIconQuestionMark
 | PpAlertIconNote
 | PpAlertIconCaution
 | PpAlertIconStop
 
marshallPpAlertIcon :: PpAlertIcon -> Prelude.IO Int.Int16
marshallPpAlertIcon v =
  case v of
     PpAlertIconQuestionMark -> Prelude.return (0)
     PpAlertIconNote -> Prelude.return (1)
     PpAlertIconCaution -> Prelude.return (2)
     PpAlertIconStop -> Prelude.return (3)
unmarshallPpAlertIcon :: Int.Int16 -> Prelude.IO PpAlertIcon
unmarshallPpAlertIcon v =
  case v of
     0 -> Prelude.return (PpAlertIconQuestionMark)
     1 -> Prelude.return (PpAlertIconNote)
     2 -> Prelude.return (PpAlertIconCaution)
     3 -> Prelude.return (PpAlertIconStop)
     _ -> Prelude.fail (Prelude.userError "unmarshallPpAlertIcon: illegal enum value ")
data PpSlideShowPointerType
 = PpSlideShowPointerNone
 | PpSlideShowPointerArrow
 | PpSlideShowPointerPen
 | PpSlideShowPointerAlwaysHidden
 
marshallPpSlideShowPointerType :: PpSlideShowPointerType -> Prelude.IO Int.Int16
marshallPpSlideShowPointerType v =
  case v of
     PpSlideShowPointerNone -> Prelude.return (0)
     PpSlideShowPointerArrow -> Prelude.return (1)
     PpSlideShowPointerPen -> Prelude.return (2)
     PpSlideShowPointerAlwaysHidden -> Prelude.return (3)
unmarshallPpSlideShowPointerType :: Int.Int16 -> Prelude.IO PpSlideShowPointerType
unmarshallPpSlideShowPointerType v =
  case v of
     0 -> Prelude.return (PpSlideShowPointerNone)
     1 -> Prelude.return (PpSlideShowPointerArrow)
     2 -> Prelude.return (PpSlideShowPointerPen)
     3 -> Prelude.return (PpSlideShowPointerAlwaysHidden)
     _ -> Prelude.fail (Prelude.userError "unmarshallPpSlideShowPointerType: illegal enum value ")
data PpSlideShowState
 = PpSlideShowRunning
 | PpSlideShowPaused
 | PpSlideShowBlackScreen
 | PpSlideShowWhiteScreen
 | PpSlideShowDone
 
marshallPpSlideShowState :: PpSlideShowState -> Prelude.IO Int.Int16
marshallPpSlideShowState v =
  case v of
     PpSlideShowRunning -> Prelude.return (1)
     PpSlideShowPaused -> Prelude.return (2)
     PpSlideShowBlackScreen -> Prelude.return (3)
     PpSlideShowWhiteScreen -> Prelude.return (4)
     PpSlideShowDone -> Prelude.return (5)
unmarshallPpSlideShowState :: Int.Int16 -> Prelude.IO PpSlideShowState
unmarshallPpSlideShowState v =
  case v of
     1 -> Prelude.return (PpSlideShowRunning)
     2 -> Prelude.return (PpSlideShowPaused)
     3 -> Prelude.return (PpSlideShowBlackScreen)
     4 -> Prelude.return (PpSlideShowWhiteScreen)
     5 -> Prelude.return (PpSlideShowDone)
     _ -> Prelude.fail (Prelude.userError "unmarshallPpSlideShowState: illegal enum value ")
data PpSlideShowAdvanceMode
 = PpSlideShowManualAdvance
 | PpSlideShowUseSlideTimings
 | PpSlideShowRehearseNewTimings
 
marshallPpSlideShowAdvanceMode :: PpSlideShowAdvanceMode -> Prelude.IO Int.Int16
marshallPpSlideShowAdvanceMode v =
  case v of
     PpSlideShowManualAdvance -> Prelude.return (1)
     PpSlideShowUseSlideTimings -> Prelude.return (2)
     PpSlideShowRehearseNewTimings -> Prelude.return (3)
unmarshallPpSlideShowAdvanceMode :: Int.Int16 -> Prelude.IO PpSlideShowAdvanceMode
unmarshallPpSlideShowAdvanceMode v =
  case v of
     1 -> Prelude.return (PpSlideShowManualAdvance)
     2 -> Prelude.return (PpSlideShowUseSlideTimings)
     3 -> Prelude.return (PpSlideShowRehearseNewTimings)
     _ -> Prelude.fail (Prelude.userError "unmarshallPpSlideShowAdvanceMode: illegal enum value ")
data PpFileDialogType
 = PpFileDialogOpen
 | PpFileDialogSave
 
marshallPpFileDialogType :: PpFileDialogType -> Prelude.IO Int.Int16
marshallPpFileDialogType v =
  case v of
     PpFileDialogOpen -> Prelude.return (1)
     PpFileDialogSave -> Prelude.return (2)
unmarshallPpFileDialogType :: Int.Int16 -> Prelude.IO PpFileDialogType
unmarshallPpFileDialogType v =
  case v of
     1 -> Prelude.return (PpFileDialogOpen)
     2 -> Prelude.return (PpFileDialogSave)
     _ -> Prelude.fail (Prelude.userError "unmarshallPpFileDialogType: illegal enum value ")
data PpFileDialogView
 = PpFileDialogViewDetails
 | PpFileDialogViewPreview
 | PpFileDialogViewProperties
 | PpFileDialogViewList
 
marshallPpFileDialogView :: PpFileDialogView -> Prelude.IO Int.Int16
marshallPpFileDialogView v =
  case v of
     PpFileDialogViewDetails -> Prelude.return (1)
     PpFileDialogViewPreview -> Prelude.return (2)
     PpFileDialogViewProperties -> Prelude.return (3)
     PpFileDialogViewList -> Prelude.return (4)
unmarshallPpFileDialogView :: Int.Int16 -> Prelude.IO PpFileDialogView
unmarshallPpFileDialogView v =
  case v of
     1 -> Prelude.return (PpFileDialogViewDetails)
     2 -> Prelude.return (PpFileDialogViewPreview)
     3 -> Prelude.return (PpFileDialogViewProperties)
     4 -> Prelude.return (PpFileDialogViewList)
     _ -> Prelude.fail (Prelude.userError "unmarshallPpFileDialogView: illegal enum value ")
data PpPrintOutputType
 = PpPrintOutputSlides
 | PpPrintOutputTwoSlideHandouts
 | PpPrintOutputThreeSlideHandouts
 | PpPrintOutputSixSlideHandouts
 | PpPrintOutputNotesPages
 | PpPrintOutputOutline
 | PpPrintOutputBuildSlides
 
marshallPpPrintOutputType :: PpPrintOutputType -> Prelude.IO Int.Int16
marshallPpPrintOutputType v =
  case v of
     PpPrintOutputSlides -> Prelude.return (1)
     PpPrintOutputTwoSlideHandouts -> Prelude.return (2)
     PpPrintOutputThreeSlideHandouts -> Prelude.return (3)
     PpPrintOutputSixSlideHandouts -> Prelude.return (4)
     PpPrintOutputNotesPages -> Prelude.return (5)
     PpPrintOutputOutline -> Prelude.return (6)
     PpPrintOutputBuildSlides -> Prelude.return (7)
unmarshallPpPrintOutputType :: Int.Int16 -> Prelude.IO PpPrintOutputType
unmarshallPpPrintOutputType v =
  case v of
     1 -> Prelude.return (PpPrintOutputSlides)
     2 -> Prelude.return (PpPrintOutputTwoSlideHandouts)
     3 -> Prelude.return (PpPrintOutputThreeSlideHandouts)
     4 -> Prelude.return (PpPrintOutputSixSlideHandouts)
     5 -> Prelude.return (PpPrintOutputNotesPages)
     6 -> Prelude.return (PpPrintOutputOutline)
     7 -> Prelude.return (PpPrintOutputBuildSlides)
     _ -> Prelude.fail (Prelude.userError "unmarshallPpPrintOutputType: illegal enum value ")
data PpPrintColorType
 = PpPrintColor
 | PpPrintBlackAndWhite
 | PpPrintPureBlackAndWhite
 
marshallPpPrintColorType :: PpPrintColorType -> Prelude.IO Int.Int16
marshallPpPrintColorType v =
  case v of
     PpPrintColor -> Prelude.return (1)
     PpPrintBlackAndWhite -> Prelude.return (2)
     PpPrintPureBlackAndWhite -> Prelude.return (3)
unmarshallPpPrintColorType :: Int.Int16 -> Prelude.IO PpPrintColorType
unmarshallPpPrintColorType v =
  case v of
     1 -> Prelude.return (PpPrintColor)
     2 -> Prelude.return (PpPrintBlackAndWhite)
     3 -> Prelude.return (PpPrintPureBlackAndWhite)
     _ -> Prelude.fail (Prelude.userError "unmarshallPpPrintColorType: illegal enum value ")
data PpSelectionType
 = PpSelectionNone
 | PpSelectionSlides
 | PpSelectionShapes
 | PpSelectionText
 
marshallPpSelectionType :: PpSelectionType -> Prelude.IO Int.Int16
marshallPpSelectionType v =
  case v of
     PpSelectionNone -> Prelude.return (0)
     PpSelectionSlides -> Prelude.return (1)
     PpSelectionShapes -> Prelude.return (2)
     PpSelectionText -> Prelude.return (3)
unmarshallPpSelectionType :: Int.Int16 -> Prelude.IO PpSelectionType
unmarshallPpSelectionType v =
  case v of
     0 -> Prelude.return (PpSelectionNone)
     1 -> Prelude.return (PpSelectionSlides)
     2 -> Prelude.return (PpSelectionShapes)
     3 -> Prelude.return (PpSelectionText)
     _ -> Prelude.fail (Prelude.userError "unmarshallPpSelectionType: illegal enum value ")
data PpDirection
 = PpDirectionMixed
 | PpDirectionLeftToRight
 | PpDirectionRightToLeft
 
marshallPpDirection :: PpDirection -> Prelude.IO Int.Int16
marshallPpDirection v =
  case v of
     PpDirectionMixed -> Prelude.return ((-2))
     PpDirectionLeftToRight -> Prelude.return (1)
     PpDirectionRightToLeft -> Prelude.return (2)
unmarshallPpDirection :: Int.Int16 -> Prelude.IO PpDirection
unmarshallPpDirection v =
  case v of
     (-2) -> Prelude.return (PpDirectionMixed)
     1 -> Prelude.return (PpDirectionLeftToRight)
     2 -> Prelude.return (PpDirectionRightToLeft)
     _ -> Prelude.fail (Prelude.userError "unmarshallPpDirection: illegal enum value ")
data PpDateTimeFormat
 = PpDateTimeFormatMixed
 | PpDateTimeMdyy
 | PpDateTimeddddMMMMddyyyy
 | PpDateTimedMMMMyyyy
 | PpDateTimeMMMMdyyyy
 | PpDateTimedMMMyy
 | PpDateTimeMMMMyy
 | PpDateTimeMMyy
 | PpDateTimeMMddyyHmm
 | PpDateTimeMMddyyhmmAMPM
 | PpDateTimeHmm
 | PpDateTimeHmmss
 | PpDateTimehmmAMPM
 | PpDateTimehmmssAMPM
 
marshallPpDateTimeFormat :: PpDateTimeFormat -> Prelude.IO Int.Int16
marshallPpDateTimeFormat v =
  case v of
     PpDateTimeFormatMixed -> Prelude.return ((-2))
     PpDateTimeMdyy -> Prelude.return (1)
     PpDateTimeddddMMMMddyyyy -> Prelude.return (2)
     PpDateTimedMMMMyyyy -> Prelude.return (3)
     PpDateTimeMMMMdyyyy -> Prelude.return (4)
     PpDateTimedMMMyy -> Prelude.return (5)
     PpDateTimeMMMMyy -> Prelude.return (6)
     PpDateTimeMMyy -> Prelude.return (7)
     PpDateTimeMMddyyHmm -> Prelude.return (8)
     PpDateTimeMMddyyhmmAMPM -> Prelude.return (9)
     PpDateTimeHmm -> Prelude.return (10)
     PpDateTimeHmmss -> Prelude.return (11)
     PpDateTimehmmAMPM -> Prelude.return (12)
     PpDateTimehmmssAMPM -> Prelude.return (13)
unmarshallPpDateTimeFormat :: Int.Int16 -> Prelude.IO PpDateTimeFormat
unmarshallPpDateTimeFormat v =
  case v of
     (-2) -> Prelude.return (PpDateTimeFormatMixed)
     1 -> Prelude.return (PpDateTimeMdyy)
     2 -> Prelude.return (PpDateTimeddddMMMMddyyyy)
     3 -> Prelude.return (PpDateTimedMMMMyyyy)
     4 -> Prelude.return (PpDateTimeMMMMdyyyy)
     5 -> Prelude.return (PpDateTimedMMMyy)
     6 -> Prelude.return (PpDateTimeMMMMyy)
     7 -> Prelude.return (PpDateTimeMMyy)
     8 -> Prelude.return (PpDateTimeMMddyyHmm)
     9 -> Prelude.return (PpDateTimeMMddyyhmmAMPM)
     10 -> Prelude.return (PpDateTimeHmm)
     11 -> Prelude.return (PpDateTimeHmmss)
     12 -> Prelude.return (PpDateTimehmmAMPM)
     13 -> Prelude.return (PpDateTimehmmssAMPM)
     _ -> Prelude.fail (Prelude.userError "unmarshallPpDateTimeFormat: illegal enum value ")
data PpTransitionSpeed
 = PpTransitionSpeedMixed
 | PpTransitionSpeedSlow
 | PpTransitionSpeedMedium
 | PpTransitionSpeedFast
 
marshallPpTransitionSpeed :: PpTransitionSpeed -> Prelude.IO Int.Int16
marshallPpTransitionSpeed v =
  case v of
     PpTransitionSpeedMixed -> Prelude.return ((-2))
     PpTransitionSpeedSlow -> Prelude.return (1)
     PpTransitionSpeedMedium -> Prelude.return (2)
     PpTransitionSpeedFast -> Prelude.return (3)
unmarshallPpTransitionSpeed :: Int.Int16 -> Prelude.IO PpTransitionSpeed
unmarshallPpTransitionSpeed v =
  case v of
     (-2) -> Prelude.return (PpTransitionSpeedMixed)
     1 -> Prelude.return (PpTransitionSpeedSlow)
     2 -> Prelude.return (PpTransitionSpeedMedium)
     3 -> Prelude.return (PpTransitionSpeedFast)
     _ -> Prelude.fail (Prelude.userError "unmarshallPpTransitionSpeed: illegal enum value ")
data PpMouseActivation
 = PpMouseClick
 | PpMouseOver
 
marshallPpMouseActivation :: PpMouseActivation -> Prelude.IO Int.Int16
marshallPpMouseActivation v =
  case v of
     PpMouseClick -> Prelude.return (1)
     PpMouseOver -> Prelude.return (2)
unmarshallPpMouseActivation :: Int.Int16 -> Prelude.IO PpMouseActivation
unmarshallPpMouseActivation v =
  case v of
     1 -> Prelude.return (PpMouseClick)
     2 -> Prelude.return (PpMouseOver)
     _ -> Prelude.fail (Prelude.userError "unmarshallPpMouseActivation: illegal enum value ")
data PpActionType
 = PpActionMixed
 | PpActionNone
 | PpActionNextSlide
 | PpActionPreviousSlide
 | PpActionFirstSlide
 | PpActionLastSlide
 | PpActionLastSlideViewed
 | PpActionEndShow
 | PpActionHyperlink
 | PpActionRunMacro
 | PpActionRunProgram
 | PpActionNamedSlideShow
 | PpActionOLEVerb
 | PpActionPlay
 
marshallPpActionType :: PpActionType -> Prelude.IO Int.Int16
marshallPpActionType v =
  case v of
     PpActionMixed -> Prelude.return ((-2))
     PpActionNone -> Prelude.return (0)
     PpActionNextSlide -> Prelude.return (1)
     PpActionPreviousSlide -> Prelude.return (2)
     PpActionFirstSlide -> Prelude.return (3)
     PpActionLastSlide -> Prelude.return (4)
     PpActionLastSlideViewed -> Prelude.return (5)
     PpActionEndShow -> Prelude.return (6)
     PpActionHyperlink -> Prelude.return (7)
     PpActionRunMacro -> Prelude.return (8)
     PpActionRunProgram -> Prelude.return (9)
     PpActionNamedSlideShow -> Prelude.return (10)
     PpActionOLEVerb -> Prelude.return (11)
     PpActionPlay -> Prelude.return (12)
unmarshallPpActionType :: Int.Int16 -> Prelude.IO PpActionType
unmarshallPpActionType v =
  case v of
     (-2) -> Prelude.return (PpActionMixed)
     0 -> Prelude.return (PpActionNone)
     1 -> Prelude.return (PpActionNextSlide)
     2 -> Prelude.return (PpActionPreviousSlide)
     3 -> Prelude.return (PpActionFirstSlide)
     4 -> Prelude.return (PpActionLastSlide)
     5 -> Prelude.return (PpActionLastSlideViewed)
     6 -> Prelude.return (PpActionEndShow)
     7 -> Prelude.return (PpActionHyperlink)
     8 -> Prelude.return (PpActionRunMacro)
     9 -> Prelude.return (PpActionRunProgram)
     10 -> Prelude.return (PpActionNamedSlideShow)
     11 -> Prelude.return (PpActionOLEVerb)
     12 -> Prelude.return (PpActionPlay)
     _ -> Prelude.fail (Prelude.userError "unmarshallPpActionType: illegal enum value ")
data PpPlaceholderType
 = PpPlaceholderMixed
 | PpPlaceholderTitle
 | PpPlaceholderBody
 | PpPlaceholderCenterTitle
 | PpPlaceholderSubtitle
 | PpPlaceholderVerticalTitle
 | PpPlaceholderVerticalBody
 | PpPlaceholderObject
 | PpPlaceholderChart
 | PpPlaceholderBitmap
 | PpPlaceholderMediaClip
 | PpPlaceholderOrgChart
 | PpPlaceholderTable
 | PpPlaceholderSlideNumber
 | PpPlaceholderHeader
 | PpPlaceholderFooter
 | PpPlaceholderDate
 
marshallPpPlaceholderType :: PpPlaceholderType -> Prelude.IO Int.Int16
marshallPpPlaceholderType v =
  case v of
     PpPlaceholderMixed -> Prelude.return ((-2))
     PpPlaceholderTitle -> Prelude.return (1)
     PpPlaceholderBody -> Prelude.return (2)
     PpPlaceholderCenterTitle -> Prelude.return (3)
     PpPlaceholderSubtitle -> Prelude.return (4)
     PpPlaceholderVerticalTitle -> Prelude.return (5)
     PpPlaceholderVerticalBody -> Prelude.return (6)
     PpPlaceholderObject -> Prelude.return (7)
     PpPlaceholderChart -> Prelude.return (8)
     PpPlaceholderBitmap -> Prelude.return (9)
     PpPlaceholderMediaClip -> Prelude.return (10)
     PpPlaceholderOrgChart -> Prelude.return (11)
     PpPlaceholderTable -> Prelude.return (12)
     PpPlaceholderSlideNumber -> Prelude.return (13)
     PpPlaceholderHeader -> Prelude.return (14)
     PpPlaceholderFooter -> Prelude.return (15)
     PpPlaceholderDate -> Prelude.return (16)
unmarshallPpPlaceholderType :: Int.Int16 -> Prelude.IO PpPlaceholderType
unmarshallPpPlaceholderType v =
  case v of
     (-2) -> Prelude.return (PpPlaceholderMixed)
     1 -> Prelude.return (PpPlaceholderTitle)
     2 -> Prelude.return (PpPlaceholderBody)
     3 -> Prelude.return (PpPlaceholderCenterTitle)
     4 -> Prelude.return (PpPlaceholderSubtitle)
     5 -> Prelude.return (PpPlaceholderVerticalTitle)
     6 -> Prelude.return (PpPlaceholderVerticalBody)
     7 -> Prelude.return (PpPlaceholderObject)
     8 -> Prelude.return (PpPlaceholderChart)
     9 -> Prelude.return (PpPlaceholderBitmap)
     10 -> Prelude.return (PpPlaceholderMediaClip)
     11 -> Prelude.return (PpPlaceholderOrgChart)
     12 -> Prelude.return (PpPlaceholderTable)
     13 -> Prelude.return (PpPlaceholderSlideNumber)
     14 -> Prelude.return (PpPlaceholderHeader)
     15 -> Prelude.return (PpPlaceholderFooter)
     16 -> Prelude.return (PpPlaceholderDate)
     _ -> Prelude.fail (Prelude.userError "unmarshallPpPlaceholderType: illegal enum value ")
data PpSlideShowType
 = PpShowTypeSpeaker
 | PpShowTypeWindow
 | PpShowTypeKiosk
 
marshallPpSlideShowType :: PpSlideShowType -> Prelude.IO Int.Int16
marshallPpSlideShowType v =
  case v of
     PpShowTypeSpeaker -> Prelude.return (1)
     PpShowTypeWindow -> Prelude.return (2)
     PpShowTypeKiosk -> Prelude.return (3)
unmarshallPpSlideShowType :: Int.Int16 -> Prelude.IO PpSlideShowType
unmarshallPpSlideShowType v =
  case v of
     1 -> Prelude.return (PpShowTypeSpeaker)
     2 -> Prelude.return (PpShowTypeWindow)
     3 -> Prelude.return (PpShowTypeKiosk)
     _ -> Prelude.fail (Prelude.userError "unmarshallPpSlideShowType: illegal enum value ")
data PpPrintRangeType
 = PpPrintAll
 | PpPrintSelection
 | PpPrintCurrent
 | PpPrintSlideRange
 | PpPrintNamedSlideShow
 
marshallPpPrintRangeType :: PpPrintRangeType -> Prelude.IO Int.Int16
marshallPpPrintRangeType v =
  case v of
     PpPrintAll -> Prelude.return (1)
     PpPrintSelection -> Prelude.return (2)
     PpPrintCurrent -> Prelude.return (3)
     PpPrintSlideRange -> Prelude.return (4)
     PpPrintNamedSlideShow -> Prelude.return (5)
unmarshallPpPrintRangeType :: Int.Int16 -> Prelude.IO PpPrintRangeType
unmarshallPpPrintRangeType v =
  case v of
     1 -> Prelude.return (PpPrintAll)
     2 -> Prelude.return (PpPrintSelection)
     3 -> Prelude.return (PpPrintCurrent)
     4 -> Prelude.return (PpPrintSlideRange)
     5 -> Prelude.return (PpPrintNamedSlideShow)
     _ -> Prelude.fail (Prelude.userError "unmarshallPpPrintRangeType: illegal enum value ")
data PpAutoSize
 = PpAutoSizeMixed
 | PpAutoSizeNone
 | PpAutoSizeShapeToFitText
 
marshallPpAutoSize :: PpAutoSize -> Prelude.IO Int.Int16
marshallPpAutoSize v =
  case v of
     PpAutoSizeMixed -> Prelude.return ((-2))
     PpAutoSizeNone -> Prelude.return (0)
     PpAutoSizeShapeToFitText -> Prelude.return (1)
unmarshallPpAutoSize :: Int.Int16 -> Prelude.IO PpAutoSize
unmarshallPpAutoSize v =
  case v of
     (-2) -> Prelude.return (PpAutoSizeMixed)
     0 -> Prelude.return (PpAutoSizeNone)
     1 -> Prelude.return (PpAutoSizeShapeToFitText)
     _ -> Prelude.fail (Prelude.userError "unmarshallPpAutoSize: illegal enum value ")
data PpMediaType
 = PpMediaTypeMixed
 | PpMediaTypeOther
 | PpMediaTypeSound
 | PpMediaTypeMovie
 
marshallPpMediaType :: PpMediaType -> Prelude.IO Int.Int16
marshallPpMediaType v =
  case v of
     PpMediaTypeMixed -> Prelude.return ((-2))
     PpMediaTypeOther -> Prelude.return (1)
     PpMediaTypeSound -> Prelude.return (2)
     PpMediaTypeMovie -> Prelude.return (3)
unmarshallPpMediaType :: Int.Int16 -> Prelude.IO PpMediaType
unmarshallPpMediaType v =
  case v of
     (-2) -> Prelude.return (PpMediaTypeMixed)
     1 -> Prelude.return (PpMediaTypeOther)
     2 -> Prelude.return (PpMediaTypeSound)
     3 -> Prelude.return (PpMediaTypeMovie)
     _ -> Prelude.fail (Prelude.userError "unmarshallPpMediaType: illegal enum value ")
data PpSoundFormatType
 = PpSoundFormatMixed
 | PpSoundFormatNone
 | PpSoundFormatWAV
 | PpSoundFormatMIDI
 | PpSoundFormatCDAudio
 
marshallPpSoundFormatType :: PpSoundFormatType -> Prelude.IO Int.Int16
marshallPpSoundFormatType v =
  case v of
     PpSoundFormatMixed -> Prelude.return ((-2))
     PpSoundFormatNone -> Prelude.return (0)
     PpSoundFormatWAV -> Prelude.return (1)
     PpSoundFormatMIDI -> Prelude.return (2)
     PpSoundFormatCDAudio -> Prelude.return (3)
unmarshallPpSoundFormatType :: Int.Int16 -> Prelude.IO PpSoundFormatType
unmarshallPpSoundFormatType v =
  case v of
     (-2) -> Prelude.return (PpSoundFormatMixed)
     0 -> Prelude.return (PpSoundFormatNone)
     1 -> Prelude.return (PpSoundFormatWAV)
     2 -> Prelude.return (PpSoundFormatMIDI)
     3 -> Prelude.return (PpSoundFormatCDAudio)
     _ -> Prelude.fail (Prelude.userError "unmarshallPpSoundFormatType: illegal enum value ")
data PpFarEastLineBreakLevel
 = PpFarEastLineBreakLevelNormal
 | PpFarEastLineBreakLevelStrict
 | PpFarEastLineBreakLevelCustom
 
marshallPpFarEastLineBreakLevel :: PpFarEastLineBreakLevel -> Prelude.IO Int.Int16
marshallPpFarEastLineBreakLevel v =
  case v of
     PpFarEastLineBreakLevelNormal -> Prelude.return (1)
     PpFarEastLineBreakLevelStrict -> Prelude.return (2)
     PpFarEastLineBreakLevelCustom -> Prelude.return (3)
unmarshallPpFarEastLineBreakLevel :: Int.Int16 -> Prelude.IO PpFarEastLineBreakLevel
unmarshallPpFarEastLineBreakLevel v =
  case v of
     1 -> Prelude.return (PpFarEastLineBreakLevelNormal)
     2 -> Prelude.return (PpFarEastLineBreakLevelStrict)
     3 -> Prelude.return (PpFarEastLineBreakLevelCustom)
     _ -> Prelude.fail (Prelude.userError "unmarshallPpFarEastLineBreakLevel: illegal enum value ")
data PpSlideShowRangeType
 = PpShowAll
 | PpShowSlideRange
 | PpShowNamedSlideShow
 
marshallPpSlideShowRangeType :: PpSlideShowRangeType -> Prelude.IO Int.Int16
marshallPpSlideShowRangeType v =
  case v of
     PpShowAll -> Prelude.return (1)
     PpShowSlideRange -> Prelude.return (2)
     PpShowNamedSlideShow -> Prelude.return (3)
unmarshallPpSlideShowRangeType :: Int.Int16 -> Prelude.IO PpSlideShowRangeType
unmarshallPpSlideShowRangeType v =
  case v of
     1 -> Prelude.return (PpShowAll)
     2 -> Prelude.return (PpShowSlideRange)
     3 -> Prelude.return (PpShowNamedSlideShow)
     _ -> Prelude.fail (Prelude.userError "unmarshallPpSlideShowRangeType: illegal enum value ")
-}
-- --------------------------------------------------
-- 
-- interface Collection
-- 
-- --------------------------------------------------
data Collection a = Collection
                     
type ICollection a = Automation.IDispatch (Collection a)
iidICollection :: Com.IID (ICollection Automation.Interface)
iidICollection = Com.mkIID "{91493450-5A91-11CF-8700-00AA0060263B}"
getNewEnum :: Automation.IDispatch a -> Prelude.IO (Com.IUnknown Automation.Interface)
getNewEnum =
  Automation.propertyGetID 0xfffffffc [] Automation.outIUnknown
index :: Prelude.Int -> Automation.IDispatch a -> Prelude.IO (Prelude.Int)
index index =
  Automation.functionID1 0xa [Automation.inInt index] Automation.outInt
getCount :: Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getCount = Automation.propertyGetID 0xb [] Automation.outInt
-- --------------------------------------------------
-- 
-- interface Application
-- 
-- --------------------------------------------------
data Application a = Application
                      
type IApplication a = Automation.IDispatch (Application a)
iidIApplication :: Com.IID (IApplication Automation.Interface)
iidIApplication =
  Com.mkIID "{91493442-5A91-11CF-8700-00AA0060263B}"
getPropPresentations :: IApplication a -> Prelude.IO (IPresentations Automation.Interface)
getPropPresentations =
  Automation.propertyGetID 0x7d1 [] Automation.outIDispatch
getWindows :: Automation.IDispatch a -> Prelude.IO (IDocumentWindows Automation.Interface)
getWindows =
  Automation.propertyGetID 0x7d2 [] Automation.outIDispatch
getDialogs :: Automation.IDispatch a -> Prelude.IO (IPPDialogs Automation.Interface)
getDialogs =
  Automation.propertyGetID 0x7d3 [] Automation.outIDispatch
getActiveWindow :: Automation.IDispatch a -> Prelude.IO (IDocumentWindow Automation.Interface)
getActiveWindow =
  Automation.propertyGetID 0x7d4 [] Automation.outIDispatch
getActivePresentation :: Automation.IDispatch a -> Prelude.IO (IPresentation Automation.Interface)
getActivePresentation =
  Automation.propertyGetID 0x7d5 [] Automation.outIDispatch
getSlideShowWindows :: Automation.IDispatch a -> Prelude.IO (ISlideShowWindows Automation.Interface)
getSlideShowWindows =
  Automation.propertyGetID 0x7d6 [] Automation.outIDispatch
getCommandBars :: IApplication a -> Prelude.IO (Office.ICommandBars Automation.Interface)
getCommandBars =
  Automation.propertyGetID 0x7d7 [] Automation.outIDispatch
getPath :: Automation.IDispatch a -> Prelude.IO (Prelude.String)
getPath = Automation.propertyGetID 0x7d8 [] Automation.outString
getName :: Automation.IDispatch a -> Prelude.IO (Prelude.String)
getName = Automation.propertyGetID 0o0 [] Automation.outString
getCaption :: Automation.IDispatch a -> Prelude.IO (Prelude.String)
getCaption = Automation.propertyGetID 0x7d9 [] Automation.outString
setCaption :: Prelude.String -> Automation.IDispatch a -> Prelude.IO ()
setCaption caption =
  Automation.propertySetID 0x7d9 [Automation.inString caption]
getAssistant :: Automation.IDispatch a -> Prelude.IO (Office.IAssistant Automation.Interface)
getAssistant =
  Automation.propertyGetID 0x7da [] Automation.outIDispatch
getFileSearch :: IApplication a -> Prelude.IO (Office.IFileSearch Automation.Interface)
getFileSearch =
  Automation.propertyGetID 0x7db [] Automation.outIDispatch
getFileFind :: IApplication a -> Prelude.IO (Office.IFind Automation.Interface)
getFileFind =
  Automation.propertyGetID 0x7dc [] Automation.outIDispatch
getBuild :: IApplication a -> Prelude.IO (Prelude.String)
getBuild = Automation.propertyGetID 0x7dd [] Automation.outString
getVersion :: IApplication a -> Prelude.IO (Prelude.String)
getVersion = Automation.propertyGetID 0x7de [] Automation.outString
getOperatingSystem :: IApplication a -> Prelude.IO (Prelude.String)
getOperatingSystem =
  Automation.propertyGetID 0x7df [] Automation.outString
getActivePrinter :: Automation.IDispatch a -> Prelude.IO (Prelude.String)
getActivePrinter =
  Automation.propertyGetID 0x7e0 [] Automation.outString
getCreator :: Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getCreator = Automation.propertyGetID 0x7e1 [] Automation.outInt
getAddIns :: Automation.IDispatch a -> Prelude.IO (IAddIns Automation.Interface)
getAddIns =
  Automation.propertyGetID 0x7e2 [] Automation.outIDispatch
getVBE :: IApplication a -> Prelude.IO (VBIDE.IVBE Automation.Interface)
getVBE = Automation.propertyGetID 0x7e3 [] Automation.outIDispatch
help :: Prelude.String -> Prelude.Int -> IApplication a -> Prelude.IO ()
help helpFile contextID =
  Automation.methodID0 0x7e4 [Automation.inString helpFile, Automation.inInt contextID]
quit :: IApplication a -> Prelude.IO ()
quit = Automation.methodID0 0x7e5 []
--run :: Prelude.String -> Prelude.Array -> IApplication a -> Prelude.IO (Prelude.Int)
--run macroName safeArrayOfParams =
--  Automation.functionID1 0x7e6 [Automation.inString macroName, Automation.inArray safeArrayOfParams] Automation.outInt
fileDialog :: (Automation.Variant a0) => a0 -> IApplication a -> Prelude.IO (IFileDialog Automation.Interface)
fileDialog type0 =
  Automation.functionID1 0x7e7 [Automation.inVariant type0] Automation.outIDispatch
launchSpelling :: IDocumentWindow a0 -> IApplication a -> Prelude.IO ()
launchSpelling pWindow =
  Automation.methodID0 0x7e8 [Automation.inIDispatch pWindow]
getLeft :: Automation.IDispatch a -> Prelude.IO (Prelude.Float)
getLeft = Automation.propertyGetID 0x7e9 [] Automation.outFloat
setLeft :: Prelude.Float -> Automation.IDispatch a -> Prelude.IO ()
setLeft left =
  Automation.propertySetID 0x7e9 [Automation.inFloat left]
getTop :: Automation.IDispatch a -> Prelude.IO (Prelude.Float)
getTop = Automation.propertyGetID 0x7ea [] Automation.outFloat
setTop :: Prelude.Float -> Automation.IDispatch a -> Prelude.IO ()
setTop top =
  Automation.propertySetID 0x7ea [Automation.inFloat top]
getWidth :: Automation.IDispatch a -> Prelude.IO (Prelude.Float)
getWidth = Automation.propertyGetID 0x7eb [] Automation.outFloat
setWidth :: Prelude.Float -> Automation.IDispatch a -> Prelude.IO ()
setWidth width =
  Automation.propertySetID 0x7eb [Automation.inFloat width]
getHeight :: Automation.IDispatch a -> Prelude.IO (Prelude.Float)
getHeight = Automation.propertyGetID 0x7ec [] Automation.outFloat
setHeight :: Prelude.Float -> Automation.IDispatch a -> Prelude.IO ()
setHeight height =
  Automation.propertySetID 0x7ec [Automation.inFloat height]
getWindowState :: (Automation.Variant a0) => Automation.IDispatch a -> Prelude.IO (a0)
getWindowState =
  Automation.propertyGetID 0x7ed [] Automation.outVariant
setWindowState :: (Automation.Variant a0) => a0 -> Automation.IDispatch a -> Prelude.IO ()
setWindowState windowState =
  Automation.propertySetID 0x7ed [Automation.inVariant windowState]
getVisible :: (Automation.Variant a0) => Automation.IDispatch a -> Prelude.IO (a0)
getVisible =
  Automation.propertyGetID 0x7ee [] Automation.outVariant
setVisible :: (Automation.Variant a0) => a0 -> Automation.IDispatch a -> Prelude.IO ()
setVisible visible =
  Automation.propertySetID 0x7ee [Automation.inVariant visible]
getHWND :: Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getHWND = Automation.propertyGetID 0x7ef [] Automation.outInt
getActive :: (Automation.Variant a0) => Automation.IDispatch a -> Prelude.IO (a0)
getActive = Automation.propertyGetID 0x7f0 [] Automation.outVariant
activate :: Automation.IDispatch a -> Prelude.IO ()
activate = Automation.methodID0 0x7f1 []
-- --------------------------------------------------
-- 
-- interface Global
-- 
-- --------------------------------------------------
data Global a = Global
                 
type IGlobal a = Automation.IDispatch (Global a)
iidIGlobal :: Com.IID (IGlobal Automation.Interface)
iidIGlobal = Com.mkIID "{91493451-5A91-11CF-8700-00AA0060263B}"
getApplication :: Automation.IDispatch a -> Prelude.IO (Automation.IDispatch Automation.Interface)
getApplication =
  Automation.propertyGetID 0x7d4 [] Automation.outIDispatch
getPresentations :: IGlobal a -> Prelude.IO (IPresentations Automation.Interface)
getPresentations =
  Automation.propertyGetID 0x7d7 [] Automation.outIDispatch
-- --------------------------------------------------
-- 
-- coclass CoApplication
-- 
-- --------------------------------------------------
clsidCoApplication :: Com.CLSID
clsidCoApplication =
  Com.mkCLSID "{91493441-5A91-11CF-8700-00AA0060263B}"
-- --------------------------------------------------
-- 
-- coclass CoGlobal
-- 
-- --------------------------------------------------
clsidCoGlobal :: Com.CLSID
clsidCoGlobal =
  Com.mkCLSID "{91493443-5A91-11CF-8700-00AA0060263B}"
-- --------------------------------------------------
-- 
-- interface ColorFormat
-- 
-- --------------------------------------------------
data ColorFormat a = ColorFormat
                      
type IColorFormat a = Automation.IDispatch (ColorFormat a)
iidIColorFormat :: Com.IID (IColorFormat Automation.Interface)
iidIColorFormat =
  Com.mkIID "{91493452-5A91-11CF-8700-00AA0060263B}"
getParent :: Automation.IDispatch a -> Prelude.IO (Automation.IDispatch Automation.Interface)
getParent = Automation.propertyGetID 0x1 [] Automation.outIDispatch
getRGB :: Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getRGB = Automation.propertyGetID 0o0 [] Automation.outInt
setRGB :: Prelude.Int -> Automation.IDispatch a -> Prelude.IO ()
setRGB rGB = Automation.propertySetID 0o0 [Automation.inInt rGB]
getType :: (Automation.Variant a0) => IColorFormat a -> Prelude.IO (a0)
getType = Automation.propertyGetID 0x65 [] Automation.outVariant
getSchemeColor :: (Automation.Variant a0) => IColorFormat a -> Prelude.IO (a0)
getSchemeColor =
  Automation.propertyGetID 0x7d3 [] Automation.outVariant
setSchemeColor :: (Automation.Variant a0) => a0 -> IColorFormat a -> Prelude.IO ()
setSchemeColor schemeColor =
  Automation.propertySetID 0x7d3 [Automation.inVariant schemeColor]
-- --------------------------------------------------
-- 
-- interface SlideShowWindow
-- 
-- --------------------------------------------------
data SlideShowWindow a = SlideShowWindow
                          
type ISlideShowWindow a = Automation.IDispatch (SlideShowWindow a)
iidISlideShowWindow :: Com.IID (ISlideShowWindow Automation.Interface)
iidISlideShowWindow =
  Com.mkIID "{91493453-5A91-11CF-8700-00AA0060263B}"
getView :: ISlideShowWindow a -> Prelude.IO (ISlideShowView Automation.Interface)
getView = Automation.propertyGetID 0x7d3 [] Automation.outIDispatch
getPresentation :: Automation.IDispatch a -> Prelude.IO (IPresentation Automation.Interface)
getPresentation =
  Automation.propertyGetID 0x7d4 [] Automation.outIDispatch
getIsFullScreen :: (Automation.Variant a0) => ISlideShowWindow a -> Prelude.IO (a0)
getIsFullScreen =
  Automation.propertyGetID 0x7d5 [] Automation.outVariant
-- --------------------------------------------------
-- 
-- interface Selection
-- 
-- --------------------------------------------------
data Selection a = Selection
                    
type ISelection a = Automation.IDispatch (Selection a)
iidISelection :: Com.IID (ISelection Automation.Interface)
iidISelection = Com.mkIID "{91493454-5A91-11CF-8700-00AA0060263B}"
cut :: Automation.IDispatch a -> Prelude.IO ()
cut = Automation.methodID0 0x7d3 []
copy :: Automation.IDispatch a -> Prelude.IO ()
copy = Automation.methodID0 0x7d4 []
delete :: Automation.IDispatch a -> Prelude.IO ()
delete = Automation.methodID0 0x7d5 []
unselect :: ISelection a -> Prelude.IO ()
unselect = Automation.methodID0 0x7d6 []
getType0 :: (Automation.Variant a0) => ISelection a -> Prelude.IO (a0)
getType0 = Automation.propertyGetID 0x7d7 [] Automation.outVariant
getSlideRange :: ISelection a -> Prelude.IO (ISlideRange Automation.Interface)
getSlideRange =
  Automation.propertyGetID 0x7d8 [] Automation.outIDispatch
getShapeRange :: ISelection a -> Prelude.IO (Office.IShapeRange Automation.Interface)
getShapeRange =
  Automation.propertyGetID 0x7d9 [] Automation.outIDispatch
getTextRange :: Automation.IDispatch a -> Prelude.IO (ITextRange Automation.Interface)
getTextRange =
  Automation.propertyGetID 0x7da [] Automation.outIDispatch
-- --------------------------------------------------
-- 
-- interface DocumentWindows
-- 
-- --------------------------------------------------
data DocumentWindows a = DocumentWindows
                          
type IDocumentWindows a = ICollection (DocumentWindows a)
iidIDocumentWindows :: Com.IID (IDocumentWindows Automation.Interface)
iidIDocumentWindows =
  Com.mkIID "{91493455-5A91-11CF-8700-00AA0060263B}"
item :: Prelude.Int -> IDocumentWindows a -> Prelude.IO (IDocumentWindow Automation.Interface)
item index =
  Automation.functionID1 0o0 [Automation.inInt index] Automation.outIDispatch
arrange :: (Automation.Variant a0) => a0 -> IDocumentWindows a -> Prelude.IO ()
arrange arrangeStyle =
  Automation.methodID0 0x7d3 [Automation.inVariant arrangeStyle]
-- --------------------------------------------------
-- 
-- interface SlideShowWindows
-- 
-- --------------------------------------------------
data SlideShowWindows a = SlideShowWindows
                           
type ISlideShowWindows a = ICollection (SlideShowWindows a)
iidISlideShowWindows :: Com.IID (ISlideShowWindows Automation.Interface)
iidISlideShowWindows =
  Com.mkIID "{91493456-5A91-11CF-8700-00AA0060263B}"
item0 :: Prelude.Int -> ISlideShowWindows a -> Prelude.IO (ISlideShowWindow Automation.Interface)
item0 index =
  Automation.functionID1 0o0 [Automation.inInt index] Automation.outIDispatch
-- --------------------------------------------------
-- 
-- interface DocumentWindow
-- 
-- --------------------------------------------------
data DocumentWindow a = DocumentWindow
                         
type IDocumentWindow a = Automation.IDispatch (DocumentWindow a)
iidIDocumentWindow :: Com.IID (IDocumentWindow Automation.Interface)
iidIDocumentWindow =
  Com.mkIID "{91493457-5A91-11CF-8700-00AA0060263B}"
getSelection :: IDocumentWindow a -> Prelude.IO (ISelection Automation.Interface)
getSelection =
  Automation.propertyGetID 0x7d3 [] Automation.outIDispatch
getView0 :: IDocumentWindow a -> Prelude.IO (IView Automation.Interface)
getView0 =
  Automation.propertyGetID 0x7d4 [] Automation.outIDispatch
getViewType :: (Automation.Variant a0) => IDocumentWindow a -> Prelude.IO (a0)
getViewType =
  Automation.propertyGetID 0x7d6 [] Automation.outVariant
setViewType :: (Automation.Variant a0) => a0 -> IDocumentWindow a -> Prelude.IO ()
setViewType viewType =
  Automation.propertySetID 0x7d6 [Automation.inVariant viewType]
getBlackAndWhite :: (Automation.Variant a0) => IDocumentWindow a -> Prelude.IO (a0)
getBlackAndWhite =
  Automation.propertyGetID 0x7d7 [] Automation.outVariant
setBlackAndWhite :: (Automation.Variant a0) => a0 -> IDocumentWindow a -> Prelude.IO ()
setBlackAndWhite blackAndWhite =
  Automation.propertySetID 0x7d7 [Automation.inVariant blackAndWhite]
fitToPage :: IDocumentWindow a -> Prelude.IO ()
fitToPage = Automation.methodID0 0x7de []
largeScroll :: Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> IDocumentWindow a -> Prelude.IO ()
largeScroll down up toRight toLeft =
  Automation.methodID0 0x7e0 [Automation.inInt down, Automation.inInt up, Automation.inInt toRight, Automation.inInt toLeft]
smallScroll :: Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> IDocumentWindow a -> Prelude.IO ()
smallScroll down up toRight toLeft =
  Automation.methodID0 0x7e1 [Automation.inInt down, Automation.inInt up, Automation.inInt toRight, Automation.inInt toLeft]
newWindow :: Automation.IDispatch a -> Prelude.IO (IDocumentWindow Automation.Interface)
newWindow = Automation.functionID1 0x7e2 [] Automation.outIDispatch
close :: Automation.IDispatch a -> Prelude.IO ()
close = Automation.methodID0 0x7e3 []
-- --------------------------------------------------
-- 
-- interface View
-- 
-- --------------------------------------------------
data View a = View
               
type IView a = Automation.IDispatch (View a)
iidIView :: Com.IID (IView Automation.Interface)
iidIView = Com.mkIID "{91493458-5A91-11CF-8700-00AA0060263B}"
getType1 :: (Automation.Variant a0) => IView a -> Prelude.IO (a0)
getType1 = Automation.propertyGetID 0x7d3 [] Automation.outVariant
getZoom :: Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getZoom = Automation.propertyGetID 0x7d4 [] Automation.outInt
setZoom :: Prelude.Int -> IView a -> Prelude.IO ()
setZoom zoom =
  Automation.propertySetID 0x7d4 [Automation.inInt zoom]
paste :: IView a -> Prelude.IO ()
paste = Automation.methodID0 0x7d5 []
getSlide :: IView a -> Prelude.IO (Automation.IDispatch Automation.Interface)
getSlide =
  Automation.propertyGetID 0x7d6 [] Automation.outIDispatch
setSlide :: Automation.IDispatch a0 -> IView a -> Prelude.IO ()
setSlide slide =
  Automation.propertySetID 0x7d6 [Automation.inIDispatch slide]
gotoSlide :: Prelude.Int -> IView a -> Prelude.IO ()
gotoSlide index =
  Automation.methodID0 0x7d7 [Automation.inInt index]
getDisplaySlideMiniature :: (Automation.Variant a0) => IView a -> Prelude.IO (a0)
getDisplaySlideMiniature =
  Automation.propertyGetID 0x7d8 [] Automation.outVariant
setDisplaySlideMiniature :: (Automation.Variant a0) => a0 -> IView a -> Prelude.IO ()
setDisplaySlideMiniature displaySlideMiniature =
  Automation.propertySetID 0x7d8 [Automation.inVariant displaySlideMiniature]
getZoomToFit :: (Automation.Variant a0) => IView a -> Prelude.IO (a0)
getZoomToFit =
  Automation.propertyGetID 0x7d9 [] Automation.outVariant
setZoomToFit :: (Automation.Variant a0) => a0 -> IView a -> Prelude.IO ()
setZoomToFit zoomToFit =
  Automation.propertySetID 0x7d9 [Automation.inVariant zoomToFit]
-- --------------------------------------------------
-- 
-- interface SlideShowView
-- 
-- --------------------------------------------------
data SlideShowView a = SlideShowView
                        
type ISlideShowView a = Automation.IDispatch (SlideShowView a)
iidISlideShowView :: Com.IID (ISlideShowView Automation.Interface)
iidISlideShowView =
  Com.mkIID "{91493459-5A91-11CF-8700-00AA0060263B}"
getSlide0 :: ISlideShowView a -> Prelude.IO (ISlide Automation.Interface)
getSlide0 =
  Automation.propertyGetID 0x7d4 [] Automation.outIDispatch
getPointerType :: (Automation.Variant a0) => ISlideShowView a -> Prelude.IO (a0)
getPointerType =
  Automation.propertyGetID 0x7d5 [] Automation.outVariant
setPointerType :: (Automation.Variant a0) => a0 -> ISlideShowView a -> Prelude.IO ()
setPointerType pointerType =
  Automation.propertySetID 0x7d5 [Automation.inVariant pointerType]
getState :: (Automation.Variant a0) => ISlideShowView a -> Prelude.IO (a0)
getState = Automation.propertyGetID 0x7d6 [] Automation.outVariant
setState :: (Automation.Variant a0) => a0 -> ISlideShowView a -> Prelude.IO ()
setState state =
  Automation.propertySetID 0x7d6 [Automation.inVariant state]
getAcceleratorsEnabled :: (Automation.Variant a0) => ISlideShowView a -> Prelude.IO (a0)
getAcceleratorsEnabled =
  Automation.propertyGetID 0x7d7 [] Automation.outVariant
setAcceleratorsEnabled :: (Automation.Variant a0) => a0 -> ISlideShowView a -> Prelude.IO ()
setAcceleratorsEnabled acceleratorsEnabled =
  Automation.propertySetID 0x7d7 [Automation.inVariant acceleratorsEnabled]
getPresentationElapsedTime :: ISlideShowView a -> Prelude.IO (Prelude.Float)
getPresentationElapsedTime =
  Automation.propertyGetID 0x7d8 [] Automation.outFloat
getSlideElapsedTime :: ISlideShowView a -> Prelude.IO (Prelude.Float)
getSlideElapsedTime =
  Automation.propertyGetID 0x7d9 [] Automation.outFloat
setSlideElapsedTime :: Prelude.Float -> ISlideShowView a -> Prelude.IO ()
setSlideElapsedTime slideElapsedTime =
  Automation.propertySetID 0x7d9 [Automation.inFloat slideElapsedTime]
getLastSlideViewed :: ISlideShowView a -> Prelude.IO (ISlide Automation.Interface)
getLastSlideViewed =
  Automation.propertyGetID 0x7da [] Automation.outIDispatch
getAdvanceMode :: (Automation.Variant a0) => Automation.IDispatch a -> Prelude.IO (a0)
getAdvanceMode =
  Automation.propertyGetID 0x7db [] Automation.outVariant
getPointerColor :: Automation.IDispatch a -> Prelude.IO (IColorFormat Automation.Interface)
getPointerColor =
  Automation.propertyGetID 0x7dc [] Automation.outIDispatch
getIsNamedShow :: (Automation.Variant a0) => ISlideShowView a -> Prelude.IO (a0)
getIsNamedShow =
  Automation.propertyGetID 0x7dd [] Automation.outVariant
getSlideShowName :: Automation.IDispatch a -> Prelude.IO (Prelude.String)
getSlideShowName =
  Automation.propertyGetID 0x7de [] Automation.outString
drawLine :: Prelude.Float -> Prelude.Float -> Prelude.Float -> Prelude.Float -> ISlideShowView a -> Prelude.IO ()
drawLine beginX beginY endX endY =
  Automation.methodID0 0x7df [Automation.inFloat beginX, Automation.inFloat beginY, Automation.inFloat endX, Automation.inFloat endY]
eraseDrawing :: ISlideShowView a -> Prelude.IO ()
eraseDrawing = Automation.methodID0 0x7e0 []
first :: ISlideShowView a -> Prelude.IO ()
first = Automation.methodID0 0x7e1 []
last :: ISlideShowView a -> Prelude.IO ()
last = Automation.methodID0 0x7e2 []
next :: ISlideShowView a -> Prelude.IO ()
next = Automation.methodID0 0x7e3 []
previous :: ISlideShowView a -> Prelude.IO ()
previous = Automation.methodID0 0x7e4 []
gotoSlide0 :: (Automation.Variant a0) => Prelude.Int -> a0 -> Automation.IDispatch a -> Prelude.IO ()
gotoSlide0 index resetSlide =
  Automation.methodID0 0x7e5 [Automation.inInt index, Automation.inVariant resetSlide]
gotoNamedShow :: Prelude.String -> ISlideShowView a -> Prelude.IO ()
gotoNamedShow slideShowName =
  Automation.methodID0 0x7e6 [Automation.inString slideShowName]
endNamedShow :: ISlideShowView a -> Prelude.IO ()
endNamedShow = Automation.methodID0 0x7e7 []
resetSlideTime :: ISlideShowView a -> Prelude.IO ()
resetSlideTime = Automation.methodID0 0x7e8 []
exit :: ISlideShowView a -> Prelude.IO ()
exit = Automation.methodID0 0x7e9 []
--installTracker :: (Automation.Variant a1) => IMouseTracker a0 -> a1 -> ISlideShowView a -> Prelude.IO ()
--installTracker pTracker presenter =
--  Automation.methodID0 0x7ea [Automation.inIDispatch pTracker, Automation.inVariant presenter]
getCurrentShowPosition :: ISlideShowView a -> Prelude.IO (Prelude.Int)
getCurrentShowPosition =
  Automation.propertyGetID 0x7eb [] Automation.outInt
-- --------------------------------------------------
-- 
-- interface SlideShowSettings
-- 
-- --------------------------------------------------
data SlideShowSettings a = SlideShowSettings
                            
type ISlideShowSettings a = Automation.IDispatch (SlideShowSettings a)
iidISlideShowSettings :: Com.IID (ISlideShowSettings Automation.Interface)
iidISlideShowSettings =
  Com.mkIID "{9149345A-5A91-11CF-8700-00AA0060263B}"
getNamedSlideShows :: ISlideShowSettings a -> Prelude.IO (INamedSlideShows Automation.Interface)
getNamedSlideShows =
  Automation.propertyGetID 0x7d4 [] Automation.outIDispatch
getStartingSlide :: ISlideShowSettings a -> Prelude.IO (Prelude.Int)
getStartingSlide =
  Automation.propertyGetID 0x7d5 [] Automation.outInt
setStartingSlide :: Prelude.Int -> ISlideShowSettings a -> Prelude.IO ()
setStartingSlide startingSlide =
  Automation.propertySetID 0x7d5 [Automation.inInt startingSlide]
getEndingSlide :: ISlideShowSettings a -> Prelude.IO (Prelude.Int)
getEndingSlide =
  Automation.propertyGetID 0x7d6 [] Automation.outInt
setEndingSlide :: Prelude.Int -> ISlideShowSettings a -> Prelude.IO ()
setEndingSlide endingSlide =
  Automation.propertySetID 0x7d6 [Automation.inInt endingSlide]
setAdvanceMode :: (Automation.Variant a0) => a0 -> ISlideShowSettings a -> Prelude.IO ()
setAdvanceMode advanceMode =
  Automation.propertySetID 0x7d7 [Automation.inVariant advanceMode]
run0 :: ISlideShowSettings a -> Prelude.IO (ISlideShowWindow Automation.Interface)
run0 = Automation.functionID1 0x7d8 [] Automation.outIDispatch
getLoopUntilStopped :: (Automation.Variant a0) => Automation.IDispatch a -> Prelude.IO (a0)
getLoopUntilStopped =
  Automation.propertyGetID 0x7d9 [] Automation.outVariant
setLoopUntilStopped :: (Automation.Variant a0) => a0 -> Automation.IDispatch a -> Prelude.IO ()
setLoopUntilStopped loopUntilStopped =
  Automation.propertySetID 0x7d9 [Automation.inVariant loopUntilStopped]
getShowType :: (Automation.Variant a0) => ISlideShowSettings a -> Prelude.IO (a0)
getShowType =
  Automation.propertyGetID 0x7da [] Automation.outVariant
setShowType :: (Automation.Variant a0) => a0 -> ISlideShowSettings a -> Prelude.IO ()
setShowType showType =
  Automation.propertySetID 0x7da [Automation.inVariant showType]
getShowWithNarration :: (Automation.Variant a0) => ISlideShowSettings a -> Prelude.IO (a0)
getShowWithNarration =
  Automation.propertyGetID 0x7db [] Automation.outVariant
setShowWithNarration :: (Automation.Variant a0) => a0 -> ISlideShowSettings a -> Prelude.IO ()
setShowWithNarration showWithNarration =
  Automation.propertySetID 0x7db [Automation.inVariant showWithNarration]
getShowWithAnimation :: (Automation.Variant a0) => ISlideShowSettings a -> Prelude.IO (a0)
getShowWithAnimation =
  Automation.propertyGetID 0x7dc [] Automation.outVariant
setShowWithAnimation :: (Automation.Variant a0) => a0 -> ISlideShowSettings a -> Prelude.IO ()
setShowWithAnimation showWithAnimation =
  Automation.propertySetID 0x7dc [Automation.inVariant showWithAnimation]
setSlideShowName :: Prelude.String -> Automation.IDispatch a -> Prelude.IO ()
setSlideShowName slideShowName =
  Automation.propertySetID 0x7dd [Automation.inString slideShowName]
getRangeType :: (Automation.Variant a0) => ISlideShowSettings a -> Prelude.IO (a0)
getRangeType =
  Automation.propertyGetID 0x7de [] Automation.outVariant
setRangeType :: (Automation.Variant a0) => a0 -> ISlideShowSettings a -> Prelude.IO ()
setRangeType rangeType =
  Automation.propertySetID 0x7de [Automation.inVariant rangeType]
-- --------------------------------------------------
-- 
-- interface NamedSlideShows
-- 
-- --------------------------------------------------
data NamedSlideShows a = NamedSlideShows
                          
type INamedSlideShows a = ICollection (NamedSlideShows a)
iidINamedSlideShows :: Com.IID (INamedSlideShows Automation.Interface)
iidINamedSlideShows =
  Com.mkIID "{9149345B-5A91-11CF-8700-00AA0060263B}"
item1 :: Prelude.Int -> INamedSlideShows a -> Prelude.IO (INamedSlideShow Automation.Interface)
item1 index =
  Automation.functionID1 0o0 [Automation.inInt index] Automation.outIDispatch
add :: Prelude.String -> Prelude.Int -> INamedSlideShows a -> Prelude.IO (INamedSlideShow Automation.Interface)
add name safeArrayOfSlideIDs =
  Automation.functionID1 0x7d3 [Automation.inString name, Automation.inInt safeArrayOfSlideIDs] Automation.outIDispatch
-- --------------------------------------------------
-- 
-- interface NamedSlideShow
-- 
-- --------------------------------------------------
data NamedSlideShow a = NamedSlideShow
                         
type INamedSlideShow a = Automation.IDispatch (NamedSlideShow a)
iidINamedSlideShow :: Com.IID (INamedSlideShow Automation.Interface)
iidINamedSlideShow =
  Com.mkIID "{9149345C-5A91-11CF-8700-00AA0060263B}"
getSlideIDs :: INamedSlideShow a -> Prelude.IO (Prelude.Int)
getSlideIDs = Automation.propertyGetID 0x7d5 [] Automation.outInt
-- --------------------------------------------------
-- 
-- interface PrintOptions
-- 
-- --------------------------------------------------
data PrintOptions a = PrintOptions
                       
type IPrintOptions a = Automation.IDispatch (PrintOptions a)
iidIPrintOptions :: Com.IID (IPrintOptions Automation.Interface)
iidIPrintOptions =
  Com.mkIID "{9149345D-5A91-11CF-8700-00AA0060263B}"
getPrintColorType :: (Automation.Variant a0) => IPrintOptions a -> Prelude.IO (a0)
getPrintColorType =
  Automation.propertyGetID 0x7d2 [] Automation.outVariant
setPrintColorType :: (Automation.Variant a0) => a0 -> IPrintOptions a -> Prelude.IO ()
setPrintColorType printColorType =
  Automation.propertySetID 0x7d2 [Automation.inVariant printColorType]
getCollate :: (Automation.Variant a0) => IPrintOptions a -> Prelude.IO (a0)
getCollate =
  Automation.propertyGetID 0x7d3 [] Automation.outVariant
setCollate :: (Automation.Variant a0) => a0 -> IPrintOptions a -> Prelude.IO ()
setCollate collate =
  Automation.propertySetID 0x7d3 [Automation.inVariant collate]
getFitToPage :: (Automation.Variant a0) => Automation.IDispatch a -> Prelude.IO (a0)
getFitToPage =
  Automation.propertyGetID 0x7d4 [] Automation.outVariant
setFitToPage :: (Automation.Variant a0) => a0 -> Automation.IDispatch a -> Prelude.IO ()
setFitToPage fitToPage =
  Automation.propertySetID 0x7d4 [Automation.inVariant fitToPage]
getFrameSlides :: (Automation.Variant a0) => IPrintOptions a -> Prelude.IO (a0)
getFrameSlides =
  Automation.propertyGetID 0x7d5 [] Automation.outVariant
setFrameSlides :: (Automation.Variant a0) => a0 -> IPrintOptions a -> Prelude.IO ()
setFrameSlides frameSlides =
  Automation.propertySetID 0x7d5 [Automation.inVariant frameSlides]
getNumberOfCopies :: IPrintOptions a -> Prelude.IO (Prelude.Int)
getNumberOfCopies =
  Automation.propertyGetID 0x7d6 [] Automation.outInt
setNumberOfCopies :: Prelude.Int -> IPrintOptions a -> Prelude.IO ()
setNumberOfCopies numberOfCopies =
  Automation.propertySetID 0x7d6 [Automation.inInt numberOfCopies]
getOutputType :: (Automation.Variant a0) => IPrintOptions a -> Prelude.IO (a0)
getOutputType =
  Automation.propertyGetID 0x7d7 [] Automation.outVariant
setOutputType :: (Automation.Variant a0) => a0 -> IPrintOptions a -> Prelude.IO ()
setOutputType outputType =
  Automation.propertySetID 0x7d7 [Automation.inVariant outputType]
getPrintHiddenSlides :: (Automation.Variant a0) => IPrintOptions a -> Prelude.IO (a0)
getPrintHiddenSlides =
  Automation.propertyGetID 0x7d9 [] Automation.outVariant
setPrintHiddenSlides :: (Automation.Variant a0) => a0 -> IPrintOptions a -> Prelude.IO ()
setPrintHiddenSlides printHiddenSlides =
  Automation.propertySetID 0x7d9 [Automation.inVariant printHiddenSlides]
getPrintInBackground :: (Automation.Variant a0) => IPrintOptions a -> Prelude.IO (a0)
getPrintInBackground =
  Automation.propertyGetID 0x7da [] Automation.outVariant
setPrintInBackground :: (Automation.Variant a0) => a0 -> IPrintOptions a -> Prelude.IO ()
setPrintInBackground printInBackground =
  Automation.propertySetID 0x7da [Automation.inVariant printInBackground]
getRangeType0 :: (Automation.Variant a0) => IPrintOptions a -> Prelude.IO (a0)
getRangeType0 =
  Automation.propertyGetID 0x7db [] Automation.outVariant
setRangeType0 :: (Automation.Variant a0) => a0 -> IPrintOptions a -> Prelude.IO ()
setRangeType0 rangeType =
  Automation.propertySetID 0x7db [Automation.inVariant rangeType]
getRanges :: IPrintOptions a -> Prelude.IO (IPrintRanges Automation.Interface)
getRanges =
  Automation.propertyGetID 0x7dc [] Automation.outIDispatch
getPrintFontsAsGraphics :: (Automation.Variant a0) => IPrintOptions a -> Prelude.IO (a0)
getPrintFontsAsGraphics =
  Automation.propertyGetID 0x7dd [] Automation.outVariant
setPrintFontsAsGraphics :: (Automation.Variant a0) => a0 -> IPrintOptions a -> Prelude.IO ()
setPrintFontsAsGraphics printFontsAsGraphics =
  Automation.propertySetID 0x7dd [Automation.inVariant printFontsAsGraphics]
setActivePrinter :: Prelude.String -> IPrintOptions a -> Prelude.IO ()
setActivePrinter activePrinter =
  Automation.propertySetID 0x7df [Automation.inString activePrinter]
-- --------------------------------------------------
-- 
-- interface PrintRanges
-- 
-- --------------------------------------------------
data PrintRanges a = PrintRanges
                      
type IPrintRanges a = ICollection (PrintRanges a)
iidIPrintRanges :: Com.IID (IPrintRanges Automation.Interface)
iidIPrintRanges =
  Com.mkIID "{9149345E-5A91-11CF-8700-00AA0060263B}"
add0 :: Prelude.Int -> Prelude.Int -> IPrintRanges a -> Prelude.IO (IPrintRange Automation.Interface)
add0 start end =
  Automation.functionID1 0x7d1 [Automation.inInt start, Automation.inInt end] Automation.outIDispatch
clearAll :: IPrintRanges a -> Prelude.IO ()
clearAll = Automation.methodID0 0x7d3 []
item2 :: Prelude.Int -> IPrintRanges a -> Prelude.IO (IPrintRange Automation.Interface)
item2 index =
  Automation.functionID1 0o0 [Automation.inInt index] Automation.outIDispatch
-- --------------------------------------------------
-- 
-- interface PrintRange
-- 
-- --------------------------------------------------
data PrintRange a = PrintRange
                     
type IPrintRange a = Automation.IDispatch (PrintRange a)
iidIPrintRange :: Com.IID (IPrintRange Automation.Interface)
iidIPrintRange = Com.mkIID "{9149345F-5A91-11CF-8700-00AA0060263B}"
getStart :: Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getStart = Automation.propertyGetID 0x7d3 [] Automation.outInt
getEnd :: IPrintRange a -> Prelude.IO (Prelude.Int)
getEnd = Automation.propertyGetID 0x7d4 [] Automation.outInt
-- --------------------------------------------------
-- 
-- interface AddIns
-- 
-- --------------------------------------------------
data AddIns a = AddIns
                 
type IAddIns a = ICollection (AddIns a)
iidIAddIns :: Com.IID (IAddIns Automation.Interface)
iidIAddIns = Com.mkIID "{91493460-5A91-11CF-8700-00AA0060263B}"
item3 :: Prelude.Int -> IAddIns a -> Prelude.IO (IAddIn Automation.Interface)
item3 index =
  Automation.functionID1 0o0 [Automation.inInt index] Automation.outIDispatch
add1 :: Prelude.String -> IAddIns a -> Prelude.IO (IAddIn Automation.Interface)
add1 fileName =
  Automation.functionID1 0x7d3 [Automation.inString fileName] Automation.outIDispatch
remove :: Prelude.Int -> IAddIns a -> Prelude.IO ()
remove index = Automation.methodID0 0x7d4 [Automation.inInt index]
-- --------------------------------------------------
-- 
-- interface AddIn
-- 
-- --------------------------------------------------
data AddIn a = AddIn
                
type IAddIn a = Automation.IDispatch (AddIn a)
iidIAddIn :: Com.IID (IAddIn Automation.Interface)
iidIAddIn = Com.mkIID "{91493461-5A91-11CF-8700-00AA0060263B}"
getFullName :: Automation.IDispatch a -> Prelude.IO (Prelude.String)
getFullName =
  Automation.propertyGetID 0x7d3 [] Automation.outString
getRegistered :: (Automation.Variant a0) => IAddIn a -> Prelude.IO (a0)
getRegistered =
  Automation.propertyGetID 0x7d6 [] Automation.outVariant
setRegistered :: (Automation.Variant a0) => a0 -> IAddIn a -> Prelude.IO ()
setRegistered registered =
  Automation.propertySetID 0x7d6 [Automation.inVariant registered]
getAutoLoad :: (Automation.Variant a0) => IAddIn a -> Prelude.IO (a0)
getAutoLoad =
  Automation.propertyGetID 0x7d7 [] Automation.outVariant
setAutoLoad :: (Automation.Variant a0) => a0 -> IAddIn a -> Prelude.IO ()
setAutoLoad autoLoad =
  Automation.propertySetID 0x7d7 [Automation.inVariant autoLoad]
getLoaded :: (Automation.Variant a0) => IAddIn a -> Prelude.IO (a0)
getLoaded = Automation.propertyGetID 0x7d8 [] Automation.outVariant
setLoaded :: (Automation.Variant a0) => a0 -> IAddIn a -> Prelude.IO ()
setLoaded loaded =
  Automation.propertySetID 0x7d8 [Automation.inVariant loaded]
getDisplayAlerts :: (Automation.Variant a0) => IAddIn a -> Prelude.IO (a0)
getDisplayAlerts =
  Automation.propertyGetID 0x7d9 [] Automation.outVariant
setDisplayAlerts :: (Automation.Variant a0) => a0 -> IAddIn a -> Prelude.IO ()
setDisplayAlerts displayAlerts =
  Automation.propertySetID 0x7d9 [Automation.inVariant displayAlerts]
getRegisteredInHKLM :: (Automation.Variant a0) => IAddIn a -> Prelude.IO (a0)
getRegisteredInHKLM =
  Automation.propertyGetID 0x7da [] Automation.outVariant
-- --------------------------------------------------
-- 
-- interface Presentations
-- 
-- --------------------------------------------------
data Presentations a = Presentations
                        
type IPresentations a = ICollection (Presentations a)
iidIPresentations :: Com.IID (IPresentations Automation.Interface)
iidIPresentations =
  Com.mkIID "{91493462-5A91-11CF-8700-00AA0060263B}"
item4 :: Prelude.Int -> IPresentations a -> Prelude.IO (IPresentation Automation.Interface)
item4 index =
  Automation.functionID1 0o0 [Automation.inInt index] Automation.outIDispatch
add2 :: (Automation.Variant a0) => a0 -> IPresentations a -> Prelude.IO (IPresentation Automation.Interface)
add2 withWindow =
  Automation.functionID1 0x7d3 [Automation.inVariant withWindow] Automation.outIDispatch
open :: (Automation.Variant a0, Automation.Variant a1, Automation.Variant a2) => Prelude.String -> a0 -> a1 -> a2 -> IPresentations a -> Prelude.IO (IPresentation Automation.Interface)
open fileName readOnly untitled withWindow =
  Automation.functionID1 0x7d4 [Automation.inString fileName, Automation.inVariant readOnly, Automation.inVariant untitled, Automation.inVariant withWindow] Automation.outIDispatch
-- --------------------------------------------------
-- 
-- interface PresEvents
-- 
-- --------------------------------------------------
-- --------------------------------------------------
-- 
-- coclass CoPresentation
-- 
-- --------------------------------------------------
clsidCoPresentation :: Com.CLSID
clsidCoPresentation =
  Com.mkCLSID "{91493444-5A91-11CF-8700-00AA0060263B}"
-- --------------------------------------------------
-- 
-- interface Hyperlinks
-- 
-- --------------------------------------------------
data Hyperlinks a = Hyperlinks
                     
type IHyperlinks a = ICollection (Hyperlinks a)
iidIHyperlinks :: Com.IID (IHyperlinks Automation.Interface)
iidIHyperlinks = Com.mkIID "{91493464-5A91-11CF-8700-00AA0060263B}"
item5 :: Prelude.Int -> IHyperlinks a -> Prelude.IO (IHyperlink Automation.Interface)
item5 index =
  Automation.functionID1 0o0 [Automation.inInt index] Automation.outIDispatch
-- --------------------------------------------------
-- 
-- interface Hyperlink
-- 
-- --------------------------------------------------
data Hyperlink a = Hyperlink
                    
type IHyperlink a = Automation.IDispatch (Hyperlink a)
iidIHyperlink :: Com.IID (IHyperlink Automation.Interface)
iidIHyperlink = Com.mkIID "{91493465-5A91-11CF-8700-00AA0060263B}"
getType2 :: (Automation.Variant a0) => IHyperlink a -> Prelude.IO (a0)
getType2 = Automation.propertyGetID 0x7d3 [] Automation.outVariant
getAddress :: IHyperlink a -> Prelude.IO (Prelude.String)
getAddress = Automation.propertyGetID 0x7d4 [] Automation.outString
setAddress :: Prelude.String -> IHyperlink a -> Prelude.IO ()
setAddress address =
  Automation.propertySetID 0x7d4 [Automation.inString address]
getSubAddress :: IHyperlink a -> Prelude.IO (Prelude.String)
getSubAddress =
  Automation.propertyGetID 0x7d5 [] Automation.outString
setSubAddress :: Prelude.String -> IHyperlink a -> Prelude.IO ()
setSubAddress subAddress =
  Automation.propertySetID 0x7d5 [Automation.inString subAddress]
addToFavorites :: Automation.IDispatch a -> Prelude.IO ()
addToFavorites = Automation.methodID0 0x7d6 []
-- --------------------------------------------------
-- 
-- interface PageSetup
-- 
-- --------------------------------------------------
data PageSetup a = PageSetup
                    
type IPageSetup a = Automation.IDispatch (PageSetup a)
iidIPageSetup :: Com.IID (IPageSetup Automation.Interface)
iidIPageSetup = Com.mkIID "{91493466-5A91-11CF-8700-00AA0060263B}"
getFirstSlideNumber :: IPageSetup a -> Prelude.IO (Prelude.Int)
getFirstSlideNumber =
  Automation.propertyGetID 0x7d3 [] Automation.outInt
setFirstSlideNumber :: Prelude.Int -> IPageSetup a -> Prelude.IO ()
setFirstSlideNumber firstSlideNumber =
  Automation.propertySetID 0x7d3 [Automation.inInt firstSlideNumber]
getSlideHeight :: IPageSetup a -> Prelude.IO (Prelude.Float)
getSlideHeight =
  Automation.propertyGetID 0x7d4 [] Automation.outFloat
setSlideHeight :: Prelude.Float -> IPageSetup a -> Prelude.IO ()
setSlideHeight slideHeight =
  Automation.propertySetID 0x7d4 [Automation.inFloat slideHeight]
getSlideWidth :: IPageSetup a -> Prelude.IO (Prelude.Float)
getSlideWidth =
  Automation.propertyGetID 0x7d5 [] Automation.outFloat
setSlideWidth :: Prelude.Float -> IPageSetup a -> Prelude.IO ()
setSlideWidth slideWidth =
  Automation.propertySetID 0x7d5 [Automation.inFloat slideWidth]
getSlideSize :: (Automation.Variant a0) => IPageSetup a -> Prelude.IO (a0)
getSlideSize =
  Automation.propertyGetID 0x7d6 [] Automation.outVariant
setSlideSize :: (Automation.Variant a0) => a0 -> IPageSetup a -> Prelude.IO ()
setSlideSize slideSize =
  Automation.propertySetID 0x7d6 [Automation.inVariant slideSize]
getNotesOrientation :: (Automation.Variant a0) => IPageSetup a -> Prelude.IO (a0)
getNotesOrientation =
  Automation.propertyGetID 0x7d7 [] Automation.outVariant
setNotesOrientation :: (Automation.Variant a0) => a0 -> IPageSetup a -> Prelude.IO ()
setNotesOrientation notesOrientation =
  Automation.propertySetID 0x7d7 [Automation.inVariant notesOrientation]
getSlideOrientation :: (Automation.Variant a0) => IPageSetup a -> Prelude.IO (a0)
getSlideOrientation =
  Automation.propertyGetID 0x7d8 [] Automation.outVariant
setSlideOrientation :: (Automation.Variant a0) => a0 -> IPageSetup a -> Prelude.IO ()
setSlideOrientation slideOrientation =
  Automation.propertySetID 0x7d8 [Automation.inVariant slideOrientation]
-- --------------------------------------------------
-- 
-- interface Fonts
-- 
-- --------------------------------------------------
data Fonts a = Fonts
                
type IFonts a = ICollection (Fonts a)
iidIFonts :: Com.IID (IFonts Automation.Interface)
iidIFonts = Com.mkIID "{91493467-5A91-11CF-8700-00AA0060263B}"
item6 :: Prelude.Int -> IFonts a -> Prelude.IO (IFont Automation.Interface)
item6 index =
  Automation.functionID1 0o0 [Automation.inInt index] Automation.outIDispatch
replace :: Prelude.String -> Prelude.String -> IFonts a -> Prelude.IO ()
replace original replacement =
  Automation.methodID0 0x7d3 [Automation.inString original, Automation.inString replacement]
-- --------------------------------------------------
-- 
-- interface ExtraColors
-- 
-- --------------------------------------------------
data ExtraColors a = ExtraColors
                      
type IExtraColors a = ICollection (ExtraColors a)
iidIExtraColors :: Com.IID (IExtraColors Automation.Interface)
iidIExtraColors =
  Com.mkIID "{91493468-5A91-11CF-8700-00AA0060263B}"
item7 :: Prelude.Int -> IExtraColors a -> Prelude.IO (Prelude.Int)
item7 index =
  Automation.functionID1 0o0 [Automation.inInt index] Automation.outInt
add3 :: Prelude.Int -> Automation.IDispatch a -> Prelude.IO ()
add3 type0 = Automation.methodID0 0x7d3 [Automation.inInt type0]
-- --------------------------------------------------
-- 
-- interface Slides
-- 
-- --------------------------------------------------
data Slides a = Slides
                 
type ISlides a = ICollection (Slides a)
iidISlides :: Com.IID (ISlides Automation.Interface)
iidISlides = Com.mkIID "{91493469-5A91-11CF-8700-00AA0060263B}"
item8 :: Prelude.Int -> Automation.IDispatch a -> Prelude.IO (ISlide Automation.Interface)
item8 index =
  Automation.functionID1 0o0 [Automation.inInt index] Automation.outIDispatch
findBySlideID :: Prelude.Int -> ISlides a -> Prelude.IO (ISlide Automation.Interface)
findBySlideID slideID =
  Automation.functionID1 0x7d3 [Automation.inInt slideID] Automation.outIDispatch
add4 :: (Automation.Variant a0) => Prelude.Int -> a0 -> ISlides a -> Prelude.IO (ISlide Automation.Interface)
add4 index layout =
  Automation.functionID1 0x7d4 [Automation.inInt index, Automation.inVariant layout] Automation.outIDispatch
insertFromFile :: Prelude.String -> Prelude.Int -> Prelude.Int -> Prelude.Int -> ISlides a -> Prelude.IO (Prelude.Int)
insertFromFile fileName index slideStart slideEnd =
  Automation.functionID1 0x7d5 [Automation.inString fileName, Automation.inInt index, Automation.inInt slideStart, Automation.inInt slideEnd] Automation.outInt
range :: Prelude.Int -> ISlides a -> Prelude.IO (ISlideRange Automation.Interface)
range index =
  Automation.functionID1 0x7d6 [Automation.inInt index] Automation.outIDispatch
paste0 :: Prelude.Int -> Automation.IDispatch a -> Prelude.IO (ISlideRange Automation.Interface)
paste0 index =
  Automation.functionID1 0x7d7 [Automation.inInt index] Automation.outIDispatch
-- --------------------------------------------------
-- 
-- interface Slide
-- 
-- --------------------------------------------------
data Slide a = Slide
                
type ISlide a = Automation.IDispatch (Slide a)
iidISlide :: Com.IID (ISlide Automation.Interface)
iidISlide = Com.mkIID "{9149346A-5A91-11CF-8700-00AA0060263B}"
getShapes :: Automation.IDispatch a -> Prelude.IO (Office.IShapes Automation.Interface)
getShapes =
  Automation.propertyGetID 0x7d3 [] Automation.outIDispatch
getHeadersFooters :: Automation.IDispatch a -> Prelude.IO (IHeadersFooters Automation.Interface)
getHeadersFooters =
  Automation.propertyGetID 0x7d4 [] Automation.outIDispatch
getSlideShowTransition :: Automation.IDispatch a -> Prelude.IO (ISlideShowTransition Automation.Interface)
getSlideShowTransition =
  Automation.propertyGetID 0x7d5 [] Automation.outIDispatch
getColorScheme :: Automation.IDispatch a -> Prelude.IO (IColorScheme Automation.Interface)
getColorScheme =
  Automation.propertyGetID 0x7d6 [] Automation.outIDispatch
setColorScheme :: IColorScheme a0 -> Automation.IDispatch a -> Prelude.IO ()
setColorScheme colorScheme =
  Automation.propertySetID 0x7d6 [Automation.inIDispatch colorScheme]
getBackground :: Automation.IDispatch a -> Prelude.IO (Office.IShapeRange Automation.Interface)
getBackground =
  Automation.propertyGetID 0x7d7 [] Automation.outIDispatch
setName :: Prelude.String -> Automation.IDispatch a -> Prelude.IO ()
setName name =
  Automation.propertySetID 0x7d8 [Automation.inString name]
getSlideID :: Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getSlideID = Automation.propertyGetID 0x7d9 [] Automation.outInt
getPrintSteps :: Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getPrintSteps = Automation.propertyGetID 0x7da [] Automation.outInt
select :: Automation.IDispatch a -> Prelude.IO ()
select = Automation.methodID0 0x7db []
getLayout :: (Automation.Variant a0) => Automation.IDispatch a -> Prelude.IO (a0)
getLayout = Automation.propertyGetID 0x7de [] Automation.outVariant
setLayout :: (Automation.Variant a0) => a0 -> Automation.IDispatch a -> Prelude.IO ()
setLayout layout =
  Automation.propertySetID 0x7de [Automation.inVariant layout]
duplicate :: Automation.IDispatch a -> Prelude.IO (ISlideRange Automation.Interface)
duplicate = Automation.functionID1 0x7df [] Automation.outIDispatch
getTags :: Automation.IDispatch a -> Prelude.IO (ITags Automation.Interface)
getTags = Automation.propertyGetID 0x7e1 [] Automation.outIDispatch
getSlideIndex :: Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getSlideIndex = Automation.propertyGetID 0x7e2 [] Automation.outInt
getSlideNumber :: Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getSlideNumber =
  Automation.propertyGetID 0x7e3 [] Automation.outInt
getDisplayMasterShapes :: (Automation.Variant a0) => Automation.IDispatch a -> Prelude.IO (a0)
getDisplayMasterShapes =
  Automation.propertyGetID 0x7e4 [] Automation.outVariant
setDisplayMasterShapes :: (Automation.Variant a0) => a0 -> Automation.IDispatch a -> Prelude.IO ()
setDisplayMasterShapes displayMasterShapes =
  Automation.propertySetID 0x7e4 [Automation.inVariant displayMasterShapes]
getFollowMasterBackground :: (Automation.Variant a0) => Automation.IDispatch a -> Prelude.IO (a0)
getFollowMasterBackground =
  Automation.propertyGetID 0x7e5 [] Automation.outVariant
setFollowMasterBackground :: (Automation.Variant a0) => a0 -> Automation.IDispatch a -> Prelude.IO ()
setFollowMasterBackground followMasterBackground =
  Automation.propertySetID 0x7e5 [Automation.inVariant followMasterBackground]
getNotesPage :: Automation.IDispatch a -> Prelude.IO (ISlideRange Automation.Interface)
getNotesPage =
  Automation.propertyGetID 0x7e6 [] Automation.outIDispatch
getMaster :: Automation.IDispatch a -> Prelude.IO (IMaster Automation.Interface)
getMaster =
  Automation.propertyGetID 0x7e7 [] Automation.outIDispatch
getHyperlinks :: Automation.IDispatch a -> Prelude.IO (IHyperlinks Automation.Interface)
getHyperlinks =
  Automation.propertyGetID 0x7e8 [] Automation.outIDispatch
export :: Prelude.String -> Prelude.String -> Prelude.Int -> Prelude.Int -> Automation.IDispatch a -> Prelude.IO ()
export fileName filterName scaleWidth scaleHeight =
  Automation.methodID0 0x7e9 [Automation.inString fileName, Automation.inString filterName, Automation.inInt scaleWidth, Automation.inInt scaleHeight]
-- --------------------------------------------------
-- 
-- interface SlideRange
-- 
-- --------------------------------------------------
data SlideRange a = SlideRange
                     
type ISlideRange a = Automation.IDispatch (SlideRange a)
iidISlideRange :: Com.IID (ISlideRange Automation.Interface)
iidISlideRange = Com.mkIID "{9149346B-5A91-11CF-8700-00AA0060263B}"
-- --------------------------------------------------
-- 
-- interface Master
-- 
-- --------------------------------------------------
data Master a = Master
                 
type IMaster a = Automation.IDispatch (Master a)
iidIMaster :: Com.IID (IMaster Automation.Interface)
iidIMaster = Com.mkIID "{9149346C-5A91-11CF-8700-00AA0060263B}"
getTextStyles :: IMaster a -> Prelude.IO (ITextStyles Automation.Interface)
getTextStyles =
  Automation.propertyGetID 0x7db [] Automation.outIDispatch
-- --------------------------------------------------
-- 
-- interface SldEvents
-- 
-- --------------------------------------------------
-- --------------------------------------------------
-- 
-- coclass CoSlide
-- 
-- --------------------------------------------------
clsidCoSlide :: Com.CLSID
clsidCoSlide = Com.mkCLSID "{91493445-5A91-11CF-8700-00AA0060263B}"
-- --------------------------------------------------
-- 
-- interface ColorSchemes
-- 
-- --------------------------------------------------
data ColorSchemes a = ColorSchemes
                       
type IColorSchemes a = ICollection (ColorSchemes a)
iidIColorSchemes :: Com.IID (IColorSchemes Automation.Interface)
iidIColorSchemes =
  Com.mkIID "{9149346E-5A91-11CF-8700-00AA0060263B}"
item10 :: Prelude.Int -> IColorSchemes a -> Prelude.IO (IColorScheme Automation.Interface)
item10 index =
  Automation.functionID1 0o0 [Automation.inInt index] Automation.outIDispatch
add5 :: IColorScheme a0 -> IColorSchemes a -> Prelude.IO (IColorScheme Automation.Interface)
add5 scheme =
  Automation.functionID1 0x7d3 [Automation.inIDispatch scheme] Automation.outIDispatch
-- --------------------------------------------------
-- 
-- interface ColorScheme
-- 
-- --------------------------------------------------
data ColorScheme a = ColorScheme
                      
type IColorScheme a = ICollection (ColorScheme a)
iidIColorScheme :: Com.IID (IColorScheme Automation.Interface)
iidIColorScheme =
  Com.mkIID "{9149346F-5A91-11CF-8700-00AA0060263B}"
colors :: (Automation.Variant a0) => a0 -> IColorScheme a -> Prelude.IO (IRGBColor Automation.Interface)
colors schemeColor =
  Automation.functionID1 0o0 [Automation.inVariant schemeColor] Automation.outIDispatch
-- --------------------------------------------------
-- 
-- interface RGBColor
-- 
-- --------------------------------------------------
data RGBColor a = RGBColor
                   
type IRGBColor a = Automation.IDispatch (RGBColor a)
iidIRGBColor :: Com.IID (IRGBColor Automation.Interface)
iidIRGBColor = Com.mkIID "{91493470-5A91-11CF-8700-00AA0060263B}"
-- --------------------------------------------------
-- 
-- interface SlideShowTransition
-- 
-- --------------------------------------------------
data SlideShowTransition a = SlideShowTransition
                              
type ISlideShowTransition a = Automation.IDispatch (SlideShowTransition a)
iidISlideShowTransition :: Com.IID (ISlideShowTransition Automation.Interface)
iidISlideShowTransition =
  Com.mkIID "{91493471-5A91-11CF-8700-00AA0060263B}"
getAdvanceOnClick :: (Automation.Variant a0) => ISlideShowTransition a -> Prelude.IO (a0)
getAdvanceOnClick =
  Automation.propertyGetID 0x7d3 [] Automation.outVariant
setAdvanceOnClick :: (Automation.Variant a0) => a0 -> ISlideShowTransition a -> Prelude.IO ()
setAdvanceOnClick advanceOnClick =
  Automation.propertySetID 0x7d3 [Automation.inVariant advanceOnClick]
getAdvanceOnTime :: (Automation.Variant a0) => ISlideShowTransition a -> Prelude.IO (a0)
getAdvanceOnTime =
  Automation.propertyGetID 0x7d4 [] Automation.outVariant
setAdvanceOnTime :: (Automation.Variant a0) => a0 -> ISlideShowTransition a -> Prelude.IO ()
setAdvanceOnTime advanceOnTime =
  Automation.propertySetID 0x7d4 [Automation.inVariant advanceOnTime]
getAdvanceTime :: Automation.IDispatch a -> Prelude.IO (Prelude.Float)
getAdvanceTime =
  Automation.propertyGetID 0x7d5 [] Automation.outFloat
setAdvanceTime :: Prelude.Float -> Automation.IDispatch a -> Prelude.IO ()
setAdvanceTime advanceTime =
  Automation.propertySetID 0x7d5 [Automation.inFloat advanceTime]
getEntryEffect :: (Automation.Variant a0) => Automation.IDispatch a -> Prelude.IO (a0)
getEntryEffect =
  Automation.propertyGetID 0x7d6 [] Automation.outVariant
setEntryEffect :: (Automation.Variant a0) => a0 -> Automation.IDispatch a -> Prelude.IO ()
setEntryEffect entryEffect =
  Automation.propertySetID 0x7d6 [Automation.inVariant entryEffect]
getHidden :: (Automation.Variant a0) => ISlideShowTransition a -> Prelude.IO (a0)
getHidden = Automation.propertyGetID 0x7d7 [] Automation.outVariant
setHidden :: (Automation.Variant a0) => a0 -> ISlideShowTransition a -> Prelude.IO ()
setHidden hidden =
  Automation.propertySetID 0x7d7 [Automation.inVariant hidden]
getLoopSoundUntilNext :: (Automation.Variant a0) => ISlideShowTransition a -> Prelude.IO (a0)
getLoopSoundUntilNext =
  Automation.propertyGetID 0x7d8 [] Automation.outVariant
setLoopSoundUntilNext :: (Automation.Variant a0) => a0 -> ISlideShowTransition a -> Prelude.IO ()
setLoopSoundUntilNext loopSoundUntilNext =
  Automation.propertySetID 0x7d8 [Automation.inVariant loopSoundUntilNext]
getSoundEffect :: Automation.IDispatch a -> Prelude.IO (ISoundEffect Automation.Interface)
getSoundEffect =
  Automation.propertyGetID 0x7d9 [] Automation.outIDispatch
getSpeed :: (Automation.Variant a0) => ISlideShowTransition a -> Prelude.IO (a0)
getSpeed = Automation.propertyGetID 0x7da [] Automation.outVariant
setSpeed :: (Automation.Variant a0) => a0 -> ISlideShowTransition a -> Prelude.IO ()
setSpeed speed =
  Automation.propertySetID 0x7da [Automation.inVariant speed]
-- --------------------------------------------------
-- 
-- interface SoundEffect
-- 
-- --------------------------------------------------
data SoundEffect a = SoundEffect
                      
type ISoundEffect a = Automation.IDispatch (SoundEffect a)
iidISoundEffect :: Com.IID (ISoundEffect Automation.Interface)
iidISoundEffect =
  Com.mkIID "{91493472-5A91-11CF-8700-00AA0060263B}"
getType3 :: (Automation.Variant a0) => ISoundEffect a -> Prelude.IO (a0)
getType3 = Automation.propertyGetID 0x7d4 [] Automation.outVariant
setType :: (Automation.Variant a0) => a0 -> ISoundEffect a -> Prelude.IO ()
setType type0 =
  Automation.propertySetID 0x7d4 [Automation.inVariant type0]
importFromFile :: Prelude.String -> ISoundEffect a -> Prelude.IO ()
importFromFile fileName =
  Automation.methodID0 0x7d5 [Automation.inString fileName]
play :: Automation.IDispatch a -> Prelude.IO ()
play = Automation.methodID0 0x7d6 []
-- --------------------------------------------------
-- 
-- interface SoundFormat
-- 
-- --------------------------------------------------
data SoundFormat a = SoundFormat
                      
type ISoundFormat a = Automation.IDispatch (SoundFormat a)
iidISoundFormat :: Com.IID (ISoundFormat Automation.Interface)
iidISoundFormat =
  Com.mkIID "{91493473-5A91-11CF-8700-00AA0060263B}"
import0 :: Prelude.String -> ISoundFormat a -> Prelude.IO ()
import0 fileName =
  Automation.methodID0 0x7d1 [Automation.inString fileName]
export1 :: (Automation.Variant a0) => Prelude.String -> ISoundFormat a -> Prelude.IO (a0)
export1 fileName =
  Automation.functionID1 0x7d2 [Automation.inString fileName] Automation.outVariant
getType4 :: (Automation.Variant a0) => ISoundFormat a -> Prelude.IO (a0)
getType4 = Automation.propertyGetID 0x7d3 [] Automation.outVariant
getSourceFullName :: Automation.IDispatch a -> Prelude.IO (Prelude.String)
getSourceFullName =
  Automation.propertyGetID 0x7d4 [] Automation.outString
-- --------------------------------------------------
-- 
-- interface HeadersFooters
-- 
-- --------------------------------------------------
data HeadersFooters a = HeadersFooters
                         
type IHeadersFooters a = Automation.IDispatch (HeadersFooters a)
iidIHeadersFooters :: Com.IID (IHeadersFooters Automation.Interface)
iidIHeadersFooters =
  Com.mkIID "{91493474-5A91-11CF-8700-00AA0060263B}"
getDateAndTime :: IHeadersFooters a -> Prelude.IO (IHeaderFooter Automation.Interface)
getDateAndTime =
  Automation.propertyGetID 0x7d3 [] Automation.outIDispatch
getSlideNumber1 :: IHeadersFooters a -> Prelude.IO (IHeaderFooter Automation.Interface)
getSlideNumber1 =
  Automation.propertyGetID 0x7d4 [] Automation.outIDispatch
getHeader :: IHeadersFooters a -> Prelude.IO (IHeaderFooter Automation.Interface)
getHeader =
  Automation.propertyGetID 0x7d5 [] Automation.outIDispatch
getFooter :: IHeadersFooters a -> Prelude.IO (IHeaderFooter Automation.Interface)
getFooter =
  Automation.propertyGetID 0x7d6 [] Automation.outIDispatch
getDisplayOnTitleSlide :: (Automation.Variant a0) => IHeadersFooters a -> Prelude.IO (a0)
getDisplayOnTitleSlide =
  Automation.propertyGetID 0x7d7 [] Automation.outVariant
setDisplayOnTitleSlide :: (Automation.Variant a0) => a0 -> IHeadersFooters a -> Prelude.IO ()
setDisplayOnTitleSlide displayOnTitleSlide =
  Automation.propertySetID 0x7d7 [Automation.inVariant displayOnTitleSlide]
clear :: Automation.IDispatch a -> Prelude.IO ()
clear = Automation.methodID0 0x7d8 []
-- --------------------------------------------------
-- 
-- interface Shapes
-- 
-- --------------------------------------------------
data Shapes a = Shapes
                 
type IShapes a = Automation.IDispatch (Shapes a)
iidIShapes :: Com.IID (IShapes Automation.Interface)
iidIShapes = Com.mkIID "{91493475-5A91-11CF-8700-00AA0060263B}"
item11 :: Prelude.Int -> Automation.IDispatch a -> Prelude.IO (Office.IShape Automation.Interface)
item11 index =
  Automation.functionID1 0o0 [Automation.inInt index] Automation.outIDispatch
addCallout :: (Automation.Variant a0) => a0 -> Prelude.Float -> Prelude.Float -> Prelude.Float -> Prelude.Float -> IShapes a -> Prelude.IO (Office.IShape Automation.Interface)
addCallout type0 left top width height =
  Automation.functionID1 0xa [Automation.inVariant type0, Automation.inFloat left, Automation.inFloat top, Automation.inFloat width, Automation.inFloat height] Automation.outIDispatch
addConnector :: (Automation.Variant a0) => a0 -> Prelude.Float -> Prelude.Float -> Prelude.Float -> Prelude.Float -> IShapes a -> Prelude.IO (Office.IShape Automation.Interface)
addConnector type0 beginX beginY endX endY =
  Automation.functionID1 0xb [Automation.inVariant type0, Automation.inFloat beginX, Automation.inFloat beginY, Automation.inFloat endX, Automation.inFloat endY] Automation.outIDispatch
addCurve :: Prelude.Int -> IShapes a -> Prelude.IO (Office.IShape Automation.Interface)
addCurve safeArrayOfPoints =
  Automation.functionID1 0xc [Automation.inInt safeArrayOfPoints] Automation.outIDispatch
addLabel :: (Automation.Variant a0) => a0 -> Prelude.Float -> Prelude.Float -> Prelude.Float -> Prelude.Float -> IShapes a -> Prelude.IO (Office.IShape Automation.Interface)
addLabel orientation left top width height =
  Automation.functionID1 0xd [Automation.inVariant orientation, Automation.inFloat left, Automation.inFloat top, Automation.inFloat width, Automation.inFloat height] Automation.outIDispatch
addLine :: Prelude.Float -> Prelude.Float -> Prelude.Float -> Prelude.Float -> IShapes a -> Prelude.IO (Office.IShape Automation.Interface)
addLine beginX beginY endX endY =
  Automation.functionID1 0xe [Automation.inFloat beginX, Automation.inFloat beginY, Automation.inFloat endX, Automation.inFloat endY] Automation.outIDispatch
addPicture :: (Automation.Variant a0, Automation.Variant a1) => Prelude.String -> a0 -> a1 -> Prelude.Float -> Prelude.Float -> Prelude.Float -> Prelude.Float -> IShapes a -> Prelude.IO (Office.IShape Automation.Interface)
addPicture fileName linkToFile saveWithDocument left top width height =
  Automation.functionID1 0xf [Automation.inString fileName, Automation.inVariant linkToFile, Automation.inVariant saveWithDocument, Automation.inFloat left, Automation.inFloat top, Automation.inFloat width, Automation.inFloat height] Automation.outIDispatch
addPolyline :: Prelude.Int -> IShapes a -> Prelude.IO (Office.IShape Automation.Interface)
addPolyline safeArrayOfPoints =
  Automation.functionID1 0x10 [Automation.inInt safeArrayOfPoints] Automation.outIDispatch
addShape :: (Automation.Variant a0) => a0 -> Prelude.Float -> Prelude.Float -> Prelude.Float -> Prelude.Float -> IShapes a -> Prelude.IO (Office.IShape Automation.Interface)
addShape type0 left top width height =
  Automation.functionID1 0x11 [Automation.inVariant type0, Automation.inFloat left, Automation.inFloat top, Automation.inFloat width, Automation.inFloat height] Automation.outIDispatch
addTextEffect :: (Automation.Variant a0, Automation.Variant a1, Automation.Variant a2) => a0 -> Prelude.String -> Prelude.String -> Prelude.Float -> a1 -> a2 -> Prelude.Float -> Prelude.Float -> IShapes a -> Prelude.IO (Office.IShape Automation.Interface)
addTextEffect presetTextEffect text fontName fontSize fontBold fontItalic left top =
  Automation.functionID1 0x12 [Automation.inVariant presetTextEffect, Automation.inString text, Automation.inString fontName, Automation.inFloat fontSize, Automation.inVariant fontBold, Automation.inVariant fontItalic, Automation.inFloat left, Automation.inFloat top] Automation.outIDispatch
addTextbox :: (Automation.Variant a0) => a0 -> Prelude.Float -> Prelude.Float -> Prelude.Float -> Prelude.Float -> IShapes a -> Prelude.IO (Office.IShape Automation.Interface)
addTextbox orientation left top width height =
  Automation.functionID1 0x13 [Automation.inVariant orientation, Automation.inFloat left, Automation.inFloat top, Automation.inFloat width, Automation.inFloat height] Automation.outIDispatch
buildFreeform :: (Automation.Variant a0) => a0 -> Prelude.Float -> Prelude.Float -> IShapes a -> Prelude.IO (Office.IFreeformBuilder Automation.Interface)
buildFreeform editingType x1 y1 =
  Automation.functionID1 0x14 [Automation.inVariant editingType, Automation.inFloat x1, Automation.inFloat y1] Automation.outIDispatch
selectAll :: IShapes a -> Prelude.IO ()
selectAll = Automation.methodID0 0x16 []
range0 :: Prelude.Int -> IShapes a -> Prelude.IO (Office.IShapeRange Automation.Interface)
range0 index =
  Automation.functionID1 0x7d3 [Automation.inInt index] Automation.outIDispatch
getHasTitle :: (Automation.Variant a0) => IShapes a -> Prelude.IO (a0)
getHasTitle =
  Automation.propertyGetID 0x7d4 [] Automation.outVariant
addTitle :: IShapes a -> Prelude.IO (Office.IShape Automation.Interface)
addTitle = Automation.functionID1 0x7d5 [] Automation.outIDispatch
getTitle :: IShapes a -> Prelude.IO (Office.IShape Automation.Interface)
getTitle =
  Automation.propertyGetID 0x7d6 [] Automation.outIDispatch
getPlaceholders :: IShapes a -> Prelude.IO (IPlaceholders Automation.Interface)
getPlaceholders =
  Automation.propertyGetID 0x7d7 [] Automation.outIDispatch
addOLEObject :: (Automation.Variant a0, Automation.Variant a1) => Prelude.Float -> Prelude.Float -> Prelude.Float -> Prelude.Float -> Prelude.String -> Prelude.String -> a0 -> Prelude.String -> Prelude.Int -> Prelude.String -> a1 -> IShapes a -> Prelude.IO (Office.IShape Automation.Interface)
addOLEObject left top width height className fileName displayAsIcon iconFileName iconIndex iconLabel link =
  Automation.functionID1 0x7d8 [Automation.inFloat left, Automation.inFloat top, Automation.inFloat width, Automation.inFloat height, Automation.inString className, Automation.inString fileName, Automation.inVariant displayAsIcon, Automation.inString iconFileName, Automation.inInt iconIndex, Automation.inString iconLabel, Automation.inVariant link] Automation.outIDispatch
addComment :: Prelude.Float -> Prelude.Float -> Prelude.Float -> Prelude.Float -> IShapes a -> Prelude.IO (Office.IShape Automation.Interface)
addComment left top width height =
  Automation.functionID1 0x7d9 [Automation.inFloat left, Automation.inFloat top, Automation.inFloat width, Automation.inFloat height] Automation.outIDispatch
addPlaceholder :: (Automation.Variant a0) => a0 -> Prelude.Float -> Prelude.Float -> Prelude.Float -> Prelude.Float -> IShapes a -> Prelude.IO (Office.IShape Automation.Interface)
addPlaceholder type0 left top width height =
  Automation.functionID1 0x7da [Automation.inVariant type0, Automation.inFloat left, Automation.inFloat top, Automation.inFloat width, Automation.inFloat height] Automation.outIDispatch
addMediaObject :: Prelude.String -> Prelude.Float -> Prelude.Float -> Prelude.Float -> Prelude.Float -> IShapes a -> Prelude.IO (Office.IShape Automation.Interface)
addMediaObject fileName left top width height =
  Automation.functionID1 0x7db [Automation.inString fileName, Automation.inFloat left, Automation.inFloat top, Automation.inFloat width, Automation.inFloat height] Automation.outIDispatch
paste1 :: Automation.IDispatch a -> Prelude.IO (Office.IShapeRange Automation.Interface)
paste1 = Automation.functionID1 0x7dc [] Automation.outIDispatch
-- --------------------------------------------------
-- 
-- interface Placeholders
-- 
-- --------------------------------------------------
data Placeholders a = Placeholders
                       
type IPlaceholders a = ICollection (Placeholders a)
iidIPlaceholders :: Com.IID (IPlaceholders Automation.Interface)
iidIPlaceholders =
  Com.mkIID "{91493476-5A91-11CF-8700-00AA0060263B}"
-- --------------------------------------------------
-- 
-- interface PlaceholderFormat
-- 
-- --------------------------------------------------
data PlaceholderFormat a = PlaceholderFormat
                            
type IPlaceholderFormat a = Automation.IDispatch (PlaceholderFormat a)
iidIPlaceholderFormat :: Com.IID (IPlaceholderFormat Automation.Interface)
iidIPlaceholderFormat =
  Com.mkIID "{91493477-5A91-11CF-8700-00AA0060263B}"
getType5 :: (Automation.Variant a0) => IPlaceholderFormat a -> Prelude.IO (a0)
getType5 = Automation.propertyGetID 0x7d3 [] Automation.outVariant
-- --------------------------------------------------
-- 
-- interface FreeformBuilder
-- 
-- --------------------------------------------------
data FreeformBuilder a = FreeformBuilder
                          
type IFreeformBuilder a = Automation.IDispatch (FreeformBuilder a)
iidIFreeformBuilder :: Com.IID (IFreeformBuilder Automation.Interface)
iidIFreeformBuilder =
  Com.mkIID "{91493478-5A91-11CF-8700-00AA0060263B}"
addNodes :: (Automation.Variant a0, Automation.Variant a1) => a0 -> a1 -> Prelude.Float -> Prelude.Float -> Prelude.Float -> Prelude.Float -> Prelude.Float -> Prelude.Float -> IFreeformBuilder a -> Prelude.IO ()
addNodes segmentType editingType x1 y1 x2 y2 x3 y3 =
  Automation.methodID0 0xa [Automation.inVariant segmentType, Automation.inVariant editingType, Automation.inFloat x1, Automation.inFloat y1, Automation.inFloat x2, Automation.inFloat y2, Automation.inFloat x3, Automation.inFloat y3]
convertToShape :: IFreeformBuilder a -> Prelude.IO (Office.IShape Automation.Interface)
convertToShape =
  Automation.functionID1 0xb [] Automation.outIDispatch
-- --------------------------------------------------
-- 
-- interface Shape
-- 
-- --------------------------------------------------
data Shape a = Shape
                
type IShape a = Automation.IDispatch (Shape a)
iidIShape :: Com.IID (IShape Automation.Interface)
iidIShape = Com.mkIID "{91493479-5A91-11CF-8700-00AA0060263B}"
apply :: Automation.IDispatch a -> Prelude.IO ()
apply = Automation.methodID0 0xa []
flip :: (Automation.Variant a0) => a0 -> Automation.IDispatch a -> Prelude.IO ()
flip flipCmd =
  Automation.methodID0 0xd [Automation.inVariant flipCmd]
incrementLeft :: Prelude.Float -> Automation.IDispatch a -> Prelude.IO ()
incrementLeft increment =
  Automation.methodID0 0xe [Automation.inFloat increment]
incrementRotation :: Prelude.Float -> Automation.IDispatch a -> Prelude.IO ()
incrementRotation increment =
  Automation.methodID0 0xf [Automation.inFloat increment]
incrementTop :: Prelude.Float -> Automation.IDispatch a -> Prelude.IO ()
incrementTop increment =
  Automation.methodID0 0x10 [Automation.inFloat increment]
pickUp :: Automation.IDispatch a -> Prelude.IO ()
pickUp = Automation.methodID0 0x11 []
rerouteConnections :: Automation.IDispatch a -> Prelude.IO ()
rerouteConnections = Automation.methodID0 0x12 []
scaleHeight :: (Automation.Variant a0, Automation.Variant a1) => Prelude.Float -> a0 -> a1 -> Automation.IDispatch a -> Prelude.IO ()
scaleHeight factor relativeToOriginalSize fScale =
  Automation.methodID0 0x13 [Automation.inFloat factor, Automation.inVariant relativeToOriginalSize, Automation.inVariant fScale]
scaleWidth :: (Automation.Variant a0, Automation.Variant a1) => Prelude.Float -> a0 -> a1 -> Automation.IDispatch a -> Prelude.IO ()
scaleWidth factor relativeToOriginalSize fScale =
  Automation.methodID0 0x14 [Automation.inFloat factor, Automation.inVariant relativeToOriginalSize, Automation.inVariant fScale]
setShapesDefaultProperties :: Automation.IDispatch a -> Prelude.IO ()
setShapesDefaultProperties = Automation.methodID0 0x16 []
ungroup :: IShape a -> Prelude.IO (Office.IShapeRange Automation.Interface)
ungroup = Automation.functionID1 0x17 [] Automation.outIDispatch
zOrder :: (Automation.Variant a0) => a0 -> Automation.IDispatch a -> Prelude.IO ()
zOrder zOrderCmd =
  Automation.methodID0 0x18 [Automation.inVariant zOrderCmd]
getAdjustments :: Automation.IDispatch a -> Prelude.IO (Office.IAdjustments Automation.Interface)
getAdjustments =
  Automation.propertyGetID 0x64 [] Automation.outIDispatch
getAutoShapeType :: (Automation.Variant a0) => Automation.IDispatch a -> Prelude.IO (a0)
getAutoShapeType =
  Automation.propertyGetID 0x65 [] Automation.outVariant
setAutoShapeType :: (Automation.Variant a0) => a0 -> Automation.IDispatch a -> Prelude.IO ()
setAutoShapeType autoShapeType =
  Automation.propertySetID 0x65 [Automation.inVariant autoShapeType]
getBlackWhiteMode :: (Automation.Variant a0) => Automation.IDispatch a -> Prelude.IO (a0)
getBlackWhiteMode =
  Automation.propertyGetID 0x66 [] Automation.outVariant
setBlackWhiteMode :: (Automation.Variant a0) => a0 -> Automation.IDispatch a -> Prelude.IO ()
setBlackWhiteMode blackWhiteMode =
  Automation.propertySetID 0x66 [Automation.inVariant blackWhiteMode]
getCallout :: Automation.IDispatch a -> Prelude.IO (Office.ICalloutFormat Automation.Interface)
getCallout =
  Automation.propertyGetID 0x67 [] Automation.outIDispatch
getConnectionSiteCount :: Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getConnectionSiteCount =
  Automation.propertyGetID 0x68 [] Automation.outInt
getConnector :: (Automation.Variant a0) => Automation.IDispatch a -> Prelude.IO (a0)
getConnector =
  Automation.propertyGetID 0x69 [] Automation.outVariant
getConnectorFormat :: Automation.IDispatch a -> Prelude.IO (Office.IConnectorFormat Automation.Interface)
getConnectorFormat =
  Automation.propertyGetID 0x6a [] Automation.outIDispatch
getFill :: Automation.IDispatch a -> Prelude.IO (Office.IFillFormat Automation.Interface)
getFill = Automation.propertyGetID 0x6b [] Automation.outIDispatch
getGroupItems :: Automation.IDispatch a -> Prelude.IO (Office.IGroupShapes Automation.Interface)
getGroupItems =
  Automation.propertyGetID 0x6c [] Automation.outIDispatch
getHorizontalFlip :: (Automation.Variant a0) => Automation.IDispatch a -> Prelude.IO (a0)
getHorizontalFlip =
  Automation.propertyGetID 0x6e [] Automation.outVariant
getLine :: Automation.IDispatch a -> Prelude.IO (Office.ILineFormat Automation.Interface)
getLine = Automation.propertyGetID 0x70 [] Automation.outIDispatch
getLockAspectRatio :: (Automation.Variant a0) => Automation.IDispatch a -> Prelude.IO (a0)
getLockAspectRatio =
  Automation.propertyGetID 0x71 [] Automation.outVariant
setLockAspectRatio :: (Automation.Variant a0) => a0 -> Automation.IDispatch a -> Prelude.IO ()
setLockAspectRatio lockAspectRatio =
  Automation.propertySetID 0x71 [Automation.inVariant lockAspectRatio]
getNodes :: Automation.IDispatch a -> Prelude.IO (Office.IShapeNodes Automation.Interface)
getNodes = Automation.propertyGetID 0x74 [] Automation.outIDispatch
getRotation :: Automation.IDispatch a -> Prelude.IO (Prelude.Float)
getRotation = Automation.propertyGetID 0x75 [] Automation.outFloat
setRotation :: Prelude.Float -> Automation.IDispatch a -> Prelude.IO ()
setRotation rotation =
  Automation.propertySetID 0x75 [Automation.inFloat rotation]
getPictureFormat :: Automation.IDispatch a -> Prelude.IO (Office.IPictureFormat Automation.Interface)
getPictureFormat =
  Automation.propertyGetID 0x76 [] Automation.outIDispatch
getShadow :: Automation.IDispatch a -> Prelude.IO (Office.IShadowFormat Automation.Interface)
getShadow =
  Automation.propertyGetID 0x77 [] Automation.outIDispatch
getTextEffect :: Automation.IDispatch a -> Prelude.IO (Office.ITextEffectFormat Automation.Interface)
getTextEffect =
  Automation.propertyGetID 0x78 [] Automation.outIDispatch
getTextFrame :: Automation.IDispatch a -> Prelude.IO (Office.ITextFrame Automation.Interface)
getTextFrame =
  Automation.propertyGetID 0x79 [] Automation.outIDispatch
getThreeD :: Automation.IDispatch a -> Prelude.IO (Office.IThreeDFormat Automation.Interface)
getThreeD =
  Automation.propertyGetID 0x7a [] Automation.outIDispatch
getType6 :: (Automation.Variant a0) => Automation.IDispatch a -> Prelude.IO (a0)
getType6 = Automation.propertyGetID 0x7c [] Automation.outVariant
getVerticalFlip :: (Automation.Variant a0) => Automation.IDispatch a -> Prelude.IO (a0)
getVerticalFlip =
  Automation.propertyGetID 0x7d [] Automation.outVariant
getVertices :: Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getVertices = Automation.propertyGetID 0x7e [] Automation.outInt
getZOrderPosition :: Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getZOrderPosition =
  Automation.propertyGetID 0x81 [] Automation.outInt
getOLEFormat :: Automation.IDispatch a -> Prelude.IO (IOLEFormat Automation.Interface)
getOLEFormat =
  Automation.propertyGetID 0x7d3 [] Automation.outIDispatch
getLinkFormat :: Automation.IDispatch a -> Prelude.IO (ILinkFormat Automation.Interface)
getLinkFormat =
  Automation.propertyGetID 0x7d4 [] Automation.outIDispatch
getPlaceholderFormat :: Automation.IDispatch a -> Prelude.IO (IPlaceholderFormat Automation.Interface)
getPlaceholderFormat =
  Automation.propertyGetID 0x7d5 [] Automation.outIDispatch
getAnimationSettings :: Automation.IDispatch a -> Prelude.IO (IAnimationSettings Automation.Interface)
getAnimationSettings =
  Automation.propertyGetID 0x7d6 [] Automation.outIDispatch
getActionSettings :: Automation.IDispatch a -> Prelude.IO (IActionSettings Automation.Interface)
getActionSettings =
  Automation.propertyGetID 0x7d7 [] Automation.outIDispatch
select1 :: (Automation.Variant a0) => a0 -> Automation.IDispatch a -> Prelude.IO ()
select1 replace =
  Automation.methodID0 0x7db [Automation.inVariant replace]
duplicate1 :: IShape a -> Prelude.IO (Office.IShapeRange Automation.Interface)
duplicate1 =
  Automation.functionID1 0x7dc [] Automation.outIDispatch
getMediaType :: (Automation.Variant a0) => Automation.IDispatch a -> Prelude.IO (a0)
getMediaType =
  Automation.propertyGetID 0x7dd [] Automation.outVariant
getHasTextFrame :: (Automation.Variant a0) => Automation.IDispatch a -> Prelude.IO (a0)
getHasTextFrame =
  Automation.propertyGetID 0x7de [] Automation.outVariant
getSoundFormat :: Automation.IDispatch a -> Prelude.IO (ISoundFormat Automation.Interface)
getSoundFormat =
  Automation.propertyGetID 0x7df [] Automation.outIDispatch
-- --------------------------------------------------
-- 
-- interface ShapeRange
-- 
-- --------------------------------------------------
data ShapeRange a = ShapeRange
                     
type IShapeRange a = Automation.IDispatch (ShapeRange a)
iidIShapeRange :: Com.IID (IShapeRange Automation.Interface)
iidIShapeRange = Com.mkIID "{9149347A-5A91-11CF-8700-00AA0060263B}"
ungroup0 :: IShapeRange a -> Prelude.IO (IShapeRange Automation.Interface)
ungroup0 = Automation.functionID1 0x17 [] Automation.outIDispatch
duplicate2 :: IShapeRange a -> Prelude.IO (IShapeRange Automation.Interface)
duplicate2 =
  Automation.functionID1 0x7dc [] Automation.outIDispatch
item13 :: Prelude.Int -> Automation.IDispatch a -> Prelude.IO (IShape Automation.Interface)
item13 index =
  Automation.functionID1 0o0 [Automation.inInt index] Automation.outIDispatch
group :: IShapeRange a -> Prelude.IO (IShape Automation.Interface)
group = Automation.functionID1 0x7e0 [] Automation.outIDispatch
regroup :: IShapeRange a -> Prelude.IO (IShape Automation.Interface)
regroup = Automation.functionID1 0x7e1 [] Automation.outIDispatch
align :: (Automation.Variant a0, Automation.Variant a1) => a0 -> a1 -> IShapeRange a -> Prelude.IO ()
align alignCmd relativeTo =
  Automation.methodID0 0x7e2 [Automation.inVariant alignCmd, Automation.inVariant relativeTo]
distribute :: (Automation.Variant a0, Automation.Variant a1) => a0 -> a1 -> IShapeRange a -> Prelude.IO ()
distribute distributeCmd relativeTo =
  Automation.methodID0 0x7e3 [Automation.inVariant distributeCmd, Automation.inVariant relativeTo]
getPolygonalRepresentation :: (Automation.Variant a0) => Prelude.Int -> Prelude.Float -> IShapeRange a -> Prelude.IO (Prelude.Int, a0)
getPolygonalRepresentation maxPointsInBuffer pPoints =
  Automation.methodID2 0x7e4 [Automation.inInt maxPointsInBuffer, Automation.inFloat pPoints] Automation.outInt Automation.outVariant
-- --------------------------------------------------
-- 
-- interface GroupShapes
-- 
-- --------------------------------------------------
data GroupShapes a = GroupShapes
                      
type IGroupShapes a = Automation.IDispatch (GroupShapes a)
iidIGroupShapes :: Com.IID (IGroupShapes Automation.Interface)
iidIGroupShapes =
  Com.mkIID "{9149347B-5A91-11CF-8700-00AA0060263B}"
-- --------------------------------------------------
-- 
-- interface Adjustments
-- 
-- --------------------------------------------------
data Adjustments a = Adjustments
                      
type IAdjustments a = Automation.IDispatch (Adjustments a)
iidIAdjustments :: Com.IID (IAdjustments Automation.Interface)
iidIAdjustments =
  Com.mkIID "{9149347C-5A91-11CF-8700-00AA0060263B}"
getItem :: Prelude.Int -> IAdjustments a -> Prelude.IO (Prelude.Float)
getItem index =
  Automation.propertyGetID 0o0 [Automation.inInt index] Automation.outFloat
setItem :: Prelude.Int -> Prelude.Float -> IAdjustments a -> Prelude.IO ()
setItem index val =
  Automation.propertySetID 0o0 [Automation.inInt index, Automation.inFloat val]
-- --------------------------------------------------
-- 
-- interface PictureFormat
-- 
-- --------------------------------------------------
data PictureFormat a = PictureFormat
                        
type IPictureFormat a = Automation.IDispatch (PictureFormat a)
iidIPictureFormat :: Com.IID (IPictureFormat Automation.Interface)
iidIPictureFormat =
  Com.mkIID "{9149347D-5A91-11CF-8700-00AA0060263B}"
incrementBrightness :: Prelude.Float -> IPictureFormat a -> Prelude.IO ()
incrementBrightness increment =
  Automation.methodID0 0xa [Automation.inFloat increment]
incrementContrast :: Prelude.Float -> IPictureFormat a -> Prelude.IO ()
incrementContrast increment =
  Automation.methodID0 0xb [Automation.inFloat increment]
getBrightness :: IPictureFormat a -> Prelude.IO (Prelude.Float)
getBrightness =
  Automation.propertyGetID 0x64 [] Automation.outFloat
setBrightness :: Prelude.Float -> IPictureFormat a -> Prelude.IO ()
setBrightness brightness =
  Automation.propertySetID 0x64 [Automation.inFloat brightness]
getColorType :: (Automation.Variant a0) => IPictureFormat a -> Prelude.IO (a0)
getColorType =
  Automation.propertyGetID 0x65 [] Automation.outVariant
setColorType :: (Automation.Variant a0) => a0 -> IPictureFormat a -> Prelude.IO ()
setColorType colorType =
  Automation.propertySetID 0x65 [Automation.inVariant colorType]
getContrast :: IPictureFormat a -> Prelude.IO (Prelude.Float)
getContrast = Automation.propertyGetID 0x66 [] Automation.outFloat
setContrast :: Prelude.Float -> IPictureFormat a -> Prelude.IO ()
setContrast contrast =
  Automation.propertySetID 0x66 [Automation.inFloat contrast]
getCropBottom :: IPictureFormat a -> Prelude.IO (Prelude.Float)
getCropBottom =
  Automation.propertyGetID 0x67 [] Automation.outFloat
setCropBottom :: Prelude.Float -> IPictureFormat a -> Prelude.IO ()
setCropBottom cropBottom =
  Automation.propertySetID 0x67 [Automation.inFloat cropBottom]
getCropLeft :: IPictureFormat a -> Prelude.IO (Prelude.Float)
getCropLeft = Automation.propertyGetID 0x68 [] Automation.outFloat
setCropLeft :: Prelude.Float -> IPictureFormat a -> Prelude.IO ()
setCropLeft cropLeft =
  Automation.propertySetID 0x68 [Automation.inFloat cropLeft]
getCropRight :: IPictureFormat a -> Prelude.IO (Prelude.Float)
getCropRight = Automation.propertyGetID 0x69 [] Automation.outFloat
setCropRight :: Prelude.Float -> IPictureFormat a -> Prelude.IO ()
setCropRight cropRight =
  Automation.propertySetID 0x69 [Automation.inFloat cropRight]
getCropTop :: IPictureFormat a -> Prelude.IO (Prelude.Float)
getCropTop = Automation.propertyGetID 0x6a [] Automation.outFloat
setCropTop :: Prelude.Float -> IPictureFormat a -> Prelude.IO ()
setCropTop cropTop =
  Automation.propertySetID 0x6a [Automation.inFloat cropTop]
getTransparencyColor :: IPictureFormat a -> Prelude.IO (Prelude.Int)
getTransparencyColor =
  Automation.propertyGetID 0x6b [] Automation.outInt
setTransparencyColor :: Prelude.Int -> IPictureFormat a -> Prelude.IO ()
setTransparencyColor transparencyColor =
  Automation.propertySetID 0x6b [Automation.inInt transparencyColor]
getTransparentBackground :: (Automation.Variant a0) => IPictureFormat a -> Prelude.IO (a0)
getTransparentBackground =
  Automation.propertyGetID 0x6c [] Automation.outVariant
setTransparentBackground :: (Automation.Variant a0) => a0 -> IPictureFormat a -> Prelude.IO ()
setTransparentBackground transparentBackground =
  Automation.propertySetID 0x6c [Automation.inVariant transparentBackground]
-- --------------------------------------------------
-- 
-- interface FillFormat
-- 
-- --------------------------------------------------
data FillFormat a = FillFormat
                     
type IFillFormat a = Automation.IDispatch (FillFormat a)
iidIFillFormat :: Com.IID (IFillFormat Automation.Interface)
iidIFillFormat = Com.mkIID "{9149347E-5A91-11CF-8700-00AA0060263B}"
background :: Automation.IDispatch a -> Prelude.IO ()
background = Automation.methodID0 0xa []
oneColorGradient :: (Automation.Variant a0) => a0 -> Prelude.Int -> Prelude.Float -> IFillFormat a -> Prelude.IO ()
oneColorGradient style variant degree =
  Automation.methodID0 0xb [Automation.inVariant style, Automation.inInt variant, Automation.inFloat degree]
patterned :: (Automation.Variant a0) => a0 -> IFillFormat a -> Prelude.IO ()
patterned pattern =
  Automation.methodID0 0xc [Automation.inVariant pattern]
presetGradient :: (Automation.Variant a0, Automation.Variant a1) => a0 -> Prelude.Int -> a1 -> IFillFormat a -> Prelude.IO ()
presetGradient style variant presetGradientType =
  Automation.methodID0 0xd [Automation.inVariant style, Automation.inInt variant, Automation.inVariant presetGradientType]
presetTextured :: (Automation.Variant a0) => a0 -> IFillFormat a -> Prelude.IO ()
presetTextured presetTexture =
  Automation.methodID0 0xe [Automation.inVariant presetTexture]
solid :: IFillFormat a -> Prelude.IO ()
solid = Automation.methodID0 0xf []
twoColorGradient :: (Automation.Variant a0) => a0 -> Prelude.Int -> IFillFormat a -> Prelude.IO ()
twoColorGradient style variant =
  Automation.methodID0 0x10 [Automation.inVariant style, Automation.inInt variant]
userPicture :: Prelude.String -> IFillFormat a -> Prelude.IO ()
userPicture pictureFile =
  Automation.methodID0 0x11 [Automation.inString pictureFile]
userTextured :: Prelude.String -> IFillFormat a -> Prelude.IO ()
userTextured textureFile =
  Automation.methodID0 0x12 [Automation.inString textureFile]
getBackColor :: Automation.IDispatch a -> Prelude.IO (IColorFormat Automation.Interface)
getBackColor =
  Automation.propertyGetID 0x64 [] Automation.outIDispatch
setBackColor :: IColorFormat a0 -> Automation.IDispatch a -> Prelude.IO ()
setBackColor backColor =
  Automation.propertySetID 0x64 [Automation.inIDispatch backColor]
getForeColor :: Automation.IDispatch a -> Prelude.IO (IColorFormat Automation.Interface)
getForeColor =
  Automation.propertyGetID 0x65 [] Automation.outIDispatch
setForeColor :: IColorFormat a0 -> Automation.IDispatch a -> Prelude.IO ()
setForeColor foreColor =
  Automation.propertySetID 0x65 [Automation.inIDispatch foreColor]
getGradientColorType :: (Automation.Variant a0) => IFillFormat a -> Prelude.IO (a0)
getGradientColorType =
  Automation.propertyGetID 0x66 [] Automation.outVariant
getGradientDegree :: IFillFormat a -> Prelude.IO (Prelude.Float)
getGradientDegree =
  Automation.propertyGetID 0x67 [] Automation.outFloat
getGradientStyle :: (Automation.Variant a0) => IFillFormat a -> Prelude.IO (a0)
getGradientStyle =
  Automation.propertyGetID 0x68 [] Automation.outVariant
getGradientVariant :: IFillFormat a -> Prelude.IO (Prelude.Int)
getGradientVariant =
  Automation.propertyGetID 0x69 [] Automation.outInt
getPattern :: (Automation.Variant a0) => Automation.IDispatch a -> Prelude.IO (a0)
getPattern = Automation.propertyGetID 0x6a [] Automation.outVariant
getPresetGradientType :: (Automation.Variant a0) => IFillFormat a -> Prelude.IO (a0)
getPresetGradientType =
  Automation.propertyGetID 0x6b [] Automation.outVariant
getPresetTexture :: (Automation.Variant a0) => IFillFormat a -> Prelude.IO (a0)
getPresetTexture =
  Automation.propertyGetID 0x6c [] Automation.outVariant
getTextureName :: IFillFormat a -> Prelude.IO (Prelude.String)
getTextureName =
  Automation.propertyGetID 0x6d [] Automation.outString
getTextureType :: (Automation.Variant a0) => IFillFormat a -> Prelude.IO (a0)
getTextureType =
  Automation.propertyGetID 0x6e [] Automation.outVariant
getTransparency :: Automation.IDispatch a -> Prelude.IO (Prelude.Float)
getTransparency =
  Automation.propertyGetID 0x6f [] Automation.outFloat
setTransparency :: Prelude.Float -> Automation.IDispatch a -> Prelude.IO ()
setTransparency transparency =
  Automation.propertySetID 0x6f [Automation.inFloat transparency]
getType8 :: (Automation.Variant a0) => IFillFormat a -> Prelude.IO (a0)
getType8 = Automation.propertyGetID 0x70 [] Automation.outVariant
-- --------------------------------------------------
-- 
-- interface LineFormat
-- 
-- --------------------------------------------------
data LineFormat a = LineFormat
                     
type ILineFormat a = Automation.IDispatch (LineFormat a)
iidILineFormat :: Com.IID (ILineFormat Automation.Interface)
iidILineFormat = Com.mkIID "{9149347F-5A91-11CF-8700-00AA0060263B}"
getBeginArrowheadLength :: (Automation.Variant a0) => ILineFormat a -> Prelude.IO (a0)
getBeginArrowheadLength =
  Automation.propertyGetID 0x65 [] Automation.outVariant
setBeginArrowheadLength :: (Automation.Variant a0) => a0 -> ILineFormat a -> Prelude.IO ()
setBeginArrowheadLength beginArrowheadLength =
  Automation.propertySetID 0x65 [Automation.inVariant beginArrowheadLength]
getBeginArrowheadStyle :: (Automation.Variant a0) => ILineFormat a -> Prelude.IO (a0)
getBeginArrowheadStyle =
  Automation.propertyGetID 0x66 [] Automation.outVariant
setBeginArrowheadStyle :: (Automation.Variant a0) => a0 -> ILineFormat a -> Prelude.IO ()
setBeginArrowheadStyle beginArrowheadStyle =
  Automation.propertySetID 0x66 [Automation.inVariant beginArrowheadStyle]
getBeginArrowheadWidth :: (Automation.Variant a0) => ILineFormat a -> Prelude.IO (a0)
getBeginArrowheadWidth =
  Automation.propertyGetID 0x67 [] Automation.outVariant
setBeginArrowheadWidth :: (Automation.Variant a0) => a0 -> ILineFormat a -> Prelude.IO ()
setBeginArrowheadWidth beginArrowheadWidth =
  Automation.propertySetID 0x67 [Automation.inVariant beginArrowheadWidth]
getDashStyle :: (Automation.Variant a0) => ILineFormat a -> Prelude.IO (a0)
getDashStyle =
  Automation.propertyGetID 0x68 [] Automation.outVariant
setDashStyle :: (Automation.Variant a0) => a0 -> ILineFormat a -> Prelude.IO ()
setDashStyle dashStyle =
  Automation.propertySetID 0x68 [Automation.inVariant dashStyle]
getEndArrowheadLength :: (Automation.Variant a0) => ILineFormat a -> Prelude.IO (a0)
getEndArrowheadLength =
  Automation.propertyGetID 0x69 [] Automation.outVariant
setEndArrowheadLength :: (Automation.Variant a0) => a0 -> ILineFormat a -> Prelude.IO ()
setEndArrowheadLength endArrowheadLength =
  Automation.propertySetID 0x69 [Automation.inVariant endArrowheadLength]
getEndArrowheadStyle :: (Automation.Variant a0) => ILineFormat a -> Prelude.IO (a0)
getEndArrowheadStyle =
  Automation.propertyGetID 0x6a [] Automation.outVariant
setEndArrowheadStyle :: (Automation.Variant a0) => a0 -> ILineFormat a -> Prelude.IO ()
setEndArrowheadStyle endArrowheadStyle =
  Automation.propertySetID 0x6a [Automation.inVariant endArrowheadStyle]
getEndArrowheadWidth :: (Automation.Variant a0) => ILineFormat a -> Prelude.IO (a0)
getEndArrowheadWidth =
  Automation.propertyGetID 0x6b [] Automation.outVariant
setEndArrowheadWidth :: (Automation.Variant a0) => a0 -> ILineFormat a -> Prelude.IO ()
setEndArrowheadWidth endArrowheadWidth =
  Automation.propertySetID 0x6b [Automation.inVariant endArrowheadWidth]
setPattern :: (Automation.Variant a0) => a0 -> ILineFormat a -> Prelude.IO ()
setPattern pattern =
  Automation.propertySetID 0x6d [Automation.inVariant pattern]
getStyle :: (Automation.Variant a0) => ILineFormat a -> Prelude.IO (a0)
getStyle = Automation.propertyGetID 0x6e [] Automation.outVariant
setStyle :: (Automation.Variant a0) => a0 -> ILineFormat a -> Prelude.IO ()
setStyle style =
  Automation.propertySetID 0x6e [Automation.inVariant style]
getWeight :: ILineFormat a -> Prelude.IO (Prelude.Float)
getWeight = Automation.propertyGetID 0x71 [] Automation.outFloat
setWeight :: Prelude.Float -> ILineFormat a -> Prelude.IO ()
setWeight weight =
  Automation.propertySetID 0x71 [Automation.inFloat weight]
-- --------------------------------------------------
-- 
-- interface ShadowFormat
-- 
-- --------------------------------------------------
data ShadowFormat a = ShadowFormat
                       
type IShadowFormat a = Automation.IDispatch (ShadowFormat a)
iidIShadowFormat :: Com.IID (IShadowFormat Automation.Interface)
iidIShadowFormat =
  Com.mkIID "{91493480-5A91-11CF-8700-00AA0060263B}"
incrementOffsetX :: Prelude.Float -> IShadowFormat a -> Prelude.IO ()
incrementOffsetX increment =
  Automation.methodID0 0xa [Automation.inFloat increment]
incrementOffsetY :: Prelude.Float -> IShadowFormat a -> Prelude.IO ()
incrementOffsetY increment =
  Automation.methodID0 0xb [Automation.inFloat increment]
getObscured :: (Automation.Variant a0) => IShadowFormat a -> Prelude.IO (a0)
getObscured =
  Automation.propertyGetID 0x65 [] Automation.outVariant
setObscured :: (Automation.Variant a0) => a0 -> IShadowFormat a -> Prelude.IO ()
setObscured obscured =
  Automation.propertySetID 0x65 [Automation.inVariant obscured]
getOffsetX :: IShadowFormat a -> Prelude.IO (Prelude.Float)
getOffsetX = Automation.propertyGetID 0x66 [] Automation.outFloat
setOffsetX :: Prelude.Float -> IShadowFormat a -> Prelude.IO ()
setOffsetX offsetX =
  Automation.propertySetID 0x66 [Automation.inFloat offsetX]
getOffsetY :: IShadowFormat a -> Prelude.IO (Prelude.Float)
getOffsetY = Automation.propertyGetID 0x67 [] Automation.outFloat
setOffsetY :: Prelude.Float -> IShadowFormat a -> Prelude.IO ()
setOffsetY offsetY =
  Automation.propertySetID 0x67 [Automation.inFloat offsetY]
getType9 :: (Automation.Variant a0) => IShadowFormat a -> Prelude.IO (a0)
getType9 = Automation.propertyGetID 0x69 [] Automation.outVariant
setType0 :: (Automation.Variant a0) => a0 -> IShadowFormat a -> Prelude.IO ()
setType0 type0 =
  Automation.propertySetID 0x69 [Automation.inVariant type0]
-- --------------------------------------------------
-- 
-- interface ConnectorFormat
-- 
-- --------------------------------------------------
data ConnectorFormat a = ConnectorFormat
                          
type IConnectorFormat a = Automation.IDispatch (ConnectorFormat a)
iidIConnectorFormat :: Com.IID (IConnectorFormat Automation.Interface)
iidIConnectorFormat =
  Com.mkIID "{91493481-5A91-11CF-8700-00AA0060263B}"
beginConnect :: IShape a0 -> Prelude.Int -> IConnectorFormat a -> Prelude.IO ()
beginConnect connectedShape connectionSite =
  Automation.methodID0 0xa [Automation.inIDispatch connectedShape, Automation.inInt connectionSite]
beginDisconnect :: IConnectorFormat a -> Prelude.IO ()
beginDisconnect = Automation.methodID0 0xb []
endConnect :: IShape a0 -> Prelude.Int -> IConnectorFormat a -> Prelude.IO ()
endConnect connectedShape connectionSite =
  Automation.methodID0 0xc [Automation.inIDispatch connectedShape, Automation.inInt connectionSite]
endDisconnect :: IConnectorFormat a -> Prelude.IO ()
endDisconnect = Automation.methodID0 0xd []
getBeginConnected :: (Automation.Variant a0) => IConnectorFormat a -> Prelude.IO (a0)
getBeginConnected =
  Automation.propertyGetID 0x64 [] Automation.outVariant
getBeginConnectedShape :: IConnectorFormat a -> Prelude.IO (IShape Automation.Interface)
getBeginConnectedShape =
  Automation.propertyGetID 0x65 [] Automation.outIDispatch
getBeginConnectionSite :: IConnectorFormat a -> Prelude.IO (Prelude.Int)
getBeginConnectionSite =
  Automation.propertyGetID 0x66 [] Automation.outInt
getEndConnected :: (Automation.Variant a0) => IConnectorFormat a -> Prelude.IO (a0)
getEndConnected =
  Automation.propertyGetID 0x67 [] Automation.outVariant
getEndConnectedShape :: IConnectorFormat a -> Prelude.IO (IShape Automation.Interface)
getEndConnectedShape =
  Automation.propertyGetID 0x68 [] Automation.outIDispatch
getEndConnectionSite :: IConnectorFormat a -> Prelude.IO (Prelude.Int)
getEndConnectionSite =
  Automation.propertyGetID 0x69 [] Automation.outInt
getType10 :: (Automation.Variant a0) => IConnectorFormat a -> Prelude.IO (a0)
getType10 = Automation.propertyGetID 0x6a [] Automation.outVariant
setType1 :: (Automation.Variant a0) => a0 -> IConnectorFormat a -> Prelude.IO ()
setType1 type0 =
  Automation.propertySetID 0x6a [Automation.inVariant type0]
-- --------------------------------------------------
-- 
-- interface TextEffectFormat
-- 
-- --------------------------------------------------
data TextEffectFormat a = TextEffectFormat
                           
type ITextEffectFormat a = Automation.IDispatch (TextEffectFormat a)
iidITextEffectFormat :: Com.IID (ITextEffectFormat Automation.Interface)
iidITextEffectFormat =
  Com.mkIID "{91493482-5A91-11CF-8700-00AA0060263B}"
toggleVerticalText :: ITextEffectFormat a -> Prelude.IO ()
toggleVerticalText = Automation.methodID0 0xa []
getAlignment :: (Automation.Variant a0) => ITextEffectFormat a -> Prelude.IO (a0)
getAlignment =
  Automation.propertyGetID 0x64 [] Automation.outVariant
setAlignment :: (Automation.Variant a0) => a0 -> ITextEffectFormat a -> Prelude.IO ()
setAlignment alignment =
  Automation.propertySetID 0x64 [Automation.inVariant alignment]
getFontBold :: (Automation.Variant a0) => ITextEffectFormat a -> Prelude.IO (a0)
getFontBold =
  Automation.propertyGetID 0x65 [] Automation.outVariant
setFontBold :: (Automation.Variant a0) => a0 -> ITextEffectFormat a -> Prelude.IO ()
setFontBold fontBold =
  Automation.propertySetID 0x65 [Automation.inVariant fontBold]
getFontItalic :: (Automation.Variant a0) => ITextEffectFormat a -> Prelude.IO (a0)
getFontItalic =
  Automation.propertyGetID 0x66 [] Automation.outVariant
setFontItalic :: (Automation.Variant a0) => a0 -> ITextEffectFormat a -> Prelude.IO ()
setFontItalic fontItalic =
  Automation.propertySetID 0x66 [Automation.inVariant fontItalic]
getFontName :: ITextEffectFormat a -> Prelude.IO (Prelude.String)
getFontName = Automation.propertyGetID 0x67 [] Automation.outString
setFontName :: Prelude.String -> ITextEffectFormat a -> Prelude.IO ()
setFontName fontName =
  Automation.propertySetID 0x67 [Automation.inString fontName]
getFontSize :: ITextEffectFormat a -> Prelude.IO (Prelude.Float)
getFontSize = Automation.propertyGetID 0x68 [] Automation.outFloat
setFontSize :: Prelude.Float -> ITextEffectFormat a -> Prelude.IO ()
setFontSize fontSize =
  Automation.propertySetID 0x68 [Automation.inFloat fontSize]
getKernedPairs :: (Automation.Variant a0) => ITextEffectFormat a -> Prelude.IO (a0)
getKernedPairs =
  Automation.propertyGetID 0x69 [] Automation.outVariant
setKernedPairs :: (Automation.Variant a0) => a0 -> ITextEffectFormat a -> Prelude.IO ()
setKernedPairs kernedPairs =
  Automation.propertySetID 0x69 [Automation.inVariant kernedPairs]
getNormalizedHeight :: (Automation.Variant a0) => ITextEffectFormat a -> Prelude.IO (a0)
getNormalizedHeight =
  Automation.propertyGetID 0x6a [] Automation.outVariant
setNormalizedHeight :: (Automation.Variant a0) => a0 -> ITextEffectFormat a -> Prelude.IO ()
setNormalizedHeight normalizedHeight =
  Automation.propertySetID 0x6a [Automation.inVariant normalizedHeight]
getPresetShape :: (Automation.Variant a0) => ITextEffectFormat a -> Prelude.IO (a0)
getPresetShape =
  Automation.propertyGetID 0x6b [] Automation.outVariant
setPresetShape :: (Automation.Variant a0) => a0 -> ITextEffectFormat a -> Prelude.IO ()
setPresetShape presetShape =
  Automation.propertySetID 0x6b [Automation.inVariant presetShape]
getPresetTextEffect :: (Automation.Variant a0) => ITextEffectFormat a -> Prelude.IO (a0)
getPresetTextEffect =
  Automation.propertyGetID 0x6c [] Automation.outVariant
setPresetTextEffect :: (Automation.Variant a0) => a0 -> ITextEffectFormat a -> Prelude.IO ()
setPresetTextEffect preset =
  Automation.propertySetID 0x6c [Automation.inVariant preset]
getRotatedChars :: (Automation.Variant a0) => ITextEffectFormat a -> Prelude.IO (a0)
getRotatedChars =
  Automation.propertyGetID 0x6d [] Automation.outVariant
setRotatedChars :: (Automation.Variant a0) => a0 -> ITextEffectFormat a -> Prelude.IO ()
setRotatedChars rotatedChars =
  Automation.propertySetID 0x6d [Automation.inVariant rotatedChars]
getText :: Automation.IDispatch a -> Prelude.IO (Prelude.String)
getText = Automation.propertyGetID 0x6e [] Automation.outString
setText :: Prelude.String -> Automation.IDispatch a -> Prelude.IO ()
setText text =
  Automation.propertySetID 0x6e [Automation.inString text]
getTracking :: ITextEffectFormat a -> Prelude.IO (Prelude.Float)
getTracking = Automation.propertyGetID 0x6f [] Automation.outFloat
setTracking :: Prelude.Float -> ITextEffectFormat a -> Prelude.IO ()
setTracking tracking =
  Automation.propertySetID 0x6f [Automation.inFloat tracking]
-- --------------------------------------------------
-- 
-- interface ThreeDFormat
-- 
-- --------------------------------------------------
data ThreeDFormat a = ThreeDFormat
                       
type IThreeDFormat a = Automation.IDispatch (ThreeDFormat a)
iidIThreeDFormat :: Com.IID (IThreeDFormat Automation.Interface)
iidIThreeDFormat =
  Com.mkIID "{91493483-5A91-11CF-8700-00AA0060263B}"
incrementRotationX :: Prelude.Float -> IThreeDFormat a -> Prelude.IO ()
incrementRotationX increment =
  Automation.methodID0 0xa [Automation.inFloat increment]
incrementRotationY :: Prelude.Float -> IThreeDFormat a -> Prelude.IO ()
incrementRotationY increment =
  Automation.methodID0 0xb [Automation.inFloat increment]
resetRotation :: IThreeDFormat a -> Prelude.IO ()
resetRotation = Automation.methodID0 0xc []
setThreeDFormat :: (Automation.Variant a0) => a0 -> IThreeDFormat a -> Prelude.IO ()
setThreeDFormat presetThreeDFormat =
  Automation.methodID0 0xd [Automation.inVariant presetThreeDFormat]
setExtrusionDirection :: (Automation.Variant a0) => a0 -> IThreeDFormat a -> Prelude.IO ()
setExtrusionDirection presetExtrusionDirection =
  Automation.methodID0 0xe [Automation.inVariant presetExtrusionDirection]
getDepth :: IThreeDFormat a -> Prelude.IO (Prelude.Float)
getDepth = Automation.propertyGetID 0x64 [] Automation.outFloat
setDepth :: Prelude.Float -> IThreeDFormat a -> Prelude.IO ()
setDepth depth =
  Automation.propertySetID 0x64 [Automation.inFloat depth]
getExtrusionColor :: IThreeDFormat a -> Prelude.IO (IColorFormat Automation.Interface)
getExtrusionColor =
  Automation.propertyGetID 0x65 [] Automation.outIDispatch
getExtrusionColorType :: (Automation.Variant a0) => IThreeDFormat a -> Prelude.IO (a0)
getExtrusionColorType =
  Automation.propertyGetID 0x66 [] Automation.outVariant
setExtrusionColorType :: (Automation.Variant a0) => a0 -> IThreeDFormat a -> Prelude.IO ()
setExtrusionColorType extrusionColorType =
  Automation.propertySetID 0x66 [Automation.inVariant extrusionColorType]
getPerspective :: (Automation.Variant a0) => IThreeDFormat a -> Prelude.IO (a0)
getPerspective =
  Automation.propertyGetID 0x67 [] Automation.outVariant
setPerspective :: (Automation.Variant a0) => a0 -> IThreeDFormat a -> Prelude.IO ()
setPerspective perspective =
  Automation.propertySetID 0x67 [Automation.inVariant perspective]
getPresetExtrusionDirection :: (Automation.Variant a0) => IThreeDFormat a -> Prelude.IO (a0)
getPresetExtrusionDirection =
  Automation.propertyGetID 0x68 [] Automation.outVariant
getPresetLightingDirection :: (Automation.Variant a0) => IThreeDFormat a -> Prelude.IO (a0)
getPresetLightingDirection =
  Automation.propertyGetID 0x69 [] Automation.outVariant
setPresetLightingDirection :: (Automation.Variant a0) => a0 -> IThreeDFormat a -> Prelude.IO ()
setPresetLightingDirection presetLightingDirection =
  Automation.propertySetID 0x69 [Automation.inVariant presetLightingDirection]
getPresetLightingSoftness :: (Automation.Variant a0) => IThreeDFormat a -> Prelude.IO (a0)
getPresetLightingSoftness =
  Automation.propertyGetID 0x6a [] Automation.outVariant
setPresetLightingSoftness :: (Automation.Variant a0) => a0 -> IThreeDFormat a -> Prelude.IO ()
setPresetLightingSoftness presetLightingSoftness =
  Automation.propertySetID 0x6a [Automation.inVariant presetLightingSoftness]
getPresetMaterial :: (Automation.Variant a0) => IThreeDFormat a -> Prelude.IO (a0)
getPresetMaterial =
  Automation.propertyGetID 0x6b [] Automation.outVariant
setPresetMaterial :: (Automation.Variant a0) => a0 -> IThreeDFormat a -> Prelude.IO ()
setPresetMaterial presetMaterial =
  Automation.propertySetID 0x6b [Automation.inVariant presetMaterial]
getPresetThreeDFormat :: (Automation.Variant a0) => IThreeDFormat a -> Prelude.IO (a0)
getPresetThreeDFormat =
  Automation.propertyGetID 0x6c [] Automation.outVariant
getRotationX :: IThreeDFormat a -> Prelude.IO (Prelude.Float)
getRotationX = Automation.propertyGetID 0x6d [] Automation.outFloat
setRotationX :: Prelude.Float -> IThreeDFormat a -> Prelude.IO ()
setRotationX rotationX =
  Automation.propertySetID 0x6d [Automation.inFloat rotationX]
getRotationY :: IThreeDFormat a -> Prelude.IO (Prelude.Float)
getRotationY = Automation.propertyGetID 0x6e [] Automation.outFloat
setRotationY :: Prelude.Float -> IThreeDFormat a -> Prelude.IO ()
setRotationY rotationY =
  Automation.propertySetID 0x6e [Automation.inFloat rotationY]
-- --------------------------------------------------
-- 
-- interface TextFrame
-- 
-- --------------------------------------------------
data TextFrame a = TextFrame
                    
type ITextFrame a = Automation.IDispatch (TextFrame a)
iidITextFrame :: Com.IID (ITextFrame Automation.Interface)
iidITextFrame = Com.mkIID "{91493484-5A91-11CF-8700-00AA0060263B}"
getMarginBottom :: ITextFrame a -> Prelude.IO (Prelude.Float)
getMarginBottom =
  Automation.propertyGetID 0x64 [] Automation.outFloat
setMarginBottom :: Prelude.Float -> ITextFrame a -> Prelude.IO ()
setMarginBottom marginBottom =
  Automation.propertySetID 0x64 [Automation.inFloat marginBottom]
getMarginLeft :: ITextFrame a -> Prelude.IO (Prelude.Float)
getMarginLeft =
  Automation.propertyGetID 0x65 [] Automation.outFloat
setMarginLeft :: Prelude.Float -> ITextFrame a -> Prelude.IO ()
setMarginLeft marginLeft =
  Automation.propertySetID 0x65 [Automation.inFloat marginLeft]
getMarginRight :: ITextFrame a -> Prelude.IO (Prelude.Float)
getMarginRight =
  Automation.propertyGetID 0x66 [] Automation.outFloat
setMarginRight :: Prelude.Float -> ITextFrame a -> Prelude.IO ()
setMarginRight marginRight =
  Automation.propertySetID 0x66 [Automation.inFloat marginRight]
getMarginTop :: ITextFrame a -> Prelude.IO (Prelude.Float)
getMarginTop = Automation.propertyGetID 0x67 [] Automation.outFloat
setMarginTop :: Prelude.Float -> ITextFrame a -> Prelude.IO ()
setMarginTop marginTop =
  Automation.propertySetID 0x67 [Automation.inFloat marginTop]
getOrientation :: (Automation.Variant a0) => ITextFrame a -> Prelude.IO (a0)
getOrientation =
  Automation.propertyGetID 0x68 [] Automation.outVariant
setOrientation :: (Automation.Variant a0) => a0 -> ITextFrame a -> Prelude.IO ()
setOrientation orientation =
  Automation.propertySetID 0x68 [Automation.inVariant orientation]
getHasText :: (Automation.Variant a0) => ITextFrame a -> Prelude.IO (a0)
getHasText =
  Automation.propertyGetID 0x7d3 [] Automation.outVariant
getRuler :: Automation.IDispatch a -> Prelude.IO (IRuler Automation.Interface)
getRuler =
  Automation.propertyGetID 0x7d5 [] Automation.outIDispatch
getHorizontalAnchor :: (Automation.Variant a0) => ITextFrame a -> Prelude.IO (a0)
getHorizontalAnchor =
  Automation.propertyGetID 0x7d6 [] Automation.outVariant
setHorizontalAnchor :: (Automation.Variant a0) => a0 -> ITextFrame a -> Prelude.IO ()
setHorizontalAnchor horizontalAnchor =
  Automation.propertySetID 0x7d6 [Automation.inVariant horizontalAnchor]
getVerticalAnchor :: (Automation.Variant a0) => ITextFrame a -> Prelude.IO (a0)
getVerticalAnchor =
  Automation.propertyGetID 0x7d7 [] Automation.outVariant
setVerticalAnchor :: (Automation.Variant a0) => a0 -> ITextFrame a -> Prelude.IO ()
setVerticalAnchor verticalAnchor =
  Automation.propertySetID 0x7d7 [Automation.inVariant verticalAnchor]
getAutoSize :: (Automation.Variant a0) => ITextFrame a -> Prelude.IO (a0)
getAutoSize =
  Automation.propertyGetID 0x7d8 [] Automation.outVariant
setAutoSize :: (Automation.Variant a0) => a0 -> ITextFrame a -> Prelude.IO ()
setAutoSize autoSize =
  Automation.propertySetID 0x7d8 [Automation.inVariant autoSize]
getWordWrap :: (Automation.Variant a0) => Automation.IDispatch a -> Prelude.IO (a0)
getWordWrap =
  Automation.propertyGetID 0x7d9 [] Automation.outVariant
setWordWrap :: (Automation.Variant a0) => a0 -> Automation.IDispatch a -> Prelude.IO ()
setWordWrap wordWrap =
  Automation.propertySetID 0x7d9 [Automation.inVariant wordWrap]
deleteText :: ITextFrame a -> Prelude.IO ()
deleteText = Automation.methodID0 0x7da []
-- --------------------------------------------------
-- 
-- interface CalloutFormat
-- 
-- --------------------------------------------------
data CalloutFormat a = CalloutFormat
                        
type ICalloutFormat a = Automation.IDispatch (CalloutFormat a)
iidICalloutFormat :: Com.IID (ICalloutFormat Automation.Interface)
iidICalloutFormat =
  Com.mkIID "{91493485-5A91-11CF-8700-00AA0060263B}"
automaticLength :: ICalloutFormat a -> Prelude.IO ()
automaticLength = Automation.methodID0 0xa []
customDrop :: Prelude.Float -> ICalloutFormat a -> Prelude.IO ()
customDrop drop =
  Automation.methodID0 0xb [Automation.inFloat drop]
customLength :: Prelude.Float -> ICalloutFormat a -> Prelude.IO ()
customLength length =
  Automation.methodID0 0xc [Automation.inFloat length]
presetDrop :: (Automation.Variant a0) => a0 -> ICalloutFormat a -> Prelude.IO ()
presetDrop dropType =
  Automation.methodID0 0xd [Automation.inVariant dropType]
getAccent :: (Automation.Variant a0) => ICalloutFormat a -> Prelude.IO (a0)
getAccent = Automation.propertyGetID 0x64 [] Automation.outVariant
setAccent :: (Automation.Variant a0) => a0 -> ICalloutFormat a -> Prelude.IO ()
setAccent accent =
  Automation.propertySetID 0x64 [Automation.inVariant accent]
getAngle :: (Automation.Variant a0) => ICalloutFormat a -> Prelude.IO (a0)
getAngle = Automation.propertyGetID 0x65 [] Automation.outVariant
setAngle :: (Automation.Variant a0) => a0 -> ICalloutFormat a -> Prelude.IO ()
setAngle angle =
  Automation.propertySetID 0x65 [Automation.inVariant angle]
getAutoAttach :: (Automation.Variant a0) => ICalloutFormat a -> Prelude.IO (a0)
getAutoAttach =
  Automation.propertyGetID 0x66 [] Automation.outVariant
setAutoAttach :: (Automation.Variant a0) => a0 -> ICalloutFormat a -> Prelude.IO ()
setAutoAttach autoAttach =
  Automation.propertySetID 0x66 [Automation.inVariant autoAttach]
getAutoLength :: (Automation.Variant a0) => ICalloutFormat a -> Prelude.IO (a0)
getAutoLength =
  Automation.propertyGetID 0x67 [] Automation.outVariant
getBorder :: (Automation.Variant a0) => ICalloutFormat a -> Prelude.IO (a0)
getBorder = Automation.propertyGetID 0x68 [] Automation.outVariant
setBorder :: (Automation.Variant a0) => a0 -> ICalloutFormat a -> Prelude.IO ()
setBorder border =
  Automation.propertySetID 0x68 [Automation.inVariant border]
getDrop :: ICalloutFormat a -> Prelude.IO (Prelude.Float)
getDrop = Automation.propertyGetID 0x69 [] Automation.outFloat
getDropType :: (Automation.Variant a0) => ICalloutFormat a -> Prelude.IO (a0)
getDropType =
  Automation.propertyGetID 0x6a [] Automation.outVariant
getGap :: ICalloutFormat a -> Prelude.IO (Prelude.Float)
getGap = Automation.propertyGetID 0x6b [] Automation.outFloat
setGap :: Prelude.Float -> ICalloutFormat a -> Prelude.IO ()
setGap gap = Automation.propertySetID 0x6b [Automation.inFloat gap]
getLength :: ICalloutFormat a -> Prelude.IO (Prelude.Float)
getLength = Automation.propertyGetID 0x6c [] Automation.outFloat
getType11 :: (Automation.Variant a0) => ICalloutFormat a -> Prelude.IO (a0)
getType11 = Automation.propertyGetID 0x6d [] Automation.outVariant
setType2 :: (Automation.Variant a0) => a0 -> ICalloutFormat a -> Prelude.IO ()
setType2 type0 =
  Automation.propertySetID 0x6d [Automation.inVariant type0]
-- --------------------------------------------------
-- 
-- interface ShapeNodes
-- 
-- --------------------------------------------------
data ShapeNodes a = ShapeNodes
                     
type IShapeNodes a = Automation.IDispatch (ShapeNodes a)
iidIShapeNodes :: Com.IID (IShapeNodes Automation.Interface)
iidIShapeNodes = Com.mkIID "{91493486-5A91-11CF-8700-00AA0060263B}"
item15 :: Prelude.Int -> IShapeNodes a -> Prelude.IO (Office.IShapeNode Automation.Interface)
item15 index =
  Automation.functionID1 0o0 [Automation.inInt index] Automation.outIDispatch
delete8 :: Prelude.Int -> Automation.IDispatch a -> Prelude.IO ()
delete8 index = Automation.methodID0 0xb [Automation.inInt index]
insert :: (Automation.Variant a0, Automation.Variant a1) => Prelude.Int -> a0 -> a1 -> Prelude.Float -> Prelude.Float -> Prelude.Float -> Prelude.Float -> Prelude.Float -> Prelude.Float -> IShapeNodes a -> Prelude.IO ()
insert index segmentType editingType x1 y1 x2 y2 x3 y3 =
  Automation.methodID0 0xc [Automation.inInt index, Automation.inVariant segmentType, Automation.inVariant editingType, Automation.inFloat x1, Automation.inFloat y1, Automation.inFloat x2, Automation.inFloat y2, Automation.inFloat x3, Automation.inFloat y3]
setEditingType :: (Automation.Variant a0) => Prelude.Int -> a0 -> IShapeNodes a -> Prelude.IO ()
setEditingType index editingType =
  Automation.methodID0 0xd [Automation.inInt index, Automation.inVariant editingType]
setPosition :: Prelude.Int -> Prelude.Float -> Prelude.Float -> IShapeNodes a -> Prelude.IO ()
setPosition index x1 y1 =
  Automation.methodID0 0xe [Automation.inInt index, Automation.inFloat x1, Automation.inFloat y1]
setSegmentType :: (Automation.Variant a0) => Prelude.Int -> a0 -> IShapeNodes a -> Prelude.IO ()
setSegmentType index segmentType =
  Automation.methodID0 0xf [Automation.inInt index, Automation.inVariant segmentType]
-- --------------------------------------------------
-- 
-- interface ShapeNode
-- 
-- --------------------------------------------------
data ShapeNode a = ShapeNode
                    
type IShapeNode a = Automation.IDispatch (ShapeNode a)
iidIShapeNode :: Com.IID (IShapeNode Automation.Interface)
iidIShapeNode = Com.mkIID "{91493487-5A91-11CF-8700-00AA0060263B}"
getEditingType :: (Automation.Variant a0) => IShapeNode a -> Prelude.IO (a0)
getEditingType =
  Automation.propertyGetID 0x64 [] Automation.outVariant
getPoints :: IShapeNode a -> Prelude.IO (Prelude.Int)
getPoints = Automation.propertyGetID 0x65 [] Automation.outInt
getSegmentType :: (Automation.Variant a0) => IShapeNode a -> Prelude.IO (a0)
getSegmentType =
  Automation.propertyGetID 0x66 [] Automation.outVariant
-- --------------------------------------------------
-- 
-- interface OLEFormat
-- 
-- --------------------------------------------------
data OLEFormat a = OLEFormat
                    
type IOLEFormat a = Automation.IDispatch (OLEFormat a)
iidIOLEFormat :: Com.IID (IOLEFormat Automation.Interface)
iidIOLEFormat = Com.mkIID "{91493488-5A91-11CF-8700-00AA0060263B}"
getObjectVerbs :: IOLEFormat a -> Prelude.IO (IObjectVerbs Automation.Interface)
getObjectVerbs =
  Automation.propertyGetID 0x7d3 [] Automation.outIDispatch
getObject :: IOLEFormat a -> Prelude.IO (Automation.IDispatch Automation.Interface)
getObject =
  Automation.propertyGetID 0x7d4 [] Automation.outIDispatch
getProgID :: IOLEFormat a -> Prelude.IO (Prelude.String)
getProgID = Automation.propertyGetID 0x7d5 [] Automation.outString
getFollowColors :: (Automation.Variant a0) => IOLEFormat a -> Prelude.IO (a0)
getFollowColors =
  Automation.propertyGetID 0x7d6 [] Automation.outVariant
setFollowColors :: (Automation.Variant a0) => a0 -> IOLEFormat a -> Prelude.IO ()
setFollowColors followColors =
  Automation.propertySetID 0x7d6 [Automation.inVariant followColors]
doVerb :: Prelude.Int -> IOLEFormat a -> Prelude.IO ()
doVerb index = Automation.methodID0 0x7d7 [Automation.inInt index]
-- --------------------------------------------------
-- 
-- interface LinkFormat
-- 
-- --------------------------------------------------
data LinkFormat a = LinkFormat
                     
type ILinkFormat a = Automation.IDispatch (LinkFormat a)
iidILinkFormat :: Com.IID (ILinkFormat Automation.Interface)
iidILinkFormat = Com.mkIID "{91493489-5A91-11CF-8700-00AA0060263B}"
setSourceFullName :: Prelude.String -> ILinkFormat a -> Prelude.IO ()
setSourceFullName sourceFullName =
  Automation.propertySetID 0x7d3 [Automation.inString sourceFullName]
getAutoUpdate :: (Automation.Variant a0) => ILinkFormat a -> Prelude.IO (a0)
getAutoUpdate =
  Automation.propertyGetID 0x7d4 [] Automation.outVariant
setAutoUpdate :: (Automation.Variant a0) => a0 -> ILinkFormat a -> Prelude.IO ()
setAutoUpdate autoUpdate =
  Automation.propertySetID 0x7d4 [Automation.inVariant autoUpdate]
update :: ILinkFormat a -> Prelude.IO ()
update = Automation.methodID0 0x7d5 []
-- --------------------------------------------------
-- 
-- interface ObjectVerbs
-- 
-- --------------------------------------------------
data ObjectVerbs a = ObjectVerbs
                      
type IObjectVerbs a = ICollection (ObjectVerbs a)
iidIObjectVerbs :: Com.IID (IObjectVerbs Automation.Interface)
iidIObjectVerbs =
  Com.mkIID "{9149348A-5A91-11CF-8700-00AA0060263B}"
item16 :: Prelude.Int -> Automation.IDispatch a -> Prelude.IO (Prelude.String)
item16 index =
  Automation.functionID1 0o0 [Automation.inInt index] Automation.outString
-- --------------------------------------------------
-- 
-- interface AnimationSettings
-- 
-- --------------------------------------------------
data AnimationSettings a = AnimationSettings
                            
type IAnimationSettings a = Automation.IDispatch (AnimationSettings a)
iidIAnimationSettings :: Com.IID (IAnimationSettings Automation.Interface)
iidIAnimationSettings =
  Com.mkIID "{9149348B-5A91-11CF-8700-00AA0060263B}"
getDimColor :: IAnimationSettings a -> Prelude.IO (IColorFormat Automation.Interface)
getDimColor =
  Automation.propertyGetID 0x7d3 [] Automation.outIDispatch
getAfterEffect :: (Automation.Variant a0) => IAnimationSettings a -> Prelude.IO (a0)
getAfterEffect =
  Automation.propertyGetID 0x7d6 [] Automation.outVariant
setAfterEffect :: (Automation.Variant a0) => a0 -> IAnimationSettings a -> Prelude.IO ()
setAfterEffect afterEffect =
  Automation.propertySetID 0x7d6 [Automation.inVariant afterEffect]
getAnimationOrder :: IAnimationSettings a -> Prelude.IO (Prelude.Int)
getAnimationOrder =
  Automation.propertyGetID 0x7d7 [] Automation.outInt
setAnimationOrder :: Prelude.Int -> IAnimationSettings a -> Prelude.IO ()
setAnimationOrder animationOrder =
  Automation.propertySetID 0x7d7 [Automation.inInt animationOrder]
getAdvanceMode1 :: (Automation.Variant a0) => IAnimationSettings a -> Prelude.IO (a0)
getAdvanceMode1 =
  Automation.propertyGetID 0x7d8 [] Automation.outVariant
setAdvanceMode0 :: (Automation.Variant a0) => a0 -> IAnimationSettings a -> Prelude.IO ()
setAdvanceMode0 advanceMode =
  Automation.propertySetID 0x7d8 [Automation.inVariant advanceMode]
getPlaySettings :: IAnimationSettings a -> Prelude.IO (IPlaySettings Automation.Interface)
getPlaySettings =
  Automation.propertyGetID 0x7da [] Automation.outIDispatch
getTextLevelEffect :: (Automation.Variant a0) => IAnimationSettings a -> Prelude.IO (a0)
getTextLevelEffect =
  Automation.propertyGetID 0x7db [] Automation.outVariant
setTextLevelEffect :: (Automation.Variant a0) => a0 -> IAnimationSettings a -> Prelude.IO ()
setTextLevelEffect textLevelEffect =
  Automation.propertySetID 0x7db [Automation.inVariant textLevelEffect]
getTextUnitEffect :: (Automation.Variant a0) => IAnimationSettings a -> Prelude.IO (a0)
getTextUnitEffect =
  Automation.propertyGetID 0x7dc [] Automation.outVariant
setTextUnitEffect :: (Automation.Variant a0) => a0 -> IAnimationSettings a -> Prelude.IO ()
setTextUnitEffect textUnitEffect =
  Automation.propertySetID 0x7dc [Automation.inVariant textUnitEffect]
getAnimate :: (Automation.Variant a0) => IAnimationSettings a -> Prelude.IO (a0)
getAnimate =
  Automation.propertyGetID 0x7dd [] Automation.outVariant
setAnimate :: (Automation.Variant a0) => a0 -> IAnimationSettings a -> Prelude.IO ()
setAnimate animate =
  Automation.propertySetID 0x7dd [Automation.inVariant animate]
getAnimateBackground :: (Automation.Variant a0) => IAnimationSettings a -> Prelude.IO (a0)
getAnimateBackground =
  Automation.propertyGetID 0x7de [] Automation.outVariant
setAnimateBackground :: (Automation.Variant a0) => a0 -> IAnimationSettings a -> Prelude.IO ()
setAnimateBackground animateBackground =
  Automation.propertySetID 0x7de [Automation.inVariant animateBackground]
getAnimateTextInReverse :: (Automation.Variant a0) => IAnimationSettings a -> Prelude.IO (a0)
getAnimateTextInReverse =
  Automation.propertyGetID 0x7df [] Automation.outVariant
setAnimateTextInReverse :: (Automation.Variant a0) => a0 -> IAnimationSettings a -> Prelude.IO ()
setAnimateTextInReverse animateTextInReverse =
  Automation.propertySetID 0x7df [Automation.inVariant animateTextInReverse]
getChartUnitEffect :: (Automation.Variant a0) => IAnimationSettings a -> Prelude.IO (a0)
getChartUnitEffect =
  Automation.propertyGetID 0x7e0 [] Automation.outVariant
setChartUnitEffect :: (Automation.Variant a0) => a0 -> IAnimationSettings a -> Prelude.IO ()
setChartUnitEffect chartUnitEffect =
  Automation.propertySetID 0x7e0 [Automation.inVariant chartUnitEffect]
-- --------------------------------------------------
-- 
-- interface ActionSettings
-- 
-- --------------------------------------------------
data ActionSettings a = ActionSettings
                         
type IActionSettings a = ICollection (ActionSettings a)
iidIActionSettings :: Com.IID (IActionSettings Automation.Interface)
iidIActionSettings =
  Com.mkIID "{9149348C-5A91-11CF-8700-00AA0060263B}"
item17 :: (Automation.Variant a0) => a0 -> IActionSettings a -> Prelude.IO (IActionSetting Automation.Interface)
item17 index =
  Automation.functionID1 0o0 [Automation.inVariant index] Automation.outIDispatch
-- --------------------------------------------------
-- 
-- interface ActionSetting
-- 
-- --------------------------------------------------
data ActionSetting a = ActionSetting
                        
type IActionSetting a = Automation.IDispatch (ActionSetting a)
iidIActionSetting :: Com.IID (IActionSetting Automation.Interface)
iidIActionSetting =
  Com.mkIID "{9149348D-5A91-11CF-8700-00AA0060263B}"
getAction :: (Automation.Variant a0) => IActionSetting a -> Prelude.IO (a0)
getAction = Automation.propertyGetID 0x7d3 [] Automation.outVariant
setAction :: (Automation.Variant a0) => a0 -> IActionSetting a -> Prelude.IO ()
setAction action =
  Automation.propertySetID 0x7d3 [Automation.inVariant action]
getActionVerb :: Automation.IDispatch a -> Prelude.IO (Prelude.String)
getActionVerb =
  Automation.propertyGetID 0x7d4 [] Automation.outString
setActionVerb :: Prelude.String -> Automation.IDispatch a -> Prelude.IO ()
setActionVerb actionVerb =
  Automation.propertySetID 0x7d4 [Automation.inString actionVerb]
getAnimateAction :: (Automation.Variant a0) => IActionSetting a -> Prelude.IO (a0)
getAnimateAction =
  Automation.propertyGetID 0x7d5 [] Automation.outVariant
setAnimateAction :: (Automation.Variant a0) => a0 -> IActionSetting a -> Prelude.IO ()
setAnimateAction animateAction =
  Automation.propertySetID 0x7d5 [Automation.inVariant animateAction]
getRun :: IActionSetting a -> Prelude.IO (Prelude.String)
getRun = Automation.propertyGetID 0x7d6 [] Automation.outString
setRun :: Prelude.String -> Automation.IDispatch a -> Prelude.IO ()
setRun run =
  Automation.propertySetID 0x7d6 [Automation.inString run]
getHyperlink :: IActionSetting a -> Prelude.IO (IHyperlink Automation.Interface)
getHyperlink =
  Automation.propertyGetID 0x7d8 [] Automation.outIDispatch
-- --------------------------------------------------
-- 
-- interface PlaySettings
-- 
-- --------------------------------------------------
data PlaySettings a = PlaySettings
                       
type IPlaySettings a = Automation.IDispatch (PlaySettings a)
iidIPlaySettings :: Com.IID (IPlaySettings Automation.Interface)
iidIPlaySettings =
  Com.mkIID "{9149348E-5A91-11CF-8700-00AA0060263B}"
getHideWhileNotPlaying :: (Automation.Variant a0) => IPlaySettings a -> Prelude.IO (a0)
getHideWhileNotPlaying =
  Automation.propertyGetID 0x7d4 [] Automation.outVariant
setHideWhileNotPlaying :: (Automation.Variant a0) => a0 -> IPlaySettings a -> Prelude.IO ()
setHideWhileNotPlaying hideWhileNotPlaying =
  Automation.propertySetID 0x7d4 [Automation.inVariant hideWhileNotPlaying]
getPlayOnEntry :: (Automation.Variant a0) => IPlaySettings a -> Prelude.IO (a0)
getPlayOnEntry =
  Automation.propertyGetID 0x7d6 [] Automation.outVariant
setPlayOnEntry :: (Automation.Variant a0) => a0 -> IPlaySettings a -> Prelude.IO ()
setPlayOnEntry playOnEntry =
  Automation.propertySetID 0x7d6 [Automation.inVariant playOnEntry]
getRewindMovie :: (Automation.Variant a0) => IPlaySettings a -> Prelude.IO (a0)
getRewindMovie =
  Automation.propertyGetID 0x7d7 [] Automation.outVariant
setRewindMovie :: (Automation.Variant a0) => a0 -> IPlaySettings a -> Prelude.IO ()
setRewindMovie rewindMovie =
  Automation.propertySetID 0x7d7 [Automation.inVariant rewindMovie]
getPauseAnimation :: (Automation.Variant a0) => IPlaySettings a -> Prelude.IO (a0)
getPauseAnimation =
  Automation.propertyGetID 0x7d8 [] Automation.outVariant
setPauseAnimation :: (Automation.Variant a0) => a0 -> IPlaySettings a -> Prelude.IO ()
setPauseAnimation pauseAnimation =
  Automation.propertySetID 0x7d8 [Automation.inVariant pauseAnimation]
getStopAfterSlides :: IPlaySettings a -> Prelude.IO (Prelude.Int)
getStopAfterSlides =
  Automation.propertyGetID 0x7d9 [] Automation.outInt
setStopAfterSlides :: Prelude.Int -> IPlaySettings a -> Prelude.IO ()
setStopAfterSlides stopAfterSlides =
  Automation.propertySetID 0x7d9 [Automation.inInt stopAfterSlides]
-- --------------------------------------------------
-- 
-- interface TextRange
-- 
-- --------------------------------------------------
data TextRange a = TextRange
                    
type ITextRange a = ICollection (TextRange a)
iidITextRange :: Com.IID (ITextRange Automation.Interface)
iidITextRange = Com.mkIID "{9149348F-5A91-11CF-8700-00AA0060263B}"
getLength0 :: ITextRange a -> Prelude.IO (Prelude.Int)
getLength0 = Automation.propertyGetID 0x7d5 [] Automation.outInt
getBoundLeft :: ITextRange a -> Prelude.IO (Prelude.Float)
getBoundLeft =
  Automation.propertyGetID 0x7d6 [] Automation.outFloat
getBoundTop :: ITextRange a -> Prelude.IO (Prelude.Float)
getBoundTop = Automation.propertyGetID 0x7d7 [] Automation.outFloat
getBoundWidth :: ITextRange a -> Prelude.IO (Prelude.Float)
getBoundWidth =
  Automation.propertyGetID 0x7d8 [] Automation.outFloat
getBoundHeight :: ITextRange a -> Prelude.IO (Prelude.Float)
getBoundHeight =
  Automation.propertyGetID 0x7d9 [] Automation.outFloat
paragraphs :: Prelude.Int -> Prelude.Int -> ITextRange a -> Prelude.IO (ITextRange Automation.Interface)
paragraphs start length =
  Automation.functionID1 0x7da [Automation.inInt start, Automation.inInt length] Automation.outIDispatch
sentences :: Prelude.Int -> Prelude.Int -> ITextRange a -> Prelude.IO (ITextRange Automation.Interface)
sentences start length =
  Automation.functionID1 0x7db [Automation.inInt start, Automation.inInt length] Automation.outIDispatch
words :: Prelude.Int -> Prelude.Int -> ITextRange a -> Prelude.IO (ITextRange Automation.Interface)
words start length =
  Automation.functionID1 0x7dc [Automation.inInt start, Automation.inInt length] Automation.outIDispatch
characters :: Prelude.Int -> Prelude.Int -> ITextRange a -> Prelude.IO (ITextRange Automation.Interface)
characters start length =
  Automation.functionID1 0x7dd [Automation.inInt start, Automation.inInt length] Automation.outIDispatch
lines :: Prelude.Int -> Prelude.Int -> ITextRange a -> Prelude.IO (ITextRange Automation.Interface)
lines start length =
  Automation.functionID1 0x7de [Automation.inInt start, Automation.inInt length] Automation.outIDispatch
runs :: Prelude.Int -> Prelude.Int -> ITextRange a -> Prelude.IO (ITextRange Automation.Interface)
runs start length =
  Automation.functionID1 0x7df [Automation.inInt start, Automation.inInt length] Automation.outIDispatch
trimText :: ITextRange a -> Prelude.IO (ITextRange Automation.Interface)
trimText = Automation.functionID1 0x7e0 [] Automation.outIDispatch
insertAfter :: Prelude.String -> ITextRange a -> Prelude.IO (ITextRange Automation.Interface)
insertAfter newText =
  Automation.functionID1 0x7e1 [Automation.inString newText] Automation.outIDispatch
insertBefore :: Prelude.String -> ITextRange a -> Prelude.IO (ITextRange Automation.Interface)
insertBefore newText =
  Automation.functionID1 0x7e2 [Automation.inString newText] Automation.outIDispatch
insertDateTime :: (Automation.Variant a0, Automation.Variant a1) => a0 -> a1 -> ITextRange a -> Prelude.IO (ITextRange Automation.Interface)
insertDateTime dateTimeFormat insertAsField =
  Automation.functionID1 0x7e3 [Automation.inVariant dateTimeFormat, Automation.inVariant insertAsField] Automation.outIDispatch
insertSlideNumber :: ITextRange a -> Prelude.IO (ITextRange Automation.Interface)
insertSlideNumber =
  Automation.functionID1 0x7e4 [] Automation.outIDispatch
insertSymbol :: (Automation.Variant a0) => Prelude.String -> Prelude.Int -> a0 -> ITextRange a -> Prelude.IO (ITextRange Automation.Interface)
insertSymbol fontName charNumber unicode =
  Automation.functionID1 0x7e5 [Automation.inString fontName, Automation.inInt charNumber, Automation.inVariant unicode] Automation.outIDispatch
getFont :: Automation.IDispatch a -> Prelude.IO (IFont Automation.Interface)
getFont = Automation.propertyGetID 0x7e6 [] Automation.outIDispatch
getParagraphFormat :: Automation.IDispatch a -> Prelude.IO (IParagraphFormat Automation.Interface)
getParagraphFormat =
  Automation.propertyGetID 0x7e7 [] Automation.outIDispatch
getIndentLevel :: ITextRange a -> Prelude.IO (Prelude.Int)
getIndentLevel =
  Automation.propertyGetID 0x7e8 [] Automation.outInt
setIndentLevel :: Prelude.Int -> ITextRange a -> Prelude.IO ()
setIndentLevel indentLevel =
  Automation.propertySetID 0x7e8 [Automation.inInt indentLevel]
paste2 :: Automation.IDispatch a -> Prelude.IO (ITextRange Automation.Interface)
paste2 = Automation.functionID1 0x7ed [] Automation.outIDispatch
changeCase :: (Automation.Variant a0) => a0 -> ITextRange a -> Prelude.IO ()
changeCase type0 =
  Automation.methodID0 0x7ee [Automation.inVariant type0]
addPeriods :: ITextRange a -> Prelude.IO ()
addPeriods = Automation.methodID0 0x7ef []
removePeriods :: ITextRange a -> Prelude.IO ()
removePeriods = Automation.methodID0 0x7f0 []
find :: (Automation.Variant a0, Automation.Variant a1) => Prelude.String -> Prelude.Int -> a0 -> a1 -> ITextRange a -> Prelude.IO (ITextRange Automation.Interface)
find findWhat after matchCase wholeWords =
  Automation.functionID1 0x7f1 [Automation.inString findWhat, Automation.inInt after, Automation.inVariant matchCase, Automation.inVariant wholeWords] Automation.outIDispatch
replace0 :: (Automation.Variant a0, Automation.Variant a1) => Prelude.String -> Prelude.String -> Prelude.Int -> a0 -> a1 -> Automation.IDispatch a -> Prelude.IO (ITextRange Automation.Interface)
replace0 findWhat replaceWhat after matchCase wholeWords =
  Automation.functionID1 0x7f2 [Automation.inString findWhat, Automation.inString replaceWhat, Automation.inInt after, Automation.inVariant matchCase, Automation.inVariant wholeWords] Automation.outIDispatch
rotatedBounds :: ITextRange a -> Prelude.IO (Prelude.Float, Prelude.Float, Prelude.Float, Prelude.Float, Prelude.Float, Prelude.Float, Prelude.Float, Prelude.Float)
rotatedBounds =
  Automation.methodID8 0x7f3 [] Automation.outFloat Automation.outFloat Automation.outFloat Automation.outFloat Automation.outFloat Automation.outFloat Automation.outFloat Automation.outFloat
-- --------------------------------------------------
-- 
-- interface Ruler
-- 
-- --------------------------------------------------
data Ruler a = Ruler
                
type IRuler a = Automation.IDispatch (Ruler a)
iidIRuler :: Com.IID (IRuler Automation.Interface)
iidIRuler = Com.mkIID "{91493490-5A91-11CF-8700-00AA0060263B}"
getTabStops :: IRuler a -> Prelude.IO (ITabStops Automation.Interface)
getTabStops =
  Automation.propertyGetID 0x7d3 [] Automation.outIDispatch
getLevels :: IRuler a -> Prelude.IO (IRulerLevels Automation.Interface)
getLevels =
  Automation.propertyGetID 0x7d4 [] Automation.outIDispatch
-- --------------------------------------------------
-- 
-- interface RulerLevels
-- 
-- --------------------------------------------------
data RulerLevels a = RulerLevels
                      
type IRulerLevels a = ICollection (RulerLevels a)
iidIRulerLevels :: Com.IID (IRulerLevels Automation.Interface)
iidIRulerLevels =
  Com.mkIID "{91493491-5A91-11CF-8700-00AA0060263B}"
item18 :: Prelude.Int -> IRulerLevels a -> Prelude.IO (IRulerLevel Automation.Interface)
item18 index =
  Automation.functionID1 0o0 [Automation.inInt index] Automation.outIDispatch
-- --------------------------------------------------
-- 
-- interface RulerLevel
-- 
-- --------------------------------------------------
data RulerLevel a = RulerLevel
                     
type IRulerLevel a = Automation.IDispatch (RulerLevel a)
iidIRulerLevel :: Com.IID (IRulerLevel Automation.Interface)
iidIRulerLevel = Com.mkIID "{91493492-5A91-11CF-8700-00AA0060263B}"
getFirstMargin :: IRulerLevel a -> Prelude.IO (Prelude.Float)
getFirstMargin =
  Automation.propertyGetID 0x7d3 [] Automation.outFloat
setFirstMargin :: Prelude.Float -> IRulerLevel a -> Prelude.IO ()
setFirstMargin firstMargin =
  Automation.propertySetID 0x7d3 [Automation.inFloat firstMargin]
getLeftMargin :: IRulerLevel a -> Prelude.IO (Prelude.Float)
getLeftMargin =
  Automation.propertyGetID 0x7d4 [] Automation.outFloat
setLeftMargin :: Prelude.Float -> IRulerLevel a -> Prelude.IO ()
setLeftMargin leftMargin =
  Automation.propertySetID 0x7d4 [Automation.inFloat leftMargin]
-- --------------------------------------------------
-- 
-- interface TabStops
-- 
-- --------------------------------------------------
data TabStops a = TabStops
                   
type ITabStops a = ICollection (TabStops a)
iidITabStops :: Com.IID (ITabStops Automation.Interface)
iidITabStops = Com.mkIID "{91493493-5A91-11CF-8700-00AA0060263B}"
item19 :: Prelude.Int -> ITabStops a -> Prelude.IO (ITabStop Automation.Interface)
item19 index =
  Automation.functionID1 0o0 [Automation.inInt index] Automation.outIDispatch
getDefaultSpacing :: ITabStops a -> Prelude.IO (Prelude.Float)
getDefaultSpacing =
  Automation.propertyGetID 0x7d3 [] Automation.outFloat
setDefaultSpacing :: Prelude.Float -> ITabStops a -> Prelude.IO ()
setDefaultSpacing defaultSpacing =
  Automation.propertySetID 0x7d3 [Automation.inFloat defaultSpacing]
add6 :: (Automation.Variant a0) => a0 -> Prelude.Float -> ITabStops a -> Prelude.IO (ITabStop Automation.Interface)
add6 type0 position =
  Automation.functionID1 0x7d4 [Automation.inVariant type0, Automation.inFloat position] Automation.outIDispatch
-- --------------------------------------------------
-- 
-- interface TabStop
-- 
-- --------------------------------------------------
data TabStop a = TabStop
                  
type ITabStop a = Automation.IDispatch (TabStop a)
iidITabStop :: Com.IID (ITabStop Automation.Interface)
iidITabStop = Com.mkIID "{91493494-5A91-11CF-8700-00AA0060263B}"
getType12 :: (Automation.Variant a0) => ITabStop a -> Prelude.IO (a0)
getType12 = Automation.propertyGetID 0x7d3 [] Automation.outVariant
setType3 :: (Automation.Variant a0) => a0 -> ITabStop a -> Prelude.IO ()
setType3 type0 =
  Automation.propertySetID 0x7d3 [Automation.inVariant type0]
getPosition :: ITabStop a -> Prelude.IO (Prelude.Float)
getPosition = Automation.propertyGetID 0x7d4 [] Automation.outFloat
setPosition0 :: Prelude.Float -> ITabStop a -> Prelude.IO ()
setPosition0 position =
  Automation.propertySetID 0x7d4 [Automation.inFloat position]
-- --------------------------------------------------
-- 
-- interface Font
-- 
-- --------------------------------------------------
data Font a = Font
               
type IFont a = Automation.IDispatch (Font a)
iidIFont :: Com.IID (IFont Automation.Interface)
iidIFont = Com.mkIID "{91493495-5A91-11CF-8700-00AA0060263B}"
getColor :: IFont a -> Prelude.IO (IColorFormat Automation.Interface)
getColor =
  Automation.propertyGetID 0x7d3 [] Automation.outIDispatch
getBold :: (Automation.Variant a0) => IFont a -> Prelude.IO (a0)
getBold = Automation.propertyGetID 0x7d4 [] Automation.outVariant
setBold :: (Automation.Variant a0) => a0 -> IFont a -> Prelude.IO ()
setBold bold =
  Automation.propertySetID 0x7d4 [Automation.inVariant bold]
getItalic :: (Automation.Variant a0) => IFont a -> Prelude.IO (a0)
getItalic = Automation.propertyGetID 0x7d5 [] Automation.outVariant
setItalic :: (Automation.Variant a0) => a0 -> IFont a -> Prelude.IO ()
setItalic italic =
  Automation.propertySetID 0x7d5 [Automation.inVariant italic]
getShadow1 :: (Automation.Variant a0) => IFont a -> Prelude.IO (a0)
getShadow1 =
  Automation.propertyGetID 0x7d6 [] Automation.outVariant
setShadow :: (Automation.Variant a0) => a0 -> IFont a -> Prelude.IO ()
setShadow shadow =
  Automation.propertySetID 0x7d6 [Automation.inVariant shadow]
getEmboss :: (Automation.Variant a0) => IFont a -> Prelude.IO (a0)
getEmboss = Automation.propertyGetID 0x7d7 [] Automation.outVariant
setEmboss :: (Automation.Variant a0) => a0 -> IFont a -> Prelude.IO ()
setEmboss emboss =
  Automation.propertySetID 0x7d7 [Automation.inVariant emboss]
getUnderline :: (Automation.Variant a0) => IFont a -> Prelude.IO (a0)
getUnderline =
  Automation.propertyGetID 0x7d8 [] Automation.outVariant
setUnderline :: (Automation.Variant a0) => a0 -> IFont a -> Prelude.IO ()
setUnderline underline =
  Automation.propertySetID 0x7d8 [Automation.inVariant underline]
getSubscript :: (Automation.Variant a0) => IFont a -> Prelude.IO (a0)
getSubscript =
  Automation.propertyGetID 0x7d9 [] Automation.outVariant
setSubscript :: (Automation.Variant a0) => a0 -> IFont a -> Prelude.IO ()
setSubscript subscript =
  Automation.propertySetID 0x7d9 [Automation.inVariant subscript]
getSuperscript :: (Automation.Variant a0) => IFont a -> Prelude.IO (a0)
getSuperscript =
  Automation.propertyGetID 0x7da [] Automation.outVariant
setSuperscript :: (Automation.Variant a0) => a0 -> IFont a -> Prelude.IO ()
setSuperscript superscript =
  Automation.propertySetID 0x7da [Automation.inVariant superscript]
getBaselineOffset :: IFont a -> Prelude.IO (Prelude.Float)
getBaselineOffset =
  Automation.propertyGetID 0x7db [] Automation.outFloat
setBaselineOffset :: Prelude.Float -> IFont a -> Prelude.IO ()
setBaselineOffset baselineOffset =
  Automation.propertySetID 0x7db [Automation.inFloat baselineOffset]
getEmbedded :: (Automation.Variant a0) => IFont a -> Prelude.IO (a0)
getEmbedded =
  Automation.propertyGetID 0x7dc [] Automation.outVariant
getEmbeddable :: (Automation.Variant a0) => IFont a -> Prelude.IO (a0)
getEmbeddable =
  Automation.propertyGetID 0x7dd [] Automation.outVariant
getSize :: IFont a -> Prelude.IO (Prelude.Float)
getSize = Automation.propertyGetID 0x7de [] Automation.outFloat
setSize :: Prelude.Float -> IFont a -> Prelude.IO ()
setSize size =
  Automation.propertySetID 0x7de [Automation.inFloat size]
getNameFarEast :: IFont a -> Prelude.IO (Prelude.String)
getNameFarEast =
  Automation.propertyGetID 0x7e0 [] Automation.outString
setNameFarEast :: Prelude.String -> IFont a -> Prelude.IO ()
setNameFarEast nameFarEast =
  Automation.propertySetID 0x7e0 [Automation.inString nameFarEast]
getNameAscii :: IFont a -> Prelude.IO (Prelude.String)
getNameAscii =
  Automation.propertyGetID 0x7e1 [] Automation.outString
setNameAscii :: Prelude.String -> IFont a -> Prelude.IO ()
setNameAscii nameAscii =
  Automation.propertySetID 0x7e1 [Automation.inString nameAscii]
getAutoRotateNumbers :: (Automation.Variant a0) => IFont a -> Prelude.IO (a0)
getAutoRotateNumbers =
  Automation.propertyGetID 0x7e2 [] Automation.outVariant
setAutoRotateNumbers :: (Automation.Variant a0) => a0 -> IFont a -> Prelude.IO ()
setAutoRotateNumbers autoRotateNumbers =
  Automation.propertySetID 0x7e2 [Automation.inVariant autoRotateNumbers]
getNameOther :: IFont a -> Prelude.IO (Prelude.String)
getNameOther =
  Automation.propertyGetID 0x7e3 [] Automation.outString
setNameOther :: Prelude.String -> IFont a -> Prelude.IO ()
setNameOther nameOther =
  Automation.propertySetID 0x7e3 [Automation.inString nameOther]
-- --------------------------------------------------
-- 
-- interface ParagraphFormat
-- 
-- --------------------------------------------------
data ParagraphFormat a = ParagraphFormat
                          
type IParagraphFormat a = Automation.IDispatch (ParagraphFormat a)
iidIParagraphFormat :: Com.IID (IParagraphFormat Automation.Interface)
iidIParagraphFormat =
  Com.mkIID "{91493496-5A91-11CF-8700-00AA0060263B}"
getAlignment0 :: (Automation.Variant a0) => IParagraphFormat a -> Prelude.IO (a0)
getAlignment0 =
  Automation.propertyGetID 0x7d3 [] Automation.outVariant
setAlignment0 :: (Automation.Variant a0) => a0 -> IParagraphFormat a -> Prelude.IO ()
setAlignment0 alignment =
  Automation.propertySetID 0x7d3 [Automation.inVariant alignment]
getBullet :: IParagraphFormat a -> Prelude.IO (IBulletFormat Automation.Interface)
getBullet =
  Automation.propertyGetID 0x7d4 [] Automation.outIDispatch
getLineRuleBefore :: (Automation.Variant a0) => IParagraphFormat a -> Prelude.IO (a0)
getLineRuleBefore =
  Automation.propertyGetID 0x7d5 [] Automation.outVariant
setLineRuleBefore :: (Automation.Variant a0) => a0 -> IParagraphFormat a -> Prelude.IO ()
setLineRuleBefore lineRuleBefore =
  Automation.propertySetID 0x7d5 [Automation.inVariant lineRuleBefore]
getLineRuleAfter :: (Automation.Variant a0) => IParagraphFormat a -> Prelude.IO (a0)
getLineRuleAfter =
  Automation.propertyGetID 0x7d6 [] Automation.outVariant
setLineRuleAfter :: (Automation.Variant a0) => a0 -> IParagraphFormat a -> Prelude.IO ()
setLineRuleAfter lineRuleAfter =
  Automation.propertySetID 0x7d6 [Automation.inVariant lineRuleAfter]
getLineRuleWithin :: (Automation.Variant a0) => IParagraphFormat a -> Prelude.IO (a0)
getLineRuleWithin =
  Automation.propertyGetID 0x7d7 [] Automation.outVariant
setLineRuleWithin :: (Automation.Variant a0) => a0 -> IParagraphFormat a -> Prelude.IO ()
setLineRuleWithin lineRuleWithin =
  Automation.propertySetID 0x7d7 [Automation.inVariant lineRuleWithin]
getSpaceBefore :: IParagraphFormat a -> Prelude.IO (Prelude.Float)
getSpaceBefore =
  Automation.propertyGetID 0x7d8 [] Automation.outFloat
setSpaceBefore :: Prelude.Float -> IParagraphFormat a -> Prelude.IO ()
setSpaceBefore spaceBefore =
  Automation.propertySetID 0x7d8 [Automation.inFloat spaceBefore]
getSpaceAfter :: IParagraphFormat a -> Prelude.IO (Prelude.Float)
getSpaceAfter =
  Automation.propertyGetID 0x7d9 [] Automation.outFloat
setSpaceAfter :: Prelude.Float -> IParagraphFormat a -> Prelude.IO ()
setSpaceAfter spaceAfter =
  Automation.propertySetID 0x7d9 [Automation.inFloat spaceAfter]
getSpaceWithin :: IParagraphFormat a -> Prelude.IO (Prelude.Float)
getSpaceWithin =
  Automation.propertyGetID 0x7da [] Automation.outFloat
setSpaceWithin :: Prelude.Float -> IParagraphFormat a -> Prelude.IO ()
setSpaceWithin spaceWithin =
  Automation.propertySetID 0x7da [Automation.inFloat spaceWithin]
getBaseLineAlignment :: (Automation.Variant a0) => IParagraphFormat a -> Prelude.IO (a0)
getBaseLineAlignment =
  Automation.propertyGetID 0x7db [] Automation.outVariant
setBaseLineAlignment :: (Automation.Variant a0) => a0 -> IParagraphFormat a -> Prelude.IO ()
setBaseLineAlignment baseLineAlignment =
  Automation.propertySetID 0x7db [Automation.inVariant baseLineAlignment]
getFarEastLineBreakControl :: (Automation.Variant a0) => IParagraphFormat a -> Prelude.IO (a0)
getFarEastLineBreakControl =
  Automation.propertyGetID 0x7dc [] Automation.outVariant
setFarEastLineBreakControl :: (Automation.Variant a0) => a0 -> IParagraphFormat a -> Prelude.IO ()
setFarEastLineBreakControl farEastLineBreakControl =
  Automation.propertySetID 0x7dc [Automation.inVariant farEastLineBreakControl]
getHangingPunctuation :: (Automation.Variant a0) => IParagraphFormat a -> Prelude.IO (a0)
getHangingPunctuation =
  Automation.propertyGetID 0x7de [] Automation.outVariant
setHangingPunctuation :: (Automation.Variant a0) => a0 -> IParagraphFormat a -> Prelude.IO ()
setHangingPunctuation hangingPunctuation =
  Automation.propertySetID 0x7de [Automation.inVariant hangingPunctuation]
getTextDirection :: (Automation.Variant a0) => IParagraphFormat a -> Prelude.IO (a0)
getTextDirection =
  Automation.propertyGetID 0x7df [] Automation.outVariant
setTextDirection :: (Automation.Variant a0) => a0 -> IParagraphFormat a -> Prelude.IO ()
setTextDirection textDirection =
  Automation.propertySetID 0x7df [Automation.inVariant textDirection]
-- --------------------------------------------------
-- 
-- interface BulletFormat
-- 
-- --------------------------------------------------
data BulletFormat a = BulletFormat
                       
type IBulletFormat a = Automation.IDispatch (BulletFormat a)
iidIBulletFormat :: Com.IID (IBulletFormat Automation.Interface)
iidIBulletFormat =
  Com.mkIID "{91493497-5A91-11CF-8700-00AA0060263B}"
getCharacter :: IBulletFormat a -> Prelude.IO (Prelude.Int)
getCharacter = Automation.propertyGetID 0x7d3 [] Automation.outInt
setCharacter :: Prelude.Int -> IBulletFormat a -> Prelude.IO ()
setCharacter character =
  Automation.propertySetID 0x7d3 [Automation.inInt character]
getRelativeSize :: IBulletFormat a -> Prelude.IO (Prelude.Float)
getRelativeSize =
  Automation.propertyGetID 0x7d4 [] Automation.outFloat
setRelativeSize :: Prelude.Float -> IBulletFormat a -> Prelude.IO ()
setRelativeSize relativeSize =
  Automation.propertySetID 0x7d4 [Automation.inFloat relativeSize]
getUseTextColor :: (Automation.Variant a0) => IBulletFormat a -> Prelude.IO (a0)
getUseTextColor =
  Automation.propertyGetID 0x7d5 [] Automation.outVariant
setUseTextColor :: (Automation.Variant a0) => a0 -> IBulletFormat a -> Prelude.IO ()
setUseTextColor useTextColor =
  Automation.propertySetID 0x7d5 [Automation.inVariant useTextColor]
getUseTextFont :: (Automation.Variant a0) => IBulletFormat a -> Prelude.IO (a0)
getUseTextFont =
  Automation.propertyGetID 0x7d6 [] Automation.outVariant
setUseTextFont :: (Automation.Variant a0) => a0 -> IBulletFormat a -> Prelude.IO ()
setUseTextFont useTextFont =
  Automation.propertySetID 0x7d6 [Automation.inVariant useTextFont]
-- --------------------------------------------------
-- 
-- interface TextStyles
-- 
-- --------------------------------------------------
data TextStyles a = TextStyles
                     
type ITextStyles a = ICollection (TextStyles a)
iidITextStyles :: Com.IID (ITextStyles Automation.Interface)
iidITextStyles = Com.mkIID "{91493498-5A91-11CF-8700-00AA0060263B}"
item20 :: (Automation.Variant a0) => a0 -> ITextStyles a -> Prelude.IO (ITextStyle Automation.Interface)
item20 type0 =
  Automation.functionID1 0o0 [Automation.inVariant type0] Automation.outIDispatch
-- --------------------------------------------------
-- 
-- interface TextStyle
-- 
-- --------------------------------------------------
data TextStyle a = TextStyle
                    
type ITextStyle a = Automation.IDispatch (TextStyle a)
iidITextStyle :: Com.IID (ITextStyle Automation.Interface)
iidITextStyle = Com.mkIID "{91493499-5A91-11CF-8700-00AA0060263B}"
getTextFrame1 :: ITextStyle a -> Prelude.IO (ITextFrame Automation.Interface)
getTextFrame1 =
  Automation.propertyGetID 0x7d4 [] Automation.outIDispatch
getLevels0 :: ITextStyle a -> Prelude.IO (ITextStyleLevels Automation.Interface)
getLevels0 =
  Automation.propertyGetID 0x7d5 [] Automation.outIDispatch
-- --------------------------------------------------
-- 
-- interface TextStyleLevels
-- 
-- --------------------------------------------------
data TextStyleLevels a = TextStyleLevels
                          
type ITextStyleLevels a = ICollection (TextStyleLevels a)
iidITextStyleLevels :: Com.IID (ITextStyleLevels Automation.Interface)
iidITextStyleLevels =
  Com.mkIID "{9149349A-5A91-11CF-8700-00AA0060263B}"
item21 :: Prelude.Int -> ITextStyleLevels a -> Prelude.IO (ITextStyleLevel Automation.Interface)
item21 level =
  Automation.functionID1 0o0 [Automation.inInt level] Automation.outIDispatch
-- --------------------------------------------------
-- 
-- interface TextStyleLevel
-- 
-- --------------------------------------------------
data TextStyleLevel a = TextStyleLevel
                         
type ITextStyleLevel a = Automation.IDispatch (TextStyleLevel a)
iidITextStyleLevel :: Com.IID (ITextStyleLevel Automation.Interface)
iidITextStyleLevel =
  Com.mkIID "{9149349B-5A91-11CF-8700-00AA0060263B}"
-- --------------------------------------------------
-- 
-- interface HeaderFooter
-- 
-- --------------------------------------------------
data HeaderFooter a = HeaderFooter
                       
type IHeaderFooter a = Automation.IDispatch (HeaderFooter a)
iidIHeaderFooter :: Com.IID (IHeaderFooter Automation.Interface)
iidIHeaderFooter =
  Com.mkIID "{9149349C-5A91-11CF-8700-00AA0060263B}"
getUseFormat :: (Automation.Variant a0) => IHeaderFooter a -> Prelude.IO (a0)
getUseFormat =
  Automation.propertyGetID 0x7d5 [] Automation.outVariant
setUseFormat :: (Automation.Variant a0) => a0 -> IHeaderFooter a -> Prelude.IO ()
setUseFormat useFormat =
  Automation.propertySetID 0x7d5 [Automation.inVariant useFormat]
getFormat :: (Automation.Variant a0) => IHeaderFooter a -> Prelude.IO (a0)
getFormat = Automation.propertyGetID 0x7d6 [] Automation.outVariant
setFormat :: (Automation.Variant a0) => a0 -> IHeaderFooter a -> Prelude.IO ()
setFormat format =
  Automation.propertySetID 0x7d6 [Automation.inVariant format]
-- --------------------------------------------------
-- 
-- interface Presentation
-- 
-- --------------------------------------------------
data Presentation a = Presentation
                       
type IPresentation a = Automation.IDispatch (Presentation a)
iidIPresentation :: Com.IID (IPresentation Automation.Interface)
iidIPresentation =
  Com.mkIID "{9149349D-5A91-11CF-8700-00AA0060263B}"
getSlideMaster :: IPresentation a -> Prelude.IO (IMaster Automation.Interface)
getSlideMaster =
  Automation.propertyGetID 0x7d3 [] Automation.outIDispatch
getTitleMaster :: IPresentation a -> Prelude.IO (IMaster Automation.Interface)
getTitleMaster =
  Automation.propertyGetID 0x7d4 [] Automation.outIDispatch
getHasTitleMaster :: (Automation.Variant a0) => IPresentation a -> Prelude.IO (a0)
getHasTitleMaster =
  Automation.propertyGetID 0x7d5 [] Automation.outVariant
addTitleMaster :: IPresentation a -> Prelude.IO (IMaster Automation.Interface)
addTitleMaster =
  Automation.functionID1 0x7d6 [] Automation.outIDispatch
applyTemplate :: Prelude.String -> IPresentation a -> Prelude.IO ()
applyTemplate fileName =
  Automation.methodID0 0x7d7 [Automation.inString fileName]
getTemplateName :: IPresentation a -> Prelude.IO (Prelude.String)
getTemplateName =
  Automation.propertyGetID 0x7d8 [] Automation.outString
getNotesMaster :: IPresentation a -> Prelude.IO (IMaster Automation.Interface)
getNotesMaster =
  Automation.propertyGetID 0x7d9 [] Automation.outIDispatch
getHandoutMaster :: IPresentation a -> Prelude.IO (IMaster Automation.Interface)
getHandoutMaster =
  Automation.propertyGetID 0x7da [] Automation.outIDispatch
getSlides :: IPresentation a -> Prelude.IO (ISlides Automation.Interface)
getSlides =
  Automation.propertyGetID 0x7db [] Automation.outIDispatch
getPageSetup :: IPresentation a -> Prelude.IO (IPageSetup Automation.Interface)
getPageSetup =
  Automation.propertyGetID 0x7dc [] Automation.outIDispatch
getColorSchemes :: IPresentation a -> Prelude.IO (IColorSchemes Automation.Interface)
getColorSchemes =
  Automation.propertyGetID 0x7dd [] Automation.outIDispatch
getExtraColors :: IPresentation a -> Prelude.IO (IExtraColors Automation.Interface)
getExtraColors =
  Automation.propertyGetID 0x7de [] Automation.outIDispatch
getSlideShowSettings :: IPresentation a -> Prelude.IO (ISlideShowSettings Automation.Interface)
getSlideShowSettings =
  Automation.propertyGetID 0x7df [] Automation.outIDispatch
getFonts :: IPresentation a -> Prelude.IO (IFonts Automation.Interface)
getFonts =
  Automation.propertyGetID 0x7e0 [] Automation.outIDispatch
getDefaultShape :: IPresentation a -> Prelude.IO (IShape Automation.Interface)
getDefaultShape =
  Automation.propertyGetID 0x7e3 [] Automation.outIDispatch
getBuiltInDocumentProperties :: IPresentation a -> Prelude.IO (Automation.IDispatch Automation.Interface)
getBuiltInDocumentProperties =
  Automation.propertyGetID 0x7e4 [] Automation.outIDispatch
getCustomDocumentProperties :: IPresentation a -> Prelude.IO (Automation.IDispatch Automation.Interface)
getCustomDocumentProperties =
  Automation.propertyGetID 0x7e5 [] Automation.outIDispatch
getVBProject :: IPresentation a -> Prelude.IO (VBIDE.IVBProject Automation.Interface)
getVBProject =
  Automation.propertyGetID 0x7e6 [] Automation.outIDispatch
getReadOnly :: (Automation.Variant a0) => Automation.IDispatch a -> Prelude.IO (a0)
getReadOnly =
  Automation.propertyGetID 0x7e7 [] Automation.outVariant
getSaved :: (Automation.Variant a0) => IPresentation a -> Prelude.IO (a0)
getSaved = Automation.propertyGetID 0x7eb [] Automation.outVariant
setSaved :: (Automation.Variant a0) => a0 -> IPresentation a -> Prelude.IO ()
setSaved saved =
  Automation.propertySetID 0x7eb [Automation.inVariant saved]
getLayoutDirection :: (Automation.Variant a0) => IPresentation a -> Prelude.IO (a0)
getLayoutDirection =
  Automation.propertyGetID 0x7ec [] Automation.outVariant
setLayoutDirection :: (Automation.Variant a0) => a0 -> IPresentation a -> Prelude.IO ()
setLayoutDirection layoutDirection =
  Automation.propertySetID 0x7ec [Automation.inVariant layoutDirection]
followHyperlink :: (Automation.Variant a0) => Prelude.String -> Prelude.String -> Prelude.Int -> Prelude.Int -> Prelude.String -> a0 -> Prelude.String -> IPresentation a -> Prelude.IO ()
followHyperlink address subAddress newWindow addHistory extraInfo method headerInfo =
  Automation.methodID0 0x7ee [Automation.inString address, Automation.inString subAddress, Automation.inInt newWindow, Automation.inInt addHistory, Automation.inString extraInfo, Automation.inVariant method, Automation.inString headerInfo]
unused :: IPresentation a -> Prelude.IO ()
unused = Automation.methodID0 0x7f0 []
getPrintOptions :: IPresentation a -> Prelude.IO (IPrintOptions Automation.Interface)
getPrintOptions =
  Automation.propertyGetID 0x7f1 [] Automation.outIDispatch
printOut :: (Automation.Variant a0) => Prelude.Int -> Prelude.Int -> Prelude.String -> Prelude.Int -> a0 -> IPresentation a -> Prelude.IO ()
printOut from to printToFile copies collate =
  Automation.methodID0 0x7f2 [Automation.inInt from, Automation.inInt to, Automation.inString printToFile, Automation.inInt copies, Automation.inVariant collate]
save :: IPresentation a -> Prelude.IO ()
save = Automation.methodID0 0x7f3 []
saveAs :: (Automation.Variant a0, Automation.Variant a1) => Prelude.String -> a0 -> a1 -> IPresentation a -> Prelude.IO ()
saveAs fileName fileFormat embedTrueTypeFonts =
  Automation.methodID0 0x7f4 [Automation.inString fileName, Automation.inVariant fileFormat, Automation.inVariant embedTrueTypeFonts]
saveCopyAs :: (Automation.Variant a0, Automation.Variant a1) => Prelude.String -> a0 -> a1 -> IPresentation a -> Prelude.IO ()
saveCopyAs fileName fileFormat embedTrueTypeFonts =
  Automation.methodID0 0x7f5 [Automation.inString fileName, Automation.inVariant fileFormat, Automation.inVariant embedTrueTypeFonts]
setUndoText :: Prelude.String -> IPresentation a -> Prelude.IO ()
setUndoText text =
  Automation.methodID0 0x7f8 [Automation.inString text]
getContainer :: IPresentation a -> Prelude.IO (Automation.IDispatch Automation.Interface)
getContainer =
  Automation.propertyGetID 0x7f9 [] Automation.outIDispatch
getDisplayComments :: (Automation.Variant a0) => IPresentation a -> Prelude.IO (a0)
getDisplayComments =
  Automation.propertyGetID 0x7fa [] Automation.outVariant
setDisplayComments :: (Automation.Variant a0) => a0 -> IPresentation a -> Prelude.IO ()
setDisplayComments displayComments =
  Automation.propertySetID 0x7fa [Automation.inVariant displayComments]
getFarEastLineBreakLevel :: (Automation.Variant a0) => IPresentation a -> Prelude.IO (a0)
getFarEastLineBreakLevel =
  Automation.propertyGetID 0x7fb [] Automation.outVariant
setFarEastLineBreakLevel :: (Automation.Variant a0) => a0 -> IPresentation a -> Prelude.IO ()
setFarEastLineBreakLevel farEastLineBreakLevel =
  Automation.propertySetID 0x7fb [Automation.inVariant farEastLineBreakLevel]
getNoLineBreakBefore :: IPresentation a -> Prelude.IO (Prelude.String)
getNoLineBreakBefore =
  Automation.propertyGetID 0x7fc [] Automation.outString
setNoLineBreakBefore :: Prelude.String -> IPresentation a -> Prelude.IO ()
setNoLineBreakBefore noLineBreakBefore =
  Automation.propertySetID 0x7fc [Automation.inString noLineBreakBefore]
getNoLineBreakAfter :: IPresentation a -> Prelude.IO (Prelude.String)
getNoLineBreakAfter =
  Automation.propertyGetID 0x7fd [] Automation.outString
setNoLineBreakAfter :: Prelude.String -> IPresentation a -> Prelude.IO ()
setNoLineBreakAfter noLineBreakAfter =
  Automation.propertySetID 0x7fd [Automation.inString noLineBreakAfter]
updateLinks :: IPresentation a -> Prelude.IO ()
updateLinks = Automation.methodID0 0x7fe []
getSlideShowWindow :: IPresentation a -> Prelude.IO (ISlideShowWindow Automation.Interface)
getSlideShowWindow =
  Automation.propertyGetID 0x7ff [] Automation.outIDispatch
-- --------------------------------------------------
-- 
-- interface PPDialogs
-- 
-- --------------------------------------------------
data PPDialogs a = PPDialogs
                    
type IPPDialogs a = ICollection (PPDialogs a)
iidIPPDialogs :: Com.IID (IPPDialogs Automation.Interface)
iidIPPDialogs = Com.mkIID "{9149349E-5A91-11CF-8700-00AA0060263B}"
item22 :: Prelude.Int -> IPPDialogs a -> Prelude.IO (IPPDialog Automation.Interface)
item22 index =
  Automation.functionID1 0o0 [Automation.inInt index] Automation.outIDispatch
addDialog :: (Automation.Variant a0, Automation.Variant a2, Automation.Variant a3) => Prelude.Float -> Prelude.Float -> Prelude.Float -> Prelude.Float -> a0 -> Com.IUnknown a1 -> a2 -> a3 -> IPPDialogs a -> Prelude.IO (IPPDialog Automation.Interface)
addDialog left top width height modal parentWindow position displayHelp =
  Automation.functionID1 0x7d2 [Automation.inFloat left, Automation.inFloat top, Automation.inFloat width, Automation.inFloat height, Automation.inVariant modal, Automation.inIUnknown parentWindow, Automation.inVariant position, Automation.inVariant displayHelp] Automation.outIDispatch
addTabDialog :: (Automation.Variant a0, Automation.Variant a2, Automation.Variant a3) => Prelude.Float -> Prelude.Float -> Prelude.Float -> Prelude.Float -> a0 -> Com.IUnknown a1 -> a2 -> a3 -> IPPDialogs a -> Prelude.IO (IPPDialog Automation.Interface)
addTabDialog left top width height modal parentWindow position displayHelp =
  Automation.functionID1 0x7d3 [Automation.inFloat left, Automation.inFloat top, Automation.inFloat width, Automation.inFloat height, Automation.inVariant modal, Automation.inIUnknown parentWindow, Automation.inVariant position, Automation.inVariant displayHelp] Automation.outIDispatch
loadDialog :: (Automation.Variant a0, Automation.Variant a2) => Prelude.String -> Prelude.Int -> a0 -> Com.IUnknown a1 -> a2 -> IPPDialogs a -> Prelude.IO (IPPDialog Automation.Interface)
loadDialog resourceDLL nResID bModal parentWindow position =
  Automation.functionID1 0x7d4 [Automation.inString resourceDLL, Automation.inInt nResID, Automation.inVariant bModal, Automation.inIUnknown parentWindow, Automation.inVariant position] Automation.outIDispatch
addAlert :: IPPDialogs a -> Prelude.IO (IPPAlert Automation.Interface)
addAlert = Automation.functionID1 0x7d5 [] Automation.outIDispatch
runCharacterAlert :: (Automation.Variant a0, Automation.Variant a1, Automation.Variant a3) => Prelude.String -> a0 -> a1 -> Com.IUnknown a2 -> IPPDialogs a -> Prelude.IO (a3)
runCharacterAlert text type0 icon parentWindow =
  Automation.functionID1 0x7d8 [Automation.inString text, Automation.inVariant type0, Automation.inVariant icon, Automation.inIUnknown parentWindow] Automation.outVariant
-- --------------------------------------------------
-- 
-- interface PPAlert
-- 
-- --------------------------------------------------
data PPAlert a = PPAlert
                  
type IPPAlert a = Automation.IDispatch (PPAlert a)
iidIPPAlert :: Com.IID (IPPAlert Automation.Interface)
iidIPPAlert = Com.mkIID "{9149349F-5A91-11CF-8700-00AA0060263B}"
run1 :: Prelude.String -> Prelude.Int -> Prelude.String -> Prelude.String -> Prelude.String -> Prelude.String -> IPPAlert a -> Prelude.IO ()
run1 title type0 text leftBtn middleBtn rightBtn =
  Automation.methodID0 0x7d3 [Automation.inString title, Automation.inInt type0, Automation.inString text, Automation.inString leftBtn, Automation.inString middleBtn, Automation.inString rightBtn]
getPressedButton :: IPPAlert a -> Prelude.IO (Prelude.Int)
getPressedButton =
  Automation.propertyGetID 0x7d4 [] Automation.outInt
getOnButton :: IPPAlert a -> Prelude.IO (Prelude.String)
getOnButton =
  Automation.propertyGetID 0x7d5 [] Automation.outString
setOnButton :: Prelude.String -> IPPAlert a -> Prelude.IO ()
setOnButton onButton =
  Automation.propertySetID 0x7d5 [Automation.inString onButton]
-- --------------------------------------------------
-- 
-- interface PPDialog
-- 
-- --------------------------------------------------
data PPDialog a = PPDialog
                   
type IPPDialog a = Automation.IDispatch (PPDialog a)
iidIPPDialog :: Com.IID (IPPDialog Automation.Interface)
iidIPPDialog = Com.mkIID "{914934A0-5A91-11CF-8700-00AA0060263B}"
getStyle0 :: (Automation.Variant a0) => IPPDialog a -> Prelude.IO (a0)
getStyle0 = Automation.propertyGetID 0x7d3 [] Automation.outVariant
getMode :: (Automation.Variant a0) => IPPDialog a -> Prelude.IO (a0)
getMode = Automation.propertyGetID 0x7d4 [] Automation.outVariant
setMode :: (Automation.Variant a0) => a0 -> IPPDialog a -> Prelude.IO ()
setMode mode =
  Automation.propertySetID 0x7d4 [Automation.inVariant mode]
getHelpId :: Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getHelpId = Automation.propertyGetID 0x7d5 [] Automation.outInt
setHelpId :: Prelude.Int -> Automation.IDispatch a -> Prelude.IO ()
setHelpId helpId =
  Automation.propertySetID 0x7d5 [Automation.inInt helpId]
getHideOnIdle :: (Automation.Variant a0) => IPPDialog a -> Prelude.IO (a0)
getHideOnIdle =
  Automation.propertyGetID 0x7d6 [] Automation.outVariant
setHideOnIdle :: (Automation.Variant a0) => a0 -> IPPDialog a -> Prelude.IO ()
setHideOnIdle hideOnIdle =
  Automation.propertySetID 0x7d6 [Automation.inVariant hideOnIdle]
getResourceDLL :: IPPDialog a -> Prelude.IO (Prelude.String)
getResourceDLL =
  Automation.propertyGetID 0x7d7 [] Automation.outString
setResourceDLL :: Prelude.String -> IPPDialog a -> Prelude.IO ()
setResourceDLL resourceDLL =
  Automation.propertySetID 0x7d7 [Automation.inString resourceDLL]
getClientLeft :: Automation.IDispatch a -> Prelude.IO (Prelude.Float)
getClientLeft =
  Automation.propertyGetID 0x7dd [] Automation.outFloat
getClientTop :: Automation.IDispatch a -> Prelude.IO (Prelude.Float)
getClientTop =
  Automation.propertyGetID 0x7de [] Automation.outFloat
getClientWidth :: Automation.IDispatch a -> Prelude.IO (Prelude.Float)
getClientWidth =
  Automation.propertyGetID 0x7df [] Automation.outFloat
getClientHeight :: Automation.IDispatch a -> Prelude.IO (Prelude.Float)
getClientHeight =
  Automation.propertyGetID 0x7e0 [] Automation.outFloat
getControls :: Automation.IDispatch a -> Prelude.IO (IPPControls Automation.Interface)
getControls =
  Automation.propertyGetID 0x7e2 [] Automation.outIDispatch
getSheets :: IPPDialog a -> Prelude.IO (IPPTabSheets Automation.Interface)
getSheets =
  Automation.propertyGetID 0x7e5 [] Automation.outIDispatch
getTabControl :: IPPDialog a -> Prelude.IO (IPPTabControl Automation.Interface)
getTabControl =
  Automation.propertyGetID 0x7e6 [] Automation.outIDispatch
getDelayTime :: IPPDialog a -> Prelude.IO (Prelude.Int)
getDelayTime = Automation.propertyGetID 0x7e7 [] Automation.outInt
setDelayTime :: Prelude.Int -> IPPDialog a -> Prelude.IO ()
setDelayTime delayTime =
  Automation.propertySetID 0x7e7 [Automation.inInt delayTime]
saveDialog :: Prelude.String -> IPPDialog a -> Prelude.IO (Prelude.Int)
saveDialog fileName =
  Automation.functionID1 0x7e8 [Automation.inString fileName] Automation.outInt
terminate :: IPPDialog a -> Prelude.IO ()
terminate = Automation.methodID0 0x7e9 []
getOnTerminate :: IPPDialog a -> Prelude.IO (Prelude.String)
getOnTerminate =
  Automation.propertyGetID 0x7eb [] Automation.outString
setOnTerminate :: Prelude.String -> IPPDialog a -> Prelude.IO ()
setOnTerminate onTerminate =
  Automation.propertySetID 0x7eb [Automation.inString onTerminate]
getOnIdle :: IPPDialog a -> Prelude.IO (Prelude.String)
getOnIdle = Automation.propertyGetID 0x7ec [] Automation.outString
setOnIdle :: Prelude.String -> IPPDialog a -> Prelude.IO ()
setOnIdle onIdle =
  Automation.propertySetID 0x7ec [Automation.inString onIdle]
getOnMouseDown :: IPPDialog a -> Prelude.IO (Prelude.String)
getOnMouseDown =
  Automation.propertyGetID 0x7ed [] Automation.outString
setOnMouseDown :: Prelude.String -> IPPDialog a -> Prelude.IO ()
setOnMouseDown onMouseDown =
  Automation.propertySetID 0x7ed [Automation.inString onMouseDown]
getOnMouseUp :: IPPDialog a -> Prelude.IO (Prelude.String)
getOnMouseUp =
  Automation.propertyGetID 0x7ee [] Automation.outString
setOnMouseUp :: Prelude.String -> IPPDialog a -> Prelude.IO ()
setOnMouseUp onMouseUp =
  Automation.propertySetID 0x7ee [Automation.inString onMouseUp]
getOnKeyPressed :: IPPDialog a -> Prelude.IO (Prelude.String)
getOnKeyPressed =
  Automation.propertyGetID 0x7ef [] Automation.outString
setOnKeyPressed :: Prelude.String -> IPPDialog a -> Prelude.IO ()
setOnKeyPressed onKeyPressed =
  Automation.propertySetID 0x7ef [Automation.inString onKeyPressed]
getOnTimer :: IPPDialog a -> Prelude.IO (Prelude.String)
getOnTimer = Automation.propertyGetID 0x7f0 [] Automation.outString
setOnTimer :: Prelude.String -> IPPDialog a -> Prelude.IO ()
setOnTimer onTimer =
  Automation.propertySetID 0x7f0 [Automation.inString onTimer]
getOnActivate :: Automation.IDispatch a -> Prelude.IO (Prelude.String)
getOnActivate =
  Automation.propertyGetID 0x7f1 [] Automation.outString
setOnActivate :: Prelude.String -> Automation.IDispatch a -> Prelude.IO ()
setOnActivate onActivate =
  Automation.propertySetID 0x7f1 [Automation.inString onActivate]
-- --------------------------------------------------
-- 
-- interface PPTabSheet
-- 
-- --------------------------------------------------
data PPTabSheet a = PPTabSheet
                     
type IPPTabSheet a = Automation.IDispatch (PPTabSheet a)
iidIPPTabSheet :: Com.IID (IPPTabSheet Automation.Interface)
iidIPPTabSheet = Com.mkIID "{914934A1-5A91-11CF-8700-00AA0060263B}"
-- --------------------------------------------------
-- 
-- interface PPControls
-- 
-- --------------------------------------------------
data PPControls a = PPControls
                     
type IPPControls a = ICollection (PPControls a)
iidIPPControls :: Com.IID (IPPControls Automation.Interface)
iidIPPControls = Com.mkIID "{914934A2-5A91-11CF-8700-00AA0060263B}"
item23 :: Prelude.Int -> IPPControls a -> Prelude.IO (IPPControl Automation.Interface)
item23 index =
  Automation.functionID1 0o0 [Automation.inInt index] Automation.outIDispatch
addPushButton :: Prelude.Float -> Prelude.Float -> Prelude.Float -> Prelude.Float -> IPPControls a -> Prelude.IO (IPPPushButton Automation.Interface)
addPushButton left top width height =
  Automation.functionID1 0x7d2 [Automation.inFloat left, Automation.inFloat top, Automation.inFloat width, Automation.inFloat height] Automation.outIDispatch
addToggleButton :: Prelude.Float -> Prelude.Float -> Prelude.Float -> Prelude.Float -> IPPControls a -> Prelude.IO (IPPToggleButton Automation.Interface)
addToggleButton left top width height =
  Automation.functionID1 0x7d3 [Automation.inFloat left, Automation.inFloat top, Automation.inFloat width, Automation.inFloat height] Automation.outIDispatch
addBitmapButton :: Prelude.Float -> Prelude.Float -> Prelude.Float -> Prelude.Float -> IPPControls a -> Prelude.IO (IPPBitmapButton Automation.Interface)
addBitmapButton left top width height =
  Automation.functionID1 0x7d4 [Automation.inFloat left, Automation.inFloat top, Automation.inFloat width, Automation.inFloat height] Automation.outIDispatch
addListBox :: Prelude.Float -> Prelude.Float -> Prelude.Float -> Prelude.Float -> IPPControls a -> Prelude.IO (IPPListBox Automation.Interface)
addListBox left top width height =
  Automation.functionID1 0x7d5 [Automation.inFloat left, Automation.inFloat top, Automation.inFloat width, Automation.inFloat height] Automation.outIDispatch
addCheckBox :: Prelude.Float -> Prelude.Float -> Prelude.Float -> Prelude.Float -> IPPControls a -> Prelude.IO (IPPCheckBox Automation.Interface)
addCheckBox left top width height =
  Automation.functionID1 0x7d6 [Automation.inFloat left, Automation.inFloat top, Automation.inFloat width, Automation.inFloat height] Automation.outIDispatch
addRadioCluster :: Prelude.Float -> Prelude.Float -> Prelude.Float -> Prelude.Float -> IPPControls a -> Prelude.IO (IPPRadioCluster Automation.Interface)
addRadioCluster left top width height =
  Automation.functionID1 0x7d7 [Automation.inFloat left, Automation.inFloat top, Automation.inFloat width, Automation.inFloat height] Automation.outIDispatch
addStaticText :: Prelude.Float -> Prelude.Float -> Prelude.Float -> Prelude.Float -> IPPControls a -> Prelude.IO (IPPStaticText Automation.Interface)
addStaticText left top width height =
  Automation.functionID1 0x7d8 [Automation.inFloat left, Automation.inFloat top, Automation.inFloat width, Automation.inFloat height] Automation.outIDispatch
addEditText :: Prelude.Float -> Prelude.Float -> Prelude.Float -> Prelude.Float -> Prelude.Int -> IPPControls a -> Prelude.IO (IPPEditText Automation.Interface)
addEditText left top width height verticalScrollBar =
  Automation.functionID1 0x7d9 [Automation.inFloat left, Automation.inFloat top, Automation.inFloat width, Automation.inFloat height, Automation.inInt verticalScrollBar] Automation.outIDispatch
addIcon :: Prelude.Float -> Prelude.Float -> Prelude.Float -> Prelude.Float -> IPPControls a -> Prelude.IO (IPPIcon Automation.Interface)
addIcon left top width height =
  Automation.functionID1 0x7da [Automation.inFloat left, Automation.inFloat top, Automation.inFloat width, Automation.inFloat height] Automation.outIDispatch
addBitmap :: Prelude.Float -> Prelude.Float -> Prelude.Float -> Prelude.Float -> IPPControls a -> Prelude.IO (IPPBitmap Automation.Interface)
addBitmap left top width height =
  Automation.functionID1 0x7db [Automation.inFloat left, Automation.inFloat top, Automation.inFloat width, Automation.inFloat height] Automation.outIDispatch
addSpinner :: Prelude.Float -> Prelude.Float -> Prelude.Float -> Prelude.Float -> IPPControls a -> Prelude.IO (IPPSpinner Automation.Interface)
addSpinner left top width height =
  Automation.functionID1 0x7dc [Automation.inFloat left, Automation.inFloat top, Automation.inFloat width, Automation.inFloat height] Automation.outIDispatch
addScrollBar :: (Automation.Variant a0) => a0 -> Prelude.Float -> Prelude.Float -> Prelude.Float -> Prelude.Float -> IPPControls a -> Prelude.IO (IPPScrollBar Automation.Interface)
addScrollBar style left top width height =
  Automation.functionID1 0x7dd [Automation.inVariant style, Automation.inFloat left, Automation.inFloat top, Automation.inFloat width, Automation.inFloat height] Automation.outIDispatch
addGroupBox :: Prelude.Float -> Prelude.Float -> Prelude.Float -> Prelude.Float -> IPPControls a -> Prelude.IO (IPPGroupBox Automation.Interface)
addGroupBox left top width height =
  Automation.functionID1 0x7de [Automation.inFloat left, Automation.inFloat top, Automation.inFloat width, Automation.inFloat height] Automation.outIDispatch
addDropDown :: Prelude.Float -> Prelude.Float -> Prelude.Float -> Prelude.Float -> IPPControls a -> Prelude.IO (IPPDropDown Automation.Interface)
addDropDown left top width height =
  Automation.functionID1 0x7df [Automation.inFloat left, Automation.inFloat top, Automation.inFloat width, Automation.inFloat height] Automation.outIDispatch
addDropDownEdit :: Prelude.Float -> Prelude.Float -> Prelude.Float -> Prelude.Float -> IPPControls a -> Prelude.IO (IPPDropDownEdit Automation.Interface)
addDropDownEdit left top width height =
  Automation.functionID1 0x7e0 [Automation.inFloat left, Automation.inFloat top, Automation.inFloat width, Automation.inFloat height] Automation.outIDispatch
addMiniature :: Prelude.Float -> Prelude.Float -> Prelude.Float -> Prelude.Float -> IPPControls a -> Prelude.IO (IPPSlideMiniature Automation.Interface)
addMiniature left top width height =
  Automation.functionID1 0x7e1 [Automation.inFloat left, Automation.inFloat top, Automation.inFloat width, Automation.inFloat height] Automation.outIDispatch
addFrame :: Prelude.Float -> Prelude.Float -> Prelude.Float -> Prelude.Float -> IPPControls a -> Prelude.IO (IPPFrame Automation.Interface)
addFrame left top width height =
  Automation.functionID1 0x7e2 [Automation.inFloat left, Automation.inFloat top, Automation.inFloat width, Automation.inFloat height] Automation.outIDispatch
-- --------------------------------------------------
-- 
-- interface PPTabSheets
-- 
-- --------------------------------------------------
data PPTabSheets a = PPTabSheets
                      
type IPPTabSheets a = ICollection (PPTabSheets a)
iidIPPTabSheets :: Com.IID (IPPTabSheets Automation.Interface)
iidIPPTabSheets =
  Com.mkIID "{914934A3-5A91-11CF-8700-00AA0060263B}"
item24 :: Prelude.Int -> IPPTabSheets a -> Prelude.IO (IPPTabSheet Automation.Interface)
item24 index =
  Automation.functionID1 0o0 [Automation.inInt index] Automation.outIDispatch
add7 :: Prelude.String -> IPPTabSheets a -> Prelude.IO (IPPTabSheet Automation.Interface)
add7 name =
  Automation.functionID1 0x7d1 [Automation.inString name] Automation.outIDispatch
getActiveSheet :: IPPTabSheets a -> Prelude.IO (IPPTabSheet Automation.Interface)
getActiveSheet =
  Automation.propertyGetID 0x7d2 [] Automation.outIDispatch
-- --------------------------------------------------
-- 
-- interface PPControl
-- 
-- --------------------------------------------------
data PPControl a = PPControl
                    
type IPPControl a = Automation.IDispatch (PPControl a)
iidIPPControl :: Com.IID (IPPControl Automation.Interface)
iidIPPControl = Com.mkIID "{914934A4-5A91-11CF-8700-00AA0060263B}"
getEnable :: (Automation.Variant a0) => Automation.IDispatch a -> Prelude.IO (a0)
getEnable = Automation.propertyGetID 0x3eb [] Automation.outVariant
setEnable :: (Automation.Variant a0) => a0 -> Automation.IDispatch a -> Prelude.IO ()
setEnable enable =
  Automation.propertySetID 0x3eb [Automation.inVariant enable]
getFocus :: (Automation.Variant a0) => Automation.IDispatch a -> Prelude.IO (a0)
getFocus = Automation.propertyGetID 0x3ed [] Automation.outVariant
setFocus :: (Automation.Variant a0) => a0 -> Automation.IDispatch a -> Prelude.IO ()
setFocus focus =
  Automation.propertySetID 0x3ed [Automation.inVariant focus]
getLabel :: Automation.IDispatch a -> Prelude.IO (Prelude.String)
getLabel = Automation.propertyGetID 0x3ee [] Automation.outString
setLabel :: Prelude.String -> Automation.IDispatch a -> Prelude.IO ()
setLabel label =
  Automation.propertySetID 0x3ee [Automation.inString label]
getOnSetFocus :: Automation.IDispatch a -> Prelude.IO (Prelude.String)
getOnSetFocus =
  Automation.propertyGetID 0x3f5 [] Automation.outString
setOnSetFocus :: Prelude.String -> Automation.IDispatch a -> Prelude.IO ()
setOnSetFocus onSetFocus =
  Automation.propertySetID 0x3f5 [Automation.inString onSetFocus]
getOnKillFocus :: Automation.IDispatch a -> Prelude.IO (Prelude.String)
getOnKillFocus =
  Automation.propertyGetID 0x3f6 [] Automation.outString
setOnKillFocus :: Prelude.String -> Automation.IDispatch a -> Prelude.IO ()
setOnKillFocus onKillFocus =
  Automation.propertySetID 0x3f6 [Automation.inString onKillFocus]
-- --------------------------------------------------
-- 
-- interface PPPushButton
-- 
-- --------------------------------------------------
data PPPushButton a = PPPushButton
                       
type IPPPushButton a = IPPControl (PPPushButton a)
iidIPPPushButton :: Com.IID (IPPPushButton Automation.Interface)
iidIPPPushButton =
  Com.mkIID "{914934A5-5A91-11CF-8700-00AA0060263B}"
click :: Automation.IDispatch a -> Prelude.IO ()
click = Automation.methodID0 0x7d1 []
getIsDefault :: (Automation.Variant a0) => Automation.IDispatch a -> Prelude.IO (a0)
getIsDefault =
  Automation.propertyGetID 0x7d2 [] Automation.outVariant
setIsDefault :: (Automation.Variant a0) => a0 -> Automation.IDispatch a -> Prelude.IO ()
setIsDefault isDefault =
  Automation.propertySetID 0x7d2 [Automation.inVariant isDefault]
getIsEscape :: (Automation.Variant a0) => Automation.IDispatch a -> Prelude.IO (a0)
getIsEscape =
  Automation.propertyGetID 0x7d3 [] Automation.outVariant
setIsEscape :: (Automation.Variant a0) => a0 -> Automation.IDispatch a -> Prelude.IO ()
setIsEscape isEscape =
  Automation.propertySetID 0x7d3 [Automation.inVariant isEscape]
getOnPressed :: Automation.IDispatch a -> Prelude.IO (Prelude.String)
getOnPressed =
  Automation.propertyGetID 0x7d4 [] Automation.outString
setOnPressed :: Prelude.String -> Automation.IDispatch a -> Prelude.IO ()
setOnPressed onPressed =
  Automation.propertySetID 0x7d4 [Automation.inString onPressed]
-- --------------------------------------------------
-- 
-- interface PPToggleButton
-- 
-- --------------------------------------------------
data PPToggleButton a = PPToggleButton
                         
type IPPToggleButton a = IPPControl (PPToggleButton a)
iidIPPToggleButton :: Com.IID (IPPToggleButton Automation.Interface)
iidIPPToggleButton =
  Com.mkIID "{914934A6-5A91-11CF-8700-00AA0060263B}"
getState0 :: (Automation.Variant a0) => Automation.IDispatch a -> Prelude.IO (a0)
getState0 = Automation.propertyGetID 0x7d1 [] Automation.outVariant
setState0 :: (Automation.Variant a0) => a0 -> Automation.IDispatch a -> Prelude.IO ()
setState0 state =
  Automation.propertySetID 0x7d1 [Automation.inVariant state]
getResourceID :: Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getResourceID = Automation.propertyGetID 0x7d2 [] Automation.outInt
setResourceID :: Prelude.Int -> Automation.IDispatch a -> Prelude.IO ()
setResourceID resourceID =
  Automation.propertySetID 0x7d2 [Automation.inInt resourceID]
getOnClick :: Automation.IDispatch a -> Prelude.IO (Prelude.String)
getOnClick = Automation.propertyGetID 0x7d4 [] Automation.outString
setOnClick :: Prelude.String -> Automation.IDispatch a -> Prelude.IO ()
setOnClick onClick =
  Automation.propertySetID 0x7d4 [Automation.inString onClick]
-- --------------------------------------------------
-- 
-- interface PPBitmapButton
-- 
-- --------------------------------------------------
data PPBitmapButton a = PPBitmapButton
                         
type IPPBitmapButton a = IPPControl (PPBitmapButton a)
iidIPPBitmapButton :: Com.IID (IPPBitmapButton Automation.Interface)
iidIPPBitmapButton =
  Com.mkIID "{914934A7-5A91-11CF-8700-00AA0060263B}"
-- --------------------------------------------------
-- 
-- interface PPListBox
-- 
-- --------------------------------------------------
data PPListBox a = PPListBox
                    
type IPPListBox a = IPPControl (PPListBox a)
iidIPPListBox :: Com.IID (IPPListBox Automation.Interface)
iidIPPListBox = Com.mkIID "{914934A8-5A91-11CF-8700-00AA0060263B}"
getStrings :: Automation.IDispatch a -> Prelude.IO (IPPStrings Automation.Interface)
getStrings =
  Automation.propertyGetID 0x7d1 [] Automation.outIDispatch
getSelectionStyle :: (Automation.Variant a0) => IPPListBox a -> Prelude.IO (a0)
getSelectionStyle =
  Automation.propertyGetID 0x7d2 [] Automation.outVariant
setSelectionStyle :: (Automation.Variant a0) => a0 -> IPPListBox a -> Prelude.IO ()
setSelectionStyle selectionStyle =
  Automation.propertySetID 0x7d2 [Automation.inVariant selectionStyle]
setTabStops :: Prelude.Int -> IPPListBox a -> Prelude.IO ()
setTabStops safeArrayTabStops =
  Automation.methodID0 0x7d3 [Automation.inInt safeArrayTabStops]
getFocusItem :: Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getFocusItem = Automation.propertyGetID 0x7d4 [] Automation.outInt
setFocusItem :: Prelude.Int -> Automation.IDispatch a -> Prelude.IO ()
setFocusItem focusItem =
  Automation.propertySetID 0x7d4 [Automation.inInt focusItem]
getTopItem :: IPPListBox a -> Prelude.IO (Prelude.Int)
getTopItem = Automation.propertyGetID 0x7d5 [] Automation.outInt
getOnSelectionChange :: Automation.IDispatch a -> Prelude.IO (Prelude.String)
getOnSelectionChange =
  Automation.propertyGetID 0x7d6 [] Automation.outString
setOnSelectionChange :: Prelude.String -> Automation.IDispatch a -> Prelude.IO ()
setOnSelectionChange onSelectionChange =
  Automation.propertySetID 0x7d6 [Automation.inString onSelectionChange]
getOnDoubleClick :: Automation.IDispatch a -> Prelude.IO (Prelude.String)
getOnDoubleClick =
  Automation.propertyGetID 0x7d7 [] Automation.outString
setOnDoubleClick :: Prelude.String -> Automation.IDispatch a -> Prelude.IO ()
setOnDoubleClick onDoubleClick =
  Automation.propertySetID 0x7d7 [Automation.inString onDoubleClick]
getIsSelected :: (Automation.Variant a0) => Prelude.Int -> IPPListBox a -> Prelude.IO (a0)
getIsSelected index =
  Automation.propertyGetID 0x3e7 [Automation.inInt index] Automation.outVariant
setIsSelected :: (Automation.Variant a0) => Prelude.Int -> a0 -> IPPListBox a -> Prelude.IO ()
setIsSelected index isSelected =
  Automation.propertySetID 0x3e7 [Automation.inInt index, Automation.inVariant isSelected]
abbreviate :: (Automation.Variant a0) => a0 -> IPPListBox a -> Prelude.IO ()
abbreviate style =
  Automation.methodID0 0x7d8 [Automation.inVariant style]
getIsAbbreviated :: (Automation.Variant a0) => IPPListBox a -> Prelude.IO (a0)
getIsAbbreviated =
  Automation.propertyGetID 0x7d9 [] Automation.outVariant
-- --------------------------------------------------
-- 
-- interface PPStrings
-- 
-- --------------------------------------------------
data PPStrings a = PPStrings
                    
type IPPStrings a = ICollection (PPStrings a)
iidIPPStrings :: Com.IID (IPPStrings Automation.Interface)
iidIPPStrings = Com.mkIID "{914934A9-5A91-11CF-8700-00AA0060263B}"
add8 :: Prelude.String -> IPPStrings a -> Prelude.IO (Prelude.String)
add8 string =
  Automation.functionID1 0x7d1 [Automation.inString string] Automation.outString
insert0 :: Prelude.String -> Prelude.Int -> IPPStrings a -> Prelude.IO ()
insert0 string position =
  Automation.methodID0 0x7d2 [Automation.inString string, Automation.inInt position]
-- --------------------------------------------------
-- 
-- interface PPCheckBox
-- 
-- --------------------------------------------------
data PPCheckBox a = PPCheckBox
                     
type IPPCheckBox a = IPPControl (PPCheckBox a)
iidIPPCheckBox :: Com.IID (IPPCheckBox Automation.Interface)
iidIPPCheckBox = Com.mkIID "{914934AA-5A91-11CF-8700-00AA0060263B}"
-- --------------------------------------------------
-- 
-- interface PPRadioCluster
-- 
-- --------------------------------------------------
data PPRadioCluster a = PPRadioCluster
                         
type IPPRadioCluster a = IPPControl (PPRadioCluster a)
iidIPPRadioCluster :: Com.IID (IPPRadioCluster Automation.Interface)
iidIPPRadioCluster =
  Com.mkIID "{914934AB-5A91-11CF-8700-00AA0060263B}"
item26 :: Prelude.Int -> IPPRadioCluster a -> Prelude.IO (IPPRadioButton Automation.Interface)
item26 index =
  Automation.functionID1 0o0 [Automation.inInt index] Automation.outIDispatch
add9 :: Prelude.Float -> Prelude.Float -> Prelude.Float -> Prelude.Float -> IPPRadioCluster a -> Prelude.IO (IPPRadioButton Automation.Interface)
add9 left top width height =
  Automation.functionID1 0x7d1 [Automation.inFloat left, Automation.inFloat top, Automation.inFloat width, Automation.inFloat height] Automation.outIDispatch
getSelected :: IPPRadioCluster a -> Prelude.IO (IPPRadioButton Automation.Interface)
getSelected =
  Automation.propertyGetID 0x7d3 [] Automation.outIDispatch
-- --------------------------------------------------
-- 
-- interface PPStaticText
-- 
-- --------------------------------------------------
data PPStaticText a = PPStaticText
                       
type IPPStaticText a = IPPControl (PPStaticText a)
iidIPPStaticText :: Com.IID (IPPStaticText Automation.Interface)
iidIPPStaticText =
  Com.mkIID "{914934AC-5A91-11CF-8700-00AA0060263B}"
getUseForegroundColor :: (Automation.Variant a0) => IPPStaticText a -> Prelude.IO (a0)
getUseForegroundColor =
  Automation.propertyGetID 0x7d1 [] Automation.outVariant
setUseForegroundColor :: (Automation.Variant a0) => a0 -> IPPStaticText a -> Prelude.IO ()
setUseForegroundColor useForegroundColor =
  Automation.propertySetID 0x7d1 [Automation.inVariant useForegroundColor]
getUseBackgroundColor :: (Automation.Variant a0) => IPPStaticText a -> Prelude.IO (a0)
getUseBackgroundColor =
  Automation.propertyGetID 0x7d2 [] Automation.outVariant
setUseBackgroundColor :: (Automation.Variant a0) => a0 -> IPPStaticText a -> Prelude.IO ()
setUseBackgroundColor useBackgroundColor =
  Automation.propertySetID 0x7d2 [Automation.inVariant useBackgroundColor]
getForegroundColor :: IPPStaticText a -> Prelude.IO (Prelude.Int)
getForegroundColor =
  Automation.propertyGetID 0x7d3 [] Automation.outInt
setForegroundColor :: Prelude.Int -> IPPStaticText a -> Prelude.IO ()
setForegroundColor foregroundColor =
  Automation.propertySetID 0x7d3 [Automation.inInt foregroundColor]
getBackgroundColor :: IPPStaticText a -> Prelude.IO (Prelude.Int)
getBackgroundColor =
  Automation.propertyGetID 0x7d4 [] Automation.outInt
setBackgroundColor :: Prelude.Int -> IPPStaticText a -> Prelude.IO ()
setBackgroundColor backgroundColor =
  Automation.propertySetID 0x7d4 [Automation.inInt backgroundColor]
-- --------------------------------------------------
-- 
-- interface PPEditText
-- 
-- --------------------------------------------------
data PPEditText a = PPEditText
                     
type IPPEditText a = IPPControl (PPEditText a)
iidIPPEditText :: Com.IID (IPPEditText Automation.Interface)
iidIPPEditText = Com.mkIID "{914934AD-5A91-11CF-8700-00AA0060263B}"
getMultiLine :: (Automation.Variant a0) => IPPEditText a -> Prelude.IO (a0)
getMultiLine =
  Automation.propertyGetID 0x7d1 [] Automation.outVariant
setMultiLine :: (Automation.Variant a0) => a0 -> IPPEditText a -> Prelude.IO ()
setMultiLine multiLine =
  Automation.propertySetID 0x7d1 [Automation.inVariant multiLine]
getVerticalScrollBar :: (Automation.Variant a0) => IPPEditText a -> Prelude.IO (a0)
getVerticalScrollBar =
  Automation.propertyGetID 0x7d2 [] Automation.outVariant
setVerticalScrollBar :: (Automation.Variant a0) => a0 -> IPPEditText a -> Prelude.IO ()
setVerticalScrollBar verticalScrollBar =
  Automation.propertySetID 0x7d2 [Automation.inVariant verticalScrollBar]
setReadOnly :: (Automation.Variant a0) => a0 -> IPPEditText a -> Prelude.IO ()
setReadOnly readOnly =
  Automation.propertySetID 0x7d4 [Automation.inVariant readOnly]
getMaxLength :: IPPEditText a -> Prelude.IO (Prelude.Int)
getMaxLength = Automation.propertyGetID 0x7d6 [] Automation.outInt
setMaxLength :: Prelude.Int -> IPPEditText a -> Prelude.IO ()
setMaxLength maxLength =
  Automation.propertySetID 0x7d6 [Automation.inInt maxLength]
getOnAChange :: Automation.IDispatch a -> Prelude.IO (Prelude.String)
getOnAChange =
  Automation.propertyGetID 0x7d7 [] Automation.outString
setOnAChange :: Prelude.String -> Automation.IDispatch a -> Prelude.IO ()
setOnAChange onAChange =
  Automation.propertySetID 0x7d7 [Automation.inString onAChange]
-- --------------------------------------------------
-- 
-- interface PPIcon
-- 
-- --------------------------------------------------
data PPIcon a = PPIcon
                 
type IPPIcon a = IPPControl (PPIcon a)
iidIPPIcon :: Com.IID (IPPIcon Automation.Interface)
iidIPPIcon = Com.mkIID "{914934AE-5A91-11CF-8700-00AA0060263B}"
-- --------------------------------------------------
-- 
-- interface PPBitmap
-- 
-- --------------------------------------------------
data PPBitmap a = PPBitmap
                   
type IPPBitmap a = IPPControl (PPBitmap a)
iidIPPBitmap :: Com.IID (IPPBitmap Automation.Interface)
iidIPPBitmap = Com.mkIID "{914934AF-5A91-11CF-8700-00AA0060263B}"
-- --------------------------------------------------
-- 
-- interface PPSpinner
-- 
-- --------------------------------------------------
data PPSpinner a = PPSpinner
                    
type IPPSpinner a = IPPControl (PPSpinner a)
iidIPPSpinner :: Com.IID (IPPSpinner Automation.Interface)
iidIPPSpinner = Com.mkIID "{914934B0-5A91-11CF-8700-00AA0060263B}"
getMinimum :: Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getMinimum = Automation.propertyGetID 0x7d1 [] Automation.outInt
setMinimum :: Prelude.Int -> Automation.IDispatch a -> Prelude.IO ()
setMinimum minimum =
  Automation.propertySetID 0x7d1 [Automation.inInt minimum]
getMaximum :: Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getMaximum = Automation.propertyGetID 0x7d2 [] Automation.outInt
setMaximum :: Prelude.Int -> Automation.IDispatch a -> Prelude.IO ()
setMaximum maximum =
  Automation.propertySetID 0x7d2 [Automation.inInt maximum]
getIncrement :: Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getIncrement = Automation.propertyGetID 0x7d3 [] Automation.outInt
setIncrement :: Prelude.Int -> Automation.IDispatch a -> Prelude.IO ()
setIncrement increment =
  Automation.propertySetID 0x7d3 [Automation.inInt increment]
getPageChange :: Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getPageChange = Automation.propertyGetID 0x7d4 [] Automation.outInt
setPageChange :: Prelude.Int -> Automation.IDispatch a -> Prelude.IO ()
setPageChange pageChange =
  Automation.propertySetID 0x7d4 [Automation.inInt pageChange]
getCurrentValue :: Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getCurrentValue =
  Automation.propertyGetID 0x7d5 [] Automation.outInt
setCurrentValue :: Prelude.Int -> Automation.IDispatch a -> Prelude.IO ()
setCurrentValue currentValue =
  Automation.propertySetID 0x7d5 [Automation.inInt currentValue]
-- --------------------------------------------------
-- 
-- interface PPScrollBar
-- 
-- --------------------------------------------------
data PPScrollBar a = PPScrollBar
                      
type IPPScrollBar a = IPPControl (PPScrollBar a)
iidIPPScrollBar :: Com.IID (IPPScrollBar Automation.Interface)
iidIPPScrollBar =
  Com.mkIID "{914934B1-5A91-11CF-8700-00AA0060263B}"
getOnScroll :: IPPScrollBar a -> Prelude.IO (Prelude.String)
getOnScroll =
  Automation.propertyGetID 0x7d6 [] Automation.outString
setOnScroll :: Prelude.String -> IPPScrollBar a -> Prelude.IO ()
setOnScroll onScroll =
  Automation.propertySetID 0x7d6 [Automation.inString onScroll]
-- --------------------------------------------------
-- 
-- interface PPGroupBox
-- 
-- --------------------------------------------------
data PPGroupBox a = PPGroupBox
                     
type IPPGroupBox a = IPPControl (PPGroupBox a)
iidIPPGroupBox :: Com.IID (IPPGroupBox Automation.Interface)
iidIPPGroupBox = Com.mkIID "{914934B2-5A91-11CF-8700-00AA0060263B}"
-- --------------------------------------------------
-- 
-- interface PPFrame
-- 
-- --------------------------------------------------
data PPFrame a = PPFrame
                  
type IPPFrame a = IPPControl (PPFrame a)
iidIPPFrame :: Com.IID (IPPFrame Automation.Interface)
iidIPPFrame = Com.mkIID "{914934B3-5A91-11CF-8700-00AA0060263B}"
-- --------------------------------------------------
-- 
-- interface PPTabControl
-- 
-- --------------------------------------------------
data PPTabControl a = PPTabControl
                       
type IPPTabControl a = IPPControl (PPTabControl a)
iidIPPTabControl :: Com.IID (IPPTabControl Automation.Interface)
iidIPPTabControl =
  Com.mkIID "{914934B4-5A91-11CF-8700-00AA0060263B}"
-- --------------------------------------------------
-- 
-- interface PPDropDown
-- 
-- --------------------------------------------------
data PPDropDown a = PPDropDown
                     
type IPPDropDown a = IPPControl (PPDropDown a)
iidIPPDropDown :: Com.IID (IPPDropDown Automation.Interface)
iidIPPDropDown = Com.mkIID "{914934B5-5A91-11CF-8700-00AA0060263B}"
-- --------------------------------------------------
-- 
-- interface PPDropDownEdit
-- 
-- --------------------------------------------------
data PPDropDownEdit a = PPDropDownEdit
                         
type IPPDropDownEdit a = IPPControl (PPDropDownEdit a)
iidIPPDropDownEdit :: Com.IID (IPPDropDownEdit Automation.Interface)
iidIPPDropDownEdit =
  Com.mkIID "{914934B6-5A91-11CF-8700-00AA0060263B}"
getOnEdit :: IPPDropDownEdit a -> Prelude.IO (Prelude.String)
getOnEdit = Automation.propertyGetID 0x7d4 [] Automation.outString
setOnEdit :: Prelude.String -> IPPDropDownEdit a -> Prelude.IO ()
setOnEdit onEdit =
  Automation.propertySetID 0x7d4 [Automation.inString onEdit]
-- --------------------------------------------------
-- 
-- interface PPSlideMiniature
-- 
-- --------------------------------------------------
data PPSlideMiniature a = PPSlideMiniature
                           
type IPPSlideMiniature a = IPPControl (PPSlideMiniature a)
iidIPPSlideMiniature :: Com.IID (IPPSlideMiniature Automation.Interface)
iidIPPSlideMiniature =
  Com.mkIID "{914934B7-5A91-11CF-8700-00AA0060263B}"
setImage :: ISlide a0 -> IPPSlideMiniature a -> Prelude.IO ()
setImage slide =
  Automation.methodID0 0x7d1 [Automation.inIDispatch slide]
getSelected0 :: IPPSlideMiniature a -> Prelude.IO (Prelude.Int)
getSelected0 = Automation.propertyGetID 0x7d2 [] Automation.outInt
setSelected :: Prelude.Int -> IPPSlideMiniature a -> Prelude.IO ()
setSelected selected =
  Automation.propertySetID 0x7d2 [Automation.inInt selected]
-- --------------------------------------------------
-- 
-- interface PPRadioButton
-- 
-- --------------------------------------------------
data PPRadioButton a = PPRadioButton
                        
type IPPRadioButton a = IPPControl (PPRadioButton a)
iidIPPRadioButton :: Com.IID (IPPRadioButton Automation.Interface)
iidIPPRadioButton =
  Com.mkIID "{914934B8-5A91-11CF-8700-00AA0060263B}"
doubleClick :: IPPRadioButton a -> Prelude.IO ()
doubleClick = Automation.methodID0 0x7d3 []
-- --------------------------------------------------
-- 
-- interface Tags
-- 
-- --------------------------------------------------
data Tags a = Tags
               
type ITags a = ICollection (Tags a)
iidITags :: Com.IID (ITags Automation.Interface)
iidITags = Com.mkIID "{914934B9-5A91-11CF-8700-00AA0060263B}"
item27 :: Prelude.String -> ITags a -> Prelude.IO (Prelude.String)
item27 name =
  Automation.functionID1 0o0 [Automation.inString name] Automation.outString
add10 :: Prelude.String -> Prelude.String -> ITags a -> Prelude.IO ()
add10 name value =
  Automation.methodID0 0x7d3 [Automation.inString name, Automation.inString value]
delete11 :: Prelude.String -> Automation.IDispatch a -> Prelude.IO ()
delete11 name =
  Automation.methodID0 0x7d4 [Automation.inString name]
addBinary :: Prelude.String -> Prelude.String -> ITags a -> Prelude.IO ()
addBinary name filePath =
  Automation.methodID0 0x7d5 [Automation.inString name, Automation.inString filePath]
binaryValue :: Prelude.String -> ITags a -> Prelude.IO (Prelude.Int)
binaryValue name =
  Automation.functionID1 0x7d6 [Automation.inString name] Automation.outInt
name :: Prelude.Int -> ITags a -> Prelude.IO (Prelude.String)
name index =
  Automation.functionID1 0x7d7 [Automation.inInt index] Automation.outString
value :: Prelude.Int -> ITags a -> Prelude.IO (Prelude.String)
value index =
  Automation.functionID1 0x7d8 [Automation.inInt index] Automation.outString
-- --------------------------------------------------
-- 
-- interface FileDialogFileList
-- 
-- --------------------------------------------------
data FileDialogFileList a = FileDialogFileList
                             
type IFileDialogFileList a = ICollection (FileDialogFileList a)
iidIFileDialogFileList :: Com.IID (IFileDialogFileList Automation.Interface)
iidIFileDialogFileList =
  Com.mkIID "{914934BA-5A91-11CF-8700-00AA0060263B}"
displayName :: Prelude.Int -> IFileDialogFileList a -> Prelude.IO (Prelude.String)
displayName index =
  Automation.functionID1 0x7d3 [Automation.inInt index] Automation.outString
-- --------------------------------------------------
-- 
-- interface FileDialogExtension
-- 
-- --------------------------------------------------
data FileDialogExtension a = FileDialogExtension
                              
type IFileDialogExtension a = Automation.IDispatch (FileDialogExtension a)
iidIFileDialogExtension :: Com.IID (IFileDialogExtension Automation.Interface)
iidIFileDialogExtension =
  Com.mkIID "{914934BB-5A91-11CF-8700-00AA0060263B}"
getExtensions :: IFileDialogExtension a -> Prelude.IO (Prelude.String)
getExtensions =
  Automation.propertyGetID 0x7d3 [] Automation.outString
setExtensions :: Prelude.String -> IFileDialogExtension a -> Prelude.IO ()
setExtensions extensions =
  Automation.propertySetID 0x7d3 [Automation.inString extensions]
getDescription :: IFileDialogExtension a -> Prelude.IO (Prelude.String)
getDescription =
  Automation.propertyGetID 0x7d4 [] Automation.outString
setDescription :: Prelude.String -> IFileDialogExtension a -> Prelude.IO ()
setDescription description =
  Automation.propertySetID 0x7d4 [Automation.inString description]
-- --------------------------------------------------
-- 
-- interface FileDialogExtensionList
-- 
-- --------------------------------------------------
data FileDialogExtensionList a = FileDialogExtensionList
                                  
type IFileDialogExtensionList a = ICollection (FileDialogExtensionList a)
iidIFileDialogExtensionList :: Com.IID (IFileDialogExtensionList Automation.Interface)
iidIFileDialogExtensionList =
  Com.mkIID "{914934BC-5A91-11CF-8700-00AA0060263B}"
item29 :: Prelude.Int -> IFileDialogExtensionList a -> Prelude.IO (IFileDialogExtension Automation.Interface)
item29 index =
  Automation.functionID1 0o0 [Automation.inInt index] Automation.outIDispatch
add11 :: Prelude.String -> Prelude.String -> Automation.IDispatch a -> Prelude.IO (IFileDialogExtension Automation.Interface)
add11 extension description =
  Automation.functionID1 0x7d3 [Automation.inString extension, Automation.inString description] Automation.outIDispatch
-- --------------------------------------------------
-- 
-- interface FileDialog
-- 
-- --------------------------------------------------
data FileDialog a = FileDialog
                     
type IFileDialog a = Automation.IDispatch (FileDialog a)
iidIFileDialog :: Com.IID (IFileDialog Automation.Interface)
iidIFileDialog = Com.mkIID "{914934BD-5A91-11CF-8700-00AA0060263B}"
getExtensions0 :: IFileDialog a -> Prelude.IO (IFileDialogExtensionList Automation.Interface)
getExtensions0 =
  Automation.propertyGetID 0x7d3 [] Automation.outIDispatch
getDefaultDirectoryRegKey :: IFileDialog a -> Prelude.IO (Prelude.String)
getDefaultDirectoryRegKey =
  Automation.propertyGetID 0x7d4 [] Automation.outString
setDefaultDirectoryRegKey :: Prelude.String -> IFileDialog a -> Prelude.IO ()
setDefaultDirectoryRegKey defaultDirectoryRegKey =
  Automation.propertySetID 0x7d4 [Automation.inString defaultDirectoryRegKey]
getDialogTitle :: IFileDialog a -> Prelude.IO (Prelude.String)
getDialogTitle =
  Automation.propertyGetID 0x7d5 [] Automation.outString
setDialogTitle :: Prelude.String -> IFileDialog a -> Prelude.IO ()
setDialogTitle dialogTitle =
  Automation.propertySetID 0x7d5 [Automation.inString dialogTitle]
getActionButtonName :: IFileDialog a -> Prelude.IO (Prelude.String)
getActionButtonName =
  Automation.propertyGetID 0x7d6 [] Automation.outString
setActionButtonName :: Prelude.String -> IFileDialog a -> Prelude.IO ()
setActionButtonName actionButtonName =
  Automation.propertySetID 0x7d6 [Automation.inString actionButtonName]
getIsMultiSelect :: (Automation.Variant a0) => IFileDialog a -> Prelude.IO (a0)
getIsMultiSelect =
  Automation.propertyGetID 0x7d7 [] Automation.outVariant
setIsMultiSelect :: (Automation.Variant a0) => a0 -> IFileDialog a -> Prelude.IO ()
setIsMultiSelect isMultiSelect =
  Automation.propertySetID 0x7d7 [Automation.inVariant isMultiSelect]
getIsPrintEnabled :: (Automation.Variant a0) => IFileDialog a -> Prelude.IO (a0)
getIsPrintEnabled =
  Automation.propertyGetID 0x7d8 [] Automation.outVariant
setIsPrintEnabled :: (Automation.Variant a0) => a0 -> IFileDialog a -> Prelude.IO ()
setIsPrintEnabled isPrintEnabled =
  Automation.propertySetID 0x7d8 [Automation.inVariant isPrintEnabled]
getIsReadOnlyEnabled :: (Automation.Variant a0) => IFileDialog a -> Prelude.IO (a0)
getIsReadOnlyEnabled =
  Automation.propertyGetID 0x7d9 [] Automation.outVariant
setIsReadOnlyEnabled :: (Automation.Variant a0) => a0 -> IFileDialog a -> Prelude.IO ()
setIsReadOnlyEnabled isReadOnlyEnabled =
  Automation.propertySetID 0x7d9 [Automation.inVariant isReadOnlyEnabled]
getDirectoriesOnly :: (Automation.Variant a0) => IFileDialog a -> Prelude.IO (a0)
getDirectoriesOnly =
  Automation.propertyGetID 0x7da [] Automation.outVariant
setDirectoriesOnly :: (Automation.Variant a0) => a0 -> IFileDialog a -> Prelude.IO ()
setDirectoriesOnly directoriesOnly =
  Automation.propertySetID 0x7da [Automation.inVariant directoriesOnly]
getInitialView :: (Automation.Variant a0) => IFileDialog a -> Prelude.IO (a0)
getInitialView =
  Automation.propertyGetID 0x7db [] Automation.outVariant
setInitialView :: (Automation.Variant a0) => a0 -> IFileDialog a -> Prelude.IO ()
setInitialView initialView =
  Automation.propertySetID 0x7db [Automation.inVariant initialView]
launch :: Com.IUnknown a0 -> IFileDialog a -> Prelude.IO ()
launch pUnk =
  Automation.methodID0 0x7dc [Automation.inIUnknown pUnk]
getOnAction :: IFileDialog a -> Prelude.IO (Prelude.String)
getOnAction =
  Automation.propertyGetID 0x7dd [] Automation.outString
setOnAction :: Prelude.String -> IFileDialog a -> Prelude.IO ()
setOnAction onAction =
  Automation.propertySetID 0x7dd [Automation.inString onAction]
getFiles :: IFileDialog a -> Prelude.IO (IFileDialogFileList Automation.Interface)
getFiles =
  Automation.propertyGetID 0x7de [] Automation.outIDispatch
getUseODMADlgs :: (Automation.Variant a0) => IFileDialog a -> Prelude.IO (a0)
getUseODMADlgs =
  Automation.propertyGetID 0x7df [] Automation.outVariant
setUseODMADlgs :: (Automation.Variant a0) => a0 -> IFileDialog a -> Prelude.IO ()
setUseODMADlgs useODMADlgs =
  Automation.propertySetID 0x7df [Automation.inVariant useODMADlgs]
-- --------------------------------------------------
-- 
-- interface MouseTracker
-- 
-- --------------------------------------------------
{-
onTrack :: Int.Float -> Int.Float -> Prelude.IO ()
onTrack x y =
  do
    o_onTrack <- primonTrack x y
    Com.okHRESULT o_onTrack
    Prelude.return ()
endTrack :: Int.Float -> Int.Float -> Prelude.IO ()
endTrack x y =
  do
    o_endTrack <- primendTrack x y
    Com.okHRESULT o_endTrack
    Prelude.return ()
-}
-- --------------------------------------------------
-- 
-- interface MouseDownHandler
-- 
-- --------------------------------------------------
{-
onMouseDown :: Prelude.Maybe (Com.Interface Stdole32.IUnknown) -> Prelude.IO ()
onMouseDown activeWin =
  do
    activeWin <- Com.marshallunique_iptr activeWin
    o_onMouseDown <- primonMouseDown activeWin
    Int.free activeWin
    Com.okHRESULT o_onMouseDown
    Prelude.return ()
-}
-- --------------------------------------------------
-- 
-- interface OCXExtender
-- 
-- --------------------------------------------------
data OCXExtender a = OCXExtender
                      
type IOCXExtender a = Automation.IDispatch (OCXExtender a)
iidIOCXExtender :: Com.IID (IOCXExtender Automation.Interface)
iidIOCXExtender =
  Com.mkIID "{914934C0-5A91-11CF-8700-00AA0060263B}"
getVisible30 :: IOCXExtender a -> Prelude.IO (Prelude.Int)
getVisible30 =
  Automation.propertyGetID 0x80010007 [] Automation.outInt
setVisible30 :: Prelude.Int -> IOCXExtender a -> Prelude.IO ()
setVisible30 visible =
  Automation.propertySetID 0x80010007 [Automation.inInt visible]
-- --------------------------------------------------
-- 
-- interface OCXExtenderEvents
-- 
-- --------------------------------------------------
data OCXExtenderEvents a = OCXExtenderEvents
                            
type IOCXExtenderEvents a = Automation.IDispatch (OCXExtenderEvents a)
iidIOCXExtenderEvents :: Com.IID (IOCXExtenderEvents Automation.Interface)
iidIOCXExtenderEvents =
  Com.mkIID "{914934C1-5A91-11CF-8700-00AA0060263B}"
gotFocus :: IOCXExtenderEvents a -> Prelude.IO ()
gotFocus = Automation.method0 "GotFocus" []
lostFocus :: IOCXExtenderEvents a -> Prelude.IO ()
lostFocus = Automation.method0 "LostFocus" []
-- --------------------------------------------------
-- 
-- coclass OLEControl
-- 
-- --------------------------------------------------
clsidOLEControl :: Com.CLSID
clsidOLEControl =
  Com.mkCLSID "{91493446-5A91-11CF-8700-00AA0060263B}"


