module Visio where

import qualified Prelude
import qualified Array ( Array )
import qualified Automation (IDispatch, Interface, outIDispatch, 
                             propertyGetID, outInt, inInt, propertySetID, methodID0, outString, 
                             inIDispatch, inString, functionID1, outDouble, {- outArray, -}
                             methodID1, inDouble, inIUnknown, {-inArray,-} functionID2, methodID4, 
                             outIUnknown, methodID2, methodID6, Variant, outAddr, inVariant, 
                             inChar, outVariant, methodID3)
import qualified Com (Interface, IID, mkIID, IUnknown, CLSID, 
                      mkCLSID, okHRESULT, readiptr, Addr)
import qualified Int ( Int16 )
{-
import qualified HDirect (Int16, Int32, Addr, sizeofAddr, 
                          allocOutPointer, sizeofInt32, unmarshallref, trivialFree, 
                          doThenFree, readInt32)
-}

type LPVISIOAPPLICATION = IVApplication Automation.Interface
type LPVISIOCELL = IVCell Automation.Interface
type LPVISIOCHARS = IVCharacters Automation.Interface
type LPVISIOCONNECT = IVConnect Automation.Interface
type LPVISIOCONNECTS = IVConnects Automation.Interface
type LPVISIODOCUMENT = IVDocument Automation.Interface
type LPVISIODOCUMENTS = IVDocuments Automation.Interface
type LPVISIOMASTER = IVMaster Automation.Interface
type LPVISIOMASTERS = IVMasters Automation.Interface
type LPVISIOPAGE = IVPage Automation.Interface
type LPVISIOPAGES = IVPages Automation.Interface
type LPVISIOSELECTION = IVSelection Automation.Interface
type LPVISIOSHAPE = IVShape Automation.Interface
type LPVISIOSHAPES = IVShapes Automation.Interface
type LPVISIOSTYLE = IVStyle Automation.Interface
type LPVISIOSTYLES = IVStyles Automation.Interface
type LPVISIOWINDOW = IVWindow Automation.Interface
type LPVISIOWINDOWS = IVWindows Automation.Interface
type LPVISIOLAYER = IVLayer Automation.Interface
type LPVISIOLAYERS = IVLayers Automation.Interface
type LPVISIOFONT = IVFont Automation.Interface
type LPVISIOFONTS = IVFonts Automation.Interface
type LPVISIOCOLOR = IVColor Automation.Interface
type LPVISIOCOLORS = IVColors Automation.Interface
type LPVISIOADDON = IVAddon Automation.Interface
type LPVISIOADDONS = IVAddons Automation.Interface
type LPVISIOEVENT = IVEvent Automation.Interface
type LPVISIOEVENTS = IVEventList Automation.Interface
type LPVISIOMENUITEM = IVMenuItem Automation.Interface
type LPVISIOMENUITEMS = IVMenuItems Automation.Interface
type LPVISIOMENU = IVMenu Automation.Interface
type LPVISIOMENUS = IVMenus Automation.Interface
type LPVISIOMENUSET = IVMenuSet Automation.Interface
type LPVISIOMENUSETS = IVMenuSets Automation.Interface
type LPVISIOTOOLBARITEM = IVToolbarItem Automation.Interface
type LPVISIOTOOLBARITEMS = IVToolbarItems Automation.Interface
type LPVISIOTOOLBAR = IVToolbar Automation.Interface
type LPVISIOTOOLBARS = IVToolbars Automation.Interface
type LPVISIOTOOLBARSET = IVToolbarSet Automation.Interface
type LPVISIOTOOLBARSETS = IVToolbarSets Automation.Interface
type LPVISIOSTATUSBARITEM = IVStatusBarItem Automation.Interface
type LPVISIOSTATUSBARITEMS = IVStatusBarItems Automation.Interface
type LPVISIOSTATUSBAR = IVStatusBar Automation.Interface
type LPVISIOSTATUSBARS = IVStatusBars Automation.Interface
type LPVISIOACCELITEM = IVAccelItem Automation.Interface
type LPVISIOACCELITEMS = IVAccelItems Automation.Interface
type LPVISIOACCELTABLE = IVAccelTable Automation.Interface
type LPVISIOACCELTABLES = IVAccelTables Automation.Interface
type LPVISIOUIOBJECT = IVUIObject Automation.Interface
--type LPVISIOENUMVMENUITEM = IEnumVMenuItem Automation.Interface
--type LPVISIOENUMVMENU = IEnumVMenu Automation.Interface
--type LPVISIOENUMVMENUSET = IEnumVMenuSet Automation.Interface
--type LPVISIOENUMVTOOLBARITEM = IEnumVToolbarItem Automation.Interface
--type LPVISIOENUMVTOOLBAR = IEnumVToolbar Automation.Interface
--type LPVISIOENUMVTOOLBARSET = IEnumVToolbarSet Automation.Interface
--type LPVISIOENUMVSTATUSBARITEM = IEnumVStatusBarItem Automation.Interface
--type LPVISIOENUMVSTATUSBAR = IEnumVStatusBar Automation.Interface
--type LPVISIOENUMVACCELITEM = IEnumVAccelItem Automation.Interface
--type LPVISIOENUMVACCELTABLE = IEnumVAccelTable Automation.Interface
data VisUnitCodes
 = VisNumber
 | VisDate
 | VisDurationUnits
 | VisElapsedWeek
 | VisElapsedDay
 | VisElapsedHour
 | VisElapsedMin
 | VisElapsedSec
 | VisTypeUnits
 | VisPoints
 | VisPicas
 | VisDidots
 | VisCiceros
 | VisPageUnits
 | VisDrawingUnits
 | VisInches
 | VisFeet
 | VisFeetAndInches
 | VisMiles
 | VisCentimeters
 | VisMillimeters
 | VisMeters
 | VisKilometers
 | VisInchFrac
 | VisMileFrac
 | VisYards
 | VisNautMiles
 | VisAngleUnits
 | VisDegrees
 | VisDegreeMinSec
 | VisRadians
 | VisMin
 | VisSec
 | VisCurrency
 | VisNoCast
 
marshallVisUnitCodes :: VisUnitCodes -> Prelude.IO Int.Int16
marshallVisUnitCodes v =
  case v of
     VisNumber -> Prelude.return (32)
     VisDate -> Prelude.return (40)
     VisDurationUnits -> Prelude.return (42)
     VisElapsedWeek -> Prelude.return (43)
     VisElapsedDay -> Prelude.return (44)
     VisElapsedHour -> Prelude.return (45)
     VisElapsedMin -> Prelude.return (46)
     VisElapsedSec -> Prelude.return (47)
     VisTypeUnits -> Prelude.return (48)
     VisPoints -> Prelude.return (50)
     VisPicas -> Prelude.return (51)
     VisDidots -> Prelude.return (53)
     VisCiceros -> Prelude.return (54)
     VisPageUnits -> Prelude.return (63)
     VisDrawingUnits -> Prelude.return (64)
     VisInches -> Prelude.return (65)
     VisFeet -> Prelude.return (66)
     VisFeetAndInches -> Prelude.return (67)
     VisMiles -> Prelude.return (68)
     VisCentimeters -> Prelude.return (69)
     VisMillimeters -> Prelude.return (70)
     VisMeters -> Prelude.return (71)
     VisKilometers -> Prelude.return (72)
     VisInchFrac -> Prelude.return (73)
     VisMileFrac -> Prelude.return (74)
     VisYards -> Prelude.return (75)
     VisNautMiles -> Prelude.return (76)
     VisAngleUnits -> Prelude.return (80)
     VisDegrees -> Prelude.return (81)
     VisDegreeMinSec -> Prelude.return (82)
     VisRadians -> Prelude.return (83)
     VisMin -> Prelude.return (84)
     VisSec -> Prelude.return (85)
     VisCurrency -> Prelude.return (111)
     VisNoCast -> Prelude.return (252)
unmarshallVisUnitCodes :: Int.Int16 -> Prelude.IO VisUnitCodes
unmarshallVisUnitCodes v =
  case v of
     32 -> Prelude.return (VisNumber)
     40 -> Prelude.return (VisDate)
     42 -> Prelude.return (VisDurationUnits)
     43 -> Prelude.return (VisElapsedWeek)
     44 -> Prelude.return (VisElapsedDay)
     45 -> Prelude.return (VisElapsedHour)
     46 -> Prelude.return (VisElapsedMin)
     47 -> Prelude.return (VisElapsedSec)
     48 -> Prelude.return (VisTypeUnits)
     50 -> Prelude.return (VisPoints)
     51 -> Prelude.return (VisPicas)
     53 -> Prelude.return (VisDidots)
     54 -> Prelude.return (VisCiceros)
     63 -> Prelude.return (VisPageUnits)
     64 -> Prelude.return (VisDrawingUnits)
     65 -> Prelude.return (VisInches)
     66 -> Prelude.return (VisFeet)
     67 -> Prelude.return (VisFeetAndInches)
     68 -> Prelude.return (VisMiles)
     69 -> Prelude.return (VisCentimeters)
     70 -> Prelude.return (VisMillimeters)
     71 -> Prelude.return (VisMeters)
     72 -> Prelude.return (VisKilometers)
     73 -> Prelude.return (VisInchFrac)
     74 -> Prelude.return (VisMileFrac)
     75 -> Prelude.return (VisYards)
     76 -> Prelude.return (VisNautMiles)
     80 -> Prelude.return (VisAngleUnits)
     81 -> Prelude.return (VisDegrees)
     82 -> Prelude.return (VisDegreeMinSec)
     83 -> Prelude.return (VisRadians)
     84 -> Prelude.return (VisMin)
     85 -> Prelude.return (VisSec)
     111 -> Prelude.return (VisCurrency)
     252 -> Prelude.return (VisNoCast)
     _ -> Prelude.fail (Prelude.userError "unmarshallVisUnitCodes: illegal enum value ")
data VisWinTypes
 = VisWinOther
 | VisDrawing
 | VisStencil
 | VisSheet
 | VisIcon
 | VisPageWin
 | VisPageGroupWin
 | VisMasterWin
 | VisMasterGroupWin
 
marshallVisWinTypes :: VisWinTypes -> Prelude.IO Int.Int16
marshallVisWinTypes v =
  case v of
     VisWinOther -> Prelude.return (0)
     VisDrawing -> Prelude.return (1)
     VisStencil -> Prelude.return (2)
     VisSheet -> Prelude.return (3)
     VisIcon -> Prelude.return (4)
     VisPageWin -> Prelude.return (128)
     VisPageGroupWin -> Prelude.return (160)
     VisMasterWin -> Prelude.return (64)
     VisMasterGroupWin -> Prelude.return (96)
unmarshallVisWinTypes :: Int.Int16 -> Prelude.IO VisWinTypes
unmarshallVisWinTypes v =
  case v of
     0 -> Prelude.return (VisWinOther)
     1 -> Prelude.return (VisDrawing)
     2 -> Prelude.return (VisStencil)
     3 -> Prelude.return (VisSheet)
     4 -> Prelude.return (VisIcon)
     128 -> Prelude.return (VisPageWin)
     160 -> Prelude.return (VisPageGroupWin)
     64 -> Prelude.return (VisMasterWin)
     96 -> Prelude.return (VisMasterGroupWin)
     _ -> Prelude.fail (Prelude.userError "unmarshallVisWinTypes: illegal enum value ")
data VisShapeTypes
 = VisTypePage
 | VisTypeGroup
 | VisTypeShape
 | VisTypeForeignObject
 | VisTypeGuide
 | VisTypeMetafile
 | VisTypeBitmap
 | VisTypeIsLinked
 | VisTypeIsEmbedded
 | VisTypeIsControl
 | VisTypeIsOLE2
 
marshallVisShapeTypes :: VisShapeTypes -> Prelude.IO Int.Int16
marshallVisShapeTypes v =
  case v of
     VisTypePage -> Prelude.return (1)
     VisTypeGroup -> Prelude.return (2)
     VisTypeShape -> Prelude.return (3)
     VisTypeForeignObject -> Prelude.return (4)
     VisTypeGuide -> Prelude.return (5)
     VisTypeMetafile -> Prelude.return (16)
     VisTypeBitmap -> Prelude.return (32)
     VisTypeIsLinked -> Prelude.return (256)
     VisTypeIsEmbedded -> Prelude.return (512)
     VisTypeIsControl -> Prelude.return (1024)
     VisTypeIsOLE2 -> Prelude.return (32768)
unmarshallVisShapeTypes :: Int.Int16 -> Prelude.IO VisShapeTypes
unmarshallVisShapeTypes v =
  case v of
     1 -> Prelude.return (VisTypePage)
     2 -> Prelude.return (VisTypeGroup)
     3 -> Prelude.return (VisTypeShape)
     4 -> Prelude.return (VisTypeForeignObject)
     5 -> Prelude.return (VisTypeGuide)
     16 -> Prelude.return (VisTypeMetafile)
     32 -> Prelude.return (VisTypeBitmap)
     256 -> Prelude.return (VisTypeIsLinked)
     512 -> Prelude.return (VisTypeIsEmbedded)
     1024 -> Prelude.return (VisTypeIsControl)
     32768 -> Prelude.return (VisTypeIsOLE2)
     _ -> Prelude.fail (Prelude.userError "unmarshallVisShapeTypes: illegal enum value ")
data VisShapeIDs
 = VisInvalShapeID
 | VisPageSheetID
 
marshallVisShapeIDs :: VisShapeIDs -> Prelude.IO Int.Int16
marshallVisShapeIDs v =
  case v of
     VisInvalShapeID -> Prelude.return ((-1))
     VisPageSheetID -> Prelude.return (0)
unmarshallVisShapeIDs :: Int.Int16 -> Prelude.IO VisShapeIDs
unmarshallVisShapeIDs v =
  case v of
     (-1) -> Prelude.return (VisInvalShapeID)
     0 -> Prelude.return (VisPageSheetID)
     _ -> Prelude.fail (Prelude.userError "unmarshallVisShapeIDs: illegal enum value ")
data VisSectionIndices
 = VisSectionInval
 | VisSectionFirst
 | VisSectionLast
 | VisSectionNone
 | VisSectionObject
 | VisSectionMember
 | VisSectionCharacter
 | VisSectionParagraph
 | VisSectionTab
 | VisSectionScratch
 | VisSectionExport
 | VisSectionConnectionPts
 | VisSectionTextField
 | VisSectionControls
 | VisSectionFirstComponent
 | VisSectionLastComponent
 | VisSectionAction
 | VisSectionLayer
 | VisSectionUser
 | VisSectionProp
 | VisSectionLastReal
 
marshallVisSectionIndices :: VisSectionIndices -> Prelude.IO Int.Int16
marshallVisSectionIndices v =
  case v of
     VisSectionInval -> Prelude.return (255)
     VisSectionFirst -> Prelude.return (0)
     VisSectionLast -> Prelude.return (252)
     VisSectionNone -> Prelude.return (255)
     VisSectionObject -> Prelude.return (1)
     VisSectionMember -> Prelude.return (2)
     VisSectionCharacter -> Prelude.return (3)
     VisSectionParagraph -> Prelude.return (4)
     VisSectionTab -> Prelude.return (5)
     VisSectionScratch -> Prelude.return (6)
     VisSectionExport -> Prelude.return (7)
     VisSectionConnectionPts -> Prelude.return (7)
     VisSectionTextField -> Prelude.return (8)
     VisSectionControls -> Prelude.return (9)
     VisSectionFirstComponent -> Prelude.return (10)
     VisSectionLastComponent -> Prelude.return (239)
     VisSectionAction -> Prelude.return (240)
     VisSectionLayer -> Prelude.return (241)
     VisSectionUser -> Prelude.return (242)
     VisSectionProp -> Prelude.return (243)
     VisSectionLastReal -> Prelude.return (243)
unmarshallVisSectionIndices :: Int.Int16 -> Prelude.IO VisSectionIndices
unmarshallVisSectionIndices v =
  case v of
     255 -> Prelude.return (VisSectionInval)
     0 -> Prelude.return (VisSectionFirst)
     252 -> Prelude.return (VisSectionLast)
     255 -> Prelude.return (VisSectionNone)
     1 -> Prelude.return (VisSectionObject)
     2 -> Prelude.return (VisSectionMember)
     3 -> Prelude.return (VisSectionCharacter)
     4 -> Prelude.return (VisSectionParagraph)
     5 -> Prelude.return (VisSectionTab)
     6 -> Prelude.return (VisSectionScratch)
     7 -> Prelude.return (VisSectionExport)
     7 -> Prelude.return (VisSectionConnectionPts)
     8 -> Prelude.return (VisSectionTextField)
     9 -> Prelude.return (VisSectionControls)
     10 -> Prelude.return (VisSectionFirstComponent)
     239 -> Prelude.return (VisSectionLastComponent)
     240 -> Prelude.return (VisSectionAction)
     241 -> Prelude.return (VisSectionLayer)
     242 -> Prelude.return (VisSectionUser)
     243 -> Prelude.return (VisSectionProp)
     243 -> Prelude.return (VisSectionLastReal)
     _ -> Prelude.fail (Prelude.userError "unmarshallVisSectionIndices: illegal enum value ")
data VisRowIndices
 = VisRowFirst
 | VisRowLast
 | VisRowNone
 | VisRowXFormOut
 | VisRowXFormIn
 | VisRowLine
 | VisRowFill
 | VisRowXForm1D
 | VisRowEvent
 | VisRowLayerMem
 | VisRowGuide
 | VisRowStyle
 | VisRowForeign
 | VisRowPage
 | VisRowText
 | VisRowTextXForm
 | VisRowAlign
 | VisRowLock
 | VisRowData123
 | VisRowMisc
 | VisRowRulerGrid
 | VisRowHyperlink
 | VisRowComponent
 | VisRowVertex
 | VisRowMember
 | VisRowCharacter
 | VisRowParagraph
 | VisRowTab
 | VisRowScratch
 | VisRowExport
 | VisRowConnectionPts
 | VisRowField
 | VisRowControl
 | VisRowAction
 | VisRowLayer
 | VisRowUser
 | VisRowProp
 | VisRowFormat
 
marshallVisRowIndices :: VisRowIndices -> Prelude.IO Int.Int16
marshallVisRowIndices v =
  case v of
     VisRowFirst -> Prelude.return (0)
     VisRowLast -> Prelude.return ((-2))
     VisRowNone -> Prelude.return ((-1))
     VisRowXFormOut -> Prelude.return (1)
     VisRowXFormIn -> Prelude.return (1)
     VisRowLine -> Prelude.return (2)
     VisRowFill -> Prelude.return (3)
     VisRowXForm1D -> Prelude.return (4)
     VisRowEvent -> Prelude.return (5)
     VisRowLayerMem -> Prelude.return (6)
     VisRowGuide -> Prelude.return (7)
     VisRowStyle -> Prelude.return (8)
     VisRowForeign -> Prelude.return (9)
     VisRowPage -> Prelude.return (10)
     VisRowText -> Prelude.return (11)
     VisRowTextXForm -> Prelude.return (12)
     VisRowAlign -> Prelude.return (14)
     VisRowLock -> Prelude.return (15)
     VisRowData123 -> Prelude.return (16)
     VisRowMisc -> Prelude.return (17)
     VisRowRulerGrid -> Prelude.return (18)
     VisRowHyperlink -> Prelude.return (19)
     VisRowComponent -> Prelude.return (0)
     VisRowVertex -> Prelude.return (1)
     VisRowMember -> Prelude.return (0)
     VisRowCharacter -> Prelude.return (0)
     VisRowParagraph -> Prelude.return (0)
     VisRowTab -> Prelude.return (0)
     VisRowScratch -> Prelude.return (0)
     VisRowExport -> Prelude.return (0)
     VisRowConnectionPts -> Prelude.return (0)
     VisRowField -> Prelude.return (0)
     VisRowControl -> Prelude.return (0)
     VisRowAction -> Prelude.return (0)
     VisRowLayer -> Prelude.return (0)
     VisRowUser -> Prelude.return (0)
     VisRowProp -> Prelude.return (0)
     VisRowFormat -> Prelude.return (0)
unmarshallVisRowIndices :: Int.Int16 -> Prelude.IO VisRowIndices
unmarshallVisRowIndices v =
  case v of
     0 -> Prelude.return (VisRowFirst)
     (-2) -> Prelude.return (VisRowLast)
     (-1) -> Prelude.return (VisRowNone)
     1 -> Prelude.return (VisRowXFormOut)
     1 -> Prelude.return (VisRowXFormIn)
     2 -> Prelude.return (VisRowLine)
     3 -> Prelude.return (VisRowFill)
     4 -> Prelude.return (VisRowXForm1D)
     5 -> Prelude.return (VisRowEvent)
     6 -> Prelude.return (VisRowLayerMem)
     7 -> Prelude.return (VisRowGuide)
     8 -> Prelude.return (VisRowStyle)
     9 -> Prelude.return (VisRowForeign)
     10 -> Prelude.return (VisRowPage)
     11 -> Prelude.return (VisRowText)
     12 -> Prelude.return (VisRowTextXForm)
     14 -> Prelude.return (VisRowAlign)
     15 -> Prelude.return (VisRowLock)
     16 -> Prelude.return (VisRowData123)
     17 -> Prelude.return (VisRowMisc)
     18 -> Prelude.return (VisRowRulerGrid)
     19 -> Prelude.return (VisRowHyperlink)
     0 -> Prelude.return (VisRowComponent)
     1 -> Prelude.return (VisRowVertex)
     0 -> Prelude.return (VisRowMember)
     0 -> Prelude.return (VisRowCharacter)
     0 -> Prelude.return (VisRowParagraph)
     0 -> Prelude.return (VisRowTab)
     0 -> Prelude.return (VisRowScratch)
     0 -> Prelude.return (VisRowExport)
     0 -> Prelude.return (VisRowConnectionPts)
     0 -> Prelude.return (VisRowField)
     0 -> Prelude.return (VisRowControl)
     0 -> Prelude.return (VisRowAction)
     0 -> Prelude.return (VisRowLayer)
     0 -> Prelude.return (VisRowUser)
     0 -> Prelude.return (VisRowProp)
     0 -> Prelude.return (VisRowFormat)
     _ -> Prelude.fail (Prelude.userError "unmarshallVisRowIndices: illegal enum value ")
data VisRowTags
 = VisTagBase
 | VisTagRowVoid
 | VisTagInvalid
 | VisTagComponent
 | VisTagMoveTo
 | VisTagLineTo
 | VisTagArcTo
 | VisTagEllipticalArcTo
 | VisTagSplineBeg
 | VisTagSplineSpan
 | VisTagTab0
 | VisTagTab2
 | VisTagTab10
 | VisTagCtlPt
 | VisTagCtlPtTip
 | VisTagCnnctPt
 | VisTagCnnctNamed
 | VisTagCnnctPtABCD
 | VisTagCnnctNamedABCD
 
marshallVisRowTags :: VisRowTags -> Prelude.IO Int.Int16
marshallVisRowTags v =
  case v of
     VisTagBase -> Prelude.return (130)
     VisTagRowVoid -> Prelude.return (180)
     VisTagInvalid -> Prelude.return ((-1))
     VisTagComponent -> Prelude.return (137)
     VisTagMoveTo -> Prelude.return (138)
     VisTagLineTo -> Prelude.return (139)
     VisTagArcTo -> Prelude.return (140)
     VisTagEllipticalArcTo -> Prelude.return (144)
     VisTagSplineBeg -> Prelude.return (165)
     VisTagSplineSpan -> Prelude.return (166)
     VisTagTab0 -> Prelude.return (136)
     VisTagTab2 -> Prelude.return (150)
     VisTagTab10 -> Prelude.return (151)
     VisTagCtlPt -> Prelude.return (162)
     VisTagCtlPtTip -> Prelude.return (170)
     VisTagCnnctPt -> Prelude.return (153)
     VisTagCnnctNamed -> Prelude.return (185)
     VisTagCnnctPtABCD -> Prelude.return (186)
     VisTagCnnctNamedABCD -> Prelude.return (187)
unmarshallVisRowTags :: Int.Int16 -> Prelude.IO VisRowTags
unmarshallVisRowTags v =
  case v of
     130 -> Prelude.return (VisTagBase)
     180 -> Prelude.return (VisTagRowVoid)
     (-1) -> Prelude.return (VisTagInvalid)
     137 -> Prelude.return (VisTagComponent)
     138 -> Prelude.return (VisTagMoveTo)
     139 -> Prelude.return (VisTagLineTo)
     140 -> Prelude.return (VisTagArcTo)
     144 -> Prelude.return (VisTagEllipticalArcTo)
     165 -> Prelude.return (VisTagSplineBeg)
     166 -> Prelude.return (VisTagSplineSpan)
     136 -> Prelude.return (VisTagTab0)
     150 -> Prelude.return (VisTagTab2)
     151 -> Prelude.return (VisTagTab10)
     162 -> Prelude.return (VisTagCtlPt)
     170 -> Prelude.return (VisTagCtlPtTip)
     153 -> Prelude.return (VisTagCnnctPt)
     185 -> Prelude.return (VisTagCnnctNamed)
     186 -> Prelude.return (VisTagCnnctPtABCD)
     187 -> Prelude.return (VisTagCnnctNamedABCD)
     _ -> Prelude.fail (Prelude.userError "unmarshallVisRowTags: illegal enum value ")
data VisCellIndices
 = VisXFormPinX
 | VisXFormPinY
 | VisXFormWidth
 | VisXFormHeight
 | VisXFormLocPinX
 | VisXFormLocPinY
 | VisXFormAngle
 | VisXFormFlipX
 | VisXFormFlipY
 | VisXFormResizeMode
 | VisLineWeight
 | VisLineColor
 | VisLinePattern
 | VisLineRounding
 | VisLineArrowSize
 | VisLineBeginArrow
 | VisLineEndArrow
 | VisLineEndCap
 | VisFillForegnd
 | VisFillBkgnd
 | VisFillPattern
 | VisFillShdwForegnd
 | VisFillShdwBkgnd
 | VisFillShdwPattern
 | Vis1DBeginX
 | Vis1DBeginY
 | Vis1DEndX
 | Vis1DEndY
 | VisEvtCellTheData
 | VisEvtCellTheText
 | VisEvtCellDblClick
 | VisEvtCellXFMod
 | VisEvtCellDrop
 | VisLayerMember
 | VisGuideFlags
 | VisStyleIncludesLine
 | VisStyleIncludesFill
 | VisStyleIncludesText
 | VisFrgnImgOffsetX
 | VisFrgnImgOffsetY
 | VisFrgnImgWidth
 | VisFrgnImgHeight
 | VisPageWidth
 | VisPageHeight
 | VisPageShdwOffsetX
 | VisPageShdwOffsetY
 | VisPageScale
 | VisPageDrawingScale
 | VisPageDrawSizeType
 | VisPageDrawScaleType
 | VisTxtBlkLeftMargin
 | VisTxtBlkRightMargin
 | VisTxtBlkTopMargin
 | VisTxtBlkBottomMargin
 | VisTxtBlkVerticalAlign
 | VisTxtBlkBkgnd
 | VisAlignLeft
 | VisAlignCenter
 | VisAlignRight
 | VisAlignTop
 | VisAlignMiddle
 | VisAlignBottom
 | VisLockWidth
 | VisLockHeight
 | VisLockMoveX
 | VisLockMoveY
 | VisLockAspect
 | VisLockDelete
 | VisLockBegin
 | VisLockEnd
 | VisLockRotate
 | VisLockCrop
 | VisLockVtxEdit
 | VisLockTextEdit
 | VisLockFormat
 | VisLockGroup
 | VisLockCalcWH
 | VisLockSelect
 | VisObjHelp
 | VisCopyRight
 | VisNoObjHandles
 | VisNonPrinting
 | VisNoCtlHandles
 | VisNoAlignBox
 | VisUpdateAlignBox
 | VisHideText
 | VisDynFeedback
 | VisGlueType
 | VisWalkPref
 | VisBegTrigger
 | VisEndTrigger
 | VisLOFlags
 | VisLOInteraction
 | VisLOBehavior
 | VisXRulerDensity
 | VisYRulerDensity
 | VisXRulerOrigin
 | VisYRulerOrigin
 | VisXGridDensity
 | VisYGridDensity
 | VisXGridSpacing
 | VisYGridSpacing
 | VisXGridOrigin
 | VisYGridOrigin
 | VisHLinkDescription
 | VisHLinkAddress
 | VisHLinkSubAddress
 | VisHLinkExtraInfo
 | VisHLinkFrame
 | VisHLinkNewWin
 | VisCompNoFill
 | VisCompNoShow
 | VisX
 | VisY
 | VisBow
 | VisControlX
 | VisControlY
 | VisEccentricityAngle
 | VisAspectRatio
 | VisSplineKnot
 | VisSplineKnot2
 | VisSplineKnot3
 | VisSplineDegree
 | VisFieldCell
 | VisCharacterFont
 | VisCharacterColor
 | VisCharacterStyle
 | VisCharacterCase
 | VisCharacterPos
 | VisCharacterSize
 | VisIndentFirst
 | VisIndentLeft
 | VisIndentRight
 | VisSpaceLine
 | VisSpaceBefore
 | VisSpaceAfter
 | VisHorzAlign
 | VisTabStopCount
 | VisTabPos
 | VisTabAlign
 | VisScratchX
 | VisScratchY
 | VisScratchA
 | VisScratchB
 | VisScratchC
 | VisScratchD
 | VisCnnctA
 | VisCnnctB
 | VisCnnctC
 | VisCnnctD
 | VisCtlX
 | VisCtlY
 | VisCtlXDyn
 | VisCtlYDyn
 | VisCtlXCon
 | VisCtlYCon
 | VisCtlGlue
 | VisCtlType
 | VisCtlTip
 | VisActionMenu
 | VisActionPrompt
 | VisActionHelp
 | VisActionAction
 | VisActionChecked
 | VisActionDisabled
 | VisLayerName
 | VisLayerColor
 | VisLayerStatus
 | VisLayerVisible
 | VisLayerPrint
 | VisLayerActive
 | VisLayerLock
 | VisLayerSnap
 | VisLayerGlue
 | VisUserValue
 | VisUserPrompt
 | VisCustPropsValue
 | VisCustPropsPrompt
 | VisCustPropsLabel
 | VisCustPropsFormat
 | VisCustPropsSortKey
 | VisCustPropsType
 | VisCustPropsInvis
 | VisCustPropsAsk
 
marshallVisCellIndices :: VisCellIndices -> Prelude.IO Int.Int16
marshallVisCellIndices v =
  case v of
     VisXFormPinX -> Prelude.return (0)
     VisXFormPinY -> Prelude.return (1)
     VisXFormWidth -> Prelude.return (2)
     VisXFormHeight -> Prelude.return (3)
     VisXFormLocPinX -> Prelude.return (4)
     VisXFormLocPinY -> Prelude.return (5)
     VisXFormAngle -> Prelude.return (6)
     VisXFormFlipX -> Prelude.return (7)
     VisXFormFlipY -> Prelude.return (8)
     VisXFormResizeMode -> Prelude.return (9)
{-
     VisLineWeight -> Prelude.return (0)
     VisLineColor -> Prelude.return (1)
     VisLinePattern -> Prelude.return (2)
     VisLineRounding -> Prelude.return (3)
     VisLineArrowSize -> Prelude.return (4)
     VisLineBeginArrow -> Prelude.return (5)
     VisLineEndArrow -> Prelude.return (6)
     VisLineEndCap -> Prelude.return (7)
     VisFillForegnd -> Prelude.return (0)
     VisFillBkgnd -> Prelude.return (1)
     VisFillPattern -> Prelude.return (2)
     VisFillShdwForegnd -> Prelude.return (3)
     VisFillShdwBkgnd -> Prelude.return (4)
     VisFillShdwPattern -> Prelude.return (5)
     Vis1DBeginX -> Prelude.return (0)
     Vis1DBeginY -> Prelude.return (1)
     Vis1DEndX -> Prelude.return (2)
     Vis1DEndY -> Prelude.return (3)
     VisEvtCellTheData -> Prelude.return (0)
     VisEvtCellTheText -> Prelude.return (1)
     VisEvtCellDblClick -> Prelude.return (2)
     VisEvtCellXFMod -> Prelude.return (3)
     VisEvtCellDrop -> Prelude.return (4)
     VisLayerMember -> Prelude.return (0)
     VisGuideFlags -> Prelude.return (2)
     VisStyleIncludesLine -> Prelude.return (0)
     VisStyleIncludesFill -> Prelude.return (1)
     VisStyleIncludesText -> Prelude.return (2)
     VisFrgnImgOffsetX -> Prelude.return (0)
     VisFrgnImgOffsetY -> Prelude.return (1)
     VisFrgnImgWidth -> Prelude.return (2)
     VisFrgnImgHeight -> Prelude.return (3)
     VisPageWidth -> Prelude.return (0)
     VisPageHeight -> Prelude.return (1)
     VisPageShdwOffsetX -> Prelude.return (2)
     VisPageShdwOffsetY -> Prelude.return (3)
     VisPageScale -> Prelude.return (4)
     VisPageDrawingScale -> Prelude.return (5)
     VisPageDrawSizeType -> Prelude.return (6)
     VisPageDrawScaleType -> Prelude.return (7)
     VisTxtBlkLeftMargin -> Prelude.return (0)
     VisTxtBlkRightMargin -> Prelude.return (1)
     VisTxtBlkTopMargin -> Prelude.return (2)
     VisTxtBlkBottomMargin -> Prelude.return (3)
     VisTxtBlkVerticalAlign -> Prelude.return (4)
     VisTxtBlkBkgnd -> Prelude.return (5)
     VisAlignLeft -> Prelude.return (0)
     VisAlignCenter -> Prelude.return (1)
     VisAlignRight -> Prelude.return (2)
     VisAlignTop -> Prelude.return (3)
     VisAlignMiddle -> Prelude.return (4)
     VisAlignBottom -> Prelude.return (5)
     VisLockWidth -> Prelude.return (0)
     VisLockHeight -> Prelude.return (1)
     VisLockMoveX -> Prelude.return (2)
     VisLockMoveY -> Prelude.return (3)
     VisLockAspect -> Prelude.return (4)
     VisLockDelete -> Prelude.return (5)
     VisLockBegin -> Prelude.return (6)
     VisLockEnd -> Prelude.return (7)
     VisLockRotate -> Prelude.return (8)
     VisLockCrop -> Prelude.return (9)
     VisLockVtxEdit -> Prelude.return (10)
     VisLockTextEdit -> Prelude.return (11)
     VisLockFormat -> Prelude.return (12)
     VisLockGroup -> Prelude.return (13)
     VisLockCalcWH -> Prelude.return (14)
     VisLockSelect -> Prelude.return (15)
     VisObjHelp -> Prelude.return (0)
     VisCopyRight -> Prelude.return (1)
     VisNoObjHandles -> Prelude.return (0)
     VisNonPrinting -> Prelude.return (1)
     VisNoCtlHandles -> Prelude.return (2)
     VisNoAlignBox -> Prelude.return (3)
     VisUpdateAlignBox -> Prelude.return (4)
     VisHideText -> Prelude.return (5)
     VisDynFeedback -> Prelude.return (8)
     VisGlueType -> Prelude.return (9)
     VisWalkPref -> Prelude.return (10)
     VisBegTrigger -> Prelude.return (11)
     VisEndTrigger -> Prelude.return (12)
     VisLOFlags -> Prelude.return (13)
     VisLOInteraction -> Prelude.return (14)
     VisLOBehavior -> Prelude.return (15)
     VisXRulerDensity -> Prelude.return (0)
     VisYRulerDensity -> Prelude.return (1)
     VisXRulerOrigin -> Prelude.return (4)
     VisYRulerOrigin -> Prelude.return (5)
     VisXGridDensity -> Prelude.return (6)
     VisYGridDensity -> Prelude.return (7)
     VisXGridSpacing -> Prelude.return (8)
     VisYGridSpacing -> Prelude.return (9)
     VisXGridOrigin -> Prelude.return (10)
     VisYGridOrigin -> Prelude.return (11)
     VisHLinkDescription -> Prelude.return (0)
     VisHLinkAddress -> Prelude.return (1)
     VisHLinkSubAddress -> Prelude.return (2)
     VisHLinkExtraInfo -> Prelude.return (3)
     VisHLinkFrame -> Prelude.return (4)
     VisHLinkNewWin -> Prelude.return (5)
     VisCompNoFill -> Prelude.return (0)
     VisCompNoShow -> Prelude.return (2)
     VisX -> Prelude.return (0)
     VisY -> Prelude.return (1)
     VisBow -> Prelude.return (2)
     VisControlX -> Prelude.return (2)
     VisControlY -> Prelude.return (3)
     VisEccentricityAngle -> Prelude.return (4)
     VisAspectRatio -> Prelude.return (5)
     VisSplineKnot -> Prelude.return (2)
     VisSplineKnot2 -> Prelude.return (3)
     VisSplineKnot3 -> Prelude.return (4)
     VisSplineDegree -> Prelude.return (5)
     VisFieldCell -> Prelude.return (0)
     VisCharacterFont -> Prelude.return (0)
     VisCharacterColor -> Prelude.return (1)
     VisCharacterStyle -> Prelude.return (2)
     VisCharacterCase -> Prelude.return (3)
     VisCharacterPos -> Prelude.return (4)
     VisCharacterSize -> Prelude.return (7)
     VisIndentFirst -> Prelude.return (0)
     VisIndentLeft -> Prelude.return (1)
     VisIndentRight -> Prelude.return (2)
     VisSpaceLine -> Prelude.return (3)
     VisSpaceBefore -> Prelude.return (4)
     VisSpaceAfter -> Prelude.return (5)
     VisHorzAlign -> Prelude.return (6)
     VisTabStopCount -> Prelude.return (0)
     VisTabPos -> Prelude.return (1)
     VisTabAlign -> Prelude.return (2)
     VisScratchX -> Prelude.return (0)
     VisScratchY -> Prelude.return (1)
     VisScratchA -> Prelude.return (2)
     VisScratchB -> Prelude.return (3)
     VisScratchC -> Prelude.return (4)
     VisScratchD -> Prelude.return (5)
     VisCnnctA -> Prelude.return (2)
     VisCnnctB -> Prelude.return (3)
     VisCnnctC -> Prelude.return (4)
     VisCnnctD -> Prelude.return (5)
     VisCtlX -> Prelude.return (0)
     VisCtlY -> Prelude.return (1)
     VisCtlXDyn -> Prelude.return (2)
     VisCtlYDyn -> Prelude.return (3)
     VisCtlXCon -> Prelude.return (4)
     VisCtlYCon -> Prelude.return (5)
     VisCtlGlue -> Prelude.return (6)
     VisCtlType -> Prelude.return (7)
     VisCtlTip -> Prelude.return (8)
     VisActionMenu -> Prelude.return (0)
     VisActionPrompt -> Prelude.return (1)
     VisActionHelp -> Prelude.return (2)
     VisActionAction -> Prelude.return (3)
     VisActionChecked -> Prelude.return (4)
     VisActionDisabled -> Prelude.return (5)
     VisLayerName -> Prelude.return (0)
     VisLayerColor -> Prelude.return (2)
     VisLayerStatus -> Prelude.return (3)
     VisLayerVisible -> Prelude.return (4)
     VisLayerPrint -> Prelude.return (5)
     VisLayerActive -> Prelude.return (6)
     VisLayerLock -> Prelude.return (7)
     VisLayerSnap -> Prelude.return (8)
     VisLayerGlue -> Prelude.return (9)
     VisUserValue -> Prelude.return (0)
     VisUserPrompt -> Prelude.return (1)
     VisCustPropsValue -> Prelude.return (0)
     VisCustPropsPrompt -> Prelude.return (1)
     VisCustPropsLabel -> Prelude.return (2)
     VisCustPropsFormat -> Prelude.return (3)
     VisCustPropsSortKey -> Prelude.return (4)
     VisCustPropsType -> Prelude.return (5)
     VisCustPropsInvis -> Prelude.return (6)
     VisCustPropsAsk -> Prelude.return (7)
-}
unmarshallVisCellIndices :: Int.Int16 -> Prelude.IO VisCellIndices
unmarshallVisCellIndices v =
  case v of
     0 -> Prelude.return (VisXFormPinX)
     1 -> Prelude.return (VisXFormPinY)
     2 -> Prelude.return (VisXFormWidth)
     3 -> Prelude.return (VisXFormHeight)
     4 -> Prelude.return (VisXFormLocPinX)
     5 -> Prelude.return (VisXFormLocPinY)
     6 -> Prelude.return (VisXFormAngle)
     7 -> Prelude.return (VisXFormFlipX)
     8 -> Prelude.return (VisXFormFlipY)
     9 -> Prelude.return (VisXFormResizeMode)
{-
     0 -> Prelude.return (VisLineWeight)
     1 -> Prelude.return (VisLineColor)
     2 -> Prelude.return (VisLinePattern)
     3 -> Prelude.return (VisLineRounding)
     4 -> Prelude.return (VisLineArrowSize)
     5 -> Prelude.return (VisLineBeginArrow)
     6 -> Prelude.return (VisLineEndArrow)
     7 -> Prelude.return (VisLineEndCap)
     0 -> Prelude.return (VisFillForegnd)
     1 -> Prelude.return (VisFillBkgnd)
     2 -> Prelude.return (VisFillPattern)
     3 -> Prelude.return (VisFillShdwForegnd)
     4 -> Prelude.return (VisFillShdwBkgnd)
     5 -> Prelude.return (VisFillShdwPattern)
     0 -> Prelude.return (Vis1DBeginX)
     1 -> Prelude.return (Vis1DBeginY)
     2 -> Prelude.return (Vis1DEndX)
     3 -> Prelude.return (Vis1DEndY)
     0 -> Prelude.return (VisEvtCellTheData)
     1 -> Prelude.return (VisEvtCellTheText)
     2 -> Prelude.return (VisEvtCellDblClick)
     3 -> Prelude.return (VisEvtCellXFMod)
     4 -> Prelude.return (VisEvtCellDrop)
     0 -> Prelude.return (VisLayerMember)
     2 -> Prelude.return (VisGuideFlags)
     0 -> Prelude.return (VisStyleIncludesLine)
     1 -> Prelude.return (VisStyleIncludesFill)
     2 -> Prelude.return (VisStyleIncludesText)
     0 -> Prelude.return (VisFrgnImgOffsetX)
     1 -> Prelude.return (VisFrgnImgOffsetY)
     2 -> Prelude.return (VisFrgnImgWidth)
     3 -> Prelude.return (VisFrgnImgHeight)
     0 -> Prelude.return (VisPageWidth)
     1 -> Prelude.return (VisPageHeight)
     2 -> Prelude.return (VisPageShdwOffsetX)
     3 -> Prelude.return (VisPageShdwOffsetY)
     4 -> Prelude.return (VisPageScale)
     5 -> Prelude.return (VisPageDrawingScale)
     6 -> Prelude.return (VisPageDrawSizeType)
     7 -> Prelude.return (VisPageDrawScaleType)
     0 -> Prelude.return (VisTxtBlkLeftMargin)
     1 -> Prelude.return (VisTxtBlkRightMargin)
     2 -> Prelude.return (VisTxtBlkTopMargin)
     3 -> Prelude.return (VisTxtBlkBottomMargin)
     4 -> Prelude.return (VisTxtBlkVerticalAlign)
     5 -> Prelude.return (VisTxtBlkBkgnd)
     0 -> Prelude.return (VisAlignLeft)
     1 -> Prelude.return (VisAlignCenter)
     2 -> Prelude.return (VisAlignRight)
     3 -> Prelude.return (VisAlignTop)
     4 -> Prelude.return (VisAlignMiddle)
     5 -> Prelude.return (VisAlignBottom)
     0 -> Prelude.return (VisLockWidth)
     1 -> Prelude.return (VisLockHeight)
     2 -> Prelude.return (VisLockMoveX)
     3 -> Prelude.return (VisLockMoveY)
     4 -> Prelude.return (VisLockAspect)
     5 -> Prelude.return (VisLockDelete)
     6 -> Prelude.return (VisLockBegin)
     7 -> Prelude.return (VisLockEnd)
     8 -> Prelude.return (VisLockRotate)
     9 -> Prelude.return (VisLockCrop)
     10 -> Prelude.return (VisLockVtxEdit)
     11 -> Prelude.return (VisLockTextEdit)
     12 -> Prelude.return (VisLockFormat)
     13 -> Prelude.return (VisLockGroup)
     14 -> Prelude.return (VisLockCalcWH)
     15 -> Prelude.return (VisLockSelect)
     0 -> Prelude.return (VisObjHelp)
     1 -> Prelude.return (VisCopyRight)
     0 -> Prelude.return (VisNoObjHandles)
     1 -> Prelude.return (VisNonPrinting)
     2 -> Prelude.return (VisNoCtlHandles)
     3 -> Prelude.return (VisNoAlignBox)
     4 -> Prelude.return (VisUpdateAlignBox)
     5 -> Prelude.return (VisHideText)
     8 -> Prelude.return (VisDynFeedback)
     9 -> Prelude.return (VisGlueType)
     10 -> Prelude.return (VisWalkPref)
     11 -> Prelude.return (VisBegTrigger)
     12 -> Prelude.return (VisEndTrigger)
     13 -> Prelude.return (VisLOFlags)
     14 -> Prelude.return (VisLOInteraction)
     15 -> Prelude.return (VisLOBehavior)
     0 -> Prelude.return (VisXRulerDensity)
     1 -> Prelude.return (VisYRulerDensity)
     4 -> Prelude.return (VisXRulerOrigin)
     5 -> Prelude.return (VisYRulerOrigin)
     6 -> Prelude.return (VisXGridDensity)
     7 -> Prelude.return (VisYGridDensity)
     8 -> Prelude.return (VisXGridSpacing)
     9 -> Prelude.return (VisYGridSpacing)
     10 -> Prelude.return (VisXGridOrigin)
     11 -> Prelude.return (VisYGridOrigin)
     0 -> Prelude.return (VisHLinkDescription)
     1 -> Prelude.return (VisHLinkAddress)
     2 -> Prelude.return (VisHLinkSubAddress)
     3 -> Prelude.return (VisHLinkExtraInfo)
     4 -> Prelude.return (VisHLinkFrame)
     5 -> Prelude.return (VisHLinkNewWin)
     0 -> Prelude.return (VisCompNoFill)
     2 -> Prelude.return (VisCompNoShow)
     0 -> Prelude.return (VisX)
     1 -> Prelude.return (VisY)
     2 -> Prelude.return (VisBow)
     2 -> Prelude.return (VisControlX)
     3 -> Prelude.return (VisControlY)
     4 -> Prelude.return (VisEccentricityAngle)
     5 -> Prelude.return (VisAspectRatio)
     2 -> Prelude.return (VisSplineKnot)
     3 -> Prelude.return (VisSplineKnot2)
     4 -> Prelude.return (VisSplineKnot3)
     5 -> Prelude.return (VisSplineDegree)
     0 -> Prelude.return (VisFieldCell)
     0 -> Prelude.return (VisCharacterFont)
     1 -> Prelude.return (VisCharacterColor)
     2 -> Prelude.return (VisCharacterStyle)
     3 -> Prelude.return (VisCharacterCase)
     4 -> Prelude.return (VisCharacterPos)
     7 -> Prelude.return (VisCharacterSize)
     0 -> Prelude.return (VisIndentFirst)
     1 -> Prelude.return (VisIndentLeft)
     2 -> Prelude.return (VisIndentRight)
     3 -> Prelude.return (VisSpaceLine)
     4 -> Prelude.return (VisSpaceBefore)
     5 -> Prelude.return (VisSpaceAfter)
     6 -> Prelude.return (VisHorzAlign)
     0 -> Prelude.return (VisTabStopCount)
     1 -> Prelude.return (VisTabPos)
     2 -> Prelude.return (VisTabAlign)
     0 -> Prelude.return (VisScratchX)
     1 -> Prelude.return (VisScratchY)
     2 -> Prelude.return (VisScratchA)
     3 -> Prelude.return (VisScratchB)
     4 -> Prelude.return (VisScratchC)
     5 -> Prelude.return (VisScratchD)
     2 -> Prelude.return (VisCnnctA)
     3 -> Prelude.return (VisCnnctB)
     4 -> Prelude.return (VisCnnctC)
     5 -> Prelude.return (VisCnnctD)
     0 -> Prelude.return (VisCtlX)
     1 -> Prelude.return (VisCtlY)
     2 -> Prelude.return (VisCtlXDyn)
     3 -> Prelude.return (VisCtlYDyn)
     4 -> Prelude.return (VisCtlXCon)
     5 -> Prelude.return (VisCtlYCon)
     6 -> Prelude.return (VisCtlGlue)
     7 -> Prelude.return (VisCtlType)
     8 -> Prelude.return (VisCtlTip)
     0 -> Prelude.return (VisActionMenu)
     1 -> Prelude.return (VisActionPrompt)
     2 -> Prelude.return (VisActionHelp)
     3 -> Prelude.return (VisActionAction)
     4 -> Prelude.return (VisActionChecked)
     5 -> Prelude.return (VisActionDisabled)
     0 -> Prelude.return (VisLayerName)
     2 -> Prelude.return (VisLayerColor)
     3 -> Prelude.return (VisLayerStatus)
     4 -> Prelude.return (VisLayerVisible)
     5 -> Prelude.return (VisLayerPrint)
     6 -> Prelude.return (VisLayerActive)
     7 -> Prelude.return (VisLayerLock)
     8 -> Prelude.return (VisLayerSnap)
     9 -> Prelude.return (VisLayerGlue)
     0 -> Prelude.return (VisUserValue)
     1 -> Prelude.return (VisUserPrompt)
     0 -> Prelude.return (VisCustPropsValue)
     1 -> Prelude.return (VisCustPropsPrompt)
     2 -> Prelude.return (VisCustPropsLabel)
     3 -> Prelude.return (VisCustPropsFormat)
     4 -> Prelude.return (VisCustPropsSortKey)
     5 -> Prelude.return (VisCustPropsType)
     6 -> Prelude.return (VisCustPropsInvis)
     7 -> Prelude.return (VisCustPropsAsk)
-}
     _ -> Prelude.fail (Prelude.userError "unmarshallVisCellIndices: illegal enum value ")
data VisCellVals
 = VisXFormResizeDontCare
 | VisXFormResizeSpread
 | VisXFormResizeScale
 | VisNoFill
 | VisSolid
 | VisWideUpDiagonal
 | VisWideCross
 | VisWideDiagonalCross
 | VisWideDownDiagonal
 | VisWideHorz
 | VisWideVert
 | VisBackDotsMini
 | VisHalfAndHalf
 | VisForeDotsMini
 | VisForeDotsNarrow
 | VisForeDotsWide
 | VisThickHorz
 | VisThickVertical
 | VisThickDownDiagonal
 | VisThickUpDiagonal
 | VisThickDiagonalCross
 | VisBackDotsWide
 | VisThinHorz
 | VisThinVert
 | VisThinDownDiagonal
 | VisThinUpDiagonal
 | VisThinCross
 | VisThinDiagonalCross
 | VisGuideXActive
 | VisGuideYActive
 | VisPrintSetup
 | VisTight
 | VisStandard
 | VisCustom
 | VisLogical
 | VisDSMetric
 | VisDSEngr
 | VisDSArch
 | VisNoScale
 | VisArchitectural
 | VisEngineering
 | VisScaleCustom
 | VisScaleMetric
 | VisScaleMechanical
 | VisVertTop
 | VisVertMiddle
 | VisVertBottom
 | VisTxtBlkOpaque
 | VisDynFBDefault
 | VisDynFBUCon3Leg
 | VisDynFBUCon5Leg
 | VisGlueTypeDefault
 | VisGlueTypeTrigger
 | VisGlueTypeWalking
 | VisWalkPrefBegNS
 | VisWalkPrefEndNS
 | VisLOFlagsVisDecides
 | VisLOFlagsPlacable
 | VisLOFlagsRoutable
 | VisLOFlagsDont
 | VisLOFlagsPNRGroup
 | VisLOIPlaceNormal
 | VisLOIRouteNormal
 | VisLOBPlaceNormal
 | VisLOBRouteNormal
 | VisLOBRouteRightAng
 | VisLOBRouteStraight
 | VisLOBRouteFlowNS
 | VisLOBRouteFlowWE
 | VisLOBRouteTreeNS
 | VisLOBRouteTreeWE
 | VisRulerFine
 | VisRulerNormal
 | VisRulerCoarse
 | VisRulerFixed
 | VisGridFine
 | VisGridNormal
 | VisGridCoarse
 | VisGridFixed
 | VisBold
 | VisItalic
 | VisUnderLine
 | VisSmallCaps
 | VisCaseNormal
 | VisCaseAllCaps
 | VisCaseInitialCaps
 | VisPosNormal
 | VisPosSuper
 | VisPosSub
 | VisHorzLeft
 | VisHorzCenter
 | VisHorzRight
 | VisHorzJustify
 | VisHorzForce
 | VisTabStopLeft
 | VisTabStopCenter
 | VisTabStopRight
 | VisTabStopDecimal
 | VisTabStopComma
 | VisCtlProportional
 | VisCtlLocked
 | VisCtlOffsetMin
 | VisCtlOffsetMid
 | VisCtlOffsetMax
 | VisCtlProportionalHidden
 | VisCtlLockedHidden
 | VisCtlOffsetMinHidden
 | VisCtlOffsetMidHidden
 | VisCtlOffsetMaxHidden
 | VisNoLayerColor
 | VisLayerValid
 | VisLayerDeleted
 | VisLayerAvailable
 | VisPropTypeString
 | VisPropTypeListFix
 | VisPropTypeNumber
 | VisPropTypeBool
 | VisPropTypeListVar
 
marshallVisCellVals :: VisCellVals -> Prelude.IO Int.Int16
marshallVisCellVals v =
  case v of
     VisXFormResizeDontCare -> Prelude.return (0)
     VisXFormResizeSpread -> Prelude.return (1)
     VisXFormResizeScale -> Prelude.return (2)
     VisNoFill -> Prelude.return (0)
     VisSolid -> Prelude.return (1)
     VisWideUpDiagonal -> Prelude.return (2)
     VisWideCross -> Prelude.return (3)
     VisWideDiagonalCross -> Prelude.return (4)
     VisWideDownDiagonal -> Prelude.return (5)
     VisWideHorz -> Prelude.return (6)
     VisWideVert -> Prelude.return (7)
     VisBackDotsMini -> Prelude.return (8)
     VisHalfAndHalf -> Prelude.return (9)
     VisForeDotsMini -> Prelude.return (10)
     VisForeDotsNarrow -> Prelude.return (11)
     VisForeDotsWide -> Prelude.return (12)
     VisThickHorz -> Prelude.return (13)
     VisThickVertical -> Prelude.return (14)
     VisThickDownDiagonal -> Prelude.return (15)
     VisThickUpDiagonal -> Prelude.return (16)
     VisThickDiagonalCross -> Prelude.return (17)
     VisBackDotsWide -> Prelude.return (18)
     VisThinHorz -> Prelude.return (19)
     VisThinVert -> Prelude.return (20)
     VisThinDownDiagonal -> Prelude.return (21)
     VisThinUpDiagonal -> Prelude.return (22)
     VisThinCross -> Prelude.return (23)
     VisThinDiagonalCross -> Prelude.return (24)
     VisGuideXActive -> Prelude.return (1024)
     VisGuideYActive -> Prelude.return (2048)
{-
     VisPrintSetup -> Prelude.return (0)
     VisTight -> Prelude.return (1)
     VisStandard -> Prelude.return (2)
     VisCustom -> Prelude.return (3)
     VisLogical -> Prelude.return (4)
     VisDSMetric -> Prelude.return (5)
     VisDSEngr -> Prelude.return (6)
     VisDSArch -> Prelude.return (7)
     VisNoScale -> Prelude.return (0)
     VisArchitectural -> Prelude.return (1)
     VisEngineering -> Prelude.return (2)
     VisScaleCustom -> Prelude.return (3)
     VisScaleMetric -> Prelude.return (4)
     VisScaleMechanical -> Prelude.return (5)
     VisVertTop -> Prelude.return (0)
     VisVertMiddle -> Prelude.return (1)
     VisVertBottom -> Prelude.return (2)
     VisTxtBlkOpaque -> Prelude.return (255)
     VisDynFBDefault -> Prelude.return (0)
     VisDynFBUCon3Leg -> Prelude.return (1)
     VisDynFBUCon5Leg -> Prelude.return (2)
     VisGlueTypeDefault -> Prelude.return (0)
     VisGlueTypeTrigger -> Prelude.return (1)
     VisGlueTypeWalking -> Prelude.return (2)
     VisWalkPrefBegNS -> Prelude.return (1)
     VisWalkPrefEndNS -> Prelude.return (2)
     VisLOFlagsVisDecides -> Prelude.return (0)
     VisLOFlagsPlacable -> Prelude.return (1)
     VisLOFlagsRoutable -> Prelude.return (2)
     VisLOFlagsDont -> Prelude.return (4)
     VisLOFlagsPNRGroup -> Prelude.return (8)
     VisLOIPlaceNormal -> Prelude.return (0)
     VisLOIRouteNormal -> Prelude.return (0)
     VisLOBPlaceNormal -> Prelude.return (0)
     VisLOBRouteNormal -> Prelude.return (0)
     VisLOBRouteRightAng -> Prelude.return (1)
     VisLOBRouteStraight -> Prelude.return (2)
     VisLOBRouteFlowNS -> Prelude.return (5)
     VisLOBRouteFlowWE -> Prelude.return (6)
     VisLOBRouteTreeNS -> Prelude.return (7)
     VisLOBRouteTreeWE -> Prelude.return (8)
     VisRulerFine -> Prelude.return (32)
     VisRulerNormal -> Prelude.return (16)
     VisRulerCoarse -> Prelude.return (8)
     VisRulerFixed -> Prelude.return (0)
     VisGridFine -> Prelude.return (8)
     VisGridNormal -> Prelude.return (4)
     VisGridCoarse -> Prelude.return (2)
     VisGridFixed -> Prelude.return (0)
     VisBold -> Prelude.return (1)
     VisItalic -> Prelude.return (2)
     VisUnderLine -> Prelude.return (4)
     VisSmallCaps -> Prelude.return (8)
     VisCaseNormal -> Prelude.return (0)
     VisCaseAllCaps -> Prelude.return (1)
     VisCaseInitialCaps -> Prelude.return (2)
     VisPosNormal -> Prelude.return (0)
     VisPosSuper -> Prelude.return (1)
     VisPosSub -> Prelude.return (2)
     VisHorzLeft -> Prelude.return (0)
     VisHorzCenter -> Prelude.return (1)
     VisHorzRight -> Prelude.return (2)
     VisHorzJustify -> Prelude.return (3)
     VisHorzForce -> Prelude.return (4)
     VisTabStopLeft -> Prelude.return (0)
     VisTabStopCenter -> Prelude.return (1)
     VisTabStopRight -> Prelude.return (2)
     VisTabStopDecimal -> Prelude.return (3)
     VisTabStopComma -> Prelude.return (4)
     VisCtlProportional -> Prelude.return (0)
     VisCtlLocked -> Prelude.return (1)
     VisCtlOffsetMin -> Prelude.return (2)
     VisCtlOffsetMid -> Prelude.return (3)
     VisCtlOffsetMax -> Prelude.return (4)
     VisCtlProportionalHidden -> Prelude.return (5)
     VisCtlLockedHidden -> Prelude.return (6)
     VisCtlOffsetMinHidden -> Prelude.return (7)
     VisCtlOffsetMidHidden -> Prelude.return (8)
     VisCtlOffsetMaxHidden -> Prelude.return (9)
     VisNoLayerColor -> Prelude.return (255)
     VisLayerValid -> Prelude.return (0)
     VisLayerDeleted -> Prelude.return (1)
     VisLayerAvailable -> Prelude.return (2)
     VisPropTypeString -> Prelude.return (0)
     VisPropTypeListFix -> Prelude.return (1)
     VisPropTypeNumber -> Prelude.return (2)
     VisPropTypeBool -> Prelude.return (3)
     VisPropTypeListVar -> Prelude.return (4)
-}
unmarshallVisCellVals :: Int.Int16 -> Prelude.IO VisCellVals
unmarshallVisCellVals v =
  case v of
     0 -> Prelude.return (VisXFormResizeDontCare)
     1 -> Prelude.return (VisXFormResizeSpread)
     2 -> Prelude.return (VisXFormResizeScale)
     0 -> Prelude.return (VisNoFill)
     1 -> Prelude.return (VisSolid)
     2 -> Prelude.return (VisWideUpDiagonal)
     3 -> Prelude.return (VisWideCross)
     4 -> Prelude.return (VisWideDiagonalCross)
     5 -> Prelude.return (VisWideDownDiagonal)
     6 -> Prelude.return (VisWideHorz)
     7 -> Prelude.return (VisWideVert)
     8 -> Prelude.return (VisBackDotsMini)
     9 -> Prelude.return (VisHalfAndHalf)
     10 -> Prelude.return (VisForeDotsMini)
     11 -> Prelude.return (VisForeDotsNarrow)
     12 -> Prelude.return (VisForeDotsWide)
     13 -> Prelude.return (VisThickHorz)
     14 -> Prelude.return (VisThickVertical)
     15 -> Prelude.return (VisThickDownDiagonal)
     16 -> Prelude.return (VisThickUpDiagonal)
     17 -> Prelude.return (VisThickDiagonalCross)
     18 -> Prelude.return (VisBackDotsWide)
     19 -> Prelude.return (VisThinHorz)
     20 -> Prelude.return (VisThinVert)
     21 -> Prelude.return (VisThinDownDiagonal)
     22 -> Prelude.return (VisThinUpDiagonal)
     23 -> Prelude.return (VisThinCross)
     24 -> Prelude.return (VisThinDiagonalCross)
     1024 -> Prelude.return (VisGuideXActive)
     2048 -> Prelude.return (VisGuideYActive)
{-
     0 -> Prelude.return (VisPrintSetup)
     1 -> Prelude.return (VisTight)
     2 -> Prelude.return (VisStandard)
     3 -> Prelude.return (VisCustom)
     4 -> Prelude.return (VisLogical)
     5 -> Prelude.return (VisDSMetric)
     6 -> Prelude.return (VisDSEngr)
     7 -> Prelude.return (VisDSArch)
     0 -> Prelude.return (VisNoScale)
     1 -> Prelude.return (VisArchitectural)
     2 -> Prelude.return (VisEngineering)
     3 -> Prelude.return (VisScaleCustom)
     4 -> Prelude.return (VisScaleMetric)
     5 -> Prelude.return (VisScaleMechanical)
     0 -> Prelude.return (VisVertTop)
     1 -> Prelude.return (VisVertMiddle)
     2 -> Prelude.return (VisVertBottom)
     255 -> Prelude.return (VisTxtBlkOpaque)
     0 -> Prelude.return (VisDynFBDefault)
     1 -> Prelude.return (VisDynFBUCon3Leg)
     2 -> Prelude.return (VisDynFBUCon5Leg)
     0 -> Prelude.return (VisGlueTypeDefault)
     1 -> Prelude.return (VisGlueTypeTrigger)
     2 -> Prelude.return (VisGlueTypeWalking)
     1 -> Prelude.return (VisWalkPrefBegNS)
     2 -> Prelude.return (VisWalkPrefEndNS)
     0 -> Prelude.return (VisLOFlagsVisDecides)
     1 -> Prelude.return (VisLOFlagsPlacable)
     2 -> Prelude.return (VisLOFlagsRoutable)
     4 -> Prelude.return (VisLOFlagsDont)
     8 -> Prelude.return (VisLOFlagsPNRGroup)
     0 -> Prelude.return (VisLOIPlaceNormal)
     0 -> Prelude.return (VisLOIRouteNormal)
     0 -> Prelude.return (VisLOBPlaceNormal)
     0 -> Prelude.return (VisLOBRouteNormal)
     1 -> Prelude.return (VisLOBRouteRightAng)
     2 -> Prelude.return (VisLOBRouteStraight)
     5 -> Prelude.return (VisLOBRouteFlowNS)
     6 -> Prelude.return (VisLOBRouteFlowWE)
     7 -> Prelude.return (VisLOBRouteTreeNS)
     8 -> Prelude.return (VisLOBRouteTreeWE)
     32 -> Prelude.return (VisRulerFine)
     16 -> Prelude.return (VisRulerNormal)
     8 -> Prelude.return (VisRulerCoarse)
     0 -> Prelude.return (VisRulerFixed)
     8 -> Prelude.return (VisGridFine)
     4 -> Prelude.return (VisGridNormal)
     2 -> Prelude.return (VisGridCoarse)
     0 -> Prelude.return (VisGridFixed)
     1 -> Prelude.return (VisBold)
     2 -> Prelude.return (VisItalic)
     4 -> Prelude.return (VisUnderLine)
     8 -> Prelude.return (VisSmallCaps)
     0 -> Prelude.return (VisCaseNormal)
     1 -> Prelude.return (VisCaseAllCaps)
     2 -> Prelude.return (VisCaseInitialCaps)
     0 -> Prelude.return (VisPosNormal)
     1 -> Prelude.return (VisPosSuper)
     2 -> Prelude.return (VisPosSub)
     0 -> Prelude.return (VisHorzLeft)
     1 -> Prelude.return (VisHorzCenter)
     2 -> Prelude.return (VisHorzRight)
     3 -> Prelude.return (VisHorzJustify)
     4 -> Prelude.return (VisHorzForce)
     0 -> Prelude.return (VisTabStopLeft)
     1 -> Prelude.return (VisTabStopCenter)
     2 -> Prelude.return (VisTabStopRight)
     3 -> Prelude.return (VisTabStopDecimal)
     4 -> Prelude.return (VisTabStopComma)
     0 -> Prelude.return (VisCtlProportional)
     1 -> Prelude.return (VisCtlLocked)
     2 -> Prelude.return (VisCtlOffsetMin)
     3 -> Prelude.return (VisCtlOffsetMid)
     4 -> Prelude.return (VisCtlOffsetMax)
     5 -> Prelude.return (VisCtlProportionalHidden)
     6 -> Prelude.return (VisCtlLockedHidden)
     7 -> Prelude.return (VisCtlOffsetMinHidden)
     8 -> Prelude.return (VisCtlOffsetMidHidden)
     9 -> Prelude.return (VisCtlOffsetMaxHidden)
     255 -> Prelude.return (VisNoLayerColor)
     0 -> Prelude.return (VisLayerValid)
     1 -> Prelude.return (VisLayerDeleted)
     2 -> Prelude.return (VisLayerAvailable)
     0 -> Prelude.return (VisPropTypeString)
     1 -> Prelude.return (VisPropTypeListFix)
     2 -> Prelude.return (VisPropTypeNumber)
     3 -> Prelude.return (VisPropTypeBool)
     4 -> Prelude.return (VisPropTypeListVar)
     _ -> Prelude.fail (Prelude.userError "unmarshallVisCellVals: illegal enum value ")
-}
data VisDefaultColors
 = VisTransparent
 | VisBlack
 | VisWhite
 | VisRed
 | VisGreen
 | VisBlue
 | VisYellow
 | VisMagenta
 | VisCyan
 | VisDarkRed
 | VisDarkGreen
 | VisDarkBlue
 | VisDarkYellow
 | VisPurple
 | VisDarkCyan
 | VisGray
 | VisGray10
 | VisGray20
 | VisGray30
 | VisGray40
 | VisDarkGray
 | VisGray50
 | VisGray60
 | VisGray70
 | VisGray80
 | VisGray90
 
marshallVisDefaultColors :: VisDefaultColors -> Prelude.IO Int.Int16
marshallVisDefaultColors v =
  case v of
     VisTransparent -> Prelude.return (0)
     VisBlack -> Prelude.return (0)
     VisWhite -> Prelude.return (1)
     VisRed -> Prelude.return (2)
     VisGreen -> Prelude.return (3)
     VisBlue -> Prelude.return (4)
     VisYellow -> Prelude.return (5)
     VisMagenta -> Prelude.return (6)
     VisCyan -> Prelude.return (7)
     VisDarkRed -> Prelude.return (8)
     VisDarkGreen -> Prelude.return (9)
     VisDarkBlue -> Prelude.return (10)
     VisDarkYellow -> Prelude.return (11)
     VisPurple -> Prelude.return (12)
     VisDarkCyan -> Prelude.return (13)
     VisGray -> Prelude.return (14)
     VisGray10 -> Prelude.return (15)
     VisGray20 -> Prelude.return (16)
     VisGray30 -> Prelude.return (17)
     VisGray40 -> Prelude.return (18)
     VisDarkGray -> Prelude.return (19)
     VisGray50 -> Prelude.return (19)
     VisGray60 -> Prelude.return (20)
     VisGray70 -> Prelude.return (21)
     VisGray80 -> Prelude.return (22)
     VisGray90 -> Prelude.return (23)
unmarshallVisDefaultColors :: Int.Int16 -> Prelude.IO VisDefaultColors
unmarshallVisDefaultColors v =
  case v of
     0 -> Prelude.return (VisTransparent)
     0 -> Prelude.return (VisBlack)
     1 -> Prelude.return (VisWhite)
     2 -> Prelude.return (VisRed)
     3 -> Prelude.return (VisGreen)
     4 -> Prelude.return (VisBlue)
     5 -> Prelude.return (VisYellow)
     6 -> Prelude.return (VisMagenta)
     7 -> Prelude.return (VisCyan)
     8 -> Prelude.return (VisDarkRed)
     9 -> Prelude.return (VisDarkGreen)
     10 -> Prelude.return (VisDarkBlue)
     11 -> Prelude.return (VisDarkYellow)
     12 -> Prelude.return (VisPurple)
     13 -> Prelude.return (VisDarkCyan)
     14 -> Prelude.return (VisGray)
     15 -> Prelude.return (VisGray10)
     16 -> Prelude.return (VisGray20)
     17 -> Prelude.return (VisGray30)
     18 -> Prelude.return (VisGray40)
     19 -> Prelude.return (VisDarkGray)
     19 -> Prelude.return (VisGray50)
     20 -> Prelude.return (VisGray60)
     21 -> Prelude.return (VisGray70)
     22 -> Prelude.return (VisGray80)
     23 -> Prelude.return (VisGray90)
     _ -> Prelude.fail (Prelude.userError "unmarshallVisDefaultColors: illegal enum value ")
data VisOpenSaveArgs
 = VisOpenCopy
 | VisOpenRO
 | VisOpenDocked
 | VisOpenDontList
 | VisSaveAsRO
 | VisSaveAsWS
 | VisSavePrevNone
 | VisSavePrevDraft1st
 | VisSavePrevDetailed1st
 | VisSavePrevDraftAll
 | VisSavePrevDetailedAll
 
marshallVisOpenSaveArgs :: VisOpenSaveArgs -> Prelude.IO Int.Int16
marshallVisOpenSaveArgs v =
  case v of
     VisOpenCopy -> Prelude.return (1)
     VisOpenRO -> Prelude.return (2)
     VisOpenDocked -> Prelude.return (4)
     VisOpenDontList -> Prelude.return (8)
     VisSaveAsRO -> Prelude.return (1)
     VisSaveAsWS -> Prelude.return (2)
     VisSavePrevNone -> Prelude.return (0)
     VisSavePrevDraft1st -> Prelude.return (1)
     VisSavePrevDetailed1st -> Prelude.return (2)
     VisSavePrevDraftAll -> Prelude.return (4)
     VisSavePrevDetailedAll -> Prelude.return (8)
unmarshallVisOpenSaveArgs :: Int.Int16 -> Prelude.IO VisOpenSaveArgs
unmarshallVisOpenSaveArgs v =
  case v of
     1 -> Prelude.return (VisOpenCopy)
     2 -> Prelude.return (VisOpenRO)
     4 -> Prelude.return (VisOpenDocked)
     8 -> Prelude.return (VisOpenDontList)
     1 -> Prelude.return (VisSaveAsRO)
     2 -> Prelude.return (VisSaveAsWS)
     0 -> Prelude.return (VisSavePrevNone)
     1 -> Prelude.return (VisSavePrevDraft1st)
     2 -> Prelude.return (VisSavePrevDetailed1st)
     4 -> Prelude.return (VisSavePrevDraftAll)
     8 -> Prelude.return (VisSavePrevDetailedAll)
     _ -> Prelude.fail (Prelude.userError "unmarshallVisOpenSaveArgs: illegal enum value ")
data VisInsertObjArgs
 = VisInsertLink
 | VisInsertIcon
 | VisInsertDontShow
 | VisInsertAsControl
 | VisInsertAsEmbed
 
marshallVisInsertObjArgs :: VisInsertObjArgs -> Prelude.IO Int.Int16
marshallVisInsertObjArgs v =
  case v of
     VisInsertLink -> Prelude.return (8)
     VisInsertIcon -> Prelude.return (16)
     VisInsertDontShow -> Prelude.return (4096)
     VisInsertAsControl -> Prelude.return (8192)
     VisInsertAsEmbed -> Prelude.return (16384)
unmarshallVisInsertObjArgs :: Int.Int16 -> Prelude.IO VisInsertObjArgs
unmarshallVisInsertObjArgs v =
  case v of
     8 -> Prelude.return (VisInsertLink)
     16 -> Prelude.return (VisInsertIcon)
     4096 -> Prelude.return (VisInsertDontShow)
     8192 -> Prelude.return (VisInsertAsControl)
     16384 -> Prelude.return (VisInsertAsEmbed)
     _ -> Prelude.fail (Prelude.userError "unmarshallVisInsertObjArgs: illegal enum value ")
data VisGetSetArgs
 = VisGetFloats
 | VisGetTruncatedInts
 | VisGetRoundedInts
 | VisGetStrings
 | VisGetFormulas
 | VisSetFormulas
 | VisSetBlastGuards
 | VisSetTestCircular
 
marshallVisGetSetArgs :: VisGetSetArgs -> Prelude.IO Int.Int16
marshallVisGetSetArgs v =
  case v of
     VisGetFloats -> Prelude.return (0)
     VisGetTruncatedInts -> Prelude.return (1)
     VisGetRoundedInts -> Prelude.return (2)
     VisGetStrings -> Prelude.return (3)
     VisGetFormulas -> Prelude.return (4)
     VisSetFormulas -> Prelude.return (1)
     VisSetBlastGuards -> Prelude.return (2)
     VisSetTestCircular -> Prelude.return (4)
unmarshallVisGetSetArgs :: Int.Int16 -> Prelude.IO VisGetSetArgs
unmarshallVisGetSetArgs v =
  case v of
     0 -> Prelude.return (VisGetFloats)
     1 -> Prelude.return (VisGetTruncatedInts)
     2 -> Prelude.return (VisGetRoundedInts)
     3 -> Prelude.return (VisGetStrings)
     4 -> Prelude.return (VisGetFormulas)
     1 -> Prelude.return (VisSetFormulas)
     2 -> Prelude.return (VisSetBlastGuards)
     4 -> Prelude.return (VisSetTestCircular)
     _ -> Prelude.fail (Prelude.userError "unmarshallVisGetSetArgs: illegal enum value ")
data VisBoundingBoxArgs
 = VisBBoxUprightWH
 | VisBBoxUprightText
 | VisBBoxExtents
 | VisBBoxIncludeGuides
 | VisBBoxDrawingCoords
 | VisBBoxNoNonPrint
 
marshallVisBoundingBoxArgs :: VisBoundingBoxArgs -> Prelude.IO Int.Int16
marshallVisBoundingBoxArgs v =
  case v of
     VisBBoxUprightWH -> Prelude.return (1)
     VisBBoxUprightText -> Prelude.return (2)
     VisBBoxExtents -> Prelude.return (4)
     VisBBoxIncludeGuides -> Prelude.return (4096)
     VisBBoxDrawingCoords -> Prelude.return (8192)
     VisBBoxNoNonPrint -> Prelude.return (16384)
unmarshallVisBoundingBoxArgs :: Int.Int16 -> Prelude.IO VisBoundingBoxArgs
unmarshallVisBoundingBoxArgs v =
  case v of
     1 -> Prelude.return (VisBBoxUprightWH)
     2 -> Prelude.return (VisBBoxUprightText)
     4 -> Prelude.return (VisBBoxExtents)
     4096 -> Prelude.return (VisBBoxIncludeGuides)
     8192 -> Prelude.return (VisBBoxDrawingCoords)
     16384 -> Prelude.return (VisBBoxNoNonPrint)
     _ -> Prelude.fail (Prelude.userError "unmarshallVisBoundingBoxArgs: illegal enum value ")
data VisHitTestResults
 = VisHitOutside
 | VisHitOnBoundary
 | VisHitInside
 
marshallVisHitTestResults :: VisHitTestResults -> Prelude.IO Int.Int16
marshallVisHitTestResults v =
  case v of
     VisHitOutside -> Prelude.return (0)
     VisHitOnBoundary -> Prelude.return (1)
     VisHitInside -> Prelude.return (2)
unmarshallVisHitTestResults :: Int.Int16 -> Prelude.IO VisHitTestResults
unmarshallVisHitTestResults v =
  case v of
     0 -> Prelude.return (VisHitOutside)
     1 -> Prelude.return (VisHitOnBoundary)
     2 -> Prelude.return (VisHitInside)
     _ -> Prelude.fail (Prelude.userError "unmarshallVisHitTestResults: illegal enum value ")
data VisSelectArgs
 = VisDeselect
 | VisSelect
 | VisSubSelect
 | VisSelectAll
 | VisDeselectAll
 
marshallVisSelectArgs :: VisSelectArgs -> Prelude.IO Int.Int16
marshallVisSelectArgs v =
  case v of
     VisDeselect -> Prelude.return (1)
     VisSelect -> Prelude.return (2)
     VisSubSelect -> Prelude.return (3)
     VisSelectAll -> Prelude.return (4)
     VisDeselectAll -> Prelude.return (256)
unmarshallVisSelectArgs :: Int.Int16 -> Prelude.IO VisSelectArgs
unmarshallVisSelectArgs v =
  case v of
     1 -> Prelude.return (VisDeselect)
     2 -> Prelude.return (VisSelect)
     3 -> Prelude.return (VisSubSelect)
     4 -> Prelude.return (VisSelectAll)
     256 -> Prelude.return (VisDeselectAll)
     _ -> Prelude.fail (Prelude.userError "unmarshallVisSelectArgs: illegal enum value ")
data VisUniqueIDArgs
 = VisGetGUID
 | VisGetOrMakeGUID
 | VisDeleteGUID
 
marshallVisUniqueIDArgs :: VisUniqueIDArgs -> Prelude.IO Int.Int16
marshallVisUniqueIDArgs v =
  case v of
     VisGetGUID -> Prelude.return (0)
     VisGetOrMakeGUID -> Prelude.return (1)
     VisDeleteGUID -> Prelude.return (2)
unmarshallVisUniqueIDArgs :: Int.Int16 -> Prelude.IO VisUniqueIDArgs
unmarshallVisUniqueIDArgs v =
  case v of
     0 -> Prelude.return (VisGetGUID)
     1 -> Prelude.return (VisGetOrMakeGUID)
     2 -> Prelude.return (VisDeleteGUID)
     _ -> Prelude.fail (Prelude.userError "unmarshallVisUniqueIDArgs: illegal enum value ")
data VisExistsFlags
 = VisExistsLocally
 | VisExistsAnywhere
 
marshallVisExistsFlags :: VisExistsFlags -> Prelude.IO Int.Int16
marshallVisExistsFlags v =
  case v of
     VisExistsLocally -> Prelude.return (1)
     VisExistsAnywhere -> Prelude.return (0)
unmarshallVisExistsFlags :: Int.Int16 -> Prelude.IO VisExistsFlags
unmarshallVisExistsFlags v =
  case v of
     1 -> Prelude.return (VisExistsLocally)
     0 -> Prelude.return (VisExistsAnywhere)
     _ -> Prelude.fail (Prelude.userError "unmarshallVisExistsFlags: illegal enum value ")
data VisCellError
 = VisErrorSuccess
 | VisErrorDivideByZero
 | VisErrorValue
 | VisErrorReference
 | VisErrorName
 | VisErrorNumber
 | VisErrorNotAvailable
 
marshallVisCellError :: VisCellError -> Prelude.IO Int.Int16
marshallVisCellError v =
  case v of
     VisErrorSuccess -> Prelude.return (0)
     VisErrorDivideByZero -> Prelude.return (39)
     VisErrorValue -> Prelude.return (47)
     VisErrorReference -> Prelude.return (55)
     VisErrorName -> Prelude.return (61)
     VisErrorNumber -> Prelude.return (68)
     VisErrorNotAvailable -> Prelude.return (74)
unmarshallVisCellError :: Int.Int16 -> Prelude.IO VisCellError
unmarshallVisCellError v =
  case v of
     0 -> Prelude.return (VisErrorSuccess)
     39 -> Prelude.return (VisErrorDivideByZero)
     47 -> Prelude.return (VisErrorValue)
     55 -> Prelude.return (VisErrorReference)
     61 -> Prelude.return (VisErrorName)
     68 -> Prelude.return (VisErrorNumber)
     74 -> Prelude.return (VisErrorNotAvailable)
     _ -> Prelude.fail (Prelude.userError "unmarshallVisCellError: illegal enum value ")
data VisRoundFlags
 = VisTruncate
 | VisRound
 
marshallVisRoundFlags :: VisRoundFlags -> Prelude.IO Int.Int16
marshallVisRoundFlags v =
  case v of
     VisTruncate -> Prelude.return (0)
     VisRound -> Prelude.return (1)
unmarshallVisRoundFlags :: Int.Int16 -> Prelude.IO VisRoundFlags
unmarshallVisRoundFlags v =
  case v of
     0 -> Prelude.return (VisTruncate)
     1 -> Prelude.return (VisRound)
     _ -> Prelude.fail (Prelude.userError "unmarshallVisRoundFlags: illegal enum value ")
data VisRunTypes
 = VisCharPropRow
 | VisParaPropRow
 | VisTabPropRow
 | VisWordRun
 | VisParaRun
 | VisFieldRun
 
marshallVisRunTypes :: VisRunTypes -> Prelude.IO Int.Int16
marshallVisRunTypes v =
  case v of
     VisCharPropRow -> Prelude.return (1)
     VisParaPropRow -> Prelude.return (2)
     VisTabPropRow -> Prelude.return (3)
     VisWordRun -> Prelude.return (10)
     VisParaRun -> Prelude.return (11)
     VisFieldRun -> Prelude.return (20)
unmarshallVisRunTypes :: Int.Int16 -> Prelude.IO VisRunTypes
unmarshallVisRunTypes v =
  case v of
     1 -> Prelude.return (VisCharPropRow)
     2 -> Prelude.return (VisParaPropRow)
     3 -> Prelude.return (VisTabPropRow)
     10 -> Prelude.return (VisWordRun)
     11 -> Prelude.return (VisParaRun)
     20 -> Prelude.return (VisFieldRun)
     _ -> Prelude.fail (Prelude.userError "unmarshallVisRunTypes: illegal enum value ")
data VisCharsBias
 = VisBiasLetVisioChoose
 | VisBiasLeft
 | VisBiasRight
 
marshallVisCharsBias :: VisCharsBias -> Prelude.IO Int.Int16
marshallVisCharsBias v =
  case v of
     VisBiasLetVisioChoose -> Prelude.return (0)
     VisBiasLeft -> Prelude.return (1)
     VisBiasRight -> Prelude.return (2)
unmarshallVisCharsBias :: Int.Int16 -> Prelude.IO VisCharsBias
unmarshallVisCharsBias v =
  case v of
     0 -> Prelude.return (VisBiasLetVisioChoose)
     1 -> Prelude.return (VisBiasLeft)
     2 -> Prelude.return (VisBiasRight)
     _ -> Prelude.fail (Prelude.userError "unmarshallVisCharsBias: illegal enum value ")
data VisToolbarFlavors
 = VisToolBarNone
 | VisToolBarOn
 | VisToolBarMSOffice
 | VisToolBarLotusSS
 
marshallVisToolbarFlavors :: VisToolbarFlavors -> Prelude.IO Int.Int16
marshallVisToolbarFlavors v =
  case v of
     VisToolBarNone -> Prelude.return ((-1))
     VisToolBarOn -> Prelude.return (0)
     VisToolBarMSOffice -> Prelude.return (0)
     VisToolBarLotusSS -> Prelude.return (0)
unmarshallVisToolbarFlavors :: Int.Int16 -> Prelude.IO VisToolbarFlavors
unmarshallVisToolbarFlavors v =
  case v of
     (-1) -> Prelude.return (VisToolBarNone)
     0 -> Prelude.return (VisToolBarOn)
     0 -> Prelude.return (VisToolBarMSOffice)
     0 -> Prelude.return (VisToolBarLotusSS)
     _ -> Prelude.fail (Prelude.userError "unmarshallVisToolbarFlavors: illegal enum value ")
data VisDrawSplineFlags
 = VisSplinePeriodic
 | VisSplineDoCircles
 | VisSplineAbrupt
 | VisSpline1D
 
marshallVisDrawSplineFlags :: VisDrawSplineFlags -> Prelude.IO Int.Int16
marshallVisDrawSplineFlags v =
  case v of
     VisSplinePeriodic -> Prelude.return (1)
     VisSplineDoCircles -> Prelude.return (2)
     VisSplineAbrupt -> Prelude.return (4)
     VisSpline1D -> Prelude.return (8)
unmarshallVisDrawSplineFlags :: Int.Int16 -> Prelude.IO VisDrawSplineFlags
unmarshallVisDrawSplineFlags v =
  case v of
     1 -> Prelude.return (VisSplinePeriodic)
     2 -> Prelude.return (VisSplineDoCircles)
     4 -> Prelude.return (VisSplineAbrupt)
     8 -> Prelude.return (VisSpline1D)
     _ -> Prelude.fail (Prelude.userError "unmarshallVisDrawSplineFlags: illegal enum value ")
data VisGuideTypes
 = VisPoint
 | VisHorz
 | VisVert
 
marshallVisGuideTypes :: VisGuideTypes -> Prelude.IO Int.Int16
marshallVisGuideTypes v =
  case v of
     VisPoint -> Prelude.return (1)
     VisHorz -> Prelude.return (2)
     VisVert -> Prelude.return (3)
unmarshallVisGuideTypes :: Int.Int16 -> Prelude.IO VisGuideTypes
unmarshallVisGuideTypes v =
  case v of
     1 -> Prelude.return (VisPoint)
     2 -> Prelude.return (VisHorz)
     3 -> Prelude.return (VisVert)
     _ -> Prelude.fail (Prelude.userError "unmarshallVisGuideTypes: illegal enum value ")
data VisFontAttributes
 = VisFontRaster
 | VisFontDevice
 | VisFontScalable
 | VisFont0Alias
 
marshallVisFontAttributes :: VisFontAttributes -> Prelude.IO Int.Int16
marshallVisFontAttributes v =
  case v of
     VisFontRaster -> Prelude.return (16)
     VisFontDevice -> Prelude.return (32)
     VisFontScalable -> Prelude.return (64)
     VisFont0Alias -> Prelude.return (128)
unmarshallVisFontAttributes :: Int.Int16 -> Prelude.IO VisFontAttributes
unmarshallVisFontAttributes v =
  case v of
     16 -> Prelude.return (VisFontRaster)
     32 -> Prelude.return (VisFontDevice)
     64 -> Prelude.return (VisFontScalable)
     128 -> Prelude.return (VisFont0Alias)
     _ -> Prelude.fail (Prelude.userError "unmarshallVisFontAttributes: illegal enum value ")
data VisStatCodes
 = VisStatNormal
 | VisStatAppHasShutdown
 | VisStatDeleted
 | VisStatTouched
 | VisStatClosed
 | VisStatSuspended
 
marshallVisStatCodes :: VisStatCodes -> Prelude.IO Int.Int16
marshallVisStatCodes v =
  case v of
     VisStatNormal -> Prelude.return (0)
     VisStatAppHasShutdown -> Prelude.return (1)
     VisStatDeleted -> Prelude.return (2)
     VisStatTouched -> Prelude.return (4)
     VisStatClosed -> Prelude.return (8)
     VisStatSuspended -> Prelude.return (16)
unmarshallVisStatCodes :: Int.Int16 -> Prelude.IO VisStatCodes
unmarshallVisStatCodes v =
  case v of
     0 -> Prelude.return (VisStatNormal)
     1 -> Prelude.return (VisStatAppHasShutdown)
     2 -> Prelude.return (VisStatDeleted)
     4 -> Prelude.return (VisStatTouched)
     8 -> Prelude.return (VisStatClosed)
     16 -> Prelude.return (VisStatSuspended)
     _ -> Prelude.fail (Prelude.userError "unmarshallVisStatCodes: illegal enum value ")
data VisEventCodes
 = VisEvtIDInval
 | VisEvtCodeInval
 | VisEvtCodeDocCreate
 | VisEvtCodeDocOpen
 | VisEvtCodeDocSave
 | VisEvtCodeDocSaveAs
 | VisEvtCodeDocRunning
 | VisEvtCodeDocDesign
 | VisEvtCodeBefDocSave
 | VisEvtCodeBefDocSaveAs
 | VisEvtCodeBefForcedFlush
 | VisEvtCodeAfterForcedFlush
 | VisEvtCodeWinSelChange
 | VisEvtCodeBefWinSelDel
 | VisEvtCodeBefWinPageTurn
 | VisEvtCodeWinPageTurn
 | VisEvtCodeShapeDelete
 | VisEvtCodeBefSelDel
 | VisEvtCodeSelAdded
 | VisEvtAdd
 | VisEvtDel
 | VisEvtMod
 | VisEvtWindow
 | VisEvtDoc
 | VisEvtStyle
 | VisEvtMaster
 | VisEvtPage
 | VisEvtLayer
 | VisEvtShape
 | VisEvtText
 | VisEvtConnect
 | VisEvtSection
 | VisEvtRow
 | VisEvtCell
 | VisEvtFormula
 | VisEvtApp
 | VisEvtAppActivate
 | VisEvtAppDeactivate
 | VisEvtObjActivate
 | VisEvtObjDeactivate
 | VisEvtBeforeQuit
 | VisEvtBeforeModal
 | VisEvtAfterModal
 | VisEvtWinActivate
 | VisEvtMarker
 | VisEvtNonePending
 | VisEvtIdle
 | VisEvtCode1stUser
 | VisEvtCodeLastUser
 | VisEvtCodeCreate
 | VisEvtCodeOpen
 | VisActCodeRunAddon
 | VisActCodeAdvise
 | VisEvtIdMostRecent
 
marshallVisEventCodes :: VisEventCodes -> Prelude.IO Int.Int16
marshallVisEventCodes v =
  case v of
     VisEvtIDInval -> Prelude.return ((-1))
     VisEvtCodeInval -> Prelude.return (0)
     VisEvtCodeDocCreate -> Prelude.return (1)
     VisEvtCodeDocOpen -> Prelude.return (2)
     VisEvtCodeDocSave -> Prelude.return (3)
     VisEvtCodeDocSaveAs -> Prelude.return (4)
     VisEvtCodeDocRunning -> Prelude.return (5)
     VisEvtCodeDocDesign -> Prelude.return (6)
     VisEvtCodeBefDocSave -> Prelude.return (7)
     VisEvtCodeBefDocSaveAs -> Prelude.return (8)
     VisEvtCodeBefForcedFlush -> Prelude.return (200)
     VisEvtCodeAfterForcedFlush -> Prelude.return (201)
     VisEvtCodeWinSelChange -> Prelude.return (701)
     VisEvtCodeBefWinSelDel -> Prelude.return (702)
     VisEvtCodeBefWinPageTurn -> Prelude.return (703)
     VisEvtCodeWinPageTurn -> Prelude.return (704)
     VisEvtCodeShapeDelete -> Prelude.return (801)
     VisEvtCodeBefSelDel -> Prelude.return (901)
     VisEvtCodeSelAdded -> Prelude.return (902)
     VisEvtAdd -> Prelude.return (32768)
     VisEvtDel -> Prelude.return (16384)
     VisEvtMod -> Prelude.return (8192)
     VisEvtWindow -> Prelude.return (1)
     VisEvtDoc -> Prelude.return (2)
     VisEvtStyle -> Prelude.return (4)
     VisEvtMaster -> Prelude.return (8)
     VisEvtPage -> Prelude.return (16)
     VisEvtLayer -> Prelude.return (32)
     VisEvtShape -> Prelude.return (64)
     VisEvtText -> Prelude.return (128)
     VisEvtConnect -> Prelude.return (256)
     VisEvtSection -> Prelude.return (512)
     VisEvtRow -> Prelude.return (1024)
     VisEvtCell -> Prelude.return (2048)
     VisEvtFormula -> Prelude.return (4096)
     VisEvtApp -> Prelude.return (4096)
     VisEvtAppActivate -> Prelude.return (1)
     VisEvtAppDeactivate -> Prelude.return (2)
     VisEvtObjActivate -> Prelude.return (4)
     VisEvtObjDeactivate -> Prelude.return (8)
     VisEvtBeforeQuit -> Prelude.return (16)
     VisEvtBeforeModal -> Prelude.return (32)
     VisEvtAfterModal -> Prelude.return (64)
     VisEvtWinActivate -> Prelude.return (128)
     VisEvtMarker -> Prelude.return (256)
     VisEvtNonePending -> Prelude.return (512)
     VisEvtIdle -> Prelude.return (1024)
     VisEvtCode1stUser -> Prelude.return (28672)
     VisEvtCodeLastUser -> Prelude.return (32767)
     VisEvtCodeCreate -> Prelude.return (1)
     VisEvtCodeOpen -> Prelude.return (2)
     VisActCodeRunAddon -> Prelude.return (1)
     VisActCodeAdvise -> Prelude.return (2)
     VisEvtIdMostRecent -> Prelude.return (0)
unmarshallVisEventCodes :: Int.Int16 -> Prelude.IO VisEventCodes
unmarshallVisEventCodes v =
  case v of
     (-1) -> Prelude.return (VisEvtIDInval)
     0 -> Prelude.return (VisEvtCodeInval)
     1 -> Prelude.return (VisEvtCodeDocCreate)
     2 -> Prelude.return (VisEvtCodeDocOpen)
     3 -> Prelude.return (VisEvtCodeDocSave)
     4 -> Prelude.return (VisEvtCodeDocSaveAs)
     5 -> Prelude.return (VisEvtCodeDocRunning)
     6 -> Prelude.return (VisEvtCodeDocDesign)
     7 -> Prelude.return (VisEvtCodeBefDocSave)
     8 -> Prelude.return (VisEvtCodeBefDocSaveAs)
     200 -> Prelude.return (VisEvtCodeBefForcedFlush)
     201 -> Prelude.return (VisEvtCodeAfterForcedFlush)
     701 -> Prelude.return (VisEvtCodeWinSelChange)
     702 -> Prelude.return (VisEvtCodeBefWinSelDel)
     703 -> Prelude.return (VisEvtCodeBefWinPageTurn)
     704 -> Prelude.return (VisEvtCodeWinPageTurn)
     801 -> Prelude.return (VisEvtCodeShapeDelete)
     901 -> Prelude.return (VisEvtCodeBefSelDel)
     902 -> Prelude.return (VisEvtCodeSelAdded)
     32768 -> Prelude.return (VisEvtAdd)
     16384 -> Prelude.return (VisEvtDel)
     8192 -> Prelude.return (VisEvtMod)
     1 -> Prelude.return (VisEvtWindow)
     2 -> Prelude.return (VisEvtDoc)
     4 -> Prelude.return (VisEvtStyle)
     8 -> Prelude.return (VisEvtMaster)
     16 -> Prelude.return (VisEvtPage)
     32 -> Prelude.return (VisEvtLayer)
     64 -> Prelude.return (VisEvtShape)
     128 -> Prelude.return (VisEvtText)
     256 -> Prelude.return (VisEvtConnect)
     512 -> Prelude.return (VisEvtSection)
     1024 -> Prelude.return (VisEvtRow)
     2048 -> Prelude.return (VisEvtCell)
     4096 -> Prelude.return (VisEvtFormula)
     4096 -> Prelude.return (VisEvtApp)
     1 -> Prelude.return (VisEvtAppActivate)
     2 -> Prelude.return (VisEvtAppDeactivate)
     4 -> Prelude.return (VisEvtObjActivate)
     8 -> Prelude.return (VisEvtObjDeactivate)
     16 -> Prelude.return (VisEvtBeforeQuit)
     32 -> Prelude.return (VisEvtBeforeModal)
     64 -> Prelude.return (VisEvtAfterModal)
     128 -> Prelude.return (VisEvtWinActivate)
     256 -> Prelude.return (VisEvtMarker)
     512 -> Prelude.return (VisEvtNonePending)
     1024 -> Prelude.return (VisEvtIdle)
     28672 -> Prelude.return (VisEvtCode1stUser)
     32767 -> Prelude.return (VisEvtCodeLastUser)
     1 -> Prelude.return (VisEvtCodeCreate)
     2 -> Prelude.return (VisEvtCodeOpen)
     1 -> Prelude.return (VisActCodeRunAddon)
     2 -> Prelude.return (VisActCodeAdvise)
     0 -> Prelude.return (VisEvtIdMostRecent)
     _ -> Prelude.fail (Prelude.userError "unmarshallVisEventCodes: illegal enum value ")
data VisObjectTypes
 = VisObjTypeUnknown
 | VisObjTypeApp
 | VisObjTypeCell
 | VisObjTypeChars
 | VisObjTypeConnect
 | VisObjTypeConnects
 | VisObjTypeDoc
 | VisObjTypeDocs
 | VisObjTypeMaster
 | VisObjTypeMasters
 | VisObjTypePage
 | VisObjTypePages
 | VisObjTypeSelection
 | VisObjTypeShape
 | VisObjTypeShapes
 | VisObjTypeStyle
 | VisObjTypeStyles
 | VisObjTypeWindow
 | VisObjTypeWindows
 | VisObjTypeLayer
 | VisObjTypeLayers
 | VisObjTypeFont
 | VisObjTypeFonts
 | VisObjTypeColor
 | VisObjTypeColors
 | VisObjTypeAddon
 | VisObjTypeAddons
 | VisObjTypeEvent
 | VisObjTypeEventList
 | VisObjTypeGlobal
 | VisObjTypeHyperlink
 | VisObjTypeOLEObjects
 | VisObjTypeOLEObject
 | VisObjTypePaths
 | VisObjTypePath
 | VisObjTypeCurve
 
marshallVisObjectTypes :: VisObjectTypes -> Prelude.IO Int.Int16
marshallVisObjectTypes v =
  case v of
     VisObjTypeUnknown -> Prelude.return (1)
     VisObjTypeApp -> Prelude.return (3)
     VisObjTypeCell -> Prelude.return (4)
     VisObjTypeChars -> Prelude.return (5)
     VisObjTypeConnect -> Prelude.return (8)
     VisObjTypeConnects -> Prelude.return (9)
     VisObjTypeDoc -> Prelude.return (10)
     VisObjTypeDocs -> Prelude.return (11)
     VisObjTypeMaster -> Prelude.return (12)
     VisObjTypeMasters -> Prelude.return (13)
     VisObjTypePage -> Prelude.return (14)
     VisObjTypePages -> Prelude.return (15)
     VisObjTypeSelection -> Prelude.return (16)
     VisObjTypeShape -> Prelude.return (17)
     VisObjTypeShapes -> Prelude.return (18)
     VisObjTypeStyle -> Prelude.return (19)
     VisObjTypeStyles -> Prelude.return (20)
     VisObjTypeWindow -> Prelude.return (21)
     VisObjTypeWindows -> Prelude.return (22)
     VisObjTypeLayer -> Prelude.return (25)
     VisObjTypeLayers -> Prelude.return (26)
     VisObjTypeFont -> Prelude.return (27)
     VisObjTypeFonts -> Prelude.return (28)
     VisObjTypeColor -> Prelude.return (29)
     VisObjTypeColors -> Prelude.return (30)
     VisObjTypeAddon -> Prelude.return (31)
     VisObjTypeAddons -> Prelude.return (32)
     VisObjTypeEvent -> Prelude.return (33)
     VisObjTypeEventList -> Prelude.return (34)
     VisObjTypeGlobal -> Prelude.return (36)
     VisObjTypeHyperlink -> Prelude.return (37)
     VisObjTypeOLEObjects -> Prelude.return (38)
     VisObjTypeOLEObject -> Prelude.return (39)
     VisObjTypePaths -> Prelude.return (40)
     VisObjTypePath -> Prelude.return (41)
     VisObjTypeCurve -> Prelude.return (42)
unmarshallVisObjectTypes :: Int.Int16 -> Prelude.IO VisObjectTypes
unmarshallVisObjectTypes v =
  case v of
     1 -> Prelude.return (VisObjTypeUnknown)
     3 -> Prelude.return (VisObjTypeApp)
     4 -> Prelude.return (VisObjTypeCell)
     5 -> Prelude.return (VisObjTypeChars)
     8 -> Prelude.return (VisObjTypeConnect)
     9 -> Prelude.return (VisObjTypeConnects)
     10 -> Prelude.return (VisObjTypeDoc)
     11 -> Prelude.return (VisObjTypeDocs)
     12 -> Prelude.return (VisObjTypeMaster)
     13 -> Prelude.return (VisObjTypeMasters)
     14 -> Prelude.return (VisObjTypePage)
     15 -> Prelude.return (VisObjTypePages)
     16 -> Prelude.return (VisObjTypeSelection)
     17 -> Prelude.return (VisObjTypeShape)
     18 -> Prelude.return (VisObjTypeShapes)
     19 -> Prelude.return (VisObjTypeStyle)
     20 -> Prelude.return (VisObjTypeStyles)
     21 -> Prelude.return (VisObjTypeWindow)
     22 -> Prelude.return (VisObjTypeWindows)
     25 -> Prelude.return (VisObjTypeLayer)
     26 -> Prelude.return (VisObjTypeLayers)
     27 -> Prelude.return (VisObjTypeFont)
     28 -> Prelude.return (VisObjTypeFonts)
     29 -> Prelude.return (VisObjTypeColor)
     30 -> Prelude.return (VisObjTypeColors)
     31 -> Prelude.return (VisObjTypeAddon)
     32 -> Prelude.return (VisObjTypeAddons)
     33 -> Prelude.return (VisObjTypeEvent)
     34 -> Prelude.return (VisObjTypeEventList)
     36 -> Prelude.return (VisObjTypeGlobal)
     37 -> Prelude.return (VisObjTypeHyperlink)
     38 -> Prelude.return (VisObjTypeOLEObjects)
     39 -> Prelude.return (VisObjTypeOLEObject)
     40 -> Prelude.return (VisObjTypePaths)
     41 -> Prelude.return (VisObjTypePath)
     42 -> Prelude.return (VisObjTypeCurve)
     _ -> Prelude.fail (Prelude.userError "unmarshallVisObjectTypes: illegal enum value ")
data VisFieldCategories
 = VisFCatCustom
 | VisFCatDateTime
 | VisFCatDocument
 | VisFCatGeometry
 | VisFCatObject
 | VisFCatPage
 | VisFCatNotes
 
marshallVisFieldCategories :: VisFieldCategories -> Prelude.IO Int.Int16
marshallVisFieldCategories v =
  case v of
     VisFCatCustom -> Prelude.return (0)
     VisFCatDateTime -> Prelude.return (1)
     VisFCatDocument -> Prelude.return (2)
     VisFCatGeometry -> Prelude.return (3)
     VisFCatObject -> Prelude.return (4)
     VisFCatPage -> Prelude.return (5)
     VisFCatNotes -> Prelude.return (6)
unmarshallVisFieldCategories :: Int.Int16 -> Prelude.IO VisFieldCategories
unmarshallVisFieldCategories v =
  case v of
     0 -> Prelude.return (VisFCatCustom)
     1 -> Prelude.return (VisFCatDateTime)
     2 -> Prelude.return (VisFCatDocument)
     3 -> Prelude.return (VisFCatGeometry)
     4 -> Prelude.return (VisFCatObject)
     5 -> Prelude.return (VisFCatPage)
     6 -> Prelude.return (VisFCatNotes)
     _ -> Prelude.fail (Prelude.userError "unmarshallVisFieldCategories: illegal enum value ")
data VisFieldCodes
 = VisFCodeCreateDate
 | VisFCodeCreateTime
 | VisFCodeCurrentDate
 | VisFCodeCurrentTime
 | VisFCodeEditDate
 | VisFCodeEditTime
 | VisFCodePrintDate
 | VisFCodePrintTime
 | VisFCodeCreator
 | VisFCodeDescription
 | VisFCodeDirectory
 | VisFCodeFileName
 | VisFCodeKeyWords
 | VisFCodeSubject
 | VisFCodeTitle
 | VisFCodeManager
 | VisFCodeCompany
 | VisFCodeCategory
 | VisFCodeHyperlinkBase
 | VisFCodeWidth
 | VisFCodeHeight
 | VisFCodeAngle
 | VisFCodeData1
 | VisFCodeData2
 | VisFCodeData3
 | VisFCodeObjectID
 | VisFCodeMasterName
 | VisFCodeObjectName
 | VisFCodeObjectType
 | VisFCodeBackgroundName
 | VisFCodePageName
 | VisFCodeNumberOfPages
 | VisFCodePageNumber
 
marshallVisFieldCodes :: VisFieldCodes -> Prelude.IO Int.Int16
marshallVisFieldCodes v =
  case v of
     VisFCodeCreateDate -> Prelude.return (0)
     VisFCodeCreateTime -> Prelude.return (1)
     VisFCodeCurrentDate -> Prelude.return (2)
     VisFCodeCurrentTime -> Prelude.return (3)
     VisFCodeEditDate -> Prelude.return (4)
     VisFCodeEditTime -> Prelude.return (5)
     VisFCodePrintDate -> Prelude.return (6)
     VisFCodePrintTime -> Prelude.return (7)
     VisFCodeCreator -> Prelude.return (0)
     VisFCodeDescription -> Prelude.return (1)
     VisFCodeDirectory -> Prelude.return (2)
     VisFCodeFileName -> Prelude.return (3)
     VisFCodeKeyWords -> Prelude.return (4)
     VisFCodeSubject -> Prelude.return (5)
     VisFCodeTitle -> Prelude.return (6)
     VisFCodeManager -> Prelude.return (7)
     VisFCodeCompany -> Prelude.return (8)
     VisFCodeCategory -> Prelude.return (9)
     VisFCodeHyperlinkBase -> Prelude.return (10)
     VisFCodeWidth -> Prelude.return (0)
     VisFCodeHeight -> Prelude.return (1)
     VisFCodeAngle -> Prelude.return (2)
     VisFCodeData1 -> Prelude.return (0)
     VisFCodeData2 -> Prelude.return (1)
     VisFCodeData3 -> Prelude.return (2)
     VisFCodeObjectID -> Prelude.return (3)
     VisFCodeMasterName -> Prelude.return (4)
     VisFCodeObjectName -> Prelude.return (5)
     VisFCodeObjectType -> Prelude.return (6)
     VisFCodeBackgroundName -> Prelude.return (0)
     VisFCodePageName -> Prelude.return (1)
     VisFCodeNumberOfPages -> Prelude.return (2)
     VisFCodePageNumber -> Prelude.return (3)
unmarshallVisFieldCodes :: Int.Int16 -> Prelude.IO VisFieldCodes
unmarshallVisFieldCodes v =
  case v of
     0 -> Prelude.return (VisFCodeCreateDate)
     1 -> Prelude.return (VisFCodeCreateTime)
     2 -> Prelude.return (VisFCodeCurrentDate)
     3 -> Prelude.return (VisFCodeCurrentTime)
     4 -> Prelude.return (VisFCodeEditDate)
     5 -> Prelude.return (VisFCodeEditTime)
     6 -> Prelude.return (VisFCodePrintDate)
     7 -> Prelude.return (VisFCodePrintTime)
     0 -> Prelude.return (VisFCodeCreator)
     1 -> Prelude.return (VisFCodeDescription)
     2 -> Prelude.return (VisFCodeDirectory)
     3 -> Prelude.return (VisFCodeFileName)
     4 -> Prelude.return (VisFCodeKeyWords)
     5 -> Prelude.return (VisFCodeSubject)
     6 -> Prelude.return (VisFCodeTitle)
     7 -> Prelude.return (VisFCodeManager)
     8 -> Prelude.return (VisFCodeCompany)
     9 -> Prelude.return (VisFCodeCategory)
     10 -> Prelude.return (VisFCodeHyperlinkBase)
     0 -> Prelude.return (VisFCodeWidth)
     1 -> Prelude.return (VisFCodeHeight)
     2 -> Prelude.return (VisFCodeAngle)
     0 -> Prelude.return (VisFCodeData1)
     1 -> Prelude.return (VisFCodeData2)
     2 -> Prelude.return (VisFCodeData3)
     3 -> Prelude.return (VisFCodeObjectID)
     4 -> Prelude.return (VisFCodeMasterName)
     5 -> Prelude.return (VisFCodeObjectName)
     6 -> Prelude.return (VisFCodeObjectType)
     0 -> Prelude.return (VisFCodeBackgroundName)
     1 -> Prelude.return (VisFCodePageName)
     2 -> Prelude.return (VisFCodeNumberOfPages)
     3 -> Prelude.return (VisFCodePageNumber)
     _ -> Prelude.fail (Prelude.userError "unmarshallVisFieldCodes: illegal enum value ")
data VisFieldFormats
 = VisFmtNumGenNoUnits
 | VisFmtNumGenDefUnits
 | VisFmt0PlNoUnits
 | VisFmt0PlDefUnits
 | VisFmt1PlNoUnits
 | VisFmt1PlDefUnits
 | VisFmt2PlNoUnits
 | VisFmt2PlDefUnits
 | VisFmt3PlNoUnits
 | VisFmt3PlDefUnits
 | VisFmtFeetAndInches
 | VisFmtRadians
 | VisFmtDegrees
 | VisFmtFeetAndInches1Pl
 | VisFmtFeetAndInches2Pl
 | VisFmtFraction1PlNoUnits
 | VisFmtFraction1PlDefUnits
 | VisFmtFraction2PlNoUnits
 | VisFmtFraction2PlDefUnits
 | VisFmtDateShort
 | VisFmtDateLong
 | VisFmtDateMDYY
 | VisFmtDateMMDDYY
 | VisFmtDateMmmDYYYY
 | VisFmtDateMmmmDYYYY
 | VisFmtDateDMYY
 | VisFmtDateDDMMYY
 | VisFmtDateDMMMYYYY
 | VisFmtDateDMMMMYYYY
 | VisFmtTimeGen
 | VisFmtTimeHMM
 | VisFmtTimeHHMM
 | VisFmtTimeHMM24
 | VisFmtTimeHHMM24
 | VisFmtTimeHMMAMPM
 | VisFmtTimeHHMMAMPM
 | VisFmtStrNormal
 | VisFmtStrLower
 | VisFmtStrUpper
 | VisFmtJDategggeXmXdXww
 | VisFmtJDateyyyyXmXdXww
 | VisFmtJDategggeXmXdX
 | VisFmtJDateyyyyXmXdX
 | VisFmtJDateyyyymd
 | VisFmtJDateyymmdd
 | VisFmtJDatehmmaxpx
 | VisFmtJDateaxpxhmm
 | VisFmtJDateaxpxhXmmX
 | VisFmtJDatehXmmX
 | VisFmtCDategggeXmmmmXdddd
 | VisFmtCDateggeXmmmmXdddd
 | VisFmtCDategeXmmmmXdddd
 
marshallVisFieldFormats :: VisFieldFormats -> Prelude.IO Int.Int16
marshallVisFieldFormats v =
  case v of
     VisFmtNumGenNoUnits -> Prelude.return (0)
     VisFmtNumGenDefUnits -> Prelude.return (1)
     VisFmt0PlNoUnits -> Prelude.return (2)
     VisFmt0PlDefUnits -> Prelude.return (3)
     VisFmt1PlNoUnits -> Prelude.return (4)
     VisFmt1PlDefUnits -> Prelude.return (5)
     VisFmt2PlNoUnits -> Prelude.return (6)
     VisFmt2PlDefUnits -> Prelude.return (7)
     VisFmt3PlNoUnits -> Prelude.return (8)
     VisFmt3PlDefUnits -> Prelude.return (9)
     VisFmtFeetAndInches -> Prelude.return (10)
     VisFmtRadians -> Prelude.return (11)
     VisFmtDegrees -> Prelude.return (12)
     VisFmtFeetAndInches1Pl -> Prelude.return (13)
     VisFmtFeetAndInches2Pl -> Prelude.return (14)
     VisFmtFraction1PlNoUnits -> Prelude.return (15)
     VisFmtFraction1PlDefUnits -> Prelude.return (16)
     VisFmtFraction2PlNoUnits -> Prelude.return (17)
     VisFmtFraction2PlDefUnits -> Prelude.return (18)
     VisFmtDateShort -> Prelude.return (20)
     VisFmtDateLong -> Prelude.return (21)
     VisFmtDateMDYY -> Prelude.return (22)
     VisFmtDateMMDDYY -> Prelude.return (23)
     VisFmtDateMmmDYYYY -> Prelude.return (24)
     VisFmtDateMmmmDYYYY -> Prelude.return (25)
     VisFmtDateDMYY -> Prelude.return (26)
     VisFmtDateDDMMYY -> Prelude.return (27)
     VisFmtDateDMMMYYYY -> Prelude.return (28)
     VisFmtDateDMMMMYYYY -> Prelude.return (29)
     VisFmtTimeGen -> Prelude.return (30)
     VisFmtTimeHMM -> Prelude.return (31)
     VisFmtTimeHHMM -> Prelude.return (32)
     VisFmtTimeHMM24 -> Prelude.return (33)
     VisFmtTimeHHMM24 -> Prelude.return (34)
     VisFmtTimeHMMAMPM -> Prelude.return (35)
     VisFmtTimeHHMMAMPM -> Prelude.return (36)
     VisFmtStrNormal -> Prelude.return (37)
     VisFmtStrLower -> Prelude.return (38)
     VisFmtStrUpper -> Prelude.return (39)
     VisFmtJDategggeXmXdXww -> Prelude.return (40)
     VisFmtJDateyyyyXmXdXww -> Prelude.return (41)
     VisFmtJDategggeXmXdX -> Prelude.return (42)
     VisFmtJDateyyyyXmXdX -> Prelude.return (43)
     VisFmtJDateyyyymd -> Prelude.return (44)
     VisFmtJDateyymmdd -> Prelude.return (45)
     VisFmtJDatehmmaxpx -> Prelude.return (46)
     VisFmtJDateaxpxhmm -> Prelude.return (47)
     VisFmtJDateaxpxhXmmX -> Prelude.return (48)
     VisFmtJDatehXmmX -> Prelude.return (49)
     VisFmtCDategggeXmmmmXdddd -> Prelude.return (50)
     VisFmtCDateggeXmmmmXdddd -> Prelude.return (51)
     VisFmtCDategeXmmmmXdddd -> Prelude.return (52)
unmarshallVisFieldFormats :: Int.Int16 -> Prelude.IO VisFieldFormats
unmarshallVisFieldFormats v =
  case v of
     0 -> Prelude.return (VisFmtNumGenNoUnits)
     1 -> Prelude.return (VisFmtNumGenDefUnits)
     2 -> Prelude.return (VisFmt0PlNoUnits)
     3 -> Prelude.return (VisFmt0PlDefUnits)
     4 -> Prelude.return (VisFmt1PlNoUnits)
     5 -> Prelude.return (VisFmt1PlDefUnits)
     6 -> Prelude.return (VisFmt2PlNoUnits)
     7 -> Prelude.return (VisFmt2PlDefUnits)
     8 -> Prelude.return (VisFmt3PlNoUnits)
     9 -> Prelude.return (VisFmt3PlDefUnits)
     10 -> Prelude.return (VisFmtFeetAndInches)
     11 -> Prelude.return (VisFmtRadians)
     12 -> Prelude.return (VisFmtDegrees)
     13 -> Prelude.return (VisFmtFeetAndInches1Pl)
     14 -> Prelude.return (VisFmtFeetAndInches2Pl)
     15 -> Prelude.return (VisFmtFraction1PlNoUnits)
     16 -> Prelude.return (VisFmtFraction1PlDefUnits)
     17 -> Prelude.return (VisFmtFraction2PlNoUnits)
     18 -> Prelude.return (VisFmtFraction2PlDefUnits)
     20 -> Prelude.return (VisFmtDateShort)
     21 -> Prelude.return (VisFmtDateLong)
     22 -> Prelude.return (VisFmtDateMDYY)
     23 -> Prelude.return (VisFmtDateMMDDYY)
     24 -> Prelude.return (VisFmtDateMmmDYYYY)
     25 -> Prelude.return (VisFmtDateMmmmDYYYY)
     26 -> Prelude.return (VisFmtDateDMYY)
     27 -> Prelude.return (VisFmtDateDDMMYY)
     28 -> Prelude.return (VisFmtDateDMMMYYYY)
     29 -> Prelude.return (VisFmtDateDMMMMYYYY)
     30 -> Prelude.return (VisFmtTimeGen)
     31 -> Prelude.return (VisFmtTimeHMM)
     32 -> Prelude.return (VisFmtTimeHHMM)
     33 -> Prelude.return (VisFmtTimeHMM24)
     34 -> Prelude.return (VisFmtTimeHHMM24)
     35 -> Prelude.return (VisFmtTimeHMMAMPM)
     36 -> Prelude.return (VisFmtTimeHHMMAMPM)
     37 -> Prelude.return (VisFmtStrNormal)
     38 -> Prelude.return (VisFmtStrLower)
     39 -> Prelude.return (VisFmtStrUpper)
     40 -> Prelude.return (VisFmtJDategggeXmXdXww)
     41 -> Prelude.return (VisFmtJDateyyyyXmXdXww)
     42 -> Prelude.return (VisFmtJDategggeXmXdX)
     43 -> Prelude.return (VisFmtJDateyyyyXmXdX)
     44 -> Prelude.return (VisFmtJDateyyyymd)
     45 -> Prelude.return (VisFmtJDateyymmdd)
     46 -> Prelude.return (VisFmtJDatehmmaxpx)
     47 -> Prelude.return (VisFmtJDateaxpxhmm)
     48 -> Prelude.return (VisFmtJDateaxpxhXmmX)
     49 -> Prelude.return (VisFmtJDatehXmmX)
     50 -> Prelude.return (VisFmtCDategggeXmmmmXdddd)
     51 -> Prelude.return (VisFmtCDateggeXmmmmXdddd)
     52 -> Prelude.return (VisFmtCDategeXmmmmXdddd)
     _ -> Prelude.fail (Prelude.userError "unmarshallVisFieldFormats: illegal enum value ")
data VisDocVersions
 = VisVersionUnsaved
 | VisVersion10
 | VisVersion20
 | VisVersion30
 | VisVersion40
 | VisVersion50
 
marshallVisDocVersions :: VisDocVersions -> Prelude.IO Int.Int16
marshallVisDocVersions v =
  case v of
     VisVersionUnsaved -> Prelude.return (0)
     VisVersion10 -> Prelude.return (65571)
     VisVersion20 -> Prelude.return (131072)
     VisVersion30 -> Prelude.return (196611)
     VisVersion40 -> Prelude.return (262144)
     VisVersion50 -> Prelude.return (327680)
unmarshallVisDocVersions :: Int.Int16 -> Prelude.IO VisDocVersions
unmarshallVisDocVersions v =
  case v of
     0 -> Prelude.return (VisVersionUnsaved)
     65571 -> Prelude.return (VisVersion10)
     131072 -> Prelude.return (VisVersion20)
     196611 -> Prelude.return (VisVersion30)
     262144 -> Prelude.return (VisVersion40)
     327680 -> Prelude.return (VisVersion50)
     _ -> Prelude.fail (Prelude.userError "unmarshallVisDocVersions: illegal enum value ")
data VisMasterProperties
 = VisLeft
 | VisCenter
 | VisRight
 | VisIconFormatVisio
 | VisIconFormatBMP
 | VisNormal
 | VisTall
 | VisWide
 | VisDouble
 | VisAutomatic
 | VisManual
 | VisMasIsLinePat
 | VisMasIsLineEnd
 | VisMasIsFillPat
 | VisMasLPTileDeform
 | VisMasLPTile
 | VisMasLPStretch
 | VisMasLPAnnotate
 | VisMasLPScale
 | VisMasLEDefault
 | VisMasLEUpright
 | VisMasLEScale
 | VisMasFPTile
 | VisMasFPCenter
 | VisMasFPStretch
 | VisMasFPScale
 
marshallVisMasterProperties :: VisMasterProperties -> Prelude.IO Int.Int16
marshallVisMasterProperties v =
  case v of
     VisLeft -> Prelude.return (1)
     VisCenter -> Prelude.return (2)
     VisRight -> Prelude.return (3)
     VisIconFormatVisio -> Prelude.return (0)
     VisIconFormatBMP -> Prelude.return (2)
     VisNormal -> Prelude.return (1)
     VisTall -> Prelude.return (2)
     VisWide -> Prelude.return (3)
     VisDouble -> Prelude.return (4)
     VisAutomatic -> Prelude.return (1)
     VisManual -> Prelude.return (0)
     VisMasIsLinePat -> Prelude.return (1)
     VisMasIsLineEnd -> Prelude.return (2)
     VisMasIsFillPat -> Prelude.return (4)
     VisMasLPTileDeform -> Prelude.return (0)
     VisMasLPTile -> Prelude.return (16)
     VisMasLPStretch -> Prelude.return (32)
     VisMasLPAnnotate -> Prelude.return (48)
     VisMasLPScale -> Prelude.return (64)
     VisMasLEDefault -> Prelude.return (0)
     VisMasLEUpright -> Prelude.return (256)
     VisMasLEScale -> Prelude.return (1024)
     VisMasFPTile -> Prelude.return (0)
     VisMasFPCenter -> Prelude.return (4096)
     VisMasFPStretch -> Prelude.return (8192)
     VisMasFPScale -> Prelude.return (16384)
unmarshallVisMasterProperties :: Int.Int16 -> Prelude.IO VisMasterProperties
unmarshallVisMasterProperties v =
  case v of
     1 -> Prelude.return (VisLeft)
     2 -> Prelude.return (VisCenter)
     3 -> Prelude.return (VisRight)
     0 -> Prelude.return (VisIconFormatVisio)
     2 -> Prelude.return (VisIconFormatBMP)
     1 -> Prelude.return (VisNormal)
     2 -> Prelude.return (VisTall)
     3 -> Prelude.return (VisWide)
     4 -> Prelude.return (VisDouble)
     1 -> Prelude.return (VisAutomatic)
     0 -> Prelude.return (VisManual)
     1 -> Prelude.return (VisMasIsLinePat)
     2 -> Prelude.return (VisMasIsLineEnd)
     4 -> Prelude.return (VisMasIsFillPat)
     0 -> Prelude.return (VisMasLPTileDeform)
     16 -> Prelude.return (VisMasLPTile)
     32 -> Prelude.return (VisMasLPStretch)
     48 -> Prelude.return (VisMasLPAnnotate)
     64 -> Prelude.return (VisMasLPScale)
     0 -> Prelude.return (VisMasLEDefault)
     256 -> Prelude.return (VisMasLEUpright)
     1024 -> Prelude.return (VisMasLEScale)
     0 -> Prelude.return (VisMasFPTile)
     4096 -> Prelude.return (VisMasFPCenter)
     8192 -> Prelude.return (VisMasFPStretch)
     16384 -> Prelude.return (VisMasFPScale)
     _ -> Prelude.fail (Prelude.userError "unmarshallVisMasterProperties: illegal enum value ")
data VisFromParts
 = VisConnectFromError
 | VisFromNone
 | VisLeftEdge
 | VisCenterEdge
 | VisRightEdge
 | VisBottomEdge
 | VisMiddleEdge
 | VisTopEdge
 | VisBeginX
 | VisBeginY
 | VisBegin
 | VisEndX
 | VisEndY
 | VisEnd
 | VisControlPoint
 
marshallVisFromParts :: VisFromParts -> Prelude.IO Int.Int16
marshallVisFromParts v =
  case v of
     VisConnectFromError -> Prelude.return ((-1))
     VisFromNone -> Prelude.return (0)
     VisLeftEdge -> Prelude.return (1)
     VisCenterEdge -> Prelude.return (2)
     VisRightEdge -> Prelude.return (3)
     VisBottomEdge -> Prelude.return (4)
     VisMiddleEdge -> Prelude.return (5)
     VisTopEdge -> Prelude.return (6)
     VisBeginX -> Prelude.return (7)
     VisBeginY -> Prelude.return (8)
     VisBegin -> Prelude.return (9)
     VisEndX -> Prelude.return (10)
     VisEndY -> Prelude.return (11)
     VisEnd -> Prelude.return (12)
     VisControlPoint -> Prelude.return (100)
unmarshallVisFromParts :: Int.Int16 -> Prelude.IO VisFromParts
unmarshallVisFromParts v =
  case v of
     (-1) -> Prelude.return (VisConnectFromError)
     0 -> Prelude.return (VisFromNone)
     1 -> Prelude.return (VisLeftEdge)
     2 -> Prelude.return (VisCenterEdge)
     3 -> Prelude.return (VisRightEdge)
     4 -> Prelude.return (VisBottomEdge)
     5 -> Prelude.return (VisMiddleEdge)
     6 -> Prelude.return (VisTopEdge)
     7 -> Prelude.return (VisBeginX)
     8 -> Prelude.return (VisBeginY)
     9 -> Prelude.return (VisBegin)
     10 -> Prelude.return (VisEndX)
     11 -> Prelude.return (VisEndY)
     12 -> Prelude.return (VisEnd)
     100 -> Prelude.return (VisControlPoint)
     _ -> Prelude.fail (Prelude.userError "unmarshallVisFromParts: illegal enum value ")
data VisToParts
 = VisConnectToError
 | VisToNone
 | VisGuideX
 | VisGuideY
 | VisWholeShape
 | VisConnectionPoint
 | VisConnectError
 | VisNone
 
marshallVisToParts :: VisToParts -> Prelude.IO Int.Int16
marshallVisToParts v =
  case v of
     VisConnectToError -> Prelude.return ((-1))
     VisToNone -> Prelude.return (0)
     VisGuideX -> Prelude.return (1)
     VisGuideY -> Prelude.return (2)
     VisWholeShape -> Prelude.return (3)
     VisConnectionPoint -> Prelude.return (100)
     VisConnectError -> Prelude.return ((-1))
     VisNone -> Prelude.return (0)
unmarshallVisToParts :: Int.Int16 -> Prelude.IO VisToParts
unmarshallVisToParts v =
  case v of
     (-1) -> Prelude.return (VisConnectToError)
     0 -> Prelude.return (VisToNone)
     1 -> Prelude.return (VisGuideX)
     2 -> Prelude.return (VisGuideY)
     3 -> Prelude.return (VisWholeShape)
     100 -> Prelude.return (VisConnectionPoint)
     (-1) -> Prelude.return (VisConnectError)
     0 -> Prelude.return (VisNone)
     _ -> Prelude.fail (Prelude.userError "unmarshallVisToParts: illegal enum value ")
data VisUIObjSets
 = VisUIObjSetNoDocument
 | VisUIObjSetDrawing
 | VisUIObjSetStencil
 | VisUIObjSetShapeSheet
 | VisUIObjSetIcon
 | VisUIObjSetInPlace
 | VisUIObjSetPrintPreview
 | VisUIObjSetText
 | VisUIObjSetCntx_DrawObjSel
 | VisUIObjSetCntx_DrawOleObjSel
 | VisUIObjSetCntx_DrawNoObjSel
 | VisUIObjSetCntx_InPlaceNoObj
 | VisUIObjSetCntx_TextEdit
 | VisUIObjSetCntx_StencilRO
 | VisUIObjSetCntx_ShapeSheet
 | VisUIObjSetCntx_Toolbar
 | VisUIObjSetCntx_FullScreen
 | VisUIObjSetBinderInPlace
 | VisUIObjSetCntx_Debug
 | VisUIObjSetCntx_StencilRW
 | VisUIObjSetCntx_StencilDocked
 | VisUIObjSetHostingInPlace
 | VisUIObjSetCntx_Hyperlink
 | VisUIObjSetPal_LineColors
 | VisUIObjSetPal_LineWeights
 | VisUIObjSetPal_LinePatterns
 | VisUIObjSetPal_FillColors
 | VisUIObjSetPal_FillPatterns
 | VisUIObjSetPal_TextColors
 | VisUIObjSetPal_AlignShapes
 | VisUIObjSetPal_DistributeShapes
 | VisUIObjSetPal_Shadow
 | VisUIObjSetPal_LineEnds
 | VisUIObjSetPal_CornerRounding
 
marshallVisUIObjSets :: VisUIObjSets -> Prelude.IO Int.Int16
marshallVisUIObjSets v =
  case v of
     VisUIObjSetNoDocument -> Prelude.return (1)
     VisUIObjSetDrawing -> Prelude.return (2)
     VisUIObjSetStencil -> Prelude.return (3)
     VisUIObjSetShapeSheet -> Prelude.return (4)
     VisUIObjSetIcon -> Prelude.return (5)
     VisUIObjSetInPlace -> Prelude.return (6)
     VisUIObjSetPrintPreview -> Prelude.return (7)
     VisUIObjSetText -> Prelude.return (8)
     VisUIObjSetCntx_DrawObjSel -> Prelude.return (9)
     VisUIObjSetCntx_DrawOleObjSel -> Prelude.return (10)
     VisUIObjSetCntx_DrawNoObjSel -> Prelude.return (11)
     VisUIObjSetCntx_InPlaceNoObj -> Prelude.return (12)
     VisUIObjSetCntx_TextEdit -> Prelude.return (13)
     VisUIObjSetCntx_StencilRO -> Prelude.return (14)
     VisUIObjSetCntx_ShapeSheet -> Prelude.return (15)
     VisUIObjSetCntx_Toolbar -> Prelude.return (16)
     VisUIObjSetCntx_FullScreen -> Prelude.return (17)
     VisUIObjSetBinderInPlace -> Prelude.return (18)
     VisUIObjSetCntx_Debug -> Prelude.return (19)
     VisUIObjSetCntx_StencilRW -> Prelude.return (20)
     VisUIObjSetCntx_StencilDocked -> Prelude.return (21)
     VisUIObjSetHostingInPlace -> Prelude.return (22)
     VisUIObjSetCntx_Hyperlink -> Prelude.return (23)
     VisUIObjSetPal_LineColors -> Prelude.return (24)
     VisUIObjSetPal_LineWeights -> Prelude.return (25)
     VisUIObjSetPal_LinePatterns -> Prelude.return (26)
     VisUIObjSetPal_FillColors -> Prelude.return (27)
     VisUIObjSetPal_FillPatterns -> Prelude.return (28)
     VisUIObjSetPal_TextColors -> Prelude.return (29)
     VisUIObjSetPal_AlignShapes -> Prelude.return (30)
     VisUIObjSetPal_DistributeShapes -> Prelude.return (31)
     VisUIObjSetPal_Shadow -> Prelude.return (32)
     VisUIObjSetPal_LineEnds -> Prelude.return (33)
     VisUIObjSetPal_CornerRounding -> Prelude.return (34)
unmarshallVisUIObjSets :: Int.Int16 -> Prelude.IO VisUIObjSets
unmarshallVisUIObjSets v =
  case v of
     1 -> Prelude.return (VisUIObjSetNoDocument)
     2 -> Prelude.return (VisUIObjSetDrawing)
     3 -> Prelude.return (VisUIObjSetStencil)
     4 -> Prelude.return (VisUIObjSetShapeSheet)
     5 -> Prelude.return (VisUIObjSetIcon)
     6 -> Prelude.return (VisUIObjSetInPlace)
     7 -> Prelude.return (VisUIObjSetPrintPreview)
     8 -> Prelude.return (VisUIObjSetText)
     9 -> Prelude.return (VisUIObjSetCntx_DrawObjSel)
     10 -> Prelude.return (VisUIObjSetCntx_DrawOleObjSel)
     11 -> Prelude.return (VisUIObjSetCntx_DrawNoObjSel)
     12 -> Prelude.return (VisUIObjSetCntx_InPlaceNoObj)
     13 -> Prelude.return (VisUIObjSetCntx_TextEdit)
     14 -> Prelude.return (VisUIObjSetCntx_StencilRO)
     15 -> Prelude.return (VisUIObjSetCntx_ShapeSheet)
     16 -> Prelude.return (VisUIObjSetCntx_Toolbar)
     17 -> Prelude.return (VisUIObjSetCntx_FullScreen)
     18 -> Prelude.return (VisUIObjSetBinderInPlace)
     19 -> Prelude.return (VisUIObjSetCntx_Debug)
     20 -> Prelude.return (VisUIObjSetCntx_StencilRW)
     21 -> Prelude.return (VisUIObjSetCntx_StencilDocked)
     22 -> Prelude.return (VisUIObjSetHostingInPlace)
     23 -> Prelude.return (VisUIObjSetCntx_Hyperlink)
     24 -> Prelude.return (VisUIObjSetPal_LineColors)
     25 -> Prelude.return (VisUIObjSetPal_LineWeights)
     26 -> Prelude.return (VisUIObjSetPal_LinePatterns)
     27 -> Prelude.return (VisUIObjSetPal_FillColors)
     28 -> Prelude.return (VisUIObjSetPal_FillPatterns)
     29 -> Prelude.return (VisUIObjSetPal_TextColors)
     30 -> Prelude.return (VisUIObjSetPal_AlignShapes)
     31 -> Prelude.return (VisUIObjSetPal_DistributeShapes)
     32 -> Prelude.return (VisUIObjSetPal_Shadow)
     33 -> Prelude.return (VisUIObjSetPal_LineEnds)
     34 -> Prelude.return (VisUIObjSetPal_CornerRounding)
     _ -> Prelude.fail (Prelude.userError "unmarshallVisUIObjSets: illegal enum value ")
data VisUICmds
 = VisCmdHierarchical
 | VisCmdFileNew
 | VisCmdFileOpen
 | VisCmdFileClose
 | VisCmdFileSave
 | VisCmdFileSaveAs
 | VisCmdFileSaveWorkspace
 | VisCmdFileImport
 | VisCmdFileSummaryInfoDlg
 | VisCmdFilePrint
 | VisCmdFileExit
 | VisCmdEditUndo
 | VisCmdEditRedo
 | VisCmdEditRepeat
 | VisCmdUFEditCut
 | VisCmdUFEditCopy
 | VisCmdUFEditPaste
 | VisCmdUFEditClear
 | VisCmdUFEditDuplicate
 | VisCmdUFEditSelectAll
 | VisCmdEditSelectSpecial
 | VisCmdEditPasteSpecial
 | VisCmdEditOpenObject
 | VisCmdEditLinks
 | VisCmdEditInsertObject
 | VisCmdEditInsertField
 | VisCmdViewFitInWindow
 | VisCmdView75
 | VisCmdView100
 | VisCmdView150
 | VisCmdView200
 | VisCmdViewCustom
 | VisCmdViewRulers
 | VisCmdViewGrid
 | VisCmdViewGuides
 | VisCmdViewConnections
 | VisCmdEditFind
 | VisCmdViewStatusBar
 | VisCmdObjectBringForward
 | VisCmdObjectBringToFront
 | VisCmdObjectSendBackward
 | VisCmdObjectSendToBack
 | VisCmdObjectAlignObjects
 | VisCmdObjectConnectObjects
 | VisCmdObjectGroup
 | VisCmdObjectUngroup
 | VisCmdObjectAddToGroup
 | VisCmdObjectRemoveFromGroup
 | VisCmdObjectConvertToGroup
 | VisCmdObjectRotate90
 | VisCmdObjectFlipVertical
 | VisCmdObjectFlipHorizontal
 | VisCmdObjectReverse
 | VisCmdObjectUnion
 | VisCmdObjectCombine
 | VisCmdObjectFragment
 | VisCmdFormatStyle
 | VisCmdFormatDefineStyles
 | VisCmdFormatLine
 | VisCmdFormatFill
 | VisCmdFormatText
 | VisCmdFormatFont
 | VisCmdFormatParagraph
 | VisCmdFormatTabs
 | VisCmdFormatBlock
 | VisCmdFormatBehavior
 | VisCmdFormatProtection
 | VisCmdFormatSpecial
 | VisCmdOptionsEditDrawing
 | VisCmdOptionsEditBackground
 | VisCmdOptionsPageSetup
 | VisCmdOptionsGoToDrawing
 | VisCmdOptionsNewPage
 | VisCmdOptionsDeletePages
 | VisCmdOptionsReorderPages
 | VisCmdOptionsPreferences
 | VisCmdOptionsColorPaletteDlg
 | VisCmdOptionsProtectDocument
 | VisCmdOptionsSnapGlueSetup
 | VisCmdWindowNewWindow
 | VisCmdWindowCascadeAll
 | VisCmdWindowTileAll
 | VisCmdWindowShowShapeSheet
 | VisCmdWindowShowMasterObjects
 | VisCmdRunAddOnMenu
 | VisCmdWindowShowDrawPage
 | VisCmdHelpContents
 | VisCmdDecreaseIndent
 | VisCmdIncreaseIndent
 | VisCmdDecreaseParaSpacing
 | VisCmdIncreaseParaSpacing
 | VisCmdTextRotate90
 | VisCmdHelpAboutVisio
 | VisCmdStenEditIcon
 | VisCmdStenEditDrawing
 | VisCmdStenNameMaster
 | VisCmdStenNewMaster
 | VisCmdStenImageMaster
 | VisCmdStenCleanup
 | VisCmdSWShowValues
 | VisCmdSWShowFormulas
 | VisCmdSWShowSectionsDlg
 | VisCmdSWPasteNameDlg
 | VisCmdSWPasteFunctionDlg
 | VisCmdSWInsertRow
 | VisCmdSWInsertRowAfter
 | VisCmdSWChangeRowTypeDlg
 | VisCmdSWDeleteRow
 | VisCmdSWAddSectionDlg
 | VisCmdSWDeleteSection
 | VisCmdFormatDoubleClick
 | VisCmdDrawLineStyle
 | VisCmdDrawFillStyle
 | VisCmdDrawSnap
 | VisCmdDrawGlue
 | VisCmdDrawZoom
 | VisCmdTextStyle
 | VisCmdTextFont
 | VisCmdTextSize
 | VisCmdTextBold
 | VisCmdTextItalic
 | VisCmdTextSmallCaps
 | VisCmdTextSuperscript
 | VisCmdTextSubscript
 | VisCmdTextUline
 | VisCmdSWCancel
 | VisCmdSWAccept
 | VisCmdSWFormula
 | VisCmdSWShowToggle
 | VisCmdIconLeftColor
 | VisCmdIconPencilTool
 | VisCmdRecalcObjectWH
 | VisCmdTurnToPrevPage
 | VisCmdTurnToNextPage
 | VisCmdEditReplace
 | VisCmdAlignObjectLeft
 | VisCmdAlignObjectCenter
 | VisCmdAlignObjectRight
 | VisCmdAlignObjectTop
 | VisCmdAlignObjectMiddle
 | VisCmdAlignObjectBottom
 | VisCmdCenterDrawing
 | VisCmdDeselectAll
 | VisCmdTextEditState
 | VisCmdZoomIn
 | VisCmdZoomOut
 | VisCmdDRPointerTool
 | VisCmdDRPencilTool
 | VisCmdDRLineTool
 | VisCmdDRQtrArcTool
 | VisCmdDRRectTool
 | VisCmdDROvalTool
 | VisCmdDRConnectorTool
 | VisCmdDRConnectionTool
 | VisCmdDRTextTool
 | VisCmdDRRotateTool
 | VisCmdObjectDistributeDlg
 | VisCmdDistributeHSpace
 | VisCmdDistributeCenter
 | VisCmdDistributeVSpace
 | VisCmdDistributeMiddle
 | VisCmdDlgLotusNotesFields
 | VisCmdToolsSpelling
 | VisCmdFormatPainter
 | VisCmdStenFloating
 | VisCmdView50
 | VisCmdView400
 | VisCmdSendAsMail
 | VisCmdShapeActions
 | VisCmdDRSplineTool
 | VisCmdFormatCustPropEdit
 | VisCmdRulerGridDlg
 | VisCmdFormatShadow
 | VisCmdFormatCorners
 | VisCmdToolsInventory
 | VisCmdPageSizeScale
 | VisCmdStenSwitchSides
 | VisCmdToolsArrayShapesAddOn
 | VisCmdSetLineWeight
 | VisCmdSetLinePattern
 | VisCmdSetLineEnds
 | VisCmdSetLineCornerStyle
 | VisCmdSetLineColor
 | VisCmdCloseWindow
 | VisCmdSetFillShadow
 | VisCmdSetFillColor
 | VisCmdHelpMode
 | VisCmdOffsetDlg
 | VisCmdDesignMode
 | VisCmdShapeExplorer
 | VisCmdSetFillPattern
 | VisCmdSetCharColor
 | VisCmdSetCharSizeUp
 | VisCmdSetCharSizeDown
 | VisCmdTextHAlignLeft
 | VisCmdTextHAlignCenter
 | VisCmdTextHAlignRight
 | VisCmdTextHAlignJustify
 | VisCmdTextVAlignTop
 | VisCmdTextVAlignMiddle
 | VisCmdTextVAlignBottom
 | VisCmdStampTool
 | VisCmdObjectInfoDlg
 | VisCmdObjectHelp
 | VisCmdFileOpenStencil
 | VisCmdPrintPage
 | VisCmdSWShapeActionDlg
 | VisCmdLayerDlg
 | VisCmdLayerSetupDlg
 | VisCmdCropTool
 | VisCmdTextBlockTool
 | VisCmdStenClose
 | VisCmdIntersect
 | VisCmdSubtract
 | VisCmdStenActivate
 | VisCmdStenIconAndName
 | VisCmdStenIconOnly
 | VisCmdStenNameOnly
 | VisCmdStenAutoArrange
 | VisCmdPrintPreview
 | VisCmdOpenInVisio
 | VisCmdFullScreenMode
 | VisCmdRotate90Clockwise
 | VisCmdZoomLast
 | VisCmdZoomPageWidth
 | VisCmdToolbarsDlg
 | VisCmdINETAddToFavorites
 | VisCmdViewPageBreaks
 | VisCmdZoomSingleTile
 | VisCmdPreviousTile
 | VisCmdNextTile
 | VisCmdFirstTile
 | VisCmdLastTile
 | VisCmdInsertAutoCADAddOn
 | VisCmdInsertControlDlg
 | VisCmdJoin
 | VisCmdTrim
 | VisCmdDlgCustomFit
 | VisCmdFitCurve
 | VisCmdIconBucketTool
 | VisCmdIconLassoTool
 | VisCmdIconSelectNet
 | VisCmdToolsLayoutShapesDlg
 | VisCmdToolsRunVBE
 | VisCmdToolsMacroDlg
 | VisCmdFileNewBlankDrawing
 | VisCmdFileNewBlankStencil
 | VisCmdProgRefHelp
 | VisCmdInsertHyperLink
 | VisCmdHelpTemplates
 | VisCmdEmailRouting
 | VisCmdSendToExchange
 | VisCmdINETUserSearchPage
 | VisCmdINETVisioHomePage
 | VisCmdINETGoForward
 | VisCmdINETGoBack
 | VisCmdOpenActiveObject
 | VisCmdCancelInPlaceEditing
 | VisCmdINETVisioSolutionsLibrary
 | VisCmdINETKnowledgeBase
 | VisCmdINETDiagrammingResources
 | VisCmdINETOpenHlink
 | VisCmdINETOpenHlinkNewWnd
 | VisCmdINETCopyHyperlink
 | VisCmdHyperlinkHier
 | VisCmdINETEditHyperlink
 | VisCmdINETPasteAsHyperlink
 | VisCmdBullets
 | VisCmdShapeLayerToolbar
 | VisCmdGoToPageToolbar
 | VisCmdFormatAllTextProps
 | VisCmdBrowseSampleDrawings
 
marshallVisUICmds :: VisUICmds -> Prelude.IO Int.Int16
marshallVisUICmds v =
  case v of
     VisCmdHierarchical -> Prelude.return (200)
     VisCmdFileNew -> Prelude.return (1001)
     VisCmdFileOpen -> Prelude.return (1002)
     VisCmdFileClose -> Prelude.return (1003)
     VisCmdFileSave -> Prelude.return (1004)
     VisCmdFileSaveAs -> Prelude.return (1005)
     VisCmdFileSaveWorkspace -> Prelude.return (1006)
     VisCmdFileImport -> Prelude.return (1007)
     VisCmdFileSummaryInfoDlg -> Prelude.return (1009)
     VisCmdFilePrint -> Prelude.return (1010)
     VisCmdFileExit -> Prelude.return (1016)
     VisCmdEditUndo -> Prelude.return (1017)
     VisCmdEditRedo -> Prelude.return (1018)
     VisCmdEditRepeat -> Prelude.return (1019)
     VisCmdUFEditCut -> Prelude.return (1020)
     VisCmdUFEditCopy -> Prelude.return (1021)
     VisCmdUFEditPaste -> Prelude.return (1022)
     VisCmdUFEditClear -> Prelude.return (1023)
     VisCmdUFEditDuplicate -> Prelude.return (1024)
     VisCmdUFEditSelectAll -> Prelude.return (1025)
     VisCmdEditSelectSpecial -> Prelude.return (1026)
     VisCmdEditPasteSpecial -> Prelude.return (1027)
     VisCmdEditOpenObject -> Prelude.return (1029)
     VisCmdEditLinks -> Prelude.return (1030)
     VisCmdEditInsertObject -> Prelude.return (1031)
     VisCmdEditInsertField -> Prelude.return (1032)
     VisCmdViewFitInWindow -> Prelude.return (1033)
     VisCmdView75 -> Prelude.return (1034)
     VisCmdView100 -> Prelude.return (1035)
     VisCmdView150 -> Prelude.return (1036)
     VisCmdView200 -> Prelude.return (1037)
     VisCmdViewCustom -> Prelude.return (1038)
     VisCmdViewRulers -> Prelude.return (1039)
     VisCmdViewGrid -> Prelude.return (1040)
     VisCmdViewGuides -> Prelude.return (1041)
     VisCmdViewConnections -> Prelude.return (1042)
     VisCmdEditFind -> Prelude.return (1043)
     VisCmdViewStatusBar -> Prelude.return (1044)
     VisCmdObjectBringForward -> Prelude.return (1045)
     VisCmdObjectBringToFront -> Prelude.return (1046)
     VisCmdObjectSendBackward -> Prelude.return (1047)
     VisCmdObjectSendToBack -> Prelude.return (1048)
     VisCmdObjectAlignObjects -> Prelude.return (1049)
     VisCmdObjectConnectObjects -> Prelude.return (1050)
     VisCmdObjectGroup -> Prelude.return (1051)
     VisCmdObjectUngroup -> Prelude.return (1052)
     VisCmdObjectAddToGroup -> Prelude.return (1053)
     VisCmdObjectRemoveFromGroup -> Prelude.return (1054)
     VisCmdObjectConvertToGroup -> Prelude.return (1055)
     VisCmdObjectRotate90 -> Prelude.return (1056)
     VisCmdObjectFlipVertical -> Prelude.return (1057)
     VisCmdObjectFlipHorizontal -> Prelude.return (1058)
     VisCmdObjectReverse -> Prelude.return (1059)
     VisCmdObjectUnion -> Prelude.return (1060)
     VisCmdObjectCombine -> Prelude.return (1061)
     VisCmdObjectFragment -> Prelude.return (1062)
     VisCmdFormatStyle -> Prelude.return (1063)
     VisCmdFormatDefineStyles -> Prelude.return (1064)
     VisCmdFormatLine -> Prelude.return (1065)
     VisCmdFormatFill -> Prelude.return (1066)
     VisCmdFormatText -> Prelude.return (1067)
     VisCmdFormatFont -> Prelude.return (1067)
     VisCmdFormatParagraph -> Prelude.return (1068)
     VisCmdFormatTabs -> Prelude.return (1069)
     VisCmdFormatBlock -> Prelude.return (1070)
     VisCmdFormatBehavior -> Prelude.return (1071)
     VisCmdFormatProtection -> Prelude.return (1072)
     VisCmdFormatSpecial -> Prelude.return (1073)
     VisCmdOptionsEditDrawing -> Prelude.return (1074)
     VisCmdOptionsEditBackground -> Prelude.return (1075)
     VisCmdOptionsPageSetup -> Prelude.return (1076)
     VisCmdOptionsGoToDrawing -> Prelude.return (1077)
     VisCmdOptionsNewPage -> Prelude.return (1078)
     VisCmdOptionsDeletePages -> Prelude.return (1079)
     VisCmdOptionsReorderPages -> Prelude.return (1080)
     VisCmdOptionsPreferences -> Prelude.return (1081)
     VisCmdOptionsColorPaletteDlg -> Prelude.return (1082)
     VisCmdOptionsProtectDocument -> Prelude.return (1083)
     VisCmdOptionsSnapGlueSetup -> Prelude.return (1084)
     VisCmdWindowNewWindow -> Prelude.return (1085)
     VisCmdWindowCascadeAll -> Prelude.return (1086)
     VisCmdWindowTileAll -> Prelude.return (1087)
{-
     VisCmdWindowShowShapeSheet -> Prelude.return (1088)
     VisCmdWindowShowMasterObjects -> Prelude.return (1089)
     VisCmdRunAddOnMenu -> Prelude.return (1090)
     VisCmdWindowShowDrawPage -> Prelude.return (1091)
     VisCmdHelpContents -> Prelude.return (1092)
     VisCmdDecreaseIndent -> Prelude.return (1093)
     VisCmdIncreaseIndent -> Prelude.return (1094)
     VisCmdDecreaseParaSpacing -> Prelude.return (1095)
     VisCmdIncreaseParaSpacing -> Prelude.return (1096)
     VisCmdTextRotate90 -> Prelude.return (1098)
     VisCmdHelpAboutVisio -> Prelude.return (1100)
     VisCmdStenEditIcon -> Prelude.return (1101)
     VisCmdStenEditDrawing -> Prelude.return (1102)
     VisCmdStenNameMaster -> Prelude.return (1103)
     VisCmdStenNewMaster -> Prelude.return (1104)
     VisCmdStenImageMaster -> Prelude.return (1105)
     VisCmdStenCleanup -> Prelude.return (1106)
     VisCmdSWShowValues -> Prelude.return (1107)
     VisCmdSWShowFormulas -> Prelude.return (1108)
     VisCmdSWShowSectionsDlg -> Prelude.return (1109)
     VisCmdSWPasteNameDlg -> Prelude.return (1110)
     VisCmdSWPasteFunctionDlg -> Prelude.return (1111)
     VisCmdSWInsertRow -> Prelude.return (1112)
     VisCmdSWInsertRowAfter -> Prelude.return (1113)
     VisCmdSWChangeRowTypeDlg -> Prelude.return (1114)
     VisCmdSWDeleteRow -> Prelude.return (1115)
     VisCmdSWAddSectionDlg -> Prelude.return (1116)
     VisCmdSWDeleteSection -> Prelude.return (1117)
     VisCmdFormatDoubleClick -> Prelude.return (1118)
     VisCmdDrawLineStyle -> Prelude.return (1122)
     VisCmdDrawFillStyle -> Prelude.return (1123)
     VisCmdDrawSnap -> Prelude.return (1124)
     VisCmdDrawGlue -> Prelude.return (1125)
     VisCmdDrawZoom -> Prelude.return (1126)
     VisCmdTextStyle -> Prelude.return (1128)
     VisCmdTextFont -> Prelude.return (1129)
     VisCmdTextSize -> Prelude.return (1130)
     VisCmdTextBold -> Prelude.return (1131)
     VisCmdTextItalic -> Prelude.return (1132)
     VisCmdTextSmallCaps -> Prelude.return (1133)
     VisCmdTextSuperscript -> Prelude.return (1134)
     VisCmdTextSubscript -> Prelude.return (1135)
     VisCmdTextUline -> Prelude.return (1136)
     VisCmdSWCancel -> Prelude.return (1139)
     VisCmdSWAccept -> Prelude.return (1140)
     VisCmdSWFormula -> Prelude.return (1141)
     VisCmdSWShowToggle -> Prelude.return (1142)
     VisCmdIconLeftColor -> Prelude.return (1143)
     VisCmdIconPencilTool -> Prelude.return (1145)
     VisCmdRecalcObjectWH -> Prelude.return (1146)
     VisCmdTurnToPrevPage -> Prelude.return (1147)
     VisCmdTurnToNextPage -> Prelude.return (1148)
     VisCmdEditReplace -> Prelude.return (1179)
     VisCmdAlignObjectLeft -> Prelude.return (1196)
     VisCmdAlignObjectCenter -> Prelude.return (1197)
     VisCmdAlignObjectRight -> Prelude.return (1198)
     VisCmdAlignObjectTop -> Prelude.return (1199)
     VisCmdAlignObjectMiddle -> Prelude.return (1200)
     VisCmdAlignObjectBottom -> Prelude.return (1201)
     VisCmdCenterDrawing -> Prelude.return (1202)
     VisCmdDeselectAll -> Prelude.return (1213)
     VisCmdTextEditState -> Prelude.return (1214)
     VisCmdZoomIn -> Prelude.return (1216)
     VisCmdZoomOut -> Prelude.return (1217)
     VisCmdDRPointerTool -> Prelude.return (1219)
     VisCmdDRPencilTool -> Prelude.return (1220)
     VisCmdDRLineTool -> Prelude.return (1221)
     VisCmdDRQtrArcTool -> Prelude.return (1222)
     VisCmdDRRectTool -> Prelude.return (1223)
     VisCmdDROvalTool -> Prelude.return (1224)
     VisCmdDRConnectorTool -> Prelude.return (1225)
     VisCmdDRConnectionTool -> Prelude.return (1226)
     VisCmdDRTextTool -> Prelude.return (1227)
     VisCmdDRRotateTool -> Prelude.return (1228)
     VisCmdObjectDistributeDlg -> Prelude.return (1230)
     VisCmdDistributeHSpace -> Prelude.return (1231)
     VisCmdDistributeCenter -> Prelude.return (1233)
     VisCmdDistributeVSpace -> Prelude.return (1235)
     VisCmdDistributeMiddle -> Prelude.return (1237)
     VisCmdDlgLotusNotesFields -> Prelude.return (1245)
     VisCmdToolsSpelling -> Prelude.return (1270)
     VisCmdFormatPainter -> Prelude.return (1271)
     VisCmdStenFloating -> Prelude.return (1274)
     VisCmdView50 -> Prelude.return (1279)
     VisCmdView400 -> Prelude.return (1280)
     VisCmdSendAsMail -> Prelude.return (1292)
     VisCmdShapeActions -> Prelude.return (1309)
     VisCmdDRSplineTool -> Prelude.return (1311)
     VisCmdFormatCustPropEdit -> Prelude.return (1312)
     VisCmdRulerGridDlg -> Prelude.return (1318)
     VisCmdFormatShadow -> Prelude.return (1333)
     VisCmdFormatCorners -> Prelude.return (1334)
     VisCmdToolsInventory -> Prelude.return (1335)
     VisCmdPageSizeScale -> Prelude.return (1076)
     VisCmdStenSwitchSides -> Prelude.return (1342)
     VisCmdToolsArrayShapesAddOn -> Prelude.return (1354)
     VisCmdSetLineWeight -> Prelude.return (1355)
     VisCmdSetLinePattern -> Prelude.return (1356)
     VisCmdSetLineEnds -> Prelude.return (1357)
     VisCmdSetLineCornerStyle -> Prelude.return (1358)
     VisCmdSetLineColor -> Prelude.return (1359)
     VisCmdCloseWindow -> Prelude.return (1361)
     VisCmdSetFillShadow -> Prelude.return (1379)
     VisCmdSetFillColor -> Prelude.return (1385)
     VisCmdHelpMode -> Prelude.return (1386)
     VisCmdOffsetDlg -> Prelude.return (1387)
     VisCmdDesignMode -> Prelude.return (1388)
     VisCmdShapeExplorer -> Prelude.return (1389)
     VisCmdSetFillPattern -> Prelude.return (1399)
     VisCmdSetCharColor -> Prelude.return (1404)
     VisCmdSetCharSizeUp -> Prelude.return (1405)
     VisCmdSetCharSizeDown -> Prelude.return (1406)
     VisCmdTextHAlignLeft -> Prelude.return (1407)
     VisCmdTextHAlignCenter -> Prelude.return (1408)
     VisCmdTextHAlignRight -> Prelude.return (1409)
     VisCmdTextHAlignJustify -> Prelude.return (1412)
     VisCmdTextVAlignTop -> Prelude.return (1413)
     VisCmdTextVAlignMiddle -> Prelude.return (1414)
     VisCmdTextVAlignBottom -> Prelude.return (1422)
     VisCmdStampTool -> Prelude.return (1424)
     VisCmdObjectInfoDlg -> Prelude.return (1425)
     VisCmdObjectHelp -> Prelude.return (1428)
     VisCmdFileOpenStencil -> Prelude.return (1442)
     VisCmdPrintPage -> Prelude.return (1443)
     VisCmdSWShapeActionDlg -> Prelude.return (1444)
     VisCmdLayerDlg -> Prelude.return (1446)
     VisCmdLayerSetupDlg -> Prelude.return (1448)
     VisCmdCropTool -> Prelude.return (1449)
     VisCmdTextBlockTool -> Prelude.return (1451)
     VisCmdStenClose -> Prelude.return (1452)
     VisCmdIntersect -> Prelude.return (1453)
     VisCmdSubtract -> Prelude.return (1454)
     VisCmdStenActivate -> Prelude.return (1458)
     VisCmdStenIconAndName -> Prelude.return (1480)
     VisCmdStenIconOnly -> Prelude.return (1481)
     VisCmdStenNameOnly -> Prelude.return (1482)
     VisCmdStenAutoArrange -> Prelude.return (1483)
     VisCmdPrintPreview -> Prelude.return (1490)
     VisCmdOpenInVisio -> Prelude.return (1491)
     VisCmdFullScreenMode -> Prelude.return (1492)
     VisCmdRotate90Clockwise -> Prelude.return (1494)
     VisCmdZoomLast -> Prelude.return (1495)
     VisCmdZoomPageWidth -> Prelude.return (1496)
     VisCmdToolbarsDlg -> Prelude.return (1500)
     VisCmdINETAddToFavorites -> Prelude.return (1506)
     VisCmdViewPageBreaks -> Prelude.return (1509)
     VisCmdZoomSingleTile -> Prelude.return (1512)
     VisCmdPreviousTile -> Prelude.return (1513)
     VisCmdNextTile -> Prelude.return (1514)
     VisCmdFirstTile -> Prelude.return (1515)
     VisCmdLastTile -> Prelude.return (1516)
     VisCmdInsertAutoCADAddOn -> Prelude.return (1521)
     VisCmdInsertControlDlg -> Prelude.return (1522)
     VisCmdJoin -> Prelude.return (1533)
     VisCmdTrim -> Prelude.return (1534)
     VisCmdDlgCustomFit -> Prelude.return (1536)
     VisCmdFitCurve -> Prelude.return (1538)
     VisCmdIconBucketTool -> Prelude.return (1543)
     VisCmdIconLassoTool -> Prelude.return (1544)
     VisCmdIconSelectNet -> Prelude.return (1545)
     VisCmdToolsLayoutShapesDlg -> Prelude.return (1574)
     VisCmdToolsRunVBE -> Prelude.return (1576)
     VisCmdToolsMacroDlg -> Prelude.return (1577)
     VisCmdFileNewBlankDrawing -> Prelude.return (1579)
     VisCmdFileNewBlankStencil -> Prelude.return (1582)
     VisCmdProgRefHelp -> Prelude.return (1584)
     VisCmdInsertHyperLink -> Prelude.return (1585)
     VisCmdHelpTemplates -> Prelude.return (1586)
     VisCmdEmailRouting -> Prelude.return (1588)
     VisCmdSendToExchange -> Prelude.return (1589)
     VisCmdINETUserSearchPage -> Prelude.return (1595)
     VisCmdINETVisioHomePage -> Prelude.return (1596)
     VisCmdINETGoForward -> Prelude.return (1598)
     VisCmdINETGoBack -> Prelude.return (1599)
     VisCmdOpenActiveObject -> Prelude.return (1601)
     VisCmdCancelInPlaceEditing -> Prelude.return (1602)
     VisCmdINETVisioSolutionsLibrary -> Prelude.return (1604)
     VisCmdINETKnowledgeBase -> Prelude.return (1605)
     VisCmdINETDiagrammingResources -> Prelude.return (1606)
     VisCmdINETOpenHlink -> Prelude.return (1607)
     VisCmdINETOpenHlinkNewWnd -> Prelude.return (1608)
     VisCmdINETCopyHyperlink -> Prelude.return (1610)
     VisCmdHyperlinkHier -> Prelude.return (1611)
     VisCmdINETEditHyperlink -> Prelude.return (1619)
     VisCmdINETPasteAsHyperlink -> Prelude.return (1620)
     VisCmdBullets -> Prelude.return (1633)
     VisCmdShapeLayerToolbar -> Prelude.return (1634)
     VisCmdGoToPageToolbar -> Prelude.return (1635)
     VisCmdFormatAllTextProps -> Prelude.return (1642)
     VisCmdBrowseSampleDrawings -> Prelude.return (1645)
-}
unmarshallVisUICmds :: Int.Int16 -> Prelude.IO VisUICmds
unmarshallVisUICmds v =
  case v of
     200 -> Prelude.return (VisCmdHierarchical)
     1001 -> Prelude.return (VisCmdFileNew)
     1002 -> Prelude.return (VisCmdFileOpen)
     1003 -> Prelude.return (VisCmdFileClose)
     1004 -> Prelude.return (VisCmdFileSave)
     1005 -> Prelude.return (VisCmdFileSaveAs)
     1006 -> Prelude.return (VisCmdFileSaveWorkspace)
     1007 -> Prelude.return (VisCmdFileImport)
     1009 -> Prelude.return (VisCmdFileSummaryInfoDlg)
     1010 -> Prelude.return (VisCmdFilePrint)
     1016 -> Prelude.return (VisCmdFileExit)
     1017 -> Prelude.return (VisCmdEditUndo)
     1018 -> Prelude.return (VisCmdEditRedo)
     1019 -> Prelude.return (VisCmdEditRepeat)
     1020 -> Prelude.return (VisCmdUFEditCut)
     1021 -> Prelude.return (VisCmdUFEditCopy)
     1022 -> Prelude.return (VisCmdUFEditPaste)
     1023 -> Prelude.return (VisCmdUFEditClear)
     1024 -> Prelude.return (VisCmdUFEditDuplicate)
     1025 -> Prelude.return (VisCmdUFEditSelectAll)
     1026 -> Prelude.return (VisCmdEditSelectSpecial)
     1027 -> Prelude.return (VisCmdEditPasteSpecial)
     1029 -> Prelude.return (VisCmdEditOpenObject)
     1030 -> Prelude.return (VisCmdEditLinks)
     1031 -> Prelude.return (VisCmdEditInsertObject)
     1032 -> Prelude.return (VisCmdEditInsertField)
     1033 -> Prelude.return (VisCmdViewFitInWindow)
     1034 -> Prelude.return (VisCmdView75)
     1035 -> Prelude.return (VisCmdView100)
     1036 -> Prelude.return (VisCmdView150)
     1037 -> Prelude.return (VisCmdView200)
     1038 -> Prelude.return (VisCmdViewCustom)
     1039 -> Prelude.return (VisCmdViewRulers)
     1040 -> Prelude.return (VisCmdViewGrid)
     1041 -> Prelude.return (VisCmdViewGuides)
     1042 -> Prelude.return (VisCmdViewConnections)
     1043 -> Prelude.return (VisCmdEditFind)
     1044 -> Prelude.return (VisCmdViewStatusBar)
     1045 -> Prelude.return (VisCmdObjectBringForward)
     1046 -> Prelude.return (VisCmdObjectBringToFront)
     1047 -> Prelude.return (VisCmdObjectSendBackward)
     1048 -> Prelude.return (VisCmdObjectSendToBack)
     1049 -> Prelude.return (VisCmdObjectAlignObjects)
     1050 -> Prelude.return (VisCmdObjectConnectObjects)
     1051 -> Prelude.return (VisCmdObjectGroup)
     1052 -> Prelude.return (VisCmdObjectUngroup)
     1053 -> Prelude.return (VisCmdObjectAddToGroup)
     1054 -> Prelude.return (VisCmdObjectRemoveFromGroup)
     1055 -> Prelude.return (VisCmdObjectConvertToGroup)
     1056 -> Prelude.return (VisCmdObjectRotate90)
     1057 -> Prelude.return (VisCmdObjectFlipVertical)
     1058 -> Prelude.return (VisCmdObjectFlipHorizontal)
     1059 -> Prelude.return (VisCmdObjectReverse)
     1060 -> Prelude.return (VisCmdObjectUnion)
     1061 -> Prelude.return (VisCmdObjectCombine)
     1062 -> Prelude.return (VisCmdObjectFragment)
     1063 -> Prelude.return (VisCmdFormatStyle)
     1064 -> Prelude.return (VisCmdFormatDefineStyles)
     1065 -> Prelude.return (VisCmdFormatLine)
     1066 -> Prelude.return (VisCmdFormatFill)
     1067 -> Prelude.return (VisCmdFormatText)
     1067 -> Prelude.return (VisCmdFormatFont)
     1068 -> Prelude.return (VisCmdFormatParagraph)
     1069 -> Prelude.return (VisCmdFormatTabs)
     1070 -> Prelude.return (VisCmdFormatBlock)
     1071 -> Prelude.return (VisCmdFormatBehavior)
     1072 -> Prelude.return (VisCmdFormatProtection)
     1073 -> Prelude.return (VisCmdFormatSpecial)
     1074 -> Prelude.return (VisCmdOptionsEditDrawing)
     1075 -> Prelude.return (VisCmdOptionsEditBackground)
     1076 -> Prelude.return (VisCmdOptionsPageSetup)
     1077 -> Prelude.return (VisCmdOptionsGoToDrawing)
     1078 -> Prelude.return (VisCmdOptionsNewPage)
     1079 -> Prelude.return (VisCmdOptionsDeletePages)
     1080 -> Prelude.return (VisCmdOptionsReorderPages)
     1081 -> Prelude.return (VisCmdOptionsPreferences)
{-
     1082 -> Prelude.return (VisCmdOptionsColorPaletteDlg)
     1083 -> Prelude.return (VisCmdOptionsProtectDocument)
     1084 -> Prelude.return (VisCmdOptionsSnapGlueSetup)
     1085 -> Prelude.return (VisCmdWindowNewWindow)
     1086 -> Prelude.return (VisCmdWindowCascadeAll)
     1087 -> Prelude.return (VisCmdWindowTileAll)
     1088 -> Prelude.return (VisCmdWindowShowShapeSheet)
     1089 -> Prelude.return (VisCmdWindowShowMasterObjects)
     1090 -> Prelude.return (VisCmdRunAddOnMenu)
     1091 -> Prelude.return (VisCmdWindowShowDrawPage)
     1092 -> Prelude.return (VisCmdHelpContents)
     1093 -> Prelude.return (VisCmdDecreaseIndent)
     1094 -> Prelude.return (VisCmdIncreaseIndent)
     1095 -> Prelude.return (VisCmdDecreaseParaSpacing)
     1096 -> Prelude.return (VisCmdIncreaseParaSpacing)
     1098 -> Prelude.return (VisCmdTextRotate90)
     1100 -> Prelude.return (VisCmdHelpAboutVisio)
     1101 -> Prelude.return (VisCmdStenEditIcon)
     1102 -> Prelude.return (VisCmdStenEditDrawing)
     1103 -> Prelude.return (VisCmdStenNameMaster)
     1104 -> Prelude.return (VisCmdStenNewMaster)
     1105 -> Prelude.return (VisCmdStenImageMaster)
     1106 -> Prelude.return (VisCmdStenCleanup)
     1107 -> Prelude.return (VisCmdSWShowValues)
     1108 -> Prelude.return (VisCmdSWShowFormulas)
     1109 -> Prelude.return (VisCmdSWShowSectionsDlg)
     1110 -> Prelude.return (VisCmdSWPasteNameDlg)
     1111 -> Prelude.return (VisCmdSWPasteFunctionDlg)
     1112 -> Prelude.return (VisCmdSWInsertRow)
     1113 -> Prelude.return (VisCmdSWInsertRowAfter)
     1114 -> Prelude.return (VisCmdSWChangeRowTypeDlg)
     1115 -> Prelude.return (VisCmdSWDeleteRow)
     1116 -> Prelude.return (VisCmdSWAddSectionDlg)
     1117 -> Prelude.return (VisCmdSWDeleteSection)
     1118 -> Prelude.return (VisCmdFormatDoubleClick)
     1122 -> Prelude.return (VisCmdDrawLineStyle)
     1123 -> Prelude.return (VisCmdDrawFillStyle)
     1124 -> Prelude.return (VisCmdDrawSnap)
     1125 -> Prelude.return (VisCmdDrawGlue)
     1126 -> Prelude.return (VisCmdDrawZoom)
     1128 -> Prelude.return (VisCmdTextStyle)
     1129 -> Prelude.return (VisCmdTextFont)
     1130 -> Prelude.return (VisCmdTextSize)
     1131 -> Prelude.return (VisCmdTextBold)
     1132 -> Prelude.return (VisCmdTextItalic)
     1133 -> Prelude.return (VisCmdTextSmallCaps)
     1134 -> Prelude.return (VisCmdTextSuperscript)
     1135 -> Prelude.return (VisCmdTextSubscript)
     1136 -> Prelude.return (VisCmdTextUline)
     1139 -> Prelude.return (VisCmdSWCancel)
     1140 -> Prelude.return (VisCmdSWAccept)
     1141 -> Prelude.return (VisCmdSWFormula)
     1142 -> Prelude.return (VisCmdSWShowToggle)
     1143 -> Prelude.return (VisCmdIconLeftColor)
     1145 -> Prelude.return (VisCmdIconPencilTool)
     1146 -> Prelude.return (VisCmdRecalcObjectWH)
     1147 -> Prelude.return (VisCmdTurnToPrevPage)
     1148 -> Prelude.return (VisCmdTurnToNextPage)
     1179 -> Prelude.return (VisCmdEditReplace)
     1196 -> Prelude.return (VisCmdAlignObjectLeft)
     1197 -> Prelude.return (VisCmdAlignObjectCenter)
     1198 -> Prelude.return (VisCmdAlignObjectRight)
     1199 -> Prelude.return (VisCmdAlignObjectTop)
     1200 -> Prelude.return (VisCmdAlignObjectMiddle)
     1201 -> Prelude.return (VisCmdAlignObjectBottom)
     1202 -> Prelude.return (VisCmdCenterDrawing)
     1213 -> Prelude.return (VisCmdDeselectAll)
     1214 -> Prelude.return (VisCmdTextEditState)
     1216 -> Prelude.return (VisCmdZoomIn)
     1217 -> Prelude.return (VisCmdZoomOut)
     1219 -> Prelude.return (VisCmdDRPointerTool)
     1220 -> Prelude.return (VisCmdDRPencilTool)
     1221 -> Prelude.return (VisCmdDRLineTool)
     1222 -> Prelude.return (VisCmdDRQtrArcTool)
     1223 -> Prelude.return (VisCmdDRRectTool)
     1224 -> Prelude.return (VisCmdDROvalTool)
     1225 -> Prelude.return (VisCmdDRConnectorTool)
     1226 -> Prelude.return (VisCmdDRConnectionTool)
     1227 -> Prelude.return (VisCmdDRTextTool)
     1228 -> Prelude.return (VisCmdDRRotateTool)
     1230 -> Prelude.return (VisCmdObjectDistributeDlg)
     1231 -> Prelude.return (VisCmdDistributeHSpace)
     1233 -> Prelude.return (VisCmdDistributeCenter)
     1235 -> Prelude.return (VisCmdDistributeVSpace)
     1237 -> Prelude.return (VisCmdDistributeMiddle)
     1245 -> Prelude.return (VisCmdDlgLotusNotesFields)
     1270 -> Prelude.return (VisCmdToolsSpelling)
     1271 -> Prelude.return (VisCmdFormatPainter)
     1274 -> Prelude.return (VisCmdStenFloating)
     1279 -> Prelude.return (VisCmdView50)
     1280 -> Prelude.return (VisCmdView400)
     1292 -> Prelude.return (VisCmdSendAsMail)
     1309 -> Prelude.return (VisCmdShapeActions)
     1311 -> Prelude.return (VisCmdDRSplineTool)
     1312 -> Prelude.return (VisCmdFormatCustPropEdit)
     1318 -> Prelude.return (VisCmdRulerGridDlg)
     1333 -> Prelude.return (VisCmdFormatShadow)
     1334 -> Prelude.return (VisCmdFormatCorners)
     1335 -> Prelude.return (VisCmdToolsInventory)
     1076 -> Prelude.return (VisCmdPageSizeScale)
     1342 -> Prelude.return (VisCmdStenSwitchSides)
     1354 -> Prelude.return (VisCmdToolsArrayShapesAddOn)
     1355 -> Prelude.return (VisCmdSetLineWeight)
     1356 -> Prelude.return (VisCmdSetLinePattern)
     1357 -> Prelude.return (VisCmdSetLineEnds)
     1358 -> Prelude.return (VisCmdSetLineCornerStyle)
     1359 -> Prelude.return (VisCmdSetLineColor)
     1361 -> Prelude.return (VisCmdCloseWindow)
     1379 -> Prelude.return (VisCmdSetFillShadow)
     1385 -> Prelude.return (VisCmdSetFillColor)
     1386 -> Prelude.return (VisCmdHelpMode)
     1387 -> Prelude.return (VisCmdOffsetDlg)
     1388 -> Prelude.return (VisCmdDesignMode)
     1389 -> Prelude.return (VisCmdShapeExplorer)
     1399 -> Prelude.return (VisCmdSetFillPattern)
     1404 -> Prelude.return (VisCmdSetCharColor)
     1405 -> Prelude.return (VisCmdSetCharSizeUp)
     1406 -> Prelude.return (VisCmdSetCharSizeDown)
     1407 -> Prelude.return (VisCmdTextHAlignLeft)
     1408 -> Prelude.return (VisCmdTextHAlignCenter)
     1409 -> Prelude.return (VisCmdTextHAlignRight)
     1412 -> Prelude.return (VisCmdTextHAlignJustify)
     1413 -> Prelude.return (VisCmdTextVAlignTop)
     1414 -> Prelude.return (VisCmdTextVAlignMiddle)
     1422 -> Prelude.return (VisCmdTextVAlignBottom)
     1424 -> Prelude.return (VisCmdStampTool)
     1425 -> Prelude.return (VisCmdObjectInfoDlg)
     1428 -> Prelude.return (VisCmdObjectHelp)
     1442 -> Prelude.return (VisCmdFileOpenStencil)
     1443 -> Prelude.return (VisCmdPrintPage)
     1444 -> Prelude.return (VisCmdSWShapeActionDlg)
     1446 -> Prelude.return (VisCmdLayerDlg)
     1448 -> Prelude.return (VisCmdLayerSetupDlg)
     1449 -> Prelude.return (VisCmdCropTool)
     1451 -> Prelude.return (VisCmdTextBlockTool)
     1452 -> Prelude.return (VisCmdStenClose)
     1453 -> Prelude.return (VisCmdIntersect)
     1454 -> Prelude.return (VisCmdSubtract)
     1458 -> Prelude.return (VisCmdStenActivate)
     1480 -> Prelude.return (VisCmdStenIconAndName)
     1481 -> Prelude.return (VisCmdStenIconOnly)
     1482 -> Prelude.return (VisCmdStenNameOnly)
     1483 -> Prelude.return (VisCmdStenAutoArrange)
     1490 -> Prelude.return (VisCmdPrintPreview)
     1491 -> Prelude.return (VisCmdOpenInVisio)
     1492 -> Prelude.return (VisCmdFullScreenMode)
     1494 -> Prelude.return (VisCmdRotate90Clockwise)
     1495 -> Prelude.return (VisCmdZoomLast)
     1496 -> Prelude.return (VisCmdZoomPageWidth)
     1500 -> Prelude.return (VisCmdToolbarsDlg)
     1506 -> Prelude.return (VisCmdINETAddToFavorites)
     1509 -> Prelude.return (VisCmdViewPageBreaks)
     1512 -> Prelude.return (VisCmdZoomSingleTile)
     1513 -> Prelude.return (VisCmdPreviousTile)
     1514 -> Prelude.return (VisCmdNextTile)
     1515 -> Prelude.return (VisCmdFirstTile)
     1516 -> Prelude.return (VisCmdLastTile)
     1521 -> Prelude.return (VisCmdInsertAutoCADAddOn)
     1522 -> Prelude.return (VisCmdInsertControlDlg)
     1533 -> Prelude.return (VisCmdJoin)
     1534 -> Prelude.return (VisCmdTrim)
     1536 -> Prelude.return (VisCmdDlgCustomFit)
     1538 -> Prelude.return (VisCmdFitCurve)
     1543 -> Prelude.return (VisCmdIconBucketTool)
     1544 -> Prelude.return (VisCmdIconLassoTool)
     1545 -> Prelude.return (VisCmdIconSelectNet)
     1574 -> Prelude.return (VisCmdToolsLayoutShapesDlg)
     1576 -> Prelude.return (VisCmdToolsRunVBE)
     1577 -> Prelude.return (VisCmdToolsMacroDlg)
     1579 -> Prelude.return (VisCmdFileNewBlankDrawing)
     1582 -> Prelude.return (VisCmdFileNewBlankStencil)
     1584 -> Prelude.return (VisCmdProgRefHelp)
     1585 -> Prelude.return (VisCmdInsertHyperLink)
     1586 -> Prelude.return (VisCmdHelpTemplates)
     1588 -> Prelude.return (VisCmdEmailRouting)
     1589 -> Prelude.return (VisCmdSendToExchange)
     1595 -> Prelude.return (VisCmdINETUserSearchPage)
     1596 -> Prelude.return (VisCmdINETVisioHomePage)
     1598 -> Prelude.return (VisCmdINETGoForward)
     1599 -> Prelude.return (VisCmdINETGoBack)
     1601 -> Prelude.return (VisCmdOpenActiveObject)
     1602 -> Prelude.return (VisCmdCancelInPlaceEditing)
     1604 -> Prelude.return (VisCmdINETVisioSolutionsLibrary)
     1605 -> Prelude.return (VisCmdINETKnowledgeBase)
     1606 -> Prelude.return (VisCmdINETDiagrammingResources)
     1607 -> Prelude.return (VisCmdINETOpenHlink)
     1608 -> Prelude.return (VisCmdINETOpenHlinkNewWnd)
     1610 -> Prelude.return (VisCmdINETCopyHyperlink)
     1611 -> Prelude.return (VisCmdHyperlinkHier)
     1619 -> Prelude.return (VisCmdINETEditHyperlink)
     1620 -> Prelude.return (VisCmdINETPasteAsHyperlink)
     1633 -> Prelude.return (VisCmdBullets)
     1634 -> Prelude.return (VisCmdShapeLayerToolbar)
     1635 -> Prelude.return (VisCmdGoToPageToolbar)
     1642 -> Prelude.return (VisCmdFormatAllTextProps)
     1645 -> Prelude.return (VisCmdBrowseSampleDrawings)
-}
     _ -> Prelude.fail (Prelude.userError "unmarshallVisUICmds: illegal enum value ")

data VisUICtrlTypes
 = VisCtrlTypeEND
 | VisCtrlTypeSTATE
 | VisCtrlTypeBUTTON
 | VisCtrlTypeSTATE_BUTTON
 | VisCtrlTypePALETTEBUTTON
 | VisCtrlTypeHIERBUTTON
 | VisCtrlTypeSTATE_HIERBUTTON
 | VisCtrlTypeDROPBUTTON
 | VisCtrlTypeSTATE_DROPBUTTON
 | VisCtrlTypeSPINBUTTON
 | VisCtrlTypePUSHBUTTON
 | VisCtrlTypeOWNERDRAW_BUTTON
 | VisCtrlTypeEDITBOX
 | VisCtrlTypeCOMBOBOX
 | VisCtrlTypeCOMBODRAW
 | VisCtrlTypeLISTBOX
 | VisCtrlTypeLISTBOXDRAW
 | VisCtrlTypeCOLORBOX
 | VisCtrlTypeLABEL
 | VisCtrlTypeMESSAGE
 | VisCtrlTypeSPACER
 
marshallVisUICtrlTypes :: VisUICtrlTypes -> Prelude.IO Int.Int16
marshallVisUICtrlTypes v =
  case v of
     VisCtrlTypeEND -> Prelude.return (0)
     VisCtrlTypeSTATE -> Prelude.return (1)
     VisCtrlTypeBUTTON -> Prelude.return (2)
     VisCtrlTypeSTATE_BUTTON -> Prelude.return (3)
     VisCtrlTypePALETTEBUTTON -> Prelude.return (16)
     VisCtrlTypeHIERBUTTON -> Prelude.return (4)
     VisCtrlTypeSTATE_HIERBUTTON -> Prelude.return (5)
     VisCtrlTypeDROPBUTTON -> Prelude.return (8)
     VisCtrlTypeSTATE_DROPBUTTON -> Prelude.return (9)
     VisCtrlTypeSPINBUTTON -> Prelude.return (16)
     VisCtrlTypePUSHBUTTON -> Prelude.return (32)
     VisCtrlTypeOWNERDRAW_BUTTON -> Prelude.return (33)
     VisCtrlTypeEDITBOX -> Prelude.return (64)
     VisCtrlTypeCOMBOBOX -> Prelude.return (128)
     VisCtrlTypeCOMBODRAW -> Prelude.return (256)
     VisCtrlTypeLISTBOX -> Prelude.return (512)
     VisCtrlTypeLISTBOXDRAW -> Prelude.return (513)
     VisCtrlTypeCOLORBOX -> Prelude.return (1024)
     VisCtrlTypeLABEL -> Prelude.return (2048)
     VisCtrlTypeMESSAGE -> Prelude.return (4096)
     VisCtrlTypeSPACER -> Prelude.return (16384)
unmarshallVisUICtrlTypes :: Int.Int16 -> Prelude.IO VisUICtrlTypes
unmarshallVisUICtrlTypes v =
  case v of
     0 -> Prelude.return (VisCtrlTypeEND)
     1 -> Prelude.return (VisCtrlTypeSTATE)
     2 -> Prelude.return (VisCtrlTypeBUTTON)
     3 -> Prelude.return (VisCtrlTypeSTATE_BUTTON)
     16 -> Prelude.return (VisCtrlTypePALETTEBUTTON)
     4 -> Prelude.return (VisCtrlTypeHIERBUTTON)
     5 -> Prelude.return (VisCtrlTypeSTATE_HIERBUTTON)
     8 -> Prelude.return (VisCtrlTypeDROPBUTTON)
     9 -> Prelude.return (VisCtrlTypeSTATE_DROPBUTTON)
     16 -> Prelude.return (VisCtrlTypeSPINBUTTON)
     32 -> Prelude.return (VisCtrlTypePUSHBUTTON)
     33 -> Prelude.return (VisCtrlTypeOWNERDRAW_BUTTON)
     64 -> Prelude.return (VisCtrlTypeEDITBOX)
     128 -> Prelude.return (VisCtrlTypeCOMBOBOX)
     256 -> Prelude.return (VisCtrlTypeCOMBODRAW)
     512 -> Prelude.return (VisCtrlTypeLISTBOX)
     513 -> Prelude.return (VisCtrlTypeLISTBOXDRAW)
     1024 -> Prelude.return (VisCtrlTypeCOLORBOX)
     2048 -> Prelude.return (VisCtrlTypeLABEL)
     4096 -> Prelude.return (VisCtrlTypeMESSAGE)
     16384 -> Prelude.return (VisCtrlTypeSPACER)
     _ -> Prelude.fail (Prelude.userError "unmarshallVisUICtrlTypes: illegal enum value ")
data VisUISpacingTypes
 = VisCtrlSpacingNONE
 | VisCtrlSpacingVARIABLE_BEFORE
 | VisCtrlSpacingVARIABLE_AFTER
 | VisCtrlSpacingFIXED_BEFORE
 | VisCtrlSpacingFIXED_AFTER
 | VisCtrlSpacingNEW_ROW
 | VisCtrlSpacingTB_NOTFIXED
 | VisCtrlSpacingPALETTERIGHT
 | VisCtrlSpacingNEW_ROW_PALETTERIGHT
 
marshallVisUISpacingTypes :: VisUISpacingTypes -> Prelude.IO Int.Int16
marshallVisUISpacingTypes v =
  case v of
     VisCtrlSpacingNONE -> Prelude.return (0)
     VisCtrlSpacingVARIABLE_BEFORE -> Prelude.return (1)
     VisCtrlSpacingVARIABLE_AFTER -> Prelude.return (2)
     VisCtrlSpacingFIXED_BEFORE -> Prelude.return (4)
     VisCtrlSpacingFIXED_AFTER -> Prelude.return (8)
     VisCtrlSpacingNEW_ROW -> Prelude.return (16)
     VisCtrlSpacingTB_NOTFIXED -> Prelude.return (32)
     VisCtrlSpacingPALETTERIGHT -> Prelude.return (64)
     VisCtrlSpacingNEW_ROW_PALETTERIGHT -> Prelude.return (80)
unmarshallVisUISpacingTypes :: Int.Int16 -> Prelude.IO VisUISpacingTypes
unmarshallVisUISpacingTypes v =
  case v of
     0 -> Prelude.return (VisCtrlSpacingNONE)
     1 -> Prelude.return (VisCtrlSpacingVARIABLE_BEFORE)
     2 -> Prelude.return (VisCtrlSpacingVARIABLE_AFTER)
     4 -> Prelude.return (VisCtrlSpacingFIXED_BEFORE)
     8 -> Prelude.return (VisCtrlSpacingFIXED_AFTER)
     16 -> Prelude.return (VisCtrlSpacingNEW_ROW)
     32 -> Prelude.return (VisCtrlSpacingTB_NOTFIXED)
     64 -> Prelude.return (VisCtrlSpacingPALETTERIGHT)
     80 -> Prelude.return (VisCtrlSpacingNEW_ROW_PALETTERIGHT)
     _ -> Prelude.fail (Prelude.userError "unmarshallVisUISpacingTypes: illegal enum value ")
data VisUICtrlAtts
 = VisCtrlAlignmentLEFT
 | VisCtrlAlignmentCENTER
 | VisCtrlAlignmentRIGHT
 | VisCtrlAlignmentBOX
 | VisCtrlAlignmentLEFTBOX
 | VisCtrlAlignmentCENTERBOX
 | VisCtrlAlignmentRIGHTBOX
 
marshallVisUICtrlAtts :: VisUICtrlAtts -> Prelude.IO Int.Int16
marshallVisUICtrlAtts v =
  case v of
     VisCtrlAlignmentLEFT -> Prelude.return (1)
     VisCtrlAlignmentCENTER -> Prelude.return (2)
     VisCtrlAlignmentRIGHT -> Prelude.return (4)
     VisCtrlAlignmentBOX -> Prelude.return (128)
     VisCtrlAlignmentLEFTBOX -> Prelude.return (129)
     VisCtrlAlignmentCENTERBOX -> Prelude.return (130)
     VisCtrlAlignmentRIGHTBOX -> Prelude.return (132)
unmarshallVisUICtrlAtts :: Int.Int16 -> Prelude.IO VisUICtrlAtts
unmarshallVisUICtrlAtts v =
  case v of
     1 -> Prelude.return (VisCtrlAlignmentLEFT)
     2 -> Prelude.return (VisCtrlAlignmentCENTER)
     4 -> Prelude.return (VisCtrlAlignmentRIGHT)
     128 -> Prelude.return (VisCtrlAlignmentBOX)
     129 -> Prelude.return (VisCtrlAlignmentLEFTBOX)
     130 -> Prelude.return (VisCtrlAlignmentCENTERBOX)
     132 -> Prelude.return (VisCtrlAlignmentRIGHTBOX)
     _ -> Prelude.fail (Prelude.userError "unmarshallVisUICtrlAtts: illegal enum value ")
data VisUICtrlIDs
 = VisCtrlIDNEW
 | VisCtrlIDOPEN
 | VisCtrlIDOPENSTEN
 | VisCtrlIDSAVE
 | VisCtrlIDPRINT
 | VisCtrlIDPREVIEW
 | VisCtrlIDCUT
 | VisCtrlIDCOPY
 | VisCtrlIDPASTE
 | VisCtrlIDCLEAR
 | VisCtrlIDUNDO
 | VisCtrlIDREDO
 | VisCtrlIDREPEAT
 | VisCtrlIDPREVIOUSPAGE
 | VisCtrlIDNEXTPAGE
 | VisCtrlIDZOOMOUT
 | VisCtrlIDZOOMIN
 | VisCtrlIDZOOM100
 | VisCtrlIDFLIPHORZ
 | VisCtrlIDFLIPVERT
 | VisCtrlIDPOINTERTOOL
 | VisCtrlIDPENCILTOOL
 | VisCtrlIDLINETOOL
 | VisCtrlIDQTRARCTOOL
 | VisCtrlIDRECTTOOL
 | VisCtrlIDOVALTOOL
 | VisCtrlIDSTAMPTOOL
 | VisCtrlIDTEXTTOOL
 | VisCtrlIDROTATETOOL
 | VisCtrlIDCROPTOOL
 | VisCtrlIDCONNECTIONPTTOOL
 | VisCtrlIDSNAP
 | VisCtrlIDGLUE
 | VisCtrlIDRULER
 | VisCtrlIDGRID
 | VisCtrlIDGUIDE
 | VisCtrlIDCONNECT
 | VisCtrlIDROTATECLOCKWISE
 | VisCtrlIDROTATECOUNTER
 | VisCtrlIDNEWWINDOW
 | VisCtrlIDCORNERSTYLE
 | VisCtrlIDLINEEND
 | VisCtrlIDSHADOWSTYLE
 | VisCtrlIDFILLCOLOR
 | VisCtrlIDLINECOLOR
 | VisCtrlIDLINEWEIGHT
 | VisCtrlIDLINEPATTERN
 | VisCtrlIDFILLPATTERN
 | VisCtrlIDPOINTSIZEDOWN
 | VisCtrlIDPOINTSIZEUP
 | VisCtrlIDBOLD
 | VisCtrlIDITALIC
 | VisCtrlIDULINE
 | VisCtrlIDSUPERSCRIPT
 | VisCtrlIDSUBSCRIPT
 | VisCtrlIDTEXTCOLOR
 | VisCtrlIDTEXTLEFT
 | VisCtrlIDTEXTCENTER
 | VisCtrlIDTEXTRIGHT
 | VisCtrlIDTEXTJUSTIFY
 | VisCtrlIDTEXTTOP
 | VisCtrlIDTEXTMIDDLE
 | VisCtrlIDTEXTBOTTOM
 | VisCtrlIDALIGN
 | VisCtrlIDALIGNLEFT
 | VisCtrlIDALIGNCENTER
 | VisCtrlIDALIGNRIGHT
 | VisCtrlIDALIGNTOP
 | VisCtrlIDALIGNMIDDLE
 | VisCtrlIDALIGNBOTTOM
 | VisCtrlIDDISTRIBUTE
 | VisCtrlIDDHORZ_EQSPACE
 | VisCtrlIDDHORZ_CENTER
 | VisCtrlIDDVERT_EQSPACE
 | VisCtrlIDDVERT_MIDDLE
 | VisCtrlIDCONNECTSHAPES
 | VisCtrlIDFIRSTPAGE
 | VisCtrlIDLASTPAGE
 | VisCtrlIDPAGEBREAKS
 | VisCtrlIDICONNAME
 | VisCtrlIDICONONLY
 | VisCtrlIDNAMEONLY
 | VisCtrlIDARRANGEICONS
 | VisCtrlIDCANCELFORMULA
 | VisCtrlIDACCEPTFORMULA
 | VisCtrlIDICONPENCIL
 | VisCtrlIDICONBUCKET
 | VisCtrlIDICONLASSO
 | VisCtrlIDICONSELNET
 | VisCtrlIDBRINGFRONT
 | VisCtrlIDSENDBACK
 | VisCtrlIDGROUP
 | VisCtrlIDUNGROUP
 | VisCtrlIDCASCADE
 | VisCtrlIDTILE
 | VisCtrlIDCONNECTORTOOL
 | VisCtrlIDTEXTBLOCKTOOL
 | VisCtrlIDWHOLEPAGE
 | VisCtrlIDSINGLETILE
 | VisCtrlIDFORMULA
 | VisCtrlIDSPACER
 | VisCtrlIDALLSTYLESCOMBO
 | VisCtrlIDTEXTSTYLECOMBO
 | VisCtrlIDLINESTYLECOMBO
 | VisCtrlIDFILLSTYLECOMBO
 | VisCtrlIDZOOMCOMBO
 | VisCtrlIDFONTCOMBO
 | VisCtrlIDPOINTSIZECOMBO
 | VisCtrlIDALLSTYLESLIST
 | VisCtrlIDTEXTSTYLELIST
 | VisCtrlIDLINESTYLELIST
 | VisCtrlIDFILLSTYLELIST
 | VisCtrlIDZOOMLIST
 | VisCtrlIDFONTLIST
 | VisCtrlIDPOINTSIZELIST
 | VisCtrlIDGOTOPAGELIST
 | VisCtrlIDCLOSE
 | VisCtrlIDLEFTCOLORBOX
 | VisCtrlIDRIGHTCOLORBOX
 | VisCtrlIDCOLOR1
 | VisCtrlIDCOLOR2
 | VisCtrlIDCOLOR3
 | VisCtrlIDCOLOR4
 | VisCtrlIDCOLOR5
 | VisCtrlIDCOLOR6
 | VisCtrlIDCOLOR7
 | VisCtrlIDCOLOR8
 | VisCtrlIDCOLOR9
 | VisCtrlIDCOLOR10
 | VisCtrlIDCOLOR11
 | VisCtrlIDCOLOR12
 | VisCtrlIDCOLOR13
 | VisCtrlIDCOLOR14
 | VisCtrlIDCOLOR15
 | VisCtrlIDCOLOR16
 | VisCtrlIDTRANSPARENT
 | VisCtrlIDALLSTYLESLABEL
 | VisCtrlIDTEXTSTYLELABEL
 | VisCtrlIDLINESTYLELABEL
 | VisCtrlIDFILLSTYLELABEL
 | VisCtrlIDZOOMLABEL
 | VisCtrlIDFONTLABEL
 | VisCtrlIDPOINTSIZELABEL
 | VisCtrlIDLEFTCOLORLABEL
 | VisCtrlIDRIGHTCOLORLABEL
 | VisCtrlIDSTATUSLABEL
 | VisCtrlIDPREVIEWLABEL
 | VisCtrlIDSTATUSREADOUT
 | VisCtrlIDSTATUSMSG_1
 | VisCtrlIDSTATUSMSG_2
 | VisCtrlIDSTATUSMSG_3
 | VisCtrlIDSTATUSMSG_4
 | VisCtrlIDSTATUSMSG_5
 | VisCtrlIDSTATUSMSG_6
 | VisCtrlIDSTATUSMSG_7
 | VisCtrlIDSTATUSMSG_8
 | VisCtrlIDSTATUSMSG_9
 | VisCtrlIDSPLINETOOL
 | VisCtrlIDSPELLING
 | VisCtrlIDFORMATPAINTER
 | VisCtrlIDHELPMODE
 | VisCtrlIDLAYERPROPERTIES
 | VisCtrlIDLAYOUTSHAPES
 | VisCtrlIDINSERTHYPERLINK
 | VisCtrlIDSEARCHTHEWEB
 | VisCtrlIDGOBACK
 | VisCtrlIDGOFORWARD
 | VisCtrlIDWEBTOOLBAR
 | VisCtrlIDSHAPEEXPL
 | VisCtrlIDCUSTPROP
 | VisCtrlIDROTATETEXT
 | VisCtrlIDBULLETS
 | VisCtrlIDDECRINDENT
 | VisCtrlIDINCRINDENT
 | VisCtrlIDDECRPARA
 | VisCtrlIDINCRPARA
 | VisCtrlIDINSERTCONTROL
 | VisCtrlIDDESIGNMODE
 | VisCtrlIDSHAPESHEET
 | VisCtrlIDSHAPELAYER
 | VisCtrlIDGOTOPAGE
 | VisCtrlIDLINECOLORS
 | VisCtrlIDLINEWEIGHTS
 | VisCtrlIDLINEPATTERNS
 | VisCtrlIDFILLCOLORS
 | VisCtrlIDFILLPATTERNS
 | VisCtrlIDTEXTCOLORS
 | VisCtrlIDMACROS
 | VisCtrlIDVBEDITOR
 | VisCtrlIDSHAPELAYERCOMBO
 | VisCtrlIDSHAPELAYERLIST
 | VisCtrlIDALIGNSHAPES
 | VisCtrlIDDISTRIBUTESHAPES
 | VisCtrlIDMSG_PAGES
 
marshallVisUICtrlIDs :: VisUICtrlIDs -> Prelude.IO Int.Int16
marshallVisUICtrlIDs v =
  case v of
     VisCtrlIDNEW -> Prelude.return (8383)
     VisCtrlIDOPEN -> Prelude.return (1)
     VisCtrlIDOPENSTEN -> Prelude.return (2)
     VisCtrlIDSAVE -> Prelude.return (3)
     VisCtrlIDPRINT -> Prelude.return (4)
     VisCtrlIDPREVIEW -> Prelude.return (5)
     VisCtrlIDCUT -> Prelude.return (6)
     VisCtrlIDCOPY -> Prelude.return (7)
     VisCtrlIDPASTE -> Prelude.return (8)
     VisCtrlIDCLEAR -> Prelude.return (9)
     VisCtrlIDUNDO -> Prelude.return (10)
     VisCtrlIDREDO -> Prelude.return (11)
     VisCtrlIDREPEAT -> Prelude.return (12)
     VisCtrlIDPREVIOUSPAGE -> Prelude.return (13)
     VisCtrlIDNEXTPAGE -> Prelude.return (14)
     VisCtrlIDZOOMOUT -> Prelude.return (15)
     VisCtrlIDZOOMIN -> Prelude.return (16)
     VisCtrlIDZOOM100 -> Prelude.return (17)
     VisCtrlIDFLIPHORZ -> Prelude.return (18)
     VisCtrlIDFLIPVERT -> Prelude.return (19)
     VisCtrlIDPOINTERTOOL -> Prelude.return (20)
     VisCtrlIDPENCILTOOL -> Prelude.return (21)
     VisCtrlIDLINETOOL -> Prelude.return (22)
     VisCtrlIDQTRARCTOOL -> Prelude.return (23)
     VisCtrlIDRECTTOOL -> Prelude.return (24)
     VisCtrlIDOVALTOOL -> Prelude.return (25)
     VisCtrlIDSTAMPTOOL -> Prelude.return (26)
     VisCtrlIDTEXTTOOL -> Prelude.return (27)
     VisCtrlIDROTATETOOL -> Prelude.return (28)
     VisCtrlIDCROPTOOL -> Prelude.return (29)
     VisCtrlIDCONNECTIONPTTOOL -> Prelude.return (30)
     VisCtrlIDSNAP -> Prelude.return (31)
     VisCtrlIDGLUE -> Prelude.return (32)
     VisCtrlIDRULER -> Prelude.return (33)
     VisCtrlIDGRID -> Prelude.return (34)
     VisCtrlIDGUIDE -> Prelude.return (35)
     VisCtrlIDCONNECT -> Prelude.return (36)
     VisCtrlIDROTATECLOCKWISE -> Prelude.return (37)
     VisCtrlIDROTATECOUNTER -> Prelude.return (38)
     VisCtrlIDNEWWINDOW -> Prelude.return (39)
     VisCtrlIDCORNERSTYLE -> Prelude.return (40)
     VisCtrlIDLINEEND -> Prelude.return (41)
     VisCtrlIDSHADOWSTYLE -> Prelude.return (42)
     VisCtrlIDFILLCOLOR -> Prelude.return (43)
     VisCtrlIDLINECOLOR -> Prelude.return (44)
     VisCtrlIDLINEWEIGHT -> Prelude.return (45)
     VisCtrlIDLINEPATTERN -> Prelude.return (46)
     VisCtrlIDFILLPATTERN -> Prelude.return (47)
     VisCtrlIDPOINTSIZEDOWN -> Prelude.return (48)
     VisCtrlIDPOINTSIZEUP -> Prelude.return (49)
     VisCtrlIDBOLD -> Prelude.return (50)
     VisCtrlIDITALIC -> Prelude.return (51)
     VisCtrlIDULINE -> Prelude.return (52)
     VisCtrlIDSUPERSCRIPT -> Prelude.return (53)
     VisCtrlIDSUBSCRIPT -> Prelude.return (54)
     VisCtrlIDTEXTCOLOR -> Prelude.return (55)
     VisCtrlIDTEXTLEFT -> Prelude.return (56)
     VisCtrlIDTEXTCENTER -> Prelude.return (57)
     VisCtrlIDTEXTRIGHT -> Prelude.return (58)
     VisCtrlIDTEXTJUSTIFY -> Prelude.return (59)
     VisCtrlIDTEXTTOP -> Prelude.return (60)
     VisCtrlIDTEXTMIDDLE -> Prelude.return (61)
     VisCtrlIDTEXTBOTTOM -> Prelude.return (62)
     VisCtrlIDALIGN -> Prelude.return (63)
     VisCtrlIDALIGNLEFT -> Prelude.return (64)
     VisCtrlIDALIGNCENTER -> Prelude.return (65)
     VisCtrlIDALIGNRIGHT -> Prelude.return (66)
     VisCtrlIDALIGNTOP -> Prelude.return (67)
     VisCtrlIDALIGNMIDDLE -> Prelude.return (68)
     VisCtrlIDALIGNBOTTOM -> Prelude.return (69)
     VisCtrlIDDISTRIBUTE -> Prelude.return (70)
     VisCtrlIDDHORZ_EQSPACE -> Prelude.return (71)
     VisCtrlIDDHORZ_CENTER -> Prelude.return (72)
     VisCtrlIDDVERT_EQSPACE -> Prelude.return (73)
     VisCtrlIDDVERT_MIDDLE -> Prelude.return (74)
     VisCtrlIDCONNECTSHAPES -> Prelude.return (75)
{-
     VisCtrlIDFIRSTPAGE -> Prelude.return (76)
     VisCtrlIDLASTPAGE -> Prelude.return (77)
     VisCtrlIDPAGEBREAKS -> Prelude.return (78)
     VisCtrlIDICONNAME -> Prelude.return (80)
     VisCtrlIDICONONLY -> Prelude.return (81)
     VisCtrlIDNAMEONLY -> Prelude.return (82)
     VisCtrlIDARRANGEICONS -> Prelude.return (83)
     VisCtrlIDCANCELFORMULA -> Prelude.return (84)
     VisCtrlIDACCEPTFORMULA -> Prelude.return (85)
     VisCtrlIDICONPENCIL -> Prelude.return (86)
     VisCtrlIDICONBUCKET -> Prelude.return (87)
     VisCtrlIDICONLASSO -> Prelude.return (88)
     VisCtrlIDICONSELNET -> Prelude.return (89)
     VisCtrlIDBRINGFRONT -> Prelude.return (90)
     VisCtrlIDSENDBACK -> Prelude.return (91)
     VisCtrlIDGROUP -> Prelude.return (92)
     VisCtrlIDUNGROUP -> Prelude.return (93)
     VisCtrlIDCASCADE -> Prelude.return (94)
     VisCtrlIDTILE -> Prelude.return (95)
     VisCtrlIDCONNECTORTOOL -> Prelude.return (96)
     VisCtrlIDTEXTBLOCKTOOL -> Prelude.return (97)
     VisCtrlIDWHOLEPAGE -> Prelude.return (98)
     VisCtrlIDSINGLETILE -> Prelude.return (99)
     VisCtrlIDFORMULA -> Prelude.return (190)
     VisCtrlIDSPACER -> Prelude.return (191)
     VisCtrlIDALLSTYLESCOMBO -> Prelude.return (200)
     VisCtrlIDTEXTSTYLECOMBO -> Prelude.return (201)
     VisCtrlIDLINESTYLECOMBO -> Prelude.return (202)
     VisCtrlIDFILLSTYLECOMBO -> Prelude.return (203)
     VisCtrlIDZOOMCOMBO -> Prelude.return (204)
     VisCtrlIDFONTCOMBO -> Prelude.return (205)
     VisCtrlIDPOINTSIZECOMBO -> Prelude.return (206)
     VisCtrlIDALLSTYLESLIST -> Prelude.return (220)
     VisCtrlIDTEXTSTYLELIST -> Prelude.return (221)
     VisCtrlIDLINESTYLELIST -> Prelude.return (222)
     VisCtrlIDFILLSTYLELIST -> Prelude.return (223)
     VisCtrlIDZOOMLIST -> Prelude.return (224)
     VisCtrlIDFONTLIST -> Prelude.return (225)
     VisCtrlIDPOINTSIZELIST -> Prelude.return (226)
     VisCtrlIDGOTOPAGELIST -> Prelude.return (227)
     VisCtrlIDCLOSE -> Prelude.return (240)
     VisCtrlIDLEFTCOLORBOX -> Prelude.return (300)
     VisCtrlIDRIGHTCOLORBOX -> Prelude.return (301)
     VisCtrlIDCOLOR1 -> Prelude.return (302)
     VisCtrlIDCOLOR2 -> Prelude.return (303)
     VisCtrlIDCOLOR3 -> Prelude.return (304)
     VisCtrlIDCOLOR4 -> Prelude.return (305)
     VisCtrlIDCOLOR5 -> Prelude.return (306)
     VisCtrlIDCOLOR6 -> Prelude.return (307)
     VisCtrlIDCOLOR7 -> Prelude.return (308)
     VisCtrlIDCOLOR8 -> Prelude.return (309)
     VisCtrlIDCOLOR9 -> Prelude.return (310)
     VisCtrlIDCOLOR10 -> Prelude.return (311)
     VisCtrlIDCOLOR11 -> Prelude.return (312)
     VisCtrlIDCOLOR12 -> Prelude.return (313)
     VisCtrlIDCOLOR13 -> Prelude.return (314)
     VisCtrlIDCOLOR14 -> Prelude.return (315)
     VisCtrlIDCOLOR15 -> Prelude.return (316)
     VisCtrlIDCOLOR16 -> Prelude.return (317)
     VisCtrlIDTRANSPARENT -> Prelude.return (318)
     VisCtrlIDALLSTYLESLABEL -> Prelude.return (400)
     VisCtrlIDTEXTSTYLELABEL -> Prelude.return (401)
     VisCtrlIDLINESTYLELABEL -> Prelude.return (402)
     VisCtrlIDFILLSTYLELABEL -> Prelude.return (403)
     VisCtrlIDZOOMLABEL -> Prelude.return (404)
     VisCtrlIDFONTLABEL -> Prelude.return (405)
     VisCtrlIDPOINTSIZELABEL -> Prelude.return (406)
     VisCtrlIDLEFTCOLORLABEL -> Prelude.return (407)
     VisCtrlIDRIGHTCOLORLABEL -> Prelude.return (408)
     VisCtrlIDSTATUSLABEL -> Prelude.return (409)
     VisCtrlIDPREVIEWLABEL -> Prelude.return (410)
     VisCtrlIDSTATUSREADOUT -> Prelude.return (500)
     VisCtrlIDSTATUSMSG_1 -> Prelude.return (501)
     VisCtrlIDSTATUSMSG_2 -> Prelude.return (502)
     VisCtrlIDSTATUSMSG_3 -> Prelude.return (503)
     VisCtrlIDSTATUSMSG_4 -> Prelude.return (504)
     VisCtrlIDSTATUSMSG_5 -> Prelude.return (505)
     VisCtrlIDSTATUSMSG_6 -> Prelude.return (506)
     VisCtrlIDSTATUSMSG_7 -> Prelude.return (507)
     VisCtrlIDSTATUSMSG_8 -> Prelude.return (508)
     VisCtrlIDSTATUSMSG_9 -> Prelude.return (509)
     VisCtrlIDSPLINETOOL -> Prelude.return (79)
     VisCtrlIDSPELLING -> Prelude.return (100)
     VisCtrlIDFORMATPAINTER -> Prelude.return (101)
     VisCtrlIDHELPMODE -> Prelude.return (102)
     VisCtrlIDLAYERPROPERTIES -> Prelude.return (103)
     VisCtrlIDLAYOUTSHAPES -> Prelude.return (104)
     VisCtrlIDINSERTHYPERLINK -> Prelude.return (105)
     VisCtrlIDSEARCHTHEWEB -> Prelude.return (106)
     VisCtrlIDGOBACK -> Prelude.return (107)
     VisCtrlIDGOFORWARD -> Prelude.return (108)
     VisCtrlIDWEBTOOLBAR -> Prelude.return (109)
     VisCtrlIDSHAPEEXPL -> Prelude.return (110)
     VisCtrlIDCUSTPROP -> Prelude.return (111)
     VisCtrlIDROTATETEXT -> Prelude.return (112)
     VisCtrlIDBULLETS -> Prelude.return (113)
     VisCtrlIDDECRINDENT -> Prelude.return (114)
     VisCtrlIDINCRINDENT -> Prelude.return (115)
     VisCtrlIDDECRPARA -> Prelude.return (116)
     VisCtrlIDINCRPARA -> Prelude.return (117)
     VisCtrlIDINSERTCONTROL -> Prelude.return (118)
     VisCtrlIDDESIGNMODE -> Prelude.return (119)
     VisCtrlIDSHAPESHEET -> Prelude.return (120)
     VisCtrlIDSHAPELAYER -> Prelude.return (247)
     VisCtrlIDGOTOPAGE -> Prelude.return (207)
     VisCtrlIDLINECOLORS -> Prelude.return (241)
     VisCtrlIDLINEWEIGHTS -> Prelude.return (242)
     VisCtrlIDLINEPATTERNS -> Prelude.return (243)
     VisCtrlIDFILLCOLORS -> Prelude.return (244)
     VisCtrlIDFILLPATTERNS -> Prelude.return (245)
     VisCtrlIDTEXTCOLORS -> Prelude.return (246)
     VisCtrlIDMACROS -> Prelude.return (121)
     VisCtrlIDVBEDITOR -> Prelude.return (122)
     VisCtrlIDSHAPELAYERCOMBO -> Prelude.return (208)
     VisCtrlIDSHAPELAYERLIST -> Prelude.return (228)
     VisCtrlIDALIGNSHAPES -> Prelude.return (260)
     VisCtrlIDDISTRIBUTESHAPES -> Prelude.return (261)
     VisCtrlIDMSG_PAGES -> Prelude.return (510)
-}
unmarshallVisUICtrlIDs :: Int.Int16 -> Prelude.IO VisUICtrlIDs
unmarshallVisUICtrlIDs v =
  case v of
     8383 -> Prelude.return (VisCtrlIDNEW)
     1 -> Prelude.return (VisCtrlIDOPEN)
     2 -> Prelude.return (VisCtrlIDOPENSTEN)
     3 -> Prelude.return (VisCtrlIDSAVE)
     4 -> Prelude.return (VisCtrlIDPRINT)
     5 -> Prelude.return (VisCtrlIDPREVIEW)
     6 -> Prelude.return (VisCtrlIDCUT)
     7 -> Prelude.return (VisCtrlIDCOPY)
     8 -> Prelude.return (VisCtrlIDPASTE)
     9 -> Prelude.return (VisCtrlIDCLEAR)
     10 -> Prelude.return (VisCtrlIDUNDO)
     11 -> Prelude.return (VisCtrlIDREDO)
     12 -> Prelude.return (VisCtrlIDREPEAT)
     13 -> Prelude.return (VisCtrlIDPREVIOUSPAGE)
     14 -> Prelude.return (VisCtrlIDNEXTPAGE)
     15 -> Prelude.return (VisCtrlIDZOOMOUT)
     16 -> Prelude.return (VisCtrlIDZOOMIN)
     17 -> Prelude.return (VisCtrlIDZOOM100)
     18 -> Prelude.return (VisCtrlIDFLIPHORZ)
     19 -> Prelude.return (VisCtrlIDFLIPVERT)
     20 -> Prelude.return (VisCtrlIDPOINTERTOOL)
     21 -> Prelude.return (VisCtrlIDPENCILTOOL)
     22 -> Prelude.return (VisCtrlIDLINETOOL)
     23 -> Prelude.return (VisCtrlIDQTRARCTOOL)
     24 -> Prelude.return (VisCtrlIDRECTTOOL)
     25 -> Prelude.return (VisCtrlIDOVALTOOL)
     26 -> Prelude.return (VisCtrlIDSTAMPTOOL)
     27 -> Prelude.return (VisCtrlIDTEXTTOOL)
     28 -> Prelude.return (VisCtrlIDROTATETOOL)
     29 -> Prelude.return (VisCtrlIDCROPTOOL)
     30 -> Prelude.return (VisCtrlIDCONNECTIONPTTOOL)
     31 -> Prelude.return (VisCtrlIDSNAP)
     32 -> Prelude.return (VisCtrlIDGLUE)
     33 -> Prelude.return (VisCtrlIDRULER)
     34 -> Prelude.return (VisCtrlIDGRID)
     35 -> Prelude.return (VisCtrlIDGUIDE)
     36 -> Prelude.return (VisCtrlIDCONNECT)
     37 -> Prelude.return (VisCtrlIDROTATECLOCKWISE)
     38 -> Prelude.return (VisCtrlIDROTATECOUNTER)
     39 -> Prelude.return (VisCtrlIDNEWWINDOW)
     40 -> Prelude.return (VisCtrlIDCORNERSTYLE)
     41 -> Prelude.return (VisCtrlIDLINEEND)
     42 -> Prelude.return (VisCtrlIDSHADOWSTYLE)
     43 -> Prelude.return (VisCtrlIDFILLCOLOR)
     44 -> Prelude.return (VisCtrlIDLINECOLOR)
     45 -> Prelude.return (VisCtrlIDLINEWEIGHT)
     46 -> Prelude.return (VisCtrlIDLINEPATTERN)
     47 -> Prelude.return (VisCtrlIDFILLPATTERN)
     48 -> Prelude.return (VisCtrlIDPOINTSIZEDOWN)
     49 -> Prelude.return (VisCtrlIDPOINTSIZEUP)
     50 -> Prelude.return (VisCtrlIDBOLD)
     51 -> Prelude.return (VisCtrlIDITALIC)
     52 -> Prelude.return (VisCtrlIDULINE)
     53 -> Prelude.return (VisCtrlIDSUPERSCRIPT)
     54 -> Prelude.return (VisCtrlIDSUBSCRIPT)
     55 -> Prelude.return (VisCtrlIDTEXTCOLOR)
     56 -> Prelude.return (VisCtrlIDTEXTLEFT)
     57 -> Prelude.return (VisCtrlIDTEXTCENTER)
     58 -> Prelude.return (VisCtrlIDTEXTRIGHT)
     59 -> Prelude.return (VisCtrlIDTEXTJUSTIFY)
     60 -> Prelude.return (VisCtrlIDTEXTTOP)
     61 -> Prelude.return (VisCtrlIDTEXTMIDDLE)
     62 -> Prelude.return (VisCtrlIDTEXTBOTTOM)
     63 -> Prelude.return (VisCtrlIDALIGN)
     64 -> Prelude.return (VisCtrlIDALIGNLEFT)
     65 -> Prelude.return (VisCtrlIDALIGNCENTER)
     66 -> Prelude.return (VisCtrlIDALIGNRIGHT)
     67 -> Prelude.return (VisCtrlIDALIGNTOP)
     68 -> Prelude.return (VisCtrlIDALIGNMIDDLE)
     69 -> Prelude.return (VisCtrlIDALIGNBOTTOM)
     70 -> Prelude.return (VisCtrlIDDISTRIBUTE)
     71 -> Prelude.return (VisCtrlIDDHORZ_EQSPACE)
     72 -> Prelude.return (VisCtrlIDDHORZ_CENTER)
     73 -> Prelude.return (VisCtrlIDDVERT_EQSPACE)
     74 -> Prelude.return (VisCtrlIDDVERT_MIDDLE)
     75 -> Prelude.return (VisCtrlIDCONNECTSHAPES)
{-
     76 -> Prelude.return (VisCtrlIDFIRSTPAGE)
     77 -> Prelude.return (VisCtrlIDLASTPAGE)
     78 -> Prelude.return (VisCtrlIDPAGEBREAKS)
     80 -> Prelude.return (VisCtrlIDICONNAME)
     81 -> Prelude.return (VisCtrlIDICONONLY)
     82 -> Prelude.return (VisCtrlIDNAMEONLY)
     83 -> Prelude.return (VisCtrlIDARRANGEICONS)
     84 -> Prelude.return (VisCtrlIDCANCELFORMULA)
     85 -> Prelude.return (VisCtrlIDACCEPTFORMULA)
     86 -> Prelude.return (VisCtrlIDICONPENCIL)
     87 -> Prelude.return (VisCtrlIDICONBUCKET)
     88 -> Prelude.return (VisCtrlIDICONLASSO)
     89 -> Prelude.return (VisCtrlIDICONSELNET)
     90 -> Prelude.return (VisCtrlIDBRINGFRONT)
     91 -> Prelude.return (VisCtrlIDSENDBACK)
     92 -> Prelude.return (VisCtrlIDGROUP)
     93 -> Prelude.return (VisCtrlIDUNGROUP)
     94 -> Prelude.return (VisCtrlIDCASCADE)
     95 -> Prelude.return (VisCtrlIDTILE)
     96 -> Prelude.return (VisCtrlIDCONNECTORTOOL)
     97 -> Prelude.return (VisCtrlIDTEXTBLOCKTOOL)
     98 -> Prelude.return (VisCtrlIDWHOLEPAGE)
     99 -> Prelude.return (VisCtrlIDSINGLETILE)
     190 -> Prelude.return (VisCtrlIDFORMULA)
     191 -> Prelude.return (VisCtrlIDSPACER)
     200 -> Prelude.return (VisCtrlIDALLSTYLESCOMBO)
     201 -> Prelude.return (VisCtrlIDTEXTSTYLECOMBO)
     202 -> Prelude.return (VisCtrlIDLINESTYLECOMBO)
     203 -> Prelude.return (VisCtrlIDFILLSTYLECOMBO)
     204 -> Prelude.return (VisCtrlIDZOOMCOMBO)
     205 -> Prelude.return (VisCtrlIDFONTCOMBO)
     206 -> Prelude.return (VisCtrlIDPOINTSIZECOMBO)
     220 -> Prelude.return (VisCtrlIDALLSTYLESLIST)
     221 -> Prelude.return (VisCtrlIDTEXTSTYLELIST)
     222 -> Prelude.return (VisCtrlIDLINESTYLELIST)
     223 -> Prelude.return (VisCtrlIDFILLSTYLELIST)
     224 -> Prelude.return (VisCtrlIDZOOMLIST)
     225 -> Prelude.return (VisCtrlIDFONTLIST)
     226 -> Prelude.return (VisCtrlIDPOINTSIZELIST)
     227 -> Prelude.return (VisCtrlIDGOTOPAGELIST)
     240 -> Prelude.return (VisCtrlIDCLOSE)
     300 -> Prelude.return (VisCtrlIDLEFTCOLORBOX)
     301 -> Prelude.return (VisCtrlIDRIGHTCOLORBOX)
     302 -> Prelude.return (VisCtrlIDCOLOR1)
     303 -> Prelude.return (VisCtrlIDCOLOR2)
     304 -> Prelude.return (VisCtrlIDCOLOR3)
     305 -> Prelude.return (VisCtrlIDCOLOR4)
     306 -> Prelude.return (VisCtrlIDCOLOR5)
     307 -> Prelude.return (VisCtrlIDCOLOR6)
     308 -> Prelude.return (VisCtrlIDCOLOR7)
     309 -> Prelude.return (VisCtrlIDCOLOR8)
     310 -> Prelude.return (VisCtrlIDCOLOR9)
     311 -> Prelude.return (VisCtrlIDCOLOR10)
     312 -> Prelude.return (VisCtrlIDCOLOR11)
     313 -> Prelude.return (VisCtrlIDCOLOR12)
     314 -> Prelude.return (VisCtrlIDCOLOR13)
     315 -> Prelude.return (VisCtrlIDCOLOR14)
     316 -> Prelude.return (VisCtrlIDCOLOR15)
     317 -> Prelude.return (VisCtrlIDCOLOR16)
     318 -> Prelude.return (VisCtrlIDTRANSPARENT)
     400 -> Prelude.return (VisCtrlIDALLSTYLESLABEL)
     401 -> Prelude.return (VisCtrlIDTEXTSTYLELABEL)
     402 -> Prelude.return (VisCtrlIDLINESTYLELABEL)
     403 -> Prelude.return (VisCtrlIDFILLSTYLELABEL)
     404 -> Prelude.return (VisCtrlIDZOOMLABEL)
     405 -> Prelude.return (VisCtrlIDFONTLABEL)
     406 -> Prelude.return (VisCtrlIDPOINTSIZELABEL)
     407 -> Prelude.return (VisCtrlIDLEFTCOLORLABEL)
     408 -> Prelude.return (VisCtrlIDRIGHTCOLORLABEL)
     409 -> Prelude.return (VisCtrlIDSTATUSLABEL)
     410 -> Prelude.return (VisCtrlIDPREVIEWLABEL)
     500 -> Prelude.return (VisCtrlIDSTATUSREADOUT)
     501 -> Prelude.return (VisCtrlIDSTATUSMSG_1)
     502 -> Prelude.return (VisCtrlIDSTATUSMSG_2)
     503 -> Prelude.return (VisCtrlIDSTATUSMSG_3)
     504 -> Prelude.return (VisCtrlIDSTATUSMSG_4)
     505 -> Prelude.return (VisCtrlIDSTATUSMSG_5)
     506 -> Prelude.return (VisCtrlIDSTATUSMSG_6)
     507 -> Prelude.return (VisCtrlIDSTATUSMSG_7)
     508 -> Prelude.return (VisCtrlIDSTATUSMSG_8)
     509 -> Prelude.return (VisCtrlIDSTATUSMSG_9)
     79 -> Prelude.return (VisCtrlIDSPLINETOOL)
     100 -> Prelude.return (VisCtrlIDSPELLING)
     101 -> Prelude.return (VisCtrlIDFORMATPAINTER)
     102 -> Prelude.return (VisCtrlIDHELPMODE)
     103 -> Prelude.return (VisCtrlIDLAYERPROPERTIES)
     104 -> Prelude.return (VisCtrlIDLAYOUTSHAPES)
     105 -> Prelude.return (VisCtrlIDINSERTHYPERLINK)
     106 -> Prelude.return (VisCtrlIDSEARCHTHEWEB)
     107 -> Prelude.return (VisCtrlIDGOBACK)
     108 -> Prelude.return (VisCtrlIDGOFORWARD)
     109 -> Prelude.return (VisCtrlIDWEBTOOLBAR)
     110 -> Prelude.return (VisCtrlIDSHAPEEXPL)
     111 -> Prelude.return (VisCtrlIDCUSTPROP)
     112 -> Prelude.return (VisCtrlIDROTATETEXT)
     113 -> Prelude.return (VisCtrlIDBULLETS)
     114 -> Prelude.return (VisCtrlIDDECRINDENT)
     115 -> Prelude.return (VisCtrlIDINCRINDENT)
     116 -> Prelude.return (VisCtrlIDDECRPARA)
     117 -> Prelude.return (VisCtrlIDINCRPARA)
     118 -> Prelude.return (VisCtrlIDINSERTCONTROL)
     119 -> Prelude.return (VisCtrlIDDESIGNMODE)
     120 -> Prelude.return (VisCtrlIDSHAPESHEET)
     247 -> Prelude.return (VisCtrlIDSHAPELAYER)
     207 -> Prelude.return (VisCtrlIDGOTOPAGE)
     241 -> Prelude.return (VisCtrlIDLINECOLORS)
     242 -> Prelude.return (VisCtrlIDLINEWEIGHTS)
     243 -> Prelude.return (VisCtrlIDLINEPATTERNS)
     244 -> Prelude.return (VisCtrlIDFILLCOLORS)
     245 -> Prelude.return (VisCtrlIDFILLPATTERNS)
     246 -> Prelude.return (VisCtrlIDTEXTCOLORS)
     121 -> Prelude.return (VisCtrlIDMACROS)
     122 -> Prelude.return (VisCtrlIDVBEDITOR)
     208 -> Prelude.return (VisCtrlIDSHAPELAYERCOMBO)
     228 -> Prelude.return (VisCtrlIDSHAPELAYERLIST)
     260 -> Prelude.return (VisCtrlIDALIGNSHAPES)
     261 -> Prelude.return (VisCtrlIDDISTRIBUTESHAPES)
     510 -> Prelude.return (VisCtrlIDMSG_PAGES)
-}
     _ -> Prelude.fail (Prelude.userError "unmarshallVisUICtrlIDs: illegal enum value ")
data VisUIIconIDs
 = VisIconIXNEW
 | VisIconIXOPEN
 | VisIconIXOPENSTENCIL
 | VisIconIXSAVE
 | VisIconIXPRINT
 | VisIconIXPRINTPREVIEW
 | VisIconIXCUT
 | VisIconIXCOPY
 | VisIconIXPASTE
 | VisIconIXCLEAR
 | VisIconIXUNDO
 | VisIconIXREDO
 | VisIconIXREPEAT
 | VisIconIXPREVIOUSPAGE
 | VisIconIXNEXTPAGE
 | VisIconIXZOOMOUT
 | VisIconIXZOOMIN
 | VisIconIXZOOM100
 | VisIconIXFLIPHORIZONTAL
 | VisIconIXFLIPVERTICAL
 | VisIconIXPOINTERTOOL
 | VisIconIXPENCILTOOL
 | VisIconIXLINETOOL
 | VisIconIXQTRARCTOOL
 | VisIconIXRECTANGLETOOL
 | VisIconIXOVALTOOL
 | VisIconIXSTAMPTOOL
 | VisIconIXTEXTOOL
 | VisIconIXROTATETOOL
 | VisIconIXCROP
 | VisIconIXCONNECTIONPTTOOL
 | VisIconIXSNAP
 | VisIconIXGLUE
 | VisIconIXRULER
 | VisIconIXGRID
 | VisIconIXGUIDE
 | VisIconIXCONNECTIONPOINTS
 | VisIconIXROTATECLOCKWISE
 | VisIconIXROTATECOUNTERCLOCKWISE
 | VisIconIXNEWWINDOW
 | VisIconIXCORNERSTYLE
 | VisIconIXLINEEND
 | VisIconIXSHADOWSTYLE
 | VisIconIXFILLCOLOR
 | VisIconIXLINECOLOR
 | VisIconIXLINEWEIGHT
 | VisIconIXLINEPATTERN
 | VisIconIXFILLPATTERN
 | VisIconIXPOINTSIZEDOWN
 | VisIconIXPOINTSIZEUP
 | VisIconIXBOLD
 | VisIconIXITALIC
 | VisIconIXUNDERLINE
 | VisIconIXSUPERSCRIPT
 | VisIconIXSUBSCRIPT
 | VisIconIXTEXTCOLOR
 | VisIconIXTEXTALIGNLEFT
 | VisIconIXTEXTALIGNCENTER
 | VisIconIXTEXTALIGNRIGHT
 | VisIconIXTEXTALIGNJUSTIFY
 | VisIconIXTEXTALIGNTOP
 | VisIconIXTEXTALIGNMIDDLE
 | VisIconIXTEXTALIGNBOTTOM
 | VisIconIXALIGN
 | VisIconIXALIGNLEFT
 | VisIconIXALIGNCENTER
 | VisIconIXALIGNRIGHT
 | VisIconIXALIGNTOP
 | VisIconIXALIGNMIDDLE
 | VisIconIXALIGNBOTTOM
 | VisIconIXDISTRIBUTE
 | VisIconIXDHORZ_EQSPACE
 | VisIconIXDHORZ_CENTER
 | VisIconIXDVERT_EQSPACE
 | VisIconIXDVERT_MIDDLE
 | VisIconIXCONNECTSHAPES
 | VisIconIXFIRSTPAGE
 | VisIconIXLASTPAGE
 | VisIconIXPAGEBREAKS
 | VisIconIXSPLINETOOL
 | VisIconIXICONNAME
 | VisIconIXICONONLY
 | VisIconIXNAMEONLY
 | VisIconIXARRANGE
 | VisIconIXCANCEL
 | VisIconIXACCEPT
 | VisIconIXICONPENCIL
 | VisIconIXICONBUCKET
 | VisIconIXICONLASSO
 | VisIconIXICONSELNET
 | VisIconIXBRINGFRONT
 | VisIconIXSENDBACK
 | VisIconIXGROUP
 | VisIconIXUNGROUP
 | VisIconIXCASCADE
 | VisIconIXTILE
 | VisIconIXCONNECTORTOOL
 | VisIconIXTEXTBLOCKTOOL
 | VisIconIXWHOLEPAGE
 | VisIconIXSINGLETILE
 | VisIconIXSPELLING
 | VisIconIXFORMATPAINTER
 | VisIconIXHELPMODE
 | VisIconIXLAYERPROPERTIES
 | VisIconIXLAYOUTSHAPES
 | VisIconIXINSERTHYPERLINK
 | VisIconIXSEARCHTHEWEB
 | VisIconIXGOBACK
 | VisIconIXGOFORWARD
 | VisIconIXWEBTOOLBAR
 | VisIconIXSHAPEEXPL
 | VisIconIXCUSTPROP
 | VisIconIXROTATETEXT
 | VisIconIXBULLETS
 | VisIconIXDECRINDENT
 | VisIconIXINCRINDENT
 | VisIconIXDECRPARA
 | VisIconIXINCRPARA
 | VisIconIXINSERTCONTROL
 | VisIconIXDESIGNMODE
 | VisIconIXSHAPESHEET
 | VisIconIXMACROS
 | VisIconIXVBEDITOR
 
marshallVisUIIconIDs :: VisUIIconIDs -> Prelude.IO Int.Int16
marshallVisUIIconIDs v =
  case v of
     VisIconIXNEW -> Prelude.return (0)
     VisIconIXOPEN -> Prelude.return (1)
     VisIconIXOPENSTENCIL -> Prelude.return (2)
     VisIconIXSAVE -> Prelude.return (3)
     VisIconIXPRINT -> Prelude.return (4)
     VisIconIXPRINTPREVIEW -> Prelude.return (5)
     VisIconIXCUT -> Prelude.return (6)
     VisIconIXCOPY -> Prelude.return (7)
     VisIconIXPASTE -> Prelude.return (8)
     VisIconIXCLEAR -> Prelude.return (9)
     VisIconIXUNDO -> Prelude.return (10)
     VisIconIXREDO -> Prelude.return (11)
     VisIconIXREPEAT -> Prelude.return (12)
     VisIconIXPREVIOUSPAGE -> Prelude.return (13)
     VisIconIXNEXTPAGE -> Prelude.return (14)
     VisIconIXZOOMOUT -> Prelude.return (15)
     VisIconIXZOOMIN -> Prelude.return (16)
     VisIconIXZOOM100 -> Prelude.return (17)
     VisIconIXFLIPHORIZONTAL -> Prelude.return (18)
     VisIconIXFLIPVERTICAL -> Prelude.return (19)
     VisIconIXPOINTERTOOL -> Prelude.return (20)
     VisIconIXPENCILTOOL -> Prelude.return (21)
     VisIconIXLINETOOL -> Prelude.return (22)
     VisIconIXQTRARCTOOL -> Prelude.return (23)
     VisIconIXRECTANGLETOOL -> Prelude.return (24)
     VisIconIXOVALTOOL -> Prelude.return (25)
     VisIconIXSTAMPTOOL -> Prelude.return (26)
     VisIconIXTEXTOOL -> Prelude.return (27)
     VisIconIXROTATETOOL -> Prelude.return (28)
     VisIconIXCROP -> Prelude.return (29)
     VisIconIXCONNECTIONPTTOOL -> Prelude.return (30)
     VisIconIXSNAP -> Prelude.return (31)
     VisIconIXGLUE -> Prelude.return (32)
     VisIconIXRULER -> Prelude.return (33)
     VisIconIXGRID -> Prelude.return (34)
     VisIconIXGUIDE -> Prelude.return (35)
     VisIconIXCONNECTIONPOINTS -> Prelude.return (36)
     VisIconIXROTATECLOCKWISE -> Prelude.return (37)
     VisIconIXROTATECOUNTERCLOCKWISE -> Prelude.return (38)
     VisIconIXNEWWINDOW -> Prelude.return (39)
     VisIconIXCORNERSTYLE -> Prelude.return (40)
     VisIconIXLINEEND -> Prelude.return (41)
     VisIconIXSHADOWSTYLE -> Prelude.return (42)
     VisIconIXFILLCOLOR -> Prelude.return (43)
     VisIconIXLINECOLOR -> Prelude.return (44)
     VisIconIXLINEWEIGHT -> Prelude.return (45)
     VisIconIXLINEPATTERN -> Prelude.return (46)
     VisIconIXFILLPATTERN -> Prelude.return (47)
     VisIconIXPOINTSIZEDOWN -> Prelude.return (48)
     VisIconIXPOINTSIZEUP -> Prelude.return (49)
     VisIconIXBOLD -> Prelude.return (50)
     VisIconIXITALIC -> Prelude.return (51)
     VisIconIXUNDERLINE -> Prelude.return (52)
     VisIconIXSUPERSCRIPT -> Prelude.return (53)
     VisIconIXSUBSCRIPT -> Prelude.return (54)
     VisIconIXTEXTCOLOR -> Prelude.return (55)
     VisIconIXTEXTALIGNLEFT -> Prelude.return (56)
     VisIconIXTEXTALIGNCENTER -> Prelude.return (57)
     VisIconIXTEXTALIGNRIGHT -> Prelude.return (58)
     VisIconIXTEXTALIGNJUSTIFY -> Prelude.return (59)
     VisIconIXTEXTALIGNTOP -> Prelude.return (60)
     VisIconIXTEXTALIGNMIDDLE -> Prelude.return (61)
     VisIconIXTEXTALIGNBOTTOM -> Prelude.return (62)
     VisIconIXALIGN -> Prelude.return (63)
     VisIconIXALIGNLEFT -> Prelude.return (64)
     VisIconIXALIGNCENTER -> Prelude.return (65)
     VisIconIXALIGNRIGHT -> Prelude.return (66)
     VisIconIXALIGNTOP -> Prelude.return (67)
     VisIconIXALIGNMIDDLE -> Prelude.return (68)
     VisIconIXALIGNBOTTOM -> Prelude.return (69)
     VisIconIXDISTRIBUTE -> Prelude.return (70)
     VisIconIXDHORZ_EQSPACE -> Prelude.return (71)
     VisIconIXDHORZ_CENTER -> Prelude.return (72)
     VisIconIXDVERT_EQSPACE -> Prelude.return (73)
     VisIconIXDVERT_MIDDLE -> Prelude.return (74)
     VisIconIXCONNECTSHAPES -> Prelude.return (75)
     VisIconIXFIRSTPAGE -> Prelude.return (76)
     VisIconIXLASTPAGE -> Prelude.return (77)
     VisIconIXPAGEBREAKS -> Prelude.return (78)
     VisIconIXSPLINETOOL -> Prelude.return (79)
     VisIconIXICONNAME -> Prelude.return (80)
     VisIconIXICONONLY -> Prelude.return (81)
     VisIconIXNAMEONLY -> Prelude.return (82)
     VisIconIXARRANGE -> Prelude.return (83)
     VisIconIXCANCEL -> Prelude.return (84)
     VisIconIXACCEPT -> Prelude.return (85)
     VisIconIXICONPENCIL -> Prelude.return (86)
     VisIconIXICONBUCKET -> Prelude.return (87)
     VisIconIXICONLASSO -> Prelude.return (88)
     VisIconIXICONSELNET -> Prelude.return (89)
     VisIconIXBRINGFRONT -> Prelude.return (90)
     VisIconIXSENDBACK -> Prelude.return (91)
     VisIconIXGROUP -> Prelude.return (92)
     VisIconIXUNGROUP -> Prelude.return (93)
     VisIconIXCASCADE -> Prelude.return (94)
     VisIconIXTILE -> Prelude.return (95)
     VisIconIXCONNECTORTOOL -> Prelude.return (96)
     VisIconIXTEXTBLOCKTOOL -> Prelude.return (97)
     VisIconIXWHOLEPAGE -> Prelude.return (98)
     VisIconIXSINGLETILE -> Prelude.return (99)
{-
     VisIconIXSPELLING -> Prelude.return (100)
     VisIconIXFORMATPAINTER -> Prelude.return (101)
     VisIconIXHELPMODE -> Prelude.return (102)
     VisIconIXLAYERPROPERTIES -> Prelude.return (103)
     VisIconIXLAYOUTSHAPES -> Prelude.return (104)
     VisIconIXINSERTHYPERLINK -> Prelude.return (105)
     VisIconIXSEARCHTHEWEB -> Prelude.return (106)
     VisIconIXGOBACK -> Prelude.return (107)
     VisIconIXGOFORWARD -> Prelude.return (108)
     VisIconIXWEBTOOLBAR -> Prelude.return (109)
     VisIconIXSHAPEEXPL -> Prelude.return (110)
     VisIconIXCUSTPROP -> Prelude.return (111)
     VisIconIXROTATETEXT -> Prelude.return (112)
     VisIconIXBULLETS -> Prelude.return (113)
     VisIconIXDECRINDENT -> Prelude.return (114)
     VisIconIXINCRINDENT -> Prelude.return (115)
     VisIconIXDECRPARA -> Prelude.return (116)
     VisIconIXINCRPARA -> Prelude.return (117)
     VisIconIXINSERTCONTROL -> Prelude.return (118)
     VisIconIXDESIGNMODE -> Prelude.return (119)
     VisIconIXSHAPESHEET -> Prelude.return (120)
     VisIconIXMACROS -> Prelude.return (121)
     VisIconIXVBEDITOR -> Prelude.return (122)
-}
unmarshallVisUIIconIDs :: Int.Int16 -> Prelude.IO VisUIIconIDs
unmarshallVisUIIconIDs v =
  case v of
     0 -> Prelude.return (VisIconIXNEW)
     1 -> Prelude.return (VisIconIXOPEN)
     2 -> Prelude.return (VisIconIXOPENSTENCIL)
     3 -> Prelude.return (VisIconIXSAVE)
     4 -> Prelude.return (VisIconIXPRINT)
     5 -> Prelude.return (VisIconIXPRINTPREVIEW)
     6 -> Prelude.return (VisIconIXCUT)
     7 -> Prelude.return (VisIconIXCOPY)
     8 -> Prelude.return (VisIconIXPASTE)
     9 -> Prelude.return (VisIconIXCLEAR)
     10 -> Prelude.return (VisIconIXUNDO)
     11 -> Prelude.return (VisIconIXREDO)
     12 -> Prelude.return (VisIconIXREPEAT)
     13 -> Prelude.return (VisIconIXPREVIOUSPAGE)
     14 -> Prelude.return (VisIconIXNEXTPAGE)
     15 -> Prelude.return (VisIconIXZOOMOUT)
     16 -> Prelude.return (VisIconIXZOOMIN)
     17 -> Prelude.return (VisIconIXZOOM100)
     18 -> Prelude.return (VisIconIXFLIPHORIZONTAL)
     19 -> Prelude.return (VisIconIXFLIPVERTICAL)
     20 -> Prelude.return (VisIconIXPOINTERTOOL)
     21 -> Prelude.return (VisIconIXPENCILTOOL)
     22 -> Prelude.return (VisIconIXLINETOOL)
     23 -> Prelude.return (VisIconIXQTRARCTOOL)
     24 -> Prelude.return (VisIconIXRECTANGLETOOL)
     25 -> Prelude.return (VisIconIXOVALTOOL)
     26 -> Prelude.return (VisIconIXSTAMPTOOL)
     27 -> Prelude.return (VisIconIXTEXTOOL)
     28 -> Prelude.return (VisIconIXROTATETOOL)
     29 -> Prelude.return (VisIconIXCROP)
     30 -> Prelude.return (VisIconIXCONNECTIONPTTOOL)
     31 -> Prelude.return (VisIconIXSNAP)
     32 -> Prelude.return (VisIconIXGLUE)
     33 -> Prelude.return (VisIconIXRULER)
     34 -> Prelude.return (VisIconIXGRID)
     35 -> Prelude.return (VisIconIXGUIDE)
     36 -> Prelude.return (VisIconIXCONNECTIONPOINTS)
     37 -> Prelude.return (VisIconIXROTATECLOCKWISE)
     38 -> Prelude.return (VisIconIXROTATECOUNTERCLOCKWISE)
     39 -> Prelude.return (VisIconIXNEWWINDOW)
     40 -> Prelude.return (VisIconIXCORNERSTYLE)
     41 -> Prelude.return (VisIconIXLINEEND)
     42 -> Prelude.return (VisIconIXSHADOWSTYLE)
     43 -> Prelude.return (VisIconIXFILLCOLOR)
     44 -> Prelude.return (VisIconIXLINECOLOR)
     45 -> Prelude.return (VisIconIXLINEWEIGHT)
     46 -> Prelude.return (VisIconIXLINEPATTERN)
     47 -> Prelude.return (VisIconIXFILLPATTERN)
     48 -> Prelude.return (VisIconIXPOINTSIZEDOWN)
     49 -> Prelude.return (VisIconIXPOINTSIZEUP)
     50 -> Prelude.return (VisIconIXBOLD)
     51 -> Prelude.return (VisIconIXITALIC)
     52 -> Prelude.return (VisIconIXUNDERLINE)
     53 -> Prelude.return (VisIconIXSUPERSCRIPT)
     54 -> Prelude.return (VisIconIXSUBSCRIPT)
     55 -> Prelude.return (VisIconIXTEXTCOLOR)
     56 -> Prelude.return (VisIconIXTEXTALIGNLEFT)
     57 -> Prelude.return (VisIconIXTEXTALIGNCENTER)
     58 -> Prelude.return (VisIconIXTEXTALIGNRIGHT)
     59 -> Prelude.return (VisIconIXTEXTALIGNJUSTIFY)
     60 -> Prelude.return (VisIconIXTEXTALIGNTOP)
     61 -> Prelude.return (VisIconIXTEXTALIGNMIDDLE)
     62 -> Prelude.return (VisIconIXTEXTALIGNBOTTOM)
     63 -> Prelude.return (VisIconIXALIGN)
     64 -> Prelude.return (VisIconIXALIGNLEFT)
     65 -> Prelude.return (VisIconIXALIGNCENTER)
     66 -> Prelude.return (VisIconIXALIGNRIGHT)
     67 -> Prelude.return (VisIconIXALIGNTOP)
     68 -> Prelude.return (VisIconIXALIGNMIDDLE)
     69 -> Prelude.return (VisIconIXALIGNBOTTOM)
     70 -> Prelude.return (VisIconIXDISTRIBUTE)
     71 -> Prelude.return (VisIconIXDHORZ_EQSPACE)
     72 -> Prelude.return (VisIconIXDHORZ_CENTER)
     73 -> Prelude.return (VisIconIXDVERT_EQSPACE)
     74 -> Prelude.return (VisIconIXDVERT_MIDDLE)
     75 -> Prelude.return (VisIconIXCONNECTSHAPES)
     76 -> Prelude.return (VisIconIXFIRSTPAGE)
     77 -> Prelude.return (VisIconIXLASTPAGE)
     78 -> Prelude.return (VisIconIXPAGEBREAKS)
     79 -> Prelude.return (VisIconIXSPLINETOOL)
     80 -> Prelude.return (VisIconIXICONNAME)
     81 -> Prelude.return (VisIconIXICONONLY)
     82 -> Prelude.return (VisIconIXNAMEONLY)
     83 -> Prelude.return (VisIconIXARRANGE)
     84 -> Prelude.return (VisIconIXCANCEL)
     85 -> Prelude.return (VisIconIXACCEPT)
     86 -> Prelude.return (VisIconIXICONPENCIL)
     87 -> Prelude.return (VisIconIXICONBUCKET)
     88 -> Prelude.return (VisIconIXICONLASSO)
     89 -> Prelude.return (VisIconIXICONSELNET)
     90 -> Prelude.return (VisIconIXBRINGFRONT)
     91 -> Prelude.return (VisIconIXSENDBACK)
     92 -> Prelude.return (VisIconIXGROUP)
     93 -> Prelude.return (VisIconIXUNGROUP)
     94 -> Prelude.return (VisIconIXCASCADE)
     95 -> Prelude.return (VisIconIXTILE)
     96 -> Prelude.return (VisIconIXCONNECTORTOOL)
     97 -> Prelude.return (VisIconIXTEXTBLOCKTOOL)
{-
     98 -> Prelude.return (VisIconIXWHOLEPAGE)
     99 -> Prelude.return (VisIconIXSINGLETILE)
     100 -> Prelude.return (VisIconIXSPELLING)
     101 -> Prelude.return (VisIconIXFORMATPAINTER)
     102 -> Prelude.return (VisIconIXHELPMODE)
     103 -> Prelude.return (VisIconIXLAYERPROPERTIES)
     104 -> Prelude.return (VisIconIXLAYOUTSHAPES)
     105 -> Prelude.return (VisIconIXINSERTHYPERLINK)
     106 -> Prelude.return (VisIconIXSEARCHTHEWEB)
     107 -> Prelude.return (VisIconIXGOBACK)
     108 -> Prelude.return (VisIconIXGOFORWARD)
     109 -> Prelude.return (VisIconIXWEBTOOLBAR)
     110 -> Prelude.return (VisIconIXSHAPEEXPL)
     111 -> Prelude.return (VisIconIXCUSTPROP)
     112 -> Prelude.return (VisIconIXROTATETEXT)
     113 -> Prelude.return (VisIconIXBULLETS)
     114 -> Prelude.return (VisIconIXDECRINDENT)
     115 -> Prelude.return (VisIconIXINCRINDENT)
     116 -> Prelude.return (VisIconIXDECRPARA)
     117 -> Prelude.return (VisIconIXINCRPARA)
     118 -> Prelude.return (VisIconIXINSERTCONTROL)
     119 -> Prelude.return (VisIconIXDESIGNMODE)
     120 -> Prelude.return (VisIconIXSHAPESHEET)
     121 -> Prelude.return (VisIconIXMACROS)
     122 -> Prelude.return (VisIconIXVBEDITOR)
-}
     _ -> Prelude.fail (Prelude.userError "unmarshallVisUIIconIDs: illegal enum value ")
data VisUIStringIDs
 = VisStrIDBASESTRINGID
 | VisStrIDALLSTYLES
 | VisStrIDTEXTSTYLE
 | VisStrIDLINESTYLE
 | VisStrIDFILLSTYLE
 | VisStrIDZOOM
 | VisStrIDFONT
 | VisStrIDPOINTSIZE
 | VisStrIDLEFTCOLOR
 | VisStrIDRIGHTCOLOR
 | VisStrIDSTATUS
 | VisStrIDPRINTPREVIEW
 | VisStrIDTEXTEDIT
 | VisStrIDCLOSE
 | VisStrIDNONE
 | VisStrIDCHANGE
 | VisStrIDSPACE
 | VisStrIDREADY
 | VisStrIDWAIT
 | VisStrIDDRAG
 | VisStrIDDRAW
 | VisStrIDEDIT
 | VisStrIDMOVE
 | VisStrIDSIZE
 | VisStrIDROTATE
 | VisStrIDCROP
 | VisStrIDSCROLL
 | VisStrIDADD
 | VisStrIDEXTEND
 | VisStrIDCOPY
 | VisStrIDLINECOLORS
 | VisStrIDLINEWEIGHTS
 | VisStrIDLINEPATTERNS
 | VisStrIDFILLCOLORS
 | VisStrIDFILLPATTERNS
 | VisStrIDTEXTCOLORS
 | VisStrIDSHADOWS
 | VisStrIDLINEENDS
 | VisStrIDCORNERS
 | VisStrIDNOSHADOW
 
marshallVisUIStringIDs :: VisUIStringIDs -> Prelude.IO Int.Int16
marshallVisUIStringIDs v =
  case v of
     VisStrIDBASESTRINGID -> Prelude.return (2000)
     VisStrIDALLSTYLES -> Prelude.return (2000)
     VisStrIDTEXTSTYLE -> Prelude.return (2001)
     VisStrIDLINESTYLE -> Prelude.return (2002)
     VisStrIDFILLSTYLE -> Prelude.return (2003)
     VisStrIDZOOM -> Prelude.return (2004)
     VisStrIDFONT -> Prelude.return (2005)
     VisStrIDPOINTSIZE -> Prelude.return (2006)
     VisStrIDLEFTCOLOR -> Prelude.return (2007)
     VisStrIDRIGHTCOLOR -> Prelude.return (2008)
     VisStrIDSTATUS -> Prelude.return (2009)
     VisStrIDPRINTPREVIEW -> Prelude.return (2010)
     VisStrIDTEXTEDIT -> Prelude.return (2011)
     VisStrIDCLOSE -> Prelude.return (2050)
     VisStrIDNONE -> Prelude.return (2300)
     VisStrIDCHANGE -> Prelude.return (2301)
     VisStrIDSPACE -> Prelude.return (2302)
     VisStrIDREADY -> Prelude.return (2320)
     VisStrIDWAIT -> Prelude.return (2321)
     VisStrIDDRAG -> Prelude.return (2322)
     VisStrIDDRAW -> Prelude.return (2323)
     VisStrIDEDIT -> Prelude.return (2324)
     VisStrIDMOVE -> Prelude.return (2325)
     VisStrIDSIZE -> Prelude.return (2326)
     VisStrIDROTATE -> Prelude.return (2327)
     VisStrIDCROP -> Prelude.return (2328)
     VisStrIDSCROLL -> Prelude.return (2329)
     VisStrIDADD -> Prelude.return (2330)
     VisStrIDEXTEND -> Prelude.return (2331)
     VisStrIDCOPY -> Prelude.return (2332)
     VisStrIDLINECOLORS -> Prelude.return (2051)
     VisStrIDLINEWEIGHTS -> Prelude.return (2052)
     VisStrIDLINEPATTERNS -> Prelude.return (2053)
     VisStrIDFILLCOLORS -> Prelude.return (2054)
     VisStrIDFILLPATTERNS -> Prelude.return (2055)
     VisStrIDTEXTCOLORS -> Prelude.return (2056)
     VisStrIDSHADOWS -> Prelude.return (2057)
     VisStrIDLINEENDS -> Prelude.return (2058)
     VisStrIDCORNERS -> Prelude.return (2059)
     VisStrIDNOSHADOW -> Prelude.return (2060)
unmarshallVisUIStringIDs :: Int.Int16 -> Prelude.IO VisUIStringIDs
unmarshallVisUIStringIDs v =
  case v of
     2000 -> Prelude.return (VisStrIDBASESTRINGID)
     2000 -> Prelude.return (VisStrIDALLSTYLES)
     2001 -> Prelude.return (VisStrIDTEXTSTYLE)
     2002 -> Prelude.return (VisStrIDLINESTYLE)
     2003 -> Prelude.return (VisStrIDFILLSTYLE)
     2004 -> Prelude.return (VisStrIDZOOM)
     2005 -> Prelude.return (VisStrIDFONT)
     2006 -> Prelude.return (VisStrIDPOINTSIZE)
     2007 -> Prelude.return (VisStrIDLEFTCOLOR)
     2008 -> Prelude.return (VisStrIDRIGHTCOLOR)
     2009 -> Prelude.return (VisStrIDSTATUS)
     2010 -> Prelude.return (VisStrIDPRINTPREVIEW)
     2011 -> Prelude.return (VisStrIDTEXTEDIT)
     2050 -> Prelude.return (VisStrIDCLOSE)
     2300 -> Prelude.return (VisStrIDNONE)
     2301 -> Prelude.return (VisStrIDCHANGE)
     2302 -> Prelude.return (VisStrIDSPACE)
     2320 -> Prelude.return (VisStrIDREADY)
     2321 -> Prelude.return (VisStrIDWAIT)
     2322 -> Prelude.return (VisStrIDDRAG)
     2323 -> Prelude.return (VisStrIDDRAW)
     2324 -> Prelude.return (VisStrIDEDIT)
     2325 -> Prelude.return (VisStrIDMOVE)
     2326 -> Prelude.return (VisStrIDSIZE)
     2327 -> Prelude.return (VisStrIDROTATE)
     2328 -> Prelude.return (VisStrIDCROP)
     2329 -> Prelude.return (VisStrIDSCROLL)
     2330 -> Prelude.return (VisStrIDADD)
     2331 -> Prelude.return (VisStrIDEXTEND)
     2332 -> Prelude.return (VisStrIDCOPY)
     2051 -> Prelude.return (VisStrIDLINECOLORS)
     2052 -> Prelude.return (VisStrIDLINEWEIGHTS)
     2053 -> Prelude.return (VisStrIDLINEPATTERNS)
     2054 -> Prelude.return (VisStrIDFILLCOLORS)
     2055 -> Prelude.return (VisStrIDFILLPATTERNS)
     2056 -> Prelude.return (VisStrIDTEXTCOLORS)
     2057 -> Prelude.return (VisStrIDSHADOWS)
     2058 -> Prelude.return (VisStrIDLINEENDS)
     2059 -> Prelude.return (VisStrIDCORNERS)
     2060 -> Prelude.return (VisStrIDNOSHADOW)
     _ -> Prelude.fail (Prelude.userError "unmarshallVisUIStringIDs: illegal enum value ")
-- --------------------------------------------------
-- 
-- interface IVApplication
-- 
-- --------------------------------------------------
data VApplication a = VApplication
                       
type IVApplication a = Automation.IDispatch (VApplication a)
iidIVApplication :: Com.IID (IVApplication Automation.Interface)
iidIVApplication =
  Com.mkIID "{000D0700-0000-0000-C000-000000000046}"
getActiveDocument :: Automation.IDispatch a -> Prelude.IO (IVDocument Automation.Interface)
getActiveDocument =
  Automation.propertyGetID 0o0 [] Automation.outIDispatch
getActivePage :: Automation.IDispatch a -> Prelude.IO (IVPage Automation.Interface)
getActivePage =
  Automation.propertyGetID 0x1 [] Automation.outIDispatch
getActiveWindow :: Automation.IDispatch a -> Prelude.IO (IVWindow Automation.Interface)
getActiveWindow =
  Automation.propertyGetID 0x2 [] Automation.outIDispatch
getApplication :: Automation.IDispatch a -> Prelude.IO (IVApplication Automation.Interface)
getApplication =
  Automation.propertyGetID 0x3 [] Automation.outIDispatch
getDocuments :: Automation.IDispatch a -> Prelude.IO (IVDocuments Automation.Interface)
getDocuments =
  Automation.propertyGetID 0x4 [] Automation.outIDispatch
getObjectType :: Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getObjectType = Automation.propertyGetID 0x5 [] Automation.outInt
getOnDataChangeDelay :: IVApplication a -> Prelude.IO (Prelude.Int)
getOnDataChangeDelay =
  Automation.propertyGetID 0x6 [] Automation.outInt
setOnDataChangeDelay :: Prelude.Int -> IVApplication a -> Prelude.IO ()
setOnDataChangeDelay lpi4Ret =
  Automation.propertySetID 0x6 [Automation.inInt lpi4Ret]
getProcessID :: IVApplication a -> Prelude.IO (Prelude.Int)
getProcessID = Automation.propertyGetID 0x7 [] Automation.outInt
quit :: IVApplication a -> Prelude.IO ()
quit = Automation.methodID0 0x9 []
redo :: IVApplication a -> Prelude.IO ()
redo = Automation.methodID0 0xa []
getScreenUpdating :: IVApplication a -> Prelude.IO (Prelude.Int)
getScreenUpdating =
  Automation.propertyGetID 0xb [] Automation.outInt
setScreenUpdating :: Prelude.Int -> IVApplication a -> Prelude.IO ()
setScreenUpdating lpi2Ret =
  Automation.propertySetID 0xb [Automation.inInt lpi2Ret]
getStat :: Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getStat = Automation.propertyGetID 0xc [] Automation.outInt
undo :: IVApplication a -> Prelude.IO ()
undo = Automation.methodID0 0xd []
getVersion :: IVApplication a -> Prelude.IO (Prelude.String)
getVersion = Automation.propertyGetID 0xe [] Automation.outString
getWindowHandle :: Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getWindowHandle = Automation.propertyGetID 0xf [] Automation.outInt
getWindows :: Automation.IDispatch a -> Prelude.IO (IVWindows Automation.Interface)
getWindows =
  Automation.propertyGetID 0x10 [] Automation.outIDispatch
getLanguage :: IVApplication a -> Prelude.IO (Prelude.Int)
getLanguage = Automation.propertyGetID 0x8 [] Automation.outInt
getIsVisio16 :: IVApplication a -> Prelude.IO (Prelude.Int)
getIsVisio16 = Automation.propertyGetID 0x11 [] Automation.outInt
getIsVisio32 :: IVApplication a -> Prelude.IO (Prelude.Int)
getIsVisio32 = Automation.propertyGetID 0x12 [] Automation.outInt
getWindowHandle32 :: Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getWindowHandle32 =
  Automation.propertyGetID 0x13 [] Automation.outInt
getInstanceHandle :: IVApplication a -> Prelude.IO (Prelude.Int)
getInstanceHandle =
  Automation.propertyGetID 0x14 [] Automation.outInt
getInstanceHandle32 :: IVApplication a -> Prelude.IO (Prelude.Int)
getInstanceHandle32 =
  Automation.propertyGetID 0x15 [] Automation.outInt
getBuiltInMenus :: IVApplication a -> Prelude.IO (IVUIObject Automation.Interface)
getBuiltInMenus =
  Automation.propertyGetID 0x16 [] Automation.outIDispatch
getBuiltInToolbars :: Prelude.Int -> IVApplication a -> Prelude.IO (IVUIObject Automation.Interface)
getBuiltInToolbars fIgnored =
  Automation.propertyGetID 0x17 [Automation.inInt fIgnored] Automation.outIDispatch
getCustomMenus :: Automation.IDispatch a -> Prelude.IO (IVUIObject Automation.Interface)
getCustomMenus =
  Automation.propertyGetID 0x18 [] Automation.outIDispatch
setCustomMenus :: IVUIObject a0 -> Automation.IDispatch a -> Prelude.IO ()
setCustomMenus menusObject =
  Automation.methodID0 0x19 [Automation.inIDispatch menusObject]
getCustomMenusFile :: Automation.IDispatch a -> Prelude.IO (Prelude.String)
getCustomMenusFile =
  Automation.propertyGetID 0x1a [] Automation.outString
setCustomMenusFile :: Prelude.String -> Automation.IDispatch a -> Prelude.IO ()
setCustomMenusFile lpbstrRet =
  Automation.propertySetID 0x1a [Automation.inString lpbstrRet]
clearCustomMenus :: Automation.IDispatch a -> Prelude.IO ()
clearCustomMenus = Automation.methodID0 0x1b []
getCustomToolbars :: Automation.IDispatch a -> Prelude.IO (IVUIObject Automation.Interface)
getCustomToolbars =
  Automation.propertyGetID 0x1c [] Automation.outIDispatch
setCustomToolbars :: IVUIObject a0 -> Automation.IDispatch a -> Prelude.IO ()
setCustomToolbars toolbarsObject =
  Automation.methodID0 0x1d [Automation.inIDispatch toolbarsObject]
getCustomToolbarsFile :: Automation.IDispatch a -> Prelude.IO (Prelude.String)
getCustomToolbarsFile =
  Automation.propertyGetID 0x1e [] Automation.outString
setCustomToolbarsFile :: Prelude.String -> Automation.IDispatch a -> Prelude.IO ()
setCustomToolbarsFile lpbstrRet =
  Automation.propertySetID 0x1e [Automation.inString lpbstrRet]
clearCustomToolbars :: Automation.IDispatch a -> Prelude.IO ()
clearCustomToolbars = Automation.methodID0 0x1f []
getAddonPaths :: IVApplication a -> Prelude.IO (Prelude.String)
getAddonPaths =
  Automation.propertyGetID 0x20 [] Automation.outString
setAddonPaths :: Prelude.String -> IVApplication a -> Prelude.IO ()
setAddonPaths lpbstrRet =
  Automation.propertySetID 0x20 [Automation.inString lpbstrRet]
getDrawingPaths :: IVApplication a -> Prelude.IO (Prelude.String)
getDrawingPaths =
  Automation.propertyGetID 0x21 [] Automation.outString
setDrawingPaths :: Prelude.String -> IVApplication a -> Prelude.IO ()
setDrawingPaths lpbstrRet =
  Automation.propertySetID 0x21 [Automation.inString lpbstrRet]
getFilterPaths :: IVApplication a -> Prelude.IO (Prelude.String)
getFilterPaths =
  Automation.propertyGetID 0x22 [] Automation.outString
setFilterPaths :: Prelude.String -> IVApplication a -> Prelude.IO ()
setFilterPaths lpbstrRet =
  Automation.propertySetID 0x22 [Automation.inString lpbstrRet]
getHelpPaths :: IVApplication a -> Prelude.IO (Prelude.String)
getHelpPaths =
  Automation.propertyGetID 0x23 [] Automation.outString
setHelpPaths :: Prelude.String -> IVApplication a -> Prelude.IO ()
setHelpPaths lpbstrRet =
  Automation.propertySetID 0x23 [Automation.inString lpbstrRet]
getStartupPaths :: IVApplication a -> Prelude.IO (Prelude.String)
getStartupPaths =
  Automation.propertyGetID 0x24 [] Automation.outString
setStartupPaths :: Prelude.String -> IVApplication a -> Prelude.IO ()
setStartupPaths lpbstrRet =
  Automation.propertySetID 0x24 [Automation.inString lpbstrRet]
getStencilPaths :: IVApplication a -> Prelude.IO (Prelude.String)
getStencilPaths =
  Automation.propertyGetID 0x25 [] Automation.outString
setStencilPaths :: Prelude.String -> IVApplication a -> Prelude.IO ()
setStencilPaths lpbstrRet =
  Automation.propertySetID 0x25 [Automation.inString lpbstrRet]
getTemplatePaths :: IVApplication a -> Prelude.IO (Prelude.String)
getTemplatePaths =
  Automation.propertyGetID 0x26 [] Automation.outString
setTemplatePaths :: Prelude.String -> IVApplication a -> Prelude.IO ()
setTemplatePaths lpbstrRet =
  Automation.propertySetID 0x26 [Automation.inString lpbstrRet]
getUserName :: IVApplication a -> Prelude.IO (Prelude.String)
getUserName = Automation.propertyGetID 0x27 [] Automation.outString
setUserName :: Prelude.String -> IVApplication a -> Prelude.IO ()
setUserName lpbstrRet =
  Automation.propertySetID 0x27 [Automation.inString lpbstrRet]
getPromptForSummary :: IVApplication a -> Prelude.IO (Prelude.Int)
getPromptForSummary =
  Automation.propertyGetID 0x28 [] Automation.outInt
setPromptForSummary :: Prelude.Int -> IVApplication a -> Prelude.IO ()
setPromptForSummary lpi2Ret =
  Automation.propertySetID 0x28 [Automation.inInt lpi2Ret]
getAddons :: Automation.IDispatch a -> Prelude.IO (IVAddons Automation.Interface)
getAddons =
  Automation.propertyGetID 0x29 [] Automation.outIDispatch
saveWorkspaceAs :: Prelude.String -> IVApplication a -> Prelude.IO ()
saveWorkspaceAs fileName =
  Automation.methodID0 0x2a [Automation.inString fileName]
doCmd :: Prelude.Int -> IVApplication a -> Prelude.IO ()
doCmd commandID =
  Automation.methodID0 0x2b [Automation.inInt commandID]
getProfileName :: IVApplication a -> Prelude.IO (Prelude.String)
getProfileName =
  Automation.propertyGetID 0x2c [] Automation.outString
getEventInfo :: Prelude.Int -> IVApplication a -> Prelude.IO (Prelude.String)
getEventInfo reservedPass0 =
  Automation.propertyGetID 0x2d [Automation.inInt reservedPass0] Automation.outString
getEventList :: Automation.IDispatch a -> Prelude.IO (IVEventList Automation.Interface)
getEventList =
  Automation.propertyGetID 0x2e [] Automation.outIDispatch
getPersistsEvents :: Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getPersistsEvents =
  Automation.propertyGetID 0x2f [] Automation.outInt
getActive :: IVApplication a -> Prelude.IO (Prelude.Int)
getActive = Automation.propertyGetID 0x30 [] Automation.outInt
getDeferRecalc :: IVApplication a -> Prelude.IO (Prelude.Int)
getDeferRecalc = Automation.propertyGetID 0x31 [] Automation.outInt
setDeferRecalc :: Prelude.Int -> IVApplication a -> Prelude.IO ()
setDeferRecalc lpi2Ret =
  Automation.propertySetID 0x31 [Automation.inInt lpi2Ret]
getAlertResponse :: IVApplication a -> Prelude.IO (Prelude.Int)
getAlertResponse =
  Automation.propertyGetID 0x32 [] Automation.outInt
setAlertResponse :: Prelude.Int -> IVApplication a -> Prelude.IO ()
setAlertResponse lpi2Ret =
  Automation.propertySetID 0x32 [Automation.inInt lpi2Ret]
getShowProgress :: IVApplication a -> Prelude.IO (Prelude.Int)
getShowProgress =
  Automation.propertyGetID 0x33 [] Automation.outInt
setShowProgress :: Prelude.Int -> IVApplication a -> Prelude.IO ()
setShowProgress lpi2Ret =
  Automation.propertySetID 0x33 [Automation.inInt lpi2Ret]
getVbe :: Automation.IDispatch a -> Prelude.IO (Automation.IDispatch Automation.Interface)
getVbe = Automation.propertyGetID 0x34 [] Automation.outIDispatch
getShowMenus :: IVApplication a -> Prelude.IO (Prelude.Int)
getShowMenus = Automation.propertyGetID 0x35 [] Automation.outInt
setShowMenus :: Prelude.Int -> IVApplication a -> Prelude.IO ()
setShowMenus lpi2Ret =
  Automation.propertySetID 0x35 [Automation.inInt lpi2Ret]
getToolbarStyle :: IVApplication a -> Prelude.IO (Prelude.Int)
getToolbarStyle =
  Automation.propertyGetID 0x36 [] Automation.outInt
setToolbarStyle :: Prelude.Int -> IVApplication a -> Prelude.IO ()
setToolbarStyle lpi2Ret =
  Automation.propertySetID 0x36 [Automation.inInt lpi2Ret]
getShowStatusBar :: IVApplication a -> Prelude.IO (Prelude.Int)
getShowStatusBar =
  Automation.propertyGetID 0x37 [] Automation.outInt
setShowStatusBar :: Prelude.Int -> IVApplication a -> Prelude.IO ()
setShowStatusBar lpi2Ret =
  Automation.propertySetID 0x37 [Automation.inInt lpi2Ret]
getEventsEnabled :: IVApplication a -> Prelude.IO (Prelude.Int)
getEventsEnabled =
  Automation.propertyGetID 0x38 [] Automation.outInt
setEventsEnabled :: Prelude.Int -> IVApplication a -> Prelude.IO ()
setEventsEnabled lpi2Ret =
  Automation.propertySetID 0x38 [Automation.inInt lpi2Ret]
formatResult :: Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.String -> IVApplication a -> Prelude.IO (Prelude.String)
formatResult stringOrNumber unitsIn unitsOut format =
  Automation.functionID1 0x39 [Automation.inInt stringOrNumber, Automation.inInt unitsIn, Automation.inInt unitsOut, Automation.inString format] Automation.outString
convertResult :: Prelude.Int -> Prelude.Int -> Prelude.Int -> IVApplication a -> Prelude.IO (Prelude.Double)
convertResult stringOrNumber unitsIn unitsOut =
  Automation.functionID1 0x3a [Automation.inInt stringOrNumber, Automation.inInt unitsIn, Automation.inInt unitsOut] Automation.outDouble
getPath :: Automation.IDispatch a -> Prelude.IO (Prelude.String)
getPath = Automation.propertyGetID 0x3b [] Automation.outString
--enumDirectories :: Prelude.String -> IVApplication a -> Prelude.IO (Array.Array Prelude.Int z)
--enumDirectories pathsString =
--  Automation.methodID1 0x3c [Automation.inString pathsString] Automation.outArray
getTraceFlags :: IVApplication a -> Prelude.IO (Prelude.Int)
getTraceFlags = Automation.propertyGetID 0x3d [] Automation.outInt
setTraceFlags :: Prelude.Int -> IVApplication a -> Prelude.IO ()
setTraceFlags lpi4Ret =
  Automation.propertySetID 0x3d [Automation.inInt lpi4Ret]
purgeUndo :: IVApplication a -> Prelude.IO ()
purgeUndo = Automation.methodID0 0x3e []
queueMarkerEvent :: Prelude.String -> IVApplication a -> Prelude.IO (Prelude.Int)
queueMarkerEvent contextString =
  Automation.functionID1 0x3f [Automation.inString contextString] Automation.outInt
getShowToolbar :: IVApplication a -> Prelude.IO (Prelude.Int)
getShowToolbar = Automation.propertyGetID 0x40 [] Automation.outInt
setShowToolbar :: Prelude.Int -> IVApplication a -> Prelude.IO ()
setShowToolbar lpi2Ret =
  Automation.propertySetID 0x40 [Automation.inInt lpi2Ret]
-- --------------------------------------------------
-- 
-- interface IVCell
-- 
-- --------------------------------------------------
data VCell a = VCell
                
type IVCell a = Automation.IDispatch (VCell a)
iidIVCell :: Com.IID (IVCell Automation.Interface)
iidIVCell = Com.mkIID "{000D0701-0000-0000-C000-000000000046}"
getError :: IVCell a -> Prelude.IO (Prelude.Int)
getError = Automation.propertyGetID 0x3 [] Automation.outInt
getFormula :: IVCell a -> Prelude.IO (Prelude.String)
getFormula = Automation.propertyGetID 0x4 [] Automation.outString
setFormula :: Prelude.String -> IVCell a -> Prelude.IO ()
setFormula lpbstrRet =
  Automation.propertySetID 0x4 [Automation.inString lpbstrRet]
setFormulaForce :: Prelude.String -> IVCell a -> Prelude.IO ()
setFormulaForce rhs =
  Automation.propertySetID 0x5 [Automation.inString rhs]
glueTo :: IVCell a0 -> IVCell a -> Prelude.IO ()
glueTo cellObject =
  Automation.methodID0 0x6 [Automation.inIDispatch cellObject]
glueToPos :: IVShape a0 -> Prelude.Double -> Prelude.Double -> IVCell a -> Prelude.IO ()
glueToPos sheetObject xPercent yPercent =
  Automation.methodID0 0x7 [Automation.inIDispatch sheetObject, Automation.inDouble xPercent, Automation.inDouble yPercent]
getResult :: Prelude.Int -> IVCell a -> Prelude.IO (Prelude.Double)
getResult unitsNameOrCode =
  Automation.propertyGetID 0x8 [Automation.inInt unitsNameOrCode] Automation.outDouble
setResult :: Prelude.Int -> Prelude.Double -> IVCell a -> Prelude.IO ()
setResult unitsNameOrCode lpr8Ret =
  Automation.propertySetID 0x8 [Automation.inInt unitsNameOrCode, Automation.inDouble lpr8Ret]
setResultForce :: Prelude.Int -> Prelude.Double -> IVCell a -> Prelude.IO ()
setResultForce unitsNameOrCode rhs =
  Automation.propertySetID 0x9 [Automation.inInt unitsNameOrCode, Automation.inDouble rhs]
getResultIU :: IVCell a -> Prelude.IO (Prelude.Double)
getResultIU = Automation.propertyGetID 0o0 [] Automation.outDouble
setResultIU :: Prelude.Double -> IVCell a -> Prelude.IO ()
setResultIU lpr8Ret =
  Automation.propertySetID 0o0 [Automation.inDouble lpr8Ret]
setResultIUForce :: Prelude.Double -> IVCell a -> Prelude.IO ()
setResultIUForce rhs =
  Automation.propertySetID 0xa [Automation.inDouble rhs]
getUnits :: IVCell a -> Prelude.IO (Prelude.Int)
getUnits = Automation.propertyGetID 0xc [] Automation.outInt
getName :: Automation.IDispatch a -> Prelude.IO (Prelude.String)
getName = Automation.propertyGetID 0xd [] Automation.outString
getLocalName :: IVCell a -> Prelude.IO (Prelude.String)
getLocalName = Automation.propertyGetID 0xe [] Automation.outString
setRowName :: Prelude.String -> IVCell a -> Prelude.IO ()
setRowName lpbstrRet =
  Automation.propertySetID 0xf [Automation.inString lpbstrRet]
getDocument :: Automation.IDispatch a -> Prelude.IO (IVDocument Automation.Interface)
getDocument =
  Automation.propertyGetID 0x10 [] Automation.outIDispatch
getShape :: Automation.IDispatch a -> Prelude.IO (IVShape Automation.Interface)
getShape = Automation.propertyGetID 0x11 [] Automation.outIDispatch
getStyle :: IVCell a -> Prelude.IO (IVStyle Automation.Interface)
getStyle = Automation.propertyGetID 0x12 [] Automation.outIDispatch
getSection :: IVCell a -> Prelude.IO (Prelude.Int)
getSection = Automation.propertyGetID 0x13 [] Automation.outInt
getRow :: Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getRow = Automation.propertyGetID 0x14 [] Automation.outInt
getColumn :: IVCell a -> Prelude.IO (Prelude.Int)
getColumn = Automation.propertyGetID 0x15 [] Automation.outInt
getIsConstant :: IVCell a -> Prelude.IO (Prelude.Int)
getIsConstant = Automation.propertyGetID 0x16 [] Automation.outInt
getIsInherited :: IVCell a -> Prelude.IO (Prelude.Int)
getIsInherited = Automation.propertyGetID 0x17 [] Automation.outInt
getResultInt :: Prelude.Int -> Prelude.Int -> IVCell a -> Prelude.IO (Prelude.Int)
getResultInt unitsNameOrCode fRound =
  Automation.propertyGetID 0x18 [Automation.inInt unitsNameOrCode, Automation.inInt fRound] Automation.outInt
setResultFromInt :: Prelude.Int -> Prelude.Int -> IVCell a -> Prelude.IO ()
setResultFromInt unitsNameOrCode rhs =
  Automation.propertySetID 0x9c3 [Automation.inInt unitsNameOrCode, Automation.inInt rhs]
setResultFromIntForce :: Prelude.Int -> Prelude.Int -> IVCell a -> Prelude.IO ()
setResultFromIntForce unitsNameOrCode rhs =
  Automation.propertySetID 0x19 [Automation.inInt unitsNameOrCode, Automation.inInt rhs]
getResultStr :: Prelude.Int -> IVCell a -> Prelude.IO (Prelude.String)
getResultStr unitsNameOrCode =
  Automation.propertyGetID 0x1a [Automation.inInt unitsNameOrCode] Automation.outString
trigger :: IVCell a -> Prelude.IO ()
trigger = Automation.methodID0 0x1b []
getRowName :: IVCell a -> Prelude.IO (Prelude.String)
getRowName = Automation.propertyGetID 0xf [] Automation.outString
-- --------------------------------------------------
-- 
-- interface IVCharacters
-- 
-- --------------------------------------------------
data VCharacters a = VCharacters
                      
type IVCharacters a = Automation.IDispatch (VCharacters a)
iidIVCharacters :: Com.IID (IVCharacters Automation.Interface)
iidIVCharacters =
  Com.mkIID "{000D0702-0000-0000-C000-000000000046}"
addCustomField :: Prelude.String -> Prelude.Int -> IVCharacters a -> Prelude.IO ()
addCustomField formula format =
  Automation.methodID0 0x1 [Automation.inString formula, Automation.inInt format]
addField :: Prelude.Int -> Prelude.Int -> Prelude.Int -> IVCharacters a -> Prelude.IO ()
addField category code format =
  Automation.methodID0 0x2 [Automation.inInt category, Automation.inInt code, Automation.inInt format]
getBegin :: IVCharacters a -> Prelude.IO (Prelude.Int)
getBegin = Automation.propertyGetID 0x4 [] Automation.outInt
setBegin :: Prelude.Int -> IVCharacters a -> Prelude.IO ()
setBegin lpi4Ret =
  Automation.propertySetID 0x4 [Automation.inInt lpi4Ret]
getCharCount :: Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getCharCount = Automation.propertyGetID 0x5 [] Automation.outInt
setCharProps :: Prelude.Int -> Prelude.Int -> IVCharacters a -> Prelude.IO ()
setCharProps cellIndex rhs =
  Automation.propertySetID 0x15 [Automation.inInt cellIndex, Automation.inInt rhs]
getCharPropsRow :: Prelude.Int -> IVCharacters a -> Prelude.IO (Prelude.Int)
getCharPropsRow biasLorR =
  Automation.propertyGetID 0x10 [Automation.inInt biasLorR] Automation.outInt
copy :: Automation.IDispatch a -> Prelude.IO ()
copy = Automation.methodID0 0x6 []
cut :: Automation.IDispatch a -> Prelude.IO ()
cut = Automation.methodID0 0x7 []
getEnd :: IVCharacters a -> Prelude.IO (Prelude.Int)
getEnd = Automation.propertyGetID 0x9 [] Automation.outInt
setEnd :: Prelude.Int -> IVCharacters a -> Prelude.IO ()
setEnd lpi4Ret =
  Automation.propertySetID 0x9 [Automation.inInt lpi4Ret]
getFieldCategory :: IVCharacters a -> Prelude.IO (Prelude.Int)
getFieldCategory =
  Automation.propertyGetID 0xa [] Automation.outInt
getFieldCode :: IVCharacters a -> Prelude.IO (Prelude.Int)
getFieldCode = Automation.propertyGetID 0xb [] Automation.outInt
getFieldFormat :: IVCharacters a -> Prelude.IO (Prelude.Int)
getFieldFormat = Automation.propertyGetID 0xc [] Automation.outInt
getFieldFormula :: IVCharacters a -> Prelude.IO (Prelude.String)
getFieldFormula =
  Automation.propertyGetID 0xd [] Automation.outString
getIsField :: IVCharacters a -> Prelude.IO (Prelude.Int)
getIsField = Automation.propertyGetID 0xe [] Automation.outInt
setParaProps :: Prelude.Int -> Prelude.Int -> IVCharacters a -> Prelude.IO ()
setParaProps cellIndex rhs =
  Automation.propertySetID 0x16 [Automation.inInt cellIndex, Automation.inInt rhs]
getParaPropsRow :: Prelude.Int -> IVCharacters a -> Prelude.IO (Prelude.Int)
getParaPropsRow biasLorR =
  Automation.propertyGetID 0x11 [Automation.inInt biasLorR] Automation.outInt
paste :: Automation.IDispatch a -> Prelude.IO ()
paste = Automation.methodID0 0xf []
getTabPropsRow :: Prelude.Int -> IVCharacters a -> Prelude.IO (Prelude.Int)
getTabPropsRow biasLorR =
  Automation.propertyGetID 0x12 [Automation.inInt biasLorR] Automation.outInt
getRunBegin :: Prelude.Int -> IVCharacters a -> Prelude.IO (Prelude.Int)
getRunBegin runType =
  Automation.propertyGetID 0x13 [Automation.inInt runType] Automation.outInt
getRunEnd :: Prelude.Int -> IVCharacters a -> Prelude.IO (Prelude.Int)
getRunEnd runType =
  Automation.propertyGetID 0x14 [Automation.inInt runType] Automation.outInt
getTextAsString :: IVCharacters a -> Prelude.IO (Prelude.String)
getTextAsString =
  Automation.propertyGetID 0x63 [] Automation.outString
setText :: Prelude.Int -> IVCharacters a -> Prelude.IO ()
setText lpvarRet =
  Automation.propertySetID 0o0 [Automation.inInt lpvarRet]
getText :: IVCharacters a -> Prelude.IO (Prelude.Int)
getText = Automation.propertyGetID 0o0 [] Automation.outInt
-- --------------------------------------------------
-- 
-- interface IVConnect
-- 
-- --------------------------------------------------
data VConnect a = VConnect
                   
type IVConnect a = Automation.IDispatch (VConnect a)
iidIVConnect :: Com.IID (IVConnect Automation.Interface)
iidIVConnect = Com.mkIID "{000D0703-0000-0000-C000-000000000046}"
getFromSheet :: Automation.IDispatch a -> Prelude.IO (IVShape Automation.Interface)
getFromSheet =
  Automation.propertyGetID 0o0 [] Automation.outIDispatch
getToSheet :: Automation.IDispatch a -> Prelude.IO (IVShape Automation.Interface)
getToSheet =
  Automation.propertyGetID 0x1 [] Automation.outIDispatch
getFromCell :: IVConnect a -> Prelude.IO (IVCell Automation.Interface)
getFromCell =
  Automation.propertyGetID 0x2 [] Automation.outIDispatch
getToCell :: IVConnect a -> Prelude.IO (IVCell Automation.Interface)
getToCell = Automation.propertyGetID 0x3 [] Automation.outIDispatch
getFromPart :: IVConnect a -> Prelude.IO (Prelude.Int)
getFromPart = Automation.propertyGetID 0x4 [] Automation.outInt
getToPart :: IVConnect a -> Prelude.IO (Prelude.Int)
getToPart = Automation.propertyGetID 0x5 [] Automation.outInt
getIndex :: Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getIndex = Automation.propertyGetID 0x9 [] Automation.outInt
-- --------------------------------------------------
-- 
-- interface IVConnects
-- 
-- --------------------------------------------------
data VConnects a = VConnects
                    
type IVConnects a = Automation.IDispatch (VConnects a)
iidIVConnects :: Com.IID (IVConnects Automation.Interface)
iidIVConnects = Com.mkIID "{000D0704-0000-0000-C000-000000000046}"
getItem :: Prelude.Int -> IVConnects a -> Prelude.IO (IVConnect Automation.Interface)
getItem index =
  Automation.propertyGetID 0o0 [Automation.inInt index] Automation.outIDispatch
getCount :: Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getCount = Automation.propertyGetID 0x1 [] Automation.outInt
-- --------------------------------------------------
-- 
-- interface IVDocument
-- 
-- --------------------------------------------------
data VDocument a = VDocument
                    
type IVDocument a = Automation.IDispatch (VDocument a)
iidIVDocument :: Com.IID (IVDocument Automation.Interface)
iidIVDocument = Com.mkIID "{000D0705-0000-0000-C000-000000000046}"
getInPlace :: IVDocument a -> Prelude.IO (Prelude.Int)
getInPlace = Automation.propertyGetID 0x5 [] Automation.outInt
getMasters :: IVDocument a -> Prelude.IO (IVMasters Automation.Interface)
getMasters =
  Automation.propertyGetID 0x6 [] Automation.outIDispatch
getPages :: IVDocument a -> Prelude.IO (IVPages Automation.Interface)
getPages = Automation.propertyGetID 0x7 [] Automation.outIDispatch
getStyles :: IVDocument a -> Prelude.IO (IVStyles Automation.Interface)
getStyles = Automation.propertyGetID 0x8 [] Automation.outIDispatch
getFullName :: IVDocument a -> Prelude.IO (Prelude.String)
getFullName = Automation.propertyGetID 0x15 [] Automation.outString
drop :: Com.IUnknown a0 -> Prelude.Int -> Prelude.Int -> IVDocument a -> Prelude.IO (IVMaster Automation.Interface)
drop objectToDrop xPos yPos =
  Automation.functionID1 0x9 [Automation.inIUnknown objectToDrop, Automation.inInt xPos, Automation.inInt yPos] Automation.outIDispatch
getSaved :: IVDocument a -> Prelude.IO (Prelude.Int)
getSaved = Automation.propertyGetID 0xa [] Automation.outInt
setSaved :: Prelude.Int -> IVDocument a -> Prelude.IO ()
setSaved lpi2Ret =
  Automation.propertySetID 0xa [Automation.inInt lpi2Ret]
getReadOnly :: IVDocument a -> Prelude.IO (Prelude.Int)
getReadOnly = Automation.propertyGetID 0xb [] Automation.outInt
save :: IVDocument a -> Prelude.IO (Prelude.Int)
save = Automation.functionID1 0xc [] Automation.outInt
saveAs :: Prelude.String -> IVDocument a -> Prelude.IO (Prelude.Int)
saveAs fileName =
  Automation.functionID1 0xd [Automation.inString fileName] Automation.outInt
getVersion0 :: IVDocument a -> Prelude.IO (Prelude.Int)
getVersion0 = Automation.propertyGetID 0xe [] Automation.outInt
setVersion :: Prelude.Int -> IVDocument a -> Prelude.IO ()
setVersion lpi4Ret =
  Automation.propertySetID 0xe [Automation.inInt lpi4Ret]
getTitle :: IVDocument a -> Prelude.IO (Prelude.String)
getTitle = Automation.propertyGetID 0xf [] Automation.outString
setTitle :: Prelude.String -> IVDocument a -> Prelude.IO ()
setTitle lpbstrRet =
  Automation.propertySetID 0xf [Automation.inString lpbstrRet]
getSubject :: IVDocument a -> Prelude.IO (Prelude.String)
getSubject = Automation.propertyGetID 0x10 [] Automation.outString
setSubject :: Prelude.String -> IVDocument a -> Prelude.IO ()
setSubject lpbstrRet =
  Automation.propertySetID 0x10 [Automation.inString lpbstrRet]
getCreator :: IVDocument a -> Prelude.IO (Prelude.String)
getCreator = Automation.propertyGetID 0x11 [] Automation.outString
setCreator :: Prelude.String -> IVDocument a -> Prelude.IO ()
setCreator lpbstrRet =
  Automation.propertySetID 0x11 [Automation.inString lpbstrRet]
getKeywords :: IVDocument a -> Prelude.IO (Prelude.String)
getKeywords = Automation.propertyGetID 0x12 [] Automation.outString
setKeywords :: Prelude.String -> IVDocument a -> Prelude.IO ()
setKeywords lpbstrRet =
  Automation.propertySetID 0x12 [Automation.inString lpbstrRet]
getDescription :: Automation.IDispatch a -> Prelude.IO (Prelude.String)
getDescription =
  Automation.propertyGetID 0x13 [] Automation.outString
setDescription :: Prelude.String -> Automation.IDispatch a -> Prelude.IO ()
setDescription lpbstrRet =
  Automation.propertySetID 0x13 [Automation.inString lpbstrRet]
print :: Automation.IDispatch a -> Prelude.IO ()
print = Automation.methodID0 0x16 []
close :: Automation.IDispatch a -> Prelude.IO ()
close = Automation.methodID0 0x17 []
getFonts :: IVDocument a -> Prelude.IO (IVFonts Automation.Interface)
getFonts = Automation.propertyGetID 0x20 [] Automation.outIDispatch
getColors :: IVDocument a -> Prelude.IO (IVColors Automation.Interface)
getColors =
  Automation.propertyGetID 0x21 [] Automation.outIDispatch
getTemplate :: IVDocument a -> Prelude.IO (Prelude.String)
getTemplate = Automation.propertyGetID 0x23 [] Automation.outString
saveAsEx :: Prelude.String -> Prelude.Int -> IVDocument a -> Prelude.IO ()
saveAsEx fileName saveFlags =
  Automation.methodID0 0x24 [Automation.inString fileName, Automation.inInt saveFlags]
getSavePreviewMode :: IVDocument a -> Prelude.IO (Prelude.Int)
getSavePreviewMode =
  Automation.propertyGetID 0x25 [] Automation.outInt
setSavePreviewMode :: Prelude.Int -> IVDocument a -> Prelude.IO ()
setSavePreviewMode lpi2Ret =
  Automation.propertySetID 0x25 [Automation.inInt lpi2Ret]
getIcon :: Prelude.Int -> Prelude.String -> IVDocument a -> Prelude.IO ()
getIcon iD fileName =
  Automation.methodID0 0x26 [Automation.inInt iD, Automation.inString fileName]
setIcon :: Prelude.Int -> Prelude.Int -> Prelude.String -> IVDocument a -> Prelude.IO ()
setIcon iD index fileName =
  Automation.methodID0 0x27 [Automation.inInt iD, Automation.inInt index, Automation.inString fileName]
getLeftMargin :: Prelude.Int -> IVDocument a -> Prelude.IO (Prelude.Double)
getLeftMargin unitsNameOrCode =
  Automation.propertyGetID 0x28 [Automation.inInt unitsNameOrCode] Automation.outDouble
setLeftMargin :: Prelude.Int -> Prelude.Double -> IVDocument a -> Prelude.IO ()
setLeftMargin unitsNameOrCode lpr8Ret =
  Automation.propertySetID 0x28 [Automation.inInt unitsNameOrCode, Automation.inDouble lpr8Ret]
getRightMargin :: Prelude.Int -> IVDocument a -> Prelude.IO (Prelude.Double)
getRightMargin unitsNameOrCode =
  Automation.propertyGetID 0x29 [Automation.inInt unitsNameOrCode] Automation.outDouble
setRightMargin :: Prelude.Int -> Prelude.Double -> IVDocument a -> Prelude.IO ()
setRightMargin unitsNameOrCode lpr8Ret =
  Automation.propertySetID 0x29 [Automation.inInt unitsNameOrCode, Automation.inDouble lpr8Ret]
getTopMargin :: Prelude.Int -> IVDocument a -> Prelude.IO (Prelude.Double)
getTopMargin unitsNameOrCode =
  Automation.propertyGetID 0x2a [Automation.inInt unitsNameOrCode] Automation.outDouble
setTopMargin :: Prelude.Int -> Prelude.Double -> IVDocument a -> Prelude.IO ()
setTopMargin unitsNameOrCode lpr8Ret =
  Automation.propertySetID 0x2a [Automation.inInt unitsNameOrCode, Automation.inDouble lpr8Ret]
getBottomMargin :: Prelude.Int -> IVDocument a -> Prelude.IO (Prelude.Double)
getBottomMargin unitsNameOrCode =
  Automation.propertyGetID 0x2b [Automation.inInt unitsNameOrCode] Automation.outDouble
setBottomMargin :: Prelude.Int -> Prelude.Double -> IVDocument a -> Prelude.IO ()
setBottomMargin unitsNameOrCode lpr8Ret =
  Automation.propertySetID 0x2b [Automation.inInt unitsNameOrCode, Automation.inDouble lpr8Ret]
getPrintLandscape :: IVDocument a -> Prelude.IO (Prelude.Int)
getPrintLandscape =
  Automation.propertyGetID 0x2c [] Automation.outInt
setPrintLandscape :: Prelude.Int -> IVDocument a -> Prelude.IO ()
setPrintLandscape lpi2Ret =
  Automation.propertySetID 0x2c [Automation.inInt lpi2Ret]
getPrintCenteredH :: IVDocument a -> Prelude.IO (Prelude.Int)
getPrintCenteredH =
  Automation.propertyGetID 0x2d [] Automation.outInt
setPrintCenteredH :: Prelude.Int -> IVDocument a -> Prelude.IO ()
setPrintCenteredH lpi2Ret =
  Automation.propertySetID 0x2d [Automation.inInt lpi2Ret]
getPrintCenteredV :: IVDocument a -> Prelude.IO (Prelude.Int)
getPrintCenteredV =
  Automation.propertyGetID 0x2e [] Automation.outInt
setPrintCenteredV :: Prelude.Int -> IVDocument a -> Prelude.IO ()
setPrintCenteredV lpi2Ret =
  Automation.propertySetID 0x2e [Automation.inInt lpi2Ret]
getPrintScale :: IVDocument a -> Prelude.IO (Prelude.Double)
getPrintScale =
  Automation.propertyGetID 0x2f [] Automation.outDouble
setPrintScale :: Prelude.Double -> IVDocument a -> Prelude.IO ()
setPrintScale lpr8Ret =
  Automation.propertySetID 0x2f [Automation.inDouble lpr8Ret]
getPrintFitOnPages :: IVDocument a -> Prelude.IO (Prelude.Int)
getPrintFitOnPages =
  Automation.propertyGetID 0x30 [] Automation.outInt
setPrintFitOnPages :: Prelude.Int -> IVDocument a -> Prelude.IO ()
setPrintFitOnPages lpi2Ret =
  Automation.propertySetID 0x30 [Automation.inInt lpi2Ret]
getPrintPagesAcross :: IVDocument a -> Prelude.IO (Prelude.Int)
getPrintPagesAcross =
  Automation.propertyGetID 0x31 [] Automation.outInt
setPrintPagesAcross :: Prelude.Int -> IVDocument a -> Prelude.IO ()
setPrintPagesAcross lpi2Ret =
  Automation.propertySetID 0x31 [Automation.inInt lpi2Ret]
getPrintPagesDown :: IVDocument a -> Prelude.IO (Prelude.Int)
getPrintPagesDown =
  Automation.propertyGetID 0x32 [] Automation.outInt
setPrintPagesDown :: Prelude.Int -> IVDocument a -> Prelude.IO ()
setPrintPagesDown lpi2Ret =
  Automation.propertySetID 0x32 [Automation.inInt lpi2Ret]
getDefaultStyle :: IVDocument a -> Prelude.IO (Prelude.String)
getDefaultStyle =
  Automation.propertyGetID 0x33 [] Automation.outString
setDefaultStyle :: Prelude.String -> IVDocument a -> Prelude.IO ()
setDefaultStyle lpbstrRet =
  Automation.propertySetID 0x33 [Automation.inString lpbstrRet]
getDefaultLineStyle :: IVDocument a -> Prelude.IO (Prelude.String)
getDefaultLineStyle =
  Automation.propertyGetID 0x34 [] Automation.outString
setDefaultLineStyle :: Prelude.String -> IVDocument a -> Prelude.IO ()
setDefaultLineStyle lpbstrRet =
  Automation.propertySetID 0x34 [Automation.inString lpbstrRet]
getDefaultFillStyle :: IVDocument a -> Prelude.IO (Prelude.String)
getDefaultFillStyle =
  Automation.propertyGetID 0x35 [] Automation.outString
setDefaultFillStyle :: Prelude.String -> IVDocument a -> Prelude.IO ()
setDefaultFillStyle lpbstrRet =
  Automation.propertySetID 0x35 [Automation.inString lpbstrRet]
getDefaultTextStyle :: IVDocument a -> Prelude.IO (Prelude.String)
getDefaultTextStyle =
  Automation.propertyGetID 0x36 [] Automation.outString
setDefaultTextStyle :: Prelude.String -> IVDocument a -> Prelude.IO ()
setDefaultTextStyle lpbstrRet =
  Automation.propertySetID 0x36 [Automation.inString lpbstrRet]
openStencilWindow :: IVDocument a -> Prelude.IO (IVWindow Automation.Interface)
openStencilWindow =
  Automation.functionID1 0x38 [] Automation.outIDispatch
parseLine :: Prelude.String -> IVDocument a -> Prelude.IO ()
parseLine line =
  Automation.methodID0 0x39 [Automation.inString line]
executeLine :: Prelude.String -> IVDocument a -> Prelude.IO ()
executeLine line =
  Automation.methodID0 0x3a [Automation.inString line]
getVBProject :: IVDocument a -> Prelude.IO (Automation.IDispatch Automation.Interface)
getVBProject =
  Automation.propertyGetID 0x3b [] Automation.outIDispatch
getPaperWidth :: Prelude.Int -> IVDocument a -> Prelude.IO (Prelude.Double)
getPaperWidth unitsNameOrCode =
  Automation.propertyGetID 0x3c [Automation.inInt unitsNameOrCode] Automation.outDouble
getPaperHeight :: Prelude.Int -> IVDocument a -> Prelude.IO (Prelude.Double)
getPaperHeight unitsNameOrCode =
  Automation.propertyGetID 0x3d [Automation.inInt unitsNameOrCode] Automation.outDouble
getPaperSize :: IVDocument a -> Prelude.IO (Prelude.Int)
getPaperSize = Automation.propertyGetID 0x3e [] Automation.outInt
setPaperSize :: Prelude.Int -> IVDocument a -> Prelude.IO ()
setPaperSize lpi2Ret =
  Automation.propertySetID 0x3e [Automation.inInt lpi2Ret]
followHyperlink45 :: Prelude.String -> Prelude.String -> IVDocument a -> Prelude.IO ()
followHyperlink45 target location =
  Automation.methodID0 0x3f [Automation.inString target, Automation.inString location]
getCodeName :: IVDocument a -> Prelude.IO (Prelude.String)
getCodeName =
  Automation.propertyGetID 0x80010000 [] Automation.outString
getMode :: IVDocument a -> Prelude.IO (Prelude.Int)
getMode = Automation.propertyGetID 0x40 [] Automation.outInt
setMode :: Prelude.Int -> IVDocument a -> Prelude.IO ()
setMode lpi2Ret =
  Automation.propertySetID 0x40 [Automation.inInt lpi2Ret]
getOLEObjects :: Automation.IDispatch a -> Prelude.IO (IVOLEObjects Automation.Interface)
getOLEObjects =
  Automation.propertyGetID 0x41 [] Automation.outIDispatch
followHyperlink :: Prelude.String -> Prelude.String -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> IVDocument a -> Prelude.IO ()
followHyperlink address subAddress extraInfo frame newWindow res1 res2 res3 =
  Automation.methodID0 0x42 [Automation.inString address, Automation.inString subAddress, Automation.inInt extraInfo, Automation.inInt frame, Automation.inInt newWindow, Automation.inInt res1, Automation.inInt res2, Automation.inInt res3]
getManager :: IVDocument a -> Prelude.IO (Prelude.String)
getManager = Automation.propertyGetID 0x43 [] Automation.outString
setManager :: Prelude.String -> IVDocument a -> Prelude.IO ()
setManager lpbstrRet =
  Automation.propertySetID 0x43 [Automation.inString lpbstrRet]
getCompany :: IVDocument a -> Prelude.IO (Prelude.String)
getCompany = Automation.propertyGetID 0x44 [] Automation.outString
setCompany :: Prelude.String -> IVDocument a -> Prelude.IO ()
setCompany lpbstrRet =
  Automation.propertySetID 0x44 [Automation.inString lpbstrRet]
getCategory :: IVDocument a -> Prelude.IO (Prelude.String)
getCategory = Automation.propertyGetID 0x45 [] Automation.outString
setCategory :: Prelude.String -> IVDocument a -> Prelude.IO ()
setCategory lpbstrRet =
  Automation.propertySetID 0x45 [Automation.inString lpbstrRet]
getHyperlinkBase :: IVDocument a -> Prelude.IO (Prelude.String)
getHyperlinkBase =
  Automation.propertyGetID 0x46 [] Automation.outString
setHyperlinkBase :: Prelude.String -> IVDocument a -> Prelude.IO ()
setHyperlinkBase lpbstrRet =
  Automation.propertySetID 0x46 [Automation.inString lpbstrRet]
-- --------------------------------------------------
-- 
-- interface IVDocuments
-- 
-- --------------------------------------------------
data VDocuments a = VDocuments
                     
type IVDocuments a = Automation.IDispatch (VDocuments a)
iidIVDocuments :: Com.IID (IVDocuments Automation.Interface)
iidIVDocuments = Com.mkIID "{000D0706-0000-0000-C000-000000000046}"
add :: Prelude.String -> IVDocuments a -> Prelude.IO (IVDocument Automation.Interface)
add fileName =
  Automation.functionID1 0x4 [Automation.inString fileName] Automation.outIDispatch
open :: Prelude.String -> IVDocuments a -> Prelude.IO (IVDocument Automation.Interface)
open fileName =
  Automation.functionID1 0x5 [Automation.inString fileName] Automation.outIDispatch
getItem0 :: Prelude.Int -> IVDocuments a -> Prelude.IO (IVDocument Automation.Interface)
getItem0 nameOrIndex =
  Automation.propertyGetID 0o0 [Automation.inInt nameOrIndex] Automation.outIDispatch
openEx :: Prelude.String -> Prelude.Int -> IVDocuments a -> Prelude.IO (IVDocument Automation.Interface)
openEx fileName flags =
  Automation.functionID1 0x6 [Automation.inString fileName, Automation.inInt flags] Automation.outIDispatch
--getNames :: Automation.IDispatch a -> Prelude.IO (Array.Array Prelude.Int z)
--getNames = Automation.methodID1 0x9 [] Automation.outArray
-- --------------------------------------------------
-- 
-- interface IVMaster
-- 
-- --------------------------------------------------
data VMaster a = VMaster
                  
type IVMaster a = Automation.IDispatch (VMaster a)
iidIVMaster :: Com.IID (IVMaster Automation.Interface)
iidIVMaster = Com.mkIID "{000D0707-0000-0000-C000-000000000046}"
getPrompt :: IVMaster a -> Prelude.IO (Prelude.String)
getPrompt = Automation.propertyGetID 0x6 [] Automation.outString
setPrompt :: Prelude.String -> IVMaster a -> Prelude.IO ()
setPrompt lpbstrRet =
  Automation.propertySetID 0x6 [Automation.inString lpbstrRet]
getAlignName :: IVMaster a -> Prelude.IO (Prelude.Int)
getAlignName = Automation.propertyGetID 0x7 [] Automation.outInt
setAlignName :: Prelude.Int -> IVMaster a -> Prelude.IO ()
setAlignName lpi2Ret =
  Automation.propertySetID 0x7 [Automation.inInt lpi2Ret]
getIconSize :: IVMaster a -> Prelude.IO (Prelude.Int)
getIconSize = Automation.propertyGetID 0x8 [] Automation.outInt
setIconSize :: Prelude.Int -> IVMaster a -> Prelude.IO ()
setIconSize lpi2Ret =
  Automation.propertySetID 0x8 [Automation.inInt lpi2Ret]
getIconUpdate :: IVMaster a -> Prelude.IO (Prelude.Int)
getIconUpdate = Automation.propertyGetID 0x9 [] Automation.outInt
setIconUpdate :: Prelude.Int -> IVMaster a -> Prelude.IO ()
setIconUpdate lpi2Ret =
  Automation.propertySetID 0x9 [Automation.inInt lpi2Ret]
setName :: Prelude.String -> Automation.IDispatch a -> Prelude.IO ()
setName lpbstrRet =
  Automation.propertySetID 0o0 [Automation.inString lpbstrRet]
getShapes :: Automation.IDispatch a -> Prelude.IO (IVShapes Automation.Interface)
getShapes = Automation.propertyGetID 0x3 [] Automation.outIDispatch
getOneD :: Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getOneD = Automation.propertyGetID 0xb [] Automation.outInt
delete :: Automation.IDispatch a -> Prelude.IO ()
delete = Automation.methodID0 0xc []
getUniqueID :: IVMaster a -> Prelude.IO (Prelude.String)
getUniqueID = Automation.propertyGetID 0xd [] Automation.outString
getLayers :: Automation.IDispatch a -> Prelude.IO (IVLayers Automation.Interface)
getLayers = Automation.propertyGetID 0xe [] Automation.outIDispatch
getPageSheet :: Automation.IDispatch a -> Prelude.IO (IVShape Automation.Interface)
getPageSheet =
  Automation.propertyGetID 0xf [] Automation.outIDispatch
drop0 :: Com.IUnknown a0 -> Prelude.Double -> Prelude.Double -> Automation.IDispatch a -> Prelude.IO (IVShape Automation.Interface)
drop0 objectToDrop xPos yPos =
  Automation.functionID1 0x10 [Automation.inIUnknown objectToDrop, Automation.inDouble xPos, Automation.inDouble yPos] Automation.outIDispatch
centerDrawing :: Automation.IDispatch a -> Prelude.IO ()
centerDrawing = Automation.methodID0 0x11 []
drawLine :: Prelude.Double -> Prelude.Double -> Prelude.Double -> Prelude.Double -> Automation.IDispatch a -> Prelude.IO (IVShape Automation.Interface)
drawLine xLeft yTop xRight yBottom =
  Automation.functionID1 0x14 [Automation.inDouble xLeft, Automation.inDouble yTop, Automation.inDouble xRight, Automation.inDouble yBottom] Automation.outIDispatch
drawRectangle :: Prelude.Double -> Prelude.Double -> Prelude.Double -> Prelude.Double -> Automation.IDispatch a -> Prelude.IO (IVShape Automation.Interface)
drawRectangle xLeft yTop xRight yBottom =
  Automation.functionID1 0x15 [Automation.inDouble xLeft, Automation.inDouble yTop, Automation.inDouble xRight, Automation.inDouble yBottom] Automation.outIDispatch
drawOval :: Prelude.Double -> Prelude.Double -> Prelude.Double -> Prelude.Double -> Automation.IDispatch a -> Prelude.IO (IVShape Automation.Interface)
drawOval xLeft yTop xRight yBottom =
  Automation.functionID1 0x16 [Automation.inDouble xLeft, Automation.inDouble yTop, Automation.inDouble xRight, Automation.inDouble yBottom] Automation.outIDispatch
--drawSpline :: Array.Array Prelude.Int z -> Prelude.Double -> Prelude.Int -> Automation.IDispatch a -> Prelude.IO (IVShape Automation.Interface)
--drawSpline xyArray tolerance flags =
--  Automation.functionID1 0x17 [Automation.inArray xyArray, Automation.inDouble tolerance, Automation.inInt flags] Automation.outIDispatch
--drawBezier :: Array.Array Prelude.Int z -> Prelude.Int -> Prelude.Int -> Automation.IDispatch a -> Prelude.IO (IVShape Automation.Interface)
--drawBezier xyArray degree flags =
--  Automation.functionID1 0x18 [Automation.inArray xyArray, Automation.inInt degree, Automation.inInt flags] Automation.outIDispatch
--drawPolyline :: Array.Array Prelude.Int z -> Prelude.Int -> Automation.IDispatch a -> Prelude.IO (IVShape Automation.Interface)
--drawPolyline xyArray flags =
--  Automation.functionID1 0x19 [Automation.inArray xyArray, Automation.inInt flags] Automation.outIDispatch
import0 :: Prelude.String -> Automation.IDispatch a -> Prelude.IO (IVShape Automation.Interface)
import0 fileName =
  Automation.functionID1 0x1a [Automation.inString fileName] Automation.outIDispatch
export :: Prelude.String -> Automation.IDispatch a -> Prelude.IO ()
export fileName =
  Automation.methodID0 0x1b [Automation.inString fileName]
insertFromFile :: Prelude.String -> Prelude.Int -> Automation.IDispatch a -> Prelude.IO (IVShape Automation.Interface)
insertFromFile fileName flags =
  Automation.functionID1 0x1c [Automation.inString fileName, Automation.inInt flags] Automation.outIDispatch
insertObject :: Prelude.String -> Prelude.Int -> Automation.IDispatch a -> Prelude.IO (IVShape Automation.Interface)
insertObject classOrProgID flags =
  Automation.functionID1 0x1d [Automation.inString classOrProgID, Automation.inInt flags] Automation.outIDispatch
openDrawWindow :: Automation.IDispatch a -> Prelude.IO (IVWindow Automation.Interface)
openDrawWindow =
  Automation.functionID1 0x1e [] Automation.outIDispatch
openIconWindow :: IVMaster a -> Prelude.IO (IVWindow Automation.Interface)
openIconWindow =
  Automation.functionID1 0x1f [] Automation.outIDispatch
open0 :: IVMaster a -> Prelude.IO (IVMaster Automation.Interface)
open0 = Automation.functionID1 0x20 [] Automation.outIDispatch
--dropMany :: Array.Array Prelude.Int z -> Array.Array Prelude.Int z -> Automation.IDispatch a -> Prelude.IO (Array.Array Prelude.Int z, Prelude.Int)
--dropMany objectsToInstance xyArray =
--  Automation.functionID2 0x22 [Automation.inArray objectsToInstance, Automation.inArray xyArray] Automation.outArray Automation.outInt
--getFormulas :: Array.Array Prelude.Int z -> Automation.IDispatch a -> Prelude.IO (Array.Array Prelude.Int z)
--getFormulas sID_SRCStream =
--  Automation.methodID1 0x23 [Automation.inArray sID_SRCStream] Automation.outArray
--getResults :: Array.Array Prelude.Int z -> Prelude.Int -> Array.Array Prelude.Int z -> Automation.IDispatch a -> Prelude.IO (Array.Array Prelude.Int z)
--getResults sID_SRCStream flags unitsNamesOrCodes =
--  Automation.methodID1 0x24 [Automation.inArray sID_SRCStream, Automation.inInt flags, Automation.inArray unitsNamesOrCodes] Automation.outArray
--setFormulas :: Array.Array Prelude.Int z -> Array.Array Prelude.Int z -> Prelude.Int -> Automation.IDispatch a -> Prelude.IO (Prelude.Int)
--setFormulas sID_SRCStream formulaArray flags =
--  Automation.functionID1 0x25 [Automation.inArray sID_SRCStream, Automation.inArray formulaArray, Automation.inInt flags] Automation.outInt
--setResults :: Array.Array Prelude.Int z -> Array.Array Prelude.Int z -> Array.Array Prelude.Int z -> Prelude.Int -> Automation.IDispatch a -> Prelude.IO (Prelude.Int)
--setResults sID_SRCStream unitsNamesOrCodes resultArray flags =
--  Automation.functionID1 0x26 [Automation.inArray sID_SRCStream, Automation.inArray unitsNamesOrCodes, Automation.inArray resultArray, Automation.inInt flags] Automation.outInt
getConnects :: Automation.IDispatch a -> Prelude.IO (IVConnects Automation.Interface)
getConnects =
  Automation.propertyGetID 0x27 [] Automation.outIDispatch
importIcon :: Prelude.String -> IVMaster a -> Prelude.IO ()
importIcon fileName =
  Automation.methodID0 0x28 [Automation.inString fileName]
exportIcon :: Prelude.String -> Prelude.Int -> IVMaster a -> Prelude.IO ()
exportIcon fileName flags =
  Automation.methodID0 0x29 [Automation.inString fileName, Automation.inInt flags]
layout :: Automation.IDispatch a -> Prelude.IO ()
layout = Automation.methodID0 0x2a []
boundingBox :: Prelude.Int -> Automation.IDispatch a -> Prelude.IO (Prelude.Double, Prelude.Double, Prelude.Double, Prelude.Double)
boundingBox flags =
  Automation.methodID4 0x2b [Automation.inInt flags] Automation.outDouble Automation.outDouble Automation.outDouble Automation.outDouble
getID :: Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getID = Automation.propertyGetID 0x2c [] Automation.outInt
getPatternFlags :: IVMaster a -> Prelude.IO (Prelude.Int)
getPatternFlags =
  Automation.propertyGetID 0x2e [] Automation.outInt
setPatternFlags :: Prelude.Int -> IVMaster a -> Prelude.IO ()
setPatternFlags lpi2Ret =
  Automation.propertySetID 0x2e [Automation.inInt lpi2Ret]
getMatchByName :: IVMaster a -> Prelude.IO (Prelude.Int)
getMatchByName = Automation.propertyGetID 0x2f [] Automation.outInt
setMatchByName :: Prelude.Int -> IVMaster a -> Prelude.IO ()
setMatchByName lpi2Ret =
  Automation.propertySetID 0x2f [Automation.inInt lpi2Ret]
-- --------------------------------------------------
-- 
-- interface IVMasters
-- 
-- --------------------------------------------------
data VMasters a = VMasters
                   
type IVMasters a = Automation.IDispatch (VMasters a)
iidIVMasters :: Com.IID (IVMasters Automation.Interface)
iidIVMasters = Com.mkIID "{000D0708-0000-0000-C000-000000000046}"
getItem1 :: Prelude.Int -> IVMasters a -> Prelude.IO (IVMaster Automation.Interface)
getItem1 nameUIDOrIndex =
  Automation.propertyGetID 0o0 [Automation.inInt nameUIDOrIndex] Automation.outIDispatch
add0 :: IVMasters a -> Prelude.IO (IVMaster Automation.Interface)
add0 = Automation.functionID1 0x8 [] Automation.outIDispatch
-- --------------------------------------------------
-- 
-- interface IVPage
-- 
-- --------------------------------------------------
data VPage a = VPage
                
type IVPage a = Automation.IDispatch (VPage a)
iidIVPage :: Com.IID (IVPage Automation.Interface)
iidIVPage = Com.mkIID "{000D0709-0000-0000-C000-000000000046}"
getBackground :: IVPage a -> Prelude.IO (Prelude.Int)
getBackground = Automation.propertyGetID 0xb [] Automation.outInt
setBackground :: Prelude.Int -> IVPage a -> Prelude.IO ()
setBackground lpi2Ret =
  Automation.propertySetID 0xb [Automation.inInt lpi2Ret]
pasteSpecial :: Prelude.Int -> IVPage a -> Prelude.IO ()
pasteSpecial format =
  Automation.methodID0 0x10 [Automation.inInt format]
addGuide :: Prelude.Int -> Prelude.Double -> Prelude.Double -> IVPage a -> Prelude.IO (IVShape Automation.Interface)
addGuide type0 xPos yPos =
  Automation.functionID1 0xc [Automation.inInt type0, Automation.inDouble xPos, Automation.inDouble yPos] Automation.outIDispatch
getBackPageAsObj :: IVPage a -> Prelude.IO (IVPage Automation.Interface)
getBackPageAsObj =
  Automation.propertyGetID 0xe [] Automation.outIDispatch
setBackPageFromName :: Prelude.String -> IVPage a -> Prelude.IO ()
setBackPageFromName rhs =
  Automation.propertySetID 0x5db [Automation.inString rhs]
delete0 :: Prelude.Int -> Automation.IDispatch a -> Prelude.IO ()
delete0 fRenumberPages =
  Automation.methodID0 0x15 [Automation.inInt fRenumberPages]
getBackPage :: IVPage a -> Prelude.IO (Prelude.Int)
getBackPage = Automation.propertyGetID 0x25 [] Automation.outInt
setBackPage :: Prelude.Int -> IVPage a -> Prelude.IO ()
setBackPage lpobjRet =
  Automation.propertySetID 0x25 [Automation.inInt lpobjRet]
-- --------------------------------------------------
-- 
-- interface IVPages
-- 
-- --------------------------------------------------
data VPages a = VPages
                 
type IVPages a = Automation.IDispatch (VPages a)
iidIVPages :: Com.IID (IVPages Automation.Interface)
iidIVPages = Com.mkIID "{000D070A-0000-0000-C000-000000000046}"
getItem2 :: Prelude.Int -> IVPages a -> Prelude.IO (IVPage Automation.Interface)
getItem2 nameOrIndex =
  Automation.propertyGetID 0o0 [Automation.inInt nameOrIndex] Automation.outIDispatch
add1 :: IVPages a -> Prelude.IO (IVPage Automation.Interface)
add1 = Automation.functionID1 0x4 [] Automation.outIDispatch
-- --------------------------------------------------
-- 
-- interface IVSelection
-- 
-- --------------------------------------------------
data VSelection a = VSelection
                     
type IVSelection a = Automation.IDispatch (VSelection a)
iidIVSelection :: Com.IID (IVSelection Automation.Interface)
iidIVSelection = Com.mkIID "{000D070B-0000-0000-C000-000000000046}"
getItem3 :: Prelude.Int -> IVSelection a -> Prelude.IO (IVShape Automation.Interface)
getItem3 index =
  Automation.propertyGetID 0o0 [Automation.inInt index] Automation.outIDispatch
getContainingPage :: Automation.IDispatch a -> Prelude.IO (IVPage Automation.Interface)
getContainingPage =
  Automation.propertyGetID 0x7 [] Automation.outIDispatch
getContainingMaster :: Automation.IDispatch a -> Prelude.IO (IVMaster Automation.Interface)
getContainingMaster =
  Automation.propertyGetID 0x8 [] Automation.outIDispatch
getContainingShape :: Automation.IDispatch a -> Prelude.IO (IVShape Automation.Interface)
getContainingShape =
  Automation.propertyGetID 0x9 [] Automation.outIDispatch
bringForward :: Automation.IDispatch a -> Prelude.IO ()
bringForward = Automation.methodID0 0xa []
bringToFront :: Automation.IDispatch a -> Prelude.IO ()
bringToFront = Automation.methodID0 0xb []
sendBackward :: Automation.IDispatch a -> Prelude.IO ()
sendBackward = Automation.methodID0 0xc []
sendToBack :: Automation.IDispatch a -> Prelude.IO ()
sendToBack = Automation.methodID0 0xd []
getStyle0 :: Automation.IDispatch a -> Prelude.IO (Prelude.String)
getStyle0 = Automation.propertyGetID 0xe [] Automation.outString
setStyle :: Prelude.String -> Automation.IDispatch a -> Prelude.IO ()
setStyle lpbstrRet =
  Automation.propertySetID 0xe [Automation.inString lpbstrRet]
setStyleKeepFmt :: Prelude.String -> Automation.IDispatch a -> Prelude.IO ()
setStyleKeepFmt rhs =
  Automation.propertySetID 0xf [Automation.inString rhs]
getLineStyle :: Automation.IDispatch a -> Prelude.IO (Prelude.String)
getLineStyle =
  Automation.propertyGetID 0x10 [] Automation.outString
setLineStyle :: Prelude.String -> Automation.IDispatch a -> Prelude.IO ()
setLineStyle lpbstrRet =
  Automation.propertySetID 0x10 [Automation.inString lpbstrRet]
setLineStyleKeepFmt :: Prelude.String -> Automation.IDispatch a -> Prelude.IO ()
setLineStyleKeepFmt rhs =
  Automation.propertySetID 0x11 [Automation.inString rhs]
getFillStyle :: Automation.IDispatch a -> Prelude.IO (Prelude.String)
getFillStyle =
  Automation.propertyGetID 0x12 [] Automation.outString
setFillStyle :: Prelude.String -> Automation.IDispatch a -> Prelude.IO ()
setFillStyle lpbstrRet =
  Automation.propertySetID 0x12 [Automation.inString lpbstrRet]
setFillStyleKeepFmt :: Prelude.String -> Automation.IDispatch a -> Prelude.IO ()
setFillStyleKeepFmt rhs =
  Automation.propertySetID 0x13 [Automation.inString rhs]
getTextStyle :: Automation.IDispatch a -> Prelude.IO (Prelude.String)
getTextStyle =
  Automation.propertyGetID 0x14 [] Automation.outString
setTextStyle :: Prelude.String -> Automation.IDispatch a -> Prelude.IO ()
setTextStyle lpbstrRet =
  Automation.propertySetID 0x14 [Automation.inString lpbstrRet]
setTextStyleKeepFmt :: Prelude.String -> Automation.IDispatch a -> Prelude.IO ()
setTextStyleKeepFmt rhs =
  Automation.propertySetID 0x15 [Automation.inString rhs]
combine :: Automation.IDispatch a -> Prelude.IO ()
combine = Automation.methodID0 0x16 []
fragment :: Automation.IDispatch a -> Prelude.IO ()
fragment = Automation.methodID0 0x17 []
intersect :: Automation.IDispatch a -> Prelude.IO ()
intersect = Automation.methodID0 0x18 []
subtract :: Automation.IDispatch a -> Prelude.IO ()
subtract = Automation.methodID0 0x19 []
union :: Automation.IDispatch a -> Prelude.IO ()
union = Automation.methodID0 0x1a []
flipHorizontal :: Automation.IDispatch a -> Prelude.IO ()
flipHorizontal = Automation.methodID0 0x1b []
flipVertical :: Automation.IDispatch a -> Prelude.IO ()
flipVertical = Automation.methodID0 0x1c []
reverseEnds :: Automation.IDispatch a -> Prelude.IO ()
reverseEnds = Automation.methodID0 0x1d []
rotate90 :: Automation.IDispatch a -> Prelude.IO ()
rotate90 = Automation.methodID0 0x1e []
duplicate :: Automation.IDispatch a -> Prelude.IO ()
duplicate = Automation.methodID0 0x22 []
group :: Automation.IDispatch a -> Prelude.IO ()
group = Automation.methodID0 0x23 []
convertToGroup :: Automation.IDispatch a -> Prelude.IO ()
convertToGroup = Automation.methodID0 0x24 []
ungroup :: Automation.IDispatch a -> Prelude.IO ()
ungroup = Automation.methodID0 0x25 []
selectAll :: Automation.IDispatch a -> Prelude.IO ()
selectAll = Automation.methodID0 0x26 []
deselectAll :: Automation.IDispatch a -> Prelude.IO ()
deselectAll = Automation.methodID0 0x27 []
select :: IVShape a0 -> Prelude.Int -> Automation.IDispatch a -> Prelude.IO ()
select sheetObject selectAction =
  Automation.methodID0 0x28 [Automation.inIDispatch sheetObject, Automation.inInt selectAction]
trim :: Automation.IDispatch a -> Prelude.IO ()
trim = Automation.methodID0 0x2b []
join :: Automation.IDispatch a -> Prelude.IO ()
join = Automation.methodID0 0x2c []
fitCurve :: Prelude.Double -> Prelude.Int -> Automation.IDispatch a -> Prelude.IO ()
fitCurve tolerance flags =
  Automation.methodID0 0x2d [Automation.inDouble tolerance, Automation.inInt flags]
-- --------------------------------------------------
-- 
-- interface IVShape
-- 
-- --------------------------------------------------
data VShape a = VShape
                 
type IVShape a = Automation.IDispatch (VShape a)
iidIVShape :: Com.IID (IVShape Automation.Interface)
iidIVShape = Com.mkIID "{000D070C-0000-0000-C000-000000000046}"
getParent :: IVShape a -> Prelude.IO (Automation.IDispatch Automation.Interface)
getParent =
  Automation.propertyGetID 0x38 [] Automation.outIDispatch
getMaster :: Automation.IDispatch a -> Prelude.IO (IVMaster Automation.Interface)
getMaster =
  Automation.propertyGetID 0x15 [] Automation.outIDispatch
getType :: Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getType = Automation.propertyGetID 0x14 [] Automation.outInt
getCells :: Prelude.String -> Automation.IDispatch a -> Prelude.IO (IVCell Automation.Interface)
getCells cellName =
  Automation.propertyGetID 0xd [Automation.inString cellName] Automation.outIDispatch
getCellsSRC :: Prelude.Int -> Prelude.Int -> Prelude.Int -> Automation.IDispatch a -> Prelude.IO (IVCell Automation.Interface)
getCellsSRC section row column =
  Automation.propertyGetID 0xe [Automation.inInt section, Automation.inInt row, Automation.inInt column] Automation.outIDispatch
getData1 :: Automation.IDispatch a -> Prelude.IO (Prelude.String)
getData1 = Automation.propertyGetID 0xf [] Automation.outString
setData1 :: Prelude.String -> Automation.IDispatch a -> Prelude.IO ()
setData1 lpbstrRet =
  Automation.propertySetID 0xf [Automation.inString lpbstrRet]
getData2 :: Automation.IDispatch a -> Prelude.IO (Prelude.String)
getData2 = Automation.propertyGetID 0x10 [] Automation.outString
setData2 :: Prelude.String -> Automation.IDispatch a -> Prelude.IO ()
setData2 lpbstrRet =
  Automation.propertySetID 0x10 [Automation.inString lpbstrRet]
getData3 :: Automation.IDispatch a -> Prelude.IO (Prelude.String)
getData3 = Automation.propertyGetID 0x11 [] Automation.outString
setData3 :: Prelude.String -> Automation.IDispatch a -> Prelude.IO ()
setData3 lpbstrRet =
  Automation.propertySetID 0x11 [Automation.inString lpbstrRet]
getHelp :: Automation.IDispatch a -> Prelude.IO (Prelude.String)
getHelp = Automation.propertyGetID 0x12 [] Automation.outString
setHelp :: Prelude.String -> Automation.IDispatch a -> Prelude.IO ()
setHelp lpbstrRet =
  Automation.propertySetID 0x12 [Automation.inString lpbstrRet]
getNameID :: Automation.IDispatch a -> Prelude.IO (Prelude.String)
getNameID = Automation.propertyGetID 0x4 [] Automation.outString
getText0 :: IVShape a -> Prelude.IO (Prelude.String)
getText0 = Automation.propertyGetID 0x6 [] Automation.outString
setText0 :: Prelude.String -> IVShape a -> Prelude.IO ()
setText0 lpbstrRet =
  Automation.propertySetID 0x6 [Automation.inString lpbstrRet]
getCharacters :: IVShape a -> Prelude.IO (IVCharacters Automation.Interface)
getCharacters =
  Automation.propertyGetID 0x8 [] Automation.outIDispatch
setOneD :: Prelude.Int -> IVShape a -> Prelude.IO ()
setOneD lpi2Ret =
  Automation.propertySetID 0x16 [Automation.inInt lpi2Ret]
getGeometryCount :: IVShape a -> Prelude.IO (Prelude.Int)
getGeometryCount =
  Automation.propertyGetID 0x17 [] Automation.outInt
getRowCount :: Prelude.Int -> Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getRowCount section =
  Automation.propertyGetID 0x18 [Automation.inInt section] Automation.outInt
addSection :: Prelude.Int -> Automation.IDispatch a -> Prelude.IO (Prelude.Int)
addSection section =
  Automation.functionID1 0x19 [Automation.inInt section] Automation.outInt
deleteSection :: Prelude.Int -> Automation.IDispatch a -> Prelude.IO ()
deleteSection section =
  Automation.methodID0 0x1a [Automation.inInt section]
addRow :: Prelude.Int -> Prelude.Int -> Prelude.Int -> Automation.IDispatch a -> Prelude.IO (Prelude.Int)
addRow section row rowTag =
  Automation.functionID1 0x1b [Automation.inInt section, Automation.inInt row, Automation.inInt rowTag] Automation.outInt
deleteRow :: Prelude.Int -> Prelude.Int -> Automation.IDispatch a -> Prelude.IO ()
deleteRow section row =
  Automation.methodID0 0x1c [Automation.inInt section, Automation.inInt row]
getRowsCellCount :: Prelude.Int -> Prelude.Int -> Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getRowsCellCount section row =
  Automation.propertyGetID 0x1d [Automation.inInt section, Automation.inInt row] Automation.outInt
getRowType :: Prelude.Int -> Prelude.Int -> Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getRowType section row =
  Automation.propertyGetID 0x1e [Automation.inInt section, Automation.inInt row] Automation.outInt
setRowType :: Prelude.Int -> Prelude.Int -> Prelude.Int -> Automation.IDispatch a -> Prelude.IO ()
setRowType section row lpi2Ret =
  Automation.propertySetID 0x1e [Automation.inInt section, Automation.inInt row, Automation.inInt lpi2Ret]
setCenter :: Prelude.Double -> Prelude.Double -> Automation.IDispatch a -> Prelude.IO ()
setCenter xPos yPos =
  Automation.methodID0 0x1f [Automation.inDouble xPos, Automation.inDouble yPos]
setBegin0 :: Prelude.Double -> Prelude.Double -> IVShape a -> Prelude.IO ()
setBegin0 xPos yPos =
  Automation.methodID0 0x20 [Automation.inDouble xPos, Automation.inDouble yPos]
setEnd0 :: Prelude.Double -> Prelude.Double -> IVShape a -> Prelude.IO ()
setEnd0 xPos yPos =
  Automation.methodID0 0x21 [Automation.inDouble xPos, Automation.inDouble yPos]
getAreaIU :: IVShape a -> Prelude.IO (Prelude.Double)
getAreaIU = Automation.propertyGetID 0x3a [] Automation.outDouble
getLengthIU :: IVShape a -> Prelude.IO (Prelude.Double)
getLengthIU = Automation.propertyGetID 0x3b [] Automation.outDouble
getGeomExIf :: Prelude.Int -> Prelude.Double -> IVShape a -> Prelude.IO (Com.IUnknown Automation.Interface)
getGeomExIf fFill lineRes =
  Automation.propertyGetID 0x3c [Automation.inInt fFill, Automation.inDouble lineRes] Automation.outIUnknown
getUniqueID0 :: Prelude.Int -> Automation.IDispatch a -> Prelude.IO (Prelude.String)
getUniqueID0 fUniqueID =
  Automation.propertyGetID 0x3d [Automation.inInt fUniqueID] Automation.outString
getSectionExists :: Prelude.Int -> Prelude.Int -> Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getSectionExists section fLocalExists =
  Automation.propertyGetID 0x41 [Automation.inInt section, Automation.inInt fLocalExists] Automation.outInt
getRowExists :: Prelude.Int -> Prelude.Int -> Prelude.Int -> Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getRowExists section row fLocalExists =
  Automation.propertyGetID 0x42 [Automation.inInt section, Automation.inInt row, Automation.inInt fLocalExists] Automation.outInt
getCellExists :: Prelude.String -> Prelude.Int -> Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getCellExists cellName fLocalExists =
  Automation.propertyGetID 0x43 [Automation.inString cellName, Automation.inInt fLocalExists] Automation.outInt
getCellsSRCExists :: Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getCellsSRCExists section row column fLocalExists =
  Automation.propertyGetID 0x44 [Automation.inInt section, Automation.inInt row, Automation.inInt column, Automation.inInt fLocalExists] Automation.outInt
getLayerCount :: Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getLayerCount = Automation.propertyGetID 0x45 [] Automation.outInt
getLayer :: Prelude.Int -> Automation.IDispatch a -> Prelude.IO (IVLayer Automation.Interface)
getLayer index =
  Automation.propertyGetID 0x46 [Automation.inInt index] Automation.outIDispatch
addNamedRow :: Prelude.Int -> Prelude.String -> Prelude.Int -> Automation.IDispatch a -> Prelude.IO (Prelude.Int)
addNamedRow section rowName rowTag =
  Automation.functionID1 0x47 [Automation.inInt section, Automation.inString rowName, Automation.inInt rowTag] Automation.outInt
addRows :: Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Automation.IDispatch a -> Prelude.IO (Prelude.Int)
addRows section row rowTag rowCount =
  Automation.functionID1 0x48 [Automation.inInt section, Automation.inInt row, Automation.inInt rowTag, Automation.inInt rowCount] Automation.outInt
getClassID :: Automation.IDispatch a -> Prelude.IO (Prelude.String)
getClassID = Automation.propertyGetID 0x56 [] Automation.outString
getForeignType :: Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getForeignType = Automation.propertyGetID 0x57 [] Automation.outInt
getObject :: Automation.IDispatch a -> Prelude.IO (Automation.IDispatch Automation.Interface)
getObject =
  Automation.propertyGetID 0x58 [] Automation.outIDispatch
openSheetWindow :: Automation.IDispatch a -> Prelude.IO (IVWindow Automation.Interface)
openSheetWindow =
  Automation.functionID1 0x5a [] Automation.outIDispatch
getFromConnects :: Automation.IDispatch a -> Prelude.IO (IVConnects Automation.Interface)
getFromConnects =
  Automation.propertyGetID 0x61 [] Automation.outIDispatch
hitTest :: Prelude.Double -> Prelude.Double -> Prelude.Double -> Automation.IDispatch a -> Prelude.IO (Prelude.Int)
hitTest xPos yPos tolerance =
  Automation.functionID1 0x64 [Automation.inDouble xPos, Automation.inDouble yPos, Automation.inDouble tolerance] Automation.outInt
getHyperlink :: Automation.IDispatch a -> Prelude.IO (IVHyperlink Automation.Interface)
getHyperlink =
  Automation.propertyGetID 0x65 [] Automation.outIDispatch
getProgID :: Automation.IDispatch a -> Prelude.IO (Prelude.String)
getProgID = Automation.propertyGetID 0x66 [] Automation.outString
getObjectIsInherited :: Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getObjectIsInherited =
  Automation.propertyGetID 0x67 [] Automation.outInt
getPaths :: IVShape a -> Prelude.IO (IVPaths Automation.Interface)
getPaths = Automation.propertyGetID 0x68 [] Automation.outIDispatch
getPathsLocal :: IVShape a -> Prelude.IO (IVPaths Automation.Interface)
getPathsLocal =
  Automation.propertyGetID 0x69 [] Automation.outIDispatch
addHyperlink :: IVShape a -> Prelude.IO (IVHyperlink Automation.Interface)
addHyperlink =
  Automation.functionID1 0x6a [] Automation.outIDispatch
-- --------------------------------------------------
-- 
-- interface IVShapes
-- 
-- --------------------------------------------------
data VShapes a = VShapes
                  
type IVShapes a = Automation.IDispatch (VShapes a)
iidIVShapes :: Com.IID (IVShapes Automation.Interface)
iidIVShapes = Com.mkIID "{000D070D-0000-0000-C000-000000000046}"
getItem4 :: Prelude.Int -> IVShapes a -> Prelude.IO (IVShape Automation.Interface)
getItem4 nameUIDOrIndex =
  Automation.propertyGetID 0o0 [Automation.inInt nameUIDOrIndex] Automation.outIDispatch
getItemFromID :: Prelude.Int -> IVShapes a -> Prelude.IO (IVShape Automation.Interface)
getItemFromID objectID =
  Automation.propertyGetID 0xc [Automation.inInt objectID] Automation.outIDispatch
-- --------------------------------------------------
-- 
-- interface IVStyle
-- 
-- --------------------------------------------------
data VStyle a = VStyle
                 
type IVStyle a = Automation.IDispatch (VStyle a)
iidIVStyle :: Com.IID (IVStyle Automation.Interface)
iidIVStyle = Com.mkIID "{000D070E-0000-0000-C000-000000000046}"
getBasedOn :: IVStyle a -> Prelude.IO (Prelude.String)
getBasedOn = Automation.propertyGetID 0x6 [] Automation.outString
setBasedOn :: Prelude.String -> IVStyle a -> Prelude.IO ()
setBasedOn lpbstrRet =
  Automation.propertySetID 0x6 [Automation.inString lpbstrRet]
getTextBasedOn :: IVStyle a -> Prelude.IO (Prelude.String)
getTextBasedOn =
  Automation.propertyGetID 0x7 [] Automation.outString
setTextBasedOn :: Prelude.String -> IVStyle a -> Prelude.IO ()
setTextBasedOn lpbstrRet =
  Automation.propertySetID 0x7 [Automation.inString lpbstrRet]
getLineBasedOn :: IVStyle a -> Prelude.IO (Prelude.String)
getLineBasedOn =
  Automation.propertyGetID 0x8 [] Automation.outString
setLineBasedOn :: Prelude.String -> IVStyle a -> Prelude.IO ()
setLineBasedOn lpbstrRet =
  Automation.propertySetID 0x8 [Automation.inString lpbstrRet]
getFillBasedOn :: IVStyle a -> Prelude.IO (Prelude.String)
getFillBasedOn =
  Automation.propertyGetID 0x9 [] Automation.outString
setFillBasedOn :: Prelude.String -> IVStyle a -> Prelude.IO ()
setFillBasedOn lpbstrRet =
  Automation.propertySetID 0x9 [Automation.inString lpbstrRet]
getIncludesText :: IVStyle a -> Prelude.IO (Prelude.Int)
getIncludesText = Automation.propertyGetID 0xa [] Automation.outInt
setIncludesText :: Prelude.Int -> IVStyle a -> Prelude.IO ()
setIncludesText lpi2Ret =
  Automation.propertySetID 0xa [Automation.inInt lpi2Ret]
getIncludesLine :: IVStyle a -> Prelude.IO (Prelude.Int)
getIncludesLine = Automation.propertyGetID 0xb [] Automation.outInt
setIncludesLine :: Prelude.Int -> IVStyle a -> Prelude.IO ()
setIncludesLine lpi2Ret =
  Automation.propertySetID 0xb [Automation.inInt lpi2Ret]
getIncludesFill :: IVStyle a -> Prelude.IO (Prelude.Int)
getIncludesFill = Automation.propertyGetID 0xc [] Automation.outInt
setIncludesFill :: Prelude.Int -> IVStyle a -> Prelude.IO ()
setIncludesFill lpi2Ret =
  Automation.propertySetID 0xc [Automation.inInt lpi2Ret]
-- --------------------------------------------------
-- 
-- interface IVStyles
-- 
-- --------------------------------------------------
data VStyles a = VStyles
                  
type IVStyles a = Automation.IDispatch (VStyles a)
iidIVStyles :: Com.IID (IVStyles Automation.Interface)
iidIVStyles = Com.mkIID "{000D070F-0000-0000-C000-000000000046}"
getItem5 :: Prelude.Int -> IVStyles a -> Prelude.IO (IVStyle Automation.Interface)
getItem5 nameOrIndex =
  Automation.propertyGetID 0o0 [Automation.inInt nameOrIndex] Automation.outIDispatch
add2 :: Prelude.String -> Prelude.String -> Prelude.Int -> Prelude.Int -> Prelude.Int -> IVStyles a -> Prelude.IO (IVStyle Automation.Interface)
add2 styleName basedOn fIncludesText fIncludesLine fIncludesFill =
  Automation.functionID1 0x5 [Automation.inString styleName, Automation.inString basedOn, Automation.inInt fIncludesText, Automation.inInt fIncludesLine, Automation.inInt fIncludesFill] Automation.outIDispatch
getItemFromID0 :: Prelude.Int -> IVStyles a -> Prelude.IO (IVStyle Automation.Interface)
getItemFromID0 objectID =
  Automation.propertyGetID 0x9 [Automation.inInt objectID] Automation.outIDispatch
-- --------------------------------------------------
-- 
-- interface IVWindow
-- 
-- --------------------------------------------------
data VWindow a = VWindow
                  
type IVWindow a = Automation.IDispatch (VWindow a)
iidIVWindow :: Com.IID (IVWindow Automation.Interface)
iidIVWindow = Com.mkIID "{000D0710-0000-0000-C000-000000000046}"
activate :: IVWindow a -> Prelude.IO ()
activate = Automation.methodID0 0x3 []
getPageAsObj :: IVWindow a -> Prelude.IO (IVPage Automation.Interface)
getPageAsObj =
  Automation.propertyGetID 0x6 [] Automation.outIDispatch
setPageFromName :: Prelude.String -> IVWindow a -> Prelude.IO ()
setPageFromName rhs =
  Automation.propertySetID 0x2bb [Automation.inString rhs]
getZoom :: IVWindow a -> Prelude.IO (Prelude.Double)
getZoom = Automation.propertyGetID 0x7 [] Automation.outDouble
setZoom :: Prelude.Double -> IVWindow a -> Prelude.IO ()
setZoom lpr8Ret =
  Automation.propertySetID 0x7 [Automation.inDouble lpr8Ret]
getSelection :: IVWindow a -> Prelude.IO (IVSelection Automation.Interface)
getSelection =
  Automation.propertyGetID 0xb [] Automation.outIDispatch
addToGroup :: IVWindow a -> Prelude.IO ()
addToGroup = Automation.methodID0 0x17 []
removeFromGroup :: IVWindow a -> Prelude.IO ()
removeFromGroup = Automation.methodID0 0x18 []
getSubType :: IVWindow a -> Prelude.IO (Prelude.Int)
getSubType = Automation.propertyGetID 0x19 [] Automation.outInt
getShowRulers :: IVWindow a -> Prelude.IO (Prelude.Int)
getShowRulers = Automation.propertyGetID 0x22 [] Automation.outInt
setShowRulers :: Prelude.Int -> IVWindow a -> Prelude.IO ()
setShowRulers lpi2Ret =
  Automation.propertySetID 0x22 [Automation.inInt lpi2Ret]
getShowGrid :: IVWindow a -> Prelude.IO (Prelude.Int)
getShowGrid = Automation.propertyGetID 0x23 [] Automation.outInt
setShowGrid :: Prelude.Int -> IVWindow a -> Prelude.IO ()
setShowGrid lpi2Ret =
  Automation.propertySetID 0x23 [Automation.inInt lpi2Ret]
getShowGuides :: IVWindow a -> Prelude.IO (Prelude.Int)
getShowGuides = Automation.propertyGetID 0x24 [] Automation.outInt
setShowGuides :: Prelude.Int -> IVWindow a -> Prelude.IO ()
setShowGuides lpi2Ret =
  Automation.propertySetID 0x24 [Automation.inInt lpi2Ret]
getShowConnectPoints :: IVWindow a -> Prelude.IO (Prelude.Int)
getShowConnectPoints =
  Automation.propertyGetID 0x25 [] Automation.outInt
setShowConnectPoints :: Prelude.Int -> IVWindow a -> Prelude.IO ()
setShowConnectPoints lpi2Ret =
  Automation.propertySetID 0x25 [Automation.inInt lpi2Ret]
getShowPageBreaks :: IVWindow a -> Prelude.IO (Prelude.Int)
getShowPageBreaks =
  Automation.propertyGetID 0x26 [] Automation.outInt
setShowPageBreaks :: Prelude.Int -> IVWindow a -> Prelude.IO ()
setShowPageBreaks lpi2Ret =
  Automation.propertySetID 0x26 [Automation.inInt lpi2Ret]
getPage :: IVWindow a -> Prelude.IO (Prelude.Int)
getPage = Automation.propertyGetID 0x27 [] Automation.outInt
setPage :: Prelude.Int -> IVWindow a -> Prelude.IO ()
setPage lpobjRet =
  Automation.propertySetID 0x27 [Automation.inInt lpobjRet]
--dockedStencils :: IVWindow a -> Prelude.IO (Array.Array Prelude.Int z)
--dockedStencils = Automation.methodID1 0x28 [] Automation.outArray
getMaster0 :: IVWindow a -> Prelude.IO (Prelude.Int)
getMaster0 = Automation.propertyGetID 0x29 [] Automation.outInt
getShowScrollBars :: IVWindow a -> Prelude.IO (Prelude.Int)
getShowScrollBars =
  Automation.propertyGetID 0x2a [] Automation.outInt
setShowScrollBars :: Prelude.Int -> IVWindow a -> Prelude.IO ()
setShowScrollBars lpi2Ret =
  Automation.propertySetID 0x2a [Automation.inInt lpi2Ret]
-- --------------------------------------------------
-- 
-- interface IVWindows
-- 
-- --------------------------------------------------
data VWindows a = VWindows
                   
type IVWindows a = Automation.IDispatch (VWindows a)
iidIVWindows :: Com.IID (IVWindows Automation.Interface)
iidIVWindows = Com.mkIID "{000D0711-0000-0000-C000-000000000046}"
getItem6 :: Prelude.Int -> IVWindows a -> Prelude.IO (IVWindow Automation.Interface)
getItem6 index =
  Automation.propertyGetID 0o0 [Automation.inInt index] Automation.outIDispatch
arrange :: IVWindows a -> Prelude.IO ()
arrange = Automation.methodID0 0x4 []
-- --------------------------------------------------
-- 
-- interface IVLayer
-- 
-- --------------------------------------------------
data VLayer a = VLayer
                 
type IVLayer a = Automation.IDispatch (VLayer a)
iidIVLayer :: Com.IID (IVLayer Automation.Interface)
iidIVLayer = Com.mkIID "{000D0712-0000-0000-C000-000000000046}"
getPage0 :: Automation.IDispatch a -> Prelude.IO (IVPage Automation.Interface)
getPage0 = Automation.propertyGetID 0x3 [] Automation.outIDispatch
add3 :: IVShape a0 -> Prelude.Int -> IVLayer a -> Prelude.IO ()
add3 sheetObject fPresMems =
  Automation.methodID0 0x7 [Automation.inIDispatch sheetObject, Automation.inInt fPresMems]
remove :: IVShape a0 -> Prelude.Int -> IVLayer a -> Prelude.IO ()
remove sheetObject fPresMems =
  Automation.methodID0 0x8 [Automation.inIDispatch sheetObject, Automation.inInt fPresMems]
getCellsC :: Prelude.Int -> IVLayer a -> Prelude.IO (IVCell Automation.Interface)
getCellsC column =
  Automation.propertyGetID 0xa [Automation.inInt column] Automation.outIDispatch
-- --------------------------------------------------
-- 
-- interface IVLayers
-- 
-- --------------------------------------------------
data VLayers a = VLayers
                  
type IVLayers a = Automation.IDispatch (VLayers a)
iidIVLayers :: Com.IID (IVLayers Automation.Interface)
iidIVLayers = Com.mkIID "{000D0713-0000-0000-C000-000000000046}"
getItem7 :: Prelude.Int -> IVLayers a -> Prelude.IO (IVLayer Automation.Interface)
getItem7 nameOrIndex =
  Automation.propertyGetID 0o0 [Automation.inInt nameOrIndex] Automation.outIDispatch
add4 :: Prelude.String -> IVLayers a -> Prelude.IO (IVLayer Automation.Interface)
add4 layerName =
  Automation.functionID1 0x6 [Automation.inString layerName] Automation.outIDispatch
-- --------------------------------------------------
-- 
-- interface IVFont
-- 
-- --------------------------------------------------
data VFont a = VFont
                
type IVFont a = Automation.IDispatch (VFont a)
iidIVFont :: Com.IID (IVFont Automation.Interface)
iidIVFont = Com.mkIID "{000D0714-0000-0000-C000-000000000046}"
getAttributes :: IVFont a -> Prelude.IO (Prelude.Int)
getAttributes = Automation.propertyGetID 0x5 [] Automation.outInt
getCharSet :: IVFont a -> Prelude.IO (Prelude.Int)
getCharSet = Automation.propertyGetID 0x6 [] Automation.outInt
getPitchAndFamily :: IVFont a -> Prelude.IO (Prelude.Int)
getPitchAndFamily =
  Automation.propertyGetID 0x7 [] Automation.outInt
-- --------------------------------------------------
-- 
-- interface IVFonts
-- 
-- --------------------------------------------------
data VFonts a = VFonts
                 
type IVFonts a = Automation.IDispatch (VFonts a)
iidIVFonts :: Com.IID (IVFonts Automation.Interface)
iidIVFonts = Com.mkIID "{000D0715-0000-0000-C000-000000000046}"
getItem8 :: Prelude.Int -> IVFonts a -> Prelude.IO (IVFont Automation.Interface)
getItem8 nameOrIndex =
  Automation.propertyGetID 0o0 [Automation.inInt nameOrIndex] Automation.outIDispatch
getItemFromID1 :: Prelude.Int -> IVFonts a -> Prelude.IO (IVFont Automation.Interface)
getItemFromID1 objectID =
  Automation.propertyGetID 0x4 [Automation.inInt objectID] Automation.outIDispatch
-- --------------------------------------------------
-- 
-- interface IVColor
-- 
-- --------------------------------------------------
data VColor a = VColor
                 
type IVColor a = Automation.IDispatch (VColor a)
iidIVColor :: Com.IID (IVColor Automation.Interface)
iidIVColor = Com.mkIID "{000D0716-0000-0000-C000-000000000046}"
getRed :: IVColor a -> Prelude.IO (Prelude.Int)
getRed = Automation.propertyGetID 0x4 [] Automation.outInt
setRed :: Prelude.Int -> IVColor a -> Prelude.IO ()
setRed lpi2Ret =
  Automation.propertySetID 0x4 [Automation.inInt lpi2Ret]
getGreen :: IVColor a -> Prelude.IO (Prelude.Int)
getGreen = Automation.propertyGetID 0x5 [] Automation.outInt
setGreen :: Prelude.Int -> IVColor a -> Prelude.IO ()
setGreen lpi2Ret =
  Automation.propertySetID 0x5 [Automation.inInt lpi2Ret]
getBlue :: IVColor a -> Prelude.IO (Prelude.Int)
getBlue = Automation.propertyGetID 0x6 [] Automation.outInt
setBlue :: Prelude.Int -> IVColor a -> Prelude.IO ()
setBlue lpi2Ret =
  Automation.propertySetID 0x6 [Automation.inInt lpi2Ret]
getFlags :: IVColor a -> Prelude.IO (Prelude.Int)
getFlags = Automation.propertyGetID 0x7 [] Automation.outInt
setFlags :: Prelude.Int -> IVColor a -> Prelude.IO ()
setFlags lpi2Ret =
  Automation.propertySetID 0x7 [Automation.inInt lpi2Ret]
getPaletteEntry :: IVColor a -> Prelude.IO (Prelude.Int)
getPaletteEntry = Automation.propertyGetID 0o0 [] Automation.outInt
setPaletteEntry :: Prelude.Int -> IVColor a -> Prelude.IO ()
setPaletteEntry lpi4Ret =
  Automation.propertySetID 0o0 [Automation.inInt lpi4Ret]
-- --------------------------------------------------
-- 
-- interface IVColors
-- 
-- --------------------------------------------------
data VColors a = VColors
                  
type IVColors a = Automation.IDispatch (VColors a)
iidIVColors :: Com.IID (IVColors Automation.Interface)
iidIVColors = Com.mkIID "{000D0717-0000-0000-C000-000000000046}"
getItem9 :: Prelude.Int -> IVColors a -> Prelude.IO (IVColor Automation.Interface)
getItem9 index =
  Automation.propertyGetID 0o0 [Automation.inInt index] Automation.outIDispatch
-- --------------------------------------------------
-- 
-- interface IVAddon
-- 
-- --------------------------------------------------
data VAddon a = VAddon
                 
type IVAddon a = Automation.IDispatch (VAddon a)
iidIVAddon :: Com.IID (IVAddon Automation.Interface)
iidIVAddon = Com.mkIID "{000D0718-0000-0000-C000-000000000046}"
getEnabled :: Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getEnabled = Automation.propertyGetID 0x4 [] Automation.outInt
run :: Prelude.String -> IVAddon a -> Prelude.IO ()
run argString =
  Automation.methodID0 0x5 [Automation.inString argString]
-- --------------------------------------------------
-- 
-- interface IVAddons
-- 
-- --------------------------------------------------
data VAddons a = VAddons
                  
type IVAddons a = Automation.IDispatch (VAddons a)
iidIVAddons :: Com.IID (IVAddons Automation.Interface)
iidIVAddons = Com.mkIID "{000D0719-0000-0000-C000-000000000046}"
getItem10 :: Prelude.Int -> IVAddons a -> Prelude.IO (IVAddon Automation.Interface)
getItem10 nameOrIndex =
  Automation.propertyGetID 0o0 [Automation.inInt nameOrIndex] Automation.outIDispatch
add5 :: Prelude.String -> IVAddons a -> Prelude.IO (IVAddon Automation.Interface)
add5 fileName =
  Automation.functionID1 0x4 [Automation.inString fileName] Automation.outIDispatch
-- --------------------------------------------------
-- 
-- interface IVEvent
-- 
-- --------------------------------------------------
data VEvent a = VEvent
                 
type IVEvent a = Automation.IDispatch (VEvent a)
iidIVEvent :: Com.IID (IVEvent Automation.Interface)
iidIVEvent = Com.mkIID "{000D071A-0000-0000-C000-000000000046}"
getEvent :: IVEvent a -> Prelude.IO (Prelude.Int)
getEvent = Automation.propertyGetID 0o0 [] Automation.outInt
setEvent :: Prelude.Int -> IVEvent a -> Prelude.IO ()
setEvent lpi2Ret =
  Automation.propertySetID 0o0 [Automation.inInt lpi2Ret]
getAction :: IVEvent a -> Prelude.IO (Prelude.Int)
getAction = Automation.propertyGetID 0x4 [] Automation.outInt
setAction :: Prelude.Int -> IVEvent a -> Prelude.IO ()
setAction lpi2Ret =
  Automation.propertySetID 0x4 [Automation.inInt lpi2Ret]
getTarget :: IVEvent a -> Prelude.IO (Prelude.String)
getTarget = Automation.propertyGetID 0x5 [] Automation.outString
setTarget :: Prelude.String -> IVEvent a -> Prelude.IO ()
setTarget lpbstrRet =
  Automation.propertySetID 0x5 [Automation.inString lpbstrRet]
getTargetArgs :: IVEvent a -> Prelude.IO (Prelude.String)
getTargetArgs =
  Automation.propertyGetID 0x6 [] Automation.outString
setTargetArgs :: Prelude.String -> IVEvent a -> Prelude.IO ()
setTargetArgs lpbstrRet =
  Automation.propertySetID 0x6 [Automation.inString lpbstrRet]
trigger0 :: Prelude.String -> Automation.IDispatch a -> Prelude.IO ()
trigger0 contextString =
  Automation.methodID0 0x7 [Automation.inString contextString]
getID4 :: IVEvent a -> Prelude.IO (Prelude.Int)
getID4 = Automation.propertyGetID 0xa [] Automation.outInt
setEnabled :: Prelude.Int -> IVEvent a -> Prelude.IO ()
setEnabled lpi2Ret =
  Automation.propertySetID 0xb [Automation.inInt lpi2Ret]
getPersistable :: IVEvent a -> Prelude.IO (Prelude.Int)
getPersistable = Automation.propertyGetID 0xc [] Automation.outInt
getPersistent :: IVEvent a -> Prelude.IO (Prelude.Int)
getPersistent = Automation.propertyGetID 0xd [] Automation.outInt
setPersistent :: Prelude.Int -> IVEvent a -> Prelude.IO ()
setPersistent lpi2Ret =
  Automation.propertySetID 0xd [Automation.inInt lpi2Ret]
-- --------------------------------------------------
-- 
-- interface IVEventList
-- 
-- --------------------------------------------------
data VEventList a = VEventList
                     
type IVEventList a = Automation.IDispatch (VEventList a)
iidIVEventList :: Com.IID (IVEventList Automation.Interface)
iidIVEventList = Com.mkIID "{000D071B-0000-0000-C000-000000000046}"
getItem11 :: Prelude.Int -> IVEventList a -> Prelude.IO (IVEvent Automation.Interface)
getItem11 index =
  Automation.propertyGetID 0o0 [Automation.inInt index] Automation.outIDispatch
add6 :: Prelude.Int -> Prelude.Int -> Prelude.String -> Prelude.String -> IVEventList a -> Prelude.IO (IVEvent Automation.Interface)
add6 eventCode action target targetArgs =
  Automation.functionID1 0x4 [Automation.inInt eventCode, Automation.inInt action, Automation.inString target, Automation.inString targetArgs] Automation.outIDispatch
addAdvise :: Prelude.Int -> Prelude.Int -> Prelude.String -> Prelude.String -> IVEventList a -> Prelude.IO (IVEvent Automation.Interface)
addAdvise eventCode sinkIUnkOrIDisp iIDSink targetArgs =
  Automation.functionID1 0x5 [Automation.inInt eventCode, Automation.inInt sinkIUnkOrIDisp, Automation.inString iIDSink, Automation.inString targetArgs] Automation.outIDispatch
getItemFromID2 :: Prelude.Int -> IVEventList a -> Prelude.IO (IVEvent Automation.Interface)
getItemFromID2 objectID =
  Automation.propertyGetID 0x6 [Automation.inInt objectID] Automation.outIDispatch
-- --------------------------------------------------
-- 
-- interface IVGlobal
-- 
-- --------------------------------------------------
data VGlobal a = VGlobal
                  
type IVGlobal a = Automation.IDispatch (VGlobal a)
iidIVGlobal :: Com.IID (IVGlobal Automation.Interface)
iidIVGlobal = Com.mkIID "{000D071C-0000-0000-C000-000000000046}"
-- --------------------------------------------------
-- 
-- dispinterface EDocument
-- 
-- --------------------------------------------------
data EDocument a = EDocument
                    
type IEDocument a = Automation.IDispatch (EDocument a)
iidIEDocument :: Com.IID (IEDocument Automation.Interface)
iidIEDocument = Com.mkIID "{000D0750-0000-0000-C000-000000000046}"
documentOpened :: IVDocument a0 -> Automation.IDispatch a -> Prelude.IO ()
documentOpened doc =
  Automation.methodID0 0x2 [Automation.inIDispatch doc]
documentCreated :: IVDocument a0 -> Automation.IDispatch a -> Prelude.IO ()
documentCreated doc =
  Automation.methodID0 0x1 [Automation.inIDispatch doc]
documentSaved :: IVDocument a0 -> Automation.IDispatch a -> Prelude.IO ()
documentSaved doc =
  Automation.methodID0 0x3 [Automation.inIDispatch doc]
documentSavedAs :: IVDocument a0 -> Automation.IDispatch a -> Prelude.IO ()
documentSavedAs doc =
  Automation.methodID0 0x4 [Automation.inIDispatch doc]
documentChanged :: IVDocument a0 -> Automation.IDispatch a -> Prelude.IO ()
documentChanged doc =
  Automation.methodID0 0x2002 [Automation.inIDispatch doc]
beforeDocumentClose :: IVDocument a0 -> Automation.IDispatch a -> Prelude.IO ()
beforeDocumentClose doc =
  Automation.methodID0 0x4002 [Automation.inIDispatch doc]
styleAdded :: IVStyle a0 -> Automation.IDispatch a -> Prelude.IO ()
styleAdded style =
  Automation.methodID0 0x8004 [Automation.inIDispatch style]
styleChanged :: IVStyle a0 -> Automation.IDispatch a -> Prelude.IO ()
styleChanged style =
  Automation.methodID0 0x2004 [Automation.inIDispatch style]
beforeStyleDelete :: IVStyle a0 -> Automation.IDispatch a -> Prelude.IO ()
beforeStyleDelete style =
  Automation.methodID0 0x4004 [Automation.inIDispatch style]
masterAdded :: IVMaster a0 -> Automation.IDispatch a -> Prelude.IO ()
masterAdded master =
  Automation.methodID0 0x8008 [Automation.inIDispatch master]
masterChanged :: IVMaster a0 -> Automation.IDispatch a -> Prelude.IO ()
masterChanged master =
  Automation.methodID0 0x2008 [Automation.inIDispatch master]
beforeMasterDelete :: IVMaster a0 -> Automation.IDispatch a -> Prelude.IO ()
beforeMasterDelete master =
  Automation.methodID0 0x4008 [Automation.inIDispatch master]
pageAdded :: IVPage a0 -> Automation.IDispatch a -> Prelude.IO ()
pageAdded page =
  Automation.methodID0 0x8010 [Automation.inIDispatch page]
pageChanged :: IVPage a0 -> Automation.IDispatch a -> Prelude.IO ()
pageChanged page =
  Automation.methodID0 0x2010 [Automation.inIDispatch page]
beforePageDelete :: IVPage a0 -> Automation.IDispatch a -> Prelude.IO ()
beforePageDelete page =
  Automation.methodID0 0x4010 [Automation.inIDispatch page]
shapeAdded :: IVShape a0 -> Automation.IDispatch a -> Prelude.IO ()
shapeAdded shape =
  Automation.methodID0 0x8040 [Automation.inIDispatch shape]
beforeSelectionDelete :: IVSelection a0 -> Automation.IDispatch a -> Prelude.IO ()
beforeSelectionDelete selection =
  Automation.methodID0 0x385 [Automation.inIDispatch selection]
runModeEntered :: IVDocument a0 -> Automation.IDispatch a -> Prelude.IO ()
runModeEntered doc =
  Automation.methodID0 0x5 [Automation.inIDispatch doc]
designModeEntered :: IVDocument a0 -> Automation.IDispatch a -> Prelude.IO ()
designModeEntered doc =
  Automation.methodID0 0x6 [Automation.inIDispatch doc]
beforeDocumentSave :: IVDocument a0 -> Automation.IDispatch a -> Prelude.IO ()
beforeDocumentSave doc =
  Automation.methodID0 0x7 [Automation.inIDispatch doc]
beforeDocumentSaveAs :: IVDocument a0 -> Automation.IDispatch a -> Prelude.IO ()
beforeDocumentSaveAs doc =
  Automation.methodID0 0x8 [Automation.inIDispatch doc]
-- --------------------------------------------------
-- 
-- dispinterface EApplication
-- 
-- --------------------------------------------------
data EApplication a = EApplication
                       
type IEApplication a = Automation.IDispatch (EApplication a)
iidIEApplication :: Com.IID (IEApplication Automation.Interface)
iidIEApplication =
  Com.mkIID "{000D0B00-0000-0000-C000-000000000046}"
appActivated :: IVApplication a0 -> IEApplication a -> Prelude.IO ()
appActivated app =
  Automation.methodID0 0x1001 [Automation.inIDispatch app]
appDeactivated :: IVApplication a0 -> IEApplication a -> Prelude.IO ()
appDeactivated app =
  Automation.methodID0 0x1002 [Automation.inIDispatch app]
appObjActivated :: IVApplication a0 -> IEApplication a -> Prelude.IO ()
appObjActivated app =
  Automation.methodID0 0x1004 [Automation.inIDispatch app]
appObjDeactivated :: IVApplication a0 -> IEApplication a -> Prelude.IO ()
appObjDeactivated app =
  Automation.methodID0 0x1008 [Automation.inIDispatch app]
beforeQuit :: IVApplication a0 -> IEApplication a -> Prelude.IO ()
beforeQuit app =
  Automation.methodID0 0x1010 [Automation.inIDispatch app]
beforeModal :: IVApplication a0 -> IEApplication a -> Prelude.IO ()
beforeModal app =
  Automation.methodID0 0x1020 [Automation.inIDispatch app]
afterModal :: IVApplication a0 -> IEApplication a -> Prelude.IO ()
afterModal app =
  Automation.methodID0 0x1040 [Automation.inIDispatch app]
windowOpened :: IVWindow a0 -> Automation.IDispatch a -> Prelude.IO ()
windowOpened window =
  Automation.methodID0 0x8001 [Automation.inIDispatch window]
selectionChanged :: IVWindow a0 -> Automation.IDispatch a -> Prelude.IO ()
selectionChanged window =
  Automation.methodID0 0x2bd [Automation.inIDispatch window]
beforeWindowClosed :: IVWindow a0 -> Automation.IDispatch a -> Prelude.IO ()
beforeWindowClosed window =
  Automation.methodID0 0x4001 [Automation.inIDispatch window]
windowActivated :: IVWindow a0 -> Automation.IDispatch a -> Prelude.IO ()
windowActivated window =
  Automation.methodID0 0x1080 [Automation.inIDispatch window]
beforeWindowSelDelete :: IVWindow a0 -> Automation.IDispatch a -> Prelude.IO ()
beforeWindowSelDelete window =
  Automation.methodID0 0x2be [Automation.inIDispatch window]
beforeWindowPageTurn :: IVWindow a0 -> Automation.IDispatch a -> Prelude.IO ()
beforeWindowPageTurn window =
  Automation.methodID0 0x2bf [Automation.inIDispatch window]
windowTurnedToPage :: IVWindow a0 -> Automation.IDispatch a -> Prelude.IO ()
windowTurnedToPage window =
  Automation.methodID0 0x2c0 [Automation.inIDispatch window]
shapeChanged :: IVShape a0 -> Automation.IDispatch a -> Prelude.IO ()
shapeChanged shape =
  Automation.methodID0 0x2040 [Automation.inIDispatch shape]
selectionAdded :: IVSelection a0 -> Automation.IDispatch a -> Prelude.IO ()
selectionAdded selection =
  Automation.methodID0 0x386 [Automation.inIDispatch selection]
beforeShapeDelete :: IVShape a0 -> Automation.IDispatch a -> Prelude.IO ()
beforeShapeDelete shape =
  Automation.methodID0 0x4040 [Automation.inIDispatch shape]
textChanged :: IVShape a0 -> Automation.IDispatch a -> Prelude.IO ()
textChanged shape =
  Automation.methodID0 0x2080 [Automation.inIDispatch shape]
cellChanged :: IVCell a0 -> Automation.IDispatch a -> Prelude.IO ()
cellChanged cell =
  Automation.methodID0 0x2800 [Automation.inIDispatch cell]
markerEvent :: IVApplication a0 -> Prelude.Int -> Prelude.String -> IEApplication a -> Prelude.IO ()
markerEvent app sequenceNum contextString =
  Automation.methodID0 0x1100 [Automation.inIDispatch app, Automation.inInt sequenceNum, Automation.inString contextString]
noEventsPending :: IVApplication a0 -> IEApplication a -> Prelude.IO ()
noEventsPending app =
  Automation.methodID0 0x1200 [Automation.inIDispatch app]
visioIsIdle :: IVApplication a0 -> IEApplication a -> Prelude.IO ()
visioIsIdle app =
  Automation.methodID0 0x1400 [Automation.inIDispatch app]
mustFlushScopeBeginning :: IVApplication a0 -> IEApplication a -> Prelude.IO ()
mustFlushScopeBeginning app =
  Automation.methodID0 0xc8 [Automation.inIDispatch app]
mustFlushScopeEnded :: IVApplication a0 -> IEApplication a -> Prelude.IO ()
mustFlushScopeEnded app =
  Automation.methodID0 0xc9 [Automation.inIDispatch app]
formulaChanged :: IVCell a0 -> Automation.IDispatch a -> Prelude.IO ()
formulaChanged cell =
  Automation.methodID0 0x3000 [Automation.inIDispatch cell]
connectionsAdded :: IVConnects a0 -> Automation.IDispatch a -> Prelude.IO ()
connectionsAdded connects =
  Automation.methodID0 0x8100 [Automation.inIDispatch connects]
connectionsDeleted :: IVConnects a0 -> Automation.IDispatch a -> Prelude.IO ()
connectionsDeleted connects =
  Automation.methodID0 0x4100 [Automation.inIDispatch connects]
-- --------------------------------------------------
-- 
-- dispinterface EWindows
-- 
-- --------------------------------------------------
data EWindows a = EWindows
                   
type IEWindows a = Automation.IDispatch (EWindows a)
iidIEWindows :: Com.IID (IEWindows Automation.Interface)
iidIEWindows = Com.mkIID "{000D0B01-0000-0000-C000-000000000046}"
-- --------------------------------------------------
-- 
-- dispinterface EWindow
-- 
-- --------------------------------------------------
data EWindow a = EWindow
                  
type IEWindow a = Automation.IDispatch (EWindow a)
iidIEWindow :: Com.IID (IEWindow Automation.Interface)
iidIEWindow = Com.mkIID "{000D0B02-0000-0000-C000-000000000046}"
-- --------------------------------------------------
-- 
-- dispinterface EDocuments
-- 
-- --------------------------------------------------
data EDocuments a = EDocuments
                     
type IEDocuments a = Automation.IDispatch (EDocuments a)
iidIEDocuments :: Com.IID (IEDocuments Automation.Interface)
iidIEDocuments = Com.mkIID "{000D0B03-0000-0000-C000-000000000046}"
-- --------------------------------------------------
-- 
-- dispinterface EStyles
-- 
-- --------------------------------------------------
data EStyles a = EStyles
                  
type IEStyles a = Automation.IDispatch (EStyles a)
iidIEStyles :: Com.IID (IEStyles Automation.Interface)
iidIEStyles = Com.mkIID "{000D0B05-0000-0000-C000-000000000046}"
-- --------------------------------------------------
-- 
-- dispinterface EStyle
-- 
-- --------------------------------------------------
data EStyle a = EStyle
                 
type IEStyle a = Automation.IDispatch (EStyle a)
iidIEStyle :: Com.IID (IEStyle Automation.Interface)
iidIEStyle = Com.mkIID "{000D0B06-0000-0000-C000-000000000046}"
-- --------------------------------------------------
-- 
-- dispinterface EMasters
-- 
-- --------------------------------------------------
data EMasters a = EMasters
                   
type IEMasters a = Automation.IDispatch (EMasters a)
iidIEMasters :: Com.IID (IEMasters Automation.Interface)
iidIEMasters = Com.mkIID "{000D0B07-0000-0000-C000-000000000046}"
-- --------------------------------------------------
-- 
-- dispinterface EMaster
-- 
-- --------------------------------------------------
data EMaster a = EMaster
                  
type IEMaster a = Automation.IDispatch (EMaster a)
iidIEMaster :: Com.IID (IEMaster Automation.Interface)
iidIEMaster = Com.mkIID "{000D0B08-0000-0000-C000-000000000046}"
-- --------------------------------------------------
-- 
-- dispinterface EPages
-- 
-- --------------------------------------------------
data EPages a = EPages
                 
type IEPages a = Automation.IDispatch (EPages a)
iidIEPages :: Com.IID (IEPages Automation.Interface)
iidIEPages = Com.mkIID "{000D0B09-0000-0000-C000-000000000046}"
-- --------------------------------------------------
-- 
-- dispinterface EPage
-- 
-- --------------------------------------------------
data EPage a = EPage
                
type IEPage a = Automation.IDispatch (EPage a)
iidIEPage :: Com.IID (IEPage Automation.Interface)
iidIEPage = Com.mkIID "{000D0B0A-0000-0000-C000-000000000046}"
-- --------------------------------------------------
-- 
-- dispinterface EShape
-- 
-- --------------------------------------------------
data EShape a = EShape
                 
type IEShape a = Automation.IDispatch (EShape a)
iidIEShape :: Com.IID (IEShape Automation.Interface)
iidIEShape = Com.mkIID "{000D0B0B-0000-0000-C000-000000000046}"
-- --------------------------------------------------
-- 
-- dispinterface ECharacters
-- 
-- --------------------------------------------------
data ECharacters a = ECharacters
                      
type IECharacters a = Automation.IDispatch (ECharacters a)
iidIECharacters :: Com.IID (IECharacters Automation.Interface)
iidIECharacters =
  Com.mkIID "{000D0B0C-0000-0000-C000-000000000046}"
-- --------------------------------------------------
-- 
-- dispinterface ECell
-- 
-- --------------------------------------------------
data ECell a = ECell
                
type IECell a = Automation.IDispatch (ECell a)
iidIECell :: Com.IID (IECell Automation.Interface)
iidIECell = Com.mkIID "{000D0B0D-0000-0000-C000-000000000046}"
-- --------------------------------------------------
-- 
-- coclass Application
-- 
-- --------------------------------------------------
clsidApplication :: Com.CLSID
clsidApplication =
  Com.mkCLSID "{00021A20-0000-0000-C000-000000000046}"
-- --------------------------------------------------
-- 
-- coclass Document
-- 
-- --------------------------------------------------
clsidDocument :: Com.CLSID
clsidDocument =
  Com.mkCLSID "{00021A21-0000-0000-C000-000000000046}"
-- --------------------------------------------------
-- 
-- coclass Documents
-- 
-- --------------------------------------------------
clsidDocuments :: Com.CLSID
clsidDocuments =
  Com.mkCLSID "{000D0A00-0000-0000-C000-000000000046}"
-- --------------------------------------------------
-- 
-- coclass Styles
-- 
-- --------------------------------------------------
clsidStyles :: Com.CLSID
clsidStyles = Com.mkCLSID "{000D0A01-0000-0000-C000-000000000046}"
-- --------------------------------------------------
-- 
-- coclass Style
-- 
-- --------------------------------------------------
clsidStyle :: Com.CLSID
clsidStyle = Com.mkCLSID "{000D0A02-0000-0000-C000-000000000046}"
-- --------------------------------------------------
-- 
-- coclass Masters
-- 
-- --------------------------------------------------
clsidMasters :: Com.CLSID
clsidMasters = Com.mkCLSID "{000D0A03-0000-0000-C000-000000000046}"
-- --------------------------------------------------
-- 
-- coclass Master
-- 
-- --------------------------------------------------
clsidMaster :: Com.CLSID
clsidMaster = Com.mkCLSID "{000D0A04-0000-0000-C000-000000000046}"
-- --------------------------------------------------
-- 
-- coclass Pages
-- 
-- --------------------------------------------------
clsidPages :: Com.CLSID
clsidPages = Com.mkCLSID "{000D0A05-0000-0000-C000-000000000046}"
-- --------------------------------------------------
-- 
-- coclass Page
-- 
-- --------------------------------------------------
clsidPage :: Com.CLSID
clsidPage = Com.mkCLSID "{000D0A06-0000-0000-C000-000000000046}"
-- --------------------------------------------------
-- 
-- coclass Layers
-- 
-- --------------------------------------------------
clsidLayers :: Com.CLSID
clsidLayers = Com.mkCLSID "{000D0A07-0000-0000-C000-000000000046}"
-- --------------------------------------------------
-- 
-- coclass Layer
-- 
-- --------------------------------------------------
clsidLayer :: Com.CLSID
clsidLayer = Com.mkCLSID "{000D0A08-0000-0000-C000-000000000046}"
-- --------------------------------------------------
-- 
-- coclass Shapes
-- 
-- --------------------------------------------------
clsidShapes :: Com.CLSID
clsidShapes = Com.mkCLSID "{000D0A09-0000-0000-C000-000000000046}"
-- --------------------------------------------------
-- 
-- coclass Shape
-- 
-- --------------------------------------------------
clsidShape :: Com.CLSID
clsidShape = Com.mkCLSID "{000D0A0A-0000-0000-C000-000000000046}"
-- --------------------------------------------------
-- 
-- coclass Windows
-- 
-- --------------------------------------------------
clsidWindows :: Com.CLSID
clsidWindows = Com.mkCLSID "{000D0A0B-0000-0000-C000-000000000046}"
-- --------------------------------------------------
-- 
-- coclass Window
-- 
-- --------------------------------------------------
clsidWindow :: Com.CLSID
clsidWindow = Com.mkCLSID "{000D0A0C-0000-0000-C000-000000000046}"
-- --------------------------------------------------
-- 
-- coclass Cell
-- 
-- --------------------------------------------------
clsidCell :: Com.CLSID
clsidCell = Com.mkCLSID "{000D0A0D-0000-0000-C000-000000000046}"
-- --------------------------------------------------
-- 
-- coclass Selection
-- 
-- --------------------------------------------------
clsidSelection :: Com.CLSID
clsidSelection =
  Com.mkCLSID "{000D0A0E-0000-0000-C000-000000000046}"
-- --------------------------------------------------
-- 
-- coclass Font
-- 
-- --------------------------------------------------
clsidFont :: Com.CLSID
clsidFont = Com.mkCLSID "{000D0A0F-0000-0000-C000-000000000046}"
-- --------------------------------------------------
-- 
-- coclass Fonts
-- 
-- --------------------------------------------------
clsidFonts :: Com.CLSID
clsidFonts = Com.mkCLSID "{000D0A10-0000-0000-C000-000000000046}"
-- --------------------------------------------------
-- 
-- coclass Color
-- 
-- --------------------------------------------------
clsidColor :: Com.CLSID
clsidColor = Com.mkCLSID "{000D0A11-0000-0000-C000-000000000046}"
-- --------------------------------------------------
-- 
-- coclass Colors
-- 
-- --------------------------------------------------
clsidColors :: Com.CLSID
clsidColors = Com.mkCLSID "{000D0A12-0000-0000-C000-000000000046}"
-- --------------------------------------------------
-- 
-- coclass Addon
-- 
-- --------------------------------------------------
clsidAddon :: Com.CLSID
clsidAddon = Com.mkCLSID "{000D0A13-0000-0000-C000-000000000046}"
-- --------------------------------------------------
-- 
-- coclass Addons
-- 
-- --------------------------------------------------
clsidAddons :: Com.CLSID
clsidAddons = Com.mkCLSID "{000D0A14-0000-0000-C000-000000000046}"
-- --------------------------------------------------
-- 
-- coclass Event
-- 
-- --------------------------------------------------
clsidEvent :: Com.CLSID
clsidEvent = Com.mkCLSID "{000D0A15-0000-0000-C000-000000000046}"
-- --------------------------------------------------
-- 
-- coclass EventList
-- 
-- --------------------------------------------------
clsidEventList :: Com.CLSID
clsidEventList =
  Com.mkCLSID "{000D0A16-0000-0000-C000-000000000046}"
-- --------------------------------------------------
-- 
-- coclass Characters
-- 
-- --------------------------------------------------
clsidCharacters :: Com.CLSID
clsidCharacters =
  Com.mkCLSID "{000D0A17-0000-0000-C000-000000000046}"
-- --------------------------------------------------
-- 
-- coclass Connect
-- 
-- --------------------------------------------------
clsidConnect :: Com.CLSID
clsidConnect = Com.mkCLSID "{000D0A18-0000-0000-C000-000000000046}"
-- --------------------------------------------------
-- 
-- coclass Connects
-- 
-- --------------------------------------------------
clsidConnects :: Com.CLSID
clsidConnects =
  Com.mkCLSID "{000D0A19-0000-0000-C000-000000000046}"
-- --------------------------------------------------
-- 
-- coclass Global
-- 
-- --------------------------------------------------
clsidGlobal :: Com.CLSID
clsidGlobal = Com.mkCLSID "{000D0A1A-0000-0000-C000-000000000046}"
-- --------------------------------------------------
-- 
-- interface IVMenuItem
-- 
-- --------------------------------------------------
data VMenuItem a = VMenuItem
                    
type IVMenuItem a = Automation.IDispatch (VMenuItem a)
iidIVMenuItem :: Com.IID (IVMenuItem Automation.Interface)
iidIVMenuItem = Com.mkIID "{000D0212-0000-0000-C000-000000000046}"
getDefault :: Automation.IDispatch a -> Prelude.IO (Prelude.String)
getDefault =
  Automation.propertyGetID 0x60020001 [] Automation.outString
getIndex11 :: Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getIndex11 =
  Automation.propertyGetID 0x60020002 [] Automation.outInt
getMenuItems :: Automation.IDispatch a -> Prelude.IO (IVMenuItems Automation.Interface)
getMenuItems =
  Automation.propertyGetID 0x60020003 [] Automation.outIDispatch
getParent0 :: IVMenuItem a -> Prelude.IO (IVMenuItems Automation.Interface)
getParent0 =
  Automation.propertyGetID 0x60020004 [] Automation.outIDispatch
setCmdNum :: Prelude.Int -> Automation.IDispatch a -> Prelude.IO ()
setCmdNum pwCmd =
  Automation.propertySetID 0x60020005 [Automation.inInt pwCmd]
getCmdNum :: Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getCmdNum =
  Automation.propertyGetID 0x60020005 [] Automation.outInt
setHelpContextID :: Prelude.Int -> Automation.IDispatch a -> Prelude.IO ()
setHelpContextID pHelpContextID =
  Automation.propertySetID 0x60020007 [Automation.inInt pHelpContextID]
getHelpContextID :: Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getHelpContextID =
  Automation.propertyGetID 0x60020007 [] Automation.outInt
getIsSeparator :: IVMenuItem a -> Prelude.IO (Prelude.Int)
getIsSeparator =
  Automation.propertyGetID 0x60020009 [] Automation.outInt
getIsHierarchical :: IVMenuItem a -> Prelude.IO (Prelude.Int)
getIsHierarchical =
  Automation.propertyGetID 0x6002000a [] Automation.outInt
setCaption :: Prelude.String -> Automation.IDispatch a -> Prelude.IO ()
setCaption pCaption =
  Automation.propertySetID 0o0 [Automation.inString pCaption]
getCaption :: Automation.IDispatch a -> Prelude.IO (Prelude.String)
getCaption = Automation.propertyGetID 0o0 [] Automation.outString
setActionText :: Prelude.String -> Automation.IDispatch a -> Prelude.IO ()
setActionText pActionText =
  Automation.propertySetID 0x6002000d [Automation.inString pActionText]
getActionText :: Automation.IDispatch a -> Prelude.IO (Prelude.String)
getActionText =
  Automation.propertyGetID 0x6002000d [] Automation.outString
setMiniHelp :: Prelude.String -> IVMenuItem a -> Prelude.IO ()
setMiniHelp pMiniHelp =
  Automation.propertySetID 0x6002000f [Automation.inString pMiniHelp]
getMiniHelp :: IVMenuItem a -> Prelude.IO (Prelude.String)
getMiniHelp =
  Automation.propertyGetID 0x6002000f [] Automation.outString
setAddOnName :: Prelude.String -> Automation.IDispatch a -> Prelude.IO ()
setAddOnName pAddOnName =
  Automation.propertySetID 0x60020011 [Automation.inString pAddOnName]
getAddOnName :: Automation.IDispatch a -> Prelude.IO (Prelude.String)
getAddOnName =
  Automation.propertyGetID 0x60020011 [] Automation.outString
setAddOnArgs :: Prelude.String -> Automation.IDispatch a -> Prelude.IO ()
setAddOnArgs pAddOnArgs =
  Automation.propertySetID 0x60020013 [Automation.inString pAddOnArgs]
getAddOnArgs :: Automation.IDispatch a -> Prelude.IO (Prelude.String)
getAddOnArgs =
  Automation.propertyGetID 0x60020013 [] Automation.outString
setHelpFile :: Prelude.String -> Automation.IDispatch a -> Prelude.IO ()
setHelpFile pHelpFile =
  Automation.propertySetID 0x60020015 [Automation.inString pHelpFile]
getHelpFile :: Automation.IDispatch a -> Prelude.IO (Prelude.String)
getHelpFile =
  Automation.propertyGetID 0x60020015 [] Automation.outString
-- --------------------------------------------------
-- 
-- interface IEnumVMenuItem
-- 
-- --------------------------------------------------
{-
next :: HDirect.Int32 -> Prelude.IO (IVMenuItem Automation.Interface, HDirect.Int32)
next celt =
  do
    rgelt <- HDirect.allocOutPointer (Prelude.toInt HDirect.sizeofAddr)
    pceltFetched <- HDirect.allocOutPointer (Prelude.toInt HDirect.sizeofInt32)
    o_next <- primnext celt rgelt pceltFetched
    Com.okHRESULT o_next
    rgelt <- HDirect.doThenFree HDirect.trivialFree (HDirect.unmarshallref Com.readiptr) rgelt
    pceltFetched <- HDirect.doThenFree HDirect.trivialFree (HDirect.unmarshallref HDirect.readInt32) pceltFetched
    Prelude.return (rgelt, pceltFetched)
skip :: HDirect.Int32 -> Prelude.IO ()
skip celt =
  do
    o_skip <- primskip celt
    Com.okHRESULT o_skip
    Prelude.return ()
reset :: Prelude.IO ()
reset =
  do
    o_reset <- primreset
    Com.okHRESULT o_reset
    Prelude.return ()
clone :: Prelude.IO (IEnumVMenuItem Automation.Interface)
clone =
  do
    ppenm <- HDirect.allocOutPointer (Prelude.toInt HDirect.sizeofAddr)
    o_clone <- primclone ppenm
    Com.okHRESULT o_clone
    ppenm <- HDirect.doThenFree HDirect.trivialFree (HDirect.unmarshallref Com.readiptr) ppenm
    Prelude.return (ppenm)
-}
-- --------------------------------------------------
-- 
-- interface IVMenuItems
-- 
-- --------------------------------------------------
data VMenuItems a = VMenuItems
                     
type IVMenuItems a = Automation.IDispatch (VMenuItems a)
iidIVMenuItems :: Com.IID (IVMenuItems Automation.Interface)
iidIVMenuItems = Com.mkIID "{000D0216-0000-0000-C000-000000000046}"
getNewEnum :: Automation.IDispatch a -> Prelude.IO (Com.IUnknown Automation.Interface)
getNewEnum =
  Automation.propertyGetID 0xfffffffc [] Automation.outIUnknown
getItem12 :: Prelude.Int -> IVMenuItems a -> Prelude.IO (IVMenuItem Automation.Interface)
getItem12 lIndex =
  Automation.propertyGetID 0o0 [Automation.inInt lIndex] Automation.outIDispatch
add7 :: IVMenuItems a -> Prelude.IO (IVMenuItem Automation.Interface)
add7 = Automation.functionID1 0x60020002 [] Automation.outIDispatch
addAt :: Prelude.Int -> IVMenuItems a -> Prelude.IO (IVMenuItem Automation.Interface)
addAt lIndex =
  Automation.functionID1 0x60020003 [Automation.inInt lIndex] Automation.outIDispatch
getCount12 :: Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getCount12 =
  Automation.propertyGetID 0x60020004 [] Automation.outInt
getParent1 :: IVMenuItems a -> Prelude.IO (IVMenu Automation.Interface)
getParent1 =
  Automation.propertyGetID 0x60020005 [] Automation.outIDispatch
-- --------------------------------------------------
-- 
-- interface IVMenu
-- 
-- --------------------------------------------------
data VMenu a = VMenu
                
type IVMenu a = Automation.IDispatch (VMenu a)
iidIVMenu :: Com.IID (IVMenu Automation.Interface)
iidIVMenu = Com.mkIID "{000D0222-0000-0000-C000-000000000046}"
setMDIWindowMenu :: Prelude.Int -> IVMenu a -> Prelude.IO ()
setMDIWindowMenu pMDIWindowMenu =
  Automation.propertySetID 0x60020005 [Automation.inInt pMDIWindowMenu]
getMDIWindowMenu :: IVMenu a -> Prelude.IO (Prelude.Int)
getMDIWindowMenu =
  Automation.propertyGetID 0x60020005 [] Automation.outInt
getParent2 :: IVMenu a -> Prelude.IO (IVMenus Automation.Interface)
getParent2 =
  Automation.propertyGetID 0x60020008 [] Automation.outIDispatch
-- --------------------------------------------------
-- 
-- interface IEnumVMenu
-- 
-- --------------------------------------------------
{-
next0 :: HDirect.Int32 -> Prelude.IO (IVMenu Automation.Interface, HDirect.Int32)
next0 celt =
  do
    rgelt <- HDirect.allocOutPointer (Prelude.toInt HDirect.sizeofAddr)
    pceltFetched <- HDirect.allocOutPointer (Prelude.toInt HDirect.sizeofInt32)
    o_next0 <- primnext0 celt rgelt pceltFetched
    Com.okHRESULT o_next0
    rgelt <- HDirect.doThenFree HDirect.trivialFree (HDirect.unmarshallref Com.readiptr) rgelt
    pceltFetched <- HDirect.doThenFree HDirect.trivialFree (HDirect.unmarshallref HDirect.readInt32) pceltFetched
    Prelude.return (rgelt, pceltFetched)
clone0 :: Prelude.IO (IEnumVMenu Automation.Interface)
clone0 =
  do
    ppenm <- HDirect.allocOutPointer (Prelude.toInt HDirect.sizeofAddr)
    o_clone0 <- primclone0 ppenm
    Com.okHRESULT o_clone0
    ppenm <- HDirect.doThenFree HDirect.trivialFree (HDirect.unmarshallref Com.readiptr) ppenm
    Prelude.return (ppenm)
-}
-- --------------------------------------------------
-- 
-- interface IVMenus
-- 
-- --------------------------------------------------
data VMenus a = VMenus
                 
type IVMenus a = Automation.IDispatch (VMenus a)
iidIVMenus :: Com.IID (IVMenus Automation.Interface)
iidIVMenus = Com.mkIID "{000D0225-0000-0000-C000-000000000046}"
getItem13 :: Prelude.Int -> IVMenus a -> Prelude.IO (IVMenu Automation.Interface)
getItem13 lIndex =
  Automation.propertyGetID 0o0 [Automation.inInt lIndex] Automation.outIDispatch
add8 :: IVMenus a -> Prelude.IO (IVMenu Automation.Interface)
add8 = Automation.functionID1 0x60020002 [] Automation.outIDispatch
addAt0 :: Prelude.Int -> IVMenus a -> Prelude.IO (IVMenu Automation.Interface)
addAt0 lIndex =
  Automation.functionID1 0x60020003 [Automation.inInt lIndex] Automation.outIDispatch
getParent3 :: IVMenus a -> Prelude.IO (IVMenuSet Automation.Interface)
getParent3 =
  Automation.propertyGetID 0x60020005 [] Automation.outIDispatch
-- --------------------------------------------------
-- 
-- interface IVMenuSet
-- 
-- --------------------------------------------------
data VMenuSet a = VMenuSet
                   
type IVMenuSet a = Automation.IDispatch (VMenuSet a)
iidIVMenuSet :: Com.IID (IVMenuSet Automation.Interface)
iidIVMenuSet = Com.mkIID "{000D0232-0000-0000-C000-000000000046}"
getSetID :: Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getSetID = Automation.propertyGetID 0x60020004 [] Automation.outInt
getMenus :: IVMenuSet a -> Prelude.IO (IVMenus Automation.Interface)
getMenus =
  Automation.propertyGetID 0x60020005 [] Automation.outIDispatch
getParent4 :: IVMenuSet a -> Prelude.IO (IVMenuSets Automation.Interface)
getParent4 =
  Automation.propertyGetID 0x60020006 [] Automation.outIDispatch
-- --------------------------------------------------
-- 
-- interface IEnumVMenuSet
-- 
-- --------------------------------------------------
{-
next1 :: HDirect.Int32 -> Prelude.IO (IVMenuSet Automation.Interface, HDirect.Int32)
next1 celt =
  do
    rgelt <- HDirect.allocOutPointer (Prelude.toInt HDirect.sizeofAddr)
    pceltFetched <- HDirect.allocOutPointer (Prelude.toInt HDirect.sizeofInt32)
    o_next1 <- primnext1 celt rgelt pceltFetched
    Com.okHRESULT o_next1
    rgelt <- HDirect.doThenFree HDirect.trivialFree (HDirect.unmarshallref Com.readiptr) rgelt
    pceltFetched <- HDirect.doThenFree HDirect.trivialFree (HDirect.unmarshallref HDirect.readInt32) pceltFetched
    Prelude.return (rgelt, pceltFetched)
clone1 :: Prelude.IO (IEnumVMenuSet Automation.Interface)
clone1 =
  do
    ppenm <- HDirect.allocOutPointer (Prelude.toInt HDirect.sizeofAddr)
    o_clone1 <- primclone1 ppenm
    Com.okHRESULT o_clone1
    ppenm <- HDirect.doThenFree HDirect.trivialFree (HDirect.unmarshallref Com.readiptr) ppenm
    Prelude.return (ppenm)
-}
-- --------------------------------------------------
-- 
-- interface IVMenuSets
-- 
-- --------------------------------------------------
data VMenuSets a = VMenuSets
                    
type IVMenuSets a = Automation.IDispatch (VMenuSets a)
iidIVMenuSets :: Com.IID (IVMenuSets Automation.Interface)
iidIVMenuSets = Com.mkIID "{000D0236-0000-0000-C000-000000000046}"
getItem14 :: Prelude.Int -> IVMenuSets a -> Prelude.IO (IVMenuSet Automation.Interface)
getItem14 lIndex =
  Automation.propertyGetID 0o0 [Automation.inInt lIndex] Automation.outIDispatch
getItemAtID :: Prelude.Int -> IVMenuSets a -> Prelude.IO (IVMenuSet Automation.Interface)
getItemAtID lID =
  Automation.propertyGetID 0x60020002 [Automation.inInt lID] Automation.outIDispatch
add9 :: IVMenuSets a -> Prelude.IO (IVMenuSet Automation.Interface)
add9 = Automation.functionID1 0x60020003 [] Automation.outIDispatch
addAtID :: Prelude.Int -> IVMenuSets a -> Prelude.IO (IVMenuSet Automation.Interface)
addAtID lID =
  Automation.functionID1 0x60020004 [Automation.inInt lID] Automation.outIDispatch
getParent5 :: Automation.IDispatch a -> Prelude.IO (IVUIObject Automation.Interface)
getParent5 =
  Automation.propertyGetID 0x60020006 [] Automation.outIDispatch
-- --------------------------------------------------
-- 
-- interface IVToolbarItem
-- 
-- --------------------------------------------------
data VToolbarItem a = VToolbarItem
                       
type IVToolbarItem a = Automation.IDispatch (VToolbarItem a)
iidIVToolbarItem :: Com.IID (IVToolbarItem Automation.Interface)
iidIVToolbarItem =
  Com.mkIID "{000D0242-0000-0000-C000-000000000046}"
iconFileName :: Prelude.String -> Automation.IDispatch a -> Prelude.IO ()
iconFileName iconFileName =
  Automation.methodID0 0x60020001 [Automation.inString iconFileName]
getParent6 :: IVToolbarItem a -> Prelude.IO (IVToolbarItems Automation.Interface)
getParent6 =
  Automation.propertyGetID 0x60020004 [] Automation.outIDispatch
setCntrlType :: Prelude.Int -> Automation.IDispatch a -> Prelude.IO ()
setCntrlType pwCntrlType =
  Automation.propertySetID 0x60020011 [Automation.inInt pwCntrlType]
getCntrlType :: Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getCntrlType =
  Automation.propertyGetID 0x60020011 [] Automation.outInt
setCntrlID :: Prelude.Int -> Automation.IDispatch a -> Prelude.IO ()
setCntrlID pwCntrlID =
  Automation.propertySetID 0x60020013 [Automation.inInt pwCntrlID]
getCntrlID :: Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getCntrlID =
  Automation.propertyGetID 0x60020013 [] Automation.outInt
setTypeSpecific1 :: Prelude.Int -> Automation.IDispatch a -> Prelude.IO ()
setTypeSpecific1 pwTypeSpecific =
  Automation.propertySetID 0x60020015 [Automation.inInt pwTypeSpecific]
getTypeSpecific1 :: Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getTypeSpecific1 =
  Automation.propertyGetID 0x60020015 [] Automation.outInt
setPriority :: Prelude.Int -> Automation.IDispatch a -> Prelude.IO ()
setPriority pwPriority =
  Automation.propertySetID 0x60020017 [Automation.inInt pwPriority]
getPriority :: Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getPriority =
  Automation.propertyGetID 0x60020017 [] Automation.outInt
setSpacing :: Prelude.Int -> Automation.IDispatch a -> Prelude.IO ()
setSpacing pwSpacing =
  Automation.propertySetID 0x60020019 [Automation.inInt pwSpacing]
getSpacing :: Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getSpacing =
  Automation.propertyGetID 0x60020019 [] Automation.outInt
setTypeSpecific2 :: Prelude.Int -> Automation.IDispatch a -> Prelude.IO ()
setTypeSpecific2 pwTypeSpecific =
  Automation.propertySetID 0x6002001b [Automation.inInt pwTypeSpecific]
getTypeSpecific2 :: Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getTypeSpecific2 =
  Automation.propertyGetID 0x6002001b [] Automation.outInt
-- --------------------------------------------------
-- 
-- interface IEnumVToolbarItem
-- 
-- --------------------------------------------------
{-
next2 :: HDirect.Int32 -> Prelude.IO (IVToolbarItem Automation.Interface, HDirect.Int32)
next2 celt =
  do
    rgelt <- HDirect.allocOutPointer (Prelude.toInt HDirect.sizeofAddr)
    pceltFetched <- HDirect.allocOutPointer (Prelude.toInt HDirect.sizeofInt32)
    o_next2 <- primnext2 celt rgelt pceltFetched
    Com.okHRESULT o_next2
    rgelt <- HDirect.doThenFree HDirect.trivialFree (HDirect.unmarshallref Com.readiptr) rgelt
    pceltFetched <- HDirect.doThenFree HDirect.trivialFree (HDirect.unmarshallref HDirect.readInt32) pceltFetched
    Prelude.return (rgelt, pceltFetched)
clone2 :: Prelude.IO (IEnumVToolbarItem Automation.Interface)
clone2 =
  do
    ppenm <- HDirect.allocOutPointer (Prelude.toInt HDirect.sizeofAddr)
    o_clone2 <- primclone2 ppenm
    Com.okHRESULT o_clone2
    ppenm <- HDirect.doThenFree HDirect.trivialFree (HDirect.unmarshallref Com.readiptr) ppenm
    Prelude.return (ppenm)
-}
-- --------------------------------------------------
-- 
-- interface IVToolbarItems
-- 
-- --------------------------------------------------
data VToolbarItems a = VToolbarItems
                        
type IVToolbarItems a = Automation.IDispatch (VToolbarItems a)
iidIVToolbarItems :: Com.IID (IVToolbarItems Automation.Interface)
iidIVToolbarItems =
  Com.mkIID "{000D0245-0000-0000-C000-000000000046}"
getItem15 :: Prelude.Int -> IVToolbarItems a -> Prelude.IO (IVToolbarItem Automation.Interface)
getItem15 lIndex =
  Automation.propertyGetID 0o0 [Automation.inInt lIndex] Automation.outIDispatch
add10 :: IVToolbarItems a -> Prelude.IO (IVToolbarItem Automation.Interface)
add10 =
  Automation.functionID1 0x60020002 [] Automation.outIDispatch
addAt1 :: Prelude.Int -> IVToolbarItems a -> Prelude.IO (IVToolbarItem Automation.Interface)
addAt1 lIndex =
  Automation.functionID1 0x60020003 [Automation.inInt lIndex] Automation.outIDispatch
getParent7 :: IVToolbarItems a -> Prelude.IO (IVToolbar Automation.Interface)
getParent7 =
  Automation.propertyGetID 0x60020005 [] Automation.outIDispatch
-- --------------------------------------------------
-- 
-- interface IVToolbar
-- 
-- --------------------------------------------------
data VToolbar a = VToolbar
                   
type IVToolbar a = Automation.IDispatch (VToolbar a)
iidIVToolbar :: Com.IID (IVToolbar Automation.Interface)
iidIVToolbar = Com.mkIID "{000D0252-0000-0000-C000-000000000046}"
getToolbarItems :: IVToolbar a -> Prelude.IO (IVToolbarItems Automation.Interface)
getToolbarItems =
  Automation.propertyGetID 0x60020005 [] Automation.outIDispatch
getParent8 :: IVToolbar a -> Prelude.IO (IVToolbars Automation.Interface)
getParent8 =
  Automation.propertyGetID 0x60020006 [] Automation.outIDispatch
-- --------------------------------------------------
-- 
-- interface IEnumVToolbar
-- 
-- --------------------------------------------------
{-
next3 :: HDirect.Int32 -> Prelude.IO (IVToolbar Automation.Interface, HDirect.Int32)
next3 celt =
  do
    rgelt <- HDirect.allocOutPointer (Prelude.toInt HDirect.sizeofAddr)
    pceltFetched <- HDirect.allocOutPointer (Prelude.toInt HDirect.sizeofInt32)
    o_next3 <- primnext3 celt rgelt pceltFetched
    Com.okHRESULT o_next3
    rgelt <- HDirect.doThenFree HDirect.trivialFree (HDirect.unmarshallref Com.readiptr) rgelt
    pceltFetched <- HDirect.doThenFree HDirect.trivialFree (HDirect.unmarshallref HDirect.readInt32) pceltFetched
    Prelude.return (rgelt, pceltFetched)
clone3 :: Prelude.IO (IEnumVToolbar Automation.Interface)
clone3 =
  do
    ppenm <- HDirect.allocOutPointer (Prelude.toInt HDirect.sizeofAddr)
    o_clone3 <- primclone3 ppenm
    Com.okHRESULT o_clone3
    ppenm <- HDirect.doThenFree HDirect.trivialFree (HDirect.unmarshallref Com.readiptr) ppenm
    Prelude.return (ppenm)
-}
-- --------------------------------------------------
-- 
-- interface IVToolbars
-- 
-- --------------------------------------------------
data VToolbars a = VToolbars
                    
type IVToolbars a = Automation.IDispatch (VToolbars a)
iidIVToolbars :: Com.IID (IVToolbars Automation.Interface)
iidIVToolbars = Com.mkIID "{000D0255-0000-0000-C000-000000000046}"
getItem16 :: Prelude.Int -> IVToolbars a -> Prelude.IO (IVToolbar Automation.Interface)
getItem16 lIndex =
  Automation.propertyGetID 0o0 [Automation.inInt lIndex] Automation.outIDispatch
add11 :: IVToolbars a -> Prelude.IO (IVToolbar Automation.Interface)
add11 =
  Automation.functionID1 0x60020002 [] Automation.outIDispatch
addAt2 :: Prelude.Int -> IVToolbars a -> Prelude.IO (IVToolbar Automation.Interface)
addAt2 lIndex =
  Automation.functionID1 0x60020003 [Automation.inInt lIndex] Automation.outIDispatch
getParent9 :: IVToolbars a -> Prelude.IO (IVToolbarSet Automation.Interface)
getParent9 =
  Automation.propertyGetID 0x60020005 [] Automation.outIDispatch
-- --------------------------------------------------
-- 
-- interface IVToolbarSet
-- 
-- --------------------------------------------------
data VToolbarSet a = VToolbarSet
                      
type IVToolbarSet a = Automation.IDispatch (VToolbarSet a)
iidIVToolbarSet :: Com.IID (IVToolbarSet Automation.Interface)
iidIVToolbarSet =
  Com.mkIID "{000D0262-0000-0000-C000-000000000046}"
getToolbars :: IVToolbarSet a -> Prelude.IO (IVToolbars Automation.Interface)
getToolbars =
  Automation.propertyGetID 0x60020005 [] Automation.outIDispatch
getParent10 :: IVToolbarSet a -> Prelude.IO (IVToolbarSets Automation.Interface)
getParent10 =
  Automation.propertyGetID 0x60020006 [] Automation.outIDispatch
-- --------------------------------------------------
-- 
-- interface IEnumVToolbarSet
-- 
-- --------------------------------------------------
{-
next4 :: HDirect.Int32 -> Prelude.IO (IVToolbarSet Automation.Interface, HDirect.Int32)
next4 celt =
  do
    rgelt <- HDirect.allocOutPointer (Prelude.toInt HDirect.sizeofAddr)
    pceltFetched <- HDirect.allocOutPointer (Prelude.toInt HDirect.sizeofInt32)
    o_next4 <- primnext4 celt rgelt pceltFetched
    Com.okHRESULT o_next4
    rgelt <- HDirect.doThenFree HDirect.trivialFree (HDirect.unmarshallref Com.readiptr) rgelt
    pceltFetched <- HDirect.doThenFree HDirect.trivialFree (HDirect.unmarshallref HDirect.readInt32) pceltFetched
    Prelude.return (rgelt, pceltFetched)
clone4 :: Prelude.IO (IEnumVToolbarSet Automation.Interface)
clone4 =
  do
    ppenm <- HDirect.allocOutPointer (Prelude.toInt HDirect.sizeofAddr)
    o_clone4 <- primclone4 ppenm
    Com.okHRESULT o_clone4
    ppenm <- HDirect.doThenFree HDirect.trivialFree (HDirect.unmarshallref Com.readiptr) ppenm
    Prelude.return (ppenm)
-}
-- --------------------------------------------------
-- 
-- interface IVToolbarSets
-- 
-- --------------------------------------------------
data VToolbarSets a = VToolbarSets
                       
type IVToolbarSets a = Automation.IDispatch (VToolbarSets a)
iidIVToolbarSets :: Com.IID (IVToolbarSets Automation.Interface)
iidIVToolbarSets =
  Com.mkIID "{000D0266-0000-0000-C000-000000000046}"
getItem17 :: Prelude.Int -> IVToolbarSets a -> Prelude.IO (IVToolbarSet Automation.Interface)
getItem17 lIndex =
  Automation.propertyGetID 0o0 [Automation.inInt lIndex] Automation.outIDispatch
getItemAtID0 :: Prelude.Int -> IVToolbarSets a -> Prelude.IO (IVToolbarSet Automation.Interface)
getItemAtID0 lID =
  Automation.propertyGetID 0x60020002 [Automation.inInt lID] Automation.outIDispatch
add12 :: IVToolbarSets a -> Prelude.IO (IVToolbarSet Automation.Interface)
add12 =
  Automation.functionID1 0x60020003 [] Automation.outIDispatch
addAtID0 :: Prelude.Int -> IVToolbarSets a -> Prelude.IO (IVToolbarSet Automation.Interface)
addAtID0 lID =
  Automation.functionID1 0x60020004 [Automation.inInt lID] Automation.outIDispatch
-- --------------------------------------------------
-- 
-- interface IVStatusBarItem
-- 
-- --------------------------------------------------
data VStatusBarItem a = VStatusBarItem
                         
type IVStatusBarItem a = Automation.IDispatch (VStatusBarItem a)
iidIVStatusBarItem :: Com.IID (IVStatusBarItem Automation.Interface)
iidIVStatusBarItem =
  Com.mkIID "{000D0272-0000-0000-C000-000000000046}"
getParent12 :: IVStatusBarItem a -> Prelude.IO (IVStatusBarItems Automation.Interface)
getParent12 =
  Automation.propertyGetID 0x60020004 [] Automation.outIDispatch
-- --------------------------------------------------
-- 
-- interface IEnumVStatusBarItem
-- 
-- --------------------------------------------------
{-
next5 :: HDirect.Int32 -> Prelude.IO (IVStatusBarItem Automation.Interface, HDirect.Int32)
next5 celt =
  do
    rgelt <- HDirect.allocOutPointer (Prelude.toInt HDirect.sizeofAddr)
    pceltFetched <- HDirect.allocOutPointer (Prelude.toInt HDirect.sizeofInt32)
    o_next5 <- primnext5 celt rgelt pceltFetched
    Com.okHRESULT o_next5
    rgelt <- HDirect.doThenFree HDirect.trivialFree (HDirect.unmarshallref Com.readiptr) rgelt
    pceltFetched <- HDirect.doThenFree HDirect.trivialFree (HDirect.unmarshallref HDirect.readInt32) pceltFetched
    Prelude.return (rgelt, pceltFetched)
clone5 :: Prelude.IO (IEnumVStatusBarItem Automation.Interface)
clone5 =
  do
    ppenm <- HDirect.allocOutPointer (Prelude.toInt HDirect.sizeofAddr)
    o_clone5 <- primclone5 ppenm
    Com.okHRESULT o_clone5
    ppenm <- HDirect.doThenFree HDirect.trivialFree (HDirect.unmarshallref Com.readiptr) ppenm
    Prelude.return (ppenm)
-}
-- --------------------------------------------------
-- 
-- interface IVStatusBarItems
-- 
-- --------------------------------------------------
data VStatusBarItems a = VStatusBarItems
                          
type IVStatusBarItems a = Automation.IDispatch (VStatusBarItems a)
iidIVStatusBarItems :: Com.IID (IVStatusBarItems Automation.Interface)
iidIVStatusBarItems =
  Com.mkIID "{000D0275-0000-0000-C000-000000000046}"
getItem18 :: Prelude.Int -> IVStatusBarItems a -> Prelude.IO (IVStatusBarItem Automation.Interface)
getItem18 lIndex =
  Automation.propertyGetID 0o0 [Automation.inInt lIndex] Automation.outIDispatch
add13 :: IVStatusBarItems a -> Prelude.IO (IVStatusBarItem Automation.Interface)
add13 =
  Automation.functionID1 0x60020002 [] Automation.outIDispatch
addAt3 :: Prelude.Int -> IVStatusBarItems a -> Prelude.IO (IVStatusBarItem Automation.Interface)
addAt3 lIndex =
  Automation.functionID1 0x60020003 [Automation.inInt lIndex] Automation.outIDispatch
getParent13 :: IVStatusBarItems a -> Prelude.IO (IVStatusBar Automation.Interface)
getParent13 =
  Automation.propertyGetID 0x60020005 [] Automation.outIDispatch
-- --------------------------------------------------
-- 
-- interface IVStatusBar
-- 
-- --------------------------------------------------
data VStatusBar a = VStatusBar
                     
type IVStatusBar a = Automation.IDispatch (VStatusBar a)
iidIVStatusBar :: Com.IID (IVStatusBar Automation.Interface)
iidIVStatusBar = Com.mkIID "{000D0282-0000-0000-C000-000000000046}"
getStatusBarItems :: IVStatusBar a -> Prelude.IO (IVStatusBarItems Automation.Interface)
getStatusBarItems =
  Automation.propertyGetID 0x60020005 [] Automation.outIDispatch
getParent14 :: IVStatusBar a -> Prelude.IO (IVStatusBars Automation.Interface)
getParent14 =
  Automation.propertyGetID 0x60020006 [] Automation.outIDispatch
-- --------------------------------------------------
-- 
-- interface IEnumVStatusBar
-- 
-- --------------------------------------------------
{-
next6 :: HDirect.Int32 -> Prelude.IO (IVStatusBar Automation.Interface, HDirect.Int32)
next6 celt =
  do
    rgelt <- HDirect.allocOutPointer (Prelude.toInt HDirect.sizeofAddr)
    pceltFetched <- HDirect.allocOutPointer (Prelude.toInt HDirect.sizeofInt32)
    o_next6 <- primnext6 celt rgelt pceltFetched
    Com.okHRESULT o_next6
    rgelt <- HDirect.doThenFree HDirect.trivialFree (HDirect.unmarshallref Com.readiptr) rgelt
    pceltFetched <- HDirect.doThenFree HDirect.trivialFree (HDirect.unmarshallref HDirect.readInt32) pceltFetched
    Prelude.return (rgelt, pceltFetched)
clone6 :: Prelude.IO (IEnumVStatusBar Automation.Interface)
clone6 =
  do
    ppenm <- HDirect.allocOutPointer (Prelude.toInt HDirect.sizeofAddr)
    o_clone6 <- primclone6 ppenm
    Com.okHRESULT o_clone6
    ppenm <- HDirect.doThenFree HDirect.trivialFree (HDirect.unmarshallref Com.readiptr) ppenm
    Prelude.return (ppenm)
-}
-- --------------------------------------------------
-- 
-- interface IVStatusBars
-- 
-- --------------------------------------------------
data VStatusBars a = VStatusBars
                      
type IVStatusBars a = Automation.IDispatch (VStatusBars a)
iidIVStatusBars :: Com.IID (IVStatusBars Automation.Interface)
iidIVStatusBars =
  Com.mkIID "{000D0285-0000-0000-C000-000000000046}"
getItem19 :: Prelude.Int -> IVStatusBars a -> Prelude.IO (IVStatusBar Automation.Interface)
getItem19 lIndex =
  Automation.propertyGetID 0o0 [Automation.inInt lIndex] Automation.outIDispatch
getItemAtID1 :: Prelude.Int -> IVStatusBars a -> Prelude.IO (IVStatusBar Automation.Interface)
getItemAtID1 lID =
  Automation.propertyGetID 0x60020002 [Automation.inInt lID] Automation.outIDispatch
add14 :: IVStatusBars a -> Prelude.IO (IVStatusBar Automation.Interface)
add14 =
  Automation.functionID1 0x60020003 [] Automation.outIDispatch
addAtID1 :: Prelude.Int -> IVStatusBars a -> Prelude.IO (IVStatusBar Automation.Interface)
addAtID1 lID =
  Automation.functionID1 0x60020004 [Automation.inInt lID] Automation.outIDispatch
-- --------------------------------------------------
-- 
-- interface IVAccelItem
-- 
-- --------------------------------------------------
data VAccelItem a = VAccelItem
                     
type IVAccelItem a = Automation.IDispatch (VAccelItem a)
iidIVAccelItem :: Com.IID (IVAccelItem Automation.Interface)
iidIVAccelItem = Com.mkIID "{000D0292-0000-0000-C000-000000000046}"
getDefault7 :: IVAccelItem a -> Prelude.IO (Prelude.Int)
getDefault7 =
  Automation.propertyGetID 0x60020001 [] Automation.outInt
setKey :: Prelude.Int -> IVAccelItem a -> Prelude.IO ()
setKey pKey =
  Automation.propertySetID 0x60020004 [Automation.inInt pKey]
getKey :: IVAccelItem a -> Prelude.IO (Prelude.Int)
getKey = Automation.propertyGetID 0x60020004 [] Automation.outInt
setAlt :: Prelude.Int -> IVAccelItem a -> Prelude.IO ()
setAlt pAlt =
  Automation.propertySetID 0x60020006 [Automation.inInt pAlt]
getAlt :: IVAccelItem a -> Prelude.IO (Prelude.Int)
getAlt = Automation.propertyGetID 0x60020006 [] Automation.outInt
setShift :: Prelude.Int -> IVAccelItem a -> Prelude.IO ()
setShift pShift =
  Automation.propertySetID 0x60020008 [Automation.inInt pShift]
getShift :: IVAccelItem a -> Prelude.IO (Prelude.Int)
getShift = Automation.propertyGetID 0x60020008 [] Automation.outInt
setControl :: Prelude.Int -> IVAccelItem a -> Prelude.IO ()
setControl pControl =
  Automation.propertySetID 0x6002000a [Automation.inInt pControl]
getControl :: IVAccelItem a -> Prelude.IO (Prelude.Int)
getControl =
  Automation.propertyGetID 0x6002000a [] Automation.outInt
getParent16 :: IVAccelItem a -> Prelude.IO (IVAccelItems Automation.Interface)
getParent16 =
  Automation.propertyGetID 0x6002000c [] Automation.outIDispatch
-- --------------------------------------------------
-- 
-- interface IEnumVAccelItem
-- 
-- --------------------------------------------------
{-
next7 :: HDirect.Int32 -> Prelude.IO (IVAccelItem Automation.Interface, HDirect.Int32)
next7 celt =
  do
    rgelt <- HDirect.allocOutPointer (Prelude.toInt HDirect.sizeofAddr)
    pceltFetched <- HDirect.allocOutPointer (Prelude.toInt HDirect.sizeofInt32)
    o_next7 <- primnext7 celt rgelt pceltFetched
    Com.okHRESULT o_next7
    rgelt <- HDirect.doThenFree HDirect.trivialFree (HDirect.unmarshallref Com.readiptr) rgelt
    pceltFetched <- HDirect.doThenFree HDirect.trivialFree (HDirect.unmarshallref HDirect.readInt32) pceltFetched
    Prelude.return (rgelt, pceltFetched)
clone7 :: Prelude.IO (IEnumVAccelItem Automation.Interface)
clone7 =
  do
    ppenm <- HDirect.allocOutPointer (Prelude.toInt HDirect.sizeofAddr)
    o_clone7 <- primclone7 ppenm
    Com.okHRESULT o_clone7
    ppenm <- HDirect.doThenFree HDirect.trivialFree (HDirect.unmarshallref Com.readiptr) ppenm
    Prelude.return (ppenm)
-}
-- --------------------------------------------------
-- 
-- interface IVAccelItems
-- 
-- --------------------------------------------------
data VAccelItems a = VAccelItems
                      
type IVAccelItems a = Automation.IDispatch (VAccelItems a)
iidIVAccelItems :: Com.IID (IVAccelItems Automation.Interface)
iidIVAccelItems =
  Com.mkIID "{000D0295-0000-0000-C000-000000000046}"
getItem20 :: Prelude.Int -> IVAccelItems a -> Prelude.IO (IVAccelItem Automation.Interface)
getItem20 lIndex =
  Automation.propertyGetID 0o0 [Automation.inInt lIndex] Automation.outIDispatch
add15 :: IVAccelItems a -> Prelude.IO (IVAccelItem Automation.Interface)
add15 =
  Automation.functionID1 0x60020002 [] Automation.outIDispatch
getParent17 :: IVAccelItems a -> Prelude.IO (IVAccelTable Automation.Interface)
getParent17 =
  Automation.propertyGetID 0x60020004 [] Automation.outIDispatch
-- --------------------------------------------------
-- 
-- interface IVAccelTable
-- 
-- --------------------------------------------------
data VAccelTable a = VAccelTable
                      
type IVAccelTable a = Automation.IDispatch (VAccelTable a)
iidIVAccelTable :: Com.IID (IVAccelTable Automation.Interface)
iidIVAccelTable =
  Com.mkIID "{000D02A2-0000-0000-C000-000000000046}"
setTableName :: Prelude.String -> IVAccelTable a -> Prelude.IO ()
setTableName pTableName =
  Automation.propertySetID 0o0 [Automation.inString pTableName]
getTableName :: IVAccelTable a -> Prelude.IO (Prelude.String)
getTableName = Automation.propertyGetID 0o0 [] Automation.outString
getAccelItems :: IVAccelTable a -> Prelude.IO (IVAccelItems Automation.Interface)
getAccelItems =
  Automation.propertyGetID 0x60020005 [] Automation.outIDispatch
getParent18 :: IVAccelTable a -> Prelude.IO (IVAccelTables Automation.Interface)
getParent18 =
  Automation.propertyGetID 0x60020006 [] Automation.outIDispatch
-- --------------------------------------------------
-- 
-- interface IEnumVAccelTable
-- 
-- --------------------------------------------------
{-
next8 :: HDirect.Int32 -> Prelude.IO (IVAccelTable Automation.Interface, HDirect.Int32)
next8 celt =
  do
    rgelt <- HDirect.allocOutPointer (Prelude.toInt HDirect.sizeofAddr)
    pceltFetched <- HDirect.allocOutPointer (Prelude.toInt HDirect.sizeofInt32)
    o_next8 <- primnext8 celt rgelt pceltFetched
    Com.okHRESULT o_next8
    rgelt <- HDirect.doThenFree HDirect.trivialFree (HDirect.unmarshallref Com.readiptr) rgelt
    pceltFetched <- HDirect.doThenFree HDirect.trivialFree (HDirect.unmarshallref HDirect.readInt32) pceltFetched
    Prelude.return (rgelt, pceltFetched)
clone8 :: Prelude.IO (IEnumVAccelTable Automation.Interface)
clone8 =
  do
    ppenm <- HDirect.allocOutPointer (Prelude.toInt HDirect.sizeofAddr)
    o_clone8 <- primclone8 ppenm
    Com.okHRESULT o_clone8
    ppenm <- HDirect.doThenFree HDirect.trivialFree (HDirect.unmarshallref Com.readiptr) ppenm
    Prelude.return (ppenm)
-}
-- --------------------------------------------------
-- 
-- interface IVAccelTables
-- 
-- --------------------------------------------------
data VAccelTables a = VAccelTables
                       
type IVAccelTables a = Automation.IDispatch (VAccelTables a)
iidIVAccelTables :: Com.IID (IVAccelTables Automation.Interface)
iidIVAccelTables =
  Com.mkIID "{000D02A5-0000-0000-C000-000000000046}"
getItem21 :: Prelude.Int -> IVAccelTables a -> Prelude.IO (IVAccelTable Automation.Interface)
getItem21 lIndex =
  Automation.propertyGetID 0o0 [Automation.inInt lIndex] Automation.outIDispatch
getItemAtID2 :: Prelude.Int -> IVAccelTables a -> Prelude.IO (IVAccelTable Automation.Interface)
getItemAtID2 lID =
  Automation.propertyGetID 0x60020002 [Automation.inInt lID] Automation.outIDispatch
add16 :: IVAccelTables a -> Prelude.IO (IVAccelTable Automation.Interface)
add16 =
  Automation.functionID1 0x60020003 [] Automation.outIDispatch
addAtID2 :: Prelude.Int -> IVAccelTables a -> Prelude.IO (IVAccelTable Automation.Interface)
addAtID2 lID =
  Automation.functionID1 0x60020004 [Automation.inInt lID] Automation.outIDispatch
-- --------------------------------------------------
-- 
-- interface IVUIObject
-- 
-- --------------------------------------------------
data VUIObject a = VUIObject
                    
type IVUIObject a = Automation.IDispatch (VUIObject a)
iidIVUIObject :: Com.IID (IVUIObject Automation.Interface)
iidIVUIObject = Com.mkIID "{000D0202-0000-0000-C000-000000000046}"
setFlavor :: Prelude.Int -> IVUIObject a -> Prelude.IO ()
setFlavor pFlavor =
  Automation.propertySetID 0x60020004 [Automation.inInt pFlavor]
getFlavor :: IVUIObject a -> Prelude.IO (Prelude.Int)
getFlavor =
  Automation.propertyGetID 0x60020004 [] Automation.outInt
getMenuSets :: IVUIObject a -> Prelude.IO (IVMenuSets Automation.Interface)
getMenuSets =
  Automation.propertyGetID 0x60020006 [] Automation.outIDispatch
getToolbarSets :: IVUIObject a -> Prelude.IO (IVToolbarSets Automation.Interface)
getToolbarSets =
  Automation.propertyGetID 0x60020007 [] Automation.outIDispatch
getStatusBars :: IVUIObject a -> Prelude.IO (IVStatusBars Automation.Interface)
getStatusBars =
  Automation.propertyGetID 0x60020008 [] Automation.outIDispatch
getAccelTables :: IVUIObject a -> Prelude.IO (IVAccelTables Automation.Interface)
getAccelTables =
  Automation.propertyGetID 0x60020009 [] Automation.outIDispatch
saveToFile :: Prelude.String -> IVUIObject a -> Prelude.IO ()
saveToFile fileName =
  Automation.methodID0 0x6002000a [Automation.inString fileName]
loadFromFile :: Prelude.String -> IVUIObject a -> Prelude.IO ()
loadFromFile fileName =
  Automation.methodID0 0x6002000b [Automation.inString fileName]
updateUI :: IVUIObject a -> Prelude.IO ()
updateUI = Automation.methodID0 0x6002000c []
-- --------------------------------------------------
-- 
-- coclass UIObject
-- 
-- --------------------------------------------------
clsidUIObject :: Com.CLSID
clsidUIObject =
  Com.mkCLSID "{000D0201-0000-0000-C000-000000000046}"
-- --------------------------------------------------
-- 
-- coclass MenuItem
-- 
-- --------------------------------------------------
clsidMenuItem :: Com.CLSID
clsidMenuItem =
  Com.mkCLSID "{000D0210-0000-0000-C000-000000000046}"
-- --------------------------------------------------
-- 
-- coclass MenuItems
-- 
-- --------------------------------------------------
clsidMenuItems :: Com.CLSID
clsidMenuItems =
  Com.mkCLSID "{000D0215-0000-0000-C000-000000000046}"
-- --------------------------------------------------
-- 
-- coclass Menu
-- 
-- --------------------------------------------------
clsidMenu :: Com.CLSID
clsidMenu = Com.mkCLSID "{000D0220-0000-0000-C000-000000000046}"
-- --------------------------------------------------
-- 
-- coclass Menus
-- 
-- --------------------------------------------------
clsidMenus :: Com.CLSID
clsidMenus = Com.mkCLSID "{000D0224-0000-0000-C000-000000000046}"
-- --------------------------------------------------
-- 
-- coclass MenuSet
-- 
-- --------------------------------------------------
clsidMenuSet :: Com.CLSID
clsidMenuSet = Com.mkCLSID "{000D0230-0000-0000-C000-000000000046}"
-- --------------------------------------------------
-- 
-- coclass MenuSets
-- 
-- --------------------------------------------------
clsidMenuSets :: Com.CLSID
clsidMenuSets =
  Com.mkCLSID "{000D0235-0000-0000-C000-000000000046}"
-- --------------------------------------------------
-- 
-- coclass ToolbarItem
-- 
-- --------------------------------------------------
clsidToolbarItem :: Com.CLSID
clsidToolbarItem =
  Com.mkCLSID "{000D0240-0000-0000-C000-000000000046}"
-- --------------------------------------------------
-- 
-- coclass ToolbarItems
-- 
-- --------------------------------------------------
clsidToolbarItems :: Com.CLSID
clsidToolbarItems =
  Com.mkCLSID "{000D0244-0000-0000-C000-000000000046}"
-- --------------------------------------------------
-- 
-- coclass Toolbar
-- 
-- --------------------------------------------------
clsidToolbar :: Com.CLSID
clsidToolbar = Com.mkCLSID "{000D0250-0000-0000-C000-000000000046}"
-- --------------------------------------------------
-- 
-- coclass Toolbars
-- 
-- --------------------------------------------------
clsidToolbars :: Com.CLSID
clsidToolbars =
  Com.mkCLSID "{000D0254-0000-0000-C000-000000000046}"
-- --------------------------------------------------
-- 
-- coclass ToolbarSet
-- 
-- --------------------------------------------------
clsidToolbarSet :: Com.CLSID
clsidToolbarSet =
  Com.mkCLSID "{000D0260-0000-0000-C000-000000000046}"
-- --------------------------------------------------
-- 
-- coclass ToolbarSets
-- 
-- --------------------------------------------------
clsidToolbarSets :: Com.CLSID
clsidToolbarSets =
  Com.mkCLSID "{000D0265-0000-0000-C000-000000000046}"
-- --------------------------------------------------
-- 
-- coclass StatusBarItem
-- 
-- --------------------------------------------------
clsidStatusBarItem :: Com.CLSID
clsidStatusBarItem =
  Com.mkCLSID "{000D0270-0000-0000-C000-000000000046}"
-- --------------------------------------------------
-- 
-- coclass StatusBarItems
-- 
-- --------------------------------------------------
clsidStatusBarItems :: Com.CLSID
clsidStatusBarItems =
  Com.mkCLSID "{000D0274-0000-0000-C000-000000000046}"
-- --------------------------------------------------
-- 
-- coclass StatusBar
-- 
-- --------------------------------------------------
clsidStatusBar :: Com.CLSID
clsidStatusBar =
  Com.mkCLSID "{000D0280-0000-0000-C000-000000000046}"
-- --------------------------------------------------
-- 
-- coclass StatusBars
-- 
-- --------------------------------------------------
clsidStatusBars :: Com.CLSID
clsidStatusBars =
  Com.mkCLSID "{000D0284-0000-0000-C000-000000000046}"
-- --------------------------------------------------
-- 
-- coclass AccelItem
-- 
-- --------------------------------------------------
clsidAccelItem :: Com.CLSID
clsidAccelItem =
  Com.mkCLSID "{000D0290-0000-0000-C000-000000000046}"
-- --------------------------------------------------
-- 
-- coclass AccelItems
-- 
-- --------------------------------------------------
clsidAccelItems :: Com.CLSID
clsidAccelItems =
  Com.mkCLSID "{000D0294-0000-0000-C000-000000000046}"
-- --------------------------------------------------
-- 
-- coclass AccelTable
-- 
-- --------------------------------------------------
clsidAccelTable :: Com.CLSID
clsidAccelTable =
  Com.mkCLSID "{000D02A0-0000-0000-C000-000000000046}"
-- --------------------------------------------------
-- 
-- coclass AccelTables
-- 
-- --------------------------------------------------
clsidAccelTables :: Com.CLSID
clsidAccelTables =
  Com.mkCLSID "{000D02A4-0000-0000-C000-000000000046}"
type LPVISIOHYPERLINK = IVHyperlink Automation.Interface
type LPVISIOOBJECTS = IVOLEObjects Automation.Interface
type LPVISIOOBJECT = IVOLEObject Automation.Interface
type LPVISIOPATHS = IVPaths Automation.Interface
type LPVISIOPATH  = IVPath  Automation.Interface
type LPVISIOCURVE = IVCurve Automation.Interface
data VisScrollbarStates
 = VisScrollBarNeither
 | VisScrollBarHoriz
 | VisScrollBarVert
 | VisScrollBarBoth
 
marshallVisScrollbarStates :: VisScrollbarStates -> Prelude.IO Int.Int16
marshallVisScrollbarStates v =
  case v of
     VisScrollBarNeither -> Prelude.return (0)
     VisScrollBarHoriz -> Prelude.return (1)
     VisScrollBarVert -> Prelude.return (4)
     VisScrollBarBoth -> Prelude.return (5)
unmarshallVisScrollbarStates :: Int.Int16 -> Prelude.IO VisScrollbarStates
unmarshallVisScrollbarStates v =
  case v of
     0 -> Prelude.return (VisScrollBarNeither)
     1 -> Prelude.return (VisScrollBarHoriz)
     4 -> Prelude.return (VisScrollBarVert)
     5 -> Prelude.return (VisScrollBarBoth)
     _ -> Prelude.fail (Prelude.userError "unmarshallVisScrollbarStates: illegal enum value ")
data VisDocModeArgs
 = VisDocModeRun
 | VisDocModeDesign
 
marshallVisDocModeArgs :: VisDocModeArgs -> Prelude.IO Int.Int16
marshallVisDocModeArgs v =
  case v of
     VisDocModeRun -> Prelude.return (0)
     VisDocModeDesign -> Prelude.return (1)
unmarshallVisDocModeArgs :: Int.Int16 -> Prelude.IO VisDocModeArgs
unmarshallVisDocModeArgs v =
  case v of
     0 -> Prelude.return (VisDocModeRun)
     1 -> Prelude.return (VisDocModeDesign)
     _ -> Prelude.fail (Prelude.userError "unmarshallVisDocModeArgs: illegal enum value ")
data VisTraceFlags
 = VisTraceEvents
 | VisTraceAdvises
 | VisTraceAddonInvokes
 | VisTraceCallsToVBA
 
marshallVisTraceFlags :: VisTraceFlags -> Prelude.IO Int.Int16
marshallVisTraceFlags v =
  case v of
     VisTraceEvents -> Prelude.return (1)
     VisTraceAdvises -> Prelude.return (2)
     VisTraceAddonInvokes -> Prelude.return (4)
     VisTraceCallsToVBA -> Prelude.return (8)
unmarshallVisTraceFlags :: Int.Int16 -> Prelude.IO VisTraceFlags
unmarshallVisTraceFlags v =
  case v of
     1 -> Prelude.return (VisTraceEvents)
     2 -> Prelude.return (VisTraceAdvises)
     4 -> Prelude.return (VisTraceAddonInvokes)
     8 -> Prelude.return (VisTraceCallsToVBA)
     _ -> Prelude.fail (Prelude.userError "unmarshallVisTraceFlags: illegal enum value ")
-- --------------------------------------------------
-- 
-- interface IVHyperlink
-- 
-- --------------------------------------------------
data VHyperlink a = VHyperlink
                     
type IVHyperlink a = Automation.IDispatch (VHyperlink a)
iidIVHyperlink :: Com.IID (IVHyperlink Automation.Interface)
iidIVHyperlink = Com.mkIID "{000D071D-0000-0000-C000-000000000046}"
getAddress :: IVHyperlink a -> Prelude.IO (Prelude.String)
getAddress = Automation.propertyGetID 0x5 [] Automation.outString
setAddress :: Prelude.String -> IVHyperlink a -> Prelude.IO ()
setAddress lpbstrRet =
  Automation.propertySetID 0x5 [Automation.inString lpbstrRet]
getSubAddress :: IVHyperlink a -> Prelude.IO (Prelude.String)
getSubAddress =
  Automation.propertyGetID 0x6 [] Automation.outString
setSubAddress :: Prelude.String -> IVHyperlink a -> Prelude.IO ()
setSubAddress lpbstrRet =
  Automation.propertySetID 0x6 [Automation.inString lpbstrRet]
getNewWindow :: IVHyperlink a -> Prelude.IO (Prelude.Int)
getNewWindow = Automation.propertyGetID 0x7 [] Automation.outInt
setNewWindow :: Prelude.Int -> IVHyperlink a -> Prelude.IO ()
setNewWindow lpi2Ret =
  Automation.propertySetID 0x7 [Automation.inInt lpi2Ret]
getExtraInfo :: IVHyperlink a -> Prelude.IO (Prelude.String)
getExtraInfo = Automation.propertyGetID 0x8 [] Automation.outString
setExtraInfo :: Prelude.String -> IVHyperlink a -> Prelude.IO ()
setExtraInfo lpbstrRet =
  Automation.propertySetID 0x8 [Automation.inString lpbstrRet]
getFrame :: IVHyperlink a -> Prelude.IO (Prelude.String)
getFrame = Automation.propertyGetID 0x9 [] Automation.outString
setFrame :: Prelude.String -> IVHyperlink a -> Prelude.IO ()
setFrame lpbstrRet =
  Automation.propertySetID 0x9 [Automation.inString lpbstrRet]
addToFavorites :: Prelude.Int -> IVHyperlink a -> Prelude.IO ()
addToFavorites favoritesTitle =
  Automation.methodID0 0xa [Automation.inInt favoritesTitle]
follow :: IVHyperlink a -> Prelude.IO ()
follow = Automation.methodID0 0xb []
createURL :: Prelude.Int -> IVHyperlink a -> Prelude.IO (Prelude.String)
createURL canonicalForm =
  Automation.functionID1 0xe [Automation.inInt canonicalForm] Automation.outString
-- --------------------------------------------------
-- 
-- interface IVOLEObjects
-- 
-- --------------------------------------------------
data VOLEObjects a = VOLEObjects
                      
type IVOLEObjects a = Automation.IDispatch (VOLEObjects a)
iidIVOLEObjects :: Com.IID (IVOLEObjects Automation.Interface)
iidIVOLEObjects =
  Com.mkIID "{000D071E-0000-0000-C000-000000000046}"
getItem22 :: Prelude.Int -> IVOLEObjects a -> Prelude.IO (IVOLEObject Automation.Interface)
getItem22 nameOrIndex =
  Automation.propertyGetID 0o0 [Automation.inInt nameOrIndex] Automation.outIDispatch
-- --------------------------------------------------
-- 
-- interface IVOLEObject
-- 
-- --------------------------------------------------
data VOLEObject a = VOLEObject
                     
type IVOLEObject a = Automation.IDispatch (VOLEObject a)
iidIVOLEObject :: Com.IID (IVOLEObject Automation.Interface)
iidIVOLEObject = Com.mkIID "{000D071F-0000-0000-C000-000000000046}"
-- --------------------------------------------------
-- 
-- interface IVPaths
-- 
-- --------------------------------------------------
data VPaths a = VPaths
                 
type IVPaths a = Automation.IDispatch (VPaths a)
iidIVPaths :: Com.IID (IVPaths Automation.Interface)
iidIVPaths = Com.mkIID "{000D0720-0000-0000-C000-000000000046}"
getItem23 :: Prelude.Int -> IVPaths a -> Prelude.IO (IVPath Automation.Interface)
getItem23 index =
  Automation.propertyGetID 0o0 [Automation.inInt index] Automation.outIDispatch
-- --------------------------------------------------
-- 
-- interface IVPath
-- 
-- --------------------------------------------------
data VPath a = VPath
                
type IVPath a = Automation.IDispatch (VPath a)
iidIVPath :: Com.IID (IVPath Automation.Interface)
iidIVPath = Com.mkIID "{000D0721-0000-0000-C000-000000000046}"
getItem24 :: Prelude.Int -> IVPath a -> Prelude.IO (IVCurve Automation.Interface)
getItem24 index =
  Automation.propertyGetID 0o0 [Automation.inInt index] Automation.outIDispatch
getClosed :: Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getClosed = Automation.propertyGetID 0x4 [] Automation.outInt
--points :: Prelude.Double -> Automation.IDispatch a -> Prelude.IO (Array.Array Prelude.Int z)
--points tolerance =
--  Automation.methodID1 0x5 [Automation.inDouble tolerance] Automation.outArray
-- --------------------------------------------------
-- 
-- interface IVCurve
-- 
-- --------------------------------------------------
data VCurve a = VCurve
                 
type IVCurve a = Automation.IDispatch (VCurve a)
iidIVCurve :: Com.IID (IVCurve Automation.Interface)
iidIVCurve = Com.mkIID "{000D0722-0000-0000-C000-000000000046}"
getStart :: IVCurve a -> Prelude.IO (Prelude.Double)
getStart = Automation.propertyGetID 0x5 [] Automation.outDouble
getEnd0 :: IVCurve a -> Prelude.IO (Prelude.Double)
getEnd0 = Automation.propertyGetID 0x6 [] Automation.outDouble
point :: Prelude.Double -> IVCurve a -> Prelude.IO (Prelude.Double, Prelude.Double)
point t =
  Automation.methodID2 0o0 [Automation.inDouble t] Automation.outDouble Automation.outDouble
pointAndDerivatives :: Prelude.Double -> Prelude.Int -> IVCurve a -> Prelude.IO (Prelude.Double, Prelude.Double, Prelude.Double, Prelude.Double, Prelude.Double, Prelude.Double)
pointAndDerivatives t n =
  Automation.methodID6 0x8 [Automation.inDouble t, Automation.inInt n] Automation.outDouble Automation.outDouble Automation.outDouble Automation.outDouble Automation.outDouble Automation.outDouble
-- --------------------------------------------------
-- 
-- interface IVExtender
-- 
-- --------------------------------------------------
data VExtender a = VExtender
                    
type IVExtender a = Automation.IDispatch (VExtender a)
iidIVExtender :: Com.IID (IVExtender Automation.Interface)
iidIVExtender = Com.mkIID "{000D0D0E-0000-0000-C000-000000000046}"
getObject1 :: IVExtender a -> Prelude.IO (Com.IUnknown Automation.Interface)
getObject1 =
  Automation.propertyGetID 0xfffffcde [] Automation.outIUnknown
getParent20 :: IVExtender a -> Prelude.IO (Com.IUnknown Automation.Interface)
getParent20 =
  Automation.propertyGetID 0x80010008 [] Automation.outIUnknown
index :: Automation.IDispatch a -> Prelude.IO ()
index = Automation.methodID0 0xfffffcdc []
getShapeParent :: IVExtender a -> Prelude.IO (Automation.IDispatch Automation.Interface)
getShapeParent =
  Automation.propertyGetID 0x80010138 [] Automation.outIDispatch
shapeCopy :: IVExtender a -> Prelude.IO ()
shapeCopy = Automation.methodID0 0x80010109 []
shapeCut :: IVExtender a -> Prelude.IO ()
shapeCut = Automation.methodID0 0x8001010a []
shapeDelete :: IVExtender a -> Prelude.IO ()
shapeDelete = Automation.methodID0 0x8001010b []
shapeDuplicate :: IVExtender a -> Prelude.IO ()
shapeDuplicate = Automation.methodID0 0x8001010c []
getShapeIndex :: IVExtender a -> Prelude.IO (Prelude.Int)
getShapeIndex =
  Automation.propertyGetID 0x80010123 [] Automation.outInt
getShapeObject :: IVExtender a -> Prelude.IO (Automation.IDispatch Automation.Interface)
getShapeObject =
  Automation.propertyGetID 0x80010158 [] Automation.outIDispatch
getShapeID :: IVExtender a -> Prelude.IO (Prelude.Int)
getShapeID =
  Automation.propertyGetID 0x8001015b [] Automation.outInt
-- --------------------------------------------------
-- 
-- dispinterface IVDispExtender
-- 
-- --------------------------------------------------
data VDispExtender a = VDispExtender
                        
type IVDispExtender a = Automation.IDispatch (VDispExtender a)
iidIVDispExtender :: Com.IID (IVDispExtender Automation.Interface)
iidIVDispExtender =
  Com.mkIID "{000D0D0F-0000-0000-C000-000000000046}"
getName10 :: IVDispExtender a -> Prelude.IO (Prelude.String)
getName10 =
  Automation.propertyGetID 0x80010000 [] Automation.outString
setName6 :: Prelude.String -> IVDispExtender a -> Prelude.IO ()
setName6 rhs =
  Automation.propertySetID 0x80010000 [Automation.inString rhs]
getObject2 :: IVDispExtender a -> Prelude.IO (Com.IUnknown Automation.Interface)
getObject2 =
  Automation.propertyGetID 0xfffffcde [] Automation.outIUnknown
getParent21 :: IVDispExtender a -> Prelude.IO (Com.IUnknown Automation.Interface)
getParent21 =
  Automation.propertyGetID 0x80010008 [] Automation.outIUnknown
delete20 :: IVDispExtender a -> Prelude.IO ()
delete20 = Automation.methodID0 0xfffffcdf []
index0 :: IVDispExtender a -> Prelude.IO ()
index0 = Automation.methodID0 0xfffffcdc []
getShape4 :: IVDispExtender a -> Prelude.IO (IVShape Automation.Interface)
getShape4 =
  Automation.propertyGetID 0x80010100 [] Automation.outIDispatch
group3 :: IVDispExtender a -> Prelude.IO ()
group3 = Automation.methodID0 0x8001012d []
bringForward2 :: IVDispExtender a -> Prelude.IO ()
bringForward2 = Automation.methodID0 0x8001012e []
bringToFront2 :: IVDispExtender a -> Prelude.IO ()
bringToFront2 = Automation.methodID0 0x8001012f []
convertToGroup2 :: IVDispExtender a -> Prelude.IO ()
convertToGroup2 = Automation.methodID0 0x80010130 []
sendBackward2 :: IVDispExtender a -> Prelude.IO ()
sendBackward2 = Automation.methodID0 0x80010134 []
sendToBack2 :: IVDispExtender a -> Prelude.IO ()
sendToBack2 = Automation.methodID0 0x80010135 []
getDocument20 :: IVDispExtender a -> Prelude.IO (IVDocument Automation.Interface)
getDocument20 =
  Automation.propertyGetID 0x8001012c [] Automation.outIDispatch
getShapeParent0 :: IVDispExtender a -> Prelude.IO (Automation.IDispatch Automation.Interface)
getShapeParent0 =
  Automation.propertyGetID 0x80010138 [] Automation.outIDispatch
getApplication35 :: IVDispExtender a -> Prelude.IO (IVApplication Automation.Interface)
getApplication35 =
  Automation.propertyGetID 0x80010101 [] Automation.outIDispatch
getMaster4 :: IVDispExtender a -> Prelude.IO (IVMaster Automation.Interface)
getMaster4 =
  Automation.propertyGetID 0x80010115 [] Automation.outIDispatch
getCells2 :: Prelude.String -> IVDispExtender a -> Prelude.IO (IVCell Automation.Interface)
getCells2 cellName =
  Automation.propertyGetID 0x8001010d [Automation.inString cellName] Automation.outIDispatch
getCellsSRC1 :: Prelude.Int -> Prelude.Int -> Prelude.Int -> IVDispExtender a -> Prelude.IO (IVCell Automation.Interface)
getCellsSRC1 section row column =
  Automation.propertyGetID 0x8001010e [Automation.inInt section, Automation.inInt row, Automation.inInt column] Automation.outIDispatch
getData11 :: IVDispExtender a -> Prelude.IO (Prelude.String)
getData11 =
  Automation.propertyGetID 0x8001010f [] Automation.outString
setData11 :: Prelude.String -> IVDispExtender a -> Prelude.IO ()
setData11 rhs =
  Automation.propertySetID 0x8001010f [Automation.inString rhs]
getData21 :: IVDispExtender a -> Prelude.IO (Prelude.String)
getData21 =
  Automation.propertyGetID 0x80010110 [] Automation.outString
setData21 :: Prelude.String -> IVDispExtender a -> Prelude.IO ()
setData21 rhs =
  Automation.propertySetID 0x80010110 [Automation.inString rhs]
getData31 :: IVDispExtender a -> Prelude.IO (Prelude.String)
getData31 =
  Automation.propertyGetID 0x80010111 [] Automation.outString
setData31 :: Prelude.String -> IVDispExtender a -> Prelude.IO ()
setData31 rhs =
  Automation.propertySetID 0x80010111 [Automation.inString rhs]
getHelp1 :: IVDispExtender a -> Prelude.IO (Prelude.String)
getHelp1 =
  Automation.propertyGetID 0x80010112 [] Automation.outString
setHelp1 :: Prelude.String -> IVDispExtender a -> Prelude.IO ()
setHelp1 rhs =
  Automation.propertySetID 0x80010112 [Automation.inString rhs]
getNameID1 :: IVDispExtender a -> Prelude.IO (Prelude.String)
getNameID1 =
  Automation.propertyGetID 0x80010104 [] Automation.outString
shapeCopy0 :: IVDispExtender a -> Prelude.IO ()
shapeCopy0 = Automation.methodID0 0x80010109 []
shapeCut0 :: IVDispExtender a -> Prelude.IO ()
shapeCut0 = Automation.methodID0 0x8001010a []
shapeDelete0 :: IVDispExtender a -> Prelude.IO ()
shapeDelete0 = Automation.methodID0 0x8001010b []
shapeDuplicate0 :: IVDispExtender a -> Prelude.IO ()
shapeDuplicate0 = Automation.methodID0 0x8001010c []
getRowCount1 :: Prelude.Int -> IVDispExtender a -> Prelude.IO (Prelude.Int)
getRowCount1 section =
  Automation.propertyGetID 0x80010118 [Automation.inInt section] Automation.outInt
addSection1 :: Prelude.Int -> IVDispExtender a -> Prelude.IO (Prelude.Int)
addSection1 section =
  Automation.methodID1 0x80010119 [Automation.inInt section] Automation.outInt
deleteSection1 :: Prelude.Int -> IVDispExtender a -> Prelude.IO ()
deleteSection1 section =
  Automation.methodID0 0x8001011a [Automation.inInt section]
addRow1 :: Prelude.Int -> Prelude.Int -> Prelude.Int -> IVDispExtender a -> Prelude.IO (Prelude.Int)
addRow1 section row rowTag =
  Automation.methodID1 0x8001011b [Automation.inInt section, Automation.inInt row, Automation.inInt rowTag] Automation.outInt
deleteRow1 :: Prelude.Int -> Prelude.Int -> IVDispExtender a -> Prelude.IO ()
deleteRow1 section row =
  Automation.methodID0 0x8001011c [Automation.inInt section, Automation.inInt row]
getRowsCellCount1 :: Prelude.Int -> Prelude.Int -> IVDispExtender a -> Prelude.IO (Prelude.Int)
getRowsCellCount1 section row =
  Automation.propertyGetID 0x8001011d [Automation.inInt section, Automation.inInt row] Automation.outInt
getRowType1 :: Prelude.Int -> Prelude.Int -> IVDispExtender a -> Prelude.IO (Prelude.Int)
getRowType1 section row =
  Automation.propertyGetID 0x8001011e [Automation.inInt section, Automation.inInt row] Automation.outInt
setRowType1 :: Prelude.Int -> Prelude.Int -> Prelude.Int -> IVDispExtender a -> Prelude.IO ()
setRowType1 section row rhs =
  Automation.propertySetID 0x8001011e [Automation.inInt section, Automation.inInt row, Automation.inInt rhs]
setCenter1 :: Prelude.Double -> Prelude.Double -> IVDispExtender a -> Prelude.IO ()
setCenter1 xPos yPos =
  Automation.methodID0 0x8001011f [Automation.inDouble xPos, Automation.inDouble yPos]
getConnects3 :: IVDispExtender a -> Prelude.IO (IVConnects Automation.Interface)
getConnects3 =
  Automation.propertyGetID 0x80010122 [] Automation.outIDispatch
getShapeIndex0 :: IVDispExtender a -> Prelude.IO (Prelude.Int)
getShapeIndex0 =
  Automation.propertyGetID 0x80010123 [] Automation.outInt
getStyle3 :: IVDispExtender a -> Prelude.IO (Prelude.String)
getStyle3 =
  Automation.propertyGetID 0x80010124 [] Automation.outString
setStyle2 :: Prelude.String -> IVDispExtender a -> Prelude.IO ()
setStyle2 rhs =
  Automation.propertySetID 0x80010124 [Automation.inString rhs]
setStyleKeepFmt2 :: Prelude.String -> IVDispExtender a -> Prelude.IO ()
setStyleKeepFmt2 rhs =
  Automation.propertySetID 0x80010128 [Automation.inString rhs]
getLineStyle2 :: IVDispExtender a -> Prelude.IO (Prelude.String)
getLineStyle2 =
  Automation.propertyGetID 0x80010125 [] Automation.outString
setLineStyle2 :: Prelude.String -> IVDispExtender a -> Prelude.IO ()
setLineStyle2 rhs =
  Automation.propertySetID 0x80010125 [Automation.inString rhs]
setLineStyleKeepFmt2 :: Prelude.String -> IVDispExtender a -> Prelude.IO ()
setLineStyleKeepFmt2 rhs =
  Automation.propertySetID 0x80010129 [Automation.inString rhs]
getFillStyle2 :: IVDispExtender a -> Prelude.IO (Prelude.String)
getFillStyle2 =
  Automation.propertyGetID 0x80010126 [] Automation.outString
setFillStyle2 :: Prelude.String -> IVDispExtender a -> Prelude.IO ()
setFillStyle2 rhs =
  Automation.propertySetID 0x80010126 [Automation.inString rhs]
setFillStyleKeepFmt2 :: Prelude.String -> IVDispExtender a -> Prelude.IO ()
setFillStyleKeepFmt2 rhs =
  Automation.propertySetID 0x8001012a [Automation.inString rhs]
export4 :: Prelude.String -> IVDispExtender a -> Prelude.IO ()
export4 fileName =
  Automation.methodID0 0x80010139 [Automation.inString fileName]
getUniqueID2 :: Prelude.Int -> IVDispExtender a -> Prelude.IO (Prelude.String)
getUniqueID2 fUniqueID =
  Automation.propertyGetID 0x8001013d [Automation.inInt fUniqueID] Automation.outString
getContainingPage3 :: IVDispExtender a -> Prelude.IO (IVPage Automation.Interface)
getContainingPage3 =
  Automation.propertyGetID 0x8001013e [] Automation.outIDispatch
getContainingMaster3 :: IVDispExtender a -> Prelude.IO (IVMaster Automation.Interface)
getContainingMaster3 =
  Automation.propertyGetID 0x8001013f [] Automation.outIDispatch
getContainingShape3 :: IVDispExtender a -> Prelude.IO (IVShape Automation.Interface)
getContainingShape3 =
  Automation.propertyGetID 0x80010140 [] Automation.outIDispatch
getSectionExists1 :: Prelude.Int -> Prelude.Int -> IVDispExtender a -> Prelude.IO (Prelude.Int)
getSectionExists1 section fLocalExists =
  Automation.propertyGetID 0x80010141 [Automation.inInt section, Automation.inInt fLocalExists] Automation.outInt
getRowExists1 :: Prelude.Int -> Prelude.Int -> Prelude.Int -> IVDispExtender a -> Prelude.IO (Prelude.Int)
getRowExists1 section row fLocalExists =
  Automation.propertyGetID 0x80010142 [Automation.inInt section, Automation.inInt row, Automation.inInt fLocalExists] Automation.outInt
getCellExists1 :: Prelude.String -> Prelude.Int -> IVDispExtender a -> Prelude.IO (Prelude.Int)
getCellExists1 cellName fLocalExists =
  Automation.propertyGetID 0x80010143 [Automation.inString cellName, Automation.inInt fLocalExists] Automation.outInt
getCellsSRCExists1 :: Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> IVDispExtender a -> Prelude.IO (Prelude.Int)
getCellsSRCExists1 section row column fLocalExists =
  Automation.propertyGetID 0x80010144 [Automation.inInt section, Automation.inInt row, Automation.inInt column, Automation.inInt fLocalExists] Automation.outInt
getLayerCount1 :: IVDispExtender a -> Prelude.IO (Prelude.Int)
getLayerCount1 =
  Automation.propertyGetID 0x80010145 [] Automation.outInt
getLayer1 :: Prelude.Int -> IVDispExtender a -> Prelude.IO (IVLayer Automation.Interface)
getLayer1 index =
  Automation.propertyGetID 0x80010146 [Automation.inInt index] Automation.outIDispatch
addNamedRow1 :: Prelude.Int -> Prelude.String -> Prelude.Int -> IVDispExtender a -> Prelude.IO (Prelude.Int)
addNamedRow1 section rowName rowTag =
  Automation.methodID1 0x80010147 [Automation.inInt section, Automation.inString rowName, Automation.inInt rowTag] Automation.outInt
addRows1 :: Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> IVDispExtender a -> Prelude.IO (Prelude.Int)
addRows1 section row rowTag rowCount =
  Automation.methodID1 0x80010148 [Automation.inInt section, Automation.inInt row, Automation.inInt rowTag, Automation.inInt rowCount] Automation.outInt
getEventList19 :: IVDispExtender a -> Prelude.IO (IVEventList Automation.Interface)
getEventList19 =
  Automation.propertyGetID 0x80010149 [] Automation.outIDispatch
getPersistsEvents18 :: IVDispExtender a -> Prelude.IO (Prelude.Int)
getPersistsEvents18 =
  Automation.propertyGetID 0x8001014a [] Automation.outInt
getClassID2 :: IVDispExtender a -> Prelude.IO (Prelude.String)
getClassID2 =
  Automation.propertyGetID 0x80010156 [] Automation.outString
getShapeObject0 :: IVDispExtender a -> Prelude.IO (Automation.IDispatch Automation.Interface)
getShapeObject0 =
  Automation.propertyGetID 0x80010158 [] Automation.outIDispatch
openSheetWindow1 :: IVDispExtender a -> Prelude.IO (IVWindow Automation.Interface)
openSheetWindow1 =
  Automation.methodID1 0x8001015a [] Automation.outIDispatch
getShapeID0 :: IVDispExtender a -> Prelude.IO (Prelude.Int)
getShapeID0 =
  Automation.propertyGetID 0x8001015b [] Automation.outInt
--getFormulas4 :: Array.Array Prelude.Int z -> IVDispExtender a -> Prelude.IO (Array.Array Prelude.Int z)
--getFormulas4 sRCStream =
--  Automation.methodID1 0x8001015d [Automation.inArray sRCStream] Automation.outArray
--getResults4 :: Array.Array Prelude.Int z -> Prelude.Int -> Array.Array Prelude.Int z -> IVDispExtender a -> Prelude.IO (Array.Array Prelude.Int z)
--getResults4 sRCStream flags unitsNamesOrCodes =
--  Automation.methodID1 0x8001015e [Automation.inArray sRCStream, Automation.inInt flags, Automation.inArray unitsNamesOrCodes] Automation.outArray
--setFormulas4 :: Array.Array Prelude.Int z -> Array.Array Prelude.Int z -> Prelude.Int -> IVDispExtender a -> Prelude.IO (Prelude.Int)
--setFormulas4 sRCStream formulaArray flags =
--  Automation.methodID1 0x8001015f [Automation.inArray sRCStream, Automation.inArray formulaArray, Automation.inInt flags] Automation.outInt
--setResults4 :: Array.Array Prelude.Int z -> Array.Array Prelude.Int z -> Array.Array Prelude.Int z -> Prelude.Int -> IVDispExtender a -> Prelude.IO (Prelude.Int)
--setResults4 sRCStream unitsNamesOrCodes resultArray flags =
--  Automation.methodID1 0x80010160 [Automation.inArray sRCStream, Automation.inArray unitsNamesOrCodes, Automation.inArray resultArray, Automation.inInt flags] Automation.outInt
getFromConnects1 :: IVDispExtender a -> Prelude.IO (IVConnects Automation.Interface)
getFromConnects1 =
  Automation.propertyGetID 0x80010161 [] Automation.outIDispatch
boundingBox4 :: Prelude.Int -> IVDispExtender a -> Prelude.IO (Prelude.Double, Prelude.Double, Prelude.Double, Prelude.Double)
boundingBox4 flags =
  Automation.methodID4 0x80010163 [Automation.inInt flags] Automation.outDouble Automation.outDouble Automation.outDouble Automation.outDouble
hitTest1 :: Prelude.Double -> Prelude.Double -> Prelude.Double -> IVDispExtender a -> Prelude.IO (Prelude.Int)
hitTest1 xPos yPos tolerance =
  Automation.methodID1 0x80010164 [Automation.inDouble xPos, Automation.inDouble yPos, Automation.inDouble tolerance] Automation.outInt
getHyperlink1 :: IVDispExtender a -> Prelude.IO (IVHyperlink Automation.Interface)
getHyperlink1 =
  Automation.propertyGetID 0x80010165 [] Automation.outIDispatch
getProgID2 :: IVDispExtender a -> Prelude.IO (Prelude.String)
getProgID2 =
  Automation.propertyGetID 0x80010166 [] Automation.outString
getObjectIsInherited1 :: IVDispExtender a -> Prelude.IO (Prelude.Int)
getObjectIsInherited1 =
  Automation.propertyGetID 0x80010167 [] Automation.outInt
-- --------------------------------------------------
-- 
-- interface IVAmbients
-- 
-- --------------------------------------------------
data VAmbients a = VAmbients
                    
type IVAmbients a = Automation.IDispatch (VAmbients a)
iidIVAmbients :: Com.IID (IVAmbients Automation.Interface)
iidIVAmbients = Com.mkIID "{000D0D10-0000-0000-C000-000000000046}"
getBackColor :: IVAmbients a -> Prelude.IO (Prelude.Int)
getBackColor =
  Automation.propertyGetID 0xfffffd43 [] Automation.outInt
getDisplayName :: IVAmbients a -> Prelude.IO (Prelude.String)
getDisplayName =
  Automation.propertyGetID 0xfffffd42 [] Automation.outString
getFont :: IVAmbients a -> Prelude.IO (Automation.IDispatch Automation.Interface)
getFont =
  Automation.propertyGetID 0xfffffd41 [] Automation.outIDispatch
getForeColor :: IVAmbients a -> Prelude.IO (Prelude.Int)
getForeColor =
  Automation.propertyGetID 0xfffffd40 [] Automation.outInt
getLocaleID :: IVAmbients a -> Prelude.IO (Prelude.Int)
getLocaleID =
  Automation.propertyGetID 0xfffffd3f [] Automation.outInt
getMessageReflect :: IVAmbients a -> Prelude.IO (Prelude.Int)
getMessageReflect =
  Automation.propertyGetID 0xfffffd3e [] Automation.outInt
getScaleUnits :: IVAmbients a -> Prelude.IO (Prelude.String)
getScaleUnits =
  Automation.propertyGetID 0xfffffd3d [] Automation.outString
getTextAlign :: IVAmbients a -> Prelude.IO (Prelude.Int)
getTextAlign =
  Automation.propertyGetID 0xfffffd3c [] Automation.outInt
getUserMode :: IVAmbients a -> Prelude.IO (Prelude.Int)
getUserMode =
  Automation.propertyGetID 0xfffffd3b [] Automation.outInt
getUIDead :: IVAmbients a -> Prelude.IO (Prelude.Int)
getUIDead =
  Automation.propertyGetID 0xfffffd3a [] Automation.outInt
getShowGrabHandles :: IVAmbients a -> Prelude.IO (Prelude.Int)
getShowGrabHandles =
  Automation.propertyGetID 0xfffffd39 [] Automation.outInt
getShowHatching :: IVAmbients a -> Prelude.IO (Prelude.Int)
getShowHatching =
  Automation.propertyGetID 0xfffffd38 [] Automation.outInt
getDisplayAsDefault :: IVAmbients a -> Prelude.IO (Prelude.Int)
getDisplayAsDefault =
  Automation.propertyGetID 0xfffffd37 [] Automation.outInt
getSupportsMnemonics :: IVAmbients a -> Prelude.IO (Prelude.Int)
getSupportsMnemonics =
  Automation.propertyGetID 0xfffffd36 [] Automation.outInt
getAutoClip :: IVAmbients a -> Prelude.IO (Prelude.Int)
getAutoClip =
  Automation.propertyGetID 0xfffffd35 [] Automation.outInt
getAppearance :: IVAmbients a -> Prelude.IO (Prelude.Int)
getAppearance =
  Automation.propertyGetID 0xfffffd34 [] Automation.outInt
-- --------------------------------------------------
-- 
-- coclass Control
-- 
-- --------------------------------------------------
clsidControl :: Com.CLSID
clsidControl = Com.mkCLSID "{000D0D00-0000-0000-C000-000000000046}"
-- --------------------------------------------------
-- 
-- coclass Extender
-- 
-- --------------------------------------------------
clsidExtender :: Com.CLSID
clsidExtender =
  Com.mkCLSID "{000D0D06-0000-0000-C000-000000000046}"
-- --------------------------------------------------
-- 
-- coclass Hyperlink
-- 
-- --------------------------------------------------
clsidHyperlink :: Com.CLSID
clsidHyperlink =
  Com.mkCLSID "{000D0A1B-0000-0000-C000-000000000046}"
-- --------------------------------------------------
-- 
-- coclass OLEObjects
-- 
-- --------------------------------------------------
clsidOLEObjects :: Com.CLSID
clsidOLEObjects =
  Com.mkCLSID "{000D0A1C-0000-0000-C000-000000000046}"
-- --------------------------------------------------
-- 
-- coclass OLEObject
-- 
-- --------------------------------------------------
clsidOLEObject :: Com.CLSID
clsidOLEObject =
  Com.mkCLSID "{000D0A1D-0000-0000-C000-000000000046}"
-- --------------------------------------------------
-- 
-- coclass Paths
-- 
-- --------------------------------------------------
clsidPaths :: Com.CLSID
clsidPaths = Com.mkCLSID "{000D0A1E-0000-0000-C000-000000000046}"
-- --------------------------------------------------
-- 
-- coclass Path
-- 
-- --------------------------------------------------
clsidPath :: Com.CLSID
clsidPath = Com.mkCLSID "{000D0A1F-0000-0000-C000-000000000046}"
-- --------------------------------------------------
-- 
-- coclass Curve
-- 
-- --------------------------------------------------
clsidCurve :: Com.CLSID
clsidCurve = Com.mkCLSID "{000D0A20-0000-0000-C000-000000000046}"
