module Word97 where

import qualified Prelude
import qualified Automation (IDispatch, Interface, outIDispatch, 
                             propertyGetID, outInt, outString, inInt, propertySetID, Variant, 
                             inVariant, inString, inIDispatch, outVariant, methodID0, 
                             functionID1, inArray, outFloat, inFloat, outIUnknown, outDouble)
import qualified Com (IID, mkIID, IUnknown, CLSID, mkCLSID)
import qualified Int (Int16)
import qualified Office (IAssistant, ICommandBars, IFileSearch, 
                        IShapes, IShape, IShapeRange, IFreeformBuilder, IAdjustments, 
                        ICalloutFormat, IConnectorFormat, IFillFormat, IGroupShapes, 
                        ILineFormat, IShapeNodes, IPictureFormat, IShadowFormat, 
                        ITextEffectFormat, ITextFrame, IThreeDFormat)
import qualified VBIDE (IWindow, IVBE, IApplication, IVBProject)

{-
data WdMailSystem
 = WdNoMailSystem
 | WdMAPI
 | WdPowerTalk
 | WdMAPIandPowerTalk
 
marshallWdMailSystem :: WdMailSystem -> Prelude.IO Int.Int16
marshallWdMailSystem v =
  case v of
     WdNoMailSystem -> Prelude.return (0)
     WdMAPI -> Prelude.return (1)
     WdPowerTalk -> Prelude.return (2)
     WdMAPIandPowerTalk -> Prelude.return (3)
unmarshallWdMailSystem :: Int.Int16 -> Prelude.IO WdMailSystem
unmarshallWdMailSystem v =
  case v of
     0 -> Prelude.return (WdNoMailSystem)
     1 -> Prelude.return (WdMAPI)
     2 -> Prelude.return (WdPowerTalk)
     3 -> Prelude.return (WdMAPIandPowerTalk)
     _ -> Prelude.fail (Prelude.userError "unmarshallWdMailSystem: illegal enum value ")
data WdTemplateType
 = WdNormalTemplate
 | WdGlobalTemplate
 | WdAttachedTemplate
 
marshallWdTemplateType :: WdTemplateType -> Prelude.IO Int.Int16
marshallWdTemplateType v =
  case v of
     WdNormalTemplate -> Prelude.return (0)
     WdGlobalTemplate -> Prelude.return (1)
     WdAttachedTemplate -> Prelude.return (2)
unmarshallWdTemplateType :: Int.Int16 -> Prelude.IO WdTemplateType
unmarshallWdTemplateType v =
  case v of
     0 -> Prelude.return (WdNormalTemplate)
     1 -> Prelude.return (WdGlobalTemplate)
     2 -> Prelude.return (WdAttachedTemplate)
     _ -> Prelude.fail (Prelude.userError "unmarshallWdTemplateType: illegal enum value ")
data WdContinue
 = WdContinueDisabled
 | WdResetList
 | WdContinueList
 
marshallWdContinue :: WdContinue -> Prelude.IO Int.Int16
marshallWdContinue v =
  case v of
     WdContinueDisabled -> Prelude.return (0)
     WdResetList -> Prelude.return (1)
     WdContinueList -> Prelude.return (2)
unmarshallWdContinue :: Int.Int16 -> Prelude.IO WdContinue
unmarshallWdContinue v =
  case v of
     0 -> Prelude.return (WdContinueDisabled)
     1 -> Prelude.return (WdResetList)
     2 -> Prelude.return (WdContinueList)
     _ -> Prelude.fail (Prelude.userError "unmarshallWdContinue: illegal enum value ")
data WdIMEMode
 = WdIMEModeNoControl
 | WdIMEModeOn
 | WdIMEModeOff
 | WdIMEModeHiragana
 | WdIMEModeKatakana
 | WdIMEModeKatakanaHalf
 | WdIMEModeAlphaFull
 | WdIMEModeAlpha
 | WdIMEModeHangulFull
 | WdIMEModeHangul
 
marshallWdIMEMode :: WdIMEMode -> Prelude.IO Int.Int16
marshallWdIMEMode v =
  case v of
     WdIMEModeNoControl -> Prelude.return (0)
     WdIMEModeOn -> Prelude.return (1)
     WdIMEModeOff -> Prelude.return (2)
     WdIMEModeHiragana -> Prelude.return (4)
     WdIMEModeKatakana -> Prelude.return (5)
     WdIMEModeKatakanaHalf -> Prelude.return (6)
     WdIMEModeAlphaFull -> Prelude.return (7)
     WdIMEModeAlpha -> Prelude.return (8)
     WdIMEModeHangulFull -> Prelude.return (9)
     WdIMEModeHangul -> Prelude.return (10)
unmarshallWdIMEMode :: Int.Int16 -> Prelude.IO WdIMEMode
unmarshallWdIMEMode v =
  case v of
     0 -> Prelude.return (WdIMEModeNoControl)
     1 -> Prelude.return (WdIMEModeOn)
     2 -> Prelude.return (WdIMEModeOff)
     4 -> Prelude.return (WdIMEModeHiragana)
     5 -> Prelude.return (WdIMEModeKatakana)
     6 -> Prelude.return (WdIMEModeKatakanaHalf)
     7 -> Prelude.return (WdIMEModeAlphaFull)
     8 -> Prelude.return (WdIMEModeAlpha)
     9 -> Prelude.return (WdIMEModeHangulFull)
     10 -> Prelude.return (WdIMEModeHangul)
     _ -> Prelude.fail (Prelude.userError "unmarshallWdIMEMode: illegal enum value ")
data WdBaselineAlignment
 = WdBaselineAlignTop
 | WdBaselineAlignCenter
 | WdBaselineAlignBaseline
 | WdBaselineAlignFarEast50
 | WdBaselineAlignAuto
 
marshallWdBaselineAlignment :: WdBaselineAlignment -> Prelude.IO Int.Int16
marshallWdBaselineAlignment v =
  case v of
     WdBaselineAlignTop -> Prelude.return (0)
     WdBaselineAlignCenter -> Prelude.return (1)
     WdBaselineAlignBaseline -> Prelude.return (2)
     WdBaselineAlignFarEast50 -> Prelude.return (3)
     WdBaselineAlignAuto -> Prelude.return (4)
unmarshallWdBaselineAlignment :: Int.Int16 -> Prelude.IO WdBaselineAlignment
unmarshallWdBaselineAlignment v =
  case v of
     0 -> Prelude.return (WdBaselineAlignTop)
     1 -> Prelude.return (WdBaselineAlignCenter)
     2 -> Prelude.return (WdBaselineAlignBaseline)
     3 -> Prelude.return (WdBaselineAlignFarEast50)
     4 -> Prelude.return (WdBaselineAlignAuto)
     _ -> Prelude.fail (Prelude.userError "unmarshallWdBaselineAlignment: illegal enum value ")
data WdIndexFilter
 = WdIndexFilterNone
 | WdIndexFilterAiueo
 | WdIndexFilterAkasatana
 | WdIndexFilterChosung
 | WdIndexFilterLow
 | WdIndexFilterMedium
 | WdIndexFilterFull
 
marshallWdIndexFilter :: WdIndexFilter -> Prelude.IO Int.Int16
marshallWdIndexFilter v =
  case v of
     WdIndexFilterNone -> Prelude.return (0)
     WdIndexFilterAiueo -> Prelude.return (1)
     WdIndexFilterAkasatana -> Prelude.return (2)
     WdIndexFilterChosung -> Prelude.return (3)
     WdIndexFilterLow -> Prelude.return (4)
     WdIndexFilterMedium -> Prelude.return (5)
     WdIndexFilterFull -> Prelude.return (6)
unmarshallWdIndexFilter :: Int.Int16 -> Prelude.IO WdIndexFilter
unmarshallWdIndexFilter v =
  case v of
     0 -> Prelude.return (WdIndexFilterNone)
     1 -> Prelude.return (WdIndexFilterAiueo)
     2 -> Prelude.return (WdIndexFilterAkasatana)
     3 -> Prelude.return (WdIndexFilterChosung)
     4 -> Prelude.return (WdIndexFilterLow)
     5 -> Prelude.return (WdIndexFilterMedium)
     6 -> Prelude.return (WdIndexFilterFull)
     _ -> Prelude.fail (Prelude.userError "unmarshallWdIndexFilter: illegal enum value ")
data WdIndexSortBy
 = WdIndexSortByStroke
 | WdIndexSortBySyllable
 
marshallWdIndexSortBy :: WdIndexSortBy -> Prelude.IO Int.Int16
marshallWdIndexSortBy v =
  case v of
     WdIndexSortByStroke -> Prelude.return (0)
     WdIndexSortBySyllable -> Prelude.return (1)
unmarshallWdIndexSortBy :: Int.Int16 -> Prelude.IO WdIndexSortBy
unmarshallWdIndexSortBy v =
  case v of
     0 -> Prelude.return (WdIndexSortByStroke)
     1 -> Prelude.return (WdIndexSortBySyllable)
     _ -> Prelude.fail (Prelude.userError "unmarshallWdIndexSortBy: illegal enum value ")
data WdJustificationMode
 = WdJustificationModeExpand
 | WdJustificationModeCompress
 | WdJustificationModeCompressKana
 
marshallWdJustificationMode :: WdJustificationMode -> Prelude.IO Int.Int16
marshallWdJustificationMode v =
  case v of
     WdJustificationModeExpand -> Prelude.return (0)
     WdJustificationModeCompress -> Prelude.return (1)
     WdJustificationModeCompressKana -> Prelude.return (2)
unmarshallWdJustificationMode :: Int.Int16 -> Prelude.IO WdJustificationMode
unmarshallWdJustificationMode v =
  case v of
     0 -> Prelude.return (WdJustificationModeExpand)
     1 -> Prelude.return (WdJustificationModeCompress)
     2 -> Prelude.return (WdJustificationModeCompressKana)
     _ -> Prelude.fail (Prelude.userError "unmarshallWdJustificationMode: illegal enum value ")
data WdFarEastLineBreakLevel
 = WdFarEastLineBreakLevelNormal
 | WdFarEastLineBreakLevelStrict
 | WdFarEastLineBreakLevelCustom
 
marshallWdFarEastLineBreakLevel :: WdFarEastLineBreakLevel -> Prelude.IO Int.Int16
marshallWdFarEastLineBreakLevel v =
  case v of
     WdFarEastLineBreakLevelNormal -> Prelude.return (0)
     WdFarEastLineBreakLevelStrict -> Prelude.return (1)
     WdFarEastLineBreakLevelCustom -> Prelude.return (2)
unmarshallWdFarEastLineBreakLevel :: Int.Int16 -> Prelude.IO WdFarEastLineBreakLevel
unmarshallWdFarEastLineBreakLevel v =
  case v of
     0 -> Prelude.return (WdFarEastLineBreakLevelNormal)
     1 -> Prelude.return (WdFarEastLineBreakLevelStrict)
     2 -> Prelude.return (WdFarEastLineBreakLevelCustom)
     _ -> Prelude.fail (Prelude.userError "unmarshallWdFarEastLineBreakLevel: illegal enum value ")
data WdMultipleWordConversionsMode
 = WdHangulToHanja
 | WdHanjaToHangul
 
marshallWdMultipleWordConversionsMode :: WdMultipleWordConversionsMode -> Prelude.IO Int.Int16
marshallWdMultipleWordConversionsMode v =
  case v of
     WdHangulToHanja -> Prelude.return (0)
     WdHanjaToHangul -> Prelude.return (1)
unmarshallWdMultipleWordConversionsMode :: Int.Int16 -> Prelude.IO WdMultipleWordConversionsMode
unmarshallWdMultipleWordConversionsMode v =
  case v of
     0 -> Prelude.return (WdHangulToHanja)
     1 -> Prelude.return (WdHanjaToHangul)
     _ -> Prelude.fail (Prelude.userError "unmarshallWdMultipleWordConversionsMode: illegal enum value ")
data WdColorIndex
 = WdAuto
 | WdBlack
 | WdBlue
 | WdTurquoise
 | WdBrightGreen
 | WdPink
 | WdRed
 | WdYellow
 | WdWhite
 | WdDarkBlue
 | WdTeal
 | WdGreen
 | WdViolet
 | WdDarkRed
 | WdDarkYellow
 | WdGray50
 | WdGray25
 | WdByAuthor
 | WdNoHighlight
 
marshallWdColorIndex :: WdColorIndex -> Prelude.IO Int.Int16
marshallWdColorIndex v =
  case v of
     WdAuto -> Prelude.return (0)
     WdBlack -> Prelude.return (1)
     WdBlue -> Prelude.return (2)
     WdTurquoise -> Prelude.return (3)
     WdBrightGreen -> Prelude.return (4)
     WdPink -> Prelude.return (5)
     WdRed -> Prelude.return (6)
     WdYellow -> Prelude.return (7)
     WdWhite -> Prelude.return (8)
     WdDarkBlue -> Prelude.return (9)
     WdTeal -> Prelude.return (10)
     WdGreen -> Prelude.return (11)
     WdViolet -> Prelude.return (12)
     WdDarkRed -> Prelude.return (13)
     WdDarkYellow -> Prelude.return (14)
     WdGray50 -> Prelude.return (15)
     WdGray25 -> Prelude.return (16)
     WdByAuthor -> Prelude.return ((-1))
     WdNoHighlight -> Prelude.return (0)
unmarshallWdColorIndex :: Int.Int16 -> Prelude.IO WdColorIndex
unmarshallWdColorIndex v =
  case v of
     0 -> Prelude.return (WdAuto)
     1 -> Prelude.return (WdBlack)
     2 -> Prelude.return (WdBlue)
     3 -> Prelude.return (WdTurquoise)
     4 -> Prelude.return (WdBrightGreen)
     5 -> Prelude.return (WdPink)
     6 -> Prelude.return (WdRed)
     7 -> Prelude.return (WdYellow)
     8 -> Prelude.return (WdWhite)
     9 -> Prelude.return (WdDarkBlue)
     10 -> Prelude.return (WdTeal)
     11 -> Prelude.return (WdGreen)
     12 -> Prelude.return (WdViolet)
     13 -> Prelude.return (WdDarkRed)
     14 -> Prelude.return (WdDarkYellow)
     15 -> Prelude.return (WdGray50)
     16 -> Prelude.return (WdGray25)
     (-1) -> Prelude.return (WdByAuthor)
     0 -> Prelude.return (WdNoHighlight)
     _ -> Prelude.fail (Prelude.userError "unmarshallWdColorIndex: illegal enum value ")
data WdTextureIndex
 = WdTextureNone
 | WdTexture2Pt5Percent
 | WdTexture5Percent
 | WdTexture7Pt5Percent
 | WdTexture10Percent
 | WdTexture12Pt5Percent
 | WdTexture15Percent
 | WdTexture17Pt5Percent
 | WdTexture20Percent
 | WdTexture22Pt5Percent
 | WdTexture25Percent
 | WdTexture27Pt5Percent
 | WdTexture30Percent
 | WdTexture32Pt5Percent
 | WdTexture35Percent
 | WdTexture37Pt5Percent
 | WdTexture40Percent
 | WdTexture42Pt5Percent
 | WdTexture45Percent
 | WdTexture47Pt5Percent
 | WdTexture50Percent
 | WdTexture52Pt5Percent
 | WdTexture55Percent
 | WdTexture57Pt5Percent
 | WdTexture60Percent
 | WdTexture62Pt5Percent
 | WdTexture65Percent
 | WdTexture67Pt5Percent
 | WdTexture70Percent
 | WdTexture72Pt5Percent
 | WdTexture75Percent
 | WdTexture77Pt5Percent
 | WdTexture80Percent
 | WdTexture82Pt5Percent
 | WdTexture85Percent
 | WdTexture87Pt5Percent
 | WdTexture90Percent
 | WdTexture92Pt5Percent
 | WdTexture95Percent
 | WdTexture97Pt5Percent
 | WdTextureSolid
 | WdTextureDarkHorizontal
 | WdTextureDarkVertical
 | WdTextureDarkDiagonalDown
 | WdTextureDarkDiagonalUp
 | WdTextureDarkCross
 | WdTextureDarkDiagonalCross
 | WdTextureHorizontal
 | WdTextureVertical
 | WdTextureDiagonalDown
 | WdTextureDiagonalUp
 | WdTextureCross
 | WdTextureDiagonalCross
 
marshallWdTextureIndex :: WdTextureIndex -> Prelude.IO Int.Int16
marshallWdTextureIndex v =
  case v of
     WdTextureNone -> Prelude.return (0)
     WdTexture2Pt5Percent -> Prelude.return (25)
     WdTexture5Percent -> Prelude.return (50)
     WdTexture7Pt5Percent -> Prelude.return (75)
     WdTexture10Percent -> Prelude.return (100)
     WdTexture12Pt5Percent -> Prelude.return (125)
     WdTexture15Percent -> Prelude.return (150)
     WdTexture17Pt5Percent -> Prelude.return (175)
     WdTexture20Percent -> Prelude.return (200)
     WdTexture22Pt5Percent -> Prelude.return (225)
     WdTexture25Percent -> Prelude.return (250)
     WdTexture27Pt5Percent -> Prelude.return (275)
     WdTexture30Percent -> Prelude.return (300)
     WdTexture32Pt5Percent -> Prelude.return (325)
     WdTexture35Percent -> Prelude.return (350)
     WdTexture37Pt5Percent -> Prelude.return (375)
     WdTexture40Percent -> Prelude.return (400)
     WdTexture42Pt5Percent -> Prelude.return (425)
     WdTexture45Percent -> Prelude.return (450)
     WdTexture47Pt5Percent -> Prelude.return (475)
     WdTexture50Percent -> Prelude.return (500)
     WdTexture52Pt5Percent -> Prelude.return (525)
     WdTexture55Percent -> Prelude.return (550)
     WdTexture57Pt5Percent -> Prelude.return (575)
     WdTexture60Percent -> Prelude.return (600)
     WdTexture62Pt5Percent -> Prelude.return (625)
     WdTexture65Percent -> Prelude.return (650)
     WdTexture67Pt5Percent -> Prelude.return (675)
     WdTexture70Percent -> Prelude.return (700)
     WdTexture72Pt5Percent -> Prelude.return (725)
     WdTexture75Percent -> Prelude.return (750)
     WdTexture77Pt5Percent -> Prelude.return (775)
     WdTexture80Percent -> Prelude.return (800)
     WdTexture82Pt5Percent -> Prelude.return (825)
     WdTexture85Percent -> Prelude.return (850)
     WdTexture87Pt5Percent -> Prelude.return (875)
     WdTexture90Percent -> Prelude.return (900)
     WdTexture92Pt5Percent -> Prelude.return (925)
     WdTexture95Percent -> Prelude.return (950)
     WdTexture97Pt5Percent -> Prelude.return (975)
     WdTextureSolid -> Prelude.return (1000)
     WdTextureDarkHorizontal -> Prelude.return ((-1))
     WdTextureDarkVertical -> Prelude.return ((-2))
     WdTextureDarkDiagonalDown -> Prelude.return ((-3))
     WdTextureDarkDiagonalUp -> Prelude.return ((-4))
     WdTextureDarkCross -> Prelude.return ((-5))
     WdTextureDarkDiagonalCross -> Prelude.return ((-6))
     WdTextureHorizontal -> Prelude.return ((-7))
     WdTextureVertical -> Prelude.return ((-8))
     WdTextureDiagonalDown -> Prelude.return ((-9))
     WdTextureDiagonalUp -> Prelude.return ((-10))
     WdTextureCross -> Prelude.return ((-11))
     WdTextureDiagonalCross -> Prelude.return ((-12))
unmarshallWdTextureIndex :: Int.Int16 -> Prelude.IO WdTextureIndex
unmarshallWdTextureIndex v =
  case v of
     0 -> Prelude.return (WdTextureNone)
     25 -> Prelude.return (WdTexture2Pt5Percent)
     50 -> Prelude.return (WdTexture5Percent)
     75 -> Prelude.return (WdTexture7Pt5Percent)
     100 -> Prelude.return (WdTexture10Percent)
     125 -> Prelude.return (WdTexture12Pt5Percent)
     150 -> Prelude.return (WdTexture15Percent)
     175 -> Prelude.return (WdTexture17Pt5Percent)
     200 -> Prelude.return (WdTexture20Percent)
     225 -> Prelude.return (WdTexture22Pt5Percent)
     250 -> Prelude.return (WdTexture25Percent)
     275 -> Prelude.return (WdTexture27Pt5Percent)
     300 -> Prelude.return (WdTexture30Percent)
     325 -> Prelude.return (WdTexture32Pt5Percent)
     350 -> Prelude.return (WdTexture35Percent)
     375 -> Prelude.return (WdTexture37Pt5Percent)
     400 -> Prelude.return (WdTexture40Percent)
     425 -> Prelude.return (WdTexture42Pt5Percent)
     450 -> Prelude.return (WdTexture45Percent)
     475 -> Prelude.return (WdTexture47Pt5Percent)
     500 -> Prelude.return (WdTexture50Percent)
     525 -> Prelude.return (WdTexture52Pt5Percent)
     550 -> Prelude.return (WdTexture55Percent)
     575 -> Prelude.return (WdTexture57Pt5Percent)
     600 -> Prelude.return (WdTexture60Percent)
     625 -> Prelude.return (WdTexture62Pt5Percent)
     650 -> Prelude.return (WdTexture65Percent)
     675 -> Prelude.return (WdTexture67Pt5Percent)
     700 -> Prelude.return (WdTexture70Percent)
     725 -> Prelude.return (WdTexture72Pt5Percent)
     750 -> Prelude.return (WdTexture75Percent)
     775 -> Prelude.return (WdTexture77Pt5Percent)
     800 -> Prelude.return (WdTexture80Percent)
     825 -> Prelude.return (WdTexture82Pt5Percent)
     850 -> Prelude.return (WdTexture85Percent)
     875 -> Prelude.return (WdTexture87Pt5Percent)
     900 -> Prelude.return (WdTexture90Percent)
     925 -> Prelude.return (WdTexture92Pt5Percent)
     950 -> Prelude.return (WdTexture95Percent)
     975 -> Prelude.return (WdTexture97Pt5Percent)
     1000 -> Prelude.return (WdTextureSolid)
     (-1) -> Prelude.return (WdTextureDarkHorizontal)
     (-2) -> Prelude.return (WdTextureDarkVertical)
     (-3) -> Prelude.return (WdTextureDarkDiagonalDown)
     (-4) -> Prelude.return (WdTextureDarkDiagonalUp)
     (-5) -> Prelude.return (WdTextureDarkCross)
     (-6) -> Prelude.return (WdTextureDarkDiagonalCross)
     (-7) -> Prelude.return (WdTextureHorizontal)
     (-8) -> Prelude.return (WdTextureVertical)
     (-9) -> Prelude.return (WdTextureDiagonalDown)
     (-10) -> Prelude.return (WdTextureDiagonalUp)
     (-11) -> Prelude.return (WdTextureCross)
     (-12) -> Prelude.return (WdTextureDiagonalCross)
     _ -> Prelude.fail (Prelude.userError "unmarshallWdTextureIndex: illegal enum value ")
data WdUnderline
 = WdUnderlineNone
 | WdUnderlineSingle
 | WdUnderlineWords
 | WdUnderlineDouble
 | WdUnderlineDotted
 | WdUnderlineThick
 | WdUnderlineDash
 | WdUnderlineDotDash
 | WdUnderlineDotDotDash
 | WdUnderlineWavy
 
marshallWdUnderline :: WdUnderline -> Prelude.IO Int.Int16
marshallWdUnderline v =
  case v of
     WdUnderlineNone -> Prelude.return (0)
     WdUnderlineSingle -> Prelude.return (1)
     WdUnderlineWords -> Prelude.return (2)
     WdUnderlineDouble -> Prelude.return (3)
     WdUnderlineDotted -> Prelude.return (4)
     WdUnderlineThick -> Prelude.return (6)
     WdUnderlineDash -> Prelude.return (7)
     WdUnderlineDotDash -> Prelude.return (9)
     WdUnderlineDotDotDash -> Prelude.return (10)
     WdUnderlineWavy -> Prelude.return (11)
unmarshallWdUnderline :: Int.Int16 -> Prelude.IO WdUnderline
unmarshallWdUnderline v =
  case v of
     0 -> Prelude.return (WdUnderlineNone)
     1 -> Prelude.return (WdUnderlineSingle)
     2 -> Prelude.return (WdUnderlineWords)
     3 -> Prelude.return (WdUnderlineDouble)
     4 -> Prelude.return (WdUnderlineDotted)
     6 -> Prelude.return (WdUnderlineThick)
     7 -> Prelude.return (WdUnderlineDash)
     9 -> Prelude.return (WdUnderlineDotDash)
     10 -> Prelude.return (WdUnderlineDotDotDash)
     11 -> Prelude.return (WdUnderlineWavy)
     _ -> Prelude.fail (Prelude.userError "unmarshallWdUnderline: illegal enum value ")
data WdEmphasisMark
 = WdEmphasisMarkNone
 | WdEmphasisMarkOverSolidCircle
 | WdEmphasisMarkOverComma
 | WdEmphasisMarkOverWhiteCircle
 | WdEmphasisMarkUnderSolidCircle
 
marshallWdEmphasisMark :: WdEmphasisMark -> Prelude.IO Int.Int16
marshallWdEmphasisMark v =
  case v of
     WdEmphasisMarkNone -> Prelude.return (0)
     WdEmphasisMarkOverSolidCircle -> Prelude.return (1)
     WdEmphasisMarkOverComma -> Prelude.return (2)
     WdEmphasisMarkOverWhiteCircle -> Prelude.return (3)
     WdEmphasisMarkUnderSolidCircle -> Prelude.return (4)
unmarshallWdEmphasisMark :: Int.Int16 -> Prelude.IO WdEmphasisMark
unmarshallWdEmphasisMark v =
  case v of
     0 -> Prelude.return (WdEmphasisMarkNone)
     1 -> Prelude.return (WdEmphasisMarkOverSolidCircle)
     2 -> Prelude.return (WdEmphasisMarkOverComma)
     3 -> Prelude.return (WdEmphasisMarkOverWhiteCircle)
     4 -> Prelude.return (WdEmphasisMarkUnderSolidCircle)
     _ -> Prelude.fail (Prelude.userError "unmarshallWdEmphasisMark: illegal enum value ")
data WdInternationalIndex
 = WdListSeparator
 | WdDecimalSeparator
 | WdThousandsSeparator
 | WdCurrencyCode
 | Wd24HourClock
 | WdInternationalAM
 | WdInternationalPM
 | WdTimeSeparator
 | WdDateSeparator
 | WdProductLanguageID
 
marshallWdInternationalIndex :: WdInternationalIndex -> Prelude.IO Int.Int16
marshallWdInternationalIndex v =
  case v of
     WdListSeparator -> Prelude.return (17)
     WdDecimalSeparator -> Prelude.return (18)
     WdThousandsSeparator -> Prelude.return (19)
     WdCurrencyCode -> Prelude.return (20)
     Wd24HourClock -> Prelude.return (21)
     WdInternationalAM -> Prelude.return (22)
     WdInternationalPM -> Prelude.return (23)
     WdTimeSeparator -> Prelude.return (24)
     WdDateSeparator -> Prelude.return (25)
     WdProductLanguageID -> Prelude.return (26)
unmarshallWdInternationalIndex :: Int.Int16 -> Prelude.IO WdInternationalIndex
unmarshallWdInternationalIndex v =
  case v of
     17 -> Prelude.return (WdListSeparator)
     18 -> Prelude.return (WdDecimalSeparator)
     19 -> Prelude.return (WdThousandsSeparator)
     20 -> Prelude.return (WdCurrencyCode)
     21 -> Prelude.return (Wd24HourClock)
     22 -> Prelude.return (WdInternationalAM)
     23 -> Prelude.return (WdInternationalPM)
     24 -> Prelude.return (WdTimeSeparator)
     25 -> Prelude.return (WdDateSeparator)
     26 -> Prelude.return (WdProductLanguageID)
     _ -> Prelude.fail (Prelude.userError "unmarshallWdInternationalIndex: illegal enum value ")
data WdAutoMacros
 = WdAutoExec
 | WdAutoNew
 | WdAutoOpen
 | WdAutoClose
 | WdAutoExit
 
marshallWdAutoMacros :: WdAutoMacros -> Prelude.IO Int.Int16
marshallWdAutoMacros v =
  case v of
     WdAutoExec -> Prelude.return (0)
     WdAutoNew -> Prelude.return (1)
     WdAutoOpen -> Prelude.return (2)
     WdAutoClose -> Prelude.return (3)
     WdAutoExit -> Prelude.return (4)
unmarshallWdAutoMacros :: Int.Int16 -> Prelude.IO WdAutoMacros
unmarshallWdAutoMacros v =
  case v of
     0 -> Prelude.return (WdAutoExec)
     1 -> Prelude.return (WdAutoNew)
     2 -> Prelude.return (WdAutoOpen)
     3 -> Prelude.return (WdAutoClose)
     4 -> Prelude.return (WdAutoExit)
     _ -> Prelude.fail (Prelude.userError "unmarshallWdAutoMacros: illegal enum value ")
data WdCaptionPosition
 = WdCaptionPositionAbove
 | WdCaptionPositionBelow
 
marshallWdCaptionPosition :: WdCaptionPosition -> Prelude.IO Int.Int16
marshallWdCaptionPosition v =
  case v of
     WdCaptionPositionAbove -> Prelude.return (0)
     WdCaptionPositionBelow -> Prelude.return (1)
unmarshallWdCaptionPosition :: Int.Int16 -> Prelude.IO WdCaptionPosition
unmarshallWdCaptionPosition v =
  case v of
     0 -> Prelude.return (WdCaptionPositionAbove)
     1 -> Prelude.return (WdCaptionPositionBelow)
     _ -> Prelude.fail (Prelude.userError "unmarshallWdCaptionPosition: illegal enum value ")
data WdCountry
 = WdUS
 | WdCanada
 | WdLatinAmerica
 | WdNetherlands
 | WdFrance
 | WdSpain
 | WdItaly
 | WdUK
 | WdDenmark
 | WdSweden
 | WdNorway
 | WdGermany
 | WdPeru
 | WdMexico
 | WdArgentina
 | WdBrazil
 | WdChile
 | WdVenezuela
 | WdJapan
 | WdTaiwan
 | WdChina
 | WdKorea
 | WdFinland
 | WdIceland
 
marshallWdCountry :: WdCountry -> Prelude.IO Int.Int16
marshallWdCountry v =
  case v of
     WdUS -> Prelude.return (1)
     WdCanada -> Prelude.return (2)
     WdLatinAmerica -> Prelude.return (3)
     WdNetherlands -> Prelude.return (31)
     WdFrance -> Prelude.return (33)
     WdSpain -> Prelude.return (34)
     WdItaly -> Prelude.return (39)
     WdUK -> Prelude.return (44)
     WdDenmark -> Prelude.return (45)
     WdSweden -> Prelude.return (46)
     WdNorway -> Prelude.return (47)
     WdGermany -> Prelude.return (49)
     WdPeru -> Prelude.return (51)
     WdMexico -> Prelude.return (52)
     WdArgentina -> Prelude.return (54)
     WdBrazil -> Prelude.return (55)
     WdChile -> Prelude.return (56)
     WdVenezuela -> Prelude.return (58)
     WdJapan -> Prelude.return (81)
     WdTaiwan -> Prelude.return (886)
     WdChina -> Prelude.return (86)
     WdKorea -> Prelude.return (82)
     WdFinland -> Prelude.return (358)
     WdIceland -> Prelude.return (354)
unmarshallWdCountry :: Int.Int16 -> Prelude.IO WdCountry
unmarshallWdCountry v =
  case v of
     1 -> Prelude.return (WdUS)
     2 -> Prelude.return (WdCanada)
     3 -> Prelude.return (WdLatinAmerica)
     31 -> Prelude.return (WdNetherlands)
     33 -> Prelude.return (WdFrance)
     34 -> Prelude.return (WdSpain)
     39 -> Prelude.return (WdItaly)
     44 -> Prelude.return (WdUK)
     45 -> Prelude.return (WdDenmark)
     46 -> Prelude.return (WdSweden)
     47 -> Prelude.return (WdNorway)
     49 -> Prelude.return (WdGermany)
     51 -> Prelude.return (WdPeru)
     52 -> Prelude.return (WdMexico)
     54 -> Prelude.return (WdArgentina)
     55 -> Prelude.return (WdBrazil)
     56 -> Prelude.return (WdChile)
     58 -> Prelude.return (WdVenezuela)
     81 -> Prelude.return (WdJapan)
     886 -> Prelude.return (WdTaiwan)
     86 -> Prelude.return (WdChina)
     82 -> Prelude.return (WdKorea)
     358 -> Prelude.return (WdFinland)
     354 -> Prelude.return (WdIceland)
     _ -> Prelude.fail (Prelude.userError "unmarshallWdCountry: illegal enum value ")
data WdHeadingSeparator
 = WdHeadingSeparatorNone
 | WdHeadingSeparatorBlankLine
 | WdHeadingSeparatorLetter
 | WdHeadingSeparatorLetterLow
 | WdHeadingSeparatorLetterFull
 
marshallWdHeadingSeparator :: WdHeadingSeparator -> Prelude.IO Int.Int16
marshallWdHeadingSeparator v =
  case v of
     WdHeadingSeparatorNone -> Prelude.return (0)
     WdHeadingSeparatorBlankLine -> Prelude.return (1)
     WdHeadingSeparatorLetter -> Prelude.return (2)
     WdHeadingSeparatorLetterLow -> Prelude.return (3)
     WdHeadingSeparatorLetterFull -> Prelude.return (4)
unmarshallWdHeadingSeparator :: Int.Int16 -> Prelude.IO WdHeadingSeparator
unmarshallWdHeadingSeparator v =
  case v of
     0 -> Prelude.return (WdHeadingSeparatorNone)
     1 -> Prelude.return (WdHeadingSeparatorBlankLine)
     2 -> Prelude.return (WdHeadingSeparatorLetter)
     3 -> Prelude.return (WdHeadingSeparatorLetterLow)
     4 -> Prelude.return (WdHeadingSeparatorLetterFull)
     _ -> Prelude.fail (Prelude.userError "unmarshallWdHeadingSeparator: illegal enum value ")
data WdSeparatorType
 = WdSeparatorHyphen
 | WdSeparatorPeriod
 | WdSeparatorColon
 | WdSeparatorEmDash
 | WdSeparatorEnDash
 
marshallWdSeparatorType :: WdSeparatorType -> Prelude.IO Int.Int16
marshallWdSeparatorType v =
  case v of
     WdSeparatorHyphen -> Prelude.return (0)
     WdSeparatorPeriod -> Prelude.return (1)
     WdSeparatorColon -> Prelude.return (2)
     WdSeparatorEmDash -> Prelude.return (3)
     WdSeparatorEnDash -> Prelude.return (4)
unmarshallWdSeparatorType :: Int.Int16 -> Prelude.IO WdSeparatorType
unmarshallWdSeparatorType v =
  case v of
     0 -> Prelude.return (WdSeparatorHyphen)
     1 -> Prelude.return (WdSeparatorPeriod)
     2 -> Prelude.return (WdSeparatorColon)
     3 -> Prelude.return (WdSeparatorEmDash)
     4 -> Prelude.return (WdSeparatorEnDash)
     _ -> Prelude.fail (Prelude.userError "unmarshallWdSeparatorType: illegal enum value ")
data WdPageNumberAlignment
 = WdAlignPageNumberLeft
 | WdAlignPageNumberCenter
 | WdAlignPageNumberRight
 | WdAlignPageNumberInside
 | WdAlignPageNumberOutside
 
marshallWdPageNumberAlignment :: WdPageNumberAlignment -> Prelude.IO Int.Int16
marshallWdPageNumberAlignment v =
  case v of
     WdAlignPageNumberLeft -> Prelude.return (0)
     WdAlignPageNumberCenter -> Prelude.return (1)
     WdAlignPageNumberRight -> Prelude.return (2)
     WdAlignPageNumberInside -> Prelude.return (3)
     WdAlignPageNumberOutside -> Prelude.return (4)
unmarshallWdPageNumberAlignment :: Int.Int16 -> Prelude.IO WdPageNumberAlignment
unmarshallWdPageNumberAlignment v =
  case v of
     0 -> Prelude.return (WdAlignPageNumberLeft)
     1 -> Prelude.return (WdAlignPageNumberCenter)
     2 -> Prelude.return (WdAlignPageNumberRight)
     3 -> Prelude.return (WdAlignPageNumberInside)
     4 -> Prelude.return (WdAlignPageNumberOutside)
     _ -> Prelude.fail (Prelude.userError "unmarshallWdPageNumberAlignment: illegal enum value ")
data WdBorderType
 = WdBorderTop
 | WdBorderLeft
 | WdBorderBottom
 | WdBorderRight
 | WdBorderHorizontal
 | WdBorderVertical
 
marshallWdBorderType :: WdBorderType -> Prelude.IO Int.Int16
marshallWdBorderType v =
  case v of
     WdBorderTop -> Prelude.return ((-1))
     WdBorderLeft -> Prelude.return ((-2))
     WdBorderBottom -> Prelude.return ((-3))
     WdBorderRight -> Prelude.return ((-4))
     WdBorderHorizontal -> Prelude.return ((-5))
     WdBorderVertical -> Prelude.return ((-6))
unmarshallWdBorderType :: Int.Int16 -> Prelude.IO WdBorderType
unmarshallWdBorderType v =
  case v of
     (-1) -> Prelude.return (WdBorderTop)
     (-2) -> Prelude.return (WdBorderLeft)
     (-3) -> Prelude.return (WdBorderBottom)
     (-4) -> Prelude.return (WdBorderRight)
     (-5) -> Prelude.return (WdBorderHorizontal)
     (-6) -> Prelude.return (WdBorderVertical)
     _ -> Prelude.fail (Prelude.userError "unmarshallWdBorderType: illegal enum value ")
data WdBorderTypeHID
 = WdBorderDiagonalDown
 | WdBorderDiagonalUp
 
marshallWdBorderTypeHID :: WdBorderTypeHID -> Prelude.IO Int.Int16
marshallWdBorderTypeHID v =
  case v of
     WdBorderDiagonalDown -> Prelude.return ((-7))
     WdBorderDiagonalUp -> Prelude.return ((-8))
unmarshallWdBorderTypeHID :: Int.Int16 -> Prelude.IO WdBorderTypeHID
unmarshallWdBorderTypeHID v =
  case v of
     (-7) -> Prelude.return (WdBorderDiagonalDown)
     (-8) -> Prelude.return (WdBorderDiagonalUp)
     _ -> Prelude.fail (Prelude.userError "unmarshallWdBorderTypeHID: illegal enum value ")
data WdFramePosition
 = WdFrameTop
 | WdFrameLeft
 | WdFrameBottom
 | WdFrameRight
 | WdFrameCenter
 | WdFrameInside
 | WdFrameOutside
 
marshallWdFramePosition :: WdFramePosition -> Prelude.IO Int.Int16
marshallWdFramePosition v =
  case v of
     WdFrameTop -> Prelude.return ((-999999))
     WdFrameLeft -> Prelude.return ((-999998))
     WdFrameBottom -> Prelude.return ((-999997))
     WdFrameRight -> Prelude.return ((-999996))
     WdFrameCenter -> Prelude.return ((-999995))
     WdFrameInside -> Prelude.return ((-999994))
     WdFrameOutside -> Prelude.return ((-999993))
unmarshallWdFramePosition :: Int.Int16 -> Prelude.IO WdFramePosition
unmarshallWdFramePosition v =
  case v of
     (-999999) -> Prelude.return (WdFrameTop)
     (-999998) -> Prelude.return (WdFrameLeft)
     (-999997) -> Prelude.return (WdFrameBottom)
     (-999996) -> Prelude.return (WdFrameRight)
     (-999995) -> Prelude.return (WdFrameCenter)
     (-999994) -> Prelude.return (WdFrameInside)
     (-999993) -> Prelude.return (WdFrameOutside)
     _ -> Prelude.fail (Prelude.userError "unmarshallWdFramePosition: illegal enum value ")
data WdAnimation
 = WdAnimationNone
 | WdAnimationLasVegasLights
 | WdAnimationBlinkingBackground
 | WdAnimationSparkleText
 | WdAnimationMarchingBlackAnts
 | WdAnimationMarchingRedAnts
 | WdAnimationShimmer
 
marshallWdAnimation :: WdAnimation -> Prelude.IO Int.Int16
marshallWdAnimation v =
  case v of
     WdAnimationNone -> Prelude.return (0)
     WdAnimationLasVegasLights -> Prelude.return (1)
     WdAnimationBlinkingBackground -> Prelude.return (2)
     WdAnimationSparkleText -> Prelude.return (3)
     WdAnimationMarchingBlackAnts -> Prelude.return (4)
     WdAnimationMarchingRedAnts -> Prelude.return (5)
     WdAnimationShimmer -> Prelude.return (6)
unmarshallWdAnimation :: Int.Int16 -> Prelude.IO WdAnimation
unmarshallWdAnimation v =
  case v of
     0 -> Prelude.return (WdAnimationNone)
     1 -> Prelude.return (WdAnimationLasVegasLights)
     2 -> Prelude.return (WdAnimationBlinkingBackground)
     3 -> Prelude.return (WdAnimationSparkleText)
     4 -> Prelude.return (WdAnimationMarchingBlackAnts)
     5 -> Prelude.return (WdAnimationMarchingRedAnts)
     6 -> Prelude.return (WdAnimationShimmer)
     _ -> Prelude.fail (Prelude.userError "unmarshallWdAnimation: illegal enum value ")
data WdCharacterCase
 = WdNextCase
 | WdLowerCase
 | WdUpperCase
 | WdTitleWord
 | WdTitleSentence
 | WdToggleCase
 
marshallWdCharacterCase :: WdCharacterCase -> Prelude.IO Int.Int16
marshallWdCharacterCase v =
  case v of
     WdNextCase -> Prelude.return ((-1))
     WdLowerCase -> Prelude.return (0)
     WdUpperCase -> Prelude.return (1)
     WdTitleWord -> Prelude.return (2)
     WdTitleSentence -> Prelude.return (4)
     WdToggleCase -> Prelude.return (5)
unmarshallWdCharacterCase :: Int.Int16 -> Prelude.IO WdCharacterCase
unmarshallWdCharacterCase v =
  case v of
     (-1) -> Prelude.return (WdNextCase)
     0 -> Prelude.return (WdLowerCase)
     1 -> Prelude.return (WdUpperCase)
     2 -> Prelude.return (WdTitleWord)
     4 -> Prelude.return (WdTitleSentence)
     5 -> Prelude.return (WdToggleCase)
     _ -> Prelude.fail (Prelude.userError "unmarshallWdCharacterCase: illegal enum value ")
data WdCharacterCaseHID
 = WdHalfWidth
 | WdFullWidth
 | WdKatakana
 | WdHiragana
 
marshallWdCharacterCaseHID :: WdCharacterCaseHID -> Prelude.IO Int.Int16
marshallWdCharacterCaseHID v =
  case v of
     WdHalfWidth -> Prelude.return (6)
     WdFullWidth -> Prelude.return (7)
     WdKatakana -> Prelude.return (8)
     WdHiragana -> Prelude.return (9)
unmarshallWdCharacterCaseHID :: Int.Int16 -> Prelude.IO WdCharacterCaseHID
unmarshallWdCharacterCaseHID v =
  case v of
     6 -> Prelude.return (WdHalfWidth)
     7 -> Prelude.return (WdFullWidth)
     8 -> Prelude.return (WdKatakana)
     9 -> Prelude.return (WdHiragana)
     _ -> Prelude.fail (Prelude.userError "unmarshallWdCharacterCaseHID: illegal enum value ")
data WdSummaryMode
 = WdSummaryModeHighlight
 | WdSummaryModeHideAllButSummary
 | WdSummaryModeInsert
 | WdSummaryModeCreateNew
 
marshallWdSummaryMode :: WdSummaryMode -> Prelude.IO Int.Int16
marshallWdSummaryMode v =
  case v of
     WdSummaryModeHighlight -> Prelude.return (0)
     WdSummaryModeHideAllButSummary -> Prelude.return (1)
     WdSummaryModeInsert -> Prelude.return (2)
     WdSummaryModeCreateNew -> Prelude.return (3)
unmarshallWdSummaryMode :: Int.Int16 -> Prelude.IO WdSummaryMode
unmarshallWdSummaryMode v =
  case v of
     0 -> Prelude.return (WdSummaryModeHighlight)
     1 -> Prelude.return (WdSummaryModeHideAllButSummary)
     2 -> Prelude.return (WdSummaryModeInsert)
     3 -> Prelude.return (WdSummaryModeCreateNew)
     _ -> Prelude.fail (Prelude.userError "unmarshallWdSummaryMode: illegal enum value ")
data WdSummaryLength
 = Wd10Sentences
 | Wd20Sentences
 | Wd100Words
 | Wd500Words
 | Wd10Percent
 | Wd25Percent
 | Wd50Percent
 | Wd75Percent
 
marshallWdSummaryLength :: WdSummaryLength -> Prelude.IO Int.Int16
marshallWdSummaryLength v =
  case v of
     Wd10Sentences -> Prelude.return ((-2))
     Wd20Sentences -> Prelude.return ((-3))
     Wd100Words -> Prelude.return ((-4))
     Wd500Words -> Prelude.return ((-5))
     Wd10Percent -> Prelude.return ((-6))
     Wd25Percent -> Prelude.return ((-7))
     Wd50Percent -> Prelude.return ((-8))
     Wd75Percent -> Prelude.return ((-9))
unmarshallWdSummaryLength :: Int.Int16 -> Prelude.IO WdSummaryLength
unmarshallWdSummaryLength v =
  case v of
     (-2) -> Prelude.return (Wd10Sentences)
     (-3) -> Prelude.return (Wd20Sentences)
     (-4) -> Prelude.return (Wd100Words)
     (-5) -> Prelude.return (Wd500Words)
     (-6) -> Prelude.return (Wd10Percent)
     (-7) -> Prelude.return (Wd25Percent)
     (-8) -> Prelude.return (Wd50Percent)
     (-9) -> Prelude.return (Wd75Percent)
     _ -> Prelude.fail (Prelude.userError "unmarshallWdSummaryLength: illegal enum value ")
data WdStyleType
 = WdStyleTypeParagraph
 | WdStyleTypeCharacter
 
marshallWdStyleType :: WdStyleType -> Prelude.IO Int.Int16
marshallWdStyleType v =
  case v of
     WdStyleTypeParagraph -> Prelude.return (1)
     WdStyleTypeCharacter -> Prelude.return (2)
unmarshallWdStyleType :: Int.Int16 -> Prelude.IO WdStyleType
unmarshallWdStyleType v =
  case v of
     1 -> Prelude.return (WdStyleTypeParagraph)
     2 -> Prelude.return (WdStyleTypeCharacter)
     _ -> Prelude.fail (Prelude.userError "unmarshallWdStyleType: illegal enum value ")
data WdUnits
 = WdCharacter
 | WdWord
 | WdSentence
 | WdParagraph
 | WdLine
 | WdStory
 | WdScreen
 | WdSection
 | WdColumn
 | WdRow
 | WdWindow
 | WdCell
 | WdCharacterFormatting
 | WdParagraphFormatting
 | WdTable
 | WdItem
 
marshallWdUnits :: WdUnits -> Prelude.IO Int.Int16
marshallWdUnits v =
  case v of
     WdCharacter -> Prelude.return (1)
     WdWord -> Prelude.return (2)
     WdSentence -> Prelude.return (3)
     WdParagraph -> Prelude.return (4)
     WdLine -> Prelude.return (5)
     WdStory -> Prelude.return (6)
     WdScreen -> Prelude.return (7)
     WdSection -> Prelude.return (8)
     WdColumn -> Prelude.return (9)
     WdRow -> Prelude.return (10)
     WdWindow -> Prelude.return (11)
     WdCell -> Prelude.return (12)
     WdCharacterFormatting -> Prelude.return (13)
     WdParagraphFormatting -> Prelude.return (14)
     WdTable -> Prelude.return (15)
     WdItem -> Prelude.return (16)
unmarshallWdUnits :: Int.Int16 -> Prelude.IO WdUnits
unmarshallWdUnits v =
  case v of
     1 -> Prelude.return (WdCharacter)
     2 -> Prelude.return (WdWord)
     3 -> Prelude.return (WdSentence)
     4 -> Prelude.return (WdParagraph)
     5 -> Prelude.return (WdLine)
     6 -> Prelude.return (WdStory)
     7 -> Prelude.return (WdScreen)
     8 -> Prelude.return (WdSection)
     9 -> Prelude.return (WdColumn)
     10 -> Prelude.return (WdRow)
     11 -> Prelude.return (WdWindow)
     12 -> Prelude.return (WdCell)
     13 -> Prelude.return (WdCharacterFormatting)
     14 -> Prelude.return (WdParagraphFormatting)
     15 -> Prelude.return (WdTable)
     16 -> Prelude.return (WdItem)
     _ -> Prelude.fail (Prelude.userError "unmarshallWdUnits: illegal enum value ")
data WdGoToItem
 = WdGoToBookmark
 | WdGoToSection
 | WdGoToPage
 | WdGoToTable
 | WdGoToLine
 | WdGoToFootnote
 | WdGoToEndnote
 | WdGoToComment
 | WdGoToField
 | WdGoToGraphic
 | WdGoToObject
 | WdGoToEquation
 | WdGoToHeading
 | WdGoToPercent
 | WdGoToSpellingError
 | WdGoToGrammaticalError
 | WdGoToProofreadingError
 
marshallWdGoToItem :: WdGoToItem -> Prelude.IO Int.Int16
marshallWdGoToItem v =
  case v of
     WdGoToBookmark -> Prelude.return ((-1))
     WdGoToSection -> Prelude.return (0)
     WdGoToPage -> Prelude.return (1)
     WdGoToTable -> Prelude.return (2)
     WdGoToLine -> Prelude.return (3)
     WdGoToFootnote -> Prelude.return (4)
     WdGoToEndnote -> Prelude.return (5)
     WdGoToComment -> Prelude.return (6)
     WdGoToField -> Prelude.return (7)
     WdGoToGraphic -> Prelude.return (8)
     WdGoToObject -> Prelude.return (9)
     WdGoToEquation -> Prelude.return (10)
     WdGoToHeading -> Prelude.return (11)
     WdGoToPercent -> Prelude.return (12)
     WdGoToSpellingError -> Prelude.return (13)
     WdGoToGrammaticalError -> Prelude.return (14)
     WdGoToProofreadingError -> Prelude.return (15)
unmarshallWdGoToItem :: Int.Int16 -> Prelude.IO WdGoToItem
unmarshallWdGoToItem v =
  case v of
     (-1) -> Prelude.return (WdGoToBookmark)
     0 -> Prelude.return (WdGoToSection)
     1 -> Prelude.return (WdGoToPage)
     2 -> Prelude.return (WdGoToTable)
     3 -> Prelude.return (WdGoToLine)
     4 -> Prelude.return (WdGoToFootnote)
     5 -> Prelude.return (WdGoToEndnote)
     6 -> Prelude.return (WdGoToComment)
     7 -> Prelude.return (WdGoToField)
     8 -> Prelude.return (WdGoToGraphic)
     9 -> Prelude.return (WdGoToObject)
     10 -> Prelude.return (WdGoToEquation)
     11 -> Prelude.return (WdGoToHeading)
     12 -> Prelude.return (WdGoToPercent)
     13 -> Prelude.return (WdGoToSpellingError)
     14 -> Prelude.return (WdGoToGrammaticalError)
     15 -> Prelude.return (WdGoToProofreadingError)
     _ -> Prelude.fail (Prelude.userError "unmarshallWdGoToItem: illegal enum value ")
data WdGoToDirection
 = WdGoToFirst
 | WdGoToLast
 | WdGoToNext
 | WdGoToRelative
 | WdGoToPrevious
 | WdGoToAbsolute
 
marshallWdGoToDirection :: WdGoToDirection -> Prelude.IO Int.Int16
marshallWdGoToDirection v =
  case v of
     WdGoToFirst -> Prelude.return (1)
     WdGoToLast -> Prelude.return ((-1))
     WdGoToNext -> Prelude.return (2)
     WdGoToRelative -> Prelude.return (2)
     WdGoToPrevious -> Prelude.return (3)
     WdGoToAbsolute -> Prelude.return (1)
unmarshallWdGoToDirection :: Int.Int16 -> Prelude.IO WdGoToDirection
unmarshallWdGoToDirection v =
  case v of
     1 -> Prelude.return (WdGoToFirst)
     (-1) -> Prelude.return (WdGoToLast)
     2 -> Prelude.return (WdGoToNext)
     2 -> Prelude.return (WdGoToRelative)
     3 -> Prelude.return (WdGoToPrevious)
     1 -> Prelude.return (WdGoToAbsolute)
     _ -> Prelude.fail (Prelude.userError "unmarshallWdGoToDirection: illegal enum value ")
data WdCollapseDirection
 = WdCollapseStart
 | WdCollapseEnd
 
marshallWdCollapseDirection :: WdCollapseDirection -> Prelude.IO Int.Int16
marshallWdCollapseDirection v =
  case v of
     WdCollapseStart -> Prelude.return (1)
     WdCollapseEnd -> Prelude.return (0)
unmarshallWdCollapseDirection :: Int.Int16 -> Prelude.IO WdCollapseDirection
unmarshallWdCollapseDirection v =
  case v of
     1 -> Prelude.return (WdCollapseStart)
     0 -> Prelude.return (WdCollapseEnd)
     _ -> Prelude.fail (Prelude.userError "unmarshallWdCollapseDirection: illegal enum value ")
data WdRowHeightRule
 = WdRowHeightAuto
 | WdRowHeightAtLeast
 | WdRowHeightExactly
 
marshallWdRowHeightRule :: WdRowHeightRule -> Prelude.IO Int.Int16
marshallWdRowHeightRule v =
  case v of
     WdRowHeightAuto -> Prelude.return (0)
     WdRowHeightAtLeast -> Prelude.return (1)
     WdRowHeightExactly -> Prelude.return (2)
unmarshallWdRowHeightRule :: Int.Int16 -> Prelude.IO WdRowHeightRule
unmarshallWdRowHeightRule v =
  case v of
     0 -> Prelude.return (WdRowHeightAuto)
     1 -> Prelude.return (WdRowHeightAtLeast)
     2 -> Prelude.return (WdRowHeightExactly)
     _ -> Prelude.fail (Prelude.userError "unmarshallWdRowHeightRule: illegal enum value ")
data WdFrameSizeRule
 = WdFrameAuto
 | WdFrameAtLeast
 | WdFrameExact
 
marshallWdFrameSizeRule :: WdFrameSizeRule -> Prelude.IO Int.Int16
marshallWdFrameSizeRule v =
  case v of
     WdFrameAuto -> Prelude.return (0)
     WdFrameAtLeast -> Prelude.return (1)
     WdFrameExact -> Prelude.return (2)
unmarshallWdFrameSizeRule :: Int.Int16 -> Prelude.IO WdFrameSizeRule
unmarshallWdFrameSizeRule v =
  case v of
     0 -> Prelude.return (WdFrameAuto)
     1 -> Prelude.return (WdFrameAtLeast)
     2 -> Prelude.return (WdFrameExact)
     _ -> Prelude.fail (Prelude.userError "unmarshallWdFrameSizeRule: illegal enum value ")
data WdInsertCells
 = WdInsertCellsShiftRight
 | WdInsertCellsShiftDown
 | WdInsertCellsEntireRow
 | WdInsertCellsEntireColumn
 
marshallWdInsertCells :: WdInsertCells -> Prelude.IO Int.Int16
marshallWdInsertCells v =
  case v of
     WdInsertCellsShiftRight -> Prelude.return (0)
     WdInsertCellsShiftDown -> Prelude.return (1)
     WdInsertCellsEntireRow -> Prelude.return (2)
     WdInsertCellsEntireColumn -> Prelude.return (3)
unmarshallWdInsertCells :: Int.Int16 -> Prelude.IO WdInsertCells
unmarshallWdInsertCells v =
  case v of
     0 -> Prelude.return (WdInsertCellsShiftRight)
     1 -> Prelude.return (WdInsertCellsShiftDown)
     2 -> Prelude.return (WdInsertCellsEntireRow)
     3 -> Prelude.return (WdInsertCellsEntireColumn)
     _ -> Prelude.fail (Prelude.userError "unmarshallWdInsertCells: illegal enum value ")
data WdDeleteCells
 = WdDeleteCellsShiftLeft
 | WdDeleteCellsShiftUp
 | WdDeleteCellsEntireRow
 | WdDeleteCellsEntireColumn
 
marshallWdDeleteCells :: WdDeleteCells -> Prelude.IO Int.Int16
marshallWdDeleteCells v =
  case v of
     WdDeleteCellsShiftLeft -> Prelude.return (0)
     WdDeleteCellsShiftUp -> Prelude.return (1)
     WdDeleteCellsEntireRow -> Prelude.return (2)
     WdDeleteCellsEntireColumn -> Prelude.return (3)
unmarshallWdDeleteCells :: Int.Int16 -> Prelude.IO WdDeleteCells
unmarshallWdDeleteCells v =
  case v of
     0 -> Prelude.return (WdDeleteCellsShiftLeft)
     1 -> Prelude.return (WdDeleteCellsShiftUp)
     2 -> Prelude.return (WdDeleteCellsEntireRow)
     3 -> Prelude.return (WdDeleteCellsEntireColumn)
     _ -> Prelude.fail (Prelude.userError "unmarshallWdDeleteCells: illegal enum value ")
data WdListApplyTo
 = WdListApplyToWholeList
 | WdListApplyToThisPointForward
 | WdListApplyToSelection
 
marshallWdListApplyTo :: WdListApplyTo -> Prelude.IO Int.Int16
marshallWdListApplyTo v =
  case v of
     WdListApplyToWholeList -> Prelude.return (0)
     WdListApplyToThisPointForward -> Prelude.return (1)
     WdListApplyToSelection -> Prelude.return (2)
unmarshallWdListApplyTo :: Int.Int16 -> Prelude.IO WdListApplyTo
unmarshallWdListApplyTo v =
  case v of
     0 -> Prelude.return (WdListApplyToWholeList)
     1 -> Prelude.return (WdListApplyToThisPointForward)
     2 -> Prelude.return (WdListApplyToSelection)
     _ -> Prelude.fail (Prelude.userError "unmarshallWdListApplyTo: illegal enum value ")
data WdAlertLevel
 = WdAlertsNone
 | WdAlertsMessageBox
 | WdAlertsAll
 
marshallWdAlertLevel :: WdAlertLevel -> Prelude.IO Int.Int16
marshallWdAlertLevel v =
  case v of
     WdAlertsNone -> Prelude.return (0)
     WdAlertsMessageBox -> Prelude.return ((-2))
     WdAlertsAll -> Prelude.return ((-1))
unmarshallWdAlertLevel :: Int.Int16 -> Prelude.IO WdAlertLevel
unmarshallWdAlertLevel v =
  case v of
     0 -> Prelude.return (WdAlertsNone)
     (-2) -> Prelude.return (WdAlertsMessageBox)
     (-1) -> Prelude.return (WdAlertsAll)
     _ -> Prelude.fail (Prelude.userError "unmarshallWdAlertLevel: illegal enum value ")
data WdCursorType
 = WdCursorWait
 | WdCursorIBeam
 | WdCursorNormal
 | WdCursorNorthwestArrow
 
marshallWdCursorType :: WdCursorType -> Prelude.IO Int.Int16
marshallWdCursorType v =
  case v of
     WdCursorWait -> Prelude.return (0)
     WdCursorIBeam -> Prelude.return (1)
     WdCursorNormal -> Prelude.return (2)
     WdCursorNorthwestArrow -> Prelude.return (3)
unmarshallWdCursorType :: Int.Int16 -> Prelude.IO WdCursorType
unmarshallWdCursorType v =
  case v of
     0 -> Prelude.return (WdCursorWait)
     1 -> Prelude.return (WdCursorIBeam)
     2 -> Prelude.return (WdCursorNormal)
     3 -> Prelude.return (WdCursorNorthwestArrow)
     _ -> Prelude.fail (Prelude.userError "unmarshallWdCursorType: illegal enum value ")
data WdEnableCancelKey
 = WdCancelDisabled
 | WdCancelInterrupt
 
marshallWdEnableCancelKey :: WdEnableCancelKey -> Prelude.IO Int.Int16
marshallWdEnableCancelKey v =
  case v of
     WdCancelDisabled -> Prelude.return (0)
     WdCancelInterrupt -> Prelude.return (1)
unmarshallWdEnableCancelKey :: Int.Int16 -> Prelude.IO WdEnableCancelKey
unmarshallWdEnableCancelKey v =
  case v of
     0 -> Prelude.return (WdCancelDisabled)
     1 -> Prelude.return (WdCancelInterrupt)
     _ -> Prelude.fail (Prelude.userError "unmarshallWdEnableCancelKey: illegal enum value ")
data WdRulerStyle
 = WdAdjustNone
 | WdAdjustProportional
 | WdAdjustFirstColumn
 | WdAdjustSameWidth
 
marshallWdRulerStyle :: WdRulerStyle -> Prelude.IO Int.Int16
marshallWdRulerStyle v =
  case v of
     WdAdjustNone -> Prelude.return (0)
     WdAdjustProportional -> Prelude.return (1)
     WdAdjustFirstColumn -> Prelude.return (2)
     WdAdjustSameWidth -> Prelude.return (3)
unmarshallWdRulerStyle :: Int.Int16 -> Prelude.IO WdRulerStyle
unmarshallWdRulerStyle v =
  case v of
     0 -> Prelude.return (WdAdjustNone)
     1 -> Prelude.return (WdAdjustProportional)
     2 -> Prelude.return (WdAdjustFirstColumn)
     3 -> Prelude.return (WdAdjustSameWidth)
     _ -> Prelude.fail (Prelude.userError "unmarshallWdRulerStyle: illegal enum value ")
data WdParagraphAlignment
 = WdAlignParagraphLeft
 | WdAlignParagraphCenter
 | WdAlignParagraphRight
 | WdAlignParagraphJustify
 
marshallWdParagraphAlignment :: WdParagraphAlignment -> Prelude.IO Int.Int16
marshallWdParagraphAlignment v =
  case v of
     WdAlignParagraphLeft -> Prelude.return (0)
     WdAlignParagraphCenter -> Prelude.return (1)
     WdAlignParagraphRight -> Prelude.return (2)
     WdAlignParagraphJustify -> Prelude.return (3)
unmarshallWdParagraphAlignment :: Int.Int16 -> Prelude.IO WdParagraphAlignment
unmarshallWdParagraphAlignment v =
  case v of
     0 -> Prelude.return (WdAlignParagraphLeft)
     1 -> Prelude.return (WdAlignParagraphCenter)
     2 -> Prelude.return (WdAlignParagraphRight)
     3 -> Prelude.return (WdAlignParagraphJustify)
     _ -> Prelude.fail (Prelude.userError "unmarshallWdParagraphAlignment: illegal enum value ")
data WdParagraphAlignmentHID = WdAlignParagraphDistribute
                                
marshallWdParagraphAlignmentHID :: WdParagraphAlignmentHID -> Prelude.IO Int.Int16
marshallWdParagraphAlignmentHID v =
  case v of
     WdAlignParagraphDistribute -> Prelude.return (4)
unmarshallWdParagraphAlignmentHID :: Int.Int16 -> Prelude.IO WdParagraphAlignmentHID
unmarshallWdParagraphAlignmentHID v =
  case v of
     4 -> Prelude.return (WdAlignParagraphDistribute)
     _ -> Prelude.fail (Prelude.userError "unmarshallWdParagraphAlignmentHID: illegal enum value ")
data WdListLevelAlignment
 = WdListLevelAlignLeft
 | WdListLevelAlignCenter
 | WdListLevelAlignRight
 
marshallWdListLevelAlignment :: WdListLevelAlignment -> Prelude.IO Int.Int16
marshallWdListLevelAlignment v =
  case v of
     WdListLevelAlignLeft -> Prelude.return (0)
     WdListLevelAlignCenter -> Prelude.return (1)
     WdListLevelAlignRight -> Prelude.return (2)
unmarshallWdListLevelAlignment :: Int.Int16 -> Prelude.IO WdListLevelAlignment
unmarshallWdListLevelAlignment v =
  case v of
     0 -> Prelude.return (WdListLevelAlignLeft)
     1 -> Prelude.return (WdListLevelAlignCenter)
     2 -> Prelude.return (WdListLevelAlignRight)
     _ -> Prelude.fail (Prelude.userError "unmarshallWdListLevelAlignment: illegal enum value ")
data WdRowAlignment
 = WdAlignRowLeft
 | WdAlignRowCenter
 | WdAlignRowRight
 
marshallWdRowAlignment :: WdRowAlignment -> Prelude.IO Int.Int16
marshallWdRowAlignment v =
  case v of
     WdAlignRowLeft -> Prelude.return (0)
     WdAlignRowCenter -> Prelude.return (1)
     WdAlignRowRight -> Prelude.return (2)
unmarshallWdRowAlignment :: Int.Int16 -> Prelude.IO WdRowAlignment
unmarshallWdRowAlignment v =
  case v of
     0 -> Prelude.return (WdAlignRowLeft)
     1 -> Prelude.return (WdAlignRowCenter)
     2 -> Prelude.return (WdAlignRowRight)
     _ -> Prelude.fail (Prelude.userError "unmarshallWdRowAlignment: illegal enum value ")
data WdTabAlignment
 = WdAlignTabLeft
 | WdAlignTabCenter
 | WdAlignTabRight
 | WdAlignTabDecimal
 | WdAlignTabBar
 | WdAlignTabList
 
marshallWdTabAlignment :: WdTabAlignment -> Prelude.IO Int.Int16
marshallWdTabAlignment v =
  case v of
     WdAlignTabLeft -> Prelude.return (0)
     WdAlignTabCenter -> Prelude.return (1)
     WdAlignTabRight -> Prelude.return (2)
     WdAlignTabDecimal -> Prelude.return (3)
     WdAlignTabBar -> Prelude.return (4)
     WdAlignTabList -> Prelude.return (6)
unmarshallWdTabAlignment :: Int.Int16 -> Prelude.IO WdTabAlignment
unmarshallWdTabAlignment v =
  case v of
     0 -> Prelude.return (WdAlignTabLeft)
     1 -> Prelude.return (WdAlignTabCenter)
     2 -> Prelude.return (WdAlignTabRight)
     3 -> Prelude.return (WdAlignTabDecimal)
     4 -> Prelude.return (WdAlignTabBar)
     6 -> Prelude.return (WdAlignTabList)
     _ -> Prelude.fail (Prelude.userError "unmarshallWdTabAlignment: illegal enum value ")
data WdVerticalAlignment
 = WdAlignVerticalTop
 | WdAlignVerticalCenter
 | WdAlignVerticalJustify
 | WdAlignVerticalBottom
 
marshallWdVerticalAlignment :: WdVerticalAlignment -> Prelude.IO Int.Int16
marshallWdVerticalAlignment v =
  case v of
     WdAlignVerticalTop -> Prelude.return (0)
     WdAlignVerticalCenter -> Prelude.return (1)
     WdAlignVerticalJustify -> Prelude.return (2)
     WdAlignVerticalBottom -> Prelude.return (3)
unmarshallWdVerticalAlignment :: Int.Int16 -> Prelude.IO WdVerticalAlignment
unmarshallWdVerticalAlignment v =
  case v of
     0 -> Prelude.return (WdAlignVerticalTop)
     1 -> Prelude.return (WdAlignVerticalCenter)
     2 -> Prelude.return (WdAlignVerticalJustify)
     3 -> Prelude.return (WdAlignVerticalBottom)
     _ -> Prelude.fail (Prelude.userError "unmarshallWdVerticalAlignment: illegal enum value ")
data WdCellVerticalAlignment
 = WdCellAlignVerticalTop
 | WdCellAlignVerticalCenter
 | WdCellAlignVerticalBottom
 
marshallWdCellVerticalAlignment :: WdCellVerticalAlignment -> Prelude.IO Int.Int16
marshallWdCellVerticalAlignment v =
  case v of
     WdCellAlignVerticalTop -> Prelude.return (0)
     WdCellAlignVerticalCenter -> Prelude.return (1)
     WdCellAlignVerticalBottom -> Prelude.return (3)
unmarshallWdCellVerticalAlignment :: Int.Int16 -> Prelude.IO WdCellVerticalAlignment
unmarshallWdCellVerticalAlignment v =
  case v of
     0 -> Prelude.return (WdCellAlignVerticalTop)
     1 -> Prelude.return (WdCellAlignVerticalCenter)
     3 -> Prelude.return (WdCellAlignVerticalBottom)
     _ -> Prelude.fail (Prelude.userError "unmarshallWdCellVerticalAlignment: illegal enum value ")
data WdTrailingCharacter
 = WdTrailingTab
 | WdTrailingSpace
 | WdTrailingNone
 
marshallWdTrailingCharacter :: WdTrailingCharacter -> Prelude.IO Int.Int16
marshallWdTrailingCharacter v =
  case v of
     WdTrailingTab -> Prelude.return (0)
     WdTrailingSpace -> Prelude.return (1)
     WdTrailingNone -> Prelude.return (2)
unmarshallWdTrailingCharacter :: Int.Int16 -> Prelude.IO WdTrailingCharacter
unmarshallWdTrailingCharacter v =
  case v of
     0 -> Prelude.return (WdTrailingTab)
     1 -> Prelude.return (WdTrailingSpace)
     2 -> Prelude.return (WdTrailingNone)
     _ -> Prelude.fail (Prelude.userError "unmarshallWdTrailingCharacter: illegal enum value ")
data WdListGalleryType
 = WdBulletGallery
 | WdNumberGallery
 | WdOutlineNumberGallery
 
marshallWdListGalleryType :: WdListGalleryType -> Prelude.IO Int.Int16
marshallWdListGalleryType v =
  case v of
     WdBulletGallery -> Prelude.return (1)
     WdNumberGallery -> Prelude.return (2)
     WdOutlineNumberGallery -> Prelude.return (3)
unmarshallWdListGalleryType :: Int.Int16 -> Prelude.IO WdListGalleryType
unmarshallWdListGalleryType v =
  case v of
     1 -> Prelude.return (WdBulletGallery)
     2 -> Prelude.return (WdNumberGallery)
     3 -> Prelude.return (WdOutlineNumberGallery)
     _ -> Prelude.fail (Prelude.userError "unmarshallWdListGalleryType: illegal enum value ")
data WdListNumberStyle
 = WdListNumberStyleArabic
 | WdListNumberStyleUppercaseRoman
 | WdListNumberStyleLowercaseRoman
 | WdListNumberStyleUppercaseLetter
 | WdListNumberStyleLowercaseLetter
 | WdListNumberStyleOrdinal
 | WdListNumberStyleCardinalText
 | WdListNumberStyleOrdinalText
 | WdListNumberStyleArabicLZ
 | WdListNumberStyleBullet
 | WdListNumberStyleLegal
 | WdListNumberStyleLegalLZ
 | WdListNumberStyleNone
 
marshallWdListNumberStyle :: WdListNumberStyle -> Prelude.IO Int.Int16
marshallWdListNumberStyle v =
  case v of
     WdListNumberStyleArabic -> Prelude.return (0)
     WdListNumberStyleUppercaseRoman -> Prelude.return (1)
     WdListNumberStyleLowercaseRoman -> Prelude.return (2)
     WdListNumberStyleUppercaseLetter -> Prelude.return (3)
     WdListNumberStyleLowercaseLetter -> Prelude.return (4)
     WdListNumberStyleOrdinal -> Prelude.return (5)
     WdListNumberStyleCardinalText -> Prelude.return (6)
     WdListNumberStyleOrdinalText -> Prelude.return (7)
     WdListNumberStyleArabicLZ -> Prelude.return (22)
     WdListNumberStyleBullet -> Prelude.return (23)
     WdListNumberStyleLegal -> Prelude.return (253)
     WdListNumberStyleLegalLZ -> Prelude.return (254)
     WdListNumberStyleNone -> Prelude.return (255)
unmarshallWdListNumberStyle :: Int.Int16 -> Prelude.IO WdListNumberStyle
unmarshallWdListNumberStyle v =
  case v of
     0 -> Prelude.return (WdListNumberStyleArabic)
     1 -> Prelude.return (WdListNumberStyleUppercaseRoman)
     2 -> Prelude.return (WdListNumberStyleLowercaseRoman)
     3 -> Prelude.return (WdListNumberStyleUppercaseLetter)
     4 -> Prelude.return (WdListNumberStyleLowercaseLetter)
     5 -> Prelude.return (WdListNumberStyleOrdinal)
     6 -> Prelude.return (WdListNumberStyleCardinalText)
     7 -> Prelude.return (WdListNumberStyleOrdinalText)
     22 -> Prelude.return (WdListNumberStyleArabicLZ)
     23 -> Prelude.return (WdListNumberStyleBullet)
     253 -> Prelude.return (WdListNumberStyleLegal)
     254 -> Prelude.return (WdListNumberStyleLegalLZ)
     255 -> Prelude.return (WdListNumberStyleNone)
     _ -> Prelude.fail (Prelude.userError "unmarshallWdListNumberStyle: illegal enum value ")
data WdListNumberStyleHID
 = WdListNumberStyleKanji
 | WdListNumberStyleKanjiDigit
 | WdListNumberStyleAiueoHalfWidth
 | WdListNumberStyleIrohaHalfWidth
 | WdListNumberStyleArabicFullWidth
 | WdListNumberStyleKanjiTraditional
 | WdListNumberStyleKanjiTraditional2
 | WdListNumberStyleNumberInCircle
 | WdListNumberStyleAiueo
 | WdListNumberStyleIroha
 | WdListNumberStyleGanada
 | WdListNumberStyleChosung
 | WdListNumberStyleGBNum1
 | WdListNumberStyleGBNum2
 | WdListNumberStyleGBNum3
 | WdListNumberStyleGBNum4
 | WdListNumberStyleZodiac1
 | WdListNumberStyleZodiac2
 | WdListNumberStyleZodiac3
 | WdListNumberStyleTradChinNum1
 | WdListNumberStyleTradChinNum2
 | WdListNumberStyleTradChinNum3
 | WdListNumberStyleTradChinNum4
 | WdListNumberStyleSimpChinNum1
 | WdListNumberStyleSimpChinNum2
 | WdListNumberStyleSimpChinNum3
 | WdListNumberStyleSimpChinNum4
 | WdListNumberStyleHanjaRead
 | WdListNumberStyleHanjaReadDigit
 | WdListNumberStyleHangul
 | WdListNumberStyleHanja
 
marshallWdListNumberStyleHID :: WdListNumberStyleHID -> Prelude.IO Int.Int16
marshallWdListNumberStyleHID v =
  case v of
     WdListNumberStyleKanji -> Prelude.return (10)
     WdListNumberStyleKanjiDigit -> Prelude.return (11)
     WdListNumberStyleAiueoHalfWidth -> Prelude.return (12)
     WdListNumberStyleIrohaHalfWidth -> Prelude.return (13)
     WdListNumberStyleArabicFullWidth -> Prelude.return (14)
     WdListNumberStyleKanjiTraditional -> Prelude.return (16)
     WdListNumberStyleKanjiTraditional2 -> Prelude.return (17)
     WdListNumberStyleNumberInCircle -> Prelude.return (18)
     WdListNumberStyleAiueo -> Prelude.return (20)
     WdListNumberStyleIroha -> Prelude.return (21)
     WdListNumberStyleGanada -> Prelude.return (24)
     WdListNumberStyleChosung -> Prelude.return (25)
     WdListNumberStyleGBNum1 -> Prelude.return (26)
     WdListNumberStyleGBNum2 -> Prelude.return (27)
     WdListNumberStyleGBNum3 -> Prelude.return (28)
     WdListNumberStyleGBNum4 -> Prelude.return (29)
     WdListNumberStyleZodiac1 -> Prelude.return (30)
     WdListNumberStyleZodiac2 -> Prelude.return (31)
     WdListNumberStyleZodiac3 -> Prelude.return (32)
     WdListNumberStyleTradChinNum1 -> Prelude.return (33)
     WdListNumberStyleTradChinNum2 -> Prelude.return (34)
     WdListNumberStyleTradChinNum3 -> Prelude.return (35)
     WdListNumberStyleTradChinNum4 -> Prelude.return (36)
     WdListNumberStyleSimpChinNum1 -> Prelude.return (37)
     WdListNumberStyleSimpChinNum2 -> Prelude.return (38)
     WdListNumberStyleSimpChinNum3 -> Prelude.return (39)
     WdListNumberStyleSimpChinNum4 -> Prelude.return (40)
     WdListNumberStyleHanjaRead -> Prelude.return (41)
     WdListNumberStyleHanjaReadDigit -> Prelude.return (42)
     WdListNumberStyleHangul -> Prelude.return (43)
     WdListNumberStyleHanja -> Prelude.return (44)
unmarshallWdListNumberStyleHID :: Int.Int16 -> Prelude.IO WdListNumberStyleHID
unmarshallWdListNumberStyleHID v =
  case v of
     10 -> Prelude.return (WdListNumberStyleKanji)
     11 -> Prelude.return (WdListNumberStyleKanjiDigit)
     12 -> Prelude.return (WdListNumberStyleAiueoHalfWidth)
     13 -> Prelude.return (WdListNumberStyleIrohaHalfWidth)
     14 -> Prelude.return (WdListNumberStyleArabicFullWidth)
     16 -> Prelude.return (WdListNumberStyleKanjiTraditional)
     17 -> Prelude.return (WdListNumberStyleKanjiTraditional2)
     18 -> Prelude.return (WdListNumberStyleNumberInCircle)
     20 -> Prelude.return (WdListNumberStyleAiueo)
     21 -> Prelude.return (WdListNumberStyleIroha)
     24 -> Prelude.return (WdListNumberStyleGanada)
     25 -> Prelude.return (WdListNumberStyleChosung)
     26 -> Prelude.return (WdListNumberStyleGBNum1)
     27 -> Prelude.return (WdListNumberStyleGBNum2)
     28 -> Prelude.return (WdListNumberStyleGBNum3)
     29 -> Prelude.return (WdListNumberStyleGBNum4)
     30 -> Prelude.return (WdListNumberStyleZodiac1)
     31 -> Prelude.return (WdListNumberStyleZodiac2)
     32 -> Prelude.return (WdListNumberStyleZodiac3)
     33 -> Prelude.return (WdListNumberStyleTradChinNum1)
     34 -> Prelude.return (WdListNumberStyleTradChinNum2)
     35 -> Prelude.return (WdListNumberStyleTradChinNum3)
     36 -> Prelude.return (WdListNumberStyleTradChinNum4)
     37 -> Prelude.return (WdListNumberStyleSimpChinNum1)
     38 -> Prelude.return (WdListNumberStyleSimpChinNum2)
     39 -> Prelude.return (WdListNumberStyleSimpChinNum3)
     40 -> Prelude.return (WdListNumberStyleSimpChinNum4)
     41 -> Prelude.return (WdListNumberStyleHanjaRead)
     42 -> Prelude.return (WdListNumberStyleHanjaReadDigit)
     43 -> Prelude.return (WdListNumberStyleHangul)
     44 -> Prelude.return (WdListNumberStyleHanja)
     _ -> Prelude.fail (Prelude.userError "unmarshallWdListNumberStyleHID: illegal enum value ")
data WdNoteNumberStyle
 = WdNoteNumberStyleArabic
 | WdNoteNumberStyleUppercaseRoman
 | WdNoteNumberStyleLowercaseRoman
 | WdNoteNumberStyleUppercaseLetter
 | WdNoteNumberStyleLowercaseLetter
 | WdNoteNumberStyleSymbol
 
marshallWdNoteNumberStyle :: WdNoteNumberStyle -> Prelude.IO Int.Int16
marshallWdNoteNumberStyle v =
  case v of
     WdNoteNumberStyleArabic -> Prelude.return (0)
     WdNoteNumberStyleUppercaseRoman -> Prelude.return (1)
     WdNoteNumberStyleLowercaseRoman -> Prelude.return (2)
     WdNoteNumberStyleUppercaseLetter -> Prelude.return (3)
     WdNoteNumberStyleLowercaseLetter -> Prelude.return (4)
     WdNoteNumberStyleSymbol -> Prelude.return (9)
unmarshallWdNoteNumberStyle :: Int.Int16 -> Prelude.IO WdNoteNumberStyle
unmarshallWdNoteNumberStyle v =
  case v of
     0 -> Prelude.return (WdNoteNumberStyleArabic)
     1 -> Prelude.return (WdNoteNumberStyleUppercaseRoman)
     2 -> Prelude.return (WdNoteNumberStyleLowercaseRoman)
     3 -> Prelude.return (WdNoteNumberStyleUppercaseLetter)
     4 -> Prelude.return (WdNoteNumberStyleLowercaseLetter)
     9 -> Prelude.return (WdNoteNumberStyleSymbol)
     _ -> Prelude.fail (Prelude.userError "unmarshallWdNoteNumberStyle: illegal enum value ")
data WdNoteNumberStyleHID
 = WdNoteNumberStyleArabicFullWidth
 | WdNoteNumberStyleKanji
 | WdNoteNumberStyleKanjiDigit
 | WdNoteNumberStyleKanjiTraditional
 | WdNoteNumberStyleNumberInCircle
 | WdNoteNumberStyleHanjaRead
 | WdNoteNumberStyleHanjaReadDigit
 | WdNoteNumberStyleTradChinNum1
 | WdNoteNumberStyleTradChinNum2
 | WdNoteNumberStyleSimpChinNum1
 | WdNoteNumberStyleSimpChinNum2
 
marshallWdNoteNumberStyleHID :: WdNoteNumberStyleHID -> Prelude.IO Int.Int16
marshallWdNoteNumberStyleHID v =
  case v of
     WdNoteNumberStyleArabicFullWidth -> Prelude.return (14)
     WdNoteNumberStyleKanji -> Prelude.return (10)
     WdNoteNumberStyleKanjiDigit -> Prelude.return (11)
     WdNoteNumberStyleKanjiTraditional -> Prelude.return (16)
     WdNoteNumberStyleNumberInCircle -> Prelude.return (18)
     WdNoteNumberStyleHanjaRead -> Prelude.return (41)
     WdNoteNumberStyleHanjaReadDigit -> Prelude.return (42)
     WdNoteNumberStyleTradChinNum1 -> Prelude.return (33)
     WdNoteNumberStyleTradChinNum2 -> Prelude.return (34)
     WdNoteNumberStyleSimpChinNum1 -> Prelude.return (37)
     WdNoteNumberStyleSimpChinNum2 -> Prelude.return (38)
unmarshallWdNoteNumberStyleHID :: Int.Int16 -> Prelude.IO WdNoteNumberStyleHID
unmarshallWdNoteNumberStyleHID v =
  case v of
     14 -> Prelude.return (WdNoteNumberStyleArabicFullWidth)
     10 -> Prelude.return (WdNoteNumberStyleKanji)
     11 -> Prelude.return (WdNoteNumberStyleKanjiDigit)
     16 -> Prelude.return (WdNoteNumberStyleKanjiTraditional)
     18 -> Prelude.return (WdNoteNumberStyleNumberInCircle)
     41 -> Prelude.return (WdNoteNumberStyleHanjaRead)
     42 -> Prelude.return (WdNoteNumberStyleHanjaReadDigit)
     33 -> Prelude.return (WdNoteNumberStyleTradChinNum1)
     34 -> Prelude.return (WdNoteNumberStyleTradChinNum2)
     37 -> Prelude.return (WdNoteNumberStyleSimpChinNum1)
     38 -> Prelude.return (WdNoteNumberStyleSimpChinNum2)
     _ -> Prelude.fail (Prelude.userError "unmarshallWdNoteNumberStyleHID: illegal enum value ")
data WdCaptionNumberStyle
 = WdCaptionNumberStyleArabic
 | WdCaptionNumberStyleUppercaseRoman
 | WdCaptionNumberStyleLowercaseRoman
 | WdCaptionNumberStyleUppercaseLetter
 | WdCaptionNumberStyleLowercaseLetter
 
marshallWdCaptionNumberStyle :: WdCaptionNumberStyle -> Prelude.IO Int.Int16
marshallWdCaptionNumberStyle v =
  case v of
     WdCaptionNumberStyleArabic -> Prelude.return (0)
     WdCaptionNumberStyleUppercaseRoman -> Prelude.return (1)
     WdCaptionNumberStyleLowercaseRoman -> Prelude.return (2)
     WdCaptionNumberStyleUppercaseLetter -> Prelude.return (3)
     WdCaptionNumberStyleLowercaseLetter -> Prelude.return (4)
unmarshallWdCaptionNumberStyle :: Int.Int16 -> Prelude.IO WdCaptionNumberStyle
unmarshallWdCaptionNumberStyle v =
  case v of
     0 -> Prelude.return (WdCaptionNumberStyleArabic)
     1 -> Prelude.return (WdCaptionNumberStyleUppercaseRoman)
     2 -> Prelude.return (WdCaptionNumberStyleLowercaseRoman)
     3 -> Prelude.return (WdCaptionNumberStyleUppercaseLetter)
     4 -> Prelude.return (WdCaptionNumberStyleLowercaseLetter)
     _ -> Prelude.fail (Prelude.userError "unmarshallWdCaptionNumberStyle: illegal enum value ")
data WdCaptionNumberStyleHID
 = WdCaptionNumberStyleArabicFullWidth
 | WdCaptionNumberStyleKanji
 | WdCaptionNumberStyleKanjiDigit
 | WdCaptionNumberStyleKanjiTraditional
 | WdCaptionNumberStyleNumberInCircle
 | WdCaptionNumberStyleGanada
 | WdCaptionNumberStyleChosung
 | WdCaptionNumberStyleZodiac1
 | WdCaptionNumberStyleZodiac2
 | WdCaptionNumberStyleHanjaRead
 | WdCaptionNumberStyleHanjaReadDigit
 | WdCaptionNumberStyleTradChinNum2
 | WdCaptionNumberStyleTradChinNum3
 | WdCaptionNumberStyleSimpChinNum2
 | WdCaptionNumberStyleSimpChinNum3
 
marshallWdCaptionNumberStyleHID :: WdCaptionNumberStyleHID -> Prelude.IO Int.Int16
marshallWdCaptionNumberStyleHID v =
  case v of
     WdCaptionNumberStyleArabicFullWidth -> Prelude.return (14)
     WdCaptionNumberStyleKanji -> Prelude.return (10)
     WdCaptionNumberStyleKanjiDigit -> Prelude.return (11)
     WdCaptionNumberStyleKanjiTraditional -> Prelude.return (16)
     WdCaptionNumberStyleNumberInCircle -> Prelude.return (18)
     WdCaptionNumberStyleGanada -> Prelude.return (24)
     WdCaptionNumberStyleChosung -> Prelude.return (25)
     WdCaptionNumberStyleZodiac1 -> Prelude.return (30)
     WdCaptionNumberStyleZodiac2 -> Prelude.return (31)
     WdCaptionNumberStyleHanjaRead -> Prelude.return (41)
     WdCaptionNumberStyleHanjaReadDigit -> Prelude.return (42)
     WdCaptionNumberStyleTradChinNum2 -> Prelude.return (34)
     WdCaptionNumberStyleTradChinNum3 -> Prelude.return (35)
     WdCaptionNumberStyleSimpChinNum2 -> Prelude.return (38)
     WdCaptionNumberStyleSimpChinNum3 -> Prelude.return (39)
unmarshallWdCaptionNumberStyleHID :: Int.Int16 -> Prelude.IO WdCaptionNumberStyleHID
unmarshallWdCaptionNumberStyleHID v =
  case v of
     14 -> Prelude.return (WdCaptionNumberStyleArabicFullWidth)
     10 -> Prelude.return (WdCaptionNumberStyleKanji)
     11 -> Prelude.return (WdCaptionNumberStyleKanjiDigit)
     16 -> Prelude.return (WdCaptionNumberStyleKanjiTraditional)
     18 -> Prelude.return (WdCaptionNumberStyleNumberInCircle)
     24 -> Prelude.return (WdCaptionNumberStyleGanada)
     25 -> Prelude.return (WdCaptionNumberStyleChosung)
     30 -> Prelude.return (WdCaptionNumberStyleZodiac1)
     31 -> Prelude.return (WdCaptionNumberStyleZodiac2)
     41 -> Prelude.return (WdCaptionNumberStyleHanjaRead)
     42 -> Prelude.return (WdCaptionNumberStyleHanjaReadDigit)
     34 -> Prelude.return (WdCaptionNumberStyleTradChinNum2)
     35 -> Prelude.return (WdCaptionNumberStyleTradChinNum3)
     38 -> Prelude.return (WdCaptionNumberStyleSimpChinNum2)
     39 -> Prelude.return (WdCaptionNumberStyleSimpChinNum3)
     _ -> Prelude.fail (Prelude.userError "unmarshallWdCaptionNumberStyleHID: illegal enum value ")
data WdPageNumberStyle
 = WdPageNumberStyleArabic
 | WdPageNumberStyleUppercaseRoman
 | WdPageNumberStyleLowercaseRoman
 | WdPageNumberStyleUppercaseLetter
 | WdPageNumberStyleLowercaseLetter
 
marshallWdPageNumberStyle :: WdPageNumberStyle -> Prelude.IO Int.Int16
marshallWdPageNumberStyle v =
  case v of
     WdPageNumberStyleArabic -> Prelude.return (0)
     WdPageNumberStyleUppercaseRoman -> Prelude.return (1)
     WdPageNumberStyleLowercaseRoman -> Prelude.return (2)
     WdPageNumberStyleUppercaseLetter -> Prelude.return (3)
     WdPageNumberStyleLowercaseLetter -> Prelude.return (4)
unmarshallWdPageNumberStyle :: Int.Int16 -> Prelude.IO WdPageNumberStyle
unmarshallWdPageNumberStyle v =
  case v of
     0 -> Prelude.return (WdPageNumberStyleArabic)
     1 -> Prelude.return (WdPageNumberStyleUppercaseRoman)
     2 -> Prelude.return (WdPageNumberStyleLowercaseRoman)
     3 -> Prelude.return (WdPageNumberStyleUppercaseLetter)
     4 -> Prelude.return (WdPageNumberStyleLowercaseLetter)
     _ -> Prelude.fail (Prelude.userError "unmarshallWdPageNumberStyle: illegal enum value ")
data WdPageNumberStyleHID
 = WdPageNumberStyleArabicFullWidth
 | WdPageNumberStyleKanji
 | WdPageNumberStyleKanjiDigit
 | WdPageNumberStyleKanjiTraditional
 | WdPageNumberStyleNumberInCircle
 | WdPageNumberStyleHanjaRead
 | WdPageNumberStyleHanjaReadDigit
 | WdPageNumberStyleTradChinNum1
 | WdPageNumberStyleTradChinNum2
 | WdPageNumberStyleSimpChinNum1
 | WdPageNumberStyleSimpChinNum2
 
marshallWdPageNumberStyleHID :: WdPageNumberStyleHID -> Prelude.IO Int.Int16
marshallWdPageNumberStyleHID v =
  case v of
     WdPageNumberStyleArabicFullWidth -> Prelude.return (14)
     WdPageNumberStyleKanji -> Prelude.return (10)
     WdPageNumberStyleKanjiDigit -> Prelude.return (11)
     WdPageNumberStyleKanjiTraditional -> Prelude.return (16)
     WdPageNumberStyleNumberInCircle -> Prelude.return (18)
     WdPageNumberStyleHanjaRead -> Prelude.return (41)
     WdPageNumberStyleHanjaReadDigit -> Prelude.return (42)
     WdPageNumberStyleTradChinNum1 -> Prelude.return (33)
     WdPageNumberStyleTradChinNum2 -> Prelude.return (34)
     WdPageNumberStyleSimpChinNum1 -> Prelude.return (37)
     WdPageNumberStyleSimpChinNum2 -> Prelude.return (38)
unmarshallWdPageNumberStyleHID :: Int.Int16 -> Prelude.IO WdPageNumberStyleHID
unmarshallWdPageNumberStyleHID v =
  case v of
     14 -> Prelude.return (WdPageNumberStyleArabicFullWidth)
     10 -> Prelude.return (WdPageNumberStyleKanji)
     11 -> Prelude.return (WdPageNumberStyleKanjiDigit)
     16 -> Prelude.return (WdPageNumberStyleKanjiTraditional)
     18 -> Prelude.return (WdPageNumberStyleNumberInCircle)
     41 -> Prelude.return (WdPageNumberStyleHanjaRead)
     42 -> Prelude.return (WdPageNumberStyleHanjaReadDigit)
     33 -> Prelude.return (WdPageNumberStyleTradChinNum1)
     34 -> Prelude.return (WdPageNumberStyleTradChinNum2)
     37 -> Prelude.return (WdPageNumberStyleSimpChinNum1)
     38 -> Prelude.return (WdPageNumberStyleSimpChinNum2)
     _ -> Prelude.fail (Prelude.userError "unmarshallWdPageNumberStyleHID: illegal enum value ")
data WdStatistic
 = WdStatisticWords
 | WdStatisticLines
 | WdStatisticPages
 | WdStatisticCharacters
 | WdStatisticParagraphs
 | WdStatisticCharactersWithSpaces
 
marshallWdStatistic :: WdStatistic -> Prelude.IO Int.Int16
marshallWdStatistic v =
  case v of
     WdStatisticWords -> Prelude.return (0)
     WdStatisticLines -> Prelude.return (1)
     WdStatisticPages -> Prelude.return (2)
     WdStatisticCharacters -> Prelude.return (3)
     WdStatisticParagraphs -> Prelude.return (4)
     WdStatisticCharactersWithSpaces -> Prelude.return (5)
unmarshallWdStatistic :: Int.Int16 -> Prelude.IO WdStatistic
unmarshallWdStatistic v =
  case v of
     0 -> Prelude.return (WdStatisticWords)
     1 -> Prelude.return (WdStatisticLines)
     2 -> Prelude.return (WdStatisticPages)
     3 -> Prelude.return (WdStatisticCharacters)
     4 -> Prelude.return (WdStatisticParagraphs)
     5 -> Prelude.return (WdStatisticCharactersWithSpaces)
     _ -> Prelude.fail (Prelude.userError "unmarshallWdStatistic: illegal enum value ")
data WdStatisticHID = WdStatisticFarEastCharacters
                       
marshallWdStatisticHID :: WdStatisticHID -> Prelude.IO Int.Int16
marshallWdStatisticHID v =
  case v of
     WdStatisticFarEastCharacters -> Prelude.return (6)
unmarshallWdStatisticHID :: Int.Int16 -> Prelude.IO WdStatisticHID
unmarshallWdStatisticHID v =
  case v of
     6 -> Prelude.return (WdStatisticFarEastCharacters)
     _ -> Prelude.fail (Prelude.userError "unmarshallWdStatisticHID: illegal enum value ")
data WdBuiltInProperty
 = WdPropertyTitle
 | WdPropertySubject
 | WdPropertyAuthor
 | WdPropertyKeywords
 | WdPropertyComments
 | WdPropertyTemplate
 | WdPropertyLastAuthor
 | WdPropertyRevision
 | WdPropertyAppName
 | WdPropertyTimeLastPrinted
 | WdPropertyTimeCreated
 | WdPropertyTimeLastSaved
 | WdPropertyVBATotalEdit
 | WdPropertyPages
 | WdPropertyWords
 | WdPropertyCharacters
 | WdPropertySecurity
 | WdPropertyCategory
 | WdPropertyFormat
 | WdPropertyManager
 | WdPropertyCompany
 | WdPropertyBytes
 | WdPropertyLines
 | WdPropertyParas
 | WdPropertySlides
 | WdPropertyNotes
 | WdPropertyHiddenSlides
 | WdPropertyMMClips
 | WdPropertyHyperlinkBase
 | WdPropertyCharsWSpaces
 
marshallWdBuiltInProperty :: WdBuiltInProperty -> Prelude.IO Int.Int16
marshallWdBuiltInProperty v =
  case v of
     WdPropertyTitle -> Prelude.return (1)
     WdPropertySubject -> Prelude.return (2)
     WdPropertyAuthor -> Prelude.return (3)
     WdPropertyKeywords -> Prelude.return (4)
     WdPropertyComments -> Prelude.return (5)
     WdPropertyTemplate -> Prelude.return (6)
     WdPropertyLastAuthor -> Prelude.return (7)
     WdPropertyRevision -> Prelude.return (8)
     WdPropertyAppName -> Prelude.return (9)
     WdPropertyTimeLastPrinted -> Prelude.return (10)
     WdPropertyTimeCreated -> Prelude.return (11)
     WdPropertyTimeLastSaved -> Prelude.return (12)
     WdPropertyVBATotalEdit -> Prelude.return (13)
     WdPropertyPages -> Prelude.return (14)
     WdPropertyWords -> Prelude.return (15)
     WdPropertyCharacters -> Prelude.return (16)
     WdPropertySecurity -> Prelude.return (17)
     WdPropertyCategory -> Prelude.return (18)
     WdPropertyFormat -> Prelude.return (19)
     WdPropertyManager -> Prelude.return (20)
     WdPropertyCompany -> Prelude.return (21)
     WdPropertyBytes -> Prelude.return (22)
     WdPropertyLines -> Prelude.return (23)
     WdPropertyParas -> Prelude.return (24)
     WdPropertySlides -> Prelude.return (25)
     WdPropertyNotes -> Prelude.return (26)
     WdPropertyHiddenSlides -> Prelude.return (27)
     WdPropertyMMClips -> Prelude.return (28)
     WdPropertyHyperlinkBase -> Prelude.return (29)
     WdPropertyCharsWSpaces -> Prelude.return (30)
unmarshallWdBuiltInProperty :: Int.Int16 -> Prelude.IO WdBuiltInProperty
unmarshallWdBuiltInProperty v =
  case v of
     1 -> Prelude.return (WdPropertyTitle)
     2 -> Prelude.return (WdPropertySubject)
     3 -> Prelude.return (WdPropertyAuthor)
     4 -> Prelude.return (WdPropertyKeywords)
     5 -> Prelude.return (WdPropertyComments)
     6 -> Prelude.return (WdPropertyTemplate)
     7 -> Prelude.return (WdPropertyLastAuthor)
     8 -> Prelude.return (WdPropertyRevision)
     9 -> Prelude.return (WdPropertyAppName)
     10 -> Prelude.return (WdPropertyTimeLastPrinted)
     11 -> Prelude.return (WdPropertyTimeCreated)
     12 -> Prelude.return (WdPropertyTimeLastSaved)
     13 -> Prelude.return (WdPropertyVBATotalEdit)
     14 -> Prelude.return (WdPropertyPages)
     15 -> Prelude.return (WdPropertyWords)
     16 -> Prelude.return (WdPropertyCharacters)
     17 -> Prelude.return (WdPropertySecurity)
     18 -> Prelude.return (WdPropertyCategory)
     19 -> Prelude.return (WdPropertyFormat)
     20 -> Prelude.return (WdPropertyManager)
     21 -> Prelude.return (WdPropertyCompany)
     22 -> Prelude.return (WdPropertyBytes)
     23 -> Prelude.return (WdPropertyLines)
     24 -> Prelude.return (WdPropertyParas)
     25 -> Prelude.return (WdPropertySlides)
     26 -> Prelude.return (WdPropertyNotes)
     27 -> Prelude.return (WdPropertyHiddenSlides)
     28 -> Prelude.return (WdPropertyMMClips)
     29 -> Prelude.return (WdPropertyHyperlinkBase)
     30 -> Prelude.return (WdPropertyCharsWSpaces)
     _ -> Prelude.fail (Prelude.userError "unmarshallWdBuiltInProperty: illegal enum value ")
data WdLineSpacing
 = WdLineSpaceSingle
 | WdLineSpace1pt5
 | WdLineSpaceDouble
 | WdLineSpaceAtLeast
 | WdLineSpaceExactly
 | WdLineSpaceMultiple
 
marshallWdLineSpacing :: WdLineSpacing -> Prelude.IO Int.Int16
marshallWdLineSpacing v =
  case v of
     WdLineSpaceSingle -> Prelude.return (0)
     WdLineSpace1pt5 -> Prelude.return (1)
     WdLineSpaceDouble -> Prelude.return (2)
     WdLineSpaceAtLeast -> Prelude.return (3)
     WdLineSpaceExactly -> Prelude.return (4)
     WdLineSpaceMultiple -> Prelude.return (5)
unmarshallWdLineSpacing :: Int.Int16 -> Prelude.IO WdLineSpacing
unmarshallWdLineSpacing v =
  case v of
     0 -> Prelude.return (WdLineSpaceSingle)
     1 -> Prelude.return (WdLineSpace1pt5)
     2 -> Prelude.return (WdLineSpaceDouble)
     3 -> Prelude.return (WdLineSpaceAtLeast)
     4 -> Prelude.return (WdLineSpaceExactly)
     5 -> Prelude.return (WdLineSpaceMultiple)
     _ -> Prelude.fail (Prelude.userError "unmarshallWdLineSpacing: illegal enum value ")
data WdNumberType
 = WdNumberParagraph
 | WdNumberListNum
 | WdNumberAllNumbers
 
marshallWdNumberType :: WdNumberType -> Prelude.IO Int.Int16
marshallWdNumberType v =
  case v of
     WdNumberParagraph -> Prelude.return (1)
     WdNumberListNum -> Prelude.return (2)
     WdNumberAllNumbers -> Prelude.return (3)
unmarshallWdNumberType :: Int.Int16 -> Prelude.IO WdNumberType
unmarshallWdNumberType v =
  case v of
     1 -> Prelude.return (WdNumberParagraph)
     2 -> Prelude.return (WdNumberListNum)
     3 -> Prelude.return (WdNumberAllNumbers)
     _ -> Prelude.fail (Prelude.userError "unmarshallWdNumberType: illegal enum value ")
data WdListType
 = WdListNoNumbering
 | WdListListNumOnly
 | WdListBullet
 | WdListSimpleNumbering
 | WdListOutlineNumbering
 | WdListMixedNumbering
 
marshallWdListType :: WdListType -> Prelude.IO Int.Int16
marshallWdListType v =
  case v of
     WdListNoNumbering -> Prelude.return (0)
     WdListListNumOnly -> Prelude.return (1)
     WdListBullet -> Prelude.return (2)
     WdListSimpleNumbering -> Prelude.return (3)
     WdListOutlineNumbering -> Prelude.return (4)
     WdListMixedNumbering -> Prelude.return (5)
unmarshallWdListType :: Int.Int16 -> Prelude.IO WdListType
unmarshallWdListType v =
  case v of
     0 -> Prelude.return (WdListNoNumbering)
     1 -> Prelude.return (WdListListNumOnly)
     2 -> Prelude.return (WdListBullet)
     3 -> Prelude.return (WdListSimpleNumbering)
     4 -> Prelude.return (WdListOutlineNumbering)
     5 -> Prelude.return (WdListMixedNumbering)
     _ -> Prelude.fail (Prelude.userError "unmarshallWdListType: illegal enum value ")
data WdStoryType
 = WdMainTextStory
 | WdFootnotesStory
 | WdEndnotesStory
 | WdCommentsStory
 | WdTextFrameStory
 | WdEvenPagesHeaderStory
 | WdPrimaryHeaderStory
 | WdEvenPagesFooterStory
 | WdPrimaryFooterStory
 | WdFirstPageHeaderStory
 | WdFirstPageFooterStory
 
marshallWdStoryType :: WdStoryType -> Prelude.IO Int.Int16
marshallWdStoryType v =
  case v of
     WdMainTextStory -> Prelude.return (1)
     WdFootnotesStory -> Prelude.return (2)
     WdEndnotesStory -> Prelude.return (3)
     WdCommentsStory -> Prelude.return (4)
     WdTextFrameStory -> Prelude.return (5)
     WdEvenPagesHeaderStory -> Prelude.return (6)
     WdPrimaryHeaderStory -> Prelude.return (7)
     WdEvenPagesFooterStory -> Prelude.return (8)
     WdPrimaryFooterStory -> Prelude.return (9)
     WdFirstPageHeaderStory -> Prelude.return (10)
     WdFirstPageFooterStory -> Prelude.return (11)
unmarshallWdStoryType :: Int.Int16 -> Prelude.IO WdStoryType
unmarshallWdStoryType v =
  case v of
     1 -> Prelude.return (WdMainTextStory)
     2 -> Prelude.return (WdFootnotesStory)
     3 -> Prelude.return (WdEndnotesStory)
     4 -> Prelude.return (WdCommentsStory)
     5 -> Prelude.return (WdTextFrameStory)
     6 -> Prelude.return (WdEvenPagesHeaderStory)
     7 -> Prelude.return (WdPrimaryHeaderStory)
     8 -> Prelude.return (WdEvenPagesFooterStory)
     9 -> Prelude.return (WdPrimaryFooterStory)
     10 -> Prelude.return (WdFirstPageHeaderStory)
     11 -> Prelude.return (WdFirstPageFooterStory)
     _ -> Prelude.fail (Prelude.userError "unmarshallWdStoryType: illegal enum value ")
data WdSaveFormat
 = WdFormatDocument
 | WdFormatTemplate
 | WdFormatText
 | WdFormatTextLineBreaks
 | WdFormatDOSText
 | WdFormatDOSTextLineBreaks
 | WdFormatRTF
 | WdFormatUnicodeText
 
marshallWdSaveFormat :: WdSaveFormat -> Prelude.IO Int.Int16
marshallWdSaveFormat v =
  case v of
     WdFormatDocument -> Prelude.return (0)
     WdFormatTemplate -> Prelude.return (1)
     WdFormatText -> Prelude.return (2)
     WdFormatTextLineBreaks -> Prelude.return (3)
     WdFormatDOSText -> Prelude.return (4)
     WdFormatDOSTextLineBreaks -> Prelude.return (5)
     WdFormatRTF -> Prelude.return (6)
     WdFormatUnicodeText -> Prelude.return (7)
unmarshallWdSaveFormat :: Int.Int16 -> Prelude.IO WdSaveFormat
unmarshallWdSaveFormat v =
  case v of
     0 -> Prelude.return (WdFormatDocument)
     1 -> Prelude.return (WdFormatTemplate)
     2 -> Prelude.return (WdFormatText)
     3 -> Prelude.return (WdFormatTextLineBreaks)
     4 -> Prelude.return (WdFormatDOSText)
     5 -> Prelude.return (WdFormatDOSTextLineBreaks)
     6 -> Prelude.return (WdFormatRTF)
     7 -> Prelude.return (WdFormatUnicodeText)
     _ -> Prelude.fail (Prelude.userError "unmarshallWdSaveFormat: illegal enum value ")
data WdOpenFormat
 = WdOpenFormatAuto
 | WdOpenFormatDocument
 | WdOpenFormatTemplate
 | WdOpenFormatRTF
 | WdOpenFormatText
 | WdOpenFormatUnicodeText
 
marshallWdOpenFormat :: WdOpenFormat -> Prelude.IO Int.Int16
marshallWdOpenFormat v =
  case v of
     WdOpenFormatAuto -> Prelude.return (0)
     WdOpenFormatDocument -> Prelude.return (1)
     WdOpenFormatTemplate -> Prelude.return (2)
     WdOpenFormatRTF -> Prelude.return (3)
     WdOpenFormatText -> Prelude.return (4)
     WdOpenFormatUnicodeText -> Prelude.return (5)
unmarshallWdOpenFormat :: Int.Int16 -> Prelude.IO WdOpenFormat
unmarshallWdOpenFormat v =
  case v of
     0 -> Prelude.return (WdOpenFormatAuto)
     1 -> Prelude.return (WdOpenFormatDocument)
     2 -> Prelude.return (WdOpenFormatTemplate)
     3 -> Prelude.return (WdOpenFormatRTF)
     4 -> Prelude.return (WdOpenFormatText)
     5 -> Prelude.return (WdOpenFormatUnicodeText)
     _ -> Prelude.fail (Prelude.userError "unmarshallWdOpenFormat: illegal enum value ")
data WdHeaderFooterIndex
 = WdHeaderFooterPrimary
 | WdHeaderFooterFirstPage
 | WdHeaderFooterEvenPages
 
marshallWdHeaderFooterIndex :: WdHeaderFooterIndex -> Prelude.IO Int.Int16
marshallWdHeaderFooterIndex v =
  case v of
     WdHeaderFooterPrimary -> Prelude.return (1)
     WdHeaderFooterFirstPage -> Prelude.return (2)
     WdHeaderFooterEvenPages -> Prelude.return (3)
unmarshallWdHeaderFooterIndex :: Int.Int16 -> Prelude.IO WdHeaderFooterIndex
unmarshallWdHeaderFooterIndex v =
  case v of
     1 -> Prelude.return (WdHeaderFooterPrimary)
     2 -> Prelude.return (WdHeaderFooterFirstPage)
     3 -> Prelude.return (WdHeaderFooterEvenPages)
     _ -> Prelude.fail (Prelude.userError "unmarshallWdHeaderFooterIndex: illegal enum value ")
data WdTocFormat
 = WdTOCTemplate
 | WdTOCClassic
 | WdTOCDistinctive
 | WdTOCFancy
 | WdTOCModern
 | WdTOCFormal
 | WdTOCSimple
 
marshallWdTocFormat :: WdTocFormat -> Prelude.IO Int.Int16
marshallWdTocFormat v =
  case v of
     WdTOCTemplate -> Prelude.return (0)
     WdTOCClassic -> Prelude.return (1)
     WdTOCDistinctive -> Prelude.return (2)
     WdTOCFancy -> Prelude.return (3)
     WdTOCModern -> Prelude.return (4)
     WdTOCFormal -> Prelude.return (5)
     WdTOCSimple -> Prelude.return (6)
unmarshallWdTocFormat :: Int.Int16 -> Prelude.IO WdTocFormat
unmarshallWdTocFormat v =
  case v of
     0 -> Prelude.return (WdTOCTemplate)
     1 -> Prelude.return (WdTOCClassic)
     2 -> Prelude.return (WdTOCDistinctive)
     3 -> Prelude.return (WdTOCFancy)
     4 -> Prelude.return (WdTOCModern)
     5 -> Prelude.return (WdTOCFormal)
     6 -> Prelude.return (WdTOCSimple)
     _ -> Prelude.fail (Prelude.userError "unmarshallWdTocFormat: illegal enum value ")
data WdTofFormat
 = WdTOFTemplate
 | WdTOFClassic
 | WdTOFDistinctive
 | WdTOFCentered
 | WdTOFFormal
 | WdTOFSimple
 
marshallWdTofFormat :: WdTofFormat -> Prelude.IO Int.Int16
marshallWdTofFormat v =
  case v of
     WdTOFTemplate -> Prelude.return (0)
     WdTOFClassic -> Prelude.return (1)
     WdTOFDistinctive -> Prelude.return (2)
     WdTOFCentered -> Prelude.return (3)
     WdTOFFormal -> Prelude.return (4)
     WdTOFSimple -> Prelude.return (5)
unmarshallWdTofFormat :: Int.Int16 -> Prelude.IO WdTofFormat
unmarshallWdTofFormat v =
  case v of
     0 -> Prelude.return (WdTOFTemplate)
     1 -> Prelude.return (WdTOFClassic)
     2 -> Prelude.return (WdTOFDistinctive)
     3 -> Prelude.return (WdTOFCentered)
     4 -> Prelude.return (WdTOFFormal)
     5 -> Prelude.return (WdTOFSimple)
     _ -> Prelude.fail (Prelude.userError "unmarshallWdTofFormat: illegal enum value ")
data WdToaFormat
 = WdTOATemplate
 | WdTOAClassic
 | WdTOADistinctive
 | WdTOAFormal
 | WdTOASimple
 
marshallWdToaFormat :: WdToaFormat -> Prelude.IO Int.Int16
marshallWdToaFormat v =
  case v of
     WdTOATemplate -> Prelude.return (0)
     WdTOAClassic -> Prelude.return (1)
     WdTOADistinctive -> Prelude.return (2)
     WdTOAFormal -> Prelude.return (3)
     WdTOASimple -> Prelude.return (4)
unmarshallWdToaFormat :: Int.Int16 -> Prelude.IO WdToaFormat
unmarshallWdToaFormat v =
  case v of
     0 -> Prelude.return (WdTOATemplate)
     1 -> Prelude.return (WdTOAClassic)
     2 -> Prelude.return (WdTOADistinctive)
     3 -> Prelude.return (WdTOAFormal)
     4 -> Prelude.return (WdTOASimple)
     _ -> Prelude.fail (Prelude.userError "unmarshallWdToaFormat: illegal enum value ")
data WdLineStyle
 = WdLineStyleNone
 | WdLineStyleSingle
 | WdLineStyleDot
 | WdLineStyleDashSmallGap
 | WdLineStyleDashLargeGap
 | WdLineStyleDashDot
 | WdLineStyleDashDotDot
 | WdLineStyleDouble
 | WdLineStyleTriple
 | WdLineStyleThinThickSmallGap
 | WdLineStyleThickThinSmallGap
 | WdLineStyleThinThickThinSmallGap
 | WdLineStyleThinThickMedGap
 | WdLineStyleThickThinMedGap
 | WdLineStyleThinThickThinMedGap
 | WdLineStyleThinThickLargeGap
 | WdLineStyleThickThinLargeGap
 | WdLineStyleThinThickThinLargeGap
 | WdLineStyleSingleWavy
 | WdLineStyleDoubleWavy
 | WdLineStyleDashDotStroked
 | WdLineStyleEmboss3D
 | WdLineStyleEngrave3D
 
marshallWdLineStyle :: WdLineStyle -> Prelude.IO Int.Int16
marshallWdLineStyle v =
  case v of
     WdLineStyleNone -> Prelude.return (0)
     WdLineStyleSingle -> Prelude.return (1)
     WdLineStyleDot -> Prelude.return (2)
     WdLineStyleDashSmallGap -> Prelude.return (3)
     WdLineStyleDashLargeGap -> Prelude.return (4)
     WdLineStyleDashDot -> Prelude.return (5)
     WdLineStyleDashDotDot -> Prelude.return (6)
     WdLineStyleDouble -> Prelude.return (7)
     WdLineStyleTriple -> Prelude.return (8)
     WdLineStyleThinThickSmallGap -> Prelude.return (9)
     WdLineStyleThickThinSmallGap -> Prelude.return (10)
     WdLineStyleThinThickThinSmallGap -> Prelude.return (11)
     WdLineStyleThinThickMedGap -> Prelude.return (12)
     WdLineStyleThickThinMedGap -> Prelude.return (13)
     WdLineStyleThinThickThinMedGap -> Prelude.return (14)
     WdLineStyleThinThickLargeGap -> Prelude.return (15)
     WdLineStyleThickThinLargeGap -> Prelude.return (16)
     WdLineStyleThinThickThinLargeGap -> Prelude.return (17)
     WdLineStyleSingleWavy -> Prelude.return (18)
     WdLineStyleDoubleWavy -> Prelude.return (19)
     WdLineStyleDashDotStroked -> Prelude.return (20)
     WdLineStyleEmboss3D -> Prelude.return (21)
     WdLineStyleEngrave3D -> Prelude.return (22)
unmarshallWdLineStyle :: Int.Int16 -> Prelude.IO WdLineStyle
unmarshallWdLineStyle v =
  case v of
     0 -> Prelude.return (WdLineStyleNone)
     1 -> Prelude.return (WdLineStyleSingle)
     2 -> Prelude.return (WdLineStyleDot)
     3 -> Prelude.return (WdLineStyleDashSmallGap)
     4 -> Prelude.return (WdLineStyleDashLargeGap)
     5 -> Prelude.return (WdLineStyleDashDot)
     6 -> Prelude.return (WdLineStyleDashDotDot)
     7 -> Prelude.return (WdLineStyleDouble)
     8 -> Prelude.return (WdLineStyleTriple)
     9 -> Prelude.return (WdLineStyleThinThickSmallGap)
     10 -> Prelude.return (WdLineStyleThickThinSmallGap)
     11 -> Prelude.return (WdLineStyleThinThickThinSmallGap)
     12 -> Prelude.return (WdLineStyleThinThickMedGap)
     13 -> Prelude.return (WdLineStyleThickThinMedGap)
     14 -> Prelude.return (WdLineStyleThinThickThinMedGap)
     15 -> Prelude.return (WdLineStyleThinThickLargeGap)
     16 -> Prelude.return (WdLineStyleThickThinLargeGap)
     17 -> Prelude.return (WdLineStyleThinThickThinLargeGap)
     18 -> Prelude.return (WdLineStyleSingleWavy)
     19 -> Prelude.return (WdLineStyleDoubleWavy)
     20 -> Prelude.return (WdLineStyleDashDotStroked)
     21 -> Prelude.return (WdLineStyleEmboss3D)
     22 -> Prelude.return (WdLineStyleEngrave3D)
     _ -> Prelude.fail (Prelude.userError "unmarshallWdLineStyle: illegal enum value ")
data WdLineWidth
 = WdLineWidth025pt
 | WdLineWidth050pt
 | WdLineWidth075pt
 | WdLineWidth100pt
 | WdLineWidth150pt
 | WdLineWidth225pt
 | WdLineWidth300pt
 | WdLineWidth450pt
 | WdLineWidth600pt
 
marshallWdLineWidth :: WdLineWidth -> Prelude.IO Int.Int16
marshallWdLineWidth v =
  case v of
     WdLineWidth025pt -> Prelude.return (2)
     WdLineWidth050pt -> Prelude.return (4)
     WdLineWidth075pt -> Prelude.return (6)
     WdLineWidth100pt -> Prelude.return (8)
     WdLineWidth150pt -> Prelude.return (12)
     WdLineWidth225pt -> Prelude.return (18)
     WdLineWidth300pt -> Prelude.return (24)
     WdLineWidth450pt -> Prelude.return (36)
     WdLineWidth600pt -> Prelude.return (48)
unmarshallWdLineWidth :: Int.Int16 -> Prelude.IO WdLineWidth
unmarshallWdLineWidth v =
  case v of
     2 -> Prelude.return (WdLineWidth025pt)
     4 -> Prelude.return (WdLineWidth050pt)
     6 -> Prelude.return (WdLineWidth075pt)
     8 -> Prelude.return (WdLineWidth100pt)
     12 -> Prelude.return (WdLineWidth150pt)
     18 -> Prelude.return (WdLineWidth225pt)
     24 -> Prelude.return (WdLineWidth300pt)
     36 -> Prelude.return (WdLineWidth450pt)
     48 -> Prelude.return (WdLineWidth600pt)
     _ -> Prelude.fail (Prelude.userError "unmarshallWdLineWidth: illegal enum value ")
data WdBreakType
 = WdSectionBreakNextPage
 | WdSectionBreakContinuous
 | WdSectionBreakEvenPage
 | WdSectionBreakOddPage
 | WdLineBreak
 | WdPageBreak
 | WdColumnBreak
 
marshallWdBreakType :: WdBreakType -> Prelude.IO Int.Int16
marshallWdBreakType v =
  case v of
     WdSectionBreakNextPage -> Prelude.return (2)
     WdSectionBreakContinuous -> Prelude.return (3)
     WdSectionBreakEvenPage -> Prelude.return (4)
     WdSectionBreakOddPage -> Prelude.return (5)
     WdLineBreak -> Prelude.return (6)
     WdPageBreak -> Prelude.return (7)
     WdColumnBreak -> Prelude.return (8)
unmarshallWdBreakType :: Int.Int16 -> Prelude.IO WdBreakType
unmarshallWdBreakType v =
  case v of
     2 -> Prelude.return (WdSectionBreakNextPage)
     3 -> Prelude.return (WdSectionBreakContinuous)
     4 -> Prelude.return (WdSectionBreakEvenPage)
     5 -> Prelude.return (WdSectionBreakOddPage)
     6 -> Prelude.return (WdLineBreak)
     7 -> Prelude.return (WdPageBreak)
     8 -> Prelude.return (WdColumnBreak)
     _ -> Prelude.fail (Prelude.userError "unmarshallWdBreakType: illegal enum value ")
data WdTabLeader
 = WdTabLeaderSpaces
 | WdTabLeaderDots
 | WdTabLeaderDashes
 | WdTabLeaderLines
 
marshallWdTabLeader :: WdTabLeader -> Prelude.IO Int.Int16
marshallWdTabLeader v =
  case v of
     WdTabLeaderSpaces -> Prelude.return (0)
     WdTabLeaderDots -> Prelude.return (1)
     WdTabLeaderDashes -> Prelude.return (2)
     WdTabLeaderLines -> Prelude.return (3)
unmarshallWdTabLeader :: Int.Int16 -> Prelude.IO WdTabLeader
unmarshallWdTabLeader v =
  case v of
     0 -> Prelude.return (WdTabLeaderSpaces)
     1 -> Prelude.return (WdTabLeaderDots)
     2 -> Prelude.return (WdTabLeaderDashes)
     3 -> Prelude.return (WdTabLeaderLines)
     _ -> Prelude.fail (Prelude.userError "unmarshallWdTabLeader: illegal enum value ")
data WdTabLeaderHID
 = WdTabLeaderHeavy
 | WdTabLeaderMiddleDot
 
marshallWdTabLeaderHID :: WdTabLeaderHID -> Prelude.IO Int.Int16
marshallWdTabLeaderHID v =
  case v of
     WdTabLeaderHeavy -> Prelude.return (4)
     WdTabLeaderMiddleDot -> Prelude.return (5)
unmarshallWdTabLeaderHID :: Int.Int16 -> Prelude.IO WdTabLeaderHID
unmarshallWdTabLeaderHID v =
  case v of
     4 -> Prelude.return (WdTabLeaderHeavy)
     5 -> Prelude.return (WdTabLeaderMiddleDot)
     _ -> Prelude.fail (Prelude.userError "unmarshallWdTabLeaderHID: illegal enum value ")
data WdMeasurementUnits
 = WdInches
 | WdCentimeters
 | WdPoints
 | WdPicas
 
marshallWdMeasurementUnits :: WdMeasurementUnits -> Prelude.IO Int.Int16
marshallWdMeasurementUnits v =
  case v of
     WdInches -> Prelude.return (0)
     WdCentimeters -> Prelude.return (1)
     WdPoints -> Prelude.return (3)
     WdPicas -> Prelude.return (4)
unmarshallWdMeasurementUnits :: Int.Int16 -> Prelude.IO WdMeasurementUnits
unmarshallWdMeasurementUnits v =
  case v of
     0 -> Prelude.return (WdInches)
     1 -> Prelude.return (WdCentimeters)
     3 -> Prelude.return (WdPoints)
     4 -> Prelude.return (WdPicas)
     _ -> Prelude.fail (Prelude.userError "unmarshallWdMeasurementUnits: illegal enum value ")
data WdMeasurementUnitsHID = WdMillimeters
                              
marshallWdMeasurementUnitsHID :: WdMeasurementUnitsHID -> Prelude.IO Int.Int16
marshallWdMeasurementUnitsHID v =
  case v of
     WdMillimeters -> Prelude.return (2)
unmarshallWdMeasurementUnitsHID :: Int.Int16 -> Prelude.IO WdMeasurementUnitsHID
unmarshallWdMeasurementUnitsHID v =
  case v of
     2 -> Prelude.return (WdMillimeters)
     _ -> Prelude.fail (Prelude.userError "unmarshallWdMeasurementUnitsHID: illegal enum value ")
data WdDropPosition
 = WdDropNone
 | WdDropNormal
 | WdDropMargin
 
marshallWdDropPosition :: WdDropPosition -> Prelude.IO Int.Int16
marshallWdDropPosition v =
  case v of
     WdDropNone -> Prelude.return (0)
     WdDropNormal -> Prelude.return (1)
     WdDropMargin -> Prelude.return (2)
unmarshallWdDropPosition :: Int.Int16 -> Prelude.IO WdDropPosition
unmarshallWdDropPosition v =
  case v of
     0 -> Prelude.return (WdDropNone)
     1 -> Prelude.return (WdDropNormal)
     2 -> Prelude.return (WdDropMargin)
     _ -> Prelude.fail (Prelude.userError "unmarshallWdDropPosition: illegal enum value ")
data WdNumberingRule
 = WdRestartContinuous
 | WdRestartSection
 | WdRestartPage
 
marshallWdNumberingRule :: WdNumberingRule -> Prelude.IO Int.Int16
marshallWdNumberingRule v =
  case v of
     WdRestartContinuous -> Prelude.return (0)
     WdRestartSection -> Prelude.return (1)
     WdRestartPage -> Prelude.return (2)
unmarshallWdNumberingRule :: Int.Int16 -> Prelude.IO WdNumberingRule
unmarshallWdNumberingRule v =
  case v of
     0 -> Prelude.return (WdRestartContinuous)
     1 -> Prelude.return (WdRestartSection)
     2 -> Prelude.return (WdRestartPage)
     _ -> Prelude.fail (Prelude.userError "unmarshallWdNumberingRule: illegal enum value ")
data WdFootnoteLocation
 = WdBottomOfPage
 | WdBeneathText
 
marshallWdFootnoteLocation :: WdFootnoteLocation -> Prelude.IO Int.Int16
marshallWdFootnoteLocation v =
  case v of
     WdBottomOfPage -> Prelude.return (0)
     WdBeneathText -> Prelude.return (1)
unmarshallWdFootnoteLocation :: Int.Int16 -> Prelude.IO WdFootnoteLocation
unmarshallWdFootnoteLocation v =
  case v of
     0 -> Prelude.return (WdBottomOfPage)
     1 -> Prelude.return (WdBeneathText)
     _ -> Prelude.fail (Prelude.userError "unmarshallWdFootnoteLocation: illegal enum value ")
data WdEndnoteLocation
 = WdEndOfSection
 | WdEndOfDocument
 
marshallWdEndnoteLocation :: WdEndnoteLocation -> Prelude.IO Int.Int16
marshallWdEndnoteLocation v =
  case v of
     WdEndOfSection -> Prelude.return (0)
     WdEndOfDocument -> Prelude.return (1)
unmarshallWdEndnoteLocation :: Int.Int16 -> Prelude.IO WdEndnoteLocation
unmarshallWdEndnoteLocation v =
  case v of
     0 -> Prelude.return (WdEndOfSection)
     1 -> Prelude.return (WdEndOfDocument)
     _ -> Prelude.fail (Prelude.userError "unmarshallWdEndnoteLocation: illegal enum value ")
data WdSortSeparator
 = WdSortSeparateByTabs
 | WdSortSeparateByCommas
 | WdSortSeparateByDefaultTableSeparator
 
marshallWdSortSeparator :: WdSortSeparator -> Prelude.IO Int.Int16
marshallWdSortSeparator v =
  case v of
     WdSortSeparateByTabs -> Prelude.return (0)
     WdSortSeparateByCommas -> Prelude.return (1)
     WdSortSeparateByDefaultTableSeparator -> Prelude.return (2)
unmarshallWdSortSeparator :: Int.Int16 -> Prelude.IO WdSortSeparator
unmarshallWdSortSeparator v =
  case v of
     0 -> Prelude.return (WdSortSeparateByTabs)
     1 -> Prelude.return (WdSortSeparateByCommas)
     2 -> Prelude.return (WdSortSeparateByDefaultTableSeparator)
     _ -> Prelude.fail (Prelude.userError "unmarshallWdSortSeparator: illegal enum value ")
data WdTableFieldSeparator
 = WdSeparateByParagraphs
 | WdSeparateByTabs
 | WdSeparateByCommas
 | WdSeparateByDefaultListSeparator
 
marshallWdTableFieldSeparator :: WdTableFieldSeparator -> Prelude.IO Int.Int16
marshallWdTableFieldSeparator v =
  case v of
     WdSeparateByParagraphs -> Prelude.return (0)
     WdSeparateByTabs -> Prelude.return (1)
     WdSeparateByCommas -> Prelude.return (2)
     WdSeparateByDefaultListSeparator -> Prelude.return (3)
unmarshallWdTableFieldSeparator :: Int.Int16 -> Prelude.IO WdTableFieldSeparator
unmarshallWdTableFieldSeparator v =
  case v of
     0 -> Prelude.return (WdSeparateByParagraphs)
     1 -> Prelude.return (WdSeparateByTabs)
     2 -> Prelude.return (WdSeparateByCommas)
     3 -> Prelude.return (WdSeparateByDefaultListSeparator)
     _ -> Prelude.fail (Prelude.userError "unmarshallWdTableFieldSeparator: illegal enum value ")
data WdSortFieldType
 = WdSortFieldAlphanumeric
 | WdSortFieldNumeric
 | WdSortFieldDate
 
marshallWdSortFieldType :: WdSortFieldType -> Prelude.IO Int.Int16
marshallWdSortFieldType v =
  case v of
     WdSortFieldAlphanumeric -> Prelude.return (0)
     WdSortFieldNumeric -> Prelude.return (1)
     WdSortFieldDate -> Prelude.return (2)
unmarshallWdSortFieldType :: Int.Int16 -> Prelude.IO WdSortFieldType
unmarshallWdSortFieldType v =
  case v of
     0 -> Prelude.return (WdSortFieldAlphanumeric)
     1 -> Prelude.return (WdSortFieldNumeric)
     2 -> Prelude.return (WdSortFieldDate)
     _ -> Prelude.fail (Prelude.userError "unmarshallWdSortFieldType: illegal enum value ")
data WdSortFieldTypeHID
 = WdSortFieldSyllable
 | WdSortFieldJapanJIS
 | WdSortFieldStroke
 | WdSortFieldKoreaKS
 
marshallWdSortFieldTypeHID :: WdSortFieldTypeHID -> Prelude.IO Int.Int16
marshallWdSortFieldTypeHID v =
  case v of
     WdSortFieldSyllable -> Prelude.return (3)
     WdSortFieldJapanJIS -> Prelude.return (4)
     WdSortFieldStroke -> Prelude.return (5)
     WdSortFieldKoreaKS -> Prelude.return (6)
unmarshallWdSortFieldTypeHID :: Int.Int16 -> Prelude.IO WdSortFieldTypeHID
unmarshallWdSortFieldTypeHID v =
  case v of
     3 -> Prelude.return (WdSortFieldSyllable)
     4 -> Prelude.return (WdSortFieldJapanJIS)
     5 -> Prelude.return (WdSortFieldStroke)
     6 -> Prelude.return (WdSortFieldKoreaKS)
     _ -> Prelude.fail (Prelude.userError "unmarshallWdSortFieldTypeHID: illegal enum value ")
data WdSortOrder
 = WdSortOrderAscending
 | WdSortOrderDescending
 
marshallWdSortOrder :: WdSortOrder -> Prelude.IO Int.Int16
marshallWdSortOrder v =
  case v of
     WdSortOrderAscending -> Prelude.return (0)
     WdSortOrderDescending -> Prelude.return (1)
unmarshallWdSortOrder :: Int.Int16 -> Prelude.IO WdSortOrder
unmarshallWdSortOrder v =
  case v of
     0 -> Prelude.return (WdSortOrderAscending)
     1 -> Prelude.return (WdSortOrderDescending)
     _ -> Prelude.fail (Prelude.userError "unmarshallWdSortOrder: illegal enum value ")
data WdTableFormat
 = WdTableFormatNone
 | WdTableFormatSimple1
 | WdTableFormatSimple2
 | WdTableFormatSimple3
 | WdTableFormatClassic1
 | WdTableFormatClassic2
 | WdTableFormatClassic3
 | WdTableFormatClassic4
 | WdTableFormatColorful1
 | WdTableFormatColorful2
 | WdTableFormatColorful3
 | WdTableFormatColumns1
 | WdTableFormatColumns2
 | WdTableFormatColumns3
 | WdTableFormatColumns4
 | WdTableFormatColumns5
 | WdTableFormatGrid1
 | WdTableFormatGrid2
 | WdTableFormatGrid3
 | WdTableFormatGrid4
 | WdTableFormatGrid5
 | WdTableFormatGrid6
 | WdTableFormatGrid7
 | WdTableFormatGrid8
 | WdTableFormatList1
 | WdTableFormatList2
 | WdTableFormatList3
 | WdTableFormatList4
 | WdTableFormatList5
 | WdTableFormatList6
 | WdTableFormatList7
 | WdTableFormatList8
 | WdTableFormat3DEffects1
 | WdTableFormat3DEffects2
 | WdTableFormat3DEffects3
 | WdTableFormatContemporary
 | WdTableFormatElegant
 | WdTableFormatProfessional
 | WdTableFormatSubtle1
 | WdTableFormatSubtle2
 
marshallWdTableFormat :: WdTableFormat -> Prelude.IO Int.Int16
marshallWdTableFormat v =
  case v of
     WdTableFormatNone -> Prelude.return (0)
     WdTableFormatSimple1 -> Prelude.return (1)
     WdTableFormatSimple2 -> Prelude.return (2)
     WdTableFormatSimple3 -> Prelude.return (3)
     WdTableFormatClassic1 -> Prelude.return (4)
     WdTableFormatClassic2 -> Prelude.return (5)
     WdTableFormatClassic3 -> Prelude.return (6)
     WdTableFormatClassic4 -> Prelude.return (7)
     WdTableFormatColorful1 -> Prelude.return (8)
     WdTableFormatColorful2 -> Prelude.return (9)
     WdTableFormatColorful3 -> Prelude.return (10)
     WdTableFormatColumns1 -> Prelude.return (11)
     WdTableFormatColumns2 -> Prelude.return (12)
     WdTableFormatColumns3 -> Prelude.return (13)
     WdTableFormatColumns4 -> Prelude.return (14)
     WdTableFormatColumns5 -> Prelude.return (15)
     WdTableFormatGrid1 -> Prelude.return (16)
     WdTableFormatGrid2 -> Prelude.return (17)
     WdTableFormatGrid3 -> Prelude.return (18)
     WdTableFormatGrid4 -> Prelude.return (19)
     WdTableFormatGrid5 -> Prelude.return (20)
     WdTableFormatGrid6 -> Prelude.return (21)
     WdTableFormatGrid7 -> Prelude.return (22)
     WdTableFormatGrid8 -> Prelude.return (23)
     WdTableFormatList1 -> Prelude.return (24)
     WdTableFormatList2 -> Prelude.return (25)
     WdTableFormatList3 -> Prelude.return (26)
     WdTableFormatList4 -> Prelude.return (27)
     WdTableFormatList5 -> Prelude.return (28)
     WdTableFormatList6 -> Prelude.return (29)
     WdTableFormatList7 -> Prelude.return (30)
     WdTableFormatList8 -> Prelude.return (31)
     WdTableFormat3DEffects1 -> Prelude.return (32)
     WdTableFormat3DEffects2 -> Prelude.return (33)
     WdTableFormat3DEffects3 -> Prelude.return (34)
     WdTableFormatContemporary -> Prelude.return (35)
     WdTableFormatElegant -> Prelude.return (36)
     WdTableFormatProfessional -> Prelude.return (37)
     WdTableFormatSubtle1 -> Prelude.return (38)
     WdTableFormatSubtle2 -> Prelude.return (39)
unmarshallWdTableFormat :: Int.Int16 -> Prelude.IO WdTableFormat
unmarshallWdTableFormat v =
  case v of
     0 -> Prelude.return (WdTableFormatNone)
     1 -> Prelude.return (WdTableFormatSimple1)
     2 -> Prelude.return (WdTableFormatSimple2)
     3 -> Prelude.return (WdTableFormatSimple3)
     4 -> Prelude.return (WdTableFormatClassic1)
     5 -> Prelude.return (WdTableFormatClassic2)
     6 -> Prelude.return (WdTableFormatClassic3)
     7 -> Prelude.return (WdTableFormatClassic4)
     8 -> Prelude.return (WdTableFormatColorful1)
     9 -> Prelude.return (WdTableFormatColorful2)
     10 -> Prelude.return (WdTableFormatColorful3)
     11 -> Prelude.return (WdTableFormatColumns1)
     12 -> Prelude.return (WdTableFormatColumns2)
     13 -> Prelude.return (WdTableFormatColumns3)
     14 -> Prelude.return (WdTableFormatColumns4)
     15 -> Prelude.return (WdTableFormatColumns5)
     16 -> Prelude.return (WdTableFormatGrid1)
     17 -> Prelude.return (WdTableFormatGrid2)
     18 -> Prelude.return (WdTableFormatGrid3)
     19 -> Prelude.return (WdTableFormatGrid4)
     20 -> Prelude.return (WdTableFormatGrid5)
     21 -> Prelude.return (WdTableFormatGrid6)
     22 -> Prelude.return (WdTableFormatGrid7)
     23 -> Prelude.return (WdTableFormatGrid8)
     24 -> Prelude.return (WdTableFormatList1)
     25 -> Prelude.return (WdTableFormatList2)
     26 -> Prelude.return (WdTableFormatList3)
     27 -> Prelude.return (WdTableFormatList4)
     28 -> Prelude.return (WdTableFormatList5)
     29 -> Prelude.return (WdTableFormatList6)
     30 -> Prelude.return (WdTableFormatList7)
     31 -> Prelude.return (WdTableFormatList8)
     32 -> Prelude.return (WdTableFormat3DEffects1)
     33 -> Prelude.return (WdTableFormat3DEffects2)
     34 -> Prelude.return (WdTableFormat3DEffects3)
     35 -> Prelude.return (WdTableFormatContemporary)
     36 -> Prelude.return (WdTableFormatElegant)
     37 -> Prelude.return (WdTableFormatProfessional)
     38 -> Prelude.return (WdTableFormatSubtle1)
     39 -> Prelude.return (WdTableFormatSubtle2)
     _ -> Prelude.fail (Prelude.userError "unmarshallWdTableFormat: illegal enum value ")
data WdTableFormatApply
 = WdTableFormatApplyBorders
 | WdTableFormatApplyShading
 | WdTableFormatApplyFont
 | WdTableFormatApplyColor
 | WdTableFormatApplyAutoFit
 | WdTableFormatApplyHeadingRows
 | WdTableFormatApplyLastRow
 | WdTableFormatApplyFirstColumn
 | WdTableFormatApplyLastColumn
 
marshallWdTableFormatApply :: WdTableFormatApply -> Prelude.IO Int.Int16
marshallWdTableFormatApply v =
  case v of
     WdTableFormatApplyBorders -> Prelude.return (1)
     WdTableFormatApplyShading -> Prelude.return (2)
     WdTableFormatApplyFont -> Prelude.return (4)
     WdTableFormatApplyColor -> Prelude.return (8)
     WdTableFormatApplyAutoFit -> Prelude.return (16)
     WdTableFormatApplyHeadingRows -> Prelude.return (32)
     WdTableFormatApplyLastRow -> Prelude.return (64)
     WdTableFormatApplyFirstColumn -> Prelude.return (128)
     WdTableFormatApplyLastColumn -> Prelude.return (256)
unmarshallWdTableFormatApply :: Int.Int16 -> Prelude.IO WdTableFormatApply
unmarshallWdTableFormatApply v =
  case v of
     1 -> Prelude.return (WdTableFormatApplyBorders)
     2 -> Prelude.return (WdTableFormatApplyShading)
     4 -> Prelude.return (WdTableFormatApplyFont)
     8 -> Prelude.return (WdTableFormatApplyColor)
     16 -> Prelude.return (WdTableFormatApplyAutoFit)
     32 -> Prelude.return (WdTableFormatApplyHeadingRows)
     64 -> Prelude.return (WdTableFormatApplyLastRow)
     128 -> Prelude.return (WdTableFormatApplyFirstColumn)
     256 -> Prelude.return (WdTableFormatApplyLastColumn)
     _ -> Prelude.fail (Prelude.userError "unmarshallWdTableFormatApply: illegal enum value ")
data WdLanguageID
 = WdLanguageNone
 | WdNoProofing
 | WdDanish
 | WdGerman
 | WdSwissGerman
 | WdEnglishAUS
 | WdEnglishUK
 | WdEnglishUS
 | WdEnglishCanadian
 | WdEnglishNewZealand
 | WdEnglishSouthAfrica
 | WdSpanish
 | WdFrench
 | WdFrenchCanadian
 | WdItalian
 | WdDutch
 | WdNorwegianBokmol
 | WdNorwegianNynorsk
 | WdBrazilianPortuguese
 | WdPortuguese
 | WdFinnish
 | WdSwedish
 | WdCatalan
 | WdGreek
 | WdTurkish
 | WdRussian
 | WdCzech
 | WdHungarian
 | WdPolish
 | WdSlovenian
 | WdBasque
 | WdMalaysian
 | WdJapanese
 | WdKorean
 | WdSimplifiedChinese
 | WdTraditionalChinese
 | WdSwissFrench
 | WdSesotho
 | WdTsonga
 | WdTswana
 | WdVenda
 | WdXhosa
 | WdZulu
 | WdAfrikaans
 | WdArabic
 | WdHebrew
 | WdSlovak
 | WdFarsi
 | WdRomanian
 | WdCroatian
 | WdUkrainian
 | WdByelorussian
 | WdEstonian
 | WdLatvian
 | WdMacedonian
 | WdSerbianLatin
 | WdSerbianCyrillic
 | WdIcelandic
 | WdBelgianFrench
 | WdBelgianDutch
 | WdBulgarian
 | WdMexicanSpanish
 | WdSpanishModernSort
 | WdSwissItalian
 
marshallWdLanguageID :: WdLanguageID -> Prelude.IO Int.Int16
marshallWdLanguageID v =
  case v of
     WdLanguageNone -> Prelude.return (0)
     WdNoProofing -> Prelude.return (1024)
     WdDanish -> Prelude.return (1030)
     WdGerman -> Prelude.return (1031)
     WdSwissGerman -> Prelude.return (2055)
     WdEnglishAUS -> Prelude.return (3081)
     WdEnglishUK -> Prelude.return (2057)
     WdEnglishUS -> Prelude.return (1033)
     WdEnglishCanadian -> Prelude.return (4105)
     WdEnglishNewZealand -> Prelude.return (5129)
     WdEnglishSouthAfrica -> Prelude.return (7177)
     WdSpanish -> Prelude.return (1034)
     WdFrench -> Prelude.return (1036)
     WdFrenchCanadian -> Prelude.return (3084)
     WdItalian -> Prelude.return (1040)
     WdDutch -> Prelude.return (1043)
     WdNorwegianBokmol -> Prelude.return (1044)
     WdNorwegianNynorsk -> Prelude.return (2068)
     WdBrazilianPortuguese -> Prelude.return (1046)
     WdPortuguese -> Prelude.return (2070)
     WdFinnish -> Prelude.return (1035)
     WdSwedish -> Prelude.return (1053)
     WdCatalan -> Prelude.return (1027)
     WdGreek -> Prelude.return (1032)
     WdTurkish -> Prelude.return (1055)
     WdRussian -> Prelude.return (1049)
     WdCzech -> Prelude.return (1029)
     WdHungarian -> Prelude.return (1038)
     WdPolish -> Prelude.return (1045)
     WdSlovenian -> Prelude.return (1060)
     WdBasque -> Prelude.return (1069)
     WdMalaysian -> Prelude.return (1086)
     WdJapanese -> Prelude.return (1041)
     WdKorean -> Prelude.return (1042)
     WdSimplifiedChinese -> Prelude.return (2052)
     WdTraditionalChinese -> Prelude.return (1028)
     WdSwissFrench -> Prelude.return (4108)
     WdSesotho -> Prelude.return (1072)
     WdTsonga -> Prelude.return (1073)
     WdTswana -> Prelude.return (1074)
     WdVenda -> Prelude.return (1075)
     WdXhosa -> Prelude.return (1076)
     WdZulu -> Prelude.return (1077)
     WdAfrikaans -> Prelude.return (1078)
     WdArabic -> Prelude.return (1025)
     WdHebrew -> Prelude.return (1037)
     WdSlovak -> Prelude.return (1051)
     WdFarsi -> Prelude.return (1065)
     WdRomanian -> Prelude.return (1048)
     WdCroatian -> Prelude.return (1050)
     WdUkrainian -> Prelude.return (1058)
     WdByelorussian -> Prelude.return (1059)
     WdEstonian -> Prelude.return (1061)
     WdLatvian -> Prelude.return (1062)
     WdMacedonian -> Prelude.return (1071)
     WdSerbianLatin -> Prelude.return (2074)
     WdSerbianCyrillic -> Prelude.return (3098)
     WdIcelandic -> Prelude.return (1039)
     WdBelgianFrench -> Prelude.return (2060)
     WdBelgianDutch -> Prelude.return (2067)
     WdBulgarian -> Prelude.return (1026)
     WdMexicanSpanish -> Prelude.return (2058)
     WdSpanishModernSort -> Prelude.return (3082)
     WdSwissItalian -> Prelude.return (2064)
unmarshallWdLanguageID :: Int.Int16 -> Prelude.IO WdLanguageID
unmarshallWdLanguageID v =
  case v of
     0 -> Prelude.return (WdLanguageNone)
     1024 -> Prelude.return (WdNoProofing)
     1030 -> Prelude.return (WdDanish)
     1031 -> Prelude.return (WdGerman)
     2055 -> Prelude.return (WdSwissGerman)
     3081 -> Prelude.return (WdEnglishAUS)
     2057 -> Prelude.return (WdEnglishUK)
     1033 -> Prelude.return (WdEnglishUS)
     4105 -> Prelude.return (WdEnglishCanadian)
     5129 -> Prelude.return (WdEnglishNewZealand)
     7177 -> Prelude.return (WdEnglishSouthAfrica)
     1034 -> Prelude.return (WdSpanish)
     1036 -> Prelude.return (WdFrench)
     3084 -> Prelude.return (WdFrenchCanadian)
     1040 -> Prelude.return (WdItalian)
     1043 -> Prelude.return (WdDutch)
     1044 -> Prelude.return (WdNorwegianBokmol)
     2068 -> Prelude.return (WdNorwegianNynorsk)
     1046 -> Prelude.return (WdBrazilianPortuguese)
     2070 -> Prelude.return (WdPortuguese)
     1035 -> Prelude.return (WdFinnish)
     1053 -> Prelude.return (WdSwedish)
     1027 -> Prelude.return (WdCatalan)
     1032 -> Prelude.return (WdGreek)
     1055 -> Prelude.return (WdTurkish)
     1049 -> Prelude.return (WdRussian)
     1029 -> Prelude.return (WdCzech)
     1038 -> Prelude.return (WdHungarian)
     1045 -> Prelude.return (WdPolish)
     1060 -> Prelude.return (WdSlovenian)
     1069 -> Prelude.return (WdBasque)
     1086 -> Prelude.return (WdMalaysian)
     1041 -> Prelude.return (WdJapanese)
     1042 -> Prelude.return (WdKorean)
     2052 -> Prelude.return (WdSimplifiedChinese)
     1028 -> Prelude.return (WdTraditionalChinese)
     4108 -> Prelude.return (WdSwissFrench)
     1072 -> Prelude.return (WdSesotho)
     1073 -> Prelude.return (WdTsonga)
     1074 -> Prelude.return (WdTswana)
     1075 -> Prelude.return (WdVenda)
     1076 -> Prelude.return (WdXhosa)
     1077 -> Prelude.return (WdZulu)
     1078 -> Prelude.return (WdAfrikaans)
     1025 -> Prelude.return (WdArabic)
     1037 -> Prelude.return (WdHebrew)
     1051 -> Prelude.return (WdSlovak)
     1065 -> Prelude.return (WdFarsi)
     1048 -> Prelude.return (WdRomanian)
     1050 -> Prelude.return (WdCroatian)
     1058 -> Prelude.return (WdUkrainian)
     1059 -> Prelude.return (WdByelorussian)
     1061 -> Prelude.return (WdEstonian)
     1062 -> Prelude.return (WdLatvian)
     1071 -> Prelude.return (WdMacedonian)
     2074 -> Prelude.return (WdSerbianLatin)
     3098 -> Prelude.return (WdSerbianCyrillic)
     1039 -> Prelude.return (WdIcelandic)
     2060 -> Prelude.return (WdBelgianFrench)
     2067 -> Prelude.return (WdBelgianDutch)
     1026 -> Prelude.return (WdBulgarian)
     2058 -> Prelude.return (WdMexicanSpanish)
     3082 -> Prelude.return (WdSpanishModernSort)
     2064 -> Prelude.return (WdSwissItalian)
     _ -> Prelude.fail (Prelude.userError "unmarshallWdLanguageID: illegal enum value ")
data WdFieldType
 = WdFieldEmpty
 | WdFieldRef
 | WdFieldIndexEntry
 | WdFieldFootnoteRef
 | WdFieldSet
 | WdFieldIf
 | WdFieldIndex
 | WdFieldTOCEntry
 | WdFieldStyleRef
 | WdFieldRefDoc
 | WdFieldSequence
 | WdFieldTOC
 | WdFieldInfo
 | WdFieldTitle
 | WdFieldSubject
 | WdFieldAuthor
 | WdFieldKeyWord
 | WdFieldComments
 | WdFieldLastSavedBy
 | WdFieldCreateDate
 | WdFieldSaveDate
 | WdFieldPrintDate
 | WdFieldRevisionNum
 | WdFieldEditTime
 | WdFieldNumPages
 | WdFieldNumWords
 | WdFieldNumChars
 | WdFieldFileName
 | WdFieldTemplate
 | WdFieldDate
 | WdFieldTime
 | WdFieldPage
 | WdFieldExpression
 | WdFieldQuote
 | WdFieldInclude
 | WdFieldPageRef
 | WdFieldAsk
 | WdFieldFillIn
 | WdFieldData
 | WdFieldNext
 | WdFieldNextIf
 | WdFieldSkipIf
 | WdFieldMergeRec
 | WdFieldDDE
 | WdFieldDDEAuto
 | WdFieldGlossary
 | WdFieldPrint
 | WdFieldFormula
 | WdFieldGoToButton
 | WdFieldMacroButton
 | WdFieldAutoNumOutline
 | WdFieldAutoNumLegal
 | WdFieldAutoNum
 | WdFieldImport
 | WdFieldLink
 | WdFieldSymbol
 | WdFieldEmbed
 | WdFieldMergeField
 | WdFieldUserName
 | WdFieldUserInitials
 | WdFieldUserAddress
 | WdFieldBarCode
 | WdFieldDocVariable
 | WdFieldSection
 | WdFieldSectionPages
 | WdFieldIncludePicture
 | WdFieldIncludeText
 | WdFieldFileSize
 | WdFieldFormTextInput
 | WdFieldFormCheckBox
 | WdFieldNoteRef
 | WdFieldTOA
 | WdFieldTOAEntry
 | WdFieldMergeSeq
 | WdFieldPrivate
 | WdFieldDatabase
 | WdFieldAutoText
 | WdFieldCompare
 | WdFieldAddin
 | WdFieldSubscriber
 | WdFieldFormDropDown
 | WdFieldAdvance
 | WdFieldDocProperty
 | WdFieldOCX
 | WdFieldHyperlink
 | WdFieldAutoTextList
 | WdFieldListNum
 | WdFieldHTMLActiveX
 
marshallWdFieldType :: WdFieldType -> Prelude.IO Int.Int16
marshallWdFieldType v =
  case v of
     WdFieldEmpty -> Prelude.return ((-1))
     WdFieldRef -> Prelude.return (3)
     WdFieldIndexEntry -> Prelude.return (4)
     WdFieldFootnoteRef -> Prelude.return (5)
     WdFieldSet -> Prelude.return (6)
     WdFieldIf -> Prelude.return (7)
     WdFieldIndex -> Prelude.return (8)
     WdFieldTOCEntry -> Prelude.return (9)
     WdFieldStyleRef -> Prelude.return (10)
     WdFieldRefDoc -> Prelude.return (11)
     WdFieldSequence -> Prelude.return (12)
     WdFieldTOC -> Prelude.return (13)
     WdFieldInfo -> Prelude.return (14)
     WdFieldTitle -> Prelude.return (15)
     WdFieldSubject -> Prelude.return (16)
     WdFieldAuthor -> Prelude.return (17)
     WdFieldKeyWord -> Prelude.return (18)
     WdFieldComments -> Prelude.return (19)
     WdFieldLastSavedBy -> Prelude.return (20)
     WdFieldCreateDate -> Prelude.return (21)
     WdFieldSaveDate -> Prelude.return (22)
     WdFieldPrintDate -> Prelude.return (23)
     WdFieldRevisionNum -> Prelude.return (24)
     WdFieldEditTime -> Prelude.return (25)
     WdFieldNumPages -> Prelude.return (26)
     WdFieldNumWords -> Prelude.return (27)
     WdFieldNumChars -> Prelude.return (28)
     WdFieldFileName -> Prelude.return (29)
     WdFieldTemplate -> Prelude.return (30)
     WdFieldDate -> Prelude.return (31)
     WdFieldTime -> Prelude.return (32)
     WdFieldPage -> Prelude.return (33)
     WdFieldExpression -> Prelude.return (34)
     WdFieldQuote -> Prelude.return (35)
     WdFieldInclude -> Prelude.return (36)
     WdFieldPageRef -> Prelude.return (37)
     WdFieldAsk -> Prelude.return (38)
     WdFieldFillIn -> Prelude.return (39)
     WdFieldData -> Prelude.return (40)
     WdFieldNext -> Prelude.return (41)
     WdFieldNextIf -> Prelude.return (42)
     WdFieldSkipIf -> Prelude.return (43)
     WdFieldMergeRec -> Prelude.return (44)
     WdFieldDDE -> Prelude.return (45)
     WdFieldDDEAuto -> Prelude.return (46)
     WdFieldGlossary -> Prelude.return (47)
     WdFieldPrint -> Prelude.return (48)
     WdFieldFormula -> Prelude.return (49)
     WdFieldGoToButton -> Prelude.return (50)
     WdFieldMacroButton -> Prelude.return (51)
     WdFieldAutoNumOutline -> Prelude.return (52)
     WdFieldAutoNumLegal -> Prelude.return (53)
     WdFieldAutoNum -> Prelude.return (54)
     WdFieldImport -> Prelude.return (55)
     WdFieldLink -> Prelude.return (56)
     WdFieldSymbol -> Prelude.return (57)
     WdFieldEmbed -> Prelude.return (58)
     WdFieldMergeField -> Prelude.return (59)
     WdFieldUserName -> Prelude.return (60)
     WdFieldUserInitials -> Prelude.return (61)
     WdFieldUserAddress -> Prelude.return (62)
     WdFieldBarCode -> Prelude.return (63)
     WdFieldDocVariable -> Prelude.return (64)
     WdFieldSection -> Prelude.return (65)
     WdFieldSectionPages -> Prelude.return (66)
     WdFieldIncludePicture -> Prelude.return (67)
     WdFieldIncludeText -> Prelude.return (68)
     WdFieldFileSize -> Prelude.return (69)
     WdFieldFormTextInput -> Prelude.return (70)
     WdFieldFormCheckBox -> Prelude.return (71)
     WdFieldNoteRef -> Prelude.return (72)
     WdFieldTOA -> Prelude.return (73)
     WdFieldTOAEntry -> Prelude.return (74)
     WdFieldMergeSeq -> Prelude.return (75)
     WdFieldPrivate -> Prelude.return (77)
     WdFieldDatabase -> Prelude.return (78)
     WdFieldAutoText -> Prelude.return (79)
     WdFieldCompare -> Prelude.return (80)
     WdFieldAddin -> Prelude.return (81)
     WdFieldSubscriber -> Prelude.return (82)
     WdFieldFormDropDown -> Prelude.return (83)
     WdFieldAdvance -> Prelude.return (84)
     WdFieldDocProperty -> Prelude.return (85)
     WdFieldOCX -> Prelude.return (87)
     WdFieldHyperlink -> Prelude.return (88)
     WdFieldAutoTextList -> Prelude.return (89)
     WdFieldListNum -> Prelude.return (90)
     WdFieldHTMLActiveX -> Prelude.return (91)
unmarshallWdFieldType :: Int.Int16 -> Prelude.IO WdFieldType
unmarshallWdFieldType v =
  case v of
     (-1) -> Prelude.return (WdFieldEmpty)
     3 -> Prelude.return (WdFieldRef)
     4 -> Prelude.return (WdFieldIndexEntry)
     5 -> Prelude.return (WdFieldFootnoteRef)
     6 -> Prelude.return (WdFieldSet)
     7 -> Prelude.return (WdFieldIf)
     8 -> Prelude.return (WdFieldIndex)
     9 -> Prelude.return (WdFieldTOCEntry)
     10 -> Prelude.return (WdFieldStyleRef)
     11 -> Prelude.return (WdFieldRefDoc)
     12 -> Prelude.return (WdFieldSequence)
     13 -> Prelude.return (WdFieldTOC)
     14 -> Prelude.return (WdFieldInfo)
     15 -> Prelude.return (WdFieldTitle)
     16 -> Prelude.return (WdFieldSubject)
     17 -> Prelude.return (WdFieldAuthor)
     18 -> Prelude.return (WdFieldKeyWord)
     19 -> Prelude.return (WdFieldComments)
     20 -> Prelude.return (WdFieldLastSavedBy)
     21 -> Prelude.return (WdFieldCreateDate)
     22 -> Prelude.return (WdFieldSaveDate)
     23 -> Prelude.return (WdFieldPrintDate)
     24 -> Prelude.return (WdFieldRevisionNum)
     25 -> Prelude.return (WdFieldEditTime)
     26 -> Prelude.return (WdFieldNumPages)
     27 -> Prelude.return (WdFieldNumWords)
     28 -> Prelude.return (WdFieldNumChars)
     29 -> Prelude.return (WdFieldFileName)
     30 -> Prelude.return (WdFieldTemplate)
     31 -> Prelude.return (WdFieldDate)
     32 -> Prelude.return (WdFieldTime)
     33 -> Prelude.return (WdFieldPage)
     34 -> Prelude.return (WdFieldExpression)
     35 -> Prelude.return (WdFieldQuote)
     36 -> Prelude.return (WdFieldInclude)
     37 -> Prelude.return (WdFieldPageRef)
     38 -> Prelude.return (WdFieldAsk)
     39 -> Prelude.return (WdFieldFillIn)
     40 -> Prelude.return (WdFieldData)
     41 -> Prelude.return (WdFieldNext)
     42 -> Prelude.return (WdFieldNextIf)
     43 -> Prelude.return (WdFieldSkipIf)
     44 -> Prelude.return (WdFieldMergeRec)
     45 -> Prelude.return (WdFieldDDE)
     46 -> Prelude.return (WdFieldDDEAuto)
     47 -> Prelude.return (WdFieldGlossary)
     48 -> Prelude.return (WdFieldPrint)
     49 -> Prelude.return (WdFieldFormula)
     50 -> Prelude.return (WdFieldGoToButton)
     51 -> Prelude.return (WdFieldMacroButton)
     52 -> Prelude.return (WdFieldAutoNumOutline)
     53 -> Prelude.return (WdFieldAutoNumLegal)
     54 -> Prelude.return (WdFieldAutoNum)
     55 -> Prelude.return (WdFieldImport)
     56 -> Prelude.return (WdFieldLink)
     57 -> Prelude.return (WdFieldSymbol)
     58 -> Prelude.return (WdFieldEmbed)
     59 -> Prelude.return (WdFieldMergeField)
     60 -> Prelude.return (WdFieldUserName)
     61 -> Prelude.return (WdFieldUserInitials)
     62 -> Prelude.return (WdFieldUserAddress)
     63 -> Prelude.return (WdFieldBarCode)
     64 -> Prelude.return (WdFieldDocVariable)
     65 -> Prelude.return (WdFieldSection)
     66 -> Prelude.return (WdFieldSectionPages)
     67 -> Prelude.return (WdFieldIncludePicture)
     68 -> Prelude.return (WdFieldIncludeText)
     69 -> Prelude.return (WdFieldFileSize)
     70 -> Prelude.return (WdFieldFormTextInput)
     71 -> Prelude.return (WdFieldFormCheckBox)
     72 -> Prelude.return (WdFieldNoteRef)
     73 -> Prelude.return (WdFieldTOA)
     74 -> Prelude.return (WdFieldTOAEntry)
     75 -> Prelude.return (WdFieldMergeSeq)
     77 -> Prelude.return (WdFieldPrivate)
     78 -> Prelude.return (WdFieldDatabase)
     79 -> Prelude.return (WdFieldAutoText)
     80 -> Prelude.return (WdFieldCompare)
     81 -> Prelude.return (WdFieldAddin)
     82 -> Prelude.return (WdFieldSubscriber)
     83 -> Prelude.return (WdFieldFormDropDown)
     84 -> Prelude.return (WdFieldAdvance)
     85 -> Prelude.return (WdFieldDocProperty)
     87 -> Prelude.return (WdFieldOCX)
     88 -> Prelude.return (WdFieldHyperlink)
     89 -> Prelude.return (WdFieldAutoTextList)
     90 -> Prelude.return (WdFieldListNum)
     91 -> Prelude.return (WdFieldHTMLActiveX)
     _ -> Prelude.fail (Prelude.userError "unmarshallWdFieldType: illegal enum value ")
data WdBuiltinStyle
 = WdStyleNormal
 | WdStyleEnvelopeAddress
 | WdStyleEnvelopeReturn
 | WdStyleBodyText
 | WdStyleHeading1
 | WdStyleHeading2
 | WdStyleHeading3
 | WdStyleHeading4
 | WdStyleHeading5
 | WdStyleHeading6
 | WdStyleHeading7
 | WdStyleHeading8
 | WdStyleHeading9
 | WdStyleIndex1
 | WdStyleIndex2
 | WdStyleIndex3
 | WdStyleIndex4
 | WdStyleIndex5
 | WdStyleIndex6
 | WdStyleIndex7
 | WdStyleIndex8
 | WdStyleIndex9
 | WdStyleTOC1
 | WdStyleTOC2
 | WdStyleTOC3
 | WdStyleTOC4
 | WdStyleTOC5
 | WdStyleTOC6
 | WdStyleTOC7
 | WdStyleTOC8
 | WdStyleTOC9
 | WdStyleNormalIndent
 | WdStyleFootnoteText
 | WdStyleCommentText
 | WdStyleHeader
 | WdStyleFooter
 | WdStyleIndexHeading
 | WdStyleCaption
 | WdStyleTableOfFigures
 | WdStyleFootnoteReference
 | WdStyleCommentReference
 | WdStyleLineNumber
 | WdStylePageNumber
 | WdStyleEndnoteReference
 | WdStyleEndnoteText
 | WdStyleTableOfAuthorities
 | WdStyleMacroText
 | WdStyleTOAHeading
 | WdStyleList
 | WdStyleListBullet
 | WdStyleListNumber
 | WdStyleList2
 | WdStyleList3
 | WdStyleList4
 | WdStyleList5
 | WdStyleListBullet2
 | WdStyleListBullet3
 | WdStyleListBullet4
 | WdStyleListBullet5
 | WdStyleListNumber2
 | WdStyleListNumber3
 | WdStyleListNumber4
 | WdStyleListNumber5
 | WdStyleTitle
 | WdStyleClosing
 | WdStyleSignature
 | WdStyleDefaultParagraphFont
 | WdStyleBodyTextIndent
 | WdStyleListContinue
 | WdStyleListContinue2
 | WdStyleListContinue3
 | WdStyleListContinue4
 | WdStyleListContinue5
 | WdStyleMessageHeader
 | WdStyleSubtitle
 | WdStyleSalutation
 | WdStyleDate
 | WdStyleBodyTextFirstIndent
 | WdStyleBodyTextFirstIndent2
 | WdStyleNoteHeading
 | WdStyleBodyText2
 | WdStyleBodyText3
 | WdStyleBodyTextIndent2
 | WdStyleBodyTextIndent3
 | WdStyleBlockQuotation
 | WdStyleHyperlink
 | WdStyleHyperlinkFollowed
 | WdStyleStrong
 | WdStyleEmphasis
 | WdStyleNavPane
 | WdStylePlainText
 
marshallWdBuiltinStyle :: WdBuiltinStyle -> Prelude.IO Int.Int16
marshallWdBuiltinStyle v =
  case v of
     WdStyleNormal -> Prelude.return ((-1))
     WdStyleEnvelopeAddress -> Prelude.return ((-37))
     WdStyleEnvelopeReturn -> Prelude.return ((-38))
     WdStyleBodyText -> Prelude.return ((-67))
     WdStyleHeading1 -> Prelude.return ((-2))
     WdStyleHeading2 -> Prelude.return ((-3))
     WdStyleHeading3 -> Prelude.return ((-4))
     WdStyleHeading4 -> Prelude.return ((-5))
     WdStyleHeading5 -> Prelude.return ((-6))
     WdStyleHeading6 -> Prelude.return ((-7))
     WdStyleHeading7 -> Prelude.return ((-8))
     WdStyleHeading8 -> Prelude.return ((-9))
     WdStyleHeading9 -> Prelude.return ((-10))
     WdStyleIndex1 -> Prelude.return ((-11))
     WdStyleIndex2 -> Prelude.return ((-12))
     WdStyleIndex3 -> Prelude.return ((-13))
     WdStyleIndex4 -> Prelude.return ((-14))
     WdStyleIndex5 -> Prelude.return ((-15))
     WdStyleIndex6 -> Prelude.return ((-16))
     WdStyleIndex7 -> Prelude.return ((-17))
     WdStyleIndex8 -> Prelude.return ((-18))
     WdStyleIndex9 -> Prelude.return ((-19))
     WdStyleTOC1 -> Prelude.return ((-20))
     WdStyleTOC2 -> Prelude.return ((-21))
     WdStyleTOC3 -> Prelude.return ((-22))
     WdStyleTOC4 -> Prelude.return ((-23))
     WdStyleTOC5 -> Prelude.return ((-24))
     WdStyleTOC6 -> Prelude.return ((-25))
     WdStyleTOC7 -> Prelude.return ((-26))
     WdStyleTOC8 -> Prelude.return ((-27))
     WdStyleTOC9 -> Prelude.return ((-28))
     WdStyleNormalIndent -> Prelude.return ((-29))
     WdStyleFootnoteText -> Prelude.return ((-30))
     WdStyleCommentText -> Prelude.return ((-31))
     WdStyleHeader -> Prelude.return ((-32))
     WdStyleFooter -> Prelude.return ((-33))
     WdStyleIndexHeading -> Prelude.return ((-34))
     WdStyleCaption -> Prelude.return ((-35))
     WdStyleTableOfFigures -> Prelude.return ((-36))
     WdStyleFootnoteReference -> Prelude.return ((-39))
     WdStyleCommentReference -> Prelude.return ((-40))
     WdStyleLineNumber -> Prelude.return ((-41))
     WdStylePageNumber -> Prelude.return ((-42))
     WdStyleEndnoteReference -> Prelude.return ((-43))
     WdStyleEndnoteText -> Prelude.return ((-44))
     WdStyleTableOfAuthorities -> Prelude.return ((-45))
     WdStyleMacroText -> Prelude.return ((-46))
     WdStyleTOAHeading -> Prelude.return ((-47))
     WdStyleList -> Prelude.return ((-48))
     WdStyleListBullet -> Prelude.return ((-49))
     WdStyleListNumber -> Prelude.return ((-50))
     WdStyleList2 -> Prelude.return ((-51))
     WdStyleList3 -> Prelude.return ((-52))
     WdStyleList4 -> Prelude.return ((-53))
     WdStyleList5 -> Prelude.return ((-54))
     WdStyleListBullet2 -> Prelude.return ((-55))
     WdStyleListBullet3 -> Prelude.return ((-56))
     WdStyleListBullet4 -> Prelude.return ((-57))
     WdStyleListBullet5 -> Prelude.return ((-58))
     WdStyleListNumber2 -> Prelude.return ((-59))
     WdStyleListNumber3 -> Prelude.return ((-60))
     WdStyleListNumber4 -> Prelude.return ((-61))
     WdStyleListNumber5 -> Prelude.return ((-62))
     WdStyleTitle -> Prelude.return ((-63))
     WdStyleClosing -> Prelude.return ((-64))
     WdStyleSignature -> Prelude.return ((-65))
     WdStyleDefaultParagraphFont -> Prelude.return ((-66))
     WdStyleBodyTextIndent -> Prelude.return ((-68))
     WdStyleListContinue -> Prelude.return ((-69))
     WdStyleListContinue2 -> Prelude.return ((-70))
     WdStyleListContinue3 -> Prelude.return ((-71))
     WdStyleListContinue4 -> Prelude.return ((-72))
     WdStyleListContinue5 -> Prelude.return ((-73))
     WdStyleMessageHeader -> Prelude.return ((-74))
     WdStyleSubtitle -> Prelude.return ((-75))
     WdStyleSalutation -> Prelude.return ((-76))
     WdStyleDate -> Prelude.return ((-77))
     WdStyleBodyTextFirstIndent -> Prelude.return ((-78))
     WdStyleBodyTextFirstIndent2 -> Prelude.return ((-79))
     WdStyleNoteHeading -> Prelude.return ((-80))
     WdStyleBodyText2 -> Prelude.return ((-81))
     WdStyleBodyText3 -> Prelude.return ((-82))
     WdStyleBodyTextIndent2 -> Prelude.return ((-83))
     WdStyleBodyTextIndent3 -> Prelude.return ((-84))
     WdStyleBlockQuotation -> Prelude.return ((-85))
     WdStyleHyperlink -> Prelude.return ((-86))
     WdStyleHyperlinkFollowed -> Prelude.return ((-87))
     WdStyleStrong -> Prelude.return ((-88))
     WdStyleEmphasis -> Prelude.return ((-89))
     WdStyleNavPane -> Prelude.return ((-90))
     WdStylePlainText -> Prelude.return ((-91))
unmarshallWdBuiltinStyle :: Int.Int16 -> Prelude.IO WdBuiltinStyle
unmarshallWdBuiltinStyle v =
  case v of
     (-1) -> Prelude.return (WdStyleNormal)
     (-37) -> Prelude.return (WdStyleEnvelopeAddress)
     (-38) -> Prelude.return (WdStyleEnvelopeReturn)
     (-67) -> Prelude.return (WdStyleBodyText)
     (-2) -> Prelude.return (WdStyleHeading1)
     (-3) -> Prelude.return (WdStyleHeading2)
     (-4) -> Prelude.return (WdStyleHeading3)
     (-5) -> Prelude.return (WdStyleHeading4)
     (-6) -> Prelude.return (WdStyleHeading5)
     (-7) -> Prelude.return (WdStyleHeading6)
     (-8) -> Prelude.return (WdStyleHeading7)
     (-9) -> Prelude.return (WdStyleHeading8)
     (-10) -> Prelude.return (WdStyleHeading9)
     (-11) -> Prelude.return (WdStyleIndex1)
     (-12) -> Prelude.return (WdStyleIndex2)
     (-13) -> Prelude.return (WdStyleIndex3)
     (-14) -> Prelude.return (WdStyleIndex4)
     (-15) -> Prelude.return (WdStyleIndex5)
     (-16) -> Prelude.return (WdStyleIndex6)
     (-17) -> Prelude.return (WdStyleIndex7)
     (-18) -> Prelude.return (WdStyleIndex8)
     (-19) -> Prelude.return (WdStyleIndex9)
     (-20) -> Prelude.return (WdStyleTOC1)
     (-21) -> Prelude.return (WdStyleTOC2)
     (-22) -> Prelude.return (WdStyleTOC3)
     (-23) -> Prelude.return (WdStyleTOC4)
     (-24) -> Prelude.return (WdStyleTOC5)
     (-25) -> Prelude.return (WdStyleTOC6)
     (-26) -> Prelude.return (WdStyleTOC7)
     (-27) -> Prelude.return (WdStyleTOC8)
     (-28) -> Prelude.return (WdStyleTOC9)
     (-29) -> Prelude.return (WdStyleNormalIndent)
     (-30) -> Prelude.return (WdStyleFootnoteText)
     (-31) -> Prelude.return (WdStyleCommentText)
     (-32) -> Prelude.return (WdStyleHeader)
     (-33) -> Prelude.return (WdStyleFooter)
     (-34) -> Prelude.return (WdStyleIndexHeading)
     (-35) -> Prelude.return (WdStyleCaption)
     (-36) -> Prelude.return (WdStyleTableOfFigures)
     (-39) -> Prelude.return (WdStyleFootnoteReference)
     (-40) -> Prelude.return (WdStyleCommentReference)
     (-41) -> Prelude.return (WdStyleLineNumber)
     (-42) -> Prelude.return (WdStylePageNumber)
     (-43) -> Prelude.return (WdStyleEndnoteReference)
     (-44) -> Prelude.return (WdStyleEndnoteText)
     (-45) -> Prelude.return (WdStyleTableOfAuthorities)
     (-46) -> Prelude.return (WdStyleMacroText)
     (-47) -> Prelude.return (WdStyleTOAHeading)
     (-48) -> Prelude.return (WdStyleList)
     (-49) -> Prelude.return (WdStyleListBullet)
     (-50) -> Prelude.return (WdStyleListNumber)
     (-51) -> Prelude.return (WdStyleList2)
     (-52) -> Prelude.return (WdStyleList3)
     (-53) -> Prelude.return (WdStyleList4)
     (-54) -> Prelude.return (WdStyleList5)
     (-55) -> Prelude.return (WdStyleListBullet2)
     (-56) -> Prelude.return (WdStyleListBullet3)
     (-57) -> Prelude.return (WdStyleListBullet4)
     (-58) -> Prelude.return (WdStyleListBullet5)
     (-59) -> Prelude.return (WdStyleListNumber2)
     (-60) -> Prelude.return (WdStyleListNumber3)
     (-61) -> Prelude.return (WdStyleListNumber4)
     (-62) -> Prelude.return (WdStyleListNumber5)
     (-63) -> Prelude.return (WdStyleTitle)
     (-64) -> Prelude.return (WdStyleClosing)
     (-65) -> Prelude.return (WdStyleSignature)
     (-66) -> Prelude.return (WdStyleDefaultParagraphFont)
     (-68) -> Prelude.return (WdStyleBodyTextIndent)
     (-69) -> Prelude.return (WdStyleListContinue)
     (-70) -> Prelude.return (WdStyleListContinue2)
     (-71) -> Prelude.return (WdStyleListContinue3)
     (-72) -> Prelude.return (WdStyleListContinue4)
     (-73) -> Prelude.return (WdStyleListContinue5)
     (-74) -> Prelude.return (WdStyleMessageHeader)
     (-75) -> Prelude.return (WdStyleSubtitle)
     (-76) -> Prelude.return (WdStyleSalutation)
     (-77) -> Prelude.return (WdStyleDate)
     (-78) -> Prelude.return (WdStyleBodyTextFirstIndent)
     (-79) -> Prelude.return (WdStyleBodyTextFirstIndent2)
     (-80) -> Prelude.return (WdStyleNoteHeading)
     (-81) -> Prelude.return (WdStyleBodyText2)
     (-82) -> Prelude.return (WdStyleBodyText3)
     (-83) -> Prelude.return (WdStyleBodyTextIndent2)
     (-84) -> Prelude.return (WdStyleBodyTextIndent3)
     (-85) -> Prelude.return (WdStyleBlockQuotation)
     (-86) -> Prelude.return (WdStyleHyperlink)
     (-87) -> Prelude.return (WdStyleHyperlinkFollowed)
     (-88) -> Prelude.return (WdStyleStrong)
     (-89) -> Prelude.return (WdStyleEmphasis)
     (-90) -> Prelude.return (WdStyleNavPane)
     (-91) -> Prelude.return (WdStylePlainText)
     _ -> Prelude.fail (Prelude.userError "unmarshallWdBuiltinStyle: illegal enum value ")
data WdWordDialogTab
 = WdDialogToolsOptionsTabView
 | WdDialogToolsOptionsTabGeneral
 | WdDialogToolsOptionsTabEdit
 | WdDialogToolsOptionsTabPrint
 | WdDialogToolsOptionsTabSave
 | WdDialogToolsOptionsTabProofread
 | WdDialogToolsOptionsTabTrackChanges
 | WdDialogToolsOptionsTabUserInfo
 | WdDialogToolsOptionsTabCompatibility
 | WdDialogToolsOptionsTabFileLocations
 | WdDialogFilePageSetupTabMargins
 | WdDialogFilePageSetupTabPaperSize
 | WdDialogFilePageSetupTabPaperSource
 | WdDialogFilePageSetupTabLayout
 | WdDialogInsertSymbolTabSymbols
 | WdDialogInsertSymbolTabSpecialCharacters
 | WdDialogNoteOptionsTabAllFootnotes
 | WdDialogNoteOptionsTabAllEndnotes
 | WdDialogInsertIndexAndTablesTabIndex
 | WdDialogInsertIndexAndTablesTabTableOfContents
 | WdDialogInsertIndexAndTablesTabTableOfFigures
 | WdDialogInsertIndexAndTablesTabTableOfAuthorities
 | WdDialogOrganizerTabStyles
 | WdDialogOrganizerTabAutoText
 | WdDialogOrganizerTabCommandBars
 | WdDialogOrganizerTabMacros
 | WdDialogFormatFontTabFont
 | WdDialogFormatFontTabCharacterSpacing
 | WdDialogFormatFontTabAnimation
 | WdDialogFormatBordersAndShadingTabBorders
 | WdDialogFormatBordersAndShadingTabPageBorder
 | WdDialogFormatBordersAndShadingTabShading
 | WdDialogToolsEnvelopesAndLabelsTabEnvelopes
 | WdDialogToolsEnvelopesAndLabelsTabLabels
 | WdDialogFormatParagraphTabIndentsAndSpacing
 | WdDialogFormatParagraphTabTextFlow
 | WdDialogFormatDrawingObjectTabColorsAndLines
 | WdDialogFormatDrawingObjectTabSize
 | WdDialogFormatDrawingObjectTabPosition
 | WdDialogFormatDrawingObjectTabWrapping
 | WdDialogFormatDrawingObjectTabPicture
 | WdDialogFormatDrawingObjectTabTextbox
 | WdDialogToolsAutoCorrectExceptionsTabFirstLetter
 | WdDialogToolsAutoCorrectExceptionsTabInitialCaps
 | WdDialogFormatBulletsAndNumberingTabBulleted
 | WdDialogFormatBulletsAndNumberingTabNumbered
 | WdDialogFormatBulletsAndNumberingTabOutlineNumbered
 | WdDialogLetterWizardTabLetterFormat
 | WdDialogLetterWizardTabRecipientInfo
 | WdDialogLetterWizardTabOtherElements
 | WdDialogLetterWizardTabSenderInfo
 | WdDialogToolsAutoManagerTabAutoCorrect
 | WdDialogToolsAutoManagerTabAutoFormatAsYouType
 | WdDialogToolsAutoManagerTabAutoText
 | WdDialogToolsAutoManagerTabAutoFormat
 
marshallWdWordDialogTab :: WdWordDialogTab -> Prelude.IO Int.Int16
marshallWdWordDialogTab v =
  case v of
     WdDialogToolsOptionsTabView -> Prelude.return (204)
     WdDialogToolsOptionsTabGeneral -> Prelude.return (203)
     WdDialogToolsOptionsTabEdit -> Prelude.return (224)
     WdDialogToolsOptionsTabPrint -> Prelude.return (208)
     WdDialogToolsOptionsTabSave -> Prelude.return (209)
     WdDialogToolsOptionsTabProofread -> Prelude.return (211)
     WdDialogToolsOptionsTabTrackChanges -> Prelude.return (386)
     WdDialogToolsOptionsTabUserInfo -> Prelude.return (213)
     WdDialogToolsOptionsTabCompatibility -> Prelude.return (525)
     WdDialogToolsOptionsTabFileLocations -> Prelude.return (225)
     WdDialogFilePageSetupTabMargins -> Prelude.return (150000)
     WdDialogFilePageSetupTabPaperSize -> Prelude.return (150001)
     WdDialogFilePageSetupTabPaperSource -> Prelude.return (150002)
     WdDialogFilePageSetupTabLayout -> Prelude.return (150003)
     WdDialogInsertSymbolTabSymbols -> Prelude.return (200000)
     WdDialogInsertSymbolTabSpecialCharacters -> Prelude.return (200001)
     WdDialogNoteOptionsTabAllFootnotes -> Prelude.return (300000)
     WdDialogNoteOptionsTabAllEndnotes -> Prelude.return (300001)
     WdDialogInsertIndexAndTablesTabIndex -> Prelude.return (400000)
     WdDialogInsertIndexAndTablesTabTableOfContents -> Prelude.return (400001)
     WdDialogInsertIndexAndTablesTabTableOfFigures -> Prelude.return (400002)
     WdDialogInsertIndexAndTablesTabTableOfAuthorities -> Prelude.return (400003)
     WdDialogOrganizerTabStyles -> Prelude.return (500000)
     WdDialogOrganizerTabAutoText -> Prelude.return (500001)
     WdDialogOrganizerTabCommandBars -> Prelude.return (500002)
     WdDialogOrganizerTabMacros -> Prelude.return (500003)
     WdDialogFormatFontTabFont -> Prelude.return (600000)
     WdDialogFormatFontTabCharacterSpacing -> Prelude.return (600001)
     WdDialogFormatFontTabAnimation -> Prelude.return (600002)
     WdDialogFormatBordersAndShadingTabBorders -> Prelude.return (700000)
     WdDialogFormatBordersAndShadingTabPageBorder -> Prelude.return (700001)
     WdDialogFormatBordersAndShadingTabShading -> Prelude.return (700002)
     WdDialogToolsEnvelopesAndLabelsTabEnvelopes -> Prelude.return (800000)
     WdDialogToolsEnvelopesAndLabelsTabLabels -> Prelude.return (800001)
     WdDialogFormatParagraphTabIndentsAndSpacing -> Prelude.return (1000000)
     WdDialogFormatParagraphTabTextFlow -> Prelude.return (1000001)
     WdDialogFormatDrawingObjectTabColorsAndLines -> Prelude.return (1200000)
     WdDialogFormatDrawingObjectTabSize -> Prelude.return (1200001)
     WdDialogFormatDrawingObjectTabPosition -> Prelude.return (1200002)
     WdDialogFormatDrawingObjectTabWrapping -> Prelude.return (1200003)
     WdDialogFormatDrawingObjectTabPicture -> Prelude.return (1200004)
     WdDialogFormatDrawingObjectTabTextbox -> Prelude.return (1200005)
     WdDialogToolsAutoCorrectExceptionsTabFirstLetter -> Prelude.return (1400000)
     WdDialogToolsAutoCorrectExceptionsTabInitialCaps -> Prelude.return (1400001)
     WdDialogFormatBulletsAndNumberingTabBulleted -> Prelude.return (1500000)
     WdDialogFormatBulletsAndNumberingTabNumbered -> Prelude.return (1500001)
     WdDialogFormatBulletsAndNumberingTabOutlineNumbered -> Prelude.return (1500002)
     WdDialogLetterWizardTabLetterFormat -> Prelude.return (1600000)
     WdDialogLetterWizardTabRecipientInfo -> Prelude.return (1600001)
     WdDialogLetterWizardTabOtherElements -> Prelude.return (1600002)
     WdDialogLetterWizardTabSenderInfo -> Prelude.return (1600003)
     WdDialogToolsAutoManagerTabAutoCorrect -> Prelude.return (1700000)
     WdDialogToolsAutoManagerTabAutoFormatAsYouType -> Prelude.return (1700001)
     WdDialogToolsAutoManagerTabAutoText -> Prelude.return (1700002)
     WdDialogToolsAutoManagerTabAutoFormat -> Prelude.return (1700003)
unmarshallWdWordDialogTab :: Int.Int16 -> Prelude.IO WdWordDialogTab
unmarshallWdWordDialogTab v =
  case v of
     204 -> Prelude.return (WdDialogToolsOptionsTabView)
     203 -> Prelude.return (WdDialogToolsOptionsTabGeneral)
     224 -> Prelude.return (WdDialogToolsOptionsTabEdit)
     208 -> Prelude.return (WdDialogToolsOptionsTabPrint)
     209 -> Prelude.return (WdDialogToolsOptionsTabSave)
     211 -> Prelude.return (WdDialogToolsOptionsTabProofread)
     386 -> Prelude.return (WdDialogToolsOptionsTabTrackChanges)
     213 -> Prelude.return (WdDialogToolsOptionsTabUserInfo)
     525 -> Prelude.return (WdDialogToolsOptionsTabCompatibility)
     225 -> Prelude.return (WdDialogToolsOptionsTabFileLocations)
     150000 -> Prelude.return (WdDialogFilePageSetupTabMargins)
     150001 -> Prelude.return (WdDialogFilePageSetupTabPaperSize)
     150002 -> Prelude.return (WdDialogFilePageSetupTabPaperSource)
     150003 -> Prelude.return (WdDialogFilePageSetupTabLayout)
     200000 -> Prelude.return (WdDialogInsertSymbolTabSymbols)
     200001 -> Prelude.return (WdDialogInsertSymbolTabSpecialCharacters)
     300000 -> Prelude.return (WdDialogNoteOptionsTabAllFootnotes)
     300001 -> Prelude.return (WdDialogNoteOptionsTabAllEndnotes)
     400000 -> Prelude.return (WdDialogInsertIndexAndTablesTabIndex)
     400001 -> Prelude.return (WdDialogInsertIndexAndTablesTabTableOfContents)
     400002 -> Prelude.return (WdDialogInsertIndexAndTablesTabTableOfFigures)
     400003 -> Prelude.return (WdDialogInsertIndexAndTablesTabTableOfAuthorities)
     500000 -> Prelude.return (WdDialogOrganizerTabStyles)
     500001 -> Prelude.return (WdDialogOrganizerTabAutoText)
     500002 -> Prelude.return (WdDialogOrganizerTabCommandBars)
     500003 -> Prelude.return (WdDialogOrganizerTabMacros)
     600000 -> Prelude.return (WdDialogFormatFontTabFont)
     600001 -> Prelude.return (WdDialogFormatFontTabCharacterSpacing)
     600002 -> Prelude.return (WdDialogFormatFontTabAnimation)
     700000 -> Prelude.return (WdDialogFormatBordersAndShadingTabBorders)
     700001 -> Prelude.return (WdDialogFormatBordersAndShadingTabPageBorder)
     700002 -> Prelude.return (WdDialogFormatBordersAndShadingTabShading)
     800000 -> Prelude.return (WdDialogToolsEnvelopesAndLabelsTabEnvelopes)
     800001 -> Prelude.return (WdDialogToolsEnvelopesAndLabelsTabLabels)
     1000000 -> Prelude.return (WdDialogFormatParagraphTabIndentsAndSpacing)
     1000001 -> Prelude.return (WdDialogFormatParagraphTabTextFlow)
     1200000 -> Prelude.return (WdDialogFormatDrawingObjectTabColorsAndLines)
     1200001 -> Prelude.return (WdDialogFormatDrawingObjectTabSize)
     1200002 -> Prelude.return (WdDialogFormatDrawingObjectTabPosition)
     1200003 -> Prelude.return (WdDialogFormatDrawingObjectTabWrapping)
     1200004 -> Prelude.return (WdDialogFormatDrawingObjectTabPicture)
     1200005 -> Prelude.return (WdDialogFormatDrawingObjectTabTextbox)
     1400000 -> Prelude.return (WdDialogToolsAutoCorrectExceptionsTabFirstLetter)
     1400001 -> Prelude.return (WdDialogToolsAutoCorrectExceptionsTabInitialCaps)
     1500000 -> Prelude.return (WdDialogFormatBulletsAndNumberingTabBulleted)
     1500001 -> Prelude.return (WdDialogFormatBulletsAndNumberingTabNumbered)
     1500002 -> Prelude.return (WdDialogFormatBulletsAndNumberingTabOutlineNumbered)
     1600000 -> Prelude.return (WdDialogLetterWizardTabLetterFormat)
     1600001 -> Prelude.return (WdDialogLetterWizardTabRecipientInfo)
     1600002 -> Prelude.return (WdDialogLetterWizardTabOtherElements)
     1600003 -> Prelude.return (WdDialogLetterWizardTabSenderInfo)
     1700000 -> Prelude.return (WdDialogToolsAutoManagerTabAutoCorrect)
     1700001 -> Prelude.return (WdDialogToolsAutoManagerTabAutoFormatAsYouType)
     1700002 -> Prelude.return (WdDialogToolsAutoManagerTabAutoText)
     1700003 -> Prelude.return (WdDialogToolsAutoManagerTabAutoFormat)
     _ -> Prelude.fail (Prelude.userError "unmarshallWdWordDialogTab: illegal enum value ")
data WdWordDialogTabHID
 = WdDialogToolsOptionsTabTypography
 | WdDialogToolsOptionsTabFuzzy
 | WdDialogToolsOptionsTabHangulHanjaConversion
 | WdDialogFilePageSetupTabCharsLines
 | WdDialogFormatParagraphTabTeisai
 | WdDialogToolsAutoCorrectExceptionsTabHangulAndAlphabet
 
marshallWdWordDialogTabHID :: WdWordDialogTabHID -> Prelude.IO Int.Int16
marshallWdWordDialogTabHID v =
  case v of
     WdDialogToolsOptionsTabTypography -> Prelude.return (739)
     WdDialogToolsOptionsTabFuzzy -> Prelude.return (790)
     WdDialogToolsOptionsTabHangulHanjaConversion -> Prelude.return (786)
     WdDialogFilePageSetupTabCharsLines -> Prelude.return (150004)
     WdDialogFormatParagraphTabTeisai -> Prelude.return (1000002)
     WdDialogToolsAutoCorrectExceptionsTabHangulAndAlphabet -> Prelude.return (1400002)
unmarshallWdWordDialogTabHID :: Int.Int16 -> Prelude.IO WdWordDialogTabHID
unmarshallWdWordDialogTabHID v =
  case v of
     739 -> Prelude.return (WdDialogToolsOptionsTabTypography)
     790 -> Prelude.return (WdDialogToolsOptionsTabFuzzy)
     786 -> Prelude.return (WdDialogToolsOptionsTabHangulHanjaConversion)
     150004 -> Prelude.return (WdDialogFilePageSetupTabCharsLines)
     1000002 -> Prelude.return (WdDialogFormatParagraphTabTeisai)
     1400002 -> Prelude.return (WdDialogToolsAutoCorrectExceptionsTabHangulAndAlphabet)
     _ -> Prelude.fail (Prelude.userError "unmarshallWdWordDialogTabHID: illegal enum value ")
data WdWordDialog
 = WdDialogHelpAbout
 | WdDialogHelpWordPerfectHelp
 | WdDialogHelpWordPerfectHelpOptions
 | WdDialogFormatChangeCase
 | WdDialogToolsWordCount
 | WdDialogDocumentStatistics
 | WdDialogFileNew
 | WdDialogFileOpen
 | WdDialogMailMergeOpenDataSource
 | WdDialogMailMergeOpenHeaderSource
 | WdDialogMailMergeUseAddressBook
 | WdDialogFileSaveAs
 | WdDialogFileSummaryInfo
 | WdDialogToolsTemplates
 | WdDialogOrganizer
 | WdDialogFilePrint
 | WdDialogMailMerge
 | WdDialogMailMergeCheck
 | WdDialogMailMergeQueryOptions
 | WdDialogMailMergeFindRecord
 | WdDialogMailMergeInsertIf
 | WdDialogMailMergeInsertNextIf
 | WdDialogMailMergeInsertSkipIf
 | WdDialogMailMergeInsertFillIn
 | WdDialogMailMergeInsertAsk
 | WdDialogMailMergeInsertSet
 | WdDialogMailMergeHelper
 | WdDialogLetterWizard
 | WdDialogFilePrintSetup
 | WdDialogFileFind
 | WdDialogMailMergeCreateDataSource
 | WdDialogMailMergeCreateHeaderSource
 | WdDialogEditPasteSpecial
 | WdDialogEditFind
 | WdDialogEditReplace
 | WdDialogEditGoToOld
 | WdDialogEditGoTo
 | WdDialogCreateAutoText
 | WdDialogEditAutoText
 | WdDialogEditLinks
 | WdDialogEditObject
 | WdDialogConvertObject
 | WdDialogTableToText
 | WdDialogTextToTable
 | WdDialogTableInsertTable
 | WdDialogTableInsertCells
 | WdDialogTableInsertRow
 | WdDialogTableDeleteCells
 | WdDialogTableSplitCells
 | WdDialogTableFormula
 | WdDialogTableAutoFormat
 | WdDialogTableFormatCell
 | WdDialogViewZoom
 | WdDialogNewToolbar
 | WdDialogInsertBreak
 | WdDialogInsertFootnote
 | WdDialogInsertSymbol
 | WdDialogInsertPicture
 | WdDialogInsertFile
 | WdDialogInsertDateTime
 | WdDialogInsertField
 | WdDialogInsertDatabase
 | WdDialogInsertMergeField
 | WdDialogInsertBookmark
 | WdDialogMarkIndexEntry
 | WdDialogMarkCitation
 | WdDialogEditTOACategory
 | WdDialogInsertIndexAndTables
 | WdDialogInsertIndex
 | WdDialogInsertTableOfContents
 | WdDialogMarkTableOfContentsEntry
 | WdDialogInsertTableOfFigures
 | WdDialogInsertTableOfAuthorities
 | WdDialogInsertObject
 | WdDialogFormatCallout
 | WdDialogDrawSnapToGrid
 | WdDialogDrawAlign
 | WdDialogToolsEnvelopesAndLabels
 | WdDialogToolsCreateEnvelope
 | WdDialogToolsCreateLabels
 | WdDialogToolsProtectDocument
 | WdDialogToolsProtectSection
 | WdDialogToolsUnprotectDocument
 | WdDialogFormatFont
 | WdDialogFormatParagraph
 | WdDialogFormatSectionLayout
 | WdDialogFormatColumns
 | WdDialogFileDocumentLayout
 | WdDialogFileMacPageSetup
 | WdDialogFilePrintOneCopy
 | WdDialogFileMacPageSetupGX
 | WdDialogFileMacCustomPageSetupGX
 | WdDialogFilePageSetup
 | WdDialogFormatTabs
 | WdDialogFormatStyle
 | WdDialogFormatStyleGallery
 | WdDialogFormatDefineStyleFont
 | WdDialogFormatDefineStylePara
 | WdDialogFormatDefineStyleTabs
 | WdDialogFormatDefineStyleFrame
 | WdDialogFormatDefineStyleBorders
 | WdDialogFormatDefineStyleLang
 | WdDialogFormatPicture
 | WdDialogToolsLanguage
 | WdDialogFormatBordersAndShading
 | WdDialogFormatDrawingObject
 | WdDialogFormatFrame
 | WdDialogFormatDropCap
 | WdDialogFormatBulletsAndNumbering
 | WdDialogToolsHyphenation
 | WdDialogToolsBulletsNumbers
 | WdDialogToolsHighlightChanges
 | WdDialogToolsAcceptRejectChanges
 | WdDialogToolsMergeDocuments
 | WdDialogToolsCompareDocuments
 | WdDialogTableSort
 | WdDialogToolsCustomizeMenuBar
 | WdDialogToolsCustomize
 | WdDialogToolsCustomizeKeyboard
 | WdDialogToolsCustomizeMenus
 | WdDialogListCommands
 | WdDialogToolsOptions
 | WdDialogToolsOptionsGeneral
 | WdDialogToolsAdvancedSettings
 | WdDialogToolsOptionsCompatibility
 | WdDialogToolsOptionsPrint
 | WdDialogToolsOptionsSave
 | WdDialogToolsOptionsSpellingAndGrammar
 | WdDialogToolsSpellingAndGrammar
 | WdDialogToolsThesaurus
 | WdDialogToolsOptionsUserInfo
 | WdDialogToolsOptionsAutoFormat
 | WdDialogToolsOptionsTrackChanges
 | WdDialogToolsOptionsEdit
 | WdDialogToolsMacro
 | WdDialogInsertPageNumbers
 | WdDialogFormatPageNumber
 | WdDialogNoteOptions
 | WdDialogCopyFile
 | WdDialogFormatAddrFonts
 | WdDialogFormatRetAddrFonts
 | WdDialogToolsOptionsFileLocations
 | WdDialogToolsCreateDirectory
 | WdDialogUpdateTOC
 | WdDialogInsertFormField
 | WdDialogFormFieldOptions
 | WdDialogInsertCaption
 | WdDialogInsertAutoCaption
 | WdDialogInsertAddCaption
 | WdDialogInsertCaptionNumbering
 | WdDialogInsertCrossReference
 | WdDialogToolsManageFields
 | WdDialogToolsAutoManager
 | WdDialogToolsAutoCorrect
 | WdDialogToolsAutoCorrectExceptions
 | WdDialogConnect
 | WdDialogToolsOptionsView
 | WdDialogInsertSubdocument
 | WdDialogFileRoutingSlip
 | WdDialogFontSubstitution
 | WdDialogEditCreatePublisher
 | WdDialogEditSubscribeTo
 | WdDialogEditPublishOptions
 | WdDialogEditSubscribeOptions
 | WdDialogControlRun
 | WdDialogFileVersions
 | WdDialogToolsAutoSummarize
 | WdDialogFileSaveVersion
 | WdDialogWindowActivate
 | WdDialogToolsMacroRecord
 | WdDialogToolsRevisions
 
marshallWdWordDialog :: WdWordDialog -> Prelude.IO Int.Int16
marshallWdWordDialog v =
  case v of
     WdDialogHelpAbout -> Prelude.return (9)
     WdDialogHelpWordPerfectHelp -> Prelude.return (10)
     WdDialogHelpWordPerfectHelpOptions -> Prelude.return (511)
     WdDialogFormatChangeCase -> Prelude.return (322)
     WdDialogToolsWordCount -> Prelude.return (228)
     WdDialogDocumentStatistics -> Prelude.return (78)
     WdDialogFileNew -> Prelude.return (79)
     WdDialogFileOpen -> Prelude.return (80)
     WdDialogMailMergeOpenDataSource -> Prelude.return (81)
     WdDialogMailMergeOpenHeaderSource -> Prelude.return (82)
     WdDialogMailMergeUseAddressBook -> Prelude.return (779)
     WdDialogFileSaveAs -> Prelude.return (84)
     WdDialogFileSummaryInfo -> Prelude.return (86)
     WdDialogToolsTemplates -> Prelude.return (87)
     WdDialogOrganizer -> Prelude.return (222)
     WdDialogFilePrint -> Prelude.return (88)
     WdDialogMailMerge -> Prelude.return (676)
     WdDialogMailMergeCheck -> Prelude.return (677)
     WdDialogMailMergeQueryOptions -> Prelude.return (681)
     WdDialogMailMergeFindRecord -> Prelude.return (569)
     WdDialogMailMergeInsertIf -> Prelude.return (4049)
     WdDialogMailMergeInsertNextIf -> Prelude.return (4053)
     WdDialogMailMergeInsertSkipIf -> Prelude.return (4055)
     WdDialogMailMergeInsertFillIn -> Prelude.return (4048)
     WdDialogMailMergeInsertAsk -> Prelude.return (4047)
     WdDialogMailMergeInsertSet -> Prelude.return (4054)
     WdDialogMailMergeHelper -> Prelude.return (680)
     WdDialogLetterWizard -> Prelude.return (821)
     WdDialogFilePrintSetup -> Prelude.return (97)
     WdDialogFileFind -> Prelude.return (99)
     WdDialogMailMergeCreateDataSource -> Prelude.return (642)
     WdDialogMailMergeCreateHeaderSource -> Prelude.return (643)
     WdDialogEditPasteSpecial -> Prelude.return (111)
     WdDialogEditFind -> Prelude.return (112)
     WdDialogEditReplace -> Prelude.return (117)
     WdDialogEditGoToOld -> Prelude.return (811)
     WdDialogEditGoTo -> Prelude.return (896)
     WdDialogCreateAutoText -> Prelude.return (872)
     WdDialogEditAutoText -> Prelude.return (985)
     WdDialogEditLinks -> Prelude.return (124)
     WdDialogEditObject -> Prelude.return (125)
     WdDialogConvertObject -> Prelude.return (392)
     WdDialogTableToText -> Prelude.return (128)
     WdDialogTextToTable -> Prelude.return (127)
     WdDialogTableInsertTable -> Prelude.return (129)
     WdDialogTableInsertCells -> Prelude.return (130)
     WdDialogTableInsertRow -> Prelude.return (131)
     WdDialogTableDeleteCells -> Prelude.return (133)
     WdDialogTableSplitCells -> Prelude.return (137)
     WdDialogTableFormula -> Prelude.return (348)
     WdDialogTableAutoFormat -> Prelude.return (563)
     WdDialogTableFormatCell -> Prelude.return (612)
     WdDialogViewZoom -> Prelude.return (577)
     WdDialogNewToolbar -> Prelude.return (586)
     WdDialogInsertBreak -> Prelude.return (159)
     WdDialogInsertFootnote -> Prelude.return (370)
     WdDialogInsertSymbol -> Prelude.return (162)
     WdDialogInsertPicture -> Prelude.return (163)
     WdDialogInsertFile -> Prelude.return (164)
     WdDialogInsertDateTime -> Prelude.return (165)
     WdDialogInsertField -> Prelude.return (166)
     WdDialogInsertDatabase -> Prelude.return (341)
     WdDialogInsertMergeField -> Prelude.return (167)
     WdDialogInsertBookmark -> Prelude.return (168)
     WdDialogMarkIndexEntry -> Prelude.return (169)
     WdDialogMarkCitation -> Prelude.return (463)
     WdDialogEditTOACategory -> Prelude.return (625)
     WdDialogInsertIndexAndTables -> Prelude.return (473)
     WdDialogInsertIndex -> Prelude.return (170)
     WdDialogInsertTableOfContents -> Prelude.return (171)
     WdDialogMarkTableOfContentsEntry -> Prelude.return (442)
     WdDialogInsertTableOfFigures -> Prelude.return (472)
     WdDialogInsertTableOfAuthorities -> Prelude.return (471)
     WdDialogInsertObject -> Prelude.return (172)
     WdDialogFormatCallout -> Prelude.return (610)
     WdDialogDrawSnapToGrid -> Prelude.return (633)
     WdDialogDrawAlign -> Prelude.return (634)
     WdDialogToolsEnvelopesAndLabels -> Prelude.return (607)
     WdDialogToolsCreateEnvelope -> Prelude.return (173)
     WdDialogToolsCreateLabels -> Prelude.return (489)
     WdDialogToolsProtectDocument -> Prelude.return (503)
     WdDialogToolsProtectSection -> Prelude.return (578)
     WdDialogToolsUnprotectDocument -> Prelude.return (521)
     WdDialogFormatFont -> Prelude.return (174)
     WdDialogFormatParagraph -> Prelude.return (175)
     WdDialogFormatSectionLayout -> Prelude.return (176)
     WdDialogFormatColumns -> Prelude.return (177)
     WdDialogFileDocumentLayout -> Prelude.return (178)
     WdDialogFileMacPageSetup -> Prelude.return (685)
     WdDialogFilePrintOneCopy -> Prelude.return (445)
     WdDialogFileMacPageSetupGX -> Prelude.return (444)
     WdDialogFileMacCustomPageSetupGX -> Prelude.return (737)
     WdDialogFilePageSetup -> Prelude.return (178)
     WdDialogFormatTabs -> Prelude.return (179)
     WdDialogFormatStyle -> Prelude.return (180)
     WdDialogFormatStyleGallery -> Prelude.return (505)
     WdDialogFormatDefineStyleFont -> Prelude.return (181)
     WdDialogFormatDefineStylePara -> Prelude.return (182)
     WdDialogFormatDefineStyleTabs -> Prelude.return (183)
     WdDialogFormatDefineStyleFrame -> Prelude.return (184)
     WdDialogFormatDefineStyleBorders -> Prelude.return (185)
     WdDialogFormatDefineStyleLang -> Prelude.return (186)
     WdDialogFormatPicture -> Prelude.return (187)
     WdDialogToolsLanguage -> Prelude.return (188)
     WdDialogFormatBordersAndShading -> Prelude.return (189)
     WdDialogFormatDrawingObject -> Prelude.return (960)
     WdDialogFormatFrame -> Prelude.return (190)
     WdDialogFormatDropCap -> Prelude.return (488)
     WdDialogFormatBulletsAndNumbering -> Prelude.return (824)
     WdDialogToolsHyphenation -> Prelude.return (195)
     WdDialogToolsBulletsNumbers -> Prelude.return (196)
     WdDialogToolsHighlightChanges -> Prelude.return (197)
     WdDialogToolsAcceptRejectChanges -> Prelude.return (506)
     WdDialogToolsMergeDocuments -> Prelude.return (435)
     WdDialogToolsCompareDocuments -> Prelude.return (198)
     WdDialogTableSort -> Prelude.return (199)
     WdDialogToolsCustomizeMenuBar -> Prelude.return (615)
     WdDialogToolsCustomize -> Prelude.return (152)
     WdDialogToolsCustomizeKeyboard -> Prelude.return (432)
     WdDialogToolsCustomizeMenus -> Prelude.return (433)
     WdDialogListCommands -> Prelude.return (723)
     WdDialogToolsOptions -> Prelude.return (974)
     WdDialogToolsOptionsGeneral -> Prelude.return (203)
     WdDialogToolsAdvancedSettings -> Prelude.return (206)
     WdDialogToolsOptionsCompatibility -> Prelude.return (525)
     WdDialogToolsOptionsPrint -> Prelude.return (208)
     WdDialogToolsOptionsSave -> Prelude.return (209)
     WdDialogToolsOptionsSpellingAndGrammar -> Prelude.return (211)
     WdDialogToolsSpellingAndGrammar -> Prelude.return (828)
     WdDialogToolsThesaurus -> Prelude.return (194)
     WdDialogToolsOptionsUserInfo -> Prelude.return (213)
     WdDialogToolsOptionsAutoFormat -> Prelude.return (959)
     WdDialogToolsOptionsTrackChanges -> Prelude.return (386)
     WdDialogToolsOptionsEdit -> Prelude.return (224)
     WdDialogToolsMacro -> Prelude.return (215)
     WdDialogInsertPageNumbers -> Prelude.return (294)
     WdDialogFormatPageNumber -> Prelude.return (298)
     WdDialogNoteOptions -> Prelude.return (373)
     WdDialogCopyFile -> Prelude.return (300)
     WdDialogFormatAddrFonts -> Prelude.return (103)
     WdDialogFormatRetAddrFonts -> Prelude.return (221)
     WdDialogToolsOptionsFileLocations -> Prelude.return (225)
     WdDialogToolsCreateDirectory -> Prelude.return (833)
     WdDialogUpdateTOC -> Prelude.return (331)
     WdDialogInsertFormField -> Prelude.return (483)
     WdDialogFormFieldOptions -> Prelude.return (353)
     WdDialogInsertCaption -> Prelude.return (357)
     WdDialogInsertAutoCaption -> Prelude.return (359)
     WdDialogInsertAddCaption -> Prelude.return (402)
     WdDialogInsertCaptionNumbering -> Prelude.return (358)
     WdDialogInsertCrossReference -> Prelude.return (367)
     WdDialogToolsManageFields -> Prelude.return (631)
     WdDialogToolsAutoManager -> Prelude.return (915)
     WdDialogToolsAutoCorrect -> Prelude.return (378)
     WdDialogToolsAutoCorrectExceptions -> Prelude.return (762)
     WdDialogConnect -> Prelude.return (420)
     WdDialogToolsOptionsView -> Prelude.return (204)
     WdDialogInsertSubdocument -> Prelude.return (583)
     WdDialogFileRoutingSlip -> Prelude.return (624)
     WdDialogFontSubstitution -> Prelude.return (581)
     WdDialogEditCreatePublisher -> Prelude.return (732)
     WdDialogEditSubscribeTo -> Prelude.return (733)
     WdDialogEditPublishOptions -> Prelude.return (735)
     WdDialogEditSubscribeOptions -> Prelude.return (736)
     WdDialogControlRun -> Prelude.return (235)
     WdDialogFileVersions -> Prelude.return (945)
     WdDialogToolsAutoSummarize -> Prelude.return (874)
     WdDialogFileSaveVersion -> Prelude.return (1007)
     WdDialogWindowActivate -> Prelude.return (220)
     WdDialogToolsMacroRecord -> Prelude.return (214)
     WdDialogToolsRevisions -> Prelude.return (197)
unmarshallWdWordDialog :: Int.Int16 -> Prelude.IO WdWordDialog
unmarshallWdWordDialog v =
  case v of
     9 -> Prelude.return (WdDialogHelpAbout)
     10 -> Prelude.return (WdDialogHelpWordPerfectHelp)
     511 -> Prelude.return (WdDialogHelpWordPerfectHelpOptions)
     322 -> Prelude.return (WdDialogFormatChangeCase)
     228 -> Prelude.return (WdDialogToolsWordCount)
     78 -> Prelude.return (WdDialogDocumentStatistics)
     79 -> Prelude.return (WdDialogFileNew)
     80 -> Prelude.return (WdDialogFileOpen)
     81 -> Prelude.return (WdDialogMailMergeOpenDataSource)
     82 -> Prelude.return (WdDialogMailMergeOpenHeaderSource)
     779 -> Prelude.return (WdDialogMailMergeUseAddressBook)
     84 -> Prelude.return (WdDialogFileSaveAs)
     86 -> Prelude.return (WdDialogFileSummaryInfo)
     87 -> Prelude.return (WdDialogToolsTemplates)
     222 -> Prelude.return (WdDialogOrganizer)
     88 -> Prelude.return (WdDialogFilePrint)
     676 -> Prelude.return (WdDialogMailMerge)
     677 -> Prelude.return (WdDialogMailMergeCheck)
     681 -> Prelude.return (WdDialogMailMergeQueryOptions)
     569 -> Prelude.return (WdDialogMailMergeFindRecord)
     4049 -> Prelude.return (WdDialogMailMergeInsertIf)
     4053 -> Prelude.return (WdDialogMailMergeInsertNextIf)
     4055 -> Prelude.return (WdDialogMailMergeInsertSkipIf)
     4048 -> Prelude.return (WdDialogMailMergeInsertFillIn)
     4047 -> Prelude.return (WdDialogMailMergeInsertAsk)
     4054 -> Prelude.return (WdDialogMailMergeInsertSet)
     680 -> Prelude.return (WdDialogMailMergeHelper)
     821 -> Prelude.return (WdDialogLetterWizard)
     97 -> Prelude.return (WdDialogFilePrintSetup)
     99 -> Prelude.return (WdDialogFileFind)
     642 -> Prelude.return (WdDialogMailMergeCreateDataSource)
     643 -> Prelude.return (WdDialogMailMergeCreateHeaderSource)
     111 -> Prelude.return (WdDialogEditPasteSpecial)
     112 -> Prelude.return (WdDialogEditFind)
     117 -> Prelude.return (WdDialogEditReplace)
     811 -> Prelude.return (WdDialogEditGoToOld)
     896 -> Prelude.return (WdDialogEditGoTo)
     872 -> Prelude.return (WdDialogCreateAutoText)
     985 -> Prelude.return (WdDialogEditAutoText)
     124 -> Prelude.return (WdDialogEditLinks)
     125 -> Prelude.return (WdDialogEditObject)
     392 -> Prelude.return (WdDialogConvertObject)
     128 -> Prelude.return (WdDialogTableToText)
     127 -> Prelude.return (WdDialogTextToTable)
     129 -> Prelude.return (WdDialogTableInsertTable)
     130 -> Prelude.return (WdDialogTableInsertCells)
     131 -> Prelude.return (WdDialogTableInsertRow)
     133 -> Prelude.return (WdDialogTableDeleteCells)
     137 -> Prelude.return (WdDialogTableSplitCells)
     348 -> Prelude.return (WdDialogTableFormula)
     563 -> Prelude.return (WdDialogTableAutoFormat)
     612 -> Prelude.return (WdDialogTableFormatCell)
     577 -> Prelude.return (WdDialogViewZoom)
     586 -> Prelude.return (WdDialogNewToolbar)
     159 -> Prelude.return (WdDialogInsertBreak)
     370 -> Prelude.return (WdDialogInsertFootnote)
     162 -> Prelude.return (WdDialogInsertSymbol)
     163 -> Prelude.return (WdDialogInsertPicture)
     164 -> Prelude.return (WdDialogInsertFile)
     165 -> Prelude.return (WdDialogInsertDateTime)
     166 -> Prelude.return (WdDialogInsertField)
     341 -> Prelude.return (WdDialogInsertDatabase)
     167 -> Prelude.return (WdDialogInsertMergeField)
     168 -> Prelude.return (WdDialogInsertBookmark)
     169 -> Prelude.return (WdDialogMarkIndexEntry)
     463 -> Prelude.return (WdDialogMarkCitation)
     625 -> Prelude.return (WdDialogEditTOACategory)
     473 -> Prelude.return (WdDialogInsertIndexAndTables)
     170 -> Prelude.return (WdDialogInsertIndex)
     171 -> Prelude.return (WdDialogInsertTableOfContents)
     442 -> Prelude.return (WdDialogMarkTableOfContentsEntry)
     472 -> Prelude.return (WdDialogInsertTableOfFigures)
     471 -> Prelude.return (WdDialogInsertTableOfAuthorities)
     172 -> Prelude.return (WdDialogInsertObject)
     610 -> Prelude.return (WdDialogFormatCallout)
     633 -> Prelude.return (WdDialogDrawSnapToGrid)
     634 -> Prelude.return (WdDialogDrawAlign)
     607 -> Prelude.return (WdDialogToolsEnvelopesAndLabels)
     173 -> Prelude.return (WdDialogToolsCreateEnvelope)
     489 -> Prelude.return (WdDialogToolsCreateLabels)
     503 -> Prelude.return (WdDialogToolsProtectDocument)
     578 -> Prelude.return (WdDialogToolsProtectSection)
     521 -> Prelude.return (WdDialogToolsUnprotectDocument)
     174 -> Prelude.return (WdDialogFormatFont)
     175 -> Prelude.return (WdDialogFormatParagraph)
     176 -> Prelude.return (WdDialogFormatSectionLayout)
     177 -> Prelude.return (WdDialogFormatColumns)
     178 -> Prelude.return (WdDialogFileDocumentLayout)
     685 -> Prelude.return (WdDialogFileMacPageSetup)
     445 -> Prelude.return (WdDialogFilePrintOneCopy)
     444 -> Prelude.return (WdDialogFileMacPageSetupGX)
     737 -> Prelude.return (WdDialogFileMacCustomPageSetupGX)
     178 -> Prelude.return (WdDialogFilePageSetup)
     179 -> Prelude.return (WdDialogFormatTabs)
     180 -> Prelude.return (WdDialogFormatStyle)
     505 -> Prelude.return (WdDialogFormatStyleGallery)
     181 -> Prelude.return (WdDialogFormatDefineStyleFont)
     182 -> Prelude.return (WdDialogFormatDefineStylePara)
     183 -> Prelude.return (WdDialogFormatDefineStyleTabs)
     184 -> Prelude.return (WdDialogFormatDefineStyleFrame)
     185 -> Prelude.return (WdDialogFormatDefineStyleBorders)
     186 -> Prelude.return (WdDialogFormatDefineStyleLang)
     187 -> Prelude.return (WdDialogFormatPicture)
     188 -> Prelude.return (WdDialogToolsLanguage)
     189 -> Prelude.return (WdDialogFormatBordersAndShading)
     960 -> Prelude.return (WdDialogFormatDrawingObject)
     190 -> Prelude.return (WdDialogFormatFrame)
     488 -> Prelude.return (WdDialogFormatDropCap)
     824 -> Prelude.return (WdDialogFormatBulletsAndNumbering)
     195 -> Prelude.return (WdDialogToolsHyphenation)
     196 -> Prelude.return (WdDialogToolsBulletsNumbers)
     197 -> Prelude.return (WdDialogToolsHighlightChanges)
     506 -> Prelude.return (WdDialogToolsAcceptRejectChanges)
     435 -> Prelude.return (WdDialogToolsMergeDocuments)
     198 -> Prelude.return (WdDialogToolsCompareDocuments)
     199 -> Prelude.return (WdDialogTableSort)
     615 -> Prelude.return (WdDialogToolsCustomizeMenuBar)
     152 -> Prelude.return (WdDialogToolsCustomize)
     432 -> Prelude.return (WdDialogToolsCustomizeKeyboard)
     433 -> Prelude.return (WdDialogToolsCustomizeMenus)
     723 -> Prelude.return (WdDialogListCommands)
     974 -> Prelude.return (WdDialogToolsOptions)
     203 -> Prelude.return (WdDialogToolsOptionsGeneral)
     206 -> Prelude.return (WdDialogToolsAdvancedSettings)
     525 -> Prelude.return (WdDialogToolsOptionsCompatibility)
     208 -> Prelude.return (WdDialogToolsOptionsPrint)
     209 -> Prelude.return (WdDialogToolsOptionsSave)
     211 -> Prelude.return (WdDialogToolsOptionsSpellingAndGrammar)
     828 -> Prelude.return (WdDialogToolsSpellingAndGrammar)
     194 -> Prelude.return (WdDialogToolsThesaurus)
     213 -> Prelude.return (WdDialogToolsOptionsUserInfo)
     959 -> Prelude.return (WdDialogToolsOptionsAutoFormat)
     386 -> Prelude.return (WdDialogToolsOptionsTrackChanges)
     224 -> Prelude.return (WdDialogToolsOptionsEdit)
     215 -> Prelude.return (WdDialogToolsMacro)
     294 -> Prelude.return (WdDialogInsertPageNumbers)
     298 -> Prelude.return (WdDialogFormatPageNumber)
     373 -> Prelude.return (WdDialogNoteOptions)
     300 -> Prelude.return (WdDialogCopyFile)
     103 -> Prelude.return (WdDialogFormatAddrFonts)
     221 -> Prelude.return (WdDialogFormatRetAddrFonts)
     225 -> Prelude.return (WdDialogToolsOptionsFileLocations)
     833 -> Prelude.return (WdDialogToolsCreateDirectory)
     331 -> Prelude.return (WdDialogUpdateTOC)
     483 -> Prelude.return (WdDialogInsertFormField)
     353 -> Prelude.return (WdDialogFormFieldOptions)
     357 -> Prelude.return (WdDialogInsertCaption)
     359 -> Prelude.return (WdDialogInsertAutoCaption)
     402 -> Prelude.return (WdDialogInsertAddCaption)
     358 -> Prelude.return (WdDialogInsertCaptionNumbering)
     367 -> Prelude.return (WdDialogInsertCrossReference)
     631 -> Prelude.return (WdDialogToolsManageFields)
     915 -> Prelude.return (WdDialogToolsAutoManager)
     378 -> Prelude.return (WdDialogToolsAutoCorrect)
     762 -> Prelude.return (WdDialogToolsAutoCorrectExceptions)
     420 -> Prelude.return (WdDialogConnect)
     204 -> Prelude.return (WdDialogToolsOptionsView)
     583 -> Prelude.return (WdDialogInsertSubdocument)
     624 -> Prelude.return (WdDialogFileRoutingSlip)
     581 -> Prelude.return (WdDialogFontSubstitution)
     732 -> Prelude.return (WdDialogEditCreatePublisher)
     733 -> Prelude.return (WdDialogEditSubscribeTo)
     735 -> Prelude.return (WdDialogEditPublishOptions)
     736 -> Prelude.return (WdDialogEditSubscribeOptions)
     235 -> Prelude.return (WdDialogControlRun)
     945 -> Prelude.return (WdDialogFileVersions)
     874 -> Prelude.return (WdDialogToolsAutoSummarize)
     1007 -> Prelude.return (WdDialogFileSaveVersion)
     220 -> Prelude.return (WdDialogWindowActivate)
     214 -> Prelude.return (WdDialogToolsMacroRecord)
     197 -> Prelude.return (WdDialogToolsRevisions)
     _ -> Prelude.fail (Prelude.userError "unmarshallWdWordDialog: illegal enum value ")
data WdWordDialogHID
 = WdDialogToolsOptionsFuzzy
 | WdDialogToolsOptionsTypography
 | WdDialogToolsOptionsAutoFormatAsYouType
 
marshallWdWordDialogHID :: WdWordDialogHID -> Prelude.IO Int.Int16
marshallWdWordDialogHID v =
  case v of
     WdDialogToolsOptionsFuzzy -> Prelude.return (790)
     WdDialogToolsOptionsTypography -> Prelude.return (739)
     WdDialogToolsOptionsAutoFormatAsYouType -> Prelude.return (778)
unmarshallWdWordDialogHID :: Int.Int16 -> Prelude.IO WdWordDialogHID
unmarshallWdWordDialogHID v =
  case v of
     790 -> Prelude.return (WdDialogToolsOptionsFuzzy)
     739 -> Prelude.return (WdDialogToolsOptionsTypography)
     778 -> Prelude.return (WdDialogToolsOptionsAutoFormatAsYouType)
     _ -> Prelude.fail (Prelude.userError "unmarshallWdWordDialogHID: illegal enum value ")
data WdFieldKind
 = WdFieldKindNone
 | WdFieldKindHot
 | WdFieldKindWarm
 | WdFieldKindCold
 
marshallWdFieldKind :: WdFieldKind -> Prelude.IO Int.Int16
marshallWdFieldKind v =
  case v of
     WdFieldKindNone -> Prelude.return (0)
     WdFieldKindHot -> Prelude.return (1)
     WdFieldKindWarm -> Prelude.return (2)
     WdFieldKindCold -> Prelude.return (3)
unmarshallWdFieldKind :: Int.Int16 -> Prelude.IO WdFieldKind
unmarshallWdFieldKind v =
  case v of
     0 -> Prelude.return (WdFieldKindNone)
     1 -> Prelude.return (WdFieldKindHot)
     2 -> Prelude.return (WdFieldKindWarm)
     3 -> Prelude.return (WdFieldKindCold)
     _ -> Prelude.fail (Prelude.userError "unmarshallWdFieldKind: illegal enum value ")
data WdTextFormFieldType
 = WdRegularText
 | WdNumberText
 | WdDateText
 | WdCurrentDateText
 | WdCurrentTimeText
 | WdCalculationText
 
marshallWdTextFormFieldType :: WdTextFormFieldType -> Prelude.IO Int.Int16
marshallWdTextFormFieldType v =
  case v of
     WdRegularText -> Prelude.return (0)
     WdNumberText -> Prelude.return (1)
     WdDateText -> Prelude.return (2)
     WdCurrentDateText -> Prelude.return (3)
     WdCurrentTimeText -> Prelude.return (4)
     WdCalculationText -> Prelude.return (5)
unmarshallWdTextFormFieldType :: Int.Int16 -> Prelude.IO WdTextFormFieldType
unmarshallWdTextFormFieldType v =
  case v of
     0 -> Prelude.return (WdRegularText)
     1 -> Prelude.return (WdNumberText)
     2 -> Prelude.return (WdDateText)
     3 -> Prelude.return (WdCurrentDateText)
     4 -> Prelude.return (WdCurrentTimeText)
     5 -> Prelude.return (WdCalculationText)
     _ -> Prelude.fail (Prelude.userError "unmarshallWdTextFormFieldType: illegal enum value ")
data WdChevronConvertRule
 = WdNeverConvert
 | WdAlwaysConvert
 | WdAskToNotConvert
 | WdAskToConvert
 
marshallWdChevronConvertRule :: WdChevronConvertRule -> Prelude.IO Int.Int16
marshallWdChevronConvertRule v =
  case v of
     WdNeverConvert -> Prelude.return (0)
     WdAlwaysConvert -> Prelude.return (1)
     WdAskToNotConvert -> Prelude.return (2)
     WdAskToConvert -> Prelude.return (3)
unmarshallWdChevronConvertRule :: Int.Int16 -> Prelude.IO WdChevronConvertRule
unmarshallWdChevronConvertRule v =
  case v of
     0 -> Prelude.return (WdNeverConvert)
     1 -> Prelude.return (WdAlwaysConvert)
     2 -> Prelude.return (WdAskToNotConvert)
     3 -> Prelude.return (WdAskToConvert)
     _ -> Prelude.fail (Prelude.userError "unmarshallWdChevronConvertRule: illegal enum value ")
data WdMailMergeMainDocType
 = WdNotAMergeDocument
 | WdFormLetters
 | WdMailingLabels
 | WdEnvelopes
 | WdCatalog
 
marshallWdMailMergeMainDocType :: WdMailMergeMainDocType -> Prelude.IO Int.Int16
marshallWdMailMergeMainDocType v =
  case v of
     WdNotAMergeDocument -> Prelude.return ((-1))
     WdFormLetters -> Prelude.return (0)
     WdMailingLabels -> Prelude.return (1)
     WdEnvelopes -> Prelude.return (2)
     WdCatalog -> Prelude.return (3)
unmarshallWdMailMergeMainDocType :: Int.Int16 -> Prelude.IO WdMailMergeMainDocType
unmarshallWdMailMergeMainDocType v =
  case v of
     (-1) -> Prelude.return (WdNotAMergeDocument)
     0 -> Prelude.return (WdFormLetters)
     1 -> Prelude.return (WdMailingLabels)
     2 -> Prelude.return (WdEnvelopes)
     3 -> Prelude.return (WdCatalog)
     _ -> Prelude.fail (Prelude.userError "unmarshallWdMailMergeMainDocType: illegal enum value ")
data WdMailMergeState
 = WdNormalDocument
 | WdMainDocumentOnly
 | WdMainAndDataSource
 | WdMainAndHeader
 | WdMainAndSourceAndHeader
 | WdDataSource
 
marshallWdMailMergeState :: WdMailMergeState -> Prelude.IO Int.Int16
marshallWdMailMergeState v =
  case v of
     WdNormalDocument -> Prelude.return (0)
     WdMainDocumentOnly -> Prelude.return (1)
     WdMainAndDataSource -> Prelude.return (2)
     WdMainAndHeader -> Prelude.return (3)
     WdMainAndSourceAndHeader -> Prelude.return (4)
     WdDataSource -> Prelude.return (5)
unmarshallWdMailMergeState :: Int.Int16 -> Prelude.IO WdMailMergeState
unmarshallWdMailMergeState v =
  case v of
     0 -> Prelude.return (WdNormalDocument)
     1 -> Prelude.return (WdMainDocumentOnly)
     2 -> Prelude.return (WdMainAndDataSource)
     3 -> Prelude.return (WdMainAndHeader)
     4 -> Prelude.return (WdMainAndSourceAndHeader)
     5 -> Prelude.return (WdDataSource)
     _ -> Prelude.fail (Prelude.userError "unmarshallWdMailMergeState: illegal enum value ")
data WdMailMergeDestination
 = WdSendToNewDocument
 | WdSendToPrinter
 | WdSendToEmail
 | WdSendToFax
 
marshallWdMailMergeDestination :: WdMailMergeDestination -> Prelude.IO Int.Int16
marshallWdMailMergeDestination v =
  case v of
     WdSendToNewDocument -> Prelude.return (0)
     WdSendToPrinter -> Prelude.return (1)
     WdSendToEmail -> Prelude.return (2)
     WdSendToFax -> Prelude.return (3)
unmarshallWdMailMergeDestination :: Int.Int16 -> Prelude.IO WdMailMergeDestination
unmarshallWdMailMergeDestination v =
  case v of
     0 -> Prelude.return (WdSendToNewDocument)
     1 -> Prelude.return (WdSendToPrinter)
     2 -> Prelude.return (WdSendToEmail)
     3 -> Prelude.return (WdSendToFax)
     _ -> Prelude.fail (Prelude.userError "unmarshallWdMailMergeDestination: illegal enum value ")
data WdMailMergeActiveRecord
 = WdNoActiveRecord
 | WdNextRecord
 | WdPreviousRecord
 | WdFirstRecord
 | WdLastRecord
 
marshallWdMailMergeActiveRecord :: WdMailMergeActiveRecord -> Prelude.IO Int.Int16
marshallWdMailMergeActiveRecord v =
  case v of
     WdNoActiveRecord -> Prelude.return ((-1))
     WdNextRecord -> Prelude.return ((-2))
     WdPreviousRecord -> Prelude.return ((-3))
     WdFirstRecord -> Prelude.return ((-4))
     WdLastRecord -> Prelude.return ((-5))
unmarshallWdMailMergeActiveRecord :: Int.Int16 -> Prelude.IO WdMailMergeActiveRecord
unmarshallWdMailMergeActiveRecord v =
  case v of
     (-1) -> Prelude.return (WdNoActiveRecord)
     (-2) -> Prelude.return (WdNextRecord)
     (-3) -> Prelude.return (WdPreviousRecord)
     (-4) -> Prelude.return (WdFirstRecord)
     (-5) -> Prelude.return (WdLastRecord)
     _ -> Prelude.fail (Prelude.userError "unmarshallWdMailMergeActiveRecord: illegal enum value ")
data WdMailMergeDefaultRecord
 = WdDefaultFirstRecord
 | WdDefaultLastRecord
 
marshallWdMailMergeDefaultRecord :: WdMailMergeDefaultRecord -> Prelude.IO Int.Int16
marshallWdMailMergeDefaultRecord v =
  case v of
     WdDefaultFirstRecord -> Prelude.return (1)
     WdDefaultLastRecord -> Prelude.return ((-16))
unmarshallWdMailMergeDefaultRecord :: Int.Int16 -> Prelude.IO WdMailMergeDefaultRecord
unmarshallWdMailMergeDefaultRecord v =
  case v of
     1 -> Prelude.return (WdDefaultFirstRecord)
     (-16) -> Prelude.return (WdDefaultLastRecord)
     _ -> Prelude.fail (Prelude.userError "unmarshallWdMailMergeDefaultRecord: illegal enum value ")
data WdMailMergeDataSource
 = WdNoMergeInfo
 | WdMergeInfoFromWord
 | WdMergeInfoFromAccessDDE
 | WdMergeInfoFromExcelDDE
 | WdMergeInfoFromMSQueryDDE
 | WdMergeInfoFromODBC
 
marshallWdMailMergeDataSource :: WdMailMergeDataSource -> Prelude.IO Int.Int16
marshallWdMailMergeDataSource v =
  case v of
     WdNoMergeInfo -> Prelude.return ((-1))
     WdMergeInfoFromWord -> Prelude.return (0)
     WdMergeInfoFromAccessDDE -> Prelude.return (1)
     WdMergeInfoFromExcelDDE -> Prelude.return (2)
     WdMergeInfoFromMSQueryDDE -> Prelude.return (3)
     WdMergeInfoFromODBC -> Prelude.return (4)
unmarshallWdMailMergeDataSource :: Int.Int16 -> Prelude.IO WdMailMergeDataSource
unmarshallWdMailMergeDataSource v =
  case v of
     (-1) -> Prelude.return (WdNoMergeInfo)
     0 -> Prelude.return (WdMergeInfoFromWord)
     1 -> Prelude.return (WdMergeInfoFromAccessDDE)
     2 -> Prelude.return (WdMergeInfoFromExcelDDE)
     3 -> Prelude.return (WdMergeInfoFromMSQueryDDE)
     4 -> Prelude.return (WdMergeInfoFromODBC)
     _ -> Prelude.fail (Prelude.userError "unmarshallWdMailMergeDataSource: illegal enum value ")
data WdMailMergeComparison
 = WdMergeIfEqual
 | WdMergeIfNotEqual
 | WdMergeIfLessThan
 | WdMergeIfGreaterThan
 | WdMergeIfLessThanOrEqual
 | WdMergeIfGreaterThanOrEqual
 | WdMergeIfIsBlank
 | WdMergeIfIsNotBlank
 
marshallWdMailMergeComparison :: WdMailMergeComparison -> Prelude.IO Int.Int16
marshallWdMailMergeComparison v =
  case v of
     WdMergeIfEqual -> Prelude.return (0)
     WdMergeIfNotEqual -> Prelude.return (1)
     WdMergeIfLessThan -> Prelude.return (2)
     WdMergeIfGreaterThan -> Prelude.return (3)
     WdMergeIfLessThanOrEqual -> Prelude.return (4)
     WdMergeIfGreaterThanOrEqual -> Prelude.return (5)
     WdMergeIfIsBlank -> Prelude.return (6)
     WdMergeIfIsNotBlank -> Prelude.return (7)
unmarshallWdMailMergeComparison :: Int.Int16 -> Prelude.IO WdMailMergeComparison
unmarshallWdMailMergeComparison v =
  case v of
     0 -> Prelude.return (WdMergeIfEqual)
     1 -> Prelude.return (WdMergeIfNotEqual)
     2 -> Prelude.return (WdMergeIfLessThan)
     3 -> Prelude.return (WdMergeIfGreaterThan)
     4 -> Prelude.return (WdMergeIfLessThanOrEqual)
     5 -> Prelude.return (WdMergeIfGreaterThanOrEqual)
     6 -> Prelude.return (WdMergeIfIsBlank)
     7 -> Prelude.return (WdMergeIfIsNotBlank)
     _ -> Prelude.fail (Prelude.userError "unmarshallWdMailMergeComparison: illegal enum value ")
data WdBookmarkSortBy
 = WdSortByName
 | WdSortByLocation
 
marshallWdBookmarkSortBy :: WdBookmarkSortBy -> Prelude.IO Int.Int16
marshallWdBookmarkSortBy v =
  case v of
     WdSortByName -> Prelude.return (0)
     WdSortByLocation -> Prelude.return (1)
unmarshallWdBookmarkSortBy :: Int.Int16 -> Prelude.IO WdBookmarkSortBy
unmarshallWdBookmarkSortBy v =
  case v of
     0 -> Prelude.return (WdSortByName)
     1 -> Prelude.return (WdSortByLocation)
     _ -> Prelude.fail (Prelude.userError "unmarshallWdBookmarkSortBy: illegal enum value ")
data WdWindowState
 = WdWindowStateNormal
 | WdWindowStateMaximize
 | WdWindowStateMinimize
 
marshallWdWindowState :: WdWindowState -> Prelude.IO Int.Int16
marshallWdWindowState v =
  case v of
     WdWindowStateNormal -> Prelude.return (0)
     WdWindowStateMaximize -> Prelude.return (1)
     WdWindowStateMinimize -> Prelude.return (2)
unmarshallWdWindowState :: Int.Int16 -> Prelude.IO WdWindowState
unmarshallWdWindowState v =
  case v of
     0 -> Prelude.return (WdWindowStateNormal)
     1 -> Prelude.return (WdWindowStateMaximize)
     2 -> Prelude.return (WdWindowStateMinimize)
     _ -> Prelude.fail (Prelude.userError "unmarshallWdWindowState: illegal enum value ")
data WdPictureLinkType
 = WdLinkNone
 | WdLinkDataInDoc
 | WdLinkDataOnDisk
 
marshallWdPictureLinkType :: WdPictureLinkType -> Prelude.IO Int.Int16
marshallWdPictureLinkType v =
  case v of
     WdLinkNone -> Prelude.return (0)
     WdLinkDataInDoc -> Prelude.return (1)
     WdLinkDataOnDisk -> Prelude.return (2)
unmarshallWdPictureLinkType :: Int.Int16 -> Prelude.IO WdPictureLinkType
unmarshallWdPictureLinkType v =
  case v of
     0 -> Prelude.return (WdLinkNone)
     1 -> Prelude.return (WdLinkDataInDoc)
     2 -> Prelude.return (WdLinkDataOnDisk)
     _ -> Prelude.fail (Prelude.userError "unmarshallWdPictureLinkType: illegal enum value ")
data WdLinkType
 = WdLinkTypeOLE
 | WdLinkTypePicture
 | WdLinkTypeText
 | WdLinkTypeReference
 | WdLinkTypeInclude
 | WdLinkTypeImport
 | WdLinkTypeDDE
 | WdLinkTypeDDEAuto
 
marshallWdLinkType :: WdLinkType -> Prelude.IO Int.Int16
marshallWdLinkType v =
  case v of
     WdLinkTypeOLE -> Prelude.return (0)
     WdLinkTypePicture -> Prelude.return (1)
     WdLinkTypeText -> Prelude.return (2)
     WdLinkTypeReference -> Prelude.return (3)
     WdLinkTypeInclude -> Prelude.return (4)
     WdLinkTypeImport -> Prelude.return (5)
     WdLinkTypeDDE -> Prelude.return (6)
     WdLinkTypeDDEAuto -> Prelude.return (7)
unmarshallWdLinkType :: Int.Int16 -> Prelude.IO WdLinkType
unmarshallWdLinkType v =
  case v of
     0 -> Prelude.return (WdLinkTypeOLE)
     1 -> Prelude.return (WdLinkTypePicture)
     2 -> Prelude.return (WdLinkTypeText)
     3 -> Prelude.return (WdLinkTypeReference)
     4 -> Prelude.return (WdLinkTypeInclude)
     5 -> Prelude.return (WdLinkTypeImport)
     6 -> Prelude.return (WdLinkTypeDDE)
     7 -> Prelude.return (WdLinkTypeDDEAuto)
     _ -> Prelude.fail (Prelude.userError "unmarshallWdLinkType: illegal enum value ")
data WdWindowType
 = WdWindowDocument
 | WdWindowTemplate
 
marshallWdWindowType :: WdWindowType -> Prelude.IO Int.Int16
marshallWdWindowType v =
  case v of
     WdWindowDocument -> Prelude.return (0)
     WdWindowTemplate -> Prelude.return (1)
unmarshallWdWindowType :: Int.Int16 -> Prelude.IO WdWindowType
unmarshallWdWindowType v =
  case v of
     0 -> Prelude.return (WdWindowDocument)
     1 -> Prelude.return (WdWindowTemplate)
     _ -> Prelude.fail (Prelude.userError "unmarshallWdWindowType: illegal enum value ")
data WdViewType
 = WdNormalView
 | WdOutlineView
 | WdPageView
 | WdPrintPreview
 | WdMasterView
 | WdOnlineView
 
marshallWdViewType :: WdViewType -> Prelude.IO Int.Int16
marshallWdViewType v =
  case v of
     WdNormalView -> Prelude.return (1)
     WdOutlineView -> Prelude.return (2)
     WdPageView -> Prelude.return (3)
     WdPrintPreview -> Prelude.return (4)
     WdMasterView -> Prelude.return (5)
     WdOnlineView -> Prelude.return (6)
unmarshallWdViewType :: Int.Int16 -> Prelude.IO WdViewType
unmarshallWdViewType v =
  case v of
     1 -> Prelude.return (WdNormalView)
     2 -> Prelude.return (WdOutlineView)
     3 -> Prelude.return (WdPageView)
     4 -> Prelude.return (WdPrintPreview)
     5 -> Prelude.return (WdMasterView)
     6 -> Prelude.return (WdOnlineView)
     _ -> Prelude.fail (Prelude.userError "unmarshallWdViewType: illegal enum value ")
data WdSeekView
 = WdSeekMainDocument
 | WdSeekPrimaryHeader
 | WdSeekFirstPageHeader
 | WdSeekEvenPagesHeader
 | WdSeekPrimaryFooter
 | WdSeekFirstPageFooter
 | WdSeekEvenPagesFooter
 | WdSeekFootnotes
 | WdSeekEndnotes
 | WdSeekCurrentPageHeader
 | WdSeekCurrentPageFooter
 
marshallWdSeekView :: WdSeekView -> Prelude.IO Int.Int16
marshallWdSeekView v =
  case v of
     WdSeekMainDocument -> Prelude.return (0)
     WdSeekPrimaryHeader -> Prelude.return (1)
     WdSeekFirstPageHeader -> Prelude.return (2)
     WdSeekEvenPagesHeader -> Prelude.return (3)
     WdSeekPrimaryFooter -> Prelude.return (4)
     WdSeekFirstPageFooter -> Prelude.return (5)
     WdSeekEvenPagesFooter -> Prelude.return (6)
     WdSeekFootnotes -> Prelude.return (7)
     WdSeekEndnotes -> Prelude.return (8)
     WdSeekCurrentPageHeader -> Prelude.return (9)
     WdSeekCurrentPageFooter -> Prelude.return (10)
unmarshallWdSeekView :: Int.Int16 -> Prelude.IO WdSeekView
unmarshallWdSeekView v =
  case v of
     0 -> Prelude.return (WdSeekMainDocument)
     1 -> Prelude.return (WdSeekPrimaryHeader)
     2 -> Prelude.return (WdSeekFirstPageHeader)
     3 -> Prelude.return (WdSeekEvenPagesHeader)
     4 -> Prelude.return (WdSeekPrimaryFooter)
     5 -> Prelude.return (WdSeekFirstPageFooter)
     6 -> Prelude.return (WdSeekEvenPagesFooter)
     7 -> Prelude.return (WdSeekFootnotes)
     8 -> Prelude.return (WdSeekEndnotes)
     9 -> Prelude.return (WdSeekCurrentPageHeader)
     10 -> Prelude.return (WdSeekCurrentPageFooter)
     _ -> Prelude.fail (Prelude.userError "unmarshallWdSeekView: illegal enum value ")
data WdSpecialPane
 = WdPaneNone
 | WdPanePrimaryHeader
 | WdPaneFirstPageHeader
 | WdPaneEvenPagesHeader
 | WdPanePrimaryFooter
 | WdPaneFirstPageFooter
 | WdPaneEvenPagesFooter
 | WdPaneFootnotes
 | WdPaneEndnotes
 | WdPaneFootnoteContinuationNotice
 | WdPaneFootnoteContinuationSeparator
 | WdPaneFootnoteSeparator
 | WdPaneEndnoteContinuationNotice
 | WdPaneEndnoteContinuationSeparator
 | WdPaneEndnoteSeparator
 | WdPaneComments
 | WdPaneCurrentPageHeader
 | WdPaneCurrentPageFooter
 
marshallWdSpecialPane :: WdSpecialPane -> Prelude.IO Int.Int16
marshallWdSpecialPane v =
  case v of
     WdPaneNone -> Prelude.return (0)
     WdPanePrimaryHeader -> Prelude.return (1)
     WdPaneFirstPageHeader -> Prelude.return (2)
     WdPaneEvenPagesHeader -> Prelude.return (3)
     WdPanePrimaryFooter -> Prelude.return (4)
     WdPaneFirstPageFooter -> Prelude.return (5)
     WdPaneEvenPagesFooter -> Prelude.return (6)
     WdPaneFootnotes -> Prelude.return (7)
     WdPaneEndnotes -> Prelude.return (8)
     WdPaneFootnoteContinuationNotice -> Prelude.return (9)
     WdPaneFootnoteContinuationSeparator -> Prelude.return (10)
     WdPaneFootnoteSeparator -> Prelude.return (11)
     WdPaneEndnoteContinuationNotice -> Prelude.return (12)
     WdPaneEndnoteContinuationSeparator -> Prelude.return (13)
     WdPaneEndnoteSeparator -> Prelude.return (14)
     WdPaneComments -> Prelude.return (15)
     WdPaneCurrentPageHeader -> Prelude.return (16)
     WdPaneCurrentPageFooter -> Prelude.return (17)
unmarshallWdSpecialPane :: Int.Int16 -> Prelude.IO WdSpecialPane
unmarshallWdSpecialPane v =
  case v of
     0 -> Prelude.return (WdPaneNone)
     1 -> Prelude.return (WdPanePrimaryHeader)
     2 -> Prelude.return (WdPaneFirstPageHeader)
     3 -> Prelude.return (WdPaneEvenPagesHeader)
     4 -> Prelude.return (WdPanePrimaryFooter)
     5 -> Prelude.return (WdPaneFirstPageFooter)
     6 -> Prelude.return (WdPaneEvenPagesFooter)
     7 -> Prelude.return (WdPaneFootnotes)
     8 -> Prelude.return (WdPaneEndnotes)
     9 -> Prelude.return (WdPaneFootnoteContinuationNotice)
     10 -> Prelude.return (WdPaneFootnoteContinuationSeparator)
     11 -> Prelude.return (WdPaneFootnoteSeparator)
     12 -> Prelude.return (WdPaneEndnoteContinuationNotice)
     13 -> Prelude.return (WdPaneEndnoteContinuationSeparator)
     14 -> Prelude.return (WdPaneEndnoteSeparator)
     15 -> Prelude.return (WdPaneComments)
     16 -> Prelude.return (WdPaneCurrentPageHeader)
     17 -> Prelude.return (WdPaneCurrentPageFooter)
     _ -> Prelude.fail (Prelude.userError "unmarshallWdSpecialPane: illegal enum value ")
data WdPageFit
 = WdPageFitNone
 | WdPageFitFullPage
 | WdPageFitBestFit
 
marshallWdPageFit :: WdPageFit -> Prelude.IO Int.Int16
marshallWdPageFit v =
  case v of
     WdPageFitNone -> Prelude.return (0)
     WdPageFitFullPage -> Prelude.return (1)
     WdPageFitBestFit -> Prelude.return (2)
unmarshallWdPageFit :: Int.Int16 -> Prelude.IO WdPageFit
unmarshallWdPageFit v =
  case v of
     0 -> Prelude.return (WdPageFitNone)
     1 -> Prelude.return (WdPageFitFullPage)
     2 -> Prelude.return (WdPageFitBestFit)
     _ -> Prelude.fail (Prelude.userError "unmarshallWdPageFit: illegal enum value ")
data WdBrowseTarget
 = WdBrowsePage
 | WdBrowseSection
 | WdBrowseComment
 | WdBrowseFootnote
 | WdBrowseEndnote
 | WdBrowseField
 | WdBrowseTable
 | WdBrowseGraphic
 | WdBrowseHeading
 | WdBrowseEdit
 | WdBrowseFind
 | WdBrowseGoTo
 
marshallWdBrowseTarget :: WdBrowseTarget -> Prelude.IO Int.Int16
marshallWdBrowseTarget v =
  case v of
     WdBrowsePage -> Prelude.return (1)
     WdBrowseSection -> Prelude.return (2)
     WdBrowseComment -> Prelude.return (3)
     WdBrowseFootnote -> Prelude.return (4)
     WdBrowseEndnote -> Prelude.return (5)
     WdBrowseField -> Prelude.return (6)
     WdBrowseTable -> Prelude.return (7)
     WdBrowseGraphic -> Prelude.return (8)
     WdBrowseHeading -> Prelude.return (9)
     WdBrowseEdit -> Prelude.return (10)
     WdBrowseFind -> Prelude.return (11)
     WdBrowseGoTo -> Prelude.return (12)
unmarshallWdBrowseTarget :: Int.Int16 -> Prelude.IO WdBrowseTarget
unmarshallWdBrowseTarget v =
  case v of
     1 -> Prelude.return (WdBrowsePage)
     2 -> Prelude.return (WdBrowseSection)
     3 -> Prelude.return (WdBrowseComment)
     4 -> Prelude.return (WdBrowseFootnote)
     5 -> Prelude.return (WdBrowseEndnote)
     6 -> Prelude.return (WdBrowseField)
     7 -> Prelude.return (WdBrowseTable)
     8 -> Prelude.return (WdBrowseGraphic)
     9 -> Prelude.return (WdBrowseHeading)
     10 -> Prelude.return (WdBrowseEdit)
     11 -> Prelude.return (WdBrowseFind)
     12 -> Prelude.return (WdBrowseGoTo)
     _ -> Prelude.fail (Prelude.userError "unmarshallWdBrowseTarget: illegal enum value ")
data WdPaperTray
 = WdPrinterDefaultBin
 | WdPrinterUpperBin
 | WdPrinterOnlyBin
 | WdPrinterLowerBin
 | WdPrinterMiddleBin
 | WdPrinterManualFeed
 | WdPrinterEnvelopeFeed
 | WdPrinterManualEnvelopeFeed
 | WdPrinterAutomaticSheetFeed
 | WdPrinterTractorFeed
 | WdPrinterSmallFormatBin
 | WdPrinterLargeFormatBin
 | WdPrinterLargeCapacityBin
 | WdPrinterPaperCassette
 | WdPrinterFormSource
 
marshallWdPaperTray :: WdPaperTray -> Prelude.IO Int.Int16
marshallWdPaperTray v =
  case v of
     WdPrinterDefaultBin -> Prelude.return (0)
     WdPrinterUpperBin -> Prelude.return (1)
     WdPrinterOnlyBin -> Prelude.return (1)
     WdPrinterLowerBin -> Prelude.return (2)
     WdPrinterMiddleBin -> Prelude.return (3)
     WdPrinterManualFeed -> Prelude.return (4)
     WdPrinterEnvelopeFeed -> Prelude.return (5)
     WdPrinterManualEnvelopeFeed -> Prelude.return (6)
     WdPrinterAutomaticSheetFeed -> Prelude.return (7)
     WdPrinterTractorFeed -> Prelude.return (8)
     WdPrinterSmallFormatBin -> Prelude.return (9)
     WdPrinterLargeFormatBin -> Prelude.return (10)
     WdPrinterLargeCapacityBin -> Prelude.return (11)
     WdPrinterPaperCassette -> Prelude.return (14)
     WdPrinterFormSource -> Prelude.return (15)
unmarshallWdPaperTray :: Int.Int16 -> Prelude.IO WdPaperTray
unmarshallWdPaperTray v =
  case v of
     0 -> Prelude.return (WdPrinterDefaultBin)
     1 -> Prelude.return (WdPrinterUpperBin)
     1 -> Prelude.return (WdPrinterOnlyBin)
     2 -> Prelude.return (WdPrinterLowerBin)
     3 -> Prelude.return (WdPrinterMiddleBin)
     4 -> Prelude.return (WdPrinterManualFeed)
     5 -> Prelude.return (WdPrinterEnvelopeFeed)
     6 -> Prelude.return (WdPrinterManualEnvelopeFeed)
     7 -> Prelude.return (WdPrinterAutomaticSheetFeed)
     8 -> Prelude.return (WdPrinterTractorFeed)
     9 -> Prelude.return (WdPrinterSmallFormatBin)
     10 -> Prelude.return (WdPrinterLargeFormatBin)
     11 -> Prelude.return (WdPrinterLargeCapacityBin)
     14 -> Prelude.return (WdPrinterPaperCassette)
     15 -> Prelude.return (WdPrinterFormSource)
     _ -> Prelude.fail (Prelude.userError "unmarshallWdPaperTray: illegal enum value ")
data WdOrientation
 = WdOrientPortrait
 | WdOrientLandscape
 
marshallWdOrientation :: WdOrientation -> Prelude.IO Int.Int16
marshallWdOrientation v =
  case v of
     WdOrientPortrait -> Prelude.return (0)
     WdOrientLandscape -> Prelude.return (1)
unmarshallWdOrientation :: Int.Int16 -> Prelude.IO WdOrientation
unmarshallWdOrientation v =
  case v of
     0 -> Prelude.return (WdOrientPortrait)
     1 -> Prelude.return (WdOrientLandscape)
     _ -> Prelude.fail (Prelude.userError "unmarshallWdOrientation: illegal enum value ")
data WdSelectionType
 = WdNoSelection
 | WdSelectionIP
 | WdSelectionNormal
 | WdSelectionFrame
 | WdSelectionColumn
 | WdSelectionRow
 | WdSelectionBlock
 | WdSelectionInlineShape
 | WdSelectionShape
 
marshallWdSelectionType :: WdSelectionType -> Prelude.IO Int.Int16
marshallWdSelectionType v =
  case v of
     WdNoSelection -> Prelude.return (0)
     WdSelectionIP -> Prelude.return (1)
     WdSelectionNormal -> Prelude.return (2)
     WdSelectionFrame -> Prelude.return (3)
     WdSelectionColumn -> Prelude.return (4)
     WdSelectionRow -> Prelude.return (5)
     WdSelectionBlock -> Prelude.return (6)
     WdSelectionInlineShape -> Prelude.return (7)
     WdSelectionShape -> Prelude.return (8)
unmarshallWdSelectionType :: Int.Int16 -> Prelude.IO WdSelectionType
unmarshallWdSelectionType v =
  case v of
     0 -> Prelude.return (WdNoSelection)
     1 -> Prelude.return (WdSelectionIP)
     2 -> Prelude.return (WdSelectionNormal)
     3 -> Prelude.return (WdSelectionFrame)
     4 -> Prelude.return (WdSelectionColumn)
     5 -> Prelude.return (WdSelectionRow)
     6 -> Prelude.return (WdSelectionBlock)
     7 -> Prelude.return (WdSelectionInlineShape)
     8 -> Prelude.return (WdSelectionShape)
     _ -> Prelude.fail (Prelude.userError "unmarshallWdSelectionType: illegal enum value ")
data WdCaptionLabelID
 = WdCaptionFigure
 | WdCaptionTable
 | WdCaptionEquation
 
marshallWdCaptionLabelID :: WdCaptionLabelID -> Prelude.IO Int.Int16
marshallWdCaptionLabelID v =
  case v of
     WdCaptionFigure -> Prelude.return ((-1))
     WdCaptionTable -> Prelude.return ((-2))
     WdCaptionEquation -> Prelude.return ((-3))
unmarshallWdCaptionLabelID :: Int.Int16 -> Prelude.IO WdCaptionLabelID
unmarshallWdCaptionLabelID v =
  case v of
     (-1) -> Prelude.return (WdCaptionFigure)
     (-2) -> Prelude.return (WdCaptionTable)
     (-3) -> Prelude.return (WdCaptionEquation)
     _ -> Prelude.fail (Prelude.userError "unmarshallWdCaptionLabelID: illegal enum value ")
data WdReferenceType
 = WdRefTypeNumberedItem
 | WdRefTypeHeading
 | WdRefTypeBookmark
 | WdRefTypeFootnote
 | WdRefTypeEndnote
 
marshallWdReferenceType :: WdReferenceType -> Prelude.IO Int.Int16
marshallWdReferenceType v =
  case v of
     WdRefTypeNumberedItem -> Prelude.return (0)
     WdRefTypeHeading -> Prelude.return (1)
     WdRefTypeBookmark -> Prelude.return (2)
     WdRefTypeFootnote -> Prelude.return (3)
     WdRefTypeEndnote -> Prelude.return (4)
unmarshallWdReferenceType :: Int.Int16 -> Prelude.IO WdReferenceType
unmarshallWdReferenceType v =
  case v of
     0 -> Prelude.return (WdRefTypeNumberedItem)
     1 -> Prelude.return (WdRefTypeHeading)
     2 -> Prelude.return (WdRefTypeBookmark)
     3 -> Prelude.return (WdRefTypeFootnote)
     4 -> Prelude.return (WdRefTypeEndnote)
     _ -> Prelude.fail (Prelude.userError "unmarshallWdReferenceType: illegal enum value ")
data WdReferenceKind
 = WdContentText
 | WdNumberRelativeContext
 | WdNumberNoContext
 | WdNumberFullContext
 | WdEntireCaption
 | WdOnlyLabelAndNumber
 | WdOnlyCaptionText
 | WdFootnoteNumber
 | WdEndnoteNumber
 | WdPageNumber
 | WdPosition
 | WdFootnoteNumberFormatted
 | WdEndnoteNumberFormatted
 
marshallWdReferenceKind :: WdReferenceKind -> Prelude.IO Int.Int16
marshallWdReferenceKind v =
  case v of
     WdContentText -> Prelude.return ((-1))
     WdNumberRelativeContext -> Prelude.return ((-2))
     WdNumberNoContext -> Prelude.return ((-3))
     WdNumberFullContext -> Prelude.return ((-4))
     WdEntireCaption -> Prelude.return (2)
     WdOnlyLabelAndNumber -> Prelude.return (3)
     WdOnlyCaptionText -> Prelude.return (4)
     WdFootnoteNumber -> Prelude.return (5)
     WdEndnoteNumber -> Prelude.return (6)
     WdPageNumber -> Prelude.return (7)
     WdPosition -> Prelude.return (15)
     WdFootnoteNumberFormatted -> Prelude.return (16)
     WdEndnoteNumberFormatted -> Prelude.return (17)
unmarshallWdReferenceKind :: Int.Int16 -> Prelude.IO WdReferenceKind
unmarshallWdReferenceKind v =
  case v of
     (-1) -> Prelude.return (WdContentText)
     (-2) -> Prelude.return (WdNumberRelativeContext)
     (-3) -> Prelude.return (WdNumberNoContext)
     (-4) -> Prelude.return (WdNumberFullContext)
     2 -> Prelude.return (WdEntireCaption)
     3 -> Prelude.return (WdOnlyLabelAndNumber)
     4 -> Prelude.return (WdOnlyCaptionText)
     5 -> Prelude.return (WdFootnoteNumber)
     6 -> Prelude.return (WdEndnoteNumber)
     7 -> Prelude.return (WdPageNumber)
     15 -> Prelude.return (WdPosition)
     16 -> Prelude.return (WdFootnoteNumberFormatted)
     17 -> Prelude.return (WdEndnoteNumberFormatted)
     _ -> Prelude.fail (Prelude.userError "unmarshallWdReferenceKind: illegal enum value ")
data WdIndexFormat
 = WdIndexTemplate
 | WdIndexClassic
 | WdIndexFancy
 | WdIndexModern
 | WdIndexBulleted
 | WdIndexFormal
 | WdIndexSimple
 
marshallWdIndexFormat :: WdIndexFormat -> Prelude.IO Int.Int16
marshallWdIndexFormat v =
  case v of
     WdIndexTemplate -> Prelude.return (0)
     WdIndexClassic -> Prelude.return (1)
     WdIndexFancy -> Prelude.return (2)
     WdIndexModern -> Prelude.return (3)
     WdIndexBulleted -> Prelude.return (4)
     WdIndexFormal -> Prelude.return (5)
     WdIndexSimple -> Prelude.return (6)
unmarshallWdIndexFormat :: Int.Int16 -> Prelude.IO WdIndexFormat
unmarshallWdIndexFormat v =
  case v of
     0 -> Prelude.return (WdIndexTemplate)
     1 -> Prelude.return (WdIndexClassic)
     2 -> Prelude.return (WdIndexFancy)
     3 -> Prelude.return (WdIndexModern)
     4 -> Prelude.return (WdIndexBulleted)
     5 -> Prelude.return (WdIndexFormal)
     6 -> Prelude.return (WdIndexSimple)
     _ -> Prelude.fail (Prelude.userError "unmarshallWdIndexFormat: illegal enum value ")
data WdIndexType
 = WdIndexIndent
 | WdIndexRunin
 
marshallWdIndexType :: WdIndexType -> Prelude.IO Int.Int16
marshallWdIndexType v =
  case v of
     WdIndexIndent -> Prelude.return (0)
     WdIndexRunin -> Prelude.return (1)
unmarshallWdIndexType :: Int.Int16 -> Prelude.IO WdIndexType
unmarshallWdIndexType v =
  case v of
     0 -> Prelude.return (WdIndexIndent)
     1 -> Prelude.return (WdIndexRunin)
     _ -> Prelude.fail (Prelude.userError "unmarshallWdIndexType: illegal enum value ")
data WdRevisionsWrap
 = WdWrapNever
 | WdWrapAlways
 | WdWrapAsk
 
marshallWdRevisionsWrap :: WdRevisionsWrap -> Prelude.IO Int.Int16
marshallWdRevisionsWrap v =
  case v of
     WdWrapNever -> Prelude.return (0)
     WdWrapAlways -> Prelude.return (1)
     WdWrapAsk -> Prelude.return (2)
unmarshallWdRevisionsWrap :: Int.Int16 -> Prelude.IO WdRevisionsWrap
unmarshallWdRevisionsWrap v =
  case v of
     0 -> Prelude.return (WdWrapNever)
     1 -> Prelude.return (WdWrapAlways)
     2 -> Prelude.return (WdWrapAsk)
     _ -> Prelude.fail (Prelude.userError "unmarshallWdRevisionsWrap: illegal enum value ")
data WdRevisionType
 = WdNoRevision
 | WdRevisionInsert
 | WdRevisionDelete
 | WdRevisionProperty
 | WdRevisionParagraphNumber
 | WdRevisionDisplayField
 | WdRevisionReconcile
 | WdRevisionConflict
 | WdRevisionStyle
 | WdRevisionReplace
 
marshallWdRevisionType :: WdRevisionType -> Prelude.IO Int.Int16
marshallWdRevisionType v =
  case v of
     WdNoRevision -> Prelude.return (0)
     WdRevisionInsert -> Prelude.return (1)
     WdRevisionDelete -> Prelude.return (2)
     WdRevisionProperty -> Prelude.return (3)
     WdRevisionParagraphNumber -> Prelude.return (4)
     WdRevisionDisplayField -> Prelude.return (5)
     WdRevisionReconcile -> Prelude.return (6)
     WdRevisionConflict -> Prelude.return (7)
     WdRevisionStyle -> Prelude.return (8)
     WdRevisionReplace -> Prelude.return (9)
unmarshallWdRevisionType :: Int.Int16 -> Prelude.IO WdRevisionType
unmarshallWdRevisionType v =
  case v of
     0 -> Prelude.return (WdNoRevision)
     1 -> Prelude.return (WdRevisionInsert)
     2 -> Prelude.return (WdRevisionDelete)
     3 -> Prelude.return (WdRevisionProperty)
     4 -> Prelude.return (WdRevisionParagraphNumber)
     5 -> Prelude.return (WdRevisionDisplayField)
     6 -> Prelude.return (WdRevisionReconcile)
     7 -> Prelude.return (WdRevisionConflict)
     8 -> Prelude.return (WdRevisionStyle)
     9 -> Prelude.return (WdRevisionReplace)
     _ -> Prelude.fail (Prelude.userError "unmarshallWdRevisionType: illegal enum value ")
data WdRoutingSlipDelivery
 = WdOneAfterAnother
 | WdAllAtOnce
 
marshallWdRoutingSlipDelivery :: WdRoutingSlipDelivery -> Prelude.IO Int.Int16
marshallWdRoutingSlipDelivery v =
  case v of
     WdOneAfterAnother -> Prelude.return (0)
     WdAllAtOnce -> Prelude.return (1)
unmarshallWdRoutingSlipDelivery :: Int.Int16 -> Prelude.IO WdRoutingSlipDelivery
unmarshallWdRoutingSlipDelivery v =
  case v of
     0 -> Prelude.return (WdOneAfterAnother)
     1 -> Prelude.return (WdAllAtOnce)
     _ -> Prelude.fail (Prelude.userError "unmarshallWdRoutingSlipDelivery: illegal enum value ")
data WdRoutingSlipStatus
 = WdNotYetRouted
 | WdRouteInProgress
 | WdRouteComplete
 
marshallWdRoutingSlipStatus :: WdRoutingSlipStatus -> Prelude.IO Int.Int16
marshallWdRoutingSlipStatus v =
  case v of
     WdNotYetRouted -> Prelude.return (0)
     WdRouteInProgress -> Prelude.return (1)
     WdRouteComplete -> Prelude.return (2)
unmarshallWdRoutingSlipStatus :: Int.Int16 -> Prelude.IO WdRoutingSlipStatus
unmarshallWdRoutingSlipStatus v =
  case v of
     0 -> Prelude.return (WdNotYetRouted)
     1 -> Prelude.return (WdRouteInProgress)
     2 -> Prelude.return (WdRouteComplete)
     _ -> Prelude.fail (Prelude.userError "unmarshallWdRoutingSlipStatus: illegal enum value ")
data WdSectionStart
 = WdSectionContinuous
 | WdSectionNewColumn
 | WdSectionNewPage
 | WdSectionEvenPage
 | WdSectionOddPage
 
marshallWdSectionStart :: WdSectionStart -> Prelude.IO Int.Int16
marshallWdSectionStart v =
  case v of
     WdSectionContinuous -> Prelude.return (0)
     WdSectionNewColumn -> Prelude.return (1)
     WdSectionNewPage -> Prelude.return (2)
     WdSectionEvenPage -> Prelude.return (3)
     WdSectionOddPage -> Prelude.return (4)
unmarshallWdSectionStart :: Int.Int16 -> Prelude.IO WdSectionStart
unmarshallWdSectionStart v =
  case v of
     0 -> Prelude.return (WdSectionContinuous)
     1 -> Prelude.return (WdSectionNewColumn)
     2 -> Prelude.return (WdSectionNewPage)
     3 -> Prelude.return (WdSectionEvenPage)
     4 -> Prelude.return (WdSectionOddPage)
     _ -> Prelude.fail (Prelude.userError "unmarshallWdSectionStart: illegal enum value ")
data WdSaveOptions
 = WdDoNotSaveChanges
 | WdSaveChanges
 | WdPromptToSaveChanges
 
marshallWdSaveOptions :: WdSaveOptions -> Prelude.IO Int.Int16
marshallWdSaveOptions v =
  case v of
     WdDoNotSaveChanges -> Prelude.return (0)
     WdSaveChanges -> Prelude.return ((-1))
     WdPromptToSaveChanges -> Prelude.return ((-2))
unmarshallWdSaveOptions :: Int.Int16 -> Prelude.IO WdSaveOptions
unmarshallWdSaveOptions v =
  case v of
     0 -> Prelude.return (WdDoNotSaveChanges)
     (-1) -> Prelude.return (WdSaveChanges)
     (-2) -> Prelude.return (WdPromptToSaveChanges)
     _ -> Prelude.fail (Prelude.userError "unmarshallWdSaveOptions: illegal enum value ")
data WdDocumentKind
 = WdDocumentNotSpecified
 | WdDocumentLetter
 | WdDocumentEmail
 
marshallWdDocumentKind :: WdDocumentKind -> Prelude.IO Int.Int16
marshallWdDocumentKind v =
  case v of
     WdDocumentNotSpecified -> Prelude.return (0)
     WdDocumentLetter -> Prelude.return (1)
     WdDocumentEmail -> Prelude.return (2)
unmarshallWdDocumentKind :: Int.Int16 -> Prelude.IO WdDocumentKind
unmarshallWdDocumentKind v =
  case v of
     0 -> Prelude.return (WdDocumentNotSpecified)
     1 -> Prelude.return (WdDocumentLetter)
     2 -> Prelude.return (WdDocumentEmail)
     _ -> Prelude.fail (Prelude.userError "unmarshallWdDocumentKind: illegal enum value ")
data WdDocumentType
 = WdTypeDocument
 | WdTypeTemplate
 
marshallWdDocumentType :: WdDocumentType -> Prelude.IO Int.Int16
marshallWdDocumentType v =
  case v of
     WdTypeDocument -> Prelude.return (0)
     WdTypeTemplate -> Prelude.return (1)
unmarshallWdDocumentType :: Int.Int16 -> Prelude.IO WdDocumentType
unmarshallWdDocumentType v =
  case v of
     0 -> Prelude.return (WdTypeDocument)
     1 -> Prelude.return (WdTypeTemplate)
     _ -> Prelude.fail (Prelude.userError "unmarshallWdDocumentType: illegal enum value ")
data WdOriginalFormat
 = WdWordDocument
 | WdOriginalDocumentFormat
 | WdPromptUser
 
marshallWdOriginalFormat :: WdOriginalFormat -> Prelude.IO Int.Int16
marshallWdOriginalFormat v =
  case v of
     WdWordDocument -> Prelude.return (0)
     WdOriginalDocumentFormat -> Prelude.return (1)
     WdPromptUser -> Prelude.return (2)
unmarshallWdOriginalFormat :: Int.Int16 -> Prelude.IO WdOriginalFormat
unmarshallWdOriginalFormat v =
  case v of
     0 -> Prelude.return (WdWordDocument)
     1 -> Prelude.return (WdOriginalDocumentFormat)
     2 -> Prelude.return (WdPromptUser)
     _ -> Prelude.fail (Prelude.userError "unmarshallWdOriginalFormat: illegal enum value ")
data WdRelocate
 = WdRelocateUp
 | WdRelocateDown
 
marshallWdRelocate :: WdRelocate -> Prelude.IO Int.Int16
marshallWdRelocate v =
  case v of
     WdRelocateUp -> Prelude.return (0)
     WdRelocateDown -> Prelude.return (1)
unmarshallWdRelocate :: Int.Int16 -> Prelude.IO WdRelocate
unmarshallWdRelocate v =
  case v of
     0 -> Prelude.return (WdRelocateUp)
     1 -> Prelude.return (WdRelocateDown)
     _ -> Prelude.fail (Prelude.userError "unmarshallWdRelocate: illegal enum value ")
data WdInsertedTextMark
 = WdInsertedTextMarkNone
 | WdInsertedTextMarkBold
 | WdInsertedTextMarkItalic
 | WdInsertedTextMarkUnderline
 | WdInsertedTextMarkDoubleUnderline
 
marshallWdInsertedTextMark :: WdInsertedTextMark -> Prelude.IO Int.Int16
marshallWdInsertedTextMark v =
  case v of
     WdInsertedTextMarkNone -> Prelude.return (0)
     WdInsertedTextMarkBold -> Prelude.return (1)
     WdInsertedTextMarkItalic -> Prelude.return (2)
     WdInsertedTextMarkUnderline -> Prelude.return (3)
     WdInsertedTextMarkDoubleUnderline -> Prelude.return (4)
unmarshallWdInsertedTextMark :: Int.Int16 -> Prelude.IO WdInsertedTextMark
unmarshallWdInsertedTextMark v =
  case v of
     0 -> Prelude.return (WdInsertedTextMarkNone)
     1 -> Prelude.return (WdInsertedTextMarkBold)
     2 -> Prelude.return (WdInsertedTextMarkItalic)
     3 -> Prelude.return (WdInsertedTextMarkUnderline)
     4 -> Prelude.return (WdInsertedTextMarkDoubleUnderline)
     _ -> Prelude.fail (Prelude.userError "unmarshallWdInsertedTextMark: illegal enum value ")
data WdRevisedLinesMark
 = WdRevisedLinesMarkNone
 | WdRevisedLinesMarkLeftBorder
 | WdRevisedLinesMarkRightBorder
 | WdRevisedLinesMarkOutsideBorder
 
marshallWdRevisedLinesMark :: WdRevisedLinesMark -> Prelude.IO Int.Int16
marshallWdRevisedLinesMark v =
  case v of
     WdRevisedLinesMarkNone -> Prelude.return (0)
     WdRevisedLinesMarkLeftBorder -> Prelude.return (1)
     WdRevisedLinesMarkRightBorder -> Prelude.return (2)
     WdRevisedLinesMarkOutsideBorder -> Prelude.return (3)
unmarshallWdRevisedLinesMark :: Int.Int16 -> Prelude.IO WdRevisedLinesMark
unmarshallWdRevisedLinesMark v =
  case v of
     0 -> Prelude.return (WdRevisedLinesMarkNone)
     1 -> Prelude.return (WdRevisedLinesMarkLeftBorder)
     2 -> Prelude.return (WdRevisedLinesMarkRightBorder)
     3 -> Prelude.return (WdRevisedLinesMarkOutsideBorder)
     _ -> Prelude.fail (Prelude.userError "unmarshallWdRevisedLinesMark: illegal enum value ")
data WdDeletedTextMark
 = WdDeletedTextMarkHidden
 | WdDeletedTextMarkStrikeThrough
 | WdDeletedTextMarkCaret
 | WdDeletedTextMarkPound
 
marshallWdDeletedTextMark :: WdDeletedTextMark -> Prelude.IO Int.Int16
marshallWdDeletedTextMark v =
  case v of
     WdDeletedTextMarkHidden -> Prelude.return (0)
     WdDeletedTextMarkStrikeThrough -> Prelude.return (1)
     WdDeletedTextMarkCaret -> Prelude.return (2)
     WdDeletedTextMarkPound -> Prelude.return (3)
unmarshallWdDeletedTextMark :: Int.Int16 -> Prelude.IO WdDeletedTextMark
unmarshallWdDeletedTextMark v =
  case v of
     0 -> Prelude.return (WdDeletedTextMarkHidden)
     1 -> Prelude.return (WdDeletedTextMarkStrikeThrough)
     2 -> Prelude.return (WdDeletedTextMarkCaret)
     3 -> Prelude.return (WdDeletedTextMarkPound)
     _ -> Prelude.fail (Prelude.userError "unmarshallWdDeletedTextMark: illegal enum value ")
data WdRevisedPropertiesMark
 = WdRevisedPropertiesMarkNone
 | WdRevisedPropertiesMarkBold
 | WdRevisedPropertiesMarkItalic
 | WdRevisedPropertiesMarkUnderline
 | WdRevisedPropertiesMarkDoubleUnderline
 
marshallWdRevisedPropertiesMark :: WdRevisedPropertiesMark -> Prelude.IO Int.Int16
marshallWdRevisedPropertiesMark v =
  case v of
     WdRevisedPropertiesMarkNone -> Prelude.return (0)
     WdRevisedPropertiesMarkBold -> Prelude.return (1)
     WdRevisedPropertiesMarkItalic -> Prelude.return (2)
     WdRevisedPropertiesMarkUnderline -> Prelude.return (3)
     WdRevisedPropertiesMarkDoubleUnderline -> Prelude.return (4)
unmarshallWdRevisedPropertiesMark :: Int.Int16 -> Prelude.IO WdRevisedPropertiesMark
unmarshallWdRevisedPropertiesMark v =
  case v of
     0 -> Prelude.return (WdRevisedPropertiesMarkNone)
     1 -> Prelude.return (WdRevisedPropertiesMarkBold)
     2 -> Prelude.return (WdRevisedPropertiesMarkItalic)
     3 -> Prelude.return (WdRevisedPropertiesMarkUnderline)
     4 -> Prelude.return (WdRevisedPropertiesMarkDoubleUnderline)
     _ -> Prelude.fail (Prelude.userError "unmarshallWdRevisedPropertiesMark: illegal enum value ")
data WdFieldShading
 = WdFieldShadingNever
 | WdFieldShadingAlways
 | WdFieldShadingWhenSelected
 
marshallWdFieldShading :: WdFieldShading -> Prelude.IO Int.Int16
marshallWdFieldShading v =
  case v of
     WdFieldShadingNever -> Prelude.return (0)
     WdFieldShadingAlways -> Prelude.return (1)
     WdFieldShadingWhenSelected -> Prelude.return (2)
unmarshallWdFieldShading :: Int.Int16 -> Prelude.IO WdFieldShading
unmarshallWdFieldShading v =
  case v of
     0 -> Prelude.return (WdFieldShadingNever)
     1 -> Prelude.return (WdFieldShadingAlways)
     2 -> Prelude.return (WdFieldShadingWhenSelected)
     _ -> Prelude.fail (Prelude.userError "unmarshallWdFieldShading: illegal enum value ")
data WdDefaultFilePath
 = WdDocumentsPath
 | WdPicturesPath
 | WdUserTemplatesPath
 | WdWorkgroupTemplatesPath
 | WdUserOptionsPath
 | WdAutoRecoverPath
 | WdToolsPath
 | WdTutorialPath
 | WdStartupPath
 | WdProgramPath
 | WdGraphicsFiltersPath
 | WdTextConvertersPath
 | WdProofingToolsPath
 | WdTempFilePath
 | WdCurrentFolderPath
 | WdStyleGalleryPath
 | WdBorderArtPath
 
marshallWdDefaultFilePath :: WdDefaultFilePath -> Prelude.IO Int.Int16
marshallWdDefaultFilePath v =
  case v of
     WdDocumentsPath -> Prelude.return (0)
     WdPicturesPath -> Prelude.return (1)
     WdUserTemplatesPath -> Prelude.return (2)
     WdWorkgroupTemplatesPath -> Prelude.return (3)
     WdUserOptionsPath -> Prelude.return (4)
     WdAutoRecoverPath -> Prelude.return (5)
     WdToolsPath -> Prelude.return (6)
     WdTutorialPath -> Prelude.return (7)
     WdStartupPath -> Prelude.return (8)
     WdProgramPath -> Prelude.return (9)
     WdGraphicsFiltersPath -> Prelude.return (10)
     WdTextConvertersPath -> Prelude.return (11)
     WdProofingToolsPath -> Prelude.return (12)
     WdTempFilePath -> Prelude.return (13)
     WdCurrentFolderPath -> Prelude.return (14)
     WdStyleGalleryPath -> Prelude.return (15)
     WdBorderArtPath -> Prelude.return (19)
unmarshallWdDefaultFilePath :: Int.Int16 -> Prelude.IO WdDefaultFilePath
unmarshallWdDefaultFilePath v =
  case v of
     0 -> Prelude.return (WdDocumentsPath)
     1 -> Prelude.return (WdPicturesPath)
     2 -> Prelude.return (WdUserTemplatesPath)
     3 -> Prelude.return (WdWorkgroupTemplatesPath)
     4 -> Prelude.return (WdUserOptionsPath)
     5 -> Prelude.return (WdAutoRecoverPath)
     6 -> Prelude.return (WdToolsPath)
     7 -> Prelude.return (WdTutorialPath)
     8 -> Prelude.return (WdStartupPath)
     9 -> Prelude.return (WdProgramPath)
     10 -> Prelude.return (WdGraphicsFiltersPath)
     11 -> Prelude.return (WdTextConvertersPath)
     12 -> Prelude.return (WdProofingToolsPath)
     13 -> Prelude.return (WdTempFilePath)
     14 -> Prelude.return (WdCurrentFolderPath)
     15 -> Prelude.return (WdStyleGalleryPath)
     19 -> Prelude.return (WdBorderArtPath)
     _ -> Prelude.fail (Prelude.userError "unmarshallWdDefaultFilePath: illegal enum value ")
data WdCompatibility
 = WdNoTabHangIndent
 | WdNoSpaceRaiseLower
 | WdPrintColBlack
 | WdWrapTrailSpaces
 | WdNoColumnBalance
 | WdConvMailMergeEsc
 | WdSuppressSpBfAfterPgBrk
 | WdSuppressTopSpacing
 | WdOrigWordTableRules
 | WdTransparentMetafiles
 | WdShowBreaksInFrames
 | WdSwapBordersFacingPages
 | WdLeaveBackslashAlone
 | WdExpandShiftReturn
 | WdDontULTrailSpace
 | WdDontBalanceSingleByteDoubleByteWidth
 | WdSuppressTopSpacingMac5
 | WdSpacingInWholePoints
 | WdPrintBodyTextBeforeHeader
 | WdNoLeading
 | WdNoSpaceForUL
 | WdMWSmallCaps
 | WdNoExtraLineSpacing
 | WdTruncateFontHeight
 | WdSubFontBySize
 | WdUsePrinterMetrics
 | WdWW6BorderRules
 | WdExactOnTop
 | WdSuppressBottomSpacing
 | WdWPSpaceWidth
 | WdWPJustification
 | WdLineWrapLikeWord6
 
marshallWdCompatibility :: WdCompatibility -> Prelude.IO Int.Int16
marshallWdCompatibility v =
  case v of
     WdNoTabHangIndent -> Prelude.return (1)
     WdNoSpaceRaiseLower -> Prelude.return (2)
     WdPrintColBlack -> Prelude.return (3)
     WdWrapTrailSpaces -> Prelude.return (4)
     WdNoColumnBalance -> Prelude.return (5)
     WdConvMailMergeEsc -> Prelude.return (6)
     WdSuppressSpBfAfterPgBrk -> Prelude.return (7)
     WdSuppressTopSpacing -> Prelude.return (8)
     WdOrigWordTableRules -> Prelude.return (9)
     WdTransparentMetafiles -> Prelude.return (10)
     WdShowBreaksInFrames -> Prelude.return (11)
     WdSwapBordersFacingPages -> Prelude.return (12)
     WdLeaveBackslashAlone -> Prelude.return (13)
     WdExpandShiftReturn -> Prelude.return (14)
     WdDontULTrailSpace -> Prelude.return (15)
     WdDontBalanceSingleByteDoubleByteWidth -> Prelude.return (16)
     WdSuppressTopSpacingMac5 -> Prelude.return (17)
     WdSpacingInWholePoints -> Prelude.return (18)
     WdPrintBodyTextBeforeHeader -> Prelude.return (19)
     WdNoLeading -> Prelude.return (20)
     WdNoSpaceForUL -> Prelude.return (21)
     WdMWSmallCaps -> Prelude.return (22)
     WdNoExtraLineSpacing -> Prelude.return (23)
     WdTruncateFontHeight -> Prelude.return (24)
     WdSubFontBySize -> Prelude.return (25)
     WdUsePrinterMetrics -> Prelude.return (26)
     WdWW6BorderRules -> Prelude.return (27)
     WdExactOnTop -> Prelude.return (28)
     WdSuppressBottomSpacing -> Prelude.return (29)
     WdWPSpaceWidth -> Prelude.return (30)
     WdWPJustification -> Prelude.return (31)
     WdLineWrapLikeWord6 -> Prelude.return (32)
unmarshallWdCompatibility :: Int.Int16 -> Prelude.IO WdCompatibility
unmarshallWdCompatibility v =
  case v of
     1 -> Prelude.return (WdNoTabHangIndent)
     2 -> Prelude.return (WdNoSpaceRaiseLower)
     3 -> Prelude.return (WdPrintColBlack)
     4 -> Prelude.return (WdWrapTrailSpaces)
     5 -> Prelude.return (WdNoColumnBalance)
     6 -> Prelude.return (WdConvMailMergeEsc)
     7 -> Prelude.return (WdSuppressSpBfAfterPgBrk)
     8 -> Prelude.return (WdSuppressTopSpacing)
     9 -> Prelude.return (WdOrigWordTableRules)
     10 -> Prelude.return (WdTransparentMetafiles)
     11 -> Prelude.return (WdShowBreaksInFrames)
     12 -> Prelude.return (WdSwapBordersFacingPages)
     13 -> Prelude.return (WdLeaveBackslashAlone)
     14 -> Prelude.return (WdExpandShiftReturn)
     15 -> Prelude.return (WdDontULTrailSpace)
     16 -> Prelude.return (WdDontBalanceSingleByteDoubleByteWidth)
     17 -> Prelude.return (WdSuppressTopSpacingMac5)
     18 -> Prelude.return (WdSpacingInWholePoints)
     19 -> Prelude.return (WdPrintBodyTextBeforeHeader)
     20 -> Prelude.return (WdNoLeading)
     21 -> Prelude.return (WdNoSpaceForUL)
     22 -> Prelude.return (WdMWSmallCaps)
     23 -> Prelude.return (WdNoExtraLineSpacing)
     24 -> Prelude.return (WdTruncateFontHeight)
     25 -> Prelude.return (WdSubFontBySize)
     26 -> Prelude.return (WdUsePrinterMetrics)
     27 -> Prelude.return (WdWW6BorderRules)
     28 -> Prelude.return (WdExactOnTop)
     29 -> Prelude.return (WdSuppressBottomSpacing)
     30 -> Prelude.return (WdWPSpaceWidth)
     31 -> Prelude.return (WdWPJustification)
     32 -> Prelude.return (WdLineWrapLikeWord6)
     _ -> Prelude.fail (Prelude.userError "unmarshallWdCompatibility: illegal enum value ")
data WdPaperSize
 = WdPaper10x14
 | WdPaper11x17
 | WdPaperLetter
 | WdPaperLetterSmall
 | WdPaperLegal
 | WdPaperExecutive
 | WdPaperA3
 | WdPaperA4
 | WdPaperA4Small
 | WdPaperA5
 | WdPaperB4
 | WdPaperB5
 | WdPaperCSheet
 | WdPaperDSheet
 | WdPaperESheet
 | WdPaperFanfoldLegalGerman
 | WdPaperFanfoldStdGerman
 | WdPaperFanfoldUS
 | WdPaperFolio
 | WdPaperLedger
 | WdPaperNote
 | WdPaperQuarto
 | WdPaperStatement
 | WdPaperTabloid
 | WdPaperEnvelope9
 | WdPaperEnvelope10
 | WdPaperEnvelope11
 | WdPaperEnvelope12
 | WdPaperEnvelope14
 | WdPaperEnvelopeB4
 | WdPaperEnvelopeB5
 | WdPaperEnvelopeB6
 | WdPaperEnvelopeC3
 | WdPaperEnvelopeC4
 | WdPaperEnvelopeC5
 | WdPaperEnvelopeC6
 | WdPaperEnvelopeC65
 | WdPaperEnvelopeDL
 | WdPaperEnvelopeItaly
 | WdPaperEnvelopeMonarch
 | WdPaperEnvelopePersonal
 | WdPaperCustom
 
marshallWdPaperSize :: WdPaperSize -> Prelude.IO Int.Int16
marshallWdPaperSize v =
  case v of
     WdPaper10x14 -> Prelude.return (0)
     WdPaper11x17 -> Prelude.return (1)
     WdPaperLetter -> Prelude.return (2)
     WdPaperLetterSmall -> Prelude.return (3)
     WdPaperLegal -> Prelude.return (4)
     WdPaperExecutive -> Prelude.return (5)
     WdPaperA3 -> Prelude.return (6)
     WdPaperA4 -> Prelude.return (7)
     WdPaperA4Small -> Prelude.return (8)
     WdPaperA5 -> Prelude.return (9)
     WdPaperB4 -> Prelude.return (10)
     WdPaperB5 -> Prelude.return (11)
     WdPaperCSheet -> Prelude.return (12)
     WdPaperDSheet -> Prelude.return (13)
     WdPaperESheet -> Prelude.return (14)
     WdPaperFanfoldLegalGerman -> Prelude.return (15)
     WdPaperFanfoldStdGerman -> Prelude.return (16)
     WdPaperFanfoldUS -> Prelude.return (17)
     WdPaperFolio -> Prelude.return (18)
     WdPaperLedger -> Prelude.return (19)
     WdPaperNote -> Prelude.return (20)
     WdPaperQuarto -> Prelude.return (21)
     WdPaperStatement -> Prelude.return (22)
     WdPaperTabloid -> Prelude.return (23)
     WdPaperEnvelope9 -> Prelude.return (24)
     WdPaperEnvelope10 -> Prelude.return (25)
     WdPaperEnvelope11 -> Prelude.return (26)
     WdPaperEnvelope12 -> Prelude.return (27)
     WdPaperEnvelope14 -> Prelude.return (28)
     WdPaperEnvelopeB4 -> Prelude.return (29)
     WdPaperEnvelopeB5 -> Prelude.return (30)
     WdPaperEnvelopeB6 -> Prelude.return (31)
     WdPaperEnvelopeC3 -> Prelude.return (32)
     WdPaperEnvelopeC4 -> Prelude.return (33)
     WdPaperEnvelopeC5 -> Prelude.return (34)
     WdPaperEnvelopeC6 -> Prelude.return (35)
     WdPaperEnvelopeC65 -> Prelude.return (36)
     WdPaperEnvelopeDL -> Prelude.return (37)
     WdPaperEnvelopeItaly -> Prelude.return (38)
     WdPaperEnvelopeMonarch -> Prelude.return (39)
     WdPaperEnvelopePersonal -> Prelude.return (40)
     WdPaperCustom -> Prelude.return (41)
unmarshallWdPaperSize :: Int.Int16 -> Prelude.IO WdPaperSize
unmarshallWdPaperSize v =
  case v of
     0 -> Prelude.return (WdPaper10x14)
     1 -> Prelude.return (WdPaper11x17)
     2 -> Prelude.return (WdPaperLetter)
     3 -> Prelude.return (WdPaperLetterSmall)
     4 -> Prelude.return (WdPaperLegal)
     5 -> Prelude.return (WdPaperExecutive)
     6 -> Prelude.return (WdPaperA3)
     7 -> Prelude.return (WdPaperA4)
     8 -> Prelude.return (WdPaperA4Small)
     9 -> Prelude.return (WdPaperA5)
     10 -> Prelude.return (WdPaperB4)
     11 -> Prelude.return (WdPaperB5)
     12 -> Prelude.return (WdPaperCSheet)
     13 -> Prelude.return (WdPaperDSheet)
     14 -> Prelude.return (WdPaperESheet)
     15 -> Prelude.return (WdPaperFanfoldLegalGerman)
     16 -> Prelude.return (WdPaperFanfoldStdGerman)
     17 -> Prelude.return (WdPaperFanfoldUS)
     18 -> Prelude.return (WdPaperFolio)
     19 -> Prelude.return (WdPaperLedger)
     20 -> Prelude.return (WdPaperNote)
     21 -> Prelude.return (WdPaperQuarto)
     22 -> Prelude.return (WdPaperStatement)
     23 -> Prelude.return (WdPaperTabloid)
     24 -> Prelude.return (WdPaperEnvelope9)
     25 -> Prelude.return (WdPaperEnvelope10)
     26 -> Prelude.return (WdPaperEnvelope11)
     27 -> Prelude.return (WdPaperEnvelope12)
     28 -> Prelude.return (WdPaperEnvelope14)
     29 -> Prelude.return (WdPaperEnvelopeB4)
     30 -> Prelude.return (WdPaperEnvelopeB5)
     31 -> Prelude.return (WdPaperEnvelopeB6)
     32 -> Prelude.return (WdPaperEnvelopeC3)
     33 -> Prelude.return (WdPaperEnvelopeC4)
     34 -> Prelude.return (WdPaperEnvelopeC5)
     35 -> Prelude.return (WdPaperEnvelopeC6)
     36 -> Prelude.return (WdPaperEnvelopeC65)
     37 -> Prelude.return (WdPaperEnvelopeDL)
     38 -> Prelude.return (WdPaperEnvelopeItaly)
     39 -> Prelude.return (WdPaperEnvelopeMonarch)
     40 -> Prelude.return (WdPaperEnvelopePersonal)
     41 -> Prelude.return (WdPaperCustom)
     _ -> Prelude.fail (Prelude.userError "unmarshallWdPaperSize: illegal enum value ")
data WdCustomLabelPageSize
 = WdCustomLabelLetter
 | WdCustomLabelLetterLS
 | WdCustomLabelA4
 | WdCustomLabelA4LS
 | WdCustomLabelA5
 | WdCustomLabelA5LS
 | WdCustomLabelB5
 | WdCustomLabelMini
 | WdCustomLabelFanfold
 
marshallWdCustomLabelPageSize :: WdCustomLabelPageSize -> Prelude.IO Int.Int16
marshallWdCustomLabelPageSize v =
  case v of
     WdCustomLabelLetter -> Prelude.return (0)
     WdCustomLabelLetterLS -> Prelude.return (1)
     WdCustomLabelA4 -> Prelude.return (2)
     WdCustomLabelA4LS -> Prelude.return (3)
     WdCustomLabelA5 -> Prelude.return (4)
     WdCustomLabelA5LS -> Prelude.return (5)
     WdCustomLabelB5 -> Prelude.return (6)
     WdCustomLabelMini -> Prelude.return (7)
     WdCustomLabelFanfold -> Prelude.return (8)
unmarshallWdCustomLabelPageSize :: Int.Int16 -> Prelude.IO WdCustomLabelPageSize
unmarshallWdCustomLabelPageSize v =
  case v of
     0 -> Prelude.return (WdCustomLabelLetter)
     1 -> Prelude.return (WdCustomLabelLetterLS)
     2 -> Prelude.return (WdCustomLabelA4)
     3 -> Prelude.return (WdCustomLabelA4LS)
     4 -> Prelude.return (WdCustomLabelA5)
     5 -> Prelude.return (WdCustomLabelA5LS)
     6 -> Prelude.return (WdCustomLabelB5)
     7 -> Prelude.return (WdCustomLabelMini)
     8 -> Prelude.return (WdCustomLabelFanfold)
     _ -> Prelude.fail (Prelude.userError "unmarshallWdCustomLabelPageSize: illegal enum value ")
data WdProtectionType
 = WdNoProtection
 | WdAllowOnlyRevisions
 | WdAllowOnlyComments
 | WdAllowOnlyFormFields
 
marshallWdProtectionType :: WdProtectionType -> Prelude.IO Int.Int16
marshallWdProtectionType v =
  case v of
     WdNoProtection -> Prelude.return ((-1))
     WdAllowOnlyRevisions -> Prelude.return (0)
     WdAllowOnlyComments -> Prelude.return (1)
     WdAllowOnlyFormFields -> Prelude.return (2)
unmarshallWdProtectionType :: Int.Int16 -> Prelude.IO WdProtectionType
unmarshallWdProtectionType v =
  case v of
     (-1) -> Prelude.return (WdNoProtection)
     0 -> Prelude.return (WdAllowOnlyRevisions)
     1 -> Prelude.return (WdAllowOnlyComments)
     2 -> Prelude.return (WdAllowOnlyFormFields)
     _ -> Prelude.fail (Prelude.userError "unmarshallWdProtectionType: illegal enum value ")
data WdPartOfSpeech
 = WdAdjective
 | WdNoun
 | WdAdverb
 | WdVerb
 
marshallWdPartOfSpeech :: WdPartOfSpeech -> Prelude.IO Int.Int16
marshallWdPartOfSpeech v =
  case v of
     WdAdjective -> Prelude.return (0)
     WdNoun -> Prelude.return (1)
     WdAdverb -> Prelude.return (2)
     WdVerb -> Prelude.return (3)
unmarshallWdPartOfSpeech :: Int.Int16 -> Prelude.IO WdPartOfSpeech
unmarshallWdPartOfSpeech v =
  case v of
     0 -> Prelude.return (WdAdjective)
     1 -> Prelude.return (WdNoun)
     2 -> Prelude.return (WdAdverb)
     3 -> Prelude.return (WdVerb)
     _ -> Prelude.fail (Prelude.userError "unmarshallWdPartOfSpeech: illegal enum value ")
data WdSubscriberFormats
 = WdSubscriberBestFormat
 | WdSubscriberRTF
 | WdSubscriberText
 | WdSubscriberPict
 
marshallWdSubscriberFormats :: WdSubscriberFormats -> Prelude.IO Int.Int16
marshallWdSubscriberFormats v =
  case v of
     WdSubscriberBestFormat -> Prelude.return (0)
     WdSubscriberRTF -> Prelude.return (1)
     WdSubscriberText -> Prelude.return (2)
     WdSubscriberPict -> Prelude.return (4)
unmarshallWdSubscriberFormats :: Int.Int16 -> Prelude.IO WdSubscriberFormats
unmarshallWdSubscriberFormats v =
  case v of
     0 -> Prelude.return (WdSubscriberBestFormat)
     1 -> Prelude.return (WdSubscriberRTF)
     2 -> Prelude.return (WdSubscriberText)
     4 -> Prelude.return (WdSubscriberPict)
     _ -> Prelude.fail (Prelude.userError "unmarshallWdSubscriberFormats: illegal enum value ")
data WdEditionType
 = WdPublisher
 | WdSubscriber
 
marshallWdEditionType :: WdEditionType -> Prelude.IO Int.Int16
marshallWdEditionType v =
  case v of
     WdPublisher -> Prelude.return (0)
     WdSubscriber -> Prelude.return (1)
unmarshallWdEditionType :: Int.Int16 -> Prelude.IO WdEditionType
unmarshallWdEditionType v =
  case v of
     0 -> Prelude.return (WdPublisher)
     1 -> Prelude.return (WdSubscriber)
     _ -> Prelude.fail (Prelude.userError "unmarshallWdEditionType: illegal enum value ")
data WdEditionOption
 = WdCancelPublisher
 | WdSendPublisher
 | WdSelectPublisher
 | WdAutomaticUpdate
 | WdManualUpdate
 | WdChangeAttributes
 | WdUpdateSubscriber
 | WdOpenSource
 
marshallWdEditionOption :: WdEditionOption -> Prelude.IO Int.Int16
marshallWdEditionOption v =
  case v of
     WdCancelPublisher -> Prelude.return (0)
     WdSendPublisher -> Prelude.return (1)
     WdSelectPublisher -> Prelude.return (2)
     WdAutomaticUpdate -> Prelude.return (3)
     WdManualUpdate -> Prelude.return (4)
     WdChangeAttributes -> Prelude.return (5)
     WdUpdateSubscriber -> Prelude.return (6)
     WdOpenSource -> Prelude.return (7)
unmarshallWdEditionOption :: Int.Int16 -> Prelude.IO WdEditionOption
unmarshallWdEditionOption v =
  case v of
     0 -> Prelude.return (WdCancelPublisher)
     1 -> Prelude.return (WdSendPublisher)
     2 -> Prelude.return (WdSelectPublisher)
     3 -> Prelude.return (WdAutomaticUpdate)
     4 -> Prelude.return (WdManualUpdate)
     5 -> Prelude.return (WdChangeAttributes)
     6 -> Prelude.return (WdUpdateSubscriber)
     7 -> Prelude.return (WdOpenSource)
     _ -> Prelude.fail (Prelude.userError "unmarshallWdEditionOption: illegal enum value ")
data WdRelativeHorizontalPosition
 = WdRelativeHorizontalPositionMargin
 | WdRelativeHorizontalPositionPage
 | WdRelativeHorizontalPositionColumn
 
marshallWdRelativeHorizontalPosition :: WdRelativeHorizontalPosition -> Prelude.IO Int.Int16
marshallWdRelativeHorizontalPosition v =
  case v of
     WdRelativeHorizontalPositionMargin -> Prelude.return (0)
     WdRelativeHorizontalPositionPage -> Prelude.return (1)
     WdRelativeHorizontalPositionColumn -> Prelude.return (2)
unmarshallWdRelativeHorizontalPosition :: Int.Int16 -> Prelude.IO WdRelativeHorizontalPosition
unmarshallWdRelativeHorizontalPosition v =
  case v of
     0 -> Prelude.return (WdRelativeHorizontalPositionMargin)
     1 -> Prelude.return (WdRelativeHorizontalPositionPage)
     2 -> Prelude.return (WdRelativeHorizontalPositionColumn)
     _ -> Prelude.fail (Prelude.userError "unmarshallWdRelativeHorizontalPosition: illegal enum value ")
data WdRelativeVerticalPosition
 = WdRelativeVerticalPositionMargin
 | WdRelativeVerticalPositionPage
 | WdRelativeVerticalPositionParagraph
 
marshallWdRelativeVerticalPosition :: WdRelativeVerticalPosition -> Prelude.IO Int.Int16
marshallWdRelativeVerticalPosition v =
  case v of
     WdRelativeVerticalPositionMargin -> Prelude.return (0)
     WdRelativeVerticalPositionPage -> Prelude.return (1)
     WdRelativeVerticalPositionParagraph -> Prelude.return (2)
unmarshallWdRelativeVerticalPosition :: Int.Int16 -> Prelude.IO WdRelativeVerticalPosition
unmarshallWdRelativeVerticalPosition v =
  case v of
     0 -> Prelude.return (WdRelativeVerticalPositionMargin)
     1 -> Prelude.return (WdRelativeVerticalPositionPage)
     2 -> Prelude.return (WdRelativeVerticalPositionParagraph)
     _ -> Prelude.fail (Prelude.userError "unmarshallWdRelativeVerticalPosition: illegal enum value ")
data WdHelpType
 = WdHelp
 | WdHelpAbout
 | WdHelpActiveWindow
 | WdHelpContents
 | WdHelpExamplesAndDemos
 | WdHelpIndex
 | WdHelpKeyboard
 | WdHelpPSSHelp
 | WdHelpQuickPreview
 | WdHelpSearch
 | WdHelpUsingHelp
 
marshallWdHelpType :: WdHelpType -> Prelude.IO Int.Int16
marshallWdHelpType v =
  case v of
     WdHelp -> Prelude.return (0)
     WdHelpAbout -> Prelude.return (1)
     WdHelpActiveWindow -> Prelude.return (2)
     WdHelpContents -> Prelude.return (3)
     WdHelpExamplesAndDemos -> Prelude.return (4)
     WdHelpIndex -> Prelude.return (5)
     WdHelpKeyboard -> Prelude.return (6)
     WdHelpPSSHelp -> Prelude.return (7)
     WdHelpQuickPreview -> Prelude.return (8)
     WdHelpSearch -> Prelude.return (9)
     WdHelpUsingHelp -> Prelude.return (10)
unmarshallWdHelpType :: Int.Int16 -> Prelude.IO WdHelpType
unmarshallWdHelpType v =
  case v of
     0 -> Prelude.return (WdHelp)
     1 -> Prelude.return (WdHelpAbout)
     2 -> Prelude.return (WdHelpActiveWindow)
     3 -> Prelude.return (WdHelpContents)
     4 -> Prelude.return (WdHelpExamplesAndDemos)
     5 -> Prelude.return (WdHelpIndex)
     6 -> Prelude.return (WdHelpKeyboard)
     7 -> Prelude.return (WdHelpPSSHelp)
     8 -> Prelude.return (WdHelpQuickPreview)
     9 -> Prelude.return (WdHelpSearch)
     10 -> Prelude.return (WdHelpUsingHelp)
     _ -> Prelude.fail (Prelude.userError "unmarshallWdHelpType: illegal enum value ")
data WdHelpTypeHID
 = WdHelpIchitaro
 | WdHelpPE2
 
marshallWdHelpTypeHID :: WdHelpTypeHID -> Prelude.IO Int.Int16
marshallWdHelpTypeHID v =
  case v of
     WdHelpIchitaro -> Prelude.return (11)
     WdHelpPE2 -> Prelude.return (12)
unmarshallWdHelpTypeHID :: Int.Int16 -> Prelude.IO WdHelpTypeHID
unmarshallWdHelpTypeHID v =
  case v of
     11 -> Prelude.return (WdHelpIchitaro)
     12 -> Prelude.return (WdHelpPE2)
     _ -> Prelude.fail (Prelude.userError "unmarshallWdHelpTypeHID: illegal enum value ")
data WdKeyCategory
 = WdKeyCategoryNil
 | WdKeyCategoryDisable
 | WdKeyCategoryCommand
 | WdKeyCategoryMacro
 | WdKeyCategoryFont
 | WdKeyCategoryAutoText
 | WdKeyCategoryStyle
 | WdKeyCategorySymbol
 | WdKeyCategoryPrefix
 
marshallWdKeyCategory :: WdKeyCategory -> Prelude.IO Int.Int16
marshallWdKeyCategory v =
  case v of
     WdKeyCategoryNil -> Prelude.return ((-1))
     WdKeyCategoryDisable -> Prelude.return (0)
     WdKeyCategoryCommand -> Prelude.return (1)
     WdKeyCategoryMacro -> Prelude.return (2)
     WdKeyCategoryFont -> Prelude.return (3)
     WdKeyCategoryAutoText -> Prelude.return (4)
     WdKeyCategoryStyle -> Prelude.return (5)
     WdKeyCategorySymbol -> Prelude.return (6)
     WdKeyCategoryPrefix -> Prelude.return (7)
unmarshallWdKeyCategory :: Int.Int16 -> Prelude.IO WdKeyCategory
unmarshallWdKeyCategory v =
  case v of
     (-1) -> Prelude.return (WdKeyCategoryNil)
     0 -> Prelude.return (WdKeyCategoryDisable)
     1 -> Prelude.return (WdKeyCategoryCommand)
     2 -> Prelude.return (WdKeyCategoryMacro)
     3 -> Prelude.return (WdKeyCategoryFont)
     4 -> Prelude.return (WdKeyCategoryAutoText)
     5 -> Prelude.return (WdKeyCategoryStyle)
     6 -> Prelude.return (WdKeyCategorySymbol)
     7 -> Prelude.return (WdKeyCategoryPrefix)
     _ -> Prelude.fail (Prelude.userError "unmarshallWdKeyCategory: illegal enum value ")
data WdKey
 = WdNoKey
 | WdKeyShift
 | WdKeyControl
 | WdKeyCommand
 | WdKeyAlt
 | WdKeyOption
 | WdKeyA
 | WdKeyB
 | WdKeyC
 | WdKeyD
 | WdKeyE
 | WdKeyF
 | WdKeyG
 | WdKeyH
 | WdKeyI
 | WdKeyJ
 | WdKeyK
 | WdKeyL
 | WdKeyM
 | WdKeyN
 | WdKeyO
 | WdKeyP
 | WdKeyQ
 | WdKeyR
 | WdKeyS
 | WdKeyT
 | WdKeyU
 | WdKeyV
 | WdKeyW
 | WdKeyX
 | WdKeyY
 | WdKeyZ
 | WdKey0
 | WdKey1
 | WdKey2
 | WdKey3
 | WdKey4
 | WdKey5
 | WdKey6
 | WdKey7
 | WdKey8
 | WdKey9
 | WdKeyBackspace
 | WdKeyTab
 | WdKeyNumeric5Special
 | WdKeyReturn
 | WdKeyPause
 | WdKeyEsc
 | WdKeySpacebar
 | WdKeyPageUp
 | WdKeyPageDown
 | WdKeyEnd
 | WdKeyHome
 | WdKeyInsert
 | WdKeyDelete
 | WdKeyNumeric0
 | WdKeyNumeric1
 | WdKeyNumeric2
 | WdKeyNumeric3
 | WdKeyNumeric4
 | WdKeyNumeric5
 | WdKeyNumeric6
 | WdKeyNumeric7
 | WdKeyNumeric8
 | WdKeyNumeric9
 | WdKeyNumericMultiply
 | WdKeyNumericAdd
 | WdKeyNumericSubtract
 | WdKeyNumericDecimal
 | WdKeyNumericDivide
 | WdKeyF1
 | WdKeyF2
 | WdKeyF3
 | WdKeyF4
 | WdKeyF5
 | WdKeyF6
 | WdKeyF7
 | WdKeyF8
 | WdKeyF9
 | WdKeyF10
 | WdKeyF11
 | WdKeyF12
 | WdKeyF13
 | WdKeyF14
 | WdKeyF15
 | WdKeyF16
 | WdKeyScrollLock
 | WdKeySemiColon
 | WdKeyEquals
 | WdKeyComma
 | WdKeyHyphen
 | WdKeyPeriod
 | WdKeySlash
 | WdKeyBackSingleQuote
 | WdKeyOpenSquareBrace
 | WdKeyBackSlash
 | WdKeyCloseSquareBrace
 | WdKeySingleQuote
 
marshallWdKey :: WdKey -> Prelude.IO Int.Int16
marshallWdKey v =
  case v of
     WdNoKey -> Prelude.return (255)
     WdKeyShift -> Prelude.return (256)
     WdKeyControl -> Prelude.return (512)
     WdKeyCommand -> Prelude.return (512)
     WdKeyAlt -> Prelude.return (1024)
     WdKeyOption -> Prelude.return (1024)
     WdKeyA -> Prelude.return (65)
     WdKeyB -> Prelude.return (66)
     WdKeyC -> Prelude.return (67)
     WdKeyD -> Prelude.return (68)
     WdKeyE -> Prelude.return (69)
     WdKeyF -> Prelude.return (70)
     WdKeyG -> Prelude.return (71)
     WdKeyH -> Prelude.return (72)
     WdKeyI -> Prelude.return (73)
     WdKeyJ -> Prelude.return (74)
     WdKeyK -> Prelude.return (75)
     WdKeyL -> Prelude.return (76)
     WdKeyM -> Prelude.return (77)
     WdKeyN -> Prelude.return (78)
     WdKeyO -> Prelude.return (79)
     WdKeyP -> Prelude.return (80)
     WdKeyQ -> Prelude.return (81)
     WdKeyR -> Prelude.return (82)
     WdKeyS -> Prelude.return (83)
     WdKeyT -> Prelude.return (84)
     WdKeyU -> Prelude.return (85)
     WdKeyV -> Prelude.return (86)
     WdKeyW -> Prelude.return (87)
     WdKeyX -> Prelude.return (88)
     WdKeyY -> Prelude.return (89)
     WdKeyZ -> Prelude.return (90)
     WdKey0 -> Prelude.return (48)
     WdKey1 -> Prelude.return (49)
     WdKey2 -> Prelude.return (50)
     WdKey3 -> Prelude.return (51)
     WdKey4 -> Prelude.return (52)
     WdKey5 -> Prelude.return (53)
     WdKey6 -> Prelude.return (54)
     WdKey7 -> Prelude.return (55)
     WdKey8 -> Prelude.return (56)
     WdKey9 -> Prelude.return (57)
     WdKeyBackspace -> Prelude.return (8)
     WdKeyTab -> Prelude.return (9)
     WdKeyNumeric5Special -> Prelude.return (12)
     WdKeyReturn -> Prelude.return (13)
     WdKeyPause -> Prelude.return (19)
     WdKeyEsc -> Prelude.return (27)
     WdKeySpacebar -> Prelude.return (32)
     WdKeyPageUp -> Prelude.return (33)
     WdKeyPageDown -> Prelude.return (34)
     WdKeyEnd -> Prelude.return (35)
     WdKeyHome -> Prelude.return (36)
     WdKeyInsert -> Prelude.return (45)
     WdKeyDelete -> Prelude.return (46)
     WdKeyNumeric0 -> Prelude.return (96)
     WdKeyNumeric1 -> Prelude.return (97)
     WdKeyNumeric2 -> Prelude.return (98)
     WdKeyNumeric3 -> Prelude.return (99)
     WdKeyNumeric4 -> Prelude.return (100)
     WdKeyNumeric5 -> Prelude.return (101)
     WdKeyNumeric6 -> Prelude.return (102)
     WdKeyNumeric7 -> Prelude.return (103)
     WdKeyNumeric8 -> Prelude.return (104)
     WdKeyNumeric9 -> Prelude.return (105)
     WdKeyNumericMultiply -> Prelude.return (106)
     WdKeyNumericAdd -> Prelude.return (107)
     WdKeyNumericSubtract -> Prelude.return (109)
     WdKeyNumericDecimal -> Prelude.return (110)
     WdKeyNumericDivide -> Prelude.return (111)
     WdKeyF1 -> Prelude.return (112)
     WdKeyF2 -> Prelude.return (113)
     WdKeyF3 -> Prelude.return (114)
     WdKeyF4 -> Prelude.return (115)
     WdKeyF5 -> Prelude.return (116)
     WdKeyF6 -> Prelude.return (117)
     WdKeyF7 -> Prelude.return (118)
     WdKeyF8 -> Prelude.return (119)
     WdKeyF9 -> Prelude.return (120)
     WdKeyF10 -> Prelude.return (121)
     WdKeyF11 -> Prelude.return (122)
     WdKeyF12 -> Prelude.return (123)
     WdKeyF13 -> Prelude.return (124)
     WdKeyF14 -> Prelude.return (125)
     WdKeyF15 -> Prelude.return (126)
     WdKeyF16 -> Prelude.return (127)
     WdKeyScrollLock -> Prelude.return (145)
     WdKeySemiColon -> Prelude.return (186)
     WdKeyEquals -> Prelude.return (187)
     WdKeyComma -> Prelude.return (188)
     WdKeyHyphen -> Prelude.return (189)
     WdKeyPeriod -> Prelude.return (190)
     WdKeySlash -> Prelude.return (191)
     WdKeyBackSingleQuote -> Prelude.return (192)
     WdKeyOpenSquareBrace -> Prelude.return (219)
     WdKeyBackSlash -> Prelude.return (220)
     WdKeyCloseSquareBrace -> Prelude.return (221)
     WdKeySingleQuote -> Prelude.return (222)
unmarshallWdKey :: Int.Int16 -> Prelude.IO WdKey
unmarshallWdKey v =
  case v of
     255 -> Prelude.return (WdNoKey)
     256 -> Prelude.return (WdKeyShift)
     512 -> Prelude.return (WdKeyControl)
     512 -> Prelude.return (WdKeyCommand)
     1024 -> Prelude.return (WdKeyAlt)
     1024 -> Prelude.return (WdKeyOption)
     65 -> Prelude.return (WdKeyA)
     66 -> Prelude.return (WdKeyB)
     67 -> Prelude.return (WdKeyC)
     68 -> Prelude.return (WdKeyD)
     69 -> Prelude.return (WdKeyE)
     70 -> Prelude.return (WdKeyF)
     71 -> Prelude.return (WdKeyG)
     72 -> Prelude.return (WdKeyH)
     73 -> Prelude.return (WdKeyI)
     74 -> Prelude.return (WdKeyJ)
     75 -> Prelude.return (WdKeyK)
     76 -> Prelude.return (WdKeyL)
     77 -> Prelude.return (WdKeyM)
     78 -> Prelude.return (WdKeyN)
     79 -> Prelude.return (WdKeyO)
     80 -> Prelude.return (WdKeyP)
     81 -> Prelude.return (WdKeyQ)
     82 -> Prelude.return (WdKeyR)
     83 -> Prelude.return (WdKeyS)
     84 -> Prelude.return (WdKeyT)
     85 -> Prelude.return (WdKeyU)
     86 -> Prelude.return (WdKeyV)
     87 -> Prelude.return (WdKeyW)
     88 -> Prelude.return (WdKeyX)
     89 -> Prelude.return (WdKeyY)
     90 -> Prelude.return (WdKeyZ)
     48 -> Prelude.return (WdKey0)
     49 -> Prelude.return (WdKey1)
     50 -> Prelude.return (WdKey2)
     51 -> Prelude.return (WdKey3)
     52 -> Prelude.return (WdKey4)
     53 -> Prelude.return (WdKey5)
     54 -> Prelude.return (WdKey6)
     55 -> Prelude.return (WdKey7)
     56 -> Prelude.return (WdKey8)
     57 -> Prelude.return (WdKey9)
     8 -> Prelude.return (WdKeyBackspace)
     9 -> Prelude.return (WdKeyTab)
     12 -> Prelude.return (WdKeyNumeric5Special)
     13 -> Prelude.return (WdKeyReturn)
     19 -> Prelude.return (WdKeyPause)
     27 -> Prelude.return (WdKeyEsc)
     32 -> Prelude.return (WdKeySpacebar)
     33 -> Prelude.return (WdKeyPageUp)
     34 -> Prelude.return (WdKeyPageDown)
     35 -> Prelude.return (WdKeyEnd)
     36 -> Prelude.return (WdKeyHome)
     45 -> Prelude.return (WdKeyInsert)
     46 -> Prelude.return (WdKeyDelete)
     96 -> Prelude.return (WdKeyNumeric0)
     97 -> Prelude.return (WdKeyNumeric1)
     98 -> Prelude.return (WdKeyNumeric2)
     99 -> Prelude.return (WdKeyNumeric3)
     100 -> Prelude.return (WdKeyNumeric4)
     101 -> Prelude.return (WdKeyNumeric5)
     102 -> Prelude.return (WdKeyNumeric6)
     103 -> Prelude.return (WdKeyNumeric7)
     104 -> Prelude.return (WdKeyNumeric8)
     105 -> Prelude.return (WdKeyNumeric9)
     106 -> Prelude.return (WdKeyNumericMultiply)
     107 -> Prelude.return (WdKeyNumericAdd)
     109 -> Prelude.return (WdKeyNumericSubtract)
     110 -> Prelude.return (WdKeyNumericDecimal)
     111 -> Prelude.return (WdKeyNumericDivide)
     112 -> Prelude.return (WdKeyF1)
     113 -> Prelude.return (WdKeyF2)
     114 -> Prelude.return (WdKeyF3)
     115 -> Prelude.return (WdKeyF4)
     116 -> Prelude.return (WdKeyF5)
     117 -> Prelude.return (WdKeyF6)
     118 -> Prelude.return (WdKeyF7)
     119 -> Prelude.return (WdKeyF8)
     120 -> Prelude.return (WdKeyF9)
     121 -> Prelude.return (WdKeyF10)
     122 -> Prelude.return (WdKeyF11)
     123 -> Prelude.return (WdKeyF12)
     124 -> Prelude.return (WdKeyF13)
     125 -> Prelude.return (WdKeyF14)
     126 -> Prelude.return (WdKeyF15)
     127 -> Prelude.return (WdKeyF16)
     145 -> Prelude.return (WdKeyScrollLock)
     186 -> Prelude.return (WdKeySemiColon)
     187 -> Prelude.return (WdKeyEquals)
     188 -> Prelude.return (WdKeyComma)
     189 -> Prelude.return (WdKeyHyphen)
     190 -> Prelude.return (WdKeyPeriod)
     191 -> Prelude.return (WdKeySlash)
     192 -> Prelude.return (WdKeyBackSingleQuote)
     219 -> Prelude.return (WdKeyOpenSquareBrace)
     220 -> Prelude.return (WdKeyBackSlash)
     221 -> Prelude.return (WdKeyCloseSquareBrace)
     222 -> Prelude.return (WdKeySingleQuote)
     _ -> Prelude.fail (Prelude.userError "unmarshallWdKey: illegal enum value ")
data WdOLEType
 = WdOLELink
 | WdOLEEmbed
 | WdOLEControl
 
marshallWdOLEType :: WdOLEType -> Prelude.IO Int.Int16
marshallWdOLEType v =
  case v of
     WdOLELink -> Prelude.return (0)
     WdOLEEmbed -> Prelude.return (1)
     WdOLEControl -> Prelude.return (2)
unmarshallWdOLEType :: Int.Int16 -> Prelude.IO WdOLEType
unmarshallWdOLEType v =
  case v of
     0 -> Prelude.return (WdOLELink)
     1 -> Prelude.return (WdOLEEmbed)
     2 -> Prelude.return (WdOLEControl)
     _ -> Prelude.fail (Prelude.userError "unmarshallWdOLEType: illegal enum value ")
data WdOLEVerb
 = WdOLEVerbPrimary
 | WdOLEVerbShow
 | WdOLEVerbOpen
 | WdOLEVerbHide
 | WdOLEVerbUIActivate
 | WdOLEVerbInPlaceActivate
 | WdOLEVerbDiscardUndoState
 
marshallWdOLEVerb :: WdOLEVerb -> Prelude.IO Int.Int16
marshallWdOLEVerb v =
  case v of
     WdOLEVerbPrimary -> Prelude.return (0)
     WdOLEVerbShow -> Prelude.return ((-1))
     WdOLEVerbOpen -> Prelude.return ((-2))
     WdOLEVerbHide -> Prelude.return ((-3))
     WdOLEVerbUIActivate -> Prelude.return ((-4))
     WdOLEVerbInPlaceActivate -> Prelude.return ((-5))
     WdOLEVerbDiscardUndoState -> Prelude.return ((-6))
unmarshallWdOLEVerb :: Int.Int16 -> Prelude.IO WdOLEVerb
unmarshallWdOLEVerb v =
  case v of
     0 -> Prelude.return (WdOLEVerbPrimary)
     (-1) -> Prelude.return (WdOLEVerbShow)
     (-2) -> Prelude.return (WdOLEVerbOpen)
     (-3) -> Prelude.return (WdOLEVerbHide)
     (-4) -> Prelude.return (WdOLEVerbUIActivate)
     (-5) -> Prelude.return (WdOLEVerbInPlaceActivate)
     (-6) -> Prelude.return (WdOLEVerbDiscardUndoState)
     _ -> Prelude.fail (Prelude.userError "unmarshallWdOLEVerb: illegal enum value ")
data WdOLEPlacement
 = WdInLine
 | WdFloatOverText
 
marshallWdOLEPlacement :: WdOLEPlacement -> Prelude.IO Int.Int16
marshallWdOLEPlacement v =
  case v of
     WdInLine -> Prelude.return (0)
     WdFloatOverText -> Prelude.return (1)
unmarshallWdOLEPlacement :: Int.Int16 -> Prelude.IO WdOLEPlacement
unmarshallWdOLEPlacement v =
  case v of
     0 -> Prelude.return (WdInLine)
     1 -> Prelude.return (WdFloatOverText)
     _ -> Prelude.fail (Prelude.userError "unmarshallWdOLEPlacement: illegal enum value ")
data WdEnvelopeOrientation
 = WdLeftPortrait
 | WdCenterPortrait
 | WdRightPortrait
 | WdLeftLandscape
 | WdCenterLandscape
 | WdRightLandscape
 | WdLeftClockwise
 | WdCenterClockwise
 | WdRightClockwise
 
marshallWdEnvelopeOrientation :: WdEnvelopeOrientation -> Prelude.IO Int.Int16
marshallWdEnvelopeOrientation v =
  case v of
     WdLeftPortrait -> Prelude.return (0)
     WdCenterPortrait -> Prelude.return (1)
     WdRightPortrait -> Prelude.return (2)
     WdLeftLandscape -> Prelude.return (3)
     WdCenterLandscape -> Prelude.return (4)
     WdRightLandscape -> Prelude.return (5)
     WdLeftClockwise -> Prelude.return (6)
     WdCenterClockwise -> Prelude.return (7)
     WdRightClockwise -> Prelude.return (8)
unmarshallWdEnvelopeOrientation :: Int.Int16 -> Prelude.IO WdEnvelopeOrientation
unmarshallWdEnvelopeOrientation v =
  case v of
     0 -> Prelude.return (WdLeftPortrait)
     1 -> Prelude.return (WdCenterPortrait)
     2 -> Prelude.return (WdRightPortrait)
     3 -> Prelude.return (WdLeftLandscape)
     4 -> Prelude.return (WdCenterLandscape)
     5 -> Prelude.return (WdRightLandscape)
     6 -> Prelude.return (WdLeftClockwise)
     7 -> Prelude.return (WdCenterClockwise)
     8 -> Prelude.return (WdRightClockwise)
     _ -> Prelude.fail (Prelude.userError "unmarshallWdEnvelopeOrientation: illegal enum value ")
data WdLetterStyle
 = WdFullBlock
 | WdModifiedBlock
 | WdSemiBlock
 
marshallWdLetterStyle :: WdLetterStyle -> Prelude.IO Int.Int16
marshallWdLetterStyle v =
  case v of
     WdFullBlock -> Prelude.return (0)
     WdModifiedBlock -> Prelude.return (1)
     WdSemiBlock -> Prelude.return (2)
unmarshallWdLetterStyle :: Int.Int16 -> Prelude.IO WdLetterStyle
unmarshallWdLetterStyle v =
  case v of
     0 -> Prelude.return (WdFullBlock)
     1 -> Prelude.return (WdModifiedBlock)
     2 -> Prelude.return (WdSemiBlock)
     _ -> Prelude.fail (Prelude.userError "unmarshallWdLetterStyle: illegal enum value ")
data WdLetterheadLocation
 = WdLetterTop
 | WdLetterBottom
 | WdLetterLeft
 | WdLetterRight
 
marshallWdLetterheadLocation :: WdLetterheadLocation -> Prelude.IO Int.Int16
marshallWdLetterheadLocation v =
  case v of
     WdLetterTop -> Prelude.return (0)
     WdLetterBottom -> Prelude.return (1)
     WdLetterLeft -> Prelude.return (2)
     WdLetterRight -> Prelude.return (3)
unmarshallWdLetterheadLocation :: Int.Int16 -> Prelude.IO WdLetterheadLocation
unmarshallWdLetterheadLocation v =
  case v of
     0 -> Prelude.return (WdLetterTop)
     1 -> Prelude.return (WdLetterBottom)
     2 -> Prelude.return (WdLetterLeft)
     3 -> Prelude.return (WdLetterRight)
     _ -> Prelude.fail (Prelude.userError "unmarshallWdLetterheadLocation: illegal enum value ")
data WdSalutationType
 = WdSalutationInformal
 | WdSalutationFormal
 | WdSalutationBusiness
 | WdSalutationOther
 
marshallWdSalutationType :: WdSalutationType -> Prelude.IO Int.Int16
marshallWdSalutationType v =
  case v of
     WdSalutationInformal -> Prelude.return (0)
     WdSalutationFormal -> Prelude.return (1)
     WdSalutationBusiness -> Prelude.return (2)
     WdSalutationOther -> Prelude.return (3)
unmarshallWdSalutationType :: Int.Int16 -> Prelude.IO WdSalutationType
unmarshallWdSalutationType v =
  case v of
     0 -> Prelude.return (WdSalutationInformal)
     1 -> Prelude.return (WdSalutationFormal)
     2 -> Prelude.return (WdSalutationBusiness)
     3 -> Prelude.return (WdSalutationOther)
     _ -> Prelude.fail (Prelude.userError "unmarshallWdSalutationType: illegal enum value ")
data WdSalutationGender
 = WdGenderFemale
 | WdGenderMale
 | WdGenderNeutral
 | WdGenderUnknown
 
marshallWdSalutationGender :: WdSalutationGender -> Prelude.IO Int.Int16
marshallWdSalutationGender v =
  case v of
     WdGenderFemale -> Prelude.return (0)
     WdGenderMale -> Prelude.return (1)
     WdGenderNeutral -> Prelude.return (2)
     WdGenderUnknown -> Prelude.return (3)
unmarshallWdSalutationGender :: Int.Int16 -> Prelude.IO WdSalutationGender
unmarshallWdSalutationGender v =
  case v of
     0 -> Prelude.return (WdGenderFemale)
     1 -> Prelude.return (WdGenderMale)
     2 -> Prelude.return (WdGenderNeutral)
     3 -> Prelude.return (WdGenderUnknown)
     _ -> Prelude.fail (Prelude.userError "unmarshallWdSalutationGender: illegal enum value ")
data WdMovementType
 = WdMove
 | WdExtend
 
marshallWdMovementType :: WdMovementType -> Prelude.IO Int.Int16
marshallWdMovementType v =
  case v of
     WdMove -> Prelude.return (0)
     WdExtend -> Prelude.return (1)
unmarshallWdMovementType :: Int.Int16 -> Prelude.IO WdMovementType
unmarshallWdMovementType v =
  case v of
     0 -> Prelude.return (WdMove)
     1 -> Prelude.return (WdExtend)
     _ -> Prelude.fail (Prelude.userError "unmarshallWdMovementType: illegal enum value ")
data WdConstants
 = WdUndefined
 | WdToggle
 | WdForward
 | WdBackward
 | WdAutoPosition
 | WdFirst
 | WdCreatorCode
 
marshallWdConstants :: WdConstants -> Prelude.IO Int.Int16
marshallWdConstants v =
  case v of
     WdUndefined -> Prelude.return (9999999)
     WdToggle -> Prelude.return (9999998)
     WdForward -> Prelude.return (1073741823)
     WdBackward -> Prelude.return ((-1073741823))
     WdAutoPosition -> Prelude.return (0)
     WdFirst -> Prelude.return (1)
     WdCreatorCode -> Prelude.return (1297307460)
unmarshallWdConstants :: Int.Int16 -> Prelude.IO WdConstants
unmarshallWdConstants v =
  case v of
     9999999 -> Prelude.return (WdUndefined)
     9999998 -> Prelude.return (WdToggle)
     1073741823 -> Prelude.return (WdForward)
     (-1073741823) -> Prelude.return (WdBackward)
     0 -> Prelude.return (WdAutoPosition)
     1 -> Prelude.return (WdFirst)
     1297307460 -> Prelude.return (WdCreatorCode)
     _ -> Prelude.fail (Prelude.userError "unmarshallWdConstants: illegal enum value ")
data WdPasteDataType
 = WdPasteOLEObject
 | WdPasteRTF
 | WdPasteText
 | WdPasteMetafilePicture
 | WdPasteBitmap
 | WdPasteDeviceIndependentBitmap
 | WdPasteHyperlink
 | WdPasteShape
 | WdPasteEnhancedMetafile
 
marshallWdPasteDataType :: WdPasteDataType -> Prelude.IO Int.Int16
marshallWdPasteDataType v =
  case v of
     WdPasteOLEObject -> Prelude.return (0)
     WdPasteRTF -> Prelude.return (1)
     WdPasteText -> Prelude.return (2)
     WdPasteMetafilePicture -> Prelude.return (3)
     WdPasteBitmap -> Prelude.return (4)
     WdPasteDeviceIndependentBitmap -> Prelude.return (5)
     WdPasteHyperlink -> Prelude.return (7)
     WdPasteShape -> Prelude.return (8)
     WdPasteEnhancedMetafile -> Prelude.return (9)
unmarshallWdPasteDataType :: Int.Int16 -> Prelude.IO WdPasteDataType
unmarshallWdPasteDataType v =
  case v of
     0 -> Prelude.return (WdPasteOLEObject)
     1 -> Prelude.return (WdPasteRTF)
     2 -> Prelude.return (WdPasteText)
     3 -> Prelude.return (WdPasteMetafilePicture)
     4 -> Prelude.return (WdPasteBitmap)
     5 -> Prelude.return (WdPasteDeviceIndependentBitmap)
     7 -> Prelude.return (WdPasteHyperlink)
     8 -> Prelude.return (WdPasteShape)
     9 -> Prelude.return (WdPasteEnhancedMetafile)
     _ -> Prelude.fail (Prelude.userError "unmarshallWdPasteDataType: illegal enum value ")
data WdPrintOutItem
 = WdPrintDocumentContent
 | WdPrintProperties
 | WdPrintComments
 | WdPrintStyles
 | WdPrintAutoTextEntries
 | WdPrintKeyAssignments
 | WdPrintEnvelope
 
marshallWdPrintOutItem :: WdPrintOutItem -> Prelude.IO Int.Int16
marshallWdPrintOutItem v =
  case v of
     WdPrintDocumentContent -> Prelude.return (0)
     WdPrintProperties -> Prelude.return (1)
     WdPrintComments -> Prelude.return (2)
     WdPrintStyles -> Prelude.return (3)
     WdPrintAutoTextEntries -> Prelude.return (4)
     WdPrintKeyAssignments -> Prelude.return (5)
     WdPrintEnvelope -> Prelude.return (6)
unmarshallWdPrintOutItem :: Int.Int16 -> Prelude.IO WdPrintOutItem
unmarshallWdPrintOutItem v =
  case v of
     0 -> Prelude.return (WdPrintDocumentContent)
     1 -> Prelude.return (WdPrintProperties)
     2 -> Prelude.return (WdPrintComments)
     3 -> Prelude.return (WdPrintStyles)
     4 -> Prelude.return (WdPrintAutoTextEntries)
     5 -> Prelude.return (WdPrintKeyAssignments)
     6 -> Prelude.return (WdPrintEnvelope)
     _ -> Prelude.fail (Prelude.userError "unmarshallWdPrintOutItem: illegal enum value ")
data WdPrintOutPages
 = WdPrintAllPages
 | WdPrintOddPagesOnly
 | WdPrintEvenPagesOnly
 
marshallWdPrintOutPages :: WdPrintOutPages -> Prelude.IO Int.Int16
marshallWdPrintOutPages v =
  case v of
     WdPrintAllPages -> Prelude.return (0)
     WdPrintOddPagesOnly -> Prelude.return (1)
     WdPrintEvenPagesOnly -> Prelude.return (2)
unmarshallWdPrintOutPages :: Int.Int16 -> Prelude.IO WdPrintOutPages
unmarshallWdPrintOutPages v =
  case v of
     0 -> Prelude.return (WdPrintAllPages)
     1 -> Prelude.return (WdPrintOddPagesOnly)
     2 -> Prelude.return (WdPrintEvenPagesOnly)
     _ -> Prelude.fail (Prelude.userError "unmarshallWdPrintOutPages: illegal enum value ")
data WdPrintOutRange
 = WdPrintAllDocument
 | WdPrintSelection
 | WdPrintCurrentPage
 | WdPrintFromTo
 | WdPrintRangeOfPages
 
marshallWdPrintOutRange :: WdPrintOutRange -> Prelude.IO Int.Int16
marshallWdPrintOutRange v =
  case v of
     WdPrintAllDocument -> Prelude.return (0)
     WdPrintSelection -> Prelude.return (1)
     WdPrintCurrentPage -> Prelude.return (2)
     WdPrintFromTo -> Prelude.return (3)
     WdPrintRangeOfPages -> Prelude.return (4)
unmarshallWdPrintOutRange :: Int.Int16 -> Prelude.IO WdPrintOutRange
unmarshallWdPrintOutRange v =
  case v of
     0 -> Prelude.return (WdPrintAllDocument)
     1 -> Prelude.return (WdPrintSelection)
     2 -> Prelude.return (WdPrintCurrentPage)
     3 -> Prelude.return (WdPrintFromTo)
     4 -> Prelude.return (WdPrintRangeOfPages)
     _ -> Prelude.fail (Prelude.userError "unmarshallWdPrintOutRange: illegal enum value ")
data WdDictionaryType
 = WdSpelling
 | WdGrammar
 | WdThesaurus
 | WdHyphenation
 | WdSpellingComplete
 | WdSpellingCustom
 | WdSpellingLegal
 | WdSpellingMedical
 
marshallWdDictionaryType :: WdDictionaryType -> Prelude.IO Int.Int16
marshallWdDictionaryType v =
  case v of
     WdSpelling -> Prelude.return (0)
     WdGrammar -> Prelude.return (1)
     WdThesaurus -> Prelude.return (2)
     WdHyphenation -> Prelude.return (3)
     WdSpellingComplete -> Prelude.return (4)
     WdSpellingCustom -> Prelude.return (5)
     WdSpellingLegal -> Prelude.return (6)
     WdSpellingMedical -> Prelude.return (7)
unmarshallWdDictionaryType :: Int.Int16 -> Prelude.IO WdDictionaryType
unmarshallWdDictionaryType v =
  case v of
     0 -> Prelude.return (WdSpelling)
     1 -> Prelude.return (WdGrammar)
     2 -> Prelude.return (WdThesaurus)
     3 -> Prelude.return (WdHyphenation)
     4 -> Prelude.return (WdSpellingComplete)
     5 -> Prelude.return (WdSpellingCustom)
     6 -> Prelude.return (WdSpellingLegal)
     7 -> Prelude.return (WdSpellingMedical)
     _ -> Prelude.fail (Prelude.userError "unmarshallWdDictionaryType: illegal enum value ")
data WdDictionaryTypeHID
 = WdHangulHanjaConversion
 | WdHangulHanjaConversionCustom
 
marshallWdDictionaryTypeHID :: WdDictionaryTypeHID -> Prelude.IO Int.Int16
marshallWdDictionaryTypeHID v =
  case v of
     WdHangulHanjaConversion -> Prelude.return (8)
     WdHangulHanjaConversionCustom -> Prelude.return (9)
unmarshallWdDictionaryTypeHID :: Int.Int16 -> Prelude.IO WdDictionaryTypeHID
unmarshallWdDictionaryTypeHID v =
  case v of
     8 -> Prelude.return (WdHangulHanjaConversion)
     9 -> Prelude.return (WdHangulHanjaConversionCustom)
     _ -> Prelude.fail (Prelude.userError "unmarshallWdDictionaryTypeHID: illegal enum value ")
data WdSpellingWordType
 = WdSpellword
 | WdWildcard
 | WdAnagram
 
marshallWdSpellingWordType :: WdSpellingWordType -> Prelude.IO Int.Int16
marshallWdSpellingWordType v =
  case v of
     WdSpellword -> Prelude.return (0)
     WdWildcard -> Prelude.return (1)
     WdAnagram -> Prelude.return (2)
unmarshallWdSpellingWordType :: Int.Int16 -> Prelude.IO WdSpellingWordType
unmarshallWdSpellingWordType v =
  case v of
     0 -> Prelude.return (WdSpellword)
     1 -> Prelude.return (WdWildcard)
     2 -> Prelude.return (WdAnagram)
     _ -> Prelude.fail (Prelude.userError "unmarshallWdSpellingWordType: illegal enum value ")
data WdSpellingErrorType
 = WdSpellingCorrect
 | WdSpellingNotInDictionary
 | WdSpellingCapitalization
 
marshallWdSpellingErrorType :: WdSpellingErrorType -> Prelude.IO Int.Int16
marshallWdSpellingErrorType v =
  case v of
     WdSpellingCorrect -> Prelude.return (0)
     WdSpellingNotInDictionary -> Prelude.return (1)
     WdSpellingCapitalization -> Prelude.return (2)
unmarshallWdSpellingErrorType :: Int.Int16 -> Prelude.IO WdSpellingErrorType
unmarshallWdSpellingErrorType v =
  case v of
     0 -> Prelude.return (WdSpellingCorrect)
     1 -> Prelude.return (WdSpellingNotInDictionary)
     2 -> Prelude.return (WdSpellingCapitalization)
     _ -> Prelude.fail (Prelude.userError "unmarshallWdSpellingErrorType: illegal enum value ")
data WdProofreadingErrorType
 = WdSpellingError
 | WdGrammaticalError
 
marshallWdProofreadingErrorType :: WdProofreadingErrorType -> Prelude.IO Int.Int16
marshallWdProofreadingErrorType v =
  case v of
     WdSpellingError -> Prelude.return (0)
     WdGrammaticalError -> Prelude.return (1)
unmarshallWdProofreadingErrorType :: Int.Int16 -> Prelude.IO WdProofreadingErrorType
unmarshallWdProofreadingErrorType v =
  case v of
     0 -> Prelude.return (WdSpellingError)
     1 -> Prelude.return (WdGrammaticalError)
     _ -> Prelude.fail (Prelude.userError "unmarshallWdProofreadingErrorType: illegal enum value ")
data WdInlineShapeType
 = WdInlineShapeEmbeddedOLEObject
 | WdInlineShapeLinkedOLEObject
 | WdInlineShapePicture
 | WdInlineShapeLinkedPicture
 | WdInlineShapeOLEControlObject
 
marshallWdInlineShapeType :: WdInlineShapeType -> Prelude.IO Int.Int16
marshallWdInlineShapeType v =
  case v of
     WdInlineShapeEmbeddedOLEObject -> Prelude.return (1)
     WdInlineShapeLinkedOLEObject -> Prelude.return (2)
     WdInlineShapePicture -> Prelude.return (3)
     WdInlineShapeLinkedPicture -> Prelude.return (4)
     WdInlineShapeOLEControlObject -> Prelude.return (5)
unmarshallWdInlineShapeType :: Int.Int16 -> Prelude.IO WdInlineShapeType
unmarshallWdInlineShapeType v =
  case v of
     1 -> Prelude.return (WdInlineShapeEmbeddedOLEObject)
     2 -> Prelude.return (WdInlineShapeLinkedOLEObject)
     3 -> Prelude.return (WdInlineShapePicture)
     4 -> Prelude.return (WdInlineShapeLinkedPicture)
     5 -> Prelude.return (WdInlineShapeOLEControlObject)
     _ -> Prelude.fail (Prelude.userError "unmarshallWdInlineShapeType: illegal enum value ")
data WdArrangeStyle
 = WdTiled
 | WdIcons
 
marshallWdArrangeStyle :: WdArrangeStyle -> Prelude.IO Int.Int16
marshallWdArrangeStyle v =
  case v of
     WdTiled -> Prelude.return (0)
     WdIcons -> Prelude.return (1)
unmarshallWdArrangeStyle :: Int.Int16 -> Prelude.IO WdArrangeStyle
unmarshallWdArrangeStyle v =
  case v of
     0 -> Prelude.return (WdTiled)
     1 -> Prelude.return (WdIcons)
     _ -> Prelude.fail (Prelude.userError "unmarshallWdArrangeStyle: illegal enum value ")
data WdSelectionFlags
 = WdSelStartActive
 | WdSelAtEOL
 | WdSelOvertype
 | WdSelActive
 | WdSelReplace
 
marshallWdSelectionFlags :: WdSelectionFlags -> Prelude.IO Int.Int16
marshallWdSelectionFlags v =
  case v of
     WdSelStartActive -> Prelude.return (1)
     WdSelAtEOL -> Prelude.return (2)
     WdSelOvertype -> Prelude.return (4)
     WdSelActive -> Prelude.return (8)
     WdSelReplace -> Prelude.return (16)
unmarshallWdSelectionFlags :: Int.Int16 -> Prelude.IO WdSelectionFlags
unmarshallWdSelectionFlags v =
  case v of
     1 -> Prelude.return (WdSelStartActive)
     2 -> Prelude.return (WdSelAtEOL)
     4 -> Prelude.return (WdSelOvertype)
     8 -> Prelude.return (WdSelActive)
     16 -> Prelude.return (WdSelReplace)
     _ -> Prelude.fail (Prelude.userError "unmarshallWdSelectionFlags: illegal enum value ")
data WdAutoVersions
 = WdAutoVersionOff
 | WdAutoVersionOnClose
 
marshallWdAutoVersions :: WdAutoVersions -> Prelude.IO Int.Int16
marshallWdAutoVersions v =
  case v of
     WdAutoVersionOff -> Prelude.return (0)
     WdAutoVersionOnClose -> Prelude.return (1)
unmarshallWdAutoVersions :: Int.Int16 -> Prelude.IO WdAutoVersions
unmarshallWdAutoVersions v =
  case v of
     0 -> Prelude.return (WdAutoVersionOff)
     1 -> Prelude.return (WdAutoVersionOnClose)
     _ -> Prelude.fail (Prelude.userError "unmarshallWdAutoVersions: illegal enum value ")
data WdOrganizerObject
 = WdOrganizerObjectStyles
 | WdOrganizerObjectAutoText
 | WdOrganizerObjectCommandBars
 | WdOrganizerObjectProjectItems
 
marshallWdOrganizerObject :: WdOrganizerObject -> Prelude.IO Int.Int16
marshallWdOrganizerObject v =
  case v of
     WdOrganizerObjectStyles -> Prelude.return (0)
     WdOrganizerObjectAutoText -> Prelude.return (1)
     WdOrganizerObjectCommandBars -> Prelude.return (2)
     WdOrganizerObjectProjectItems -> Prelude.return (3)
unmarshallWdOrganizerObject :: Int.Int16 -> Prelude.IO WdOrganizerObject
unmarshallWdOrganizerObject v =
  case v of
     0 -> Prelude.return (WdOrganizerObjectStyles)
     1 -> Prelude.return (WdOrganizerObjectAutoText)
     2 -> Prelude.return (WdOrganizerObjectCommandBars)
     3 -> Prelude.return (WdOrganizerObjectProjectItems)
     _ -> Prelude.fail (Prelude.userError "unmarshallWdOrganizerObject: illegal enum value ")
data WdFindMatch
 = WdMatchParagraphMark
 | WdMatchTabCharacter
 | WdMatchCommentMark
 | WdMatchAnyCharacter
 | WdMatchAnyDigit
 | WdMatchAnyLetter
 | WdMatchCaretCharacter
 | WdMatchColumnBreak
 | WdMatchEmDash
 | WdMatchEnDash
 | WdMatchEndnoteMark
 | WdMatchField
 | WdMatchFootnoteMark
 | WdMatchGraphic
 | WdMatchManualLineBreak
 | WdMatchManualPageBreak
 | WdMatchNonbreakingHyphen
 | WdMatchNonbreakingSpace
 | WdMatchOptionalHyphen
 | WdMatchSectionBreak
 | WdMatchWhiteSpace
 
marshallWdFindMatch :: WdFindMatch -> Prelude.IO Int.Int16
marshallWdFindMatch v =
  case v of
     WdMatchParagraphMark -> Prelude.return (65551)
     WdMatchTabCharacter -> Prelude.return (9)
     WdMatchCommentMark -> Prelude.return (5)
     WdMatchAnyCharacter -> Prelude.return (65599)
     WdMatchAnyDigit -> Prelude.return (65567)
     WdMatchAnyLetter -> Prelude.return (65583)
     WdMatchCaretCharacter -> Prelude.return (11)
     WdMatchColumnBreak -> Prelude.return (14)
     WdMatchEmDash -> Prelude.return (8212)
     WdMatchEnDash -> Prelude.return (8211)
     WdMatchEndnoteMark -> Prelude.return (65555)
     WdMatchField -> Prelude.return (19)
     WdMatchFootnoteMark -> Prelude.return (65554)
     WdMatchGraphic -> Prelude.return (1)
     WdMatchManualLineBreak -> Prelude.return (65551)
     WdMatchManualPageBreak -> Prelude.return (65564)
     WdMatchNonbreakingHyphen -> Prelude.return (30)
     WdMatchNonbreakingSpace -> Prelude.return (160)
     WdMatchOptionalHyphen -> Prelude.return (31)
     WdMatchSectionBreak -> Prelude.return (65580)
     WdMatchWhiteSpace -> Prelude.return (65655)
unmarshallWdFindMatch :: Int.Int16 -> Prelude.IO WdFindMatch
unmarshallWdFindMatch v =
  case v of
     65551 -> Prelude.return (WdMatchParagraphMark)
     9 -> Prelude.return (WdMatchTabCharacter)
     5 -> Prelude.return (WdMatchCommentMark)
     65599 -> Prelude.return (WdMatchAnyCharacter)
     65567 -> Prelude.return (WdMatchAnyDigit)
     65583 -> Prelude.return (WdMatchAnyLetter)
     11 -> Prelude.return (WdMatchCaretCharacter)
     14 -> Prelude.return (WdMatchColumnBreak)
     8212 -> Prelude.return (WdMatchEmDash)
     8211 -> Prelude.return (WdMatchEnDash)
     65555 -> Prelude.return (WdMatchEndnoteMark)
     19 -> Prelude.return (WdMatchField)
     65554 -> Prelude.return (WdMatchFootnoteMark)
     1 -> Prelude.return (WdMatchGraphic)
     65551 -> Prelude.return (WdMatchManualLineBreak)
     65564 -> Prelude.return (WdMatchManualPageBreak)
     30 -> Prelude.return (WdMatchNonbreakingHyphen)
     160 -> Prelude.return (WdMatchNonbreakingSpace)
     31 -> Prelude.return (WdMatchOptionalHyphen)
     65580 -> Prelude.return (WdMatchSectionBreak)
     65655 -> Prelude.return (WdMatchWhiteSpace)
     _ -> Prelude.fail (Prelude.userError "unmarshallWdFindMatch: illegal enum value ")
data WdFindWrap
 = WdFindStop
 | WdFindContinue
 | WdFindAsk
 
marshallWdFindWrap :: WdFindWrap -> Prelude.IO Int.Int16
marshallWdFindWrap v =
  case v of
     WdFindStop -> Prelude.return (0)
     WdFindContinue -> Prelude.return (1)
     WdFindAsk -> Prelude.return (2)
unmarshallWdFindWrap :: Int.Int16 -> Prelude.IO WdFindWrap
unmarshallWdFindWrap v =
  case v of
     0 -> Prelude.return (WdFindStop)
     1 -> Prelude.return (WdFindContinue)
     2 -> Prelude.return (WdFindAsk)
     _ -> Prelude.fail (Prelude.userError "unmarshallWdFindWrap: illegal enum value ")
data WdInformation
 = WdActiveEndAdjustedPageNumber
 | WdActiveEndSectionNumber
 | WdActiveEndPageNumber
 | WdNumberOfPagesInDocument
 | WdHorizontalPositionRelativeToPage
 | WdVerticalPositionRelativeToPage
 | WdHorizontalPositionRelativeToTextBoundary
 | WdVerticalPositionRelativeToTextBoundary
 | WdFirstCharacterColumnNumber
 | WdFirstCharacterLineNumber
 | WdFrameIsSelected
 | WdWithInTable
 | WdStartOfRangeRowNumber
 | WdEndOfRangeRowNumber
 | WdMaximumNumberOfRows
 | WdStartOfRangeColumnNumber
 | WdEndOfRangeColumnNumber
 | WdMaximumNumberOfColumns
 | WdZoomPercentage
 | WdSelectionMode
 | WdCapsLock
 | WdNumLock
 | WdOverType
 | WdRevisionMarking
 | WdInFootnoteEndnotePane
 | WdInCommentPane
 | WdInHeaderFooter
 | WdAtEndOfRowMarker
 | WdReferenceOfType
 | WdHeaderFooterType
 | WdInMasterDocument
 | WdInFootnote
 | WdInEndnote
 | WdInWordMail
 | WdInClipboard
 
marshallWdInformation :: WdInformation -> Prelude.IO Int.Int16
marshallWdInformation v =
  case v of
     WdActiveEndAdjustedPageNumber -> Prelude.return (1)
     WdActiveEndSectionNumber -> Prelude.return (2)
     WdActiveEndPageNumber -> Prelude.return (3)
     WdNumberOfPagesInDocument -> Prelude.return (4)
     WdHorizontalPositionRelativeToPage -> Prelude.return (5)
     WdVerticalPositionRelativeToPage -> Prelude.return (6)
     WdHorizontalPositionRelativeToTextBoundary -> Prelude.return (7)
     WdVerticalPositionRelativeToTextBoundary -> Prelude.return (8)
     WdFirstCharacterColumnNumber -> Prelude.return (9)
     WdFirstCharacterLineNumber -> Prelude.return (10)
     WdFrameIsSelected -> Prelude.return (11)
     WdWithInTable -> Prelude.return (12)
     WdStartOfRangeRowNumber -> Prelude.return (13)
     WdEndOfRangeRowNumber -> Prelude.return (14)
     WdMaximumNumberOfRows -> Prelude.return (15)
     WdStartOfRangeColumnNumber -> Prelude.return (16)
     WdEndOfRangeColumnNumber -> Prelude.return (17)
     WdMaximumNumberOfColumns -> Prelude.return (18)
     WdZoomPercentage -> Prelude.return (19)
     WdSelectionMode -> Prelude.return (20)
     WdCapsLock -> Prelude.return (21)
     WdNumLock -> Prelude.return (22)
     WdOverType -> Prelude.return (23)
     WdRevisionMarking -> Prelude.return (24)
     WdInFootnoteEndnotePane -> Prelude.return (25)
     WdInCommentPane -> Prelude.return (26)
     WdInHeaderFooter -> Prelude.return (28)
     WdAtEndOfRowMarker -> Prelude.return (31)
     WdReferenceOfType -> Prelude.return (32)
     WdHeaderFooterType -> Prelude.return (33)
     WdInMasterDocument -> Prelude.return (34)
     WdInFootnote -> Prelude.return (35)
     WdInEndnote -> Prelude.return (36)
     WdInWordMail -> Prelude.return (37)
     WdInClipboard -> Prelude.return (38)
unmarshallWdInformation :: Int.Int16 -> Prelude.IO WdInformation
unmarshallWdInformation v =
  case v of
     1 -> Prelude.return (WdActiveEndAdjustedPageNumber)
     2 -> Prelude.return (WdActiveEndSectionNumber)
     3 -> Prelude.return (WdActiveEndPageNumber)
     4 -> Prelude.return (WdNumberOfPagesInDocument)
     5 -> Prelude.return (WdHorizontalPositionRelativeToPage)
     6 -> Prelude.return (WdVerticalPositionRelativeToPage)
     7 -> Prelude.return (WdHorizontalPositionRelativeToTextBoundary)
     8 -> Prelude.return (WdVerticalPositionRelativeToTextBoundary)
     9 -> Prelude.return (WdFirstCharacterColumnNumber)
     10 -> Prelude.return (WdFirstCharacterLineNumber)
     11 -> Prelude.return (WdFrameIsSelected)
     12 -> Prelude.return (WdWithInTable)
     13 -> Prelude.return (WdStartOfRangeRowNumber)
     14 -> Prelude.return (WdEndOfRangeRowNumber)
     15 -> Prelude.return (WdMaximumNumberOfRows)
     16 -> Prelude.return (WdStartOfRangeColumnNumber)
     17 -> Prelude.return (WdEndOfRangeColumnNumber)
     18 -> Prelude.return (WdMaximumNumberOfColumns)
     19 -> Prelude.return (WdZoomPercentage)
     20 -> Prelude.return (WdSelectionMode)
     21 -> Prelude.return (WdCapsLock)
     22 -> Prelude.return (WdNumLock)
     23 -> Prelude.return (WdOverType)
     24 -> Prelude.return (WdRevisionMarking)
     25 -> Prelude.return (WdInFootnoteEndnotePane)
     26 -> Prelude.return (WdInCommentPane)
     28 -> Prelude.return (WdInHeaderFooter)
     31 -> Prelude.return (WdAtEndOfRowMarker)
     32 -> Prelude.return (WdReferenceOfType)
     33 -> Prelude.return (WdHeaderFooterType)
     34 -> Prelude.return (WdInMasterDocument)
     35 -> Prelude.return (WdInFootnote)
     36 -> Prelude.return (WdInEndnote)
     37 -> Prelude.return (WdInWordMail)
     38 -> Prelude.return (WdInClipboard)
     _ -> Prelude.fail (Prelude.userError "unmarshallWdInformation: illegal enum value ")
data WdWrapType
 = WdWrapSquare
 | WdWrapTight
 | WdWrapThrough
 | WdWrapNone
 | WdWrapTopBottom
 
marshallWdWrapType :: WdWrapType -> Prelude.IO Int.Int16
marshallWdWrapType v =
  case v of
     WdWrapSquare -> Prelude.return (0)
     WdWrapTight -> Prelude.return (1)
     WdWrapThrough -> Prelude.return (2)
     WdWrapNone -> Prelude.return (3)
     WdWrapTopBottom -> Prelude.return (4)
unmarshallWdWrapType :: Int.Int16 -> Prelude.IO WdWrapType
unmarshallWdWrapType v =
  case v of
     0 -> Prelude.return (WdWrapSquare)
     1 -> Prelude.return (WdWrapTight)
     2 -> Prelude.return (WdWrapThrough)
     3 -> Prelude.return (WdWrapNone)
     4 -> Prelude.return (WdWrapTopBottom)
     _ -> Prelude.fail (Prelude.userError "unmarshallWdWrapType: illegal enum value ")
data WdWrapSideType
 = WdWrapBoth
 | WdWrapLeft
 | WdWrapRight
 | WdWrapLargest
 
marshallWdWrapSideType :: WdWrapSideType -> Prelude.IO Int.Int16
marshallWdWrapSideType v =
  case v of
     WdWrapBoth -> Prelude.return (0)
     WdWrapLeft -> Prelude.return (1)
     WdWrapRight -> Prelude.return (2)
     WdWrapLargest -> Prelude.return (3)
unmarshallWdWrapSideType :: Int.Int16 -> Prelude.IO WdWrapSideType
unmarshallWdWrapSideType v =
  case v of
     0 -> Prelude.return (WdWrapBoth)
     1 -> Prelude.return (WdWrapLeft)
     2 -> Prelude.return (WdWrapRight)
     3 -> Prelude.return (WdWrapLargest)
     _ -> Prelude.fail (Prelude.userError "unmarshallWdWrapSideType: illegal enum value ")
data WdOutlineLevel
 = WdOutlineLevel1
 | WdOutlineLevel2
 | WdOutlineLevel3
 | WdOutlineLevel4
 | WdOutlineLevel5
 | WdOutlineLevel6
 | WdOutlineLevel7
 | WdOutlineLevel8
 | WdOutlineLevel9
 | WdOutlineLevelBodyText
 
marshallWdOutlineLevel :: WdOutlineLevel -> Prelude.IO Int.Int16
marshallWdOutlineLevel v =
  case v of
     WdOutlineLevel1 -> Prelude.return (1)
     WdOutlineLevel2 -> Prelude.return (2)
     WdOutlineLevel3 -> Prelude.return (3)
     WdOutlineLevel4 -> Prelude.return (4)
     WdOutlineLevel5 -> Prelude.return (5)
     WdOutlineLevel6 -> Prelude.return (6)
     WdOutlineLevel7 -> Prelude.return (7)
     WdOutlineLevel8 -> Prelude.return (8)
     WdOutlineLevel9 -> Prelude.return (9)
     WdOutlineLevelBodyText -> Prelude.return (10)
unmarshallWdOutlineLevel :: Int.Int16 -> Prelude.IO WdOutlineLevel
unmarshallWdOutlineLevel v =
  case v of
     1 -> Prelude.return (WdOutlineLevel1)
     2 -> Prelude.return (WdOutlineLevel2)
     3 -> Prelude.return (WdOutlineLevel3)
     4 -> Prelude.return (WdOutlineLevel4)
     5 -> Prelude.return (WdOutlineLevel5)
     6 -> Prelude.return (WdOutlineLevel6)
     7 -> Prelude.return (WdOutlineLevel7)
     8 -> Prelude.return (WdOutlineLevel8)
     9 -> Prelude.return (WdOutlineLevel9)
     10 -> Prelude.return (WdOutlineLevelBodyText)
     _ -> Prelude.fail (Prelude.userError "unmarshallWdOutlineLevel: illegal enum value ")
data WdTextOrientation
 = WdTextOrientationHorizontal
 | WdTextOrientationUpward
 | WdTextOrientationDownward
 
marshallWdTextOrientation :: WdTextOrientation -> Prelude.IO Int.Int16
marshallWdTextOrientation v =
  case v of
     WdTextOrientationHorizontal -> Prelude.return (0)
     WdTextOrientationUpward -> Prelude.return (2)
     WdTextOrientationDownward -> Prelude.return (3)
unmarshallWdTextOrientation :: Int.Int16 -> Prelude.IO WdTextOrientation
unmarshallWdTextOrientation v =
  case v of
     0 -> Prelude.return (WdTextOrientationHorizontal)
     2 -> Prelude.return (WdTextOrientationUpward)
     3 -> Prelude.return (WdTextOrientationDownward)
     _ -> Prelude.fail (Prelude.userError "unmarshallWdTextOrientation: illegal enum value ")
data WdTextOrientationHID
 = WdTextOrientationVerticalFarEast
 | WdTextOrientationHorizontalRotatedFarEast
 
marshallWdTextOrientationHID :: WdTextOrientationHID -> Prelude.IO Int.Int16
marshallWdTextOrientationHID v =
  case v of
     WdTextOrientationVerticalFarEast -> Prelude.return (1)
     WdTextOrientationHorizontalRotatedFarEast -> Prelude.return (4)
unmarshallWdTextOrientationHID :: Int.Int16 -> Prelude.IO WdTextOrientationHID
unmarshallWdTextOrientationHID v =
  case v of
     1 -> Prelude.return (WdTextOrientationVerticalFarEast)
     4 -> Prelude.return (WdTextOrientationHorizontalRotatedFarEast)
     _ -> Prelude.fail (Prelude.userError "unmarshallWdTextOrientationHID: illegal enum value ")
data WdPageBorderArt
 = WdArtApples
 | WdArtMapleMuffins
 | WdArtCakeSlice
 | WdArtCandyCorn
 | WdArtIceCreamCones
 | WdArtChampagneBottle
 | WdArtPartyGlass
 | WdArtChristmasTree
 | WdArtTrees
 | WdArtPalmsColor
 | WdArtBalloons3Colors
 | WdArtBalloonsHotAir
 | WdArtPartyFavor
 | WdArtConfettiStreamers
 | WdArtHearts
 | WdArtHeartBalloon
 | WdArtStars3D
 | WdArtStarsShadowed
 | WdArtStars
 | WdArtSun
 | WdArtEarth2
 | WdArtEarth1
 | WdArtPeopleHats
 | WdArtSombrero
 | WdArtPencils
 | WdArtPackages
 | WdArtClocks
 | WdArtFirecrackers
 | WdArtRings
 | WdArtMapPins
 | WdArtConfetti
 | WdArtCreaturesButterfly
 | WdArtCreaturesLadyBug
 | WdArtCreaturesFish
 | WdArtBirdsFlight
 | WdArtScaredCat
 | WdArtBats
 | WdArtFlowersRoses
 | WdArtFlowersRedRose
 | WdArtPoinsettias
 | WdArtHolly
 | WdArtFlowersTiny
 | WdArtFlowersPansy
 | WdArtFlowersModern2
 | WdArtFlowersModern1
 | WdArtWhiteFlowers
 | WdArtVine
 | WdArtFlowersDaisies
 | WdArtFlowersBlockPrint
 | WdArtDecoArchColor
 | WdArtFans
 | WdArtFilm
 | WdArtLightning1
 | WdArtCompass
 | WdArtDoubleD
 | WdArtClassicalWave
 | WdArtShadowedSquares
 | WdArtTwistedLines1
 | WdArtWaveline
 | WdArtQuadrants
 | WdArtCheckedBarColor
 | WdArtSwirligig
 | WdArtPushPinNote1
 | WdArtPushPinNote2
 | WdArtPumpkin1
 | WdArtEggsBlack
 | WdArtCup
 | WdArtHeartGray
 | WdArtGingerbreadMan
 | WdArtBabyPacifier
 | WdArtBabyRattle
 | WdArtCabins
 | WdArtHouseFunky
 | WdArtStarsBlack
 | WdArtSnowflakes
 | WdArtSnowflakeFancy
 | WdArtSkyrocket
 | WdArtSeattle
 | WdArtMusicNotes
 | WdArtPalmsBlack
 | WdArtMapleLeaf
 | WdArtPaperClips
 | WdArtShorebirdTracks
 | WdArtPeople
 | WdArtPeopleWaving
 | WdArtEclipsingSquares2
 | WdArtHypnotic
 | WdArtDiamondsGray
 | WdArtDecoArch
 | WdArtDecoBlocks
 | WdArtCirclesLines
 | WdArtPapyrus
 | WdArtWoodwork
 | WdArtWeavingBraid
 | WdArtWeavingRibbon
 | WdArtWeavingAngles
 | WdArtArchedScallops
 | WdArtSafari
 | WdArtCelticKnotwork
 | WdArtCrazyMaze
 | WdArtEclipsingSquares1
 | WdArtBirds
 | WdArtFlowersTeacup
 | WdArtNorthwest
 | WdArtSouthwest
 | WdArtTribal6
 | WdArtTribal4
 | WdArtTribal3
 | WdArtTribal2
 | WdArtTribal5
 | WdArtXIllusions
 | WdArtZanyTriangles
 | WdArtPyramids
 | WdArtPyramidsAbove
 | WdArtConfettiGrays
 | WdArtConfettiOutline
 | WdArtConfettiWhite
 | WdArtMosaic
 | WdArtLightning2
 | WdArtHeebieJeebies
 | WdArtLightBulb
 | WdArtGradient
 | WdArtTriangleParty
 | WdArtTwistedLines2
 | WdArtMoons
 | WdArtOvals
 | WdArtDoubleDiamonds
 | WdArtChainLink
 | WdArtTriangles
 | WdArtTribal1
 | WdArtMarqueeToothed
 | WdArtSharksTeeth
 | WdArtSawtooth
 | WdArtSawtoothGray
 | WdArtPostageStamp
 | WdArtWeavingStrips
 | WdArtZigZag
 | WdArtCrossStitch
 | WdArtGems
 | WdArtCirclesRectangles
 | WdArtCornerTriangles
 | WdArtCreaturesInsects
 | WdArtZigZagStitch
 | WdArtCheckered
 | WdArtCheckedBarBlack
 | WdArtMarquee
 | WdArtBasicWhiteDots
 | WdArtBasicWideMidline
 | WdArtBasicWideOutline
 | WdArtBasicWideInline
 | WdArtBasicThinLines
 | WdArtBasicWhiteDashes
 | WdArtBasicWhiteSquares
 | WdArtBasicBlackSquares
 | WdArtBasicBlackDashes
 | WdArtBasicBlackDots
 | WdArtStarsTop
 | WdArtCertificateBanner
 | WdArtHandmade1
 | WdArtHandmade2
 | WdArtTornPaper
 | WdArtTornPaperBlack
 | WdArtCouponCutoutDashes
 | WdArtCouponCutoutDots
 
marshallWdPageBorderArt :: WdPageBorderArt -> Prelude.IO Int.Int16
marshallWdPageBorderArt v =
  case v of
     WdArtApples -> Prelude.return (1)
     WdArtMapleMuffins -> Prelude.return (2)
     WdArtCakeSlice -> Prelude.return (3)
     WdArtCandyCorn -> Prelude.return (4)
     WdArtIceCreamCones -> Prelude.return (5)
     WdArtChampagneBottle -> Prelude.return (6)
     WdArtPartyGlass -> Prelude.return (7)
     WdArtChristmasTree -> Prelude.return (8)
     WdArtTrees -> Prelude.return (9)
     WdArtPalmsColor -> Prelude.return (10)
     WdArtBalloons3Colors -> Prelude.return (11)
     WdArtBalloonsHotAir -> Prelude.return (12)
     WdArtPartyFavor -> Prelude.return (13)
     WdArtConfettiStreamers -> Prelude.return (14)
     WdArtHearts -> Prelude.return (15)
     WdArtHeartBalloon -> Prelude.return (16)
     WdArtStars3D -> Prelude.return (17)
     WdArtStarsShadowed -> Prelude.return (18)
     WdArtStars -> Prelude.return (19)
     WdArtSun -> Prelude.return (20)
     WdArtEarth2 -> Prelude.return (21)
     WdArtEarth1 -> Prelude.return (22)
     WdArtPeopleHats -> Prelude.return (23)
     WdArtSombrero -> Prelude.return (24)
     WdArtPencils -> Prelude.return (25)
     WdArtPackages -> Prelude.return (26)
     WdArtClocks -> Prelude.return (27)
     WdArtFirecrackers -> Prelude.return (28)
     WdArtRings -> Prelude.return (29)
     WdArtMapPins -> Prelude.return (30)
     WdArtConfetti -> Prelude.return (31)
     WdArtCreaturesButterfly -> Prelude.return (32)
     WdArtCreaturesLadyBug -> Prelude.return (33)
     WdArtCreaturesFish -> Prelude.return (34)
     WdArtBirdsFlight -> Prelude.return (35)
     WdArtScaredCat -> Prelude.return (36)
     WdArtBats -> Prelude.return (37)
     WdArtFlowersRoses -> Prelude.return (38)
     WdArtFlowersRedRose -> Prelude.return (39)
     WdArtPoinsettias -> Prelude.return (40)
     WdArtHolly -> Prelude.return (41)
     WdArtFlowersTiny -> Prelude.return (42)
     WdArtFlowersPansy -> Prelude.return (43)
     WdArtFlowersModern2 -> Prelude.return (44)
     WdArtFlowersModern1 -> Prelude.return (45)
     WdArtWhiteFlowers -> Prelude.return (46)
     WdArtVine -> Prelude.return (47)
     WdArtFlowersDaisies -> Prelude.return (48)
     WdArtFlowersBlockPrint -> Prelude.return (49)
     WdArtDecoArchColor -> Prelude.return (50)
     WdArtFans -> Prelude.return (51)
     WdArtFilm -> Prelude.return (52)
     WdArtLightning1 -> Prelude.return (53)
     WdArtCompass -> Prelude.return (54)
     WdArtDoubleD -> Prelude.return (55)
     WdArtClassicalWave -> Prelude.return (56)
     WdArtShadowedSquares -> Prelude.return (57)
     WdArtTwistedLines1 -> Prelude.return (58)
     WdArtWaveline -> Prelude.return (59)
     WdArtQuadrants -> Prelude.return (60)
     WdArtCheckedBarColor -> Prelude.return (61)
     WdArtSwirligig -> Prelude.return (62)
     WdArtPushPinNote1 -> Prelude.return (63)
     WdArtPushPinNote2 -> Prelude.return (64)
     WdArtPumpkin1 -> Prelude.return (65)
     WdArtEggsBlack -> Prelude.return (66)
     WdArtCup -> Prelude.return (67)
     WdArtHeartGray -> Prelude.return (68)
     WdArtGingerbreadMan -> Prelude.return (69)
     WdArtBabyPacifier -> Prelude.return (70)
     WdArtBabyRattle -> Prelude.return (71)
     WdArtCabins -> Prelude.return (72)
     WdArtHouseFunky -> Prelude.return (73)
     WdArtStarsBlack -> Prelude.return (74)
     WdArtSnowflakes -> Prelude.return (75)
     WdArtSnowflakeFancy -> Prelude.return (76)
     WdArtSkyrocket -> Prelude.return (77)
     WdArtSeattle -> Prelude.return (78)
     WdArtMusicNotes -> Prelude.return (79)
     WdArtPalmsBlack -> Prelude.return (80)
     WdArtMapleLeaf -> Prelude.return (81)
     WdArtPaperClips -> Prelude.return (82)
     WdArtShorebirdTracks -> Prelude.return (83)
     WdArtPeople -> Prelude.return (84)
     WdArtPeopleWaving -> Prelude.return (85)
     WdArtEclipsingSquares2 -> Prelude.return (86)
     WdArtHypnotic -> Prelude.return (87)
     WdArtDiamondsGray -> Prelude.return (88)
     WdArtDecoArch -> Prelude.return (89)
     WdArtDecoBlocks -> Prelude.return (90)
     WdArtCirclesLines -> Prelude.return (91)
     WdArtPapyrus -> Prelude.return (92)
     WdArtWoodwork -> Prelude.return (93)
     WdArtWeavingBraid -> Prelude.return (94)
     WdArtWeavingRibbon -> Prelude.return (95)
     WdArtWeavingAngles -> Prelude.return (96)
     WdArtArchedScallops -> Prelude.return (97)
     WdArtSafari -> Prelude.return (98)
     WdArtCelticKnotwork -> Prelude.return (99)
     WdArtCrazyMaze -> Prelude.return (100)
     WdArtEclipsingSquares1 -> Prelude.return (101)
     WdArtBirds -> Prelude.return (102)
     WdArtFlowersTeacup -> Prelude.return (103)
     WdArtNorthwest -> Prelude.return (104)
     WdArtSouthwest -> Prelude.return (105)
     WdArtTribal6 -> Prelude.return (106)
     WdArtTribal4 -> Prelude.return (107)
     WdArtTribal3 -> Prelude.return (108)
     WdArtTribal2 -> Prelude.return (109)
     WdArtTribal5 -> Prelude.return (110)
     WdArtXIllusions -> Prelude.return (111)
     WdArtZanyTriangles -> Prelude.return (112)
     WdArtPyramids -> Prelude.return (113)
     WdArtPyramidsAbove -> Prelude.return (114)
     WdArtConfettiGrays -> Prelude.return (115)
     WdArtConfettiOutline -> Prelude.return (116)
     WdArtConfettiWhite -> Prelude.return (117)
     WdArtMosaic -> Prelude.return (118)
     WdArtLightning2 -> Prelude.return (119)
     WdArtHeebieJeebies -> Prelude.return (120)
     WdArtLightBulb -> Prelude.return (121)
     WdArtGradient -> Prelude.return (122)
     WdArtTriangleParty -> Prelude.return (123)
     WdArtTwistedLines2 -> Prelude.return (124)
     WdArtMoons -> Prelude.return (125)
     WdArtOvals -> Prelude.return (126)
     WdArtDoubleDiamonds -> Prelude.return (127)
     WdArtChainLink -> Prelude.return (128)
     WdArtTriangles -> Prelude.return (129)
     WdArtTribal1 -> Prelude.return (130)
     WdArtMarqueeToothed -> Prelude.return (131)
     WdArtSharksTeeth -> Prelude.return (132)
     WdArtSawtooth -> Prelude.return (133)
     WdArtSawtoothGray -> Prelude.return (134)
     WdArtPostageStamp -> Prelude.return (135)
     WdArtWeavingStrips -> Prelude.return (136)
     WdArtZigZag -> Prelude.return (137)
     WdArtCrossStitch -> Prelude.return (138)
     WdArtGems -> Prelude.return (139)
     WdArtCirclesRectangles -> Prelude.return (140)
     WdArtCornerTriangles -> Prelude.return (141)
     WdArtCreaturesInsects -> Prelude.return (142)
     WdArtZigZagStitch -> Prelude.return (143)
     WdArtCheckered -> Prelude.return (144)
     WdArtCheckedBarBlack -> Prelude.return (145)
     WdArtMarquee -> Prelude.return (146)
     WdArtBasicWhiteDots -> Prelude.return (147)
     WdArtBasicWideMidline -> Prelude.return (148)
     WdArtBasicWideOutline -> Prelude.return (149)
     WdArtBasicWideInline -> Prelude.return (150)
     WdArtBasicThinLines -> Prelude.return (151)
     WdArtBasicWhiteDashes -> Prelude.return (152)
     WdArtBasicWhiteSquares -> Prelude.return (153)
     WdArtBasicBlackSquares -> Prelude.return (154)
     WdArtBasicBlackDashes -> Prelude.return (155)
     WdArtBasicBlackDots -> Prelude.return (156)
     WdArtStarsTop -> Prelude.return (157)
     WdArtCertificateBanner -> Prelude.return (158)
     WdArtHandmade1 -> Prelude.return (159)
     WdArtHandmade2 -> Prelude.return (160)
     WdArtTornPaper -> Prelude.return (161)
     WdArtTornPaperBlack -> Prelude.return (162)
     WdArtCouponCutoutDashes -> Prelude.return (163)
     WdArtCouponCutoutDots -> Prelude.return (164)
unmarshallWdPageBorderArt :: Int.Int16 -> Prelude.IO WdPageBorderArt
unmarshallWdPageBorderArt v =
  case v of
     1 -> Prelude.return (WdArtApples)
     2 -> Prelude.return (WdArtMapleMuffins)
     3 -> Prelude.return (WdArtCakeSlice)
     4 -> Prelude.return (WdArtCandyCorn)
     5 -> Prelude.return (WdArtIceCreamCones)
     6 -> Prelude.return (WdArtChampagneBottle)
     7 -> Prelude.return (WdArtPartyGlass)
     8 -> Prelude.return (WdArtChristmasTree)
     9 -> Prelude.return (WdArtTrees)
     10 -> Prelude.return (WdArtPalmsColor)
     11 -> Prelude.return (WdArtBalloons3Colors)
     12 -> Prelude.return (WdArtBalloonsHotAir)
     13 -> Prelude.return (WdArtPartyFavor)
     14 -> Prelude.return (WdArtConfettiStreamers)
     15 -> Prelude.return (WdArtHearts)
     16 -> Prelude.return (WdArtHeartBalloon)
     17 -> Prelude.return (WdArtStars3D)
     18 -> Prelude.return (WdArtStarsShadowed)
     19 -> Prelude.return (WdArtStars)
     20 -> Prelude.return (WdArtSun)
     21 -> Prelude.return (WdArtEarth2)
     22 -> Prelude.return (WdArtEarth1)
     23 -> Prelude.return (WdArtPeopleHats)
     24 -> Prelude.return (WdArtSombrero)
     25 -> Prelude.return (WdArtPencils)
     26 -> Prelude.return (WdArtPackages)
     27 -> Prelude.return (WdArtClocks)
     28 -> Prelude.return (WdArtFirecrackers)
     29 -> Prelude.return (WdArtRings)
     30 -> Prelude.return (WdArtMapPins)
     31 -> Prelude.return (WdArtConfetti)
     32 -> Prelude.return (WdArtCreaturesButterfly)
     33 -> Prelude.return (WdArtCreaturesLadyBug)
     34 -> Prelude.return (WdArtCreaturesFish)
     35 -> Prelude.return (WdArtBirdsFlight)
     36 -> Prelude.return (WdArtScaredCat)
     37 -> Prelude.return (WdArtBats)
     38 -> Prelude.return (WdArtFlowersRoses)
     39 -> Prelude.return (WdArtFlowersRedRose)
     40 -> Prelude.return (WdArtPoinsettias)
     41 -> Prelude.return (WdArtHolly)
     42 -> Prelude.return (WdArtFlowersTiny)
     43 -> Prelude.return (WdArtFlowersPansy)
     44 -> Prelude.return (WdArtFlowersModern2)
     45 -> Prelude.return (WdArtFlowersModern1)
     46 -> Prelude.return (WdArtWhiteFlowers)
     47 -> Prelude.return (WdArtVine)
     48 -> Prelude.return (WdArtFlowersDaisies)
     49 -> Prelude.return (WdArtFlowersBlockPrint)
     50 -> Prelude.return (WdArtDecoArchColor)
     51 -> Prelude.return (WdArtFans)
     52 -> Prelude.return (WdArtFilm)
     53 -> Prelude.return (WdArtLightning1)
     54 -> Prelude.return (WdArtCompass)
     55 -> Prelude.return (WdArtDoubleD)
     56 -> Prelude.return (WdArtClassicalWave)
     57 -> Prelude.return (WdArtShadowedSquares)
     58 -> Prelude.return (WdArtTwistedLines1)
     59 -> Prelude.return (WdArtWaveline)
     60 -> Prelude.return (WdArtQuadrants)
     61 -> Prelude.return (WdArtCheckedBarColor)
     62 -> Prelude.return (WdArtSwirligig)
     63 -> Prelude.return (WdArtPushPinNote1)
     64 -> Prelude.return (WdArtPushPinNote2)
     65 -> Prelude.return (WdArtPumpkin1)
     66 -> Prelude.return (WdArtEggsBlack)
     67 -> Prelude.return (WdArtCup)
     68 -> Prelude.return (WdArtHeartGray)
     69 -> Prelude.return (WdArtGingerbreadMan)
     70 -> Prelude.return (WdArtBabyPacifier)
     71 -> Prelude.return (WdArtBabyRattle)
     72 -> Prelude.return (WdArtCabins)
     73 -> Prelude.return (WdArtHouseFunky)
     74 -> Prelude.return (WdArtStarsBlack)
     75 -> Prelude.return (WdArtSnowflakes)
     76 -> Prelude.return (WdArtSnowflakeFancy)
     77 -> Prelude.return (WdArtSkyrocket)
     78 -> Prelude.return (WdArtSeattle)
     79 -> Prelude.return (WdArtMusicNotes)
     80 -> Prelude.return (WdArtPalmsBlack)
     81 -> Prelude.return (WdArtMapleLeaf)
     82 -> Prelude.return (WdArtPaperClips)
     83 -> Prelude.return (WdArtShorebirdTracks)
     84 -> Prelude.return (WdArtPeople)
     85 -> Prelude.return (WdArtPeopleWaving)
     86 -> Prelude.return (WdArtEclipsingSquares2)
     87 -> Prelude.return (WdArtHypnotic)
     88 -> Prelude.return (WdArtDiamondsGray)
     89 -> Prelude.return (WdArtDecoArch)
     90 -> Prelude.return (WdArtDecoBlocks)
     91 -> Prelude.return (WdArtCirclesLines)
     92 -> Prelude.return (WdArtPapyrus)
     93 -> Prelude.return (WdArtWoodwork)
     94 -> Prelude.return (WdArtWeavingBraid)
     95 -> Prelude.return (WdArtWeavingRibbon)
     96 -> Prelude.return (WdArtWeavingAngles)
     97 -> Prelude.return (WdArtArchedScallops)
     98 -> Prelude.return (WdArtSafari)
     99 -> Prelude.return (WdArtCelticKnotwork)
     100 -> Prelude.return (WdArtCrazyMaze)
     101 -> Prelude.return (WdArtEclipsingSquares1)
     102 -> Prelude.return (WdArtBirds)
     103 -> Prelude.return (WdArtFlowersTeacup)
     104 -> Prelude.return (WdArtNorthwest)
     105 -> Prelude.return (WdArtSouthwest)
     106 -> Prelude.return (WdArtTribal6)
     107 -> Prelude.return (WdArtTribal4)
     108 -> Prelude.return (WdArtTribal3)
     109 -> Prelude.return (WdArtTribal2)
     110 -> Prelude.return (WdArtTribal5)
     111 -> Prelude.return (WdArtXIllusions)
     112 -> Prelude.return (WdArtZanyTriangles)
     113 -> Prelude.return (WdArtPyramids)
     114 -> Prelude.return (WdArtPyramidsAbove)
     115 -> Prelude.return (WdArtConfettiGrays)
     116 -> Prelude.return (WdArtConfettiOutline)
     117 -> Prelude.return (WdArtConfettiWhite)
     118 -> Prelude.return (WdArtMosaic)
     119 -> Prelude.return (WdArtLightning2)
     120 -> Prelude.return (WdArtHeebieJeebies)
     121 -> Prelude.return (WdArtLightBulb)
     122 -> Prelude.return (WdArtGradient)
     123 -> Prelude.return (WdArtTriangleParty)
     124 -> Prelude.return (WdArtTwistedLines2)
     125 -> Prelude.return (WdArtMoons)
     126 -> Prelude.return (WdArtOvals)
     127 -> Prelude.return (WdArtDoubleDiamonds)
     128 -> Prelude.return (WdArtChainLink)
     129 -> Prelude.return (WdArtTriangles)
     130 -> Prelude.return (WdArtTribal1)
     131 -> Prelude.return (WdArtMarqueeToothed)
     132 -> Prelude.return (WdArtSharksTeeth)
     133 -> Prelude.return (WdArtSawtooth)
     134 -> Prelude.return (WdArtSawtoothGray)
     135 -> Prelude.return (WdArtPostageStamp)
     136 -> Prelude.return (WdArtWeavingStrips)
     137 -> Prelude.return (WdArtZigZag)
     138 -> Prelude.return (WdArtCrossStitch)
     139 -> Prelude.return (WdArtGems)
     140 -> Prelude.return (WdArtCirclesRectangles)
     141 -> Prelude.return (WdArtCornerTriangles)
     142 -> Prelude.return (WdArtCreaturesInsects)
     143 -> Prelude.return (WdArtZigZagStitch)
     144 -> Prelude.return (WdArtCheckered)
     145 -> Prelude.return (WdArtCheckedBarBlack)
     146 -> Prelude.return (WdArtMarquee)
     147 -> Prelude.return (WdArtBasicWhiteDots)
     148 -> Prelude.return (WdArtBasicWideMidline)
     149 -> Prelude.return (WdArtBasicWideOutline)
     150 -> Prelude.return (WdArtBasicWideInline)
     151 -> Prelude.return (WdArtBasicThinLines)
     152 -> Prelude.return (WdArtBasicWhiteDashes)
     153 -> Prelude.return (WdArtBasicWhiteSquares)
     154 -> Prelude.return (WdArtBasicBlackSquares)
     155 -> Prelude.return (WdArtBasicBlackDashes)
     156 -> Prelude.return (WdArtBasicBlackDots)
     157 -> Prelude.return (WdArtStarsTop)
     158 -> Prelude.return (WdArtCertificateBanner)
     159 -> Prelude.return (WdArtHandmade1)
     160 -> Prelude.return (WdArtHandmade2)
     161 -> Prelude.return (WdArtTornPaper)
     162 -> Prelude.return (WdArtTornPaperBlack)
     163 -> Prelude.return (WdArtCouponCutoutDashes)
     164 -> Prelude.return (WdArtCouponCutoutDots)
     _ -> Prelude.fail (Prelude.userError "unmarshallWdPageBorderArt: illegal enum value ")
data WdBorderDistanceFrom
 = WdBorderDistanceFromText
 | WdBorderDistanceFromPageEdge
 
marshallWdBorderDistanceFrom :: WdBorderDistanceFrom -> Prelude.IO Int.Int16
marshallWdBorderDistanceFrom v =
  case v of
     WdBorderDistanceFromText -> Prelude.return (0)
     WdBorderDistanceFromPageEdge -> Prelude.return (1)
unmarshallWdBorderDistanceFrom :: Int.Int16 -> Prelude.IO WdBorderDistanceFrom
unmarshallWdBorderDistanceFrom v =
  case v of
     0 -> Prelude.return (WdBorderDistanceFromText)
     1 -> Prelude.return (WdBorderDistanceFromPageEdge)
     _ -> Prelude.fail (Prelude.userError "unmarshallWdBorderDistanceFrom: illegal enum value ")
data WdReplace
 = WdReplaceNone
 | WdReplaceOne
 | WdReplaceAll
 
marshallWdReplace :: WdReplace -> Prelude.IO Int.Int16
marshallWdReplace v =
  case v of
     WdReplaceNone -> Prelude.return (0)
     WdReplaceOne -> Prelude.return (1)
     WdReplaceAll -> Prelude.return (2)
unmarshallWdReplace :: Int.Int16 -> Prelude.IO WdReplace
unmarshallWdReplace v =
  case v of
     0 -> Prelude.return (WdReplaceNone)
     1 -> Prelude.return (WdReplaceOne)
     2 -> Prelude.return (WdReplaceAll)
     _ -> Prelude.fail (Prelude.userError "unmarshallWdReplace: illegal enum value ")
data WdFontBias
 = WdFontBiasDontCare
 | WdFontBiasDefault
 | WdFontBiasFareast
 
marshallWdFontBias :: WdFontBias -> Prelude.IO Int.Int16
marshallWdFontBias v =
  case v of
     WdFontBiasDontCare -> Prelude.return (255)
     WdFontBiasDefault -> Prelude.return (0)
     WdFontBiasFareast -> Prelude.return (1)
unmarshallWdFontBias :: Int.Int16 -> Prelude.IO WdFontBias
unmarshallWdFontBias v =
  case v of
     255 -> Prelude.return (WdFontBiasDontCare)
     0 -> Prelude.return (WdFontBiasDefault)
     1 -> Prelude.return (WdFontBiasFareast)
     _ -> Prelude.fail (Prelude.userError "unmarshallWdFontBias: illegal enum value ")
-}
-- --------------------------------------------------
-- 
-- interface Application
-- 
-- --------------------------------------------------
data Application a = Application
                      
type IApplication a = Automation.IDispatch (Application a)
iidIApplication :: Com.IID (IApplication Automation.Interface)
iidIApplication =
  Com.mkIID "{00020970-0000-0000-C000-000000000046}"
getApplication :: IApplication a -> Prelude.IO (IApplication Automation.Interface)
getApplication =
  Automation.propertyGetID 0x3e8 [] Automation.outIDispatch
getCreator :: Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getCreator = Automation.propertyGetID 0x3e9 [] Automation.outInt
getParent :: Automation.IDispatch a -> Prelude.IO (Automation.IDispatch Automation.Interface)
getParent =
  Automation.propertyGetID 0x3ea [] Automation.outIDispatch
getName :: Automation.IDispatch a -> Prelude.IO (Prelude.String)
getName = Automation.propertyGetID 0o0 [] Automation.outString
getDocuments :: Automation.IDispatch a -> Prelude.IO (IDocuments Automation.Interface)
getDocuments =
  Automation.propertyGetID 0x6 [] Automation.outIDispatch
getWindows :: Automation.IDispatch a -> Prelude.IO (IWindows Automation.Interface)
getWindows =
  Automation.propertyGetID 0x2 [] Automation.outIDispatch
getActiveDocument :: Automation.IDispatch a -> Prelude.IO (IDocument Automation.Interface)
getActiveDocument =
  Automation.propertyGetID 0x3 [] Automation.outIDispatch
getActiveWindow :: Automation.IDispatch a -> Prelude.IO (VBIDE.IWindow Automation.Interface)
getActiveWindow =
  Automation.propertyGetID 0x4 [] Automation.outIDispatch
getSelection :: Automation.IDispatch a -> Prelude.IO (ISelection Automation.Interface)
getSelection =
  Automation.propertyGetID 0x5 [] Automation.outIDispatch
getWordBasic :: Automation.IDispatch a -> Prelude.IO (Automation.IDispatch Automation.Interface)
getWordBasic =
  Automation.propertyGetID 0x1 [] Automation.outIDispatch
getRecentFiles :: Automation.IDispatch a -> Prelude.IO (IRecentFiles Automation.Interface)
getRecentFiles =
  Automation.propertyGetID 0x7 [] Automation.outIDispatch
getNormalTemplate :: Automation.IDispatch a -> Prelude.IO (ITemplate Automation.Interface)
getNormalTemplate =
  Automation.propertyGetID 0x8 [] Automation.outIDispatch
getSystem :: Automation.IDispatch a -> Prelude.IO (ISystem Automation.Interface)
getSystem = Automation.propertyGetID 0x9 [] Automation.outIDispatch
getAutoCorrect :: Automation.IDispatch a -> Prelude.IO (IAutoCorrect Automation.Interface)
getAutoCorrect =
  Automation.propertyGetID 0xa [] Automation.outIDispatch
getFontNames :: Automation.IDispatch a -> Prelude.IO (IFontNames Automation.Interface)
getFontNames =
  Automation.propertyGetID 0xb [] Automation.outIDispatch
getLandscapeFontNames :: Automation.IDispatch a -> Prelude.IO (IFontNames Automation.Interface)
getLandscapeFontNames =
  Automation.propertyGetID 0xc [] Automation.outIDispatch
getPortraitFontNames :: Automation.IDispatch a -> Prelude.IO (IFontNames Automation.Interface)
getPortraitFontNames =
  Automation.propertyGetID 0xd [] Automation.outIDispatch
getLanguages :: Automation.IDispatch a -> Prelude.IO (ILanguages Automation.Interface)
getLanguages =
  Automation.propertyGetID 0xe [] Automation.outIDispatch
getAssistant :: Automation.IDispatch a -> Prelude.IO (Office.IAssistant Automation.Interface)
getAssistant =
  Automation.propertyGetID 0xf [] Automation.outIDispatch
getBrowser :: IApplication a -> Prelude.IO (IBrowser Automation.Interface)
getBrowser =
  Automation.propertyGetID 0x10 [] Automation.outIDispatch
getFileConverters :: Automation.IDispatch a -> Prelude.IO (IFileConverters Automation.Interface)
getFileConverters =
  Automation.propertyGetID 0x11 [] Automation.outIDispatch
getMailingLabel :: IApplication a -> Prelude.IO (IMailingLabel Automation.Interface)
getMailingLabel =
  Automation.propertyGetID 0x12 [] Automation.outIDispatch
getDialogs :: Automation.IDispatch a -> Prelude.IO (IDialogs Automation.Interface)
getDialogs =
  Automation.propertyGetID 0x13 [] Automation.outIDispatch
getCaptionLabels :: Automation.IDispatch a -> Prelude.IO (ICaptionLabels Automation.Interface)
getCaptionLabels =
  Automation.propertyGetID 0x14 [] Automation.outIDispatch
getAutoCaptions :: Automation.IDispatch a -> Prelude.IO (IAutoCaptions Automation.Interface)
getAutoCaptions =
  Automation.propertyGetID 0x15 [] Automation.outIDispatch
getAddIns :: Automation.IDispatch a -> Prelude.IO (IAddIns Automation.Interface)
getAddIns =
  Automation.propertyGetID 0x16 [] Automation.outIDispatch
getVisible :: Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getVisible = Automation.propertyGetID 0x17 [] Automation.outInt
setVisible :: Prelude.Int -> Automation.IDispatch a -> Prelude.IO ()
setVisible prop =
  Automation.propertySetID 0x17 [Automation.inInt prop]
getVersion :: Automation.IDispatch a -> Prelude.IO (Prelude.String)
getVersion = Automation.propertyGetID 0x18 [] Automation.outString
getScreenUpdating :: IApplication a -> Prelude.IO (Prelude.Int)
getScreenUpdating =
  Automation.propertyGetID 0x1a [] Automation.outInt
setScreenUpdating :: Prelude.Int -> IApplication a -> Prelude.IO ()
setScreenUpdating prop =
  Automation.propertySetID 0x1a [Automation.inInt prop]
getPrintPreview :: Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getPrintPreview =
  Automation.propertyGetID 0x1b [] Automation.outInt
setPrintPreview :: Prelude.Int -> Automation.IDispatch a -> Prelude.IO ()
setPrintPreview prop =
  Automation.propertySetID 0x1b [Automation.inInt prop]
getTasks :: Automation.IDispatch a -> Prelude.IO (ITasks Automation.Interface)
getTasks = Automation.propertyGetID 0x1c [] Automation.outIDispatch
getDisplayStatusBar :: IApplication a -> Prelude.IO (Prelude.Int)
getDisplayStatusBar =
  Automation.propertyGetID 0x1d [] Automation.outInt
setDisplayStatusBar :: Prelude.Int -> IApplication a -> Prelude.IO ()
setDisplayStatusBar prop =
  Automation.propertySetID 0x1d [Automation.inInt prop]
getSpecialMode :: IApplication a -> Prelude.IO (Prelude.Int)
getSpecialMode = Automation.propertyGetID 0x1e [] Automation.outInt
getUsableWidth :: IApplication a -> Prelude.IO (Prelude.Int)
getUsableWidth = Automation.propertyGetID 0x21 [] Automation.outInt
getUsableHeight :: IApplication a -> Prelude.IO (Prelude.Int)
getUsableHeight =
  Automation.propertyGetID 0x22 [] Automation.outInt
getMathCoprocessorAvailable :: IApplication a -> Prelude.IO (Prelude.Int)
getMathCoprocessorAvailable =
  Automation.propertyGetID 0x24 [] Automation.outInt
getMouseAvailable :: IApplication a -> Prelude.IO (Prelude.Int)
getMouseAvailable =
  Automation.propertyGetID 0x25 [] Automation.outInt
getInternational :: (Automation.Variant a0) => a0 -> IApplication a -> Prelude.IO (Prelude.Int)
getInternational idex =
  Automation.propertyGetID 0x2e [Automation.inVariant idex] Automation.outInt
getBuild :: IApplication a -> Prelude.IO (Prelude.String)
getBuild = Automation.propertyGetID 0x2f [] Automation.outString
getCapsLock :: IApplication a -> Prelude.IO (Prelude.Int)
getCapsLock = Automation.propertyGetID 0x30 [] Automation.outInt
getNumLock :: IApplication a -> Prelude.IO (Prelude.Int)
getNumLock = Automation.propertyGetID 0x31 [] Automation.outInt
getUserName :: IApplication a -> Prelude.IO (Prelude.String)
getUserName = Automation.propertyGetID 0x34 [] Automation.outString
setUserName :: Prelude.String -> IApplication a -> Prelude.IO ()
setUserName prop =
  Automation.propertySetID 0x34 [Automation.inString prop]
getUserInitials :: IApplication a -> Prelude.IO (Prelude.String)
getUserInitials =
  Automation.propertyGetID 0x35 [] Automation.outString
setUserInitials :: Prelude.String -> IApplication a -> Prelude.IO ()
setUserInitials prop =
  Automation.propertySetID 0x35 [Automation.inString prop]
getUserAddress :: IApplication a -> Prelude.IO (Prelude.String)
getUserAddress =
  Automation.propertyGetID 0x36 [] Automation.outString
setUserAddress :: Prelude.String -> IApplication a -> Prelude.IO ()
setUserAddress prop =
  Automation.propertySetID 0x36 [Automation.inString prop]
getMacroContainer :: Automation.IDispatch a -> Prelude.IO (Automation.IDispatch Automation.Interface)
getMacroContainer =
  Automation.propertyGetID 0x37 [] Automation.outIDispatch
getDisplayRecentFiles :: IApplication a -> Prelude.IO (Prelude.Int)
getDisplayRecentFiles =
  Automation.propertyGetID 0x38 [] Automation.outInt
setDisplayRecentFiles :: Prelude.Int -> IApplication a -> Prelude.IO ()
setDisplayRecentFiles prop =
  Automation.propertySetID 0x38 [Automation.inInt prop]
getCommandBars :: Automation.IDispatch a -> Prelude.IO (Office.ICommandBars Automation.Interface)
getCommandBars =
  Automation.propertyGetID 0x39 [] Automation.outIDispatch
getSynonymInfo :: Prelude.String -> Prelude.Int -> Automation.IDispatch a -> Prelude.IO (ISynonymInfo Automation.Interface)
getSynonymInfo word languageID =
  Automation.propertyGetID 0x3b [Automation.inString word, Automation.inInt languageID] Automation.outIDispatch
getVBE :: Automation.IDispatch a -> Prelude.IO (VBIDE.IVBE Automation.Interface)
getVBE = Automation.propertyGetID 0x3d [] Automation.outIDispatch
getDefaultSaveFormat :: IApplication a -> Prelude.IO (Prelude.String)
getDefaultSaveFormat =
  Automation.propertyGetID 0x40 [] Automation.outString
setDefaultSaveFormat :: Prelude.String -> IApplication a -> Prelude.IO ()
setDefaultSaveFormat prop =
  Automation.propertySetID 0x40 [Automation.inString prop]
getListGalleries :: Automation.IDispatch a -> Prelude.IO (IListGalleries Automation.Interface)
getListGalleries =
  Automation.propertyGetID 0x41 [] Automation.outIDispatch
getActivePrinter :: Automation.IDispatch a -> Prelude.IO (Prelude.String)
getActivePrinter =
  Automation.propertyGetID 0x42 [] Automation.outString
setActivePrinter :: Prelude.String -> Automation.IDispatch a -> Prelude.IO ()
setActivePrinter prop =
  Automation.propertySetID 0x42 [Automation.inString prop]
getTemplates :: Automation.IDispatch a -> Prelude.IO (ITemplates Automation.Interface)
getTemplates =
  Automation.propertyGetID 0x43 [] Automation.outIDispatch
getCustomizationContext :: Automation.IDispatch a -> Prelude.IO (Automation.IDispatch Automation.Interface)
getCustomizationContext =
  Automation.propertyGetID 0x44 [] Automation.outIDispatch
setCustomizationContext :: Automation.IDispatch a0 -> Automation.IDispatch a -> Prelude.IO ()
setCustomizationContext prop =
  Automation.propertySetID 0x44 [Automation.inIDispatch prop]
getKeyBindings :: Automation.IDispatch a -> Prelude.IO (IKeyBindings Automation.Interface)
getKeyBindings =
  Automation.propertyGetID 0x45 [] Automation.outIDispatch
getKeysBoundTo :: (Automation.Variant a0) => a0 -> Prelude.String -> Prelude.Int -> Automation.IDispatch a -> Prelude.IO (IKeysBoundTo Automation.Interface)
getKeysBoundTo keyCategory command commandParameter =
  Automation.propertyGetID 0x46 [Automation.inVariant keyCategory, Automation.inString command, Automation.inInt commandParameter] Automation.outIDispatch
getFindKey :: Prelude.Int -> Prelude.Int -> Automation.IDispatch a -> Prelude.IO (IKeyBinding Automation.Interface)
getFindKey keyCode keyCode2 =
  Automation.propertyGetID 0x47 [Automation.inInt keyCode, Automation.inInt keyCode2] Automation.outIDispatch
getCaption :: Automation.IDispatch a -> Prelude.IO (Prelude.String)
getCaption = Automation.propertyGetID 0x50 [] Automation.outString
setCaption :: Prelude.String -> Automation.IDispatch a -> Prelude.IO ()
setCaption prop =
  Automation.propertySetID 0x50 [Automation.inString prop]
getPath :: Automation.IDispatch a -> Prelude.IO (Prelude.String)
getPath = Automation.propertyGetID 0x51 [] Automation.outString
getDisplayScrollBars :: IApplication a -> Prelude.IO (Prelude.Int)
getDisplayScrollBars =
  Automation.propertyGetID 0x52 [] Automation.outInt
setDisplayScrollBars :: Prelude.Int -> IApplication a -> Prelude.IO ()
setDisplayScrollBars prop =
  Automation.propertySetID 0x52 [Automation.inInt prop]
getStartupPath :: IApplication a -> Prelude.IO (Prelude.String)
getStartupPath =
  Automation.propertyGetID 0x53 [] Automation.outString
setStartupPath :: Prelude.String -> IApplication a -> Prelude.IO ()
setStartupPath prop =
  Automation.propertySetID 0x53 [Automation.inString prop]
getBackgroundSavingStatus :: IApplication a -> Prelude.IO (Prelude.Int)
getBackgroundSavingStatus =
  Automation.propertyGetID 0x55 [] Automation.outInt
getBackgroundPrintingStatus :: IApplication a -> Prelude.IO (Prelude.Int)
getBackgroundPrintingStatus =
  Automation.propertyGetID 0x56 [] Automation.outInt
getLeft :: Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getLeft = Automation.propertyGetID 0x57 [] Automation.outInt
setLeft :: Prelude.Int -> Automation.IDispatch a -> Prelude.IO ()
setLeft prop =
  Automation.propertySetID 0x57 [Automation.inInt prop]
getTop :: Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getTop = Automation.propertyGetID 0x58 [] Automation.outInt
setTop :: Prelude.Int -> Automation.IDispatch a -> Prelude.IO ()
setTop prop = Automation.propertySetID 0x58 [Automation.inInt prop]
getWidth :: Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getWidth = Automation.propertyGetID 0x59 [] Automation.outInt
setWidth :: Prelude.Int -> Automation.IDispatch a -> Prelude.IO ()
setWidth prop =
  Automation.propertySetID 0x59 [Automation.inInt prop]
getHeight :: Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getHeight = Automation.propertyGetID 0x5a [] Automation.outInt
setHeight :: Prelude.Int -> Automation.IDispatch a -> Prelude.IO ()
setHeight prop =
  Automation.propertySetID 0x5a [Automation.inInt prop]
getWindowState :: (Automation.Variant a0) => Automation.IDispatch a -> Prelude.IO (a0)
getWindowState =
  Automation.propertyGetID 0x5b [] Automation.outVariant
setWindowState :: (Automation.Variant a0) => a0 -> Automation.IDispatch a -> Prelude.IO ()
setWindowState prop =
  Automation.propertySetID 0x5b [Automation.inVariant prop]
getDisplayAutoCompleteTips :: IApplication a -> Prelude.IO (Prelude.Int)
getDisplayAutoCompleteTips =
  Automation.propertyGetID 0x5c [] Automation.outInt
setDisplayAutoCompleteTips :: Prelude.Int -> IApplication a -> Prelude.IO ()
setDisplayAutoCompleteTips prop =
  Automation.propertySetID 0x5c [Automation.inInt prop]
getOptions :: Automation.IDispatch a -> Prelude.IO (IOptions Automation.Interface)
getOptions =
  Automation.propertyGetID 0x5d [] Automation.outIDispatch
getDisplayAlerts :: (Automation.Variant a0) => IApplication a -> Prelude.IO (a0)
getDisplayAlerts =
  Automation.propertyGetID 0x5e [] Automation.outVariant
setDisplayAlerts :: (Automation.Variant a0) => a0 -> IApplication a -> Prelude.IO ()
setDisplayAlerts prop =
  Automation.propertySetID 0x5e [Automation.inVariant prop]
getCustomDictionaries :: Automation.IDispatch a -> Prelude.IO (IDictionaries Automation.Interface)
getCustomDictionaries =
  Automation.propertyGetID 0x5f [] Automation.outIDispatch
getPathSeparator :: IApplication a -> Prelude.IO (Prelude.String)
getPathSeparator =
  Automation.propertyGetID 0x60 [] Automation.outString
setStatusBar :: Prelude.String -> Automation.IDispatch a -> Prelude.IO ()
setStatusBar rhs =
  Automation.propertySetID 0x61 [Automation.inString rhs]
getMAPIAvailable :: IApplication a -> Prelude.IO (Prelude.Int)
getMAPIAvailable =
  Automation.propertyGetID 0x62 [] Automation.outInt
getDisplayScreenTips :: Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getDisplayScreenTips =
  Automation.propertyGetID 0x63 [] Automation.outInt
setDisplayScreenTips :: Prelude.Int -> Automation.IDispatch a -> Prelude.IO ()
setDisplayScreenTips prop =
  Automation.propertySetID 0x63 [Automation.inInt prop]
getEnableCancelKey :: (Automation.Variant a0) => IApplication a -> Prelude.IO (a0)
getEnableCancelKey =
  Automation.propertyGetID 0x64 [] Automation.outVariant
setEnableCancelKey :: (Automation.Variant a0) => a0 -> IApplication a -> Prelude.IO ()
setEnableCancelKey prop =
  Automation.propertySetID 0x64 [Automation.inVariant prop]
getUserControl :: Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getUserControl = Automation.propertyGetID 0x65 [] Automation.outInt
getFileSearch :: IApplication a -> Prelude.IO (Office.IFileSearch Automation.Interface)
getFileSearch =
  Automation.propertyGetID 0x67 [] Automation.outIDispatch
getMailSystem :: (Automation.Variant a0) => IApplication a -> Prelude.IO (a0)
getMailSystem =
  Automation.propertyGetID 0x68 [] Automation.outVariant
getDefaultTableSeparator :: IApplication a -> Prelude.IO (Prelude.String)
getDefaultTableSeparator =
  Automation.propertyGetID 0x69 [] Automation.outString
setDefaultTableSeparator :: Prelude.String -> IApplication a -> Prelude.IO ()
setDefaultTableSeparator prop =
  Automation.propertySetID 0x69 [Automation.inString prop]
getShowVisualBasicEditor :: Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getShowVisualBasicEditor =
  Automation.propertyGetID 0x6a [] Automation.outInt
setShowVisualBasicEditor :: Prelude.Int -> Automation.IDispatch a -> Prelude.IO ()
setShowVisualBasicEditor prop =
  Automation.propertySetID 0x6a [Automation.inInt prop]
getBrowseExtraFileTypes :: IApplication a -> Prelude.IO (Prelude.String)
getBrowseExtraFileTypes =
  Automation.propertyGetID 0x6c [] Automation.outString
setBrowseExtraFileTypes :: Prelude.String -> IApplication a -> Prelude.IO ()
setBrowseExtraFileTypes prop =
  Automation.propertySetID 0x6c [Automation.inString prop]
getIsObjectValid :: Automation.IDispatch a0 -> Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getIsObjectValid object =
  Automation.propertyGetID 0x6d [Automation.inIDispatch object] Automation.outInt
getHangulHanjaDictionaries :: Automation.IDispatch a -> Prelude.IO (IHangulHanjaConversionDictionaries Automation.Interface)
getHangulHanjaDictionaries =
  Automation.propertyGetID 0x6e [] Automation.outIDispatch
getMailMessage :: IApplication a -> Prelude.IO (IMailMessage Automation.Interface)
getMailMessage =
  Automation.propertyGetID 0x15c [] Automation.outIDispatch
getFocusInMailHeader :: IApplication a -> Prelude.IO (Prelude.Int)
getFocusInMailHeader =
  Automation.propertyGetID 0x182 [] Automation.outInt
quit :: Prelude.Int -> Prelude.Int -> Prelude.Int -> IApplication a -> Prelude.IO ()
quit saveChanges originalFormat routeDocument =
  Automation.methodID0 0x451 [Automation.inInt saveChanges, Automation.inInt originalFormat, Automation.inInt routeDocument]
screenRefresh :: IApplication a -> Prelude.IO ()
screenRefresh = Automation.methodID0 0x12d []
printOut :: Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> IApplication a -> Prelude.IO ()
printOut background append range outputFileName from to item copies pages pageType printToFile collate fileName activePrinterMacGX manualDuplexPrint =
  Automation.methodID0 0x12e [Automation.inInt background, Automation.inInt append, Automation.inInt range, Automation.inInt outputFileName, Automation.inInt from, Automation.inInt to, Automation.inInt item, Automation.inInt copies, Automation.inInt pages, Automation.inInt pageType, Automation.inInt printToFile, Automation.inInt collate, Automation.inInt fileName, Automation.inInt activePrinterMacGX, Automation.inInt manualDuplexPrint]
lookupNameProperties :: Prelude.String -> IApplication a -> Prelude.IO ()
lookupNameProperties name =
  Automation.methodID0 0x12f [Automation.inString name]
substituteFont :: Prelude.String -> Prelude.String -> IApplication a -> Prelude.IO ()
substituteFont unavailableFont substituteFont =
  Automation.methodID0 0x130 [Automation.inString unavailableFont, Automation.inString substituteFont]
repeat :: Prelude.Int -> Automation.IDispatch a -> Prelude.IO (Prelude.Int)
repeat times =
  Automation.functionID1 0x131 [Automation.inInt times] Automation.outInt
dDEExecute :: Prelude.Int -> Prelude.String -> Automation.IDispatch a -> Prelude.IO ()
dDEExecute channel command =
  Automation.methodID0 0x136 [Automation.inInt channel, Automation.inString command]
dDEInitiate :: Prelude.String -> Prelude.String -> Automation.IDispatch a -> Prelude.IO (Prelude.Int)
dDEInitiate app topic =
  Automation.functionID1 0x137 [Automation.inString app, Automation.inString topic] Automation.outInt
dDEPoke :: Prelude.Int -> Prelude.String -> Prelude.String -> Automation.IDispatch a -> Prelude.IO ()
dDEPoke channel item data0 =
  Automation.methodID0 0x138 [Automation.inInt channel, Automation.inString item, Automation.inString data0]
dDERequest :: Prelude.Int -> Prelude.String -> Automation.IDispatch a -> Prelude.IO (Prelude.String)
dDERequest channel item =
  Automation.functionID1 0x139 [Automation.inInt channel, Automation.inString item] Automation.outString
dDETerminate :: Prelude.Int -> Automation.IDispatch a -> Prelude.IO ()
dDETerminate channel =
  Automation.methodID0 0x13a [Automation.inInt channel]
dDETerminateAll :: Automation.IDispatch a -> Prelude.IO ()
dDETerminateAll = Automation.methodID0 0x13b []
buildKeyCode :: (Automation.Variant a0) => a0 -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Automation.IDispatch a -> Prelude.IO (Prelude.Int)
buildKeyCode arg1 arg2 arg3 arg4 =
  Automation.functionID1 0x13c [Automation.inVariant arg1, Automation.inInt arg2, Automation.inInt arg3, Automation.inInt arg4] Automation.outInt
keyString :: Prelude.Int -> Prelude.Int -> Automation.IDispatch a -> Prelude.IO (Prelude.String)
keyString keyCode keyCode2 =
  Automation.functionID1 0x13d [Automation.inInt keyCode, Automation.inInt keyCode2] Automation.outString
organizerCopy :: (Automation.Variant a0) => Prelude.String -> Prelude.String -> Prelude.String -> a0 -> IApplication a -> Prelude.IO ()
organizerCopy source destination name object =
  Automation.methodID0 0x13e [Automation.inString source, Automation.inString destination, Automation.inString name, Automation.inVariant object]
organizerDelete :: (Automation.Variant a0) => Prelude.String -> Prelude.String -> a0 -> IApplication a -> Prelude.IO ()
organizerDelete source name object =
  Automation.methodID0 0x13f [Automation.inString source, Automation.inString name, Automation.inVariant object]
organizerRename :: (Automation.Variant a0) => Prelude.String -> Prelude.String -> Prelude.String -> a0 -> IApplication a -> Prelude.IO ()
organizerRename source name newName object =
  Automation.methodID0 0x140 [Automation.inString source, Automation.inString name, Automation.inString newName, Automation.inVariant object]

getAddress :: Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> IApplication a -> Prelude.IO (Prelude.String)
getAddress name addressProperties useAutoText displaySelectDialog selectDialog checkNamesDialog recentAddressesChoice updateRecentAddresses =
  Automation.functionID1 0x142 [Automation.inInt name, Automation.inInt addressProperties, Automation.inInt useAutoText, Automation.inInt displaySelectDialog, Automation.inInt selectDialog, Automation.inInt checkNamesDialog, Automation.inInt recentAddressesChoice, Automation.inInt updateRecentAddresses] Automation.outString
checkGrammar :: Prelude.String -> IApplication a -> Prelude.IO (Prelude.Int)
checkGrammar string =
  Automation.functionID1 0x143 [Automation.inString string] Automation.outInt
checkSpelling :: Prelude.String -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Automation.IDispatch a -> Prelude.IO (Prelude.Int)
checkSpelling word customDictionary ignoreUppercase mainDictionary customDictionary2 customDictionary3 customDictionary4 customDictionary5 customDictionary6 customDictionary7 customDictionary8 customDictionary9 customDictionary10 =
  Automation.functionID1 0x144 [Automation.inString word, Automation.inInt customDictionary, Automation.inInt ignoreUppercase, Automation.inInt mainDictionary, Automation.inInt customDictionary2, Automation.inInt customDictionary3, Automation.inInt customDictionary4, Automation.inInt customDictionary5, Automation.inInt customDictionary6, Automation.inInt customDictionary7, Automation.inInt customDictionary8, Automation.inInt customDictionary9, Automation.inInt customDictionary10] Automation.outInt
resetIgnoreAll :: IApplication a -> Prelude.IO ()
resetIgnoreAll = Automation.methodID0 0x146 []
getSpellingSuggestions :: Prelude.String -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Automation.IDispatch a -> Prelude.IO (ISpellingSuggestions Automation.Interface)
getSpellingSuggestions word customDictionary ignoreUppercase mainDictionary suggestionMode customDictionary2 customDictionary3 customDictionary4 customDictionary5 customDictionary6 customDictionary7 customDictionary8 customDictionary9 customDictionary10 =
  Automation.functionID1 0x147 [Automation.inString word, Automation.inInt customDictionary, Automation.inInt ignoreUppercase, Automation.inInt mainDictionary, Automation.inInt suggestionMode, Automation.inInt customDictionary2, Automation.inInt customDictionary3, Automation.inInt customDictionary4, Automation.inInt customDictionary5, Automation.inInt customDictionary6, Automation.inInt customDictionary7, Automation.inInt customDictionary8, Automation.inInt customDictionary9, Automation.inInt customDictionary10] Automation.outIDispatch
goBack :: IApplication a -> Prelude.IO ()
goBack = Automation.methodID0 0x148 []
help :: Prelude.Int -> Automation.IDispatch a -> Prelude.IO ()
help helpType =
  Automation.methodID0 0x149 [Automation.inInt helpType]
automaticChange :: IApplication a -> Prelude.IO ()
automaticChange = Automation.methodID0 0x14a []
showMe :: IApplication a -> Prelude.IO ()
showMe = Automation.methodID0 0x14b []
helpTool :: IApplication a -> Prelude.IO ()
helpTool = Automation.methodID0 0x14c []
newWindow :: Automation.IDispatch a -> Prelude.IO (VBIDE.IWindow Automation.Interface)
newWindow = Automation.functionID1 0x159 [] Automation.outIDispatch
listCommands :: Prelude.Int -> IApplication a -> Prelude.IO ()
listCommands listAllCommands =
  Automation.methodID0 0x15a [Automation.inInt listAllCommands]
showClipboard :: IApplication a -> Prelude.IO ()
showClipboard = Automation.methodID0 0x15d []
onTime :: Prelude.Int -> Prelude.String -> Prelude.Int -> IApplication a -> Prelude.IO ()
onTime when name tolerance =
  Automation.methodID0 0x15e [Automation.inInt when, Automation.inString name, Automation.inInt tolerance]
nextLetter :: IApplication a -> Prelude.IO ()
nextLetter = Automation.methodID0 0x15f []
mountVolume :: Prelude.String -> Prelude.String -> Prelude.String -> Prelude.Int -> Prelude.Int -> Prelude.Int -> IApplication a -> Prelude.IO (Prelude.Int)
mountVolume zone server volume user userPassword volumePassword =
  Automation.functionID1 0x161 [Automation.inString zone, Automation.inString server, Automation.inString volume, Automation.inInt user, Automation.inInt userPassword, Automation.inInt volumePassword] Automation.outInt
cleanString :: Prelude.String -> Automation.IDispatch a -> Prelude.IO (Prelude.String)
cleanString string =
  Automation.functionID1 0x162 [Automation.inString string] Automation.outString
sendFax :: IApplication a -> Prelude.IO ()
sendFax = Automation.methodID0 0x164 []
changeFileOpenDirectory :: Prelude.String -> Automation.IDispatch a -> Prelude.IO ()
changeFileOpenDirectory path =
  Automation.methodID0 0x165 [Automation.inString path]
run :: Prelude.String -> IApplication a -> Prelude.IO ()
run macroName =
  Automation.methodID0 0x166 [Automation.inString macroName]
goForward :: IApplication a -> Prelude.IO ()
goForward = Automation.methodID0 0x167 []
move :: Prelude.Int -> Prelude.Int -> Automation.IDispatch a -> Prelude.IO ()
move left top =
  Automation.methodID0 0x168 [Automation.inInt left, Automation.inInt top]
resize :: Prelude.Int -> Prelude.Int -> Automation.IDispatch a -> Prelude.IO ()
resize width height =
  Automation.methodID0 0x169 [Automation.inInt width, Automation.inInt height]
inchesToPoints :: Prelude.Float -> Automation.IDispatch a -> Prelude.IO (Prelude.Float)
inchesToPoints inches =
  Automation.functionID1 0x172 [Automation.inFloat inches] Automation.outFloat
centimetersToPoints :: Prelude.Float -> Automation.IDispatch a -> Prelude.IO (Prelude.Float)
centimetersToPoints centimeters =
  Automation.functionID1 0x173 [Automation.inFloat centimeters] Automation.outFloat
millimetersToPoints :: Prelude.Float -> Automation.IDispatch a -> Prelude.IO (Prelude.Float)
millimetersToPoints millimeters =
  Automation.functionID1 0x174 [Automation.inFloat millimeters] Automation.outFloat
picasToPoints :: Prelude.Float -> Automation.IDispatch a -> Prelude.IO (Prelude.Float)
picasToPoints picas =
  Automation.functionID1 0x175 [Automation.inFloat picas] Automation.outFloat
linesToPoints :: Prelude.Float -> Automation.IDispatch a -> Prelude.IO (Prelude.Float)
linesToPoints lines =
  Automation.functionID1 0x176 [Automation.inFloat lines] Automation.outFloat
pointsToInches :: Prelude.Float -> Automation.IDispatch a -> Prelude.IO (Prelude.Float)
pointsToInches points =
  Automation.functionID1 0x17c [Automation.inFloat points] Automation.outFloat
pointsToCentimeters :: Prelude.Float -> Automation.IDispatch a -> Prelude.IO (Prelude.Float)
pointsToCentimeters points =
  Automation.functionID1 0x17d [Automation.inFloat points] Automation.outFloat
pointsToMillimeters :: Prelude.Float -> Automation.IDispatch a -> Prelude.IO (Prelude.Float)
pointsToMillimeters points =
  Automation.functionID1 0x17e [Automation.inFloat points] Automation.outFloat
pointsToPicas :: Prelude.Float -> Automation.IDispatch a -> Prelude.IO (Prelude.Float)
pointsToPicas points =
  Automation.functionID1 0x17f [Automation.inFloat points] Automation.outFloat
pointsToLines :: Prelude.Float -> Automation.IDispatch a -> Prelude.IO (Prelude.Float)
pointsToLines points =
  Automation.functionID1 0x180 [Automation.inFloat points] Automation.outFloat
activate :: Automation.IDispatch a -> Prelude.IO ()
activate = Automation.methodID0 0x181 []
-- --------------------------------------------------
-- 
-- interface Global
-- 
-- --------------------------------------------------
data Global a = Global
                 
type IGlobal a = Automation.IDispatch (Global a)
iidIGlobal :: Com.IID (IGlobal Automation.Interface)
iidIGlobal = Com.mkIID "{000209B9-0000-0000-C000-000000000046}"
getApplication0 :: Automation.IDispatch a -> Prelude.IO (VBIDE.IApplication Automation.Interface)
getApplication0 =
  Automation.propertyGetID 0x3e8 [] Automation.outIDispatch
-- --------------------------------------------------
-- 
-- interface FontNames
-- 
-- --------------------------------------------------
data FontNames a = FontNames
                    
type IFontNames a = Automation.IDispatch (FontNames a)
iidIFontNames :: Com.IID (IFontNames Automation.Interface)
iidIFontNames = Com.mkIID "{0002096F-0000-0000-C000-000000000046}"
getNewEnum :: Automation.IDispatch a -> Prelude.IO (Com.IUnknown Automation.Interface)
getNewEnum =
  Automation.propertyGetID 0xfffffffc [] Automation.outIUnknown
getCount :: Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getCount = Automation.propertyGetID 0x2 [] Automation.outInt
item :: Prelude.Int -> IFontNames a -> Prelude.IO (Prelude.String)
item idex =
  Automation.functionID1 0o0 [Automation.inInt idex] Automation.outString
-- --------------------------------------------------
-- 
-- interface Languages
-- 
-- --------------------------------------------------
data Languages a = Languages
                    
type ILanguages a = Automation.IDispatch (Languages a)
iidILanguages :: Com.IID (ILanguages Automation.Interface)
iidILanguages = Com.mkIID "{0002096E-0000-0000-C000-000000000046}"
item0 :: Prelude.Int -> ILanguages a -> Prelude.IO (ILanguage Automation.Interface)
item0 idex =
  Automation.functionID1 0o0 [Automation.inInt idex] Automation.outIDispatch
-- --------------------------------------------------
-- 
-- interface Language
-- 
-- --------------------------------------------------
data Language a = Language
                   
type ILanguage a = Automation.IDispatch (Language a)
iidILanguage :: Com.IID (ILanguage Automation.Interface)
iidILanguage = Com.mkIID "{0002096D-0000-0000-C000-000000000046}"
getID :: (Automation.Variant a0) => ILanguage a -> Prelude.IO (a0)
getID = Automation.propertyGetID 0xa [] Automation.outVariant
getNameLocal :: Automation.IDispatch a -> Prelude.IO (Prelude.String)
getNameLocal = Automation.propertyGetID 0o0 [] Automation.outString
getActiveGrammarDictionary :: ILanguage a -> Prelude.IO (IDictionary Automation.Interface)
getActiveGrammarDictionary =
  Automation.propertyGetID 0xd [] Automation.outIDispatch
getActiveHyphenationDictionary :: ILanguage a -> Prelude.IO (IDictionary Automation.Interface)
getActiveHyphenationDictionary =
  Automation.propertyGetID 0xe [] Automation.outIDispatch
getActiveSpellingDictionary :: ILanguage a -> Prelude.IO (IDictionary Automation.Interface)
getActiveSpellingDictionary =
  Automation.propertyGetID 0xf [] Automation.outIDispatch
getActiveThesaurusDictionary :: ILanguage a -> Prelude.IO (IDictionary Automation.Interface)
getActiveThesaurusDictionary =
  Automation.propertyGetID 0x10 [] Automation.outIDispatch
getDefaultWritingStyle :: ILanguage a -> Prelude.IO (Prelude.String)
getDefaultWritingStyle =
  Automation.propertyGetID 0x11 [] Automation.outString
setDefaultWritingStyle :: Prelude.String -> ILanguage a -> Prelude.IO ()
setDefaultWritingStyle prop =
  Automation.propertySetID 0x11 [Automation.inString prop]
getWritingStyleList :: ILanguage a -> Prelude.IO (Prelude.Int)
getWritingStyleList =
  Automation.propertyGetID 0x12 [] Automation.outInt
getSpellingDictionaryType :: (Automation.Variant a0) => ILanguage a -> Prelude.IO (a0)
getSpellingDictionaryType =
  Automation.propertyGetID 0x13 [] Automation.outVariant
setSpellingDictionaryType :: (Automation.Variant a0) => a0 -> ILanguage a -> Prelude.IO ()
setSpellingDictionaryType prop =
  Automation.propertySetID 0x13 [Automation.inVariant prop]
-- --------------------------------------------------
-- 
-- interface Documents
-- 
-- --------------------------------------------------
data Documents a = Documents
                    
type IDocuments a = Automation.IDispatch (Documents a)
iidIDocuments :: Com.IID (IDocuments Automation.Interface)
iidIDocuments = Com.mkIID "{0002096C-0000-0000-C000-000000000046}"
item1 :: Prelude.Int -> IDocuments a -> Prelude.IO (IDocument Automation.Interface)
item1 idex =
  Automation.functionID1 0o0 [Automation.inInt idex] Automation.outIDispatch
close :: Prelude.Int -> Prelude.Int -> Prelude.Int -> Automation.IDispatch a -> Prelude.IO ()
close saveChanges originalFormat routeDocument =
  Automation.methodID0 0x451 [Automation.inInt saveChanges, Automation.inInt originalFormat, Automation.inInt routeDocument]
add :: Prelude.Int -> Prelude.Int -> IDocuments a -> Prelude.IO (IDocument Automation.Interface)
add template newTemplate =
  Automation.functionID1 0xb [Automation.inInt template, Automation.inInt newTemplate] Automation.outIDispatch
open :: Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> IDocuments a -> Prelude.IO (IDocument Automation.Interface)
open fileName confirmConversions readOnly addToRecentFiles passwordDocument passwordTemplate revert writePasswordDocument writePasswordTemplate format =
  Automation.functionID1 0xc [Automation.inInt fileName, Automation.inInt confirmConversions, Automation.inInt readOnly, Automation.inInt addToRecentFiles, Automation.inInt passwordDocument, Automation.inInt passwordTemplate, Automation.inInt revert, Automation.inInt writePasswordDocument, Automation.inInt writePasswordTemplate, Automation.inInt format] Automation.outIDispatch
save :: Prelude.Int -> Prelude.Int -> IDocuments a -> Prelude.IO ()
save noPrompt originalFormat =
  Automation.methodID0 0xd [Automation.inInt noPrompt, Automation.inInt originalFormat]
-- --------------------------------------------------
-- 
-- interface Document
-- 
-- --------------------------------------------------
data Document a = Document
                   
type IDocument a = Automation.IDispatch (Document a)
iidIDocument :: Com.IID (IDocument Automation.Interface)
iidIDocument = Com.mkIID "{0002096B-0000-0000-C000-000000000046}"
getBuiltInDocumentProperties :: Automation.IDispatch a -> Prelude.IO (Automation.IDispatch Automation.Interface)
getBuiltInDocumentProperties =
  Automation.propertyGetID 0x3e8 [] Automation.outIDispatch
getCustomDocumentProperties :: Automation.IDispatch a -> Prelude.IO (Automation.IDispatch Automation.Interface)
getCustomDocumentProperties =
  Automation.propertyGetID 0x2 [] Automation.outIDispatch
getBookmarks :: Automation.IDispatch a -> Prelude.IO (IBookmarks Automation.Interface)
getBookmarks =
  Automation.propertyGetID 0x4 [] Automation.outIDispatch
getTables :: Automation.IDispatch a -> Prelude.IO (ITables Automation.Interface)
getTables = Automation.propertyGetID 0x6 [] Automation.outIDispatch
getFootnotes :: Automation.IDispatch a -> Prelude.IO (IFootnotes Automation.Interface)
getFootnotes =
  Automation.propertyGetID 0x7 [] Automation.outIDispatch
getEndnotes :: Automation.IDispatch a -> Prelude.IO (IEndnotes Automation.Interface)
getEndnotes =
  Automation.propertyGetID 0x8 [] Automation.outIDispatch
getComments :: Automation.IDispatch a -> Prelude.IO (IComments Automation.Interface)
getComments =
  Automation.propertyGetID 0x9 [] Automation.outIDispatch
getType :: (Automation.Variant a0) => IDocument a -> Prelude.IO (a0)
getType = Automation.propertyGetID 0xa [] Automation.outVariant
getAutoHyphenation :: IDocument a -> Prelude.IO (Prelude.Int)
getAutoHyphenation =
  Automation.propertyGetID 0xb [] Automation.outInt
setAutoHyphenation :: Prelude.Int -> IDocument a -> Prelude.IO ()
setAutoHyphenation prop =
  Automation.propertySetID 0xb [Automation.inInt prop]
getHyphenateCaps :: IDocument a -> Prelude.IO (Prelude.Int)
getHyphenateCaps =
  Automation.propertyGetID 0xc [] Automation.outInt
setHyphenateCaps :: Prelude.Int -> IDocument a -> Prelude.IO ()
setHyphenateCaps prop =
  Automation.propertySetID 0xc [Automation.inInt prop]
getHyphenationZone :: IDocument a -> Prelude.IO (Prelude.Int)
getHyphenationZone =
  Automation.propertyGetID 0xd [] Automation.outInt
setHyphenationZone :: Prelude.Int -> IDocument a -> Prelude.IO ()
setHyphenationZone prop =
  Automation.propertySetID 0xd [Automation.inInt prop]
getConsecutiveHyphensLimit :: IDocument a -> Prelude.IO (Prelude.Int)
getConsecutiveHyphensLimit =
  Automation.propertyGetID 0xe [] Automation.outInt
setConsecutiveHyphensLimit :: Prelude.Int -> IDocument a -> Prelude.IO ()
setConsecutiveHyphensLimit prop =
  Automation.propertySetID 0xe [Automation.inInt prop]
getSections :: Automation.IDispatch a -> Prelude.IO (ISections Automation.Interface)
getSections =
  Automation.propertyGetID 0xf [] Automation.outIDispatch
getParagraphs :: Automation.IDispatch a -> Prelude.IO (IParagraphs Automation.Interface)
getParagraphs =
  Automation.propertyGetID 0x10 [] Automation.outIDispatch
getWords :: Automation.IDispatch a -> Prelude.IO (IWords Automation.Interface)
getWords = Automation.propertyGetID 0x11 [] Automation.outIDispatch
getSentences :: Automation.IDispatch a -> Prelude.IO (ISentences Automation.Interface)
getSentences =
  Automation.propertyGetID 0x12 [] Automation.outIDispatch
getCharacters :: Automation.IDispatch a -> Prelude.IO (ICharacters Automation.Interface)
getCharacters =
  Automation.propertyGetID 0x13 [] Automation.outIDispatch
getFields :: Automation.IDispatch a -> Prelude.IO (IFields Automation.Interface)
getFields =
  Automation.propertyGetID 0x14 [] Automation.outIDispatch
getFormFields :: Automation.IDispatch a -> Prelude.IO (IFormFields Automation.Interface)
getFormFields =
  Automation.propertyGetID 0x15 [] Automation.outIDispatch
getStyles :: IDocument a -> Prelude.IO (IStyles Automation.Interface)
getStyles =
  Automation.propertyGetID 0x16 [] Automation.outIDispatch
getFrames :: Automation.IDispatch a -> Prelude.IO (IFrames Automation.Interface)
getFrames =
  Automation.propertyGetID 0x17 [] Automation.outIDispatch
getTablesOfFigures :: IDocument a -> Prelude.IO (ITablesOfFigures Automation.Interface)
getTablesOfFigures =
  Automation.propertyGetID 0x19 [] Automation.outIDispatch
getVariables :: IDocument a -> Prelude.IO (IVariables Automation.Interface)
getVariables =
  Automation.propertyGetID 0x1a [] Automation.outIDispatch
getMailMerge :: IDocument a -> Prelude.IO (IMailMerge Automation.Interface)
getMailMerge =
  Automation.propertyGetID 0x1b [] Automation.outIDispatch
getEnvelope :: IDocument a -> Prelude.IO (IEnvelope Automation.Interface)
getEnvelope =
  Automation.propertyGetID 0x1c [] Automation.outIDispatch
getFullName :: Automation.IDispatch a -> Prelude.IO (Prelude.String)
getFullName = Automation.propertyGetID 0x1d [] Automation.outString
getRevisions :: Automation.IDispatch a -> Prelude.IO (IRevisions Automation.Interface)
getRevisions =
  Automation.propertyGetID 0x1e [] Automation.outIDispatch
getTablesOfContents :: IDocument a -> Prelude.IO (ITablesOfContents Automation.Interface)
getTablesOfContents =
  Automation.propertyGetID 0x1f [] Automation.outIDispatch
getTablesOfAuthorities :: IDocument a -> Prelude.IO (ITablesOfAuthorities Automation.Interface)
getTablesOfAuthorities =
  Automation.propertyGetID 0x20 [] Automation.outIDispatch
getPageSetup :: Automation.IDispatch a -> Prelude.IO (IPageSetup Automation.Interface)
getPageSetup =
  Automation.propertyGetID 0x44d [] Automation.outIDispatch
setPageSetup :: IPageSetup a0 -> Automation.IDispatch a -> Prelude.IO ()
setPageSetup prop =
  Automation.propertySetID 0x44d [Automation.inIDispatch prop]
getHasRoutingSlip :: IDocument a -> Prelude.IO (Prelude.Int)
getHasRoutingSlip =
  Automation.propertyGetID 0x23 [] Automation.outInt
setHasRoutingSlip :: Prelude.Int -> IDocument a -> Prelude.IO ()
setHasRoutingSlip prop =
  Automation.propertySetID 0x23 [Automation.inInt prop]
getRoutingSlip :: IDocument a -> Prelude.IO (IRoutingSlip Automation.Interface)
getRoutingSlip =
  Automation.propertyGetID 0x24 [] Automation.outIDispatch
getRouted :: IDocument a -> Prelude.IO (Prelude.Int)
getRouted = Automation.propertyGetID 0x25 [] Automation.outInt
getTablesOfAuthoritiesCategories :: IDocument a -> Prelude.IO (ITablesOfAuthoritiesCategories Automation.Interface)
getTablesOfAuthoritiesCategories =
  Automation.propertyGetID 0x26 [] Automation.outIDispatch
getIndexes :: IDocument a -> Prelude.IO (Indexes Automation.Interface)
getIndexes =
  Automation.propertyGetID 0x27 [] Automation.outIDispatch
getSaved :: Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getSaved = Automation.propertyGetID 0x28 [] Automation.outInt
setSaved :: Prelude.Int -> Automation.IDispatch a -> Prelude.IO ()
setSaved prop =
  Automation.propertySetID 0x28 [Automation.inInt prop]
getContent :: IDocument a -> Prelude.IO (IRange Automation.Interface)
getContent =
  Automation.propertyGetID 0x29 [] Automation.outIDispatch
getKind :: (Automation.Variant a0) => IDocument a -> Prelude.IO (a0)
getKind = Automation.propertyGetID 0x2b [] Automation.outVariant
setKind :: (Automation.Variant a0) => a0 -> IDocument a -> Prelude.IO ()
setKind prop =
  Automation.propertySetID 0x2b [Automation.inVariant prop]
getReadOnly :: Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getReadOnly = Automation.propertyGetID 0x2c [] Automation.outInt
getSubdocuments :: Automation.IDispatch a -> Prelude.IO (ISubdocuments Automation.Interface)
getSubdocuments =
  Automation.propertyGetID 0x2d [] Automation.outIDispatch
getIsMasterDocument :: IDocument a -> Prelude.IO (Prelude.Int)
getIsMasterDocument =
  Automation.propertyGetID 0x2e [] Automation.outInt
getDefaultTabStop :: IDocument a -> Prelude.IO (Prelude.Float)
getDefaultTabStop =
  Automation.propertyGetID 0x30 [] Automation.outFloat
setDefaultTabStop :: Prelude.Float -> IDocument a -> Prelude.IO ()
setDefaultTabStop prop =
  Automation.propertySetID 0x30 [Automation.inFloat prop]
getEmbedTrueTypeFonts :: IDocument a -> Prelude.IO (Prelude.Int)
getEmbedTrueTypeFonts =
  Automation.propertyGetID 0x32 [] Automation.outInt
setEmbedTrueTypeFonts :: Prelude.Int -> IDocument a -> Prelude.IO ()
setEmbedTrueTypeFonts prop =
  Automation.propertySetID 0x32 [Automation.inInt prop]
getSaveFormsData :: IDocument a -> Prelude.IO (Prelude.Int)
getSaveFormsData =
  Automation.propertyGetID 0x33 [] Automation.outInt
setSaveFormsData :: Prelude.Int -> IDocument a -> Prelude.IO ()
setSaveFormsData prop =
  Automation.propertySetID 0x33 [Automation.inInt prop]
getReadOnlyRecommended :: IDocument a -> Prelude.IO (Prelude.Int)
getReadOnlyRecommended =
  Automation.propertyGetID 0x34 [] Automation.outInt
setReadOnlyRecommended :: Prelude.Int -> IDocument a -> Prelude.IO ()
setReadOnlyRecommended prop =
  Automation.propertySetID 0x34 [Automation.inInt prop]
getSaveSubsetFonts :: IDocument a -> Prelude.IO (Prelude.Int)
getSaveSubsetFonts =
  Automation.propertyGetID 0x35 [] Automation.outInt
setSaveSubsetFonts :: Prelude.Int -> IDocument a -> Prelude.IO ()
setSaveSubsetFonts prop =
  Automation.propertySetID 0x35 [Automation.inInt prop]
getCompatibility :: (Automation.Variant a0) => a0 -> IDocument a -> Prelude.IO (Prelude.Int)
getCompatibility type0 =
  Automation.propertyGetID 0x37 [Automation.inVariant type0] Automation.outInt
setCompatibility :: (Automation.Variant a0) => a0 -> Prelude.Int -> IDocument a -> Prelude.IO ()
setCompatibility type0 prop =
  Automation.propertySetID 0x37 [Automation.inVariant type0, Automation.inInt prop]
getStoryRanges :: IDocument a -> Prelude.IO (IStoryRanges Automation.Interface)
getStoryRanges =
  Automation.propertyGetID 0x38 [] Automation.outIDispatch
getIsSubdocument :: IDocument a -> Prelude.IO (Prelude.Int)
getIsSubdocument =
  Automation.propertyGetID 0x3a [] Automation.outInt
getSaveFormat :: Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getSaveFormat = Automation.propertyGetID 0x3b [] Automation.outInt
getProtectionType :: (Automation.Variant a0) => IDocument a -> Prelude.IO (a0)
getProtectionType =
  Automation.propertyGetID 0x3c [] Automation.outVariant
getHyperlinks :: Automation.IDispatch a -> Prelude.IO (IHyperlinks Automation.Interface)
getHyperlinks =
  Automation.propertyGetID 0x3d [] Automation.outIDispatch
getShapes :: Automation.IDispatch a -> Prelude.IO (Office.IShapes Automation.Interface)
getShapes =
  Automation.propertyGetID 0x3e [] Automation.outIDispatch
getListTemplates :: Automation.IDispatch a -> Prelude.IO (IListTemplates Automation.Interface)
getListTemplates =
  Automation.propertyGetID 0x3f [] Automation.outIDispatch
getLists :: IDocument a -> Prelude.IO (ILists Automation.Interface)
getLists = Automation.propertyGetID 0x40 [] Automation.outIDispatch
getUpdateStylesOnOpen :: IDocument a -> Prelude.IO (Prelude.Int)
getUpdateStylesOnOpen =
  Automation.propertyGetID 0x42 [] Automation.outInt
setUpdateStylesOnOpen :: Prelude.Int -> IDocument a -> Prelude.IO ()
setUpdateStylesOnOpen prop =
  Automation.propertySetID 0x42 [Automation.inInt prop]
getAttachedTemplate :: IDocument a -> Prelude.IO (Prelude.Int)
getAttachedTemplate =
  Automation.propertyGetID 0x43 [] Automation.outInt
setAttachedTemplate :: Prelude.Int -> IDocument a -> Prelude.IO ()
setAttachedTemplate prop =
  Automation.propertySetID 0x43 [Automation.inInt prop]
getInlineShapes :: Automation.IDispatch a -> Prelude.IO (InlineShapes Automation.Interface)
getInlineShapes =
  Automation.propertyGetID 0x44 [] Automation.outIDispatch
getBackground :: IDocument a -> Prelude.IO (Office.IShape Automation.Interface)
getBackground =
  Automation.propertyGetID 0x45 [] Automation.outIDispatch
setBackground :: Office.IShape a0 -> IDocument a -> Prelude.IO ()
setBackground prop =
  Automation.propertySetID 0x45 [Automation.inIDispatch prop]
getGrammarChecked :: Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getGrammarChecked =
  Automation.propertyGetID 0x46 [] Automation.outInt
setGrammarChecked :: Prelude.Int -> Automation.IDispatch a -> Prelude.IO ()
setGrammarChecked prop =
  Automation.propertySetID 0x46 [Automation.inInt prop]
getSpellingChecked :: Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getSpellingChecked =
  Automation.propertyGetID 0x47 [] Automation.outInt
setSpellingChecked :: Prelude.Int -> Automation.IDispatch a -> Prelude.IO ()
setSpellingChecked prop =
  Automation.propertySetID 0x47 [Automation.inInt prop]
getShowGrammaticalErrors :: IDocument a -> Prelude.IO (Prelude.Int)
getShowGrammaticalErrors =
  Automation.propertyGetID 0x48 [] Automation.outInt
setShowGrammaticalErrors :: Prelude.Int -> IDocument a -> Prelude.IO ()
setShowGrammaticalErrors prop =
  Automation.propertySetID 0x48 [Automation.inInt prop]
getShowSpellingErrors :: IDocument a -> Prelude.IO (Prelude.Int)
getShowSpellingErrors =
  Automation.propertyGetID 0x49 [] Automation.outInt
setShowSpellingErrors :: Prelude.Int -> IDocument a -> Prelude.IO ()
setShowSpellingErrors prop =
  Automation.propertySetID 0x49 [Automation.inInt prop]
getVersions :: IDocument a -> Prelude.IO (IVersions Automation.Interface)
getVersions =
  Automation.propertyGetID 0x4b [] Automation.outIDispatch
getShowSummary :: IDocument a -> Prelude.IO (Prelude.Int)
getShowSummary = Automation.propertyGetID 0x4c [] Automation.outInt
setShowSummary :: Prelude.Int -> IDocument a -> Prelude.IO ()
setShowSummary prop =
  Automation.propertySetID 0x4c [Automation.inInt prop]
getSummaryViewMode :: (Automation.Variant a0) => IDocument a -> Prelude.IO (a0)
getSummaryViewMode =
  Automation.propertyGetID 0x4d [] Automation.outVariant
setSummaryViewMode :: (Automation.Variant a0) => a0 -> IDocument a -> Prelude.IO ()
setSummaryViewMode prop =
  Automation.propertySetID 0x4d [Automation.inVariant prop]
getSummaryLength :: IDocument a -> Prelude.IO (Prelude.Int)
getSummaryLength =
  Automation.propertyGetID 0x4e [] Automation.outInt
setSummaryLength :: Prelude.Int -> IDocument a -> Prelude.IO ()
setSummaryLength prop =
  Automation.propertySetID 0x4e [Automation.inInt prop]
getPrintFractionalWidths :: IDocument a -> Prelude.IO (Prelude.Int)
getPrintFractionalWidths =
  Automation.propertyGetID 0x4f [] Automation.outInt
setPrintFractionalWidths :: Prelude.Int -> IDocument a -> Prelude.IO ()
setPrintFractionalWidths prop =
  Automation.propertySetID 0x4f [Automation.inInt prop]
getPrintPostScriptOverText :: IDocument a -> Prelude.IO (Prelude.Int)
getPrintPostScriptOverText =
  Automation.propertyGetID 0x50 [] Automation.outInt
setPrintPostScriptOverText :: Prelude.Int -> IDocument a -> Prelude.IO ()
setPrintPostScriptOverText prop =
  Automation.propertySetID 0x50 [Automation.inInt prop]
getContainer :: IDocument a -> Prelude.IO (Automation.IDispatch Automation.Interface)
getContainer =
  Automation.propertyGetID 0x52 [] Automation.outIDispatch
getPrintFormsData :: IDocument a -> Prelude.IO (Prelude.Int)
getPrintFormsData =
  Automation.propertyGetID 0x53 [] Automation.outInt
setPrintFormsData :: Prelude.Int -> IDocument a -> Prelude.IO ()
setPrintFormsData prop =
  Automation.propertySetID 0x53 [Automation.inInt prop]
getListParagraphs :: Automation.IDispatch a -> Prelude.IO (IListParagraphs Automation.Interface)
getListParagraphs =
  Automation.propertyGetID 0x54 [] Automation.outIDispatch
setPassword :: Prelude.String -> IDocument a -> Prelude.IO ()
setPassword rhs =
  Automation.propertySetID 0x55 [Automation.inString rhs]
setWritePassword :: Prelude.String -> IDocument a -> Prelude.IO ()
setWritePassword rhs =
  Automation.propertySetID 0x56 [Automation.inString rhs]
getHasPassword :: IDocument a -> Prelude.IO (Prelude.Int)
getHasPassword = Automation.propertyGetID 0x57 [] Automation.outInt
getWriteReserved :: IDocument a -> Prelude.IO (Prelude.Int)
getWriteReserved =
  Automation.propertyGetID 0x58 [] Automation.outInt
getActiveWritingStyle :: Prelude.Int -> IDocument a -> Prelude.IO (Prelude.String)
getActiveWritingStyle languageID =
  Automation.propertyGetID 0x5a [Automation.inInt languageID] Automation.outString
setActiveWritingStyle :: Prelude.Int -> Prelude.String -> IDocument a -> Prelude.IO ()
setActiveWritingStyle languageID prop =
  Automation.propertySetID 0x5a [Automation.inInt languageID, Automation.inString prop]
setUserControl :: Prelude.Int -> IDocument a -> Prelude.IO ()
setUserControl prop =
  Automation.propertySetID 0x5c [Automation.inInt prop]
getHasMailer :: IDocument a -> Prelude.IO (Prelude.Int)
getHasMailer = Automation.propertyGetID 0x5d [] Automation.outInt
setHasMailer :: Prelude.Int -> IDocument a -> Prelude.IO ()
setHasMailer prop =
  Automation.propertySetID 0x5d [Automation.inInt prop]
getMailer :: IDocument a -> Prelude.IO (IMailer Automation.Interface)
getMailer =
  Automation.propertyGetID 0x5e [] Automation.outIDispatch
getReadabilityStatistics :: Automation.IDispatch a -> Prelude.IO (IReadabilityStatistics Automation.Interface)
getReadabilityStatistics =
  Automation.propertyGetID 0x60 [] Automation.outIDispatch
getGrammaticalErrors :: Automation.IDispatch a -> Prelude.IO (IProofreadingErrors Automation.Interface)
getGrammaticalErrors =
  Automation.propertyGetID 0x61 [] Automation.outIDispatch
getSpellingErrors :: Automation.IDispatch a -> Prelude.IO (IProofreadingErrors Automation.Interface)
getSpellingErrors =
  Automation.propertyGetID 0x62 [] Automation.outIDispatch
getVBProject :: Automation.IDispatch a -> Prelude.IO (VBIDE.IVBProject Automation.Interface)
getVBProject =
  Automation.propertyGetID 0x63 [] Automation.outIDispatch
getFormsDesign :: IDocument a -> Prelude.IO (Prelude.Int)
getFormsDesign = Automation.propertyGetID 0x64 [] Automation.outInt
getCodeName :: IDocument a -> Prelude.IO (Prelude.String)
getCodeName =
  Automation.propertyGetID 0x80010000 [] Automation.outString
setCodeName :: Prelude.String -> IDocument a -> Prelude.IO ()
setCodeName prop =
  Automation.propertySetID 0x80010000 [Automation.inString prop]
getCodeName0 :: IDocument a -> Prelude.IO (Prelude.String)
getCodeName0 =
  Automation.propertyGetID 0x106 [] Automation.outString
getSnapToGrid :: Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getSnapToGrid = Automation.propertyGetID 0x12c [] Automation.outInt
setSnapToGrid :: Prelude.Int -> Automation.IDispatch a -> Prelude.IO ()
setSnapToGrid prop =
  Automation.propertySetID 0x12c [Automation.inInt prop]
getSnapToShapes :: Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getSnapToShapes =
  Automation.propertyGetID 0x12d [] Automation.outInt
setSnapToShapes :: Prelude.Int -> Automation.IDispatch a -> Prelude.IO ()
setSnapToShapes prop =
  Automation.propertySetID 0x12d [Automation.inInt prop]
getGridDistanceHorizontal :: Automation.IDispatch a -> Prelude.IO (Prelude.Float)
getGridDistanceHorizontal =
  Automation.propertyGetID 0x12e [] Automation.outFloat
setGridDistanceHorizontal :: Prelude.Float -> Automation.IDispatch a -> Prelude.IO ()
setGridDistanceHorizontal prop =
  Automation.propertySetID 0x12e [Automation.inFloat prop]
getGridDistanceVertical :: Automation.IDispatch a -> Prelude.IO (Prelude.Float)
getGridDistanceVertical =
  Automation.propertyGetID 0x12f [] Automation.outFloat
setGridDistanceVertical :: Prelude.Float -> Automation.IDispatch a -> Prelude.IO ()
setGridDistanceVertical prop =
  Automation.propertySetID 0x12f [Automation.inFloat prop]
getGridOriginHorizontal :: Automation.IDispatch a -> Prelude.IO (Prelude.Float)
getGridOriginHorizontal =
  Automation.propertyGetID 0x130 [] Automation.outFloat
setGridOriginHorizontal :: Prelude.Float -> Automation.IDispatch a -> Prelude.IO ()
setGridOriginHorizontal prop =
  Automation.propertySetID 0x130 [Automation.inFloat prop]
getGridOriginVertical :: Automation.IDispatch a -> Prelude.IO (Prelude.Float)
getGridOriginVertical =
  Automation.propertyGetID 0x131 [] Automation.outFloat
setGridOriginVertical :: Prelude.Float -> Automation.IDispatch a -> Prelude.IO ()
setGridOriginVertical prop =
  Automation.propertySetID 0x131 [Automation.inFloat prop]
getGridSpaceBetweenHorizontalLines :: IDocument a -> Prelude.IO (Prelude.Int)
getGridSpaceBetweenHorizontalLines =
  Automation.propertyGetID 0x132 [] Automation.outInt
setGridSpaceBetweenHorizontalLines :: Prelude.Int -> IDocument a -> Prelude.IO ()
setGridSpaceBetweenHorizontalLines prop =
  Automation.propertySetID 0x132 [Automation.inInt prop]
getGridSpaceBetweenVerticalLines :: IDocument a -> Prelude.IO (Prelude.Int)
getGridSpaceBetweenVerticalLines =
  Automation.propertyGetID 0x133 [] Automation.outInt
setGridSpaceBetweenVerticalLines :: Prelude.Int -> IDocument a -> Prelude.IO ()
setGridSpaceBetweenVerticalLines prop =
  Automation.propertySetID 0x133 [Automation.inInt prop]
getGridOriginFromMargin :: IDocument a -> Prelude.IO (Prelude.Int)
getGridOriginFromMargin =
  Automation.propertyGetID 0x134 [] Automation.outInt
setGridOriginFromMargin :: Prelude.Int -> IDocument a -> Prelude.IO ()
setGridOriginFromMargin prop =
  Automation.propertySetID 0x134 [Automation.inInt prop]
getKerningByAlgorithm :: Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getKerningByAlgorithm =
  Automation.propertyGetID 0x135 [] Automation.outInt
setKerningByAlgorithm :: Prelude.Int -> Automation.IDispatch a -> Prelude.IO ()
setKerningByAlgorithm prop =
  Automation.propertySetID 0x135 [Automation.inInt prop]
getJustificationMode :: (Automation.Variant a0) => Automation.IDispatch a -> Prelude.IO (a0)
getJustificationMode =
  Automation.propertyGetID 0x136 [] Automation.outVariant
setJustificationMode :: (Automation.Variant a0) => a0 -> Automation.IDispatch a -> Prelude.IO ()
setJustificationMode prop =
  Automation.propertySetID 0x136 [Automation.inVariant prop]
getFarEastLineBreakLevel :: (Automation.Variant a0) => Automation.IDispatch a -> Prelude.IO (a0)
getFarEastLineBreakLevel =
  Automation.propertyGetID 0x137 [] Automation.outVariant
setFarEastLineBreakLevel :: (Automation.Variant a0) => a0 -> Automation.IDispatch a -> Prelude.IO ()
setFarEastLineBreakLevel prop =
  Automation.propertySetID 0x137 [Automation.inVariant prop]
getNoLineBreakBefore :: Automation.IDispatch a -> Prelude.IO (Prelude.String)
getNoLineBreakBefore =
  Automation.propertyGetID 0x138 [] Automation.outString
setNoLineBreakBefore :: Prelude.String -> Automation.IDispatch a -> Prelude.IO ()
setNoLineBreakBefore prop =
  Automation.propertySetID 0x138 [Automation.inString prop]
getNoLineBreakAfter :: Automation.IDispatch a -> Prelude.IO (Prelude.String)
getNoLineBreakAfter =
  Automation.propertyGetID 0x139 [] Automation.outString
setNoLineBreakAfter :: Prelude.String -> Automation.IDispatch a -> Prelude.IO ()
setNoLineBreakAfter prop =
  Automation.propertySetID 0x139 [Automation.inString prop]
getTrackRevisions :: IDocument a -> Prelude.IO (Prelude.Int)
getTrackRevisions =
  Automation.propertyGetID 0x13a [] Automation.outInt
setTrackRevisions :: Prelude.Int -> IDocument a -> Prelude.IO ()
setTrackRevisions prop =
  Automation.propertySetID 0x13a [Automation.inInt prop]
getPrintRevisions :: IDocument a -> Prelude.IO (Prelude.Int)
getPrintRevisions =
  Automation.propertyGetID 0x13b [] Automation.outInt
setPrintRevisions :: Prelude.Int -> IDocument a -> Prelude.IO ()
setPrintRevisions prop =
  Automation.propertySetID 0x13b [Automation.inInt prop]
getShowRevisions :: IDocument a -> Prelude.IO (Prelude.Int)
getShowRevisions =
  Automation.propertyGetID 0x13c [] Automation.outInt
setShowRevisions :: Prelude.Int -> IDocument a -> Prelude.IO ()
setShowRevisions prop =
  Automation.propertySetID 0x13c [Automation.inInt prop]
saveAs :: Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> IDocument a -> Prelude.IO ()
saveAs fileName fileFormat lockComments password addToRecentFiles writePassword readOnlyRecommended embedTrueTypeFonts saveNativePictureFormat saveFormsData saveAsAOCELetter =
  Automation.methodID0 0x66 [Automation.inInt fileName, Automation.inInt fileFormat, Automation.inInt lockComments, Automation.inInt password, Automation.inInt addToRecentFiles, Automation.inInt writePassword, Automation.inInt readOnlyRecommended, Automation.inInt embedTrueTypeFonts, Automation.inInt saveNativePictureFormat, Automation.inInt saveFormsData, Automation.inInt saveAsAOCELetter]
repaginate :: IDocument a -> Prelude.IO ()
repaginate = Automation.methodID0 0x67 []
fitToPages :: IDocument a -> Prelude.IO ()
fitToPages = Automation.methodID0 0x68 []
manualHyphenation :: IDocument a -> Prelude.IO ()
manualHyphenation = Automation.methodID0 0x69 []
select :: Automation.IDispatch a -> Prelude.IO ()
select = Automation.methodID0 0xffff []
dataForm :: IDocument a -> Prelude.IO ()
dataForm = Automation.methodID0 0x6a []
route :: IDocument a -> Prelude.IO ()
route = Automation.methodID0 0x6b []
save0 :: Automation.IDispatch a -> Prelude.IO ()
save0 = Automation.methodID0 0x6c []
printOut0 :: Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Automation.IDispatch a -> Prelude.IO ()
printOut0 background append range outputFileName from to item copies pages pageType printToFile collate activePrinterMacGX manualDuplexPrint =
  Automation.methodID0 0x6d [Automation.inInt background, Automation.inInt append, Automation.inInt range, Automation.inInt outputFileName, Automation.inInt from, Automation.inInt to, Automation.inInt item, Automation.inInt copies, Automation.inInt pages, Automation.inInt pageType, Automation.inInt printToFile, Automation.inInt collate, Automation.inInt activePrinterMacGX, Automation.inInt manualDuplexPrint]
sendMail :: IDocument a -> Prelude.IO ()
sendMail = Automation.methodID0 0x6e []
range :: Prelude.Int -> Prelude.Int -> IDocument a -> Prelude.IO (IRange Automation.Interface)
range start end =
  Automation.functionID1 0x7d0 [Automation.inInt start, Automation.inInt end] Automation.outIDispatch
runAutoMacro :: (Automation.Variant a0) => a0 -> IDocument a -> Prelude.IO ()
runAutoMacro which =
  Automation.methodID0 0x70 [Automation.inVariant which]
printPreview :: Automation.IDispatch a -> Prelude.IO ()
printPreview = Automation.methodID0 0x72 []
goTo :: Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Automation.IDispatch a -> Prelude.IO (IRange Automation.Interface)
goTo what which count name =
  Automation.functionID1 0x73 [Automation.inInt what, Automation.inInt which, Automation.inInt count, Automation.inInt name] Automation.outIDispatch
undo :: Prelude.Int -> IDocument a -> Prelude.IO (Prelude.Int)
undo times =
  Automation.functionID1 0x74 [Automation.inInt times] Automation.outInt
redo :: Prelude.Int -> IDocument a -> Prelude.IO (Prelude.Int)
redo times =
  Automation.functionID1 0x75 [Automation.inInt times] Automation.outInt
computeStatistics :: (Automation.Variant a0) => a0 -> Prelude.Int -> IDocument a -> Prelude.IO (Prelude.Int)
computeStatistics statistic includeFootnotesAndEndnotes =
  Automation.functionID1 0x76 [Automation.inVariant statistic, Automation.inInt includeFootnotesAndEndnotes] Automation.outInt
makeCompatibilityDefault :: IDocument a -> Prelude.IO ()
makeCompatibilityDefault = Automation.methodID0 0x77 []
protect :: (Automation.Variant a0) => a0 -> Prelude.Int -> Prelude.Int -> IDocument a -> Prelude.IO ()
protect type0 noReset password =
  Automation.methodID0 0x78 [Automation.inVariant type0, Automation.inInt noReset, Automation.inInt password]
unprotect :: Prelude.Int -> IDocument a -> Prelude.IO ()
unprotect password =
  Automation.methodID0 0x79 [Automation.inInt password]
editionOptions :: (Automation.Variant a0, Automation.Variant a1) => a0 -> a1 -> Prelude.String -> Prelude.Int -> IDocument a -> Prelude.IO ()
editionOptions type0 option name format =
  Automation.methodID0 0x7a [Automation.inVariant type0, Automation.inVariant option, Automation.inString name, Automation.inInt format]
runLetterWizard :: Prelude.Int -> Prelude.Int -> IDocument a -> Prelude.IO ()
runLetterWizard letterContent wizardMode =
  Automation.methodID0 0x7b [Automation.inInt letterContent, Automation.inInt wizardMode]
getLetterContent :: IDocument a -> Prelude.IO (ILetterContent Automation.Interface)
getLetterContent =
  Automation.functionID1 0x7c [] Automation.outIDispatch
setLetterContent :: Prelude.Int -> IDocument a -> Prelude.IO ()
setLetterContent letterContent =
  Automation.methodID0 0x7d [Automation.inInt letterContent]
copyStylesFromTemplate :: Prelude.String -> IDocument a -> Prelude.IO ()
copyStylesFromTemplate template =
  Automation.methodID0 0x7e [Automation.inString template]
updateStyles :: IDocument a -> Prelude.IO ()
updateStyles = Automation.methodID0 0x7f []
checkGrammar0 :: Automation.IDispatch a -> Prelude.IO ()
checkGrammar0 = Automation.methodID0 0x83 []
checkSpelling1 :: Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Automation.IDispatch a -> Prelude.IO ()
checkSpelling1 customDictionary ignoreUppercase alwaysSuggest customDictionary2 customDictionary3 customDictionary4 customDictionary5 customDictionary6 customDictionary7 customDictionary8 customDictionary9 customDictionary10 =
  Automation.methodID0 0x84 [Automation.inInt customDictionary, Automation.inInt ignoreUppercase, Automation.inInt alwaysSuggest, Automation.inInt customDictionary2, Automation.inInt customDictionary3, Automation.inInt customDictionary4, Automation.inInt customDictionary5, Automation.inInt customDictionary6, Automation.inInt customDictionary7, Automation.inInt customDictionary8, Automation.inInt customDictionary9, Automation.inInt customDictionary10]
followHyperlink :: Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> IDocument a -> Prelude.IO ()
followHyperlink address subAddress newWindow addHistory extraInfo method headerInfo =
  Automation.methodID0 0x87 [Automation.inInt address, Automation.inInt subAddress, Automation.inInt newWindow, Automation.inInt addHistory, Automation.inInt extraInfo, Automation.inInt method, Automation.inInt headerInfo]
addToFavorites :: Automation.IDispatch a -> Prelude.IO ()
addToFavorites = Automation.methodID0 0x88 []
reload :: IDocument a -> Prelude.IO ()
reload = Automation.methodID0 0x89 []
autoSummarize :: Prelude.Int -> Prelude.Int -> Prelude.Int -> IDocument a -> Prelude.IO (IRange Automation.Interface)
autoSummarize length mode updateProperties =
  Automation.functionID1 0x8a [Automation.inInt length, Automation.inInt mode, Automation.inInt updateProperties] Automation.outIDispatch
removeNumbers :: Prelude.Int -> Automation.IDispatch a -> Prelude.IO ()
removeNumbers numberType =
  Automation.methodID0 0x8c [Automation.inInt numberType]
convertNumbersToText :: Prelude.Int -> Automation.IDispatch a -> Prelude.IO ()
convertNumbersToText numberType =
  Automation.methodID0 0x8d [Automation.inInt numberType]
countNumberedItems :: Prelude.Int -> Prelude.Int -> Automation.IDispatch a -> Prelude.IO (Prelude.Int)
countNumberedItems numberType level =
  Automation.functionID1 0x8e [Automation.inInt numberType, Automation.inInt level] Automation.outInt
post :: IDocument a -> Prelude.IO ()
post = Automation.methodID0 0x8f []
toggleFormsDesign :: IDocument a -> Prelude.IO ()
toggleFormsDesign = Automation.methodID0 0x90 []
compare :: Prelude.String -> IDocument a -> Prelude.IO ()
compare name = Automation.methodID0 0x91 [Automation.inString name]
updateSummaryProperties :: IDocument a -> Prelude.IO ()
updateSummaryProperties = Automation.methodID0 0x92 []
getCrossReferenceItems :: Prelude.Int -> IDocument a -> Prelude.IO (Prelude.Int)
getCrossReferenceItems referenceType =
  Automation.functionID1 0x93 [Automation.inInt referenceType] Automation.outInt
autoFormat :: Automation.IDispatch a -> Prelude.IO ()
autoFormat = Automation.methodID0 0x94 []
viewCode :: IDocument a -> Prelude.IO ()
viewCode = Automation.methodID0 0x95 []
viewPropertyBrowser :: IDocument a -> Prelude.IO ()
viewPropertyBrowser = Automation.methodID0 0x96 []
forwardMailer :: IDocument a -> Prelude.IO ()
forwardMailer = Automation.methodID0 0xfa []
reply :: Automation.IDispatch a -> Prelude.IO ()
reply = Automation.methodID0 0xfb []
replyAll :: Automation.IDispatch a -> Prelude.IO ()
replyAll = Automation.methodID0 0xfc []
sendMailer :: Prelude.Int -> Prelude.Int -> IDocument a -> Prelude.IO ()
sendMailer fileFormat priority =
  Automation.methodID0 0xfd [Automation.inInt fileFormat, Automation.inInt priority]
undoClear :: IDocument a -> Prelude.IO ()
undoClear = Automation.methodID0 0xfe []
presentIt :: IDocument a -> Prelude.IO ()
presentIt = Automation.methodID0 0xff []
sendFax0 :: Prelude.String -> Prelude.Int -> Automation.IDispatch a -> Prelude.IO ()
sendFax0 address subject =
  Automation.methodID0 0x100 [Automation.inString address, Automation.inInt subject]
merge :: Prelude.String -> IDocument a -> Prelude.IO ()
merge fileName =
  Automation.methodID0 0x101 [Automation.inString fileName]
closePrintPreview :: IDocument a -> Prelude.IO ()
closePrintPreview = Automation.methodID0 0x102 []
checkConsistency :: IDocument a -> Prelude.IO ()
checkConsistency = Automation.methodID0 0x103 []
createLetterContent :: (Automation.Variant a0, Automation.Variant a1, Automation.Variant a2) => Prelude.String -> Prelude.Int -> Prelude.String -> a0 -> Prelude.Int -> a1 -> Prelude.Float -> Prelude.String -> Prelude.String -> Prelude.String -> a2 -> Prelude.String -> Prelude.String -> Prelude.String -> Prelude.String -> Prelude.String -> Prelude.String -> Prelude.String -> Prelude.String -> Prelude.String -> Prelude.String -> Prelude.String -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> IDocument a -> Prelude.IO (ILetterContent Automation.Interface)
createLetterContent dateFormat includeHeaderFooter pageDesign letterStyle letterhead letterheadLocation letterheadSize recipientName recipientAddress salutation salutationType recipientReference mailingInstructions attentionLine subject cCList returnAddress senderName closing senderCompany senderJobTitle senderInitials enclosureNumber infoBlock recipientCode recipientGender returnAddressShortForm senderCity senderCode senderGender senderReference =
  Automation.functionID1 0x104 [Automation.inString dateFormat, Automation.inInt includeHeaderFooter, Automation.inString pageDesign, Automation.inVariant letterStyle, Automation.inInt letterhead, Automation.inVariant letterheadLocation, Automation.inFloat letterheadSize, Automation.inString recipientName, Automation.inString recipientAddress, Automation.inString salutation, Automation.inVariant salutationType, Automation.inString recipientReference, Automation.inString mailingInstructions, Automation.inString attentionLine, Automation.inString subject, Automation.inString cCList, Automation.inString returnAddress, Automation.inString senderName, Automation.inString closing, Automation.inString senderCompany, Automation.inString senderJobTitle, Automation.inString senderInitials, Automation.inInt enclosureNumber, Automation.inInt infoBlock, Automation.inInt recipientCode, Automation.inInt recipientGender, Automation.inInt returnAddressShortForm, Automation.inInt senderCity, Automation.inInt senderCode, Automation.inInt senderGender, Automation.inInt senderReference] Automation.outIDispatch
acceptAllRevisions :: IDocument a -> Prelude.IO ()
acceptAllRevisions = Automation.methodID0 0x13d []
rejectAllRevisions :: IDocument a -> Prelude.IO ()
rejectAllRevisions = Automation.methodID0 0x13e []
-- --------------------------------------------------
-- 
-- interface Template
-- 
-- --------------------------------------------------
data Template a = Template
                   
type ITemplate a = Automation.IDispatch (Template a)
iidITemplate :: Com.IID (ITemplate Automation.Interface)
iidITemplate = Com.mkIID "{0002096A-0000-0000-C000-000000000046}"
getAutoTextEntries :: ITemplate a -> Prelude.IO (IAutoTextEntries Automation.Interface)
getAutoTextEntries =
  Automation.propertyGetID 0x2 [] Automation.outIDispatch
getLanguageID :: (Automation.Variant a0) => Automation.IDispatch a -> Prelude.IO (a0)
getLanguageID =
  Automation.propertyGetID 0x4 [] Automation.outVariant
setLanguageID :: (Automation.Variant a0) => a0 -> Automation.IDispatch a -> Prelude.IO ()
setLanguageID prop =
  Automation.propertySetID 0x4 [Automation.inVariant prop]
getType0 :: (Automation.Variant a0) => ITemplate a -> Prelude.IO (a0)
getType0 = Automation.propertyGetID 0x6 [] Automation.outVariant
getLanguageIDFarEast :: (Automation.Variant a0) => Automation.IDispatch a -> Prelude.IO (a0)
getLanguageIDFarEast =
  Automation.propertyGetID 0xb [] Automation.outVariant
setLanguageIDFarEast :: (Automation.Variant a0) => a0 -> Automation.IDispatch a -> Prelude.IO ()
setLanguageIDFarEast prop =
  Automation.propertySetID 0xb [Automation.inVariant prop]
openAsDocument :: ITemplate a -> Prelude.IO (IDocument Automation.Interface)
openAsDocument =
  Automation.functionID1 0x64 [] Automation.outIDispatch
-- --------------------------------------------------
-- 
-- interface Templates
-- 
-- --------------------------------------------------
data Templates a = Templates
                    
type ITemplates a = Automation.IDispatch (Templates a)
iidITemplates :: Com.IID (ITemplates Automation.Interface)
iidITemplates = Com.mkIID "{000209A2-0000-0000-C000-000000000046}"
item2 :: Prelude.Int -> ITemplates a -> Prelude.IO (ITemplate Automation.Interface)
item2 idex =
  Automation.functionID1 0o0 [Automation.inInt idex] Automation.outIDispatch
-- --------------------------------------------------
-- 
-- interface RoutingSlip
-- 
-- --------------------------------------------------
data RoutingSlip a = RoutingSlip
                      
type IRoutingSlip a = Automation.IDispatch (RoutingSlip a)
iidIRoutingSlip :: Com.IID (IRoutingSlip Automation.Interface)
iidIRoutingSlip =
  Com.mkIID "{00020969-0000-0000-C000-000000000046}"
getSubject :: Automation.IDispatch a -> Prelude.IO (Prelude.String)
getSubject = Automation.propertyGetID 0x1 [] Automation.outString
setSubject :: Prelude.String -> Automation.IDispatch a -> Prelude.IO ()
setSubject prop =
  Automation.propertySetID 0x1 [Automation.inString prop]
getMessage :: IRoutingSlip a -> Prelude.IO (Prelude.String)
getMessage = Automation.propertyGetID 0x2 [] Automation.outString
setMessage :: Prelude.String -> IRoutingSlip a -> Prelude.IO ()
setMessage prop =
  Automation.propertySetID 0x2 [Automation.inString prop]
getDelivery :: (Automation.Variant a0) => IRoutingSlip a -> Prelude.IO (a0)
getDelivery = Automation.propertyGetID 0x3 [] Automation.outVariant
setDelivery :: (Automation.Variant a0) => a0 -> IRoutingSlip a -> Prelude.IO ()
setDelivery prop =
  Automation.propertySetID 0x3 [Automation.inVariant prop]
getTrackStatus :: IRoutingSlip a -> Prelude.IO (Prelude.Int)
getTrackStatus = Automation.propertyGetID 0x4 [] Automation.outInt
setTrackStatus :: Prelude.Int -> IRoutingSlip a -> Prelude.IO ()
setTrackStatus prop =
  Automation.propertySetID 0x4 [Automation.inInt prop]
getProtect :: (Automation.Variant a0) => IRoutingSlip a -> Prelude.IO (a0)
getProtect = Automation.propertyGetID 0x5 [] Automation.outVariant
setProtect :: (Automation.Variant a0) => a0 -> Automation.IDispatch a -> Prelude.IO ()
setProtect prop =
  Automation.propertySetID 0x5 [Automation.inVariant prop]
getReturnWhenDone :: IRoutingSlip a -> Prelude.IO (Prelude.Int)
getReturnWhenDone =
  Automation.propertyGetID 0x6 [] Automation.outInt
setReturnWhenDone :: Prelude.Int -> IRoutingSlip a -> Prelude.IO ()
setReturnWhenDone prop =
  Automation.propertySetID 0x6 [Automation.inInt prop]
getStatus :: (Automation.Variant a0) => IRoutingSlip a -> Prelude.IO (a0)
getStatus = Automation.propertyGetID 0x7 [] Automation.outVariant
getRecipients :: Prelude.Int -> IRoutingSlip a -> Prelude.IO (Prelude.Int)
getRecipients idex =
  Automation.propertyGetID 0x9 [Automation.inInt idex] Automation.outInt
reset :: Automation.IDispatch a -> Prelude.IO ()
reset = Automation.methodID0 0x65 []
addRecipient :: Prelude.String -> IRoutingSlip a -> Prelude.IO ()
addRecipient recipient =
  Automation.methodID0 0x66 [Automation.inString recipient]
-- --------------------------------------------------
-- 
-- interface Bookmark
-- 
-- --------------------------------------------------
data Bookmark a = Bookmark
                   
type IBookmark a = Automation.IDispatch (Bookmark a)
iidIBookmark :: Com.IID (IBookmark Automation.Interface)
iidIBookmark = Com.mkIID "{00020968-0000-0000-C000-000000000046}"
getRange :: Automation.IDispatch a -> Prelude.IO (IRange Automation.Interface)
getRange = Automation.propertyGetID 0x1 [] Automation.outIDispatch
getEmpty :: IBookmark a -> Prelude.IO (Prelude.Int)
getEmpty = Automation.propertyGetID 0x2 [] Automation.outInt
getStart :: Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getStart = Automation.propertyGetID 0x3 [] Automation.outInt
setStart :: Prelude.Int -> Automation.IDispatch a -> Prelude.IO ()
setStart prop =
  Automation.propertySetID 0x3 [Automation.inInt prop]
getEnd :: Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getEnd = Automation.propertyGetID 0x4 [] Automation.outInt
setEnd :: Prelude.Int -> Automation.IDispatch a -> Prelude.IO ()
setEnd prop = Automation.propertySetID 0x4 [Automation.inInt prop]
getColumn :: IBookmark a -> Prelude.IO (Prelude.Int)
getColumn = Automation.propertyGetID 0x5 [] Automation.outInt
getStoryType :: (Automation.Variant a0) => Automation.IDispatch a -> Prelude.IO (a0)
getStoryType =
  Automation.propertyGetID 0x6 [] Automation.outVariant
delete :: Automation.IDispatch a -> Prelude.IO ()
delete = Automation.methodID0 0xb []
copy :: Prelude.String -> IBookmark a -> Prelude.IO (IBookmark Automation.Interface)
copy name =
  Automation.functionID1 0xc [Automation.inString name] Automation.outIDispatch
-- --------------------------------------------------
-- 
-- interface Bookmarks
-- 
-- --------------------------------------------------
data Bookmarks a = Bookmarks
                    
type IBookmarks a = Automation.IDispatch (Bookmarks a)
iidIBookmarks :: Com.IID (IBookmarks Automation.Interface)
iidIBookmarks = Com.mkIID "{00020967-0000-0000-C000-000000000046}"
getDefaultSorting :: (Automation.Variant a0) => IBookmarks a -> Prelude.IO (a0)
getDefaultSorting =
  Automation.propertyGetID 0x3 [] Automation.outVariant
setDefaultSorting :: (Automation.Variant a0) => a0 -> IBookmarks a -> Prelude.IO ()
setDefaultSorting prop =
  Automation.propertySetID 0x3 [Automation.inVariant prop]
getShowHidden :: IBookmarks a -> Prelude.IO (Prelude.Int)
getShowHidden = Automation.propertyGetID 0x4 [] Automation.outInt
setShowHidden :: Prelude.Int -> IBookmarks a -> Prelude.IO ()
setShowHidden prop =
  Automation.propertySetID 0x4 [Automation.inInt prop]
item3 :: Prelude.Int -> IBookmarks a -> Prelude.IO (IBookmark Automation.Interface)
item3 idex =
  Automation.functionID1 0o0 [Automation.inInt idex] Automation.outIDispatch
add0 :: Prelude.String -> Prelude.Int -> IBookmarks a -> Prelude.IO (IBookmark Automation.Interface)
add0 name range =
  Automation.functionID1 0x5 [Automation.inString name, Automation.inInt range] Automation.outIDispatch
exists :: Prelude.String -> Automation.IDispatch a -> Prelude.IO (Prelude.Int)
exists name =
  Automation.functionID1 0x6 [Automation.inString name] Automation.outInt
-- --------------------------------------------------
-- 
-- interface Variable
-- 
-- --------------------------------------------------
data Variable a = Variable
                   
type IVariable a = Automation.IDispatch (Variable a)
iidIVariable :: Com.IID (IVariable Automation.Interface)
iidIVariable = Com.mkIID "{00020966-0000-0000-C000-000000000046}"
getValue :: Automation.IDispatch a -> Prelude.IO (Prelude.String)
getValue = Automation.propertyGetID 0o0 [] Automation.outString
setValue :: Prelude.String -> Automation.IDispatch a -> Prelude.IO ()
setValue prop =
  Automation.propertySetID 0o0 [Automation.inString prop]
getIndex :: Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getIndex = Automation.propertyGetID 0x2 [] Automation.outInt
-- --------------------------------------------------
-- 
-- interface Variables
-- 
-- --------------------------------------------------
data Variables a = Variables
                    
type IVariables a = Automation.IDispatch (Variables a)
iidIVariables :: Com.IID (IVariables Automation.Interface)
iidIVariables = Com.mkIID "{00020965-0000-0000-C000-000000000046}"
item4 :: Prelude.Int -> IVariables a -> Prelude.IO (IVariable Automation.Interface)
item4 idex =
  Automation.functionID1 0o0 [Automation.inInt idex] Automation.outIDispatch
add1 :: Prelude.String -> Prelude.Int -> IVariables a -> Prelude.IO (IVariable Automation.Interface)
add1 name value =
  Automation.functionID1 0x7 [Automation.inString name, Automation.inInt value] Automation.outIDispatch
-- --------------------------------------------------
-- 
-- interface RecentFile
-- 
-- --------------------------------------------------
data RecentFile a = RecentFile
                     
type IRecentFile a = Automation.IDispatch (RecentFile a)
iidIRecentFile :: Com.IID (IRecentFile Automation.Interface)
iidIRecentFile = Com.mkIID "{00020964-0000-0000-C000-000000000046}"
setReadOnly :: Prelude.Int -> IRecentFile a -> Prelude.IO ()
setReadOnly prop =
  Automation.propertySetID 0x2 [Automation.inInt prop]
open0 :: Automation.IDispatch a -> Prelude.IO (IDocument Automation.Interface)
open0 = Automation.functionID1 0x4 [] Automation.outIDispatch
-- --------------------------------------------------
-- 
-- interface RecentFiles
-- 
-- --------------------------------------------------
data RecentFiles a = RecentFiles
                      
type IRecentFiles a = Automation.IDispatch (RecentFiles a)
iidIRecentFiles :: Com.IID (IRecentFiles Automation.Interface)
iidIRecentFiles =
  Com.mkIID "{00020963-0000-0000-C000-000000000046}"
getMaximum :: Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getMaximum = Automation.propertyGetID 0x2 [] Automation.outInt
setMaximum :: Prelude.Int -> IRecentFiles a -> Prelude.IO ()
setMaximum prop =
  Automation.propertySetID 0x2 [Automation.inInt prop]
item5 :: Prelude.Int -> IRecentFiles a -> Prelude.IO (IRecentFile Automation.Interface)
item5 idex =
  Automation.functionID1 0o0 [Automation.inInt idex] Automation.outIDispatch
add2 :: Prelude.Int -> Prelude.Int -> IRecentFiles a -> Prelude.IO (IRecentFile Automation.Interface)
add2 document readOnly =
  Automation.functionID1 0x3 [Automation.inInt document, Automation.inInt readOnly] Automation.outIDispatch
-- --------------------------------------------------
-- 
-- interface Window
-- 
-- --------------------------------------------------
data Window a = Window
                 
type IWindow a = Automation.IDispatch (Window a)
iidIWindow :: Com.IID (IWindow Automation.Interface)
iidIWindow = Com.mkIID "{00020962-0000-0000-C000-000000000046}"
getActivePane :: IWindow a -> Prelude.IO (IPane Automation.Interface)
getActivePane =
  Automation.propertyGetID 0x1 [] Automation.outIDispatch
getDocument :: Automation.IDispatch a -> Prelude.IO (IDocument Automation.Interface)
getDocument =
  Automation.propertyGetID 0x2 [] Automation.outIDispatch
getPanes :: IWindow a -> Prelude.IO (IPanes Automation.Interface)
getPanes = Automation.propertyGetID 0x3 [] Automation.outIDispatch
getSplit :: IWindow a -> Prelude.IO (Prelude.Int)
getSplit = Automation.propertyGetID 0x9 [] Automation.outInt
setSplit :: Prelude.Int -> IWindow a -> Prelude.IO ()
setSplit prop =
  Automation.propertySetID 0x9 [Automation.inInt prop]
getSplitVertical :: IWindow a -> Prelude.IO (Prelude.Int)
getSplitVertical =
  Automation.propertyGetID 0xa [] Automation.outInt
setSplitVertical :: Prelude.Int -> IWindow a -> Prelude.IO ()
setSplitVertical prop =
  Automation.propertySetID 0xa [Automation.inInt prop]
getDisplayRulers :: Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getDisplayRulers =
  Automation.propertyGetID 0xc [] Automation.outInt
setDisplayRulers :: Prelude.Int -> Automation.IDispatch a -> Prelude.IO ()
setDisplayRulers prop =
  Automation.propertySetID 0xc [Automation.inInt prop]
getDisplayVerticalRuler :: Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getDisplayVerticalRuler =
  Automation.propertyGetID 0xd [] Automation.outInt
setDisplayVerticalRuler :: Prelude.Int -> Automation.IDispatch a -> Prelude.IO ()
setDisplayVerticalRuler prop =
  Automation.propertySetID 0xd [Automation.inInt prop]
getView :: Automation.IDispatch a -> Prelude.IO (IView Automation.Interface)
getView = Automation.propertyGetID 0xe [] Automation.outIDispatch
getType1 :: (Automation.Variant a0) => IWindow a -> Prelude.IO (a0)
getType1 = Automation.propertyGetID 0xf [] Automation.outVariant
getNext :: IWindow a -> Prelude.IO (IWindow Automation.Interface)
getNext = Automation.propertyGetID 0x10 [] Automation.outIDispatch
getPrevious :: IWindow a -> Prelude.IO (IWindow Automation.Interface)
getPrevious =
  Automation.propertyGetID 0x11 [] Automation.outIDispatch
getWindowNumber :: IWindow a -> Prelude.IO (Prelude.Int)
getWindowNumber =
  Automation.propertyGetID 0x12 [] Automation.outInt
getDisplayVerticalScrollBar :: IWindow a -> Prelude.IO (Prelude.Int)
getDisplayVerticalScrollBar =
  Automation.propertyGetID 0x13 [] Automation.outInt
setDisplayVerticalScrollBar :: Prelude.Int -> IWindow a -> Prelude.IO ()
setDisplayVerticalScrollBar prop =
  Automation.propertySetID 0x13 [Automation.inInt prop]
getDisplayHorizontalScrollBar :: IWindow a -> Prelude.IO (Prelude.Int)
getDisplayHorizontalScrollBar =
  Automation.propertyGetID 0x14 [] Automation.outInt
setDisplayHorizontalScrollBar :: Prelude.Int -> IWindow a -> Prelude.IO ()
setDisplayHorizontalScrollBar prop =
  Automation.propertySetID 0x14 [Automation.inInt prop]
getStyleAreaWidth :: IWindow a -> Prelude.IO (Prelude.Float)
getStyleAreaWidth =
  Automation.propertyGetID 0x15 [] Automation.outFloat
setStyleAreaWidth :: Prelude.Float -> IWindow a -> Prelude.IO ()
setStyleAreaWidth prop =
  Automation.propertySetID 0x15 [Automation.inFloat prop]
getHorizontalPercentScrolled :: Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getHorizontalPercentScrolled =
  Automation.propertyGetID 0x17 [] Automation.outInt
setHorizontalPercentScrolled :: Prelude.Int -> Automation.IDispatch a -> Prelude.IO ()
setHorizontalPercentScrolled prop =
  Automation.propertySetID 0x17 [Automation.inInt prop]
getVerticalPercentScrolled :: Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getVerticalPercentScrolled =
  Automation.propertyGetID 0x18 [] Automation.outInt
setVerticalPercentScrolled :: Prelude.Int -> Automation.IDispatch a -> Prelude.IO ()
setVerticalPercentScrolled prop =
  Automation.propertySetID 0x18 [Automation.inInt prop]
getDocumentMap :: IWindow a -> Prelude.IO (Prelude.Int)
getDocumentMap = Automation.propertyGetID 0x19 [] Automation.outInt
setDocumentMap :: Prelude.Int -> IWindow a -> Prelude.IO ()
setDocumentMap prop =
  Automation.propertySetID 0x19 [Automation.inInt prop]
getActive :: Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getActive = Automation.propertyGetID 0x1a [] Automation.outInt
getDocumentMapPercentWidth :: IWindow a -> Prelude.IO (Prelude.Int)
getDocumentMapPercentWidth =
  Automation.propertyGetID 0x1b [] Automation.outInt
setDocumentMapPercentWidth :: Prelude.Int -> IWindow a -> Prelude.IO ()
setDocumentMapPercentWidth prop =
  Automation.propertySetID 0x1b [Automation.inInt prop]
getIMEMode :: (Automation.Variant a0) => IWindow a -> Prelude.IO (a0)
getIMEMode = Automation.propertyGetID 0x1e [] Automation.outVariant
setIMEMode :: (Automation.Variant a0) => a0 -> IWindow a -> Prelude.IO ()
setIMEMode prop =
  Automation.propertySetID 0x1e [Automation.inVariant prop]
close1 :: Prelude.Int -> Prelude.Int -> Automation.IDispatch a -> Prelude.IO ()
close1 saveChanges routeDocument =
  Automation.methodID0 0x66 [Automation.inInt saveChanges, Automation.inInt routeDocument]
largeScroll :: Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Automation.IDispatch a -> Prelude.IO ()
largeScroll down up toRight toLeft =
  Automation.methodID0 0x67 [Automation.inInt down, Automation.inInt up, Automation.inInt toRight, Automation.inInt toLeft]
smallScroll :: Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Automation.IDispatch a -> Prelude.IO ()
smallScroll down up toRight toLeft =
  Automation.methodID0 0x68 [Automation.inInt down, Automation.inInt up, Automation.inInt toRight, Automation.inInt toLeft]
newWindow1 :: IWindow a -> Prelude.IO (IWindow Automation.Interface)
newWindow1 = Automation.functionID1 0x69 [] Automation.outIDispatch
pageScroll :: Prelude.Int -> Prelude.Int -> Automation.IDispatch a -> Prelude.IO ()
pageScroll down up =
  Automation.methodID0 0x6c [Automation.inInt down, Automation.inInt up]
-- --------------------------------------------------
-- 
-- interface Windows
-- 
-- --------------------------------------------------
data Windows a = Windows
                  
type IWindows a = Automation.IDispatch (Windows a)
iidIWindows :: Com.IID (IWindows Automation.Interface)
iidIWindows = Com.mkIID "{00020961-0000-0000-C000-000000000046}"
item6 :: Prelude.Int -> IWindows a -> Prelude.IO (IWindow Automation.Interface)
item6 idex =
  Automation.functionID1 0o0 [Automation.inInt idex] Automation.outIDispatch
add3 :: Prelude.Int -> IWindows a -> Prelude.IO (IWindow Automation.Interface)
add3 window =
  Automation.functionID1 0xa [Automation.inInt window] Automation.outIDispatch
arrange :: Prelude.Int -> IWindows a -> Prelude.IO ()
arrange arrangeStyle =
  Automation.methodID0 0xb [Automation.inInt arrangeStyle]
-- --------------------------------------------------
-- 
-- interface Pane
-- 
-- --------------------------------------------------
data Pane a = Pane
               
type IPane a = Automation.IDispatch (Pane a)
iidIPane :: Com.IID (IPane Automation.Interface)
iidIPane = Com.mkIID "{00020960-0000-0000-C000-000000000046}"
getZooms :: IPane a -> Prelude.IO (IZooms Automation.Interface)
getZooms = Automation.propertyGetID 0x7 [] Automation.outIDispatch
getNext0 :: IPane a -> Prelude.IO (IPane Automation.Interface)
getNext0 = Automation.propertyGetID 0xb [] Automation.outIDispatch
getPrevious0 :: IPane a -> Prelude.IO (IPane Automation.Interface)
getPrevious0 =
  Automation.propertyGetID 0xc [] Automation.outIDispatch
getMinimumFontSize :: IPane a -> Prelude.IO (Prelude.Int)
getMinimumFontSize =
  Automation.propertyGetID 0xf [] Automation.outInt
setMinimumFontSize :: Prelude.Int -> IPane a -> Prelude.IO ()
setMinimumFontSize prop =
  Automation.propertySetID 0xf [Automation.inInt prop]
getBrowseToWindow :: IPane a -> Prelude.IO (Prelude.Int)
getBrowseToWindow =
  Automation.propertyGetID 0x10 [] Automation.outInt
setBrowseToWindow :: Prelude.Int -> IPane a -> Prelude.IO ()
setBrowseToWindow prop =
  Automation.propertySetID 0x10 [Automation.inInt prop]
getBrowseWidth :: IPane a -> Prelude.IO (Prelude.Int)
getBrowseWidth = Automation.propertyGetID 0x11 [] Automation.outInt
close2 :: Automation.IDispatch a -> Prelude.IO ()
close2 = Automation.methodID0 0x65 []
autoScroll :: Prelude.Int -> IPane a -> Prelude.IO ()
autoScroll velocity =
  Automation.methodID0 0x68 [Automation.inInt velocity]
-- --------------------------------------------------
-- 
-- interface Panes
-- 
-- --------------------------------------------------
data Panes a = Panes
                
type IPanes a = Automation.IDispatch (Panes a)
iidIPanes :: Com.IID (IPanes Automation.Interface)
iidIPanes = Com.mkIID "{0002095F-0000-0000-C000-000000000046}"
item7 :: Prelude.Int -> IPanes a -> Prelude.IO (IPane Automation.Interface)
item7 idex =
  Automation.functionID1 0o0 [Automation.inInt idex] Automation.outIDispatch
add4 :: Prelude.Int -> IPanes a -> Prelude.IO (IPane Automation.Interface)
add4 splitVertical =
  Automation.functionID1 0x3 [Automation.inInt splitVertical] Automation.outIDispatch
-- --------------------------------------------------
-- 
-- interface Range
-- 
-- --------------------------------------------------
data Range a = Range
                
type IRange a = Automation.IDispatch (Range a)
iidIRange :: Com.IID (IRange Automation.Interface)
iidIRange = Com.mkIID "{0002095E-0000-0000-C000-000000000046}"
getText :: Automation.IDispatch a -> Prelude.IO (Prelude.String)
getText = Automation.propertyGetID 0o0 [] Automation.outString
setText :: Prelude.String -> Automation.IDispatch a -> Prelude.IO ()
setText prop =
  Automation.propertySetID 0o0 [Automation.inString prop]
getFormattedText :: Automation.IDispatch a -> Prelude.IO (IRange Automation.Interface)
getFormattedText =
  Automation.propertyGetID 0x2 [] Automation.outIDispatch
setFormattedText :: IRange a0 -> Automation.IDispatch a -> Prelude.IO ()
setFormattedText prop =
  Automation.propertySetID 0x2 [Automation.inIDispatch prop]
getFont :: Automation.IDispatch a -> Prelude.IO (IFont Automation.Interface)
getFont = Automation.propertyGetID 0x5 [] Automation.outIDispatch
setFont :: IFont a0 -> Automation.IDispatch a -> Prelude.IO ()
setFont prop =
  Automation.propertySetID 0x5 [Automation.inIDispatch prop]
getDuplicate :: IRange a -> Prelude.IO (IRange Automation.Interface)
getDuplicate =
  Automation.propertyGetID 0x6 [] Automation.outIDispatch
getCells :: Automation.IDispatch a -> Prelude.IO (ICells Automation.Interface)
getCells = Automation.propertyGetID 0x39 [] Automation.outIDispatch
getBorders :: Automation.IDispatch a -> Prelude.IO (IBorders Automation.Interface)
getBorders =
  Automation.propertyGetID 0x44c [] Automation.outIDispatch
setBorders :: IBorders a0 -> Automation.IDispatch a -> Prelude.IO ()
setBorders prop =
  Automation.propertySetID 0x44c [Automation.inIDispatch prop]
getShading :: Automation.IDispatch a -> Prelude.IO (IShading Automation.Interface)
getShading =
  Automation.propertyGetID 0x3d [] Automation.outIDispatch
getTextRetrievalMode :: IRange a -> Prelude.IO (ITextRetrievalMode Automation.Interface)
getTextRetrievalMode =
  Automation.propertyGetID 0x3e [] Automation.outIDispatch
setTextRetrievalMode :: ITextRetrievalMode a0 -> IRange a -> Prelude.IO ()
setTextRetrievalMode prop =
  Automation.propertySetID 0x3e [Automation.inIDispatch prop]
getParagraphFormat :: Automation.IDispatch a -> Prelude.IO (IParagraphFormat Automation.Interface)
getParagraphFormat =
  Automation.propertyGetID 0x44e [] Automation.outIDispatch
setParagraphFormat :: IParagraphFormat a0 -> Automation.IDispatch a -> Prelude.IO ()
setParagraphFormat prop =
  Automation.propertySetID 0x44e [Automation.inIDispatch prop]
getListFormat :: IRange a -> Prelude.IO (IListFormat Automation.Interface)
getListFormat =
  Automation.propertyGetID 0x44 [] Automation.outIDispatch
getBold :: Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getBold = Automation.propertyGetID 0x82 [] Automation.outInt
setBold :: Prelude.Int -> Automation.IDispatch a -> Prelude.IO ()
setBold prop =
  Automation.propertySetID 0x82 [Automation.inInt prop]
getItalic :: Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getItalic = Automation.propertyGetID 0x83 [] Automation.outInt
setItalic :: Prelude.Int -> Automation.IDispatch a -> Prelude.IO ()
setItalic prop =
  Automation.propertySetID 0x83 [Automation.inInt prop]
getUnderline :: (Automation.Variant a0) => Automation.IDispatch a -> Prelude.IO (a0)
getUnderline =
  Automation.propertyGetID 0x8b [] Automation.outVariant
setUnderline :: (Automation.Variant a0) => a0 -> Automation.IDispatch a -> Prelude.IO ()
setUnderline prop =
  Automation.propertySetID 0x8b [Automation.inVariant prop]
getEmphasisMark :: (Automation.Variant a0) => Automation.IDispatch a -> Prelude.IO (a0)
getEmphasisMark =
  Automation.propertyGetID 0x8c [] Automation.outVariant
setEmphasisMark :: (Automation.Variant a0) => a0 -> Automation.IDispatch a -> Prelude.IO ()
setEmphasisMark prop =
  Automation.propertySetID 0x8c [Automation.inVariant prop]
getDisableCharacterSpaceGrid :: Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getDisableCharacterSpaceGrid =
  Automation.propertyGetID 0x8d [] Automation.outInt
setDisableCharacterSpaceGrid :: Prelude.Int -> Automation.IDispatch a -> Prelude.IO ()
setDisableCharacterSpaceGrid prop =
  Automation.propertySetID 0x8d [Automation.inInt prop]
getStyle :: Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getStyle = Automation.propertyGetID 0x97 [] Automation.outInt
setStyle :: Prelude.Int -> Automation.IDispatch a -> Prelude.IO ()
setStyle prop =
  Automation.propertySetID 0x97 [Automation.inInt prop]
getStoryLength :: Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getStoryLength = Automation.propertyGetID 0x98 [] Automation.outInt
getSynonymInfo1 :: IRange a -> Prelude.IO (ISynonymInfo Automation.Interface)
getSynonymInfo1 =
  Automation.propertyGetID 0x9b [] Automation.outIDispatch
getHighlightColorIndex :: (Automation.Variant a0) => IRange a -> Prelude.IO (a0)
getHighlightColorIndex =
  Automation.propertyGetID 0x12d [] Automation.outVariant
setHighlightColorIndex :: (Automation.Variant a0) => a0 -> IRange a -> Prelude.IO ()
setHighlightColorIndex prop =
  Automation.propertySetID 0x12d [Automation.inVariant prop]
getColumns :: Automation.IDispatch a -> Prelude.IO (IColumns Automation.Interface)
getColumns =
  Automation.propertyGetID 0x12e [] Automation.outIDispatch
getRows :: Automation.IDispatch a -> Prelude.IO (IRows Automation.Interface)
getRows = Automation.propertyGetID 0x12f [] Automation.outIDispatch
getCanEdit :: IRange a -> Prelude.IO (Prelude.Int)
getCanEdit = Automation.propertyGetID 0x130 [] Automation.outInt
getCanPaste :: IRange a -> Prelude.IO (Prelude.Int)
getCanPaste = Automation.propertyGetID 0x131 [] Automation.outInt
getIsEndOfRowMark :: Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getIsEndOfRowMark =
  Automation.propertyGetID 0x133 [] Automation.outInt
getBookmarkID :: Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getBookmarkID = Automation.propertyGetID 0x134 [] Automation.outInt
getPreviousBookmarkID :: Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getPreviousBookmarkID =
  Automation.propertyGetID 0x135 [] Automation.outInt
getFind :: Automation.IDispatch a -> Prelude.IO (IFind Automation.Interface)
getFind = Automation.propertyGetID 0x106 [] Automation.outIDispatch
getShapeRange :: Automation.IDispatch a -> Prelude.IO (Office.IShapeRange Automation.Interface)
getShapeRange =
  Automation.propertyGetID 0x137 [] Automation.outIDispatch
getCase :: (Automation.Variant a0) => IRange a -> Prelude.IO (a0)
getCase = Automation.propertyGetID 0x138 [] Automation.outVariant
setCase :: (Automation.Variant a0) => a0 -> IRange a -> Prelude.IO ()
setCase prop =
  Automation.propertySetID 0x138 [Automation.inVariant prop]
getInformation :: (Automation.Variant a0) => a0 -> Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getInformation type0 =
  Automation.propertyGetID 0x139 [Automation.inVariant type0] Automation.outInt
getOrientation :: (Automation.Variant a0) => Automation.IDispatch a -> Prelude.IO (a0)
getOrientation =
  Automation.propertyGetID 0x13d [] Automation.outVariant
setOrientation :: (Automation.Variant a0) => a0 -> Automation.IDispatch a -> Prelude.IO ()
setOrientation prop =
  Automation.propertySetID 0x13d [Automation.inVariant prop]
getNextStoryRange :: IRange a -> Prelude.IO (IRange Automation.Interface)
getNextStoryRange =
  Automation.propertyGetID 0x140 [] Automation.outIDispatch
getLanguageIDOther :: (Automation.Variant a0) => Automation.IDispatch a -> Prelude.IO (a0)
getLanguageIDOther =
  Automation.propertyGetID 0x142 [] Automation.outVariant
setLanguageIDOther :: (Automation.Variant a0) => a0 -> Automation.IDispatch a -> Prelude.IO ()
setLanguageIDOther prop =
  Automation.propertySetID 0x142 [Automation.inVariant prop]
setRange :: Prelude.Int -> Prelude.Int -> Automation.IDispatch a -> Prelude.IO ()
setRange start end =
  Automation.methodID0 0x64 [Automation.inInt start, Automation.inInt end]
collapse :: Prelude.Int -> Automation.IDispatch a -> Prelude.IO ()
collapse direction =
  Automation.methodID0 0x65 [Automation.inInt direction]
insertBefore :: Prelude.String -> Automation.IDispatch a -> Prelude.IO ()
insertBefore text =
  Automation.methodID0 0x66 [Automation.inString text]
insertAfter :: Prelude.String -> Automation.IDispatch a -> Prelude.IO ()
insertAfter text =
  Automation.methodID0 0x68 [Automation.inString text]
next :: Prelude.Int -> Prelude.Int -> Automation.IDispatch a -> Prelude.IO (IRange Automation.Interface)
next unit count =
  Automation.functionID1 0x69 [Automation.inInt unit, Automation.inInt count] Automation.outIDispatch
previous :: Prelude.Int -> Prelude.Int -> Automation.IDispatch a -> Prelude.IO (IRange Automation.Interface)
previous unit count =
  Automation.functionID1 0x6a [Automation.inInt unit, Automation.inInt count] Automation.outIDispatch
startOf :: Prelude.Int -> Prelude.Int -> Automation.IDispatch a -> Prelude.IO (Prelude.Int)
startOf unit extend =
  Automation.functionID1 0x6b [Automation.inInt unit, Automation.inInt extend] Automation.outInt
endOf :: Prelude.Int -> Prelude.Int -> Automation.IDispatch a -> Prelude.IO (Prelude.Int)
endOf unit extend =
  Automation.functionID1 0x6c [Automation.inInt unit, Automation.inInt extend] Automation.outInt
move0 :: Prelude.Int -> Prelude.Int -> Automation.IDispatch a -> Prelude.IO (Prelude.Int)
move0 unit count =
  Automation.functionID1 0x6d [Automation.inInt unit, Automation.inInt count] Automation.outInt
moveStart :: Prelude.Int -> Prelude.Int -> Automation.IDispatch a -> Prelude.IO (Prelude.Int)
moveStart unit count =
  Automation.functionID1 0x6e [Automation.inInt unit, Automation.inInt count] Automation.outInt
moveEnd :: Prelude.Int -> Prelude.Int -> Automation.IDispatch a -> Prelude.IO (Prelude.Int)
moveEnd unit count =
  Automation.functionID1 0x6f [Automation.inInt unit, Automation.inInt count] Automation.outInt
moveWhile :: Prelude.Int -> Prelude.Int -> Automation.IDispatch a -> Prelude.IO (Prelude.Int)
moveWhile cset count =
  Automation.functionID1 0x70 [Automation.inInt cset, Automation.inInt count] Automation.outInt
moveStartWhile :: Prelude.Int -> Prelude.Int -> Automation.IDispatch a -> Prelude.IO (Prelude.Int)
moveStartWhile cset count =
  Automation.functionID1 0x71 [Automation.inInt cset, Automation.inInt count] Automation.outInt
moveEndWhile :: Prelude.Int -> Prelude.Int -> Automation.IDispatch a -> Prelude.IO (Prelude.Int)
moveEndWhile cset count =
  Automation.functionID1 0x72 [Automation.inInt cset, Automation.inInt count] Automation.outInt
moveUntil :: Prelude.Int -> Prelude.Int -> Automation.IDispatch a -> Prelude.IO (Prelude.Int)
moveUntil cset count =
  Automation.functionID1 0x73 [Automation.inInt cset, Automation.inInt count] Automation.outInt
moveStartUntil :: Prelude.Int -> Prelude.Int -> Automation.IDispatch a -> Prelude.IO (Prelude.Int)
moveStartUntil cset count =
  Automation.functionID1 0x74 [Automation.inInt cset, Automation.inInt count] Automation.outInt
moveEndUntil :: Prelude.Int -> Prelude.Int -> Automation.IDispatch a -> Prelude.IO (Prelude.Int)
moveEndUntil cset count =
  Automation.functionID1 0x75 [Automation.inInt cset, Automation.inInt count] Automation.outInt
cut :: Automation.IDispatch a -> Prelude.IO ()
cut = Automation.methodID0 0x77 []
copy0 :: Automation.IDispatch a -> Prelude.IO ()
copy0 = Automation.methodID0 0x78 []
paste :: Automation.IDispatch a -> Prelude.IO ()
paste = Automation.methodID0 0x79 []
insertBreak :: Prelude.Int -> Automation.IDispatch a -> Prelude.IO ()
insertBreak type0 =
  Automation.methodID0 0x7a [Automation.inInt type0]
insertFile :: Prelude.String -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Automation.IDispatch a -> Prelude.IO ()
insertFile fileName range confirmConversions link attachment =
  Automation.methodID0 0x7b [Automation.inString fileName, Automation.inInt range, Automation.inInt confirmConversions, Automation.inInt link, Automation.inInt attachment]
inStory :: IRange a0 -> Automation.IDispatch a -> Prelude.IO (Prelude.Int)
inStory range =
  Automation.functionID1 0x7d [Automation.inIDispatch range] Automation.outInt
inRange :: IRange a0 -> Automation.IDispatch a -> Prelude.IO (Prelude.Int)
inRange range =
  Automation.functionID1 0x7e [Automation.inIDispatch range] Automation.outInt
delete2 :: Prelude.Int -> Prelude.Int -> Automation.IDispatch a -> Prelude.IO (Prelude.Int)
delete2 unit count =
  Automation.functionID1 0x7f [Automation.inInt unit, Automation.inInt count] Automation.outInt
wholeStory :: Automation.IDispatch a -> Prelude.IO ()
wholeStory = Automation.methodID0 0x80 []
expand :: Prelude.Int -> Automation.IDispatch a -> Prelude.IO (Prelude.Int)
expand unit =
  Automation.functionID1 0x81 [Automation.inInt unit] Automation.outInt
insertParagraph :: Automation.IDispatch a -> Prelude.IO ()
insertParagraph = Automation.methodID0 0xa0 []
insertParagraphAfter :: Automation.IDispatch a -> Prelude.IO ()
insertParagraphAfter = Automation.methodID0 0xa1 []
convertToTable :: Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Automation.IDispatch a -> Prelude.IO (ITable Automation.Interface)
convertToTable separator numRows numColumns initialColumnWidth format applyBorders applyShading applyFont applyColor applyHeadingRows applyLastRow applyFirstColumn applyLastColumn autoFit =
  Automation.functionID1 0xa2 [Automation.inInt separator, Automation.inInt numRows, Automation.inInt numColumns, Automation.inInt initialColumnWidth, Automation.inInt format, Automation.inInt applyBorders, Automation.inInt applyShading, Automation.inInt applyFont, Automation.inInt applyColor, Automation.inInt applyHeadingRows, Automation.inInt applyLastRow, Automation.inInt applyFirstColumn, Automation.inInt applyLastColumn, Automation.inInt autoFit] Automation.outIDispatch
insertDateTime :: Prelude.Int -> Prelude.Int -> Prelude.Int -> Automation.IDispatch a -> Prelude.IO ()
insertDateTime dateTimeFormat insertAsField insertAsFullWidth =
  Automation.methodID0 0xa3 [Automation.inInt dateTimeFormat, Automation.inInt insertAsField, Automation.inInt insertAsFullWidth]
insertSymbol :: Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Automation.IDispatch a -> Prelude.IO ()
insertSymbol characterNumber font unicode bias =
  Automation.methodID0 0xa4 [Automation.inInt characterNumber, Automation.inInt font, Automation.inInt unicode, Automation.inInt bias]
insertCrossReference :: (Automation.Variant a0) => Prelude.Int -> a0 -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Automation.IDispatch a -> Prelude.IO ()
insertCrossReference referenceType referenceKind referenceItem insertAsHyperlink includePosition =
  Automation.methodID0 0xa5 [Automation.inInt referenceType, Automation.inVariant referenceKind, Automation.inInt referenceItem, Automation.inInt insertAsHyperlink, Automation.inInt includePosition]
insertCaption :: Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Automation.IDispatch a -> Prelude.IO ()
insertCaption label title titleAutoText position =
  Automation.methodID0 0xa6 [Automation.inInt label, Automation.inInt title, Automation.inInt titleAutoText, Automation.inInt position]
copyAsPicture :: Automation.IDispatch a -> Prelude.IO ()
copyAsPicture = Automation.methodID0 0xa7 []
sort :: Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Automation.IDispatch a -> Prelude.IO ()
sort excludeHeader fieldNumber sortFieldType sortOrder fieldNumber2 sortFieldType2 sortOrder2 fieldNumber3 sortFieldType3 sortOrder3 sortColumn separator caseSensitive languageID =
  Automation.methodID0 0xa8 [Automation.inInt excludeHeader, Automation.inInt fieldNumber, Automation.inInt sortFieldType, Automation.inInt sortOrder, Automation.inInt fieldNumber2, Automation.inInt sortFieldType2, Automation.inInt sortOrder2, Automation.inInt fieldNumber3, Automation.inInt sortFieldType3, Automation.inInt sortOrder3, Automation.inInt sortColumn, Automation.inInt separator, Automation.inInt caseSensitive, Automation.inInt languageID]
sortAscending :: Automation.IDispatch a -> Prelude.IO ()
sortAscending = Automation.methodID0 0xa9 []
sortDescending :: Automation.IDispatch a -> Prelude.IO ()
sortDescending = Automation.methodID0 0xaa []
isEqual :: IRange a0 -> Automation.IDispatch a -> Prelude.IO (Prelude.Int)
isEqual range =
  Automation.functionID1 0xab [Automation.inIDispatch range] Automation.outInt
calculate :: Automation.IDispatch a -> Prelude.IO (Prelude.Float)
calculate = Automation.functionID1 0xac [] Automation.outFloat
goToNext :: (Automation.Variant a0) => a0 -> Automation.IDispatch a -> Prelude.IO (IRange Automation.Interface)
goToNext what =
  Automation.functionID1 0xae [Automation.inVariant what] Automation.outIDispatch
goToPrevious :: (Automation.Variant a0) => a0 -> Automation.IDispatch a -> Prelude.IO (IRange Automation.Interface)
goToPrevious what =
  Automation.functionID1 0xaf [Automation.inVariant what] Automation.outIDispatch
pasteSpecial :: Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Automation.IDispatch a -> Prelude.IO ()
pasteSpecial iconIndex link placement displayAsIcon dataType iconFileName iconLabel =
  Automation.methodID0 0xb0 [Automation.inInt iconIndex, Automation.inInt link, Automation.inInt placement, Automation.inInt displayAsIcon, Automation.inInt dataType, Automation.inInt iconFileName, Automation.inInt iconLabel]
lookupNameProperties0 :: Automation.IDispatch a -> Prelude.IO ()
lookupNameProperties0 = Automation.methodID0 0xb1 []
computeStatistics0 :: (Automation.Variant a0) => a0 -> IRange a -> Prelude.IO (Prelude.Int)
computeStatistics0 statistic =
  Automation.functionID1 0xb2 [Automation.inVariant statistic] Automation.outInt
relocate :: Prelude.Int -> IRange a -> Prelude.IO ()
relocate direction =
  Automation.methodID0 0xb3 [Automation.inInt direction]
checkSynonyms :: IRange a -> Prelude.IO ()
checkSynonyms = Automation.methodID0 0xb4 []
subscribeTo :: Prelude.String -> Prelude.Int -> IRange a -> Prelude.IO ()
subscribeTo edition format =
  Automation.methodID0 0xb5 [Automation.inString edition, Automation.inInt format]
createPublisher :: Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> IRange a -> Prelude.IO ()
createPublisher edition containsPICT containsRTF containsText =
  Automation.methodID0 0xb6 [Automation.inInt edition, Automation.inInt containsPICT, Automation.inInt containsRTF, Automation.inInt containsText]
insertAutoText :: IRange a -> Prelude.IO ()
insertAutoText = Automation.methodID0 0xb7 []
insertDatabase :: Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> IRange a -> Prelude.IO ()
insertDatabase format style linkToSource connection sQLStatement sQLStatement1 passwordDocument passwordTemplate writePasswordDocument writePasswordTemplate dataSource from to includeFields =
  Automation.methodID0 0xc2 [Automation.inInt format, Automation.inInt style, Automation.inInt linkToSource, Automation.inInt connection, Automation.inInt sQLStatement, Automation.inInt sQLStatement1, Automation.inInt passwordDocument, Automation.inInt passwordTemplate, Automation.inInt writePasswordDocument, Automation.inInt writePasswordTemplate, Automation.inInt dataSource, Automation.inInt from, Automation.inInt to, Automation.inInt includeFields]
getSpellingSuggestions1 :: Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> IRange a -> Prelude.IO (ISpellingSuggestions Automation.Interface)
getSpellingSuggestions1 customDictionary ignoreUppercase mainDictionary suggestionMode customDictionary2 customDictionary3 customDictionary4 customDictionary5 customDictionary6 customDictionary7 customDictionary8 customDictionary9 customDictionary10 =
  Automation.functionID1 0xd1 [Automation.inInt customDictionary, Automation.inInt ignoreUppercase, Automation.inInt mainDictionary, Automation.inInt suggestionMode, Automation.inInt customDictionary2, Automation.inInt customDictionary3, Automation.inInt customDictionary4, Automation.inInt customDictionary5, Automation.inInt customDictionary6, Automation.inInt customDictionary7, Automation.inInt customDictionary8, Automation.inInt customDictionary9, Automation.inInt customDictionary10] Automation.outIDispatch
insertParagraphBefore :: Automation.IDispatch a -> Prelude.IO ()
insertParagraphBefore = Automation.methodID0 0xd4 []
nextSubdocument :: Automation.IDispatch a -> Prelude.IO ()
nextSubdocument = Automation.methodID0 0xdb []
previousSubdocument :: Automation.IDispatch a -> Prelude.IO ()
previousSubdocument = Automation.methodID0 0xdc []
convertHangulAndHanja :: Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> IRange a -> Prelude.IO ()
convertHangulAndHanja conversionsMode fastConversion checkHangulEnding enableRecentOrdering customDictionary =
  Automation.methodID0 0xdd [Automation.inInt conversionsMode, Automation.inInt fastConversion, Automation.inInt checkHangulEnding, Automation.inInt enableRecentOrdering, Automation.inInt customDictionary]
-- --------------------------------------------------
-- 
-- interface ListFormat
-- 
-- --------------------------------------------------
data ListFormat a = ListFormat
                     
type IListFormat a = Automation.IDispatch (ListFormat a)
iidIListFormat :: Com.IID (IListFormat Automation.Interface)
iidIListFormat = Com.mkIID "{000209C0-0000-0000-C000-000000000046}"
getListLevelNumber :: Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getListLevelNumber =
  Automation.propertyGetID 0x44 [] Automation.outInt
setListLevelNumber :: Prelude.Int -> IListFormat a -> Prelude.IO ()
setListLevelNumber prop =
  Automation.propertySetID 0x44 [Automation.inInt prop]
getList :: IListFormat a -> Prelude.IO (IList Automation.Interface)
getList = Automation.propertyGetID 0x45 [] Automation.outIDispatch
getListTemplate :: Automation.IDispatch a -> Prelude.IO (IListTemplate Automation.Interface)
getListTemplate =
  Automation.propertyGetID 0x46 [] Automation.outIDispatch
getListValue :: IListFormat a -> Prelude.IO (Prelude.Int)
getListValue = Automation.propertyGetID 0x47 [] Automation.outInt
getSingleList :: IListFormat a -> Prelude.IO (Prelude.Int)
getSingleList = Automation.propertyGetID 0x48 [] Automation.outInt
getSingleListTemplate :: Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getSingleListTemplate =
  Automation.propertyGetID 0x49 [] Automation.outInt
getListType :: (Automation.Variant a0) => IListFormat a -> Prelude.IO (a0)
getListType =
  Automation.propertyGetID 0x4a [] Automation.outVariant
getListString :: IListFormat a -> Prelude.IO (Prelude.String)
getListString =
  Automation.propertyGetID 0x4b [] Automation.outString
canContinuePreviousList :: (Automation.Variant a1) => IListTemplate a0 -> Automation.IDispatch a -> Prelude.IO (a1)
canContinuePreviousList listTemplate =
  Automation.functionID1 0xb8 [Automation.inIDispatch listTemplate] Automation.outVariant
applyBulletDefault :: IListFormat a -> Prelude.IO ()
applyBulletDefault = Automation.methodID0 0xbc []
applyNumberDefault :: IListFormat a -> Prelude.IO ()
applyNumberDefault = Automation.methodID0 0xbd []
applyOutlineNumberDefault :: IListFormat a -> Prelude.IO ()
applyOutlineNumberDefault = Automation.methodID0 0xbe []
applyListTemplate :: IListTemplate a0 -> Prelude.Int -> Prelude.Int -> IListFormat a -> Prelude.IO ()
applyListTemplate listTemplate continuePreviousList applyTo =
  Automation.methodID0 0xbf [Automation.inIDispatch listTemplate, Automation.inInt continuePreviousList, Automation.inInt applyTo]
listOutdent :: IListFormat a -> Prelude.IO ()
listOutdent = Automation.methodID0 0xd2 []
listIndent :: IListFormat a -> Prelude.IO ()
listIndent = Automation.methodID0 0xd3 []
-- --------------------------------------------------
-- 
-- interface Find
-- 
-- --------------------------------------------------
data Find a = Find
               
type IFind a = Automation.IDispatch (Find a)
iidIFind :: Com.IID (IFind Automation.Interface)
iidIFind = Com.mkIID "{000209B0-0000-0000-C000-000000000046}"
getForward :: IFind a -> Prelude.IO (Prelude.Int)
getForward = Automation.propertyGetID 0xa [] Automation.outInt
setForward :: Prelude.Int -> IFind a -> Prelude.IO ()
setForward prop =
  Automation.propertySetID 0xa [Automation.inInt prop]
getFound :: Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getFound = Automation.propertyGetID 0xc [] Automation.outInt
getMatchAllWordForms :: IFind a -> Prelude.IO (Prelude.Int)
getMatchAllWordForms =
  Automation.propertyGetID 0xd [] Automation.outInt
setMatchAllWordForms :: Prelude.Int -> IFind a -> Prelude.IO ()
setMatchAllWordForms prop =
  Automation.propertySetID 0xd [Automation.inInt prop]
getMatchCase :: IFind a -> Prelude.IO (Prelude.Int)
getMatchCase = Automation.propertyGetID 0xe [] Automation.outInt
setMatchCase :: Prelude.Int -> IFind a -> Prelude.IO ()
setMatchCase prop =
  Automation.propertySetID 0xe [Automation.inInt prop]
getMatchWildcards :: IFind a -> Prelude.IO (Prelude.Int)
getMatchWildcards =
  Automation.propertyGetID 0xf [] Automation.outInt
setMatchWildcards :: Prelude.Int -> IFind a -> Prelude.IO ()
setMatchWildcards prop =
  Automation.propertySetID 0xf [Automation.inInt prop]
getMatchSoundsLike :: IFind a -> Prelude.IO (Prelude.Int)
getMatchSoundsLike =
  Automation.propertyGetID 0x10 [] Automation.outInt
setMatchSoundsLike :: Prelude.Int -> IFind a -> Prelude.IO ()
setMatchSoundsLike prop =
  Automation.propertySetID 0x10 [Automation.inInt prop]
getMatchWholeWord :: IFind a -> Prelude.IO (Prelude.Int)
getMatchWholeWord =
  Automation.propertyGetID 0x11 [] Automation.outInt
setMatchWholeWord :: Prelude.Int -> IFind a -> Prelude.IO ()
setMatchWholeWord prop =
  Automation.propertySetID 0x11 [Automation.inInt prop]
getMatchFuzzy :: IFind a -> Prelude.IO (Prelude.Int)
getMatchFuzzy = Automation.propertyGetID 0x28 [] Automation.outInt
setMatchFuzzy :: Prelude.Int -> IFind a -> Prelude.IO ()
setMatchFuzzy prop =
  Automation.propertySetID 0x28 [Automation.inInt prop]
getMatchByte :: IFind a -> Prelude.IO (Prelude.Int)
getMatchByte = Automation.propertyGetID 0x29 [] Automation.outInt
setMatchByte :: Prelude.Int -> IFind a -> Prelude.IO ()
setMatchByte prop =
  Automation.propertySetID 0x29 [Automation.inInt prop]
getHighlight :: Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getHighlight = Automation.propertyGetID 0x18 [] Automation.outInt
setHighlight :: Prelude.Int -> Automation.IDispatch a -> Prelude.IO ()
setHighlight prop =
  Automation.propertySetID 0x18 [Automation.inInt prop]
getReplacement :: IFind a -> Prelude.IO (IReplacement Automation.Interface)
getReplacement =
  Automation.propertyGetID 0x19 [] Automation.outIDispatch
getFrame :: Automation.IDispatch a -> Prelude.IO (IFrame Automation.Interface)
getFrame = Automation.propertyGetID 0x1a [] Automation.outIDispatch
getWrap :: (Automation.Variant a0) => IFind a -> Prelude.IO (a0)
getWrap = Automation.propertyGetID 0x1b [] Automation.outVariant
setWrap :: (Automation.Variant a0) => a0 -> IFind a -> Prelude.IO ()
setWrap prop =
  Automation.propertySetID 0x1b [Automation.inVariant prop]
getFormat :: IFind a -> Prelude.IO (Prelude.Int)
getFormat = Automation.propertyGetID 0x1c [] Automation.outInt
setFormat :: Prelude.Int -> IFind a -> Prelude.IO ()
setFormat prop =
  Automation.propertySetID 0x1c [Automation.inInt prop]
getCorrectHangulEndings :: IFind a -> Prelude.IO (Prelude.Int)
getCorrectHangulEndings =
  Automation.propertyGetID 0x3d [] Automation.outInt
setCorrectHangulEndings :: Prelude.Int -> IFind a -> Prelude.IO ()
setCorrectHangulEndings prop =
  Automation.propertySetID 0x3d [Automation.inInt prop]
execute :: Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> IFind a -> Prelude.IO (Prelude.Int)
execute findText matchCase matchWholeWord matchWildcards matchSoundsLike matchAllWordForms forward wrap format replaceWith replace =
  Automation.functionID1 0x1e [Automation.inInt findText, Automation.inInt matchCase, Automation.inInt matchWholeWord, Automation.inInt matchWildcards, Automation.inInt matchSoundsLike, Automation.inInt matchAllWordForms, Automation.inInt forward, Automation.inInt wrap, Automation.inInt format, Automation.inInt replaceWith, Automation.inInt replace] Automation.outInt
clearFormatting :: Automation.IDispatch a -> Prelude.IO ()
clearFormatting = Automation.methodID0 0x1f []
setAllFuzzyOptions :: IFind a -> Prelude.IO ()
setAllFuzzyOptions = Automation.methodID0 0x20 []
clearAllFuzzyOptions :: IFind a -> Prelude.IO ()
clearAllFuzzyOptions = Automation.methodID0 0x21 []
-- --------------------------------------------------
-- 
-- interface Replacement
-- 
-- --------------------------------------------------
data Replacement a = Replacement
                      
type IReplacement a = Automation.IDispatch (Replacement a)
iidIReplacement :: Com.IID (IReplacement Automation.Interface)
iidIReplacement =
  Com.mkIID "{000209B1-0000-0000-C000-000000000046}"
-- --------------------------------------------------
-- 
-- interface Characters
-- 
-- --------------------------------------------------
data Characters a = Characters
                     
type ICharacters a = Automation.IDispatch (Characters a)
iidICharacters :: Com.IID (ICharacters Automation.Interface)
iidICharacters = Com.mkIID "{0002095D-0000-0000-C000-000000000046}"
getFirst :: Automation.IDispatch a -> Prelude.IO (IRange Automation.Interface)
getFirst = Automation.propertyGetID 0x3 [] Automation.outIDispatch
getLast :: Automation.IDispatch a -> Prelude.IO (IRange Automation.Interface)
getLast = Automation.propertyGetID 0x4 [] Automation.outIDispatch
item8 :: Prelude.Int -> Automation.IDispatch a -> Prelude.IO (IRange Automation.Interface)
item8 idex =
  Automation.functionID1 0o0 [Automation.inInt idex] Automation.outIDispatch
-- --------------------------------------------------
-- 
-- interface Words
-- 
-- --------------------------------------------------
data Words a = Words
                
type IWords a = Automation.IDispatch (Words a)
iidIWords :: Com.IID (IWords Automation.Interface)
iidIWords = Com.mkIID "{0002095C-0000-0000-C000-000000000046}"
-- --------------------------------------------------
-- 
-- interface Sentences
-- 
-- --------------------------------------------------
data Sentences a = Sentences
                    
type ISentences a = Automation.IDispatch (Sentences a)
iidISentences :: Com.IID (ISentences Automation.Interface)
iidISentences = Com.mkIID "{0002095B-0000-0000-C000-000000000046}"
-- --------------------------------------------------
-- 
-- interface Sections
-- 
-- --------------------------------------------------
data Sections a = Sections
                   
type ISections a = Automation.IDispatch (Sections a)
iidISections :: Com.IID (ISections Automation.Interface)
iidISections = Com.mkIID "{0002095A-0000-0000-C000-000000000046}"
getFirst2 :: ISections a -> Prelude.IO (ISection Automation.Interface)
getFirst2 = Automation.propertyGetID 0x3 [] Automation.outIDispatch
getLast2 :: ISections a -> Prelude.IO (ISection Automation.Interface)
getLast2 = Automation.propertyGetID 0x4 [] Automation.outIDispatch
item11 :: Prelude.Int -> ISections a -> Prelude.IO (ISection Automation.Interface)
item11 idex =
  Automation.functionID1 0o0 [Automation.inInt idex] Automation.outIDispatch
add5 :: Prelude.Int -> Prelude.Int -> ISections a -> Prelude.IO (ISection Automation.Interface)
add5 range start =
  Automation.functionID1 0x5 [Automation.inInt range, Automation.inInt start] Automation.outIDispatch
-- --------------------------------------------------
-- 
-- interface Section
-- 
-- --------------------------------------------------
data Section a = Section
                  
type ISection a = Automation.IDispatch (Section a)
iidISection :: Com.IID (ISection Automation.Interface)
iidISection = Com.mkIID "{00020959-0000-0000-C000-000000000046}"
getHeaders :: ISection a -> Prelude.IO (IHeadersFooters Automation.Interface)
getHeaders =
  Automation.propertyGetID 0x79 [] Automation.outIDispatch
getFooters :: ISection a -> Prelude.IO (IHeadersFooters Automation.Interface)
getFooters =
  Automation.propertyGetID 0x7a [] Automation.outIDispatch
getProtectedForForms :: ISection a -> Prelude.IO (Prelude.Int)
getProtectedForForms =
  Automation.propertyGetID 0x7b [] Automation.outInt
setProtectedForForms :: Prelude.Int -> ISection a -> Prelude.IO ()
setProtectedForForms prop =
  Automation.propertySetID 0x7b [Automation.inInt prop]
-- --------------------------------------------------
-- 
-- interface Paragraphs
-- 
-- --------------------------------------------------
data Paragraphs a = Paragraphs
                     
type IParagraphs a = Automation.IDispatch (Paragraphs a)
iidIParagraphs :: Com.IID (IParagraphs Automation.Interface)
iidIParagraphs = Com.mkIID "{00020958-0000-0000-C000-000000000046}"
getFirst3 :: IParagraphs a -> Prelude.IO (IParagraph Automation.Interface)
getFirst3 = Automation.propertyGetID 0x3 [] Automation.outIDispatch
getLast3 :: IParagraphs a -> Prelude.IO (IParagraph Automation.Interface)
getLast3 = Automation.propertyGetID 0x4 [] Automation.outIDispatch
getFormat0 :: Automation.IDispatch a -> Prelude.IO (IParagraphFormat Automation.Interface)
getFormat0 =
  Automation.propertyGetID 0x44e [] Automation.outIDispatch
setFormat0 :: IParagraphFormat a0 -> Automation.IDispatch a -> Prelude.IO ()
setFormat0 prop =
  Automation.propertySetID 0x44e [Automation.inIDispatch prop]
getTabStops :: Automation.IDispatch a -> Prelude.IO (ITabStops Automation.Interface)
getTabStops =
  Automation.propertyGetID 0x44f [] Automation.outIDispatch
setTabStops :: ITabStops a0 -> Automation.IDispatch a -> Prelude.IO ()
setTabStops prop =
  Automation.propertySetID 0x44f [Automation.inIDispatch prop]
getAlignment :: (Automation.Variant a0) => Automation.IDispatch a -> Prelude.IO (a0)
getAlignment =
  Automation.propertyGetID 0x65 [] Automation.outVariant
setAlignment :: (Automation.Variant a0) => a0 -> Automation.IDispatch a -> Prelude.IO ()
setAlignment prop =
  Automation.propertySetID 0x65 [Automation.inVariant prop]
getKeepTogether :: Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getKeepTogether =
  Automation.propertyGetID 0x66 [] Automation.outInt
setKeepTogether :: Prelude.Int -> Automation.IDispatch a -> Prelude.IO ()
setKeepTogether prop =
  Automation.propertySetID 0x66 [Automation.inInt prop]
getKeepWithNext :: Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getKeepWithNext =
  Automation.propertyGetID 0x67 [] Automation.outInt
setKeepWithNext :: Prelude.Int -> Automation.IDispatch a -> Prelude.IO ()
setKeepWithNext prop =
  Automation.propertySetID 0x67 [Automation.inInt prop]
getPageBreakBefore :: Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getPageBreakBefore =
  Automation.propertyGetID 0x68 [] Automation.outInt
setPageBreakBefore :: Prelude.Int -> Automation.IDispatch a -> Prelude.IO ()
setPageBreakBefore prop =
  Automation.propertySetID 0x68 [Automation.inInt prop]
getNoLineNumber :: Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getNoLineNumber =
  Automation.propertyGetID 0x69 [] Automation.outInt
setNoLineNumber :: Prelude.Int -> Automation.IDispatch a -> Prelude.IO ()
setNoLineNumber prop =
  Automation.propertySetID 0x69 [Automation.inInt prop]
getRightIndent :: Automation.IDispatch a -> Prelude.IO (Prelude.Float)
getRightIndent =
  Automation.propertyGetID 0x6a [] Automation.outFloat
setRightIndent :: Prelude.Float -> Automation.IDispatch a -> Prelude.IO ()
setRightIndent prop =
  Automation.propertySetID 0x6a [Automation.inFloat prop]
getLeftIndent :: Automation.IDispatch a -> Prelude.IO (Prelude.Float)
getLeftIndent =
  Automation.propertyGetID 0x6b [] Automation.outFloat
setLeftIndent :: Prelude.Float -> Automation.IDispatch a -> Prelude.IO ()
setLeftIndent prop =
  Automation.propertySetID 0x6b [Automation.inFloat prop]
getFirstLineIndent :: Automation.IDispatch a -> Prelude.IO (Prelude.Float)
getFirstLineIndent =
  Automation.propertyGetID 0x6c [] Automation.outFloat
setFirstLineIndent :: Prelude.Float -> Automation.IDispatch a -> Prelude.IO ()
setFirstLineIndent prop =
  Automation.propertySetID 0x6c [Automation.inFloat prop]
getLineSpacing :: Automation.IDispatch a -> Prelude.IO (Prelude.Float)
getLineSpacing =
  Automation.propertyGetID 0x6d [] Automation.outFloat
setLineSpacing :: Prelude.Float -> Automation.IDispatch a -> Prelude.IO ()
setLineSpacing prop =
  Automation.propertySetID 0x6d [Automation.inFloat prop]
getLineSpacingRule :: (Automation.Variant a0) => Automation.IDispatch a -> Prelude.IO (a0)
getLineSpacingRule =
  Automation.propertyGetID 0x6e [] Automation.outVariant
setLineSpacingRule :: (Automation.Variant a0) => a0 -> Automation.IDispatch a -> Prelude.IO ()
setLineSpacingRule prop =
  Automation.propertySetID 0x6e [Automation.inVariant prop]
getSpaceBefore :: Automation.IDispatch a -> Prelude.IO (Prelude.Float)
getSpaceBefore =
  Automation.propertyGetID 0x6f [] Automation.outFloat
setSpaceBefore :: Prelude.Float -> Automation.IDispatch a -> Prelude.IO ()
setSpaceBefore prop =
  Automation.propertySetID 0x6f [Automation.inFloat prop]
getSpaceAfter :: Automation.IDispatch a -> Prelude.IO (Prelude.Float)
getSpaceAfter =
  Automation.propertyGetID 0x70 [] Automation.outFloat
setSpaceAfter :: Prelude.Float -> Automation.IDispatch a -> Prelude.IO ()
setSpaceAfter prop =
  Automation.propertySetID 0x70 [Automation.inFloat prop]
getHyphenation :: Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getHyphenation = Automation.propertyGetID 0x71 [] Automation.outInt
setHyphenation :: Prelude.Int -> Automation.IDispatch a -> Prelude.IO ()
setHyphenation prop =
  Automation.propertySetID 0x71 [Automation.inInt prop]
getWidowControl :: Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getWidowControl =
  Automation.propertyGetID 0x72 [] Automation.outInt
setWidowControl :: Prelude.Int -> Automation.IDispatch a -> Prelude.IO ()
setWidowControl prop =
  Automation.propertySetID 0x72 [Automation.inInt prop]
getFarEastLineBreakControl :: Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getFarEastLineBreakControl =
  Automation.propertyGetID 0x75 [] Automation.outInt
setFarEastLineBreakControl :: Prelude.Int -> Automation.IDispatch a -> Prelude.IO ()
setFarEastLineBreakControl prop =
  Automation.propertySetID 0x75 [Automation.inInt prop]
getWordWrap :: Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getWordWrap = Automation.propertyGetID 0x76 [] Automation.outInt
setWordWrap :: Prelude.Int -> Automation.IDispatch a -> Prelude.IO ()
setWordWrap prop =
  Automation.propertySetID 0x76 [Automation.inInt prop]
getHangingPunctuation :: Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getHangingPunctuation =
  Automation.propertyGetID 0x77 [] Automation.outInt
setHangingPunctuation :: Prelude.Int -> Automation.IDispatch a -> Prelude.IO ()
setHangingPunctuation prop =
  Automation.propertySetID 0x77 [Automation.inInt prop]
getHalfWidthPunctuationOnTopOfLine :: Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getHalfWidthPunctuationOnTopOfLine =
  Automation.propertyGetID 0x78 [] Automation.outInt
setHalfWidthPunctuationOnTopOfLine :: Prelude.Int -> Automation.IDispatch a -> Prelude.IO ()
setHalfWidthPunctuationOnTopOfLine prop =
  Automation.propertySetID 0x78 [Automation.inInt prop]
getAddSpaceBetweenFarEastAndAlpha :: Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getAddSpaceBetweenFarEastAndAlpha =
  Automation.propertyGetID 0x79 [] Automation.outInt
setAddSpaceBetweenFarEastAndAlpha :: Prelude.Int -> Automation.IDispatch a -> Prelude.IO ()
setAddSpaceBetweenFarEastAndAlpha prop =
  Automation.propertySetID 0x79 [Automation.inInt prop]
getAddSpaceBetweenFarEastAndDigit :: Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getAddSpaceBetweenFarEastAndDigit =
  Automation.propertyGetID 0x7a [] Automation.outInt
setAddSpaceBetweenFarEastAndDigit :: Prelude.Int -> Automation.IDispatch a -> Prelude.IO ()
setAddSpaceBetweenFarEastAndDigit prop =
  Automation.propertySetID 0x7a [Automation.inInt prop]
getBaseLineAlignment :: (Automation.Variant a0) => Automation.IDispatch a -> Prelude.IO (a0)
getBaseLineAlignment =
  Automation.propertyGetID 0x7b [] Automation.outVariant
setBaseLineAlignment :: (Automation.Variant a0) => a0 -> Automation.IDispatch a -> Prelude.IO ()
setBaseLineAlignment prop =
  Automation.propertySetID 0x7b [Automation.inVariant prop]
getAutoAdjustRightIndent :: Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getAutoAdjustRightIndent =
  Automation.propertyGetID 0x7c [] Automation.outInt
setAutoAdjustRightIndent :: Prelude.Int -> Automation.IDispatch a -> Prelude.IO ()
setAutoAdjustRightIndent prop =
  Automation.propertySetID 0x7c [Automation.inInt prop]
getDisableLineHeightGrid :: Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getDisableLineHeightGrid =
  Automation.propertyGetID 0x7d [] Automation.outInt
setDisableLineHeightGrid :: Prelude.Int -> Automation.IDispatch a -> Prelude.IO ()
setDisableLineHeightGrid prop =
  Automation.propertySetID 0x7d [Automation.inInt prop]
getOutlineLevel :: (Automation.Variant a0) => Automation.IDispatch a -> Prelude.IO (a0)
getOutlineLevel =
  Automation.propertyGetID 0xca [] Automation.outVariant
setOutlineLevel :: (Automation.Variant a0) => a0 -> Automation.IDispatch a -> Prelude.IO ()
setOutlineLevel prop =
  Automation.propertySetID 0xca [Automation.inVariant prop]
item12 :: Prelude.Int -> Automation.IDispatch a -> Prelude.IO (IParagraph Automation.Interface)
item12 idex =
  Automation.functionID1 0o0 [Automation.inInt idex] Automation.outIDispatch
add6 :: Prelude.Int -> IParagraphs a -> Prelude.IO (IParagraph Automation.Interface)
add6 range =
  Automation.functionID1 0x5 [Automation.inInt range] Automation.outIDispatch
closeUp :: Automation.IDispatch a -> Prelude.IO ()
closeUp = Automation.methodID0 0x12d []
openUp :: Automation.IDispatch a -> Prelude.IO ()
openUp = Automation.methodID0 0x12e []
openOrCloseUp :: Automation.IDispatch a -> Prelude.IO ()
openOrCloseUp = Automation.methodID0 0x12f []
tabHangingIndent :: Prelude.Int -> Automation.IDispatch a -> Prelude.IO ()
tabHangingIndent count =
  Automation.methodID0 0x130 [Automation.inInt count]
tabIndent :: Prelude.Int -> Automation.IDispatch a -> Prelude.IO ()
tabIndent count =
  Automation.methodID0 0x132 [Automation.inInt count]
space1 :: Automation.IDispatch a -> Prelude.IO ()
space1 = Automation.methodID0 0x139 []
space15 :: Automation.IDispatch a -> Prelude.IO ()
space15 = Automation.methodID0 0x13a []
space2 :: Automation.IDispatch a -> Prelude.IO ()
space2 = Automation.methodID0 0x13b []
indentCharWidth :: Prelude.Int -> Automation.IDispatch a -> Prelude.IO ()
indentCharWidth count =
  Automation.methodID0 0x140 [Automation.inInt count]
indentFirstLineCharWidth :: Prelude.Int -> Automation.IDispatch a -> Prelude.IO ()
indentFirstLineCharWidth count =
  Automation.methodID0 0x142 [Automation.inInt count]
outlinePromote :: Automation.IDispatch a -> Prelude.IO ()
outlinePromote = Automation.methodID0 0x144 []
outlineDemote :: Automation.IDispatch a -> Prelude.IO ()
outlineDemote = Automation.methodID0 0x145 []
outlineDemoteToBody :: Automation.IDispatch a -> Prelude.IO ()
outlineDemoteToBody = Automation.methodID0 0x146 []
indent :: Automation.IDispatch a -> Prelude.IO ()
indent = Automation.methodID0 0x14d []
outdent :: Automation.IDispatch a -> Prelude.IO ()
outdent = Automation.methodID0 0x14e []
-- --------------------------------------------------
-- 
-- interface Paragraph
-- 
-- --------------------------------------------------
data Paragraph a = Paragraph
                    
type IParagraph a = Automation.IDispatch (Paragraph a)
iidIParagraph :: Com.IID (IParagraph Automation.Interface)
iidIParagraph = Com.mkIID "{00020957-0000-0000-C000-000000000046}"
getDropCap :: IParagraph a -> Prelude.IO (IDropCap Automation.Interface)
getDropCap =
  Automation.propertyGetID 0xd [] Automation.outIDispatch
next0 :: Prelude.Int -> IParagraph a -> Prelude.IO (IParagraph Automation.Interface)
next0 count =
  Automation.functionID1 0x144 [Automation.inInt count] Automation.outIDispatch
previous0 :: Prelude.Int -> IParagraph a -> Prelude.IO (IParagraph Automation.Interface)
previous0 count =
  Automation.functionID1 0x145 [Automation.inInt count] Automation.outIDispatch
-- --------------------------------------------------
-- 
-- interface DropCap
-- 
-- --------------------------------------------------
data DropCap a = DropCap
                  
type IDropCap a = Automation.IDispatch (DropCap a)
iidIDropCap :: Com.IID (IDropCap Automation.Interface)
iidIDropCap = Com.mkIID "{00020956-0000-0000-C000-000000000046}"
getPosition :: (Automation.Variant a0) => IDropCap a -> Prelude.IO (a0)
getPosition = Automation.propertyGetID 0xa [] Automation.outVariant
setPosition :: (Automation.Variant a0) => a0 -> IDropCap a -> Prelude.IO ()
setPosition prop =
  Automation.propertySetID 0xa [Automation.inVariant prop]
getFontName :: Automation.IDispatch a -> Prelude.IO (Prelude.String)
getFontName = Automation.propertyGetID 0xb [] Automation.outString
setFontName :: Prelude.String -> Automation.IDispatch a -> Prelude.IO ()
setFontName prop =
  Automation.propertySetID 0xb [Automation.inString prop]
getLinesToDrop :: IDropCap a -> Prelude.IO (Prelude.Int)
getLinesToDrop = Automation.propertyGetID 0xc [] Automation.outInt
setLinesToDrop :: Prelude.Int -> IDropCap a -> Prelude.IO ()
setLinesToDrop prop =
  Automation.propertySetID 0xc [Automation.inInt prop]
getDistanceFromText :: Automation.IDispatch a -> Prelude.IO (Prelude.Float)
getDistanceFromText =
  Automation.propertyGetID 0xd [] Automation.outFloat
setDistanceFromText :: Prelude.Float -> Automation.IDispatch a -> Prelude.IO ()
setDistanceFromText prop =
  Automation.propertySetID 0xd [Automation.inFloat prop]
clear :: Automation.IDispatch a -> Prelude.IO ()
clear = Automation.methodID0 0x64 []
enable :: IDropCap a -> Prelude.IO ()
enable = Automation.methodID0 0x65 []
-- --------------------------------------------------
-- 
-- interface TabStops
-- 
-- --------------------------------------------------
data TabStops a = TabStops
                   
type ITabStops a = Automation.IDispatch (TabStops a)
iidITabStops :: Com.IID (ITabStops Automation.Interface)
iidITabStops = Com.mkIID "{00020955-0000-0000-C000-000000000046}"
item13 :: Prelude.Int -> ITabStops a -> Prelude.IO (ITabStop Automation.Interface)
item13 idex =
  Automation.functionID1 0o0 [Automation.inInt idex] Automation.outIDispatch
add7 :: Prelude.Float -> Prelude.Int -> Prelude.Int -> ITabStops a -> Prelude.IO (ITabStop Automation.Interface)
add7 position alignment leader =
  Automation.functionID1 0x64 [Automation.inFloat position, Automation.inInt alignment, Automation.inInt leader] Automation.outIDispatch
clearAll :: Automation.IDispatch a -> Prelude.IO ()
clearAll = Automation.methodID0 0x65 []
before :: Prelude.Float -> ITabStops a -> Prelude.IO (ITabStop Automation.Interface)
before position =
  Automation.functionID1 0x66 [Automation.inFloat position] Automation.outIDispatch
after :: Prelude.Float -> ITabStops a -> Prelude.IO (ITabStop Automation.Interface)
after position =
  Automation.functionID1 0x67 [Automation.inFloat position] Automation.outIDispatch
-- --------------------------------------------------
-- 
-- interface TabStop
-- 
-- --------------------------------------------------
data TabStop a = TabStop
                  
type ITabStop a = Automation.IDispatch (TabStop a)
iidITabStop :: Com.IID (ITabStop Automation.Interface)
iidITabStop = Com.mkIID "{00020954-0000-0000-C000-000000000046}"
getAlignment1 :: (Automation.Variant a0) => ITabStop a -> Prelude.IO (a0)
getAlignment1 =
  Automation.propertyGetID 0x64 [] Automation.outVariant
setAlignment1 :: (Automation.Variant a0) => a0 -> ITabStop a -> Prelude.IO ()
setAlignment1 prop =
  Automation.propertySetID 0x64 [Automation.inVariant prop]
getLeader :: (Automation.Variant a0) => ITabStop a -> Prelude.IO (a0)
getLeader = Automation.propertyGetID 0x65 [] Automation.outVariant
setLeader :: (Automation.Variant a0) => a0 -> ITabStop a -> Prelude.IO ()
setLeader prop =
  Automation.propertySetID 0x65 [Automation.inVariant prop]
getPosition0 :: ITabStop a -> Prelude.IO (Prelude.Float)
getPosition0 = Automation.propertyGetID 0x66 [] Automation.outFloat
setPosition0 :: Prelude.Float -> ITabStop a -> Prelude.IO ()
setPosition0 prop =
  Automation.propertySetID 0x66 [Automation.inFloat prop]
getCustomTab :: ITabStop a -> Prelude.IO (Prelude.Int)
getCustomTab = Automation.propertyGetID 0x67 [] Automation.outInt
getNext1 :: ITabStop a -> Prelude.IO (ITabStop Automation.Interface)
getNext1 = Automation.propertyGetID 0x68 [] Automation.outIDispatch
getPrevious1 :: ITabStop a -> Prelude.IO (ITabStop Automation.Interface)
getPrevious1 =
  Automation.propertyGetID 0x69 [] Automation.outIDispatch
-- --------------------------------------------------
-- 
-- interface ParagraphFormat
-- 
-- --------------------------------------------------
data ParagraphFormat a = ParagraphFormat
                          
type IParagraphFormat a = Automation.IDispatch (ParagraphFormat a)
iidIParagraphFormat :: Com.IID (IParagraphFormat Automation.Interface)
iidIParagraphFormat =
  Com.mkIID "{00020953-0000-0000-C000-000000000046}"
getDuplicate0 :: IParagraphFormat a -> Prelude.IO (IParagraphFormat Automation.Interface)
getDuplicate0 =
  Automation.propertyGetID 0xa [] Automation.outIDispatch
-- --------------------------------------------------
-- 
-- interface Font
-- 
-- --------------------------------------------------
data Font a = Font
               
type IFont a = Automation.IDispatch (Font a)
iidIFont :: Com.IID (IFont Automation.Interface)
iidIFont = Com.mkIID "{00020952-0000-0000-C000-000000000046}"
getDuplicate1 :: IFont a -> Prelude.IO (IFont Automation.Interface)
getDuplicate1 =
  Automation.propertyGetID 0xa [] Automation.outIDispatch
getHidden :: IFont a -> Prelude.IO (Prelude.Int)
getHidden = Automation.propertyGetID 0x84 [] Automation.outInt
setHidden :: Prelude.Int -> IFont a -> Prelude.IO ()
setHidden prop =
  Automation.propertySetID 0x84 [Automation.inInt prop]
getSmallCaps :: IFont a -> Prelude.IO (Prelude.Int)
getSmallCaps = Automation.propertyGetID 0x85 [] Automation.outInt
setSmallCaps :: Prelude.Int -> IFont a -> Prelude.IO ()
setSmallCaps prop =
  Automation.propertySetID 0x85 [Automation.inInt prop]
getAllCaps :: IFont a -> Prelude.IO (Prelude.Int)
getAllCaps = Automation.propertyGetID 0x86 [] Automation.outInt
setAllCaps :: Prelude.Int -> IFont a -> Prelude.IO ()
setAllCaps prop =
  Automation.propertySetID 0x86 [Automation.inInt prop]
getStrikeThrough :: IFont a -> Prelude.IO (Prelude.Int)
getStrikeThrough =
  Automation.propertyGetID 0x87 [] Automation.outInt
setStrikeThrough :: Prelude.Int -> IFont a -> Prelude.IO ()
setStrikeThrough prop =
  Automation.propertySetID 0x87 [Automation.inInt prop]
getDoubleStrikeThrough :: IFont a -> Prelude.IO (Prelude.Int)
getDoubleStrikeThrough =
  Automation.propertyGetID 0x88 [] Automation.outInt
setDoubleStrikeThrough :: Prelude.Int -> IFont a -> Prelude.IO ()
setDoubleStrikeThrough prop =
  Automation.propertySetID 0x88 [Automation.inInt prop]
getColorIndex :: (Automation.Variant a0) => Automation.IDispatch a -> Prelude.IO (a0)
getColorIndex =
  Automation.propertyGetID 0x89 [] Automation.outVariant
setColorIndex :: (Automation.Variant a0) => a0 -> Automation.IDispatch a -> Prelude.IO ()
setColorIndex prop =
  Automation.propertySetID 0x89 [Automation.inVariant prop]
getSubscript :: IFont a -> Prelude.IO (Prelude.Int)
getSubscript = Automation.propertyGetID 0x8a [] Automation.outInt
setSubscript :: Prelude.Int -> IFont a -> Prelude.IO ()
setSubscript prop =
  Automation.propertySetID 0x8a [Automation.inInt prop]
getSuperscript :: IFont a -> Prelude.IO (Prelude.Int)
getSuperscript = Automation.propertyGetID 0x8b [] Automation.outInt
setSuperscript :: Prelude.Int -> IFont a -> Prelude.IO ()
setSuperscript prop =
  Automation.propertySetID 0x8b [Automation.inInt prop]
getSize :: Automation.IDispatch a -> Prelude.IO (Prelude.Float)
getSize = Automation.propertyGetID 0x8d [] Automation.outFloat
setSize :: Prelude.Float -> Automation.IDispatch a -> Prelude.IO ()
setSize prop =
  Automation.propertySetID 0x8d [Automation.inFloat prop]
setName :: Prelude.String -> Automation.IDispatch a -> Prelude.IO ()
setName prop =
  Automation.propertySetID 0x8e [Automation.inString prop]
getPosition1 :: IFont a -> Prelude.IO (Prelude.Int)
getPosition1 = Automation.propertyGetID 0x8f [] Automation.outInt
setPosition1 :: Prelude.Int -> IFont a -> Prelude.IO ()
setPosition1 prop =
  Automation.propertySetID 0x8f [Automation.inInt prop]
getSpacing :: Automation.IDispatch a -> Prelude.IO (Prelude.Float)
getSpacing = Automation.propertyGetID 0x90 [] Automation.outFloat
setSpacing :: Prelude.Float -> Automation.IDispatch a -> Prelude.IO ()
setSpacing prop =
  Automation.propertySetID 0x90 [Automation.inFloat prop]
getScaling :: IFont a -> Prelude.IO (Prelude.Int)
getScaling = Automation.propertyGetID 0x91 [] Automation.outInt
setScaling :: Prelude.Int -> IFont a -> Prelude.IO ()
setScaling prop =
  Automation.propertySetID 0x91 [Automation.inInt prop]
getShadow :: IFont a -> Prelude.IO (Prelude.Int)
getShadow = Automation.propertyGetID 0x92 [] Automation.outInt
setShadow :: Prelude.Int -> IFont a -> Prelude.IO ()
setShadow prop =
  Automation.propertySetID 0x92 [Automation.inInt prop]
getOutline :: IFont a -> Prelude.IO (Prelude.Int)
getOutline = Automation.propertyGetID 0x93 [] Automation.outInt
setOutline :: Prelude.Int -> IFont a -> Prelude.IO ()
setOutline prop =
  Automation.propertySetID 0x93 [Automation.inInt prop]
getEmboss :: IFont a -> Prelude.IO (Prelude.Int)
getEmboss = Automation.propertyGetID 0x94 [] Automation.outInt
setEmboss :: Prelude.Int -> IFont a -> Prelude.IO ()
setEmboss prop =
  Automation.propertySetID 0x94 [Automation.inInt prop]
getKerning :: IFont a -> Prelude.IO (Prelude.Float)
getKerning = Automation.propertyGetID 0x95 [] Automation.outFloat
setKerning :: Prelude.Float -> IFont a -> Prelude.IO ()
setKerning prop =
  Automation.propertySetID 0x95 [Automation.inFloat prop]
getEngrave :: IFont a -> Prelude.IO (Prelude.Int)
getEngrave = Automation.propertyGetID 0x96 [] Automation.outInt
setEngrave :: Prelude.Int -> IFont a -> Prelude.IO ()
setEngrave prop =
  Automation.propertySetID 0x96 [Automation.inInt prop]
getAnimation :: (Automation.Variant a0) => IFont a -> Prelude.IO (a0)
getAnimation =
  Automation.propertyGetID 0x97 [] Automation.outVariant
setAnimation :: (Automation.Variant a0) => a0 -> IFont a -> Prelude.IO ()
setAnimation prop =
  Automation.propertySetID 0x97 [Automation.inVariant prop]
getNameFarEast :: IFont a -> Prelude.IO (Prelude.String)
getNameFarEast =
  Automation.propertyGetID 0x9c [] Automation.outString
setNameFarEast :: Prelude.String -> IFont a -> Prelude.IO ()
setNameFarEast prop =
  Automation.propertySetID 0x9c [Automation.inString prop]
getNameAscii :: IFont a -> Prelude.IO (Prelude.String)
getNameAscii =
  Automation.propertyGetID 0x9d [] Automation.outString
setNameAscii :: Prelude.String -> IFont a -> Prelude.IO ()
setNameAscii prop =
  Automation.propertySetID 0x9d [Automation.inString prop]
getNameOther :: IFont a -> Prelude.IO (Prelude.String)
getNameOther =
  Automation.propertyGetID 0x9e [] Automation.outString
setNameOther :: Prelude.String -> IFont a -> Prelude.IO ()
setNameOther prop =
  Automation.propertySetID 0x9e [Automation.inString prop]
grow :: IFont a -> Prelude.IO ()
grow = Automation.methodID0 0x64 []
shrink :: Automation.IDispatch a -> Prelude.IO ()
shrink = Automation.methodID0 0x65 []
setAsTemplateDefault :: Automation.IDispatch a -> Prelude.IO ()
setAsTemplateDefault = Automation.methodID0 0x67 []
-- --------------------------------------------------
-- 
-- interface Table
-- 
-- --------------------------------------------------
data Table a = Table
                
type ITable a = Automation.IDispatch (Table a)
iidITable :: Com.IID (ITable Automation.Interface)
iidITable = Com.mkIID "{00020951-0000-0000-C000-000000000046}"
getUniform :: ITable a -> Prelude.IO (Prelude.Int)
getUniform = Automation.propertyGetID 0x69 [] Automation.outInt
getAutoFormatType :: ITable a -> Prelude.IO (Prelude.Int)
getAutoFormatType =
  Automation.propertyGetID 0x6a [] Automation.outInt
sort0 :: Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Automation.IDispatch a -> Prelude.IO ()
sort0 excludeHeader fieldNumber sortFieldType sortOrder fieldNumber2 sortFieldType2 sortOrder2 fieldNumber3 sortFieldType3 sortOrder3 caseSensitive languageID =
  Automation.methodID0 0xa [Automation.inInt excludeHeader, Automation.inInt fieldNumber, Automation.inInt sortFieldType, Automation.inInt sortOrder, Automation.inInt fieldNumber2, Automation.inInt sortFieldType2, Automation.inInt sortOrder2, Automation.inInt fieldNumber3, Automation.inInt sortFieldType3, Automation.inInt sortOrder3, Automation.inInt caseSensitive, Automation.inInt languageID]
autoFormat1 :: Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Automation.IDispatch a -> Prelude.IO ()
autoFormat1 format applyBorders applyShading applyFont applyColor applyHeadingRows applyLastRow applyFirstColumn applyLastColumn autoFit =
  Automation.methodID0 0xe [Automation.inInt format, Automation.inInt applyBorders, Automation.inInt applyShading, Automation.inInt applyFont, Automation.inInt applyColor, Automation.inInt applyHeadingRows, Automation.inInt applyLastRow, Automation.inInt applyFirstColumn, Automation.inInt applyLastColumn, Automation.inInt autoFit]
updateAutoFormat :: ITable a -> Prelude.IO ()
updateAutoFormat = Automation.methodID0 0xf []
convertToText :: Prelude.Int -> Automation.IDispatch a -> Prelude.IO (IRange Automation.Interface)
convertToText separator =
  Automation.functionID1 0x10 [Automation.inInt separator] Automation.outIDispatch
cell :: Prelude.Int -> Prelude.Int -> ITable a -> Prelude.IO (ICell Automation.Interface)
cell row column =
  Automation.functionID1 0x11 [Automation.inInt row, Automation.inInt column] Automation.outIDispatch
split :: Prelude.Int -> ITable a -> Prelude.IO (ITable Automation.Interface)
split beforeRow =
  Automation.functionID1 0x12 [Automation.inInt beforeRow] Automation.outIDispatch
-- --------------------------------------------------
-- 
-- interface Row
-- 
-- --------------------------------------------------
data Row a = Row
              
type IRow a = Automation.IDispatch (Row a)
iidIRow :: Com.IID (IRow Automation.Interface)
iidIRow = Com.mkIID "{00020950-0000-0000-C000-000000000046}"
getAllowBreakAcrossPages :: Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getAllowBreakAcrossPages =
  Automation.propertyGetID 0x3 [] Automation.outInt
setAllowBreakAcrossPages :: Prelude.Int -> Automation.IDispatch a -> Prelude.IO ()
setAllowBreakAcrossPages prop =
  Automation.propertySetID 0x3 [Automation.inInt prop]
getAlignment3 :: (Automation.Variant a0) => Automation.IDispatch a -> Prelude.IO (a0)
getAlignment3 =
  Automation.propertyGetID 0x4 [] Automation.outVariant
setAlignment3 :: (Automation.Variant a0) => a0 -> Automation.IDispatch a -> Prelude.IO ()
setAlignment3 prop =
  Automation.propertySetID 0x4 [Automation.inVariant prop]
getHeadingFormat :: Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getHeadingFormat =
  Automation.propertyGetID 0x5 [] Automation.outInt
setHeadingFormat :: Prelude.Int -> Automation.IDispatch a -> Prelude.IO ()
setHeadingFormat prop =
  Automation.propertySetID 0x5 [Automation.inInt prop]
getSpaceBetweenColumns :: Automation.IDispatch a -> Prelude.IO (Prelude.Float)
getSpaceBetweenColumns =
  Automation.propertyGetID 0x6 [] Automation.outFloat
setSpaceBetweenColumns :: Prelude.Float -> Automation.IDispatch a -> Prelude.IO ()
setSpaceBetweenColumns prop =
  Automation.propertySetID 0x6 [Automation.inFloat prop]
getHeight1 :: Automation.IDispatch a -> Prelude.IO (Prelude.Float)
getHeight1 = Automation.propertyGetID 0x7 [] Automation.outFloat
setHeight1 :: Prelude.Float -> Automation.IDispatch a -> Prelude.IO ()
setHeight1 prop =
  Automation.propertySetID 0x7 [Automation.inFloat prop]
getHeightRule :: (Automation.Variant a0) => Automation.IDispatch a -> Prelude.IO (a0)
getHeightRule =
  Automation.propertyGetID 0x8 [] Automation.outVariant
setHeightRule :: (Automation.Variant a0) => a0 -> Automation.IDispatch a -> Prelude.IO ()
setHeightRule prop =
  Automation.propertySetID 0x8 [Automation.inVariant prop]
getIsLast :: Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getIsLast = Automation.propertyGetID 0xa [] Automation.outInt
getIsFirst :: Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getIsFirst = Automation.propertyGetID 0xb [] Automation.outInt
getNext2 :: IRow a -> Prelude.IO (IRow Automation.Interface)
getNext2 = Automation.propertyGetID 0x68 [] Automation.outIDispatch
getPrevious2 :: IRow a -> Prelude.IO (IRow Automation.Interface)
getPrevious2 =
  Automation.propertyGetID 0x69 [] Automation.outIDispatch
setLeftIndent3 :: (Automation.Variant a0) => Prelude.Float -> a0 -> Automation.IDispatch a -> Prelude.IO ()
setLeftIndent3 leftIndent rulerStyle =
  Automation.methodID0 0xca [Automation.inFloat leftIndent, Automation.inVariant rulerStyle]
setHeight2 :: (Automation.Variant a0) => Prelude.Float -> a0 -> Automation.IDispatch a -> Prelude.IO ()
setHeight2 rowHeight heightRule =
  Automation.methodID0 0xcb [Automation.inFloat rowHeight, Automation.inVariant heightRule]
-- --------------------------------------------------
-- 
-- interface Column
-- 
-- --------------------------------------------------
data Column a = Column
                 
type IColumn a = Automation.IDispatch (Column a)
iidIColumn :: Com.IID (IColumn Automation.Interface)
iidIColumn = Com.mkIID "{0002094F-0000-0000-C000-000000000046}"
getWidth1 :: Automation.IDispatch a -> Prelude.IO (Prelude.Float)
getWidth1 = Automation.propertyGetID 0x3 [] Automation.outFloat
setWidth1 :: Prelude.Float -> Automation.IDispatch a -> Prelude.IO ()
setWidth1 prop =
  Automation.propertySetID 0x3 [Automation.inFloat prop]
getNext3 :: IColumn a -> Prelude.IO (IColumn Automation.Interface)
getNext3 = Automation.propertyGetID 0x67 [] Automation.outIDispatch
getPrevious3 :: IColumn a -> Prelude.IO (IColumn Automation.Interface)
getPrevious3 =
  Automation.propertyGetID 0x68 [] Automation.outIDispatch
setWidth2 :: (Automation.Variant a0) => Prelude.Float -> a0 -> Automation.IDispatch a -> Prelude.IO ()
setWidth2 columnWidth rulerStyle =
  Automation.methodID0 0xc9 [Automation.inFloat columnWidth, Automation.inVariant rulerStyle]
autoFit :: Automation.IDispatch a -> Prelude.IO ()
autoFit = Automation.methodID0 0xca []
sort1 :: Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Automation.IDispatch a -> Prelude.IO ()
sort1 excludeHeader sortFieldType sortOrder caseSensitive languageID =
  Automation.methodID0 0xcb [Automation.inInt excludeHeader, Automation.inInt sortFieldType, Automation.inInt sortOrder, Automation.inInt caseSensitive, Automation.inInt languageID]
-- --------------------------------------------------
-- 
-- interface Cell
-- 
-- --------------------------------------------------
data Cell a = Cell
               
type ICell a = Automation.IDispatch (Cell a)
iidICell :: Com.IID (ICell Automation.Interface)
iidICell = Com.mkIID "{0002094E-0000-0000-C000-000000000046}"
getRowIndex :: ICell a -> Prelude.IO (Prelude.Int)
getRowIndex = Automation.propertyGetID 0x4 [] Automation.outInt
getColumnIndex :: ICell a -> Prelude.IO (Prelude.Int)
getColumnIndex = Automation.propertyGetID 0x5 [] Automation.outInt
getVerticalAlignment :: (Automation.Variant a0) => Automation.IDispatch a -> Prelude.IO (a0)
getVerticalAlignment =
  Automation.propertyGetID 0x450 [] Automation.outVariant
setVerticalAlignment :: (Automation.Variant a0) => a0 -> Automation.IDispatch a -> Prelude.IO ()
setVerticalAlignment prop =
  Automation.propertySetID 0x450 [Automation.inVariant prop]
getColumn0 :: ICell a -> Prelude.IO (IColumn Automation.Interface)
getColumn0 =
  Automation.propertyGetID 0x65 [] Automation.outIDispatch
getRow :: ICell a -> Prelude.IO (IRow Automation.Interface)
getRow = Automation.propertyGetID 0x66 [] Automation.outIDispatch
getNext4 :: ICell a -> Prelude.IO (ICell Automation.Interface)
getNext4 = Automation.propertyGetID 0x67 [] Automation.outIDispatch
getPrevious4 :: ICell a -> Prelude.IO (ICell Automation.Interface)
getPrevious4 =
  Automation.propertyGetID 0x68 [] Automation.outIDispatch
delete6 :: Prelude.Int -> Automation.IDispatch a -> Prelude.IO ()
delete6 shiftCells =
  Automation.methodID0 0xc8 [Automation.inInt shiftCells]
formula :: Prelude.Int -> Prelude.Int -> ICell a -> Prelude.IO ()
formula formula numFormat =
  Automation.methodID0 0xc9 [Automation.inInt formula, Automation.inInt numFormat]
setHeight4 :: (Automation.Variant a0) => Prelude.Int -> a0 -> Automation.IDispatch a -> Prelude.IO ()
setHeight4 rowHeight heightRule =
  Automation.methodID0 0xcb [Automation.inInt rowHeight, Automation.inVariant heightRule]
merge0 :: ICell a0 -> ICell a -> Prelude.IO ()
merge0 mergeTo =
  Automation.methodID0 0xcc [Automation.inIDispatch mergeTo]
split0 :: Prelude.Int -> Prelude.Int -> ICell a -> Prelude.IO ()
split0 numRows numColumns =
  Automation.methodID0 0xcd [Automation.inInt numRows, Automation.inInt numColumns]
autoSum :: ICell a -> Prelude.IO ()
autoSum = Automation.methodID0 0xce []
-- --------------------------------------------------
-- 
-- interface Tables
-- 
-- --------------------------------------------------
data Tables a = Tables
                 
type ITables a = Automation.IDispatch (Tables a)
iidITables :: Com.IID (ITables Automation.Interface)
iidITables = Com.mkIID "{0002094D-0000-0000-C000-000000000046}"
item14 :: Prelude.Int -> ITables a -> Prelude.IO (ITable Automation.Interface)
item14 idex =
  Automation.functionID1 0o0 [Automation.inInt idex] Automation.outIDispatch
add8 :: IRange a0 -> Prelude.Int -> Prelude.Int -> ITables a -> Prelude.IO (ITable Automation.Interface)
add8 range numRows numColumns =
  Automation.functionID1 0x4 [Automation.inIDispatch range, Automation.inInt numRows, Automation.inInt numColumns] Automation.outIDispatch
-- --------------------------------------------------
-- 
-- interface Rows
-- 
-- --------------------------------------------------
data Rows a = Rows
               
type IRows a = Automation.IDispatch (Rows a)
iidIRows :: Com.IID (IRows Automation.Interface)
iidIRows = Com.mkIID "{0002094C-0000-0000-C000-000000000046}"
getFirst4 :: IRows a -> Prelude.IO (IRow Automation.Interface)
getFirst4 = Automation.propertyGetID 0xa [] Automation.outIDispatch
getLast4 :: IRows a -> Prelude.IO (IRow Automation.Interface)
getLast4 = Automation.propertyGetID 0xb [] Automation.outIDispatch
item15 :: Prelude.Int -> IRows a -> Prelude.IO (IRow Automation.Interface)
item15 idex =
  Automation.functionID1 0o0 [Automation.inInt idex] Automation.outIDispatch
add9 :: Prelude.Int -> IRows a -> Prelude.IO (IRow Automation.Interface)
add9 beforeRow =
  Automation.functionID1 0x64 [Automation.inInt beforeRow] Automation.outIDispatch
distributeHeight :: Automation.IDispatch a -> Prelude.IO ()
distributeHeight = Automation.methodID0 0xce []
-- --------------------------------------------------
-- 
-- interface Columns
-- 
-- --------------------------------------------------
data Columns a = Columns
                  
type IColumns a = Automation.IDispatch (Columns a)
iidIColumns :: Com.IID (IColumns Automation.Interface)
iidIColumns = Com.mkIID "{0002094B-0000-0000-C000-000000000046}"
getFirst5 :: IColumns a -> Prelude.IO (IColumn Automation.Interface)
getFirst5 =
  Automation.propertyGetID 0x64 [] Automation.outIDispatch
getLast5 :: IColumns a -> Prelude.IO (IColumn Automation.Interface)
getLast5 = Automation.propertyGetID 0x65 [] Automation.outIDispatch
item16 :: Prelude.Int -> IColumns a -> Prelude.IO (IColumn Automation.Interface)
item16 idex =
  Automation.functionID1 0o0 [Automation.inInt idex] Automation.outIDispatch
add10 :: Prelude.Int -> IColumns a -> Prelude.IO (IColumn Automation.Interface)
add10 beforeColumn =
  Automation.functionID1 0x5 [Automation.inInt beforeColumn] Automation.outIDispatch
distributeWidth :: Automation.IDispatch a -> Prelude.IO ()
distributeWidth = Automation.methodID0 0xcb []
-- --------------------------------------------------
-- 
-- interface Cells
-- 
-- --------------------------------------------------
data Cells a = Cells
                
type ICells a = Automation.IDispatch (Cells a)
iidICells :: Com.IID (ICells Automation.Interface)
iidICells = Com.mkIID "{0002094A-0000-0000-C000-000000000046}"
item17 :: Prelude.Int -> ICells a -> Prelude.IO (ICell Automation.Interface)
item17 idex =
  Automation.functionID1 0o0 [Automation.inInt idex] Automation.outIDispatch
add11 :: Prelude.Int -> ICells a -> Prelude.IO (ICell Automation.Interface)
add11 beforeCell =
  Automation.functionID1 0x4 [Automation.inInt beforeCell] Automation.outIDispatch
merge1 :: Automation.IDispatch a -> Prelude.IO ()
merge1 = Automation.methodID0 0xcc []
split1 :: Prelude.Int -> Prelude.Int -> Prelude.Int -> Automation.IDispatch a -> Prelude.IO ()
split1 numRows numColumns mergeBeforeSplit =
  Automation.methodID0 0xcd [Automation.inInt numRows, Automation.inInt numColumns, Automation.inInt mergeBeforeSplit]
-- --------------------------------------------------
-- 
-- interface AutoCorrect
-- 
-- --------------------------------------------------
data AutoCorrect a = AutoCorrect
                      
type IAutoCorrect a = Automation.IDispatch (AutoCorrect a)
iidIAutoCorrect :: Com.IID (IAutoCorrect Automation.Interface)
iidIAutoCorrect =
  Com.mkIID "{00020949-0000-0000-C000-000000000046}"
getCorrectDays :: IAutoCorrect a -> Prelude.IO (Prelude.Int)
getCorrectDays = Automation.propertyGetID 0x1 [] Automation.outInt
setCorrectDays :: Prelude.Int -> IAutoCorrect a -> Prelude.IO ()
setCorrectDays prop =
  Automation.propertySetID 0x1 [Automation.inInt prop]
getCorrectInitialCaps :: IAutoCorrect a -> Prelude.IO (Prelude.Int)
getCorrectInitialCaps =
  Automation.propertyGetID 0x2 [] Automation.outInt
setCorrectInitialCaps :: Prelude.Int -> IAutoCorrect a -> Prelude.IO ()
setCorrectInitialCaps prop =
  Automation.propertySetID 0x2 [Automation.inInt prop]
getCorrectSentenceCaps :: IAutoCorrect a -> Prelude.IO (Prelude.Int)
getCorrectSentenceCaps =
  Automation.propertyGetID 0x3 [] Automation.outInt
setCorrectSentenceCaps :: Prelude.Int -> IAutoCorrect a -> Prelude.IO ()
setCorrectSentenceCaps prop =
  Automation.propertySetID 0x3 [Automation.inInt prop]
getReplaceText :: IAutoCorrect a -> Prelude.IO (Prelude.Int)
getReplaceText = Automation.propertyGetID 0x4 [] Automation.outInt
setReplaceText :: Prelude.Int -> IAutoCorrect a -> Prelude.IO ()
setReplaceText prop =
  Automation.propertySetID 0x4 [Automation.inInt prop]
getEntries :: IAutoCorrect a -> Prelude.IO (IAutoCorrectEntries Automation.Interface)
getEntries =
  Automation.propertyGetID 0x6 [] Automation.outIDispatch
getFirstLetterExceptions :: IAutoCorrect a -> Prelude.IO (IFirstLetterExceptions Automation.Interface)
getFirstLetterExceptions =
  Automation.propertyGetID 0x7 [] Automation.outIDispatch
getFirstLetterAutoAdd :: IAutoCorrect a -> Prelude.IO (Prelude.Int)
getFirstLetterAutoAdd =
  Automation.propertyGetID 0x8 [] Automation.outInt
setFirstLetterAutoAdd :: Prelude.Int -> IAutoCorrect a -> Prelude.IO ()
setFirstLetterAutoAdd prop =
  Automation.propertySetID 0x8 [Automation.inInt prop]
getTwoInitialCapsExceptions :: IAutoCorrect a -> Prelude.IO (ITwoInitialCapsExceptions Automation.Interface)
getTwoInitialCapsExceptions =
  Automation.propertyGetID 0x9 [] Automation.outIDispatch
getTwoInitialCapsAutoAdd :: IAutoCorrect a -> Prelude.IO (Prelude.Int)
getTwoInitialCapsAutoAdd =
  Automation.propertyGetID 0xa [] Automation.outInt
setTwoInitialCapsAutoAdd :: Prelude.Int -> IAutoCorrect a -> Prelude.IO ()
setTwoInitialCapsAutoAdd prop =
  Automation.propertySetID 0xa [Automation.inInt prop]
getCorrectCapsLock :: IAutoCorrect a -> Prelude.IO (Prelude.Int)
getCorrectCapsLock =
  Automation.propertyGetID 0xb [] Automation.outInt
setCorrectCapsLock :: Prelude.Int -> IAutoCorrect a -> Prelude.IO ()
setCorrectCapsLock prop =
  Automation.propertySetID 0xb [Automation.inInt prop]
getCorrectHangulAndAlphabet :: IAutoCorrect a -> Prelude.IO (Prelude.Int)
getCorrectHangulAndAlphabet =
  Automation.propertyGetID 0xc [] Automation.outInt
setCorrectHangulAndAlphabet :: Prelude.Int -> IAutoCorrect a -> Prelude.IO ()
setCorrectHangulAndAlphabet prop =
  Automation.propertySetID 0xc [Automation.inInt prop]
getHangulAndAlphabetExceptions :: IAutoCorrect a -> Prelude.IO (IHangulAndAlphabetExceptions Automation.Interface)
getHangulAndAlphabetExceptions =
  Automation.propertyGetID 0xd [] Automation.outIDispatch
getHangulAndAlphabetAutoAdd :: IAutoCorrect a -> Prelude.IO (Prelude.Int)
getHangulAndAlphabetAutoAdd =
  Automation.propertyGetID 0xe [] Automation.outInt
setHangulAndAlphabetAutoAdd :: Prelude.Int -> IAutoCorrect a -> Prelude.IO ()
setHangulAndAlphabetAutoAdd prop =
  Automation.propertySetID 0xe [Automation.inInt prop]
-- --------------------------------------------------
-- 
-- interface AutoCorrectEntries
-- 
-- --------------------------------------------------
data AutoCorrectEntries a = AutoCorrectEntries
                             
type IAutoCorrectEntries a = Automation.IDispatch (AutoCorrectEntries a)
iidIAutoCorrectEntries :: Com.IID (IAutoCorrectEntries Automation.Interface)
iidIAutoCorrectEntries =
  Com.mkIID "{00020948-0000-0000-C000-000000000046}"
item18 :: Prelude.Int -> IAutoCorrectEntries a -> Prelude.IO (IAutoCorrectEntry Automation.Interface)
item18 idex =
  Automation.functionID1 0o0 [Automation.inInt idex] Automation.outIDispatch
add12 :: Prelude.String -> Prelude.String -> IAutoCorrectEntries a -> Prelude.IO (IAutoCorrectEntry Automation.Interface)
add12 name value =
  Automation.functionID1 0x65 [Automation.inString name, Automation.inString value] Automation.outIDispatch
addRichText :: Prelude.String -> IRange a0 -> IAutoCorrectEntries a -> Prelude.IO (IAutoCorrectEntry Automation.Interface)
addRichText name range =
  Automation.functionID1 0x66 [Automation.inString name, Automation.inIDispatch range] Automation.outIDispatch
-- --------------------------------------------------
-- 
-- interface AutoCorrectEntry
-- 
-- --------------------------------------------------
data AutoCorrectEntry a = AutoCorrectEntry
                           
type IAutoCorrectEntry a = Automation.IDispatch (AutoCorrectEntry a)
iidIAutoCorrectEntry :: Com.IID (IAutoCorrectEntry Automation.Interface)
iidIAutoCorrectEntry =
  Com.mkIID "{00020947-0000-0000-C000-000000000046}"
getRichText :: IAutoCorrectEntry a -> Prelude.IO (Prelude.Int)
getRichText = Automation.propertyGetID 0x4 [] Automation.outInt
apply :: IRange a0 -> IAutoCorrectEntry a -> Prelude.IO ()
apply range =
  Automation.methodID0 0x66 [Automation.inIDispatch range]
-- --------------------------------------------------
-- 
-- interface FirstLetterExceptions
-- 
-- --------------------------------------------------
data FirstLetterExceptions a = FirstLetterExceptions
                                
type IFirstLetterExceptions a = Automation.IDispatch (FirstLetterExceptions a)
iidIFirstLetterExceptions :: Com.IID (IFirstLetterExceptions Automation.Interface)
iidIFirstLetterExceptions =
  Com.mkIID "{00020946-0000-0000-C000-000000000046}"
item19 :: Prelude.Int -> IFirstLetterExceptions a -> Prelude.IO (IFirstLetterException Automation.Interface)
item19 idex =
  Automation.functionID1 0o0 [Automation.inInt idex] Automation.outIDispatch
add13 :: Prelude.String -> IFirstLetterExceptions a -> Prelude.IO (IFirstLetterException Automation.Interface)
add13 name =
  Automation.functionID1 0x65 [Automation.inString name] Automation.outIDispatch
-- --------------------------------------------------
-- 
-- interface FirstLetterException
-- 
-- --------------------------------------------------
data FirstLetterException a = FirstLetterException
                               
type IFirstLetterException a = Automation.IDispatch (FirstLetterException a)
iidIFirstLetterException :: Com.IID (IFirstLetterException Automation.Interface)
iidIFirstLetterException =
  Com.mkIID "{00020945-0000-0000-C000-000000000046}"
-- --------------------------------------------------
-- 
-- interface TwoInitialCapsExceptions
-- 
-- --------------------------------------------------
data TwoInitialCapsExceptions a = TwoInitialCapsExceptions
                                   
type ITwoInitialCapsExceptions a = Automation.IDispatch (TwoInitialCapsExceptions a)
iidITwoInitialCapsExceptions :: Com.IID (ITwoInitialCapsExceptions Automation.Interface)
iidITwoInitialCapsExceptions =
  Com.mkIID "{00020944-0000-0000-C000-000000000046}"
item20 :: Prelude.Int -> ITwoInitialCapsExceptions a -> Prelude.IO (ITwoInitialCapsException Automation.Interface)
item20 idex =
  Automation.functionID1 0o0 [Automation.inInt idex] Automation.outIDispatch
add14 :: Prelude.String -> ITwoInitialCapsExceptions a -> Prelude.IO (ITwoInitialCapsException Automation.Interface)
add14 name =
  Automation.functionID1 0x65 [Automation.inString name] Automation.outIDispatch
-- --------------------------------------------------
-- 
-- interface TwoInitialCapsException
-- 
-- --------------------------------------------------
data TwoInitialCapsException a = TwoInitialCapsException
                                  
type ITwoInitialCapsException a = Automation.IDispatch (TwoInitialCapsException a)
iidITwoInitialCapsException :: Com.IID (ITwoInitialCapsException Automation.Interface)
iidITwoInitialCapsException =
  Com.mkIID "{00020943-0000-0000-C000-000000000046}"
-- --------------------------------------------------
-- 
-- interface Footnotes
-- 
-- --------------------------------------------------
data Footnotes a = Footnotes
                    
type IFootnotes a = Automation.IDispatch (Footnotes a)
iidIFootnotes :: Com.IID (IFootnotes Automation.Interface)
iidIFootnotes = Com.mkIID "{00020942-0000-0000-C000-000000000046}"
getLocation :: (Automation.Variant a0) => IFootnotes a -> Prelude.IO (a0)
getLocation =
  Automation.propertyGetID 0x64 [] Automation.outVariant
setLocation :: (Automation.Variant a0) => a0 -> IFootnotes a -> Prelude.IO ()
setLocation prop =
  Automation.propertySetID 0x64 [Automation.inVariant prop]
getNumberStyle :: (Automation.Variant a0) => Automation.IDispatch a -> Prelude.IO (a0)
getNumberStyle =
  Automation.propertyGetID 0x65 [] Automation.outVariant
setNumberStyle :: (Automation.Variant a0) => a0 -> Automation.IDispatch a -> Prelude.IO ()
setNumberStyle prop =
  Automation.propertySetID 0x65 [Automation.inVariant prop]
getStartingNumber :: Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getStartingNumber =
  Automation.propertyGetID 0x66 [] Automation.outInt
setStartingNumber :: Prelude.Int -> Automation.IDispatch a -> Prelude.IO ()
setStartingNumber prop =
  Automation.propertySetID 0x66 [Automation.inInt prop]
getNumberingRule :: (Automation.Variant a0) => Automation.IDispatch a -> Prelude.IO (a0)
getNumberingRule =
  Automation.propertyGetID 0x67 [] Automation.outVariant
setNumberingRule :: (Automation.Variant a0) => a0 -> Automation.IDispatch a -> Prelude.IO ()
setNumberingRule prop =
  Automation.propertySetID 0x67 [Automation.inVariant prop]
getSeparator :: Automation.IDispatch a -> Prelude.IO (IRange Automation.Interface)
getSeparator =
  Automation.propertyGetID 0x68 [] Automation.outIDispatch
getContinuationSeparator :: Automation.IDispatch a -> Prelude.IO (IRange Automation.Interface)
getContinuationSeparator =
  Automation.propertyGetID 0x69 [] Automation.outIDispatch
getContinuationNotice :: Automation.IDispatch a -> Prelude.IO (IRange Automation.Interface)
getContinuationNotice =
  Automation.propertyGetID 0x6a [] Automation.outIDispatch
item21 :: Prelude.Int -> IFootnotes a -> Prelude.IO (IFootnote Automation.Interface)
item21 idex =
  Automation.functionID1 0o0 [Automation.inInt idex] Automation.outIDispatch
add15 :: IRange a0 -> Prelude.Int -> Prelude.Int -> IFootnotes a -> Prelude.IO (IFootnote Automation.Interface)
add15 range reference text =
  Automation.functionID1 0x4 [Automation.inIDispatch range, Automation.inInt reference, Automation.inInt text] Automation.outIDispatch
convert :: Automation.IDispatch a -> Prelude.IO ()
convert = Automation.methodID0 0x5 []
swapWithEndnotes :: IFootnotes a -> Prelude.IO ()
swapWithEndnotes = Automation.methodID0 0x6 []
resetSeparator :: Automation.IDispatch a -> Prelude.IO ()
resetSeparator = Automation.methodID0 0x7 []
resetContinuationSeparator :: Automation.IDispatch a -> Prelude.IO ()
resetContinuationSeparator = Automation.methodID0 0x8 []
resetContinuationNotice :: Automation.IDispatch a -> Prelude.IO ()
resetContinuationNotice = Automation.methodID0 0x9 []
-- --------------------------------------------------
-- 
-- interface Endnotes
-- 
-- --------------------------------------------------
data Endnotes a = Endnotes
                   
type IEndnotes a = Automation.IDispatch (Endnotes a)
iidIEndnotes :: Com.IID (IEndnotes Automation.Interface)
iidIEndnotes = Com.mkIID "{00020941-0000-0000-C000-000000000046}"
getLocation0 :: (Automation.Variant a0) => IEndnotes a -> Prelude.IO (a0)
getLocation0 =
  Automation.propertyGetID 0x64 [] Automation.outVariant
setLocation0 :: (Automation.Variant a0) => a0 -> IEndnotes a -> Prelude.IO ()
setLocation0 prop =
  Automation.propertySetID 0x64 [Automation.inVariant prop]
item22 :: Prelude.Int -> IEndnotes a -> Prelude.IO (IEndnote Automation.Interface)
item22 idex =
  Automation.functionID1 0o0 [Automation.inInt idex] Automation.outIDispatch
add16 :: IRange a0 -> Prelude.Int -> Prelude.Int -> IEndnotes a -> Prelude.IO (IEndnote Automation.Interface)
add16 range reference text =
  Automation.functionID1 0x4 [Automation.inIDispatch range, Automation.inInt reference, Automation.inInt text] Automation.outIDispatch
swapWithFootnotes :: IEndnotes a -> Prelude.IO ()
swapWithFootnotes = Automation.methodID0 0x6 []
-- --------------------------------------------------
-- 
-- interface Comments
-- 
-- --------------------------------------------------
data Comments a = Comments
                   
type IComments a = Automation.IDispatch (Comments a)
iidIComments :: Com.IID (IComments Automation.Interface)
iidIComments = Com.mkIID "{00020940-0000-0000-C000-000000000046}"
getShowBy :: IComments a -> Prelude.IO (Prelude.String)
getShowBy = Automation.propertyGetID 0x3eb [] Automation.outString
setShowBy :: Prelude.String -> IComments a -> Prelude.IO ()
setShowBy prop =
  Automation.propertySetID 0x3eb [Automation.inString prop]
item23 :: Prelude.Int -> IComments a -> Prelude.IO (IComment Automation.Interface)
item23 idex =
  Automation.functionID1 0o0 [Automation.inInt idex] Automation.outIDispatch
add17 :: IRange a0 -> Prelude.Int -> IComments a -> Prelude.IO (IComment Automation.Interface)
add17 range text =
  Automation.functionID1 0x4 [Automation.inIDispatch range, Automation.inInt text] Automation.outIDispatch
-- --------------------------------------------------
-- 
-- interface Footnote
-- 
-- --------------------------------------------------
data Footnote a = Footnote
                   
type IFootnote a = Automation.IDispatch (Footnote a)
iidIFootnote :: Com.IID (IFootnote Automation.Interface)
iidIFootnote = Com.mkIID "{0002093F-0000-0000-C000-000000000046}"
getReference :: Automation.IDispatch a -> Prelude.IO (IRange Automation.Interface)
getReference =
  Automation.propertyGetID 0x5 [] Automation.outIDispatch
-- --------------------------------------------------
-- 
-- interface Endnote
-- 
-- --------------------------------------------------
data Endnote a = Endnote
                  
type IEndnote a = Automation.IDispatch (Endnote a)
iidIEndnote :: Com.IID (IEndnote Automation.Interface)
iidIEndnote = Com.mkIID "{0002093E-0000-0000-C000-000000000046}"
-- --------------------------------------------------
-- 
-- interface Comment
-- 
-- --------------------------------------------------
data Comment a = Comment
                  
type IComment a = Automation.IDispatch (Comment a)
iidIComment :: Com.IID (IComment Automation.Interface)
iidIComment = Com.mkIID "{0002093D-0000-0000-C000-000000000046}"
getScope :: IComment a -> Prelude.IO (IRange Automation.Interface)
getScope =
  Automation.propertyGetID 0x3ed [] Automation.outIDispatch
getAuthor :: Automation.IDispatch a -> Prelude.IO (Prelude.String)
getAuthor = Automation.propertyGetID 0x3ef [] Automation.outString
setAuthor :: Prelude.String -> IComment a -> Prelude.IO ()
setAuthor prop =
  Automation.propertySetID 0x3ef [Automation.inString prop]
getInitial :: IComment a -> Prelude.IO (Prelude.String)
getInitial = Automation.propertyGetID 0x3f0 [] Automation.outString
setInitial :: Prelude.String -> IComment a -> Prelude.IO ()
setInitial prop =
  Automation.propertySetID 0x3f0 [Automation.inString prop]
getShowTip :: IComment a -> Prelude.IO (Prelude.Int)
getShowTip = Automation.propertyGetID 0x3f1 [] Automation.outInt
setShowTip :: Prelude.Int -> IComment a -> Prelude.IO ()
setShowTip prop =
  Automation.propertySetID 0x3f1 [Automation.inInt prop]
-- --------------------------------------------------
-- 
-- interface Borders
-- 
-- --------------------------------------------------
data Borders a = Borders
                  
type IBorders a = Automation.IDispatch (Borders a)
iidIBorders :: Com.IID (IBorders Automation.Interface)
iidIBorders = Com.mkIID "{0002093C-0000-0000-C000-000000000046}"
getEnable :: Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getEnable = Automation.propertyGetID 0x2 [] Automation.outInt
setEnable :: Prelude.Int -> Automation.IDispatch a -> Prelude.IO ()
setEnable prop =
  Automation.propertySetID 0x2 [Automation.inInt prop]
getDistanceFromTop :: IBorders a -> Prelude.IO (Prelude.Int)
getDistanceFromTop =
  Automation.propertyGetID 0x4 [] Automation.outInt
setDistanceFromTop :: Prelude.Int -> IBorders a -> Prelude.IO ()
setDistanceFromTop prop =
  Automation.propertySetID 0x4 [Automation.inInt prop]
getShadow0 :: IBorders a -> Prelude.IO (Prelude.Int)
getShadow0 = Automation.propertyGetID 0x5 [] Automation.outInt
setShadow0 :: Prelude.Int -> IBorders a -> Prelude.IO ()
setShadow0 prop =
  Automation.propertySetID 0x5 [Automation.inInt prop]
getInsideLineStyle :: (Automation.Variant a0) => IBorders a -> Prelude.IO (a0)
getInsideLineStyle =
  Automation.propertyGetID 0x6 [] Automation.outVariant
setInsideLineStyle :: (Automation.Variant a0) => a0 -> IBorders a -> Prelude.IO ()
setInsideLineStyle prop =
  Automation.propertySetID 0x6 [Automation.inVariant prop]
getOutsideLineStyle :: (Automation.Variant a0) => IBorders a -> Prelude.IO (a0)
getOutsideLineStyle =
  Automation.propertyGetID 0x7 [] Automation.outVariant
setOutsideLineStyle :: (Automation.Variant a0) => a0 -> IBorders a -> Prelude.IO ()
setOutsideLineStyle prop =
  Automation.propertySetID 0x7 [Automation.inVariant prop]
getInsideLineWidth :: (Automation.Variant a0) => IBorders a -> Prelude.IO (a0)
getInsideLineWidth =
  Automation.propertyGetID 0x8 [] Automation.outVariant
setInsideLineWidth :: (Automation.Variant a0) => a0 -> IBorders a -> Prelude.IO ()
setInsideLineWidth prop =
  Automation.propertySetID 0x8 [Automation.inVariant prop]
getOutsideLineWidth :: (Automation.Variant a0) => IBorders a -> Prelude.IO (a0)
getOutsideLineWidth =
  Automation.propertyGetID 0x9 [] Automation.outVariant
setOutsideLineWidth :: (Automation.Variant a0) => a0 -> IBorders a -> Prelude.IO ()
setOutsideLineWidth prop =
  Automation.propertySetID 0x9 [Automation.inVariant prop]
getInsideColorIndex :: (Automation.Variant a0) => IBorders a -> Prelude.IO (a0)
getInsideColorIndex =
  Automation.propertyGetID 0xa [] Automation.outVariant
setInsideColorIndex :: (Automation.Variant a0) => a0 -> IBorders a -> Prelude.IO ()
setInsideColorIndex prop =
  Automation.propertySetID 0xa [Automation.inVariant prop]
getOutsideColorIndex :: (Automation.Variant a0) => IBorders a -> Prelude.IO (a0)
getOutsideColorIndex =
  Automation.propertyGetID 0xb [] Automation.outVariant
setOutsideColorIndex :: (Automation.Variant a0) => a0 -> IBorders a -> Prelude.IO ()
setOutsideColorIndex prop =
  Automation.propertySetID 0xb [Automation.inVariant prop]
getDistanceFromLeft :: IBorders a -> Prelude.IO (Prelude.Int)
getDistanceFromLeft =
  Automation.propertyGetID 0x14 [] Automation.outInt
setDistanceFromLeft :: Prelude.Int -> IBorders a -> Prelude.IO ()
setDistanceFromLeft prop =
  Automation.propertySetID 0x14 [Automation.inInt prop]
getDistanceFromBottom :: IBorders a -> Prelude.IO (Prelude.Int)
getDistanceFromBottom =
  Automation.propertyGetID 0x15 [] Automation.outInt
setDistanceFromBottom :: Prelude.Int -> IBorders a -> Prelude.IO ()
setDistanceFromBottom prop =
  Automation.propertySetID 0x15 [Automation.inInt prop]
getDistanceFromRight :: IBorders a -> Prelude.IO (Prelude.Int)
getDistanceFromRight =
  Automation.propertyGetID 0x16 [] Automation.outInt
setDistanceFromRight :: Prelude.Int -> IBorders a -> Prelude.IO ()
setDistanceFromRight prop =
  Automation.propertySetID 0x16 [Automation.inInt prop]
getAlwaysInFront :: IBorders a -> Prelude.IO (Prelude.Int)
getAlwaysInFront =
  Automation.propertyGetID 0x17 [] Automation.outInt
setAlwaysInFront :: Prelude.Int -> IBorders a -> Prelude.IO ()
setAlwaysInFront prop =
  Automation.propertySetID 0x17 [Automation.inInt prop]
getSurroundHeader :: IBorders a -> Prelude.IO (Prelude.Int)
getSurroundHeader =
  Automation.propertyGetID 0x18 [] Automation.outInt
setSurroundHeader :: Prelude.Int -> IBorders a -> Prelude.IO ()
setSurroundHeader prop =
  Automation.propertySetID 0x18 [Automation.inInt prop]
getSurroundFooter :: IBorders a -> Prelude.IO (Prelude.Int)
getSurroundFooter =
  Automation.propertyGetID 0x19 [] Automation.outInt
setSurroundFooter :: Prelude.Int -> IBorders a -> Prelude.IO ()
setSurroundFooter prop =
  Automation.propertySetID 0x19 [Automation.inInt prop]
getJoinBorders :: IBorders a -> Prelude.IO (Prelude.Int)
getJoinBorders = Automation.propertyGetID 0x1a [] Automation.outInt
setJoinBorders :: Prelude.Int -> IBorders a -> Prelude.IO ()
setJoinBorders prop =
  Automation.propertySetID 0x1a [Automation.inInt prop]
getHasHorizontal :: IBorders a -> Prelude.IO (Prelude.Int)
getHasHorizontal =
  Automation.propertyGetID 0x1b [] Automation.outInt
getHasVertical :: IBorders a -> Prelude.IO (Prelude.Int)
getHasVertical = Automation.propertyGetID 0x1c [] Automation.outInt
getDistanceFrom :: (Automation.Variant a0) => IBorders a -> Prelude.IO (a0)
getDistanceFrom =
  Automation.propertyGetID 0x1d [] Automation.outVariant
setDistanceFrom :: (Automation.Variant a0) => a0 -> IBorders a -> Prelude.IO ()
setDistanceFrom prop =
  Automation.propertySetID 0x1d [Automation.inVariant prop]
getEnableFirstPageInSection :: IBorders a -> Prelude.IO (Prelude.Int)
getEnableFirstPageInSection =
  Automation.propertyGetID 0x1e [] Automation.outInt
setEnableFirstPageInSection :: Prelude.Int -> IBorders a -> Prelude.IO ()
setEnableFirstPageInSection prop =
  Automation.propertySetID 0x1e [Automation.inInt prop]
getEnableOtherPagesInSection :: IBorders a -> Prelude.IO (Prelude.Int)
getEnableOtherPagesInSection =
  Automation.propertyGetID 0x1f [] Automation.outInt
setEnableOtherPagesInSection :: Prelude.Int -> IBorders a -> Prelude.IO ()
setEnableOtherPagesInSection prop =
  Automation.propertySetID 0x1f [Automation.inInt prop]
item24 :: (Automation.Variant a0) => a0 -> IBorders a -> Prelude.IO (IBorder Automation.Interface)
item24 idex =
  Automation.functionID1 0o0 [Automation.inVariant idex] Automation.outIDispatch
applyPageBordersToAllSections :: IBorders a -> Prelude.IO ()
applyPageBordersToAllSections = Automation.methodID0 0x7d0 []
-- --------------------------------------------------
-- 
-- interface Border
-- 
-- --------------------------------------------------
data Border a = Border
                 
type IBorder a = Automation.IDispatch (Border a)
iidIBorder :: Com.IID (IBorder Automation.Interface)
iidIBorder = Com.mkIID "{0002093B-0000-0000-C000-000000000046}"
getInside :: IBorder a -> Prelude.IO (Prelude.Int)
getInside = Automation.propertyGetID 0x2 [] Automation.outInt
getLineStyle :: (Automation.Variant a0) => IBorder a -> Prelude.IO (a0)
getLineStyle =
  Automation.propertyGetID 0x3 [] Automation.outVariant
setLineStyle :: (Automation.Variant a0) => a0 -> IBorder a -> Prelude.IO ()
setLineStyle prop =
  Automation.propertySetID 0x3 [Automation.inVariant prop]
getLineWidth :: (Automation.Variant a0) => IBorder a -> Prelude.IO (a0)
getLineWidth =
  Automation.propertyGetID 0x4 [] Automation.outVariant
setLineWidth :: (Automation.Variant a0) => a0 -> IBorder a -> Prelude.IO ()
setLineWidth prop =
  Automation.propertySetID 0x4 [Automation.inVariant prop]
getArtStyle :: (Automation.Variant a0) => IBorder a -> Prelude.IO (a0)
getArtStyle = Automation.propertyGetID 0x5 [] Automation.outVariant
setArtStyle :: (Automation.Variant a0) => a0 -> IBorder a -> Prelude.IO ()
setArtStyle prop =
  Automation.propertySetID 0x5 [Automation.inVariant prop]
getArtWidth :: IBorder a -> Prelude.IO (Prelude.Int)
getArtWidth = Automation.propertyGetID 0x6 [] Automation.outInt
setArtWidth :: Prelude.Int -> IBorder a -> Prelude.IO ()
setArtWidth prop =
  Automation.propertySetID 0x6 [Automation.inInt prop]
-- --------------------------------------------------
-- 
-- interface Shading
-- 
-- --------------------------------------------------
data Shading a = Shading
                  
type IShading a = Automation.IDispatch (Shading a)
iidIShading :: Com.IID (IShading Automation.Interface)
iidIShading = Com.mkIID "{0002093A-0000-0000-C000-000000000046}"
getForegroundPatternColorIndex :: (Automation.Variant a0) => IShading a -> Prelude.IO (a0)
getForegroundPatternColorIndex =
  Automation.propertyGetID 0x1 [] Automation.outVariant
setForegroundPatternColorIndex :: (Automation.Variant a0) => a0 -> IShading a -> Prelude.IO ()
setForegroundPatternColorIndex prop =
  Automation.propertySetID 0x1 [Automation.inVariant prop]
getBackgroundPatternColorIndex :: (Automation.Variant a0) => IShading a -> Prelude.IO (a0)
getBackgroundPatternColorIndex =
  Automation.propertyGetID 0x2 [] Automation.outVariant
setBackgroundPatternColorIndex :: (Automation.Variant a0) => a0 -> IShading a -> Prelude.IO ()
setBackgroundPatternColorIndex prop =
  Automation.propertySetID 0x2 [Automation.inVariant prop]
getTexture :: (Automation.Variant a0) => IShading a -> Prelude.IO (a0)
getTexture = Automation.propertyGetID 0x3 [] Automation.outVariant
setTexture :: (Automation.Variant a0) => a0 -> IShading a -> Prelude.IO ()
setTexture prop =
  Automation.propertySetID 0x3 [Automation.inVariant prop]
-- --------------------------------------------------
-- 
-- interface TextRetrievalMode
-- 
-- --------------------------------------------------
data TextRetrievalMode a = TextRetrievalMode
                            
type ITextRetrievalMode a = Automation.IDispatch (TextRetrievalMode a)
iidITextRetrievalMode :: Com.IID (ITextRetrievalMode Automation.Interface)
iidITextRetrievalMode =
  Com.mkIID "{00020939-0000-0000-C000-000000000046}"
getViewType :: (Automation.Variant a0) => ITextRetrievalMode a -> Prelude.IO (a0)
getViewType = Automation.propertyGetID 0o0 [] Automation.outVariant
setViewType :: (Automation.Variant a0) => a0 -> ITextRetrievalMode a -> Prelude.IO ()
setViewType prop =
  Automation.propertySetID 0o0 [Automation.inVariant prop]
getDuplicate2 :: ITextRetrievalMode a -> Prelude.IO (ITextRetrievalMode Automation.Interface)
getDuplicate2 =
  Automation.propertyGetID 0x1 [] Automation.outIDispatch
getIncludeHiddenText :: ITextRetrievalMode a -> Prelude.IO (Prelude.Int)
getIncludeHiddenText =
  Automation.propertyGetID 0x2 [] Automation.outInt
setIncludeHiddenText :: Prelude.Int -> ITextRetrievalMode a -> Prelude.IO ()
setIncludeHiddenText prop =
  Automation.propertySetID 0x2 [Automation.inInt prop]
getIncludeFieldCodes :: ITextRetrievalMode a -> Prelude.IO (Prelude.Int)
getIncludeFieldCodes =
  Automation.propertyGetID 0x3 [] Automation.outInt
setIncludeFieldCodes :: Prelude.Int -> ITextRetrievalMode a -> Prelude.IO ()
setIncludeFieldCodes prop =
  Automation.propertySetID 0x3 [Automation.inInt prop]
-- --------------------------------------------------
-- 
-- interface AutoTextEntries
-- 
-- --------------------------------------------------
data AutoTextEntries a = AutoTextEntries
                          
type IAutoTextEntries a = Automation.IDispatch (AutoTextEntries a)
iidIAutoTextEntries :: Com.IID (IAutoTextEntries Automation.Interface)
iidIAutoTextEntries =
  Com.mkIID "{00020937-0000-0000-C000-000000000046}"
item25 :: Prelude.Int -> IAutoTextEntries a -> Prelude.IO (IAutoTextEntry Automation.Interface)
item25 idex =
  Automation.functionID1 0o0 [Automation.inInt idex] Automation.outIDispatch
add18 :: Prelude.String -> IRange a0 -> IAutoTextEntries a -> Prelude.IO (IAutoTextEntry Automation.Interface)
add18 name range =
  Automation.functionID1 0x65 [Automation.inString name, Automation.inIDispatch range] Automation.outIDispatch
appendToSpike :: IRange a0 -> IAutoTextEntries a -> Prelude.IO (IAutoTextEntry Automation.Interface)
appendToSpike range =
  Automation.functionID1 0x66 [Automation.inIDispatch range] Automation.outIDispatch
-- --------------------------------------------------
-- 
-- interface AutoTextEntry
-- 
-- --------------------------------------------------
data AutoTextEntry a = AutoTextEntry
                        
type IAutoTextEntry a = Automation.IDispatch (AutoTextEntry a)
iidIAutoTextEntry :: Com.IID (IAutoTextEntry Automation.Interface)
iidIAutoTextEntry =
  Com.mkIID "{00020936-0000-0000-C000-000000000046}"
getStyleName :: IAutoTextEntry a -> Prelude.IO (Prelude.String)
getStyleName = Automation.propertyGetID 0x3 [] Automation.outString
insert :: IRange a0 -> Prelude.Int -> IAutoTextEntry a -> Prelude.IO (IRange Automation.Interface)
insert where0 richText =
  Automation.functionID1 0x66 [Automation.inIDispatch where0, Automation.inInt richText] Automation.outIDispatch
-- --------------------------------------------------
-- 
-- interface System
-- 
-- --------------------------------------------------
data System a = System
                 
type ISystem a = Automation.IDispatch (System a)
iidISystem :: Com.IID (ISystem Automation.Interface)
iidISystem = Com.mkIID "{00020935-0000-0000-C000-000000000046}"
getOperatingSystem :: ISystem a -> Prelude.IO (Prelude.String)
getOperatingSystem =
  Automation.propertyGetID 0x1 [] Automation.outString
getProcessorType :: ISystem a -> Prelude.IO (Prelude.String)
getProcessorType =
  Automation.propertyGetID 0x2 [] Automation.outString
getFreeDiskSpace :: ISystem a -> Prelude.IO (Prelude.Int)
getFreeDiskSpace =
  Automation.propertyGetID 0x4 [] Automation.outInt
getCountry :: (Automation.Variant a0) => ISystem a -> Prelude.IO (a0)
getCountry = Automation.propertyGetID 0x5 [] Automation.outVariant
getLanguageDesignation :: ISystem a -> Prelude.IO (Prelude.String)
getLanguageDesignation =
  Automation.propertyGetID 0x6 [] Automation.outString
getHorizontalResolution :: ISystem a -> Prelude.IO (Prelude.Int)
getHorizontalResolution =
  Automation.propertyGetID 0x7 [] Automation.outInt
getVerticalResolution :: ISystem a -> Prelude.IO (Prelude.Int)
getVerticalResolution =
  Automation.propertyGetID 0x8 [] Automation.outInt
getProfileString :: Prelude.String -> Prelude.String -> ISystem a -> Prelude.IO (Prelude.String)
getProfileString section key =
  Automation.propertyGetID 0x9 [Automation.inString section, Automation.inString key] Automation.outString
setProfileString :: Prelude.String -> Prelude.String -> Prelude.String -> ISystem a -> Prelude.IO ()
setProfileString section key prop =
  Automation.propertySetID 0x9 [Automation.inString section, Automation.inString key, Automation.inString prop]
getPrivateProfileString :: Prelude.String -> Prelude.String -> Prelude.String -> ISystem a -> Prelude.IO (Prelude.String)
getPrivateProfileString fileName section key =
  Automation.propertyGetID 0xa [Automation.inString fileName, Automation.inString section, Automation.inString key] Automation.outString
setPrivateProfileString :: Prelude.String -> Prelude.String -> Prelude.String -> Prelude.String -> ISystem a -> Prelude.IO ()
setPrivateProfileString fileName section key prop =
  Automation.propertySetID 0xa [Automation.inString fileName, Automation.inString section, Automation.inString key, Automation.inString prop]
getMathCoprocessorInstalled :: ISystem a -> Prelude.IO (Prelude.Int)
getMathCoprocessorInstalled =
  Automation.propertyGetID 0xb [] Automation.outInt
getComputerType :: ISystem a -> Prelude.IO (Prelude.String)
getComputerType =
  Automation.propertyGetID 0xc [] Automation.outString
getMacintoshName :: ISystem a -> Prelude.IO (Prelude.String)
getMacintoshName =
  Automation.propertyGetID 0xe [] Automation.outString
getQuickDrawInstalled :: ISystem a -> Prelude.IO (Prelude.Int)
getQuickDrawInstalled =
  Automation.propertyGetID 0xf [] Automation.outInt
getCursor :: (Automation.Variant a0) => ISystem a -> Prelude.IO (a0)
getCursor = Automation.propertyGetID 0x10 [] Automation.outVariant
setCursor :: (Automation.Variant a0) => a0 -> ISystem a -> Prelude.IO ()
setCursor prop =
  Automation.propertySetID 0x10 [Automation.inVariant prop]
mSInfo :: ISystem a -> Prelude.IO ()
mSInfo = Automation.methodID0 0x65 []
connect :: Prelude.String -> Prelude.Int -> Prelude.Int -> ISystem a -> Prelude.IO ()
connect path drive password =
  Automation.methodID0 0x66 [Automation.inString path, Automation.inInt drive, Automation.inInt password]
-- --------------------------------------------------
-- 
-- interface OLEFormat
-- 
-- --------------------------------------------------
data OLEFormat a = OLEFormat
                    
type IOLEFormat a = Automation.IDispatch (OLEFormat a)
iidIOLEFormat :: Com.IID (IOLEFormat Automation.Interface)
iidIOLEFormat = Com.mkIID "{00020933-0000-0000-C000-000000000046}"
getClassType :: IOLEFormat a -> Prelude.IO (Prelude.String)
getClassType = Automation.propertyGetID 0x2 [] Automation.outString
setClassType :: Prelude.String -> IOLEFormat a -> Prelude.IO ()
setClassType prop =
  Automation.propertySetID 0x2 [Automation.inString prop]
getDisplayAsIcon :: IOLEFormat a -> Prelude.IO (Prelude.Int)
getDisplayAsIcon =
  Automation.propertyGetID 0x3 [] Automation.outInt
setDisplayAsIcon :: Prelude.Int -> IOLEFormat a -> Prelude.IO ()
setDisplayAsIcon prop =
  Automation.propertySetID 0x3 [Automation.inInt prop]
getIconName :: IOLEFormat a -> Prelude.IO (Prelude.String)
getIconName = Automation.propertyGetID 0x7 [] Automation.outString
setIconName :: Prelude.String -> IOLEFormat a -> Prelude.IO ()
setIconName prop =
  Automation.propertySetID 0x7 [Automation.inString prop]
getIconPath :: IOLEFormat a -> Prelude.IO (Prelude.String)
getIconPath = Automation.propertyGetID 0x8 [] Automation.outString
getIconIndex :: IOLEFormat a -> Prelude.IO (Prelude.Int)
getIconIndex = Automation.propertyGetID 0x9 [] Automation.outInt
setIconIndex :: Prelude.Int -> IOLEFormat a -> Prelude.IO ()
setIconIndex prop =
  Automation.propertySetID 0x9 [Automation.inInt prop]
getIconLabel :: IOLEFormat a -> Prelude.IO (Prelude.String)
getIconLabel = Automation.propertyGetID 0xa [] Automation.outString
setIconLabel :: Prelude.String -> IOLEFormat a -> Prelude.IO ()
setIconLabel prop =
  Automation.propertySetID 0xa [Automation.inString prop]
getLabel :: IOLEFormat a -> Prelude.IO (Prelude.String)
getLabel = Automation.propertyGetID 0xc [] Automation.outString
getObject :: IOLEFormat a -> Prelude.IO (Automation.IDispatch Automation.Interface)
getObject = Automation.propertyGetID 0xe [] Automation.outIDispatch
getProgID :: IOLEFormat a -> Prelude.IO (Prelude.String)
getProgID = Automation.propertyGetID 0x16 [] Automation.outString
edit :: IOLEFormat a -> Prelude.IO ()
edit = Automation.methodID0 0x6a []
open1 :: Automation.IDispatch a -> Prelude.IO ()
open1 = Automation.methodID0 0x6b []
doVerb :: Prelude.Int -> IOLEFormat a -> Prelude.IO ()
doVerb verbIndex =
  Automation.methodID0 0x6d [Automation.inInt verbIndex]
convertTo :: Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> IOLEFormat a -> Prelude.IO ()
convertTo classType displayAsIcon iconFileName iconIndex iconLabel =
  Automation.methodID0 0x6e [Automation.inInt classType, Automation.inInt displayAsIcon, Automation.inInt iconFileName, Automation.inInt iconIndex, Automation.inInt iconLabel]
activateAs :: Prelude.String -> IOLEFormat a -> Prelude.IO ()
activateAs classType =
  Automation.methodID0 0x6f [Automation.inString classType]
-- --------------------------------------------------
-- 
-- interface LinkFormat
-- 
-- --------------------------------------------------
data LinkFormat a = LinkFormat
                     
type ILinkFormat a = Automation.IDispatch (LinkFormat a)
iidILinkFormat :: Com.IID (ILinkFormat Automation.Interface)
iidILinkFormat = Com.mkIID "{00020931-0000-0000-C000-000000000046}"
getAutoUpdate :: ILinkFormat a -> Prelude.IO (Prelude.Int)
getAutoUpdate = Automation.propertyGetID 0x1 [] Automation.outInt
setAutoUpdate :: Prelude.Int -> ILinkFormat a -> Prelude.IO ()
setAutoUpdate prop =
  Automation.propertySetID 0x1 [Automation.inInt prop]
getSourceName :: ILinkFormat a -> Prelude.IO (Prelude.String)
getSourceName =
  Automation.propertyGetID 0x4 [] Automation.outString
getSourcePath :: ILinkFormat a -> Prelude.IO (Prelude.String)
getSourcePath =
  Automation.propertyGetID 0x5 [] Automation.outString
getLocked :: Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getLocked = Automation.propertyGetID 0xd [] Automation.outInt
setLocked :: Prelude.Int -> Automation.IDispatch a -> Prelude.IO ()
setLocked prop =
  Automation.propertySetID 0xd [Automation.inInt prop]
getType2 :: (Automation.Variant a0) => ILinkFormat a -> Prelude.IO (a0)
getType2 = Automation.propertyGetID 0x10 [] Automation.outVariant
getSourceFullName :: ILinkFormat a -> Prelude.IO (Prelude.String)
getSourceFullName =
  Automation.propertyGetID 0x15 [] Automation.outString
setSourceFullName :: Prelude.String -> ILinkFormat a -> Prelude.IO ()
setSourceFullName prop =
  Automation.propertySetID 0x15 [Automation.inString prop]
getSavePictureWithDocument :: ILinkFormat a -> Prelude.IO (Prelude.Int)
getSavePictureWithDocument =
  Automation.propertyGetID 0x16 [] Automation.outInt
setSavePictureWithDocument :: Prelude.Int -> ILinkFormat a -> Prelude.IO ()
setSavePictureWithDocument prop =
  Automation.propertySetID 0x16 [Automation.inInt prop]
breakLink :: ILinkFormat a -> Prelude.IO ()
breakLink = Automation.methodID0 0x68 []
update :: Automation.IDispatch a -> Prelude.IO ()
update = Automation.methodID0 0x69 []
-- --------------------------------------------------
-- 
-- interface OLEControl
-- 
-- --------------------------------------------------
data OLEControl a = OLEControl
                     
type IOLEControl a = Automation.IDispatch (OLEControl a)
iidIOLEControl :: Com.IID (IOLEControl Automation.Interface)
iidIOLEControl = Com.mkIID "{000209A4-0000-0000-C000-000000000046}"
getLeft1 :: Automation.IDispatch a -> Prelude.IO (Prelude.Float)
getLeft1 =
  Automation.propertyGetID 0x80010103 [] Automation.outFloat
setLeft1 :: Prelude.Float -> Automation.IDispatch a -> Prelude.IO ()
setLeft1 prop =
  Automation.propertySetID 0x80010103 [Automation.inFloat prop]
getTop1 :: Automation.IDispatch a -> Prelude.IO (Prelude.Float)
getTop1 =
  Automation.propertyGetID 0x80010104 [] Automation.outFloat
setTop1 :: Prelude.Float -> Automation.IDispatch a -> Prelude.IO ()
setTop1 prop =
  Automation.propertySetID 0x80010104 [Automation.inFloat prop]
getAutomation :: IOLEControl a -> Prelude.IO (Automation.IDispatch Automation.Interface)
getAutomation =
  Automation.propertyGetID 0x80010107 [] Automation.outIDispatch
-- --------------------------------------------------
-- 
-- interface Fields
-- 
-- --------------------------------------------------
data Fields a = Fields
                 
type IFields a = Automation.IDispatch (Fields a)
iidIFields :: Com.IID (IFields Automation.Interface)
iidIFields = Com.mkIID "{00020930-0000-0000-C000-000000000046}"
getLocked0 :: IFields a -> Prelude.IO (Prelude.Int)
getLocked0 = Automation.propertyGetID 0x2 [] Automation.outInt
setLocked0 :: Prelude.Int -> IFields a -> Prelude.IO ()
setLocked0 prop =
  Automation.propertySetID 0x2 [Automation.inInt prop]
item26 :: Prelude.Int -> IFields a -> Prelude.IO (IField Automation.Interface)
item26 idex =
  Automation.functionID1 0o0 [Automation.inInt idex] Automation.outIDispatch
toggleShowCodes :: IFields a -> Prelude.IO ()
toggleShowCodes = Automation.methodID0 0x64 []
update0 :: Automation.IDispatch a -> Prelude.IO (Prelude.Int)
update0 = Automation.functionID1 0x65 [] Automation.outInt
unlink :: Automation.IDispatch a -> Prelude.IO ()
unlink = Automation.methodID0 0x66 []
updateSource :: Automation.IDispatch a -> Prelude.IO ()
updateSource = Automation.methodID0 0x68 []
add19 :: IRange a0 -> Prelude.Int -> Prelude.Int -> Prelude.Int -> IFields a -> Prelude.IO (IField Automation.Interface)
add19 range type0 text preserveFormatting =
  Automation.functionID1 0x69 [Automation.inIDispatch range, Automation.inInt type0, Automation.inInt text, Automation.inInt preserveFormatting] Automation.outIDispatch
-- --------------------------------------------------
-- 
-- interface Field
-- 
-- --------------------------------------------------
data Field a = Field
                
type IField a = Automation.IDispatch (Field a)
iidIField :: Com.IID (IField Automation.Interface)
iidIField = Com.mkIID "{0002092F-0000-0000-C000-000000000046}"
getCode :: Automation.IDispatch a -> Prelude.IO (IRange Automation.Interface)
getCode = Automation.propertyGetID 0o0 [] Automation.outIDispatch
setCode :: IRange a0 -> Automation.IDispatch a -> Prelude.IO ()
setCode prop =
  Automation.propertySetID 0o0 [Automation.inIDispatch prop]
getType3 :: (Automation.Variant a0) => Automation.IDispatch a -> Prelude.IO (a0)
getType3 = Automation.propertyGetID 0x1 [] Automation.outVariant
getKind0 :: (Automation.Variant a0) => IField a -> Prelude.IO (a0)
getKind0 = Automation.propertyGetID 0x3 [] Automation.outVariant
getResult :: IField a -> Prelude.IO (IRange Automation.Interface)
getResult = Automation.propertyGetID 0x4 [] Automation.outIDispatch
setResult :: IRange a0 -> IField a -> Prelude.IO ()
setResult prop =
  Automation.propertySetID 0x4 [Automation.inIDispatch prop]
getData :: IField a -> Prelude.IO (Prelude.String)
getData = Automation.propertyGetID 0x5 [] Automation.outString
setData :: Prelude.String -> IField a -> Prelude.IO ()
setData prop =
  Automation.propertySetID 0x5 [Automation.inString prop]
getNext5 :: IField a -> Prelude.IO (IField Automation.Interface)
getNext5 = Automation.propertyGetID 0x6 [] Automation.outIDispatch
getPrevious5 :: IField a -> Prelude.IO (IField Automation.Interface)
getPrevious5 =
  Automation.propertyGetID 0x7 [] Automation.outIDispatch
getShowCodes :: IField a -> Prelude.IO (Prelude.Int)
getShowCodes = Automation.propertyGetID 0x9 [] Automation.outInt
setShowCodes :: Prelude.Int -> IField a -> Prelude.IO ()
setShowCodes prop =
  Automation.propertySetID 0x9 [Automation.inInt prop]
getLinkFormat :: Automation.IDispatch a -> Prelude.IO (ILinkFormat Automation.Interface)
getLinkFormat =
  Automation.propertyGetID 0xa [] Automation.outIDispatch
getOLEFormat :: Automation.IDispatch a -> Prelude.IO (IOLEFormat Automation.Interface)
getOLEFormat =
  Automation.propertyGetID 0xb [] Automation.outIDispatch
getInlineShape :: IField a -> Prelude.IO (InlineShape Automation.Interface)
getInlineShape =
  Automation.propertyGetID 0xc [] Automation.outIDispatch
update1 :: Automation.IDispatch a -> Prelude.IO (Prelude.Int)
update1 = Automation.functionID1 0x65 [] Automation.outInt
doClick :: IField a -> Prelude.IO ()
doClick = Automation.methodID0 0x68 []
-- --------------------------------------------------
-- 
-- interface Browser
-- 
-- --------------------------------------------------
data Browser a = Browser
                  
type IBrowser a = Automation.IDispatch (Browser a)
iidIBrowser :: Com.IID (IBrowser Automation.Interface)
iidIBrowser = Com.mkIID "{0002092E-0000-0000-C000-000000000046}"
getTarget :: (Automation.Variant a0) => IBrowser a -> Prelude.IO (a0)
getTarget = Automation.propertyGetID 0x1 [] Automation.outVariant
setTarget :: (Automation.Variant a0) => a0 -> IBrowser a -> Prelude.IO ()
setTarget prop =
  Automation.propertySetID 0x1 [Automation.inVariant prop]
next1 :: Automation.IDispatch a -> Prelude.IO ()
next1 = Automation.methodID0 0x65 []
previous1 :: Automation.IDispatch a -> Prelude.IO ()
previous1 = Automation.methodID0 0x66 []
-- --------------------------------------------------
-- 
-- interface Styles
-- 
-- --------------------------------------------------
data Styles a = Styles
                 
type IStyles a = Automation.IDispatch (Styles a)
iidIStyles :: Com.IID (IStyles Automation.Interface)
iidIStyles = Com.mkIID "{0002092D-0000-0000-C000-000000000046}"
item27 :: Prelude.Int -> IStyles a -> Prelude.IO (IStyle Automation.Interface)
item27 idx =
  Automation.functionID1 0o0 [Automation.inInt idx] Automation.outIDispatch
add20 :: Prelude.String -> Prelude.Int -> IStyles a -> Prelude.IO (IStyle Automation.Interface)
add20 name type0 =
  Automation.functionID1 0x64 [Automation.inString name, Automation.inInt type0] Automation.outIDispatch
-- --------------------------------------------------
-- 
-- interface Style
-- 
-- --------------------------------------------------
data Style a = Style
                
type IStyle a = Automation.IDispatch (Style a)
iidIStyle :: Com.IID (IStyle Automation.Interface)
iidIStyle = Com.mkIID "{0002092C-0000-0000-C000-000000000046}"
setNameLocal :: Prelude.String -> IStyle a -> Prelude.IO ()
setNameLocal prop =
  Automation.propertySetID 0o0 [Automation.inString prop]
getBaseStyle :: IStyle a -> Prelude.IO (Prelude.Int)
getBaseStyle = Automation.propertyGetID 0x1 [] Automation.outInt
setBaseStyle :: Prelude.Int -> IStyle a -> Prelude.IO ()
setBaseStyle prop =
  Automation.propertySetID 0x1 [Automation.inInt prop]
getDescription :: IStyle a -> Prelude.IO (Prelude.String)
getDescription =
  Automation.propertyGetID 0x2 [] Automation.outString
getType4 :: (Automation.Variant a0) => IStyle a -> Prelude.IO (a0)
getType4 = Automation.propertyGetID 0x3 [] Automation.outVariant
getBuiltIn :: Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getBuiltIn = Automation.propertyGetID 0x4 [] Automation.outInt
getNextParagraphStyle :: IStyle a -> Prelude.IO (Prelude.Int)
getNextParagraphStyle =
  Automation.propertyGetID 0x5 [] Automation.outInt
setNextParagraphStyle :: Prelude.Int -> IStyle a -> Prelude.IO ()
setNextParagraphStyle prop =
  Automation.propertySetID 0x5 [Automation.inInt prop]
getInUse :: IStyle a -> Prelude.IO (Prelude.Int)
getInUse = Automation.propertyGetID 0x6 [] Automation.outInt
getAutomaticallyUpdate :: IStyle a -> Prelude.IO (Prelude.Int)
getAutomaticallyUpdate =
  Automation.propertyGetID 0xd [] Automation.outInt
setAutomaticallyUpdate :: Prelude.Int -> IStyle a -> Prelude.IO ()
setAutomaticallyUpdate prop =
  Automation.propertySetID 0xd [Automation.inInt prop]
getHidden0 :: IStyle a -> Prelude.IO (Prelude.Int)
getHidden0 = Automation.propertyGetID 0x11 [] Automation.outInt
setHidden0 :: Prelude.Int -> IStyle a -> Prelude.IO ()
setHidden0 prop =
  Automation.propertySetID 0x11 [Automation.inInt prop]
linkToListTemplate :: IListTemplate a0 -> Prelude.Int -> IStyle a -> Prelude.IO ()
linkToListTemplate listTemplate listLevelNumber =
  Automation.methodID0 0x65 [Automation.inIDispatch listTemplate, Automation.inInt listLevelNumber]
-- --------------------------------------------------
-- 
-- interface Frames
-- 
-- --------------------------------------------------
data Frames a = Frames
                 
type IFrames a = Automation.IDispatch (Frames a)
iidIFrames :: Com.IID (IFrames Automation.Interface)
iidIFrames = Com.mkIID "{0002092B-0000-0000-C000-000000000046}"
item28 :: Prelude.Int -> IFrames a -> Prelude.IO (IFrame Automation.Interface)
item28 idex =
  Automation.functionID1 0o0 [Automation.inInt idex] Automation.outIDispatch
add21 :: IRange a0 -> IFrames a -> Prelude.IO (IFrame Automation.Interface)
add21 range =
  Automation.functionID1 0x64 [Automation.inIDispatch range] Automation.outIDispatch
-- --------------------------------------------------
-- 
-- interface Frame
-- 
-- --------------------------------------------------
data Frame a = Frame
                
type IFrame a = Automation.IDispatch (Frame a)
iidIFrame :: Com.IID (IFrame Automation.Interface)
iidIFrame = Com.mkIID "{0002092A-0000-0000-C000-000000000046}"
getHeightRule3 :: (Automation.Variant a0) => IFrame a -> Prelude.IO (a0)
getHeightRule3 =
  Automation.propertyGetID 0x1 [] Automation.outVariant
setHeightRule3 :: (Automation.Variant a0) => a0 -> IFrame a -> Prelude.IO ()
setHeightRule3 prop =
  Automation.propertySetID 0x1 [Automation.inVariant prop]
getWidthRule :: (Automation.Variant a0) => IFrame a -> Prelude.IO (a0)
getWidthRule =
  Automation.propertyGetID 0x2 [] Automation.outVariant
setWidthRule :: (Automation.Variant a0) => a0 -> IFrame a -> Prelude.IO ()
setWidthRule prop =
  Automation.propertySetID 0x2 [Automation.inVariant prop]
getHorizontalDistanceFromText :: IFrame a -> Prelude.IO (Prelude.Float)
getHorizontalDistanceFromText =
  Automation.propertyGetID 0x3 [] Automation.outFloat
setHorizontalDistanceFromText :: Prelude.Float -> IFrame a -> Prelude.IO ()
setHorizontalDistanceFromText prop =
  Automation.propertySetID 0x3 [Automation.inFloat prop]
getHorizontalPosition :: IFrame a -> Prelude.IO (Prelude.Float)
getHorizontalPosition =
  Automation.propertyGetID 0x5 [] Automation.outFloat
setHorizontalPosition :: Prelude.Float -> IFrame a -> Prelude.IO ()
setHorizontalPosition prop =
  Automation.propertySetID 0x5 [Automation.inFloat prop]
getLockAnchor :: IFrame a -> Prelude.IO (Prelude.Int)
getLockAnchor = Automation.propertyGetID 0x6 [] Automation.outInt
setLockAnchor :: Prelude.Int -> IFrame a -> Prelude.IO ()
setLockAnchor prop =
  Automation.propertySetID 0x6 [Automation.inInt prop]
getRelativeHorizontalPosition :: (Automation.Variant a0) => Automation.IDispatch a -> Prelude.IO (a0)
getRelativeHorizontalPosition =
  Automation.propertyGetID 0x7 [] Automation.outVariant
setRelativeHorizontalPosition :: (Automation.Variant a0) => a0 -> Automation.IDispatch a -> Prelude.IO ()
setRelativeHorizontalPosition prop =
  Automation.propertySetID 0x7 [Automation.inVariant prop]
getRelativeVerticalPosition :: (Automation.Variant a0) => Automation.IDispatch a -> Prelude.IO (a0)
getRelativeVerticalPosition =
  Automation.propertyGetID 0x8 [] Automation.outVariant
setRelativeVerticalPosition :: (Automation.Variant a0) => a0 -> Automation.IDispatch a -> Prelude.IO ()
setRelativeVerticalPosition prop =
  Automation.propertySetID 0x8 [Automation.inVariant prop]
getVerticalDistanceFromText :: IFrame a -> Prelude.IO (Prelude.Float)
getVerticalDistanceFromText =
  Automation.propertyGetID 0x9 [] Automation.outFloat
setVerticalDistanceFromText :: Prelude.Float -> IFrame a -> Prelude.IO ()
setVerticalDistanceFromText prop =
  Automation.propertySetID 0x9 [Automation.inFloat prop]
getVerticalPosition :: IFrame a -> Prelude.IO (Prelude.Float)
getVerticalPosition =
  Automation.propertyGetID 0xa [] Automation.outFloat
setVerticalPosition :: Prelude.Float -> IFrame a -> Prelude.IO ()
setVerticalPosition prop =
  Automation.propertySetID 0xa [Automation.inFloat prop]
getTextWrap :: IFrame a -> Prelude.IO (Prelude.Int)
getTextWrap = Automation.propertyGetID 0xc [] Automation.outInt
setTextWrap :: Prelude.Int -> IFrame a -> Prelude.IO ()
setTextWrap prop =
  Automation.propertySetID 0xc [Automation.inInt prop]
-- --------------------------------------------------
-- 
-- interface FormFields
-- 
-- --------------------------------------------------
data FormFields a = FormFields
                     
type IFormFields a = Automation.IDispatch (FormFields a)
iidIFormFields :: Com.IID (IFormFields Automation.Interface)
iidIFormFields = Com.mkIID "{00020929-0000-0000-C000-000000000046}"
getShaded :: IFormFields a -> Prelude.IO (Prelude.Int)
getShaded = Automation.propertyGetID 0x2 [] Automation.outInt
setShaded :: Prelude.Int -> IFormFields a -> Prelude.IO ()
setShaded prop =
  Automation.propertySetID 0x2 [Automation.inInt prop]
item29 :: Prelude.Int -> IFormFields a -> Prelude.IO (IFormField Automation.Interface)
item29 idx =
  Automation.functionID1 0o0 [Automation.inInt idx] Automation.outIDispatch
add22 :: (Automation.Variant a1) => IRange a0 -> a1 -> IFormFields a -> Prelude.IO (IFormField Automation.Interface)
add22 range type0 =
  Automation.functionID1 0x65 [Automation.inIDispatch range, Automation.inVariant type0] Automation.outIDispatch
-- --------------------------------------------------
-- 
-- interface FormField
-- 
-- --------------------------------------------------
data FormField a = FormField
                    
type IFormField a = Automation.IDispatch (FormField a)
iidIFormField :: Com.IID (IFormField Automation.Interface)
iidIFormField = Com.mkIID "{00020928-0000-0000-C000-000000000046}"
getEntryMacro :: IFormField a -> Prelude.IO (Prelude.String)
getEntryMacro =
  Automation.propertyGetID 0x3 [] Automation.outString
setEntryMacro :: Prelude.String -> IFormField a -> Prelude.IO ()
setEntryMacro prop =
  Automation.propertySetID 0x3 [Automation.inString prop]
getExitMacro :: IFormField a -> Prelude.IO (Prelude.String)
getExitMacro = Automation.propertyGetID 0x4 [] Automation.outString
setExitMacro :: Prelude.String -> IFormField a -> Prelude.IO ()
setExitMacro prop =
  Automation.propertySetID 0x4 [Automation.inString prop]
getOwnHelp :: IFormField a -> Prelude.IO (Prelude.Int)
getOwnHelp = Automation.propertyGetID 0x5 [] Automation.outInt
setOwnHelp :: Prelude.Int -> IFormField a -> Prelude.IO ()
setOwnHelp prop =
  Automation.propertySetID 0x5 [Automation.inInt prop]
getOwnStatus :: IFormField a -> Prelude.IO (Prelude.Int)
getOwnStatus = Automation.propertyGetID 0x6 [] Automation.outInt
setOwnStatus :: Prelude.Int -> IFormField a -> Prelude.IO ()
setOwnStatus prop =
  Automation.propertySetID 0x6 [Automation.inInt prop]
getHelpText :: IFormField a -> Prelude.IO (Prelude.String)
getHelpText = Automation.propertyGetID 0x7 [] Automation.outString
setHelpText :: Prelude.String -> IFormField a -> Prelude.IO ()
setHelpText prop =
  Automation.propertySetID 0x7 [Automation.inString prop]
getStatusText :: IFormField a -> Prelude.IO (Prelude.String)
getStatusText =
  Automation.propertyGetID 0x8 [] Automation.outString
setStatusText :: Prelude.String -> IFormField a -> Prelude.IO ()
setStatusText prop =
  Automation.propertySetID 0x8 [Automation.inString prop]
getEnabled :: IFormField a -> Prelude.IO (Prelude.Int)
getEnabled = Automation.propertyGetID 0x9 [] Automation.outInt
setEnabled :: Prelude.Int -> IFormField a -> Prelude.IO ()
setEnabled prop =
  Automation.propertySetID 0x9 [Automation.inInt prop]
getResult0 :: IFormField a -> Prelude.IO (Prelude.String)
getResult0 = Automation.propertyGetID 0xa [] Automation.outString
setResult0 :: Prelude.String -> IFormField a -> Prelude.IO ()
setResult0 prop =
  Automation.propertySetID 0xa [Automation.inString prop]
getTextInput :: IFormField a -> Prelude.IO (ITextInput Automation.Interface)
getTextInput =
  Automation.propertyGetID 0xb [] Automation.outIDispatch
getCheckBox :: IFormField a -> Prelude.IO (ICheckBox Automation.Interface)
getCheckBox =
  Automation.propertyGetID 0xc [] Automation.outIDispatch
getDropDown :: IFormField a -> Prelude.IO (IDropDown Automation.Interface)
getDropDown =
  Automation.propertyGetID 0xd [] Automation.outIDispatch
getNext6 :: IFormField a -> Prelude.IO (IFormField Automation.Interface)
getNext6 = Automation.propertyGetID 0xe [] Automation.outIDispatch
getPrevious6 :: IFormField a -> Prelude.IO (IFormField Automation.Interface)
getPrevious6 =
  Automation.propertyGetID 0xf [] Automation.outIDispatch
getCalculateOnExit :: IFormField a -> Prelude.IO (Prelude.Int)
getCalculateOnExit =
  Automation.propertyGetID 0x10 [] Automation.outInt
setCalculateOnExit :: Prelude.Int -> IFormField a -> Prelude.IO ()
setCalculateOnExit prop =
  Automation.propertySetID 0x10 [Automation.inInt prop]
-- --------------------------------------------------
-- 
-- interface TextInput
-- 
-- --------------------------------------------------
data TextInput a = TextInput
                    
type ITextInput a = Automation.IDispatch (TextInput a)
iidITextInput :: Com.IID (ITextInput Automation.Interface)
iidITextInput = Com.mkIID "{00020927-0000-0000-C000-000000000046}"
getValid :: Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getValid = Automation.propertyGetID 0o0 [] Automation.outInt
getDefault :: ITextInput a -> Prelude.IO (Prelude.String)
getDefault = Automation.propertyGetID 0x1 [] Automation.outString
setDefault :: Prelude.String -> ITextInput a -> Prelude.IO ()
setDefault prop =
  Automation.propertySetID 0x1 [Automation.inString prop]
getType6 :: (Automation.Variant a0) => ITextInput a -> Prelude.IO (a0)
getType6 = Automation.propertyGetID 0x2 [] Automation.outVariant
getFormat2 :: ITextInput a -> Prelude.IO (Prelude.String)
getFormat2 = Automation.propertyGetID 0x3 [] Automation.outString
editType :: (Automation.Variant a0) => a0 -> Prelude.Int -> Prelude.Int -> Prelude.Int -> ITextInput a -> Prelude.IO ()
editType type0 default0 format enabled =
  Automation.methodID0 0x66 [Automation.inVariant type0, Automation.inInt default0, Automation.inInt format, Automation.inInt enabled]
-- --------------------------------------------------
-- 
-- interface CheckBox
-- 
-- --------------------------------------------------
data CheckBox a = CheckBox
                   
type ICheckBox a = Automation.IDispatch (CheckBox a)
iidICheckBox :: Com.IID (ICheckBox Automation.Interface)
iidICheckBox = Com.mkIID "{00020926-0000-0000-C000-000000000046}"
getAutoSize :: ICheckBox a -> Prelude.IO (Prelude.Int)
getAutoSize = Automation.propertyGetID 0x1 [] Automation.outInt
setAutoSize :: Prelude.Int -> ICheckBox a -> Prelude.IO ()
setAutoSize prop =
  Automation.propertySetID 0x1 [Automation.inInt prop]
getDefault0 :: ICheckBox a -> Prelude.IO (Prelude.Int)
getDefault0 = Automation.propertyGetID 0x3 [] Automation.outInt
setDefault0 :: Prelude.Int -> ICheckBox a -> Prelude.IO ()
setDefault0 prop =
  Automation.propertySetID 0x3 [Automation.inInt prop]
getValue2 :: ICheckBox a -> Prelude.IO (Prelude.Int)
getValue2 = Automation.propertyGetID 0x4 [] Automation.outInt
setValue2 :: Prelude.Int -> ICheckBox a -> Prelude.IO ()
setValue2 prop =
  Automation.propertySetID 0x4 [Automation.inInt prop]
-- --------------------------------------------------
-- 
-- interface DropDown
-- 
-- --------------------------------------------------
data DropDown a = DropDown
                   
type IDropDown a = Automation.IDispatch (DropDown a)
iidIDropDown :: Com.IID (IDropDown Automation.Interface)
iidIDropDown = Com.mkIID "{00020925-0000-0000-C000-000000000046}"
getDefault1 :: IDropDown a -> Prelude.IO (Prelude.Int)
getDefault1 = Automation.propertyGetID 0x1 [] Automation.outInt
setDefault1 :: Prelude.Int -> IDropDown a -> Prelude.IO ()
setDefault1 prop =
  Automation.propertySetID 0x1 [Automation.inInt prop]
getValue3 :: IDropDown a -> Prelude.IO (Prelude.Int)
getValue3 = Automation.propertyGetID 0x2 [] Automation.outInt
setValue3 :: Prelude.Int -> IDropDown a -> Prelude.IO ()
setValue3 prop =
  Automation.propertySetID 0x2 [Automation.inInt prop]
getListEntries :: IDropDown a -> Prelude.IO (IListEntries Automation.Interface)
getListEntries =
  Automation.propertyGetID 0x3 [] Automation.outIDispatch
-- --------------------------------------------------
-- 
-- interface ListEntries
-- 
-- --------------------------------------------------
data ListEntries a = ListEntries
                      
type IListEntries a = Automation.IDispatch (ListEntries a)
iidIListEntries :: Com.IID (IListEntries Automation.Interface)
iidIListEntries =
  Com.mkIID "{00020924-0000-0000-C000-000000000046}"
item30 :: Prelude.Int -> IListEntries a -> Prelude.IO (IListEntry Automation.Interface)
item30 idx =
  Automation.functionID1 0o0 [Automation.inInt idx] Automation.outIDispatch
add23 :: Prelude.String -> Prelude.Int -> IListEntries a -> Prelude.IO (IListEntry Automation.Interface)
add23 name idx =
  Automation.functionID1 0x65 [Automation.inString name, Automation.inInt idx] Automation.outIDispatch
-- --------------------------------------------------
-- 
-- interface ListEntry
-- 
-- --------------------------------------------------
data ListEntry a = ListEntry
                    
type IListEntry a = Automation.IDispatch (ListEntry a)
iidIListEntry :: Com.IID (IListEntry Automation.Interface)
iidIListEntry = Com.mkIID "{00020923-0000-0000-C000-000000000046}"
-- --------------------------------------------------
-- 
-- interface TablesOfFigures
-- 
-- --------------------------------------------------
data TablesOfFigures a = TablesOfFigures
                          
type ITablesOfFigures a = Automation.IDispatch (TablesOfFigures a)
iidITablesOfFigures :: Com.IID (ITablesOfFigures Automation.Interface)
iidITablesOfFigures =
  Com.mkIID "{00020922-0000-0000-C000-000000000046}"
getFormat3 :: (Automation.Variant a0) => ITablesOfFigures a -> Prelude.IO (a0)
getFormat3 = Automation.propertyGetID 0x2 [] Automation.outVariant
setFormat2 :: (Automation.Variant a0) => a0 -> ITablesOfFigures a -> Prelude.IO ()
setFormat2 prop =
  Automation.propertySetID 0x2 [Automation.inVariant prop]
item31 :: Prelude.Int -> ITablesOfFigures a -> Prelude.IO (ITableOfFigures Automation.Interface)
item31 idex =
  Automation.functionID1 0o0 [Automation.inInt idex] Automation.outIDispatch
add24 :: IRange a0 -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> ITablesOfFigures a -> Prelude.IO (ITableOfFigures Automation.Interface)
add24 range caption includeLabel useHeadingStyles upperHeadingLevel lowerHeadingLevel useFields tableID rightAlignPageNumbers includePageNumbers addedStyles =
  Automation.functionID1 0x64 [Automation.inIDispatch range, Automation.inInt caption, Automation.inInt includeLabel, Automation.inInt useHeadingStyles, Automation.inInt upperHeadingLevel, Automation.inInt lowerHeadingLevel, Automation.inInt useFields, Automation.inInt tableID, Automation.inInt rightAlignPageNumbers, Automation.inInt includePageNumbers, Automation.inInt addedStyles] Automation.outIDispatch
markEntry :: IRange a0 -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Automation.IDispatch a -> Prelude.IO (IField Automation.Interface)
markEntry range entry entryAutoText tableID level =
  Automation.functionID1 0x65 [Automation.inIDispatch range, Automation.inInt entry, Automation.inInt entryAutoText, Automation.inInt tableID, Automation.inInt level] Automation.outIDispatch
-- --------------------------------------------------
-- 
-- interface TableOfFigures
-- 
-- --------------------------------------------------
data TableOfFigures a = TableOfFigures
                         
type ITableOfFigures a = Automation.IDispatch (TableOfFigures a)
iidITableOfFigures :: Com.IID (ITableOfFigures Automation.Interface)
iidITableOfFigures =
  Com.mkIID "{00020921-0000-0000-C000-000000000046}"
getIncludeLabel :: ITableOfFigures a -> Prelude.IO (Prelude.Int)
getIncludeLabel = Automation.propertyGetID 0x2 [] Automation.outInt
setIncludeLabel :: Prelude.Int -> ITableOfFigures a -> Prelude.IO ()
setIncludeLabel prop =
  Automation.propertySetID 0x2 [Automation.inInt prop]
getRightAlignPageNumbers :: Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getRightAlignPageNumbers =
  Automation.propertyGetID 0x3 [] Automation.outInt
setRightAlignPageNumbers :: Prelude.Int -> Automation.IDispatch a -> Prelude.IO ()
setRightAlignPageNumbers prop =
  Automation.propertySetID 0x3 [Automation.inInt prop]
getUseHeadingStyles :: Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getUseHeadingStyles =
  Automation.propertyGetID 0x4 [] Automation.outInt
setUseHeadingStyles :: Prelude.Int -> Automation.IDispatch a -> Prelude.IO ()
setUseHeadingStyles prop =
  Automation.propertySetID 0x4 [Automation.inInt prop]
getLowerHeadingLevel :: Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getLowerHeadingLevel =
  Automation.propertyGetID 0x5 [] Automation.outInt
setLowerHeadingLevel :: Prelude.Int -> Automation.IDispatch a -> Prelude.IO ()
setLowerHeadingLevel prop =
  Automation.propertySetID 0x5 [Automation.inInt prop]
getUpperHeadingLevel :: Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getUpperHeadingLevel =
  Automation.propertyGetID 0x6 [] Automation.outInt
setUpperHeadingLevel :: Prelude.Int -> Automation.IDispatch a -> Prelude.IO ()
setUpperHeadingLevel prop =
  Automation.propertySetID 0x6 [Automation.inInt prop]
getIncludePageNumbers :: Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getIncludePageNumbers =
  Automation.propertyGetID 0x7 [] Automation.outInt
setIncludePageNumbers :: Prelude.Int -> Automation.IDispatch a -> Prelude.IO ()
setIncludePageNumbers prop =
  Automation.propertySetID 0x7 [Automation.inInt prop]
getUseFields :: Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getUseFields = Automation.propertyGetID 0x9 [] Automation.outInt
setUseFields :: Prelude.Int -> Automation.IDispatch a -> Prelude.IO ()
setUseFields prop =
  Automation.propertySetID 0x9 [Automation.inInt prop]
getTableID :: Automation.IDispatch a -> Prelude.IO (Prelude.String)
getTableID = Automation.propertyGetID 0xa [] Automation.outString
setTableID :: Prelude.String -> Automation.IDispatch a -> Prelude.IO ()
setTableID prop =
  Automation.propertySetID 0xa [Automation.inString prop]
getHeadingStyles :: Automation.IDispatch a -> Prelude.IO (IHeadingStyles Automation.Interface)
getHeadingStyles =
  Automation.propertyGetID 0xb [] Automation.outIDispatch
getTabLeader :: (Automation.Variant a0) => Automation.IDispatch a -> Prelude.IO (a0)
getTabLeader =
  Automation.propertyGetID 0xc [] Automation.outVariant
setTabLeader :: (Automation.Variant a0) => a0 -> Automation.IDispatch a -> Prelude.IO ()
setTabLeader prop =
  Automation.propertySetID 0xc [Automation.inVariant prop]
updatePageNumbers :: Automation.IDispatch a -> Prelude.IO ()
updatePageNumbers = Automation.methodID0 0x65 []
-- --------------------------------------------------
-- 
-- interface MailMerge
-- 
-- --------------------------------------------------
data MailMerge a = MailMerge
                    
type IMailMerge a = Automation.IDispatch (MailMerge a)
iidIMailMerge :: Com.IID (IMailMerge Automation.Interface)
iidIMailMerge = Com.mkIID "{00020920-0000-0000-C000-000000000046}"
getMainDocumentType :: (Automation.Variant a0) => IMailMerge a -> Prelude.IO (a0)
getMainDocumentType =
  Automation.propertyGetID 0x1 [] Automation.outVariant
setMainDocumentType :: (Automation.Variant a0) => a0 -> IMailMerge a -> Prelude.IO ()
setMainDocumentType prop =
  Automation.propertySetID 0x1 [Automation.inVariant prop]
getState :: (Automation.Variant a0) => IMailMerge a -> Prelude.IO (a0)
getState = Automation.propertyGetID 0x2 [] Automation.outVariant
getDestination :: (Automation.Variant a0) => IMailMerge a -> Prelude.IO (a0)
getDestination =
  Automation.propertyGetID 0x3 [] Automation.outVariant
setDestination :: (Automation.Variant a0) => a0 -> IMailMerge a -> Prelude.IO ()
setDestination prop =
  Automation.propertySetID 0x3 [Automation.inVariant prop]
getDataSource :: IMailMerge a -> Prelude.IO (IMailMergeDataSource Automation.Interface)
getDataSource =
  Automation.propertyGetID 0x4 [] Automation.outIDispatch
getFields1 :: IMailMerge a -> Prelude.IO (IMailMergeFields Automation.Interface)
getFields1 =
  Automation.propertyGetID 0x5 [] Automation.outIDispatch
getViewMailMergeFieldCodes :: IMailMerge a -> Prelude.IO (Prelude.Int)
getViewMailMergeFieldCodes =
  Automation.propertyGetID 0x6 [] Automation.outInt
setViewMailMergeFieldCodes :: Prelude.Int -> IMailMerge a -> Prelude.IO ()
setViewMailMergeFieldCodes prop =
  Automation.propertySetID 0x6 [Automation.inInt prop]
getSuppressBlankLines :: IMailMerge a -> Prelude.IO (Prelude.Int)
getSuppressBlankLines =
  Automation.propertyGetID 0x7 [] Automation.outInt
setSuppressBlankLines :: Prelude.Int -> IMailMerge a -> Prelude.IO ()
setSuppressBlankLines prop =
  Automation.propertySetID 0x7 [Automation.inInt prop]
getMailAsAttachment :: IMailMerge a -> Prelude.IO (Prelude.Int)
getMailAsAttachment =
  Automation.propertyGetID 0x8 [] Automation.outInt
setMailAsAttachment :: Prelude.Int -> IMailMerge a -> Prelude.IO ()
setMailAsAttachment prop =
  Automation.propertySetID 0x8 [Automation.inInt prop]
getMailAddressFieldName :: IMailMerge a -> Prelude.IO (Prelude.String)
getMailAddressFieldName =
  Automation.propertyGetID 0x9 [] Automation.outString
setMailAddressFieldName :: Prelude.String -> IMailMerge a -> Prelude.IO ()
setMailAddressFieldName prop =
  Automation.propertySetID 0x9 [Automation.inString prop]
getMailSubject :: IMailMerge a -> Prelude.IO (Prelude.String)
getMailSubject =
  Automation.propertyGetID 0xa [] Automation.outString
setMailSubject :: Prelude.String -> IMailMerge a -> Prelude.IO ()
setMailSubject prop =
  Automation.propertySetID 0xa [Automation.inString prop]
createDataSource :: Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> IMailMerge a -> Prelude.IO ()
createDataSource name passwordDocument writePasswordDocument headerRecord mSQuery sQLStatement sQLStatement1 connection linkToSource =
  Automation.methodID0 0x65 [Automation.inInt name, Automation.inInt passwordDocument, Automation.inInt writePasswordDocument, Automation.inInt headerRecord, Automation.inInt mSQuery, Automation.inInt sQLStatement, Automation.inInt sQLStatement1, Automation.inInt connection, Automation.inInt linkToSource]
createHeaderSource :: Prelude.String -> Prelude.Int -> Prelude.Int -> Prelude.Int -> IMailMerge a -> Prelude.IO ()
createHeaderSource name passwordDocument writePasswordDocument headerRecord =
  Automation.methodID0 0x66 [Automation.inString name, Automation.inInt passwordDocument, Automation.inInt writePasswordDocument, Automation.inInt headerRecord]
openDataSource :: Prelude.String -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> IMailMerge a -> Prelude.IO ()
openDataSource name format confirmConversions readOnly linkToSource addToRecentFiles passwordDocument passwordTemplate revert writePasswordDocument writePasswordTemplate connection sQLStatement sQLStatement1 =
  Automation.methodID0 0x67 [Automation.inString name, Automation.inInt format, Automation.inInt confirmConversions, Automation.inInt readOnly, Automation.inInt linkToSource, Automation.inInt addToRecentFiles, Automation.inInt passwordDocument, Automation.inInt passwordTemplate, Automation.inInt revert, Automation.inInt writePasswordDocument, Automation.inInt writePasswordTemplate, Automation.inInt connection, Automation.inInt sQLStatement, Automation.inInt sQLStatement1]
openHeaderSource :: Prelude.String -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> IMailMerge a -> Prelude.IO ()
openHeaderSource name format confirmConversions readOnly addToRecentFiles passwordDocument passwordTemplate revert writePasswordDocument writePasswordTemplate =
  Automation.methodID0 0x68 [Automation.inString name, Automation.inInt format, Automation.inInt confirmConversions, Automation.inInt readOnly, Automation.inInt addToRecentFiles, Automation.inInt passwordDocument, Automation.inInt passwordTemplate, Automation.inInt revert, Automation.inInt writePasswordDocument, Automation.inInt writePasswordTemplate]
execute0 :: Prelude.Int -> Automation.IDispatch a -> Prelude.IO ()
execute0 pause = Automation.methodID0 0x69 [Automation.inInt pause]
check :: IMailMerge a -> Prelude.IO ()
check = Automation.methodID0 0x6a []
editDataSource :: IMailMerge a -> Prelude.IO ()
editDataSource = Automation.methodID0 0x6b []
editHeaderSource :: IMailMerge a -> Prelude.IO ()
editHeaderSource = Automation.methodID0 0x6c []
editMainDocument :: IMailMerge a -> Prelude.IO ()
editMainDocument = Automation.methodID0 0x6d []
useAddressBook :: Prelude.String -> IMailMerge a -> Prelude.IO ()
useAddressBook type0 =
  Automation.methodID0 0x6f [Automation.inString type0]
-- --------------------------------------------------
-- 
-- interface MailMergeFields
-- 
-- --------------------------------------------------
data MailMergeFields a = MailMergeFields
                          
type IMailMergeFields a = Automation.IDispatch (MailMergeFields a)
iidIMailMergeFields :: Com.IID (IMailMergeFields Automation.Interface)
iidIMailMergeFields =
  Com.mkIID "{0002091F-0000-0000-C000-000000000046}"
item32 :: Prelude.Int -> IMailMergeFields a -> Prelude.IO (IMailMergeField Automation.Interface)
item32 idex =
  Automation.functionID1 0o0 [Automation.inInt idex] Automation.outIDispatch
add25 :: IRange a0 -> Prelude.String -> IMailMergeFields a -> Prelude.IO (IMailMergeField Automation.Interface)
add25 range name =
  Automation.functionID1 0x65 [Automation.inIDispatch range, Automation.inString name] Automation.outIDispatch
addAsk :: IRange a0 -> Prelude.String -> Prelude.Int -> Prelude.Int -> Prelude.Int -> IMailMergeFields a -> Prelude.IO (IMailMergeField Automation.Interface)
addAsk range name prompt defaultAskText askOnce =
  Automation.functionID1 0x66 [Automation.inIDispatch range, Automation.inString name, Automation.inInt prompt, Automation.inInt defaultAskText, Automation.inInt askOnce] Automation.outIDispatch
addFillIn :: IRange a0 -> Prelude.Int -> Prelude.Int -> Prelude.Int -> IMailMergeFields a -> Prelude.IO (IMailMergeField Automation.Interface)
addFillIn range prompt defaultFillInText askOnce =
  Automation.functionID1 0x67 [Automation.inIDispatch range, Automation.inInt prompt, Automation.inInt defaultFillInText, Automation.inInt askOnce] Automation.outIDispatch
addIf :: (Automation.Variant a1) => IRange a0 -> Prelude.String -> a1 -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> IMailMergeFields a -> Prelude.IO (IMailMergeField Automation.Interface)
addIf range mergeField comparison compareTo trueAutoText trueText falseAutoText falseText =
  Automation.functionID1 0x68 [Automation.inIDispatch range, Automation.inString mergeField, Automation.inVariant comparison, Automation.inInt compareTo, Automation.inInt trueAutoText, Automation.inInt trueText, Automation.inInt falseAutoText, Automation.inInt falseText] Automation.outIDispatch
addMergeRec :: IRange a0 -> IMailMergeFields a -> Prelude.IO (IMailMergeField Automation.Interface)
addMergeRec range =
  Automation.functionID1 0x69 [Automation.inIDispatch range] Automation.outIDispatch
addMergeSeq :: IRange a0 -> IMailMergeFields a -> Prelude.IO (IMailMergeField Automation.Interface)
addMergeSeq range =
  Automation.functionID1 0x6a [Automation.inIDispatch range] Automation.outIDispatch
addNext :: IRange a0 -> IMailMergeFields a -> Prelude.IO (IMailMergeField Automation.Interface)
addNext range =
  Automation.functionID1 0x6b [Automation.inIDispatch range] Automation.outIDispatch
addNextIf :: (Automation.Variant a1) => IRange a0 -> Prelude.String -> a1 -> Prelude.Int -> IMailMergeFields a -> Prelude.IO (IMailMergeField Automation.Interface)
addNextIf range mergeField comparison compareTo =
  Automation.functionID1 0x6c [Automation.inIDispatch range, Automation.inString mergeField, Automation.inVariant comparison, Automation.inInt compareTo] Automation.outIDispatch
addSet :: IRange a0 -> Prelude.String -> Prelude.Int -> Prelude.Int -> IMailMergeFields a -> Prelude.IO (IMailMergeField Automation.Interface)
addSet range name valueText valueAutoText =
  Automation.functionID1 0x6d [Automation.inIDispatch range, Automation.inString name, Automation.inInt valueText, Automation.inInt valueAutoText] Automation.outIDispatch
addSkipIf :: (Automation.Variant a1) => IRange a0 -> Prelude.String -> a1 -> Prelude.Int -> IMailMergeFields a -> Prelude.IO (IMailMergeField Automation.Interface)
addSkipIf range mergeField comparison compareTo =
  Automation.functionID1 0x6e [Automation.inIDispatch range, Automation.inString mergeField, Automation.inVariant comparison, Automation.inInt compareTo] Automation.outIDispatch
-- --------------------------------------------------
-- 
-- interface MailMergeField
-- 
-- --------------------------------------------------
data MailMergeField a = MailMergeField
                         
type IMailMergeField a = Automation.IDispatch (MailMergeField a)
iidIMailMergeField :: Com.IID (IMailMergeField Automation.Interface)
iidIMailMergeField =
  Com.mkIID "{0002091E-0000-0000-C000-000000000046}"
getNext7 :: IMailMergeField a -> Prelude.IO (IMailMergeField Automation.Interface)
getNext7 = Automation.propertyGetID 0x8 [] Automation.outIDispatch
getPrevious7 :: IMailMergeField a -> Prelude.IO (IMailMergeField Automation.Interface)
getPrevious7 =
  Automation.propertyGetID 0x9 [] Automation.outIDispatch
-- --------------------------------------------------
-- 
-- interface MailMergeDataSource
-- 
-- --------------------------------------------------
data MailMergeDataSource a = MailMergeDataSource
                              
type IMailMergeDataSource a = Automation.IDispatch (MailMergeDataSource a)
iidIMailMergeDataSource :: Com.IID (IMailMergeDataSource Automation.Interface)
iidIMailMergeDataSource =
  Com.mkIID "{0002091D-0000-0000-C000-000000000046}"
getHeaderSourceName :: IMailMergeDataSource a -> Prelude.IO (Prelude.String)
getHeaderSourceName =
  Automation.propertyGetID 0x2 [] Automation.outString
getType8 :: (Automation.Variant a0) => IMailMergeDataSource a -> Prelude.IO (a0)
getType8 = Automation.propertyGetID 0x3 [] Automation.outVariant
getHeaderSourceType :: (Automation.Variant a0) => IMailMergeDataSource a -> Prelude.IO (a0)
getHeaderSourceType =
  Automation.propertyGetID 0x4 [] Automation.outVariant
getConnectString :: IMailMergeDataSource a -> Prelude.IO (Prelude.String)
getConnectString =
  Automation.propertyGetID 0x5 [] Automation.outString
getQueryString :: IMailMergeDataSource a -> Prelude.IO (Prelude.String)
getQueryString =
  Automation.propertyGetID 0x6 [] Automation.outString
setQueryString :: Prelude.String -> IMailMergeDataSource a -> Prelude.IO ()
setQueryString prop =
  Automation.propertySetID 0x6 [Automation.inString prop]
getActiveRecord :: (Automation.Variant a0) => IMailMergeDataSource a -> Prelude.IO (a0)
getActiveRecord =
  Automation.propertyGetID 0x7 [] Automation.outVariant
setActiveRecord :: (Automation.Variant a0) => a0 -> IMailMergeDataSource a -> Prelude.IO ()
setActiveRecord prop =
  Automation.propertySetID 0x7 [Automation.inVariant prop]
getFirstRecord :: IMailMergeDataSource a -> Prelude.IO (Prelude.Int)
getFirstRecord = Automation.propertyGetID 0x8 [] Automation.outInt
setFirstRecord :: Prelude.Int -> IMailMergeDataSource a -> Prelude.IO ()
setFirstRecord prop =
  Automation.propertySetID 0x8 [Automation.inInt prop]
getLastRecord :: IMailMergeDataSource a -> Prelude.IO (Prelude.Int)
getLastRecord = Automation.propertyGetID 0x9 [] Automation.outInt
setLastRecord :: Prelude.Int -> IMailMergeDataSource a -> Prelude.IO ()
setLastRecord prop =
  Automation.propertySetID 0x9 [Automation.inInt prop]
getFieldNames :: IMailMergeDataSource a -> Prelude.IO (IMailMergeFieldNames Automation.Interface)
getFieldNames =
  Automation.propertyGetID 0xa [] Automation.outIDispatch
getDataFields :: IMailMergeDataSource a -> Prelude.IO (IMailMergeDataFields Automation.Interface)
getDataFields =
  Automation.propertyGetID 0xb [] Automation.outIDispatch
findRecord :: Prelude.String -> Prelude.String -> IMailMergeDataSource a -> Prelude.IO (Prelude.Int)
findRecord findText field =
  Automation.functionID1 0x65 [Automation.inString findText, Automation.inString field] Automation.outInt
-- --------------------------------------------------
-- 
-- interface MailMergeFieldNames
-- 
-- --------------------------------------------------
data MailMergeFieldNames a = MailMergeFieldNames
                              
type IMailMergeFieldNames a = Automation.IDispatch (MailMergeFieldNames a)
iidIMailMergeFieldNames :: Com.IID (IMailMergeFieldNames Automation.Interface)
iidIMailMergeFieldNames =
  Com.mkIID "{0002091C-0000-0000-C000-000000000046}"
item33 :: Prelude.Int -> IMailMergeFieldNames a -> Prelude.IO (IMailMergeFieldName Automation.Interface)
item33 idx =
  Automation.functionID1 0o0 [Automation.inInt idx] Automation.outIDispatch
-- --------------------------------------------------
-- 
-- interface MailMergeFieldName
-- 
-- --------------------------------------------------
data MailMergeFieldName a = MailMergeFieldName
                             
type IMailMergeFieldName a = Automation.IDispatch (MailMergeFieldName a)
iidIMailMergeFieldName :: Com.IID (IMailMergeFieldName Automation.Interface)
iidIMailMergeFieldName =
  Com.mkIID "{0002091B-0000-0000-C000-000000000046}"
-- --------------------------------------------------
-- 
-- interface MailMergeDataFields
-- 
-- --------------------------------------------------
data MailMergeDataFields a = MailMergeDataFields
                              
type IMailMergeDataFields a = Automation.IDispatch (MailMergeDataFields a)
iidIMailMergeDataFields :: Com.IID (IMailMergeDataFields Automation.Interface)
iidIMailMergeDataFields =
  Com.mkIID "{0002091A-0000-0000-C000-000000000046}"
item34 :: Prelude.Int -> IMailMergeDataFields a -> Prelude.IO (IMailMergeDataField Automation.Interface)
item34 idx =
  Automation.functionID1 0o0 [Automation.inInt idx] Automation.outIDispatch
-- --------------------------------------------------
-- 
-- interface MailMergeDataField
-- 
-- --------------------------------------------------
data MailMergeDataField a = MailMergeDataField
                             
type IMailMergeDataField a = Automation.IDispatch (MailMergeDataField a)
iidIMailMergeDataField :: Com.IID (IMailMergeDataField Automation.Interface)
iidIMailMergeDataField =
  Com.mkIID "{00020919-0000-0000-C000-000000000046}"
-- --------------------------------------------------
-- 
-- interface Envelope
-- 
-- --------------------------------------------------
data Envelope a = Envelope
                   
type IEnvelope a = Automation.IDispatch (Envelope a)
iidIEnvelope :: Com.IID (IEnvelope Automation.Interface)
iidIEnvelope = Com.mkIID "{00020918-0000-0000-C000-000000000046}"
getAddress0 :: IEnvelope a -> Prelude.IO (IRange Automation.Interface)
getAddress0 =
  Automation.propertyGetID 0x1 [] Automation.outIDispatch
getReturnAddress :: IEnvelope a -> Prelude.IO (IRange Automation.Interface)
getReturnAddress =
  Automation.propertyGetID 0x2 [] Automation.outIDispatch
getDefaultPrintBarCode :: Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getDefaultPrintBarCode =
  Automation.propertyGetID 0x4 [] Automation.outInt
setDefaultPrintBarCode :: Prelude.Int -> Automation.IDispatch a -> Prelude.IO ()
setDefaultPrintBarCode prop =
  Automation.propertySetID 0x4 [Automation.inInt prop]
getDefaultPrintFIMA :: IEnvelope a -> Prelude.IO (Prelude.Int)
getDefaultPrintFIMA =
  Automation.propertyGetID 0x5 [] Automation.outInt
setDefaultPrintFIMA :: Prelude.Int -> IEnvelope a -> Prelude.IO ()
setDefaultPrintFIMA prop =
  Automation.propertySetID 0x5 [Automation.inInt prop]
getDefaultHeight :: IEnvelope a -> Prelude.IO (Prelude.Float)
getDefaultHeight =
  Automation.propertyGetID 0x6 [] Automation.outFloat
setDefaultHeight :: Prelude.Float -> IEnvelope a -> Prelude.IO ()
setDefaultHeight prop =
  Automation.propertySetID 0x6 [Automation.inFloat prop]
getDefaultWidth :: IEnvelope a -> Prelude.IO (Prelude.Float)
getDefaultWidth =
  Automation.propertyGetID 0x7 [] Automation.outFloat
setDefaultWidth :: Prelude.Float -> IEnvelope a -> Prelude.IO ()
setDefaultWidth prop =
  Automation.propertySetID 0x7 [Automation.inFloat prop]
getDefaultSize :: IEnvelope a -> Prelude.IO (Prelude.String)
getDefaultSize =
  Automation.propertyGetID 0o0 [] Automation.outString
setDefaultSize :: Prelude.String -> IEnvelope a -> Prelude.IO ()
setDefaultSize prop =
  Automation.propertySetID 0o0 [Automation.inString prop]
getDefaultOmitReturnAddress :: IEnvelope a -> Prelude.IO (Prelude.Int)
getDefaultOmitReturnAddress =
  Automation.propertyGetID 0x9 [] Automation.outInt
setDefaultOmitReturnAddress :: Prelude.Int -> IEnvelope a -> Prelude.IO ()
setDefaultOmitReturnAddress prop =
  Automation.propertySetID 0x9 [Automation.inInt prop]
getFeedSource :: (Automation.Variant a0) => IEnvelope a -> Prelude.IO (a0)
getFeedSource =
  Automation.propertyGetID 0xc [] Automation.outVariant
setFeedSource :: (Automation.Variant a0) => a0 -> IEnvelope a -> Prelude.IO ()
setFeedSource prop =
  Automation.propertySetID 0xc [Automation.inVariant prop]
getAddressFromLeft :: IEnvelope a -> Prelude.IO (Prelude.Float)
getAddressFromLeft =
  Automation.propertyGetID 0xd [] Automation.outFloat
setAddressFromLeft :: Prelude.Float -> IEnvelope a -> Prelude.IO ()
setAddressFromLeft prop =
  Automation.propertySetID 0xd [Automation.inFloat prop]
getAddressFromTop :: IEnvelope a -> Prelude.IO (Prelude.Float)
getAddressFromTop =
  Automation.propertyGetID 0xe [] Automation.outFloat
setAddressFromTop :: Prelude.Float -> IEnvelope a -> Prelude.IO ()
setAddressFromTop prop =
  Automation.propertySetID 0xe [Automation.inFloat prop]
getReturnAddressFromLeft :: IEnvelope a -> Prelude.IO (Prelude.Float)
getReturnAddressFromLeft =
  Automation.propertyGetID 0xf [] Automation.outFloat
setReturnAddressFromLeft :: Prelude.Float -> IEnvelope a -> Prelude.IO ()
setReturnAddressFromLeft prop =
  Automation.propertySetID 0xf [Automation.inFloat prop]
getReturnAddressFromTop :: IEnvelope a -> Prelude.IO (Prelude.Float)
getReturnAddressFromTop =
  Automation.propertyGetID 0x10 [] Automation.outFloat
setReturnAddressFromTop :: Prelude.Float -> IEnvelope a -> Prelude.IO ()
setReturnAddressFromTop prop =
  Automation.propertySetID 0x10 [Automation.inFloat prop]
getAddressStyle :: IEnvelope a -> Prelude.IO (IStyle Automation.Interface)
getAddressStyle =
  Automation.propertyGetID 0x11 [] Automation.outIDispatch
getReturnAddressStyle :: IEnvelope a -> Prelude.IO (IStyle Automation.Interface)
getReturnAddressStyle =
  Automation.propertyGetID 0x12 [] Automation.outIDispatch
getDefaultOrientation :: (Automation.Variant a0) => IEnvelope a -> Prelude.IO (a0)
getDefaultOrientation =
  Automation.propertyGetID 0x13 [] Automation.outVariant
setDefaultOrientation :: (Automation.Variant a0) => a0 -> IEnvelope a -> Prelude.IO ()
setDefaultOrientation prop =
  Automation.propertySetID 0x13 [Automation.inVariant prop]
getDefaultFaceUp :: IEnvelope a -> Prelude.IO (Prelude.Int)
getDefaultFaceUp =
  Automation.propertyGetID 0x14 [] Automation.outInt
setDefaultFaceUp :: Prelude.Int -> IEnvelope a -> Prelude.IO ()
setDefaultFaceUp prop =
  Automation.propertySetID 0x14 [Automation.inInt prop]
insert0 :: Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> IEnvelope a -> Prelude.IO ()
insert0 extractAddress address autoText omitReturnAddress returnAddress returnAutoText printBarCode printFIMA size height width feedSource addressFromLeft addressFromTop returnAddressFromLeft returnAddressFromTop defaultFaceUp defaultOrientation =
  Automation.methodID0 0x65 [Automation.inInt extractAddress, Automation.inInt address, Automation.inInt autoText, Automation.inInt omitReturnAddress, Automation.inInt returnAddress, Automation.inInt returnAutoText, Automation.inInt printBarCode, Automation.inInt printFIMA, Automation.inInt size, Automation.inInt height, Automation.inInt width, Automation.inInt feedSource, Automation.inInt addressFromLeft, Automation.inInt addressFromTop, Automation.inInt returnAddressFromLeft, Automation.inInt returnAddressFromTop, Automation.inInt defaultFaceUp, Automation.inInt defaultOrientation]
printOut2 :: Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Automation.IDispatch a -> Prelude.IO ()
printOut2 extractAddress address autoText omitReturnAddress returnAddress returnAutoText printBarCode printFIMA size height width feedSource addressFromLeft addressFromTop returnAddressFromLeft returnAddressFromTop defaultFaceUp defaultOrientation =
  Automation.methodID0 0x66 [Automation.inInt extractAddress, Automation.inInt address, Automation.inInt autoText, Automation.inInt omitReturnAddress, Automation.inInt returnAddress, Automation.inInt returnAutoText, Automation.inInt printBarCode, Automation.inInt printFIMA, Automation.inInt size, Automation.inInt height, Automation.inInt width, Automation.inInt feedSource, Automation.inInt addressFromLeft, Automation.inInt addressFromTop, Automation.inInt returnAddressFromLeft, Automation.inInt returnAddressFromTop, Automation.inInt defaultFaceUp, Automation.inInt defaultOrientation]
updateDocument :: IEnvelope a -> Prelude.IO ()
updateDocument = Automation.methodID0 0x67 []
-- --------------------------------------------------
-- 
-- interface MailingLabel
-- 
-- --------------------------------------------------
data MailingLabel a = MailingLabel
                       
type IMailingLabel a = Automation.IDispatch (MailingLabel a)
iidIMailingLabel :: Com.IID (IMailingLabel Automation.Interface)
iidIMailingLabel =
  Com.mkIID "{00020917-0000-0000-C000-000000000046}"
getDefaultLaserTray :: (Automation.Variant a0) => IMailingLabel a -> Prelude.IO (a0)
getDefaultLaserTray =
  Automation.propertyGetID 0x4 [] Automation.outVariant
setDefaultLaserTray :: (Automation.Variant a0) => a0 -> IMailingLabel a -> Prelude.IO ()
setDefaultLaserTray prop =
  Automation.propertySetID 0x4 [Automation.inVariant prop]
getCustomLabels :: IMailingLabel a -> Prelude.IO (ICustomLabels Automation.Interface)
getCustomLabels =
  Automation.propertyGetID 0x8 [] Automation.outIDispatch
getDefaultLabelName :: IMailingLabel a -> Prelude.IO (Prelude.String)
getDefaultLabelName =
  Automation.propertyGetID 0x9 [] Automation.outString
setDefaultLabelName :: Prelude.String -> IMailingLabel a -> Prelude.IO ()
setDefaultLabelName prop =
  Automation.propertySetID 0x9 [Automation.inString prop]
createNewDocument :: Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> IMailingLabel a -> Prelude.IO (IDocument Automation.Interface)
createNewDocument name address autoText extractAddress laserTray =
  Automation.functionID1 0x65 [Automation.inInt name, Automation.inInt address, Automation.inInt autoText, Automation.inInt extractAddress, Automation.inInt laserTray] Automation.outIDispatch
printOut3 :: Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Automation.IDispatch a -> Prelude.IO ()
printOut3 name address extractAddress laserTray singleLabel row column =
  Automation.methodID0 0x66 [Automation.inInt name, Automation.inInt address, Automation.inInt extractAddress, Automation.inInt laserTray, Automation.inInt singleLabel, Automation.inInt row, Automation.inInt column]
-- --------------------------------------------------
-- 
-- interface CustomLabels
-- 
-- --------------------------------------------------
data CustomLabels a = CustomLabels
                       
type ICustomLabels a = Automation.IDispatch (CustomLabels a)
iidICustomLabels :: Com.IID (ICustomLabels Automation.Interface)
iidICustomLabels =
  Com.mkIID "{00020916-0000-0000-C000-000000000046}"
item35 :: Prelude.Int -> ICustomLabels a -> Prelude.IO (ICustomLabel Automation.Interface)
item35 idx =
  Automation.functionID1 0o0 [Automation.inInt idx] Automation.outIDispatch
add26 :: Prelude.String -> Prelude.Int -> ICustomLabels a -> Prelude.IO (ICustomLabel Automation.Interface)
add26 name dotMatrix =
  Automation.functionID1 0x65 [Automation.inString name, Automation.inInt dotMatrix] Automation.outIDispatch
-- --------------------------------------------------
-- 
-- interface CustomLabel
-- 
-- --------------------------------------------------
data CustomLabel a = CustomLabel
                      
type ICustomLabel a = Automation.IDispatch (CustomLabel a)
iidICustomLabel :: Com.IID (ICustomLabel Automation.Interface)
iidICustomLabel =
  Com.mkIID "{00020915-0000-0000-C000-000000000046}"
getTopMargin :: Automation.IDispatch a -> Prelude.IO (Prelude.Float)
getTopMargin = Automation.propertyGetID 0x3 [] Automation.outFloat
setTopMargin :: Prelude.Float -> Automation.IDispatch a -> Prelude.IO ()
setTopMargin prop =
  Automation.propertySetID 0x3 [Automation.inFloat prop]
getSideMargin :: ICustomLabel a -> Prelude.IO (Prelude.Float)
getSideMargin = Automation.propertyGetID 0x4 [] Automation.outFloat
setSideMargin :: Prelude.Float -> ICustomLabel a -> Prelude.IO ()
setSideMargin prop =
  Automation.propertySetID 0x4 [Automation.inFloat prop]
getVerticalPitch :: ICustomLabel a -> Prelude.IO (Prelude.Float)
getVerticalPitch =
  Automation.propertyGetID 0x7 [] Automation.outFloat
setVerticalPitch :: Prelude.Float -> ICustomLabel a -> Prelude.IO ()
setVerticalPitch prop =
  Automation.propertySetID 0x7 [Automation.inFloat prop]
getHorizontalPitch :: ICustomLabel a -> Prelude.IO (Prelude.Float)
getHorizontalPitch =
  Automation.propertyGetID 0x8 [] Automation.outFloat
setHorizontalPitch :: Prelude.Float -> ICustomLabel a -> Prelude.IO ()
setHorizontalPitch prop =
  Automation.propertySetID 0x8 [Automation.inFloat prop]
getNumberAcross :: ICustomLabel a -> Prelude.IO (Prelude.Int)
getNumberAcross = Automation.propertyGetID 0x9 [] Automation.outInt
setNumberAcross :: Prelude.Int -> ICustomLabel a -> Prelude.IO ()
setNumberAcross prop =
  Automation.propertySetID 0x9 [Automation.inInt prop]
getNumberDown :: ICustomLabel a -> Prelude.IO (Prelude.Int)
getNumberDown = Automation.propertyGetID 0xa [] Automation.outInt
setNumberDown :: Prelude.Int -> ICustomLabel a -> Prelude.IO ()
setNumberDown prop =
  Automation.propertySetID 0xa [Automation.inInt prop]
getDotMatrix :: ICustomLabel a -> Prelude.IO (Prelude.Int)
getDotMatrix = Automation.propertyGetID 0xb [] Automation.outInt
getPageSize :: (Automation.Variant a0) => ICustomLabel a -> Prelude.IO (a0)
getPageSize = Automation.propertyGetID 0xc [] Automation.outVariant
setPageSize :: (Automation.Variant a0) => a0 -> ICustomLabel a -> Prelude.IO ()
setPageSize prop =
  Automation.propertySetID 0xc [Automation.inVariant prop]
-- --------------------------------------------------
-- 
-- interface TablesOfContents
-- 
-- --------------------------------------------------
data TablesOfContents a = TablesOfContents
                           
type ITablesOfContents a = Automation.IDispatch (TablesOfContents a)
iidITablesOfContents :: Com.IID (ITablesOfContents Automation.Interface)
iidITablesOfContents =
  Com.mkIID "{00020914-0000-0000-C000-000000000046}"
getFormat4 :: (Automation.Variant a0) => ITablesOfContents a -> Prelude.IO (a0)
getFormat4 = Automation.propertyGetID 0x2 [] Automation.outVariant
setFormat3 :: (Automation.Variant a0) => a0 -> ITablesOfContents a -> Prelude.IO ()
setFormat3 prop =
  Automation.propertySetID 0x2 [Automation.inVariant prop]
item36 :: Prelude.Int -> ITablesOfContents a -> Prelude.IO (ITableOfContents Automation.Interface)
item36 idex =
  Automation.functionID1 0o0 [Automation.inInt idex] Automation.outIDispatch
add27 :: IRange a0 -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> ITablesOfContents a -> Prelude.IO (ITableOfContents Automation.Interface)
add27 range useHeadingStyles upperHeadingLevel lowerHeadingLevel useFields tableID rightAlignPageNumbers includePageNumbers addedStyles =
  Automation.functionID1 0x64 [Automation.inIDispatch range, Automation.inInt useHeadingStyles, Automation.inInt upperHeadingLevel, Automation.inInt lowerHeadingLevel, Automation.inInt useFields, Automation.inInt tableID, Automation.inInt rightAlignPageNumbers, Automation.inInt includePageNumbers, Automation.inInt addedStyles] Automation.outIDispatch
-- --------------------------------------------------
-- 
-- interface TableOfContents
-- 
-- --------------------------------------------------
data TableOfContents a = TableOfContents
                          
type ITableOfContents a = Automation.IDispatch (TableOfContents a)
iidITableOfContents :: Com.IID (ITableOfContents Automation.Interface)
iidITableOfContents =
  Com.mkIID "{00020913-0000-0000-C000-000000000046}"
-- --------------------------------------------------
-- 
-- interface TablesOfAuthorities
-- 
-- --------------------------------------------------
data TablesOfAuthorities a = TablesOfAuthorities
                              
type ITablesOfAuthorities a = Automation.IDispatch (TablesOfAuthorities a)
iidITablesOfAuthorities :: Com.IID (ITablesOfAuthorities Automation.Interface)
iidITablesOfAuthorities =
  Com.mkIID "{00020912-0000-0000-C000-000000000046}"
getFormat5 :: (Automation.Variant a0) => ITablesOfAuthorities a -> Prelude.IO (a0)
getFormat5 = Automation.propertyGetID 0x2 [] Automation.outVariant
setFormat4 :: (Automation.Variant a0) => a0 -> ITablesOfAuthorities a -> Prelude.IO ()
setFormat4 prop =
  Automation.propertySetID 0x2 [Automation.inVariant prop]
item37 :: Prelude.Int -> ITablesOfAuthorities a -> Prelude.IO (ITableOfAuthorities Automation.Interface)
item37 idex =
  Automation.functionID1 0o0 [Automation.inInt idex] Automation.outIDispatch
add28 :: IRange a0 -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> ITablesOfAuthorities a -> Prelude.IO (ITableOfAuthorities Automation.Interface)
add28 range category bookmark passim keepEntryFormatting separator includeSequenceName entrySeparator pageRangeSeparator includeCategoryHeader pageNumberSeparator =
  Automation.functionID1 0x64 [Automation.inIDispatch range, Automation.inInt category, Automation.inInt bookmark, Automation.inInt passim, Automation.inInt keepEntryFormatting, Automation.inInt separator, Automation.inInt includeSequenceName, Automation.inInt entrySeparator, Automation.inInt pageRangeSeparator, Automation.inInt includeCategoryHeader, Automation.inInt pageNumberSeparator] Automation.outIDispatch
nextCitation :: Prelude.String -> ITablesOfAuthorities a -> Prelude.IO ()
nextCitation shortCitation =
  Automation.methodID0 0x67 [Automation.inString shortCitation]
markCitation :: IRange a0 -> Prelude.String -> Prelude.Int -> Prelude.Int -> Prelude.Int -> ITablesOfAuthorities a -> Prelude.IO (IField Automation.Interface)
markCitation range shortCitation longCitation longCitationAutoText category =
  Automation.functionID1 0x65 [Automation.inIDispatch range, Automation.inString shortCitation, Automation.inInt longCitation, Automation.inInt longCitationAutoText, Automation.inInt category] Automation.outIDispatch
markAllCitations :: Prelude.String -> Prelude.Int -> Prelude.Int -> Prelude.Int -> ITablesOfAuthorities a -> Prelude.IO ()
markAllCitations shortCitation longCitation longCitationAutoText category =
  Automation.methodID0 0x66 [Automation.inString shortCitation, Automation.inInt longCitation, Automation.inInt longCitationAutoText, Automation.inInt category]
-- --------------------------------------------------
-- 
-- interface TableOfAuthorities
-- 
-- --------------------------------------------------
data TableOfAuthorities a = TableOfAuthorities
                             
type ITableOfAuthorities a = Automation.IDispatch (TableOfAuthorities a)
iidITableOfAuthorities :: Com.IID (ITableOfAuthorities Automation.Interface)
iidITableOfAuthorities =
  Com.mkIID "{00020911-0000-0000-C000-000000000046}"
getPassim :: ITableOfAuthorities a -> Prelude.IO (Prelude.Int)
getPassim = Automation.propertyGetID 0x1 [] Automation.outInt
setPassim :: Prelude.Int -> ITableOfAuthorities a -> Prelude.IO ()
setPassim prop =
  Automation.propertySetID 0x1 [Automation.inInt prop]
getKeepEntryFormatting :: ITableOfAuthorities a -> Prelude.IO (Prelude.Int)
getKeepEntryFormatting =
  Automation.propertyGetID 0x2 [] Automation.outInt
setKeepEntryFormatting :: Prelude.Int -> ITableOfAuthorities a -> Prelude.IO ()
setKeepEntryFormatting prop =
  Automation.propertySetID 0x2 [Automation.inInt prop]
getCategory :: ITableOfAuthorities a -> Prelude.IO (Prelude.Int)
getCategory = Automation.propertyGetID 0x3 [] Automation.outInt
setCategory :: Prelude.Int -> ITableOfAuthorities a -> Prelude.IO ()
setCategory prop =
  Automation.propertySetID 0x3 [Automation.inInt prop]
getBookmark :: ITableOfAuthorities a -> Prelude.IO (Prelude.String)
getBookmark = Automation.propertyGetID 0x4 [] Automation.outString
setBookmark :: Prelude.String -> ITableOfAuthorities a -> Prelude.IO ()
setBookmark prop =
  Automation.propertySetID 0x4 [Automation.inString prop]
getSeparator1 :: ITableOfAuthorities a -> Prelude.IO (Prelude.String)
getSeparator1 =
  Automation.propertyGetID 0x5 [] Automation.outString
setSeparator :: Prelude.String -> ITableOfAuthorities a -> Prelude.IO ()
setSeparator prop =
  Automation.propertySetID 0x5 [Automation.inString prop]
getIncludeSequenceName :: ITableOfAuthorities a -> Prelude.IO (Prelude.String)
getIncludeSequenceName =
  Automation.propertyGetID 0x6 [] Automation.outString
setIncludeSequenceName :: Prelude.String -> ITableOfAuthorities a -> Prelude.IO ()
setIncludeSequenceName prop =
  Automation.propertySetID 0x6 [Automation.inString prop]
getEntrySeparator :: ITableOfAuthorities a -> Prelude.IO (Prelude.String)
getEntrySeparator =
  Automation.propertyGetID 0x7 [] Automation.outString
setEntrySeparator :: Prelude.String -> ITableOfAuthorities a -> Prelude.IO ()
setEntrySeparator prop =
  Automation.propertySetID 0x7 [Automation.inString prop]
getPageRangeSeparator :: ITableOfAuthorities a -> Prelude.IO (Prelude.String)
getPageRangeSeparator =
  Automation.propertyGetID 0x8 [] Automation.outString
setPageRangeSeparator :: Prelude.String -> ITableOfAuthorities a -> Prelude.IO ()
setPageRangeSeparator prop =
  Automation.propertySetID 0x8 [Automation.inString prop]
getIncludeCategoryHeader :: ITableOfAuthorities a -> Prelude.IO (Prelude.Int)
getIncludeCategoryHeader =
  Automation.propertyGetID 0x9 [] Automation.outInt
setIncludeCategoryHeader :: Prelude.Int -> ITableOfAuthorities a -> Prelude.IO ()
setIncludeCategoryHeader prop =
  Automation.propertySetID 0x9 [Automation.inInt prop]
getPageNumberSeparator :: ITableOfAuthorities a -> Prelude.IO (Prelude.String)
getPageNumberSeparator =
  Automation.propertyGetID 0xa [] Automation.outString
setPageNumberSeparator :: Prelude.String -> ITableOfAuthorities a -> Prelude.IO ()
setPageNumberSeparator prop =
  Automation.propertySetID 0xa [Automation.inString prop]
-- --------------------------------------------------
-- 
-- interface Dialogs
-- 
-- --------------------------------------------------
data Dialogs a = Dialogs
                  
type IDialogs a = Automation.IDispatch (Dialogs a)
iidIDialogs :: Com.IID (IDialogs Automation.Interface)
iidIDialogs = Com.mkIID "{00020910-0000-0000-C000-000000000046}"
item38 :: (Automation.Variant a0) => a0 -> IDialogs a -> Prelude.IO (IDialog Automation.Interface)
item38 idex =
  Automation.functionID1 0o0 [Automation.inVariant idex] Automation.outIDispatch
-- --------------------------------------------------
-- 
-- interface Dialog
-- 
-- --------------------------------------------------
data Dialog a = Dialog
                 
type IDialog a = Automation.IDispatch (Dialog a)
iidIDialog :: Com.IID (IDialog Automation.Interface)
iidIDialog = Com.mkIID "{000209B8-0000-0000-C000-000000000046}"
getDefaultTab :: (Automation.Variant a0) => IDialog a -> Prelude.IO (a0)
getDefaultTab =
  Automation.propertyGetID 0x7d02 [] Automation.outVariant
setDefaultTab :: (Automation.Variant a0) => a0 -> IDialog a -> Prelude.IO ()
setDefaultTab prop =
  Automation.propertySetID 0x7d02 [Automation.inVariant prop]
getType9 :: (Automation.Variant a0) => IDialog a -> Prelude.IO (a0)
getType9 = Automation.propertyGetID 0o0 [] Automation.outVariant
show :: Prelude.Int -> IDialog a -> Prelude.IO (Prelude.Int)
show timeOut =
  Automation.functionID1 0x150 [Automation.inInt timeOut] Automation.outInt
display :: Prelude.Int -> IDialog a -> Prelude.IO (Prelude.Int)
display timeOut =
  Automation.functionID1 0x152 [Automation.inInt timeOut] Automation.outInt
execute1 :: Automation.IDispatch a -> Prelude.IO ()
execute1 = Automation.methodID0 0x7d01 []
-- --------------------------------------------------
-- 
-- interface PageSetup
-- 
-- --------------------------------------------------
data PageSetup a = PageSetup
                    
type IPageSetup a = Automation.IDispatch (PageSetup a)
iidIPageSetup :: Com.IID (IPageSetup Automation.Interface)
iidIPageSetup = Com.mkIID "{00020971-0000-0000-C000-000000000046}"
getBottomMargin :: IPageSetup a -> Prelude.IO (Prelude.Float)
getBottomMargin =
  Automation.propertyGetID 0x65 [] Automation.outFloat
setBottomMargin :: Prelude.Float -> IPageSetup a -> Prelude.IO ()
setBottomMargin prop =
  Automation.propertySetID 0x65 [Automation.inFloat prop]
getLeftMargin :: IPageSetup a -> Prelude.IO (Prelude.Float)
getLeftMargin =
  Automation.propertyGetID 0x66 [] Automation.outFloat
setLeftMargin :: Prelude.Float -> IPageSetup a -> Prelude.IO ()
setLeftMargin prop =
  Automation.propertySetID 0x66 [Automation.inFloat prop]
getRightMargin :: IPageSetup a -> Prelude.IO (Prelude.Float)
getRightMargin =
  Automation.propertyGetID 0x67 [] Automation.outFloat
setRightMargin :: Prelude.Float -> IPageSetup a -> Prelude.IO ()
setRightMargin prop =
  Automation.propertySetID 0x67 [Automation.inFloat prop]
getGutter :: IPageSetup a -> Prelude.IO (Prelude.Float)
getGutter = Automation.propertyGetID 0x68 [] Automation.outFloat
setGutter :: Prelude.Float -> IPageSetup a -> Prelude.IO ()
setGutter prop =
  Automation.propertySetID 0x68 [Automation.inFloat prop]
getPageWidth :: IPageSetup a -> Prelude.IO (Prelude.Float)
getPageWidth = Automation.propertyGetID 0x69 [] Automation.outFloat
setPageWidth :: Prelude.Float -> IPageSetup a -> Prelude.IO ()
setPageWidth prop =
  Automation.propertySetID 0x69 [Automation.inFloat prop]
getPageHeight :: IPageSetup a -> Prelude.IO (Prelude.Float)
getPageHeight =
  Automation.propertyGetID 0x6a [] Automation.outFloat
setPageHeight :: Prelude.Float -> IPageSetup a -> Prelude.IO ()
setPageHeight prop =
  Automation.propertySetID 0x6a [Automation.inFloat prop]
getOrientation0 :: (Automation.Variant a0) => IPageSetup a -> Prelude.IO (a0)
getOrientation0 =
  Automation.propertyGetID 0x6b [] Automation.outVariant
setOrientation0 :: (Automation.Variant a0) => a0 -> IPageSetup a -> Prelude.IO ()
setOrientation0 prop =
  Automation.propertySetID 0x6b [Automation.inVariant prop]
getFirstPageTray :: (Automation.Variant a0) => IPageSetup a -> Prelude.IO (a0)
getFirstPageTray =
  Automation.propertyGetID 0x6c [] Automation.outVariant
setFirstPageTray :: (Automation.Variant a0) => a0 -> IPageSetup a -> Prelude.IO ()
setFirstPageTray prop =
  Automation.propertySetID 0x6c [Automation.inVariant prop]
getOtherPagesTray :: (Automation.Variant a0) => IPageSetup a -> Prelude.IO (a0)
getOtherPagesTray =
  Automation.propertyGetID 0x6d [] Automation.outVariant
setOtherPagesTray :: (Automation.Variant a0) => a0 -> IPageSetup a -> Prelude.IO ()
setOtherPagesTray prop =
  Automation.propertySetID 0x6d [Automation.inVariant prop]
getVerticalAlignment1 :: (Automation.Variant a0) => IPageSetup a -> Prelude.IO (a0)
getVerticalAlignment1 =
  Automation.propertyGetID 0x6e [] Automation.outVariant
setVerticalAlignment1 :: (Automation.Variant a0) => a0 -> IPageSetup a -> Prelude.IO ()
setVerticalAlignment1 prop =
  Automation.propertySetID 0x6e [Automation.inVariant prop]
getMirrorMargins :: IPageSetup a -> Prelude.IO (Prelude.Int)
getMirrorMargins =
  Automation.propertyGetID 0x6f [] Automation.outInt
setMirrorMargins :: Prelude.Int -> IPageSetup a -> Prelude.IO ()
setMirrorMargins prop =
  Automation.propertySetID 0x6f [Automation.inInt prop]
getHeaderDistance :: IPageSetup a -> Prelude.IO (Prelude.Float)
getHeaderDistance =
  Automation.propertyGetID 0x70 [] Automation.outFloat
setHeaderDistance :: Prelude.Float -> IPageSetup a -> Prelude.IO ()
setHeaderDistance prop =
  Automation.propertySetID 0x70 [Automation.inFloat prop]
getFooterDistance :: IPageSetup a -> Prelude.IO (Prelude.Float)
getFooterDistance =
  Automation.propertyGetID 0x71 [] Automation.outFloat
setFooterDistance :: Prelude.Float -> IPageSetup a -> Prelude.IO ()
setFooterDistance prop =
  Automation.propertySetID 0x71 [Automation.inFloat prop]
getSectionStart :: (Automation.Variant a0) => IPageSetup a -> Prelude.IO (a0)
getSectionStart =
  Automation.propertyGetID 0x72 [] Automation.outVariant
setSectionStart :: (Automation.Variant a0) => a0 -> IPageSetup a -> Prelude.IO ()
setSectionStart prop =
  Automation.propertySetID 0x72 [Automation.inVariant prop]
getOddAndEvenPagesHeaderFooter :: IPageSetup a -> Prelude.IO (Prelude.Int)
getOddAndEvenPagesHeaderFooter =
  Automation.propertyGetID 0x73 [] Automation.outInt
setOddAndEvenPagesHeaderFooter :: Prelude.Int -> IPageSetup a -> Prelude.IO ()
setOddAndEvenPagesHeaderFooter prop =
  Automation.propertySetID 0x73 [Automation.inInt prop]
getDifferentFirstPageHeaderFooter :: IPageSetup a -> Prelude.IO (Prelude.Int)
getDifferentFirstPageHeaderFooter =
  Automation.propertyGetID 0x74 [] Automation.outInt
setDifferentFirstPageHeaderFooter :: Prelude.Int -> IPageSetup a -> Prelude.IO ()
setDifferentFirstPageHeaderFooter prop =
  Automation.propertySetID 0x74 [Automation.inInt prop]
getSuppressEndnotes :: IPageSetup a -> Prelude.IO (Prelude.Int)
getSuppressEndnotes =
  Automation.propertyGetID 0x75 [] Automation.outInt
setSuppressEndnotes :: Prelude.Int -> IPageSetup a -> Prelude.IO ()
setSuppressEndnotes prop =
  Automation.propertySetID 0x75 [Automation.inInt prop]
getLineNumbering :: IPageSetup a -> Prelude.IO (ILineNumbering Automation.Interface)
getLineNumbering =
  Automation.propertyGetID 0x76 [] Automation.outIDispatch
setLineNumbering :: ILineNumbering a0 -> IPageSetup a -> Prelude.IO ()
setLineNumbering prop =
  Automation.propertySetID 0x76 [Automation.inIDispatch prop]
getTextColumns :: IPageSetup a -> Prelude.IO (ITextColumns Automation.Interface)
getTextColumns =
  Automation.propertyGetID 0x77 [] Automation.outIDispatch
setTextColumns :: ITextColumns a0 -> IPageSetup a -> Prelude.IO ()
setTextColumns prop =
  Automation.propertySetID 0x77 [Automation.inIDispatch prop]
getPaperSize :: (Automation.Variant a0) => IPageSetup a -> Prelude.IO (a0)
getPaperSize =
  Automation.propertyGetID 0x78 [] Automation.outVariant
setPaperSize :: (Automation.Variant a0) => a0 -> IPageSetup a -> Prelude.IO ()
setPaperSize prop =
  Automation.propertySetID 0x78 [Automation.inVariant prop]
getTwoPagesOnOne :: IPageSetup a -> Prelude.IO (Prelude.Int)
getTwoPagesOnOne =
  Automation.propertyGetID 0x79 [] Automation.outInt
setTwoPagesOnOne :: Prelude.Int -> IPageSetup a -> Prelude.IO ()
setTwoPagesOnOne prop =
  Automation.propertySetID 0x79 [Automation.inInt prop]
getGutterOnTop :: IPageSetup a -> Prelude.IO (Prelude.Int)
getGutterOnTop = Automation.propertyGetID 0x7a [] Automation.outInt
setGutterOnTop :: Prelude.Int -> IPageSetup a -> Prelude.IO ()
setGutterOnTop prop =
  Automation.propertySetID 0x7a [Automation.inInt prop]
getCharsLine :: IPageSetup a -> Prelude.IO (Prelude.Float)
getCharsLine = Automation.propertyGetID 0x7b [] Automation.outFloat
setCharsLine :: Prelude.Float -> IPageSetup a -> Prelude.IO ()
setCharsLine prop =
  Automation.propertySetID 0x7b [Automation.inFloat prop]
getLinesPage :: IPageSetup a -> Prelude.IO (Prelude.Float)
getLinesPage = Automation.propertyGetID 0x7c [] Automation.outFloat
setLinesPage :: Prelude.Float -> IPageSetup a -> Prelude.IO ()
setLinesPage prop =
  Automation.propertySetID 0x7c [Automation.inFloat prop]
getShowGrid :: IPageSetup a -> Prelude.IO (Prelude.Int)
getShowGrid = Automation.propertyGetID 0x80 [] Automation.outInt
setShowGrid :: Prelude.Int -> IPageSetup a -> Prelude.IO ()
setShowGrid prop =
  Automation.propertySetID 0x80 [Automation.inInt prop]
togglePortrait :: IPageSetup a -> Prelude.IO ()
togglePortrait = Automation.methodID0 0xc9 []
-- --------------------------------------------------
-- 
-- interface LineNumbering
-- 
-- --------------------------------------------------
data LineNumbering a = LineNumbering
                        
type ILineNumbering a = Automation.IDispatch (LineNumbering a)
iidILineNumbering :: Com.IID (ILineNumbering Automation.Interface)
iidILineNumbering =
  Com.mkIID "{00020972-0000-0000-C000-000000000046}"
getRestartMode :: (Automation.Variant a0) => ILineNumbering a -> Prelude.IO (a0)
getRestartMode =
  Automation.propertyGetID 0x64 [] Automation.outVariant
setRestartMode :: (Automation.Variant a0) => a0 -> ILineNumbering a -> Prelude.IO ()
setRestartMode prop =
  Automation.propertySetID 0x64 [Automation.inVariant prop]
getCountBy :: ILineNumbering a -> Prelude.IO (Prelude.Int)
getCountBy = Automation.propertyGetID 0x67 [] Automation.outInt
setCountBy :: Prelude.Int -> ILineNumbering a -> Prelude.IO ()
setCountBy prop =
  Automation.propertySetID 0x67 [Automation.inInt prop]
getActive0 :: ILineNumbering a -> Prelude.IO (Prelude.Int)
getActive0 = Automation.propertyGetID 0x68 [] Automation.outInt
setActive :: Prelude.Int -> ILineNumbering a -> Prelude.IO ()
setActive prop =
  Automation.propertySetID 0x68 [Automation.inInt prop]
-- --------------------------------------------------
-- 
-- interface TextColumns
-- 
-- --------------------------------------------------
data TextColumns a = TextColumns
                      
type ITextColumns a = Automation.IDispatch (TextColumns a)
iidITextColumns :: Com.IID (ITextColumns Automation.Interface)
iidITextColumns =
  Com.mkIID "{00020973-0000-0000-C000-000000000046}"
getEvenlySpaced :: ITextColumns a -> Prelude.IO (Prelude.Int)
getEvenlySpaced =
  Automation.propertyGetID 0x64 [] Automation.outInt
setEvenlySpaced :: Prelude.Int -> ITextColumns a -> Prelude.IO ()
setEvenlySpaced prop =
  Automation.propertySetID 0x64 [Automation.inInt prop]
getLineBetween :: ITextColumns a -> Prelude.IO (Prelude.Int)
getLineBetween = Automation.propertyGetID 0x65 [] Automation.outInt
setLineBetween :: Prelude.Int -> ITextColumns a -> Prelude.IO ()
setLineBetween prop =
  Automation.propertySetID 0x65 [Automation.inInt prop]
item39 :: Prelude.Int -> ITextColumns a -> Prelude.IO (ITextColumn Automation.Interface)
item39 idex =
  Automation.functionID1 0o0 [Automation.inInt idex] Automation.outIDispatch
add29 :: Prelude.Int -> Prelude.Int -> Prelude.Int -> ITextColumns a -> Prelude.IO (ITextColumn Automation.Interface)
add29 width spacing evenlySpaced =
  Automation.functionID1 0xc9 [Automation.inInt width, Automation.inInt spacing, Automation.inInt evenlySpaced] Automation.outIDispatch
setCount :: Prelude.Int -> ITextColumns a -> Prelude.IO ()
setCount numColumns =
  Automation.methodID0 0xca [Automation.inInt numColumns]
-- --------------------------------------------------
-- 
-- interface TextColumn
-- 
-- --------------------------------------------------
data TextColumn a = TextColumn
                     
type ITextColumn a = Automation.IDispatch (TextColumn a)
iidITextColumn :: Com.IID (ITextColumn Automation.Interface)
iidITextColumn = Com.mkIID "{00020974-0000-0000-C000-000000000046}"
-- --------------------------------------------------
-- 
-- interface Selection
-- 
-- --------------------------------------------------
data Selection a = Selection
                    
type ISelection a = Automation.IDispatch (Selection a)
iidISelection :: Com.IID (ISelection Automation.Interface)
iidISelection = Com.mkIID "{00020975-0000-0000-C000-000000000046}"
getType10 :: (Automation.Variant a0) => ISelection a -> Prelude.IO (a0)
getType10 = Automation.propertyGetID 0x6 [] Automation.outVariant
getHeaderFooter :: ISelection a -> Prelude.IO (IHeaderFooter Automation.Interface)
getHeaderFooter =
  Automation.propertyGetID 0x132 [] Automation.outIDispatch
getFlags :: (Automation.Variant a0) => ISelection a -> Prelude.IO (a0)
getFlags = Automation.propertyGetID 0x192 [] Automation.outVariant
setFlags :: (Automation.Variant a0) => a0 -> ISelection a -> Prelude.IO ()
setFlags prop =
  Automation.propertySetID 0x192 [Automation.inVariant prop]
getStartIsActive :: ISelection a -> Prelude.IO (Prelude.Int)
getStartIsActive =
  Automation.propertyGetID 0x194 [] Automation.outInt
setStartIsActive :: Prelude.Int -> ISelection a -> Prelude.IO ()
setStartIsActive prop =
  Automation.propertySetID 0x194 [Automation.inInt prop]
getIPAtEndOfLine :: ISelection a -> Prelude.IO (Prelude.Int)
getIPAtEndOfLine =
  Automation.propertyGetID 0x195 [] Automation.outInt
getExtendMode :: ISelection a -> Prelude.IO (Prelude.Int)
getExtendMode = Automation.propertyGetID 0x196 [] Automation.outInt
setExtendMode :: Prelude.Int -> ISelection a -> Prelude.IO ()
setExtendMode prop =
  Automation.propertySetID 0x196 [Automation.inInt prop]
getColumnSelectMode :: ISelection a -> Prelude.IO (Prelude.Int)
getColumnSelectMode =
  Automation.propertyGetID 0x197 [] Automation.outInt
setColumnSelectMode :: Prelude.Int -> ISelection a -> Prelude.IO ()
setColumnSelectMode prop =
  Automation.propertySetID 0x197 [Automation.inInt prop]
previousField :: ISelection a -> Prelude.IO (IField Automation.Interface)
previousField =
  Automation.functionID1 0xb1 [] Automation.outIDispatch
nextField :: ISelection a -> Prelude.IO (IField Automation.Interface)
nextField = Automation.functionID1 0xb2 [] Automation.outIDispatch
insertCells :: Prelude.Int -> ISelection a -> Prelude.IO ()
insertCells shiftCells =
  Automation.methodID0 0xd6 [Automation.inInt shiftCells]
extend :: Prelude.Int -> ISelection a -> Prelude.IO ()
extend character =
  Automation.methodID0 0x12c [Automation.inInt character]
moveLeft :: Prelude.Int -> Prelude.Int -> Prelude.Int -> ISelection a -> Prelude.IO (Prelude.Int)
moveLeft unit count extend =
  Automation.functionID1 0x1f4 [Automation.inInt unit, Automation.inInt count, Automation.inInt extend] Automation.outInt
moveRight :: Prelude.Int -> Prelude.Int -> Prelude.Int -> ISelection a -> Prelude.IO (Prelude.Int)
moveRight unit count extend =
  Automation.functionID1 0x1f5 [Automation.inInt unit, Automation.inInt count, Automation.inInt extend] Automation.outInt
moveUp :: Prelude.Int -> Prelude.Int -> Prelude.Int -> ISelection a -> Prelude.IO (Prelude.Int)
moveUp unit count extend =
  Automation.functionID1 0x1f6 [Automation.inInt unit, Automation.inInt count, Automation.inInt extend] Automation.outInt
moveDown :: Prelude.Int -> Prelude.Int -> Prelude.Int -> ISelection a -> Prelude.IO (Prelude.Int)
moveDown unit count extend =
  Automation.functionID1 0x1f7 [Automation.inInt unit, Automation.inInt count, Automation.inInt extend] Automation.outInt
homeKey :: Prelude.Int -> Prelude.Int -> ISelection a -> Prelude.IO (Prelude.Int)
homeKey unit extend =
  Automation.functionID1 0x1f8 [Automation.inInt unit, Automation.inInt extend] Automation.outInt
endKey :: Prelude.Int -> Prelude.Int -> ISelection a -> Prelude.IO (Prelude.Int)
endKey unit extend =
  Automation.functionID1 0x1f9 [Automation.inInt unit, Automation.inInt extend] Automation.outInt
escapeKey :: ISelection a -> Prelude.IO ()
escapeKey = Automation.methodID0 0x1fa []
typeText :: Prelude.String -> ISelection a -> Prelude.IO ()
typeText text =
  Automation.methodID0 0x1fb [Automation.inString text]
copyFormat :: ISelection a -> Prelude.IO ()
copyFormat = Automation.methodID0 0x1fd []
pasteFormat :: ISelection a -> Prelude.IO ()
pasteFormat = Automation.methodID0 0x1fe []
typeParagraph :: ISelection a -> Prelude.IO ()
typeParagraph = Automation.methodID0 0x200 []
typeBackspace :: ISelection a -> Prelude.IO ()
typeBackspace = Automation.methodID0 0x201 []
selectColumn :: ISelection a -> Prelude.IO ()
selectColumn = Automation.methodID0 0x204 []
selectCurrentFont :: ISelection a -> Prelude.IO ()
selectCurrentFont = Automation.methodID0 0x205 []
selectCurrentAlignment :: ISelection a -> Prelude.IO ()
selectCurrentAlignment = Automation.methodID0 0x206 []
selectCurrentSpacing :: ISelection a -> Prelude.IO ()
selectCurrentSpacing = Automation.methodID0 0x207 []
selectCurrentIndent :: ISelection a -> Prelude.IO ()
selectCurrentIndent = Automation.methodID0 0x208 []
selectCurrentTabs :: ISelection a -> Prelude.IO ()
selectCurrentTabs = Automation.methodID0 0x209 []
selectCurrentColor :: ISelection a -> Prelude.IO ()
selectCurrentColor = Automation.methodID0 0x20a []
createTextbox :: ISelection a -> Prelude.IO ()
createTextbox = Automation.methodID0 0x20b []
selectRow :: ISelection a -> Prelude.IO ()
selectRow = Automation.methodID0 0x20d []
splitTable :: ISelection a -> Prelude.IO ()
splitTable = Automation.methodID0 0x20e []
insertRows :: Prelude.Int -> ISelection a -> Prelude.IO ()
insertRows numRows =
  Automation.methodID0 0x210 [Automation.inInt numRows]
insertColumns :: ISelection a -> Prelude.IO ()
insertColumns = Automation.methodID0 0x211 []
insertFormula :: Prelude.Int -> Prelude.Int -> ISelection a -> Prelude.IO ()
insertFormula formula numberFormat =
  Automation.methodID0 0x212 [Automation.inInt formula, Automation.inInt numberFormat]
nextRevision :: Prelude.Int -> ISelection a -> Prelude.IO (IRevision Automation.Interface)
nextRevision wrap =
  Automation.functionID1 0x213 [Automation.inInt wrap] Automation.outIDispatch
previousRevision :: Prelude.Int -> ISelection a -> Prelude.IO (IRevision Automation.Interface)
previousRevision wrap =
  Automation.functionID1 0x214 [Automation.inInt wrap] Automation.outIDispatch
-- --------------------------------------------------
-- 
-- interface TablesOfAuthoritiesCategories
-- 
-- --------------------------------------------------
data TablesOfAuthoritiesCategories a = TablesOfAuthoritiesCategories
                                        
type ITablesOfAuthoritiesCategories a = Automation.IDispatch (TablesOfAuthoritiesCategories a)
iidITablesOfAuthoritiesCategories :: Com.IID (ITablesOfAuthoritiesCategories Automation.Interface)
iidITablesOfAuthoritiesCategories =
  Com.mkIID "{00020976-0000-0000-C000-000000000046}"
item40 :: Prelude.Int -> ITablesOfAuthoritiesCategories a -> Prelude.IO (ITableOfAuthoritiesCategory Automation.Interface)
item40 idx =
  Automation.functionID1 0o0 [Automation.inInt idx] Automation.outIDispatch
-- --------------------------------------------------
-- 
-- interface TableOfAuthoritiesCategory
-- 
-- --------------------------------------------------
data TableOfAuthoritiesCategory a = TableOfAuthoritiesCategory
                                     
type ITableOfAuthoritiesCategory a = Automation.IDispatch (TableOfAuthoritiesCategory a)
iidITableOfAuthoritiesCategory :: Com.IID (ITableOfAuthoritiesCategory Automation.Interface)
iidITableOfAuthoritiesCategory =
  Com.mkIID "{00020977-0000-0000-C000-000000000046}"
-- --------------------------------------------------
-- 
-- interface CaptionLabels
-- 
-- --------------------------------------------------
data CaptionLabels a = CaptionLabels
                        
type ICaptionLabels a = Automation.IDispatch (CaptionLabels a)
iidICaptionLabels :: Com.IID (ICaptionLabels Automation.Interface)
iidICaptionLabels =
  Com.mkIID "{00020978-0000-0000-C000-000000000046}"
item41 :: Prelude.Int -> ICaptionLabels a -> Prelude.IO (ICaptionLabel Automation.Interface)
item41 idx =
  Automation.functionID1 0o0 [Automation.inInt idx] Automation.outIDispatch
add30 :: Prelude.String -> ICaptionLabels a -> Prelude.IO (ICaptionLabel Automation.Interface)
add30 name =
  Automation.functionID1 0x64 [Automation.inString name] Automation.outIDispatch
-- --------------------------------------------------
-- 
-- interface CaptionLabel
-- 
-- --------------------------------------------------
data CaptionLabel a = CaptionLabel
                       
type ICaptionLabel a = Automation.IDispatch (CaptionLabel a)
iidICaptionLabel :: Com.IID (ICaptionLabel Automation.Interface)
iidICaptionLabel =
  Com.mkIID "{00020979-0000-0000-C000-000000000046}"
getID0 :: (Automation.Variant a0) => ICaptionLabel a -> Prelude.IO (a0)
getID0 = Automation.propertyGetID 0x2 [] Automation.outVariant
getIncludeChapterNumber :: Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getIncludeChapterNumber =
  Automation.propertyGetID 0x3 [] Automation.outInt
setIncludeChapterNumber :: Prelude.Int -> Automation.IDispatch a -> Prelude.IO ()
setIncludeChapterNumber prop =
  Automation.propertySetID 0x3 [Automation.inInt prop]
getNumberStyle1 :: (Automation.Variant a0) => ICaptionLabel a -> Prelude.IO (a0)
getNumberStyle1 =
  Automation.propertyGetID 0x4 [] Automation.outVariant
setNumberStyle1 :: (Automation.Variant a0) => a0 -> ICaptionLabel a -> Prelude.IO ()
setNumberStyle1 prop =
  Automation.propertySetID 0x4 [Automation.inVariant prop]
getChapterStyleLevel :: ICaptionLabel a -> Prelude.IO (Prelude.Int)
getChapterStyleLevel =
  Automation.propertyGetID 0x5 [] Automation.outInt
setChapterStyleLevel :: Prelude.Int -> ICaptionLabel a -> Prelude.IO ()
setChapterStyleLevel prop =
  Automation.propertySetID 0x5 [Automation.inInt prop]
getSeparator2 :: (Automation.Variant a0) => ICaptionLabel a -> Prelude.IO (a0)
getSeparator2 =
  Automation.propertyGetID 0x6 [] Automation.outVariant
setSeparator0 :: (Automation.Variant a0) => a0 -> ICaptionLabel a -> Prelude.IO ()
setSeparator0 prop =
  Automation.propertySetID 0x6 [Automation.inVariant prop]
getPosition2 :: (Automation.Variant a0) => ICaptionLabel a -> Prelude.IO (a0)
getPosition2 =
  Automation.propertyGetID 0x7 [] Automation.outVariant
setPosition2 :: (Automation.Variant a0) => a0 -> ICaptionLabel a -> Prelude.IO ()
setPosition2 prop =
  Automation.propertySetID 0x7 [Automation.inVariant prop]
-- --------------------------------------------------
-- 
-- interface AutoCaptions
-- 
-- --------------------------------------------------
data AutoCaptions a = AutoCaptions
                       
type IAutoCaptions a = Automation.IDispatch (AutoCaptions a)
iidIAutoCaptions :: Com.IID (IAutoCaptions Automation.Interface)
iidIAutoCaptions =
  Com.mkIID "{0002097A-0000-0000-C000-000000000046}"
item42 :: Prelude.Int -> IAutoCaptions a -> Prelude.IO (IAutoCaption Automation.Interface)
item42 idx =
  Automation.functionID1 0o0 [Automation.inInt idx] Automation.outIDispatch
cancelAutoInsert :: IAutoCaptions a -> Prelude.IO ()
cancelAutoInsert = Automation.methodID0 0x64 []
-- --------------------------------------------------
-- 
-- interface AutoCaption
-- 
-- --------------------------------------------------
data AutoCaption a = AutoCaption
                      
type IAutoCaption a = Automation.IDispatch (AutoCaption a)
iidIAutoCaption :: Com.IID (IAutoCaption Automation.Interface)
iidIAutoCaption =
  Com.mkIID "{0002097B-0000-0000-C000-000000000046}"
getAutoInsert :: IAutoCaption a -> Prelude.IO (Prelude.Int)
getAutoInsert = Automation.propertyGetID 0x1 [] Automation.outInt
setAutoInsert :: Prelude.Int -> IAutoCaption a -> Prelude.IO ()
setAutoInsert prop =
  Automation.propertySetID 0x1 [Automation.inInt prop]
getCaptionLabel :: IAutoCaption a -> Prelude.IO (Prelude.Int)
getCaptionLabel = Automation.propertyGetID 0x3 [] Automation.outInt
setCaptionLabel :: Prelude.Int -> IAutoCaption a -> Prelude.IO ()
setCaptionLabel prop =
  Automation.propertySetID 0x3 [Automation.inInt prop]
-- --------------------------------------------------
-- 
-- interface Indexes
-- 
-- --------------------------------------------------
data Ndexes a = Ndexes
                 
type Indexes a = Automation.IDispatch (Ndexes a)
iidIndexes :: Com.IID (Indexes Automation.Interface)
iidIndexes = Com.mkIID "{0002097C-0000-0000-C000-000000000046}"
getFormat6 :: (Automation.Variant a0) => Indexes a -> Prelude.IO (a0)
getFormat6 = Automation.propertyGetID 0x2 [] Automation.outVariant
setFormat5 :: (Automation.Variant a0) => a0 -> Indexes a -> Prelude.IO ()
setFormat5 prop =
  Automation.propertySetID 0x2 [Automation.inVariant prop]
item43 :: Prelude.Int -> Indexes a -> Prelude.IO (Index Automation.Interface)
item43 idex =
  Automation.functionID1 0o0 [Automation.inInt idex] Automation.outIDispatch
add31 :: IRange a0 -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Indexes a -> Prelude.IO (Index Automation.Interface)
add31 range headingSeparator rightAlignPageNumbers type0 numberOfColumns accentedLetters =
  Automation.functionID1 0x64 [Automation.inIDispatch range, Automation.inInt headingSeparator, Automation.inInt rightAlignPageNumbers, Automation.inInt type0, Automation.inInt numberOfColumns, Automation.inInt accentedLetters] Automation.outIDispatch
markEntry1 :: IRange a0 -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Indexes a -> Prelude.IO (IField Automation.Interface)
markEntry1 range entry entryAutoText crossReference crossReferenceAutoText bookmarkName bold italic reading =
  Automation.functionID1 0x65 [Automation.inIDispatch range, Automation.inInt entry, Automation.inInt entryAutoText, Automation.inInt crossReference, Automation.inInt crossReferenceAutoText, Automation.inInt bookmarkName, Automation.inInt bold, Automation.inInt italic, Automation.inInt reading] Automation.outIDispatch
markAllEntries :: IRange a0 -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Indexes a -> Prelude.IO ()
markAllEntries range entry entryAutoText crossReference crossReferenceAutoText bookmarkName bold italic =
  Automation.methodID0 0x66 [Automation.inIDispatch range, Automation.inInt entry, Automation.inInt entryAutoText, Automation.inInt crossReference, Automation.inInt crossReferenceAutoText, Automation.inInt bookmarkName, Automation.inInt bold, Automation.inInt italic]
autoMarkEntries :: Prelude.String -> Indexes a -> Prelude.IO ()
autoMarkEntries concordanceFileName =
  Automation.methodID0 0x67 [Automation.inString concordanceFileName]
-- --------------------------------------------------
-- 
-- interface Index
-- 
-- --------------------------------------------------
data Ndex a = Ndex
               
type Index a = Automation.IDispatch (Ndex a)
iidIndex :: Com.IID (Index Automation.Interface)
iidIndex = Com.mkIID "{0002097D-0000-0000-C000-000000000046}"
getHeadingSeparator :: (Automation.Variant a0) => Index a -> Prelude.IO (a0)
getHeadingSeparator =
  Automation.propertyGetID 0x1 [] Automation.outVariant
setHeadingSeparator :: (Automation.Variant a0) => a0 -> Index a -> Prelude.IO ()
setHeadingSeparator prop =
  Automation.propertySetID 0x1 [Automation.inVariant prop]
getType11 :: (Automation.Variant a0) => Index a -> Prelude.IO (a0)
getType11 = Automation.propertyGetID 0x3 [] Automation.outVariant
setType :: (Automation.Variant a0) => a0 -> Index a -> Prelude.IO ()
setType prop =
  Automation.propertySetID 0x3 [Automation.inVariant prop]
getNumberOfColumns :: Index a -> Prelude.IO (Prelude.Int)
getNumberOfColumns =
  Automation.propertyGetID 0x4 [] Automation.outInt
setNumberOfColumns :: Prelude.Int -> Index a -> Prelude.IO ()
setNumberOfColumns prop =
  Automation.propertySetID 0x4 [Automation.inInt prop]
getAccentedLetters :: Index a -> Prelude.IO (Prelude.Int)
getAccentedLetters =
  Automation.propertyGetID 0x7 [] Automation.outInt
setAccentedLetters :: Prelude.Int -> Index a -> Prelude.IO ()
setAccentedLetters prop =
  Automation.propertySetID 0x7 [Automation.inInt prop]
getSortBy :: (Automation.Variant a0) => Index a -> Prelude.IO (a0)
getSortBy = Automation.propertyGetID 0x8 [] Automation.outVariant
setSortBy :: (Automation.Variant a0) => a0 -> Index a -> Prelude.IO ()
setSortBy prop =
  Automation.propertySetID 0x8 [Automation.inVariant prop]
getFilter :: (Automation.Variant a0) => Index a -> Prelude.IO (a0)
getFilter = Automation.propertyGetID 0x9 [] Automation.outVariant
setFilter :: (Automation.Variant a0) => a0 -> Index a -> Prelude.IO ()
setFilter prop =
  Automation.propertySetID 0x9 [Automation.inVariant prop]
-- --------------------------------------------------
-- 
-- interface AddIn
-- 
-- --------------------------------------------------
data AddIn a = AddIn
                
type IAddIn a = Automation.IDispatch (AddIn a)
iidIAddIn :: Com.IID (IAddIn Automation.Interface)
iidIAddIn = Com.mkIID "{0002097E-0000-0000-C000-000000000046}"
getInstalled :: IAddIn a -> Prelude.IO (Prelude.Int)
getInstalled = Automation.propertyGetID 0x4 [] Automation.outInt
setInstalled :: Prelude.Int -> IAddIn a -> Prelude.IO ()
setInstalled prop =
  Automation.propertySetID 0x4 [Automation.inInt prop]
getCompiled :: IAddIn a -> Prelude.IO (Prelude.Int)
getCompiled = Automation.propertyGetID 0x5 [] Automation.outInt
getAutoload :: IAddIn a -> Prelude.IO (Prelude.Int)
getAutoload = Automation.propertyGetID 0x6 [] Automation.outInt
-- --------------------------------------------------
-- 
-- interface AddIns
-- 
-- --------------------------------------------------
data AddIns a = AddIns
                 
type IAddIns a = Automation.IDispatch (AddIns a)
iidIAddIns :: Com.IID (IAddIns Automation.Interface)
iidIAddIns = Com.mkIID "{0002097F-0000-0000-C000-000000000046}"
item44 :: Prelude.Int -> IAddIns a -> Prelude.IO (IAddIn Automation.Interface)
item44 idx =
  Automation.functionID1 0o0 [Automation.inInt idx] Automation.outIDispatch
add32 :: Prelude.String -> Prelude.Int -> IAddIns a -> Prelude.IO (IAddIn Automation.Interface)
add32 fileName install =
  Automation.functionID1 0x2 [Automation.inString fileName, Automation.inInt install] Automation.outIDispatch
unload :: Prelude.Int -> IAddIns a -> Prelude.IO ()
unload removeFromList =
  Automation.methodID0 0x3 [Automation.inInt removeFromList]
-- --------------------------------------------------
-- 
-- interface Revisions
-- 
-- --------------------------------------------------
data Revisions a = Revisions
                    
type IRevisions a = Automation.IDispatch (Revisions a)
iidIRevisions :: Com.IID (IRevisions Automation.Interface)
iidIRevisions = Com.mkIID "{00020980-0000-0000-C000-000000000046}"
item45 :: Prelude.Int -> IRevisions a -> Prelude.IO (IRevision Automation.Interface)
item45 idex =
  Automation.functionID1 0o0 [Automation.inInt idex] Automation.outIDispatch
acceptAll :: IRevisions a -> Prelude.IO ()
acceptAll = Automation.methodID0 0x65 []
rejectAll :: IRevisions a -> Prelude.IO ()
rejectAll = Automation.methodID0 0x66 []
-- --------------------------------------------------
-- 
-- interface Revision
-- 
-- --------------------------------------------------
data Revision a = Revision
                   
type IRevision a = Automation.IDispatch (Revision a)
iidIRevision :: Com.IID (IRevision Automation.Interface)
iidIRevision = Com.mkIID "{00020981-0000-0000-C000-000000000046}"
type DATE = Prelude.Double
getDate :: Automation.IDispatch a -> Prelude.IO (Prelude.Double)
getDate = Automation.propertyGetID 0x2 [] Automation.outDouble
getType12 :: (Automation.Variant a0) => IRevision a -> Prelude.IO (a0)
getType12 = Automation.propertyGetID 0x4 [] Automation.outVariant
accept :: IRevision a -> Prelude.IO ()
accept = Automation.methodID0 0x65 []
reject :: IRevision a -> Prelude.IO ()
reject = Automation.methodID0 0x66 []
-- --------------------------------------------------
-- 
-- interface Task
-- 
-- --------------------------------------------------
data Task a = Task
               
type ITask a = Automation.IDispatch (Task a)
iidITask :: Com.IID (ITask Automation.Interface)
iidITask = Com.mkIID "{00020982-0000-0000-C000-000000000046}"
activate5 :: Prelude.Int -> Automation.IDispatch a -> Prelude.IO ()
activate5 wait = Automation.methodID0 0xa [Automation.inInt wait]
sendWindowMessage :: Prelude.Int -> Prelude.Int -> Prelude.Int -> ITask a -> Prelude.IO ()
sendWindowMessage message wParam lParam =
  Automation.methodID0 0xe [Automation.inInt message, Automation.inInt wParam, Automation.inInt lParam]
-- --------------------------------------------------
-- 
-- interface Tasks
-- 
-- --------------------------------------------------
data Tasks a = Tasks
                
type ITasks a = Automation.IDispatch (Tasks a)
iidITasks :: Com.IID (ITasks Automation.Interface)
iidITasks = Com.mkIID "{00020983-0000-0000-C000-000000000046}"
item46 :: Prelude.Int -> ITasks a -> Prelude.IO (ITask Automation.Interface)
item46 idx =
  Automation.functionID1 0o0 [Automation.inInt idx] Automation.outIDispatch
exitWindows :: ITasks a -> Prelude.IO ()
exitWindows = Automation.methodID0 0x3 []
-- --------------------------------------------------
-- 
-- interface HeadersFooters
-- 
-- --------------------------------------------------
data HeadersFooters a = HeadersFooters
                         
type IHeadersFooters a = Automation.IDispatch (HeadersFooters a)
iidIHeadersFooters :: Com.IID (IHeadersFooters Automation.Interface)
iidIHeadersFooters =
  Com.mkIID "{00020984-0000-0000-C000-000000000046}"
item47 :: (Automation.Variant a0) => a0 -> IHeadersFooters a -> Prelude.IO (IHeaderFooter Automation.Interface)
item47 idex =
  Automation.functionID1 0o0 [Automation.inVariant idex] Automation.outIDispatch
-- --------------------------------------------------
-- 
-- interface HeaderFooter
-- 
-- --------------------------------------------------
data HeaderFooter a = HeaderFooter
                       
type IHeaderFooter a = Automation.IDispatch (HeaderFooter a)
iidIHeaderFooter :: Com.IID (IHeaderFooter Automation.Interface)
iidIHeaderFooter =
  Com.mkIID "{00020985-0000-0000-C000-000000000046}"
getIndex22 :: (Automation.Variant a0) => IHeaderFooter a -> Prelude.IO (a0)
getIndex22 = Automation.propertyGetID 0x2 [] Automation.outVariant
getIsHeader :: IHeaderFooter a -> Prelude.IO (Prelude.Int)
getIsHeader = Automation.propertyGetID 0x3 [] Automation.outInt
getExists :: IHeaderFooter a -> Prelude.IO (Prelude.Int)
getExists = Automation.propertyGetID 0x4 [] Automation.outInt
setExists :: Prelude.Int -> IHeaderFooter a -> Prelude.IO ()
setExists prop =
  Automation.propertySetID 0x4 [Automation.inInt prop]
getPageNumbers :: IHeaderFooter a -> Prelude.IO (IPageNumbers Automation.Interface)
getPageNumbers =
  Automation.propertyGetID 0x5 [] Automation.outIDispatch
getLinkToPrevious :: IHeaderFooter a -> Prelude.IO (Prelude.Int)
getLinkToPrevious =
  Automation.propertyGetID 0x6 [] Automation.outInt
setLinkToPrevious :: Prelude.Int -> IHeaderFooter a -> Prelude.IO ()
setLinkToPrevious prop =
  Automation.propertySetID 0x6 [Automation.inInt prop]
-- --------------------------------------------------
-- 
-- interface PageNumbers
-- 
-- --------------------------------------------------
data PageNumbers a = PageNumbers
                      
type IPageNumbers a = Automation.IDispatch (PageNumbers a)
iidIPageNumbers :: Com.IID (IPageNumbers Automation.Interface)
iidIPageNumbers =
  Com.mkIID "{00020986-0000-0000-C000-000000000046}"
getNumberStyle2 :: (Automation.Variant a0) => IPageNumbers a -> Prelude.IO (a0)
getNumberStyle2 =
  Automation.propertyGetID 0x2 [] Automation.outVariant
setNumberStyle2 :: (Automation.Variant a0) => a0 -> IPageNumbers a -> Prelude.IO ()
setNumberStyle2 prop =
  Automation.propertySetID 0x2 [Automation.inVariant prop]
getHeadingLevelForChapter :: IPageNumbers a -> Prelude.IO (Prelude.Int)
getHeadingLevelForChapter =
  Automation.propertyGetID 0x4 [] Automation.outInt
setHeadingLevelForChapter :: Prelude.Int -> IPageNumbers a -> Prelude.IO ()
setHeadingLevelForChapter prop =
  Automation.propertySetID 0x4 [Automation.inInt prop]
getChapterPageSeparator :: (Automation.Variant a0) => IPageNumbers a -> Prelude.IO (a0)
getChapterPageSeparator =
  Automation.propertyGetID 0x5 [] Automation.outVariant
setChapterPageSeparator :: (Automation.Variant a0) => a0 -> IPageNumbers a -> Prelude.IO ()
setChapterPageSeparator prop =
  Automation.propertySetID 0x5 [Automation.inVariant prop]
getRestartNumberingAtSection :: IPageNumbers a -> Prelude.IO (Prelude.Int)
getRestartNumberingAtSection =
  Automation.propertyGetID 0x6 [] Automation.outInt
setRestartNumberingAtSection :: Prelude.Int -> IPageNumbers a -> Prelude.IO ()
setRestartNumberingAtSection prop =
  Automation.propertySetID 0x6 [Automation.inInt prop]
getShowFirstPageNumber :: IPageNumbers a -> Prelude.IO (Prelude.Int)
getShowFirstPageNumber =
  Automation.propertyGetID 0x8 [] Automation.outInt
setShowFirstPageNumber :: Prelude.Int -> IPageNumbers a -> Prelude.IO ()
setShowFirstPageNumber prop =
  Automation.propertySetID 0x8 [Automation.inInt prop]
item48 :: Prelude.Int -> IPageNumbers a -> Prelude.IO (IPageNumber Automation.Interface)
item48 idex =
  Automation.functionID1 0o0 [Automation.inInt idex] Automation.outIDispatch
add33 :: Prelude.Int -> Prelude.Int -> IPageNumbers a -> Prelude.IO (IPageNumber Automation.Interface)
add33 pageNumberAlignment firstPage =
  Automation.functionID1 0x65 [Automation.inInt pageNumberAlignment, Automation.inInt firstPage] Automation.outIDispatch
-- --------------------------------------------------
-- 
-- interface PageNumber
-- 
-- --------------------------------------------------
data PageNumber a = PageNumber
                     
type IPageNumber a = Automation.IDispatch (PageNumber a)
iidIPageNumber :: Com.IID (IPageNumber Automation.Interface)
iidIPageNumber = Com.mkIID "{00020987-0000-0000-C000-000000000046}"
getAlignment5 :: (Automation.Variant a0) => IPageNumber a -> Prelude.IO (a0)
getAlignment5 =
  Automation.propertyGetID 0x3 [] Automation.outVariant
setAlignment5 :: (Automation.Variant a0) => a0 -> IPageNumber a -> Prelude.IO ()
setAlignment5 prop =
  Automation.propertySetID 0x3 [Automation.inVariant prop]
-- --------------------------------------------------
-- 
-- interface Subdocuments
-- 
-- --------------------------------------------------
data Subdocuments a = Subdocuments
                       
type ISubdocuments a = Automation.IDispatch (Subdocuments a)
iidISubdocuments :: Com.IID (ISubdocuments Automation.Interface)
iidISubdocuments =
  Com.mkIID "{00020988-0000-0000-C000-000000000046}"
getExpanded :: ISubdocuments a -> Prelude.IO (Prelude.Int)
getExpanded = Automation.propertyGetID 0x2 [] Automation.outInt
setExpanded :: Prelude.Int -> ISubdocuments a -> Prelude.IO ()
setExpanded prop =
  Automation.propertySetID 0x2 [Automation.inInt prop]
item49 :: Prelude.Int -> ISubdocuments a -> Prelude.IO (ISubdocument Automation.Interface)
item49 idex =
  Automation.functionID1 0o0 [Automation.inInt idex] Automation.outIDispatch
addFromFile :: Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> ISubdocuments a -> Prelude.IO (ISubdocument Automation.Interface)
addFromFile name confirmConversions readOnly passwordDocument passwordTemplate revert writePasswordDocument writePasswordTemplate =
  Automation.functionID1 0x64 [Automation.inInt name, Automation.inInt confirmConversions, Automation.inInt readOnly, Automation.inInt passwordDocument, Automation.inInt passwordTemplate, Automation.inInt revert, Automation.inInt writePasswordDocument, Automation.inInt writePasswordTemplate] Automation.outIDispatch
addFromRange :: IRange a0 -> ISubdocuments a -> Prelude.IO (ISubdocument Automation.Interface)
addFromRange range =
  Automation.functionID1 0x65 [Automation.inIDispatch range] Automation.outIDispatch
merge2 :: Prelude.Int -> Prelude.Int -> ISubdocuments a -> Prelude.IO ()
merge2 firstSubdocument lastSubdocument =
  Automation.methodID0 0x66 [Automation.inInt firstSubdocument, Automation.inInt lastSubdocument]
-- --------------------------------------------------
-- 
-- interface Subdocument
-- 
-- --------------------------------------------------
data Subdocument a = Subdocument
                      
type ISubdocument a = Automation.IDispatch (Subdocument a)
iidISubdocument :: Com.IID (ISubdocument Automation.Interface)
iidISubdocument =
  Com.mkIID "{00020989-0000-0000-C000-000000000046}"
getHasFile :: ISubdocument a -> Prelude.IO (Prelude.Int)
getHasFile = Automation.propertyGetID 0x5 [] Automation.outInt
getLevel :: ISubdocument a -> Prelude.IO (Prelude.Int)
getLevel = Automation.propertyGetID 0x6 [] Automation.outInt
split2 :: IRange a0 -> ISubdocument a -> Prelude.IO ()
split2 range =
  Automation.methodID0 0x65 [Automation.inIDispatch range]
-- --------------------------------------------------
-- 
-- interface HeadingStyles
-- 
-- --------------------------------------------------
data HeadingStyles a = HeadingStyles
                        
type IHeadingStyles a = Automation.IDispatch (HeadingStyles a)
iidIHeadingStyles :: Com.IID (IHeadingStyles Automation.Interface)
iidIHeadingStyles =
  Com.mkIID "{0002098A-0000-0000-C000-000000000046}"
item50 :: Prelude.Int -> IHeadingStyles a -> Prelude.IO (IHeadingStyle Automation.Interface)
item50 idex =
  Automation.functionID1 0o0 [Automation.inInt idex] Automation.outIDispatch
add34 :: Prelude.Int -> Prelude.Int -> IHeadingStyles a -> Prelude.IO (IHeadingStyle Automation.Interface)
add34 style level =
  Automation.functionID1 0x64 [Automation.inInt style, Automation.inInt level] Automation.outIDispatch
-- --------------------------------------------------
-- 
-- interface HeadingStyle
-- 
-- --------------------------------------------------
data HeadingStyle a = HeadingStyle
                       
type IHeadingStyle a = Automation.IDispatch (HeadingStyle a)
iidIHeadingStyle :: Com.IID (IHeadingStyle Automation.Interface)
iidIHeadingStyle =
  Com.mkIID "{0002098B-0000-0000-C000-000000000046}"
getLevel0 :: IHeadingStyle a -> Prelude.IO (Prelude.Int)
getLevel0 = Automation.propertyGetID 0x2 [] Automation.outInt
setLevel :: Prelude.Int -> IHeadingStyle a -> Prelude.IO ()
setLevel prop =
  Automation.propertySetID 0x2 [Automation.inInt prop]
-- --------------------------------------------------
-- 
-- interface StoryRanges
-- 
-- --------------------------------------------------
data StoryRanges a = StoryRanges
                      
type IStoryRanges a = Automation.IDispatch (StoryRanges a)
iidIStoryRanges :: Com.IID (IStoryRanges Automation.Interface)
iidIStoryRanges =
  Com.mkIID "{0002098C-0000-0000-C000-000000000046}"
item51 :: (Automation.Variant a0) => a0 -> IStoryRanges a -> Prelude.IO (IRange Automation.Interface)
item51 idex =
  Automation.functionID1 0o0 [Automation.inVariant idex] Automation.outIDispatch
-- --------------------------------------------------
-- 
-- interface ListLevel
-- 
-- --------------------------------------------------
data ListLevel a = ListLevel
                    
type IListLevel a = Automation.IDispatch (ListLevel a)
iidIListLevel :: Com.IID (IListLevel Automation.Interface)
iidIListLevel = Com.mkIID "{0002098D-0000-0000-C000-000000000046}"
getNumberFormat :: IListLevel a -> Prelude.IO (Prelude.String)
getNumberFormat =
  Automation.propertyGetID 0x2 [] Automation.outString
setNumberFormat :: Prelude.String -> IListLevel a -> Prelude.IO ()
setNumberFormat prop =
  Automation.propertySetID 0x2 [Automation.inString prop]
getTrailingCharacter :: (Automation.Variant a0) => IListLevel a -> Prelude.IO (a0)
getTrailingCharacter =
  Automation.propertyGetID 0x3 [] Automation.outVariant
setTrailingCharacter :: (Automation.Variant a0) => a0 -> IListLevel a -> Prelude.IO ()
setTrailingCharacter prop =
  Automation.propertySetID 0x3 [Automation.inVariant prop]
getNumberStyle3 :: (Automation.Variant a0) => IListLevel a -> Prelude.IO (a0)
getNumberStyle3 =
  Automation.propertyGetID 0x4 [] Automation.outVariant
setNumberStyle3 :: (Automation.Variant a0) => a0 -> IListLevel a -> Prelude.IO ()
setNumberStyle3 prop =
  Automation.propertySetID 0x4 [Automation.inVariant prop]
getNumberPosition :: IListLevel a -> Prelude.IO (Prelude.Float)
getNumberPosition =
  Automation.propertyGetID 0x5 [] Automation.outFloat
setNumberPosition :: Prelude.Float -> IListLevel a -> Prelude.IO ()
setNumberPosition prop =
  Automation.propertySetID 0x5 [Automation.inFloat prop]
getAlignment6 :: (Automation.Variant a0) => IListLevel a -> Prelude.IO (a0)
getAlignment6 =
  Automation.propertyGetID 0x6 [] Automation.outVariant
setAlignment6 :: (Automation.Variant a0) => a0 -> IListLevel a -> Prelude.IO ()
setAlignment6 prop =
  Automation.propertySetID 0x6 [Automation.inVariant prop]
getTextPosition :: IListLevel a -> Prelude.IO (Prelude.Float)
getTextPosition =
  Automation.propertyGetID 0x7 [] Automation.outFloat
setTextPosition :: Prelude.Float -> IListLevel a -> Prelude.IO ()
setTextPosition prop =
  Automation.propertySetID 0x7 [Automation.inFloat prop]
getTabPosition :: IListLevel a -> Prelude.IO (Prelude.Float)
getTabPosition =
  Automation.propertyGetID 0x8 [] Automation.outFloat
setTabPosition :: Prelude.Float -> IListLevel a -> Prelude.IO ()
setTabPosition prop =
  Automation.propertySetID 0x8 [Automation.inFloat prop]
getResetOnHigher :: IListLevel a -> Prelude.IO (Prelude.Int)
getResetOnHigher =
  Automation.propertyGetID 0x9 [] Automation.outInt
setResetOnHigher :: Prelude.Int -> IListLevel a -> Prelude.IO ()
setResetOnHigher prop =
  Automation.propertySetID 0x9 [Automation.inInt prop]
getStartAt :: IListLevel a -> Prelude.IO (Prelude.Int)
getStartAt = Automation.propertyGetID 0xa [] Automation.outInt
setStartAt :: Prelude.Int -> IListLevel a -> Prelude.IO ()
setStartAt prop =
  Automation.propertySetID 0xa [Automation.inInt prop]
getLinkedStyle :: IListLevel a -> Prelude.IO (Prelude.String)
getLinkedStyle =
  Automation.propertyGetID 0xb [] Automation.outString
setLinkedStyle :: Prelude.String -> IListLevel a -> Prelude.IO ()
setLinkedStyle prop =
  Automation.propertySetID 0xb [Automation.inString prop]
-- --------------------------------------------------
-- 
-- interface ListLevels
-- 
-- --------------------------------------------------
data ListLevels a = ListLevels
                     
type IListLevels a = Automation.IDispatch (ListLevels a)
iidIListLevels :: Com.IID (IListLevels Automation.Interface)
iidIListLevels = Com.mkIID "{0002098E-0000-0000-C000-000000000046}"
item52 :: Prelude.Int -> IListLevels a -> Prelude.IO (IListLevel Automation.Interface)
item52 idex =
  Automation.functionID1 0o0 [Automation.inInt idex] Automation.outIDispatch
-- --------------------------------------------------
-- 
-- interface ListTemplate
-- 
-- --------------------------------------------------
data ListTemplate a = ListTemplate
                       
type IListTemplate a = Automation.IDispatch (ListTemplate a)
iidIListTemplate :: Com.IID (IListTemplate Automation.Interface)
iidIListTemplate =
  Com.mkIID "{0002098F-0000-0000-C000-000000000046}"
getOutlineNumbered :: IListTemplate a -> Prelude.IO (Prelude.Int)
getOutlineNumbered =
  Automation.propertyGetID 0x1 [] Automation.outInt
setOutlineNumbered :: Prelude.Int -> IListTemplate a -> Prelude.IO ()
setOutlineNumbered prop =
  Automation.propertySetID 0x1 [Automation.inInt prop]
getListLevels :: IListTemplate a -> Prelude.IO (IListLevels Automation.Interface)
getListLevels =
  Automation.propertyGetID 0x2 [] Automation.outIDispatch
convert1 :: Prelude.Int -> Automation.IDispatch a -> Prelude.IO (IListTemplate Automation.Interface)
convert1 level =
  Automation.functionID1 0x65 [Automation.inInt level] Automation.outIDispatch
-- --------------------------------------------------
-- 
-- interface ListTemplates
-- 
-- --------------------------------------------------
data ListTemplates a = ListTemplates
                        
type IListTemplates a = Automation.IDispatch (ListTemplates a)
iidIListTemplates :: Com.IID (IListTemplates Automation.Interface)
iidIListTemplates =
  Com.mkIID "{00020990-0000-0000-C000-000000000046}"
item53 :: Prelude.Int -> IListTemplates a -> Prelude.IO (IListTemplate Automation.Interface)
item53 idx =
  Automation.functionID1 0o0 [Automation.inInt idx] Automation.outIDispatch
add35 :: Prelude.Int -> Prelude.Int -> IListTemplates a -> Prelude.IO (IListTemplate Automation.Interface)
add35 outlineNumbered name =
  Automation.functionID1 0x64 [Automation.inInt outlineNumbered, Automation.inInt name] Automation.outIDispatch
-- --------------------------------------------------
-- 
-- interface ListParagraphs
-- 
-- --------------------------------------------------
data ListParagraphs a = ListParagraphs
                         
type IListParagraphs a = Automation.IDispatch (ListParagraphs a)
iidIListParagraphs :: Com.IID (IListParagraphs Automation.Interface)
iidIListParagraphs =
  Com.mkIID "{00020991-0000-0000-C000-000000000046}"
-- --------------------------------------------------
-- 
-- interface List
-- 
-- --------------------------------------------------
data List a = List
               
type IList a = Automation.IDispatch (List a)
iidIList :: Com.IID (IList Automation.Interface)
iidIList = Com.mkIID "{00020992-0000-0000-C000-000000000046}"
applyListTemplate0 :: IListTemplate a0 -> Prelude.Int -> Automation.IDispatch a -> Prelude.IO ()
applyListTemplate0 listTemplate continuePreviousList =
  Automation.methodID0 0x68 [Automation.inIDispatch listTemplate, Automation.inInt continuePreviousList]
-- --------------------------------------------------
-- 
-- interface Lists
-- 
-- --------------------------------------------------
data Lists a = Lists
                
type ILists a = Automation.IDispatch (Lists a)
iidILists :: Com.IID (ILists Automation.Interface)
iidILists = Com.mkIID "{00020993-0000-0000-C000-000000000046}"
item55 :: Prelude.Int -> ILists a -> Prelude.IO (IList Automation.Interface)
item55 idex =
  Automation.functionID1 0o0 [Automation.inInt idex] Automation.outIDispatch
-- --------------------------------------------------
-- 
-- interface ListGallery
-- 
-- --------------------------------------------------
data ListGallery a = ListGallery
                      
type IListGallery a = Automation.IDispatch (ListGallery a)
iidIListGallery :: Com.IID (IListGallery Automation.Interface)
iidIListGallery =
  Com.mkIID "{00020994-0000-0000-C000-000000000046}"
getModified :: Prelude.Int -> IListGallery a -> Prelude.IO (Prelude.Int)
getModified idex =
  Automation.propertyGetID 0x65 [Automation.inInt idex] Automation.outInt
reset4 :: Prelude.Int -> Automation.IDispatch a -> Prelude.IO ()
reset4 idex = Automation.methodID0 0x64 [Automation.inInt idex]
-- --------------------------------------------------
-- 
-- interface ListGalleries
-- 
-- --------------------------------------------------
data ListGalleries a = ListGalleries
                        
type IListGalleries a = Automation.IDispatch (ListGalleries a)
iidIListGalleries :: Com.IID (IListGalleries Automation.Interface)
iidIListGalleries =
  Com.mkIID "{00020995-0000-0000-C000-000000000046}"
item56 :: (Automation.Variant a0) => a0 -> IListGalleries a -> Prelude.IO (IListGallery Automation.Interface)
item56 idex =
  Automation.functionID1 0o0 [Automation.inVariant idex] Automation.outIDispatch
-- --------------------------------------------------
-- 
-- interface KeyBindings
-- 
-- --------------------------------------------------
data KeyBindings a = KeyBindings
                      
type IKeyBindings a = Automation.IDispatch (KeyBindings a)
iidIKeyBindings :: Com.IID (IKeyBindings Automation.Interface)
iidIKeyBindings =
  Com.mkIID "{00020996-0000-0000-C000-000000000046}"
getContext :: Automation.IDispatch a -> Prelude.IO (Automation.IDispatch Automation.Interface)
getContext =
  Automation.propertyGetID 0xa [] Automation.outIDispatch
item57 :: Prelude.Int -> Automation.IDispatch a -> Prelude.IO (IKeyBinding Automation.Interface)
item57 idex =
  Automation.functionID1 0o0 [Automation.inInt idex] Automation.outIDispatch
add36 :: (Automation.Variant a0) => a0 -> Prelude.String -> Prelude.Int -> Prelude.Int -> Prelude.Int -> IKeyBindings a -> Prelude.IO (IKeyBinding Automation.Interface)
add36 keyCategory command keyCode keyCode2 commandParameter =
  Automation.functionID1 0x65 [Automation.inVariant keyCategory, Automation.inString command, Automation.inInt keyCode, Automation.inInt keyCode2, Automation.inInt commandParameter] Automation.outIDispatch
key :: Prelude.Int -> Prelude.Int -> Automation.IDispatch a -> Prelude.IO (IKeyBinding Automation.Interface)
key keyCode keyCode2 =
  Automation.functionID1 0x6e [Automation.inInt keyCode, Automation.inInt keyCode2] Automation.outIDispatch
-- --------------------------------------------------
-- 
-- interface KeysBoundTo
-- 
-- --------------------------------------------------
data KeysBoundTo a = KeysBoundTo
                      
type IKeysBoundTo a = Automation.IDispatch (KeysBoundTo a)
iidIKeysBoundTo :: Com.IID (IKeysBoundTo Automation.Interface)
iidIKeysBoundTo =
  Com.mkIID "{00020997-0000-0000-C000-000000000046}"
getKeyCategory :: (Automation.Variant a0) => Automation.IDispatch a -> Prelude.IO (a0)
getKeyCategory =
  Automation.propertyGetID 0x3 [] Automation.outVariant
getCommand :: Automation.IDispatch a -> Prelude.IO (Prelude.String)
getCommand = Automation.propertyGetID 0x4 [] Automation.outString
getCommandParameter :: Automation.IDispatch a -> Prelude.IO (Prelude.String)
getCommandParameter =
  Automation.propertyGetID 0x5 [] Automation.outString
-- --------------------------------------------------
-- 
-- interface KeyBinding
-- 
-- --------------------------------------------------
data KeyBinding a = KeyBinding
                     
type IKeyBinding a = Automation.IDispatch (KeyBinding a)
iidIKeyBinding :: Com.IID (IKeyBinding Automation.Interface)
iidIKeyBinding = Com.mkIID "{00020998-0000-0000-C000-000000000046}"
getKeyString :: IKeyBinding a -> Prelude.IO (Prelude.String)
getKeyString = Automation.propertyGetID 0x2 [] Automation.outString
getProtected :: IKeyBinding a -> Prelude.IO (Prelude.Int)
getProtected = Automation.propertyGetID 0x3 [] Automation.outInt
getKeyCode :: IKeyBinding a -> Prelude.IO (Prelude.Int)
getKeyCode = Automation.propertyGetID 0x6 [] Automation.outInt
getKeyCode2 :: IKeyBinding a -> Prelude.IO (Prelude.Int)
getKeyCode2 = Automation.propertyGetID 0x7 [] Automation.outInt
disable :: IKeyBinding a -> Prelude.IO ()
disable = Automation.methodID0 0x66 []
rebind :: (Automation.Variant a0) => a0 -> Prelude.String -> Prelude.Int -> IKeyBinding a -> Prelude.IO ()
rebind keyCategory command commandParameter =
  Automation.methodID0 0x68 [Automation.inVariant keyCategory, Automation.inString command, Automation.inInt commandParameter]
-- --------------------------------------------------
-- 
-- interface FileConverter
-- 
-- --------------------------------------------------
data FileConverter a = FileConverter
                        
type IFileConverter a = Automation.IDispatch (FileConverter a)
iidIFileConverter :: Com.IID (IFileConverter Automation.Interface)
iidIFileConverter =
  Com.mkIID "{00020999-0000-0000-C000-000000000046}"
getFormatName :: IFileConverter a -> Prelude.IO (Prelude.String)
getFormatName =
  Automation.propertyGetID 0o0 [] Automation.outString
getClassName :: IFileConverter a -> Prelude.IO (Prelude.String)
getClassName = Automation.propertyGetID 0x1 [] Automation.outString
getOpenFormat :: IFileConverter a -> Prelude.IO (Prelude.Int)
getOpenFormat = Automation.propertyGetID 0x3 [] Automation.outInt
getCanSave :: IFileConverter a -> Prelude.IO (Prelude.Int)
getCanSave = Automation.propertyGetID 0x4 [] Automation.outInt
getCanOpen :: IFileConverter a -> Prelude.IO (Prelude.Int)
getCanOpen = Automation.propertyGetID 0x5 [] Automation.outInt
getExtensions :: IFileConverter a -> Prelude.IO (Prelude.String)
getExtensions =
  Automation.propertyGetID 0x8 [] Automation.outString
-- --------------------------------------------------
-- 
-- interface FileConverters
-- 
-- --------------------------------------------------
data FileConverters a = FileConverters
                         
type IFileConverters a = Automation.IDispatch (FileConverters a)
iidIFileConverters :: Com.IID (IFileConverters Automation.Interface)
iidIFileConverters =
  Com.mkIID "{0002099A-0000-0000-C000-000000000046}"
getConvertMacWordChevrons :: (Automation.Variant a0) => IFileConverters a -> Prelude.IO (a0)
getConvertMacWordChevrons =
  Automation.propertyGetID 0x2 [] Automation.outVariant
setConvertMacWordChevrons :: (Automation.Variant a0) => a0 -> IFileConverters a -> Prelude.IO ()
setConvertMacWordChevrons prop =
  Automation.propertySetID 0x2 [Automation.inVariant prop]
item59 :: Prelude.Int -> IFileConverters a -> Prelude.IO (IFileConverter Automation.Interface)
item59 idx =
  Automation.functionID1 0o0 [Automation.inInt idx] Automation.outIDispatch
-- --------------------------------------------------
-- 
-- interface SynonymInfo
-- 
-- --------------------------------------------------
data SynonymInfo a = SynonymInfo
                      
type ISynonymInfo a = Automation.IDispatch (SynonymInfo a)
iidISynonymInfo :: Com.IID (ISynonymInfo Automation.Interface)
iidISynonymInfo =
  Com.mkIID "{0002099B-0000-0000-C000-000000000046}"
getWord :: ISynonymInfo a -> Prelude.IO (Prelude.String)
getWord = Automation.propertyGetID 0x1 [] Automation.outString
getMeaningCount :: ISynonymInfo a -> Prelude.IO (Prelude.Int)
getMeaningCount = Automation.propertyGetID 0x3 [] Automation.outInt
getMeaningList :: ISynonymInfo a -> Prelude.IO (Prelude.Int)
getMeaningList = Automation.propertyGetID 0x4 [] Automation.outInt
getPartOfSpeechList :: ISynonymInfo a -> Prelude.IO (Prelude.Int)
getPartOfSpeechList =
  Automation.propertyGetID 0x5 [] Automation.outInt
getSynonymList :: Prelude.Int -> ISynonymInfo a -> Prelude.IO (Prelude.Int)
getSynonymList meaning =
  Automation.propertyGetID 0x7 [Automation.inInt meaning] Automation.outInt
getAntonymList :: ISynonymInfo a -> Prelude.IO (Prelude.Int)
getAntonymList = Automation.propertyGetID 0x8 [] Automation.outInt
getRelatedExpressionList :: ISynonymInfo a -> Prelude.IO (Prelude.Int)
getRelatedExpressionList =
  Automation.propertyGetID 0x9 [] Automation.outInt
getRelatedWordList :: ISynonymInfo a -> Prelude.IO (Prelude.Int)
getRelatedWordList =
  Automation.propertyGetID 0xa [] Automation.outInt
-- --------------------------------------------------
-- 
-- interface Hyperlinks
-- 
-- --------------------------------------------------
data Hyperlinks a = Hyperlinks
                     
type IHyperlinks a = Automation.IDispatch (Hyperlinks a)
iidIHyperlinks :: Com.IID (IHyperlinks Automation.Interface)
iidIHyperlinks = Com.mkIID "{0002099C-0000-0000-C000-000000000046}"
item60 :: Prelude.Int -> IHyperlinks a -> Prelude.IO (IHyperlink Automation.Interface)
item60 idx =
  Automation.functionID1 0o0 [Automation.inInt idx] Automation.outIDispatch
add37 :: Automation.IDispatch a0 -> Prelude.Int -> Prelude.Int -> IHyperlinks a -> Prelude.IO (IHyperlink Automation.Interface)
add37 anchor address subAddress =
  Automation.functionID1 0x64 [Automation.inIDispatch anchor, Automation.inInt address, Automation.inInt subAddress] Automation.outIDispatch
-- --------------------------------------------------
-- 
-- interface Hyperlink
-- 
-- --------------------------------------------------
data Hyperlink a = Hyperlink
                    
type IHyperlink a = Automation.IDispatch (Hyperlink a)
iidIHyperlink :: Com.IID (IHyperlink Automation.Interface)
iidIHyperlink = Com.mkIID "{0002099D-0000-0000-C000-000000000046}"
getAddress1 :: IHyperlink a -> Prelude.IO (Prelude.String)
getAddress1 =
  Automation.propertyGetID 0x3ec [] Automation.outString
getType13 :: (Automation.Variant a0) => IHyperlink a -> Prelude.IO (a0)
getType13 = Automation.propertyGetID 0x3ed [] Automation.outVariant
getShape :: IHyperlink a -> Prelude.IO (Office.IShape Automation.Interface)
getShape =
  Automation.propertyGetID 0x3ef [] Automation.outIDispatch
getSubAddress :: IHyperlink a -> Prelude.IO (Prelude.String)
getSubAddress =
  Automation.propertyGetID 0x3f0 [] Automation.outString
getExtraInfoRequired :: IHyperlink a -> Prelude.IO (Prelude.Int)
getExtraInfoRequired =
  Automation.propertyGetID 0x3f1 [] Automation.outInt
follow :: Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> IHyperlink a -> Prelude.IO ()
follow newWindow addHistory extraInfo method headerInfo =
  Automation.methodID0 0x68 [Automation.inInt newWindow, Automation.inInt addHistory, Automation.inInt extraInfo, Automation.inInt method, Automation.inInt headerInfo]
-- --------------------------------------------------
-- 
-- interface Shapes
-- 
-- --------------------------------------------------
data Shapes a = Shapes
                 
type IShapes a = Automation.IDispatch (Shapes a)
iidIShapes :: Com.IID (IShapes Automation.Interface)
iidIShapes = Com.mkIID "{0002099F-0000-0000-C000-000000000046}"
item61 :: Prelude.Int -> Automation.IDispatch a -> Prelude.IO (Office.IShape Automation.Interface)
item61 idx =
  Automation.functionID1 0o0 [Automation.inInt idx] Automation.outIDispatch
addCallout :: (Automation.Variant a0) => a0 -> Prelude.Float -> Prelude.Float -> Prelude.Float -> Prelude.Float -> Prelude.Int -> IShapes a -> Prelude.IO (Office.IShape Automation.Interface)
addCallout type0 left top width height anchor =
  Automation.functionID1 0xa [Automation.inVariant type0, Automation.inFloat left, Automation.inFloat top, Automation.inFloat width, Automation.inFloat height, Automation.inInt anchor] Automation.outIDispatch
addConnector :: (Automation.Variant a0) => a0 -> Prelude.Float -> Prelude.Float -> Prelude.Float -> Prelude.Float -> IShapes a -> Prelude.IO (Office.IShape Automation.Interface)
addConnector type0 beginX beginY endX endY =
  Automation.functionID1 0xb [Automation.inVariant type0, Automation.inFloat beginX, Automation.inFloat beginY, Automation.inFloat endX, Automation.inFloat endY] Automation.outIDispatch
addCurve :: Prelude.Int -> Prelude.Int -> IShapes a -> Prelude.IO (Office.IShape Automation.Interface)
addCurve safeArrayOfPoints anchor =
  Automation.functionID1 0xc [Automation.inInt safeArrayOfPoints, Automation.inInt anchor] Automation.outIDispatch
addLabel :: (Automation.Variant a0) => a0 -> Prelude.Float -> Prelude.Float -> Prelude.Float -> Prelude.Float -> Prelude.Int -> IShapes a -> Prelude.IO (Office.IShape Automation.Interface)
addLabel orientation left top width height anchor =
  Automation.functionID1 0xd [Automation.inVariant orientation, Automation.inFloat left, Automation.inFloat top, Automation.inFloat width, Automation.inFloat height, Automation.inInt anchor] Automation.outIDispatch
addLine :: Prelude.Float -> Prelude.Float -> Prelude.Float -> Prelude.Float -> Prelude.Int -> IShapes a -> Prelude.IO (Office.IShape Automation.Interface)
addLine beginX beginY endX endY anchor =
  Automation.functionID1 0xe [Automation.inFloat beginX, Automation.inFloat beginY, Automation.inFloat endX, Automation.inFloat endY, Automation.inInt anchor] Automation.outIDispatch
addPicture :: Prelude.String -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> IShapes a -> Prelude.IO (Office.IShape Automation.Interface)
addPicture fileName linkToFile saveWithDocument left top width height anchor =
  Automation.functionID1 0xf [Automation.inString fileName, Automation.inInt linkToFile, Automation.inInt saveWithDocument, Automation.inInt left, Automation.inInt top, Automation.inInt width, Automation.inInt height, Automation.inInt anchor] Automation.outIDispatch
addPolyline :: Prelude.Int -> Prelude.Int -> IShapes a -> Prelude.IO (Office.IShape Automation.Interface)
addPolyline safeArrayOfPoints anchor =
  Automation.functionID1 0x10 [Automation.inInt safeArrayOfPoints, Automation.inInt anchor] Automation.outIDispatch
addShape :: Prelude.Int -> Prelude.Float -> Prelude.Float -> Prelude.Float -> Prelude.Float -> Prelude.Int -> IShapes a -> Prelude.IO (Office.IShape Automation.Interface)
addShape type0 left top width height anchor =
  Automation.functionID1 0x11 [Automation.inInt type0, Automation.inFloat left, Automation.inFloat top, Automation.inFloat width, Automation.inFloat height, Automation.inInt anchor] Automation.outIDispatch
addTextEffect :: (Automation.Variant a0, Automation.Variant a1, Automation.Variant a2) => a0 -> Prelude.String -> Prelude.String -> Prelude.Float -> a1 -> a2 -> Prelude.Float -> Prelude.Float -> Prelude.Int -> IShapes a -> Prelude.IO (Office.IShape Automation.Interface)
addTextEffect presetTextEffect text fontName fontSize fontBold fontItalic left top anchor =
  Automation.functionID1 0x12 [Automation.inVariant presetTextEffect, Automation.inString text, Automation.inString fontName, Automation.inFloat fontSize, Automation.inVariant fontBold, Automation.inVariant fontItalic, Automation.inFloat left, Automation.inFloat top, Automation.inInt anchor] Automation.outIDispatch
addTextbox :: (Automation.Variant a0) => a0 -> Prelude.Float -> Prelude.Float -> Prelude.Float -> Prelude.Float -> Prelude.Int -> IShapes a -> Prelude.IO (Office.IShape Automation.Interface)
addTextbox orientation left top width height anchor =
  Automation.functionID1 0x13 [Automation.inVariant orientation, Automation.inFloat left, Automation.inFloat top, Automation.inFloat width, Automation.inFloat height, Automation.inInt anchor] Automation.outIDispatch
buildFreeform :: (Automation.Variant a0) => a0 -> Prelude.Float -> Prelude.Float -> IShapes a -> Prelude.IO (Office.IFreeformBuilder Automation.Interface)
buildFreeform editingType x1 y1 =
  Automation.functionID1 0x14 [Automation.inVariant editingType, Automation.inFloat x1, Automation.inFloat y1] Automation.outIDispatch
range0 :: Prelude.Int -> IShapes a -> Prelude.IO (Office.IShapeRange Automation.Interface)
range0 indx =
  Automation.functionID1 0x15 [Automation.inInt indx] Automation.outIDispatch
selectAll :: IShapes a -> Prelude.IO ()
selectAll = Automation.methodID0 0x16 []
addOLEObject :: Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> IShapes a -> Prelude.IO (Office.IShape Automation.Interface)
addOLEObject classType fileName linkToFile displayAsIcon iconFileName iconIndex iconLabel left top width height anchor =
  Automation.functionID1 0x18 [Automation.inInt classType, Automation.inInt fileName, Automation.inInt linkToFile, Automation.inInt displayAsIcon, Automation.inInt iconFileName, Automation.inInt iconIndex, Automation.inInt iconLabel, Automation.inInt left, Automation.inInt top, Automation.inInt width, Automation.inInt height, Automation.inInt anchor] Automation.outIDispatch
addOLEControl :: Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> IShapes a -> Prelude.IO (Office.IShape Automation.Interface)
addOLEControl classType left top width height anchor =
  Automation.functionID1 0x66 [Automation.inInt classType, Automation.inInt left, Automation.inInt top, Automation.inInt width, Automation.inInt height, Automation.inInt anchor] Automation.outIDispatch
-- --------------------------------------------------
-- 
-- interface ShapeRange
-- 
-- --------------------------------------------------
data ShapeRange a = ShapeRange
                     
type IShapeRange a = Automation.IDispatch (ShapeRange a)
iidIShapeRange :: Com.IID (IShapeRange Automation.Interface)
iidIShapeRange = Com.mkIID "{000209B5-0000-0000-C000-000000000046}"
getAdjustments :: Automation.IDispatch a -> Prelude.IO (Office.IAdjustments Automation.Interface)
getAdjustments =
  Automation.propertyGetID 0x64 [] Automation.outIDispatch
getAutoShapeType :: (Automation.Variant a0) => Automation.IDispatch a -> Prelude.IO (a0)
getAutoShapeType =
  Automation.propertyGetID 0x65 [] Automation.outVariant
setAutoShapeType :: (Automation.Variant a0) => a0 -> Automation.IDispatch a -> Prelude.IO ()
setAutoShapeType prop =
  Automation.propertySetID 0x65 [Automation.inVariant prop]
getCallout :: Automation.IDispatch a -> Prelude.IO (Office.ICalloutFormat Automation.Interface)
getCallout =
  Automation.propertyGetID 0x67 [] Automation.outIDispatch
getConnectionSiteCount :: Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getConnectionSiteCount =
  Automation.propertyGetID 0x68 [] Automation.outInt
getConnector :: (Automation.Variant a0) => Automation.IDispatch a -> Prelude.IO (a0)
getConnector =
  Automation.propertyGetID 0x69 [] Automation.outVariant
getConnectorFormat :: Automation.IDispatch a -> Prelude.IO (Office.IConnectorFormat Automation.Interface)
getConnectorFormat =
  Automation.propertyGetID 0x6a [] Automation.outIDispatch
getFill :: Automation.IDispatch a -> Prelude.IO (Office.IFillFormat Automation.Interface)
getFill = Automation.propertyGetID 0x6b [] Automation.outIDispatch
getGroupItems :: IShapeRange a -> Prelude.IO (Office.IGroupShapes Automation.Interface)
getGroupItems =
  Automation.propertyGetID 0x6c [] Automation.outIDispatch
getHorizontalFlip :: (Automation.Variant a0) => Automation.IDispatch a -> Prelude.IO (a0)
getHorizontalFlip =
  Automation.propertyGetID 0x6e [] Automation.outVariant
getLine :: Automation.IDispatch a -> Prelude.IO (Office.ILineFormat Automation.Interface)
getLine = Automation.propertyGetID 0x70 [] Automation.outIDispatch
getLockAspectRatio :: (Automation.Variant a0) => Automation.IDispatch a -> Prelude.IO (a0)
getLockAspectRatio =
  Automation.propertyGetID 0x71 [] Automation.outVariant
setLockAspectRatio :: (Automation.Variant a0) => a0 -> Automation.IDispatch a -> Prelude.IO ()
setLockAspectRatio prop =
  Automation.propertySetID 0x71 [Automation.inVariant prop]
getNodes :: Automation.IDispatch a -> Prelude.IO (Office.IShapeNodes Automation.Interface)
getNodes = Automation.propertyGetID 0x74 [] Automation.outIDispatch
getRotation :: Automation.IDispatch a -> Prelude.IO (Prelude.Float)
getRotation = Automation.propertyGetID 0x75 [] Automation.outFloat
setRotation :: Prelude.Float -> Automation.IDispatch a -> Prelude.IO ()
setRotation prop =
  Automation.propertySetID 0x75 [Automation.inFloat prop]
getPictureFormat :: Automation.IDispatch a -> Prelude.IO (Office.IPictureFormat Automation.Interface)
getPictureFormat =
  Automation.propertyGetID 0x76 [] Automation.outIDispatch
getShadow1 :: Automation.IDispatch a -> Prelude.IO (Office.IShadowFormat Automation.Interface)
getShadow1 =
  Automation.propertyGetID 0x77 [] Automation.outIDispatch
getTextEffect :: Automation.IDispatch a -> Prelude.IO (Office.ITextEffectFormat Automation.Interface)
getTextEffect =
  Automation.propertyGetID 0x78 [] Automation.outIDispatch
getTextFrame :: Automation.IDispatch a -> Prelude.IO (Office.ITextFrame Automation.Interface)
getTextFrame =
  Automation.propertyGetID 0x79 [] Automation.outIDispatch
getThreeD :: Automation.IDispatch a -> Prelude.IO (Office.IThreeDFormat Automation.Interface)
getThreeD =
  Automation.propertyGetID 0x7a [] Automation.outIDispatch
getType14 :: (Automation.Variant a0) => Automation.IDispatch a -> Prelude.IO (a0)
getType14 = Automation.propertyGetID 0x7c [] Automation.outVariant
getVerticalFlip :: (Automation.Variant a0) => Automation.IDispatch a -> Prelude.IO (a0)
getVerticalFlip =
  Automation.propertyGetID 0x7d [] Automation.outVariant
getVertices :: Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getVertices = Automation.propertyGetID 0x7e [] Automation.outInt
getVisible2 :: (Automation.Variant a0) => Automation.IDispatch a -> Prelude.IO (a0)
getVisible2 =
  Automation.propertyGetID 0x7f [] Automation.outVariant
setVisible2 :: (Automation.Variant a0) => a0 -> Automation.IDispatch a -> Prelude.IO ()
setVisible2 prop =
  Automation.propertySetID 0x7f [Automation.inVariant prop]
getZOrderPosition :: Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getZOrderPosition =
  Automation.propertyGetID 0x81 [] Automation.outInt
getHyperlink :: Automation.IDispatch a -> Prelude.IO (IHyperlink Automation.Interface)
getHyperlink =
  Automation.propertyGetID 0x3e9 [] Automation.outIDispatch
getLockAnchor0 :: Automation.IDispatch a -> Prelude.IO (Prelude.Int)
getLockAnchor0 =
  Automation.propertyGetID 0x12e [] Automation.outInt
setLockAnchor0 :: Prelude.Int -> Automation.IDispatch a -> Prelude.IO ()
setLockAnchor0 prop =
  Automation.propertySetID 0x12e [Automation.inInt prop]
getWrapFormat :: Automation.IDispatch a -> Prelude.IO (IWrapFormat Automation.Interface)
getWrapFormat =
  Automation.propertyGetID 0x12f [] Automation.outIDispatch
getAnchor :: Automation.IDispatch a -> Prelude.IO (IRange Automation.Interface)
getAnchor =
  Automation.propertyGetID 0x130 [] Automation.outIDispatch
align :: (Automation.Variant a0) => a0 -> Prelude.Int -> IShapeRange a -> Prelude.IO ()
align align relativeTo =
  Automation.methodID0 0xa [Automation.inVariant align, Automation.inInt relativeTo]
apply0 :: Automation.IDispatch a -> Prelude.IO ()
apply0 = Automation.methodID0 0xb []
distribute :: (Automation.Variant a0) => a0 -> Prelude.Int -> IShapeRange a -> Prelude.IO ()
distribute distribute relativeTo =
  Automation.methodID0 0xd [Automation.inVariant distribute, Automation.inInt relativeTo]
duplicate :: IShapeRange a -> Prelude.IO (IShapeRange Automation.Interface)
duplicate = Automation.functionID1 0xe [] Automation.outIDispatch
flip :: (Automation.Variant a0) => a0 -> Automation.IDispatch a -> Prelude.IO ()
flip flipCmd =
  Automation.methodID0 0xf [Automation.inVariant flipCmd]
incrementLeft :: Prelude.Float -> Automation.IDispatch a -> Prelude.IO ()
incrementLeft increment =
  Automation.methodID0 0x10 [Automation.inFloat increment]
incrementRotation :: Prelude.Float -> Automation.IDispatch a -> Prelude.IO ()
incrementRotation increment =
  Automation.methodID0 0x11 [Automation.inFloat increment]
incrementTop :: Prelude.Float -> Automation.IDispatch a -> Prelude.IO ()
incrementTop increment =
  Automation.methodID0 0x12 [Automation.inFloat increment]
group :: IShapeRange a -> Prelude.IO (Office.IShape Automation.Interface)
group = Automation.functionID1 0x13 [] Automation.outIDispatch
pickUp :: Automation.IDispatch a -> Prelude.IO ()
pickUp = Automation.methodID0 0x14 []
regroup :: IShapeRange a -> Prelude.IO (Office.IShape Automation.Interface)
regroup = Automation.functionID1 0x15 [] Automation.outIDispatch
rerouteConnections :: Automation.IDispatch a -> Prelude.IO ()
rerouteConnections = Automation.methodID0 0x16 []
scaleHeight :: (Automation.Variant a0, Automation.Variant a1) => Prelude.Float -> a0 -> a1 -> Automation.IDispatch a -> Prelude.IO ()
scaleHeight factor relativeToOriginalSize scale =
  Automation.methodID0 0x17 [Automation.inFloat factor, Automation.inVariant relativeToOriginalSize, Automation.inVariant scale]
scaleWidth :: (Automation.Variant a0, Automation.Variant a1) => Prelude.Float -> a0 -> a1 -> Automation.IDispatch a -> Prelude.IO ()
scaleWidth factor relativeToOriginalSize scale =
  Automation.methodID0 0x18 [Automation.inFloat factor, Automation.inVariant relativeToOriginalSize, Automation.inVariant scale]
select16 :: Prelude.Int -> Automation.IDispatch a -> Prelude.IO ()
select16 replace =
  Automation.methodID0 0x19 [Automation.inInt replace]
setShapesDefaultProperties :: Automation.IDispatch a -> Prelude.IO ()
setShapesDefaultProperties = Automation.methodID0 0x1a []
ungroup :: Automation.IDispatch a -> Prelude.IO (IShapeRange Automation.Interface)
ungroup = Automation.functionID1 0x1b [] Automation.outIDispatch
zOrder :: (Automation.Variant a0) => a0 -> Automation.IDispatch a -> Prelude.IO ()
zOrder zOrderCmd =
  Automation.methodID0 0x1c [Automation.inVariant zOrderCmd]
convertToFrame :: Automation.IDispatch a -> Prelude.IO (IFrame Automation.Interface)
convertToFrame =
  Automation.functionID1 0x1d [] Automation.outIDispatch
convertToInlineShape :: Automation.IDispatch a -> Prelude.IO (InlineShape Automation.Interface)
convertToInlineShape =
  Automation.functionID1 0x1e [] Automation.outIDispatch
-- --------------------------------------------------
-- 
-- interface GroupShapes
-- 
-- --------------------------------------------------
data GroupShapes a = GroupShapes
                      
type IGroupShapes a = Automation.IDispatch (GroupShapes a)
iidIGroupShapes :: Com.IID (IGroupShapes Automation.Interface)
iidIGroupShapes =
  Com.mkIID "{000209B6-0000-0000-C000-000000000046}"
-- --------------------------------------------------
-- 
-- interface Shape
-- 
-- --------------------------------------------------
data Shape a = Shape
                
type IShape a = Automation.IDispatch (Shape a)
iidIShape :: Com.IID (IShape Automation.Interface)
iidIShape = Com.mkIID "{000209A0-0000-0000-C000-000000000046}"
getGroupItems0 :: IShape a -> Prelude.IO (IGroupShapes Automation.Interface)
getGroupItems0 =
  Automation.propertyGetID 0x6c [] Automation.outIDispatch
duplicate0 :: IShape a -> Prelude.IO (IShape Automation.Interface)
duplicate0 = Automation.functionID1 0xc [] Automation.outIDispatch
-- --------------------------------------------------
-- 
-- interface TextFrame
-- 
-- --------------------------------------------------
data TextFrame a = TextFrame
                    
type ITextFrame a = Automation.IDispatch (TextFrame a)
iidITextFrame :: Com.IID (ITextFrame Automation.Interface)
iidITextFrame = Com.mkIID "{000209B2-0000-0000-C000-000000000046}"
getParent148 :: ITextFrame a -> Prelude.IO (IShape Automation.Interface)
getParent148 =
  Automation.propertyGetID 0x1 [] Automation.outIDispatch
getMarginBottom :: ITextFrame a -> Prelude.IO (Prelude.Float)
getMarginBottom =
  Automation.propertyGetID 0x64 [] Automation.outFloat
setMarginBottom :: Prelude.Float -> ITextFrame a -> Prelude.IO ()
setMarginBottom prop =
  Automation.propertySetID 0x64 [Automation.inFloat prop]
getMarginLeft :: ITextFrame a -> Prelude.IO (Prelude.Float)
getMarginLeft =
  Automation.propertyGetID 0x65 [] Automation.outFloat
setMarginLeft :: Prelude.Float -> ITextFrame a -> Prelude.IO ()
setMarginLeft prop =
  Automation.propertySetID 0x65 [Automation.inFloat prop]
getMarginRight :: ITextFrame a -> Prelude.IO (Prelude.Float)
getMarginRight =
  Automation.propertyGetID 0x66 [] Automation.outFloat
setMarginRight :: Prelude.Float -> ITextFrame a -> Prelude.IO ()
setMarginRight prop =
  Automation.propertySetID 0x66 [Automation.inFloat prop]
getMarginTop :: ITextFrame a -> Prelude.IO (Prelude.Float)
getMarginTop = Automation.propertyGetID 0x67 [] Automation.outFloat
setMarginTop :: Prelude.Float -> ITextFrame a -> Prelude.IO ()
setMarginTop prop =
  Automation.propertySetID 0x67 [Automation.inFloat prop]
getOrientation2 :: (Automation.Variant a0) => ITextFrame a -> Prelude.IO (a0)
getOrientation2 =
  Automation.propertyGetID 0x68 [] Automation.outVariant
setOrientation2 :: (Automation.Variant a0) => a0 -> ITextFrame a -> Prelude.IO ()
setOrientation2 prop =
  Automation.propertySetID 0x68 [Automation.inVariant prop]
getTextRange :: ITextFrame a -> Prelude.IO (IRange Automation.Interface)
getTextRange =
  Automation.propertyGetID 0x3e9 [] Automation.outIDispatch
getContainingRange :: ITextFrame a -> Prelude.IO (IRange Automation.Interface)
getContainingRange =
  Automation.propertyGetID 0x3ea [] Automation.outIDispatch
getNext8 :: ITextFrame a -> Prelude.IO (ITextFrame Automation.Interface)
getNext8 =
  Automation.propertyGetID 0x1389 [] Automation.outIDispatch
setNext :: ITextFrame a0 -> ITextFrame a -> Prelude.IO ()
setNext prop =
  Automation.propertySetID 0x1389 [Automation.inIDispatch prop]
getPrevious8 :: ITextFrame a -> Prelude.IO (ITextFrame Automation.Interface)
getPrevious8 =
  Automation.propertyGetID 0x138a [] Automation.outIDispatch
setPrevious :: ITextFrame a0 -> ITextFrame a -> Prelude.IO ()
setPrevious prop =
  Automation.propertySetID 0x138a [Automation.inIDispatch prop]
getOverflowing :: ITextFrame a -> Prelude.IO (Prelude.Int)
getOverflowing =
  Automation.propertyGetID 0x138b [] Automation.outInt
getHasText :: ITextFrame a -> Prelude.IO (Prelude.Int)
getHasText = Automation.propertyGetID 0x1390 [] Automation.outInt
breakForwardLink :: ITextFrame a -> Prelude.IO ()
breakForwardLink = Automation.methodID0 0x138c []
validLinkTarget :: ITextFrame a0 -> ITextFrame a -> Prelude.IO (Prelude.Int)
validLinkTarget targetTextFrame =
  Automation.functionID1 0x138e [Automation.inIDispatch targetTextFrame] Automation.outInt
-- --------------------------------------------------
-- 
-- interface LetterContent
-- 
-- --------------------------------------------------
data LetterContent a = LetterContent
                        
type ILetterContent a = Automation.IDispatch (LetterContent a)
iidILetterContent :: Com.IID (ILetterContent Automation.Interface)
iidILetterContent =
  Com.mkIID "{000209A1-0000-0000-C000-000000000046}"
getDuplicate3 :: ILetterContent a -> Prelude.IO (ILetterContent Automation.Interface)
getDuplicate3 =
  Automation.propertyGetID 0xa [] Automation.outIDispatch
getDateFormat :: ILetterContent a -> Prelude.IO (Prelude.String)
getDateFormat =
  Automation.propertyGetID 0x65 [] Automation.outString
setDateFormat :: Prelude.String -> ILetterContent a -> Prelude.IO ()
setDateFormat prop =
  Automation.propertySetID 0x65 [Automation.inString prop]
getIncludeHeaderFooter :: ILetterContent a -> Prelude.IO (Prelude.Int)
getIncludeHeaderFooter =
  Automation.propertyGetID 0x66 [] Automation.outInt
setIncludeHeaderFooter :: Prelude.Int -> ILetterContent a -> Prelude.IO ()
setIncludeHeaderFooter prop =
  Automation.propertySetID 0x66 [Automation.inInt prop]
getPageDesign :: ILetterContent a -> Prelude.IO (Prelude.String)
getPageDesign =
  Automation.propertyGetID 0x67 [] Automation.outString
setPageDesign :: Prelude.String -> ILetterContent a -> Prelude.IO ()
setPageDesign prop =
  Automation.propertySetID 0x67 [Automation.inString prop]
getLetterStyle :: (Automation.Variant a0) => ILetterContent a -> Prelude.IO (a0)
getLetterStyle =
  Automation.propertyGetID 0x68 [] Automation.outVariant
setLetterStyle :: (Automation.Variant a0) => a0 -> ILetterContent a -> Prelude.IO ()
setLetterStyle prop =
  Automation.propertySetID 0x68 [Automation.inVariant prop]
getLetterhead :: ILetterContent a -> Prelude.IO (Prelude.Int)
getLetterhead = Automation.propertyGetID 0x69 [] Automation.outInt
setLetterhead :: Prelude.Int -> ILetterContent a -> Prelude.IO ()
setLetterhead prop =
  Automation.propertySetID 0x69 [Automation.inInt prop]
getLetterheadLocation :: (Automation.Variant a0) => ILetterContent a -> Prelude.IO (a0)
getLetterheadLocation =
  Automation.propertyGetID 0x6a [] Automation.outVariant
setLetterheadLocation :: (Automation.Variant a0) => a0 -> ILetterContent a -> Prelude.IO ()
setLetterheadLocation prop =
  Automation.propertySetID 0x6a [Automation.inVariant prop]
getLetterheadSize :: ILetterContent a -> Prelude.IO (Prelude.Float)
getLetterheadSize =
  Automation.propertyGetID 0x6b [] Automation.outFloat
setLetterheadSize :: Prelude.Float -> ILetterContent a -> Prelude.IO ()
setLetterheadSize prop =
  Automation.propertySetID 0x6b [Automation.inFloat prop]
getRecipientName :: ILetterContent a -> Prelude.IO (Prelude.String)
getRecipientName =
  Automation.propertyGetID 0x6c [] Automation.outString
setRecipientName :: Prelude.String -> ILetterContent a -> Prelude.IO ()
setRecipientName prop =
  Automation.propertySetID 0x6c [Automation.inString prop]
getRecipientAddress :: ILetterContent a -> Prelude.IO (Prelude.String)
getRecipientAddress =
  Automation.propertyGetID 0x6d [] Automation.outString
setRecipientAddress :: Prelude.String -> ILetterContent a -> Prelude.IO ()
setRecipientAddress prop =
  Automation.propertySetID 0x6d [Automation.inString prop]
getSalutation :: ILetterContent a -> Prelude.IO (Prelude.String)
getSalutation =
  Automation.propertyGetID 0x6e [] Automation.outString
setSalutation :: Prelude.String -> ILetterContent a -> Prelude.IO ()
setSalutation prop =
  Automation.propertySetID 0x6e [Automation.inString prop]
getSalutationType :: (Automation.Variant a0) => ILetterContent a -> Prelude.IO (a0)
getSalutationType =
  Automation.propertyGetID 0x6f [] Automation.outVariant
setSalutationType :: (Automation.Variant a0) => a0 -> ILetterContent a -> Prelude.IO ()
setSalutationType prop =
  Automation.propertySetID 0x6f [Automation.inVariant prop]
getRecipientReference :: ILetterContent a -> Prelude.IO (Prelude.String)
getRecipientReference =
  Automation.propertyGetID 0x70 [] Automation.outString
setRecipientReference :: Prelude.String -> ILetterContent a -> Prelude.IO ()
setRecipientReference prop =
  Automation.propertySetID 0x70 [Automation.inString prop]
getMailingInstructions :: ILetterContent a -> Prelude.IO (Prelude.String)
getMailingInstructions =
  Automation.propertyGetID 0x72 [] Automation.outString
setMailingInstructions :: Prelude.String -> ILetterContent a -> Prelude.IO ()
setMailingInstructions prop =
  Automation.propertySetID 0x72 [Automation.inString prop]
getAttentionLine :: ILetterContent a -> Prelude.IO (Prelude.String)
getAttentionLine =
  Automation.propertyGetID 0x73 [] Automation.outString
setAttentionLine :: Prelude.String -> ILetterContent a -> Prelude.IO ()
setAttentionLine prop =
  Automation.propertySetID 0x73 [Automation.inString prop]
getEnclosureNumber :: ILetterContent a -> Prelude.IO (Prelude.Int)
getEnclosureNumber =
  Automation.propertyGetID 0x75 [] Automation.outInt
setEnclosureNumber :: Prelude.Int -> ILetterContent a -> Prelude.IO ()
setEnclosureNumber prop =
  Automation.propertySetID 0x75 [Automation.inInt prop]
getCCList :: ILetterContent a -> Prelude.IO (Prelude.String)
getCCList = Automation.propertyGetID 0x76 [] Automation.outString
setCCList :: Prelude.String -> ILetterContent a -> Prelude.IO ()
setCCList prop =
  Automation.propertySetID 0x76 [Automation.inString prop]
getReturnAddress0 :: ILetterContent a -> Prelude.IO (Prelude.String)
getReturnAddress0 =
  Automation.propertyGetID 0x77 [] Automation.outString
setReturnAddress :: Prelude.String -> ILetterContent a -> Prelude.IO ()
setReturnAddress prop =
  Automation.propertySetID 0x77 [Automation.inString prop]
getSenderName :: ILetterContent a -> Prelude.IO (Prelude.String)
getSenderName =
  Automation.propertyGetID 0x78 [] Automation.outString
setSenderName :: Prelude.String -> ILetterContent a -> Prelude.IO ()
setSenderName prop =
  Automation.propertySetID 0x78 [Automation.inString prop]
getClosing :: ILetterContent a -> Prelude.IO (Prelude.String)
getClosing = Automation.propertyGetID 0x79 [] Automation.outString
setClosing :: Prelude.String -> ILetterContent a -> Prelude.IO ()
setClosing prop =
  Automation.propertySetID 0x79 [Automation.inString prop]
getSenderCompany :: ILetterContent a -> Prelude.IO (Prelude.String)
getSenderCompany =
  Automation.propertyGetID 0x7a [] Automation.outString
setSenderCompany :: Prelude.String -> ILetterContent a -> Prelude.IO ()
setSenderCompany prop =
  Automation.propertySetID 0x7a [Automation.inString prop]
getSenderJobTitle :: ILetterContent a -> Prelude.IO (Prelude.String)
getSenderJobTitle =
  Automation.propertyGetID 0x7b [] Automation.outString
setSenderJobTitle :: Prelude.String -> ILetterContent a -> Prelude.IO ()
setSenderJobTitle prop =
  Automation.propertySetID 0x7b [Automation.inString prop]
getSenderInitials :: ILetterContent a -> Prelude.IO (Prelude.String)
getSenderInitials =
  Automation.propertyGetID 0x7c [] Automation.outString
setSenderInitials :: Prelude.String -> ILetterContent a -> Prelude.IO ()
setSenderInitials prop =
  Automation.propertySetID 0x7c [Automation.inString prop]
getInfoBlock :: ILetterContent a -> Prelude.IO (Prelude.Int)
getInfoBlock = Automation.propertyGetID 0x7d [] Automation.outInt
setInfoBlock :: Prelude.Int -> ILetterContent a -> Prelude.IO ()
setInfoBlock prop =
  Automation.propertySetID 0x7d [Automation.inInt prop]
getRecipientCode :: ILetterContent a -> Prelude.IO (Prelude.String)
getRecipientCode =
  Automation.propertyGetID 0x7e [] Automation.outString
setRecipientCode :: Prelude.String -> ILetterContent a -> Prelude.IO ()
setRecipientCode prop =
  Automation.propertySetID 0x7e [Automation.inString prop]
getRecipientGender :: (Automation.Variant a0) => ILetterContent a -> Prelude.IO (a0)
getRecipientGender =
  Automation.propertyGetID 0x7f [] Automation.outVariant
setRecipientGender :: (Automation.Variant a0) => a0 -> ILetterContent a -> Prelude.IO ()
setRecipientGender prop =
  Automation.propertySetID 0x7f [Automation.inVariant prop]
getReturnAddressShortForm :: ILetterContent a -> Prelude.IO (Prelude.String)
getReturnAddressShortForm =
  Automation.propertyGetID 0x80 [] Automation.outString
setReturnAddressShortForm :: Prelude.String -> ILetterContent a -> Prelude.IO ()
setReturnAddressShortForm prop =
  Automation.propertySetID 0x80 [Automation.inString prop]
getSenderCity :: ILetterContent a -> Prelude.IO (Prelude.String)
getSenderCity =
  Automation.propertyGetID 0x81 [] Automation.outString
setSenderCity :: Prelude.String -> ILetterContent a -> Prelude.IO ()
setSenderCity prop =
  Automation.propertySetID 0x81 [Automation.inString prop]
getSenderCode :: ILetterContent a -> Prelude.IO (Prelude.String)
getSenderCode =
  Automation.propertyGetID 0x82 [] Automation.outString
setSenderCode :: Prelude.String -> ILetterContent a -> Prelude.IO ()
setSenderCode prop =
  Automation.propertySetID 0x82 [Automation.inString prop]
getSenderGender :: (Automation.Variant a0) => ILetterContent a -> Prelude.IO (a0)
getSenderGender =
  Automation.propertyGetID 0x83 [] Automation.outVariant
setSenderGender :: (Automation.Variant a0) => a0 -> ILetterContent a -> Prelude.IO ()
setSenderGender prop =
  Automation.propertySetID 0x83 [Automation.inVariant prop]
getSenderReference :: ILetterContent a -> Prelude.IO (Prelude.String)
getSenderReference =
  Automation.propertyGetID 0x84 [] Automation.outString
setSenderReference :: Prelude.String -> ILetterContent a -> Prelude.IO ()
setSenderReference prop =
  Automation.propertySetID 0x84 [Automation.inString prop]
-- --------------------------------------------------
-- 
-- interface View
-- 
-- --------------------------------------------------
data View a = View
               
type IView a = Automation.IDispatch (View a)
iidIView :: Com.IID (IView Automation.Interface)
iidIView = Com.mkIID "{000209A5-0000-0000-C000-000000000046}"
getType16 :: (Automation.Variant a0) => IView a -> Prelude.IO (a0)
getType16 = Automation.propertyGetID 0o0 [] Automation.outVariant
setType0 :: (Automation.Variant a0) => a0 -> IView a -> Prelude.IO ()
setType0 prop =
  Automation.propertySetID 0o0 [Automation.inVariant prop]
getFullScreen :: IView a -> Prelude.IO (Prelude.Int)
getFullScreen = Automation.propertyGetID 0x1 [] Automation.outInt
setFullScreen :: Prelude.Int -> IView a -> Prelude.IO ()
setFullScreen prop =
  Automation.propertySetID 0x1 [Automation.inInt prop]
getDraft :: IView a -> Prelude.IO (Prelude.Int)
getDraft = Automation.propertyGetID 0x2 [] Automation.outInt
setDraft :: Prelude.Int -> IView a -> Prelude.IO ()
setDraft prop =
  Automation.propertySetID 0x2 [Automation.inInt prop]
getShowAll :: IView a -> Prelude.IO (Prelude.Int)
getShowAll = Automation.propertyGetID 0x3 [] Automation.outInt
setShowAll :: Prelude.Int -> IView a -> Prelude.IO ()
setShowAll prop =
  Automation.propertySetID 0x3 [Automation.inInt prop]
getShowFieldCodes :: IView a -> Prelude.IO (Prelude.Int)
getShowFieldCodes =
  Automation.propertyGetID 0x4 [] Automation.outInt
setShowFieldCodes :: Prelude.Int -> IView a -> Prelude.IO ()
setShowFieldCodes prop =
  Automation.propertySetID 0x4 [Automation.inInt prop]
getMailMergeDataView :: IView a -> Prelude.IO (Prelude.Int)
getMailMergeDataView =
  Automation.propertyGetID 0x5 [] Automation.outInt
setMailMergeDataView :: Prelude.Int -> IView a -> Prelude.IO ()
setMailMergeDataView prop =
  Automation.propertySetID 0x5 [Automation.inInt prop]
getMagnifier :: IView a -> Prelude.IO (Prelude.Int)
getMagnifier = Automation.propertyGetID 0x7 [] Automation.outInt
setMagnifier :: Prelude.Int -> IView a -> Prelude.IO ()
setMagnifier prop =
  Automation.propertySetID 0x7 [Automation.inInt prop]
getShowFirstLineOnly :: IView a -> Prelude.IO (Prelude.Int)
getShowFirstLineOnly =
  Automation.propertyGetID 0x8 [] Automation.outInt
setShowFirstLineOnly :: Prelude.Int -> IView a -> Prelude.IO ()
setShowFirstLineOnly prop =
  Automation.propertySetID 0x8 [Automation.inInt prop]
getShowFormat :: IView a -> Prelude.IO (Prelude.Int)
getShowFormat = Automation.propertyGetID 0x9 [] Automation.outInt
setShowFormat :: Prelude.Int -> IView a -> Prelude.IO ()
setShowFormat prop =
  Automation.propertySetID 0x9 [Automation.inInt prop]
getZoom :: IView a -> Prelude.IO (IZoom Automation.Interface)
getZoom = Automation.propertyGetID 0xa [] Automation.outIDispatch
getShowObjectAnchors :: IView a -> Prelude.IO (Prelude.Int)
getShowObjectAnchors =
  Automation.propertyGetID 0xb [] Automation.outInt
setShowObjectAnchors :: Prelude.Int -> IView a -> Prelude.IO ()
setShowObjectAnchors prop =
  Automation.propertySetID 0xb [Automation.inInt prop]
getShowTextBoundaries :: IView a -> Prelude.IO (Prelude.Int)
getShowTextBoundaries =
  Automation.propertyGetID 0xc [] Automation.outInt
setShowTextBoundaries :: Prelude.Int -> IView a -> Prelude.IO ()
setShowTextBoundaries prop =
  Automation.propertySetID 0xc [Automation.inInt prop]
getShowHighlight :: IView a -> Prelude.IO (Prelude.Int)
getShowHighlight =
  Automation.propertyGetID 0xd [] Automation.outInt
setShowHighlight :: Prelude.Int -> IView a -> Prelude.IO ()
setShowHighlight prop =
  Automation.propertySetID 0xd [Automation.inInt prop]
getShowDrawings :: IView a -> Prelude.IO (Prelude.Int)
getShowDrawings = Automation.propertyGetID 0xe [] Automation.outInt
setShowDrawings :: Prelude.Int -> IView a -> Prelude.IO ()
setShowDrawings prop =
  Automation.propertySetID 0xe [Automation.inInt prop]
getShowTabs :: IView a -> Prelude.IO (Prelude.Int)
getShowTabs = Automation.propertyGetID 0xf [] Automation.outInt
setShowTabs :: Prelude.Int -> IView a -> Prelude.IO ()
setShowTabs prop =
  Automation.propertySetID 0xf [Automation.inInt prop]
getShowSpaces :: IView a -> Prelude.IO (Prelude.Int)
getShowSpaces = Automation.propertyGetID 0x10 [] Automation.outInt
setShowSpaces :: Prelude.Int -> IView a -> Prelude.IO ()
setShowSpaces prop =
  Automation.propertySetID 0x10 [Automation.inInt prop]
getShowParagraphs :: IView a -> Prelude.IO (Prelude.Int)
getShowParagraphs =
  Automation.propertyGetID 0x11 [] Automation.outInt
setShowParagraphs :: Prelude.Int -> IView a -> Prelude.IO ()
setShowParagraphs prop =
  Automation.propertySetID 0x11 [Automation.inInt prop]
getShowHyphens :: IView a -> Prelude.IO (Prelude.Int)
getShowHyphens = Automation.propertyGetID 0x12 [] Automation.outInt
setShowHyphens :: Prelude.Int -> IView a -> Prelude.IO ()
setShowHyphens prop =
  Automation.propertySetID 0x12 [Automation.inInt prop]
getShowHiddenText :: IView a -> Prelude.IO (Prelude.Int)
getShowHiddenText =
  Automation.propertyGetID 0x13 [] Automation.outInt
setShowHiddenText :: Prelude.Int -> IView a -> Prelude.IO ()
setShowHiddenText prop =
  Automation.propertySetID 0x13 [Automation.inInt prop]
getWrapToWindow :: IView a -> Prelude.IO (Prelude.Int)
getWrapToWindow =
  Automation.propertyGetID 0x14 [] Automation.outInt
setWrapToWindow :: Prelude.Int -> IView a -> Prelude.IO ()
setWrapToWindow prop =
  Automation.propertySetID 0x14 [Automation.inInt prop]
getShowPicturePlaceHolders :: IView a -> Prelude.IO (Prelude.Int)
getShowPicturePlaceHolders =
  Automation.propertyGetID 0x15 [] Automation.outInt
setShowPicturePlaceHolders :: Prelude.Int -> IView a -> Prelude.IO ()
setShowPicturePlaceHolders prop =
  Automation.propertySetID 0x15 [Automation.inInt prop]
getShowBookmarks :: IView a -> Prelude.IO (Prelude.Int)
getShowBookmarks =
  Automation.propertyGetID 0x16 [] Automation.outInt
setShowBookmarks :: Prelude.Int -> IView a -> Prelude.IO ()
setShowBookmarks prop =
  Automation.propertySetID 0x16 [Automation.inInt prop]
getFieldShading :: (Automation.Variant a0) => IView a -> Prelude.IO (a0)
getFieldShading =
  Automation.propertyGetID 0x17 [] Automation.outVariant
setFieldShading :: (Automation.Variant a0) => a0 -> IView a -> Prelude.IO ()
setFieldShading prop =
  Automation.propertySetID 0x17 [Automation.inVariant prop]
getShowAnimation :: IView a -> Prelude.IO (Prelude.Int)
getShowAnimation =
  Automation.propertyGetID 0x18 [] Automation.outInt
setShowAnimation :: Prelude.Int -> IView a -> Prelude.IO ()
setShowAnimation prop =
  Automation.propertySetID 0x18 [Automation.inInt prop]
getTableGridlines :: IView a -> Prelude.IO (Prelude.Int)
getTableGridlines =
  Automation.propertyGetID 0x19 [] Automation.outInt
setTableGridlines :: Prelude.Int -> IView a -> Prelude.IO ()
setTableGridlines prop =
  Automation.propertySetID 0x19 [Automation.inInt prop]
getEnlargeFontsLessThan :: IView a -> Prelude.IO (Prelude.Int)
getEnlargeFontsLessThan =
  Automation.propertyGetID 0x1a [] Automation.outInt
setEnlargeFontsLessThan :: Prelude.Int -> IView a -> Prelude.IO ()
setEnlargeFontsLessThan prop =
  Automation.propertySetID 0x1a [Automation.inInt prop]
getShowMainTextLayer :: IView a -> Prelude.IO (Prelude.Int)
getShowMainTextLayer =
  Automation.propertyGetID 0x1b [] Automation.outInt
setShowMainTextLayer :: Prelude.Int -> IView a -> Prelude.IO ()
setShowMainTextLayer prop =
  Automation.propertySetID 0x1b [Automation.inInt prop]
getSeekView :: (Automation.Variant a0) => IView a -> Prelude.IO (a0)
getSeekView =
  Automation.propertyGetID 0x1c [] Automation.outVariant
setSeekView :: (Automation.Variant a0) => a0 -> IView a -> Prelude.IO ()
setSeekView prop =
  Automation.propertySetID 0x1c [Automation.inVariant prop]
getSplitSpecial :: (Automation.Variant a0) => IView a -> Prelude.IO (a0)
getSplitSpecial =
  Automation.propertyGetID 0x1d [] Automation.outVariant
setSplitSpecial :: (Automation.Variant a0) => a0 -> IView a -> Prelude.IO ()
setSplitSpecial prop =
  Automation.propertySetID 0x1d [Automation.inVariant prop]
getBrowseToWindow0 :: IView a -> Prelude.IO (Prelude.Int)
getBrowseToWindow0 =
  Automation.propertyGetID 0x1e [] Automation.outInt
setBrowseToWindow0 :: Prelude.Int -> IView a -> Prelude.IO ()
setBrowseToWindow0 prop =
  Automation.propertySetID 0x1e [Automation.inInt prop]
getShowOptionalBreaks :: IView a -> Prelude.IO (Prelude.Int)
getShowOptionalBreaks =
  Automation.propertyGetID 0x1f [] Automation.outInt
setShowOptionalBreaks :: Prelude.Int -> IView a -> Prelude.IO ()
setShowOptionalBreaks prop =
  Automation.propertySetID 0x1f [Automation.inInt prop]
collapseOutline :: Prelude.Int -> IView a -> Prelude.IO ()
collapseOutline range =
  Automation.methodID0 0x65 [Automation.inInt range]
expandOutline :: Prelude.Int -> IView a -> Prelude.IO ()
expandOutline range =
  Automation.methodID0 0x66 [Automation.inInt range]
showAllHeadings :: IView a -> Prelude.IO ()
showAllHeadings = Automation.methodID0 0x67 []
showHeading :: Prelude.Int -> IView a -> Prelude.IO ()
showHeading level =
  Automation.methodID0 0x68 [Automation.inInt level]
previousHeaderFooter :: IView a -> Prelude.IO ()
previousHeaderFooter = Automation.methodID0 0x69 []
nextHeaderFooter :: IView a -> Prelude.IO ()
nextHeaderFooter = Automation.methodID0 0x6a []
-- --------------------------------------------------
-- 
-- interface Zoom
-- 
-- --------------------------------------------------
data Zoom a = Zoom
               
type IZoom a = Automation.IDispatch (Zoom a)
iidIZoom :: Com.IID (IZoom Automation.Interface)
iidIZoom = Com.mkIID "{000209A6-0000-0000-C000-000000000046}"
getPercentage :: IZoom a -> Prelude.IO (Prelude.Int)
getPercentage = Automation.propertyGetID 0o0 [] Automation.outInt
setPercentage :: Prelude.Int -> IZoom a -> Prelude.IO ()
setPercentage prop =
  Automation.propertySetID 0o0 [Automation.inInt prop]
getPageFit :: (Automation.Variant a0) => IZoom a -> Prelude.IO (a0)
getPageFit = Automation.propertyGetID 0x1 [] Automation.outVariant
setPageFit :: (Automation.Variant a0) => a0 -> IZoom a -> Prelude.IO ()
setPageFit prop =
  Automation.propertySetID 0x1 [Automation.inVariant prop]
getPageRows :: IZoom a -> Prelude.IO (Prelude.Int)
getPageRows = Automation.propertyGetID 0x2 [] Automation.outInt
setPageRows :: Prelude.Int -> IZoom a -> Prelude.IO ()
setPageRows prop =
  Automation.propertySetID 0x2 [Automation.inInt prop]
getPageColumns :: IZoom a -> Prelude.IO (Prelude.Int)
getPageColumns = Automation.propertyGetID 0x3 [] Automation.outInt
setPageColumns :: Prelude.Int -> IZoom a -> Prelude.IO ()
setPageColumns prop =
  Automation.propertySetID 0x3 [Automation.inInt prop]
-- --------------------------------------------------
-- 
-- interface Zooms
-- 
-- --------------------------------------------------
data Zooms a = Zooms
                
type IZooms a = Automation.IDispatch (Zooms a)
iidIZooms :: Com.IID (IZooms Automation.Interface)
iidIZooms = Com.mkIID "{000209A7-0000-0000-C000-000000000046}"
item64 :: (Automation.Variant a0) => a0 -> IZooms a -> Prelude.IO (IZoom Automation.Interface)
item64 idex =
  Automation.functionID1 0o0 [Automation.inVariant idex] Automation.outIDispatch
-- --------------------------------------------------
-- 
-- interface InlineShape
-- 
-- --------------------------------------------------
data NlineShape a = NlineShape
                     
type InlineShape a = Automation.IDispatch (NlineShape a)
iidInlineShape :: Com.IID (InlineShape Automation.Interface)
iidInlineShape = Com.mkIID "{000209A8-0000-0000-C000-000000000046}"
getField :: InlineShape a -> Prelude.IO (IField Automation.Interface)
getField = Automation.propertyGetID 0x4 [] Automation.outIDispatch
getType17 :: (Automation.Variant a0) => InlineShape a -> Prelude.IO (a0)
getType17 = Automation.propertyGetID 0x6 [] Automation.outVariant
getScaleHeight :: InlineShape a -> Prelude.IO (Prelude.Float)
getScaleHeight =
  Automation.propertyGetID 0xa [] Automation.outFloat
setScaleHeight :: Prelude.Float -> Automation.IDispatch a -> Prelude.IO ()
setScaleHeight prop =
  Automation.propertySetID 0xa [Automation.inFloat prop]
getScaleWidth :: InlineShape a -> Prelude.IO (Prelude.Float)
getScaleWidth = Automation.propertyGetID 0xb [] Automation.outFloat
setScaleWidth :: Prelude.Float -> Automation.IDispatch a -> Prelude.IO ()
setScaleWidth prop =
  Automation.propertySetID 0xb [Automation.inFloat prop]
setPictureFormat :: Office.IPictureFormat a0 -> InlineShape a -> Prelude.IO ()
setPictureFormat prop =
  Automation.propertySetID 0x76 [Automation.inIDispatch prop]
convertToShape :: InlineShape a -> Prelude.IO (IShape Automation.Interface)
convertToShape =
  Automation.functionID1 0x68 [] Automation.outIDispatch
-- --------------------------------------------------
-- 
-- interface InlineShapes
-- 
-- --------------------------------------------------
data NlineShapes a = NlineShapes
                      
type InlineShapes a = Automation.IDispatch (NlineShapes a)
iidInlineShapes :: Com.IID (InlineShapes Automation.Interface)
iidInlineShapes =
  Com.mkIID "{000209A9-0000-0000-C000-000000000046}"
item65 :: Prelude.Int -> InlineShapes a -> Prelude.IO (InlineShape Automation.Interface)
item65 idex =
  Automation.functionID1 0o0 [Automation.inInt idex] Automation.outIDispatch
addPicture0 :: Prelude.String -> Prelude.Int -> Prelude.Int -> Prelude.Int -> InlineShapes a -> Prelude.IO (InlineShape Automation.Interface)
addPicture0 fileName linkToFile saveWithDocument range =
  Automation.functionID1 0x64 [Automation.inString fileName, Automation.inInt linkToFile, Automation.inInt saveWithDocument, Automation.inInt range] Automation.outIDispatch
addOLEObject0 :: Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> InlineShapes a -> Prelude.IO (InlineShape Automation.Interface)
addOLEObject0 classType fileName linkToFile displayAsIcon iconFileName iconIndex iconLabel range =
  Automation.functionID1 0x18 [Automation.inInt classType, Automation.inInt fileName, Automation.inInt linkToFile, Automation.inInt displayAsIcon, Automation.inInt iconFileName, Automation.inInt iconIndex, Automation.inInt iconLabel, Automation.inInt range] Automation.outIDispatch
addOLEControl0 :: Prelude.Int -> Prelude.Int -> InlineShapes a -> Prelude.IO (InlineShape Automation.Interface)
addOLEControl0 classType range =
  Automation.functionID1 0x66 [Automation.inInt classType, Automation.inInt range] Automation.outIDispatch
new :: IRange a0 -> InlineShapes a -> Prelude.IO (InlineShape Automation.Interface)
new range =
  Automation.functionID1 0xc8 [Automation.inIDispatch range] Automation.outIDispatch
-- --------------------------------------------------
-- 
-- interface SpellingSuggestions
-- 
-- --------------------------------------------------
data SpellingSuggestions a = SpellingSuggestions
                              
type ISpellingSuggestions a = Automation.IDispatch (SpellingSuggestions a)
iidISpellingSuggestions :: Com.IID (ISpellingSuggestions Automation.Interface)
iidISpellingSuggestions =
  Com.mkIID "{000209AA-0000-0000-C000-000000000046}"
getSpellingErrorType :: (Automation.Variant a0) => ISpellingSuggestions a -> Prelude.IO (a0)
getSpellingErrorType =
  Automation.propertyGetID 0x2 [] Automation.outVariant
item66 :: Prelude.Int -> ISpellingSuggestions a -> Prelude.IO (ISpellingSuggestion Automation.Interface)
item66 idex =
  Automation.functionID1 0o0 [Automation.inInt idex] Automation.outIDispatch
-- --------------------------------------------------
-- 
-- interface SpellingSuggestion
-- 
-- --------------------------------------------------
data SpellingSuggestion a = SpellingSuggestion
                             
type ISpellingSuggestion a = Automation.IDispatch (SpellingSuggestion a)
iidISpellingSuggestion :: Com.IID (ISpellingSuggestion Automation.Interface)
iidISpellingSuggestion =
  Com.mkIID "{000209AB-0000-0000-C000-000000000046}"
-- --------------------------------------------------
-- 
-- interface Dictionaries
-- 
-- --------------------------------------------------
data Dictionaries a = Dictionaries
                       
type IDictionaries a = Automation.IDispatch (Dictionaries a)
iidIDictionaries :: Com.IID (IDictionaries Automation.Interface)
iidIDictionaries =
  Com.mkIID "{000209AC-0000-0000-C000-000000000046}"
getActiveCustomDictionary :: Automation.IDispatch a -> Prelude.IO (IDictionary Automation.Interface)
getActiveCustomDictionary =
  Automation.propertyGetID 0x3 [] Automation.outIDispatch
setActiveCustomDictionary :: IDictionary a0 -> Automation.IDispatch a -> Prelude.IO ()
setActiveCustomDictionary prop =
  Automation.propertySetID 0x3 [Automation.inIDispatch prop]
item67 :: Prelude.Int -> Automation.IDispatch a -> Prelude.IO (IDictionary Automation.Interface)
item67 idex =
  Automation.functionID1 0o0 [Automation.inInt idex] Automation.outIDispatch
add38 :: Prelude.String -> Automation.IDispatch a -> Prelude.IO (IDictionary Automation.Interface)
add38 fileName =
  Automation.functionID1 0x65 [Automation.inString fileName] Automation.outIDispatch
-- --------------------------------------------------
-- 
-- interface HangulHanjaConversionDictionaries
-- 
-- --------------------------------------------------
data HangulHanjaConversionDictionaries a = HangulHanjaConversionDictionaries
                                            
type IHangulHanjaConversionDictionaries a = Automation.IDispatch (HangulHanjaConversionDictionaries a)
iidIHangulHanjaConversionDictionaries :: Com.IID (IHangulHanjaConversionDictionaries Automation.Interface)
iidIHangulHanjaConversionDictionaries =
  Com.mkIID "{000209E0-0000-0000-C000-000000000046}"
getBuiltinDictionary :: IHangulHanjaConversionDictionaries a -> Prelude.IO (IDictionary Automation.Interface)
getBuiltinDictionary =
  Automation.propertyGetID 0x4 [] Automation.outIDispatch
-- --------------------------------------------------
-- 
-- interface Dictionary
-- 
-- --------------------------------------------------
data Dictionary a = Dictionary
                     
type IDictionary a = Automation.IDispatch (Dictionary a)
iidIDictionary :: Com.IID (IDictionary Automation.Interface)
iidIDictionary = Com.mkIID "{000209AD-0000-0000-C000-000000000046}"
getType18 :: (Automation.Variant a0) => IDictionary a -> Prelude.IO (a0)
getType18 = Automation.propertyGetID 0x4 [] Automation.outVariant
getLanguageSpecific :: IDictionary a -> Prelude.IO (Prelude.Int)
getLanguageSpecific =
  Automation.propertyGetID 0x5 [] Automation.outInt
setLanguageSpecific :: Prelude.Int -> IDictionary a -> Prelude.IO ()
setLanguageSpecific prop =
  Automation.propertySetID 0x5 [Automation.inInt prop]
-- --------------------------------------------------
-- 
-- interface ReadabilityStatistics
-- 
-- --------------------------------------------------
data ReadabilityStatistics a = ReadabilityStatistics
                                
type IReadabilityStatistics a = Automation.IDispatch (ReadabilityStatistics a)
iidIReadabilityStatistics :: Com.IID (IReadabilityStatistics Automation.Interface)
iidIReadabilityStatistics =
  Com.mkIID "{000209AE-0000-0000-C000-000000000046}"
item69 :: Prelude.Int -> IReadabilityStatistics a -> Prelude.IO (IReadabilityStatistic Automation.Interface)
item69 idex =
  Automation.functionID1 0o0 [Automation.inInt idex] Automation.outIDispatch
-- --------------------------------------------------
-- 
-- interface ReadabilityStatistic
-- 
-- --------------------------------------------------
data ReadabilityStatistic a = ReadabilityStatistic
                               
type IReadabilityStatistic a = Automation.IDispatch (ReadabilityStatistic a)
iidIReadabilityStatistic :: Com.IID (IReadabilityStatistic Automation.Interface)
iidIReadabilityStatistic =
  Com.mkIID "{000209AF-0000-0000-C000-000000000046}"
getValue5 :: IReadabilityStatistic a -> Prelude.IO (Prelude.Float)
getValue5 = Automation.propertyGetID 0x1 [] Automation.outFloat
-- --------------------------------------------------
-- 
-- interface Versions
-- 
-- --------------------------------------------------
data Versions a = Versions
                   
type IVersions a = Automation.IDispatch (Versions a)
iidIVersions :: Com.IID (IVersions Automation.Interface)
iidIVersions = Com.mkIID "{000209B3-0000-0000-C000-000000000046}"
getAutoVersion :: (Automation.Variant a0) => IVersions a -> Prelude.IO (a0)
getAutoVersion =
  Automation.propertyGetID 0x3 [] Automation.outVariant
setAutoVersion :: (Automation.Variant a0) => a0 -> IVersions a -> Prelude.IO ()
setAutoVersion prop =
  Automation.propertySetID 0x3 [Automation.inVariant prop]
item70 :: Prelude.Int -> IVersions a -> Prelude.IO (IVersion Automation.Interface)
item70 idex =
  Automation.functionID1 0o0 [Automation.inInt idex] Automation.outIDispatch
save2 :: Prelude.Int -> Automation.IDispatch a -> Prelude.IO ()
save2 comment = Automation.methodID0 0xb [Automation.inInt comment]
-- --------------------------------------------------
-- 
-- interface Version
-- 
-- --------------------------------------------------
data Version a = Version
                  
type IVersion a = Automation.IDispatch (Version a)
iidIVersion :: Com.IID (IVersion Automation.Interface)
iidIVersion = Com.mkIID "{000209B4-0000-0000-C000-000000000046}"
getSavedBy :: IVersion a -> Prelude.IO (Prelude.String)
getSavedBy = Automation.propertyGetID 0x3eb [] Automation.outString
getComment :: IVersion a -> Prelude.IO (Prelude.String)
getComment = Automation.propertyGetID 0x3ec [] Automation.outString
-- --------------------------------------------------
-- 
-- interface Options
-- 
-- --------------------------------------------------
data Options a = Options
                  
type IOptions a = Automation.IDispatch (Options a)
iidIOptions :: Com.IID (IOptions Automation.Interface)
iidIOptions = Com.mkIID "{000209B7-0000-0000-C000-000000000046}"
getAllowAccentedUppercase :: IOptions a -> Prelude.IO (Prelude.Int)
getAllowAccentedUppercase =
  Automation.propertyGetID 0x1 [] Automation.outInt
setAllowAccentedUppercase :: Prelude.Int -> IOptions a -> Prelude.IO ()
setAllowAccentedUppercase prop =
  Automation.propertySetID 0x1 [Automation.inInt prop]
getWPHelp :: IOptions a -> Prelude.IO (Prelude.Int)
getWPHelp = Automation.propertyGetID 0x11 [] Automation.outInt
setWPHelp :: Prelude.Int -> IOptions a -> Prelude.IO ()
setWPHelp prop =
  Automation.propertySetID 0x11 [Automation.inInt prop]
getWPDocNavKeys :: IOptions a -> Prelude.IO (Prelude.Int)
getWPDocNavKeys =
  Automation.propertyGetID 0x12 [] Automation.outInt
setWPDocNavKeys :: Prelude.Int -> IOptions a -> Prelude.IO ()
setWPDocNavKeys prop =
  Automation.propertySetID 0x12 [Automation.inInt prop]
getPagination :: IOptions a -> Prelude.IO (Prelude.Int)
getPagination = Automation.propertyGetID 0x13 [] Automation.outInt
setPagination :: Prelude.Int -> IOptions a -> Prelude.IO ()
setPagination prop =
  Automation.propertySetID 0x13 [Automation.inInt prop]
getBlueScreen :: IOptions a -> Prelude.IO (Prelude.Int)
getBlueScreen = Automation.propertyGetID 0x14 [] Automation.outInt
setBlueScreen :: Prelude.Int -> IOptions a -> Prelude.IO ()
setBlueScreen prop =
  Automation.propertySetID 0x14 [Automation.inInt prop]
getEnableSound :: IOptions a -> Prelude.IO (Prelude.Int)
getEnableSound = Automation.propertyGetID 0x15 [] Automation.outInt
setEnableSound :: Prelude.Int -> IOptions a -> Prelude.IO ()
setEnableSound prop =
  Automation.propertySetID 0x15 [Automation.inInt prop]
getConfirmConversions :: IOptions a -> Prelude.IO (Prelude.Int)
getConfirmConversions =
  Automation.propertyGetID 0x16 [] Automation.outInt
setConfirmConversions :: Prelude.Int -> IOptions a -> Prelude.IO ()
setConfirmConversions prop =
  Automation.propertySetID 0x16 [Automation.inInt prop]
getUpdateLinksAtOpen :: IOptions a -> Prelude.IO (Prelude.Int)
getUpdateLinksAtOpen =
  Automation.propertyGetID 0x17 [] Automation.outInt
setUpdateLinksAtOpen :: Prelude.Int -> IOptions a -> Prelude.IO ()
setUpdateLinksAtOpen prop =
  Automation.propertySetID 0x17 [Automation.inInt prop]
getSendMailAttach :: IOptions a -> Prelude.IO (Prelude.Int)
getSendMailAttach =
  Automation.propertyGetID 0x18 [] Automation.outInt
setSendMailAttach :: Prelude.Int -> IOptions a -> Prelude.IO ()
setSendMailAttach prop =
  Automation.propertySetID 0x18 [Automation.inInt prop]
getMeasurementUnit :: (Automation.Variant a0) => IOptions a -> Prelude.IO (a0)
getMeasurementUnit =
  Automation.propertyGetID 0x1a [] Automation.outVariant
setMeasurementUnit :: (Automation.Variant a0) => a0 -> IOptions a -> Prelude.IO ()
setMeasurementUnit prop =
  Automation.propertySetID 0x1a [Automation.inVariant prop]
getButtonFieldClicks :: IOptions a -> Prelude.IO (Prelude.Int)
getButtonFieldClicks =
  Automation.propertyGetID 0x1b [] Automation.outInt
setButtonFieldClicks :: Prelude.Int -> IOptions a -> Prelude.IO ()
setButtonFieldClicks prop =
  Automation.propertySetID 0x1b [Automation.inInt prop]
getShortMenuNames :: IOptions a -> Prelude.IO (Prelude.Int)
getShortMenuNames =
  Automation.propertyGetID 0x1c [] Automation.outInt
setShortMenuNames :: Prelude.Int -> IOptions a -> Prelude.IO ()
setShortMenuNames prop =
  Automation.propertySetID 0x1c [Automation.inInt prop]
getRTFInClipboard :: IOptions a -> Prelude.IO (Prelude.Int)
getRTFInClipboard =
  Automation.propertyGetID 0x1d [] Automation.outInt
setRTFInClipboard :: Prelude.Int -> IOptions a -> Prelude.IO ()
setRTFInClipboard prop =
  Automation.propertySetID 0x1d [Automation.inInt prop]
getUpdateFieldsAtPrint :: IOptions a -> Prelude.IO (Prelude.Int)
getUpdateFieldsAtPrint =
  Automation.propertyGetID 0x1e [] Automation.outInt
setUpdateFieldsAtPrint :: Prelude.Int -> IOptions a -> Prelude.IO ()
setUpdateFieldsAtPrint prop =
  Automation.propertySetID 0x1e [Automation.inInt prop]
getPrintProperties :: IOptions a -> Prelude.IO (Prelude.Int)
getPrintProperties =
  Automation.propertyGetID 0x1f [] Automation.outInt
setPrintProperties :: Prelude.Int -> IOptions a -> Prelude.IO ()
setPrintProperties prop =
  Automation.propertySetID 0x1f [Automation.inInt prop]
getPrintFieldCodes :: IOptions a -> Prelude.IO (Prelude.Int)
getPrintFieldCodes =
  Automation.propertyGetID 0x20 [] Automation.outInt
setPrintFieldCodes :: Prelude.Int -> IOptions a -> Prelude.IO ()
setPrintFieldCodes prop =
  Automation.propertySetID 0x20 [Automation.inInt prop]
getPrintComments :: IOptions a -> Prelude.IO (Prelude.Int)
getPrintComments =
  Automation.propertyGetID 0x21 [] Automation.outInt
setPrintComments :: Prelude.Int -> IOptions a -> Prelude.IO ()
setPrintComments prop =
  Automation.propertySetID 0x21 [Automation.inInt prop]
getPrintHiddenText :: IOptions a -> Prelude.IO (Prelude.Int)
getPrintHiddenText =
  Automation.propertyGetID 0x22 [] Automation.outInt
setPrintHiddenText :: Prelude.Int -> IOptions a -> Prelude.IO ()
setPrintHiddenText prop =
  Automation.propertySetID 0x22 [Automation.inInt prop]
getEnvelopeFeederInstalled :: IOptions a -> Prelude.IO (Prelude.Int)
getEnvelopeFeederInstalled =
  Automation.propertyGetID 0x23 [] Automation.outInt
getUpdateLinksAtPrint :: IOptions a -> Prelude.IO (Prelude.Int)
getUpdateLinksAtPrint =
  Automation.propertyGetID 0x24 [] Automation.outInt
setUpdateLinksAtPrint :: Prelude.Int -> IOptions a -> Prelude.IO ()
setUpdateLinksAtPrint prop =
  Automation.propertySetID 0x24 [Automation.inInt prop]
getPrintBackground :: IOptions a -> Prelude.IO (Prelude.Int)
getPrintBackground =
  Automation.propertyGetID 0x25 [] Automation.outInt
setPrintBackground :: Prelude.Int -> IOptions a -> Prelude.IO ()
setPrintBackground prop =
  Automation.propertySetID 0x25 [Automation.inInt prop]
getPrintDrawingObjects :: IOptions a -> Prelude.IO (Prelude.Int)
getPrintDrawingObjects =
  Automation.propertyGetID 0x26 [] Automation.outInt
setPrintDrawingObjects :: Prelude.Int -> IOptions a -> Prelude.IO ()
setPrintDrawingObjects prop =
  Automation.propertySetID 0x26 [Automation.inInt prop]
getDefaultTray :: IOptions a -> Prelude.IO (Prelude.String)
getDefaultTray =
  Automation.propertyGetID 0x27 [] Automation.outString
setDefaultTray :: Prelude.String -> IOptions a -> Prelude.IO ()
setDefaultTray prop =
  Automation.propertySetID 0x27 [Automation.inString prop]
getDefaultTrayID :: IOptions a -> Prelude.IO (Prelude.Int)
getDefaultTrayID =
  Automation.propertyGetID 0x28 [] Automation.outInt
setDefaultTrayID :: Prelude.Int -> IOptions a -> Prelude.IO ()
setDefaultTrayID prop =
  Automation.propertySetID 0x28 [Automation.inInt prop]
getCreateBackup :: IOptions a -> Prelude.IO (Prelude.Int)
getCreateBackup =
  Automation.propertyGetID 0x29 [] Automation.outInt
setCreateBackup :: Prelude.Int -> IOptions a -> Prelude.IO ()
setCreateBackup prop =
  Automation.propertySetID 0x29 [Automation.inInt prop]
getAllowFastSave :: IOptions a -> Prelude.IO (Prelude.Int)
getAllowFastSave =
  Automation.propertyGetID 0x2a [] Automation.outInt
setAllowFastSave :: Prelude.Int -> IOptions a -> Prelude.IO ()
setAllowFastSave prop =
  Automation.propertySetID 0x2a [Automation.inInt prop]
getSavePropertiesPrompt :: IOptions a -> Prelude.IO (Prelude.Int)
getSavePropertiesPrompt =
  Automation.propertyGetID 0x2b [] Automation.outInt
setSavePropertiesPrompt :: Prelude.Int -> IOptions a -> Prelude.IO ()
setSavePropertiesPrompt prop =
  Automation.propertySetID 0x2b [Automation.inInt prop]
getSaveNormalPrompt :: IOptions a -> Prelude.IO (Prelude.Int)
getSaveNormalPrompt =
  Automation.propertyGetID 0x2c [] Automation.outInt
setSaveNormalPrompt :: Prelude.Int -> IOptions a -> Prelude.IO ()
setSaveNormalPrompt prop =
  Automation.propertySetID 0x2c [Automation.inInt prop]
getSaveInterval :: IOptions a -> Prelude.IO (Prelude.Int)
getSaveInterval =
  Automation.propertyGetID 0x2d [] Automation.outInt
setSaveInterval :: Prelude.Int -> IOptions a -> Prelude.IO ()
setSaveInterval prop =
  Automation.propertySetID 0x2d [Automation.inInt prop]
getBackgroundSave :: IOptions a -> Prelude.IO (Prelude.Int)
getBackgroundSave =
  Automation.propertyGetID 0x2e [] Automation.outInt
setBackgroundSave :: Prelude.Int -> IOptions a -> Prelude.IO ()
setBackgroundSave prop =
  Automation.propertySetID 0x2e [Automation.inInt prop]
getInsertedTextMark :: (Automation.Variant a0) => IOptions a -> Prelude.IO (a0)
getInsertedTextMark =
  Automation.propertyGetID 0x39 [] Automation.outVariant
setInsertedTextMark :: (Automation.Variant a0) => a0 -> IOptions a -> Prelude.IO ()
setInsertedTextMark prop =
  Automation.propertySetID 0x39 [Automation.inVariant prop]
getDeletedTextMark :: (Automation.Variant a0) => IOptions a -> Prelude.IO (a0)
getDeletedTextMark =
  Automation.propertyGetID 0x3a [] Automation.outVariant
setDeletedTextMark :: (Automation.Variant a0) => a0 -> IOptions a -> Prelude.IO ()
setDeletedTextMark prop =
  Automation.propertySetID 0x3a [Automation.inVariant prop]
getRevisedLinesMark :: (Automation.Variant a0) => IOptions a -> Prelude.IO (a0)
getRevisedLinesMark =
  Automation.propertyGetID 0x3b [] Automation.outVariant
setRevisedLinesMark :: (Automation.Variant a0) => a0 -> IOptions a -> Prelude.IO ()
setRevisedLinesMark prop =
  Automation.propertySetID 0x3b [Automation.inVariant prop]
getInsertedTextColor :: (Automation.Variant a0) => IOptions a -> Prelude.IO (a0)
getInsertedTextColor =
  Automation.propertyGetID 0x3c [] Automation.outVariant
setInsertedTextColor :: (Automation.Variant a0) => a0 -> IOptions a -> Prelude.IO ()
setInsertedTextColor prop =
  Automation.propertySetID 0x3c [Automation.inVariant prop]
getDeletedTextColor :: (Automation.Variant a0) => IOptions a -> Prelude.IO (a0)
getDeletedTextColor =
  Automation.propertyGetID 0x3d [] Automation.outVariant
setDeletedTextColor :: (Automation.Variant a0) => a0 -> IOptions a -> Prelude.IO ()
setDeletedTextColor prop =
  Automation.propertySetID 0x3d [Automation.inVariant prop]
getRevisedLinesColor :: (Automation.Variant a0) => IOptions a -> Prelude.IO (a0)
getRevisedLinesColor =
  Automation.propertyGetID 0x3e [] Automation.outVariant
setRevisedLinesColor :: (Automation.Variant a0) => a0 -> IOptions a -> Prelude.IO ()
setRevisedLinesColor prop =
  Automation.propertySetID 0x3e [Automation.inVariant prop]
getDefaultFilePath :: (Automation.Variant a0) => a0 -> IOptions a -> Prelude.IO (Prelude.String)
getDefaultFilePath path =
  Automation.propertyGetID 0x41 [Automation.inVariant path] Automation.outString
setDefaultFilePath :: (Automation.Variant a0) => a0 -> Prelude.String -> IOptions a -> Prelude.IO ()
setDefaultFilePath path prop =
  Automation.propertySetID 0x41 [Automation.inVariant path, Automation.inString prop]
getOvertype :: IOptions a -> Prelude.IO (Prelude.Int)
getOvertype = Automation.propertyGetID 0x42 [] Automation.outInt
setOvertype :: Prelude.Int -> IOptions a -> Prelude.IO ()
setOvertype prop =
  Automation.propertySetID 0x42 [Automation.inInt prop]
getReplaceSelection :: IOptions a -> Prelude.IO (Prelude.Int)
getReplaceSelection =
  Automation.propertyGetID 0x43 [] Automation.outInt
setReplaceSelection :: Prelude.Int -> IOptions a -> Prelude.IO ()
setReplaceSelection prop =
  Automation.propertySetID 0x43 [Automation.inInt prop]
getAllowDragAndDrop :: IOptions a -> Prelude.IO (Prelude.Int)
getAllowDragAndDrop =
  Automation.propertyGetID 0x44 [] Automation.outInt
setAllowDragAndDrop :: Prelude.Int -> IOptions a -> Prelude.IO ()
setAllowDragAndDrop prop =
  Automation.propertySetID 0x44 [Automation.inInt prop]
getAutoWordSelection :: IOptions a -> Prelude.IO (Prelude.Int)
getAutoWordSelection =
  Automation.propertyGetID 0x45 [] Automation.outInt
setAutoWordSelection :: Prelude.Int -> IOptions a -> Prelude.IO ()
setAutoWordSelection prop =
  Automation.propertySetID 0x45 [Automation.inInt prop]
getINSKeyForPaste :: IOptions a -> Prelude.IO (Prelude.Int)
getINSKeyForPaste =
  Automation.propertyGetID 0x46 [] Automation.outInt
setINSKeyForPaste :: Prelude.Int -> IOptions a -> Prelude.IO ()
setINSKeyForPaste prop =
  Automation.propertySetID 0x46 [Automation.inInt prop]
getSmartCutPaste :: IOptions a -> Prelude.IO (Prelude.Int)
getSmartCutPaste =
  Automation.propertyGetID 0x47 [] Automation.outInt
setSmartCutPaste :: Prelude.Int -> IOptions a -> Prelude.IO ()
setSmartCutPaste prop =
  Automation.propertySetID 0x47 [Automation.inInt prop]
getTabIndentKey :: IOptions a -> Prelude.IO (Prelude.Int)
getTabIndentKey =
  Automation.propertyGetID 0x48 [] Automation.outInt
setTabIndentKey :: Prelude.Int -> IOptions a -> Prelude.IO ()
setTabIndentKey prop =
  Automation.propertySetID 0x48 [Automation.inInt prop]
getPictureEditor :: IOptions a -> Prelude.IO (Prelude.String)
getPictureEditor =
  Automation.propertyGetID 0x49 [] Automation.outString
setPictureEditor :: Prelude.String -> IOptions a -> Prelude.IO ()
setPictureEditor prop =
  Automation.propertySetID 0x49 [Automation.inString prop]
getAnimateScreenMovements :: IOptions a -> Prelude.IO (Prelude.Int)
getAnimateScreenMovements =
  Automation.propertyGetID 0x4a [] Automation.outInt
setAnimateScreenMovements :: Prelude.Int -> IOptions a -> Prelude.IO ()
setAnimateScreenMovements prop =
  Automation.propertySetID 0x4a [Automation.inInt prop]
getVirusProtection :: IOptions a -> Prelude.IO (Prelude.Int)
getVirusProtection =
  Automation.propertyGetID 0x4b [] Automation.outInt
setVirusProtection :: Prelude.Int -> IOptions a -> Prelude.IO ()
setVirusProtection prop =
  Automation.propertySetID 0x4b [Automation.inInt prop]
getRevisedPropertiesMark :: (Automation.Variant a0) => IOptions a -> Prelude.IO (a0)
getRevisedPropertiesMark =
  Automation.propertyGetID 0x4c [] Automation.outVariant
setRevisedPropertiesMark :: (Automation.Variant a0) => a0 -> IOptions a -> Prelude.IO ()
setRevisedPropertiesMark prop =
  Automation.propertySetID 0x4c [Automation.inVariant prop]
getRevisedPropertiesColor :: (Automation.Variant a0) => IOptions a -> Prelude.IO (a0)
getRevisedPropertiesColor =
  Automation.propertyGetID 0x4d [] Automation.outVariant
setRevisedPropertiesColor :: (Automation.Variant a0) => a0 -> IOptions a -> Prelude.IO ()
setRevisedPropertiesColor prop =
  Automation.propertySetID 0x4d [Automation.inVariant prop]
getInlineConversion :: IOptions a -> Prelude.IO (Prelude.Int)
getInlineConversion =
  Automation.propertyGetID 0x56 [] Automation.outInt
setInlineConversion :: Prelude.Int -> IOptions a -> Prelude.IO ()
setInlineConversion prop =
  Automation.propertySetID 0x56 [Automation.inInt prop]
getIMEAutomaticControl :: IOptions a -> Prelude.IO (Prelude.Int)
getIMEAutomaticControl =
  Automation.propertyGetID 0x57 [] Automation.outInt
setIMEAutomaticControl :: Prelude.Int -> IOptions a -> Prelude.IO ()
setIMEAutomaticControl prop =
  Automation.propertySetID 0x57 [Automation.inInt prop]
getAutoFormatApplyHeadings :: IOptions a -> Prelude.IO (Prelude.Int)
getAutoFormatApplyHeadings =
  Automation.propertyGetID 0xfa [] Automation.outInt
setAutoFormatApplyHeadings :: Prelude.Int -> IOptions a -> Prelude.IO ()
setAutoFormatApplyHeadings prop =
  Automation.propertySetID 0xfa [Automation.inInt prop]
getAutoFormatApplyLists :: IOptions a -> Prelude.IO (Prelude.Int)
getAutoFormatApplyLists =
  Automation.propertyGetID 0xfb [] Automation.outInt
setAutoFormatApplyLists :: Prelude.Int -> IOptions a -> Prelude.IO ()
setAutoFormatApplyLists prop =
  Automation.propertySetID 0xfb [Automation.inInt prop]
getAutoFormatApplyBulletedLists :: IOptions a -> Prelude.IO (Prelude.Int)
getAutoFormatApplyBulletedLists =
  Automation.propertyGetID 0xfc [] Automation.outInt
setAutoFormatApplyBulletedLists :: Prelude.Int -> IOptions a -> Prelude.IO ()
setAutoFormatApplyBulletedLists prop =
  Automation.propertySetID 0xfc [Automation.inInt prop]
getAutoFormatApplyOtherParas :: IOptions a -> Prelude.IO (Prelude.Int)
getAutoFormatApplyOtherParas =
  Automation.propertyGetID 0xfd [] Automation.outInt
setAutoFormatApplyOtherParas :: Prelude.Int -> IOptions a -> Prelude.IO ()
setAutoFormatApplyOtherParas prop =
  Automation.propertySetID 0xfd [Automation.inInt prop]
getAutoFormatReplaceQuotes :: IOptions a -> Prelude.IO (Prelude.Int)
getAutoFormatReplaceQuotes =
  Automation.propertyGetID 0xfe [] Automation.outInt
setAutoFormatReplaceQuotes :: Prelude.Int -> IOptions a -> Prelude.IO ()
setAutoFormatReplaceQuotes prop =
  Automation.propertySetID 0xfe [Automation.inInt prop]
getAutoFormatReplaceSymbols :: IOptions a -> Prelude.IO (Prelude.Int)
getAutoFormatReplaceSymbols =
  Automation.propertyGetID 0xff [] Automation.outInt
setAutoFormatReplaceSymbols :: Prelude.Int -> IOptions a -> Prelude.IO ()
setAutoFormatReplaceSymbols prop =
  Automation.propertySetID 0xff [Automation.inInt prop]
getAutoFormatReplaceOrdinals :: IOptions a -> Prelude.IO (Prelude.Int)
getAutoFormatReplaceOrdinals =
  Automation.propertyGetID 0x100 [] Automation.outInt
setAutoFormatReplaceOrdinals :: Prelude.Int -> IOptions a -> Prelude.IO ()
setAutoFormatReplaceOrdinals prop =
  Automation.propertySetID 0x100 [Automation.inInt prop]
getAutoFormatReplaceFractions :: IOptions a -> Prelude.IO (Prelude.Int)
getAutoFormatReplaceFractions =
  Automation.propertyGetID 0x101 [] Automation.outInt
setAutoFormatReplaceFractions :: Prelude.Int -> IOptions a -> Prelude.IO ()
setAutoFormatReplaceFractions prop =
  Automation.propertySetID 0x101 [Automation.inInt prop]
getAutoFormatReplacePlainTextEmphasis :: IOptions a -> Prelude.IO (Prelude.Int)
getAutoFormatReplacePlainTextEmphasis =
  Automation.propertyGetID 0x102 [] Automation.outInt
setAutoFormatReplacePlainTextEmphasis :: Prelude.Int -> IOptions a -> Prelude.IO ()
setAutoFormatReplacePlainTextEmphasis prop =
  Automation.propertySetID 0x102 [Automation.inInt prop]
getAutoFormatPreserveStyles :: IOptions a -> Prelude.IO (Prelude.Int)
getAutoFormatPreserveStyles =
  Automation.propertyGetID 0x103 [] Automation.outInt
setAutoFormatPreserveStyles :: Prelude.Int -> IOptions a -> Prelude.IO ()
setAutoFormatPreserveStyles prop =
  Automation.propertySetID 0x103 [Automation.inInt prop]
getAutoFormatAsYouTypeApplyHeadings :: IOptions a -> Prelude.IO (Prelude.Int)
getAutoFormatAsYouTypeApplyHeadings =
  Automation.propertyGetID 0x104 [] Automation.outInt
setAutoFormatAsYouTypeApplyHeadings :: Prelude.Int -> IOptions a -> Prelude.IO ()
setAutoFormatAsYouTypeApplyHeadings prop =
  Automation.propertySetID 0x104 [Automation.inInt prop]
getAutoFormatAsYouTypeApplyBorders :: IOptions a -> Prelude.IO (Prelude.Int)
getAutoFormatAsYouTypeApplyBorders =
  Automation.propertyGetID 0x105 [] Automation.outInt
setAutoFormatAsYouTypeApplyBorders :: Prelude.Int -> IOptions a -> Prelude.IO ()
setAutoFormatAsYouTypeApplyBorders prop =
  Automation.propertySetID 0x105 [Automation.inInt prop]
getAutoFormatAsYouTypeApplyBulletedLists :: IOptions a -> Prelude.IO (Prelude.Int)
getAutoFormatAsYouTypeApplyBulletedLists =
  Automation.propertyGetID 0x106 [] Automation.outInt
setAutoFormatAsYouTypeApplyBulletedLists :: Prelude.Int -> IOptions a -> Prelude.IO ()
setAutoFormatAsYouTypeApplyBulletedLists prop =
  Automation.propertySetID 0x106 [Automation.inInt prop]
getAutoFormatAsYouTypeApplyNumberedLists :: IOptions a -> Prelude.IO (Prelude.Int)
getAutoFormatAsYouTypeApplyNumberedLists =
  Automation.propertyGetID 0x107 [] Automation.outInt
setAutoFormatAsYouTypeApplyNumberedLists :: Prelude.Int -> IOptions a -> Prelude.IO ()
setAutoFormatAsYouTypeApplyNumberedLists prop =
  Automation.propertySetID 0x107 [Automation.inInt prop]
getAutoFormatAsYouTypeReplaceQuotes :: IOptions a -> Prelude.IO (Prelude.Int)
getAutoFormatAsYouTypeReplaceQuotes =
  Automation.propertyGetID 0x108 [] Automation.outInt
setAutoFormatAsYouTypeReplaceQuotes :: Prelude.Int -> IOptions a -> Prelude.IO ()
setAutoFormatAsYouTypeReplaceQuotes prop =
  Automation.propertySetID 0x108 [Automation.inInt prop]
getAutoFormatAsYouTypeReplaceSymbols :: IOptions a -> Prelude.IO (Prelude.Int)
getAutoFormatAsYouTypeReplaceSymbols =
  Automation.propertyGetID 0x109 [] Automation.outInt
setAutoFormatAsYouTypeReplaceSymbols :: Prelude.Int -> IOptions a -> Prelude.IO ()
setAutoFormatAsYouTypeReplaceSymbols prop =
  Automation.propertySetID 0x109 [Automation.inInt prop]
getAutoFormatAsYouTypeReplaceOrdinals :: IOptions a -> Prelude.IO (Prelude.Int)
getAutoFormatAsYouTypeReplaceOrdinals =
  Automation.propertyGetID 0x10a [] Automation.outInt
setAutoFormatAsYouTypeReplaceOrdinals :: Prelude.Int -> IOptions a -> Prelude.IO ()
setAutoFormatAsYouTypeReplaceOrdinals prop =
  Automation.propertySetID 0x10a [Automation.inInt prop]
getAutoFormatAsYouTypeReplaceFractions :: IOptions a -> Prelude.IO (Prelude.Int)
getAutoFormatAsYouTypeReplaceFractions =
  Automation.propertyGetID 0x10b [] Automation.outInt
setAutoFormatAsYouTypeReplaceFractions :: Prelude.Int -> IOptions a -> Prelude.IO ()
setAutoFormatAsYouTypeReplaceFractions prop =
  Automation.propertySetID 0x10b [Automation.inInt prop]
getAutoFormatAsYouTypeReplacePlainTextEmphasis :: IOptions a -> Prelude.IO (Prelude.Int)
getAutoFormatAsYouTypeReplacePlainTextEmphasis =
  Automation.propertyGetID 0x10c [] Automation.outInt
setAutoFormatAsYouTypeReplacePlainTextEmphasis :: Prelude.Int -> IOptions a -> Prelude.IO ()
setAutoFormatAsYouTypeReplacePlainTextEmphasis prop =
  Automation.propertySetID 0x10c [Automation.inInt prop]
getAutoFormatAsYouTypeFormatListItemBeginning :: IOptions a -> Prelude.IO (Prelude.Int)
getAutoFormatAsYouTypeFormatListItemBeginning =
  Automation.propertyGetID 0x10d [] Automation.outInt
setAutoFormatAsYouTypeFormatListItemBeginning :: Prelude.Int -> IOptions a -> Prelude.IO ()
setAutoFormatAsYouTypeFormatListItemBeginning prop =
  Automation.propertySetID 0x10d [Automation.inInt prop]
getAutoFormatAsYouTypeDefineStyles :: IOptions a -> Prelude.IO (Prelude.Int)
getAutoFormatAsYouTypeDefineStyles =
  Automation.propertyGetID 0x10e [] Automation.outInt
setAutoFormatAsYouTypeDefineStyles :: Prelude.Int -> IOptions a -> Prelude.IO ()
setAutoFormatAsYouTypeDefineStyles prop =
  Automation.propertySetID 0x10e [Automation.inInt prop]
getAutoFormatPlainTextWordMail :: IOptions a -> Prelude.IO (Prelude.Int)
getAutoFormatPlainTextWordMail =
  Automation.propertyGetID 0x10f [] Automation.outInt
setAutoFormatPlainTextWordMail :: Prelude.Int -> IOptions a -> Prelude.IO ()
setAutoFormatPlainTextWordMail prop =
  Automation.propertySetID 0x10f [Automation.inInt prop]
getAutoFormatAsYouTypeReplaceHyperlinks :: IOptions a -> Prelude.IO (Prelude.Int)
getAutoFormatAsYouTypeReplaceHyperlinks =
  Automation.propertyGetID 0x110 [] Automation.outInt
setAutoFormatAsYouTypeReplaceHyperlinks :: Prelude.Int -> IOptions a -> Prelude.IO ()
setAutoFormatAsYouTypeReplaceHyperlinks prop =
  Automation.propertySetID 0x110 [Automation.inInt prop]
getAutoFormatReplaceHyperlinks :: IOptions a -> Prelude.IO (Prelude.Int)
getAutoFormatReplaceHyperlinks =
  Automation.propertyGetID 0x111 [] Automation.outInt
setAutoFormatReplaceHyperlinks :: Prelude.Int -> IOptions a -> Prelude.IO ()
setAutoFormatReplaceHyperlinks prop =
  Automation.propertySetID 0x111 [Automation.inInt prop]
getDefaultHighlightColorIndex :: (Automation.Variant a0) => IOptions a -> Prelude.IO (a0)
getDefaultHighlightColorIndex =
  Automation.propertyGetID 0x112 [] Automation.outVariant
setDefaultHighlightColorIndex :: (Automation.Variant a0) => a0 -> IOptions a -> Prelude.IO ()
setDefaultHighlightColorIndex prop =
  Automation.propertySetID 0x112 [Automation.inVariant prop]
getDefaultBorderLineStyle :: (Automation.Variant a0) => IOptions a -> Prelude.IO (a0)
getDefaultBorderLineStyle =
  Automation.propertyGetID 0x113 [] Automation.outVariant
setDefaultBorderLineStyle :: (Automation.Variant a0) => a0 -> IOptions a -> Prelude.IO ()
setDefaultBorderLineStyle prop =
  Automation.propertySetID 0x113 [Automation.inVariant prop]
getCheckSpellingAsYouType :: IOptions a -> Prelude.IO (Prelude.Int)
getCheckSpellingAsYouType =
  Automation.propertyGetID 0x114 [] Automation.outInt
setCheckSpellingAsYouType :: Prelude.Int -> IOptions a -> Prelude.IO ()
setCheckSpellingAsYouType prop =
  Automation.propertySetID 0x114 [Automation.inInt prop]
getCheckGrammarAsYouType :: IOptions a -> Prelude.IO (Prelude.Int)
getCheckGrammarAsYouType =
  Automation.propertyGetID 0x115 [] Automation.outInt
setCheckGrammarAsYouType :: Prelude.Int -> IOptions a -> Prelude.IO ()
setCheckGrammarAsYouType prop =
  Automation.propertySetID 0x115 [Automation.inInt prop]
getIgnoreInternetAndFileAddresses :: IOptions a -> Prelude.IO (Prelude.Int)
getIgnoreInternetAndFileAddresses =
  Automation.propertyGetID 0x116 [] Automation.outInt
setIgnoreInternetAndFileAddresses :: Prelude.Int -> IOptions a -> Prelude.IO ()
setIgnoreInternetAndFileAddresses prop =
  Automation.propertySetID 0x116 [Automation.inInt prop]
getShowReadabilityStatistics :: IOptions a -> Prelude.IO (Prelude.Int)
getShowReadabilityStatistics =
  Automation.propertyGetID 0x117 [] Automation.outInt
setShowReadabilityStatistics :: Prelude.Int -> IOptions a -> Prelude.IO ()
setShowReadabilityStatistics prop =
  Automation.propertySetID 0x117 [Automation.inInt prop]
getIgnoreUppercase :: IOptions a -> Prelude.IO (Prelude.Int)
getIgnoreUppercase =
  Automation.propertyGetID 0x118 [] Automation.outInt
setIgnoreUppercase :: Prelude.Int -> IOptions a -> Prelude.IO ()
setIgnoreUppercase prop =
  Automation.propertySetID 0x118 [Automation.inInt prop]
getIgnoreMixedDigits :: IOptions a -> Prelude.IO (Prelude.Int)
getIgnoreMixedDigits =
  Automation.propertyGetID 0x119 [] Automation.outInt
setIgnoreMixedDigits :: Prelude.Int -> IOptions a -> Prelude.IO ()
setIgnoreMixedDigits prop =
  Automation.propertySetID 0x119 [Automation.inInt prop]
getSuggestFromMainDictionaryOnly :: IOptions a -> Prelude.IO (Prelude.Int)
getSuggestFromMainDictionaryOnly =
  Automation.propertyGetID 0x11a [] Automation.outInt
setSuggestFromMainDictionaryOnly :: Prelude.Int -> IOptions a -> Prelude.IO ()
setSuggestFromMainDictionaryOnly prop =
  Automation.propertySetID 0x11a [Automation.inInt prop]
getSuggestSpellingCorrections :: IOptions a -> Prelude.IO (Prelude.Int)
getSuggestSpellingCorrections =
  Automation.propertyGetID 0x11b [] Automation.outInt
setSuggestSpellingCorrections :: Prelude.Int -> IOptions a -> Prelude.IO ()
setSuggestSpellingCorrections prop =
  Automation.propertySetID 0x11b [Automation.inInt prop]
getDefaultBorderLineWidth :: (Automation.Variant a0) => IOptions a -> Prelude.IO (a0)
getDefaultBorderLineWidth =
  Automation.propertyGetID 0x11c [] Automation.outVariant
setDefaultBorderLineWidth :: (Automation.Variant a0) => a0 -> IOptions a -> Prelude.IO ()
setDefaultBorderLineWidth prop =
  Automation.propertySetID 0x11c [Automation.inVariant prop]
getCheckGrammarWithSpelling :: IOptions a -> Prelude.IO (Prelude.Int)
getCheckGrammarWithSpelling =
  Automation.propertyGetID 0x11d [] Automation.outInt
setCheckGrammarWithSpelling :: Prelude.Int -> IOptions a -> Prelude.IO ()
setCheckGrammarWithSpelling prop =
  Automation.propertySetID 0x11d [Automation.inInt prop]
getDefaultOpenFormat :: (Automation.Variant a0) => IOptions a -> Prelude.IO (a0)
getDefaultOpenFormat =
  Automation.propertyGetID 0x11e [] Automation.outVariant
setDefaultOpenFormat :: (Automation.Variant a0) => a0 -> IOptions a -> Prelude.IO ()
setDefaultOpenFormat prop =
  Automation.propertySetID 0x11e [Automation.inVariant prop]
getPrintDraft :: IOptions a -> Prelude.IO (Prelude.Int)
getPrintDraft = Automation.propertyGetID 0x11f [] Automation.outInt
setPrintDraft :: Prelude.Int -> IOptions a -> Prelude.IO ()
setPrintDraft prop =
  Automation.propertySetID 0x11f [Automation.inInt prop]
getPrintReverse :: IOptions a -> Prelude.IO (Prelude.Int)
getPrintReverse =
  Automation.propertyGetID 0x120 [] Automation.outInt
setPrintReverse :: Prelude.Int -> IOptions a -> Prelude.IO ()
setPrintReverse prop =
  Automation.propertySetID 0x120 [Automation.inInt prop]
getMapPaperSize :: IOptions a -> Prelude.IO (Prelude.Int)
getMapPaperSize =
  Automation.propertyGetID 0x121 [] Automation.outInt
setMapPaperSize :: Prelude.Int -> IOptions a -> Prelude.IO ()
setMapPaperSize prop =
  Automation.propertySetID 0x121 [Automation.inInt prop]
getAutoFormatAsYouTypeApplyTables :: IOptions a -> Prelude.IO (Prelude.Int)
getAutoFormatAsYouTypeApplyTables =
  Automation.propertyGetID 0x122 [] Automation.outInt
setAutoFormatAsYouTypeApplyTables :: Prelude.Int -> IOptions a -> Prelude.IO ()
setAutoFormatAsYouTypeApplyTables prop =
  Automation.propertySetID 0x122 [Automation.inInt prop]
getAutoFormatApplyFirstIndents :: IOptions a -> Prelude.IO (Prelude.Int)
getAutoFormatApplyFirstIndents =
  Automation.propertyGetID 0x123 [] Automation.outInt
setAutoFormatApplyFirstIndents :: Prelude.Int -> IOptions a -> Prelude.IO ()
setAutoFormatApplyFirstIndents prop =
  Automation.propertySetID 0x123 [Automation.inInt prop]
getAutoFormatMatchParentheses :: IOptions a -> Prelude.IO (Prelude.Int)
getAutoFormatMatchParentheses =
  Automation.propertyGetID 0x126 [] Automation.outInt
setAutoFormatMatchParentheses :: Prelude.Int -> IOptions a -> Prelude.IO ()
setAutoFormatMatchParentheses prop =
  Automation.propertySetID 0x126 [Automation.inInt prop]
getAutoFormatReplaceFarEastDashes :: IOptions a -> Prelude.IO (Prelude.Int)
getAutoFormatReplaceFarEastDashes =
  Automation.propertyGetID 0x127 [] Automation.outInt
setAutoFormatReplaceFarEastDashes :: Prelude.Int -> IOptions a -> Prelude.IO ()
setAutoFormatReplaceFarEastDashes prop =
  Automation.propertySetID 0x127 [Automation.inInt prop]
getAutoFormatDeleteAutoSpaces :: IOptions a -> Prelude.IO (Prelude.Int)
getAutoFormatDeleteAutoSpaces =
  Automation.propertyGetID 0x128 [] Automation.outInt
setAutoFormatDeleteAutoSpaces :: Prelude.Int -> IOptions a -> Prelude.IO ()
setAutoFormatDeleteAutoSpaces prop =
  Automation.propertySetID 0x128 [Automation.inInt prop]
getAutoFormatAsYouTypeApplyFirstIndents :: IOptions a -> Prelude.IO (Prelude.Int)
getAutoFormatAsYouTypeApplyFirstIndents =
  Automation.propertyGetID 0x129 [] Automation.outInt
setAutoFormatAsYouTypeApplyFirstIndents :: Prelude.Int -> IOptions a -> Prelude.IO ()
setAutoFormatAsYouTypeApplyFirstIndents prop =
  Automation.propertySetID 0x129 [Automation.inInt prop]
getAutoFormatAsYouTypeApplyDates :: IOptions a -> Prelude.IO (Prelude.Int)
getAutoFormatAsYouTypeApplyDates =
  Automation.propertyGetID 0x12a [] Automation.outInt
setAutoFormatAsYouTypeApplyDates :: Prelude.Int -> IOptions a -> Prelude.IO ()
setAutoFormatAsYouTypeApplyDates prop =
  Automation.propertySetID 0x12a [Automation.inInt prop]
getAutoFormatAsYouTypeApplyClosings :: IOptions a -> Prelude.IO (Prelude.Int)
getAutoFormatAsYouTypeApplyClosings =
  Automation.propertyGetID 0x12b [] Automation.outInt
setAutoFormatAsYouTypeApplyClosings :: Prelude.Int -> IOptions a -> Prelude.IO ()
setAutoFormatAsYouTypeApplyClosings prop =
  Automation.propertySetID 0x12b [Automation.inInt prop]
getAutoFormatAsYouTypeMatchParentheses :: IOptions a -> Prelude.IO (Prelude.Int)
getAutoFormatAsYouTypeMatchParentheses =
  Automation.propertyGetID 0x12c [] Automation.outInt
setAutoFormatAsYouTypeMatchParentheses :: Prelude.Int -> IOptions a -> Prelude.IO ()
setAutoFormatAsYouTypeMatchParentheses prop =
  Automation.propertySetID 0x12c [Automation.inInt prop]
getAutoFormatAsYouTypeReplaceFarEastDashes :: IOptions a -> Prelude.IO (Prelude.Int)
getAutoFormatAsYouTypeReplaceFarEastDashes =
  Automation.propertyGetID 0x12d [] Automation.outInt
setAutoFormatAsYouTypeReplaceFarEastDashes :: Prelude.Int -> IOptions a -> Prelude.IO ()
setAutoFormatAsYouTypeReplaceFarEastDashes prop =
  Automation.propertySetID 0x12d [Automation.inInt prop]
getAutoFormatAsYouTypeDeleteAutoSpaces :: IOptions a -> Prelude.IO (Prelude.Int)
getAutoFormatAsYouTypeDeleteAutoSpaces =
  Automation.propertyGetID 0x12e [] Automation.outInt
setAutoFormatAsYouTypeDeleteAutoSpaces :: Prelude.Int -> IOptions a -> Prelude.IO ()
setAutoFormatAsYouTypeDeleteAutoSpaces prop =
  Automation.propertySetID 0x12e [Automation.inInt prop]
getAutoFormatAsYouTypeInsertClosings :: IOptions a -> Prelude.IO (Prelude.Int)
getAutoFormatAsYouTypeInsertClosings =
  Automation.propertyGetID 0x12f [] Automation.outInt
setAutoFormatAsYouTypeInsertClosings :: Prelude.Int -> IOptions a -> Prelude.IO ()
setAutoFormatAsYouTypeInsertClosings prop =
  Automation.propertySetID 0x12f [Automation.inInt prop]
getAutoFormatAsYouTypeAutoLetterWizard :: IOptions a -> Prelude.IO (Prelude.Int)
getAutoFormatAsYouTypeAutoLetterWizard =
  Automation.propertyGetID 0x130 [] Automation.outInt
setAutoFormatAsYouTypeAutoLetterWizard :: Prelude.Int -> IOptions a -> Prelude.IO ()
setAutoFormatAsYouTypeAutoLetterWizard prop =
  Automation.propertySetID 0x130 [Automation.inInt prop]
getAutoFormatAsYouTypeInsertOvers :: IOptions a -> Prelude.IO (Prelude.Int)
getAutoFormatAsYouTypeInsertOvers =
  Automation.propertyGetID 0x131 [] Automation.outInt
setAutoFormatAsYouTypeInsertOvers :: Prelude.Int -> IOptions a -> Prelude.IO ()
setAutoFormatAsYouTypeInsertOvers prop =
  Automation.propertySetID 0x131 [Automation.inInt prop]
getDisplayGridLines :: IOptions a -> Prelude.IO (Prelude.Int)
getDisplayGridLines =
  Automation.propertyGetID 0x132 [] Automation.outInt
setDisplayGridLines :: Prelude.Int -> IOptions a -> Prelude.IO ()
setDisplayGridLines prop =
  Automation.propertySetID 0x132 [Automation.inInt prop]
getMatchFuzzyCase :: IOptions a -> Prelude.IO (Prelude.Int)
getMatchFuzzyCase =
  Automation.propertyGetID 0x135 [] Automation.outInt
setMatchFuzzyCase :: Prelude.Int -> IOptions a -> Prelude.IO ()
setMatchFuzzyCase prop =
  Automation.propertySetID 0x135 [Automation.inInt prop]
getMatchFuzzyByte :: IOptions a -> Prelude.IO (Prelude.Int)
getMatchFuzzyByte =
  Automation.propertyGetID 0x136 [] Automation.outInt
setMatchFuzzyByte :: Prelude.Int -> IOptions a -> Prelude.IO ()
setMatchFuzzyByte prop =
  Automation.propertySetID 0x136 [Automation.inInt prop]
getMatchFuzzyHiragana :: IOptions a -> Prelude.IO (Prelude.Int)
getMatchFuzzyHiragana =
  Automation.propertyGetID 0x137 [] Automation.outInt
setMatchFuzzyHiragana :: Prelude.Int -> IOptions a -> Prelude.IO ()
setMatchFuzzyHiragana prop =
  Automation.propertySetID 0x137 [Automation.inInt prop]
getMatchFuzzySmallKana :: IOptions a -> Prelude.IO (Prelude.Int)
getMatchFuzzySmallKana =
  Automation.propertyGetID 0x138 [] Automation.outInt
setMatchFuzzySmallKana :: Prelude.Int -> IOptions a -> Prelude.IO ()
setMatchFuzzySmallKana prop =
  Automation.propertySetID 0x138 [Automation.inInt prop]
getMatchFuzzyDash :: IOptions a -> Prelude.IO (Prelude.Int)
getMatchFuzzyDash =
  Automation.propertyGetID 0x139 [] Automation.outInt
setMatchFuzzyDash :: Prelude.Int -> IOptions a -> Prelude.IO ()
setMatchFuzzyDash prop =
  Automation.propertySetID 0x139 [Automation.inInt prop]
getMatchFuzzyIterationMark :: IOptions a -> Prelude.IO (Prelude.Int)
getMatchFuzzyIterationMark =
  Automation.propertyGetID 0x13a [] Automation.outInt
setMatchFuzzyIterationMark :: Prelude.Int -> IOptions a -> Prelude.IO ()
setMatchFuzzyIterationMark prop =
  Automation.propertySetID 0x13a [Automation.inInt prop]
getMatchFuzzyKanji :: IOptions a -> Prelude.IO (Prelude.Int)
getMatchFuzzyKanji =
  Automation.propertyGetID 0x13b [] Automation.outInt
setMatchFuzzyKanji :: Prelude.Int -> IOptions a -> Prelude.IO ()
setMatchFuzzyKanji prop =
  Automation.propertySetID 0x13b [Automation.inInt prop]
getMatchFuzzyOldKana :: IOptions a -> Prelude.IO (Prelude.Int)
getMatchFuzzyOldKana =
  Automation.propertyGetID 0x13c [] Automation.outInt
setMatchFuzzyOldKana :: Prelude.Int -> IOptions a -> Prelude.IO ()
setMatchFuzzyOldKana prop =
  Automation.propertySetID 0x13c [Automation.inInt prop]
getMatchFuzzyProlongedSoundMark :: IOptions a -> Prelude.IO (Prelude.Int)
getMatchFuzzyProlongedSoundMark =
  Automation.propertyGetID 0x13d [] Automation.outInt
setMatchFuzzyProlongedSoundMark :: Prelude.Int -> IOptions a -> Prelude.IO ()
setMatchFuzzyProlongedSoundMark prop =
  Automation.propertySetID 0x13d [Automation.inInt prop]
getMatchFuzzyDZ :: IOptions a -> Prelude.IO (Prelude.Int)
getMatchFuzzyDZ =
  Automation.propertyGetID 0x13e [] Automation.outInt
setMatchFuzzyDZ :: Prelude.Int -> IOptions a -> Prelude.IO ()
setMatchFuzzyDZ prop =
  Automation.propertySetID 0x13e [Automation.inInt prop]
getMatchFuzzyBV :: IOptions a -> Prelude.IO (Prelude.Int)
getMatchFuzzyBV =
  Automation.propertyGetID 0x13f [] Automation.outInt
setMatchFuzzyBV :: Prelude.Int -> IOptions a -> Prelude.IO ()
setMatchFuzzyBV prop =
  Automation.propertySetID 0x13f [Automation.inInt prop]
getMatchFuzzyTC :: IOptions a -> Prelude.IO (Prelude.Int)
getMatchFuzzyTC =
  Automation.propertyGetID 0x140 [] Automation.outInt
setMatchFuzzyTC :: Prelude.Int -> IOptions a -> Prelude.IO ()
setMatchFuzzyTC prop =
  Automation.propertySetID 0x140 [Automation.inInt prop]
getMatchFuzzyHF :: IOptions a -> Prelude.IO (Prelude.Int)
getMatchFuzzyHF =
  Automation.propertyGetID 0x141 [] Automation.outInt
setMatchFuzzyHF :: Prelude.Int -> IOptions a -> Prelude.IO ()
setMatchFuzzyHF prop =
  Automation.propertySetID 0x141 [Automation.inInt prop]
getMatchFuzzyZJ :: IOptions a -> Prelude.IO (Prelude.Int)
getMatchFuzzyZJ =
  Automation.propertyGetID 0x142 [] Automation.outInt
setMatchFuzzyZJ :: Prelude.Int -> IOptions a -> Prelude.IO ()
setMatchFuzzyZJ prop =
  Automation.propertySetID 0x142 [Automation.inInt prop]
getMatchFuzzyAY :: IOptions a -> Prelude.IO (Prelude.Int)
getMatchFuzzyAY =
  Automation.propertyGetID 0x143 [] Automation.outInt
setMatchFuzzyAY :: Prelude.Int -> IOptions a -> Prelude.IO ()
setMatchFuzzyAY prop =
  Automation.propertySetID 0x143 [Automation.inInt prop]
getMatchFuzzyKiKu :: IOptions a -> Prelude.IO (Prelude.Int)
getMatchFuzzyKiKu =
  Automation.propertyGetID 0x144 [] Automation.outInt
setMatchFuzzyKiKu :: Prelude.Int -> IOptions a -> Prelude.IO ()
setMatchFuzzyKiKu prop =
  Automation.propertySetID 0x144 [Automation.inInt prop]
getMatchFuzzyPunctuation :: IOptions a -> Prelude.IO (Prelude.Int)
getMatchFuzzyPunctuation =
  Automation.propertyGetID 0x145 [] Automation.outInt
setMatchFuzzyPunctuation :: Prelude.Int -> IOptions a -> Prelude.IO ()
setMatchFuzzyPunctuation prop =
  Automation.propertySetID 0x145 [Automation.inInt prop]
getMatchFuzzySpace :: IOptions a -> Prelude.IO (Prelude.Int)
getMatchFuzzySpace =
  Automation.propertyGetID 0x146 [] Automation.outInt
setMatchFuzzySpace :: Prelude.Int -> IOptions a -> Prelude.IO ()
setMatchFuzzySpace prop =
  Automation.propertySetID 0x146 [Automation.inInt prop]
getApplyFarEastFontsToAscii :: IOptions a -> Prelude.IO (Prelude.Int)
getApplyFarEastFontsToAscii =
  Automation.propertyGetID 0x147 [] Automation.outInt
setApplyFarEastFontsToAscii :: Prelude.Int -> IOptions a -> Prelude.IO ()
setApplyFarEastFontsToAscii prop =
  Automation.propertySetID 0x147 [Automation.inInt prop]
getConvertHighAnsiToFarEast :: IOptions a -> Prelude.IO (Prelude.Int)
getConvertHighAnsiToFarEast =
  Automation.propertyGetID 0x148 [] Automation.outInt
setConvertHighAnsiToFarEast :: Prelude.Int -> IOptions a -> Prelude.IO ()
setConvertHighAnsiToFarEast prop =
  Automation.propertySetID 0x148 [Automation.inInt prop]
getPrintOddPagesInAscendingOrder :: IOptions a -> Prelude.IO (Prelude.Int)
getPrintOddPagesInAscendingOrder =
  Automation.propertyGetID 0x14a [] Automation.outInt
setPrintOddPagesInAscendingOrder :: Prelude.Int -> IOptions a -> Prelude.IO ()
setPrintOddPagesInAscendingOrder prop =
  Automation.propertySetID 0x14a [Automation.inInt prop]
getPrintEvenPagesInAscendingOrder :: IOptions a -> Prelude.IO (Prelude.Int)
getPrintEvenPagesInAscendingOrder =
  Automation.propertyGetID 0x14b [] Automation.outInt
setPrintEvenPagesInAscendingOrder :: Prelude.Int -> IOptions a -> Prelude.IO ()
setPrintEvenPagesInAscendingOrder prop =
  Automation.propertySetID 0x14b [Automation.inInt prop]
getDefaultBorderColorIndex :: (Automation.Variant a0) => IOptions a -> Prelude.IO (a0)
getDefaultBorderColorIndex =
  Automation.propertyGetID 0x151 [] Automation.outVariant
setDefaultBorderColorIndex :: (Automation.Variant a0) => a0 -> IOptions a -> Prelude.IO ()
setDefaultBorderColorIndex prop =
  Automation.propertySetID 0x151 [Automation.inVariant prop]
getEnableMisusedWordsDictionary :: IOptions a -> Prelude.IO (Prelude.Int)
getEnableMisusedWordsDictionary =
  Automation.propertyGetID 0x152 [] Automation.outInt
setEnableMisusedWordsDictionary :: Prelude.Int -> IOptions a -> Prelude.IO ()
setEnableMisusedWordsDictionary prop =
  Automation.propertySetID 0x152 [Automation.inInt prop]
getAllowCombinedAuxiliaryForms :: IOptions a -> Prelude.IO (Prelude.Int)
getAllowCombinedAuxiliaryForms =
  Automation.propertyGetID 0x153 [] Automation.outInt
setAllowCombinedAuxiliaryForms :: Prelude.Int -> IOptions a -> Prelude.IO ()
setAllowCombinedAuxiliaryForms prop =
  Automation.propertySetID 0x153 [Automation.inInt prop]
getHangulHanjaFastConversion :: IOptions a -> Prelude.IO (Prelude.Int)
getHangulHanjaFastConversion =
  Automation.propertyGetID 0x154 [] Automation.outInt
setHangulHanjaFastConversion :: Prelude.Int -> IOptions a -> Prelude.IO ()
setHangulHanjaFastConversion prop =
  Automation.propertySetID 0x154 [Automation.inInt prop]
getCheckHangulEndings :: IOptions a -> Prelude.IO (Prelude.Int)
getCheckHangulEndings =
  Automation.propertyGetID 0x155 [] Automation.outInt
setCheckHangulEndings :: Prelude.Int -> IOptions a -> Prelude.IO ()
setCheckHangulEndings prop =
  Automation.propertySetID 0x155 [Automation.inInt prop]
getEnableHangulHanjaRecentOrdering :: IOptions a -> Prelude.IO (Prelude.Int)
getEnableHangulHanjaRecentOrdering =
  Automation.propertyGetID 0x156 [] Automation.outInt
setEnableHangulHanjaRecentOrdering :: Prelude.Int -> IOptions a -> Prelude.IO ()
setEnableHangulHanjaRecentOrdering prop =
  Automation.propertySetID 0x156 [Automation.inInt prop]
getMultipleWordConversionsMode :: (Automation.Variant a0) => IOptions a -> Prelude.IO (a0)
getMultipleWordConversionsMode =
  Automation.propertyGetID 0x157 [] Automation.outVariant
setMultipleWordConversionsMode :: (Automation.Variant a0) => a0 -> IOptions a -> Prelude.IO ()
setMultipleWordConversionsMode prop =
  Automation.propertySetID 0x157 [Automation.inVariant prop]
setWPHelpOptions :: Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> Prelude.Int -> IOptions a -> Prelude.IO ()
setWPHelpOptions commandKeyHelp docNavigationKeys mouseSimulation demoGuidance demoSpeed helpType =
  Automation.methodID0 0x14d [Automation.inInt commandKeyHelp, Automation.inInt docNavigationKeys, Automation.inInt mouseSimulation, Automation.inInt demoGuidance, Automation.inInt demoSpeed, Automation.inInt helpType]
-- --------------------------------------------------
-- 
-- interface MailMessage
-- 
-- --------------------------------------------------
data MailMessage a = MailMessage
                      
type IMailMessage a = Automation.IDispatch (MailMessage a)
iidIMailMessage :: Com.IID (IMailMessage Automation.Interface)
iidIMailMessage =
  Com.mkIID "{000209BA-0000-0000-C000-000000000046}"
checkName :: IMailMessage a -> Prelude.IO ()
checkName = Automation.methodID0 0x14e []
displayMoveDialog :: IMailMessage a -> Prelude.IO ()
displayMoveDialog = Automation.methodID0 0x150 []
displayProperties :: IMailMessage a -> Prelude.IO ()
displayProperties = Automation.methodID0 0x151 []
displaySelectNamesDialog :: IMailMessage a -> Prelude.IO ()
displaySelectNamesDialog = Automation.methodID0 0x152 []
forward :: Automation.IDispatch a -> Prelude.IO ()
forward = Automation.methodID0 0x153 []
goToNext1 :: Automation.IDispatch a -> Prelude.IO ()
goToNext1 = Automation.methodID0 0x154 []
goToPrevious1 :: Automation.IDispatch a -> Prelude.IO ()
goToPrevious1 = Automation.methodID0 0x155 []
toggleHeader :: IMailMessage a -> Prelude.IO ()
toggleHeader = Automation.methodID0 0x158 []
-- --------------------------------------------------
-- 
-- interface ProofreadingErrors
-- 
-- --------------------------------------------------
data ProofreadingErrors a = ProofreadingErrors
                             
type IProofreadingErrors a = Automation.IDispatch (ProofreadingErrors a)
iidIProofreadingErrors :: Com.IID (IProofreadingErrors Automation.Interface)
iidIProofreadingErrors =
  Com.mkIID "{000209BB-0000-0000-C000-000000000046}"
getType19 :: (Automation.Variant a0) => IProofreadingErrors a -> Prelude.IO (a0)
getType19 = Automation.propertyGetID 0x2 [] Automation.outVariant
-- --------------------------------------------------
-- 
-- interface Mailer
-- 
-- --------------------------------------------------
data Mailer a = Mailer
                 
type IMailer a = Automation.IDispatch (Mailer a)
iidIMailer :: Com.IID (IMailer Automation.Interface)
iidIMailer = Com.mkIID "{000209BD-0000-0000-C000-000000000046}"
getBCCRecipients :: IMailer a -> Prelude.IO (Prelude.Int)
getBCCRecipients =
  Automation.propertyGetID 0x64 [] Automation.outInt
setBCCRecipients :: Prelude.Int -> IMailer a -> Prelude.IO ()
setBCCRecipients prop =
  Automation.propertySetID 0x64 [Automation.inInt prop]
getCCRecipients :: IMailer a -> Prelude.IO (Prelude.Int)
getCCRecipients =
  Automation.propertyGetID 0x65 [] Automation.outInt
setCCRecipients :: Prelude.Int -> IMailer a -> Prelude.IO ()
setCCRecipients prop =
  Automation.propertySetID 0x65 [Automation.inInt prop]
getRecipients0 :: IMailer a -> Prelude.IO (Prelude.Int)
getRecipients0 = Automation.propertyGetID 0x66 [] Automation.outInt
setRecipients :: Prelude.Int -> Automation.IDispatch a -> Prelude.IO ()
setRecipients prop =
  Automation.propertySetID 0x66 [Automation.inInt prop]
getEnclosures :: IMailer a -> Prelude.IO (Prelude.Int)
getEnclosures = Automation.propertyGetID 0x67 [] Automation.outInt
setEnclosures :: Prelude.Int -> IMailer a -> Prelude.IO ()
setEnclosures prop =
  Automation.propertySetID 0x67 [Automation.inInt prop]
getSender :: IMailer a -> Prelude.IO (Prelude.String)
getSender = Automation.propertyGetID 0x68 [] Automation.outString
getSendDateTime :: IMailer a -> Prelude.IO (Prelude.Double)
getSendDateTime =
  Automation.propertyGetID 0x69 [] Automation.outDouble
getReceived :: IMailer a -> Prelude.IO (Prelude.Int)
getReceived = Automation.propertyGetID 0x6a [] Automation.outInt
-- --------------------------------------------------
-- 
-- interface WrapFormat
-- 
-- --------------------------------------------------
data WrapFormat a = WrapFormat
                     
type IWrapFormat a = Automation.IDispatch (WrapFormat a)
iidIWrapFormat :: Com.IID (IWrapFormat Automation.Interface)
iidIWrapFormat = Com.mkIID "{000209C3-0000-0000-C000-000000000046}"
getType20 :: (Automation.Variant a0) => IWrapFormat a -> Prelude.IO (a0)
getType20 = Automation.propertyGetID 0x64 [] Automation.outVariant
setType1 :: (Automation.Variant a0) => a0 -> IWrapFormat a -> Prelude.IO ()
setType1 prop =
  Automation.propertySetID 0x64 [Automation.inVariant prop]
getSide :: (Automation.Variant a0) => IWrapFormat a -> Prelude.IO (a0)
getSide = Automation.propertyGetID 0x65 [] Automation.outVariant
setSide :: (Automation.Variant a0) => a0 -> IWrapFormat a -> Prelude.IO ()
setSide prop =
  Automation.propertySetID 0x65 [Automation.inVariant prop]
getDistanceTop :: IWrapFormat a -> Prelude.IO (Prelude.Float)
getDistanceTop =
  Automation.propertyGetID 0x66 [] Automation.outFloat
setDistanceTop :: Prelude.Float -> IWrapFormat a -> Prelude.IO ()
setDistanceTop prop =
  Automation.propertySetID 0x66 [Automation.inFloat prop]
getDistanceBottom :: IWrapFormat a -> Prelude.IO (Prelude.Float)
getDistanceBottom =
  Automation.propertyGetID 0x67 [] Automation.outFloat
setDistanceBottom :: Prelude.Float -> IWrapFormat a -> Prelude.IO ()
setDistanceBottom prop =
  Automation.propertySetID 0x67 [Automation.inFloat prop]
getDistanceLeft :: IWrapFormat a -> Prelude.IO (Prelude.Float)
getDistanceLeft =
  Automation.propertyGetID 0x68 [] Automation.outFloat
setDistanceLeft :: Prelude.Float -> IWrapFormat a -> Prelude.IO ()
setDistanceLeft prop =
  Automation.propertySetID 0x68 [Automation.inFloat prop]
getDistanceRight :: IWrapFormat a -> Prelude.IO (Prelude.Float)
getDistanceRight =
  Automation.propertyGetID 0x69 [] Automation.outFloat
setDistanceRight :: Prelude.Float -> IWrapFormat a -> Prelude.IO ()
setDistanceRight prop =
  Automation.propertySetID 0x69 [Automation.inFloat prop]
-- --------------------------------------------------
-- 
-- interface HangulAndAlphabetExceptions
-- 
-- --------------------------------------------------
data HangulAndAlphabetExceptions a = HangulAndAlphabetExceptions
                                      
type IHangulAndAlphabetExceptions a = Automation.IDispatch (HangulAndAlphabetExceptions a)
iidIHangulAndAlphabetExceptions :: Com.IID (IHangulAndAlphabetExceptions Automation.Interface)
iidIHangulAndAlphabetExceptions =
  Com.mkIID "{000209D1-0000-0000-C000-000000000046}"
item72 :: Prelude.Int -> IHangulAndAlphabetExceptions a -> Prelude.IO (IHangulAndAlphabetException Automation.Interface)
item72 idex =
  Automation.functionID1 0o0 [Automation.inInt idex] Automation.outIDispatch
add40 :: Prelude.String -> IHangulAndAlphabetExceptions a -> Prelude.IO (IHangulAndAlphabetException Automation.Interface)
add40 name =
  Automation.functionID1 0x65 [Automation.inString name] Automation.outIDispatch
-- --------------------------------------------------
-- 
-- interface HangulAndAlphabetException
-- 
-- --------------------------------------------------
data HangulAndAlphabetException a = HangulAndAlphabetException
                                     
type IHangulAndAlphabetException a = Automation.IDispatch (HangulAndAlphabetException a)
iidIHangulAndAlphabetException :: Com.IID (IHangulAndAlphabetException Automation.Interface)
iidIHangulAndAlphabetException =
  Com.mkIID "{000209D2-0000-0000-C000-000000000046}"
-- --------------------------------------------------
-- 
-- interface Adjustments
-- 
-- --------------------------------------------------
data Adjustments a = Adjustments
                      
type IAdjustments a = Automation.IDispatch (Adjustments a)
iidIAdjustments :: Com.IID (IAdjustments Automation.Interface)
iidIAdjustments =
  Com.mkIID "{000209C4-0000-0000-C000-000000000046}"
getItem :: Prelude.Int -> IAdjustments a -> Prelude.IO (Prelude.Float)
getItem idex =
  Automation.propertyGetID 0o0 [Automation.inInt idex] Automation.outFloat
setItem :: Prelude.Int -> Prelude.Float -> IAdjustments a -> Prelude.IO ()
setItem idex prop =
  Automation.propertySetID 0o0 [Automation.inInt idex, Automation.inFloat prop]
-- --------------------------------------------------
-- 
-- interface CalloutFormat
-- 
-- --------------------------------------------------
data CalloutFormat a = CalloutFormat
                        
type ICalloutFormat a = Automation.IDispatch (CalloutFormat a)
iidICalloutFormat :: Com.IID (ICalloutFormat Automation.Interface)
iidICalloutFormat =
  Com.mkIID "{000209C5-0000-0000-C000-000000000046}"
getAccent :: (Automation.Variant a0) => ICalloutFormat a -> Prelude.IO (a0)
getAccent = Automation.propertyGetID 0x64 [] Automation.outVariant
setAccent :: (Automation.Variant a0) => a0 -> ICalloutFormat a -> Prelude.IO ()
setAccent prop =
  Automation.propertySetID 0x64 [Automation.inVariant prop]
getAngle :: (Automation.Variant a0) => ICalloutFormat a -> Prelude.IO (a0)
getAngle = Automation.propertyGetID 0x65 [] Automation.outVariant
setAngle :: (Automation.Variant a0) => a0 -> ICalloutFormat a -> Prelude.IO ()
setAngle prop =
  Automation.propertySetID 0x65 [Automation.inVariant prop]
getAutoAttach :: (Automation.Variant a0) => ICalloutFormat a -> Prelude.IO (a0)
getAutoAttach =
  Automation.propertyGetID 0x66 [] Automation.outVariant
setAutoAttach :: (Automation.Variant a0) => a0 -> ICalloutFormat a -> Prelude.IO ()
setAutoAttach prop =
  Automation.propertySetID 0x66 [Automation.inVariant prop]
getAutoLength :: (Automation.Variant a0) => ICalloutFormat a -> Prelude.IO (a0)
getAutoLength =
  Automation.propertyGetID 0x67 [] Automation.outVariant
getBorder :: (Automation.Variant a0) => ICalloutFormat a -> Prelude.IO (a0)
getBorder = Automation.propertyGetID 0x68 [] Automation.outVariant
setBorder :: (Automation.Variant a0) => a0 -> ICalloutFormat a -> Prelude.IO ()
setBorder prop =
  Automation.propertySetID 0x68 [Automation.inVariant prop]
getDrop :: ICalloutFormat a -> Prelude.IO (Prelude.Float)
getDrop = Automation.propertyGetID 0x69 [] Automation.outFloat
getDropType :: (Automation.Variant a0) => ICalloutFormat a -> Prelude.IO (a0)
getDropType =
  Automation.propertyGetID 0x6a [] Automation.outVariant
getGap :: ICalloutFormat a -> Prelude.IO (Prelude.Float)
getGap = Automation.propertyGetID 0x6b [] Automation.outFloat
setGap :: Prelude.Float -> ICalloutFormat a -> Prelude.IO ()
setGap prop =
  Automation.propertySetID 0x6b [Automation.inFloat prop]
getLength :: ICalloutFormat a -> Prelude.IO (Prelude.Float)
getLength = Automation.propertyGetID 0x6c [] Automation.outFloat
getType21 :: (Automation.Variant a0) => ICalloutFormat a -> Prelude.IO (a0)
getType21 = Automation.propertyGetID 0x6d [] Automation.outVariant
setType2 :: (Automation.Variant a0) => a0 -> ICalloutFormat a -> Prelude.IO ()
setType2 prop =
  Automation.propertySetID 0x6d [Automation.inVariant prop]
automaticLength :: ICalloutFormat a -> Prelude.IO ()
automaticLength = Automation.methodID0 0xa []
customDrop :: Prelude.Float -> ICalloutFormat a -> Prelude.IO ()
customDrop drop =
  Automation.methodID0 0xb [Automation.inFloat drop]
customLength :: Prelude.Float -> ICalloutFormat a -> Prelude.IO ()
customLength length =
  Automation.methodID0 0xc [Automation.inFloat length]
presetDrop :: (Automation.Variant a0) => a0 -> ICalloutFormat a -> Prelude.IO ()
presetDrop dropType =
  Automation.methodID0 0xd [Automation.inVariant dropType]
-- --------------------------------------------------
-- 
-- interface ColorFormat
-- 
-- --------------------------------------------------
data ColorFormat a = ColorFormat
                      
type IColorFormat a = Automation.IDispatch (ColorFormat a)
iidIColorFormat :: Com.IID (IColorFormat Automation.Interface)
iidIColorFormat =
  Com.mkIID "{000209C6-0000-0000-C000-000000000046}"
getRGB :: IColorFormat a -> Prelude.IO (Prelude.Int)
getRGB = Automation.propertyGetID 0o0 [] Automation.outInt
setRGB :: Prelude.Int -> IColorFormat a -> Prelude.IO ()
setRGB prop = Automation.propertySetID 0o0 [Automation.inInt prop]
getSchemeColor :: IColorFormat a -> Prelude.IO (Prelude.Int)
getSchemeColor = Automation.propertyGetID 0x64 [] Automation.outInt
setSchemeColor :: Prelude.Int -> IColorFormat a -> Prelude.IO ()
setSchemeColor prop =
  Automation.propertySetID 0x64 [Automation.inInt prop]
getType22 :: (Automation.Variant a0) => IColorFormat a -> Prelude.IO (a0)
getType22 = Automation.propertyGetID 0x65 [] Automation.outVariant
-- --------------------------------------------------
-- 
-- interface ConnectorFormat
-- 
-- --------------------------------------------------
data ConnectorFormat a = ConnectorFormat
                          
type IConnectorFormat a = Automation.IDispatch (ConnectorFormat a)
iidIConnectorFormat :: Com.IID (IConnectorFormat Automation.Interface)
iidIConnectorFormat =
  Com.mkIID "{000209C7-0000-0000-C000-000000000046}"
getBeginConnected :: (Automation.Variant a0) => IConnectorFormat a -> Prelude.IO (a0)
getBeginConnected =
  Automation.propertyGetID 0x64 [] Automation.outVariant
getBeginConnectedShape :: IConnectorFormat a -> Prelude.IO (IShape Automation.Interface)
getBeginConnectedShape =
  Automation.propertyGetID 0x65 [] Automation.outIDispatch
getBeginConnectionSite :: IConnectorFormat a -> Prelude.IO (Prelude.Int)
getBeginConnectionSite =
  Automation.propertyGetID 0x66 [] Automation.outInt
getEndConnected :: (Automation.Variant a0) => IConnectorFormat a -> Prelude.IO (a0)
getEndConnected =
  Automation.propertyGetID 0x67 [] Automation.outVariant
getEndConnectedShape :: IConnectorFormat a -> Prelude.IO (IShape Automation.Interface)
getEndConnectedShape =
  Automation.propertyGetID 0x68 [] Automation.outIDispatch
getEndConnectionSite :: IConnectorFormat a -> Prelude.IO (Prelude.Int)
getEndConnectionSite =
  Automation.propertyGetID 0x69 [] Automation.outInt
getType23 :: (Automation.Variant a0) => IConnectorFormat a -> Prelude.IO (a0)
getType23 = Automation.propertyGetID 0x6a [] Automation.outVariant
setType3 :: (Automation.Variant a0) => a0 -> IConnectorFormat a -> Prelude.IO ()
setType3 prop =
  Automation.propertySetID 0x6a [Automation.inVariant prop]
beginConnect :: IShape a0 -> Prelude.Int -> IConnectorFormat a -> Prelude.IO ()
beginConnect connectedShape connectionSite =
  Automation.methodID0 0xa [Automation.inIDispatch connectedShape, Automation.inInt connectionSite]
beginDisconnect :: IConnectorFormat a -> Prelude.IO ()
beginDisconnect = Automation.methodID0 0xb []
endConnect :: IShape a0 -> Prelude.Int -> IConnectorFormat a -> Prelude.IO ()
endConnect connectedShape connectionSite =
  Automation.methodID0 0xc [Automation.inIDispatch connectedShape, Automation.inInt connectionSite]
endDisconnect :: IConnectorFormat a -> Prelude.IO ()
endDisconnect = Automation.methodID0 0xd []
-- --------------------------------------------------
-- 
-- interface FillFormat
-- 
-- --------------------------------------------------
data FillFormat a = FillFormat
                     
type IFillFormat a = Automation.IDispatch (FillFormat a)
iidIFillFormat :: Com.IID (IFillFormat Automation.Interface)
iidIFillFormat = Com.mkIID "{000209C8-0000-0000-C000-000000000046}"
getBackColor :: Automation.IDispatch a -> Prelude.IO (IColorFormat Automation.Interface)
getBackColor =
  Automation.propertyGetID 0x64 [] Automation.outIDispatch
getForeColor :: Automation.IDispatch a -> Prelude.IO (IColorFormat Automation.Interface)
getForeColor =
  Automation.propertyGetID 0x65 [] Automation.outIDispatch
getGradientColorType :: (Automation.Variant a0) => IFillFormat a -> Prelude.IO (a0)
getGradientColorType =
  Automation.propertyGetID 0x66 [] Automation.outVariant
getGradientDegree :: IFillFormat a -> Prelude.IO (Prelude.Float)
getGradientDegree =
  Automation.propertyGetID 0x67 [] Automation.outFloat
getGradientStyle :: (Automation.Variant a0) => IFillFormat a -> Prelude.IO (a0)
getGradientStyle =
  Automation.propertyGetID 0x68 [] Automation.outVariant
getGradientVariant :: IFillFormat a -> Prelude.IO (Prelude.Int)
getGradientVariant =
  Automation.propertyGetID 0x69 [] Automation.outInt
getPattern :: (Automation.Variant a0) => Automation.IDispatch a -> Prelude.IO (a0)
getPattern = Automation.propertyGetID 0x6a [] Automation.outVariant
getPresetGradientType :: (Automation.Variant a0) => IFillFormat a -> Prelude.IO (a0)
getPresetGradientType =
  Automation.propertyGetID 0x6b [] Automation.outVariant
getPresetTexture :: (Automation.Variant a0) => IFillFormat a -> Prelude.IO (a0)
getPresetTexture =
  Automation.propertyGetID 0x6c [] Automation.outVariant
getTextureName :: IFillFormat a -> Prelude.IO (Prelude.String)
getTextureName =
  Automation.propertyGetID 0x6d [] Automation.outString
getTextureType :: (Automation.Variant a0) => IFillFormat a -> Prelude.IO (a0)
getTextureType =
  Automation.propertyGetID 0x6e [] Automation.outVariant
getTransparency :: Automation.IDispatch a -> Prelude.IO (Prelude.Float)
getTransparency =
  Automation.propertyGetID 0x6f [] Automation.outFloat
setTransparency :: Prelude.Float -> Automation.IDispatch a -> Prelude.IO ()
setTransparency prop =
  Automation.propertySetID 0x6f [Automation.inFloat prop]
getType24 :: (Automation.Variant a0) => IFillFormat a -> Prelude.IO (a0)
getType24 = Automation.propertyGetID 0x70 [] Automation.outVariant
background :: Automation.IDispatch a -> Prelude.IO ()
background = Automation.methodID0 0xa []
oneColorGradient :: (Automation.Variant a0) => a0 -> Prelude.Int -> Prelude.Float -> IFillFormat a -> Prelude.IO ()
oneColorGradient style variant degree =
  Automation.methodID0 0xb [Automation.inVariant style, Automation.inInt variant, Automation.inFloat degree]
patterned :: (Automation.Variant a0) => a0 -> IFillFormat a -> Prelude.IO ()
patterned pattern =
  Automation.methodID0 0xc [Automation.inVariant pattern]
presetGradient :: (Automation.Variant a0, Automation.Variant a1) => a0 -> Prelude.Int -> a1 -> IFillFormat a -> Prelude.IO ()
presetGradient style variant presetGradientType =
  Automation.methodID0 0xd [Automation.inVariant style, Automation.inInt variant, Automation.inVariant presetGradientType]
presetTextured :: (Automation.Variant a0) => a0 -> IFillFormat a -> Prelude.IO ()
presetTextured presetTexture =
  Automation.methodID0 0xe [Automation.inVariant presetTexture]
solid :: IFillFormat a -> Prelude.IO ()
solid = Automation.methodID0 0xf []
twoColorGradient :: (Automation.Variant a0) => a0 -> Prelude.Int -> IFillFormat a -> Prelude.IO ()
twoColorGradient style variant =
  Automation.methodID0 0x10 [Automation.inVariant style, Automation.inInt variant]
userPicture :: Prelude.String -> IFillFormat a -> Prelude.IO ()
userPicture pictureFile =
  Automation.methodID0 0x11 [Automation.inString pictureFile]
userTextured :: Prelude.String -> IFillFormat a -> Prelude.IO ()
userTextured textureFile =
  Automation.methodID0 0x12 [Automation.inString textureFile]
-- --------------------------------------------------
-- 
-- interface FreeformBuilder
-- 
-- --------------------------------------------------
data FreeformBuilder a = FreeformBuilder
                          
type IFreeformBuilder a = Automation.IDispatch (FreeformBuilder a)
iidIFreeformBuilder :: Com.IID (IFreeformBuilder Automation.Interface)
iidIFreeformBuilder =
  Com.mkIID "{000209C9-0000-0000-C000-000000000046}"
addNodes :: (Automation.Variant a0, Automation.Variant a1) => a0 -> a1 -> Prelude.Float -> Prelude.Float -> Prelude.Float -> Prelude.Float -> Prelude.Float -> Prelude.Float -> IFreeformBuilder a -> Prelude.IO ()
addNodes segmentType editingType x1 y1 x2 y2 x3 y3 =
  Automation.methodID0 0xa [Automation.inVariant segmentType, Automation.inVariant editingType, Automation.inFloat x1, Automation.inFloat y1, Automation.inFloat x2, Automation.inFloat y2, Automation.inFloat x3, Automation.inFloat y3]
convertToShape0 :: Prelude.Int -> IFreeformBuilder a -> Prelude.IO (IShape Automation.Interface)
convertToShape0 anchor =
  Automation.functionID1 0xb [Automation.inInt anchor] Automation.outIDispatch
-- --------------------------------------------------
-- 
-- interface LineFormat
-- 
-- --------------------------------------------------
data LineFormat a = LineFormat
                     
type ILineFormat a = Automation.IDispatch (LineFormat a)
iidILineFormat :: Com.IID (ILineFormat Automation.Interface)
iidILineFormat = Com.mkIID "{000209CA-0000-0000-C000-000000000046}"
getBeginArrowheadLength :: (Automation.Variant a0) => ILineFormat a -> Prelude.IO (a0)
getBeginArrowheadLength =
  Automation.propertyGetID 0x65 [] Automation.outVariant
setBeginArrowheadLength :: (Automation.Variant a0) => a0 -> ILineFormat a -> Prelude.IO ()
setBeginArrowheadLength prop =
  Automation.propertySetID 0x65 [Automation.inVariant prop]
getBeginArrowheadStyle :: (Automation.Variant a0) => ILineFormat a -> Prelude.IO (a0)
getBeginArrowheadStyle =
  Automation.propertyGetID 0x66 [] Automation.outVariant
setBeginArrowheadStyle :: (Automation.Variant a0) => a0 -> ILineFormat a -> Prelude.IO ()
setBeginArrowheadStyle prop =
  Automation.propertySetID 0x66 [Automation.inVariant prop]
getBeginArrowheadWidth :: (Automation.Variant a0) => ILineFormat a -> Prelude.IO (a0)
getBeginArrowheadWidth =
  Automation.propertyGetID 0x67 [] Automation.outVariant
setBeginArrowheadWidth :: (Automation.Variant a0) => a0 -> ILineFormat a -> Prelude.IO ()
setBeginArrowheadWidth prop =
  Automation.propertySetID 0x67 [Automation.inVariant prop]
getDashStyle :: (Automation.Variant a0) => ILineFormat a -> Prelude.IO (a0)
getDashStyle =
  Automation.propertyGetID 0x68 [] Automation.outVariant
setDashStyle :: (Automation.Variant a0) => a0 -> ILineFormat a -> Prelude.IO ()
setDashStyle prop =
  Automation.propertySetID 0x68 [Automation.inVariant prop]
getEndArrowheadLength :: (Automation.Variant a0) => ILineFormat a -> Prelude.IO (a0)
getEndArrowheadLength =
  Automation.propertyGetID 0x69 [] Automation.outVariant
setEndArrowheadLength :: (Automation.Variant a0) => a0 -> ILineFormat a -> Prelude.IO ()
setEndArrowheadLength prop =
  Automation.propertySetID 0x69 [Automation.inVariant prop]
getEndArrowheadStyle :: (Automation.Variant a0) => ILineFormat a -> Prelude.IO (a0)
getEndArrowheadStyle =
  Automation.propertyGetID 0x6a [] Automation.outVariant
setEndArrowheadStyle :: (Automation.Variant a0) => a0 -> ILineFormat a -> Prelude.IO ()
setEndArrowheadStyle prop =
  Automation.propertySetID 0x6a [Automation.inVariant prop]
getEndArrowheadWidth :: (Automation.Variant a0) => ILineFormat a -> Prelude.IO (a0)
getEndArrowheadWidth =
  Automation.propertyGetID 0x6b [] Automation.outVariant
setEndArrowheadWidth :: (Automation.Variant a0) => a0 -> ILineFormat a -> Prelude.IO ()
setEndArrowheadWidth prop =
  Automation.propertySetID 0x6b [Automation.inVariant prop]
setPattern :: (Automation.Variant a0) => a0 -> ILineFormat a -> Prelude.IO ()
setPattern prop =
  Automation.propertySetID 0x6d [Automation.inVariant prop]
getStyle7 :: (Automation.Variant a0) => ILineFormat a -> Prelude.IO (a0)
getStyle7 = Automation.propertyGetID 0x6e [] Automation.outVariant
setStyle7 :: (Automation.Variant a0) => a0 -> ILineFormat a -> Prelude.IO ()
setStyle7 prop =
  Automation.propertySetID 0x6e [Automation.inVariant prop]
getWeight :: ILineFormat a -> Prelude.IO (Prelude.Float)
getWeight = Automation.propertyGetID 0x71 [] Automation.outFloat
setWeight :: Prelude.Float -> ILineFormat a -> Prelude.IO ()
setWeight prop =
  Automation.propertySetID 0x71 [Automation.inFloat prop]
-- --------------------------------------------------
-- 
-- interface PictureFormat
-- 
-- --------------------------------------------------
data PictureFormat a = PictureFormat
                        
type IPictureFormat a = Automation.IDispatch (PictureFormat a)
iidIPictureFormat :: Com.IID (IPictureFormat Automation.Interface)
iidIPictureFormat =
  Com.mkIID "{000209CB-0000-0000-C000-000000000046}"
getBrightness :: IPictureFormat a -> Prelude.IO (Prelude.Float)
getBrightness =
  Automation.propertyGetID 0x64 [] Automation.outFloat
setBrightness :: Prelude.Float -> IPictureFormat a -> Prelude.IO ()
setBrightness prop =
  Automation.propertySetID 0x64 [Automation.inFloat prop]
getColorType :: (Automation.Variant a0) => IPictureFormat a -> Prelude.IO (a0)
getColorType =
  Automation.propertyGetID 0x65 [] Automation.outVariant
setColorType :: (Automation.Variant a0) => a0 -> IPictureFormat a -> Prelude.IO ()
setColorType prop =
  Automation.propertySetID 0x65 [Automation.inVariant prop]
getContrast :: IPictureFormat a -> Prelude.IO (Prelude.Float)
getContrast = Automation.propertyGetID 0x66 [] Automation.outFloat
setContrast :: Prelude.Float -> IPictureFormat a -> Prelude.IO ()
setContrast prop =
  Automation.propertySetID 0x66 [Automation.inFloat prop]
getCropBottom :: IPictureFormat a -> Prelude.IO (Prelude.Float)
getCropBottom =
  Automation.propertyGetID 0x67 [] Automation.outFloat
setCropBottom :: Prelude.Float -> IPictureFormat a -> Prelude.IO ()
setCropBottom prop =
  Automation.propertySetID 0x67 [Automation.inFloat prop]
getCropLeft :: IPictureFormat a -> Prelude.IO (Prelude.Float)
getCropLeft = Automation.propertyGetID 0x68 [] Automation.outFloat
setCropLeft :: Prelude.Float -> IPictureFormat a -> Prelude.IO ()
setCropLeft prop =
  Automation.propertySetID 0x68 [Automation.inFloat prop]
getCropRight :: IPictureFormat a -> Prelude.IO (Prelude.Float)
getCropRight = Automation.propertyGetID 0x69 [] Automation.outFloat
setCropRight :: Prelude.Float -> IPictureFormat a -> Prelude.IO ()
setCropRight prop =
  Automation.propertySetID 0x69 [Automation.inFloat prop]
getCropTop :: IPictureFormat a -> Prelude.IO (Prelude.Float)
getCropTop = Automation.propertyGetID 0x6a [] Automation.outFloat
setCropTop :: Prelude.Float -> IPictureFormat a -> Prelude.IO ()
setCropTop prop =
  Automation.propertySetID 0x6a [Automation.inFloat prop]
getTransparencyColor :: IPictureFormat a -> Prelude.IO (Prelude.Int)
getTransparencyColor =
  Automation.propertyGetID 0x6b [] Automation.outInt
setTransparencyColor :: Prelude.Int -> IPictureFormat a -> Prelude.IO ()
setTransparencyColor prop =
  Automation.propertySetID 0x6b [Automation.inInt prop]
getTransparentBackground :: (Automation.Variant a0) => IPictureFormat a -> Prelude.IO (a0)
getTransparentBackground =
  Automation.propertyGetID 0x6c [] Automation.outVariant
setTransparentBackground :: (Automation.Variant a0) => a0 -> IPictureFormat a -> Prelude.IO ()
setTransparentBackground prop =
  Automation.propertySetID 0x6c [Automation.inVariant prop]
incrementBrightness :: Prelude.Float -> IPictureFormat a -> Prelude.IO ()
incrementBrightness increment =
  Automation.methodID0 0xa [Automation.inFloat increment]
incrementContrast :: Prelude.Float -> IPictureFormat a -> Prelude.IO ()
incrementContrast increment =
  Automation.methodID0 0xb [Automation.inFloat increment]
-- --------------------------------------------------
-- 
-- interface ShadowFormat
-- 
-- --------------------------------------------------
data ShadowFormat a = ShadowFormat
                       
type IShadowFormat a = Automation.IDispatch (ShadowFormat a)
iidIShadowFormat :: Com.IID (IShadowFormat Automation.Interface)
iidIShadowFormat =
  Com.mkIID "{000209CC-0000-0000-C000-000000000046}"
getObscured :: (Automation.Variant a0) => IShadowFormat a -> Prelude.IO (a0)
getObscured =
  Automation.propertyGetID 0x65 [] Automation.outVariant
setObscured :: (Automation.Variant a0) => a0 -> IShadowFormat a -> Prelude.IO ()
setObscured prop =
  Automation.propertySetID 0x65 [Automation.inVariant prop]
getOffsetX :: IShadowFormat a -> Prelude.IO (Prelude.Float)
getOffsetX = Automation.propertyGetID 0x66 [] Automation.outFloat
setOffsetX :: Prelude.Float -> IShadowFormat a -> Prelude.IO ()
setOffsetX prop =
  Automation.propertySetID 0x66 [Automation.inFloat prop]
getOffsetY :: IShadowFormat a -> Prelude.IO (Prelude.Float)
getOffsetY = Automation.propertyGetID 0x67 [] Automation.outFloat
setOffsetY :: Prelude.Float -> IShadowFormat a -> Prelude.IO ()
setOffsetY prop =
  Automation.propertySetID 0x67 [Automation.inFloat prop]
getType25 :: (Automation.Variant a0) => IShadowFormat a -> Prelude.IO (a0)
getType25 = Automation.propertyGetID 0x69 [] Automation.outVariant
setType4 :: (Automation.Variant a0) => a0 -> IShadowFormat a -> Prelude.IO ()
setType4 prop =
  Automation.propertySetID 0x69 [Automation.inVariant prop]
incrementOffsetX :: Prelude.Float -> IShadowFormat a -> Prelude.IO ()
incrementOffsetX increment =
  Automation.methodID0 0xa [Automation.inFloat increment]
incrementOffsetY :: Prelude.Float -> IShadowFormat a -> Prelude.IO ()
incrementOffsetY increment =
  Automation.methodID0 0xb [Automation.inFloat increment]
-- --------------------------------------------------
-- 
-- interface ShapeNode
-- 
-- --------------------------------------------------
data ShapeNode a = ShapeNode
                    
type IShapeNode a = Automation.IDispatch (ShapeNode a)
iidIShapeNode :: Com.IID (IShapeNode Automation.Interface)
iidIShapeNode = Com.mkIID "{000209CD-0000-0000-C000-000000000046}"
getEditingType :: (Automation.Variant a0) => IShapeNode a -> Prelude.IO (a0)
getEditingType =
  Automation.propertyGetID 0x64 [] Automation.outVariant
getPoints :: IShapeNode a -> Prelude.IO (Prelude.Int)
getPoints = Automation.propertyGetID 0x65 [] Automation.outInt
getSegmentType :: (Automation.Variant a0) => IShapeNode a -> Prelude.IO (a0)
getSegmentType =
  Automation.propertyGetID 0x66 [] Automation.outVariant
-- --------------------------------------------------
-- 
-- interface ShapeNodes
-- 
-- --------------------------------------------------
data ShapeNodes a = ShapeNodes
                     
type IShapeNodes a = Automation.IDispatch (ShapeNodes a)
iidIShapeNodes :: Com.IID (IShapeNodes Automation.Interface)
iidIShapeNodes = Com.mkIID "{000209CE-0000-0000-C000-000000000046}"
delete45 :: Prelude.Int -> Automation.IDispatch a -> Prelude.IO ()
delete45 idex = Automation.methodID0 0xb [Automation.inInt idex]
item73 :: Prelude.Int -> IShapeNodes a -> Prelude.IO (IShapeNode Automation.Interface)
item73 idex =
  Automation.functionID1 0o0 [Automation.inInt idex] Automation.outIDispatch
setEditingType :: (Automation.Variant a0) => Prelude.Int -> a0 -> IShapeNodes a -> Prelude.IO ()
setEditingType idex editingType =
  Automation.methodID0 0xd [Automation.inInt idex, Automation.inVariant editingType]
setPosition3 :: Prelude.Int -> Prelude.Float -> Prelude.Float -> IShapeNodes a -> Prelude.IO ()
setPosition3 idex x1 y1 =
  Automation.methodID0 0xe [Automation.inInt idex, Automation.inFloat x1, Automation.inFloat y1]
setSegmentType :: (Automation.Variant a0) => Prelude.Int -> a0 -> IShapeNodes a -> Prelude.IO ()
setSegmentType idex segmentType =
  Automation.methodID0 0xf [Automation.inInt idex, Automation.inVariant segmentType]
insert1 :: (Automation.Variant a0, Automation.Variant a1) => Prelude.Int -> a0 -> a1 -> Prelude.Float -> Prelude.Float -> Prelude.Float -> Prelude.Float -> Prelude.Float -> Prelude.Float -> IShapeNodes a -> Prelude.IO ()
insert1 idex segmentType editingType x1 y1 x2 y2 x3 y3 =
  Automation.methodID0 0xc [Automation.inInt idex, Automation.inVariant segmentType, Automation.inVariant editingType, Automation.inFloat x1, Automation.inFloat y1, Automation.inFloat x2, Automation.inFloat y2, Automation.inFloat x3, Automation.inFloat y3]
-- --------------------------------------------------
-- 
-- interface TextEffectFormat
-- 
-- --------------------------------------------------
data TextEffectFormat a = TextEffectFormat
                           
type ITextEffectFormat a = Automation.IDispatch (TextEffectFormat a)
iidITextEffectFormat :: Com.IID (ITextEffectFormat Automation.Interface)
iidITextEffectFormat =
  Com.mkIID "{000209CF-0000-0000-C000-000000000046}"
getAlignment7 :: (Automation.Variant a0) => ITextEffectFormat a -> Prelude.IO (a0)
getAlignment7 =
  Automation.propertyGetID 0x64 [] Automation.outVariant
setAlignment7 :: (Automation.Variant a0) => a0 -> ITextEffectFormat a -> Prelude.IO ()
setAlignment7 prop =
  Automation.propertySetID 0x64 [Automation.inVariant prop]
getFontBold :: (Automation.Variant a0) => ITextEffectFormat a -> Prelude.IO (a0)
getFontBold =
  Automation.propertyGetID 0x65 [] Automation.outVariant
setFontBold :: (Automation.Variant a0) => a0 -> ITextEffectFormat a -> Prelude.IO ()
setFontBold prop =
  Automation.propertySetID 0x65 [Automation.inVariant prop]
getFontItalic :: (Automation.Variant a0) => ITextEffectFormat a -> Prelude.IO (a0)
getFontItalic =
  Automation.propertyGetID 0x66 [] Automation.outVariant
setFontItalic :: (Automation.Variant a0) => a0 -> ITextEffectFormat a -> Prelude.IO ()
setFontItalic prop =
  Automation.propertySetID 0x66 [Automation.inVariant prop]
getFontSize :: ITextEffectFormat a -> Prelude.IO (Prelude.Float)
getFontSize = Automation.propertyGetID 0x68 [] Automation.outFloat
setFontSize :: Prelude.Float -> ITextEffectFormat a -> Prelude.IO ()
setFontSize prop =
  Automation.propertySetID 0x68 [Automation.inFloat prop]
getKernedPairs :: (Automation.Variant a0) => ITextEffectFormat a -> Prelude.IO (a0)
getKernedPairs =
  Automation.propertyGetID 0x69 [] Automation.outVariant
setKernedPairs :: (Automation.Variant a0) => a0 -> ITextEffectFormat a -> Prelude.IO ()
setKernedPairs prop =
  Automation.propertySetID 0x69 [Automation.inVariant prop]
getNormalizedHeight :: (Automation.Variant a0) => ITextEffectFormat a -> Prelude.IO (a0)
getNormalizedHeight =
  Automation.propertyGetID 0x6a [] Automation.outVariant
setNormalizedHeight :: (Automation.Variant a0) => a0 -> ITextEffectFormat a -> Prelude.IO ()
setNormalizedHeight prop =
  Automation.propertySetID 0x6a [Automation.inVariant prop]
getPresetShape :: (Automation.Variant a0) => ITextEffectFormat a -> Prelude.IO (a0)
getPresetShape =
  Automation.propertyGetID 0x6b [] Automation.outVariant
setPresetShape :: (Automation.Variant a0) => a0 -> ITextEffectFormat a -> Prelude.IO ()
setPresetShape prop =
  Automation.propertySetID 0x6b [Automation.inVariant prop]
getPresetTextEffect :: (Automation.Variant a0) => ITextEffectFormat a -> Prelude.IO (a0)
getPresetTextEffect =
  Automation.propertyGetID 0x6c [] Automation.outVariant
setPresetTextEffect :: (Automation.Variant a0) => a0 -> ITextEffectFormat a -> Prelude.IO ()
setPresetTextEffect prop =
  Automation.propertySetID 0x6c [Automation.inVariant prop]
getRotatedChars :: (Automation.Variant a0) => ITextEffectFormat a -> Prelude.IO (a0)
getRotatedChars =
  Automation.propertyGetID 0x6d [] Automation.outVariant
setRotatedChars :: (Automation.Variant a0) => a0 -> ITextEffectFormat a -> Prelude.IO ()
setRotatedChars prop =
  Automation.propertySetID 0x6d [Automation.inVariant prop]
getTracking :: ITextEffectFormat a -> Prelude.IO (Prelude.Float)
getTracking = Automation.propertyGetID 0x6f [] Automation.outFloat
setTracking :: Prelude.Float -> ITextEffectFormat a -> Prelude.IO ()
setTracking prop =
  Automation.propertySetID 0x6f [Automation.inFloat prop]
toggleVerticalText :: ITextEffectFormat a -> Prelude.IO ()
toggleVerticalText = Automation.methodID0 0xa []
-- --------------------------------------------------
-- 
-- interface ThreeDFormat
-- 
-- --------------------------------------------------
data ThreeDFormat a = ThreeDFormat
                       
type IThreeDFormat a = Automation.IDispatch (ThreeDFormat a)
iidIThreeDFormat :: Com.IID (IThreeDFormat Automation.Interface)
iidIThreeDFormat =
  Com.mkIID "{000209D0-0000-0000-C000-000000000046}"
getDepth :: IThreeDFormat a -> Prelude.IO (Prelude.Float)
getDepth = Automation.propertyGetID 0x64 [] Automation.outFloat
setDepth :: Prelude.Float -> IThreeDFormat a -> Prelude.IO ()
setDepth prop =
  Automation.propertySetID 0x64 [Automation.inFloat prop]
getExtrusionColor :: IThreeDFormat a -> Prelude.IO (IColorFormat Automation.Interface)
getExtrusionColor =
  Automation.propertyGetID 0x65 [] Automation.outIDispatch
getExtrusionColorType :: (Automation.Variant a0) => IThreeDFormat a -> Prelude.IO (a0)
getExtrusionColorType =
  Automation.propertyGetID 0x66 [] Automation.outVariant
setExtrusionColorType :: (Automation.Variant a0) => a0 -> IThreeDFormat a -> Prelude.IO ()
setExtrusionColorType prop =
  Automation.propertySetID 0x66 [Automation.inVariant prop]
getPerspective :: (Automation.Variant a0) => IThreeDFormat a -> Prelude.IO (a0)
getPerspective =
  Automation.propertyGetID 0x67 [] Automation.outVariant
setPerspective :: (Automation.Variant a0) => a0 -> IThreeDFormat a -> Prelude.IO ()
setPerspective prop =
  Automation.propertySetID 0x67 [Automation.inVariant prop]
getPresetExtrusionDirection :: (Automation.Variant a0) => IThreeDFormat a -> Prelude.IO (a0)
getPresetExtrusionDirection =
  Automation.propertyGetID 0x68 [] Automation.outVariant
getPresetLightingDirection :: (Automation.Variant a0) => IThreeDFormat a -> Prelude.IO (a0)
getPresetLightingDirection =
  Automation.propertyGetID 0x69 [] Automation.outVariant
setPresetLightingDirection :: (Automation.Variant a0) => a0 -> IThreeDFormat a -> Prelude.IO ()
setPresetLightingDirection prop =
  Automation.propertySetID 0x69 [Automation.inVariant prop]
getPresetLightingSoftness :: (Automation.Variant a0) => IThreeDFormat a -> Prelude.IO (a0)
getPresetLightingSoftness =
  Automation.propertyGetID 0x6a [] Automation.outVariant
setPresetLightingSoftness :: (Automation.Variant a0) => a0 -> IThreeDFormat a -> Prelude.IO ()
setPresetLightingSoftness prop =
  Automation.propertySetID 0x6a [Automation.inVariant prop]
getPresetMaterial :: (Automation.Variant a0) => IThreeDFormat a -> Prelude.IO (a0)
getPresetMaterial =
  Automation.propertyGetID 0x6b [] Automation.outVariant
setPresetMaterial :: (Automation.Variant a0) => a0 -> IThreeDFormat a -> Prelude.IO ()
setPresetMaterial prop =
  Automation.propertySetID 0x6b [Automation.inVariant prop]
getPresetThreeDFormat :: (Automation.Variant a0) => IThreeDFormat a -> Prelude.IO (a0)
getPresetThreeDFormat =
  Automation.propertyGetID 0x6c [] Automation.outVariant
getRotationX :: IThreeDFormat a -> Prelude.IO (Prelude.Float)
getRotationX = Automation.propertyGetID 0x6d [] Automation.outFloat
setRotationX :: Prelude.Float -> IThreeDFormat a -> Prelude.IO ()
setRotationX prop =
  Automation.propertySetID 0x6d [Automation.inFloat prop]
getRotationY :: IThreeDFormat a -> Prelude.IO (Prelude.Float)
getRotationY = Automation.propertyGetID 0x6e [] Automation.outFloat
setRotationY :: Prelude.Float -> IThreeDFormat a -> Prelude.IO ()
setRotationY prop =
  Automation.propertySetID 0x6e [Automation.inFloat prop]
incrementRotationX :: Prelude.Float -> IThreeDFormat a -> Prelude.IO ()
incrementRotationX increment =
  Automation.methodID0 0xa [Automation.inFloat increment]
incrementRotationY :: Prelude.Float -> IThreeDFormat a -> Prelude.IO ()
incrementRotationY increment =
  Automation.methodID0 0xb [Automation.inFloat increment]
resetRotation :: IThreeDFormat a -> Prelude.IO ()
resetRotation = Automation.methodID0 0xc []
setExtrusionDirection :: (Automation.Variant a0) => a0 -> IThreeDFormat a -> Prelude.IO ()
setExtrusionDirection presetExtrusionDirection =
  Automation.methodID0 0xe [Automation.inVariant presetExtrusionDirection]
setThreeDFormat :: (Automation.Variant a0) => a0 -> IThreeDFormat a -> Prelude.IO ()
setThreeDFormat presetThreeDFormat =
  Automation.methodID0 0xd [Automation.inVariant presetThreeDFormat]
-- --------------------------------------------------
-- 
-- dispinterface ApplicationEvents
-- 
-- --------------------------------------------------
data ApplicationEvents a = ApplicationEvents
                            
type IApplicationEvents a = Automation.IDispatch (ApplicationEvents a)
iidIApplicationEvents :: Com.IID (IApplicationEvents Automation.Interface)
iidIApplicationEvents =
  Com.mkIID "{000209F7-0000-0000-C000-000000000046}"
startup :: IApplicationEvents a -> Prelude.IO ()
startup = Automation.methodID0 0x1 []
quit0 :: IApplicationEvents a -> Prelude.IO ()
quit0 = Automation.methodID0 0x2 []
documentChange :: IApplicationEvents a -> Prelude.IO ()
documentChange = Automation.methodID0 0x3 []
-- --------------------------------------------------
-- 
-- coclass Global0
-- 
-- --------------------------------------------------
clsidGlobal0 :: Com.CLSID
clsidGlobal0 = Com.mkCLSID "{000209F0-0000-0000-C000-000000000046}"
-- --------------------------------------------------
-- 
-- coclass Application0
-- 
-- --------------------------------------------------
clsidApplication0 :: Com.CLSID
clsidApplication0 =
  Com.mkCLSID "{000209FF-0000-0000-C000-000000000046}"
-- --------------------------------------------------
-- 
-- dispinterface DocumentEvents
-- 
-- --------------------------------------------------
data DocumentEvents a = DocumentEvents
                         
type IDocumentEvents a = Automation.IDispatch (DocumentEvents a)
iidIDocumentEvents :: Com.IID (IDocumentEvents Automation.Interface)
iidIDocumentEvents =
  Com.mkIID "{000209F6-0000-0000-C000-000000000046}"
new0 :: IDocumentEvents a -> Prelude.IO ()
new0 = Automation.methodID0 0x4 []
open4 :: IDocumentEvents a -> Prelude.IO ()
open4 = Automation.methodID0 0x5 []
close4 :: IDocumentEvents a -> Prelude.IO ()
close4 = Automation.methodID0 0x6 []
-- --------------------------------------------------
-- 
-- coclass Document0
-- 
-- --------------------------------------------------
clsidDocument0 :: Com.CLSID
clsidDocument0 =
  Com.mkCLSID "{00020906-0000-0000-C000-000000000046}"
-- --------------------------------------------------
-- 
-- coclass Font0
-- 
-- --------------------------------------------------
clsidFont0 :: Com.CLSID
clsidFont0 = Com.mkCLSID "{000209F5-0000-0000-C000-000000000046}"
-- --------------------------------------------------
-- 
-- coclass ParagraphFormat0
-- 
-- --------------------------------------------------
clsidParagraphFormat0 :: Com.CLSID
clsidParagraphFormat0 =
  Com.mkCLSID "{000209F4-0000-0000-C000-000000000046}"
-- --------------------------------------------------
-- 
-- dispinterface OCXEvents
-- 
-- --------------------------------------------------
data OCXEvents a = OCXEvents
                    
type IOCXEvents a = Automation.IDispatch (OCXEvents a)
iidIOCXEvents :: Com.IID (IOCXEvents Automation.Interface)
iidIOCXEvents = Com.mkIID "{000209F3-0000-0000-C000-000000000046}"
gotFocus :: IOCXEvents a -> Prelude.IO ()
gotFocus = Automation.methodID0 0x800100e0 []
lostFocus :: IOCXEvents a -> Prelude.IO ()
lostFocus = Automation.methodID0 0x800100e1 []
-- --------------------------------------------------
-- 
-- coclass OLEControl0
-- 
-- --------------------------------------------------
clsidOLEControl0 :: Com.CLSID
clsidOLEControl0 =
  Com.mkCLSID "{000209F2-0000-0000-C000-000000000046}"
-- --------------------------------------------------
-- 
-- coclass LetterContent0
-- 
-- --------------------------------------------------
clsidLetterContent0 :: Com.CLSID
clsidLetterContent0 =
  Com.mkCLSID "{000209F1-0000-0000-C000-000000000046}"
